<?php

namespace Ministra\Admin;

use Doctrine\DBAL\DriverManager;
use Ministra\Admin\Adapter\DataTableAdapter;
use Ministra\Admin\Container\SilexPsrContainer;
use Ministra\Admin\Lib\Middleware\Pipelines;
use Ministra\Admin\Repository\LicenseKeysRepository;
use Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\bc70fa482207010a349f58cf3018db43;
use Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\j80745c4cc31d942969cb7585729fc68e\C03917cb81747312ca590a52b4df6bf17;
use Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\adccd522f376c0019f6dcd12d04172af as k42ba9544f47e7d3d9612890455ad45c8;
use Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\A5c0337a1ecfb793b55606ba231709f2e\s87b3c77de38d5d0376727c6401bf69ab;
use Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\A5c0337a1ecfb793b55606ba231709f2e\V56fd2ff6f9b7b65906e32d3b8370aebb;
use Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\J97d213853bdce60feaf250b6ac0bbb08;
use Pimple\Container;
use Pimple\ServiceProviderInterface;
use Psr\Container\ContainerInterface;
use Silex\Application;
class AppServiceProvider implements \Pimple\ServiceProviderInterface
{
    public function register(\Pimple\Container $container)
    {
        $container->offsetSet(\Psr\Container\ContainerInterface::class, function (\Silex\Application $app) {
            return new \Ministra\Admin\Container\SilexPsrContainer($app);
        });
        $container->offsetSet('pipelines', function (\Silex\Application $app) {
            return new \Ministra\Admin\Lib\Middleware\Pipelines();
        });
        $this->registerRepository($container);
        $container->offsetSet(\Ministra\Admin\Adapter\DataTableAdapter::class, function (\Silex\Application $app) {
            return new \Ministra\Admin\Adapter\DataTableAdapter($app['request_stack']->getCurrentRequest(), $app['db']);
        });
        $this->registerUtilConnection($container);
        $this->registerUtilService($container);
    }
    protected function registerRepository(\Pimple\Container $container)
    {
        $container->offsetSet(\Ministra\Admin\Repository\LicenseKeysRepository::class, function (\Silex\Application $app) {
            return new \Ministra\Admin\Repository\LicenseKeysRepository($app['db']);
        });
    }
    protected function registerUtilConnection(\Pimple\Container $container)
    {
        $file = \realpath(__DIR__ . '/../../') . '/deploy/clear_key_util/db_util.sqlite';
        if (!\file_exists($file)) {
            \file_put_contents($file, '');
        }
        if (!\is_writable($file)) {
            throw new \RuntimeException("Clear key util database file does not writable: {$file}");
        }
        $dirs = [\dirname($file) . '/logs', \dirname($file) . '/reports'];
        foreach ($dirs as $dir) {
            if (!\is_writable($file)) {
                throw new \RuntimeException("Directory does not writable: {$dir}");
            }
        }
        if (!\extension_loaded('pdo_sqlite')) {
            throw new \Exception('SQLite extension missing');
        }
        $container->offsetSet('util.connection', \Doctrine\DBAL\DriverManager::getConnection(['driver' => 'pdo_sqlite', 'path' => $file]));
    }
    protected function registerUtilService(\Pimple\Container $container)
    {
        $container->offsetSet(\Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\A5c0337a1ecfb793b55606ba231709f2e\V56fd2ff6f9b7b65906e32d3b8370aebb::class, function (\Silex\Application $app) {
            return new \Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\A5c0337a1ecfb793b55606ba231709f2e\V56fd2ff6f9b7b65906e32d3b8370aebb($app['util.connection']);
        });
        $container->offsetSet(\Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\A5c0337a1ecfb793b55606ba231709f2e\s87b3c77de38d5d0376727c6401bf69ab::class, function (\Silex\Application $app) {
            return new \Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\A5c0337a1ecfb793b55606ba231709f2e\s87b3c77de38d5d0376727c6401bf69ab($app['util.connection']);
        });
        $container->offsetSet(\Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\j80745c4cc31d942969cb7585729fc68e\C03917cb81747312ca590a52b4df6bf17::class, function (\Silex\Application $app) {
            return new \Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\adccd522f376c0019f6dcd12d04172af($app['db']);
        });
        $container->offsetSet(\Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\bc70fa482207010a349f58cf3018db43::class, function (\Silex\Application $app) {
            return new \Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\bc70fa482207010a349f58cf3018db43($app->offsetGet(\Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\A5c0337a1ecfb793b55606ba231709f2e\s87b3c77de38d5d0376727c6401bf69ab::class), $app->offsetGet(\Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\A5c0337a1ecfb793b55606ba231709f2e\V56fd2ff6f9b7b65906e32d3b8370aebb::class), $app->offsetGet(\Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\j80745c4cc31d942969cb7585729fc68e\C03917cb81747312ca590a52b4df6bf17::class), \Ministra\Lib\d82c7fabcebee285c51cde1ea7b462a88\dbe0c656da0397188b22329d9a8227b0\J97d213853bdce60feaf250b6ac0bbb08::n75f9cbf25b67a8797552c96603594503, $app->offsetGet('util.path'));
        });
    }
}
