<?php

namespace Ministra\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
class Version1535720059 extends \Doctrine\DBAL\Migrations\AbstractMigration
{
    public function up(\Doctrine\DBAL\Schema\Schema $schema)
    {
        $this->addSql(<<<EOL
--
UPDATE `apps_tos` SET `tos_en` = '
<br>
<h1>
<span>Conditions of Use for Ministra Application Directory </span>
</h1>
<br>
<h3>
<span>October 1, 2015</span>
</h3>
<br>
<h2>
<span>1. Introduction</span>
</h2>
<p>
<span>Ministra Application Directory (hereinafter referred to as the Directory) is an ordered list of applications provided by the application vendors that are available for installation in Middleware Ministra (hereinafter referred to as Ministra).</span>
</p>
<p>
<span>The Directory is provided by Infomir, LLC (hereinafter referred to as the Company or we/us), which is located at the following address: 2626 East 14</span><sup><span>th</span></sup><span> Street, Brooklyn, New York 11235.</span>
</p>
<p>
<span>In order to use the Directory it is required that you agree to the following Conditions of Use (hereinafter referred to as the Conditions). Please read them carefully. If any of their provisions are unclear or are unacceptable to you, you may not use the Directory. By starting to use the Directory, you accept the Conditions.</span>
</p>
<h2>
<span>2. Directory Use</span>
</h2>
<p>
<span><b>Access to the Directory</b>.</span>
<span> You are granted a non-exclusive, non-transferable license to use the Directory to install/remove the applications to Ministra or other media. The application availability varies by country, and the entire list of applications will possibly not be available in your country.</span>
</p>
<p>
<span><b>Applications.</b></span>
<span>The Company provides a platform in the form of Ministra interface, by which you can at your sole discretion produce a list of applications with those available in the Directory or add/remove an application to the Directory yourself. In connection herewith, all relationships associated with your use of such applications, be it relations with the stakeholders (including, but not limited to, financial relations) or the relationship with the authorities and organizations that oversee the legality and morality issues within certain Content categories shall be regulated solely between you and such persons and the Company shall have no liability or responsibility for such use by you or your stakeholders.</span>
</p>
<p>
<span><b>Application sources.</b></span>
<span>The Company provides a list of applications, but does not limit you to installing the applications distributed on the Internet. These applications are developed by third parties unrelated to the Company, therefore the Company does not bear any responsibility for any damage to the software, hardware, and user devices as a result of their use by you.</span>
</p>
<p>
<span><b>No Warranty</b>.</span>
<span> THE DIRECTORY AND THE SOFTWARE ASSOCIATED WITH THE DIRECTORY (the “Software”) IS LICENSED TO YOU ON AN “AS IS WHERE IS” BASIS AND IS WITHOUT ANY REPRESENTATION OR WARRANTY, EXPRESS OR IMPLIED, BY ACT OR LAW, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MECHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT OF PROPRIETARY RIGHTS.  THE COMPANY SHALL HAVE NO LIABILITY WHATSOEVER WITH RESPECT TO YOUR USE OF THE DIRECTORY AND/OR SOFTWARE, INCLUDING, WITHOUT LIMITATION, INCIDENTAL DAMAGES, SPECIAL DAMAGES, PUNITIVE DAMAGES, CONSEQUENTIAL DAMAGES, LOST PROFITS, SUSPENSION OF ACTIVITY, LOSS OF INFORMATION, OR DATA, OR MONETARY FUNDS.  THE COMPANY MAKES NO GUARANTY THAT THE SOFTWARE WILL BE FREE FROM DEFECTS OR ERRORS, THAT ANY DEFECTS OR ERRORS WILL BE CORRECTED, OR THAT THE SOFTWARE OR ANY PORTION THEREOF WILL MEET YOUR REQUIREMENTS.</span>
</p>
<p>
<span><b>Copyright Notice</b>.</span>
<span>The paragraph captioned “No Warranty” and the following notice must appear on all copies of the Software: “Copyright © 2015 Infomir, LLC, All Rights Reserved”.</span>
</p>
<p>
<span><b>Prohibitions</b>.</span>
<span>Notwithstanding the license granted hereunder, you may not alter, modify, enhance, update, reverse engineer, decompile, disassemble, or redesign the Software.  You further acknowledge and agree that you have no intellectual property rights in and to the Software and that you will do nothing inconsistent with the Company’s intellectual property rights in the Software. </span>
</p>
<p>
<span><b>Content</b></span>
<span>(defined as data files, texts, software, music, audio files, photos, videos or other images) is always provided for you by your application vendor. The Company is not a distributor (licensee, provider, agent, etc.) of the Content. The Content is created by third parties that are not related to the Company, therefore the Company is not responsible for the Content created by third parties, and did not give its approval in relation to such Content.</span>
</p>
<p>
<span><b>Age restrictions.</b></span>
<span>To use the Directory you must be eighteen (18) or older.. If in accordance with the legislation of the country you conduct business in or you are going to access the Directory from you are not permitted or are prohibited by law to use an application or any Content, you must not access the Directory. You must abide by all the additional age restrictions, which may be applied for the use and distribution of the Content or applications of one kind or another.</span>
</p>
<p>
<span><b>Key Conditions of Use.</b></span>
<span>To use the Directory you need Ministra and a compatible Device, which meets the system requirements of the relevant application and Content that may be occasionally changed, as well as an Internet connection and compatible software. The use of applications and their efficiency depend on these factors. You shall bear responsibility for meeting the system requirements and the Company has no liability or responsibility for any system requirements.</span>
</p>
<p>
<span><b>Payments to third parties.</b></span>
<span>Some third parties (e.g., an application vendor, stakeholder, ISP or mobile operator) may charge for data transfer or access when using applications. You shall always make all such payments yourself and shall be responsible for them.</span>
</p>
<p>
<span><b>Directory updating.</b></span>
<span>Our Company reserves the right to change the functionality or user interface design of the Directory from time to time. To use the Directory you may need to install such updates or software occasionally produced by our Company. The Directory may occasionally access the application source servers and check for the updates necessary for its operation, for example, patches, enhancements, missing plug-ins and new versions (hereinafter collectively referred to as the Updates).</span>
</p>
<h2>
<span>3. Rights and Restrictions </span>
</h2>
<p>
<span><b>Security functions.</b></span>
<span>You do not have the right to independently attempt to or authorize other persons, assist them and encourage them to traverse, disable or destroy any security functions or components, such as digital rights management or encryption protecting any application or Content (including the Directory) that prevent or otherwise restrict access to them. Violation of any security functions may become subject to a civil, administrative or criminal responsibility.</span>
</p>
<p>
<span><b>Defective Content</b>.</span>
<span>If you have any faults or problems during operation of the application, you should contact the application vendor.</span>
</p>
<p>
<span><b>Application removal or unavailability.</b></span>
<span>The access to applications is provided through the Directory without time limitation. In some cases (for example, if the application vendor terminates the support of the applications or Content, if the application or Content violate the terms or laws applicable) the Company may remove the application from the Directory. If possible, the Company will send you an advance notice about the application or Content removal or termination of access.</span>
</p>
<p>
<span><b>Hazardous activity.</b></span>
<span>There are no applications or Content intended for use in the operation of nuclear facilities, life support systems, emergency communication, navigation or communication of aircrafts or flight control, as well as other activities, in which the failure of the application or Content may result in death, injury or serious damage to health or the environment.</span>
</p>
<p>
<span><b>Change in the Conditions.</b></span>
<span>In the event of changes in the Conditions, before the next use of the Directory you will be prompted to accept the new Conditions. Once you accept the new Conditions, they will apply to the entire Directory (including the previously installed applications), the Software and all subsequent applications up to the new changes notification.</span>
<br>
<br>
<span>If you do accept the changed Conditions, you may not use the Directory and/or the Software.</span>
</p>
<p>
<span><b>4. Miscellaneous</b></span>
</p>
<p>
<span>These Conditions of Use shall bind and inure to the benefit of the Company’s and your successors and permitted assigns.  These Conditions of Use shall be construed in accordance with the laws of the State of New York, including its provisions of the Uniform Commercial Code, and without regard to (i) the conflict of laws provisions thereof, (ii) the United Nations Convention on Contracts for the International Sale of Goods, and (iii) the United Nations Convention on the Limitation Period in the International Sale of Goods, as amended.</span>
</p>
<p>
<span>The failure of the Company to require full or strict performance of any term set forth herein shall not effect the right to require full and strict performance of any term at any time thereafter.  If any one or more of the provisions of the Conditions of Use shall be held to be invalid, illegal or unenforceable, the other provisions shall not be effected and the Conditions of Use shall be construed as if such invalid, illegal or unenforceable provision had not been contained herein.  Nothing in these Conditions of Use shall be construed as creating any direct or beneficial right in or on behalf of any third party.  These Conditions of Use shall constitute the entire and only agreement between the parties hereto, and any representation, affirmation of fact, and course of prior dealing, promise, or condition in connection therewith or usage of the trade not incorporated herein shall not be binding on the Company.  No waiver, alteration or modification of the provisions hereof shall be binding unless in writing and signed by the specifically authorized representative of the Company.</span>
</p>';
EOL
);
    }
    public function down(\Doctrine\DBAL\Schema\Schema $schema)
    {
    }
}
