<?php

namespace Ministra\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
class Version1535720019 extends \Doctrine\DBAL\Migrations\AbstractMigration
{
    public function up(\Doctrine\DBAL\Schema\Schema $schema)
    {
        if (!$schema->getTable('users')->hasColumn('openweathermap_city_id')) {
            $this->addSql('ALTER TABLE `users` ADD `openweathermap_city_id` int(11) NOT NULL DEFAULT 0;');
        }
        if (!$schema->getTable('weatherco_cache')->hasColumn('updated_current')) {
            $this->addSql('ALTER TABLE `weatherco_cache` ADD `updated_current` timestamp null default null;');
        }
        if (!$schema->getTable('weatherco_cache')->hasColumn('updated_forecast')) {
            $this->addSql('ALTER TABLE `weatherco_cache` ADD `updated_forecast` timestamp null default null;');
        }
        $this->addSql(<<<EOL
CREATE TABLE `all_cities` (
  `id` int NOT NULL,
  `name` varchar(128) NOT NULL DEFAULT '',
  `name_ru` varchar(128) NOT NULL DEFAULT '',
  `country` varchar(64) NOT NULL DEFAULT '',
  `country_id` int NOT NULL DEFAULT 0,
  `admin1_code` varchar(64) NOT NULL DEFAULT '',
  `admin2_code` varchar(64) NOT NULL DEFAULT '',
  `admin3_code` varchar(64) NOT NULL DEFAULT '',
  `admin4_code` varchar(64) NOT NULL DEFAULT '',
  `lat` varchar(32) NOT NULL DEFAULT '',
  `lon` varchar(32) NOT NULL DEFAULT '',
  `timezone` varchar(64) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `country_id` (`country_id`),
  KEY `timezone` (`timezone`)
) DEFAULT CHARSET=utf8;
CREATE TABLE `openweathermap_cache` (
  `id` int NOT NULL AUTO_INCREMENT,
  `current` text,
  `forecast` text,
  `updated_current` timestamp null default null,
  `updated_forecast` timestamp null default null,
  `city_id` int NOT NULL DEFAULT 0,
  `last_request` timestamp null default null,
  PRIMARY KEY (`id`),
  UNIQUE KEY `city_id` (`city_id`)
) DEFAULT CHARSET=utf8;
UPDATE weatherco_cache SET updated_current = updated, updated_forecast=updated;
SET NAMES utf8;
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("290594", "Umm al Qaywayn", "Умм-эль-Кайвайн", "AE", "784", "", "07", "", "", "25.56473", "55.55517", "Asia/Dubai"),("291074", "Ras al-Khaimah", "Рас-эль-Хайма", "AE", "784", "", "05", "", "", "25.78953", "55.9432", "Asia/Dubai"),("291279", "Muzayri‘", "", "AE", "784", "", "01", "", "", "23.14355", "53.7881", "Asia/Dubai"),("291696", "Khawr Fakkān", "Хор-Факкан", "AE", "784", "", "06", "", "", "25.33132", "56.34199", "Asia/Dubai"),("292223", "Dubai", "Дубай", "AE", "784", "", "03", "", "", "25.0657", "55.17128", "Asia/Dubai"),("292231", "Dibba Al-Fujairah", "", "AE", "784", "", "04", "", "", "25.59246", "56.26176", "Asia/Dubai"),("292239", "Dibba Al-Hisn", "Дибба Аль-Хисн", "AE", "784", "", "04", "", "", "25.61955", "56.27291", "Asia/Dubai"),("292672", "Sharjah", "Шарджа", "AE", "784", "", "06", "", "", "25.33737", "55.41206", "Asia/Dubai"),("292688", "Ar Ruways", "Ар-Руваис", "AE", "784", "AE", "01", "", "", "24.11028", "52.73056", "Asia/Dubai"),("292878", "Al Fujayrah", "Фуджейра", "AE", "784", "", "04", "", "", "25.11641", "56.34141", "Asia/Dubai"),("292913", "Al Ain", "Аль-Айн", "AE", "784", "", "01", "", "", "24.19167", "55.76056", "Asia/Dubai"),("292932", "Ajman", "", "AE", "784", "", "02", "", "", "25.41111", "55.43504", "Asia/Dubai"),("292953", "Adh Dhayd", "", "AE", "784", "", "06", "", "", "25.28812", "55.88157", "Asia/Dubai"),("292968", "Abu Dhabi", "Абу-Даби", "AE", "784", "", "01", "", "", "24.46667", "54.36667", "Asia/Dubai"),("1120483", "Kuhsān", "", "AF", "4", "", "11", "", "", "34.65389", "61.19778", "Asia/Kabul"),("1120487", "Tukzār", "", "AF", "4", "", "33", "", "", "35.94831", "66.42132", "Asia/Kabul"),("1120711", "Zindah Jān", "", "AF", "4", "", "11", "", "", "34.34264", "61.74675", "Asia/Kabul"),("1120863", "Zarghūn Shahr", "", "AF", "4", "", "29", "", "", "32.84734", "68.44573", "Asia/Kabul"),("1120879", "Zaṟah Sharan", "", "AF", "4", "", "29", "", "", "33.14641", "68.79213", "Asia/Kabul"),("1120985", "Zaranj", "Зарани", "AF", "4", "", "19", "7053297", "", "30.95962", "61.86037", "Asia/Kabul"),("1121271", "Yangī Qal‘ah", "", "AF", "4", "", "26", "", "", "37.46572", "69.61131", "Asia/Kabul"),("1122408", "Tīr Pul", "", "AF", "4", "", "11", "", "", "34.59431", "61.26895", "Asia/Kabul"),("1122747", "Tarinkot", "", "AF", "4", "", "39", "7054035", "", "32.62998", "65.87806", "Asia/Kabul"),("1123004", "Taloqan", "Таликан", "AF", "4", "", "26", "", "", "36.73605", "69.53451", "Asia/Kabul"),("1123343", "Tagāw-Bāy", "", "AF", "4", "", "33", "", "", "35.69941", "66.06164", "Asia/Kabul"),("1123424", "Tagāb", "", "AF", "4", "", "14", "", "", "34.85501", "69.64917", "Asia/Kabul"),("1125155", "Shīnḏanḏ", "Шинданд", "AF", "4", "", "11", "", "", "33.30294", "62.1474", "Asia/Kabul"),("1125444", "Shibirghān", "Шеберган", "AF", "4", "", "31", "", "", "36.66757", "65.7529", "Asia/Kabul"),("1125896", "Shahrak", "", "AF", "4", "", "09", "", "", "34.10737", "64.3052", "Asia/Kabul"),("1126606", "Sidqābād", "", "AF", "4", "", "14", "7053088", "", "35.02298", "69.35112", "Asia/Kabul"),("1127110", "Sar-e Pul", "Сари-Пуль", "AF", "4", "", "33", "", "", "36.21544", "65.93249", "Asia/Kabul"),("1127547", "Sangīn", "", "AF", "4", "", "10", "", "", "32.07275", "64.8359", "Asia/Kabul"),("1127628", "Sang-e Chārak", "", "AF", "4", "", "33", "", "", "35.84972", "66.43694", "Asia/Kabul"),("1127768", "Aībak", "Саманган", "AF", "4", "", "32", "", "", "36.26468", "68.01551", "Asia/Kabul"),("1128239", "Rūdbār", "", "AF", "4", "", "19", "", "", "30.15", "62.6", "Asia/Kabul"),("1128265", "Rustāq", "", "AF", "4", "", "26", "", "", "37.12604", "69.83045", "Asia/Kabul"),("1129516", "Qarqīn", "Кханика", "AF", "4", "", "31", "", "", "37.41853", "66.04358", "Asia/Kabul"),("1129636", "Qarchī Gak", "", "AF", "4", "", "30", "", "", "37.03999", "66.78891", "Asia/Kabul"),("1129648", "Qarāwul", "", "AF", "4", "", "24", "", "", "37.21959", "68.7802", "Asia/Kabul"),("1129678", "Qarah Bāgh", "", "AF", "4", "", "11", "", "", "34.94023", "61.77589", "Asia/Kabul"),("1129867", "Qala i Naw", "", "AF", "4", "", "02", "", "", "34.98735", "63.12891", "Asia/Kabul"),("1130065", "Qal‘ah-ye Shahr", "", "AF", "4", "", "33", "", "", "35.54729", "65.5676", "Asia/Kabul"),("1130131", "Qalāt", "", "AF", "4", "", "28", "", "", "32.10575", "66.90833", "Asia/Kabul"),("1130469", "Pārūn", "", "AF", "4", "", "38", "7054028", "", "35.42064", "70.92261", "Asia/Kabul"),("1130490", "Pul-e Khumrī", "Пули-Хумри", "AF", "4", "", "03", "", "", "35.94458", "68.71512", "Asia/Kabul"),("1130497", "Pul-e ‘Alam", "", "AF", "4", "", "17", "", "", "33.99529", "69.02274", "Asia/Kabul"),("1131162", "Panjāb", "", "AF", "4", "", "05", "", "", "34.38795", "67.02327", "Asia/Kabul"),("1131316", "Paghmān", "Пагман", "AF", "4", "", "13", "", "", "34.58787", "68.95091", "Asia/Kabul"),("1131462", "Uruzgān", "", "AF", "4", "", "39", "", "", "32.92775", "66.63253", "Asia/Kabul"),("1131833", "Nīlī", "", "AF", "4", "", "41", "", "", "33.72178", "66.13023", "Asia/Kabul"),("1132495", "Nahrīn", "Нахрин", "AF", "4", "", "03", "", "", "36.0649", "69.13343", "Asia/Kabul"),("1133270", "Mīr Bachah Kōṯ", "", "AF", "4", "", "13", "", "", "34.74999", "69.11899", "Asia/Kabul"),("1133310", "Mīrābād", "", "AF", "4", "", "19", "", "", "30.43624", "61.8383", "Asia/Kabul"),("1133453", "Maymana", "Меймене", "AF", "4", "", "07", "", "", "35.92139", "64.78361", "Asia/Kabul"),("1133574", "Mehtar Lām", "Митарлам", "AF", "4", "", "35", "", "", "34.67139", "70.20944", "Asia/Kabul"),("1133616", "Mazār-e Sharīf", "Мазари-Шариф", "AF", "4", "", "30", "", "", "36.70904", "67.11087", "Asia/Kabul"),("1134720", "Lashkar Gāh", "Лашкаргах", "AF", "4", "", "10", "", "", "31.59382", "64.37161", "Asia/Kabul"),("1134762", "Larkird", "", "AF", "4", "", "33", "", "", "35.48936", "66.66409", "Asia/Kabul"),("1135158", "Kushk", "Кушк", "AF", "4", "", "11", "", "", "33.29565", "61.95221", "Asia/Kabul"),("1135689", "Kunduz", "Кундуз", "AF", "4", "", "24", "", "", "36.72895", "68.857", "Asia/Kabul"),("1136469", "Khōst", "Хост", "AF", "4", "", "37", "", "", "33.33951", "69.92041", "Asia/Kabul"),("1136575", "Khulm", "Ташкурган", "AF", "4", "", "30", "", "", "36.69736", "67.69826", "Asia/Kabul"),("1136863", "Khāsh", "", "AF", "4", "", "19", "", "", "31.52919", "62.79055", "Asia/Kabul"),("1137148", "Khandūd", "", "AF", "4", "", "01", "", "", "36.95127", "72.318", "Asia/Kabul"),("1137168", "Khanabad", "Ханабад", "AF", "4", "", "24", "", "", "36.6825", "69.11556", "Asia/Kabul"),("1137807", "Karukh", "", "AF", "4", "", "11", "", "", "34.48108", "62.5863", "Asia/Kabul"),("1138336", "Kandahār", "Кандагар", "AF", "4", "", "23", "", "", "31.61332", "65.71013", "Asia/Kabul"),("1138958", "Kabul", "Кабул", "AF", "4", "", "13", "", "", "34.52813", "69.17233", "Asia/Kabul"),("1139085", "Jurm", "", "AF", "4", "", "01", "", "", "36.86477", "70.83421", "Asia/Kabul"),("1139715", "Jalālābād", "Джалалабад", "AF", "4", "", "18", "", "", "34.42647", "70.45153", "Asia/Kabul"),("1139807", "Jabal os Saraj", "Dzhabal’-Ussaradzh", "AF", "4", "", "40", "", "", "35.11833", "69.23778", "Asia/Kabul"),("1140026", "Herāt", "Герат", "AF", "4", "", "11", "", "", "34.34817", "62.19967", "Asia/Kabul"),("1141089", "Ghormach", "", "AF", "4", "", "02", "7052787", "", "35.73062", "63.78264", "Asia/Kabul"),("1141269", "Ghazni", "Газни", "AF", "4", "", "08", "", "", "33.55391", "68.42096", "Asia/Kabul"),("1141540", "Gereshk", "Герешк", "AF", "4", "", "10", "", "", "31.82089", "64.57005", "Asia/Kabul"),("1141857", "Gardez", "Гардез", "AF", "4", "", "36", "7053978", "", "33.59744", "69.22592", "Asia/Kabul"),("1142170", "Fayzabad", "Файзабад", "AF", "4", "", "01", "", "", "37.11664", "70.58002", "Asia/Kabul"),("1142239", "Farkhār", "", "AF", "4", "", "26", "", "", "36.57288", "69.85783", "Asia/Kabul"),("1142264", "Farah", "", "AF", "4", "", "06", "", "", "32.37451", "62.11638", "Asia/Kabul"),("1142404", "Kafir Qala", "", "AF", "4", "", "11", "", "", "34.66667", "61.06667", "Asia/Kabul"),("1142545", "Imām Şāḩib", "", "AF", "4", "", "24", "", "", "37.18897", "68.93644", "Asia/Kabul"),("1143838", "Dasht-e Archī", "", "AF", "4", "", "24", "", "", "37.13333", "69.16667", "Asia/Kabul"),("1143874", "Darzāb", "", "AF", "4", "", "31", "", "", "35.97744", "65.37828", "Asia/Kabul"),("1143901", "Markaz-e Ḩukūmat-e Darwēshān", "", "AF", "4", "", "10", "", "", "31.13231", "64.1934", "Asia/Kabul"),("1144942", "Chīras", "", "AF", "4", "", "33", "", "", "35.41674", "65.98234", "Asia/Kabul"),("1145352", "Charikar", "Чарикар", "AF", "4", "", "40", "", "", "35.01361", "69.17139", "Asia/Kabul"),("1145866", "Chahār Burj", "", "AF", "4", "", "11", "", "", "34.24475", "62.19165", "Asia/Kabul"),("1145904", "Fayrōz Kōh", "", "AF", "4", "", "09", "", "", "34.51952", "65.25093", "Asia/Kabul"),("1146822", "Bāsawul", "", "AF", "4", "", "18", "", "", "34.24749", "70.87218", "Asia/Kabul"),("1147066", "Baraki Barak", "", "AF", "4", "", "17", "", "", "33.96744", "68.9492", "Asia/Kabul"),("1147242", "Bāmyān", "", "AF", "4", "", "05", "", "", "34.82156", "67.82734", "Asia/Kabul"),("1147290", "Balkh", "Балх", "AF", "4", "", "30", "", "", "36.75635", "66.8972", "Asia/Kabul"),("1147540", "Baghlān", "Баглан", "AF", "4", "", "03", "", "", "36.13068", "68.70829", "Asia/Kabul"),("1147851", "Ḩukūmatī Azrah", "", "AF", "4", "", "17", "", "", "34.17355", "69.64573", "Asia/Kabul"),("1148106", "Ārt Khwājah", "", "AF", "4", "", "26", "", "", "37.08571", "69.47958", "Asia/Kabul"),("1148205", "Āsmār", "", "AF", "4", "", "34", "", "", "35.03333", "71.35809", "Asia/Kabul"),("1148268", "Ashkāsham", "", "AF", "4", "", "01", "", "", "36.68333", "71.53333", "Asia/Kabul"),("1148311", "Asadābād", "Асадабад", "AF", "4", "", "34", "", "", "34.87311", "71.14697", "Asia/Kabul"),("1148658", "Andkhōy", "", "AF", "4", "", "07", "", "", "36.95293", "65.12376", "Asia/Kabul"),("1148709", "Anār Darah", "", "AF", "4", "", "06", "", "", "32.7587", "61.65397", "Asia/Kabul"),("1149052", "‘Alāqahdārī Dīshū", "", "AF", "4", "", "10", "", "", "30.43206", "63.29802", "Asia/Kabul"),("1429434", "Bāzārak", "Базарак", "AF", "4", "", "42", "", "", "35.31292", "69.51519", "Asia/Kabul"),("1456960", "Maydanshakhr", "", "AF", "4", "", "27", "", "", "34.39561", "68.86618", "Asia/Kabul"),("1469706", "Markaz-e Woluswalī-ye Āchīn", "", "AF", "4", "", "18", "", "", "34.12583", "70.70778", "Asia/Kabul"),("8534261", "Sharan", "", "AF", "4", "", "29", "7053785", "", "33.17568", "68.73045", "Asia/Kabul"),("363243", "Sarandë", "Саранда", "AL", "8", "", "51", "20", "", "39.87556", "20.00528", "Europe/Tirane"),("781443", "Tepelenë", "", "AL", "8", "", "45", "23", "", "40.29583", "20.01917", "Europe/Tirane"),("781979", "Poliçan", "", "AL", "8", "", "40", "01", "", "40.61222", "20.09806", "Europe/Tirane"),("782061", "Peshkopi", "", "AL", "8", "", "41", "", "", "41.685", "20.42889", "Europe/Tirane"),("782070", "Përmet", "", "AL", "8", "", "45", "17", "", "40.23361", "20.35167", "Europe/Tirane"),("782661", "Kukës", "Кукес", "AL", "8", "", "47", "", "", "42.07694", "20.42194", "Europe/Tirane"),("782756", "Korçë", "Корча", "AL", "8", "", "46", "09", "", "40.61861", "20.78083", "Europe/Tirane"),("783059", "Gramsh", "", "AL", "8", "", "43", "07", "", "40.86972", "20.18444", "Europe/Tirane"),("783148", "Gjirokastër", "Гирокастра", "AL", "8", "", "45", "", "", "40.07583", "20.13889", "Europe/Tirane"),("783259", "Ersekë", "", "AL", "8", "", "46", "08", "", "40.33778", "20.67889", "Europe/Tirane"),("783263", "Elbasan", "Эльбасан", "AL", "8", "", "43", "", "", "41.1125", "20.08222", "Europe/Tirane"),("783408", "Çorovodë", "", "AL", "8", "", "40", "22", "", "40.50417", "20.22722", "Europe/Tirane"),("783493", "Burrel", "Буррель", "AL", "8", "", "41", "15", "", "41.61028", "20.00889", "Europe/Tirane"),("783508", "Bulqizë", "", "AL", "8", "", "41", "29", "", "41.49167", "20.22194", "Europe/Tirane"),("783606", "Bilisht", "", "AL", "8", "", "46", "31", "", "40.6275", "20.99", "Europe/Tirane"),("832209", "Librazhd-Qendër", "", "AL", "8", "", "43", "13", "", "41.19694", "20.33556", "Europe/Tirane"),("3183719", "Vlorë", "Влёра", "AL", "8", "", "51", "", "", "40.46667", "19.48972", "Europe/Tirane"),("3183875", "Tirana", "Тирана", "AL", "8", "", "50", "", "", "41.3275", "19.81889", "Europe/Tirane"),("3184081", "Shkodër", "Шкодер", "AL", "8", "", "49", "21", "", "42.06828", "19.51258", "Europe/Tirane"),("3184099", "Shijak", "", "AL", "8", "", "42", "03", "", "41.34556", "19.56722", "Europe/Tirane"),("3184197", "Selenicë", "", "AL", "8", "", "51", "27", "", "40.53056", "19.63583", "Europe/Tirane"),("3184252", "Rrogozhinë", "", "AL", "8", "", "50", "33", "", "41.07639", "19.66528", "Europe/Tirane"),("3184264", "Rrëshen", "", "AL", "8", "", "48", "16", "", "41.7675", "19.87556", "Europe/Tirane"),("3184290", "Roskovec", "", "AL", "8", "", "44", "05", "", "40.7375", "19.70222", "Europe/Tirane"),("3184388", "Pukë", "", "AL", "8", "", "49", "19", "", "42.04444", "19.89972", "Europe/Tirane"),("3184497", "Peqin", "", "AL", "8", "", "43", "38", "", "41.04611", "19.75111", "Europe/Tirane"),("3184517", "Patos Fshat", "", "AL", "8", "", "44", "", "", "40.64278", "19.65083", "Europe/Tirane"),("3184806", "Mamurras", "", "AL", "8", "", "48", "35", "", "41.5775", "19.69222", "Europe/Tirane"),("3184862", "Lushnjë", "Люшня", "AL", "8", "", "44", "14", "", "40.94194", "19.705", "Europe/Tirane"),("3184935", "Lezhë", "Лежа", "AL", "8", "", "48", "", "", "41.78361", "19.64361", "Europe/Tirane"),("3185012", "Laç", "Лак", "AL", "8", "", "48", "35", "", "41.63556", "19.71306", "Europe/Tirane"),("3185060", "Kuçovë", "Кучова", "AL", "8", "", "40", "34", "", "40.80028", "19.91667", "Europe/Tirane"),("3185082", "Krujë", "Круе", "AL", "8", "", "42", "10", "", "41.50917", "19.79278", "Europe/Tirane"),("3185211", "Kavajë", "Кавайе", "AL", "8", "", "50", "33", "", "41.18556", "19.55694", "Europe/Tirane"),("3185270", "Kamëz", "", "AL", "8", "", "50", "28", "", "41.38167", "19.76028", "Europe/Tirane"),("3185638", "Fushë-Krujë", "", "AL", "8", "", "42", "10", "", "41.47833", "19.71778", "Europe/Tirane"),("3185670", "Fier-Çifçi", "", "AL", "8", "", "44", "", "", "40.71667", "19.56667", "Europe/Tirane"),("3185672", "Fier", "Фиери", "AL", "8", "", "44", "", "", "40.72389", "19.55611", "Europe/Tirane"),("3185728", "Durrës", "Дуррес", "AL", "8", "", "42", "", "", "41.32306", "19.44139", "Europe/Tirane"),("3185897", "Cërrik", "", "AL", "8", "", "43", "04", "", "41.03167", "19.97583", "Europe/Tirane"),("3186084", "Berat", "Берат", "AL", "8", "", "40", "01", "", "40.70583", "19.95222", "Europe/Tirane"),("3186145", "Ballsh", "", "AL", "8", "", "44", "37", "", "40.59889", "19.73472", "Europe/Tirane"),("174710", "Yeghegnadzor", "", "AM", "51", "", "10", "", "", "39.76389", "45.33239", "Asia/Yerevan"),("174725", "Vedi", "", "AM", "51", "", "02", "", "", "39.91388", "44.7251", "Asia/Yerevan"),("174726", "Vayk’", "", "AM", "51", "", "10", "", "", "39.6889", "45.46668", "Asia/Yerevan"),("174875", "Kapan", "Капан", "AM", "51", "", "08", "", "", "39.20755", "46.40576", "Asia/Yerevan"),("174895", "Goris", "Горис", "AM", "51", "", "08", "", "", "39.51111", "46.34168", "Asia/Yerevan"),("174972", "Hats’avan", "Ацаван", "AM", "51", "", "08", "", "", "39.46405", "45.97047", "Asia/Yerevan"),("174979", "Artashat", "Арташат", "AM", "51", "", "02", "", "", "39.96144", "44.54447", "Asia/Yerevan"),("174991", "Ararat", "Арарат", "AM", "51", "", "02", "", "", "39.83069", "44.70569", "Asia/Yerevan"),("616052", "Yerevan", "Ереван", "AM", "51", "", "11", "", "", "40.18111", "44.51361", "Asia/Yerevan"),("616062", "Ejmiatsin", "Вагаршапат", "AM", "51", "", "03", "", "", "40.16557", "44.29462", "Asia/Yerevan"),("616065", "Yeghvard", "", "AM", "51", "", "05", "", "", "40.32507", "44.48608", "Asia/Yerevan"),("616108", "Vardenis", "", "AM", "51", "", "04", "", "", "40.18329", "45.73053", "Asia/Yerevan"),("616109", "Vardenik", "", "AM", "51", "", "04", "", "", "40.13348", "45.44311", "Asia/Yerevan"),("616178", "Tashir", "", "AM", "51", "", "06", "", "", "41.12072", "44.28462", "Asia/Yerevan"),("616194", "Step’anavan", "", "AM", "51", "", "06", "", "", "41.00995", "44.38531", "Asia/Yerevan"),("616199", "Spitak", "Спитак", "AM", "51", "", "06", "", "", "40.83221", "44.26731", "Asia/Yerevan"),("616250", "Sevan", "Севан", "AM", "51", "", "04", "", "", "40.5473", "44.94171", "Asia/Yerevan"),("616255", "Sarukhan", "", "AM", "51", "", "04", "", "", "40.29169", "45.13068", "Asia/Yerevan"),("616328", "Sardarapat", "", "AM", "51", "", "03", "", "", "40.13206", "44.00969", "Asia/Yerevan"),("616333", "Noyemberyan", "", "AM", "51", "", "09", "", "", "41.17244", "44.99917", "Asia/Yerevan"),("616361", "Noratus", "", "AM", "51", "", "04", "", "", "40.37793", "45.18048", "Asia/Yerevan"),("616375", "Nerk’in Getashen", "", "AM", "51", "", "04", "", "", "40.14172", "45.27087", "Asia/Yerevan"),("616417", "Metsamor", "", "AM", "51", "", "03", "", "", "40.07233", "44.29169", "Asia/Yerevan"),("616435", "Masis", "Масис", "AM", "51", "", "02", "", "", "40.06542", "44.41618", "Asia/Yerevan"),("616438", "Martuni", "", "AM", "51", "", "04", "", "", "40.13892", "45.30548", "Asia/Yerevan"),("616530", "Vanadzor", "Кировакан", "AM", "51", "", "06", "", "", "40.80456", "44.4939", "Asia/Yerevan"),("616576", "Karanlukh", "", "AM", "51", "", "04", "", "", "40.10444", "45.28972", "Asia/Yerevan"),("616599", "Gavarr", "Гавар", "AM", "51", "", "04", "", "", "40.35398", "45.12386", "Asia/Yerevan"),("616627", "Ijevan", "", "AM", "51", "", "09", "", "", "40.87877", "45.14851", "Asia/Yerevan"),("616629", "Hrazdan", "Раздан", "AM", "51", "", "05", "", "", "40.49748", "44.7662", "Asia/Yerevan"),("616631", "Armavir", "Армавир", "AM", "51", "", "03", "", "", "40.15446", "44.03815", "Asia/Yerevan"),("616635", "Gyumri", "Гюмри", "AM", "51", "", "07", "", "", "40.7942", "43.84528", "Asia/Yerevan"),("616697", "Garrni", "", "AM", "51", "", "05", "", "", "40.11931", "44.73442", "Asia/Yerevan"),("616752", "Dilijan", "", "AM", "51", "", "09", "", "", "40.7417", "44.8501", "Asia/Yerevan"),("616786", "Chambarak", "", "AM", "51", "", "04", "", "", "40.59655", "45.35498", "Asia/Yerevan"),("616790", "Byureghavan", "", "AM", "51", "", "05", "", "", "40.31417", "44.59333", "Asia/Yerevan"),("616802", "Berd", "", "AM", "51", "", "09", "", "", "40.88135", "45.38901", "Asia/Yerevan"),("616877", "Ashtarak", "Аштарак", "AM", "51", "", "01", "", "", "40.2991", "44.36204", "Asia/Yerevan"),("616953", "Aparan", "", "AM", "51", "", "01", "", "", "40.59323", "44.3589", "Asia/Yerevan"),("616974", "Alaverdi", "", "AM", "51", "", "06", "", "", "41.09766", "44.67316", "Asia/Yerevan"),("616989", "Akhuryan", "", "AM", "51", "", "07", "", "", "40.78003", "43.90027", "Asia/Yerevan"),("617026", "Abovyan", "Абовян", "AM", "51", "", "05", "", "", "40.27368", "44.63348", "Asia/Yerevan"),("145531", "Saurimo", "Сауримо", "AO", "24", "", "18", "", "", "-9.66078", "20.39155", "Africa/Luanda"),("145724", "Lucapa", "Лукапа", "AO", "24", "", "17", "", "", "-8.41915", "20.74466", "Africa/Luanda"),("876177", "Luau", "Луау", "AO", "24", "", "14", "", "", "-10.70727", "22.22466", "Africa/Luanda"),("876233", "Léua", "", "AO", "24", "", "14", "", "", "-11.65", "20.45", "Africa/Luanda"),("2236568", "Uíge", "Уиже", "AO", "24", "", "15", "", "", "-7.60874", "15.06131", "Africa/Luanda"),("2236967", "Soio", "Сойу", "AO", "24", "", "16", "", "", "-6.1349", "12.36894", "Africa/Luanda"),("2239001", "Nzeto", "Нзето", "AO", "24", "", "16", "", "", "-7.23116", "12.8666", "Africa/Luanda"),("2239076", "N’dalatando", "", "AO", "24", "", "05", "", "", "-9.29782", "14.91162", "Africa/Luanda"),("2239520", "Mbanza Congo", "", "AO", "24", "", "16", "", "", "-6.26703", "14.2401", "Africa/Luanda"),("2239862", "Malanje", "Маланже", "AO", "24", "", "12", "2239859", "", "-9.54015", "16.34096", "Africa/Luanda"),("2240449", "Luanda", "Луанда", "AO", "24", "", "20", "", "", "-8.83682", "13.23432", "Africa/Luanda"),("2242001", "Caxito", "Кашито", "AO", "24", "", "19", "", "", "-8.57848", "13.66425", "Africa/Luanda"),("2242885", "Camabatela", "", "AO", "24", "", "05", "", "", "-8.18812", "15.37495", "Africa/Luanda"),("2243271", "Cabinda", "Кабинда", "AO", "24", "", "03", "", "", "-5.55", "12.2", "Africa/Luanda"),("3345497", "Uacu Cungo", "", "AO", "24", "", "06", "", "", "-11.35669", "15.11719", "Africa/Luanda"),("3346015", "Sumbe", "Сумбе", "AO", "24", "", "06", "", "", "-11.20605", "13.84371", "Africa/Luanda"),("3346598", "Quibala", "", "AO", "24", "", "06", "", "", "-10.73366", "14.97995", "Africa/Luanda"),("3346821", "Ondjiva", "", "AO", "24", "", "07", "", "", "-17.06667", "15.73333", "Africa/Luanda"),("3347019", "Namibe", "Намибе", "AO", "24", "", "13", "", "", "-15.19611", "12.15222", "Africa/Luanda"),("3347353", "Menongue", "Менонге", "AO", "24", "AO", "04", "", "", "-14.6585", "17.69099", "Africa/Luanda"),("3347719", "Luena", "Луэна", "AO", "24", "", "14", "", "", "-11.78333", "19.91667", "Africa/Luanda"),("3347762", "Lubango", "Лубанго", "AO", "24", "", "09", "", "", "-14.91717", "13.4925", "Africa/Luanda"),("3347853", "Longonjo", "Логонжу", "AO", "24", "", "08", "", "", "-12.90667", "15.25333", "Africa/Luanda"),("3347939", "Lobito", "Лобиту", "AO", "24", "", "01", "", "", "-12.3644", "13.53601", "Africa/Luanda"),("3348078", "Cuito", "Куито", "AO", "24", "", "02", "", "", "-12.38333", "16.93333", "Africa/Luanda"),("3348313", "Huambo", "Уамбо", "AO", "24", "", "08", "", "", "-12.77611", "15.73917", "Africa/Luanda"),("3349580", "Chissamba", "", "AO", "24", "", "02", "", "", "-12.16667", "17.33333", "Africa/Luanda"),("3350246", "Catumbela", "Катумбела", "AO", "24", "", "01", "", "", "-12.43002", "13.54677", "Africa/Luanda"),("3350372", "Catabola", "Катабола", "AO", "24", "", "02", "", "", "-12.15", "17.28333", "Africa/Luanda"),("3351014", "Camacupa", "Камакупа", "AO", "24", "", "02", "", "", "-12.01667", "17.48333", "Africa/Luanda"),("3351024", "Caluquembe", "Калукембе", "AO", "24", "", "09", "", "", "-13.78333", "14.68333", "Africa/Luanda"),("3351380", "Caconda", "", "AO", "24", "", "09", "", "", "-13.73333", "15.06667", "Africa/Luanda"),("3351500", "Caála", "Каале", "AO", "24", "", "08", "", "", "-12.8525", "15.56056", "Africa/Luanda"),("3351663", "Benguela", "Бенгела", "AO", "24", "", "01", "", "", "-12.57626", "13.40547", "Africa/Luanda"),("9376229", "Chela", "", "AO", "24", "", "08", "3347879", "", "-12.30261", "15.43358", "Africa/Luanda"),("3427213", "Zárate", "Зарате", "AR", "32", "", "01", "06882", "", "-34.09814", "-59.02858", "America/Argentina/Buenos_Aires"),("3427388", "Villa Ocampo", "", "AR", "32", "", "21", "82049", "", "-28.48752", "-59.35515", "America/Argentina/Cordoba"),("3427399", "Villa María Grande", "", "AR", "32", "", "08", "30084", "", "-31.66565", "-59.90182", "America/Argentina/Cordoba"),("3427408", "Villa Lugano", "", "AR", "32", "", "07", "", "", "-34.67907", "-58.47263", "America/Argentina/Buenos_Aires"),("3427420", "Villa Hernandarias", "", "AR", "32", "", "08", "30084", "", "-31.23101", "-59.985", "America/Argentina/Cordoba"),("3427428", "Villaguay", "", "AR", "32", "", "08", "30113", "", "-31.8653", "-59.02689", "America/Argentina/Cordoba"),("3427431", "Villa Gesell", "Вилья-Хесель", "AR", "32", "", "01", "06868", "", "-37.26394", "-56.97304", "America/Argentina/Buenos_Aires"),("3427443", "Villa Elisa", "", "AR", "32", "", "08", "30008", "", "-32.1632", "-58.40082", "America/Argentina/Cordoba"),("3427537", "Veinticinco de Mayo", "", "AR", "32", "", "14", "54119", "", "-27.37679", "-54.74312", "America/Argentina/Cordoba"),("3427582", "Urdinarrain", "", "AR", "32", "", "08", "30056", "", "-32.68573", "-58.89323", "America/Argentina/Cordoba"),("3427761", "Tigre", "Тигре", "AR", "32", "AR", "01", "06805", "", "-34.42603", "-58.57962", "America/Argentina/Buenos_Aires"),("3427833", "Tandil", "Тандиль", "AR", "32", "", "01", "06791", "", "-37.32167", "-59.13316", "America/Argentina/Buenos_Aires"),("3428068", "San Vicente", "", "AR", "32", "", "14", "54112", "", "-26.61667", "-54.13333", "America/Argentina/Cordoba"),("3428071", "Santo Tomé", "", "AR", "32", "", "06", "18168", "", "-28.54939", "-56.04077", "America/Argentina/Cordoba"),("3428079", "Santo Pipó", "", "AR", "32", "", "14", "54098", "", "-27.14132", "-55.40867", "America/Argentina/Cordoba"),("3428182", "Santa Rosa", "", "AR", "32", "", "06", "18028", "", "-28.26318", "-58.11891", "America/Argentina/Cordoba"),("3428287", "Santa Lucía", "", "AR", "32", "", "06", "18091", "", "-28.98746", "-59.10287", "America/Argentina/Cordoba"),("3428359", "Santa Elena", "", "AR", "32", "", "08", "30070", "", "-30.94768", "-59.78696", "America/Argentina/Cordoba"),("3428481", "San Salvador", "", "AR", "32", "", "08", "30088", "", "-31.62487", "-58.50524", "America/Argentina/Cordoba"),("3428577", "San Pedro", "", "AR", "32", "", "14", "54112", "", "-26.62207", "-54.10842", "America/Argentina/Cordoba"),("3428644", "San Miguel", "", "AR", "32", "", "06", "18154", "", "-27.99585", "-57.58964", "America/Argentina/Cordoba"),("3428708", "San Luis del Palmar", "", "AR", "32", "", "06", "18140", "", "-27.5079", "-58.55454", "America/Argentina/Cordoba"),("3428759", "San Lorenzo", "", "AR", "32", "", "06", "18126", "", "-28.13306", "-58.76733", "America/Argentina/Cordoba"),("3428858", "San José de Feliciano", "", "AR", "32", "", "08", "30042", "", "-30.38452", "-58.75167", "America/Argentina/Cordoba"),("3428928", "San José", "", "AR", "32", "", "14", "54007", "", "-27.76979", "-55.7826", "America/Argentina/Cordoba"),("3428975", "San Javier", "", "AR", "32", "", "21", "82098", "", "-30.57781", "-59.9317", "America/Argentina/Cordoba"),("3428992", "San Isidro", "", "AR", "32", "", "01", "06756", "", "-34.4721", "-58.52708", "America/Argentina/Buenos_Aires"),("3429160", "San Clemente del Tuyú", "", "AR", "32", "", "01", "06420", "", "-36.35694", "-56.72351", "America/Argentina/Buenos_Aires"),("3429403", "Saladas", "", "AR", "32", "", "06", "18126", "", "-28.25384", "-58.62591", "America/Argentina/Cordoba"),("3429439", "Rosario del Tala", "", "AR", "32", "", "08", "30091", "", "-32.30286", "-59.14545", "America/Argentina/Cordoba"),("3429576", "Retiro", "Ретиро", "AR", "32", "", "07", "", "", "-34.58333", "-58.38333", "America/Argentina/Buenos_Aires"),("3429577", "Resistencia", "Ресистенсия", "AR", "32", "", "03", "22140", "", "-27.46056", "-58.98389", "America/Argentina/Cordoba"),("3429594", "Reconquista", "Реконкиста", "AR", "32", "", "21", "82049", "", "-29.15", "-59.65", "America/Argentina/Cordoba"),("3429652", "Quilmes", "Кильмес", "AR", "32", "", "01", "06658", "", "-34.72904", "-58.26374", "America/Argentina/Buenos_Aires"),("3429713", "Puerto Vilelas", "", "AR", "32", "", "03", "22140", "", "-27.51414", "-58.93906", "America/Argentina/Cordoba"),("3429721", "Puerto Tirol", "", "AR", "32", "", "03", "22077", "", "-27.37218", "-59.08206", "America/Argentina/Cordoba"),("3429732", "Puerto Rico", "", "AR", "32", "", "14", "54077", "", "-26.79598", "-55.02402", "America/Argentina/Cordoba"),("3429738", "Puerto Piray", "", "AR", "32", "", "14", "54084", "", "-26.46779", "-54.71476", "America/Argentina/Cordoba"),("3429764", "Puerto Libertad", "", "AR", "32", "", "14", "54063", "", "-25.91641", "-54.62089", "America/Argentina/Cordoba"),("3429777", "Puerto Iguazú", "Пуэрто-Игуасу", "AR", "32", "AR", "14", "54063", "", "-25.59912", "-54.57355", "America/Argentina/Cordoba"),("3429786", "Puerto Esperanza", "", "AR", "32", "", "14", "54063", "", "-26.01517", "-54.67306", "America/Argentina/Cordoba"),("3429790", "Puerto Eldorado", "", "AR", "32", "", "14", "54042", "", "-26.40843", "-54.69463", "America/Argentina/Cordoba"),("3429866", "Presidencia de la Plaza", "", "AR", "32", "", "03", "22119", "", "-27.00147", "-59.84243", "America/Argentina/Cordoba"),("3429886", "Posadas", "Посадас", "AR", "32", "", "14", "54028", "", "-27.36708", "-55.89608", "America/Argentina/Cordoba"),("3429902", "Pontevedra", "", "AR", "32", "", "01", "06539", "", "-34.74785", "-58.70072", "America/Argentina/Buenos_Aires"),("3429949", "Pirané", "", "AR", "32", "", "09", "34056", "", "-25.73239", "-59.10879", "America/Argentina/Cordoba"),("3430029", "Perugorría", "", "AR", "32", "", "06", "18035", "", "-29.34132", "-58.61059", "America/Argentina/Cordoba"),("3430104", "Paso de los Libres", "", "AR", "32", "", "06", "18119", "", "-29.71251", "-57.08771", "America/Argentina/Cordoba"),("3430105", "Paso de la Patria", "", "AR", "32", "", "06", "18133", "", "-27.31676", "-58.57197", "America/Argentina/Cordoba"),("3430178", "Panambí", "", "AR", "32", "", "14", "54091", "", "-27.72369", "-54.91515", "America/Argentina/Cordoba"),("3430180", "Pampa del Indio", "", "AR", "32", "", "03", "22084", "", "-26.06468", "-59.91898", "America/Argentina/Cordoba"),("3430186", "Palo Santo", "", "AR", "32", "", "09", "34056", "", "-25.56332", "-59.33781", "America/Argentina/Cordoba"),("3430340", "Oberá", "Обера", "AR", "32", "", "14", "54091", "", "-27.48706", "-55.11994", "America/Argentina/Cordoba"),("3430402", "Nuestra Señora del Rosario de Caa Catí", "", "AR", "32", "", "06", "18063", "", "-27.75072", "-57.62073", "America/Argentina/Cordoba"),("3430443", "Necochea", "", "AR", "32", "", "01", "06581", "", "-38.5545", "-58.73961", "America/Argentina/Buenos_Aires"),("3430545", "Morón", "", "AR", "32", "", "01", "06568", "", "-34.6509", "-58.61956", "America/Argentina/Buenos_Aires"),("3430598", "Monte Caseros", "", "AR", "32", "", "06", "18112", "", "-30.25359", "-57.63626", "America/Argentina/Cordoba"),("3430601", "Montecarlo", "", "AR", "32", "", "14", "54084", "", "-26.5662", "-54.757", "America/Argentina/Cordoba"),("3430648", "Mocoretá", "", "AR", "32", "", "06", "18112", "", "-30.61891", "-57.96344", "America/Argentina/Cordoba"),("3430708", "Mercedes", "", "AR", "32", "", "01", "06532", "", "-34.65145", "-59.43068", "America/Argentina/Buenos_Aires"),("3430709", "Mercedes", "Мерседес", "AR", "32", "", "06", "18105", "", "-29.18416", "-58.07519", "America/Argentina/Cordoba"),("3430760", "Mburucuyá", "", "AR", "32", "", "06", "18098", "", "-28.04532", "-58.22835", "America/Argentina/Cordoba"),("3430857", "Margarita Belén", "", "AR", "32", "", "03", "22126", "", "-27.2616", "-58.97219", "America/Argentina/Cordoba"),("3430863", "Mar del Plata", "Мар-дель-Плата", "AR", "32", "", "01", "06357", "", "-38.00228", "-57.55754", "America/Argentina/Buenos_Aires"),("3430940", "Malabrigo", "", "AR", "32", "", "21", "82049", "", "-29.34636", "-59.96957", "America/Argentina/Cordoba"),("3430968", "Maciá", "", "AR", "32", "", "08", "30091", "", "-32.1722", "-59.39947", "America/Argentina/Cordoba"),("3430988", "Luján", "Лухан", "AR", "32", "", "01", "06497", "", "-34.57028", "-59.105", "America/Argentina/Buenos_Aires"),("3431606", "Las Toscas", "", "AR", "32", "", "21", "82049", "", "-28.3529", "-59.25795", "America/Argentina/Cordoba"),("3431916", "Larroque", "", "AR", "32", "", "08", "30056", "", "-33.03595", "-59.00125", "America/Argentina/Cordoba"),("3432043", "La Plata", "Ла-Плата", "AR", "32", "", "01", "06441", "", "-34.92145", "-57.95453", "America/Argentina/Buenos_Aires"),("3432079", "La Paz", "", "AR", "32", "", "08", "30070", "", "-30.74485", "-59.64566", "America/Argentina/Cordoba"),("3432355", "La Leonesa", "", "AR", "32", "", "03", "22014", "", "-27.03786", "-58.70347", "America/Argentina/Cordoba"),("3432760", "La Cruz", "", "AR", "32", "", "06", "18147", "", "-29.17443", "-56.64326", "America/Argentina/Cordoba"),("3433349", "Jardín América", "", "AR", "32", "", "14", "54098", "", "-27.04346", "-55.22698", "America/Argentina/Cordoba"),("3433363", "Itatí", "", "AR", "32", "", "06", "18077", "", "-27.27043", "-58.24458", "America/Argentina/Cordoba"),("3433513", "Ibarreta", "", "AR", "32", "", "09", "34035", "", "-25.21438", "-59.85851", "America/Argentina/Cordoba"),("3433658", "Gualeguaychú", "Гуалегуайчу", "AR", "32", "", "08", "30056", "", "-33.00937", "-58.51722", "America/Argentina/Cordoba"),("3433663", "Gualeguay", "", "AR", "32", "", "08", "30049", "", "-33.14156", "-59.30966", "America/Argentina/Cordoba"),("3433715", "Goya", "Гойя", "AR", "32", "", "06", "18070", "", "-29.14395", "-59.2651", "America/Argentina/Cordoba"),("3433743", "Gobernador Roca", "", "AR", "32", "", "14", "54098", "", "-27.18636", "-55.46433", "America/Argentina/Cordoba"),("3433753", "Gobernador Ingeniero Valentín Virasoro", "", "AR", "32", "", "06", "18168", "", "-28.05", "-56.03333", "America/Argentina/Cordoba"),("3433803", "General José de San Martín", "", "AR", "32", "", "03", "22084", "", "-26.53743", "-59.34158", "America/Argentina/Cordoba"),("3433836", "Garupá", "", "AR", "32", "", "14", "54028", "", "-27.48171", "-55.82921", "America/Argentina/Cordoba"),("3433839", "Garuhapé", "", "AR", "32", "", "14", "54077", "", "-26.81768", "-54.95665", "America/Argentina/Cordoba"),("3433899", "Formosa", "Формоза", "AR", "32", "", "09", "34014", "", "-26.17753", "-58.17814", "America/Argentina/Cordoba"),("3433901", "Fontana", "", "AR", "32", "", "03", "22140", "", "-27.41813", "-59.02392", "America/Argentina/Cordoba"),("3433956", "Federal", "", "AR", "32", "", "08", "30035", "", "-30.95465", "-58.78326", "America/Argentina/Cordoba"),("3433959", "Federación", "", "AR", "32", "", "08", "30028", "", "-31.00621", "-57.89962", "America/Argentina/Cordoba"),("3434095", "Esquina", "", "AR", "32", "", "06", "18049", "", "-30.01444", "-59.52719", "America/Argentina/Cordoba"),("3434291", "El Soberbio", "", "AR", "32", "", "14", "54056", "", "-27.29847", "-54.19877", "America/Argentina/Cordoba"),("3434731", "El Colorado", "", "AR", "32", "", "09", "34056", "", "-26.30808", "-59.37291", "America/Argentina/Cordoba"),("3434932", "El Alcázar", "", "AR", "32", "", "14", "54077", "", "-26.71459", "-54.81523", "America/Argentina/Cordoba"),("3434995", "Dos de Mayo", "", "AR", "32", "", "14", "54014", "", "-27.02277", "-54.68669", "America/Argentina/Cordoba"),("3435038", "Dolores", "", "AR", "32", "", "01", "06238", "", "-36.31321", "-57.67918", "America/Argentina/Buenos_Aires"),("3435103", "Curuzú Cuatiá", "", "AR", "32", "", "06", "18035", "", "-29.79171", "-58.0546", "America/Argentina/Cordoba"),("3435217", "Corrientes", "Корриентес", "AR", "32", "", "06", "18021", "", "-27.4806", "-58.8341", "America/Argentina/Cordoba"),("3435261", "Concordia", "Конкордия", "AR", "32", "", "08", "30015", "", "-31.39296", "-58.02089", "America/Argentina/Cordoba"),("3435264", "Concepción del Uruguay", "Консепсьон-дель-Уругвай", "AR", "32", "", "08", "30098", "", "-32.48249", "-58.23722", "America/Argentina/Cordoba"),("3435266", "Concepción de la Sierra", "", "AR", "32", "", "14", "54035", "", "-27.98311", "-55.52031", "America/Argentina/Cordoba"),("3435283", "Comandante Fontana", "", "AR", "32", "", "09", "34035", "", "-25.33453", "-59.68212", "America/Argentina/Cordoba"),("3435290", "Colonia Wanda", "", "AR", "32", "", "14", "54063", "", "-25.97408", "-54.42806", "America/Argentina/Cordoba"),("3435344", "Colonia Aurora", "", "AR", "32", "", "14", "54119", "", "-27.47428", "-54.52498", "America/Argentina/Cordoba"),("3435356", "Colegiales", "", "AR", "32", "", "07", "", "", "-34.57365", "-58.44924", "America/Argentina/Buenos_Aires"),("3435364", "Clorinda", "", "AR", "32", "", "09", "34049", "", "-25.28481", "-57.71851", "America/Argentina/Cordoba"),("3435486", "Chajarí", "", "AR", "32", "", "08", "30028", "", "-30.75048", "-57.97962", "America/Argentina/Cordoba"),("3435532", "Cerro Azul", "", "AR", "32", "", "14", "54070", "", "-27.6331", "-55.4962", "America/Argentina/Cordoba"),("3435701", "Capioví", "", "AR", "32", "", "14", "54077", "", "-26.92998", "-55.06084", "America/Argentina/Cordoba"),("3435734", "Candelaria", "", "AR", "32", "", "14", "54021", "", "-27.4595", "-55.74536", "America/Argentina/Cordoba"),("3435750", "Campo Viera", "", "AR", "32", "", "14", "54091", "", "-27.38333", "-55.03333", "America/Argentina/Cordoba"),("3435765", "Campo Ramón", "", "AR", "32", "", "14", "54091", "", "-27.46108", "-55.01901", "America/Argentina/Cordoba"),("3435789", "Campo Grande", "", "AR", "32", "", "14", "54014", "", "-27.2077", "-54.97977", "America/Argentina/Cordoba"),("3435810", "Campana", "Кампана", "AR", "32", "", "01", "06126", "", "-34.16874", "-58.95914", "America/Argentina/Buenos_Aires"),("3435910", "Buenos Aires", "Буэнос-Айрес", "AR", "32", "", "07", "", "", "-34.61315", "-58.37723", "America/Argentina/Buenos_Aires"),("3435966", "Bovril", "", "AR", "32", "", "08", "30070", "", "-31.34311", "-59.44512", "America/Argentina/Cordoba"),("3436030", "Bernardo de Irigoyen", "", "AR", "32", "", "14", "54049", "", "-26.2552", "-53.64581", "America/Argentina/Cordoba"),("3436124", "Barranqueras", "", "AR", "32", "", "03", "22140", "", "-27.48132", "-58.93925", "America/Argentina/Cordoba"),("3436199", "Azul", "Азул", "AR", "32", "", "01", "06049", "", "-36.77698", "-59.85854", "America/Argentina/Buenos_Aires"),("3436230", "Avellaneda", "", "AR", "32", "", "21", "82049", "", "-29.11761", "-59.65834", "America/Argentina/Cordoba"),("3436287", "Aristóbulo del Valle", "", "AR", "32", "", "14", "54014", "", "-27.09625", "-54.89626", "America/Argentina/Cordoba"),("3436370", "Alvear", "", "AR", "32", "", "06", "18056", "", "-29.09683", "-56.55043", "America/Argentina/Cordoba"),("3436448", "Alba Posse", "", "AR", "32", "", "14", "54119", "", "-27.56978", "-54.68262", "America/Argentina/Cordoba"),("3832132", "Zapala", "Сапала", "AR", "32", "", "15", "58112", "", "-38.89916", "-70.05442", "America/Argentina/Salta"),("3832189", "Yuto", "", "AR", "32", "", "10", "38035", "", "-23.64342", "-64.47194", "America/Argentina/Jujuy"),("3832260", "Yerba Buena", "", "AR", "32", "", "24", "90119", "", "-26.81667", "-65.31667", "America/Argentina/Tucuman"),("3832376", "Yacimiento Río Turbio", "", "AR", "32", "", "20", "78021", "", "-51.57321", "-72.3508", "America/Argentina/Rio_Gallegos"),("3832647", "Villa Regina", "", "AR", "32", "", "16", "62042", "", "-39.1", "-67.06667", "America/Argentina/Salta"),("3832653", "Villa Paula de Sarmiento", "", "AR", "32", "", "18", "70042", "", "-31.4933", "-68.53838", "America/Argentina/San_Juan"),("3832658", "Villa Ojo de Agua", "", "AR", "32", "", "22", "86126", "", "-29.50003", "-63.69377", "America/Argentina/Cordoba"),("3832662", "Villa Nueva", "", "AR", "32", "", "05", "14042", "", "-32.43293", "-63.24763", "America/Argentina/Cordoba"),("3832694", "Villa María", "", "AR", "32", "", "05", "14042", "", "-32.40751", "-63.24016", "America/Argentina/Cordoba"),("3832711", "Villa La Angostura", "", "AR", "32", "", "15", "58070", "", "-40.76173", "-71.64631", "America/Argentina/Salta"),("3832719", "Villa Huidobro", "", "AR", "32", "", "05", "14035", "", "-34.83826", "-64.58686", "America/Argentina/Cordoba"),("3832734", "Villa General Belgrano", "", "AR", "32", "", "05", "14007", "", "-31.97542", "-64.5559", "America/Argentina/Cordoba"),("3832756", "Villa Dolores", "", "AR", "32", "", "05", "14133", "", "-31.94585", "-65.18958", "America/Argentina/Cordoba"),("3832759", "Villa de Soto", "", "AR", "32", "", "05", "14028", "", "-30.85523", "-64.99947", "America/Argentina/Cordoba"),("3832763", "Villa del Totoral", "", "AR", "32", "", "05", "14168", "", "-30.81667", "-63.71667", "America/Argentina/Cordoba"),("3832778", "Villa Constitución", "", "AR", "32", "", "21", "82028", "", "-33.22778", "-60.3297", "America/Argentina/Cordoba"),("3832783", "Chañar Ladeado", "", "AR", "32", "", "21", "82014", "", "-33.32524", "-62.03831", "America/Argentina/Cordoba"),("3832791", "Villa Carlos Paz", "Карлос-Паз", "AR", "32", "", "05", "14091", "", "-31.42414", "-64.49778", "America/Argentina/Cordoba"),("3832793", "Villa Cañás", "", "AR", "32", "", "21", "82042", "", "-34.00565", "-61.60757", "America/Argentina/Cordoba"),("3832797", "Villa Berthet", "", "AR", "32", "", "03", "22147", "", "-27.29174", "-60.41263", "America/Argentina/Cordoba"),("3832811", "Villa Ángela", "", "AR", "32", "", "03", "22098", "", "-27.57383", "-60.71526", "America/Argentina/Cordoba"),("3832815", "Villa Allende", "", "AR", "32", "", "05", "14021", "", "-31.29458", "-64.29538", "America/Argentina/Cordoba"),("3832899", "Viedma", "Вьедма", "AR", "32", "", "16", "62007", "", "-40.81345", "-62.99668", "America/Argentina/Salta"),("3832917", "Vicuña Mackenna", "", "AR", "32", "", "05", "14098", "", "-33.91965", "-64.39215", "America/Argentina/Cordoba"),("3832923", "Victorica", "", "AR", "32", "", "11", "42098", "", "-36.21505", "-65.43586", "America/Argentina/Salta"),("3832934", "Victoria", "Виктория", "AR", "32", "", "08", "30105", "", "-32.61841", "-60.15478", "America/Argentina/Cordoba"),("3832959", "Viale", "", "AR", "32", "", "08", "30084", "", "-31.86782", "-60.00722", "America/Argentina/Cordoba"),("3833027", "Vera", "", "AR", "32", "", "21", "82133", "", "-29.4593", "-60.21261", "America/Argentina/Cordoba"),("3833062", "Venado Tuerto", "Неукен", "AR", "32", "", "21", "82042", "", "-33.74556", "-61.96885", "America/Argentina/Cordoba"),("3833111", "Veinticinco de Mayo", "", "AR", "32", "", "11", "42112", "", "-37.7741", "-67.71638", "America/Argentina/Salta"),("3833112", "Veinticinco de Mayo", "", "AR", "32", "", "01", "06854", "", "-35.4323", "-60.17271", "America/Argentina/Buenos_Aires"),("3833211", "Valle Hermoso", "", "AR", "32", "", "05", "14091", "", "-31.11732", "-64.48084", "America/Argentina/Cordoba"),("3833367", "Ushuaia", "Ушуая", "AR", "32", "", "23", "94014", "", "-54.8", "-68.3", "America/Argentina/Ushuaia"),("3833412", "Unquillo", "", "AR", "32", "", "05", "14021", "", "-31.23073", "-64.31615", "America/Argentina/Cordoba"),("3833675", "Trevelin", "", "AR", "32", "", "04", "26035", "", "-43.0858", "-71.46386", "America/Argentina/Catamarca"),("3833794", "Tres Isletas", "", "AR", "32", "", "03", "22091", "", "-26.34067", "-60.43207", "America/Argentina/Cordoba"),("3833859", "Tres Arroyos", "", "AR", "32", "", "01", "06833", "", "-38.37394", "-60.27978", "America/Argentina/Buenos_Aires"),("3833883", "Trelew", "", "AR", "32", "", "04", "26077", "", "-43.24895", "-65.30505", "America/Argentina/Catamarca"),("3833947", "Trancas", "", "AR", "32", "", "24", "90112", "", "-26.21575", "-65.28492", "America/Argentina/Tucuman"),("3833995", "Totoras", "", "AR", "32", "", "21", "82056", "", "-32.5844", "-61.16852", "America/Argentina/Cordoba"),("3834048", "Tostado", "", "AR", "32", "", "21", "82077", "", "-29.23202", "-61.76917", "America/Argentina/Cordoba"),("3834361", "Tinogasta", "", "AR", "32", "", "02", "10105", "", "-28.06319", "-67.56488", "America/Argentina/Catamarca"),("3834397", "Tilisarao", "", "AR", "32", "", "19", "74028", "", "-32.73292", "-65.29109", "America/Argentina/San_Luis"),("3834403", "Tilcara", "", "AR", "32", "", "10", "38094", "", "-23.57757", "-65.3509", "America/Argentina/Jujuy"),("3834502", "Termas de Río Hondo", "", "AR", "32", "", "22", "86147", "", "-27.49362", "-64.85972", "America/Argentina/Cordoba"),("3834601", "Tartagal", "Тартагал", "AR", "32", "", "17", "66056", "", "-22.51637", "-63.80131", "America/Argentina/Salta"),("3834665", "Tancacha", "", "AR", "32", "", "05", "14161", "", "-32.24309", "-63.9807", "America/Argentina/Cordoba"),("3834813", "Tafí Viejo", "", "AR", "32", "", "24", "90105", "", "-26.73201", "-65.25921", "America/Argentina/Tucuman"),("3834843", "Taco Pozo", "", "AR", "32", "", "03", "22007", "", "-25.61667", "-63.28333", "America/Argentina/Cordoba"),("3834961", "Suncho Corral", "", "AR", "32", "", "22", "86098", "", "-27.93357", "-63.42938", "America/Argentina/Cordoba"),("3834971", "Sunchales", "", "AR", "32", "", "21", "82021", "", "-30.94404", "-61.56148", "America/Argentina/Cordoba"),("3835238", "Simoca", "", "AR", "32", "", "24", "90091", "", "-27.26272", "-65.35647", "America/Argentina/Tucuman"),("3835297", "Sierra Grande", "", "AR", "32", "", "16", "62077", "", "-41.60603", "-65.35574", "America/Argentina/Salta"),("3835372", "Senillosa", "", "AR", "32", "", "15", "58035", "", "-39.01412", "-68.43281", "America/Argentina/Salta"),("3835695", "Sastre", "", "AR", "32", "", "21", "82126", "", "-31.76762", "-61.82887", "America/Argentina/Cordoba"),("3835710", "Sarmiento", "", "AR", "32", "", "04", "26091", "", "-45.58815", "-69.06996", "America/Argentina/Catamarca"),("3835793", "Santo Tomé", "", "AR", "32", "", "21", "82063", "", "-31.66274", "-60.7653", "America/Argentina/Cordoba"),("3835869", "Santiago del Estero", "Сантьяго-дель-Эстеро", "AR", "32", "", "22", "86049", "", "-27.79511", "-64.26149", "America/Argentina/Cordoba"),("3835921", "Santa Sylvina", "", "AR", "32", "", "03", "22043", "", "-27.83261", "-61.13747", "America/Argentina/Cordoba"),("3835938", "Santa Rosa de Río Primero", "", "AR", "32", "", "05", "14105", "", "-31.15231", "-63.40191", "America/Argentina/Cordoba"),("3835943", "Santa Rosa de Calamuchita", "", "AR", "32", "", "05", "14007", "", "-32.06905", "-64.53631", "America/Argentina/Cordoba"),("3835994", "Santa Rosa", "Санта-Роса", "AR", "32", "", "11", "42021", "", "-36.61667", "-64.28333", "America/Argentina/Salta"),("3836194", "Santa Lucía", "", "AR", "32", "", "18", "70098", "", "-31.53987", "-68.49503", "America/Argentina/San_Juan"),("3836277", "Santa Fe de la Vera Cruz", "Санта-Фе", "AR", "32", "", "21", "82063", "", "-31.63333", "-60.7", "America/Argentina/Cordoba"),("3836564", "San Salvador de Jujuy", "Сан Сальвадор де Жужуй", "AR", "32", "", "10", "38021", "", "-24.19457", "-65.29712", "America/Argentina/Jujuy"),("3836620", "San Ramón de la Nueva Orán", "", "AR", "32", "", "17", "66126", "", "-23.13705", "-64.32426", "America/Argentina/Salta"),("3836669", "San Rafael", "Сан-Рафаэль", "AR", "32", "", "13", "50105", "", "-34.61772", "-68.33007", "America/Argentina/Mendoza"),("3836772", "San Pedro", "", "AR", "32", "", "10", "38063", "", "-24.23127", "-64.86614", "America/Argentina/Jujuy"),("3836846", "San Nicolás de los Arroyos", "", "AR", "32", "", "01", "06763", "", "-33.33578", "-60.22523", "America/Argentina/Buenos_Aires"),("3836873", "San Miguel de Tucumán", "Сан-Мигель-де-Тукуман", "AR", "32", "", "24", "90084", "", "-26.82414", "-65.2226", "America/Argentina/Tucuman"),("3836951", "San Martín de los Andes", "Сан-Мартин-Де-Лос-Андес", "AR", "32", "", "15", "58056", "", "-40.15789", "-71.35337", "America/Argentina/Salta"),("3836992", "San Martín", "", "AR", "32", "", "13", "50098", "", "-33.08103", "-68.46814", "America/Argentina/Mendoza"),("3836993", "San Martín", "", "AR", "32", "", "18", "70091", "", "-31.42957", "-68.50065", "America/Argentina/San_Juan"),("3837056", "San Luis", "Сан-Луис", "AR", "32", "", "19", "74056", "", "-33.29501", "-66.33563", "America/Argentina/San_Luis"),("3837124", "San Justo", "", "AR", "32", "", "21", "82112", "", "-30.78913", "-60.59189", "America/Argentina/Cordoba"),("3837213", "San Juan", "Сан-Хуан", "AR", "32", "", "18", "70028", "", "-31.5375", "-68.53639", "America/Argentina/San_Juan"),("3837240", "San José de Jáchal", "", "AR", "32", "", "18", "70056", "", "-30.24057", "-68.74693", "America/Argentina/San_Juan"),("3837441", "San Jorge", "", "AR", "32", "", "21", "82126", "", "-31.89618", "-61.85984", "America/Argentina/Cordoba"),("3837675", "San Francisco", "", "AR", "32", "", "05", "14140", "", "-31.42797", "-62.08266", "America/Argentina/Cordoba"),("3837702", "San Fernando del Valle de Catamarca", "Сан-Фернандо-дель-Валье-де-Катамарка", "AR", "32", "", "02", "10049", "", "-28.46957", "-65.78524", "America/Argentina/Catamarca"),("3837823", "San Cristóbal", "", "AR", "32", "", "21", "82091", "", "-30.31053", "-61.23724", "America/Argentina/Cordoba"),("3837857", "San Carlos Centro", "", "AR", "32", "", "21", "82070", "", "-31.72864", "-61.09192", "America/Argentina/Cordoba"),("3837943", "San Bernardo", "", "AR", "32", "", "03", "22112", "", "-27.28782", "-60.71252", "America/Argentina/Cordoba"),("3837956", "San Benito", "", "AR", "32", "", "08", "30084", "", "-31.78371", "-60.44156", "America/Argentina/Cordoba"),("3837980", "San Antonio Oeste", "", "AR", "32", "", "16", "62077", "", "-40.73193", "-64.94769", "America/Argentina/Salta"),("3838158", "San Agustín de Valle Fértil", "", "AR", "32", "", "18", "70119", "", "-30.63353", "-67.46821", "America/Argentina/San_Juan"),("3838201", "Sampacho", "", "AR", "32", "", "05", "14098", "", "-33.3839", "-64.72211", "America/Argentina/Cordoba"),("3838233", "Salta", "Сальта", "AR", "32", "", "17", "66028", "", "-24.7859", "-65.41166", "America/Argentina/Salta"),("3838235", "Salsipuedes", "", "AR", "32", "", "05", "14021", "", "-31.13725", "-64.29589", "America/Argentina/Cordoba"),("3838506", "Rufino", "", "AR", "32", "", "21", "82042", "", "-34.26827", "-62.71262", "America/Argentina/Cordoba"),("3838583", "Rosario", "Росарио", "AR", "32", "", "21", "82084", "", "-32.94682", "-60.63932", "America/Argentina/Cordoba"),("3838638", "Roldán", "", "AR", "32", "", "21", "82119", "", "-32.89846", "-60.90681", "America/Argentina/Cordoba"),("3838793", "Río Tercero", "", "AR", "32", "", "05", "14161", "", "-32.17301", "-64.11405", "America/Argentina/Cordoba"),("3838797", "Río Segundo", "", "AR", "32", "", "05", "14119", "", "-31.6526", "-63.9099", "America/Argentina/Cordoba"),("3838859", "Río Gallegos", "Рио-Гальегос", "AR", "32", "", "20", "78021", "", "-51.62261", "-69.21813", "America/Argentina/Rio_Gallegos"),("3838874", "Río Cuarto", "Рио-Куарто", "AR", "32", "", "05", "14098", "", "-33.13067", "-64.34992", "America/Argentina/Cordoba"),("3838902", "Río Ceballos", "", "AR", "32", "", "05", "14021", "", "-31.16486", "-64.32241", "America/Argentina/Cordoba"),("3839262", "Recreo", "", "AR", "32", "", "21", "82063", "", "-31.49076", "-60.73299", "America/Argentina/Cordoba"),("3839263", "Recreo", "", "AR", "32", "", "02", "10070", "", "-29.28184", "-65.06096", "America/Argentina/Catamarca"),("3839282", "Realicó", "", "AR", "32", "", "11", "42133", "", "-35.03658", "-64.2447", "America/Argentina/Salta"),("3839307", "Rawson", "Роусон", "AR", "32", "", "04", "26077", "", "-43.30016", "-65.10228", "America/Argentina/Catamarca"),("3839479", "Rafaela", "Рафаэла", "AR", "32", "", "21", "82021", "", "-31.25033", "-61.4867", "America/Argentina/Cordoba"),("3839482", "Rada Tilly", "", "AR", "32", "AR", "04", "", "", "-45.93333", "-67.53333", "America/Argentina/Catamarca"),("3839490", "Quitilipi", "", "AR", "32", "", "03", "22133", "", "-26.86913", "-60.21683", "America/Argentina/Cordoba"),("3839565", "Quimilí", "", "AR", "32", "", "22", "86119", "", "-27.63333", "-62.41667", "America/Argentina/Cordoba"),("3839982", "Punta Alta", "Пунта-Альта", "AR", "32", "", "01", "06182", "", "-38.87588", "-62.07359", "America/Argentina/Buenos_Aires"),("3840082", "San Julián", "", "AR", "32", "", "20", "78042", "", "-49.30554", "-67.72743", "America/Argentina/Rio_Gallegos"),("3840092", "Puerto Madryn", "Пуэрто-Мадрин", "AR", "32", "", "04", "26007", "", "-42.7692", "-65.03851", "America/Argentina/Catamarca"),("3840104", "Puerto Deseado", "", "AR", "32", "", "20", "78014", "", "-47.75034", "-65.89382", "America/Argentina/Rio_Gallegos"),("3840300", "Presidencia Roque Sáenz Peña", "", "AR", "32", "", "03", "22021", "", "-26.78522", "-60.43876", "America/Argentina/Cordoba"),("3840470", "Pozo del Molle", "", "AR", "32", "", "05", "14119", "", "-32.0186", "-62.91984", "America/Argentina/Cordoba"),("3840860", "Pocito", "", "AR", "32", "", "18", "70070", "", "-31.68333", "-68.58333", "America/Argentina/San_Juan"),("3840885", "Plottier", "", "AR", "32", "", "15", "58035", "", "-38.96667", "-68.23333", "America/Argentina/Salta"),("3840896", "Plaza Huincul", "", "AR", "32", "", "15", "58035", "", "-38.92598", "-69.20863", "America/Argentina/Salta"),("3841149", "Pilar", "", "AR", "32", "", "05", "14119", "", "-31.6789", "-63.87964", "America/Argentina/Cordoba"),("3841309", "Pico Truncado", "", "AR", "32", "", "20", "78014", "", "-46.7949", "-67.95731", "America/Argentina/Rio_Gallegos"),("3841490", "Pergamino", "Пергамино", "AR", "32", "", "01", "06623", "", "-33.88995", "-60.57357", "America/Argentina/Buenos_Aires"),("3841500", "Pérez", "", "AR", "32", "", "21", "82084", "", "-32.99835", "-60.76791", "America/Argentina/Cordoba"),("3841956", "Paraná", "Парана", "AR", "32", "", "08", "30084", "", "-31.73197", "-60.5238", "America/Argentina/Cordoba"),("3842142", "Pampa del Infierno", "", "AR", "32", "", "03", "22007", "", "-26.50517", "-61.17436", "America/Argentina/Cordoba"),("3842190", "Palpalá", "", "AR", "32", "", "10", "38042", "", "-24.25647", "-65.21163", "America/Argentina/Jujuy"),("3842268", "Palma Sola", "", "AR", "32", "", "10", "38070", "", "-23.96336", "-64.29872", "America/Argentina/Jujuy"),("3842621", "Oncativo", "", "AR", "32", "", "05", "14119", "", "-31.91353", "-63.68201", "America/Argentina/Cordoba"),("3842662", "Oliva", "", "AR", "32", "", "05", "14161", "", "-32.04158", "-63.56978", "America/Argentina/Cordoba"),("3842670", "Olavarría", "Олаваррия", "AR", "32", "", "01", "06595", "", "-36.89272", "-60.32254", "America/Argentina/Buenos_Aires"),("3842881", "Nueve de Julio", "Нев-де-Хулио", "AR", "32", "", "01", "06588", "", "-35.44437", "-60.88313", "America/Argentina/Buenos_Aires"),("3842882", "Nueve de Julio", "", "AR", "32", "", "18", "70063", "", "-31.66914", "-68.39023", "America/Argentina/San_Juan"),("3843123", "Neuquén", "Неукен", "AR", "32", "", "15", "58035", "", "-38.95161", "-68.0591", "America/Argentina/Salta"),("3843619", "Morteros", "", "AR", "32", "", "05", "14140", "", "-30.71164", "-61.99862", "America/Argentina/Cordoba"),("3843803", "Monteros", "", "AR", "32", "", "24", "90070", "", "-27.16741", "-65.49832", "America/Argentina/Tucuman"),("3843830", "Monte Maíz", "", "AR", "32", "", "05", "14182", "", "-33.20462", "-62.60085", "America/Argentina/Cordoba"),("3843871", "Monte Cristo", "", "AR", "32", "", "05", "14021", "", "-31.34312", "-63.94437", "America/Argentina/Cordoba"),("3843881", "Monte Buey", "", "AR", "32", "", "05", "14063", "", "-32.91642", "-62.45669", "America/Argentina/Cordoba"),("3844229", "Mina Clavero", "", "AR", "32", "", "05", "14126", "", "-31.72101", "-65.00619", "America/Argentina/Cordoba"),("3844377", "Merlo", "", "AR", "32", "", "19", "74049", "", "-32.34288", "-65.01396", "America/Argentina/San_Luis"),("3844421", "Mendoza", "Мендоса", "AR", "32", "", "13", "50028", "", "-32.89084", "-68.82717", "America/Argentina/Mendoza"),("3844899", "Marcos Juárez", "", "AR", "32", "", "05", "14063", "", "-32.6978", "-62.10672", "America/Argentina/Cordoba"),("3845073", "Malvinas Argentinas", "", "AR", "32", "", "05", "14014", "", "-31.38333", "-64.06667", "America/Argentina/Cordoba"),("3845202", "Malagueño", "", "AR", "32", "", "05", "14147", "", "-31.46467", "-64.3584", "America/Argentina/Cordoba"),("3845330", "Machagai", "", "AR", "32", "", "03", "22168", "", "-26.92614", "-60.04955", "America/Argentina/Cordoba"),("3846175", "Los Frentones", "", "AR", "32", "", "03", "22007", "", "-26.4077", "-61.41367", "America/Argentina/Cordoba"),("3846514", "Los Altos", "", "AR", "32", "", "02", "10098", "", "-28.04845", "-65.49945", "America/Argentina/Catamarca"),("3846864", "Lincoln", "", "AR", "32", "", "01", "06469", "", "-34.86649", "-61.5302", "America/Argentina/Buenos_Aires"),("3846915", "Libertador General San Martín", "", "AR", "32", "", "10", "38035", "", "-23.80644", "-64.78757", "America/Argentina/Jujuy"),("3846991", "Leones", "", "AR", "32", "", "05", "14063", "", "-32.66174", "-62.29678", "America/Argentina/Cordoba"),("3847482", "La Toma", "", "AR", "32", "", "19", "74021", "", "-33.05258", "-65.62385", "America/Argentina/San_Luis"),("3847613", "Las Varillas", "", "AR", "32", "", "05", "14140", "", "-31.87208", "-62.71946", "America/Argentina/Cordoba"),("3847836", "Las Rosas", "", "AR", "32", "", "21", "82007", "", "-32.47661", "-61.58041", "America/Argentina/Cordoba"),("3847933", "Las Parejas", "", "AR", "32", "", "21", "82007", "", "-32.68478", "-61.51637", "America/Argentina/Cordoba"),("3848164", "Las Lomitas", "", "AR", "32", "", "09", "34035", "", "-24.70955", "-60.59303", "America/Argentina/Cordoba"),("3848209", "Las Lajitas", "", "AR", "32", "", "17", "66007", "", "-24.68333", "-64.25", "America/Argentina/Salta"),("3848343", "Las Higueras", "", "AR", "32", "", "05", "14098", "", "-33.09231", "-64.28899", "America/Argentina/Cordoba"),("3848353", "Las Heras", "", "AR", "32", "", "20", "78014", "", "-46.54186", "-68.93593", "America/Argentina/Rio_Gallegos"),("3848687", "Las Breñas", "", "AR", "32", "", "03", "22105", "", "-27.08966", "-61.08161", "America/Argentina/Cordoba"),("3848950", "La Rioja", "Ла-Риоха", "AR", "32", "", "12", "46014", "", "-29.41105", "-66.85067", "America/Argentina/La_Rioja"),("3849140", "La Quiaca", "", "AR", "32", "", "10", "38112", "", "-22.10236", "-65.59299", "America/Argentina/Jujuy"),("3850005", "Lamarque", "", "AR", "32", "", "16", "62014", "", "-39.42304", "-65.70208", "America/Argentina/Salta"),("3850920", "Laguna Paiva", "", "AR", "32", "", "21", "82063", "", "-31.30391", "-60.65894", "America/Argentina/Cordoba"),("3850929", "Laguna Larga", "", "AR", "32", "", "05", "14119", "", "-31.77652", "-63.80104", "America/Argentina/Cordoba"),("3851331", "La Falda", "", "AR", "32", "", "05", "14091", "", "-31.08841", "-64.48987", "America/Argentina/Cordoba"),("3851798", "La Cumbre", "", "AR", "32", "", "05", "14091", "", "-30.98201", "-64.49139", "America/Argentina/Cordoba"),("3851985", "La Cocha", "", "AR", "32", "", "24", "90049", "", "-27.77729", "-65.57035", "America/Argentina/Tucuman"),("3852279", "La Carlota", "", "AR", "32", "", "05", "14056", "", "-33.41993", "-63.29769", "America/Argentina/Cordoba"),("3852374", "La Calera", "", "AR", "32", "", "05", "14021", "", "-31.34377", "-64.33529", "America/Argentina/Cordoba"),("3852468", "Laboulaye", "", "AR", "32", "", "05", "14084", "", "-34.12662", "-63.39119", "America/Argentina/Cordoba"),("3852480", "Laborde", "", "AR", "32", "", "05", "14182", "", "-33.15319", "-62.85661", "America/Argentina/Cordoba"),("3853330", "Justo Daract", "", "AR", "32", "", "19", "74035", "", "-33.8594", "-65.18277", "America/Argentina/San_Luis"),("3853331", "Justiniano Posse", "", "AR", "32", "", "05", "14182", "", "-32.88411", "-62.67788", "America/Argentina/Cordoba"),("3853350", "Junín de los Andes", "", "AR", "32", "", "15", "58049", "", "-39.95043", "-71.06936", "America/Argentina/Salta"),("3853354", "Junín", "", "AR", "32", "", "01", "06413", "", "-34.58382", "-60.94332", "America/Argentina/Buenos_Aires"),("3853491", "Joaquín V. González", "", "AR", "32", "", "17", "66112", "", "-25.08333", "-64.18333", "America/Argentina/Salta"),("3853510", "Jesús María", "", "AR", "32", "", "05", "14021", "", "-30.98153", "-64.09424", "America/Argentina/Cordoba"),("3853745", "Intendente Alvear", "", "AR", "32", "", "11", "42056", "", "-35.23383", "-63.59205", "America/Argentina/Salta"),("3853767", "Ingenio La Esperanza", "", "AR", "32", "", "10", "38063", "", "-24.22554", "-64.83896", "America/Argentina/Jujuy"),("3853782", "Ingeniero Luis A. Huergo", "", "AR", "32", "AR", "16", "62042", "", "-39.08333", "-67.23333", "America/Argentina/Salta"),("3853786", "Ingeniero Jacobacci", "", "AR", "32", "", "16", "62091", "", "-41.3292", "-69.55015", "America/Argentina/Salta"),("3853788", "Ingeniero Guillermo N. Juárez", "", "AR", "32", "", "09", "34028", "", "-23.9", "-61.85", "America/Argentina/Cordoba"),("3853935", "Icaño", "", "AR", "32", "", "02", "10070", "", "-28.91934", "-65.32817", "America/Argentina/Catamarca"),("3853967", "Humahuaca", "", "AR", "32", "", "10", "38028", "", "-23.20544", "-65.35048", "America/Argentina/Jujuy"),("3853974", "Huinca Renancó", "", "AR", "32", "", "05", "14035", "", "-34.84038", "-64.3758", "America/Argentina/Cordoba"),("3853981", "Huillapima", "", "AR", "32", "", "02", "10042", "", "-28.72533", "-65.9787", "America/Argentina/Catamarca"),("3854008", "Huerta Grande", "", "AR", "32", "", "05", "14091", "", "-31.07524", "-64.49063", "America/Argentina/Cordoba"),("3854331", "Hernando", "", "AR", "32", "", "05", "14161", "", "-32.42657", "-63.73333", "America/Argentina/Cordoba"),("3854336", "Hermoso Campo", "", "AR", "32", "", "03", "22039", "", "-27.60816", "-61.34441", "America/Argentina/Cordoba"),("3854493", "Guatraché", "", "AR", "32", "", "11", "42070", "", "-37.66776", "-63.53021", "America/Argentina/Salta"),("3854724", "Graneros", "", "AR", "32", "", "24", "90035", "", "-27.64934", "-65.4383", "America/Argentina/Tucuman"),("3854895", "Granadero Baigorria", "", "AR", "32", "", "21", "82084", "", "-32.85683", "-60.71754", "America/Argentina/Cordoba"),("3854985", "Gobernador Gálvez", "", "AR", "32", "", "21", "82084", "", "-33.03016", "-60.64045", "America/Argentina/Cordoba"),("3855041", "General Villegas", "", "AR", "32", "", "01", "06392", "", "-35.03285", "-63.01252", "America/Argentina/Buenos_Aires"),("3855065", "General Roca", "Хенераль", "AR", "32", "", "16", "62042", "", "-39.03333", "-67.58333", "America/Argentina/Salta"),("3855067", "General Ramírez", "", "AR", "32", "", "08", "30021", "", "-32.17601", "-60.20079", "America/Argentina/Cordoba"),("3855074", "General Pinedo", "", "AR", "32", "", "03", "22036", "", "-27.31667", "-61.28333", "America/Argentina/Cordoba"),("3855075", "General Pico", "", "AR", "32", "", "11", "42105", "", "-35.65662", "-63.75682", "America/Argentina/Salta"),("3855098", "General Levalle", "", "AR", "32", "", "05", "14084", "", "-34.01472", "-63.92413", "America/Argentina/Cordoba"),("3855114", "General Fernández Oro", "", "AR", "32", "", "16", "62042", "", "-38.95297", "-67.92489", "America/Argentina/Salta"),("3855116", "General Enrique Mosconi", "", "AR", "32", "", "17", "66056", "", "-22.59588", "-63.81255", "America/Argentina/Salta"),("3855121", "General Conesa", "", "AR", "32", "", "16", "62028", "", "-40.1", "-64.43333", "America/Argentina/Salta"),("3855124", "General Cabrera", "", "AR", "32", "", "05", "14056", "", "-32.81313", "-63.87243", "America/Argentina/Cordoba"),("3855143", "General Acha", "", "AR", "32", "", "11", "42154", "", "-37.37698", "-64.60431", "America/Argentina/Salta"),("3855244", "Gálvez", "", "AR", "32", "", "21", "82105", "", "-32.02927", "-61.22103", "America/Argentina/Cordoba"),("3855284", "Gaimán", "", "AR", "32", "", "04", "26042", "", "-43.2897", "-65.4929", "America/Argentina/Catamarca"),("3855302", "Funes", "", "AR", "32", "", "21", "82084", "", "-32.91568", "-60.80995", "America/Argentina/Cordoba"),("3855368", "Fray Luis Beltrán", "", "AR", "32", "AR", "16", "62014", "", "-39.31667", "-65.76667", "America/Argentina/Salta"),("3855370", "Fray Luis A. Beltrán", "", "AR", "32", "", "21", "82119", "", "-32.79122", "-60.72819", "America/Argentina/Cordoba"),("3855394", "Fraile Pintado", "", "AR", "32", "", "10", "38035", "", "-23.94079", "-64.79943", "America/Argentina/Jujuy"),("3855554", "Firmat", "", "AR", "32", "", "21", "82042", "", "-33.45937", "-61.4832", "America/Argentina/Cordoba"),("3855588", "Fiambalá", "", "AR", "32", "", "02", "10105", "", "-27.68705", "-67.6149", "America/Argentina/Catamarca"),("3855666", "Famaillá", "", "AR", "32", "", "24", "90028", "", "-27.05413", "-65.40329", "America/Argentina/Tucuman"),("3855974", "Esquel", "Эскель", "AR", "32", "", "04", "26035", "", "-42.91147", "-71.31947", "America/Argentina/Catamarca"),("3856022", "Esperanza", "", "AR", "32", "", "21", "82070", "", "-31.4488", "-60.93173", "America/Argentina/Cordoba"),("3856231", "Embarcación", "", "AR", "32", "", "17", "66056", "", "-23.21003", "-64.09965", "America/Argentina/Salta"),("3856235", "Embalse", "", "AR", "32", "", "05", "14007", "", "-32.18", "-64.41809", "America/Argentina/Cordoba"),("3856436", "El Trébol", "", "AR", "32", "", "21", "82126", "", "-32.2008", "-61.7014", "America/Argentina/Cordoba"),("3857012", "El Quebrachal", "", "AR", "32", "", "17", "66007", "", "-25.28333", "-64.06667", "America/Argentina/Salta"),("3857974", "El Galpón", "", "AR", "32", "", "17", "66112", "", "-25.38069", "-64.65259", "America/Argentina/Salta"),("3858553", "El Carril", "", "AR", "32", "", "17", "66042", "", "-25.0741", "-65.49174", "America/Argentina/Salta"),("3858677", "El Calafate", "", "AR", "32", "AR", "20", "78028", "", "-50.34075", "-72.27682", "America/Argentina/Rio_Gallegos"),("3858765", "El Bolsón", "", "AR", "32", "", "16", "62021", "", "-41.96051", "-71.53336", "America/Argentina/Salta"),("3859036", "Eduardo Castex", "", "AR", "32", "", "11", "42035", "", "-35.91501", "-64.29448", "America/Argentina/Salta"),("3859384", "Diamante", "", "AR", "32", "", "08", "30021", "", "-32.06641", "-60.63837", "America/Argentina/Cordoba"),("3859409", "Devoto", "", "AR", "32", "", "05", "14140", "", "-31.40431", "-62.30634", "America/Argentina/Cordoba"),("3859429", "Despeñaderos", "", "AR", "32", "", "05", "14147", "", "-31.81626", "-64.28989", "America/Argentina/Cordoba"),("3859512", "Deán Funes", "", "AR", "32", "", "05", "14049", "", "-30.42036", "-64.34984", "America/Argentina/Cordoba"),("3859552", "Cutral-Có", "", "AR", "32", "", "15", "58035", "", "-38.93424", "-69.23052", "America/Argentina/Salta"),("3859828", "Cruz del Eje", "", "AR", "32", "", "05", "14028", "", "-30.72644", "-64.80387", "America/Argentina/Cordoba"),("3859839", "Cruz Alta", "", "AR", "32", "", "05", "14063", "", "-33.00887", "-61.80746", "America/Argentina/Cordoba"),("3859904", "Crespo", "", "AR", "32", "", "08", "30084", "", "-32.02873", "-60.30658", "America/Argentina/Cordoba"),("3859965", "Cosquín", "", "AR", "32", "", "05", "14091", "", "-31.24508", "-64.46563", "America/Argentina/Cordoba"),("3859974", "Corzuela", "", "AR", "32", "", "03", "22049", "", "-26.95374", "-60.96928", "America/Argentina/Cordoba"),("3860129", "Corral de Bustos", "", "AR", "32", "", "05", "14063", "", "-33.28205", "-62.18463", "America/Argentina/Cordoba"),("3860164", "Coronel Suárez", "Коронель-Суарез", "AR", "32", "", "01", "06203", "", "-37.45467", "-61.93343", "America/Argentina/Buenos_Aires"),("3860178", "Coronel Moldes", "", "AR", "32", "", "05", "14098", "", "-33.6227", "-64.59711", "America/Argentina/Cordoba"),("3860197", "Coronel Du Graty", "", "AR", "32", "", "03", "22098", "", "-27.68038", "-60.91462", "America/Argentina/Cordoba"),("3860199", "Coronel Dorrego", "", "AR", "32", "", "01", "06189", "", "-38.71867", "-61.28733", "America/Argentina/Buenos_Aires"),("3860217", "Coronda", "", "AR", "32", "", "21", "82105", "", "-31.97263", "-60.91983", "America/Argentina/Cordoba"),("3860259", "Córdoba", "Кордова", "AR", "32", "", "05", "14014", "", "-31.4135", "-64.18105", "America/Argentina/Cordoba"),("3860419", "Concepción del Bermejo", "", "AR", "32", "", "03", "22007", "", "-26.59926", "-60.94617", "America/Argentina/Cordoba"),("3860443", "Comodoro Rivadavia", "Комодоро-Ривадавия", "AR", "32", "", "04", "26021", "", "-45.86413", "-67.49656", "America/Argentina/Catamarca"),("3861002", "Clodomira", "", "AR", "32", "", "22", "86035", "", "-27.5744", "-64.13108", "America/Argentina/Cordoba"),("3861056", "Cipolletti", "Чиполлетти", "AR", "32", "", "16", "62042", "", "-38.93392", "-67.99032", "America/Argentina/Salta"),("3861061", "Cinco Saltos", "", "AR", "32", "", "16", "62042", "", "-38.82225", "-68.06293", "America/Argentina/Salta"),("3861262", "Chos Malal", "", "AR", "32", "", "15", "58042", "", "-37.37809", "-70.27085", "America/Argentina/Salta"),("3861329", "Choele Choel", "", "AR", "32", "", "16", "62014", "", "-39.26667", "-65.68333", "America/Argentina/Salta"),("3861344", "Chivilcoy", "", "AR", "32", "", "01", "06224", "", "-34.89566", "-60.01667", "America/Argentina/Buenos_Aires"),("3861416", "Chimbas", "", "AR", "32", "", "18", "70042", "", "-31.48333", "-68.53333", "America/Argentina/San_Juan"),("3861445", "Chilecito", "", "AR", "32", "", "12", "46042", "", "-29.16195", "-67.4974", "America/Argentina/La_Rioja"),("3861494", "Chicoana", "", "AR", "32", "", "17", "66042", "", "-25.10088", "-65.5331", "America/Argentina/Salta"),("3861678", "Charata", "", "AR", "32", "", "03", "22028", "", "-27.21438", "-61.18795", "America/Argentina/Cordoba"),("3861824", "Chamical", "", "AR", "32", "", "12", "46035", "", "-30.36002", "-66.31399", "America/Argentina/La_Rioja"),("3861953", "Chacabuco", "Чакабуко", "AR", "32", "", "01", "06210", "", "-34.64167", "-60.47389", "America/Argentina/Buenos_Aires"),("3861966", "Cervantes", "", "AR", "32", "", "16", "62042", "", "-39.05", "-67.38333", "America/Argentina/Salta"),("3862100", "Ceres", "", "AR", "32", "", "21", "82091", "", "-29.881", "-61.94504", "America/Argentina/Cordoba"),("3862144", "Centenario", "", "AR", "32", "", "15", "58035", "", "-38.82955", "-68.1318", "America/Argentina/Salta"),("3862240", "Caucete", "", "AR", "32", "", "18", "70035", "", "-31.65179", "-68.28105", "America/Argentina/San_Juan"),("3862254", "Catriel", "", "AR", "32", "", "16", "62042", "", "-37.87907", "-67.7956", "America/Argentina/Salta"),("3862320", "Castelli", "", "AR", "32", "", "03", "22063", "", "-25.94679", "-60.61947", "America/Argentina/Cordoba"),("3862351", "Casilda", "", "AR", "32", "", "21", "82014", "", "-33.04417", "-61.16806", "America/Argentina/Cordoba"),("3862655", "Carcarañá", "", "AR", "32", "", "21", "82119", "", "-32.85679", "-61.15331", "America/Argentina/Cordoba"),("3862738", "Capitán Bermúdez", "", "AR", "32", "", "21", "82119", "", "-32.82262", "-60.71852", "America/Argentina/Cordoba"),("3862761", "Capilla del Monte", "", "AR", "32", "", "05", "14091", "", "-30.86088", "-64.52515", "America/Argentina/Cordoba"),("3862772", "Capayán", "", "AR", "32", "", "02", "10042", "", "-28.76105", "-66.05025", "America/Argentina/Catamarca"),("3862883", "Canals", "", "AR", "32", "", "05", "14182", "", "-33.56542", "-62.88927", "America/Argentina/Cordoba"),("3862981", "Cañada de Gómez", "Канада-де-Гомес", "AR", "32", "", "21", "82056", "", "-32.81636", "-61.39493", "America/Argentina/Cordoba"),("3863095", "Campo Largo", "", "AR", "32", "", "03", "22070", "", "-26.80077", "-60.84215", "America/Argentina/Cordoba"),("3863136", "Campo Gallo", "", "AR", "32", "", "22", "86014", "", "-26.58333", "-62.85", "America/Argentina/Cordoba"),("3863362", "Calingasta", "", "AR", "32", "", "18", "70021", "", "-31.33084", "-69.40783", "America/Argentina/San_Juan"),("3863366", "Calilegua", "", "AR", "32", "", "10", "38035", "", "-23.77368", "-64.77002", "America/Argentina/Jujuy"),("3863379", "Caleta Olivia", "Калета-Оливия", "AR", "32", "", "20", "78014", "", "-46.43929", "-67.52814", "America/Argentina/Rio_Gallegos"),("3863419", "Calchaquí", "", "AR", "32", "", "21", "82133", "", "-29.88767", "-60.28697", "America/Argentina/Cordoba"),("3863491", "Caimancito", "", "AR", "32", "", "10", "38035", "", "-23.74069", "-64.5937", "America/Argentina/Jujuy"),("3863503", "Cafayate", "", "AR", "32", "AR", "17", "66021", "", "-26.07286", "-65.97766", "America/Argentina/Salta"),("3863833", "Brinkmann", "", "AR", "32", "", "05", "14140", "", "-30.86589", "-62.03742", "America/Argentina/Cordoba"),("3864274", "Berrotarán", "", "AR", "32", "", "05", "14098", "", "-32.451", "-64.38867", "America/Argentina/Cordoba"),("3864328", "Beltrán", "", "AR", "32", "", "22", "86161", "", "-27.82913", "-64.06098", "America/Argentina/Cordoba"),("3864331", "Bell Ville", "", "AR", "32", "", "05", "14182", "", "-32.62591", "-62.68873", "America/Argentina/Cordoba"),("3864375", "Bella Vista", "", "AR", "32", "", "24", "90056", "", "-27.03424", "-65.30196", "America/Argentina/Tucuman"),("3864888", "Balnearia", "", "AR", "32", "", "05", "14140", "", "-31.0088", "-62.66733", "America/Argentina/Cordoba"),("3865086", "Bahía Blanca", "Байя-Бланка", "AR", "32", "", "01", "06056", "", "-38.71959", "-62.27243", "America/Argentina/Buenos_Aires"),("3865186", "Aviá Terai", "", "AR", "32", "", "03", "22070", "", "-26.68532", "-60.7292", "America/Argentina/Cordoba"),("3865385", "Arroyo Seco", "", "AR", "32", "", "21", "82084", "", "-33.15489", "-60.50863", "America/Argentina/Cordoba"),("3865424", "Arroyito", "", "AR", "32", "", "05", "14140", "", "-31.42022", "-63.05002", "America/Argentina/Cordoba"),("3865449", "Armstrong", "", "AR", "32", "", "21", "82007", "", "-32.78215", "-61.60222", "America/Argentina/Cordoba"),("3865474", "Arias", "", "AR", "32", "", "05", "14063", "", "-33.64411", "-62.40272", "America/Argentina/Cordoba"),("3865579", "Arauco", "", "AR", "32", "", "12", "46007", "", "-28.5805", "-66.79438", "America/Argentina/La_Rioja"),("3865605", "Apolinario Saravia", "", "AR", "32", "", "17", "66007", "", "-24.43276", "-63.99535", "America/Argentina/Salta"),("3865802", "Andalgalá", "", "AR", "32", "", "02", "10021", "", "-27.60012", "-66.31794", "America/Argentina/Catamarca"),("3865840", "Añatuya", "", "AR", "32", "", "22", "86077", "", "-28.46064", "-62.83472", "America/Argentina/Cordoba"),("3866163", "Alta Gracia", "Альта-Грация", "AR", "32", "", "05", "14147", "", "-31.65292", "-64.42826", "America/Argentina/Cordoba"),("3866237", "Almafuerte", "", "AR", "32", "", "05", "14161", "", "-32.19296", "-64.25559", "America/Argentina/Cordoba"),("3866242", "Allen", "", "AR", "32", "", "16", "62042", "", "-38.97736", "-67.82714", "America/Argentina/Salta"),("3866367", "Alderetes", "", "AR", "32", "", "24", "90014", "", "-26.81667", "-65.13333", "America/Argentina/Tucuman"),("3866425", "Albardón", "", "AR", "32", "", "18", "70007", "", "-31.43722", "-68.52556", "America/Argentina/San_Juan"),("3866496", "Aguilares", "", "AR", "32", "", "24", "90077", "", "-27.4338", "-65.61427", "America/Argentina/Tucuman"),("3866935", "Adelia María", "", "AR", "32", "", "05", "14098", "", "-33.63152", "-64.02097", "America/Argentina/Cordoba"),("3867009", "Abra Pampa", "", "AR", "32", "", "10", "38007", "", "-22.72049", "-65.69697", "America/Argentina/Jujuy"),("6693230", "Villa Santa Rita", "", "AR", "32", "", "07", "", "", "-34.61082", "-58.481", "America/Argentina/Buenos_Aires"),("7116866", "Villa Mercedes", "", "AR", "32", "", "19", "74035", "", "-33.67571", "-65.45783", "America/Argentina/San_Luis"),("7284819", "La Punta", "", "AR", "32", "", "19", "74056", "", "-33.18368", "-66.3127", "America/Argentina/San_Luis"),("7647007", "San Carlos de Bariloche", "Сан Карлос де Барилоче", "AR", "32", "", "16", "62021", "3837856", "-41.14557", "-71.30822", "America/Argentina/Salta"),("8521759", "Río Turbio", "", "AR", "32", "", "20", "78021", "", "-51.53587", "-72.33673", "America/Argentina/Rio_Gallegos"),("10172104", "Adrogué", "", "AR", "32", "", "01", "06028", "", "-34.80041", "-58.38384", "America/Argentina/Buenos_Aires"),("2601384", "Neu-Guntramsdorf", "", "AT", "40", "", "03", "317", "31710", "48.0642", "16.31573", "Europe/Vienna"),("2760415", "Zwettl Stift", "", "AT", "40", "", "03", "325", "32530", "48.61667", "15.2", "Europe/Vienna"),("2760510", "Zistersdorf", "", "AT", "40", "", "03", "308", "30863", "48.53333", "16.75", "Europe/Vienna"),("2760523", "Zirl", "", "AT", "40", "", "07", "703", "70369", "47.28333", "11.23333", "Europe/Vienna"),("2760610", "Zeltweg", "", "AT", "40", "", "06", "620", "62038", "47.18333", "14.75", "Europe/Vienna"),("2760634", "Zell am See", "", "AT", "40", "", "05", "506", "50628", "47.32556", "12.79444", "Europe/Vienna"),("2760772", "Ybbs an der Donau", "", "AT", "40", "", "03", "315", "31549", "48.16667", "15.08333", "Europe/Vienna"),("2760854", "Wörgl", "", "AT", "40", "", "07", "705", "70531", "47.48906", "12.06174", "Europe/Vienna"),("2760855", "Wördern", "", "AT", "40", "", "03", "321", "32142", "48.334", "16.21016", "Europe/Vienna"),("2760887", "Wolkersdorf im Weinviertel", "", "AT", "40", "", "03", "316", "31655", "48.38333", "16.51667", "Europe/Vienna"),("2760894", "Wolfurt", "", "AT", "40", "", "08", "802", "80240", "47.46667", "9.75", "Europe/Vienna"),("2760910", "Wolfsberg", "", "AT", "40", "", "02", "209", "20923", "46.84056", "14.84417", "Europe/Vienna"),("2761186", "Wilhelmsburg", "", "AT", "40", "", "03", "319", "31947", "48.10571", "15.60539", "Europe/Vienna"),("2761353", "Wiener Neustadt", "Винер-Нойштадт", "AT", "40", "", "03", "304", "30401", "47.8", "16.25", "Europe/Vienna"),("2761354", "Wiener Neudorf", "", "AT", "40", "", "03", "317", "31725", "48.08278", "16.31384", "Europe/Vienna"),("2761369", "Vienna", "Вена", "AT", "40", "", "09", "900", "901", "48.20849", "16.37208", "Europe/Vienna"),("2761436", "Wetzelsdorf", "", "AT", "40", "", "06", "601", "60101", "47.05293", "15.39923", "Europe/Vienna"),("2761475", "Wernberg", "", "AT", "40", "", "02", "207", "20727", "46.61667", "13.93333", "Europe/Vienna"),("2761524", "Wels", "Вельс", "AT", "40", "", "04", "403", "40301", "48.16667", "14.03333", "Europe/Vienna"),("2761531", "Weiz", "", "AT", "40", "", "06", "617", "61755", "47.21667", "15.61667", "Europe/Vienna"),("2761669", "Weinzierl bei Krems", "", "AT", "40", "", "03", "313", "31327", "48.4", "15.6", "Europe/Vienna"),("2761834", "Wattens", "", "AT", "40", "", "07", "703", "70367", "47.28333", "11.6", "Europe/Vienna"),("2762077", "Waidhofen an der Ybbs", "", "AT", "40", "", "03", "303", "30301", "47.96004", "14.77361", "Europe/Vienna"),("2762079", "Waidhofen an der Thaya", "", "AT", "40", "", "03", "322", "32220", "48.81667", "15.28333", "Europe/Vienna"),("2762290", "Vorchdorf", "", "AT", "40", "", "04", "407", "40720", "48.00388", "13.92122", "Europe/Vienna"),("2762304", "Völs", "", "AT", "40", "", "07", "703", "70364", "47.25", "11.33333", "Europe/Vienna"),("2762315", "Völkermarkt", "", "AT", "40", "", "02", "208", "20817", "46.66222", "14.63444", "Europe/Vienna"),("2762327", "Voitsberg", "", "AT", "40", "", "06", "616", "61625", "47.03333", "15.15", "Europe/Vienna"),("2762343", "Vöcklabruck", "", "AT", "40", "", "04", "417", "41746", "48.01667", "13.65", "Europe/Vienna"),("2762372", "Villach", "Филлах", "AT", "40", "", "02", "202", "20201", "46.61028", "13.85583", "Europe/Vienna"),("2762453", "Velden am Wörthersee", "", "AT", "40", "", "02", "207", "20725", "46.61301", "14.0413", "Europe/Vienna"),("2763266", "Tulln", "", "AT", "40", "", "03", "321", "32135", "48.32829", "16.05858", "Europe/Vienna"),("2763332", "Trofaiach", "", "AT", "40", "", "06", "611", "61120", "47.42524", "15.00681", "Europe/Vienna"),("2763423", "Traun", "", "AT", "40", "", "04", "410", "41021", "48.22656", "14.23459", "Europe/Vienna"),("2763459", "Traismauer", "", "AT", "40", "", "03", "319", "31943", "48.35", "15.73333", "Europe/Vienna"),("2763460", "Traiskirchen", "", "AT", "40", "", "03", "306", "30639", "48.01485", "16.29324", "Europe/Vienna"),("2763595", "Timelkam", "", "AT", "40", "", "04", "417", "41743", "48.00394", "13.6076", "Europe/Vienna"),("2763749", "Thalgau", "", "AT", "40", "", "05", "503", "50337", "47.83333", "13.25", "Europe/Vienna"),("2763795", "Ternitz", "Терниц", "AT", "40", "", "03", "318", "31839", "47.71565", "16.03575", "Europe/Vienna"),("2763810", "Telfs", "", "AT", "40", "", "07", "703", "70357", "47.30707", "11.06817", "Europe/Vienna"),("2763929", "Tamsweg", "", "AT", "40", "", "05", "505", "50510", "47.12808", "13.81102", "Europe/Vienna"),("2764172", "Strasswalchen", "", "AT", "40", "", "05", "503", "50335", "47.98333", "13.25", "Europe/Vienna"),("2764175", "Strasshof an der Nordbahn", "", "AT", "40", "", "03", "308", "30856", "48.31667", "16.66667", "Europe/Vienna"),("2764279", "Stockerau", "", "AT", "40", "", "03", "312", "31230", "48.38333", "16.21667", "Europe/Vienna"),("2764359", "Steyr", "Штайр", "AT", "40", "", "04", "402", "40201", "48.04274", "14.42127", "Europe/Vienna"),("2764786", "Spittal an der Drau", "Шпитталь-ан-дер-Драу", "AT", "40", "", "02", "206", "20635", "46.8", "13.5", "Europe/Vienna"),("2764958", "Hall in Tirol", "", "AT", "40", "AT", "07", "703", "70354", "47.28333", "11.51667", "Europe/Vienna"),("2765080", "Sierning", "", "AT", "40", "", "04", "415", "41516", "48.04343", "14.30935", "Europe/Vienna"),("2765091", "Sieghartskirchen", "", "AT", "40", "", "03", "321", "32131", "48.25531", "16.01223", "Europe/Vienna"),("2765257", "Seekirchen am Wallersee", "", "AT", "40", "", "05", "503", "50339", "47.9", "13.13333", "Europe/Vienna"),("2765286", "Seeboden", "", "AT", "40", "", "02", "206", "20634", "46.81909", "13.5143", "Europe/Vienna"),("2765388", "Schwechat", "Швехат", "AT", "40", "", "03", "324", "32419", "48.13333", "16.46667", "Europe/Vienna"),("2765390", "Schwaz", "", "AT", "40", "", "07", "709", "70926", "47.35169", "11.71014", "Europe/Vienna"),("2765602", "Schrems", "", "AT", "40", "", "03", "309", "30935", "48.78333", "15.06667", "Europe/Vienna"),("2766359", "Sankt Veit an der Glan", "", "AT", "40", "", "02", "205", "20527", "46.76806", "14.36028", "Europe/Vienna"),("2766365", "Sankt Valentin", "", "AT", "40", "", "03", "305", "30531", "48.16667", "14.51667", "Europe/Vienna"),("2766429", "Sankt Pölten", "Санкт-Пёльтен", "AT", "40", "", "03", "302", "30201", "48.2", "15.63333", "Europe/Vienna"),("2766643", "Sankt Johann im Pongau", "", "AT", "40", "", "05", "504", "50418", "47.35", "13.2", "Europe/Vienna"),("2766772", "Sankt Andrä", "", "AT", "40", "", "02", "209", "20913", "46.76829", "14.81991", "Europe/Vienna"),("2766824", "Salzburg", "Зальцбург", "AT", "40", "", "05", "501", "50101", "47.79941", "13.04399", "Europe/Vienna"),("2766922", "Saalfelden am Steinernen Meer", "Зальфельден-ам-Штайнернен-Меер", "AT", "40", "", "05", "506", "50619", "47.42681", "12.848", "Europe/Vienna"),("2766971", "Rum", "", "AT", "40", "", "07", "703", "70346", "47.28333", "11.45", "Europe/Vienna"),("2767034", "Rottenmann", "", "AT", "40", "", "06", "612", "61238", "47.51667", "14.35", "Europe/Vienna"),("2767471", "Ried im Innkreis", "", "AT", "40", "", "04", "412", "41225", "48.21123", "13.48855", "Europe/Vienna"),("2767511", "Reutte", "", "AT", "40", "", "07", "708", "70828", "47.48333", "10.71667", "Europe/Vienna"),("2767974", "Rankweil", "", "AT", "40", "", "08", "804", "80414", "47.27108", "9.64308", "Europe/Vienna"),("2768232", "Purkersdorf", "", "AT", "40", "", "03", "324", "32416", "48.20769", "16.17539", "Europe/Vienna"),("2768236", "Purgstall", "", "AT", "40", "", "03", "320", "32008", "48.05841", "15.13478", "Europe/Vienna"),("2768348", "Pressbaum", "", "AT", "40", "", "03", "324", "32415", "48.18333", "16.08333", "Europe/Vienna"),("2768450", "Poysdorf", "", "AT", "40", "", "03", "316", "31644", "48.66667", "16.63333", "Europe/Vienna"),("2768472", "Pottendorf", "", "AT", "40", "", "03", "306", "30626", "47.9", "16.38333", "Europe/Vienna"),("2768811", "Pinkafeld", "", "AT", "40", "", "01", "109", "10918", "47.36667", "16.11667", "Europe/Vienna"),("2769105", "Perg", "", "AT", "40", "", "04", "411", "41116", "48.25", "14.63333", "Europe/Vienna"),("2769110", "Perchtoldsdorf", "", "AT", "40", "", "03", "317", "31719", "48.11935", "16.26607", "Europe/Vienna"),("2769212", "Paternion", "", "AT", "40", "", "02", "207", "20720", "46.71417", "13.63611", "Europe/Vienna"),("2769225", "Pasching", "", "AT", "40", "", "04", "410", "41017", "48.25931", "14.20369", "Europe/Vienna"),("2769623", "Oberwart", "", "AT", "40", "", "01", "109", "10917", "47.28971", "16.20595", "Europe/Vienna"),("2770684", "Neusiedl am See", "", "AT", "40", "", "01", "107", "10713", "47.94901", "16.8417", "Europe/Vienna"),("2770711", "Neunkirchen", "", "AT", "40", "", "03", "318", "31818", "47.72096", "16.08107", "Europe/Vienna"),("2770885", "Nenzing", "", "AT", "40", "", "08", "801", "80116", "47.18436", "9.70539", "Europe/Vienna"),("2770993", "Mürzzuschlag", "", "AT", "40", "", "06", "621", "62121", "47.6", "15.68333", "Europe/Vienna"),("2771335", "Mödling", "Мёдлинг", "AT", "40", "", "03", "317", "31717", "48.08605", "16.28921", "Europe/Vienna"),("2771385", "Mittersill", "", "AT", "40", "", "05", "506", "50613", "47.28333", "12.48333", "Europe/Vienna"),("2771557", "Mistelbach", "", "AT", "40", "", "03", "316", "31633", "48.57", "16.57667", "Europe/Vienna"),("2771619", "Micheldorf in Oberösterreich", "", "AT", "40", "", "04", "409", "40908", "47.87764", "14.13357", "Europe/Vienna"),("2771682", "Melk", "", "AT", "40", "", "03", "315", "31524", "48.22737", "15.33186", "Europe/Vienna"),("2771817", "Mattersburg", "", "AT", "40", "", "01", "106", "10606", "47.73333", "16.4", "Europe/Vienna"),("2771828", "Matrei in Osttirol", "", "AT", "40", "", "07", "707", "70717", "47", "12.53333", "Europe/Vienna"),("2771867", "Sankt Florian", "", "AT", "40", "AT", "04", "410", "41013", "48.20568", "14.37836", "Europe/Vienna"),("2771896", "Mariatrost", "", "AT", "40", "", "06", "601", "60101", "47.1", "15.5", "Europe/Vienna"),("2771940", "Maria Enzersdorf", "", "AT", "40", "", "03", "317", "31716", "48.1", "16.28333", "Europe/Vienna"),("2771962", "Marchtrenk", "", "AT", "40", "", "04", "418", "41812", "48.18333", "14.11667", "Europe/Vienna"),("2772173", "Lustenau", "Лустенау", "AT", "40", "", "08", "803", "80303", "47.42642", "9.65851", "Europe/Vienna"),("2772345", "Lochau", "", "AT", "40", "", "08", "802", "80226", "47.53333", "9.75", "Europe/Vienna"),("2772400", "Linz", "Линц", "AT", "40", "", "04", "401", "40101", "48.30639", "14.28611", "Europe/Vienna"),("2772480", "Liezen", "", "AT", "40", "", "06", "612", "61223", "47.56667", "14.23333", "Europe/Vienna"),("2772505", "Lienz", "", "AT", "40", "", "07", "707", "70716", "46.8289", "12.76903", "Europe/Vienna"),("2772635", "Leonding", "Леондинг", "AT", "40", "", "04", "410", "41012", "48.27965", "14.2533", "Europe/Vienna"),("2772649", "Leoben", "Леобен", "AT", "40", "", "06", "611", "61108", "47.3765", "15.09144", "Europe/Vienna"),("2772653", "Lenzing", "", "AT", "40", "", "04", "417", "41713", "47.97326", "13.60846", "Europe/Vienna"),("2772753", "Leibnitz", "", "AT", "40", "", "06", "610", "61022", "46.78161", "15.53836", "Europe/Vienna"),("2772827", "Lauterach", "", "AT", "40", "", "08", "802", "80224", "47.48306", "9.73306", "Europe/Vienna"),("2772998", "Langenzersdorf", "", "AT", "40", "", "03", "312", "31214", "48.3", "16.35", "Europe/Vienna"),("2773010", "Langenlois", "", "AT", "40", "", "03", "313", "31322", "48.46667", "15.66667", "Europe/Vienna"),("2773070", "Landeck", "", "AT", "40", "", "07", "706", "70614", "47.13988", "10.56593", "Europe/Vienna"),("2773215", "Laakirchen", "", "AT", "40", "", "04", "407", "40711", "47.98188", "13.82166", "Europe/Vienna"),("2773229", "Laa an der Thaya", "", "AT", "40", "", "03", "316", "31629", "48.71667", "16.38333", "Europe/Vienna"),("2773300", "Kufstein", "Куфштайн", "AT", "40", "", "07", "705", "70513", "47.58333", "12.16667", "Europe/Vienna"),("2773304", "Kuchl", "", "AT", "40", "", "05", "502", "50207", "47.62647", "13.1448", "Europe/Vienna"),("2773447", "Krieglach", "", "AT", "40", "", "06", "621", "62115", "47.53333", "15.55", "Europe/Vienna"),("2773538", "Kremsmünster", "", "AT", "40", "", "04", "409", "40907", "48.0529", "14.12919", "Europe/Vienna"),("2773549", "Krems an der Donau", "Кремс-на-Дунае", "AT", "40", "", "03", "301", "30101", "48.40921", "15.61415", "Europe/Vienna"),("2773653", "Kottingbrunn", "", "AT", "40", "", "03", "306", "30618", "47.95096", "16.22715", "Europe/Vienna"),("2773698", "Korneuburg", "", "AT", "40", "", "03", "312", "31213", "48.35", "16.33333", "Europe/Vienna"),("2773848", "Köflach", "", "AT", "40", "", "06", "616", "61609", "47.06667", "15.08333", "Europe/Vienna"),("2773887", "Knittelfeld", "", "AT", "40", "", "06", "620", "62013", "47.21667", "14.81667", "Europe/Vienna"),("2773913", "Klosterneuburg", "Клостернойбург", "AT", "40", "", "03", "324", "32408", "48.30521", "16.32522", "Europe/Vienna"),("2774326", "Klagenfurt am Wörthersee", "Клагенфурт", "AT", "40", "", "02", "201", "20101", "46.62472", "14.30528", "Europe/Vienna"),("2774347", "Kitzbühel", "", "AT", "40", "", "07", "704", "70411", "47.44637", "12.39215", "Europe/Vienna"),("2774437", "Kindberg", "", "AT", "40", "", "06", "621", "62114", "47.5", "15.45", "Europe/Vienna"),("2774773", "Kapfenberg", "Капфенберг", "AT", "40", "", "06", "621", "62113", "47.44458", "15.29331", "Europe/Vienna"),("2775020", "Judenburg", "", "AT", "40", "", "06", "620", "62011", "47.16667", "14.66667", "Europe/Vienna"),("2775093", "Jenbach", "", "AT", "40", "", "07", "709", "70917", "47.39173", "11.77245", "Europe/Vienna"),("2775220", "Innsbruck", "Инсбрук", "AT", "40", "", "07", "701", "70101", "47.26266", "11.39454", "Europe/Vienna"),("2775307", "Imst", "", "AT", "40", "", "07", "702", "70203", "47.24504", "10.73974", "Europe/Vienna"),("2775497", "Hörsching", "", "AT", "40", "", "04", "410", "41007", "48.22627", "14.17786", "Europe/Vienna"),("2775516", "Horn", "", "AT", "40", "", "03", "311", "31109", "48.66274", "15.65663", "Europe/Vienna"),("2775531", "Hörbranz", "", "AT", "40", "", "08", "802", "80218", "47.55", "9.75", "Europe/Vienna"),("2775541", "Hopfgarten im Brixental", "", "AT", "40", "", "07", "704", "70406", "47.45", "12.16667", "Europe/Vienna"),("2775636", "Hollabrunn", "", "AT", "40", "", "03", "310", "31022", "48.55", "16.08333", "Europe/Vienna"),("2775742", "Hohenems", "", "AT", "40", "", "08", "803", "80302", "47.36667", "9.68306", "Europe/Vienna"),("2775950", "Höchst", "", "AT", "40", "", "08", "802", "80217", "47.45934", "9.6405", "Europe/Vienna"),("2776401", "Himberg", "", "AT", "40", "", "03", "324", "32406", "48.08333", "16.43333", "Europe/Vienna"),("2776470", "Herzogenburg", "", "AT", "40", "", "03", "319", "31912", "48.28137", "15.69431", "Europe/Vienna"),("2776497", "Hermagor", "", "AT", "40", "", "02", "203", "20305", "46.62722", "13.36722", "Europe/Vienna"),("2776801", "Hartberg", "", "AT", "40", "", "06", "622", "62219", "47.28333", "15.96667", "Europe/Vienna"),("2776874", "Hard", "", "AT", "40", "", "08", "802", "80215", "47.48306", "9.68306", "Europe/Vienna"),("2776951", "Hallein", "Халлайн", "AT", "40", "", "05", "502", "50205", "47.68333", "13.1", "Europe/Vienna"),("2776988", "Hainburg an der Donau", "", "AT", "40", "", "03", "307", "30710", "48.14627", "16.94504", "Europe/Vienna"),("2777836", "Groß-Enzersdorf", "", "AT", "40", "", "03", "308", "30821", "48.20278", "16.55083", "Europe/Vienna"),("2777921", "Grödig", "", "AT", "40", "", "05", "503", "50314", "47.73333", "13.03333", "Europe/Vienna"),("2778067", "Graz", "Грац", "AT", "40", "", "06", "601", "60101", "47.06667", "15.45", "Europe/Vienna"),("2778085", "Gratkorn", "", "AT", "40", "", "06", "606", "60613", "47.13333", "15.35", "Europe/Vienna"),("2778218", "Götzis", "", "AT", "40", "", "08", "804", "80408", "47.33306", "9.63306", "Europe/Vienna"),("2778255", "Gösting", "", "AT", "40", "", "06", "601", "60101", "47.09788", "15.39777", "Europe/Vienna"),("2778436", "Gmunden", "", "AT", "40", "", "04", "407", "40705", "47.91839", "13.79933", "Europe/Vienna"),("2778439", "Gmünd", "", "AT", "40", "", "03", "309", "30908", "48.7683", "14.9808", "Europe/Vienna"),("2778455", "Gloggnitz", "", "AT", "40", "", "03", "318", "31810", "47.67487", "15.93893", "Europe/Vienna"),("2778478", "Gleisdorf", "", "AT", "40", "", "06", "617", "61713", "47.10559", "15.71011", "Europe/Vienna"),("2778690", "Gerasdorf bei Wien", "", "AT", "40", "", "03", "324", "32404", "48.29447", "16.46765", "Europe/Vienna"),("2778843", "Garsten", "", "AT", "40", "", "04", "415", "41506", "48.0224", "14.40747", "Europe/Vienna"),("2778877", "Gänserndorf", "", "AT", "40", "", "03", "308", "30817", "48.33925", "16.72016", "Europe/Vienna"),("2778966", "Gallneukirchen", "", "AT", "40", "", "04", "416", "41607", "48.35363", "14.41604", "Europe/Vienna"),("2779115", "Fürstenfeld", "", "AT", "40", "", "06", "622", "62212", "47.05", "16.08333", "Europe/Vienna"),("2779202", "Frohnleiten", "", "AT", "40", "", "06", "606", "60610", "47.26667", "15.31667", "Europe/Vienna"),("2779229", "Friesach", "", "AT", "40", "", "02", "205", "20505", "46.95528", "14.40583", "Europe/Vienna"),("2779275", "Freistadt", "", "AT", "40", "", "04", "406", "40601", "48.51103", "14.50453", "Europe/Vienna"),("2779380", "Frankenburg", "", "AT", "40", "", "04", "417", "41709", "48.06844", "13.49065", "Europe/Vienna"),("2779450", "Fohnsdorf", "", "AT", "40", "", "06", "620", "62007", "47.2", "14.68333", "Europe/Vienna"),("2779640", "Ferlach", "", "AT", "40", "", "02", "204", "20405", "46.52694", "14.30194", "Europe/Vienna"),("2779669", "Feldkirchen in Kärnten", "", "AT", "40", "", "02", "210", "21002", "46.72368", "14.0958", "Europe/Vienna"),("2779672", "Feldkirchen an der Donau", "", "AT", "40", "", "04", "416", "41606", "48.34524", "14.05134", "Europe/Vienna"),("2779674", "Feldkirch", "Фельдкирх", "AT", "40", "", "08", "804", "80404", "47.23306", "9.6", "Europe/Vienna"),("2780048", "Enns", "", "AT", "40", "", "04", "410", "41005", "48.21346", "14.47612", "Europe/Vienna"),("2780057", "Engerwitzdorf", "", "AT", "40", "", "04", "416", "41605", "48.34507", "14.44204", "Europe/Vienna"),("2780190", "Eisenstadt", "", "AT", "40", "", "01", "101", "10101", "47.84565", "16.52327", "Europe/Vienna"),("2780207", "Eisenerz", "", "AT", "40", "", "06", "611", "61101", "47.53333", "14.88333", "Europe/Vienna"),("2780501", "Ebreichsdorf", "", "AT", "40", "", "03", "306", "30607", "47.95", "16.4", "Europe/Vienna"),("2780531", "Eberndorf", "", "AT", "40", "", "02", "208", "20803", "46.59139", "14.64361", "Europe/Vienna"),("2780544", "Ebenthal", "", "AT", "40", "", "02", "204", "20402", "46.60806", "14.36417", "Europe/Vienna"),("2780547", "Ebensee", "", "AT", "40", "", "04", "407", "40704", "47.80716", "13.779", "Europe/Vienna"),("2780579", "Ebbs", "", "AT", "40", "", "07", "705", "70508", "47.63333", "12.21667", "Europe/Vienna"),("2780741", "Dornbirn", "Дорнбирн", "AT", "40", "", "08", "803", "80301", "47.41427", "9.74195", "Europe/Vienna"),("2781017", "Deutsch-Wagram", "", "AT", "40", "", "03", "308", "30808", "48.29972", "16.56667", "Europe/Vienna"),("2781023", "Deutschlandsberg", "", "AT", "40", "", "06", "603", "60302", "46.81528", "15.22222", "Europe/Vienna"),("2781371", "Bruck an der Mur", "", "AT", "40", "", "06", "621", "62106", "47.41667", "15.28333", "Europe/Vienna"),("2781373", "Bruck an der Leitha", "", "AT", "40", "", "03", "307", "30704", "48.01667", "16.76667", "Europe/Vienna"),("2781503", "Bregenz", "Брегенц", "AT", "40", "", "08", "802", "80207", "47.50311", "9.7471", "Europe/Vienna"),("2781520", "Braunau am Inn", "Браунау-ам-Инн", "AT", "40", "", "04", "404", "40404", "48.25628", "13.04343", "Europe/Vienna"),("2781680", "Bludenz", "", "AT", "40", "", "08", "801", "80103", "47.15476", "9.82255", "Europe/Vienna"),("2781735", "Bischofshofen", "", "AT", "40", "", "05", "504", "50404", "47.41667", "13.21667", "Europe/Vienna"),("2781837", "Berndorf", "", "AT", "40", "", "03", "306", "30605", "47.94567", "16.10973", "Europe/Vienna"),("2781859", "Bergheim", "", "AT", "40", "", "05", "503", "50303", "47.83333", "13.03333", "Europe/Vienna"),("2782043", "Bad Vöslau", "", "AT", "40", "", "03", "306", "30603", "47.96533", "16.21359", "Europe/Vienna"),("2782052", "Bad Ischl", "", "AT", "40", "", "04", "407", "40703", "47.71109", "13.61893", "Europe/Vienna"),("2782053", "Bad Hofgastein", "", "AT", "40", "", "05", "504", "50402", "47.17274", "13.09871", "Europe/Vienna"),("2782055", "Bad Goisern", "", "AT", "40", "", "04", "407", "40702", "47.64252", "13.61609", "Europe/Vienna"),("2782058", "Bad Gastein", "", "AT", "40", "", "05", "504", "50403", "47.11547", "13.13467", "Europe/Vienna"),("2782067", "Baden", "Баден", "AT", "40", "", "03", "306", "30604", "48.00543", "16.23264", "Europe/Vienna"),("2782070", "Bad Aussee", "", "AT", "40", "", "06", "612", "61207", "47.60998", "13.78243", "Europe/Vienna"),("2782302", "Asten", "", "AT", "40", "", "04", "410", "41003", "48.21941", "14.41784", "Europe/Vienna"),("2782408", "Arnoldstein", "", "AT", "40", "", "02", "207", "20702", "46.54611", "13.71", "Europe/Vienna"),("2782480", "Ansfelden", "", "AT", "40", "", "04", "410", "41002", "48.20969", "14.29004", "Europe/Vienna"),("2782555", "Amstetten", "Амштеттен", "AT", "40", "", "03", "305", "30502", "48.1229", "14.87206", "Europe/Vienna"),("2782627", "Altmünster", "", "AT", "40", "", "04", "407", "40701", "47.90219", "13.76415", "Europe/Vienna"),("2782728", "Altach", "", "AT", "40", "", "08", "804", "80401", "47.35", "9.65", "Europe/Vienna"),("2783050", "Abtenau", "", "AT", "40", "", "05", "502", "50201", "47.56373", "13.34599", "Europe/Vienna"),("2783058", "Absam", "", "AT", "40", "", "07", "703", "70301", "47.3", "11.5", "Europe/Vienna"),("3218464", "Finkenstein am Faaker See", "", "AT", "40", "", "02", "207", "20711", "46.56556", "13.86528", "Europe/Vienna"),("3233832", "Attnang-Puchheim", "", "AT", "40", "", "04", "417", "41703", "48.00833", "13.71667", "Europe/Vienna"),("3323063", "Ansfelden", "", "AT", "40", "", "05", "503", "50332", "47.965", "13.04944", "Europe/Vienna"),("2058430", "Whyalla", "Уайалла", "AU", "36", "", "05", "48540", "", "-33.03268", "137.56483", "Australia/Adelaide"),("2058682", "Wembley", "", "AU", "36", "", "08", "51310", "", "-31.93333", "115.8", "Australia/Perth"),("2059124", "Wanneroo", "", "AU", "36", "", "08", "58760", "", "-31.75", "115.8", "Australia/Perth"),("2059470", "Victor Harbor", "", "AU", "36", "", "05", "48050", "", "-35.55042", "138.62154", "Australia/Adelaide"),("2060771", "Swan View", "", "AU", "36", "", "08", "56090", "", "-31.88333", "116.05", "Australia/Perth"),("2060886", "Subiaco", "", "AU", "36", "", "08", "56580", "", "-31.9485", "115.8268", "Australia/Perth"),("2061224", "Spearwood", "", "AU", "36", "", "08", "51820", "", "-32.10534", "115.77797", "Australia/Perth"),("2061261", "South Perth", "", "AU", "36", "", "08", "57840", "", "-31.98333", "115.86667", "Australia/Perth"),("2061758", "Seaton", "", "AU", "36", "", "05", "41060", "", "-34.9", "138.51667", "Australia/Adelaide"),("2061840", "Scarborough", "", "AU", "36", "", "08", "57910", "", "-31.89578", "115.76431", "Australia/Perth"),("2062013", "Salisbury", "", "AU", "36", "", "05", "47140", "", "-34.76667", "138.63333", "Australia/Adelaide"),("2062057", "Safety Bay", "", "AU", "36", "", "08", "57490", "", "-32.30463", "115.74213", "Australia/Perth"),("2062338", "Rockingham", "", "AU", "36", "", "08", "57490", "", "-32.27682", "115.72978", "Australia/Perth"),("2062944", "Prospect", "", "AU", "36", "", "05", "46510", "", "-34.88241", "138.5933", "Australia/Adelaide"),("2063030", "Port Pirie", "", "AU", "36", "", "05", "46450", "", "-33.19176", "138.01746", "Australia/Adelaide"),("2063036", "Port Lincoln", "", "AU", "36", "", "05", "46300", "", "-34.72625", "135.87442", "Australia/Adelaide"),("2063042", "Port Hedland", "Порт-Хедленд", "AU", "36", "", "08", "57280", "", "-20.31215", "118.61059", "Australia/Perth"),("2063055", "Port Augusta West", "", "AU", "36", "", "05", "46090", "", "-32.48611", "137.75833", "Australia/Adelaide"),("2063056", "Port Augusta", "", "AU", "36", "", "05", "46090", "", "-32.49597", "137.77281", "Australia/Adelaide"),("2063523", "Perth", "Перт", "AU", "36", "", "08", "57080", "", "-31.95224", "115.8614", "Australia/Perth"),("2064340", "Nuriootpa", "", "AU", "36", "", "05", "40310", "", "-34.46825", "138.99767", "Australia/Adelaide"),("2064550", "Northam", "", "AU", "36", "", "08", "56730", "", "-31.64932", "116.67423", "Australia/Perth"),("2064768", "Newman", "", "AU", "36", "", "08", "53220", "", "-23.35644", "119.73553", "Australia/Perth"),("2064874", "Nedlands", "", "AU", "36", "", "08", "56580", "", "-31.98184", "115.8073", "Australia/Perth"),("2065176", "Murray Bridge", "Марри-Бридж", "AU", "36", "", "05", "45040", "", "-35.11986", "139.27345", "Australia/Adelaide"),("2065594", "Mount Isa", "Маунт-Айза", "AU", "36", "", "04", "35300", "", "-20.72523", "139.49727", "Australia/Brisbane"),("2065665", "Mount Barker", "", "AU", "36", "", "05", "44550", "", "-35.06667", "138.86667", "Australia/Adelaide"),("2065710", "Mosman Park", "", "AU", "36", "", "08", "55740", "", "-32.00538", "115.7638", "Australia/Perth"),("2065740", "Morphett Vale", "", "AU", "36", "", "05", "45340", "", "-35.13333", "138.51667", "Australia/Adelaide"),("2066041", "Modbury", "", "AU", "36", "", "05", "47700", "", "-34.83333", "138.68333", "Australia/Adelaide"),("2066653", "McMinns Lagoon", "", "AU", "36", "", "03", "72300", "", "-12.55397", "131.11165", "Australia/Darwin"),("2066756", "Maylands", "", "AU", "36", "", "08", "50420", "", "-31.93097", "115.89486", "Australia/Perth"),("2066981", "Margaret River", "", "AU", "36", "", "08", "50280", "", "-33.95504", "115.07599", "Australia/Perth"),("2067119", "Mandurah", "Мандъюра", "AU", "36", "", "08", "55110", "", "-32.5269", "115.7217", "Australia/Perth"),("2067260", "Maddington", "", "AU", "36", "", "08", "53780", "", "-32.05", "115.98333", "Australia/Perth"),("2068079", "Kwinana", "", "AU", "36", "", "08", "54830", "", "-32.23013", "115.78128", "Australia/Perth"),("2068110", "Kununurra", "", "AU", "36", "", "08", "59520", "", "-15.77825", "128.74208", "Australia/Perth"),("2068569", "Kenwick", "", "AU", "36", "", "08", "53780", "", "-32.03333", "115.96667", "Australia/Perth"),("2068594", "Kelmscott", "", "AU", "36", "", "08", "50210", "", "-32.12434", "116.0259", "Australia/Perth"),("2068655", "Katherine", "", "AU", "36", "", "03", "72200", "", "-14.46517", "132.26347", "Australia/Darwin"),("2068823", "Kalgoorlie", "Калгурли", "AU", "36", "", "08", "54280", "", "-30.74614", "121.4742", "Australia/Perth"),("2069375", "Ingle Farm", "", "AU", "36", "", "05", "47140", "", "-34.83333", "138.63333", "Australia/Adelaide"),("2069646", "Hope Valley", "", "AU", "36", "", "05", "47700", "", "-34.83333", "138.7", "Australia/Adelaide"),("2070106", "Happy Valley", "", "AU", "36", "", "05", "44060", "", "-35.08333", "138.53333", "Australia/Adelaide"),("2070515", "Grange", "", "AU", "36", "", "05", "41060", "", "-34.90223", "138.49022", "Australia/Adelaide"),("2070571", "Gosnells", "", "AU", "36", "", "08", "53780", "", "-32.081", "116.0054", "Australia/Perth"),("2070711", "Golden Grove", "", "AU", "36", "", "05", "47700", "", "-34.78333", "138.73333", "Australia/Adelaide"),("2070998", "Geraldton", "Джералдтон", "AU", "36", "", "08", "53520", "", "-28.77897", "114.61459", "Australia/Perth"),("2071059", "Gawler", "Голер", "AU", "36", "", "05", "42030", "", "-34.60251", "138.74902", "Australia/Adelaide"),("2071223", "Fremantle", "Фримантл", "AU", "36", "", "08", "53430", "", "-32.05454", "115.75127", "Australia/Perth"),("2071601", "Findon", "", "AU", "36", "", "05", "41060", "", "-34.9", "138.53333", "Australia/Adelaide"),("2071860", "Esperance", "", "AU", "36", "", "08", "53290", "", "-33.85919", "121.89164", "Australia/Perth"),("2073124", "Darwin", "Дарвин", "AU", "36", "", "03", "71000", "", "-12.46113", "130.84185", "Australia/Darwin"),("2073603", "Cottesloe", "", "AU", "36", "", "08", "56930", "", "-32", "115.76667", "Australia/Perth"),("2074113", "Collie", "", "AU", "36", "", "08", "51890", "", "-33.36206", "116.15617", "Australia/Perth"),("2074865", "Carnarvon", "", "AU", "36", "", "08", "51540", "", "-24.88258", "113.65713", "Australia/Perth"),("2075056", "Campbelltown", "", "AU", "36", "AU", "05", "40910", "", "-34.88333", "138.66667", "Australia/Adelaide"),("2075265", "Busselton", "", "AU", "36", "", "08", "51260", "", "-33.65249", "115.3455", "Australia/Perth"),("2075432", "Bunbury", "Банбери", "AU", "36", "", "08", "51190", "", "-33.32711", "115.64137", "Australia/Perth"),("2075720", "Broome", "", "AU", "36", "", "08", "50980", "", "-17.95538", "122.23922", "Australia/Perth"),("2075988", "Boulder", "", "AU", "36", "", "08", "54280", "", "-30.78204", "121.4912", "Australia/Perth"),("2076752", "Bentley", "", "AU", "36", "", "08", "51330", "", "-32", "115.91667", "Australia/Perth"),("2077030", "Bassendean", "", "AU", "36", "", "08", "50350", "", "-31.90906", "115.9437", "Australia/Perth"),("2077454", "Australind", "", "AU", "36", "", "08", "53990", "", "-33.2792", "115.71504", "Australia/Perth"),("2077579", "Armadale", "", "AU", "36", "", "08", "50210", "", "-32.14607", "116.0093", "Australia/Perth"),("2077641", "Applecross", "", "AU", "36", "", "08", "55320", "", "-32.01667", "115.83333", "Australia/Perth"),("2077895", "Alice Springs", "Алис-Спрингс", "AU", "36", "", "03", "70200", "", "-23.69748", "133.88362", "Australia/Darwin"),("2077935", "Aldinga", "", "AU", "36", "", "05", "45340", "", "-35.28333", "138.48333", "Australia/Adelaide"),("2077963", "Albany", "Олбани", "AU", "36", "", "08", "50080", "", "-35.0031", "117.86595", "Australia/Perth"),("2078025", "Adelaide", "Аделаида", "AU", "36", "", "05", "40070", "", "-34.92866", "138.59863", "Australia/Adelaide"),("2078313", "Eaton", "", "AU", "36", "", "08", "52660", "", "-33.31664", "115.70503", "Australia/Perth"),("2078766", "Quinns Rocks", "", "AU", "36", "", "08", "58760", "", "-31.67379", "115.70372", "Australia/Perth"),("2078894", "East Fremantle", "", "AU", "36", "", "08", "53150", "", "-32.03823", "115.7676", "Australia/Perth"),("2078904", "Claremont", "", "AU", "36", "", "08", "51750", "", "-31.97961", "115.7823", "Australia/Perth"),("2078907", "Bicton", "", "AU", "36", "", "08", "55320", "", "-32.02778", "115.78333", "Australia/Perth"),("2078908", "Attadale", "", "AU", "36", "", "08", "55320", "", "-32.02489", "115.802", "Australia/Perth"),("2079183", "Warnbro", "", "AU", "36", "", "08", "57490", "", "-32.34017", "115.7473", "Australia/Perth"),("2079189", "Mullaloo", "", "AU", "36", "", "08", "54170", "", "-31.77896", "115.73676", "Australia/Perth"),("2142245", "Young", "", "AU", "36", "", "02", "18750", "", "-34.3135", "148.30107", "Australia/Sydney"),("2142316", "Yeppoon", "", "AU", "36", "", "04", "36360", "", "-23.12683", "150.74406", "Australia/Brisbane"),("2142412", "Yass", "", "AU", "36", "", "02", "18710", "", "-34.84036", "148.90987", "Australia/Sydney"),("2142447", "Yarrawonga", "", "AU", "36", "", "07", "24900", "", "-36.01923", "145.99973", "Australia/Sydney"),("2142457", "Yarraville", "", "AU", "36", "", "07", "24330", "", "-37.81667", "144.9", "Australia/Melbourne"),("2142747", "Wynyard", "", "AU", "36", "", "06", "65410", "", "-40.9897", "145.72617", "Australia/Hobart"),("2142750", "Wynnum", "", "AU", "36", "", "04", "31000", "", "-27.44527", "153.15813", "Australia/Brisbane"),("2143069", "Woodridge", "", "AU", "36", "", "04", "34590", "", "-27.63333", "153.1", "Australia/Brisbane"),("2143285", "Wodonga", "Уодонга", "AU", "36", "", "07", "27170", "", "-36.12179", "146.88809", "Australia/Melbourne"),("2143407", "Windsor", "", "AU", "36", "", "07", "26350", "", "-37.85344", "144.99241", "Australia/Melbourne"),("2143561", "Williamstown", "", "AU", "36", "", "07", "23110", "", "-37.857", "144.89769", "Australia/Melbourne"),("2144095", "Werribee", "", "AU", "36", "", "07", "27260", "", "-37.9", "144.66667", "Australia/Melbourne"),("2144157", "Wellington Point", "", "AU", "36", "", "04", "36250", "", "-27.48333", "153.25", "Australia/Brisbane"),("2144168", "Wellington", "", "AU", "36", "", "02", "18150", "", "-32.55588", "148.94508", "Australia/Sydney"),("2144397", "Watsonia", "", "AU", "36", "", "07", "20660", "", "-37.71667", "145.08333", "Australia/Melbourne"),("2144502", "Warwick", "", "AU", "36", "", "04", "36660", "", "-28.21901", "152.03438", "Australia/Brisbane"),("2144528", "Warrnambool", "Уорнамбул", "AU", "36", "", "07", "26730", "", "-38.38176", "142.48799", "Australia/Melbourne"),("2144583", "Warrandyte", "", "AU", "36", "", "07", "24210", "", "-37.75", "145.23333", "Australia/Melbourne"),("2144604", "Warragul", "", "AU", "36", "", "07", "20830", "", "-38.15912", "145.93118", "Australia/Melbourne"),("2144728", "Wantirna South", "", "AU", "36", "", "07", "23670", "", "-37.88333", "145.21667", "Australia/Melbourne"),("2144729", "Wantirna", "", "AU", "36", "", "07", "23670", "", "-37.85", "145.21667", "Australia/Melbourne"),("2144764", "Wangaratta", "Уангаратта", "AU", "36", "", "07", "26700", "", "-36.35846", "146.32056", "Australia/Melbourne"),("2145110", "Wagga Wagga", "Уогга Уогга", "AU", "36", "", "02", "17750", "", "-35.12577", "147.35375", "Australia/Sydney"),("2145214", "Victoria Point", "", "AU", "36", "", "04", "36250", "", "-27.58329", "153.31172", "Australia/Brisbane"),("2145267", "Vermont", "", "AU", "36", "", "07", "26980", "", "-37.83616", "145.19428", "Australia/Melbourne"),("2145392", "Urangan", "", "AU", "36", "", "04", "33220", "", "-25.29214", "152.90535", "Australia/Brisbane"),("2145409", "Upwey", "", "AU", "36", "", "07", "27450", "", "-37.9", "145.33333", "Australia/Melbourne"),("2145461", "Upper Coomera", "", "AU", "36", "", "04", "33430", "", "-27.9", "153.3", "Australia/Brisbane"),("2145532", "Ulverstone", "", "AU", "36", "", "06", "60810", "", "-41.16026", "146.18242", "Australia/Hobart"),("2145554", "Ulladulla", "", "AU", "36", "", "02", "16950", "", "-35.35906", "150.47247", "Australia/Sydney"),("2145875", "Tumut", "", "AU", "36", "", "02", "17500", "", "-35.30016", "148.22505", "Australia/Sydney"),("2145921", "Tullamarine", "", "AU", "36", "", "07", "23270", "", "-37.70128", "144.881", "Australia/Melbourne"),("2145990", "Truganina", "", "AU", "36", "", "07", "27260", "", "-37.81667", "144.75", "Australia/Melbourne"),("2146108", "Traralgon", "Траралгон", "AU", "36", "", "07", "23810", "", "-38.19528", "146.5415", "Australia/Melbourne"),("2146142", "Townsville", "Таунсвилл", "AU", "36", "", "04", "37010", "", "-19.26639", "146.80569", "Australia/Brisbane"),("2146219", "Torquay", "", "AU", "36", "", "04", "33220", "", "-25.28496", "152.87886", "Australia/Brisbane"),("2146268", "Toowoomba", "Тувумба", "AU", "36", "", "04", "36910", "", "-27.56056", "151.95386", "Australia/Brisbane"),("2146291", "Toorak", "", "AU", "36", "", "07", "26350", "", "-37.84165", "145.01438", "Australia/Melbourne"),("2146793", "Thornbury", "", "AU", "36", "", "07", "21890", "", "-37.75", "145", "Australia/Melbourne"),("2146827", "Thomastown", "", "AU", "36", "", "07", "27070", "", "-37.68333", "145.01667", "Australia/Melbourne"),("2146997", "Tewantin", "", "AU", "36", "", "04", "36710", "", "-26.39104", "153.03432", "Australia/Brisbane"),("2147139", "Templestowe Lower", "", "AU", "36", "", "07", "24210", "", "-37.76667", "145.11667", "Australia/Melbourne"),("2147336", "Tarragindi", "", "AU", "36", "", "04", "31000", "", "-27.53333", "153.03333", "Australia/Brisbane"),("2147357", "Tarneit", "", "AU", "36", "", "07", "27260", "", "-37.86667", "144.66667", "Australia/Melbourne"),("2147381", "Taree", "Тари", "AU", "36", "", "02", "13350", "", "-31.91099", "152.45387", "Australia/Sydney"),("2147497", "Tamworth", "Тамуорт", "AU", "36", "", "02", "17310", "", "-31.09048", "150.92905", "Australia/Sydney"),("2147714", "Sydney", "Сидней", "AU", "36", "", "02", "17200", "", "-33.86785", "151.20732", "Australia/Sydney"),("2147717", "Sydenham", "", "AU", "36", "", "07", "21180", "", "-37.7", "144.76667", "Australia/Melbourne"),("2147756", "Swan Hill", "", "AU", "36", "", "07", "26610", "", "-35.33781", "143.5544", "Australia/Melbourne"),("2147826", "Surrey Hills", "", "AU", "36", "", "07", "21110", "", "-37.81667", "145.1", "Australia/Melbourne"),("2147849", "Surfers Paradise", "Сёрферс Парадайз", "AU", "36", "", "04", "33430", "", "-28.00274", "153.42999", "Australia/Brisbane"),("2147892", "Sunnybank", "", "AU", "36", "", "04", "31000", "", "-27.58333", "153.05", "Australia/Brisbane"),("2147914", "Sunbury", "Санбери", "AU", "36", "", "07", "23270", "", "-37.57742", "144.72607", "Australia/Melbourne"),("2148070", "Strathpine", "", "AU", "36", "", "04", "35010", "", "-27.30414", "152.98977", "Australia/Brisbane"),("2148398", "Port Stephens", "", "AU", "36", "AU", "02", "16400", "", "-32.71314", "152.06623", "Australia/Sydney"),("2148431", "Stawell", "", "AU", "36", "", "07", "25810", "", "-37.05632", "142.78088", "Australia/Melbourne"),("2148588", "Springvale South", "", "AU", "36", "", "07", "22670", "", "-37.96667", "145.15", "Australia/Melbourne"),("2148591", "Springvale", "", "AU", "36", "", "07", "22670", "", "-37.94853", "145.15274", "Australia/Melbourne"),("2148928", "Southport", "", "AU", "36", "", "04", "33430", "", "-27.96724", "153.39796", "Australia/Brisbane"),("2148955", "South Melbourne", "", "AU", "36", "", "07", "25900", "", "-37.83333", "144.96667", "Australia/Melbourne"),("2148997", "South Grafton", "", "AU", "36", "", "02", "11730", "", "-29.7076", "152.92627", "Australia/Sydney"),("2149128", "Somerville", "", "AU", "36", "", "07", "25340", "", "-38.21667", "145.16667", "Australia/Melbourne"),("2149349", "Slacks Creek", "", "AU", "36", "", "04", "34590", "", "-27.65", "153.15", "Australia/Brisbane"),("2149475", "Singleton", "", "AU", "36", "", "02", "17000", "", "-32.56742", "151.16603", "Australia/Sydney"),("2149645", "Shepparton", "Шеппартон", "AU", "36", "", "07", "22830", "", "-36.38047", "145.39867", "Australia/Melbourne"),("2149936", "Sebastopol", "", "AU", "36", "", "07", "20570", "", "-37.58532", "143.83953", "Australia/Melbourne"),("2149975", "Seaford", "", "AU", "36", "", "07", "22170", "", "-38.1", "145.13333", "Australia/Melbourne"),("2150093", "Scoresby", "", "AU", "36", "", "07", "23670", "", "-37.9", "145.23333", "Australia/Melbourne"),("2150615", "Sale", "", "AU", "36", "", "07", "26810", "", "-38.11095", "147.06802", "Australia/Melbourne"),("2150660", "Saint Kilda", "", "AU", "36", "", "07", "25900", "", "-37.8676", "144.98099", "Australia/Melbourne"),("2150717", "Saint Albans", "", "AU", "36", "", "07", "21180", "", "-37.73333", "144.8", "Australia/Melbourne"),("2150765", "Rye", "", "AU", "36", "", "07", "", "", "-38.36667", "144.81667", "Australia/Melbourne"),("2150791", "Rutherford", "", "AU", "36", "", "02", "15050", "", "-32.71667", "151.53333", "Australia/Sydney"),("2150894", "Rowville", "", "AU", "36", "", "07", "23670", "", "-37.93333", "145.23333", "Australia/Melbourne"),("2151120", "Rosebud", "", "AU", "36", "", "07", "25340", "", "-38.35542", "144.9068", "Australia/Melbourne"),("2151146", "Rosanna", "", "AU", "36", "", "07", "20660", "", "-37.75", "145.06667", "Australia/Melbourne"),("2151187", "Roma", "", "AU", "36", "", "04", "34860", "", "-26.56741", "148.78751", "Australia/Brisbane"),("2151437", "Rockhampton", "Рокхемптон", "AU", "36", "", "04", "36360", "", "-23.38032", "150.50595", "Australia/Brisbane"),("2151522", "Riverstone", "", "AU", "36", "", "02", "10750", "", "-33.68333", "150.86667", "Australia/Sydney"),("2151575", "Ringwood East", "", "AU", "36", "", "07", "24410", "", "-37.81667", "145.25", "Australia/Melbourne"),("2151649", "Richmond", "", "AU", "36", "", "07", "27350", "", "-37.81819", "145.00176", "Australia/Melbourne"),("2151650", "Richmond", "", "AU", "36", "", "02", "13800", "", "-33.59956", "150.75142", "Australia/Sydney"),("2151716", "Reservoir", "", "AU", "36", "", "07", "21890", "", "-37.71667", "145", "Australia/Melbourne"),("2151886", "Redlynch", "", "AU", "36", "", "04", "32070", "", "-16.88333", "145.7", "Australia/Brisbane"),("2151905", "Red Hill", "", "AU", "36", "", "04", "37340", "", "-20.31667", "148.5", "Australia/Brisbane"),("2151932", "Redfern", "", "AU", "36", "", "02", "17200", "", "-33.89279", "151.20415", "Australia/Sydney"),("2152071", "Rathmines", "", "AU", "36", "", "02", "14650", "", "-33.03773", "151.58443", "Australia/Sydney"),("2152286", "Queanbeyan", "Куинбеян", "AU", "36", "", "02", "16470", "", "-35.35493", "149.232", "Australia/Sydney"),("2152329", "Quakers Hill", "", "AU", "36", "", "02", "10750", "", "-33.73333", "150.88333", "Australia/Sydney"),("2152361", "Pymble", "", "AU", "36", "", "02", "17200", "", "-33.74386", "151.14188", "Australia/Sydney"),("2152558", "Preston", "", "AU", "36", "", "07", "21890", "", "-37.75", "145.01667", "Australia/Melbourne"),("2152658", "Port Melbourne", "", "AU", "36", "", "07", "25900", "", "-37.83961", "144.94228", "Australia/Melbourne"),("2152659", "Port Macquarie", "Порт Маккуори", "AU", "36", "", "02", "16380", "", "-31.43084", "152.90894", "Australia/Sydney"),("2152667", "Portland", "", "AU", "36", "", "07", "22410", "", "-38.3462", "141.60257", "Australia/Melbourne"),("2152819", "Point Cook", "", "AU", "36", "", "07", "27260", "", "-37.91482", "144.75088", "Australia/Melbourne"),("2153467", "Penshurst", "", "AU", "36", "", "02", "14150", "", "-33.96667", "151.08333", "Australia/Sydney"),("2153471", "Penrith", "", "AU", "36", "", "02", "16350", "", "-33.75", "150.7", "Australia/Sydney"),("2153483", "Pennant Hills", "", "AU", "36", "", "02", "14000", "", "-33.73783", "151.07216", "Australia/Sydney"),("2153720", "Pascoe Vale", "", "AU", "36", "", "07", "25250", "", "-37.73333", "144.93333", "Australia/Melbourne"),("2153770", "Parkville", "", "AU", "36", "", "07", "24600", "", "-37.78333", "144.95", "Australia/Melbourne"),("2153778", "Parkes", "", "AU", "36", "", "02", "16200", "", "-33.1372", "148.1759", "Australia/Sydney"),("2153784", "Parkdale", "", "AU", "36", "", "07", "23430", "", "-37.98333", "145.06667", "Australia/Melbourne"),("2153925", "Palm Beach", "", "AU", "36", "", "04", "33430", "", "-28.11694", "153.46584", "Australia/Brisbane"),("2153951", "Pakenham South", "", "AU", "36", "", "07", "21450", "", "-38.13333", "145.51667", "Australia/Melbourne"),("2154172", "Ormond", "", "AU", "36", "", "07", "22310", "", "-37.9", "145.03333", "Australia/Melbourne"),("2154219", "Orange", "Орандж", "AU", "36", "", "02", "16150", "", "-33.28397", "149.10018", "Australia/Sydney"),("2154544", "Oatley", "", "AU", "36", "", "02", "14150", "", "-33.98004", "151.07201", "Australia/Sydney"),("2154720", "Nunawading", "", "AU", "36", "", "07", "26980", "", "-37.82043", "145.17308", "Australia/Melbourne"),("2154787", "Nowra", "Новра", "AU", "36", "", "02", "16950", "", "-34.88422", "150.60036", "Australia/Sydney"),("2154826", "North Wonthaggi", "", "AU", "36", "", "07", "20740", "", "-38.6", "145.6", "Australia/Melbourne"),("2154855", "North Sydney", "", "AU", "36", "", "02", "15950", "", "-33.839", "151.2072", "Australia/Sydney"),("2154912", "North Melbourne", "", "AU", "36", "", "07", "24600", "", "-37.8", "144.96667", "Australia/Melbourne"),("2154913", "Northmead", "", "AU", "36", "", "02", "16250", "", "-33.78333", "150.98333", "Australia/Sydney"),("2154962", "North Fitzroy", "", "AU", "36", "", "07", "27350", "", "-37.78862", "144.97885", "Australia/Melbourne"),("2155001", "Northcote", "", "AU", "36", "", "07", "21890", "", "-37.76667", "145", "Australia/Melbourne"),("2155132", "Noosaville", "", "AU", "36", "", "04", "36710", "", "-26.4", "153.06667", "Australia/Brisbane"),("2155204", "Noble Park", "", "AU", "36", "", "07", "22670", "", "-37.96667", "145.16667", "Australia/Melbourne"),("2155386", "Newtown", "", "AU", "36", "", "02", "15200", "", "-33.89835", "151.17754", "Australia/Sydney"),("2155411", "Newport", "", "AU", "36", "", "07", "23110", "", "-37.84427", "144.88483", "Australia/Melbourne"),("2155412", "Newport", "", "AU", "36", "", "02", "16370", "", "-33.65639", "151.31401", "Australia/Sydney"),("2155415", "New Norfolk", "", "AU", "36", "", "06", "61510", "", "-42.78261", "147.0587", "Australia/Hobart"),("2155416", "Newnham", "", "AU", "36", "", "06", "64010", "", "-41.39714", "147.13127", "Australia/Hobart"),("2155472", "Newcastle", "Ньюкасл", "AU", "36", "", "02", "15900", "", "-32.92715", "151.77647", "Australia/Sydney"),("2155542", "Nerang", "", "AU", "36", "", "04", "33430", "", "-27.98941", "153.33633", "Australia/Brisbane"),("2155562", "Nelson Bay", "", "AU", "36", "", "02", "16400", "", "-32.72043", "152.14398", "Australia/Sydney"),("2155717", "Narre Warren North", "", "AU", "36", "", "07", "21610", "", "-37.98333", "145.31667", "Australia/Melbourne"),("2155718", "Narre Warren", "", "AU", "36", "", "07", "21610", "", "-38.03333", "145.3", "Australia/Melbourne"),("2155742", "Narrabri", "", "AU", "36", "", "02", "15750", "", "-30.32488", "149.78266", "Australia/Sydney"),("2155745", "Narrabeen", "", "AU", "36", "", "02", "18000", "", "-33.71277", "151.29736", "Australia/Sydney"),("2155772", "Narellan", "", "AU", "36", "", "02", "11450", "", "-34.03333", "150.73333", "Australia/Sydney"),("2155783", "Narara", "", "AU", "36", "", "02", "13100", "", "-33.4", "151.35", "Australia/Sydney"),("2155787", "Narangba", "", "AU", "36", "", "04", "35010", "", "-27.20338", "152.95923", "Australia/Brisbane"),("2155796", "Naracoorte", "", "AU", "36", "", "05", "45090", "", "-36.95785", "140.7383", "Australia/Adelaide"),("2155858", "Nambucca Heads", "", "AU", "36", "", "02", "15700", "", "-30.64318", "153.00884", "Australia/Sydney"),("2155859", "Nambucca", "", "AU", "36", "", "02", "15700", "", "-30.63333", "152.98333", "Australia/Sydney"),("2155862", "Nambour", "", "AU", "36", "", "04", "36710", "", "-26.62613", "152.95941", "Australia/Brisbane"),("2156034", "Muswellbrook", "", "AU", "36", "", "02", "15650", "", "-32.26118", "150.89009", "Australia/Sydney"),("2156049", "Murwillumbah", "", "AU", "36", "", "02", "17550", "", "-28.32732", "153.39339", "Australia/Sydney"),("2156067", "Murrumbeena", "", "AU", "36", "", "07", "22310", "", "-37.9", "145.06667", "Australia/Melbourne"),("2156340", "Mulgrave", "", "AU", "36", "", "07", "24970", "", "-37.91667", "145.2", "Australia/Melbourne"),("2156404", "Mudgee", "", "AU", "36", "", "02", "15270", "", "-32.59426", "149.5871", "Australia/Sydney"),("2156578", "Mount Martha", "", "AU", "36", "", "07", "25340", "", "-38.26667", "145.01667", "Australia/Melbourne"),("2156643", "Mount Gambier", "Маунт-Гамбиер", "AU", "36", "", "05", "44620", "", "-37.8318", "140.77919", "Australia/Adelaide"),("2156652", "Mount Evelyn", "", "AU", "36", "", "07", "27450", "", "-37.78333", "145.38333", "Australia/Melbourne"),("2156663", "Mount Eliza", "", "AU", "36", "", "07", "25340", "", "-38.18333", "145.08333", "Australia/Melbourne"),("2156671", "Mount Druitt", "", "AU", "36", "", "02", "10750", "", "-33.76667", "150.81667", "Australia/Sydney"),("2156694", "Mount Colah", "", "AU", "36", "", "02", "14000", "", "-33.68333", "151.11667", "Australia/Sydney"),("2156777", "Moss Vale", "", "AU", "36", "", "02", "18350", "", "-34.55374", "150.37115", "Australia/Sydney"),("2156813", "Mosman", "Мосман", "AU", "36", "", "02", "15350", "", "-33.83902", "151.23956", "Australia/Sydney"),("2156825", "Morwell", "", "AU", "36", "", "07", "23810", "", "-38.23476", "146.39499", "Australia/Melbourne"),("2156853", "Mortdale", "", "AU", "36", "", "02", "14150", "", "-33.96667", "151.08333", "Australia/Sydney"),("2156878", "Mornington", "Морнингтон", "AU", "36", "", "07", "25340", "", "-38.21792", "145.03876", "Australia/Melbourne"),("2156927", "Moree", "", "AU", "36", "", "02", "15300", "", "-29.46278", "149.84157", "Australia/Sydney"),("2156933", "Mordialloc", "", "AU", "36", "", "07", "23430", "", "-38", "145.08333", "Australia/Melbourne"),("2156934", "Morayfield", "", "AU", "36", "", "04", "35010", "", "-27.10876", "152.94907", "Australia/Brisbane"),("2157026", "Moorabbin", "", "AU", "36", "", "07", "20910", "", "-37.93667", "145.03417", "Australia/Melbourne"),("2157056", "Moonee Ponds", "", "AU", "36", "", "07", "25060", "", "-37.76667", "144.91667", "Australia/Melbourne"),("2157090", "Moonah", "", "AU", "36", "", "06", "62610", "", "-42.84617", "147.30228", "Australia/Hobart"),("2157109", "Mooloolaba", "", "AU", "36", "", "04", "36710", "", "-26.68164", "153.11925", "Australia/Brisbane"),("2157161", "Montrose", "", "AU", "36", "", "07", "27450", "", "-37.81667", "145.35", "Australia/Melbourne"),("2157167", "Montmorency", "", "AU", "36", "", "07", "20660", "", "-37.71667", "145.11667", "Australia/Melbourne"),("2157343", "Moe", "Мои", "AU", "36", "", "07", "23810", "", "-38.17828", "146.26099", "Australia/Melbourne"),("2157373", "Mittagong", "", "AU", "36", "", "02", "18350", "", "-34.45002", "150.44572", "Australia/Sydney"),("2157410", "Mitcham", "", "AU", "36", "", "07", "26980", "", "-37.81667", "145.2", "Australia/Melbourne"),("2157495", "Miranda", "", "AU", "36", "", "02", "17150", "", "-34.03857", "151.10005", "Australia/Sydney"),("2157635", "Mill Park", "", "AU", "36", "", "07", "27070", "", "-37.66667", "145.06667", "Australia/Melbourne"),("2157652", "Millicent", "", "AU", "36", "", "05", "48340", "", "-37.59389", "140.34947", "Australia/Adelaide"),("2157698", "Mildura", "Милдьюра", "AU", "36", "", "07", "24780", "", "-34.18551", "142.16251", "Australia/Melbourne"),("2157995", "Merrylands", "", "AU", "36", "", "02", "13950", "", "-33.83333", "150.98333", "Australia/Sydney"),("2158020", "Merimbula", "", "AU", "36", "", "02", "10550", "", "-36.88901", "149.90961", "Australia/Sydney"),("2158051", "Mernda", "", "AU", "36", "", "07", "27070", "", "-37.60075", "145.09555", "Australia/Melbourne"),("2158109", "Mentone", "", "AU", "36", "", "07", "23430", "", "-37.98333", "145.06667", "Australia/Melbourne"),("2158130", "Menai", "", "AU", "36", "", "02", "17150", "", "-34.01667", "151.01667", "Australia/Sydney"),("2158145", "Melton South", "", "AU", "36", "", "07", "24650", "", "-37.70773", "144.57493", "Australia/Melbourne"),("2158151", "Melton", "Мелтон", "AU", "36", "", "07", "24650", "", "-37.68339", "144.58543", "Australia/Melbourne"),("2158177", "Melbourne", "Мельбурн", "AU", "36", "", "07", "24600", "", "-37.814", "144.96332", "Australia/Melbourne"),("2158220", "Medowie", "", "AU", "36", "", "02", "16400", "", "-32.7415", "151.8676", "Australia/Sydney"),("2158307", "McKinnon", "", "AU", "36", "", "07", "22310", "", "-37.91667", "145.05", "Australia/Melbourne"),("2158504", "Matraville", "", "AU", "36", "", "02", "16550", "", "-33.95", "151.23333", "Australia/Sydney"),("2158538", "Mascot", "", "AU", "36", "", "02", "11100", "", "-33.92598", "151.19347", "Australia/Sydney"),("2158561", "Maryborough", "", "AU", "36", "", "07", "21670", "", "-37.04562", "143.73923", "Australia/Melbourne"),("2158562", "Maryborough", "Мэриборо", "AU", "36", "", "04", "33220", "", "-25.54073", "152.70493", "Australia/Brisbane"),("2158626", "Marrickville", "", "AU", "36", "", "02", "15200", "", "-33.90318", "151.15176", "Australia/Sydney"),("2158651", "Maroubra", "", "AU", "36", "", "02", "16550", "", "-33.95", "151.23333", "Australia/Sydney"),("2158724", "Maribyrnong", "", "AU", "36", "", "07", "24330", "", "-37.78333", "144.88333", "Australia/Melbourne"),("2158745", "Margate", "", "AU", "36", "", "04", "35010", "", "-27.24761", "153.09809", "Australia/Brisbane"),("2158767", "Mareeba", "", "AU", "36", "", "04", "36810", "", "-16.99096", "145.42306", "Australia/Brisbane"),("2158867", "Manly", "", "AU", "36", "", "02", "15150", "", "-33.79798", "151.28826", "Australia/Sydney"),("2159045", "Maitland", "Мейтленд", "AU", "36", "", "02", "15050", "", "-32.73308", "151.5574", "Australia/Sydney"),("2159177", "Macleod", "", "AU", "36", "", "07", "20660", "", "-37.73333", "145.06667", "Australia/Melbourne"),("2159220", "Mackay", "Макей", "AU", "36", "", "04", "34770", "", "-21.15345", "149.16554", "Australia/Brisbane"),("2159291", "Lysterfield", "", "AU", "36", "", "07", "27450", "", "-37.93333", "145.3", "Australia/Melbourne"),("2159654", "Long Jetty", "", "AU", "36", "", "02", "18550", "", "-33.35795", "151.48135", "Australia/Sydney"),("2159851", "Liverpool", "", "AU", "36", "", "02", "12850", "", "-33.9", "150.93333", "Australia/Sydney"),("2160053", "Lithgow", "", "AU", "36", "", "02", "14870", "", "-33.48247", "150.13631", "Australia/Sydney"),("2160063", "Lismore", "Лизмор", "AU", "36", "", "02", "14850", "", "-28.81354", "153.2773", "Australia/Sydney"),("2160070", "Lisarow", "", "AU", "36", "", "02", "13100", "", "-33.38333", "151.36667", "Australia/Sydney"),("2160113", "Lindisfarne", "", "AU", "36", "", "06", "61410", "", "-42.84837", "147.36192", "Australia/Hobart"),("2160114", "Lindfield", "", "AU", "36", "", "02", "14500", "", "-33.78333", "151.16667", "Australia/Sydney"),("2160188", "Lilydale", "", "AU", "36", "", "07", "27450", "", "-37.75", "145.35", "Australia/Melbourne"),("2160258", "Lidcombe", "", "AU", "36", "", "02", "10200", "", "-33.86436", "151.0397", "Australia/Sydney"),("2160299", "Leumeah", "", "AU", "36", "", "02", "11500", "", "-34.05", "150.83333", "Australia/Sydney"),("2160336", "Leopold", "", "AU", "36", "", "07", "22750", "", "-38.19001", "144.46825", "Australia/Melbourne"),("2160386", "Leichhardt", "", "AU", "36", "", "02", "14800", "", "-33.88341", "151.15625", "Australia/Sydney"),("2160413", "Leeton", "", "AU", "36", "", "02", "14750", "", "-34.55105", "146.40483", "Australia/Sydney"),("2160493", "Lavington", "", "AU", "36", "", "02", "10050", "", "-36.03976", "146.93958", "Australia/Sydney"),("2160517", "Launceston", "Лонсестон", "AU", "36", "", "06", "64010", "", "-41.43876", "147.13467", "Australia/Hobart"),("2160560", "Lara", "", "AU", "36", "", "07", "22750", "", "-38.02388", "144.40617", "Australia/Melbourne"),("2160582", "Langwarrin", "", "AU", "36", "", "07", "22170", "", "-38.16667", "145.16667", "Australia/Melbourne"),("2160706", "Lalor", "", "AU", "36", "", "07", "27070", "", "-37.66667", "145.01667", "Australia/Melbourne"),("2160735", "Lakes Entrance", "", "AU", "36", "", "07", "22110", "", "-37.86679", "148.00159", "Australia/Melbourne"),("2160744", "Lakemba", "", "AU", "36", "", "02", "11550", "", "-33.91972", "151.07592", "Australia/Sydney"),("2160774", "Lake Albert", "", "AU", "36", "", "02", "17750", "", "-35.16667", "147.38333", "Australia/Sydney"),("2160910", "Kyabram", "", "AU", "36", "", "07", "21370", "", "-36.31335", "145.05035", "Australia/Melbourne"),("2160922", "Kurri Kurri", "", "AU", "36", "", "02", "11720", "", "-32.81933", "151.47908", "Australia/Sydney"),("2161311", "Kingston", "", "AU", "36", "", "06", "63610", "", "-42.97638", "147.30351", "Australia/Hobart"),("2161335", "Kingscliff", "", "AU", "36", "", "02", "17550", "", "-28.25983", "153.57816", "Australia/Sydney"),("2161376", "Kingaroy", "", "AU", "36", "", "04", "36630", "", "-26.53994", "151.8373", "Australia/Brisbane"),("2161408", "Kilsyth", "", "AU", "36", "", "07", "27450", "", "-37.8", "145.31667", "Australia/Melbourne"),("2161515", "Kiama", "", "AU", "36", "", "02", "14400", "", "-34.66828", "150.85219", "Australia/Sydney"),("2161532", "Keysborough", "", "AU", "36", "", "07", "22670", "", "-37.99116", "145.17385", "Australia/Melbourne"),("2161540", "Kew", "", "AU", "36", "", "07", "21110", "", "-37.80639", "145.03086", "Australia/Melbourne"),("2161602", "Kenthurst", "", "AU", "36", "", "02", "10500", "", "-33.65527", "151.00503", "Australia/Sydney"),("2161608", "Kensington", "", "AU", "36", "", "02", "16550", "", "-33.92019", "151.22241", "Australia/Sydney"),("2161609", "Kensington", "", "AU", "36", "", "07", "25060", "", "-37.78333", "144.93333", "Australia/Melbourne"),("2161613", "Kennington", "", "AU", "36", "", "07", "22620", "", "-36.78333", "144.3", "Australia/Melbourne"),("2161658", "Kempsey", "", "AU", "36", "", "02", "14350", "", "-31.07898", "152.83093", "Australia/Sydney"),("2161678", "Kelso", "", "AU", "36", "", "02", "10470", "", "-33.41667", "149.6", "Australia/Sydney"),("2161719", "Keilor", "", "AU", "36", "", "07", "21180", "", "-37.71667", "144.83333", "Australia/Melbourne"),("2161776", "Katoomba", "Катумба", "AU", "36", "", "02", "10900", "", "-33.71977", "150.30739", "Australia/Sydney"),("2161903", "Kangaroo Flat", "", "AU", "36", "", "07", "22620", "", "-36.8", "144.25", "Australia/Melbourne"),("2162419", "Jannali", "", "AU", "36", "", "02", "17150", "", "-34.01643", "151.06065", "Australia/Sydney"),("2162662", "Inverell", "", "AU", "36", "", "02", "14200", "", "-29.77403", "151.11166", "Australia/Sydney"),("2162683", "Innisfail", "", "AU", "36", "", "04", "32260", "", "-17.52209", "146.03102", "Australia/Brisbane"),("2162733", "Ingleburn", "", "AU", "36", "", "02", "11500", "", "-34", "150.86667", "Australia/Sydney"),("2162737", "Ingham", "", "AU", "36", "", "04", "33800", "", "-18.64552", "146.16248", "Australia/Brisbane"),("2162970", "Hughesdale", "", "AU", "36", "", "07", "24970", "", "-37.9", "145.08333", "Australia/Melbourne"),("2163055", "Horsham", "", "AU", "36", "", "07", "23190", "", "-36.71131", "142.19981", "Australia/Melbourne"),("2163137", "Hornsby", "", "AU", "36", "", "02", "14000", "", "-33.70244", "151.09931", "Australia/Sydney"),("2163355", "Hobart", "Хобарт", "AU", "36", "AU", "06", "62810", "", "-42.87936", "147.32941", "Australia/Hobart"),("2163472", "Highett", "", "AU", "36", "", "07", "23430", "", "-37.95", "145.05", "Australia/Melbourne"),("2163641", "Helensburgh", "", "AU", "36", "", "02", "18450", "", "-34.17836", "150.99522", "Australia/Sydney"),("2163653", "Heidelberg West", "", "AU", "36", "", "07", "20660", "", "-37.75", "145.03333", "Australia/Melbourne"),("2163654", "Heidelberg", "", "AU", "36", "", "07", "20660", "", "-37.75", "145.06667", "Australia/Melbourne"),("2163684", "Heathmont", "", "AU", "36", "", "07", "24410", "", "-37.83333", "145.25", "Australia/Melbourne"),("2163697", "Heathcote", "", "AU", "36", "", "02", "17150", "", "-34.0841", "151.01305", "Australia/Sydney"),("2163701", "Healesville", "", "AU", "36", "", "07", "27450", "", "-37.65395", "145.51718", "Australia/Melbourne"),("2163776", "Hawthorn South", "", "AU", "36", "", "07", "21110", "", "-37.8329", "145.0367", "Australia/Melbourne"),("2163837", "Hastings", "", "AU", "36", "", "07", "25340", "", "-38.3", "145.18333", "Australia/Melbourne"),("2163990", "Hampton Park", "", "AU", "36", "", "07", "21610", "", "-38.03333", "145.25", "Australia/Melbourne"),("2163994", "Hampton", "", "AU", "36", "", "07", "", "", "-37.95", "145", "Australia/Melbourne"),("2164025", "Hamilton", "", "AU", "36", "", "07", "26260", "", "-37.74425", "142.02202", "Australia/Melbourne"),("2164062", "Hallam", "", "AU", "36", "", "07", "21610", "", "-38.01667", "145.26667", "Australia/Melbourne"),("2164123", "Haberfield", "", "AU", "36", "", "02", "17200", "", "-33.88333", "151.2", "Australia/Sydney"),("2164129", "Gympie", "", "AU", "36", "", "04", "33620", "", "-26.18979", "152.66499", "Australia/Brisbane"),("2164206", "Gunnedah", "", "AU", "36", "", "02", "13550", "", "-30.98065", "150.25838", "Australia/Sydney"),("2164422", "Griffith", "Гриффит", "AU", "36", "", "02", "13450", "", "-34.28853", "146.05093", "Australia/Sydney"),("2164495", "Greenvale", "", "AU", "36", "", "07", "23270", "", "-37.63333", "144.86667", "Australia/Melbourne"),("2164515", "Greensborough", "", "AU", "36", "", "07", "20660", "", "-37.70462", "145.10302", "Australia/Melbourne"),("2164691", "Granville", "", "AU", "36", "", "02", "16250", "", "-33.83333", "151.01667", "Australia/Sydney"),("2164771", "Grafton", "", "AU", "36", "", "02", "11730", "", "-29.68104", "152.93394", "Australia/Sydney"),("2164837", "Goulburn", "Гулберн", "AU", "36", "", "02", "13310", "", "-34.75155", "149.72086", "Australia/Sydney"),("2164855", "Gorokan", "", "AU", "36", "", "02", "18550", "", "-33.25764", "151.5097", "Australia/Sydney"),("2164904", "Gordon", "", "AU", "36", "", "02", "11730", "", "-29.3", "152.71667", "Australia/Sydney"),("2164966", "Goonellabah", "", "AU", "36", "", "02", "14850", "", "-28.81667", "153.31667", "Australia/Sydney"),("2164972", "Goondiwindi", "", "AU", "36", "", "04", "33610", "", "-28.54709", "150.30546", "Australia/Brisbane"),("2165025", "Goodna", "", "AU", "36", "", "04", "33960", "", "-27.61046", "152.89896", "Australia/Brisbane"),("2165087", "Gold Coast", "Голд Коуст", "AU", "36", "", "04", "33430", "", "-28.00029", "153.43088", "Australia/Brisbane"),("2165200", "Glenroy", "", "AU", "36", "", "07", "25250", "", "-37.7", "144.93333", "Australia/Melbourne"),("2165229", "Glenorchy", "", "AU", "36", "", "06", "62610", "", "-42.83343", "147.27593", "Australia/Hobart"),("2165291", "Glen Innes", "", "AU", "36", "", "02", "13010", "", "-29.73485", "151.7385", "Australia/Sydney"),("2165303", "Glenhaven", "", "AU", "36", "", "02", "10500", "", "-33.7", "151", "Australia/Sydney"),("2165326", "Glenfield", "", "AU", "36", "", "02", "11500", "", "-33.96667", "150.9", "Australia/Sydney"),("2165329", "Glenferrie", "", "AU", "36", "", "07", "21110", "", "-37.83333", "145.05", "Australia/Melbourne"),("2165403", "Glenbrook", "", "AU", "36", "", "02", "10900", "", "-33.76667", "150.61667", "Australia/Sydney"),("2165478", "Gladstone", "Глэдстон", "AU", "36", "", "04", "33360", "", "-23.84852", "151.25775", "Australia/Brisbane"),("2165796", "Geelong West", "", "AU", "36", "", "07", "22750", "", "-38.13888", "144.34842", "Australia/Melbourne"),("2165798", "Geelong", "Джилонг", "AU", "36", "", "07", "22750", "", "-38.14711", "144.36069", "Australia/Melbourne"),("2165828", "Gatton", "", "AU", "36", "", "04", "34580", "", "-27.55873", "152.27618", "Australia/Brisbane"),("2166143", "Frankston East", "Френкстон", "AU", "36", "", "07", "22170", "", "-38.13333", "145.13333", "Australia/Melbourne"),("2166144", "Frankston", "", "AU", "36", "", "07", "22170", "", "-38.14458", "145.12291", "Australia/Melbourne"),("2166309", "Forster", "", "AU", "36", "", "02", "13400", "", "-32.18136", "152.51715", "Australia/Sydney"),("2166340", "Forest Hill", "", "AU", "36", "", "07", "26980", "", "-37.83333", "145.18333", "Australia/Melbourne"),("2166370", "Footscray", "", "AU", "36", "", "07", "24330", "", "-37.8", "144.9", "Australia/Melbourne"),("2166584", "Fitzroy", "", "AU", "36", "", "07", "27350", "", "-37.79839", "144.97833", "Australia/Melbourne"),("2166819", "Fawkner", "", "AU", "36", "", "07", "25250", "", "-37.71667", "144.96667", "Australia/Melbourne"),("2167208", "Essendon", "", "AU", "36", "", "07", "25060", "", "-37.76667", "144.91667", "Australia/Melbourne"),("2167279", "Epping", "", "AU", "36", "", "07", "27070", "", "-37.65", "145.03333", "Australia/Melbourne"),("2167280", "Epping", "", "AU", "36", "", "02", "16250", "", "-33.77271", "151.08184", "Australia/Sydney"),("2167312", "Engadine", "", "AU", "36", "", "02", "17150", "", "-34.06564", "151.01266", "Australia/Sydney"),("2167425", "Emerald", "", "AU", "36", "", "07", "21450", "", "-37.93167", "145.44093", "Australia/Melbourne"),("2167426", "Emerald", "", "AU", "36", "", "04", "32270", "", "-23.52296", "148.15784", "Australia/Brisbane"),("2167444", "Eltham North", "", "AU", "36", "", "07", "25710", "", "-37.7", "145.15", "Australia/Melbourne"),("2167445", "Eltham", "", "AU", "36", "", "07", "25710", "", "-37.73333", "145.15", "Australia/Melbourne"),("2167751", "Edithvale", "", "AU", "36", "", "07", "23430", "", "-38.03724", "145.10974", "Australia/Melbourne"),("2167817", "Echuca", "Ичука", "AU", "36", "", "07", "21370", "", "-36.14057", "144.75185", "Australia/Melbourne"),("2167869", "East Maitland", "", "AU", "36", "", "02", "15050", "", "-32.75", "151.58333", "Australia/Sydney"),("2167943", "East Ballina", "", "AU", "36", "", "02", "10250", "", "-28.86667", "153.58333", "Australia/Sydney"),("2167949", "Earlwood", "", "AU", "36", "", "02", "14150", "", "-33.95", "151.1", "Australia/Sydney"),("2168305", "Dubbo", "Даббо", "AU", "36", "", "02", "12600", "", "-32.24295", "148.60484", "Australia/Sydney"),("2168386", "Dromana", "", "AU", "36", "", "07", "25340", "", "-38.33375", "144.96458", "Australia/Melbourne"),("2168537", "Doreen", "", "AU", "36", "", "07", "25710", "", "-37.6", "145.15", "Australia/Melbourne"),("2168556", "Doonside", "", "AU", "36", "", "02", "10750", "", "-33.76667", "150.86667", "Australia/Sydney"),("2168579", "Donvale", "", "AU", "36", "", "07", "24210", "", "-37.7891", "145.17488", "Australia/Melbourne"),("2168605", "Doncaster East", "", "AU", "36", "", "07", "24210", "", "-37.78761", "145.14888", "Australia/Melbourne"),("2168607", "Doncaster", "", "AU", "36", "", "07", "24210", "", "-37.78828", "145.12373", "Australia/Melbourne"),("2168807", "Dingley Village", "", "AU", "36", "", "07", "23430", "", "-37.9827", "145.1342", "Australia/Melbourne"),("2168919", "Diamond Creek", "", "AU", "36", "", "07", "25710", "", "-37.66667", "145.15", "Australia/Melbourne"),("2168943", "Devonport", "Девонпорт", "AU", "36", "", "06", "61610", "", "-41.17695", "146.35152", "Australia/Hobart"),("2169018", "Derrimut", "", "AU", "36", "", "07", "21180", "", "-37.79238", "144.76994", "Australia/Melbourne"),("2169068", "Deniliquin", "", "AU", "36", "", "02", "12500", "", "-35.53245", "144.95364", "Australia/Sydney"),("2169145", "Deer Park", "", "AU", "36", "", "07", "21180", "", "-37.76667", "144.78333", "Australia/Melbourne"),("2169220", "Deception Bay", "", "AU", "36", "", "04", "35010", "", "-27.19354", "153.02631", "Australia/Brisbane"),("2169378", "Darlinghurst", "", "AU", "36", "", "02", "17200", "", "-33.87939", "151.21925", "Australia/Sydney"),("2169423", "Dapto", "", "AU", "36", "", "02", "18450", "", "-34.5", "150.78333", "Australia/Sydney"),("2169460", "Dandenong", "", "AU", "36", "", "07", "22670", "", "-37.98333", "145.2", "Australia/Melbourne"),("2169535", "Dalby", "", "AU", "36", "", "04", "37310", "", "-27.18169", "151.26205", "Australia/Brisbane"),("2169866", "Croydon North", "", "AU", "36", "", "07", "24410", "", "-37.78333", "145.3", "Australia/Melbourne"),("2169868", "Croydon", "", "AU", "36", "", "02", "10150", "", "-33.88333", "151.11667", "Australia/Sydney"),("2169956", "Cronulla", "", "AU", "36", "", "02", "17150", "", "-34.06251", "151.14961", "Australia/Sydney"),("2170078", "Cranbourne", "", "AU", "36", "", "07", "21610", "", "-38.1", "145.28333", "Australia/Melbourne"),("2170079", "Cranbourne", "", "AU", "36", "", "07", "21610", "", "-38.11342", "145.28326", "Australia/Melbourne"),("2170089", "Craigieburn", "", "AU", "36", "", "07", "23270", "", "-37.6", "144.95", "Australia/Melbourne"),("2170139", "Cowra", "", "AU", "36", "", "02", "12350", "", "-33.83554", "148.69663", "Australia/Sydney"),("2170253", "Corrimal", "", "AU", "36", "", "02", "18450", "", "-34.37864", "150.90356", "Australia/Sydney"),("2170260", "Corowa", "", "AU", "36", "", "02", "12300", "", "-35.99704", "146.38552", "Australia/Sydney"),("2170577", "Cooma", "", "AU", "36", "", "02", "12050", "", "-36.23517", "149.12408", "Australia/Sydney"),("2170581", "Coolum Beach", "", "AU", "36", "", "04", "36710", "", "-26.5283", "153.08809", "Australia/Brisbane"),("2170697", "Coogee", "", "AU", "36", "", "02", "16550", "", "-33.9205", "151.25522", "Australia/Sydney"),("2170852", "Concord", "", "AU", "36", "", "02", "11520", "", "-33.84722", "151.10381", "Australia/Sydney"),("2171000", "Collingwood", "", "AU", "36", "", "07", "27350", "", "-37.8", "144.98333", "Australia/Melbourne"),("2171069", "Colac", "", "AU", "36", "", "07", "21750", "", "-38.339", "143.58489", "Australia/Melbourne"),("2171085", "Coffs Harbour", "Кофс-Харбор", "AU", "36", "", "02", "11800", "", "-30.29626", "153.11351", "Australia/Sydney"),("2171168", "Coburg", "", "AU", "36", "", "07", "25250", "", "-37.75", "144.96667", "Australia/Melbourne"),("2171320", "Clifton Springs", "", "AU", "36", "", "07", "22750", "", "-38.1567", "144.5551", "Australia/Melbourne"),("2171324", "Clifton Hill", "", "AU", "36", "", "07", "27350", "", "-37.79798", "144.99533", "Australia/Melbourne"),("2171360", "Cleveland", "", "AU", "36", "", "04", "36250", "", "-27.52677", "153.26516", "Australia/Brisbane"),("2171395", "Clayton South", "", "AU", "36", "", "07", "23430", "", "-37.93333", "145.11667", "Australia/Melbourne"),("2171400", "Clayton", "", "AU", "36", "", "07", "24970", "", "-37.91667", "145.11667", "Australia/Melbourne"),("2171452", "Clarinda", "", "AU", "36", "", "07", "23430", "", "-37.93333", "145.11667", "Australia/Melbourne"),("2171476", "Claremont", "", "AU", "36", "", "06", "62610", "", "-42.78333", "147.25", "Australia/Hobart"),("2171507", "Wollongong", "Вуллонгонг", "AU", "36", "", "02", "18450", "", "-34.424", "150.89345", "Australia/Sydney"),("2171586", "Chipping Norton", "", "AU", "36", "", "02", "12850", "", "-33.9", "150.95", "Australia/Sydney"),("2171693", "Chelsea Heights", "", "AU", "36", "", "07", "23430", "", "-38.03333", "145.13333", "Australia/Melbourne"),("2171694", "Chelsea", "", "AU", "36", "", "07", "23430", "", "-38.05", "145.11667", "Australia/Melbourne"),("2171707", "Chatswood", "", "AU", "36", "", "02", "18250", "", "-33.8", "151.18333", "Australia/Sydney"),("2171722", "Charters Towers", "", "AU", "36", "", "04", "32310", "", "-20.07671", "146.26353", "Australia/Brisbane"),("2171766", "Charlestown", "", "AU", "36", "", "02", "14650", "", "-32.95", "151.66667", "Australia/Sydney"),("2171845", "Cessnock", "Сеснок", "AU", "36", "", "02", "11720", "", "-32.83211", "151.35623", "Australia/Sydney"),("2171945", "Caulfield North", "", "AU", "36", "", "07", "22310", "", "-37.8739", "145.02485", "Australia/Melbourne"),("2172106", "Castlemaine", "", "AU", "36", "", "07", "25430", "", "-37.06709", "144.21684", "Australia/Melbourne"),("2172111", "Castle Hill", "", "AU", "36", "", "02", "10500", "", "-33.73333", "151", "Australia/Sydney"),("2172153", "Casino", "", "AU", "36", "", "02", "16610", "", "-28.85819", "153.04748", "Australia/Sydney"),("2172191", "Carrum Downs", "", "AU", "36", "", "07", "22170", "", "-38.09968", "145.17248", "Australia/Melbourne"),("2172264", "Carnegie", "", "AU", "36", "", "07", "26350", "", "-37.88333", "145.06667", "Australia/Melbourne"),("2172289", "Carlton North", "", "AU", "36", "", "07", "27350", "", "-37.78333", "144.96667", "Australia/Melbourne"),("2172293", "Carlton", "", "AU", "36", "", "07", "24600", "", "-37.8", "144.96667", "Australia/Melbourne"),("2172303", "Carlingford", "", "AU", "36", "", "02", "16250", "", "-33.78269", "151.04888", "Australia/Sydney"),("2172311", "Caringbah", "", "AU", "36", "", "02", "17150", "", "-34.04726", "151.12051", "Australia/Sydney"),("2172517", "Canberra", "Канберра", "AU", "36", "", "01", "", "", "-35.28346", "149.12807", "Australia/Sydney"),("2172563", "Camperdown", "", "AU", "36", "", "02", "15200", "", "-33.88965", "151.17642", "Australia/Sydney"),("2172586", "Campbelltown", "", "AU", "36", "", "02", "11500", "", "-34.06667", "150.81667", "Australia/Sydney"),("2172607", "Campbellfield", "", "AU", "36", "", "07", "23270", "", "-37.68333", "144.95", "Australia/Melbourne"),("2172686", "Camberwell", "", "AU", "36", "", "07", "21110", "", "-37.84205", "145.0694", "Australia/Melbourne"),("2172710", "Caloundra", "Калундра", "AU", "36", "", "04", "36710", "", "-26.80346", "153.12195", "Australia/Brisbane"),("2172797", "Cairns", "Кернс", "AU", "36", "", "04", "32070", "", "-16.92304", "145.76625", "Australia/Brisbane"),("2172832", "Caboolture", "", "AU", "36", "", "04", "35010", "", "-27.08465", "152.9511", "Australia/Brisbane"),("2172880", "Byron Bay", "", "AU", "36", "", "02", "11350", "", "-28.64201", "153.61194", "Australia/Sydney"),("2172994", "Burwood East", "", "AU", "36", "", "07", "26980", "", "-37.85", "145.15", "Australia/Melbourne"),("2173099", "Burpengary", "", "AU", "36", "", "04", "35010", "", "-27.15746", "152.95758", "Australia/Brisbane"),("2173125", "Burnie", "Берни", "AU", "36", "", "06", "60610", "", "-41.05584", "145.90375", "Australia/Hobart"),("2173310", "Bundamba", "", "AU", "36", "", "04", "33960", "", "-27.60947", "152.81133", "Australia/Brisbane"),("2173323", "Bundaberg", "Бандаберг", "AU", "36", "", "04", "31820", "", "-24.86621", "152.3479", "Australia/Brisbane"),("2173445", "Bulli", "", "AU", "36", "", "02", "18450", "", "-34.33834", "150.91347", "Australia/Sydney"),("2173464", "Bulleen", "", "AU", "36", "", "07", "24210", "", "-37.76667", "145.08333", "Australia/Melbourne"),("2173605", "Buderim", "", "AU", "36", "", "04", "36710", "", "-26.68443", "153.05705", "Australia/Brisbane"),("2173734", "Brunswick West", "", "AU", "36", "", "07", "25250", "", "-37.76461", "144.94383", "Australia/Melbourne"),("2173739", "Brunswick East", "", "AU", "36", "", "07", "25250", "", "-37.77255", "144.97241", "Australia/Melbourne"),("2173741", "Brunswick", "", "AU", "36", "", "07", "25250", "", "-37.76667", "144.96667", "Australia/Melbourne"),("2173911", "Broken Hill", "Брокен-Хилл", "AU", "36", "", "02", "11250", "", "-31.9652", "141.4512", "Australia/Broken_Hill"),("2173964", "Broadmeadows", "", "AU", "36", "", "07", "23270", "", "-37.68015", "144.91877", "Australia/Melbourne"),("2174003", "Brisbane", "Брисбен", "AU", "36", "", "04", "31000", "", "-27.46794", "153.02809", "Australia/Brisbane"),("2174040", "Brighton", "", "AU", "36", "", "04", "31000", "", "-27.29582", "153.05721", "Australia/Brisbane"),("2174079", "Bridgewater", "", "AU", "36", "", "06", "60410", "", "-42.73719", "147.22784", "Australia/Hobart"),("2174360", "Box Hill", "", "AU", "36", "", "07", "26980", "", "-37.81887", "145.12545", "Australia/Melbourne"),("2174400", "Bowral", "", "AU", "36", "", "02", "18350", "", "-34.4775", "150.4204", "Australia/Sydney"),("2174444", "Bowen", "", "AU", "36", "", "04", "37340", "", "-20.01367", "148.24754", "Australia/Brisbane"),("2174563", "Botany", "", "AU", "36", "", "02", "11100", "", "-33.94599", "151.19591", "Australia/Sydney"),("2174580", "Boronia", "", "AU", "36", "", "07", "23670", "", "-37.86667", "145.28333", "Australia/Melbourne"),("2174933", "Bongaree", "", "AU", "36", "", "04", "35010", "", "-27.08367", "153.15942", "Australia/Brisbane"),("2174976", "Bomaderry", "", "AU", "36", "", "02", "16950", "", "-34.84967", "150.61093", "Australia/Sydney"),("2175341", "Blaxland", "", "AU", "36", "", "02", "10900", "", "-33.75", "150.6", "Australia/Sydney"),("2175403", "Blackwater", "", "AU", "36", "", "04", "32270", "", "-23.58351", "148.87912", "Australia/Brisbane"),("2175411", "Blacktown", "", "AU", "36", "", "02", "10750", "", "-33.76667", "150.91667", "Australia/Sydney"),("2175527", "Blackmans Bay", "", "AU", "36", "", "06", "63610", "", "-43.00311", "147.31694", "Australia/Hobart"),("2175819", "Biloela", "", "AU", "36", "", "04", "30370", "", "-24.39589", "150.51504", "Australia/Brisbane"),("2176031", "Berwick", "", "AU", "36", "", "07", "21610", "", "-38.03333", "145.35", "Australia/Melbourne"),("2176088", "Berkeley Vale", "", "AU", "36", "", "02", "18550", "", "-33.35", "151.43333", "Australia/Sydney"),("2176090", "Berkeley", "", "AU", "36", "", "02", "18450", "", "-34.48333", "150.85", "Australia/Sydney"),("2176123", "Bentleigh", "", "AU", "36", "", "07", "22310", "", "-37.91806", "145.03544", "Australia/Melbourne"),("2176187", "Bendigo", "Бендиго", "AU", "36", "", "07", "22620", "", "-36.75818", "144.28024", "Australia/Melbourne"),("2176225", "Benalla", "", "AU", "36", "", "07", "21010", "", "-36.55113", "145.98425", "Australia/Melbourne"),("2176412", "Beenleigh", "", "AU", "36", "", "04", "34590", "", "-27.71137", "153.2029", "Australia/Brisbane"),("2176487", "Beaumaris", "", "AU", "36", "", "07", "20910", "", "-37.98534", "145.03361", "Australia/Melbourne"),("2176566", "Bayswater", "", "AU", "36", "", "07", "23670", "", "-37.85", "145.26667", "Australia/Melbourne"),("2176592", "Baulkham Hills", "", "AU", "36", "", "02", "10500", "", "-33.75881", "150.99292", "Australia/Sydney"),("2176632", "Bathurst", "Бэтхерст", "AU", "36", "", "02", "10470", "", "-33.41665", "149.5806", "Australia/Sydney"),("2176639", "Batemans Bay", "", "AU", "36", "", "02", "12750", "", "-35.70658", "150.17541", "Australia/Sydney"),("2176934", "Banora Point", "", "AU", "36", "", "02", "17550", "", "-28.21298", "153.53634", "Australia/Sydney"),("2176947", "Bankstown", "", "AU", "36", "", "02", "10350", "", "-33.91667", "151.03333", "Australia/Sydney"),("2177026", "Balwyn", "", "AU", "36", "", "07", "21110", "", "-37.81667", "145.06667", "Australia/Melbourne"),("2177052", "Balmain", "", "AU", "36", "", "02", "14800", "", "-33.85481", "151.1833", "Australia/Sydney"),("2177069", "Ballina", "", "AU", "36", "", "02", "10250", "", "-28.86414", "153.56541", "Australia/Sydney"),("2177091", "Ballarat", "Балларат", "AU", "36", "", "07", "20570", "", "-37.56622", "143.84957", "Australia/Melbourne"),("2177114", "Balgowlah", "", "AU", "36", "", "02", "15150", "", "-33.79494", "151.2572", "Australia/Sydney"),("2177207", "Balaclava", "", "AU", "36", "", "07", "22310", "", "-37.86667", "145", "Australia/Melbourne"),("2177233", "Bairnsdale", "", "AU", "36", "", "07", "22110", "", "-37.82289", "147.61041", "Australia/Melbourne"),("2177394", "Bacchus Marsh", "", "AU", "36", "", "07", "25150", "", "-37.67268", "144.43829", "Australia/Melbourne"),("2177413", "Ayr", "", "AU", "36", "", "04", "31900", "", "-19.57393", "147.40666", "Australia/Brisbane"),("2177513", "Auburn", "", "AU", "36", "", "02", "10200", "", "-33.85", "151.03333", "Australia/Sydney"),("2177541", "Atherton", "", "AU", "36", "", "04", "36810", "", "-17.26864", "145.47522", "Australia/Brisbane"),("2177547", "Aspendale", "", "AU", "36", "", "07", "23430", "", "-38.02913", "145.10266", "Australia/Melbourne"),("2177565", "Ashfield", "", "AU", "36", "", "02", "10150", "", "-33.88834", "151.12274", "Australia/Sydney"),("2177571", "Ashburton", "", "AU", "36", "", "07", "21110", "", "-37.86667", "145.08333", "Australia/Melbourne"),("2177576", "Ascot Vale", "", "AU", "36", "", "07", "24600", "", "-37.78333", "144.91667", "Australia/Melbourne"),("2177626", "Artarmon", "", "AU", "36", "", "02", "18250", "", "-33.81667", "151.18333", "Australia/Sydney"),("2177671", "Armidale", "Армидейл", "AU", "36", "", "02", "10110", "", "-30.50828", "151.67123", "Australia/Sydney"),("2177756", "Ararat", "", "AU", "36", "", "07", "20260", "", "-37.28542", "142.92728", "Australia/Melbourne"),("2177992", "Altona", "", "AU", "36", "", "07", "23110", "", "-37.86964", "144.83036", "Australia/Melbourne"),("2178174", "Albury", "Олбери", "AU", "36", "", "02", "10050", "", "-36.07482", "146.92401", "Australia/Sydney"),("2178190", "Albert Park", "", "AU", "36", "", "07", "27350", "", "-37.83333", "145", "Australia/Melbourne"),("2205631", "Raymond Terrace", "", "AU", "36", "", "02", "16400", "", "-32.75", "151.75", "Australia/Sydney"),("2205969", "Gymea", "", "AU", "36", "", "02", "17150", "", "-34.03637", "151.08528", "Australia/Sydney"),("2205970", "Kirrawee", "", "AU", "36", "", "02", "17150", "", "-34.03831", "151.06903", "Australia/Sydney"),("2205979", "Gymea Bay", "", "AU", "36", "", "02", "17150", "", "-34.05209", "151.08795", "Australia/Sydney"),("2205999", "Brighton-Le-Sands", "", "AU", "36", "", "02", "16650", "", "-33.96009", "151.1511", "Australia/Sydney"),("2206003", "Blakehurst", "", "AU", "36", "", "02", "14450", "", "-33.99152", "151.10876", "Australia/Sydney"),("2206006", "Lugarno", "", "AU", "36", "", "02", "14150", "", "-33.98267", "151.04184", "Australia/Sydney"),("2206068", "New Town", "", "AU", "36", "", "06", "62810", "", "-42.85758", "147.30869", "Australia/Hobart"),("2206089", "Sandy Bay", "", "AU", "36", "", "06", "62810", "", "-42.89449", "147.32439", "Australia/Hobart"),("2206108", "Fairy Meadow", "", "AU", "36", "", "02", "18450", "", "-34.39303", "150.89275", "Australia/Sydney"),("2207259", "South Brisbane", "", "AU", "36", "", "04", "31000", "", "-27.48034", "153.02049", "Australia/Brisbane"),("2207330", "Scarborough", "", "AU", "36", "", "04", "35010", "", "-27.20118", "153.10939", "Australia/Brisbane"),("2207538", "Bonbeach", "", "AU", "36", "", "07", "23430", "", "-38.06528", "145.12278", "Australia/Melbourne"),("2207618", "Cheltenham", "", "AU", "36", "", "07", "20910", "", "-37.96944", "145.04806", "Australia/Melbourne"),("2207748", "Bellevue Hill", "", "AU", "36", "", "02", "18500", "", "-33.87899", "151.25101", "Australia/Sydney"),("2207753", "Paddington", "", "AU", "36", "", "02", "18500", "", "-33.88419", "151.23151", "Australia/Sydney"),("2207762", "Lilyfield", "", "AU", "36", "", "02", "14800", "", "-33.87499", "151.1653", "Australia/Sydney"),("2207783", "Drummoyne", "", "AU", "36", "", "02", "11520", "", "-33.85237", "151.15491", "Australia/Sydney"),("2207796", "Greenwich", "", "AU", "36", "", "02", "14700", "", "-33.83954", "151.183", "Australia/Sydney"),("2207809", "Hunters Hill", "", "AU", "36", "", "02", "14100", "", "-33.83432", "151.1459", "Australia/Sydney"),("2207822", "Cammeray", "", "AU", "36", "", "02", "15950", "", "-33.82132", "151.21609", "Australia/Sydney"),("2207880", "Neutral Bay", "", "AU", "36", "", "02", "15950", "", "-33.83784", "151.2175", "Australia/Sydney"),("2208285", "Randwick", "", "AU", "36", "", "02", "16550", "", "-33.91439", "151.24895", "Australia/Sydney"),("2208288", "Bronte", "", "AU", "36", "", "02", "18050", "", "-33.90198", "151.26556", "Australia/Sydney"),("2208290", "Bondi", "", "AU", "36", "", "02", "18050", "", "-33.89429", "151.26444", "Australia/Sydney"),("2208292", "Gladesville", "", "AU", "36", "", "02", "14100", "", "-33.83333", "151.13333", "Australia/Sydney"),("2208302", "Forestville", "", "AU", "36", "", "02", "18000", "", "-33.76667", "151.20833", "Australia/Sydney"),("2208305", "Dee Why", "", "AU", "36", "", "02", "18000", "", "-33.75", "151.3", "Australia/Sydney"),("2208313", "Umina", "", "AU", "36", "", "02", "13100", "", "-33.52314", "151.31325", "Australia/Sydney"),("6290236", "Airport West", "", "AU", "36", "", "07", "25060", "", "-37.7247", "144.88126", "Australia/Melbourne"),("6290241", "Gladstone Park", "", "AU", "36", "", "07", "23270", "", "-37.68742", "144.88675", "Australia/Melbourne"),("6301965", "Palmerston", "Палмерстон", "AU", "36", "", "03", "72800", "", "-12.48602", "130.9833", "Australia/Darwin"),("6533368", "Moranbah", "", "AU", "36", "", "04", "33980", "", "-22.00163", "148.04661", "Australia/Brisbane"),("6619483", "Kaleen", "", "AU", "36", "", "01", "", "", "-35.21814", "149.10516", "Australia/Sydney"),("6620339", "Karratha", "", "AU", "36", "", "08", "57560", "", "-20.73765", "116.84629", "Australia/Perth"),("6621336", "Hillarys", "", "AU", "36", "", "08", "54170", "", "-31.80698", "115.74045", "Australia/Perth"),("6621337", "Kingsford", "", "AU", "36", "", "02", "16550", "", "-33.92399", "151.22749", "Australia/Sydney"),("6621338", "Klemzig", "", "AU", "36", "", "05", "45890", "", "-34.87928", "138.63562", "Australia/Adelaide"),("6621340", "Maidstone", "", "AU", "36", "", "07", "24330", "", "-37.78035", "144.87353", "Australia/Melbourne"),("6621357", "Woollahra", "", "AU", "36", "", "02", "18500", "", "-33.8878", "151.23681", "Australia/Sydney"),("6690772", "Corlette", "", "AU", "36", "", "02", "16400", "", "-32.72014", "152.10846", "Australia/Sydney"),("6692248", "Howrah", "", "AU", "36", "", "06", "61410", "", "-42.88728", "147.40554", "Australia/Hobart"),("6693769", "North Narrabeen", "", "AU", "36", "", "02", "16370", "", "-33.70935", "151.29607", "Australia/Sydney"),("6695255", "Joondalup", "", "AU", "36", "", "08", "54170", "", "-31.74445", "115.76835", "Australia/Perth"),("6695266", "Como", "", "AU", "36", "", "08", "57840", "", "-31.99119", "115.86336", "Australia/Perth"),("6695559", "Arncliffe", "", "AU", "36", "", "02", "16650", "", "-33.93627", "151.14819", "Australia/Sydney"),("6697124", "East Lismore", "", "AU", "36", "", "02", "14850", "", "-28.82591", "153.2888", "Australia/Sydney"),("6697141", "Mindarie", "", "AU", "36", "", "08", "58760", "", "-31.68932", "115.70698", "Australia/Perth"),("6697150", "Clarkson", "", "AU", "36", "", "08", "58760", "", "-31.68282", "115.7247", "Australia/Perth"),("6697151", "Kinross", "", "AU", "36", "", "08", "54170", "", "-31.71868", "115.73839", "Australia/Perth"),("6697152", "Currambine", "", "AU", "36", "", "08", "54170", "", "-31.73306", "115.74766", "Australia/Perth"),("6697155", "Heathridge", "", "AU", "36", "", "08", "54170", "", "-31.76244", "115.75895", "Australia/Perth"),("6930431", "Freshwater", "", "AU", "36", "", "02", "18000", "", "-33.77867", "151.28569", "Australia/Sydney"),("6931018", "Taringa", "", "AU", "36", "", "04", "31000", "", "-27.49061", "152.97861", "Australia/Brisbane"),("6931021", "Inala", "", "AU", "36", "", "04", "31000", "", "-27.59715", "152.97432", "Australia/Brisbane"),("6941710", "Mount Lawley", "", "AU", "36", "", "08", "58570", "", "-31.93439", "115.8716", "Australia/Perth"),("6943454", "Paradise", "", "AU", "36", "", "05", "40910", "", "-34.87361", "138.66896", "Australia/Adelaide"),("6943474", "Athelstone", "", "AU", "36", "", "05", "40910", "", "-34.87019", "138.6999", "Australia/Adelaide"),("6943551", "Wooloowin", "", "AU", "36", "", "04", "31000", "", "-27.42244", "153.04204", "Australia/Brisbane"),("6943555", "Zillmere", "", "AU", "36", "", "04", "31000", "", "-27.35591", "153.04453", "Australia/Brisbane"),("6943556", "Taigum", "", "AU", "36", "", "04", "31000", "", "-27.34265", "153.04444", "Australia/Brisbane"),("6943558", "Bracken Ridge", "", "AU", "36", "", "04", "31000", "", "-27.3171", "153.03097", "Australia/Brisbane"),("6943579", "Windsor", "", "AU", "36", "", "04", "31000", "", "-27.43631", "153.02882", "Australia/Brisbane"),("6945028", "Bridegman Downs", "", "AU", "36", "", "04", "31000", "", "-27.35538", "152.99432", "Australia/Brisbane"),("6949377", "Canterbury", "", "AU", "36", "", "02", "11550", "", "-33.91192", "151.11862", "Australia/Sydney"),("6951440", "Tamborine Mountain", "", "AU", "36", "", "04", "36510", "", "-27.96954", "153.19937", "Australia/Brisbane"),("7281782", "North Ryde", "", "AU", "36", "", "02", "16700", "", "-33.79677", "151.12436", "Australia/Sydney"),("7281785", "Stirling", "", "AU", "36", "", "08", "57910", "", "-31.88343", "115.8099", "Australia/Perth"),("7281804", "North Melbourne", "", "AU", "36", "", "07", "24600", "", "-37.80289", "144.94816", "Australia/Melbourne"),("7281805", "Caroline Springs", "", "AU", "36", "", "07", "24650", "", "-37.74124", "144.73631", "Australia/Melbourne"),("7281807", "Hoppers Crossing", "", "AU", "36", "", "07", "27260", "", "-37.88264", "144.7003", "Australia/Melbourne"),("7281823", "Rouse Hill", "", "AU", "36", "", "02", "10750", "", "-33.68207", "150.9154", "Australia/Sydney"),("7281838", "Logan City", "", "AU", "36", "", "04", "34590", "", "-27.63917", "153.10944", "Australia/Brisbane"),("7281839", "Carindale", "", "AU", "36", "", "04", "31000", "", "-27.50578", "153.10236", "Australia/Brisbane"),("7281840", "Paramatta", "", "AU", "36", "", "02", "16250", "", "-33.8178", "151.00348", "Australia/Sydney"),("7281850", "Ferntree Gully", "", "AU", "36", "", "07", "23670", "", "-37.88461", "145.29539", "Australia/Melbourne"),("7302259", "City of Parramatta", "", "AU", "36", "", "02", "16250", "", "-33.81667", "151", "Australia/Sydney"),("7302624", "Phillip Island", "", "AU", "36", "", "07", "20740", "", "-38.48349", "145.23102", "Australia/Melbourne"),("7302625", "Springwood", "", "AU", "36", "", "04", "34590", "", "-27.61183", "153.12899", "Australia/Brisbane"),("7302628", "Adelaide Hills", "", "AU", "36", "", "05", "40120", "", "-34.91119", "138.70735", "Australia/Adelaide"),("7302631", "Canning Vale", "", "AU", "36", "", "08", "51330", "", "-32.05799", "115.91814", "Australia/Perth"),("7302634", "Varsity Lakes", "", "AU", "36", "", "04", "33430", "", "-28.0894", "153.4122", "Australia/Brisbane"),("7302638", "Oxenford", "", "AU", "36", "", "04", "33430", "", "-27.89033", "153.31309", "Australia/Brisbane"),("7302640", "Toormina", "", "AU", "36", "", "02", "11800", "", "-30.35384", "153.08843", "Australia/Sydney"),("7302642", "Glenmore Park", "", "AU", "36", "", "02", "16350", "", "-33.79068", "150.6693", "Australia/Sydney"),("7302683", "Southbank", "", "AU", "36", "", "07", "24600", "", "-37.8228", "144.96434", "Australia/Melbourne"),("7303250", "St Kilda East", "", "AU", "36", "", "07", "25900", "", "-37.86594", "145.00018", "Australia/Melbourne"),("7521471", "Docklands", "", "AU", "36", "", "07", "24600", "", "-37.8149", "144.95052", "Australia/Melbourne"),("7932573", "Melton West", "", "AU", "36", "", "07", "24650", "", "-37.67852", "144.56883", "Australia/Melbourne"),("7932575", "Kurunjang", "", "AU", "36", "", "07", "24650", "", "-37.67587", "144.5969", "Australia/Melbourne"),("7932611", "Ashwood", "", "AU", "36", "", "07", "24970", "", "-37.86659", "145.10553", "Australia/Melbourne"),("7932612", "Glen Iris", "", "AU", "36", "", "07", "26350", "", "-37.85995", "145.05489", "Australia/Melbourne"),("7932618", "Caulfield North", "", "AU", "36", "", "07", "22310", "", "-37.87255", "145.02262", "Australia/Melbourne"),("7932619", "Elsternwick", "", "AU", "36", "", "07", "22310", "", "-37.88441", "145.00434", "Australia/Melbourne"),("7932620", "Elwood", "", "AU", "36", "", "07", "25900", "", "-37.88214", "144.98215", "Australia/Melbourne"),("7932622", "Burwood", "", "AU", "36", "", "07", "26980", "", "-37.84978", "145.11901", "Australia/Melbourne"),("7932623", "Box Hill South", "", "AU", "36", "", "07", "26980", "", "-37.83236", "145.12098", "Australia/Melbourne"),("7932624", "Blackburn", "", "AU", "36", "", "07", "26980", "", "-37.81901", "145.15326", "Australia/Melbourne"),("7932625", "Canterbury", "", "AU", "36", "", "07", "21110", "", "-37.8247", "145.08476", "Australia/Melbourne"),("7932627", "Hawthorn East", "", "AU", "36", "", "07", "21110", "", "-37.82484", "145.0464", "Australia/Melbourne"),("7932628", "Kew East", "", "AU", "36", "", "07", "21110", "", "-37.79758", "145.05378", "Australia/Melbourne"),("7932629", "Balwyn North", "", "AU", "36", "", "07", "21110", "", "-37.79086", "145.09386", "Australia/Melbourne"),("7932630", "Mont Albert North", "", "AU", "36", "", "07", "26980", "", "-37.80043", "145.10828", "Australia/Melbourne"),("7932631", "Box Hill North", "", "AU", "36", "", "07", "26980", "", "-37.80266", "145.12656", "Australia/Melbourne"),("7932632", "Blackburn North", "", "AU", "36", "", "07", "26980", "", "-37.80931", "145.1518", "Australia/Melbourne"),("7932634", "Blackburn South", "", "AU", "36", "", "07", "26980", "", "-37.83975", "145.15549", "Australia/Melbourne"),("7932635", "Chadstone", "", "AU", "36", "", "07", "24970", "", "-37.88766", "145.09519", "Australia/Melbourne"),("7932638", "Malvern East", "", "AU", "36", "", "07", "26350", "", "-37.87397", "145.04253", "Australia/Melbourne"),("7932640", "Oakleigh South", "", "AU", "36", "", "07", "24970", "", "-37.92416", "145.09146", "Australia/Melbourne"),("7932643", "Caulfield South", "", "AU", "36", "", "07", "22310", "", "-37.89562", "145.02597", "Australia/Melbourne"),("7932646", "Brighton East", "", "AU", "36", "", "07", "20910", "", "-37.90232", "145.01734", "Australia/Melbourne"),("7932652", "Black Rock", "", "AU", "36", "", "07", "20910", "", "-37.97357", "145.01636", "Australia/Melbourne"),("7932653", "Aspendale Gardens", "", "AU", "36", "", "07", "23430", "", "-38.02277", "145.11798", "Australia/Melbourne"),("7932654", "Booval", "", "AU", "36", "", "04", "33960", "", "-27.61328", "152.78944", "Australia/Brisbane"),("7932659", "Brassall", "", "AU", "36", "", "04", "33960", "", "-27.59753", "152.74755", "Australia/Brisbane"),("7932664", "Raceview", "", "AU", "36", "", "04", "33960", "", "-27.63472", "152.77519", "Australia/Brisbane"),("7932666", "Flinders View", "", "AU", "36", "", "04", "33960", "", "-27.65046", "152.77451", "Australia/Brisbane"),("7932670", "Redbank Plains", "", "AU", "36", "", "04", "33960", "", "-27.64613", "152.85965", "Australia/Brisbane"),("7932671", "Collingwood Park", "", "AU", "36", "", "04", "33960", "", "-27.61282", "152.86008", "Australia/Brisbane"),("7932687", "Clontarf", "", "AU", "36", "", "04", "35010", "", "-27.25341", "153.07835", "Australia/Brisbane"),("8014922", "Ballarat Central", "", "AU", "36", "", "07", "20570", "", "-37.56206", "143.85082", "Australia/Melbourne"),("8015209", "St Albans", "", "AU", "36", "", "07", "21180", "", "-37.74496", "144.80049", "Australia/Melbourne"),("8029813", "Eleebana", "", "AU", "36", "", "02", "14650", "", "-32.9896", "151.63642", "Australia/Sydney"),("8029814", "Summer Hill", "", "AU", "36", "", "02", "10150", "", "-33.89146", "151.13825", "Australia/Sydney"),("8298607", "Altona North", "", "AU", "36", "", "07", "23110", "", "-37.83487", "144.84735", "Australia/Melbourne"),("8299269", "Balcatta", "", "AU", "36", "", "08", "57910", "", "-31.87501", "115.82839", "Australia/Perth"),("8299578", "Belmont", "", "AU", "36", "", "08", "50490", "", "-31.9435", "115.9255", "Australia/Perth"),("8310668", "Bateau Bay", "", "AU", "36", "", "02", "18550", "", "-33.38334", "151.46671", "Australia/Sydney"),("8335007", "East Perth", "", "AU", "36", "", "08", "57080", "", "-31.95872", "115.87109", "Australia/Perth"),("8335327", "Alexandria", "", "AU", "36", "", "02", "17200", "", "-33.90219", "151.20037", "Australia/Sydney"),("8347324", "Doveton", "", "AU", "36", "", "07", "21610", "", "-37.99346", "145.23891", "Australia/Melbourne"),("8347325", "Endeavour Hills", "", "AU", "36", "", "07", "21610", "", "-37.97695", "145.25866", "Australia/Melbourne"),("8347750", "Tapping", "", "AU", "36", "", "08", "58760", "", "-31.71947", "115.79559", "Australia/Perth"),("8347847", "Taylors Lakes", "", "AU", "36", "", "07", "21180", "", "-37.69863", "144.78631", "Australia/Melbourne"),("8347891", "Woodvale", "", "AU", "36", "", "08", "54170", "", "-31.78928", "115.79676", "Australia/Perth"),("8347896", "Roxburgh Park", "", "AU", "36", "", "07", "23270", "", "-37.62581", "144.92555", "Australia/Melbourne"),("8347945", "Beeliar", "", "AU", "36", "", "08", "51820", "", "-32.13339", "115.80637", "Australia/Perth"),("8347982", "Lynbrook", "", "AU", "36", "", "07", "21610", "", "-38.05588", "145.25615", "Australia/Melbourne"),("8348078", "Wyndham Vale", "", "AU", "36", "", "07", "27260", "", "-37.8415", "144.54101", "Australia/Melbourne"),("8348101", "Willetton", "", "AU", "36", "", "08", "51330", "", "-32.05251", "115.88782", "Australia/Perth"),("8348173", "Carramar", "", "AU", "36", "", "08", "58760", "", "-31.69023", "115.77159", "Australia/Perth"),("8348266", "Alexander Heights", "", "AU", "36", "", "08", "58760", "", "-31.82758", "115.86501", "Australia/Perth"),("8348306", "Delahey", "", "AU", "36", "", "07", "21180", "", "-37.7198", "144.77732", "Australia/Melbourne"),("8348314", "Wilson", "", "AU", "36", "", "08", "51330", "", "-32.02058", "115.91181", "Australia/Perth"),("8348326", "Butler", "", "AU", "36", "", "08", "58760", "", "-31.64298", "115.70431", "Australia/Perth");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("8348333", "Darch", "", "AU", "36", "", "08", "58760", "", "-31.81255", "115.8458", "Australia/Perth"),("8348392", "Innaloo", "", "AU", "36", "", "08", "57910", "", "-31.89272", "115.79508", "Australia/Perth"),("8348406", "Booragoon", "", "AU", "36", "", "08", "55320", "", "-32.03945", "115.83369", "Australia/Perth"),("8348424", "Seville Grove", "", "AU", "36", "", "08", "50210", "", "-32.13645", "115.98905", "Australia/Perth"),("8348442", "Murrumba Downs", "", "AU", "36", "", "04", "35010", "", "-27.26733", "153.01053", "Australia/Brisbane"),("8348488", "Knoxfield", "", "AU", "36", "", "07", "23670", "", "-37.88978", "145.24962", "Australia/Melbourne"),("8348536", "Little Mountain", "", "AU", "36", "", "04", "36710", "", "-26.78436", "153.09218", "Australia/Brisbane"),("8348565", "Glendenning", "", "AU", "36", "", "02", "10750", "", "-33.7483", "150.85411", "Australia/Sydney"),("8348655", "Padbury", "", "AU", "36", "", "08", "54170", "", "-31.80645", "115.7688", "Australia/Perth"),("8348675", "East Victoria Park", "", "AU", "36", "", "08", "58510", "", "-31.98894", "115.90388", "Australia/Perth"),("8348699", "Palmyra", "", "AU", "36", "", "08", "55320", "", "-32.04502", "115.78589", "Australia/Perth"),("8348779", "Bell Park", "", "AU", "36", "", "07", "22750", "", "-38.10793", "144.33839", "Australia/Melbourne"),("8348813", "Golden Square", "", "AU", "36", "", "07", "22620", "", "-36.77265", "144.25271", "Australia/Melbourne"),("8348815", "Annerley", "", "AU", "36", "", "04", "31000", "", "-27.51228", "153.03248", "Australia/Brisbane"),("8348836", "Dulwich Hill", "", "AU", "36", "", "02", "15200", "", "-33.9041", "151.13945", "Australia/Sydney"),("8348843", "Viewbank", "", "AU", "36", "", "07", "20660", "", "-37.73991", "145.09323", "Australia/Melbourne"),("8348898", "Chirnside Park", "", "AU", "36", "", "07", "27450", "", "-37.7386", "145.31431", "Australia/Melbourne"),("8348967", "Meadow Heights", "", "AU", "36", "", "07", "23270", "", "-37.65117", "144.91855", "Australia/Melbourne"),("8349002", "Westminster", "", "AU", "36", "", "08", "57910", "", "-31.86744", "115.83919", "Australia/Perth"),("8349024", "Bibra Lake", "", "AU", "36", "", "08", "51820", "", "-32.09764", "115.81921", "Australia/Perth"),("8349071", "Kardinya", "", "AU", "36", "", "08", "55320", "", "-32.06561", "115.81483", "Australia/Perth"),("8349072", "Karrinyup", "", "AU", "36", "", "08", "57910", "", "-31.87233", "115.77684", "Australia/Perth"),("8349075", "Kewdale", "", "AU", "36", "", "08", "50490", "", "-31.97886", "115.95159", "Australia/Perth"),("8349092", "Ocean Reef", "", "AU", "36", "", "08", "54170", "", "-31.75871", "115.73601", "Australia/Perth"),("8349098", "Port Kennedy", "", "AU", "36", "", "08", "57490", "", "-32.37342", "115.7515", "Australia/Perth"),("8349100", "Secret Harbour", "", "AU", "36", "", "08", "57490", "", "-32.40589", "115.75852", "Australia/Perth"),("8349105", "Tuart Hill", "", "AU", "36", "", "08", "57910", "", "-31.89808", "115.83495", "Australia/Perth"),("8349108", "Thornlie", "", "AU", "36", "", "08", "53780", "", "-32.06003", "115.955", "Australia/Perth"),("8349115", "Winthrop", "", "AU", "36", "", "08", "55320", "", "-32.05216", "115.82972", "Australia/Perth"),("8349117", "Yangebup", "", "AU", "36", "", "08", "51820", "", "-32.12065", "115.81623", "Australia/Perth"),("8349118", "Yokine", "", "AU", "36", "", "08", "57910", "", "-31.90113", "115.85319", "Australia/Perth"),("8349243", "Hillside", "", "AU", "36", "", "07", "24650", "", "-37.69047", "144.74172", "Australia/Melbourne"),("8349257", "Wavell Heights", "", "AU", "36", "", "04", "31000", "", "-27.39385", "153.04698", "Australia/Brisbane"),("8349364", "Braybrook", "", "AU", "36", "", "07", "24330", "", "-37.78671", "144.85484", "Australia/Melbourne"),("8349376", "Cairnlea", "", "AU", "36", "", "07", "21180", "", "-37.75931", "144.78781", "Australia/Melbourne"),("8349381", "Bundoora", "", "AU", "36", "", "07", "20660", "", "-37.69825", "145.05967", "Australia/Melbourne"),("8349399", "Patterson Lakes", "", "AU", "36", "", "07", "23430", "", "-38.06934", "145.14327", "Australia/Melbourne"),("8349439", "Skye", "", "AU", "36", "", "07", "22170", "", "-38.10505", "145.2163", "Australia/Melbourne"),("8436118", "Beaumont Hills", "", "AU", "36", "", "02", "10500", "", "-33.69993", "150.9411", "Australia/Sydney"),("8469169", "North Adelaide", "", "AU", "36", "", "05", "40070", "", "-34.90733", "138.59141", "Australia/Adelaide"),("8478275", "Victoria Park", "", "AU", "36", "", "08", "58510", "", "-31.97619", "115.90525", "Australia/Perth"),("8555644", "Bondi Junction", "", "AU", "36", "", "02", "18050", "", "-33.89275", "151.24723", "Australia/Sydney"),("8556202", "Bald Hills", "", "AU", "36", "", "04", "31000", "", "-27.32112", "153.00857", "Australia/Brisbane"),("8629873", "Beecroft", "", "AU", "36", "", "02", "14000", "", "-33.74954", "151.0648", "Australia/Sydney"),("9172072", "Lane Cove North", "", "AU", "36", "", "02", "18250", "", "-33.80543", "151.16638", "Australia/Sydney"),("9883890", "Ascot", "", "AU", "36", "", "04", "31000", "", "-27.43154", "153.058", "Australia/Brisbane"),("9957323", "Chermside West", "", "AU", "36", "", "04", "31000", "", "-27.38383", "153.01586", "Australia/Brisbane"),("9957324", "Everton Park", "", "AU", "36", "", "04", "31000", "", "-27.40732", "152.9884", "Australia/Brisbane"),("9957327", "Stafford", "", "AU", "36", "", "04", "31000", "", "-27.41044", "153.01105", "Australia/Brisbane"),("9957328", "Stafford Heights", "", "AU", "36", "", "04", "31000", "", "-27.39354", "153.0105", "Australia/Brisbane"),("9957340", "Forest Lake", "", "AU", "36", "", "04", "31000", "", "-27.62563", "152.96883", "Australia/Brisbane"),("9957342", "Greenslopes", "", "AU", "36", "", "04", "31000", "", "-27.50815", "153.04951", "Australia/Brisbane"),("9957346", "Mansfield", "", "AU", "36", "", "04", "31000", "", "-27.53929", "153.09895", "Australia/Brisbane"),("9957347", "Mount Gravatt East", "", "AU", "36", "", "04", "31000", "", "-27.5405", "153.08221", "Australia/Brisbane"),("9957350", "Sunnybank Hills", "", "AU", "36", "", "04", "31000", "", "-27.61025", "153.05388", "Australia/Brisbane"),("9957351", "Upper Mount Gravatt", "", "AU", "36", "", "04", "31000", "", "-27.56128", "153.08453", "Australia/Brisbane"),("9957353", "Yeronga", "", "AU", "36", "", "04", "31000", "", "-27.51571", "153.01642", "Australia/Brisbane"),("9957444", "Camp Hill", "", "AU", "36", "", "04", "31000", "", "-27.49354", "153.07629", "Australia/Brisbane"),("9957521", "Manly West", "", "AU", "36", "", "04", "31000", "", "-27.47382", "153.16641", "Australia/Brisbane"),("9957543", "Morningside", "", "AU", "36", "", "04", "31000", "", "-27.46165", "153.07511", "Australia/Brisbane"),("9957637", "Wynnum West", "", "AU", "36", "", "04", "31000", "", "-27.45824", "153.15319", "Australia/Brisbane"),("9957703", "Springfield", "", "AU", "36", "", "04", "33960", "", "-27.65365", "152.91716", "Australia/Brisbane"),("9958114", "Rochedale South", "", "AU", "36", "", "04", "34590", "", "-27.59521", "153.12332", "Australia/Brisbane"),("9958129", "Waterford West", "", "AU", "36", "", "04", "34590", "", "-27.69056", "153.13319", "Australia/Brisbane"),("9958153", "Ferny Hills", "", "AU", "36", "", "04", "35010", "", "-27.39594", "152.93737", "Australia/Brisbane"),("9958500", "Samford Valley", "", "AU", "36", "", "04", "35010", "", "-27.3727", "152.86699", "Australia/Brisbane"),("9972408", "Flemington", "", "AU", "36", "", "07", "25060", "", "-37.78825", "144.93001", "Australia/Melbourne"),("9972411", "Fairfield", "", "AU", "36", "", "07", "21890", "", "-37.77977", "145.01764", "Australia/Melbourne"),("9972412", "Heidelberg Heights", "", "AU", "36", "", "07", "20660", "", "-37.74313", "145.05695", "Australia/Melbourne"),("9972415", "Westmeadows", "", "AU", "36", "", "07", "23270", "", "-37.67604", "144.88701", "Australia/Melbourne"),("9972422", "Keilor East", "", "AU", "36", "", "07", "25060", "", "-37.73261", "144.86504", "Australia/Melbourne"),("9972423", "Coburg North", "", "AU", "36", "", "07", "25250", "", "-37.72867", "144.96134", "Australia/Melbourne"),("9972464", "Hadfield", "", "AU", "36", "", "07", "25250", "", "-37.70728", "144.9416", "Australia/Melbourne"),("9972465", "Oak Park", "", "AU", "36", "", "07", "25250", "", "-37.71842", "144.91945", "Australia/Melbourne"),("9972466", "Pascoe Vale South", "", "AU", "36", "", "07", "25250", "", "-37.73973", "144.94615", "Australia/Melbourne"),("9972470", "Bayswater North", "", "AU", "36", "", "07", "24410", "", "-37.82612", "145.29831", "Australia/Melbourne"),("9972471", "Croydon Hills", "", "AU", "36", "", "07", "24410", "", "-37.77651", "145.26355", "Australia/Melbourne"),("9972487", "Vermont South", "", "AU", "36", "", "07", "26980", "", "-37.85747", "145.1827", "Australia/Melbourne"),("9972515", "Cranbourne East", "", "AU", "36", "", "07", "21610", "", "-38.11531", "145.29814", "Australia/Melbourne"),("9972516", "Cranbourne North", "", "AU", "36", "", "07", "21610", "", "-38.08292", "145.27805", "Australia/Melbourne"),("9972517", "Cranbourne West", "", "AU", "36", "", "07", "21610", "", "-38.0965", "145.26707", "Australia/Melbourne"),("9972518", "Narre Warren South", "", "AU", "36", "", "07", "21610", "", "-38.04369", "145.2923", "Australia/Melbourne"),("9972522", "Dandenong North", "", "AU", "36", "", "07", "22670", "", "-37.96649", "145.2081", "Australia/Melbourne"),("9972524", "Noble Park North", "", "AU", "36", "", "07", "22670", "", "-37.94978", "145.19257", "Australia/Melbourne"),("9972526", "Frankston North", "", "AU", "36", "", "07", "22170", "", "-38.12352", "145.14836", "Australia/Melbourne"),("9972527", "Frankston South", "", "AU", "36", "", "07", "22170", "", "-38.16604", "145.13643", "Australia/Melbourne"),("9972569", "Keilor Downs", "", "AU", "36", "", "07", "21180", "", "-37.72337", "144.80839", "Australia/Melbourne"),("9972577", "Sunshine North", "", "AU", "36", "", "07", "21180", "", "-37.76987", "144.82787", "Australia/Melbourne"),("9972578", "Sunshine West", "", "AU", "36", "", "07", "21180", "", "-37.79117", "144.81637", "Australia/Melbourne"),("9972579", "Altona Meadows", "", "AU", "36", "", "07", "23110", "", "-37.88413", "144.78367", "Australia/Melbourne"),("9972583", "West Footscray", "", "AU", "36", "", "07", "24330", "", "-37.79746", "144.87727", "Australia/Melbourne"),("9972586", "Taylors Hill", "", "AU", "36", "", "07", "24650", "", "-37.70988", "144.75483", "Australia/Melbourne"),("9972597", "Allambie Heights", "", "AU", "36", "", "02", "18000", "", "-33.76655", "151.24981", "Australia/Sydney"),("9972601", "Belfield", "", "AU", "36", "", "02", "11550", "", "-33.90354", "151.08467", "Australia/Sydney"),("9972602", "Berala", "", "AU", "36", "", "02", "10200", "", "-33.87197", "151.03386", "Australia/Sydney"),("9972604", "Berowra Heights", "", "AU", "36", "", "02", "14000", "", "-33.61211", "151.13754", "Australia/Sydney"),("9972618", "Bondi Beach", "", "AU", "36", "", "02", "18050", "", "-33.89079", "151.27852", "Australia/Sydney"),("9972621", "Cabramatta West", "", "AU", "36", "", "02", "12850", "", "-33.89669", "150.91056", "Australia/Sydney"),("9972622", "Cambridge Park", "", "AU", "36", "", "02", "16350", "", "-33.74784", "150.72208", "Australia/Sydney"),("9972625", "Caringbah South", "", "AU", "36", "", "02", "17150", "", "-34.05662", "151.12149", "Australia/Sydney"),("9972648", "Concord West", "", "AU", "36", "", "02", "11520", "", "-33.84809", "151.08609", "Australia/Sydney"),("9972670", "Ermington", "", "AU", "36", "", "02", "16250", "", "-33.81483", "151.05467", "Australia/Sydney"),("9972671", "Fairfield East", "", "AU", "36", "", "02", "12850", "", "-33.86938", "150.97129", "Australia/Sydney"),("9972672", "Fairfield Heights", "", "AU", "36", "", "02", "12850", "", "-33.86445", "150.93884", "Australia/Sydney"),("9972673", "Fairlight", "", "AU", "36", "", "02", "15150", "", "-33.79575", "151.27346", "Australia/Sydney"),("9972707", "Harris Park", "", "AU", "36", "", "02", "16250", "", "-33.82285", "151.00781", "Australia/Sydney"),("9972759", "Hornsby Heights", "", "AU", "36", "", "02", "14000", "", "-33.6713", "151.09428", "Australia/Sydney"),("9972778", "Killara", "", "AU", "36", "", "02", "14500", "", "-33.76604", "151.16213", "Australia/Sydney"),("9972786", "Kingswood Park", "", "AU", "36", "", "02", "16350", "", "-33.76651", "150.7144", "Australia/Sydney"),("9972815", "Macquarie Park", "", "AU", "36", "", "02", "16700", "", "-33.775", "151.11248", "Australia/Sydney"),("9972821", "Marsfield", "", "AU", "36", "", "02", "16700", "", "-33.77784", "151.10574", "Australia/Sydney"),("9972832", "Narellan Vale", "", "AU", "36", "", "02", "11450", "", "-34.04974", "150.74392", "Australia/Sydney"),("9972833", "Narraweena", "", "AU", "36", "", "02", "18000", "", "-33.75519", "151.27659", "Australia/Sydney"),("9972847", "North Bondi", "", "AU", "36", "", "02", "18050", "", "-33.88787", "151.28075", "Australia/Sydney"),("9972937", "South Coogee", "", "AU", "36", "", "02", "16550", "", "-33.93106", "151.25599", "Australia/Sydney"),("9972943", "South Windsor", "", "AU", "36", "", "02", "13800", "", "-33.61808", "150.80443", "Australia/Sydney"),("9972945", "Stanhope Gardens", "", "AU", "36", "", "02", "10750", "", "-33.72206", "150.92597", "Australia/Sydney"),("9972948", "Telopea", "", "AU", "36", "", "02", "16250", "", "-33.79279", "151.03858", "Australia/Sydney"),("9972964", "West Pennant", "", "AU", "36", "", "02", "10500", "", "-33.7457", "151.04764", "Australia/Sydney"),("9972965", "West Ryde", "", "AU", "36", "", "02", "16700", "", "-33.80543", "151.07386", "Australia/Sydney"),("9972972", "Wollstonecraft", "", "AU", "36", "", "02", "15950", "", "-33.8328", "151.18981", "Australia/Sydney"),("9973091", "Henley Beach", "", "AU", "36", "", "05", "41060", "", "-34.92029", "138.49442", "Australia/Adelaide"),("10035407", "City Beach", "", "AU", "36", "", "08", "51310", "", "-31.9344", "115.76174", "Australia/Perth"),("10055413", "Kallaroo", "", "AU", "36", "", "08", "54170", "", "-31.79098", "115.75298", "Australia/Perth"),("10056968", "Mount Pleasant", "", "AU", "36", "", "08", "55320", "", "-32.03974", "115.84993", "Australia/Perth"),("10056976", "Parmelia", "", "AU", "36", "", "08", "54830", "", "-32.25784", "115.82208", "Australia/Perth"),("10056984", "Rivervale", "", "AU", "36", "", "08", "50490", "", "-31.95546", "115.91306", "Australia/Perth"),("10057011", "South Lake", "", "AU", "36", "", "08", "51820", "", "-32.11125", "115.83873", "Australia/Perth"),("10057017", "Wembley Downs", "", "AU", "36", "", "08", "57910", "", "-31.91169", "115.77358", "Australia/Perth"),("10062591", "West Moonah", "", "AU", "36", "", "06", "62610", "", "-42.84996", "147.28181", "Australia/Hobart"),("10063050", "Burleigh Waters", "", "AU", "36", "", "04", "33430", "", "-28.09975", "153.42463", "Australia/Brisbane"),("10103846", "Elermore Vale", "", "AU", "36", "", "02", "15900", "", "-32.91621", "151.67665", "Australia/Sydney"),("10103855", "Mayfield", "", "AU", "36", "", "02", "15900", "", "-32.89793", "151.73613", "Australia/Sydney"),("10103878", "Belmont North", "", "AU", "36", "", "02", "14650", "", "-33.02081", "151.66849", "Australia/Sydney"),("10103951", "Toronto", "", "AU", "36", "", "02", "14650", "", "-33.01357", "151.59373", "Australia/Sydney"),("10108696", "Albion Park Rail", "", "AU", "36", "", "02", "16900", "", "-34.56123", "150.79675", "Australia/Sydney"),("10108731", "Barrack Heights", "", "AU", "36", "", "02", "16900", "", "-34.56601", "150.85516", "Australia/Sydney"),("10109423", "Cordeaux Heights", "", "AU", "36", "", "02", "18450", "", "-34.44043", "150.83748", "Australia/Sydney"),("10110993", "Hamlyn Heights", "", "AU", "36", "", "07", "22750", "", "-38.12108", "144.32799", "Australia/Melbourne"),("10114292", "Tweed Heads West", "", "AU", "36", "", "02", "17550", "", "-28.18736", "153.52278", "Australia/Sydney"),("10114318", "Rangeville", "", "AU", "36", "", "04", "36910", "", "-27.58318", "151.97997", "Australia/Brisbane"),("10114319", "Darling Heights", "", "AU", "36", "", "04", "36910", "", "-27.59659", "151.93045", "Australia/Brisbane"),("10114321", "East Toowoomba", "", "AU", "36", "", "04", "36910", "", "-27.57086", "151.97422", "Australia/Brisbane"),("10114338", "South Tamworth", "", "AU", "36", "", "02", "17310", "", "-31.11", "150.92254", "Australia/Sydney"),("10116056", "East Albury", "", "AU", "36", "", "02", "10050", "", "-36.08144", "146.92991", "Australia/Sydney"),("10116099", "North Albury", "", "AU", "36", "", "02", "10050", "", "-36.05745", "146.92995", "Australia/Sydney"),("11073472", "Marangaroo", "", "AU", "36", "", "08", "58760", "", "-31.82711", "115.83843", "Australia/Perth"),("146858", "Sharur City", "", "AZ", "31", "", "35", "147997", "", "39.55298", "44.97993", "Asia/Baku"),("146862", "Prishibinskoye", "", "AZ", "31", "", "15", "", "", "39.11817", "48.59255", "Asia/Baku"),("146901", "Zangilan", "", "AZ", "31", "", "69", "", "", "39.0884", "46.6513", "Asia/Baku"),("146958", "Yaycı", "", "AZ", "31", "", "35", "148132", "", "38.94052", "45.73244", "Asia/Baku"),("146961", "Yardımlı", "", "AZ", "31", "", "66", "", "", "38.90771", "48.24052", "Asia/Baku"),("146969", "Novyy Karanlug", "", "AZ", "31", "", "65", "", "", "39.79546", "47.10989", "Asia/Baku"),("146970", "Xankandi", "Степанакерт", "AZ", "31", "", "61", "", "", "39.8177", "46.7528", "Asia/Baku"),("147059", "Əhmədbəyli", "Tel’mankend", "AZ", "31", "", "45", "", "", "39.87867", "48.39901", "Asia/Baku"),("147105", "Shushi", "Шуша", "AZ", "31", "", "55", "", "", "39.76006", "46.74989", "Asia/Baku"),("147271", "Salyan", "Сальян", "AZ", "31", "", "49", "", "", "39.59621", "48.98479", "Asia/Baku"),("147288", "Saatlı", "Саатлы", "AZ", "31", "", "45", "", "", "39.93214", "48.36892", "Asia/Baku"),("147305", "Qubadlı", "", "AZ", "31", "", "43", "", "", "39.34441", "46.58183", "Asia/Baku"),("147368", "Ordubad", "", "AZ", "31", "", "35", "147365", "", "38.90961", "46.02274", "Asia/Baku"),("147425", "Neftçala", "Нефтечала", "AZ", "31", "", "36", "", "", "39.3768", "49.247", "Asia/Baku"),("147429", "Nakhchivan", "Нахичевань", "AZ", "31", "", "35", "7669114", "", "39.20889", "45.41222", "Asia/Baku"),("147504", "Mincivan", "", "AZ", "31", "", "69", "", "", "39.03058", "46.7214", "Asia/Baku"),("147552", "Masally", "", "AZ", "31", "", "32", "", "", "39.03532", "48.6654", "Asia/Baku"),("147611", "Lerik", "", "AZ", "31", "", "31", "", "", "38.77388", "48.41497", "Asia/Baku"),("147622", "Lankaran", "Ленкорань", "AZ", "31", "", "29", "", "", "38.75428", "48.85062", "Asia/Baku"),("147625", "Laçın", "", "AZ", "31", "", "28", "", "", "39.59881", "46.55045", "Asia/Baku"),("147774", "Xocalı", "", "AZ", "31", "", "64", "", "", "39.91297", "46.79028", "Asia/Baku"),("147982", "Imishli", "Имишли", "AZ", "31", "", "24", "", "", "39.87095", "48.05995", "Asia/Baku"),("148106", "Fizuli", "Физули", "AZ", "31", "", "18", "", "", "39.60094", "47.14529", "Asia/Baku"),("148141", "Jebrail", "", "AZ", "31", "", "14", "", "", "39.39917", "47.02835", "Asia/Baku"),("148177", "Dünyamalılar", "", "AZ", "31", "AZ", "12", "", "", "39.77278", "47.75889", "Asia/Baku"),("148251", "Culfa", "", "AZ", "31", "", "35", "148132", "", "38.95397", "45.62961", "Asia/Baku"),("148290", "Dzhalilabad", "", "AZ", "31", "", "15", "", "", "39.20963", "48.49186", "Asia/Baku"),("148291", "Cahri", "", "AZ", "31", "", "35", "7669114", "", "39.34837", "45.41557", "Asia/Baku"),("148323", "Boradigah", "", "AZ", "31", "", "32", "", "", "38.93013", "48.7092", "Asia/Baku"),("148340", "Pushkino", "", "AZ", "31", "", "13", "", "", "39.45833", "48.545", "Asia/Baku"),("148354", "Beylagan", "", "AZ", "31", "", "12", "", "", "39.77556", "47.61861", "Asia/Baku"),("148375", "Severo-Vostotchnyi Bank", "", "AZ", "31", "", "36", "", "", "39.41117", "49.24792", "Asia/Baku"),("148445", "Astara", "Астара", "AZ", "31", "", "08", "", "", "38.45598", "48.87498", "Asia/Baku"),("148565", "Şirvan", "Ширван", "AZ", "31", "", "07", "", "", "39.93778", "48.929", "Asia/Baku"),("148619", "Ağdam", "Агдам", "AZ", "31", "", "03", "", "", "39.99096", "46.92736", "Asia/Baku"),("393927", "Avşar", "", "AZ", "31", "AZ", "02", "", "", "39.97389", "47.42389", "Asia/Baku"),("584562", "Zyrya", "", "AZ", "31", "", "09", "", "", "40.36613", "50.29198", "Asia/Baku"),("584586", "Zardob", "", "AZ", "31", "", "71", "", "", "40.21991", "47.70997", "Asia/Baku"),("584596", "Zaqatala", "Закаталы", "AZ", "31", "", "70", "", "", "41.6316", "46.64479", "Asia/Baku"),("584614", "Zabrat", "Забрат", "AZ", "31", "", "09", "", "", "40.47746", "49.94174", "Asia/Baku"),("584649", "Yevlakh", "Евлах", "AZ", "31", "", "68", "", "", "40.61832", "47.15014", "Asia/Baku"),("584715", "Xudat", "", "AZ", "31", "", "60", "", "", "41.63052", "48.68161", "Asia/Baku"),("584716", "Yelenendorf", "Гёйгёль", "AZ", "31", "", "62", "", "", "40.58584", "46.3189", "Asia/Baku"),("584717", "Xaçmaz", "Хачмас", "AZ", "31", "", "60", "", "", "41.46426", "48.80565", "Asia/Baku"),("584791", "Ujar", "Уджары", "AZ", "31", "", "59", "", "", "40.51902", "47.65423", "Asia/Baku"),("584792", "Türkan", "", "AZ", "31", "", "09", "", "", "40.3646", "50.22075", "Asia/Baku"),("584821", "Tovuz", "", "AZ", "31", "", "58", "", "", "40.99249", "45.62838", "Asia/Baku"),("584871", "Terter", "Тертер", "AZ", "31", "", "57", "", "", "40.34179", "46.93242", "Asia/Baku"),("584923", "Sumqayıt", "Сумгаит", "AZ", "31", "", "54", "", "", "40.58972", "49.66861", "Asia/Baku"),("584954", "Kyzyl-Burun", "", "AZ", "31", "", "53", "", "", "41.07754", "49.11257", "Asia/Baku"),("585103", "Qaraçuxur", "Гарачухур", "AZ", "31", "", "09", "", "", "40.39667", "49.97361", "Asia/Baku"),("585145", "Saray", "", "AZ", "31", "", "01", "", "", "40.53299", "49.71681", "Asia/Baku"),("585152", "Shamkhor", "Шамкир", "AZ", "31", "", "51", "", "", "40.82975", "46.0178", "Asia/Baku"),("585156", "Shamakhi", "Шемаха", "AZ", "31", "", "50", "", "", "40.63141", "48.64137", "Asia/Baku"),("585170", "Sheki", "Шеки", "AZ", "31", "", "48", "", "", "41.19194", "47.17056", "Asia/Baku"),("585177", "Samux", "", "AZ", "31", "", "52", "", "", "40.76485", "46.40868", "Asia/Baku"),("585184", "Sabunçu", "Сабунчи", "AZ", "31", "", "09", "", "", "40.4425", "49.94806", "Asia/Baku"),("585187", "Sabirabad", "Сабирабад", "AZ", "31", "", "46", "", "", "40.00869", "48.47701", "Asia/Baku"),("585220", "Qusar", "Кусары", "AZ", "31", "", "44", "", "", "41.4275", "48.4302", "Asia/Baku"),("585221", "Quba", "Куба", "AZ", "31", "", "42", "", "", "41.36108", "48.51341", "Asia/Baku"),("585223", "Qobustan", "", "AZ", "31", "", "09", "", "", "40.08238", "49.41205", "Asia/Baku"),("585225", "Hacıqabul", "Кази-Магомед", "AZ", "31", "", "23", "", "", "40.03874", "48.94286", "Asia/Baku"),("585226", "Qazax", "Казах", "AZ", "31", "", "40", "", "", "41.09246", "45.36561", "Asia/Baku"),("585227", "Qax", "", "AZ", "31", "", "39", "", "", "41.41826", "46.92043", "Asia/Baku"),("585231", "Qutqashen", "", "AZ", "31", "", "38", "", "", "40.98247", "47.84909", "Asia/Baku"),("585333", "Oğuz", "", "AZ", "31", "", "37", "", "", "41.07128", "47.46528", "Asia/Baku"),("585379", "Hacı Zeynalabdin", "", "AZ", "31", "", "54", "", "", "40.62333", "49.55861", "Asia/Baku"),("585388", "Nardaran", "", "AZ", "31", "", "09", "", "", "40.55611", "50.00556", "Asia/Baku"),("585400", "Naftalan", "", "AZ", "31", "", "34", "", "", "40.50821", "46.8203", "Asia/Baku"),("585514", "Mingelchaur", "Мингечаур", "AZ", "31", "", "33", "", "", "40.76395", "47.05953", "Asia/Baku"),("585557", "Maştağa", "Маштага", "AZ", "31", "", "09", "", "", "40.52983", "50.00616", "Asia/Baku"),("585568", "Mardakan", "Мардакян", "AZ", "31", "", "09", "", "", "40.49182", "50.14292", "Asia/Baku"),("585570", "Qobustan", "", "AZ", "31", "", "41", "", "", "40.5336", "48.92819", "Asia/Baku"),("585630", "Lökbatan", "Локбатан", "AZ", "31", "", "09", "", "", "40.3256", "49.73376", "Asia/Baku"),("585666", "Qızılhacılı", "", "AZ", "31", "", "21", "", "", "40.57362", "46.849", "Asia/Baku"),("585763", "Kyurdarmir", "Кюрдамир", "AZ", "31", "", "27", "", "", "40.34532", "48.15085", "Asia/Baku"),("585838", "Qobu", "", "AZ", "31", "", "01", "", "", "40.40472", "49.71306", "Asia/Baku"),("585909", "Khyzy", "", "AZ", "31", "", "63", "", "", "40.90576", "49.08127", "Asia/Baku"),("585915", "Khirdalan", "Хырдалан", "AZ", "31", "", "01", "", "", "40.44808", "49.75502", "Asia/Baku"),("585940", "Khodzhi-Gasan", "", "AZ", "31", "", "09", "", "", "40.41293", "49.76904", "Asia/Baku"),("586135", "Qarayeri", "", "AZ", "31", "", "52", "", "", "40.78825", "46.3072", "Asia/Baku"),("586268", "Kerbakhiar", "", "AZ", "31", "", "26", "", "", "40.10984", "46.04446", "Asia/Baku"),("586318", "İsmayıllı", "", "AZ", "31", "", "25", "", "", "40.78485", "48.15141", "Asia/Baku"),("586340", "Yeni Suraxanı", "", "AZ", "31", "", "09", "", "", "40.43026", "50.03598", "Asia/Baku"),("586427", "Geoktschai", "Геокчай", "AZ", "31", "", "22", "", "", "40.65055", "47.74219", "Asia/Baku"),("586429", "Hövsan", "Говсан", "AZ", "31", "", "09", "", "", "40.37444", "50.08528", "Asia/Baku"),("586430", "Goranboy", "", "AZ", "31", "", "21", "", "", "40.61028", "46.78972", "Asia/Baku"),("586523", "Ganja", "Гянджа", "AZ", "31", "", "20", "", "", "40.68278", "46.36056", "Asia/Baku"),("586573", "Kyadabek", "", "AZ", "31", "", "19", "", "", "40.57055", "45.81229", "Asia/Baku"),("586631", "Corat", "", "AZ", "31", "", "54", "", "", "40.57176", "49.70509", "Asia/Baku"),("586652", "Ceyranbatan", "", "AZ", "31", "", "01", "", "", "40.54194", "49.66073", "Asia/Baku"),("586692", "Dzagam", "", "AZ", "31", "", "51", "", "", "40.9033", "45.88564", "Asia/Baku"),("586763", "Divichibazar", "Дивичи", "AZ", "31", "", "17", "", "", "41.20117", "48.98712", "Asia/Baku"),("586765", "Yukhary-Dashkesan", "", "AZ", "31", "", "16", "", "", "40.52393", "46.08186", "Asia/Baku"),("586845", "Çinarlı", "", "AZ", "31", "", "39", "", "", "41.46965", "46.91582", "Asia/Baku"),("586925", "Buzovna", "Бузовна", "AZ", "31", "", "09", "", "", "40.51903", "50.11438", "Asia/Baku"),("586967", "Binagadi", "", "AZ", "31", "", "09", "", "", "40.46602", "49.82783", "Asia/Baku"),("586968", "Biny Selo", "Бина", "AZ", "31", "", "09", "", "", "40.45076", "50.08686", "Asia/Baku"),("586971", "Bilajer", "", "AZ", "31", "", "09", "", "", "40.56441", "50.04002", "Asia/Baku"),("587057", "Barda", "Барда", "AZ", "31", "", "11", "", "", "40.37577", "47.12619", "Asia/Baku"),("587070", "Belokany", "", "AZ", "31", "", "10", "", "", "41.72626", "46.40478", "Asia/Baku"),("587071", "Balakhani", "", "AZ", "31", "", "09", "", "", "40.46344", "49.91893", "Asia/Baku"),("587078", "Bilajari", "", "AZ", "31", "", "09", "", "", "40.4444", "49.80566", "Asia/Baku"),("587084", "Baku", "Баку", "AZ", "31", "", "09", "", "", "40.37767", "49.89201", "Asia/Baku"),("587207", "Pirallahı", "", "AZ", "31", "", "09", "", "", "40.47013", "50.32476", "Asia/Baku"),("587261", "Amirdzhan", "", "AZ", "31", "", "09", "", "", "40.42639", "49.98361", "Asia/Baku"),("587319", "Aliabad", "", "AZ", "31", "", "70", "", "", "41.4829", "46.63483", "Asia/Baku"),("587361", "Aghsu", "Ахсу", "AZ", "31", "", "06", "", "", "40.57028", "48.40087", "Asia/Baku"),("587362", "Aghstafa", "", "AZ", "31", "", "05", "", "", "41.11889", "45.45389", "Asia/Baku"),("587378", "Ağdaş", "Агдаш", "AZ", "31", "", "04", "", "", "40.64699", "47.4738", "Asia/Baku"),("587379", "Martakert", "", "AZ", "31", "", "57", "", "", "40.21238", "46.82086", "Asia/Baku"),("587384", "Agdzhabedy", "Агджабеди", "AZ", "31", "", "02", "", "", "40.05015", "47.45937", "Asia/Baku"),("824003", "Bakıxanov", "Бакиханова", "AZ", "31", "", "09", "", "", "40.41894", "49.96693", "Asia/Baku"),("824050", "Aran", "", "AZ", "31", "", "67", "", "", "40.62528", "46.97556", "Asia/Baku"),("863732", "Ramana", "", "AZ", "31", "", "09", "", "", "40.44222", "49.98056", "Asia/Baku"),("863761", "Badamdar", "", "AZ", "31", "", "09", "", "", "40.34024", "49.8045", "Asia/Baku"),("3186246", "Zvornik", "", "BA", "70", "", "02", "", "", "44.38605", "19.10247", "Europe/Sarajevo"),("3186423", "Živinice", "", "BA", "70", "", "01", "", "", "44.44929", "18.64978", "Europe/Sarajevo"),("3186567", "Žepče", "", "BA", "70", "", "01", "", "", "44.42667", "18.03778", "Europe/Sarajevo"),("3186573", "Zenica", "Зеница", "BA", "70", "", "01", "", "", "44.20169", "17.90397", "Europe/Sarajevo"),("3186588", "Željezno Polje", "", "BA", "70", "", "01", "", "", "44.39875", "17.94103", "Europe/Sarajevo"),("3186717", "Zavidovići", "", "BA", "70", "", "01", "", "", "44.44583", "18.14972", "Europe/Sarajevo"),("3187162", "Vrnograč", "", "BA", "70", "", "01", "", "", "45.16369", "15.95444", "Europe/Sarajevo"),("3187464", "Vogošća", "", "BA", "70", "", "01", "", "", "43.90225", "18.34438", "Europe/Sarajevo"),("3187590", "Vitez", "", "BA", "70", "", "01", "", "", "44.15424", "17.79009", "Europe/Sarajevo"),("3187609", "Visoko", "Високо", "BA", "70", "", "01", "", "", "43.98889", "18.17806", "Europe/Sarajevo"),("3187681", "Višegrad", "", "BA", "70", "", "02", "", "", "43.7826", "19.29256", "Europe/Sarajevo"),("3188199", "Velika Obarska", "", "BA", "70", "", "02", "", "", "44.80461", "19.16183", "Europe/Sarajevo"),("3188225", "Velika Kladuša", "Велика-Кладуша", "BA", "70", "", "01", "", "", "45.18497", "15.80579", "Europe/Sarajevo"),("3188357", "Varoška Rijeka", "", "BA", "70", "", "01", "", "", "45.08936", "16.01906", "Europe/Sarajevo"),("3188366", "Vareš", "", "BA", "70", "", "01", "", "", "44.16444", "18.32833", "Europe/Sarajevo"),("3188582", "Tuzla", "Тузла", "BA", "70", "", "01", "", "", "44.53842", "18.66709", "Europe/Sarajevo"),("3188691", "Tržačka Raštela", "", "BA", "70", "", "01", "", "", "44.97597", "15.78489", "Europe/Sarajevo"),("3188817", "Trn", "", "BA", "70", "", "02", "", "", "44.85829", "17.23583", "Europe/Sarajevo"),("3188893", "Trebinje", "Требинье", "BA", "70", "", "02", "", "", "42.71197", "18.34362", "Europe/Sarajevo"),("3188924", "Travnik", "Травник", "BA", "70", "", "01", "", "", "44.22637", "17.66583", "Europe/Sarajevo"),("3189046", "Tojšići", "", "BA", "70", "", "01", "", "", "44.50133", "18.78523", "Europe/Sarajevo"),("3189143", "Teslić", "", "BA", "70", "", "02", "", "", "44.60639", "17.85972", "Europe/Sarajevo"),("3189146", "Tešanj", "", "BA", "70", "", "01", "", "", "44.61191", "17.98552", "Europe/Sarajevo"),("3189602", "Šturlić", "", "BA", "70", "", "01", "", "", "45.06389", "15.77806", "Europe/Sarajevo"),("3189823", "Stolac", "", "BA", "70", "", "01", "", "", "43.084", "17.95995", "Europe/Sarajevo"),("3189884", "Stijena", "", "BA", "70", "", "01", "", "", "44.9363", "16.02224", "Europe/Sarajevo"),("3190158", "Srebrenik", "", "BA", "70", "", "01", "", "", "44.70819", "18.48834", "Europe/Sarajevo"),("3190172", "Srbac", "", "BA", "70", "", "02", "", "", "45.0973", "17.52331", "Europe/Sarajevo"),("3190385", "Sokolac", "", "BA", "70", "", "02", "", "", "43.93817", "18.80079", "Europe/Sarajevo"),("3190733", "Kneževo", "", "BA", "70", "", "02", "", "", "44.49071", "17.38161", "Europe/Sarajevo"),("3190837", "Šipovo", "", "BA", "70", "", "02", "", "", "44.28237", "17.08597", "Europe/Sarajevo"),("3191156", "Šekovići", "", "BA", "70", "", "02", "", "", "44.29896", "18.85532", "Europe/Sarajevo"),("3191281", "Sarajevo", "Сараево", "BA", "70", "", "01", "3343737", "", "43.84864", "18.35644", "Europe/Sarajevo"),("3191297", "Sanski Most", "", "BA", "70", "", "01", "", "", "44.7667", "16.667", "Europe/Sarajevo"),("3191302", "Sanica", "", "BA", "70", "", "01", "", "", "44.61354", "16.64062", "Europe/Sarajevo"),("3191589", "Rodoč", "", "BA", "70", "", "01", "", "", "43.31453", "17.8029", "Europe/Sarajevo"),("3192236", "Novi Travnik", "", "BA", "70", "", "01", "", "", "44.17133", "17.65816", "Europe/Sarajevo"),("3192279", "Prozor", "", "BA", "70", "", "01", "", "", "43.82222", "17.60917", "Europe/Sarajevo"),("3192327", "Prnjavor", "", "BA", "70", "", "02", "", "", "44.87021", "17.66256", "Europe/Sarajevo"),("3192409", "Prijedor", "Приедора", "BA", "70", "", "02", "", "", "44.97991", "16.71401", "Europe/Sarajevo"),("3192653", "Potoci", "", "BA", "70", "", "01", "", "", "43.40953", "17.87855", "Europe/Sarajevo"),("3192878", "Podzvizd", "", "BA", "70", "", "01", "", "", "45.17417", "15.87361", "Europe/Sarajevo"),("3193008", "Podhum", "", "BA", "70", "", "01", "", "", "43.72295", "16.99887", "Europe/Sarajevo"),("3193542", "Pećigrad", "", "BA", "70", "", "01", "", "", "45.05444", "15.89694", "Europe/Sarajevo"),("3193692", "Pale", "", "BA", "70", "", "02", "", "", "43.81664", "18.56949", "Europe/Sarajevo"),("3193776", "Otoka", "", "BA", "70", "", "01", "", "", "44.96", "16.17917", "Europe/Sarajevo"),("3193821", "Ostrožac", "", "BA", "70", "", "01", "", "", "44.90866", "15.94045", "Europe/Sarajevo"),("3194061", "Orahovica Donja", "", "BA", "70", "", "01", "", "", "44.65345", "18.36951", "Europe/Sarajevo"),("3194120", "Omarska", "", "BA", "70", "", "02", "", "", "44.8917", "16.89814", "Europe/Sarajevo"),("3194199", "Odžak", "", "BA", "70", "", "01", "", "", "45.02461", "18.32107", "Europe/Sarajevo"),("3194510", "Nevesinje", "", "BA", "70", "", "02", "", "", "43.25861", "18.11333", "Europe/Sarajevo"),("3194724", "Mrkonjić Grad", "", "BA", "70", "", "02", "", "", "44.41729", "17.08288", "Europe/Sarajevo"),("3194828", "Mostar", "Мостар", "BA", "70", "", "01", "3343740", "", "43.34333", "17.80806", "Europe/Sarajevo"),("3195066", "Mionica", "", "BA", "70", "", "01", "", "", "44.86646", "18.46603", "Europe/Sarajevo"),("3195128", "Milići", "", "BA", "70", "", "02", "", "", "44.17016", "19.09195", "Europe/Sarajevo"),("3195839", "Mala Kladuša", "", "BA", "70", "", "01", "", "", "45.13443", "15.85217", "Europe/Sarajevo"),("3195930", "Mahala", "", "BA", "70", "", "01", "", "", "44.01194", "18.25528", "Europe/Sarajevo"),("3195946", "Maglaj", "", "BA", "70", "", "01", "", "", "44.54771", "18.10003", "Europe/Sarajevo"),("3196324", "Ljubuški", "", "BA", "70", "", "01", "", "", "43.19694", "17.545", "Europe/Sarajevo"),("3196410", "Livno", "", "BA", "70", "", "01", "", "", "43.82695", "17.00746", "Europe/Sarajevo"),("3196428", "Široki Brijeg", "", "BA", "70", "", "01", "", "", "43.3829", "17.59416", "Europe/Sarajevo"),("3196792", "Laktaši", "", "BA", "70", "", "02", "", "", "44.90857", "17.30135", "Europe/Sarajevo"),("3197532", "Kotor Varoš", "", "BA", "70", "", "02", "", "", "44.61831", "17.37204", "Europe/Sarajevo"),("3198050", "Ključ", "", "BA", "70", "", "01", "", "", "44.53251", "16.77682", "Europe/Sarajevo"),("3198126", "Kladanj", "", "BA", "70", "", "01", "", "", "44.22669", "18.69274", "Europe/Sarajevo"),("3198138", "Kiseljak", "", "BA", "70", "", "01", "", "", "43.94295", "18.08132", "Europe/Sarajevo"),("3198462", "Kalenderovci Donji", "", "BA", "70", "", "02", "", "", "44.94673", "17.83785", "Europe/Sarajevo"),("3198490", "Kakanj", "", "BA", "70", "", "01", "", "", "44.13311", "18.12292", "Europe/Sarajevo"),("3198895", "Janja", "", "BA", "70", "", "02", "", "", "44.66554", "19.24691", "Europe/Sarajevo"),("3198934", "Jajce", "", "BA", "70", "", "01", "", "", "44.34203", "17.27059", "Europe/Sarajevo"),("3199142", "Ilijaš", "", "BA", "70", "", "01", "", "", "43.95128", "18.27128", "Europe/Sarajevo"),("3199438", "Hadžići", "", "BA", "70", "", "01", "", "", "43.82222", "18.20667", "Europe/Sarajevo"),("3199525", "Gromiljak", "", "BA", "70", "", "01", "", "", "43.96668", "18.05504", "Europe/Sarajevo"),("3199744", "Gradačac", "", "BA", "70", "", "01", "", "", "44.87851", "18.42764", "Europe/Sarajevo"),("3199779", "Gračanica", "", "BA", "70", "", "01", "", "", "44.70307", "18.3101", "Europe/Sarajevo"),("3199862", "Gostovići", "", "BA", "70", "", "01", "", "", "44.41124", "18.17029", "Europe/Sarajevo"),("3199904", "Gornji Vakuf", "", "BA", "70", "", "01", "", "", "43.93806", "17.58833", "Europe/Sarajevo"),("3200396", "Goražde", "Горажде", "BA", "70", "", "01", "", "", "43.66795", "18.97564", "Europe/Sarajevo"),("3200829", "Fojnica", "", "BA", "70", "", "01", "", "", "43.95952", "17.90288", "Europe/Sarajevo"),("3200837", "Foča", "", "BA", "70", "", "02", "", "", "43.50646", "18.77854", "Europe/Sarajevo"),("3200930", "Tomislavgrad", "", "BA", "70", "", "01", "", "", "43.71849", "17.22515", "Europe/Sarajevo"),("3201376", "Donji Vakuf", "", "BA", "70", "", "01", "", "", "44.14361", "17.4", "Europe/Sarajevo"),("3201662", "Donja Mahala", "", "BA", "70", "", "01", "", "", "45.04327", "18.66996", "Europe/Sarajevo"),("3201984", "Doboj", "Добой", "BA", "70", "", "02", "", "", "44.73179", "18.08698", "Europe/Sarajevo"),("3202014", "Divičani", "", "BA", "70", "", "01", "", "", "44.36682", "17.32678", "Europe/Sarajevo"),("3202081", "Derventa", "", "BA", "70", "", "02", "", "", "44.97839", "17.90779", "Europe/Sarajevo"),("3202564", "Čitluk", "", "BA", "70", "", "01", "", "", "43.22861", "17.70083", "Europe/Sarajevo"),("3202822", "Cazin", "", "BA", "70", "", "01", "", "", "44.96694", "15.94306", "Europe/Sarajevo"),("3202873", "Čapljina", "", "BA", "70", "", "01", "", "", "43.12139", "17.68444", "Europe/Sarajevo"),("3202935", "Bužim", "", "BA", "70", "", "01", "", "", "45.05361", "16.03254", "Europe/Sarajevo"),("3203099", "Bugojno", "Бугойно", "BA", "70", "", "01", "", "", "44.05722", "17.45083", "Europe/Sarajevo"),("3203521", "Brčko", "Брчко", "BA", "70", "", "BRC", "", "", "44.86995", "18.81012", "Europe/Sarajevo"),("3203644", "Bosansko Grahovo", "", "BA", "70", "", "01", "", "", "44.17944", "16.36389", "Europe/Sarajevo"),("3203647", "Novi Grad", "", "BA", "70", "", "02", "", "", "45.04643", "16.37782", "Europe/Sarajevo"),("3203651", "Brod", "", "BA", "70", "", "02", "", "", "45.13747", "17.98722", "Europe/Sarajevo"),("3203653", "Bosanska Krupa", "Босанска Крупа", "BA", "70", "", "01", "", "", "44.8825", "16.15139", "Europe/Sarajevo"),("3203656", "Gradiška", "", "BA", "70", "", "02", "", "", "45.14484", "17.25453", "Europe/Sarajevo"),("3203657", "Kozarska Dubica", "", "BA", "70", "", "02", "", "", "45.17667", "16.80944", "Europe/Sarajevo"),("3203950", "Blatnica", "", "BA", "70", "", "02", "", "", "44.48677", "17.82278", "Europe/Sarajevo"),("3204161", "Bileća", "", "BA", "70", "", "02", "3294539", "", "42.87645", "18.42967", "Europe/Sarajevo"),("3204186", "Bijeljina", "Биелине", "BA", "70", "", "02", "", "", "44.75874", "19.21437", "Europe/Sarajevo"),("3204222", "Bihać", "Бихач", "BA", "70", "", "01", "", "", "44.81694", "15.87083", "Europe/Sarajevo"),("3204520", "Banovići", "", "BA", "70", "", "00", "", "", "44.40596", "18.52648", "Europe/Sarajevo"),("3204541", "Banja Luka", "Баня-Лука", "BA", "70", "", "02", "", "", "44.77842", "17.19386", "Europe/Sarajevo"),("3210439", "Jelah", "", "BA", "70", "", "01", "", "", "44.654", "17.95897", "Europe/Sarajevo"),("3247554", "Čelinac", "", "BA", "70", "", "02", "", "", "44.72453", "17.32431", "Europe/Sarajevo"),("3253010", "Tešanjka", "", "BA", "70", "", "01", "", "", "44.67228", "18.01109", "Europe/Sarajevo"),("3257948", "Kovači", "", "BA", "70", "", "01", "", "", "44.44874", "18.20521", "Europe/Sarajevo"),("3259075", "Ćoralići", "", "BA", "70", "", "01", "", "", "45.00694", "15.87194", "Europe/Sarajevo"),("3262021", "Crnići", "", "BA", "70", "", "01", "", "", "43.13156", "17.86452", "Europe/Sarajevo"),("3289093", "Kačuni", "", "BA", "70", "", "01", "", "", "44.06433", "17.93894", "Europe/Sarajevo"),("3301568", "Todorovo", "", "BA", "70", "", "01", "", "", "45.08833", "15.93083", "Europe/Sarajevo"),("3337476", "Konjic", "", "BA", "70", "", "01", "", "", "43.65126", "17.96082", "Europe/Sarajevo"),("3344411", "Jablanica", "", "BA", "70", "", "01", "", "", "43.66028", "17.76167", "Europe/Sarajevo"),("8335444", "Mejdan - Obilićevo", "", "BA", "70", "", "02", "", "", "44.76324", "17.19012", "Europe/Sarajevo"),("3373430", "Welchman Hall", "", "BB", "52", "", "11", "", "", "13.18676", "-59.57663", "America/Barbados"),("3373477", "Crane", "", "BB", "52", "", "10", "", "", "13.10487", "-59.44861", "America/Barbados"),("3373505", "Speightstown", "", "BB", "52", "", "09", "", "", "13.25072", "-59.64396", "America/Barbados"),("3373652", "Oistins", "", "BB", "52", "", "01", "", "", "13.07067", "-59.54637", "America/Barbados"),("3373790", "Holetown", "", "BB", "52", "", "04", "", "", "13.18672", "-59.63808", "America/Barbados"),("3373831", "Greenland", "", "BB", "52", "", "02", "", "", "13.25808", "-59.57763", "America/Barbados"),("3373877", "Four Cross Roads", "", "BB", "52", "", "05", "", "", "13.17018", "-59.52186", "America/Barbados"),("3373993", "Checker Hall", "", "BB", "52", "", "07", "", "", "13.28445", "-59.64223", "America/Barbados"),("3374036", "Bridgetown", "Бриджтаун", "BB", "52", "", "08", "", "", "13.10732", "-59.62021", "America/Barbados"),("3374083", "Bathsheba", "", "BB", "52", "", "06", "", "", "13.21133", "-59.52596", "America/Barbados"),("1185092", "Thākurgaon", "", "BD", "50", "", "87", "5594", "559494", "26.03097", "88.46989", "Asia/Dhaka"),("1185095", "Teknāf", "", "BD", "50", "", "84", "2022", "202290", "20.85829", "92.29773", "Asia/Dhaka"),("1185098", "Tungi", "", "BD", "50", "", "81", "3033", "303330", "23.89154", "90.40232", "Asia/Dhaka"),("1185099", "Sylhet", "Силхет", "BD", "50", "", "86", "6091", "609162", "24.89904", "91.87198", "Asia/Dhaka"),("1185100", "Dohār", "", "BD", "50", "", "81", "3026", "302618", "23.59311", "90.14251", "Asia/Dhaka"),("1185106", "Jamālpur", "", "BD", "50", "", "H", "3039", "303936", "24.91965", "89.94812", "Asia/Dhaka"),("1185108", "Shibganj", "", "BD", "50", "", "83", "5070", "507088", "24.68501", "88.15638", "Asia/Dhaka"),("1185111", "Sātkhira", "", "BD", "50", "", "82", "4087", "408782", "22.70817", "89.07185", "Asia/Dhaka"),("1185115", "Sirājganj", "Сираджгандж", "BD", "50", "", "83", "5088", "508878", "24.45771", "89.70802", "Asia/Dhaka"),("1185116", "Netrakona", "", "BD", "50", "", "H", "3072", "307274", "24.88352", "90.72898", "Asia/Dhaka"),("1185117", "Narsingdi", "", "BD", "50", "", "81", "3068", "306860", "23.92298", "90.71768", "Asia/Dhaka"),("1185120", "Sandwīp", "Сандвип", "BD", "50", "", "84", "2015", "201578", "22.51409", "91.45491", "Asia/Dhaka"),("1185121", "Shāhzādpur", "", "BD", "50", "", "83", "5088", "508867", "24.17687", "89.5988", "Asia/Dhaka"),("1185127", "Rāmganj", "", "BD", "50", "", "84", "2051", "205165", "23.1006", "90.84989", "Asia/Dhaka"),("1185128", "Rājshāhi", "Раджшахи", "BD", "50", "", "83", "5081", "508122", "24.374", "88.60114", "Asia/Dhaka"),("1185138", "Pirojpur", "", "BD", "50", "", "85", "1079", "107980", "22.57965", "89.97521", "Asia/Dhaka"),("1185141", "Panchagarh", "", "BD", "50", "", "87", "5577", "557773", "26.33338", "88.55777", "Asia/Dhaka"),("1185148", "Patiya", "", "BD", "50", "", "84", "2015", "201561", "22.29543", "91.979", "Asia/Dhaka"),("1185149", "Parbatipur", "", "BD", "50", "", "87", "5527", "552777", "25.66369", "88.93093", "Asia/Dhaka"),("1185155", "Nārāyanganj", "", "BD", "50", "", "81", "3067", "306758", "23.61352", "90.50298", "Asia/Dhaka"),("1185156", "Nālchiti", "", "BD", "50", "", "85", "1042", "104273", "22.63696", "90.27195", "Asia/Dhaka"),("1185159", "Nāgarpur", "", "BD", "50", "BD", "81", "3093", "309376", "24.05783", "89.87696", "Asia/Dhaka"),("1185160", "Nageswari", "", "BD", "50", "", "87", "5549", "554961", "25.96817", "89.69153", "Asia/Dhaka"),("1185162", "Mymensingh", "Майменсингх", "BD", "50", "", "H", "3061", "306152", "24.75636", "90.40646", "Asia/Dhaka"),("1185164", "Muktāgācha", "", "BD", "50", "", "H", "3061", "306165", "24.76484", "90.25698", "Asia/Dhaka"),("1185165", "Mirzāpur", "Мирзапур", "BD", "50", "", "81", "3093", "309366", "24.10287", "90.09841", "Asia/Dhaka"),("1185166", "Maulavi Bāzār", "", "BD", "50", "", "86", "6058", "605874", "24.48888", "91.77075", "Asia/Dhaka"),("1185167", "Morrelgonj", "", "BD", "50", "", "82", "4001", "400160", "22.45566", "89.85584", "Asia/Dhaka"),("1185171", "Mehendiganj", "", "BD", "50", "", "85", "1006", "100662", "22.82257", "90.52859", "Asia/Dhaka"),("1185173", "Mathba", "", "BD", "50", "", "85", "1079", "107958", "22.28616", "89.95883", "Asia/Dhaka"),("1185181", "Lalmanirhat", "", "BD", "50", "", "87", "5552", "555255", "25.91719", "89.44595", "Asia/Dhaka"),("1185183", "Lākshām", "", "BD", "50", "", "84", "2019", "201972", "23.24018", "91.12143", "Asia/Dhaka"),("1185186", "Comilla", "Комилле", "BD", "50", "", "84", "2019", "201967", "23.46186", "91.18503", "Asia/Dhaka"),("1185188", "Rangpur", "Рангпур", "BD", "50", "", "87", "5585", "558549", "25.74664", "89.25166", "Asia/Dhaka"),("1185191", "Kushtia", "", "BD", "50", "", "82", "4050", "405079", "23.9028", "89.11943", "Asia/Dhaka"),("1185199", "Kālīganj", "", "BD", "50", "", "82", "4044", "404433", "23.40964", "89.13801", "Asia/Dhaka"),("1185204", "Jhingergācha", "", "BD", "50", "", "82", "4041", "404123", "23.11134", "89.09061", "Asia/Dhaka"),("1185206", "Joypur Hāt", "", "BD", "50", "", "83", "5038", "503847", "25.10147", "89.02734", "Asia/Dhaka"),("1185207", "Ishurdi", "", "BD", "50", "", "83", "5076", "507639", "24.12858", "89.06573", "Asia/Dhaka"),("1185209", "Habiganj", "", "BD", "50", "", "86", "6036", "603644", "24.38044", "91.41299", "Asia/Dhaka"),("1185210", "Gaurnadi", "", "BD", "50", "", "85", "1006", "100632", "22.97372", "90.22376", "Asia/Dhaka"),("1185218", "Gafargaon", "", "BD", "50", "", "H", "3061", "306122", "24.432", "90.5585", "Asia/Dhaka"),("1185224", "Feni", "", "BD", "50", "", "84", "2030", "203029", "23.0144", "91.3966", "Asia/Dhaka"),("1185236", "Rāipur", "Райпур", "BD", "50", "", "84", "2051", "205158", "23.0391", "90.76808", "Asia/Dhaka"),("1185239", "Sarankhola", "", "BD", "50", "", "82", "4001", "400177", "22.31006", "89.79113", "Asia/Dhaka"),("1185241", "Dhaka", "Дакка", "BD", "50", "", "81", "3026", "302640", "23.7104", "90.40744", "Asia/Dhaka"),("1185247", "Chilmāri", "", "BD", "50", "", "87", "5549", "554909", "25.55613", "89.67097", "Asia/Dhaka"),("1185249", "Chhāgalnāiya", "", "BD", "50", "", "84", "2030", "203014", "23.02475", "91.51091", "Asia/Dhaka"),("1185251", "Lālmohan", "", "BD", "50", "", "85", "1009", "100954", "22.33774", "90.73708", "Asia/Dhaka"),("1185252", "Khagrachhari", "Кхаграчари", "BD", "50", "", "84", "2046", "204649", "23.10787", "91.97007", "Asia/Dhaka"),("1185254", "Chhātak", "", "BD", "50", "", "86", "6090", "609023", "25.03852", "91.66958", "Asia/Dhaka"),("1185260", "Bhātpāra Abhaynagar", "", "BD", "50", "", "82", "4041", "404104", "23.01472", "89.43936", "Asia/Dhaka"),("1185262", "Bherāmāra", "", "BD", "50", "", "82", "4050", "405015", "24.02452", "88.99234", "Asia/Dhaka"),("1185263", "Bhairab Bāzār", "", "BD", "50", "", "81", "3048", "304811", "24.0524", "90.9764", "Asia/Dhaka"),("1185270", "Bāndarban", "Бандарбан", "BD", "50", "", "84", "2003", "200314", "22.19534", "92.21946", "Asia/Dhaka"),("1185272", "Kālia", "Калия", "BD", "50", "", "82", "4065", "406528", "23.043", "89.63094", "Asia/Dhaka"),("1185274", "Baniachang", "", "BD", "50", "", "86", "6036", "603611", "24.51863", "91.35787", "Asia/Dhaka"),("1185276", "Bājitpur", "", "BD", "50", "", "81", "3048", "304806", "24.21623", "90.95002", "Asia/Dhaka"),("1185283", "Badarganj", "", "BD", "50", "", "87", "5585", "558503", "25.67419", "89.05377", "Asia/Dhaka"),("1185293", "Narail", "", "BD", "50", "", "82", "4065", "406576", "23.15509", "89.49515", "Asia/Dhaka"),("1185920", "Tungipāra", "", "BD", "50", "", "81", "3035", "303591", "22.89983", "89.90326", "Asia/Dhaka"),("1188569", "Sarishābāri", "", "BD", "50", "", "H", "3039", "303985", "24.75127", "89.83126", "Asia/Dhaka"),("1189056", "Sakhipur", "", "BD", "50", "", "81", "3093", "309385", "24.31988", "90.16943", "Asia/Dhaka"),("1189638", "Raojān", "", "BD", "50", "", "84", "2015", "201574", "22.53511", "91.91919", "Asia/Dhaka"),("1191139", "Phultala", "", "BD", "50", "", "82", "4047", "404712", "22.71673", "89.51194", "Asia/Dhaka"),("1191368", "Pālang", "", "BD", "50", "", "81", "3086", "308669", "23.21824", "90.35076", "Asia/Dhaka"),("1192366", "Pār Naogaon", "", "BD", "50", "", "83", "5064", "506460", "24.80418", "88.94875", "Asia/Dhaka"),("1193823", "Nabīnagar", "", "BD", "50", "", "84", "2012", "201285", "23.88791", "90.96792", "Asia/Dhaka"),("1196292", "Lakshmīpur", "", "BD", "50", "", "84", "2051", "205143", "22.9443", "90.83005", "Asia/Dhaka"),("1197895", "Kesabpur", "", "BD", "50", "", "82", "4041", "404138", "22.90725", "89.21954", "Asia/Dhaka"),("1201753", "Hājīganj", "", "BD", "50", "", "84", "2013", "201349", "23.25191", "90.85508", "Asia/Dhaka"),("1203344", "Farīdpur", "", "BD", "50", "", "81", "3029", "302947", "23.60612", "89.84064", "Asia/Dhaka"),("1203891", "Dinājpur", "", "BD", "50", "", "87", "5527", "552764", "25.62745", "88.63779", "Asia/Dhaka"),("1205481", "Uttar Char Fasson", "", "BD", "50", "", "82", "", "", "22.22647", "90.71275", "Asia/Dhaka"),("1205733", "Chittagong", "Читтагонг", "BD", "50", "", "84", "2015", "201541", "22.3384", "91.83168", "Asia/Dhaka"),("1207047", "Char Bhadrāsan", "", "BD", "50", "", "81", "3054", "305487", "23.30916", "90.22698", "Asia/Dhaka"),("1209562", "Bera", "Беру", "BD", "50", "", "83", "5076", "507616", "24.07821", "89.63262", "Asia/Dhaka"),("1210565", "Burhānuddin", "", "BD", "50", "", "85", "1009", "100921", "22.49518", "90.72391", "Asia/Dhaka"),("1336133", "Sātkania", "", "BD", "50", "", "84", "2015", "201582", "22.07639", "92.04955", "Asia/Dhaka"),("1336134", "Cox’s Bāzār", "Кокс-Базар", "BD", "50", "", "84", "2022", "202224", "21.43973", "92.00955", "Asia/Dhaka"),("1336135", "Khulna", "Кхулна", "BD", "50", "", "82", "4047", "404751", "22.80979", "89.56439", "Asia/Dhaka"),("1336136", "Bhola", "Бхола", "BD", "50", "", "85", "1009", "100918", "22.68759", "90.64403", "Asia/Dhaka"),("1336137", "Barisāl", "Барисал", "BD", "50", "", "85", "1006", "100651", "22.70497", "90.37013", "Asia/Dhaka"),("1336140", "Jessore", "", "BD", "50", "", "82", "4041", "404147", "23.16971", "89.21371", "Asia/Dhaka"),("1336143", "Pābna", "Пабне", "BD", "50", "", "83", "5076", "507655", "24.00644", "89.2372", "Asia/Dhaka"),("1336144", "Tāngāil", "", "BD", "50", "", "81", "3093", "309395", "24.24984", "89.91655", "Asia/Dhaka"),("1337233", "Bogra", "Богра", "BD", "50", "", "83", "5010", "501020", "24.85098", "89.37108", "Asia/Dhaka"),("1337239", "Pīrgaaj", "", "BD", "50", "", "87", "5594", "559482", "25.85587", "88.35943", "Asia/Dhaka"),("1337240", "Nawābganj", "", "BD", "50", "", "83", "5070", "507066", "24.59025", "88.27444", "Asia/Dhaka"),("1337245", "Mādārīpur", "", "BD", "50", "", "81", "3054", "305454", "23.17097", "90.20935", "Asia/Dhaka"),("1337248", "Sherpur", "", "BD", "50", "", "H", "3089", "308988", "25.01881", "90.01751", "Asia/Dhaka"),("1337249", "Kishorganj", "", "BD", "50", "", "81", "3048", "304849", "24.43944", "90.78291", "Asia/Dhaka"),("1462681", "Manikchari", "", "BD", "50", "", "84", "2046", "204667", "22.83957", "91.84128", "Asia/Dhaka"),("1477498", "Bhāndāria", "", "BD", "50", "", "85", "1079", "107914", "22.48898", "90.06273", "Asia/Dhaka"),("6414184", "Fatikchari", "", "BD", "50", "", "84", "2015", "201533", "22.68768", "91.78123", "Asia/Dhaka"),("6545349", "Saidpur", "", "BD", "50", "", "83", "", "", "25.77769", "88.89169", "Asia/Dhaka"),("7701354", "Azimpur", "", "BD", "50", "", "81", "3026", "302640", "23.7298", "90.3854", "Asia/Dhaka"),("9827976", "Paltan", "", "BD", "50", "", "81", "3026", "302640", "23.73625", "90.41426", "Asia/Dhaka"),("2783081", "Zwijndrecht", "", "BE", "56", "", "VLG", "VAN", "11", "51.21979", "4.32664", "Europe/Brussels"),("2783089", "Zwevegem", "", "BE", "56", "", "VLG", "VWV", "34", "50.81268", "3.33848", "Europe/Brussels"),("2783143", "Zutendaal", "", "BE", "56", "", "VLG", "VLI", "71", "50.93306", "5.5753", "Europe/Brussels"),("2783151", "Zulte", "", "BE", "56", "", "VLG", "VOV", "44", "50.91954", "3.44859", "Europe/Brussels"),("2783170", "Zoutleeuw", "", "BE", "56", "", "VLG", "VBR", "24", "50.83316", "5.10376", "Europe/Brussels"),("2783175", "Zottegem", "Зоттегем", "BE", "56", "", "VLG", "VOV", "41", "50.86955", "3.81052", "Europe/Brussels"),("2783184", "Zonnebeke", "", "BE", "56", "", "VLG", "VWV", "33", "50.8726", "2.98725", "Europe/Brussels"),("2783188", "Zonhoven", "", "BE", "56", "", "VLG", "VLI", "71", "50.99064", "5.36819", "Europe/Brussels"),("2783195", "Zomergem", "", "BE", "56", "", "VLG", "VOV", "44", "51.11994", "3.56496", "Europe/Brussels"),("2783204", "Zoersel", "", "BE", "56", "", "VLG", "VAN", "11", "51.26825", "4.71296", "Europe/Brussels"),("2783215", "Zingem", "", "BE", "56", "", "VLG", "VOV", "45", "50.90409", "3.65305", "Europe/Brussels"),("2783274", "Zemst", "Земст", "BE", "56", "", "VLG", "VBR", "23", "50.98318", "4.46079", "Europe/Brussels"),("2783278", "Zelzate", "", "BE", "56", "", "VLG", "VOV", "43", "51.18963", "3.80777", "Europe/Brussels"),("2783293", "Zele", "Зеле", "BE", "56", "", "VLG", "VOV", "42", "51.06566", "4.0403", "Europe/Brussels"),("2783308", "Zedelgem", "Зедельгем", "BE", "56", "", "VLG", "VWV", "31", "51.14236", "3.1368", "Europe/Brussels"),("2783310", "Zaventem", "", "BE", "56", "", "VLG", "VBR", "23", "50.88365", "4.47298", "Europe/Brussels"),("2783347", "Zandhoven", "", "BE", "56", "", "VLG", "VAN", "11", "51.21488", "4.66164", "Europe/Brussels"),("2783385", "Yvoir", "", "BE", "56", "", "WAL", "WNA", "91", "50.3279", "4.88059", "Europe/Brussels"),("2783416", "Wuustwezel", "", "BE", "56", "", "VLG", "VAN", "11", "51.39214", "4.59546", "Europe/Brussels"),("2783462", "Wommelgem", "", "BE", "56", "", "VLG", "VAN", "11", "51.20452", "4.5225", "Europe/Brussels"),("2783586", "Wingene", "", "BE", "56", "", "VLG", "VWV", "37", "51.05782", "3.27359", "Europe/Brussels"),("2783632", "Willebroek", "Виллебрук", "BE", "56", "", "VLG", "VAN", "12", "51.06041", "4.36019", "Europe/Brussels"),("2783684", "Wijnegem", "", "BE", "56", "", "VLG", "VAN", "11", "51.22787", "4.51895", "Europe/Brussels"),("2783717", "Wielsbeke", "", "BE", "56", "", "VLG", "VWV", "37", "50.9", "3.36667", "Europe/Brussels"),("2783728", "Wichelen", "", "BE", "56", "", "VLG", "VOV", "42", "51.00526", "3.97683", "Europe/Brussels"),("2783737", "Wezembeek-Oppem", "", "BE", "56", "", "VLG", "VBR", "23", "50.8395", "4.49427", "Europe/Brussels"),("2783759", "Wevelgem", "Вевельгеме", "BE", "56", "", "VLG", "VWV", "34", "50.8", "3.16667", "Europe/Brussels"),("2783763", "Wetteren", "Веттерен", "BE", "56", "", "VLG", "VOV", "42", "51.00526", "3.88341", "Europe/Brussels"),("2783801", "Westerlo", "Вестерло", "BE", "56", "", "VLG", "VAN", "13", "51.09049", "4.91544", "Europe/Brussels"),("2783820", "Wervik", "", "BE", "56", "", "VLG", "VWV", "33", "50.78069", "3.03854", "Europe/Brussels"),("2783856", "Wemmel", "", "BE", "56", "", "VLG", "VBR", "23", "50.90812", "4.30613", "Europe/Brussels"),("2783864", "Wellen", "", "BE", "56", "", "VLG", "VLI", "73", "50.84096", "5.33867", "Europe/Brussels"),("2783870", "Welkenraedt", "", "BE", "56", "", "WAL", "WLG", "63", "50.6605", "5.97034", "Europe/Brussels"),("2783941", "Wavre", "Вавр", "BE", "56", "", "WAL", "WBR", "25", "50.71717", "4.60138", "Europe/Brussels"),("2783985", "Waterloo", "Ватерлоо", "BE", "56", "", "WAL", "WBR", "25", "50.71469", "4.3991", "Europe/Brussels"),("2784066", "Waremme", "", "BE", "56", "", "WAL", "WLG", "64", "50.6976", "5.25524", "Europe/Brussels"),("2784068", "Waregem", "Варегем", "BE", "56", "", "VLG", "VWV", "34", "50.88898", "3.42756", "Europe/Brussels"),("2784092", "Wanze", "", "BE", "56", "", "WAL", "WLG", "61", "50.53907", "5.20846", "Europe/Brussels"),("2784168", "Walhain-Saint-Paul", "", "BE", "56", "", "WAL", "WBR", "25", "50.62627", "4.69837", "Europe/Brussels"),("2784189", "Walcourt", "Валькур", "BE", "56", "", "WAL", "WNA", "93", "50.25401", "4.43796", "Europe/Brussels"),("2784199", "Waimes", "", "BE", "56", "", "WAL", "WLG", "63", "50.41488", "6.11207", "Europe/Brussels"),("2784227", "Wachtebeke", "", "BE", "56", "", "VLG", "VOV", "44", "51.16852", "3.87183", "Europe/Brussels"),("2784231", "Waasmunster", "", "BE", "56", "", "VLG", "VOV", "42", "51.10572", "4.08573", "Europe/Brussels"),("2784237", "Waarschoot", "", "BE", "56", "", "VLG", "VOV", "44", "51.1525", "3.605", "Europe/Brussels"),("2784349", "Vosselaar", "", "BE", "56", "", "VLG", "VAN", "13", "51.30856", "4.8896", "Europe/Brussels"),("2784370", "Vorselaar", "", "BE", "56", "", "VLG", "VAN", "13", "51.20243", "4.77259", "Europe/Brussels"),("2784548", "Visé", "", "BE", "56", "", "WAL", "WLG", "62", "50.7376", "5.69907", "Europe/Brussels"),("2784555", "Virton", "", "BE", "56", "", "WAL", "WLX", "85", "49.56824", "5.53259", "Europe/Brussels"),("2784604", "Vilvoorde", "Вилворде", "BE", "56", "", "VLG", "VBR", "23", "50.92814", "4.42938", "Europe/Brussels"),("2784639", "Villers-le-Bouillet", "", "BE", "56", "", "WAL", "WLG", "61", "50.57708", "5.25945", "Europe/Brussels"),("2784641", "Villers-la-Ville", "", "BE", "56", "", "WAL", "WBR", "25", "50.56667", "4.51667", "Europe/Brussels"),("2784775", "Vielsalm", "", "BE", "56", "", "WAL", "WLX", "82", "50.28407", "5.91502", "Europe/Brussels"),("2784804", "Veurne", "", "BE", "56", "", "VLG", "VWV", "38", "51.07316", "2.66803", "Europe/Brussels"),("2784821", "Verviers", "Вервье", "BE", "56", "", "WAL", "WLG", "63", "50.58907", "5.86241", "Europe/Brussels"),("2785141", "Turnhout", "Турнхоут", "BE", "56", "", "VLG", "VAN", "13", "51.32254", "4.94471", "Europe/Brussels"),("2785169", "Tubize", "Тюбиз", "BE", "56", "", "WAL", "WBR", "25", "50.69059", "4.2009", "Europe/Brussels"),("2785208", "Trooz", "", "BE", "56", "", "WAL", "WLG", "62", "50.57026", "5.69521", "Europe/Brussels"),("2785293", "Tremelo", "", "BE", "56", "", "VLG", "VBR", "24", "50.99231", "4.70807", "Europe/Brussels"),("2785341", "Tournai", "Турне", "BE", "56", "", "WAL", "WHT", "57", "50.60715", "3.38932", "Europe/Brussels"),("2785364", "Torhout", "Торхоут", "BE", "56", "", "VLG", "VWV", "31", "51.0656", "3.10085", "Europe/Brussels"),("2785389", "Tongeren", "Тонгерен", "BE", "56", "", "VLG", "VLI", "73", "50.78054", "5.46484", "Europe/Brussels"),("2785470", "Tienen", "Тинен", "BE", "56", "", "VLG", "VBR", "24", "50.80745", "4.9378", "Europe/Brussels"),("2785476", "Tielt", "", "BE", "56", "", "VLG", "VWV", "37", "50.99931", "3.32707", "Europe/Brussels"),("2785517", "Thuin", "", "BE", "56", "", "WAL", "WHT", "56", "50.33933", "4.28604", "Europe/Brussels"),("2785593", "Theux", "", "BE", "56", "", "WAL", "WLG", "63", "50.53323", "5.81245", "Europe/Brussels"),("2785612", "Tessenderlo", "", "BE", "56", "", "VLG", "VLI", "71", "51.06513", "5.08856", "Europe/Brussels"),("2785622", "Tervuren", "Тервюрен", "BE", "56", "", "VLG", "VBR", "24", "50.82372", "4.51418", "Europe/Brussels"),("2785654", "Ternat", "", "BE", "56", "", "VLG", "VBR", "23", "50.86654", "4.16682", "Europe/Brussels"),("2785778", "Temse", "Темсе", "BE", "56", "", "VLG", "VOV", "46", "51.12794", "4.21372", "Europe/Brussels"),("2786087", "Stekene", "", "BE", "56", "", "VLG", "VOV", "46", "51.2099", "4.03651", "Europe/Brussels"),("2786124", "Steenokkerzeel", "", "BE", "56", "", "VLG", "VBR", "23", "50.91851", "4.50989", "Europe/Brussels"),("2786185", "Stavelot", "", "BE", "56", "", "WAL", "WLG", "63", "50.395", "5.93124", "Europe/Brussels"),("2786226", "Staden", "", "BE", "56", "", "VLG", "VWV", "36", "50.97456", "3.01469", "Europe/Brussels"),("2786229", "Stabroek", "", "BE", "56", "", "VLG", "VAN", "11", "51.33189", "4.37127", "Europe/Brussels"),("2786242", "Sprimont", "", "BE", "56", "", "WAL", "WLG", "62", "50.50922", "5.6595", "Europe/Brussels"),("2786318", "Spa", "", "BE", "56", "", "WAL", "WLG", "63", "50.48375", "5.86674", "Europe/Brussels"),("2786344", "Soumagne", "Сумань", "BE", "56", "", "WAL", "WLG", "62", "50.61385", "5.74679", "Europe/Brussels"),("2786390", "Sombreffe", "", "BE", "56", "", "WAL", "WNA", "92", "50.52865", "4.60087", "Europe/Brussels"),("2786420", "Soignies", "Суанье", "BE", "56", "", "WAL", "WHT", "55", "50.57904", "4.07129", "Europe/Brussels"),("2786545", "Sint-Truiden", "Синт-Трюйден", "BE", "56", "", "VLG", "VLI", "71", "50.81679", "5.18647", "Europe/Brussels"),("2786559", "Sint-Pieters-Leeuw", "", "BE", "56", "", "VLG", "VBR", "23", "50.77926", "4.24355", "Europe/Brussels"),("2786578", "Sint-Niklaas", "Синт-Никлас", "BE", "56", "", "VLG", "VOV", "46", "51.16509", "4.1437", "Europe/Brussels"),("2786587", "Sint-Martens-Lennik", "", "BE", "56", "", "VLG", "VBR", "23", "50.81158", "4.16965", "Europe/Brussels"),("2786591", "Sint-Martens-Latem", "", "BE", "56", "", "VLG", "VOV", "44", "51.01459", "3.63779", "Europe/Brussels"),("2786603", "Sint-Maria-Lierde", "", "BE", "56", "", "VLG", "VOV", "45", "50.82172", "3.84814", "Europe/Brussels"),("2786616", "Sint-Lievens-Houtem", "", "BE", "56", "", "VLG", "VOV", "41", "50.9197", "3.86225", "Europe/Brussels"),("2786626", "Sint-Laureins", "", "BE", "56", "", "VLG", "VOV", "43", "51.24202", "3.52441", "Europe/Brussels"),("2786634", "Sint-Kruis", "", "BE", "56", "", "VLG", "VWV", "31", "51.21399", "3.24949", "Europe/Brussels"),("2786641", "Sint-Katelijne-Waver", "", "BE", "56", "", "VLG", "VAN", "12", "51.06691", "4.53469", "Europe/Brussels"),("2786694", "Sint-Gillis-Waas", "", "BE", "56", "", "VLG", "VOV", "46", "51.21914", "4.12374", "Europe/Brussels"),("2786700", "Sint-Genesius-Rode", "", "BE", "56", "", "VLG", "VBR", "23", "50.74645", "4.35754", "Europe/Brussels"),("2786746", "Sint-Amands", "", "BE", "56", "", "VLG", "VAN", "12", "51.05645", "4.20957", "Europe/Brussels"),("2786769", "Silly", "", "BE", "56", "", "WAL", "WHT", "55", "50.64877", "3.92363", "Europe/Brussels"),("2786824", "Seraing", "Серен", "BE", "56", "", "WAL", "WLG", "62", "50.58362", "5.50115", "Europe/Brussels"),("2786852", "Seneffe", "", "BE", "56", "", "WAL", "WHT", "52", "50.53135", "4.26301", "Europe/Brussels"),("2786963", "Schoten", "", "BE", "56", "", "VLG", "VAN", "11", "51.25251", "4.50268", "Europe/Brussels"),("2787048", "Schilde", "Шильде", "BE", "56", "", "VLG", "VAN", "11", "51.24107", "4.58336", "Europe/Brussels"),("2787080", "Schelle", "", "BE", "56", "", "VLG", "VAN", "11", "51.12615", "4.34114", "Europe/Brussels"),("2787315", "Saint-Vith", "", "BE", "56", "", "WAL", "WLG", "63", "50.28146", "6.12724", "Europe/Brussels"),("2787356", "Saint-Nicolas", "Санкт-Никола", "BE", "56", "", "WAL", "WLG", "62", "50.62837", "5.53243", "Europe/Brussels"),("2787407", "Saint-Hubert", "", "BE", "56", "", "WAL", "WLX", "84", "50.02668", "5.37401", "Europe/Brussels"),("2787416", "Saint-Ghislain", "Санкт-Гилене", "BE", "56", "", "WAL", "WHT", "53", "50.44816", "3.81886", "Europe/Brussels"),("2787521", "Rumst", "", "BE", "56", "", "VLG", "VAN", "11", "51.08153", "4.42217", "Europe/Brussels"),("2787547", "Ruiselede", "", "BE", "56", "", "VLG", "VWV", "37", "51.04039", "3.39416", "Europe/Brussels"),("2787662", "Rotselaar", "", "BE", "56", "", "VLG", "VBR", "24", "50.95302", "4.71665", "Europe/Brussels"),("2787769", "Ronse", "Ронсе", "BE", "56", "", "VLG", "VOV", "45", "50.74574", "3.6005", "Europe/Brussels"),("2787878", "Roeulx", "", "BE", "56", "", "WAL", "WHT", "", "50.50365", "4.11163", "Europe/Brussels"),("2787889", "Roeselare", "Руселаре", "BE", "56", "", "VLG", "VWV", "36", "50.94653", "3.12269", "Europe/Brussels"),("2787948", "Rochefort", "", "BE", "56", "", "WAL", "WNA", "91", "50.1631", "5.2216", "Europe/Brussels"),("2787989", "Rixensart", "Риксенсарт", "BE", "56", "", "WAL", "WBR", "25", "50.71229", "4.52529", "Europe/Brussels"),("2788051", "Rijkevorsel", "", "BE", "56", "", "VLG", "VAN", "13", "51.34795", "4.76053", "Europe/Brussels"),("2788088", "Riemst", "", "BE", "56", "", "VLG", "VLI", "73", "50.80995", "5.60131", "Europe/Brussels"),("2788138", "Retie", "", "BE", "56", "", "VLG", "VAN", "13", "51.26652", "5.08242", "Europe/Brussels"),("2788211", "Remicourt", "", "BE", "56", "", "WAL", "WLG", "64", "50.68069", "5.32785", "Europe/Brussels"),("2788299", "Rebecq-Rognon", "", "BE", "56", "", "WAL", "WBR", "25", "50.65147", "4.10683", "Europe/Brussels"),("2788312", "Ravels", "", "BE", "56", "", "VLG", "VAN", "13", "51.37274", "4.9921", "Europe/Brussels"),("2788348", "Ranst", "", "BE", "56", "", "VLG", "VAN", "11", "51.18983", "4.56533", "Europe/Brussels"),("2788381", "Ramillies", "", "BE", "56", "", "WAL", "WBR", "25", "50.63395", "4.90119", "Europe/Brussels"),("2788410", "Raeren", "", "BE", "56", "", "WAL", "WLG", "63", "50.6672", "6.11535", "Europe/Brussels"),("2788444", "Quiévrain", "", "BE", "56", "", "WAL", "WHT", "53", "50.40737", "3.68351", "Europe/Brussels"),("2788446", "Quévy-le-Petit", "", "BE", "56", "", "WAL", "WHT", "53", "50.36879", "3.93602", "Europe/Brussels"),("2788499", "Quaregnon", "", "BE", "56", "", "WAL", "WHT", "53", "50.44067", "3.8653", "Europe/Brussels"),("2788506", "Puurs", "", "BE", "56", "", "VLG", "VAN", "12", "51.07409", "4.28844", "Europe/Brussels"),("2788521", "Putte", "", "BE", "56", "", "VLG", "VAN", "12", "51.05337", "4.63263", "Europe/Brussels"),("2788577", "Profondeville", "", "BE", "56", "", "WAL", "WNA", "92", "50.37581", "4.86506", "Europe/Brussels"),("2788726", "Poperinge", "Поперинге", "BE", "56", "", "VLG", "VWV", "33", "50.85386", "2.72659", "Europe/Brussels"),("2788765", "Pont-à-Celles", "", "BE", "56", "", "WAL", "WHT", "52", "50.50518", "4.36887", "Europe/Brussels"),("2788849", "Plombières", "", "BE", "56", "", "WAL", "WLG", "63", "50.73656", "5.95922", "Europe/Brussels"),("2788925", "Pittem", "", "BE", "56", "", "VLG", "VWV", "37", "50.99279", "3.26317", "Europe/Brussels"),("2789016", "Philippeville", "", "BE", "56", "", "WAL", "WNA", "93", "50.19612", "4.54374", "Europe/Brussels"),("2789156", "Perwez", "", "BE", "56", "", "WAL", "WBR", "25", "50.62426", "4.81354", "Europe/Brussels"),("2789162", "Péruwelz", "Перювельз", "BE", "56", "", "WAL", "WHT", "57", "50.50819", "3.59373", "Europe/Brussels"),("2789190", "Pepinster", "", "BE", "56", "", "WAL", "WLG", "63", "50.57375", "5.8049", "Europe/Brussels"),("2789232", "Peer", "", "BE", "56", "", "VLG", "VLI", "72", "51.1303", "5.45952", "Europe/Brussels"),("2789236", "Pecq", "", "BE", "56", "", "WAL", "WHT", "57", "50.68619", "3.33789", "Europe/Brussels"),("2789354", "Paliseul", "", "BE", "56", "", "WAL", "WLX", "84", "49.90395", "5.13537", "Europe/Brussels"),("2789403", "Overpelt", "", "BE", "56", "", "VLG", "VLI", "72", "51.21038", "5.41557", "Europe/Brussels"),("2789413", "Overijse", "Оверийсе", "BE", "56", "", "VLG", "VBR", "23", "50.77436", "4.53461", "Europe/Brussels"),("2789471", "Oupeye", "Упе", "BE", "56", "", "WAL", "WLG", "62", "50.71184", "5.6468", "Europe/Brussels"),("2789483", "Oud-Turnhout", "", "BE", "56", "", "VLG", "VAN", "13", "51.31978", "4.9841", "Europe/Brussels"),("2789492", "Oud-Heverlee", "", "BE", "56", "", "VLG", "VBR", "24", "50.83522", "4.66421", "Europe/Brussels"),("2789519", "Oudenburg", "", "BE", "56", "", "VLG", "VWV", "35", "51.18489", "3.00035", "Europe/Brussels"),("2789529", "Oudenaarde", "Оуденаарде", "BE", "56", "", "VLG", "VOV", "45", "50.85168", "3.60891", "Europe/Brussels"),("2789570", "Ottignies", "", "BE", "56", "", "WAL", "WBR", "25", "50.66535", "4.56679", "Europe/Brussels"),("2789654", "Opwijk", "", "BE", "56", "", "VLG", "VBR", "23", "50.96724", "4.18442", "Europe/Brussels"),("2789714", "Opglabbeek", "", "BE", "56", "", "VLG", "VLI", "71", "51.04258", "5.58346", "Europe/Brussels"),("2789737", "Oostrozebeke", "", "BE", "56", "", "VLG", "VWV", "37", "50.92093", "3.33799", "Europe/Brussels"),("2789745", "Oostmalle", "", "BE", "56", "", "VLG", "VAN", "11", "51.3", "4.73333", "Europe/Brussels"),("2789751", "Oostkamp", "Осткамп", "BE", "56", "", "VLG", "VWV", "31", "51.15432", "3.23128", "Europe/Brussels"),("2789771", "Oosterzele", "", "BE", "56", "", "VLG", "VOV", "44", "50.95261", "3.79826", "Europe/Brussels"),("2789786", "Ostend", "Остенде", "BE", "56", "", "VLG", "VWV", "35", "51.21551", "2.927", "Europe/Brussels"),("2789886", "Olen", "", "BE", "56", "", "VLG", "VAN", "13", "51.14391", "4.8598", "Europe/Brussels"),("2790101", "Nivelles", "Нивель", "BE", "56", "", "WAL", "WBR", "25", "50.59833", "4.32848", "Europe/Brussels"),("2790114", "Ninove", "Нинове", "BE", "56", "", "VLG", "VOV", "41", "50.82776", "4.02657", "Europe/Brussels"),("2790135", "Nijlen", "", "BE", "56", "", "VLG", "VAN", "12", "51.16096", "4.67008", "Europe/Brussels"),("2790150", "Nieuwpoort", "", "BE", "56", "", "VLG", "VWV", "38", "51.13008", "2.75135", "Europe/Brussels"),("2790179", "Nieuwerkerken", "", "BE", "56", "", "VLG", "VLI", "71", "50.8638", "5.19467", "Europe/Brussels"),("2790225", "Niel", "", "BE", "56", "", "VLG", "VAN", "11", "51.11096", "4.33428", "Europe/Brussels"),("2790235", "Nevele", "", "BE", "56", "", "VLG", "VOV", "44", "51.03531", "3.54574", "Europe/Brussels"),("2790286", "Neufchâteau", "", "BE", "56", "", "WAL", "WLX", "84", "49.84074", "5.43535", "Europe/Brussels"),("2790357", "Neerpelt", "", "BE", "56", "", "VLG", "VLI", "72", "51.22807", "5.4427", "Europe/Brussels"),("2790433", "Nazareth", "", "BE", "56", "", "VLG", "VOV", "44", "50.95686", "3.59425", "Europe/Brussels"),("2790451", "Nassogne", "", "BE", "56", "", "WAL", "WLX", "83", "50.12849", "5.34274", "Europe/Brussels"),("2790467", "Nandrin", "", "BE", "56", "", "WAL", "WLG", "61", "50.50675", "5.41905", "Europe/Brussels"),("2790471", "Namur", "Намюр", "BE", "56", "", "WAL", "WNA", "92", "50.4669", "4.86746", "Europe/Brussels"),("2790595", "Mouscron", "Мускрон", "BE", "56", "", "WAL", "WHT", "54", "50.74497", "3.20639", "Europe/Brussels"),("2790676", "Mortsel", "Мортсел", "BE", "56", "", "VLG", "VAN", "11", "51.16697", "4.45127", "Europe/Brussels"),("2790697", "Morlanwelz-Mariemont", "", "BE", "56", "", "WAL", "WHT", "56", "50.45502", "4.24519", "Europe/Brussels"),("2790729", "Moorslede", "", "BE", "56", "", "VLG", "VWV", "36", "50.8919", "3.06117", "Europe/Brussels"),("2790756", "Mont-Saint-Guibert", "", "BE", "56", "", "WAL", "WBR", "25", "50.63427", "4.61061", "Europe/Brussels"),("2790869", "Mons", "Монс", "BE", "56", "", "WAL", "WHT", "53", "50.45413", "3.95229", "Europe/Brussels"),("2790906", "Momignies", "", "BE", "56", "", "WAL", "WHT", "56", "50.0271", "4.16519", "Europe/Brussels"),("2791067", "Mol", "Мол", "BE", "56", "", "VLG", "VAN", "13", "51.19188", "5.11662", "Europe/Brussels"),("2791120", "Moerbeke", "", "BE", "56", "", "VLG", "VOV", "44", "51.17409", "3.93001", "Europe/Brussels"),("2791194", "Middelkerke", "", "BE", "56", "", "VLG", "VWV", "35", "51.18532", "2.82077", "Europe/Brussels"),("2791255", "Meulebeke", "", "BE", "56", "", "VLG", "VWV", "37", "50.95136", "3.28804", "Europe/Brussels"),("2791261", "Mettet", "", "BE", "56", "", "WAL", "WNA", "92", "50.32119", "4.66232", "Europe/Brussels"),("2791272", "Messancy", "", "BE", "56", "", "WAL", "WLX", "81", "49.59201", "5.81879", "Europe/Brussels"),("2791297", "Merksplas", "", "BE", "56", "", "VLG", "VAN", "13", "51.35851", "4.86513", "Europe/Brussels"),("2791315", "Merelbeke", "Мерелбеке", "BE", "56", "", "VLG", "VOV", "44", "50.99447", "3.74621", "Europe/Brussels"),("2791323", "Merchtem", "", "BE", "56", "", "VLG", "VBR", "23", "50.95129", "4.23197", "Europe/Brussels"),("2791343", "Menen", "Менен", "BE", "56", "", "VLG", "VWV", "34", "50.79722", "3.12245", "Europe/Brussels"),("2791385", "Melle", "", "BE", "56", "", "VLG", "VOV", "44", "51.00232", "3.80526", "Europe/Brussels"),("2791424", "Meise", "", "BE", "56", "", "VLG", "VBR", "23", "50.93934", "4.32655", "Europe/Brussels"),("2791494", "Meerhout", "", "BE", "56", "", "VLG", "VAN", "13", "51.1321", "5.07842", "Europe/Brussels"),("2791537", "Mechelen", "Мехелен", "BE", "56", "", "VLG", "VAN", "12", "51.02574", "4.47762", "Europe/Brussels"),("2791733", "Marchin", "", "BE", "56", "", "WAL", "WLG", "61", "50.46707", "5.2428", "Europe/Brussels"),("2791744", "Marche-en-Famenne", "Марш-ан-Фамен", "BE", "56", "", "WAL", "WLX", "83", "50.22678", "5.34416", "Europe/Brussels"),("2791814", "Manage", "", "BE", "56", "", "WAL", "WHT", "52", "50.50312", "4.23589", "Europe/Brussels"),("2791834", "Malmédy", "", "BE", "56", "", "WAL", "WLG", "63", "50.42686", "6.02794", "Europe/Brussels"),("2791857", "Maldegem", "Мальдегем", "BE", "56", "", "VLG", "VOV", "43", "51.20737", "3.44511", "Europe/Brussels"),("2791951", "Machelen", "", "BE", "56", "", "VLG", "VBR", "23", "50.91061", "4.44174", "Europe/Brussels"),("2791961", "Maasmechelen", "Маасмехелене", "BE", "56", "", "VLG", "VLI", "73", "50.96545", "5.69452", "Europe/Brussels"),("2791964", "Maaseik", "Маасейк", "BE", "56", "", "VLG", "VLI", "72", "51.09802", "5.78379", "Europe/Brussels"),("2792007", "Lummen", "", "BE", "56", "", "VLG", "VLI", "71", "50.98772", "5.19121", "Europe/Brussels"),("2792034", "Lubbeek", "", "BE", "56", "", "VLG", "VBR", "24", "50.88278", "4.83896", "Europe/Brussels"),("2792057", "Lovendegem", "", "BE", "56", "", "VLG", "VOV", "44", "51.10168", "3.61298", "Europe/Brussels"),("2792073", "Louvain-la-Neuve", "Лувен-ла-Нев", "BE", "56", "", "WAL", "WBR", "25", "50.66829", "4.61443", "Europe/Brussels"),("2792165", "Londerzeel", "", "BE", "56", "", "VLG", "VBR", "23", "51.00468", "4.30304", "Europe/Brussels"),("2792179", "Lommel", "Ломмел", "BE", "56", "", "VLG", "VLI", "72", "51.23074", "5.31349", "Europe/Brussels"),("2792196", "Lokeren", "Локерен", "BE", "56", "", "VLG", "VOV", "46", "51.10364", "3.99339", "Europe/Brussels"),("2792235", "Lochristi", "", "BE", "56", "", "VLG", "VOV", "44", "51.09644", "3.83194", "Europe/Brussels"),("2792245", "Lobbes", "", "BE", "56", "", "WAL", "WHT", "56", "50.35258", "4.26716", "Europe/Brussels"),("2792292", "Lint", "", "BE", "56", "", "VLG", "VAN", "11", "51.12707", "4.49669", "Europe/Brussels"),("2792348", "Limbourg", "", "BE", "56", "", "WAL", "WLG", "63", "50.61222", "5.9412", "Europe/Brussels"),("2792360", "Lille", "", "BE", "56", "", "VLG", "VAN", "13", "51.24197", "4.82313", "Europe/Brussels"),("2792397", "Lier", "Льер", "BE", "56", "", "VLG", "VAN", "12", "51.13128", "4.57041", "Europe/Brussels"),("2792413", "Liège", "Льеж", "BE", "56", "", "WAL", "WLG", "62", "50.63373", "5.56749", "Europe/Brussels"),("2792423", "Liedekerke", "", "BE", "56", "", "VLG", "VBR", "23", "50.86892", "4.08743", "Europe/Brussels"),("2792428", "Lichtervelde", "", "BE", "56", "", "VLG", "VWV", "36", "51.03333", "3.15", "Europe/Brussels"),("2792482", "Leuven", "Лёвен", "BE", "56", "", "VLG", "VBR", "24", "50.87959", "4.70093", "Europe/Brussels"),("2792567", "Lessines", "Лессин", "BE", "56", "", "WAL", "WHT", "55", "50.71104", "3.83579", "Europe/Brussels"),("2792856", "Leopoldsburg", "", "BE", "56", "", "VLG", "VLI", "71", "51.11667", "5.25", "Europe/Brussels"),("2792879", "Lendelede", "", "BE", "56", "", "VLG", "VWV", "34", "50.88626", "3.23747", "Europe/Brussels"),("2793067", "Ledegem", "", "BE", "56", "", "VLG", "VWV", "36", "50.85785", "3.12409", "Europe/Brussels"),("2793070", "Ledeberg", "", "BE", "56", "", "VLG", "VOV", "44", "51.03859", "3.74458", "Europe/Brussels"),("2793077", "Lede", "", "BE", "56", "", "VLG", "VOV", "41", "50.96626", "3.98594", "Europe/Brussels"),("2793144", "Lebbeke", "", "BE", "56", "", "VLG", "VOV", "42", "51.00464", "4.13457", "Europe/Brussels"),("2793429", "Landen", "", "BE", "56", "", "VLG", "VBR", "24", "50.75267", "5.082", "Europe/Brussels"),("2793446", "Lanaken", "", "BE", "56", "", "VLG", "VLI", "73", "50.89318", "5.6468", "Europe/Brussels"),("2793508", "La Louvière", "Ла-Лувьер", "BE", "56", "", "WAL", "WHT", "55", "50.48657", "4.18785", "Europe/Brussels"),("2793548", "La Hulpe", "", "BE", "56", "", "WAL", "WBR", "25", "50.73091", "4.48577", "Europe/Brussels"),("2793722", "La Calamine", "", "BE", "56", "", "WAL", "WLG", "63", "50.71809", "6.01107", "Europe/Brussels"),("2793733", "La Bruyère", "", "BE", "56", "", "WAL", "WNA", "", "50.39478", "4.61444", "Europe/Brussels"),("2793797", "Laarne", "", "BE", "56", "", "VLG", "VOV", "42", "51.03078", "3.85077", "Europe/Brussels"),("2793857", "Kuurne", "", "BE", "56", "", "VLG", "VWV", "34", "50.85143", "3.2824", "Europe/Brussels"),("2793907", "Kruishoutem", "", "BE", "56", "", "VLG", "VOV", "45", "50.90168", "3.52588", "Europe/Brussels"),("2793940", "Kruibeke", "", "BE", "56", "", "VLG", "VOV", "46", "51.17048", "4.31444", "Europe/Brussels"),("2794016", "Kraainem", "", "BE", "56", "", "VLG", "VBR", "23", "50.86155", "4.46946", "Europe/Brussels"),("2794055", "Kortrijk", "Кортрейк", "BE", "56", "", "VLG", "VWV", "34", "50.82803", "3.26487", "Europe/Brussels"),("2794063", "Kortessem", "", "BE", "56", "", "VLG", "VLI", "73", "50.8589", "5.38974", "Europe/Brussels"),("2794070", "Kortenberg", "", "BE", "56", "", "VLG", "VBR", "24", "50.88982", "4.54353", "Europe/Brussels"),("2794072", "Kortenaken", "", "BE", "56", "", "VLG", "VBR", "24", "50.90862", "5.05968", "Europe/Brussels"),("2794074", "Kortemark", "", "BE", "56", "", "VLG", "VWV", "32", "51.02951", "3.04112", "Europe/Brussels"),("2794117", "Kontich", "Контич", "BE", "56", "", "VLG", "VAN", "11", "51.13213", "4.44706", "Europe/Brussels"),("2794166", "Koksijde", "Коксийде", "BE", "56", "", "VLG", "VWV", "38", "51.11642", "2.63772", "Europe/Brussels"),("2794194", "Koekelare", "", "BE", "56", "", "VLG", "VWV", "32", "51.09047", "2.9783", "Europe/Brussels"),("2794210", "Knokke-Heist", "Кнокке-Хейст", "BE", "56", "", "VLG", "VWV", "31", "51.35", "3.26667", "Europe/Brussels"),("2794223", "Knesselare", "", "BE", "56", "", "VLG", "VOV", "44", "51.13932", "3.41282", "Europe/Brussels"),("2794445", "Kinrooi", "", "BE", "56", "", "VLG", "VLI", "72", "51.14543", "5.74207", "Europe/Brussels"),("2794619", "Keerbergen", "", "BE", "56", "", "VLG", "VBR", "24", "51.00295", "4.63434", "Europe/Brussels"),("2794663", "Kasterlee", "", "BE", "56", "", "VLG", "VAN", "13", "51.24118", "4.96651", "Europe/Brussels"),("2794707", "Kaprijke", "", "BE", "56", "", "VLG", "VOV", "43", "51.2172", "3.61519", "Europe/Brussels"),("2794724", "Kapelle-op-den-Bos", "", "BE", "56", "", "VLG", "VBR", "23", "51.0097", "4.36303", "Europe/Brussels"),("2794730", "Kapellen", "Капеллене", "BE", "56", "", "VLG", "VAN", "11", "51.31377", "4.43539", "Europe/Brussels"),("2794763", "Kampenhout", "", "BE", "56", "", "VLG", "VBR", "23", "50.9421", "4.55103", "Europe/Brussels"),("2794788", "Kalmthout", "", "BE", "56", "", "VLG", "VAN", "11", "51.38442", "4.47556", "Europe/Brussels"),("2794852", "Jurbise", "", "BE", "56", "", "WAL", "WHT", "53", "50.531", "3.90942", "Europe/Brussels"),("2794854", "Juprelle", "", "BE", "56", "", "WAL", "WLG", "62", "50.7076", "5.53127", "Europe/Brussels"),("2794895", "Jodoigne", "", "BE", "56", "", "WAL", "WBR", "25", "50.72357", "4.86914", "Europe/Brussels"),("2794989", "Jalhay", "", "BE", "56", "", "WAL", "WLG", "63", "50.55876", "5.96764", "Europe/Brussels"),("2794999", "Jabbeke", "", "BE", "56", "", "VLG", "VWV", "31", "51.18185", "3.08935", "Europe/Brussels"),("2795009", "Izegem", "Изегем", "BE", "56", "", "VLG", "VWV", "36", "50.91396", "3.21378", "Europe/Brussels"),("2795017", "Ittre", "", "BE", "56", "", "WAL", "WBR", "25", "50.64396", "4.26476", "Europe/Brussels"),("2795056", "Ingelmunster", "", "BE", "56", "", "VLG", "VWV", "36", "50.92081", "3.25571", "Europe/Brussels"),("2795100", "Ieper", "Ипр", "BE", "56", "", "VLG", "VWV", "33", "50.85114", "2.88569", "Europe/Brussels"),("2795106", "Ichtegem", "", "BE", "56", "", "VLG", "VWV", "35", "51.09572", "3.01549", "Europe/Brussels"),("2795113", "Huy", "Юи", "BE", "56", "", "WAL", "WLG", "61", "50.51894", "5.23284", "Europe/Brussels"),("2795170", "Hulshout", "", "BE", "56", "", "VLG", "VAN", "13", "51.07451", "4.79081", "Europe/Brussels"),("2795184", "Huldenberg", "", "BE", "56", "", "VLG", "VBR", "24", "50.78939", "4.5831", "Europe/Brussels"),("2795232", "Hove", "", "BE", "56", "", "VLG", "VAN", "11", "51.15446", "4.4707", "Europe/Brussels"),("2795255", "Houthulst", "", "BE", "56", "", "VLG", "VWV", "32", "50.97824", "2.9505", "Europe/Brussels"),("2795261", "Houthalen", "", "BE", "56", "", "VLG", "VLI", "72", "51.03427", "5.37429", "Europe/Brussels"),("2795398", "Hoogstraten", "Хогстратен", "BE", "56", "", "VLG", "VAN", "13", "51.40029", "4.76034", "Europe/Brussels"),("2795423", "Hooglede", "", "BE", "56", "", "VLG", "VWV", "36", "50.98333", "3.08333", "Europe/Brussels"),("2795511", "Holsbeek", "", "BE", "56", "", "VLG", "VBR", "24", "50.92097", "4.75747", "Europe/Brussels"),("2795648", "Hoeselt", "", "BE", "56", "", "VLG", "VLI", "73", "50.84714", "5.48767", "Europe/Brussels"),("2795699", "Hoeilaart", "", "BE", "56", "", "VLG", "VBR", "23", "50.7673", "4.46835", "Europe/Brussels"),("2795703", "Hoegaarden", "", "BE", "56", "", "VLG", "VBR", "24", "50.7756", "4.88952", "Europe/Brussels"),("2795730", "Hoboken", "", "BE", "56", "BE", "VLG", "VAN", "11", "51.17611", "4.34844", "Europe/Brussels"),("2795800", "Heusden", "", "BE", "56", "", "VLG", "VLI", "71", "51.03664", "5.28013", "Europe/Brussels"),("2795908", "Herzele", "", "BE", "56", "", "VLG", "VOV", "41", "50.88681", "3.89014", "Europe/Brussels"),("2795912", "Herve", "Эрв", "BE", "56", "", "WAL", "WLG", "63", "50.64083", "5.79353", "Europe/Brussels"),("2795930", "Herstal", "Эрсталь", "BE", "56", "", "WAL", "WLG", "62", "50.66415", "5.62346", "Europe/Brussels"),("2795933", "Herselt", "", "BE", "56", "", "VLG", "VAN", "13", "51.05159", "4.88231", "Europe/Brussels"),("2795956", "Herne", "", "BE", "56", "", "VLG", "VBR", "23", "50.72423", "4.03481", "Europe/Brussels"),("2795985", "Herk-de-Stad", "", "BE", "56", "", "VLG", "VLI", "71", "50.94013", "5.16636", "Europe/Brussels"),("2796005", "Herenthout", "", "BE", "56", "", "VLG", "VAN", "13", "51.1401", "4.75572", "Europe/Brussels"),("2796009", "Herentals", "Херенталс", "BE", "56", "", "VLG", "VAN", "13", "51.17655", "4.83248", "Europe/Brussels"),("2796012", "Herent", "", "BE", "56", "", "VLG", "VBR", "24", "50.90861", "4.67056", "Europe/Brussels"),("2796056", "Hensies", "", "BE", "56", "", "WAL", "WHT", "53", "50.43263", "3.68411", "Europe/Brussels"),("2796085", "Hemiksem", "", "BE", "56", "", "VLG", "VAN", "11", "51.14484", "4.33874", "Europe/Brussels"),("2796132", "Helchteren", "", "BE", "56", "", "VLG", "VLI", "72", "51.05591", "5.38244", "Europe/Brussels"),("2796153", "Heist-op-den-Berg", "", "BE", "56", "", "VLG", "VAN", "12", "51.07537", "4.72827", "Europe/Brussels"),("2796297", "Heers", "", "BE", "56", "", "VLG", "VLI", "73", "50.75383", "5.3021", "Europe/Brussels"),("2796482", "Hastière-Lavaux", "", "BE", "56", "", "WAL", "WNA", "91", "50.21849", "4.82446", "Europe/Brussels"),("2796491", "Hasselt", "Хасселт", "BE", "56", "", "VLG", "VLI", "71", "50.93106", "5.33781", "Europe/Brussels"),("2796542", "Harelbeke", "Харелбеке", "BE", "56", "", "VLG", "VWV", "34", "50.85343", "3.30935", "Europe/Brussels"),("2796583", "Hannut", "", "BE", "56", "", "WAL", "WLG", "64", "50.67142", "5.07898", "Europe/Brussels"),("2796627", "Hamois", "", "BE", "56", "", "WAL", "WNA", "91", "50.3402", "5.15619", "Europe/Brussels"),("2796637", "Hamme", "Хамме", "BE", "56", "", "VLG", "VOV", "42", "51.09822", "4.13705", "Europe/Brussels"),("2796696", "Halle", "Галле", "BE", "56", "", "VLG", "VBR", "23", "50.73385", "4.23454", "Europe/Brussels"),("2796715", "Halen", "", "BE", "56", "", "VLG", "VLI", "71", "50.94837", "5.11096", "Europe/Brussels"),("2796807", "Habay-la-Vieille", "", "BE", "56", "", "WAL", "WLX", "85", "49.72329", "5.61999", "Europe/Brussels"),("2796833", "Haaltert", "", "BE", "56", "", "VLG", "VOV", "41", "50.90634", "4.00093", "Europe/Brussels"),("2796844", "Haacht", "", "BE", "56", "", "VLG", "VBR", "24", "50.97737", "4.63777", "Europe/Brussels"),("2797094", "Grobbendonk", "", "BE", "56", "", "VLG", "VAN", "13", "51.19043", "4.73562", "Europe/Brussels"),("2797114", "Grimbergen", "Гримберген", "BE", "56", "", "VLG", "VBR", "23", "50.93409", "4.37213", "Europe/Brussels"),("2797128", "Grez-Doiceau", "", "BE", "56", "", "WAL", "WBR", "25", "50.73901", "4.69829", "Europe/Brussels"),("2797417", "Gooik", "", "BE", "56", "", "VLG", "VBR", "23", "50.79443", "4.11378", "Europe/Brussels"),("2797500", "Glabbeek-Zuurbemde", "", "BE", "56", "", "VLG", "VBR", "24", "50.87348", "4.94442", "Europe/Brussels"),("2797517", "Gistel", "", "BE", "56", "", "VLG", "VWV", "35", "51.15612", "2.96387", "Europe/Brussels"),("2797523", "Gingelom", "", "BE", "56", "", "VLG", "VLI", "71", "50.74792", "5.13422", "Europe/Brussels"),("2797581", "Gesves", "", "BE", "56", "", "WAL", "WNA", "92", "50.40146", "5.07457", "Europe/Brussels"),("2797598", "Gerpinnes", "", "BE", "56", "", "WAL", "WHT", "52", "50.33789", "4.52731", "Europe/Brussels"),("2797638", "Geraardsbergen", "Герардсберген", "BE", "56", "", "VLG", "VOV", "41", "50.77343", "3.88223", "Europe/Brussels"),("2797656", "Gent", "Гент", "BE", "56", "", "VLG", "VOV", "44", "51.05", "3.71667", "Europe/Brussels"),("2797670", "Genk", "Генк", "BE", "56", "", "VLG", "VLI", "71", "50.965", "5.50082", "Europe/Brussels"),("2797694", "Genappe", "", "BE", "56", "", "WAL", "WBR", "25", "50.61173", "4.45152", "Europe/Brussels"),("2797713", "Gembloux", "Гемблуа", "BE", "56", "", "WAL", "WNA", "92", "50.56149", "4.69889", "Europe/Brussels"),("2797761", "Geetbets", "", "BE", "56", "", "VLG", "VBR", "24", "50.89431", "5.11199", "Europe/Brussels"),("2797779", "Geel", "Геел", "BE", "56", "", "VLG", "VAN", "13", "51.16557", "4.98917", "Europe/Brussels"),("2797798", "Gavere", "", "BE", "56", "", "VLG", "VOV", "44", "50.92917", "3.66184", "Europe/Brussels"),("2797851", "Galmaarden", "", "BE", "56", "", "VLG", "VBR", "23", "50.75389", "3.97121", "Europe/Brussels"),("2797979", "Frasnes-lez-Buissenal", "", "BE", "56", "", "WAL", "WHT", "51", "50.66783", "3.62047", "Europe/Brussels"),("2798023", "Frameries", "Фрамерис", "BE", "56", "", "WAL", "WHT", "53", "50.40578", "3.89603", "Europe/Brussels"),("2798099", "Fosses-la-Ville", "", "BE", "56", "", "WAL", "WNA", "92", "50.39517", "4.69623", "Europe/Brussels"),("2798272", "Florenville", "", "BE", "56", "", "WAL", "WLX", "85", "49.69983", "5.3074", "Europe/Brussels"),("2798276", "Florennes", "", "BE", "56", "", "WAL", "WNA", "93", "50.25127", "4.60636", "Europe/Brussels"),("2798279", "Floreffe", "", "BE", "56", "", "WAL", "WNA", "92", "50.43452", "4.7596", "Europe/Brussels"),("2798297", "Fleurus", "Флерус", "BE", "56", "", "WAL", "WHT", "52", "50.48351", "4.55006", "Europe/Brussels"),("2798301", "Fléron", "Флерон", "BE", "56", "", "WAL", "WLG", "62", "50.61516", "5.68062", "Europe/Brussels"),("2798307", "Flémalle-Haute", "", "BE", "56", "", "WAL", "WLG", "62", "50.59994", "5.44471", "Europe/Brussels"),("2798470", "Farciennes", "", "BE", "56", "", "WAL", "WHT", "52", "50.43006", "4.54152", "Europe/Brussels"),("2798551", "Evergem", "Эвергем", "BE", "56", "", "VLG", "VOV", "44", "51.10529", "3.704", "Europe/Brussels"),("2798573", "Eupen", "Эйпен", "BE", "56", "", "WAL", "WLG", "63", "50.6279", "6.03647", "Europe/Brussels"),("2798593", "Étalle", "", "BE", "56", "", "WAL", "WLX", "85", "49.67385", "5.60019", "Europe/Brussels"),("2798597", "Estinnes-au-Val", "", "BE", "56", "", "WAL", "WHT", "56", "50.41016", "4.10477", "Europe/Brussels"),("2798604", "Estaimpuis", "", "BE", "56", "", "WAL", "WHT", "57", "50.70485", "3.26785", "Europe/Brussels"),("2798615", "Essen", "", "BE", "56", "", "VLG", "VAN", "11", "51.46791", "4.46901", "Europe/Brussels"),("2798636", "Esneux", "", "BE", "56", "", "WAL", "WLG", "62", "50.53596", "5.56775", "Europe/Brussels"),("2798666", "Erquelinnes", "", "BE", "56", "", "WAL", "WHT", "56", "50.30688", "4.11129", "Europe/Brussels"),("2798743", "Engis", "", "BE", "56", "", "WAL", "WLG", "62", "50.58156", "5.39916", "Europe/Brussels"),("2798747", "Enghien", "", "BE", "56", "", "WAL", "WHT", "55", "50.68373", "4.03284", "Europe/Brussels"),("2798836", "Ellezelles", "", "BE", "56", "", "WAL", "WHT", "51", "50.73512", "3.67985", "Europe/Brussels"),("2798949", "Éghezée", "", "BE", "56", "", "WAL", "WNA", "92", "50.59076", "4.91175", "Europe/Brussels"),("2798987", "Eeklo", "Экло", "BE", "56", "", "VLG", "VOV", "43", "51.18703", "3.55654", "Europe/Brussels"),("2799007", "Edegem", "", "BE", "56", "", "VLG", "VAN", "11", "51.15662", "4.44504", "Europe/Brussels"),("2799024", "Écaussinnes-d’Enghien", "", "BE", "56", "", "WAL", "WHT", "55", "50.56822", "4.1658", "Europe/Brussels"),("2799047", "Durbuy", "", "BE", "56", "", "WAL", "WLX", "83", "50.35291", "5.45631", "Europe/Brussels"),("2799090", "Duffel", "", "BE", "56", "", "VLG", "VAN", "12", "51.09554", "4.50903", "Europe/Brussels"),("2799226", "Dour", "", "BE", "56", "", "WAL", "WHT", "53", "50.39583", "3.77792", "Europe/Brussels"),("2799347", "Dison", "", "BE", "56", "", "WAL", "WLG", "63", "50.61004", "5.8534", "Europe/Brussels"),("2799357", "Dinant", "", "BE", "56", "", "WAL", "WNA", "91", "50.25807", "4.91166", "Europe/Brussels"),("2799365", "Dilbeek", "Дилбек", "BE", "56", "", "VLG", "VBR", "23", "50.84799", "4.25972", "Europe/Brussels"),("2799369", "Diksmuide", "", "BE", "56", "", "VLG", "VWV", "32", "51.03248", "2.86384", "Europe/Brussels"),("2799397", "Diest", "", "BE", "56", "", "VLG", "VBR", "24", "50.98923", "5.05062", "Europe/Brussels"),("2799412", "Diepenbeek", "", "BE", "56", "", "VLG", "VLI", "71", "50.90769", "5.41875", "Europe/Brussels"),("2799416", "Diegem", "", "BE", "56", "", "VLG", "VBR", "23", "50.89727", "4.43354", "Europe/Brussels"),("2799496", "Destelbergen", "", "BE", "56", "", "VLG", "VOV", "44", "51.05952", "3.79899", "Europe/Brussels"),("2799511", "Dessel", "", "BE", "56", "", "VLG", "VAN", "13", "51.23855", "5.11448", "Europe/Brussels"),("2799570", "De Pinte", "", "BE", "56", "", "VLG", "VOV", "44", "50.99339", "3.64747", "Europe/Brussels"),("2799577", "De Panne", "", "BE", "56", "", "VLG", "VWV", "38", "51.09793", "2.59368", "Europe/Brussels"),("2799586", "Dentergem", "", "BE", "56", "", "VLG", "VWV", "37", "50.96429", "3.41617", "Europe/Brussels"),("2799645", "Dendermonde", "Дендермонде", "BE", "56", "", "VLG", "VOV", "42", "51.02869", "4.10106", "Europe/Brussels"),("2799647", "Denderleeuw", "", "BE", "56", "", "VLG", "VOV", "41", "50.88506", "4.07601", "Europe/Brussels"),("2799746", "Deinze", "Дейнзе", "BE", "56", "", "VLG", "VOV", "44", "50.98175", "3.53096", "Europe/Brussels"),("2799779", "De Haan", "", "BE", "56", "", "VLG", "VWV", "35", "51.27261", "3.03446", "Europe/Brussels"),("2799797", "Deerlijk", "", "BE", "56", "", "VLG", "VWV", "34", "50.85337", "3.35416", "Europe/Brussels"),("2799885", "Damme", "", "BE", "56", "", "VLG", "VWV", "31", "51.25147", "3.28144", "Europe/Brussels"),("2799897", "Dalhem", "", "BE", "56", "", "WAL", "WLG", "62", "50.71315", "5.72774", "Europe/Brussels"),("2800025", "Couvin", "", "BE", "56", "", "WAL", "WNA", "93", "50.05284", "4.49495", "Europe/Brussels"),("2800042", "Court-Saint-Étienne", "", "BE", "56", "", "WAL", "WBR", "25", "50.63378", "4.56851", "Europe/Brussels"),("2800063", "Courcelles", "Курсель", "BE", "56", "", "WAL", "WHT", "52", "50.46379", "4.3747", "Europe/Brussels"),("2800204", "Comblain-au-Pont", "", "BE", "56", "", "WAL", "WLG", "62", "50.47488", "5.57711", "Europe/Brussels"),("2800220", "Colfontaine", "", "BE", "56", "", "WAL", "WHT", "53", "50.4141", "3.85569", "Europe/Brussels"),("2800298", "Ciney", "", "BE", "56", "", "WAL", "WNA", "91", "50.29449", "5.10015", "Europe/Brussels"),("2800325", "Chimay", "", "BE", "56", "", "WAL", "WHT", "56", "50.04856", "4.31712", "Europe/Brussels"),("2800328", "Chièvres", "", "BE", "56", "", "WAL", "WHT", "51", "50.58787", "3.80711", "Europe/Brussels"),("2800430", "Chaumont-Gistoux", "", "BE", "56", "", "WAL", "WBR", "25", "50.67753", "4.7212", "Europe/Brussels"),("2800438", "Chaudfontaine", "", "BE", "56", "", "WAL", "WLG", "62", "50.5828", "5.6341", "Europe/Brussels"),("2800448", "Châtelet", "Шатле", "BE", "56", "", "WAL", "WHT", "52", "50.40338", "4.52826", "Europe/Brussels"),("2800457", "Chastre-Villeroux-Blanmont", "", "BE", "56", "", "WAL", "WBR", "25", "50.60857", "4.64198", "Europe/Brussels"),("2800461", "Chasse Royale", "", "BE", "56", "", "WAL", "WHT", "", "50.42842", "3.95001", "Europe/Brussels"),("2800481", "Charleroi", "Шарлеруа", "BE", "56", "", "WAL", "WHT", "52", "50.41136", "4.44448", "Europe/Brussels"),("2800500", "Chapelle-lez-Herlaimont", "", "BE", "56", "", "WAL", "WHT", "52", "50.4713", "4.28227", "Europe/Brussels"),("2800605", "Celles", "", "BE", "56", "", "WAL", "WHT", "57", "50.71229", "3.45733", "Europe/Brussels"),("2800711", "Butgenbach", "", "BE", "56", "", "WAL", "WLG", "63", "50.42689", "6.20504", "Europe/Brussels"),("2800782", "Bullange", "", "BE", "56", "", "WAL", "WLG", "63", "50.40731", "6.25749", "Europe/Brussels"),("2800816", "Buggenhout", "", "BE", "56", "", "VLG", "VOV", "42", "51.0159", "4.20173", "Europe/Brussels"),("2800866", "Brussels", "Брюссель", "BE", "56", "", "BRU", "BRU", "21", "50.85045", "4.34878", "Europe/Brussels"),("2800883", "Brunehault", "", "BE", "56", "", "WAL", "WHT", "", "50.50524", "4.43209", "Europe/Brussels"),("2800931", "Brugge", "Брюгге", "BE", "56", "", "VLG", "VWV", "31", "51.20892", "3.22424", "Europe/Brussels"),("2801093", "Bree", "", "BE", "56", "", "VLG", "VLI", "72", "51.14152", "5.5969", "Europe/Brussels"),("2801103", "Bredene", "", "BE", "56", "", "VLG", "VWV", "35", "51.23489", "2.97559", "Europe/Brussels"),("2801106", "Brecht", "Брехт", "BE", "56", "", "VLG", "VAN", "11", "51.35024", "4.63829", "Europe/Brussels"),("2801117", "Brasschaat", "Брасхат", "BE", "56", "", "VLG", "VAN", "11", "51.2912", "4.49182", "Europe/Brussels"),("2801147", "Braives", "", "BE", "56", "", "WAL", "WLG", "64", "50.61745", "5.13302", "Europe/Brussels"),("2801150", "Braine-le-Comte", "Брем-ле-Конт", "BE", "56", "", "WAL", "WHT", "55", "50.60979", "4.14658", "Europe/Brussels"),("2801152", "Braine-le-Château", "", "BE", "56", "", "WAL", "WBR", "25", "50.6799", "4.27385", "Europe/Brussels"),("2801154", "Braine-l'Alleud", "Брен-л'Аллё", "BE", "56", "", "WAL", "WBR", "25", "50.68363", "4.36784", "Europe/Brussels"),("2801215", "Boutersem", "", "BE", "56", "", "VLG", "VBR", "24", "50.83511", "4.8345", "Europe/Brussels"),("2801226", "Boussu", "Боуссу", "BE", "56", "", "WAL", "WHT", "53", "50.43417", "3.7944", "Europe/Brussels"),("2801283", "Bouillon", "", "BE", "56", "", "WAL", "WLX", "84", "49.79324", "5.06703", "Europe/Brussels"),("2801438", "Borsbeek", "", "BE", "56", "", "VLG", "VAN", "11", "51.19661", "4.48543", "Europe/Brussels"),("2801447", "Bornem", "", "BE", "56", "", "VLG", "VAN", "12", "51.09716", "4.24364", "Europe/Brussels"),("2801467", "Borgloon", "", "BE", "56", "", "VLG", "VLI", "73", "50.80505", "5.34366", "Europe/Brussels"),("2801483", "Boortmeerbeek", "", "BE", "56", "", "VLG", "VBR", "24", "50.97929", "4.57443", "Europe/Brussels"),("2801494", "Boom", "", "BE", "56", "", "VLG", "VAN", "11", "51.09242", "4.3717", "Europe/Brussels"),("2801539", "Bonheiden", "", "BE", "56", "", "VLG", "VAN", "12", "51.02261", "4.54714", "Europe/Brussels"),("2801743", "Boechout", "", "BE", "56", "", "VLG", "VAN", "11", "51.15959", "4.49195", "Europe/Brussels"),("2801754", "Bocholt", "", "BE", "56", "", "VLG", "VLI", "72", "51.17337", "5.57994", "Europe/Brussels"),("2801820", "Blégny", "", "BE", "56", "", "WAL", "WLG", "62", "50.67255", "5.72508", "Europe/Brussels"),("2801858", "Blankenberge", "Бланкенберге", "BE", "56", "", "VLG", "VWV", "31", "51.31306", "3.13227", "Europe/Brussels"),("2801922", "Binche", "Бенш", "BE", "56", "", "WAL", "WHT", "56", "50.41155", "4.16469", "Europe/Brussels"),("2801924", "Bilzen", "Билзен", "BE", "56", "", "VLG", "VLI", "73", "50.87325", "5.5184", "Europe/Brussels"),("2801998", "Bierbeek", "", "BE", "56", "", "VLG", "VBR", "24", "50.82876", "4.75949", "Europe/Brussels"),("2802015", "Beyne-Heusay", "", "BE", "56", "", "WAL", "WLG", "62", "50.62251", "5.66508", "Europe/Brussels"),("2802031", "Beveren", "Беверен", "BE", "56", "", "VLG", "VOV", "46", "51.21187", "4.25633", "Europe/Brussels"),("2802106", "Bertrix", "", "BE", "56", "", "WAL", "WLX", "84", "49.85596", "5.25539", "Europe/Brussels"),("2802123", "Bertem", "", "BE", "56", "", "VLG", "VBR", "24", "50.86403", "4.62918", "Europe/Brussels"),("2802135", "Bernissart", "", "BE", "56", "", "WAL", "WHT", "51", "50.4746", "3.64961", "Europe/Brussels"),("2802154", "Berlare", "", "BE", "56", "", "VLG", "VOV", "42", "51.03333", "4", "Europe/Brussels"),("2802156", "Berlaar", "", "BE", "56", "", "VLG", "VAN", "12", "51.1176", "4.65835", "Europe/Brussels"),("2802170", "Beringen", "Берингене", "BE", "56", "", "VLG", "VLI", "71", "51.04954", "5.22606", "Europe/Brussels"),("2802292", "Beloeil", "", "BE", "56", "", "WAL", "WHT", "51", "50.55047", "3.73484", "Europe/Brussels"),("2802374", "Bekkevoort", "", "BE", "56", "", "VLG", "VBR", "24", "50.94074", "4.969", "Europe/Brussels"),("2802405", "Begijnendijk", "", "BE", "56", "", "VLG", "VBR", "24", "51.01942", "4.78377", "Europe/Brussels"),("2802433", "Beersel", "Берсел", "BE", "56", "", "VLG", "VBR", "23", "50.76589", "4.3002", "Europe/Brussels"),("2802435", "Beerse", "", "BE", "56", "", "VLG", "VAN", "13", "51.31927", "4.85304", "Europe/Brussels"),("2802437", "Beernem", "", "BE", "56", "", "VLG", "VWV", "31", "51.13981", "3.33896", "Europe/Brussels"),("2802483", "Beauvechain", "", "BE", "56", "", "WAL", "WBR", "25", "50.78195", "4.7718", "Europe/Brussels"),("2802501", "Beauraing", "", "BE", "56", "", "WAL", "WNA", "91", "50.11042", "4.95554", "Europe/Brussels"),("2802510", "Beaumont", "", "BE", "56", "", "WAL", "WHT", "56", "50.23699", "4.23926", "Europe/Brussels"),("2802583", "Bastogne", "", "BE", "56", "", "WAL", "WLX", "82", "50.00347", "5.71844", "Europe/Brussels"),("2802606", "Bassenge", "", "BE", "56", "", "WAL", "WLG", "62", "50.75883", "5.60989", "Europe/Brussels"),("2802610", "Basse Lasne", "", "BE", "56", "", "WAL", "WHT", "", "50.69503", "4.49218", "Europe/Brussels"),("2802743", "Balen", "", "BE", "56", "", "VLG", "VAN", "13", "51.16837", "5.17027", "Europe/Brussels"),("2802837", "Aywaille", "", "BE", "56", "", "WAL", "WLG", "62", "50.47411", "5.67684", "Europe/Brussels"),("2802849", "Awans", "", "BE", "56", "", "WAL", "WLG", "62", "50.66774", "5.46329", "Europe/Brussels"),("2802871", "Avelgem", "", "BE", "56", "", "VLG", "VWV", "34", "50.77618", "3.44502", "Europe/Brussels"),("2802990", "Aubange", "", "BE", "56", "", "WAL", "WLX", "81", "49.56652", "5.80492", "Europe/Brussels"),("2803010", "Ath", "Ат", "BE", "56", "", "WAL", "WHT", "51", "50.62937", "3.77801", "Europe/Brussels"),("2803018", "Assesse", "", "BE", "56", "", "WAL", "WNA", "92", "50.36934", "5.02204", "Europe/Brussels"),("2803026", "Assenede", "", "BE", "56", "", "VLG", "VOV", "43", "51.22598", "3.75085", "Europe/Brussels"),("2803033", "Asse", "Ассо", "BE", "56", "", "VLG", "VBR", "23", "50.91011", "4.19836", "Europe/Brussels"),("2803053", "As", "", "BE", "56", "", "VLG", "VLI", "71", "51.00755", "5.58453", "Europe/Brussels"),("2803073", "Arlon", "Арлон", "BE", "56", "", "WAL", "WLX", "81", "49.68333", "5.81667", "Europe/Brussels"),("2803083", "Arendonk", "", "BE", "56", "", "VLG", "VAN", "13", "51.32267", "5.08289", "Europe/Brussels"),("2803091", "Ardooie", "", "BE", "56", "", "VLG", "VWV", "37", "50.9757", "3.19736", "Europe/Brussels"),("2803130", "Anzegem", "", "BE", "56", "", "VLG", "VWV", "34", "50.837", "3.47786", "Europe/Brussels"),("2803138", "Antwerpen", "Антверпен", "BE", "56", "", "VLG", "VAN", "11", "51.21989", "4.40346", "Europe/Brussels"),("2803144", "Antoing", "", "BE", "56", "", "WAL", "WHT", "57", "50.56765", "3.4492", "Europe/Brussels"),("2803160", "Ans", "Анс", "BE", "56", "", "WAL", "WLG", "62", "50.6623", "5.52029", "Europe/Brussels"),("2803174", "Anhée", "", "BE", "56", "", "WAL", "WNA", "91", "50.31039", "4.87827", "Europe/Brussels"),("2803199", "Anderlues", "", "BE", "56", "", "WAL", "WHT", "56", "50.40704", "4.27136", "Europe/Brussels"),("2803204", "Andenne", "Анден", "BE", "56", "", "WAL", "WNA", "92", "50.48941", "5.09513", "Europe/Brussels"),("2803242", "Amblève", "", "BE", "56", "", "WAL", "WLG", "63", "50.35357", "6.17002", "Europe/Brussels"),("2803246", "Amay", "", "BE", "56", "", "WAL", "WLG", "61", "50.54829", "5.30974", "Europe/Brussels"),("2803285", "Alken", "", "BE", "56", "", "VLG", "VLI", "73", "50.87553", "5.30558", "Europe/Brussels"),("2803323", "Aiseau", "", "BE", "56", "", "WAL", "WHT", "52", "50.41158", "4.58671", "Europe/Brussels"),("2803420", "Aartselaar", "", "BE", "56", "", "VLG", "VAN", "11", "51.13412", "4.38678", "Europe/Brussels"),("2803429", "Aarschot", "Ааршот", "BE", "56", "", "VLG", "VBR", "24", "50.98715", "4.83695", "Europe/Brussels"),("2803443", "Aalter", "Алтер", "BE", "56", "", "VLG", "VOV", "44", "51.09017", "3.44693", "Europe/Brussels"),("2803448", "Aalst", "", "BE", "56", "", "VLG", "VOV", "41", "50.93604", "4.0355", "Europe/Brussels"),("2353197", "Zorgo", "", "BF", "854", "", "11", "20", "", "12.24922", "-0.61527", "Africa/Ouagadougou"),("2353257", "Ziniaré", "", "BF", "854", "", "11", "68", "", "12.58186", "-1.2971", "Africa/Ouagadougou"),("2353688", "Yako", "Яко", "BF", "854", "", "10", "34", "", "12.9591", "-2.26075", "Africa/Ouagadougou"),("2354176", "Tougan", "", "BF", "854", "", "01", "73", "", "13.0725", "-3.0694", "Africa/Ouagadougou"),("2354265", "Toma", "", "BF", "854", "", "01", "66", "", "12.75844", "-2.89879", "Africa/Ouagadougou"),("2354349", "Titao", "", "BF", "854", "", "10", "62", "", "13.76667", "-2.06667", "Africa/Ouagadougou"),("2354675", "Tenkodogo", "", "BF", "854", "", "04", "49", "", "11.78", "-0.36972", "Africa/Ouagadougou"),("2355404", "Salanso", "", "BF", "854", "", "01", "46", "", "12.17423", "-4.08477", "Africa/Ouagadougou"),("2356228", "Réo", "Рео", "BF", "854", "", "06", "36", "", "12.31963", "-2.47094", "Africa/Ouagadougou"),("2356454", "Pô", "", "BF", "854", "", "07", "65", "", "11.16972", "-1.145", "Africa/Ouagadougou"),("2356459", "Pitmoaga", "", "BF", "854", "", "06", "19", "", "12.23972", "-1.87667", "Africa/Ouagadougou"),("2356738", "Pama", "", "BF", "854", "BF", "08", "57", "", "11.24972", "0.7075", "Africa/Ouagadougou"),("2357012", "Ouargaye", "", "BF", "854", "", "04", "59", "", "11.50202", "0.05886", "Africa/Ouagadougou"),("2357043", "Ouahigouya", "", "BF", "854", "", "10", "76", "", "13.58278", "-2.42158", "Africa/Ouagadougou"),("2357048", "Ouagadougou", "Уагадугу", "BF", "854", "", "03", "53", "", "12.36566", "-1.53388", "Africa/Ouagadougou"),("2357163", "Nouna", "", "BF", "854", "", "01", "58", "", "12.72939", "-3.86305", "Africa/Ouagadougou"),("2358100", "Manga", "", "BF", "854", "", "07", "44", "", "11.66361", "-1.07306", "Africa/Ouagadougou"),("2358382", "Léo", "Лев", "BF", "854", "", "06", "72", "", "11.10033", "-2.10654", "Africa/Ouagadougou"),("2358738", "Koupéla", "", "BF", "854", "", "04", "28", "", "12.17864", "-0.35103", "Africa/Ouagadougou"),("2358946", "Koudougou", "Кудугу", "BF", "854", "", "06", "19", "", "12.25263", "-2.36272", "Africa/Ouagadougou"),("2359142", "Kongoussi", "", "BF", "854", "", "05", "15", "", "13.32583", "-1.53472", "Africa/Ouagadougou"),("2359227", "Kombissiri", "", "BF", "854", "", "07", "47", "", "12.06095", "-1.33355", "Africa/Ouagadougou"),("2359317", "Kokologo", "", "BF", "854", "", "06", "19", "", "12.18972", "-1.88556", "Africa/Ouagadougou"),("2359608", "Kaya", "Кая", "BF", "854", "", "05", "70", "", "13.09167", "-1.08444", "Africa/Ouagadougou"),("2360073", "Houndé", "", "BF", "854", "", "09", "74", "", "11.5", "-3.51667", "Africa/Ouagadougou"),("2360238", "Gourcy", "", "BF", "854", "", "10", "78", "", "13.20776", "-2.35893", "Africa/Ouagadougou"),("2360286", "Goulouré", "", "BF", "854", "", "06", "19", "", "12.2276", "-1.92922", "Africa/Ouagadougou"),("2360372", "Gorom-Gorom", "", "BF", "854", "", "12", "33", "", "14.4429", "-0.23468", "Africa/Ouagadougou"),("2360615", "Garango", "", "BF", "854", "", "04", "49", "", "11.8", "-0.55056", "Africa/Ouagadougou"),("2360886", "Fada N'gourma", "", "BF", "854", "", "08", "50", "", "12.06157", "0.35843", "Africa/Ouagadougou"),("2361082", "Dori", "Дори", "BF", "854", "", "12", "71", "", "14.0354", "-0.0345", "Africa/Ouagadougou"),("2361177", "Djibo", "Джибо", "BF", "854", "", "12", "40", "", "14.0994", "-1.62554", "Africa/Ouagadougou"),("2361342", "Diébougou", "", "BF", "854", "", "13", "48", "", "10.96209", "-3.24967", "Africa/Ouagadougou"),("2361373", "Diapaga", "Диапага", "BF", "854", "", "08", "42", "", "12.07305", "1.78838", "Africa/Ouagadougou"),("2361477", "Dédougou", "", "BF", "854", "", "01", "63", "", "12.46338", "-3.46075", "Africa/Ouagadougou"),("2361586", "Dano", "", "BF", "854", "", "13", "52", "", "11.1464", "-3.05784", "Africa/Ouagadougou"),("2361845", "Boussé", "", "BF", "854", "", "11", "60", "", "12.6576", "-1.89288", "Africa/Ouagadougou"),("2361946", "Boulsa", "", "BF", "854", "", "05", "64", "", "12.66664", "-0.57469", "Africa/Ouagadougou"),("2362150", "Boromo", "", "BF", "854", "", "01", "45", "", "11.74542", "-2.93006", "Africa/Ouagadougou"),("2362323", "Bogandé", "", "BF", "854", "", "08", "21", "", "12.9704", "-0.14953", "Africa/Ouagadougou"),("2362344", "Bobo-Dioulasso", "Бобо-Диуласо", "BF", "854", "", "09", "51", "", "11.17715", "-4.2979", "Africa/Ouagadougou"),("2362669", "Batié", "", "BF", "854", "", "13", "67", "", "9.88333", "-2.91667", "Africa/Ouagadougou"),("2362909", "Banfora", "Банфору", "BF", "854", "", "02", "55", "", "10.63333", "-4.76667", "Africa/Ouagadougou"),("2577162", "Gaoua", "", "BF", "854", "", "13", "69", "", "10.29917", "-3.25083", "Africa/Ouagadougou"),("2577164", "Orodara", "", "BF", "854", "", "09", "54", "", "10.94917", "-4.93417", "Africa/Ouagadougou"),("725213", "Beloslav", "", "BG", "100", "", "61", "VAR04", "", "43.18333", "27.7", "Europe/Sofia"),("725271", "Zlatograd", "", "BG", "100", "", "57", "SML11", "", "41.3795", "25.09605", "Europe/Sofia"),("725283", "Zlatitsa", "", "BG", "100", "", "58", "SFO47", "", "42.71667", "24.13333", "Europe/Sofia"),("725578", "Yambol", "", "BG", "100", "", "65", "JAM26", "", "42.48333", "26.5", "Europe/Sofia"),("725586", "Yakoruda", "", "BG", "100", "", "38", "BLG53", "", "42.02528", "23.68417", "Europe/Sofia"),("725623", "Varshets", "", "BG", "100", "", "47", "MON12", "", "43.19528", "23.28611", "Europe/Sofia"),("725683", "Valchedram", "", "BG", "100", "", "47", "MON11", "", "43.69639", "23.44472", "Europe/Sofia"),("725712", "Vratsa", "Враца", "BG", "100", "", "64", "VRC10", "", "43.21", "23.5625", "Europe/Sofia"),("725905", "Vidin", "Видин", "BG", "100", "", "63", "VID09", "", "43.99", "22.8725", "Europe/Sofia"),("725935", "Vetovo", "", "BG", "100", "", "53", "RSE05", "", "43.7", "26.26667", "Europe/Sofia"),("725988", "Velingrad", "Велинград", "BG", "100", "", "48", "PAZ08", "", "42.02754", "23.99155", "Europe/Sofia"),("725993", "Veliko Tŭrnovo", "", "BG", "100", "", "62", "VTR04", "", "43.08124", "25.62904", "Europe/Sofia"),("726050", "Varna", "Варна", "BG", "100", "", "61", "VAR06", "", "43.21667", "27.91667", "Europe/Sofia"),("726130", "Tvarditsa", "", "BG", "100", "", "56", "SLV24", "", "42.7", "25.9", "Europe/Sofia"),("726141", "Tutrakan", "", "BG", "100", "", "55", "SLS34", "", "44.05", "26.61667", "Europe/Sofia"),("726174", "Targovishte", "", "BG", "100", "", "60", "TGV35", "", "43.2512", "26.57215", "Europe/Sofia"),("726287", "Tryavna", "", "BG", "100", "", "41", "GAB35", "", "42.86667", "25.5", "Europe/Sofia"),("726320", "Troyan", "", "BG", "100", "", "46", "LOV34", "", "42.89427", "24.71589", "Europe/Sofia"),("726384", "Topolovgrad", "", "BG", "100", "", "43", "HKV32", "", "42.08333", "26.33333", "Europe/Sofia"),("726418", "Dobrich", "Добрич", "BG", "100", "", "40", "DOB28", "", "43.56667", "27.83333", "Europe/Sofia"),("726464", "Teteven", "", "BG", "100", "", "46", "LOV33", "", "42.91667", "24.26667", "Europe/Sofia"),("726474", "Tervel", "", "BG", "100", "", "40", "DOB27", "", "43.75", "27.4", "Europe/Sofia"),("726524", "Svoge", "", "BG", "100", "", "58", "SFO43", "", "42.96667", "23.35", "Europe/Sofia"),("726534", "Svishtov", "", "BG", "100", "", "62", "VTR28", "", "43.61959", "25.35044", "Europe/Sofia"),("726546", "Svilengrad", "Свиленград", "BG", "100", "", "43", "HKV28", "", "41.76667", "26.2", "Europe/Sofia"),("726657", "Saedinenie", "", "BG", "100", "", "51", "PDV33", "", "42.26667", "24.55", "Europe/Sofia"),("726727", "Strazhitsa", "", "BG", "100", "BG", "62", "VTR31", "", "43.23333", "25.96667", "Europe/Sofia"),("726748", "Straldzha", "", "BG", "100", "", "65", "JAM22", "", "42.6", "26.68333", "Europe/Sofia"),("726848", "Stara Zagora", "Стара-Загора", "BG", "100", "", "59", "SZR31", "", "42.43278", "25.64194", "Europe/Sofia"),("726872", "Dupnitsa", "", "BG", "100", "", "45", "KNL48", "", "42.26667", "23.11667", "Europe/Sofia"),("726890", "Stamboliyski", "", "BG", "100", "", "51", "", "", "42.13333", "24.53333", "Europe/Sofia"),("727011", "Sofia", "София", "BG", "100", "", "42", "SOF46", "", "42.69751", "23.32415", "Europe/Sofia"),("727030", "Smolyan", "", "BG", "100", "", "57", "SML31", "", "41.58528", "24.69194", "Europe/Sofia"),("727069", "Slivnitsa", "", "BG", "100", "", "58", "SFO45", "", "42.85182", "23.03792", "Europe/Sofia"),("727079", "Sliven", "Сливен", "BG", "100", "", "56", "SLV20", "", "42.68583", "26.32917", "Europe/Sofia"),("727212", "Simitli", "", "BG", "100", "", "38", "BLG44", "", "41.88333", "23.11667", "Europe/Sofia"),("727217", "Simeonovgrad", "", "BG", "100", "", "43", "HKV29", "", "42.03333", "25.83333", "Europe/Sofia"),("727221", "Silistra", "Силистра", "BG", "100", "", "55", "SLS31", "", "44.11667", "27.26667", "Europe/Sofia"),("727233", "Shumen", "", "BG", "100", "", "54", "SHU30", "", "43.27064", "26.92286", "Europe/Sofia"),("727337", "Sevlievo", "", "BG", "100", "", "41", "GAB29", "", "43.02583", "25.11361", "Europe/Sofia"),("727354", "Septemvri", "", "BG", "100", "", "48", "PAZ29", "", "42.21667", "24.1", "Europe/Sofia"),("727447", "Sandanski", "", "BG", "100", "", "38", "BLG40", "", "41.56667", "23.28333", "Europe/Sofia"),("727462", "Samokov", "", "BG", "100", "", "58", "SFO39", "", "42.337", "23.5528", "Europe/Sofia"),("727523", "Ruse", "Русе", "BG", "100", "", "53", "RSE27", "", "43.85639", "25.97083", "Europe/Sofia"),("727689", "Razlog", "", "BG", "100", "", "38", "BLG37", "", "41.8863", "23.46714", "Europe/Sofia"),("727696", "Razgrad", "Разград", "BG", "100", "", "52", "RAZ26", "", "43.53333", "26.51667", "Europe/Sofia"),("727791", "Rakovski", "", "BG", "100", "", "51", "PDV25", "", "42.3", "24.96667", "Europe/Sofia"),("727801", "Rakitovo", "", "BG", "100", "", "48", "PAZ24", "", "41.98333", "24.08333", "Europe/Sofia"),("727832", "Radomir", "", "BG", "100", "", "49", "PER36", "", "42.54444", "22.95778", "Europe/Sofia"),("727838", "Radnevo", "", "BG", "100", "", "59", "SZR27", "", "42.3", "25.93333", "Europe/Sofia"),("727921", "Provadia", "", "BG", "100", "", "61", "VAR24", "", "43.18333", "27.43333", "Europe/Sofia"),("727987", "Veliki Preslav", "", "BG", "100", "", "54", "SHU23", "", "43.16667", "26.81667", "Europe/Sofia"),("728075", "Popovo", "", "BG", "100", "", "60", "TGV24", "", "43.35", "26.23333", "Europe/Sofia"),("728108", "Pomorie", "", "BG", "100", "", "39", "BGS17", "", "42.55882", "27.64393", "Europe/Sofia"),("728124", "Polski Trambesh", "", "BG", "100", "", "62", "VTR26", "", "43.38361", "25.64972", "Europe/Sofia"),("728193", "Plovdiv", "Пловдив", "BG", "100", "", "51", "PDV22", "", "42.15", "24.75", "Europe/Sofia"),("728203", "Pleven", "Плевен", "BG", "100", "", "50", "PVN24", "", "43.41667", "24.61667", "Europe/Sofia"),("728251", "Pirdop", "", "BG", "100", "", "58", "SFO55", "", "42.7", "24.18333", "Europe/Sofia"),("728288", "Petrich", "Петрич", "BG", "100", "", "38", "BLG33", "", "41.39846", "23.20702", "Europe/Sofia"),("728317", "Peshtera", "", "BG", "100", "", "48", "PAZ21", "", "42.03333", "24.3", "Europe/Sofia"),("728321", "Perushtitsa", "", "BG", "100", "", "51", "PDV40", "", "42.05", "24.55", "Europe/Sofia"),("728330", "Pernik", "Перник", "BG", "100", "", "49", "PER32", "", "42.6", "23.03333", "Europe/Sofia"),("728378", "Pazardzhik", "Пазарджик", "BG", "100", "", "48", "PAZ19", "", "42.2", "24.33333", "Europe/Sofia"),("728385", "Pavlikeni", "", "BG", "100", "", "62", "VTR22", "", "43.24278", "25.32194", "Europe/Sofia"),("728448", "Panagyurishte", "", "BG", "100", "", "48", "PAZ20", "", "42.5", "24.18333", "Europe/Sofia"),("728565", "Oryahovo", "", "BG", "100", "", "64", "VRC31", "", "43.73333", "23.96667", "Europe/Sofia"),("728634", "Omurtag", "", "BG", "100", "", "60", "TGV22", "", "43.1", "26.41667", "Europe/Sofia"),("728734", "Novi Pazar", "", "BG", "100", "", "54", "SHU22", "", "43.35", "27.2", "Europe/Sofia"),("728742", "Nova Zagora", "", "BG", "100", "", "56", "SLV16", "", "42.48333", "26.01667", "Europe/Sofia"),("728825", "Nesebar", "", "BG", "100", "", "39", "BGS15", "", "42.65921", "27.73602", "Europe/Sofia"),("728851", "Nedelino", "", "BG", "100", "", "57", "SML18", "", "41.45602", "25.08008", "Europe/Sofia"),("729114", "Montana", "Монтана", "BG", "100", "", "47", "MON29", "", "43.4125", "23.225", "Europe/Sofia"),("729125", "Tsarevo", "", "BG", "100", "BG", "39", "BGS13", "", "42.16955", "27.84541", "Europe/Sofia"),("729134", "Mezdra", "", "BG", "100", "", "64", "VRC27", "", "43.15", "23.7", "Europe/Sofia"),("729439", "Madan", "", "BG", "100", "", "57", "SML16", "", "41.49869", "24.93973", "Europe/Sofia"),("729466", "Lyubimets", "", "BG", "100", "", "43", "HKV17", "", "41.83333", "26.08333", "Europe/Sofia"),("729489", "Lyaskovets", "", "BG", "100", "", "62", "VTR20", "", "43.11111", "25.72833", "Europe/Sofia"),("729507", "Lukovit", "", "BG", "100", "", "46", "LOV19", "", "43.2", "24.16667", "Europe/Sofia"),("729559", "Lovech", "Ловеч", "BG", "100", "", "46", "LOV18", "", "43.13333", "24.71667", "Europe/Sofia"),("729581", "Lom", "", "BG", "100", "", "47", "MON24", "", "43.81389", "23.23611", "Europe/Sofia"),("729636", "Levski", "", "BG", "100", "", "50", "PVN16", "", "43.36667", "25.13333", "Europe/Sofia"),("729730", "Kyustendil", "", "BG", "100", "", "45", "KNL29", "", "42.28389", "22.69111", "Europe/Sofia"),("729794", "Kardzhali", "Кырджали", "BG", "100", "", "44", "KRZ16", "", "41.65", "25.36667", "Europe/Sofia"),("729839", "Kubrat", "", "BG", "100", "", "52", "RAZ16", "", "43.8", "26.5", "Europe/Sofia"),("729896", "Krumovgrad", "", "BG", "100", "", "44", "KRZ15", "", "41.47127", "25.65485", "Europe/Sofia"),("729936", "Krichim", "", "BG", "100", "", "51", "PDV39", "", "42.05", "24.46667", "Europe/Sofia"),("730013", "Kozloduy", "", "BG", "100", "", "64", "VRC20", "", "43.78333", "23.73333", "Europe/Sofia"),("730073", "Kotel", "", "BG", "100", "", "56", "SLV11", "", "42.88333", "26.45", "Europe/Sofia"),("730084", "Kostinbrod", "", "BG", "100", "", "58", "SFO26", "", "42.81667", "23.21667", "Europe/Sofia"),("730287", "Knezha", "", "BG", "100", "", "50", "PVN39", "", "43.5", "24.08333", "Europe/Sofia"),("730419", "Hisarya", "", "BG", "100", "", "51", "PDV37", "", "42.5", "24.7", "Europe/Sofia"),("730435", "Haskovo", "Хасково", "BG", "100", "", "43", "HKV34", "", "41.93415", "25.55557", "Europe/Sofia"),("730442", "Harmanli", "", "BG", "100", "", "43", "HKV33", "", "41.93333", "25.9", "Europe/Sofia"),("730496", "Kazanlak", "Казанлык", "BG", "100", "", "59", "SZR12", "", "42.61667", "25.4", "Europe/Sofia"),("730518", "Kavarna", "", "BG", "100", "", "40", "DOB17", "", "43.43333", "28.33333", "Europe/Sofia"),("730559", "Karnobat", "", "BG", "100", "", "39", "BGS09", "", "42.65", "26.98333", "Europe/Sofia"),("730565", "Karlovo", "Карлово", "BG", "100", "", "51", "PDV13", "", "42.63333", "24.8", "Europe/Sofia"),("730866", "Isperih", "", "BG", "100", "", "52", "RAZ14", "", "43.71667", "26.83333", "Europe/Sofia"),("730919", "Ihtiman", "", "BG", "100", "", "58", "SFO20", "", "42.43333", "23.81667", "Europe/Sofia"),("730987", "Gŭlŭbovo", "", "BG", "100", "BG", "59", "", "", "42.13333", "25.85", "Europe/Sofia"),("731016", "Sredets", "", "BG", "100", "", "39", "BGS06", "", "42.34747", "27.17898", "Europe/Sofia"),("731108", "Gotse Delchev", "Гоце-Делчев", "BG", "100", "", "38", "BLG11", "", "41.56667", "23.73333", "Europe/Sofia"),("731233", "Gorna Oryahovitsa", "Горна Оряховица", "BG", "100", "", "62", "VTR06", "", "43.12778", "25.70167", "Europe/Sofia"),("731384", "Godech", "", "BG", "100", "", "58", "SFO09", "", "43.01682", "23.04852", "Europe/Sofia"),("731453", "Dolni Chiflik", "", "BG", "100", "BG", "61", "VAR13", "", "42.98333", "27.71667", "Europe/Sofia"),("731464", "General-Toshevo", "", "BG", "100", "", "40", "", "", "43.7", "28.03333", "Europe/Sofia"),("731549", "Gabrovo", "Габрово", "BG", "100", "BG", "41", "GAB05", "", "42.87472", "25.33417", "Europe/Sofia"),("731626", "Etropole", "", "BG", "100", "", "58", "SFO18", "", "42.83333", "24", "Europe/Sofia"),("731670", "Elhovo", "", "BG", "100", "", "65", "JAM07", "", "42.16667", "26.56667", "Europe/Sofia"),("731675", "Elin Pelin", "", "BG", "100", "", "58", "SFO17", "SFO17-05", "42.66667", "23.6", "Europe/Sofia"),("731696", "Elena", "", "BG", "100", "", "62", "HKV34", "HKV34-12", "42.93333", "25.88333", "Europe/Sofia"),("731818", "Dulovo", "", "BG", "100", "", "55", "SLS10", "", "43.81667", "27.15", "Europe/Sofia"),("731822", "Dalgopol", "", "BG", "100", "", "61", "VAR16", "", "43.05", "27.35", "Europe/Sofia"),("731882", "Dryanovo", "", "BG", "100", "", "41", "GAB12", "", "42.97897", "25.4785", "Europe/Sofia"),("732099", "Dolni Dabnik", "", "BG", "100", "", "50", "PVN11", "", "43.4", "24.43333", "Europe/Sofia"),("732263", "Dimitrovgrad", "Димитровград", "BG", "100", "", "43", "HKV09", "", "42.05", "25.6", "Europe/Sofia"),("732280", "Devnya", "", "BG", "100", "", "61", "VAR14", "", "43.22222", "27.56944", "Europe/Sofia"),("732285", "Devin", "", "BG", "100", "", "57", "SML09", "", "41.74327", "24.40003", "Europe/Sofia"),("732452", "Chirpan", "", "BG", "100", "", "59", "SZR36", "", "42.2", "25.33333", "Europe/Sofia"),("732491", "Cherven Bryag", "", "BG", "100", "", "50", "PVN37", "", "43.26667", "24.1", "Europe/Sofia"),("732627", "Chepelare", "", "BG", "100", "", "57", "SML38", "", "41.73333", "24.68333", "Europe/Sofia"),("732704", "Byala Slatina", "", "BG", "100", "", "64", "VRC08", "", "43.46667", "23.93333", "Europe/Sofia"),("732770", "Burgas", "Бургас", "BG", "100", "", "39", "BGS04", "", "42.50606", "27.46781", "Europe/Sofia"),("733014", "Botevgrad", "", "BG", "100", "", "58", "SFO07", "", "42.9", "23.78333", "Europe/Sofia"),("733151", "Bobovdol", "", "BG", "100", "", "45", "KNL04", "", "42.36972", "23.01722", "Europe/Sofia"),("733191", "Blagoevgrad", "Благоевград", "BG", "100", "", "38", "BLG03", "", "42.01667", "23.1", "Europe/Sofia"),("733264", "Berkovitsa", "", "BG", "100", "", "47", "MON02", "", "43.23611", "23.12583", "Europe/Sofia"),("733309", "Belogradchik", "", "BG", "100", "", "63", "VID01", "", "43.62722", "22.68361", "Europe/Sofia"),("733359", "Belene", "", "BG", "100", "", "50", "PVN03", "", "43.65", "25.11667", "Europe/Sofia"),("733462", "Bansko", "", "BG", "100", "", "38", "BLG01", "", "41.8383", "23.48851", "Europe/Sofia"),("733515", "Balchik", "", "BG", "100", "BG", "40", "DOB03", "", "43.41667", "28.16667", "Europe/Sofia"),("733579", "Aytos", "", "BG", "100", "", "39", "BGS01", "", "42.7", "27.25", "Europe/Sofia"),("733618", "Asenovgrad", "", "BG", "100", "", "51", "PDV01", "", "42.01667", "24.86667", "Europe/Sofia"),("733716", "Aksakovo", "", "BG", "100", "BG", "61", "VAR02", "", "43.25", "27.81667", "Europe/Sofia"),("6355004", "Zlatni Pyasatsi", "", "BG", "100", "", "61", "VAR06", "", "43.285", "28.0418", "Europe/Sofia"),("422232", "Makamba", "Макамба", "BI", "108", "", "17", "", "", "-4.1348", "29.804", "Africa/Bujumbura"),("423328", "Bururi", "Бурури", "BI", "108", "", "10", "", "", "-3.94877", "29.62438", "Africa/Bujumbura"),("423549", "Rumonge", "", "BI", "108", "", "26", "9158023", "", "-3.9736", "29.4386", "Africa/Bujumbura"),("423794", "Mwaro", "", "BI", "108", "", "23", "", "", "-3.51128", "29.70334", "Africa/Bujumbura"),("425336", "Isale", "", "BI", "108", "", "25", "", "", "-3.3489", "29.4839", "Africa/Bujumbura"),("425378", "Bujumbura", "Бужумбура", "BI", "108", "", "24", "", "", "-3.3822", "29.3644", "Africa/Bujumbura"),("425551", "Muramvya", "", "BI", "108", "", "22", "", "", "-3.2682", "29.6079", "Africa/Bujumbura"),("426272", "Gitega", "Гитеге", "BI", "108", "", "13", "", "", "-3.4264", "29.9308", "Africa/Bujumbura"),("426700", "Ruyigi", "Руйиги", "BI", "108", "", "21", "", "", "-3.47639", "30.24861", "Africa/Bujumbura"),("427701", "Cankuzo", "", "BI", "108", "", "11", "", "", "-3.2186", "30.5528", "Africa/Bujumbura"),("428219", "Karuzi", "", "BI", "108", "", "14", "", "", "-3.10139", "30.16278", "Africa/Bujumbura"),("428515", "Bubanza", "", "BI", "108", "", "09", "", "", "-3.0804", "29.391", "Africa/Bujumbura"),("430021", "Cibitoke", "", "BI", "108", "", "12", "", "", "-2.8869", "29.1248", "Africa/Bujumbura"),("430569", "Ngozi", "Нгози", "BI", "108", "", "19", "", "", "-2.9075", "29.8306", "Africa/Bujumbura"),("430952", "Kayanza", "", "BI", "108", "", "15", "", "", "-2.9221", "29.6293", "Africa/Bujumbura"),("431748", "Muyinga", "Муйинга", "BI", "108", "", "18", "", "", "-2.8451", "30.3414", "Africa/Bujumbura"),("432456", "Kirundo", "", "BI", "108", "", "16", "", "", "-2.5845", "30.0959", "Africa/Bujumbura"),("433635", "Rutana", "Рутана", "BI", "108", "", "20", "", "", "-3.9279", "29.992", "Africa/Bujumbura"),("2391377", "Tchaourou", "", "BJ", "204", "", "10", "", "", "8.88649", "2.59753", "Africa/Porto-Novo"),("2391455", "Tanguiéta", "", "BJ", "204", "", "08", "", "", "10.62118", "1.26651", "Africa/Porto-Novo"),("2391893", "Savé", "", "BJ", "204", "", "11", "", "", "8.03424", "2.4866", "Africa/Porto-Novo"),("2391895", "Savalou", "", "BJ", "204", "", "11", "", "", "7.92807", "1.97558", "Africa/Porto-Novo"),("2392009", "Sakété", "", "BJ", "204", "", "17", "", "", "6.73618", "2.65866", "Africa/Porto-Novo"),("2392087", "Porto-Novo", "Порто-Ново", "BJ", "204", "", "16", "", "", "6.49646", "2.60359", "Africa/Porto-Novo"),("2392108", "Pobé", "", "BJ", "204", "", "17", "", "", "6.98008", "2.6649", "Africa/Porto-Novo"),("2392204", "Parakou", "Параку", "BJ", "204", "", "10", "", "", "9.33716", "2.63031", "Africa/Porto-Novo"),("2392308", "Ouidah", "Виды", "BJ", "204", "", "09", "", "", "6.36307", "2.08506", "Africa/Porto-Novo"),("2392505", "Nikki", "Никки", "BJ", "204", "", "10", "", "", "9.94009", "3.21075", "Africa/Porto-Novo"),("2392601", "Natitingou", "Натитингу", "BJ", "204", "", "08", "", "", "10.30416", "1.37962", "Africa/Porto-Novo"),("2392837", "Malanville", "Маланвилем", "BJ", "204", "", "08", "", "", "11.86819", "3.38327", "Africa/Porto-Novo"),("2392897", "Lokossa", "", "BJ", "204", "", "15", "", "", "6.63869", "1.71674", "Africa/Porto-Novo"),("2393551", "Kétou", "", "BJ", "204", "", "17", "", "", "7.36332", "2.59978", "Africa/Porto-Novo"),("2393693", "Kandi", "Канди", "BJ", "204", "", "07", "", "", "11.13417", "2.93861", "Africa/Porto-Novo"),("2393887", "Hévié", "", "BJ", "204", "", "09", "", "", "6.41667", "2.25", "Africa/Porto-Novo"),("2393917", "Guilmaro", "", "BJ", "204", "", "08", "", "", "10.56583", "1.72444", "Africa/Porto-Novo"),("2393947", "Grand-Popo", "", "BJ", "204", "", "15", "", "", "6.28036", "1.82251", "Africa/Porto-Novo"),("2394545", "Dogbo", "", "BJ", "204", "", "12", "", "", "6.81667", "1.78333", "Africa/Porto-Novo"),("2394560", "Djougou", "", "BJ", "204", "", "13", "", "", "9.70853", "1.66598", "Africa/Porto-Novo"),("2394711", "Dassa-Zoumé", "", "BJ", "204", "", "11", "", "", "7.75", "2.18333", "Africa/Porto-Novo"),("2394814", "Cové", "", "BJ", "204", "", "18", "", "", "7.22097", "2.34017", "Africa/Porto-Novo"),("2394819", "Cotonou", "Котону", "BJ", "204", "", "14", "", "", "6.36536", "2.41833", "Africa/Porto-Novo"),("2394824", "Comé", "", "BJ", "204", "", "15", "", "", "6.40764", "1.88198", "Africa/Porto-Novo"),("2395049", "Bohicon", "", "BJ", "204", "", "18", "", "", "7.17826", "2.0667", "Africa/Porto-Novo"),("2395127", "Bétérou", "", "BJ", "204", "", "10", "", "", "9.19916", "2.25855", "Africa/Porto-Novo"),("2395182", "Bembèrèkè", "", "BJ", "204", "", "10", "", "", "10.22827", "2.66335", "Africa/Porto-Novo"),("2395261", "Bassila", "", "BJ", "204", "", "13", "", "", "9.00814", "1.6654", "Africa/Porto-Novo"),("2395317", "Banikoara", "", "BJ", "204", "", "07", "", "", "11.29845", "2.43856", "Africa/Porto-Novo"),("2395568", "Aplahoué", "", "BJ", "204", "", "12", "", "", "6.93333", "1.68333", "Africa/Porto-Novo"),("2395635", "Allada", "", "BJ", "204", "", "09", "", "", "6.66547", "2.15138", "Africa/Porto-Novo"),("2395914", "Abomey-Calavi", "Абомей-Калави", "BJ", "204", "", "09", "", "", "6.44852", "2.35566", "Africa/Porto-Novo"),("2395915", "Abomey", "Абомей", "BJ", "204", "", "18", "", "", "7.18286", "1.99119", "Africa/Porto-Novo"),("3444105", "San Matías", "", "BO", "68", "", "08", "0712", "10400576", "-16.36667", "-58.4", "America/La_Paz"),("3444176", "Roboré", "", "BO", "68", "", "08", "0705", "", "-18.33473", "-59.76142", "America/La_Paz"),("3444201", "Puerto Quijarro", "", "BO", "68", "", "08", "", "", "-17.78333", "-57.76667", "America/La_Paz"),("3901178", "Yacuiba", "Якуиба", "BO", "68", "", "09", "0603", "", "-22.01643", "-63.67753", "America/La_Paz"),("3901301", "Warnes", "", "BO", "68", "", "08", "", "", "-17.5163", "-63.16778", "America/La_Paz"),("3901501", "Villazón", "Вильясон", "BO", "68", "", "07", "", "", "-22.08659", "-65.59422", "America/La_Paz"),("3901504", "Villa Yapacaní", "", "BO", "68", "", "08", "", "", "-17.4", "-63.83333", "America/La_Paz"),("3901547", "Villamontes", "Вилья-Монтес", "BO", "68", "", "09", "", "", "-21.26235", "-63.46903", "America/La_Paz"),("3901874", "Vallegrande", "", "BO", "68", "", "08", "", "", "-18.48923", "-64.10609", "America/La_Paz"),("3901903", "Uyuni", "", "BO", "68", "", "07", "", "", "-20.45967", "-66.82503", "America/La_Paz"),("3902202", "Tupiza", "", "BO", "68", "", "07", "", "", "-21.44345", "-65.71875", "America/La_Paz"),("3902377", "Trinidad", "Тринидад", "BO", "68", "", "03", "", "", "-14.83333", "-64.9", "America/La_Paz"),("3903320", "Tarija", "Тариха", "BO", "68", "", "09", "", "", "-21.53549", "-64.72956", "America/La_Paz"),("3903342", "Tarata", "", "BO", "68", "", "02", "", "", "-17.60898", "-66.02135", "America/La_Paz"),("3903987", "Sucre", "Сукре", "BO", "68", "", "01", "", "", "-19.03332", "-65.26274", "America/La_Paz"),("3904666", "Santiago del Torno", "", "BO", "68", "", "08", "", "", "-17.98674", "-63.38118", "America/La_Paz"),("3904729", "Santa Rosa del Sara", "", "BO", "68", "", "08", "", "", "-17.10916", "-63.59514", "America/La_Paz"),("3904906", "Santa Cruz de la Sierra", "Санта-Крус-де-ла-Сиерра", "BO", "68", "", "08", "", "", "-17.78629", "-63.18117", "America/La_Paz"),("3905159", "San Pedro", "", "BO", "68", "BO", "04", "", "", "-16.23717", "-68.85063", "America/La_Paz"),("3905453", "San Julian", "", "BO", "68", "", "08", "", "", "-17.78333", "-62.86667", "America/La_Paz"),("3905658", "San Ignacio de Velasco", "", "BO", "68", "", "08", "", "", "-16.36667", "-60.95", "America/La_Paz"),("3905792", "San Borja", "", "BO", "68", "", "03", "", "", "-14.81667", "-66.85", "America/La_Paz"),("3906209", "Rurrenabaque", "", "BO", "68", "", "03", "", "", "-14.44125", "-67.52781", "America/La_Paz"),("3906466", "Riberalta", "", "BO", "68", "", "03", "0802", "10173550", "-11.00654", "-66.06312", "America/La_Paz"),("3906478", "Reyes", "", "BO", "68", "", "03", "3915596", "", "-14.2952", "-67.33624", "America/La_Paz"),("3907080", "Punata", "", "BO", "68", "", "02", "", "", "-17.54234", "-65.83472", "America/La_Paz"),("3907584", "Potosí", "Потоси", "BO", "68", "", "07", "", "", "-19.58361", "-65.75306", "America/La_Paz"),("3907646", "Portachuelo", "", "BO", "68", "", "08", "", "", "-17.35168", "-63.39282", "America/La_Paz"),("3908339", "Patacamaya", "", "BO", "68", "", "04", "", "", "-17.2358", "-67.92169", "America/La_Paz"),("3909010", "Pailón", "", "BO", "68", "", "08", "", "", "-17.65", "-62.75", "America/La_Paz"),("3909234", "Oruro", "Оруро", "BO", "68", "", "05", "", "", "-17.98333", "-67.15", "America/La_Paz"),("3910027", "Montero", "Монтеро", "BO", "68", "", "08", "", "", "-17.33866", "-63.2505", "America/La_Paz"),("3910094", "Monteagudo", "", "BO", "68", "", "01", "", "", "-19.79989", "-63.95461", "America/La_Paz"),("3910291", "Mizque", "", "BO", "68", "", "02", "", "", "-17.94101", "-65.34016", "America/La_Paz"),("3910343", "Mineros", "", "BO", "68", "", "08", "", "", "-17.11876", "-63.231", "America/La_Paz"),("3911409", "Llallagua", "", "BO", "68", "", "07", "", "", "-18.42426", "-66.58388", "America/La_Paz"),("3911925", "La Paz", "Ла-Пас", "BO", "68", "", "04", "", "", "-16.5", "-68.15", "America/La_Paz"),("3912418", "La Bélgica", "", "BO", "68", "", "08", "", "", "-17.55", "-63.21667", "America/La_Paz"),("3914839", "Huanuni", "", "BO", "68", "", "05", "", "", "-18.289", "-66.83583", "America/La_Paz"),("3915350", "Guayaramerín", "", "BO", "68", "", "03", "", "", "-10.83676", "-65.36136", "America/La_Paz"),("3918937", "Cotoca", "", "BO", "68", "", "08", "", "", "-17.81667", "-63.05", "America/La_Paz"),("3919352", "Concepción", "", "BO", "68", "", "08", "", "", "-16.43333", "-60.9", "America/La_Paz"),("3919884", "Colchani", "", "BO", "68", "", "07", "", "", "-20.3", "-66.93333", "America/La_Paz"),("3919968", "Cochabamba", "Кочабамба", "BO", "68", "", "02", "", "", "-17.3895", "-66.1568", "America/La_Paz"),("3919998", "Cobija", "Кобиха", "BO", "68", "", "06", "", "", "-11.02671", "-68.76918", "America/La_Paz"),("3920016", "Cliza", "", "BO", "68", "", "02", "", "", "-17.58777", "-65.93253", "America/La_Paz"),("3920736", "Chimoré", "", "BO", "68", "", "02", "", "", "-16.99417", "-65.1533", "America/La_Paz"),("3921355", "Challapata", "", "BO", "68", "", "05", "", "", "-18.90208", "-66.77048", "America/La_Paz"),("3922125", "Capinota", "", "BO", "68", "", "02", "", "", "-17.71113", "-66.26082", "America/La_Paz"),("3922414", "Camiri", "Камири", "BO", "68", "", "08", "", "", "-20.03849", "-63.51833", "America/La_Paz"),("3923644", "Ascensión", "", "BO", "68", "", "08", "", "", "-15.7", "-63.08333", "America/La_Paz"),("3924341", "Aiquile", "", "BO", "68", "", "02", "", "", "-18.20408", "-65.18068", "America/La_Paz"),("3924610", "Achacachi", "", "BO", "68", "", "04", "", "", "-16.05", "-68.68333", "America/La_Paz"),("3384983", "Vitorino Freire", "", "BR", "76", "", "13", "2107407", "", "-4.04238", "-45.23777", "America/Fortaleza"),("3384986", "Vitória do Mearim", "", "BR", "76", "", "13", "2112902", "", "-3.46222", "-44.87056", "America/Fortaleza"),("3384987", "Vitória de Santo Antão", "Витория-де-Санту-Антан", "BR", "76", "", "30", "2616407", "", "-8.11806", "-35.29139", "America/Recife"),("3385022", "Viseu", "", "BR", "76", "", "16", "1508308", "", "-1.19667", "-46.14", "America/Belem"),("3385077", "Conde", "", "BR", "76", "", "17", "2504603", "", "-7.25972", "-34.9075", "America/Fortaleza"),("3385088", "Vigia", "", "BR", "76", "", "16", "1508209", "", "-0.85833", "-48.14167", "America/Belem"),("3385106", "Viçosa do Ceará", "", "BR", "76", "", "06", "2314102", "", "-3.56222", "-41.09222", "America/Fortaleza"),("3385109", "Viçosa", "", "BR", "76", "", "02", "2709400", "", "-9.37139", "-36.24083", "America/Maceio"),("3385118", "Vicência", "", "BR", "76", "", "30", "2616308", "", "-7.65694", "-35.32667", "America/Recife"),("3385122", "Viana", "Виана", "BR", "76", "", "13", "2112803", "", "-3.22028", "-45.00361", "America/Fortaleza"),("3385467", "Várzea Alegre", "", "BR", "76", "", "06", "2305605", "", "-5.35", "-40.38333", "America/Fortaleza"),("3385504", "Varjota", "", "BR", "76", "", "06", "2313955", "", "-4.19444", "-40.47667", "America/Fortaleza"),("3385538", "Vargem Grande", "", "BR", "76", "", "13", "2112704", "", "-3.54306", "-43.91583", "America/Fortaleza"),("3385592", "Valença do Piauí", "", "BR", "76", "", "20", "2211308", "", "-6.4075", "-41.74556", "America/Fortaleza"),("3385645", "Urucurituba", "", "BR", "76", "", "04", "1304401", "", "-3.12845", "-58.15856", "America/Manaus"),("3385658", "Uruçuí", "", "BR", "76", "", "20", "2211209", "", "-7.22944", "-44.55611", "America/Fortaleza"),("3385670", "Urucará", "", "BR", "76", "", "04", "1304302", "", "-2.53639", "-57.76", "America/Manaus"),("3385674", "Uruburetama", "", "BR", "76", "", "06", "2313807", "", "-3.625", "-39.50833", "America/Fortaleza"),("3385726", "Urbano Santos", "", "BR", "76", "", "13", "2112605", "", "-3.20778", "-43.40361", "America/Fortaleza"),("3385736", "Upanema", "", "BR", "76", "", "22", "2414605", "", "-5.64194", "-37.25778", "America/Fortaleza"),("3385742", "União dos Palmares", "", "BR", "76", "", "02", "2709301", "", "-9.16278", "-36.03194", "America/Maceio"),("3385745", "União", "", "BR", "76", "", "20", "2211100", "", "-4.58583", "-42.86417", "America/Fortaleza"),("3385758", "Umirim", "", "BR", "76", "", "06", "2313757", "", "-3.67722", "-39.35028", "America/Fortaleza"),("3385826", "Umarizal", "", "BR", "76", "", "22", "2414506", "", "-5.99056", "-37.81444", "America/Fortaleza"),("3385850", "Uiraúna", "", "BR", "76", "", "17", "2516904", "", "-6.51833", "-38.41222", "America/Fortaleza"),("3385873", "Ubajara", "", "BR", "76", "", "06", "2313609", "", "-3.85444", "-40.92111", "America/Fortaleza"),("3385883", "Uauá", "", "BR", "76", "", "05", "2932002", "", "-9.84139", "-39.48167", "America/Bahia"),("3385899", "Tutóia", "", "BR", "76", "", "13", "2112506", "", "-2.76194", "-42.27444", "America/Fortaleza"),("3385908", "Turiaçu", "", "BR", "76", "", "13", "2112407", "", "-1.66333", "-45.37167", "America/Fortaleza"),("3385920", "Tupanatinga", "", "BR", "76", "", "30", "2615805", "", "-8.75333", "-37.33972", "America/Recife"),("3385922", "Tuntum", "", "BR", "76", "", "13", "2112308", "", "-5.25806", "-44.64889", "America/Fortaleza"),("3385935", "Tucuruí", "", "BR", "76", "", "16", "1508100", "", "-3.76585", "-49.67923", "America/Belem"),("3385980", "Tucumã", "", "BR", "76", "", "16", "1502509", "", "-0.18333", "-50.05", "America/Belem"),("3386042", "Trindade", "", "BR", "76", "", "30", "2615607", "", "-7.76194", "-40.26778", "America/Recife"),("3386177", "Trairi", "", "BR", "76", "", "06", "2313500", "", "-3.27778", "-39.26889", "America/Fortaleza"),("3386198", "Traipu", "", "BR", "76", "", "02", "2709202", "", "-9.97056", "-37.00333", "America/Maceio"),("3386213", "Touros", "", "BR", "76", "", "22", "2414407", "", "-5.19889", "-35.46083", "America/Fortaleza"),("3386264", "Toritama", "Торитама", "BR", "76", "", "30", "2615409", "", "-8.00667", "-36.05667", "America/Recife"),("3386279", "Tomé Açu", "", "BR", "76", "", "16", "1508001", "", "-2.41889", "-48.15222", "America/Belem"),("3386361", "Timon", "Тимон", "BR", "76", "", "13", "2112209", "", "-5.09417", "-42.83667", "America/Fortaleza"),("3386372", "Timbiras", "", "BR", "76", "", "13", "2112100", "", "-4.25528", "-43.94056", "America/Fortaleza"),("3386396", "Timbaúba", "", "BR", "76", "", "30", "2615300", "", "-7.50528", "-35.31833", "America/Recife"),("3386449", "Tianguá", "", "BR", "76", "", "06", "2313401", "", "-3.73222", "-40.99167", "America/Fortaleza"),("3386467", "Terra Santa", "", "BR", "76", "", "16", "1507979", "", "-2.10417", "-56.48694", "America/Santarem"),("3386496", "Teresina", "Терезина", "BR", "76", "", "20", "2211001", "", "-5.08917", "-42.80194", "America/Fortaleza"),("3386533", "Teixeira", "", "BR", "76", "", "17", "2516706", "", "-7.22278", "-37.25417", "America/Fortaleza"),("3386567", "São João dos Inhamuns", "", "BR", "76", "", "06", "2313302", "", "-6", "-40.28333", "America/Fortaleza"),("3386622", "Taquaritinga do Norte", "", "BR", "76", "", "30", "2615003", "", "-7.90306", "-36.04417", "America/Recife"),("3386628", "Taquarana", "", "BR", "76", "", "02", "2709103", "", "-9.645", "-36.49722", "America/Maceio"),("3386693", "Taperoá", "", "BR", "76", "", "17", "2516508", "", "-7.2075", "-36.82667", "America/Fortaleza"),("3386842", "Tangará", "", "BR", "76", "", "22", "2414001", "", "-6.19944", "-35.80167", "America/Fortaleza"),("3386874", "Tamboril", "", "BR", "76", "", "06", "2313203", "", "-4.83222", "-40.32056", "America/Fortaleza"),("3386931", "Tamandaré", "", "BR", "76", "BR", "30", "2614857", "", "-8.75632", "-35.09995", "America/Recife"),("3387082", "Tabira", "", "BR", "76", "", "30", "2614600", "", "-7.59083", "-37.53944", "America/Recife"),("3387115", "Surubim", "", "BR", "76", "", "30", "2614501", "", "-7.83306", "-35.75472", "America/Recife"),("3387130", "Sumé", "", "BR", "76", "", "17", "2516300", "", "-7.67167", "-36.88", "America/Fortaleza"),("3387202", "Sousa", "", "BR", "76", "", "17", "2516201", "", "-6.75917", "-38.22806", "America/Fortaleza"),("3387204", "Soure", "", "BR", "76", "", "16", "1507904", "", "-0.71667", "-48.52333", "America/Belem"),("3387258", "Soledade", "", "BR", "76", "", "17", "2516102", "", "-7.05722", "-36.36278", "America/Fortaleza"),("3387266", "Solânea", "", "BR", "76", "", "17", "2501500", "", "-6.755", "-35.54", "America/Fortaleza"),("3387296", "Sobral", "Собрал", "BR", "76", "", "06", "2312908", "", "-3.68611", "-40.34972", "America/Fortaleza"),("3387604", "Sirinhaém", "", "BR", "76", "BR", "30", "2614204", "", "-8.59083", "-35.11611", "America/Recife"),("3387620", "Simplício Mendes", "", "BR", "76", "", "20", "2210805", "", "-7.85389", "-41.91028", "America/Fortaleza"),("3387663", "Sertânia", "", "BR", "76", "", "30", "2614105", "", "-8.07361", "-37.26444", "America/Recife"),("3387786", "Serra Talhada", "", "BR", "76", "", "30", "2613909", "", "-7.99194", "-38.29833", "America/Recife"),("3387880", "Serra Branca", "", "BR", "76", "", "17", "2517209", "", "-6.53333", "-38.26667", "America/Fortaleza"),("3387926", "Senador Pompeu", "", "BR", "76", "", "06", "2312700", "", "-5.58806", "-39.37167", "America/Fortaleza"),("3387928", "Senador José Porfírio", "", "BR", "76", "", "16", "1507805", "", "-2.59083", "-51.95417", "America/Belem"),("3387987", "Satuba", "", "BR", "76", "", "02", "2708907", "", "-9.56333", "-35.82444", "America/Maceio"),("3388092", "São Tomé", "", "BR", "76", "", "22", "2412906", "", "-5.9725", "-36.07528", "America/Fortaleza"),("3388112", "São Sebastião", "", "BR", "76", "", "02", "2708808", "", "-9.93361", "-36.55417", "America/Maceio"),("3388145", "São Raimundo Nonato", "", "BR", "76", "", "20", "2210607", "", "-9.01528", "-42.69944", "America/Fortaleza"),("3388147", "São Raimundo das Mangabeiras", "", "BR", "76", "", "13", "2111607", "", "-7.02194", "-45.48111", "America/Fortaleza"),("3388173", "São Pedro do Piauí", "", "BR", "76", "", "20", "2210508", "", "-5.92944", "-42.71861", "America/Fortaleza"),("3388238", "São Paulo do Potengi", "", "BR", "76", "", "22", "2412609", "", "-5.895", "-35.76278", "America/Fortaleza"),("3388266", "São Miguel do Tapuio", "", "BR", "76", "", "20", "2210409", "", "-5.50361", "-41.32333", "America/Fortaleza"),("3388269", "São Miguel dos Campos", "Сан-Мигель-дус-Кампус", "BR", "76", "", "02", "2708600", "", "-9.78111", "-36.09361", "America/Maceio"),("3388270", "São Miguel do Guamá", "", "BR", "76", "", "16", "1507607", "", "-1.62667", "-47.48333", "America/Belem"),("3388304", "São Miguel", "", "BR", "76", "", "22", "2407500", "", "-5.46667", "-35.36667", "America/Fortaleza"),("3388318", "São Mateus do Maranhão", "", "BR", "76", "", "13", "2111508", "", "-4.04167", "-44.475", "America/Fortaleza"),("3388341", "São Luís do Quitunde", "", "BR", "76", "", "02", "2708501", "", "-9.31833", "-35.56111", "America/Maceio"),("3388368", "São Luís", "Сан-Луис", "BR", "76", "", "13", "2111300", "", "-2.52972", "-44.30278", "America/Fortaleza"),("3388376", "São Lourenço da Mata", "Сан-Лоренсу-да-Мата", "BR", "76", "", "30", "2613701", "", "-8.00222", "-35.01833", "America/Recife"),("3388435", "São José do Egito", "", "BR", "76", "", "30", "2613602", "", "-7.47889", "-37.27444", "America/Recife"),("3388437", "São José do Campestre", "", "BR", "76", "", "22", "2412302", "", "-6.31556", "-35.71389", "America/Fortaleza"),("3388440", "São José do Belmonte", "", "BR", "76", "", "30", "2613503", "", "-7.86139", "-38.75972", "America/Recife"),("3388441", "São José de Ribamar", "", "BR", "76", "", "13", "2111201", "", "-2.56194", "-44.05417", "America/Fortaleza"),("3388442", "São José de Piranhas", "", "BR", "76", "", "17", "2514503", "", "-7.12056", "-38.50194", "America/Fortaleza"),("3388443", "São José de Mipibu", "", "BR", "76", "", "22", "2412203", "", "-6.07472", "-35.23778", "America/Fortaleza"),("3388447", "São José da Tapera", "", "BR", "76", "", "02", "2708402", "", "-9.55833", "-37.38111", "America/Maceio"),("3388454", "São José da Laje", "", "BR", "76", "", "02", "2708303", "", "-9.00972", "-36.05833", "America/Maceio"),("3388456", "São José da Coroa Grande", "", "BR", "76", "", "30", "2613404", "", "-8.89778", "-35.14778", "America/Recife"),("3388567", "São Joaquim do Monte", "", "BR", "76", "", "30", "2613305", "", "-8.4325", "-35.80444", "America/Recife"),("3388615", "São João dos Patos", "", "BR", "76", "", "13", "2111102", "", "-6.495", "-43.70222", "America/Fortaleza"),("3388618", "São João do Piauí", "", "BR", "76", "", "20", "2210003", "", "-8.35806", "-42.24667", "America/Fortaleza"),("3388626", "São João de Pirabas", "", "BR", "76", "", "16", "1507474", "", "-0.77472", "-47.17722", "America/Belem"),("3388660", "São João", "", "BR", "76", "", "30", "2613206", "", "-8.87556", "-36.36667", "America/Recife"),("3388713", "São Gonçalo do Amarante", "", "BR", "76", "", "22", "2412005", "", "-5.79333", "-35.32944", "America/Fortaleza"),("3388714", "São Gonçalo do Amarante", "", "BR", "76", "", "06", "2312403", "", "-3.60722", "-38.96833", "America/Fortaleza"),("3388760", "São Geraldo do Araguaia", "", "BR", "76", "", "16", "1507458", "", "-6.40056", "-48.555", "America/Araguaina"),("3388847", "São Félix do Xingu", "", "BR", "76", "", "16", "1507300", "", "-6.64472", "-51.995", "America/Belem"),("3388868", "São Domingos do Maranhão", "", "BR", "76", "", "13", "2110708", "", "-5.57583", "-44.38528", "America/Fortaleza"),("3388926", "São Caetano de Odivelas", "", "BR", "76", "", "16", "1507102", "", "-0.75", "-48.02", "America/Belem"),("3388949", "São Bernardo", "", "BR", "76", "", "13", "2110609", "", "-3.36139", "-42.41778", "America/Fortaleza"),("3388991", "São Bento", "", "BR", "76", "", "17", "2504306", "", "-6.28333", "-37.75", "America/Fortaleza"),("3389006", "São Bento", "Сан-Бенту", "BR", "76", "", "13", "2110500", "", "-2.69583", "-44.82139", "America/Fortaleza"),("3389012", "São Benedito do Rio Preto", "", "BR", "76", "", "13", "2110401", "", "-3.33361", "-43.52833", "America/Fortaleza"),("3389062", "Santo Antônio do Tauá", "", "BR", "76", "", "16", "1507003", "", "-1.15194", "-48.12944", "America/Belem"),("3389134", "Santo Antônio", "", "BR", "76", "", "22", "2411502", "", "-6.31056", "-35.47889", "America/Fortaleza"),("3389321", "Santa Rita", "", "BR", "76", "", "17", "2513703", "", "-7.11389", "-34.97806", "America/Fortaleza"),("3389339", "Santa Rita", "", "BR", "76", "", "13", "2112704", "", "-3.86358", "-43.85999", "America/Fortaleza"),("3389353", "Santarém", "Сантарен", "BR", "76", "", "16", "1506807", "", "-2.44306", "-54.70833", "America/Santarem"),("3389358", "Santa Quitéria do Maranhão", "", "BR", "76", "", "13", "2110104", "", "-3.51556", "-42.54667", "America/Fortaleza"),("3389361", "Santa Quitéria", "", "BR", "76", "", "06", "2312205", "", "-4.33194", "-40.15667", "America/Fortaleza"),("3389380", "Santana do Mundaú", "", "BR", "76", "", "02", "2708105", "", "-9.16806", "-36.22222", "America/Maceio"),("3389381", "Santana do Matos", "", "BR", "76", "", "22", "2411403", "", "-5.9575", "-36.65556", "America/Fortaleza"),("3389384", "Santana do Ipanema", "Сантана-ду-Ипанема", "BR", "76", "", "02", "2708006", "", "-9.37833", "-37.24528", "America/Maceio"),("3389387", "Santana do Acaraú", "", "BR", "76", "", "06", "2312007", "", "-3.46056", "-40.21222", "America/Fortaleza"),("3389459", "Santa Maria do Pará", "", "BR", "76", "", "16", "1506609", "", "-1.35028", "-47.57556", "America/Belem"),("3389462", "Santa Maria da Boa Vista", "", "BR", "76", "", "30", "2612604", "", "-8.80778", "-39.82556", "America/Bahia"),("3389557", "Santa Luzia", "", "BR", "76", "", "13", "2109502", "", "-7.64265", "-47.21738", "America/Fortaleza"),("3389560", "Santa Luzia", "", "BR", "76", "", "17", "2513406", "", "-6.87222", "-36.91861", "America/Fortaleza"),("3389609", "Santa Inês", "Санта-Инес", "BR", "76", "", "13", "2109908", "", "-3.66667", "-45.38", "America/Fortaleza"),("3389622", "Santa Helena", "", "BR", "76", "", "13", "2109809", "", "-2.23111", "-45.3", "America/Fortaleza"),("3389652", "Santa Cruz do Capibaribe", "", "BR", "76", "", "30", "2612505", "", "-7.9575", "-36.20472", "America/Recife"),("3389673", "Santa Cruz", "", "BR", "76", "", "22", "2411205", "", "-6.22944", "-36.02278", "America/Fortaleza"),("3389822", "Salinópolis", "", "BR", "76", "", "16", "1506203", "", "-0.61361", "-47.35611", "America/Belem"),("3389860", "Salgueiro", "Салгейру", "BR", "76", "", "30", "2612208", "", "-8.07417", "-39.11917", "America/Recife"),("3390160", "Russas", "", "BR", "76", "", "06", "2311801", "", "-4.94028", "-37.97583", "America/Fortaleza"),("3390280", "Rio Tinto", "", "BR", "76", "", "17", "2512903", "", "-6.80306", "-35.08056", "America/Fortaleza"),("3390288", "Rio Largo", "", "BR", "76", "", "02", "2707701", "", "-9.47833", "-35.85333", "America/Maceio"),("3390295", "Rio Formoso", "", "BR", "76", "", "30", "2611903", "", "-8.66877", "-35.16277", "America/Recife"),("3390326", "Ribeirão", "", "BR", "76", "BR", "30", "2611804", "", "-8.51444", "-35.37778", "America/Recife"),("3390581", "Riachão", "", "BR", "76", "", "13", "2109502", "", "-7.36194", "-46.61722", "America/Fortaleza"),("3390659", "Reriutaba", "", "BR", "76", "", "06", "2311702", "", "-4.14167", "-40.58222", "America/Fortaleza"),("3390674", "Remígio", "", "BR", "76", "", "17", "2501104", "", "-6.94646", "-35.78039", "America/Fortaleza"),("3390700", "Regeneração", "", "BR", "76", "", "20", "2208809", "", "-6.23122", "-42.68691", "America/Fortaleza"),("3390732", "Redenção", "", "BR", "76", "", "06", "2311603", "", "-4.22583", "-38.73056", "America/Fortaleza"),("3390760", "Recife", "Ресифи", "BR", "76", "", "30", "2611606", "", "-8.05389", "-34.88111", "America/Recife"),("3390814", "Raposa", "", "BR", "76", "", "13", "2108009", "", "-6.51667", "-44.18333", "America/Fortaleza"),("3390896", "Quixeré", "", "BR", "76", "", "06", "2311504", "", "-5.07417", "-37.98861", "America/Fortaleza"),("3390901", "Quixeramobim", "", "BR", "76", "", "06", "2311405", "", "-5.19917", "-39.29278", "America/Fortaleza"),("3390907", "Quixadá", "", "BR", "76", "", "06", "2311306", "", "-4.97139", "-39.01528", "America/Fortaleza"),("3390965", "Quipapá", "", "BR", "76", "", "30", "2611507", "", "-8.82778", "-36.01167", "America/Recife"),("3391090", "Quebrangulo", "", "BR", "76", "", "02", "2707602", "", "-9.31889", "-36.47111", "America/Maceio"),("3391172", "Princesa Isabel", "", "BR", "76", "", "17", "2512309", "", "-7.73667", "-37.99333", "America/Fortaleza"),("3391220", "Presidente Dutra", "", "BR", "76", "", "13", "2109106", "", "-5.29", "-44.49", "America/Fortaleza"),("3391287", "Prainha", "", "BR", "76", "", "16", "1506005", "", "-1.8", "-53.48", "America/Santarem"),("3391360", "Santana", "Сантана", "BR", "76", "", "03", "1600600", "", "-0.05833", "-51.18167", "America/Belem"),("3391371", "Porto Franco", "", "BR", "76", "", "13", "2109007", "", "-6.33833", "-47.39917", "America/Araguaina"),("3391387", "Porto de Moz", "", "BR", "76", "", "16", "1505908", "", "-1.74833", "-52.23833", "America/Santarem"),("3391395", "Porto da Folha", "", "BR", "76", "", "28", "2805604", "", "-9.91722", "-37.27833", "America/Maceio"),("3391397", "Porto Calvo", "", "BR", "76", "", "02", "2707305", "", "-9.045", "-35.39833", "America/Maceio"),("3391408", "Porto", "", "BR", "76", "", "20", "2208502", "", "-3.89333", "-42.71", "America/Fortaleza"),("3391412", "Portel", "", "BR", "76", "", "16", "1505809", "", "-1.93556", "-50.82111", "America/Belem"),("3391556", "Pombos", "", "BR", "76", "", "30", "2611309", "", "-8.14139", "-35.39583", "America/Recife"),("3391571", "Pombal", "", "BR", "76", "", "17", "2512101", "", "-6.77028", "-37.80167", "America/Fortaleza"),("3391744", "Poço Branco", "", "BR", "76", "", "22", "2410108", "", "-5.62278", "-35.66278", "America/Fortaleza"),("3391762", "Pocinhos", "", "BR", "76", "", "17", "2512002", "", "-7.07667", "-36.06111", "America/Fortaleza"),("3391774", "Poção de Pedras", "", "BR", "76", "", "13", "2105203", "", "-4.66667", "-44.85", "America/Fortaleza"),("3391889", "Pitimbu", "", "BR", "76", "", "17", "2511905", "", "-7.47056", "-34.80861", "America/Fortaleza"),("3391895", "Pirpirituba", "", "BR", "76", "", "17", "2511806", "", "-6.78", "-35.49861", "America/Fortaleza"),("3391908", "Piripiri", "", "BR", "76", "", "20", "2208403", "", "-4.27333", "-41.77694", "America/Fortaleza"),("3391940", "Pirapemas", "", "BR", "76", "", "13", "2108801", "", "-3.72667", "-44.22333", "America/Fortaleza"),("3391991", "Piracuruca", "", "BR", "76", "", "20", "2208304", "", "-3.92806", "-41.70917", "America/Fortaleza"),("3392018", "Pio XII", "", "BR", "76", "", "13", "2108702", "", "-3.8325", "-45.1525", "America/Fortaleza"),("3392054", "Pinheiro", "Пиньейру", "BR", "76", "", "13", "2108603", "", "-2.52139", "-45.0825", "America/Fortaleza"),("3392088", "Pindaré Mirim", "", "BR", "76", "", "13", "2108504", "", "-3.60833", "-45.34333", "America/Fortaleza"),("3392126", "Pilar", "Пилар", "BR", "76", "", "02", "2706901", "", "-9.59722", "-35.95667", "America/Maceio"),("3392127", "Pilar", "", "BR", "76", "", "17", "2511509", "", "-7.26722", "-35.26", "America/Fortaleza"),("3392145", "Picuí", "", "BR", "76", "", "17", "2511400", "", "-6.51056", "-36.34694", "America/Fortaleza"),("3392167", "Picos", "Пикус", "BR", "76", "", "20", "2208007", "", "-7.07694", "-41.46694", "America/Fortaleza"),("3392225", "Piancó", "", "BR", "76", "", "17", "2511301", "", "-7.19806", "-37.92917", "America/Fortaleza"),("3392242", "Petrolina", "Петролина", "BR", "76", "", "30", "2611101", "", "-9.39861", "-40.50083", "America/Recife"),("3392243", "Jatobá", "Ятоба", "BR", "76", "", "30", "2608057", "", "-9.18306", "-38.26889", "America/Recife"),("3392251", "Pesqueira", "", "BR", "76", "", "30", "2610905", "", "-8.35778", "-36.69639", "America/Recife"),("3392345", "Pentecoste", "", "BR", "76", "", "06", "2310704", "", "-3.79278", "-39.27028", "America/Fortaleza"),("3392361", "Pendências", "", "BR", "76", "", "22", "2409902", "", "-5.26", "-36.72222", "America/Fortaleza"),("3392368", "Penalva", "", "BR", "76", "", "13", "2108306", "", "-3.29417", "-45.17361", "America/Fortaleza"),("3392425", "Pedro Velho", "", "BR", "76", "", "22", "2409803", "", "-6.43917", "-35.22139", "America/Fortaleza"),("3392431", "Pedro II", "", "BR", "76", "", "20", "2207900", "", "-4.42472", "-41.45861", "America/Fortaleza"),("3392478", "Pedras de Fogo", "", "BR", "76", "", "17", "2511202", "", "-7.40194", "-35.11639", "America/Recife"),("3392629", "Pedra Branca", "Педра-Бранка", "BR", "76", "", "06", "2310506", "", "-5.45417", "-39.71722", "America/Fortaleza"),("3392657", "Pedra", "", "BR", "76", "", "30", "2610806", "", "-8.49694", "-36.94083", "America/Recife"),("3392731", "Paulo Ramos", "", "BR", "76", "", "13", "2107407", "", "-4.21667", "-45.18333", "America/Fortaleza"),("3392734", "Paulo Afonso", "", "BR", "76", "", "05", "2924009", "", "-9.40611", "-38.21472", "America/Bahia"),("3392740", "Paulista", "", "BR", "76", "", "30", "2610707", "", "-7.94083", "-34.87306", "America/Recife"),("3392862", "Patu", "", "BR", "76", "", "22", "2409308", "", "-6.11", "-37.63667", "America/Fortaleza"),("3392887", "Patos", "Патус", "BR", "76", "", "17", "2510808", "", "-7.02444", "-37.28", "America/Fortaleza"),("3392907", "Pastos Bons", "", "BR", "76", "", "13", "2108009", "", "-6.60167", "-44.07667", "America/Fortaleza"),("3392916", "Passira", "", "BR", "76", "", "30", "2610509", "", "-7.995", "-35.58056", "America/Recife"),("3392942", "Passagem Franca", "", "BR", "76", "", "13", "2107902", "", "-6.17972", "-43.78361", "America/Fortaleza"),("3392996", "Parnarama", "", "BR", "76", "", "13", "2107803", "", "-5.68167", "-43.09333", "America/Fortaleza"),("3392997", "Parnamirim", "", "BR", "76", "", "30", "2610400", "", "-8.09056", "-39.57833", "America/Recife"),("3392998", "Parnamirim", "Парнамирин", "BR", "76", "", "22", "2403251", "", "-5.91556", "-35.26278", "America/Fortaleza"),("3393001", "Parnaíba", "Парнаиба", "BR", "76", "", "20", "2207702", "", "-2.90472", "-41.77667", "America/Fortaleza"),("3393008", "Parintins", "Паринтинса", "BR", "76", "", "04", "1303403", "", "-2.62833", "-56.73583", "America/Manaus"),("3393017", "Parelhas", "", "BR", "76", "", "22", "2408904", "", "-6.68778", "-36.6575", "America/Fortaleza"),("3393065", "Parambu", "", "BR", "76", "", "06", "2310308", "", "-6.21111", "-40.69444", "America/Fortaleza"),("3393091", "Paraipaba", "", "BR", "76", "", "06", "2310258", "", "-3.43944", "-39.14833", "America/Fortaleza"),("3393095", "Paraibano", "", "BR", "76", "", "13", "2107704", "", "-6.43306", "-43.98361", "America/Fortaleza"),("3393106", "Paragominas", "", "BR", "76", "", "16", "1505502", "", "-2.96667", "-47.48333", "America/Belem"),("3393115", "Paracuru", "", "BR", "76", "", "06", "2310209", "", "-3.41", "-39.03056", "America/Fortaleza"),("3393174", "Pão de Açúcar", "", "BR", "76", "", "02", "2706406", "", "-9.74833", "-37.43667", "America/Maceio"),("3393264", "Palmares", "", "BR", "76", "", "30", "2610004", "", "-8.68333", "-35.59167", "America/Recife"),("3393400", "Pacatuba", "", "BR", "76", "", "06", "2309706", "", "-3.98417", "-38.62028", "America/Fortaleza"),("3393409", "Pacajus", "", "BR", "76", "", "06", "2309607", "", "-4.1725", "-38.46056", "America/Fortaleza"),("3393452", "Ouricuri", "", "BR", "76", "", "30", "2609907", "", "-7.8825", "-40.08167", "America/Recife"),("3393455", "Ourém", "", "BR", "76", "", "16", "1505403", "", "-1.55194", "-47.11444", "America/Belem"),("3393465", "Orós", "", "BR", "76", "", "06", "2309508", "", "-6.24444", "-38.91361", "America/Fortaleza"),("3393470", "Orobó", "", "BR", "76", "", "30", "2609709", "", "-7.745", "-35.60222", "America/Recife"),("3393471", "Oriximiná", "", "BR", "76", "", "16", "1505304", "", "-1.76556", "-55.86611", "America/Santarem"),("3393536", "Olinda", "Олинда", "BR", "76", "", "30", "2609600", "", "-8.00889", "-34.85528", "America/Recife"),("3393762", "Oeiras do Pará", "", "BR", "76", "", "16", "1505205", "", "-2.00306", "-49.85444", "America/Belem"),("3393764", "Oeiras", "", "BR", "76", "", "20", "2207009", "", "-7.02528", "-42.13111", "America/Fortaleza"),("3393766", "Ocara", "", "BR", "76", "", "06", "2309458", "", "-4.49083", "-38.59667", "America/Fortaleza"),("3393768", "Ábidos", "", "BR", "76", "", "16", "1505106", "", "-1.9175", "-55.51806", "America/Santarem"),("3393783", "Novo Oriente", "", "BR", "76", "", "06", "2309409", "", "-5.53444", "-40.77417", "America/Fortaleza"),("3393792", "Novo Lino", "", "BR", "76", "", "02", "2705606", "", "-8.915", "-35.64667", "America/Maceio"),("3393832", "Nova Russas", "", "BR", "76", "", "06", "2309300", "", "-4.70667", "-40.56306", "America/Fortaleza"),("3393838", "Nova Olinda do Norte", "", "BR", "76", "", "04", "1303106", "", "-3.89174", "-59.09542", "America/Manaus"),("3393867", "Nova Floresta", "", "BR", "76", "", "17", "2510105", "", "-6.45528", "-36.20333", "America/Fortaleza"),("3393876", "Nova Cruz", "", "BR", "76", "", "22", "2408300", "", "-6.47806", "-35.43389", "America/Fortaleza"),("3393922", "Nísia Floresta", "", "BR", "76", "", "22", "2408201", "", "-6.09111", "-35.20861", "America/Fortaleza"),("3393929", "Nhamundá", "", "BR", "76", "", "04", "1303007", "", "-2.18611", "-56.71306", "America/Santarem"),("3393972", "Nazaré da Mata", "Назар-да-Мата", "BR", "76", "", "30", "2609501", "", "-7.74167", "-35.22778", "America/Recife"),("3394023", "Natal", "Натал", "BR", "76", "", "22", "2408102", "", "-5.795", "-35.20944", "America/Fortaleza"),("3394116", "Murici", "", "BR", "76", "", "02", "2705507", "", "-9.30667", "-35.94333", "America/Maceio"),("3394326", "Muaná", "", "BR", "76", "", "16", "1504901", "", "-1.52833", "-49.21667", "America/Belem"),("3394453", "Moreno", "", "BR", "76", "", "30", "2609402", "", "-8.11861", "-35.09222", "America/Recife"),("3394500", "Morada Nova", "", "BR", "76", "", "06", "2308708", "", "-5.10667", "-38.3725", "America/Fortaleza"),("3394549", "Monteiro", "", "BR", "76", "", "17", "2509701", "", "-7.88944", "-37.12", "America/Fortaleza"),("3394594", "Monte Alegre", "", "BR", "76", "", "22", "2402709", "", "-5.88972", "-36.30139", "America/Fortaleza"),("3394605", "Monte Alegre", "Монти-Алегри", "BR", "76", "", "16", "1504802", "", "-2.00082", "-54.08102", "America/Santarem"),("3394612", "Montanhas", "", "BR", "76", "", "22", "2407708", "", "-6.48583", "-35.2875", "America/Fortaleza"),("3394640", "Monção", "", "BR", "76", "", "13", "2106904", "", "-3.49167", "-45.25111", "America/Fortaleza"),("3394649", "Mombaça", "", "BR", "76", "", "06", "2308500", "", "-5.74306", "-39.6275", "America/Fortaleza"),("3394661", "Moju", "", "BR", "76", "", "16", "1504703", "", "-1.88389", "-48.76889", "America/Belem"),("3394682", "Mossoró", "Мосоро", "BR", "76", "", "22", "2408003", "", "-5.1875", "-37.34417", "America/Fortaleza"),("3394745", "Mocajuba", "", "BR", "76", "", "16", "1504604", "", "-2.58417", "-49.50722", "America/Belem"),("3394755", "Missão Velha", "", "BR", "76", "", "06", "2308401", "", "-7.24972", "-39.14306", "America/Fortaleza"),("3394813", "Mirador", "", "BR", "76", "", "13", "2106706", "", "-6.37083", "-44.36306", "America/Fortaleza"),("3394884", "Milagres", "", "BR", "76", "", "06", "2308302", "", "-7.31333", "-38.94556", "America/Fortaleza"),("3394892", "Miguel Alves", "", "BR", "76", "", "20", "2206209", "", "-4.16556", "-42.89528", "America/Fortaleza"),("3394908", "Messias", "", "BR", "76", "", "02", "2705200", "", "-9.38333", "-35.84167", "America/Maceio"),("3395042", "Mazagão", "", "BR", "76", "", "03", "1600402", "", "-0.115", "-51.28944", "America/Belem"),("3395062", "Maués", "", "BR", "76", "", "04", "1302900", "", "-3.38361", "-57.71861", "America/Manaus"),("3395077", "Matriz de Camaragibe", "", "BR", "76", "", "02", "2705101", "", "-9.15167", "-35.53333", "America/Maceio"),("3395122", "Matinha", "", "BR", "76", "", "13", "2106508", "", "-3.10056", "-45.03361", "America/Fortaleza"),("3395336", "Maribondo", "", "BR", "76", "", "02", "2704807", "", "-9.57722", "-36.30528", "America/Maceio"),("3395380", "Mari", "", "BR", "76", "", "17", "2509107", "", "-7.06", "-35.31944", "America/Fortaleza"),("3395395", "Marechal Deodoro", "", "BR", "76", "", "02", "2704708", "", "-9.71028", "-35.895", "America/Maceio"),("3395404", "Marco", "", "BR", "76", "", "06", "2307809", "", "-3.12389", "-40.14667", "America/Fortaleza"),("3395440", "Marapanim", "", "BR", "76", "", "16", "1504406", "", "-0.7175", "-47.69972", "America/Belem"),("3395456", "Maraial", "", "BR", "76", "", "30", "2609204", "", "-8.7825", "-35.80889", "America/Recife"),("3395458", "Maragogi", "", "BR", "76", "", "02", "2704500", "", "-9.01222", "-35.2225", "America/Maceio"),("3395473", "Maracanaú", "", "BR", "76", "", "06", "2307650", "", "-3.87667", "-38.62556", "America/Fortaleza"),("3395483", "Maracanã", "", "BR", "76", "", "16", "1504307", "", "-0.76614", "-47.45371", "America/Belem"),("3395497", "Maracaçumé", "", "BR", "76", "", "13", "2106326", "", "-2.04278", "-45.95917", "America/Fortaleza"),("3395503", "Marabá", "Мараба", "BR", "76", "", "16", "1504208", "", "-5.38146", "-49.13232", "America/Belem"),("3395717", "Mamanguape", "", "BR", "76", "", "17", "2508901", "", "-6.83861", "-35.12611", "America/Fortaleza"),("3395880", "Major Isidoro", "", "BR", "76", "", "02", "2704401", "", "-9.53222", "-36.985", "America/Maceio"),("3395981", "Maceió", "Масейо", "BR", "76", "", "02", "2704302", "", "-9.66583", "-35.73528", "America/Maceio"),("3395998", "Macau", "", "BR", "76", "", "22", "2407203", "", "-5.115", "-36.63444", "America/Fortaleza"),("3396009", "Macaparana", "", "BR", "76", "", "30", "2609006", "", "-7.55472", "-35.45306", "America/Recife"),("3396016", "Macapá", "Макапа", "BR", "76", "", "03", "1600303", "", "0.03889", "-51.06639", "America/Belem"),("3396048", "Macaíba", "", "BR", "76", "", "22", "2407104", "", "-5.85833", "-35.35389", "America/Fortaleza"),("3396101", "Luzilândia", "", "BR", "76", "", "20", "2205805", "", "-3.45778", "-42.37028", "America/Fortaleza"),("3396121", "Luís Correia", "", "BR", "76", "", "20", "2205706", "", "-2.87917", "-41.66694", "America/Fortaleza"),("3396266", "Limoeiro do Norte", "", "BR", "76", "", "06", "2307601", "", "-5.14556", "-38.09806", "America/Fortaleza"),("3396277", "Limoeiro", "", "BR", "76", "", "30", "2608909", "", "-7.87472", "-35.45028", "America/Recife"),("3396364", "Lavras da Mangabeira", "", "BR", "76", "", "06", "2307502", "", "-6.75333", "-38.96444", "America/Fortaleza"),("3396496", "Lajedo", "Лажеду", "BR", "76", "", "30", "2608800", "", "-8.66361", "-36.32", "America/Recife"),("3396601", "Lago da Pedra", "Лаго-да-Педра", "BR", "76", "", "13", "2113009", "", "-4.28674", "-45.23824", "America/Fortaleza"),("3396620", "Lagoa Seca", "", "BR", "76", "", "17", "2508307", "", "-7.17083", "-35.85361", "America/Fortaleza"),("3396662", "Lagoa Nova", "", "BR", "76", "", "22", "2406502", "", "-6.1", "-36.48333", "America/Fortaleza");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("3396769", "Lagoa do Itaenga", "", "BR", "76", "", "30", "2608503", "", "-7.93611", "-35.29028", "America/Recife"),("3396877", "Lagoa da Canoa", "", "BR", "76", "", "02", "2704104", "", "-9.82972", "-36.73778", "America/Maceio"),("3396979", "Juruti", "", "BR", "76", "", "16", "1503903", "", "-2.15222", "-56.09222", "America/Santarem"),("3397008", "Juripiranga", "", "BR", "76", "", "17", "2507903", "", "-7.37333", "-35.23806", "America/Fortaleza"),("3397063", "Junqueiro", "", "BR", "76", "", "02", "2704005", "", "-9.92528", "-36.47583", "America/Maceio"),("3397108", "Jucurutu", "", "BR", "76", "", "22", "2406106", "", "-6.03389", "-37.02028", "America/Fortaleza"),("3397119", "Jucás", "", "BR", "76", "", "06", "2307403", "", "-6.52528", "-39.5275", "America/Fortaleza"),("3397147", "Juazeiro do Norte", "Жуазейру-ду-Норти", "BR", "76", "", "06", "2307304", "", "-7.21306", "-39.31528", "America/Fortaleza"),("3397175", "Juàzeirinho", "", "BR", "76", "", "17", "2500775", "", "-6.81667", "-38.05", "America/Fortaleza"),("3397230", "José de Freitas", "", "BR", "76", "", "20", "2205508", "", "-4.75639", "-42.57556", "America/Fortaleza"),("3397262", "Joaquim Nabuco", "", "BR", "76", "", "30", "2608206", "", "-8.62444", "-35.53333", "America/Recife"),("3397277", "João Pessoa", "Жуан-Песоа", "BR", "76", "", "17", "2507507", "", "-7.115", "-34.86306", "America/Fortaleza"),("3397315", "João Câmara", "", "BR", "76", "", "22", "2405801", "", "-5.5375", "-35.81972", "America/Fortaleza"),("3397319", "João Alfredo", "", "BR", "76", "", "30", "2608107", "", "-7.85583", "-35.58833", "America/Recife"),("3397337", "Girau do Ponciano", "", "BR", "76", "", "02", "2702900", "", "-9.88417", "-36.82889", "America/Maceio"),("3397560", "Jardim do Seridó", "", "BR", "76", "", "22", "2405702", "", "-6.58444", "-36.77444", "America/Fortaleza"),("3397562", "Jardim de Piranhas", "", "BR", "76", "", "22", "2405603", "", "-6.37861", "-37.35194", "America/Fortaleza"),("3397590", "Jardim", "", "BR", "76", "", "06", "2310209", "", "-3.46444", "-39.05667", "America/Fortaleza"),("3397660", "Jaicós", "", "BR", "76", "", "20", "2205201", "", "-7.35917", "-41.13778", "America/Fortaleza"),("3397665", "Jaguaruana", "", "BR", "76", "", "06", "2307007", "", "-4.83389", "-37.78111", "America/Fortaleza"),("3397675", "Jaguaribe", "Жагуариби", "BR", "76", "", "06", "2306900", "", "-5.89056", "-38.62194", "America/Fortaleza"),("3397800", "Jacaraú", "", "BR", "76", "", "17", "2507309", "", "-6.61222", "-35.29278", "America/Fortaleza"),("3397838", "Jaboatão", "", "BR", "76", "", "30", "2607901", "", "-8.18028", "-35.00139", "America/Recife"),("3397851", "Itupiranga", "", "BR", "76", "", "16", "1503705", "", "-5.13472", "-49.32667", "America/Belem"),("3397865", "Itaueira", "", "BR", "76", "", "20", "2205102", "", "-7.60333", "-43.02556", "America/Fortaleza"),("3397886", "Itaquitinga", "", "BR", "76", "", "30", "2607802", "", "-7.66778", "-35.10167", "America/Recife"),("3397893", "Itacoatiara", "", "BR", "76", "BR", "04", "1301902", "", "-3.14306", "-58.44417", "America/Manaus"),("3397898", "Itaporanga", "", "BR", "76", "", "17", "2507002", "", "-7.30444", "-38.15028", "America/Fortaleza"),("3397904", "Itapissuma", "", "BR", "76", "", "30", "2607752", "", "-7.77639", "-34.89222", "America/Recife"),("3397909", "Itapipoca", "Итапипока", "BR", "76", "", "06", "2306405", "", "-3.49444", "-39.57861", "America/Fortaleza"),("3397936", "Itapecuru Mirim", "", "BR", "76", "", "13", "2105401", "", "-3.3925", "-44.35861", "America/Fortaleza"),("3397941", "Itapagé", "", "BR", "76", "", "06", "2306306", "", "-3.68667", "-39.58611", "America/Fortaleza"),("3397963", "Itamaracá", "", "BR", "76", "", "30", "2607604", "", "-7.74778", "-34.82556", "America/Noronha"),("3397967", "Itaituba", "", "BR", "76", "", "16", "1503606", "", "-4.27611", "-55.98361", "America/Santarem"),("3397969", "Itaitinga", "", "BR", "76", "", "06", "2306256", "", "-3.96944", "-38.52806", "America/Fortaleza"),("3397983", "Itaíba", "", "BR", "76", "", "30", "2607505", "", "-8.9475", "-37.42278", "America/Recife"),("3398003", "Itabaiana", "", "BR", "76", "", "17", "2506905", "", "-7.32861", "-35.3325", "America/Fortaleza"),("3398014", "Irituia", "", "BR", "76", "", "16", "1503507", "", "-1.77111", "-47.43806", "America/Belem"),("3398028", "Irauçuba", "", "BR", "76", "", "06", "2306108", "", "-3.74611", "-39.78333", "America/Fortaleza"),("3398076", "Ipueiras", "", "BR", "76", "", "06", "", "", "-7.03333", "-40.45", "America/Fortaleza"),("3398105", "Ipubi", "", "BR", "76", "", "30", "2607307", "", "-7.65194", "-40.14889", "America/Recife"),("3398112", "Ipu", "", "BR", "76", "", "06", "2305803", "", "-4.32222", "-40.71083", "America/Fortaleza"),("3398115", "Ipojuca", "Ипожука", "BR", "76", "", "30", "2607208", "", "-8.39889", "-35.06389", "America/Recife"),("3398178", "Inhuma", "", "BR", "76", "", "20", "2204709", "", "-6.66833", "-41.70778", "America/Fortaleza"),("3398192", "Inhapi", "", "BR", "76", "", "02", "2703304", "", "-9.22139", "-37.74861", "America/Maceio"),("3398224", "Ingá", "", "BR", "76", "", "17", "2506806", "", "-7.28083", "-35.60444", "America/Fortaleza"),("3398255", "Independência", "", "BR", "76", "", "06", "2305605", "", "-5.39639", "-40.30861", "America/Fortaleza"),("3398269", "Imperatriz", "Императрис", "BR", "76", "", "13", "2105302", "", "-5.52639", "-47.49167", "America/Fortaleza"),("3398331", "Iguatu", "", "BR", "76", "", "06", "2305506", "", "-6.35944", "-39.29861", "America/Fortaleza"),("3398343", "Igarapé Miri", "", "BR", "76", "", "16", "1503309", "", "-1.975", "-48.95972", "America/Belem"),("3398350", "Igarapé Açu", "", "BR", "76", "", "16", "1503200", "", "-1.12889", "-47.62", "America/Belem"),("3398352", "Igarassu", "", "BR", "76", "", "30", "2606804", "", "-7.83417", "-34.90639", "America/Recife"),("3398355", "Igaci", "", "BR", "76", "", "02", "2703106", "", "-9.53694", "-36.63361", "America/Maceio"),("3398379", "Icó", "", "BR", "76", "", "06", "2305407", "", "-6.40111", "-38.86222", "America/Fortaleza"),("3398401", "Ibimirim", "", "BR", "76", "", "30", "2606606", "", "-8.54056", "-37.69028", "America/Recife"),("3398408", "Ibiapina", "", "BR", "76", "", "06", "2305308", "", "-3.92333", "-40.88944", "America/Fortaleza"),("3398412", "Ibateguara", "", "BR", "76", "", "02", "2703007", "", "-8.9725", "-35.93944", "America/Maceio"),("3398428", "Humberto de Campos", "", "BR", "76", "", "13", "2105005", "", "-2.59833", "-43.46111", "America/Fortaleza"),("3398450", "Horizonte", "", "BR", "76", "", "06", "2305233", "", "-4.1", "-38.48333", "America/Fortaleza"),("3398457", "Hidrolândia", "", "BR", "76", "", "06", "2305209", "", "-4.40806", "-40.43778", "America/Fortaleza"),("3398480", "Gurupá", "", "BR", "76", "", "16", "1503101", "", "-1.405", "-51.64", "America/Belem"),("3398485", "Gurinhém", "", "BR", "76", "", "17", "2506400", "", "-7.12389", "-35.42444", "America/Fortaleza"),("3398569", "Guaraciaba do Norte", "", "BR", "76", "", "06", "2305001", "", "-4.16694", "-40.7475", "America/Fortaleza"),("3398570", "Guarabira", "", "BR", "76", "", "17", "2506301", "", "-6.85472", "-35.49", "America/Fortaleza"),("3398612", "Guajará", "", "BR", "76", "", "04", "1300680", "", "-2.96667", "-57.66667", "America/Manaus"),("3398614", "Guaiúba", "", "BR", "76", "", "06", "2304954", "", "-4.03972", "-38.63722", "America/Fortaleza"),("3398622", "Guabiraba", "", "BR", "76", "", "30", "2601300", "", "-8.41667", "-35.66667", "America/Recife"),("3398691", "Gravatá", "", "BR", "76", "", "30", "2606408", "", "-8.20111", "-35.56472", "America/Recife"),("3398706", "Granja", "", "BR", "76", "", "06", "2304707", "", "-3.12028", "-40.82611", "America/Fortaleza"),("3398856", "Grajaú", "", "BR", "76", "", "13", "2104800", "", "-5.81944", "-46.13861", "America/Fortaleza"),("3398871", "Governador Dix Sept Rosado", "", "BR", "76", "", "22", "2404309", "", "-5.45889", "-37.52083", "America/Fortaleza"),("3398902", "Goianinha", "", "BR", "76", "", "22", "2404200", "", "-6.26472", "-35.2125", "America/Fortaleza"),("3398904", "Goiana", "Гояна", "BR", "76", "", "30", "2606200", "", "-7.56056", "-35.0025", "America/Recife"),("3398920", "Glória do Goitá", "", "BR", "76", "", "30", "2606101", "", "-8.00167", "-35.29278", "America/Recife"),("3399058", "Garanhuns", "Гараньюнс", "BR", "76", "", "30", "2606002", "", "-8.88202", "-36.50216", "America/Recife"),("3399132", "Gameleira", "", "BR", "76", "", "30", "2605905", "", "-8.58444", "-35.38667", "America/Recife"),("3399377", "Fortuna", "", "BR", "76", "", "13", "2104206", "", "-5.73333", "-44.15833", "America/Fortaleza"),("3399415", "Fortaleza", "Форталеза", "BR", "76", "BR", "06", "2304400", "", "-3.71722", "-38.54306", "America/Fortaleza"),("3399445", "Forquilha", "", "BR", "76", "", "06", "2304350", "", "-3.79833", "-40.26056", "America/Fortaleza"),("3399506", "Floriano", "Флориан", "BR", "76", "", "20", "2203909", "", "-6.76694", "-43.0225", "America/Fortaleza"),("3399518", "Floresta", "", "BR", "76", "", "30", "2605707", "", "-8.60111", "-38.56861", "America/Recife"),("3399539", "Flores", "", "BR", "76", "", "30", "2605608", "", "-7.86806", "-37.97472", "America/Recife"),("3399571", "Flexeiras", "", "BR", "76", "", "02", "2702801", "", "-9.1975", "-35.78083", "America/Maceio"),("3399679", "Feira Nova", "", "BR", "76", "", "30", "2605400", "", "-7.95083", "-35.38917", "America/Recife"),("3400497", "Farias Brito", "", "BR", "76", "", "06", "2304301", "", "-6.93056", "-39.56556", "America/Fortaleza"),("3400515", "Fagundes", "", "BR", "76", "", "17", "2506103", "", "-7.355", "-35.775", "America/Fortaleza"),("3400541", "Exu", "", "BR", "76", "", "30", "2605301", "", "-7.51194", "-39.72417", "America/Recife"),("3400558", "Eusébio", "Эусебио", "BR", "76", "", "06", "2304285", "", "-3.89", "-38.45056", "America/Fortaleza"),("3400567", "Extremoz", "Эстремос", "BR", "76", "", "22", "2403608", "", "-5.70556", "-35.30722", "America/Fortaleza"),("3400617", "Estreito", "", "BR", "76", "", "13", "2107803", "", "-5.78333", "-43.25", "America/Fortaleza"),("3400739", "Esperantinópolis", "", "BR", "76", "", "13", "2104008", "", "-4.86667", "-44.70833", "America/Fortaleza"),("3400740", "Esperantina", "", "BR", "76", "", "20", "2203701", "", "-3.90167", "-42.23361", "America/Fortaleza"),("3400752", "Esperança", "", "BR", "76", "", "17", "2506004", "", "-7.03306", "-35.85722", "America/Fortaleza"),("3400804", "Escada", "", "BR", "76", "", "30", "2605202", "", "-8.35917", "-35.22361", "America/Recife"),("3400920", "Elesbão Veloso", "", "BR", "76", "", "20", "2203503", "", "-6.20194", "-42.14028", "America/Fortaleza"),("3400969", "Dom Pedro", "", "BR", "76", "", "13", "2106003", "", "-5.03749", "-44.43857", "America/Fortaleza"),("3401060", "Desterro", "", "BR", "76", "", "17", "2505402", "", "-7.29056", "-37.09389", "America/Fortaleza"),("3401106", "Demerval Lobão", "", "BR", "76", "", "20", "2203305", "", "-5.35833", "-42.67639", "America/Fortaleza"),("3401109", "Delmiro Gouveia", "", "BR", "76", "", "02", "2702405", "", "-9.38861", "-37.99917", "America/Maceio"),("3401138", "Custódia", "", "BR", "76", "", "30", "2605103", "", "-8.0875", "-37.64306", "America/Recife"),("3401148", "Cururupu", "", "BR", "76", "", "13", "2103703", "", "-1.82833", "-44.86833", "America/Fortaleza"),("3401188", "Curuçá", "", "BR", "76", "", "16", "1502905", "", "-0.72889", "-47.84806", "America/Belem"),("3401283", "Currais Novos", "Куррайс-Новус", "BR", "76", "", "22", "2403103", "", "-6.26083", "-36.51778", "America/Fortaleza"),("3401331", "Curaçá", "", "BR", "76", "", "05", "2909901", "", "-8.99028", "-39.90944", "America/Bahia"),("3401340", "Cupira", "", "BR", "76", "", "30", "2605004", "", "-8.61667", "-35.95", "America/Recife"),("3401404", "Cumaru", "", "BR", "76", "", "30", "2604908", "", "-8.00611", "-35.69722", "America/Recife"),("3401419", "Cuité", "", "BR", "76", "", "17", "2505105", "", "-6.48361", "-36.15361", "America/Fortaleza"),("3401457", "Cruz do Espírito Santo", "", "BR", "76", "", "17", "2504900", "", "-7.14", "-35.08639", "America/Fortaleza"),("3401487", "Cruz", "", "BR", "76", "", "06", "2304251", "", "-2.9211", "-40.17589", "America/Fortaleza"),("3401545", "Crato", "Крату", "BR", "76", "", "06", "2304202", "", "-7.23417", "-39.40944", "America/Fortaleza"),("3401548", "Crateús", "", "BR", "76", "", "06", "2304103", "", "-5.17833", "-40.6775", "America/Fortaleza"),("3401703", "Coroatá", "", "BR", "76", "", "13", "2103604", "", "-4.13", "-44.12417", "America/Fortaleza"),("3401725", "Coremas", "", "BR", "76", "", "17", "2504801", "", "-7.01444", "-37.94583", "America/Fortaleza"),("3401729", "Coreaú", "", "BR", "76", "", "06", "2304004", "", "-3.53333", "-40.65667", "America/Fortaleza"),("3401830", "Condado", "", "BR", "76", "", "30", "2604601", "", "-7.58583", "-35.10583", "America/Recife"),("3401845", "Conceição do Araguaia", "", "BR", "76", "", "16", "1502707", "", "-8.26441", "-49.26982", "America/Belem"),("3401944", "Colônia Leopoldina", "", "BR", "76", "", "02", "", "", "-8.90889", "-35.725", "America/Recife"),("3401963", "Colinas", "Колинас", "BR", "76", "", "13", "2103505", "", "-6.02583", "-44.24917", "America/Fortaleza"),("3401992", "Coelho Neto", "", "BR", "76", "", "13", "2103406", "", "-4.25667", "-43.01278", "America/Fortaleza"),("3402000", "Codó", "", "BR", "76", "", "13", "2103307", "", "-4.45528", "-43.88556", "America/Fortaleza"),("3402050", "Cocal", "", "BR", "76", "", "20", "2202703", "", "-3.47194", "-41.5575", "America/Fortaleza"),("3402164", "Chorozinho", "", "BR", "76", "", "06", "2303956", "", "-4.30028", "-38.49778", "America/Fortaleza"),("3402229", "Chapadinha", "", "BR", "76", "", "13", "2103208", "", "-3.74167", "-43.36028", "America/Fortaleza"),("3402271", "Chã Grande", "", "BR", "76", "", "30", "2604502", "", "-8.23833", "-35.46167", "America/Recife"),("3402340", "Cedro", "", "BR", "76", "", "06", "2303808", "", "-6.60667", "-39.06222", "America/Fortaleza"),("3402360", "Ceará Mirim", "", "BR", "76", "", "22", "2402600", "", "-5.63444", "-35.42556", "America/Fortaleza"),("3402383", "Caxias", "", "BR", "76", "BR", "13", "2103000", "", "-4.85889", "-43.35611", "America/Fortaleza"),("3402429", "Caucaia", "", "BR", "76", "", "06", "2303709", "", "-3.73611", "-38.65306", "America/Fortaleza"),("3402465", "Catolé do Rocha", "", "BR", "76", "", "17", "2504306", "", "-6.34389", "-37.74667", "America/Fortaleza"),("3402528", "Catende", "", "BR", "76", "", "30", "2604205", "", "-8.66667", "-35.71667", "America/Recife"),("3402548", "Castelo do Piauí", "", "BR", "76", "", "20", "2202604", "", "-5.32222", "-41.5525", "America/Fortaleza"),("3402591", "Castanhal", "", "BR", "76", "", "16", "1502400", "", "-1.29389", "-47.92639", "America/Belem"),("3402613", "Cascavel", "", "BR", "76", "", "06", "2303501", "", "-4.13306", "-38.24194", "America/Fortaleza"),("3402648", "Carutapera", "", "BR", "76", "", "13", "2102903", "", "-1.195", "-46.02", "America/Fortaleza"),("3402655", "Caruaru", "Каруару", "BR", "76", "", "30", "2604106", "", "-8.28333", "-35.97611", "America/Recife"),("3402721", "Carpina", "Карпина", "BR", "76", "", "30", "2604007", "", "-7.85083", "-35.25472", "America/Recife"),("3402724", "Carolina", "Каролина", "BR", "76", "", "13", "2102804", "", "-7.33561", "-47.46218", "America/Fortaleza"),("3402848", "Carnaíba", "", "BR", "76", "", "30", "2606606", "", "-8.7", "-37.66667", "America/Recife"),("3402882", "Caririaçu", "", "BR", "76", "", "06", "2303204", "", "-7.04222", "-39.28361", "America/Fortaleza"),("3402893", "Cariré", "", "BR", "76", "", "06", "2303105", "", "-3.95056", "-40.47333", "America/Fortaleza"),("3402920", "Careiro da Várzea", "", "BR", "76", "", "04", "1301159", "", "-3.19695", "-59.82674", "America/Manaus"),("3402944", "Caraúbas", "", "BR", "76", "", "22", "2402303", "", "-5.7925", "-37.55667", "America/Fortaleza"),("3403127", "Capitão Poço", "", "BR", "76", "", "16", "1502301", "", "-1.74639", "-47.05944", "America/Belem"),("3403200", "Capela", "", "BR", "76", "", "02", "2701704", "", "-9.4075", "-36.07361", "America/Maceio"),("3403208", "Capanema", "", "BR", "76", "", "16", "1502202", "", "-1.19583", "-47.18083", "America/Belem"),("3403251", "Canto do Buriti", "", "BR", "76", "", "20", "2202307", "", "-8.11", "-42.94444", "America/Fortaleza"),("3403309", "Cantanhede", "", "BR", "76", "", "13", "2102705", "", "-3.63333", "-44.37667", "America/Fortaleza"),("3403344", "Canindé de São Francisco", "", "BR", "76", "", "28", "2801207", "", "-9.66", "-37.78944", "America/Maceio"),("3403353", "Canindé", "", "BR", "76", "", "06", "2302800", "", "-4.35889", "-39.31167", "America/Fortaleza"),("3403360", "Canhotinho", "", "BR", "76", "", "30", "2603702", "", "-8.88222", "-36.19111", "America/Recife"),("3403362", "Canguaretama", "Кангуаретама", "BR", "76", "", "22", "2402204", "", "-6.38", "-35.12889", "America/Fortaleza"),("3403395", "Cândido Mendes", "", "BR", "76", "", "13", "2102606", "", "-1.44667", "-45.71667", "America/Fortaleza"),("3403534", "Campos Sales", "", "BR", "76", "", "06", "2302701", "", "-7.07444", "-40.37611", "America/Fortaleza"),("3403566", "Campo Maior", "", "BR", "76", "", "20", "2202208", "", "-4.82778", "-42.16861", "America/Fortaleza"),("3403611", "Campo Alegre", "", "BR", "76", "", "02", "2701407", "", "-9.78194", "-36.35083", "America/Maceio"),("3403642", "Campina Grande", "Кампина-Гранде", "BR", "76", "", "17", "2504009", "", "-7.23056", "-35.88111", "America/Fortaleza"),("3403685", "Camocim de São Félix", "", "BR", "76", "", "30", "2603504", "", "-8.35861", "-35.76194", "America/Recife"),("3403687", "Camocim", "", "BR", "76", "", "06", "2302602", "", "-2.90222", "-40.84111", "America/Fortaleza"),("3403697", "Cametá", "", "BR", "76", "", "16", "1502103", "", "-2.24444", "-49.49583", "America/Belem"),("3403941", "Cajueiro", "", "BR", "76", "", "02", "2704203", "", "-9.71667", "-36.45", "America/Maceio"),("3404020", "Cajazeiras", "Кажазейрас", "BR", "76", "", "17", "2503704", "", "-6.89028", "-38.55528", "America/Fortaleza"),("3404117", "Caicó", "Кайко", "BR", "76", "", "22", "2402006", "", "-6.45833", "-37.09778", "America/Fortaleza"),("3404231", "Caetés", "", "BR", "76", "", "30", "2603207", "", "-8.77306", "-36.6225", "America/Recife"),("3404306", "Cacimba de Dentro", "", "BR", "76", "", "17", "2503506", "", "-6.64167", "-35.79", "America/Fortaleza"),("3404355", "Cachoeirinha", "", "BR", "76", "", "30", "2603108", "", "-8.48639", "-36.23306", "America/Recife"),("3404513", "Cabrobó", "", "BR", "76", "", "30", "2603009", "", "-8.51417", "-39.31", "America/Recife"),("3404545", "Cabo", "", "BR", "76", "", "30", "2602902", "", "-8.28333", "-35.03333", "America/Recife"),("3404558", "Cabedelo", "", "BR", "76", "", "17", "2503209", "", "-6.98111", "-34.83389", "America/Fortaleza"),("3404656", "Caaporã", "", "BR", "76", "", "17", "2503001", "", "-7.51556", "-34.90833", "America/Fortaleza"),("3404713", "Buriti dos Lopes", "", "BR", "76", "", "20", "2202000", "", "-3.175", "-41.86694", "America/Fortaleza"),("3404722", "Buriti Bravo", "", "BR", "76", "", "13", "2102309", "", "-5.83722", "-43.83361", "America/Fortaleza"),("3404760", "Bujaru", "", "BR", "76", "", "16", "1501907", "", "-1.515", "-48.04472", "America/Belem"),("3404766", "Buíque", "Буики", "BR", "76", "", "30", "2602803", "", "-8.62306", "-37.15583", "America/Recife"),("3404817", "Breves", "", "BR", "76", "", "16", "1501808", "", "-1.68222", "-50.48028", "America/Belem"),("3404833", "Brejo Santo", "", "BR", "76", "", "06", "2302503", "", "-7.49333", "-38.98722", "America/Fortaleza"),("3404862", "Brejo da Madre de Deus", "", "BR", "76", "", "30", "2602605", "", "-8.14583", "-36.37111", "America/Recife"),("3404889", "Brejo", "", "BR", "76", "", "13", "2102101", "", "-3.68444", "-42.75028", "America/Fortaleza"),("3404924", "Brejinho", "", "BR", "76", "", "22", "2401800", "", "-6.19083", "-35.35667", "America/Fortaleza"),("3405006", "Bragança", "", "BR", "76", "", "16", "1501709", "", "-1.05361", "-46.76556", "America/Belem"),("3405051", "Borba", "", "BR", "76", "", "04", "1300805", "", "-4.39143", "-59.58864", "America/Manaus"),("3405061", "Boqueirão", "", "BR", "76", "", "17", "2502508", "", "-7.48237", "-36.13422", "America/Fortaleza"),("3405172", "Bonito", "", "BR", "76", "", "30", "2602308", "", "-8.47028", "-35.72861", "America/Recife"),("3405304", "Bom Jesus", "", "BR", "76", "", "20", "2201903", "", "-9.07444", "-44.35861", "America/Fortaleza"),("3405339", "Bom Jardim", "", "BR", "76", "", "30", "2602209", "", "-7.79583", "-35.58722", "America/Recife"),("3405341", "Bom Jardim", "", "BR", "76", "", "13", "2104073", "", "-7.01667", "-46.48333", "America/Fortaleza"),("3405380", "Bom Conselho", "", "BR", "76", "", "30", "2602100", "", "-9.16972", "-36.67972", "America/Recife"),("3405616", "Boa Viagem", "", "BR", "76", "", "06", "2302404", "", "-5.1275", "-39.73222", "America/Fortaleza"),("3405738", "Bezerros", "Безеррус", "BR", "76", "", "30", "2601904", "", "-8.23333", "-35.79694", "America/Recife"),("3405778", "Bequimão", "", "BR", "76", "", "13", "2101905", "", "-2.44889", "-44.7825", "America/Fortaleza"),("3405792", "Benevides", "", "BR", "76", "", "16", "1501501", "", "-1.36139", "-48.24472", "America/Belem"),("3405796", "Beneditinos", "", "BR", "76", "", "20", "2201606", "", "-5.45", "-42.36667", "America/Fortaleza"),("3405812", "Belo Jardim", "", "BR", "76", "", "30", "2601706", "", "-8.33556", "-36.42417", "America/Recife"),("3405851", "Belém do Brejo do Cruz", "", "BR", "76", "", "17", "2502003", "", "-6.18861", "-37.53583", "America/Fortaleza"),("3405852", "Belém de São Francisco", "", "BR", "76", "", "30", "2601607", "", "-8.75389", "-38.96583", "America/Recife"),("3405863", "Belém", "Белем", "BR", "76", "", "17", "2501906", "", "-6.69167", "-35.53333", "America/Fortaleza"),("3405870", "Belém", "Белен", "BR", "76", "", "16", "1501402", "", "-1.45583", "-48.50444", "America/Belem"),("3405908", "Bela Cruz", "", "BR", "76", "", "06", "2302305", "", "-3.05056", "-40.16778", "America/Fortaleza"),("3405924", "Beberibe", "Беберибе", "BR", "76", "", "06", "2302206", "", "-4.17972", "-38.13056", "America/Fortaleza"),("3405940", "Bayeux", "", "BR", "76", "", "17", "2501807", "", "-7.125", "-34.93222", "America/Fortaleza"),("3405954", "Baturité", "", "BR", "76", "", "06", "2302107", "", "-4.32861", "-38.88472", "America/Fortaleza"),("3405993", "Batalha", "", "BR", "76", "", "02", "2700706", "", "-9.67778", "-37.12472", "America/Maceio"),("3406001", "Batalha", "", "BR", "76", "", "20", "2201507", "", "-4.025", "-42.075", "America/Fortaleza"),("3406041", "Barroquinha", "", "BR", "76", "", "06", "2302057", "", "-3.01889", "-41.13611", "America/Fortaleza"),("3406088", "Barro", "", "BR", "76", "", "06", "2307502", "", "-6.71667", "-38.86667", "America/Fortaleza"),("3406160", "Barreiros", "", "BR", "76", "", "30", "2601409", "", "-8.81833", "-35.18639", "America/Recife"),("3406196", "Barreirinhas", "", "BR", "76", "", "13", "2101707", "", "-2.75556", "-42.82591", "America/Fortaleza"),("3406202", "Barreirinha", "", "BR", "76", "", "04", "1300508", "", "-2.79333", "-57.07", "America/Manaus"),("3406263", "Barras", "Баррас", "BR", "76", "", "20", "2201200", "", "-4.24444", "-42.29444", "America/Fortaleza"),("3406318", "Barra do Corda", "", "BR", "76", "", "13", "2101608", "", "-5.50308", "-45.23693", "America/Fortaleza"),("3406333", "Barra de Santo Antônio", "", "BR", "76", "", "02", "2700508", "", "-9.40472", "-35.50722", "America/Maceio"),("3406429", "Barcarena", "", "BR", "76", "", "16", "1501303", "", "-1.50583", "-48.62583", "America/Belem"),("3406442", "Barbalha", "", "BR", "76", "", "06", "2301901", "", "-7.31111", "-39.30417", "America/Fortaleza"),("3406457", "Baraúna", "", "BR", "76", "", "22", "2401453", "", "-5.08", "-37.61667", "America/Fortaleza"),("3406503", "Bananeiras", "", "BR", "76", "", "17", "2501500", "", "-6.75", "-35.63333", "America/Fortaleza"),("3406545", "Balsas", "Альтбальсас", "BR", "76", "", "13", "2101400", "", "-7.5325", "-46.03556", "America/Fortaleza"),("3406844", "Baião", "", "BR", "76", "", "16", "1501204", "", "-2.79056", "-49.67167", "America/Belem"),("3406910", "Bacabal", "Бакабал", "BR", "76", "", "13", "2101202", "", "-4.29167", "-44.79167", "America/Fortaleza"),("3406948", "Autazes", "", "BR", "76", "", "04", "1300300", "", "-3.57972", "-59.13056", "America/Manaus"),("3406954", "Aurora", "", "BR", "76", "", "06", "2301703", "", "-6.9425", "-38.9675", "America/Fortaleza"),("3406961", "Augusto Corrêa", "", "BR", "76", "", "16", "1500909", "", "-1.02167", "-46.635", "America/Belem"),("3406996", "Atalaia", "", "BR", "76", "", "02", "2700409", "", "-9.50194", "-36.02278", "America/Maceio"),("3407010", "Assaré", "", "BR", "76", "", "06", "2301604", "", "-6.87444", "-39.875", "America/Fortaleza"),("3407091", "Aroeiras", "", "BR", "76", "", "17", "2501302", "", "-7.54528", "-35.7075", "America/Fortaleza"),("3407151", "Arês", "", "BR", "76", "", "22", "2401206", "", "-6.19444", "-35.16028", "America/Fortaleza"),("3407194", "Areia Branca", "", "BR", "76", "", "22", "2401107", "", "-4.95611", "-37.13694", "America/Fortaleza"),("3407210", "Areia", "", "BR", "76", "", "17", "2501104", "", "-6.96333", "-35.69167", "America/Fortaleza"),("3407216", "Arcoverde", "Арковерди", "BR", "76", "", "30", "2601201", "", "-8.41889", "-37.05389", "America/Recife"),("3407239", "Araruna", "", "BR", "76", "", "17", "2501005", "", "-6.55833", "-35.74167", "America/Fortaleza"),("3407243", "Araripina", "Арарипина", "BR", "76", "", "30", "2601102", "", "-7.57611", "-40.49833", "America/Recife"),("3407248", "Araripe", "", "BR", "76", "", "06", "2301307", "", "-7.2125", "-40.04611", "America/Fortaleza"),("3407258", "Arari", "", "BR", "76", "", "13", "2101004", "", "-3.45361", "-44.78", "America/Fortaleza"),("3407297", "Arara", "", "BR", "76", "", "17", "2500908", "", "-6.82833", "-35.75833", "America/Fortaleza"),("3407327", "Arapiraca", "", "BR", "76", "", "02", "2700300", "", "-9.7525", "-36.66111", "America/Maceio"),("3407351", "Araioses", "", "BR", "76", "", "13", "2100907", "", "-2.89", "-41.90306", "America/Fortaleza"),("3407357", "Araguaína", "Арагуаина", "BR", "76", "BR", "31", "1702109", "", "-7.19111", "-48.20722", "America/Araguaina"),("3407366", "Araçoiaba", "", "BR", "76", "", "30", "2601052", "", "-7.79028", "-35.09083", "America/Recife"),("3407367", "Aracoiaba", "", "BR", "76", "", "06", "2301208", "", "-4.37111", "-38.81417", "America/Fortaleza"),("3407378", "Aracati", "Аракати", "BR", "76", "", "06", "2301109", "", "-4.56167", "-37.76972", "America/Fortaleza"),("3407407", "Aquiraz", "", "BR", "76", "", "06", "2301000", "", "-3.90139", "-38.39111", "America/Fortaleza"),("3407440", "Apodi", "", "BR", "76", "", "22", "2401008", "", "-5.66417", "-37.79889", "America/Fortaleza"),("3407544", "Angicos", "", "BR", "76", "", "22", "2400802", "", "-5.66556", "-36.60111", "America/Fortaleza"),("3407669", "Ananindeua", "Ананиндеуа", "BR", "76", "", "16", "1500800", "", "-1.36556", "-48.37222", "America/Belem"),("3407682", "Anajatuba", "", "BR", "76", "", "13", "2100709", "", "-3.26444", "-44.61972", "America/Fortaleza"),("3407693", "Anadia", "", "BR", "76", "", "02", "2700201", "", "-9.68444", "-36.30417", "America/Maceio"),("3407703", "Amontada", "", "BR", "76", "", "06", "2300754", "", "-3.36167", "-39.83167", "America/Fortaleza"),("3407755", "Amarante do Maranhão", "", "BR", "76", "", "13", "2100600", "", "-5.56667", "-46.74222", "America/Fortaleza"),("3407756", "Amarante", "", "BR", "76", "", "20", "2200509", "", "-6.24316", "-42.84544", "America/Fortaleza"),("3407758", "Amaraji", "", "BR", "76", "", "30", "2600906", "", "-8.38306", "-35.4525", "America/Recife"),("3407797", "Altos", "", "BR", "76", "", "20", "2200400", "", "-5.03806", "-42.46", "America/Fortaleza"),("3407871", "Altinho", "", "BR", "76", "", "30", "2600807", "", "-8.48972", "-36.05944", "America/Recife"),("3407882", "Altamira", "Альтамира", "BR", "76", "", "16", "1500602", "", "-3.20333", "-52.20639", "America/Santarem"),("3407903", "Almeirim", "Алмейрин", "BR", "76", "", "16", "1500503", "", "-1.52333", "-52.58167", "America/Santarem"),("3407940", "Alhandra", "", "BR", "76", "", "17", "2500601", "", "-7.43861", "-34.91444", "America/Fortaleza"),("3407977", "Alexandria", "", "BR", "76", "", "22", "2400505", "", "-6.4125", "-38.01583", "America/Fortaleza"),("3407980", "Alenquer", "", "BR", "76", "", "16", "1500404", "", "-1.94167", "-54.73833", "America/Santarem"),("3408073", "Alcântara", "", "BR", "76", "", "13", "2100204", "", "-2.4041", "-44.41669", "America/Fortaleza"),("3408094", "Alagoinha", "", "BR", "76", "", "17", "2500502", "", "-6.95", "-35.545", "America/Fortaleza"),("3408097", "Alagoa Nova", "", "BR", "76", "", "17", "2500403", "", "-7.07083", "-35.75833", "America/Fortaleza"),("3408100", "Alagoa Grande", "", "BR", "76", "", "17", "2515807", "", "-7.15833", "-35.63", "America/Fortaleza"),("3408166", "Águas Belas", "", "BR", "76", "", "30", "2600500", "", "-9.11139", "-37.12306", "America/Recife"),("3408175", "Água Preta", "", "BR", "76", "", "30", "2600401", "", "-8.7075", "-35.53056", "America/Recife"),("3408210", "Água Branca", "", "BR", "76", "", "02", "2700102", "", "-9.26083", "-37.93611", "America/Maceio"),("3408221", "Água Branca", "", "BR", "76", "", "20", "2200202", "", "-5.89222", "-42.63611", "America/Fortaleza"),("3408251", "Agrestina", "", "BR", "76", "", "30", "2600302", "", "-8.45806", "-35.94472", "America/Recife"),("3408269", "Afuá", "", "BR", "76", "", "16", "1500305", "", "-0.15667", "-50.38667", "America/Belem"),("3408272", "Afonso Bezerra", "", "BR", "76", "", "22", "2400307", "", "-5.49833", "-36.50556", "America/Fortaleza"),("3408274", "Afogados da Ingazeira", "", "BR", "76", "", "30", "2600104", "", "-7.75083", "-37.63917", "America/Recife"),("3408337", "Açu", "", "BR", "76", "", "22", "2400208", "", "-5.57667", "-36.90861", "America/Fortaleza"),("3408343", "Acopiara", "", "BR", "76", "", "06", "2300309", "", "-6.09528", "-39.4525", "America/Fortaleza"),("3408368", "Acaraú", "Акарау", "BR", "76", "", "06", "2300200", "", "-2.88556", "-40.12", "America/Fortaleza"),("3408386", "Acará", "", "BR", "76", "", "16", "1500206", "", "-1.96083", "-48.19667", "America/Belem"),("3408404", "Abreu e Lima", "", "BR", "76", "", "30", "2600054", "", "-7.91167", "-34.90278", "America/Recife"),("3408424", "Abaetetuba", "", "BR", "76", "", "16", "1500107", "", "-1.71806", "-48.8825", "America/Belem"),("3444823", "Xique Xique", "", "BR", "76", "", "05", "2933604", "", "-10.82294", "-42.72815", "America/Bahia"),("3444843", "Chavantes", "", "BR", "76", "", "27", "3557204", "", "-23.03889", "-49.70944", "America/Sao_Paulo"),("3444848", "Xanxerê", "", "BR", "76", "", "26", "4219507", "", "-26.87694", "-52.40417", "America/Sao_Paulo"),("3444864", "Votuporanga", "", "BR", "76", "", "27", "3557105", "", "-20.42278", "-49.97278", "America/Sao_Paulo"),("3444866", "Votorantim", "", "BR", "76", "", "27", "3557006", "", "-23.54667", "-47.43778", "America/Sao_Paulo"),("3444876", "Volta Redonda", "Волта-Редонда", "BR", "76", "", "21", "3306305", "", "-22.52306", "-44.10417", "America/Sao_Paulo"),("3444914", "Vitória da Conquista", "Витория-да-Конкиста", "BR", "76", "", "05", "2933307", "", "-14.86611", "-40.83944", "America/Bahia"),("3444924", "Vitória", "Витория", "BR", "76", "", "08", "3205309", "", "-20.31944", "-40.33778", "America/Sao_Paulo"),("3444969", "Visconde do Rio Branco", "", "BR", "76", "", "15", "3172004", "", "-21.01028", "-42.84056", "America/Sao_Paulo"),("3444997", "Viradouro", "", "BR", "76", "", "27", "3556800", "", "-20.87306", "-48.29694", "America/Sao_Paulo"),("3445014", "Vinhedo", "", "BR", "76", "", "27", "3556701", "", "-23.02972", "-46.97528", "America/Sao_Paulo"),("3445026", "Vila Velha", "Вила-Велья", "BR", "76", "", "08", "3205200", "", "-20.32972", "-40.2925", "America/Sao_Paulo"),("3445126", "Videira", "Видейра", "BR", "76", "", "26", "4219309", "", "-27.00833", "-51.15167", "America/Sao_Paulo"),("3445133", "Viçosa", "Висоза", "BR", "76", "", "15", "3171303", "", "-20.75389", "-42.88194", "America/Sao_Paulo"),("3445148", "Vianópolis", "", "BR", "76", "", "29", "5222005", "", "-16.74194", "-48.51639", "America/Sao_Paulo"),("3445153", "Viana", "Виана", "BR", "76", "", "08", "3205101", "", "-20.39028", "-40.49611", "America/Sao_Paulo"),("3445156", "Viamão", "Виаман", "BR", "76", "", "23", "4323002", "", "-30.08111", "-51.02333", "America/Sao_Paulo"),("3445162", "Vespasiano", "", "BR", "76", "", "15", "3171204", "", "-19.69194", "-43.92333", "America/Sao_Paulo"),("3445299", "Veranópolis", "", "BR", "76", "", "23", "4322806", "", "-28.93611", "-51.54944", "America/Sao_Paulo"),("3445307", "Vera Cruz", "", "BR", "76", "", "05", "2901304", "", "-12.63333", "-41.03333", "America/Bahia"),("3445348", "Wenceslau Braz", "", "BR", "76", "", "18", "4128500", "", "-23.87389", "-49.80278", "America/Sao_Paulo"),("3445350", "Venâncio Aires", "", "BR", "76", "", "23", "4322608", "", "-29.60639", "-52.19194", "America/Sao_Paulo"),("3445418", "Vazante", "", "BR", "76", "", "15", "3171006", "", "-17.98694", "-46.90778", "America/Sao_Paulo"),("3445433", "Vassouras", "", "BR", "76", "", "21", "3306206", "", "-22.40389", "-43.6625", "America/Sao_Paulo"),("3445442", "Varzelândia", "", "BR", "76", "", "15", "3170909", "", "-15.70139", "-44.0275", "America/Sao_Paulo"),("3445446", "Várzea Paulista", "", "BR", "76", "", "27", "3556503", "", "-23.21139", "-46.82833", "America/Sao_Paulo"),("3445451", "Várzea Grande", "", "BR", "76", "", "14", "5108402", "", "-15.64667", "-56.1325", "America/Cuiaba"),("3445459", "Várzea da Palma", "", "BR", "76", "", "15", "3170800", "", "-17.5976", "-44.73367", "America/Sao_Paulo"),("3445487", "Varginha", "Варжинья", "BR", "76", "", "15", "3170701", "", "-21.55139", "-45.43028", "America/Sao_Paulo"),("3445500", "Vargem Grande do Sul", "Варжен-Гранди-ду-Сул", "BR", "76", "", "27", "3556404", "", "-21.83222", "-46.89361", "America/Sao_Paulo"),("3445575", "Valparaíso", "", "BR", "76", "", "27", "3556305", "", "-21.22778", "-50.86833", "America/Sao_Paulo"),("3445578", "Valinhos", "", "BR", "76", "", "27", "3556206", "", "-22.97056", "-46.99583", "America/Sao_Paulo"),("3445594", "Valente", "", "BR", "76", "", "05", "2933000", "", "-11.41222", "-39.46194", "America/Bahia"),("3445596", "Valença", "Валенса", "BR", "76", "", "21", "3306107", "", "-22.24556", "-43.70028", "America/Sao_Paulo"),("3445597", "Valença", "", "BR", "76", "", "05", "2932903", "", "-13.37028", "-39.07306", "America/Bahia"),("3445630", "Vacaria", "Вакария", "BR", "76", "", "23", "4322509", "", "-28.51222", "-50.93389", "America/Sao_Paulo"),("3445667", "Urussanga", "", "BR", "76", "", "26", "4219002", "", "-28.51778", "-49.32083", "America/Sao_Paulo"),("3445675", "Urupês", "", "BR", "76", "", "27", "3556008", "", "-21.20167", "-49.29", "America/Sao_Paulo"),("3445679", "Uruguaiana", "Уругуаяна", "BR", "76", "", "23", "4322400", "", "-29.75472", "-57.08833", "America/Sao_Paulo"),("3445690", "Uruçuca", "", "BR", "76", "", "05", "2932705", "", "-14.59306", "-39.28444", "America/Bahia"),("3445712", "Uruana", "", "BR", "76", "", "29", "5221700", "", "-15.5036", "-49.68266", "America/Sao_Paulo"),("3445713", "Uruaçu", "Уруасу", "BR", "76", "", "29", "5221601", "", "-14.52472", "-49.14083", "America/Sao_Paulo"),("3445746", "União da Vitória", "Униан-да-Витория", "BR", "76", "", "18", "4128203", "", "-26.23", "-51.08639", "America/Sao_Paulo"),("3445764", "Unaí", "Унай", "BR", "76", "", "15", "3170404", "", "-16.3575", "-46.90611", "America/Sao_Paulo"),("3445781", "Una", "", "BR", "76", "", "05", "2932507", "", "-15.29333", "-39.07528", "America/Bahia"),("3445782", "Umuarama", "", "BR", "76", "", "18", "4128104", "", "-23.76639", "-53.325", "America/Sao_Paulo"),("3445818", "Umbaúba", "", "BR", "76", "", "28", "2807600", "", "-11.38333", "-37.65778", "America/Maceio"),("3445831", "Uberlândia", "Уберландия", "BR", "76", "", "15", "3170206", "", "-18.91861", "-48.27722", "America/Sao_Paulo"),("3445839", "Uberaba", "Убераба", "BR", "76", "", "15", "3170107", "", "-19.74833", "-47.93194", "America/Sao_Paulo"),("3445847", "Ubatuba", "Убатуба", "BR", "76", "", "27", "3555406", "", "-23.43389", "-45.07111", "America/Sao_Paulo"),("3445849", "Ubatã", "", "BR", "76", "", "05", "2932309", "", "-14.20906", "-39.52641", "America/Bahia"),("3445853", "Ubaitaba", "", "BR", "76", "", "05", "2932200", "", "-14.3125", "-39.32333", "America/Bahia"),("3445854", "Ubaíra", "", "BR", "76", "", "05", "2932101", "", "-13.26806", "-39.66278", "America/Bahia"),("3445859", "Ubá", "Уба", "BR", "76", "", "15", "3169901", "", "-21.12", "-42.94278", "America/Sao_Paulo"),("3445912", "Turmalina", "", "BR", "76", "", "15", "3169703", "", "-17.28556", "-42.73", "America/Sao_Paulo"),("3445922", "Tupi Paulista", "", "BR", "76", "", "27", "3555109", "", "-21.38111", "-51.57056", "America/Sao_Paulo"),("3445939", "Tupanciretã", "", "BR", "76", "", "23", "4322202", "", "-29.08056", "-53.83583", "America/Sao_Paulo"),("3445941", "Tupaciguara", "Тупасигуара", "BR", "76", "", "15", "3169604", "", "-18.59222", "-48.705", "America/Sao_Paulo"),("3445942", "Tupã", "Тупа", "BR", "76", "", "27", "3555000", "", "-21.93472", "-50.51361", "America/Sao_Paulo"),("3445983", "Tucano", "", "BR", "76", "", "05", "2931905", "", "-10.95817", "-38.79084", "America/Bahia"),("3445993", "Tubarão", "Тубаран", "BR", "76", "", "26", "4218707", "", "-28.46667", "-49.00694", "America/Sao_Paulo"),("3446019", "Triunfo", "", "BR", "76", "", "23", "4322004", "", "-29.94333", "-51.71806", "America/Sao_Paulo"),("3446038", "Trindade", "Триндади", "BR", "76", "", "29", "5221403", "", "-16.64944", "-49.48889", "America/Sao_Paulo"),("3446065", "Três Rios", "", "BR", "76", "", "21", "3306008", "", "-22.11667", "-43.20917", "America/Sao_Paulo"),("3446077", "Três Pontas", "Трес-Понтас", "BR", "76", "", "15", "3169406", "", "-21.36667", "-45.5125", "America/Sao_Paulo"),("3446087", "Três Passos", "", "BR", "76", "", "23", "4321907", "", "-27.45556", "-53.93194", "America/Sao_Paulo"),("3446098", "Três Lagoas", "Трес-Лагоас", "BR", "76", "", "11", "5008305", "", "-20.78765", "-51.70338", "America/Campo_Grande"),("3446130", "Três de Maio", "", "BR", "76", "", "23", "4321808", "", "-27.77333", "-54.24", "America/Sao_Paulo"),("3446137", "Três Coroas", "", "BR", "76", "", "23", "4321709", "", "-29.51694", "-50.77778", "America/Sao_Paulo"),("3446138", "Três Corações", "", "BR", "76", "", "15", "3169307", "", "-21.69694", "-45.25333", "America/Sao_Paulo"),("3446171", "Três Barras", "", "BR", "76", "", "26", "4218301", "", "-26.10639", "-50.32222", "America/Sao_Paulo"),("3446194", "Tremembé", "", "BR", "76", "", "27", "3554805", "", "-22.95833", "-45.54944", "America/Sao_Paulo"),("3446232", "Tramandaí", "", "BR", "76", "", "23", "4321600", "", "-29.98472", "-50.13361", "America/Sao_Paulo"),("3446295", "Torres", "Торрес", "BR", "76", "", "23", "4321501", "", "-29.33528", "-49.72694", "America/Sao_Paulo"),("3446370", "Toledo", "Толедо", "BR", "76", "", "18", "4127700", "", "-24.71361", "-53.74306", "America/Sao_Paulo"),("3446392", "Tocantins", "", "BR", "76", "", "15", "3169000", "", "-21.175", "-43.01778", "America/Sao_Paulo"),("3446400", "Tobias Barreto", "", "BR", "76", "", "28", "2807402", "", "-11.18389", "-37.99833", "America/Maceio"),("3446445", "Timóteo", "Тимофей", "BR", "76", "", "15", "3168705", "", "-19.58106", "-42.64953", "America/Sao_Paulo"),("3446465", "Timbó", "", "BR", "76", "", "26", "4218202", "", "-26.82333", "-49.27167", "America/Sao_Paulo"),("3446500", "Tijucas", "Тижукас", "BR", "76", "", "26", "4218004", "", "-27.24139", "-48.63361", "America/Sao_Paulo"),("3446539", "Tietê", "", "BR", "76", "", "27", "3554508", "", "-23.10194", "-47.71472", "America/Sao_Paulo"),("3446550", "Tibagi", "", "BR", "76", "", "18", "4127502", "", "-24.50944", "-50.41361", "America/Sao_Paulo"),("3446556", "Teutônia", "", "BR", "76", "", "23", "4321451", "", "-29.44806", "-51.80639", "America/Sao_Paulo"),("3446579", "Terra Roxa", "", "BR", "76", "", "18", "4127809", "", "-23.85571", "-50.0314", "America/Sao_Paulo"),("3446581", "Terra Rica", "", "BR", "76", "", "18", "4127304", "", "-22.70944", "-52.61694", "America/Sao_Paulo"),("3446587", "Terra Nova", "", "BR", "76", "", "05", "2927200", "", "-12.36667", "-40.66667", "America/Bahia"),("3446598", "Terra Boa", "", "BR", "76", "", "18", "4127205", "", "-23.76806", "-52.44417", "America/Sao_Paulo"),("3446606", "Teresópolis", "Терезополис", "BR", "76", "", "21", "3305802", "", "-22.4167", "-42.97822", "America/Sao_Paulo"),("3446619", "Terenos", "", "BR", "76", "", "11", "5008008", "", "-20.44222", "-54.86028", "America/Campo_Grande"),("3446621", "Teófilo Otoni", "Теофилу-Отони", "BR", "76", "", "15", "3168606", "", "-17.8575", "-41.50528", "America/Sao_Paulo"),("3446625", "Teodoro Sampaio", "", "BR", "76", "", "27", "3554300", "", "-22.5325", "-52.1675", "America/Sao_Paulo"),("3446652", "Telêmaco Borba", "", "BR", "76", "", "18", "4127106", "", "-24.32389", "-50.61556", "America/Sao_Paulo"),("3446682", "Taubaté", "Таубате", "BR", "76", "", "27", "3554102", "", "-23.02639", "-45.55528", "America/Sao_Paulo"),("3446692", "Tatuí", "", "BR", "76", "", "27", "3554003", "", "-23.35556", "-47.85694", "America/Sao_Paulo"),("3446718", "Tarumã", "", "BR", "76", "", "27", "3553955", "", "-22.74667", "-50.57722", "America/Sao_Paulo"),("3446752", "Taquarituba", "", "BR", "76", "", "27", "3553807", "", "-23.53306", "-49.24444", "America/Sao_Paulo"),("3446753", "Taquaritinga", "", "BR", "76", "", "27", "3553708", "", "-21.40611", "-48.50472", "America/Sao_Paulo"),("3446783", "Taquari", "Такуари", "BR", "76", "", "23", "4321303", "", "-29.79972", "-51.86444", "America/Sao_Paulo"),("3446847", "Taquara", "", "BR", "76", "", "23", "4321204", "", "-29.65056", "-50.78056", "America/Sao_Paulo"),("3446866", "Tapiramutá", "", "BR", "76", "", "05", "2931301", "", "-11.84722", "-40.79139", "America/Bahia"),("3446880", "Tapes", "", "BR", "76", "", "23", "4321105", "", "-30.67333", "-51.39583", "America/Sao_Paulo"),("3446881", "Taperoá", "", "BR", "76", "", "05", "2931202", "", "-13.53806", "-39.09861", "America/Bahia"),("3446922", "Tapejara", "", "BR", "76", "", "23", "4320909", "", "-28.06806", "-52.01389", "America/Sao_Paulo"),("3446923", "Tapejara", "", "BR", "76", "", "18", "4126801", "", "-23.73306", "-52.87333", "America/Sao_Paulo"),("3446971", "Tanhaçu", "", "BR", "76", "", "05", "2931004", "", "-14.02139", "-41.24806", "America/Bahia"),("3446974", "Tanguá", "", "BR", "76", "", "21", "3305752", "", "-22.73028", "-42.71417", "America/Sao_Paulo"),("3446979", "Tanabi", "", "BR", "76", "", "27", "3553401", "", "-20.62639", "-49.64917", "America/Sao_Paulo"),("3447005", "Tambaú", "", "BR", "76", "", "27", "3553302", "", "-21.705", "-47.27444", "America/Sao_Paulo"),("3447059", "Taiobeiras", "Тайобейрас", "BR", "76", "", "15", "3168002", "", "-15.80778", "-42.23306", "America/Sao_Paulo"),("3447075", "Taguatinga", "", "BR", "76", "BR", "31", "1720903", "", "-12.40389", "-46.43611", "America/Araguaina"),("3447186", "Taboão da Serra", "", "BR", "76", "", "27", "3552809", "", "-23.62611", "-46.79167", "America/Sao_Paulo"),("3447200", "Tabatinga", "", "BR", "76", "", "27", "3552700", "", "-21.71667", "-48.6875", "America/Sao_Paulo"),("3447212", "Suzano", "Сузано", "BR", "76", "", "27", "3552502", "", "-23.5425", "-46.31083", "America/Sao_Paulo"),("3447259", "Sumaré", "Сумаре", "BR", "76", "", "27", "3552403", "", "-22.82194", "-47.26694", "America/Sao_Paulo"),("3447399", "Sorocaba", "Сорокаба", "BR", "76", "", "27", "3552205", "", "-23.50167", "-47.45806", "America/Sao_Paulo"),("3447409", "Sombrio", "", "BR", "76", "", "26", "4217709", "", "-29.11389", "-49.61667", "America/Sao_Paulo"),("3447423", "Soledade", "", "BR", "76", "", "23", "4320800", "", "-28.81833", "-52.51028", "America/Sao_Paulo"),("3447437", "Socorro", "Сокорро", "BR", "76", "", "27", "3552106", "", "-22.59139", "-46.52889", "America/Sao_Paulo"),("3447473", "Sobradinho", "", "BR", "76", "", "05", "2929107", "", "-12.83333", "-39.1", "America/Bahia"),("3447537", "Siqueira Campos", "", "BR", "76", "", "18", "4126603", "", "-23.68889", "-49.83389", "America/Sao_Paulo"),("3447562", "Simão Dias", "", "BR", "76", "", "28", "2807105", "", "-10.73833", "-37.81111", "America/Maceio"),("3447589", "Silvânia", "", "BR", "76", "", "29", "5220603", "", "-16.65889", "-48.60806", "America/Sao_Paulo"),("3447591", "Silva Jardim", "", "BR", "76", "", "21", "3305604", "", "-22.65083", "-42.39167", "America/Sao_Paulo"),("3447597", "Sidrolândia", "", "BR", "76", "", "11", "5007901", "", "-20.93194", "-54.96139", "America/Campo_Grande"),("3447598", "Siderópolis", "", "BR", "76", "", "26", "4217600", "", "-28.59778", "-49.42444", "America/Sao_Paulo"),("3447602", "Severínia", "", "BR", "76", "", "27", "3551900", "", "-20.80944", "-48.80278", "America/Sao_Paulo"),("3447624", "Sete Lagoas", "Сети-Лагоас", "BR", "76", "", "15", "3167202", "", "-19.46583", "-44.24667", "America/Sao_Paulo"),("3447651", "Sertãozinho", "", "BR", "76", "", "27", "3551702", "", "-21.13778", "-47.99028", "America/Sao_Paulo"),("3447658", "Sertanópolis", "", "BR", "76", "", "18", "4126504", "", "-23.05861", "-51.03639", "America/Sao_Paulo"),("3447672", "Serro", "", "BR", "76", "", "15", "3167103", "", "-18.60472", "-43.37944", "America/Sao_Paulo"),("3447690", "Serrinha", "", "BR", "76", "", "05", "2930501", "", "-11.66417", "-39.0075", "America/Bahia"),("3447718", "Serra Negra", "", "BR", "76", "", "27", "3551603", "", "-22.61222", "-46.70056", "America/Sao_Paulo"),("3447720", "Serrana", "", "BR", "76", "", "27", "3551504", "", "-21.21139", "-47.59556", "America/Sao_Paulo"),("3447779", "Serra", "Серра", "BR", "76", "", "08", "3205002", "", "-20.12861", "-40.30778", "America/Sao_Paulo"),("3447785", "Seropédica", "", "BR", "76", "", "21", "3305554", "", "-22.74389", "-43.7075", "America/Sao_Paulo"),("3447839", "Senhor do Bonfim", "", "BR", "76", "", "05", "2930105", "", "-10.46139", "-40.18944", "America/Bahia"),("3447848", "Sengés", "", "BR", "76", "", "18", "4126306", "", "-24.11335", "-49.46315", "America/Sao_Paulo"),("3447854", "Senador Canedo", "", "BR", "76", "", "29", "5220454", "", "-16.70806", "-49.09306", "America/Sao_Paulo"),("3447928", "Seabra", "", "BR", "76", "", "05", "2929909", "", "-12.41713", "-41.77049", "America/Bahia"),("3447929", "Schroeder", "", "BR", "76", "", "26", "4217402", "", "-26.4125", "-49.07306", "America/Sao_Paulo"),("3447961", "Saubara", "", "BR", "76", "", "05", "2929750", "", "-12.7375", "-38.76861", "America/Bahia"),("3447969", "Sarzedo", "", "BR", "76", "", "15", "3165537", "", "-20.03528", "-44.14472", "America/Sao_Paulo"),("3447997", "Sarandi", "Саранди", "BR", "76", "", "23", "4320107", "", "-27.94389", "-52.92306", "America/Sao_Paulo"),("3447998", "Sarandi", "", "BR", "76", "", "18", "4126256", "", "-23.44361", "-51.87389", "America/Sao_Paulo"),("3448011", "Saquarema", "", "BR", "76", "", "21", "3305505", "", "-22.92", "-42.51028", "America/Sao_Paulo"),("3448031", "Sapucaia", "Сапукая", "BR", "76", "", "23", "4320008", "", "-29.83333", "-51.15", "America/Sao_Paulo"),("3448033", "Sapucaia", "", "BR", "76", "", "21", "3305406", "", "-21.995", "-42.91444", "America/Sao_Paulo"),("3448063", "Sapiranga", "", "BR", "76", "", "23", "4319901", "", "-29.63806", "-51.00694", "America/Sao_Paulo"),("3448136", "São Vicente", "Сан-Висенти", "BR", "76", "", "27", "3551009", "", "-23.96306", "-46.39194", "America/Sao_Paulo"),("3448197", "São Simão", "", "BR", "76", "", "27", "3550902", "", "-21.47917", "-47.55083", "America/Sao_Paulo"),("3448207", "São Sepé", "", "BR", "76", "", "23", "4319604", "", "-30.16056", "-53.56528", "America/Sao_Paulo"),("3448219", "São Sebastião do Passé", "", "BR", "76", "", "05", "2929503", "", "-12.5125", "-38.49528", "America/Bahia"),("3448221", "São Sebastião do Paraíso", "Сан-Себастьян-ду-Параисо", "BR", "76", "", "15", "3164704", "", "-20.91694", "-46.99139", "America/Sao_Paulo"),("3448227", "São Sebastião do Caí", "", "BR", "76", "", "23", "4319505", "", "-29.58667", "-51.37556", "America/Sao_Paulo"),("3448257", "São Sebastião", "", "BR", "76", "", "27", "3550704", "", "-23.76", "-45.40972", "America/Sao_Paulo"),("3448300", "São Roque", "", "BR", "76", "", "27", "3550605", "", "-23.52917", "-47.13528", "America/Sao_Paulo"),("3448332", "São Pedro do Sul", "", "BR", "76", "", "23", "4319406", "", "-29.62056", "-54.17889", "America/Sao_Paulo"),("3448351", "São Pedro da Aldeia", "", "BR", "76", "", "21", "3305208", "", "-22.83917", "-42.10278", "America/Sao_Paulo"),("3448403", "São Pedro", "", "BR", "76", "", "27", "3550407", "", "-22.54861", "-47.91389", "America/Sao_Paulo"),("3448439", "São Paulo", "Сан-Паулу", "BR", "76", "", "27", "3550308", "", "-23.5475", "-46.63611", "America/Sao_Paulo"),("3448453", "São Miguel do Iguaçu", "", "BR", "76", "", "18", "4125704", "", "-25.34806", "-54.23778", "America/Sao_Paulo"),("3448455", "São Miguel do Araguaia", "", "BR", "76", "", "29", "5220207", "", "-13.275", "-50.16278", "America/Sao_Paulo"),("3448502", "São Mateus do Sul", "Сан-Матеус-ду-Сул", "BR", "76", "", "18", "4125605", "", "-25.87417", "-50.38278", "America/Sao_Paulo"),("3448519", "São Mateus", "Сан-Матеус", "BR", "76", "", "08", "3204906", "", "-18.72011", "-39.85891", "America/Sao_Paulo"),("3448533", "São Marcos", "", "BR", "76", "", "23", "4319000", "", "-28.97111", "-51.06806", "America/Sao_Paulo"),("3448545", "São Manuel", "Сан-Мануэль", "BR", "76", "", "27", "3550100", "", "-22.73111", "-48.57056", "America/Sao_Paulo"),("3448552", "São Luiz Gonzaga", "", "BR", "76", "", "23", "4318903", "", "-28.40833", "-54.96083", "America/Sao_Paulo"),("3448558", "São Luís de Montes Belos", "", "BR", "76", "", "29", "5220108", "", "-16.525", "-50.37222", "America/Sao_Paulo"),("3448596", "São Lourenço do Sul", "Сан-Лоренсу-ду-Сул", "BR", "76", "", "23", "4318804", "", "-31.36528", "-51.97833", "America/Sao_Paulo"),("3448597", "São Lourenço do Oeste", "", "BR", "76", "", "26", "4216909", "", "-26.35917", "-52.85111", "America/Sao_Paulo"),("3448599", "São Lourenço da Serra", "", "BR", "76", "", "27", "3549953", "", "-23.8525", "-46.9425", "America/Sao_Paulo"),("3448616", "São Lourenço", "Сан-Лоренсу", "BR", "76", "", "15", "3163706", "", "-22.11639", "-45.05444", "America/Sao_Paulo"),("3448622", "São Leopoldo", "Сан-Леополду", "BR", "76", "", "23", "4318705", "", "-29.76028", "-51.14722", "America/Sao_Paulo"),("3448632", "São José dos Pinhais", "Сан-Жозе-дус-Пиньяйс", "BR", "76", "", "18", "4125506", "", "-25.5302", "-49.20836", "America/Sao_Paulo"),("3448636", "São José dos Campos", "Сан-Жозе-дус-Кампус", "BR", "76", "", "27", "3549904", "", "-23.17944", "-45.88694", "America/Sao_Paulo"),("3448639", "São José do Rio Preto", "Сан-Жозе-ду-Риу-Прету", "BR", "76", "", "27", "3549805", "", "-20.81972", "-49.37944", "America/Sao_Paulo"),("3448640", "São José do Rio Pardo", "", "BR", "76", "", "27", "3549706", "", "-21.59556", "-46.88861", "America/Sao_Paulo"),("3448669", "São José do Calçado", "", "BR", "76", "", "08", "3204807", "", "-21.02528", "-41.65444", "America/Sao_Paulo"),("3448742", "São José", "", "BR", "76", "", "26", "4202800", "", "-28.21171", "-49.1632", "America/Sao_Paulo"),("3448824", "São Joaquim de Bicas", "", "BR", "76", "", "15", "3162922", "", "-20.04917", "-44.27389", "America/Sao_Paulo"),("3448825", "São Joaquim da Barra", "", "BR", "76", "", "27", "3549409", "", "-20.58139", "-47.85472", "America/Sao_Paulo"),("3448828", "São Joaquim", "", "BR", "76", "", "26", "4216503", "", "-28.29389", "-49.93167", "America/Sao_Paulo"),("3448846", "São João Nepomuceno", "Сан-Жуан-Непомусено", "BR", "76", "", "15", "3162906", "", "-21.54", "-43.01056", "America/Sao_Paulo"),("3448850", "São João Evangelista", "", "BR", "76", "", "15", "3162807", "", "-18.54778", "-42.76333", "America/Sao_Paulo"),("3448861", "São João do Paraíso", "", "BR", "76", "", "15", "3162708", "", "-15.31361", "-42.01444", "America/Sao_Paulo"),("3448877", "São João de Meriti", "Сан-Жуан-ди-Мерити", "BR", "76", "", "21", "3305109", "", "-22.80389", "-43.37222", "America/Sao_Paulo"),("3448879", "São João del Rei", "Сан-Жуан-дел-Рей", "BR", "76", "", "15", "3162500", "", "-21.13556", "-44.26167", "America/Sao_Paulo"),("3448892", "São João da Ponte", "", "BR", "76", "", "15", "3162401", "", "-15.92917", "-44.00778", "America/Sao_Paulo"),("3448902", "São João da Boa Vista", "", "BR", "76", "", "27", "3549102", "", "-21.96917", "-46.79806", "America/Sao_Paulo"),("3448903", "São João da Barra", "Сан-Жуан-да-Барра", "BR", "76", "", "21", "3305000", "", "-21.64028", "-41.05111", "America/Sao_Paulo"),("3448906", "São João Batista", "", "BR", "76", "", "26", "4216305", "", "-27.27611", "-48.84944", "America/Sao_Paulo"),("3449045", "São Jerônimo", "", "BR", "76", "", "23", "4318408", "", "-29.95917", "-51.72222", "America/Sao_Paulo"),("3449053", "São Gotardo", "", "BR", "76", "", "15", "3162104", "", "-19.31111", "-46.04889", "America/Sao_Paulo"),("3449055", "São Gonçalo dos Campos", "", "BR", "76", "", "05", "2929305", "", "-12.43333", "-38.96667", "America/Bahia"),("3449056", "São Gonçalo do Sapucaí", "", "BR", "76", "", "15", "3162005", "", "-21.89222", "-45.59528", "America/Sao_Paulo"),("3449099", "São Gabriel", "", "BR", "76", "", "23", "4318309", "", "-30.33639", "-54.32", "America/Sao_Paulo"),("3449112", "São Francisco do Sul", "Сан-Франсиску-ду-Сул", "BR", "76", "", "26", "4216206", "", "-26.24333", "-48.63806", "America/Sao_Paulo"),("3449116", "São Francisco do Conde", "Сан-Франсиску-ду-Конде", "BR", "76", "", "05", "2929206", "", "-12.6275", "-38.68", "America/Bahia"),("3449121", "São Francisco de Paula", "", "BR", "76", "", "23", "4318200", "", "-29.44806", "-50.58361", "America/Sao_Paulo"),("3449124", "São Francisco de Assis", "", "BR", "76", "", "23", "4318101", "", "-29.55028", "-55.13111", "America/Sao_Paulo"),("3449176", "São Francisco", "", "BR", "76", "", "15", "3161106", "", "-15.94861", "-44.86444", "America/Sao_Paulo"),("3449195", "São Fidélis", "", "BR", "76", "", "21", "3304805", "", "-21.64611", "-41.74694", "America/Sao_Paulo"),("3449216", "São Felipe", "", "BR", "76", "", "05", "2906899", "", "-14.8386", "-41.39174", "America/Bahia"),("3449219", "São Domingos do Prata", "", "BR", "76", "", "15", "3161007", "", "-19.865", "-42.96833", "America/Sao_Paulo"),("3449304", "São Desidério", "", "BR", "76", "", "05", "2928901", "", "-12.36333", "-44.97333", "America/Bahia"),("3449310", "São Cristóvão", "Сан-Кристован", "BR", "76", "", "28", "2806701", "", "-11.01472", "-37.20639", "America/Maceio"),("3449319", "São Carlos", "Сан-Карлос", "BR", "76", "", "27", "3548906", "", "-22.0175", "-47.89083", "America/Sao_Paulo"),("3449324", "São Caetano do Sul", "Сан-Каэтано-ду-Сул", "BR", "76", "", "27", "3548807", "", "-23.62306", "-46.55111", "America/Sao_Paulo"),("3449340", "São Borja", "Сан-Борха", "BR", "76", "", "23", "4318002", "", "-28.66056", "-56.00444", "America/Sao_Paulo"),("3449344", "São Bernardo do Campo", "Сан-Бернардо-ду-Кампу", "BR", "76", "", "27", "3548708", "", "-23.69389", "-46.565", "America/Sao_Paulo"),("3449350", "São Bento do Sul", "Сан-Бенту-ду-Сул", "BR", "76", "", "26", "4215802", "", "-26.25028", "-49.37861", "America/Sao_Paulo"),("3449427", "Santos Dumont", "", "BR", "76", "", "15", "3160702", "", "-21.45667", "-43.5525", "America/Sao_Paulo"),("3449433", "Santos", "Сантос", "BR", "76", "", "27", "3548500", "", "-23.96083", "-46.33361", "America/Sao_Paulo"),("3449467", "Santo Estêvão", "", "BR", "76", "", "05", "2928802", "", "-12.43028", "-39.25139", "America/Bahia"),("3449476", "Santo Augusto", "", "BR", "76", "", "23", "4317806", "", "-27.85083", "-53.77722", "America/Sao_Paulo"),("3449479", "Santo Antônio do Sudoeste", "", "BR", "76", "", "18", "4124400", "", "-26.07361", "-53.72528", "America/Sao_Paulo"),("3449500", "Santo Antônio do Monte", "", "BR", "76", "", "15", "3160405", "", "-20.08722", "-45.29361", "America/Sao_Paulo"),("3449502", "Santo Antônio do Leverger", "", "BR", "76", "", "14", "5107800", "", "-15.86556", "-56.07667", "America/Cuiaba"),("3449516", "Santo Antônio do Amparo", "", "BR", "76", "", "15", "3159902", "", "-20.94639", "-44.91889", "America/Sao_Paulo"),("3449518", "Santo Antônio de Posse", "", "BR", "76", "", "27", "3548005", "", "-22.60611", "-46.91944", "America/Sao_Paulo"),("3449519", "Santo Antônio de Pádua", "", "BR", "76", "", "21", "3304706", "", "-21.53944", "-42.18028", "America/Sao_Paulo"),("3449521", "Santo Antônio de Jesus", "", "BR", "76", "", "05", "2928703", "", "-12.96889", "-39.26139", "America/Bahia"),("3449529", "Santo Antônio da Platina", "Санту-Антониу-да-Платина", "BR", "76", "", "18", "4124103", "", "-23.295", "-50.07722", "America/Sao_Paulo"),("3449696", "Santo Ângelo", "Санту-Анджело", "BR", "76", "", "23", "4317509", "", "-28.29917", "-54.26306", "America/Sao_Paulo"),("3449701", "Santo André", "Санту-Андре", "BR", "76", "", "27", "3547809", "", "-23.66389", "-46.53833", "America/Sao_Paulo"),("3449707", "Santo Anastácio", "", "BR", "76", "", "27", "3543238", "", "-21.83833", "-51.61028", "America/Sao_Paulo"),("3449710", "Santo Amaro das Brotas", "", "BR", "76", "", "28", "2806602", "", "-10.78889", "-37.05444", "America/Maceio"),("3449711", "Santo Amaro da Imperatriz", "", "BR", "76", "", "26", "4215703", "", "-27.68806", "-48.77861", "America/Sao_Paulo"),("3449720", "Santo Amaro", "", "BR", "76", "", "05", "2928604", "", "-12.54667", "-38.71194", "America/Bahia"),("3449741", "Santiago", "Сантьяго", "BR", "76", "", "23", "4317400", "", "-29.19167", "-54.86722", "America/Sao_Paulo"),("3449747", "Santa Vitória do Palmar", "", "BR", "76", "", "23", "4317301", "", "-33.51889", "-53.36806", "America/Sao_Paulo"),("3449749", "Santa Vitória", "", "BR", "76", "", "15", "3159803", "", "-18.83861", "-50.12139", "America/Sao_Paulo"),("3449782", "Santa Teresa", "", "BR", "76", "", "08", "3204609", "", "-19.93556", "-40.60028", "America/Sao_Paulo"),("3449793", "Santa Rosa de Viterbo", "", "BR", "76", "", "27", "3547601", "", "-21.47278", "-47.36306", "America/Sao_Paulo"),("3449822", "Santa Rosa", "", "BR", "76", "", "23", "4317202", "", "-27.87083", "-54.48139", "America/Sao_Paulo"),("3449847", "Santa Rita do Sapucaí", "Санта-Рита-ду-Сапукайя", "BR", "76", "", "15", "3159605", "", "-22.25222", "-45.70333", "America/Sao_Paulo"),("3449851", "Santa Rita do Passa Quatro", "", "BR", "76", "", "27", "3547502", "", "-21.71028", "-47.47806", "America/Sao_Paulo"),("3449933", "Santana do Paraíso", "Сантана-ду-Параисо", "BR", "76", "", "15", "3158953", "", "-19.36361", "-42.56861", "America/Sao_Paulo"),("3449936", "Santana do Livramento", "Сантана-ду-Ливраменту", "BR", "76", "", "23", "4317103", "", "-30.89083", "-55.53278", "America/Sao_Paulo"),("3449948", "Santana de Parnaíba", "", "BR", "76", "", "27", "3547304", "", "-23.44417", "-46.91778", "America/Sao_Paulo"),("3450031", "Santana", "", "BR", "76", "", "05", "2920304", "", "-14.46667", "-41.8", "America/Bahia"),("3450057", "Santa Maria do Suaçuí", "", "BR", "76", "", "15", "3158201", "", "-18.19028", "-42.41417", "America/Sao_Paulo"),("3450063", "Santa Maria da Vitória", "Санта-Мария-да-Витория", "BR", "76", "", "05", "2928109", "", "-13.38814", "-44.19868", "America/Bahia"),("3450083", "Santa Maria", "Санта-Мария", "BR", "76", "", "23", "4316907", "", "-29.68417", "-53.80694", "America/Sao_Paulo"),("3450144", "Santa Luzia", "Санта-Лусия", "BR", "76", "", "15", "3157807", "", "-19.76972", "-43.85139", "America/Sao_Paulo"),("3450157", "Santaluz", "", "BR", "76", "", "05", "2928000", "", "-11.25583", "-39.37472", "America/Bahia"),("3450188", "Santa Isabel", "", "BR", "76", "", "27", "3546801", "", "-23.31556", "-46.22139", "America/Sao_Paulo"),("3450202", "Santa Inês", "", "BR", "76", "", "05", "2927903", "", "-13.29222", "-39.81889", "America/Bahia"),("3450206", "Santa Helena de Goiás", "Санта-Элена-ди-Гояс", "BR", "76", "", "29", "5219308", "", "-17.81361", "-50.59694", "America/Sao_Paulo"),("3450225", "Santa Gertrudes", "", "BR", "76", "", "27", "3546702", "", "-22.45667", "-47.53028", "America/Sao_Paulo"),("3450232", "Santa Fé do Sul", "", "BR", "76", "", "27", "3546603", "", "-20.21111", "-50.92583", "America/Sao_Paulo"),("3450269", "Santa Cruz do Sul", "Санта-Крус-ду-Сул", "BR", "76", "", "23", "4316808", "", "-29.7175", "-52.42583", "America/Sao_Paulo"),("3450272", "Santa Cruz do Rio Pardo", "", "BR", "76", "", "27", "3546405", "", "-22.89889", "-49.6325", "America/Sao_Paulo"),("3450283", "Santa Cruz das Palmeiras", "", "BR", "76", "", "27", "3546306", "", "-21.82694", "-47.24861", "America/Sao_Paulo"),("3450288", "Santa Cruz Cabrália", "", "BR", "76", "", "05", "2927705", "", "-16.27806", "-39.02472", "America/Bahia"),("3450376", "Santa Cecília", "", "BR", "76", "", "26", "4215505", "", "-26.96083", "-50.42694", "America/Sao_Paulo"),("3450400", "Santa Branca", "", "BR", "76", "", "27", "3546009", "", "-23.39667", "-45.88389", "America/Sao_Paulo"),("3450404", "Santa Bárbara d'Oeste", "", "BR", "76", "BR", "27", "3545803", "", "-22.75361", "-47.41361", "America/Sao_Paulo"),("3450464", "Santa Adélia", "", "BR", "76", "", "27", "3545605", "", "-21.24278", "-48.80417", "America/Sao_Paulo"),("3450496", "Sananduva", "", "BR", "76", "", "23", "4316600", "", "-27.94972", "-51.80667", "America/Sao_Paulo"),("3450554", "Salvador", "Салвадор", "BR", "76", "", "05", "2927408", "", "-12.97111", "-38.51083", "America/Bahia"),("3450563", "Salto de Pirapora", "", "BR", "76", "", "27", "3545308", "", "-23.64889", "-47.57333", "America/Sao_Paulo"),("3450594", "Salto", "Сальто", "BR", "76", "", "27", "3545209", "", "-23.20083", "-47.28694", "America/Sao_Paulo"),("3450671", "Salinas", "", "BR", "76", "", "15", "3157005", "", "-16.17028", "-42.29028", "America/Sao_Paulo"),("3450710", "Salgado", "", "BR", "76", "", "28", "2806206", "", "-11.03194", "-37.475", "America/Maceio"),("3450759", "Sacramento", "", "BR", "76", "", "15", "3156908", "", "-19.86528", "-47.44", "America/Sao_Paulo"),("3450806", "Sabinópolis", "", "BR", "76", "", "15", "3156809", "", "-18.66611", "-43.08389", "America/Sao_Paulo"),("3450832", "Ruy Barbosa", "", "BR", "76", "", "05", "2927200", "", "-12.28389", "-40.49389", "America/Bahia"),("3450843", "Rubiataba", "", "BR", "76", "", "29", "5218904", "", "-15.16444", "-49.80333", "America/Sao_Paulo"),("3450872", "Rosário Oeste", "", "BR", "76", "", "14", "5107701", "", "-14.83611", "-56.4275", "America/Cuiaba"),("3450873", "Rosário do Sul", "Росарио-ду-Сул", "BR", "76", "", "23", "4316402", "", "-30.25833", "-54.91417", "America/Sao_Paulo"),("3450909", "Rondonópolis", "", "BR", "76", "", "14", "5107602", "", "-16.47083", "-54.63556", "America/Cuiaba"),("3450963", "Rolante", "", "BR", "76", "", "23", "4316006", "", "-29.65056", "-50.57583", "America/Sao_Paulo"),("3450964", "Rolândia", "", "BR", "76", "", "18", "4122404", "", "-23.30972", "-51.36917", "America/Sao_Paulo"),("3451051", "Rio Verde de Mato Grosso", "", "BR", "76", "", "11", "5007406", "", "-18.91806", "-54.84417", "America/Campo_Grande"),("3451071", "Rio Real", "", "BR", "76", "", "05", "2927002", "", "-11.48472", "-37.93278", "America/Bahia"),("3451094", "Rio Pomba", "", "BR", "76", "", "15", "3155801", "", "-21.27472", "-43.17917", "America/Sao_Paulo"),("3451095", "Rio Piracicaba", "", "BR", "76", "", "15", "3155702", "", "-19.92917", "-43.17417", "America/Sao_Paulo"),("3451100", "Rio Pardo de Minas", "", "BR", "76", "", "15", "3155603", "", "-15.60972", "-42.53972", "America/Sao_Paulo"),("3451102", "Rio Pardo", "Рио-Пардо", "BR", "76", "", "23", "4315701", "", "-29.98972", "-52.37806", "America/Sao_Paulo"),("3451107", "Rio Novo do Sul", "", "BR", "76", "", "08", "3204401", "", "-20.8625", "-40.93639", "America/Sao_Paulo"),("3451114", "Rio Novo", "", "BR", "76", "", "15", "3155405", "", "-21.47703", "-43.12589", "America/Sao_Paulo"),("3451121", "Rio Negro", "", "BR", "76", "", "18", "4122305", "", "-26.10583", "-49.7975", "America/Sao_Paulo"),("3451124", "Rio Negrinho", "", "BR", "76", "", "26", "4215000", "", "-26.25444", "-49.51833", "America/Sao_Paulo"),("3451131", "Riolândia", "", "BR", "76", "", "27", "3544202", "", "-19.98083", "-49.68194", "America/Sao_Paulo"),("3451134", "Rio Grande da Serra", "", "BR", "76", "", "27", "3544103", "", "-23.74417", "-46.39833", "America/Sao_Paulo"),("3451138", "Rio Grande", "Рио-Гранде", "BR", "76", "", "23", "4315602", "", "-32.035", "-52.09861", "America/Sao_Paulo"),("3451152", "Rio do Sul", "Риу-ду-Сул", "BR", "76", "", "26", "4214805", "", "-27.21417", "-49.64306", "America/Sao_Paulo"),("3451190", "Rio de Janeiro", "Рио-де-Жанейро", "BR", "76", "", "21", "3304557", "", "-22.90278", "-43.2075", "America/Sao_Paulo"),("3451202", "Rio das Pedras", "", "BR", "76", "", "27", "3544004", "", "-22.84333", "-47.60611", "America/Sao_Paulo"),("3451205", "Rio das Ostras", "", "BR", "76", "", "21", "3304524", "", "-22.52694", "-41.945", "America/Sao_Paulo"),("3451232", "Rio Claro", "", "BR", "76", "", "21", "3304409", "", "-22.72306", "-44.13556", "America/Sao_Paulo"),("3451234", "Rio Claro", "", "BR", "76", "", "27", "3543907", "", "-22.41139", "-47.56139", "America/Sao_Paulo"),("3451236", "Rio Casca", "", "BR", "76", "", "15", "3154903", "", "-20.22611", "-42.65083", "America/Sao_Paulo"),("3451241", "Rio Brilhante", "", "BR", "76", "", "11", "5007208", "", "-21.80194", "-54.54639", "America/Campo_Grande"),("3451242", "Rio Branco do Sul", "Риу-Бранку-ду-Сул", "BR", "76", "", "18", "4122206", "", "-25.19", "-49.31417", "America/Sao_Paulo"),("3451261", "Rio Bonito", "", "BR", "76", "", "21", "3304300", "", "-22.70861", "-42.60972", "America/Sao_Paulo"),("3451305", "Ribeirópolis", "", "BR", "76", "", "28", "2806008", "", "-10.53944", "-37.41667", "America/Maceio"),("3451328", "Ribeirão Preto", "Рибейран-Прету", "BR", "76", "", "27", "3543402", "", "-21.1775", "-47.81028", "America/Sao_Paulo"),("3451329", "Ribeirão Pires", "", "BR", "76", "", "27", "3543303", "", "-23.71056", "-46.41333", "America/Sao_Paulo"),("3451353", "Ribeirão das Neves", "", "BR", "76", "", "15", "3154606", "", "-19.76694", "-44.08667", "America/Sao_Paulo"),("3451357", "Ribeirão da Ilha", "", "BR", "76", "BR", "26", "4205407", "", "-27.69934", "-48.53219", "America/Sao_Paulo"),("3451362", "Ribeirão Branco", "", "BR", "76", "", "27", "3543006", "", "-24.22083", "-48.76556", "America/Sao_Paulo"),("3451363", "Ribeirão Bonito", "", "BR", "76", "", "27", "3542909", "", "-22.06667", "-48.17611", "America/Sao_Paulo"),("3451383", "Ribeira do Pombal", "", "BR", "76", "", "05", "2926608", "", "-10.83444", "-38.53583", "America/Bahia"),("3451399", "Ribas do Rio Pardo", "", "BR", "76", "", "11", "5007109", "", "-20.44306", "-53.75917", "America/Campo_Grande"),("3451403", "Rialma", "", "BR", "76", "", "29", "5218607", "", "-15.315", "-49.58444", "America/Sao_Paulo"),("3451448", "Riacho de Santana", "", "BR", "76", "", "05", "2926400", "", "-13.60917", "-42.93889", "America/Bahia"),("3451474", "Riachão do Jacuípe", "", "BR", "76", "", "05", "2926301", "", "-11.80694", "-39.38556", "America/Bahia"),("3451478", "Riachão das Neves", "", "BR", "76", "", "05", "2926202", "", "-11.74611", "-44.91", "America/Bahia"),("3451650", "Resplendor", "", "BR", "76", "", "15", "3154309", "", "-19.32556", "-41.25528", "America/Sao_Paulo"),("3451663", "Reserva", "", "BR", "76", "", "18", "4121703", "", "-24.65028", "-50.85056", "America/Sao_Paulo"),("3451668", "Resende", "Резенди", "BR", "76", "", "21", "3304201", "", "-22.46889", "-44.44667", "America/Sao_Paulo"),("3451704", "Registro", "", "BR", "76", "", "27", "3542602", "", "-24.4875", "-47.84361", "America/Sao_Paulo"),("3451709", "Regente Feijó", "", "BR", "76", "", "27", "3542404", "", "-22.22139", "-51.30278", "America/Sao_Paulo"),("3451750", "Recreio", "", "BR", "76", "", "15", "3154101", "", "-21.525", "-42.46917", "America/Sao_Paulo"),("3451783", "Realeza", "", "BR", "76", "", "18", "4121406", "", "-25.76889", "-53.5325", "America/Sao_Paulo"),("3451812", "Raposos", "", "BR", "76", "", "15", "3153905", "", "-19.96722", "-43.80417", "America/Sao_Paulo"),("3451856", "Rancharia", "", "BR", "76", "", "27", "3542206", "", "-22.22917", "-50.89306", "America/Sao_Paulo"),("3451931", "Quirinópolis", "", "BR", "76", "", "29", "5218508", "", "-18.44833", "-50.45167", "America/Sao_Paulo"),("3452073", "Queimados", "", "BR", "76", "", "21", "3304144", "", "-22.71611", "-43.55528", "America/Sao_Paulo"),("3452085", "Queimadas", "", "BR", "76", "", "05", "2925808", "", "-10.97833", "-39.62639", "America/Bahia"),("3452141", "Quatro Barras", "", "BR", "76", "", "18", "4120804", "", "-25.36556", "-49.07694", "America/Sao_Paulo"),("3452148", "Quatis", "", "BR", "76", "", "21", "3304128", "", "-22.40722", "-44.25806", "America/Sao_Paulo"),("3452167", "Quatá", "", "BR", "76", "", "27", "3541703", "", "-22.2475", "-50.69833", "America/Sao_Paulo"),("3452179", "Quaraí", "Куараи", "BR", "76", "", "23", "4315305", "", "-30.3875", "-56.45139", "America/Sao_Paulo"),("3452216", "Prudentópolis", "", "BR", "76", "", "18", "4120606", "", "-25.21306", "-50.97778", "America/Sao_Paulo"),("3452233", "Propriá", "", "BR", "76", "", "28", "2805703", "", "-10.21111", "-36.84028", "America/Maceio"),("3452237", "Promissão", "", "BR", "76", "", "27", "3541604", "", "-21.53667", "-49.85806", "America/Sao_Paulo"),("3452320", "Presidente Venceslau", "", "BR", "76", "", "27", "3541505", "", "-21.87611", "-51.84389", "America/Sao_Paulo"),("3452324", "Presidente Prudente", "Президенти-Пруденти", "BR", "76", "", "27", "3541406", "", "-22.12556", "-51.38889", "America/Sao_Paulo"),("3452327", "Presidente Olegário", "", "BR", "76", "", "15", "3153400", "", "-18.41778", "-46.41806", "America/Sao_Paulo"),("3452331", "Presidente Epitácio", "", "BR", "76", "", "27", "3541307", "", "-21.76333", "-52.11556", "America/Sao_Paulo"),("3452335", "Presidente Bernardes", "", "BR", "76", "", "27", "3541208", "", "-22.00611", "-51.55306", "America/Sao_Paulo"),("3452440", "Prata", "", "BR", "76", "", "15", "3152808", "", "-19.30722", "-48.92417", "America/Sao_Paulo"),("3452465", "Praia Grande", "Прайя-Гранди", "BR", "76", "", "27", "3541000", "", "-24.00583", "-46.40278", "America/Sao_Paulo"),("3452478", "Pradópolis", "", "BR", "76", "", "27", "3540903", "", "-21.35944", "-48.06556", "America/Sao_Paulo"),("3452483", "Prado", "", "BR", "76", "", "05", "2925501", "", "-17.34111", "-39.22083", "America/Bahia"),("3452490", "Poxoréo", "", "BR", "76", "", "14", "5107008", "", "-15.83722", "-54.38917", "America/Cuiaba"),("3452525", "Pouso Alegre", "Позу-Алегри", "BR", "76", "", "15", "3152501", "", "-22.23", "-45.93639", "America/Sao_Paulo"),("3452599", "Posse", "", "BR", "76", "", "29", "5218300", "", "-14.09306", "-46.36944", "America/Sao_Paulo"),("3452623", "Porto União", "", "BR", "76", "", "26", "4213609", "", "-26.23806", "-51.07833", "America/Sao_Paulo"),("3452640", "Porto Seguro", "Порту-Сегуру", "BR", "76", "", "05", "2925303", "", "-16.44972", "-39.06472", "America/Bahia"),("3452671", "Porto Real do Colégio", "", "BR", "76", "", "02", "2707503", "", "-10.18583", "-36.84", "America/Maceio"),("3452672", "Porto Real", "", "BR", "76", "", "21", "3304110", "", "-22.41972", "-44.29028", "America/Sao_Paulo"),("3452712", "Porto Murtinho", "", "BR", "76", "", "11", "5006903", "", "-21.69889", "-57.8825", "America/Campo_Grande"),("3452775", "Porto Ferreira", "Порту-Феррейра", "BR", "76", "", "27", "3540705", "", "-21.85389", "-47.47917", "America/Sao_Paulo"),("3452779", "Porto Feliz", "Порту-Фелис", "BR", "76", "", "27", "3540606", "", "-23.21472", "-47.52389", "America/Sao_Paulo"),("3452900", "Porto Belo", "", "BR", "76", "", "26", "4213500", "", "-27.15778", "-48.55306", "America/Sao_Paulo"),("3452909", "Pôrto Barra do Ivinheima", "", "BR", "76", "", "11", "5005707", "", "-22.96667", "-53.66667", "America/Campo_Grande"),("3452925", "Porto Alegre", "Порту-Алегри", "BR", "76", "", "23", "4314902", "", "-30.03306", "-51.23", "America/Sao_Paulo"),("3452956", "Porteirinha", "", "BR", "76", "", "15", "3152204", "", "-15.74333", "-43.02833", "America/Sao_Paulo"),("3452982", "Portão", "", "BR", "76", "", "23", "4314803", "", "-29.70167", "-51.24194", "America/Sao_Paulo"),("3452992", "Porecatu", "", "BR", "76", "", "18", "4120002", "", "-22.75583", "-51.37917", "America/Sao_Paulo"),("3453010", "Porciúncula", "", "BR", "76", "", "21", "3304102", "", "-20.96278", "-42.04083", "America/Sao_Paulo"),("3453014", "Porangatu", "Порангату", "BR", "76", "", "29", "5218003", "", "-13.44083", "-49.14861", "America/Sao_Paulo"),("3453025", "Ponto Novo", "", "BR", "76", "", "05", "2925253", "", "-10.86278", "-40.13361", "America/Bahia"),("3453060", "Pontes e Lacerda", "", "BR", "76", "", "14", "5106752", "", "-15.22611", "-59.33528", "America/Cuiaba"),("3453078", "Ponte Nova", "", "BR", "76", "", "15", "3152105", "", "-20.41639", "-42.90861", "America/Sao_Paulo"),("3453150", "Ponta Porã", "Понта-Поран", "BR", "76", "", "11", "5006606", "", "-22.53611", "-55.72556", "America/Campo_Grande"),("3453158", "Pontalina", "", "BR", "76", "", "29", "5217708", "", "-17.525", "-49.44722", "America/Sao_Paulo"),("3453171", "Pontal", "", "BR", "76", "", "27", "3540200", "", "-21.0225", "-48.03722", "America/Sao_Paulo"),("3453186", "Ponta Grossa", "Понта-Гроса", "BR", "76", "", "18", "4119905", "", "-25.095", "-50.16194", "America/Sao_Paulo"),("3453240", "Pompéu", "", "BR", "76", "", "15", "3152006", "", "-19.22444", "-44.93528", "America/Sao_Paulo"),("3453242", "Pompéia", "", "BR", "76", "", "27", "3540002", "", "-22.10861", "-50.17167", "America/Sao_Paulo"),("3453245", "Pomerode", "", "BR", "76", "", "26", "4213203", "", "-26.74056", "-49.17694", "America/Sao_Paulo"),("3453300", "Poço Verde", "", "BR", "76", "", "28", "2805505", "", "-10.70833", "-38.18333", "America/Bahia"),("3453303", "Poços de Caldas", "Посус-ди-Калдас", "BR", "76", "", "15", "3151800", "", "-21.78778", "-46.56139", "America/Sao_Paulo"),("3453315", "Poconé", "", "BR", "76", "", "14", "5106505", "", "-16.25667", "-56.62278", "America/Cuiaba"),("3453337", "Poções", "", "BR", "76", "", "05", "2925105", "", "-14.52972", "-40.36528", "America/Bahia"),("3453406", "Poá", "", "BR", "76", "", "27", "3539806", "", "-23.52806", "-46.34472", "America/Sao_Paulo"),("3453420", "Planaltina", "", "BR", "76", "", "29", "5217609", "", "-15.45278", "-47.61417", "America/Sao_Paulo"),("3453435", "Piúma", "", "BR", "76", "", "08", "3204203", "", "-20.83778", "-40.72194", "America/Sao_Paulo"),("3453439", "Piuí", "", "BR", "76", "", "15", "3151503", "", "-20.46528", "-45.95806", "America/Sao_Paulo"),("3453457", "Pitangui", "", "BR", "76", "", "15", "3151404", "", "-19.68278", "-44.89028", "America/Sao_Paulo"),("3453467", "Pitangueiras", "", "BR", "76", "", "27", "3539509", "", "-21.00944", "-48.22167", "America/Sao_Paulo"),("3453478", "Pitanga", "", "BR", "76", "", "18", "4119608", "", "-24.75722", "-51.76139", "America/Sao_Paulo"),("3453494", "Piritiba", "", "BR", "76", "", "05", "2924801", "", "-11.73028", "-40.55528", "America/Bahia"),("3453503", "Pires do Rio", "Пирес-ду-Риу", "BR", "76", "", "29", "5217401", "", "-17.29972", "-48.27944", "America/Sao_Paulo"),("3453512", "Pirenópolis", "", "BR", "76", "", "29", "5217302", "", "-15.85072", "-48.96087", "America/Sao_Paulo"),("3453535", "Piraquara", "", "BR", "76", "", "18", "4119509", "", "-25.44227", "-49.06795", "America/Sao_Paulo"),("3453542", "Pirapozinho", "", "BR", "76", "", "27", "3539202", "", "-22.27528", "-51.5", "America/Sao_Paulo"),("3453544", "Pirapora do Bom Jesus", "", "BR", "76", "", "27", "3539103", "", "-23.39694", "-47.00222", "America/Sao_Paulo"),("3453546", "Pirapora", "", "BR", "76", "", "15", "3151206", "", "-17.345", "-44.94194", "America/Sao_Paulo"),("3453586", "Piranhas", "", "BR", "76", "", "29", "5217203", "", "-16.42694", "-51.82222", "America/Sao_Paulo"),("3453605", "Pirajuí", "", "BR", "76", "", "27", "3538907", "", "-21.99861", "-49.45722", "America/Sao_Paulo"),("3453610", "Piraju", "", "BR", "76", "", "27", "3538808", "", "-23.19361", "-49.38389", "America/Sao_Paulo"),("3453622", "Piraí do Sul", "", "BR", "76", "", "18", "4119400", "", "-24.52611", "-49.94861", "America/Sao_Paulo"),("3453635", "Piraí", "", "BR", "76", "", "21", "3304003", "", "-22.62917", "-43.89806", "America/Sao_Paulo"),("3453639", "Pirassununga", "Пирасунунга", "BR", "76", "", "27", "3539301", "", "-21.99611", "-47.42583", "America/Sao_Paulo"),("3453643", "Piracicaba", "Пирасикаба", "BR", "76", "", "27", "3538709", "", "-22.72528", "-47.64917", "America/Sao_Paulo"),("3453659", "Piracanjuba", "", "BR", "76", "", "29", "5217104", "", "-17.30278", "-49.01667", "America/Sao_Paulo"),("3453661", "Piracaia", "", "BR", "76", "", "27", "3538600", "", "-23.05389", "-46.35806", "America/Sao_Paulo"),("3453682", "Piquete", "", "BR", "76", "", "27", "3538501", "", "-22.61361", "-45.17611", "America/Sao_Paulo"),("3453741", "Pinheiro Machado", "", "BR", "76", "", "23", "4314506", "", "-31.57833", "-53.38111", "America/Sao_Paulo"),("3453767", "Pinheiral", "", "BR", "76", "", "21", "3303955", "", "-22.51278", "-44.00056", "America/Sao_Paulo"),("3453777", "Pinhão", "", "BR", "76", "", "18", "4119301", "", "-25.69556", "-51.65972", "America/Sao_Paulo"),("3453807", "Espírito Santo do Pinhal", "", "BR", "76", "", "27", "3548104", "", "-22.11583", "-46.68278", "America/Sao_Paulo"),("3453821", "Pindorama", "", "BR", "76", "", "27", "3538105", "", "-21.18583", "-48.90722", "America/Sao_Paulo"),("3453827", "Pindobaçu", "", "BR", "76", "", "05", "2924603", "", "-10.74167", "-40.36083", "America/Bahia"),("3453837", "Pindamonhangaba", "Пиндамоньянгаба", "BR", "76", "", "27", "3538006", "", "-22.92389", "-45.46167", "America/Sao_Paulo"),("3453896", "Pilar do Sul", "", "BR", "76", "", "27", "3537909", "", "-23.81306", "-47.71639", "America/Sao_Paulo"),("3453926", "Piedade", "", "BR", "76", "", "27", "3537800", "", "-23.71194", "-47.42778", "America/Sao_Paulo"),("3454005", "Piaçabuçu", "", "BR", "76", "", "02", "2706802", "", "-10.40556", "-36.43444", "America/Maceio"),("3454031", "Petrópolis", "Петрополис", "BR", "76", "", "21", "3303906", "", "-22.505", "-43.17861", "America/Sao_Paulo"),("3454032", "Petrolina de Goiás", "", "BR", "76", "", "29", "5216809", "", "-16.095", "-49.33806", "America/Sao_Paulo"),("3454061", "Peruíbe", "Перуиби", "BR", "76", "", "27", "3537602", "", "-24.32", "-46.99833", "America/Sao_Paulo"),("3454131", "Pereira Barreto", "", "BR", "76", "", "27", "3537404", "", "-20.63833", "-51.10917", "America/Sao_Paulo"),("3454139", "Perdões", "", "BR", "76", "", "15", "3149903", "", "-21.09083", "-45.09139", "America/Sao_Paulo"),("3454213", "Penha", "Пенья", "BR", "76", "", "26", "4212502", "", "-26.76944", "-48.64583", "America/Sao_Paulo"),("3454231", "Penedo", "", "BR", "76", "", "02", "2706703", "", "-10.29028", "-36.58639", "America/Maceio"),("3454235", "Penápolis", "Пенаполис", "BR", "76", "", "27", "3537305", "", "-21.41972", "-50.0775", "America/Sao_Paulo"),("3454244", "Pelotas", "Пелотас", "BR", "76", "", "23", "4314407", "", "-31.77194", "-52.3425", "America/Sao_Paulo"),("3454358", "Pedro Leopoldo", "", "BR", "76", "", "15", "3149309", "", "-19.61806", "-44.04306", "America/Sao_Paulo"),("3454407", "Pedreira", "Педрейра", "BR", "76", "", "27", "3537107", "", "-22.74194", "-46.90139", "America/Sao_Paulo"),("3454408", "Pedregulho", "", "BR", "76", "", "27", "3537008", "", "-20.25694", "-47.47667", "America/Sao_Paulo"),("3454578", "Pedra Azul", "", "BR", "76", "", "15", "3148707", "", "-16.00528", "-41.29722", "America/Sao_Paulo"),("3454620", "Pederneiras", "", "BR", "76", "", "27", "3536703", "", "-22.35167", "-48.775", "America/Sao_Paulo"),("3454628", "Peçanha", "", "BR", "76", "", "15", "3148608", "", "-18.54861", "-42.55694", "America/Sao_Paulo"),("3454632", "Peabiru", "", "BR", "76", "", "18", "4118808", "", "-23.91278", "-52.34306", "America/Sao_Paulo"),("3454690", "Paulínia", "Паулиния", "BR", "76", "", "27", "3536505", "", "-22.76111", "-47.15417", "America/Sao_Paulo"),("3454743", "Pau Brasil", "", "BR", "76", "", "05", "2923902", "", "-15.46417", "-39.65111", "America/Bahia"),("3454763", "Patrocínio", "Патросиниу", "BR", "76", "", "15", "3148103", "", "-18.94389", "-46.9925", "America/Sao_Paulo"),("3454783", "Patos de Minas", "Патус-ди-Минас", "BR", "76", "", "15", "3148004", "", "-18.57889", "-46.51806", "America/Sao_Paulo"),("3454818", "Pato Branco", "Пату-Бранку", "BR", "76", "", "18", "4118501", "", "-26.22861", "-52.67056", "America/Sao_Paulo"),("3454827", "Paty do Alferes", "Пати-ду-Алферис", "BR", "76", "", "21", "3303856", "", "-22.42861", "-43.41861", "America/Sao_Paulo"),("3454847", "Passos", "Пассос", "BR", "76", "", "15", "3147907", "", "-20.71889", "-46.60972", "America/Sao_Paulo"),("3454857", "Passo Fundo", "Пасу-Фунду", "BR", "76", "", "23", "4314100", "", "-28.26278", "-52.40667", "America/Sao_Paulo"),("3454901", "Passa Quatro", "", "BR", "76", "", "15", "3147600", "", "-22.39028", "-44.96667", "America/Sao_Paulo"),("3454954", "Parobé", "", "BR", "76", "", "23", "4314050", "", "-29.62861", "-50.83472", "America/Sao_Paulo"),("3454967", "Pariquera Açu", "", "BR", "76", "", "27", "3536208", "", "-24.715", "-47.88111", "America/Sao_Paulo"),("3454968", "Paripiranga", "", "BR", "76", "", "05", "2923803", "", "-10.6875", "-37.86167", "America/Bahia"),("3455020", "Paraúna", "", "BR", "76", "", "29", "5216403", "", "-16.94778", "-50.44861", "America/Sao_Paulo"),("3455029", "Paratinga", "", "BR", "76", "", "05", "2923704", "", "-12.69056", "-43.18417", "America/Bahia"),("3455036", "Paraty", "", "BR", "76", "", "21", "3303807", "", "-23.21778", "-44.71306", "America/Sao_Paulo"),("3455049", "Paranhos", "", "BR", "76", "", "11", "5006358", "", "-23.89278", "-55.43111", "America/Campo_Grande"),("3455051", "Paranavaí", "", "BR", "76", "", "18", "4118402", "", "-23.07306", "-52.46528", "America/Sao_Paulo"),("3455061", "Paranapanema", "", "BR", "76", "", "27", "3535804", "", "-23.3863", "-48.72441", "America/Sao_Paulo"),("3455065", "Paranaíba", "Паранаиба", "BR", "76", "", "11", "5006309", "", "-19.67722", "-51.19083", "America/Campo_Grande"),("3455070", "Paranaguá", "Паранагуа", "BR", "76", "", "18", "4118204", "", "-25.51626", "-48.52537", "America/Sao_Paulo"),("3455082", "Paramirim", "", "BR", "76", "", "05", "2923605", "", "-13.4425", "-42.23889", "America/Bahia"),("3455089", "Paraisópolis", "", "BR", "76", "", "15", "3147303", "", "-22.55417", "-45.78", "America/Sao_Paulo"),("3455141", "Paraíba do Sul", "Параиба-ду-Сул", "BR", "76", "", "21", "3303708", "", "-22.15847", "-43.29321", "America/Sao_Paulo"),("3455152", "Paraguaçu Paulista", "", "BR", "76", "", "27", "3535507", "", "-22.41278", "-50.57583", "America/Sao_Paulo"),("3455155", "Paraguaçu", "", "BR", "76", "", "15", "3147204", "", "-21.54722", "-45.7375", "America/Sao_Paulo"),("3455161", "Pará de Minas", "Пара-ди-Минас", "BR", "76", "", "15", "3147105", "", "-19.86028", "-44.60833", "America/Sao_Paulo"),("3455168", "Paracatu", "Паракату", "BR", "76", "", "15", "3147006", "", "-17.22222", "-46.87472", "America/Sao_Paulo"),("3455170", "Paracambi", "", "BR", "76", "", "21", "3303609", "", "-22.60829", "-43.7084", "America/Sao_Paulo"),("3455195", "Papagaios", "", "BR", "76", "", "15", "3146909", "", "-19.44917", "-44.74778", "America/Sao_Paulo"),("3455251", "Panorama", "", "BR", "76", "", "27", "3535408", "", "-21.35639", "-51.85972", "America/Sao_Paulo"),("3455277", "Pancas", "", "BR", "76", "", "08", "3204005", "", "-19.225", "-40.85139", "America/Sao_Paulo"),("3455281", "Panambi", "", "BR", "76", "", "23", "4313904", "", "-28.2925", "-53.50167", "America/Sao_Paulo"),("3455298", "Palotina", "", "BR", "76", "", "18", "4117909", "", "-24.28389", "-53.84", "America/Sao_Paulo"),("3455342", "Palmital", "", "BR", "76", "", "27", "3535309", "", "-22.78889", "-50.2175", "America/Sao_Paulo"),("3455362", "Palmeiras de Goiás", "", "BR", "76", "", "29", "5215702", "", "-16.805", "-49.92583", "America/Sao_Paulo"),("3455416", "Palmeira das Missões", "", "BR", "76", "", "23", "4313706", "", "-27.89944", "-53.31361", "America/Sao_Paulo"),("3455425", "Palmeira", "", "BR", "76", "", "18", "4117701", "", "-25.42944", "-50.00639", "America/Sao_Paulo"),("3455447", "Palmas de Monte Alto", "", "BR", "76", "", "05", "2923407", "", "-14.26722", "-43.16194", "America/Bahia"),("3455459", "Palmas", "Пальмас", "BR", "76", "", "18", "4117602", "", "-26.48417", "-51.99056", "America/Sao_Paulo"),("3455461", "Palmares do Sul", "", "BR", "76", "", "23", "4313656", "", "-30.25778", "-50.50972", "America/Sao_Paulo"),("3455478", "Palhoça", "Пальоса", "BR", "76", "", "26", "4211900", "", "-27.64528", "-48.66778", "America/Sao_Paulo"),("3455553", "Paiçandu", "", "BR", "76", "", "18", "4117503", "", "-23.4575", "-52.04861", "America/Sao_Paulo"),("3455568", "Padre Paraíso", "", "BR", "76", "", "15", "3146305", "", "-17.07417", "-41.48444", "America/Sao_Paulo"),("3455580", "Padre Bernardo", "", "BR", "76", "", "29", "5215603", "", "-15.16595", "-48.28281", "America/Sao_Paulo"),("3455643", "Pacaembu", "", "BR", "76", "", "27", "3534906", "", "-21.56222", "-51.26056", "America/Sao_Paulo"),("3455671", "Ouro Preto", "Ору-Прету", "BR", "76", "", "15", "3146107", "", "-20.39484", "-43.50517", "America/Sao_Paulo"),("3455689", "Ouro Branco", "", "BR", "76", "", "15", "3145901", "", "-20.52334", "-43.69486", "America/Sao_Paulo"),("3455729", "Ourinhos", "Ориньюс", "BR", "76", "", "27", "3534708", "", "-22.97889", "-49.87056", "America/Sao_Paulo"),("3455750", "Otacílio Costa", "", "BR", "76", "", "26", "4211751", "", "-27.48306", "-50.12194", "America/Sao_Paulo"),("3455756", "Osvaldo Cruz", "", "BR", "76", "", "27", "3534609", "", "-21.79667", "-50.87861", "America/Sao_Paulo"),("3455769", "Osório", "Осорио", "BR", "76", "", "23", "4313508", "", "-29.88667", "-50.26972", "America/Sao_Paulo"),("3455775", "Osasco", "Осаску", "BR", "76", "", "27", "3534401", "", "-23.5325", "-46.79167", "America/Sao_Paulo"),("3455777", "Ortigueira", "", "BR", "76", "", "18", "4117305", "", "-24.20833", "-50.94944", "America/Sao_Paulo"),("3455784", "Orleans", "", "BR", "76", "", "26", "4211702", "", "-28.35889", "-49.29139", "America/Sao_Paulo"),("3455785", "Orlândia", "", "BR", "76", "", "27", "3534302", "", "-20.72028", "-47.88667", "America/Sao_Paulo"),("3455786", "Orizona", "", "BR", "76", "", "29", "5215306", "", "-17.03139", "-48.29583", "America/Sao_Paulo"),("3455903", "Oliveira dos Brejinhos", "", "BR", "76", "", "05", "2923209", "", "-12.31694", "-42.89611", "America/Bahia"),("3455908", "Oliveira", "Оливейра", "BR", "76", "", "15", "3145604", "", "-20.69639", "-44.82722", "America/Sao_Paulo"),("3455913", "Olindina", "", "BR", "76", "", "05", "2923100", "", "-11.36667", "-38.33333", "America/Bahia"),("3455923", "Olímpia", "Олимпия", "BR", "76", "", "27", "3533908", "", "-20.73722", "-48.91472", "America/Sao_Paulo"),("3456037", "Nuporanga", "", "BR", "76", "", "27", "3533601", "", "-20.73095", "-47.75177", "America/Sao_Paulo"),("3456060", "Novo Horizonte", "", "BR", "76", "", "27", "3533502", "", "-21.46806", "-49.22083", "America/Sao_Paulo"),("3456068", "Novo Hamburgo", "Нову-Амбургу", "BR", "76", "", "23", "4313409", "", "-29.67833", "-51.13056", "America/Sao_Paulo"),("3456070", "Novo Cruzeiro", "", "BR", "76", "", "15", "3145307", "", "-17.46806", "-41.87528", "America/Sao_Paulo"),("3456102", "Nova Viçosa", "", "BR", "76", "", "05", "2923001", "", "-17.89194", "-39.37194", "America/Bahia"),("3456110", "Nova Venécia", "", "BR", "76", "", "08", "3203908", "", "-18.71056", "-40.40056", "America/Sao_Paulo"),("3456115", "Nova Soure", "", "BR", "76", "", "05", "2922904", "", "-11.23333", "-38.48333", "America/Bahia"),("3456125", "Nova Prata", "", "BR", "76", "", "23", "4313300", "", "-28.78389", "-51.61", "America/Sao_Paulo"),("3456127", "Nova Petrópolis", "", "BR", "76", "", "23", "4313201", "", "-29.37639", "-51.11444", "America/Sao_Paulo"),("3456137", "Nova Olímpia", "", "BR", "76", "", "14", "5106232", "", "-14.79722", "-57.28806", "America/Cuiaba"),("3456138", "Nova Odessa", "", "BR", "76", "", "27", "3533403", "", "-22.7775", "-47.29583", "America/Sao_Paulo"),("3456146", "Nova Londrina", "", "BR", "76", "", "18", "4117107", "", "-22.76583", "-52.985", "America/Sao_Paulo"),("3456147", "Nova Lima", "Нова-Лима", "BR", "76", "", "15", "3144805", "", "-19.98556", "-43.84667", "America/Sao_Paulo"),("3456160", "Nova Iguaçu", "Нова-Игуасу", "BR", "76", "", "21", "3303500", "", "-22.75917", "-43.45111", "America/Sao_Paulo"),("3456164", "Nova Granada", "", "BR", "76", "", "27", "3533007", "", "-20.53389", "-49.31417", "America/Sao_Paulo"),("3456166", "Nova Friburgo", "Нова-Фрибургу", "BR", "76", "", "21", "3303401", "", "-22.28194", "-42.53111", "America/Sao_Paulo"),("3456176", "Nova Era", "", "BR", "76", "", "15", "3144706", "", "-19.75", "-43.0375", "America/Sao_Paulo"),("3456196", "Nova Aurora", "", "BR", "76", "", "18", "4118402", "", "-22.86667", "-52.56667", "America/Sao_Paulo"),("3456223", "Nossa Senhora do Socorro", "", "BR", "76", "", "28", "2804805", "", "-10.855", "-37.12611", "America/Maceio"),("3456234", "Nossa Senhora das Dores", "", "BR", "76", "", "28", "2804607", "", "-10.49167", "-37.19333", "America/Maceio"),("3456240", "Nossa Senhora da Glória", "", "BR", "76", "", "28", "2804508", "", "-10.21833", "-37.42028", "America/Maceio"),("3456248", "Nortelândia", "", "BR", "76", "", "14", "5106000", "", "-14.45472", "-56.80278", "America/Cuiaba"),("3456277", "Nobres", "", "BR", "76", "", "14", "5105903", "", "-14.72028", "-56.3275", "America/Cuiaba"),("3456283", "Niterói", "Нитерой", "BR", "76", "", "21", "3303302", "", "-22.88333", "-43.10361", "America/Sao_Paulo"),("3456285", "Niquelândia", "Никеландия", "BR", "76", "", "29", "5214606", "", "-14.47389", "-48.45972", "America/Sao_Paulo"),("3456290", "Nilópolis", "", "BR", "76", "", "21", "3303203", "", "-22.8075", "-43.41389", "America/Sao_Paulo"),("3456309", "Nhandeara", "", "BR", "76", "", "27", "3532603", "", "-20.6897", "-50.0407", "America/Sao_Paulo"),("3456322", "Nerópolis", "Нерополис", "BR", "76", "", "29", "5214507", "", "-16.40639", "-49.21861", "America/Sao_Paulo"),("3456324", "Nepomuceno", "", "BR", "76", "", "15", "3144607", "", "-21.23342", "-45.23488", "America/Sao_Paulo"),("3456325", "Neópolis", "", "BR", "76", "", "28", "2804409", "", "-10.32", "-36.57944", "America/Maceio"),("3456366", "Nazaré", "Назар", "BR", "76", "", "05", "2922508", "", "-13.035", "-39.01444", "America/Bahia"),("3456368", "Naviraí", "Навираи", "BR", "76", "", "11", "5005707", "", "-23.065", "-54.19056", "America/Campo_Grande"),("3456370", "Navegantes", "Навегантис", "BR", "76", "", "26", "4211306", "", "-26.89889", "-48.65417", "America/Sao_Paulo"),("3456377", "Natividade", "", "BR", "76", "", "21", "3303104", "", "-21.04222", "-41.97333", "America/Sao_Paulo"),("3456397", "Não Me Toque", "", "BR", "76", "", "23", "4312658", "", "-28.45917", "-52.82083", "America/Sao_Paulo"),("3456398", "Nanuque", "", "BR", "76", "", "15", "3144300", "", "-17.83917", "-40.35389", "America/Sao_Paulo"),("3456412", "Muzambinho", "", "BR", "76", "", "15", "3144102", "", "-21.37583", "-46.52556", "America/Sao_Paulo"),("3456445", "Mutum", "", "BR", "76", "", "15", "3144003", "", "-19.8", "-41.43833", "America/Sao_Paulo"),("3456450", "Mutuípe", "", "BR", "76", "", "05", "2922409", "", "-13.22861", "-39.50472", "America/Bahia"),("3456483", "Muritiba", "", "BR", "76", "", "05", "2908309", "", "-12.91667", "-39.25", "America/Bahia"),("3456500", "Muriaé", "Муриаэ", "BR", "76", "", "15", "3143906", "", "-21.13056", "-42.36639", "America/Sao_Paulo"),("3456530", "Muniz Freire", "", "BR", "76", "", "08", "3203700", "", "-20.46417", "-41.41306", "America/Sao_Paulo"),("3456559", "Mundo Novo", "", "BR", "76", "", "05", "2922102", "", "-11.85889", "-40.4725", "America/Bahia"),("3456591", "Mucurici", "", "BR", "76", "", "08", "3203601", "", "-18.09333", "-40.51583", "America/Sao_Paulo"),("3456593", "Mucuri", "Мукури", "BR", "76", "", "05", "2922003", "", "-18.08639", "-39.55083", "America/Bahia"),("3456642", "Mozarlândia", "", "BR", "76", "", "29", "5214002", "", "-14.74472", "-50.57056", "America/Sao_Paulo"),("3456696", "Morro do Chapéu", "", "BR", "76", "", "05", "2921708", "", "-11.54852", "-41.15804", "America/Bahia"),("3456707", "Morro da Fumaça", "", "BR", "76", "", "26", "4211207", "", "-28.65083", "-49.21", "America/Sao_Paulo"),("3456724", "Morro Agudo", "", "BR", "76", "", "27", "3531902", "", "-20.73139", "-48.05778", "America/Sao_Paulo"),("3456735", "Morrinhos", "", "BR", "76", "", "29", "5213806", "", "-17.73111", "-49.09944", "America/Sao_Paulo"),("3456763", "Moreira Sales", "", "BR", "76", "", "18", "4116109", "", "-24.06222", "-53.00694", "America/Sao_Paulo"),("3456806", "Monte Sião", "", "BR", "76", "", "15", "3143401", "", "-22.4325", "-46.5725", "America/Sao_Paulo"),("3456814", "Montes Claros", "Монтис-Кларус", "BR", "76", "", "15", "3143302", "", "-16.735", "-43.86167", "America/Sao_Paulo"),("3456816", "Monte Santo de Minas", "", "BR", "76", "", "15", "3143203", "", "-21.18972", "-46.98028", "America/Sao_Paulo"),("3456820", "Monte Santo", "", "BR", "76", "", "05", "2921500", "", "-10.43778", "-39.33278", "America/Bahia"),("3456826", "Montenegro", "Черногория", "BR", "76", "", "23", "4312401", "", "-29.68861", "-51.46111", "America/Sao_Paulo"),("3456827", "Monte Mor", "", "BR", "76", "", "27", "3531803", "", "-22.94667", "-47.31583", "America/Sao_Paulo"),("3456848", "Monte Carmelo", "", "BR", "76", "", "15", "3143104", "", "-18.72472", "-47.49861", "America/Sao_Paulo"),("3456863", "Monte Azul Paulista", "", "BR", "76", "", "27", "3531506", "", "-20.90722", "-48.64139", "America/Sao_Paulo"),("3456864", "Monte Azul", "", "BR", "76", "", "15", "3142908", "", "-15.155", "-42.87472", "America/Sao_Paulo"),("3456866", "Monte Aprazível", "", "BR", "76", "", "27", "3531407", "", "-20.7725", "-49.71417", "America/Sao_Paulo"),("3456873", "Monte Alto", "", "BR", "76", "", "27", "3531308", "", "-21.26111", "-48.49639", "America/Sao_Paulo"),("3456879", "Monte Alegre de Sergipe", "", "BR", "76", "", "28", "2804201", "", "-10.02722", "-37.56222", "America/Maceio"),("3456880", "Monte Alegre de Minas", "", "BR", "76", "", "15", "3142809", "", "-18.87056", "-48.88083", "America/Sao_Paulo"),("3456905", "Montanha", "", "BR", "76", "", "08", "3203502", "", "-18.12694", "-40.36333", "America/Sao_Paulo"),("3456944", "Mongaguá", "", "BR", "76", "", "27", "3531100", "", "-24.09306", "-46.62083", "America/Sao_Paulo"),("3456998", "Mogi Mirim", "Можи-Мирин", "BR", "76", "", "27", "3530805", "", "-22.43194", "-46.95778", "America/Sao_Paulo"),("3457000", "Mogi Guaçu", "Можи-Гуасу", "BR", "76", "", "27", "3530706", "", "-22.3677", "-46.94552", "America/Sao_Paulo"),("3457001", "Mogi das Cruzes", "", "BR", "76", "", "27", "3530607", "", "-23.52278", "-46.18833", "America/Sao_Paulo"),("3457025", "Mococa", "", "BR", "76", "", "27", "3530508", "", "-21.46778", "-47.00472", "America/Sao_Paulo"),("3457098", "Mirante do Paranapanema", "", "BR", "76", "", "27", "3530201", "", "-22.29194", "-51.90639", "America/Sao_Paulo"),("3457107", "Mirandopólis", "Мирандополис", "BR", "76", "", "27", "3530102", "", "-21.13361", "-51.10167", "America/Sao_Paulo"),("3457113", "Miranda", "", "BR", "76", "", "11", "5005608", "", "-20.24056", "-56.37833", "America/Campo_Grande"),("3457119", "Miraí", "", "BR", "76", "", "15", "3142205", "", "-21.19528", "-42.61417", "America/Sao_Paulo"),("3457133", "Miracema", "Мирасема", "BR", "76", "", "21", "3303005", "", "-21.41222", "-42.19667", "America/Sao_Paulo"),("3457135", "Miracatu", "", "BR", "76", "", "27", "3529906", "", "-24.28139", "-47.45972", "America/Sao_Paulo"),("3457136", "Mirabela", "", "BR", "76", "", "15", "3142007", "", "-16.26278", "-44.16444", "America/Sao_Paulo"),("3457147", "Mineiros", "", "BR", "76", "", "29", "5213103", "", "-17.56944", "-52.55111", "America/Sao_Paulo"),("3457152", "Minas Novas", "", "BR", "76", "", "15", "3141801", "", "-17.21861", "-42.59028", "America/Sao_Paulo"),("3457161", "Mimoso do Sul", "", "BR", "76", "", "08", "3203403", "", "-21.06417", "-41.36639", "America/Sao_Paulo"),("3457191", "Miguel Pereira", "", "BR", "76", "", "21", "3302908", "", "-22.45389", "-43.46889", "America/Sao_Paulo"),("3457192", "Miguelópolis", "", "BR", "76", "", "27", "3529708", "", "-20.17944", "-48.03194", "America/Sao_Paulo"),("3457202", "Miguel Calmon", "", "BR", "76", "", "05", "2921203", "", "-11.42889", "-40.595", "America/Bahia"),("3457247", "Mendes", "", "BR", "76", "", "21", "3302809", "", "-22.52667", "-43.73278", "America/Sao_Paulo"),("3457358", "Medina", "", "BR", "76", "", "15", "3141405", "", "-16.2225", "-41.47694", "America/Sao_Paulo"),("3457359", "Medianeira", "Медианейра", "BR", "76", "", "18", "4115804", "", "-25.29528", "-54.09389", "America/Sao_Paulo"),("3457360", "Medeiros Neto", "", "BR", "76", "", "05", "2921104", "", "-17.37389", "-40.22056", "America/Bahia"),("3457381", "Mauá", "", "BR", "76", "", "27", "3529401", "", "-23.66778", "-46.46139", "America/Sao_Paulo"),("3457393", "Matozinhos", "", "BR", "76", "", "15", "3141108", "", "-19.55778", "-44.08139", "America/Sao_Paulo"),("3457398", "Mato Verde", "", "BR", "76", "", "15", "3141009", "", "-15.39722", "-42.86639", "America/Sao_Paulo"),("3457454", "Matipó", "", "BR", "76", "", "15", "3140902", "", "-20.28389", "-42.34111", "America/Sao_Paulo"),("3457479", "Matias Barbosa", "", "BR", "76", "", "15", "3140803", "", "-21.86917", "-43.31944", "America/Sao_Paulo"),("3457484", "Mateus Leme", "", "BR", "76", "", "15", "3140704", "", "-19.98639", "-44.42778", "America/Sao_Paulo"),("3457487", "Matelândia", "", "BR", "76", "", "18", "4115606", "", "-25.24083", "-53.99639", "America/Sao_Paulo"),("3457509", "Matão", "", "BR", "76", "", "27", "3529302", "", "-21.60333", "-48.36583", "America/Sao_Paulo"),("3457528", "Mata de São João", "Мата-де-Сан-Жуан", "BR", "76", "", "05", "2921005", "", "-12.53028", "-38.29917", "America/Bahia"),("3457566", "Mascote", "", "BR", "76", "", "05", "2920908", "", "-15.56306", "-39.3025", "America/Bahia"),("3457582", "Maruim", "", "BR", "76", "", "28", "2804003", "", "-10.7375", "-37.08167", "America/Maceio"),("3457595", "Martinópolis", "", "BR", "76", "", "27", "3529203", "", "-22.14583", "-51.17083", "America/Sao_Paulo"),("3457598", "Martinho Campos", "", "BR", "76", "", "15", "3140506", "", "-19.33167", "-45.23694", "America/Sao_Paulo"),("3457671", "Maringá", "Маринга", "BR", "76", "", "18", "4115200", "", "-23.42528", "-51.93861", "America/Sao_Paulo"),("3457692", "Marília", "Марилья", "BR", "76", "", "27", "3529005", "", "-22.21389", "-49.94583", "America/Sao_Paulo"),("3457708", "Maricá", "", "BR", "76", "", "21", "3302700", "", "-22.91944", "-42.81861", "America/Sao_Paulo"),("3457736", "Mariana", "Мариана", "BR", "76", "", "15", "3140001", "", "-20.37778", "-43.41611", "America/Sao_Paulo"),("3457741", "Marialva", "", "BR", "76", "", "18", "4114807", "", "-23.485", "-51.79167", "America/Sao_Paulo"),("3457770", "Marechal Floriano", "", "BR", "76", "", "08", "3203346", "", "-20.41278", "-40.68306", "America/Sao_Paulo"),("3457772", "Marechal Cândido Rondon", "", "BR", "76", "", "18", "4114609", "", "-24.55611", "-54.05667", "America/Sao_Paulo"),("3457776", "Mar de Espanha", "", "BR", "76", "", "15", "3139805", "", "-21.86722", "-43.00972", "America/Sao_Paulo"),("3457817", "Marau", "", "BR", "76", "", "23", "4311809", "", "-28.44917", "-52.2", "America/Sao_Paulo"),("3457819", "Marataizes", "", "BR", "76", "", "08", "3203320", "", "-21.04333", "-40.82444", "America/Sao_Paulo"),("3457850", "Maragogipe", "", "BR", "76", "", "05", "2920601", "", "-12.77778", "-38.91944", "America/Bahia"),("3457854", "Maracás", "", "BR", "76", "", "05", "2920502", "", "-13.44111", "-40.43083", "America/Bahia"),("3457859", "Maracaju", "", "BR", "76", "", "11", "5005400", "", "-21.61444", "-55.16833", "America/Campo_Grande"),("3457862", "Maracaí", "", "BR", "76", "", "27", "3528809", "", "-22.61056", "-50.66722", "America/Sao_Paulo"),("3457928", "Mantenópolis", "", "BR", "76", "", "08", "3203304", "", "-18.8625", "-41.12278", "America/Sao_Paulo"),("3457950", "Manhumirim", "", "BR", "76", "", "15", "3139508", "", "-20.35778", "-41.95806", "America/Sao_Paulo"),("3457952", "Manhuaçu", "Маньюасу", "BR", "76", "", "15", "3139409", "", "-20.25806", "-42.03361", "America/Sao_Paulo"),("3457991", "Mangaratiba", "", "BR", "76", "", "21", "3302601", "", "-22.95972", "-44.04056", "America/Sao_Paulo"),("3458020", "Manga", "", "BR", "76", "", "15", "3139300", "", "-14.75583", "-43.93222", "America/Sao_Paulo"),("3458049", "Mandaguari", "", "BR", "76", "", "18", "4114203", "", "-23.5475", "-51.67083", "America/Sao_Paulo"),("3458051", "Mandaguaçu", "", "BR", "76", "", "18", "4114104", "", "-23.34722", "-52.09528", "America/Sao_Paulo"),("3458093", "Malhador", "", "BR", "76", "", "28", "2803906", "", "-10.65778", "-37.30472", "America/Maceio"),("3458121", "Malacacheta", "", "BR", "76", "", "15", "3139201", "", "-17.84222", "-42.07667", "America/Sao_Paulo"),("3458131", "Mairiporã", "Майрипоран", "BR", "76", "", "27", "3528502", "", "-23.31861", "-46.58667", "America/Sao_Paulo"),("3458132", "Mairinque", "Майринки", "BR", "76", "", "27", "3528403", "", "-23.54583", "-47.18333", "America/Sao_Paulo"),("3458134", "Mairi", "", "BR", "76", "", "05", "2920106", "", "-11.71139", "-40.14889", "America/Bahia"),("3458147", "Mafra", "Мафре", "BR", "76", "", "26", "4210100", "", "-26.11139", "-49.80528", "America/Sao_Paulo"),("3458161", "Madre de Deus", "", "BR", "76", "", "05", "2919926", "", "-12.74083", "-38.62083", "America/Bahia"),("3458211", "Machado", "", "BR", "76", "", "15", "3139003", "", "-21.67472", "-45.91972", "America/Sao_Paulo"),("3458237", "Macaúbas", "", "BR", "76", "", "05", "2919801", "", "-13.01944", "-42.69861", "America/Bahia"),("3458245", "Macatuba", "", "BR", "76", "", "27", "3528007", "", "-22.50222", "-48.71139", "America/Sao_Paulo"),("3458266", "Macaé", "Макаэ", "BR", "76", "", "21", "3302403", "", "-22.37083", "-41.78694", "America/Sao_Paulo"),("3458329", "Luziânia", "", "BR", "76", "", "29", "5212501", "", "-16.2525", "-47.95028", "America/Sao_Paulo"),("3458333", "Luz", "", "BR", "76", "", "15", "3138807", "", "-19.80139", "-45.68556", "America/Sao_Paulo"),("3458390", "Lucélia", "", "BR", "76", "", "27", "3527405", "", "-21.72028", "-51.01889", "America/Sao_Paulo"),("3458397", "Lucas", "Лукас", "BR", "76", "", "14", "5101605", "", "-16.33333", "-55.93333", "America/Cuiaba"),("3458406", "Louveira", "", "BR", "76", "", "27", "3527306", "", "-23.08639", "-46.95056", "America/Sao_Paulo"),("3458425", "Lorena", "", "BR", "76", "", "27", "3527207", "", "-22.73083", "-45.12472", "America/Sao_Paulo"),("3458449", "Londrina", "Лондрина", "BR", "76", "", "18", "4113700", "", "-23.31028", "-51.16278", "America/Sao_Paulo"),("3458479", "Loanda", "", "BR", "76", "", "18", "4113502", "", "-22.92306", "-53.13722", "America/Sao_Paulo"),("3458481", "Livramento do Brumado", "", "BR", "76", "", "05", "2919504", "", "-13.65145", "-41.84564", "America/Bahia"),("3458494", "Lins", "Линс", "BR", "76", "", "27", "3527108", "", "-21.67861", "-49.7425", "America/Sao_Paulo"),("3458498", "Linhares", "", "BR", "76", "", "08", "3203205", "", "-19.39111", "-40.07222", "America/Sao_Paulo"),("3458575", "Limeira", "Лимейра", "BR", "76", "", "27", "3526902", "", "-22.56472", "-47.40167", "America/Sao_Paulo"),("3458591", "Lima Duarte", "", "BR", "76", "", "15", "3138609", "", "-21.8425", "-43.79306", "America/Sao_Paulo"),("3458632", "Leopoldina", "", "BR", "76", "", "15", "3138401", "", "-21.53194", "-42.64306", "America/Sao_Paulo"),("3458645", "Lençóis Paulista", "", "BR", "76", "", "27", "3526803", "", "-22.59861", "-48.80028", "America/Sao_Paulo"),("3458662", "Leme", "Лем", "BR", "76", "", "27", "3526704", "", "-22.18556", "-47.39028", "America/Sao_Paulo"),("3458696", "Lavras", "Лаврас", "BR", "76", "", "15", "3138203", "", "-21.24528", "-44.99972", "America/Sao_Paulo"),("3458721", "Lauro Muller", "", "BR", "76", "", "26", "4209607", "", "-28.39278", "-49.39667", "America/Sao_Paulo"),("3458746", "Laranjeiras do Sul", "", "BR", "76", "", "18", "4113304", "", "-25.40778", "-52.41611", "America/Sao_Paulo"),("3458778", "Laranjeiras", "", "BR", "76", "", "28", "2803609", "", "-10.80639", "-37.17", "America/Maceio"),("3458786", "Laranjal Paulista", "", "BR", "76", "", "27", "3526407", "", "-23.04972", "-47.83667", "America/Sao_Paulo"),("3458817", "Lapão", "", "BR", "76", "", "05", "2919157", "", "-11.38333", "-41.83194", "America/Bahia"),("3458826", "Lapa", "", "BR", "76", "", "18", "4113205", "", "-25.76972", "-49.71583", "America/Sao_Paulo"),("3458881", "Lambari", "", "BR", "76", "", "15", "3137809", "", "-21.97556", "-45.35028", "America/Sao_Paulo"),("3458902", "Lajinha", "", "BR", "76", "", "15", "3137700", "", "-20.15139", "-41.62278", "America/Sao_Paulo"),("3458930", "Lages", "Лажис", "BR", "76", "", "26", "4209300", "", "-27.81611", "-50.32611", "America/Sao_Paulo"),("3459035", "Lajeado", "", "BR", "76", "", "23", "4311403", "", "-29.46694", "-51.96139", "America/Sao_Paulo"),("3459094", "Laguna", "Лагуна", "BR", "76", "", "26", "4209409", "", "-28.4825", "-48.78083", "America/Sao_Paulo"),("3459126", "Lagoa Vermelha", "", "BR", "76", "", "23", "4311304", "", "-28.20861", "-51.52583", "America/Sao_Paulo"),("3459138", "Lagoa Santa", "", "BR", "76", "", "15", "3137601", "", "-19.63006", "-43.9009", "America/Sao_Paulo"),("3459181", "Lagoa Formosa", "", "BR", "76", "", "15", "3137502", "", "-18.77861", "-46.4075", "America/Sao_Paulo"),("3459251", "Lagoa da Prata", "", "BR", "76", "", "15", "3137205", "", "-20.0225", "-45.54361", "America/Sao_Paulo"),("3459303", "Lagoa", "", "BR", "76", "", "26", "4205407", "", "-27.60491", "-48.46713", "America/Sao_Paulo"),("3459342", "Lagarto", "", "BR", "76", "", "28", "2803500", "", "-10.91722", "-37.65", "America/Maceio"),("3459352", "Ladário", "", "BR", "76", "", "11", "5005202", "", "-19.00472", "-57.60167", "America/Campo_Grande"),("3459435", "Juquitiba", "", "BR", "76", "", "27", "3526209", "", "-23.93167", "-47.06833", "America/Sao_Paulo"),("3459440", "Juquiá", "", "BR", "76", "", "27", "3526100", "", "-24.32083", "-47.63472", "America/Sao_Paulo"),("3459452", "Junqueirópolis", "", "BR", "76", "", "27", "3526001", "", "-21.51472", "-51.43361", "America/Sao_Paulo"),("3459462", "Jundiaí", "Жундиаи", "BR", "76", "", "27", "3525904", "", "-23.18639", "-46.88417", "America/Sao_Paulo"),("3459495", "Júlio de Castilhos", "", "BR", "76", "", "23", "4311205", "", "-29.22694", "-53.68167", "America/Sao_Paulo"),("3459505", "Juiz de Fora", "Жуис-ди-Фора", "BR", "76", "", "15", "3136702", "", "-21.76417", "-43.35028", "America/Sao_Paulo"),("3459550", "Juatuba", "", "BR", "76", "", "15", "3136652", "", "-19.95194", "-44.34278", "America/Sao_Paulo"),("3459667", "José Bonifácio", "", "BR", "76", "", "27", "3525706", "", "-21.05278", "-49.68833", "America/Sao_Paulo"),("3459712", "Joinville", "Жоинвили", "BR", "76", "", "26", "4209102", "", "-26.30444", "-48.84556", "America/Sao_Paulo"),("3459785", "João Pinheiro", "", "BR", "76", "", "15", "3136306", "", "-17.7425", "-46.1725", "America/Sao_Paulo"),("3459795", "João Neiva", "", "BR", "76", "", "08", "3203130", "", "-19.7575", "-40.38556", "America/Sao_Paulo"),("3459796", "João Monlevade", "Жуан-Монлевади", "BR", "76", "", "15", "3136207", "", "-19.81", "-43.17361", "America/Sao_Paulo"),("3459855", "Joanópolis", "", "BR", "76", "", "27", "3525508", "", "-22.93028", "-46.27556", "America/Sao_Paulo"),("3459867", "Joaíma", "", "BR", "76", "", "15", "3136009", "", "-16.65417", "-41.03056", "America/Sao_Paulo"),("3459869", "Joaçaba", "Жоасаба", "BR", "76", "", "26", "4209003", "", "-27.17806", "-51.50472", "America/Sao_Paulo"),("3459876", "Jitaúna", "", "BR", "76", "", "05", "2918308", "", "-14.01274", "-39.89833", "America/Bahia"),("3459901", "Jetibá", "", "BR", "76", "", "08", "3204559", "", "-20.02069", "-40.68145", "America/Sao_Paulo"),("3459909", "Jerônimo Monteiro", "", "BR", "76", "", "08", "3203106", "", "-20.78944", "-41.395", "America/Sao_Paulo"),("3459922", "Jeremoabo", "", "BR", "76", "", "05", "2918100", "", "-10.075", "-38.48083", "America/Bahia"),("3459925", "Jequitinhonha", "", "BR", "76", "", "15", "3135803", "", "-16.43389", "-41.00333", "America/Sao_Paulo"),("3459943", "Jequié", "Жекие", "BR", "76", "", "05", "2918001", "", "-13.85875", "-40.08512", "America/Bahia"),("3460005", "Jaú", "Жау", "BR", "76", "", "27", "3525300", "", "-22.29639", "-48.55778", "America/Sao_Paulo"),("3460048", "Jataizinho", "", "BR", "76", "", "18", "4112702", "", "-23.25417", "-50.98", "America/Sao_Paulo"),("3460064", "Jataí", "", "BR", "76", "", "29", "5211909", "", "-17.87939", "-51.72166", "America/Sao_Paulo"),("3460068", "Jarinu", "", "BR", "76", "", "27", "3525201", "", "-23.10139", "-46.72833", "America/Sao_Paulo"),("3460071", "Jardinópolis", "", "BR", "76", "", "27", "3525102", "", "-21.01778", "-47.76389", "America/Sao_Paulo"),("3460087", "Jardim", "", "BR", "76", "", "11", "5005004", "", "-21.48028", "-56.13806", "America/Campo_Grande"),("3460102", "Jaraguá do Sul", "Жарагуа-ду-Сул", "BR", "76", "", "26", "4208906", "", "-26.48611", "-49.06667", "America/Sao_Paulo"),("3460107", "Jaraguá", "", "BR", "76", "", "29", "5211800", "", "-15.75694", "-49.33444", "America/Sao_Paulo"),("3460132", "Japeri", "", "BR", "76", "", "21", "3302270", "", "-22.64306", "-43.65333", "America/Sao_Paulo"),("3460136", "Japaratuba", "", "BR", "76", "", "28", "2803302", "", "-10.59333", "-36.94028", "America/Maceio"),("3460148", "Januária", "", "BR", "76", "", "15", "3135209", "", "-15.48866", "-44.35988", "America/Sao_Paulo"),("3460170", "Jandira", "", "BR", "76", "", "27", "3525003", "", "-23.5275", "-46.9025", "America/Sao_Paulo"),("3460172", "Jandaia do Sul", "", "BR", "76", "", "18", "4112108", "", "-23.60306", "-51.64333", "America/Sao_Paulo"),("3460174", "Janaúba", "", "BR", "76", "", "15", "3135100", "", "-15.8025", "-43.30889", "America/Sao_Paulo"),("3460186", "Jales", "", "BR", "76", "", "27", "3524808", "", "-20.26889", "-50.54583", "America/Sao_Paulo"),("3460197", "Jaguaruna", "", "BR", "76", "", "26", "4208807", "", "-28.62145", "-49.02529", "America/Sao_Paulo"),("3460200", "Jaguariúna", "", "BR", "76", "", "27", "3524709", "", "-22.70556", "-46.98583", "America/Sao_Paulo"),("3460214", "Jaguariaíva", "", "BR", "76", "", "18", "4112009", "", "-24.24423", "-49.70932", "America/Sao_Paulo"),("3460225", "Jaguarari", "", "BR", "76", "", "05", "2917706", "", "-10.26389", "-40.19583", "America/Bahia"),("3460232", "Jaguarão", "", "BR", "76", "", "23", "4311007", "", "-32.56611", "-53.37583", "America/Sao_Paulo"),("3460242", "Jaguaquara", "", "BR", "76", "", "05", "2917607", "", "-13.53056", "-39.97083", "America/Bahia"),("3460267", "Jacutinga", "", "BR", "76", "", "15", "3134905", "", "-22.28556", "-46.61222", "America/Sao_Paulo"),("3460281", "Jacupiranga", "", "BR", "76", "", "27", "3524600", "", "-24.6925", "-48.00222", "America/Sao_Paulo"),("3460344", "Jacobina", "", "BR", "76", "", "05", "2917508", "", "-11.18143", "-40.51372", "America/Bahia"),("3460355", "Jaciara", "", "BR", "76", "", "14", "5104807", "", "-15.96528", "-54.96833", "America/Cuiaba"),("3460362", "Jacarezinho", "Жакарезинью", "BR", "76", "", "18", "4111803", "", "-23.16056", "-49.96944", "America/Sao_Paulo"),("3460370", "Jacareí", "Жакареи", "BR", "76", "", "27", "3524402", "", "-23.30528", "-45.96583", "America/Sao_Paulo"),("3460441", "Jaboticabal", "Жаботикабал", "BR", "76", "", "27", "3524303", "", "-21.25472", "-48.32222", "America/Sao_Paulo"),("3460484", "Ivoti", "", "BR", "76", "", "23", "4310801", "", "-29.59111", "-51.16056", "America/Sao_Paulo"),("3460505", "Iúna", "", "BR", "76", "", "08", "3203007", "", "-20.34583", "-41.53583", "America/Sao_Paulo"),("3460511", "Ituverava", "", "BR", "76", "", "27", "3524105", "", "-20.33944", "-47.78056", "America/Sao_Paulo"),("3460513", "Iturama", "Итурама", "BR", "76", "", "15", "3134400", "", "-19.72806", "-50.19556", "America/Sao_Paulo"),("3460516", "Itupeva", "", "BR", "76", "", "27", "3524006", "", "-23.15306", "-47.05778", "America/Sao_Paulo"),("3460522", "Itumbiara", "Итумбиара", "BR", "76", "", "29", "5211503", "", "-18.41917", "-49.21528", "America/Sao_Paulo"),("3460523", "Ituiutaba", "Итиютаба", "BR", "76", "", "15", "3134202", "", "-18.97428", "-49.46212", "America/Sao_Paulo"),("3460530", "Ituberá", "", "BR", "76", "", "05", "2917300", "", "-13.73222", "-39.14917", "America/Bahia"),("3460535", "Itu", "Иту", "BR", "76", "", "27", "3523909", "", "-23.26417", "-47.29917", "America/Sao_Paulo"),("3460542", "Itororó", "", "BR", "76", "", "05", "2917102", "", "-15.11694", "-40.07028", "America/Bahia"),("3460549", "Itiruçu", "", "BR", "76", "", "05", "2916906", "", "-13.53167", "-40.15028", "America/Bahia"),("3460553", "Itirapina", "", "BR", "76", "", "27", "3523602", "", "-22.25278", "-47.82278", "America/Sao_Paulo"),("3460584", "Itaúna", "", "BR", "76", "", "15", "3133808", "", "-20.07528", "-44.57639", "America/Sao_Paulo"),("3460588", "Itaú de Minas", "", "BR", "76", "", "15", "3133758", "", "-20.73944", "-46.75222", "America/Sao_Paulo"),("3460594", "Itatinga", "", "BR", "76", "", "27", "3523503", "", "-23.10167", "-48.61583", "America/Sao_Paulo"),("3460598", "Itatiba", "", "BR", "76", "", "27", "3523404", "", "-23.00583", "-46.83889", "America/Sao_Paulo"),("3460602", "Itatiaia", "", "BR", "76", "", "21", "3302254", "", "-22.49611", "-44.56333", "America/Sao_Paulo"),("3460620", "Itararé", "Итараре", "BR", "76", "", "27", "3523206", "", "-24.1125", "-49.33167", "America/Sao_Paulo"),("3460622", "Itarantim", "", "BR", "76", "", "05", "2916807", "", "-15.65972", "-40.06556", "America/Bahia"),("3460629", "Itaqui", "Итака", "BR", "76", "", "23", "4310603", "", "-29.12528", "-56.55306", "America/Sao_Paulo"),("3460644", "Itaquaquecetuba", "", "BR", "76", "", "27", "3523107", "", "-23.48611", "-46.34833", "America/Sao_Paulo"),("3460648", "Itapuranga", "", "BR", "76", "", "29", "5211206", "", "-15.56222", "-49.94861", "America/Sao_Paulo"),("3460651", "Itapuí", "", "BR", "76", "", "27", "3522901", "", "-22.23333", "-48.71917", "America/Sao_Paulo"),("3460666", "Itaporanga", "", "BR", "76", "", "27", "3522802", "", "-23.70778", "-49.48972", "America/Sao_Paulo"),("3460671", "Itápolis", "", "BR", "76", "", "27", "3522703", "", "-21.59556", "-48.81278", "America/Sao_Paulo"),("3460697", "Itapirapuã", "", "BR", "76", "", "29", "5211008", "", "-15.82333", "-50.61333", "America/Sao_Paulo"),("3460699", "Itapira", "", "BR", "76", "", "27", "3522604", "", "-22.43611", "-46.82167", "America/Sao_Paulo"),("3460718", "Itapevi", "", "BR", "76", "", "27", "3522505", "", "-23.54889", "-46.93417", "America/Sao_Paulo"),("3460723", "Itapeva", "", "BR", "76", "", "27", "3522406", "", "-23.98222", "-48.87556", "America/Sao_Paulo"),("3460728", "Itapetininga", "Итапетининга", "BR", "76", "", "27", "3522307", "", "-23.59167", "-48.05306", "America/Sao_Paulo"),("3460730", "Itapetinga", "", "BR", "76", "", "05", "2916401", "", "-15.24889", "-40.24778", "America/Bahia"),("3460733", "Itaperuna", "", "BR", "76", "", "21", "3302205", "", "-21.205", "-41.88778", "America/Sao_Paulo"),("3460734", "Itaperuçu", "", "BR", "76", "", "18", "4111258", "", "-25.22", "-49.34778", "America/Sao_Paulo"),("3460738", "Itapemirim", "", "BR", "76", "", "08", "3202801", "", "-21.01111", "-40.83389", "America/Sao_Paulo"),("3460740", "Itapema", "Итапема", "BR", "76", "", "26", "4208302", "", "-27.09028", "-48.61139", "America/Sao_Paulo"),("3460748", "Itapecerica da Serra", "Итапесерика-да-Серра", "BR", "76", "", "27", "3522208", "", "-23.71694", "-46.84917", "America/Sao_Paulo"),("3460752", "Itapecerica", "", "BR", "76", "", "15", "3133501", "", "-20.4725", "-45.12556", "America/Sao_Paulo"),("3460764", "Itaparica", "", "BR", "76", "", "05", "2916104", "", "-12.88833", "-38.67861", "America/Bahia"),("3460773", "Itapaci", "", "BR", "76", "", "29", "5210901", "", "-14.95083", "-49.54944", "America/Sao_Paulo"),("3460774", "Itaocara", "", "BR", "76", "", "21", "3302106", "", "-21.66917", "-42.07611", "America/Sao_Paulo"),("3460785", "Itanhém", "", "BR", "76", "", "05", "2916005", "", "-17.16639", "-40.33", "America/Bahia"),("3460788", "Itanhandu", "", "BR", "76", "", "15", "3133105", "", "-22.29583", "-44.93472", "America/Sao_Paulo"),("3460791", "Itanhaém", "", "BR", "76", "", "27", "3522109", "", "-24.18306", "-46.78889", "America/Sao_Paulo"),("3460813", "Itambé", "", "BR", "76", "", "05", "2915809", "", "-15.245", "-40.62444", "America/Bahia"),("3460817", "Itambacuri", "", "BR", "76", "", "15", "3132701", "", "-18.03111", "-41.685", "America/Sao_Paulo"),("3460825", "Itamarandiba", "", "BR", "76", "", "15", "3132503", "", "-17.85722", "-42.85889", "America/Sao_Paulo"),("3460826", "Itamaraju", "", "BR", "76", "", "05", "2915601", "", "-17.03917", "-39.53111", "America/Bahia"),("3460831", "Itajuípe", "", "BR", "76", "", "05", "2915502", "", "-14.67806", "-39.375", "America/Bahia"),("3460834", "Itajubá", "Итажуба", "BR", "76", "", "15", "3132404", "", "-22.42556", "-45.45278", "America/Sao_Paulo"),("3460836", "Itajobi", "", "BR", "76", "", "27", "3521903", "", "-21.31806", "-49.05444", "America/Sao_Paulo"),("3460837", "Itagibá", "", "BR", "76", "", "05", "2915205", "", "-14.28361", "-39.84278", "America/Bahia"),("3460845", "Itajaí", "Итажаи", "BR", "76", "", "26", "4208203", "", "-26.90778", "-48.66194", "America/Sao_Paulo"),("3460887", "Itaí", "", "BR", "76", "", "27", "3521804", "", "-23.41778", "-49.09056", "America/Sao_Paulo"),("3460899", "Itaguaí", "Итагуаи", "BR", "76", "", "21", "3302007", "", "-22.85222", "-43.77528", "America/Sao_Paulo"),("3460901", "Itaguaçu", "", "BR", "76", "", "08", "3202702", "", "-19.80194", "-40.85556", "America/Sao_Paulo"),("3460907", "Itagi", "", "BR", "76", "", "05", "2915106", "", "-14.16278", "-40.00611", "America/Bahia"),("3460940", "Itacaré", "", "BR", "76", "", "05", "2914901", "", "-14.2789", "-38.99584", "America/Bahia"),("3460942", "Itacarambi", "", "BR", "76", "", "15", "3132107", "", "-15.10222", "-44.09194", "America/Sao_Paulo"),("3460949", "Itabuna", "Итабуна", "BR", "76", "", "05", "2914802", "", "-14.78556", "-39.28028", "America/Bahia"),("3460950", "Itaboraí", "", "BR", "76", "", "21", "3301900", "", "-22.74444", "-42.85944", "America/Sao_Paulo"),("3460954", "Itabirito", "", "BR", "76", "", "15", "3131901", "", "-20.25333", "-43.80139", "America/Sao_Paulo"),("3460960", "Itabira", "Итабира", "BR", "76", "", "15", "3131703", "", "-19.61917", "-43.22694", "America/Sao_Paulo"),("3460963", "Itaberaí", "Итабераи", "BR", "76", "", "29", "5210406", "", "-16.02028", "-49.81028", "America/Sao_Paulo"),("3460966", "Itaberaba", "", "BR", "76", "", "05", "2914703", "", "-12.5275", "-40.30694", "America/Bahia"),("3460967", "Itaberá", "", "BR", "76", "", "27", "3521705", "", "-23.86194", "-49.13722", "America/Sao_Paulo"),("3460971", "Itabaianinha", "", "BR", "76", "", "28", "2803005", "", "-11.27389", "-37.79", "America/Maceio"),("3460974", "Itabaiana", "", "BR", "76", "", "28", "2802908", "", "-10.685", "-37.42528", "America/Maceio"),("3461013", "Irecê", "", "BR", "76", "", "05", "2914604", "", "-11.30417", "-41.85583", "America/Bahia"),("3461017", "Irati", "", "BR", "76", "", "18", "4110706", "", "-25.46722", "-50.65111", "America/Sao_Paulo"),("3461022", "Irará", "", "BR", "76", "", "05", "2914505", "", "-12.05", "-38.76667", "America/Bahia"),("3461023", "Iraquara", "", "BR", "76", "", "05", "2914406", "", "-12.24861", "-41.61944", "America/Bahia"),("3461055", "Iracemápolis", "", "BR", "76", "", "27", "3521408", "", "-22.58056", "-47.51861", "America/Sao_Paulo"),("3461080", "Ipuã", "", "BR", "76", "", "27", "3521309", "", "-20.43806", "-48.01222", "America/Sao_Paulo"),("3461089", "Iporã", "", "BR", "76", "", "18", "4110607", "", "-24.00306", "-53.70417", "America/Sao_Paulo"),("3461090", "Iporá", "Ипора", "BR", "76", "", "29", "5210208", "", "-16.44194", "-51.11778", "America/Sao_Paulo"),("3461124", "Ipirá", "", "BR", "76", "", "05", "2914000", "", "-12.15833", "-39.73722", "America/Bahia"),("3461129", "Ipiaú", "Ипиау", "BR", "76", "", "05", "2913903", "", "-14.13449", "-39.73948", "America/Bahia"),("3461134", "Iperó", "", "BR", "76", "", "27", "3521002", "", "-23.35028", "-47.68861", "America/Sao_Paulo"),("3461143", "Ipauçu", "", "BR", "76", "", "27", "3520905", "", "-23.05667", "-49.62639", "America/Sao_Paulo"),("3461144", "Ipatinga", "Ипатинга", "BR", "76", "", "15", "3131307", "", "-19.46833", "-42.53667", "America/Sao_Paulo"),("3461151", "Ipameri", "", "BR", "76", "", "29", "5210109", "", "-17.72194", "-48.15972", "America/Sao_Paulo"),("3461153", "Ipaba", "", "BR", "76", "", "15", "3131158", "", "-19.41361", "-42.41944", "America/Sao_Paulo"),("3461194", "Inhumas", "", "BR", "76", "", "29", "5210000", "", "-16.35778", "-49.49611", "America/Sao_Paulo"),("3461214", "Inhapim", "", "BR", "76", "", "15", "3130903", "", "-19.54917", "-42.12", "America/Sao_Paulo"),("3461224", "Inhambupe", "", "BR", "76", "", "05", "2913705", "", "-11.78444", "-38.35306", "America/Bahia"),("3461311", "Indaiatuba", "Индаятуба", "BR", "76", "", "27", "3520509", "", "-23.08842", "-47.2119", "America/Sao_Paulo"),("3461316", "Indaial", "", "BR", "76", "", "26", "4207502", "", "-26.89778", "-49.23167", "America/Sao_Paulo"),("3461368", "Imbituva", "", "BR", "76", "", "18", "4110102", "", "-25.23", "-50.60444", "America/Sao_Paulo"),("3461370", "Imbituba", "", "BR", "76", "", "26", "4207304", "", "-28.24", "-48.67028", "America/Sao_Paulo"),("3461408", "Ilhéus", "Ильеус", "BR", "76", "", "05", "2913606", "", "-14.79364", "-39.03949", "America/Bahia"),("3461411", "Ilha Solteira", "Илья-Солтейра", "BR", "76", "", "27", "3520442", "", "-20.43278", "-51.3425", "America/Sao_Paulo"),("3461425", "Ilhabela", "", "BR", "76", "", "27", "3520400", "", "-23.77806", "-45.35806", "America/Sao_Paulo"),("3461444", "Ijuí", "Ижуи", "BR", "76", "", "23", "4310207", "", "-28.38778", "-53.91472", "America/Sao_Paulo"),("3461455", "Iguatemi", "", "BR", "76", "", "11", "5004304", "", "-23.68028", "-54.56111", "America/Campo_Grande"),("3461465", "Iguape", "Игуапи", "BR", "76", "", "27", "3520301", "", "-24.70806", "-47.55528", "America/Sao_Paulo"),("3461469", "Iguaí", "", "BR", "76", "", "05", "2913507", "", "-14.75639", "-40.08917", "America/Bahia"),("3461477", "Iguaba Grande", "", "BR", "76", "", "21", "3301876", "", "-22.83917", "-42.22889", "America/Sao_Paulo"),("3461481", "Igrejinha", "Игрежинья", "BR", "76", "", "23", "4310108", "", "-29.57444", "-50.79028", "America/Sao_Paulo"),("3461498", "Igarapé", "", "BR", "76", "", "15", "3130101", "", "-20.07028", "-44.30167", "America/Sao_Paulo"),("3461499", "Igarapava", "", "BR", "76", "", "27", "3520103", "", "-20.03833", "-47.74694", "America/Sao_Paulo"),("3461501", "Igaraçu do Tietê", "", "BR", "76", "", "27", "3520004", "", "-22.50917", "-48.55778", "America/Sao_Paulo"),("3461510", "Iconha", "", "BR", "76", "", "08", "3202603", "", "-20.79306", "-40.81111", "America/Sao_Paulo"),("3461519", "Içara", "Исара", "BR", "76", "", "26", "4207007", "", "-28.71333", "-49.3", "America/Sao_Paulo"),("3461525", "Ibotirama", "", "BR", "76", "", "05", "2913200", "", "-12.18528", "-43.22056", "America/Bahia"),("3461528", "Ibiúna", "", "BR", "76", "", "27", "3519709", "", "-23.65639", "-47.2225", "America/Sao_Paulo"),("3461550", "Ibitinga", "", "BR", "76", "", "27", "3519600", "", "-21.75778", "-48.82889", "America/Sao_Paulo"),("3461559", "Ibirubá", "", "BR", "76", "", "23", "4310009", "", "-28.6275", "-53.08972", "America/Sao_Paulo"),("3461563", "Ibirité", "Ибирите", "BR", "76", "", "15", "3129806", "", "-20.02194", "-44.05889", "America/Sao_Paulo"),("3461565", "Ibirataia", "", "BR", "76", "", "05", "2912905", "", "-14.06694", "-39.64056", "America/Bahia"),("3461572", "Ibirapitanga", "", "BR", "76", "", "05", "2912707", "", "-14.16417", "-39.37361", "America/Bahia"),("3461576", "Ibirama", "", "BR", "76", "", "26", "4206900", "", "-27.05694", "-49.51778", "America/Sao_Paulo"),("3461579", "Ibiraçu", "", "BR", "76", "", "08", "3202504", "", "-19.83194", "-40.36972", "America/Sao_Paulo"),("3461588", "Ibiporã", "", "BR", "76", "", "18", "4109807", "", "-23.26917", "-51.04806", "America/Sao_Paulo"),("3461592", "Ibipeba", "", "BR", "76", "", "05", "2912400", "", "-11.64083", "-42.01111", "America/Bahia"),("3461602", "Ibicuí", "", "BR", "76", "", "05", "2912301", "", "-14.84167", "-39.98667", "America/Bahia"),("3461606", "Ibicaraí", "", "BR", "76", "", "05", "2912103", "", "-14.865", "-39.5875", "America/Bahia"),("3461620", "Ibiá", "", "BR", "76", "", "15", "3129509", "", "-19.47833", "-46.53889", "America/Sao_Paulo"),("3461624", "Ibatiba", "", "BR", "76", "", "08", "3202454", "", "-20.23389", "-41.51056", "America/Sao_Paulo"),("3461625", "Ibaté", "", "BR", "76", "", "27", "3519303", "", "-21.95472", "-47.99667", "America/Sao_Paulo"),("3461628", "Ibaiti", "", "BR", "76", "", "18", "4109708", "", "-23.84861", "-50.18778", "America/Sao_Paulo"),("3461638", "Iaçu", "", "BR", "76", "", "05", "2911907", "", "-12.76722", "-40.21167", "America/Bahia"),("3461641", "Iaciara", "", "BR", "76", "", "29", "5209903", "", "-14.09583", "-46.63167", "America/Sao_Paulo"),("3461655", "Hortolândia", "Ортоландия", "BR", "76", "", "27", "3519071", "", "-22.85833", "-47.22", "America/Sao_Paulo"),("3461659", "Horizontina", "", "BR", "76", "", "23", "4309605", "", "-27.62583", "-54.30778", "America/Sao_Paulo"),("3461677", "Hidrolândia", "", "BR", "76", "", "29", "5209705", "", "-16.96222", "-49.22806", "America/Sao_Paulo"),("3461680", "Herval", "", "BR", "76", "", "23", "4307104", "", "-32.02361", "-53.39556", "America/Sao_Paulo"),("3461724", "Gurupi", "Гурупи", "BR", "76", "", "31", "1709500", "", "-11.72917", "-49.06861", "America/Araguaina"),("3461733", "Guiratinga", "", "BR", "76", "", "14", "5104203", "", "-16.34534", "-53.76177", "America/Cuiaba"),("3461750", "Guia Lopes da Laguna", "", "BR", "76", "", "11", "5004106", "", "-21.45778", "-56.11417", "America/Campo_Grande"),("3461763", "Guaxupé", "", "BR", "76", "", "15", "3128709", "", "-21.30528", "-46.71278", "America/Sao_Paulo"),("3461786", "Guarulhos", "", "BR", "76", "", "27", "3518800", "", "-23.46278", "-46.53333", "America/Sao_Paulo"),("3461789", "Guarujá", "Гуаружа", "BR", "76", "", "27", "3518701", "", "-23.99306", "-46.25639", "America/Sao_Paulo"),("3461824", "Guariba", "", "BR", "76", "", "27", "3518602", "", "-21.36", "-48.22833", "America/Sao_Paulo"),("3461857", "Guaratuba", "", "BR", "76", "", "18", "4109609", "", "-25.88278", "-48.57472", "America/Sao_Paulo"),("3461859", "Guaratinguetá", "Гуаратингета", "BR", "76", "", "27", "3518404", "", "-22.81639", "-45.1925", "America/Sao_Paulo"),("3461860", "Guaratinga", "", "BR", "76", "", "05", "2914653", "", "-16.58564", "-39.78189", "America/Bahia"),("3461871", "Guararema", "", "BR", "76", "", "27", "3518305", "", "-23.415", "-46.035", "America/Sao_Paulo"),("3461874", "Guararapes", "", "BR", "76", "", "27", "3518206", "", "-21.26083", "-50.64278", "America/Sao_Paulo"),("3461879", "Guarapuava", "Гуарапуава", "BR", "76", "", "18", "4109401", "", "-25.39048", "-51.46541", "America/Sao_Paulo"),("3461888", "Guarapari", "Гуарапари", "BR", "76", "", "08", "3202405", "", "-20.65367", "-40.50204", "America/Sao_Paulo"),("3461892", "Guaraniaçu", "", "BR", "76", "", "18", "4109302", "", "-25.10083", "-52.87806", "America/Sao_Paulo"),("3461910", "Guaranésia", "", "BR", "76", "", "15", "3128303", "", "-21.29917", "-46.8025", "America/Sao_Paulo"),("3461914", "Guaramirim", "", "BR", "76", "", "26", "4206504", "", "-26.47306", "-49.00278", "America/Sao_Paulo"),("3461935", "Guará", "", "BR", "76", "", "27", "3517703", "", "-20.42833", "-47.82417", "America/Sao_Paulo"),("3461941", "Guaporé", "", "BR", "76", "", "23", "4309407", "", "-28.84556", "-51.89028", "America/Sao_Paulo"),("3461943", "Guapó", "", "BR", "76", "", "29", "5209200", "", "-16.83056", "-49.53194", "America/Sao_Paulo"),("3461949", "Guapimirim", "Гуапимирин", "BR", "76", "", "21", "3301850", "", "-22.53722", "-42.98194", "America/Sao_Paulo"),("3461954", "Guapiaçu", "", "BR", "76", "", "27", "3517505", "", "-20.795", "-49.22028", "America/Sao_Paulo"),("3461958", "Guanhães", "", "BR", "76", "", "15", "3128006", "", "-18.775", "-42.9325", "America/Sao_Paulo"),("3461973", "Guanambi", "", "BR", "76", "", "05", "2911709", "", "-14.22333", "-42.78139", "America/Bahia"),("3461995", "Guaíra", "Гуайра", "BR", "76", "", "27", "3517406", "", "-20.31833", "-48.31056", "America/Sao_Paulo"),("3462022", "Guaçuí", "", "BR", "76", "", "08", "3202306", "", "-20.77556", "-41.67944", "America/Sao_Paulo"),("3462089", "Gravataí", "Граватаи", "BR", "76", "", "23", "4309209", "", "-29.94218", "-50.99278", "America/Sao_Paulo"),("3462315", "Governador Valadares", "Говернадор-Валадарес", "BR", "76", "", "15", "3127701", "", "-18.85111", "-41.94944", "America/Sao_Paulo"),("3462371", "Goiatuba", "Гоятуба", "BR", "76", "", "29", "5209101", "", "-18.0125", "-49.35472", "America/Sao_Paulo"),("3462374", "Goiás", "", "BR", "76", "", "29", "5208905", "", "-15.93444", "-50.14028", "America/Sao_Paulo"),("3462376", "Goianira", "Гоянира", "BR", "76", "", "29", "5208806", "", "-16.49611", "-49.42639", "America/Sao_Paulo"),("3462377", "Goiânia", "Гояния", "BR", "76", "", "29", "5208707", "", "-16.67861", "-49.25389", "America/Sao_Paulo"),("3462378", "Goianésia", "", "BR", "76", "", "29", "5208608", "", "-15.3175", "-49.1175", "America/Sao_Paulo"),("3462383", "Goianápolis", "", "BR", "76", "", "29", "5208400", "", "-16.51056", "-49.02389", "America/Sao_Paulo"),("3462419", "Giruá", "", "BR", "76", "", "23", "4309001", "", "-28.02833", "-54.34972", "America/Sao_Paulo"),("3462487", "General Salgado", "", "BR", "76", "", "27", "3516903", "", "-20.64833", "-50.36056", "America/Sao_Paulo"),("3462535", "Gaspar", "", "BR", "76", "", "26", "4205902", "", "-26.93139", "-48.95889", "America/Sao_Paulo"),("3462557", "Garibaldi", "", "BR", "76", "", "23", "4308607", "", "-29.25611", "-51.53361", "America/Sao_Paulo"),("3462580", "Garça", "", "BR", "76", "", "27", "3516705", "", "-22.21056", "-49.65611", "America/Sao_Paulo"),("3462601", "Gandu", "", "BR", "76", "", "05", "2911204", "", "-13.74389", "-39.48667", "America/Bahia"),("3462882", "Fundão", "", "BR", "76", "", "08", "3202207", "", "-19.93408", "-40.40473", "America/Sao_Paulo"),("3462916", "Frutal", "Фрутал", "BR", "76", "", "15", "3127107", "", "-20.02472", "-48.94056", "America/Sao_Paulo"),("3462944", "Frei Paulo", "", "BR", "76", "", "28", "2802304", "", "-10.54944", "-37.53444", "America/Maceio"),("3462956", "Frederico Westphalen", "", "BR", "76", "", "23", "4308508", "", "-27.35917", "-53.39444", "America/Sao_Paulo"),("3462964", "Franco da Rocha", "", "BR", "76", "", "27", "3516408", "", "-23.32167", "-46.72694", "America/Sao_Paulo"),("3462975", "Francisco Sá", "", "BR", "76", "", "15", "3126703", "", "-16.47583", "-43.48833", "America/Sao_Paulo"),("3462980", "Francisco Morato", "", "BR", "76", "", "27", "3516309", "", "-23.28167", "-46.74528", "America/Sao_Paulo"),("3462996", "Francisco Beltrão", "Белтран-Франциско", "BR", "76", "", "18", "4108403", "", "-26.08111", "-53.055", "America/Sao_Paulo"),("3463011", "Franca", "Франко", "BR", "76", "", "27", "3516200", "", "-20.53861", "-47.40083", "America/Sao_Paulo"),("3463030", "Foz do Iguaçu", "Фос-ду-Игуасу", "BR", "76", "", "18", "4108304", "", "-25.54778", "-54.58806", "America/Sao_Paulo"),("3463066", "Forquilhinha", "Форкильинья", "BR", "76", "", "26", "4205456", "", "-28.7475", "-49.47222", "America/Sao_Paulo"),("3463124", "Formosa do Rio Preto", "", "BR", "76", "", "05", "2911105", "", "-11.04833", "-45.19306", "America/Bahia"),("3463140", "Formosa", "", "BR", "76", "", "29", "5208004", "", "-15.53722", "-47.33444", "America/Sao_Paulo"),("3463174", "Formiga", "Формига", "BR", "76", "", "15", "3126109", "", "-20.46444", "-45.42639", "America/Sao_Paulo"),("3463228", "Paulista Flórida", "", "BR", "76", "", "27", "3516002", "", "-21.6", "-51.2", "America/Sao_Paulo"),("3463237", "Florianópolis", "Флорианополис", "BR", "76", "", "26", "4205407", "", "-27.59667", "-48.54917", "America/Sao_Paulo"),("3463246", "Florestópolis", "", "BR", "76", "", "18", "4108007", "", "-22.86333", "-51.38722", "America/Sao_Paulo"),("3463271", "Flores da Cunha", "", "BR", "76", "", "23", "4308201", "", "-29.02889", "-51.18167", "America/Sao_Paulo"),("3463326", "Firminópolis", "", "BR", "76", "", "29", "5207808", "", "-16.58194", "-50.305", "America/Sao_Paulo"),("3463422", "Ferraz de Vasconcelos", "", "BR", "76", "", "27", "3515707", "", "-23.54083", "-46.36861", "America/Sao_Paulo"),("3463432", "Fernandópolis", "", "BR", "76", "", "27", "3515509", "", "-20.28389", "-50.24639", "America/Sao_Paulo"),("3463478", "Feira de Santana", "Фейра-де-Сантана", "BR", "76", "", "05", "2910800", "", "-12.26667", "-38.96667", "America/Bahia"),("3463573", "Faxinal", "", "BR", "76", "", "18", "4107603", "", "-24.00028", "-51.31944", "America/Sao_Paulo"),("3463604", "Fartura", "", "BR", "76", "", "27", "3515400", "", "-23.38833", "-49.51", "America/Sao_Paulo"),("3463605", "Farroupilha", "", "BR", "76", "", "23", "4307906", "", "-29.225", "-51.34778", "America/Sao_Paulo"),("3463668", "Extrema", "", "BR", "76", "", "15", "3125101", "", "-22.85472", "-46.31833", "America/Sao_Paulo"),("3463698", "Euclides da Cunha", "Евклид-да-Кунья", "BR", "76", "", "05", "2910701", "", "-10.5075", "-39.01583", "America/Bahia"),("3463762", "Estrela", "", "BR", "76", "", "23", "4322509", "", "-28.06111", "-50.93833", "America/Sao_Paulo"),("3463859", "Esteio", "", "BR", "76", "", "23", "4307708", "", "-29.86139", "-51.17917", "America/Sao_Paulo"),("3463865", "Estância Velha", "", "BR", "76", "", "23", "4307609", "", "-29.64833", "-51.17389", "America/Sao_Paulo"),("3463900", "Estância", "", "BR", "76", "", "28", "2802106", "", "-11.26833", "-37.43833", "America/Maceio"),("3463916", "Espumoso", "", "BR", "76", "", "23", "4307500", "", "-28.72472", "-52.84972", "America/Sao_Paulo"),("3463920", "Esplanada", "", "BR", "76", "", "05", "2910602", "", "-11.79611", "-37.945", "America/Bahia"),("3463939", "Espinosa", "", "BR", "76", "", "15", "3124302", "", "-14.92611", "-42.81917", "America/Sao_Paulo"),("3463993", "Espera Feliz", "", "BR", "76", "", "15", "3124203", "", "-20.65028", "-41.90722", "America/Sao_Paulo"),("3464008", "Esmeraldas", "Эсмеральдас", "BR", "76", "", "15", "3124104", "", "-19.7625", "-44.31389", "America/Sao_Paulo"),("3464073", "Erechim", "Эрешин", "BR", "76", "", "23", "4307005", "", "-27.63461", "-52.2754", "America/Sao_Paulo"),("3464100", "Entre Rios", "", "BR", "76", "", "05", "2910503", "", "-11.94194", "-38.08444", "America/Bahia"),("3464219", "Engenheiro Beltrão", "", "BR", "76", "", "18", "4107504", "", "-23.79722", "-52.26917", "America/Sao_Paulo"),("3464255", "Encruzilhada do Sul", "", "BR", "76", "", "23", "4306908", "", "-30.54389", "-52.52194", "America/Sao_Paulo"),("3464274", "Encantado", "", "BR", "76", "", "23", "4306809", "", "-29.23611", "-51.86972", "America/Sao_Paulo"),("3464304", "Embu Guaçu", "", "BR", "76", "", "27", "3515103", "", "-23.83222", "-46.81139", "America/Sao_Paulo"),("3464305", "Embu", "Эмба", "BR", "76", "", "27", "3515004", "", "-23.64889", "-46.85222", "America/Sao_Paulo"),("3464329", "Elói Mendes", "", "BR", "76", "", "15", "3123601", "", "-21.61", "-45.56528", "America/Sao_Paulo"),("3464335", "Elias Fausto", "", "BR", "76", "", "27", "3514908", "", "-23.04278", "-47.37389", "America/Sao_Paulo"),("3464343", "Eldorado", "", "BR", "76", "", "11", "5003751", "", "-23.78694", "-54.28361", "America/Campo_Grande"),("3464363", "Edéia", "", "BR", "76", "", "29", "5207402", "", "-17.33833", "-49.93139", "America/Sao_Paulo"),("3464364", "Ecoporanga", "", "BR", "76", "", "08", "3202108", "", "-18.37333", "-40.83056", "America/Sao_Paulo"),("3464374", "Duque de Caxias", "Дуки-ди-Кашиас", "BR", "76", "", "21", "3301702", "", "-22.78556", "-43.31167", "America/Sao_Paulo"),("3464422", "Duartina", "", "BR", "76", "", "27", "3514502", "", "-22.41444", "-49.40389", "America/Sao_Paulo"),("3464460", "Dourados", "Дорадус", "BR", "76", "", "11", "5003702", "", "-22.22111", "-54.80556", "America/Campo_Grande"),("3464511", "Dores do Indaiá", "", "BR", "76", "", "15", "3123205", "", "-19.46333", "-45.60167", "America/Sao_Paulo"),("3464547", "Dom Pedrito", "", "BR", "76", "", "23", "4306601", "", "-30.98278", "-54.67306", "America/Sao_Paulo"),("3464556", "Domingos Martins", "", "BR", "76", "", "08", "3201902", "", "-20.36333", "-40.65917", "America/Sao_Paulo"),("3464579", "Dois Vizinhos", "", "BR", "76", "", "18", "4107207", "", "-25.73361", "-53.05722", "America/Sao_Paulo"),("3464618", "Dois Córregos", "", "BR", "76", "", "27", "3514106", "", "-22.36611", "-48.38028", "America/Sao_Paulo"),("3464688", "Divinópolis", "Дивинополис", "BR", "76", "", "15", "3122306", "", "-20.14355", "-44.89065", "America/Sao_Paulo"),("3464693", "Divino das Laranjeiras", "", "BR", "76", "", "15", "3122108", "", "-18.77778", "-41.47972", "America/Sao_Paulo"),("3464724", "Diamantino", "", "BR", "76", "", "14", "5103502", "", "-14.40861", "-56.44611", "America/Cuiaba"),("3464728", "Diamantina", "Диамантина", "BR", "76", "", "15", "3121605", "", "-18.24692", "-43.60345", "America/Sao_Paulo"),("3464739", "Diadema", "Диадема", "BR", "76", "", "27", "3513801", "", "-23.68611", "-46.62278", "America/Sao_Paulo"),("3464809", "Descalvado", "", "BR", "76", "", "27", "3513702", "", "-21.90389", "-47.61944", "America/Sao_Paulo"),("3464891", "Curvelo", "Курвелу", "BR", "76", "", "15", "3120904", "", "-18.75639", "-44.43083", "America/Sao_Paulo"),("3464974", "Curitibanos", "Куритибанус", "BR", "76", "", "26", "4204806", "", "-27.28278", "-50.58444", "America/Sao_Paulo"),("3464975", "Curitiba", "Куритиба", "BR", "76", "", "18", "4106902", "", "-25.42778", "-49.27306", "America/Sao_Paulo"),("3465010", "Cunha", "", "BR", "76", "", "27", "3513603", "", "-23.07444", "-44.95972", "America/Sao_Paulo"),("3465038", "Cuiabá", "Куяба", "BR", "76", "", "14", "5103403", "", "-15.59611", "-56.09667", "America/Cuiaba"),("3465059", "Cubatão", "", "BR", "76", "", "27", "3513504", "", "-23.895", "-46.42528", "America/Sao_Paulo"),("3465071", "Cruzília", "", "BR", "76", "", "15", "3120805", "", "-21.83861", "-44.80833", "America/Sao_Paulo"),("3465083", "Cruzeiro do Oeste", "", "BR", "76", "", "18", "4106605", "", "-23.785", "-53.07333", "America/Sao_Paulo"),("3465090", "Cruzeiro", "", "BR", "76", "", "27", "3513405", "", "-22.57316", "-44.97108", "America/Sao_Paulo"),("3465105", "Cruz das Almas", "", "BR", "76", "", "05", "2909802", "", "-12.67", "-39.10194", "America/Bahia"),("3465108", "Cruz Alta", "Крус-Алта", "BR", "76", "", "23", "4306106", "", "-28.63861", "-53.60639", "America/Sao_Paulo"),("3465145", "Crixás", "", "BR", "76", "", "29", "5206404", "", "-14.54889", "-49.96917", "America/Sao_Paulo"),("3465154", "Cristinápolis", "", "BR", "76", "", "28", "2801702", "", "-11.47556", "-37.75528", "America/Maceio"),("3465164", "Cristalina", "Кристалина", "BR", "76", "", "29", "5206206", "", "-16.76769", "-47.6153", "America/Sao_Paulo"),("3465196", "Criciúma", "Крисиума", "BR", "76", "", "26", "4204608", "", "-28.6775", "-49.36972", "America/Sao_Paulo"),("3465209", "Cravinhos", "", "BR", "76", "", "27", "3513108", "", "-21.34028", "-47.72944", "America/Sao_Paulo"),("3465228", "Coxim", "Кошин", "BR", "76", "", "11", "5003306", "", "-18.50667", "-54.76", "America/Campo_Grande"),("3465284", "Cotia", "", "BR", "76", "", "27", "3513009", "", "-23.60389", "-46.91917", "America/Sao_Paulo"),("3465303", "Costa Rica", "", "BR", "76", "", "11", "5004304", "", "-23.41667", "-54.65", "America/Campo_Grande"),("3465320", "Cosmópolis", "", "BR", "76", "", "27", "3512803", "", "-22.64583", "-47.19611", "America/Sao_Paulo"),("3465329", "Coruripe", "", "BR", "76", "", "02", "2702306", "", "-10.12556", "-36.17556", "America/Maceio"),("3465330", "Corupá", "", "BR", "76", "BR", "26", "4204509", "", "-26.42528", "-49.24306", "America/Sao_Paulo"),("3465342", "Corumbá", "Корумба", "BR", "76", "", "11", "5003207", "", "-19.00917", "-57.65333", "America/Campo_Grande"),("3465373", "Correntina", "", "BR", "76", "", "05", "2909307", "", "-13.34333", "-44.63667", "America/Bahia"),("3465409", "Correia Pinto", "", "BR", "76", "", "26", "4204558", "", "-27.58472", "-50.36111", "America/Sao_Paulo"),("3465459", "Coronel Vivida", "", "BR", "76", "", "18", "4106506", "", "-25.97972", "-52.56778", "America/Sao_Paulo"),("3465476", "Coronel Fabriciano", "Коронел-Фабрисиану", "BR", "76", "", "15", "3119401", "", "-19.51861", "-42.62889", "America/Sao_Paulo"),("3465487", "Coromandel", "", "BR", "76", "", "15", "3119302", "", "-18.47333", "-47.20028", "America/Sao_Paulo"),("3465508", "Cornélio Procópio", "", "BR", "76", "", "18", "4106407", "", "-23.18111", "-50.64667", "America/Sao_Paulo"),("3465512", "Corinto", "Коринто", "BR", "76", "", "15", "3119104", "", "-18.38083", "-44.45639", "America/Sao_Paulo"),("3465524", "Cordeirópolis", "", "BR", "76", "", "27", "3512407", "", "-22.48194", "-47.45667", "America/Sao_Paulo"),("3465527", "Cordeiro", "", "BR", "76", "", "21", "3301504", "", "-22.02861", "-42.36083", "America/Sao_Paulo"),("3465536", "Corbélia", "", "BR", "76", "", "18", "4106308", "", "-24.79889", "-53.30667", "America/Sao_Paulo"),("3465541", "Coração de Maria", "", "BR", "76", "", "05", "2908903", "", "-12.23333", "-38.75", "America/Bahia"),("3465542", "Coração de Jesus", "", "BR", "76", "", "15", "3118809", "", "-16.68528", "-44.365", "America/Sao_Paulo"),("3465624", "Contagem", "Контажен", "BR", "76", "", "15", "3118601", "", "-19.93167", "-44.05361", "America/Sao_Paulo"),("3465639", "Conselheiro Pena", "", "BR", "76", "", "15", "3118403", "", "-19.17222", "-41.47222", "America/Sao_Paulo"),("3465644", "Conselheiro Lafaiete", "Консельейру-Лафаети", "BR", "76", "", "15", "3118304", "", "-20.66028", "-43.78611", "America/Sao_Paulo"),("3465671", "Congonhas", "Конгоньяс", "BR", "76", "", "15", "3118007", "", "-20.50525", "-43.8588", "America/Sao_Paulo"),("3465713", "Conde", "", "BR", "76", "", "05", "2908606", "", "-11.81361", "-37.61056", "America/Bahia"),("3465721", "Concórdia", "Конкордия", "BR", "76", "", "26", "4204301", "", "-27.23417", "-52.02778", "America/Sao_Paulo"),("3465729", "Conchas", "", "BR", "76", "", "27", "3512308", "", "-23.01528", "-48.01056", "America/Sao_Paulo"),("3465731", "Conchal", "", "BR", "76", "", "27", "3512209", "", "-22.33028", "-47.1725", "America/Sao_Paulo"),("3465737", "Conceição do Rio Verde", "", "BR", "76", "", "15", "3117702", "", "-21.88083", "-45.08528", "America/Sao_Paulo"),("3465745", "Conceição do Mato Dentro", "", "BR", "76", "", "15", "3117504", "", "-19.03722", "-43.425", "America/Sao_Paulo"),("3465748", "Conceição do Coité", "", "BR", "76", "", "05", "2908408", "", "-11.56389", "-39.28278", "America/Bahia"),("3465752", "Conceição do Almeida", "", "BR", "76", "", "05", "2908309", "", "-12.77944", "-39.17", "America/Bahia"),("3465758", "Conceição do Jacuípe", "", "BR", "76", "", "05", "2908507", "", "-12.31667", "-38.76667", "America/Bahia"),("3465764", "Conceição das Alagoas", "", "BR", "76", "", "15", "3117306", "", "-19.91472", "-48.38833", "America/Sao_Paulo"),("3465767", "Conceição da Feira", "", "BR", "76", "", "05", "2908200", "", "-12.50583", "-38.99861", "America/Bahia"),("3465769", "Conceição da Barra", "", "BR", "76", "", "08", "3201605", "", "-18.59333", "-39.73222", "America/Sao_Paulo"),("3465881", "Colorado", "", "BR", "76", "", "18", "4105904", "", "-22.8375", "-51.97306", "America/Sao_Paulo"),("3465927", "Colombo", "Коломбо", "BR", "76", "", "18", "4105805", "", "-25.29167", "-49.22417", "America/Sao_Paulo"),("3465944", "Colatina", "Колатина", "BR", "76", "", "08", "3201506", "", "-19.53944", "-40.63056", "America/Sao_Paulo"),("3466005", "Cocal", "", "BR", "76", "", "26", "4204251", "", "-28.60321", "-49.32767", "America/Sao_Paulo"),("3466041", "Coaraci", "", "BR", "76", "", "05", "2908002", "", "-14.64083", "-39.55111", "America/Bahia"),("3466046", "Clevelândia", "", "BR", "76", "", "18", "4105706", "", "-26.39583", "-52.47083", "America/Sao_Paulo"),("3466062", "Cláudio", "", "BR", "76", "", "15", "3116605", "", "-20.44333", "-44.76583", "America/Sao_Paulo"),("3466134", "Cipó", "", "BR", "76", "", "05", "2907905", "", "-11.09972", "-38.51361", "America/Bahia"),("3466165", "Cidreira", "", "BR", "76", "", "23", "4305454", "", "-30.18111", "-50.20556", "America/Sao_Paulo"),("3466171", "Cícero Dantas", "", "BR", "76", "", "05", "2907806", "", "-10.6", "-38.38333", "America/Bahia"),("3466174", "Cianorte", "Сианорте", "BR", "76", "", "18", "4105508", "", "-23.66333", "-52.605", "America/Sao_Paulo"),("3466187", "Chuí", "", "BR", "76", "BR", "23", "4305439", "", "-33.69111", "-53.45667", "America/Sao_Paulo"),("3466196", "Chopinzinho", "", "BR", "76", "", "18", "4105409", "", "-25.85583", "-52.52333", "America/Sao_Paulo"),("3466261", "Charqueadas", "", "BR", "76", "", "23", "4305355", "", "-29.95472", "-51.62528", "America/Sao_Paulo"),("3466267", "Charqueada", "", "BR", "76", "", "27", "3511706", "", "-22.50972", "-47.77806", "America/Sao_Paulo"),("3466296", "Chapecó", "Шапеко", "BR", "76", "", "26", "4204202", "", "-27.09639", "-52.61833", "America/Sao_Paulo"),("3466307", "Chapada dos Guimarães", "", "BR", "76", "", "14", "5103007", "", "-15.46056", "-55.74972", "America/Cuiaba"),("3466395", "Cerro Largo", "", "BR", "76", "", "23", "4305207", "", "-28.14861", "-54.73806", "America/Sao_Paulo"),("3466429", "Cerquilho", "", "BR", "76", "", "27", "3511508", "", "-23.165", "-47.74361", "America/Sao_Paulo"),("3466430", "Cerqueira César", "", "BR", "76", "", "27", "3511409", "", "-23.03556", "-49.16611", "America/Sao_Paulo"),("3466436", "Ceres", "", "BR", "76", "", "29", "5205406", "", "-15.30833", "-49.59833", "America/Sao_Paulo"),("3466462", "Centralina", "", "BR", "76", "", "15", "3115805", "", "-18.58389", "-49.19944", "America/Sao_Paulo"),("3466470", "Centenário do Sul", "", "BR", "76", "", "18", "4105102", "", "-22.82111", "-51.59528", "America/Sao_Paulo"),("3466481", "Celso Ramos", "", "BR", "76", "", "26", "4204152", "", "-27.63444", "-51.33639", "America/Sao_Paulo"),("3466537", "Caxias do Sul", "Кашиас-ду-Сул", "BR", "76", "", "23", "4305108", "", "-29.16806", "-51.17944", "America/Sao_Paulo"),("3466547", "Caxambu", "", "BR", "76", "", "15", "3115508", "", "-21.97722", "-44.9325", "America/Sao_Paulo"),("3466641", "Catu", "", "BR", "76", "", "05", "2907509", "", "-12.35306", "-38.37889", "America/Bahia"),("3466692", "Catanduva", "Катандува", "BR", "76", "", "27", "3511102", "", "-21.13778", "-48.97278", "America/Sao_Paulo"),("3466696", "Catalão", "", "BR", "76", "", "29", "5205109", "", "-18.16583", "-47.94639", "America/Sao_Paulo"),("3466698", "Cataguases", "Катагуазис", "BR", "76", "", "15", "3115300", "", "-21.38917", "-42.69667", "America/Sao_Paulo"),("3466703", "Castro Alves", "", "BR", "76", "", "05", "2907301", "", "-12.76556", "-39.42833", "America/Bahia"),("3466704", "Castro", "", "BR", "76", "", "18", "4104907", "", "-24.78927", "-50.01225", "America/Sao_Paulo"),("3466708", "Castilho", "", "BR", "76", "", "27", "3511003", "", "-20.87222", "-51.4875", "America/Sao_Paulo"),("3466723", "Castelo", "Каштелу", "BR", "76", "", "08", "3201407", "", "-20.60361", "-41.18472", "America/Sao_Paulo"),("3466750", "Cassilândia", "", "BR", "76", "", "11", "5002902", "", "-19.11333", "-51.73417", "America/Campo_Grande"),("3466752", "Cássia", "", "BR", "76", "", "15", "3115102", "", "-20.58306", "-46.92194", "America/Sao_Paulo"),("3466763", "Casimiro de Abreu", "", "BR", "76", "", "21", "3301306", "", "-22.48056", "-42.20417", "America/Sao_Paulo"),("3466779", "Cascavel", "Каскавел", "BR", "76", "", "18", "4104808", "", "-24.95583", "-53.45528", "America/Sao_Paulo"),("3466824", "Casa Branca", "", "BR", "76", "", "27", "3510807", "", "-21.77389", "-47.08639", "America/Sao_Paulo"),("3466900", "Carmo do Rio Verde", "", "BR", "76", "", "29", "5205000", "", "-15.35361", "-49.7075", "America/Sao_Paulo"),("3466901", "Carmo do Rio Claro", "", "BR", "76", "", "15", "3114402", "", "-20.97194", "-46.11889", "America/Sao_Paulo"),("3466902", "Carmo do Paranaíba", "", "BR", "76", "", "15", "3114303", "", "-19.00083", "-46.31611", "America/Sao_Paulo"),("3466903", "Carmo do Cajuru", "", "BR", "76", "", "15", "3114204", "", "-20.18417", "-44.77111", "America/Sao_Paulo"),("3466913", "Carmo", "", "BR", "76", "", "21", "3301207", "", "-21.93361", "-42.60861", "America/Sao_Paulo"),("3466931", "Carlos Chagas", "", "BR", "76", "", "15", "3113701", "", "-17.70306", "-40.76639", "America/Sao_Paulo"),("3466933", "Carlos Barbosa", "", "BR", "76", "", "23", "4304804", "", "-29.2975", "-51.50361", "America/Sao_Paulo"),("3466941", "Carira", "", "BR", "76", "", "28", "2801405", "", "-10.36083", "-37.70111", "America/Maceio"),("3466950", "Carinhanha", "", "BR", "76", "", "05", "2907103", "", "-14.30472", "-43.765", "America/Bahia"),("3466970", "Cardoso", "", "BR", "76", "", "27", "3510708", "", "-20.08194", "-49.91417", "America/Sao_Paulo"),("3466978", "Carazinho", "Каразинью", "BR", "76", "", "23", "4304705", "", "-28.28389", "-52.78639", "America/Sao_Paulo"),("3466988", "Caratinga", "Каратинга", "BR", "76", "", "15", "3113404", "", "-19.78972", "-42.13917", "America/Sao_Paulo"),("3466993", "Caarapó", "", "BR", "76", "", "11", "5002407", "", "-22.63417", "-54.82222", "America/Campo_Grande"),("3466998", "Carapicuíba", "", "BR", "76", "", "27", "3510609", "", "-23.52272", "-46.835", "America/Sao_Paulo"),("3467012", "Carangola", "Карангола", "BR", "76", "", "15", "3113305", "", "-20.73306", "-42.02944", "America/Sao_Paulo"),("3467026", "Carandaí", "", "BR", "76", "", "15", "3113206", "", "-20.95361", "-43.80639", "America/Sao_Paulo"),("3467042", "Carambeí", "", "BR", "76", "", "18", "4104659", "", "-24.9526", "-50.1159", "America/Sao_Paulo"),("3467078", "Caraí", "", "BR", "76", "", "15", "3113008", "", "-17.18889", "-41.69472", "America/Sao_Paulo"),("3467081", "Caraguatatuba", "Карагуататуба", "BR", "76", "", "27", "3510500", "", "-23.62028", "-45.41306", "America/Sao_Paulo"),("3467197", "Capivari", "Капивари", "BR", "76", "", "27", "3510401", "", "-22.995", "-47.50778", "America/Sao_Paulo"),("3467261", "Capinzal", "", "BR", "76", "", "26", "4203907", "", "-27.34361", "-51.61194", "America/Sao_Paulo"),("3467263", "Capinópolis", "", "BR", "76", "", "15", "3112604", "", "-18.68194", "-49.56972", "America/Sao_Paulo"),("3467272", "Capim Grosso", "", "BR", "76", "", "05", "2906873", "", "-11.38111", "-40.01278", "America/Bahia"),("3467305", "Capelinha", "Капелинья", "BR", "76", "", "15", "3112307", "", "-17.69139", "-42.51583", "America/Sao_Paulo"),("3467314", "Capela do Alto", "", "BR", "76", "", "27", "3510302", "", "-23.47056", "-47.73472", "America/Sao_Paulo"),("3467319", "Capela", "", "BR", "76", "", "28", "2801306", "", "-10.50333", "-37.05278", "America/Maceio"),("3467362", "Capão da Canoa", "", "BR", "76", "", "23", "4304630", "", "-29.74556", "-50.00972", "America/Sao_Paulo"),("3467371", "Capâo Bonito", "", "BR", "76", "", "27", "3510203", "", "-24.00583", "-48.34944", "America/Sao_Paulo"),("3467445", "Cantagalo", "", "BR", "76", "", "21", "3301108", "", "-21.98111", "-42.36806", "America/Sao_Paulo"),("3467452", "Canoinhas", "", "BR", "76", "", "26", "4203808", "", "-26.17722", "-50.39", "America/Sao_Paulo"),("3467467", "Canoas", "Каноас", "BR", "76", "", "23", "4304606", "", "-29.91778", "-51.18361", "America/Sao_Paulo"),("3467512", "Canguçu", "", "BR", "76", "", "23", "4304507", "", "-31.395", "-52.67556", "America/Sao_Paulo"),("3467530", "Canela", "Канела", "BR", "76", "", "23", "4304408", "", "-29.35622", "-50.81357", "America/Sao_Paulo"),("3467542", "Cândido Mota", "", "BR", "76", "", "27", "3510005", "", "-22.74639", "-50.38694", "America/Sao_Paulo"),("3467545", "Cândido de Abreu", "", "BR", "76", "", "18", "4104402", "", "-24.56694", "-51.33333", "America/Sao_Paulo"),("3467550", "Candelária", "", "BR", "76", "", "23", "4304200", "", "-29.66917", "-52.78889", "America/Sao_Paulo"),("3467577", "Canavieiras", "", "BR", "76", "", "05", "2906303", "", "-15.675", "-38.94722", "America/Bahia"),("3467604", "Canarana", "", "BR", "76", "", "05", "2906204", "", "-11.68472", "-41.76889", "America/Bahia"),("3467609", "Cananéia", "", "BR", "76", "", "27", "3509908", "", "-25.01472", "-47.92667", "America/Sao_Paulo"),("3467673", "Campo Verde", "", "BR", "76", "", "11", "5004908", "", "-20.41667", "-54.06667", "America/Campo_Grande"),("3467677", "Campos Novos", "Кампус-Новус", "BR", "76", "", "26", "4203600", "", "-27.40167", "-51.225", "America/Sao_Paulo"),("3467680", "Campos Gerais", "Кампус-Жерайс", "BR", "76", "", "15", "3111606", "", "-21.235", "-45.75861", "America/Sao_Paulo"),("3467684", "Campos do Jordão", "Кампус-ду-Жордау", "BR", "76", "", "27", "3509700", "", "-22.73944", "-45.59139", "America/Sao_Paulo"),("3467687", "Campos Belos", "", "BR", "76", "", "29", "5204904", "", "-13.03667", "-46.77167", "America/Sao_Paulo"),("3467688", "Campos Altos", "", "BR", "76", "", "15", "3111507", "", "-19.69611", "-46.17139", "America/Sao_Paulo"),("3467693", "Campos dos Goytacazes", "Кампос", "BR", "76", "", "21", "3301009", "", "-21.75227", "-41.33044", "America/Sao_Paulo"),("3467717", "Campo Mourão", "", "BR", "76", "", "18", "4104303", "", "-24.04309", "-52.37929", "America/Sao_Paulo"),("3467736", "Campo Largo", "", "BR", "76", "", "18", "4104204", "", "-25.45955", "-49.53014", "America/Sao_Paulo"),("3467747", "Campo Grande", "Кампу-Гранди", "BR", "76", "", "11", "5002704", "", "-20.44278", "-54.64639", "America/Campo_Grande"),("3467760", "Campo Formoso", "", "BR", "76", "", "05", "2906006", "", "-10.5075", "-40.32139", "America/Bahia"),("3467780", "Campo do Brito", "", "BR", "76", "", "28", "2801009", "", "-10.73333", "-37.49333", "America/Maceio"),("3467796", "Campo Belo", "Кампу-Белу", "BR", "76", "", "15", "3111200", "", "-20.89722", "-45.27722", "America/Sao_Paulo"),("3467860", "Campina Verde", "", "BR", "76", "", "15", "3111101", "", "-19.53791", "-49.48813", "America/Sao_Paulo"),("3467865", "Campinas", "Кампинас", "BR", "76", "", "27", "3509502", "", "-22.90556", "-47.06083", "America/Sao_Paulo"),("3467877", "Campina Grande do Sul", "Кампина-Гранде-ду-Сул", "BR", "76", "", "18", "4104006", "", "-25.30556", "-49.05528", "America/Sao_Paulo"),("3467908", "Campestre", "", "BR", "76", "", "15", "3111002", "", "-21.71111", "-46.24639", "America/Sao_Paulo"),("3467928", "Campanha", "", "BR", "76", "", "15", "3110905", "", "-21.83611", "-45.40056", "America/Sao_Paulo"),("3467952", "Cambuquira", "", "BR", "76", "", "15", "3110707", "", "-21.85222", "-45.29583", "America/Sao_Paulo"),("3467956", "Cambuí", "", "BR", "76", "", "15", "3110608", "", "-22.61222", "-46.0575", "America/Sao_Paulo"),("3467962", "Cambuci", "", "BR", "76", "", "21", "3300902", "", "-21.57528", "-41.91111", "America/Sao_Paulo"),("3467978", "Cambé", "", "BR", "76", "", "18", "4103701", "", "-23.27583", "-51.27833", "America/Sao_Paulo"),("3467985", "Cambará", "", "BR", "76", "", "18", "4103602", "", "-23.04639", "-50.07361", "America/Sao_Paulo"),("3468014", "Camaquã", "", "BR", "76", "", "23", "4303509", "", "-30.85111", "-51.81222", "America/Sao_Paulo"),("3468020", "Camapuã", "", "BR", "76", "", "11", "5002605", "", "-19.53139", "-54.04389", "America/Campo_Grande"),("3468023", "Camanducaia", "", "BR", "76", "", "15", "3110509", "", "-22.75528", "-46.14472", "America/Sao_Paulo"),("3468025", "Camamu", "", "BR", "76", "", "05", "2905800", "", "-13.94472", "-39.10389", "America/Bahia"),("3468031", "Camaçari", "", "BR", "76", "", "05", "2905701", "", "-12.6975", "-38.32417", "America/Bahia"),("3468100", "Caldas Novas", "", "BR", "76", "", "29", "5204508", "", "-17.74431", "-48.62789", "America/Sao_Paulo"),("3468121", "Cajuru", "", "BR", "76", "", "27", "3509403", "", "-21.27528", "-47.30417", "America/Sao_Paulo"),("3468157", "Cajati", "", "BR", "76", "", "27", "3509254", "", "-24.73611", "-48.12278", "America/Sao_Paulo"),("3468158", "Cajamar", "", "BR", "76", "", "27", "3509205", "", "-23.35611", "-46.87694", "America/Sao_Paulo"),("3468215", "Caieiras", "", "BR", "76", "", "27", "3509007", "", "-23.36417", "-46.74056", "America/Sao_Paulo"),("3468234", "Caiapônia", "", "BR", "76", "", "29", "5204409", "", "-16.95667", "-51.81028", "America/Sao_Paulo"),("3468296", "Cafelândia", "", "BR", "76", "", "27", "3508801", "", "-21.8025", "-49.61", "America/Sao_Paulo"),("3468314", "Cafarnaum", "", "BR", "76", "", "05", "2905305", "", "-11.69361", "-41.46833", "America/Bahia"),("3468317", "Caetité", "Каэтите", "BR", "76", "", "05", "2905206", "", "-14.06944", "-42.475", "America/Bahia"),("3468327", "Caeté", "Каэте", "BR", "76", "", "15", "3110004", "", "-19.88", "-43.66972", "America/Sao_Paulo"),("3468349", "Caculé", "", "BR", "76", "", "05", "2905008", "", "-14.50333", "-42.22222", "America/Bahia"),("3468352", "Caçu", "", "BR", "76", "", "29", "5204300", "", "-18.55667", "-51.13083", "America/Sao_Paulo"),("3468353", "Caconde", "", "BR", "76", "", "27", "3508702", "", "-21.52944", "-46.64389", "America/Sao_Paulo"),("3468376", "Cachoeiro de Itapemirim", "Кашуэйру-ди-Итапемирин", "BR", "76", "", "08", "3201209", "", "-20.84889", "-41.11278", "America/Sao_Paulo"),("3468403", "Cachoeirinha", "", "BR", "76", "", "23", "4303103", "", "-29.95111", "-51.09389", "America/Sao_Paulo"),("3468425", "Cachoeiras de Macacu", "", "BR", "76", "", "21", "3300803", "", "-22.4625", "-42.65306", "America/Sao_Paulo"),("3468436", "Cachoeira do Sul", "Кашуэйра-ду-Сул", "BR", "76", "", "23", "4303004", "", "-30.03917", "-52.89389", "America/Sao_Paulo"),("3468535", "Cachoeira", "", "BR", "76", "", "05", "2904902", "", "-12.60139", "-38.96576", "America/Bahia"),("3468553", "Cacequi", "", "BR", "76", "", "23", "4302907", "", "-29.88361", "-54.825", "America/Sao_Paulo"),("3468560", "Caçapava do Sul", "", "BR", "76", "", "23", "4302808", "", "-30.51436", "-53.48496", "America/Sao_Paulo"),("3468562", "Caçapava", "", "BR", "76", "", "27", "3508504", "", "-23.10083", "-45.70694", "America/Sao_Paulo"),("3468570", "Caçador", "Касадор", "BR", "76", "", "26", "4203006", "", "-26.77528", "-51.015", "America/Sao_Paulo"),("3468592", "Cabreúva", "Кабреува", "BR", "76", "", "27", "3508405", "", "-23.3075", "-47.13278", "America/Sao_Paulo"),("3468615", "Cabo Frio", "Кабу-Фриу", "BR", "76", "", "21", "3300704", "", "-22.88717", "-42.02622", "America/Sao_Paulo"),("3468704", "Butiá", "", "BR", "76", "", "23", "4302709", "", "-30.11972", "-51.96222", "America/Sao_Paulo"),("3468720", "Buritizeiro", "", "BR", "76", "", "15", "3109402", "", "-17.35111", "-44.96222", "America/Sao_Paulo"),("3468732", "Buritis", "", "BR", "76", "", "15", "3109303", "", "-15.61778", "-46.42333", "America/Sao_Paulo"),("3468745", "Buriti Alegre", "", "BR", "76", "", "29", "5203906", "", "-18.14", "-49.04028", "America/Sao_Paulo"),("3468789", "Buritama", "", "BR", "76", "", "27", "3508108", "", "-21.06611", "-50.14722", "America/Sao_Paulo"),("3468802", "Buri", "", "BR", "76", "", "27", "3508009", "", "-23.7975", "-48.59278", "America/Sao_Paulo"),("3468823", "Boquim", "", "BR", "76", "", "28", "2800670", "", "-11.14694", "-37.62056", "America/Maceio"),("3468858", "Buerarema", "", "BR", "76", "", "05", "2904704", "", "-14.95944", "-39.29972", "America/Bahia"),("3468869", "Bueno Brandão", "", "BR", "76", "", "15", "3109105", "", "-22.44083", "-46.35083", "America/Sao_Paulo"),("3468879", "Brusque", "", "BR", "76", "", "26", "4202909", "", "-27.09795", "-48.91281", "America/Sao_Paulo"),("3468893", "Brumado", "Брумаду", "BR", "76", "", "05", "2904605", "", "-14.20361", "-41.66528", "America/Bahia"),("3468894", "Brumadinho", "", "BR", "76", "", "15", "3109006", "", "-20.14333", "-44.19972", "America/Sao_Paulo"),("3468899", "Brotas", "", "BR", "76", "", "27", "3507902", "", "-22.28417", "-48.12667", "America/Sao_Paulo"),("3468902", "Brodósqui", "", "BR", "76", "", "27", "3507803", "", "-20.99139", "-47.65861", "America/Sao_Paulo"),("3469057", "Brasília de Minas", "", "BR", "76", "", "15", "3108602", "", "-16.20639", "-44.43333", "America/Sao_Paulo"),("3469058", "Brasília", "Бразилия", "BR", "76", "", "07", "5300108", "", "-15.77972", "-47.92972", "America/Sao_Paulo"),("3469092", "Bragança Paulista", "Браганса-Паулиста", "BR", "76", "", "27", "3507605", "", "-22.9527", "-46.54418", "America/Sao_Paulo"),("3469115", "Braço do Norte", "", "BR", "76", "", "26", "4202800", "", "-28.275", "-49.16556", "America/Sao_Paulo"),("3469136", "Botucatu", "Ботукату", "BR", "76", "", "27", "3507506", "", "-22.88583", "-48.445", "America/Sao_Paulo"),("3469140", "Botelhos", "", "BR", "76", "", "15", "3108404", "", "-21.63333", "-46.395", "America/Sao_Paulo"),("3469169", "Borda da Mata", "", "BR", "76", "", "15", "3108305", "", "-22.27417", "-46.16528", "America/Sao_Paulo"),("3469173", "Borborema", "", "BR", "76", "", "27", "3507407", "", "-21.61972", "-49.07361", "America/Sao_Paulo"),("3469190", "Boquira", "", "BR", "76", "", "05", "2904100", "", "-12.82306", "-42.73056", "America/Bahia"),("3469294", "Bonito", "", "BR", "76", "", "11", "5002209", "", "-21.12111", "-56.48194", "America/Campo_Grande"),("3469374", "Bom Sucesso", "", "BR", "76", "", "15", "3108008", "", "-21.03306", "-44.75806", "America/Sao_Paulo"),("3469421", "Bom Jesus dos Perdões", "", "BR", "76", "", "27", "3507100", "", "-23.135", "-46.46528", "America/Sao_Paulo"),("3469425", "Bom Jesus do Itabapoana", "Бон-Жезус-ду-Итабапоана", "BR", "76", "", "21", "3300605", "", "-21.13389", "-41.67972", "America/Sao_Paulo"),("3469426", "Bom Jesus do Galho", "", "BR", "76", "", "15", "3107802", "", "-19.82889", "-42.31611", "America/Sao_Paulo"),("3469437", "Bom Jesus da Lapa", "Бон-Жезус-да-Лапа", "BR", "76", "", "05", "2903904", "", "-13.255", "-43.41806", "America/Bahia"),("3469516", "Bom Despacho", "", "BR", "76", "", "15", "3107406", "", "-19.73639", "-45.25222", "America/Sao_Paulo"),("3469540", "Boituva", "", "BR", "76", "", "27", "3507001", "", "-23.28333", "-47.67222", "America/Sao_Paulo"),("3469601", "Bocaiúva", "", "BR", "76", "", "15", "3107307", "", "-17.10778", "-43.815", "America/Sao_Paulo"),("3469910", "Boa Esperança do Sul", "", "BR", "76", "", "27", "3506706", "", "-21.9925", "-48.39083", "America/Sao_Paulo"),("3469932", "Boa Esperança", "Боа-Эсперанса", "BR", "76", "", "15", "3107109", "", "-21.09", "-45.56583", "America/Sao_Paulo"),("3469942", "Boa Esperança", "", "BR", "76", "", "08", "3201001", "", "-18.54", "-40.29583", "America/Sao_Paulo"),("3469968", "Blumenau", "Блуменау", "BR", "76", "", "26", "4202404", "", "-26.91944", "-49.06611", "America/Sao_Paulo"),("3469984", "Biritiba Mirim", "", "BR", "76", "", "27", "3506607", "", "-23.5725", "-46.03861", "America/Sao_Paulo"),("3469989", "Birigui", "", "BR", "76", "", "27", "3506508", "", "-21.28861", "-50.34", "America/Sao_Paulo"),("3470003", "Biguaçu", "", "BR", "76", "", "26", "4202305", "", "-27.49417", "-48.65556", "America/Sao_Paulo"),("3470025", "Bicas", "", "BR", "76", "", "15", "3106903", "", "-21.72528", "-43.05944", "America/Sao_Paulo"),("3470044", "Betim", "Бетин", "BR", "76", "", "15", "3106705", "", "-19.96778", "-44.19833", "America/Sao_Paulo"),("3470052", "Bertioga", "", "BR", "76", "", "27", "3506359", "", "-23.85444", "-46.13861", "America/Sao_Paulo"),("3470059", "Bernardino de Campos", "", "BR", "76", "", "27", "3506300", "", "-23.01306", "-49.47417", "America/Sao_Paulo"),("3470073", "Bento Gonçalves", "", "BR", "76", "", "23", "4302105", "", "-29.17139", "-51.51917", "America/Sao_Paulo"),("3470117", "Belo Oriente", "", "BR", "76", "", "15", "3106309", "", "-19.22", "-42.48361", "America/Sao_Paulo"),("3470127", "Belo Horizonte", "Белу-Оризонти", "BR", "76", "", "15", "3106200", "", "-19.92083", "-43.93778", "America/Sao_Paulo"),("3470137", "Belmonte", "", "BR", "76", "", "05", "2903409", "", "-15.86104", "-38.88143", "America/Bahia"),("3470142", "Belford Roxo", "Белфорд-Рошу", "BR", "76", "", "21", "3300456", "", "-22.76417", "-43.39944", "America/Sao_Paulo"),("3470162", "Bela Vista do Paraíso", "", "BR", "76", "", "18", "4102802", "", "-22.99667", "-51.19056", "America/Sao_Paulo"),("3470164", "Bela Vista de Goiás", "", "BR", "76", "", "29", "5203302", "", "-16.97278", "-48.95333", "America/Sao_Paulo"),("3470177", "Bela Vista", "", "BR", "76", "", "11", "5002100", "", "-22.10889", "-56.52111", "America/Campo_Grande"),("3470264", "Bebedouro", "", "BR", "76", "", "27", "3506102", "", "-20.94944", "-48.47917", "America/Sao_Paulo"),("3470279", "Bauru", "Бауру", "BR", "76", "", "27", "3506003", "", "-22.31472", "-49.06056", "America/Sao_Paulo"),("3470324", "Batatais", "Бататайс", "BR", "76", "", "27", "3505906", "", "-20.89111", "-47.585", "America/Sao_Paulo"),("3470338", "Bataiporã", "", "BR", "76", "", "11", "5002001", "", "-22.29528", "-53.27111", "America/Campo_Grande"),("3470341", "Bastos", "", "BR", "76", "", "27", "3505807", "", "-21.92194", "-50.73389", "America/Sao_Paulo"),("3470353", "Barueri", "Баруэри", "BR", "76", "", "27", "3505708", "", "-23.51056", "-46.87611", "America/Sao_Paulo"),("3470369", "Barroso", "", "BR", "76", "", "15", "3105905", "", "-21.18694", "-43.97583", "America/Sao_Paulo"),("3470409", "Barro Alto", "", "BR", "76", "", "29", "5203203", "", "-14.97083", "-48.91583", "America/Sao_Paulo"),("3470410", "Barro Alto", "", "BR", "76", "", "05", "2903235", "", "-11.76083", "-41.91167", "America/Bahia"),("3470428", "Barrinha", "", "BR", "76", "", "27", "3505609", "", "-21.19361", "-48.16389", "America/Sao_Paulo"),("3470451", "Barretos", "Барретус", "BR", "76", "", "27", "3505500", "", "-20.55722", "-48.56778", "America/Sao_Paulo"),("3470470", "Barreiro do Jaíba", "", "BR", "76", "", "15", "3171030", "", "-15.61532", "-43.59187", "America/Sao_Paulo"),("3470583", "Barreiras", "Баррейрас", "BR", "76", "", "05", "2903201", "", "-12.15278", "-44.99", "America/Bahia"),("3470597", "Barra Velha", "", "BR", "76", "", "26", "4202107", "", "-26.63222", "-48.68472", "America/Sao_Paulo"),("3470636", "Barra Mansa", "Барра-Манса", "BR", "76", "", "21", "3300407", "", "-22.54417", "-44.17139", "America/Sao_Paulo"),("3470674", "Barra dos Coqueiros", "", "BR", "76", "", "28", "2800605", "", "-10.90889", "-37.03861", "America/Maceio"),("3470691", "Barra do Piraí", "", "BR", "76", "", "21", "3300308", "", "-22.47", "-43.82556", "America/Sao_Paulo"),("3470709", "Barra do Garças", "Барра-ду-Гарсас", "BR", "76", "", "14", "5101803", "", "-15.89", "-52.25667", "America/Cuiaba"),("3470718", "Barra do Bugres", "", "BR", "76", "", "14", "5101704", "", "-15.0725", "-57.18111", "America/Cuiaba"),("3470730", "Barra de São Francisco", "Барра-де-Сан-Франциско", "BR", "76", "", "08", "3200904", "", "-18.755", "-40.89083", "America/Sao_Paulo"),("3470744", "Barra da Estiva", "", "BR", "76", "", "05", "2902807", "", "-13.62611", "-41.32694", "America/Bahia"),("3470776", "Barra Bonita", "", "BR", "76", "", "27", "3505302", "", "-22.49472", "-48.55806", "America/Sao_Paulo"),("3470821", "Barra", "Барра", "BR", "76", "", "05", "2902708", "", "-11.08944", "-43.14167", "America/Bahia"),("3470825", "Bariri", "", "BR", "76", "", "27", "3505203", "", "-22.07444", "-48.74028", "America/Sao_Paulo"),("3470858", "Barbacena", "", "BR", "76", "", "15", "3105608", "", "-21.22583", "-43.77361", "America/Sao_Paulo"),("3470878", "Barão de Cocais", "", "BR", "76", "", "15", "3105400", "", "-19.94583", "-43.48722", "America/Sao_Paulo"),("3470912", "Bandeirantes", "", "BR", "76", "", "18", "4102406", "", "-23.11", "-50.3675", "America/Sao_Paulo"),("3471005", "Bambuí", "", "BR", "76", "", "15", "3105103", "", "-20.00639", "-45.97694", "America/Sao_Paulo"),("3471039", "Balneário Camboriú", "Балнеариу-Камбориу", "BR", "76", "", "26", "4202008", "", "-26.99056", "-48.63472", "America/Sao_Paulo"),("3471061", "Baixo Guandu", "", "BR", "76", "", "08", "3200805", "", "-19.51889", "-41.01583", "America/Sao_Paulo"),("3471094", "Baixa Grande", "", "BR", "76", "", "05", "2902609", "", "-11.95972", "-40.16806", "America/Bahia"),("3471196", "Bagé", "Баг", "BR", "76", "", "23", "4301602", "", "-31.33139", "-54.10694", "America/Sao_Paulo"),("3471208", "Baependi", "", "BR", "76", "", "15", "3104908", "", "-21.95889", "-44.89", "America/Sao_Paulo"),("3471210", "Bady Bassitt", "", "BR", "76", "", "27", "3504602", "", "-20.91806", "-49.44528", "America/Sao_Paulo"),("3471291", "Avaré", "", "BR", "76", "", "27", "3504503", "", "-23.09861", "-48.92583", "America/Sao_Paulo"),("3471309", "Auriflama", "", "BR", "76", "", "27", "3504206", "", "-20.68556", "-50.55472", "America/Sao_Paulo"),("3471335", "Atibaia", "Атибая", "BR", "76", "", "27", "3504107", "", "-23.11694", "-46.55028", "America/Sao_Paulo"),("3471368", "Astorga", "", "BR", "76", "", "18", "4102109", "", "-23.2325", "-51.66556", "America/Sao_Paulo"),("3471369", "Astolfo Dutra", "", "BR", "76", "", "15", "3104601", "", "-21.31528", "-42.86222", "America/Sao_Paulo"),("3471374", "Assis", "Ассис", "BR", "76", "", "27", "3504008", "", "-22.66167", "-50.41222", "America/Sao_Paulo"),("3471377", "Assaí", "", "BR", "76", "", "18", "4101903", "", "-23.37333", "-50.84139", "America/Sao_Paulo"),("3471393", "Arujá", "", "BR", "76", "", "27", "3503901", "", "-23.39611", "-46.32083", "America/Sao_Paulo"),("3471395", "Artur Nogueira", "", "BR", "76", "", "27", "3503802", "", "-22.57306", "-47.1725", "America/Sao_Paulo"),("3471422", "Arroio Grande", "", "BR", "76", "", "23", "4301305", "", "-32.2375", "-53.08694", "America/Sao_Paulo"),("3471425", "Arroio dos Ratos", "", "BR", "76", "", "23", "4301107", "", "-30.07722", "-51.72917", "America/Sao_Paulo"),("3471428", "Arroio do Meio", "", "BR", "76", "", "23", "4301008", "", "-29.40111", "-51.945", "America/Sao_Paulo"),("3471451", "Arraial do Cabo", "", "BR", "76", "", "21", "3300258", "", "-22.96611", "-42.02778", "America/Sao_Paulo"),("3471487", "Armação de Búzios", "", "BR", "76", "", "21", "3300233", "", "-22.74694", "-41.88167", "America/Sao_Paulo"),("3471522", "Arinos", "", "BR", "76", "", "15", "3104502", "", "-15.91694", "-46.10556", "America/Sao_Paulo"),("3471551", "Arenápolis", "", "BR", "76", "", "14", "5101308", "", "-14.45028", "-56.84611", "America/Cuiaba"),("3471609", "Areia Branca", "", "BR", "76", "", "28", "2800506", "", "-10.75778", "-37.31528", "America/Maceio"),("3471665", "Areal", "", "BR", "76", "", "21", "3300225", "", "-22.23056", "-43.10556", "America/Sao_Paulo"),("3471674", "Areado", "", "BR", "76", "", "15", "3104304", "", "-21.35861", "-46.14556", "America/Sao_Paulo"),("3471683", "Arcos", "Аркос", "BR", "76", "", "15", "3104205", "", "-20.28194", "-45.53944", "America/Sao_Paulo"),("3471691", "Araxá", "Араша", "BR", "76", "", "15", "3104007", "", "-19.59333", "-46.94056", "America/Sao_Paulo"),("3471697", "Araucária", "Араукария", "BR", "76", "", "18", "4101804", "", "-25.59306", "-49.41028", "America/Sao_Paulo"),("3471715", "Araruama", "Араруама", "BR", "76", "", "21", "3300209", "", "-22.87278", "-42.34306", "America/Sao_Paulo"),("3471758", "Araras", "", "BR", "76", "", "27", "3503307", "", "-22.35694", "-47.38417", "America/Sao_Paulo"),("3471766", "Araraquara", "Араракуара", "BR", "76", "", "27", "3503208", "", "-21.79444", "-48.17556", "America/Sao_Paulo"),("3471772", "Araranguá", "Арарангуа", "BR", "76", "", "26", "4201406", "", "-28.93575", "-49.49538", "America/Sao_Paulo"),("3471798", "Arapongas", "Арапонгас", "BR", "76", "", "18", "4101507", "", "-23.41944", "-51.42444", "America/Sao_Paulo"),("3471830", "Araguari", "Арагуари", "BR", "76", "", "15", "3103504", "", "-18.64722", "-48.18722", "America/Sao_Paulo"),("3471840", "Aragarças", "", "BR", "76", "", "29", "5201702", "", "-15.8975", "-52.25083", "America/Sao_Paulo"),("3471846", "Araçuaí", "Арасуаи", "BR", "76", "", "15", "3103405", "", "-16.84972", "-42.07028", "America/Sao_Paulo"),("3471848", "Aracruz", "Аракрус", "BR", "76", "", "08", "3200607", "", "-19.82028", "-40.27333", "America/Sao_Paulo"),("3471849", "Araçoiaba da Serra", "", "BR", "76", "", "27", "3502903", "", "-23.50528", "-47.61417", "America/Sao_Paulo"),("3471854", "Araci", "", "BR", "76", "", "05", "2902104", "", "-11.33333", "-38.96667", "America/Bahia"),("3471859", "Araçatuba", "Арасатуба", "BR", "76", "", "27", "3502804", "", "-21.20889", "-50.43278", "America/Sao_Paulo"),("3471872", "Aracaju", "Аракажу", "BR", "76", "", "28", "2800308", "", "-10.91111", "-37.07167", "America/Maceio"),("3471896", "Aquidauana", "", "BR", "76", "", "11", "5001102", "", "-20.47111", "-55.78722", "America/Campo_Grande"),("3471902", "Aquidabã", "", "BR", "76", "", "28", "2800209", "", "-10.28139", "-37.01861", "America/Maceio"),("3471910", "Apucarana", "", "BR", "76", "", "18", "4101408", "", "-23.55083", "-51.46083", "America/Sao_Paulo");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("3471927", "Apiaí", "", "BR", "76", "", "27", "3502705", "", "-24.50944", "-48.8425", "America/Sao_Paulo"),("3471940", "Aparecida do Taboado", "", "BR", "76", "", "11", "5001003", "", "-20.08667", "-51.09361", "America/Campo_Grande"),("3471949", "Aparecida", "Апаресида", "BR", "76", "", "27", "3502507", "", "-22.84694", "-45.22972", "America/Sao_Paulo"),("3472048", "Antonina", "", "BR", "76", "", "18", "4101200", "", "-25.42861", "-48.71194", "America/Sao_Paulo"),("3472138", "Anicuns", "", "BR", "76", "", "29", "5201306", "", "-16.46111", "-49.96167", "America/Sao_Paulo"),("3472174", "Anguera", "", "BR", "76", "", "05", "2901502", "", "-12.15111", "-39.24639", "America/Bahia"),("3472177", "Angra dos Reis", "Ангра-дус-Рейс", "BR", "76", "", "21", "3300100", "", "-23.00667", "-44.31806", "America/Sao_Paulo"),("3472234", "Angatuba", "", "BR", "76", "", "27", "3502200", "", "-23.48972", "-48.41278", "America/Sao_Paulo"),("3472245", "Andrelândia", "", "BR", "76", "", "15", "3102803", "", "-21.73972", "-44.30917", "America/Sao_Paulo"),("3472248", "Andradina", "", "BR", "76", "", "27", "3502101", "", "-20.89611", "-51.37944", "America/Sao_Paulo"),("3472254", "Andradas", "Андрадас", "BR", "76", "", "15", "3102605", "", "-22.06806", "-46.56917", "America/Sao_Paulo"),("3472284", "Anastácio", "", "BR", "76", "", "11", "5000708", "", "-20.48361", "-55.80694", "America/Campo_Grande"),("3472287", "Anápolis", "Анаполис", "BR", "76", "", "29", "5201108", "", "-16.32667", "-48.95278", "America/Sao_Paulo"),("3472304", "Ampére", "", "BR", "76", "", "18", "4101002", "", "-25.915", "-53.47278", "America/Sao_Paulo"),("3472311", "Amparo", "", "BR", "76", "", "27", "3501905", "", "-22.70111", "-46.76444", "America/Sao_Paulo"),("3472338", "Américo Brasiliense", "", "BR", "76", "", "27", "3501707", "", "-21.72444", "-48.10167", "America/Sao_Paulo"),("3472343", "Americana", "Американа", "BR", "76", "", "27", "3501608", "", "-22.73917", "-47.33139", "America/Sao_Paulo"),("3472344", "América Dourada", "", "BR", "76", "", "05", "2901155", "", "-11.45528", "-41.43611", "America/Bahia"),("3472370", "Amargosa", "", "BR", "76", "", "05", "2901007", "", "-13.03028", "-39.60472", "America/Bahia"),("3472404", "Alvorada", "", "BR", "76", "", "31", "1700707", "", "-12.48", "-49.12472", "America/Araguaina"),("3472406", "Alvinópolis", "", "BR", "76", "", "15", "3102308", "", "-20.10667", "-43.04889", "America/Sao_Paulo"),("3472417", "Álvares Machado", "", "BR", "76", "", "27", "3501301", "", "-22.07944", "-51.47194", "America/Sao_Paulo"),("3472437", "Alto Piquiri", "", "BR", "76", "", "18", "4100707", "", "-24.02806", "-53.44056", "America/Sao_Paulo"),("3472440", "Alto Paraná", "", "BR", "76", "", "18", "4100608", "", "-23.12889", "-52.31889", "America/Sao_Paulo"),("3472444", "Altãnia", "", "BR", "76", "", "18", "4100509", "", "-23.87444", "-53.90167", "America/Sao_Paulo"),("3472473", "Alto Araguaia", "", "BR", "76", "", "14", "5100300", "", "-17.31472", "-53.21528", "America/Cuiaba"),("3472485", "Altinópolis", "", "BR", "76", "", "27", "3501004", "", "-21.02556", "-47.37389", "America/Sao_Paulo"),("3472487", "Alterosa", "", "BR", "76", "", "15", "3102001", "", "-21.24917", "-46.14306", "America/Sao_Paulo"),("3472507", "Alpinópolis", "", "BR", "76", "", "15", "3101904", "", "-20.86361", "-46.38806", "America/Sao_Paulo"),("3472518", "Almirante Tamandaré", "", "BR", "76", "", "18", "4100400", "", "-25.32472", "-49.31", "America/Sao_Paulo"),("3472520", "Almenara", "Альменара", "BR", "76", "", "15", "3101706", "", "-16.18361", "-40.69444", "America/Sao_Paulo"),("3472596", "Alfredo Chaves", "", "BR", "76", "", "08", "3200300", "", "-20.635", "-40.74972", "America/Sao_Paulo"),("3472603", "Alfenas", "", "BR", "76", "", "15", "3101607", "", "-21.42917", "-45.94722", "America/Sao_Paulo"),("3472609", "Além Paraíba", "", "BR", "76", "", "15", "3101508", "", "-21.88778", "-42.70444", "America/Sao_Paulo"),("3472638", "Alegrete", "Алегрети", "BR", "76", "", "23", "4300406", "", "-29.78306", "-55.79194", "America/Sao_Paulo"),("3472666", "Alegre", "", "BR", "76", "", "08", "3200201", "", "-20.76361", "-41.53306", "America/Sao_Paulo"),("3472766", "Alagoinhas", "Алагоиньяс", "BR", "76", "", "05", "2900702", "", "-12.13556", "-38.41917", "America/Bahia"),("3472808", "Aimorés", "", "BR", "76", "", "15", "3101102", "", "-19.49583", "-41.06389", "America/Sao_Paulo"),("3472825", "Agudos", "", "BR", "76", "", "27", "3500709", "", "-22.46917", "-48.9875", "America/Sao_Paulo"),("3472848", "Águas Vermelhas", "", "BR", "76", "", "15", "3101003", "", "-15.74722", "-41.46", "America/Sao_Paulo"),("3472864", "Águas Formosas", "", "BR", "76", "", "15", "3100906", "", "-17.08222", "-40.93583", "America/Sao_Paulo"),("3472869", "Águas de Lindóia", "", "BR", "76", "", "27", "3500501", "", "-22.47639", "-46.63278", "America/Sao_Paulo"),("3472969", "Aguaí", "", "BR", "76", "", "27", "3500303", "", "-22.05944", "-46.97861", "America/Sao_Paulo"),("3473129", "Afonso Cláudio", "", "BR", "76", "", "08", "3200102", "", "-20.07417", "-41.12389", "America/Sao_Paulo"),("3473157", "Adamantina", "", "BR", "76", "", "27", "3500105", "", "-21.68528", "-51.0725", "America/Sao_Paulo"),("3473183", "Açucena", "", "BR", "76", "", "15", "3100500", "", "-19.07306", "-42.54639", "America/Sao_Paulo"),("3473218", "Acajutiba", "", "BR", "76", "", "05", "2900306", "", "-11.66222", "-38.01722", "America/Bahia"),("3473267", "Abaeté", "Абаэте", "BR", "76", "", "15", "3100203", "", "-19.16", "-45.44583", "America/Sao_Paulo"),("3473268", "Abadiânia", "", "BR", "76", "", "29", "5200100", "", "-16.20417", "-48.70694", "America/Sao_Paulo"),("3473964", "Guaíba", "", "BR", "76", "", "23", "4309308", "", "-30.11389", "-51.325", "America/Sao_Paulo"),("3474574", "Palmas", "Палмас", "BR", "76", "", "31", "1721000", "", "-10.16745", "-48.32766", "America/Araguaina"),("3478424", "Pontal do Paraná", "", "BR", "76", "", "18", "4119954", "", "-25.67361", "-48.51111", "America/Sao_Paulo"),("3661944", "Tefé", "", "BR", "76", "", "04", "1304203", "", "-3.36841", "-64.72054", "America/Manaus"),("3661980", "Tarauacá", "", "BR", "76", "", "01", "1200609", "", "-8.16139", "-70.76556", "America/Rio_Branco"),("3662075", "Tabatinga", "", "BR", "76", "", "04", "1304062", "", "-4.23116", "-69.93858", "America/Manaus"),("3662155", "Sena Madureira", "", "BR", "76", "", "01", "1200500", "", "-9.06341", "-68.67245", "America/Rio_Branco"),("3662252", "São Paulo de Olivença", "", "BR", "76", "", "04", "1303908", "", "-3.37833", "-68.8725", "America/Manaus"),("3662342", "São Gabriel da Cachoeira", "", "BR", "76", "", "04", "1303809", "", "-0.1181", "-67.08527", "America/Manaus"),("3662395", "Santo Antônio do Içá", "", "BR", "76", "", "04", "1303700", "", "-3.10222", "-67.93972", "America/Manaus"),("3662574", "Rio Branco", "Риу-Бранку", "BR", "76", "", "01", "1200401", "", "-9.97472", "-67.81", "America/Rio_Branco"),("3662762", "Porto Velho", "Порту-Велью", "BR", "76", "", "24", "1100205", "", "-8.76194", "-63.90389", "America/Porto_Velho"),("3662927", "Pauini", "", "BR", "76", "", "04", "1303502", "", "-7.71361", "-66.97639", "America/Manaus"),("3663142", "Novo Aripuanã", "", "BR", "76", "", "04", "1303304", "", "-5.12056", "-60.37972", "America/Manaus"),("3663503", "Manicoré", "", "BR", "76", "", "04", "1302702", "", "-5.80917", "-61.30028", "America/Manaus"),("3663516", "Mâncio Lima", "", "BR", "76", "", "01", "1200336", "", "-7.61417", "-72.89583", "America/Rio_Branco"),("3663517", "Manaus", "Манаус", "BR", "76", "", "04", "1302603", "", "-3.10194", "-60.025", "America/Manaus"),("3663524", "Manaquiri", "", "BR", "76", "", "04", "1302553", "", "-3.31667", "-60.35", "America/Manaus"),("3663529", "Manacapuru", "Манакапуру", "BR", "76", "", "04", "1302504", "", "-3.29972", "-60.62056", "America/Manaus"),("3663693", "Jutaí", "", "BR", "76", "", "04", "1302306", "", "-5.18333", "-68.9", "America/Manaus"),("3664078", "Humaitá", "", "BR", "76", "", "04", "1301704", "", "-7.51651", "-63.03105", "America/Manaus"),("3664207", "Fonte Boa", "", "BR", "76", "", "04", "1301605", "", "-2.51389", "-66.09167", "America/Manaus"),("3664243", "Feijó", "", "BR", "76", "", "01", "1200302", "", "-8.1654", "-70.35486", "America/Rio_Branco"),("3664301", "Envira", "", "BR", "76", "", "04", "1301407", "", "-7.3", "-70.21667", "America/Eirunepe"),("3664321", "Eirunepé", "", "BR", "76", "", "04", "1301407", "", "-6.66028", "-69.87361", "America/Eirunepe"),("3664464", "Cruzeiro do Sul", "", "BR", "76", "BR", "01", "1200203", "", "-7.62759", "-72.67756", "America/Rio_Branco"),("3664525", "Codajás", "", "BR", "76", "", "04", "1301308", "", "-3.83667", "-62.05694", "America/Manaus"),("3664539", "Coari", "Коари", "BR", "76", "", "04", "1301209", "", "-4.085", "-63.14139", "America/Manaus"),("3664659", "Carauari", "", "BR", "76", "", "04", "1301001", "", "-4.88278", "-66.89583", "America/Manaus"),("3664716", "Canutama", "", "BR", "76", "", "04", "1300904", "", "-6.53389", "-64.38306", "America/Manaus"),("3664956", "Boca do Acre", "", "BR", "76", "", "04", "1300706", "", "-8.75222", "-67.39778", "America/Manaus"),("3664980", "Boa Vista", "Боа-Виста", "BR", "76", "", "25", "1400100", "", "2.81972", "-60.67333", "America/Boa_Vista"),("3665016", "Benjamin Constant", "", "BR", "76", "", "04", "1300607", "", "-4.37555", "-70.03179", "America/Eirunepe"),("3665098", "Barcelos", "", "BR", "76", "", "04", "1300409", "", "-0.97357", "-62.9269", "America/Manaus"),("3665199", "Ariquemes", "", "BR", "76", "", "24", "1100023", "", "-9.91333", "-63.04083", "America/Porto_Velho"),("3665202", "Aripuanã", "Арипуанан", "BR", "76", "", "14", "5103254", "", "-9.16667", "-60.63333", "America/Cuiaba"),("3665315", "Anori", "", "BR", "76", "", "04", "1300102", "", "-3.77278", "-61.64417", "America/Manaus"),("3665380", "Alvarães", "", "BR", "76", "", "04", "1300029", "", "-3.22083", "-64.80417", "America/Manaus"),("3736808", "Iranduba", "", "BR", "76", "", "04", "1301852", "", "-3.28472", "-60.18611", "America/Manaus"),("3924674", "Xapuri", "", "BR", "76", "", "01", "1200708", "", "-10.65167", "-68.50444", "America/Rio_Branco"),("3924679", "Vilhena", "Вилена", "BR", "76", "", "24", "1100304", "", "-12.74056", "-60.14583", "America/Porto_Velho"),("3924752", "Senador Guiomard", "", "BR", "76", "", "01", "1200450", "", "-10.1497", "-67.73741", "America/Rio_Branco"),("3924872", "Presidente Médici", "", "BR", "76", "", "24", "1100254", "", "-11.17528", "-61.90139", "America/Porto_Velho"),("3924877", "Pôsto Fiscal Rolim de Moura", "", "BR", "76", "", "24", "1100015", "", "-13.08271", "-62.27726", "America/Porto_Velho"),("3924895", "Plácido de Castro", "", "BR", "76", "", "01", "1200385", "", "-10.33528", "-67.18556", "America/Rio_Branco"),("3924908", "Pimenta Bueno", "", "BR", "76", "", "24", "1100189", "", "-11.6725", "-61.19361", "America/Porto_Velho"),("3924948", "Ouro Preto do Oeste", "Ору-Прету-ду-Уэсти", "BR", "76", "", "24", "1100155", "", "-10.74806", "-62.21583", "America/Porto_Velho"),("3925033", "Ji Paraná", "", "BR", "76", "", "24", "1100122", "", "-10.88528", "-61.95167", "America/Porto_Velho"),("3925040", "Jaru", "Жара", "BR", "76", "", "24", "1100114", "", "-10.43889", "-62.46639", "America/Porto_Velho"),("3925075", "Guajará Mirim", "", "BR", "76", "", "24", "1100106", "", "-10.78278", "-65.33944", "America/Porto_Velho"),("3925212", "Cacoal", "Какоал", "BR", "76", "", "24", "1100049", "", "-11.43861", "-61.44722", "America/Porto_Velho"),("3925227", "Brasiléia", "", "BR", "76", "", "01", "1200104", "", "-11.01611", "-68.74806", "America/Rio_Branco"),("6316406", "Aparecida de Goiânia", "Апаресида-ди-Гояния", "BR", "76", "", "29", "5201405", "", "-16.82333", "-49.24389", "America/Sao_Paulo"),("6316729", "Campinas", "", "BR", "76", "", "26", "4216602", "", "-27.59444", "-48.60694", "America/Sao_Paulo"),("6317344", "Jaboatão dos Guararapes", "Жабоатан-дус-Гуарарапис", "BR", "76", "", "30", "2607901", "", "-8.11278", "-35.01472", "America/Recife"),("6317464", "Lauro de Freitas", "", "BR", "76", "", "05", "2919207", "", "-12.89444", "-38.32722", "America/Bahia"),("6317953", "Pinhais", "", "BR", "76", "", "18", "4119152", "", "-25.44472", "-49.1925", "America/Sao_Paulo"),("6318165", "Rio Preto da Eva", "", "BR", "76", "", "04", "1303569", "", "-2.69795", "-59.70172", "America/Manaus"),("6318694", "Simões Filho", "", "BR", "76", "", "05", "2930709", "", "-12.78444", "-38.40389", "America/Bahia"),("6318696", "Sinop", "", "BR", "76", "", "14", "5107909", "", "-11.86417", "-55.5025", "America/Cuiaba"),("6693804", "Cambebba", "", "BR", "76", "", "06", "2303709", "", "-3.62092", "-38.82913", "America/Fortaleza"),("7874475", "Itacorubi", "", "BR", "76", "", "26", "4205407", "", "-27.58315", "-48.49503", "America/Sao_Paulo"),("7874477", "Santa Monica", "", "BR", "76", "", "26", "4205407", "", "-27.59137", "-48.50756", "America/Sao_Paulo"),("7874479", "Trindade", "", "BR", "76", "", "26", "4205407", "", "-27.58612", "-48.52335", "America/Sao_Paulo"),("7874481", "Saco dos Limoes", "", "BR", "76", "", "26", "4205407", "", "-27.60864", "-48.53605", "America/Sao_Paulo"),("7874483", "Costeira do Pirajubae", "", "BR", "76", "", "26", "4205407", "", "-27.63586", "-48.5212", "America/Sao_Paulo"),("7874492", "Freguesia do Ribeirao da Ilha", "", "BR", "76", "", "26", "4205407", "", "-27.71773", "-48.56266", "America/Sao_Paulo"),("8739860", "Gavea", "", "BR", "76", "", "26", "4215109", "", "-26.90967", "-49.36547", "America/Sao_Paulo"),("11184422", "Planaltina", "", "BR", "76", "", "07", "5300108", "", "-15.61791", "-47.64874", "America/Sao_Paulo"),("932987", "Tshabong", "", "BW", "72", "BW", "04", "", "", "-26.05", "22.45", "Africa/Gaborone"),("933000", "Tonota", "", "BW", "72", "", "01", "", "", "-21.44236", "27.46153", "Africa/Gaborone"),("933018", "Thamaga", "", "BW", "72", "", "06", "", "", "-24.67014", "25.53975", "Africa/Gaborone"),("933077", "Shakawe", "", "BW", "72", "", "11", "", "", "-18.36536", "21.84219", "Africa/Gaborone"),("933088", "Serowe", "Серова", "BW", "72", "", "01", "", "", "-22.38754", "26.71077", "Africa/Gaborone"),("933099", "Selebi-Phikwe", "", "BW", "72", "", "01", "", "", "-21.97895", "27.84296", "Africa/Gaborone"),("933141", "Ramotswa", "", "BW", "72", "", "09", "", "", "-24.87158", "25.86989", "Africa/Gaborone"),("933151", "Rakops", "", "BW", "72", "", "01", "", "", "-21.02257", "24.36052", "Africa/Gaborone"),("933182", "Palapye", "Палапье", "BW", "72", "", "01", "", "", "-22.54605", "27.12507", "Africa/Gaborone"),("933184", "Otse", "", "BW", "72", "", "09", "", "", "-25.01667", "25.73333", "Africa/Gaborone"),("933186", "Orapa", "", "BW", "72", "", "01", "", "", "-21.3115", "25.37642", "Africa/Gaborone"),("933271", "Mosopa", "", "BW", "72", "", "10", "", "", "-24.7718", "25.42156", "Africa/Gaborone"),("933305", "Molepolole", "Молепололе", "BW", "72", "", "06", "", "", "-24.40659", "25.49508", "Africa/Gaborone"),("933331", "Mogoditshane", "", "BW", "72", "", "06", "", "", "-24.62694", "25.86556", "Africa/Gaborone"),("933340", "Mochudi", "Мочуди", "BW", "72", "BW", "05", "", "", "-24.41667", "26.15", "Africa/Gaborone"),("933366", "Maun", "Маун", "BW", "72", "", "11", "", "", "-19.98333", "23.41667", "Africa/Gaborone"),("933471", "Mahalapye", "", "BW", "72", "", "01", "", "", "-23.10407", "26.81421", "Africa/Gaborone"),("933521", "Lobatse", "Лобаце", "BW", "72", "", "09", "", "", "-25.22435", "25.67728", "Africa/Gaborone"),("933534", "Letlhakeng", "", "BW", "72", "", "06", "", "", "-24.09442", "25.02977", "Africa/Gaborone"),("933535", "Letlhakane", "", "BW", "72", "", "01", "", "", "-21.41494", "25.59263", "Africa/Gaborone"),("933596", "Kopong", "", "BW", "72", "", "09", "", "", "-24.48333", "25.88333", "Africa/Gaborone"),("933677", "Kasane", "", "BW", "72", "", "11", "", "", "-17.81667", "25.15", "Africa/Gaborone"),("933685", "Kanye", "Канье", "BW", "72", "", "10", "", "", "-24.96675", "25.33273", "Africa/Gaborone"),("933719", "Janeng", "", "BW", "72", "", "09", "", "", "-25.41667", "25.55", "Africa/Gaborone"),("933759", "Ghanzi", "", "BW", "72", "BW", "03", "", "", "-21.69785", "21.64581", "Africa/Gaborone"),("933773", "Gaborone", "Габороне", "BW", "72", "", "09", "", "", "-24.65451", "25.90859", "Africa/Gaborone"),("933777", "Gabane", "", "BW", "72", "", "06", "", "", "-24.66667", "25.78222", "Africa/Gaborone"),("933778", "Francistown", "Франсистаун", "BW", "72", "", "08", "", "", "-21.16995", "27.50787", "Africa/Gaborone"),("1106206", "Metsemotlhaba", "", "BW", "72", "", "06", "", "", "-24.55139", "25.80306", "Africa/Gaborone"),("611866", "Skidal’", "", "BY", "112", "", "03", "", "", "53.5904", "24.2478", "Europe/Minsk"),("618800", "Horad Zhodzina", "Жодино", "BY", "112", "", "05", "", "", "54.0985", "28.3331", "Europe/Minsk"),("618806", "Zhlobin", "Жлобин", "BY", "112", "", "02", "", "", "52.8926", "30.024", "Europe/Minsk"),("618815", "Zhytkavichy", "", "BY", "112", "", "02", "", "", "52.2168", "27.8561", "Europe/Minsk"),("618913", "Zhabinka", "", "BY", "112", "", "01", "", "", "52.1984", "24.0115", "Europe/Minsk"),("618932", "Zel’va", "", "BY", "112", "", "03", "", "", "53.1504", "24.8153", "Europe/Minsk"),("619066", "Zaslawye", "", "BY", "112", "", "05", "", "", "54.0114", "27.2695", "Europe/Minsk"),("619979", "Voranava", "", "BY", "112", "", "03", "", "", "54.1492", "25.3112", "Europe/Minsk"),("620127", "Vitebsk", "Витебск", "BY", "112", "", "07", "", "", "55.1904", "30.2049", "Europe/Minsk"),("620146", "Vishnyeva", "", "BY", "112", "", "03", "", "", "54.7102", "26.5228", "Europe/Minsk"),("620181", "Vilyeyka", "Вилейка", "BY", "112", "", "05", "", "", "54.4914", "26.9111", "Europe/Minsk"),("620214", "Vyetka", "", "BY", "112", "", "02", "", "", "52.5591", "31.1794", "Europe/Minsk"),("620255", "Vyerkhnyadzvinsk", "", "BY", "112", "", "07", "", "", "55.7777", "27.9389", "Europe/Minsk"),("620391", "Vawkavysk", "Волковыск", "BY", "112", "", "03", "", "", "53.1561", "24.4513", "Europe/Minsk"),("620445", "Valozhyn", "", "BY", "112", "", "05", "", "", "54.0892", "26.5266", "Europe/Minsk"),("620483", "Uzda", "", "BY", "112", "", "05", "", "", "53.4627", "27.2137", "Europe/Minsk"),("620540", "Ushachy", "", "BY", "112", "", "07", "620539", "", "55.179", "28.6158", "Europe/Minsk"),("620833", "Talachyn", "", "BY", "112", "", "07", "", "", "54.4087", "29.6955", "Europe/Minsk"),("621048", "Svislach", "", "BY", "112", "", "03", "", "", "53.0368", "24.0957", "Europe/Minsk"),("621074", "Svyetlahorsk", "Светлогорск", "BY", "112", "", "02", "", "", "52.6329", "29.7389", "Europe/Minsk"),("621266", "Stowbtsy", "Столбцы", "BY", "112", "", "05", "", "", "53.4785", "26.7434", "Europe/Minsk"),("621277", "Stolin", "", "BY", "112", "", "01", "", "", "51.89115", "26.84597", "Europe/Minsk"),("621396", "Staryya Darohi", "", "BY", "112", "", "05", "", "", "53.0402", "28.267", "Europe/Minsk"),("621462", "Starobin", "", "BY", "112", "", "05", "", "", "52.7267", "27.4606", "Europe/Minsk"),("621713", "Smarhon’", "Сморгонь", "BY", "112", "", "03", "", "", "54.4798", "26.3957", "Europe/Minsk"),("621729", "Horad Smalyavichy", "", "BY", "112", "", "05", "", "", "54.0249", "28.0894", "Europe/Minsk"),("621732", "Smilavichy", "", "BY", "112", "", "05", "", "", "53.7496", "28.0115", "Europe/Minsk"),("621741", "Slutsk", "Слуцк", "BY", "112", "", "05", "", "", "53.0274", "27.5597", "Europe/Minsk"),("621754", "Slonim", "Слоним", "BY", "112", "", "03", "", "", "53.0869", "25.3163", "Europe/Minsk"),("621838", "Slawharad", "", "BY", "112", "", "06", "", "", "53.4429", "31.0014", "Europe/Minsk"),("622034", "Shklow", "", "BY", "112", "", "06", "", "", "54.2131", "30.2877", "Europe/Minsk"),("622113", "Shchuchin", "Щучин", "BY", "112", "", "03", "", "", "53.6014", "24.7465", "Europe/Minsk"),("622179", "Sharkawshchyna", "", "BY", "112", "", "07", "", "", "55.3689", "27.4686", "Europe/Minsk"),("622258", "Syanno", "", "BY", "112", "", "07", "", "", "54.8108", "29.7086", "Europe/Minsk"),("622428", "Salihorsk", "Солигорск", "BY", "112", "", "05", "", "", "52.7876", "27.5415", "Europe/Minsk"),("622690", "Rasony", "", "BY", "112", "", "07", "", "", "55.9058", "28.8135", "Europe/Minsk"),("622700", "Ros’", "", "BY", "112", "", "03", "", "", "53.2858", "24.4128", "Europe/Minsk"),("622739", "Rahachow", "Рогачев", "BY", "112", "", "02", "", "", "53.0934", "30.0495", "Europe/Minsk"),("622794", "Rechytsa", "Речица", "BY", "112", "", "02", "", "", "52.3617", "30.3916", "Europe/Minsk"),("622849", "Rakaw", "", "BY", "112", "", "05", "", "", "53.9674", "27.0562", "Europe/Minsk"),("622877", "Radashkovichy", "", "BY", "112", "", "05", "", "", "54.1554", "27.2412", "Europe/Minsk"),("622997", "Pruzhany", "Пружаны", "BY", "112", "", "01", "", "", "52.556", "24.4573", "Europe/Minsk"),("623317", "Polatsk", "Полоцк", "BY", "112", "", "07", "", "", "55.4879", "28.7856", "Europe/Minsk"),("623512", "Plyeshchanitsy", "", "BY", "112", "", "05", "", "", "54.4235", "27.8301", "Europe/Minsk"),("623549", "Pinsk", "Пинск", "BY", "112", "", "01", "", "", "52.1229", "26.0951", "Europe/Minsk"),("623581", "Pyetrykaw", "", "BY", "112", "", "02", "", "", "52.1289", "28.4921", "Europe/Minsk"),("623760", "Pastavy", "Поставы", "BY", "112", "", "07", "", "", "55.11676", "26.83263", "Europe/Minsk"),("623941", "Astravyets", "", "BY", "112", "BY", "03", "", "", "54.61378", "25.95537", "Europe/Minsk"),("624034", "Asipovichy", "Осиповичи", "BY", "112", "", "06", "", "", "53.3011", "28.6386", "Europe/Minsk"),("624079", "Orsha", "Орша", "BY", "112", "", "07", "", "", "54.5081", "30.4172", "Europe/Minsk"),("624400", "Novoye Medvezhino", "Медвежино", "BY", "112", "", "04", "", "", "53.88333", "27.45", "Europe/Minsk"),("624494", "Novolukoml’", "", "BY", "112", "", "00", "", "", "54.66192", "29.15016", "Europe/Minsk"),("624700", "Nyasvizh", "", "BY", "112", "", "05", "", "", "53.2189", "26.6779", "Europe/Minsk"),("624784", "Navapolatsk", "Новополоцк", "BY", "112", "", "07", "", "", "55.5318", "28.5987", "Europe/Minsk"),("624785", "Navahrudak", "Новогрудок", "BY", "112", "", "03", "", "", "53.5942", "25.8191", "Europe/Minsk"),("624861", "Myadzyel", "", "BY", "112", "", "05", "", "", "54.8789", "26.9371", "Europe/Minsk"),("624889", "Mstsislaw", "", "BY", "112", "", "06", "", "", "54.0185", "31.7217", "Europe/Minsk"),("625130", "Myory", "", "BY", "112", "", "07", "", "", "55.6222", "27.6281", "Europe/Minsk"),("625144", "Minsk", "Минск", "BY", "112", "", "04", "", "", "53.9", "27.56667", "Europe/Minsk"),("625228", "Mikashevichy", "", "BY", "112", "", "01", "", "", "52.2173", "27.476", "Europe/Minsk"),("625324", "Mazyr", "Мозырь", "BY", "112", "", "02", "", "", "52.0495", "29.2456", "Europe/Minsk"),("625367", "Masty", "Мосты", "BY", "112", "", "03", "", "", "53.4122", "24.5387", "Europe/Minsk"),("625409", "Mar’’ina Horka", "Марьина Горка", "BY", "112", "", "05", "", "", "53.509", "28.147", "Europe/Minsk"),("625539", "Malaryta", "", "BY", "112", "", "01", "", "", "51.7905", "24.074", "Europe/Minsk"),("625625", "Maladzyechna", "Молодечно", "BY", "112", "", "05", "", "", "54.3167", "26.854", "Europe/Minsk"),("625665", "Mahilyow", "Могилёв", "BY", "112", "", "06", "", "", "53.9168", "30.3449", "Europe/Minsk"),("625671", "Machulishchy", "", "BY", "112", "", "05", "", "", "53.7788", "27.5948", "Europe/Minsk"),("625721", "Lyuban’", "", "BY", "112", "", "05", "", "", "52.7985", "28.0048", "Europe/Minsk"),("625743", "Lyepyel’", "Лепель", "BY", "112", "", "07", "", "", "54.8814", "28.699", "Europe/Minsk"),("625772", "Lyakhavichy", "", "BY", "112", "", "01", "", "", "53.0388", "26.2656", "Europe/Minsk"),("625818", "Luninyets", "Лунинец", "BY", "112", "", "01", "", "", "52.2472", "26.8047", "Europe/Minsk"),("625907", "Loyew", "", "BY", "112", "", "02", "", "", "51.9458", "30.7953", "Europe/Minsk"),("625931", "Loshnitsa", "", "BY", "112", "", "05", "", "", "54.2796", "28.7649", "Europe/Minsk"),("625972", "Lahoysk", "", "BY", "112", "", "05", "", "", "54.2064", "27.8512", "Europe/Minsk"),("626064", "Lyozna", "", "BY", "112", "", "07", "626065", "", "55.0247", "30.797", "Europe/Minsk"),("626081", "Lida", "Лида", "BY", "112", "", "03", "", "", "53.88333", "25.29972", "Europe/Minsk"),("626450", "Krychaw", "Кричев", "BY", "112", "", "06", "", "", "53.7125", "31.717", "Europe/Minsk"),("626471", "Krupki", "", "BY", "112", "", "05", "", "", "54.3178", "29.1374", "Europe/Minsk"),("626491", "Kruhlaye", "", "BY", "112", "", "06", "", "", "54.2497", "29.7968", "Europe/Minsk"),("626621", "Krasnasyel’ski", "", "BY", "112", "", "03", "", "", "53.2645", "24.4301", "Europe/Minsk"),("626625", "Krasnapollye", "", "BY", "112", "", "06", "", "", "53.3353", "31.3999", "Europe/Minsk"),("626806", "Kastsyukowka", "", "BY", "112", "", "02", "", "", "52.5387", "30.9173", "Europe/Minsk"),("626808", "Kastsyukovichy", "", "BY", "112", "", "06", "", "", "53.3525", "32.0514", "Europe/Minsk"),("626939", "Karelichy", "", "BY", "112", "", "03", "", "", "53.5648", "26.1406", "Europe/Minsk"),("626956", "Kapyl’", "", "BY", "112", "", "05", "", "", "53.1516", "27.0913", "Europe/Minsk"),("627083", "Kalodzishchy", "Колодищи", "BY", "112", "", "05", "", "", "53.944", "27.7823", "Europe/Minsk"),("627145", "Kobryn", "Кобрин", "BY", "112", "", "01", "", "", "52.2138", "24.3564", "Europe/Minsk"),("627202", "Klimavichy", "", "BY", "112", "", "06", "", "", "53.6079", "31.9586", "Europe/Minsk"),("627205", "Klichaw", "", "BY", "112", "", "06", "", "", "53.4923", "29.3356", "Europe/Minsk"),("627214", "Klyetsk", "", "BY", "112", "", "05", "", "", "53.0635", "26.6321", "Europe/Minsk"),("627272", "Kirawsk", "", "BY", "112", "", "06", "", "", "53.2693", "29.4752", "Europe/Minsk"),("627362", "Khoyniki", "", "BY", "112", "", "02", "", "", "51.8911", "29.9552", "Europe/Minsk"),("627711", "Kamyanyets", "", "BY", "112", "", "01", "", "", "52.40013", "23.81", "Europe/Minsk"),("627751", "Kalinkavichy", "Калинковичи", "BY", "112", "", "02", "", "", "52.1323", "29.3257", "Europe/Minsk"),("627793", "Iwye", "", "BY", "112", "", "03", "", "", "53.9299", "25.7727", "Europe/Minsk"),("627800", "Ivatsevichy", "Ивацевичи", "BY", "112", "", "01", "", "", "52.709", "25.3401", "Europe/Minsk"),("627811", "Ivanava", "", "BY", "112", "", "01", "", "", "52.1451", "25.5365", "Europe/Minsk"),("627904", "Hrodna", "Гродно", "BY", "112", "", "03", "", "", "53.6884", "23.8258", "Europe/Minsk"),("627905", "Horki", "Горки", "BY", "112", "", "06", "", "", "54.2862", "30.9863", "Europe/Minsk"),("627907", "Gomel", "Гомель", "BY", "112", "", "02", "", "", "52.4345", "30.9754", "Europe/Minsk"),("627908", "Hlybokaye", "Глубокое", "BY", "112", "", "07", "", "", "55.1384", "27.6905", "Europe/Minsk"),("628155", "Haradok", "", "BY", "112", "", "07", "", "", "55.4624", "29.9845", "Europe/Minsk"),("628387", "Hlusk", "", "BY", "112", "", "06", "", "", "52.903", "28.6845", "Europe/Minsk"),("628511", "Hatava", "", "BY", "112", "", "05", "", "", "53.7829", "27.6407", "Europe/Minsk"),("628634", "Dzyarzhynsk", "Дзержинск", "BY", "112", "", "05", "", "", "53.6832", "27.138", "Europe/Minsk"),("628658", "Dzyatlava", "", "BY", "112", "", "03", "", "", "53.4631", "25.4068", "Europe/Minsk"),("628758", "Dubrowna", "", "BY", "112", "", "07", "", "", "54.5716", "30.691", "Europe/Minsk"),("628884", "Drahichyn", "", "BY", "112", "", "01", "", "", "52.1874", "25.1597", "Europe/Minsk"),("629002", "Dokshytsy", "", "BY", "112", "", "07", "", "", "54.8918", "27.7667", "Europe/Minsk"),("629018", "Dobrush", "Добруш", "BY", "112", "", "02", "", "", "52.4089", "31.3237", "Europe/Minsk"),("629159", "Davyd-Haradok", "", "BY", "112", "", "01", "", "", "52.0566", "27.2161", "Europe/Minsk"),("629273", "Chervyen’", "", "BY", "112", "", "05", "", "", "53.7059", "28.4313", "Europe/Minsk"),("629347", "Cherykaw", "", "BY", "112", "", "06", "", "", "53.5689", "31.3831", "Europe/Minsk"),("629390", "Chachersk", "", "BY", "112", "", "02", "", "", "52.9164", "30.9179", "Europe/Minsk"),("629395", "Chavusy", "", "BY", "112", "", "06", "", "", "53.8098", "30.9717", "Europe/Minsk"),("629400", "Chashniki", "", "BY", "112", "", "07", "", "", "54.8584", "29.1608", "Europe/Minsk"),("629447", "Bykhaw", "Быхов", "BY", "112", "", "06", "", "", "53.521", "30.2454", "Europe/Minsk"),("629454", "Byaroza", "Берёза", "BY", "112", "", "01", "", "", "52.5314", "24.9786", "Europe/Minsk"),("629634", "Brest", "Брест", "BY", "112", "", "01", "", "", "52.09755", "23.68775", "Europe/Minsk"),("629640", "Braslaw", "", "BY", "112", "", "07", "", "", "55.6413", "27.0418", "Europe/Minsk"),("629986", "Vyalikaya Byerastavitsa", "", "BY", "112", "", "03", "", "", "53.196", "24.0166", "Europe/Minsk"),("630166", "Berëzovka", "", "BY", "112", "", "00", "", "", "53.72143", "25.49927", "Europe/Minsk"),("630197", "Byerazino", "", "BY", "112", "", "05", "", "", "53.8391", "28.9879", "Europe/Minsk"),("630245", "Byalynichy", "", "BY", "112", "", "06", "", "", "53.9994", "29.7141", "Europe/Minsk"),("630279", "Byelaazyorsk", "", "BY", "112", "", "01", "", "", "52.4731", "25.1784", "Europe/Minsk"),("630376", "Horad Barysaw", "Город Борисов", "BY", "112", "", "05", "", "", "54.2279", "28.505", "Europe/Minsk"),("630429", "Baranovichi", "Барановичи", "BY", "112", "", "01", "", "", "53.1327", "26.0139", "Europe/Minsk"),("630431", "Baran’", "", "BY", "112", "", "07", "", "", "54.4784", "30.3159", "Europe/Minsk"),("630468", "Babruysk", "Бобруйск", "BY", "112", "", "06", "", "", "53.1384", "29.2214", "Europe/Minsk"),("630515", "Ashmyany", "", "BY", "112", "", "03", "", "", "54.421", "25.936", "Europe/Minsk"),("6846555", "Fanipol", "", "BY", "112", "", "", "", "", "53.74998", "27.33338", "Europe/Minsk"),("8020004", "Druzhny", "", "BY", "112", "", "05", "", "", "53.6238", "27.8977", "Europe/Minsk"),("8020218", "Malinovka", "Малиновка", "BY", "112", "", "04", "", "", "53.8579", "27.4374", "Europe/Minsk"),("8247399", "Chyst’", "", "BY", "112", "", "05", "", "", "54.2698", "27.1067", "Europe/Minsk"),("8247407", "Lyasny", "", "BY", "112", "", "05", "", "", "54.0072", "27.6963", "Europe/Minsk"),("3581164", "San Pedro", "", "BZ", "84", "", "01", "", "", "17.91598", "-87.9659", "America/Belize"),("3581194", "San Ignacio", "", "BZ", "84", "", "02", "", "", "17.1588", "-89.0696", "America/Belize"),("3581398", "Punta Gorda", "", "BZ", "84", "", "06", "", "", "16.09835", "-88.8097", "America/Belize"),("3581514", "Orange Walk", "", "BZ", "84", "", "04", "", "", "18.08124", "-88.56328", "America/Belize"),("3582228", "Dangriga", "", "BZ", "84", "", "05", "9252696", "", "16.9697", "-88.23313", "America/Belize"),("3582305", "Corozal", "", "BZ", "84", "", "03", "", "", "18.39375", "-88.38849", "America/Belize"),("3582662", "Benque Viejo del Carmen", "", "BZ", "84", "", "02", "", "", "17.075", "-89.13917", "America/Belize"),("3582672", "Belmopan", "Бельмопан", "BZ", "84", "", "02", "", "", "17.25", "-88.76667", "America/Belize"),("3582677", "Belize City", "Белиз", "BZ", "84", "", "01", "", "", "17.49952", "-88.19756", "America/Belize"),("5881791", "Abbotsford", "Абботсфорд", "CA", "124", "", "02", "5957659", "", "49.05798", "-122.25257", "America/Vancouver"),("5882142", "Acton Vale", "", "CA", "124", "", "10", "16", "48028", "45.65007", "-72.56582", "America/Toronto"),("5882799", "Airdrie", "", "CA", "124", "", "01", "", "", "51.30011", "-114.03528", "America/Edmonton"),("5882873", "Ajax", "Эйджакс", "CA", "124", "", "08", "", "", "43.85012", "-79.03288", "America/Toronto"),("5884083", "Alma", "Алма", "CA", "124", "", "10", "02", "93042", "48.55009", "-71.6491", "America/Toronto"),("5884467", "Amherst", "", "CA", "124", "", "07", "", "", "45.83345", "-64.19874", "America/Halifax"),("5884473", "Amherstburg", "", "CA", "124", "", "08", "", "", "42.11679", "-83.04985", "America/Toronto"),("5884588", "Amos", "", "CA", "124", "", "10", "08", "88055", "48.56688", "-78.11624", "America/Toronto"),("5885280", "Angus", "", "CA", "124", "", "08", "", "", "44.31681", "-79.88295", "America/Toronto"),("5885383", "Anmore", "", "CA", "124", "", "02", "5915", "", "49.31637", "-122.85263", "America/Vancouver"),("5886182", "Antigonish", "", "CA", "124", "", "07", "", "", "45.61685", "-61.99858", "America/Halifax"),("5887214", "Arnprior", "", "CA", "124", "", "08", "", "", "45.43341", "-76.34939", "America/Toronto"),("5887470", "Asbestos", "", "CA", "124", "", "10", "05", "40043", "45.76678", "-71.9324", "America/Toronto"),("5888716", "Aylmer", "", "CA", "124", "", "08", "", "", "42.76679", "-80.98302", "America/Toronto"),("5889745", "Baie-Comeau", "", "CA", "124", "", "10", "09", "96020", "49.21679", "-68.14894", "America/Toronto"),("5892532", "Banff", "", "CA", "124", "", "01", "", "", "51.17622", "-115.56982", "America/Edmonton"),("5894171", "Barrie", "Барри", "CA", "124", "", "08", "", "", "44.40011", "-79.66634", "America/Toronto"),("5895424", "Bay Roberts", "", "CA", "124", "", "05", "", "", "47.59989", "-53.26478", "America/St_Johns"),("5895650", "Beaconsfield", "", "CA", "124", "", "10", "06", "66107", "45.43341", "-73.86586", "America/Toronto"),("5896495", "Beauharnois", "", "CA", "124", "", "10", "16", "70022", "45.31341", "-73.8725", "America/Toronto"),("5896522", "Beaumont", "", "CA", "124", "", "01", "", "", "53.35013", "-113.41871", "America/Edmonton"),("5897209", "Bécancour", "", "CA", "124", "", "10", "17", "38010", "46.33336", "-72.43241", "America/Toronto"),("5897884", "Belleville", "Бельвиль", "CA", "124", "", "08", "5971841", "", "44.16682", "-77.38277", "America/Toronto"),("5898070", "Bells Corners", "", "CA", "124", "", "08", "", "", "45.31588", "-75.83012", "America/Toronto"),("5898138", "Beloeil", "", "CA", "124", "", "10", "16", "57040", "45.56839", "-73.20568", "America/Toronto"),("5903510", "Blainville", "", "CA", "124", "", "10", "15", "", "45.66678", "-73.88249", "America/Toronto"),("5904501", "Bluewater", "", "CA", "124", "", "08", "", "", "43.46679", "-81.59977", "America/Toronto"),("5905132", "Boisbriand", "", "CA", "124", "", "10", "15", "73005", "45.61678", "-73.83249", "America/Toronto"),("5905152", "Bois-des-Filion", "", "CA", "124", "", "10", "13", "65005", "45.66678", "-73.74918", "America/Toronto"),("5905616", "Bonnyville", "", "CA", "124", "", "01", "", "", "54.26684", "-110.73505", "America/Edmonton"),("5906267", "Boucherville", "Бушервиль", "CA", "124", "", "10", "16", "58033", "45.59104", "-73.43605", "America/Toronto"),("5907092", "Bracebridge", "", "CA", "124", "", "08", "", "", "45.03341", "-79.31633", "America/Toronto"),("5907364", "Brampton", "Брамптон", "CA", "124", "", "08", "", "", "43.68341", "-79.76633", "America/Toronto"),("5907896", "Brandon", "Брэндон", "CA", "124", "", "03", "", "", "49.84692", "-99.95306", "America/Winnipeg"),("5907983", "Brant", "", "CA", "124", "", "08", "", "", "43.1334", "-80.34967", "America/Toronto"),("5907990", "Brantford", "Брантфорд", "CA", "124", "", "08", "", "", "43.1334", "-80.26636", "America/Toronto"),("5908723", "Bridgewater", "", "CA", "124", "", "07", "", "", "44.37856", "-64.51882", "America/Halifax"),("5909294", "Brockville", "Броквилл", "CA", "124", "", "08", "", "", "44.59132", "-75.68705", "America/Toronto"),("5909403", "Bromont", "", "CA", "124", "", "10", "16", "46078", "45.31678", "-72.64912", "America/Toronto"),("5909514", "Brooks", "", "CA", "124", "", "01", "", "", "50.58341", "-111.88509", "America/Edmonton"),("5909629", "Brossard", "", "CA", "124", "", "10", "16", "58007", "45.45008", "-73.46583", "America/Toronto"),("5909969", "Brownsburg-Chatham", "", "CA", "124", "", "10", "15", "76043", "45.68342", "-74.4159", "America/Toronto"),("5911592", "Burlington", "Берлингтон", "CA", "124", "", "08", "", "", "43.38621", "-79.83713", "America/Toronto"),("5911606", "Burnaby", "Бернаби", "CA", "124", "", "02", "", "", "49.26636", "-122.95263", "America/Vancouver"),("5913490", "Calgary", "Калгари", "CA", "124", "", "01", "", "", "51.05011", "-114.08529", "America/Edmonton"),("5913695", "Cambridge", "Кеймбридж", "CA", "124", "", "08", "", "", "43.3601", "-80.31269", "America/Toronto"),("5913934", "Camlachie", "", "CA", "124", "", "08", "", "", "43.03596", "-82.1616", "America/Toronto"),("5914132", "Campbell River", "Кэмпбелл-Ривер", "CA", "124", "", "02", "", "", "50.01634", "-125.24459", "America/Vancouver"),("5914653", "Camrose", "", "CA", "124", "", "01", "", "", "53.01684", "-112.83525", "America/Edmonton"),("5914826", "Candiac", "", "CA", "124", "", "10", "16", "67020", "45.38338", "-73.51587", "America/Toronto"),("5914894", "Canmore", "", "CA", "124", "", "01", "", "", "51.08335", "-115.35206", "America/Edmonton"),("5916722", "Carbonear", "", "CA", "124", "", "05", "", "", "47.73319", "-53.21478", "America/St_Johns"),("5917117", "Carignan", "", "CA", "124", "", "10", "16", "", "45.45008", "-73.29916", "America/Toronto"),("5917158", "Carleton Place", "", "CA", "124", "", "08", "", "", "45.13341", "-76.14938", "America/Toronto"),("5918118", "Castlegar", "", "CA", "124", "", "02", "", "", "49.29984", "-117.66894", "America/Vancouver"),("5919566", "Chambly", "Шамбли", "CA", "124", "", "10", "16", "", "45.45008", "-73.28246", "America/Toronto"),("5920089", "Charlemagne", "", "CA", "124", "", "10", "14", "", "45.71678", "-73.48247", "America/Toronto"),("5920288", "Charlottetown", "Шарлоттаун", "CA", "124", "", "09", "1102", "", "46.23899", "-63.13414", "America/Halifax"),("5920433", "Châteauguay", "", "CA", "124", "", "10", "16", "", "45.38338", "-73.74919", "America/Toronto"),("5921147", "Chibougamau", "", "CA", "124", "", "10", "10", "", "49.91684", "-74.36586", "America/Toronto"),("5921356", "Chilliwack", "", "CA", "124", "", "02", "5909", "", "49.16638", "-121.95257", "America/Vancouver"),("5923101", "Clarence-Rockland", "", "CA", "124", "", "08", "", "", "45.5501", "-75.29101", "America/Toronto"),("5924417", "Coaldale", "", "CA", "124", "", "01", "", "", "49.7167", "-112.61854", "America/Edmonton"),("5924500", "Coaticook", "", "CA", "124", "", "10", "05", "44037", "45.13339", "-71.79907", "America/Toronto"),("5924579", "Cobourg", "", "CA", "124", "", "08", "", "", "43.95977", "-78.16515", "America/Toronto"),("5924618", "Cochrane", "", "CA", "124", "", "01", "", "", "51.18341", "-114.46871", "America/Edmonton"),("5925024", "Cold Lake", "", "CA", "124", "", "01", "", "", "54.46525", "-110.18154", "America/Edmonton"),("5925975", "Collingwood", "", "CA", "124", "", "08", "", "", "44.4834", "-80.21638", "America/Toronto"),("5926268", "Colwood", "", "CA", "124", "", "02", "", "", "48.43293", "-123.48591", "America/Vancouver"),("5926511", "Conception Bay South", "", "CA", "124", "", "05", "", "", "47.49989", "-52.99806", "America/St_Johns"),("5926526", "Concord", "", "CA", "124", "", "08", "", "", "43.80011", "-79.48291", "America/Toronto"),("5927689", "Coquitlam", "", "CA", "124", "", "02", "", "", "49.28297", "-122.75262", "America/Vancouver"),("5927969", "Corner Brook", "Корнер-Брук", "CA", "124", "", "05", "", "", "48.95001", "-57.95202", "America/St_Johns"),("5928065", "Cornwall", "", "CA", "124", "", "08", "", "", "45.01809", "-74.72815", "America/Toronto"),("5928488", "Côte-Saint-Luc", "", "CA", "124", "", "10", "06", "66058", "45.46536", "-73.66585", "America/Toronto"),("5930890", "Courtenay", "Куртенэ", "CA", "124", "", "02", "", "", "49.68657", "-124.9936", "America/Vancouver"),("5931074", "Cowansville", "", "CA", "124", "", "10", "16", "46080", "45.20008", "-72.74913", "America/Toronto"),("5931800", "Cranbrook", "Кранбрук", "CA", "124", "", "02", "", "", "49.49991", "-115.76879", "America/Edmonton"),("5935277", "Dartmouth", "", "CA", "124", "", "07", "", "", "44.67134", "-63.57719", "America/Halifax"),("5935341", "Dauphin", "", "CA", "124", "", "03", "", "", "51.14941", "-100.05023", "America/Winnipeg"),("5935804", "Dawson Creek", "", "CA", "124", "", "02", "5955", "", "55.75984", "-120.2403", "America/Dawson_Creek"),("5937612", "Delson", "", "CA", "124", "", "10", "16", "67025", "45.36678", "-73.54917", "America/Toronto"),("5937615", "Delta", "Дельта", "CA", "124", "", "02", "", "", "49.14399", "-122.9068", "America/Vancouver"),("5938513", "Deux-Montagnes", "", "CA", "124", "", "10", "15", "72010", "45.53455", "-73.90168", "America/Toronto"),("5938801", "Devon", "", "CA", "124", "", "01", "", "", "53.36683", "-113.73533", "America/Edmonton"),("5939219", "Dieppe", "Дьеп", "CA", "124", "", "04", "", "", "46.07844", "-64.68735", "America/Moncton"),("5940934", "Dolbeau-Mistassini", "", "CA", "124", "", "10", "02", "92022", "48.8786", "-72.23142", "America/Toronto"),("5940956", "Dollard-Des Ormeaux", "", "CA", "124", "", "10", "", "", "45.49452", "-73.82419", "America/Toronto"),("5941761", "Dorchester", "", "CA", "124", "", "08", "", "", "42.98339", "-81.06643", "America/Toronto"),("5941925", "Dorval", "Дорваль", "CA", "124", "", "10", "06", "66087", "45.4473", "-73.75335", "America/Toronto"),("5942547", "Drayton Valley", "", "CA", "124", "", "01", "", "", "53.21682", "-114.98544", "America/Edmonton"),("5942845", "Drummondville", "Драммондвилл", "CA", "124", "", "10", "17", "49058", "45.88336", "-72.48241", "America/Toronto"),("5942913", "Dryden", "", "CA", "124", "", "08", "", "", "49.78334", "-92.75032", "America/Winnipeg"),("5943865", "Duncan", "Дункан", "CA", "124", "", "02", "", "", "48.78293", "-123.70266", "America/Vancouver"),("5946768", "Edmonton", "Эдмонтон", "CA", "124", "", "01", "", "", "53.55014", "-113.46871", "America/Edmonton"),("5946820", "Edson", "", "CA", "124", "", "01", "", "", "53.58345", "-116.43559", "America/Edmonton"),("5947866", "Elliot Lake", "", "CA", "124", "", "08", "", "", "46.38336", "-82.63315", "America/Toronto"),("5949568", "Estevan", "", "CA", "124", "", "11", "", "", "49.13337", "-102.98422", "America/Regina"),("5950267", "Etobicoke", "Этобико", "CA", "124", "", "08", "", "", "43.65421", "-79.56711", "America/Toronto"),("5951644", "Farnham", "", "CA", "124", "", "10", "16", "46112", "45.28338", "-72.98244", "America/Toronto"),("5952370", "Fernie", "", "CA", "124", "", "02", "", "", "49.49996", "-115.06871", "America/Edmonton"),("5954718", "Flin Flon", "", "CA", "124", "", "03", "", "", "54.76703", "-101.87433", "America/Winnipeg"),("5955815", "Fort Erie", "", "CA", "124", "", "08", "", "", "42.90012", "-78.93286", "America/Toronto"),("5955826", "Fort Frances", "", "CA", "124", "", "08", "", "", "48.59988", "-93.4003", "America/Winnipeg"),("5955895", "Fort McMurray", "", "CA", "124", "", "01", "", "", "56.72676", "-111.38103", "America/Edmonton"),("5955948", "Fort Saskatchewan", "", "CA", "124", "", "01", "", "", "53.71684", "-113.2187", "America/Edmonton"),("5955960", "Fort St. John", "Форт-Сент-Джон", "CA", "124", "", "02", "", "", "56.24988", "-120.85292", "America/Dawson_Creek"),("5957776", "Fredericton", "Фредериктон", "CA", "124", "", "04", "", "", "45.94541", "-66.66558", "America/Moncton"),("5959326", "Gananoque", "", "CA", "124", "", "08", "", "", "44.33342", "-76.16607", "America/Toronto"),("5959878", "Gaspé", "", "CA", "124", "", "10", "11", "03005", "48.83341", "-64.48194", "America/Toronto"),("5959974", "Gatineau", "Гатино", "CA", "124", "", "10", "07", "81017", "45.47723", "-75.70164", "America/Toronto"),("5960971", "Gibsons", "", "CA", "124", "", "02", "5929", "", "49.39539", "-123.50555", "America/Vancouver"),("5961564", "Glace Bay", "", "CA", "124", "", "07", "", "", "46.19695", "-59.95698", "America/Glace_Bay"),("5962442", "Goderich", "", "CA", "124", "", "08", "5978829", "", "43.74171", "-81.71339", "America/Toronto"),("5964215", "Granby", "Гранби", "CA", "124", "", "10", "16", "47017", "45.40008", "-72.73243", "America/Toronto"),("5964347", "Grande Prairie", "Гранд-Прери", "CA", "124", "", "01", "", "", "55.16667", "-118.80271", "America/Edmonton"),("5964378", "Grand Falls-Windsor", "", "CA", "124", "", "05", "", "", "48.93324", "-55.66492", "America/St_Johns"),("5964700", "Greater Sudbury", "Большой Садбери", "CA", "124", "", "08", "", "", "46.49", "-80.99001", "America/Toronto"),("5965546", "Gravenhurst", "", "CA", "124", "", "08", "", "", "44.91681", "-79.36633", "America/Toronto"),("5965812", "Greater Napanee", "", "CA", "124", "", "08", "", "", "44.25012", "-76.94944", "America/Toronto"),("5966689", "Greenwood", "", "CA", "124", "", "07", "", "", "44.97413", "-64.93169", "America/Halifax"),("5967629", "Guelph", "Гелф", "CA", "124", "", "08", "6177913", "", "43.54594", "-80.25599", "America/Toronto"),("5969782", "Hamilton", "Гамильтон", "CA", "124", "", "08", "", "", "43.25011", "-79.84963", "America/Toronto"),("5970014", "Hampstead", "", "CA", "124", "", "10", "06", "66058", "45.48064", "-73.66307", "America/Toronto"),("5970063", "Hanceville", "", "CA", "124", "", "02", "", "", "51.91922", "-123.04458", "America/Vancouver"),("5970301", "Hanover", "", "CA", "124", "", "08", "", "", "44.15009", "-81.03303", "America/Toronto"),("5970458", "Happy Valley-Goose Bay", "", "CA", "124", "", "05", "", "", "53.3038", "-60.32576", "America/Goose_Bay"),("5972360", "Hawkesbury", "", "CA", "124", "", "08", "", "", "45.60009", "-74.61595", "America/Toronto"),("5975038", "High River", "", "CA", "124", "", "01", "", "", "50.58341", "-113.86867", "America/Edmonton"),("5975503", "Hinton", "", "CA", "124", "", "01", "", "", "53.40009", "-117.58567", "America/Edmonton"),("5978126", "Hudson", "", "CA", "124", "", "10", "16", "71100", "45.45008", "-74.14922", "America/Toronto"),("5978765", "Huntsville", "Хантсвилл", "CA", "124", "", "08", "", "", "45.33341", "-79.21632", "America/Toronto"),("5978831", "Huron East", "", "CA", "124", "", "08", "", "", "43.61679", "-81.29975", "America/Toronto"),("5983175", "Ingersoll", "", "CA", "124", "", "08", "", "", "43.03339", "-80.88302", "America/Toronto"),("5983433", "Innisfil", "", "CA", "124", "", "08", "", "", "44.30011", "-79.64964", "America/Toronto"),("5983720", "Iqaluit", "", "CA", "124", "", "14", "", "", "63.74697", "-68.51727", "America/Iqaluit"),("5987650", "Joliette", "", "CA", "124", "", "10", "14", "61020", "46.0164", "-73.4236", "America/Toronto"),("5989045", "Kamloops", "Камлупс", "CA", "124", "", "02", "", "", "50.66648", "-120.3192", "America/Vancouver"),("5989403", "Kapuskasing", "", "CA", "124", "", "08", "5924616", "", "49.41694", "-82.43308", "America/Toronto"),("5990579", "Kelowna", "Келоуна", "CA", "124", "", "02", "", "", "49.88307", "-119.48568", "America/Vancouver"),("5991148", "Kentville", "", "CA", "124", "", "07", "1207", "", "45.0771", "-64.49605", "America/Halifax"),("5991370", "Keswick", "", "CA", "124", "", "08", "", "", "44.25011", "-79.46632", "America/Toronto"),("5992059", "Kimberley", "", "CA", "124", "", "02", "5901", "", "49.67071", "-115.9776", "America/Edmonton"),("5992144", "Kincardine", "", "CA", "124", "", "08", "", "", "44.18339", "-81.63307", "America/Toronto"),("5992500", "Kingston", "Кингстон", "CA", "124", "", "08", "", "", "44.22976", "-76.48098", "America/Toronto"),("5992830", "Kirkland", "", "CA", "124", "", "10", "06", "66102", "45.45008", "-73.86586", "America/Toronto"),("5992836", "Kirkland Lake", "", "CA", "124", "", "08", "", "", "48.14461", "-80.03767", "America/Toronto"),("5992996", "Kitchener", "Китченер", "CA", "124", "", "08", "", "", "43.42537", "-80.5112", "America/Toronto"),("5993072", "Kitimat", "", "CA", "124", "", "02", "", "", "54.05244", "-128.65342", "America/Vancouver"),("5994839", "Labrador City", "", "CA", "124", "", "05", "", "", "52.94626", "-66.91137", "America/Goose_Bay"),("6002133", "Lac-Brome", "", "CA", "124", "", "10", "16", "46075", "45.21678", "-72.51581", "America/Toronto"),("6024829", "Lachute", "", "CA", "124", "", "10", "15", "76020", "45.65008", "-74.33253", "America/Toronto"),("6035615", "Lacombe", "", "CA", "124", "", "01", "", "", "52.46681", "-113.7353", "America/Edmonton"),("6047817", "Ladysmith", "", "CA", "124", "", "02", "5919", "", "48.99016", "-123.81699", "America/Vancouver"),("6049024", "Lambton Shores", "", "CA", "124", "", "08", "", "", "43.16678", "-81.93309", "America/Toronto"),("6049388", "Langford", "", "CA", "124", "", "02", "", "", "48.44963", "-123.50261", "America/Vancouver"),("6049429", "Langley", "", "CA", "124", "", "02", "", "", "49.10107", "-122.65883", "America/Vancouver"),("6049430", "Langley", "", "CA", "124", "", "02", "", "", "49.08297", "-122.58589", "America/Vancouver"),("6049863", "La Prairie", "", "CA", "124", "", "10", "16", "67015", "45.41678", "-73.49917", "America/Toronto"),("6050194", "La Sarre", "", "CA", "124", "", "10", "08", "87090", "48.80019", "-79.19964", "America/Toronto"),("6050263", "L'Assomption", "", "CA", "124", "", "10", "14", "60028", "45.82318", "-73.4294", "America/Toronto"),("6050416", "La Tuque", "", "CA", "124", "", "10", "04", "90012", "47.43337", "-72.7824", "America/Toronto"),("6050610", "Laval", "Лаваль", "CA", "124", "", "10", "13", "65005", "45.56995", "-73.692", "America/Toronto"),("6050650", "Lavaltrie", "", "CA", "124", "", "10", "14", "", "45.88338", "-73.28245", "America/Toronto"),("6051562", "Leduc", "", "CA", "124", "", "01", "", "", "53.26682", "-113.55201", "America/Edmonton"),("6052788", "Les Coteaux", "", "CA", "124", "", "10", "16", "71033", "45.28338", "-74.23254", "America/Toronto"),("6053154", "Lethbridge", "Летбридж", "CA", "124", "", "01", "", "", "49.69999", "-112.81856", "America/Edmonton"),("6053877", "L'Île-Perrot", "", "CA", "124", "", "10", "16", "71060", "45.38338", "-73.9492", "America/Toronto"),("6058024", "Lloydminster", "Ллойдминстер", "CA", "124", "", "11", "", "", "53.28346", "-110.00157", "America/Edmonton"),("6058560", "London", "Лондон", "CA", "124", "", "08", "", "", "42.98339", "-81.23304", "America/Toronto"),("6059891", "Longueuil", "Лонгёй", "CA", "124", "", "10", "16", "58227", "45.53121", "-73.51806", "America/Toronto"),("6060407", "Lorraine", "", "CA", "124", "", "10", "14", "64008", "45.68338", "-73.78249", "America/Toronto"),("6060839", "Louiseville", "", "CA", "124", "", "10", "04", "51015", "46.25594", "-72.94145", "America/Toronto"),("6062163", "Lutes Mountain", "", "CA", "124", "", "04", "", "", "46.13544", "-64.90504", "America/Moncton"),("6064180", "Magog", "Мейгог", "CA", "124", "", "10", "05", "45072", "45.26678", "-72.14909", "America/Toronto"),("6065686", "Maple Ridge", "Мэпл-Ридж", "CA", "124", "", "02", "", "", "49.21939", "-122.60193", "America/Vancouver"),("6066350", "Marieville", "", "CA", "124", "", "10", "16", "55048", "45.43338", "-73.16585", "America/Toronto"),("6066513", "Markham", "Маркем", "CA", "124", "", "08", "", "", "43.86682", "-79.2663", "America/Toronto"),("6067494", "Mascouche", "", "CA", "124", "", "10", "14", "64015", "45.74965", "-73.59956", "America/Toronto"),("6071618", "Medicine Hat", "Медисин-Хат", "CA", "124", "", "01", "", "", "50.03928", "-110.67661", "America/Edmonton"),("6071876", "Melfort", "", "CA", "124", "", "11", "", "", "52.86673", "-104.61768", "America/Regina"),("6072206", "Mercier", "", "CA", "124", "", "10", "16", "67045", "45.31678", "-73.74919", "America/Toronto"),("6072350", "Merritt", "", "CA", "124", "", "02", "", "", "50.11225", "-120.7942", "America/Vancouver"),("6073363", "Midland", "", "CA", "124", "", "08", "", "", "44.7501", "-79.88296", "America/Toronto"),("6074377", "Milton", "Милтон", "CA", "124", "", "08", "5969719", "", "43.51681", "-79.88294", "America/Toronto"),("6075061", "Mirabel", "Мирабель", "CA", "124", "", "10", "15", "74005", "45.65008", "-74.08251", "America/Toronto"),("6075081", "Miramichi", "Мирамиши", "CA", "124", "", "04", "1309", "", "47.02895", "-65.50186", "America/Moncton"),("6075357", "Mississauga", "Миссиссога", "CA", "124", "", "08", "", "", "43.5789", "-79.6583", "America/Toronto"),("6076211", "Moncton", "Монктон", "CA", "124", "", "04", "1307", "", "46.09454", "-64.7965", "America/Moncton"),("6077128", "Mont-Laurier", "", "CA", "124", "", "10", "15", "79088", "46.55011", "-75.4993", "America/Toronto"),("6077243", "Montréal", "Монреаль", "CA", "124", "", "10", "06", "", "45.50884", "-73.58781", "America/Toronto"),("6077265", "Montréal-Ouest", "", "CA", "124", "", "10", "", "", "45.45286", "-73.64918", "America/Toronto"),("6077315", "Mont-Royal", "", "CA", "124", "", "10", "06", "66072", "45.51675", "-73.64918", "America/Toronto"),("6077340", "Mont-Saint-Hilaire", "", "CA", "124", "", "10", "16", "57035", "45.56515", "-73.1868", "America/Toronto"),("6077445", "Mont-Tremblant", "", "CA", "124", "", "10", "15", "", "46.21274", "-74.58438", "America/Toronto"),("6078112", "Moose Jaw", "Мус-Джо", "CA", "124", "", "11", "", "", "50.40005", "-105.53445", "America/Regina"),("6078447", "Morden", "", "CA", "124", "", "03", "", "", "49.1919", "-98.10136", "America/Winnipeg"),("6078636", "Morinville", "", "CA", "124", "", "01", "", "", "53.80014", "-113.65203", "America/Edmonton"),("6082231", "Mount Pearl", "", "CA", "124", "", "05", "", "", "47.51659", "-52.78135", "America/St_Johns"),("6085772", "Nanaimo", "Нанаймо", "CA", "124", "", "02", "", "", "49.16638", "-123.94003", "America/Vancouver"),("6086871", "Nelson", "", "CA", "124", "", "02", "", "", "49.49985", "-117.28553", "America/Vancouver"),("6087579", "New Glasgow", "", "CA", "124", "", "07", "", "", "45.58344", "-62.64863", "America/Halifax"),("6087701", "Newmarket", "Ньюмаркет", "CA", "124", "", "08", "", "", "44.05011", "-79.46631", "America/Toronto"),("6087844", "New Westminster", "Нью-Уэстминстер", "CA", "124", "", "02", "", "", "49.20678", "-122.91092", "America/Vancouver"),("6087892", "Niagara Falls", "Ниагара-Фолс", "CA", "124", "", "08", "", "", "43.10012", "-79.06627", "America/Toronto"),("6088132", "Nicolet", "", "CA", "124", "", "10", "17", "50072", "46.21676", "-72.61582", "America/Toronto"),("6089125", "Norfolk County", "", "CA", "124", "", "08", "", "", "42.8334", "-80.38297", "America/Toronto"),("6089404", "North Battleford", "", "CA", "124", "", "11", "", "", "52.77972", "-108.2967", "America/Regina"),("6089426", "North Bay", "Норт-Бей", "CA", "124", "", "08", "6088501", "", "46.3168", "-79.46633", "America/Toronto"),("6089661", "North Cowichan", "", "CA", "124", "", "02", "", "", "48.84133", "-123.68596", "America/Vancouver"),("6090405", "North Perth", "", "CA", "124", "", "08", "", "", "43.7251", "-80.96723", "America/Toronto"),("6090579", "North Saanich", "", "CA", "124", "", "02", "", "", "48.66634", "-123.41933", "America/Vancouver"),("6090785", "North Vancouver", "", "CA", "124", "", "02", "5909", "", "49.31636", "-123.06934", "America/Vancouver"),("6091104", "North York", "Норт-Йорк", "CA", "124", "", "08", "", "", "43.76681", "-79.4163", "America/Toronto"),("6091369", "Notre-Dame-de-l'Île-Perrot", "", "CA", "124", "", "10", "16", "71065", "45.36678", "-73.9325", "America/Toronto"),("6091422", "Notre-Dame-des-Prairies", "", "CA", "124", "", "10", "14", "61030", "46.05007", "-73.43245", "America/Toronto"),("6091919", "Oak Bay", "", "CA", "124", "", "02", "", "", "48.44964", "-123.3026", "America/Vancouver"),("6092122", "Oakville", "Оквилл", "CA", "124", "", "08", "", "", "43.45011", "-79.68292", "America/Toronto"),("6093010", "Okotoks", "", "CA", "124", "", "01", "", "", "50.72885", "-113.98281", "America/Edmonton"),("6093347", "Olds", "", "CA", "124", "", "01", "", "", "51.78341", "-114.10199", "America/Edmonton"),("6094201", "Orangeville", "", "CA", "124", "", "08", "", "", "43.9168", "-80.09967", "America/Toronto"),("6094325", "Orillia", "Ориллия", "CA", "124", "", "08", "", "", "44.60868", "-79.42068", "America/Toronto"),("6094407", "Oromocto", "", "CA", "124", "", "04", "", "", "45.83512", "-66.47917", "America/Moncton"),("6094578", "Oshawa", "Ошава", "CA", "124", "", "08", "", "", "43.90012", "-78.84957", "America/Toronto"),("6094817", "Ottawa", "Оттава", "CA", "124", "", "08", "", "", "45.41117", "-75.69812", "America/Toronto"),("6094884", "Otterburn Park", "", "CA", "124", "", "10", "16", "57030", "45.53338", "-73.21585", "America/Toronto"),("6095645", "Owen Sound", "Оуэн-Саунд", "CA", "124", "", "08", "", "", "44.56717", "-80.94349", "America/Toronto"),("6098642", "Parksville", "", "CA", "124", "", "02", "5921", "", "49.31947", "-124.31575", "America/Vancouver"),("6098747", "Parry Sound", "", "CA", "124", "", "08", "6098746", "", "45.34732", "-80.03527", "America/Toronto"),("6100069", "Peace River", "", "CA", "124", "", "01", "", "", "56.23715", "-117.29176", "America/Edmonton"),("6100832", "Pembroke", "", "CA", "124", "", "08", "", "", "45.81681", "-77.11616", "America/Toronto"),("6101141", "Penticton", "", "CA", "124", "", "02", "", "", "49.48062", "-119.58584", "America/Vancouver"),("6101546", "Perth", "", "CA", "124", "", "08", "", "", "44.90011", "-76.24939", "America/Toronto"),("6101606", "Petawawa", "", "CA", "124", "", "08", "", "", "45.89452", "-77.28007", "America/Toronto"),("6101645", "Peterborough", "Питерборо", "CA", "124", "", "08", "", "", "44.30012", "-78.31623", "America/Toronto"),("6103581", "Petrolia", "", "CA", "124", "", "08", "", "", "42.86678", "-82.14981", "America/Toronto"),("6104111", "Pickering", "Пикеринг", "CA", "124", "", "08", "", "", "43.90012", "-79.13289", "America/Toronto"),("6104876", "Pincourt", "", "CA", "124", "", "10", "16", "71070", "45.38338", "-73.9825", "America/Toronto"),("6105815", "Pitt Meadows", "Питт-Медоус", "CA", "124", "", "02", "", "", "49.22119", "-122.68965", "America/Vancouver"),("6107272", "Pointe-Calumet", "", "CA", "124", "", "10", "15", "72020", "45.50008", "-73.9659", "America/Toronto"),("6107325", "Pointe-Claire", "", "CA", "124", "", "10", "06", "", "45.44868", "-73.81669", "America/Toronto"),("6109273", "Ponoka", "", "CA", "124", "", "01", "", "", "52.6768", "-113.58147", "America/Edmonton"),("6110611", "Pont Rouge", "", "CA", "124", "", "10", "02", "92015", "48.88332", "-72.08247", "America/Toronto"),("6111529", "Portage la Prairie", "", "CA", "124", "", "03", "", "", "49.97282", "-98.29263", "America/Winnipeg"),("6111632", "Port Alberni", "", "CA", "124", "", "02", "", "", "49.24133", "-124.8028", "America/Vancouver"),("6111696", "Port-Cartier", "", "CA", "124", "", "10", "09", "97022", "50.03339", "-66.86545", "America/Toronto"),("6111704", "Port Colborne", "", "CA", "124", "", "08", "", "", "42.90012", "-79.23288", "America/Toronto"),("6111962", "Port Moody", "", "CA", "124", "", "02", "", "", "49.28297", "-122.85263", "America/Vancouver"),("6112608", "Powell River", "", "CA", "124", "", "02", "5927", "", "49.83278", "-124.52368", "America/Vancouver"),("6113198", "Prévost", "", "CA", "124", "", "10", "15", "75040", "45.86678", "-74.08251", "America/Toronto"),("6113335", "Prince Albert", "Принс-Альберт", "CA", "124", "", "11", "", "", "53.20008", "-105.76772", "America/Regina"),("6113355", "Prince Edward", "", "CA", "124", "", "08", "", "", "44.00012", "-77.24946", "America/Toronto"),("6113365", "Prince George", "Принс-Джордж", "CA", "124", "", "02", "", "", "53.9166", "-122.75301", "America/Vancouver"),("6113406", "Prince Rupert", "", "CA", "124", "", "02", "5947", "", "54.31507", "-130.32098", "America/Vancouver"),("6113466", "Princeville", "", "CA", "124", "", "07", "", "", "45.76684", "-61.29853", "America/Halifax"),("6115187", "Quesnel", "", "CA", "124", "", "02", "", "", "52.97842", "-122.4931", "America/Vancouver"),("6115355", "Quinte West", "", "CA", "124", "", "08", "", "", "44.18342", "-77.56618", "America/Toronto"),("6117611", "Rawdon", "", "CA", "124", "", "10", "14", "", "46.05007", "-73.71587", "America/Toronto"),("6117731", "Rayside-Balfour", "", "CA", "124", "", "08", "", "", "46.60873", "-81.20763", "America/Toronto"),("6118158", "Red Deer", "Ред-Дир", "CA", "124", "", "01", "", "", "52.26682", "-113.802", "America/Edmonton"),("6119109", "Regina", "Реджайна", "CA", "124", "", "11", "", "", "50.45008", "-104.6178", "America/Regina"),("6119448", "Renfrew", "", "CA", "124", "", "08", "", "", "45.46681", "-76.68272", "America/Toronto"),("6119518", "Repentigny", "Репантиньи", "CA", "124", "", "10", "14", "", "45.74222", "-73.45008", "America/Toronto"),("6121621", "Revelstoke", "", "CA", "124", "", "02", "5939", "", "50.99712", "-118.1953", "America/Vancouver"),("6122037", "Richelieu", "", "CA", "124", "", "10", "16", "", "45.44336", "-73.24602", "America/Toronto"),("6122085", "Richmond", "Ричмонд", "CA", "124", "", "02", "", "", "49.17003", "-123.13683", "America/Vancouver"),("6122091", "Richmond Hill", "", "CA", "124", "", "08", "6185560", "", "43.87111", "-79.43725", "America/Toronto"),("6125653", "Roberval", "", "CA", "124", "", "10", "02", "91025", "48.5168", "-72.23244", "America/Toronto"),("6126305", "Rock Forest", "", "CA", "124", "", "10", "05", "43027", "45.35699", "-71.99676", "America/Toronto"),("6126749", "Rocky Mountain House", "", "CA", "124", "", "01", "", "", "52.36683", "-114.9188", "America/Edmonton"),("6127681", "Rosemère", "", "CA", "124", "", "10", "15", "", "45.63338", "-73.79919", "America/Toronto"),("6128577", "Rouyn-Noranda", "Руэн-Норанда", "CA", "124", "", "10", "08", "86042", "48.23656", "-79.02311", "America/Toronto"),("6137063", "Sackville", "", "CA", "124", "", "04", "", "", "45.91875", "-64.38455", "America/Moncton"),("6137270", "Saguenay", "Сагеней", "CA", "124", "", "10", "02", "94068", "48.41675", "-71.06573", "America/Toronto"),("6137489", "Saint-Basile-le-Grand", "", "CA", "124", "", "10", "16", "57020", "45.53338", "-73.28246", "America/Toronto"),("6137540", "Saint-Bruno-de-Montarville", "", "CA", "124", "", "10", "", "", "45.53341", "-73.34916", "America/Toronto"),("6137633", "Saint-Constant", "", "CA", "124", "", "10", "16", "67035", "45.36678", "-73.56588", "America/Toronto"),("6137696", "Sainte-Adèle", "", "CA", "124", "", "10", "15", "", "45.95008", "-74.13251", "America/Toronto"),("6137702", "Sainte-Agathe-des-Monts", "", "CA", "124", "", "10", "15", "", "46.05009", "-74.28252", "America/Toronto"),("6137733", "Sainte-Anne-de-Bellevue", "", "CA", "124", "", "10", "", "", "45.40618", "-73.9456", "America/Toronto"),("6137749", "Sainte-Anne-des-Monts", "", "CA", "124", "", "10", "11", "04037", "49.12402", "-66.49243", "America/Toronto"),("6137753", "Sainte-Anne-des-Plaines", "", "CA", "124", "", "10", "15", "73035", "45.76468", "-73.81156", "America/Toronto"),("6137780", "Sainte-Catherine", "", "CA", "124", "", "10", "16", "67030", "45.40008", "-73.58248", "America/Toronto"),("6137781", "Sainte-Catherine", "", "CA", "124", "", "10", "04", "37067", "46.31836", "-72.56632", "America/Toronto"),("6137941", "Sainte-Julie", "", "CA", "124", "", "10", "16", "59010", "45.58338", "-73.33246", "America/Toronto"),("6138032", "Sainte-Marthe-sur-le-Lac", "", "CA", "124", "", "10", "15", "72015", "45.53338", "-73.9325", "America/Toronto"),("6138121", "Sainte-Thérèse", "", "CA", "124", "", "10", "15", "73010", "45.63922", "-73.82757", "America/Toronto"),("6138175", "Saint-Eustache", "", "CA", "124", "", "10", "15", "72005", "45.565", "-73.90554", "America/Toronto"),("6138201", "Saint-Félicien", "", "CA", "124", "", "10", "02", "91042", "48.65007", "-72.44906", "America/Toronto"),("6138210", "Saint-Félix-de-Valois", "", "CA", "124", "", "10", "14", "62007", "46.16977", "-73.42525", "America/Toronto"),("6138352", "Saint-Hippolyte", "", "CA", "124", "", "10", "15", "75045", "45.93338", "-74.0159", "America/Toronto"),("6138374", "Saint-Hyacinthe", "Санкт-Гиацинт", "CA", "124", "", "10", "16", "54048", "45.63076", "-72.95699", "America/Toronto"),("6138495", "Saint-Jean-sur-Richelieu", "Сен-Жан-сюр-Ришелье", "CA", "124", "", "10", "16", "56083", "45.30713", "-73.26259", "America/Toronto"),("6138501", "Saint-Jérôme", "Сен-Жером", "CA", "124", "", "10", "15", "75017", "45.78036", "-74.00365", "America/Toronto"),("6138517", "Saint John", "Сент-Джон", "CA", "124", "", "04", "1301", "", "45.27271", "-66.06766", "America/Moncton"),("6138573", "Saint-Joseph-du-Lac", "", "CA", "124", "", "10", "15", "72025", "45.53338", "-73.9992", "America/Toronto"),("6138610", "Saint-Laurent", "Сен-Лоран", "CA", "124", "", "10", "06", "66072", "45.50008", "-73.66585", "America/Toronto"),("6138617", "Saint-Lazare", "", "CA", "124", "", "10", "16", "71105", "45.40008", "-74.13256", "America/Toronto"),("6138625", "Saint-Léonard", "", "CA", "124", "", "10", "06", "", "45.58773", "-73.59501", "America/Toronto"),("6138643", "Saint-Lin-Laurentides", "", "CA", "124", "", "10", "14", "63048", "45.85008", "-73.76588", "America/Toronto"),("6138916", "Saint-Pie", "", "CA", "124", "", "10", "16", "54008", "45.50277", "-72.9089", "America/Toronto"),("6138980", "Saint-Raymond", "", "CA", "124", "", "10", "", "", "45.46698", "-73.60948", "America/Toronto"),("6139045", "Saint-Sauveur", "", "CA", "124", "", "10", "15", "77043", "45.88686", "-74.17943", "America/Toronto"),("6139216", "Saint-Zotique", "", "CA", "124", "", "10", "16", "71025", "45.25009", "-74.24924", "America/Toronto"),("6139289", "Salaberry-de-Valleyfield", "Салаберри-де-Валлифилд", "CA", "124", "", "10", "16", "70052", "45.25008", "-74.13253", "America/Toronto"),("6139416", "Salmon Arm", "Сэлмон-Арм", "CA", "124", "", "02", "", "", "50.6998", "-119.30237", "America/Vancouver"),("6141190", "Sarnia", "Сарния", "CA", "124", "", "08", "6049019", "", "42.97866", "-82.40407", "America/Toronto"),("6141256", "Saskatoon", "Саскатун", "CA", "124", "", "11", "", "", "52.13238", "-106.66892", "America/Regina"),("6141439", "Sault Ste. Marie", "", "CA", "124", "", "08", "5883638", "", "46.51677", "-84.33325", "America/Toronto"),("6143367", "Sechelt", "", "CA", "124", "", "02", "5929", "", "49.47512", "-123.75903", "America/Vancouver"),("6144054", "Selkirk", "", "CA", "124", "", "03", "", "", "50.1436", "-96.88452", "America/Winnipeg"),("6144312", "Sept-Îles", "Сет-Иль", "CA", "124", "", "10", "09", "97007", "50.20011", "-66.38208", "America/Toronto"),("6145489", "Shawinigan", "Шавиниган", "CA", "124", "", "10", "04", "", "46.56675", "-72.74913", "America/Toronto"),("6146143", "Sherbrooke", "Шербрук", "CA", "124", "", "10", "05", "43027", "45.40008", "-71.89908", "America/Toronto"),("6146279", "Sherwood Park", "", "CA", "124", "", "01", "", "", "53.51684", "-113.3187", "America/Edmonton"),("6149374", "Slave Lake", "", "CA", "124", "", "01", "", "", "55.28344", "-114.76896", "America/Edmonton"),("6149996", "Smithers", "", "CA", "124", "", "02", "", "", "54.78036", "-127.17428", "America/Vancouver"),("6150174", "Smiths Falls", "", "CA", "124", "", "08", "6049130", "", "44.90452", "-76.02333", "America/Toronto"),("6151264", "Sooke", "", "CA", "124", "", "02", "", "", "48.37463", "-123.72762", "America/Vancouver"),("6151352", "Sorel-Tracy", "Сорель-Трейси", "CA", "124", "", "10", "16", "53052", "46.03336", "-73.11585", "America/Toronto"),("6152244", "South Huron", "", "CA", "124", "", "08", "", "", "43.31679", "-81.51647", "America/Toronto"),("6154383", "Spruce Grove", "", "CA", "124", "", "01", "", "", "53.53344", "-113.91874", "America/Edmonton"),("6155033", "St. Albert", "", "CA", "124", "", "01", "", "", "53.63344", "-113.63533", "America/Edmonton"),("6155721", "St. Catharines", "Сент-Катаринс", "CA", "124", "", "08", "6087883", "", "43.17126", "-79.24267", "America/Toronto"),("6156102", "Steinbach", "", "CA", "124", "", "03", "", "", "49.52579", "-96.68451", "America/Winnipeg"),("6156244", "Stephenville", "", "CA", "124", "", "05", "", "", "48.55001", "-58.5818", "America/St_Johns"),("6156307", "Stettler", "", "CA", "124", "", "01", "", "", "52.31683", "-112.71861", "America/Edmonton"),("6157536", "Stony Plain", "", "CA", "124", "", "01", "", "", "53.53343", "-114.00205", "America/Edmonton"),("6157977", "Stratford", "Стратфорд", "CA", "124", "", "08", "", "", "43.36679", "-80.94972", "America/Toronto"),("6158023", "Strathmore", "", "CA", "124", "", "01", "", "", "51.05011", "-113.38523", "America/Edmonton"),("6158357", "St. Thomas", "", "CA", "124", "", "08", "", "", "42.77361", "-81.18038", "America/Toronto"),("6159232", "Summerland", "", "CA", "124", "", "02", "", "", "49.59977", "-119.66911", "America/Vancouver"),("6159244", "Summerside", "", "CA", "124", "", "09", "1103", "", "46.39593", "-63.78762", "America/Halifax"),("6159905", "Surrey", "Суррей", "CA", "124", "", "02", "", "", "49.10635", "-122.82509", "America/Vancouver"),("6160603", "Swift Current", "", "CA", "124", "", "11", "", "", "50.28337", "-107.80135", "America/Swift_Current"),("6160806", "Sylvan Lake", "", "CA", "124", "", "01", "", "", "52.31681", "-114.0853", "America/Edmonton"),("6160919", "Taber", "", "CA", "124", "", "01", "", "", "49.78703", "-112.14603", "America/Edmonton"),("6162659", "Temiskaming Shores", "", "CA", "124", "", "08", "", "", "47.49376", "-79.71529", "America/Toronto"),("6162949", "Terrace", "", "CA", "124", "", "02", "", "", "54.51634", "-128.60345", "America/Vancouver"),("6163012", "Terrebonne", "Тербон", "CA", "124", "", "10", "14", "64008", "45.70004", "-73.64732", "America/Toronto"),("6164499", "The Pas", "", "CA", "124", "", "03", "", "", "53.82509", "-101.25413", "America/Winnipeg"),("6165406", "Thompson", "", "CA", "124", "", "03", "", "", "55.7435", "-97.85579", "America/Winnipeg"),("6165719", "Thorold", "", "CA", "124", "", "08", "", "", "43.11682", "-79.19958", "America/Toronto"),("6166142", "Thunder Bay", "Тандер-Бей", "CA", "124", "", "08", "6166139", "", "48.38202", "-89.25018", "America/Thunder_Bay"),("6166739", "Timmins", "", "CA", "124", "", "08", "", "", "48.46686", "-81.33312", "America/Toronto"),("6167865", "Toronto", "Торонто", "CA", "124", "", "08", "", "", "43.70011", "-79.4163", "America/Toronto"),("6168326", "Trail", "", "CA", "124", "", "02", "", "", "49.09983", "-117.70223", "America/Vancouver"),("6169141", "Trois-Rivières", "Труа-Ривьер", "CA", "124", "", "10", "04", "37067", "46.34515", "-72.5477", "America/Toronto"),("6169587", "Truro", "Труро", "CA", "124", "", "07", "", "", "45.36685", "-63.26538", "America/Halifax"),("6172932", "Uxbridge", "", "CA", "124", "", "08", "", "", "44.10012", "-79.11628", "America/Toronto"),("6173012", "Val-des-Monts", "", "CA", "124", "", "10", "07", "82015", "45.6501", "-75.66604", "America/Toronto"),("6173017", "Val-d'Or", "Валь-д'Ор", "CA", "124", "", "10", "08", "89008", "48.0974", "-77.79737", "America/Toronto"),("6173331", "Vancouver", "Ванкувер", "CA", "124", "", "02", "", "", "49.24966", "-123.11934", "America/Vancouver"),("6173508", "Varennes", "", "CA", "124", "", "10", "16", "", "45.68338", "-73.43246", "America/Toronto"),("6173570", "Vaudreuil-Dorion", "", "CA", "124", "", "10", "16", "71083", "45.40008", "-74.03251", "America/Toronto"),("6173577", "Vaughan", "Вон", "CA", "124", "", "08", "", "", "43.8361", "-79.49827", "America/Toronto"),("6173635", "Vegreville", "", "CA", "124", "", "01", "", "", "53.50015", "-112.05182", "America/Edmonton"),("6173864", "Vernon", "Вернон", "CA", "124", "", "02", "5937", "", "50.26729", "-119.27337", "America/Vancouver"),("6174041", "Victoria", "Виктория", "CA", "124", "", "02", "", "", "48.43294", "-123.3693", "America/Vancouver"),("6174151", "Victoriaville", "Викториавилл", "CA", "124", "", "10", "17", "39062", "46.05007", "-71.96579", "America/Toronto"),("6175059", "Wainwright", "", "CA", "124", "", "01", "", "", "52.83482", "-110.85342", "America/Edmonton"),("6176421", "Wasaga Beach", "", "CA", "124", "", "08", "", "", "44.5168", "-80.01637", "America/Toronto"),("6176823", "Waterloo", "Ватерлоо", "CA", "124", "", "08", "", "", "43.4668", "-80.51639", "America/Toronto"),("6177869", "Welland", "", "CA", "124", "", "08", "", "", "42.98342", "-79.24958", "America/Toronto"),("6178582", "West End", "", "CA", "124", "", "02", "", "", "49.28333", "-123.13333", "America/Vancouver"),("6179138", "Westlock", "", "CA", "124", "", "01", "", "", "54.15016", "-113.86876", "America/Edmonton"),("6179226", "Westmount", "Уэстмаунт", "CA", "124", "", "10", "", "", "45.48341", "-73.59918", "America/Toronto"),("6179602", "Wetaskiwin", "", "CA", "124", "", "01", "", "", "52.96683", "-113.36869", "America/Edmonton"),("6179652", "Weyburn", "", "CA", "124", "", "11", "", "", "49.66675", "-103.85109", "America/Regina"),("6180144", "Whistler", "", "CA", "124", "", "02", "", "", "50.1164", "-122.96946", "America/Vancouver"),("6180285", "Whitecourt", "", "CA", "124", "", "01", "", "", "54.15015", "-115.68548", "America/Edmonton"),("6180550", "Whitehorse", "Уайтхорс", "CA", "124", "", "12", "", "", "60.71611", "-135.05375", "America/Whitehorse"),("6180961", "White Rock", "", "CA", "124", "", "02", "5915", "", "49.01636", "-122.8026", "America/Vancouver"),("6182212", "Williams Lake", "", "CA", "124", "", "02", "5941", "", "52.14153", "-122.14451", "America/Vancouver"),("6182959", "Windsor", "", "CA", "124", "", "10", "05", "42088", "45.56678", "-71.99909", "America/Toronto"),("6182962", "Windsor", "Уинсор", "CA", "124", "", "08", "", "", "42.30008", "-83.01654", "America/Toronto"),("6183204", "Winkler", "", "CA", "124", "", "03", "", "", "49.1817", "-97.94104", "America/Winnipeg"),("6183235", "Winnipeg", "Виннипег", "CA", "124", "", "03", "", "", "49.8844", "-97.14704", "America/Winnipeg"),("6184365", "Woodstock", "Вудсток", "CA", "124", "", "08", "6095780", "", "43.13339", "-80.7497", "America/Toronto"),("6185217", "Yarmouth", "", "CA", "124", "", "07", "", "", "43.83345", "-66.11557", "America/Halifax"),("6185377", "Yellowknife", "Йеллоунайф", "CA", "124", "", "13", "", "", "62.45411", "-114.37248", "America/Yellowknife"),("6185607", "Yorkton", "", "CA", "124", "", "11", "", "", "51.2167", "-102.46766", "America/Regina"),("6295855", "Beauceville", "", "CA", "124", "", "10", "12", "27028", "46.21785", "-70.77873", "America/Toronto"),("6324729", "Halifax", "Галифакс", "CA", "124", "", "07", "", "", "44.64533", "-63.57239", "America/Halifax"),("6324733", "St. John's", "Сент-Джонс", "CA", "124", "", "05", "", "", "47.56494", "-52.70931", "America/St_Johns"),("6325494", "Québec", "Квебек", "CA", "124", "", "10", "", "", "46.81228", "-71.21454", "America/Toronto"),("6325521", "Lévis", "Леви", "CA", "124", "", "10", "12", "25213", "46.80326", "-71.17793", "America/Blanc-Sablon"),("6325529", "Montmagny", "", "CA", "124", "", "10", "12", "", "46.98043", "-70.55493", "America/Toronto"),("6354895", "Rimouski", "Римуски", "CA", "124", "", "10", "01", "10043", "48.44879", "-68.52396", "America/Toronto"),("6354897", "Rivière-du-Loup", "Ривьер-дю-Лу", "CA", "124", "", "10", "01", "", "47.82699", "-69.54243", "America/Toronto"),("6354908", "Sydney", "", "CA", "124", "", "07", "Cape Breton County (undefined)", "", "46.1351", "-60.1831", "America/Glace_Bay"),("6534203", "L'Ancienne-Lorette", "", "CA", "124", "", "10", "", "", "46.79392", "-71.35191", "America/Toronto"),("6545023", "Edmundston", "Эдмундстон", "CA", "124", "", "04", "", "", "47.3737", "-68.32512", "America/Moncton"),("6620953", "Saint-Georges", "", "CA", "124", "", "10", "12", "29073", "46.11353", "-70.66526", "America/Toronto"),("6639619", "Sainte Catherine de la Jacques Cartier", "", "CA", "124", "", "10", "03", "22005", "46.85244", "-71.62056", "America/Toronto"),("6690232", "Baie-Saint-Paul", "", "CA", "124", "", "10", "03", "", "47.44109", "-70.49858", "America/Toronto"),("6696258", "Campbellton", "", "CA", "124", "", "04", "11", "", "48.00751", "-66.67272", "America/Moncton"),("6696259", "Bathurst", "", "CA", "124", "", "04", "", "", "47.61814", "-65.65112", "America/Moncton"),("6696260", "Matane", "", "CA", "124", "", "10", "01", "", "48.82857", "-67.52197", "America/Toronto"),("6942553", "Paris", "", "CA", "124", "", "08", "", "", "43.2", "-80.38333", "America/Toronto"),("6943488", "Amqui", "", "CA", "124", "", "10", "01", "07047", "48.46382", "-67.43134", "America/Toronto"),("6943811", "Chandler", "", "CA", "124", "", "10", "11", "02028", "48.34935", "-64.67926", "America/Toronto"),("6943827", "Thetford-Mines", "", "CA", "124", "", "10", "12", "31084", "46.09371", "-71.30539", "America/Toronto"),("6944113", "Mont-Joli", "", "CA", "124", "", "10", "01", "", "48.58388", "-68.19214", "America/Toronto"),("6945986", "La Malbaie", "", "CA", "124", "", "10", "03", "", "47.654", "-70.15268", "America/Toronto"),("6945989", "Sainte-Marie", "", "CA", "124", "", "10", "12", "", "46.43401", "-71.01168", "America/Toronto"),("6945991", "Plessisville", "", "CA", "124", "", "10", "04", "", "46.21856", "-71.76201", "America/Toronto"),("6948711", "Scarborough", "", "CA", "124", "", "08", "", "", "43.77223", "-79.25666", "America/Toronto"),("7280414", "Cole Harbour", "", "CA", "124", "", "07", "", "", "44.67244", "-63.47506", "America/Halifax"),("7281931", "Okanagan", "", "CA", "124", "", "02", "", "", "50.36386", "-119.34997", "America/Vancouver"),("7281936", "West Kelowna", "", "CA", "124", "", "02", "", "", "49.8625", "-119.58333", "America/Vancouver"),("7303783", "Sydney Mines", "", "CA", "124", "", "07", "", "", "46.23669", "-60.21767", "America/Glace_Bay"),("7303786", "Jonquière", "Жонкьер", "CA", "124", "", "10", "02", "94068", "48.41648", "-71.24884", "America/Toronto"),("7535681", "Saint-Augustin-de-Desmaures", "", "CA", "124", "", "10", "03", "", "46.74064", "-71.45131", "America/Toronto"),("7535690", "Donnacona", "", "CA", "124", "", "10", "03", "34025", "46.68042", "-71.7239", "America/Toronto"),("7602078", "Ladner", "", "CA", "124", "", "02", "", "", "49.08938", "-123.08241", "America/Vancouver"),("7669012", "Walnut Grove", "", "CA", "124", "", "02", "", "", "49.16473", "-122.64042", "America/Vancouver"),("7669018", "Aldergrove", "", "CA", "124", "", "02", "", "", "49.05801", "-122.47087", "America/Vancouver"),("7870925", "East York", "", "CA", "124", "", "08", "", "", "43.69053", "-79.32794", "America/Toronto"),("8285452", "Ancaster", "Анкастер", "CA", "124", "", "08", "", "", "43.21806", "-79.98716", "America/Toronto"),("8354533", "Shannon", "", "CA", "124", "", "10", "03", "22020", "46.88026", "-71.51464", "America/Toronto"),("8354586", "Saint-Henri", "", "CA", "124", "", "10", "12", "", "46.69314", "-71.06927", "America/Toronto"),("8379100", "Pont-Rouge", "", "CA", "124", "", "10", "03", "34017", "46.75468", "-71.69566", "America/Toronto"),("8379101", "Princeville", "", "CA", "124", "", "10", "17", "32033", "46.17163", "-71.87462", "America/Toronto"),("8533869", "West Vancouver", "", "CA", "124", "", "02", "", "", "49.36672", "-123.16652", "America/Vancouver"),("8558534", "Willowdale", "", "CA", "124", "", "08", "", "", "43.76672", "-79.39909", "America/Toronto"),("10287505", "Lower Sackville", "", "CA", "124", "", "07", "", "", "44.77599", "-63.67865", "America/Halifax"),("10627796", "le Plateau", "", "CA", "124", "", "10", "07", "81017", "45.43514", "-75.7803", "America/Toronto"),("11203927", "Wild Rose", "", "CA", "124", "", "01", "", "", "53.4708", "-113.38119", "America/Edmonton"),("11203928", "Silver Berry", "", "CA", "124", "", "01", "", "", "53.45787", "-113.3817", "America/Edmonton"),("7304591", "West Island", "", "CC", "166", "", "", "", "", "-12.15681", "96.82251", "Indian/Cocos"),("235826", "Zemio", "", "CF", "140", "", "05", "9143464", "", "5.03144", "25.13614", "Africa/Bangui"),("236524", "Rafaï", "", "CF", "140", "", "08", "9143468", "", "4.95", "23.91667", "Africa/Bangui"),("236901", "Ouadda", "", "CF", "140", "", "03", "9143466", "", "8.07771", "22.40075", "Africa/Bangui"),("236950", "Obo", "", "CF", "140", "", "05", "9143463", "", "5.39586", "26.49211", "Africa/Bangui"),("237379", "Ndélé", "", "CF", "140", "", "01", "9143460", "", "8.41091", "20.64728", "Africa/Bangui"),("237478", "Mobaye", "", "CF", "140", "", "02", "7731891", "", "4.31902", "21.17861", "Africa/Bangui"),("238373", "Kembé", "", "CF", "140", "", "02", "7731890", "", "4.62275", "21.88645", "Africa/Bangui"),("238566", "Ippy", "", "CF", "140", "", "11", "7732067", "", "6.26793", "21.22468", "Africa/Bangui"),("239899", "Bria", "Бриа", "CF", "140", "", "03", "9143465", "", "6.54233", "21.98633", "Africa/Bangui"),("240210", "Birao", "", "CF", "140", "", "14", "9143458", "", "10.28488", "22.78818", "Africa/Bangui"),("240498", "Bangassou", "Бангасу", "CF", "140", "", "08", "7732064", "", "4.74132", "22.81838", "Africa/Bangui"),("240604", "Bambari", "Бамбари", "CF", "140", "", "11", "7732062", "", "5.76795", "20.67565", "Africa/Bangui"),("240999", "Alindao", "", "CF", "140", "", "02", "9143474", "", "5.02667", "21.20876", "Africa/Bangui"),("2383119", "Sibut", "Сибут", "CF", "140", "", "06", "7732483", "", "5.71801", "19.07389", "Africa/Bangui"),("2383523", "Paoua", "", "CF", "140", "", "13", "9143494", "", "7.24269", "16.44059", "Africa/Bangui"),("2383827", "Nola", "", "CF", "140", "", "16", "7731904", "", "3.52494", "16.04583", "Africa/Bangui"),("2384377", "Mongoumba", "", "CF", "140", "", "07", "7731898", "", "3.64153", "18.59364", "Africa/Bangui"),("2384770", "Mbaïki", "", "CF", "140", "", "07", "7732068", "", "3.86781", "17.98923", "Africa/Bangui"),("2385535", "Kouango", "", "CF", "140", "", "11", "7731893", "", "4.99337", "19.96186", "Africa/Bangui"),("2386012", "Kaga Bandoro", "", "CF", "140", "", "15", "9143469", "", "6.98961", "19.18744", "Africa/Bangui"),("2386042", "Kabo", "", "CF", "140", "", "12", "9143478", "", "7.69937", "18.62903", "Africa/Bangui"),("2386756", "Gamboula", "", "CF", "140", "", "04", "7732916", "", "4.11775", "15.13926", "Africa/Bangui"),("2387435", "Damara", "Дамара", "CF", "140", "", "17", "7731895", "", "4.96075", "18.7035", "Africa/Bangui"),("2387495", "Carnot", "", "CF", "140", "", "04", "2387494", "", "4.94273", "15.87735", "Africa/Bangui"),("2387546", "Bozoum", "Бозуме", "CF", "140", "", "13", "8299286", "", "6.31933", "16.37992", "Africa/Bangui"),("2387890", "Bouca", "", "CF", "140", "", "12", "9143477", "", "6.50734", "18.2767", "Africa/Bangui"),("2387926", "Bouar", "Буаре", "CF", "140", "", "09", "7732085", "", "5.93404", "15.59599", "Africa/Bangui"),("2388036", "Bossangoa", "Босангоа", "CF", "140", "", "12", "7732115", "", "6.49263", "17.45518", "Africa/Bangui"),("2388614", "Boda", "", "CF", "140", "", "07", "9143467", "", "4.31887", "17.46953", "Africa/Bangui"),("2388720", "Boali", "", "CF", "140", "", "17", "8299285", "", "4.80048", "18.12747", "Africa/Bangui"),("2388873", "Bimbo", "", "CF", "140", "", "17", "7731896", "", "4.25671", "18.41583", "Africa/Bangui"),("2389086", "Berbérati", "Берберати", "CF", "140", "", "04", "7732685", "", "4.26116", "15.79216", "Africa/Bangui"),("2389691", "Batangafo", "", "CF", "140", "", "12", "9143472", "", "7.30082", "18.2833", "Africa/Bangui"),("2389804", "Baoro", "", "CF", "140", "", "09", "7732103", "", "5.66667", "15.96667", "Africa/Bangui"),("2389853", "Bangui", "Банги", "CF", "140", "", "18", "7731897", "", "4.36122", "18.55496", "Africa/Bangui"),("2657896", "Zürich", "Цюрих", "CH", "756", "", "ZH", "112", "261", "47.36667", "8.55", "Europe/Zurich"),("2657908", "Zug", "Цуг", "CH", "756", "", "ZG", "900", "1711", "47.17242", "8.51745", "Europe/Zurich"),("2657910", "Zuchwil", "", "CH", "756", "", "SO", "1106", "2534", "47.20173", "7.56649", "Europe/Zurich"),("2657912", "Zollikon", "", "CH", "756", "", "ZH", "107", "161", "47.34019", "8.57407", "Europe/Zurich"),("2657913", "Zollikofen", "", "CH", "756", "", "BE", "246", "361", "46.99905", "7.45809", "Europe/Zurich"),("2657915", "Zofingen", "", "CH", "756", "", "AG", "1910", "4289", "47.28779", "7.94586", "Europe/Zurich"),("2657928", "Zermatt", "", "CH", "756", "", "VS", "2313", "6300", "46.01998", "7.74863", "Europe/Zurich"),("2657941", "Yverdon-les-Bains", "Ивердон-ле-Бен", "CH", "756", "", "VD", "2224", "5938", "46.77852", "6.64115", "Europe/Zurich"),("2657947", "Würenlos", "", "CH", "756", "", "AG", "1902", "4048", "47.44208", "8.36439", "Europe/Zurich"),("2657954", "Worb", "", "CH", "756", "", "BE", "246", "627", "46.92984", "7.56306", "Europe/Zurich"),("2657955", "Wollerau", "", "CH", "756", "", "SZ", "503", "1321", "47.19478", "8.71903", "Europe/Zurich"),("2657963", "Wohlen", "", "CH", "756", "", "AG", "1903", "4082", "47.35236", "8.27877", "Europe/Zurich"),("2657964", "Wohlen", "", "CH", "756", "", "BE", "246", "360", "46.97118", "7.35685", "Europe/Zurich"),("2657968", "Wittenbach", "", "CH", "756", "", "SG", "1721", "3204", "47.46108", "9.38601", "Europe/Zurich"),("2657969", "Zürich (Kreis 7) / Witikon", "", "CH", "756", "", "ZH", "112", "261", "47.35751", "8.59105", "Europe/Zurich"),("2657970", "Winterthur", "Винтертур", "CH", "756", "", "ZH", "110", "230", "47.50564", "8.72413", "Europe/Zurich"),("2657976", "Windisch", "", "CH", "756", "", "AG", "1904", "4123", "47.47899", "8.21842", "Europe/Zurich"),("2657996", "Wil", "Виль", "CH", "756", "", "SG", "1728", "3427", "47.46152", "9.04552", "Europe/Zurich"),("2658007", "Zürich (Kreis 3) / Alt-Wiedikon", "", "CH", "756", "CH", "ZH", "112", "261", "47.36201", "8.51497", "Europe/Zurich"),("2658010", "Wetzikon", "", "CH", "756", "", "ZH", "105", "121", "47.3264", "8.79779", "Europe/Zurich"),("2658011", "Wettingen", "Веттинген", "CH", "756", "", "AG", "1902", "4045", "47.47049", "8.31636", "Europe/Zurich"),("2658036", "Weinfelden", "", "CH", "756", "", "TG", "2015", "4946", "47.56667", "9.1", "Europe/Zurich"),("2658042", "Wattwil", "", "CH", "756", "", "SG", "1727", "3379", "47.29955", "9.08657", "Europe/Zurich"),("2658060", "Wallisellen", "", "CH", "756", "", "ZH", "103", "69", "47.41499", "8.59672", "Europe/Zurich"),("2658076", "Wahlern", "", "CH", "756", "", "BE", "246", "855", "46.82806", "7.35318", "Europe/Zurich"),("2658082", "Wädenswil", "", "CH", "756", "", "ZH", "106", "142", "47.22683", "8.6687", "Europe/Zurich"),("2658112", "Visp", "", "CH", "756", "", "VS", "2313", "6297", "46.2937", "7.88149", "Europe/Zurich"),("2658119", "Villmergen", "", "CH", "756", "", "AG", "1903", "4080", "47.34917", "8.24583", "Europe/Zurich"),("2658128", "Villars-sur-Glâne", "", "CH", "756", "", "FR", "1004", "2228", "46.79054", "7.11717", "Europe/Zurich"),("2658135", "Viganello", "", "CH", "756", "", "TI", "2105", "5192", "46.01342", "8.96879", "Europe/Zurich"),("2658143", "Veyrier", "", "CH", "756", "", "GE", "2500", "6645", "46.16699", "6.18436", "Europe/Zurich"),("2658145", "Vevey", "Веве", "CH", "756", "", "VD", "2230", "5890", "46.46299", "6.84345", "Europe/Zurich"),("2658151", "Versoix", "", "CH", "756", "", "GE", "2500", "6644", "46.28382", "6.16214", "Europe/Zurich"),("2658154", "Vernier", "", "CH", "756", "", "GE", "2500", "6643", "46.21702", "6.08497", "Europe/Zurich"),("2658172", "Veltheim (Kreis 5)", "", "CH", "756", "", "ZH", "110", "230", "47.51419", "8.717", "Europe/Zurich"),("2658209", "Uzwil", "", "CH", "756", "", "SG", "1728", "3408", "47.43653", "9.13422", "Europe/Zurich"),("2658210", "Uznach", "", "CH", "756", "", "SG", "1726", "3339", "47.22421", "8.98263", "Europe/Zurich"),("2658216", "Uster", "Устер", "CH", "756", "", "ZH", "109", "198", "47.34713", "8.72091", "Europe/Zurich"),("2658217", "Urtenen", "", "CH", "756", "", "BE", "246", "551", "47.02667", "7.50081", "Europe/Zurich"),("2658237", "Untersiggenthal", "", "CH", "756", "", "AG", "1902", "4044", "47.50213", "8.25554", "Europe/Zurich"),("2658240", "Unterseen", "", "CH", "756", "", "BE", "250", "593", "46.6853", "7.84722", "Europe/Zurich"),("2658264", "Unterägeri", "", "CH", "756", "", "ZG", "900", "1709", "47.13645", "8.5853", "Europe/Zurich"),("2658277", "Uetendorf", "", "CH", "756", "", "BE", "247", "944", "46.77392", "7.57251", "Europe/Zurich"),("2658312", "Trimbach", "", "CH", "756", "", "SO", "1105", "2500", "47.36561", "7.8868", "Europe/Zurich"),("2658344", "Töss (Kreis 4)", "", "CH", "756", "CH", "ZH", "110", "230", "47.4789", "8.70215", "Europe/Zurich"),("2658377", "Thun", "Тун", "CH", "756", "", "BE", "247", "942", "46.75118", "7.62166", "Europe/Zurich"),("2658386", "Therwil", "", "CH", "756", "", "BL", "1301", "2775", "47.50117", "7.55286", "Europe/Zurich"),("2658388", "Thalwil", "", "CH", "756", "", "ZH", "106", "141", "47.29175", "8.56351", "Europe/Zurich"),("2658397", "Teufen", "", "CH", "756", "", "AR", "1502", "3024", "47.3908", "9.38644", "Europe/Zurich"),("2658440", "Sursee", "", "CH", "756", "", "LU", "314", "1095", "47.17088", "8.11113", "Europe/Zurich"),("2658449", "Sumiswald", "", "CH", "756", "", "BE", "245", "957", "47.02747", "7.74526", "Europe/Zurich"),("2658457", "Suhr", "", "CH", "756", "", "AG", "1901", "4012", "47.37172", "8.07967", "Europe/Zurich"),("2658483", "Steinhausen", "", "CH", "756", "", "ZG", "900", "1702", "47.1951", "8.48581", "Europe/Zurich"),("2658494", "Steffisburg", "", "CH", "756", "", "BE", "247", "939", "46.77807", "7.63249", "Europe/Zurich"),("2658504", "Stans", "", "CH", "756", "", "NW", "700", "1509", "46.95805", "8.36609", "Europe/Zurich"),("2658518", "Stäfa", "", "CH", "756", "", "ZH", "107", "158", "47.24254", "8.72342", "Europe/Zurich"),("2658524", "Spreitenbach", "", "CH", "756", "", "AG", "1902", "4040", "47.42016", "8.36301", "Europe/Zurich"),("2658536", "Spiez", "", "CH", "756", "", "BE", "249", "768", "46.68473", "7.69111", "Europe/Zurich"),("2658564", "Solothurn", "", "CH", "756", "", "SO", "1109", "2601", "47.20791", "7.53714", "Europe/Zurich"),("2658572", "Sissach", "", "CH", "756", "", "BL", "1304", "2861", "47.46408", "7.80888", "Europe/Zurich"),("2658575", "Sirnach", "", "CH", "756", "", "TG", "2014", "4761", "47.46222", "8.99763", "Europe/Zurich"),("2658576", "Sitten", "Сьон", "CH", "756", "", "VS", "2312", "6266", "46.22739", "7.35559", "Europe/Zurich"),("2658606", "Sierre", "", "CH", "756", "", "VS", "2311", "6248", "46.29192", "7.53559", "Europe/Zurich"),("2658608", "Siebnen", "", "CH", "756", "", "SZ", "505", "1346", "47.17449", "8.89781", "Europe/Zurich"),("2658656", "Zürich (Kreis 11) / Seebach", "", "CH", "756", "", "ZH", "112", "261", "47.42181", "8.54779", "Europe/Zurich"),("2658665", "Schwyz", "", "CH", "756", "", "SZ", "506", "1372", "47.02076", "8.65414", "Europe/Zurich"),("2658696", "Schübelbach", "", "CH", "756", "", "SZ", "505", "1346", "47.17326", "8.92811", "Europe/Zurich"),("2658724", "Schlieren", "", "CH", "756", "", "ZH", "111", "247", "47.39668", "8.44763", "Europe/Zurich"),("2658761", "Schaffhausen", "Шаффхаузен", "CH", "756", "", "SH", "1403", "2939", "47.69732", "8.63493", "Europe/Zurich"),("2658775", "Savièse", "", "CH", "756", "", "VS", "2312", "6265", "46.25115", "7.34558", "Europe/Zurich"),("2658786", "Sarnen", "", "CH", "756", "", "OW", "600", "1407", "46.89611", "8.24531", "Europe/Zurich"),("2658793", "Sargans", "", "CH", "756", "", "SG", "1725", "3296", "47.04896", "9.44103", "Europe/Zurich"),("2658816", "Sankt Margrethen", "", "CH", "756", "", "SG", "1723", "3236", "47.45253", "9.63741", "Europe/Zurich"),("2658822", "Sankt Gallen", "Санкт-Галлен", "CH", "756", "", "SG", "1721", "3203", "47.42391", "9.37477", "Europe/Zurich"),("2658871", "Saint-Imier", "", "CH", "756", "", "BE", "241", "443", "47.15284", "6.99692", "Europe/Zurich"),("2658904", "Saanen", "", "CH", "756", "", "BE", "248", "843", "46.48945", "7.26003", "Europe/Zurich"),("2658909", "Rüti", "", "CH", "756", "", "ZH", "105", "117", "47.25603", "8.85552", "Europe/Zurich"),("2658914", "Ruswil", "", "CH", "756", "", "LU", "314", "1098", "47.08425", "8.12645", "Europe/Zurich"),("2658927", "Rümlang", "", "CH", "756", "", "ZH", "104", "97", "47.45041", "8.52993", "Europe/Zurich"),("2658950", "Rotkreuz", "", "CH", "756", "", "ZG", "900", "1707", "47.14059", "8.42934", "Europe/Zurich"),("2658952", "Rothrist", "", "CH", "756", "", "AG", "1910", "4282", "47.30508", "7.89196", "Europe/Zurich"),("2658969", "Rorschach", "", "CH", "756", "", "SG", "1722", "3215", "47.478", "9.4903", "Europe/Zurich"),("2658985", "Romanshorn", "", "CH", "756", "", "TG", "2011", "4436", "47.56586", "9.37869", "Europe/Zurich"),("2659050", "Richterswil", "", "CH", "756", "", "ZH", "106", "138", "47.20622", "8.69686", "Europe/Zurich"),("2659060", "Rheinfelden", "", "CH", "756", "", "AG", "1909", "4258", "47.55437", "7.79403", "Europe/Zurich"),("2659070", "Renens", "Ренан", "CH", "756", "", "VD", "2229", "5591", "46.53989", "6.5881", "Europe/Zurich"),("2659076", "Reinach", "", "CH", "756", "", "AG", "1905", "4141", "47.25944", "8.18845", "Europe/Zurich"),("2659083", "Regensdorf", "", "CH", "756", "", "ZH", "104", "96", "47.4341", "8.46874", "Europe/Zurich"),("2659099", "Rapperswil", "Рапперсвиль", "CH", "756", "", "SG", "1726", "3340", "47.22557", "8.82228", "Europe/Zurich"),("2659127", "Pully", "", "CH", "756", "", "VD", "2226", "5590", "46.51027", "6.66183", "Europe/Zurich"),("2659136", "Prilly", "", "CH", "756", "", "VD", "2229", "5591", "46.53698", "6.60456", "Europe/Zurich"),("2659142", "Pregassona", "", "CH", "756", "", "TI", "2105", "5192", "46.02021", "8.97429", "Europe/Zurich"),("2659147", "Pratteln", "", "CH", "756", "", "BL", "1303", "2831", "47.52071", "7.69356", "Europe/Zurich"),("2659171", "Porrentruy", "", "CH", "756", "", "JU", "2603", "6800", "47.41533", "7.07522", "Europe/Zurich"),("2659190", "Plan-les-Ouates", "", "CH", "756", "", "GE", "2500", "6633", "46.16789", "6.11664", "Europe/Zurich"),("2659219", "Pfäffikon", "", "CH", "756", "", "ZH", "108", "177", "47.36453", "8.79202", "Europe/Zurich"),("2659220", "Pfäffikon", "", "CH", "756", "", "SZ", "503", "1322", "47.20109", "8.77816", "Europe/Zurich"),("2659227", "Peseux", "", "CH", "756", "", "NE", "2401", "6412", "46.98704", "6.88903", "Europe/Zurich"),("2659243", "Payerne", "", "CH", "756", "", "VD", "2222", "5822", "46.82201", "6.93608", "Europe/Zurich"),("2659289", "Orbe", "", "CH", "756", "", "VD", "2224", "5757", "46.72504", "6.53069", "Europe/Zurich"),("2659296", "Onex", "", "CH", "756", "", "GE", "2500", "6631", "46.18396", "6.10237", "Europe/Zurich"),("2659297", "Olten", "Ольтен", "CH", "756", "", "SO", "1108", "2581", "47.34999", "7.90329", "Europe/Zurich"),("2659298", "Ollon", "", "CH", "756", "", "VD", "2221", "5409", "46.29524", "6.99314", "Europe/Zurich"),("2659303", "Oftringen", "", "CH", "756", "", "AG", "1910", "4280", "47.31382", "7.92533", "Europe/Zurich"),("2659310", "Zürich (Kreis 11) / Oerlikon", "", "CH", "756", "", "ZH", "112", "261", "47.40823", "8.54258", "Europe/Zurich"),("2659321", "Oberwil", "", "CH", "756", "", "BL", "1301", "2771", "47.51407", "7.55786", "Europe/Zurich"),("2659331", "Oberuzwil", "", "CH", "756", "", "SG", "1728", "3407", "47.43076", "9.12724", "Europe/Zurich"),("2659332", "Urdorf", "", "CH", "756", "", "ZH", "111", "250", "47.38507", "8.42581", "Europe/Zurich"),("2659344", "Obersiggenthal", "", "CH", "756", "", "AG", "1902", "4038", "47.4875", "8.29652", "Europe/Zurich"),("2659357", "Oberriet", "", "CH", "756", "", "SG", "1723", "3254", "47.32088", "9.56808", "Europe/Zurich"),("2659391", "Oberentfelden", "", "CH", "756", "", "AG", "1901", "4010", "47.35639", "8.04594", "Europe/Zurich"),("2659392", "Oberengstringen", "", "CH", "756", "", "ZH", "111", "245", "47.40841", "8.46515", "Europe/Zurich"),("2659422", "Nyon", "Ньон", "CH", "756", "", "VD", "2228", "5724", "46.38318", "6.23955", "Europe/Zurich"),("2659474", "Nidau", "", "CH", "756", "", "BE", "242", "743", "47.12545", "7.24033", "Europe/Zurich"),("2659485", "Neuhausen", "", "CH", "756", "", "SH", "1403", "2937", "47.68579", "8.61474", "Europe/Zurich"),("2659489", "Neuenkirch", "", "CH", "756", "", "LU", "314", "1093", "47.09989", "8.20416", "Europe/Zurich"),("2659490", "Neuenhof", "", "CH", "756", "", "AG", "1902", "4034", "47.4526", "8.32577", "Europe/Zurich"),("2659496", "Neuchâtel", "Невшатель", "CH", "756", "", "NE", "2404", "6458", "46.99179", "6.931", "Europe/Zurich"),("2659510", "Naters", "", "CH", "756", "", "VS", "2301", "6007", "46.32536", "7.98912", "Europe/Zurich"),("2659522", "Muttenz", "Муттенц", "CH", "756", "", "BL", "1301", "2770", "47.52271", "7.64511", "Europe/Zurich"),("2659529", "Murten/Morat", "", "CH", "756", "", "FR", "1005", "2275", "46.92827", "7.11715", "Europe/Zurich"),("2659531", "Muri", "", "CH", "756", "", "AG", "1908", "4236", "47.27428", "8.33854", "Europe/Zurich"),("2659532", "Muri", "", "CH", "756", "", "BE", "246", "356", "46.93122", "7.48658", "Europe/Zurich"),("2659546", "Münsingen", "", "CH", "756", "", "BE", "246", "616", "46.87298", "7.561", "Europe/Zurich"),("2659551", "Münchenstein", "", "CH", "756", "", "BL", "1301", "2769", "47.51848", "7.60966", "Europe/Zurich"),("2659552", "Münchenbuchsee", "", "CH", "756", "", "BE", "246", "546", "47.02175", "7.45036", "Europe/Zurich"),("2659568", "Moutier", "", "CH", "756", "", "BE", "241", "700", "47.27818", "7.36951", "Europe/Zurich"),("2659587", "Morges", "", "CH", "756", "", "VD", "2227", "5642", "46.51127", "6.49854", "Europe/Zurich"),("2659601", "Montreux", "Монтрё", "CH", "756", "", "VD", "2230", "5886", "46.43301", "6.91143", "Europe/Zurich"),("2659613", "Monthey", "Монте", "CH", "756", "", "VS", "2308", "6153", "46.25451", "6.95406", "Europe/Zurich"),("2659645", "Möhlin", "", "CH", "756", "", "AG", "1909", "4254", "47.55915", "7.84329", "Europe/Zurich"),("2659658", "Minusio", "", "CH", "756", "", "TI", "2104", "5118", "46.17769", "8.81473", "Europe/Zurich"),("2659667", "Meyrin", "Мерен", "CH", "756", "", "GE", "2500", "6630", "46.23424", "6.08025", "Europe/Zurich"),("2659687", "Menziken", "", "CH", "756", "", "AG", "1905", "4141", "47.24249", "8.19047", "Europe/Zurich"),("2659689", "Mendrisio", "", "CH", "756", "", "TI", "2106", "5254", "45.87019", "8.9816", "Europe/Zurich"),("2659708", "Meggen", "", "CH", "756", "", "LU", "312", "1063", "47.04691", "8.37467", "Europe/Zurich"),("2659739", "Massagno", "", "CH", "756", "", "TI", "2105", "5192", "46.01257", "8.94354", "Europe/Zurich"),("2659748", "Martigny-Ville", "", "CH", "756", "", "VS", "2307", "6136", "46.10276", "7.07245", "Europe/Zurich"),("2659758", "Marly", "", "CH", "756", "", "FR", "1004", "2206", "46.77611", "7.16459", "Europe/Zurich"),("2659772", "Männedorf", "", "CH", "756", "", "ZH", "107", "155", "47.25686", "8.69893", "Europe/Zurich"),("2659776", "Malters", "", "CH", "756", "", "LU", "312", "1062", "47.03628", "8.18193", "Europe/Zurich"),("2659808", "Lyss", "", "CH", "756", "", "BE", "243", "306", "47.0741", "7.30655", "Europe/Zurich"),("2659811", "Luzern", "Люцерн", "CH", "756", "", "LU", "311", "1061", "47.05048", "8.30635", "Europe/Zurich"),("2659819", "Lutry", "", "CH", "756", "", "VD", "2226", "5606", "46.50241", "6.68647", "Europe/Zurich"),("2659836", "Lugano", "Лугано", "CH", "756", "", "TI", "2105", "5192", "46.01008", "8.96004", "Europe/Zurich"),("2659853", "Losone", "", "CH", "756", "", "TI", "2104", "5115", "46.16866", "8.75928", "Europe/Zurich"),("2659869", "Locarno", "", "CH", "756", "", "TI", "2104", "5113", "46.17086", "8.79953", "Europe/Zurich"),("2659873", "Littau", "", "CH", "756", "", "LU", "311", "1061", "47.05", "8.26274", "Europe/Zurich"),("2659891", "Liestal", "", "CH", "756", "", "BL", "1303", "2829", "47.48455", "7.73446", "Europe/Zurich"),("2659952", "Lenzburg", "", "CH", "756", "", "AG", "1907", "4201", "47.38853", "8.17503", "Europe/Zurich"),("2659957", "Lengnau", "", "CH", "756", "", "BE", "242", "387", "47.18155", "7.36814", "Europe/Zurich"),("2659959", "Le Mont-sur-Lausanne", "", "CH", "756", "", "VD", "2225", "5587", "46.55815", "6.63145", "Europe/Zurich"),("2659960", "Le Locle", "", "CH", "756", "", "NE", "2403", "6436", "47.05953", "6.75228", "Europe/Zurich"),("2659977", "Le Châtelard", "Шатлар", "CH", "756", "", "VD", "2230", "5886", "46.44527", "6.89908", "Europe/Zurich"),("2659994", "Lausanne", "Лозанна", "CH", "756", "", "VD", "2225", "5586", "46.516", "6.63282", "Europe/Zurich"),("2660001", "Laufen", "", "CH", "756", "", "BL", "1302", "2787", "47.42193", "7.49946", "Europe/Zurich"),("2660008", "La Tour-de-Peilz", "", "CH", "756", "", "VD", "2230", "5889", "46.45312", "6.85856", "Europe/Zurich"),("2660032", "Langnau", "", "CH", "756", "", "BE", "245", "902", "46.93936", "7.78738", "Europe/Zurich"),("2660034", "Langenthal", "", "CH", "756", "", "BE", "244", "329", "47.21526", "7.79607", "Europe/Zurich"),("2660075", "Lachen", "", "CH", "756", "", "SZ", "505", "1341", "47.19927", "8.85432", "Europe/Zurich"),("2660076", "La Chaux-de-Fonds", "Ла-Шо-де-Фон", "CH", "756", "", "NE", "2402", "6421", "47.09993", "6.82586", "Europe/Zurich"),("2660086", "Küttigen", "", "CH", "756", "", "AG", "1901", "4008", "47.41566", "8.04767", "Europe/Zurich"),("2660088", "Küssnacht", "", "CH", "756", "", "SZ", "504", "1331", "47.08557", "8.44206", "Europe/Zurich"),("2660089", "Küsnacht", "", "CH", "756", "", "ZH", "107", "154", "47.31805", "8.58401", "Europe/Zurich"),("2660104", "Kriens", "Кринс", "CH", "756", "", "LU", "312", "1059", "47.03537", "8.27631", "Europe/Zurich"),("2660108", "Kreuzlingen", "Кройцлинген", "CH", "756", "", "TG", "2013", "4671", "47.65051", "9.17504", "Europe/Zurich"),("2660119", "Köniz", "Кёниц", "CH", "756", "", "BE", "246", "355", "46.92436", "7.41457", "Europe/Zurich"),("2660127", "Kloten", "Клотен", "CH", "756", "", "ZH", "103", "62", "47.45152", "8.58491", "Europe/Zurich"),("2660155", "Kirchberg", "", "CH", "756", "", "SG", "1727", "3392", "47.41159", "9.0402", "Europe/Zurich"),("2660156", "Kirchberg", "", "CH", "756", "", "BE", "245", "412", "47.08538", "7.58288", "Europe/Zurich"),("2660161", "Kilchberg", "", "CH", "756", "", "ZH", "106", "135", "47.32438", "8.54548", "Europe/Zurich"),("2660171", "Kerns", "", "CH", "756", "", "OW", "600", "1404", "46.90134", "8.27528", "Europe/Zurich"),("2660221", "Jona", "", "CH", "756", "", "SG", "1726", "3340", "47.22983", "8.83884", "Europe/Zurich"),("2660253", "Interlaken", "", "CH", "756", "", "BE", "250", "593", "46.68387", "7.86638", "Europe/Zurich"),("2660261", "Ingenbohl", "", "CH", "756", "", "SZ", "506", "1364", "46.9988", "8.61529", "Europe/Zurich"),("2660277", "Igis", "", "CH", "756", "", "GR", "1826", "3955", "46.94531", "9.57218", "Europe/Zurich"),("2660292", "Hünenberg", "", "CH", "756", "", "ZG", "900", "1703", "47.17536", "8.42497", "Europe/Zurich"),("2660298", "Horw", "", "CH", "756", "", "LU", "312", "1059", "47.01692", "8.30956", "Europe/Zurich"),("2660305", "Horgen", "Хорген", "CH", "756", "", "ZH", "106", "133", "47.25983", "8.59778", "Europe/Zurich"),("2660306", "Zürich (Kreis 10) / Höngg", "", "CH", "756", "", "ZH", "112", "261", "47.40313", "8.4971", "Europe/Zurich"),("2660332", "Hochdorf", "", "CH", "756", "", "LU", "313", "1031", "47.16841", "8.29179", "Europe/Zurich"),("2660338", "Hinwil", "", "CH", "756", "", "ZH", "105", "117", "47.29426", "8.84393", "Europe/Zurich"),("2660355", "Herzogenbuchsee", "", "CH", "756", "", "BE", "244", "979", "47.18795", "7.7062", "Europe/Zurich"),("2660359", "Herrliberg", "", "CH", "756", "", "ZH", "107", "152", "47.29064", "8.61464", "Europe/Zurich"),("2660365", "Herisau", "Херизау", "CH", "756", "", "AR", "1501", "3001", "47.38615", "9.27916", "Europe/Zurich"),("2660367", "Hergiswil", "", "CH", "756", "", "NW", "700", "1507", "46.98429", "8.30944", "Europe/Zurich"),("2660390", "Heimberg", "", "CH", "756", "", "BE", "247", "928", "46.79482", "7.60433", "Europe/Zurich"),("2660461", "Gstaad", "", "CH", "756", "", "BE", "248", "843", "46.47215", "7.28685", "Europe/Zurich"),("2660512", "Grenchen", "Гренхен", "CH", "756", "", "SO", "1107", "2546", "47.1921", "7.39586", "Europe/Zurich"),("2660515", "Greifensee", "", "CH", "756", "", "ZH", "109", "194", "47.36717", "8.68115", "Europe/Zurich"),("2660523", "Gränichen", "", "CH", "756", "", "AG", "1901", "4006", "47.3593", "8.10243", "Europe/Zurich"),("2660532", "Le Grand-Saconnex", "", "CH", "756", "", "GE", "2500", "6634", "46.23188", "6.12091", "Europe/Zurich"),("2660543", "Grabs", "", "CH", "756", "", "SG", "1724", "3273", "47.18248", "9.44395", "Europe/Zurich"),("2660549", "Gossau", "Госсау", "CH", "756", "", "SG", "1721", "3443", "47.41551", "9.25482", "Europe/Zurich"),("2660573", "Goldau", "", "CH", "756", "", "SZ", "506", "1362", "47.04761", "8.54616", "Europe/Zurich"),("2660575", "Goldach", "", "CH", "756", "", "SG", "1722", "3213", "47.47401", "9.46711", "Europe/Zurich"),("2660594", "Glarus", "", "CH", "756", "", "GL", "800", "1632", "47.04057", "9.06804", "Europe/Zurich"),("2660600", "Gland", "", "CH", "756", "", "VD", "2228", "5721", "46.42082", "6.2701", "Europe/Zurich"),("2660603", "Giubiasco", "", "CH", "756", "", "TI", "2101", "5005", "46.17246", "9.00793", "Europe/Zurich"),("2660646", "Genève", "Женева", "CH", "756", "", "GE", "2500", "6621", "46.20222", "6.14569", "Europe/Zurich"),("2660656", "Gelterkinden", "", "CH", "756", "", "BL", "1304", "2846", "47.46497", "7.85174", "Europe/Zurich"),("2660700", "Fully", "", "CH", "756", "", "VS", "2307", "6133", "46.13851", "7.11468", "Europe/Zurich"),("2660707", "Frutigen", "", "CH", "756", "", "BE", "249", "563", "46.58723", "7.64945", "Europe/Zurich"),("2660718", "Fribourg", "Фрибур", "CH", "756", "", "FR", "1004", "2196", "46.80237", "7.15128", "Europe/Zurich"),("2660719", "Frenkendorf", "", "CH", "756", "", "BL", "1303", "2824", "47.50686", "7.71648", "Europe/Zurich"),("2660721", "Freienbach", "", "CH", "756", "", "SZ", "503", "1322", "47.20534", "8.75842", "Europe/Zurich"),("2660727", "Frauenfeld", "Фрауэнфельд", "CH", "756", "", "TG", "2012", "4566", "47.55776", "8.89893", "Europe/Zurich"),("2660762", "Flawil", "", "CH", "756", "", "SG", "1728", "3402", "47.41301", "9.18324", "Europe/Zurich"),("2660851", "Estavayer-le-Lac", "", "CH", "756", "", "FR", "1001", "2015", "46.84876", "6.8465", "Europe/Zurich"),("2660860", "Eschenbach", "", "CH", "756", "", "SG", "1726", "3342", "47.23981", "8.92156", "Europe/Zurich"),("2660884", "Epalinges", "", "CH", "756", "", "VD", "2225", "5584", "46.54896", "6.66831", "Europe/Zurich"),("2660911", "Emmen", "Эммен", "CH", "756", "", "LU", "313", "1024", "47.08615", "8.30046", "Europe/Zurich"),("2660913", "Embrach", "", "CH", "756", "", "ZH", "103", "56", "47.50561", "8.59406", "Europe/Zurich"),("2660925", "Einsiedeln", "", "CH", "756", "", "SZ", "501", "1301", "47.12849", "8.74735", "Europe/Zurich"),("2660944", "Effretikon", "", "CH", "756", "", "ZH", "108", "174", "47.42575", "8.69094", "Europe/Zurich"),("2660947", "Ecublens", "", "CH", "756", "", "FR", "1002", "2072", "46.60735", "6.80895", "Europe/Zurich"),("2660953", "Ebikon", "", "CH", "756", "", "LU", "312", "1054", "47.07937", "8.34041", "Europe/Zurich"),("2660970", "Düdingen", "", "CH", "756", "", "FR", "1006", "2293", "46.84915", "7.18848", "Europe/Zurich"),("2660971", "Dübendorf", "", "CH", "756", "", "ZH", "109", "191", "47.39724", "8.61872", "Europe/Zurich"),("2660989", "Dornach", "", "CH", "756", "", "SO", "1104", "2473", "47.48038", "7.61644", "Europe/Zurich"),("2661001", "Domat", "", "CH", "756", "", "GR", "1824", "3722", "46.83483", "9.45075", "Europe/Zurich"),("2661014", "Dietlikon / Dietlikon (Dorf)", "", "CH", "756", "", "ZH", "103", "54", "47.41827", "8.6188", "Europe/Zurich"),("2661015", "Dietikon", "", "CH", "756", "", "ZH", "111", "243", "47.40165", "8.40015", "Europe/Zurich"),("2661021", "Diepoldsau", "", "CH", "756", "", "SG", "1723", "3234", "47.386", "9.65558", "Europe/Zurich"),("2661030", "Derendingen", "", "CH", "756", "", "SO", "1106", "2517", "47.1985", "7.58844", "Europe/Zurich"),("2661035", "Delémont", "", "CH", "756", "", "JU", "2601", "6711", "47.36493", "7.34453", "Europe/Zurich"),("2661039", "Davos", "", "CH", "756", "", "GR", "1830", "3851", "46.80429", "9.83723", "Europe/Zurich"),("2661072", "Crissier", "", "CH", "756", "", "VD", "2229", "5583", "46.54586", "6.57567", "Europe/Zurich"),("2661129", "Conthey", "", "CH", "756", "", "VS", "2302", "6023", "46.2237", "7.30283", "Europe/Zurich"),("2661144", "Colombier", "", "CH", "756", "", "VD", "2227", "5634", "46.55709", "6.47284", "Europe/Zurich"),("2661148", "Collombey", "", "CH", "756", "", "VS", "2308", "6152", "46.27385", "6.94789", "Europe/Zurich"),("2661169", "Chur", "Кур", "CH", "756", "", "GR", "1829", "3901", "46.84986", "9.53287", "Europe/Zurich"),("2661176", "Chiasso", "", "CH", "756", "", "TI", "2106", "5250", "45.83203", "9.03119", "Europe/Zurich"),("2661191", "Chêne-Bourg", "", "CH", "756", "", "GE", "2500", "6613", "46.19534", "6.19406", "Europe/Zurich"),("2661197", "Chavannes", "", "CH", "756", "", "VD", "2229", "5627", "46.53005", "6.57068", "Europe/Zurich"),("2661202", "Châtel-Saint-Denis", "", "CH", "756", "", "FR", "1007", "2325", "46.52691", "6.90083", "Europe/Zurich"),("2661228", "Cham", "", "CH", "756", "", "ZG", "900", "1702", "47.18213", "8.46358", "Europe/Zurich"),("2661265", "Carouge", "Каруж", "CH", "756", "", "GE", "2500", "6608", "46.18096", "6.13921", "Europe/Zurich"),("2661305", "Bussigny", "", "CH", "756", "", "VD", "2229", "5583", "46.5511", "6.55597", "Europe/Zurich"),("2661321", "Burgdorf", "", "CH", "756", "", "BE", "245", "404", "47.05901", "7.62786", "Europe/Zurich"),("2661328", "Buochs", "", "CH", "756", "", "NW", "700", "1502", "46.97398", "8.42279", "Europe/Zurich"),("2661337", "Bulle", "", "CH", "756", "", "FR", "1003", "2125", "46.61797", "7.0569", "Europe/Zurich"),("2661338", "Bülach", "", "CH", "756", "", "ZH", "103", "53", "47.52197", "8.54049", "Europe/Zurich"),("2661348", "Buchs", "", "CH", "756", "", "AG", "1901", "4003", "47.39358", "8.08233", "Europe/Zurich"),("2661349", "Buchs", "", "CH", "756", "CH,", "SG", "1724", "3271", "47.16743", "9.47794", "Europe/Zurich"),("2661350", "Buchrain", "", "CH", "756", "", "LU", "312", "1052", "47.09625", "8.34729", "Europe/Zurich"),("2661374", "Brugg", "", "CH", "756", "", "AG", "1904", "4095", "47.48096", "8.20869", "Europe/Zurich"),("2661407", "Bremgarten", "", "CH", "756", "", "AG", "1903", "4063", "47.35109", "8.34214", "Europe/Zurich"),("2661432", "Bottmingen", "", "CH", "756", "", "BL", "1301", "2767", "47.52343", "7.57211", "Europe/Zurich"),("2661456", "Bolligen", "", "CH", "756", "", "BE", "246", "352", "46.9751", "7.49697", "Europe/Zurich"),("2661468", "Blonay", "", "CH", "756", "", "VD", "2230", "5881", "46.46778", "6.89615", "Europe/Zurich"),("2661490", "Birsfelden", "", "CH", "756", "", "BL", "1301", "2766", "47.5529", "7.62322", "Europe/Zurich"),("2661499", "Binningen", "", "CH", "756", "", "BL", "1301", "2765", "47.54021", "7.56932", "Europe/Zurich"),("2661513", "Biel/Bienne", "Биль", "CH", "756", "", "BE", "242", "371", "47.13713", "7.24608", "Europe/Zurich"),("2661519", "Biberist", "", "CH", "756", "", "SO", "1106", "2513", "47.18009", "7.56246", "Europe/Zurich"),("2661524", "Biasca", "", "CH", "756", "", "TI", "2107", "5281", "46.35972", "8.96965", "Europe/Zurich"),("2661527", "Bex", "", "CH", "756", "", "VD", "2221", "5402", "46.24965", "7.0098", "Europe/Zurich"),("2661547", "Bernex", "", "CH", "756", "", "GE", "2500", "6607", "46.1765", "6.07544", "Europe/Zurich"),("2661552", "Bern", "Берн", "CH", "756", "", "BE", "246", "351", "46.94809", "7.44744", "Europe/Zurich"),("2661563", "Belp", "", "CH", "756", "", "BE", "246", "861", "46.89129", "7.49825", "Europe/Zurich"),("2661567", "Bellinzona", "Беллинцона", "CH", "756", "", "TI", "2101", "5002", "46.19278", "9.01703", "Europe/Zurich"),("2661599", "Bassersdorf", "", "CH", "756", "", "ZH", "103", "52", "47.44342", "8.62851", "Europe/Zurich"),("2661600", "Basse-Nendaz", "", "CH", "756", "", "VS", "2302", "6024", "46.18993", "7.31209", "Europe/Zurich"),("2661604", "Basel", "Базель", "CH", "756", "", "BS", "1200", "2701", "47.55839", "7.57327", "Europe/Zurich"),("2661626", "Balsthal", "", "CH", "756", "", "SO", "1102", "2422", "47.31613", "7.69318", "Europe/Zurich"),("2661641", "Bagnes", "", "CH", "756", "", "VS", "2303", "6031", "46.08333", "7.21667", "Europe/Zurich"),("2661644", "Bad Ragaz", "", "CH", "756", "", "SG", "1725", "3291", "47.00601", "9.50266", "Europe/Zurich"),("2661646", "Baden", "Баден", "CH", "756", "", "AG", "1902", "4021", "47.47333", "8.30592", "Europe/Zurich"),("2661653", "Baar", "Бар", "CH", "756", "", "ZG", "900", "1701", "47.19625", "8.52954", "Europe/Zurich"),("2661666", "Zürich (Kreis 4) / Aussersihl", "", "CH", "756", "", "ZH", "112", "261", "47.37752", "8.52127", "Europe/Zurich"),("2661689", "Au", "", "CH", "756", "", "SG", "1723", "3233", "47.43093", "9.63448", "Europe/Zurich"),("2661698", "Ascona", "", "CH", "756", "", "TI", "2104", "5091", "46.15451", "8.77327", "Europe/Zurich"),("2661708", "Arth", "", "CH", "756", "", "SZ", "506", "1362", "47.06337", "8.52349", "Europe/Zurich"),("2661719", "Arlesheim", "", "CH", "756", "", "BL", "1301", "2763", "47.49412", "7.61979", "Europe/Zurich"),("2661731", "Arbon", "", "CH", "756", "", "TG", "2011", "4401", "47.51667", "9.43333", "Europe/Zurich"),("2661740", "Appenzell", "", "CH", "756", "", "AI", "1600", "3101", "47.33103", "9.40996", "Europe/Zurich"),("2661756", "Amriswil", "", "CH", "756", "", "TG", "2011", "4461", "47.54699", "9.29586", "Europe/Zurich"),("2661766", "Altstätten", "", "CH", "756", "", "SG", "1723", "3251", "47.37766", "9.54746", "Europe/Zurich"),("2661776", "Altendorf", "", "CH", "756", "", "SZ", "505", "1341", "47.18994", "8.83823", "Europe/Zurich"),("2661780", "Altdorf", "", "CH", "756", "", "UR", "400", "1201", "46.88042", "8.64441", "Europe/Zurich"),("2661789", "Alpnach", "", "CH", "756", "", "OW", "600", "1401", "46.94227", "8.2718", "Europe/Zurich"),("2661810", "Allschwil", "Альшвиль", "CH", "756", "", "BL", "1301", "2762", "47.55074", "7.53599", "Europe/Zurich"),("2661834", "Aigle", "", "CH", "756", "", "VD", "2221", "5401", "46.3181", "6.96457", "Europe/Zurich"),("2661842", "Affoltern am Albis", "", "CH", "756", "", "ZH", "101", "2", "47.27743", "8.45128", "Europe/Zurich"),("2661852", "Aesch", "", "CH", "756", "", "BL", "1301", "2761", "47.47104", "7.5973", "Europe/Zurich"),("2661861", "Adliswil", "", "CH", "756", "", "ZH", "106", "131", "47.30997", "8.52462", "Europe/Zurich"),("2661862", "Adligenswil", "", "CH", "756", "", "LU", "312", "1051", "47.06521", "8.36124", "Europe/Zurich"),("2661879", "Aarburg", "", "CH", "756", "", "AG", "1910", "4271", "47.32067", "7.89986", "Europe/Zurich"),("2661881", "Aarau", "Арау", "CH", "756", "", "AG", "1901", "4001", "47.39254", "8.04422", "Europe/Zurich"),("2661882", "Aadorf", "", "CH", "756", "", "TG", "2014", "4551", "47.49204", "8.90099", "Europe/Zurich"),("3206590", "Riehen", "Риен", "CH", "756", "", "BS", "1200", "2703", "47.57884", "7.64683", "Europe/Zurich"),("3209498", "Chêne-Bougeries", "", "CH", "756", "", "GE", "2500", "6612", "46.19843", "6.18642", "Europe/Zurich"),("3209505", "Thônex", "", "CH", "756", "", "GE", "2500", "6640", "46.18815", "6.19904", "Europe/Zurich"),("6285791", "Ecublens", "", "CH", "756", "", "VD", "2229", "5635", "46.52899", "6.56261", "Europe/Zurich"),("6291374", "Wallisellen / Wallisellen-Ost", "", "CH", "756", "", "ZH", "103", "69", "47.41446", "8.59727", "Europe/Zurich"),("6292757", "Horgen / Horgen (Dorfkern)", "", "CH", "756", "", "ZH", "106", "133", "47.25604", "8.60159", "Europe/Zurich"),("6293080", "Thalwil / Dorfkern", "", "CH", "756", "", "ZH", "106", "141", "47.29047", "8.56633", "Europe/Zurich"),("6293977", "Pfäffikon / Pfäffikon (Dorfkern)", "", "CH", "756", "", "ZH", "108", "177", "47.36943", "8.78309", "Europe/Zurich"),("6294547", "Uster / Kirch-Uster", "", "CH", "756", "", "ZH", "109", "198", "47.34579", "8.71839", "Europe/Zurich"),("6294550", "Uster / Ober-Uster", "", "CH", "756", "", "ZH", "109", "198", "47.34874", "8.73319", "Europe/Zurich"),("6295092", "Oberwinterthur (Kreis 2) / Talacker", "", "CH", "756", "", "ZH", "110", "230", "47.50596", "8.7515", "Europe/Zurich"),("6295102", "Oberwinterthur (Kreis 2) / Guggenbühl", "", "CH", "756", "", "ZH", "110", "230", "47.51339", "8.75998", "Europe/Zurich"),("6295183", "Mattenbach (Kreis 7) / Deutweg", "", "CH", "756", "", "ZH", "110", "230", "47.49419", "8.73948", "Europe/Zurich"),("6295475", "Zürich (Kreis 10) / Wipkingen", "", "CH", "756", "", "ZH", "112", "261", "47.39503", "8.52529", "Europe/Zurich"),("6295484", "Zürich (Kreis 11) / Affoltern", "", "CH", "756", "", "ZH", "112", "261", "47.41814", "8.5122", "Europe/Zurich"),("6295490", "Zürich (Kreis 12) / Saatlen", "", "CH", "756", "", "ZH", "112", "261", "47.41127", "8.5648", "Europe/Zurich"),("6295491", "Zürich (Kreis 12) / Schwamendingen-Mitte", "", "CH", "756", "", "ZH", "112", "261", "47.4063", "8.57242", "Europe/Zurich"),("6295492", "Zürich (Kreis 12) / Hirzenbach", "", "CH", "756", "", "ZH", "112", "261", "47.40187", "8.58633", "Europe/Zurich"),("6295495", "Zürich (Kreis 2) / Wollishofen", "", "CH", "756", "", "ZH", "112", "261", "47.3401", "8.53134", "Europe/Zurich"),("6295496", "Zürich (Kreis 2) / Enge", "", "CH", "756", "", "ZH", "112", "261", "47.3605", "8.53127", "Europe/Zurich"),("6295497", "Zürich (Kreis 3) / Friesenberg", "", "CH", "756", "", "ZH", "112", "261", "47.36372", "8.50417", "Europe/Zurich"),("6295498", "Zürich (Kreis 3) / Sihlfeld", "", "CH", "756", "", "ZH", "112", "261", "47.37382", "8.51164", "Europe/Zurich"),("6295500", "Zürich (Kreis 4) / Langstrasse", "", "CH", "756", "", "ZH", "112", "261", "47.37767", "8.52854", "Europe/Zurich"),("6295501", "Zürich (Kreis 4) / Hard", "", "CH", "756", "", "ZH", "112", "261", "47.38311", "8.50942", "Europe/Zurich"),("6295502", "Zürich (Kreis 5) / Gewerbeschule", "", "CH", "756", "", "ZH", "112", "261", "47.38481", "8.53011", "Europe/Zurich"),("6295504", "Zürich (Kreis 6) / Unterstrass", "", "CH", "756", "", "ZH", "112", "261", "47.3953", "8.53721", "Europe/Zurich"),("6295505", "Zürich (Kreis 6) / Oberstrass", "", "CH", "756", "", "ZH", "112", "261", "47.38917", "8.5504", "Europe/Zurich"),("6295506", "Zürich (Kreis 7) / Fluntern", "", "CH", "756", "", "ZH", "112", "261", "47.38013", "8.56133", "Europe/Zurich"),("6295507", "Zürich (Kreis 7) / Hottingen", "", "CH", "756", "", "ZH", "112", "261", "47.37011", "8.56306", "Europe/Zurich"),("6295508", "Zürich (Kreis 7) / Hirslanden", "", "CH", "756", "", "ZH", "112", "261", "47.3624", "8.56755", "Europe/Zurich"),("6295510", "Zürich (Kreis 8) / Mühlebach", "", "CH", "756", "", "ZH", "112", "261", "47.35727", "8.55744", "Europe/Zurich"),("6295512", "Zürich (Kreis 9) / Albisrieden", "", "CH", "756", "", "ZH", "112", "261", "47.37398", "8.49007", "Europe/Zurich"),("6295513", "Zürich (Kreis 9) / Altstetten", "", "CH", "756", "", "ZH", "112", "261", "47.38946", "8.48533", "Europe/Zurich"),("6295517", "Hegnau", "", "CH", "756", "", "ZH", "109", "199", "47.39227", "8.66988", "Europe/Zurich"),("6295520", "Stadt Winterthur (Kreis 1)", "", "CH", "756", "", "ZH", "110", "230", "47.49494", "8.71954", "Europe/Zurich"),("6295521", "Zürich (Kreis 5)", "", "CH", "756", "", "ZH", "112", "261", "47.38767", "8.52152", "Europe/Zurich"),("6295523", "Zürich (Kreis 12)", "", "CH", "756", "", "ZH", "112", "261", "47.40372", "8.57608", "Europe/Zurich"),("6295524", "Wülflingen (Kreis 6)", "", "CH", "756", "", "ZH", "110", "230", "47.51036", "8.68333", "Europe/Zurich"),("6295531", "Seen (Kreis 3)", "", "CH", "756", "", "ZH", "110", "230", "47.47646", "8.76996", "Europe/Zurich"),("6295532", "Zürich (Kreis 3)", "", "CH", "756", "", "ZH", "112", "261", "47.35785", "8.50296", "Europe/Zurich"),("6295533", "Zürich (Kreis 11)", "", "CH", "756", "", "ZH", "112", "261", "47.42326", "8.52166", "Europe/Zurich"),("6295534", "Zürich (Kreis 9)", "", "CH", "756", "", "ZH", "112", "261", "47.38245", "8.47993", "Europe/Zurich"),("6295536", "Oberwinterthur (Kreis 2)", "", "CH", "756", "", "ZH", "110", "230", "47.51692", "8.76863", "Europe/Zurich"),("6295539", "Zürich (Kreis 10)", "", "CH", "756", "", "ZH", "112", "261", "47.40773", "8.5005", "Europe/Zurich"),("6295540", "Zürich (Kreis 2)", "", "CH", "756", "", "ZH", "112", "261", "47.33756", "8.5211", "Europe/Zurich"),("6295542", "Zürich (Kreis 8)", "", "CH", "756", "", "ZH", "112", "261", "47.3548", "8.56097", "Europe/Zurich"),("6295546", "Zürich (Kreis 1)", "", "CH", "756", "", "ZH", "112", "261", "47.37055", "8.54177", "Europe/Zurich"),("6295547", "Mattenbach (Kreis 7)", "", "CH", "756", "", "ZH", "110", "230", "47.48705", "8.74681", "Europe/Zurich"),("6295548", "Zürich (Kreis 7)", "", "CH", "756", "", "ZH", "112", "261", "47.37328", "8.58038", "Europe/Zurich"),("6295550", "Zürich (Kreis 6)", "", "CH", "756", "", "ZH", "112", "261", "47.39223", "8.54381", "Europe/Zurich"),("6620245", "Thal", "", "CH", "756", "", "SG", "1722", "3237", "47.46677", "9.56643", "Europe/Zurich"),("6640317", "Langnau am Albis", "", "CH", "756", "", "ZH", "106", "136", "47.28885", "8.5411", "Europe/Zurich"),("6691640", "Lancy", "Ланси", "CH", "756", "", "GE", "2500", "6628", "46.18981", "6.11441", "Europe/Zurich"),("7779000", "Les Avanchets", "", "CH", "756", "", "GE", "2500", "6643", "46.22168", "6.10814", "Europe/Zurich"),("8521688", "Blécherette", "", "CH", "756", "", "VD", "2225", "5586", "46.53932", "6.62227", "Europe/Zurich"),("2279172", "Zuénoula", "", "CI", "385", "", "96", "11153167", "", "7.43027", "-6.05054", "Africa/Abidjan"),("2279755", "Yamoussoukro", "Ямусукро", "CI", "385", "", "81", "", "", "6.82055", "-5.27674", "Africa/Abidjan"),("2280045", "Vavoua", "Вавуа", "CI", "385", "", "96", "11153166", "", "7.38194", "-6.47778", "Africa/Abidjan"),("2280316", "Toumodi", "", "CI", "385", "", "81", "", "", "6.55799", "-5.01769", "Africa/Abidjan"),("2280333", "Toulépleu Gueré", "", "CI", "385", "", "78", "", "", "6.57395", "-8.42592", "Africa/Abidjan"),("2280376", "Touba", "", "CI", "385", "", "97", "2597334", "", "8.28333", "-7.68333", "Africa/Abidjan"),("2280589", "Tengréla", "", "CI", "385", "", "87", "", "", "10.48115", "-6.40694", "Africa/Abidjan"),("2280761", "Tiassalé", "", "CI", "385", "", "82", "", "", "5.89839", "-4.82293", "Africa/Abidjan"),("2280995", "Tanda", "", "CI", "385", "", "92", "", "", "7.80335", "-3.16832", "Africa/Abidjan"),("2281120", "Tabou", "", "CI", "385", "", "76", "", "", "4.42295", "-7.3528", "Africa/Abidjan"),("2281606", "Sinfra", "", "CI", "385", "", "92", "", "", "6.62103", "-5.91144", "Africa/Abidjan"),("2281951", "Sassandra", "Сассандра", "CI", "385", "", "76", "", "", "4.95384", "-6.08531", "Africa/Abidjan"),("2282006", "San-Pédro", "", "CI", "385", "", "76", "", "", "4.74851", "-6.6363", "Africa/Abidjan"),("2282178", "Sakassou", "", "CI", "385", "", "90", "", "", "7.45462", "-5.29263", "Africa/Abidjan"),("2282827", "Oumé", "", "CI", "385", "", "95", "11153083", "", "6.38309", "-5.41759", "Africa/Abidjan"),("2283016", "Odienné", "Одиенне", "CI", "385", "", "77", "", "", "9.50511", "-7.56433", "Africa/Abidjan"),("2284589", "Mankono", "", "CI", "385", "", "97", "11153172", "", "8.05861", "-6.18972", "Africa/Abidjan"),("2284647", "Man", "", "CI", "385", "", "78", "", "", "7.41251", "-7.55383", "Africa/Abidjan"),("2285449", "Lakota", "Лакота", "CI", "385", "", "95", "11153153", "", "5.84752", "-5.682", "Africa/Abidjan"),("2286304", "Korhogo", "Корого", "CI", "385", "", "87", "", "", "9.45803", "-5.62961", "Africa/Abidjan"),("2287298", "Katiola", "", "CI", "385", "", "90", "11153171", "2287296", "8.13728", "-5.10095", "Africa/Abidjan"),("2287790", "Issia", "", "CI", "385", "", "96", "11153166", "", "6.49224", "-6.58558", "Africa/Abidjan"),("2287958", "Guiglo", "", "CI", "385", "", "78", "", "", "6.54368", "-7.4935", "Africa/Abidjan"),("2287970", "Guibéroua", "", "CI", "385", "", "95", "", "", "6.23869", "-6.17147", "Africa/Abidjan"),("2288105", "Grand-Lahou", "", "CI", "385", "", "82", "", "", "5.25068", "-5.00333", "Africa/Abidjan"),("2288115", "Grand-Bassam", "Гран-Бассам", "CI", "385", "", "94", "11153079", "", "5.2118", "-3.73884", "Africa/Abidjan"),("2288118", "Affery", "", "CI", "385", "", "82", "", "", "6.32035", "-3.95235", "Africa/Abidjan"),("2288829", "Gagnoa", "", "CI", "385", "", "95", "", "", "6.13193", "-5.9506", "Africa/Abidjan"),("2289049", "Ferkessédougou", "Феркеседугу", "CI", "385", "", "87", "", "", "9.5928", "-5.19449", "Africa/Abidjan"),("2289549", "Duekoué", "", "CI", "385", "", "78", "", "", "6.74202", "-7.34918", "Africa/Abidjan"),("2289887", "Divo", "", "CI", "385", "", "95", "", "", "5.83739", "-5.35723", "Africa/Abidjan"),("2289983", "Dimbokro", "", "CI", "385", "", "81", "", "", "6.64678", "-4.70519", "Africa/Abidjan"),("2290412", "Daoukro", "Даукро", "CI", "385", "", "81", "11153155", "", "7.0591", "-3.9631", "Africa/Abidjan"),("2290462", "Danané", "Данане", "CI", "385", "", "78", "", "", "7.25957", "-8.15498", "Africa/Abidjan"),("2290486", "Daloa", "Далоа", "CI", "385", "", "96", "", "", "6.87735", "-6.45022", "Africa/Abidjan"),("2290582", "Dabou", "Даб", "CI", "385", "", "82", "", "", "5.32556", "-4.37685", "Africa/Abidjan"),("2290609", "Dabakala", "", "CI", "385", "", "90", "", "", "8.36321", "-4.42863", "Africa/Abidjan"),("2290836", "Boundiali", "Бундиали", "CI", "385", "", "87", "11153168", "", "9.52167", "-6.48694", "Africa/Abidjan"),("2290849", "Bouna", "Буна", "CI", "385", "", "92", "", "", "9.26927", "-2.9951", "Africa/Abidjan"),("2290956", "Bouaké", "Буаке", "CI", "385", "", "90", "", "", "7.69385", "-5.03031", "Africa/Abidjan"),("2290964", "Bouaflé", "", "CI", "385", "", "96", "11153167", "", "6.99041", "-5.7442", "Africa/Abidjan"),("2290985", "Botro", "", "CI", "385", "", "90", "", "", "7.85249", "-5.31063", "Africa/Abidjan"),("2291087", "Bonoua", "", "CI", "385", "", "89", "", "", "5.27247", "-3.59625", "Africa/Abidjan"),("2291113", "Bongouanou", "", "CI", "385", "", "81", "", "", "6.65175", "-4.20406", "Africa/Abidjan"),("2291136", "Bondoukou", "Бондуку", "CI", "385", "", "92", "", "", "8.0402", "-2.80003", "Africa/Abidjan"),("2291383", "Bocanda", "", "CI", "385", "", "81", "", "", "7.06264", "-4.49948", "Africa/Abidjan"),("2291580", "Bingerville", "", "CI", "385", "", "93", "", "", "5.35581", "-3.88537", "Africa/Abidjan"),("2291666", "Biankouma", "", "CI", "385", "", "78", "", "", "7.73909", "-7.61377", "Africa/Abidjan"),("2291779", "Béoumi", "", "CI", "385", "", "90", "", "", "7.67395", "-5.58085", "Africa/Abidjan"),("2292179", "Bangolo", "", "CI", "385", "", "78", "11153164", "2292178", "7.01232", "-7.48639", "Africa/Abidjan"),("2292542", "Ayamé", "", "CI", "385", "", "94", "", "", "5.6052", "-3.15709", "Africa/Abidjan"),("2292755", "Arrah", "", "CI", "385", "", "81", "11153156", "", "6.67342", "-3.96938", "Africa/Abidjan"),("2292852", "Anyama", "Аньяме", "CI", "385", "", "93", "", "", "5.49462", "-4.05183", "Africa/Abidjan"),("2293107", "Akoupé", "", "CI", "385", "", "82", "11153162", "", "6.38423", "-3.88759", "Africa/Abidjan"),("2293260", "Agnibilékrou", "", "CI", "385", "", "94", "11153078", "", "7.13113", "-3.20415", "Africa/Abidjan"),("2293268", "Agboville", "Агбовиле", "CI", "385", "", "82", "11153160", "", "5.92801", "-4.21319", "Africa/Abidjan"),("2293342", "Adzopé", "Адзопе", "CI", "385", "", "82", "", "", "6.10694", "-3.86194", "Africa/Abidjan"),("2293428", "Adiaké", "", "CI", "385", "", "94", "", "", "5.28634", "-3.30403", "Africa/Abidjan"),("2293507", "Aboisso", "Абуассо", "CI", "385", "", "94", "", "", "5.46779", "-3.20711", "Africa/Abidjan"),("2293521", "Abobo", "", "CI", "385", "", "93", "", "", "5.41613", "-4.0159", "Africa/Abidjan"),("2293538", "Abidjan", "Абиджан", "CI", "385", "", "93", "", "", "5.30966", "-4.01266", "Africa/Abidjan"),("2293549", "Abengourou", "Абенгуру", "CI", "385", "", "94", "11153078", "", "6.72972", "-3.49639", "Africa/Abidjan"),("2596934", "Séguéla", "Сегеле", "CI", "385", "", "97", "", "", "7.96111", "-6.67306", "Africa/Abidjan"),("2598243", "Soubré", "", "CI", "385", "", "76", "", "", "5.78556", "-6.60833", "Africa/Abidjan"),("2220849", "Yoko", "", "CM", "120", "", "11", "", "", "5.53333", "12.31667", "Africa/Douala"),("2220853", "Yokadouma", "", "CM", "120", "", "04", "", "", "3.51667", "15.05", "Africa/Douala"),("2220957", "Yaoundé", "Яунде", "CM", "120", "", "11", "", "", "3.86667", "11.51667", "Africa/Douala"),("2221030", "Yagoua", "", "CM", "120", "", "12", "", "", "10.34107", "15.23288", "Africa/Douala"),("2221046", "Yabassi", "", "CM", "120", "", "05", "", "", "4.45697", "9.96822", "Africa/Douala"),("2221053", "Wum", "", "CM", "120", "", "07", "", "", "6.38333", "10.06667", "Africa/Douala"),("2221394", "Tonga", "", "CM", "120", "", "08", "", "", "4.96667", "10.7", "Africa/Douala"),("2221504", "Tiko", "", "CM", "120", "", "09", "", "", "4.075", "9.36005", "Africa/Douala"),("2221530", "Tibati", "", "CM", "120", "", "10", "", "", "6.46504", "12.62843", "Africa/Douala"),("2221607", "Tcholliré", "", "CM", "120", "", "13", "", "", "8.4022", "14.1698", "Africa/Douala"),("2222230", "Sangmélima", "Сангмелима", "CM", "120", "", "14", "", "", "2.93333", "11.98333", "Africa/Douala"),("2222366", "Saa", "", "CM", "120", "", "11", "", "", "4.36667", "11.45", "Africa/Douala"),("2222439", "Rey Bouba", "", "CM", "120", "", "13", "", "", "8.6724", "14.1786", "Africa/Douala"),("2222539", "Poli", "", "CM", "120", "", "13", "", "", "8.4756", "13.24097", "Africa/Douala"),("2222568", "Pitoa", "", "CM", "120", "", "13", "", "", "9.3839", "13.50231", "Africa/Douala"),("2222623", "Penja", "", "CM", "120", "", "05", "", "", "4.63911", "9.67987", "Africa/Douala"),("2223216", "Okola", "", "CM", "120", "", "11", "", "", "4.01667", "11.38333", "Africa/Douala"),("2223293", "Obala", "", "CM", "120", "", "11", "", "", "4.16667", "11.53333", "Africa/Douala"),("2223421", "Ntui", "", "CM", "120", "", "11", "", "", "4.45", "11.63333", "Africa/Douala"),("2223734", "Nkoteng", "", "CM", "120", "", "11", "", "", "4.51667", "12.03333", "Africa/Douala"),("2223763", "Nkongsamba", "Нконгсамба", "CM", "120", "", "05", "", "", "4.9547", "9.9404", "Africa/Douala"),("2224212", "Njinikom", "", "CM", "120", "", "07", "", "", "6.23333", "10.28333", "Africa/Douala"),("2224413", "Nguti", "", "CM", "120", "", "09", "", "", "5.3299", "9.4185", "Africa/Douala"),("2224827", "Ngaoundéré", "", "CM", "120", "", "10", "", "", "7.32765", "13.58472", "Africa/Douala"),("2224863", "Ngambé", "", "CM", "120", "", "05", "2222269", "", "4.23343", "10.61532", "Africa/Douala"),("2225263", "Ndikiniméki", "", "CM", "120", "", "11", "", "", "4.76667", "10.83333", "Africa/Douala"),("2225325", "Ndelele", "", "CM", "120", "", "04", "", "", "4.04065", "14.92501", "Africa/Douala"),("2225457", "Nanga Eboko", "", "CM", "120", "", "11", "", "", "4.68333", "12.36667", "Africa/Douala"),("2225726", "Muyuka", "", "CM", "120", "", "09", "", "", "4.2898", "9.4103", "Africa/Douala"),("2225728", "Mutengene", "", "CM", "120", "", "09", "", "", "4.0913", "9.3144", "Africa/Douala"),("2225745", "Mundemba", "", "CM", "120", "", "09", "", "", "4.9479", "8.8724", "Africa/Douala"),("2225991", "Mora", "Море", "CM", "120", "", "12", "", "", "11.04611", "14.14011", "Africa/Douala"),("2226275", "Mokolo", "", "CM", "120", "", "12", "", "", "10.74244", "13.80227", "Africa/Douala"),("2226441", "Mme-Bafumen", "", "CM", "120", "", "07", "", "", "6.33333", "10.23333", "Africa/Douala"),("2226641", "Mindif", "", "CM", "120", "", "12", "", "", "10.39757", "14.43626", "Africa/Douala"),("2227230", "Melong", "", "CM", "120", "", "05", "", "", "5.12181", "9.96143", "Africa/Douala"),("2227402", "Meïganga", "Мейганге", "CM", "120", "", "10", "", "", "6.51667", "14.3", "Africa/Douala"),("2227613", "Mbouda", "", "CM", "120", "", "08", "", "", "5.62611", "10.25421", "Africa/Douala"),("2227853", "Mbengwi", "", "CM", "120", "", "07", "", "", "6.01667", "10", "Africa/Douala"),("2228005", "Mbanga", "", "CM", "120", "", "05", "", "", "4.5016", "9.5671", "Africa/Douala"),("2228028", "Mbandjok", "", "CM", "120", "", "11", "", "", "4.45", "11.9", "Africa/Douala"),("2228079", "Mbalmayo", "Мбальмайо", "CM", "120", "", "11", "", "", "3.51667", "11.5", "Africa/Douala"),("2228373", "Maroua", "Маруа", "CM", "120", "", "12", "", "", "10.59095", "14.31593", "Africa/Douala"),("2228499", "Manjo", "", "CM", "120", "", "05", "", "", "4.8428", "9.8217", "Africa/Douala"),("2228675", "Mamfe", "", "CM", "120", "", "09", "", "", "5.75132", "9.3137", "Africa/Douala"),("2228881", "Makary", "", "CM", "120", "", "12", "", "", "12.57535", "14.45483", "Africa/Douala"),("2229152", "Loum", "Лум", "CM", "120", "", "05", "", "", "4.7182", "9.7351", "Africa/Douala"),("2229267", "Lolodorf", "", "CM", "120", "", "14", "", "", "3.23333", "10.73333", "Africa/Douala"),("2229411", "Limbe", "Лимбе", "CM", "120", "", "09", "", "", "4.02356", "9.20607", "Africa/Douala"),("2229681", "Lagdo", "", "CM", "120", "", "13", "", "", "9.05828", "13.66605", "Africa/Douala"),("2229748", "Kumbo", "", "CM", "120", "", "07", "", "", "6.2", "10.66667", "Africa/Douala"),("2229752", "Kumba", "Кумбой", "CM", "120", "", "09", "", "", "4.6363", "9.4469", "Africa/Douala"),("2229761", "Kribi", "Криби", "CM", "120", "", "14", "", "", "2.93725", "9.90765", "Africa/Douala"),("2229798", "Kousséri", "", "CM", "120", "", "12", "", "", "12.07689", "15.03063", "Africa/Douala"),("2230028", "Kontcha", "", "CM", "120", "", "10", "", "", "7.96667", "12.23333", "Africa/Douala"),("2230285", "Bankim", "", "CM", "120", "", "10", "", "", "6.08303", "11.4905", "Africa/Douala"),("2230599", "Kaélé", "", "CM", "120", "", "12", "", "", "10.10917", "14.45083", "Africa/Douala"),("2230641", "Jakiri", "", "CM", "120", "", "07", "", "", "6.1", "10.65", "Africa/Douala"),("2230876", "Guider", "", "CM", "120", "", "13", "", "", "9.9333", "13.94671", "Africa/Douala"),("2231319", "Garoua Boulaï", "", "CM", "120", "", "04", "", "", "5.88333", "14.55", "Africa/Douala"),("2231320", "Garoua", "Гаруа", "CM", "120", "", "13", "", "", "9.30143", "13.39771", "Africa/Douala"),("2231482", "Fundong", "", "CM", "120", "", "07", "", "", "6.25", "10.26667", "Africa/Douala"),("2231504", "Foumbot", "", "CM", "120", "", "08", "", "", "5.50803", "10.6325", "Africa/Douala"),("2231506", "Foumban", "", "CM", "120", "", "08", "", "", "5.72662", "10.89865", "Africa/Douala"),("2231564", "Fontem", "", "CM", "120", "", "09", "", "", "5.4685", "9.8818", "Africa/Douala"),("2231881", "Eséka", "", "CM", "120", "", "11", "", "", "3.65", "10.76667", "Africa/Douala"),("2232239", "Edéa", "Эдеа", "CM", "120", "", "05", "", "", "3.8", "10.13333", "Africa/Douala"),("2232283", "Ébolowa", "", "CM", "120", "", "14", "", "", "2.9", "11.15", "Africa/Douala"),("2232444", "Dschang", "", "CM", "120", "", "08", "", "", "5.44397", "10.05332", "Africa/Douala"),("2232497", "Doumé", "", "CM", "120", "", "04", "", "", "4.23333", "13.45", "Africa/Douala"),("2232593", "Douala", "Дуала", "CM", "120", "", "05", "", "", "4.04827", "9.70428", "Africa/Douala"),("2232997", "Dizangué", "", "CM", "120", "", "05", "", "", "3.76667", "9.98333", "Africa/Douala"),("2233056", "Dimako", "", "CM", "120", "", "04", "", "", "4.38333", "13.56667", "Africa/Douala"),("2233410", "Buea", "", "CM", "120", "", "09", "", "", "4.1527", "9.241", "Africa/Douala"),("2233704", "Bonabéri", "", "CM", "120", "", "05", "", "", "4.0779", "9.6759", "Africa/Douala"),("2233805", "Bogo", "", "CM", "120", "", "12", "", "", "10.7336", "14.60928", "Africa/Douala"),("2234339", "Bétaré Oya", "", "CM", "120", "", "04", "", "", "5.6", "14.08333", "Africa/Douala"),("2234359", "Bertoua", "Бертуа", "CM", "120", "", "04", "", "", "4.57728", "13.68459", "Africa/Douala"),("2234455", "Belo", "", "CM", "120", "", "07", "", "", "6.13333", "10.25", "Africa/Douala"),("2234520", "Bélel", "", "CM", "120", "", "10", "", "", "7.05", "14.43333", "Africa/Douala"),("2234536", "Bélabo", "Белабо", "CM", "120", "", "04", "", "", "4.93333", "13.3", "Africa/Douala"),("2234545", "Bekondo", "", "CM", "120", "", "09", "", "", "4.6819", "9.3214", "Africa/Douala"),("2234635", "Bazou", "", "CM", "120", "", "08", "", "", "5.06001", "10.46751", "Africa/Douala"),("2234663", "Batouri", "", "CM", "120", "", "04", "", "", "4.43333", "14.36667", "Africa/Douala"),("2234684", "Batibo", "", "CM", "120", "", "07", "", "", "5.8358", "9.8553", "Africa/Douala"),("2234794", "Banyo", "", "CM", "120", "", "10", "", "", "6.75", "11.81667", "Africa/Douala"),("2234803", "Bansoa", "", "CM", "120", "", "08", "", "", "5.44836", "10.31355", "Africa/Douala"),("2234842", "Ngou", "", "CM", "120", "", "08", "", "", "5.19685", "10.38595", "Africa/Douala"),("2234865", "Bangangté", "", "CM", "120", "", "08", "", "", "5.14079", "10.52535", "Africa/Douala"),("2234904", "Bandjoun", "", "CM", "120", "", "08", "", "", "5.37568", "10.41326", "Africa/Douala"),("2234936", "Bana", "", "CM", "120", "", "08", "", "", "5.14655", "10.27545", "Africa/Douala"),("2234941", "Bamusso", "", "CM", "120", "", "09", "", "", "4.4591", "8.9027", "Africa/Douala"),("2234968", "Bamendjou", "", "CM", "120", "", "08", "", "", "5.38988", "10.33014", "Africa/Douala"),("2234974", "Bamenda", "Баменды", "CM", "120", "", "07", "", "", "5.9597", "10.14597", "Africa/Douala"),("2235029", "Bali", "Бали", "CM", "120", "", "07", "", "", "5.88737", "10.01176", "Africa/Douala"),("2235189", "Bafoussam", "Бафуссама", "CM", "120", "", "08", "", "", "5.47775", "10.41759", "Africa/Douala"),("2235194", "Bafia", "", "CM", "120", "", "11", "", "", "4.75", "11.23333", "Africa/Douala"),("2235196", "Bafang", "", "CM", "120", "", "08", "", "", "5.15705", "10.1771", "Africa/Douala"),("2235293", "Babanki", "", "CM", "120", "", "07", "", "", "6.11667", "10.25", "Africa/Douala"),("2235660", "Ambam", "", "CM", "120", "", "14", "", "", "2.38333", "11.28333", "Africa/Douala"),("2235776", "Akonolinga", "", "CM", "120", "", "11", "", "", "3.76667", "12.25", "Africa/Douala"),("2235814", "Akom II", "", "CM", "120", "", "14", "", "", "2.78333", "10.56667", "Africa/Douala"),("2236053", "Abong Mbang", "", "CM", "120", "", "04", "", "", "3.98333", "13.18333", "Africa/Douala"),("2594800", "Idenao", "", "CM", "120", "", "09", "", "", "4.2475", "9.00472", "Africa/Douala"),("2595172", "Ndom", "", "CM", "120", "", "05", "", "", "4.4978", "9.5628", "Africa/Douala"),("1279524", "Zangguy", "", "CN", "156", "CN", "13", "", "", "37.28333", "78.76667", "Asia/Shanghai"),("1279715", "Rikaze", "Шигадзе", "CN", "156", "", "14", "", "", "29.25", "88.88333", "Asia/Urumqi"),("1279945", "Jiuquan", "Сучжоу", "CN", "156", "", "15", "", "", "39.74318", "98.51736", "Asia/Shanghai"),("1280037", "Shache", "", "CN", "156", "", "13", "", "", "38.41667", "77.24056", "Asia/Shanghai"),("1280281", "Qamdo", "", "CN", "156", "", "14", "", "", "31.1304", "97.17982", "Asia/Urumqi"),("1280517", "Nagqu", "Нагчу", "CN", "156", "", "14", "", "", "31.47678", "92.05729", "Asia/Urumqi"),("1280737", "Lhasa", "Лхаса", "CN", "156", "", "14", "", "", "29.65", "91.1", "Asia/Urumqi"),("1280757", "Laojunmiao", "", "CN", "156", "", "15", "", "", "39.83333", "97.73333", "Asia/Shanghai"),("1280849", "Kashgar", "Кашгар", "CN", "156", "", "13", "", "", "39.47066", "75.98951", "Asia/Shanghai"),("1280957", "Jiayuguan", "Цзяюйгуань", "CN", "156", "", "15", "", "", "39.81121", "98.28618", "Asia/Shanghai"),("1281019", "Hotan", "Хотан", "CN", "156", "", "13", "", "", "37.1075", "79.93548", "Asia/Shanghai"),("1281119", "Jiangzi", "", "CN", "156", "", "14", "", "", "28.92026", "89.59956", "Asia/Urumqi"),("1281368", "Dêqên", "Дечен", "CN", "156", "", "14", "", "", "29.96178", "90.71875", "Asia/Urumqi"),("1281593", "Burang", "", "CN", "156", "", "14", "", "", "30.29559", "81.17511", "Asia/Shanghai"),("1529102", "Ürümqi", "Урумчи", "CN", "156", "", "13", "", "", "43.80096", "87.60046", "Asia/Urumqi"),("1529114", "Turpan", "Турфан", "CN", "156", "", "13", "", "", "42.94769", "89.17886", "Asia/Urumqi"),("1529195", "Shihezi", "Шихэцзы", "CN", "156", "", "13", "", "", "44.3023", "86.03694", "Asia/Urumqi"),("1529363", "Kuqa", "Куча", "CN", "156", "", "13", "", "", "41.72778", "82.93639", "Asia/Urumqi"),("1529376", "Korla", "Корла", "CN", "156", "", "13", "", "", "41.76055", "86.15231", "Asia/Urumqi"),("1529452", "Hoxtolgay", "", "CN", "156", "", "13", "", "", "46.51872", "86.00214", "Asia/Urumqi"),("1529484", "Hami", "Хами", "CN", "156", "", "13", "", "", "42.83393", "93.50601", "Asia/Urumqi"),("1529569", "Changji", "Чанцзи", "CN", "156", "", "13", "1529568", "", "44.00782", "87.30461", "Asia/Urumqi"),("1529626", "Baijiantan", "", "CN", "156", "", "13", "", "", "45.68928", "85.12441", "Asia/Urumqi"),("1529630", "Aykol", "", "CN", "156", "", "13", "", "", "40.95759", "80.13574", "Asia/Shanghai"),("1529641", "Aral", "Аральское", "CN", "156", "", "13", "", "", "40.54184", "81.26566", "Asia/Shanghai"),("1529651", "Altay", "Алтайская", "CN", "156", "", "13", "", "", "47.84864", "88.13361", "Asia/Urumqi"),("1529660", "Aksu", "Аксу", "CN", "156", "", "13", "", "", "41.18418", "80.27921", "Asia/Shanghai"),("1537890", "Sishilichengzi", "", "CN", "156", "CN", "13", "", "", "41.96194", "86.47667", "Asia/Urumqi"),("1783621", "Zunyi", "Цзуньи", "CN", "156", "", "18", "", "", "27.68667", "106.90722", "Asia/Shanghai"),("1783633", "Zoucheng", "", "CN", "156", "", "25", "", "", "35.40056", "116.96556", "Asia/Shanghai"),("1783683", "Yanjiang", "Цзыян", "CN", "156", "", "32", "", "", "30.12108", "104.64811", "Asia/Shanghai"),("1783745", "Zigong", "Цзыгун", "CN", "156", "", "32", "", "", "29.34162", "104.77689", "Asia/Shanghai"),("1783763", "Zhuzhou", "Чжучжоу", "CN", "156", "", "11", "1783761", "", "27.83333", "113.15", "Asia/Shanghai"),("1783873", "Zhumadian", "Чжумадянь", "CN", "156", "", "09", "", "", "32.97944", "114.02944", "Asia/Shanghai"),("1783920", "Zhujiajiao", "", "CN", "156", "", "23", "", "", "31.10757", "121.05696", "Asia/Shanghai"),("1783934", "Shangqiu", "Шанцю", "CN", "156", "", "09", "", "", "34.45", "115.65", "Asia/Shanghai"),("1783940", "Zhuji", "", "CN", "156", "", "02", "", "", "29.71877", "120.24233", "Asia/Shanghai"),("1783988", "Mizhou", "", "CN", "156", "", "25", "", "", "35.99472", "119.3975", "Asia/Shanghai"),("1784055", "Zhuanghe", "", "CN", "156", "", "19", "", "", "39.70083", "122.99111", "Asia/Shanghai"),("1784074", "Zhouzhuang", "Чжоучжуан", "CN", "156", "", "04", "", "", "31.11788", "120.84427", "Asia/Shanghai"),("1784130", "Zhoukou", "Чжоуко", "CN", "156", "", "09", "", "", "33.63333", "114.63333", "Asia/Shanghai"),("1784178", "Zhoucun", "", "CN", "156", "", "25", "", "", "36.81667", "117.81667", "Asia/Shanghai"),("1784185", "Yuxi", "Юйси", "CN", "156", "", "29", "", "", "24.355", "102.54222", "Asia/Shanghai"),("1784253", "Zhongxing", "", "CN", "156", "", "04", "", "", "33.70389", "118.67917", "Asia/Shanghai"),("1784310", "Zhongshu", "Чжуншу", "CN", "156", "", "29", "", "", "24.51667", "103.76667", "Asia/Shanghai"),("1784553", "Zhicheng", "", "CN", "156", "", "02", "", "", "31.0054", "119.90488", "Asia/Shanghai"),("1784554", "Zhicheng", "", "CN", "156", "", "12", "", "", "30.29556", "111.50472", "Asia/Shanghai"),("1784580", "Zhenzhou", "", "CN", "156", "", "04", "", "", "32.28034", "119.16999", "Asia/Shanghai"),("1784642", "Zhenjiang", "", "CN", "156", "", "04", "", "", "32.21086", "119.45508", "Asia/Shanghai"),("1784647", "Zhaobaoshan", "", "CN", "156", "", "02", "", "", "29.9695", "121.68753", "Asia/Shanghai"),("1784658", "Zhengzhou", "Чжэнчжоу", "CN", "156", "", "09", "", "", "34.75778", "113.64861", "Asia/Shanghai"),("1784820", "Xinghua", "Синхуа", "CN", "156", "", "04", "", "", "32.93917", "119.83417", "Asia/Shanghai"),("1784841", "Zhaotong", "Чжаотун", "CN", "156", "", "29", "", "", "27.31667", "103.71667", "Asia/Shanghai"),("1784853", "Zhaoqing", "Чжаоцин", "CN", "156", "", "30", "", "", "23.05116", "112.45972", "Asia/Shanghai"),("1784929", "Zhaogezhuang", "", "CN", "156", "", "10", "", "", "39.76538", "118.41191", "Asia/Shanghai"),("1784953", "Luofeng", "", "CN", "156", "", "25", "", "", "37.36497", "120.40997", "Asia/Shanghai"),("1784990", "Zhanjiang", "Чжаньцзян", "CN", "156", "", "30", "", "", "21.28145", "110.34271", "Asia/Urumqi"),("1785018", "Zhangzhou", "Чжанчжоу", "CN", "156", "", "07", "", "", "24.51333", "117.65556", "Asia/Shanghai"),("1785036", "Zhangye", "", "CN", "156", "", "15", "", "", "38.93417", "100.45167", "Asia/Shanghai"),("1785066", "Zhangwan", "", "CN", "156", "CN", "07", "", "", "26.71139", "119.59194", "Asia/Shanghai"),("1785286", "Zibo", "Цзыбо", "CN", "156", "", "25", "", "", "36.79056", "118.06333", "Asia/Shanghai"),("1785294", "Anyang", "Аньянг", "CN", "156", "", "09", "1817942", "", "36.096", "114.38278", "Asia/Shanghai"),("1785453", "Zaozhuang", "Цзаочжуан", "CN", "156", "", "25", "", "", "34.86472", "117.55417", "Asia/Shanghai"),("1785462", "Zaoyang", "", "CN", "156", "", "12", "", "", "32.12722", "112.75417", "Asia/Shanghai"),("1785489", "Zaojiacheng", "", "CN", "156", "", "28", "", "", "39.27706", "117.43574", "Asia/Shanghai"),("1785545", "Yuyao", "Юяо", "CN", "156", "", "02", "1799395", "1785543", "30.05", "121.14944", "Asia/Shanghai"),("1785566", "Yingchuan", "", "CN", "156", "", "09", "", "", "34.16278", "113.46389", "Asia/Shanghai"),("1785572", "Yuxia", "", "CN", "156", "", "26", "", "", "34.06153", "108.62905", "Asia/Shanghai"),("1785623", "Kunshan", "Куньшань", "CN", "156", "", "04", "", "", "31.37762", "120.95431", "Asia/Shanghai"),("1785655", "Yunyang", "", "CN", "156", "", "09", "", "", "33.44743", "112.71422", "Asia/Shanghai"),("1785698", "Yunmeng Chengguanzhen", "", "CN", "156", "", "12", "", "", "31.06251", "113.76545", "Asia/Shanghai"),("1785710", "Jinghong", "", "CN", "156", "", "29", "", "", "21.99102", "100.73409", "Asia/Shanghai"),("1785716", "Pizhou", "", "CN", "156", "", "04", "", "", "34.31139", "117.95028", "Asia/Shanghai"),("1785725", "Yunfu", "Юньфу", "CN", "156", "", "30", "", "", "22.92833", "112.03954", "Asia/Shanghai"),("1785738", "Yuncheng", "Юньчэн", "CN", "156", "", "24", "", "", "35.02306", "110.99278", "Asia/Shanghai"),("1785777", "Yulinshi", "Юйлинь", "CN", "156", "", "26", "", "", "38.29181", "109.73753", "Asia/Shanghai"),("1785781", "Yulin", "", "CN", "156", "", "16", "", "", "22.63333", "110.15", "Asia/Shanghai"),("1785964", "Yudong", "Юйдун", "CN", "156", "", "33", "", "", "29.385", "106.51944", "Asia/Shanghai"),("1785974", "Yuci", "", "CN", "156", "", "24", "", "", "37.68028", "112.73194", "Asia/Shanghai"),("1785980", "Yucheng", "Юйчэн", "CN", "156", "", "25", "", "", "34.92889", "116.46528", "Asia/Shanghai"),("1786060", "Yuanping", "", "CN", "156", "", "24", "", "", "38.71528", "112.7575", "Asia/Shanghai"),("1786067", "Qianjiang", "Юаньлинь", "CN", "156", "", "12", "", "", "30.421", "112.8919", "Asia/Shanghai"),("1786112", "Heyuan", "Хэюань", "CN", "156", "", "30", "", "", "23.73333", "114.68333", "Asia/Shanghai"),("1786293", "Yongning", "", "CN", "156", "CN", "07", "", "", "24.68", "118.69", "Asia/Shanghai"),("1786357", "Yongfeng", "", "CN", "156", "", "11", "", "", "27.42829", "112.18338", "Asia/Shanghai"),("1786378", "Yongchuan", "", "CN", "156", "", "33", "", "", "29.35376", "105.89392", "Asia/Shanghai"),("1786455", "Yishui", "", "CN", "156", "", "25", "", "", "35.78472", "118.62806", "Asia/Shanghai"),("1786546", "Zhongxiang", "", "CN", "156", "", "12", "", "", "31.16611", "112.58306", "Asia/Shanghai"),("1786587", "Yingshang Chengguanzhen", "", "CN", "156", "", "01", "", "", "32.62945", "116.27013", "Asia/Shanghai"),("1786640", "Chengzhong", "", "CN", "156", "", "12", "", "", "30.94454", "113.55284", "Asia/Shanghai"),("1786657", "Yinchuan", "Иньчуань", "CN", "156", "", "21", "", "", "38.46806", "106.27306", "Asia/Shanghai"),("1786676", "Yima", "Йимы", "CN", "156", "", "09", "", "", "34.73806", "111.88389", "Asia/Shanghai"),("1786720", "Yigou", "", "CN", "156", "", "09", "", "", "35.81139", "114.31667", "Asia/Shanghai"),("1786731", "Qingzhou", "Цинчжоу", "CN", "156", "", "25", "", "", "36.69667", "118.47972", "Asia/Shanghai"),("1786746", "Yichun", "Ичунь", "CN", "156", "", "03", "", "", "27.83333", "114.4", "Asia/Shanghai"),("1786759", "Yicheng", "", "CN", "156", "", "12", "", "", "31.70472", "112.25611", "Asia/Shanghai"),("1786760", "Yicheng", "", "CN", "156", "", "04", "", "", "31.36059", "119.82016", "Asia/Shanghai"),("1786764", "Yichang", "Ичан", "CN", "156", "", "12", "1786761", "", "30.71444", "111.28472", "Asia/Shanghai"),("1786770", "Yibin", "Ибинь", "CN", "156", "", "32", "", "", "28.76667", "104.62383", "Asia/Shanghai"),("1786855", "Yatou", "Жунчэн", "CN", "156", "", "25", "", "", "37.1566", "122.43762", "Asia/Shanghai"),("1786867", "Yashan", "", "CN", "156", "", "16", "", "", "22.1975", "109.94194", "Asia/Shanghai"),("1787031", "Yanzhou", "", "CN", "156", "", "25", "", "", "35.55278", "116.82861", "Asia/Shanghai"),("1787093", "Yantai", "Яньтай", "CN", "156", "", "25", "", "", "37.47649", "121.44081", "Asia/Shanghai"),("1787144", "Yanliang", "", "CN", "156", "", "26", "", "", "34.65918", "109.22921", "Asia/Shanghai"),("1787227", "Yangzhou", "Янчжоу", "CN", "156", "", "04", "", "", "32.39722", "119.43583", "Asia/Shanghai"),("1787323", "Yangshuo", "Яншо", "CN", "156", "", "16", "", "", "24.78081", "110.48967", "Asia/Shanghai"),("1787331", "Zhangjiagang", "", "CN", "156", "", "04", "", "", "31.865", "120.53889", "Asia/Shanghai"),("1787351", "Yangquan", "", "CN", "156", "", "24", "", "", "37.8575", "113.56333", "Asia/Shanghai"),("1787437", "Yangliuqing", "", "CN", "156", "", "28", "", "", "39.1375", "116.99972", "Asia/Shanghai"),("1787601", "Yanggu", "Янг", "CN", "156", "", "25", "", "", "36.11056", "115.77528", "Asia/Shanghai"),("1787646", "Yangcun", "", "CN", "156", "", "28", "", "", "39.36389", "117.06028", "Asia/Shanghai"),("1787746", "Yancheng", "Яньчэн", "CN", "156", "", "04", "", "", "33.3575", "120.1573", "Asia/Shanghai"),("1787824", "Tongshan", "Сюйчжоу", "CN", "156", "", "04", "", "", "34.18045", "117.15707", "Asia/Shanghai"),("1787837", "Xucheng", "", "CN", "156", "", "30", "", "", "20.32917", "110.16712", "Asia/Urumqi"),("1787858", "Shangrao", "Шанжао", "CN", "156", "", "03", "", "", "28.45179", "117.94287", "Asia/Shanghai"),("1787901", "Xunchang", "", "CN", "156", "", "32", "", "", "28.45433", "104.71498", "Asia/Shanghai"),("1788046", "Jiangguanchi", "", "CN", "156", "", "09", "", "", "34.12821", "113.80681", "Asia/Shanghai"),("1788081", "Xuanzhou", "", "CN", "156", "", "01", "", "", "30.9525", "118.75528", "Asia/Shanghai"),("1788206", "Xixiang", "", "CN", "156", "", "09", "", "", "35.16278", "112.865", "Asia/Shanghai"),("1788245", "Xiuying", "", "CN", "156", "CN", "31", "", "", "20.00073", "110.29359", "Asia/Shanghai"),("1788268", "Xiulin", "", "CN", "156", "", "12", "", "", "29.71667", "112.4", "Asia/Shanghai"),("1788291", "Xitangtuo", "", "CN", "156", "", "28", "", "", "39.3224", "117.48821", "Asia/Shanghai"),("1788402", "Xiongzhou", "", "CN", "156", "", "30", "", "", "25.11667", "114.3", "Asia/Shanghai"),("1788406", "Guixi", "", "CN", "156", "", "03", "", "", "28.28857", "117.21329", "Asia/Shanghai"),("1788450", "Xinzhou", "Синьчжоу", "CN", "156", "", "24", "", "", "38.40917", "112.73333", "Asia/Shanghai"),("1788452", "Xinzhou", "", "CN", "156", "", "12", "", "", "30.86667", "114.8", "Asia/Shanghai"),("1788462", "Xinzhi", "", "CN", "156", "", "24", "", "", "36.49889", "111.70472", "Asia/Shanghai"),("1788508", "Xinyu", "", "CN", "156", "", "03", "9072903", "", "27.80429", "114.93335", "Asia/Shanghai"),("1788522", "Hancheng", "", "CN", "156", "", "09", "", "", "32.51861", "112.35222", "Asia/Shanghai"),("1788534", "Xinyang", "Цзинань", "CN", "156", "", "09", "", "", "32.12278", "114.06556", "Asia/Shanghai"),("1788572", "Nangandao", "Синьсян", "CN", "156", "", "09", "", "", "35.19033", "113.80151", "Asia/Shanghai"),("1788618", "Xintai", "", "CN", "156", "", "25", "", "", "35.90056", "117.75194", "Asia/Shanghai"),("1788638", "Xinshi", "", "CN", "156", "", "12", "", "", "31.04704", "113.14098", "Asia/Shanghai"),("1788694", "Xinpu", "", "CN", "156", "", "04", "", "", "34.59972", "119.15944", "Asia/Shanghai"),("1788816", "Xinji", "", "CN", "156", "", "10", "", "", "37.90278", "115.20361", "Asia/Shanghai"),("1788852", "Xining", "Синин", "CN", "156", "", "06", "", "", "36.62554", "101.75739", "Asia/Shanghai"),("1788869", "Shangmei", "", "CN", "156", "", "11", "", "", "27.74278", "111.29556", "Asia/Shanghai"),("1788927", "Xingtai", "Синтай", "CN", "156", "", "10", "", "", "37.06306", "114.49417", "Asia/Shanghai"),("1789065", "Ankang", "Анкан", "CN", "156", "", "26", "", "", "32.68", "109.01722", "Asia/Shanghai"),("1789118", "Xindian", "", "CN", "156", "", "25", "", "", "36.7975", "118.29444", "Asia/Shanghai"),("1789134", "Xindian", "", "CN", "156", "", "07", "", "", "24.61006", "118.24068", "Asia/Shanghai"),("1789137", "Xindi", "", "CN", "156", "", "12", "", "", "29.81667", "113.46667", "Asia/Shanghai"),("1789176", "Feicheng", "", "CN", "156", "", "25", "", "", "36.24861", "116.76583", "Asia/Shanghai"),("1789273", "Sanshui", "", "CN", "156", "", "30", "", "", "23.15486", "112.89161", "Asia/Shanghai"),("1789289", "Ximei", "", "CN", "156", "", "07", "", "", "24.98773", "118.3858", "Asia/Shanghai"),("1789427", "Wacheng", "", "CN", "156", "", "09", "", "", "33.78333", "114.51667", "Asia/Shanghai"),("1789462", "Xihe", "", "CN", "156", "", "12", "", "", "31.68635", "113.46585", "Asia/Shanghai"),("1789597", "Xiditou", "", "CN", "156", "", "28", "", "", "39.25375", "117.34814", "Asia/Shanghai"),("1789647", "Xichang", "Сичан", "CN", "156", "", "32", "", "", "27.89642", "102.26341", "Asia/Shanghai"),("1789659", "Xibing", "", "CN", "156", "CN", "07", "", "", "26.98139", "119.72472", "Asia/Shanghai"),("1789693", "Xiazhuang", "", "CN", "156", "", "25", "", "", "34.91611", "118.63889", "Asia/Shanghai"),("1789703", "Xiazhen", "", "CN", "156", "", "25", "", "", "34.80222", "117.11167", "Asia/Shanghai"),("1789799", "Xiashi", "", "CN", "156", "", "02", "", "", "30.53629", "120.68638", "Asia/Shanghai"),("1789897", "Zijinglu", "", "CN", "156", "", "09", "", "", "34.76", "112.97139", "Asia/Shanghai"),("1789945", "Xiaoweizhai", "", "CN", "156", "", "18", "", "", "26.19028", "107.5125", "Asia/Shanghai"),("1789998", "Xiaoshan", "Сяошань", "CN", "156", "", "02", "", "", "30.16746", "120.25883", "Asia/Shanghai"),("1790100", "Xiaolingwei", "", "CN", "156", "", "04", "", "", "32.03244", "118.854", "Asia/Shanghai"),("1790254", "Xiaogan", "", "CN", "156", "", "12", "1790253", "", "30.92689", "113.92221", "Asia/Shanghai"),("1790272", "Xiaodian", "", "CN", "156", "", "28", "", "", "39.25412", "117.22747", "Asia/Shanghai"),("1790353", "Xianyang", "Саньян", "CN", "156", "", "26", "", "", "34.33778", "108.70261", "Asia/Shanghai"),("1790371", "Xiantao", "", "CN", "156", "", "12", "", "", "30.3708", "113.44294", "Asia/Shanghai"),("1790379", "Xianshuigu", "", "CN", "156", "", "28", "", "", "38.985", "117.38278", "Asia/Shanghai"),("1790392", "Xiannü", "", "CN", "156", "", "04", "", "", "32.42806", "119.56048", "Asia/Shanghai"),("1790396", "Xianning", "Сяньнин", "CN", "156", "", "12", "1790395", "", "29.84347", "114.32201", "Asia/Shanghai"),("1790413", "Xianju", "", "CN", "156", "", "02", "", "", "28.8547", "120.73168", "Asia/Shanghai"),("1790437", "Zhuhai", "Чжухай", "CN", "156", "", "30", "", "", "22.27694", "113.56778", "Asia/Shanghai"),("1790451", "Wenxing", "", "CN", "156", "", "11", "", "", "28.68208", "112.87864", "Asia/Shanghai"),("1790471", "Xiangxiang", "", "CN", "156", "", "11", "", "", "27.73333", "112.53333", "Asia/Shanghai"),("1790492", "Xiangtan", "Сянтань", "CN", "156", "", "11", "", "", "27.85", "112.9", "Asia/Shanghai"),("1790587", "Xiangyang", "Сянфань", "CN", "156", "", "12", "1790585", "", "32.0422", "112.14479", "Asia/Shanghai"),("1790601", "Xiangcheng Chengguanzhen", "", "CN", "156", "", "09", "", "", "33.84703", "113.4778", "Asia/Shanghai"),("1790630", "Xi’an", "Сиань", "CN", "156", "", "26", "", "", "34.25833", "108.92861", "Asia/Shanghai"),("1790645", "Xiamen", "Сямэнь", "CN", "156", "", "07", "", "", "24.47979", "118.08187", "Asia/Shanghai"),("1790707", "Xiahu", "", "CN", "156", "CN", "07", "", "", "26.61056", "119.94833", "Asia/Shanghai"),("1790807", "Xiabaishi", "", "CN", "156", "CN", "07", "", "", "26.81528", "119.67917", "Asia/Shanghai"),("1790840", "Wuzhou", "", "CN", "156", "", "16", "", "", "23.48333", "111.31667", "Asia/Shanghai"),("1790885", "Wuyang", "", "CN", "156", "", "01", "", "", "31.9925", "116.24722", "Asia/Shanghai"),("1790894", "Wuxue", "", "CN", "156", "", "12", "", "", "29.85058", "115.5525", "Asia/Shanghai"),("1790923", "Wuxi", "Уси", "CN", "156", "", "04", "", "", "31.56887", "120.28857", "Asia/Shanghai"),("1791056", "Dongyang", "", "CN", "156", "", "02", "", "", "29.26778", "120.22528", "Asia/Shanghai"),("1791121", "Changde", "Чандэ", "CN", "156", "", "11", "", "", "29.04638", "111.6783", "Asia/Shanghai"),("1791236", "Wuhu", "Уху", "CN", "156", "", "01", "", "", "31.33728", "118.37351", "Asia/Shanghai"),("1791247", "Wuhan", "Ухань", "CN", "156", "", "12", "", "", "30.58333", "114.26667", "Asia/Shanghai"),("1791249", "Wuhai", "", "CN", "156", "", "20", "", "", "39.68442", "106.81583", "Asia/Shanghai"),("1791325", "Wuda", "", "CN", "156", "", "20", "", "", "39.49944", "106.71167", "Asia/Shanghai"),("1791347", "Wucheng", "", "CN", "156", "", "01", "", "", "29.60077", "118.17495", "Asia/Shanghai"),("1791388", "Wenzhou", "Вэньчжоу", "CN", "156", "", "02", "", "", "27.99942", "120.66682", "Asia/Shanghai"),("1791422", "Wenshui", "", "CN", "156", "", "18", "", "", "28.45056", "106.52667", "Asia/Shanghai"),("1791428", "Wenshang", "", "CN", "156", "", "25", "", "", "35.7275", "116.49611", "Asia/Shanghai"),("1791464", "Wenling", "", "CN", "156", "", "02", "", "", "28.37524", "121.38416", "Asia/Shanghai"),("1791536", "Tianfu", "", "CN", "156", "", "25", "", "", "37.19723", "122.05228", "Asia/Shanghai"),("1791636", "Weinan", "Вэйнань", "CN", "156", "", "26", "", "", "34.50355", "109.50891", "Asia/Shanghai"),("1791673", "Weihai", "Вэйхай", "CN", "156", "", "25", "", "", "37.50914", "122.11356", "Asia/Shanghai"),("1791681", "Weifang", "Вэйфан", "CN", "156", "", "25", "", "", "36.71", "119.10194", "Asia/Shanghai"),("1791748", "Wanxian", "", "CN", "156", "", "33", "", "", "30.81544", "108.37089", "Asia/Shanghai"),("1791779", "Wanning", "", "CN", "156", "", "31", "Wanning Shi (undefined)", "", "18.79931", "110.3841", "Asia/Shanghai"),("1792087", "Yinzhu", "", "CN", "156", "", "25", "", "", "35.87861", "119.97528", "Asia/Shanghai"),("1792260", "Wafangdian", "", "CN", "156", "", "19", "", "", "39.61833", "122.00806", "Asia/Shanghai"),("1792286", "Tuzhai", "", "CN", "156", "", "07", "", "", "24.98301", "118.83194", "Asia/Shanghai"),("1792359", "Huangshan", "Туньси", "CN", "156", "", "01", "", "", "29.71139", "118.3125", "Asia/Shanghai"),("1792516", "Loushanguan", "", "CN", "156", "", "18", "", "", "28.1368", "106.822", "Asia/Shanghai"),("1792520", "Tongzhou", "Тунчжоу", "CN", "156", "", "22", "", "", "39.90395", "116.66183", "Asia/Shanghai"),("1792585", "Fuding", "", "CN", "156", "", "07", "", "", "27.32734", "120.21399", "Asia/Shanghai"),("1792592", "Tongren", "", "CN", "156", "", "18", "1792591", "", "27.71722", "109.18528", "Asia/Shanghai"),("1792621", "Wusong", "", "CN", "156", "", "01", "", "", "30.95", "117.78333", "Asia/Shanghai"),("1792692", "Tongchuan", "", "CN", "156", "", "32", "", "", "31.09407", "105.08731", "Asia/Shanghai"),("1792749", "Tingjiang", "", "CN", "156", "", "07", "", "", "26.07401", "119.50574", "Asia/Shanghai"),("1792892", "Tianshui", "", "CN", "156", "", "15", "", "", "34.57952", "105.74238", "Asia/Shanghai"),("1792916", "Tianpeng", "", "CN", "156", "", "32", "", "", "30.98664", "103.93933", "Asia/Shanghai"),("1792947", "Tianjin", "Тяньцзинь", "CN", "156", "", "28", "", "", "39.14222", "117.17667", "Asia/Shanghai"),("1793036", "Chengtangcun", "Тэнчжоу", "CN", "156", "", "25", "", "", "35.08357", "117.19071", "Asia/Shanghai"),("1793089", "Taozhuang", "", "CN", "156", "", "25", "", "", "34.85", "117.33333", "Asia/Shanghai"),("1793230", "Tantou", "", "CN", "156", "", "07", "", "", "26.03033", "119.59739", "Asia/Shanghai"),("1793286", "Tangzhai", "", "CN", "156", "", "01", "", "", "34.43278", "116.59111", "Asia/Shanghai"),("1793346", "Tangshan", "Таншань", "CN", "156", "", "10", "", "", "39.63333", "118.18333", "Asia/Shanghai"),("1793364", "Tangping", "", "CN", "156", "", "30", "", "", "22.03177", "111.93537", "Asia/Shanghai"),("1793385", "Tangjiazhuang", "", "CN", "156", "", "10", "", "", "39.74326", "118.45099", "Asia/Shanghai"),("1793419", "Binhe", "", "CN", "156", "", "09", "", "", "32.68833", "112.8275", "Asia/Shanghai"),("1793424", "Tanggu", "Танго", "CN", "156", "", "28", "", "", "39.02111", "117.64694", "Asia/Shanghai"),("1793505", "Taizhou", "Тайчжоу", "CN", "156", "", "04", "", "", "32.49069", "119.90812", "Asia/Shanghai"),("1793511", "Taiyuan", "Тайюань", "CN", "156", "", "24", "", "", "37.86944", "112.56028", "Asia/Shanghai"),("1793533", "Taixing", "", "CN", "156", "", "04", "", "", "32.16667", "120.01361", "Asia/Shanghai"),("1793700", "Taishan", "Тайшань", "CN", "156", "", "30", "", "", "22.25135", "112.7799", "Asia/Shanghai"),("1793724", "Tai’an", "Тайань", "CN", "156", "", "25", "", "", "36.18528", "117.12", "Asia/Shanghai"),("1793743", "Suzhou", "Сучжоу", "CN", "156", "", "01", "", "", "33.63611", "116.97889", "Asia/Shanghai"),("1793774", "Suozhen", "", "CN", "156", "", "25", "", "", "36.95389", "118.10472", "Asia/Shanghai"),("1793879", "Suizhou", "", "CN", "156", "", "12", "", "", "31.71111", "113.36306", "Asia/Shanghai"),("1793889", "Suixi", "", "CN", "156", "", "01", "", "", "33.89067", "116.77473", "Asia/Shanghai"),("1793899", "Suicheng", "", "CN", "156", "", "04", "", "", "33.8963", "117.93307", "Asia/Shanghai"),("1793900", "Suining", "Суйнин", "CN", "156", "", "32", "", "", "30.50802", "105.57332", "Asia/Shanghai");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("1794035", "Songjiang", "", "CN", "156", "", "23", "", "", "31.03595", "121.2146", "Asia/Shanghai"),("1794140", "Sishui", "", "CN", "156", "", "25", "", "", "35.64889", "117.27583", "Asia/Shanghai"),("1794198", "Simenqian", "", "CN", "156", "", "11", "", "", "27.48722", "110.88611", "Asia/Shanghai"),("1794479", "Laixi", "", "CN", "156", "", "25", "", "", "36.85917", "120.52694", "Asia/Shanghai"),("1794685", "Shuangjiang", "", "CN", "156", "", "11", "", "", "26.15467", "109.7138", "Asia/Shanghai"),("1794794", "Shouguang", "Шоугуан", "CN", "156", "", "25", "", "", "36.88", "118.7375", "Asia/Shanghai"),("1794806", "Shizuishan", "", "CN", "156", "", "21", "", "", "39.23333", "106.76944", "Asia/Shanghai"),("1794825", "Shizilu", "", "CN", "156", "", "25", "", "", "35.17111", "118.82889", "Asia/Shanghai"),("1794903", "Shiyan", "Шиянь", "CN", "156", "", "12", "1794892", "", "32.6475", "110.77806", "Asia/Shanghai"),("1794904", "Shiyan", "Шиян", "CN", "156", "", "12", "", "", "32.56667", "110.78333", "Asia/Shanghai"),("1794920", "Shijiang", "", "CN", "156", "CN", "11", "", "", "27.08194", "110.79333", "Asia/Shanghai"),("1794947", "Shiwan", "", "CN", "156", "", "30", "", "", "23.00107", "113.077", "Asia/Shanghai"),("1794971", "Shitanjing", "", "CN", "156", "", "21", "", "", "39.23417", "106.34389", "Asia/Shanghai"),("1795055", "Shiqiao", "", "CN", "156", "", "30", "", "", "22.9464", "113.35769", "Asia/Shanghai"),("1795058", "Shiqian", "", "CN", "156", "CN", "18", "", "", "27.5225", "108.22806", "Asia/Shanghai"),("1795060", "Shiqi", "", "CN", "156", "", "30", "", "", "22.51682", "113.38521", "Asia/Shanghai"),("1795166", "Shima", "Шима", "CN", "156", "", "07", "", "", "24.44647", "117.81216", "Asia/Shanghai"),("1795184", "Shilong", "", "CN", "156", "", "30", "", "", "23.11444", "113.84722", "Asia/Shanghai"),("1795196", "Tongchuanshi", "", "CN", "156", "", "26", "", "", "35.07474", "109.08495", "Asia/Shanghai"),("1795270", "Shijiazhuang", "Шицзячжуан", "CN", "156", "", "10", "", "", "38.04139", "114.47861", "Asia/Shanghai"),("1795565", "Shenzhen", "Шэньчжэнь", "CN", "156", "", "30", "1795563", "", "22.54554", "114.0683", "Asia/Shanghai"),("1795579", "Yanta", "", "CN", "156", "", "25", "", "", "36.24111", "115.66722", "Asia/Shanghai"),("1795632", "Shenjiamen", "", "CN", "156", "", "02", "", "", "29.95763", "122.29802", "Asia/Shanghai"),("1795816", "Shashi", "Шаши", "CN", "156", "", "12", "", "", "30.30722", "112.24472", "Asia/Shanghai"),("1795842", "Shaping", "", "CN", "156", "", "30", "", "", "22.77019", "112.95776", "Asia/Shanghai"),("1795855", "Shaoxing", "Шаосин", "CN", "156", "", "02", "", "", "30.00237", "120.57864", "Asia/Shanghai"),("1795857", "Shaowu", "", "CN", "156", "", "07", "", "", "27.34089", "117.4831", "Asia/Shanghai"),("1795874", "Shaoguan", "Шаогуань", "CN", "156", "", "30", "", "", "24.8", "113.58333", "Asia/Shanghai"),("1795909", "Shanyang", "", "CN", "156", "", "07", "", "", "26.67019", "119.20509", "Asia/Shanghai"),("1795919", "Shancheng", "", "CN", "156", "", "25", "", "", "34.79528", "116.08167", "Asia/Shanghai"),("1795928", "Shanwei", "Шаньвэй", "CN", "156", "", "30", "", "", "22.78199", "115.3475", "Asia/Shanghai"),("1795940", "Shantou", "Шаньтоу", "CN", "156", "", "30", "", "", "23.36814", "116.71479", "Asia/Shanghai"),("1795941", "Shanting", "", "CN", "156", "", "25", "", "", "35.07528", "117.45778", "Asia/Shanghai"),("1796236", "Shanghai", "Шанхай", "CN", "156", "", "23", "", "", "31.22222", "121.45806", "Asia/Shanghai"),("1796379", "Shajiang", "", "CN", "156", "CN", "07", "", "", "26.7825", "119.96694", "Asia/Shanghai"),("1796421", "Shahecheng", "", "CN", "156", "", "10", "", "", "36.93833", "114.50583", "Asia/Shanghai"),("1796556", "Sanya", "Санья", "CN", "156", "", "31", "", "", "18.24306", "109.505", "Asia/Shanghai"),("1796663", "Sanming", "Саньмин", "CN", "156", "", "07", "", "", "26.24861", "117.61861", "Asia/Shanghai"),("1797038", "Runing", "", "CN", "156", "", "09", "", "", "33.00111", "114.35417", "Asia/Shanghai"),("1797120", "Fuqing", "Фуцинь", "CN", "156", "", "07", "", "", "25.725", "119.37944", "Asia/Shanghai"),("1797121", "Jieyang", "Цзеян", "CN", "156", "", "30", "", "", "23.5418", "116.36581", "Asia/Shanghai"),("1797132", "Rizhao", "", "CN", "156", "", "25", "", "", "35.4275", "119.45528", "Asia/Shanghai"),("1797181", "Renqiu", "", "CN", "156", "", "10", "", "", "38.69889", "116.09361", "Asia/Shanghai"),("1797264", "Quzhou", "Цюйчжоу", "CN", "156", "", "02", "", "", "28.95944", "118.86861", "Asia/Shanghai"),("1797318", "Qujing", "", "CN", "156", "", "29", "", "", "25.48333", "103.78333", "Asia/Shanghai"),("1797333", "Qufu", "Цюйфу", "CN", "156", "", "25", "", "", "35.59667", "116.99111", "Asia/Shanghai"),("1797353", "Quanzhou", "Цюаньчжоу", "CN", "156", "", "07", "", "", "24.91389", "118.58583", "Asia/Shanghai"),("1797417", "Wuxi", "", "CN", "156", "", "11", "", "", "26.5844", "111.859", "Asia/Shanghai"),("1797438", "Zhuangyuan", "", "CN", "156", "", "25", "", "", "37.30553", "120.82747", "Asia/Shanghai"),("1797535", "Qiongshan", "", "CN", "156", "", "31", "", "", "20.00583", "110.35417", "Asia/Shanghai"),("1797543", "Qionghu", "", "CN", "156", "", "11", "", "", "28.84061", "112.37399", "Asia/Shanghai"),("1797551", "Qinzhou", "", "CN", "156", "", "16", "", "", "21.97296", "108.62612", "Asia/Shanghai"),("1797575", "Qinnan", "", "CN", "156", "", "04", "", "", "33.25306", "119.91333", "Asia/Shanghai"),("1797595", "Qinhuangdao", "Циньхуандао", "CN", "156", "", "10", "1797593", "", "39.93167", "119.58833", "Asia/Shanghai"),("1797658", "Jinjiang", "", "CN", "156", "", "07", "", "", "24.81978", "118.57415", "Asia/Shanghai"),("1797793", "Qingquan", "Цинцюань", "CN", "156", "", "12", "", "", "30.45113", "115.25593", "Asia/Shanghai"),("1797873", "Huai'an", "", "CN", "156", "", "04", "", "", "33.58861", "119.01917", "Asia/Shanghai"),("1797905", "Qingguang", "", "CN", "156", "", "28", "", "", "39.19883", "117.03314", "Asia/Shanghai"),("1797929", "Qingdao", "Циндао", "CN", "156", "", "25", "", "", "36.06605", "120.36939", "Asia/Shanghai"),("1797945", "Qingyuan", "", "CN", "156", "", "30", "", "", "23.7", "113.03333", "Asia/Shanghai"),("1798078", "Qidu", "", "CN", "156", "CN", "07", "", "", "26.76528", "119.54722", "Asia/Shanghai"),("1798082", "Hongqiao", "Хунцяо", "CN", "156", "", "11", "", "", "26.76837", "112.10814", "Asia/Shanghai"),("1798371", "Qiancheng", "", "CN", "156", "", "11", "", "", "27.18501", "109.76543", "Asia/Shanghai"),("1798422", "Puyang Chengguanzhen", "", "CN", "156", "", "09", "", "", "35.70506", "115.01409", "Asia/Shanghai"),("1798425", "Puyang", "", "CN", "156", "", "02", "", "", "29.45679", "119.88872", "Asia/Shanghai"),("1798449", "Putian", "Путянь", "CN", "156", "", "07", "", "", "25.43944", "119.01028", "Asia/Shanghai"),("1798473", "Puqi", "", "CN", "156", "", "12", "", "", "29.71667", "113.88333", "Asia/Shanghai"),("1798480", "Pumiao", "", "CN", "156", "", "16", "", "", "22.75867", "108.48111", "Asia/Shanghai"),("1798490", "Pulandian", "", "CN", "156", "", "19", "", "", "39.39528", "121.96694", "Asia/Shanghai"),("1798548", "Poyang", "Поянху", "CN", "156", "", "03", "", "", "28.99242", "116.66754", "Asia/Shanghai"),("1798632", "Pingyin", "", "CN", "156", "", "25", "", "", "36.28306", "116.44528", "Asia/Shanghai"),("1798634", "Pingyi", "", "CN", "156", "", "25", "", "", "35.50056", "117.63083", "Asia/Shanghai"),("1798636", "Gutao", "Пинъяо", "CN", "156", "", "24", "", "", "37.2025", "112.17806", "Asia/Shanghai"),("1798654", "Pingxiang", "", "CN", "156", "", "03", "1798652", "", "27.61672", "113.85353", "Asia/Shanghai"),("1798713", "Pingshan", "", "CN", "156", "", "30", "", "", "22.99376", "114.71311", "Asia/Shanghai"),("1798733", "Pingnan", "", "CN", "156", "", "16", "", "", "23.54218", "110.38946", "Asia/Shanghai"),("1798760", "Pingliang", "Пинлян", "CN", "156", "", "15", "", "", "35.53917", "106.68611", "Asia/Shanghai"),("1798821", "Pingdu", "Пинду", "CN", "156", "", "25", "", "", "36.78444", "119.94639", "Asia/Shanghai"),("1798827", "Pingdingshan", "Пиндиншань", "CN", "156", "", "09", "", "", "33.73847", "113.30119", "Asia/Shanghai"),("1798946", "Pengcheng", "", "CN", "156", "", "10", "", "", "36.43111", "114.17", "Asia/Shanghai"),("1798998", "Dadukou", "Паньчжихуа", "CN", "156", "", "32", "", "", "26.5479", "101.70539", "Asia/Shanghai"),("1799348", "Ningyang", "", "CN", "156", "", "25", "", "", "35.76417", "116.79139", "Asia/Shanghai"),("1799352", "Yutan", "", "CN", "156", "", "11", "", "", "28.25831", "112.56048", "Asia/Shanghai"),("1799383", "Ninghai", "", "CN", "156", "", "25", "", "", "37.38422", "121.60859", "Asia/Shanghai"),("1799384", "Ninghai", "", "CN", "156", "", "02", "", "", "29.28917", "121.42472", "Asia/Shanghai"),("1799393", "Ningchegu", "", "CN", "156", "CN", "28", "", "", "39.15889", "117.6625", "Asia/Shanghai"),("1799397", "Ningbo", "Нинбо", "CN", "156", "", "02", "", "", "29.87819", "121.54945", "Asia/Shanghai"),("1799491", "Neijiang", "", "CN", "156", "", "32", "", "", "29.58354", "105.06216", "Asia/Shanghai"),("1799552", "Nanzhou", "", "CN", "156", "", "11", "", "", "29.35955", "112.40243", "Asia/Shanghai"),("1799574", "Nanzhang Chengguanzhen", "", "CN", "156", "", "12", "", "", "31.78394", "111.82752", "Asia/Shanghai"),("1799629", "Nanyang", "Наньян", "CN", "156", "", "09", "", "", "32.99472", "112.53278", "Asia/Shanghai"),("1799722", "Nantong", "Наньтун", "CN", "156", "", "04", "", "", "32.03028", "120.87472", "Asia/Shanghai"),("1799832", "Pucheng", "", "CN", "156", "", "07", "", "", "27.92333", "118.53333", "Asia/Shanghai"),("1799846", "Nanping", "Наньпин", "CN", "156", "", "07", "", "", "26.645", "118.17361", "Asia/Shanghai"),("1799869", "Nanning", "Наньнин", "CN", "156", "", "16", "", "", "22.81667", "108.31667", "Asia/Shanghai"),("1799897", "Nanma", "", "CN", "156", "", "25", "", "", "36.18478", "118.15486", "Asia/Shanghai"),("1799908", "Nanlong", "", "CN", "156", "", "32", "", "", "31.35333", "106.06309", "Asia/Shanghai"),("1799962", "Nanjing", "Нанкин", "CN", "156", "", "04", "", "", "32.06167", "118.77778", "Asia/Shanghai"),("1800065", "Nangong", "", "CN", "156", "", "10", "", "", "37.35806", "115.37444", "Asia/Shanghai"),("1800088", "Nanfeng", "", "CN", "156", "", "30", "", "", "23.72695", "111.79723", "Asia/Shanghai"),("1800101", "Nandu", "", "CN", "156", "", "16", "", "", "22.8525", "110.82333", "Asia/Shanghai"),("1800107", "Nanding", "", "CN", "156", "", "25", "", "", "36.74833", "118.05583", "Asia/Shanghai"),("1800146", "Nanchong", "Наньчун", "CN", "156", "", "32", "", "", "30.79508", "106.08473", "Asia/Shanghai"),("1800163", "Nanchang", "Наньчан", "CN", "156", "", "03", "", "", "28.68396", "115.85306", "Asia/Shanghai"),("1800430", "Miyang", "", "CN", "156", "", "29", "", "", "24.40417", "103.44278", "Asia/Shanghai"),("1800498", "Mingshui", "", "CN", "156", "", "25", "", "", "36.71667", "117.5", "Asia/Shanghai"),("1800519", "Mingguang", "", "CN", "156", "", "01", "", "", "32.78017", "117.96378", "Asia/Shanghai"),("1800521", "Minggang", "", "CN", "156", "", "09", "", "", "32.45861", "114.04861", "Asia/Shanghai"),("1800627", "Mianyang", "Мяньян", "CN", "156", "", "32", "", "", "31.46784", "104.68168", "Asia/Shanghai"),("1800657", "Mentougou", "", "CN", "156", "", "22", "", "", "39.93819", "116.09307", "Asia/Shanghai"),("1800675", "Mengyin", "", "CN", "156", "", "25", "", "", "35.70694", "117.92639", "Asia/Shanghai"),("1800764", "Mengcheng Chengguanzhen", "", "CN", "156", "", "01", "", "", "33.26611", "116.56605", "Asia/Shanghai"),("1800779", "Meizhou", "Мэйчжоу", "CN", "156", "", "30", "1800794", "", "24.28859", "116.11768", "Asia/Shanghai"),("1800829", "Wuchuan", "", "CN", "156", "", "30", "", "", "21.45713", "110.76591", "Asia/Urumqi"),("1801401", "Majie", "", "CN", "156", "", "29", "", "", "25.0319", "102.638", "Asia/Shanghai"),("1801455", "Zhijiang", "", "CN", "156", "", "12", "", "", "30.42139", "111.75333", "Asia/Shanghai"),("1801582", "Macheng", "", "CN", "156", "", "12", "", "", "31.18013", "115.02213", "Asia/Shanghai"),("1801615", "Maba", "", "CN", "156", "", "30", "", "", "24.68413", "113.59839", "Asia/Shanghai"),("1801722", "Lüshun", "Порт-Артур", "CN", "156", "", "19", "", "", "38.8", "121.26667", "Asia/Shanghai"),("1801757", "Luqiao", "", "CN", "156", "", "02", "", "", "28.58023", "121.37491", "Asia/Shanghai"),("1801792", "Luoyang", "Лоян", "CN", "156", "", "09", "1801785", "", "34.68361", "112.45361", "Asia/Shanghai"),("1801797", "Luoyang", "Лоян", "CN", "156", "", "07", "", "", "24.95938", "118.683", "Asia/Shanghai"),("1801799", "Luoyang", "Лоян", "CN", "156", "", "30", "", "", "23.16244", "114.27342", "Asia/Shanghai"),("1801850", "Luorong", "", "CN", "156", "", "16", "", "", "24.40583", "109.60861", "Asia/Shanghai"),("1801934", "Luohe", "", "CN", "156", "", "09", "", "", "33.56394", "114.04272", "Asia/Shanghai"),("1801983", "Luocheng", "", "CN", "156", "", "32", "", "", "29.38481", "104.02862", "Asia/Shanghai"),("1802068", "Lucheng", "", "CN", "156", "", "01", "", "", "31.23357", "117.28057", "Asia/Shanghai"),("1802171", "Kangding", "Кандин", "CN", "156", "", "32", "1810269", "1804839", "30.00222", "101.9569", "Asia/Shanghai"),("1802177", "Lubu", "", "CN", "156", "", "30", "", "", "23.17233", "112.28298", "Asia/Shanghai"),("1802204", "Luancheng", "", "CN", "156", "", "10", "", "", "37.87917", "114.65167", "Asia/Shanghai"),("1802238", "Loudi", "Лоуди", "CN", "156", "", "11", "", "", "27.73444", "111.99444", "Asia/Shanghai"),("1802476", "Longquan", "Лунцюань", "CN", "156", "", "29", "", "", "24.67193", "102.1613", "Asia/Shanghai"),("1802526", "Longmen", "", "CN", "156", "CN", "07", "", "", "24.95972", "118.08889", "Asia/Shanghai"),("1802550", "Longgang", "", "CN", "156", "", "25", "", "", "37.65181", "120.33063", "Asia/Shanghai"),("1802788", "Licheng", "", "CN", "156", "", "04", "", "", "31.42813", "119.48353", "Asia/Shanghai"),("1802875", "Guankou", "Лиуянг", "CN", "156", "", "11", "", "", "28.15861", "113.62709", "Asia/Shanghai"),("1802940", "Puning", "", "CN", "156", "", "30", "1805830", "1798477", "23.31072", "116.16869", "Asia/Shanghai"),("1803010", "Liukuaizhuang", "", "CN", "156", "", "28", "", "", "39.24789", "117.33941", "Asia/Shanghai"),("1803159", "Liuduzhai", "", "CN", "156", "", "11", "", "", "27.36611", "110.935", "Asia/Shanghai"),("1803245", "Lishui", "Лишуй", "CN", "156", "", "02", "", "", "28.46042", "119.91029", "Asia/Shanghai"),("1803266", "Lintong", "", "CN", "156", "", "26", "", "", "34.37803", "109.20892", "Asia/Shanghai"),("1803318", "Linyi", "Линьи", "CN", "156", "", "25", "", "", "35.06306", "118.34278", "Asia/Shanghai"),("1803331", "Linxia Chengguanzhen", "Линься", "CN", "156", "", "15", "", "", "35.60028", "103.20639", "Asia/Shanghai"),("1803334", "Linxi", "", "CN", "156", "", "10", "", "", "39.71183", "118.44954", "Asia/Shanghai"),("1803352", "Linshui", "", "CN", "156", "", "10", "", "", "36.42472", "114.20472", "Asia/Shanghai"),("1803364", "Linqu", "", "CN", "156", "", "25", "", "", "36.51556", "118.53972", "Asia/Shanghai"),("1803365", "Linqiong", "", "CN", "156", "", "32", "", "", "30.41587", "103.46089", "Asia/Shanghai"),("1803367", "Qingnian", "", "CN", "156", "", "25", "", "", "36.84032", "115.71183", "Asia/Shanghai"),("1803374", "Linping", "", "CN", "156", "", "02", "", "", "30.4225", "120.29722", "Asia/Shanghai"),("1803422", "Linhai", "", "CN", "156", "", "02", "", "", "28.84815", "121.12807", "Asia/Shanghai"),("1803551", "Lingcheng", "", "CN", "156", "", "16", "", "", "22.70722", "110.34917", "Asia/Shanghai"),("1803560", "Lincheng", "Линьчэн", "CN", "156", "", "31", "", "", "19.90778", "109.68583", "Asia/Shanghai"),("1803567", "Linfen", "Линьфынь", "CN", "156", "", "24", "", "", "36.08889", "111.51889", "Asia/Shanghai"),("1803616", "Xishan", "Лилин", "CN", "156", "", "11", "", "", "27.66667", "113.5", "Asia/Shanghai"),("1803782", "Lichuan", "Личуань", "CN", "156", "", "12", "", "", "30.3", "108.85", "Asia/Shanghai"),("1803791", "Licheng", "", "CN", "156", "", "30", "", "", "23.29549", "113.82465", "Asia/Shanghai"),("1803834", "Liaocheng", "Ляочэн", "CN", "156", "", "25", "", "", "36.45596", "115.97766", "Asia/Shanghai"),("1803841", "Lianzhou", "", "CN", "156", "", "30", "", "", "24.78186", "112.3712", "Asia/Shanghai"),("1803842", "Lianzhou", "", "CN", "156", "", "16", "", "", "21.66621", "109.20116", "Asia/Shanghai"),("1803886", "Lianran", "", "CN", "156", "", "29", "", "", "24.92271", "102.48496", "Asia/Shanghai"),("1803936", "Wuwei", "", "CN", "156", "", "15", "", "", "37.92672", "102.63202", "Asia/Shanghai"),("1803948", "Liangxiang", "", "CN", "156", "", "22", "", "", "39.73598", "116.13295", "Asia/Shanghai"),("1804120", "Lianjiang", "", "CN", "156", "", "30", "", "", "21.64673", "110.28172", "Asia/Urumqi"),("1804153", "Leshan", "Лэшань", "CN", "156", "", "32", "", "", "29.56227", "103.76386", "Asia/Shanghai"),("1804162", "Lengshuitan", "", "CN", "156", "", "11", "", "", "26.4111", "111.59559", "Asia/Shanghai"),("1804169", "Lengshuijiang", "", "CN", "156", "", "11", "", "", "27.68806", "111.42944", "Asia/Shanghai"),("1804208", "Leiyang", "", "CN", "156", "", "11", "", "", "26.40238", "112.85908", "Asia/Shanghai"),("1804252", "Lecheng", "", "CN", "156", "", "30", "", "", "25.128", "113.35041", "Asia/Shanghai"),("1804386", "Laohekou", "", "CN", "156", "", "12", "", "", "32.38583", "111.66778", "Asia/Shanghai"),("1804430", "Lanzhou", "Ланьчжоу", "CN", "156", "", "15", "", "", "36.05701", "103.83987", "Asia/Shanghai"),("1804442", "Lanxi", "", "CN", "156", "", "02", "", "", "29.21588", "119.47156", "Asia/Shanghai"),("1804451", "Lianyuan", "", "CN", "156", "", "11", "", "", "27.68833", "111.66417", "Asia/Shanghai"),("1804540", "Langfang", "Ланфан", "CN", "156", "", "10", "", "", "39.50972", "116.69472", "Asia/Shanghai"),("1804578", "Weichanglu", "", "CN", "156", "", "25", "", "", "37.18073", "119.94217", "Asia/Shanghai"),("1804586", "Laiyang", "", "CN", "156", "", "25", "", "", "36.97583", "120.71361", "Asia/Shanghai"),("1804591", "Laiwu", "", "CN", "156", "", "25", "", "", "36.19278", "117.65694", "Asia/Shanghai"),("1804609", "Laibin", "", "CN", "156", "", "16", "", "", "23.7", "109.26667", "Asia/Shanghai"),("1804645", "Kunyang", "", "CN", "156", "", "02", "", "", "27.66583", "120.56583", "Asia/Shanghai"),("1804651", "Kunming", "Куньмин", "CN", "156", "", "29", "", "", "25.03889", "102.71833", "Asia/Shanghai"),("1804850", "Kaiyuan", "Кайюань", "CN", "156", "", "29", "", "", "23.69767", "103.30372", "Asia/Shanghai"),("1804874", "Kaihua", "", "CN", "156", "", "29", "", "", "23.3695", "104.27721", "Asia/Shanghai"),("1804879", "Kaifeng", "Кайфэн", "CN", "156", "", "09", "", "", "34.7986", "114.30742", "Asia/Shanghai"),("1804892", "Juye", "", "CN", "156", "", "25", "", "", "35.39472", "116.08833", "Asia/Shanghai"),("1804979", "Juegang", "", "CN", "156", "", "04", "", "", "32.31737", "121.18552", "Asia/Shanghai"),("1805179", "Jiujiang", "Цзюцзян", "CN", "156", "", "03", "", "", "29.70475", "116.00206", "Asia/Shanghai"),("1805267", "Jishui", "", "CN", "156", "", "09", "", "", "33.73333", "115.4", "Asia/Shanghai"),("1805270", "Qianzhou", "", "CN", "156", "", "11", "", "", "28.31925", "109.73346", "Asia/Shanghai"),("1805298", "Jinzhou", "Цзиньчжоу", "CN", "156", "", "19", "", "", "39.1", "121.71667", "Asia/Shanghai"),("1805334", "Jinxiang", "", "CN", "156", "", "02", "", "", "27.43265", "120.60625", "Asia/Shanghai"),("1805379", "Jinshi", "", "CN", "156", "", "11", "", "", "29.60487", "111.87012", "Asia/Shanghai"),("1805408", "Jinsha", "Цзиньша", "CN", "156", "", "04", "", "", "32.08982", "121.07355", "Asia/Shanghai"),("1805482", "Jinjing", "", "CN", "156", "CN", "07", "", "", "24.575", "118.59722", "Asia/Shanghai"),("1805505", "Jinjiang", "", "CN", "156", "", "31", "", "", "19.72878", "110.00851", "Asia/Shanghai"),("1805515", "Jinji", "", "CN", "156", "", "16", "", "", "23.22806", "110.82611", "Asia/Shanghai"),("1805518", "Jining", "Цзинин", "CN", "156", "", "25", "", "", "35.405", "116.58139", "Asia/Shanghai"),("1805528", "Jinhua", "Цзиньхуа", "CN", "156", "", "02", "", "", "29.10678", "119.64421", "Asia/Shanghai"),("1805540", "Jingzhou", "Цзинчжоу", "CN", "156", "", "12", "", "", "30.35028", "112.19028", "Asia/Shanghai"),("1805563", "Tianchang", "", "CN", "156", "", "10", "", "", "37.99806", "114.01556", "Asia/Shanghai"),("1805611", "Jingmen", "Цзинмэнь", "CN", "156", "", "12", "", "", "31.03361", "112.20472", "Asia/Shanghai"),("1805618", "Jingling", "", "CN", "156", "", "12", "", "", "30.65", "113.1", "Asia/Shanghai"),("1805680", "Jingdezhen", "Цзиндэчжэнь", "CN", "156", "", "03", "", "", "29.2947", "117.20789", "Asia/Shanghai"),("1805733", "Jinchang", "Цзиньчан", "CN", "156", "", "15", "1805747", "", "38.50062", "102.19379", "Asia/Shanghai"),("1805741", "Jincheng", "Цзиньчэн", "CN", "156", "", "24", "", "", "35.50222", "112.83278", "Asia/Shanghai"),("1805753", "Jinan", "Цзинань", "CN", "156", "", "25", "", "", "36.66833", "116.99722", "Asia/Shanghai"),("1805757", "Jimo", "", "CN", "156", "", "25", "", "", "36.38972", "120.46222", "Asia/Shanghai"),("1805798", "Jijiang", "", "CN", "156", "", "33", "", "", "29.28993", "106.25001", "Asia/Shanghai"),("1805833", "Jiexiu", "", "CN", "156", "", "24", "", "", "37.02444", "111.9125", "Asia/Shanghai"),("1805844", "Jieshou", "", "CN", "156", "", "01", "1810843", "", "33.26338", "115.36108", "Asia/Shanghai"),("1805857", "Jieshi", "", "CN", "156", "", "30", "", "", "22.81027", "115.83058", "Asia/Shanghai"),("1805884", "Jiehu", "", "CN", "156", "", "25", "", "", "35.54278", "118.455", "Asia/Shanghai"),("1805935", "Jiazi", "", "CN", "156", "", "30", "", "", "22.87932", "116.07318", "Asia/Shanghai"),("1805953", "Jiaxing", "Цзясин", "CN", "156", "", "02", "", "", "30.7522", "120.75", "Asia/Shanghai"),("1805987", "Jiaozuo", "Цзяоцзо", "CN", "156", "", "09", "", "", "35.23972", "113.23306", "Asia/Shanghai"),("1806096", "Jiaozhou", "", "CN", "156", "", "25", "", "", "36.28389", "120.00333", "Asia/Shanghai"),("1806097", "Ningde", "", "CN", "156", "", "07", "", "", "26.66167", "119.52278", "Asia/Shanghai"),("1806167", "Jian’ou", "", "CN", "156", "", "07", "", "", "27.04694", "118.32528", "Asia/Shanghai"),("1806180", "Jianjiang", "", "CN", "156", "CN", "07", "", "", "26.54972", "119.755", "Asia/Shanghai"),("1806218", "Jiangyan", "", "CN", "156", "", "04", "", "", "32.50611", "120.14278", "Asia/Shanghai"),("1806248", "Jianguang", "", "CN", "156", "", "03", "", "", "28.19377", "115.7836", "Asia/Shanghai"),("1806299", "Jiangmen", "Цзянмэнь", "CN", "156", "", "30", "", "", "22.58333", "113.08333", "Asia/Shanghai"),("1806327", "Jiangkou", "", "CN", "156", "", "07", "", "", "25.48694", "119.19834", "Asia/Shanghai"),("1806408", "Yangjiang", "Янцзян", "CN", "156", "", "30", "", "", "21.85563", "111.96272", "Asia/Shanghai"),("1806445", "Ji’an", "Цзиань", "CN", "156", "", "03", "", "", "27.11716", "114.97927", "Asia/Shanghai"),("1806466", "Guangyuan", "", "CN", "156", "", "32", "", "", "32.44201", "105.823", "Asia/Shanghai"),("1806535", "Huzhou", "", "CN", "156", "", "02", "", "", "30.8703", "120.0933", "Asia/Shanghai"),("1806591", "Hutang", "", "CN", "156", "", "04", "", "", "31.53429", "119.49", "Asia/Shanghai"),("1806627", "Huotong", "", "CN", "156", "CN", "07", "", "", "26.84972", "119.41806", "Asia/Shanghai"),("1806651", "Huoqiu Chengguanzhen", "", "CN", "156", "", "01", "", "", "32.35473", "116.2939", "Asia/Shanghai"),("1806696", "Humen", "Хумэнь", "CN", "156", "", "30", "", "", "22.81899", "113.67306", "Asia/Shanghai"),("1806776", "Huizhou", "Хуэйчжоу", "CN", "156", "", "30", "", "", "23.11147", "114.41523", "Asia/Shanghai"),("1806840", "Huilong", "Квидонга", "CN", "156", "", "04", "", "", "31.81111", "121.655", "Asia/Shanghai"),("1806881", "Huicheng", "", "CN", "156", "", "30", "", "", "23.03845", "116.28988", "Asia/Shanghai"),("1806882", "Xinhui", "", "CN", "156", "", "30", "", "", "22.456", "113.0482", "Asia/Shanghai"),("1806960", "Huazhou", "", "CN", "156", "", "30", "", "", "21.63333", "110.58333", "Asia/Urumqi"),("1806988", "Huayin", "", "CN", "156", "", "26", "", "", "34.56528", "110.06639", "Asia/Shanghai"),("1807082", "Huantuo", "", "CN", "156", "", "28", "", "", "39.22634", "117.3239", "Asia/Shanghai"),("1807112", "Huangzhou", "Хуанчжоу", "CN", "156", "", "12", "", "", "30.45", "114.8", "Asia/Shanghai"),("1807143", "Huangyan", "", "CN", "156", "", "02", "", "", "28.6501", "121.26591", "Asia/Shanghai"),("1807234", "Huangshi", "Хуанши", "CN", "156", "", "12", "", "", "30.24706", "115.04814", "Asia/Shanghai"),("1807301", "Dasha", "Даша", "CN", "156", "", "30", "", "", "23.11037", "113.4418", "Asia/Shanghai"),("1807308", "Huangpi", "", "CN", "156", "", "12", "", "", "30.88453", "114.37789", "Asia/Shanghai"),("1807339", "Huangmei", "", "CN", "156", "", "12", "", "", "30.19235", "116.02496", "Asia/Shanghai"),("1807508", "Huanggang", "Хуанган", "CN", "156", "", "30", "", "", "23.67704", "116.99961", "Asia/Shanghai"),("1807544", "Daxing", "Дасин", "CN", "156", "", "22", "", "", "39.74025", "116.32693", "Asia/Shanghai"),("1807553", "Dingcheng", "", "CN", "156", "", "09", "", "", "32.12722", "115.03944", "Asia/Shanghai"),("1807645", "Huaiyuan Chengguanzhen", "", "CN", "156", "", "01", "", "", "32.95893", "117.16566", "Asia/Shanghai"),("1807681", "Huainan", "", "CN", "156", "", "01", "", "", "32.62639", "116.99694", "Asia/Shanghai"),("1807687", "Huaicheng", "", "CN", "156", "", "30", "", "", "23.91952", "112.17629", "Asia/Shanghai"),("1807689", "Huaihua", "Хуайхуа", "CN", "156", "", "11", "1807688", "", "27.56337", "110.00404", "Asia/Shanghai"),("1807695", "Huaidian", "", "CN", "156", "", "09", "", "", "33.43333", "115.03333", "Asia/Shanghai"),("1807700", "Huaibei", "Хуайбэй", "CN", "156", "", "01", "", "", "33.97444", "116.79167", "Asia/Shanghai"),("1808106", "Hongjiang", "", "CN", "156", "", "11", "", "", "27.11", "109.99556", "Asia/Shanghai"),("1808198", "Heze", "Хэцзэ", "CN", "156", "", "25", "", "", "35.23929", "115.47358", "Asia/Shanghai"),("1808212", "Hechuan", "", "CN", "156", "", "33", "", "", "29.99228", "106.26461", "Asia/Shanghai"),("1808316", "Yiyang", "Иян", "CN", "156", "", "11", "", "", "28.58917", "112.32833", "Asia/Shanghai"),("1808336", "Hepo", "Хэпо", "CN", "156", "", "30", "", "", "23.43077", "115.82991", "Asia/Shanghai"),("1808370", "Hengyang", "Хэнъян", "CN", "156", "", "11", "1808369", "", "26.88946", "112.61888", "Asia/Shanghai"),("1808392", "Hengshui", "Хэншуй", "CN", "156", "", "10", "", "", "37.73222", "115.70111", "Asia/Shanghai"),("1808722", "Hefei", "Хэфэй", "CN", "156", "", "01", "", "", "31.86389", "117.28083", "Asia/Shanghai"),("1808744", "Hede", "Хеде", "CN", "156", "", "04", "", "", "33.7722", "120.26176", "Asia/Shanghai"),("1808747", "Hecun", "", "CN", "156", "", "10", "", "", "36.53333", "114.11111", "Asia/Shanghai"),("1808770", "Hebi", "", "CN", "156", "", "09", "", "", "35.89917", "114.1925", "Asia/Shanghai"),("1808857", "Hanzhong", "Ханьчжун", "CN", "156", "", "26", "", "", "33.07507", "107.02214", "Asia/Shanghai"),("1808872", "Chengyang", "Фуаня", "CN", "156", "", "07", "", "", "27.08917", "119.64528", "Asia/Shanghai"),("1808879", "Hanting", "", "CN", "156", "", "25", "", "", "36.77083", "119.21083", "Asia/Shanghai"),("1808899", "Hanjiashu", "", "CN", "156", "CN", "28", "", "", "39.1875", "117.07306", "Asia/Shanghai"),("1808926", "Hangzhou", "Ханчжоу", "CN", "156", "", "02", "", "", "30.29365", "120.16142", "Asia/Shanghai"),("1808931", "Hangu", "Ханга", "CN", "156", "", "28", "", "", "39.24889", "117.78917", "Asia/Shanghai"),("1808963", "Handan", "Ханьдань", "CN", "156", "", "10", "", "", "36.60056", "114.46778", "Asia/Shanghai"),("1808977", "Hanchuan", "", "CN", "156", "", "12", "", "", "30.65", "113.76667", "Asia/Shanghai"),("1808981", "Hancheng", "", "CN", "156", "", "26", "", "", "35.46028", "110.42917", "Asia/Shanghai"),("1809003", "Haizhou", "", "CN", "156", "", "04", "", "", "34.58167", "119.12889", "Asia/Shanghai"),("1809061", "Jiaojiang", "", "CN", "156", "", "02", "", "", "28.68028", "121.44278", "Asia/Shanghai"),("1809062", "Haimen", "", "CN", "156", "", "30", "", "", "23.19346", "116.61219", "Asia/Shanghai"),("1809077", "Haikou", "", "CN", "156", "", "29", "", "", "24.77985", "102.57548", "Asia/Shanghai"),("1809078", "Haikou", "Хайкоу", "CN", "156", "", "31", "", "", "20.04583", "110.34167", "Asia/Shanghai"),("1809159", "Guye", "", "CN", "156", "", "10", "", "", "39.73054", "118.44085", "Asia/Shanghai"),("1809263", "Guozhen", "", "CN", "156", "", "26", "", "", "34.36591", "107.35904", "Asia/Shanghai"),("1809412", "Guli", "Гули", "CN", "156", "", "02", "", "", "28.88162", "120.03308", "Asia/Shanghai"),("1809461", "Guiyang", "Гуйян", "CN", "156", "", "18", "1809458", "", "26.58333", "106.71667", "Asia/Shanghai"),("1809483", "Guiren", "", "CN", "156", "", "04", "", "", "33.66972", "118.18889", "Asia/Shanghai"),("1809486", "Guiping", "", "CN", "156", "", "16", "", "", "23.39336", "110.07437", "Asia/Shanghai"),("1809498", "Guilin", "Гуйлинь", "CN", "156", "", "16", "", "", "25.28194", "110.28639", "Asia/Shanghai"),("1809532", "Guigang", "", "CN", "156", "", "16", "", "", "23.09639", "109.60917", "Asia/Shanghai"),("1809548", "Gufeng", "", "CN", "156", "", "07", "", "", "26.90833", "118.98194", "Asia/Shanghai"),("1809610", "Gucheng Chengguanzhen", "", "CN", "156", "", "12", "", "", "32.26604", "111.63476", "Asia/Shanghai"),("1809747", "Guantou", "", "CN", "156", "", "07", "", "", "26.13515", "119.55718", "Asia/Shanghai"),("1809858", "Guangzhou", "Гуанчжоу", "CN", "156", "", "30", "", "", "23.11667", "113.25", "Asia/Shanghai"),("1809879", "Guangshui", "", "CN", "156", "", "12", "", "", "31.6199", "113.9978", "Asia/Shanghai"),("1810240", "Gejiu", "", "CN", "156", "", "29", "", "", "23.36085", "103.15372", "Asia/Shanghai"),("1810295", "Gaozhou", "", "CN", "156", "", "30", "", "", "21.93924", "110.84607", "Asia/Urumqi"),("1810309", "Gaoyou", "", "CN", "156", "", "04", "", "", "32.78933", "119.44182", "Asia/Shanghai"),("1810437", "Gaoping", "", "CN", "156", "", "32", "", "", "30.77576", "106.10294", "Asia/Shanghai"),("1810458", "Gaomi", "", "CN", "156", "", "25", "", "", "36.38333", "119.75278", "Asia/Shanghai"),("1810553", "Gaogou", "", "CN", "156", "", "04", "", "", "34.0175", "119.18861", "Asia/Shanghai"),("1810677", "Ganshui", "", "CN", "156", "", "33", "", "", "28.74222", "106.71111", "Asia/Shanghai"),("1810821", "Fuzhou", "Фучжоу", "CN", "156", "", "07", "", "", "26.06139", "119.30611", "Asia/Shanghai"),("1810845", "Fuyang", "Фуян", "CN", "156", "", "01", "", "", "32.9", "115.81667", "Asia/Shanghai"),("1810846", "Fuyang", "Фуянь", "CN", "156", "", "02", "", "", "30.05333", "119.95194", "Asia/Shanghai"),("1810920", "Qingyang", "", "CN", "156", "", "25", "", "", "37.49583", "121.25806", "Asia/Shanghai"),("1810979", "Fuling", "Фулин", "CN", "156", "", "33", "", "", "29.706", "107.39575", "Asia/Shanghai"),("1811103", "Foshan", "Фошань", "CN", "156", "", "30", "", "", "23.02677", "113.13148", "Asia/Shanghai"),("1811114", "Fenyi", "", "CN", "156", "", "03", "", "", "27.81117", "114.66805", "Asia/Shanghai"),("1811169", "Fengzhou", "", "CN", "156", "", "07", "", "", "24.95762", "118.53365", "Asia/Shanghai"),("1811200", "Fengxian", "", "CN", "156", "", "04", "", "", "34.70388", "116.58717", "Asia/Shanghai"),("1811224", "Fengtai", "", "CN", "156", "CN", "28", "", "", "39.55806", "117.74917", "Asia/Shanghai"),("1811260", "Fengrun", "", "CN", "156", "", "10", "", "", "39.83333", "118.11667", "Asia/Shanghai"),("1811305", "Fengkou", "", "CN", "156", "", "12", "", "", "30.08268", "113.33346", "Asia/Shanghai"),("1811440", "Feicheng", "", "CN", "156", "", "25", "", "", "35.26056", "117.9675", "Asia/Shanghai"),("1811496", "Fanzhuang", "", "CN", "156", "", "28", "", "", "39.19361", "117.335", "Asia/Shanghai"),("1811542", "Fangshan", "", "CN", "156", "", "22", "", "", "39.68699", "115.99658", "Asia/Shanghai"),("1811619", "Ezhou", "", "CN", "156", "", "12", "", "", "30.4", "114.83333", "Asia/Shanghai"),("1811720", "Enshi", "Эньши", "CN", "156", "", "12", "1811624", "", "30.3", "109.48333", "Asia/Shanghai"),("1811729", "Encheng", "Эньпин", "CN", "156", "", "30", "", "", "22.18659", "112.30424", "Asia/Shanghai"),("1811764", "Duyun", "Дуюн", "CN", "156", "", "18", "1798280", "1811763", "26.26667", "107.51667", "Asia/Shanghai"),("1811829", "Duobao", "", "CN", "156", "", "12", "", "", "30.67", "112.68952", "Asia/Shanghai"),("1811929", "Ducheng", "", "CN", "156", "", "30", "", "", "23.24212", "111.5284", "Asia/Shanghai"),("1812057", "Xinyi", "", "CN", "156", "", "30", "", "", "22.37303", "110.94746", "Asia/Urumqi"),("1812091", "Dongyuan", "", "CN", "156", "", "07", "", "", "24.91738", "118.75236", "Asia/Shanghai"),("1812101", "Shengli", "Дуньин", "CN", "156", "", "25", "", "", "37.46271", "118.49165", "Asia/Shanghai"),("1812168", "Dongxi", "", "CN", "156", "CN", "33", "", "", "28.76139", "106.66111", "Asia/Shanghai"),("1812228", "Dongtai", "", "CN", "156", "", "04", "", "", "32.85231", "120.30947", "Asia/Shanghai"),("1812256", "Dongsheng", "", "CN", "156", "", "20", "", "", "39.81609", "109.97763", "Asia/Shanghai"),("1812427", "Dongkan", "", "CN", "156", "", "04", "", "", "33.99972", "119.83083", "Asia/Shanghai"),("1812521", "Donghai", "", "CN", "156", "", "30", "", "", "22.94593", "115.64204", "Asia/Shanghai"),("1812545", "Dongguan", "Дунгуань", "CN", "156", "", "30", "", "", "23.01797", "113.74866", "Asia/Shanghai"),("1812597", "Dongdu", "", "CN", "156", "", "25", "", "", "35.85", "117.7", "Asia/Shanghai"),("1812600", "Dongditou", "", "CN", "156", "", "28", "", "", "39.26641", "117.37273", "Asia/Shanghai"),("1812613", "Dongdai", "", "CN", "156", "", "07", "", "", "26.24366", "119.61566", "Asia/Shanghai"),("1812621", "Dongcun", "", "CN", "156", "", "25", "", "", "36.77667", "121.15972", "Asia/Shanghai"),("1812728", "Dingzhou", "", "CN", "156", "", "10", "", "", "38.51306", "114.99556", "Asia/Shanghai"),("1812754", "Dingtao", "", "CN", "156", "", "25", "", "", "35.07436", "115.56582", "Asia/Shanghai"),("1812805", "Dinghai", "", "CN", "156", "", "07", "", "", "26.28022", "119.78964", "Asia/Shanghai"),("1812955", "Dezhou", "Дэчжоу", "CN", "156", "", "25", "", "", "37.45127", "116.31046", "Asia/Shanghai"),("1812961", "Deyang", "Дэян", "CN", "156", "", "32", "", "", "31.13019", "104.38198", "Asia/Shanghai"),("1812981", "Deqing", "", "CN", "156", "", "02", "", "", "30.54485", "119.9599", "Asia/Shanghai"),("1812988", "Dengzhou", "Пэнлай", "CN", "156", "", "25", "", "", "37.80822", "120.75908", "Asia/Shanghai"),("1812990", "Huazhou", "", "CN", "156", "", "09", "", "", "32.68222", "112.08194", "Asia/Shanghai"),("1813016", "Songyang", "", "CN", "156", "", "09", "", "", "34.45528", "113.02806", "Asia/Shanghai"),("1813046", "Dazuo", "", "CN", "156", "", "07", "", "", "24.88616", "118.96433", "Asia/Shanghai"),("1813088", "Dazhong", "", "CN", "156", "", "04", "", "", "33.19973", "120.4578", "Asia/Shanghai"),("1813171", "Zhangjiajie", "Чжанцзяцзе", "CN", "156", "", "11", "", "", "29.12944", "110.47833", "Asia/Shanghai"),("1813206", "Daye", "", "CN", "156", "", "12", "", "", "30.08333", "114.95", "Asia/Shanghai"),("1813253", "Lijiang", "Лицзян", "CN", "156", "", "29", "", "", "26.86879", "100.22072", "Asia/Shanghai"),("1813325", "Dazhou", "", "CN", "156", "", "32", "1813324", "1813320", "31.21592", "107.50092", "Asia/Shanghai"),("1813344", "Dawukou", "", "CN", "156", "", "21", "", "", "39.04194", "106.39583", "Asia/Shanghai"),("1813383", "Dawangtai", "", "CN", "156", "", "28", "", "", "39.27504", "117.48502", "Asia/Shanghai"),("1813451", "Datong", "Датун", "CN", "156", "", "01", "", "", "32.62082", "117.06319", "Asia/Shanghai"),("1813658", "Fenghua", "", "CN", "156", "", "02", "", "", "29.65628", "121.4064", "Asia/Shanghai"),("1813775", "Daokou", "", "CN", "156", "", "09", "", "", "35.56389", "114.50583", "Asia/Shanghai"),("1813812", "Danshui", "Даньшуем", "CN", "156", "", "30", "", "", "22.7984", "114.46716", "Asia/Shanghai"),("1813828", "Danjiangkou", "Даньцзянкоу", "CN", "156", "", "12", "", "", "32.54278", "111.50861", "Asia/Shanghai"),("1813851", "Gushu", "", "CN", "156", "", "01", "", "", "31.56055", "118.48147", "Asia/Shanghai"),("1813892", "Xincheng", "", "CN", "156", "", "09", "", "", "33.63333", "115.18333", "Asia/Shanghai"),("1814082", "Daliang", "Далян", "CN", "156", "", "30", "", "", "22.84067", "113.2503", "Asia/Shanghai"),("1814087", "Dalian", "Далянь", "CN", "156", "", "19", "1814068", "", "38.91222", "121.60222", "Asia/Shanghai"),("1814093", "Dali", "Дали", "CN", "156", "", "29", "", "", "25.58474", "100.21229", "Asia/Shanghai"),("1814123", "Dakoutun", "", "CN", "156", "CN", "28", "", "", "39.58333", "117.22889", "Asia/Shanghai"),("1814577", "Dabizhuang", "", "CN", "156", "", "28", "", "", "39.19306", "117.25583", "Asia/Shanghai"),("1814757", "Chuzhou", "Чучжоу", "CN", "156", "", "01", "", "", "32.32194", "118.29778", "Asia/Shanghai"),("1814786", "Yangchun", "", "CN", "156", "", "30", "", "", "22.16667", "111.78333", "Asia/Shanghai"),("1814870", "Yiwu", "", "CN", "156", "", "02", "", "", "29.31506", "120.07676", "Asia/Shanghai"),("1814906", "Chongqing", "Чунцин", "CN", "156", "", "33", "", "", "29.56278", "106.55278", "Asia/Shanghai"),("1814919", "Chonglong", "", "CN", "156", "", "32", "", "", "29.78062", "104.85224", "Asia/Shanghai"),("1814934", "Chizhou", "", "CN", "156", "", "01", "", "", "30.66134", "117.47783", "Asia/Shanghai"),("1814999", "Chitu", "", "CN", "156", "CN", "28", "", "", "39.20333", "117.40278", "Asia/Shanghai"),("1815059", "Chenzhou", "Чэньчжоу", "CN", "156", "", "11", "1815056", "", "25.8", "113.03333", "Asia/Shanghai"),("1815184", "Chengyang", "", "CN", "156", "", "25", "", "", "35.57944", "118.83278", "Asia/Shanghai"),("1815251", "Jiangyin", "", "CN", "156", "", "04", "", "", "31.91102", "120.26302", "Asia/Shanghai"),("1815286", "Chengdu", "Чэнду", "CN", "156", "", "32", "", "", "30.66667", "104.06667", "Asia/Shanghai"),("1815302", "Chenghua", "", "CN", "156", "", "30", "", "", "23.46132", "116.77007", "Asia/Shanghai"),("1815395", "Chaozhou", "Чаочжоу", "CN", "156", "", "30", "", "", "23.65396", "116.62262", "Asia/Shanghai"),("1815427", "Chaohu", "", "CN", "156", "", "01", "", "", "31.6", "117.86667", "Asia/Shanghai"),("1815456", "Changzhou", "Чанчжоу", "CN", "156", "", "04", "", "", "31.77359", "119.95401", "Asia/Shanghai"),("1815463", "Changzhi", "Чанчжи", "CN", "156", "", "24", "", "", "35.20889", "111.73861", "Asia/Shanghai"),("1815577", "Changsha", "Чанша", "CN", "156", "", "11", "1815551", "", "28.19874", "112.97087", "Asia/Shanghai"),("1815585", "Changqing", "Чанцин", "CN", "156", "", "25", "", "", "36.5575", "116.72722", "Asia/Shanghai"),("1815656", "Changli", "Чанли", "CN", "156", "", "10", "", "", "39.70417", "119.15056", "Asia/Shanghai"),("1815667", "Changleng", "", "CN", "156", "", "03", "", "", "28.7", "115.81667", "Asia/Shanghai"),("1816026", "Caohe", "", "CN", "156", "", "12", "", "", "30.2297", "115.43346", "Asia/Shanghai"),("1816028", "Weining", "Вэйнин", "CN", "156", "", "18", "", "", "26.85", "104.23333", "Asia/Shanghai"),("1816080", "Cangzhou", "Цанчжоу", "CN", "156", "", "10", "", "", "38.31667", "116.86667", "Asia/Shanghai"),("1816176", "Caidian", "", "CN", "156", "", "12", "", "", "30.58333", "114.03333", "Asia/Shanghai"),("1816221", "Buhe", "Бухэ", "CN", "156", "", "12", "", "", "30.28757", "112.22979", "Asia/Shanghai"),("1816234", "Bozhou", "Бочжоу", "CN", "156", "", "01", "11287254", "", "33.87722", "115.77028", "Asia/Shanghai"),("1816256", "Botou", "Бота", "CN", "156", "", "10", "", "", "38.06667", "116.5666", "Asia/Shanghai"),("1816265", "Boshan", "", "CN", "156", "", "25", "", "", "36.48333", "117.83333", "Asia/Shanghai"),("1816269", "Baise City", "Бозе", "CN", "156", "", "16", "", "", "23.89972", "106.61333", "Asia/Shanghai"),("1816336", "Binzhou", "", "CN", "156", "", "25", "", "", "37.36667", "118.01667", "Asia/Shanghai"),("1816338", "Luxu", "", "CN", "156", "", "16", "", "", "23.22378", "108.80217", "Asia/Shanghai"),("1816373", "Bijie", "Бицзе", "CN", "156", "", "18", "1816372", "", "27.30193", "105.28627", "Asia/Shanghai"),("1816401", "Biaokou", "", "CN", "156", "", "28", "", "", "39.32527", "117.55378", "Asia/Shanghai"),("1816406", "Bianzhuang", "", "CN", "156", "", "25", "", "", "34.84861", "118.04472", "Asia/Shanghai"),("1816440", "Bengbu", "Бэнбу", "CN", "156", "", "01", "", "", "32.94083", "117.36083", "Asia/Shanghai"),("1816670", "Beijing", "Пекин", "CN", "156", "", "22", "", "", "39.9075", "116.39723", "Asia/Shanghai"),("1816693", "Beihuaidian", "", "CN", "156", "", "28", "", "", "39.25854", "117.56378", "Asia/Shanghai"),("1816705", "Beihai", "Бэйхай", "CN", "156", "", "16", "", "", "21.48333", "109.1", "Asia/Shanghai"),("1816751", "Beidao", "", "CN", "156", "", "15", "", "", "34.56861", "105.89333", "Asia/Shanghai"),("1816753", "Beidaihehaibin", "Бейдайхэ", "CN", "156", "CN", "10", "", "", "39.82222", "119.51806", "Asia/Shanghai"),("1816781", "Beicang", "", "CN", "156", "", "28", "", "", "39.2357", "117.12262", "Asia/Shanghai"),("1816790", "Beibei", "Бэй", "CN", "156", "", "33", "", "", "29.82739", "106.43645", "Asia/Shanghai"),("1816890", "Baoying", "", "CN", "156", "", "04", "", "", "33.22917", "119.30917", "Asia/Shanghai"),("1816924", "Langzhong", "", "CN", "156", "", "32", "", "", "31.55037", "105.99381", "Asia/Shanghai"),("1816971", "Baoding", "Баодин", "CN", "156", "", "10", "", "", "38.85111", "115.49028", "Asia/Shanghai"),("1817090", "Bangjun", "", "CN", "156", "CN", "28", "", "", "39.99111", "117.26278", "Asia/Shanghai"),("1817240", "Baiyin", "", "CN", "156", "", "15", "", "", "36.54696", "104.17023", "Asia/Shanghai"),("1817701", "Baihe", "", "CN", "156", "", "16", "", "", "22.1343", "107.232", "Asia/Shanghai"),("1817720", "Shangyu", "", "CN", "156", "CN", "02", "", "", "30.01556", "120.87111", "Asia/Shanghai"),("1817858", "Babu", "Бабу", "CN", "156", "", "16", "", "", "24.41667", "111.51667", "Asia/Shanghai"),("1817952", "Anxiang", "", "CN", "156", "", "11", "", "", "29.4", "112.15", "Asia/Shanghai"),("1817968", "Anshun", "Аньшунь", "CN", "156", "", "18", "", "", "26.25", "105.93333", "Asia/Shanghai"),("1817990", "Anqiu", "", "CN", "156", "", "25", "", "", "36.43417", "119.1925", "Asia/Shanghai"),("1817993", "Anqing", "Аньцин", "CN", "156", "", "01", "", "", "30.51365", "117.04723", "Asia/Shanghai"),("1818004", "Mabai", "", "CN", "156", "", "29", "", "", "23.01279", "104.45081", "Asia/Shanghai"),("1818016", "Anlu", "", "CN", "156", "", "12", "", "", "31.2575", "113.67833", "Asia/Shanghai"),("1818051", "Anjiang", "", "CN", "156", "", "11", "", "", "27.31944", "110.10306", "Asia/Shanghai"),("1818116", "Anbu", "", "CN", "156", "", "30", "", "", "23.44895", "116.68092", "Asia/Shanghai"),("1885823", "Jiangyou", "", "CN", "156", "", "32", "", "", "31.76667", "104.71667", "Asia/Shanghai"),("1886760", "Suzhou", "Сучжоу", "CN", "156", "", "04", "", "", "31.30408", "120.59538", "Asia/Shanghai"),("1886762", "Zhoushan", "Чжоушань", "CN", "156", "", "02", "", "", "29.98869", "122.20488", "Asia/Shanghai"),("1898359", "Mudu", "Муду", "CN", "156", "", "04", "", "", "31.25597", "120.51857", "Asia/Shanghai"),("1898494", "Songling", "Сунлин", "CN", "156", "", "04", "", "", "31.1933", "120.71758", "Asia/Shanghai"),("1915223", "Zhongshan", "", "CN", "156", "", "30", "", "", "21.31992", "110.5723", "Asia/Urumqi"),("1919014", "Lianghu", "", "CN", "156", "", "02", "", "", "29.99152", "120.89845", "Asia/Shanghai"),("1920772", "Zhoucheng", "", "CN", "156", "", "25", "", "", "35.91222", "116.31167", "Asia/Shanghai"),("1921372", "Dalianwan", "", "CN", "156", "", "19", "", "", "39.02861", "121.695", "Asia/Shanghai"),("1927639", "Yueyang", "Юэян", "CN", "156", "", "11", "", "", "29.37455", "113.09481", "Asia/Shanghai"),("1929434", "Bojia", "", "CN", "156", "", "11", "", "", "26.46722", "111.96806", "Asia/Shanghai"),("1941693", "Xinzhuang", "", "CN", "156", "", "28", "", "", "39.0249", "117.34377", "Asia/Shanghai"),("1941783", "Rong’an", "", "CN", "156", "", "07", "", "", "26.12472", "119.12139", "Asia/Shanghai"),("1941784", "Shangjie", "", "CN", "156", "", "07", "", "", "26.08679", "119.18494", "Asia/Shanghai"),("1941833", "Houyu", "", "CN", "156", "", "07", "", "", "26.05958", "119.53502", "Asia/Shanghai"),("2033128", "Zhenlai", "", "CN", "156", "", "05", "", "", "45.84955", "123.2973", "Asia/Shanghai"),("2033135", "Zhengjiatun", "", "CN", "156", "", "05", "", "", "43.50639", "123.50639", "Asia/Shanghai"),("2033147", "Zhaozhou", "Чжаочжоу", "CN", "156", "", "08", "", "", "45.68333", "125.31667", "Asia/Shanghai"),("2033149", "Zhaoyuan", "", "CN", "156", "", "08", "", "", "45.5", "125.13333", "Asia/Shanghai"),("2033168", "Zhaodong", "", "CN", "156", "", "08", "", "", "46.06771", "125.98263", "Asia/Shanghai"),("2033196", "Zhangjiakou", "Чжанцзякоу", "CN", "156", "", "10", "", "", "40.81", "114.87944", "Asia/Shanghai"),("2033225", "Zhalantun", "Чжаланьтунь", "CN", "156", "", "20", "", "", "48.00945", "122.73651", "Asia/Shanghai"),("2033242", "Yushu", "Юйшу", "CN", "156", "", "05", "", "", "44.8", "126.53333", "Asia/Shanghai"),("2033301", "Youhao", "", "CN", "156", "", "08", "", "", "47.85306", "128.83565", "Asia/Shanghai"),("2033370", "Yingkou", "Инкоу", "CN", "156", "", "19", "2033369", "", "40.66482", "122.22833", "Asia/Shanghai"),("2033403", "Yilan", "", "CN", "156", "", "08", "", "", "46.31618", "129.55455", "Asia/Shanghai"),("2033413", "Yichun", "Ичунь", "CN", "156", "", "08", "", "", "47.72143", "128.87529", "Asia/Shanghai"),("2033423", "Yebaishou", "", "CN", "156", "", "19", "", "", "41.3975", "119.64083", "Asia/Shanghai"),("2033449", "Yantongshan", "", "CN", "156", "", "05", "", "", "43.29194", "126.00944", "Asia/Shanghai"),("2033467", "Yanji", "Яньцзи", "CN", "156", "", "05", "", "", "42.9075", "129.50778", "Asia/Shanghai"),("2033536", "Yakeshi", "Якэши", "CN", "156", "", "20", "", "", "49.28333", "120.73333", "Asia/Shanghai"),("2033574", "Zhangjiakou Shi Xuanhua Qu", "", "CN", "156", "", "10", "", "", "40.61028", "115.04472", "Asia/Shanghai"),("2033602", "Xiuyan", "", "CN", "156", "", "19", "", "", "40.29278", "123.27444", "Asia/Shanghai"),("2033667", "Xinqing", "", "CN", "156", "", "08", "", "", "48.28701", "129.52337", "Asia/Shanghai"),("2033675", "Xinmin", "Синьминь", "CN", "156", "", "19", "", "", "41.99083", "122.82528", "Asia/Shanghai"),("2033739", "Xinglongshan", "", "CN", "156", "", "05", "", "", "43.95611", "125.46611", "Asia/Shanghai"),("2033766", "Xingcheng", "Синчэн", "CN", "156", "", "19", "", "", "40.61667", "120.71667", "Asia/Shanghai"),("2033824", "Xilin Hot", "", "CN", "156", "", "20", "", "", "43.96667", "116.03333", "Asia/Shanghai"),("2033866", "Xifeng", "", "CN", "156", "", "19", "", "", "42.73722", "124.72222", "Asia/Shanghai"),("2033934", "Xiaoshi", "", "CN", "156", "", "19", "", "", "41.29711", "124.12092", "Asia/Shanghai"),("2034141", "Wuchang", "Учан", "CN", "156", "", "08", "", "", "44.91428", "127.15001", "Asia/Shanghai"),("2034221", "Wangqing", "Ванцине", "CN", "156", "", "05", "", "", "43.32179", "129.76342", "Asia/Shanghai"),("2034226", "Hepingjie", "", "CN", "156", "", "05", "", "", "42.05972", "126.91583", "Asia/Shanghai"),("2034228", "Wangkui", "", "CN", "156", "", "08", "", "", "46.83283", "126.47768", "Asia/Shanghai"),("2034312", "Ulanhot", "", "CN", "156", "", "20", "", "", "46.08333", "122.08333", "Asia/Shanghai"),("2034340", "Tumen", "Тюменский", "CN", "156", "", "05", "", "", "42.96611", "129.8425", "Asia/Shanghai"),("2034400", "Tongliao", "", "CN", "156", "", "20", "", "", "43.6125", "122.26528", "Asia/Shanghai"),("2034439", "Tieling", "Телин", "CN", "156", "", "19", "2034437", "", "42.29306", "123.84139", "Asia/Shanghai"),("2034440", "Tieli", "", "CN", "156", "", "08", "", "", "46.98043", "128.04497", "Asia/Shanghai"),("2034497", "Guangming", "Таонань", "CN", "156", "", "05", "", "", "45.33333", "122.78333", "Asia/Shanghai"),("2034599", "Tailai", "", "CN", "156", "", "08", "", "", "46.38909", "123.41371", "Asia/Shanghai"),("2034600", "Taikang", "", "CN", "156", "", "08", "", "", "46.86135", "124.442", "Asia/Shanghai"),("2034615", "Tahe", "", "CN", "156", "", "08", "", "", "52.33333", "124.73333", "Asia/Shanghai"),("2034638", "Sujiatun", "Суцзятунь", "CN", "156", "", "19", "", "", "41.65917", "123.33917", "Asia/Shanghai"),("2034651", "Suileng", "", "CN", "156", "", "08", "", "", "47.24805", "127.09535", "Asia/Shanghai"),("2034655", "Suihua", "", "CN", "156", "", "08", "", "", "46.63954", "126.99508", "Asia/Shanghai"),("2034657", "Suifenhe", "", "CN", "156", "", "08", "", "", "44.39982", "131.14775", "Asia/Shanghai"),("2034691", "Songjianghe", "", "CN", "156", "", "05", "", "", "42.1859", "127.47895", "Asia/Shanghai"),("2034714", "Siping", "", "CN", "156", "", "05", "", "", "43.16143", "124.37785", "Asia/Shanghai"),("2034754", "Shunyi", "Шуньи", "CN", "156", "", "22", "", "", "40.12175", "116.64783", "Asia/Shanghai"),("2034761", "Shulan", "Шулань", "CN", "156", "", "05", "", "", "44.41667", "126.95", "Asia/Shanghai"),("2034786", "Shuangyashan", "", "CN", "156", "CN", "08", "", "", "46.63611", "131.15389", "Asia/Shanghai"),("2034791", "Shuangyang", "", "CN", "156", "", "05", "", "", "43.52417", "125.67361", "Asia/Shanghai"),("2034834", "Shuangcheng", "", "CN", "156", "", "08", "", "", "45.35", "126.28333", "Asia/Shanghai"),("2034918", "Shiguai", "", "CN", "156", "", "20", "", "", "40.70583", "110.28556", "Asia/Shanghai"),("2034937", "Shenyang", "Шэньян", "CN", "156", "", "19", "2034935", "", "41.79222", "123.43278", "Asia/Shanghai"),("2034995", "Shanhetun", "", "CN", "156", "", "08", "", "", "44.7", "127.2", "Asia/Shanghai"),("2034996", "Shanhaiguan", "", "CN", "156", "", "10", "", "", "40.0025", "119.74889", "Asia/Shanghai"),("2035002", "Shangzhi", "", "CN", "156", "", "08", "", "", "45.21406", "127.97426", "Asia/Shanghai"),("2035182", "Sanchazi", "", "CN", "156", "", "05", "", "", "42.08167", "126.60028", "Asia/Shanghai"),("2035196", "Salaqi", "", "CN", "156", "", "20", "", "", "40.54139", "110.51083", "Asia/Shanghai"),("2035225", "Fendou", "", "CN", "156", "", "08", "", "", "46.64142", "124.86283", "Asia/Shanghai"),("2035261", "Taihe", "", "CN", "156", "", "08", "", "", "45.76195", "130.85131", "Asia/Shanghai"),("2035265", "Qiqihar", "Цицикар", "CN", "156", "", "08", "", "", "47.34088", "123.96045", "Asia/Shanghai"),("2035325", "Qinggang", "", "CN", "156", "", "08", "", "", "46.68469", "126.10595", "Asia/Shanghai"),("2035399", "Songyuan", "", "CN", "156", "", "05", "6587798", "6587792", "45.12902", "124.82769", "Asia/Shanghai"),("2035453", "Pingzhuang", "", "CN", "156", "", "20", "", "", "42.03722", "119.28889", "Asia/Shanghai"),("2035511", "Panshi", "Паньши", "CN", "156", "", "05", "", "", "42.94222", "126.05611", "Asia/Shanghai"),("2035513", "Panshan", "", "CN", "156", "", "19", "", "", "41.18806", "122.04944", "Asia/Shanghai"),("2035593", "Nianzishan", "", "CN", "156", "", "08", "", "", "47.51667", "122.88333", "Asia/Shanghai"),("2035601", "Nenjiang", "", "CN", "156", "", "08", "", "", "49.17414", "125.21774", "Asia/Shanghai"),("2035610", "Nehe", "Нэхэ", "CN", "156", "", "08", "", "", "48.48333", "124.83333", "Asia/Shanghai"),("2035635", "Nantai", "", "CN", "156", "", "19", "", "", "40.9241", "122.80437", "Asia/Shanghai"),("2035644", "Nanpiao", "", "CN", "156", "", "19", "", "", "41.09822", "120.74792", "Asia/Shanghai"),("2035669", "Lianhe", "", "CN", "156", "", "08", "", "", "47.13333", "129.27426", "Asia/Shanghai"),("2035707", "Mujiayingzi", "", "CN", "156", "", "20", "", "", "42.11667", "118.78333", "Asia/Shanghai"),("2035715", "Mudanjiang", "Муданьцзян", "CN", "156", "", "08", "", "", "44.58333", "129.6", "Asia/Shanghai"),("2035746", "Mishan", "Мишань", "CN", "156", "", "08", "", "", "45.55", "131.88333", "Asia/Shanghai"),("2035754", "Mingyue", "", "CN", "156", "", "05", "", "", "43.10694", "128.92167", "Asia/Shanghai"),("2035758", "Mingshui", "", "CN", "156", "", "08", "", "", "47.1815", "125.90027", "Asia/Shanghai"),("2035801", "Meihekou", "", "CN", "156", "", "05", "", "", "42.52722", "125.67528", "Asia/Shanghai"),("2035836", "Manzhouli", "Маньчжурия", "CN", "156", "", "20", "", "", "49.6", "117.43333", "Asia/Shanghai"),("2035966", "Longjing", "", "CN", "156", "", "05", "", "", "42.77139", "129.42333", "Asia/Shanghai"),("2035970", "Longjiang", "Лонцзян", "CN", "156", "", "08", "", "", "47.33072", "123.17816", "Asia/Shanghai"),("2035980", "Longfeng", "", "CN", "156", "", "08", "", "", "46.53168", "125.1038", "Asia/Shanghai"),("2036033", "Liuhe", "Люхэ", "CN", "156", "", "05", "", "", "42.24007", "125.71717", "Asia/Shanghai"),("2036055", "Lishu", "Лишать", "CN", "156", "", "05", "", "", "43.30472", "124.32778", "Asia/Shanghai"),("2036066", "Linkou", "", "CN", "156", "", "08", "", "", "45.28606", "130.26151", "Asia/Shanghai"),("2036069", "Linjiang", "Линьцзяне", "CN", "156", "", "05", "", "", "41.80694", "126.90778", "Asia/Shanghai"),("2036075", "Lingyuan", "", "CN", "156", "", "19", "", "", "41.24", "119.40111", "Asia/Shanghai"),("2036081", "Lingdong", "", "CN", "156", "", "08", "", "", "46.56694", "131.14528", "Asia/Shanghai"),("2036106", "Liaozhong", "", "CN", "156", "", "19", "", "", "41.50611", "122.72417", "Asia/Shanghai"),("2036109", "Liaoyuan", "", "CN", "156", "", "05", "", "", "42.90361", "125.13583", "Asia/Shanghai"),("2036113", "Liaoyang", "Ляоян", "CN", "156", "", "19", "", "", "41.27194", "123.17306", "Asia/Shanghai"),("2036226", "Lanxi", "", "CN", "156", "", "08", "", "", "46.25785", "126.28269", "Asia/Shanghai"),("2036237", "Langxiang", "", "CN", "156", "", "08", "", "", "46.94985", "128.86849", "Asia/Shanghai"),("2036241", "Langtou", "", "CN", "156", "", "19", "", "", "40.02611", "124.32861", "Asia/Shanghai"),("2036283", "Kuandian", "", "CN", "156", "", "19", "", "", "40.72861", "124.78472", "Asia/Shanghai"),("2036337", "Kaiyuan", "Кайюань", "CN", "156", "", "19", "", "", "42.53306", "124.04028", "Asia/Shanghai"),("2036338", "Kaitong", "", "CN", "156", "", "05", "", "", "44.81351", "123.15", "Asia/Shanghai"),("2036389", "Jixi", "Цзиси", "CN", "156", "", "08", "", "", "45.30109", "130.95718", "Asia/Shanghai"),("2036401", "Jiutai", "", "CN", "156", "", "05", "", "", "44.1525", "125.83278", "Asia/Shanghai"),("2036403", "Jiupu", "", "CN", "156", "", "19", "2038630", "", "41.06667", "122.95", "Asia/Shanghai"),("2036418", "Jishu", "", "CN", "156", "", "05", "", "", "44.31667", "126.8", "Asia/Shanghai"),("2036427", "Jinzhou", "Цзиньчжоу", "CN", "156", "", "19", "", "", "41.10778", "121.14167", "Asia/Shanghai"),("2036434", "Lianshan", "", "CN", "156", "", "19", "", "", "40.76432", "120.85327", "Asia/Shanghai"),("2036458", "Jining", "Цзинин", "CN", "156", "", "20", "", "", "41.0275", "113.10583", "Asia/Shanghai"),("2036502", "Jilin", "Цзилинь", "CN", "156", "", "05", "", "", "43.85083", "126.56028", "Asia/Shanghai"),("2036519", "Jidong", "", "CN", "156", "", "08", "", "", "45.21667", "131.08333", "Asia/Shanghai"),("2036536", "Minzhu", "Цзяохэ", "CN", "156", "", "05", "", "", "43.72145", "127.33401", "Asia/Shanghai"),("2036581", "Jiamusi", "Цзямусы", "CN", "156", "", "08", "", "", "46.79927", "130.31633", "Asia/Shanghai"),("2036595", "Jalai Nur", "Чжалайнор", "CN", "156", "", "20", "", "", "49.45", "117.7", "Asia/Shanghai"),("2036597", "Jagdaqi", "", "CN", "156", "", "20", "", "", "50.41667", "124.11667", "Asia/Shanghai"),("2036619", "Hushitai", "", "CN", "156", "", "19", "", "", "41.93222", "123.51139", "Asia/Shanghai"),("2036653", "Hunchun", "Хуньчунь", "CN", "156", "", "05", "", "", "42.8675", "130.35806", "Asia/Shanghai"),("2036670", "Hulan Ergi", "", "CN", "156", "", "08", "", "", "47.20417", "123.63333", "Asia/Shanghai"),("2036671", "Hulan", "Хулан", "CN", "156", "", "08", "", "", "45.98333", "126.6", "Asia/Shanghai"),("2036685", "Huinan", "", "CN", "156", "", "05", "", "", "42.6225", "126.26139", "Asia/Shanghai"),("2036713", "Huanren", "", "CN", "156", "", "19", "", "", "41.26472", "125.36667", "Asia/Shanghai"),("2036734", "Huangnihe", "", "CN", "156", "", "05", "", "", "43.55833", "128.02389", "Asia/Shanghai"),("2036753", "Huanan", "", "CN", "156", "", "08", "", "", "46.2207", "130.525", "Asia/Shanghai"),("2036776", "Huadian", "", "CN", "156", "", "05", "", "", "42.96333", "126.74778", "Asia/Shanghai"),("2036876", "Honggang", "", "CN", "156", "", "08", "", "", "46.40124", "124.88322", "Asia/Shanghai"),("2036892", "Hohhot", "Хух-Хото", "CN", "156", "", "20", "", "", "40.81056", "111.65222", "Asia/Shanghai"),("2036920", "Fendou", "", "CN", "156", "", "08", "", "", "45.21235", "130.90254", "Asia/Shanghai"),("2036933", "Helong", "Хэлуне", "CN", "156", "", "05", "", "", "42.53974", "128.99722", "Asia/Shanghai"),("2036959", "Heishan", "", "CN", "156", "", "19", "", "", "41.68917", "122.11278", "Asia/Shanghai"),("2036973", "Heihe", "Хэйхэ", "CN", "156", "", "08", "", "", "50.24413", "127.49016", "Asia/Shanghai"),("2036986", "Hegang", "Хэган", "CN", "156", "", "08", "", "", "47.35118", "130.30012", "Asia/Shanghai"),("2037013", "Harbin", "Харбин", "CN", "156", "", "08", "", "", "45.75", "126.65", "Asia/Shanghai"),("2037069", "Hailun", "", "CN", "156", "", "08", "", "", "47.4565", "126.95368", "Asia/Shanghai"),("2037075", "Hailin", "Хайлин", "CN", "156", "", "08", "", "", "44.57149", "129.38539", "Asia/Shanghai"),("2037078", "Hailar", "Хайлар", "CN", "156", "", "20", "", "", "49.2", "119.7", "Asia/Shanghai"),("2037086", "Haicheng", "", "CN", "156", "", "19", "", "", "40.85158", "122.74754", "Asia/Shanghai"),("2037222", "Gongzhuling", "Гунчжулина", "CN", "156", "", "05", "", "", "43.50075", "124.81979", "Asia/Shanghai"),("2037240", "Gongchangling", "", "CN", "156", "", "19", "", "", "41.11667", "123.45", "Asia/Shanghai"),("2037252", "Genhe", "", "CN", "156", "", "20", "", "", "50.78333", "121.51667", "Asia/Shanghai"),("2037311", "Gannan", "", "CN", "156", "", "08", "", "", "47.91472", "123.50306", "Asia/Shanghai"),("2037330", "Fuyuan", "Фуюань", "CN", "156", "", "08", "", "", "48.36306", "134.28917", "Asia/Shanghai"),("2037334", "Fuyu", "", "CN", "156", "", "08", "", "", "47.79756", "124.45731", "Asia/Shanghai"),("2037335", "Fuyu", "", "CN", "156", "", "05", "", "", "45.18333", "124.81667", "Asia/Shanghai"),("2037345", "Fuxin", "Фусинь", "CN", "156", "", "19", "", "", "42.05889", "121.745", "Asia/Shanghai"),("2037346", "Fuxin", "Фусинь", "CN", "156", "", "19", "", "", "42.01556", "121.65889", "Asia/Shanghai"),("2037355", "Fushun", "Фушунь", "CN", "156", "", "19", "", "", "41.85583", "123.92333", "Asia/Shanghai"),("2037370", "Fuli", "Фули", "CN", "156", "", "08", "", "", "46.72167", "131.13944", "Asia/Shanghai"),("2037375", "Fujin", "Фуцзинь", "CN", "156", "", "08", "", "", "47.26", "132.03222", "Asia/Shanghai"),("2037391", "Beichengqu", "", "CN", "156", "", "20", "", "", "40.43944", "113.15361", "Asia/Shanghai"),("2037393", "Fengxiang", "Фенгсианг", "CN", "156", "", "08", "", "", "47.57549", "130.82306", "Asia/Shanghai"),("2037411", "Fengcheng", "", "CN", "156", "", "19", "", "", "40.45361", "124.07167", "Asia/Shanghai"),("2037485", "Erenhot", "", "CN", "156", "", "20", "", "", "43.6475", "111.97667", "Asia/Shanghai"),("2037494", "Erdaojiang", "", "CN", "156", "", "05", "", "", "41.77639", "126.03194", "Asia/Shanghai"),("2037534", "Dunhua", "Дуньхуа", "CN", "156", "", "05", "", "", "43.3725", "128.2425", "Asia/Shanghai"),("2037611", "Dongning", "", "CN", "156", "", "08", "", "", "44.06219", "131.12075", "Asia/Shanghai"),("2037620", "Dongling", "Донлин", "CN", "156", "", "19", "", "", "41.81444", "123.57583", "Asia/Shanghai"),("2037658", "Dongfeng", "", "CN", "156", "", "05", "", "", "42.64031", "125.51176", "Asia/Shanghai"),("2037685", "Dongxing", "", "CN", "156", "", "08", "", "", "45.36088", "130.78679", "Asia/Shanghai"),("2037712", "Dehui", "", "CN", "156", "", "05", "", "", "44.53333", "125.7", "Asia/Shanghai"),("2037799", "Datong", "Датун", "CN", "156", "", "24", "", "", "40.09361", "113.29139", "Asia/Shanghai"),("2037820", "Dashitou", "", "CN", "156", "", "05", "", "", "43.30667", "128.51139", "Asia/Shanghai"),("2037823", "Dashiqiao", "", "CN", "156", "", "19", "", "", "40.63732", "122.50251", "Asia/Shanghai"),("2037860", "Daqing", "Дацин", "CN", "156", "", "08", "", "", "46.58333", "125", "Asia/Shanghai"),("2037886", "Dandong", "Даньдун", "CN", "156", "", "19", "", "", "40.12917", "124.39472", "Asia/Shanghai"),("2037913", "Linghai", "", "CN", "156", "", "19", "", "", "41.16528", "121.36667", "Asia/Shanghai"),("2037930", "Dalai", "", "CN", "156", "", "05", "", "", "45.5", "124.3", "Asia/Shanghai"),("2038067", "Chifeng", "Чифэн", "CN", "156", "", "20", "", "", "42.26833", "118.96361", "Asia/Shanghai"),("2038080", "Chengzihe", "", "CN", "156", "", "08", "", "", "45.33333", "131.06667", "Asia/Shanghai"),("2038087", "Chengde", "Чэндэ", "CN", "156", "", "10", "2038085", "2038084", "40.9519", "117.95883", "Asia/Shanghai"),("2038118", "Chaoyang", "Чаоян", "CN", "156", "", "05", "", "", "42.66223", "126.0263", "Asia/Shanghai"),("2038120", "Chaoyang", "Чаоян", "CN", "156", "", "19", "", "", "41.57028", "120.45861", "Asia/Shanghai"),("2038139", "Changtu", "Чанту", "CN", "156", "", "19", "", "", "42.77884", "124.09545", "Asia/Shanghai"),("2038154", "Changping", "Чанпин", "CN", "156", "", "22", "", "", "40.21612", "116.23471", "Asia/Shanghai"),("2038158", "Changling", "", "CN", "156", "", "05", "", "", "44.26532", "124.00045", "Asia/Shanghai"),("2038180", "Changchun", "Чанчунь", "CN", "156", "", "05", "2038176", "", "43.88", "125.32278", "Asia/Shanghai"),("2038198", "Chaihe", "", "CN", "156", "", "08", "", "", "44.7598", "129.67826", "Asia/Shanghai"),("2038274", "Boli", "Боли", "CN", "156", "", "08", "", "", "45.75279", "130.57211", "Asia/Shanghai"),("2038283", "Binzhou", "", "CN", "156", "", "08", "", "", "45.75281", "127.47986", "Asia/Shanghai"),("2038300", "Benxi", "Бэньси", "CN", "156", "", "19", "", "", "41.28861", "123.765", "Asia/Shanghai"),("2038342", "Beipiao", "", "CN", "156", "", "19", "", "", "41.79194", "120.77917", "Asia/Shanghai"),("2038365", "Bei’an", "", "CN", "156", "", "08", "", "", "48.26667", "126.6", "Asia/Shanghai"),("2038421", "Bayan", "Баян", "CN", "156", "", "08", "", "", "46.07556", "127.3984", "Asia/Shanghai"),("2038432", "Baotou", "Баотоу", "CN", "156", "CN", "20", "", "", "40.65222", "109.82222", "Asia/Shanghai"),("2038438", "Baoshan", "Баошань", "CN", "156", "", "08", "", "", "46.55861", "131.42444", "Asia/Shanghai"),("2038446", "Baoqing", "Баоцин", "CN", "156", "", "08", "", "", "46.33167", "132.21111", "Asia/Shanghai"),("2038482", "Bamiantong", "", "CN", "156", "", "08", "", "", "44.91738", "130.52", "Asia/Shanghai"),("2038529", "Baishishan", "", "CN", "156", "", "05", "", "", "43.58333", "127.56667", "Asia/Shanghai"),("2038541", "Baiquan", "", "CN", "156", "", "08", "", "", "47.60605", "126.08481", "Asia/Shanghai"),("2038569", "Baicheng", "Байчен", "CN", "156", "", "05", "", "", "45.60746", "122.82076", "Asia/Shanghai"),("2038584", "Baishan", "Байшань", "CN", "156", "", "05", "", "", "41.93853", "126.41965", "Asia/Shanghai"),("2038632", "Anshan", "Аньшань", "CN", "156", "", "19", "2038630", "", "41.12361", "122.99", "Asia/Shanghai"),("2038650", "Anda", "Анда", "CN", "156", "", "08", "", "", "46.40202", "125.31454", "Asia/Shanghai"),("2038665", "Oroqen Zizhiqi", "Алихэ", "CN", "156", "", "20", "", "", "50.56667", "123.71667", "Asia/Shanghai"),("2038679", "Acheng", "Ахенг", "CN", "156", "", "08", "", "", "45.54545", "126.97703", "Asia/Shanghai"),("2047837", "Songling", "", "CN", "156", "", "10", "", "", "40.29303", "118.26908", "Asia/Shanghai"),("6825277", "Shilin", "Шилин", "CN", "156", "", "29", "", "", "24.81878", "103.33237", "Asia/Shanghai"),("7283386", "Changshu City", "", "CN", "156", "", "04", "", "", "31.64615", "120.74221", "Asia/Shanghai"),("7290013", "Shixing", "", "CN", "156", "", "30", "", "", "24.94824", "114.06572", "Asia/Shanghai"),("7303248", "Jiashan", "", "CN", "156", "", "02", "", "", "30.84918", "120.92583", "Asia/Shanghai"),("7304020", "Fenghuang", "Фенхуань", "CN", "156", "", "11", "", "", "27.93557", "109.59961", "Asia/Shanghai"),("7602670", "Zhu Cheng City", "", "CN", "156", "", "25", "", "", "35.99502", "119.40259", "Asia/Shanghai"),("7910932", "Shangri-La", "Шангри-Ла", "CN", "156", "", "29", "1281365", "", "27.82511", "99.70779", "Asia/Shanghai"),("8347664", "Ordos", "Ордос", "CN", "156", "", "20", "", "", "39.6086", "109.78157", "Asia/Shanghai"),("8505006", "Wenshan City", "", "CN", "156", "", "29", "1791424", "", "23.36306", "104.25047", "Asia/Shanghai"),("8533133", "Liupanshui", "", "CN", "156", "", "18", "", "", "26.59444", "104.83333", "Asia/Shanghai"),("3533556", "Zaza del Medio", "", "CU", "192", "", "14", "", "", "21.99712", "-79.36678", "America/Havana"),("3533753", "Yara", "", "CU", "192", "", "09", "", "", "20.27465", "-76.95132", "America/Havana"),("3533826", "Yaguajay", "", "CU", "192", "", "14", "", "", "22.32691", "-79.23567", "America/Havana"),("3534094", "Viñales", "Виньялес", "CU", "192", "", "01", "2108", "", "22.61892", "-83.70694", "America/Havana"),("3534363", "Vertientes", "", "CU", "192", "", "05", "", "", "21.25817", "-78.14979", "America/Havana"),("3534432", "Venezuela", "", "CU", "192", "", "07", "", "", "21.73748", "-78.79336", "America/Havana"),("3534632", "Varadero", "Варадеро", "CU", "192", "CU", "03", "", "", "23.15678", "-81.24441", "America/Havana"),("3534749", "San Germán", "", "CU", "192", "", "12", "", "", "20.60009", "-76.13364", "America/Havana"),("3534761", "Unión de Reyes", "", "CU", "192", "", "03", "", "", "22.79505", "-81.53617", "America/Havana"),("3534915", "Trinidad", "Тринидад", "CU", "192", "", "14", "", "", "21.80224", "-79.98467", "America/Havana"),("3535143", "Topes de Collantes", "", "CU", "192", "", "14", "2806", "", "21.91524", "-80.01929", "America/Havana"),("3535775", "Soroa", "", "CU", "192", "", "AR", "", "", "22.8", "-83.01667", "America/Havana"),("3536259", "Sibanicú", "", "CU", "192", "", "05", "", "", "21.23631", "-77.52561", "America/Havana"),("3536640", "Santo Domingo", "", "CU", "192", "", "16", "", "", "22.58677", "-80.24261", "America/Havana"),("3536724", "Santiago de las Vegas", "Сантьяго-де-лас-Вегас", "CU", "192", "", "02", "2313", "", "22.97", "-82.38694", "America/Havana"),("3536729", "Santiago de Cuba", "Сантьяго-де-Куба", "CU", "192", "", "15", "3406", "", "20.02083", "-75.82667", "America/Havana"),("3537840", "Santa Cruz del Sur", "", "CU", "192", "", "05", "", "", "20.71633", "-77.99816", "America/Havana"),("3537845", "Santa Cruz del Norte", "", "CU", "192", "", "MA", "", "", "23.15424", "-81.92556", "America/Havana"),("3537906", "Santa Clara", "Санта Клара", "CU", "192", "", "16", "", "", "22.40694", "-79.96472", "America/Havana"),("3538758", "San Nicolás de Bari", "", "CU", "192", "", "MA", "2407", "", "22.78444", "-81.91333", "America/Havana"),("3538803", "San Miguel del Padrón", "", "CU", "192", "", "02", "", "", "23.06639", "-82.29472", "America/Havana"),("3539092", "San Luis", "", "CU", "192", "", "01", "", "", "22.27898", "-83.75956", "America/Havana"),("3539093", "San Luis", "", "CU", "192", "", "15", "", "", "20.18809", "-75.85031", "America/Havana"),("3539560", "San José de las Lajas", "", "CU", "192", "", "MA", "", "", "22.96139", "-82.15111", "America/Havana"),("3540667", "Sancti Spíritus", "Санкти-Спиритус", "CU", "192", "", "14", "", "", "21.92972", "-79.4425", "America/Havana"),("3540680", "San Cristobal", "", "CU", "192", "", "AR", "", "", "22.71658", "-83.05647", "America/Havana"),("3540885", "San Antonio de los Baños", "", "CU", "192", "", "AR", "", "", "22.89018", "-82.50099", "America/Havana"),("3541440", "Sagua la Grande", "", "CU", "192", "", "16", "", "", "22.80667", "-80.07556", "America/Havana"),("3541446", "Sagua de Tánamo", "", "CU", "192", "", "12", "", "", "20.58269", "-75.24116", "America/Havana"),("3541999", "Rodas", "Родас", "CU", "192", "", "08", "", "", "22.34184", "-80.55596", "America/Havana"),("3542137", "Río Guayabal de Yateras", "", "CU", "192", "", "10", "", "", "20.36667", "-75.01667", "America/Havana"),("3542167", "Río Cauto", "", "CU", "192", "", "09", "", "", "20.55971", "-76.91673", "America/Havana"),("3542455", "Remedios", "Ремедиос", "CU", "192", "", "16", "", "", "22.49502", "-79.54548", "America/Havana"),("3542502", "Regla", "", "CU", "192", "CU", "02", "", "", "23.125", "-82.33194", "America/Havana"),("3542744", "Ranchuelo", "", "CU", "192", "", "16", "2612", "", "22.37266", "-80.15046", "America/Havana"),("3542965", "Quivicán", "", "CU", "192", "", "MA", "", "", "22.82313", "-82.35558", "America/Havana"),("3543077", "Quemado de Güines", "", "CU", "192", "", "16", "", "", "22.78816", "-80.25226", "America/Havana"),("3543299", "Puerto Padre", "Пуэрто-Падре", "CU", "192", "", "13", "", "", "21.19517", "-76.60358", "America/Havana"),("3543498", "Primero de Enero", "", "CU", "192", "", "07", "", "", "21.94501", "-78.4313", "America/Havana"),("3543961", "Placetas", "", "CU", "192", "", "16", "", "", "22.31184", "-79.6544", "America/Havana"),("3544091", "Pinar del Río", "Пинар-дель-Рио", "CU", "192", "", "01", "2108", "", "22.41667", "-83.69667", "America/Havana"),("3544393", "Perico", "", "CU", "192", "", "03", "", "", "22.76987", "-81.0183", "America/Havana"),("3544607", "Pedro Betancourt", "", "CU", "192", "", "03", "", "", "22.72709", "-81.28963", "America/Havana"),("3545040", "Palmira", "", "CU", "192", "", "08", "", "", "22.24126", "-80.3911", "America/Havana"),("3545064", "Palma Soriano", "", "CU", "192", "", "15", "", "", "20.2113", "-75.99362", "America/Havana"),("3545841", "Nuevitas", "", "CU", "192", "", "05", "", "", "21.54585", "-77.26504", "America/Havana"),("3545867", "Nueva Gerona", "Нуэва-Херона", "CU", "192", "", "04", "", "", "21.88667", "-82.80556", "America/Havana"),("3545981", "Niquero", "", "CU", "192", "", "09", "", "", "20.04698", "-77.58089", "America/Havana"),("3546434", "Morón", "Морон", "CU", "192", "", "07", "", "", "22.10774", "-78.62667", "America/Havana"),("3546791", "Moa", "Моа", "CU", "192", "", "12", "", "", "20.65776", "-74.95075", "America/Havana"),("3546882", "Minas de Matahambre", "", "CU", "192", "", "01", "", "", "22.58691", "-83.94551", "America/Havana"),("3546894", "Minas", "Минас", "CU", "192", "", "05", "", "", "21.48802", "-77.61033", "America/Havana"),("3547260", "Media Luna", "", "CU", "192", "", "09", "", "", "20.14298", "-77.43532", "America/Havana"),("3547398", "Matanzas", "Матанзас", "CU", "192", "", "03", "", "", "23.04111", "-81.5775", "America/Havana"),("3547519", "Martí", "", "CU", "192", "", "03", "", "", "22.94714", "-80.91902", "America/Havana"),("3547600", "Mariel", "", "CU", "192", "", "AR", "", "", "22.98931", "-82.75376", "America/Havana"),("3547867", "Manzanillo", "Мансанильо", "CU", "192", "", "09", "", "", "20.34173", "-77.12126", "America/Havana"),("3547930", "Mantua", "", "CU", "192", "", "01", "", "", "22.29058", "-84.28599", "America/Havana"),("3547976", "Manicaragua", "", "CU", "192", "", "16", "", "", "22.15021", "-79.97867", "America/Havana"),("3548099", "Manatí", "", "CU", "192", "", "13", "", "", "21.3107", "-76.93403", "America/Havana"),("3548441", "Maisí", "", "CU", "192", "", "10", "", "", "20.24673", "-74.15181", "America/Havana"),("3548529", "Madruga", "", "CU", "192", "", "MA", "", "", "22.91", "-81.85639", "America/Havana"),("3548993", "Los Palacios", "", "CU", "192", "", "01", "", "", "22.58882", "-83.24671", "America/Havana"),("3549463", "Los Arabos", "", "CU", "192", "", "03", "", "", "22.72969", "-80.72081", "America/Havana"),("3550598", "Las Tunas", "Лас-Тунас", "CU", "192", "", "13", "", "", "20.96167", "-76.95111", "America/Havana"),("3551184", "La Sierpe", "", "CU", "192", "", "14", "", "", "21.77241", "-79.26832", "America/Havana"),("3551608", "La Salud", "Ла Салюд", "CU", "192", "", "MA", "", "", "22.87199", "-82.42328", "America/Havana"),("3553478", "Havana", "Гавана", "CU", "192", "", "02", "", "", "23.13302", "-82.38304", "America/Havana"),("3555907", "Jovellanos", "", "CU", "192", "", "03", "", "", "22.80375", "-81.19127", "America/Havana"),("3556077", "Jobabo", "", "CU", "192", "", "12", "", "", "20.96917", "-76.29944", "America/Havana"),("3556078", "Jobabo", "", "CU", "192", "", "13", "", "", "20.90748", "-77.28194", "America/Havana"),("3556168", "Jiguaní", "", "CU", "192", "", "09", "", "", "20.36785", "-76.42741", "America/Havana"),("3556268", "Jesús Menéndez", "", "CU", "192", "", "13", "", "", "21.16139", "-76.47919", "America/Havana"),("3556334", "Jatibonico", "", "CU", "192", "", "14", "", "", "21.94333", "-79.16906", "America/Havana"),("3556351", "Jaruco", "", "CU", "192", "", "MA", "", "", "23.04419", "-82.00919", "America/Havana"),("3556406", "Jamaica", "", "CU", "192", "", "MA", "", "", "22.97559", "-82.16852", "America/Havana"),("3556437", "Jagüey Grande", "", "CU", "192", "", "03", "", "", "22.52694", "-81.12861", "America/Havana"),("3556969", "Holguín", "Ольгин", "CU", "192", "", "12", "3206", "", "20.88722", "-76.26306", "America/Havana"),("3557332", "Guisa", "", "CU", "192", "", "09", "", "", "20.25494", "-76.5393", "America/Havana"),("3557347", "Güira de Melena", "", "CU", "192", "", "AR", "", "", "22.79613", "-82.50667", "America/Havana"),("3557378", "Güines", "Гуинес", "CU", "192", "", "MA", "", "", "22.83727", "-82.02641", "America/Havana"),("3557432", "Guayos", "", "CU", "192", "", "14", "", "", "22.04956", "-79.46106", "America/Havana"),("3557689", "Guantánamo", "Гуантанамо", "CU", "192", "", "10", "3509", "", "20.14444", "-75.20917", "America/Havana"),("3557758", "Guane", "", "CU", "192", "", "01", "", "", "22.20179", "-84.08484", "America/Havana"),("3557801", "Guanajay", "", "CU", "192", "", "AR", "", "", "22.92639", "-82.6875", "America/Havana"),("3557846", "Guanabacoa", "", "CU", "192", "", "02", "", "", "23.1236", "-82.30082", "America/Havana"),("3557923", "Guáimaro", "", "CU", "192", "", "05", "", "", "21.05222", "-77.3499", "America/Havana"),("3558315", "Gibara", "", "CU", "192", "", "12", "", "", "21.10988", "-76.13145", "America/Havana"),("3558744", "Fomento", "", "CU", "192", "", "14", "", "", "22.10475", "-79.72141", "America/Havana"),("3558771", "Florida", "Флорида", "CU", "192", "", "05", "", "", "21.52536", "-78.22579", "America/Havana"),("3558792", "Florencia", "", "CU", "192", "", "07", "", "", "22.1461", "-78.97328", "America/Havana"),("3559235", "Esperanza", "", "CU", "192", "", "16", "", "", "22.4468", "-80.09711", "America/Havana"),("3559318", "Esmeralda", "Эсмеральда", "CU", "192", "", "05", "", "", "21.85139", "-78.11725", "America/Havana"),("3559416", "Encrucijada", "", "CU", "192", "", "16", "", "", "22.61802", "-79.86603", "America/Havana"),("3562827", "Cumanayagua", "", "CU", "192", "", "08", "2707", "", "22.15247", "-80.20354", "America/Havana"),("3562895", "Cueto", "", "CU", "192", "", "12", "", "", "20.64855", "-75.92967", "America/Havana"),("3563145", "Cruces", "Крусес", "CU", "192", "", "08", "", "", "22.34203", "-80.27021", "America/Havana"),("3563317", "Corralillo", "", "CU", "192", "", "16", "", "", "22.98212", "-80.58556", "America/Havana"),("3563504", "Contramaestre", "", "CU", "192", "", "15", "", "", "20.29879", "-76.24511", "America/Havana"),("3563559", "Consolación del Sur", "", "CU", "192", "", "01", "", "", "22.50419", "-83.51442", "America/Havana"),("3563609", "Condado", "Кондадо", "CU", "192", "", "14", "", "", "21.8767", "-79.84014", "America/Havana"),("3563843", "Colón", "", "CU", "192", "", "03", "", "", "22.72064", "-80.90492", "America/Havana"),("3563856", "Colombia", "", "CU", "192", "", "13", "", "", "20.98812", "-77.42598", "America/Havana"),("3564084", "Ciro Redondo", "", "CU", "192", "", "07", "", "", "22.01921", "-78.70365", "America/Havana"),("3564114", "Cifuentes", "", "CU", "192", "", "16", "", "", "22.6493", "-80.04935", "America/Havana"),("3564124", "Cienfuegos", "Сьенфуэгос", "CU", "192", "", "08", "2707", "", "22.14957", "-80.44662", "America/Havana"),("3564178", "Ciego de Ávila", "", "CU", "192", "", "07", "", "", "21.84", "-78.76194", "America/Havana"),("3564394", "Chambas", "", "CU", "192", "", "07", "", "", "22.19534", "-78.9123", "America/Havana"),("3564436", "Cerro", "", "CU", "192", "", "02", "", "", "23.10861", "-82.37778", "America/Havana"),("3564885", "Cauto Cristo", "", "CU", "192", "", "09", "", "", "20.55709", "-76.4727", "America/Havana"),("3565432", "Cárdenas", "Карденас", "CU", "192", "", "03", "", "", "23.03661", "-81.20596", "America/Havana"),("3565768", "Candelaria", "", "CU", "192", "", "AR", "", "", "22.74057", "-82.95912", "America/Havana"),("3565951", "Campechuela", "", "CU", "192", "", "09", "", "", "20.23329", "-77.2799", "America/Havana"),("3566054", "Camajuaní", "", "CU", "192", "", "16", "", "", "22.48333", "-79.75", "America/Havana"),("3566067", "Camagüey", "Камагуэй", "CU", "192", "", "05", "", "", "21.38083", "-77.91694", "America/Havana"),("3566134", "Calimete", "", "CU", "192", "", "03", "", "", "22.5342", "-80.91105", "America/Havana"),("3566235", "Calabazar de Sagua", "", "CU", "192", "", "16", "", "", "22.64515", "-79.8951", "America/Havana"),("3566356", "Caibarién", "", "CU", "192", "", "16", "", "", "22.51996", "-79.46599", "America/Havana"),("3566429", "Cacocum", "", "CU", "192", "", "12", "", "", "20.73775", "-76.32574", "America/Havana"),("3566573", "Cabañas", "", "CU", "192", "", "AR", "", "", "22.97944", "-82.92214", "America/Havana"),("3566603", "Cabaiguán", "", "CU", "192", "", "14", "", "", "22.07874", "-79.49726", "America/Havana"),("3567082", "Bolondrón", "", "CU", "192", "", "03", "", "", "22.76307", "-81.4478", "America/Havana"),("3567546", "Bejucal", "", "CU", "192", "", "MA", "", "", "22.92861", "-82.38861", "America/Havana"),("3567597", "Bayamo", "Баямо", "CU", "192", "", "09", "", "", "20.37417", "-76.64361", "America/Havana"),("3567612", "Bauta", "", "CU", "192", "", "AR", "", "", "22.98226", "-82.54719", "America/Havana"),("3567655", "Batabanó", "", "CU", "192", "", "MA", "", "", "22.71794", "-82.28965", "America/Havana"),("3567669", "Bartolomé Masó", "", "CU", "192", "", "09", "", "", "20.16635", "-76.94291", "America/Havana"),("3567823", "Baraguá", "", "CU", "192", "", "07", "", "", "21.68216", "-78.62567", "America/Havana"),("3567834", "Baracoa", "", "CU", "192", "", "10", "", "", "20.34711", "-74.49624", "America/Havana"),("3567869", "Banes", "", "CU", "192", "", "12", "", "", "20.96116", "-75.722", "America/Havana"),("3567995", "Bahía Honda", "", "CU", "192", "", "AR", "", "", "22.90332", "-83.15994", "America/Havana"),("3568312", "Artemisa", "Артемиса", "CU", "192", "", "AR", "", "", "22.81667", "-82.75944", "America/Havana"),("3568342", "Arroyo Naranjo", "", "CU", "192", "", "02", "", "", "23.03677", "-82.36937", "America/Havana"),("3569024", "Amancio", "", "CU", "192", "", "13", "", "", "20.81914", "-77.57958", "America/Havana"),("3569136", "Alquízar", "", "CU", "192", "", "AR", "", "", "22.80517", "-82.58392", "America/Havana"),("3569370", "Alamar", "Аламар", "CU", "192", "", "02", "", "", "23.15794", "-82.27837", "America/Havana"),("3569379", "Alacranes", "", "CU", "192", "", "03", "", "", "22.76719", "-81.56803", "America/Havana"),("3569546", "Aguada de Pasajeros", "", "CU", "192", "", "08", "2701", "", "22.3852", "-80.84792", "America/Havana"),("3569741", "Abreus", "", "CU", "192", "", "08", "", "", "22.27797", "-80.56931", "America/Havana"),("3746181", "Habana del Este", "", "CU", "192", "", "02", "", "", "23.15917", "-82.33056", "America/Havana"),("3746183", "Centro Habana", "", "CU", "192", "", "02", "", "", "23.13833", "-82.36417", "America/Havana"),("3746184", "La Habana Vieja", "", "CU", "192", "", "02", "", "", "23.13028", "-82.35306", "America/Havana"),("3746938", "Báguanos", "", "CU", "192", "", "12", "", "", "20.75167", "-76.02694", "America/Havana"),("3754915", "Jimaguayú", "", "CU", "192", "", "05", "", "", "21.24224", "-77.82625", "America/Havana"),("6956646", "Arroyo Naranjo", "", "CU", "192", "", "02", "", "", "23.0144", "-82.3031", "America/Havana"),("6956647", "Boyeros", "", "CU", "192", "", "02", "", "", "23.0072", "-82.4017", "America/Havana"),("6956648", "Diez de Octubre", "", "CU", "192", "", "02", "", "", "23.0881", "-82.3597", "America/Havana"),("3374117", "Vila Nova Sintra", "", "CV", "132", "", "02", "", "", "14.86667", "-24.71667", "Atlantic/Cape_Verde"),("3374120", "Vila do Maio", "", "CV", "132", "", "04", "", "", "15.13823", "-23.21158", "Atlantic/Cape_Verde"),("3374121", "Vila da Ribeira Brava", "", "CV", "132", "", "22", "", "", "16.61667", "-24.3", "Atlantic/Cape_Verde"),("3374165", "Tarrafal de São Nicolau", "", "CV", "132", "", "27", "", "", "16.56667", "-24.36667", "Atlantic/Cape_Verde"),("3374166", "Tarrafal", "", "CV", "132", "", "20", "", "", "15.27881", "-23.75192", "Atlantic/Cape_Verde"),("3374210", "São Filipe", "", "CV", "132", "", "18", "", "", "14.8961", "-24.49556", "Atlantic/Cape_Verde"),("3374211", "São Domingos", "", "CV", "132", "", "17", "", "", "15.02438", "-23.5625", "Atlantic/Cape_Verde"),("3374218", "Santa Maria", "", "CV", "132", "", "08", "", "", "16.6", "-22.9", "Atlantic/Cape_Verde"),("3374221", "Santa Cruz", "", "CV", "132", "", "16", "", "", "15.13333", "-23.56667", "Atlantic/Cape_Verde"),("3374235", "Vila de Sal Rei", "", "CV", "132", "", "01", "", "", "16.18333", "-22.91667", "Atlantic/Cape_Verde"),("3374275", "Ribeira Grande", "", "CV", "132", "", "07", "", "", "17.18561", "-25.07243", "Atlantic/Cape_Verde"),("3374333", "Praia", "Прая", "CV", "132", "", "14", "", "", "14.93152", "-23.51254", "Atlantic/Cape_Verde"),("3374336", "Porto Novo", "", "CV", "132", "", "21", "", "", "17.01969", "-25.06471", "Atlantic/Cape_Verde"),("3374338", "Porto dos Mosteiros", "", "CV", "132", "", "13", "", "", "15.03333", "-24.33333", "Atlantic/Cape_Verde"),("3374351", "Pombas", "", "CV", "132", "", "05", "", "", "17.15026", "-25.02007", "Atlantic/Cape_Verde"),("3374360", "Picos", "", "CV", "132", "", "26", "", "", "15.0836", "-23.63236", "Atlantic/Cape_Verde"),("3374462", "Mindelo", "Минделу", "CV", "132", "", "11", "", "", "16.89014", "-24.98042", "Atlantic/Cape_Verde"),("3374707", "Cova Figueira", "", "CV", "132", "", "24", "", "", "14.89054", "-24.29343", "Atlantic/Cape_Verde"),("3374725", "Cidade Velha", "", "CV", "132", "", "23", "", "", "14.91667", "-23.61667", "Atlantic/Cape_Verde"),("3374794", "Calheta", "", "CV", "132", "", "19", "", "", "15.18613", "-23.59228", "Atlantic/Cape_Verde"),("3374888", "Assomada", "", "CV", "132", "", "15", "", "", "15.1", "-23.68333", "Atlantic/Cape_Verde"),("8441167", "João Teves", "", "CV", "132", "", "25", "", "", "15.06457", "-23.58969", "Atlantic/Cape_Verde"),("8441169", "Pedra Badejo", "", "CV", "132", "", "16", "", "", "15.13493", "-23.53215", "Atlantic/Cape_Verde"),("8521418", "Espargos", "", "CV", "132", "", "08", "", "", "16.75524", "-22.9446", "Atlantic/Cape_Verde"),("18918", "Protaras", "Протарас", "CY", "196", "", "01", "", "", "35.0125", "34.05833", "Asia/Nicosia"),("145952", "Ýpsonas", "", "CY", "196", "", "05", "", "", "34.68797", "32.96191", "Asia/Nicosia"),("145964", "Géri", "", "CY", "196", "", "04", "", "", "35.1056", "33.41977", "Asia/Nicosia"),("145981", "Tséri", "", "CY", "196", "", "04", "", "", "35.07307", "33.32344", "Asia/Nicosia"),("146105", "Rizokárpaso", "", "CY", "196", "", "01", "", "", "35.59719", "34.37916", "Asia/Nicosia"),("146189", "Pérgamos", "", "CY", "196", "", "03", "", "", "35.04167", "33.70833", "Asia/Nicosia"),("146209", "Paralímni", "", "CY", "196", "", "01", "", "", "35.03945", "33.98181", "Asia/Nicosia"),("146214", "Paphos", "Пафос", "CY", "196", "", "06", "", "", "34.77679", "32.42451", "Asia/Nicosia"),("146268", "Nicosia", "Никосия", "CY", "196", "", "04", "", "", "35.17531", "33.3642", "Asia/Nicosia"),("146286", "Mórfou", "", "CY", "196", "", "04", "", "", "35.19869", "32.99338", "Asia/Nicosia"),("146371", "Livádia", "", "CY", "196", "", "03", "", "", "34.95118", "33.62658", "Asia/Nicosia"),("146384", "Limassol", "Лимасол", "CY", "196", "", "05", "", "", "34.68406", "33.03794", "Asia/Nicosia"),("146392", "Léfka", "", "CY", "196", "", "04", "", "", "35.11199", "32.84997", "Asia/Nicosia"),("146400", "Larnaca", "Ларнака", "CY", "196", "", "03", "", "", "34.92291", "33.6233", "Asia/Nicosia"),("146403", "Lápithos", "", "CY", "196", "", "02", "", "", "35.33823", "33.17368", "Asia/Nicosia"),("146412", "Kyrenia", "Кирения", "CY", "196", "", "02", "", "", "35.33634", "33.31729", "Asia/Nicosia"),("146617", "Famagusta", "Фамагуста", "CY", "196", "", "01", "", "", "35.12054", "33.93894", "Asia/Nicosia"),("146654", "Dhromolaxia", "", "CY", "196", "", "03", "", "", "34.87551", "33.58684", "Asia/Nicosia"),("146661", "Derýneia", "", "CY", "196", "", "01", "", "", "35.06484", "33.96083", "Asia/Nicosia"),("146666", "Dáli", "", "CY", "196", "", "04", "", "", "35.02294", "33.42195", "Asia/Nicosia"),("146796", "Aradíppou", "", "CY", "196", "", "03", "", "", "34.95151", "33.59199", "Asia/Nicosia"),("3061284", "Dvůr Králové nad Labem", "Двур-Кралове-над-Лабем", "CZ", "203", "", "82", "0525", "", "50.43172", "15.81402", "Europe/Prague"),("3061327", "Zubří", "", "CZ", "203", "", "90", "0723", "", "49.46603", "18.09249", "Europe/Prague"),("3061344", "Znojmo", "Зноймо", "CZ", "203", "", "78", "0627", "", "48.8555", "16.0488", "Europe/Prague"),("3061370", "Zlín", "Злин", "CZ", "203", "", "90", "0724", "", "49.22645", "17.67065", "Europe/Prague"),("3061562", "Železný Brod", "", "CZ", "203", "", "83", "0512", "", "50.64274", "15.25408", "Europe/Prague"),("3061692", "Žďár nad Sázavou Druhy", "", "CZ", "203", "", "80", "0615", "", "49.58726", "15.93215", "Europe/Prague"),("3061695", "Žďár nad Sázavou", "Ждяр-над-Сазавоу", "CZ", "203", "CZ", "80", "0615", "", "49.56263", "15.93924", "Europe/Prague"),("3061822", "Žatec", "Жатец", "CZ", "203", "", "89", "0424", "", "50.32717", "13.54577", "Europe/Prague"),("3061888", "Žamberk", "", "CZ", "203", "", "86", "0534", "", "50.08601", "16.46738", "Europe/Prague"),("3062111", "Zábřeh", "", "CZ", "203", "", "84", "0715", "", "49.8826", "16.87223", "Europe/Prague"),("3062214", "Vysoké Mýto", "", "CZ", "203", "", "86", "0532", "", "49.9532", "16.16169", "Europe/Prague"),("3062257", "Vysočany", "", "CZ", "203", "", "52", "8378777", "", "50.10938", "14.51667", "Europe/Prague"),("3062283", "Vyškov", "Вышков", "CZ", "203", "", "78", "0626", "", "49.27747", "16.99897", "Europe/Prague"),("3062339", "Vsetín", "Всетин", "CZ", "203", "", "90", "0723", "", "49.33871", "17.99619", "Europe/Prague"),("3062439", "Vrchlabí", "", "CZ", "203", "", "82", "0525", "", "50.62697", "15.60937", "Europe/Prague"),("3062446", "Vrbno pod Pradědem", "", "CZ", "203", "", "85", "0801", "", "50.12095", "17.38316", "Europe/Prague"),("3062497", "Vratimov", "", "CZ", "203", "", "85", "0806", "", "49.76995", "18.31015", "Europe/Prague"),("3062642", "Vodňany", "", "CZ", "203", "", "79", "0316", "", "49.14789", "14.17513", "Europe/Prague"),("3062759", "Vlašim", "", "CZ", "203", "", "88", "0201", "", "49.70632", "14.89881", "Europe/Prague"),("3062811", "Vítkov", "", "CZ", "203", "", "85", "0805", "", "49.77445", "17.74941", "Europe/Prague"),("3062888", "Vimperk", "", "CZ", "203", "", "79", "0315", "", "49.05857", "13.78286", "Europe/Prague"),("3063032", "Veselí nad Moravou", "", "CZ", "203", "", "78", "0625", "", "48.95363", "17.37648", "Europe/Prague"),("3063033", "Veselí nad Lužnicí", "", "CZ", "203", "", "79", "0317", "", "49.1843", "14.69734", "Europe/Prague"),("3063196", "Velké Meziříčí", "", "CZ", "203", "", "80", "0615", "", "49.35522", "16.01224", "Europe/Prague"),("3063375", "Varnsdorf", "Варнсдорф", "CZ", "203", "", "89", "0421", "", "50.91154", "14.61824", "Europe/Prague"),("3063447", "Valašské Meziříčí", "Мезиржичи", "CZ", "203", "", "90", "0723", "", "49.47181", "17.97113", "Europe/Prague"),("3063448", "Valašské Klobouky", "", "CZ", "203", "", "90", "0724", "", "49.14064", "18.0076", "Europe/Prague"),("3063546", "Ústí nad Orlicí", "Усти-над-Орлици", "CZ", "203", "", "86", "0534", "", "49.97387", "16.39361", "Europe/Prague"),("3063548", "Ústí nad Labem", "Усти-над-Лабем", "CZ", "203", "", "89", "0427", "", "50.6607", "14.03227", "Europe/Prague"),("3063590", "Úpice", "", "CZ", "203", "", "82", "0525", "", "50.51237", "16.01607", "Europe/Prague"),("3063596", "Uničov", "", "CZ", "203", "", "84", "0712", "", "49.77092", "17.12144", "Europe/Prague"),("3063736", "Uherský Brod", "Угерски-Брод", "CZ", "203", "", "90", "0722", "", "49.02513", "17.64715", "Europe/Prague"),("3063739", "Uherské Hradiště", "Градиште", "CZ", "203", "", "90", "0722", "", "49.06975", "17.45969", "Europe/Prague"),("3063794", "Týn nad Vltavou", "", "CZ", "203", "", "79", "0311", "", "49.2234", "14.42057", "Europe/Prague"),("3063797", "Týniště nad Orlicí", "", "CZ", "203", "", "82", "0524", "", "50.15136", "16.0777", "Europe/Prague"),("3063804", "Týnec nad Sázavou", "", "CZ", "203", "", "88", "0201", "", "49.83348", "14.58983", "Europe/Prague"),("3063853", "Turnov", "", "CZ", "203", "", "83", "0514", "", "50.58356", "15.15186", "Europe/Prague"),("3063907", "Trutnov", "Трутнов", "CZ", "203", "", "82", "0525", "", "50.56101", "15.9127", "Europe/Prague"),("3064000", "Třinec", "Тршинец", "CZ", "203", "", "85", "0802", "", "49.67763", "18.67078", "Europe/Prague"),("3064029", "Třešť", "", "CZ", "203", "CZ", "80", "0612", "", "49.29092", "15.48211", "Europe/Prague"),("3064079", "Třeboň", "", "CZ", "203", "", "79", "0313", "", "49.00364", "14.77065", "Europe/Prague"),("3064104", "Třebíč", "Тршебич", "CZ", "203", "", "80", "0614", "", "49.21492", "15.88166", "Europe/Prague"),("3064122", "Třebechovice pod Orebem", "", "CZ", "203", "", "82", "0521", "", "50.20097", "15.99223", "Europe/Prague"),("3064211", "Tišnov", "", "CZ", "203", "", "78", "0623", "", "49.34872", "16.42438", "Europe/Prague"),("3064288", "Teplice", "Теплице", "CZ", "203", "", "89", "0426", "", "50.6404", "13.82451", "Europe/Prague"),("3064316", "Telč", "", "CZ", "203", "", "80", "0612", "", "49.18418", "15.45275", "Europe/Prague"),("3064358", "Tanvald", "", "CZ", "203", "", "83", "0512", "", "50.73735", "15.30585", "Europe/Prague"),("3064373", "Tachov", "", "CZ", "203", "", "87", "0327", "", "49.79528", "12.63365", "Europe/Prague"),("3064379", "Tábor", "Табор", "CZ", "203", "", "79", "0317", "", "49.41441", "14.6578", "Europe/Prague"),("3064454", "Svitavy", "Свитави", "CZ", "203", "", "86", "0533", "", "49.75594", "16.46829", "Europe/Prague"),("3064510", "Světlá nad Sázavou", "", "CZ", "203", "", "80", "0611", "", "49.66801", "15.40393", "Europe/Prague"),("3064662", "Sušice", "", "CZ", "203", "", "87", "0322", "", "49.23106", "13.52018", "Europe/Prague"),("3064673", "Šumperk", "Шумперк", "CZ", "203", "", "84", "0715", "", "49.96528", "16.97061", "Europe/Prague"),("3064807", "Studénka", "", "CZ", "203", "", "85", "0804", "", "49.72342", "18.07853", "Europe/Prague"),("3064894", "Střížkov", "", "CZ", "203", "", "52", "8378777", "", "50.12674", "14.49363", "Europe/Prague"),("3064919", "Stříbro", "", "CZ", "203", "", "87", "0327", "", "49.75565", "12.997", "Europe/Prague"),("3064995", "Strážnice", "", "CZ", "203", "", "78", "0625", "", "48.90102", "17.3168", "Europe/Prague"),("3065067", "Strakonice", "Страконице", "CZ", "203", "", "79", "0316", "", "49.26141", "13.90237", "Europe/Prague"),("3065117", "Stochov", "", "CZ", "203", "", "88", "0203", "", "50.14631", "13.96345", "Europe/Prague"),("3065163", "Štětí", "", "CZ", "203", "", "89", "0423", "", "50.45298", "14.37421", "Europe/Prague"),("3065166", "Šternberk", "", "CZ", "203", "", "84", "0712", "", "49.73044", "17.29889", "Europe/Prague"),("3065281", "Starý Bohumín", "", "CZ", "203", "", "85", "0803", "", "49.9169", "18.33619", "Europe/Prague"),("3065328", "Staré Město", "", "CZ", "203", "", "52", "8378769", "", "50.087", "14.42024", "Europe/Prague"),("3065335", "Staré Město", "", "CZ", "203", "", "90", "0722", "", "49.07515", "17.43338", "Europe/Prague"),("3065617", "Sokolov", "Соколов", "CZ", "203", "", "81", "0413", "", "50.1813", "12.6401", "Europe/Prague"),("3065644", "Soběslav", "", "CZ", "203", "", "79", "0317", "", "49.25993", "14.71861", "Europe/Prague"),("3065768", "Šluknov", "", "CZ", "203", "", "89", "0421", "", "51.00369", "14.45258", "Europe/Prague"),("3065824", "Slavkov u Brna", "", "CZ", "203", "", "78", "0626", "", "49.15325", "16.87649", "Europe/Prague"),("3065843", "Slavičín", "", "CZ", "203", "", "90", "0724", "", "49.08799", "17.87349", "Europe/Prague"),("3065901", "Šlapanice", "", "CZ", "203", "", "78", "0623", "", "49.16863", "16.72731", "Europe/Prague"),("3065903", "Slaný", "", "CZ", "203", "", "88", "0203", "", "50.23046", "14.08693", "Europe/Prague"),("3065921", "Skuteč", "", "CZ", "203", "", "86", "0531", "", "49.84347", "15.99655", "Europe/Prague"),("3066154", "Sezimovo Ústí", "", "CZ", "203", "", "79", "0317", "", "49.38519", "14.6848", "Europe/Prague"),("3066184", "Šenov", "", "CZ", "203", "", "85", "0806", "", "49.79315", "18.37607", "Europe/Prague"),("3066220", "Semily", "", "CZ", "203", "", "83", "0514", "", "50.60191", "15.33552", "Europe/Prague"),("3066333", "Sedlčany", "", "CZ", "203", "", "88", "020B", "", "49.66057", "14.42664", "Europe/Prague"),("3066483", "Rýmařov", "", "CZ", "203", "CZ", "85", "0801", "", "49.93183", "17.27177", "Europe/Prague"),("3066492", "Rychvald", "", "CZ", "203", "", "85", "0803", "", "49.86625", "18.37626", "Europe/Prague"),("3066503", "Rychnov nad Kněžnou", "", "CZ", "203", "", "82", "0524", "", "50.16284", "16.27488", "Europe/Prague"),("3066578", "Rumburk", "", "CZ", "203", "", "89", "0421", "", "50.95151", "14.55699", "Europe/Prague"),("3066636", "Roztoky", "", "CZ", "203", "", "88", "020A", "", "50.15841", "14.3976", "Europe/Prague"),("3066651", "Rožnov pod Radhoštěm", "", "CZ", "203", "", "90", "0723", "", "49.45853", "18.14302", "Europe/Prague"),("3066719", "Rousínov", "", "CZ", "203", "", "78", "0626", "", "49.20128", "16.88215", "Europe/Prague"),("3066727", "Roudnice nad Labem", "", "CZ", "203", "", "89", "0423", "", "50.42528", "14.26175", "Europe/Prague"),("3066759", "Rosice", "", "CZ", "203", "", "78", "0623", "", "49.18232", "16.38787", "Europe/Prague"),("3066794", "Rokycany", "", "CZ", "203", "", "87", "0326", "", "49.7427", "13.59459", "Europe/Prague"),("3066878", "Říčany", "", "CZ", "203", "", "88", "0209", "", "49.99168", "14.65427", "Europe/Prague"),("3067051", "Rakovník", "", "CZ", "203", "", "88", "020C", "", "50.1037", "13.7334", "Europe/Prague"),("3067395", "Protivín", "", "CZ", "203", "", "79", "0314", "", "49.19949", "14.21717", "Europe/Prague"),("3067421", "Prostějov", "Простейов", "CZ", "203", "", "84", "0713", "", "49.47188", "17.11184", "Europe/Prague"),("3067433", "Prosek", "", "CZ", "203", "", "52", "8378777", "", "50.11525", "14.50685", "Europe/Prague"),("3067542", "Příbram", "Пршибрам", "CZ", "203", "", "88", "020B", "", "49.68988", "14.01043", "Europe/Prague"),("3067544", "Příbor", "", "CZ", "203", "", "85", "0804", "", "49.64094", "18.14499", "Europe/Prague"),("3067553", "Přeštice", "", "CZ", "203", "", "87", "0324", "", "49.57298", "13.3335", "Europe/Prague"),("3067580", "Přerov", "Преров", "CZ", "203", "", "84", "0714", "", "49.45511", "17.4509", "Europe/Prague"),("3067594", "Přelouč", "", "CZ", "203", "", "86", "0532", "", "50.03985", "15.56031", "Europe/Prague"),("3067696", "Prague", "Прага", "CZ", "203", "", "52", "", "", "50.08804", "14.42076", "Europe/Prague"),("3067713", "Prachatice", "", "CZ", "203", "", "79", "0315", "", "49.01292", "13.99752", "Europe/Prague"),("3067870", "Polná", "", "CZ", "203", "", "80", "0612", "", "49.487", "15.71881", "Europe/Prague"),("3067882", "Polička", "", "CZ", "203", "", "86", "0533", "", "49.71465", "16.26543", "Europe/Prague"),("3068107", "Poděbrady", "", "CZ", "203", "", "88", "0208", "", "50.14242", "15.11881", "Europe/Prague"),("3068119", "Podbořany", "", "CZ", "203", "", "89", "0424", "", "50.22937", "13.41192", "Europe/Prague"),("3068160", "Pilsen", "Пльзень", "CZ", "203", "", "87", "0323", "", "49.74747", "13.37759", "Europe/Prague"),("3068246", "Planá", "", "CZ", "203", "", "87", "0327", "", "49.86816", "12.74378", "Europe/Prague"),("3068293", "Písek", "Писек", "CZ", "203", "", "79", "0314", "", "49.3088", "14.1475", "Europe/Prague"),("3068329", "Petřvald", "", "CZ", "203", "", "85", "0803", "", "49.831", "18.3894", "Europe/Prague"),("3068445", "Pelhřimov", "", "CZ", "203", "", "80", "0613", "", "49.43134", "15.22336", "Europe/Prague"),("3068582", "Pardubice", "Пардубице", "CZ", "203", "", "86", "0532", "", "50.04075", "15.77659", "Europe/Prague"),("3068647", "Pacov", "", "CZ", "203", "", "80", "0613", "", "49.47076", "15.00168", "Europe/Prague"),("3068689", "Otrokovice", "", "CZ", "203", "", "90", "0724", "", "49.21667", "17.51667", "Europe/Prague"),("3068690", "Otrokovice", "", "CZ", "203", "CZ", "90", "0724", "", "49.20934", "17.53944", "Europe/Prague"),("3068766", "Ostrov", "Остров", "CZ", "203", "", "81", "0412", "", "50.30592", "12.93907", "Europe/Prague"),("3068799", "Ostrava", "Острава", "CZ", "203", "", "85", "0806", "", "49.83465", "18.28204", "Europe/Prague"),("3068873", "Orlová", "Орлова", "CZ", "203", "", "85", "0803", "", "49.84527", "18.43011", "Europe/Prague"),("3068927", "Opava", "Опава", "CZ", "203", "", "85", "0805", "", "49.93866", "17.90257", "Europe/Prague"),("3069011", "Olomouc", "Оломоуц", "CZ", "203", "", "84", "0712", "", "49.59552", "17.25175", "Europe/Prague"),("3069136", "Odry", "", "CZ", "203", "", "85", "0804", "", "49.66255", "17.83084", "Europe/Prague"),("3069230", "Nýrsko", "", "CZ", "203", "", "87", "0322", "", "49.29387", "13.14353", "Europe/Prague"),("3069232", "Nýřany", "", "CZ", "203", "", "87", "0325", "", "49.71145", "13.21185", "Europe/Prague"),("3069236", "Nymburk", "", "CZ", "203", "", "88", "0208", "", "50.18605", "15.04167", "Europe/Prague"),("3069305", "Nový Jičín", "", "CZ", "203", "", "85", "0804", "", "49.59438", "18.01028", "Europe/Prague"),("3069377", "Nový Bydžov", "", "CZ", "203", "", "82", "0521", "", "50.2415", "15.49082", "Europe/Prague"),("3069381", "Nový Bor", "", "CZ", "203", "", "83", "0511", "", "50.75761", "14.55555", "Europe/Prague"),("3069431", "Nové Strašecí", "", "CZ", "203", "", "88", "020C", "", "50.15272", "13.90043", "Europe/Prague"),("3069465", "Nové Město na Moravě", "", "CZ", "203", "", "80", "0615", "", "49.56144", "16.07418", "Europe/Prague"),("3069466", "Nové Město nad Metují", "", "CZ", "203", "", "82", "0523", "", "50.34456", "16.15147", "Europe/Prague"),("3069669", "Nová Paka", "", "CZ", "203", "", "82", "0522", "", "50.49449", "15.51503", "Europe/Prague"),("3069844", "Neratovice", "", "CZ", "203", "", "88", "0206", "", "50.25926", "14.51759", "Europe/Prague"),("3069934", "Nejdek", "", "CZ", "203", "", "81", "0412", "", "50.32242", "12.72936", "Europe/Prague"),("3070045", "Napajedla", "", "CZ", "203", "", "90", "0724", "", "49.17156", "17.51194", "Europe/Prague"),("3070055", "Náměšť nad Oslavou", "", "CZ", "203", "CZ", "80", "0614", "", "49.20726", "16.15849", "Europe/Prague"),("3070122", "Náchod", "", "CZ", "203", "", "82", "0523", "", "50.4167", "16.16289", "Europe/Prague"),("3070291", "Most", "Мост", "CZ", "203", "", "89", "0425", "", "50.50301", "13.63617", "Europe/Prague"),("3070310", "Moravský Krumlov", "", "CZ", "203", "", "78", "0627", "", "49.04893", "16.31169", "Europe/Prague"),("3070323", "Moravské Budějovice", "", "CZ", "203", "", "80", "0614", "", "49.05209", "15.80864", "Europe/Prague"),("3070325", "Moravská Třebová", "", "CZ", "203", "", "86", "0533", "", "49.75793", "16.66426", "Europe/Prague"),("3070409", "Mohelnice", "", "CZ", "203", "", "84", "0715", "", "49.77698", "16.91946", "Europe/Prague"),("3070420", "Modřany", "Модржаны", "CZ", "203", "CZ", "52", "8378780", "", "50.01116", "14.4096", "Europe/Prague"),("3070451", "Mnichovo Hradiště", "", "CZ", "203", "", "88", "0207", "", "50.5272", "14.97134", "Europe/Prague"),("3070544", "Mladá Boleslav", "Млада-Болеслав", "CZ", "203", "", "88", "0207", "", "50.41135", "14.90318", "Europe/Prague"),("3070622", "Mimoň", "", "CZ", "203", "", "83", "0511", "", "50.65869", "14.72474", "Europe/Prague"),("3070628", "Milovice", "", "CZ", "203", "", "88", "0208", "", "50.22596", "14.88863", "Europe/Prague"),("3070678", "Milevsko", "", "CZ", "203", "", "79", "0314", "", "49.45089", "14.36", "Europe/Prague"),("3070720", "Mikulov", "", "CZ", "203", "", "78", "0624", "", "48.80556", "16.6378", "Europe/Prague"),("3070862", "Mělník", "Мельник", "CZ", "203", "", "88", "0206", "", "50.3505", "14.47411", "Europe/Prague"),("3071024", "Mariánské Lázně", "", "CZ", "203", "", "81", "0411", "", "49.96459", "12.70118", "Europe/Prague"),("3071213", "Malá Strana", "", "CZ", "203", "", "52", "8378769", "", "50.08774", "14.40449", "Europe/Prague"),("3071304", "Lysá nad Labem", "", "CZ", "203", "", "88", "0208", "", "50.20143", "14.83281", "Europe/Prague"),("3071407", "Luhačovice", "", "CZ", "203", "", "90", "0724", "", "49.09982", "17.75747", "Europe/Prague"),("3071480", "Lovosice", "", "CZ", "203", "", "89", "0423", "", "50.51504", "14.05103", "Europe/Prague"),("3071507", "Louny", "Лоуни", "CZ", "203", "", "89", "0424", "", "50.35699", "13.79667", "Europe/Prague"),("3071606", "Lomnice nad Popelkou", "", "CZ", "203", "", "83", "0514", "", "50.53062", "15.37341", "Europe/Prague"),("3071665", "Litvínov", "Литвинов", "CZ", "203", "", "89", "0425", "", "50.6042", "13.61812", "Europe/Prague"),("3071669", "Litovel", "", "CZ", "203", "", "84", "0712", "", "49.70121", "17.07615", "Europe/Prague"),("3071675", "Litomyšl", "", "CZ", "203", "", "86", "0533", "", "49.86809", "16.31298", "Europe/Prague"),("3071677", "Litoměřice", "Литомержице", "CZ", "203", "", "89", "0423", "", "50.53348", "14.1318", "Europe/Prague"),("3071791", "Lipník nad Bečvou", "", "CZ", "203", "", "84", "0714", "", "49.52721", "17.58594", "Europe/Prague"),("3071961", "Liberec", "Либерец", "CZ", "203", "", "83", "0513", "", "50.76711", "15.05619", "Europe/Prague"),("3071966", "Libeň", "", "CZ", "203", "", "52", "8378776", "", "50.10819", "14.47457", "Europe/Prague"),("3072130", "Letovice", "", "CZ", "203", "", "78", "0621", "", "49.54709", "16.57357", "Europe/Prague"),("3072134", "Letohrad", "", "CZ", "203", "", "86", "0534", "", "50.0358", "16.49879", "Europe/Prague"),("3072137", "Letňany", "", "CZ", "203", "CZ", "52", "8378788", "", "50.13333", "14.51667", "Europe/Prague"),("3072235", "Ledeč nad Sázavou", "", "CZ", "203", "", "80", "0611", "", "49.69517", "15.27772", "Europe/Prague"),("3072332", "Lanškroun", "", "CZ", "203", "", "86", "0534", "", "49.91217", "16.6119", "Europe/Prague"),("3072394", "Kynšperk nad Ohří", "", "CZ", "203", "", "81", "0413", "", "50.11893", "12.53027", "Europe/Prague"),("3072407", "Kyjov", "", "CZ", "203", "CZ", "78", "0625", "", "49.01018", "17.12253", "Europe/Prague"),("3072463", "Kutná Hora", "Кутна-Гора", "CZ", "203", "", "88", "0205", "", "49.94839", "15.26816", "Europe/Prague"),("3072476", "Kuřim", "", "CZ", "203", "", "78", "0623", "", "49.29852", "16.53144", "Europe/Prague"),("3072497", "Kunovice", "", "CZ", "203", "", "90", "0722", "", "49.04499", "17.47011", "Europe/Prague"),("3072598", "Krupka", "", "CZ", "203", "", "89", "0426", "", "50.68449", "13.85815", "Europe/Prague"),("3072649", "Kroměříž", "Кромнержиж", "CZ", "203", "", "90", "0721", "", "49.29785", "17.39312", "Europe/Prague"),("3072656", "Krnov", "Крнов", "CZ", "203", "", "85", "0801", "", "50.08967", "17.70385", "Europe/Prague"),("3072841", "Kravaře", "", "CZ", "203", "", "85", "0805", "", "49.93203", "18.00472", "Europe/Prague"),("3072903", "Kraslice", "", "CZ", "203", "", "81", "0413", "", "50.32372", "12.51747", "Europe/Prague"),("3072927", "Králův Dvůr", "", "CZ", "203", "CZ", "88", "0202", "", "49.94981", "14.03445", "Europe/Prague"),("3072929", "Kralupy nad Vltavou", "Кралупи-над-Влтавой", "CZ", "203", "", "88", "", "", "50.24107", "14.31149", "Europe/Prague"),("3073149", "Kostelec nad Orlicí", "", "CZ", "203", "", "82", "0524", "", "50.12267", "16.21319", "Europe/Prague"),("3073254", "Kopřivnice", "Копршивницах", "CZ", "203", "", "85", "0804", "", "49.59947", "18.1448", "Europe/Prague"),("3073371", "Kolín", "Колин", "CZ", "203", "", "88", "0204", "", "50.02806", "15.1998", "Europe/Prague"),("3073407", "Kojetín", "", "CZ", "203", "", "84", "0714", "", "49.35179", "17.30207", "Europe/Prague"),("3073660", "Klatovy", "Клатовы", "CZ", "203", "", "87", "0322", "", "49.39552", "13.29505", "Europe/Prague"),("3073668", "Klášterec nad Ohří", "", "CZ", "203", "", "89", "0422", "", "50.3886", "13.18342", "Europe/Prague"),("3073699", "Kladno", "Кладно", "CZ", "203", "", "88", "0203", "", "50.14734", "14.10285", "Europe/Prague"),("3073743", "Kbely", "", "CZ", "203", "", "52", "8378789", "", "50.13333", "14.55", "Europe/Prague"),("3073789", "Karviná", "Карвина", "CZ", "203", "", "85", "0803", "", "49.854", "18.54169", "Europe/Prague"),("3073803", "Karlovy Vary", "Карловы Вары", "CZ", "203", "", "81", "0412", "", "50.23271", "12.87117", "Europe/Prague"),("3073838", "Karlín", "", "CZ", "203", "CZ", "52", "8378776", "", "50.09272", "14.44711", "Europe/Prague"),("3073862", "Kaplice", "", "CZ", "203", "", "79", "0312", "", "48.73881", "14.49449", "Europe/Prague"),("3074020", "Kadaň", "", "CZ", "203", "", "89", "", "", "50.38333", "13.26667", "Europe/Prague"),("3074110", "Jirkov", "Йирков", "CZ", "203", "", "89", "0422", "", "50.49979", "13.44769", "Europe/Prague"),("3074149", "Jindřichův Hradec", "Йиндржихув-Градец", "CZ", "203", "", "79", "0313", "", "49.14404", "15.00301", "Europe/Prague"),("3074181", "Jílové", "", "CZ", "203", "", "89", "0421", "", "50.76082", "14.10383", "Europe/Prague"),("3074187", "Jilemnice", "", "CZ", "203", "", "83", "0514", "", "50.6089", "15.50653", "Europe/Prague"),("3074199", "Jihlava", "Йиглава", "CZ", "203", "", "80", "0612", "", "49.3961", "15.59124", "Europe/Prague"),("3074204", "Jičín", "Йичин", "CZ", "203", "", "82", "0522", "", "50.43723", "15.35162", "Europe/Prague"),("3074281", "Jeseník", "", "CZ", "203", "", "84", "0711", "", "50.22937", "17.20464", "Europe/Prague"),("3074462", "Jaroměř", "", "CZ", "203", "", "82", "0523", "", "50.3562", "15.92136", "Europe/Prague"),("3074593", "Jablunkov", "", "CZ", "203", "", "85", "0802", "", "49.57672", "18.76458", "Europe/Prague"),("3074603", "Jablonec nad Nisou", "Яблонец", "CZ", "203", "", "83", "0512", "", "50.72431", "15.17108", "Europe/Prague"),("3074615", "Ivančice", "", "CZ", "203", "", "78", "0623", "", "49.10144", "16.37752", "Europe/Prague"),("3074677", "Hustopeče", "", "CZ", "203", "", "78", "0624", "", "48.94085", "16.73762", "Europe/Prague"),("3074723", "Humpolec", "", "CZ", "203", "", "80", "0613", "", "49.54152", "15.35932", "Europe/Prague"),("3074731", "Hulín", "", "CZ", "203", "", "90", "0721", "", "49.31689", "17.46374", "Europe/Prague"),("3074805", "Hronov", "", "CZ", "203", "", "82", "0523", "", "50.47968", "16.1823", "Europe/Prague"),("3074893", "Hranice", "Границе", "CZ", "203", "", "84", "0714", "", "49.54796", "17.73469", "Europe/Prague"),("3074944", "Hrádek nad Nisou", "", "CZ", "203", "", "83", "0513", "", "50.85279", "14.84455", "Europe/Prague"),("3074967", "Hradec Králové", "Градец Кралове", "CZ", "203", "", "82", "0521", "", "50.20923", "15.83277", "Europe/Prague"),("3074975", "Hradec nad Moravici", "", "CZ", "203", "", "85", "0805", "", "49.87042", "17.87843", "Europe/Prague"),("3075119", "Hořovice", "", "CZ", "203", "", "88", "0202", "", "49.83597", "13.90268", "Europe/Prague"),("3075208", "Horní Slavkov", "", "CZ", "203", "", "81", "0413", "", "50.13863", "12.80758", "Europe/Prague"),("3075257", "Horní Počernice", "", "CZ", "203", "CZ", "52", "8378790", "", "50.1121", "14.61036", "Europe/Prague"),("3075493", "Hořice", "", "CZ", "203", "", "82", "0522", "", "50.36609", "15.63183", "Europe/Prague"),("3075522", "Horažďovice", "", "CZ", "203", "CZ", "87", "0322", "", "49.32069", "13.701", "Europe/Prague"),("3075599", "Holice", "", "CZ", "203", "", "86", "0532", "", "50.06601", "15.9859", "Europe/Prague"),("3075606", "Holešov", "", "CZ", "203", "", "90", "0721", "", "49.33331", "17.57832", "Europe/Prague"),("3075654", "Hodonín", "Годонин", "CZ", "203", "", "78", "0625", "", "48.84893", "17.13244", "Europe/Prague"),("3075716", "Hlučín", "", "CZ", "203", "", "85", "0805", "", "49.89795", "18.19196", "Europe/Prague"),("3075766", "Hlinsko", "", "CZ", "203", "", "86", "0531", "", "49.76213", "15.90756", "Europe/Prague"),("3075919", "Havlíčkův Brod", "Гавличкув-Брод", "CZ", "203", "", "80", "0611", "", "49.60785", "15.58069", "Europe/Prague"),("3075921", "Havířov", "Гавиржов", "CZ", "203", "", "85", "", "", "49.77984", "18.43688", "Europe/Prague"),("3076076", "Habartov", "", "CZ", "203", "", "81", "0413", "", "50.18297", "12.55054", "Europe/Prague"),("3076116", "Fulnek", "", "CZ", "203", "", "85", "0804", "", "49.71238", "17.90319", "Europe/Prague"),("3076123", "Frýdlant nad Ostravicí", "", "CZ", "203", "", "85", "0802", "", "49.5928", "18.35967", "Europe/Prague"),("3076124", "Frýdlant", "", "CZ", "203", "", "83", "0513", "", "50.92139", "15.07974", "Europe/Prague"),("3076127", "Frýdek-Místek", "Мистек", "CZ", "203", "", "85", "0802", "", "49.68333", "18.35", "Europe/Prague"),("3076132", "Frenštát pod Radhoštěm", "", "CZ", "203", "", "85", "0804", "", "49.54835", "18.21078", "Europe/Prague"),("3076136", "Františkovy Lázně", "", "CZ", "203", "", "81", "0411", "", "50.12033", "12.35174", "Europe/Prague"),("3076311", "Duchcov", "", "CZ", "203", "", "89", "0426", "", "50.60376", "13.74621", "Europe/Prague"),("3076329", "Dubňany", "", "CZ", "203", "", "78", "0625", "", "48.91694", "17.09004", "Europe/Prague"),("3076346", "Dubí", "", "CZ", "203", "", "89", "0426", "", "50.68558", "13.78561", "Europe/Prague"),("3076587", "Domažlice", "", "CZ", "203", "", "87", "0321", "", "49.44049", "12.92976", "Europe/Prague"),("3076972", "Doksy", "", "CZ", "203", "", "83", "0511", "", "50.56471", "14.65553", "Europe/Prague"),("3076985", "Dobruška", "", "CZ", "203", "", "82", "0524", "", "50.29201", "16.16001", "Europe/Prague"),("3077024", "Dobříš", "", "CZ", "203", "", "88", "020B", "", "49.78113", "14.16717", "Europe/Prague"),("3077073", "Dobřany", "", "CZ", "203", "", "87", "0324", "", "49.65482", "13.29307", "Europe/Prague"),("3077244", "Děčín", "Дечин", "CZ", "203", "", "89", "0421", "", "50.78215", "14.21478", "Europe/Prague"),("3077304", "Dačice", "", "CZ", "203", "", "79", "0313", "", "49.08154", "15.43727", "Europe/Prague"),("3077539", "Chrudim", "Хрудим", "CZ", "203", "", "86", "0531", "", "49.95109", "15.79558", "Europe/Prague"),("3077549", "Chropyně", "", "CZ", "203", "", "90", "0721", "", "49.35644", "17.36451", "Europe/Prague"),("3077584", "Chrastava", "", "CZ", "203", "", "83", "0513", "", "50.81693", "14.96884", "Europe/Prague"),("3077669", "Chotěboř", "", "CZ", "203", "", "80", "0611", "", "49.72072", "15.67018", "Europe/Prague"),("3077685", "Chomutov", "Хомутов", "CZ", "203", "", "89", "0422", "", "50.46048", "13.41779", "Europe/Prague"),("3077706", "Chodov", "", "CZ", "203", "", "81", "0413", "", "50.24018", "12.74551", "Europe/Prague"),("3077725", "Choceň", "", "CZ", "203", "", "86", "0534", "", "50.00161", "16.22303", "Europe/Prague"),("3077751", "Chlumec nad Cidlinou", "", "CZ", "203", "", "82", "0521", "", "50.1544", "15.46026", "Europe/Prague"),("3077835", "Cheb", "Хеб", "CZ", "203", "", "81", "0411", "", "50.07963", "12.37392", "Europe/Prague"),("3077882", "Český Těšín", "Чески-Тешин", "CZ", "203", "", "85", "", "", "49.74613", "18.62613", "Europe/Prague"),("3077889", "Český Krumlov", "", "CZ", "203", "", "79", "0312", "", "48.81091", "14.31521", "Europe/Prague"),("3077898", "Český Brod", "", "CZ", "203", "", "88", "0204", "", "50.0742", "14.86081", "Europe/Prague"),("3077916", "České Budějovice", "Ческе-Будеёвице", "CZ", "203", "", "79", "0311", "", "48.97447", "14.47434", "Europe/Prague"),("3077920", "Česká Třebová", "Ческа-Тршебова", "CZ", "203", "", "86", "0534", "", "49.90436", "16.44413", "Europe/Prague"),("3077921", "Česká Skalice", "", "CZ", "203", "", "82", "0523", "", "50.39467", "16.04276", "Europe/Prague"),("3077929", "Česká Lípa", "Ческа-Липа", "CZ", "203", "", "83", "0511", "", "50.68551", "14.53764", "Europe/Prague"),("3077932", "Česká Kamenice", "", "CZ", "203", "", "89", "0421", "", "50.7978", "14.41767", "Europe/Prague"),("3077955", "Červený Kostelec", "", "CZ", "203", "", "82", "0523", "", "50.47626", "16.09289", "Europe/Prague"),("3078160", "Čelákovice", "", "CZ", "203", "", "88", "0209", "", "50.16038", "14.75005", "Europe/Prague"),("3078234", "Čáslav", "", "CZ", "203", "", "88", "0205", "", "49.91099", "15.38972", "Europe/Prague"),("3078286", "Bystřice pod Hostýnem", "", "CZ", "203", "", "90", "0721", "", "49.39924", "17.67401", "Europe/Prague"),("3078288", "Bystřice nad Pernštejnem", "", "CZ", "203", "", "80", "0615", "", "49.52295", "16.26147", "Europe/Prague"),("3078301", "Bystřice", "", "CZ", "203", "", "85", "0802", "", "49.63657", "18.72038", "Europe/Prague"),("3078503", "Bučovice", "", "CZ", "203", "", "78", "0626", "", "49.14896", "17.00191", "Europe/Prague"),("3078545", "Bruntál", "", "CZ", "203", "", "85", "0801", "", "49.98844", "17.4647", "Europe/Prague"),("3078577", "Broumov", "", "CZ", "203", "", "82", "0523", "", "50.58566", "16.33181", "Europe/Prague"),("3078610", "Brno", "Брно", "CZ", "203", "", "78", "0622", "", "49.19522", "16.60796", "Europe/Prague"),("3078773", "Břeclav", "Бржецлав", "CZ", "203", "", "78", "0624", "", "48.75897", "16.88203", "Europe/Prague"),("3078833", "Braník", "", "CZ", "203", "", "52", "", "", "50.03498", "14.41518", "Europe/Prague"),("3078837", "Brandýs nad Labem-Stará Boleslav", "", "CZ", "203", "", "88", "0209", "", "50.18709", "14.66326", "Europe/Prague"),("3078910", "Boskovice", "", "CZ", "203", "", "78", "0621", "", "49.48751", "16.65997", "Europe/Prague"),("3079129", "Bohumín", "Богумин", "CZ", "203", "", "85", "0803", "", "49.90411", "18.35755", "Europe/Prague"),("3079252", "Blatná", "", "CZ", "203", "", "79", "0316", "", "49.42489", "13.88176", "Europe/Prague"),("3079273", "Blansko", "Бланско", "CZ", "203", "", "78", "0621", "", "49.36304", "16.64446", "Europe/Prague"),("3079336", "Bílovec", "", "CZ", "203", "", "85", "0804", "", "49.75639", "18.01581", "Europe/Prague"),("3079346", "Bílina Kyselka", "", "CZ", "203", "", "89", "0426", "", "50.55", "13.76667", "Europe/Prague"),("3079348", "Bílina", "Билина", "CZ", "203", "CZ", "89", "0426", "", "50.54854", "13.77535", "Europe/Prague"),("3079467", "Beroun", "Бероун", "CZ", "203", "", "88", "0202", "", "49.96382", "14.072", "Europe/Prague"),("3079508", "Benešov", "Бенешов", "CZ", "203", "", "88", "0201", "", "49.78162", "14.68697", "Europe/Prague"),("3079514", "Benátky nad Jizerou", "", "CZ", "203", "", "88", "0207", "", "50.29085", "14.82343", "Europe/Prague"),("3079616", "Bechyně", "", "CZ", "203", "", "79", "0317", "", "49.29523", "14.4681", "Europe/Prague"),("3079751", "Aš", "", "CZ", "203", "CZ", "81", "0411", "", "50.22387", "12.19499", "Europe/Prague"),("6269470", "Černý Most", "", "CZ", "203", "", "52", "", "", "50.10475", "14.57974", "Europe/Prague"),("2803476", "Zwönitz", "", "DE", "276", "", "13", "00", "14521", "50.63027", "12.80999", "Europe/Berlin"),("2803515", "Zwingenberg", "", "DE", "276", "", "05", "064", "06431", "49.72389", "8.61084", "Europe/Berlin"),("2803537", "Zwiesel", "", "DE", "276", "", "02", "092", "09276", "49.01693", "13.23765", "Europe/Berlin"),("2803560", "Zwickau", "Цвиккау", "DE", "276", "", "13", "00", "14524", "50.72724", "12.48839", "Europe/Berlin"),("2803588", "Zwenkau", "", "DE", "276", "", "13", "00", "14729", "51.21872", "12.33008", "Europe/Berlin"),("2803620", "Zweibrücken", "Цвайбрюккен", "DE", "276", "", "08", "00", "07320", "49.24686", "7.36977", "Europe/Berlin"),("2803655", "Zusmarshausen", "", "DE", "276", "", "02", "097", "09772", "48.40014", "10.59917", "Europe/Berlin"),("2803723", "Zulpich", "Цюльпих", "DE", "276", "", "07", "053", "05366", "50.69447", "6.65414", "Europe/Berlin"),("2803786", "Zschorlau", "", "DE", "276", "", "13", "00", "14521", "50.56667", "12.65", "Europe/Berlin"),("2803798", "Zschopau", "", "DE", "276", "", "13", "00", "14521", "50.74818", "13.07691", "Europe/Berlin"),("2803870", "Zossen", "Цоссен", "DE", "276", "", "11", "00", "12072", "52.216", "13.44909", "Europe/Berlin"),("2803884", "Zorneding", "", "DE", "276", "", "02", "091", "09175", "48.08433", "11.82446", "Europe/Berlin"),("2804008", "Zittau", "Циттау", "DE", "276", "", "13", "00", "14626", "50.89772", "14.80764", "Europe/Berlin"),("2804034", "Zirndorf", "Цирндорф", "DE", "276", "", "02", "095", "09573", "49.4424", "10.95414", "Europe/Berlin"),("2804159", "Zimmern ob Rottweil", "", "DE", "276", "", "01", "083", "08325", "48.1666", "8.59436", "Europe/Berlin"),("2804297", "Zierenberg", "", "DE", "276", "", "05", "066", "06633", "51.36948", "9.30164", "Europe/Berlin"),("2804642", "Zeven", "", "DE", "276", "", "06", "00", "03357", "53.29657", "9.27685", "Europe/Berlin"),("2804646", "Zeuthen", "", "DE", "276", "", "11", "00", "12061", "52.36667", "13.61667", "Europe/Berlin"),("2804654", "Zeulenroda", "", "DE", "276", "", "15", "00", "16076", "50.65278", "11.98377", "Europe/Berlin"),("2804697", "Zetel", "", "DE", "276", "", "06", "00", "03455", "53.41667", "7.98333", "Europe/Berlin"),("2804748", "Zerbst", "Цербст", "DE", "276", "", "14", "00", "15082", "51.9662", "12.08517", "Europe/Berlin"),("2804808", "Zellingen", "", "DE", "276", "", "02", "096", "09677", "49.89737", "9.81746", "Europe/Berlin"),("2804810", "Zell im Wiesental", "", "DE", "276", "", "01", "083", "08336", "47.70555", "7.85248", "Europe/Berlin"),("2804867", "Zella-Mehlis", "", "DE", "276", "", "15", "00", "16066", "50.65642", "10.66046", "Europe/Berlin"),("2804895", "Zell", "", "DE", "276", "", "01", "082", "08216", "48.69235", "8.06301", "Europe/Berlin"),("2804922", "Zeitz", "Цайц", "DE", "276", "", "14", "00", "15084", "51.04962", "12.1369", "Europe/Berlin"),("2804933", "Zeitlarn", "", "DE", "276", "", "02", "093", "09375", "49.07848", "12.11174", "Europe/Berlin"),("2805008", "Zeil", "", "DE", "276", "", "02", "096", "09674", "50.00986", "10.5947", "Europe/Berlin"),("2805059", "Zehlendorf", "Целендорф", "DE", "276", "", "16", "00", "11000", "52.43333", "13.25", "Europe/Berlin"),("2805075", "Zehdenick", "", "DE", "276", "", "11", "00", "12065", "52.97852", "13.33165", "Europe/Berlin"),("2805228", "Zapfendorf", "", "DE", "276", "", "02", "094", "09471", "50.01783", "10.93243", "Europe/Berlin"),("2805385", "Xanten", "Ксантен", "DE", "276", "", "07", "051", "05170", "51.65877", "6.45297", "Europe/Berlin"),("2805419", "Wutöschingen", "", "DE", "276", "", "01", "083", "08337", "47.66667", "8.36667", "Europe/Berlin"),("2805480", "Wustermark", "", "DE", "276", "", "11", "00", "12063", "52.55", "12.95", "Europe/Berlin"),("2805483", "Wusterhausen", "", "DE", "276", "", "11", "00", "12068", "52.8912", "12.46021", "Europe/Berlin"),("2805497", "Wüstenrot", "", "DE", "276", "", "01", "081", "08125", "49.08083", "9.46056", "Europe/Berlin"),("2805597", "Wurzen", "Вурцен", "DE", "276", "", "13", "00", "14729", "51.3707", "12.73939", "Europe/Berlin"),("2805615", "Würzburg", "Вюрцбург", "DE", "276", "", "02", "096", "09663", "49.79391", "9.95121", "Europe/Berlin"),("2805644", "Würselen", "Вюрзелен", "DE", "276", "", "07", "053", "05334", "50.81809", "6.1347", "Europe/Berlin"),("2805753", "Wuppertal", "Вупперталь", "DE", "276", "", "07", "051", "05124", "51.27027", "7.16755", "Europe/Berlin"),("2805761", "Wunstorf", "Вунсторф", "DE", "276", "", "06", "00", "03241", "52.42377", "9.43585", "Europe/Berlin"),("2805762", "Wunsiedel", "", "DE", "276", "", "02", "094", "09479", "50.03923", "12.00342", "Europe/Berlin"),("2805785", "Wünnenberg", "", "DE", "276", "", "07", "057", "05774", "51.52002", "8.69934", "Europe/Berlin"),("2805910", "Wülfrath", "Вюльфрат", "DE", "276", "", "07", "051", "05158", "51.28195", "7.03821", "Europe/Berlin"),("2805999", "Wriezen", "", "DE", "276", "", "11", "00", "12064", "52.72091", "14.13425", "Europe/Berlin"),("2806081", "Wörth am Rhein", "Вёрт-на-Рейне", "DE", "276", "", "08", "00", "07334", "49.04888", "8.25959", "Europe/Berlin"),("2806105", "Wörrstadt", "", "DE", "276", "", "08", "00", "07331", "49.84861", "8.12417", "Europe/Berlin"),("2806108", "Worpswede", "", "DE", "276", "", "06", "00", "03356", "53.21667", "8.93333", "Europe/Berlin"),("2806142", "Worms", "Вормс", "DE", "276", "", "08", "00", "07319", "49.63278", "8.35916", "Europe/Berlin"),("2806192", "Worbis", "", "DE", "276", "", "15", "00", "16061", "51.41997", "10.3633", "Europe/Berlin"),("2806287", "Woltersdorf", "", "DE", "276", "", "11", "00", "12067", "52.45", "13.76667", "Europe/Berlin"),("2806339", "Wolnzach", "", "DE", "276", "", "02", "091", "09186", "48.6038", "11.62568", "Europe/Berlin"),("2806342", "Wolmirstedt", "", "DE", "276", "", "14", "00", "15083", "52.24856", "11.62945", "Europe/Berlin"),("2806501", "Wolgast", "", "DE", "276", "", "12", "00", "13075", "54.05275", "13.77201", "Europe/Berlin"),("2806646", "Wolfschlugen", "", "DE", "276", "", "01", "081", "08116", "48.65", "9.28333", "Europe/Berlin"),("2806654", "Wolfsburg", "Вольфсбург", "DE", "276", "", "06", "00", "03103", "52.42452", "10.7815", "Europe/Berlin"),("2806768", "Wolfratshausen", "Вольфратсхаузен", "DE", "276", "", "02", "091", "09173", "47.91289", "11.42166", "Europe/Berlin"),("2806799", "Wolfhagen", "", "DE", "276", "", "05", "066", "06633", "51.32611", "9.17015", "Europe/Berlin"),("2806852", "Wölfersheim", "", "DE", "276", "", "05", "064", "06440", "50.4", "8.81667", "Europe/Berlin"),("2806914", "Wolfenbüttel", "Вольфенбюттель", "DE", "276", "", "06", "00", "03158", "52.16442", "10.54095", "Europe/Berlin"),("2806919", "Wolfen", "Вольфен", "DE", "276", "", "14", "00", "15082", "51.66122", "12.26873", "Europe/Berlin"),("2806946", "Wolfach", "", "DE", "276", "", "01", "083", "08317", "48.29319", "8.2158", "Europe/Berlin"),("2807184", "Witzenhausen", "Витценхаузен", "DE", "276", "", "05", "066", "06636", "51.34103", "9.8554", "Europe/Berlin"),("2807201", "Wittstock", "", "DE", "276", "", "11", "00", "12068", "53.16118", "12.48287", "Europe/Berlin"),("2807218", "Wittmund", "Витмунд", "DE", "276", "", "06", "00", "03462", "53.57674", "7.77839", "Europe/Berlin"),("2807240", "Wittlich", "Виттлих", "DE", "276", "", "08", "00", "07231", "49.98596", "6.89308", "Europe/Berlin"),("2807257", "Wittingen", "", "DE", "276", "", "06", "00", "03151", "52.72694", "10.73613", "Europe/Berlin"),("2807265", "Wittichenau", "", "DE", "276", "", "13", "00", "14625", "51.38496", "14.24403", "Europe/Berlin"),("2807335", "Wittenburg", "", "DE", "276", "", "12", "00", "13076", "53.50599", "11.08049", "Europe/Berlin"),("2807344", "Wittenberge", "Виттенберге", "DE", "276", "", "11", "00", "12070", "53.00543", "11.75032", "Europe/Berlin"),("2807360", "Wittenau", "", "DE", "276", "", "16", "00", "11000", "52.59319", "13.32127", "Europe/Berlin"),("2807363", "Witten", "Виттен", "DE", "276", "", "07", "059", "05954", "51.44362", "7.35258", "Europe/Berlin"),("2807440", "Wissen", "", "DE", "276", "", "08", "00", "07132", "50.77915", "7.73466", "Europe/Berlin"),("2807465", "Wismar", "Висмар", "DE", "276", "", "12", "00", "13074", "53.89314", "11.45286", "Europe/Berlin"),("2807549", "Wirges", "", "DE", "276", "", "08", "00", "07143", "50.47195", "7.79844", "Europe/Berlin"),("2807594", "Wipperfürth", "Випперфюрт", "DE", "276", "", "07", "053", "05374", "51.1161", "7.39865", "Europe/Berlin"),("2807736", "Winterlingen", "", "DE", "276", "", "01", "084", "08417", "48.18333", "9.11667", "Europe/Berlin"),("2807748", "Winterhude", "", "DE", "276", "", "04", "00", "02000", "53.6", "10", "Europe/Berlin"),("2807788", "Winterberg", "", "DE", "276", "", "07", "059", "05958", "51.19248", "8.53468", "Europe/Berlin"),("2807825", "Winterbach", "", "DE", "276", "", "01", "081", "08119", "48.79918", "9.47914", "Europe/Berlin"),("2807845", "Winsen", "", "DE", "276", "", "06", "00", "03353", "53.35753", "10.21282", "Europe/Berlin"),("2807846", "Winsen", "", "DE", "276", "", "06", "00", "03351", "52.68301", "9.91362", "Europe/Berlin"),("2807872", "Winnenden", "Винненден", "DE", "276", "", "01", "081", "08119", "48.87563", "9.39819", "Europe/Berlin"),("2808101", "Windsbach", "", "DE", "276", "", "02", "095", "09571", "49.24786", "10.82651", "Europe/Berlin"),("2808148", "Windischeschenbach", "", "DE", "276", "", "02", "093", "09374", "49.80108", "12.1571", "Europe/Berlin"),("2808406", "Wilthen", "", "DE", "276", "", "13", "00", "14625", "51.09745", "14.3929", "Europe/Berlin"),("2808436", "Wilsdruff", "", "DE", "276", "", "13", "00", "14628", "51.05199", "13.53657", "Europe/Berlin"),("2808461", "Wilnsdorf", "Вильнсдорф", "DE", "276", "", "07", "059", "05970", "50.81667", "8.1", "Europe/Berlin"),("2808473", "Wilmersdorf", "Вильмерсдорф", "DE", "276", "", "16", "00", "11000", "52.48333", "13.31667", "Europe/Berlin"),("2808493", "Willstätt", "", "DE", "276", "", "01", "083", "08317", "48.53333", "7.88333", "Europe/Berlin"),("2808533", "Willingshausen", "", "DE", "276", "", "05", "066", "06634", "50.85", "9.2", "Europe/Berlin"),("2808544", "Willingen", "", "DE", "276", "", "05", "066", "06635", "51.29418", "8.6091", "Europe/Berlin"),("2808559", "Willich", "Виллих", "DE", "276", "", "07", "051", "05166", "51.26371", "6.54734", "Europe/Berlin"),("2808619", "Willebadessen", "", "DE", "276", "", "07", "057", "05762", "51.62564", "9.03694", "Europe/Berlin"),("2808644", "Wilkau-Haßlau", "", "DE", "276", "", "13", "00", "14524", "50.67504", "12.51482", "Europe/Berlin"),("2808649", "Wilhermsdorf", "", "DE", "276", "", "02", "095", "09573", "49.48308", "10.71555", "Europe/Berlin"),("2808662", "Wilhelmstadt", "", "DE", "276", "", "16", "00", "11000", "52.52462", "13.17707", "Europe/Berlin"),("2808664", "Wilhelmsruh", "", "DE", "276", "", "16", "00", "11000", "52.5871", "13.36855", "Europe/Berlin"),("2808720", "Wilhelmshaven", "Вильгельмсхафен", "DE", "276", "", "06", "00", "03405", "53.52998", "8.11253", "Europe/Berlin"),("2808893", "Wildeshausen", "Вильдесхаузен", "DE", "276", "", "06", "00", "03458", "52.89446", "8.43375", "Europe/Berlin"),("2809013", "Wildberg", "", "DE", "276", "", "01", "082", "08235", "48.62336", "8.74518", "Europe/Berlin"),("2809025", "Bad Wildbad", "", "DE", "276", "", "01", "082", "08235", "48.75071", "8.5504", "Europe/Berlin"),("2809092", "Wietze", "", "DE", "276", "", "06", "00", "03351", "52.65", "9.83333", "Europe/Berlin"),("2809100", "Wietmarschen", "", "DE", "276", "", "06", "00", "03456", "52.53333", "7.13333", "Europe/Berlin"),("2809134", "Wiesmoor", "", "DE", "276", "", "06", "00", "03452", "53.41667", "7.73333", "Europe/Berlin"),("2809138", "Wiesloch", "Вислох", "DE", "276", "", "01", "082", "08226", "49.29504", "8.69846", "Europe/Berlin"),("2809259", "Wiesenburg", "", "DE", "276", "", "11", "00", "12069", "52.11456", "12.45534", "Europe/Berlin"),("2809346", "Wiesbaden", "Висбаден", "DE", "276", "", "05", "064", "06414", "50.08258", "8.24932", "Europe/Berlin"),("2809403", "Wiernsheim", "", "DE", "276", "", "01", "082", "08236", "48.88333", "8.85", "Europe/Berlin"),("2809517", "Wiehl", "Виль", "DE", "276", "", "07", "053", "05374", "50.9495", "7.55062", "Europe/Berlin"),("2809544", "Wiefelstede", "", "DE", "276", "", "06", "00", "03451", "53.25", "8.11667", "Europe/Berlin"),("2809778", "Wickede", "", "DE", "276", "", "07", "059", "05974", "51.4964", "7.86587", "Europe/Berlin"),("2809889", "Wetzlar", "Вецлар", "DE", "276", "", "05", "065", "06532", "50.56109", "8.50495", "Europe/Berlin"),("2809897", "Wetzendorf", "", "DE", "276", "", "02", "095", "09564", "49.47056", "11.04148", "Europe/Berlin"),("2809919", "Wettringen", "", "DE", "276", "", "07", "055", "05566", "52.20939", "7.31895", "Europe/Berlin"),("2809984", "Wetter (Ruhr)", "", "DE", "276", "", "07", "059", "05954", "51.38747", "7.39277", "Europe/Berlin"),("2809985", "Wetter", "", "DE", "276", "", "05", "065", "06534", "50.90254", "8.72366", "Europe/Berlin"),("2810136", "Westhausen", "", "DE", "276", "", "01", "081", "08136", "48.88333", "10.18333", "Europe/Berlin"),("2810188", "Westerstede", "Вестерстеде", "DE", "276", "", "06", "00", "03451", "53.25682", "7.92737", "Europe/Berlin"),("2810204", "Westerrönfeld", "", "DE", "276", "", "10", "00", "01058", "54.28333", "9.65", "Europe/Berlin"),("2810284", "Westerland", "", "DE", "276", "", "10", "00", "01054", "54.9079", "8.30326", "Europe/Berlin"),("2810289", "Westerkappeln", "", "DE", "276", "", "07", "055", "05566", "52.31667", "7.88333", "Europe/Berlin"),("2810413", "Westerburg", "", "DE", "276", "", "08", "00", "07143", "50.55938", "7.97482", "Europe/Berlin"),("2810538", "Westend", "", "DE", "276", "", "16", "00", "11000", "52.51708", "13.27636", "Europe/Berlin"),("2810587", "Weßling", "", "DE", "276", "", "02", "091", "09188", "48.07452", "11.2482", "Europe/Berlin"),("2810612", "Wesseling", "Весселинг", "DE", "276", "", "07", "053", "05362", "50.82709", "6.9747", "Europe/Berlin"),("2810678", "Wesel", "Везель", "DE", "276", "", "07", "051", "05170", "51.6669", "6.62037", "Europe/Berlin"),("2810702", "Wertingen", "", "DE", "276", "", "02", "097", "09773", "48.56314", "10.68149", "Europe/Berlin"),("2810710", "Werther", "", "DE", "276", "", "07", "057", "05754", "52.07771", "8.41793", "Europe/Berlin"),("2810716", "Wertheim", "", "DE", "276", "", "01", "081", "08128", "49.759", "9.50852", "Europe/Berlin"),("2810808", "Wernigerode", "Вернигероде", "DE", "276", "", "14", "00", "15085", "51.83652", "10.78216", "Europe/Berlin"),("2810815", "Werneuchen", "", "DE", "276", "", "11", "00", "12060", "52.63275", "13.73437", "Europe/Berlin"),("2810832", "Werneck", "", "DE", "276", "", "02", "096", "09678", "49.98201", "10.09884", "Europe/Berlin"),("2810833", "Werne", "Верне", "DE", "276", "", "07", "059", "05978", "51.66446", "7.63421", "Europe/Berlin"),("2810840", "Wernberg-Köblitz", "", "DE", "276", "", "02", "093", "09376", "49.53931", "12.1613", "Europe/Berlin"),("2810841", "Wernau", "", "DE", "276", "", "01", "081", "08116", "48.69306", "9.41533", "Europe/Berlin"),("2810848", "Wermsdorf", "", "DE", "276", "", "13", "00", "14730", "51.28333", "12.95", "Europe/Berlin"),("2810855", "Wermelskirchen", "Вермельскирхен", "DE", "276", "", "07", "053", "05378", "51.1397", "7.21583", "Europe/Berlin"),("2810860", "Werlte", "", "DE", "276", "", "06", "00", "03454", "52.85", "7.68333", "Europe/Berlin"),("2810878", "Werl", "Верль", "DE", "276", "", "07", "059", "05974", "51.55493", "7.91403", "Europe/Berlin"),("2810919", "Werdohl", "Вердоль", "DE", "276", "", "07", "059", "05962", "51.26011", "7.76608", "Europe/Berlin"),("2810945", "Werder", "Вердер", "DE", "276", "", "11", "00", "12069", "52.37874", "12.934", "Europe/Berlin"),("2810969", "Werdau", "Вердау", "DE", "276", "", "13", "00", "14524", "50.73604", "12.37534", "Europe/Berlin"),("2811013", "Wenzenbach", "", "DE", "276", "", "02", "093", "09375", "49.07561", "12.19954", "Europe/Berlin"),("2811031", "Wentorf bei Hamburg", "", "DE", "276", "", "10", "00", "01053", "53.5", "10.25", "Europe/Berlin"),("2811072", "Wennigsen", "", "DE", "276", "", "06", "00", "03241", "52.27404", "9.57287", "Europe/Berlin"),("2811204", "Wendlingen am Neckar", "Вендлинген-на-Неккаре", "DE", "276", "", "01", "081", "08116", "48.67124", "9.37632", "Europe/Berlin"),("2811278", "Wenden", "Венден", "DE", "276", "", "07", "059", "05966", "50.96667", "7.86667", "Europe/Berlin"),("2811292", "Wendelstein", "", "DE", "276", "", "02", "095", "09576", "49.3523", "11.15069", "Europe/Berlin"),("2811317", "Wendeburg", "", "DE", "276", "", "06", "00", "03157", "52.32957", "10.39255", "Europe/Berlin"),("2811342", "Wemding", "", "DE", "276", "", "02", "097", "09779", "48.87461", "10.72452", "Europe/Berlin"),("2811354", "Welzheim", "", "DE", "276", "", "01", "081", "08119", "48.87675", "9.63434", "Europe/Berlin"),("2811361", "Welver", "", "DE", "276", "", "07", "059", "05974", "51.61667", "7.96667", "Europe/Berlin"),("2811461", "Wellingsbüttel", "", "DE", "276", "", "04", "00", "02000", "53.64104", "10.0798", "Europe/Berlin"),("2811611", "Weitramsdorf", "", "DE", "276", "", "02", "094", "09473", "50.25", "10.88333", "Europe/Berlin"),("2811614", "Weitnau", "", "DE", "276", "", "02", "097", "09780", "47.64171", "10.12732", "Europe/Berlin"),("2811644", "Weiterstadt", "Вайтерштадт", "DE", "276", "", "05", "064", "06432", "49.9039", "8.58874", "Europe/Berlin"),("2811698", "Weißwasser", "Вайсвассер", "DE", "276", "", "13", "00", "14626", "51.50403", "14.64017", "Europe/Berlin"),("2811837", "Weißenthurm", "", "DE", "276", "", "08", "00", "07137", "50.41719", "7.45072", "Europe/Berlin"),("2811879", "Weißenhorn", "", "DE", "276", "", "02", "097", "09775", "48.30501", "10.16047", "Europe/Berlin"),("2811899", "Weißenfels", "Вайсенфельс", "DE", "276", "", "14", "00", "15084", "51.20148", "11.96843", "Europe/Berlin"),("2811909", "Weißenburg in Bayern", "Вайсенбург", "DE", "276", "", "02", "095", "09577", "49.03095", "10.97221", "Europe/Berlin"),("2812053", "Weissach", "", "DE", "276", "", "01", "081", "08115", "48.84687", "8.92828", "Europe/Berlin"),("2812071", "Weiskirchen", "", "DE", "276", "", "09", "00", "10042", "49.55", "6.81667", "Europe/Berlin"),("2812086", "Weisendorf", "", "DE", "276", "", "02", "095", "09572", "49.62283", "10.82531", "Europe/Berlin"),("2812145", "Weinstadt-Endersbach", "", "DE", "276", "", "01", "081", "08119", "48.81311", "9.36387", "Europe/Berlin"),("2812158", "Weinsberg", "", "DE", "276", "", "01", "081", "08125", "49.15127", "9.28762", "Europe/Berlin"),("2812174", "Weinheim", "Вайнхайм", "DE", "276", "", "01", "082", "08226", "49.54887", "8.66697", "Europe/Berlin"),("2812197", "Weingarten", "", "DE", "276", "", "01", "082", "08215", "49.05457", "8.52678", "Europe/Berlin"),("2812204", "Weingarten", "Вайнгартен", "DE", "276", "", "01", "084", "08436", "47.81009", "9.63863", "Europe/Berlin"),("2812225", "Weinböhla", "", "DE", "276", "", "13", "00", "14627", "51.16667", "13.56667", "Europe/Berlin"),("2812482", "Weimar", "Веймар", "DE", "276", "", "15", "00", "16055", "50.9803", "11.32903", "Europe/Berlin"),("2812497", "Weilmünster", "", "DE", "276", "", "05", "065", "06533", "50.43143", "8.37673", "Europe/Berlin"),("2812502", "Weil im Schönbuch", "", "DE", "276", "", "01", "081", "08115", "48.6227", "9.06355", "Europe/Berlin"),("2812509", "Weilheim an der Teck", "", "DE", "276", "", "01", "081", "08116", "48.61572", "9.53751", "Europe/Berlin"),("2812515", "Weilheim", "Вайльхайм", "DE", "276", "", "02", "091", "09190", "47.84147", "11.15484", "Europe/Berlin"),("2812522", "Weilerswist", "Вайлерсвист", "DE", "276", "", "07", "053", "05366", "50.76667", "6.83333", "Europe/Berlin"),("2812625", "Weil der Stadt", "Вайль-дер-Штадт", "DE", "276", "", "01", "081", "08115", "48.74953", "8.87176", "Europe/Berlin"),("2812626", "Weilburg", "", "DE", "276", "", "05", "065", "06533", "50.48438", "8.26249", "Europe/Berlin"),("2812636", "Weil am Rhein", "Вайль-на-Рейне", "DE", "276", "", "01", "083", "08336", "47.59331", "7.62082", "Europe/Berlin"),("2812655", "Weikersheim", "", "DE", "276", "", "01", "081", "08128", "49.47866", "9.89977", "Europe/Berlin"),("2813040", "Weiden", "Вайден", "DE", "276", "", "02", "093", "09363", "49.67682", "12.15613", "Europe/Berlin"),("2813110", "Weida", "", "DE", "276", "", "15", "00", "16076", "50.77449", "12.06028", "Europe/Berlin"),("2813187", "Weißensee", "Вайсензее", "DE", "276", "DE", "16", "00", "11000", "52.55632", "13.46649", "Europe/Berlin"),("2813216", "Wehrheim", "", "DE", "276", "", "05", "064", "06434", "50.3", "8.56667", "Europe/Berlin"),("2813262", "Wehr", "", "DE", "276", "", "01", "083", "08337", "47.62983", "7.90423", "Europe/Berlin"),("2813344", "Wegscheid", "", "DE", "276", "", "02", "092", "09275", "48.60136", "13.78733", "Europe/Berlin"),("2813390", "Wegberg", "Вегберг", "DE", "276", "", "07", "053", "05370", "51.14221", "6.28436", "Europe/Berlin"),("2813410", "Weeze", "", "DE", "276", "", "07", "051", "05154", "51.62678", "6.19792", "Europe/Berlin"),("2813433", "Weener", "Венер", "DE", "276", "", "06", "00", "03457", "53.16332", "7.35052", "Europe/Berlin"),("2813464", "Wedel", "Ведель", "DE", "276", "", "10", "00", "01056", "53.58374", "9.69835", "Europe/Berlin"),("2813472", "Wedding", "", "DE", "276", "", "16", "00", "11000", "52.54734", "13.35594", "Europe/Berlin"),("2813660", "Wathlingen", "", "DE", "276", "", "06", "00", "03351", "52.5369", "10.15069", "Europe/Berlin"),("2813700", "Wassertrüdingen", "", "DE", "276", "", "02", "095", "09571", "49.04328", "10.59906", "Europe/Berlin"),("2813755", "Wasserburg am Inn", "", "DE", "276", "", "02", "091", "09187", "48.0525", "12.22341", "Europe/Berlin"),("2813786", "Wassenberg", "Вассенберг", "DE", "276", "", "07", "053", "05370", "51.10009", "6.15484", "Europe/Berlin"),("2814005", "Warstein", "Варштайн", "DE", "276", "", "07", "059", "05974", "51.44488", "8.34851", "Europe/Berlin"),("2814055", "Warnemünde", "", "DE", "276", "", "12", "00", "13003", "54.1767", "12.08402", "Europe/Berlin"),("2814127", "Warendorf", "Варендорф", "DE", "276", "", "07", "055", "05570", "51.95109", "7.98756", "Europe/Berlin"),("2814131", "Waren", "Варен", "DE", "276", "", "12", "00", "13071", "53.5204", "12.67985", "Europe/Berlin"),("2814146", "Wardenburg", "Варденбург", "DE", "276", "", "06", "00", "03458", "53.06667", "8.2", "Europe/Berlin"),("2814153", "Warburg", "Варбург", "DE", "276", "", "07", "057", "05762", "51.49011", "9.14641", "Europe/Berlin"),("2814181", "Wanzleben", "", "DE", "276", "", "14", "00", "15083", "52.06087", "11.4408", "Europe/Berlin"),("2814195", "Wannweil", "", "DE", "276", "", "01", "084", "08415", "48.51667", "9.15", "Europe/Berlin"),("2814196", "Wannsee", "", "DE", "276", "", "16", "00", "11000", "52.41915", "13.15531", "Europe/Berlin"),("2814270", "Wangen im Allgäu", "Ванген-им-Алльгой", "DE", "276", "", "01", "084", "08436", "47.6895", "9.83247", "Europe/Berlin"),("2814305", "Wandlitz", "Вандлиц", "DE", "276", "", "11", "00", "12060", "52.74196", "13.45799", "Europe/Berlin"),("2814362", "Waltrop", "Вальтроп", "DE", "276", "", "07", "055", "05562", "51.62125", "7.40238", "Europe/Berlin"),("2814392", "Waltershausen", "", "DE", "276", "", "15", "00", "16067", "50.89827", "10.55791", "Europe/Berlin"),("2814445", "Waltenhofen", "", "DE", "276", "", "02", "097", "09780", "47.66446", "10.30695", "Europe/Berlin"),("2814462", "Walsrode", "Вальсроде", "DE", "276", "", "06", "00", "03358", "52.86147", "9.5926", "Europe/Berlin"),("2814599", "Wallersdorf", "", "DE", "276", "", "02", "092", "09279", "48.73767", "12.74744", "Europe/Berlin"),("2814613", "Wallerfangen", "", "DE", "276", "", "09", "00", "10044", "49.33333", "6.71667", "Europe/Berlin"),("2814632", "Wallenhorst", "Валленхорст", "DE", "276", "", "06", "00", "03459", "52.35", "8.01667", "Europe/Berlin"),("2814667", "Walldürn", "", "DE", "276", "", "01", "082", "08225", "49.58358", "9.36642", "Europe/Berlin"),("2814670", "Walldorf", "", "DE", "276", "", "01", "082", "08226", "49.30637", "8.64236", "Europe/Berlin"),("2814775", "Waldstetten", "", "DE", "276", "", "01", "081", "08136", "48.76615", "9.82135", "Europe/Berlin"),("2814791", "Waldshut-Tiengen", "Вальдсхут-Тинген", "DE", "276", "", "01", "083", "08337", "47.62323", "8.21717", "Europe/Berlin"),("2814795", "Waldsee", "", "DE", "276", "", "08", "00", "07338", "49.39528", "8.44028", "Europe/Berlin"),("2814815", "Waldsassen", "", "DE", "276", "", "02", "093", "09377", "50.00167", "12.30434", "Europe/Berlin"),("2814846", "Waldmünchen", "", "DE", "276", "", "02", "093", "09372", "49.37804", "12.70905", "Europe/Berlin"),("2814851", "Waldmohr", "", "DE", "276", "", "08", "00", "07336", "49.38333", "7.33333", "Europe/Berlin"),("2814853", "Wald-Michelbach", "", "DE", "276", "", "05", "064", "06431", "49.57", "8.83167", "Europe/Berlin"),("2814874", "Waldkraiburg", "Вальдкрайбург", "DE", "276", "", "02", "091", "09183", "48.20854", "12.39893", "Europe/Berlin"),("2814880", "Waldkirchen", "", "DE", "276", "", "02", "092", "09272", "48.7327", "13.60082", "Europe/Berlin"),("2814883", "Waldkirch", "Вальдкирх", "DE", "276", "", "01", "083", "08316", "48.09585", "7.96371", "Europe/Berlin"),("2814888", "Waldkappel", "", "DE", "276", "", "05", "066", "06636", "51.14462", "9.87695", "Europe/Berlin"),("2814956", "Waldheim", "", "DE", "276", "", "13", "00", "14522", "51.07282", "13.02004", "Europe/Berlin"),("2815032", "Waldfischbach-Burgalben", "", "DE", "276", "", "08", "00", "07340", "49.28333", "7.66667", "Europe/Berlin"),("2815035", "Waldfeucht", "", "DE", "276", "", "07", "053", "05370", "51.0661", "5.98815", "Europe/Berlin"),("2815076", "Waldenbuch", "", "DE", "276", "", "01", "081", "08115", "48.6383", "9.13256", "Europe/Berlin"),("2815101", "Waldeck", "", "DE", "276", "", "05", "066", "06635", "51.20618", "9.06286", "Europe/Berlin"),("2815127", "Waldbüttelbrunn", "", "DE", "276", "", "02", "096", "09679", "49.78833", "9.84667", "Europe/Berlin"),("2815137", "Waldbröl", "Вальдбрёль", "DE", "276", "", "07", "053", "05374", "50.87576", "7.61688", "Europe/Berlin"),("2815328", "Waibstadt", "", "DE", "276", "", "01", "082", "08226", "49.29505", "8.91771", "Europe/Berlin"),("2815330", "Waiblingen", "Вайблинген", "DE", "276", "", "01", "081", "08119", "48.83241", "9.31641", "Europe/Berlin"),("2815375", "Wahn-Heide", "", "DE", "276", "", "07", "053", "05315", "50.85891", "7.10662", "Europe/Berlin"),("2815392", "Wahlstedt", "", "DE", "276", "", "10", "00", "01060", "53.95161", "10.20626", "Europe/Berlin"),("2815484", "Waging am See", "", "DE", "276", "", "02", "091", "09189", "47.93414", "12.73392", "Europe/Berlin"),("2815487", "Waghäusel", "Вагхойзель", "DE", "276", "", "01", "082", "08215", "49.24991", "8.51257", "Europe/Berlin"),("2815523", "Wagenfeld", "", "DE", "276", "", "06", "00", "03251", "52.55", "8.58333", "Europe/Berlin"),("2815559", "Wadgassen", "", "DE", "276", "", "09", "00", "10044", "49.26667", "6.78333", "Europe/Berlin"),("2815563", "Wadersloh", "", "DE", "276", "", "07", "055", "05570", "51.73333", "8.25", "Europe/Berlin"),("2815565", "Wadern", "Вадерн", "DE", "276", "", "09", "00", "10042", "49.54122", "6.88774", "Europe/Berlin"),("2815642", "Wächtersbach", "", "DE", "276", "", "05", "064", "06435", "50.25511", "9.29564", "Europe/Berlin"),("2815651", "Wachtendonk", "", "DE", "276", "", "07", "051", "05154", "51.40916", "6.33894", "Europe/Berlin"),("2815678", "Wachtberg", "Вахтберг", "DE", "276", "", "07", "053", "05382", "50.63333", "7.1", "Europe/Berlin"),("2815784", "Wabern", "", "DE", "276", "", "05", "066", "06634", "51.1", "9.35", "Europe/Berlin"),("2815804", "Waakirchen", "", "DE", "276", "", "02", "091", "09182", "47.7725", "11.67315", "Europe/Berlin"),("2815824", "Vreden", "Фреден", "DE", "276", "", "07", "055", "05554", "52.03792", "6.828", "Europe/Berlin"),("2816616", "Volkmarsen", "", "DE", "276", "", "05", "066", "06635", "51.40895", "9.11814", "Europe/Berlin"),("2816630", "Völklingen", "Фёльклинген", "DE", "276", "", "09", "00", "10041", "49.25162", "6.85873", "Europe/Berlin"),("2816702", "Volkach", "", "DE", "276", "", "02", "096", "09675", "49.86352", "10.22813", "Europe/Berlin"),("2816761", "Vöhringen", "", "DE", "276", "", "02", "097", "09775", "48.27839", "10.08236", "Europe/Berlin"),("2816769", "Vöhl", "", "DE", "276", "", "05", "066", "06635", "51.20565", "8.9451", "Europe/Berlin"),("2816770", "Vohenstrauß", "", "DE", "276", "", "02", "093", "09374", "49.62383", "12.33808", "Europe/Berlin"),("2816776", "Vohburg an der Donau", "", "DE", "276", "", "02", "091", "09186", "48.76977", "11.61845", "Europe/Berlin"),("2817065", "Voerde", "Ферде", "DE", "276", "", "07", "051", "05170", "51.59703", "6.6863", "Europe/Berlin"),("2817105", "Vlotho", "Флото", "DE", "276", "", "07", "057", "05758", "52.1653", "8.85996", "Europe/Berlin"),("2817130", "Visselhövede", "", "DE", "276", "", "06", "00", "03357", "52.98546", "9.58265", "Europe/Berlin"),("2817139", "Visbek", "", "DE", "276", "", "06", "00", "03460", "52.83333", "8.31667", "Europe/Berlin"),("2817202", "Vilshofen", "", "DE", "276", "", "02", "092", "09275", "48.62695", "13.19222", "Europe/Berlin"),("2817207", "Vilseck", "", "DE", "276", "", "02", "093", "09371", "49.6148", "11.80261", "Europe/Berlin"),("2817209", "Vilsbiburg", "", "DE", "276", "", "02", "092", "09274", "48.45296", "12.35604", "Europe/Berlin"),("2817217", "Villmar", "", "DE", "276", "", "05", "065", "06533", "50.39287", "8.1931", "Europe/Berlin"),("2817220", "Villingen-Schwenningen", "Виллинген-Швеннинген", "DE", "276", "", "01", "083", "08326", "48.06226", "8.49358", "Europe/Berlin"),("2817311", "Viersen", "Фирзен", "DE", "276", "", "07", "051", "05166", "51.25435", "6.39441", "Europe/Berlin"),("2817324", "Viernheim", "Фирнхайм", "DE", "276", "", "05", "064", "06431", "49.54033", "8.5782", "Europe/Berlin"),("2817394", "Vienenburg", "", "DE", "276", "", "06", "00", "03153", "51.95242", "10.56374", "Europe/Berlin"),("2817483", "Viechtach", "", "DE", "276", "", "02", "092", "09276", "49.08001", "12.88566", "Europe/Berlin"),("2817506", "Vettweiß", "", "DE", "276", "", "07", "053", "05358", "50.73333", "6.6", "Europe/Berlin"),("2817517", "Vetschau", "", "DE", "276", "", "11", "00", "12066", "51.78638", "14.07941", "Europe/Berlin"),("2817537", "Versmold", "Ферсмольд", "DE", "276", "", "07", "057", "05754", "52.04009", "8.15272", "Europe/Berlin"),("2817576", "Verl", "Ферль", "DE", "276", "", "07", "057", "05754", "51.88333", "8.51667", "Europe/Berlin"),("2817599", "Verden", "Ферден", "DE", "276", "", "06", "00", "03361", "52.92343", "9.23491", "Europe/Berlin"),("2817674", "Velten", "", "DE", "276", "", "11", "00", "12065", "52.69149", "13.17533", "Europe/Berlin"),("2817704", "Velen", "", "DE", "276", "", "07", "055", "05554", "51.9", "6.98333", "Europe/Berlin"),("2817719", "Velden", "", "DE", "276", "", "02", "092", "09274", "48.36632", "12.25596", "Europe/Berlin"),("2817722", "Velburg", "", "DE", "276", "", "02", "093", "09373", "49.23212", "11.6716", "Europe/Berlin"),("2817724", "Velbert", "Фельберт", "DE", "276", "", "07", "051", "05158", "51.33537", "7.04348", "Europe/Berlin"),("2817733", "Veitshöchheim", "", "DE", "276", "", "02", "096", "09679", "49.83278", "9.88167", "Europe/Berlin"),("2817736", "Veitsbronn", "", "DE", "276", "", "02", "095", "09573", "49.51239", "10.88797", "Europe/Berlin"),("2817812", "Vechta", "Фехта", "DE", "276", "", "06", "00", "03460", "52.72632", "8.28598", "Europe/Berlin"),("2817813", "Vechelde", "Фехельде", "DE", "276", "", "06", "00", "03157", "52.26038", "10.36491", "Europe/Berlin"),("2817818", "Vaterstetten", "Фатерштеттен", "DE", "276", "", "02", "091", "09175", "48.10537", "11.76825", "Europe/Berlin"),("2817873", "Varel", "", "DE", "276", "", "06", "00", "03455", "53.39693", "8.13621", "Europe/Berlin"),("2817909", "Vallendar", "", "DE", "276", "", "08", "00", "07137", "50.39586", "7.62427", "Europe/Berlin"),("2817927", "Vaihingen an der Enz", "Файхинген-на-Энце", "DE", "276", "", "01", "081", "08118", "48.93563", "8.96045", "Europe/Berlin"),("2818067", "Uetersen", "Итерзен", "DE", "276", "", "10", "00", "01056", "53.68769", "9.66394", "Europe/Berlin"),("2818094", "Uslar", "Услар", "DE", "276", "", "06", "00", "03155", "51.6569", "9.63501", "Europe/Berlin"),("2818097", "Usingen", "", "DE", "276", "", "05", "064", "06434", "50.33554", "8.53688", "Europe/Berlin"),("2818246", "Bad Urach", "", "DE", "276", "", "01", "084", "08415", "48.49107", "9.40009", "Europe/Berlin"),("2818766", "Unterschleißheim", "Унтершлайсхайм", "DE", "276", "", "02", "091", "09184", "48.28038", "11.57684", "Europe/Berlin"),("2819081", "Untermeitingen", "", "DE", "276", "", "02", "097", "09772", "48.16082", "10.80694", "Europe/Berlin"),("2819399", "Unterhausen", "", "DE", "276", "", "01", "084", "08415", "48.4298", "9.25504", "Europe/Berlin"),("2819465", "Unterhaching", "Унтерхахинг", "DE", "276", "", "02", "091", "09184", "48.06598", "11.61564", "Europe/Berlin"),("2819479", "Untergruppenbach", "", "DE", "276", "", "01", "081", "08125", "49.0894", "9.27516", "Europe/Berlin"),("2819497", "Untergriesbach", "", "DE", "276", "", "02", "092", "09275", "48.57434", "13.66725", "Europe/Berlin"),("2819568", "Unterföhring", "", "DE", "276", "", "02", "091", "09184", "48.19253", "11.64293", "Europe/Berlin"),("2819974", "Unterkrozingen", "", "DE", "276", "", "01", "083", "08315", "47.91933", "7.69045", "Europe/Berlin"),("2820087", "Unna", "Унна", "DE", "276", "", "07", "059", "05978", "51.53795", "7.68969", "Europe/Berlin"),("2820190", "Umkirch", "", "DE", "276", "", "01", "083", "08315", "48.03333", "7.76667", "Europe/Berlin"),("2820256", "Ulm", "Ульм", "DE", "276", "", "01", "084", "08421", "48.39841", "9.99155", "Europe/Berlin"),("2820407", "Uhingen", "", "DE", "276", "", "01", "081", "08117", "48.70475", "9.5857", "Europe/Berlin"),("2820423", "Uffenheim", "", "DE", "276", "", "02", "095", "09575", "49.54415", "10.23286", "Europe/Berlin"),("2820436", "Uetze", "", "DE", "276", "", "06", "00", "03241", "52.46511", "10.20467", "Europe/Berlin"),("2820456", "Uelzen", "Ильцен", "DE", "276", "", "06", "00", "03360", "52.96572", "10.56111", "Europe/Berlin"),("2820458", "Uelsen", "", "DE", "276", "", "06", "00", "03456", "52.5", "6.88333", "Europe/Berlin"),("2820465", "Uedem", "", "DE", "276", "", "07", "051", "05154", "51.66667", "6.3", "Europe/Berlin"),("2820471", "Ueckermünde", "", "DE", "276", "", "12", "00", "13075", "53.73795", "14.04473", "Europe/Berlin"),("2820577", "Überlingen", "Иберлинген", "DE", "276", "", "01", "084", "08435", "47.76977", "9.17136", "Europe/Berlin"),("2820583", "Überherrn", "", "DE", "276", "", "09", "00", "10044", "49.24187", "6.6984", "Europe/Berlin"),("2820621", "Übach-Palenberg", "Ибах-Паленберг", "DE", "276", "", "07", "053", "05370", "50.93333", "6.11667", "Europe/Berlin"),("2820643", "Twistringen", "", "DE", "276", "", "06", "00", "03251", "52.79926", "8.64163", "Europe/Berlin"),("2820692", "Tutzing", "", "DE", "276", "", "02", "091", "09188", "47.90938", "11.2803", "Europe/Berlin"),("2820693", "Tuttlingen", "Тутлинген", "DE", "276", "", "01", "083", "08327", "47.98464", "8.8177", "Europe/Berlin"),("2820752", "Türkheim", "", "DE", "276", "", "02", "097", "09778", "48.06401", "10.64156", "Europe/Berlin"),("2820775", "Tuntenhausen", "", "DE", "276", "", "02", "091", "09187", "47.93509", "12.01518", "Europe/Berlin"),("2820860", "Tübingen", "Тюбинген", "DE", "276", "", "01", "084", "08416", "48.52266", "9.05222", "Europe/Berlin"),("2820964", "Trostberg an der Alz", "", "DE", "276", "", "02", "091", "09189", "48.02802", "12.55804", "Europe/Berlin"),("2820973", "Trossingen", "Троссинген", "DE", "276", "", "01", "083", "08327", "48.07667", "8.64409", "Europe/Berlin"),("2821029", "Troisdorf", "Тройсдорф", "DE", "276", "", "07", "053", "05382", "50.80901", "7.14968", "Europe/Berlin"),("2821065", "Trochtelfingen", "", "DE", "276", "", "01", "084", "08415", "48.30843", "9.24491", "Europe/Berlin"),("2821085", "Trittau", "", "DE", "276", "", "10", "00", "01062", "53.61667", "10.4", "Europe/Berlin"),("2821143", "Triftern", "", "DE", "276", "", "02", "092", "09277", "48.39468", "13.00627", "Europe/Berlin"),("2821164", "Trier", "Трир", "DE", "276", "", "08", "00", "07211", "49.75565", "6.63935", "Europe/Berlin"),("2821216", "Triberg im Schwarzwald", "", "DE", "276", "", "01", "083", "08326", "48.13175", "8.23317", "Europe/Berlin"),("2821248", "Treuenbrietzen", "", "DE", "276", "", "11", "00", "12069", "52.09754", "12.87258", "Europe/Berlin"),("2821251", "Treuen", "", "DE", "276", "", "13", "00", "14523", "50.54247", "12.30339", "Europe/Berlin"),("2821254", "Treuchtlingen", "", "DE", "276", "", "02", "095", "09577", "48.95473", "10.90833", "Europe/Berlin"),("2821292", "Alt-Treptow", "", "DE", "276", "DE", "16", "00", "11000", "52.48863", "13.4586", "Europe/Berlin"),("2821336", "Trendelburg", "", "DE", "276", "", "05", "066", "06633", "51.57408", "9.42095", "Europe/Berlin"),("2821395", "Treffurt", "", "DE", "276", "", "15", "00", "16063", "51.13691", "10.23361", "Europe/Berlin"),("2821416", "Trebur", "", "DE", "276", "", "05", "064", "06433", "49.93111", "8.41611", "Europe/Berlin"),("2821465", "Trebbin", "", "DE", "276", "", "11", "00", "12072", "52.21675", "13.22496", "Europe/Berlin"),("2821480", "Travemünde", "", "DE", "276", "", "10", "00", "01003", "53.96304", "10.8709", "Europe/Berlin"),("2821515", "Traunstein", "Траунштайн", "DE", "276", "", "02", "091", "09189", "47.86825", "12.64335", "Europe/Berlin"),("2821517", "Traunreut", "Траунройт", "DE", "276", "", "02", "091", "09189", "47.96269", "12.59231", "Europe/Berlin"),("2821558", "Trappenkamp", "", "DE", "276", "", "10", "00", "01060", "54.05", "10.25", "Europe/Berlin"),("2821690", "Traben-Trarbach", "", "DE", "276", "", "08", "00", "07231", "49.95076", "7.11562", "Europe/Berlin"),("2821736", "Tostedt", "", "DE", "276", "", "06", "00", "03353", "53.28333", "9.71667", "Europe/Berlin"),("2821779", "Tornesch", "", "DE", "276", "", "10", "00", "01056", "53.7", "9.71667", "Europe/Berlin"),("2821802", "Torgelow", "", "DE", "276", "", "12", "00", "13075", "53.63415", "14.01346", "Europe/Berlin"),("2821807", "Torgau", "Торгау", "DE", "276", "", "13", "00", "14730", "51.56016", "12.99617", "Europe/Berlin"),("2821878", "Tönning", "", "DE", "276", "", "10", "00", "01054", "54.31879", "8.94234", "Europe/Berlin"),("2821899", "Tönisvorst", "Тёнисфорст", "DE", "276", "", "07", "051", "05166", "51.32092", "6.49412", "Europe/Berlin"),("2821963", "Töging am Inn", "", "DE", "276", "", "02", "091", "09171", "48.26018", "12.5846", "Europe/Berlin"),("2821975", "Todtnau", "", "DE", "276", "", "01", "083", "08336", "47.82941", "7.9438", "Europe/Berlin"),("2822073", "Titz", "", "DE", "276", "", "07", "053", "05358", "51.00619", "6.42477", "Europe/Berlin"),("2822075", "Tittmoning", "", "DE", "276", "", "02", "091", "09189", "48.06164", "12.7676", "Europe/Berlin"),("2822083", "Titisee-Neustadt", "", "DE", "276", "", "01", "083", "08315", "47.92104", "8.19063", "Europe/Berlin"),("2822100", "Tirschenreuth", "", "DE", "276", "", "02", "093", "09377", "49.88263", "12.33112", "Europe/Berlin"),("2822160", "Timmendorfer Strand", "", "DE", "276", "", "10", "00", "01055", "53.9953", "10.77676", "Europe/Berlin"),("2822224", "Tiergarten", "", "DE", "276", "", "16", "00", "11000", "52.51667", "13.36667", "Europe/Berlin"),("2822401", "Tiefenbronn", "", "DE", "276", "", "01", "082", "08236", "48.83333", "8.8", "Europe/Berlin"),("2822595", "Thum", "", "DE", "276", "", "13", "00", "14521", "50.67081", "12.95091", "Europe/Berlin"),("2822713", "Tholey", "", "DE", "276", "", "09", "00", "10046", "49.48374", "7.03691", "Europe/Berlin"),("2822939", "Tharandt", "", "DE", "276", "", "13", "00", "14628", "50.98525", "13.58035", "Europe/Berlin"),("2822958", "Thannhausen", "", "DE", "276", "", "02", "097", "09774", "48.28334", "10.46917", "Europe/Berlin"),("2823044", "Thalmässing", "", "DE", "276", "", "02", "095", "09576", "49.08834", "11.2215", "Europe/Berlin"),("2823081", "Thalheim", "", "DE", "276", "", "13", "00", "14521", "50.70077", "12.84996", "Europe/Berlin"),("2823141", "Thale", "", "DE", "276", "", "14", "00", "15085", "51.74861", "11.041", "Europe/Berlin"),("2823230", "Teutschenthal", "", "DE", "276", "", "14", "00", "15088", "51.45", "11.8", "Europe/Berlin"),("2823360", "Teublitz", "", "DE", "276", "", "02", "093", "09376", "49.22289", "12.08727", "Europe/Berlin"),("2823368", "Tettnang", "", "DE", "276", "", "01", "084", "08435", "47.66857", "9.59132", "Europe/Berlin"),("2823398", "Teterow", "", "DE", "276", "", "12", "00", "13072", "53.77545", "12.57487", "Europe/Berlin"),("2823504", "Teningen", "", "DE", "276", "", "01", "083", "08316", "48.12952", "7.81205", "Europe/Berlin"),("2823533", "Templin", "Темплин", "DE", "276", "", "11", "00", "12073", "53.11865", "13.5022", "Europe/Berlin"),("2823538", "Tempelhof", "Темпельхоф", "DE", "276", "", "16", "00", "11000", "52.46667", "13.4", "Europe/Berlin"),("2823567", "Teltow", "Тельтов", "DE", "276", "", "11", "00", "12069", "52.4031", "13.26014", "Europe/Berlin"),("2823590", "Telgte", "Тельгте", "DE", "276", "", "07", "055", "05570", "51.97995", "7.78293", "Europe/Berlin"),("2823611", "Teisendorf", "", "DE", "276", "", "02", "091", "09172", "47.84921", "12.81919", "Europe/Berlin"),("2823708", "Tegel", "Тегель", "DE", "276", "", "16", "00", "11000", "52.57601", "13.29389", "Europe/Berlin"),("2823728", "Tecklenburg", "", "DE", "276", "", "07", "055", "05566", "52.21957", "7.81357", "Europe/Berlin"),("2823799", "Taunusstein", "Таунусштайн", "DE", "276", "", "05", "064", "06439", "50.14993", "8.15206", "Europe/Berlin"),("2823810", "Taufkirchen", "", "DE", "276", "", "02", "091", "09177", "48.34987", "12.13202", "Europe/Berlin"),("2823812", "Taufkirchen", "", "DE", "276", "", "02", "091", "09184", "48.0486", "11.61701", "Europe/Berlin"),("2823836", "Taucha", "", "DE", "276", "", "13", "00", "14730", "51.38333", "12.48333", "Europe/Berlin"),("2823854", "Tauberbischofsheim", "", "DE", "276", "", "01", "081", "08128", "49.62472", "9.66278", "Europe/Berlin"),("2823978", "Tarp", "", "DE", "276", "", "10", "00", "01059", "54.66667", "9.4", "Europe/Berlin"),("2824245", "Tangstedt", "", "DE", "276", "", "10", "00", "01062", "53.73333", "10.08333", "Europe/Berlin"),("2824254", "Tangermünde", "", "DE", "276", "", "14", "00", "15090", "52.54463", "11.97647", "Europe/Berlin"),("2824255", "Tangerhütte", "", "DE", "276", "", "14", "00", "15090", "52.4353", "11.80724", "Europe/Berlin"),("2824284", "Tamm", "", "DE", "276", "", "01", "081", "08118", "48.91988", "9.11556", "Europe/Berlin"),("2824420", "Tacherting", "", "DE", "276", "", "02", "091", "09189", "48.07825", "12.57008", "Europe/Berlin"),("2824461", "Syke", "Зике", "DE", "276", "", "06", "00", "03251", "52.91345", "8.82209", "Europe/Berlin"),("2824545", "Süßen", "", "DE", "276", "", "01", "081", "08117", "48.67934", "9.75534", "Europe/Berlin"),("2824564", "Süsel", "", "DE", "276", "", "10", "00", "01055", "54.06667", "10.71667", "Europe/Berlin"),("2824655", "Sundern", "Зундерн", "DE", "276", "", "07", "059", "05958", "51.3281", "8.00369", "Europe/Berlin"),("2824801", "Sulzbach-Rosenberg", "Зульцбах-Розенберг", "DE", "276", "", "02", "093", "09371", "49.50126", "11.74598", "Europe/Berlin"),("2824804", "Sulzbach an der Murr", "", "DE", "276", "", "01", "081", "08119", "49.00303", "9.5003", "Europe/Berlin"),("2824806", "Sulzbach am Main", "", "DE", "276", "", "02", "096", "09676", "49.91149", "9.15315", "Europe/Berlin"),("2824837", "Sulzbach", "", "DE", "276", "", "05", "064", "06436", "50.13396", "8.52797", "Europe/Berlin"),("2824841", "Sulzbach", "Зульцбах", "DE", "276", "", "09", "00", "10041", "49.29882", "7.05696", "Europe/Berlin"),("2824855", "Sulz am Neckar", "", "DE", "276", "", "01", "083", "08325", "48.36241", "8.63309", "Europe/Berlin"),("2824902", "Sulingen", "", "DE", "276", "", "06", "00", "03251", "52.68373", "8.80949", "Europe/Berlin"),("2824948", "Suhl", "Зуль", "DE", "276", "", "15", "00", "16054", "50.60911", "10.69401", "Europe/Berlin"),("2824998", "Südlohn", "", "DE", "276", "", "07", "055", "05554", "51.93333", "6.86667", "Europe/Berlin"),("2825297", "Stuttgart", "Штутгарт", "DE", "276", "", "01", "081", "08111", "48.78232", "9.17702", "Europe/Berlin");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("2825422", "Stuhr", "", "DE", "276", "", "06", "00", "03251", "53.03333", "8.75", "Europe/Berlin"),("2825429", "Stühlingen", "", "DE", "276", "", "01", "083", "08337", "47.7458", "8.44813", "Europe/Berlin"),("2825638", "Strullendorf", "", "DE", "276", "", "02", "094", "09471", "49.84429", "10.97208", "Europe/Berlin"),("2826082", "Strausberg", "Штраусберг", "DE", "276", "", "11", "00", "12064", "52.57859", "13.88741", "Europe/Berlin"),("2826099", "Straubing", "Штраубинг", "DE", "276", "", "02", "092", "09263", "48.88126", "12.57385", "Europe/Berlin"),("2826258", "Strasburg", "", "DE", "276", "", "12", "00", "13075", "53.5103", "13.74513", "Europe/Berlin"),("2826287", "Stralsund", "Штральзунд", "DE", "276", "", "12", "00", "13073", "54.30911", "13.0818", "Europe/Berlin"),("2826304", "Straelen", "Штрален", "DE", "276", "", "07", "051", "05154", "51.4419", "6.26639", "Europe/Berlin"),("2826403", "Storkow", "", "DE", "276", "", "11", "00", "12067", "52.25662", "13.93337", "Europe/Berlin"),("2826503", "Stolzenau", "", "DE", "276", "", "06", "00", "03256", "52.51667", "9.06667", "Europe/Berlin"),("2826532", "Stolpen", "", "DE", "276", "", "13", "00", "14628", "51.04901", "14.07943", "Europe/Berlin"),("2826584", "Stollberg", "", "DE", "276", "", "13", "00", "14521", "50.70999", "12.78034", "Europe/Berlin"),("2826595", "Stolberg", "Штольберг", "DE", "276", "", "07", "053", "05334", "50.77368", "6.22595", "Europe/Berlin"),("2826670", "Stockstadt am Main", "", "DE", "276", "", "02", "096", "09671", "49.97005", "9.07153", "Europe/Berlin"),("2826671", "Stockstadt am Rhein", "", "DE", "276", "", "05", "064", "06433", "49.80944", "8.47278", "Europe/Berlin"),("2826743", "Stockheim", "", "DE", "276", "", "02", "094", "09476", "50.3", "11.26667", "Europe/Berlin"),("2826861", "Stockelsdorf", "", "DE", "276", "", "10", "00", "01055", "53.8922", "10.64713", "Europe/Berlin"),("2826909", "Stockach", "Штоках", "DE", "276", "", "01", "083", "08335", "47.85105", "9.0091", "Europe/Berlin"),("2827166", "Steyerberg", "", "DE", "276", "", "06", "00", "03256", "52.57017", "9.02423", "Europe/Berlin"),("2827216", "Stetten am Kalten Markt", "", "DE", "276", "", "01", "084", "08437", "48.12419", "9.07775", "Europe/Berlin"),("2827406", "Stephanskirchen", "", "DE", "276", "", "02", "091", "09187", "47.85389", "12.1856", "Europe/Berlin"),("2827479", "Stendal", "Стендаль", "DE", "276", "", "14", "00", "15090", "52.6069", "11.85867", "Europe/Berlin"),("2827552", "Stellingen", "", "DE", "276", "", "04", "00", "02000", "53.5922", "9.9287", "Europe/Berlin"),("2827574", "Stelle", "", "DE", "276", "", "06", "00", "03353", "53.38416", "10.11138", "Europe/Berlin"),("2827988", "Steinheim am der Murr", "", "DE", "276", "", "01", "081", "08118", "48.96821", "9.27708", "Europe/Berlin"),("2827989", "Steinheim am Albuch", "", "DE", "276", "", "01", "081", "08135", "48.6909", "10.06382", "Europe/Berlin"),("2827990", "Steinheim", "", "DE", "276", "", "07", "057", "05762", "51.87066", "9.09136", "Europe/Berlin"),("2828050", "Steinhagen", "", "DE", "276", "", "07", "057", "05754", "52", "8.4", "Europe/Berlin"),("2828105", "Steinfurt", "Штайнфурт", "DE", "276", "", "07", "055", "05566", "52.15045", "7.33664", "Europe/Berlin"),("2828136", "Steinfeld", "", "DE", "276", "", "06", "00", "03460", "52.58596", "8.21417", "Europe/Berlin"),("2828206", "Steinenbronn", "", "DE", "276", "", "01", "081", "08115", "48.66667", "9.11667", "Europe/Berlin"),("2828228", "Steinen", "", "DE", "276", "", "01", "083", "08336", "47.64446", "7.73914", "Europe/Berlin"),("2828685", "Stein", "", "DE", "276", "", "02", "095", "09573", "49.41581", "11.01599", "Europe/Berlin"),("2828723", "Steinbach-Hallenberg", "", "DE", "276", "", "15", "00", "16066", "50.69624", "10.56541", "Europe/Berlin"),("2828737", "Steinbach am Taunus", "", "DE", "276", "", "05", "064", "06434", "50.16774", "8.57278", "Europe/Berlin"),("2828871", "Steinau an der Straße", "", "DE", "276", "", "05", "064", "06435", "50.31401", "9.46335", "Europe/Berlin"),("2828994", "Steilshoop", "", "DE", "276", "", "04", "00", "02000", "53.61028", "10.05917", "Europe/Berlin"),("2829109", "Steglitz", "Штеглиц", "DE", "276", "", "16", "00", "11000", "52.45606", "13.332", "Europe/Berlin"),("2829145", "Stegaurach", "", "DE", "276", "", "02", "094", "09471", "49.86543", "10.84385", "Europe/Berlin"),("2829322", "Staufenberg", "", "DE", "276", "", "05", "065", "06531", "50.66197", "8.73158", "Europe/Berlin"),("2829333", "Staufen", "", "DE", "276", "", "01", "083", "08337", "47.75686", "8.21078", "Europe/Berlin"),("2829422", "Staßfurt", "Штасфурт", "DE", "276", "", "14", "00", "15089", "51.85186", "11.58508", "Europe/Berlin"),("2829457", "Starnberg", "Штарнберг", "DE", "276", "", "02", "091", "09188", "48.00193", "11.34416", "Europe/Berlin"),("2829657", "Stahnsdorf", "", "DE", "276", "", "11", "00", "12069", "52.38333", "13.21667", "Europe/Berlin"),("2829701", "Bad Staffelstein", "", "DE", "276", "", "02", "094", "09478", "50.10199", "11.00128", "Europe/Berlin"),("2829750", "Stadtroda", "", "DE", "276", "", "15", "00", "16074", "50.85684", "11.72677", "Europe/Berlin"),("2829753", "Stadtoldendorf", "", "DE", "276", "", "06", "00", "03255", "51.88242", "9.6265", "Europe/Berlin"),("2829758", "Stadtlohn", "Штадтлон", "DE", "276", "", "07", "055", "05554", "51.99399", "6.91918", "Europe/Berlin"),("2829765", "Stadtilm", "", "DE", "276", "", "15", "00", "16070", "50.77596", "11.08262", "Europe/Berlin"),("2829777", "Stadthagen", "Штадтхаген", "DE", "276", "", "06", "00", "03257", "52.32333", "9.20311", "Europe/Berlin"),("2829790", "Stadtbergen", "", "DE", "276", "", "02", "097", "09772", "48.36641", "10.84636", "Europe/Berlin"),("2829804", "Stadtallendorf", "Штадталлендорф", "DE", "276", "", "05", "065", "06534", "50.82261", "9.01294", "Europe/Berlin"),("2829901", "Stade", "Штаде", "DE", "276", "", "06", "00", "03359", "53.59337", "9.47629", "Europe/Berlin"),("2829962", "Staaken", "", "DE", "276", "", "16", "00", "11000", "52.53661", "13.15057", "Europe/Berlin"),("2829998", "Sprockhövel", "Шпрокхёфель", "DE", "276", "", "07", "059", "05954", "51.34669", "7.24343", "Europe/Berlin"),("2830035", "Springe", "Шпринге", "DE", "276", "", "06", "00", "03241", "52.20845", "9.55416", "Europe/Berlin"),("2830452", "Spiesen-Elversberg", "", "DE", "276", "", "09", "00", "10043", "49.31667", "7.13333", "Europe/Berlin"),("2830582", "Speyer", "Шпайер", "DE", "276", "", "08", "00", "07318", "49.32083", "8.43111", "Europe/Berlin"),("2830637", "Spenge", "", "DE", "276", "", "07", "057", "05758", "52.14021", "8.48475", "Europe/Berlin"),("2830652", "Spelle", "", "DE", "276", "", "06", "00", "03454", "52.36667", "7.46667", "Europe/Berlin"),("2830670", "Speichersdorf", "", "DE", "276", "", "02", "094", "09472", "49.88333", "11.78333", "Europe/Berlin"),("2830829", "Spangenberg", "", "DE", "276", "", "05", "066", "06634", "51.11644", "9.6627", "Europe/Berlin"),("2830849", "Spalt", "", "DE", "276", "", "02", "095", "09576", "49.17553", "10.92453", "Europe/Berlin"),("2830851", "Spaichingen", "", "DE", "276", "", "01", "083", "08327", "48.07477", "8.73508", "Europe/Berlin"),("2830880", "Sottrum", "", "DE", "276", "", "06", "00", "03357", "53.11667", "9.23333", "Europe/Berlin"),("2831083", "Sontra", "", "DE", "276", "", "05", "066", "06636", "51.07171", "9.93558", "Europe/Berlin"),("2831088", "Sonthofen", "Зонтхофен", "DE", "276", "", "02", "097", "09780", "47.51821", "10.28262", "Europe/Berlin"),("2831091", "Sontheim an der Brenz", "", "DE", "276", "", "01", "081", "08135", "48.55235", "10.29097", "Europe/Berlin"),("2831105", "Sonsbeck", "", "DE", "276", "", "07", "051", "05170", "51.61667", "6.36667", "Europe/Berlin"),("2831239", "Sonnefeld", "", "DE", "276", "", "02", "094", "09473", "50.21667", "11.13333", "Europe/Berlin"),("2831250", "Sonneberg", "Зоннеберг", "DE", "276", "", "15", "00", "16072", "50.3592", "11.17463", "Europe/Berlin"),("2831276", "Sondershausen", "Зондерсхаузен", "DE", "276", "", "15", "00", "16065", "51.36973", "10.87011", "Europe/Berlin"),("2831403", "Sömmerda", "Зёммерда", "DE", "276", "", "15", "00", "16068", "51.15914", "11.11524", "Europe/Berlin"),("2831486", "Soltau", "Зольтау", "DE", "276", "", "06", "00", "03358", "52.98638", "9.84338", "Europe/Berlin"),("2831580", "Solingen", "Золинген", "DE", "276", "", "07", "051", "05122", "51.17343", "7.0845", "Europe/Berlin"),("2831671", "Söhlde", "", "DE", "276", "", "06", "00", "03254", "52.18898", "10.23239", "Europe/Berlin"),("2831685", "Sohland", "", "DE", "276", "", "13", "00", "14625", "51.04089", "14.41897", "Europe/Berlin"),("2831699", "Sögel", "", "DE", "276", "", "06", "00", "03454", "52.85", "7.51667", "Europe/Berlin"),("2831708", "Soest", "Зоест", "DE", "276", "", "07", "059", "05974", "51.57558", "8.10619", "Europe/Berlin"),("2831802", "Sittensen", "", "DE", "276", "", "06", "00", "03357", "53.27615", "9.50429", "Europe/Berlin"),("2831847", "Sinzing", "", "DE", "276", "", "02", "093", "09375", "49", "12.03333", "Europe/Berlin"),("2831852", "Sinzig", "Зинциг", "DE", "276", "", "08", "00", "07131", "50.54384", "7.24639", "Europe/Berlin"),("2831853", "Sinzheim", "", "DE", "276", "", "01", "082", "08216", "48.76667", "8.16667", "Europe/Berlin"),("2831872", "Sinsheim", "Зинсхайм", "DE", "276", "", "01", "082", "08226", "49.2529", "8.87867", "Europe/Berlin"),("2831888", "Sinnersdorf", "", "DE", "276", "", "07", "053", "05362", "51.02445", "6.81787", "Europe/Berlin"),("2831896", "Sinn", "", "DE", "276", "", "05", "065", "06532", "50.65", "8.33333", "Europe/Berlin"),("2831924", "Singen", "Зинген", "DE", "276", "", "01", "083", "08335", "47.75935", "8.8403", "Europe/Berlin"),("2831948", "Sindelfingen", "Зиндельфинген", "DE", "276", "", "01", "081", "08115", "48.7", "9.01667", "Europe/Berlin"),("2832013", "Simmern", "", "DE", "276", "", "08", "00", "07140", "49.98198", "7.52351", "Europe/Berlin"),("2832023", "Simmerath", "Зиммерат", "DE", "276", "", "07", "053", "05334", "50.6", "6.3", "Europe/Berlin"),("2832043", "Simbach am Inn", "", "DE", "276", "", "02", "092", "09277", "48.26548", "13.02309", "Europe/Berlin"),("2832232", "Sigmaringen", "Зигмаринген", "DE", "276", "", "01", "084", "08437", "48.08829", "9.23033", "Europe/Berlin"),("2832373", "Siemensstadt", "", "DE", "276", "", "16", "00", "11000", "52.54053", "13.26294", "Europe/Berlin"),("2832424", "Siegsdorf", "", "DE", "276", "", "02", "091", "09189", "47.82278", "12.64277", "Europe/Berlin"),("2832495", "Siegen", "Зиген", "DE", "276", "", "07", "059", "05970", "50.87481", "8.02431", "Europe/Berlin"),("2832521", "Siegburg", "Зигбург", "DE", "276", "", "07", "053", "05382", "50.80019", "7.20769", "Europe/Berlin"),("2832884", "Seubersdorf", "", "DE", "276", "", "02", "093", "09373", "49.16212", "11.62714", "Europe/Berlin"),("2832939", "Sersheim", "", "DE", "276", "", "01", "081", "08118", "48.96667", "9.01667", "Europe/Berlin"),("2833073", "Senftenberg", "Зенфтенберг", "DE", "276", "", "11", "00", "12066", "51.52517", "14.00164", "Europe/Berlin"),("2833076", "Sendenhorst", "", "DE", "276", "", "07", "055", "05570", "51.84303", "7.82996", "Europe/Berlin"),("2833079", "Senden", "", "DE", "276", "", "07", "055", "05558", "51.85", "7.5", "Europe/Berlin"),("2833080", "Senden", "", "DE", "276", "", "02", "097", "09775", "48.32441", "10.04442", "Europe/Berlin"),("2833139", "Selters", "", "DE", "276", "", "05", "065", "06533", "50.51681", "8.28953", "Europe/Berlin"),("2833170", "Selm", "Зельм", "DE", "276", "", "07", "059", "05978", "51.69689", "7.46809", "Europe/Berlin"),("2833242", "Seligenstadt", "Зелигенштадт", "DE", "276", "", "05", "064", "06438", "50.0432", "8.97394", "Europe/Berlin"),("2833296", "Selb", "Зельб", "DE", "276", "", "02", "094", "09479", "50.17058", "12.13054", "Europe/Berlin"),("2833475", "Sehnde", "Зенде", "DE", "276", "", "06", "00", "03241", "52.31394", "9.9682", "Europe/Berlin"),("2833564", "Seevetal", "Зеветаль", "DE", "276", "", "06", "00", "03353", "53.4", "9.96667", "Europe/Berlin"),("2833592", "Seesen", "Зезен", "DE", "276", "", "06", "00", "03153", "51.89095", "10.17847", "Europe/Berlin"),("2833641", "Seelze", "Зельце", "DE", "276", "", "06", "00", "03241", "52.39635", "9.59727", "Europe/Berlin"),("2833651", "Seelow", "", "DE", "276", "", "11", "00", "12064", "52.53392", "14.38128", "Europe/Berlin"),("2833704", "Seelbach", "", "DE", "276", "", "01", "083", "08317", "48.31667", "7.95", "Europe/Berlin"),("2833866", "Seefeld", "", "DE", "276", "", "02", "091", "09188", "48.03505", "11.21395", "Europe/Berlin"),("2834102", "Sebnitz", "", "DE", "276", "", "13", "00", "14628", "50.9754", "14.27579", "Europe/Berlin"),("2834226", "Schwieberdingen", "", "DE", "276", "", "01", "081", "08118", "48.87644", "9.07439", "Europe/Berlin"),("2834240", "Schwetzingen", "Шветцинген", "DE", "276", "", "01", "082", "08226", "49.38217", "8.5823", "Europe/Berlin"),("2834265", "Schwerte", "Шверте", "DE", "276", "", "07", "059", "05978", "51.44387", "7.5675", "Europe/Berlin"),("2834282", "Schwerin", "Шверин", "DE", "276", "", "12", "00", "13004", "53.62937", "11.41316", "Europe/Berlin"),("2834334", "Schwendi", "", "DE", "276", "", "01", "084", "08426", "48.18333", "9.96667", "Europe/Berlin"),("2834372", "Schwelm", "Швельм", "DE", "276", "", "07", "059", "05954", "51.28635", "7.29388", "Europe/Berlin"),("2834498", "Schweinfurt", "Швайнфурт", "DE", "276", "", "02", "096", "09662", "50.04937", "10.22175", "Europe/Berlin"),("2834594", "Schweich", "", "DE", "276", "", "08", "00", "07235", "49.82215", "6.75256", "Europe/Berlin"),("2834629", "Schwedt (Oder)", "", "DE", "276", "", "11", "00", "12073", "53.05963", "14.28154", "Europe/Berlin"),("2834740", "Schwarzheide", "", "DE", "276", "", "11", "00", "12066", "51.47671", "13.85559", "Europe/Berlin"),("2834945", "Schwarzenfeld", "", "DE", "276", "", "02", "093", "09376", "49.38774", "12.13484", "Europe/Berlin"),("2834955", "Schwarzenbruck", "", "DE", "276", "", "02", "095", "09574", "49.35778", "11.24333", "Europe/Berlin"),("2834978", "Schwarzenberg", "Шварценберг", "DE", "276", "", "13", "00", "14521", "50.53791", "12.78522", "Europe/Berlin"),("2835013", "Schwarzenbek", "", "DE", "276", "", "10", "00", "01053", "53.50303", "10.48055", "Europe/Berlin"),("2835018", "Schwarzenbach an der Saale", "", "DE", "276", "", "02", "094", "09475", "50.22279", "11.93504", "Europe/Berlin"),("2835220", "Schwarmstedt", "", "DE", "276", "", "06", "00", "03358", "52.67794", "9.61767", "Europe/Berlin"),("2835260", "Schwanewede", "Шваневеде", "DE", "276", "", "06", "00", "03356", "53.23333", "8.6", "Europe/Berlin"),("2835297", "Schwandorf in Bayern", "", "DE", "276", "", "02", "093", "09376", "49.32534", "12.1098", "Europe/Berlin"),("2835342", "Schwalmtal", "", "DE", "276", "", "07", "051", "05166", "51.21667", "6.26667", "Europe/Berlin"),("2835345", "Schwalmstadt", "Швальмштадт", "DE", "276", "", "05", "066", "06634", "50.93333", "9.21667", "Europe/Berlin"),("2835381", "Schwalbach am Taunus", "", "DE", "276", "", "05", "064", "06436", "50.15", "8.53333", "Europe/Berlin"),("2835382", "Schwalbach", "", "DE", "276", "", "09", "00", "10044", "49.3", "6.81667", "Europe/Berlin"),("2835385", "Schwaikheim", "", "DE", "276", "", "01", "081", "08119", "48.87733", "9.34958", "Europe/Berlin"),("2835411", "Schwaigern", "", "DE", "276", "", "01", "081", "08125", "49.14494", "9.05525", "Europe/Berlin"),("2835421", "Schwaig", "", "DE", "276", "", "02", "095", "09574", "49.46955", "11.20064", "Europe/Berlin"),("2835477", "Schwabmünchen", "", "DE", "276", "", "02", "097", "09772", "48.17928", "10.75675", "Europe/Berlin"),("2835481", "Schwäbisch Hall", "", "DE", "276", "", "01", "081", "08127", "49.11127", "9.73908", "Europe/Berlin"),("2835482", "Schwäbisch Gmünd", "Швебиш-Гмюнд", "DE", "276", "", "01", "081", "08136", "48.79947", "9.79809", "Europe/Berlin"),("2835496", "Schwabhausen", "", "DE", "276", "", "02", "091", "09174", "48.40157", "11.35729", "Europe/Berlin"),("2835537", "Schwabach", "Швабах", "DE", "276", "", "02", "095", "09565", "49.33047", "11.02346", "Europe/Berlin"),("2835542", "Schwaan", "", "DE", "276", "", "12", "00", "13072", "53.94047", "12.10715", "Europe/Berlin"),("2835587", "Schüttorf", "", "DE", "276", "", "06", "00", "03456", "52.32281", "7.22176", "Europe/Berlin"),("2835596", "Schutterwald", "", "DE", "276", "", "01", "083", "08317", "48.45", "7.88333", "Europe/Berlin"),("2835635", "Bad Schussenried", "", "DE", "276", "", "01", "084", "08426", "48.00468", "9.65741", "Europe/Berlin"),("2835787", "Schulzendorf", "", "DE", "276", "", "11", "00", "12061", "52.36667", "13.58333", "Europe/Berlin"),("2836040", "Schrozberg", "", "DE", "276", "", "01", "081", "08127", "49.34528", "9.97944", "Europe/Berlin"),("2836084", "Schrobenhausen", "Шробенхаузен", "DE", "276", "", "02", "091", "09185", "48.56067", "11.26071", "Europe/Berlin"),("2836089", "Schriesheim", "", "DE", "276", "", "01", "082", "08226", "49.47372", "8.6636", "Europe/Berlin"),("2836203", "Schramberg", "Шрамберг", "DE", "276", "", "01", "083", "08325", "48.22399", "8.38583", "Europe/Berlin"),("2836251", "Schotten", "", "DE", "276", "", "05", "065", "06535", "50.50346", "9.12516", "Europe/Berlin"),("2836282", "Schortens", "", "DE", "276", "", "06", "00", "03455", "53.53333", "7.95", "Europe/Berlin"),("2836320", "Schorndorf", "Шорндорф", "DE", "276", "", "01", "081", "08119", "48.80537", "9.52721", "Europe/Berlin"),("2836390", "Schöppingen", "", "DE", "276", "", "07", "055", "05554", "52.1", "7.23333", "Europe/Berlin"),("2836396", "Schöppenstedt", "", "DE", "276", "", "06", "00", "03158", "52.14308", "10.7745", "Europe/Berlin"),("2836413", "Schopfheim", "Шопфхайм", "DE", "276", "", "01", "083", "08336", "47.65105", "7.82089", "Europe/Berlin"),("2836455", "Schonungen", "", "DE", "276", "", "02", "096", "09678", "50.05008", "10.30809", "Europe/Berlin"),("2836532", "Schönkirchen", "", "DE", "276", "", "10", "00", "01057", "54.33333", "10.23333", "Europe/Berlin"),("2836543", "Schöningen", "", "DE", "276", "", "06", "00", "03154", "52.13802", "10.96745", "Europe/Berlin"),("2836581", "Schönheide", "", "DE", "276", "", "13", "00", "14521", "50.50458", "12.52158", "Europe/Berlin"),("2836616", "Schongau", "", "DE", "276", "", "02", "091", "09190", "47.8124", "10.89664", "Europe/Berlin"),("2836746", "Schöneiche", "", "DE", "276", "", "11", "00", "12067", "52.47286", "13.69226", "Europe/Berlin"),("2836761", "Schönefeld", "", "DE", "276", "", "11", "00", "12061", "52.38333", "13.51667", "Europe/Berlin"),("2836788", "Schöneberg", "", "DE", "276", "", "16", "00", "11000", "52.46667", "13.35", "Europe/Berlin"),("2836809", "Schönebeck", "Шёнебек", "DE", "276", "", "14", "00", "15089", "52.01682", "11.7307", "Europe/Berlin"),("2837085", "Schönau am Königssee", "", "DE", "276", "DE", "02", "091", "09172", "47.60055", "12.98704", "Europe/Berlin"),("2837093", "Schönaich", "", "DE", "276", "", "01", "081", "08115", "48.65871", "9.06012", "Europe/Berlin"),("2837115", "Schömberg", "", "DE", "276", "", "01", "082", "08235", "48.78713", "8.64495", "Europe/Berlin"),("2837134", "Schöllnach", "", "DE", "276", "", "02", "092", "09271", "48.75412", "13.17781", "Europe/Berlin"),("2837291", "Schneverdingen", "Шнефердинген", "DE", "276", "", "06", "00", "03358", "53.11685", "9.79524", "Europe/Berlin"),("2837470", "Schneeberg", "Шнеберг", "DE", "276", "", "13", "00", "14521", "50.59465", "12.64139", "Europe/Berlin"),("2837572", "Schnaittach", "", "DE", "276", "", "02", "095", "09574", "49.55958", "11.34328", "Europe/Berlin"),("2837652", "Schmölln", "", "DE", "276", "", "15", "00", "16077", "50.89678", "12.35339", "Europe/Berlin"),("2837706", "Schmitten", "", "DE", "276", "", "05", "064", "06434", "50.26667", "8.45", "Europe/Berlin"),("2837954", "Schmelz", "", "DE", "276", "", "09", "00", "10044", "49.43333", "6.85", "Europe/Berlin"),("2838009", "Schmargendorf", "", "DE", "276", "", "16", "00", "11000", "52.47517", "13.29071", "Europe/Berlin"),("2838053", "Schmallenberg", "Шмалленберг", "DE", "276", "", "07", "059", "05958", "51.15473", "8.28505", "Europe/Berlin"),("2838059", "Schmalkalden", "Шмалькальден", "DE", "276", "", "15", "00", "16066", "50.72136", "10.44386", "Europe/Berlin"),("2838167", "Schlüsselfeld", "", "DE", "276", "", "02", "094", "09471", "49.75621", "10.61873", "Europe/Berlin"),("2838201", "Schlüchtern", "Шлюхтерн", "DE", "276", "", "05", "064", "06435", "50.34891", "9.52532", "Europe/Berlin"),("2838459", "Schlitz", "", "DE", "276", "", "05", "065", "06535", "50.67416", "9.56102", "Europe/Berlin"),("2838502", "Schliersee", "", "DE", "276", "", "02", "091", "09182", "47.73621", "11.85936", "Europe/Berlin"),("2838534", "Schliengen", "", "DE", "276", "", "01", "083", "08336", "47.75698", "7.57645", "Europe/Berlin"),("2838600", "Schleusingen", "", "DE", "276", "", "15", "00", "16069", "50.51076", "10.75658", "Europe/Berlin"),("2838634", "Schleswig", "Шлезвиг", "DE", "276", "", "10", "00", "01059", "54.52156", "9.5586", "Europe/Berlin"),("2838671", "Bad Schlema", "", "DE", "276", "", "13", "00", "14521", "50.60257", "12.67288", "Europe/Berlin"),("2838673", "Schleiz", "", "DE", "276", "", "15", "00", "16075", "50.57866", "11.81024", "Europe/Berlin"),("2838744", "Schleiden", "", "DE", "276", "", "07", "053", "05366", "50.52896", "6.47692", "Europe/Berlin"),("2838918", "Schlangenbad", "", "DE", "276", "", "05", "064", "06439", "50.1", "8.1", "Europe/Berlin"),("2838922", "Schlangen", "", "DE", "276", "", "07", "057", "05766", "51.80978", "8.84605", "Europe/Berlin"),("2839010", "Schladen", "", "DE", "276", "", "06", "00", "03158", "52.02218", "10.53967", "Europe/Berlin"),("2839050", "Schkeuditz", "Шкойдиц", "DE", "276", "", "13", "00", "14730", "51.39678", "12.22141", "Europe/Berlin"),("2839101", "Schipkau", "", "DE", "276", "", "11", "00", "12066", "51.51667", "13.88333", "Europe/Berlin"),("2839316", "Schiffweiler", "Шифвайлер", "DE", "276", "", "09", "00", "10043", "49.36667", "7.13333", "Europe/Berlin"),("2839335", "Schifferstadt", "Шифферштадт", "DE", "276", "", "08", "00", "07338", "49.38417", "8.3775", "Europe/Berlin"),("2839345", "Schiffdorf", "", "DE", "276", "", "06", "00", "03352", "53.53333", "8.65", "Europe/Berlin"),("2839393", "Schierling", "", "DE", "276", "", "02", "093", "09375", "48.83422", "12.13946", "Europe/Berlin"),("2839613", "Scheßlitz", "", "DE", "276", "", "02", "094", "09471", "49.97568", "11.03299", "Europe/Berlin"),("2839674", "Schermbeck", "", "DE", "276", "", "07", "051", "05170", "51.68333", "6.86667", "Europe/Berlin"),("2839819", "Schellerten", "", "DE", "276", "", "06", "00", "03254", "52.1853", "10.10227", "Europe/Berlin"),("2839888", "Schelklingen", "", "DE", "276", "", "01", "084", "08425", "48.37575", "9.73273", "Europe/Berlin"),("2840070", "Scheeßel", "", "DE", "276", "", "06", "00", "03357", "53.16667", "9.48333", "Europe/Berlin"),("2840393", "Scharbeutz", "", "DE", "276", "", "10", "00", "01055", "54.03333", "10.75", "Europe/Berlin"),("2840526", "Schallstadt", "", "DE", "276", "", "01", "083", "08315", "47.95855", "7.75755", "Europe/Berlin"),("2840555", "Schalksmühle", "", "DE", "276", "", "07", "059", "05962", "51.23333", "7.53333", "Europe/Berlin"),("2840634", "Schäftlarn", "", "DE", "276", "", "02", "091", "09184", "47.99027", "11.45591", "Europe/Berlin"),("2841039", "Schaafheim", "", "DE", "276", "", "05", "064", "06432", "49.92417", "9.00944", "Europe/Berlin"),("2841125", "Saulgau", "", "DE", "276", "", "01", "084", "08437", "48.01676", "9.50064", "Europe/Berlin"),("2841178", "Sauerlach", "", "DE", "276", "", "02", "091", "09184", "47.97171", "11.65383", "Europe/Berlin"),("2841290", "Satteldorf", "", "DE", "276", "", "01", "081", "08127", "49.16953", "10.07957", "Europe/Berlin"),("2841321", "Satow-Oberhagen", "", "DE", "276", "", "12", "00", "13072", "53.99545", "11.88466", "Europe/Berlin"),("2841333", "Saßnitz", "", "DE", "276", "", "12", "00", "13073", "54.5157", "13.64451", "Europe/Berlin"),("2841351", "Sassenberg", "", "DE", "276", "", "07", "055", "05570", "51.99223", "8.04068", "Europe/Berlin"),("2841374", "Sasel", "", "DE", "276", "", "04", "00", "02000", "53.65385", "10.11184", "Europe/Berlin"),("2841380", "Sasbach", "", "DE", "276", "", "01", "083", "08317", "48.63971", "8.09375", "Europe/Berlin"),("2841386", "Sarstedt", "Зарштедт", "DE", "276", "", "06", "00", "03254", "52.23495", "9.85411", "Europe/Berlin"),("2841463", "Sankt Wendel", "Санкт-Вендель", "DE", "276", "", "09", "00", "10046", "49.46633", "7.16814", "Europe/Berlin"),("2841577", "Sankt Johann", "", "DE", "276", "", "01", "084", "08415", "48.45397", "9.34396", "Europe/Berlin"),("2841590", "Sankt Ingbert", "", "DE", "276", "", "09", "00", "10045", "49.27697", "7.11672", "Europe/Berlin"),("2841619", "Sankt Georgen im Schwarzwald", "", "DE", "276", "", "01", "083", "08326", "48.12716", "8.33513", "Europe/Berlin"),("2841631", "St. Georg", "", "DE", "276", "", "04", "00", "02000", "53.55513", "10.01231", "Europe/Berlin"),("2841648", "Sankt Augustin", "Санкт-Августин", "DE", "276", "", "07", "053", "05382", "50.77538", "7.197", "Europe/Berlin"),("2841684", "Alt-Sanitz", "", "DE", "276", "", "12", "00", "13075", "53.81363", "13.58786", "Europe/Berlin"),("2841693", "Sangerhausen", "Зангерхаузен", "DE", "276", "", "14", "00", "15087", "51.47221", "11.29533", "Europe/Berlin"),("2841835", "Sandhausen", "", "DE", "276", "", "01", "082", "08226", "49.34278", "8.65917", "Europe/Berlin"),("2841879", "Sandersdorf", "", "DE", "276", "", "14", "00", "15082", "51.62841", "12.26492", "Europe/Berlin"),("2841895", "Sande", "", "DE", "276", "", "06", "00", "03455", "53.50489", "8.01418", "Europe/Berlin"),("2842109", "Salzweg", "", "DE", "276", "", "02", "092", "09275", "48.61667", "13.48333", "Europe/Berlin"),("2842112", "Salzwedel", "Зальцведель", "DE", "276", "", "14", "00", "15081", "52.85435", "11.1525", "Europe/Berlin"),("2842131", "Salzkotten", "Зальцкоттен", "DE", "276", "", "07", "057", "05774", "51.6717", "8.60092", "Europe/Berlin"),("2842143", "Salzhemmendorf", "", "DE", "276", "", "06", "00", "03252", "52.067", "9.5872", "Europe/Berlin"),("2842175", "Salzbergen", "", "DE", "276", "", "06", "00", "03454", "52.33333", "7.35", "Europe/Berlin"),("2842331", "Salach", "", "DE", "276", "", "01", "081", "08117", "48.69198", "9.73715", "Europe/Berlin"),("2842441", "Saerbeck", "", "DE", "276", "", "07", "055", "05566", "52.17372", "7.63395", "Europe/Berlin"),("2842621", "Saarwellingen", "", "DE", "276", "", "09", "00", "10044", "49.3543", "6.80487", "Europe/Berlin"),("2842632", "Saarlouis", "Саарлуисе", "DE", "276", "", "09", "00", "10044", "49.31366", "6.75154", "Europe/Berlin"),("2842644", "Saarburg", "", "DE", "276", "", "08", "00", "07235", "49.60641", "6.54365", "Europe/Berlin"),("2842647", "Saarbrücken", "Саарбрюккен", "DE", "276", "", "09", "00", "10041", "49.2354", "6.98165", "Europe/Berlin"),("2842688", "Saalfeld", "Заальфельд", "DE", "276", "", "15", "00", "16073", "50.64826", "11.36536", "Europe/Berlin"),("2842728", "Saal", "", "DE", "276", "", "02", "092", "09273", "48.90099", "11.93196", "Europe/Berlin"),("2842816", "Rüthen", "", "DE", "276", "", "07", "059", "05974", "51.4909", "8.43596", "Europe/Berlin"),("2842824", "Rutesheim", "", "DE", "276", "", "01", "081", "08115", "48.80808", "8.94536", "Europe/Berlin"),("2842884", "Rüsselsheim", "Рюссельсхайм", "DE", "276", "", "05", "064", "06433", "49.98955", "8.42251", "Europe/Berlin"),("2842960", "Ruppichteroth", "", "DE", "276", "", "07", "053", "05382", "50.84367", "7.48409", "Europe/Berlin"),("2843042", "Runkel", "", "DE", "276", "", "05", "065", "06533", "50.40574", "8.15457", "Europe/Berlin"),("2843106", "Rummelsburg", "", "DE", "276", "", "16", "00", "11000", "52.50146", "13.4934", "Europe/Berlin"),("2843146", "Rülzheim", "", "DE", "276", "", "08", "00", "07334", "49.16278", "8.28583", "Europe/Berlin"),("2843185", "Ruhstorf", "", "DE", "276", "", "02", "092", "09279", "48.53976", "12.68305", "Europe/Berlin"),("2843203", "Ruhpolding", "", "DE", "276", "", "02", "091", "09189", "47.76667", "12.65", "Europe/Berlin"),("2843258", "Ruhla", "", "DE", "276", "", "15", "00", "16063", "50.89296", "10.36573", "Europe/Berlin"),("2843350", "Rudow", "", "DE", "276", "", "16", "00", "11000", "52.42407", "13.48529", "Europe/Berlin"),("2843355", "Rudolstadt", "Рудольштадт", "DE", "276", "", "15", "00", "16073", "50.72043", "11.34046", "Europe/Berlin"),("2843395", "Rüdesheim am Rhein", "", "DE", "276", "", "05", "064", "06439", "49.98214", "7.92964", "Europe/Berlin"),("2843415", "Rudersberg", "", "DE", "276", "", "01", "081", "08119", "48.88515", "9.52927", "Europe/Berlin"),("2843636", "Rottweil", "Ротвайль", "DE", "276", "", "01", "083", "08325", "48.16783", "8.62719", "Europe/Berlin"),("2843682", "Rotthalmünster", "", "DE", "276", "", "02", "092", "09275", "48.35825", "13.20162", "Europe/Berlin"),("2843724", "Rottendorf", "", "DE", "276", "", "02", "096", "09679", "49.8", "10.03333", "Europe/Berlin"),("2843728", "Rottenburg an der Laaber", "", "DE", "276", "", "02", "092", "09274", "48.70233", "12.02717", "Europe/Berlin"),("2843729", "Rottenburg", "", "DE", "276", "", "01", "084", "08416", "48.47629", "8.93528", "Europe/Berlin"),("2843775", "Rottach-Egern", "", "DE", "276", "", "02", "091", "09182", "47.68966", "11.77065", "Europe/Berlin"),("2844056", "Rothenburg ob der Tauber", "", "DE", "276", "", "02", "095", "09571", "49.37885", "10.18711", "Europe/Berlin"),("2844062", "Rothenburg", "", "DE", "276", "", "13", "00", "14626", "51.334", "14.96874", "Europe/Berlin"),("2844126", "Röthenbach an der Pegnitz", "", "DE", "276", "", "02", "095", "09574", "49.48301", "11.24116", "Europe/Berlin"),("2844265", "Roth", "Рота", "DE", "276", "", "02", "095", "09576", "49.24762", "11.09111", "Europe/Berlin"),("2844277", "Roetgen", "", "DE", "276", "", "07", "053", "05334", "50.65", "6.2", "Europe/Berlin"),("2844434", "Rotenburg an der Fulda", "", "DE", "276", "", "05", "066", "06632", "50.99556", "9.72838", "Europe/Berlin"),("2844437", "Rotenburg", "Ротенбург", "DE", "276", "", "06", "00", "03357", "53.11125", "9.41082", "Europe/Berlin"),("2844567", "Rot am See", "", "DE", "276", "", "01", "081", "08127", "49.25", "10.01667", "Europe/Berlin"),("2844588", "Rostock", "Росток", "DE", "276", "", "12", "00", "13003", "54.0887", "12.14049", "Europe/Berlin"),("2844604", "Roßwein", "", "DE", "276", "", "13", "00", "14522", "51.06589", "13.18308", "Europe/Berlin"),("2844616", "Roßtal", "", "DE", "276", "", "02", "095", "09573", "49.39567", "10.88848", "Europe/Berlin"),("2844651", "Roßleben", "", "DE", "276", "", "15", "00", "16065", "51.29886", "11.43435", "Europe/Berlin"),("2844654", "Roßlau", "", "DE", "276", "", "14", "00", "15001", "51.88736", "12.24192", "Europe/Berlin"),("2844756", "Roßdorf", "", "DE", "276", "", "05", "064", "06432", "49.85972", "8.76167", "Europe/Berlin"),("2844862", "Rösrath", "Рёсрат", "DE", "276", "", "07", "053", "05378", "50.89559", "7.18175", "Europe/Berlin"),("2844910", "Rosenthal", "", "DE", "276", "DE", "16", "00", "11000", "52.59976", "13.37774", "Europe/Berlin"),("2844988", "Rosenheim", "Розенхайм", "DE", "276", "", "02", "091", "09163", "47.85637", "12.12247", "Europe/Berlin"),("2845027", "Rosenfeld", "", "DE", "276", "", "01", "084", "08417", "48.28639", "8.72357", "Europe/Berlin"),("2845131", "Rosdorf", "", "DE", "276", "", "06", "00", "03152", "51.5", "9.9", "Europe/Berlin"),("2845160", "Rosbach vor der Höhe", "", "DE", "276", "", "05", "064", "06440", "50.30332", "8.68976", "Europe/Berlin"),("2845222", "Ronnenberg", "", "DE", "276", "", "06", "00", "03241", "52.31939", "9.65544", "Europe/Berlin"),("2845229", "Ronneburg", "", "DE", "276", "", "15", "00", "16076", "50.8634", "12.18666", "Europe/Berlin"),("2845273", "Rommerskirchen", "", "DE", "276", "", "07", "051", "05162", "51.03333", "6.68333", "Europe/Berlin"),("2845565", "Röhrmoos", "", "DE", "276", "", "02", "091", "09174", "48.32966", "11.44672", "Europe/Berlin"),("2845641", "Rohrdorf", "", "DE", "276", "", "02", "091", "09187", "47.79713", "12.1701", "Europe/Berlin"),("2845723", "Rohrbach", "", "DE", "276", "", "02", "091", "09183", "48.28933", "12.55603", "Europe/Berlin"),("2845919", "Rödinghausen", "", "DE", "276", "", "07", "057", "05758", "52.25", "8.48333", "Europe/Berlin"),("2845924", "Roding", "", "DE", "276", "", "02", "093", "09372", "49.19426", "12.51956", "Europe/Berlin"),("2845953", "Rodewisch", "", "DE", "276", "", "13", "00", "14523", "50.53083", "12.41329", "Europe/Berlin"),("2846040", "Rodenberg", "", "DE", "276", "", "06", "00", "03257", "52.31152", "9.3564", "Europe/Berlin"),("2846063", "Rodenbach", "", "DE", "276", "", "05", "064", "06435", "50.15", "9.03333", "Europe/Berlin"),("2846158", "Rodalben", "", "DE", "276", "", "08", "00", "07340", "49.2394", "7.63962", "Europe/Berlin"),("2846229", "Rockenhausen", "", "DE", "276", "", "08", "00", "07333", "49.62974", "7.82134", "Europe/Berlin"),("2846261", "Rochlitz", "", "DE", "276", "", "13", "00", "14522", "51.05007", "12.79754", "Europe/Berlin"),("2846286", "Röbel", "", "DE", "276", "", "12", "00", "13071", "53.37555", "12.60372", "Europe/Berlin"),("2846398", "Ritterhude", "", "DE", "276", "", "06", "00", "03356", "53.18289", "8.7355", "Europe/Berlin"),("2846523", "Rinteln", "Ринтельн", "DE", "276", "", "06", "00", "03257", "52.18604", "9.07917", "Europe/Berlin"),("2846722", "Rimpar", "", "DE", "276", "", "02", "096", "09679", "49.85692", "9.95705", "Europe/Berlin"),("2846754", "Rimbach", "", "DE", "276", "", "05", "064", "06431", "49.625", "8.76306", "Europe/Berlin"),("2846843", "Rietberg", "Ритберг", "DE", "276", "", "07", "057", "05754", "51.80924", "8.42841", "Europe/Berlin"),("2846939", "Riesa", "Риза", "DE", "276", "", "13", "00", "14627", "51.30777", "13.29168", "Europe/Berlin"),("2847003", "Rielasingen-Worblingen", "", "DE", "276", "", "01", "083", "08335", "47.73465", "8.84013", "Europe/Berlin"),("2847013", "Riehl", "", "DE", "276", "", "07", "053", "05315", "50.96686", "6.97572", "Europe/Berlin"),("2847033", "Riegelsberg", "", "DE", "276", "", "09", "00", "10041", "49.3", "6.93333", "Europe/Berlin"),("2847080", "Riedlingen", "", "DE", "276", "", "01", "084", "08426", "48.15455", "9.47558", "Europe/Berlin"),("2847195", "Riedering", "", "DE", "276", "", "02", "091", "09187", "47.83874", "12.20778", "Europe/Berlin"),("2847231", "Riedenburg", "", "DE", "276", "", "02", "092", "09273", "48.96383", "11.6888", "Europe/Berlin"),("2847524", "Ribnitz-Damgarten", "Рибниц-Дамгартен", "DE", "276", "", "12", "00", "13073", "54.2422", "12.45666", "Europe/Berlin"),("2847586", "Rheurdt", "", "DE", "276", "", "07", "051", "05154", "51.46667", "6.46667", "Europe/Berlin"),("2847612", "Rheinsberg", "", "DE", "276", "", "11", "00", "12068", "53.09972", "12.89885", "Europe/Berlin"),("2847639", "Rheinfelden (Baden)", "Райнфельден", "DE", "276", "", "01", "083", "08336", "47.56013", "7.78715", "Europe/Berlin"),("2847645", "Rheine", "Райн", "DE", "276", "", "07", "055", "05566", "52.28509", "7.44055", "Europe/Berlin"),("2847662", "Rheinberg", "", "DE", "276", "", "07", "051", "05170", "51.54649", "6.59525", "Europe/Berlin"),("2847666", "Rheinbach", "Райнбах", "DE", "276", "", "07", "053", "05382", "50.62562", "6.94911", "Europe/Berlin"),("2847669", "Rheinau", "", "DE", "276", "", "01", "082", "08216", "48.87173", "8.19133", "Europe/Berlin"),("2847689", "Rhede", "Реде", "DE", "276", "", "07", "055", "05554", "51.83537", "6.69602", "Europe/Berlin"),("2847690", "Rheda-Wiedenbrück", "Ред-Виденбрюк", "DE", "276", "", "07", "057", "05754", "51.84967", "8.30017", "Europe/Berlin"),("2847736", "Reutlingen", "Ройтлинген", "DE", "276", "", "01", "084", "08415", "48.49144", "9.20427", "Europe/Berlin"),("2848110", "Reppenstedt", "", "DE", "276", "", "06", "00", "03355", "53.25", "10.35", "Europe/Berlin"),("2848175", "Renningen", "Реннинген", "DE", "276", "", "01", "081", "08115", "48.76974", "8.93871", "Europe/Berlin"),("2848181", "Rennertshofen", "", "DE", "276", "", "02", "091", "09185", "48.75943", "11.04544", "Europe/Berlin"),("2848245", "Rendsburg", "Рендсбург", "DE", "276", "", "10", "00", "01058", "54.30663", "9.66313", "Europe/Berlin"),("2848251", "Renchen", "", "DE", "276", "", "01", "083", "08317", "48.5885", "8.01321", "Europe/Berlin"),("2848273", "Remscheid", "Ремшайд", "DE", "276", "", "07", "051", "05120", "51.17983", "7.1925", "Europe/Berlin"),("2848335", "Remagen", "Ремаген", "DE", "276", "", "08", "00", "07131", "50.57879", "7.22703", "Europe/Berlin"),("2848340", "Rellingen", "", "DE", "276", "", "10", "00", "01056", "53.65", "9.81667", "Europe/Berlin"),("2848543", "Reiskirchen", "", "DE", "276", "", "05", "065", "06531", "50.6", "8.83333", "Europe/Berlin"),("2848621", "Reisbach", "", "DE", "276", "", "02", "092", "09279", "48.57008", "12.62799", "Europe/Berlin"),("2848725", "Reinsdorf", "", "DE", "276", "", "13", "00", "14524", "50.7", "12.58333", "Europe/Berlin"),("2848756", "Reinickendorf", "", "DE", "276", "", "16", "00", "11000", "52.56667", "13.33333", "Europe/Berlin"),("2848762", "Reinheim", "Райнхайм", "DE", "276", "", "05", "064", "06432", "49.82923", "8.83572", "Europe/Berlin"),("2848811", "Reinfeld", "", "DE", "276", "", "10", "00", "01062", "53.83184", "10.49126", "Europe/Berlin"),("2848845", "Reinbek", "Райнбек", "DE", "276", "", "10", "00", "01062", "53.51703", "10.2488", "Europe/Berlin"),("2848867", "Reilingen", "", "DE", "276", "", "01", "082", "08226", "49.29833", "8.56417", "Europe/Berlin"),("2849017", "Reichertshofen", "", "DE", "276", "", "02", "091", "09186", "48.65775", "11.46612", "Europe/Berlin"),("2849118", "Reichenbach an der Fils", "", "DE", "276", "", "01", "081", "08116", "48.71011", "9.46429", "Europe/Berlin"),("2849156", "Reichenbach/Vogtland", "", "DE", "276", "", "13", "00", "14523", "50.62279", "12.30344", "Europe/Berlin"),("2849197", "Reichelsheim", "", "DE", "276", "", "05", "064", "06440", "50.35638", "8.87446", "Europe/Berlin"),("2849198", "Reichelsheim", "", "DE", "276", "", "05", "064", "06437", "49.71211", "8.83896", "Europe/Berlin"),("2849371", "Rehburg-Loccum", "", "DE", "276", "", "06", "00", "03256", "52.46952", "9.19957", "Europe/Berlin"),("2849446", "Rehau", "", "DE", "276", "", "02", "094", "09475", "50.24921", "12.03422", "Europe/Berlin"),("2849476", "Regenstauf", "", "DE", "276", "", "02", "093", "09375", "49.12014", "12.13027", "Europe/Berlin"),("2849483", "Regensburg", "Регенсбург", "DE", "276", "", "02", "093", "09362", "49.01513", "12.10161", "Europe/Berlin"),("2849495", "Regen", "", "DE", "276", "", "02", "092", "09276", "48.9719", "13.12824", "Europe/Berlin"),("2849548", "Rees", "Рес", "DE", "276", "", "07", "051", "05154", "51.76263", "6.39778", "Europe/Berlin"),("2849568", "Rednitzhembach", "", "DE", "276", "", "02", "095", "09576", "49.30095", "11.07997", "Europe/Berlin"),("2849647", "Recklinghausen", "Реклингхаузен", "DE", "276", "", "07", "055", "05562", "51.61379", "7.19738", "Europe/Berlin"),("2849689", "Recke", "", "DE", "276", "", "07", "055", "05566", "52.38333", "7.71667", "Europe/Berlin"),("2849740", "Rechberghausen", "", "DE", "276", "", "01", "081", "08117", "48.7308", "9.64419", "Europe/Berlin"),("2849802", "Ravensburg", "Равенсбург", "DE", "276", "", "01", "084", "08436", "47.78198", "9.61062", "Europe/Berlin"),("2849913", "Raunheim", "", "DE", "276", "", "05", "064", "06433", "50.0132", "8.45253", "Europe/Berlin"),("2850056", "Rauenberg", "", "DE", "276", "", "01", "082", "08226", "49.26943", "8.70344", "Europe/Berlin"),("2850085", "Raubling", "", "DE", "276", "", "02", "091", "09187", "47.7905", "12.11088", "Europe/Berlin"),("2850132", "Ratzeburg", "", "DE", "276", "", "10", "00", "01053", "53.6947", "10.79084", "Europe/Berlin"),("2850174", "Ratingen", "Ратинген", "DE", "276", "", "07", "051", "05158", "51.29724", "6.84929", "Europe/Berlin"),("2850213", "Rathenow", "Ратенов", "DE", "276", "", "11", "00", "12063", "52.60659", "12.33696", "Europe/Berlin"),("2850224", "Rath", "", "DE", "276", "", "07", "053", "05315", "50.92379", "7.0927", "Europe/Berlin"),("2850235", "Ratekau", "Ратекау", "DE", "276", "", "10", "00", "01055", "53.95", "10.73333", "Europe/Berlin"),("2850253", "Rastede", "Растеде", "DE", "276", "", "06", "00", "03451", "53.25", "8.2", "Europe/Berlin"),("2850257", "Rastatt", "Раштатт", "DE", "276", "", "01", "082", "08216", "48.85851", "8.20965", "Europe/Berlin"),("2850425", "Ranstadt", "", "DE", "276", "", "05", "064", "06440", "50.35", "8.98333", "Europe/Berlin"),("2850490", "Rangsdorf", "", "DE", "276", "", "11", "00", "12072", "52.29126", "13.41946", "Europe/Berlin"),("2850496", "Rangendingen", "", "DE", "276", "", "01", "084", "08417", "48.38168", "8.8894", "Europe/Berlin"),("2850536", "Ramstein-Miesenbach", "", "DE", "276", "", "08", "00", "07335", "49.44452", "7.55533", "Europe/Berlin"),("2850777", "Raisdorf", "", "DE", "276", "", "10", "00", "01057", "54.28127", "10.24915", "Europe/Berlin"),("2850808", "Rain", "", "DE", "276", "", "02", "097", "09779", "48.69029", "10.91611", "Europe/Berlin"),("2850850", "Rahnsdorf", "", "DE", "276", "DE", "16", "00", "11000", "52.44115", "13.68708", "Europe/Berlin"),("2850887", "Rahden", "Раден", "DE", "276", "", "07", "057", "05770", "52.43367", "8.61263", "Europe/Berlin"),("2850942", "Raesfeld", "", "DE", "276", "", "07", "055", "05554", "51.76667", "6.85", "Europe/Berlin"),("2850954", "Radolfzell am Bodensee", "Радольфцелль", "DE", "276", "", "01", "083", "08335", "47.74194", "8.97098", "Europe/Berlin"),("2850995", "Radevormwald", "Радеформвальд", "DE", "276", "", "07", "053", "05374", "51.20219", "7.36027", "Europe/Berlin"),("2851074", "Radeburg", "", "DE", "276", "", "13", "00", "14627", "51.21516", "13.7281", "Europe/Berlin"),("2851077", "Radebeul", "Радебойль", "DE", "276", "", "13", "00", "14627", "51.10654", "13.66047", "Europe/Berlin"),("2851079", "Radeberg", "Радеберг", "DE", "276", "", "13", "00", "14625", "51.11112", "13.91199", "Europe/Berlin"),("2851337", "Quierschied", "", "DE", "276", "", "09", "00", "10041", "49.31667", "7.05", "Europe/Berlin"),("2851343", "Quickborn", "Квикборн", "DE", "276", "", "10", "00", "01056", "53.72831", "9.90934", "Europe/Berlin"),("2851393", "Querfurt", "", "DE", "276", "", "14", "00", "15088", "51.38124", "11.60047", "Europe/Berlin"),("2851465", "Quedlinburg", "Кведлинбург", "DE", "276", "", "14", "00", "15085", "51.78843", "11.15006", "Europe/Berlin"),("2851523", "Quakenbrück", "", "DE", "276", "", "06", "00", "03459", "52.67502", "7.94983", "Europe/Berlin"),("2851543", "Pyrbaum", "", "DE", "276", "", "02", "093", "09373", "49.29622", "11.28655", "Europe/Berlin"),("2851567", "Putzbrunn", "", "DE", "276", "", "02", "091", "09184", "48.07579", "11.71572", "Europe/Berlin"),("2851584", "Püttlingen", "Пютлинген", "DE", "276", "", "09", "00", "10041", "49.2855", "6.88723", "Europe/Berlin"),("2851739", "Pullach im Isartal", "", "DE", "276", "", "02", "091", "09184", "48.06122", "11.52148", "Europe/Berlin"),("2851746", "Pulheim", "Пульхайм", "DE", "276", "", "07", "053", "05362", "50.99965", "6.80632", "Europe/Berlin"),("2851782", "Puchheim", "", "DE", "276", "", "02", "091", "09179", "48.15", "11.35", "Europe/Berlin"),("2851826", "Prüm", "", "DE", "276", "", "08", "00", "07232", "50.20785", "6.42019", "Europe/Berlin"),("2851962", "Pritzwalk", "", "DE", "276", "", "11", "00", "12070", "53.14945", "12.17405", "Europe/Berlin"),("2852101", "Prien am Chiemsee", "", "DE", "276", "", "02", "091", "09187", "47.85602", "12.34623", "Europe/Berlin"),("2852144", "Preußisch Oldendorf", "", "DE", "276", "", "07", "057", "05770", "52.30589", "8.49341", "Europe/Berlin"),("2852217", "Prenzlauer Berg", "Пренцлауэр-Берг", "DE", "276", "", "16", "00", "11000", "52.53878", "13.42443", "Europe/Berlin"),("2852218", "Prenzlau", "Пренцлау", "DE", "276", "", "11", "00", "12073", "53.31625", "13.86261", "Europe/Berlin"),("2852233", "Premnitz", "", "DE", "276", "", "11", "00", "12063", "52.53184", "12.34845", "Europe/Berlin"),("2852280", "Preetz", "Прец", "DE", "276", "", "10", "00", "01057", "54.2354", "10.27795", "Europe/Berlin"),("2852422", "Pöttmes", "", "DE", "276", "", "02", "097", "09771", "48.58383", "11.08762", "Europe/Berlin"),("2852440", "Pottenstein", "", "DE", "276", "", "02", "094", "09472", "49.77131", "11.40784", "Europe/Berlin"),("2852458", "Potsdam", "Потсдам", "DE", "276", "", "11", "00", "12054", "52.39886", "13.06566", "Europe/Berlin"),("2852512", "Pößneck", "", "DE", "276", "", "15", "00", "16075", "50.69358", "11.59229", "Europe/Berlin"),("2852566", "Porz am Rhein", "", "DE", "276", "", "07", "053", "05315", "50.88637", "7.0583", "Europe/Berlin"),("2852577", "Porta Westfalica", "", "DE", "276", "", "07", "057", "05770", "52.23779", "8.91901", "Europe/Berlin"),("2852673", "Poppenbüttel", "", "DE", "276", "", "04", "00", "02000", "53.65917", "10.08472", "Europe/Berlin"),("2852772", "Pommelsbrunn", "", "DE", "276", "", "02", "095", "09574", "49.50437", "11.51101", "Europe/Berlin"),("2852863", "Poll", "", "DE", "276", "", "07", "053", "05315", "50.91256", "6.99057", "Europe/Berlin"),("2852909", "Polch", "", "DE", "276", "", "08", "00", "07137", "50.29973", "7.31315", "Europe/Berlin"),("2852939", "Poing", "", "DE", "276", "", "02", "091", "09175", "48.17004", "11.81863", "Europe/Berlin"),("2853065", "Pocking", "", "DE", "276", "", "02", "092", "09275", "48.40149", "13.31315", "Europe/Berlin"),("2853066", "Pöcking", "", "DE", "276", "", "02", "091", "09188", "47.96667", "11.3", "Europe/Berlin"),("2853107", "Plüderhausen", "", "DE", "276", "", "01", "081", "08119", "48.79875", "9.59587", "Europe/Berlin"),("2853162", "Plön", "", "DE", "276", "", "10", "00", "01057", "54.16241", "10.42333", "Europe/Berlin"),("2853180", "Plochingen", "", "DE", "276", "", "01", "081", "08116", "48.71067", "9.41949", "Europe/Berlin"),("2853192", "Pliezhausen", "", "DE", "276", "", "01", "084", "08415", "48.55934", "9.20749", "Europe/Berlin"),("2853209", "Plettenberg", "Плеттенберг", "DE", "276", "", "07", "059", "05962", "51.20949", "7.87261", "Europe/Berlin"),("2853260", "Pleinfeld", "", "DE", "276", "", "02", "095", "09577", "49.10473", "10.98194", "Europe/Berlin"),("2853266", "Pleidelsheim", "", "DE", "276", "", "01", "081", "08118", "48.9592", "9.20311", "Europe/Berlin"),("2853292", "Plauen", "Плауэн", "DE", "276", "", "13", "00", "14523", "50.4973", "12.13782", "Europe/Berlin"),("2853297", "Plau am See", "", "DE", "276", "", "12", "00", "13076", "53.45821", "12.26246", "Europe/Berlin"),("2853310", "Plattling", "", "DE", "276", "", "02", "092", "09271", "48.77866", "12.87509", "Europe/Berlin"),("2853435", "Plankstadt", "", "DE", "276", "", "01", "082", "08226", "49.39444", "8.59611", "Europe/Berlin"),("2853463", "Planegg", "", "DE", "276", "", "02", "091", "09184", "48.1", "11.41667", "Europe/Berlin"),("2853471", "Plaidt", "", "DE", "276", "", "08", "00", "07137", "50.3926", "7.39251", "Europe/Berlin"),("2853572", "Pirna", "Пирна", "DE", "276", "", "13", "00", "14628", "50.95843", "13.93702", "Europe/Berlin"),("2853574", "Pirmasens", "Пирмазенс", "DE", "276", "", "08", "00", "07317", "49.20145", "7.60529", "Europe/Berlin"),("2853658", "Pinneberg", "Пиннеберг", "DE", "276", "", "10", "00", "01056", "53.66732", "9.78936", "Europe/Berlin"),("2853691", "Pilsting", "", "DE", "276", "", "02", "092", "09279", "48.70116", "12.65105", "Europe/Berlin"),("2853855", "Piding", "", "DE", "276", "", "02", "091", "09172", "47.76667", "12.91667", "Europe/Berlin"),("2853907", "Philippsburg", "", "DE", "276", "", "01", "082", "08215", "49.2317", "8.46074", "Europe/Berlin"),("2853924", "Pfungstadt", "Пфунгштадт", "DE", "276", "", "05", "064", "06432", "49.80557", "8.60307", "Europe/Berlin"),("2853928", "Pfullingen", "Пфуллинген", "DE", "276", "", "01", "084", "08415", "48.46458", "9.22796", "Europe/Berlin"),("2853930", "Pfullendorf", "", "DE", "276", "", "01", "084", "08437", "47.9261", "9.2578", "Europe/Berlin"),("2853949", "Pfronten", "", "DE", "276", "", "02", "097", "09777", "47.5822", "10.54962", "Europe/Berlin"),("2853961", "Pfreimd", "", "DE", "276", "", "02", "093", "09376", "49.49114", "12.18069", "Europe/Berlin"),("2853969", "Pforzheim", "Пфорцхайм", "DE", "276", "", "01", "082", "08231", "48.88436", "8.69892", "Europe/Berlin"),("2854152", "Pfedelbach", "", "DE", "276", "", "01", "081", "08126", "49.17806", "9.505", "Europe/Berlin"),("2854179", "Pfarrkirchen", "", "DE", "276", "", "02", "092", "09277", "48.43205", "12.93812", "Europe/Berlin"),("2854252", "Pfalzgrafenweiler", "", "DE", "276", "", "01", "082", "08237", "48.5265", "8.56582", "Europe/Berlin"),("2854384", "Pfaffenhofen an der Roth", "", "DE", "276", "", "02", "097", "09775", "48.35454", "10.16184", "Europe/Berlin"),("2854386", "Pfaffenhofen an der Ilm", "Пфаффенхофен-ан-дер-Ильм", "DE", "276", "", "02", "091", "09186", "48.53053", "11.505", "Europe/Berlin"),("2854646", "Petershausen", "", "DE", "276", "", "02", "091", "09174", "48.4", "11.46667", "Europe/Berlin"),("2854653", "Petershagen", "", "DE", "276", "", "11", "00", "12064", "52.52078", "13.78748", "Europe/Berlin"),("2854655", "Petershagen", "Петерсхаген", "DE", "276", "", "07", "057", "05770", "52.37513", "8.96538", "Europe/Berlin"),("2854706", "Petersberg", "", "DE", "276", "", "05", "066", "06631", "50.56187", "9.71312", "Europe/Berlin"),("2854737", "Petersaurach", "", "DE", "276", "", "02", "095", "09571", "49.3", "10.75", "Europe/Berlin"),("2854848", "Perleberg", "", "DE", "276", "", "11", "00", "12070", "53.07583", "11.85739", "Europe/Berlin"),("2854923", "Penzberg", "Пенцберг", "DE", "276", "", "02", "091", "09190", "47.75293", "11.377", "Europe/Berlin"),("2854928", "Pentling", "", "DE", "276", "", "02", "093", "09375", "48.98343", "12.0587", "Europe/Berlin"),("2854967", "Penig", "", "DE", "276", "", "13", "00", "14522", "50.93336", "12.70422", "Europe/Berlin"),("2855024", "Peitz", "", "DE", "276", "", "11", "00", "12071", "51.85841", "14.41138", "Europe/Berlin"),("2855025", "Peiting", "", "DE", "276", "", "02", "091", "09190", "47.79549", "10.92951", "Europe/Berlin"),("2855029", "Peißenberg", "", "DE", "276", "", "02", "091", "09190", "47.80466", "11.0699", "Europe/Berlin"),("2855047", "Peine", "Пайне", "DE", "276", "", "06", "00", "03157", "52.31928", "10.2352", "Europe/Berlin"),("2855065", "Pegnitz", "", "DE", "276", "", "02", "094", "09472", "49.75216", "11.54187", "Europe/Berlin"),("2855243", "Pattensen", "", "DE", "276", "", "06", "00", "03241", "52.26448", "9.76436", "Europe/Berlin"),("2855328", "Passau", "Пассау", "DE", "276", "", "02", "092", "09262", "48.5665", "13.43122", "Europe/Berlin"),("2855334", "Pasing", "", "DE", "276", "", "02", "091", "09162", "48.14146", "11.45599", "Europe/Berlin"),("2855337", "Pasewalk", "", "DE", "276", "", "12", "00", "13075", "53.50627", "13.98997", "Europe/Berlin"),("2855388", "Parsberg", "", "DE", "276", "", "02", "093", "09373", "49.16074", "11.71834", "Europe/Berlin"),("2855441", "Parchim", "Пархим", "DE", "276", "", "12", "00", "13076", "53.42631", "11.84875", "Europe/Berlin"),("2855525", "Papenburg", "Папенбург", "DE", "276", "", "06", "00", "03454", "53.07738", "7.40444", "Europe/Berlin"),("2855598", "Pankow", "Панков", "DE", "276", "", "16", "00", "11000", "52.56926", "13.40186", "Europe/Berlin"),("2855745", "Paderborn", "Падерборн", "DE", "276", "", "07", "057", "05774", "51.71905", "8.75439", "Europe/Berlin"),("2855794", "Oyten", "", "DE", "276", "", "06", "00", "03361", "53.05", "9.01667", "Europe/Berlin"),("2855859", "Overath", "Оверат", "DE", "276", "", "07", "053", "05378", "50.93275", "7.28389", "Europe/Berlin"),("2855881", "Ovelgönne", "", "DE", "276", "", "06", "00", "03461", "53.34189", "8.42179", "Europe/Berlin"),("2855917", "Ottweiler", "Отвайлер", "DE", "276", "", "09", "00", "10043", "49.40133", "7.16424", "Europe/Berlin"),("2855935", "Ottobrunn", "Оттобрунн", "DE", "276", "", "02", "091", "09184", "48.06489", "11.66327", "Europe/Berlin"),("2855937", "Ottobeuren", "", "DE", "276", "", "02", "097", "09778", "47.9413", "10.29971", "Europe/Berlin"),("2855984", "Ottersweier", "", "DE", "276", "", "01", "082", "08216", "48.67022", "8.11323", "Europe/Berlin"),("2856014", "Ottersberg", "", "DE", "276", "", "06", "00", "03361", "53.1099", "9.14408", "Europe/Berlin"),("2856024", "Otterndorf", "", "DE", "276", "", "06", "00", "03352", "53.80908", "8.90068", "Europe/Berlin"),("2856042", "Otterberg", "", "DE", "276", "", "08", "00", "07335", "49.50301", "7.76995", "Europe/Berlin"),("2856107", "Ottendorf-Okrilla", "", "DE", "276", "", "13", "00", "14625", "51.18333", "13.83333", "Europe/Berlin"),("2856184", "Oststeinbek", "", "DE", "276", "", "10", "00", "01062", "53.55", "10.16667", "Europe/Berlin"),("2856193", "Ostseebad Kühlungsborn", "", "DE", "276", "", "12", "00", "13072", "54.15035", "11.75994", "Europe/Berlin"),("2856198", "Ostseebad Binz", "", "DE", "276", "", "12", "00", "13073", "54.39995", "13.61052", "Europe/Berlin"),("2856207", "Östringen", "", "DE", "276", "", "01", "082", "08215", "49.21911", "8.71192", "Europe/Berlin"),("2856213", "Ostrhauderfehn", "", "DE", "276", "", "06", "00", "03457", "53.13333", "7.61667", "Europe/Berlin"),("2856222", "Ostrach", "", "DE", "276", "", "01", "084", "08437", "47.95", "9.38333", "Europe/Berlin"),("2856278", "Osthofen", "", "DE", "276", "", "08", "00", "07331", "49.70382", "8.32419", "Europe/Berlin"),("2856288", "Ostheim", "", "DE", "276", "", "07", "053", "05315", "50.93117", "7.04412", "Europe/Berlin"),("2856390", "Osterrönfeld", "", "DE", "276", "", "10", "00", "01058", "54.29013", "9.699", "Europe/Berlin"),("2856500", "Osterholz-Scharmbeck", "Остерхольц-Шармбек", "DE", "276", "", "06", "00", "03356", "53.22698", "8.79528", "Europe/Berlin"),("2856530", "Osterhofen", "", "DE", "276", "", "02", "092", "09271", "48.7", "13.02221", "Europe/Berlin"),("2856629", "Ostercappeln", "", "DE", "276", "", "06", "00", "03459", "52.35", "8.23333", "Europe/Berlin"),("2856637", "Osterburken", "", "DE", "276", "", "01", "082", "08225", "49.42997", "9.42252", "Europe/Berlin"),("2856639", "Osterburg", "", "DE", "276", "", "14", "00", "15090", "52.78721", "11.75297", "Europe/Berlin"),("2856816", "Ostbevern", "", "DE", "276", "", "07", "055", "05570", "52.05", "7.85", "Europe/Berlin"),("2856883", "Osnabrück", "Оснабрюк", "DE", "276", "", "06", "00", "03404", "52.27264", "8.0498", "Europe/Berlin"),("2856930", "Oschersleben", "Ошерслебен", "DE", "276", "", "14", "00", "15083", "52.03039", "11.22898", "Europe/Berlin"),("2856944", "Oschatz", "Ошац", "DE", "276", "", "13", "00", "14730", "51.30001", "13.10984", "Europe/Berlin"),("2857011", "Ortenburg", "", "DE", "276", "", "02", "092", "09275", "48.54597", "13.2225", "Europe/Berlin"),("2857012", "Ortenberg", "", "DE", "276", "", "05", "064", "06440", "50.35584", "9.05602", "Europe/Berlin"),("2857075", "Oerlenbach", "", "DE", "276", "", "02", "096", "09672", "50.15", "10.13333", "Europe/Berlin"),("2857129", "Oranienburg", "Ораниенбург", "DE", "276", "", "11", "00", "12065", "52.75577", "13.24197", "Europe/Berlin"),("2857167", "Oppenheim", "", "DE", "276", "", "08", "00", "07339", "49.8547", "8.35974", "Europe/Berlin"),("2857185", "Opladen", "Опладен", "DE", "276", "", "07", "053", "05316", "51.05521", "7.01931", "Europe/Berlin"),("2857291", "Olsberg", "Ольсберг", "DE", "276", "", "07", "059", "05958", "51.35613", "8.48899", "Europe/Berlin"),("2857306", "Olpe", "Ольпе", "DE", "276", "", "07", "059", "05966", "51.02899", "7.85139", "Europe/Berlin"),("2857363", "Olfen", "", "DE", "276", "", "07", "055", "05558", "51.70787", "7.37893", "Europe/Berlin"),("2857451", "Oldenburg in Holstein", "", "DE", "276", "", "10", "00", "01055", "54.29576", "10.90156", "Europe/Berlin"),("2857458", "Oldenburg", "Ольденбург", "DE", "276", "", "06", "00", "03403", "53.14118", "8.21467", "Europe/Berlin"),("2857472", "Olching", "Ольхинг", "DE", "276", "", "02", "091", "09179", "48.2", "11.33333", "Europe/Berlin"),("2857481", "Olbersdorf", "", "DE", "276", "", "13", "00", "14626", "50.87304", "14.77035", "Europe/Berlin"),("2857484", "Olbernhau", "", "DE", "276", "", "13", "00", "14521", "50.6587", "13.3425", "Europe/Berlin"),("2857565", "Öhringen", "Эринген", "DE", "276", "", "01", "081", "08126", "49.19884", "9.5072", "Europe/Berlin"),("2857650", "Ohlsdorf", "", "DE", "276", "", "04", "00", "02000", "53.62594", "10.03145", "Europe/Berlin"),("2857752", "Oftersheim", "", "DE", "276", "", "01", "082", "08226", "49.36528", "8.58306", "Europe/Berlin"),("2857798", "Offenburg", "Оффенбург", "DE", "276", "", "01", "083", "08317", "48.47377", "7.94495", "Europe/Berlin"),("2857803", "Offenbach an der Queich", "", "DE", "276", "", "08", "00", "07337", "49.20222", "8.18111", "Europe/Berlin"),("2857807", "Offenbach", "", "DE", "276", "", "05", "064", "06413", "50.10061", "8.76647", "Europe/Berlin"),("2857847", "Oettingen in Bayern", "", "DE", "276", "", "02", "097", "09779", "48.95274", "10.60465", "Europe/Berlin"),("2857900", "Oerlinghausen", "Эрлингхаузен", "DE", "276", "", "07", "057", "05766", "51.95453", "8.6622", "Europe/Berlin"),("2857904", "Oer-Erkenschwick", "Ор-Эркеншвик", "DE", "276", "", "07", "055", "05562", "51.64198", "7.26451", "Europe/Berlin"),("2857918", "Oelsnitz", "", "DE", "276", "", "13", "00", "14521", "50.72584", "12.701", "Europe/Berlin"),("2857919", "Oelsnitz", "", "DE", "276", "", "13", "00", "14523", "50.4147", "12.1695", "Europe/Berlin"),("2857943", "Oelde", "Ольде", "DE", "276", "", "07", "055", "05570", "51.8289", "8.14724", "Europe/Berlin"),("2857967", "Oedheim", "", "DE", "276", "", "01", "081", "08125", "49.24028", "9.25333", "Europe/Berlin"),("2857970", "Oederan", "", "DE", "276", "", "13", "00", "14522", "50.86064", "13.17164", "Europe/Berlin"),("2857985", "Oebisfelde", "", "DE", "276", "", "14", "00", "15083", "52.43421", "10.98786", "Europe/Berlin"),("2858103", "Odenthal", "Оденталь", "DE", "276", "", "07", "053", "05378", "51.03333", "7.11667", "Europe/Berlin"),("2858245", "Ochtrup", "Охтруп", "DE", "276", "", "07", "055", "05566", "52.20802", "7.18988", "Europe/Berlin"),("2858253", "Ochtendung", "", "DE", "276", "", "08", "00", "07137", "50.35", "7.38333", "Europe/Berlin"),("2858326", "Ochsenhausen", "", "DE", "276", "", "01", "084", "08426", "48.07029", "9.9503", "Europe/Berlin"),("2858333", "Ochsenfurt", "", "DE", "276", "", "02", "096", "09679", "49.66429", "10.06227", "Europe/Berlin"),("2858417", "Obrigheim", "", "DE", "276", "", "01", "082", "08225", "49.35194", "9.09083", "Europe/Berlin"),("2858729", "Oberviechtach", "", "DE", "276", "", "02", "093", "09376", "49.45809", "12.41669", "Europe/Berlin"),("2858738", "Oberursel", "", "DE", "276", "", "05", "064", "06434", "50.20731", "8.57747", "Europe/Berlin"),("2858763", "Obertshausen", "Обертсхаузен", "DE", "276", "", "05", "064", "06438", "50.07139", "8.85123", "Europe/Berlin"),("2858773", "Obertraubling", "", "DE", "276", "", "02", "093", "09375", "48.96667", "12.16667", "Europe/Berlin"),("2858787", "Oberthulba", "", "DE", "276", "", "02", "096", "09672", "50.19904", "9.95882", "Europe/Berlin"),("2858807", "Oberthal", "", "DE", "276", "", "09", "00", "10046", "49.51667", "7.1", "Europe/Berlin"),("2858906", "Oberstenfeld", "", "DE", "276", "", "01", "081", "08118", "49.02611", "9.32083", "Europe/Berlin"),("2858964", "Oberstdorf", "", "DE", "276", "", "02", "097", "09780", "47.40724", "10.27939", "Europe/Berlin"),("2858966", "Oberstaufen", "", "DE", "276", "", "02", "097", "09780", "47.55568", "10.02245", "Europe/Berlin"),("2859103", "Oberschöneweide", "", "DE", "276", "DE", "16", "00", "11000", "52.46106", "13.52108", "Europe/Berlin"),("2859147", "Oberschleißheim", "", "DE", "276", "", "02", "091", "09184", "48.25", "11.56667", "Europe/Berlin"),("2859199", "Ober-Saulheim", "", "DE", "276", "", "08", "00", "07331", "49.86376", "8.13526", "Europe/Berlin"),("2859380", "Ober-Ramstadt", "Обер-Рамштадт", "DE", "276", "", "05", "064", "06432", "49.83078", "8.74887", "Europe/Berlin"),("2859532", "Obernkirchen", "", "DE", "276", "", "06", "00", "03257", "52.2721", "9.12912", "Europe/Berlin"),("2859654", "Oberndorf", "", "DE", "276", "", "01", "083", "08325", "48.2905", "8.57221", "Europe/Berlin"),("2859675", "Obernburg am Main", "", "DE", "276", "", "02", "096", "09676", "49.83577", "9.13101", "Europe/Berlin"),("2859739", "Ober-Mörlen", "", "DE", "276", "", "05", "064", "06440", "50.3735", "8.69087", "Europe/Berlin"),("2859843", "Oberlungwitz", "", "DE", "276", "", "13", "00", "14524", "50.7823", "12.70789", "Europe/Berlin"),("2860021", "Oberkotzau", "", "DE", "276", "", "02", "094", "09475", "50.26236", "11.93484", "Europe/Berlin"),("2860049", "Oberkochen", "", "DE", "276", "", "01", "081", "08136", "48.78379", "10.10519", "Europe/Berlin"),("2860080", "Oberkirch", "Оберкирх", "DE", "276", "", "01", "083", "08317", "48.53241", "8.07864", "Europe/Berlin"),("2860400", "Oberhausen-Rheinhausen", "", "DE", "276", "", "01", "082", "08215", "49.27389", "8.47167", "Europe/Berlin"),("2860410", "Oberhausen", "Оберхаузен", "DE", "276", "", "07", "051", "05119", "51.47311", "6.88074", "Europe/Berlin"),("2860525", "Oberhaching", "", "DE", "276", "", "02", "091", "09184", "48.02455", "11.59744", "Europe/Berlin"),("2860540", "Obergünzburg", "", "DE", "276", "", "02", "097", "09777", "47.84545", "10.41821", "Europe/Berlin"),("2861096", "Oberding", "", "DE", "276", "", "02", "091", "09177", "48.31667", "11.85", "Europe/Berlin"),("2861116", "Oberderdingen", "", "DE", "276", "", "01", "082", "08215", "49.06556", "8.80306", "Europe/Berlin"),("2861232", "Oberboihingen", "", "DE", "276", "", "01", "081", "08116", "48.65", "9.36667", "Europe/Berlin"),("2861402", "Oberasbach", "", "DE", "276", "", "02", "095", "09573", "49.42275", "10.95766", "Europe/Berlin"),("2861422", "Oberammergau", "", "DE", "276", "", "02", "091", "09180", "47.59812", "11.06692", "Europe/Berlin"),("2861579", "Nußloch", "", "DE", "276", "", "01", "082", "08226", "49.32389", "8.69556", "Europe/Berlin"),("2861632", "Nürtingen", "Нюртинген", "DE", "276", "", "01", "081", "08116", "48.62565", "9.34203", "Europe/Berlin"),("2861650", "Nürnberg", "Нюрнберг", "DE", "276", "", "02", "095", "09564", "49.45421", "11.07752", "Europe/Berlin"),("2861671", "Nünchritz", "", "DE", "276", "", "13", "00", "14627", "51.29993", "13.38555", "Europe/Berlin"),("2861677", "Nümbrecht", "Нюмбрехт", "DE", "276", "", "07", "053", "05374", "50.9", "7.55", "Europe/Berlin"),("2861690", "Nufringen", "", "DE", "276", "", "01", "081", "08115", "48.62253", "8.89009", "Europe/Berlin"),("2861733", "Nottuln", "Ноттульн", "DE", "276", "", "07", "055", "05558", "51.93333", "7.35", "Europe/Berlin"),("2861788", "Nossen", "", "DE", "276", "", "13", "00", "14627", "51.05798", "13.29652", "Europe/Berlin"),("2861801", "Nörvenich", "", "DE", "276", "", "07", "053", "05358", "50.80604", "6.63952", "Europe/Berlin"),("2861804", "Nortorf", "", "DE", "276", "", "10", "00", "01058", "54.16738", "9.85437", "Europe/Berlin"),("2861814", "Northeim", "Нортхайм", "DE", "276", "", "06", "00", "03155", "51.70662", "9.99997", "Europe/Berlin"),("2861817", "Nörten-Hardenberg", "", "DE", "276", "", "06", "00", "03155", "51.62878", "9.93593", "Europe/Berlin"),("2861847", "Nordwalde", "", "DE", "276", "", "07", "055", "05566", "52.08333", "7.48333", "Europe/Berlin"),("2861866", "Nordstemmen", "", "DE", "276", "", "06", "00", "03254", "52.16196", "9.7835", "Europe/Berlin"),("2861914", "Nördlingen", "Нёрдлинген", "DE", "276", "", "02", "097", "09779", "48.85122", "10.48868", "Europe/Berlin"),("2861923", "Nordkirchen", "", "DE", "276", "", "07", "055", "05558", "51.73333", "7.53333", "Europe/Berlin"),("2861934", "Nordhorn", "Нордхорн", "DE", "276", "", "06", "00", "03456", "52.43081", "7.06833", "Europe/Berlin"),("2861939", "Nordholz", "", "DE", "276", "", "06", "00", "03352", "53.78333", "8.6", "Europe/Berlin"),("2861973", "Nordheim", "", "DE", "276", "", "01", "081", "08125", "49.10861", "9.12778", "Europe/Berlin"),("2861982", "Nordhausen", "Нордхаузен", "DE", "276", "", "15", "00", "16062", "51.5018", "10.7957", "Europe/Berlin"),("2862026", "Norderstedt", "Нордерштедт", "DE", "276", "", "10", "00", "01060", "53.6859", "9.98041", "Europe/Berlin"),("2862041", "Norderney", "", "DE", "276", "", "06", "00", "03452", "53.70828", "7.15819", "Europe/Berlin"),("2862104", "Nordenham", "Норденхаме", "DE", "276", "", "06", "00", "03461", "53.4861", "8.48093", "Europe/Berlin"),("2862118", "Norden", "Норден", "DE", "276", "", "06", "00", "03452", "53.59552", "7.20639", "Europe/Berlin"),("2862174", "Nonnweiler", "", "DE", "276", "", "09", "00", "10046", "49.61667", "6.95", "Europe/Berlin"),("2862294", "Nohfelden", "", "DE", "276", "", "09", "00", "10046", "49.58693", "7.14283", "Europe/Berlin"),("2862347", "Nittendorf", "", "DE", "276", "", "02", "093", "09375", "49.02459", "11.96126", "Europe/Berlin"),("2862348", "Nittenau", "", "DE", "276", "", "02", "093", "09376", "49.19425", "12.26741", "Europe/Berlin"),("2862375", "Nippes", "", "DE", "276", "", "07", "053", "05315", "50.96545", "6.95314", "Europe/Berlin"),("2862423", "Nikolassee", "", "DE", "276", "", "16", "00", "11000", "52.4344", "13.20095", "Europe/Berlin"),("2862460", "Niesky", "", "DE", "276", "", "13", "00", "14626", "51.29241", "14.82107", "Europe/Berlin"),("2862485", "Nierstein", "", "DE", "276", "", "08", "00", "07339", "49.87528", "8.34667", "Europe/Berlin"),("2862620", "Nienburg", "Нинбург", "DE", "276", "", "06", "00", "03256", "52.6461", "9.22086", "Europe/Berlin"),("2862675", "Nieheim", "", "DE", "276", "", "07", "057", "05762", "51.80499", "9.11302", "Europe/Berlin"),("2862698", "Niederzier", "", "DE", "276", "", "07", "053", "05358", "50.88333", "6.46667", "Europe/Berlin"),("2862724", "Niederwiesa", "", "DE", "276", "", "13", "00", "14522", "50.86667", "13.01667", "Europe/Berlin"),("2862733", "Niederwerrn", "", "DE", "276", "", "02", "096", "09678", "50.06149", "10.1827", "Europe/Berlin"),("2862831", "Niederstetten", "", "DE", "276", "", "01", "081", "08128", "49.4", "9.91944", "Europe/Berlin"),("2862888", "Niederschönhausen", "Нидершёнхаузен", "DE", "276", "DE", "16", "00", "11000", "52.58483", "13.40272", "Europe/Berlin"),("2862890", "Niederschöneweide", "", "DE", "276", "", "16", "00", "11000", "52.45564", "13.51554", "Europe/Berlin"),("2863014", "Nieder-Olm", "", "DE", "276", "", "08", "00", "07339", "49.91166", "8.20533", "Europe/Berlin"),("2863046", "Niedernhausen", "", "DE", "276", "", "05", "064", "06439", "50.15", "8.31667", "Europe/Berlin"),("2863199", "Niederkrüchten", "", "DE", "276", "", "07", "051", "05166", "51.2", "6.21667", "Europe/Berlin"),("2863223", "Niederkassel", "Нидеркассель", "DE", "276", "", "07", "053", "05382", "50.81503", "7.03777", "Europe/Berlin"),("2863240", "Nieder-Ingelheim", "", "DE", "276", "", "08", "00", "07339", "49.97756", "8.07246", "Europe/Berlin"),("2863401", "Niedergörsdorf", "", "DE", "276", "", "11", "00", "12072", "51.97943", "12.98541", "Europe/Berlin"),("2863441", "Niederfischbach", "", "DE", "276", "", "08", "00", "07132", "50.85", "7.86667", "Europe/Berlin"),("2863457", "Niedereschach", "", "DE", "276", "", "01", "083", "08326", "48.13333", "8.53333", "Europe/Berlin"),("2863638", "Niederaula", "", "DE", "276", "", "05", "066", "06632", "50.8", "9.6", "Europe/Berlin"),("2863652", "Aschau im Chiemgau", "", "DE", "276", "", "02", "091", "09187", "47.77689", "12.32297", "Europe/Berlin"),("2863685", "Niedenstein", "", "DE", "276", "", "05", "066", "06634", "51.23342", "9.31029", "Europe/Berlin"),("2863696", "Niebüll", "", "DE", "276", "", "10", "00", "01054", "54.78663", "8.82854", "Europe/Berlin"),("2863711", "Nideggen", "", "DE", "276", "", "07", "053", "05358", "50.69268", "6.48437", "Europe/Berlin"),("2863712", "Nidderau", "Ниддерау", "DE", "276", "", "05", "064", "06435", "50.23805", "8.86704", "Europe/Berlin"),("2863716", "Nidda", "Нидда", "DE", "276", "", "05", "064", "06440", "50.4133", "9.00638", "Europe/Berlin"),("2863795", "Neu Wulmstorf", "", "DE", "276", "", "06", "00", "03353", "53.46667", "9.8", "Europe/Berlin"),("2863840", "Neuwied", "Нойвид", "DE", "276", "", "08", "00", "07138", "50.4336", "7.47057", "Europe/Berlin"),("2863941", "Neu-Ulm", "Ной-Ульм", "DE", "276", "", "02", "097", "09775", "48.39279", "10.01112", "Europe/Berlin"),("2863953", "Neutraubling", "", "DE", "276", "", "02", "093", "09375", "48.98737", "12.201", "Europe/Berlin"),("2864005", "Neustrelitz", "Нойштрелице", "DE", "276", "", "12", "00", "13071", "53.3613", "13.07292", "Europe/Berlin"),("2864034", "Neustadt in Holstein", "Нойштадт", "DE", "276", "", "10", "00", "01055", "54.10707", "10.8145", "Europe/Berlin"),("2864036", "Neustadt-Glewe", "", "DE", "276", "", "12", "00", "13076", "53.37846", "11.59264", "Europe/Berlin"),("2864053", "Neustadt bei Coburg", "Нойштадт-Кобург", "DE", "276", "", "02", "094", "09473", "50.32975", "11.12058", "Europe/Berlin"),("2864054", "Neustadt", "Нойштадт-ан-дер-Вайнштрассе", "DE", "276", "", "08", "00", "07316", "49.35009", "8.13886", "Europe/Berlin"),("2864055", "Neustadt an der Waldnaab", "", "DE", "276", "", "02", "093", "09374", "49.73287", "12.17773", "Europe/Berlin"),("2864056", "Neustadt an der Donau", "", "DE", "276", "", "02", "092", "09273", "48.80705", "11.76952", "Europe/Berlin"),("2864057", "Neustadt an der Aisch", "", "DE", "276", "", "02", "095", "09575", "49.57953", "10.61126", "Europe/Berlin"),("2864058", "Neustadt am Rübenberge", "Нойштадт-ам-Рюбенберге", "DE", "276", "", "06", "00", "03241", "52.50462", "9.45871", "Europe/Berlin"),("2864067", "Neustadt", "", "DE", "276", "", "04", "00", "02000", "53.55196", "9.98558", "Europe/Berlin"),("2864072", "Neue Neustadt", "Нойштадт", "DE", "276", "", "14", "00", "15003", "52.15", "11.63333", "Europe/Berlin"),("2864089", "Neustadt in Sachsen", "", "DE", "276", "", "13", "00", "14628", "51.02844", "14.21785", "Europe/Berlin"),("2864091", "Neustadt (Hessen)", "", "DE", "276", "", "05", "065", "06534", "50.85", "9.11667", "Europe/Berlin"),("2864118", "Neuss", "Нойс", "DE", "276", "", "07", "051", "05162", "51.19807", "6.68504", "Europe/Berlin"),("2864276", "Neuruppin", "Нойруппин", "DE", "276", "", "11", "00", "12068", "52.92815", "12.80311", "Europe/Berlin"),("2864303", "Neuried", "", "DE", "276", "", "02", "091", "09184", "48.09322", "11.46561", "Europe/Berlin"),("2864387", "Neuötting", "", "DE", "276", "", "02", "091", "09171", "48.24102", "12.68998", "Europe/Berlin"),("2864422", "Neunkirchen am Main", "", "DE", "276", "", "02", "094", "09472", "49.923", "11.64793", "Europe/Berlin"),("2864425", "Neunkirchen", "", "DE", "276", "", "07", "059", "05970", "50.8", "8", "Europe/Berlin"),("2864435", "Neunkirchen", "Нойнкирхен", "DE", "276", "", "09", "00", "10043", "49.34449", "7.18045", "Europe/Berlin"),("2864468", "Neunburg vorm Wald", "", "DE", "276", "", "02", "093", "09376", "49.34782", "12.38621", "Europe/Berlin"),("2864475", "Neumünster", "Ноймюнстер", "DE", "276", "", "10", "00", "01004", "54.07477", "9.98195", "Europe/Berlin"),("2864547", "Neumarkt-Sankt Veit", "", "DE", "276", "", "02", "091", "09183", "48.36051", "12.50723", "Europe/Berlin"),("2864549", "Neumarkt in der Oberpfalz", "Ноймаркт", "DE", "276", "", "02", "093", "09373", "49.28028", "11.46278", "Europe/Berlin"),("2864577", "Neulußheim", "", "DE", "276", "", "01", "082", "08226", "49.29806", "8.51833", "Europe/Berlin"),("2864748", "Neukirchen", "", "DE", "276", "", "05", "066", "06634", "50.86906", "9.34655", "Europe/Berlin"),("2864750", "Neukirchen", "", "DE", "276", "", "13", "00", "14521", "50.77955", "12.86755", "Europe/Berlin"),("2864771", "Neukirch/Lausitz", "", "DE", "276", "", "13", "00", "14625", "51.09727", "14.30789", "Europe/Berlin"),("2864820", "Neu Isenburg", "Ной-Изенбург", "DE", "276", "", "05", "064", "06438", "50.04832", "8.69406", "Europe/Berlin"),("2864869", "Neuhofen", "", "DE", "276", "", "08", "00", "07338", "49.42778", "8.42472", "Europe/Berlin"),("2864936", "Neuhof", "", "DE", "276", "", "05", "066", "06631", "50.45313", "9.6175", "Europe/Berlin"),("2865086", "Neuhausen auf den Fildern", "", "DE", "276", "", "01", "081", "08116", "48.68333", "9.28333", "Europe/Berlin"),("2865104", "Neuhausen", "", "DE", "276", "", "01", "082", "08236", "48.8", "8.78333", "Europe/Berlin"),("2865133", "Neuhaus am Rennweg", "", "DE", "276", "", "15", "00", "16072", "50.51006", "11.13787", "Europe/Berlin"),("2865155", "Neuhaus", "", "DE", "276", "", "15", "00", "16070", "50.68333", "10.93333", "Europe/Berlin"),("2865293", "Neugersdorf", "", "DE", "276", "", "13", "00", "14626", "50.97729", "14.60881", "Europe/Berlin"),("2865341", "Neuffen", "", "DE", "276", "", "01", "081", "08116", "48.5546", "9.3755", "Europe/Berlin"),("2865376", "Neufahrn bei Freising", "", "DE", "276", "", "02", "091", "09178", "48.31588", "11.66316", "Europe/Berlin"),("2865557", "Neuenstein", "", "DE", "276", "", "01", "081", "08126", "49.2049", "9.58", "Europe/Berlin"),("2865560", "Neuenstadt am Kocher", "", "DE", "276", "", "01", "081", "08125", "49.23498", "9.33215", "Europe/Berlin"),("2865592", "Neuenrade", "", "DE", "276", "", "07", "059", "05962", "51.28278", "7.7825", "Europe/Berlin"),("2865637", "Neuenkirchen", "", "DE", "276", "", "06", "00", "03358", "53.03259", "9.70642", "Europe/Berlin"),("2865641", "Neuenkirchen", "", "DE", "276", "", "07", "055", "05566", "52.24472", "7.37183", "Europe/Berlin"),("2865716", "Neuenhagen", "", "DE", "276", "", "11", "00", "12064", "52.52985", "13.68914", "Europe/Berlin"),("2865798", "Neuendettelsau", "", "DE", "276", "", "02", "095", "09571", "49.28333", "10.78333", "Europe/Berlin"),("2865812", "Neuenbürg", "", "DE", "276", "", "01", "082", "08236", "48.84516", "8.59574", "Europe/Berlin"),("2865813", "Neuenburg am Rhein", "", "DE", "276", "", "01", "083", "08315", "47.81431", "7.56005", "Europe/Berlin"),("2866022", "Neudenau", "", "DE", "276", "", "01", "081", "08125", "49.29181", "9.26975", "Europe/Berlin"),("2866070", "Neuburg an der Donau", "Нойбург-ан-дер-Донау", "DE", "276", "", "02", "091", "09185", "48.73218", "11.18709", "Europe/Berlin"),("2866086", "Neubulach", "", "DE", "276", "", "01", "082", "08235", "48.66092", "8.69611", "Europe/Berlin"),("2866110", "Neubrück", "", "DE", "276", "", "07", "051", "05162", "51.13434", "6.63857", "Europe/Berlin"),("2866135", "Neubrandenburg", "Нойбранденбурге", "DE", "276", "", "12", "00", "13071", "53.56414", "13.27532", "Europe/Berlin"),("2866174", "Neubiberg", "", "DE", "276", "", "02", "091", "09184", "48.0771", "11.65812", "Europe/Berlin"),("2866280", "Neu-Anspach", "Ной-Анспах", "DE", "276", "", "05", "064", "06434", "50.31667", "8.5", "Europe/Berlin"),("2866333", "Nettetal", "Неттеталь", "DE", "276", "", "07", "051", "05166", "51.31667", "6.28333", "Europe/Berlin"),("2866336", "Nettersheim", "", "DE", "276", "", "07", "053", "05366", "50.49372", "6.62896", "Europe/Berlin"),("2866375", "Netphen", "Нетфен", "DE", "276", "", "07", "059", "05970", "50.91667", "8.1", "Europe/Berlin"),("2866473", "Nersingen", "", "DE", "276", "", "02", "097", "09775", "48.42829", "10.12356", "Europe/Berlin"),("2866486", "Neresheim", "", "DE", "276", "", "01", "081", "08136", "48.75511", "10.33041", "Europe/Berlin"),("2866755", "Neckartenzlingen", "", "DE", "276", "", "01", "081", "08116", "48.58981", "9.23478", "Europe/Berlin"),("2866758", "Neckarsulm", "Неккарзульм", "DE", "276", "", "01", "081", "08125", "49.18912", "9.22527", "Europe/Berlin"),("2866774", "Neckargemünd", "", "DE", "276", "", "01", "082", "08226", "49.38899", "8.7959", "Europe/Berlin"),("2866861", "Naunhof", "", "DE", "276", "", "13", "00", "14729", "51.2777", "12.58827", "Europe/Berlin"),("2866905", "Naumburg", "", "DE", "276", "", "05", "066", "06633", "51.24816", "9.16569", "Europe/Berlin"),("2866906", "Naumburg", "Наумбург", "DE", "276", "", "14", "00", "15084", "51.14987", "11.80979", "Europe/Berlin"),("2866930", "Nauen", "Науэн", "DE", "276", "", "11", "00", "12063", "52.60701", "12.87374", "Europe/Berlin"),("2866942", "Nattheim", "", "DE", "276", "", "01", "081", "08135", "48.69963", "10.24209", "Europe/Berlin"),("2867037", "Nassau", "", "DE", "276", "", "08", "00", "07141", "50.31453", "7.80025", "Europe/Berlin"),("2867112", "Nandlstadt", "", "DE", "276", "", "02", "091", "09178", "48.53644", "11.8073", "Europe/Berlin"),("2867120", "Namborn", "", "DE", "276", "", "09", "00", "10046", "49.51667", "7.13333", "Europe/Berlin"),("2867127", "Nalbach", "", "DE", "276", "", "09", "00", "10044", "49.38333", "6.78333", "Europe/Berlin"),("2867138", "Naila", "", "DE", "276", "", "02", "094", "09475", "50.33034", "11.70463", "Europe/Berlin"),("2867164", "Nagold", "Нагольд", "DE", "276", "", "01", "082", "08235", "48.5498", "8.72366", "Europe/Berlin"),("2867229", "Nackenheim", "", "DE", "276", "", "08", "00", "07339", "49.91528", "8.33889", "Europe/Berlin"),("2867252", "Nachrodt-Wiblingwerde", "", "DE", "276", "", "07", "059", "05962", "51.31667", "7.61667", "Europe/Berlin"),("2867262", "Nabburg", "", "DE", "276", "", "02", "093", "09376", "49.45347", "12.17996", "Europe/Berlin"),("2867310", "Mutterstadt", "", "DE", "276", "", "08", "00", "07338", "49.44139", "8.35611", "Europe/Berlin"),("2867335", "Mutlangen", "", "DE", "276", "", "01", "081", "08136", "48.82588", "9.79714", "Europe/Berlin"),("2867431", "Murrhardt", "", "DE", "276", "", "01", "081", "08119", "48.98191", "9.57047", "Europe/Berlin"),("2867436", "Murr", "", "DE", "276", "", "01", "081", "08118", "48.96207", "9.25924", "Europe/Berlin"),("2867445", "Murnau am Staffelsee", "", "DE", "276", "", "02", "091", "09180", "47.68085", "11.20125", "Europe/Berlin"),("2867467", "Murg", "", "DE", "276", "", "01", "083", "08337", "47.55492", "8.02182", "Europe/Berlin"),("2867492", "Münzenberg", "", "DE", "276", "", "05", "064", "06440", "50.45346", "8.7743", "Europe/Berlin"),("2867542", "Munster", "Мунстер", "DE", "276", "", "06", "00", "03358", "52.98569", "10.08756", "Europe/Berlin"),("2867543", "Münster", "Мюнстер", "DE", "276", "", "07", "055", "05515", "51.96236", "7.62571", "Europe/Berlin"),("2867548", "Münster", "", "DE", "276", "", "05", "064", "06432", "49.92278", "8.86778", "Europe/Berlin"),("2867560", "Münsingen", "", "DE", "276", "", "01", "084", "08415", "48.41126", "9.49704", "Europe/Berlin"),("2867571", "Münnerstadt", "", "DE", "276", "", "02", "096", "09672", "50.24636", "10.20187", "Europe/Berlin"),("2867608", "Munderkingen", "", "DE", "276", "", "01", "084", "08425", "48.23568", "9.64398", "Europe/Berlin"),("2867613", "Hannoversch Münden", "", "DE", "276", "", "06", "00", "03152", "51.41505", "9.65046", "Europe/Berlin"),("2867714", "Munich", "Мюнхен", "DE", "276", "", "02", "091", "09162", "48.13743", "11.57549", "Europe/Berlin"),("2867723", "Müncheberg", "", "DE", "276", "", "11", "00", "12064", "52.50704", "14.13716", "Europe/Berlin"),("2867726", "Münchberg", "", "DE", "276", "", "02", "094", "09475", "50.18952", "11.78823", "Europe/Berlin"),("2867753", "Mülsen", "", "DE", "276", "", "13", "00", "14524", "50.75", "12.56667", "Europe/Berlin"),("2867770", "Müllheim", "Мюльхайм", "DE", "276", "", "01", "083", "08315", "47.8082", "7.63035", "Europe/Berlin"),("2867838", "Mülheim", "Мюльхайм-на-Руре", "DE", "276", "", "07", "051", "05117", "51.43218", "6.87967", "Europe/Berlin"),("2867985", "Mühlheim am Main", "Мюльхайм-на-Майне", "DE", "276", "", "05", "064", "06438", "50.11667", "8.83333", "Europe/Berlin"),("2867993", "Stuttgart Mühlhausen", "", "DE", "276", "DE", "01", "081", "08111", "48.84232", "9.23028", "Europe/Berlin"),("2867996", "Mühlhausen", "Мюльхаузен", "DE", "276", "", "15", "00", "16064", "51.20896", "10.45275", "Europe/Berlin"),("2868004", "Mühlhausen", "", "DE", "276", "", "01", "082", "08226", "49.24861", "8.72667", "Europe/Berlin"),("2868506", "Mühldorf", "", "DE", "276", "", "02", "091", "09183", "48.2467", "12.52155", "Europe/Berlin"),("2868788", "Mühlacker", "Мюлакер", "DE", "276", "", "01", "082", "08236", "48.94754", "8.83675", "Europe/Berlin"),("2868807", "Muggensturm", "", "DE", "276", "", "01", "082", "08216", "48.86667", "8.28333", "Europe/Berlin"),("2868837", "Müggelheim", "", "DE", "276", "DE", "16", "00", "11000", "52.41137", "13.66403", "Europe/Berlin"),("2868853", "Mudersbach", "", "DE", "276", "", "08", "00", "07132", "50.81667", "7.95", "Europe/Berlin"),("2868861", "Müden", "", "DE", "276", "", "06", "00", "03151", "52.52771", "10.36011", "Europe/Berlin"),("2868867", "Mudau", "", "DE", "276", "", "01", "082", "08225", "49.53444", "9.20444", "Europe/Berlin"),("2868933", "Mücheln", "", "DE", "276", "", "14", "00", "15088", "51.29688", "11.80759", "Europe/Berlin"),("2868936", "Much", "", "DE", "276", "", "07", "053", "05382", "50.91667", "7.4", "Europe/Berlin"),("2869019", "Mössingen", "Мёссинген", "DE", "276", "", "01", "084", "08416", "48.40567", "9.05419", "Europe/Berlin"),("2869120", "Mosbach", "", "DE", "276", "", "01", "082", "08225", "49.35357", "9.15106", "Europe/Berlin"),("2869196", "Morsbach", "", "DE", "276", "", "07", "053", "05374", "50.86667", "7.75", "Europe/Berlin"),("2869221", "Mörlenbach", "", "DE", "276", "", "05", "064", "06431", "49.59917", "8.73472", "Europe/Berlin"),("2869244", "Moritzburg", "", "DE", "276", "", "13", "00", "14627", "51.15922", "13.68021", "Europe/Berlin"),("2869257", "Moringen", "", "DE", "276", "", "06", "00", "03155", "51.69915", "9.87107", "Europe/Berlin"),("2869306", "Morbach", "", "DE", "276", "", "08", "00", "07231", "49.81667", "7.11667", "Europe/Berlin"),("2869361", "Moosinning", "", "DE", "276", "", "02", "091", "09177", "48.27708", "11.84446", "Europe/Berlin"),("2869449", "Moosburg", "", "DE", "276", "", "02", "091", "09178", "48.47089", "11.93811", "Europe/Berlin"),("2869746", "Montabaur", "", "DE", "276", "", "08", "00", "07143", "50.43588", "7.8232", "Europe/Berlin"),("2869756", "Monschau", "", "DE", "276", "", "07", "053", "05334", "50.55462", "6.24001", "Europe/Berlin"),("2869791", "Monheim am Rhein", "", "DE", "276", "", "07", "051", "05158", "51.09162", "6.89217", "Europe/Berlin"),("2869894", "Mönchengladbach", "Мёнхенгладбах", "DE", "276", "", "07", "051", "05116", "51.18539", "6.44172", "Europe/Berlin"),("2869934", "Mömlingen", "", "DE", "276", "", "02", "096", "09676", "49.85972", "9.08333", "Europe/Berlin"),("2869936", "Mömbris", "", "DE", "276", "", "02", "096", "09671", "50.06921", "9.16371", "Europe/Berlin"),("2869994", "Mölln", "Мёльн", "DE", "276", "", "10", "00", "01053", "53.61702", "10.68742", "Europe/Berlin"),("2870094", "Molbergen", "", "DE", "276", "", "06", "00", "03453", "52.86667", "7.93333", "Europe/Berlin"),("2870194", "Möglingen", "", "DE", "276", "", "01", "081", "08118", "48.88741", "9.12694", "Europe/Berlin"),("2870221", "Moers", "Мерс", "DE", "276", "", "07", "051", "05170", "51.45342", "6.6326", "Europe/Berlin"),("2870266", "Mockrehna", "", "DE", "276", "", "13", "00", "14730", "51.50757", "12.81418", "Europe/Berlin"),("2870269", "Möckmühl", "", "DE", "276", "", "01", "081", "08125", "49.3249", "9.35837", "Europe/Berlin"),("2870278", "Möckern", "", "DE", "276", "", "14", "00", "15086", "52.14099", "11.95203", "Europe/Berlin"),("2870310", "Moabit", "Моабит", "DE", "276", "", "16", "00", "11000", "52.52635", "13.33903", "Europe/Berlin"),("2870318", "Mittweida", "Митвайда", "DE", "276", "", "13", "00", "14522", "50.98622", "12.97537", "Europe/Berlin"),("2870355", "Mitterteich", "", "DE", "276", "", "02", "093", "09377", "49.95141", "12.24206", "Europe/Berlin"),("2870481", "Mittenwalde", "", "DE", "276", "", "11", "00", "12061", "52.26007", "13.53945", "Europe/Berlin"),("2870482", "Mittenwald", "", "DE", "276", "", "02", "091", "09180", "47.4422", "11.26187", "Europe/Berlin"),("2870490", "Mittenaar", "", "DE", "276", "", "05", "065", "06532", "50.7", "8.38333", "Europe/Berlin"),("2870584", "Mittelschöntal", "", "DE", "276", "", "01", "081", "08119", "48.94615", "9.3952", "Europe/Berlin"),("2870911", "Mittegroßefehn", "", "DE", "276", "", "06", "00", "03452", "53.39165", "7.56602", "Europe/Berlin"),("2871039", "Minden", "Минден", "DE", "276", "", "07", "057", "05770", "52.28953", "8.91455", "Europe/Berlin"),("2871045", "Mindelheim", "", "DE", "276", "", "02", "097", "09778", "48.04578", "10.49222", "Europe/Berlin"),("2871079", "Miltenberg", "", "DE", "276", "", "02", "096", "09676", "49.70452", "9.26725", "Europe/Berlin"),("2871198", "Miesbach", "", "DE", "276", "", "02", "091", "09182", "47.78903", "11.83382", "Europe/Berlin"),("2871279", "Michendorf", "", "DE", "276", "", "11", "00", "12069", "52.31352", "13.02996", "Europe/Berlin"),("2871284", "Michelstadt", "Михельштадт", "DE", "276", "", "05", "064", "06437", "49.67569", "9.00373", "Europe/Berlin"),("2871367", "Michelau", "", "DE", "276", "", "02", "094", "09478", "50.16233", "11.11207", "Europe/Berlin"),("2871437", "Meuselwitz", "", "DE", "276", "", "15", "00", "16077", "51.04315", "12.29935", "Europe/Berlin"),("2871486", "Metzingen", "Метцинген", "DE", "276", "", "01", "084", "08415", "48.53695", "9.2833", "Europe/Berlin"),("2871535", "Mettmann", "Меттман", "DE", "276", "", "07", "051", "05158", "51.2504", "6.97536", "Europe/Berlin"),("2871540", "Mettingen", "", "DE", "276", "", "07", "055", "05566", "52.31667", "7.78333", "Europe/Berlin"),("2871591", "Metelen", "", "DE", "276", "", "07", "055", "05566", "52.14434", "7.2127", "Europe/Berlin"),("2871601", "Meßstetten", "", "DE", "276", "", "01", "084", "08417", "48.18317", "8.96565", "Europe/Berlin"),("2871609", "Meßkirch", "", "DE", "276", "", "01", "084", "08437", "47.99457", "9.11479", "Europe/Berlin"),("2871668", "Meschede", "Мешеде", "DE", "276", "", "07", "059", "05958", "51.3502", "8.28332", "Europe/Berlin"),("2871675", "Merzig", "Мерциге", "DE", "276", "", "09", "00", "10042", "49.44331", "6.63874", "Europe/Berlin"),("2871736", "Merseburg", "Мерзебург", "DE", "276", "", "14", "00", "15088", "51.35478", "11.98923", "Europe/Berlin"),("2871813", "Mering", "", "DE", "276", "", "02", "097", "09771", "48.2656", "10.98461", "Europe/Berlin"),("2871832", "Merchweiler", "", "DE", "276", "", "09", "00", "10043", "49.35", "7.05", "Europe/Berlin"),("2871845", "Meppen", "Меппен", "DE", "276", "", "06", "00", "03454", "52.69064", "7.29097", "Europe/Berlin"),("2871950", "Mengkofen", "", "DE", "276", "", "02", "092", "09279", "48.71894", "12.44047", "Europe/Berlin"),("2871953", "Mengerskirchen", "", "DE", "276", "", "05", "065", "06533", "50.56392", "8.15555", "Europe/Berlin"),("2871963", "Mengenich", "", "DE", "276", "", "07", "053", "05315", "50.9785", "6.86737", "Europe/Berlin"),("2871964", "Mengen", "", "DE", "276", "", "01", "084", "08437", "48.04951", "9.33005", "Europe/Berlin"),("2871979", "Mendig", "", "DE", "276", "", "08", "00", "07137", "50.36667", "7.28333", "Europe/Berlin"),("2871983", "Menden", "Менден", "DE", "276", "", "07", "059", "05962", "51.44337", "7.77825", "Europe/Berlin"),("2871992", "Memmingen", "Мемминген", "DE", "276", "", "02", "097", "09764", "47.98372", "10.18527", "Europe/Berlin"),("2872003", "Memmelsdorf", "", "DE", "276", "", "02", "094", "09471", "49.93012", "10.95921", "Europe/Berlin"),("2872028", "Melsungen", "", "DE", "276", "", "05", "066", "06634", "51.13029", "9.55236", "Europe/Berlin"),("2872047", "Mellrichstadt", "", "DE", "276", "", "02", "096", "09673", "50.42849", "10.30334", "Europe/Berlin"),("2872079", "Melle", "Мелле", "DE", "276", "", "06", "00", "03459", "52.20197", "8.33826", "Europe/Berlin"),("2872100", "Meldorf", "", "DE", "276", "", "10", "00", "01051", "54.09182", "9.0687", "Europe/Berlin"),("2872126", "Meitingen", "", "DE", "276", "", "02", "097", "09772", "48.54586", "10.85179", "Europe/Berlin"),("2872155", "Meissen", "Мейсен", "DE", "276", "", "13", "00", "14627", "51.16158", "13.4737", "Europe/Berlin"),("2872225", "Meiningen", "Майнинген", "DE", "276", "", "15", "00", "16066", "50.56787", "10.41521", "Europe/Berlin"),("2872237", "Meinerzhagen", "Майнерцхаген", "DE", "276", "", "07", "059", "05962", "51.1074", "7.64838", "Europe/Berlin"),("2872244", "Meinersen", "", "DE", "276", "", "06", "00", "03151", "52.47436", "10.35247", "Europe/Berlin"),("2872347", "Meiderich", "", "DE", "276", "", "07", "051", "05112", "51.46667", "6.76667", "Europe/Berlin"),("2872380", "Mehrhoog", "", "DE", "276", "", "07", "051", "05170", "51.73826", "6.51164", "Europe/Berlin"),("2872486", "Meersburg", "", "DE", "276", "", "01", "084", "08435", "47.69419", "9.27113", "Europe/Berlin"),("2872504", "Meerbusch", "Мербуш", "DE", "276", "", "07", "051", "05162", "51.26118", "6.6717", "Europe/Berlin"),("2872519", "Meerane", "Меране", "DE", "276", "", "13", "00", "14524", "50.84688", "12.46473", "Europe/Berlin"),("2872557", "Medebach", "", "DE", "276", "", "07", "059", "05958", "51.19713", "8.70635", "Europe/Berlin"),("2872580", "Meckesheim", "", "DE", "276", "", "01", "082", "08226", "49.32167", "8.81944", "Europe/Berlin"),("2872582", "Meckenheim", "Меккенхайм", "DE", "276", "", "07", "053", "05382", "50.62388", "7.02942", "Europe/Berlin"),("2872585", "Meckenbeuren", "", "DE", "276", "", "01", "084", "08435", "47.7", "9.56667", "Europe/Berlin"),("2872611", "Mechernich", "Мехерних", "DE", "276", "", "07", "053", "05366", "50.59304", "6.65224", "Europe/Berlin"),("2872649", "Mayen", "Майен", "DE", "276", "", "08", "00", "07137", "50.32797", "7.22277", "Europe/Berlin"),("2872670", "Maxhütte-Haidhof", "", "DE", "276", "", "02", "093", "09376", "49.19963", "12.09229", "Europe/Berlin"),("2872686", "Maxdorf", "", "DE", "276", "", "08", "00", "07338", "49.48806", "8.29167", "Europe/Berlin"),("2872777", "Maulbronn", "", "DE", "276", "", "01", "082", "08236", "48.99958", "8.80337", "Europe/Berlin"),("2873074", "Marzahn", "", "DE", "276", "", "16", "00", "11000", "52.54525", "13.56983", "Europe/Berlin"),("2873211", "Marsberg", "Марсберг", "DE", "276", "", "07", "059", "05958", "51.46171", "8.84949", "Europe/Berlin"),("2873224", "Marpingen", "", "DE", "276", "", "09", "00", "10046", "49.45228", "7.0582", "Europe/Berlin"),("2873263", "Marl", "Марль", "DE", "276", "", "07", "055", "05562", "51.65671", "7.09038", "Europe/Berlin"),("2873285", "Markt Schwaben", "", "DE", "276", "", "02", "091", "09175", "48.18949", "11.8691", "Europe/Berlin"),("2873289", "Marktredwitz", "Марктредвиц", "DE", "276", "", "02", "094", "09479", "50.00443", "12.08593", "Europe/Berlin"),("2873291", "Marktoberdorf", "Марктобердорф", "DE", "276", "", "02", "097", "09777", "47.77964", "10.61713", "Europe/Berlin"),("2873300", "Markt Indersdorf", "", "DE", "276", "", "02", "091", "09174", "48.36058", "11.37789", "Europe/Berlin"),("2873301", "Marktheidenfeld", "", "DE", "276", "", "02", "096", "09677", "49.8454", "9.60359", "Europe/Berlin"),("2873304", "Markt Erlbach", "", "DE", "276", "", "02", "095", "09575", "49.49367", "10.65265", "Europe/Berlin"),("2873331", "Markranstädt", "", "DE", "276", "", "13", "00", "14729", "51.30146", "12.2202", "Europe/Berlin"),("2873340", "Markneukirchen", "", "DE", "276", "", "13", "00", "14523", "50.31144", "12.32951", "Europe/Berlin"),("2873352", "Markkleeberg", "", "DE", "276", "", "13", "00", "14729", "51.2755", "12.36906", "Europe/Berlin"),("2873356", "Märkisches Viertel", "", "DE", "276", "", "16", "00", "11000", "52.59841", "13.35766", "Europe/Berlin"),("2873369", "Markgröningen", "", "DE", "276", "", "01", "081", "08118", "48.90493", "9.08059", "Europe/Berlin"),("2873427", "Markdorf", "", "DE", "276", "", "01", "084", "08435", "47.71916", "9.39028", "Europe/Berlin"),("2873574", "Marienheide", "", "DE", "276", "", "07", "053", "05374", "51.08317", "7.53087", "Europe/Berlin"),("2873589", "Marienfelde", "", "DE", "276", "", "16", "00", "11000", "52.41868", "13.36723", "Europe/Berlin"),("2873606", "Mariendorf", "Мариендорф", "DE", "276", "", "16", "00", "11000", "52.4378", "13.38109", "Europe/Berlin"),("2873632", "Marienberg", "", "DE", "276", "", "13", "00", "14521", "50.65051", "13.16122", "Europe/Berlin"),("2873759", "Marburg an der Lahn", "Марбург", "DE", "276", "", "05", "065", "06534", "50.80904", "8.77069", "Europe/Berlin"),("2873776", "Marbach am Neckar", "Марбах-на-Неккаре", "DE", "276", "", "01", "081", "08118", "48.93964", "9.25995", "Europe/Berlin"),("2873891", "Mannheim", "Мангейм", "DE", "276", "", "01", "082", "08222", "49.49671", "8.47955", "Europe/Berlin"),("2873992", "Manching", "", "DE", "276", "", "02", "091", "09186", "48.71656", "11.49393", "Europe/Berlin"),("2874048", "Malsch", "", "DE", "276", "", "01", "082", "08215", "48.88333", "8.33333", "Europe/Berlin"),("2874111", "Malente", "", "DE", "276", "", "10", "00", "01055", "54.17226", "10.55968", "Europe/Berlin"),("2874122", "Malchow", "", "DE", "276", "", "12", "00", "13071", "53.47477", "12.4221", "Europe/Berlin"),("2874131", "Malchin", "", "DE", "276", "", "12", "00", "13071", "53.7399", "12.76539", "Europe/Berlin"),("2874200", "Maisach", "", "DE", "276", "", "02", "091", "09179", "48.21667", "11.26667", "Europe/Berlin"),("2874225", "Mainz", "Майнц", "DE", "276", "", "08", "00", "07315", "49.98419", "8.2791", "Europe/Berlin"),("2874230", "Maintal", "Майнталь", "DE", "276", "", "05", "064", "06435", "50.15", "8.83333", "Europe/Berlin"),("2874239", "Mainleus", "", "DE", "276", "", "02", "094", "09477", "50.09987", "11.37664", "Europe/Berlin"),("2874246", "Mainhardt", "", "DE", "276", "", "01", "081", "08127", "49.07611", "9.55639", "Europe/Berlin"),("2874252", "Mainburg", "", "DE", "276", "", "02", "092", "09273", "48.64182", "11.78093", "Europe/Berlin"),("2874263", "Mainaschaff", "", "DE", "276", "", "02", "096", "09671", "49.98167", "9.09", "Europe/Berlin"),("2874455", "Mahlsdorf", "", "DE", "276", "DE", "16", "00", "11000", "52.50935", "13.61373", "Europe/Berlin"),("2874509", "Magstadt", "", "DE", "276", "", "01", "081", "08115", "48.73333", "8.96667", "Europe/Berlin"),("2874545", "Magdeburg", "Магдебург", "DE", "276", "", "14", "00", "15003", "52.12773", "11.62916", "Europe/Berlin"),("2874642", "Machern", "", "DE", "276", "", "13", "00", "14729", "51.36667", "12.63333", "Europe/Berlin"),("2874768", "Lützelbach", "", "DE", "276", "", "05", "064", "06432", "49.74233", "8.76687", "Europe/Berlin"),("2874919", "Lütjenburg", "", "DE", "276", "", "10", "00", "01057", "54.29188", "10.58945", "Europe/Berlin"),("2875067", "Lunzenau", "", "DE", "276", "", "13", "00", "14522", "50.96269", "12.75594", "Europe/Berlin"),("2875107", "Lünen", "Люнен", "DE", "276", "", "07", "059", "05978", "51.61634", "7.52872", "Europe/Berlin"),("2875115", "Lüneburg", "Люнебург", "DE", "276", "", "06", "00", "03355", "53.2509", "10.41409", "Europe/Berlin"),("2875282", "Lügde", "", "DE", "276", "", "07", "057", "05766", "51.95828", "9.24706", "Europe/Berlin"),("2875286", "Lugau", "", "DE", "276", "", "13", "00", "14521", "50.73843", "12.74861", "Europe/Berlin"),("2875343", "Ludwigslust", "", "DE", "276", "", "12", "00", "13076", "53.32917", "11.49714", "Europe/Berlin"),("2875376", "Ludwigshafen am Rhein", "Людвигсхафен-на-Рейне", "DE", "276", "", "08", "00", "07314", "49.48121", "8.44641", "Europe/Berlin"),("2875379", "Ludwigsfelde", "Людвигсфельде", "DE", "276", "", "11", "00", "12072", "52.30322", "13.25405", "Europe/Berlin"),("2875392", "Ludwigsburg", "Людвигсбург", "DE", "276", "", "01", "081", "08118", "48.89731", "9.19161", "Europe/Berlin"),("2875417", "Lüdinghausen", "Людингхаузен", "DE", "276", "", "07", "055", "05558", "51.7683", "7.44379", "Europe/Berlin"),("2875457", "Lüdenscheid", "Люденшайд", "DE", "276", "", "07", "059", "05962", "51.21977", "7.6273", "Europe/Berlin"),("2875484", "Luckenwalde", "Луккенвальде", "DE", "276", "", "11", "00", "12072", "52.09029", "13.16772", "Europe/Berlin"),("2875509", "Luckau", "", "DE", "276", "", "11", "00", "12061", "51.85245", "13.70735", "Europe/Berlin"),("2875542", "Lüchow", "", "DE", "276", "", "06", "00", "03354", "52.96811", "11.15397", "Europe/Berlin"),("2875558", "Lübz", "", "DE", "276", "", "12", "00", "13076", "53.46261", "12.02917", "Europe/Berlin"),("2875601", "Lübeck", "Любек", "DE", "276", "", "10", "00", "01003", "53.86893", "10.68729", "Europe/Berlin"),("2875623", "Lübbenau", "Люббенау", "DE", "276", "", "11", "00", "12066", "51.86217", "13.95168", "Europe/Berlin"),("2875625", "Lübben", "", "DE", "276", "", "11", "00", "12061", "51.93814", "13.88826", "Europe/Berlin"),("2875626", "Lübbecke", "Люббекке", "DE", "276", "", "07", "057", "05770", "52.30699", "8.61423", "Europe/Berlin"),("2875645", "Loxstedt", "Локсштедт", "DE", "276", "", "06", "00", "03352", "53.46667", "8.65", "Europe/Berlin"),("2875760", "Lotte", "", "DE", "276", "", "07", "055", "05566", "52.28333", "7.91667", "Europe/Berlin"),("2875799", "Lößnitz", "", "DE", "276", "", "13", "00", "14521", "50.62181", "12.73147", "Europe/Berlin"),("2875815", "Loßburg", "", "DE", "276", "", "01", "082", "08237", "48.4", "8.45", "Europe/Berlin"),("2875831", "Losheim", "", "DE", "276", "", "09", "00", "10042", "49.5099", "6.74549", "Europe/Berlin"),("2875877", "Lorsch", "", "DE", "276", "", "05", "064", "06431", "49.65", "8.56667", "Europe/Berlin"),("2875881", "Lörrach", "Лёррах", "DE", "276", "", "01", "083", "08336", "47.61497", "7.66457", "Europe/Berlin"),("2875909", "Lorch", "", "DE", "276", "", "01", "081", "08136", "48.79833", "9.6914", "Europe/Berlin"),("2875987", "Löningen", "", "DE", "276", "", "06", "00", "03453", "52.73678", "7.75809", "Europe/Berlin"),("2876009", "Lommatzsch", "", "DE", "276", "", "13", "00", "14627", "51.19537", "13.30917", "Europe/Berlin"),("2876027", "Lollar", "", "DE", "276", "", "05", "065", "06531", "50.64652", "8.70495", "Europe/Berlin"),("2876144", "Lohra", "", "DE", "276", "", "05", "065", "06534", "50.73333", "8.63333", "Europe/Berlin"),("2876147", "Lohr am Main", "Лор-на-Майне", "DE", "276", "", "02", "096", "09677", "49.98922", "9.57223", "Europe/Berlin"),("2876185", "Lohne", "", "DE", "276", "", "06", "00", "03460", "52.66625", "8.2375", "Europe/Berlin"),("2876186", "Lohne", "", "DE", "276", "", "06", "00", "03456", "52.49778", "7.22629", "Europe/Berlin"),("2876187", "Löhne", "", "DE", "276", "", "07", "057", "05758", "52.18848", "8.6922", "Europe/Berlin"),("2876218", "Lohmar", "Ломар", "DE", "276", "", "07", "053", "05382", "50.83868", "7.21399", "Europe/Berlin"),("2876282", "Lohfelden", "", "DE", "276", "", "05", "066", "06633", "51.26667", "9.53333", "Europe/Berlin"),("2876461", "Löffingen", "", "DE", "276", "", "01", "083", "08315", "47.88405", "8.34384", "Europe/Berlin"),("2876604", "Löchgau", "", "DE", "276", "", "01", "081", "08118", "49.00361", "9.10639", "Europe/Berlin"),("2876721", "Bad Lobenstein", "", "DE", "276", "", "15", "00", "16075", "50.45223", "11.6393", "Europe/Berlin"),("2876755", "Löbau", "Лёбау", "DE", "276", "", "13", "00", "14626", "51.09954", "14.66738", "Europe/Berlin"),("2876787", "Litzendorf", "", "DE", "276", "", "02", "094", "09471", "49.91444", "11.01028", "Europe/Berlin"),("2876865", "Lippstadt", "Липпштадте", "DE", "276", "", "07", "059", "05974", "51.67369", "8.34482", "Europe/Berlin"),("2876952", "Linz am Rhein", "", "DE", "276", "", "08", "00", "07138", "50.56884", "7.28445", "Europe/Berlin"),("2877021", "Linnich", "", "DE", "276", "", "07", "053", "05358", "50.98002", "6.27049", "Europe/Berlin"),("2877082", "Lingenfeld", "", "DE", "276", "", "08", "00", "07334", "49.25389", "8.33861", "Europe/Berlin"),("2877088", "Lingen", "Линген", "DE", "276", "", "06", "00", "03454", "52.52143", "7.31845", "Europe/Berlin"),("2877142", "Lindlar", "Линдлар", "DE", "276", "", "07", "053", "05374", "51.01959", "7.37758", "Europe/Berlin"),("2877315", "Lindenfels", "", "DE", "276", "", "05", "064", "06431", "49.68369", "8.78151", "Europe/Berlin"),("2877550", "Lindau", "Линдау", "DE", "276", "", "02", "097", "09776", "47.54612", "9.68431", "Europe/Berlin"),("2877647", "Limburgerhof", "", "DE", "276", "", "08", "00", "07338", "49.42444", "8.39194", "Europe/Berlin"),("2877648", "Limburg an der Lahn", "Лимбург-на-Лане", "DE", "276", "", "05", "065", "06533", "50.3836", "8.0503", "Europe/Berlin"),("2877673", "Limbach-Oberfrohna", "Лимбах-Оберфрона", "DE", "276", "", "13", "00", "14524", "50.85882", "12.76165", "Europe/Berlin"),("2877709", "Lilienthal", "Лилиенталь", "DE", "276", "", "06", "00", "03356", "53.13333", "8.91667", "Europe/Berlin"),("2877843", "Lienen", "", "DE", "276", "", "07", "055", "05566", "52.15", "7.98333", "Europe/Berlin"),("2877969", "Liebenburg", "", "DE", "276", "", "06", "00", "03153", "52.02176", "10.43169", "Europe/Berlin"),("2878018", "Lichterfelde", "", "DE", "276", "DE", "16", "00", "11000", "52.4333", "13.30762", "Europe/Berlin"),("2878027", "Lichtentanne", "", "DE", "276", "", "13", "00", "14524", "50.7", "12.43333", "Europe/Berlin"),("2878037", "Lichtenstein", "", "DE", "276", "", "13", "00", "14524", "50.75659", "12.63025", "Europe/Berlin"),("2878044", "Lichtenrade", "", "DE", "276", "", "16", "00", "11000", "52.39844", "13.40637", "Europe/Berlin"),("2878074", "Lichtenfels", "Лихтенфельс", "DE", "276", "", "02", "094", "09478", "50.14567", "11.05928", "Europe/Berlin"),("2878102", "Lichtenberg", "", "DE", "276", "", "16", "00", "11000", "52.51395", "13.49975", "Europe/Berlin"),("2878133", "Lichtenau", "", "DE", "276", "", "07", "057", "05774", "51.61707", "8.89665", "Europe/Berlin"),("2878140", "Lichtenau", "", "DE", "276", "", "01", "082", "08216", "48.72607", "8.00486", "Europe/Berlin"),("2878166", "Lich", "", "DE", "276", "", "05", "065", "06531", "50.52085", "8.81567", "Europe/Berlin"),("2878234", "Leverkusen", "Леверкузен", "DE", "276", "", "07", "053", "05316", "51.0303", "6.98432", "Europe/Berlin"),("2878270", "Leutkirch im Allgäu", "Лойткирх", "DE", "276", "", "01", "084", "08436", "47.82672", "10.0205", "Europe/Berlin"),("2878289", "Leutershausen", "", "DE", "276", "", "02", "095", "09571", "49.29869", "10.41189", "Europe/Berlin"),("2878313", "Leutenbach", "", "DE", "276", "", "01", "081", "08119", "48.88791", "9.39267", "Europe/Berlin"),("2878350", "Leuna", "", "DE", "276", "", "14", "00", "15088", "51.31783", "12.01589", "Europe/Berlin"),("2878351", "Leun", "", "DE", "276", "", "05", "065", "06532", "50.55129", "8.35836", "Europe/Berlin"),("2878673", "Leopoldshöhe", "Леопольдсхёэ", "DE", "276", "", "07", "057", "05766", "52.01246", "8.69834", "Europe/Berlin"),("2878695", "Leonberg", "Леонберг", "DE", "276", "", "01", "081", "08115", "48.8", "9.01667", "Europe/Berlin"),("2878702", "Lenzkirch", "", "DE", "276", "", "01", "083", "08315", "47.86832", "8.20211", "Europe/Berlin"),("2878773", "Lensahn", "", "DE", "276", "", "10", "00", "01055", "54.23333", "10.88333", "Europe/Berlin"),("2878784", "Lennestadt", "Леннештадт", "DE", "276", "", "07", "059", "05966", "51.11721", "8.06707", "Europe/Berlin"),("2878824", "Lenggries", "", "DE", "276", "", "02", "091", "09173", "47.68333", "11.56667", "Europe/Berlin"),("2878840", "Lengerich", "", "DE", "276", "", "07", "055", "05566", "52.18661", "7.86043", "Europe/Berlin"),("2878852", "Lengenfeld", "", "DE", "276", "", "13", "00", "14523", "50.5694", "12.36408", "Europe/Berlin"),("2878879", "Lengede", "", "DE", "276", "", "06", "00", "03157", "52.20487", "10.30775", "Europe/Berlin"),("2878912", "Lemwerder", "", "DE", "276", "", "06", "00", "03461", "53.16667", "8.61667", "Europe/Berlin"),("2878918", "Lemsahl-Mellingstedt", "", "DE", "276", "", "04", "00", "02000", "53.68998", "10.09648", "Europe/Berlin"),("2878943", "Lemgo", "Лемго", "DE", "276", "", "07", "057", "05766", "52.02786", "8.89901", "Europe/Berlin"),("2879109", "Leisnig", "", "DE", "276", "", "13", "00", "14522", "51.15743", "12.9279", "Europe/Berlin"),("2879139", "Leipzig", "Лейпциг", "DE", "276", "", "13", "00", "14713", "51.33962", "12.37129", "Europe/Berlin"),("2879150", "Leipheim", "", "DE", "276", "", "02", "097", "09774", "48.45004", "10.22278", "Europe/Berlin"),("2879185", "Leinfelden-Echterdingen", "Лайнфельден-Эхтердинген", "DE", "276", "", "01", "081", "08116", "48.69406", "9.16809", "Europe/Berlin"),("2879193", "Leinefelde", "", "DE", "276", "", "15", "00", "16061", "51.38796", "10.3262", "Europe/Berlin"),("2879200", "Leinburg", "", "DE", "276", "", "02", "095", "09574", "49.45167", "11.31", "Europe/Berlin"),("2879241", "Leimen", "Лаймен", "DE", "276", "", "01", "082", "08226", "49.34737", "8.68733", "Europe/Berlin"),("2879315", "Leichlingen", "Лайхлинген", "DE", "276", "", "07", "053", "05378", "51.10628", "7.01873", "Europe/Berlin"),("2879367", "Lehrte", "Лерте", "DE", "276", "", "06", "00", "03241", "52.37193", "9.97919", "Europe/Berlin"),("2879378", "Lehre", "", "DE", "276", "", "06", "00", "03154", "52.33333", "10.66667", "Europe/Berlin"),("2879653", "Legden", "", "DE", "276", "", "07", "055", "05554", "52.03333", "7.1", "Europe/Berlin"),("2879697", "Leer", "Лер", "DE", "276", "", "06", "00", "03457", "53.23157", "7.461", "Europe/Berlin"),("2879713", "Leegebruch", "", "DE", "276", "", "11", "00", "12065", "52.7234", "13.19304", "Europe/Berlin"),("2879758", "Leck", "", "DE", "276", "", "10", "00", "01054", "54.76667", "8.98333", "Europe/Berlin"),("2879832", "Lebach", "Лебах", "DE", "276", "", "09", "00", "10044", "49.41122", "6.90988", "Europe/Berlin"),("2879929", "Lauterbach", "", "DE", "276", "", "05", "065", "06535", "50.63558", "9.39777", "Europe/Berlin"),("2879964", "Lauter", "", "DE", "276", "", "13", "00", "14521", "50.56264", "12.73513", "Europe/Berlin"),("2880077", "Laupheim", "Лаупхайм", "DE", "276", "", "01", "084", "08426", "48.22786", "9.87874", "Europe/Berlin"),("2880099", "Lauingen", "", "DE", "276", "", "02", "097", "09773", "48.56775", "10.42706", "Europe/Berlin"),("2880111", "Lauffen am Neckar", "", "DE", "276", "", "01", "081", "08125", "49.0734", "9.14567", "Europe/Berlin"),("2880121", "Laufenburg", "", "DE", "276", "", "01", "083", "08337", "47.56512", "8.06045", "Europe/Berlin"),("2880129", "Laufen", "", "DE", "276", "", "02", "091", "09172", "47.93568", "12.92856", "Europe/Berlin"),("2880144", "Lauf an der Pegnitz", "Лауф-ан-дер-Пегниц", "DE", "276", "", "02", "095", "09574", "49.51386", "11.28247", "Europe/Berlin"),("2880146", "Laufach", "", "DE", "276", "", "02", "096", "09671", "50.01667", "9.3", "Europe/Berlin"),("2880181", "Lauenburg", "", "DE", "276", "", "10", "00", "01053", "53.37199", "10.55654", "Europe/Berlin"),("2880204", "Laudenbach", "", "DE", "276", "", "01", "082", "08226", "49.61333", "8.65389", "Europe/Berlin"),("2880221", "Lauchhammer", "Лауххаммер", "DE", "276", "", "11", "00", "12066", "51.48813", "13.76623", "Europe/Berlin"),("2880308", "Laubach", "", "DE", "276", "", "05", "065", "06531", "50.54196", "8.99034", "Europe/Berlin"),("2880351", "Lathen", "", "DE", "276", "", "06", "00", "03454", "52.86667", "7.31667", "Europe/Berlin"),("2880357", "Lastrup", "", "DE", "276", "", "06", "00", "03453", "52.78333", "7.85", "Europe/Berlin"),("2880425", "Lappersdorf", "", "DE", "276", "", "02", "093", "09375", "49.04694", "12.0913", "Europe/Berlin"),("2880498", "Lankwitz", "Ланквиц", "DE", "276", "", "16", "00", "11000", "52.43623", "13.3459", "Europe/Berlin"),("2880503", "Lankow", "", "DE", "276", "", "12", "00", "13004", "53.64983", "11.36913", "Europe/Berlin"),("2880539", "Langweid", "", "DE", "276", "", "02", "097", "09772", "48.49095", "10.8531", "Europe/Berlin"),("2880547", "Langwedel", "", "DE", "276", "", "06", "00", "03361", "52.97864", "9.18542", "Europe/Berlin"),("2880597", "Langquaid", "", "DE", "276", "", "02", "092", "09273", "48.82318", "12.05134", "Europe/Berlin"),("2880672", "Langgöns", "", "DE", "276", "", "05", "065", "06531", "50.5", "8.66667", "Europe/Berlin"),("2880726", "Langerwehe", "", "DE", "276", "", "07", "053", "05358", "50.81667", "6.35", "Europe/Berlin"),("2880862", "Langenzenn", "", "DE", "276", "", "02", "095", "09573", "49.49463", "10.7923", "Europe/Berlin"),("2880913", "Langenselbold", "", "DE", "276", "", "05", "064", "06435", "50.17657", "9.04003", "Europe/Berlin"),("2881018", "Langenhorn", "", "DE", "276", "", "04", "00", "02000", "53.66556", "10.00137", "Europe/Berlin"),("2881062", "Langenhagen", "Лангенхаген", "DE", "276", "", "06", "00", "03241", "52.44758", "9.73741", "Europe/Berlin"),("2881085", "Langenfeld", "Лангенфельд", "DE", "276", "", "07", "051", "05158", "51.10821", "6.94831", "Europe/Berlin"),("2881175", "Langenberg", "", "DE", "276", "", "07", "057", "05754", "51.78333", "8.31667", "Europe/Berlin"),("2881259", "Langenau", "", "DE", "276", "", "01", "084", "08425", "48.49616", "10.11849", "Europe/Berlin"),("2881263", "Langenargen", "", "DE", "276", "", "01", "084", "08435", "47.59858", "9.54163", "Europe/Berlin"),("2881276", "Langen", "", "DE", "276", "", "06", "00", "03352", "53.60554", "8.59509", "Europe/Berlin"),("2881279", "Langen", "Ланген", "DE", "276", "", "05", "064", "06438", "49.98955", "8.66852", "Europe/Berlin"),("2881291", "Langelsheim", "", "DE", "276", "", "06", "00", "03153", "51.93789", "10.33264", "Europe/Berlin"),("2881477", "Landstuhl", "", "DE", "276", "", "08", "00", "07335", "49.41306", "7.57021", "Europe/Berlin"),("2881485", "Landshut", "Ландсхут", "DE", "276", "", "02", "092", "09261", "48.52961", "12.16179", "Europe/Berlin"),("2881509", "Landsberg am Lech", "Ландсберг-на-Лехе", "DE", "276", "", "02", "091", "09181", "48.04819", "10.88282", "Europe/Berlin"),("2881646", "Landau in der Pfalz", "Ландау", "DE", "276", "", "08", "00", "07313", "49.19844", "8.11692", "Europe/Berlin"),("2881650", "Landau an der Isar", "", "DE", "276", "", "02", "092", "09279", "48.67249", "12.69316", "Europe/Berlin"),("2881695", "Lampertheim", "Лампертхайм", "DE", "276", "", "05", "064", "06431", "49.59786", "8.4725", "Europe/Berlin"),("2881767", "Lambsheim", "", "DE", "276", "", "08", "00", "07338", "49.51361", "8.28778", "Europe/Berlin"),("2881857", "Laichingen", "", "DE", "276", "", "01", "084", "08425", "48.48939", "9.68612", "Europe/Berlin"),("2881885", "Lahr", "Лар", "DE", "276", "", "01", "083", "08317", "48.34042", "7.86886", "Europe/Berlin"),("2881889", "Lahnstein", "Ланштайн", "DE", "276", "", "08", "00", "07141", "50.3", "7.61667", "Europe/Berlin"),("2881956", "Lage", "Лаге", "DE", "276", "", "07", "057", "05766", "51.99223", "8.79301", "Europe/Berlin"),("2881972", "Bad Laer", "", "DE", "276", "", "06", "00", "03459", "52.1", "8.08333", "Europe/Berlin"),("2881973", "Laer", "", "DE", "276", "", "07", "055", "05566", "52.05555", "7.35775", "Europe/Berlin"),("2881980", "Ladenburg", "", "DE", "276", "", "01", "082", "08226", "49.47307", "8.60896", "Europe/Berlin"),("2881991", "Ladbergen", "", "DE", "276", "", "07", "055", "05566", "52.13333", "7.75", "Europe/Berlin"),("2882028", "Lachendorf", "", "DE", "276", "", "06", "00", "03351", "52.61667", "10.25", "Europe/Berlin"),("2882059", "Laboe", "", "DE", "276", "", "10", "00", "01057", "54.4", "10.21667", "Europe/Berlin"),("2882087", "Laatzen", "Латцен", "DE", "276", "", "06", "00", "03241", "52.31506", "9.79739", "Europe/Berlin"),("2882091", "Bad Laasphe", "Бад-Ласфе", "DE", "276", "", "07", "059", "05970", "50.93139", "8.42502", "Europe/Berlin"),("2882161", "Kyritz", "", "DE", "276", "", "11", "00", "12068", "52.94212", "12.39704", "Europe/Berlin"),("2882237", "Kusterdingen", "", "DE", "276", "", "01", "084", "08416", "48.52291", "9.11977", "Europe/Berlin"),("2882265", "Kusel", "", "DE", "276", "", "08", "00", "07336", "49.53772", "7.40472", "Europe/Berlin"),("2882318", "Kürten", "Кюртен", "DE", "276", "", "07", "053", "05378", "51.05", "7.26667", "Europe/Berlin"),("2882366", "Kueps Oberfranken", "", "DE", "276", "", "02", "094", "09476", "50.19265", "11.27599", "Europe/Berlin"),("2882375", "Kuppenheim", "", "DE", "276", "", "01", "082", "08216", "48.82794", "8.25417", "Europe/Berlin"),("2882399", "Kupferzell", "", "DE", "276", "", "01", "081", "08126", "49.22778", "9.69", "Europe/Berlin"),("2882439", "Künzelsau", "Кюнцельзау", "DE", "276", "", "01", "081", "08126", "49.2818", "9.68352", "Europe/Berlin"),("2882440", "Künzell", "", "DE", "276", "", "05", "066", "06631", "50.5442", "9.71792", "Europe/Berlin"),("2882529", "Kümmersbruck", "", "DE", "276", "", "02", "093", "09371", "49.41917", "11.88833", "Europe/Berlin"),("2882575", "Külsheim", "", "DE", "276", "", "01", "081", "08128", "49.66942", "9.52361", "Europe/Berlin"),("2882588", "Kulmbach", "Кульмбах", "DE", "276", "", "02", "094", "09477", "50.10068", "11.45032", "Europe/Berlin"),("2883151", "Kuchen", "", "DE", "276", "", "01", "081", "08117", "48.63583", "9.79989", "Europe/Berlin"),("2883410", "Krumbach", "", "DE", "276", "", "02", "097", "09774", "48.24182", "10.3632", "Europe/Berlin"),("2883591", "Kropp", "", "DE", "276", "", "10", "00", "01059", "54.41667", "9.51667", "Europe/Berlin"),("2883647", "Kronshagen", "", "DE", "276", "", "10", "00", "01058", "54.33333", "10.08333", "Europe/Berlin"),("2883754", "Kronberg", "", "DE", "276", "", "05", "064", "06434", "50.18424", "8.5232", "Europe/Berlin"),("2883777", "Kronau", "", "DE", "276", "", "01", "082", "08215", "49.2225", "8.63111", "Europe/Berlin"),("2883784", "Kronach", "Кронах", "DE", "276", "", "02", "094", "09476", "50.23963", "11.33308", "Europe/Berlin"),("2883920", "Kriftel", "", "DE", "276", "", "05", "064", "06436", "50.08408", "8.46977", "Europe/Berlin"),("2884050", "Kreuztal", "Кройцталь", "DE", "276", "", "07", "059", "05970", "50.96775", "7.98848", "Europe/Berlin"),("2884161", "Kreuzberg", "", "DE", "276", "", "16", "00", "11000", "52.49973", "13.40338", "Europe/Berlin"),("2884245", "Kreuzau", "Кройцау", "DE", "276", "", "07", "053", "05358", "50.74699", "6.49069", "Europe/Berlin"),("2884344", "Kressbronn am Bodensee", "", "DE", "276", "", "01", "084", "08435", "47.5976", "9.59707", "Europe/Berlin"),("2884403", "Kremmen", "", "DE", "276", "", "11", "00", "12065", "52.76216", "13.02515", "Europe/Berlin"),("2884482", "Kreiensen", "", "DE", "276", "", "06", "00", "03155", "51.85363", "9.96481", "Europe/Berlin"),("2884509", "Krefeld", "Крефельд", "DE", "276", "", "07", "051", "05114", "51.33921", "6.58615", "Europe/Berlin"),("2884667", "Krauchenwies", "", "DE", "276", "", "01", "084", "08437", "48.03333", "9.25", "Europe/Berlin"),("2884779", "Kranenburg", "", "DE", "276", "", "07", "051", "05154", "51.78333", "6.01667", "Europe/Berlin"),("2884878", "Krailling", "", "DE", "276", "", "02", "091", "09188", "48.1", "11.4", "Europe/Berlin"),("2885070", "Kötzting", "", "DE", "276", "", "02", "093", "09372", "49.17649", "12.85515", "Europe/Berlin"),("2885237", "Köthen", "Кётен", "DE", "276", "", "14", "00", "15082", "51.75185", "11.97093", "Europe/Berlin"),("2885397", "Korschenbroich", "Коршенбройх", "DE", "276", "", "07", "051", "05162", "51.19139", "6.51352", "Europe/Berlin"),("2885408", "Kornwestheim", "Корнвестхайм", "DE", "276", "", "01", "081", "08118", "48.86158", "9.18569", "Europe/Berlin"),("2885412", "Korntal", "", "DE", "276", "", "01", "081", "08118", "48.83218", "9.1214", "Europe/Berlin"),("2885536", "Korbach", "Корбах", "DE", "276", "", "05", "066", "06635", "51.27561", "8.873", "Europe/Berlin"),("2885540", "Korb", "", "DE", "276", "", "01", "081", "08119", "48.84303", "9.36258", "Europe/Berlin"),("2885656", "Köpenick", "Кёпеник", "DE", "276", "DE", "16", "00", "11000", "52.4455", "13.57455", "Europe/Berlin"),("2885657", "Berlin Köpenick", "", "DE", "276", "DE", "16", "00", "11000", "52.44254", "13.58228", "Europe/Berlin"),("2885672", "Konz", "Конц", "DE", "276", "", "08", "00", "07235", "49.70045", "6.57652", "Europe/Berlin"),("2885679", "Konstanz", "Констанц", "DE", "276", "", "01", "083", "08335", "47.66033", "9.17582", "Europe/Berlin"),("2885689", "Konradshöhe", "", "DE", "276", "", "16", "00", "11000", "52.58535", "13.22758", "Europe/Berlin"),("2885716", "Könnern", "", "DE", "276", "", "14", "00", "15089", "51.6712", "11.77068", "Europe/Berlin"),("2885732", "Königs Wusterhausen", "Кёнигс-Вустерхаузен", "DE", "276", "", "11", "00", "12061", "52.30141", "13.633", "Europe/Berlin"),("2885734", "Königswinter", "Кёнигсвинтер", "DE", "276", "", "07", "053", "05382", "50.68376", "7.18675", "Europe/Berlin"),("2885760", "Königstein im Taunus", "Кёнигштайн", "DE", "276", "", "05", "064", "06434", "50.17943", "8.47132", "Europe/Berlin"),("2885800", "Königslutter am Elm", "Кёнигслуттер-ам-Эльм", "DE", "276", "", "06", "00", "03154", "52.25116", "10.81683", "Europe/Berlin"),("2885829", "Bad Königshofen im Grabfeld", "", "DE", "276", "", "02", "096", "09673", "50.30082", "10.46887", "Europe/Berlin"),("2885888", "Königsfeld im Schwarzwald", "", "DE", "276", "", "01", "083", "08326", "48.13814", "8.41973", "Europe/Berlin"),("2885895", "Königsee", "", "DE", "276", "", "15", "00", "16073", "50.66143", "11.09748", "Europe/Berlin"),("2885908", "Königsbrunn", "", "DE", "276", "", "02", "097", "09772", "48.27506", "10.89178", "Europe/Berlin"),("2885912", "Königsbronn", "", "DE", "276", "", "01", "081", "08135", "48.74317", "10.11193", "Europe/Berlin"),("2886008", "Köngen", "", "DE", "276", "", "01", "081", "08116", "48.68333", "9.36667", "Europe/Berlin"),("2886242", "Köln", "Кёльн", "DE", "276", "", "07", "053", "05315", "50.93333", "6.95", "Europe/Berlin"),("2886363", "Kölleda", "", "DE", "276", "", "15", "00", "16068", "51.18745", "11.24488", "Europe/Berlin"),("2886382", "Kolkwitz", "", "DE", "276", "", "11", "00", "12071", "51.75", "14.25", "Europe/Berlin"),("2886404", "Kolitzheim", "", "DE", "276", "", "02", "096", "09678", "49.91667", "10.23333", "Europe/Berlin"),("2886446", "Kolbermoor", "Кольбермор", "DE", "276", "", "02", "091", "09187", "47.84965", "12.06696", "Europe/Berlin"),("2886946", "Koblenz", "Кобленц", "DE", "276", "", "08", "00", "07111", "50.35357", "7.57883", "Europe/Berlin"),("2887140", "Knittlingen", "", "DE", "276", "", "01", "082", "08236", "49.02487", "8.75606", "Europe/Berlin"),("2887194", "Knetzgau", "", "DE", "276", "", "02", "096", "09674", "49.98333", "10.55", "Europe/Berlin"),("2887380", "Klötze", "", "DE", "276", "", "14", "00", "15081", "52.62725", "11.16424", "Europe/Berlin"),("2887645", "Klipphausen", "", "DE", "276", "", "13", "00", "14627", "51.08333", "13.53333", "Europe/Berlin"),("2887713", "Klingenthal", "", "DE", "276", "", "13", "00", "14523", "50.35963", "12.46463", "Europe/Berlin"),("2887736", "Klingenberg am Main", "", "DE", "276", "", "02", "096", "09676", "49.78507", "9.18025", "Europe/Berlin"),("2887835", "Kleve", "Клеве", "DE", "276", "", "07", "051", "05154", "51.78826", "6.13865", "Europe/Berlin"),("2888053", "Kleinwallstadt", "", "DE", "276", "", "02", "096", "09676", "49.87464", "9.16927", "Europe/Berlin"),("2888222", "Klein Schwülper", "", "DE", "276", "", "06", "00", "03151", "52.34153", "10.42903", "Europe/Berlin"),("2888344", "Klein Reken", "", "DE", "276", "", "07", "055", "05554", "51.7871", "7.04367", "Europe/Berlin"),("2888411", "Kleinostheim", "", "DE", "276", "", "02", "096", "09671", "50", "9.06667", "Europe/Berlin"),("2888523", "Kleinmachnow", "Клайнмахнов", "DE", "276", "", "11", "00", "12069", "52.40786", "13.22514", "Europe/Berlin"),("2889709", "Kleinblittersdorf", "", "DE", "276", "", "09", "00", "10041", "49.1578", "7.03734", "Europe/Berlin"),("2889990", "Klausdorf", "", "DE", "276", "", "10", "00", "01057", "54.30899", "10.21372", "Europe/Berlin"),("2890136", "Kladow", "", "DE", "276", "DE", "16", "00", "11000", "52.45423", "13.14445", "Europe/Berlin"),("2890155", "Kitzscher", "", "DE", "276", "", "13", "00", "14729", "51.16444", "12.5526", "Europe/Berlin"),("2890158", "Kitzingen", "Китцинген", "DE", "276", "", "02", "096", "09675", "49.73973", "10.15072", "Europe/Berlin"),("2890199", "Kißlegg", "", "DE", "276", "", "01", "084", "08436", "47.78894", "9.88383", "Europe/Berlin"),("2890202", "Kissing", "", "DE", "276", "", "02", "097", "09771", "48.30375", "10.97088", "Europe/Berlin"),("2890314", "Kirn", "", "DE", "276", "", "08", "00", "07133", "49.78912", "7.45765", "Europe/Berlin"),("2890322", "Kirkel", "", "DE", "276", "", "09", "00", "10045", "49.28333", "7.23333", "Europe/Berlin"),("2890328", "Kirchzarten", "", "DE", "276", "", "01", "083", "08315", "47.96667", "7.95", "Europe/Berlin"),("2890381", "Kirchseeon", "", "DE", "276", "", "02", "091", "09175", "48.07143", "11.88875", "Europe/Berlin"),("2890420", "Kirchlinteln", "", "DE", "276", "", "06", "00", "03361", "52.95", "9.31667", "Europe/Berlin"),("2890425", "Kirchlengern", "Кирхленгерн", "DE", "276", "", "07", "057", "05758", "52.2", "8.63333", "Europe/Berlin"),("2890442", "Kirchhundem", "", "DE", "276", "", "07", "059", "05966", "51.1", "8.1", "Europe/Berlin"),("2890473", "Kirchheim unter Teck", "Кирхгайм-унтер-Тек", "DE", "276", "", "01", "081", "08116", "48.64683", "9.45378", "Europe/Berlin"),("2890478", "Kirchheimbolanden", "", "DE", "276", "", "08", "00", "07333", "49.66249", "8.01513", "Europe/Berlin"),("2890479", "Kirchheim bei München", "", "DE", "276", "", "02", "091", "09184", "48.17656", "11.75563", "Europe/Berlin"),("2890482", "Kirchheim am Neckar", "", "DE", "276", "", "01", "081", "08118", "49.045", "9.14222", "Europe/Berlin"),("2890504", "Kirchhain", "Кирхгайн", "DE", "276", "", "05", "065", "06534", "50.8272", "8.92806", "Europe/Berlin"),("2890527", "Kirchentellinsfurt", "", "DE", "276", "", "01", "084", "08416", "48.53315", "9.14732", "Europe/Berlin"),("2890586", "Kirchen", "", "DE", "276", "", "08", "00", "07132", "50.80849", "7.88634", "Europe/Berlin"),("2890602", "Kirchdorf am Inn", "", "DE", "276", "", "02", "092", "09277", "48.24755", "12.98453", "Europe/Berlin"),("2890659", "Kirchberg", "", "DE", "276", "", "13", "00", "14524", "50.6219", "12.52449", "Europe/Berlin"),("2890769", "Kirchardt", "", "DE", "276", "", "01", "081", "08125", "49.205", "8.99167", "Europe/Berlin"),("2890795", "Kippenheim", "", "DE", "276", "", "01", "083", "08317", "48.29564", "7.8251", "Europe/Berlin"),("2891014", "Kierspe", "Кирспе", "DE", "276", "", "07", "059", "05962", "51.13403", "7.59075", "Europe/Berlin"),("2891122", "Kiel", "Киль", "DE", "276", "", "10", "00", "01002", "54.32133", "10.13489", "Europe/Berlin"),("2891175", "Kiefersfelden", "", "DE", "276", "", "02", "091", "09187", "47.61409", "12.19096", "Europe/Berlin"),("2891258", "Kevelaer", "Кевелар", "DE", "276", "", "07", "051", "05154", "51.58243", "6.24603", "Europe/Berlin"),("2891282", "Ketzin", "", "DE", "276", "", "11", "00", "12063", "52.47809", "12.8453", "Europe/Berlin"),("2891343", "Ketsch", "", "DE", "276", "", "01", "082", "08226", "49.36778", "8.53111", "Europe/Berlin"),("2891524", "Kerpen", "Керпен", "DE", "276", "", "07", "053", "05362", "50.86991", "6.69691", "Europe/Berlin"),("2891590", "Kenzingen", "", "DE", "276", "", "01", "083", "08316", "48.1963", "7.76974", "Europe/Berlin"),("2891621", "Kempten (Allgäu)", "", "DE", "276", "", "02", "097", "09763", "47.72674", "10.31389", "Europe/Berlin"),("2891643", "Kempen", "Кемпен", "DE", "276", "", "07", "051", "05166", "51.36432", "6.41858", "Europe/Berlin"),("2891668", "Kemnath", "", "DE", "276", "", "02", "093", "09377", "49.87007", "11.89077", "Europe/Berlin"),("2891742", "Kelsterbach", "", "DE", "276", "", "05", "064", "06433", "50.06135", "8.52916", "Europe/Berlin"),("2891750", "Kellinghusen", "", "DE", "276", "", "10", "00", "01061", "53.95202", "9.71959", "Europe/Berlin"),("2891832", "Kelkheim (Taunus)", "", "DE", "276", "", "05", "064", "06436", "50.13703", "8.4502", "Europe/Berlin"),("2891834", "Kelheim", "Кельхайм", "DE", "276", "", "02", "092", "09273", "48.91725", "11.88618", "Europe/Berlin"),("2891951", "Kehl", "Кель", "DE", "276", "", "01", "083", "08317", "48.57297", "7.81523", "Europe/Berlin"),("2892051", "Kaulsdorf", "", "DE", "276", "DE", "16", "00", "11000", "52.51732", "13.58871", "Europe/Berlin"),("2892078", "Kaufering", "", "DE", "276", "", "02", "091", "09181", "48.09121", "10.87913", "Europe/Berlin"),("2892080", "Kaufbeuren", "Кауфбойрен", "DE", "276", "", "02", "097", "09762", "47.88238", "10.62192", "Europe/Berlin"),("2892485", "Kastellaun", "", "DE", "276", "", "08", "00", "07140", "50.06922", "7.44154", "Europe/Berlin"),("2892518", "Kassel", "Кассель", "DE", "276", "", "05", "066", "06611", "51.31667", "9.5", "Europe/Berlin"),("2892648", "Karstädt", "", "DE", "276", "", "11", "00", "12070", "53.15", "11.75", "Europe/Berlin"),("2892705", "Karow", "", "DE", "276", "DE", "16", "00", "11000", "52.60904", "13.48117", "Europe/Berlin"),("2892786", "Karlstadt", "Карлштадт", "DE", "276", "", "02", "096", "09677", "49.96034", "9.77239", "Europe/Berlin"),("2892794", "Karlsruhe", "Карлсруэ", "DE", "276", "", "01", "082", "08212", "49.00937", "8.40444", "Europe/Berlin"),("2892810", "Karlshuld", "", "DE", "276", "", "02", "091", "09185", "48.68333", "11.3", "Europe/Berlin"),("2892811", "Karlshorst", "Карлсхорст", "DE", "276", "DE", "16", "00", "11000", "52.48419", "13.53185", "Europe/Berlin"),("2892874", "Karlsfeld", "", "DE", "276", "", "02", "091", "09174", "48.21667", "11.46667", "Europe/Berlin"),("2892980", "Karben", "Карбен", "DE", "276", "", "05", "064", "06440", "50.23019", "8.77155", "Europe/Berlin"),("2893022", "Kappelrodeck", "", "DE", "276", "", "01", "083", "08317", "48.59182", "8.11692", "Europe/Berlin"),("2893023", "Kappeln", "", "DE", "276", "", "10", "00", "01059", "54.66122", "9.9313", "Europe/Berlin"),("2893237", "Kandern", "", "DE", "276", "", "01", "083", "08336", "47.71393", "7.66237", "Europe/Berlin"),("2893244", "Kandel", "", "DE", "276", "", "08", "00", "07334", "49.08277", "8.1972", "Europe/Berlin"),("2893264", "Kamp-Lintfort", "Камп-Линтфорт", "DE", "276", "", "07", "051", "05170", "51.50467", "6.54587", "Europe/Berlin"),("2893437", "Kamenz", "Каменц", "DE", "276", "", "13", "00", "14625", "51.26798", "14.09374", "Europe/Berlin"),("2893438", "Kamen", "Камен", "DE", "276", "", "07", "059", "05978", "51.59231", "7.6638", "Europe/Berlin"),("2893544", "Kaltenkirchen", "Кальтенкирхен", "DE", "276", "", "10", "00", "01060", "53.83292", "9.9581", "Europe/Berlin"),("2893762", "Kall", "", "DE", "276", "", "07", "053", "05366", "50.55", "6.55", "Europe/Berlin"),("2893837", "Kalkar", "", "DE", "276", "", "07", "051", "05154", "51.73907", "6.29101", "Europe/Berlin"),("2893868", "Kalefeld", "", "DE", "276", "", "06", "00", "03155", "51.8", "10.03333", "Europe/Berlin"),("2894003", "Kaiserslautern", "Кайзерслаутерн", "DE", "276", "", "08", "00", "07312", "49.443", "7.77161", "Europe/Berlin"),("2894245", "Kahl am Main", "", "DE", "276", "", "02", "096", "09671", "50.06981", "9.00553", "Europe/Berlin"),("2894247", "Kahla", "", "DE", "276", "", "15", "00", "16074", "50.80651", "11.58516", "Europe/Berlin"),("2894375", "Kaarst", "Карст", "DE", "276", "", "07", "051", "05162", "51.22929", "6.61883", "Europe/Berlin"),("2894394", "Jüterbog", "", "DE", "276", "", "11", "00", "12072", "51.99607", "13.07979", "Europe/Berlin"),("2894553", "Jülich", "Юлих", "DE", "276", "", "07", "053", "05358", "50.92149", "6.36267", "Europe/Berlin"),("2894637", "Jüchen", "Йюхен", "DE", "276", "", "07", "051", "05162", "51.1", "6.5", "Europe/Berlin"),("2894702", "Jork", "", "DE", "276", "", "06", "00", "03359", "53.53198", "9.68076", "Europe/Berlin"),("2894742", "Jöhlingen", "", "DE", "276", "", "01", "082", "08215", "49.03218", "8.5735", "Europe/Berlin"),("2894755", "Johannisthal", "", "DE", "276", "DE", "16", "00", "11000", "52.44653", "13.5066", "Europe/Berlin"),("2894814", "Johanngeorgenstadt", "", "DE", "276", "", "13", "00", "14521", "50.43254", "12.7114", "Europe/Berlin"),("2894855", "Jockgrim", "", "DE", "276", "", "08", "00", "07334", "49.09889", "8.26778", "Europe/Berlin"),("2894897", "Jever", "", "DE", "276", "", "06", "00", "03455", "53.57368", "7.89806", "Europe/Berlin"),("2894944", "Jestetten", "", "DE", "276", "", "01", "083", "08337", "47.65", "8.56667", "Europe/Berlin"),("2894945", "Jesteburg", "", "DE", "276", "", "06", "00", "03353", "53.3", "9.96667", "Europe/Berlin"),("2894962", "Jessen", "", "DE", "276", "", "14", "00", "15091", "51.79337", "12.95762", "Europe/Berlin"),("2895044", "Jena", "Йена", "DE", "276", "", "15", "00", "16053", "50.92878", "11.5899", "Europe/Berlin"),("2895284", "Jahnsdorf", "", "DE", "276", "", "13", "00", "14521", "50.74509", "12.85414", "Europe/Berlin"),("2895569", "Itzehoe", "Итцехо", "DE", "276", "", "10", "00", "01061", "53.92099", "9.51529", "Europe/Berlin"),("2895617", "Issum", "", "DE", "276", "", "07", "051", "05154", "51.53333", "6.43333", "Europe/Berlin"),("2895630", "Isselburg", "", "DE", "276", "", "07", "055", "05554", "51.83232", "6.46428", "Europe/Berlin"),("2895636", "Ispringen", "", "DE", "276", "", "01", "082", "08236", "48.91667", "8.66667", "Europe/Berlin"),("2895638", "Isny im Allgäu", "", "DE", "276", "", "01", "084", "08436", "47.6926", "10.03857", "Europe/Berlin"),("2895643", "Ismaning", "", "DE", "276", "", "02", "091", "09184", "48.23333", "11.68333", "Europe/Berlin"),("2895664", "Isernhagen Farster Bauerschaft", "", "DE", "276", "", "06", "00", "03241", "52.47093", "9.84179", "Europe/Berlin"),("2895669", "Iserlohn", "Изерлон", "DE", "276", "", "07", "059", "05962", "51.37547", "7.70281", "Europe/Berlin"),("2895688", "Isenbüttel", "", "DE", "276", "", "06", "00", "03151", "52.43333", "10.58333", "Europe/Berlin"),("2895702", "Isen", "", "DE", "276", "", "02", "091", "09177", "48.21203", "12.05672", "Europe/Berlin"),("2895992", "Ingolstadt", "Ингольштадт", "DE", "276", "", "02", "091", "09161", "48.76508", "11.42372", "Europe/Berlin"),("2896021", "Ingelfingen", "", "DE", "276", "", "01", "081", "08126", "49.30028", "9.65303", "Europe/Berlin"),("2896120", "Inden", "", "DE", "276", "", "07", "053", "05358", "50.86667", "6.36667", "Europe/Berlin"),("2896261", "Immenstadt im Allgäu", "", "DE", "276", "", "02", "097", "09780", "47.55996", "10.21394", "Europe/Berlin"),("2896263", "Immenstaad am Bodensee", "", "DE", "276", "", "01", "084", "08435", "47.66667", "9.36667", "Europe/Berlin"),("2896279", "Immenhausen", "", "DE", "276", "", "05", "066", "06633", "51.42763", "9.48017", "Europe/Berlin"),("2896288", "Immendingen", "", "DE", "276", "", "01", "083", "08327", "47.93333", "8.73333", "Europe/Berlin"),("2896468", "Ilvesheim", "", "DE", "276", "", "01", "082", "08226", "49.47404", "8.5674", "Europe/Berlin"),("2896476", "Ilshofen", "", "DE", "276", "", "01", "081", "08127", "49.17015", "9.91825", "Europe/Berlin"),("2896477", "Ilsfeld", "", "DE", "276", "", "01", "081", "08125", "49.05548", "9.24598", "Europe/Berlin"),("2896483", "Ilsenburg", "", "DE", "276", "", "14", "00", "15085", "51.86695", "10.67817", "Europe/Berlin"),("2896514", "Ilmenau", "Ильменау", "DE", "276", "", "15", "00", "16070", "50.68322", "10.91858", "Europe/Berlin"),("2896538", "Illingen", "", "DE", "276", "", "09", "00", "10043", "49.37362", "7.04758", "Europe/Berlin"),("2896539", "Illingen", "", "DE", "276", "", "01", "082", "08236", "48.95616", "8.92459", "Europe/Berlin"),("2896546", "Illertissen", "Иллертиссен", "DE", "276", "", "02", "097", "09775", "48.22336", "10.10347", "Europe/Berlin"),("2896616", "Ihringen", "", "DE", "276", "", "01", "083", "08315", "48.04303", "7.6476", "Europe/Berlin"),("2896687", "Igersheim", "", "DE", "276", "", "01", "081", "08128", "49.49444", "9.81694", "Europe/Berlin"),("2896736", "Idstein", "Идштайн", "DE", "276", "", "05", "064", "06439", "50.21773", "8.26679", "Europe/Berlin"),("2896753", "Idar-Oberstein", "Идар-Оберштайн", "DE", "276", "", "08", "00", "07134", "49.71443", "7.30776", "Europe/Berlin"),("2896776", "Ichenhausen", "", "DE", "276", "", "02", "097", "09774", "48.37119", "10.30706", "Europe/Berlin"),("2896817", "Ibbenbüren", "Иббенбюрен", "DE", "276", "", "07", "055", "05566", "52.27964", "7.71457", "Europe/Berlin"),("2896834", "Huy-Neinstedt", "", "DE", "276", "", "14", "00", "15085", "51.96585", "10.91457", "Europe/Berlin"),("2896877", "Hüttlingen", "", "DE", "276", "", "01", "081", "08136", "48.89266", "10.10064", "Europe/Berlin"),("2896898", "Hutthurm", "", "DE", "276", "", "02", "092", "09275", "48.67276", "13.47146", "Europe/Berlin"),("2897132", "Husum", "Хузум", "DE", "276", "", "10", "00", "01054", "54.4858", "9.05239", "Europe/Berlin"),("2897216", "Hürth", "Хюрт", "DE", "276", "", "07", "053", "05362", "50.87079", "6.86761", "Europe/Berlin"),("2897219", "Hürtgenwald", "", "DE", "276", "", "07", "053", "05358", "50.71667", "6.36667", "Europe/Berlin"),("2897283", "Hünxe", "", "DE", "276", "", "07", "051", "05170", "51.65", "6.78333", "Europe/Berlin"),("2897436", "Hünfeld", "Хюнфельд", "DE", "276", "", "05", "066", "06631", "50.67966", "9.76727", "Europe/Berlin"),("2897674", "Hummelsbüttel", "", "DE", "276", "", "04", "00", "02000", "53.64773", "10.04149", "Europe/Berlin"),("2897732", "Humboldtkolonie", "", "DE", "276", "", "07", "053", "05315", "50.93182", "6.99469", "Europe/Berlin"),("2897844", "Hüllhorst", "", "DE", "276", "", "07", "057", "05770", "52.28333", "8.66667", "Europe/Berlin"),("2898028", "Hüfingen", "", "DE", "276", "", "01", "083", "08326", "47.92543", "8.48831", "Europe/Berlin"),("2898079", "Hude", "", "DE", "276", "", "06", "00", "03458", "53.10766", "8.46322", "Europe/Berlin"),("2898098", "Hückeswagen", "Хюккесваген", "DE", "276", "", "07", "053", "05374", "51.14979", "7.34471", "Europe/Berlin"),("2898111", "Hückelhoven", "Хюккельхофен", "DE", "276", "", "07", "053", "05370", "51.0555", "6.22658", "Europe/Berlin"),("2898304", "Hoyerswerda", "Хойерсверда", "DE", "276", "", "13", "00", "14625", "51.43787", "14.23549", "Europe/Berlin"),("2898321", "Höxter", "Хёкстер", "DE", "276", "", "07", "057", "05762", "51.77501", "9.38155", "Europe/Berlin"),("2898364", "Hövelhof", "Хёфельхоф", "DE", "276", "", "07", "057", "05774", "51.81667", "8.65", "Europe/Berlin"),("2898494", "Hösbach", "", "DE", "276", "", "02", "096", "09671", "50.00646", "9.20765", "Europe/Berlin"),("2898541", "Horstmar", "", "DE", "276", "", "07", "055", "05566", "52.08098", "7.30539", "Europe/Berlin"),("2898603", "Hörstel", "Хёрстель", "DE", "276", "", "07", "055", "05566", "52.29763", "7.58382", "Europe/Berlin"),("2898640", "Horst", "", "DE", "276", "", "10", "00", "01061", "53.81195", "9.62307", "Europe/Berlin"),("2898847", "Horneburg", "", "DE", "276", "", "06", "00", "03359", "53.50672", "9.57546", "Europe/Berlin"),("2898924", "Horn", "", "DE", "276", "", "07", "057", "05766", "51.87151", "8.9451", "Europe/Berlin"),("2899101", "Horb am Neckar", "Хорб-на-Неккаре", "DE", "276", "", "01", "082", "08237", "48.44423", "8.6913", "Europe/Berlin"),("2899449", "Homburg", "", "DE", "276", "", "09", "00", "10045", "49.32637", "7.33867", "Europe/Berlin"),("2899478", "Homberg", "", "DE", "276", "", "05", "066", "06634", "51.02994", "9.40261", "Europe/Berlin"),("2899479", "Homberg", "", "DE", "276", "", "05", "065", "06535", "50.73108", "8.99644", "Europe/Berlin"),("2899538", "Holzwickede", "Хольцвиккеде", "DE", "276", "", "07", "059", "05978", "51.5", "7.63333", "Europe/Berlin"),("2899601", "Holzminden", "Хольцминден", "DE", "276", "", "06", "00", "03255", "51.82798", "9.4455", "Europe/Berlin"),("2899676", "Holzkirchen", "Хольцкирхен", "DE", "276", "", "02", "091", "09182", "47.87663", "11.70181", "Europe/Berlin"),("2899880", "Holzgerlingen", "", "DE", "276", "", "01", "081", "08115", "48.63969", "9.01149", "Europe/Berlin"),("2900453", "Hollfeld", "", "DE", "276", "", "02", "094", "09472", "49.93793", "11.29153", "Europe/Berlin"),("2900623", "Holle", "", "DE", "276", "", "06", "00", "03254", "52.08721", "10.16012", "Europe/Berlin"),("2900740", "Holdorf", "", "DE", "276", "", "06", "00", "03460", "52.58333", "8.11667", "Europe/Berlin"),("2900825", "Höhr-Grenzhausen", "", "DE", "276", "", "08", "00", "07143", "50.43474", "7.66903", "Europe/Berlin"),("2901348", "Hohenwestedt", "", "DE", "276", "", "10", "00", "01058", "54.08333", "9.66667", "Europe/Berlin"),("2901420", "Hohenstein-Ernstthal", "Хоэнштайн-Эрнстталь", "DE", "276", "", "13", "00", "14524", "50.80064", "12.71287", "Europe/Berlin"),("2901588", "Hohen Neuendorf", "Хоэн-Нойендорф", "DE", "276", "", "11", "00", "12065", "52.67631", "13.27775", "Europe/Berlin"),("2901601", "Hohenmölsen", "", "DE", "276", "", "14", "00", "15084", "51.15769", "12.1", "Europe/Berlin"),("2901621", "Hohenlockstedt", "", "DE", "276", "", "10", "00", "01061", "53.96667", "9.61667", "Europe/Berlin"),("2901731", "Hohenhameln", "", "DE", "276", "", "06", "00", "03157", "52.25755", "10.06416", "Europe/Berlin"),("2901872", "Hohenbrunn", "", "DE", "276", "", "02", "091", "09184", "48.04785", "11.70224", "Europe/Berlin"),("2901908", "Höhenberg", "", "DE", "276", "", "07", "053", "05315", "50.93323", "7.04138", "Europe/Berlin"),("2902235", "Hohberg", "", "DE", "276", "", "01", "083", "08317", "48.3227", "7.89972", "Europe/Berlin"),("2902531", "Hofheim in Unterfranken", "", "DE", "276", "", "02", "096", "09674", "50.13675", "10.52321", "Europe/Berlin"),("2902533", "Hofheim am Taunus", "Хофхайм-ам-Таунус", "DE", "276", "", "05", "064", "06436", "50.09019", "8.4493", "Europe/Berlin"),("2902559", "Hofgeismar", "Хофгайсмар", "DE", "276", "", "05", "066", "06633", "51.49607", "9.385", "Europe/Berlin"),("2902731", "Hofbieber", "", "DE", "276", "", "05", "066", "06631", "50.58629", "9.83534", "Europe/Berlin"),("2902768", "Hof", "Хоф", "DE", "276", "", "02", "094", "09464", "50.31297", "11.91261", "Europe/Berlin"),("2902852", "Hockenheim", "Хоккенхайм", "DE", "276", "", "01", "082", "08226", "49.32334", "8.55194", "Europe/Berlin"),("2902951", "Höchst im Odenwald", "", "DE", "276", "", "05", "064", "06437", "49.79972", "8.99944", "Europe/Berlin"),("2903012", "Höchstädt an der Donau", "", "DE", "276", "", "02", "097", "09773", "48.61124", "10.56816", "Europe/Berlin"),("2903016", "Höchstadt an der Aisch", "", "DE", "276", "", "02", "095", "09572", "49.70617", "10.81329", "Europe/Berlin"),("2903175", "Hochheim am Main", "Хохгайм-на-Майне", "DE", "276", "", "05", "064", "06436", "50.01436", "8.35218", "Europe/Berlin"),("2903237", "Hochfeld", "", "DE", "276", "", "07", "051", "05112", "51.41943", "6.75462", "Europe/Berlin"),("2903327", "Höchberg", "", "DE", "276", "", "02", "096", "09679", "49.78446", "9.88223", "Europe/Berlin"),("2903470", "Hitzacker", "", "DE", "276", "", "06", "00", "03354", "53.15254", "11.04418", "Europe/Berlin"),("2903806", "Hirschau", "", "DE", "276", "", "02", "093", "09371", "49.54396", "11.94617", "Europe/Berlin"),("2903810", "Hirschaid", "", "DE", "276", "", "02", "094", "09471", "49.81789", "10.98918", "Europe/Berlin"),("2904397", "Hinte", "", "DE", "276", "", "06", "00", "03452", "53.41667", "7.18333", "Europe/Berlin"),("2904591", "Hilzingen", "", "DE", "276", "", "01", "083", "08335", "47.76667", "8.78333", "Europe/Berlin"),("2904607", "Hilter", "", "DE", "276", "", "06", "00", "03459", "52.13573", "8.14715", "Europe/Berlin"),("2904638", "Hilpoltstein", "", "DE", "276", "", "02", "095", "09576", "49.19047", "11.1906", "Europe/Berlin"),("2904725", "Hille", "", "DE", "276", "", "07", "057", "05770", "52.33333", "8.75", "Europe/Berlin"),("2904789", "Hildesheim", "Хильдесхайм", "DE", "276", "", "06", "00", "03254", "52.15077", "9.95112", "Europe/Berlin"),("2904795", "Hilden", "Хильден", "DE", "276", "", "07", "051", "05158", "51.16818", "6.93093", "Europe/Berlin"),("2904804", "Hildburghausen", "", "DE", "276", "", "15", "00", "16069", "50.42553", "10.73184", "Europe/Berlin"),("2904808", "Hilchenbach", "Хильхенбах", "DE", "276", "", "07", "059", "05970", "50.99687", "8.11062", "Europe/Berlin"),("2904886", "Hiddenhausen", "Хидденхаузен", "DE", "276", "", "07", "057", "05758", "52.16667", "8.61667", "Europe/Berlin"),("2904985", "Heusweiler", "Хойсвайлер", "DE", "276", "", "09", "00", "10041", "49.35", "6.93333", "Europe/Berlin"),("2904992", "Heusenstamm", "Хойзенштамм", "DE", "276", "", "05", "064", "06438", "50.05553", "8.80076", "Europe/Berlin"),("2905070", "Heuchelheim", "", "DE", "276", "", "05", "065", "06531", "50.58333", "8.63333", "Europe/Berlin"),("2905154", "Heubach", "", "DE", "276", "", "01", "081", "08136", "48.79267", "9.9337", "Europe/Berlin"),("2905206", "Hettstedt", "Хетштедт", "DE", "276", "", "14", "00", "15087", "51.6503", "11.51146", "Europe/Berlin"),("2905290", "Hessisch Oldendorf", "Хессиш-Ольдендорф", "DE", "276", "", "06", "00", "03252", "52.17269", "9.24913", "Europe/Berlin"),("2905293", "Hessisch Lichtenau", "", "DE", "276", "", "05", "066", "06636", "51.19954", "9.71857", "Europe/Berlin"),("2905455", "Herzogenrath", "Херцогенрат", "DE", "276", "", "07", "053", "05334", "50.87067", "6.10136", "Europe/Berlin"),("2905457", "Herzogenaurach", "Херцогенаурах", "DE", "276", "", "02", "095", "09572", "49.56798", "10.88565", "Europe/Berlin"),("2905496", "Herzberg am Harz", "", "DE", "276", "", "06", "00", "03156", "51.65546", "10.33938", "Europe/Berlin"),("2905504", "Herzberg", "", "DE", "276", "", "11", "00", "12062", "51.68692", "13.22016", "Europe/Berlin"),("2905527", "Herxheim am Berg", "", "DE", "276", "", "08", "00", "07332", "49.50917", "8.17917", "Europe/Berlin"),("2905560", "Herten", "Хертен", "DE", "276", "", "07", "055", "05562", "51.59638", "7.14387", "Europe/Berlin"),("2905587", "Herscheid", "", "DE", "276", "", "07", "059", "05962", "51.17901", "7.74355", "Europe/Berlin"),("2905599", "Hersbruck", "", "DE", "276", "", "02", "095", "09574", "49.51083", "11.43151", "Europe/Berlin"),("2905604", "Herrsching am Ammersee", "", "DE", "276", "", "02", "091", "09188", "47.99888", "11.17679", "Europe/Berlin"),("2905706", "Herrieden", "", "DE", "276", "", "02", "095", "09571", "49.23779", "10.5035", "Europe/Berlin"),("2905826", "Herrenberg", "Херренберг", "DE", "276", "", "01", "081", "08115", "48.59523", "8.86648", "Europe/Berlin"),("2905878", "Heroldsberg", "", "DE", "276", "", "02", "095", "09572", "49.53247", "11.15551", "Europe/Berlin"),("2905881", "Heroldsbach", "", "DE", "276", "", "02", "094", "09474", "49.69342", "10.99882", "Europe/Berlin"),("2905891", "Herne", "Херне", "DE", "276", "", "07", "059", "05916", "51.5388", "7.22572", "Europe/Berlin"),("2905904", "Hermsdorf", "", "DE", "276", "", "16", "00", "11000", "52.61131", "13.31783", "Europe/Berlin"),("2905916", "Hermsdorf", "", "DE", "276", "", "15", "00", "16074", "50.89694", "11.85549", "Europe/Berlin"),("2905929", "Hermeskeil", "", "DE", "276", "", "08", "00", "07235", "49.65528", "6.94407", "Europe/Berlin"),("2906015", "Hermannsburg", "", "DE", "276", "", "06", "00", "03351", "52.83254", "10.08957", "Europe/Berlin"),("2906088", "Heringen", "", "DE", "276", "", "05", "066", "06632", "50.88798", "10.00717", "Europe/Berlin"),("2906121", "Herford", "Херфорд", "DE", "276", "", "07", "057", "05758", "52.11457", "8.67343", "Europe/Berlin"),("2906143", "Herdorf", "", "DE", "276", "", "08", "00", "07132", "50.77704", "7.95366", "Europe/Berlin"),("2906152", "Herdecke", "Хердекке", "DE", "276", "", "07", "059", "05954", "51.39999", "7.43584", "Europe/Berlin"),("2906175", "Herbstein", "", "DE", "276", "", "05", "065", "06535", "50.56105", "9.34592", "Europe/Berlin"),("2906194", "Herbrechtingen", "", "DE", "276", "", "01", "081", "08135", "48.62173", "10.176", "Europe/Berlin"),("2906199", "Herborn", "Херборн", "DE", "276", "", "05", "065", "06532", "50.68135", "8.30369", "Europe/Berlin"),("2906205", "Herbolzheim", "", "DE", "276", "", "01", "083", "08316", "48.21884", "7.77746", "Europe/Berlin"),("2906268", "Heppenheim an der Bergstrasse", "", "DE", "276", "", "05", "064", "06431", "49.64145", "8.63206", "Europe/Berlin"),("2906331", "Hennigsdorf", "Хеннигсдорф", "DE", "276", "", "11", "00", "12065", "52.63598", "13.20419", "Europe/Berlin"),("2906376", "Hennef", "Хеннеф", "DE", "276", "", "07", "053", "05382", "50.77555", "7.28308", "Europe/Berlin"),("2906464", "Hengersberg", "", "DE", "276", "", "02", "092", "09271", "48.77255", "13.05485", "Europe/Berlin"),("2906514", "Hemsbach", "", "DE", "276", "", "01", "082", "08226", "49.59075", "8.64779", "Europe/Berlin"),("2906524", "Hemmoor", "", "DE", "276", "", "06", "00", "03352", "53.68702", "9.15492", "Europe/Berlin"),("2906530", "Hemmingen", "", "DE", "276", "", "06", "00", "03241", "52.31425", "9.72359", "Europe/Berlin"),("2906531", "Hemmingen", "", "DE", "276", "", "01", "081", "08118", "48.86667", "9.03333", "Europe/Berlin"),("2906583", "Hemhofen", "", "DE", "276", "", "02", "095", "09572", "49.68333", "10.93333", "Europe/Berlin"),("2906595", "Hemer", "Хемер", "DE", "276", "", "07", "059", "05962", "51.38707", "7.77019", "Europe/Berlin"),("2906625", "Hemau", "", "DE", "276", "", "02", "093", "09375", "49.05399", "11.78195", "Europe/Berlin"),("2906654", "Helsa", "", "DE", "276", "", "05", "066", "06633", "51.26667", "9.68333", "Europe/Berlin"),("2906676", "Helmstedt", "Хельмштедт", "DE", "276", "", "06", "00", "03154", "52.2279", "11.00985", "Europe/Berlin"),("2906744", "Helmbrechts", "", "DE", "276", "", "02", "094", "09475", "50.23557", "11.71589", "Europe/Berlin"),("2906809", "Hellersdorf", "", "DE", "276", "", "16", "00", "11000", "52.53319", "13.6088", "Europe/Berlin"),("2906843", "Hellenthal", "", "DE", "276", "", "07", "053", "05366", "50.48333", "6.43333", "Europe/Berlin"),("2907068", "Heitersheim", "", "DE", "276", "", "01", "083", "08315", "47.87468", "7.65721", "Europe/Berlin"),("2907201", "Heinsberg", "Хайнсберг", "DE", "276", "", "07", "053", "05370", "51.06358", "6.0998", "Europe/Berlin"),("2907280", "Heiningen", "", "DE", "276", "", "01", "081", "08117", "48.66177", "9.64977", "Europe/Berlin"),("2907298", "Heinersdorf", "", "DE", "276", "DE", "16", "00", "11000", "52.57173", "13.43757", "Europe/Berlin"),("2907359", "Heimsheim", "", "DE", "276", "", "01", "082", "08236", "48.80656", "8.86744", "Europe/Berlin"),("2907488", "Heilsbronn", "", "DE", "276", "", "02", "095", "09571", "49.33572", "10.78741", "Europe/Berlin"),("2907545", "Heilbad Heiligenstadt", "Хайльбад-Хайлигенштадт", "DE", "276", "", "15", "00", "16061", "51.37819", "10.13744", "Europe/Berlin"),("2907551", "Heiligensee", "", "DE", "276", "DE", "16", "00", "11000", "52.61449", "13.24501", "Europe/Berlin"),("2907585", "Heiligenhaus", "Хайлигенхаус", "DE", "276", "", "07", "051", "05158", "51.32662", "6.97106", "Europe/Berlin"),("2907589", "Heiligenhafen", "", "DE", "276", "", "10", "00", "01055", "54.36964", "10.98022", "Europe/Berlin"),("2907669", "Heilbronn", "Хайльбронн", "DE", "276", "", "01", "081", "08121", "49.13995", "9.22054", "Europe/Berlin"),("2907685", "Heikendorf", "", "DE", "276", "", "10", "00", "01057", "54.36667", "10.2", "Europe/Berlin"),("2907790", "Heidesheim", "", "DE", "276", "", "08", "00", "07332", "49.58247", "8.19537", "Europe/Berlin"),("2907851", "Heidenheim an der Brenz", "Хайденхайм-на-Бренце", "DE", "276", "", "01", "081", "08135", "48.67798", "10.15162", "Europe/Berlin"),("2907887", "Heidenau", "Хайденау", "DE", "276", "", "13", "00", "14628", "50.97221", "13.86741", "Europe/Berlin"),("2907889", "Heiden", "", "DE", "276", "", "07", "055", "05554", "51.83333", "6.93333", "Europe/Berlin"),("2907911", "Heidelberg", "Хайдельберг", "DE", "276", "", "01", "082", "08221", "49.40768", "8.69079", "Europe/Berlin"),("2907983", "Heideck", "", "DE", "276", "", "02", "095", "09576", "49.13365", "11.12726", "Europe/Berlin"),("2908032", "Heide", "Хайде", "DE", "276", "", "10", "00", "01051", "54.19579", "9.0988", "Europe/Berlin"),("2908330", "Heek", "", "DE", "276", "", "07", "055", "05554", "52.11667", "7.1", "Europe/Berlin"),("2908398", "Heddesheim", "", "DE", "276", "", "01", "082", "08226", "49.50556", "8.60361", "Europe/Berlin"),("2908495", "Hechingen", "Хехинген", "DE", "276", "", "01", "084", "08417", "48.35149", "8.96317", "Europe/Berlin"),("2908529", "Hebertshausen", "", "DE", "276", "", "02", "091", "09174", "48.28959", "11.46526", "Europe/Berlin"),("2908597", "Havixbeck", "", "DE", "276", "", "07", "055", "05558", "51.98333", "7.41667", "Europe/Berlin"),("2908644", "Havelberg", "", "DE", "276", "", "14", "00", "15090", "52.83088", "12.07552", "Europe/Berlin"),("2908661", "Hauzenberg", "", "DE", "276", "", "02", "092", "09275", "48.64957", "13.62645", "Europe/Berlin"),("2908783", "Hausham", "", "DE", "276", "", "02", "091", "09182", "47.7466", "11.84069", "Europe/Berlin"),("2908974", "Hausach", "", "DE", "276", "", "01", "083", "08317", "48.28426", "8.17602", "Europe/Berlin"),("2909230", "Hattingen", "Хаттинген", "DE", "276", "", "07", "059", "05954", "51.39894", "7.18557", "Europe/Berlin"),("2909240", "Hattersheim", "", "DE", "276", "", "05", "064", "06436", "50.07854", "8.47552", "Europe/Berlin"),("2909268", "Hatten", "", "DE", "276", "", "06", "00", "03458", "53.05", "8.38333", "Europe/Berlin"),("2909313", "Haßloch", "", "DE", "276", "", "08", "00", "07332", "49.36278", "8.25806", "Europe/Berlin"),("2909335", "Haßfurt", "", "DE", "276", "", "02", "096", "09674", "50.03521", "10.5156", "Europe/Berlin"),("2909544", "Haslach", "", "DE", "276", "", "01", "083", "08317", "48.56531", "8.05658", "Europe/Berlin"),("2909761", "Haselünne", "", "DE", "276", "", "06", "00", "03454", "52.67412", "7.4846", "Europe/Berlin"),("2909794", "Haselhorst", "", "DE", "276", "", "16", "00", "11000", "52.54409", "13.23743", "Europe/Berlin"),("2909915", "Hasbergen", "", "DE", "276", "", "06", "00", "03459", "52.23333", "7.93333", "Europe/Berlin"),("2910140", "Hartha", "", "DE", "276", "", "13", "00", "14522", "51.09863", "12.97391", "Europe/Berlin"),("2910167", "Hartenstein", "", "DE", "276", "", "13", "00", "14524", "50.66236", "12.66966", "Europe/Berlin"),("2910269", "Harsum", "", "DE", "276", "", "06", "00", "03254", "52.21045", "9.96486", "Europe/Berlin"),("2910278", "Harsewinkel", "Харзевинкель", "DE", "276", "", "07", "057", "05754", "51.96224", "8.22766", "Europe/Berlin"),("2910280", "Harsefeld", "", "DE", "276", "", "06", "00", "03359", "53.45399", "9.50297", "Europe/Berlin"),("2910302", "Harrislee", "", "DE", "276", "", "10", "00", "01059", "54.8", "9.38333", "Europe/Berlin"),("2910514", "Haren", "", "DE", "276", "", "06", "00", "03454", "52.79262", "7.24142", "Europe/Berlin"),("2910633", "Hardheim", "", "DE", "276", "", "01", "082", "08225", "49.61194", "9.47194", "Europe/Berlin"),("2910663", "Hardegsen", "", "DE", "276", "", "06", "00", "03155", "51.65227", "9.8305", "Europe/Berlin"),("2910685", "Harburg", "Харбург", "DE", "276", "", "04", "00", "02000", "53.46057", "9.98388", "Europe/Berlin"),("2910686", "Harburg", "", "DE", "276", "", "02", "097", "09779", "48.78674", "10.68927", "Europe/Berlin"),("2910831", "Hannover", "Ганновер", "DE", "276", "", "06", "00", "03241", "52.37052", "9.73322", "Europe/Berlin"),("2910875", "Hänigsen", "", "DE", "276", "", "06", "00", "03241", "52.48425", "10.09129", "Europe/Berlin"),("2910986", "Handewitt", "", "DE", "276", "", "10", "00", "01059", "54.76667", "9.33333", "Europe/Berlin"),("2911007", "Hanau am Main", "", "DE", "276", "", "05", "064", "06435", "50.13423", "8.91418", "Europe/Berlin"),("2911051", "Hamminkeln", "Хамминкельн", "DE", "276", "", "07", "051", "05170", "51.73262", "6.59031", "Europe/Berlin"),("2911214", "Hammelburg", "", "DE", "276", "", "02", "096", "09672", "50.11633", "9.89143", "Europe/Berlin"),("2911240", "Hamm", "Хамм", "DE", "276", "", "07", "059", "05915", "51.68033", "7.82089", "Europe/Berlin"),("2911271", "Hameln", "Хамельн", "DE", "276", "", "06", "00", "03252", "52.10397", "9.35623", "Europe/Berlin"),("2911285", "Wandsbek", "", "DE", "276", "", "04", "00", "02000", "53.56667", "10.1", "Europe/Berlin"),("2911287", "Marienthal", "", "DE", "276", "", "04", "00", "02000", "53.56667", "10.08333", "Europe/Berlin"),("2911288", "Hamburg-Mitte", "", "DE", "276", "", "04", "00", "02000", "53.55", "10.01667", "Europe/Berlin"),("2911293", "Eimsbüttel", "Аймсбюттель", "DE", "276", "", "04", "00", "02000", "53.56667", "9.98333", "Europe/Berlin"),("2911296", "Altona", "Альтона", "DE", "276", "", "04", "00", "02000", "53.55", "9.93333", "Europe/Berlin"),("2911298", "Hamburg", "Гамбург", "DE", "276", "", "04", "00", "02000", "53.57532", "10.01534", "Europe/Berlin"),("2911300", "Hambühren", "", "DE", "276", "", "06", "00", "03351", "52.63333", "9.98333", "Europe/Berlin"),("2911308", "Hambrücken", "", "DE", "276", "", "01", "082", "08215", "49.19", "8.54056", "Europe/Berlin"),("2911322", "Hambergen", "", "DE", "276", "", "06", "00", "03356", "53.30826", "8.8252", "Europe/Berlin"),("2911384", "Halver", "Хальфер", "DE", "276", "", "07", "059", "05962", "51.18612", "7.49817", "Europe/Berlin"),("2911395", "Haltern", "Хальтерне", "DE", "276", "", "07", "055", "05562", "51.74297", "7.18163", "Europe/Berlin"),("2911408", "Halstenbek", "", "DE", "276", "", "10", "00", "01056", "53.63333", "9.85", "Europe/Berlin"),("2911463", "Hallstadt", "", "DE", "276", "", "02", "094", "09471", "49.92901", "10.87539", "Europe/Berlin"),("2911520", "Halle", "Галле", "DE", "276", "", "07", "057", "05754", "52.06007", "8.36083", "Europe/Berlin"),("2911522", "Halle (Saale)", "Галле", "DE", "276", "DE", "14", "00", "15002", "51.5", "12", "Europe/Berlin"),("2911530", "Hallbergmoos", "", "DE", "276", "", "02", "091", "09178", "48.32747", "11.75142", "Europe/Berlin"),("2911559", "Halensee", "", "DE", "276", "", "16", "00", "11000", "52.49005", "13.29602", "Europe/Berlin"),("2911584", "Haldensleben I", "Хальденслебен", "DE", "276", "", "14", "00", "15083", "52.28906", "11.40982", "Europe/Berlin"),("2911665", "Halberstadt", "Хальберштадт", "DE", "276", "", "14", "00", "15085", "51.89562", "11.05622", "Europe/Berlin"),("2911710", "Hakenfelde", "", "DE", "276", "", "16", "00", "11000", "52.55877", "13.20831", "Europe/Berlin"),("2911739", "Haiterbach", "", "DE", "276", "", "01", "082", "08235", "48.52066", "8.64435", "Europe/Berlin"),("2911795", "Hainichen", "", "DE", "276", "", "13", "00", "14522", "50.97044", "13.12287", "Europe/Berlin"),("2911825", "Hain-Gründau", "", "DE", "276", "", "05", "064", "06435", "50.24284", "9.14287", "Europe/Berlin"),("2911960", "Haigerloch", "", "DE", "276", "", "01", "084", "08417", "48.36614", "8.80357", "Europe/Berlin"),("2911964", "Haiger", "Хайгер", "DE", "276", "", "05", "065", "06532", "50.74162", "8.20778", "Europe/Berlin"),("2912159", "Haibach", "", "DE", "276", "", "02", "096", "09671", "49.96444", "9.20722", "Europe/Berlin"),("2912351", "Hahnbach", "", "DE", "276", "", "02", "093", "09371", "49.53389", "11.80302", "Europe/Berlin"),("2912481", "Hagenow", "", "DE", "276", "", "12", "00", "13076", "53.43134", "11.19159", "Europe/Berlin"),("2912577", "Hagenbach", "", "DE", "276", "", "08", "00", "07334", "49.02611", "8.2375", "Europe/Berlin"),("2912618", "Hagen", "", "DE", "276", "", "06", "00", "03459", "52.19629", "7.98041", "Europe/Berlin"),("2912621", "Hagen", "Хаген", "DE", "276", "", "07", "059", "05914", "51.36081", "7.47168", "Europe/Berlin"),("2912681", "Hage", "", "DE", "276", "", "06", "00", "03452", "53.60274", "7.28527", "Europe/Berlin"),("2912829", "Hadamar", "", "DE", "276", "", "05", "065", "06533", "50.44593", "8.04253", "Europe/Berlin"),("2912921", "Hachenburg", "", "DE", "276", "", "08", "00", "07143", "50.65998", "7.82276", "Europe/Berlin"),("2913192", "Haar", "Хар", "DE", "276", "", "02", "091", "09184", "48.10881", "11.72653", "Europe/Berlin"),("2913195", "Haan", "Хаан", "DE", "276", "", "07", "051", "05158", "51.19382", "7.0133", "Europe/Berlin"),("2913210", "Haag in Oberbayern", "", "DE", "276", "", "02", "091", "09183", "48.16196", "12.17942", "Europe/Berlin"),("2913286", "Guxhagen", "", "DE", "276", "", "05", "066", "06634", "51.2", "9.48333", "Europe/Berlin"),("2913366", "Gütersloh", "Гютерсло", "DE", "276", "", "07", "057", "05754", "51.90693", "8.37853", "Europe/Berlin"),("2913433", "Güstrow", "Гюстров", "DE", "276", "", "12", "00", "13072", "53.7972", "12.17337", "Europe/Berlin"),("2913537", "Gunzenhausen", "Гунценхаузен", "DE", "276", "", "02", "095", "09577", "49.11663", "10.75971", "Europe/Berlin"),("2913555", "Günzburg", "Гюнцбург", "DE", "276", "", "02", "097", "09774", "48.45599", "10.27695", "Europe/Berlin"),("2913693", "Gundelsheim", "", "DE", "276", "", "01", "081", "08125", "49.2833", "9.16037", "Europe/Berlin"),("2913711", "Gundelfingen", "", "DE", "276", "", "02", "097", "09773", "48.55347", "10.37223", "Europe/Berlin"),("2913713", "Gundelfingen", "", "DE", "276", "", "01", "083", "08315", "48.04246", "7.8657", "Europe/Berlin"),("2913761", "Gummersbach", "Гуммерсбах", "DE", "276", "", "07", "053", "05374", "51.02608", "7.56473", "Europe/Berlin"),("2913838", "Güglingen", "", "DE", "276", "", "01", "081", "08125", "49.06642", "9.00175", "Europe/Berlin"),("2913890", "Gudensberg", "", "DE", "276", "", "05", "066", "06634", "51.17706", "9.36748", "Europe/Berlin"),("2913922", "Guben", "Губен", "DE", "276", "", "11", "00", "12071", "51.94987", "14.71447", "Europe/Berlin"),("2913972", "Gschwend", "", "DE", "276", "", "01", "081", "08136", "48.93333", "9.74436", "Europe/Berlin"),("2914064", "Grünwald", "", "DE", "276", "", "02", "091", "09184", "48.03947", "11.5232", "Europe/Berlin"),("2914101", "Grünstadt", "", "DE", "276", "", "08", "00", "07332", "49.56302", "8.16279", "Europe/Berlin"),("2914177", "Grünheide", "", "DE", "276", "", "11", "00", "12067", "52.42343", "13.81324", "Europe/Berlin"),("2914210", "Grunewald", "", "DE", "276", "", "16", "00", "11000", "52.48338", "13.26586", "Europe/Berlin"),("2914432", "Grünberg", "", "DE", "276", "", "05", "065", "06531", "50.59403", "8.95866", "Europe/Berlin"),("2914477", "Grünau", "", "DE", "276", "DE", "16", "00", "11000", "52.41642", "13.58039", "Europe/Berlin"),("2914801", "Groß-Zimmern", "", "DE", "276", "", "05", "064", "06432", "49.87583", "8.83444", "Europe/Berlin"),("2914929", "Groß-Umstadt", "Грос-Умштадт", "DE", "276", "", "05", "064", "06432", "49.86899", "8.9321", "Europe/Berlin"),("2915067", "Großschönau", "", "DE", "276", "", "13", "00", "14626", "50.9", "14.68333", "Europe/Berlin"),("2915076", "Großschirma", "", "DE", "276", "", "13", "00", "14522", "50.96602", "13.2859", "Europe/Berlin"),("2915116", "Großrosseln", "", "DE", "276", "", "09", "00", "10041", "49.20296", "6.84148", "Europe/Berlin"),("2915124", "Großröhrsdorf", "", "DE", "276", "", "13", "00", "14625", "51.14528", "14.01917", "Europe/Berlin"),("2915157", "Großräschen", "", "DE", "276", "", "11", "00", "12066", "51.5876", "14.01093", "Europe/Berlin"),("2915173", "Großpösna", "", "DE", "276", "", "13", "00", "14729", "51.26667", "12.5", "Europe/Berlin"),("2915196", "Großostheim", "", "DE", "276", "", "02", "096", "09671", "49.91985", "9.07596", "Europe/Berlin"),("2915372", "Großkrotzenburg", "", "DE", "276", "", "05", "064", "06435", "50.08333", "8.98333", "Europe/Berlin"),("2915375", "Groß Kreutz", "", "DE", "276", "", "11", "00", "12069", "52.40281", "12.7794", "Europe/Berlin"),("2915438", "Großkarolinenfeld", "", "DE", "276", "", "02", "091", "09187", "47.89102", "12.08101", "Europe/Berlin"),("2915511", "Großheubach", "", "DE", "276", "", "02", "096", "09676", "49.72834", "9.2228", "Europe/Berlin"),("2915556", "Großhansdorf", "", "DE", "276", "", "10", "00", "01062", "53.66667", "10.28333", "Europe/Berlin"),("2915613", "Groß-Gerau", "Грос-Герау", "DE", "276", "", "05", "064", "06433", "49.92139", "8.48255", "Europe/Berlin"),("2916606", "Großenlüder", "", "DE", "276", "", "05", "066", "06631", "50.5925", "9.54231", "Europe/Berlin"),("2916611", "Großenkneten", "", "DE", "276", "", "06", "00", "03458", "52.95", "8.26667", "Europe/Berlin"),("2916630", "Großenhain", "Гросенхайн", "DE", "276", "", "13", "00", "14627", "51.28951", "13.5335", "Europe/Berlin"),("2916936", "Großbottwar", "", "DE", "276", "", "01", "081", "08118", "49.00147", "9.29348", "Europe/Berlin"),("2916996", "Großbeeren", "", "DE", "276", "", "11", "00", "12072", "52.35862", "13.30994", "Europe/Berlin"),("2917053", "Großalmerode", "", "DE", "276", "", "05", "066", "06636", "51.25858", "9.7845", "Europe/Berlin"),("2917138", "Gronau", "Гронау", "DE", "276", "", "07", "055", "05554", "52.21099", "7.02238", "Europe/Berlin"),("2917139", "Gronau", "", "DE", "276", "", "06", "00", "03254", "52.0846", "9.77678", "Europe/Berlin"),("2917150", "Grömitz", "", "DE", "276", "", "10", "00", "01055", "54.15", "10.96667", "Europe/Berlin"),("2917170", "Groitzsch", "", "DE", "276", "", "13", "00", "14729", "51.15536", "12.28279", "Europe/Berlin"),("2917221", "Gröbenzell", "", "DE", "276", "", "02", "091", "09179", "48.2", "11.36667", "Europe/Berlin"),("2917309", "Grimmen", "", "DE", "276", "", "12", "00", "13073", "54.11215", "13.04051", "Europe/Berlin"),("2917325", "Grimma", "Гримма", "DE", "276", "", "13", "00", "14729", "51.23367", "12.71959", "Europe/Berlin"),("2917412", "Griesheim", "", "DE", "276", "", "05", "064", "06432", "49.86085", "8.5725", "Europe/Berlin"),("2917461", "Bad Griesbach", "", "DE", "276", "DE", "02", "092", "09275", "48.45181", "13.19329", "Europe/Berlin"),("2917520", "Grevesmühlen", "", "DE", "276", "", "12", "00", "13074", "53.86337", "11.1916", "Europe/Berlin"),("2917540", "Grevenbroich", "Гревенброх", "DE", "276", "", "07", "051", "05162", "51.09102", "6.5827", "Europe/Berlin"),("2917544", "Greven", "Гревен", "DE", "276", "", "07", "055", "05566", "52.09364", "7.59396", "Europe/Berlin"),("2917698", "Grenzach-Wyhlen", "", "DE", "276", "", "01", "083", "08336", "47.55", "7.68333", "Europe/Berlin"),("2917737", "Greiz", "Грайц", "DE", "276", "", "15", "00", "16076", "50.65778", "12.19918", "Europe/Berlin"),("2917788", "Greifswald", "Грайфсвальд", "DE", "276", "", "12", "00", "13075", "54.09311", "13.38786", "Europe/Berlin"),("2917793", "Greifenstein", "", "DE", "276", "", "05", "065", "06532", "50.61667", "8.3", "Europe/Berlin"),("2917816", "Grefrath", "Грефрат", "DE", "276", "", "07", "051", "05166", "51.3363", "6.34072", "Europe/Berlin"),("2917833", "Greding", "", "DE", "276", "", "02", "095", "09576", "49.04699", "11.35703", "Europe/Berlin"),("2917848", "Grebenstein", "", "DE", "276", "", "05", "066", "06633", "51.44648", "9.4125", "Europe/Berlin"),("2917850", "Grebenhain", "", "DE", "276", "", "05", "065", "06535", "50.48924", "9.33855", "Europe/Berlin"),("2917868", "Grävenwiesbach", "", "DE", "276", "", "05", "064", "06434", "50.39024", "8.4569", "Europe/Berlin"),("2917978", "Grassau", "", "DE", "276", "", "02", "091", "09189", "47.78099", "12.45359", "Europe/Berlin"),("2918037", "Grasbrunn", "", "DE", "276", "", "02", "091", "09184", "48.07905", "11.74361", "Europe/Berlin"),("2918041", "Grasberg", "", "DE", "276", "", "06", "00", "03356", "53.18333", "8.98333", "Europe/Berlin"),("2918088", "Gransee", "", "DE", "276", "", "11", "00", "12065", "53.00704", "13.1575", "Europe/Berlin"),("2918241", "Grafing bei München", "", "DE", "276", "", "02", "091", "09175", "48.04596", "11.96797", "Europe/Berlin"),("2918258", "Grafenwöhr", "", "DE", "276", "", "02", "093", "09374", "49.71728", "11.90645", "Europe/Berlin"),("2918321", "Gräfenhainichen", "", "DE", "276", "", "14", "00", "15091", "51.72892", "12.45651", "Europe/Berlin"),("2918365", "Grafenau", "", "DE", "276", "", "02", "092", "09272", "48.85768", "13.3974", "Europe/Berlin"),("2918368", "Gräfelfing", "", "DE", "276", "", "02", "091", "09184", "48.11878", "11.42939", "Europe/Berlin"),("2918405", "Grabow", "", "DE", "276", "", "12", "00", "13076", "53.27966", "11.56502", "Europe/Berlin"),("2918612", "Gottmadingen", "", "DE", "276", "", "01", "083", "08335", "47.73511", "8.77687", "Europe/Berlin"),("2918632", "Göttingen", "Гёттинген", "DE", "276", "", "06", "00", "03152", "51.53443", "9.93228", "Europe/Berlin"),("2918752", "Gotha", "Гота", "DE", "276", "", "15", "00", "16067", "50.94823", "10.70193", "Europe/Berlin"),("2918840", "Goslar", "Гослар", "DE", "276", "", "06", "00", "03153", "51.90425", "10.42766", "Europe/Berlin"),("2918987", "Görlitz", "Гёрлиц", "DE", "276", "", "13", "00", "14626", "51.15518", "14.98853", "Europe/Berlin"),("2919054", "Göppingen", "Гёппинген", "DE", "276", "", "01", "081", "08117", "48.70354", "9.65209", "Europe/Berlin"),("2919138", "Gommern", "", "DE", "276", "", "14", "00", "15086", "52.07391", "11.82297", "Europe/Berlin"),("2919146", "Gomaringen", "", "DE", "276", "", "01", "084", "08416", "48.45349", "9.09582", "Europe/Berlin"),("2919310", "Goldenstedt", "", "DE", "276", "", "06", "00", "03460", "52.78833", "8.43201", "Europe/Berlin"),("2919438", "Goldbach", "", "DE", "276", "", "02", "096", "09671", "49.99951", "9.1844", "Europe/Berlin"),("2919620", "Gochsheim", "", "DE", "276", "", "02", "096", "09678", "50.01667", "10.28333", "Europe/Berlin"),("2919625", "Goch", "Гох", "DE", "276", "", "07", "051", "05154", "51.67873", "6.15895", "Europe/Berlin"),("2919692", "Gnarrenburg", "", "DE", "276", "", "06", "00", "03357", "53.38333", "9", "Europe/Berlin"),("2919717", "Gmund am Tegernsee", "", "DE", "276", "", "02", "091", "09182", "47.75119", "11.7381", "Europe/Berlin"),("2919763", "Glückstadt", "", "DE", "276", "", "10", "00", "01061", "53.78893", "9.42576", "Europe/Berlin"),("2919765", "Glücksburg", "", "DE", "276", "", "10", "00", "01059", "54.83522", "9.54853", "Europe/Berlin"),("2919880", "Glinde", "", "DE", "276", "", "10", "00", "01062", "53.5441", "10.20048", "Europe/Berlin"),("2919908", "Glienicke", "", "DE", "276", "", "11", "00", "12065", "52.63353", "13.32564", "Europe/Berlin"),("2920020", "Glauchau", "Глаухау", "DE", "276", "", "13", "00", "14524", "50.81987", "12.54493", "Europe/Berlin"),("2920085", "Glashütten", "", "DE", "276", "", "05", "064", "06434", "50.21667", "8.4", "Europe/Berlin"),("2920205", "Glandorf", "", "DE", "276", "", "06", "00", "03459", "52.08333", "8.01667", "Europe/Berlin"),("2920229", "Gladenbach", "", "DE", "276", "", "05", "065", "06534", "50.76847", "8.58085", "Europe/Berlin"),("2920236", "Gladbeck", "Гладбек", "DE", "276", "", "07", "055", "05562", "51.57077", "6.98593", "Europe/Berlin"),("2920329", "Ginsheim-Gustavsburg", "Гинсхайм-Густавсбург", "DE", "276", "", "05", "064", "06433", "49.9711", "8.34532", "Europe/Berlin"),("2920433", "Gilching", "", "DE", "276", "", "02", "091", "09188", "48.10755", "11.2936", "Europe/Berlin"),("2920478", "Gifhorn", "Гифхорн", "DE", "276", "", "06", "00", "03151", "52.47774", "10.5511", "Europe/Berlin"),("2920512", "Gießen", "Гиссен", "DE", "276", "", "05", "065", "06531", "50.58727", "8.67554", "Europe/Berlin"),("2920620", "Giengen an der Brenz", "Гинген-на-Бренце", "DE", "276", "", "01", "081", "08135", "48.62219", "10.24312", "Europe/Berlin"),("2920757", "Gevelsberg", "Гефельсберг", "DE", "276", "", "07", "059", "05954", "51.31971", "7.3392", "Europe/Berlin"),("2920776", "Gettorf", "", "DE", "276", "", "10", "00", "01058", "54.4", "9.98333", "Europe/Berlin"),("2920789", "Gesundbrunnen", "", "DE", "276", "", "16", "00", "11000", "52.55035", "13.39139", "Europe/Berlin"),("2920834", "Geseke", "Гезеке", "DE", "276", "", "07", "059", "05974", "51.64091", "8.5109", "Europe/Berlin"),("2920842", "Gescher", "Гешер", "DE", "276", "", "07", "055", "05554", "51.954", "7.00481", "Europe/Berlin"),("2920891", "Gersthofen", "Герстхофен", "DE", "276", "", "02", "097", "09772", "48.42432", "10.87273", "Europe/Berlin"),("2920896", "Gerstetten", "", "DE", "276", "", "01", "081", "08135", "48.63333", "10.03333", "Europe/Berlin"),("2920921", "Gersheim", "", "DE", "276", "", "09", "00", "10045", "49.15", "7.2", "Europe/Berlin");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("2920926", "Gersfeld", "", "DE", "276", "", "05", "066", "06631", "50.45138", "9.91422", "Europe/Berlin"),("2920959", "Gerolzhofen", "", "DE", "276", "", "02", "096", "09678", "49.90025", "10.34832", "Europe/Berlin"),("2920963", "Gerolstein", "", "DE", "276", "", "08", "00", "07233", "50.22224", "6.65984", "Europe/Berlin"),("2920994", "Gernsheim", "", "DE", "276", "", "05", "064", "06433", "49.75305", "8.48859", "Europe/Berlin"),("2920997", "Gernsbach", "", "DE", "276", "", "01", "082", "08216", "48.77034", "8.34306", "Europe/Berlin"),("2921034", "Germersheim", "Гермерсхайм", "DE", "276", "", "08", "00", "07334", "49.22306", "8.36389", "Europe/Berlin"),("2921039", "Germering", "Гермеринг", "DE", "276", "", "02", "091", "09179", "48.13392", "11.3765", "Europe/Berlin"),("2921061", "Gerlingen", "Герлинген", "DE", "276", "", "01", "081", "08118", "48.79954", "9.06316", "Europe/Berlin"),("2921089", "Geringswalde", "", "DE", "276", "", "13", "00", "14522", "51.07677", "12.90725", "Europe/Berlin"),("2921139", "Geretsried", "", "DE", "276", "", "02", "091", "09173", "47.85775", "11.48054", "Europe/Berlin"),("2921165", "Gerbrunn", "", "DE", "276", "", "02", "096", "09679", "49.77528", "9.99361", "Europe/Berlin"),("2921232", "Gera", "Гера", "DE", "276", "", "15", "00", "16052", "50.88029", "12.08187", "Europe/Berlin"),("2921242", "Georgsmarienhütte", "Георгсмариенхютте", "DE", "276", "", "06", "00", "03459", "52.20296", "8.0448", "Europe/Berlin"),("2921267", "Georgensgmünd", "", "DE", "276", "", "02", "095", "09576", "49.18972", "11.01667", "Europe/Berlin"),("2921309", "Genthin", "", "DE", "276", "", "14", "00", "15086", "52.40668", "12.1592", "Europe/Berlin"),("2921355", "Gengenbach", "", "DE", "276", "", "01", "083", "08317", "48.40476", "8.01433", "Europe/Berlin"),("2921379", "Gemünden am Main", "", "DE", "276", "", "02", "096", "09677", "50.04946", "9.70593", "Europe/Berlin"),("2921449", "Geltendorf", "", "DE", "276", "", "02", "091", "09181", "48.13333", "11.03333", "Europe/Berlin"),("2921466", "Gelsenkirchen", "Гельзенкирхен", "DE", "276", "", "07", "055", "05513", "51.5075", "7.12283", "Europe/Berlin"),("2921473", "Gelnhausen", "Гельнхаузен", "DE", "276", "", "05", "064", "06435", "50.20164", "9.18742", "Europe/Berlin"),("2921528", "Geldern", "Гельдерн", "DE", "276", "", "07", "051", "05154", "51.51908", "6.32363", "Europe/Berlin"),("2921566", "Geithain", "", "DE", "276", "", "13", "00", "14729", "51.05528", "12.69674", "Europe/Berlin"),("2921653", "Geislingen an der Steige", "Гайслинген-ан-дер-Штайге", "DE", "276", "", "01", "081", "08117", "48.62423", "9.82736", "Europe/Berlin"),("2921656", "Geislingen", "", "DE", "276", "", "01", "084", "08417", "48.28768", "8.81241", "Europe/Berlin"),("2921682", "Geisingen", "", "DE", "276", "", "01", "083", "08327", "47.92504", "8.65002", "Europe/Berlin"),("2921707", "Geisenheim", "", "DE", "276", "", "05", "064", "06439", "49.9847", "7.96835", "Europe/Berlin"),("2921709", "Geisenhausen", "", "DE", "276", "", "02", "092", "09274", "48.47609", "12.25817", "Europe/Berlin"),("2921713", "Geisenfeld", "", "DE", "276", "", "02", "091", "09186", "48.68426", "11.61233", "Europe/Berlin"),("2921736", "Geiselhöring", "", "DE", "276", "", "02", "092", "09278", "48.82505", "12.39649", "Europe/Berlin"),("2921837", "Geilenkirchen", "Гейленкирхен", "DE", "276", "", "07", "053", "05370", "50.96745", "6.11763", "Europe/Berlin"),("2922008", "Gehrden", "", "DE", "276", "", "06", "00", "03241", "52.31362", "9.60033", "Europe/Berlin"),("2922102", "Geesthacht", "Гестахт", "DE", "276", "", "10", "00", "01053", "53.43575", "10.3779", "Europe/Berlin"),("2922112", "Geeste", "", "DE", "276", "", "06", "00", "03454", "52.6", "7.26667", "Europe/Berlin"),("2922124", "Gedern", "", "DE", "276", "", "05", "064", "06440", "50.42482", "9.1984", "Europe/Berlin"),("2922230", "Gauting", "", "DE", "276", "", "02", "091", "09188", "48.06919", "11.37703", "Europe/Berlin"),("2922309", "Gau-Algesheim", "", "DE", "276", "", "08", "00", "07339", "49.95669", "8.01569", "Europe/Berlin"),("2922436", "Gärtringen", "", "DE", "276", "", "01", "081", "08115", "48.64176", "8.90073", "Europe/Berlin"),("2922511", "Garrel", "", "DE", "276", "", "06", "00", "03453", "52.95", "8.01667", "Europe/Berlin"),("2922530", "Garmisch-Partenkirchen", "Гармиш-Партенкирхен", "DE", "276", "", "02", "091", "09180", "47.49209", "11.09576", "Europe/Berlin"),("2922580", "Gardelegen", "", "DE", "276", "", "14", "00", "15081", "52.5252", "11.39523", "Europe/Berlin"),("2922582", "Garching bei München", "Гархинг", "DE", "276", "", "02", "091", "09184", "48.24896", "11.65101", "Europe/Berlin"),("2922583", "Garching an der Alz", "", "DE", "276", "", "02", "091", "09171", "48.13451", "12.58152", "Europe/Berlin"),("2922586", "Garbsen", "Гарбсен", "DE", "276", "", "06", "00", "03241", "52.41371", "9.5899", "Europe/Berlin"),("2922716", "Gangkofen", "", "DE", "276", "", "02", "092", "09277", "48.43701", "12.56419", "Europe/Berlin"),("2922722", "Gangelt", "", "DE", "276", "", "07", "053", "05370", "50.99247", "5.99802", "Europe/Berlin"),("2922731", "Ganderkesee", "Гандеркезе", "DE", "276", "", "06", "00", "03458", "53.03333", "8.53333", "Europe/Berlin"),("2922747", "Gammertingen", "", "DE", "276", "", "01", "084", "08437", "48.2524", "9.22349", "Europe/Berlin"),("2923305", "Gaimersheim", "", "DE", "276", "", "02", "091", "09176", "48.80705", "11.36801", "Europe/Berlin"),("2923325", "Gaildorf", "", "DE", "276", "", "01", "081", "08127", "49.00027", "9.76953", "Europe/Berlin"),("2923362", "Gaggenau", "Гаггенау", "DE", "276", "", "01", "082", "08216", "48.8", "8.33333", "Europe/Berlin"),("2923410", "Gadebusch", "", "DE", "276", "", "12", "00", "13074", "53.70137", "11.11676", "Europe/Berlin"),("2923500", "Bad Füssing", "", "DE", "276", "", "02", "092", "09275", "48.351", "13.312", "Europe/Berlin"),("2923507", "Füssen", "", "DE", "276", "", "02", "097", "09777", "47.57143", "10.70171", "Europe/Berlin"),("2923521", "Furtwangen im Schwarzwald", "", "DE", "276", "", "01", "083", "08326", "48.05156", "8.20715", "Europe/Berlin"),("2923529", "Furth im Wald", "", "DE", "276", "", "02", "093", "09372", "49.30955", "12.84156", "Europe/Berlin"),("2923543", "Fürth", "", "DE", "276", "", "05", "064", "06431", "49.65083", "8.78472", "Europe/Berlin"),("2923544", "Fürth", "Фюрт", "DE", "276", "", "02", "095", "09563", "49.47593", "10.98856", "Europe/Berlin"),("2923584", "Fürstenzell", "", "DE", "276", "", "02", "092", "09275", "48.52163", "13.31749", "Europe/Berlin"),("2923588", "Fürstenwalde", "Фюрстенвальде", "DE", "276", "", "11", "00", "12067", "52.36067", "14.06185", "Europe/Berlin"),("2923625", "Fürstenfeldbruck", "Фюрстенфельдбрук", "DE", "276", "", "02", "091", "09179", "48.17904", "11.2547", "Europe/Berlin"),("2923637", "Fürstenberg", "", "DE", "276", "", "11", "00", "12065", "53.18427", "13.14442", "Europe/Berlin"),("2923658", "Fürstenau", "", "DE", "276", "", "06", "00", "03459", "52.51667", "7.6767", "Europe/Berlin"),("2923815", "Fuldatal", "", "DE", "276", "", "05", "066", "06633", "51.38333", "9.56667", "Europe/Berlin"),("2923822", "Fulda", "Фульда", "DE", "276", "", "05", "066", "06631", "50.55162", "9.67518", "Europe/Berlin"),("2923850", "Fuhlsbüttel", "", "DE", "276", "", "04", "00", "02000", "53.63459", "10.01608", "Europe/Berlin"),("2924206", "Fröndenberg", "Фрёнденберг-на-Руре", "DE", "276", "", "07", "059", "05978", "51.47563", "7.76946", "Europe/Berlin"),("2924302", "Frohnau", "", "DE", "276", "", "16", "00", "11000", "52.63336", "13.29024", "Europe/Berlin"),("2924313", "Frohburg", "", "DE", "276", "", "13", "00", "14729", "51.05719", "12.55746", "Europe/Berlin"),("2924326", "Fritzlar", "", "DE", "276", "", "05", "066", "06634", "51.13181", "9.27557", "Europe/Berlin"),("2924360", "Friesoythe", "Фризойте", "DE", "276", "", "06", "00", "03453", "53.0226", "7.85764", "Europe/Berlin"),("2924428", "Frielendorf", "", "DE", "276", "", "05", "066", "06634", "50.98333", "9.33333", "Europe/Berlin"),("2924461", "Friedrichsthal", "", "DE", "276", "", "09", "00", "10041", "49.32786", "7.09622", "Europe/Berlin"),("2924573", "Friedrichshain", "", "DE", "276", "DE", "16", "00", "11000", "52.51559", "13.45482", "Europe/Berlin"),("2924577", "Friedrichshagen", "", "DE", "276", "DE", "16", "00", "11000", "52.45052", "13.62463", "Europe/Berlin"),("2924585", "Friedrichshafen", "Фридрихсхафен", "DE", "276", "", "01", "084", "08435", "47.65689", "9.47554", "Europe/Berlin"),("2924599", "Friedrichsfelde", "", "DE", "276", "DE", "16", "00", "11000", "52.50575", "13.50812", "Europe/Berlin"),("2924625", "Friedrichsdorf", "Фридрихсдорф", "DE", "276", "", "05", "064", "06434", "50.24962", "8.64281", "Europe/Berlin"),("2924656", "Friedrichroda", "", "DE", "276", "", "15", "00", "16067", "50.85754", "10.56507", "Europe/Berlin"),("2924679", "Friedland", "", "DE", "276", "", "12", "00", "13071", "53.67028", "13.554", "Europe/Berlin"),("2924681", "Gemeinde Friedland", "", "DE", "276", "", "06", "00", "03152", "51.41667", "9.93333", "Europe/Berlin"),("2924770", "Friedenau", "Фриденау", "DE", "276", "", "16", "00", "11000", "52.47133", "13.32813", "Europe/Berlin"),("2924788", "Friedeburg", "", "DE", "276", "", "06", "00", "03462", "53.45", "7.83333", "Europe/Berlin"),("2924802", "Friedberg", "Фридберг", "DE", "276", "", "05", "064", "06440", "50.33739", "8.75591", "Europe/Berlin"),("2924803", "Friedberg", "Фридберг", "DE", "276", "", "02", "097", "09771", "48.35693", "10.98461", "Europe/Berlin"),("2924837", "Frickenhausen", "", "DE", "276", "", "01", "081", "08116", "48.59353", "9.36005", "Europe/Berlin"),("2924850", "Freyung", "", "DE", "276", "", "02", "092", "09272", "48.80952", "13.54768", "Europe/Berlin"),("2924854", "Freystadt", "", "DE", "276", "", "02", "093", "09373", "49.20007", "11.33032", "Europe/Berlin"),("2924894", "Freudenstadt", "Фройденштадт", "DE", "276", "", "01", "082", "08237", "48.46695", "8.41371", "Europe/Berlin"),("2924915", "Freudenberg", "", "DE", "276", "", "07", "059", "05970", "50.89741", "7.87415", "Europe/Berlin"),("2924967", "Freren", "", "DE", "276", "", "06", "00", "03454", "52.487", "7.54313", "Europe/Berlin"),("2925017", "Freital", "Фрайталь", "DE", "276", "", "13", "00", "14628", "51.00166", "13.6488", "Europe/Berlin"),("2925034", "Freising", "Фрайзинг", "DE", "276", "", "02", "091", "09178", "48.40351", "11.74876", "Europe/Berlin"),("2925038", "Freisen", "", "DE", "276", "", "09", "00", "10046", "49.55", "7.25", "Europe/Berlin"),("2925080", "Freilassing", "Фрайлассинг", "DE", "276", "", "02", "091", "09172", "47.84085", "12.98114", "Europe/Berlin"),("2925177", "Freiburg", "Фрайбург", "DE", "276", "", "01", "083", "08311", "47.9959", "7.85222", "Europe/Berlin"),("2925189", "Freiberg am Neckar", "Фрайберг-на-Неккаре", "DE", "276", "", "01", "081", "08118", "48.93196", "9.2024", "Europe/Berlin"),("2925192", "Freiberg", "Фрайберг", "DE", "276", "", "13", "00", "14522", "50.91089", "13.33881", "Europe/Berlin"),("2925259", "Frechen", "Фрехен", "DE", "276", "", "07", "053", "05362", "50.91485", "6.8118", "Europe/Berlin"),("2925267", "Fraureuth", "", "DE", "276", "", "13", "00", "14524", "50.7", "12.35", "Europe/Berlin"),("2925533", "Frankfurt am Main", "Франкфурт-на-Майне", "DE", "276", "", "05", "064", "06412", "50.11552", "8.68417", "Europe/Berlin"),("2925535", "Frankfurt (Oder)", "Франкфурт-на-Одере", "DE", "276", "", "11", "00", "12053", "52.34714", "14.55062", "Europe/Berlin"),("2925550", "Frankenthal", "Франкенталь", "DE", "276", "", "08", "00", "07311", "49.53414", "8.35357", "Europe/Berlin"),("2925629", "Frankenberg", "Франкенберг", "DE", "276", "", "05", "066", "06635", "51.0589", "8.80077", "Europe/Berlin"),("2925630", "Frankenberg", "Франкенберг", "DE", "276", "", "13", "00", "14522", "50.91297", "13.04011", "Europe/Berlin"),("2925832", "Forst", "Форст", "DE", "276", "", "11", "00", "12071", "51.73544", "14.63971", "Europe/Berlin"),("2925848", "Forst", "", "DE", "276", "", "01", "082", "08215", "49.15861", "8.58083", "Europe/Berlin"),("2925905", "Forchtenberg", "", "DE", "276", "", "01", "081", "08126", "49.28867", "9.56026", "Europe/Berlin"),("2925910", "Forchheim", "Форххайм", "DE", "276", "", "02", "094", "09474", "49.71754", "11.05877", "Europe/Berlin"),("2925924", "Forbach", "", "DE", "276", "", "01", "082", "08216", "48.68333", "8.35", "Europe/Berlin"),("2926017", "Fockbek", "", "DE", "276", "", "10", "00", "01058", "54.3", "9.6", "Europe/Berlin"),("2926120", "Flörsheim", "", "DE", "276", "", "05", "064", "06436", "50.01311", "8.42779", "Europe/Berlin"),("2926147", "Flöha", "", "DE", "276", "", "13", "00", "14522", "50.85613", "13.07407", "Europe/Berlin"),("2926178", "Flintbek", "", "DE", "276", "", "10", "00", "01058", "54.25", "10.06667", "Europe/Berlin"),("2926226", "Flieden", "", "DE", "276", "", "05", "066", "06631", "50.42389", "9.5666", "Europe/Berlin"),("2926271", "Flensburg", "Фленсбург", "DE", "276", "", "10", "00", "01001", "54.78431", "9.43961", "Europe/Berlin"),("2926304", "Flein", "", "DE", "276", "", "01", "081", "08125", "49.10306", "9.21083", "Europe/Berlin"),("2926586", "Fischbachau", "", "DE", "276", "", "02", "091", "09182", "47.71952", "11.95081", "Europe/Berlin"),("2926670", "Finsterwalde", "Финстервальде", "DE", "276", "", "11", "00", "12062", "51.63388", "13.70662", "Europe/Berlin"),("2926716", "Finnentrop", "Финнентроп", "DE", "276", "", "07", "059", "05966", "51.168", "7.973", "Europe/Berlin"),("2927043", "Stuttgart Feuerbach", "", "DE", "276", "", "01", "081", "08111", "48.80867", "9.15719", "Europe/Berlin"),("2927048", "Feuchtwangen", "", "DE", "276", "", "02", "095", "09571", "49.16287", "10.3385", "Europe/Berlin"),("2927054", "Feucht", "", "DE", "276", "", "02", "095", "09574", "49.37597", "11.21433", "Europe/Berlin"),("2927226", "Felsberg", "", "DE", "276", "", "05", "066", "06634", "51.13763", "9.42139", "Europe/Berlin"),("2927268", "Fellbach", "Фелльбах", "DE", "276", "", "01", "081", "08119", "48.80912", "9.27697", "Europe/Berlin"),("2927339", "Feldkirchen-Westerham", "", "DE", "276", "", "02", "091", "09187", "47.90748", "11.84266", "Europe/Berlin"),("2927347", "Feldkirchen", "", "DE", "276", "", "02", "091", "09184", "48.14811", "11.731", "Europe/Berlin"),("2927564", "Fehrbellin", "", "DE", "276", "", "11", "00", "12068", "52.8135", "12.7644", "Europe/Berlin"),("2927750", "Faßberg", "", "DE", "276", "", "06", "00", "03351", "52.9", "10.16667", "Europe/Berlin"),("2927871", "Bad Fallingbostel", "", "DE", "276", "", "06", "00", "03358", "52.86641", "9.69558", "Europe/Berlin"),("2927913", "Falkenstein", "", "DE", "276", "", "13", "00", "14523", "50.47788", "12.37129", "Europe/Berlin"),("2927930", "Falkensee", "Фалькензе", "DE", "276", "", "11", "00", "12063", "52.56014", "13.0927", "Europe/Berlin"),("2928011", "Falkenberg", "", "DE", "276", "", "11", "00", "12062", "51.58557", "13.24347", "Europe/Berlin"),("2928320", "Everswinkel", "", "DE", "276", "", "07", "055", "05570", "51.92595", "7.8469", "Europe/Berlin"),("2928379", "Eutingen", "", "DE", "276", "", "01", "082", "08231", "48.91246", "8.74898", "Europe/Berlin"),("2928381", "Eutin", "Ойтин", "DE", "276", "", "10", "00", "01055", "54.14054", "10.60751", "Europe/Berlin"),("2928396", "Euskirchen", "Ойскирхен", "DE", "276", "", "07", "053", "05366", "50.66057", "6.78722", "Europe/Berlin"),("2928615", "Ettlingen", "Эттлинген", "DE", "276", "", "01", "082", "08215", "48.94094", "8.40763", "Europe/Berlin"),("2928659", "Ettenheim", "", "DE", "276", "", "01", "083", "08317", "48.25696", "7.81247", "Europe/Berlin"),("2928717", "Esterwegen", "", "DE", "276", "", "06", "00", "03454", "52.99288", "7.63327", "Europe/Berlin"),("2928751", "Esslingen", "Эсслинген-на-Неккаре", "DE", "276", "", "01", "081", "08116", "48.73961", "9.30473", "Europe/Berlin"),("2928761", "Essingen", "", "DE", "276", "", "01", "081", "08136", "48.80859", "10.02773", "Europe/Berlin"),("2928804", "Essenbach", "", "DE", "276", "", "02", "092", "09274", "48.61332", "12.21833", "Europe/Berlin"),("2928809", "Essen", "", "DE", "276", "", "06", "00", "03453", "52.72258", "7.9371", "Europe/Berlin"),("2928810", "Essen", "Эссен", "DE", "276", "", "07", "051", "05113", "51.45657", "7.01228", "Europe/Berlin"),("2928874", "Espelkamp", "Эспелькамп", "DE", "276", "", "07", "057", "05770", "52.38251", "8.62127", "Europe/Berlin"),("2928890", "Eslohe", "", "DE", "276", "", "07", "059", "05958", "51.25369", "8.16949", "Europe/Berlin"),("2928911", "Esens", "", "DE", "276", "", "06", "00", "03462", "53.64866", "7.61267", "Europe/Berlin"),("2928963", "Eschweiler", "Эшвайлер", "DE", "276", "", "07", "053", "05334", "50.81854", "6.27184", "Europe/Berlin"),("2928967", "Eschwege", "Эшвеге", "DE", "276", "", "05", "066", "06636", "51.18386", "10.05329", "Europe/Berlin"),("2929134", "Eschborn", "Эшборн", "DE", "276", "", "05", "064", "06436", "50.14328", "8.57111", "Europe/Berlin"),("2929224", "Erzhausen", "", "DE", "276", "", "05", "064", "06432", "49.95528", "8.6475", "Europe/Berlin"),("2929247", "Erwitte", "Эрвитте", "DE", "276", "", "07", "059", "05974", "51.6127", "8.3384", "Europe/Berlin"),("2929252", "Ertingen", "", "DE", "276", "", "01", "084", "08426", "48.1", "9.46667", "Europe/Berlin"),("2929370", "Erndtebrück", "", "DE", "276", "", "07", "059", "05970", "50.98333", "8.26667", "Europe/Berlin"),("2929451", "Erlensee", "", "DE", "276", "", "05", "064", "06435", "50.16304", "8.97823", "Europe/Berlin"),("2929484", "Erlenbach am Main", "", "DE", "276", "", "02", "096", "09676", "49.80341", "9.16311", "Europe/Berlin"),("2929567", "Erlangen", "Эрланген", "DE", "276", "", "02", "095", "09562", "49.59099", "11.00783", "Europe/Berlin"),("2929600", "Erkrath", "Эркрат", "DE", "276", "", "07", "051", "05158", "51.22235", "6.90831", "Europe/Berlin"),("2929602", "Erkner", "", "DE", "276", "", "11", "00", "12067", "52.42", "13.75437", "Europe/Berlin"),("2929622", "Erkelenz", "Эркеленц", "DE", "276", "", "07", "053", "05370", "51.07947", "6.31531", "Europe/Berlin"),("2929649", "Ergoldsbach", "", "DE", "276", "", "02", "092", "09274", "48.69263", "12.20442", "Europe/Berlin"),("2929650", "Ergolding", "", "DE", "276", "", "02", "092", "09274", "48.57654", "12.17102", "Europe/Berlin"),("2929670", "Erfurt", "Эрфурт", "DE", "276", "", "15", "00", "16051", "50.9787", "11.03283", "Europe/Berlin"),("2929671", "Erftstadt", "Эрфтштадт", "DE", "276", "", "07", "053", "05362", "50.81481", "6.79387", "Europe/Berlin"),("2929692", "Erdweg", "", "DE", "276", "", "02", "091", "09174", "48.3318", "11.30339", "Europe/Berlin"),("2929715", "Erding", "Эрдинг", "DE", "276", "", "02", "091", "09177", "48.30603", "11.90686", "Europe/Berlin"),("2929783", "Erbendorf", "", "DE", "276", "", "02", "093", "09377", "49.83983", "12.04593", "Europe/Berlin"),("2929802", "Erbach", "", "DE", "276", "", "05", "064", "06437", "49.66148", "8.99402", "Europe/Berlin"),("2929804", "Erbach", "", "DE", "276", "", "01", "084", "08425", "48.32841", "9.88752", "Europe/Berlin"),("2929817", "Eppstein", "", "DE", "276", "", "05", "064", "06436", "50.14277", "8.39231", "Europe/Berlin"),("2929831", "Eppingen", "Эппинген", "DE", "276", "", "01", "081", "08125", "49.13645", "8.91229", "Europe/Berlin"),("2929837", "Eppertshausen", "", "DE", "276", "", "05", "064", "06432", "49.95056", "8.85389", "Europe/Berlin"),("2929863", "Eppelheim", "", "DE", "276", "", "01", "082", "08226", "49.4019", "8.63644", "Europe/Berlin"),("2929865", "Eppelborn", "", "DE", "276", "", "09", "00", "10043", "49.4", "6.96667", "Europe/Berlin"),("2930019", "Ensdorf", "", "DE", "276", "", "09", "00", "10044", "49.3", "6.78333", "Europe/Berlin"),("2930030", "Ennigerloh", "Эннигерло", "DE", "276", "", "07", "055", "05570", "51.83843", "8.03093", "Europe/Berlin"),("2930043", "Ennepetal", "Эннепеталь", "DE", "276", "", "07", "059", "05954", "51.29848", "7.3629", "Europe/Berlin"),("2930071", "Enkenbach-Alsenborn", "", "DE", "276", "", "08", "00", "07335", "49.48333", "7.9", "Europe/Berlin"),("2930080", "Eningen unter Achalm", "", "DE", "276", "", "01", "084", "08415", "48.48686", "9.25946", "Europe/Berlin"),("2930182", "Enger", "Энгер", "DE", "276", "", "07", "057", "05758", "52.14063", "8.55772", "Europe/Berlin"),("2930201", "Engen", "", "DE", "276", "", "01", "083", "08335", "47.85534", "8.77342", "Europe/Berlin"),("2930216", "Engelskirchen", "Энгельскирхен", "DE", "276", "", "07", "053", "05374", "50.98333", "7.4", "Europe/Berlin"),("2930367", "Bad Endorf", "", "DE", "276", "", "02", "091", "09187", "47.90901", "12.29795", "Europe/Berlin"),("2930383", "Endingen", "", "DE", "276", "", "01", "083", "08316", "48.14221", "7.70049", "Europe/Berlin"),("2930408", "Bad Endbach", "", "DE", "276", "", "05", "065", "06534", "50.75", "8.5", "Europe/Berlin"),("2930426", "Emstek", "", "DE", "276", "", "06", "00", "03453", "52.83333", "8.15", "Europe/Berlin"),("2930432", "Emskirchen", "", "DE", "276", "", "02", "095", "09575", "49.55282", "10.71278", "Europe/Berlin"),("2930449", "Emsdetten", "Эмсдеттен", "DE", "276", "", "07", "055", "05566", "52.1734", "7.52781", "Europe/Berlin"),("2930454", "Emsbüren", "", "DE", "276", "", "06", "00", "03454", "52.4", "7.3", "Europe/Berlin"),("2930500", "Emmering", "", "DE", "276", "", "02", "091", "09179", "48.18333", "11.28333", "Europe/Berlin"),("2930509", "Emmerich", "Эммерих", "DE", "276", "", "07", "051", "05154", "51.83933", "6.24792", "Europe/Berlin"),("2930523", "Emmendingen", "", "DE", "276", "", "01", "083", "08316", "48.12096", "7.85359", "Europe/Berlin"),("2930546", "Emlichheim", "", "DE", "276", "", "06", "00", "03456", "52.61667", "6.85", "Europe/Berlin"),("2930596", "Emden", "Эмден", "DE", "276", "", "06", "00", "03402", "53.36745", "7.20778", "Europe/Berlin"),("2930623", "Elze", "", "DE", "276", "", "06", "00", "03254", "52.12263", "9.73595", "Europe/Berlin"),("2930626", "Elzach", "", "DE", "276", "", "01", "083", "08316", "48.17247", "8.06992", "Europe/Berlin"),("2930628", "Elz", "", "DE", "276", "", "05", "065", "06533", "50.41667", "8.03333", "Europe/Berlin"),("2930646", "Eltville", "", "DE", "276", "", "05", "064", "06439", "50.02858", "8.11754", "Europe/Berlin"),("2930650", "Eltmann", "", "DE", "276", "", "02", "096", "09674", "49.97148", "10.66712", "Europe/Berlin"),("2930680", "Elsterwerda", "", "DE", "276", "", "11", "00", "12062", "51.46043", "13.52001", "Europe/Berlin"),("2930687", "Elsterberg", "", "DE", "276", "", "13", "00", "14523", "50.60841", "12.16787", "Europe/Berlin"),("2930726", "Elsfleth", "", "DE", "276", "", "06", "00", "03461", "53.23748", "8.45664", "Europe/Berlin"),("2930747", "Elsenfeld", "", "DE", "276", "", "02", "096", "09676", "49.84289", "9.16355", "Europe/Berlin"),("2930778", "Elsdorf", "", "DE", "276", "", "07", "053", "05362", "50.93739", "6.56828", "Europe/Berlin"),("2930821", "Elmshorn", "Эльмсхорн", "DE", "276", "", "10", "00", "01056", "53.75396", "9.65339", "Europe/Berlin"),("2930889", "Ellwangen", "Эльванген", "DE", "276", "", "01", "081", "08136", "48.96164", "10.13173", "Europe/Berlin"),("2930900", "Ellrich", "", "DE", "276", "", "15", "00", "16062", "51.58656", "10.66326", "Europe/Berlin"),("2931038", "Ellerau", "", "DE", "276", "", "10", "00", "01060", "53.75", "9.91667", "Europe/Berlin"),("2931361", "Eitorf", "Айторф", "DE", "276", "", "07", "053", "05382", "50.76667", "7.45", "Europe/Berlin"),("2931372", "Eiterfeld", "", "DE", "276", "", "05", "066", "06631", "50.76667", "9.8", "Europe/Berlin"),("2931414", "Eislingen", "Айзлинген", "DE", "276", "", "01", "081", "08117", "48.69515", "9.70676", "Europe/Berlin"),("2931433", "Eisfeld", "", "DE", "276", "", "15", "00", "16069", "50.42648", "10.90695", "Europe/Berlin"),("2931481", "Eisenhüttenstadt", "Айзенхюттенштадт", "DE", "276", "", "11", "00", "12067", "52.15", "14.65", "Europe/Berlin"),("2931521", "Eisenberg", "", "DE", "276", "", "15", "00", "16074", "50.9686", "11.90207", "Europe/Berlin"),("2931522", "Eisenberg", "", "DE", "276", "", "08", "00", "07333", "49.55859", "8.07199", "Europe/Berlin"),("2931574", "Eisenach", "Айзенах", "DE", "276", "", "15", "00", "16056", "50.9807", "10.31522", "Europe/Berlin"),("2931753", "Einhausen", "", "DE", "276", "", "05", "064", "06431", "49.67667", "8.54833", "Europe/Berlin"),("2931804", "Einbeck", "Айнбек", "DE", "276", "", "06", "00", "03155", "51.82018", "9.86961", "Europe/Berlin"),("2931871", "Eilenburg", "Айленбург", "DE", "276", "", "13", "00", "14730", "51.45984", "12.63338", "Europe/Berlin"),("2931881", "Eil", "", "DE", "276", "", "07", "053", "05315", "50.89362", "7.07967", "Europe/Berlin"),("2932040", "Eichwalde", "", "DE", "276", "", "11", "00", "12061", "52.36667", "13.61667", "Europe/Berlin"),("2932069", "Eichstätt", "", "DE", "276", "", "02", "091", "09176", "48.88854", "11.19675", "Europe/Berlin"),("2932266", "Eichenzell", "", "DE", "276", "", "05", "066", "06631", "50.49536", "9.69672", "Europe/Berlin"),("2932321", "Eichendorf", "", "DE", "276", "", "02", "092", "09279", "48.63266", "12.85586", "Europe/Berlin"),("2932382", "Eichenau", "", "DE", "276", "", "02", "091", "09179", "48.16667", "11.31667", "Europe/Berlin"),("2932738", "Eibenstock", "", "DE", "276", "", "13", "00", "14521", "50.49431", "12.59978", "Europe/Berlin"),("2932756", "Eibau", "", "DE", "276", "", "13", "00", "14626", "50.98272", "14.66214", "Europe/Berlin"),("2932788", "Ehringshausen", "", "DE", "276", "", "05", "065", "06532", "50.6", "8.38333", "Europe/Berlin"),("2932828", "Ehrenfriedersdorf", "", "DE", "276", "", "13", "00", "14521", "50.64934", "12.97009", "Europe/Berlin"),("2932882", "Ehningen", "", "DE", "276", "", "01", "081", "08115", "48.65882", "8.94124", "Europe/Berlin"),("2932924", "Ehingen", "Эхинген", "DE", "276", "", "01", "084", "08425", "48.28259", "9.72749", "Europe/Berlin"),("2932992", "Egling", "", "DE", "276", "", "02", "091", "09173", "47.92316", "11.50517", "Europe/Berlin"),("2933019", "Eggolsheim", "", "DE", "276", "", "02", "094", "09474", "49.76961", "11.05701", "Europe/Berlin"),("2933042", "Eggesin", "", "DE", "276", "", "12", "00", "13075", "53.67973", "14.07992", "Europe/Berlin"),("2933101", "Eggenstein-Leopoldshafen", "", "DE", "276", "", "01", "082", "08215", "49.09006", "8.39879", "Europe/Berlin"),("2933115", "Eggenfelden", "", "DE", "276", "", "02", "092", "09277", "48.40509", "12.75752", "Europe/Berlin"),("2933188", "Egestorf", "", "DE", "276", "", "06", "00", "03241", "52.28568", "9.51676", "Europe/Berlin"),("2933246", "Egelsbach", "", "DE", "276", "", "05", "064", "06438", "49.96792", "8.66341", "Europe/Berlin"),("2933274", "Efringen-Kirchen", "", "DE", "276", "", "01", "083", "08336", "47.65", "7.56667", "Europe/Berlin"),("2933345", "Edingen-Neckarhausen", "", "DE", "276", "", "01", "082", "08226", "49.45722", "8.60639", "Europe/Berlin"),("2933364", "Edewecht", "Эдевехт", "DE", "276", "", "06", "00", "03451", "53.12699", "7.98406", "Europe/Berlin"),("2933410", "Edenkoben", "", "DE", "276", "", "08", "00", "07337", "49.28393", "8.12714", "Europe/Berlin"),("2933607", "Eckersdorf", "", "DE", "276", "", "02", "094", "09477", "50.02874", "11.39611", "Europe/Berlin"),("2933627", "Eckernförde", "Эккернфёрде", "DE", "276", "", "10", "00", "01058", "54.46854", "9.83824", "Europe/Berlin"),("2933772", "Echzell", "", "DE", "276", "", "05", "064", "06440", "50.38888", "8.88605", "Europe/Berlin"),("2933799", "Eching", "", "DE", "276", "", "02", "091", "09178", "48.3", "11.61667", "Europe/Berlin"),("2933817", "Ebstorf", "", "DE", "276", "", "06", "00", "03360", "53.02785", "10.41839", "Europe/Berlin"),("2933882", "Eberswalde", "Эберсвальде", "DE", "276", "", "11", "00", "12060", "52.83492", "13.81951", "Europe/Berlin"),("2933922", "Ebersdorf", "", "DE", "276", "", "02", "094", "09473", "50.32898", "11.15266", "Europe/Berlin"),("2933945", "Ebersberg", "", "DE", "276", "", "02", "091", "09175", "48.0771", "11.97063", "Europe/Berlin"),("2933959", "Ebersbach an der Fils", "", "DE", "276", "", "01", "081", "08117", "48.716", "9.5236", "Europe/Berlin"),("2933965", "Ebersbach", "", "DE", "276", "", "13", "00", "14626", "51.00762", "14.58621", "Europe/Berlin"),("2933986", "Ebermannstadt", "", "DE", "276", "", "02", "094", "09474", "49.78154", "11.18168", "Europe/Berlin"),("2934014", "Eberdingen", "", "DE", "276", "", "01", "081", "08118", "48.87942", "8.96502", "Europe/Berlin"),("2934020", "Eberbach", "Эбербах", "DE", "276", "", "01", "082", "08226", "49.4668", "8.99016", "Europe/Berlin"),("2934033", "Ebensfeld", "", "DE", "276", "", "02", "094", "09478", "50.0664", "10.95835", "Europe/Berlin"),("2934163", "Duvenstedt", "", "DE", "276", "", "04", "00", "02000", "53.70806", "10.10444", "Europe/Berlin"),("2934235", "Dußlingen", "", "DE", "276", "", "01", "084", "08416", "48.45357", "9.05552", "Europe/Berlin"),("2934246", "Düsseldorf", "Дюссельдорф", "DE", "276", "", "07", "051", "05111", "51.22172", "6.77616", "Europe/Berlin"),("2934462", "Durmersheim", "", "DE", "276", "", "01", "082", "08216", "48.93333", "8.26667", "Europe/Berlin"),("2934486", "Düren", "Дюрен", "DE", "276", "", "07", "053", "05358", "50.80434", "6.49299", "Europe/Berlin"),("2934509", "Durach", "", "DE", "276", "", "02", "097", "09780", "47.6944", "10.34449", "Europe/Berlin"),("2934560", "Dunningen", "", "DE", "276", "", "01", "083", "08325", "48.21242", "8.50619", "Europe/Berlin"),("2934662", "Dülmen", "Дюльмен", "DE", "276", "", "07", "055", "05558", "51.83149", "7.28075", "Europe/Berlin"),("2934691", "Duisburg", "Дуйсбург", "DE", "276", "", "07", "051", "05112", "51.43247", "6.76516", "Europe/Berlin"),("2934728", "Duderstadt", "Дудерштадт", "DE", "276", "", "06", "00", "03152", "51.51312", "10.25951", "Europe/Berlin"),("2934737", "Dudenhofen", "", "DE", "276", "", "08", "00", "07338", "49.31861", "8.38861", "Europe/Berlin"),("2934886", "Drolshagen", "", "DE", "276", "", "07", "059", "05966", "51.02358", "7.77355", "Europe/Berlin"),("2934915", "Drochtersen", "", "DE", "276", "", "06", "00", "03359", "53.71015", "9.38463", "Europe/Berlin"),("2934965", "Driedorf", "", "DE", "276", "", "05", "065", "06532", "50.63333", "8.18333", "Europe/Berlin"),("2935022", "Dresden", "Дрезден", "DE", "276", "", "13", "00", "14612", "51.05089", "13.73832", "Europe/Berlin"),("2935042", "Drensteinfurt", "Дренштайнфурт", "DE", "276", "", "07", "055", "05570", "51.79535", "7.73815", "Europe/Berlin"),("2935220", "Dreieich", "Драйайх", "DE", "276", "", "05", "064", "06438", "50.01997", "8.69611", "Europe/Berlin"),("2935298", "Drebkau", "", "DE", "276", "", "11", "00", "12071", "51.65412", "14.22316", "Europe/Berlin"),("2935441", "Dötlingen", "", "DE", "276", "", "06", "00", "03458", "52.93333", "8.38333", "Europe/Berlin"),("2935453", "Dossenheim", "", "DE", "276", "", "01", "082", "08226", "49.45028", "8.67472", "Europe/Berlin"),("2935491", "Dörverden", "", "DE", "276", "", "06", "00", "03361", "52.85", "9.23333", "Europe/Berlin"),("2935517", "Dortmund", "Дортмунд", "DE", "276", "", "07", "059", "05913", "51.51494", "7.466", "Europe/Berlin"),("2935530", "Dorsten", "Дорстен", "DE", "276", "", "07", "055", "05562", "51.66166", "6.96514", "Europe/Berlin"),("2935642", "Dornstetten", "", "DE", "276", "", "01", "082", "08237", "48.47198", "8.49817", "Europe/Berlin"),("2935647", "Dornstadt", "", "DE", "276", "", "01", "084", "08425", "48.46697", "9.94434", "Europe/Berlin"),("2935702", "Dornhan", "", "DE", "276", "", "01", "083", "08325", "48.35008", "8.50901", "Europe/Berlin"),("2935825", "Dormagen", "Дормаген", "DE", "276", "", "07", "051", "05162", "51.09683", "6.83167", "Europe/Berlin"),("2936103", "Dorfen", "", "DE", "276", "", "02", "091", "09177", "48.27037", "12.16056", "Europe/Berlin"),("2936153", "Dörentrup", "", "DE", "276", "", "07", "057", "05766", "52.04109", "9.00278", "Europe/Berlin"),("2936186", "Donzdorf", "", "DE", "276", "", "01", "081", "08117", "48.68544", "9.81053", "Europe/Berlin"),("2936253", "Donauwörth", "Донаувёрт", "DE", "276", "", "02", "097", "09779", "48.71804", "10.7793", "Europe/Berlin"),("2936267", "Donaueschingen", "Донауэшинген", "DE", "276", "", "01", "083", "08326", "47.95514", "8.49707", "Europe/Berlin"),("2936470", "Dohna", "", "DE", "276", "", "13", "00", "14628", "50.95621", "13.85839", "Europe/Berlin"),("2936631", "Doberlug-Kirchhain", "", "DE", "276", "", "11", "00", "12062", "51.62578", "13.56232", "Europe/Berlin"),("2936658", "Döbeln", "Дебельн", "DE", "276", "", "13", "00", "14522", "51.1221", "13.11027", "Europe/Berlin"),("2936705", "Ditzingen", "Дитцинген", "DE", "276", "", "01", "081", "08118", "48.82672", "9.06703", "Europe/Berlin"),("2936759", "Dittelbrunn", "", "DE", "276", "", "02", "096", "09678", "50.08333", "10.21667", "Europe/Berlin"),("2936787", "Dissen", "", "DE", "276", "", "06", "00", "03459", "52.11591", "8.19956", "Europe/Berlin"),("2936842", "Dippoldiswalde", "", "DE", "276", "", "13", "00", "14628", "50.89621", "13.66905", "Europe/Berlin"),("2936871", "Dinslaken", "Динслакена", "DE", "276", "", "07", "051", "05170", "51.56227", "6.7434", "Europe/Berlin"),("2936881", "Dinklage", "", "DE", "276", "", "06", "00", "03460", "52.66223", "8.1244", "Europe/Berlin"),("2936885", "Dinkelscherben", "", "DE", "276", "", "02", "097", "09772", "48.34826", "10.58893", "Europe/Berlin"),("2936886", "Dinkelsbühl", "", "DE", "276", "", "02", "095", "09571", "49.06942", "10.31985", "Europe/Berlin"),("2936909", "Dingolfing", "Дингольфинг", "DE", "276", "", "02", "092", "09279", "48.64244", "12.49283", "Europe/Berlin"),("2936974", "Dillingen an der Donau", "Диллинген-на-Дунае", "DE", "276", "", "02", "097", "09773", "48.58153", "10.49527", "Europe/Berlin"),("2936977", "Dillingen", "", "DE", "276", "", "09", "00", "10044", "49.35557", "6.72781", "Europe/Berlin"),("2936985", "Dillenburg", "Дилленбург", "DE", "276", "", "05", "065", "06532", "50.74114", "8.28699", "Europe/Berlin"),("2937018", "Diez", "", "DE", "276", "", "08", "00", "07141", "50.37419", "8.00735", "Europe/Berlin"),("2937040", "Dietzenbach", "Дитценбах", "DE", "276", "", "05", "064", "06438", "50.00976", "8.77783", "Europe/Berlin"),("2937073", "Dietramszell", "", "DE", "276", "", "02", "091", "09173", "47.84871", "11.5953", "Europe/Berlin"),("2937077", "Dietmannsried", "", "DE", "276", "", "02", "097", "09780", "47.80787", "10.28948", "Europe/Berlin"),("2937110", "Dietfurt", "", "DE", "276", "", "02", "093", "09373", "49.03578", "11.58624", "Europe/Berlin"),("2937160", "Dietenhofen", "", "DE", "276", "", "02", "095", "09571", "49.39997", "10.68975", "Europe/Berlin"),("2937164", "Dietenheim", "", "DE", "276", "", "01", "084", "08425", "48.21072", "10.07163", "Europe/Berlin"),("2937217", "Dießen am Ammersee", "", "DE", "276", "", "02", "091", "09181", "47.95085", "11.10306", "Europe/Berlin"),("2937280", "Dierdorf", "", "DE", "276", "", "08", "00", "07138", "50.54647", "7.65271", "Europe/Berlin"),("2937317", "Diepholz", "Дипхольц", "DE", "276", "", "06", "00", "03251", "52.60783", "8.37005", "Europe/Berlin"),("2937407", "Dielheim", "", "DE", "276", "", "01", "082", "08226", "49.28417", "8.73806", "Europe/Berlin"),("2937449", "Diekholzen", "", "DE", "276", "", "06", "00", "03254", "52.09617", "9.91945", "Europe/Berlin"),("2937553", "Diedorf", "", "DE", "276", "", "02", "097", "09772", "48.3532", "10.78206", "Europe/Berlin"),("2937591", "Dieburg", "Дибург", "DE", "276", "", "05", "064", "06432", "49.89738", "8.84613", "Europe/Berlin"),("2937790", "Deutz", "", "DE", "276", "", "07", "053", "05315", "50.93463", "6.97495", "Europe/Berlin"),("2937896", "Dettingen unter Teck", "", "DE", "276", "", "01", "081", "08116", "48.61667", "9.45", "Europe/Berlin"),("2937898", "Dettingen an der Erms", "", "DE", "276", "", "01", "084", "08415", "48.53077", "9.34458", "Europe/Berlin"),("2937919", "Dettenhausen", "", "DE", "276", "", "01", "084", "08416", "48.60758", "9.10041", "Europe/Berlin"),("2937932", "Dettelbach", "", "DE", "276", "", "02", "096", "09675", "49.80295", "10.16519", "Europe/Berlin"),("2937936", "Detmold", "Детмольд", "DE", "276", "", "07", "057", "05766", "51.93855", "8.87318", "Europe/Berlin"),("2937937", "Detmerode", "", "DE", "276", "", "06", "00", "03103", "52.39016", "10.7448", "Europe/Berlin"),("2937959", "Dessau", "Дессау", "DE", "276", "", "14", "00", "15001", "51.83864", "12.24555", "Europe/Berlin"),("2938190", "Denzlingen", "", "DE", "276", "", "01", "083", "08316", "48.06667", "7.88333", "Europe/Berlin"),("2938253", "Denkendorf", "", "DE", "276", "", "01", "081", "08116", "48.69555", "9.31675", "Europe/Berlin"),("2938284", "Demmin", "", "DE", "276", "", "12", "00", "13071", "53.90762", "13.03142", "Europe/Berlin"),("2938323", "Delmenhorst", "Дельменхорст", "DE", "276", "", "06", "00", "03401", "53.0511", "8.63091", "Europe/Berlin"),("2938344", "Delligsen", "", "DE", "276", "", "06", "00", "03255", "51.9412", "9.80272", "Europe/Berlin"),("2938376", "Delitzsch", "Делич", "DE", "276", "", "13", "00", "14730", "51.52546", "12.34284", "Europe/Berlin"),("2938389", "Delbrück", "Дельбрюк", "DE", "276", "", "07", "057", "05774", "51.76503", "8.56223", "Europe/Berlin"),("2938391", "Deizisau", "", "DE", "276", "", "01", "081", "08116", "48.7122", "9.3861", "Europe/Berlin"),("2938403", "Deißlingen", "", "DE", "276", "", "01", "083", "08325", "48.1123", "8.60736", "Europe/Berlin"),("2938538", "Deggingen", "", "DE", "276", "", "01", "081", "08117", "48.5971", "9.71891", "Europe/Berlin"),("2938540", "Deggendorf", "Деггендорф", "DE", "276", "", "02", "092", "09271", "48.84085", "12.96068", "Europe/Berlin"),("2938714", "Daun", "", "DE", "276", "", "08", "00", "07233", "50.19716", "6.82942", "Europe/Berlin"),("2938784", "Datteln", "Даттельн", "DE", "276", "", "07", "055", "05562", "51.66667", "7.38333", "Europe/Berlin"),("2938813", "Dassel", "", "DE", "276", "", "06", "00", "03155", "51.80179", "9.68904", "Europe/Berlin"),("2938837", "Dasing", "", "DE", "276", "", "02", "097", "09771", "48.38482", "11.04667", "Europe/Berlin"),("2938913", "Darmstadt", "Дармштадт", "DE", "276", "", "05", "064", "06411", "49.87167", "8.65027", "Europe/Berlin"),("2938991", "Dannenberg", "", "DE", "276", "", "06", "00", "03354", "53.0967", "11.09001", "Europe/Berlin"),("2939167", "Damme", "Дамме", "DE", "276", "", "06", "00", "03460", "52.52157", "8.19793", "Europe/Berlin"),("2939388", "Dahme", "", "DE", "276", "", "11", "00", "12072", "51.87008", "13.42743", "Europe/Berlin"),("2939434", "Dahlen", "", "DE", "276", "", "13", "00", "14730", "51.36495", "12.99881", "Europe/Berlin"),("2939440", "Dahlem", "Далем", "DE", "276", "", "16", "00", "11000", "52.4581", "13.28702", "Europe/Berlin"),("2939623", "Dachau", "Дахау", "DE", "276", "", "02", "091", "09174", "48.26", "11.43402", "Europe/Berlin"),("2939658", "Cuxhaven", "Куксхафен", "DE", "276", "", "06", "00", "03352", "53.87176", "8.69087", "Europe/Berlin"),("2939687", "Cunewalde", "", "DE", "276", "", "13", "00", "14625", "51.1", "14.51667", "Europe/Berlin"),("2939747", "Crimmitschau", "Криммичау", "DE", "276", "", "13", "00", "14524", "50.81644", "12.39045", "Europe/Berlin"),("2939763", "Cremlingen", "", "DE", "276", "", "06", "00", "03158", "52.25", "10.65", "Europe/Berlin"),("2939797", "Crailsheim", "Крайльсхайм", "DE", "276", "", "01", "081", "08127", "49.13444", "10.07193", "Europe/Berlin"),("2939811", "Cottbus", "Котбус", "DE", "276", "", "11", "00", "12052", "51.75769", "14.32888", "Europe/Berlin"),("2939819", "Coswig", "", "DE", "276", "", "14", "00", "15091", "51.88618", "12.45009", "Europe/Berlin"),("2939820", "Coswig", "Косвиг", "DE", "276", "", "13", "00", "14627", "51.13204", "13.58312", "Europe/Berlin"),("2939862", "Coppenbrügge", "", "DE", "276", "", "06", "00", "03252", "52.11852", "9.5487", "Europe/Berlin"),("2939870", "Contwig", "", "DE", "276", "", "08", "00", "07340", "49.25", "7.43333", "Europe/Berlin"),("2939927", "Colditz", "", "DE", "276", "", "13", "00", "14729", "51.12821", "12.80295", "Europe/Berlin"),("2939942", "Cölbe", "", "DE", "276", "", "05", "065", "06534", "50.85", "8.8", "Europe/Berlin"),("2939945", "Coesfeld", "Косфельд", "DE", "276", "", "07", "055", "05558", "51.94349", "7.16809", "Europe/Berlin"),("2939949", "Cochem", "", "DE", "276", "", "08", "00", "07135", "50.14511", "7.16379", "Europe/Berlin"),("2939951", "Coburg", "Кобург", "DE", "276", "", "02", "094", "09463", "50.25937", "10.96384", "Europe/Berlin"),("2939969", "Cloppenburg", "Клоппенбург", "DE", "276", "", "06", "00", "03453", "52.84754", "8.045", "Europe/Berlin"),("2939995", "Clausthal-Zellerfeld", "Клаусталь-Целлерфельд", "DE", "276", "", "06", "00", "03153", "51.80949", "10.33821", "Europe/Berlin"),("2940132", "Chemnitz", "Хемниц", "DE", "276", "", "13", "00", "14511", "50.8357", "12.92922", "Europe/Berlin"),("2940187", "Charlottenburg", "Шарлоттенбург", "DE", "276", "", "16", "00", "11000", "52.51667", "13.28333", "Europe/Berlin"),("2940204", "Cham", "", "DE", "276", "", "02", "093", "09372", "49.22565", "12.65501", "Europe/Berlin"),("2940213", "Celle", "Целле", "DE", "276", "", "06", "00", "03351", "52.62264", "10.08047", "Europe/Berlin"),("2940231", "Castrop-Rauxel", "Кастроп-Рауксель", "DE", "276", "", "07", "055", "05562", "51.55657", "7.31155", "Europe/Berlin"),("2940317", "Cappeln", "", "DE", "276", "", "06", "00", "03453", "52.81085", "8.11474", "Europe/Berlin"),("2940381", "Bad Camberg", "", "DE", "276", "", "05", "065", "06533", "50.29695", "8.26896", "Europe/Berlin"),("2940383", "Calw", "Кальв", "DE", "276", "", "01", "082", "08235", "48.71419", "8.74031", "Europe/Berlin"),("2940397", "Callenberg", "", "DE", "276", "", "13", "00", "14524", "50.85", "12.63333", "Europe/Berlin"),("2940412", "Calden", "", "DE", "276", "", "05", "066", "06633", "51.40943", "9.40189", "Europe/Berlin"),("2940419", "Calbe", "", "DE", "276", "", "14", "00", "15089", "51.90668", "11.77478", "Europe/Berlin"),("2940424", "Calau", "", "DE", "276", "", "11", "00", "12066", "51.74402", "13.95329", "Europe/Berlin"),("2940428", "Cadolzburg", "", "DE", "276", "", "02", "095", "09573", "49.4573", "10.85329", "Europe/Berlin"),("2940451", "Buxtehude", "Букстехуде", "DE", "276", "", "06", "00", "03359", "53.46716", "9.68636", "Europe/Berlin"),("2940476", "Bützow", "", "DE", "276", "", "12", "00", "13072", "53.84832", "11.98256", "Europe/Berlin"),("2940512", "Butzbach", "Буцбах", "DE", "276", "", "05", "064", "06440", "50.43395", "8.67122", "Europe/Berlin"),("2940611", "Buttenwiesen", "", "DE", "276", "", "02", "097", "09773", "48.6", "10.71667", "Europe/Berlin"),("2940633", "Büttelborn", "", "DE", "276", "", "05", "064", "06433", "49.90333", "8.52333", "Europe/Berlin"),("2940938", "Bürstadt", "Бюрштадт", "DE", "276", "", "05", "064", "06431", "49.64266", "8.45936", "Europe/Berlin"),("2940942", "Burscheid", "Буршайд", "DE", "276", "", "07", "053", "05378", "51.1", "7.11667", "Europe/Berlin"),("2940977", "Burladingen", "", "DE", "276", "", "01", "084", "08417", "48.29111", "9.11286", "Europe/Berlin"),("2940993", "Burkhardtsdorf", "", "DE", "276", "", "13", "00", "14521", "50.73333", "12.91667", "Europe/Berlin"),("2941034", "Burkardroth", "", "DE", "276", "", "02", "096", "09672", "50.27125", "9.99162", "Europe/Berlin"),("2941090", "Burgthann", "", "DE", "276", "", "02", "095", "09574", "49.35202", "11.31154", "Europe/Berlin"),("2941150", "Burgstädt", "", "DE", "276", "", "13", "00", "14522", "50.91333", "12.806", "Europe/Berlin"),("2941190", "Burglengenfeld", "", "DE", "276", "", "02", "093", "09376", "49.20379", "12.04452", "Europe/Berlin"),("2941207", "Burgkunstadt", "", "DE", "276", "", "02", "094", "09478", "50.14093", "11.25205", "Europe/Berlin"),("2941216", "Burgkirchen an der Alz", "", "DE", "276", "", "02", "091", "09171", "48.16753", "12.7325", "Europe/Berlin"),("2941279", "Burghausen", "", "DE", "276", "", "02", "091", "09171", "48.16925", "12.83139", "Europe/Berlin"),("2941283", "Burghaun", "", "DE", "276", "", "05", "066", "06631", "50.69684", "9.72453", "Europe/Berlin"),("2941403", "Burgebrach", "", "DE", "276", "", "02", "094", "09471", "49.82832", "10.74338", "Europe/Berlin"),("2941405", "Burgdorf", "Бургдорф", "DE", "276", "", "06", "00", "03241", "52.44628", "10.0064", "Europe/Berlin"),("2941485", "Burgau", "", "DE", "276", "", "02", "097", "09774", "48.43159", "10.40989", "Europe/Berlin"),("2941496", "Burg auf Fehmarn", "", "DE", "276", "DE", "10", "00", "01055", "54.43333", "11.2", "Europe/Berlin"),("2941501", "Burg bei Magdeburg", "", "DE", "276", "", "14", "00", "15086", "52.27152", "11.85493", "Europe/Berlin"),("2941570", "Büren", "Бюрен", "DE", "276", "", "07", "057", "05774", "51.55109", "8.55956", "Europe/Berlin"),("2941595", "Burbach", "", "DE", "276", "", "07", "059", "05970", "50.75", "8.08333", "Europe/Berlin"),("2941693", "Bunde", "", "DE", "276", "", "06", "00", "03457", "53.18333", "7.26667", "Europe/Berlin"),("2941694", "Bünde", "Бюнде", "DE", "276", "", "07", "057", "05758", "52.19837", "8.58644", "Europe/Berlin"),("2941928", "Bühlertal", "", "DE", "276", "", "01", "082", "08216", "48.68569", "8.18876", "Europe/Berlin"),("2941976", "Bühl", "Бюль", "DE", "276", "", "01", "082", "08216", "48.69676", "8.13523", "Europe/Berlin"),("2942073", "Büdingen", "Бюдинген", "DE", "276", "", "05", "064", "06440", "50.29013", "9.1114", "Europe/Berlin"),("2942087", "Budenheim", "", "DE", "276", "", "08", "00", "07339", "50.01667", "8.16667", "Europe/Berlin"),("2942093", "Büdelsdorf", "", "DE", "276", "", "10", "00", "01058", "54.31844", "9.67295", "Europe/Berlin"),("2942122", "Buckow", "", "DE", "276", "", "16", "00", "11000", "52.432", "13.46018", "Europe/Berlin"),("2942159", "Bückeburg", "Бюккебург", "DE", "276", "", "06", "00", "03257", "52.26065", "9.04939", "Europe/Berlin"),("2942281", "Buchloe", "", "DE", "276", "", "02", "097", "09777", "48.03719", "10.72548", "Europe/Berlin"),("2942323", "Buchholz in der Nordheide", "Бухгольц-ин-дер-Нордхайде", "DE", "276", "", "06", "00", "03353", "53.32641", "9.86812", "Europe/Berlin"),("2942341", "Französisch Buchholz", "", "DE", "276", "DE", "16", "00", "11000", "52.60242", "13.43019", "Europe/Berlin"),("2942446", "Buchheim", "", "DE", "276", "", "07", "053", "05315", "50.95152", "7.02093", "Europe/Berlin"),("2942612", "Büchenbach", "", "DE", "276", "", "02", "095", "09576", "49.26778", "11.05889", "Europe/Berlin"),("2942627", "Büchen", "", "DE", "276", "", "10", "00", "01053", "53.48008", "10.6176", "Europe/Berlin"),("2942634", "Buchen", "Бухен", "DE", "276", "", "01", "082", "08225", "49.52416", "9.32293", "Europe/Berlin"),("2942827", "Buch", "", "DE", "276", "DE", "16", "00", "11000", "52.6347", "13.49679", "Europe/Berlin"),("2943049", "Brunsbüttel", "", "DE", "276", "", "10", "00", "01051", "53.89504", "9.10484", "Europe/Berlin"),("2943320", "Brühl", "Брюль", "DE", "276", "", "07", "053", "05362", "50.82928", "6.90499", "Europe/Berlin"),("2943321", "Brühl", "", "DE", "276", "", "01", "082", "08226", "49.39722", "8.53361", "Europe/Berlin"),("2943336", "Brüggen", "", "DE", "276", "", "07", "051", "05166", "51.24053", "6.18376", "Europe/Berlin"),("2943408", "Bruckmühl", "", "DE", "276", "", "02", "091", "09187", "47.87859", "11.91098", "Europe/Berlin"),("2943501", "Bruckberg", "", "DE", "276", "", "02", "092", "09274", "48.53333", "12", "Europe/Berlin"),("2943560", "Bruchsal", "Брухзаль", "DE", "276", "", "01", "082", "08215", "49.12426", "8.59804", "Europe/Berlin"),("2943573", "Bruchköbel", "Брухкёбель", "DE", "276", "", "05", "064", "06435", "50.17853", "8.92315", "Europe/Berlin"),("2943587", "Bruchhausen-Vilsen", "", "DE", "276", "", "06", "00", "03251", "52.82931", "8.99066", "Europe/Berlin"),("2944027", "Britz", "", "DE", "276", "", "16", "00", "11000", "52.44293", "13.43388", "Europe/Berlin"),("2944079", "Brilon", "Брилон", "DE", "276", "", "07", "059", "05958", "51.39462", "8.57146", "Europe/Berlin"),("2944126", "Brieselang", "", "DE", "276", "", "11", "00", "12063", "52.58333", "13", "Europe/Berlin"),("2944178", "Bretzfeld", "", "DE", "276", "", "01", "081", "08126", "49.17944", "9.43833", "Europe/Berlin"),("2944200", "Bretten", "Бреттен", "DE", "276", "", "01", "082", "08215", "49.03685", "8.70745", "Europe/Berlin"),("2944254", "Brensbach", "", "DE", "276", "", "05", "064", "06437", "49.77389", "8.88444", "Europe/Berlin"),("2944354", "Bremervörde", "Бремерфёрде", "DE", "276", "", "06", "00", "03357", "53.48458", "9.14306", "Europe/Berlin"),("2944368", "Bremerhaven", "Бремерхафен", "DE", "276", "", "03", "00", "04012", "53.55021", "8.57673", "Europe/Berlin"),("2944388", "Bremen", "Бремен", "DE", "276", "", "03", "00", "04011", "53.07516", "8.80777", "Europe/Berlin"),("2944440", "Breitungen", "", "DE", "276", "", "15", "00", "16066", "50.76355", "10.32724", "Europe/Berlin"),("2944800", "Breisach am Rhein", "", "DE", "276", "", "01", "083", "08315", "48.03279", "7.58294", "Europe/Berlin"),("2944820", "Breidenbach", "", "DE", "276", "", "05", "065", "06534", "50.88333", "8.46667", "Europe/Berlin"),("2944879", "Bredstedt", "", "DE", "276", "", "10", "00", "01054", "54.61868", "8.96441", "Europe/Berlin"),("2944955", "Breckerfeld", "", "DE", "276", "", "07", "059", "05954", "51.25926", "7.46807", "Europe/Berlin"),("2945024", "Braunschweig", "Брауншвейг", "DE", "276", "", "06", "00", "03101", "52.26594", "10.52673", "Europe/Berlin"),("2945041", "Braunsbedra", "", "DE", "276", "", "14", "00", "15088", "51.28602", "11.88987", "Europe/Berlin"),("2945051", "Bräunlingen", "", "DE", "276", "", "01", "083", "08326", "47.92957", "8.44806", "Europe/Berlin"),("2945055", "Braunlage", "", "DE", "276", "", "06", "00", "03153", "51.72651", "10.6109", "Europe/Berlin"),("2945073", "Braunfels", "", "DE", "276", "", "05", "065", "06532", "50.51545", "8.38918", "Europe/Berlin"),("2945165", "Brannenburg", "", "DE", "276", "", "02", "091", "09187", "47.73996", "12.09166", "Europe/Berlin"),("2945270", "Brandis", "", "DE", "276", "", "13", "00", "14729", "51.33597", "12.61024", "Europe/Berlin"),("2945341", "Brand-Erbisdorf", "", "DE", "276", "", "13", "00", "14522", "50.86643", "13.32285", "Europe/Berlin"),("2945358", "Brandenburg an der Havel", "Бранденбург", "DE", "276", "", "11", "00", "12051", "52.41667", "12.55", "Europe/Berlin"),("2945474", "Bramsche", "Брамше", "DE", "276", "", "06", "00", "03459", "52.40881", "7.97288", "Europe/Berlin"),("2945542", "Brakel", "Бракель", "DE", "276", "", "07", "057", "05762", "51.7175", "9.18596", "Europe/Berlin"),("2945545", "Brake (Unterweser)", "", "DE", "276", "", "06", "00", "03461", "53.33333", "8.48333", "Europe/Berlin"),("2945591", "Brackenheim", "Бракенхайм", "DE", "276", "", "01", "081", "08125", "49.07787", "9.06601", "Europe/Berlin"),("2945703", "Boxberg", "", "DE", "276", "", "01", "081", "08128", "49.47965", "9.64006", "Europe/Berlin"),("2945726", "Bovenden", "", "DE", "276", "", "06", "00", "03152", "51.59179", "9.92996", "Europe/Berlin"),("2945730", "Bous", "", "DE", "276", "", "09", "00", "10044", "49.27732", "6.80131", "Europe/Berlin"),("2945740", "Bötzingen", "", "DE", "276", "", "01", "083", "08315", "48.07642", "7.72485", "Europe/Berlin"),("2945756", "Bottrop", "Ботроп", "DE", "276", "", "07", "055", "05512", "51.52392", "6.9285", "Europe/Berlin"),("2945907", "Bösel", "", "DE", "276", "", "06", "00", "03453", "53", "7.95", "Europe/Berlin"),("2946016", "Borsdorf", "", "DE", "276", "", "13", "00", "14729", "51.35", "12.53333", "Europe/Berlin"),("2946111", "Bornheim", "Борнхайм", "DE", "276", "", "07", "053", "05382", "50.76313", "6.99089", "Europe/Berlin"),("2946172", "Borna", "Борна", "DE", "276", "", "13", "00", "14729", "51.12416", "12.49639", "Europe/Berlin"),("2946206", "Borkum", "", "DE", "276", "", "06", "00", "03457", "53.58094", "6.69153", "Europe/Berlin"),("2946228", "Borken", "Боркен", "DE", "276", "", "07", "055", "05554", "51.84382", "6.85774", "Europe/Berlin"),("2946230", "Borken", "", "DE", "276", "", "05", "066", "06634", "51.04501", "9.2844", "Europe/Berlin"),("2946270", "Borgholzhausen", "", "DE", "276", "", "07", "057", "05754", "52.10343", "8.30211", "Europe/Berlin"),("2946281", "Borgfelde", "", "DE", "276", "", "04", "00", "02000", "53.55475", "10.03447", "Europe/Berlin"),("2946291", "Borgentreich", "", "DE", "276", "", "07", "057", "05762", "51.56917", "9.24113", "Europe/Berlin"),("2946321", "Bordesholm", "", "DE", "276", "", "10", "00", "01058", "54.18333", "10.01667", "Europe/Berlin"),("2946366", "Boppard", "Боппард", "DE", "276", "", "08", "00", "07140", "50.23085", "7.58992", "Europe/Berlin"),("2946368", "Bopfingen", "", "DE", "276", "", "01", "081", "08136", "48.85847", "10.35417", "Europe/Berlin"),("2946428", "Bönnigheim", "", "DE", "276", "", "01", "081", "08118", "49.04018", "9.09386", "Europe/Berlin"),("2946445", "Bonndorf im Schwarzwald", "", "DE", "276", "", "01", "083", "08337", "47.81863", "8.34139", "Europe/Berlin"),("2946447", "Bonn", "Бонн", "DE", "276", "", "07", "053", "05314", "50.73438", "7.09549", "Europe/Berlin"),("2946478", "Bönen", "Бёнен", "DE", "276", "", "07", "059", "05978", "51.6", "7.76667", "Europe/Berlin"),("2946485", "Bondorf", "", "DE", "276", "", "01", "081", "08115", "48.52064", "8.83704", "Europe/Berlin"),("2946524", "Bomlitz", "", "DE", "276", "", "06", "00", "03358", "52.9", "9.65", "Europe/Berlin"),("2946696", "Boll", "", "DE", "276", "", "01", "081", "08117", "48.64357", "9.61295", "Europe/Berlin"),("2946821", "Boizenburg", "", "DE", "276", "", "12", "00", "13076", "53.38153", "10.72375", "Europe/Berlin"),("2946887", "Bohnsdorf", "", "DE", "276", "", "16", "00", "11000", "52.39434", "13.57339", "Europe/Berlin"),("2946923", "Bohmte", "", "DE", "276", "", "06", "00", "03459", "52.36667", "8.31667", "Europe/Berlin"),("2946950", "Böhmenkirch", "", "DE", "276", "", "01", "081", "08117", "48.68333", "9.93333", "Europe/Berlin"),("2946980", "Böhlen", "", "DE", "276", "", "13", "00", "14729", "51.20061", "12.38622", "Europe/Berlin"),("2947022", "Bogenhausen", "", "DE", "276", "", "02", "091", "09162", "48.15221", "11.61585", "Europe/Berlin"),("2947026", "Bogen", "", "DE", "276", "", "02", "092", "09278", "48.91122", "12.68955", "Europe/Berlin"),("2947092", "Bodenwerder", "", "DE", "276", "", "06", "00", "03255", "51.97156", "9.51931", "Europe/Berlin"),("2947125", "Bodenkirchen", "", "DE", "276", "", "02", "092", "09274", "48.38333", "12.38333", "Europe/Berlin"),("2947133", "Bodenheim", "", "DE", "276", "", "08", "00", "07339", "49.93528", "8.32", "Europe/Berlin"),("2947172", "Bodelshausen", "", "DE", "276", "", "01", "084", "08416", "48.38886", "8.97703", "Europe/Berlin"),("2947312", "Bockhorn", "", "DE", "276", "", "06", "00", "03455", "53.4", "8.01667", "Europe/Berlin"),("2947359", "Bockenem", "", "DE", "276", "", "06", "00", "03254", "52.00993", "10.13197", "Europe/Berlin"),("2947416", "Bochum", "Бохум", "DE", "276", "", "07", "059", "05911", "51.48165", "7.21648", "Europe/Berlin"),("2947421", "Bocholt", "Бохольт", "DE", "276", "", "07", "055", "05554", "51.83879", "6.61531", "Europe/Berlin"),("2947444", "Böblingen", "Бёблинген", "DE", "276", "", "01", "081", "08115", "48.68212", "9.01171", "Europe/Berlin"),("2947449", "Bobingen", "Бобинген", "DE", "276", "", "02", "097", "09772", "48.27091", "10.8339", "Europe/Berlin"),("2947465", "Bobenheim-Roxheim", "", "DE", "276", "", "08", "00", "07338", "49.5875", "8.35778", "Europe/Berlin"),("2947584", "Blumberg", "", "DE", "276", "", "01", "083", "08326", "47.84058", "8.53329", "Europe/Berlin"),("2947641", "Blomberg", "Бломберг", "DE", "276", "", "07", "057", "05766", "51.94331", "9.09067", "Europe/Berlin"),("2947739", "Blieskastel", "Блискастель", "DE", "276", "", "09", "00", "10045", "49.23724", "7.25617", "Europe/Berlin"),("2947837", "Bleicherode", "", "DE", "276", "", "15", "00", "16062", "51.44026", "10.57202", "Europe/Berlin"),("2947894", "Bleckede", "", "DE", "276", "", "06", "00", "03355", "53.28972", "10.73372", "Europe/Berlin"),("2947919", "Blaufelden", "", "DE", "276", "", "01", "081", "08127", "49.29778", "9.97389", "Europe/Berlin"),("2947949", "Blaubeuren", "", "DE", "276", "", "01", "084", "08425", "48.41215", "9.78427", "Europe/Berlin"),("2948056", "Blankenheim", "", "DE", "276", "", "07", "053", "05366", "50.43333", "6.65", "Europe/Berlin"),("2948058", "Blankenhain", "", "DE", "276", "", "15", "00", "16071", "50.85993", "11.3439", "Europe/Berlin"),("2948069", "Blankenburg", "", "DE", "276", "DE", "16", "00", "11000", "52.59293", "13.45516", "Europe/Berlin"),("2948071", "Blankenburg", "Бланкенбург", "DE", "276", "", "14", "00", "15085", "51.79025", "10.95509", "Europe/Berlin"),("2948114", "Blaichach", "", "DE", "276", "", "02", "097", "09780", "47.53333", "10.26667", "Europe/Berlin"),("2948164", "Bitterfeld-Wolfen", "Биттерфельд", "DE", "276", "", "13", "", "", "51.62355", "12.32395", "Europe/Berlin"),("2948184", "Bitburg", "", "DE", "276", "", "08", "00", "07232", "49.96794", "6.52734", "Europe/Berlin"),("2948212", "Bissendorf", "", "DE", "276", "", "06", "00", "03459", "52.23333", "8.16667", "Europe/Berlin"),("2948222", "Bispingen", "", "DE", "276", "", "06", "00", "03358", "53.08312", "9.99772", "Europe/Berlin"),("2948246", "Bisingen", "", "DE", "276", "", "01", "084", "08417", "48.31012", "8.91738", "Europe/Berlin"),("2948265", "Bischofswiesen", "", "DE", "276", "", "02", "091", "09172", "47.65", "12.95", "Europe/Berlin"),("2948267", "Bischofswerda", "", "DE", "276", "", "13", "00", "14625", "51.12771", "14.17974", "Europe/Berlin"),("2948287", "Bischofsheim an der Rhön", "", "DE", "276", "", "02", "096", "09673", "50.40239", "10.00751", "Europe/Berlin"),("2948290", "Bischofsheim", "", "DE", "276", "", "05", "064", "06433", "49.99389", "8.36722", "Europe/Berlin"),("2948339", "Bischberg", "", "DE", "276", "", "02", "094", "09471", "49.91087", "10.83212", "Europe/Berlin"),("2948351", "Birstein", "", "DE", "276", "", "05", "064", "06435", "50.35", "9.3", "Europe/Berlin"),("2948384", "Bad Birnbach", "", "DE", "276", "", "02", "092", "09277", "48.44489", "13.09103", "Europe/Berlin"),("2948503", "Birkenwerder", "", "DE", "276", "", "11", "00", "12065", "52.68333", "13.28333", "Europe/Berlin"),("2948595", "Birkenfeld", "", "DE", "276", "", "08", "00", "07134", "49.65245", "7.16668", "Europe/Berlin"),("2948598", "Birkenfeld", "", "DE", "276", "", "01", "082", "08236", "48.86667", "8.63333", "Europe/Berlin"),("2948652", "Birkenau", "", "DE", "276", "", "05", "064", "06431", "49.5625", "8.70694", "Europe/Berlin"),("2948825", "Bingen am Rhein", "Бинген-на-Рейне", "DE", "276", "", "08", "00", "07339", "49.96675", "7.8992", "Europe/Berlin"),("2948840", "Bindlach", "", "DE", "276", "", "02", "094", "09472", "49.98167", "11.61389", "Europe/Berlin"),("2948934", "Billigheim", "", "DE", "276", "", "01", "082", "08225", "49.34861", "9.25389", "Europe/Berlin"),("2948944", "Billerbeck", "", "DE", "276", "", "07", "055", "05558", "51.97829", "7.29261", "Europe/Berlin"),("2949012", "Bietigheim-Bissingen", "Битигхайм-Биссинген", "DE", "276", "", "01", "081", "08118", "48.94407", "9.11755", "Europe/Berlin"),("2949014", "Bietigheim", "", "DE", "276", "", "01", "082", "08216", "48.90919", "8.25202", "Europe/Berlin"),("2949046", "Biesenthal", "", "DE", "276", "", "11", "00", "12060", "52.76616", "13.64416", "Europe/Berlin"),("2949073", "Biesdorf", "", "DE", "276", "DE", "16", "00", "11000", "52.50906", "13.5534", "Europe/Berlin"),("2949150", "Bienenbüttel", "", "DE", "276", "", "06", "00", "03360", "53.14157", "10.48679", "Europe/Berlin"),("2949186", "Bielefeld", "Билефельд", "DE", "276", "", "07", "057", "05711", "52.03333", "8.53333", "Europe/Berlin"),("2949229", "Biedenkopf", "", "DE", "276", "", "05", "065", "06534", "50.91125", "8.53016", "Europe/Berlin"),("2949240", "Biebesheim", "", "DE", "276", "", "05", "064", "06433", "49.78088", "8.46696", "Europe/Berlin"),("2949296", "Bickenbach", "", "DE", "276", "", "05", "064", "06432", "49.75917", "8.6175", "Europe/Berlin"),("2949367", "Biblis", "", "DE", "276", "", "05", "064", "06431", "49.69167", "8.45861", "Europe/Berlin"),("2949423", "Biberach an der Riß", "Биберах-на-Рисе", "DE", "276", "", "01", "084", "08426", "48.09345", "9.79053", "Europe/Berlin"),("2949470", "Bexbach", "Бексбах", "DE", "276", "", "09", "00", "10045", "49.34615", "7.25527", "Europe/Berlin"),("2949475", "Beverungen", "Беверунген", "DE", "276", "", "07", "057", "05762", "51.66801", "9.37417", "Europe/Berlin"),("2949511", "Bad Bevensen", "", "DE", "276", "", "06", "00", "03360", "53.07923", "10.58129", "Europe/Berlin"),("2949669", "Betzdorf", "", "DE", "276", "", "08", "00", "07132", "50.79094", "7.87189", "Europe/Berlin"),("2949773", "Bestwig", "", "DE", "276", "", "07", "059", "05958", "51.36667", "8.4", "Europe/Berlin"),("2949777", "Bestensee", "", "DE", "276", "", "11", "00", "12061", "52.25", "13.65", "Europe/Berlin"),("2949803", "Besigheim", "", "DE", "276", "", "01", "081", "08118", "48.99797", "9.14268", "Europe/Berlin"),("2949906", "Bersenbrück", "", "DE", "276", "", "06", "00", "03459", "52.5516", "7.94836", "Europe/Berlin"),("2949961", "Bernsdorf", "", "DE", "276", "", "13", "00", "14625", "51.3735", "14.06886", "Europe/Berlin"),("2949998", "Bernkastel-Kues", "", "DE", "276", "", "08", "00", "07231", "49.91602", "7.07664", "Europe/Berlin"),("2950019", "Bernhardswald", "", "DE", "276", "", "02", "093", "09375", "49.1", "12.25", "Europe/Berlin"),("2950073", "Bernburg", "Бернбург", "DE", "276", "", "14", "00", "15089", "51.79464", "11.7401", "Europe/Berlin"),("2950095", "Bernau am Chiemsee", "", "DE", "276", "", "02", "091", "09187", "47.81167", "12.37566", "Europe/Berlin"),("2950096", "Bernau bei Berlin", "Бернау", "DE", "276", "", "11", "00", "12060", "52.67982", "13.58708", "Europe/Berlin"),("2950159", "Berlin", "Берлин", "DE", "276", "", "16", "00", "11000", "52.52437", "13.41053", "Europe/Berlin"),("2950265", "Bergstedt", "", "DE", "276", "", "04", "00", "02000", "53.67111", "10.12694", "Europe/Berlin"),("2950294", "Bergneustadt", "Бергнойштадт", "DE", "276", "", "07", "053", "05374", "51.02496", "7.65599", "Europe/Berlin"),("2950340", "Bergkirchen", "", "DE", "276", "", "02", "091", "09174", "48.25671", "11.36488", "Europe/Berlin"),("2950344", "Bergkamen", "Бергкамен", "DE", "276", "", "07", "059", "05978", "51.61633", "7.64451", "Europe/Berlin"),("2950349", "Bergisch Gladbach", "Бергиш Гладбах", "DE", "276", "", "07", "053", "05378", "50.9856", "7.13298", "Europe/Berlin"),("2950438", "Bergheim", "Бергем", "DE", "276", "", "07", "053", "05362", "50.95572", "6.63986", "Europe/Berlin"),("2950620", "Bergen auf Rügen", "", "DE", "276", "", "12", "00", "13073", "54.41823", "13.43349", "Europe/Berlin"),("2950622", "Bergen", "", "DE", "276", "", "06", "00", "03351", "52.80837", "9.96374", "Europe/Berlin"),("2950725", "Berg", "", "DE", "276", "", "02", "093", "09374", "49.81417", "12.14161", "Europe/Berlin"),("2950881", "Berchtesgaden", "", "DE", "276", "", "02", "091", "09172", "47.63236", "13.00187", "Europe/Berlin"),("2950882", "Berching", "", "DE", "276", "", "02", "093", "09373", "49.10695", "11.44138", "Europe/Berlin"),("2950898", "Beratzhausen", "", "DE", "276", "", "02", "093", "09375", "49.09517", "11.8097", "Europe/Berlin"),("2950978", "Bensheim", "Бенсхайм", "DE", "276", "", "05", "064", "06431", "49.68369", "8.61839", "Europe/Berlin"),("2951013", "Benningen am Neckar", "", "DE", "276", "", "01", "081", "08118", "48.94672", "9.24212", "Europe/Berlin"),("2951026", "Bennewitz", "", "DE", "276", "", "13", "00", "14729", "51.36074", "12.71376", "Europe/Berlin"),("2951111", "Bendorf", "Бендорф", "DE", "276", "", "08", "00", "07137", "50.42289", "7.57924", "Europe/Berlin"),("2951134", "Bad Belzig", "", "DE", "276", "", "11", "00", "12069", "52.14184", "12.59272", "Europe/Berlin"),("2951175", "Belm", "", "DE", "276", "", "06", "00", "03459", "52.3", "8.13333", "Europe/Berlin"),("2951206", "Bellheim", "", "DE", "276", "", "08", "00", "07334", "49.19833", "8.27944", "Europe/Berlin"),("2951258", "Belgern", "", "DE", "276", "", "13", "00", "14730", "51.48263", "13.12382", "Europe/Berlin"),("2951346", "Beilstein", "", "DE", "276", "", "01", "081", "08125", "49.0414", "9.3137", "Europe/Berlin"),("2951528", "Beeskow", "", "DE", "276", "", "11", "00", "12067", "52.17291", "14.24597", "Europe/Berlin"),("2951556", "Beerfelden", "", "DE", "276", "", "05", "064", "06437", "49.56858", "8.97444", "Europe/Berlin"),("2951595", "Beelitz", "", "DE", "276", "PL", "11", "00", "12069", "52.23812", "12.9714", "Europe/Berlin"),("2951596", "Beelen", "", "DE", "276", "", "07", "055", "05570", "51.93333", "8.13333", "Europe/Berlin"),("2951648", "Bedburg", "Бедбург", "DE", "276", "", "07", "053", "05362", "50.99258", "6.57128", "Europe/Berlin"),("2951654", "Beckum", "Беккум", "DE", "276", "", "07", "055", "05570", "51.75571", "8.04075", "Europe/Berlin"),("2951679", "Beckingen", "", "DE", "276", "", "09", "00", "10042", "49.4", "6.7", "Europe/Berlin"),("2951793", "Bebra", "", "DE", "276", "", "05", "066", "06632", "50.97445", "9.79562", "Europe/Berlin"),("2951825", "Bayreuth", "Байройт", "DE", "276", "", "02", "094", "09462", "49.94782", "11.57893", "Europe/Berlin"),("2951860", "Bayenthal", "", "DE", "276", "", "07", "053", "05315", "50.91218", "6.96799", "Europe/Berlin"),("2951881", "Bautzen", "Баутцен", "DE", "276", "", "13", "00", "14625", "51.18035", "14.43494", "Europe/Berlin"),("2951923", "Baunatal", "Баунаталь", "DE", "276", "", "05", "066", "06633", "51.25182", "9.40747", "Europe/Berlin"),("2951935", "Baumschulenweg", "", "DE", "276", "", "16", "00", "11000", "52.46583", "13.48523", "Europe/Berlin"),("2952213", "Battenberg", "", "DE", "276", "", "05", "066", "06635", "51.01391", "8.64603", "Europe/Berlin"),("2952252", "Bassum", "Бассум", "DE", "276", "", "06", "00", "03251", "52.85059", "8.72791", "Europe/Berlin"),("2952372", "Barth", "", "DE", "276", "", "12", "00", "13073", "54.36346", "12.72491", "Europe/Berlin"),("2952398", "Barßel", "", "DE", "276", "", "06", "00", "03453", "53.16667", "7.73333", "Europe/Berlin"),("2952406", "Barsinghausen", "", "DE", "276", "", "06", "00", "03241", "52.3", "9.45", "Europe/Berlin"),("2952415", "Barsbüttel", "", "DE", "276", "", "10", "00", "01062", "53.56667", "10.16667", "Europe/Berlin"),("2952444", "Barntrup", "", "DE", "276", "", "07", "057", "05766", "51.99038", "9.11642", "Europe/Berlin"),("2952452", "Barnstorf", "", "DE", "276", "", "06", "00", "03251", "52.71009", "8.50256", "Europe/Berlin"),("2952531", "Barmstedt", "", "DE", "276", "", "10", "00", "01056", "53.79209", "9.76739", "Europe/Berlin"),("2952564", "Barleben", "", "DE", "276", "", "14", "00", "15083", "52.20193", "11.6177", "Europe/Berlin"),("2952633", "Bargteheide", "", "DE", "276", "", "10", "00", "01062", "53.72856", "10.26695", "Europe/Berlin"),("2952814", "Bardowick", "", "DE", "276", "", "06", "00", "03355", "53.29354", "10.38811", "Europe/Berlin"),("2952916", "Bannewitz", "", "DE", "276", "", "13", "00", "14628", "50.99291", "13.71712", "Europe/Berlin"),("2952973", "Bammental", "", "DE", "276", "", "01", "082", "08226", "49.35611", "8.77944", "Europe/Berlin"),("2952984", "Bamberg", "Бамберг", "DE", "276", "", "02", "094", "09461", "49.89873", "10.90067", "Europe/Berlin"),("2953003", "Balve", "", "DE", "276", "", "07", "059", "05962", "51.3315", "7.86424", "Europe/Berlin"),("2953008", "Baltmannsweiler", "", "DE", "276", "", "01", "081", "08116", "48.74215", "9.4494", "Europe/Berlin"),("2953060", "Ballenstedt", "", "DE", "276", "", "14", "00", "15085", "51.719", "11.23265", "Europe/Berlin"),("2953089", "Balingen", "Балинген", "DE", "276", "", "01", "084", "08417", "48.27525", "8.85464", "Europe/Berlin"),("2953136", "Bakum", "", "DE", "276", "", "06", "00", "03460", "52.74118", "8.19546", "Europe/Berlin"),("2953194", "Baiersdorf", "", "DE", "276", "", "02", "095", "09572", "49.65807", "11.03594", "Europe/Berlin"),("2953197", "Baiersbronn", "Байрсброн", "DE", "276", "", "01", "082", "08237", "48.50318", "8.37699", "Europe/Berlin"),("2953222", "Baienfurt", "", "DE", "276", "", "01", "084", "08436", "47.81667", "9.65", "Europe/Berlin"),("2953302", "Baesweiler", "Бесвайлер", "DE", "276", "", "07", "053", "05334", "50.90964", "6.18874", "Europe/Berlin"),("2953310", "Bad Zwischenahn", "Бад-Цвишенан", "DE", "276", "", "06", "00", "03451", "53.18333", "8", "Europe/Berlin"),("2953312", "Bad Wurzach", "", "DE", "276", "", "01", "084", "08436", "47.90799", "9.89686", "Europe/Berlin"),("2953313", "Bad Wörishofen", "", "DE", "276", "", "02", "097", "09778", "48.00674", "10.59666", "Europe/Berlin"),("2953314", "Bad Windsheim", "", "DE", "276", "", "02", "095", "09575", "49.50274", "10.41539", "Europe/Berlin"),("2953315", "Bad Wimpfen", "", "DE", "276", "", "01", "081", "08125", "49.22971", "9.15648", "Europe/Berlin"),("2953317", "Bad Wildungen", "Бад-Вильдунген", "DE", "276", "", "05", "066", "06635", "51.11963", "9.12475", "Europe/Berlin"),("2953320", "Bad Waldsee", "Бад-Вальдзе", "DE", "276", "", "01", "084", "08436", "47.92027", "9.7549", "Europe/Berlin"),("2953321", "Bad Vilbel", "Бад-Фильбель", "DE", "276", "", "05", "064", "06440", "50.17866", "8.73756", "Europe/Berlin"),("2953324", "Bad Tölz", "Бад-Тёльц", "DE", "276", "", "02", "091", "09173", "47.76111", "11.5589", "Europe/Berlin"),("2953336", "Bad Sooden-Allendorf", "", "DE", "276", "", "05", "066", "06636", "51.27092", "9.97483", "Europe/Berlin"),("2953338", "Bad Soden-Salmünster", "", "DE", "276", "", "05", "064", "06435", "50.27574", "9.36705", "Europe/Berlin"),("2953339", "Bad Soden am Taunus", "Бад-Зоден", "DE", "276", "", "05", "064", "06436", "50.1408", "8.50449", "Europe/Berlin"),("2953341", "Bad Segeberg", "Бад-Зегеберг", "DE", "276", "", "10", "00", "01060", "53.94313", "10.30215", "Europe/Berlin"),("2953347", "Bad Schwartau", "Бад-Швартау", "DE", "276", "", "10", "00", "01055", "53.91887", "10.69691", "Europe/Berlin"),("2953348", "Bad Schwalbach", "", "DE", "276", "", "05", "064", "06439", "50.14196", "8.06964", "Europe/Berlin"),("2953355", "Bad Sassendorf", "", "DE", "276", "", "07", "059", "05974", "51.58333", "8.16667", "Europe/Berlin"),("2953357", "Bad Salzungen", "Бад-Зальцунген", "DE", "276", "", "15", "00", "16063", "50.81342", "10.2361", "Europe/Berlin"),("2953358", "Bad Salzuflen", "Бад-Зальцуфлен", "DE", "276", "", "07", "057", "05766", "52.0862", "8.74434", "Europe/Berlin"),("2953362", "Bad Salzdetfurth", "", "DE", "276", "", "06", "00", "03254", "52.05777", "10.0058", "Europe/Berlin"),("2953363", "Bad Säckingen", "Бад-Зекинген", "DE", "276", "", "01", "083", "08337", "47.55371", "7.94612", "Europe/Berlin"),("2953364", "Bad Sachsa", "", "DE", "276", "", "06", "00", "03156", "51.59499", "10.55546", "Europe/Berlin"),("2953367", "Bad Rothenfelde", "", "DE", "276", "", "06", "00", "03459", "52.11667", "8.16667", "Europe/Berlin"),("2953371", "Bad Reichenhall", "Бад-Райхенхалль", "DE", "276", "", "02", "091", "09172", "47.72947", "12.87819", "Europe/Berlin"),("2953374", "Bad Rappenau", "Бад-Раппенау", "DE", "276", "", "01", "081", "08125", "49.23848", "9.1018", "Europe/Berlin"),("2953379", "Bad Pyrmont", "Бад-Пирмонт", "DE", "276", "", "06", "00", "03252", "51.98589", "9.25246", "Europe/Berlin"),("2953384", "Bad Orb", "", "DE", "276", "", "05", "064", "06435", "50.22788", "9.34782", "Europe/Berlin"),("2953385", "Bad Oldesloe", "Бад-Ольдесло", "DE", "276", "", "10", "00", "01062", "53.81167", "10.37417", "Europe/Berlin"),("2953386", "Bad Oeynhausen", "Бад-Эйнхаузен", "DE", "276", "", "07", "057", "05770", "52.20699", "8.80365", "Europe/Berlin"),("2953389", "Bad Neustadt an der Saale", "Бад-Нойштадт-ан-дер-Зале", "DE", "276", "", "02", "096", "09673", "50.32174", "10.20673", "Europe/Berlin"),("2953391", "Bad Neuenahr-Ahrweiler", "Бад-Нойенар-Арвайлер", "DE", "276", "", "08", "00", "07131", "50.54322", "7.1113", "Europe/Berlin"),("2953394", "Bad Nenndorf", "", "DE", "276", "", "06", "00", "03257", "52.33703", "9.37904", "Europe/Berlin"),("2953395", "Bad Nauheim", "Бад-Наухайм", "DE", "276", "", "05", "064", "06440", "50.36463", "8.73859", "Europe/Berlin"),("2953398", "Bad Münstereifel", "Бад-Мюнстерайфель", "DE", "276", "", "07", "053", "05366", "50.55667", "6.76424", "Europe/Berlin"),("2953400", "Bad Münder am Deister", "Бад-Мюндер-ам-Дайстер", "DE", "276", "", "06", "00", "03252", "52.19551", "9.46421", "Europe/Berlin"),("2953402", "Bad Mergentheim", "", "DE", "276", "", "01", "081", "08128", "49.4925", "9.77361", "Europe/Berlin"),("2953404", "Bad Marienberg", "", "DE", "276", "", "08", "00", "07143", "50.64947", "7.94958", "Europe/Berlin"),("2953405", "Bad Lippspringe", "Бад-Липшпринге", "DE", "276", "", "07", "057", "05774", "51.78333", "8.81683", "Europe/Berlin"),("2953407", "Bad Liebenzell", "", "DE", "276", "", "01", "082", "08235", "48.77427", "8.72971", "Europe/Berlin"),("2953408", "Bad Liebenwerda", "", "DE", "276", "", "11", "00", "12062", "51.51826", "13.39459", "Europe/Berlin"),("2953410", "Bad Lauterberg im Harz", "", "DE", "276", "", "06", "00", "03156", "51.63272", "10.47031", "Europe/Berlin"),("2953411", "Bad Lausick", "", "DE", "276", "", "13", "00", "14729", "51.14495", "12.64449", "Europe/Berlin"),("2953412", "Bad Lauchstädt", "", "DE", "276", "", "14", "00", "15088", "51.38652", "11.86956", "Europe/Berlin"),("2953413", "Bad Langensalza", "Бад-Лангензальца", "DE", "276", "", "15", "00", "16064", "51.10771", "10.646", "Europe/Berlin"),("2953416", "Bad Kreuznach", "Бад-Кройцнах", "DE", "276", "", "08", "00", "07133", "49.8414", "7.86713", "Europe/Berlin"),("2953418", "Bad Kösen", "", "DE", "276", "", "14", "00", "15084", "51.13431", "11.72203", "Europe/Berlin"),("2953419", "Bad König", "", "DE", "276", "", "05", "064", "06437", "49.7432", "9.0075", "Europe/Berlin"),("2953424", "Bad Kissingen", "Бад-Киссинген", "DE", "276", "", "02", "096", "09672", "50.20228", "10.07784", "Europe/Berlin"),("2953430", "Bad Iburg", "", "DE", "276", "", "06", "00", "03459", "52.1549", "8.04216", "Europe/Berlin"),("2953434", "Bad Hönningen", "", "DE", "276", "", "08", "00", "07138", "50.51689", "7.31195", "Europe/Berlin"),("2953435", "Bad Honnef", "Бад-Хоннеф", "DE", "276", "", "07", "053", "05382", "50.64336", "7.2278", "Europe/Berlin"),("2953436", "Bad Homburg vor der Höhe", "Бад-Хомбург", "DE", "276", "", "05", "064", "06434", "50.22683", "8.61816", "Europe/Berlin"),("2953439", "Bad Hersfeld", "Бад-Херсфельд", "DE", "276", "", "05", "066", "06632", "50.87197", "9.70891", "Europe/Berlin"),("2953440", "Bad Herrenalb", "", "DE", "276", "", "01", "082", "08235", "48.79787", "8.43617", "Europe/Berlin"),("2953449", "Bad Harzburg", "Бад-Харцбурге", "DE", "276", "", "06", "00", "03153", "51.88268", "10.56157", "Europe/Berlin"),("2953456", "Bad Gandersheim", "", "DE", "276", "", "06", "00", "03155", "51.87167", "10.02537", "Europe/Berlin"),("2953458", "Bad Freienwalde", "", "DE", "276", "", "11", "00", "12064", "52.7873", "14.0304", "Europe/Berlin"),("2953459", "Bad Frankenhausen", "", "DE", "276", "", "15", "00", "16065", "51.35609", "11.09977", "Europe/Berlin"),("2953460", "Bad Feilnbach", "", "DE", "276", "", "02", "091", "09187", "47.77331", "12.00973", "Europe/Berlin"),("2953464", "Bad Essen", "Бад-Эссен", "DE", "276", "", "06", "00", "03459", "52.31667", "8.33333", "Europe/Berlin"),("2953504", "Baden-Baden", "Баден-Баден", "DE", "276", "", "01", "082", "08211", "48.7606", "8.23975", "Europe/Berlin"),("2953507", "Bad Ems", "", "DE", "276", "", "08", "00", "07141", "50.33544", "7.71369", "Europe/Berlin"),("2953520", "Bad Dürrheim", "", "DE", "276", "", "01", "083", "08326", "48.02093", "8.53056", "Europe/Berlin"),("2953521", "Bad Dürrenberg", "", "DE", "276", "", "14", "00", "15088", "51.29545", "12.06583", "Europe/Berlin"),("2953522", "Bad Dürkheim", "Бад-Дюркхайм", "DE", "276", "", "08", "00", "07332", "49.4618", "8.17236", "Europe/Berlin"),("2953524", "Bad Düben", "", "DE", "276", "", "13", "00", "14730", "51.59174", "12.58492", "Europe/Berlin"),("2953525", "Bad Driburg", "Бад-Дрибург", "DE", "276", "", "07", "057", "05762", "51.73297", "9.01969", "Europe/Berlin"),("2953528", "Bad Doberan", "", "DE", "276", "", "12", "00", "13072", "54.10712", "11.90051", "Europe/Berlin"),("2953535", "Bad Brückenau", "", "DE", "276", "", "02", "096", "09672", "50.30853", "9.78985", "Europe/Berlin"),("2953536", "Bad Breisig", "", "DE", "276", "", "08", "00", "07131", "50.50523", "7.28861", "Europe/Berlin"),("2953537", "Bad Bramstedt", "", "DE", "276", "", "10", "00", "01060", "53.9183", "9.88424", "Europe/Berlin"),("2953541", "Bad Blankenburg", "", "DE", "276", "", "15", "00", "16073", "50.68189", "11.27369", "Europe/Berlin"),("2953545", "Bad Berleburg", "Бад-Берлебург", "DE", "276", "", "07", "059", "05970", "51.05224", "8.39227", "Europe/Berlin"),("2953548", "Bad Berka", "", "DE", "276", "", "15", "00", "16071", "50.89982", "11.28245", "Europe/Berlin"),("2953549", "Bad Bergzabern", "", "DE", "276", "DE", "08", "00", "07337", "49.10245", "8.00092", "Europe/Berlin"),("2953552", "Bad Bentheim", "Бад-Бентхайм", "DE", "276", "", "06", "00", "03456", "52.31814", "7.16343", "Europe/Berlin"),("2953558", "Bad Aibling", "Бад-Айблинг", "DE", "276", "", "02", "091", "09187", "47.8638", "12.01055", "Europe/Berlin"),("2953559", "Bad Abbach", "", "DE", "276", "", "02", "092", "09273", "48.93754", "12.04494", "Europe/Berlin"),("2953568", "Backnang", "Бакнанг", "DE", "276", "", "01", "081", "08119", "48.94743", "9.43718", "Europe/Berlin"),("2953770", "Babenhausen", "Бабенхаузен", "DE", "276", "", "05", "064", "06432", "49.96519", "8.95129", "Europe/Berlin"),("2953771", "Babenhausen", "", "DE", "276", "", "02", "097", "09778", "48.14497", "10.25325", "Europe/Berlin"),("2954006", "Aurich", "Аурих", "DE", "276", "", "06", "00", "03452", "53.46919", "7.48232", "Europe/Berlin"),("2954065", "Aulendorf", "", "DE", "276", "", "01", "084", "08436", "47.95083", "9.63745", "Europe/Berlin"),("2954088", "Au in der Hallertau", "", "DE", "276", "", "02", "091", "09178", "48.55838", "11.74138", "Europe/Berlin"),("2954127", "Augustusburg", "", "DE", "276", "", "13", "00", "14522", "50.81192", "13.10197", "Europe/Berlin"),("2954164", "Augustdorf", "", "DE", "276", "", "07", "057", "05766", "51.90944", "8.73173", "Europe/Berlin"),("2954172", "Augsburg", "Аугсбург", "DE", "276", "", "02", "097", "09761", "48.37154", "10.89851", "Europe/Berlin"),("2954602", "Auerbach", "", "DE", "276", "", "13", "00", "14523", "50.51155", "12.40083", "Europe/Berlin"),("2954603", "Auerbach", "", "DE", "276", "", "02", "093", "09371", "49.69201", "11.63327", "Europe/Berlin"),("2954695", "Aue", "Ауэ", "DE", "276", "", "13", "00", "14521", "50.59034", "12.70657", "Europe/Berlin"),("2954932", "Attendorn", "Аттендорн", "DE", "276", "", "07", "059", "05966", "51.12645", "7.90333", "Europe/Berlin"),("2955009", "Aßlar", "", "DE", "276", "", "05", "065", "06532", "50.59163", "8.46273", "Europe/Berlin"),("2955068", "Asperg", "", "DE", "276", "", "01", "081", "08118", "48.90525", "9.13502", "Europe/Berlin"),("2955159", "Aschheim", "", "DE", "276", "", "02", "091", "09184", "48.17112", "11.71675", "Europe/Berlin"),("2955168", "Aschersleben", "Ашерслебен", "DE", "276", "", "14", "00", "15089", "51.75742", "11.46084", "Europe/Berlin"),("2955224", "Ascheberg", "Ашеберг", "DE", "276", "", "07", "055", "05558", "51.78333", "7.61667", "Europe/Berlin"),("2955272", "Aschaffenburg", "Ашаффенбург", "DE", "276", "", "02", "096", "09661", "49.97704", "9.15214", "Europe/Berlin"),("2955315", "Asbach", "", "DE", "276", "", "08", "00", "07138", "50.66667", "7.41667", "Europe/Berlin"),("2955368", "Arzberg", "", "DE", "276", "", "02", "094", "09479", "50.05774", "12.18676", "Europe/Berlin"),("2955394", "Artern", "", "DE", "276", "", "15", "00", "16065", "51.36431", "11.29167", "Europe/Berlin"),("2955421", "Bad Arolsen", "Бад-Арользен", "DE", "276", "", "05", "066", "06635", "51.37982", "9.01445", "Europe/Berlin"),("2955429", "Arnstorf", "", "DE", "276", "", "02", "092", "09277", "48.5584", "12.81674", "Europe/Berlin"),("2955431", "Arnstein", "", "DE", "276", "", "02", "096", "09677", "49.97767", "9.96983", "Europe/Berlin"),("2955439", "Arnstadt", "Арнштадте", "DE", "276", "", "15", "00", "16070", "50.84048", "10.95198", "Europe/Berlin"),("2955471", "Arnsberg", "Арнсберге", "DE", "276", "", "07", "059", "05958", "51.38333", "8.08333", "Europe/Berlin"),("2955745", "Appen", "", "DE", "276", "", "10", "00", "01056", "53.65", "9.73333", "Europe/Berlin"),("2955770", "Apolda", "Апольде", "DE", "276", "", "15", "00", "16071", "51.02624", "11.51638", "Europe/Berlin"),("2955817", "Apen", "", "DE", "276", "", "06", "00", "03451", "53.21667", "7.8", "Europe/Berlin"),("2955936", "Ansbach", "Ансбах", "DE", "276", "", "02", "095", "09561", "49.30481", "10.5931", "Europe/Berlin"),("2955940", "Anröchte", "", "DE", "276", "", "07", "059", "05974", "51.56667", "8.33333", "Europe/Berlin"),("2955951", "Annweiler am Trifels", "", "DE", "276", "", "08", "00", "07337", "49.20613", "7.97527", "Europe/Berlin"),("2956005", "Annaberg-Buchholz", "Аннаберг-Буххольц", "DE", "276", "", "13", "00", "14521", "50.57953", "13.00627", "Europe/Berlin"),("2956014", "Ankum", "", "DE", "276", "", "06", "00", "03459", "52.55", "7.88333", "Europe/Berlin"),("2956018", "Anklam", "", "DE", "276", "", "12", "00", "13075", "53.85637", "13.68965", "Europe/Berlin"),("2956093", "Angermünde", "Ангермюнде", "DE", "276", "", "11", "00", "12073", "53.01499", "13.99924", "Europe/Berlin"),("2956206", "Andernach", "Андернах", "DE", "276", "", "08", "00", "07137", "50.43109", "7.40425", "Europe/Berlin"),("2956378", "Ampfing", "", "DE", "276", "", "02", "091", "09183", "48.254", "12.41515", "Europe/Berlin"),("2956404", "Amöneburg", "", "DE", "276", "", "05", "065", "06534", "50.79595", "8.9233", "Europe/Berlin"),("2956656", "Amberg", "Амберг", "DE", "276", "", "02", "093", "09361", "49.44287", "11.86267", "Europe/Berlin"),("2956710", "Alzey", "", "DE", "276", "", "08", "00", "07331", "49.74657", "8.11513", "Europe/Berlin"),("2956715", "Alzenau in Unterfranken", "", "DE", "276", "", "02", "096", "09671", "50.0888", "9.06455", "Europe/Berlin"),("2956787", "Altusried", "", "DE", "276", "", "02", "097", "09780", "47.8041", "10.21429", "Europe/Berlin"),("2956891", "Altrip", "", "DE", "276", "", "08", "00", "07338", "49.43556", "8.49472", "Europe/Berlin"),("2956940", "Altötting", "", "DE", "276", "", "02", "091", "09171", "48.22533", "12.67665", "Europe/Berlin"),("2956951", "Altomünster", "", "DE", "276", "", "02", "091", "09174", "48.38767", "11.25691", "Europe/Berlin"),("2957021", "Altlußheim", "", "DE", "276", "", "01", "082", "08226", "49.30167", "8.49917", "Europe/Berlin"),("2957051", "Altlandsberg", "", "DE", "276", "", "11", "00", "12064", "52.56503", "13.72815", "Europe/Berlin"),("2957133", "Althengstett", "", "DE", "276", "", "01", "082", "08235", "48.72325", "8.79434", "Europe/Berlin"),("2957185", "Altglienicke", "", "DE", "276", "DE", "16", "00", "11000", "52.41116", "13.5355", "Europe/Berlin"),("2957437", "Altentreptow", "", "DE", "276", "", "12", "00", "13071", "53.69416", "13.26504", "Europe/Berlin"),("2957459", "Altensteig", "", "DE", "276", "", "01", "082", "08235", "48.58649", "8.60395", "Europe/Berlin"),("2957463", "Altenstadt", "", "DE", "276", "", "05", "064", "06440", "50.28747", "8.94373", "Europe/Berlin"),("2957555", "Altenkunstadt", "", "DE", "276", "", "02", "094", "09478", "50.12504", "11.2503", "Europe/Berlin"),("2957567", "Altenkirchen", "", "DE", "276", "", "08", "00", "07132", "50.68594", "7.64176", "Europe/Berlin"),("2957588", "Altenholz", "", "DE", "276", "", "10", "00", "01058", "54.4", "10.13333", "Europe/Berlin"),("2957773", "Altenburg", "Альтенбург", "DE", "276", "", "15", "00", "16077", "50.98763", "12.43684", "Europe/Berlin"),("2957829", "Altenberge", "", "DE", "276", "", "07", "055", "05566", "52.05", "7.46667", "Europe/Berlin"),("2957834", "Altenberg", "", "DE", "276", "", "13", "00", "14628", "50.76556", "13.75334", "Europe/Berlin"),("2957864", "Altenbeken", "", "DE", "276", "", "07", "057", "05774", "51.76455", "8.94201", "Europe/Berlin"),("2957886", "Altena", "Альтена", "DE", "276", "", "07", "059", "05962", "51.29472", "7.67337", "Europe/Berlin"),("2958024", "Altdorf", "", "DE", "276", "", "02", "095", "09574", "49.3856", "11.3573", "Europe/Berlin"),("2958032", "Altdorf", "", "DE", "276", "", "02", "091", "09183", "48.15374", "12.18419", "Europe/Berlin"),("2958085", "Altbach", "", "DE", "276", "", "01", "081", "08116", "48.72268", "9.38078", "Europe/Berlin"),("2958105", "Alsterdorf", "", "DE", "276", "", "04", "00", "02000", "53.61083", "10.01306", "Europe/Berlin"),("2958128", "Alsfeld", "Альсфельд", "DE", "276", "", "05", "065", "06535", "50.75185", "9.27082", "Europe/Berlin"),("2958141", "Alsdorf", "Альсдорф", "DE", "276", "", "07", "053", "05334", "50.87673", "6.16399", "Europe/Berlin"),("2958173", "Alpirsbach", "", "DE", "276", "", "01", "082", "08237", "48.34507", "8.40197", "Europe/Berlin"),("2958188", "Alpen", "", "DE", "276", "", "07", "051", "05170", "51.58333", "6.51667", "Europe/Berlin"),("2958391", "Allersberg", "", "DE", "276", "", "02", "095", "09576", "49.25132", "11.23659", "Europe/Berlin"),("2958429", "Allensbach", "", "DE", "276", "", "01", "083", "08335", "47.71536", "9.07145", "Europe/Berlin"),("2958438", "Allendorf", "", "DE", "276", "", "05", "066", "06635", "51.02995", "8.67232", "Europe/Berlin"),("2958494", "Alheim", "", "DE", "276", "", "05", "066", "06632", "51.03333", "9.66667", "Europe/Berlin"),("2958509", "Algermissen", "", "DE", "276", "", "06", "00", "03254", "52.25332", "9.96915", "Europe/Berlin"),("2958516", "Alfter", "Альфтер", "DE", "276", "", "07", "053", "05382", "50.73333", "7.01667", "Europe/Berlin"),("2958533", "Alfeld", "Альфельд", "DE", "276", "", "06", "00", "03254", "51.98382", "9.81989", "Europe/Berlin"),("2958535", "Alfdorf", "", "DE", "276", "", "01", "081", "08119", "48.84385", "9.71857", "Europe/Berlin"),("2958575", "Aldingen", "", "DE", "276", "", "01", "083", "08327", "48.1", "8.7", "Europe/Berlin"),("2958580", "Aldenhoven", "", "DE", "276", "", "07", "053", "05358", "50.9", "6.28333", "Europe/Berlin"),("2958595", "Albstadt", "Альбштадт", "DE", "276", "", "01", "084", "08417", "48.21644", "9.02596", "Europe/Berlin"),("2958744", "Albbruck", "", "DE", "276", "", "01", "083", "08337", "47.59077", "8.12954", "Europe/Berlin"),("2958781", "Aken", "", "DE", "276", "", "14", "00", "15082", "51.85274", "12.04461", "Europe/Berlin"),("2958831", "Ainring", "", "DE", "276", "", "02", "091", "09172", "47.81667", "12.95", "Europe/Berlin"),("2958904", "Aidlingen", "", "DE", "276", "", "01", "081", "08115", "48.67849", "8.89524", "Europe/Berlin"),("2958975", "Aichach", "Айхах", "DE", "276", "", "02", "097", "09771", "48.45755", "11.13413", "Europe/Berlin"),("2959083", "Ahrensburg", "Аренсбург", "DE", "276", "", "10", "00", "01062", "53.67515", "10.22593", "Europe/Berlin"),("2959084", "Ahrensbök", "", "DE", "276", "", "10", "00", "01055", "54.00862", "10.57434", "Europe/Berlin"),("2959205", "Ahlerstedt", "", "DE", "276", "", "06", "00", "03359", "53.4", "9.45", "Europe/Berlin"),("2959223", "Ahlen", "Ален", "DE", "276", "", "07", "055", "05570", "51.76338", "7.8887", "Europe/Berlin"),("2959279", "Ahaus", "Ахаус", "DE", "276", "", "07", "055", "05554", "52.07936", "7.01344", "Europe/Berlin"),("2959343", "Affing", "", "DE", "276", "", "02", "097", "09771", "48.46667", "10.98333", "Europe/Berlin"),("2959374", "Aerzen", "", "DE", "276", "", "06", "00", "03252", "52.04953", "9.25856", "Europe/Berlin"),("2959390", "Adorf", "", "DE", "276", "", "13", "00", "14523", "50.32011", "12.25986", "Europe/Berlin"),("2959441", "Adlershof", "Адлерсхоф", "DE", "276", "DE", "16", "00", "11000", "52.43548", "13.54825", "Europe/Berlin"),("2959479", "Adendorf", "", "DE", "276", "", "06", "00", "03355", "53.28189", "10.43787", "Europe/Berlin"),("2959508", "Adelsheim", "", "DE", "276", "", "01", "082", "08225", "49.4015", "9.3925", "Europe/Berlin"),("2959514", "Adelsdorf", "", "DE", "276", "", "02", "095", "09575", "49.47022", "10.68522", "Europe/Berlin"),("2959548", "Adelebsen", "", "DE", "276", "", "06", "00", "03152", "51.58272", "9.75461", "Europe/Berlin"),("2959681", "Achim", "Ахим", "DE", "276", "", "06", "00", "03361", "53.01416", "9.0263", "Europe/Berlin"),("2959686", "Achern", "Ахерн", "DE", "276", "", "01", "083", "08317", "48.63115", "8.07607", "Europe/Berlin"),("2959766", "Abtsgmünd", "", "DE", "276", "", "01", "081", "08136", "48.89503", "10.00172", "Europe/Berlin"),("2959842", "Abensberg", "", "DE", "276", "", "02", "092", "09273", "48.81684", "11.8498", "Europe/Berlin"),("2959855", "Abenberg", "", "DE", "276", "", "02", "095", "09576", "49.24282", "10.96401", "Europe/Berlin"),("2959927", "Aalen", "Ален", "DE", "276", "", "01", "081", "08136", "48.83777", "10.0933", "Europe/Berlin"),("3205535", "Höhenkirchen-Siegertsbrunn", "", "DE", "276", "", "02", "091", "09184", "48.01932", "11.71906", "Europe/Berlin"),("3205641", "Weiler-Simmerberg", "", "DE", "276", "", "02", "097", "09776", "47.58261", "9.91352", "Europe/Berlin"),("3205666", "Lauchringen", "", "DE", "276", "", "01", "083", "08337", "47.62699", "8.31442", "Europe/Berlin"),("3205690", "Uhldingen-Mühlhofen", "", "DE", "276", "", "01", "084", "08435", "47.73333", "9.25", "Europe/Berlin"),("3205691", "Ühlingen-Birkendorf", "", "DE", "276", "", "01", "083", "08337", "47.71667", "8.31667", "Europe/Berlin"),("3206149", "Altes Lager", "", "DE", "276", "", "01", "", "", "48.41939", "9.54925", "Europe/Berlin"),("3206150", "Aspach", "", "DE", "276", "", "01", "081", "08119", "48.96667", "9.4", "Europe/Berlin"),("3206188", "Königsbach-Stein", "", "DE", "276", "", "01", "082", "08236", "48.96585", "8.60573", "Europe/Berlin"),("3206254", "Niefern-Öschelbronn", "", "DE", "276", "", "01", "082", "08236", "48.91667", "8.78333", "Europe/Berlin"),("3206285", "Urbach", "", "DE", "276", "", "01", "081", "08119", "48.8168", "9.5769", "Europe/Berlin"),("3206402", "Giesen", "", "DE", "276", "", "06", "00", "03254", "52.19716", "9.8989", "Europe/Berlin"),("3206682", "Mallersdorf-Pfaffenberg", "", "DE", "276", "", "02", "092", "09278", "48.76637", "12.23096", "Europe/Berlin"),("3206934", "Postbauer-Heng", "", "DE", "276", "", "02", "093", "09373", "49.30528", "11.35722", "Europe/Berlin"),("3207077", "Katlenburg-Lindau", "", "DE", "276", "", "06", "00", "03155", "51.68333", "10.1", "Europe/Berlin"),("3207197", "Vellmar", "Фельмар", "DE", "276", "", "05", "066", "06633", "51.35806", "9.47974", "Europe/Berlin"),("3207377", "Möhnesee", "", "DE", "276", "", "07", "059", "05974", "51.5", "8.13333", "Europe/Berlin"),("3207383", "Schieder-Schwalenberg", "", "DE", "276", "", "07", "057", "05766", "51.87713", "9.19538", "Europe/Berlin"),("3207410", "Rödental", "", "DE", "276", "", "02", "094", "09473", "50.29516", "11.04122", "Europe/Berlin"),("3207512", "Bruchmühlbach-Miesau", "", "DE", "276", "", "08", "00", "07335", "49.38333", "7.43333", "Europe/Berlin"),("3207534", "Oestrich-Winkel", "", "DE", "276", "", "08", "", "", "49.99987", "8.00604", "Europe/Berlin"),("3207540", "Schönenberg-Kübelberg", "", "DE", "276", "", "08", "00", "07336", "49.4", "7.36667", "Europe/Berlin"),("3207642", "Merheim", "", "DE", "276", "", "07", "053", "05315", "50.9464", "7.04656", "Europe/Berlin"),("3207806", "Mülheim-Kärlich", "", "DE", "276", "", "08", "00", "07137", "50.3851", "7.4989", "Europe/Berlin"),("3208053", "Florstadt", "", "DE", "276", "", "05", "064", "06440", "50.31667", "8.86667", "Europe/Berlin"),("3208086", "Liederbach", "", "DE", "276", "", "05", "064", "06436", "50.12221", "8.49397", "Europe/Berlin"),("3208118", "Schöffengrund", "", "DE", "276", "", "05", "065", "06532", "50.49345", "8.47183", "Europe/Berlin"),("3208129", "Waldbrunn", "", "DE", "276", "", "05", "065", "06533", "50.51875", "8.10812", "Europe/Berlin"),("3208130", "Waldems", "", "DE", "276", "", "05", "064", "06439", "50.25", "8.33333", "Europe/Berlin"),("3208134", "Walluf", "", "DE", "276", "", "05", "064", "06439", "50.05", "8.15", "Europe/Berlin"),("3208571", "Sylt-Ost", "", "DE", "276", "", "10", "00", "01054", "54.8611", "8.41141", "Europe/Berlin"),("3208606", "Ilsede", "", "DE", "276", "", "06", "00", "03157", "52.2634", "10.19922", "Europe/Berlin"),("3208618", "Sassenburg", "", "DE", "276", "", "06", "00", "03151", "52.51667", "10.63333", "Europe/Berlin"),("3208620", "Sickte", "", "DE", "276", "", "06", "00", "03158", "52.21847", "10.6424", "Europe/Berlin"),("3209001", "Ebersbach", "", "DE", "276", "", "13", "00", "14627", "51.23333", "13.65", "Europe/Berlin"),("3209083", "Henstedt-Ulzburg", "Хенштедт-Ульцбург", "DE", "276", "", "10", "00", "01060", "53.79132", "9.97979", "Europe/Berlin"),("3209262", "Rheinau", "", "DE", "276", "", "01", "083", "08317", "48.66602", "7.93659", "Europe/Berlin"),("3209418", "Reichenau", "", "DE", "276", "", "01", "083", "08335", "47.68885", "9.06355", "Europe/Berlin"),("3209420", "Vogtsburg", "", "DE", "276", "", "01", "083", "08315", "48.09688", "7.64185", "Europe/Berlin"),("3209911", "Burg Hohenstein", "", "DE", "276", "", "05", "064", "06439", "50.19192", "8.05732", "Europe/Berlin"),("3225108", "Ransbach-Baumbach", "", "DE", "276", "", "08", "00", "07143", "50.46496", "7.7283", "Europe/Berlin"),("3225156", "Ludweiler-Warndt", "", "DE", "276", "", "09", "00", "10041", "49.22074", "6.81195", "Europe/Berlin"),("3247449", "Aachen", "Ахен", "DE", "276", "", "07", "053", "05334", "50.77664", "6.08342", "Europe/Berlin"),("3272450", "Ubstadt-Weiher", "", "DE", "276", "", "01", "082", "08215", "49.16296", "8.63165", "Europe/Berlin"),("3272455", "Dannstadt-Schauernheim", "", "DE", "276", "", "08", "00", "07338", "49.44028", "8.30861", "Europe/Berlin"),("3272456", "Sankt Leon-Rot", "", "DE", "276", "", "01", "082", "08226", "49.26593", "8.61803", "Europe/Berlin"),("3272458", "Karlsdorf-Neuthard", "", "DE", "276", "", "01", "082", "08215", "49.13472", "8.53028", "Europe/Berlin"),("3272459", "Graben-Neudorf", "", "DE", "276", "", "01", "082", "08215", "49.16695", "8.49243", "Europe/Berlin"),("3272460", "Mörfelden-Walldorf", "", "DE", "276", "", "05", "064", "06433", "49.99472", "8.58361", "Europe/Berlin"),("3272461", "Linkenheim-Hochstetten", "", "DE", "276", "", "01", "082", "08215", "49.13197", "8.41244", "Europe/Berlin"),("3272463", "Böhl-Iggelheim", "", "DE", "276", "", "08", "00", "07338", "49.38056", "8.30389", "Europe/Berlin"),("3272934", "Alsbach-Hähnlein", "", "DE", "276", "", "05", "064", "06432", "49.73861", "8.59583", "Europe/Berlin"),("3272941", "Riedstadt", "Ридштадт", "DE", "276", "", "05", "064", "06433", "49.83411", "8.49621", "Europe/Berlin"),("3274259", "Leingarten", "", "DE", "276", "", "01", "081", "08125", "49.14639", "9.11694", "Europe/Berlin"),("3274966", "Lauda-Königshofen", "Лауда-Кёнигсхофен", "DE", "276", "", "01", "081", "08128", "49.56526", "9.70816", "Europe/Berlin"),("3336891", "Filderstadt", "Фильдерштадт", "DE", "276", "", "01", "081", "08116", "48.65698", "9.22049", "Europe/Berlin"),("3336892", "Ostfildern", "", "DE", "276", "", "01", "081", "08116", "48.72704", "9.24954", "Europe/Berlin"),("3336893", "Rodgau", "Родгау", "DE", "276", "", "05", "064", "06438", "50.02627", "8.88588", "Europe/Berlin"),("3336894", "Butjadingen", "", "DE", "276", "", "06", "00", "03461", "53.54722", "8.335", "Europe/Berlin"),("3336895", "Kaufungen", "", "DE", "276", "", "05", "066", "06633", "51.28111", "9.61861", "Europe/Berlin"),("3336896", "Jettingen-Scheppach", "", "DE", "276", "", "02", "097", "09774", "48.3896", "10.4381", "Europe/Berlin"),("3337408", "Gropiusstadt", "", "DE", "276", "", "16", "00", "11000", "52.425", "13.46667", "Europe/Berlin"),("3337504", "Seeheim-Jugenheim", "Зехайм-Югенхайм", "DE", "276", "", "05", "064", "06432", "49.765", "8.65194", "Europe/Berlin"),("6545288", "Charlottenburg-Nord", "", "DE", "276", "", "16", "00", "11000", "52.53048", "13.29371", "Europe/Berlin"),("6545310", "Mitte", "", "DE", "276", "", "16", "00", "11000", "52.52003", "13.40489", "Europe/Berlin"),("6545311", "Plänterwald", "", "DE", "276", "", "16", "00", "11000", "52.48106", "13.47276", "Europe/Berlin"),("6547590", "Dallgow-Döberitz", "", "DE", "276", "", "11", "00", "12063", "52.54269", "13.05837", "Europe/Berlin"),("6550659", "Spremberg", "Шпремберг", "DE", "276", "", "11", "00", "12071", "51.56971", "14.37355", "Europe/Berlin"),("6558039", "Rheinstetten", "", "DE", "276", "", "01", "082", "08215", "48.9685", "8.30704", "Europe/Berlin"),("6559224", "Münstertal/Schwarzwald", "", "DE", "276", "", "01", "083", "08315", "47.85472", "7.78417", "Europe/Berlin"),("6639586", "Salem", "", "DE", "276", "", "01", "084", "08435", "47.76258", "9.29031", "Europe/Berlin"),("6691072", "Altstadt Sud", "", "DE", "276", "", "07", "053", "05315", "50.93331", "6.95954", "Europe/Berlin"),("6691073", "Altstadt Nord", "", "DE", "276", "", "07", "053", "05315", "50.93893", "6.95752", "Europe/Berlin"),("6691076", "Neuehrenfeld", "", "DE", "276", "", "07", "053", "05315", "50.95753", "6.93611", "Europe/Berlin"),("6691078", "Bilderstoeckchen", "", "DE", "276", "", "07", "053", "05315", "50.96983", "6.92997", "Europe/Berlin"),("6691734", "Kloster Lehnin", "", "DE", "276", "", "11", "00", "12069", "52.32039", "12.7432", "Europe/Berlin"),("6694210", "Neunkirchen am Brand", "", "DE", "276", "", "02", "094", "09474", "49.61204", "11.12967", "Europe/Berlin"),("6694704", "Rothenburgsort", "", "DE", "276", "", "04", "00", "02000", "53.535", "10.04082", "Europe/Berlin"),("6930414", "Stuttgart-Ost", "", "DE", "276", "", "01", "081", "08111", "48.78363", "9.21032", "Europe/Berlin"),("6941055", "Bochum-Hordel", "", "DE", "276", "", "07", "059", "05911", "51.50168", "7.1756", "Europe/Berlin"),("6944296", "St. Pauli", "", "DE", "276", "", "04", "00", "02000", "53.557", "9.964", "Europe/Berlin"),("7117230", "Schwanau", "", "DE", "276", "", "01", "083", "08317", "48.36669", "7.76244", "Europe/Berlin"),("7274677", "Eidelstedt", "", "DE", "276", "", "04", "00", "02000", "53.60697", "9.90538", "Europe/Berlin"),("7284168", "Paulsstadt", "", "DE", "276", "", "12", "00", "13004", "53.63283", "11.40372", "Europe/Berlin"),("7284171", "Weststadt", "", "DE", "276", "", "12", "00", "13004", "53.63472", "11.39565", "Europe/Berlin"),("7284571", "Eisleben Lutherstadt", "", "DE", "276", "", "14", "00", "15087", "51.52754", "11.54835", "Europe/Berlin"),("7289614", "Halle Neustadt", "", "DE", "276", "", "14", "00", "15002", "51.47924", "11.91605", "Europe/Berlin"),("7290243", "Bergedorf", "Бергедорф", "DE", "276", "", "04", "00", "02000", "53.48462", "10.22904", "Europe/Berlin"),("7290252", "Spandau", "", "DE", "276", "", "16", "00", "11000", "52.5511", "13.19921", "Europe/Berlin"),("7290254", "Berlin Schöneberg", "", "DE", "276", "", "16", "00", "11000", "52.48388", "13.3477", "Europe/Berlin"),("7290255", "Berlin Treptow", "", "DE", "276", "", "16", "00", "11000", "52.49376", "13.44469", "Europe/Berlin"),("7290401", "Niederrad", "", "DE", "276", "", "05", "064", "06412", "50.08309", "8.62852", "Europe/Berlin"),("7302786", "Haselbachtal", "", "DE", "276", "", "13", "00", "14625", "51.2357", "14.02576", "Europe/Berlin"),("7576812", "Rabenau", "", "DE", "276", "", "05", "065", "06531", "50.67753", "8.86425", "Europe/Berlin"),("7732633", "Garbsen-Mitte", "", "DE", "276", "", "06", "00", "03241", "52.42659", "9.60383", "Europe/Berlin"),("7932342", "Barmbek-Nord", "", "DE", "276", "", "04", "00", "02000", "53.6052", "10.03988", "Europe/Berlin"),("7932386", "Farmsen-Berne", "", "DE", "276", "", "04", "00", "02000", "53.60639", "10.11972", "Europe/Berlin"),("8051091", "Fehmarn", "", "DE", "276", "", "10", "00", "01055", "54.4378", "11.19352", "Europe/Berlin"),("8334620", "Hansaviertel", "", "DE", "276", "", "16", "00", "11000", "52.51853", "13.34178", "Europe/Berlin"),("8334621", "Falkenhagener Feld", "", "DE", "276", "", "16", "00", "11000", "52.55191", "13.16802", "Europe/Berlin"),("8334622", "Neu-Hohenschönhausen", "", "DE", "276", "", "16", "00", "11000", "52.56681", "13.51255", "Europe/Berlin"),("8334623", "Waidmannslust", "", "DE", "276", "", "16", "00", "11000", "52.60691", "13.31968", "Europe/Berlin"),("8334624", "Alt-Hohenschönhausen", "", "DE", "276", "", "16", "00", "11000", "52.54608", "13.5013", "Europe/Berlin"),("8334625", "Fennpfuhl", "", "DE", "276", "", "16", "00", "11000", "52.52921", "13.47267", "Europe/Berlin"),("8354429", "Neustadt (Orla)", "", "DE", "276", "", "15", "00", "16075", "50.7364", "11.74619", "Europe/Berlin"),("8354626", "Hamburg-Nord", "", "DE", "276", "", "04", "00", "02000", "53.58935", "9.984", "Europe/Berlin"),("8378906", "Burg Unter-Falkenstein", "", "DE", "276", "", "02", "091", "09187", "47.7044", "12.10466", "Europe/Berlin"),("8593855", "Neustadt/Nord", "", "DE", "276", "", "07", "053", "05315", "50.949", "6.9479", "Europe/Berlin"),("8593856", "Neustadt/Süd", "", "DE", "276", "", "07", "053", "05315", "50.92509", "6.94762", "Europe/Berlin"),("8593860", "Buchforst", "", "DE", "276", "", "07", "053", "05315", "50.95093", "7.00579", "Europe/Berlin"),("8593861", "Kalk", "", "DE", "276", "", "07", "053", "05315", "50.94013", "7.00605", "Europe/Berlin"),("8593865", "Mülheim", "", "DE", "276", "", "07", "053", "05315", "50.96639", "7.00384", "Europe/Berlin"),("8642860", "Gartenstadt", "", "DE", "276", "", "08", "00", "07314", "49.45937", "8.40377", "Europe/Berlin"),("8642861", "Lachen-Speyerdorf", "", "DE", "276", "", "08", "00", "07316", "49.33049", "8.19983", "Europe/Berlin"),("8739828", "Osternienburger Land", "", "DE", "276", "", "14", "00", "15082", "51.8", "12.01667", "Europe/Berlin"),("9072532", "Auf der Horst", "", "DE", "276", "", "06", "00", "03241", "52.41943", "9.60248", "Europe/Berlin"),("9222696", "Dierkow-Neu", "", "DE", "276", "", "12", "00", "13003", "54.10571", "12.16753", "Europe/Berlin"),("9973269", "Solms", "", "DE", "276", "", "05", "065", "06532", "50.5362", "8.40704", "Europe/Berlin"),("11101906", "Westhagen", "", "DE", "276", "", "06", "00", "03103", "52.40425", "10.73939", "Europe/Berlin"),("11258605", "Düsseldorf-Pempelfort", "", "DE", "276", "", "07", "051", "05111", "51.23812", "6.78678", "Europe/Berlin"),("2610020", "Vordingborg", "", "DK", "208", "", "20", "390", "", "55.00801", "11.91057", "Europe/Copenhagen"),("2610075", "Vojens", "", "DK", "208", "", "21", "510", "", "55.24639", "9.30603", "Europe/Copenhagen"),("2610319", "Viborg", "Виборг", "DK", "208", "", "18", "791", "", "56.45319", "9.40201", "Europe/Copenhagen"),("2610613", "Vejle", "Вайле", "DK", "208", "", "21", "630", "", "55.70927", "9.5357", "Europe/Copenhagen"),("2610634", "Vejen", "", "DK", "208", "", "21", "575", "", "55.48117", "9.13795", "Europe/Copenhagen"),("2610726", "Varde", "", "DK", "208", "", "21", "573", "", "55.62112", "8.48069", "Europe/Copenhagen"),("2610734", "Vanløse", "", "DK", "208", "", "17", "101", "", "55.68361", "12.48713", "Europe/Copenhagen"),("2610789", "Vallensbæk", "", "DK", "208", "", "17", "187", "", "55.63333", "12.36667", "Europe/Copenhagen"),("2611132", "Tune", "", "DK", "208", "", "20", "253", "", "55.59528", "12.18319", "Europe/Copenhagen"),("2611189", "Trørød", "", "DK", "208", "", "17", "230", "", "55.83946", "12.54432", "Europe/Copenhagen"),("2611316", "Tranbjerg", "", "DK", "208", "", "18", "751", "", "56.09011", "10.11937", "Europe/Copenhagen"),("2611497", "Tønder", "", "DK", "208", "", "21", "550", "", "54.93306", "8.86674", "Europe/Copenhagen"),("2611755", "Thisted", "", "DK", "208", "", "19", "787", "", "56.95523", "8.69491", "Europe/Copenhagen"),("2611828", "Taastrup", "Тааструп", "DK", "208", "", "17", "169", "", "55.65173", "12.29216", "Europe/Copenhagen"),("2611862", "Tårnby", "", "DK", "208", "DK", "17", "185", "", "55.6303", "12.60035", "Europe/Copenhagen"),("2612045", "Svendborg", "Свеннборге", "DK", "208", "", "21", "479", "", "55.05982", "10.60677", "Europe/Copenhagen"),("2612204", "Struer", "", "DK", "208", "", "18", "671", "", "56.49122", "8.58376", "Europe/Copenhagen"),("2612500", "Støvring", "", "DK", "208", "", "19", "840", "", "56.88536", "9.83839", "Europe/Copenhagen"),("2612629", "Stenløse", "", "DK", "208", "", "17", "240", "", "55.76828", "12.19723", "Europe/Copenhagen"),("2612710", "Stavnsholt", "", "DK", "208", "", "17", "190", "", "55.81479", "12.40545", "Europe/Copenhagen"),("2612862", "Sorø", "", "DK", "208", "", "20", "340", "", "55.43184", "11.55547", "Europe/Copenhagen"),("2613102", "Sønderborg", "Сённенборг", "DK", "208", "", "21", "540", "", "54.90926", "9.80737", "Europe/Copenhagen"),("2613233", "Solrød Strand", "", "DK", "208", "", "20", "269", "", "55.53285", "12.22227", "Europe/Copenhagen"),("2613345", "Smørumnedre", "", "DK", "208", "", "17", "240", "", "55.74232", "12.30276", "Europe/Copenhagen"),("2613451", "Slangerup", "", "DK", "208", "", "17", "250", "", "55.85", "12.18333", "Europe/Copenhagen"),("2613460", "Slagelse", "Слагельсе", "DK", "208", "", "20", "330", "", "55.40276", "11.35459", "Europe/Copenhagen"),("2613694", "Skælskør", "", "DK", "208", "", "20", "330", "", "55.25058", "11.29352", "Europe/Copenhagen"),("2613715", "Skjern", "", "DK", "208", "", "18", "760", "", "55.95", "8.5", "Europe/Copenhagen"),("2613731", "Skive", "Скиве", "DK", "208", "", "18", "779", "", "56.56381", "9.04025", "Europe/Copenhagen"),("2613887", "Skanderborg", "", "DK", "208", "", "18", "746", "", "56.03991", "9.9272", "Europe/Copenhagen"),("2613939", "Skagen", "", "DK", "208", "", "19", "813", "", "57.72093", "10.58394", "Europe/Copenhagen"),("2614030", "Silkeborg", "Силькеборг", "DK", "208", "", "18", "740", "", "56.1697", "9.54508", "Europe/Copenhagen"),("2614172", "Sæby", "", "DK", "208", "", "19", "813", "", "57.33188", "10.52251", "Europe/Copenhagen"),("2614481", "Roskilde", "Роскилле", "DK", "208", "", "20", "265", "", "55.64152", "12.08035", "Europe/Copenhagen"),("2614553", "Rønne", "", "DK", "208", "", "17", "400", "", "55.10091", "14.70664", "Europe/Copenhagen"),("2614600", "Rødovre", "", "DK", "208", "", "17", "175", "", "55.68062", "12.45373", "Europe/Copenhagen"),("2614611", "Rødekro", "", "DK", "208", "", "21", "580", "", "55.07015", "9.31641", "Europe/Copenhagen"),("2614764", "Ringsted", "Рингстед", "DK", "208", "", "20", "329", "", "55.4426", "11.79011", "Europe/Copenhagen"),("2614776", "Ringkøbing", "", "DK", "208", "", "18", "760", "", "56.09006", "8.24402", "Europe/Copenhagen"),("2614813", "Ribe", "", "DK", "208", "", "21", "561", "", "55.33051", "8.76966", "Europe/Copenhagen"),("2615006", "Randers", "Рандерс", "DK", "208", "", "18", "730", "", "56.4607", "10.03639", "Europe/Copenhagen"),("2615730", "Ølstykke", "", "DK", "208", "", "17", "240", "", "55.79567", "12.15509", "Europe/Copenhagen"),("2615876", "Odense", "Оденсе", "DK", "208", "", "21", "461", "", "55.39594", "10.38831", "Europe/Copenhagen"),("2615886", "Odder", "", "DK", "208", "", "18", "727", "", "55.97313", "10.153", "Europe/Copenhagen"),("2615961", "Nykøbing Falster", "Нюкёбинг Фальстер", "DK", "208", "", "20", "376", "", "54.76906", "11.87425", "Europe/Copenhagen"),("2615962", "Nykøbing Sjælland", "", "DK", "208", "", "20", "306", "", "55.92491", "11.67109", "Europe/Copenhagen"),("2615964", "Nykøbing Mors", "", "DK", "208", "", "19", "773", "", "56.79334", "8.85282", "Europe/Copenhagen"),("2616015", "Nyborg", "", "DK", "208", "", "21", "450", "", "55.31274", "10.78964", "Europe/Copenhagen"),("2616038", "Næstved", "Нествед", "DK", "208", "", "20", "370", "", "55.22992", "11.76092", "Europe/Copenhagen"),("2616176", "Nordborg", "", "DK", "208", "", "21", "540", "", "55.05732", "9.7408", "Europe/Copenhagen"),("2616235", "Nørresundby", "", "DK", "208", "", "19", "851", "", "57.04834", "9.9352", "Europe/Copenhagen"),("2616450", "Nivå", "", "DK", "208", "", "17", "210", "", "55.93405", "12.50485", "Europe/Copenhagen"),("2616540", "Neder Holluf", "", "DK", "208", "", "21", "461", "", "55.36451", "10.44824", "Europe/Copenhagen"),("2616599", "Nakskov", "", "DK", "208", "", "20", "360", "", "54.83734", "11.12839", "Europe/Copenhagen"),("2616672", "Munkebo", "", "DK", "208", "", "21", "440", "", "55.46184", "10.55577", "Europe/Copenhagen"),("2616933", "Middelfart", "", "DK", "208", "", "21", "410", "", "55.50591", "9.73054", "Europe/Copenhagen"),("2617072", "Maribo", "", "DK", "208", "", "20", "360", "", "54.77662", "11.50017", "Europe/Copenhagen"),("2617112", "Måløv", "", "DK", "208", "", "17", "151", "", "55.75528", "12.32327", "Europe/Copenhagen"),("2617176", "Lystrup", "", "DK", "208", "", "18", "751", "", "56.2375", "10.23778", "Europe/Copenhagen"),("2617463", "Løgten", "", "DK", "208", "", "18", "751", "", "56.27459", "10.31181", "Europe/Copenhagen"),("2617626", "Værløse", "", "DK", "208", "", "17", "190", "", "55.78251", "12.36856", "Europe/Copenhagen"),("2617658", "Lillerød", "", "DK", "208", "", "17", "201", "", "55.87496", "12.34579", "Europe/Copenhagen"),("2617812", "Lemvig", "", "DK", "208", "", "18", "665", "", "56.54856", "8.31019", "Europe/Copenhagen"),("2618361", "Korsør", "", "DK", "208", "", "20", "330", "", "55.32993", "11.13857", "Europe/Copenhagen"),("2618415", "Køge", "Кеге", "DK", "208", "", "20", "259", "", "55.45802", "12.18214", "Europe/Copenhagen"),("2618425", "Copenhagen", "Копенгаген", "DK", "208", "", "17", "101", "", "55.67594", "12.56553", "Europe/Copenhagen"),("2618468", "Kongens Lyngby", "", "DK", "208", "DK", "17", "173", "", "55.77044", "12.50378", "Europe/Copenhagen"),("2618489", "Kolt", "", "DK", "208", "", "18", "751", "", "56.10845", "10.06986", "Europe/Copenhagen"),("2618528", "Kolding", "Колдинг", "DK", "208", "", "21", "621", "", "55.4904", "9.47216", "Europe/Copenhagen"),("2618944", "Kerteminde", "", "DK", "208", "", "21", "440", "", "55.44903", "10.65769", "Europe/Copenhagen"),("2619154", "Kalundborg", "", "DK", "208", "", "20", "326", "", "55.67954", "11.08864", "Europe/Copenhagen"),("2619216", "Jyllinge", "", "DK", "208", "", "20", "265", "", "55.75843", "12.11227", "Europe/Copenhagen"),("2619377", "Ishøj", "", "DK", "208", "", "17", "183", "", "55.61543", "12.35182", "Europe/Copenhagen"),("2619426", "Ikast", "", "DK", "208", "", "18", "756", "", "56.13883", "9.15768", "Europe/Copenhagen"),("2619528", "Hvidovre", "Хвидовре", "DK", "208", "", "17", "167", "", "55.65719", "12.47364", "Europe/Copenhagen"),("2619650", "Hundested", "", "DK", "208", "", "17", "260", "", "55.96667", "11.86667", "Europe/Copenhagen"),("2619669", "Humlebæk", "", "DK", "208", "", "17", "210", "", "55.9618", "12.5341", "Europe/Copenhagen"),("2619771", "Horsens", "Хорсенс", "DK", "208", "", "18", "615", "", "55.86066", "9.85034", "Europe/Copenhagen"),("2619856", "Hørsholm", "Херсхольм", "DK", "208", "", "17", "223", "", "55.88098", "12.50111", "Europe/Copenhagen"),("2619860", "Hørning", "", "DK", "208", "", "18", "746", "", "56.08701", "10.03716", "Europe/Copenhagen"),("2620046", "Holstebro", "Хольстебро", "DK", "208", "", "18", "661", "", "56.36009", "8.61607", "Europe/Copenhagen"),("2620147", "Holbæk", "Хольбек", "DK", "208", "", "20", "316", "", "55.71354", "11.7169", "Europe/Copenhagen"),("2620167", "Hobro", "", "DK", "208", "", "19", "846", "", "56.64306", "9.79029", "Europe/Copenhagen"),("2620214", "Hjørring", "", "DK", "208", "", "19", "860", "", "57.46417", "9.98229", "Europe/Copenhagen"),("2620279", "Hirtshals", "", "DK", "208", "", "19", "860", "", "57.58812", "9.95922", "Europe/Copenhagen"),("2620288", "Hinnerup", "", "DK", "208", "", "18", "710", "", "56.26608", "10.06299", "Europe/Copenhagen"),("2620320", "Hillerød", "Хиллерод", "DK", "208", "", "17", "219", "", "55.92791", "12.30081", "Europe/Copenhagen"),("2620425", "Herning", "Хернинг", "DK", "208", "", "18", "657", "", "56.13932", "8.97378", "Europe/Copenhagen"),("2620473", "Helsingør", "Хельсингёр", "DK", "208", "", "17", "217", "", "56.03606", "12.6136", "Europe/Copenhagen"),("2620476", "Helsinge", "", "DK", "208", "", "17", "270", "", "56.02283", "12.19752", "Europe/Copenhagen"),("2620528", "Hellebæk", "", "DK", "208", "", "17", "217", "", "56.06823", "12.55782", "Europe/Copenhagen"),("2620583", "Hedensted", "", "DK", "208", "", "18", "766", "", "55.77043", "9.7011", "Europe/Copenhagen"),("2620712", "Haslev", "", "DK", "208", "", "20", "320", "", "55.32346", "11.96389", "Europe/Copenhagen"),("2620835", "Hammel", "", "DK", "208", "", "18", "710", "", "56.25762", "9.86316", "Europe/Copenhagen"),("2620952", "Hadsund", "", "DK", "208", "", "19", "846", "", "56.71482", "10.11682", "Europe/Copenhagen"),("2620956", "Hadsten", "", "DK", "208", "", "18", "710", "", "56.32819", "10.04931", "Europe/Copenhagen"),("2620964", "Haderslev", "Хадерслев", "DK", "208", "", "21", "510", "", "55.25377", "9.48982", "Europe/Copenhagen"),("2621193", "Grindsted", "", "DK", "208", "", "21", "530", "", "55.754", "8.91231", "Europe/Copenhagen"),("2621215", "Greve", "", "DK", "208", "", "20", "253", "", "55.58333", "12.3", "Europe/Copenhagen"),("2621230", "Grenaa", "", "DK", "208", "", "18", "707", "", "56.41578", "10.87825", "Europe/Copenhagen"),("2621356", "Glostrup", "", "DK", "208", "", "17", "161", "", "55.6666", "12.40377", "Europe/Copenhagen"),("2621471", "Gilleleje", "", "DK", "208", "", "17", "270", "", "56.12196", "12.31056", "Europe/Copenhagen"),("2621910", "Frederiksværk", "", "DK", "208", "", "17", "260", "", "55.97073", "12.0225", "Europe/Copenhagen"),("2621912", "Frederikssund", "", "DK", "208", "", "17", "250", "", "55.83956", "12.06896", "Europe/Copenhagen"),("2621927", "Frederikshavn", "Фредериксхавн", "DK", "208", "", "19", "813", "", "57.44073", "10.53661", "Europe/Copenhagen"),("2621942", "Frederiksberg", "Фредериксберг", "DK", "208", "", "17", "147", "", "55.67938", "12.53463", "Europe/Copenhagen"),("2621951", "Fredericia", "Фредерисия", "DK", "208", "", "21", "607", "", "55.56568", "9.75257", "Europe/Copenhagen"),("2621956", "Fredensborg", "", "DK", "208", "", "17", "210", "", "55.97558", "12.40314", "Europe/Copenhagen"),("2622061", "Fløng", "", "DK", "208", "", "17", "169", "", "55.66212", "12.18698", "Europe/Copenhagen"),("2622306", "Farum", "Фарум", "DK", "208", "", "17", "190", "", "55.80858", "12.36066", "Europe/Copenhagen"),("2622383", "Faaborg", "", "DK", "208", "", "21", "430", "", "55.0951", "10.24226", "Europe/Copenhagen"),("2622418", "Espergærde", "", "DK", "208", "", "17", "217", "", "56", "12.56667", "Europe/Copenhagen"),("2622447", "Esbjerg", "Эсбьерг", "DK", "208", "", "21", "561", "", "55.47028", "8.45187", "Europe/Copenhagen"),("2622793", "Ebeltoft", "", "DK", "208", "", "18", "706", "", "56.19442", "10.6821", "Europe/Copenhagen"),("2622937", "Dragør", "", "DK", "208", "", "17", "155", "", "55.59455", "12.66638", "Europe/Copenhagen"),("2623181", "Christianshavn", "", "DK", "208", "", "17", "101", "", "55.67383", "12.59541", "Europe/Copenhagen"),("2623188", "Charlottenlund", "", "DK", "208", "", "17", "157", "", "55.75367", "12.59181", "Europe/Copenhagen"),("2623337", "Brønderslev", "", "DK", "208", "", "19", "810", "", "57.27021", "9.94102", "Europe/Copenhagen"),("2623554", "Brande", "", "DK", "208", "", "18", "756", "", "55.93814", "9.12178", "Europe/Copenhagen"),("2623570", "Bramming", "", "DK", "208", "", "21", "561", "", "55.46946", "8.70007", "Europe/Copenhagen"),("2624019", "Bjerringbro", "", "DK", "208", "", "18", "791", "", "56.37797", "9.66065", "Europe/Copenhagen"),("2624112", "Birkerød", "", "DK", "208", "", "17", "230", "", "55.84759", "12.42791", "Europe/Copenhagen"),("2624144", "Billund", "", "DK", "208", "", "21", "530", "", "55.73349", "9.10785", "Europe/Copenhagen"),("2624341", "Ballerup", "", "DK", "208", "", "17", "151", "", "55.73165", "12.36328", "Europe/Copenhagen"),("2624502", "Assens", "", "DK", "208", "", "21", "420", "", "55.27023", "9.90081", "Europe/Copenhagen"),("2624602", "Aars", "", "DK", "208", "", "19", "820", "", "56.80399", "9.51441", "Europe/Copenhagen"),("2624652", "Århus", "Орхус", "DK", "208", "", "18", "751", "", "56.15674", "10.21076", "Europe/Copenhagen"),("2624886", "Aalborg", "Ольборг", "DK", "208", "", "19", "851", "", "57.048", "9.9187", "Europe/Copenhagen"),("2624906", "Albertslund", "Альбертслунн", "DK", "208", "", "17", "165", "", "55.65691", "12.36381", "Europe/Copenhagen"),("2625070", "Aabenraa", "", "DK", "208", "", "21", "580", "", "55.04434", "9.41741", "Europe/Copenhagen"),("3491736", "Yayas de Viajama", "", "DO", "214", "", "01", "0203", "020301", "18.6071", "-70.92753", "America/Santo_Domingo"),("3491796", "Yamasá", "", "DO", "214", "", "32", "2904", "290401", "18.77315", "-70.02583", "America/Santo_Domingo"),("3491807", "Yaguate", "", "DO", "214", "", "33", "2106", "210601", "18.3353", "-70.18113", "America/Santo_Domingo"),("3491905", "Villa Vásquez", "", "DO", "214", "", "15", "1506", "150601", "19.7411", "-71.4464", "America/Santo_Domingo"),("3491916", "Villa Riva", "", "DO", "214", "", "06", "0605", "060501", "19.18069", "-69.91319", "America/Santo_Domingo"),("3491927", "Villa Jaragua", "", "DO", "214", "", "02", "0304", "030401", "18.49077", "-71.48377", "America/Santo_Domingo"),("3491937", "Villa González", "", "DO", "214", "", "25", "2507", "250701", "19.54057", "-70.78853", "America/Santo_Domingo"),("3491941", "Villa Francisca", "", "DO", "214", "", "34", "0101", "010101", "18.48278", "-69.88914", "America/Santo_Domingo"),("3491946", "Villa Consuelo", "", "DO", "214", "", "34", "0101", "010101", "18.48333", "-69.9", "America/Santo_Domingo"),("3491948", "Villa Bisonó", "", "DO", "214", "", "25", "2502", "250201", "19.56378", "-70.87582", "America/Santo_Domingo"),("3491952", "Villa Altagracia", "Вилья-Альтаграсия", "DO", "214", "", "33", "2105", "210501", "18.67297", "-70.17095", "America/Santo_Domingo"),("3492030", "Vicente Noble", "", "DO", "214", "", "03", "0405", "040501", "18.38443", "-71.18009", "America/Santo_Domingo"),("3492073", "Veragua Arriba", "", "DO", "214", "", "08", "0903", "090301", "19.58333", "-70.33333", "America/Santo_Domingo"),("3492123", "Vallejuelo", "", "DO", "214", "", "23", "2206", "220601", "18.65354", "-71.33431", "America/Santo_Domingo"),("3492477", "Tenares", "", "DO", "214", "", "19", "1902", "190201", "19.37439", "-70.35087", "America/Santo_Domingo"),("3492517", "Tamboril", "", "DO", "214", "", "25", "2506", "250601", "19.48538", "-70.61104", "America/Santo_Domingo"),("3492520", "Tamayo", "", "DO", "214", "", "02", "0303", "030301", "18.3947", "-71.2029", "America/Santo_Domingo"),("3492897", "San Víctor Arriba", "", "DO", "214", "", "08", "0901", "090103", "19.47741", "-70.53585", "America/Santo_Domingo"),("3492908", "Santo Domingo", "Санто-Доминго", "DO", "214", "", "34", "0101", "010101", "18.50012", "-69.98857", "America/Santo_Domingo"),("3492914", "Santiago de los Caballeros", "Сантьяго-де-лос-Кабальерос", "DO", "214", "", "25", "2501", "250101", "19.4517", "-70.69703", "America/Santo_Domingo"),("3492984", "Santa Cruz de El Seibo", "", "DO", "214", "", "28", "0801", "080101", "18.76559", "-69.03886", "America/Santo_Domingo"),("3492985", "Santa Cruz de Barahona", "Санта-Крус-де-Бараона", "DO", "214", "", "03", "0401", "040101", "18.20854", "-71.10077", "America/Santo_Domingo"),("3492997", "Samaná", "", "DO", "214", "", "20", "2001", "200101", "19.20561", "-69.33685", "America/Santo_Domingo"),("3493022", "San Rafael del Yuma", "", "DO", "214", "", "10", "1102", "110201", "18.42993", "-68.6739", "America/Santo_Domingo"),("3493032", "San Pedro de Macorís", "", "DO", "214", "", "24", "2301", "230101", "18.46156", "-69.29718", "America/Santo_Domingo"),("3493081", "San Juan de la Maguana", "", "DO", "214", "", "23", "2201", "220101", "18.80588", "-71.22991", "America/Santo_Domingo"),("3493100", "San José de Ocoa", "", "DO", "214", "", "36", "3101", "310101", "18.54661", "-70.50631", "America/Santo_Domingo"),("3493103", "San José de Las Matas", "", "DO", "214", "", "25", "2505", "250501", "19.33915", "-70.93819", "America/Santo_Domingo"),("3493143", "San Gregorio de Nigua", "", "DO", "214", "", "33", "2107", "210701", "18.38333", "-70.08333", "America/Santo_Domingo"),("3493146", "San Francisco de Macorís", "", "DO", "214", "", "06", "0601", "060101", "19.30099", "-70.25259", "America/Santo_Domingo"),("3493174", "San Fernando de Monte Cristi", "", "DO", "214", "", "15", "1501", "150101", "19.84826", "-71.64597", "America/Santo_Domingo"),("3493175", "Puerto Plata", "", "DO", "214", "", "18", "1801", "180101", "19.79344", "-70.6884", "America/Santo_Domingo"),("3493198", "Sánchez", "", "DO", "214", "", "20", "2002", "200201", "19.2281", "-69.6137", "America/Santo_Domingo"),("3493202", "San Carlos", "", "DO", "214", "", "34", "0101", "010101", "18.48333", "-69.9", "America/Santo_Domingo"),("3493240", "Salvaleón de Higüey", "", "DO", "214", "", "10", "1101", "110101", "18.61501", "-68.70798", "America/Santo_Domingo"),("3493271", "Salsipuedes", "", "DO", "214", "", "19", "1901", "190101", "19.40552", "-70.37985", "America/Santo_Domingo"),("3493283", "Salcedo", "", "DO", "214", "", "19", "1901", "190101", "19.37762", "-70.41762", "America/Santo_Domingo"),("3493383", "Sabaneta", "", "DO", "214", "", "26", "2601", "260101", "19.47793", "-71.34125", "America/Santo_Domingo"),("3493410", "Sabana Yegua", "", "DO", "214", "", "01", "0204", "020401", "18.71667", "-71.01667", "America/Santo_Domingo"),("3493478", "Sabana Iglesia", "", "DO", "214", "", "25", "2509", "250901", "19.32114", "-70.75992", "America/Santo_Domingo"),("3493482", "Sabana Grande de Boyá", "", "DO", "214", "", "32", "2903", "290301", "18.94498", "-69.79331", "America/Santo_Domingo"),("3493568", "Sabana de La Mar", "", "DO", "214", "", "29", "3002", "300201", "19.05934", "-69.38843", "America/Santo_Domingo"),("3493743", "Río San Juan", "", "DO", "214", "", "14", "1404", "140401", "19.64385", "-70.07635", "America/Santo_Domingo"),("3493769", "Río Grande", "", "DO", "214", "", "18", "1802", "180202", "19.66667", "-70.76667", "America/Santo_Domingo"),("3493873", "Rincón", "", "DO", "214", "", "30", "1304", "130402", "19.11938", "-70.40632", "America/Santo_Domingo"),("3494121", "Quisqueya", "", "DO", "214", "", "24", "2305", "230501", "18.55542", "-69.40814", "America/Santo_Domingo"),("3494242", "Punta Cana", "Пунта Кана", "DO", "214", "", "10", "1101", "110103", "18.58182", "-68.40431", "America/Santo_Domingo"),("3494768", "Pimentel", "", "DO", "214", "", "06", "0604", "060401", "19.18416", "-70.10884", "America/Santo_Domingo"),("3494863", "Piedra Blanca", "", "DO", "214", "", "31", "2803", "280301", "18.84431", "-70.31688", "America/Santo_Domingo"),("3495020", "Peralta", "", "DO", "214", "", "01", "0205", "020501", "18.58164", "-70.77029", "America/Santo_Domingo"),("3495137", "Pedernales", "", "DO", "214", "", "16", "1601", "160101", "18.03838", "-71.74403", "America/Santo_Domingo"),("3495159", "Paya", "", "DO", "214", "", "35", "1701", "170105", "18.26196", "-70.2956", "America/Santo_Domingo"),("3495272", "Paraíso", "", "DO", "214", "", "03", "0404", "040401", "17.99172", "-71.16526", "America/Santo_Domingo"),("3495664", "Padre Las Casas", "", "DO", "214", "", "01", "0204", "020401", "18.73172", "-70.93917", "America/Santo_Domingo"),("3495694", "Otra Banda", "", "DO", "214", "", "10", "1101", "110103", "18.65017", "-68.66281", "America/Santo_Domingo"),("3495811", "Nizao", "", "DO", "214", "", "35", "1702", "170201", "18.24697", "-70.21053", "America/Santo_Domingo"),("3495857", "Neiba", "", "DO", "214", "", "02", "0301", "030101", "18.48137", "-71.41965", "America/Santo_Domingo"),("3496021", "Nagua", "Нагуа", "DO", "214", "", "14", "1401", "140101", "19.3832", "-69.8474", "America/Santo_Domingo"),("3496134", "Monte Plata", "Монте Плата", "DO", "214", "", "32", "2901", "290101", "18.807", "-69.78399", "America/Santo_Domingo"),("3496284", "Monción", "", "DO", "214", "", "26", "2603", "260301", "19.41083", "-71.15257", "America/Santo_Domingo"),("3496331", "Moca", "", "DO", "214", "", "08", "0901", "090101", "19.39352", "-70.52598", "America/Santo_Domingo"),("3496396", "Miches", "", "DO", "214", "", "28", "0802", "080201", "18.98364", "-69.0476", "America/Santo_Domingo"),("3496831", "Mao", "Мао", "DO", "214", "", "27", "2701", "270101", "19.55186", "-71.07813", "America/Santo_Domingo"),("3498191", "Los Llanos", "", "DO", "214", "", "24", "2302", "230201", "18.62035", "-69.49581", "America/Santo_Domingo"),("3499602", "Loma de Cabrera", "", "DO", "214", "", "04", "0502", "050201", "19.43333", "-71.6", "America/Santo_Domingo"),("3499748", "Licey al Medio", "", "DO", "214", "", "25", "2504", "250401", "19.43333", "-70.6", "America/Santo_Domingo"),("3500243", "Las Terrenas", "", "DO", "214", "", "20", "2003", "200301", "19.31102", "-69.5428", "America/Santo_Domingo"),("3500367", "Las Matas de Santa Cruz", "", "DO", "214", "", "15", "1504", "150401", "19.67119", "-71.50471", "America/Santo_Domingo"),("3500370", "Las Matas de Farfán", "Лас-Матас-де-Фарфан", "DO", "214", "", "23", "2205", "220501", "18.87309", "-71.51656", "America/Santo_Domingo"),("3500518", "Las Guáranas", "", "DO", "214", "", "06", "0606", "060601", "19.1931", "-70.20835", "America/Santo_Domingo"),("3500957", "La Romana", "Ла-Романа", "DO", "214", "", "12", "1201", "120101", "18.42733", "-68.97285", "America/Santo_Domingo"),("3502052", "La Julia", "", "DO", "214", "", "34", "0101", "010101", "18.46667", "-69.93333", "America/Santo_Domingo"),("3502373", "Laguna Salada", "", "DO", "214", "", "27", "2703", "270301", "19.65043", "-71.08429", "America/Santo_Domingo"),("3502786", "La Descubierta", "", "DO", "214", "", "09", "1003", "100301", "18.57053", "-71.72967", "America/Santo_Domingo"),("3503735", "La Agustina", "", "DO", "214", "", "34", "0101", "010101", "18.5", "-69.93333", "America/Santo_Domingo"),("3503900", "Juan de Herrera", "", "DO", "214", "", "23", "2204", "220401", "18.87402", "-71.2383", "America/Santo_Domingo"),("3504077", "Jimaní", "", "DO", "214", "", "09", "1001", "100101", "18.49169", "-71.85022", "America/Santo_Domingo"),("3504080", "Jima Abajo", "", "DO", "214", "", "30", "1304", "130401", "19.13292", "-70.37607", "America/Santo_Domingo"),("3504158", "Jarabacoa", "Харабакоа", "DO", "214", "", "30", "1303", "130301", "19.11683", "-70.63595", "America/Santo_Domingo"),("3504332", "Imbert", "", "DO", "214", "", "18", "1804", "180401", "19.75371", "-70.82906", "America/Santo_Domingo"),("3504765", "Hato Mayor del Rey", "", "DO", "214", "", "29", "3001", "300101", "18.76278", "-69.25681", "America/Santo_Domingo"),("3504951", "Guaymate", "", "DO", "214", "", "12", "1202", "120201", "18.58793", "-68.97867", "America/Santo_Domingo"),("3505488", "Gaspar Hernández", "", "DO", "214", "", "08", "0903", "090301", "19.62748", "-70.27772", "America/Santo_Domingo"),("3505517", "Galván", "", "DO", "214", "", "02", "0302", "030201", "18.50228", "-71.34271", "America/Santo_Domingo"),("3505778", "Fantino", "", "DO", "214", "", "21", "2403", "240301", "19.12148", "-70.29972", "America/Santo_Domingo"),("3505825", "Estebanía", "", "DO", "214", "", "01", "0210", "021001", "18.4577", "-70.6435", "America/Santo_Domingo"),("3505855", "Esperanza", "", "DO", "214", "", "27", "2702", "270201", "19.58469", "-70.98489", "America/Santo_Domingo"),("3505861", "Esperalvillo", "", "DO", "214", "", "32", "2905", "290501", "18.81509", "-70.03557", "America/Santo_Domingo"),("3505935", "Ensanche Luperón", "", "DO", "214", "", "34", "0101", "010101", "18.5", "-69.9", "America/Santo_Domingo"),("3505947", "Enriquillo", "", "DO", "214", "", "03", "0403", "040301", "17.9", "-71.23333", "America/Santo_Domingo"),("3506034", "El Valle", "", "DO", "214", "", "29", "3003", "300301", "18.97567", "-69.37827", "America/Santo_Domingo"),("3507628", "El Factor", "", "DO", "214", "", "14", "1403", "140301", "19.31834", "-69.88827", "America/Santo_Domingo"),("3508694", "Duvergé", "", "DO", "214", "", "09", "1002", "100201", "18.37839", "-71.52469", "America/Santo_Domingo"),("3508952", "Dajabón", "", "DO", "214", "", "04", "0501", "050101", "19.54878", "-71.70829", "America/Santo_Domingo"),("3509183", "Cristo Rey", "", "DO", "214", "", "34", "0101", "010101", "18.5", "-69.93333", "America/Santo_Domingo"),("3509207", "Cotuí", "", "DO", "214", "", "21", "2401", "240101", "19.05272", "-70.14939", "America/Santo_Domingo"),("3509363", "Constanza", "Констанция", "DO", "214", "", "30", "1302", "130201", "18.90919", "-70.74499", "America/Santo_Domingo"),("3509382", "Concepción de La Vega", "", "DO", "214", "", "30", "1301", "130101", "19.22207", "-70.52956", "America/Santo_Domingo"),("3509386", "Comendador", "", "DO", "214", "", "11", "0701", "070101", "18.8775", "-71.70278", "America/Santo_Domingo"),("3509578", "Ciudad Nueva", "", "DO", "214", "", "34", "0101", "010101", "18.46707", "-69.89339", "America/Santo_Domingo"),("3509882", "Cercado Abajo", "", "DO", "214", "", "23", "2203", "220301", "18.72681", "-71.51742", "America/Santo_Domingo"),("3510065", "Castillo", "", "DO", "214", "", "06", "0603", "060301", "19.20824", "-70.02726", "America/Santo_Domingo"),("3510637", "Cambita Garabitos", "", "DO", "214", "", "33", "2104", "210401", "18.45458", "-70.19907", "America/Santo_Domingo"),("3510885", "Cabral", "", "DO", "214", "", "03", "0402", "040201", "18.25", "-71.21667", "America/Santo_Domingo"),("3511233", "Bonao", "Бонао", "DO", "214", "", "31", "2801", "280101", "18.93687", "-70.40923", "America/Santo_Domingo"),("3511336", "Boca Chica", "Бока Чика", "DO", "214", "", "37", "3204", "320401", "18.45", "-69.6", "America/Santo_Domingo"),("3511540", "San Cristóbal", "", "DO", "214", "", "33", "2101", "210101", "18.41667", "-70.1", "America/Santo_Domingo"),("3511550", "Bella Vista", "", "DO", "214", "", "34", "0101", "010101", "18.45539", "-69.9454", "America/Santo_Domingo"),("3511626", "Bayaguana", "", "DO", "214", "", "32", "2902", "290201", "18.75031", "-69.63525", "America/Santo_Domingo"),("3512067", "Baní", "Бан", "DO", "214", "", "35", "1701", "170101", "18.27964", "-70.33185", "America/Santo_Domingo"),("3512128", "Bajos de Haina", "", "DO", "214", "", "33", "2103", "210301", "18.41538", "-70.03317", "America/Santo_Domingo"),("3512208", "Azua", "Асуа-де-Компостела", "DO", "214", "", "01", "0201", "020101", "18.45319", "-70.7349", "America/Santo_Domingo"),("7874116", "Santo Domingo Oeste", "", "DO", "214", "", "37", "3202", "320201", "18.5", "-70", "America/Santo_Domingo"),("8601412", "Santo Domingo Este", "", "DO", "214", "", "37", "3201", "320101", "18.48847", "-69.85707", "America/Santo_Domingo"),("2474141", "Boumerdas", "Бумердес", "DZ", "12", "", "40", "", "", "36.76639", "3.47717", "Africa/Algiers"),("2474506", "Zeribet el Oued", "", "DZ", "12", "", "19", "", "", "34.68284", "6.51109", "Africa/Algiers"),("2474583", "Zeralda", "", "DZ", "12", "", "55", "", "", "36.71169", "2.84244", "Africa/Algiers"),("2474638", "Zemoura", "", "DZ", "12", "", "51", "", "", "35.72251", "0.75509", "Africa/Algiers"),("2475475", "Touggourt", "Туггурт", "DZ", "12", "", "50", "", "", "33.10527", "6.05796", "Africa/Algiers"),("2475612", "Tolga", "Толга", "DZ", "12", "", "19", "", "", "34.72224", "5.37845", "Africa/Algiers"),("2475687", "Tlemcen", "Тлемсен", "DZ", "12", "", "15", "", "", "34.87833", "-1.315", "Africa/Algiers"),("2475740", "Tizi Rached", "", "DZ", "12", "", "14", "", "", "36.67176", "4.19176", "Africa/Algiers"),("2475744", "Tizi Ouzou", "Тизи-Узу", "DZ", "12", "", "14", "", "", "36.71182", "4.04591", "Africa/Algiers"),("2475752", "Tizi-n-Tleta", "", "DZ", "12", "", "14", "", "", "36.54569", "4.05712", "Africa/Algiers"),("2475764", "Tizi Gheniff", "", "DZ", "12", "", "40", "", "", "36.58839", "3.77445", "Africa/Algiers"),("2475860", "Tissemsilt", "", "DZ", "12", "", "56", "", "", "35.60722", "1.81081", "Africa/Algiers"),("2475921", "Tirmitine", "", "DZ", "12", "", "14", "", "", "36.65393", "3.98143", "Africa/Algiers"),("2476028", "Tipasa", "Типаса", "DZ", "12", "", "55", "", "", "36.58972", "2.4475", "Africa/Algiers"),("2476301", "Tindouf", "Тиндуф", "DZ", "12", "", "54", "", "", "27.67111", "-8.14743", "Africa/Algiers"),("2476396", "Timizart", "", "DZ", "12", "", "14", "", "", "36.8", "4.26667", "Africa/Algiers"),("2476403", "Timimoun", "", "DZ", "12", "", "34", "", "", "29.26388", "0.23098", "Africa/Algiers"),("2476412", "el hed", "", "DZ", "12", "", "18", "", "", "36.65", "4.77361", "Africa/Algiers"),("2476897", "Tiaret", "Тиарет", "DZ", "12", "", "13", "", "", "35.37103", "1.31699", "Africa/Algiers"),("2476915", "Theniet el Had", "", "DZ", "12", "", "35", "", "", "35.87111", "2.02806", "Africa/Algiers"),("2476917", "Thenia", "", "DZ", "12", "", "40", "", "", "36.72544", "3.55665", "Africa/Algiers"),("2477255", "Telerghma", "", "DZ", "12", "", "48", "", "", "36.11653", "6.35434", "Africa/Algiers"),("2477461", "Tébessa", "Тебесса", "DZ", "12", "", "33", "", "", "35.40417", "8.12417", "Africa/Algiers"),("2477462", "Tebesbest", "", "DZ", "12", "", "50", "", "", "33.11667", "6.08333", "Africa/Algiers"),("2477528", "Tazoult-Lambese", "", "DZ", "12", "", "03", "", "", "35.48171", "6.26074", "Africa/Algiers"),("2478216", "Tamanrasset", "Таманрассете", "DZ", "12", "", "53", "", "", "22.785", "5.52278", "Africa/Algiers"),("2478226", "Tamalous", "", "DZ", "12", "", "31", "", "", "36.83763", "6.64018", "Africa/Algiers"),("2478831", "Tadmaït", "", "DZ", "12", "", "40", "", "", "36.74413", "3.90045", "Africa/Algiers"),("2479161", "Sour el Ghozlane", "", "DZ", "12", "", "21", "", "", "36.14766", "3.69123", "Africa/Algiers"),("2479183", "Souma", "", "DZ", "12", "", "20", "", "", "36.51833", "2.90528", "Africa/Algiers"),("2479203", "Lardjem", "", "DZ", "12", "", "56", "", "", "35.74922", "1.54778", "Africa/Algiers"),("2479215", "Souk Ahras", "Сук-Ахрас", "DZ", "12", "", "52", "", "", "36.28639", "7.95111", "Africa/Algiers"),("2479247", "Sougueur", "", "DZ", "12", "", "13", "", "", "35.18568", "1.49612", "Africa/Algiers"),("2479536", "Skikda", "Скикда", "DZ", "12", "", "31", "", "", "36.87617", "6.90921", "Africa/Algiers"),("2479609", "Sig", "", "DZ", "12", "", "26", "", "", "35.52832", "-0.19369", "Africa/Algiers"),("2479916", "Sidi Okba", "", "DZ", "12", "", "19", "", "", "34.74512", "5.89833", "Africa/Algiers"),("2479966", "Sidi Moussa", "", "DZ", "12", "", "20", "", "", "36.60637", "3.08783", "Africa/Algiers"),("2480198", "Sidi Mérouane", "", "DZ", "12", "", "48", "", "", "36.52056", "6.26111", "Africa/Algiers"),("2480368", "Sidi Khaled", "", "DZ", "12", "", "19", "", "", "34.387", "4.98785", "Africa/Algiers"),("2480618", "Sidi ech Chahmi", "", "DZ", "12", "", "09", "", "", "35.65903", "-0.52168", "Africa/Algiers"),("2481007", "Sidi Bel Abbès", "Сиди-Бель-Аббес", "DZ", "12", "", "30", "", "", "35.18994", "-0.63085", "Africa/Algiers"),("2481058", "Sidi Amrane", "", "DZ", "12", "", "50", "", "", "33.49885", "6.00803", "Africa/Algiers"),("2481207", "Sidi Akkacha", "", "DZ", "12", "", "41", "", "", "36.46472", "1.30258", "Africa/Algiers"),("2481246", "Sidi Aïssa", "Сиди-Аисса", "DZ", "12", "", "27", "", "", "35.88548", "3.77236", "Africa/Algiers"),("2481389", "Sidi Abdelli", "", "DZ", "12", "", "15", "", "", "35.06937", "-1.13706", "Africa/Algiers"),("2481639", "Sfizef", "", "DZ", "12", "", "30", "", "", "35.23464", "-0.24435", "Africa/Algiers"),("2481700", "Sétif", "Сетиф", "DZ", "12", "", "12", "", "", "36.19112", "5.41373", "Africa/Algiers"),("2482090", "Sedrata", "", "DZ", "12", "", "52", "", "", "36.12868", "7.53376", "Africa/Algiers"),("2482159", "Seddouk", "", "DZ", "12", "", "18", "", "", "36.54722", "4.68611", "Africa/Algiers"),("2482211", "Sebdou", "", "DZ", "12", "", "15", "", "", "34.63703", "-1.33143", "Africa/Algiers"),("2482390", "Saoula", "", "DZ", "12", "", "55", "", "", "36.70456", "3.02462", "Africa/Algiers"),("2482447", "Salah Bey", "", "DZ", "12", "", "12", "", "", "35.85451", "5.29053", "Africa/Algiers"),("2482572", "Saïda", "Сайда", "DZ", "12", "", "10", "", "", "34.83033", "0.15171", "Africa/Algiers"),("2482886", "Rouissat", "", "DZ", "12", "", "50", "", "", "31.92427", "5.35018", "Africa/Algiers"),("2482908", "Rouiba", "", "DZ", "12", "", "01", "", "", "36.73829", "3.28079", "Africa/Algiers"),("2482939", "Rouached", "", "DZ", "12", "", "48", "", "", "36.45774", "6.04267", "Africa/Algiers"),("2483000", "Robbah", "", "DZ", "12", "", "43", "", "", "33.27967", "6.90984", "Africa/Algiers"),("2483649", "Remchi", "", "DZ", "12", "", "15", "", "", "35.06196", "-1.43362", "Africa/Algiers"),("2483668", "Relizane", "", "DZ", "12", "", "51", "", "", "35.73734", "0.55599", "Africa/Algiers"),("2483746", "Reguiba", "", "DZ", "12", "", "43", "", "", "33.56391", "6.70326", "Africa/Algiers"),("2483757", "Reghaïa", "", "DZ", "12", "", "40", "", "", "36.73587", "3.34018", "Africa/Algiers"),("2483761", "Reggane", "", "DZ", "12", "", "34", "", "", "26.71576", "0.1714", "Africa/Algiers"),("2483936", "Râs el Oued", "Рас-эль-Уэд", "DZ", "12", "", "39", "", "", "35.9441", "5.03107", "Africa/Algiers"),("2483968", "Râs el Aïoun", "", "DZ", "12", "", "03", "", "", "35.67384", "5.6453", "Africa/Algiers"),("2484620", "Oum el Bouaghi", "", "DZ", "12", "", "29", "", "", "35.87541", "7.11353", "Africa/Algiers"),("2484738", "Oumache", "", "DZ", "12", "", "19", "", "", "34.69292", "5.68092", "Africa/Algiers"),("2484835", "Ouled Moussa", "", "DZ", "12", "", "40", "", "", "36.68394", "3.36661", "Africa/Algiers"),("2484846", "Ouled Mimoun", "", "DZ", "12", "", "15", "", "", "34.90472", "-1.03394", "Africa/Algiers"),("2485572", "Oued Sly", "", "DZ", "12", "", "41", "", "", "36.10124", "1.19949", "Africa/Algiers"),("2485582", "Oued Rhiou", "", "DZ", "12", "", "51", "", "", "35.96124", "0.91896", "Africa/Algiers"),("2485618", "Oued Fodda", "", "DZ", "12", "", "41", "", "", "36.18503", "1.53299", "Africa/Algiers"),("2485633", "Oued el Alleug", "", "DZ", "12", "", "55", "", "", "36.55528", "2.79028", "Africa/Algiers"),("2485636", "Oued el Abtal", "Торки-ле-Дюк", "DZ", "12", "", "26", "", "", "35.45595", "0.68778", "Africa/Algiers"),("2485801", "Ouargla", "Уаргла", "DZ", "12", "", "50", "", "", "31.94932", "5.32502", "Africa/Algiers"),("2485926", "Oran", "Оран", "DZ", "12", "", "09", "", "", "35.69111", "-0.64167", "Africa/Algiers"),("2486284", "Nedroma", "", "DZ", "12", "", "15", "", "", "35.01361", "-1.74799", "Africa/Algiers"),("2486505", "Naciria", "", "DZ", "12", "", "40", "", "", "36.74625", "3.83163", "Africa/Algiers"),("2486523", "Naama", "", "DZ", "12", "", "49", "", "", "33.26667", "-0.31667", "Africa/Algiers"),("2486690", "M’Sila", "", "DZ", "12", "", "27", "", "", "35.70583", "4.54194", "Africa/Algiers"),("2486825", "Mouzaïa", "", "DZ", "12", "", "55", "", "", "36.46695", "2.68991", "Africa/Algiers"),("2487134", "Mostaganem", "Мостаганем", "DZ", "12", "", "07", "", "", "35.93115", "0.08918", "Africa/Algiers"),("2487452", "Mila", "", "DZ", "12", "", "48", "", "", "36.45028", "6.26444", "Africa/Algiers"),("2487620", "Metlili Chaamba", "", "DZ", "12", "", "45", "", "", "32.26667", "3.63333", "Africa/Algiers"),("2487772", "Messaad", "Мессад", "DZ", "12", "", "22", "", "", "34.15429", "3.50309", "Africa/Algiers"),("2487805", "Meskiana", "", "DZ", "12", "", "29", "", "", "35.63058", "7.66606", "Africa/Algiers"),("2487852", "Mers el Kebir", "Мерс-эль-Кебир", "DZ", "12", "", "09", "", "", "35.7279", "-0.7081", "Africa/Algiers"),("2487882", "Merouana", "", "DZ", "12", "", "03", "", "", "35.63106", "5.91186", "Africa/Algiers"),("2488202", "Melouza", "", "DZ", "12", "", "39", "", "", "35.97999", "4.18665", "Africa/Algiers"),("2488500", "Mekla", "", "DZ", "12", "", "14", "", "", "36.68178", "4.26378", "Africa/Algiers"),("2488616", "Mehdia", "Махдия", "DZ", "12", "", "13", "", "", "35.43058", "1.75714", "Africa/Algiers"),("2488716", "Megarine", "", "DZ", "12", "", "50", "", "", "33.19195", "6.08695", "Africa/Algiers"),("2488722", "Meftah", "Мефтах", "DZ", "12", "", "20", "", "", "36.6204", "3.22248", "Africa/Algiers"),("2488835", "Médéa", "Медея", "DZ", "12", "", "06", "", "", "36.26417", "2.75393", "Africa/Algiers"),("2489987", "Mazouna", "", "DZ", "12", "", "51", "", "", "36.12232", "0.89865", "Africa/Algiers"),("2490098", "Mascara", "", "DZ", "12", "", "26", "", "", "35.39664", "0.14027", "Africa/Algiers"),("2490180", "Mansourah", "Мансур", "DZ", "12", "", "39", "", "", "36.08725", "4.45192", "Africa/Algiers"),("2490183", "Mansoûra", "Мансура", "DZ", "12", "", "15", "", "", "34.86158", "-1.33935", "Africa/Algiers"),("2490297", "Makouda", "", "DZ", "12", "", "40", "", "", "36.78567", "4.06273", "Africa/Algiers"),("2491042", "L’Arbaa Naït Irathen", "", "DZ", "12", "", "14", "", "", "36.63112", "4.19864", "Africa/Algiers"),("2491050", "Larbaâ", "Ларба", "DZ", "12", "", "03", "", "", "36.56471", "3.15434", "Africa/Algiers"),("2491134", "Lakhdaria", "", "DZ", "12", "", "21", "", "", "36.56463", "3.5933", "Africa/Algiers"),("2491191", "Laghouat", "Лагуат", "DZ", "12", "", "25", "", "", "33.8", "2.86514", "Africa/Algiers"),("2491323", "Ksar el Boukhari", "", "DZ", "12", "", "06", "", "", "35.88889", "2.74905", "Africa/Algiers"),("2491335", "Ksar Chellala", "", "DZ", "12", "", "13", "", "", "35.21222", "2.31889", "Africa/Algiers"),("2491578", "Kolea", "", "DZ", "12", "", "55", "", "", "36.63888", "2.76845", "Africa/Algiers"),("2491889", "Khenchela", "", "DZ", "12", "", "47", "", "", "35.43583", "7.14333", "Africa/Algiers"),("2491911", "Khemis Miliana", "", "DZ", "12", "", "35", "", "", "36.26104", "2.22015", "Africa/Algiers"),("2491913", "Khemis el Khechna", "", "DZ", "12", "", "40", "", "", "36.64997", "3.3308", "Africa/Algiers"),("2492345", "Kerkera", "", "DZ", "12", "", "31", "", "", "36.92917", "6.58556", "Africa/Algiers"),("2492913", "Jijel", "Джиджель", "DZ", "12", "", "24", "", "", "36.82055", "5.76671", "Africa/Algiers"),("2492920", "Djidiouia", "", "DZ", "12", "", "51", "", "", "35.92989", "0.82871", "Africa/Algiers"),("2492991", "Isser", "", "DZ", "12", "", "40", "", "", "36.71859", "3.66924", "Africa/Algiers"),("2493222", "I-n-Salah", "", "DZ", "12", "", "53", "", "", "27.19351", "2.46069", "Africa/Algiers"),("2493456", "Illizi", "", "DZ", "12", "", "46", "", "", "26.48333", "8.46667", "Africa/Algiers"),("2493605", "Ighram", "", "DZ", "12", "", "14", "", "", "36.46295", "4.50532", "Africa/Algiers"),("2493918", "Hennaya", "", "DZ", "12", "", "15", "", "", "34.95139", "-1.36806", "Africa/Algiers"),("2493956", "Héliopolis", "", "DZ", "12", "", "23", "", "", "36.50361", "7.44278", "Africa/Algiers"),("2494029", "Hassi Messaoud", "Хасси-Мессауд", "DZ", "12", "", "50", "", "", "31.68041", "6.07286", "Africa/Algiers"),("2494548", "Hammamet", "Хаммамет", "DZ", "12", "", "33", "", "", "35.44862", "7.95184", "Africa/Algiers"),("2494554", "Hammam Bou Hadjar", "", "DZ", "12", "", "36", "", "", "35.37889", "-0.96778", "Africa/Algiers"),("2494610", "Hamma Bouziane", "", "DZ", "12", "", "04", "", "", "36.41205", "6.59603", "Africa/Algiers"),("2494962", "Hadjout", "", "DZ", "12", "", "55", "", "", "36.51257", "2.41382", "Africa/Algiers"),("2495662", "Guelma", "Гельма", "DZ", "12", "", "23", "", "", "36.46214", "7.42608", "Africa/Algiers"),("2496049", "Ghardaïa", "Гардая", "DZ", "12", "", "45", "", "", "32.49094", "3.67347", "Africa/Algiers"),("2496232", "Frenda", "", "DZ", "12", "", "13", "", "", "35.06544", "1.04945", "Africa/Algiers"),("2496241", "Freha", "", "DZ", "12", "", "14", "", "", "36.75234", "4.3155", "Africa/Algiers"),("2496573", "Feraoun", "", "DZ", "12", "", "18", "", "", "36.56041", "4.85454", "Africa/Algiers"),("2497060", "Es Senia", "", "DZ", "12", "", "09", "", "", "35.64779", "-0.62397", "Africa/Algiers"),("2497323", "El Tarf", "", "DZ", "12", "", "44", "", "", "36.7672", "8.31377", "Africa/Algiers"),("2497411", "El Oued", "Эль-Уэд", "DZ", "12", "", "43", "", "", "33.35608", "6.86319", "Africa/Algiers"),("2497714", "El Malah", "", "DZ", "12", "", "36", "", "", "35.39137", "-1.09238", "Africa/Algiers"),("2497796", "El Kseur", "", "DZ", "12", "", "18", "", "", "36.67942", "4.8555", "Africa/Algiers"),("2497849", "El Khroub", "", "DZ", "12", "", "04", "", "", "36.26333", "6.69361", "Africa/Algiers"),("2497988", "El Kala", "Эль-Калы", "DZ", "12", "", "44", "", "", "36.89556", "8.44333", "Africa/Algiers"),("2498000", "El Idrissia", "", "DZ", "12", "", "22", "", "", "34.44542", "2.52749", "Africa/Algiers"),("2498172", "El Hadjira", "", "DZ", "12", "", "50", "", "", "32.61336", "5.51259", "Africa/Algiers"),("2498183", "El Hadjar", "", "DZ", "12", "", "37", "", "", "36.80377", "7.73684", "Africa/Algiers"),("2498392", "El Eulma", "", "DZ", "12", "", "12", "", "", "36.15281", "5.69016", "Africa/Algiers"),("2498543", "El Bayadh", "", "DZ", "12", "", "42", "", "", "33.68318", "1.01927", "Africa/Algiers"),("2498590", "El Attaf", "Эль-Аттафом", "DZ", "12", "", "35", "", "", "36.22393", "1.67187", "Africa/Algiers"),("2498611", "Chlef", "Шлеф", "DZ", "12", "", "41", "", "", "36.16525", "1.33452", "Africa/Algiers"),("2498667", "El Aouinet", "", "DZ", "12", "", "29", "", "", "35.86691", "7.88673", "Africa/Algiers"),("2498704", "El Amria", "", "DZ", "12", "", "36", "", "", "35.52439", "-1.01577", "Africa/Algiers"),("2498752", "El Affroun", "", "DZ", "12", "", "55", "", "", "36.4701", "2.62528", "Africa/Algiers"),("2498766", "El Achir", "", "DZ", "12", "", "39", "", "", "36.06386", "4.62744", "Africa/Algiers"),("2498775", "El Abiodh Sidi Cheikh", "", "DZ", "12", "", "42", "", "", "32.893", "0.54839", "Africa/Algiers"),("2498782", "El Abadia", "", "DZ", "12", "", "35", "", "", "36.26951", "1.68609", "Africa/Algiers"),("2498954", "Ech Chettia", "", "DZ", "12", "", "41", "", "", "36.19591", "1.25537", "Africa/Algiers"),("2499055", "Drean", "", "DZ", "12", "", "37", "", "", "36.68482", "7.75111", "Africa/Algiers"),("2499104", "Draa el Mizan", "Дра-эль-Мизан", "DZ", "12", "", "21", "", "", "36.53628", "3.8334", "Africa/Algiers"),("2499116", "Draa Ben Khedda", "", "DZ", "12", "", "40", "", "", "36.73436", "3.96223", "Africa/Algiers"),("2499193", "Douera", "", "DZ", "12", "", "55", "", "", "36.67", "2.94444", "Africa/Algiers"),("2500017", "Djelfa", "", "DZ", "12", "", "22", "", "", "34.67279", "3.263", "Africa/Algiers"),("2500282", "Djamaa", "", "DZ", "12", "", "50", "", "", "33.53388", "5.99306", "Africa/Algiers"),("2500401", "Didouche Mourad", "", "DZ", "12", "", "04", "", "", "36.4525", "6.63639", "Africa/Algiers"),("2500583", "Dellys", "", "DZ", "12", "", "40", "", "", "36.91716", "3.91311", "Africa/Algiers"),("2500737", "Debila", "", "DZ", "12", "", "43", "", "", "33.51667", "6.95", "Africa/Algiers"),("2500889", "Dar el Beïda", "Дар-эль-Бейда", "DZ", "12", "", "01", "", "", "36.71333", "3.2125", "Africa/Algiers"),("2500904", "Dar Chioukh", "", "DZ", "12", "", "22", "", "", "34.89638", "3.48543", "Africa/Algiers"),("2501152", "Constantine", "", "DZ", "12", "", "04", "", "", "36.365", "6.61472", "Africa/Algiers"),("2501289", "Chorfa", "Чорфа", "DZ", "12", "", "21", "", "", "36.36505", "4.32636", "Africa/Algiers"),("2501323", "Chiffa", "", "DZ", "12", "", "20", "", "", "36.46293", "2.73873", "Africa/Algiers"),("2501362", "Chetouane", "", "DZ", "12", "", "15", "", "", "34.92129", "-1.29512", "Africa/Algiers"),("2501404", "Cheria", "", "DZ", "12", "", "33", "", "", "35.27306", "7.75194", "Africa/Algiers"),("2501465", "Cheraga", "", "DZ", "12", "", "55", "", "", "36.76775", "2.95924", "Africa/Algiers"),("2501508", "Chemini", "", "DZ", "12", "", "14", "", "", "36.6", "4.61667", "Africa/Algiers"),("2501541", "Chelghoum el Aïd", "", "DZ", "12", "", "48", "", "", "36.16286", "6.16651", "Africa/Algiers"),("2501680", "Chebli", "", "DZ", "12", "", "20", "", "", "36.57722", "3.00917", "Africa/Algiers"),("2501767", "Charef", "", "DZ", "12", "", "22", "", "", "34.62098", "2.79503", "Africa/Algiers"),("2501873", "Chabet el Ameur", "", "DZ", "12", "", "40", "", "", "36.63709", "3.69474", "Africa/Algiers"),("2502034", "Brezina", "", "DZ", "12", "", "42", "", "", "33.09892", "1.26082", "Africa/Algiers"),("2502239", "Bou Tlelis", "", "DZ", "12", "", "09", "", "", "35.57272", "-0.8996", "Africa/Algiers"),("2502686", "Boumahra Ahmed", "", "DZ", "12", "", "23", "", "", "36.45833", "7.51389", "Africa/Algiers"),("2502924", "Boukadir", "Бу-Кадир", "DZ", "12", "", "41", "", "", "36.06629", "1.12602", "Africa/Algiers"),("2502939", "Bou Ismaïl", "Бу-Исмаил", "DZ", "12", "", "55", "", "", "36.64262", "2.69007", "Africa/Algiers"),("2502958", "Bouïra", "", "DZ", "12", "", "21", "", "", "36.37489", "3.902", "Africa/Algiers"),("2502962", "Bouinan", "", "DZ", "12", "", "20", "", "", "36.53167", "2.99194", "Africa/Algiers"),("2503033", "Bou Hanifia el Hamamat", "", "DZ", "12", "", "26", "", "", "35.31473", "-0.05037", "Africa/Algiers"),("2503147", "Bougara", "", "DZ", "12", "", "20", "", "", "36.54178", "3.081", "Africa/Algiers"),("2503156", "Bougaa", "", "DZ", "12", "", "12", "", "", "36.33293", "5.08843", "Africa/Algiers"),("2503181", "Boufarik", "", "DZ", "12", "", "20", "", "", "36.57413", "2.91214", "Africa/Algiers"),("2503229", "Boudouaou", "", "DZ", "12", "", "40", "", "", "36.72735", "3.40995", "Africa/Algiers"),("2503237", "Boudjima", "", "DZ", "12", "", "14", "", "", "36.80218", "4.15187", "Africa/Algiers"),("2503468", "Boû Arfa", "", "DZ", "12", "", "20", "", "", "36.46298", "2.81464", "Africa/Algiers"),("2503620", "Bordj Zemoura", "", "DZ", "12", "", "39", "", "", "36.27462", "4.85668", "Africa/Algiers"),("2503654", "Bordj Ghdir", "", "DZ", "12", "", "39", "", "", "35.90111", "4.89806", "Africa/Algiers"),("2503661", "Bordj el Kiffan", "", "DZ", "12", "", "01", "", "", "36.74871", "3.19249", "Africa/Algiers"),("2503701", "Bordj Bou Arreridj", "", "DZ", "12", "", "39", "", "", "36.07321", "4.76108", "Africa/Algiers"),("2503755", "Boghni", "", "DZ", "12", "", "14", "", "", "36.54222", "3.95306", "Africa/Algiers"),("2503769", "Blida", "Блида", "DZ", "12", "", "20", "", "", "36.47004", "2.8277", "Africa/Algiers"),("2503826", "Biskra", "Бискра", "DZ", "12", "", "19", "", "", "34.85038", "5.72805", "Africa/Algiers"),("2503847", "Birkhadem", "", "DZ", "12", "", "01", "", "", "36.71499", "3.05002", "Africa/Algiers"),("2503852", "Birine", "", "DZ", "12", "", "22", "", "", "35.635", "3.225", "Africa/Algiers"),("2503874", "Bir el Djir", "", "DZ", "12", "", "09", "", "", "35.72", "-0.545", "Africa/Algiers"),("2503878", "Bir el Ater", "", "DZ", "12", "", "33", "", "", "34.74488", "8.06024", "Africa/Algiers"),("2504072", "Besbes", "", "DZ", "12", "", "44", "", "", "36.70222", "7.84722", "Africa/Algiers"),("2504099", "Berrouaghia", "", "DZ", "12", "", "06", "", "", "36.13516", "2.91085", "Africa/Algiers"),("2504110", "Berriane", "", "DZ", "12", "", "45", "", "", "32.82648", "3.76689", "Africa/Algiers"),("2504136", "Berrahal", "", "DZ", "12", "", "37", "", "", "36.83528", "7.45333", "Africa/Algiers"),("2504385", "Bensekrane", "", "DZ", "12", "", "15", "", "", "35.07465", "-1.22431", "Africa/Algiers"),("2504486", "Ben Mehidi", "", "DZ", "12", "", "44", "", "", "36.76967", "7.90641", "Africa/Algiers"),("2504581", "Beni Saf", "", "DZ", "12", "", "36", "", "", "35.30099", "-1.38226", "Africa/Algiers"),("2504616", "Beni Mester", "", "DZ", "12", "", "15", "", "", "34.87045", "-1.42319", "Africa/Algiers"),("2504622", "Beni Mered", "", "DZ", "12", "", "20", "", "", "36.52389", "2.86131", "Africa/Algiers"),("2504703", "Beni Douala", "", "DZ", "12", "", "14", "", "", "36.61954", "4.08282", "Africa/Algiers"),("2504739", "Beni Amrane", "", "DZ", "12", "", "40", "", "", "36.66774", "3.59115", "Africa/Algiers"),("2505329", "Bejaïa", "", "DZ", "12", "", "18", "", "", "36.75587", "5.08433", "Africa/Algiers"),("2505530", "Béchar", "Бешаре", "DZ", "12", "", "38", "", "", "31.61667", "-2.21667", "Africa/Algiers"),("2505572", "Batna", "Батна", "DZ", "12", "", "03", "", "", "35.55597", "6.17414", "Africa/Algiers"),("2505629", "Barika", "Барика", "DZ", "12", "", "03", "", "", "35.38901", "5.36584", "Africa/Algiers"),("2505651", "Barbacha", "", "DZ", "12", "", "18", "", "", "36.56667", "4.96667", "Africa/Algiers"),("2505653", "Baraki", "", "DZ", "12", "", "55", "", "", "36.66655", "3.09606", "Africa/Algiers"),("2505854", "Bab Ezzouar", "", "DZ", "12", "", "01", "", "", "36.72615", "3.18291", "Africa/Algiers"),("2505915", "Azzaba", "", "DZ", "12", "", "31", "", "", "36.73944", "7.10528", "Africa/Algiers"),("2506043", "Azazga", "", "DZ", "12", "", "14", "", "", "36.74472", "4.37222", "Africa/Algiers"),("2506404", "Arris", "", "DZ", "12", "", "03", "", "", "35.25881", "6.34706", "Africa/Algiers"),("2506519", "Arhribs", "", "DZ", "12", "", "14", "", "", "36.79361", "4.31158", "Africa/Algiers"),("2506623", "Arbatache", "", "DZ", "12", "", "40", "", "", "36.63773", "3.37127", "Africa/Algiers"),("2506795", "Aoulef", "", "DZ", "12", "", "34", "", "", "26.96667", "1.08333", "Africa/Algiers"),("2506999", "Annaba", "Аннаба", "DZ", "12", "", "37", "", "", "36.9", "7.76667", "Africa/Algiers"),("2507155", "Ammi Moussa", "", "DZ", "12", "", "51", "", "", "35.86781", "1.11143", "Africa/Algiers"),("2507169", "Amizour", "", "DZ", "12", "", "18", "", "", "36.64022", "4.90131", "Africa/Algiers"),("2507480", "Algiers", "Алжир", "DZ", "12", "", "01", "", "", "36.7525", "3.04197", "Africa/Algiers"),("2507646", "Akbou", "", "DZ", "12", "", "18", "", "", "36.4575", "4.53494", "Africa/Algiers"),("2507877", "Aïn Touta", "", "DZ", "12", "", "03", "", "", "35.37675", "5.90001", "Africa/Algiers"),("2507901", "Aïn Temouchent", "", "DZ", "12", "", "36", "", "", "35.29749", "-1.14037", "Africa/Algiers"),("2507912", "Aïn Taya", "", "DZ", "12", "", "01", "", "", "36.79333", "3.28694", "Africa/Algiers"),("2507926", "Aïn Smara", "", "DZ", "12", "", "04", "", "", "36.2674", "6.50135", "Africa/Algiers"),("2507943", "Aïn Sefra", "", "DZ", "12", "", "49", "", "", "32.75", "-0.58333", "Africa/Algiers"),("2507972", "Aïn Oussera", "", "DZ", "12", "", "22", "", "", "35.45139", "2.90583", "Africa/Algiers"),("2508010", "’Aïn Merane", "", "DZ", "12", "", "51", "", "", "36.16277", "0.97037", "Africa/Algiers"),("2508059", "Aïn Kercha", "", "DZ", "12", "", "29", "", "", "35.92472", "6.69528", "Africa/Algiers"),("2508102", "Aïn Fakroun", "", "DZ", "12", "", "29", "", "", "35.97108", "6.87374", "Africa/Algiers"),("2508119", "’Aïn el Turk", "Айн-эль-Терк", "DZ", "12", "", "09", "", "", "35.74381", "-0.7693", "Africa/Algiers"),("2508130", "’Aïn el Melh", "Айн-эль-Мельх", "DZ", "12", "", "27", "", "", "34.84146", "4.16383", "Africa/Algiers"),("2508152", "’Aïn el Hammam", "Айн-эль-Хаммам", "DZ", "12", "", "14", "", "", "36.56471", "4.30619", "Africa/Algiers"),("2508157", "‘Aïn el Hadjel", "", "DZ", "12", "", "27", "", "", "35.67003", "3.88153", "Africa/Algiers"),("2508162", "’Aïn el Hadjar", "", "DZ", "12", "", "10", "", "", "34.75846", "0.14528", "Africa/Algiers"),("2508174", "Aïn el Bya", "", "DZ", "12", "", "09", "", "", "35.80389", "-0.30178", "Africa/Algiers"),("2508180", "’Aïn el Berd", "", "DZ", "12", "", "30", "", "", "35.36395", "-0.51279", "Africa/Algiers"),("2508184", "’Aïn el Bell", "Айн-эль-Белла", "DZ", "12", "", "22", "", "", "34.34381", "3.22475", "Africa/Algiers"),("2508225", "’Aïn Deheb", "", "DZ", "12", "", "13", "", "", "34.84218", "1.54697", "Africa/Algiers"),("2508228", "Aïn Defla", "", "DZ", "12", "", "35", "", "", "36.26405", "1.9679", "Africa/Algiers"),("2508262", "’Aïn Boucif", "", "DZ", "12", "", "06", "", "", "35.89123", "3.1585", "Africa/Algiers"),("2508268", "Aïn Bessem", "", "DZ", "12", "", "21", "", "", "36.29333", "3.67319", "Africa/Algiers"),("2508275", "’Aïn Benian", "", "DZ", "12", "", "55", "", "", "36.80277", "2.92185", "Africa/Algiers"),("2508287", "Aïn Beïda", "", "DZ", "12", "", "29", "", "", "35.79639", "7.39278", "Africa/Algiers"),("2508297", "Aïn Arnat", "", "DZ", "12", "", "12", "", "", "36.18683", "5.31347", "Africa/Algiers"),("2508309", "’Aïn Abid", "", "DZ", "12", "", "04", "", "", "36.23194", "6.94333", "Africa/Algiers"),("2508737", "Aflou", "", "DZ", "12", "", "25", "", "", "34.11279", "2.10228", "Africa/Algiers"),("2508813", "Adrar", "Адрар", "DZ", "12", "", "34", "", "", "27.87429", "-0.29388", "Africa/Algiers"),("2509031", "Abou el Hassan", "", "DZ", "12", "", "41", "", "", "36.41657", "1.19616", "Africa/Algiers"),("6698360", "BABOR - VILLE", "", "DZ", "12", "", "12", "", "", "36.48994", "5.5393", "Africa/Algiers"),("10177367", "Boumagueur", "", "DZ", "12", "", "03", "", "", "35.50527", "5.5525", "Africa/Algiers"),("587450", "Võru", "", "EE", "233", "", "21", "0919", "", "57.83389", "27.01944", "Europe/Tallinn"),("587577", "Viljandi", "Вильянди", "EE", "233", "", "20", "0897", "", "58.36389", "25.59", "Europe/Tallinn"),("587876", "Valga", "", "EE", "233", "", "19", "0854", "", "57.77781", "26.0473", "Europe/Tallinn"),("588153", "Türi", "", "EE", "233", "", "04", "0835", "08358595", "58.80861", "25.4325", "Europe/Tallinn"),("588335", "Tartu", "Тарту", "EE", "233", "", "18", "0795", "", "58.38062", "26.72509", "Europe/Tallinn"),("588348", "Tapa", "", "EE", "233", "", "08", "0790", "07908140", "59.26056", "25.95861", "Europe/Tallinn"),("588409", "Tallinn", "Таллин", "EE", "233", "", "01", "0784", "07840298", "59.43696", "24.75353", "Europe/Tallinn"),("588686", "Sillamäe", "Силламяэ", "EE", "233", "", "03", "0735", "", "59.39697", "27.76331", "Europe/Tallinn"),("588780", "Saue", "", "EE", "233", "", "01", "0728", "", "59.32028", "24.5525", "Europe/Tallinn"),("589116", "Rapla", "", "EE", "233", "", "13", "0669", "06696826", "59.00722", "24.79278", "Europe/Tallinn"),("589165", "Rakvere", "Раквере", "EE", "233", "", "08", "0663", "", "59.34639", "26.35583", "Europe/Tallinn"),("589375", "Põlva", "", "EE", "233", "", "12", "0621", "06216536", "58.06028", "27.06944", "Europe/Tallinn"),("589580", "Pärnu", "Пярну", "EE", "233", "", "11", "0625", "", "58.38588", "24.49711", "Europe/Tallinn"),("589709", "Paide", "", "EE", "233", "", "04", "0566", "", "58.88556", "25.55722", "Europe/Tallinn"),("590031", "Narva", "Нарва", "EE", "233", "", "03", "0511", "", "59.37722", "28.19028", "Europe/Tallinn"),("590447", "Maardu", "Маарду", "EE", "233", "", "01", "0446", "", "59.47667", "25.025", "Europe/Tallinn"),("590939", "Kuressaare", "", "EE", "233", "", "14", "0349", "", "58.24806", "22.50389", "Europe/Tallinn"),("591260", "Kohtla-Järve", "Кохтла-Ярве", "EE", "233", "", "03", "0322", "03220265", "59.39861", "27.27306", "Europe/Tallinn"),("591313", "Kiviõli", "", "EE", "233", "", "03", "0309", "", "59.35306", "26.97111", "Europe/Tallinn"),("591472", "Keila", "", "EE", "233", "", "01", "0296", "", "59.30361", "24.41306", "Europe/Tallinn"),("591632", "Kärdla", "", "EE", "233", "", "02", "0204", "02043895", "58.99778", "22.74917", "Europe/Tallinn"),("591893", "Jõhvi", "", "EE", "233", "", "03", "0251", "02512270", "59.35917", "27.42111", "Europe/Tallinn"),("591902", "Jõgeva", "", "EE", "233", "", "05", "0249", "", "58.74667", "26.39389", "Europe/Tallinn"),("592225", "Haapsalu", "", "EE", "233", "", "07", "0183", "", "58.94306", "23.54139", "Europe/Tallinn"),("592279", "Elva", "", "EE", "233", "", "18", "0170", "", "58.2225", "26.42111", "Europe/Tallinn"),("346030", "Ziftá", "Зифта", "EG", "818", "", "05", "", "", "30.7142", "31.24425", "Africa/Cairo"),("347236", "Toukh", "Тух", "EG", "818", "", "12", "", "", "30.35394", "31.20071", "Africa/Cairo"),("347497", "Tanda", "Танта", "EG", "818", "", "05", "", "", "30.78847", "31.00192", "Africa/Cairo"),("347542", "Ţāmiyah", "", "EG", "818", "", "04", "", "", "29.47639", "30.96119", "Africa/Cairo"),("347591", "Ţalkhā", "", "EG", "818", "", "01", "", "", "31.0539", "31.37787", "Africa/Cairo"),("347612", "Talā", "Тале", "EG", "818", "", "09", "", "", "30.68025", "30.94292", "Africa/Cairo"),("347634", "Ţahţā", "Тахта", "EG", "818", "", "24", "", "", "26.7693", "31.50214", "Africa/Cairo"),("347749", "Sumusţā as Sulţānī", "", "EG", "818", "", "18", "", "", "28.91667", "30.85", "Africa/Cairo"),("347796", "Sohag", "Сохаг", "EG", "818", "", "24", "", "", "26.55695", "31.69478", "Africa/Cairo"),("347863", "Siwa Oasis", "", "EG", "818", "", "22", "", "", "29.2032", "25.51965", "Africa/Cairo"),("348112", "Sīdī Sālim", "", "EG", "818", "", "21", "", "", "31.27133", "30.78617", "Africa/Cairo"),("349114", "Shirbīn", "", "EG", "818", "", "01", "", "", "31.19688", "31.5243", "Africa/Cairo"),("349156", "Shibīn al Qanāţir", "", "EG", "818", "", "12", "", "", "30.31269", "31.32018", "Africa/Cairo"),("349158", "Shibīn al Kawm", "", "EG", "818", "", "09", "", "", "30.55258", "31.00904", "Africa/Cairo"),("349340", "Sharm el-Sheikh", "", "EG", "818", "", "26", "", "", "27.91582", "34.32995", "Africa/Cairo"),("349715", "Samannūd", "", "EG", "818", "", "05", "", "", "30.9616", "31.24069", "Africa/Cairo"),("349717", "Samālūţ", "", "EG", "818", "", "10", "", "", "28.31214", "30.71007", "Africa/Cairo"),("350203", "Rosetta", "", "EG", "818", "", "03", "", "", "31.39951", "30.41718", "Africa/Cairo"),("350207", "Ras Gharib", "", "EG", "818", "", "02", "", "", "28.35831", "33.07829", "Africa/Cairo"),("350370", "Quwaysinā", "", "EG", "818", "", "09", "", "", "30.56482", "31.15777", "Africa/Cairo"),("350376", "Quţūr", "", "EG", "818", "", "05", "", "", "30.97225", "30.95614", "Africa/Cairo"),("350422", "Kousa", "", "EG", "818", "", "23", "", "", "25.91407", "32.76362", "Africa/Cairo"),("350550", "Qinā", "", "EG", "818", "", "23", "", "", "26.16418", "32.72671", "Africa/Cairo"),("350789", "Qalyūb", "Кальюб", "EG", "818", "", "12", "", "", "30.17922", "31.2056", "Africa/Cairo"),("351434", "Naj‘ Ḩammādī", "", "EG", "818", "", "23", "", "", "26.04949", "32.24142", "Africa/Cairo"),("352344", "Minyat an Naşr", "", "EG", "818", "", "01", "", "", "31.12624", "31.64313", "Africa/Cairo"),("352354", "Minūf", "", "EG", "818", "", "09", "", "", "30.46579", "30.93164", "Africa/Cairo"),("352628", "Maţāy", "", "EG", "818", "", "10", "", "", "28.41899", "30.77924", "Africa/Cairo"),("352679", "Mashtūl as Sūq", "", "EG", "818", "", "14", "", "", "30.36056", "31.3776", "Africa/Cairo"),("352733", "Mersa Matruh", "Марса-Матрух", "EG", "818", "", "22", "", "", "31.3529", "27.23725", "Africa/Cairo"),("352736", "Marsa Alam", "", "EG", "818", "", "02", "", "", "25.06305", "34.89005", "Africa/Cairo"),("352913", "Manfalūţ", "", "EG", "818", "", "17", "", "", "27.3104", "30.97004", "Africa/Cairo"),("352951", "Mallawī", "Маллави", "EG", "818", "", "10", "", "", "27.7314", "30.84165", "Africa/Cairo"),("353219", "Madīnat Sittah Uktūbar", "", "EG", "818", "", "08", "", "", "29.81667", "31.05", "Africa/Cairo"),("353802", "Kawm Umbū", "Ком-Омбо", "EG", "818", "", "16", "", "", "24.47669", "32.94626", "Africa/Cairo"),("353828", "Kawm Ḩamādah", "", "EG", "818", "", "03", "", "", "30.76095", "30.69733", "Africa/Cairo"),("354105", "Kafr Şaqr", "", "EG", "818", "", "14", "", "", "30.79336", "31.62575", "Africa/Cairo"),("354365", "Kafr az Zayyāt", "", "EG", "818", "", "05", "", "", "30.8248", "30.81805", "Africa/Cairo"),("354502", "Kafr ash Shaykh", "", "EG", "818", "", "21", "", "", "31.1143", "30.94012", "Africa/Cairo"),("354775", "Kafr ad Dawwār", "", "EG", "818", "", "03", "", "", "31.13379", "30.12969", "Africa/Cairo"),("354981", "Juhaynah", "", "EG", "818", "", "24", "", "", "26.67319", "31.4976", "Africa/Cairo"),("355026", "Jirjā", "", "EG", "818", "", "24", "", "", "26.33826", "31.89161", "Africa/Cairo"),("355392", "‘Izbat al Burj", "", "EG", "818", "", "01", "", "", "31.5084", "31.84106", "Africa/Cairo"),("355420", "Iţsā", "", "EG", "818", "", "04", "", "", "29.2376", "30.78944", "Africa/Cairo"),("355449", "Isnā", "Эсна", "EG", "818", "", "23", "", "", "25.29336", "32.55402", "Africa/Cairo"),("355628", "Idkū", "Идку", "EG", "818", "", "03", "10430542", "", "31.3073", "30.2981", "Africa/Cairo"),("355635", "Idfū", "", "EG", "818", "", "16", "", "", "24.97916", "32.87722", "Africa/Cairo"),("355648", "Ibshawāy", "", "EG", "818", "", "04", "", "", "29.35805", "30.68142", "Africa/Cairo"),("355795", "Ḩalwān", "Хелуан", "EG", "818", "", "11", "", "", "29.84144", "31.30084", "Africa/Cairo"),("355939", "Hihyā", "", "EG", "818", "", "14", "", "", "30.6713", "31.58801", "Africa/Cairo"),("356000", "Ḩawsh ‘Īsá", "", "EG", "818", "", "03", "", "", "30.9128", "30.29019", "Africa/Cairo"),("356806", "Fuwwah", "", "EG", "818", "", "21", "", "", "31.20365", "30.54908", "Africa/Cairo"),("356933", "Farshūţ", "", "EG", "818", "", "23", "", "", "26.05494", "32.16329", "Africa/Cairo"),("356945", "Fāraskūr", "", "EG", "818", "", "20", "", "", "31.32977", "31.71507", "Africa/Cairo"),("356989", "Fāqūs", "", "EG", "818", "", "14", "", "", "30.73006", "31.80182", "Africa/Cairo"),("358048", "Damietta", "Думьят", "EG", "818", "", "20", "", "", "31.41648", "31.81332", "Africa/Cairo"),("358095", "Diyarb Najm", "", "EG", "818", "", "14", "", "", "30.75438", "31.44016", "Africa/Cairo"),("358108", "Disūq", "Дисук", "EG", "818", "", "21", "", "", "31.13259", "30.64784", "Africa/Cairo"),("358115", "Dishnā", "", "EG", "818", "", "23", "", "", "26.12467", "32.47598", "Africa/Cairo"),("358172", "Dikirnis", "Дикирнис", "EG", "818", "", "01", "", "", "31.08898", "31.59478", "Africa/Cairo"),("358245", "Dhahab", "", "EG", "818", "EG", "26", "", "", "28.50098", "34.51338", "Africa/Cairo"),("358269", "Dayrūţ", "", "EG", "818", "", "17", "", "", "27.55602", "30.80764", "Africa/Cairo"),("358274", "Dayr Mawās", "", "EG", "818", "", "10", "", "", "27.64176", "30.84662", "Africa/Cairo"),("358448", "Damanhūr", "Даманхур", "EG", "818", "", "03", "", "", "31.03408", "30.46823", "Africa/Cairo");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("358600", "Būsh", "", "EG", "818", "", "18", "", "", "29.14816", "31.12733", "Africa/Cairo"),("358619", "Port Said", "Порт-Саид", "EG", "818", "", "19", "", "", "31.25654", "32.28411", "Africa/Cairo"),("358620", "Būr Safājah", "Сафага", "EG", "818", "", "02", "", "", "26.72918", "33.93651", "Africa/Cairo"),("358821", "Bilqās", "", "EG", "818", "", "01", "", "", "31.21452", "31.35798", "Africa/Cairo"),("358840", "Bilbays", "", "EG", "818", "", "14", "", "", "30.42039", "31.56223", "Africa/Cairo"),("358970", "Basyūn", "", "EG", "818", "", "05", "", "", "30.93976", "30.81338", "Africa/Cairo"),("359173", "Banī Suwayf", "", "EG", "818", "", "18", "", "", "29.07441", "31.09785", "Africa/Cairo"),("359212", "Banī Mazār", "", "EG", "818", "", "10", "", "", "28.5036", "30.8004", "Africa/Cairo"),("359280", "Banhā", "Банха", "EG", "818", "", "12", "", "", "30.45906", "31.17858", "Africa/Cairo"),("359493", "Zagazig", "Эз-Заказик", "EG", "818", "", "14", "", "", "30.58768", "31.502", "Africa/Cairo"),("359576", "Awsīm", "", "EG", "818", "", "08", "", "", "30.12303", "31.13571", "Africa/Cairo"),("359678", "El-Tor", "", "EG", "818", "", "26", "", "", "28.24168", "33.6222", "Africa/Cairo"),("359710", "At Tall al Kabīr", "", "EG", "818", "", "07", "", "", "30.54448", "31.78525", "Africa/Cairo"),("359783", "Asyūţ", "Асьют", "EG", "818", "", "17", "", "", "27.18096", "31.18368", "Africa/Cairo"),("359792", "Aswan", "Асуан", "EG", "818", "", "16", "", "", "24.09082", "32.89942", "Africa/Cairo"),("359796", "Suez", "Суэц", "EG", "818", "", "15", "", "", "29.97371", "32.52627", "Africa/Cairo"),("359900", "Aş Şaff", "", "EG", "818", "", "08", "", "", "29.56472", "31.28111", "Africa/Cairo"),("359953", "Ash Shuhadā’", "", "EG", "818", "", "09", "", "", "30.59618", "30.89875", "Africa/Cairo"),("360048", "Ashmūn", "", "EG", "818", "", "09", "", "", "30.29857", "30.97635", "Africa/Cairo"),("360464", "Al Wāsiţah", "", "EG", "818", "", "04", "", "", "29.33778", "31.20556", "Africa/Cairo"),("360502", "Luxor", "Луксор", "EG", "818", "", "28", "", "", "25.69893", "32.6421", "Africa/Cairo"),("360526", "Al Qūşīyah", "", "EG", "818", "", "17", "", "", "27.4402", "30.81841", "Africa/Cairo"),("360531", "Al Quşayr", "Аль-Кусайра", "EG", "818", "", "02", "", "", "26.10426", "34.27793", "Africa/Cairo"),("360542", "Al Qurayn", "Аль-Эль-Курайн", "EG", "818", "", "14", "", "", "30.61618", "31.73514", "Africa/Cairo"),("360612", "Al Qanāyāt", "", "EG", "818", "", "14", "", "", "30.6188", "31.46099", "Africa/Cairo"),("360615", "Al Qanāţir al Khayrīyah", "", "EG", "818", "", "12", "", "", "30.19327", "31.13703", "Africa/Cairo"),("360630", "Cairo", "Каир", "EG", "818", "", "11", "", "", "30.06263", "31.24967", "Africa/Cairo"),("360686", "Al Minyā", "Эль-Минья", "EG", "818", "", "10", "", "", "28.10988", "30.7503", "Africa/Cairo"),("360716", "Al Maţarīyah", "", "EG", "818", "", "01", "", "", "31.18287", "32.03108", "Africa/Cairo"),("360754", "Al Manzilah", "", "EG", "818", "", "01", "", "", "31.15815", "31.937", "Africa/Cairo"),("360761", "Al Manşūrah", "", "EG", "818", "", "01", "", "", "31.03637", "31.38069", "Africa/Cairo"),("360773", "Al Manshāh", "", "EG", "818", "", "24", "", "", "26.47686", "31.8035", "Africa/Cairo"),("360829", "Al Maḩallah al Kubrá", "", "EG", "818", "", "05", "", "", "30.97063", "31.1669", "Africa/Cairo"),("360923", "Al Khārijah", "", "EG", "818", "", "13", "", "", "25.45141", "30.54635", "Africa/Cairo"),("360928", "Al Khānkah", "", "EG", "818", "", "12", "", "", "30.21035", "31.36812", "Africa/Cairo"),("360995", "Giza", "Гиза", "EG", "818", "", "08", "", "", "30.00808", "31.21093", "Africa/Cairo"),("361029", "Al Jamālīyah", "", "EG", "818", "", "01", "", "", "31.18086", "31.86518", "Africa/Cairo"),("361055", "Ismailia", "Исмаилия", "EG", "818", "", "07", "", "", "30.60427", "32.27225", "Africa/Cairo"),("361058", "Alexandria", "Александрия", "EG", "818", "", "06", "", "", "31.21564", "29.95527", "Africa/Cairo"),("361103", "Al Ibrāhīmīyah", "", "EG", "818", "", "14", "", "", "30.71877", "31.56299", "Africa/Cairo"),("361179", "Al Ḩawāmidīyah", "", "EG", "818", "", "08", "", "", "29.9", "31.25", "Africa/Cairo"),("361213", "Al Ḩāmūl", "", "EG", "818", "", "21", "", "", "31.31146", "31.14766", "Africa/Cairo"),("361291", "Hurghada", "Хургада", "EG", "818", "", "02", "", "", "27.25738", "33.81291", "Africa/Cairo"),("361320", "Al Fayyūm", "Аль-Фаюм", "EG", "818", "", "04", "", "", "29.30995", "30.8418", "Africa/Cairo"),("361329", "Al Fashn", "", "EG", "818", "", "18", "", "", "28.82431", "30.89948", "Africa/Cairo"),("361394", "Al Bawīţī", "Бавити", "EG", "818", "", "08", "", "", "28.34919", "28.86591", "Africa/Cairo"),("361435", "Al Balyanā", "", "EG", "818", "", "24", "", "", "26.23568", "32.00347", "Africa/Cairo"),("361457", "Al Bājūr", "", "EG", "818", "", "09", "", "", "30.43026", "31.03681", "Africa/Cairo"),("361478", "Al Badārī", "", "EG", "818", "", "17", "", "", "26.99257", "31.41554", "Africa/Cairo"),("361495", "Al ‘Ayyāţ", "", "EG", "818", "", "08", "", "", "29.61972", "31.2575", "Africa/Cairo"),("361546", "Arish", "", "EG", "818", "", "27", "", "", "31.13159", "33.79844", "Africa/Cairo"),("361612", "Al ‘Alamayn", "", "EG", "818", "", "22", "", "", "30.83007", "28.95502", "Africa/Cairo"),("361661", "Akhmīm", "Ахмим", "EG", "818", "", "24", "", "", "26.56217", "31.74503", "Africa/Cairo"),("361702", "Ajā", "Айа", "EG", "818", "", "01", "", "", "30.94162", "31.29039", "Africa/Cairo"),("361827", "Ad Dilinjāt", "", "EG", "818", "", "03", "", "", "30.82791", "30.53633", "Africa/Cairo"),("362004", "Abū Tīj", "", "EG", "818", "", "17", "", "", "27.04411", "31.31897", "Africa/Cairo"),("362277", "Abū Qurqāş", "", "EG", "818", "", "10", "", "", "27.9312", "30.83841", "Africa/Cairo"),("362485", "Abū Kabīr", "", "EG", "818", "", "14", "", "", "30.72508", "31.67148", "Africa/Cairo"),("362882", "Abū al Maţāmīr", "", "EG", "818", "", "03", "", "", "30.91018", "30.17438", "Africa/Cairo"),("362973", "Abnūb", "", "EG", "818", "", "17", "", "", "27.2696", "31.15105", "Africa/Cairo"),("419435", "Az Zarqā", "", "EG", "818", "", "20", "", "", "31.20864", "31.63528", "Africa/Cairo"),("6692512", "El Gouna", "", "EG", "818", "", "02", "", "", "27.39417", "33.67825", "Africa/Cairo"),("7521348", "Ain Sukhna", "Айн-Сухна", "EG", "818", "", "15", "", "", "29.60018", "32.31671", "Africa/Cairo"),("2461874", "Smara", "Смара", "EH", "732", "MA", "CE", "", "", "26.73841", "-11.67194", "Africa/El_Aaiun"),("2461993", "Laayoune Plage", "", "EH", "732", "", "00", "", "", "27.09611", "-13.41583", "Africa/El_Aaiun"),("2462881", "Laayoune", "Эль-Аюн", "EH", "732", "MA", "", "", "", "27.1418", "-13.18797", "Africa/Casablanca"),("2463447", "Dakhla", "Дахла", "EH", "732", "MA", "CE", "", "", "23.68477", "-15.95798", "Africa/El_Aaiun"),("2509305", "Zubia", "", "ES", "724", "", "51", "GR", "18084", "37.11906", "-3.584", "Europe/Madrid"),("2509377", "Zafra", "Сафра", "ES", "724", "", "57", "BA", "06158", "38.41667", "-6.41667", "Europe/Madrid"),("2509402", "Yecla", "Екла", "ES", "724", "", "31", "MU", "30043", "38.61365", "-1.11468", "Europe/Madrid"),("2509408", "Yaiza", "", "ES", "724", "", "53", "GC", "35034", "28.95678", "-13.76535", "Atlantic/Canary"),("2509463", "Villena", "Вильена", "ES", "724", "", "60", "A", "03140", "38.6373", "-0.86568", "Europe/Madrid"),("2509468", "Villaverde del Río", "", "ES", "724", "", "51", "SE", "41101", "37.58919", "-5.87443", "Europe/Madrid"),("2509487", "Villarrubia de los Ojos", "", "ES", "724", "", "54", "CR", "13096", "39.22085", "-3.60802", "Europe/Madrid"),("2509491", "Villarrobledo", "Вильярробледо", "ES", "724", "", "54", "AB", "02081", "39.26992", "-2.60119", "Europe/Madrid"),("2509509", "Vila-real", "Вила-Реал", "ES", "724", "", "60", "CS", "12032", "39.9383", "-0.10087", "Europe/Madrid"),("2509543", "Villanueva del Trabuco", "", "ES", "724", "", "51", "MA", "29097", "37.02832", "-4.33891", "Europe/Madrid"),("2509545", "Villanueva del Río y Minas", "", "ES", "724", "", "51", "SE", "41099", "37.65502", "-5.71369", "Europe/Madrid"),("2509553", "Villanueva de la Serena", "Вильянуэва-де-ла-Серена", "ES", "724", "", "57", "BA", "06153", "38.97655", "-5.7974", "Europe/Madrid"),("2509555", "Villanueva del Arzobispo", "", "ES", "724", "", "51", "J", "23097", "38.16842", "-3.00742", "Europe/Madrid"),("2509556", "Villanueva del Ariscal", "", "ES", "724", "", "51", "SE", "41098", "37.39623", "-6.14077", "Europe/Madrid"),("2509562", "Villanueva de Córdoba", "", "ES", "724", "", "51", "CO", "14069", "38.32277", "-4.62873", "Europe/Madrid"),("2509564", "Villanueva de Castellón", "", "ES", "724", "", "60", "V", "46257", "39.07741", "-0.51167", "Europe/Madrid"),("2509575", "Villamartín", "", "ES", "724", "", "51", "CA", "11041", "36.85979", "-5.64485", "Europe/Madrid"),("2509576", "Vilamarxant", "", "ES", "724", "", "60", "V", "46256", "39.56916", "-0.62453", "Europe/Madrid"),("2509588", "Villajoyosa", "", "ES", "724", "", "60", "A", "03139", "38.50754", "-0.23346", "Europe/Madrid"),("2509597", "Villafranca de los Caballeros", "", "ES", "724", "", "54", "TO", "45187", "39.42824", "-3.36079", "Europe/Madrid"),("2509598", "Villafranca de los Barros", "", "ES", "724", "", "57", "BA", "06149", "38.56144", "-6.3381", "Europe/Madrid"),("2509603", "Villa del Río", "", "ES", "724", "", "51", "CO", "14066", "37.98108", "-4.29003", "Europe/Madrid"),("2509606", "Villacarrillo", "", "ES", "724", "", "51", "J", "23095", "38.1156", "-3.0848", "Europe/Madrid"),("2509607", "Es Castell", "", "ES", "724", "", "07", "PM", "07064", "39.8776", "4.2899", "Europe/Madrid"),("2509608", "Villacañas", "", "ES", "724", "", "54", "TO", "45185", "39.62367", "-3.33813", "Europe/Madrid"),("2509650", "Vícar", "Викар", "ES", "724", "", "51", "AL", "04102", "36.83155", "-2.64273", "Europe/Madrid"),("2509693", "Vera", "", "ES", "724", "", "51", "AL", "04100", "37.24345", "-1.85905", "Europe/Madrid"),("2509768", "Velez Rubio", "", "ES", "724", "", "51", "AL", "04098", "37.64844", "-2.07686", "Europe/Madrid"),("2509769", "Vélez-Málaga", "Велес-Малага", "ES", "724", "", "51", "MA", "29094", "36.78107", "-4.10266", "Europe/Madrid"),("2509783", "Vejer de la Frontera", "", "ES", "724", "", "51", "CA", "11039", "36.24456", "-5.96953", "Europe/Madrid"),("2509799", "Vega de San Mateo", "", "ES", "724", "", "53", "GC", "35033", "28.00892", "-15.5333", "Atlantic/Canary"),("2509835", "Valverde del Camino", "", "ES", "724", "", "51", "H", "21072", "37.57511", "-6.75432", "Europe/Madrid"),("2509846", "Valsequillo de Gran Canaria", "", "ES", "724", "", "53", "GC", "35031", "27.98562", "-15.49725", "Atlantic/Canary"),("2509946", "Valencina de la Concepción", "", "ES", "724", "", "51", "SE", "41096", "37.41618", "-6.07422", "Europe/Madrid"),("2509950", "Valencia de Alcántara", "", "ES", "724", "", "57", "CC", "10203", "39.41148", "-7.24435", "Europe/Madrid"),("2509954", "Valencia", "Валенсия", "ES", "724", "", "60", "V", "46250", "39.46975", "-0.37739", "Europe/Madrid"),("2509974", "Valdés", "", "ES", "724", "", "51", "MA", "29071", "36.75835", "-4.24235", "Europe/Madrid"),("2509982", "Valdepeñas", "Вальдепеньясе", "ES", "724", "", "54", "CR", "13087", "38.76211", "-3.38483", "Europe/Madrid"),("2510073", "Utrera", "Утрера", "ES", "724", "", "51", "SE", "41095", "37.18516", "-5.78093", "Europe/Madrid"),("2510075", "Utiel", "", "ES", "724", "", "60", "V", "46249", "39.56667", "-1.2", "Europe/Madrid"),("2510098", "Umbrete", "", "ES", "724", "", "51", "SE", "41094", "37.36881", "-6.15847", "Europe/Madrid"),("2510112", "Ubrique", "", "ES", "724", "", "51", "CA", "11038", "36.67777", "-5.446", "Europe/Madrid"),("2510116", "Úbeda", "Убеда", "ES", "724", "", "51", "J", "23092", "38.01328", "-3.3705", "Europe/Madrid"),("2510128", "Turís", "", "ES", "724", "", "60", "V", "46248", "39.38333", "-0.7", "Europe/Madrid"),("2510137", "Tuineje", "", "ES", "724", "", "53", "GC", "35030", "28.32372", "-14.04722", "Atlantic/Canary"),("2510145", "Trujillo", "", "ES", "724", "", "57", "CC", "10195", "39.45786", "-5.88203", "Europe/Madrid"),("2510165", "Trigueros", "", "ES", "724", "", "51", "H", "21070", "37.38606", "-6.8268", "Europe/Madrid"),("2510186", "Trebujena", "", "ES", "724", "", "51", "CA", "11037", "36.87075", "-6.17586", "Europe/Madrid"),("2510224", "Totana", "Тотана", "ES", "724", "", "31", "MU", "30039", "37.7688", "-1.50229", "Europe/Madrid"),("2510245", "Torrox", "Торрокс", "ES", "724", "", "51", "MA", "29091", "36.75793", "-3.95233", "Europe/Madrid"),("2510249", "Torrijos", "", "ES", "724", "", "54", "TO", "45173", "39.98195", "-4.28349", "Europe/Madrid"),("2510253", "Torrevieja", "Торревьеха", "ES", "724", "", "60", "A", "03133", "37.97872", "-0.68222", "Europe/Madrid"),("2510270", "Torreperogil", "", "ES", "724", "", "51", "J", "23088", "38.0354", "-3.28998", "Europe/Madrid"),("2510271", "Torre-Pacheco", "Торре-Пачеко", "ES", "724", "", "31", "MU", "30030", "37.74293", "-0.95396", "Europe/Madrid"),("2510279", "Torrent", "", "ES", "724", "", "60", "V", "46244", "39.43705", "-0.46546", "Europe/Madrid"),("2510281", "Torremolinos", "Торремолинос", "ES", "724", "", "51", "MA", "29901", "36.62035", "-4.49976", "Europe/Madrid"),("2510301", "Torredonjimeno", "", "ES", "724", "", "51", "J", "23087", "37.76748", "-3.95776", "Europe/Madrid"),("2510310", "Torre del Campo", "", "ES", "724", "", "51", "J", "23086", "37.77051", "-3.89731", "Europe/Madrid"),("2510392", "Tomelloso", "Томельосо", "ES", "724", "", "54", "CR", "13019", "39.15759", "-3.02156", "Europe/Madrid"),("2510394", "Tomares", "", "ES", "724", "", "51", "SE", "41093", "37.37281", "-6.04589", "Europe/Madrid"),("2510409", "Toledo", "Толедо", "ES", "724", "", "54", "TO", "45168", "39.8581", "-4.02263", "Europe/Madrid"),("2510419", "Tocina", "", "ES", "724", "", "51", "SE", "41092", "37.60904", "-5.73403", "Europe/Madrid"),("2510426", "Tobarra", "", "ES", "724", "", "54", "AB", "02074", "38.59213", "-1.69191", "Europe/Madrid"),("2510455", "Tinajo", "", "ES", "724", "", "53", "GC", "35029", "29.06326", "-13.67647", "Atlantic/Canary"),("2510485", "Tías", "", "ES", "724", "", "53", "GC", "35028", "28.96108", "-13.64502", "Atlantic/Canary"),("2510488", "Teulada", "", "ES", "724", "", "60", "A", "03128", "38.7294", "0.10383", "Europe/Madrid"),("2510508", "Teror", "", "ES", "724", "", "53", "GC", "35027", "28.06062", "-15.54909", "Atlantic/Canary"),("2510542", "Telde", "Тельде", "ES", "724", "", "53", "GC", "35026", "27.99243", "-15.41915", "Atlantic/Canary"),("2510573", "Teguise", "", "ES", "724", "", "53", "GC", "35024", "29.06049", "-13.56397", "Atlantic/Canary"),("2510574", "Tegueste", "", "ES", "724", "", "53", "TF", "38046", "28.51667", "-16.31667", "Atlantic/Canary"),("2510582", "Tazacorte", "", "ES", "724", "", "53", "TF", "38045", "28.64186", "-17.93394", "Atlantic/Canary"),("2510599", "Tarifa", "Тарифа", "ES", "724", "", "51", "CA", "11035", "36.01393", "-5.60695", "Europe/Madrid"),("2510602", "Tarazona de la Mancha", "", "ES", "724", "", "54", "AB", "02073", "39.25", "-1.91667", "Europe/Madrid"),("2510689", "Talayuela", "", "ES", "724", "", "57", "CC", "10131", "39.98701", "-5.60982", "Europe/Madrid"),("2510692", "Talavera La Real", "", "ES", "724", "", "57", "BA", "06128", "38.87794", "-6.76856", "Europe/Madrid"),("2510693", "Talavera de la Reina", "Талавера де ла Рейна", "ES", "724", "", "54", "TO", "45165", "39.96348", "-4.83076", "Europe/Madrid"),("2510725", "Tacoronte", "", "ES", "724", "", "53", "TF", "38043", "28.47688", "-16.41016", "Atlantic/Canary"),("2510743", "Tavernes de la Valldigna", "", "ES", "724", "", "60", "V", "46238", "39.07195", "-0.26623", "Europe/Madrid"),("2510744", "Tavernes Blanques", "", "ES", "724", "", "60", "V", "46237", "39.5", "-0.36667", "Europe/Madrid"),("2510764", "Sueca", "", "ES", "724", "", "60", "V", "46235", "39.2026", "-0.31114", "Europe/Madrid"),("2510799", "Son Servera", "", "ES", "724", "", "07", "PM", "07062", "39.62073", "3.36008", "Europe/Madrid"),("2510801", "Sonseca", "", "ES", "724", "", "54", "TO", "45124", "39.67747", "-3.97448", "Europe/Madrid"),("2510821", "Sóller", "", "ES", "724", "", "07", "PM", "07061", "39.76623", "2.71521", "Europe/Madrid"),("2510852", "Socuéllamos", "", "ES", "724", "", "54", "CR", "13078", "39.28581", "-2.79205", "Europe/Madrid"),("2510880", "Silla", "", "ES", "724", "", "60", "V", "46230", "39.36257", "-0.41169", "Europe/Madrid"),("2510911", "Sevilla", "Севилья", "ES", "724", "", "51", "SE", "41091", "37.38283", "-5.97317", "Europe/Madrid"),("2510972", "Segorbe", "", "ES", "724", "", "60", "CS", "12104", "39.85", "-0.48333", "Europe/Madrid"),("2510975", "Sedaví", "", "ES", "724", "", "60", "V", "46223", "39.43333", "-0.38333", "Europe/Madrid"),("2511010", "Sax", "", "ES", "724", "", "60", "A", "03123", "38.53729", "-0.81779", "Europe/Madrid"),("2511012", "Sauzal", "", "ES", "724", "", "53", "TF", "38041", "28.46667", "-16.41667", "Atlantic/Canary"),("2511032", "San Vicent del Raspeig", "", "ES", "724", "", "60", "A", "03014", "38.3964", "-0.5255", "Europe/Madrid"),("2511050", "Santomera", "", "ES", "724", "", "31", "MU", "30901", "38.06147", "-1.04877", "Europe/Madrid"),("2511064", "Santiponce", "", "ES", "724", "", "51", "SE", "41089", "37.43553", "-6.04106", "Europe/Madrid"),("2511070", "Santiago del Teide", "", "ES", "724", "", "53", "TF", "38040", "28.294", "-16.81618", "Atlantic/Canary"),("2511072", "Santiago de la Ribera", "", "ES", "724", "", "31", "MU", "30035", "37.79681", "-0.80544", "Europe/Madrid"),("2511091", "Santa Úrsula", "", "ES", "724", "", "53", "TF", "38039", "28.42613", "-16.48876", "Atlantic/Canary"),("2511102", "Santa Pola", "Санта-Пола", "ES", "724", "", "60", "A", "03121", "38.19165", "-0.5658", "Europe/Madrid"),("2511106", "Santanyí", "", "ES", "724", "", "07", "PM", "07057", "39.35461", "3.12907", "Europe/Madrid"),("2511143", "Santa Margalida", "", "ES", "724", "", "07", "PM", "07055", "39.70143", "3.10215", "Europe/Madrid"),("2511150", "Santa Lucía", "", "ES", "724", "", "53", "GC", "35019", "27.91174", "-15.54071", "Atlantic/Canary"),("2511160", "Santafé", "", "ES", "724", "", "51", "GR", "18175", "37.18856", "-3.71887", "Europe/Madrid"),("2511162", "Santa Eulària des Riu", "", "ES", "724", "", "07", "PM", "07054", "38.98457", "1.53409", "Europe/Madrid"),("2511170", "Santaella", "", "ES", "724", "", "51", "CO", "14060", "37.56294", "-4.84362", "Europe/Madrid"),("2511174", "Santa Cruz de Tenerife", "Санта-Крус-де-Тенерифе", "ES", "724", "", "53", "TF", "38038", "28.46824", "-16.25462", "Atlantic/Canary"),("2511180", "Santa Cruz de la Palma", "", "ES", "724", "", "53", "TF", "38037", "28.68351", "-17.76421", "Atlantic/Canary"),("2511202", "Santa Brígida", "", "ES", "724", "", "53", "GC", "35021", "28.03197", "-15.50425", "Atlantic/Canary"),("2511230", "San Sebastián de la Gomera", "", "ES", "724", "", "53", "TF", "38036", "28.09163", "-17.11331", "Atlantic/Canary"),("2511239", "San Roque", "", "ES", "724", "", "51", "CA", "11033", "36.21067", "-5.38415", "Europe/Madrid"),("2511247", "San Pedro del Pinatar", "", "ES", "724", "", "31", "MU", "30036", "37.83568", "-0.79102", "Europe/Madrid"),("2511250", "San Pedro de Alcántara", "", "ES", "724", "", "51", "MA", "29069", "36.48839", "-4.99123", "Europe/Madrid"),("2511275", "San Nicolás", "", "ES", "724", "", "53", "GC", "35020", "27.9891", "-15.78126", "Atlantic/Canary"),("2511277", "San Miguel de Salinas", "", "ES", "724", "", "60", "A", "03120", "37.97972", "-0.78904", "Europe/Madrid"),("2511287", "San Miguel De Abona", "", "ES", "724", "", "53", "TF", "38035", "28.09826", "-16.61708", "Atlantic/Canary"),("2511302", "Sant Lluís", "", "ES", "724", "", "07", "PM", "07052", "39.84939", "4.25819", "Europe/Madrid"),("2511304", "Sanlúcar la Mayor", "", "ES", "724", "", "51", "SE", "41087", "37.38758", "-6.20346", "Europe/Madrid"),("2511306", "Sanlúcar de Barrameda", "Санлукар-де-Баррамеда", "ES", "724", "", "51", "CA", "11032", "36.77808", "-6.3515", "Europe/Madrid"),("2511326", "San Juan del Puerto", "", "ES", "724", "", "51", "H", "21064", "37.31667", "-6.84139", "Europe/Madrid"),("2511327", "San Juan de la Rambla", "", "ES", "724", "", "53", "TF", "38026", "28.39276", "-16.65015", "Atlantic/Canary"),("2511329", "San Juan de Aznalfarache", "Сан-Хуан-де-Аснальфараче", "ES", "724", "", "51", "SE", "41086", "37.35813", "-6.03731", "Europe/Madrid"),("2511330", "San Juan de Alicante", "", "ES", "724", "", "60", "A", "03014", "38.40148", "-0.43623", "Europe/Madrid"),("2511366", "San Javier", "", "ES", "724", "", "31", "MU", "30035", "37.80626", "-0.83736", "Europe/Madrid"),("2511371", "San Isidro", "Сан Исидро", "ES", "724", "", "53", "TF", "38017", "28.07617", "-16.558", "Atlantic/Canary"),("2511388", "San Fernando", "Сан-Фернандо", "ES", "724", "", "51", "CA", "11031", "36.4759", "-6.19817", "Europe/Madrid"),("2511401", "La Laguna", "Ла-Лагуна", "ES", "724", "", "53", "TF", "38023", "28.4853", "-16.32014", "Atlantic/Canary"),("2511411", "San Clemente", "", "ES", "724", "", "54", "CU", "16190", "39.4041", "-2.42819", "Europe/Madrid"),("2511440", "San Bartolomé de Tirajana", "", "ES", "724", "", "53", "GC", "35019", "27.92481", "-15.57329", "Atlantic/Canary"),("2511447", "San Bartolomé", "Сан - Бартоломе", "ES", "724", "", "53", "GC", "35018", "29.00093", "-13.613", "Atlantic/Canary"),("2511448", "Sant Antoni de Portmany", "Сан-Антонио-Абад", "ES", "724", "", "07", "PM", "07046", "38.98068", "1.30362", "Europe/Madrid"),("2511503", "Salobreña", "", "ES", "724", "", "51", "GR", "18173", "36.74277", "-3.58717", "Europe/Madrid"),("2511619", "Sagunto", "Сагунто", "ES", "724", "", "60", "V", "46220", "39.68333", "-0.26667", "Europe/Madrid"),("2511649", "Rute", "", "ES", "724", "", "51", "CO", "14058", "37.3269", "-4.36827", "Europe/Madrid"),("2511700", "Rota", "Рота", "ES", "724", "", "51", "CA", "11030", "36.62545", "-6.3622", "Europe/Madrid"),("2511716", "Roquetas de Mar", "Рокетас-де-Мар", "ES", "724", "", "51", "AL", "04079", "36.76419", "-2.61475", "Europe/Madrid"),("2511730", "Ronda", "Ронда", "ES", "724", "", "51", "MA", "29084", "36.74231", "-5.16709", "Europe/Madrid"),("2511752", "Rojales", "Рохалес", "ES", "724", "", "60", "A", "03113", "38.08799", "-0.72544", "Europe/Madrid"),("2511771", "Rocafort", "", "ES", "724", "", "60", "V", "46216", "39.53333", "-0.4", "Europe/Madrid"),("2511852", "Rincón de la Victoria", "Ринкон-де-ла-Виктория", "ES", "724", "", "51", "MA", "29082", "36.71715", "-4.27583", "Europe/Madrid"),("2511880", "Ribarroja del Turia", "", "ES", "724", "", "60", "V", "46111", "39.54595", "-0.57069", "Europe/Madrid"),("2511930", "Requena", "Рекена", "ES", "724", "", "60", "V", "46213", "39.48834", "-1.10044", "Europe/Madrid"),("2511969", "Redován", "", "ES", "724", "", "60", "A", "03111", "38.11619", "-0.90981", "Europe/Madrid"),("2511994", "Realejo Alto", "", "ES", "724", "", "53", "TF", "38026", "28.37645", "-16.58575", "Atlantic/Canary"),("2512095", "Quintanar del Rey", "", "ES", "724", "", "54", "CU", "16175", "39.33333", "-1.93333", "Europe/Madrid"),("2512096", "Quintanar de la Orden", "", "ES", "724", "", "54", "TO", "45142", "39.59369", "-3.04165", "Europe/Madrid"),("2512099", "Quintana de la Serena", "", "ES", "724", "", "57", "BA", "06109", "38.74595", "-5.67233", "Europe/Madrid"),("2512107", "Quesada", "", "ES", "724", "", "51", "J", "23028", "37.84338", "-3.06561", "Europe/Madrid"),("2512127", "Puçol", "", "ES", "724", "", "60", "V", "46205", "39.61667", "-0.3", "Europe/Madrid"),("2512152", "Pulpí", "", "ES", "724", "", "51", "AL", "04035", "37.41154", "-1.74496", "Europe/Madrid"),("2512162", "Puig", "", "ES", "724", "", "60", "V", "46204", "39.58869", "-0.30333", "Europe/Madrid"),("2512164", "Puerto Serrano", "", "ES", "724", "", "51", "CA", "11041", "36.92209", "-5.54304", "Europe/Madrid"),("2512169", "Puerto Real", "Пуэрто-Реаль", "ES", "724", "", "51", "CA", "11028", "36.52819", "-6.19011", "Europe/Madrid"),("2512177", "Puertollano", "Пуэртольяно", "ES", "724", "", "54", "CR", "13071", "38.68712", "-4.10734", "Europe/Madrid"),("2512186", "Puerto del Rosario", "Пуэрто-дель-Росарио", "ES", "724", "", "53", "GC", "35017", "28.50038", "-13.86272", "Atlantic/Canary"),("2512196", "Puerto de la Cruz", "Пуэрто-де-ла-Крус", "ES", "724", "", "53", "TF", "38028", "28.41397", "-16.54867", "Atlantic/Canary"),("2512232", "Puente-Genil", "", "ES", "724", "", "51", "CO", "14056", "37.38943", "-4.76686", "Europe/Madrid"),("2512251", "La Pobla de Vallbona", "", "ES", "724", "", "60", "V", "46202", "39.59747", "-0.55468", "Europe/Madrid"),("2512263", "Puebla de la Calzada", "", "ES", "724", "", "57", "BA", "06103", "38.89441", "-6.62592", "Europe/Madrid"),("2512282", "Priego de Córdoba", "Прьего-де-Кордоба", "ES", "724", "", "51", "CO", "14055", "37.43807", "-4.19523", "Europe/Madrid"),("2512294", "Prado del Rey", "", "ES", "724", "", "51", "CA", "11026", "36.78756", "-5.55589", "Europe/Madrid"),("2512340", "Pozoblanco", "", "ES", "724", "", "51", "CO", "14054", "38.37906", "-4.84827", "Europe/Madrid"),("2512343", "Pozo Alcón", "", "ES", "724", "", "51", "J", "23070", "37.70256", "-2.93367", "Europe/Madrid"),("2512367", "Posadas", "", "ES", "724", "", "51", "CO", "14053", "37.80205", "-5.10726", "Europe/Madrid"),("2512378", "Porto Cristo", "", "ES", "724", "", "07", "PM", "07033", "39.53953", "3.33302", "Europe/Madrid"),("2512408", "Porcuna", "", "ES", "724", "", "51", "J", "23069", "37.87102", "-4.18501", "Europe/Madrid"),("2512432", "Pollença", "", "ES", "724", "", "07", "PM", "07042", "39.87678", "3.01626", "Europe/Madrid"),("2512465", "Playa Blanca", "", "ES", "724", "", "53", "GC", "35034", "28.86426", "-13.82814", "Atlantic/Canary"),("2512490", "Pizarra", "", "ES", "724", "", "51", "MA", "29080", "36.76543", "-4.70833", "Europe/Madrid"),("2512509", "Pinos Puente", "", "ES", "724", "", "51", "GR", "18158", "37.25109", "-3.74967", "Europe/Madrid"),("2512510", "Pinoso", "", "ES", "724", "", "60", "A", "03105", "38.40164", "-1.04196", "Europe/Madrid"),("2512578", "Pilas", "", "ES", "724", "", "51", "SE", "41075", "37.30337", "-6.30097", "Europe/Madrid"),("2512581", "Pilar de la Horadada", "Пилар-де-ла-Орадада", "ES", "724", "", "60", "A", "03902", "37.86591", "-0.79256", "Europe/Madrid"),("2512620", "Picassent", "", "ES", "724", "", "60", "V", "46194", "39.3635", "-0.45949", "Europe/Madrid"),("2512624", "Picanya", "", "ES", "724", "", "60", "V", "46193", "39.43333", "-0.43333", "Europe/Madrid"),("2512730", "Peñarroya-Pueblonuevo", "", "ES", "724", "", "51", "CO", "14052", "38.3", "-5.26667", "Europe/Madrid"),("2512767", "Peligros", "", "ES", "724", "", "51", "GR", "18153", "37.23231", "-3.62901", "Europe/Madrid"),("2512794", "Pedro Muñoz", "", "ES", "724", "", "54", "CR", "13061", "39.40285", "-2.94664", "Europe/Madrid"),("2512824", "Pedrera", "", "ES", "724", "", "51", "SE", "41072", "37.22604", "-4.8942", "Europe/Madrid"),("2512825", "Pedreguer", "", "ES", "724", "", "60", "A", "03101", "38.79312", "0.03411", "Europe/Madrid"),("2512844", "Peal de Becerro", "", "ES", "724", "", "51", "J", "23028", "37.91338", "-3.12148", "Europe/Madrid"),("2512857", "Paterna de Rivera", "", "ES", "724", "", "51", "CA", "11025", "36.52246", "-5.86578", "Europe/Madrid"),("2512862", "Paterna", "Патерна", "ES", "724", "", "60", "V", "46190", "39.5", "-0.43333", "Europe/Madrid"),("2512933", "Paradas", "", "ES", "724", "", "51", "SE", "41071", "37.29047", "-5.49703", "Europe/Madrid"),("2512950", "Palos de la Frontera", "", "ES", "724", "", "51", "H", "21041", "37.23457", "-6.89471", "Europe/Madrid"),("2512989", "Palma", "Пальма", "ES", "724", "", "07", "PM", "07040", "39.56939", "2.65024", "Europe/Madrid"),("2512990", "Palma del Río", "Пальма-дель-Рио", "ES", "724", "", "51", "CO", "14036", "37.70024", "-5.28121", "Europe/Madrid"),("2513026", "Pájara", "", "ES", "724", "", "53", "GC", "35015", "28.35039", "-14.1076", "Atlantic/Canary"),("2513029", "Paiporta", "Пайпорта", "ES", "724", "", "60", "V", "46186", "39.42814", "-0.41765", "Europe/Madrid"),("2513035", "Padul", "", "ES", "724", "", "51", "GR", "18150", "37.02462", "-3.62678", "Europe/Madrid"),("2513045", "Otura", "", "ES", "724", "", "51", "GR", "18149", "37.08846", "-3.63321", "Europe/Madrid"),("2513052", "Osuna", "Осуна", "ES", "724", "", "51", "SE", "41068", "37.2376", "-5.10311", "Europe/Madrid"),("2513073", "Órjiva", "", "ES", "724", "", "51", "GR", "18147", "36.90259", "-3.42379", "Europe/Madrid"),("2513076", "Orihuela", "Ориуэла", "ES", "724", "", "60", "A", "03099", "38.08483", "-0.94401", "Europe/Madrid"),("2513106", "Ontinyent", "Онтеньенте", "ES", "724", "", "60", "V", "46184", "38.82191", "-0.60603", "Europe/Madrid"),("2513113", "Onil", "", "ES", "724", "", "60", "A", "03096", "38.62606", "-0.67313", "Europe/Madrid"),("2513114", "Ondara", "", "ES", "724", "", "60", "A", "03095", "38.82817", "0.0172", "Europe/Madrid"),("2513115", "Onda", "Онда", "ES", "724", "", "60", "CS", "12084", "39.96495", "-0.26041", "Europe/Madrid"),("2513120", "Olvera", "", "ES", "724", "", "51", "CA", "11024", "36.93418", "-5.26678", "Europe/Madrid"),("2513121", "Olula del Río", "", "ES", "724", "", "51", "AL", "04069", "37.35445", "-2.29754", "Europe/Madrid"),("2513130", "L'Olleria", "", "ES", "724", "", "60", "V", "46183", "38.91667", "-0.55", "Europe/Madrid"),("2513140", "Olivares", "", "ES", "724", "", "51", "SE", "41067", "37.41802", "-6.15603", "Europe/Madrid"),("2513143", "Oliva de la Frontera", "", "ES", "724", "", "57", "BA", "06093", "38.27595", "-6.91873", "Europe/Madrid"),("2513145", "Oliva", "Олива", "ES", "724", "", "60", "V", "46181", "38.91971", "-0.11935", "Europe/Madrid"),("2513146", "Olías del Rey", "", "ES", "724", "", "54", "TO", "45122", "39.94436", "-3.98684", "Europe/Madrid"),("2513167", "Ogíjares", "", "ES", "724", "", "51", "GR", "18145", "37.11913", "-3.60772", "Europe/Madrid"),("2513175", "Ocaña", "", "ES", "724", "", "54", "TO", "45121", "39.95785", "-3.4982", "Europe/Madrid"),("2513180", "Nules", "", "ES", "724", "", "60", "CS", "12082", "39.85362", "-0.15643", "Europe/Madrid"),("2513184", "Nueva-Carteya", "", "ES", "724", "", "51", "CO", "14046", "37.5863", "-4.46759", "Europe/Madrid"),("2513195", "Novelda", "Новельда", "ES", "724", "", "60", "A", "03093", "38.38479", "-0.76773", "Europe/Madrid"),("2513222", "Níjar", "Нихар", "ES", "724", "", "51", "AL", "04066", "36.96655", "-2.20595", "Europe/Madrid"),("2513237", "Nerva", "", "ES", "724", "", "51", "H", "21052", "37.69627", "-6.54967", "Europe/Madrid"),("2513240", "Nerja", "", "ES", "724", "", "51", "MA", "29075", "36.75278", "-3.8744", "Europe/Madrid"),("2513285", "Nazaret", "", "ES", "724", "", "53", "GC", "35024", "29.03818", "-13.56386", "Atlantic/Canary"),("2513324", "Navalmoral de la Mata", "Навальмораль-де-ла-Мата", "ES", "724", "", "57", "CC", "10131", "39.89158", "-5.54064", "Europe/Madrid"),("2513403", "Muro del Alcoy", "", "ES", "724", "", "60", "A", "03092", "38.7812", "-0.43608", "Europe/Madrid"),("2513406", "Muro", "", "ES", "724", "", "07", "PM", "07039", "39.73661", "3.05559", "Europe/Madrid"),("2513416", "Murcia", "Мурсия", "ES", "724", "", "31", "MU", "30030", "37.98704", "-1.13004", "Europe/Madrid"),("2513436", "Mula", "", "ES", "724", "", "31", "MU", "30029", "38.04095", "-1.49014", "Europe/Madrid"),("2513465", "Mutxamel", "", "ES", "724", "", "60", "A", "03014", "38.4158", "-0.44529", "Europe/Madrid"),("2513476", "Moya", "", "ES", "724", "", "53", "GC", "35013", "28.10136", "-15.58917", "Atlantic/Canary"),("2513477", "Motril", "Мотриль", "ES", "724", "", "51", "GR", "18140", "36.75066", "-3.5179", "Europe/Madrid"),("2513480", "Motilla del Palancar", "", "ES", "724", "", "54", "CU", "16134", "39.56667", "-1.88333", "Europe/Madrid"),("2513481", "Mota del Cuervo", "", "ES", "724", "", "54", "CU", "16133", "39.50189", "-2.86994", "Europe/Madrid"),("2513509", "Morón de la Frontera", "Морон-де-ла-Фронтера", "ES", "724", "", "51", "SE", "41065", "37.12084", "-5.45403", "Europe/Madrid"),("2513562", "Moratalla", "", "ES", "724", "", "31", "MU", "30028", "38.18928", "-1.89183", "Europe/Madrid"),("2513580", "Moral de Calatrava", "", "ES", "724", "", "54", "CR", "13058", "38.82989", "-3.57813", "Europe/Madrid"),("2513588", "Mora", "", "ES", "724", "", "54", "TO", "45106", "39.68492", "-3.77394", "Europe/Madrid"),("2513595", "Montoro", "", "ES", "724", "", "51", "CO", "14021", "38.02409", "-4.3834", "Europe/Madrid"),("2513601", "Montilla", "Монтилья", "ES", "724", "", "51", "CO", "14042", "37.58627", "-4.63805", "Europe/Madrid"),("2513604", "Montijo", "", "ES", "724", "", "57", "BA", "06088", "38.90839", "-6.61785", "Europe/Madrid"),("2513637", "Montellano", "", "ES", "724", "", "51", "SE", "41064", "36.99531", "-5.57145", "Europe/Madrid"),("2513640", "Montefrío", "", "ES", "724", "", "51", "GR", "18135", "37.32308", "-4.00898", "Europe/Madrid"),("2513680", "Monóvar", "", "ES", "724", "", "60", "A", "03093", "38.43809", "-0.84062", "Europe/Madrid"),("2513691", "Monforte del Cid", "", "ES", "724", "", "60", "A", "03088", "38.38027", "-0.7285", "Europe/Madrid"),("2513703", "Moncada", "Монкада", "ES", "724", "", "60", "V", "46171", "39.54555", "-0.39551", "Europe/Madrid"),("2513709", "Monachil", "", "ES", "724", "", "51", "GR", "18134", "37.1332", "-3.53724", "Europe/Madrid"),("2513759", "Molina de Segura", "Молина-де-Сегура", "ES", "724", "", "31", "MU", "30027", "38.05456", "-1.20763", "Europe/Madrid"),("2513786", "Mojacar", "", "ES", "724", "", "51", "AL", "04064", "37.1402", "-1.85102", "Europe/Madrid"),("2513791", "Moguer", "Могер", "ES", "724", "", "51", "H", "21050", "37.27559", "-6.83851", "Europe/Madrid"),("2513798", "Mogán", "", "ES", "724", "", "53", "GC", "35012", "27.88385", "-15.72538", "Atlantic/Canary"),("2513811", "Mislata", "Мислата", "ES", "724", "", "60", "V", "46169", "39.47523", "-0.41825", "Europe/Madrid"),("2513882", "Mijas", "Михас", "ES", "724", "", "51", "MA", "29070", "36.59575", "-4.63728", "Europe/Madrid"),("2513885", "Miguelturra", "", "ES", "724", "", "54", "CR", "13013", "38.96442", "-3.89047", "Europe/Madrid"),("2513886", "Miguel Esteban", "", "ES", "724", "", "54", "TO", "45101", "39.52448", "-3.07618", "Europe/Madrid"),("2513893", "Miajadas", "", "ES", "724", "", "57", "CC", "10121", "39.15127", "-5.90841", "Europe/Madrid"),("2513917", "Mérida", "Мерида", "ES", "724", "", "57", "BA", "06083", "38.91611", "-6.34366", "Europe/Madrid"),("2513931", "Mengibar", "", "ES", "724", "", "51", "J", "23061", "37.96978", "-3.80884", "Europe/Madrid"),("2513944", "Membrilla", "", "ES", "724", "", "54", "CR", "13053", "38.97198", "-3.3433", "Europe/Madrid"),("2513947", "Melilla", "Мелилья", "ES", "724", "", "ML", "ME", "52001", "35.29369", "-2.93833", "Africa/Ceuta"),("2513949", "Meliana", "", "ES", "724", "", "60", "V", "46166", "39.53333", "-0.33333", "Europe/Madrid"),("2513961", "Medina Sidonia", "", "ES", "724", "", "51", "CA", "11023", "36.45695", "-5.92717", "Europe/Madrid"),("2513983", "Mazarrón", "Масаррон", "ES", "724", "", "31", "MU", "30026", "37.5992", "-1.31493", "Europe/Madrid"),("2514042", "Maspalomas", "Маспаломас", "ES", "724", "", "53", "GC", "35019", "27.76056", "-15.58602", "Atlantic/Canary"),("2514066", "Massamagrell", "", "ES", "724", "", "60", "V", "46164", "39.56667", "-0.33333", "Europe/Madrid"),("2514073", "Martos", "Мартос", "ES", "724", "", "51", "J", "23060", "37.72107", "-3.97264", "Europe/Madrid"),("2514097", "Marratxí", "Маррачи", "ES", "724", "", "07", "PM", "07036", "39.62142", "2.7253", "Europe/Madrid"),("2514107", "Marmolejo", "", "ES", "724", "", "51", "J", "23059", "38.04549", "-4.17029", "Europe/Madrid"),("2514158", "Marchena", "", "ES", "724", "", "51", "SE", "41060", "37.329", "-5.41681", "Europe/Madrid"),("2514169", "Marbella", "Марбелья", "ES", "724", "", "51", "MA", "29069", "36.51543", "-4.88583", "Europe/Madrid"),("2514176", "Maracena", "", "ES", "724", "", "51", "GR", "18127", "37.20764", "-3.63493", "Europe/Madrid"),("2514190", "Manzanares", "", "ES", "724", "", "54", "CR", "13053", "38.99915", "-3.36991", "Europe/Madrid"),("2514197", "Manises", "Манисес", "ES", "724", "", "60", "V", "46159", "39.49139", "-0.46349", "Europe/Madrid"),("2514199", "Manilva", "", "ES", "724", "", "51", "MA", "29068", "36.37645", "-5.25026", "Europe/Madrid"),("2514211", "Mancha Real", "", "ES", "724", "", "51", "J", "23058", "37.78627", "-3.61226", "Europe/Madrid"),("2514216", "Manacor", "Манакор", "ES", "724", "", "07", "PM", "07033", "39.56964", "3.20955", "Europe/Madrid"),("2514252", "Malagón", "", "ES", "724", "", "54", "CR", "13052", "39.16668", "-3.85419", "Europe/Madrid"),("2514256", "Málaga", "Малага", "ES", "724", "", "51", "MA", "29067", "36.72016", "-4.42034", "Europe/Madrid"),("2514287", "Mairena del Aljarafe", "Майрена-дель-Альхарафе", "ES", "724", "", "51", "SE", "41059", "37.34461", "-6.06391", "Europe/Madrid"),("2514288", "Mairena del Alcor", "", "ES", "724", "", "51", "SE", "41058", "37.37301", "-5.74951", "Europe/Madrid"),("2514301", "Maó", "Мао", "ES", "724", "", "07", "PM", "07032", "39.88853", "4.26583", "Europe/Madrid"),("2514334", "Madridejos", "", "ES", "724", "", "54", "TO", "45087", "39.46823", "-3.53196", "Europe/Madrid"),("2514360", "Macael", "", "ES", "724", "", "51", "AL", "04062", "37.33318", "-2.30087", "Europe/Madrid"),("2514370", "Puerto Lumbreras", "", "ES", "724", "", "31", "MU", "30024", "37.56329", "-1.80974", "Europe/Madrid"),("2514392", "Lucena", "", "ES", "724", "", "51", "CO", "14038", "37.40881", "-4.48522", "Europe/Madrid"),("2514406", "Los Yébenes", "", "ES", "724", "", "54", "TO", "45200", "39.58158", "-3.87058", "Europe/Madrid"),("2514452", "Los Silos", "", "ES", "724", "", "53", "TF", "38042", "28.3661", "-16.81552", "Atlantic/Canary"),("2514460", "Los Santos de Maimona", "", "ES", "724", "", "57", "BA", "06122", "38.45", "-6.38333", "Europe/Madrid"),("2514553", "Los Palacios y Villafranca", "", "ES", "724", "", "51", "SE", "41069", "37.16181", "-5.92433", "Europe/Madrid"),("2514651", "Los Llanos de Aridane", "Лос-Льянос-де-Аридане", "ES", "724", "", "53", "TF", "38024", "28.65851", "-17.91821", "Atlantic/Canary"),("2514824", "Los Barrios", "Лос-Барриос", "ES", "724", "", "51", "CA", "11035", "36.18482", "-5.49213", "Europe/Madrid"),("2514868", "Los Alcázares", "", "ES", "724", "", "31", "MU", "30902", "37.74425", "-0.85041", "Europe/Madrid"),("2514883", "Lorquí", "", "ES", "724", "", "31", "MU", "30025", "38.08261", "-1.25103", "Europe/Madrid"),("2514891", "Lorca", "Лорка", "ES", "724", "", "31", "MU", "30024", "37.67119", "-1.7017", "Europe/Madrid"),("2514893", "Lora del Río", "Лора-дель-Рио", "ES", "724", "", "51", "SE", "41055", "37.65896", "-5.52751", "Europe/Madrid"),("2514912", "Lomo de Arico", "", "ES", "724", "", "53", "TF", "38017", "28.16667", "-16.48333", "Atlantic/Canary"),("2514946", "Loja", "Лоха", "ES", "724", "", "51", "GR", "18122", "37.16887", "-4.15129", "Europe/Madrid"),("2514984", "Llucmajor", "", "ES", "724", "", "07", "PM", "07031", "39.49093", "2.89108", "Europe/Madrid"),("2514988", "Lloseta", "", "ES", "724", "", "07", "PM", "07029", "39.71849", "2.8669", "Europe/Madrid"),("2515002", "Llerena", "", "ES", "724", "", "57", "BA", "06074", "38.23333", "-6.01667", "Europe/Madrid"),("2515036", "Llíria", "", "ES", "724", "", "60", "V", "46148", "39.62894", "-0.59783", "Europe/Madrid"),("2515045", "Linares", "Линарес", "ES", "724", "", "51", "J", "23055", "38.09519", "-3.63602", "Europe/Madrid"),("2515072", "Lepe", "Лепе", "ES", "724", "", "51", "H", "21044", "37.25482", "-7.20433", "Europe/Madrid"),("2515096", "Lebrija", "Лебриха", "ES", "724", "", "51", "SE", "41053", "36.92077", "-6.07529", "Europe/Madrid"),("2515118", "La Victoria de Acentejo", "", "ES", "724", "", "53", "TF", "38051", "28.43231", "-16.46232", "Atlantic/Canary"),("2515151", "La Unión", "", "ES", "724", "", "31", "MU", "30041", "37.61915", "-0.87799", "Europe/Madrid"),("2515219", "Las Torres de Cotillas", "", "ES", "724", "", "31", "MU", "30038", "38.02822", "-1.24188", "Europe/Madrid"),("2515261", "Las Pedroñeras", "", "ES", "724", "", "54", "CU", "16154", "39.44997", "-2.67394", "Europe/Madrid"),("2515270", "Las Palmas de Gran Canaria", "Лас-Пальмас-де-Гран-Канария", "ES", "724", "", "53", "GC", "35016", "28.09973", "-15.41343", "Atlantic/Canary"),("2515284", "La Solana", "", "ES", "724", "", "54", "CR", "13079", "38.94422", "-3.2381", "Europe/Madrid"),("2515493", "Las Cabezas de San Juan", "", "ES", "724", "", "51", "SE", "41020", "36.9838", "-5.93933", "Europe/Madrid"),("2515555", "La Roda", "Ла-Рода", "ES", "724", "", "54", "AB", "02069", "39.20735", "-2.15723", "Europe/Madrid"),("2515562", "La Rinconada", "Ла-Ринконада", "ES", "724", "", "51", "SE", "41081", "37.48613", "-5.98091", "Europe/Madrid"),("2515597", "La Rambla", "", "ES", "724", "", "51", "CO", "14057", "37.6076", "-4.73962", "Europe/Madrid"),("2515619", "La Puebla de Montalbán", "", "ES", "724", "", "54", "TO", "45133", "39.86297", "-4.35917", "Europe/Madrid"),("2515620", "La Puebla del Río", "", "ES", "724", "", "51", "SE", "41034", "37.26787", "-6.06264", "Europe/Madrid"),("2515622", "La Puebla de Cazalla", "", "ES", "724", "", "51", "SE", "41065", "37.22155", "-5.31153", "Europe/Madrid"),("2515623", "La Puebla de Almoradiel", "", "ES", "724", "", "54", "TO", "45135", "39.59862", "-3.11782", "Europe/Madrid"),("2515624", "sa Pobla", "", "ES", "724", "", "07", "PM", "07044", "39.7692", "3.02394", "Europe/Madrid"),("2515679", "La Palma del Condado", "", "ES", "724", "", "51", "H", "21054", "37.38605", "-6.55231", "Europe/Madrid"),("2515692", "La Orotava", "Ла-Оротава", "ES", "724", "", "53", "TF", "38026", "28.39076", "-16.52309", "Atlantic/Canary"),("2515698", "La Oliva", "", "ES", "724", "", "53", "GC", "35014", "28.61052", "-13.92912", "Atlantic/Canary"),("2515701", "la Nucia", "Ла-Нусиа", "ES", "724", "", "60", "A", "03094", "38.61372", "-0.1269", "Europe/Madrid"),("2515755", "La Mojonera", "", "ES", "724", "", "51", "AL", "04021", "37.29233", "-2.4373", "Europe/Madrid"),("2515772", "La Matanza de Acentejo", "", "ES", "724", "", "53", "TF", "38025", "28.45242", "-16.4472", "Atlantic/Canary"),("2515812", "La Línea de la Concepción", "Ла-Линеа-де-ла-Консепсьон", "ES", "724", "", "51", "CA", "11022", "36.16809", "-5.34777", "Europe/Madrid"),("2515911", "La Guancha", "", "ES", "724", "", "53", "TF", "38018", "28.3732", "-16.65158", "Atlantic/Canary"),("2516004", "L'Eliana", "", "ES", "724", "", "60", "V", "46116", "39.56667", "-0.53333", "Europe/Madrid"),("2516088", "La Carolina", "", "ES", "724", "", "51", "J", "23021", "38.27559", "-3.61535", "Europe/Madrid"),("2516089", "La Carlota", "", "ES", "724", "", "51", "CO", "14017", "37.67359", "-4.93122", "Europe/Madrid"),("2516118", "La Campana", "", "ES", "724", "", "51", "SE", "41022", "37.56891", "-5.4267", "Europe/Madrid"),("2516217", "La Algaba", "", "ES", "724", "", "51", "SE", "41007", "37.46325", "-6.01113", "Europe/Madrid"),("2516255", "Jumilla", "Хумилье", "ES", "724", "", "31", "MU", "30022", "38.47917", "-1.325", "Europe/Madrid"),("2516304", "Jódar", "", "ES", "724", "", "51", "J", "23053", "37.84064", "-3.35262", "Europe/Madrid"),("2516315", "Jimena de la Frontera", "", "ES", "724", "", "51", "CA", "11021", "36.43517", "-5.45387", "Europe/Madrid"),("2516318", "Jijona", "", "ES", "724", "", "60", "A", "03014", "38.54086", "-0.50263", "Europe/Madrid"),("2516325", "Jerez de los Caballeros", "", "ES", "724", "", "57", "BA", "06070", "38.32063", "-6.7726", "Europe/Madrid"),("2516326", "Jerez de la Frontera", "Херес-де-ла-Фронтера", "ES", "724", "", "51", "CA", "11020", "36.68645", "-6.13606", "Europe/Madrid"),("2516336", "Javea", "", "ES", "724", "", "60", "A", "03063", "38.78333", "0.16667", "Europe/Madrid"),("2516345", "Xàtiva", "Хатива", "ES", "724", "", "60", "V", "46145", "38.99042", "-0.51852", "Europe/Madrid"),("2516395", "Jaén", "Хаэн", "ES", "724", "", "51", "J", "23050", "37.76922", "-3.79028", "Europe/Madrid"),("2516414", "Iznalloz", "", "ES", "724", "", "51", "GR", "18105", "37.39258", "-3.52762", "Europe/Madrid"),("2516431", "Isla Cristina", "Исла-Кристина", "ES", "724", "", "51", "H", "21042", "37.2", "-7.31667", "Europe/Madrid"),("2516443", "Ingenio", "", "ES", "724", "", "53", "GC", "35011", "27.91855", "-15.43433", "Atlantic/Canary"),("2516449", "Infantes", "", "ES", "724", "", "54", "CR", "13084", "38.73669", "-3.01219", "Europe/Madrid"),("2516452", "Inca", "Инка", "ES", "724", "", "07", "PM", "07027", "39.7211", "2.91093", "Europe/Madrid"),("2516455", "Illora", "", "ES", "724", "", "51", "GR", "18102", "37.28771", "-3.88109", "Europe/Madrid"),("2516474", "Icod de los Vinos", "", "ES", "724", "", "53", "TF", "38022", "28.37241", "-16.71188", "Atlantic/Canary"),("2516479", "Ibiza", "Ибица", "ES", "724", "", "07", "PM", "07026", "38.90883", "1.43296", "Europe/Madrid"),("2516480", "Ibi", "Иби", "ES", "724", "", "60", "A", "03079", "38.62533", "-0.57225", "Europe/Madrid"),("2516498", "Huétor Vega", "", "ES", "724", "", "51", "GR", "18101", "37.14529", "-3.56963", "Europe/Madrid"),("2516499", "Huétor-Tájar", "", "ES", "724", "ES", "51", "GR", "18100", "37.19834", "-4.04692", "Europe/Madrid"),("2516507", "Huéscar", "", "ES", "724", "", "51", "GR", "18164", "37.81104", "-2.54116", "Europe/Madrid"),("2516542", "Huércal-Overa", "Уэркаль-Овера", "ES", "724", "", "51", "AL", "04053", "37.38897", "-1.94536", "Europe/Madrid"),("2516543", "Huércal de Almería", "", "ES", "724", "", "51", "AL", "04052", "36.88507", "-2.4376", "Europe/Madrid"),("2516548", "Huelva", "Уэльва", "ES", "724", "", "51", "H", "21041", "37.26638", "-6.94004", "Europe/Madrid"),("2516549", "Huelma", "", "ES", "724", "", "51", "J", "23044", "37.64784", "-3.45985", "Europe/Madrid"),("2516695", "Hinojosa del Duque", "", "ES", "724", "", "51", "CO", "14035", "38.50057", "-5.14651", "Europe/Madrid"),("2516773", "Herrera", "", "ES", "724", "", "51", "SE", "41050", "37.36396", "-4.84979", "Europe/Madrid"),("2516790", "Herencia", "", "ES", "724", "", "54", "CR", "13047", "39.36616", "-3.35735", "Europe/Madrid"),("2516797", "Hellín", "Эльине", "ES", "724", "", "54", "AB", "02037", "38.5106", "-1.70096", "Europe/Madrid"),("2516852", "Güimar", "", "ES", "724", "", "53", "TF", "38020", "28.31122", "-16.41276", "Atlantic/Canary"),("2516855", "Guillena", "", "ES", "724", "", "51", "SE", "41049", "37.54262", "-6.05626", "Europe/Madrid"),("2516860", "Guía de Isora", "Гиа-де-Исора", "ES", "724", "", "53", "TF", "38019", "28.21154", "-16.77947", "Atlantic/Canary"),("2516861", "Guia", "", "ES", "724", "", "53", "GC", "35009", "28.13974", "-15.63294", "Atlantic/Canary"),("2516896", "Guareña", "", "ES", "724", "", "57", "BA", "06094", "38.85952", "-6.09987", "Europe/Madrid"),("2516902", "Guardamar del Segura", "", "ES", "724", "", "60", "A", "03076", "38.09031", "-0.65556", "Europe/Madrid"),("2516925", "Guadix", "Гвадикс", "ES", "724", "", "51", "GR", "18089", "37.29932", "-3.13922", "Europe/Madrid"),("2516944", "Guadassuar", "", "ES", "724", "", "60", "V", "46139", "39.18663", "-0.47859", "Europe/Madrid"),("2517111", "Granadilla de Abona", "Гранадилья-де-Абона", "ES", "724", "", "53", "TF", "38017", "28.11882", "-16.57599", "Atlantic/Canary"),("2517117", "Granada", "Гранада", "ES", "724", "", "51", "GR", "18087", "37.18817", "-3.60667", "Europe/Madrid"),("2517197", "Gójar", "", "ES", "724", "", "51", "GR", "18084", "37.10456", "-3.60565", "Europe/Madrid"),("2517200", "Godella", "", "ES", "724", "", "60", "V", "46135", "39.53333", "-0.41667", "Europe/Madrid"),("2517217", "Gines", "", "ES", "724", "", "51", "SE", "41047", "37.38647", "-6.07729", "Europe/Madrid"),("2517236", "Gibraleón", "", "ES", "724", "", "51", "H", "21035", "37.37628", "-6.96895", "Europe/Madrid"),("2517249", "Gerena", "", "ES", "724", "", "51", "SE", "41045", "37.52957", "-6.15479", "Europe/Madrid"),("2517262", "Gelves", "", "ES", "724", "", "51", "SE", "41044", "37.33481", "-6.02601", "Europe/Madrid"),("2517298", "Gata de Gorgos", "", "ES", "724", "", "60", "A", "03071", "38.77443", "0.08538", "Europe/Madrid"),("2517310", "Garrucha", "", "ES", "724", "", "51", "AL", "04049", "37.18141", "-1.82252", "Europe/Madrid"),("2517349", "Garachico", "", "ES", "724", "", "53", "TF", "38033", "28.77807", "-17.76459", "Atlantic/Canary"),("2517350", "Garachico", "", "ES", "724", "ES", "53", "TF", "38015", "28.37365", "-16.76342", "Atlantic/Canary"),("2517367", "Gandia", "Гандия", "ES", "724", "", "60", "V", "46131", "38.96667", "-0.18333", "Europe/Madrid"),("2517436", "Gáldar", "Гальдар", "ES", "724", "", "53", "GC", "35009", "28.14701", "-15.6502", "Atlantic/Canary"),("2517500", "Fuentes de Andalucía", "", "ES", "724", "", "51", "SE", "41042", "37.46409", "-5.34615", "Europe/Madrid"),("2517512", "Fuente Palmera", "", "ES", "724", "", "51", "CO", "14030", "37.70494", "-5.09965", "Europe/Madrid"),("2517515", "Fuente Obejuna", "", "ES", "724", "", "51", "CO", "14029", "38.26667", "-5.41667", "Europe/Madrid"),("2517547", "Fuente del Maestre", "", "ES", "724", "", "57", "BA", "06054", "38.52656", "-6.44782", "Europe/Madrid"),("2517574", "Fuente-Álamo de Murcia", "", "ES", "724", "", "31", "MU", "30016", "37.7", "-1.1", "Europe/Madrid"),("2517595", "Fuengirola", "Фуэнхирола", "ES", "724", "", "51", "MA", "29054", "36.53998", "-4.62473", "Europe/Madrid"),("2517643", "Fregenal de la Sierra", "", "ES", "724", "", "57", "BA", "06067", "38.16922", "-6.6537", "Europe/Madrid"),("2517675", "Foios", "", "ES", "724", "", "60", "V", "46126", "39.53333", "-0.35", "Europe/Madrid"),("2517679", "Fortuna", "", "ES", "724", "", "31", "MU", "30020", "38.1814", "-1.1259", "Europe/Madrid"),("2517717", "Firgas", "", "ES", "724", "", "53", "GC", "35008", "28.10711", "-15.56299", "Atlantic/Canary"),("2517740", "Fernán-Núñez", "", "ES", "724", "", "51", "CO", "14027", "37.67044", "-4.7264", "Europe/Madrid"),("2517750", "Felanitx", "", "ES", "724", "", "07", "PM", "07022", "39.4696", "3.14831", "Europe/Madrid"),("2517816", "Estepona", "Эстепона", "ES", "724", "", "51", "MA", "29051", "36.42764", "-5.14589", "Europe/Madrid"),("2517820", "Estepa", "", "ES", "724", "", "51", "SE", "41041", "37.29263", "-4.87896", "Europe/Madrid"),("2517903", "Espartinas", "", "ES", "724", "", "51", "SE", "41040", "37.38154", "-6.12578", "Europe/Madrid"),("2518011", "Enguera", "", "ES", "724", "", "60", "V", "46118", "38.97974", "-0.68683", "Europe/Madrid"),("2518040", "El Viso del Alcor", "", "ES", "724", "", "51", "SE", "41102", "37.39106", "-5.71993", "Europe/Madrid"),("2518207", "El Puerto de Santa María", "Эль-Пуэрто-де-Санта-Мария", "ES", "724", "", "51", "CA", "11027", "36.59389", "-6.23298", "Europe/Madrid"),("2518277", "El Paso", "", "ES", "724", "", "53", "TF", "38027", "28.65007", "-17.88274", "Atlantic/Canary"),("2518444", "El Grao", "", "ES", "724", "", "60", "CS", "12040", "39.97358", "0.01284", "Europe/Madrid"),("2518494", "El Ejido", "Эль-Эхидо", "ES", "724", "", "51", "AL", "04013", "36.77629", "-2.81456", "Europe/Madrid"),("2518505", "Elda", "Эльда", "ES", "724", "", "60", "A", "03066", "38.47783", "-0.79157", "Europe/Madrid"),("2518521", "El Coronil", "", "ES", "724", "", "51", "SE", "41011", "37.07955", "-5.6341", "Europe/Madrid"),("2518559", "Elche", "Эльч", "ES", "724", "", "60", "A", "03065", "38.26218", "-0.70107", "Europe/Madrid"),("2518597", "El Casar", "", "ES", "724", "", "57", "BA", "06029", "38.53089", "-5.92513", "Europe/Madrid"),("2518723", "s'Arenal", "", "ES", "724", "", "07", "PM", "07031", "39.5", "2.75", "Europe/Madrid"),("2518729", "El Arahal", "", "ES", "724", "", "51", "SE", "41011", "37.26273", "-5.5453", "Europe/Madrid"),("2518770", "Écija", "Эсиха", "ES", "724", "", "51", "SE", "41039", "37.5422", "-5.0826", "Europe/Madrid"),("2518774", "Dúrcal", "", "ES", "724", "", "51", "GR", "18071", "36.98788", "-3.56601", "Europe/Madrid"),("2518794", "Dos Hermanas", "", "ES", "724", "", "51", "SE", "41038", "37.28287", "-5.92088", "Europe/Madrid"),("2518820", "Don Benito", "Дон-Бенито", "ES", "724", "", "57", "BA", "06044", "38.95627", "-5.86162", "Europe/Madrid"),("2518825", "Doña Mencía", "", "ES", "724", "", "51", "CO", "14022", "37.55346", "-4.35602", "Europe/Madrid"),("2518842", "Dolores", "", "ES", "724", "", "60", "A", "03064", "38.14002", "-0.77088", "Europe/Madrid"),("2518878", "Denia", "Дения", "ES", "724", "", "60", "A", "03063", "38.84078", "0.10574", "Europe/Madrid"),("2518924", "Daimiel", "Даймьель", "ES", "724", "", "54", "CR", "13039", "39.07004", "-3.61498", "Europe/Madrid"),("2518949", "Cullera", "Кульера", "ES", "724", "", "60", "V", "46105", "39.16667", "-0.25", "Europe/Madrid"),("2518950", "Cúllar-Vega", "", "ES", "724", "", "51", "GR", "18057", "37.15361", "-3.67072", "Europe/Madrid"),("2518988", "Cuevas del Almanzora", "", "ES", "724", "", "51", "AL", "04053", "37.29646", "-1.88466", "Europe/Madrid"),("2519068", "Quart de Poblet", "Куарт-де-Поблет", "ES", "724", "", "60", "V", "46102", "39.48139", "-0.43937", "Europe/Madrid"),("2519110", "Crevillente", "Кревильенте", "ES", "724", "", "60", "A", "03059", "38.24994", "-0.80975", "Europe/Madrid"),("2519120", "Cox", "", "ES", "724", "", "60", "A", "03058", "38.14164", "-0.88736", "Europe/Madrid"),("2519217", "Corralejo", "", "ES", "724", "", "53", "GC", "35014", "28.73079", "-13.86749", "Atlantic/Canary"),("2519221", "Corral de Almaguer", "", "ES", "724", "", "54", "TO", "45054", "39.75987", "-3.16452", "Europe/Madrid"),("2519233", "Coria del Río", "Кориа-дель-Рио", "ES", "724", "", "51", "SE", "41034", "37.28766", "-6.0541", "Europe/Madrid"),("2519234", "Coria", "", "ES", "724", "", "57", "CC", "10067", "39.98406", "-6.53603", "Europe/Madrid"),("2519240", "Córdoba", "Кордова", "ES", "724", "", "51", "CO", "14021", "37.89155", "-4.77275", "Europe/Madrid"),("2519277", "Consuegra", "", "ES", "724", "", "54", "TO", "45053", "39.46246", "-3.608", "Europe/Madrid"),("2519278", "Constantina", "", "ES", "724", "", "51", "SE", "41033", "37.86667", "-5.61667", "Europe/Madrid"),("2519289", "Conil de la Frontera", "", "ES", "724", "", "51", "CA", "11014", "36.27719", "-6.0885", "Europe/Madrid"),("2519367", "Coín", "", "ES", "724", "", "51", "MA", "29042", "36.65947", "-4.75639", "Europe/Madrid"),("2519382", "Cocentaina", "", "ES", "724", "", "60", "A", "03056", "38.73975", "-0.43976", "Europe/Madrid"),("2519402", "Ciudad Real", "Сьюдад-Реаль", "ES", "724", "", "54", "CR", "13034", "38.98626", "-3.92907", "Europe/Madrid"),("2519425", "Cieza", "Сьеса", "ES", "724", "", "31", "MU", "30019", "38.23998", "-1.41987", "Europe/Madrid"),("2519436", "Churriana de la Vega", "", "ES", "724", "", "51", "GR", "18062", "37.14499", "-3.64617", "Europe/Madrid"),("2519464", "Chiva", "", "ES", "724", "", "60", "V", "46111", "39.46667", "-0.71667", "Europe/Madrid"),("2519466", "Xirivella", "Чиривелья", "ES", "724", "", "60", "V", "46110", "39.46588", "-0.42589", "Europe/Madrid"),("2519477", "Chipiona", "Чипиона", "ES", "724", "", "51", "CA", "11016", "36.73663", "-6.43703", "Europe/Madrid"),("2519513", "Chiclana de la Frontera", "Чиклана-де-ла-Фронтера", "ES", "724", "", "51", "CA", "11015", "36.41915", "-6.14941", "Europe/Madrid"),("2519522", "Cheste", "", "ES", "724", "", "60", "V", "46109", "39.48333", "-0.68333", "Europe/Madrid"),("2519579", "Ceuti", "", "ES", "724", "", "31", "MU", "30018", "38.07859", "-1.27467", "Europe/Madrid"),("2519634", "Cenes de la Vega", "", "ES", "724", "", "51", "GR", "18047", "37.16006", "-3.53548", "Europe/Madrid"),("2519651", "Cehegín", "", "ES", "724", "", "31", "MU", "30028", "38.09242", "-1.7985", "Europe/Madrid"),("2519672", "Cazorla", "", "ES", "724", "", "51", "J", "23028", "37.91495", "-3.00342", "Europe/Madrid"),("2519685", "Caudete", "", "ES", "724", "", "54", "AB", "02025", "38.70679", "-0.98723", "Europe/Madrid"),("2519688", "Catral", "", "ES", "724", "", "60", "A", "03055", "38.16061", "-0.80209", "Europe/Madrid"),("2519690", "Catarroja", "Катаррох", "ES", "724", "", "60", "V", "46094", "39.4", "-0.4", "Europe/Madrid"),("2519696", "Castuera", "", "ES", "724", "", "57", "BA", "06087", "38.73204", "-5.5439", "Europe/Madrid"),("2519697", "Castro del Río", "", "ES", "724", "", "51", "CO", "14019", "37.69125", "-4.48058", "Europe/Madrid"),("2519711", "Castillo de Locubín", "", "ES", "724", "", "51", "J", "23026", "37.52858", "-3.9422", "Europe/Madrid"),("2519738", "Castilleja de la Cuesta", "", "ES", "724", "", "51", "SE", "41029", "37.38594", "-6.05258", "Europe/Madrid"),("2519752", "Castelló de la Plana", "Кастельон-де-ла-Плана", "ES", "724", "", "60", "CS", "12040", "39.98567", "-0.04935", "Europe/Madrid"),("2519783", "Castalla", "", "ES", "724", "", "60", "A", "03053", "38.59694", "-0.67207", "Europe/Madrid"),("2519979", "Casariche", "", "ES", "724", "", "51", "SE", "41026", "37.29389", "-4.75972", "Europe/Madrid"),("2520052", "Cartaya", "", "ES", "724", "", "51", "H", "21021", "37.28114", "-7.15071", "Europe/Madrid"),("2520055", "Cártama", "Картама", "ES", "724", "", "51", "MA", "29038", "36.71068", "-4.63297", "Europe/Madrid"),("2520058", "Cartagena", "Картахена", "ES", "724", "", "31", "MU", "30016", "37.60512", "-0.98623", "Europe/Madrid"),("2520069", "Carrizal", "", "ES", "724", "", "53", "GC", "35011", "27.91161", "-15.40558", "Atlantic/Canary"),("2520118", "Carmona", "Кармона", "ES", "724", "", "51", "SE", "41024", "37.47125", "-5.64608", "Europe/Madrid"),("2520121", "Carlet", "", "ES", "724", "", "60", "V", "46085", "39.2266", "-0.52142", "Europe/Madrid"),("2520150", "Carcaixent", "Каркахенте", "ES", "724", "", "60", "V", "46083", "39.1218", "-0.44812", "Europe/Madrid"),("2520163", "Carboneras", "", "ES", "724", "", "51", "AL", "04032", "36.99666", "-1.89651", "Europe/Madrid"),("2520171", "Caravaca", "", "ES", "724", "", "31", "MU", "30028", "38.10558", "-1.86343", "Europe/Madrid"),("2520200", "Capdepera", "", "ES", "724", "", "07", "PM", "07014", "39.70237", "3.43532", "Europe/Madrid"),("2520215", "Cantillana", "", "ES", "724", "", "51", "SE", "41023", "37.61032", "-5.82472", "Europe/Madrid"),("2520229", "Can Picafort", "", "ES", "724", "", "07", "PM", "07055", "39.76567", "3.15488", "Europe/Madrid"),("2520283", "Candelaria", "Канделарии", "ES", "724", "", "53", "TF", "38011", "28.3548", "-16.37268", "Atlantic/Canary"),("2520320", "Canals", "", "ES", "724", "", "60", "V", "46081", "38.96251", "-0.58443", "Europe/Madrid"),("2520403", "Campos", "", "ES", "724", "", "07", "PM", "07013", "39.43099", "3.01935", "Europe/Madrid"),("2520413", "Campo de Criptana", "", "ES", "724", "", "54", "CR", "13028", "39.40463", "-3.12492", "Europe/Madrid"),("2520425", "Campiña", "", "ES", "724", "", "51", "J", "23084", "38.21896", "-2.98069", "Europe/Madrid"),("2520428", "Campillos", "", "ES", "724", "", "51", "MA", "29032", "37.04826", "-4.86308", "Europe/Madrid"),("2520447", "El Campello", "", "ES", "724", "", "60", "A", "03050", "38.42885", "-0.39774", "Europe/Madrid"),("2520456", "Campanario", "", "ES", "724", "", "57", "BA", "06028", "38.8644", "-5.61744", "Europe/Madrid"),("2520477", "Camas", "Камас", "ES", "724", "", "51", "SE", "41021", "37.40202", "-6.03314", "Europe/Madrid"),("2520493", "Calvià", "Кальвиа", "ES", "724", "", "07", "PM", "07011", "39.5657", "2.50621", "Europe/Madrid"),("2520496", "Calp", "Кальп", "ES", "724", "", "60", "A", "03047", "38.6447", "0.0445", "Europe/Madrid"),("2520502", "Callosa de Segura", "Кальоса-де-Сегура", "ES", "724", "", "60", "A", "03049", "38.12497", "-0.87822", "Europe/Madrid"),("2520558", "Calasparra", "", "ES", "724", "", "31", "MU", "30013", "38.22997", "-1.69986", "Europe/Madrid"),("2520564", "Cala Rajada", "", "ES", "724", "", "07", "PM", "07014", "39.71174", "3.4631", "Europe/Madrid"),("2520568", "Calamonte", "", "ES", "724", "", "57", "BA", "06025", "38.88861", "-6.38791", "Europe/Madrid"),("2520600", "Cadiz", "Кадис", "ES", "724", "", "51", "CA", "11012", "36.52978", "-6.29465", "Europe/Madrid"),("2520611", "Cáceres", "Касерес", "ES", "724", "", "57", "CC", "10037", "39.47649", "-6.37224", "Europe/Madrid"),("2520645", "Cabra", "Кабра", "ES", "724", "", "51", "CO", "14013", "37.47249", "-4.44206", "Europe/Madrid"),("2520672", "Cabeza del Buey", "", "ES", "724", "", "57", "BA", "06023", "38.72227", "-5.21946", "Europe/Madrid"),("2520709", "Burriana", "Бурриана", "ES", "724", "", "60", "CS", "12032", "39.88901", "-0.08499", "Europe/Madrid"),("2520712", "Burjassot", "Бурхасот", "ES", "724", "", "60", "V", "46078", "39.50984", "-0.41327", "Europe/Madrid"),("2520724", "Bunyola", "", "ES", "724", "", "07", "PM", "07010", "39.69634", "2.69955", "Europe/Madrid"),("2520726", "Buñol", "", "ES", "724", "", "60", "V", "46012", "39.41667", "-0.78333", "Europe/Madrid"),("2520727", "Bullas", "", "ES", "724", "", "31", "MU", "30012", "38.04667", "-1.67227", "Europe/Madrid"),("2520735", "Bujalance", "", "ES", "724", "", "51", "CO", "14012", "37.89556", "-4.38074", "Europe/Madrid"),("2520760", "Buenavista del Norte", "", "ES", "724", "", "53", "TF", "38010", "28.37458", "-16.86098", "Atlantic/Canary"),("2520798", "Brenes", "", "ES", "724", "", "51", "SE", "41018", "37.54944", "-5.87139", "Europe/Madrid"),("2520800", "Breña Alta", "", "ES", "724", "", "53", "TF", "38008", "28.65", "-17.78333", "Atlantic/Canary"),("2520832", "Bornos", "", "ES", "724", "", "51", "CA", "11020", "36.81677", "-5.74448", "Europe/Madrid"),("2520833", "Bormujos", "", "ES", "724", "", "51", "SE", "41017", "37.37358", "-6.07233", "Europe/Madrid"),("2520850", "Bonares", "", "ES", "724", "", "51", "H", "21014", "37.32423", "-6.68073", "Europe/Madrid"),("2520869", "Bollullos par del Condado", "", "ES", "724", "", "51", "H", "21013", "37.34127", "-6.5397", "Europe/Madrid"),("2520870", "Bollullos de la Mitación", "", "ES", "724", "", "51", "SE", "41016", "37.34014", "-6.13719", "Europe/Madrid"),("2520875", "Bolaños de Calatrava", "", "ES", "724", "", "54", "CR", "13023", "38.9069", "-3.66345", "Europe/Madrid"),("2520940", "Blanca", "", "ES", "724", "", "31", "MU", "30011", "38.1791", "-1.37473", "Europe/Madrid"),("2520943", "Binissalem", "", "ES", "724", "", "07", "PM", "07008", "39.68744", "2.84396", "Europe/Madrid"),("2520955", "Bigastro", "", "ES", "724", "", "60", "A", "03044", "38.06237", "-0.89841", "Europe/Madrid"),("2520968", "Bétera", "", "ES", "724", "", "60", "V", "46070", "39.59111", "-0.46151", "Europe/Madrid"),("2521016", "Berja", "Берха", "ES", "724", "", "51", "AL", "04029", "36.84693", "-2.94966", "Europe/Madrid"),("2521050", "Benissa", "", "ES", "724", "", "60", "A", "03041", "38.71492", "0.04849", "Europe/Madrid"),("2521075", "Benigànim", "", "ES", "724", "", "60", "V", "46062", "38.95", "-0.43333", "Europe/Madrid"),("2521080", "Benifaió", "", "ES", "724", "", "60", "V", "46060", "39.28439", "-0.42598", "Europe/Madrid"),("2521086", "Beniel", "", "ES", "724", "", "31", "MU", "30010", "38.04636", "-1.00233", "Europe/Madrid"),("2521088", "Benidorm", "Бенидорм", "ES", "724", "", "60", "A", "03031", "38.53816", "-0.13098", "Europe/Madrid"),("2521105", "Benetússer", "", "ES", "724", "", "60", "V", "46054", "39.42265", "-0.39686", "Europe/Madrid"),("2521106", "Benejúzar", "", "ES", "724", "", "60", "A", "03024", "38.07728", "-0.83942", "Europe/Madrid"),("2521139", "Benalmádena", "Бенальмадена", "ES", "724", "", "51", "MA", "29025", "36.5961", "-4.57267", "Europe/Madrid"),("2521148", "Benaguasil", "", "ES", "724", "", "60", "V", "46051", "39.6", "-0.58333", "Europe/Madrid"),("2521154", "Benacazón", "", "ES", "724", "", "51", "SE", "41015", "37.35289", "-6.19663", "Europe/Madrid"),("2521207", "Beas de Segura", "", "ES", "724", "", "51", "J", "23012", "38.2524", "-2.88875", "Europe/Madrid"),("2521215", "Baza", "База", "ES", "724", "", "51", "GR", "18023", "37.49073", "-2.77259", "Europe/Madrid"),("2521316", "Bargas", "", "ES", "724", "", "54", "TO", "45019", "39.94113", "-4.01979", "Europe/Madrid"),("2521335", "Barbate de Franco", "", "ES", "724", "", "51", "CA", "11007", "36.19237", "-5.92186", "Europe/Madrid"),("2521410", "Bailén", "Байлен", "ES", "724", "", "51", "J", "23010", "38.09639", "-3.77786", "Europe/Madrid"),("2521413", "Baeza", "", "ES", "724", "", "51", "J", "23009", "37.99384", "-3.47103", "Europe/Madrid"),("2521415", "Baena", "Баэна", "ES", "724", "", "51", "CO", "14007", "37.6167", "-4.32245", "Europe/Madrid"),("2521420", "Badajoz", "Бадахос", "ES", "724", "", "57", "BA", "06015", "38.87789", "-6.97061", "Europe/Madrid"),("2521436", "Azuaga", "", "ES", "724", "", "57", "BA", "06014", "38.26667", "-5.68333", "Europe/Madrid"),("2521439", "Aznalcóllar", "", "ES", "724", "", "51", "SE", "41013", "37.51914", "-6.26988", "Europe/Madrid"),("2521451", "Ayora", "", "ES", "724", "", "60", "V", "46239", "39.05852", "-1.05635", "Europe/Madrid"),("2521456", "Ayamonte", "Айямонте", "ES", "724", "", "51", "H", "21010", "37.21329", "-7.40807", "Europe/Madrid"),("2521485", "Atarfe", "", "ES", "724", "", "51", "GR", "18022", "37.22479", "-3.68686", "Europe/Madrid"),("2521486", "Atamaría", "", "ES", "724", "", "31", "MU", "30016", "37.59989", "-0.80682", "Europe/Madrid"),("2521510", "Aspe", "Аспе", "ES", "724", "", "60", "A", "03019", "38.34511", "-0.76721", "Europe/Madrid"),("2521519", "Arucas", "Арукас", "ES", "724", "", "53", "GC", "35006", "28.11983", "-15.52325", "Atlantic/Canary"),("2521534", "Artà", "", "ES", "724", "", "07", "PM", "07006", "39.69315", "3.34979", "Europe/Madrid"),("2521555", "Arroyo de la Luz", "", "ES", "724", "", "57", "CC", "10021", "39.48511", "-6.58401", "Europe/Madrid"),("2521570", "Arrecife", "Аресифе", "ES", "724", "", "53", "GC", "35004", "28.96302", "-13.54769", "Atlantic/Canary"),("2521582", "Arona", "Арон", "ES", "724", "", "53", "TF", "38006", "28.09962", "-16.68102", "Atlantic/Canary"),("2521590", "Armilla", "", "ES", "724", "", "51", "GR", "18021", "37.14386", "-3.62534", "Europe/Madrid"),("2521594", "Arjona", "", "ES", "724", "", "51", "J", "23006", "37.93493", "-4.05478", "Europe/Madrid"),("2521619", "Argamasilla de Calatrava", "", "ES", "724", "", "54", "CR", "13020", "38.72985", "-4.07627", "Europe/Madrid"),("2521620", "Argamasilla de Alba", "", "ES", "724", "", "54", "CR", "13005", "39.12917", "-3.09247", "Europe/Madrid"),("2521665", "Arcos de la Frontera", "Аркос-де-ла-Фронтера", "ES", "724", "", "51", "CA", "11006", "36.75075", "-5.81056", "Europe/Madrid"),("2521673", "Archidona", "", "ES", "724", "", "51", "MA", "29017", "37.09654", "-4.38869", "Europe/Madrid"),("2521676", "Archena", "", "ES", "724", "", "31", "MU", "30009", "38.11631", "-1.30043", "Europe/Madrid"),("2521692", "Arafo", "", "ES", "724", "", "53", "TF", "38004", "28.33971", "-16.42244", "Atlantic/Canary"),("2521694", "Aracena", "", "ES", "724", "", "51", "H", "21007", "37.89396", "-6.56116", "Europe/Madrid"),("2521706", "Antigua", "", "ES", "724", "", "53", "GC", "35003", "28.42307", "-14.01379", "Atlantic/Canary"),("2521710", "Antequera", "Антекера", "ES", "724", "", "51", "MA", "29015", "37.01938", "-4.56123", "Europe/Madrid"),("2521718", "Añover de Tajo", "", "ES", "724", "", "54", "TO", "45014", "39.98873", "-3.76579", "Europe/Madrid"),("2521738", "Andújar", "Андухар", "ES", "724", "", "51", "J", "23005", "38.03922", "-4.05077", "Europe/Madrid"),("2521741", "Andratx", "", "ES", "724", "", "07", "PM", "07005", "39.57553", "2.42017", "Europe/Madrid"),("2521804", "Altea", "", "ES", "724", "", "60", "A", "03018", "38.59885", "-0.05139", "Europe/Madrid"),("2521840", "Alora", "", "ES", "724", "", "51", "MA", "29012", "36.82358", "-4.70575", "Europe/Madrid"),("2521845", "Almussafes", "", "ES", "724", "", "60", "V", "46035", "39.28333", "-0.41667", "Europe/Madrid"),("2521847", "Almuñécar", "Альмуньекар", "ES", "724", "", "51", "GR", "18017", "36.73393", "-3.69072", "Europe/Madrid"),("2521855", "Almoradí", "Альморади", "ES", "724", "", "60", "A", "03099", "38.10879", "-0.79197", "Europe/Madrid"),("2521857", "Almonte", "", "ES", "724", "", "51", "H", "21005", "37.2647", "-6.51667", "Europe/Madrid"),("2521867", "Almodóvar del Río", "", "ES", "724", "", "51", "CO", "14005", "37.8107", "-5.02037", "Europe/Madrid"),("2521869", "Almodóvar del Campo", "", "ES", "724", "", "54", "CR", "13015", "38.70936", "-4.17908", "Europe/Madrid"),("2521886", "Almería", "Альмерия", "ES", "724", "", "51", "AL", "04013", "36.83814", "-2.45974", "Europe/Madrid"),("2521893", "Almendralejo", "Альмендралехо", "ES", "724", "", "57", "BA", "06011", "38.68316", "-6.40747", "Europe/Madrid"),("2521899", "Almenara", "", "ES", "724", "", "60", "CS", "12011", "39.75", "-0.21667", "Europe/Madrid"),("2521909", "Almassora", "", "ES", "724", "", "60", "CS", "12040", "39.94729", "-0.06313", "Europe/Madrid"),("2521923", "Almansa", "Альманса", "ES", "724", "", "54", "AB", "02009", "38.86917", "-1.09713", "Europe/Madrid"),("2521928", "Almagro", "", "ES", "724", "", "54", "CR", "13013", "38.88941", "-3.71131", "Europe/Madrid"),("2521964", "Aljaraque", "", "ES", "724", "", "51", "H", "21002", "37.26989", "-7.02313", "Europe/Madrid"),("2521978", "Alicante", "Аликанте", "ES", "724", "", "60", "A", "03014", "38.34517", "-0.48149", "Europe/Madrid"),("2521985", "Alhaurín el Grande", "Алаурин-эль-Гранде", "ES", "724", "", "51", "MA", "29008", "36.643", "-4.68728", "Europe/Madrid"),("2521986", "Alhaurín de la Torre", "", "ES", "724", "", "51", "MA", "29007", "36.66401", "-4.56139", "Europe/Madrid"),("2521992", "Alhama de Murcia", "Альхама-де-Мурсия", "ES", "724", "", "31", "MU", "30008", "37.85103", "-1.42507", "Europe/Madrid"),("2521993", "Alhama de Granada", "", "ES", "724", "", "51", "GR", "18013", "37.00689", "-3.98963", "Europe/Madrid"),("2522000", "Alguazas", "", "ES", "724", "", "31", "MU", "30007", "38.05356", "-1.25051", "Europe/Madrid"),("2522005", "Algodonales", "", "ES", "724", "", "51", "CA", "11005", "36.88044", "-5.40536", "Europe/Madrid"),("2522007", "Alginet", "", "ES", "724", "", "60", "V", "46031", "39.26667", "-0.46667", "Europe/Madrid"),("2522012", "Algemesí", "Альхемеси", "ES", "724", "", "60", "V", "46029", "39.19042", "-0.43572", "Europe/Madrid"),("2522013", "Algeciras", "Альхесирас", "ES", "724", "", "51", "CA", "11004", "36.13326", "-5.45051", "Europe/Madrid"),("2522019", "Algarrobo", "", "ES", "724", "", "51", "MA", "29005", "36.77388", "-4.03952", "Europe/Madrid"),("2522057", "Alfafar", "Альфафар", "ES", "724", "", "60", "V", "46022", "39.41667", "-0.38333", "Europe/Madrid"),("2522077", "Aldaia", "Альдайя", "ES", "724", "", "60", "V", "46021", "39.46569", "-0.46005", "Europe/Madrid"),("2522085", "L'Alcúdia", "", "ES", "724", "", "60", "V", "46019", "39.19717", "-0.50537", "Europe/Madrid"),("2522091", "Alcúdia", "", "ES", "724", "", "07", "PM", "07003", "39.85316", "3.12138", "Europe/Madrid"),("2522098", "Alcoy", "Алька", "ES", "724", "", "60", "A", "03009", "38.70545", "-0.47432", "Europe/Madrid"),("2522129", "Alzira", "Альсира", "ES", "724", "", "60", "V", "46017", "39.15", "-0.43333", "Europe/Madrid"),("2522131", "Alcázar de San Juan", "Алькасар-де-Сан-Хуан", "ES", "724", "", "54", "CR", "13005", "39.39011", "-3.20827", "Europe/Madrid"),("2522137", "Alcaudete", "", "ES", "724", "", "51", "J", "23003", "37.59091", "-4.08237", "Europe/Madrid"),("2522152", "Alcantarilla", "Алькантарилья", "ES", "724", "", "31", "MU", "30005", "37.96939", "-1.21714", "Europe/Madrid"),("2522160", "Alcalá la Real", "Алькала-ла-Реаль", "ES", "724", "", "51", "J", "23002", "37.4614", "-3.92301", "Europe/Madrid"),("2522161", "Alcalá del Valle", "", "ES", "724", "", "51", "CA", "11002", "36.90448", "-5.1724", "Europe/Madrid"),("2522162", "Alcalá de los Gazules", "", "ES", "724", "", "51", "CA", "11001", "36.46212", "-5.72382", "Europe/Madrid"),("2522165", "Alcalá de Guadaira", "Алькала-де-Гвадаира", "ES", "724", "", "51", "SE", "41004", "37.33791", "-5.83951", "Europe/Madrid"),("2522179", "Alcàsser", "", "ES", "724", "", "60", "V", "46015", "39.36791", "-0.44447", "Europe/Madrid"),("2522183", "Alburquerque", "", "ES", "724", "", "57", "BA", "06006", "39.22076", "-7.00234", "Europe/Madrid"),("2522187", "Albuñol", "", "ES", "724", "", "51", "GR", "18006", "36.79203", "-3.205", "Europe/Madrid"),("2522200", "Albox", "", "ES", "724", "", "51", "AL", "04006", "37.38856", "-2.14949", "Europe/Madrid"),("2522203", "Alboraya", "Альборайя", "ES", "724", "", "60", "V", "46013", "39.5", "-0.35", "Europe/Madrid"),("2522208", "Albolote", "", "ES", "724", "", "51", "GR", "18003", "37.23088", "-3.6551", "Europe/Madrid"),("2522222", "Alberic", "", "ES", "724", "", "60", "V", "46011", "39.11667", "-0.51667", "Europe/Madrid"),("2522228", "Albatera", "", "ES", "724", "", "60", "A", "03005", "38.17902", "-0.87059", "Europe/Madrid"),("2522250", "Albal", "", "ES", "724", "", "60", "V", "46007", "39.4", "-0.41667", "Europe/Madrid"),("2522253", "Albaida", "", "ES", "724", "", "60", "V", "46006", "38.83798", "-0.51721", "Europe/Madrid"),("2522258", "Albacete", "Альбасете", "ES", "724", "", "54", "AB", "02003", "38.99424", "-1.85643", "Europe/Madrid"),("2522259", "Alaior", "", "ES", "724", "", "07", "PM", "07002", "39.93034", "4.14039", "Europe/Madrid"),("2522291", "Alameda", "", "ES", "724", "", "51", "MA", "29001", "37.2087", "-4.6586", "Europe/Madrid"),("2522297", "Alaquàs", "Алакуас", "ES", "724", "", "60", "V", "46005", "39.45568", "-0.461", "Europe/Madrid"),("2522325", "Agüimes", "Агуимес", "ES", "724", "", "53", "GC", "35002", "27.90539", "-15.44609", "Atlantic/Canary"),("2522333", "Águilas", "Агилас", "ES", "724", "", "31", "MU", "30003", "37.4063", "-1.58289", "Europe/Madrid"),("2522335", "Aguilar", "", "ES", "724", "", "51", "CO", "14002", "37.51476", "-4.65717", "Europe/Madrid"),("2522388", "Aguadulce", "", "ES", "724", "ES", "51", "AL", "04079", "36.81409", "-2.57235", "Europe/Madrid"),("2522423", "Agaete", "", "ES", "724", "", "53", "GC", "35001", "28.10023", "-15.69998", "Atlantic/Canary"),("2522430", "Adra", "Адра", "ES", "724", "", "51", "AL", "04003", "36.74961", "-3.02055", "Europe/Madrid"),("2522437", "Adeje", "Адехе", "ES", "724", "", "53", "TF", "38001", "28.12271", "-16.726", "Atlantic/Canary"),("2522446", "Aceuchal", "", "ES", "724", "", "57", "BA", "06002", "38.64627", "-6.48636", "Europe/Madrid"),("2522474", "Acalá del Río", "", "ES", "724", "", "51", "SE", "41007", "37.5178", "-5.98185", "Europe/Madrid"),("2522499", "Abarán", "", "ES", "724", "", "31", "MU", "30011", "38.20551", "-1.39907", "Europe/Madrid"),("2522505", "Abanilla", "", "ES", "724", "", "31", "MU", "30001", "38.20537", "-1.04153", "Europe/Madrid"),("2565056", "Punta Umbría", "", "ES", "724", "", "51", "H", "21060", "37.18213", "-6.96605", "Europe/Madrid"),("2567529", "Grao de Murviedro", "", "ES", "724", "", "60", "V", "46220", "39.64167", "-0.23889", "Europe/Madrid"),("3104218", "Zumaia", "", "ES", "724", "", "59", "SS", "20081", "43.29469", "-2.25341", "Europe/Madrid"),("3104219", "Zumarraga", "", "ES", "724", "", "59", "SS", "20080", "43.08858", "-2.31408", "Europe/Madrid"),("3104226", "Zuera", "", "ES", "724", "", "52", "Z", "50298", "41.86775", "-0.78984", "Europe/Madrid"),("3104316", "Zarautz", "", "ES", "724", "", "59", "SS", "20079", "43.28444", "-2.16992", "Europe/Madrid"),("3104324", "Zaragoza", "Сарагоса", "ES", "724", "", "52", "Z", "50297", "41.65606", "-0.87734", "Europe/Madrid"),("3104342", "Zamora", "Самора", "ES", "724", "", "55", "ZA", "49275", "41.50633", "-5.74456", "Europe/Madrid"),("3104395", "Yuncos", "", "ES", "724", "", "54", "TO", "45205", "40.0859", "-3.87106", "Europe/Madrid"),("3104475", "Viveiro", "", "ES", "724", "", "58", "LU", "27066", "43.66228", "-7.59344", "Europe/Madrid"),("3104499", "Gasteiz / Vitoria", "", "ES", "724", "", "59", "VI", "01059", "42.84998", "-2.67268", "Europe/Madrid"),("3104584", "Vinaròs", "Винаросе", "ES", "724", "", "60", "CS", "12138", "40.47033", "0.47559", "Europe/Madrid"),("3104703", "Villaviciosa de Odón", "Вильявисиоса-де-Одон", "ES", "724", "", "29", "M", "28181", "40.35692", "-3.90011", "Europe/Madrid"),("3104707", "Villaviciosa", "", "ES", "724", "", "34", "O", "33076", "43.48126", "-5.43574", "Europe/Madrid"),("3104748", "Villaverde", "", "ES", "724", "", "29", "M", "28079", "40.35", "-3.7", "Europe/Madrid"),("3104979", "Villarejo de Salvanés", "", "ES", "724", "", "29", "M", "28110", "40.16663", "-3.27277", "Europe/Madrid"),("3105148", "Villaquilambre", "Вильякиламбре", "ES", "724", "", "55", "LE", "24222", "42.64685", "-5.55835", "Europe/Madrid"),("3105184", "Vilanova i la Geltrú", "", "ES", "724", "", "56", "B", "08307", "41.22392", "1.72511", "Europe/Madrid"),("3105214", "Villanueva del Pardillo", "", "ES", "724", "", "29", "M", "28177", "40.49014", "-3.96383", "Europe/Madrid"),("3105247", "Villanueva de la Cañada", "", "ES", "724", "", "29", "M", "28176", "40.44689", "-4.00428", "Europe/Madrid"),("3105267", "Vilanova de Arousa", "", "ES", "724", "", "58", "PO", "36061", "42.56667", "-8.83333", "Europe/Madrid"),("3105331", "Villamuriel de Cerrato", "", "ES", "724", "", "55", "P", "34225", "41.94935", "-4.51584", "Europe/Madrid"),("3105501", "Villalbilla", "", "ES", "724", "", "29", "M", "28172", "40.43044", "-3.29904", "Europe/Madrid"),("3105522", "Vilalba", "", "ES", "724", "", "58", "LU", "27065", "43.29806", "-7.6813", "Europe/Madrid"),("3105575", "Vilagarcía de Arousa", "", "ES", "724", "", "58", "PO", "36060", "42.59631", "-8.76426", "Europe/Madrid"),("3105600", "Vilafranca del Penedès", "Вильяфранка-дель-Пенедес", "ES", "724", "", "56", "B", "08305", "41.34618", "1.69713", "Europe/Madrid"),("3105675", "Villa del Prado", "", "ES", "724", "", "29", "M", "28171", "40.27852", "-4.30534", "Europe/Madrid"),("3105742", "Villabona", "", "ES", "724", "", "59", "SS", "20075", "43.1854", "-2.05304", "Europe/Madrid"),("3105748", "Villablino", "", "ES", "724", "", "55", "LE", "24109", "42.93932", "-6.31943", "Europe/Madrid"),("3105763", "Atarrabia", "", "ES", "724", "", "32", "NA", "31086", "42.8323", "-1.60735", "Europe/Madrid"),("3105803", "Vila-seca", "", "ES", "724", "", "56", "T", "43123", "41.11118", "1.14764", "Europe/Madrid"),("3105805", "Vilaseca", "Вила-сека", "ES", "724", "", "56", "B", "08150", "42.06174", "2.25528", "Europe/Madrid"),("3105885", "Vilanova del Camí", "", "ES", "724", "", "56", "B", "08250", "41.57165", "1.63751", "Europe/Madrid"),("3105935", "Viladecans", "Виладеканс", "ES", "724", "", "56", "B", "08089", "41.31405", "2.01427", "Europe/Madrid"),("3105976", "Vigo", "Виго", "ES", "724", "", "58", "PO", "36057", "42.23282", "-8.72264", "Europe/Madrid"),("3105994", "Vielha", "", "ES", "724", "", "56", "L", "25243", "42.70196", "0.79556", "Europe/Madrid"),("3106050", "Vic", "", "ES", "724", "", "56", "B", "08298", "41.93012", "2.25486", "Europe/Madrid"),("3106054", "Vicálvaro", "", "ES", "724", "", "29", "M", "28079", "40.4", "-3.6", "Europe/Madrid"),("3106086", "Verín", "", "ES", "724", "", "58", "OR", "32085", "41.94149", "-7.43809", "Europe/Madrid"),("3106090", "Bergara", "", "ES", "724", "", "59", "SS", "20074", "43.1151", "-2.4175", "Europe/Madrid"),("3106166", "Venta de Baños", "", "ES", "724", "", "55", "P", "34023", "41.9211", "-4.49089", "Europe/Madrid"),("3106180", "El Vendrell", "Вендрель", "ES", "724", "", "56", "T", "43163", "41.21667", "1.53333", "Europe/Madrid"),("3106202", "Velilla de San Antonio", "", "ES", "724", "", "29", "M", "28167", "40.36516", "-3.48484", "Europe/Madrid"),("3106356", "Vedra", "", "ES", "724", "", "58", "C", "15089", "42.77817", "-8.47636", "Europe/Madrid"),("3106492", "Valls", "Вальс", "ES", "724", "", "56", "T", "43161", "41.28612", "1.24993", "Europe/Madrid"),("3106515", "Vallirana", "", "ES", "724", "", "56", "B", "08295", "41.38676", "1.93205", "Europe/Madrid"),("3106672", "Valladolid", "Вальядолид", "ES", "724", "", "55", "VA", "47186", "41.65518", "-4.72372", "Europe/Madrid"),("3106702", "Valga", "", "ES", "724", "", "58", "PO", "36056", "42.69792", "-8.63959", "Europe/Madrid"),("3106732", "Valdoviño", "", "ES", "724", "", "58", "C", "15087", "43.6", "-8.13333", "Europe/Madrid"),("3106868", "Valdemoro", "Вальдеморо", "ES", "724", "", "29", "M", "28161", "40.19081", "-3.67887", "Europe/Madrid"),("3106870", "Valdemorillo", "", "ES", "724", "", "29", "M", "28160", "40.50064", "-4.0671", "Europe/Madrid"),("3107112", "Rivas-Vaciamadrid", "Васиамадрид", "ES", "724", "", "29", "M", "28123", "40.32605", "-3.51089", "Europe/Madrid"),("3107139", "Utebo", "", "ES", "724", "", "52", "Z", "50272", "41.70826", "-0.99916", "Europe/Madrid"),("3107141", "Usurbil", "", "ES", "724", "", "59", "SS", "20073", "43.27164", "-2.04912", "Europe/Madrid"),("3107204", "Urnieta", "", "ES", "724", "", "59", "SS", "20072", "43.24727", "-1.99084", "Europe/Madrid"),("3107305", "Ulldecona", "", "ES", "724", "", "56", "T", "43156", "40.59734", "0.44718", "Europe/Madrid"),("3107364", "Tui", "", "ES", "724", "", "58", "PO", "36055", "42.04713", "-8.64435", "Europe/Madrid"),("3107415", "Tudela de Duero", "", "ES", "724", "", "55", "VA", "47175", "41.5845", "-4.58093", "Europe/Madrid"),("3107418", "Tudela", "Тудела", "ES", "724", "", "32", "NA", "31232", "42.06166", "-1.60452", "Europe/Madrid"),("3107519", "Tremp", "", "ES", "724", "", "56", "L", "25234", "42.16703", "0.89487", "Europe/Madrid"),("3107661", "Tossa de Mar", "", "ES", "724", "", "56", "GI", "17202", "41.71667", "2.93333", "Europe/Madrid"),("3107677", "Tortosa", "Тортоса", "ES", "724", "", "56", "T", "43155", "40.81249", "0.5216", "Europe/Madrid"),("3107700", "Torroella de Montgrí", "", "ES", "724", "", "56", "GI", "17199", "42.04254", "3.12703", "Europe/Madrid"),("3107722", "Torres de la Alameda", "", "ES", "724", "", "29", "M", "28154", "40.40264", "-3.35767", "Europe/Madrid"),("3107765", "Torrelodones", "", "ES", "724", "", "29", "M", "28152", "40.57654", "-3.92658", "Europe/Madrid"),("3107775", "Torrelavega", "Торрелавега", "ES", "724", "", "39", "S", "39087", "43.34943", "-4.04785", "Europe/Madrid"),("3107783", "Torrejón de la Calzada", "", "ES", "724", "", "29", "M", "28149", "40.19886", "-3.797", "Europe/Madrid"),("3107784", "Torrejón de Ardoz", "Торрехон-де-Ардос", "ES", "724", "", "29", "M", "28148", "40.45535", "-3.46973", "Europe/Madrid"),("3107807", "Torredembarra", "", "ES", "724", "", "56", "T", "43153", "41.14505", "1.39861", "Europe/Madrid"),("3107849", "Torreblanca", "", "ES", "724", "", "60", "CS", "12117", "40.22033", "0.1965", "Europe/Madrid"),("3107886", "Toro", "", "ES", "724", "", "55", "ZA", "49219", "41.52417", "-5.39534", "Europe/Madrid"),("3107941", "Torelló", "", "ES", "724", "", "56", "B", "08150", "42.04627", "2.26679", "Europe/Madrid"),("3107952", "Tordesillas", "", "ES", "724", "", "55", "VA", "47165", "41.50202", "-5.00146", "Europe/Madrid"),("3107955", "Tordera", "", "ES", "724", "", "56", "B", "08284", "41.69914", "2.71888", "Europe/Madrid"),("3107997", "Tona", "", "ES", "724", "", "56", "B", "08283", "41.84789", "2.22808", "Europe/Madrid"),("3108000", "Tomiño", "", "ES", "724", "", "58", "PO", "36054", "41.98772", "-8.75502", "Europe/Madrid"),("3108008", "Tolosa", "", "ES", "724", "", "59", "SS", "20071", "43.13484", "-2.07801", "Europe/Madrid"),("3108087", "Tineo", "", "ES", "724", "", "34", "O", "33073", "43.33765", "-6.41452", "Europe/Madrid"),("3108110", "Tiana", "", "ES", "724", "", "56", "B", "08282", "41.48201", "2.26702", "Europe/Madrid"),("3108116", "Teià", "", "ES", "724", "", "56", "B", "08281", "41.49804", "2.32206", "Europe/Madrid"),("3108118", "Tetuán de las Victorias", "", "ES", "724", "", "29", "M", "28079", "40.46667", "-3.71667", "Europe/Madrid"),("3108126", "Teruel", "Теруэль", "ES", "724", "", "52", "TE", "44216", "40.3456", "-1.10646", "Europe/Madrid"),("3108165", "Teo", "", "ES", "724", "", "58", "C", "15082", "42.75", "-8.5", "Europe/Madrid"),("3108269", "Tauste", "", "ES", "724", "", "52", "Z", "50252", "41.91804", "-1.25343", "Europe/Madrid"),("3108285", "Tàrrega", "", "ES", "724", "", "56", "L", "25217", "41.64704", "1.13957", "Europe/Madrid"),("3108286", "Terrassa", "Террасса", "ES", "724", "", "56", "B", "08279", "41.56667", "2.01667", "Europe/Madrid"),("3108288", "Tarragona", "Таррагона", "ES", "724", "", "56", "T", "43148", "41.11667", "1.25", "Europe/Madrid"),("3108308", "Tarazona", "", "ES", "724", "", "52", "Z", "50251", "41.90475", "-1.72678", "Europe/Madrid"),("3108317", "Tarancón", "Таранкон", "ES", "724", "", "54", "CU", "16203", "40.00851", "-3.00731", "Europe/Madrid"),("3108327", "Taradell", "", "ES", "724", "", "56", "B", "08278", "41.87495", "2.28662", "Europe/Madrid"),("3108412", "Tafalla", "", "ES", "724", "", "32", "NA", "31227", "42.52687", "-1.67446", "Europe/Madrid"),("3108487", "Súria", "", "ES", "724", "", "56", "B", "08229", "41.83333", "1.75", "Europe/Madrid"),("3108534", "Suances", "", "ES", "724", "", "39", "S", "39085", "43.43341", "-4.04338", "Europe/Madrid"),("3108681", "Soria", "Сория", "ES", "724", "", "55", "SO", "42173", "41.76401", "-2.46883", "Europe/Madrid"),("3108702", "Sopela", "", "ES", "724", "", "59", "BI", "48085", "43.37891", "-2.98313", "Europe/Madrid"),("3108747", "Solsona", "", "ES", "724", "", "56", "L", "25151", "41.99395", "1.51706", "Europe/Madrid"),("3108877", "Sitges", "Ситжес", "ES", "724", "", "56", "B", "08270", "41.23506", "1.81193", "Europe/Madrid"),("3108950", "Silleda", "", "ES", "724", "", "58", "PO", "36052", "42.69605", "-8.24653", "Europe/Madrid"),("3109018", "Sevilla La Nueva", "", "ES", "724", "", "29", "M", "28141", "40.34775", "-4.02727", "Europe/Madrid"),("3109041", "Sestao", "Сестао", "ES", "724", "", "59", "BI", "48084", "43.30975", "-3.00716", "Europe/Madrid"),("3109050", "Seseña", "", "ES", "724", "", "54", "TO", "45161", "40.10473", "-3.69793", "Europe/Madrid"),("3109143", "la Seu d'Urgell", "", "ES", "724", "", "56", "L", "25005", "42.35877", "1.46144", "Europe/Madrid"),("3109165", "Sentmenat", "", "ES", "724", "", "56", "B", "08033", "41.60862", "2.13532", "Europe/Madrid"),("3109256", "Segovia", "Сеговия", "ES", "724", "", "55", "SG", "40194", "40.94808", "-4.11839", "Europe/Madrid"),("3109369", "Sarria", "", "ES", "724", "", "58", "LU", "27057", "42.78148", "-7.41431", "Europe/Madrid"),("3109402", "Cerdanyola del Vallès", "", "ES", "724", "", "56", "B", "08266", "41.49109", "2.14079", "Europe/Madrid"),("3109440", "Sant Vicenç de Montalt", "", "ES", "724", "", "56", "B", "08197", "41.57853", "2.50879", "Europe/Madrid"),("3109442", "Sant Vicenç dels Horts", "", "ES", "724", "", "56", "B", "08263", "41.39317", "2.00689", "Europe/Madrid"),("3109451", "Sant Vicenç de Castellet", "", "ES", "724", "", "56", "B", "08053", "41.66667", "1.86667", "Europe/Madrid"),("3109453", "Barakaldo", "", "ES", "724", "", "59", "BI", "48013", "43.29639", "-2.98813", "Europe/Madrid"),("3109481", "Santurtzi", "", "ES", "724", "", "59", "BI", "48082", "43.32842", "-3.03248", "Europe/Madrid"),("3109527", "Santoña", "", "ES", "724", "", "39", "S", "39079", "43.44386", "-3.45757", "Europe/Madrid"),("3109535", "Santo Domingo de la Calzada", "", "ES", "724", "", "27", "LO", "26138", "42.44015", "-2.95365", "Europe/Madrid"),("3109546", "Sant Just Desvern", "", "ES", "724", "", "56", "B", "08019", "41.38389", "2.06758", "Europe/Madrid"),("3109551", "Sant Joan de Vilatorrada", "", "ES", "724", "", "56", "B", "08113", "41.74549", "1.80476", "Europe/Madrid"),("3109642", "Santiago de Compostela", "Сантьяго-де-Компостела", "ES", "724", "", "58", "C", "15078", "42.88052", "-8.54569", "Europe/Madrid"),("3109689", "Santa Perpètua de Mogoda", "", "ES", "724", "", "56", "B", "08260", "41.53333", "2.18333", "Europe/Madrid"),("3109718", "Santander", "Сантандер", "ES", "724", "", "39", "S", "39075", "43.46472", "-3.80444", "Europe/Madrid"),("3109721", "Santa Marta de Tormes", "", "ES", "724", "", "55", "SA", "37294", "40.95065", "-5.62723", "Europe/Madrid"),("3109724", "Santa Marta de Ortigueira", "", "ES", "724", "", "58", "C", "15061", "43.68333", "-7.85", "Europe/Madrid"),("3109764", "Santa Maria de Palautordera", "", "ES", "724", "", "56", "B", "08259", "41.7", "2.45", "Europe/Madrid"),("3109800", "Santa María de Cayón", "", "ES", "724", "", "39", "S", "39074", "43.30849", "-3.8368", "Europe/Madrid"),("3109804", "Barberà del Vallès", "", "ES", "724", "", "56", "B", "08252", "41.5159", "2.12457", "Europe/Madrid"),("3109871", "Santa Eulàlia de Ronçana", "", "ES", "724", "", "56", "B", "08248", "41.65", "2.23333", "Europe/Madrid"),("3109935", "Santa Cruz de Bezana", "", "ES", "724", "", "39", "S", "39073", "43.4437", "-3.90324", "Europe/Madrid"),("3109957", "Santa Cristina d'Aro", "", "ES", "724", "", "56", "GI", "17181", "41.81667", "3", "Europe/Madrid"),("3109966", "Santa Comba", "", "ES", "724", "", "58", "C", "15077", "43.03306", "-8.80925", "Europe/Madrid"),("3109981", "Santa Coloma de Gramenet", "Санта-Колома-де-Граманет", "ES", "724", "", "56", "B", "08125", "41.45152", "2.2081", "Europe/Madrid"),("3109982", "Santa Coloma de Farners", "", "ES", "724", "", "56", "GI", "17180", "41.86667", "2.66667", "Europe/Madrid"),("3109983", "Santa Coloma de Cervelló", "", "ES", "724", "", "56", "B", "08244", "41.36736", "2.01426", "Europe/Madrid"),("3110040", "San Sebastián de los Reyes", "Сан-Себастиан-де-лос-Рейес", "ES", "724", "", "29", "M", "28134", "40.55555", "-3.62733", "Europe/Madrid"),("3110044", "Donostia / San Sebastián", "Сан-Себастьян", "ES", "724", "", "59", "SS", "20069", "43.31283", "-1.97499", "Europe/Madrid"),("3110064", "Sant Sadurní d'Anoia", "", "ES", "724", "", "56", "B", "08273", "41.42555", "1.78519", "Europe/Madrid"),("3110101", "Sant Quirze del Vallès", "", "ES", "724", "", "56", "B", "08238", "41.53333", "2.08333", "Europe/Madrid"),("3110110", "Sant Pol de Mar", "", "ES", "724", "", "56", "B", "08235", "41.60177", "2.61741", "Europe/Madrid"),("3110143", "Sant Pere de Ribes", "", "ES", "724", "", "56", "B", "08270", "41.26045", "1.77391", "Europe/Madrid"),("3110326", "San Martín de Valdeiglesias", "", "ES", "724", "", "29", "M", "28133", "40.36185", "-4.39831", "Europe/Madrid"),("3110360", "San Martín de la Vega", "Сан-Мартин-де-ла-Вега", "ES", "724", "", "29", "M", "28132", "40.20735", "-3.57063", "Europe/Madrid"),("3110458", "San Lorenzo de El Escorial", "Сан-Лоренсо-де-Эль-Эскориаль", "ES", "724", "", "29", "M", "28131", "40.59144", "-4.14738", "Europe/Madrid"),("3110516", "Vilassar de Mar", "", "ES", "724", "", "56", "B", "08219", "41.50507", "2.39227", "Europe/Madrid"),("3110519", "Sant Joan Despí", "Sant Joan Despí", "ES", "724", "", "56", "B", "08019", "41.36718", "2.0574", "Europe/Madrid"),("3110581", "San Ildefonso", "", "ES", "724", "", "55", "SG", "40181", "40.90182", "-4.00685", "Europe/Madrid"),("3110589", "Sangüesa", "", "ES", "724", "", "32", "NA", "31135", "42.57483", "-1.28283", "Europe/Madrid"),("3110610", "Sanxenxo", "", "ES", "724", "", "58", "PO", "36051", "42.39996", "-8.80698", "Europe/Madrid"),("3110627", "San Fernando de Henares", "", "ES", "724", "", "29", "M", "28130", "40.42386", "-3.53261", "Europe/Madrid"),("3110642", "Sant Feliu de Llobregat", "Фелиу-де-Льобрегат", "ES", "724", "", "56", "B", "08211", "41.38333", "2.05", "Europe/Madrid"),("3110643", "Sant Feliu de Guíxols", "", "ES", "724", "", "56", "GI", "17160", "41.78333", "3.03333", "Europe/Madrid"),("3110718", "Sant Cugat del Vallès", "", "ES", "724", "", "56", "B", "08205", "41.47063", "2.08611", "Europe/Madrid"),("3110813", "Sant Celoni", "", "ES", "724", "", "56", "B", "08202", "41.68921", "2.48965", "Europe/Madrid"),("3110821", "Sant Carles de la Ràpita", "Сан-Карлос-де-ла-Рапита", "ES", "724", "", "56", "T", "43136", "40.61667", "0.6", "Europe/Madrid"),("3110834", "Sant Boi de Llobregat", "", "ES", "724", "", "56", "B", "08200", "41.34357", "2.03659", "Europe/Madrid"),("3110876", "Sant Andreu de Palomar", "", "ES", "724", "", "56", "B", "08019", "41.43541", "2.18982", "Europe/Madrid"),("3110880", "San Andrés del Rabanedo", "Сан-Андрес-дель-Рабанедо", "ES", "724", "", "55", "LE", "24089", "42.61174", "-5.61671", "Europe/Madrid"),("3110881", "Sant Andreu de Llavaneres", "", "ES", "724", "", "56", "B", "08121", "41.56667", "2.48333", "Europe/Madrid"),("3110885", "Sant Andreu de la Barca", "", "ES", "724", "", "56", "B", "08054", "41.44659", "1.97187", "Europe/Madrid"),("3110911", "San Agustín de Guadalix", "", "ES", "724", "", "29", "M", "28045", "40.67882", "-3.61639", "Europe/Madrid"),("3110921", "Sant Adrià de Besòs", "", "ES", "724", "", "56", "B", "08019", "41.43073", "2.21855", "Europe/Madrid"),("3110924", "San Adrián", "", "ES", "724", "", "32", "NA", "31215", "42.33433", "-1.93509", "Europe/Madrid"),("3110962", "Sama", "Саме", "ES", "724", "", "34", "O", "33031", "43.29568", "-5.68416", "Europe/Madrid"),("3110983", "Salt", "", "ES", "724", "", "56", "GI", "17155", "41.97489", "2.79281", "Europe/Madrid"),("3110986", "Salou", "Салоу", "ES", "724", "", "56", "T", "43171", "41.07663", "1.14163", "Europe/Madrid"),("3111003", "Sallent", "", "ES", "724", "", "56", "B", "08191", "41.82602", "1.8955", "Europe/Madrid"),("3111101", "Salas", "", "ES", "724", "", "34", "O", "33059", "43.4118", "-6.26023", "Europe/Madrid"),("3111108", "Salamanca", "Саламанка", "ES", "724", "", "55", "SA", "37274", "40.96882", "-5.66388", "Europe/Madrid"),("3111158", "Sada", "", "ES", "724", "", "58", "C", "15075", "43.35619", "-8.25796", "Europe/Madrid"),("3111185", "Sabiñánigo", "", "ES", "724", "", "52", "HU", "22199", "42.51924", "-0.36607", "Europe/Madrid"),("3111199", "Sabadell", "", "ES", "724", "", "56", "B", "08187", "41.54329", "2.10942", "Europe/Madrid"),("3111294", "Rubí", "Руби", "ES", "724", "", "56", "B", "08184", "41.49226", "2.03305", "Europe/Madrid"),("3111348", "Roses", "Росас", "ES", "724", "", "56", "GI", "17152", "42.26199", "3.17689", "Europe/Madrid"),("3111353", "O Rosal", "", "ES", "724", "", "58", "PO", "36023", "41.93536", "-8.83677", "Europe/Madrid"),("3111590", "Riudoms", "", "ES", "724", "", "56", "T", "43129", "41.13333", "1.05", "Europe/Madrid"),("3111605", "Ripollet", "", "ES", "724", "", "56", "B", "08180", "41.49686", "2.15739", "Europe/Madrid"),("3111607", "Ripoll", "", "ES", "724", "", "56", "GI", "17096", "42.20064", "2.19033", "Europe/Madrid"),("3111704", "Ruayer", "", "ES", "724", "", "34", "O", "33002", "43.05372", "-5.55019", "Europe/Madrid"),("3111807", "Ribeira", "", "ES", "724", "", "58", "C", "15089", "42.74611", "-8.44392", "Europe/Madrid"),("3111855", "Ribadesella", "", "ES", "724", "", "34", "O", "33056", "43.46145", "-5.05955", "Europe/Madrid"),("3111859", "Ribadeo", "", "ES", "724", "", "58", "LU", "27051", "43.53704", "-7.04095", "Europe/Madrid"),("3111863", "Ribadavia", "", "ES", "724", "", "58", "OR", "32069", "42.28804", "-8.14362", "Europe/Madrid"),("3111879", "Rianxo", "", "ES", "724", "", "58", "C", "15072", "42.64977", "-8.81763", "Europe/Madrid"),("3111933", "Reus", "Реус", "ES", "724", "", "56", "T", "43123", "41.15612", "1.10687", "Europe/Madrid"),("3112008", "Reocín", "", "ES", "724", "", "39", "S", "39060", "43.33915", "-4.09403", "Europe/Madrid"),("3112011", "Errenteria", "", "ES", "724", "", "59", "SS", "20067", "43.31195", "-1.90234", "Europe/Madrid"),("3112075", "Reinosa", "", "ES", "724", "", "39", "S", "39059", "42.99959", "-4.13801", "Europe/Madrid"),("3112154", "Redondela", "Редондела", "ES", "724", "", "58", "PO", "36045", "42.28337", "-8.6096", "Europe/Madrid"),("3112680", "Puigcerdà", "", "ES", "724", "", "56", "GI", "17141", "42.4316", "1.92819", "Europe/Madrid"),("3112721", "As Pontes de García Rodríguez", "", "ES", "724", "", "58", "C", "15070", "43.45266", "-7.85178", "Europe/Madrid"),("3112737", "Puente de Vallecas", "", "ES", "724", "", "29", "M", "28079", "40.39354", "-3.662", "Europe/Madrid"),("3112761", "Ponteareas", "", "ES", "724", "", "58", "PO", "36042", "42.17476", "-8.50398", "Europe/Madrid"),("3112866", "Premià de Mar", "Премия-де-Мар", "ES", "724", "", "56", "B", "08172", "41.49206", "2.36524", "Europe/Madrid"),("3112989", "Pozuelo de Alarcón", "Посуэло-де-Аларкон", "ES", "724", "", "29", "M", "28115", "40.43293", "-3.81338", "Europe/Madrid"),("3113035", "Poio", "", "ES", "724", "", "58", "PO", "36038", "42.44775", "-8.68594", "Europe/Madrid"),("3113082", "Portugalete", "Португалете", "ES", "724", "", "59", "BI", "48078", "43.32099", "-3.02064", "Europe/Madrid"),("3113157", "Porriño", "", "ES", "724", "", "58", "PO", "36039", "42.16156", "-8.6198", "Europe/Madrid"),("3113209", "Pontevedra", "Понтеведра", "ES", "724", "", "58", "PO", "36038", "42.431", "-8.64435", "Europe/Madrid"),("3113236", "Ponferrada", "Понферрада", "ES", "724", "", "55", "LE", "24115", "42.54664", "-6.59619", "Europe/Madrid"),("3113254", "Polinyà", "", "ES", "724", "", "56", "B", "08167", "41.55", "2.15", "Europe/Madrid"),("3113268", "Pola de Siero", "Пола-де-Сьеро", "ES", "724", "", "34", "O", "33066", "43.39228", "-5.66335", "Europe/Madrid"),("3113270", "Pola de Lena", "", "ES", "724", "", "34", "O", "33033", "43.16089", "-5.82878", "Europe/Madrid"),("3113271", "Pola de Laviana", "", "ES", "724", "", "34", "O", "33032", "43.24538", "-5.5629", "Europe/Madrid"),("3113331", "Plasencia", "Пласенсиа", "ES", "724", "", "57", "CC", "10148", "40.03116", "-6.08845", "Europe/Madrid"),("3113415", "Pinto", "Пинто", "ES", "724", "", "29", "M", "28113", "40.24147", "-3.69999", "Europe/Madrid"),("3113526", "Pineda de Mar", "Пинеда де Мар", "ES", "724", "", "56", "B", "08163", "41.62763", "2.6889", "Europe/Madrid"),("3113555", "Piloña", "", "ES", "724", "", "34", "O", "33049", "43.35", "-5.36667", "Europe/Madrid"),("3113576", "Piera", "", "ES", "724", "", "56", "B", "08028", "41.52232", "1.75076", "Europe/Madrid"),("3113738", "Pereiro de Aguiar", "", "ES", "724", "", "58", "OR", "32058", "42.34524", "-7.80008", "Europe/Madrid"),("3113800", "Peralta", "", "ES", "724", "", "32", "NA", "31202", "42.33834", "-1.80035", "Europe/Madrid"),("3113860", "Peníscola", "", "ES", "724", "", "60", "CS", "12089", "40.3574", "0.40692", "Europe/Madrid"),("3113910", "Peñaranda de Bracamonte", "", "ES", "724", "", "55", "SA", "37246", "40.90108", "-5.20026", "Europe/Madrid"),("3113957", "Peñafiel", "", "ES", "724", "", "55", "VA", "47114", "41.60165", "-4.11418", "Europe/Madrid"),("3114245", "Parres", "", "ES", "724", "", "34", "O", "33045", "43.35", "-5.15", "Europe/Madrid"),("3114256", "Parla", "Парла", "ES", "724", "", "29", "M", "28106", "40.23604", "-3.76752", "Europe/Madrid"),("3114267", "Parets del Vallès", "", "ES", "724", "", "56", "B", "08107", "41.57481", "2.23306", "Europe/Madrid"),("3114397", "Paracuellos de Jarama", "", "ES", "724", "", "29", "M", "28104", "40.50353", "-3.52775", "Europe/Madrid"),("3114472", "Pamplona", "Памплона", "ES", "724", "", "32", "NA", "31201", "42.81687", "-1.64323", "Europe/Madrid"),("3114516", "Pallejà", "", "ES", "724", "", "56", "B", "08157", "41.42394", "1.99505", "Europe/Madrid"),("3114531", "Palencia", "Паленсия", "ES", "724", "", "55", "P", "34120", "42.00955", "-4.52406", "Europe/Madrid"),("3114566", "Palamós", "", "ES", "724", "", "56", "GI", "17118", "41.84843", "3.12912", "Europe/Madrid"),("3114567", "Palafrugell", "Палафружель", "ES", "724", "", "56", "GI", "17117", "41.91738", "3.1631", "Europe/Madrid"),("3114643", "Padrón", "", "ES", "724", "", "58", "C", "15065", "42.73875", "-8.66057", "Europe/Madrid"),("3114711", "Oviedo", "Овьедо", "ES", "724", "", "34", "O", "33044", "43.36029", "-5.84476", "Europe/Madrid"),("3114726", "Outes", "", "ES", "724", "", "58", "C", "15062", "42.86189", "-8.90181", "Europe/Madrid"),("3114780", "Outeiro de Rei", "", "ES", "724", "", "58", "LU", "27039", "43.10198", "-7.61497", "Europe/Madrid"),("3114866", "Ortuella", "", "ES", "724", "", "59", "BI", "48083", "43.31113", "-3.05617", "Europe/Madrid"),("3114904", "Oroso", "", "ES", "724", "", "58", "C", "15078", "42.98333", "-8.43333", "Europe/Madrid"),("3114912", "Oropesa del Mar", "", "ES", "724", "", "60", "CS", "12085", "40.09134", "0.14115", "Europe/Madrid"),("3114957", "Oria", "", "ES", "724", "", "59", "SS", "20902", "43.25541", "-2.01873", "Europe/Madrid"),("3114965", "Ourense", "Оренсе", "ES", "724", "", "58", "OR", "32054", "42.33669", "-7.86407", "Europe/Madrid"),("3114992", "Ordes", "", "ES", "724", "", "58", "C", "15059", "43.07654", "-8.409", "Europe/Madrid"),("3115056", "Ondarroa", "", "ES", "724", "", "59", "BI", "48073", "43.31667", "-2.41667", "Europe/Madrid"),("3115063", "Oñati", "", "ES", "724", "", "59", "SS", "20059", "43.03262", "-2.40997", "Europe/Madrid"),("3115093", "Olot", "Олот", "ES", "724", "", "56", "GI", "17114", "42.18096", "2.49012", "Europe/Madrid"),("3115171", "Olesa de Montserrat", "", "ES", "724", "", "56", "B", "08076", "41.54372", "1.89407", "Europe/Madrid"),("3115177", "Oleiros", "Олейрос", "ES", "724", "", "58", "C", "15058", "43.33333", "-8.31667", "Europe/Madrid"),("3115314", "Nuevo Baztán", "", "ES", "724", "", "29", "M", "28100", "40.36731", "-3.24125", "Europe/Madrid"),("3115463", "Nigrán", "Нигран", "ES", "724", "", "58", "PO", "36035", "42.14153", "-8.80656", "Europe/Madrid"),("3115523", "Negreira", "", "ES", "724", "", "58", "C", "15013", "42.90402", "-8.74273", "Europe/Madrid"),("3115553", "Navia", "", "ES", "724", "", "34", "O", "33041", "43.53544", "-6.71935", "Europe/Madrid"),("3115593", "Navàs", "", "ES", "724", "", "56", "B", "08018", "41.89998", "1.87763", "Europe/Madrid"),("3115616", "Navarcles", "", "ES", "724", "", "56", "B", "08213", "41.75171", "1.90357", "Europe/Madrid"),("3115659", "Navalcarnero", "Навалькарнеро", "ES", "724", "", "29", "M", "28096", "40.28908", "-4.01197", "Europe/Madrid"),("3115739", "Narón", "Нарон", "ES", "724", "", "58", "C", "15054", "43.50175", "-8.19082", "Europe/Madrid"),("3115780", "Nájera", "", "ES", "724", "", "27", "LO", "26102", "42.41822", "-2.72865", "Europe/Madrid"),("3115824", "Muros", "", "ES", "724", "", "58", "C", "15053", "42.77617", "-9.06032", "Europe/Madrid"),("3115907", "Mungia", "", "ES", "724", "", "59", "BI", "48069", "43.35461", "-2.84524", "Europe/Madrid"),("3115941", "Mugia", "", "ES", "724", "", "58", "C", "15052", "43.10414", "-9.21791", "Europe/Madrid"),("3115943", "Mugardos", "", "ES", "724", "", "58", "C", "15051", "43.4604", "-8.25507", "Europe/Madrid"),("3115985", "Moià", "", "ES", "724", "", "56", "B", "08138", "41.81112", "2.09839", "Europe/Madrid"),("3116025", "Móstoles", "Мостолес", "ES", "724", "", "29", "M", "28092", "40.32234", "-3.86496", "Europe/Madrid"),("3116057", "Mos", "", "ES", "724", "", "58", "LU", "27010", "43.15667", "-7.55047", "Europe/Madrid"),("3116156", "Moratalaz", "", "ES", "724", "ES", "29", "M", "28079", "40.41667", "-3.65", "Europe/Madrid"),("3116157", "Morata de Tajuña", "", "ES", "724", "", "29", "M", "28091", "40.2268", "-3.43269", "Europe/Madrid"),("3116175", "Moralzarzal", "", "ES", "724", "", "29", "M", "28090", "40.67816", "-3.9707", "Europe/Madrid"),("3116198", "Moraleja", "", "ES", "724", "", "57", "CC", "10128", "40.06682", "-6.65983", "Europe/Madrid"),("3116224", "Monzón", "", "ES", "724", "", "52", "HU", "22158", "41.91084", "0.19406", "Europe/Madrid"),("3116246", "Mont-roig del Camp", "", "ES", "724", "", "56", "T", "43167", "41.08675", "0.95925", "Europe/Madrid"),("3116262", "Montornès del Vallès", "", "ES", "724", "", "56", "B", "08136", "41.54206", "2.26748", "Europe/Madrid"),("3116276", "Montmeló", "", "ES", "724", "", "56", "B", "08159", "41.55002", "2.2419", "Europe/Madrid"),("3116351", "Montehermoso", "", "ES", "724", "", "57", "CC", "10127", "40.08796", "-6.34984", "Europe/Madrid"),("3116411", "Montblanc", "", "ES", "724", "", "56", "T", "43086", "41.37636", "1.16163", "Europe/Madrid"),("3116474", "Montgat", "", "ES", "724", "", "56", "B", "08126", "41.46859", "2.28001", "Europe/Madrid"),("3116478", "Monforte de Lemos", "Монфорте-де-Лемос", "ES", "724", "", "58", "LU", "27031", "42.52165", "-7.51422", "Europe/Madrid"),("3116503", "Arrasate / Mondragón", "", "ES", "724", "", "59", "SS", "20055", "43.06441", "-2.48977", "Europe/Madrid"),("3116514", "Mondariz", "", "ES", "724", "", "58", "PO", "36030", "42.2311", "-8.45839", "Europe/Madrid"),("3116527", "Montcada i Reixac", "", "ES", "724", "", "56", "B", "08125", "41.48333", "2.18333", "Europe/Madrid"),("3116553", "Mollet del Vallès", "", "ES", "724", "", "56", "B", "08125", "41.54026", "2.21306", "Europe/Madrid"),("3116554", "Mollerussa", "", "ES", "724", "", "56", "L", "25137", "41.63333", "0.9", "Europe/Madrid"),("3116562", "Molins de Rei", "", "ES", "724", "", "56", "B", "08205", "41.41667", "2.01667", "Europe/Madrid"),("3116653", "Moaña", "Моания", "ES", "724", "", "58", "PO", "36029", "42.28333", "-8.75", "Europe/Madrid"),("3116689", "Miranda de Ebro", "Миранда-де-Эбро", "ES", "724", "", "55", "BU", "09219", "42.6865", "-2.94695", "Europe/Madrid"),("3116708", "Miraflores de la Sierra", "", "ES", "724", "", "29", "M", "28085", "40.8155", "-3.76213", "Europe/Madrid"),("3116729", "Miño", "", "ES", "724", "", "58", "C", "15048", "43.35", "-8.2", "Europe/Madrid"),("3116789", "Mieres", "Мьерес", "ES", "724", "", "34", "O", "33037", "43.25", "-5.76667", "Europe/Madrid"),("3116963", "Mejorada del Campo", "", "ES", "724", "", "29", "M", "28084", "40.39283", "-3.48194", "Europe/Madrid"),("3117008", "Medina de Ríoseco", "", "ES", "724", "", "55", "VA", "47086", "41.88327", "-5.04405", "Europe/Madrid"),("3117009", "Medina de Pomar", "", "ES", "724", "", "55", "BU", "09209", "42.92938", "-3.48804", "Europe/Madrid"),("3117010", "Medina del Campo", "Медина-дель-Кампо", "ES", "724", "", "55", "VA", "47085", "41.31239", "-4.91413", "Europe/Madrid"),("3117041", "Meco", "", "ES", "724", "", "29", "M", "28083", "40.55274", "-3.32894", "Europe/Madrid"),("3117048", "Meaño", "", "ES", "724", "", "58", "PO", "36051", "42.44661", "-8.78122", "Europe/Madrid"),("3117076", "Mazaricos", "", "ES", "724", "", "58", "C", "15045", "42.94033", "-8.97187", "Europe/Madrid"),("3117164", "Mataró", "Матаро", "ES", "724", "", "56", "B", "08121", "41.54211", "2.4445", "Europe/Madrid"),("3117200", "Matadepera", "", "ES", "724", "", "56", "B", "08279", "41.59886", "2.02648", "Europe/Madrid"),("3117225", "Masquefa", "", "ES", "724", "", "56", "B", "08119", "41.50353", "1.81136", "Europe/Madrid"),("3117232", "El Masnou", "", "ES", "724", "", "56", "B", "08118", "41.47978", "2.3188", "Europe/Madrid"),("3117331", "Martorell", "Марторелле", "ES", "724", "", "56", "B", "08114", "41.47402", "1.93062", "Europe/Madrid"),("3117409", "Marín", "", "ES", "724", "", "58", "PO", "36026", "42.38333", "-8.7", "Europe/Madrid"),("3117503", "Manzanares el Real", "", "ES", "724", "", "29", "M", "28082", "40.72627", "-3.86265", "Europe/Madrid"),("3117533", "Manresa", "Манреса", "ES", "724", "", "56", "B", "08213", "41.72815", "1.82399", "Europe/Madrid"),("3117539", "Manlleu", "Манльеу", "ES", "724", "", "56", "B", "08112", "42.00228", "2.28476", "Europe/Madrid"),("3117606", "Malpica", "", "ES", "724", "", "58", "C", "15043", "43.3228", "-8.81052", "Europe/Madrid"),("3117636", "Malgrat de Mar", "", "ES", "724", "", "56", "B", "08110", "41.64662", "2.74135", "Europe/Madrid"),("3117667", "Majadahonda", "Махадаонда", "ES", "724", "", "29", "M", "28080", "40.47353", "-3.87182", "Europe/Madrid"),("3117735", "Madrid", "Мадрид", "ES", "724", "", "29", "M", "28079", "40.4165", "-3.70256", "Europe/Madrid"),("3117811", "Lugones", "", "ES", "724", "", "34", "O", "33066", "43.40272", "-5.81215", "Europe/Madrid"),("3117814", "Lugo", "Луго", "ES", "724", "", "58", "LU", "27028", "43.00992", "-7.55602", "Europe/Madrid"),("3117862", "Luanco", "", "ES", "724", "", "34", "O", "33025", "43.61517", "-5.79344", "Europe/Madrid"),("3118024", "Los Corrales de Buelna", "", "ES", "724", "", "39", "S", "39025", "43.26358", "-4.07262", "Europe/Madrid"),("3118150", "Logroño", "Логроньо", "ES", "724", "", "27", "LO", "26089", "42.46667", "-2.45", "Europe/Madrid"),("3118212", "Lloret de Mar", "Льорет-де-Мар", "ES", "724", "", "56", "GI", "17095", "41.69993", "2.84565", "Europe/Madrid"),("3118228", "Laudio / Llodio", "", "ES", "724", "", "59", "VI", "01036", "43.14322", "-2.96204", "Europe/Madrid"),("3118238", "Lliçà d'Amunt", "", "ES", "724", "", "56", "B", "08107", "41.61667", "2.23333", "Europe/Madrid"),("3118304", "Llanes", "", "ES", "724", "", "34", "O", "33036", "43.41982", "-4.75485", "Europe/Madrid"),("3118307", "Llanera", "", "ES", "724", "", "34", "O", "33054", "43.46189", "-5.9311", "Europe/Madrid"),("3118340", "Llagostera", "", "ES", "724", "", "56", "GI", "17089", "41.82688", "2.89365", "Europe/Madrid"),("3118469", "Lezo", "", "ES", "724", "", "59", "SS", "20053", "43.32142", "-1.89739", "Europe/Madrid"),("3118514", "Lleida", "Лерида", "ES", "724", "", "56", "L", "25120", "41.61674", "0.62218", "Europe/Madrid"),("3118523", "Lekeitio", "", "ES", "724", "", "59", "BI", "48057", "43.36417", "-2.50492", "Europe/Madrid"),("3118532", "León", "Леон", "ES", "724", "", "55", "LE", "24089", "42.60003", "-5.57032", "Europe/Madrid"),("3118554", "Leioa", "", "ES", "724", "", "59", "BI", "48054", "43.32686", "-2.98884", "Europe/Madrid"),("3118594", "Leganés", "Леганес", "ES", "724", "", "29", "M", "28074", "40.32718", "-3.7635", "Europe/Madrid"),("3118848", "Las Rozas de Madrid", "Лас-Росас-де-Мадрид", "ES", "724", "", "29", "M", "28127", "40.49292", "-3.87371", "Europe/Madrid"),("3118888", "Las Navas del Marqués", "", "ES", "724", "", "55", "AV", "05168", "40.60244", "-4.33449", "Europe/Madrid"),("3118900", "Las Matas", "", "ES", "724", "", "29", "M", "28127", "40.55779", "-3.89173", "Europe/Madrid"),("3119027", "Lasarte", "", "ES", "724", "", "59", "SS", "20902", "43.26774", "-2.02169", "Europe/Madrid"),("3119099", "La Roca del Vallès", "", "ES", "724", "", "56", "B", "08181", "41.58333", "2.33333", "Europe/Madrid"),("3119145", "Laredo", "", "ES", "724", "", "39", "S", "39035", "43.4098", "-3.41613", "Europe/Madrid"),("3119153", "Lardero", "", "ES", "724", "", "27", "LO", "26084", "42.42686", "-2.46153", "Europe/Madrid"),("3119172", "Laracha", "", "ES", "724", "", "58", "C", "15019", "43.25375", "-8.58535", "Europe/Madrid"),("3119231", "La Pineda", "Ла Пинеда", "ES", "724", "ES", "56", "B", "08056", "41.07625", "1.18515", "Europe/Madrid"),("3119531", "La Llagosta", "", "ES", "724", "", "56", "B", "08125", "41.51435", "2.19297", "Europe/Madrid"),("3119536", "Lalín", "Лалин", "ES", "724", "", "58", "PO", "36024", "42.66085", "-8.11285", "Europe/Madrid"),("3119631", "Laguna de Duero", "Лагуна-де-Дуэро", "ES", "724", "", "55", "VA", "47076", "41.58151", "-4.72332", "Europe/Madrid"),("3119694", "la Garriga", "", "ES", "724", "", "56", "B", "08086", "41.68333", "2.28333", "Europe/Madrid"),("3119746", "A Estrada", "", "ES", "724", "", "58", "PO", "36017", "42.68911", "-8.48842", "Europe/Madrid"),("3119779", "l'Escala", "", "ES", "724", "", "56", "GI", "17062", "42.12562", "3.13261", "Europe/Madrid"),("3119841", "A Coruña", "Ла-Корунья", "ES", "724", "", "58", "C", "15030", "43.37135", "-8.396", "Europe/Madrid"),("3119952", "la Bisbal d'Empordà", "", "ES", "724", "", "56", "GI", "17022", "41.95", "3.05", "Europe/Madrid"),("3119979", "La Bañeza", "", "ES", "724", "", "55", "LE", "24010", "42.30026", "-5.89772", "Europe/Madrid"),("3120006", "L'Ametlla del Vallès", "", "ES", "724", "", "56", "B", "08005", "41.66667", "2.26667", "Europe/Madrid"),("3120012", "La Almunia de Doña Godina", "", "ES", "724", "", "52", "Z", "50025", "41.4767", "-1.37451", "Europe/Madrid"),("3120186", "Jaraíz de la Vera", "", "ES", "724", "", "57", "CC", "10104", "40.06005", "-5.75426", "Europe/Madrid"),("3120211", "Jaca", "", "ES", "724", "", "52", "HU", "22130", "42.56898", "-0.54987", "Europe/Madrid"),("3120288", "Iscar", "", "ES", "724", "", "55", "VA", "47075", "41.36117", "-4.53348", "Europe/Madrid"),("3120304", "Irun", "Ирун", "ES", "724", "", "59", "SS", "20045", "43.33904", "-1.78938", "Europe/Madrid"),("3120410", "Illescas", "Ильескас", "ES", "724", "", "54", "TO", "45081", "40.12213", "-3.84704", "Europe/Madrid"),("3120431", "Igualada", "Игуалада", "ES", "724", "", "56", "B", "08250", "41.58098", "1.6172", "Europe/Madrid"),("3120501", "Humanes de Madrid", "", "ES", "724", "", "29", "M", "28073", "40.25038", "-3.83062", "Europe/Madrid"),("3120514", "Huesca", "Уэска", "ES", "724", "", "52", "HU", "22125", "42.13615", "-0.4087", "Europe/Madrid"),("3120605", "Hoyo de Manzanares", "", "ES", "724", "", "29", "M", "28072", "40.62265", "-3.90733", "Europe/Madrid"),("3120619", "L'Hospitalet de Llobregat", "Оспиталет-де-Льобрегат", "ES", "724", "", "56", "B", "08101", "41.35967", "2.10028", "Europe/Madrid"),("3120635", "Hortaleza", "", "ES", "724", "", "29", "M", "28079", "40.47444", "-3.6411", "Europe/Madrid"),("3120811", "Hernani", "Эрнани", "ES", "724", "", "59", "SS", "20040", "43.26615", "-1.97615", "Europe/Madrid"),("3120874", "Haro", "", "ES", "724", "", "27", "LO", "26071", "42.57634", "-2.8476", "Europe/Madrid"),("3120928", "Guitiriz", "", "ES", "724", "", "58", "LU", "27022", "43.18169", "-7.89656", "Europe/Madrid"),("3120963", "Guijuelo", "", "ES", "724", "", "55", "SA", "37156", "40.55757", "-5.67067", "Europe/Madrid"),("3120989", "Gernika-Lumo", "", "ES", "724", "", "59", "BI", "48046", "43.31667", "-2.68333", "Europe/Madrid"),("3120998", "Güeñes", "", "ES", "724", "", "59", "BI", "48045", "43.21252", "-3.09497", "Europe/Madrid"),("3121007", "Getxo", "", "ES", "724", "", "59", "BI", "48044", "43.35689", "-3.01146", "Europe/Madrid"),("3121029", "Guardo", "", "ES", "724", "", "55", "P", "34080", "42.78966", "-4.84823", "Europe/Madrid"),("3121058", "Guadarrama", "", "ES", "724", "", "29", "M", "28068", "40.6727", "-4.08949", "Europe/Madrid"),("3121070", "Guadalajara", "Гвадалахара", "ES", "724", "", "54", "GU", "19130", "40.62862", "-3.16185", "Europe/Madrid"),("3121078", "O Grove", "", "ES", "724", "", "58", "PO", "36022", "42.49444", "-8.86502", "Europe/Madrid"),("3121105", "Griñón", "", "ES", "724", "", "29", "M", "28066", "40.21249", "-3.85482", "Europe/Madrid"),("3121145", "Granollers", "", "ES", "724", "", "56", "B", "08181", "41.60797", "2.28773", "Europe/Madrid"),("3121238", "Grado", "", "ES", "724", "", "34", "O", "33026", "43.38801", "-6.07433", "Europe/Madrid"),("3121245", "Gràcia", "", "ES", "724", "", "56", "B", "08019", "41.40237", "2.15641", "Europe/Madrid"),("3121316", "Gondomar", "", "ES", "724", "", "58", "PO", "36021", "42.11155", "-8.74971", "Europe/Madrid"),("3121404", "Xinzo de Limia", "", "ES", "724", "", "58", "OR", "32032", "42.0635", "-7.72459", "Europe/Madrid"),("3121424", "Gijón", "Хихон", "ES", "724", "", "34", "O", "33024", "43.53573", "-5.66152", "Europe/Madrid"),("3121437", "Getafe", "Хетафе", "ES", "724", "", "29", "M", "28065", "40.30571", "-3.73295", "Europe/Madrid"),("3121456", "Girona", "Жерона", "ES", "724", "", "56", "GI", "17079", "41.98311", "2.82493", "Europe/Madrid"),("3121486", "Gelida", "", "ES", "724", "", "56", "B", "08091", "41.43333", "1.86667", "Europe/Madrid"),("3121519", "Gavà", "Гава", "ES", "724", "", "56", "B", "08089", "41.30605", "2.00123", "Europe/Madrid"),("3121751", "Galdakao", "Гальдакано", "ES", "724", "", "59", "BI", "48036", "43.23333", "-2.83333", "Europe/Madrid"),("3121766", "Galapagar", "Галапагар", "ES", "724", "", "29", "M", "28061", "40.5783", "-4.00426", "Europe/Madrid"),("3121881", "Hondarribia", "", "ES", "724", "", "59", "SS", "20036", "43.36859", "-1.79622", "Europe/Madrid"),("3121926", "Fuente el Saz", "", "ES", "724", "", "29", "M", "28009", "40.63215", "-3.51146", "Europe/Madrid"),("3121956", "Fuensalida", "", "ES", "724", "", "54", "TO", "45066", "40.05288", "-4.20718", "Europe/Madrid"),("3121960", "Fuenlabrada", "Фуэнлабрада", "ES", "724", "", "29", "M", "28058", "40.28419", "-3.79415", "Europe/Madrid"),("3122157", "Fraga", "", "ES", "724", "", "52", "HU", "22112", "41.52294", "0.34894", "Europe/Madrid"),("3122172", "Foz", "", "ES", "724", "", "58", "LU", "27005", "43.5692", "-7.25441", "Europe/Madrid"),("3122426", "Fisterra", "", "ES", "724", "", "58", "C", "15037", "42.90492", "-9.26289", "Europe/Madrid"),("3122452", "Figueras", "Фигейрас", "ES", "724", "", "34", "O", "33017", "43.53943", "-7.02559", "Europe/Madrid"),("3122453", "Figueres", "Фигерас", "ES", "724", "", "56", "GI", "17066", "42.26645", "2.96163", "Europe/Madrid"),("3122564", "Fene", "", "ES", "724", "", "58", "C", "15035", "43.45", "-8.15", "Europe/Madrid"),("3122695", "Fabero", "", "ES", "724", "", "55", "LE", "24070", "42.76803", "-6.62651", "Europe/Madrid"),("3122762", "Estella-Lizarra", "", "ES", "724", "", "32", "NA", "31097", "42.67182", "-2.03226", "Europe/Madrid"),("3122826", "Esplugues de Llobregat", "", "ES", "724", "", "56", "B", "08019", "41.37732", "2.08809", "Europe/Madrid"),("3122912", "Esparreguera", "", "ES", "724", "", "56", "B", "08076", "41.53809", "1.87025", "Europe/Madrid"),("3123063", "Ermua", "Эрмуа", "ES", "724", "", "59", "BI", "48034", "43.18725", "-2.50261", "Europe/Madrid"),("3123104", "Erandio", "Эрандио", "ES", "724", "", "59", "BI", "48902", "43.30438", "-2.97352", "Europe/Madrid"),("3123329", "El Prat de Llobregat", "Эль Прат", "ES", "724", "", "56", "B", "08169", "41.32784", "2.09472", "Europe/Madrid"),("3123399", "Elorrio", "", "ES", "724", "", "59", "BI", "48032", "43.12924", "-2.54056", "Europe/Madrid"),("3123421", "El Molar", "", "ES", "724", "", "29", "M", "28045", "40.73215", "-3.57969", "Europe/Madrid"),("3123473", "Empuriabrava", "", "ES", "724", "ES", "56", "GI", "17047", "42.24691", "3.12059", "Europe/Madrid"),("3123478", "Elgoibar", "", "ES", "724", "", "59", "SS", "20032", "43.21601", "-2.41334", "Europe/Madrid"),("3123493", "Ferrol", "", "ES", "724", "", "58", "C", "15036", "43.48321", "-8.23689", "Europe/Madrid"),("3123504", "El Escorial", "", "ES", "724", "", "29", "M", "28054", "40.58254", "-4.12846", "Europe/Madrid"),("3123531", "Zalla", "", "ES", "724", "", "59", "BI", "48086", "43.23333", "-3.13333", "Europe/Madrid"),("3123622", "El Burgo de Osma", "", "ES", "724", "", "55", "SO", "42043", "41.58619", "-3.06522", "Europe/Madrid"),("3123658", "O Barco de Valdeorras", "", "ES", "724", "", "58", "OR", "32009", "42.41642", "-6.99005", "Europe/Madrid"),("3123667", "El Astillero", "Эль-Астильеро", "ES", "724", "", "39", "S", "39008", "43.40094", "-3.82051", "Europe/Madrid"),("3123682", "El Álamo", "", "ES", "724", "", "29", "M", "28004", "40.23066", "-3.99447", "Europe/Madrid"),("3123688", "Ejea de los Caballeros", "Эхеа-де-лос-Кабальерос", "ES", "724", "", "52", "Z", "50095", "42.12632", "-1.13716", "Europe/Madrid"),("3123709", "Eibar", "Эйбар", "ES", "724", "", "59", "SS", "20030", "43.18493", "-2.47158", "Europe/Madrid"),("3123773", "Durango", "Дуранго", "ES", "724", "", "59", "BI", "48027", "43.17124", "-2.6338", "Europe/Madrid"),("3123910", "Deba", "", "ES", "724", "", "59", "SS", "20029", "43.29571", "-2.35213", "Europe/Madrid"),("3123981", "Daganzo de Arriba", "", "ES", "724", "", "29", "M", "28053", "40.54293", "-3.45457", "Europe/Madrid"),("3124021", "Cuntis", "", "ES", "724", "", "58", "PO", "36015", "42.63396", "-8.56256", "Europe/Madrid"),("3124026", "Cunit", "", "ES", "724", "", "56", "T", "43051", "41.19829", "1.63645", "Europe/Madrid"),("3124041", "Culleredo", "Кульередо", "ES", "724", "", "58", "C", "15031", "43.28788", "-8.38858", "Europe/Madrid"),("3124132", "Cuenca", "Куэнка", "ES", "724", "", "54", "CU", "16078", "40.06667", "-2.13333", "Europe/Madrid"),("3124136", "Cuéllar", "", "ES", "724", "", "55", "SG", "40063", "41.40155", "-4.31474", "Europe/Madrid"),("3124142", "Cudillero", "", "ES", "724", "", "34", "O", "33021", "43.56217", "-6.14589", "Europe/Madrid"),("3124201", "Cubelles", "", "ES", "724", "", "56", "B", "08074", "41.20772", "1.67267", "Europe/Madrid"),("3124408", "Coslada", "Кослада", "ES", "724", "", "29", "M", "28049", "40.42378", "-3.56129", "Europe/Madrid"),("3124569", "Cornellà de Llobregat", "", "ES", "724", "", "56", "B", "08019", "41.35", "2.08333", "Europe/Madrid"),("3124589", "Coristanco", "", "ES", "724", "", "58", "C", "15029", "43.2", "-8.75", "Europe/Madrid"),("3124600", "Corella", "", "ES", "724", "", "32", "NA", "31077", "42.11507", "-1.78563", "Europe/Madrid"),("3124628", "Corbera de Llobregat", "", "ES", "724", "", "56", "B", "08072", "41.41702", "1.9197", "Europe/Madrid"),("3124661", "Constantí", "", "ES", "724", "", "56", "T", "43047", "41.15392", "1.21262", "Europe/Madrid"),("3124765", "Colmenar Viejo", "Кольменар-Вьехо", "ES", "724", "", "29", "M", "28045", "40.65909", "-3.76762", "Europe/Madrid"),("3124768", "Colmenarejo", "", "ES", "724", "", "29", "M", "28044", "40.56063", "-4.01713", "Europe/Madrid"),("3124769", "Colmenar de Oreja", "", "ES", "724", "", "29", "M", "28043", "40.10675", "-3.38547", "Europe/Madrid"),("3124794", "Collado-Villalba", "Кольядо-Вильяльба", "ES", "724", "", "29", "M", "28047", "40.63506", "-4.00486", "Europe/Madrid"),("3124798", "Collado Mediano", "", "ES", "724", "", "29", "M", "28046", "40.69326", "-4.0228", "Europe/Madrid"),("3124821", "Colindres", "", "ES", "724", "", "39", "S", "39023", "43.39667", "-3.45361", "Europe/Madrid"),("3124955", "Cizur Mayor", "", "ES", "724", "", "32", "NA", "31907", "42.78795", "-1.69065", "Europe/Madrid"),("3124963", "Ciudad Rodrigo", "", "ES", "724", "", "55", "SA", "37107", "40.6", "-6.53333", "Europe/Madrid"),("3124964", "Ciudad Lineal", "", "ES", "724", "", "29", "M", "28079", "40.45455", "-3.64808", "Europe/Madrid"),("3124967", "Ciutadella", "", "ES", "724", "", "07", "PM", "07015", "40.00112", "3.84144", "Europe/Madrid"),("3124971", "Cistérniga", "", "ES", "724", "", "55", "VA", "47052", "41.61294", "-4.68697", "Europe/Madrid"),("3125009", "Cintruénigo", "", "ES", "724", "", "32", "NA", "31072", "42.07937", "-1.80458", "Europe/Madrid"),("3125077", "Zierbena", "", "ES", "724", "", "59", "BI", "48913", "43.35", "-3.08333", "Europe/Madrid"),("3125082", "Ciempozuelos", "", "ES", "724", "", "29", "M", "28040", "40.15913", "-3.62103", "Europe/Madrid"),("3125212", "Chantada", "", "ES", "724", "", "58", "LU", "27016", "42.60876", "-7.77115", "Europe/Madrid"),("3125239", "Chamartín", "", "ES", "724", "", "29", "M", "28079", "40.46206", "-3.6766", "Europe/Madrid"),("3125308", "Cervera", "", "ES", "724", "", "56", "L", "25905", "41.67003", "1.2721", "Europe/Madrid"),("3125309", "Cervelló", "", "ES", "724", "", "56", "B", "08068", "41.39587", "1.95917", "Europe/Madrid"),("3125408", "Cercedilla", "", "ES", "724", "", "29", "M", "28038", "40.74101", "-4.05644", "Europe/Madrid"),("3125442", "Centelles", "", "ES", "724", "", "56", "B", "08067", "41.79746", "2.21902", "Europe/Madrid"),("3125488", "Celanova", "", "ES", "724", "", "58", "OR", "32024", "42.15303", "-7.95513", "Europe/Madrid"),("3125526", "Cee", "", "ES", "724", "", "58", "C", "15023", "42.95466", "-9.188", "Europe/Madrid"),("3125537", "Cedeira", "", "ES", "724", "", "58", "C", "15022", "43.66044", "-8.05719", "Europe/Madrid"),("3125621", "Castro-Urdiales", "", "ES", "724", "", "39", "S", "39020", "43.38285", "-3.22043", "Europe/Madrid"),("3125667", "Castro de Rei", "", "ES", "724", "", "58", "LU", "27010", "43.20866", "-7.40026", "Europe/Madrid"),("3125713", "Castro", "", "ES", "724", "", "58", "LU", "27042", "42.76667", "-7.58333", "Europe/Madrid"),("3125800", "Castell-Platja d'Aro", "", "ES", "724", "", "56", "GI", "17048", "41.81751", "3.06742", "Europe/Madrid"),("3125884", "Castelló d'Empúries", "", "ES", "724", "", "56", "GI", "17047", "42.25673", "3.07446", "Europe/Madrid"),("3125895", "Castellet", "", "ES", "724", "", "56", "B", "08058", "41.26281", "1.63369", "Europe/Madrid"),("3125897", "Castelldefels", "", "ES", "724", "", "56", "B", "08056", "41.27794", "1.97033", "Europe/Madrid"),("3125904", "Castellbisbal", "", "ES", "724", "", "56", "B", "08054", "41.47534", "1.98174", "Europe/Madrid"),("3125915", "Castellar del Vallès", "", "ES", "724", "", "56", "B", "08051", "41.61667", "2.08333", "Europe/Madrid"),("3125991", "Cassà de la Selva", "", "ES", "724", "", "56", "GI", "17044", "41.88784", "2.87524", "Europe/Madrid"),("3125994", "Caspe", "", "ES", "724", "", "52", "Z", "50074", "41.23402", "-0.03945", "Europe/Madrid"),("3126222", "Carral", "", "ES", "724", "", "58", "C", "15021", "43.2286", "-8.35545", "Europe/Madrid"),("3126254", "Carnota", "", "ES", "724", "", "58", "C", "15020", "42.8233", "-9.08913", "Europe/Madrid"),("3126293", "Cardona", "", "ES", "724", "", "56", "B", "08141", "41.91371", "1.67855", "Europe/Madrid"),("3126317", "Cardedeu", "", "ES", "724", "", "56", "B", "08181", "41.63976", "2.35739", "Europe/Madrid"),("3126369", "Carballo", "Карбальо", "ES", "724", "", "58", "C", "15019", "43.213", "-8.69104", "Europe/Madrid"),("3126373", "O Carballiño", "", "ES", "724", "", "58", "OR", "32019", "42.43163", "-8.07899", "Europe/Madrid"),("3126466", "Capellades", "", "ES", "724", "", "56", "B", "08044", "41.53005", "1.68651", "Europe/Madrid"),("3126534", "Canovelles", "", "ES", "724", "", "56", "B", "08086", "41.61667", "2.28333", "Europe/Madrid"),("3126571", "Cangas de Onís", "", "ES", "724", "", "34", "O", "33012", "43.3514", "-5.12916", "Europe/Madrid"),("3126572", "Cangas del Narcea", "", "ES", "724", "", "34", "O", "33011", "43.18333", "-6.55", "Europe/Madrid"),("3126577", "Cangas do Morrazo", "", "ES", "724", "", "58", "PO", "36008", "42.26413", "-8.78463", "Europe/Madrid"),("3126584", "Canet de Mar", "", "ES", "724", "", "56", "B", "08040", "41.59054", "2.58116", "Europe/Madrid"),("3126622", "Candeleda", "", "ES", "724", "", "55", "AV", "05047", "40.15521", "-5.24045", "Europe/Madrid"),("3126888", "Cambrils", "Камбрилс", "ES", "724", "", "56", "T", "43038", "41.06997", "1.05949", "Europe/Madrid"),("3126890", "Cambre", "", "ES", "724", "", "58", "C", "15017", "43.29438", "-8.34736", "Europe/Madrid"),("3126899", "Cambados", "", "ES", "724", "", "58", "PO", "36006", "42.51222", "-8.8131", "Europe/Madrid"),("3126913", "Camarma de Esteruelas", "", "ES", "724", "", "29", "M", "28032", "40.55032", "-3.37295", "Europe/Madrid"),("3126915", "Camariñas", "", "ES", "724", "", "58", "C", "15016", "43.13115", "-9.18172", "Europe/Madrid"),("3126917", "Camargo", "Камарго", "ES", "724", "", "39", "S", "39052", "43.40744", "-3.88498", "Europe/Madrid"),("3126974", "Calonge", "", "ES", "724", "", "56", "GI", "17034", "41.85869", "3.07926", "Europe/Madrid"),("3127007", "Calella", "", "ES", "724", "", "56", "B", "08035", "41.61381", "2.65423", "Europe/Madrid"),("3127034", "Caldas de Reis", "", "ES", "724", "ES", "58", "PO", "36005", "42.6", "-8.63333", "Europe/Madrid"),("3127035", "Caldes de Montbui", "", "ES", "724", "", "56", "B", "08033", "41.63333", "2.16667", "Europe/Madrid"),("3127047", "Calatayud", "Калатаюд", "ES", "724", "", "52", "Z", "50067", "41.35353", "-1.64318", "Europe/Madrid"),("3127065", "Calahorra", "Калаорра", "ES", "724", "", "27", "LO", "26036", "42.30506", "-1.96521", "Europe/Madrid"),("3127066", "Calafell", "", "ES", "724", "", "56", "T", "43037", "41.19997", "1.5683", "Europe/Madrid"),("3127135", "Cacabelos", "", "ES", "724", "", "55", "LE", "24030", "42.60021", "-6.72373", "Europe/Madrid"),("3127147", "Cabrils", "", "ES", "724", "", "56", "B", "08214", "41.5276", "2.36996", "Europe/Madrid"),("3127224", "Cabezón de la Sal", "", "ES", "724", "", "39", "S", "39012", "43.30824", "-4.23571", "Europe/Madrid"),("3127267", "Cabanillas del Campo", "", "ES", "724", "", "54", "GU", "19058", "40.63376", "-3.22937", "Europe/Madrid"),("3127451", "Burlata", "", "ES", "724", "", "32", "NA", "31086", "42.82562", "-1.61671", "Europe/Madrid"),("3127461", "Burgos", "Бургос", "ES", "724", "", "55", "BU", "09059", "42.34106", "-3.70184", "Europe/Madrid"),("3127476", "Burela de Cabo", "", "ES", "724", "", "58", "LU", "27902", "43.65", "-7.4", "Europe/Madrid"),("3127538", "Bueu", "", "ES", "724", "", "58", "PO", "36004", "42.32458", "-8.78497", "Europe/Madrid"),("3127588", "Brunete", "", "ES", "724", "", "29", "M", "28026", "40.40532", "-3.9985", "Europe/Madrid"),("3127611", "Briviesca", "", "ES", "724", "", "55", "BU", "09056", "42.54993", "-3.32315", "Europe/Madrid"),("3127889", "Boiro", "", "ES", "724", "", "58", "C", "15011", "42.64725", "-8.88459", "Europe/Madrid"),("3127952", "Boalo", "", "ES", "724", "", "29", "M", "28090", "40.71603", "-3.91656", "Europe/Madrid"),("3127958", "Boadilla del Monte", "", "ES", "724", "", "29", "M", "28022", "40.405", "-3.87835", "Europe/Madrid"),("3127978", "Blanes", "Бланес", "ES", "724", "", "56", "GI", "17023", "41.67419", "2.79036", "Europe/Madrid"),("3128015", "Binéfar", "", "ES", "724", "", "52", "HU", "22061", "41.85141", "0.29433", "Europe/Madrid"),("3128026", "Bilbao", "Бильбао", "ES", "724", "", "59", "BI", "48020", "43.26271", "-2.92528", "Europe/Madrid"),("3128030", "Bigues i Riells", "", "ES", "724", "", "56", "B", "08023", "41.68333", "2.23333", "Europe/Madrid"),("3128071", "Betanzos", "", "ES", "724", "", "58", "C", "15009", "43.28042", "-8.21467", "Europe/Madrid"),("3128130", "Berriozar", "", "ES", "724", "", "32", "NA", "31903", "42.83067", "-1.66648", "Europe/Madrid"),("3128174", "Bermeo", "Бермео", "ES", "724", "", "59", "BI", "48017", "43.42088", "-2.72152", "Europe/Madrid"),("3128190", "Bergondo", "", "ES", "724", "", "58", "C", "15008", "43.31667", "-8.23333", "Europe/Madrid"),("3128201", "Berga", "", "ES", "724", "", "56", "B", "08022", "42.10429", "1.84628", "Europe/Madrid"),("3128248", "Berango", "", "ES", "724", "", "59", "BI", "48016", "43.365", "-2.99601", "Europe/Madrid"),("3128272", "Benicàssim", "", "ES", "724", "", "60", "CS", "12028", "40.05", "0.06667", "Europe/Madrid"),("3128273", "Benicarló", "Беникарло", "ES", "724", "", "60", "CS", "12027", "40.4165", "0.42709", "Europe/Madrid"),("3128291", "Benavente", "", "ES", "724", "", "55", "ZA", "49021", "42.00249", "-5.67826", "Europe/Madrid"),("3128308", "Bembibre", "", "ES", "724", "", "55", "LE", "24014", "42.61771", "-6.41545", "Europe/Madrid"),("3128382", "Béjar", "Бехар", "ES", "724", "", "55", "SA", "37046", "40.38641", "-5.76341", "Europe/Madrid"),("3128398", "Begues", "", "ES", "724", "", "56", "B", "08020", "41.33333", "1.93333", "Europe/Madrid"),("3128436", "Beasain", "", "ES", "724", "", "59", "SS", "20019", "43.05017", "-2.20087", "Europe/Madrid"),("3128462", "Baiona", "", "ES", "724", "", "58", "PO", "36003", "42.11667", "-8.85", "Europe/Madrid"),("3128760", "Barcelona", "Барселона", "ES", "724", "", "56", "B", "08019", "41.38879", "2.15899", "Europe/Madrid"),("3128795", "Barbastro", "Барбастро", "ES", "724", "", "52", "HU", "22048", "42.03565", "0.12686", "Europe/Madrid"),("3128824", "Barañáin", "Бараньяйн", "ES", "724", "", "32", "NA", "31901", "42.80567", "-1.67731", "Europe/Madrid"),("3128832", "Barajas de Madrid", "", "ES", "724", "ES", "29", "M", "28079", "40.47366", "-3.57777", "Europe/Madrid"),("3128885", "Banyoles", "", "ES", "724", "", "56", "GI", "17015", "42.11667", "2.76667", "Europe/Madrid"),("3128978", "Balaguer", "", "ES", "724", "", "56", "L", "25040", "41.79117", "0.81094", "Europe/Madrid"),("3129028", "Badalona", "Бадалона", "ES", "724", "", "56", "B", "08015", "41.45004", "2.24741", "Europe/Madrid"),("3129046", "Azuqueca de Henares", "Асукека-де-Энарес", "ES", "724", "", "54", "GU", "19046", "40.56566", "-3.26753", "Europe/Madrid"),("3129059", "Azpeitia", "", "ES", "724", "", "59", "SS", "20018", "43.18246", "-2.26693", "Europe/Madrid"),("3129071", "Azkoitia", "", "ES", "724", "", "59", "SS", "20017", "43.17744", "-2.31129", "Europe/Madrid"),("3129135", "Avilés", "Авилес", "ES", "724", "", "34", "O", "33004", "43.55473", "-5.92483", "Europe/Madrid"),("3129136", "Ávila", "Авила", "ES", "724", "", "55", "AV", "05019", "40.65724", "-4.69951", "Europe/Madrid"),("3129231", "Astorga", "", "ES", "724", "", "55", "LE", "24008", "42.45879", "-6.05601", "Europe/Madrid"),("3129293", "Arzúa", "", "ES", "724", "", "58", "C", "15006", "42.93333", "-8.15", "Europe/Madrid"),("3129329", "Arteixo", "", "ES", "724", "", "58", "C", "15005", "43.30482", "-8.50749", "Europe/Madrid"),("3129356", "Arroyomolinos", "", "ES", "724", "", "29", "M", "28089", "40.26951", "-3.91946", "Europe/Madrid"),("3129371", "Arroyo", "", "ES", "724", "", "55", "VA", "47010", "41.60956", "-4.79692", "Europe/Madrid"),("3129406", "Arrigorriaga", "", "ES", "724", "", "59", "BI", "48011", "43.21006", "-2.88562", "Europe/Madrid"),("3129476", "Arnedo", "", "ES", "724", "", "27", "LO", "26018", "42.228", "-2.10083", "Europe/Madrid"),("3129607", "Argentona", "", "ES", "724", "", "56", "B", "08009", "41.55336", "2.40114", "Europe/Madrid"),("3129636", "Arganda", "Арганда", "ES", "724", "", "29", "M", "28014", "40.30076", "-3.43722", "Europe/Madrid"),("3129644", "Arévalo", "", "ES", "724", "", "55", "AV", "05016", "41.06255", "-4.72042", "Europe/Madrid"),("3129655", "Ares", "", "ES", "724", "", "58", "C", "15004", "43.42995", "-8.24254", "Europe/Madrid"),("3129660", "Arenys de Munt", "", "ES", "724", "", "56", "B", "08007", "41.61424", "2.53972", "Europe/Madrid"),("3129661", "Arenys de Mar", "", "ES", "724", "", "56", "B", "08006", "41.5819", "2.54936", "Europe/Madrid"),("3129678", "Arenas de San Pedro", "", "ES", "724", "", "55", "AV", "05014", "40.21041", "-5.08694", "Europe/Madrid"),("3129692", "Aretxabaleta", "", "ES", "724", "", "59", "SS", "20013", "43.03414", "-2.50456", "Europe/Madrid"),("3129857", "Aranjuez", "Аранхуэс", "ES", "724", "", "29", "M", "28013", "40.03108", "-3.60246", "Europe/Madrid"),("3129877", "Aranda de Duero", "Аранда-де-Дуэро", "ES", "724", "", "55", "BU", "09018", "41.67041", "-3.6892", "Europe/Madrid"),("3130032", "Anglès", "", "ES", "724", "", "56", "GI", "17008", "41.95617", "2.63603", "Europe/Madrid"),("3130067", "Andorra", "", "ES", "724", "", "52", "TE", "44025", "40.97655", "-0.44721", "Europe/Madrid"),("3130070", "Andoain", "", "ES", "724", "", "59", "SS", "20009", "43.21658", "-2.0253", "Europe/Madrid"),("3130124", "Amurrio", "", "ES", "724", "", "59", "VI", "01002", "43.05", "-3", "Europe/Madrid"),("3130131", "Amposta", "", "ES", "724", "", "56", "T", "43014", "40.70995", "0.57856", "Europe/Madrid"),("3130137", "Amorebieta", "", "ES", "724", "", "59", "BI", "48003", "43.21667", "-2.73333", "Europe/Madrid"),("3130155", "Amés", "Эймса", "ES", "724", "", "58", "C", "15013", "42.90426", "-8.65551", "Europe/Madrid"),("3130244", "Altsasu", "", "ES", "724", "", "32", "NA", "31010", "42.89999", "-2.16516", "Europe/Madrid"),("3130249", "Alpicat", "", "ES", "724", "", "56", "L", "25120", "41.6657", "0.55564", "Europe/Madrid"),("3130255", "Alpedrete", "", "ES", "724", "", "29", "M", "28010", "40.65889", "-4.02512", "Europe/Madrid"),("3130262", "Alovera", "", "ES", "724", "", "54", "GU", "19024", "40.59368", "-3.24529", "Europe/Madrid"),("3130313", "Almazán", "", "ES", "724", "", "55", "SO", "42020", "41.48648", "-2.53088", "Europe/Madrid"),("3130331", "Almacelles", "", "ES", "724", "", "56", "L", "25120", "41.73216", "0.43722", "Europe/Madrid"),("3130354", "Allariz", "", "ES", "724", "", "58", "OR", "32001", "42.19044", "-7.80175", "Europe/Madrid"),("3130380", "Algorta", "", "ES", "724", "", "59", "BI", "48044", "43.34927", "-3.0094", "Europe/Madrid"),("3130383", "Algete", "", "ES", "724", "", "29", "M", "28009", "40.59711", "-3.49743", "Europe/Madrid"),("3130399", "Alfaro", "", "ES", "724", "", "27", "LO", "26011", "42.18032", "-1.75016", "Europe/Madrid"),("3130422", "Alella", "", "ES", "724", "", "56", "B", "08003", "41.49379", "2.29451", "Europe/Madrid"),("3130564", "Alcorcón", "Алькоркон", "ES", "724", "", "29", "M", "28007", "40.34582", "-3.82487", "Europe/Madrid"),("3130567", "l'Alcora", "", "ES", "724", "", "60", "CS", "12005", "40.06667", "-0.2", "Europe/Madrid"),("3130583", "Alcobendas", "Алькобендас", "ES", "724", "", "29", "M", "28006", "40.54746", "-3.64197", "Europe/Madrid"),("3130598", "Alcarràs", "", "ES", "724", "", "56", "L", "25011", "41.56667", "0.51667", "Europe/Madrid"),("3130606", "Alcañiz", "Альканьис", "ES", "724", "", "52", "TE", "44013", "41.05", "-0.13333", "Europe/Madrid"),("3130608", "Alcanar", "", "ES", "724", "", "56", "T", "43156", "40.54316", "0.48082", "Europe/Madrid"),("3130616", "Alcalá de Henares", "Алькала-де-Энарес", "ES", "724", "", "29", "M", "28005", "40.48205", "-3.35996", "Europe/Madrid"),("3130619", "Alcalà de Xivert", "", "ES", "724", "", "60", "CS", "12004", "40.3", "0.23333", "Europe/Madrid"),("3130739", "Alagón", "", "ES", "724", "", "52", "Z", "50008", "41.76964", "-1.11906", "Europe/Madrid"),("3130824", "Aguilar de Campóo", "", "ES", "724", "", "55", "P", "34004", "42.79452", "-4.25892", "Europe/Madrid"),("3130911", "Agramunt", "", "ES", "724", "", "56", "L", "25003", "41.78686", "1.09683", "Europe/Madrid"),("3131024", "Abrera", "", "ES", "724", "", "56", "B", "08076", "41.51682", "1.901", "Europe/Madrid"),("3131093", "Abegondo", "", "ES", "724", "", "58", "C", "15001", "43.21667", "-8.28333", "Europe/Madrid"),("6252065", "Nou Barris", "", "ES", "724", "", "56", "B", "08019", "41.44163", "2.17727", "Europe/Madrid"),("6324376", "Pinar de Chamartín", "", "ES", "724", "", "29", "M", "28079", "40.47903", "-3.66836", "Europe/Madrid"),("6324533", "Santa Ponsa", "", "ES", "724", "", "07", "PM", "07011", "39.50868", "2.4766", "Europe/Madrid"),("6354969", "Playa del Ingles", "Плая дель Инглес", "ES", "724", "", "53", "GC", "35019", "27.7567", "-15.5787", "Atlantic/Canary"),("6354970", "Puerto Rico", "", "ES", "724", "", "53", "GC", "35012", "27.78943", "-15.71045", "Atlantic/Canary"),("6355013", "Puerto del Carmen", "Пуэрто-дель-Кармен", "ES", "724", "", "53", "GC", "35028", "28.92313", "-13.66579", "Atlantic/Canary"),("6355177", "La Manga del Mar Menor", "", "ES", "724", "", "31", "MU", "30016", "37.64129", "-0.71651", "Europe/Madrid"),("6362987", "Ceuta", "Сеута", "ES", "724", "", "CE", "CE", "51001", "35.88933", "-5.31979", "Africa/Ceuta"),("6533820", "Sant Cristòfol de les Fonts", "", "ES", "724", "", "56", "GI", "17114", "42.16964", "2.49943", "Europe/Madrid"),("6544099", "Moncloa-Aravaca", "", "ES", "724", "", "29", "M", "28079", "40.43547", "-3.7317", "Europe/Madrid"),("6544100", "Eixample", "Эшампле", "ES", "724", "", "56", "B", "08019", "41.38896", "2.16179", "Europe/Madrid"),("6544101", "les Corts", "", "ES", "724", "", "56", "B", "08019", "41.38712", "2.13007", "Europe/Madrid"),("6544102", "Sarrià-Sant Gervasi", "", "ES", "724", "", "56", "B", "08019", "41.40104", "2.1394", "Europe/Madrid"),("6544103", "Horta-Guinardó", "", "ES", "724", "", "56", "B", "08019", "41.41849", "2.1677", "Europe/Madrid"),("6544104", "Sants-Montjuïc", "", "ES", "724", "", "56", "B", "08019", "41.37263", "2.1546", "Europe/Madrid"),("6544105", "Sant Martí", "", "ES", "724", "", "56", "B", "08019", "41.41814", "2.19933", "Europe/Madrid"),("6544106", "Ciutat Vella", "", "ES", "724", "", "56", "B", "08019", "41.38022", "2.17319", "Europe/Madrid"),("6544487", "Arganzuela", "", "ES", "724", "", "29", "M", "28079", "40.40021", "-3.69618", "Europe/Madrid"),("6544488", "San Blas", "", "ES", "724", "", "29", "M", "28079", "40.43893", "-3.61537", "Europe/Madrid"),("6544489", "Latina", "", "ES", "724", "", "29", "M", "28079", "40.38897", "-3.74569", "Europe/Madrid"),("6544490", "Usera", "", "ES", "724", "", "29", "M", "28079", "40.38866", "-3.70035", "Europe/Madrid"),("6544491", "Salamanca", "Саламанка", "ES", "724", "", "29", "M", "28079", "40.42972", "-3.67975", "Europe/Madrid"),("6544492", "Chamberí", "", "ES", "724", "", "29", "M", "28079", "40.43404", "-3.70379", "Europe/Madrid"),("6544493", "Carabanchel", "", "ES", "724", "", "29", "M", "28079", "40.39094", "-3.7242", "Europe/Madrid"),("6544494", "City Center", "", "ES", "724", "", "29", "M", "28079", "40.41831", "-3.70275", "Europe/Madrid"),("6544495", "Retiro", "", "ES", "724", "", "29", "M", "28079", "40.41317", "-3.68307", "Europe/Madrid"),("6559502", "Pego", "", "ES", "724", "", "60", "A", "03102", "38.84305", "-0.11707", "Europe/Madrid"),("6559503", "l'Alfàs del Pi", "", "ES", "724", "", "60", "A", "03011", "38.58055", "-0.10321", "Europe/Madrid"),("6559504", "Deltebre", "", "ES", "724", "", "56", "T", "43901", "40.71944", "0.70835", "Europe/Madrid"),("6559641", "Las Gabias", "", "ES", "724", "", "51", "GR", "18905", "37.13548", "-3.67029", "Europe/Madrid"),("6615440", "Delicias", "", "ES", "724", "", "52", "Z", "50297", "41.64928", "-0.90757", "Europe/Madrid"),("6615442", "Almozara", "Альмозара", "ES", "724", "", "52", "Z", "50297", "41.66124", "-0.90169", "Europe/Madrid"),("6615443", "Montecanal", "", "ES", "724", "", "52", "Z", "50297", "41.62965", "-0.93873", "Europe/Madrid"),("6615444", "Oliver-Valdefierro", "", "ES", "724", "", "52", "Z", "50297", "41.64454", "-0.93349", "Europe/Madrid"),("6618856", "Santutxu", "", "ES", "724", "", "59", "BI", "48020", "43.25347", "-2.9161", "Europe/Madrid"),("6692471", "Los Realejos", "", "ES", "724", "", "53", "TF", "38031", "28.38487", "-16.58275", "Atlantic/Canary"),("6693088", "Pasaia", "Пасахес", "ES", "724", "", "59", "SS", "20064", "43.3253", "-1.92707", "Europe/Madrid"),("6694300", "El entrego", "", "ES", "724", "", "34", "O", "33060", "43.28752", "-5.638", "Europe/Madrid"),("6697039", "Basauri", "Басаури", "ES", "724", "", "59", "BI", "48015", "43.2397", "-2.8858", "Europe/Madrid"),("6943537", "Llefià", "", "ES", "724", "", "56", "B", "08015", "41.43806", "2.2195", "Europe/Madrid"),("7115111", "Corvera de Asturias", "Корвера-де-Астуриас", "ES", "724", "", "34", "O", "33020", "43.53554", "-5.88893", "Europe/Madrid"),("7577022", "Tres Cantos", "", "ES", "724", "", "29", "M", "28903", "40.60092", "-3.70806", "Europe/Madrid"),("8050879", "Iturrama", "", "ES", "724", "", "32", "NA", "31201", "42.80847", "-1.65825", "Europe/Madrid"),("8050880", "Ermitagaña", "", "ES", "724", "", "32", "NA", "31201", "42.81084", "-1.66409", "Europe/Madrid"),("8050888", "Primer Ensanche", "", "ES", "724", "", "32", "NA", "31201", "42.81483", "-1.64898", "Europe/Madrid"),("8050889", "Segundo Ensanche", "", "ES", "724", "", "32", "NA", "31201", "42.8139", "-1.64295", "Europe/Madrid"),("8285534", "Fuencarral-El Pardo", "", "ES", "724", "", "29", "M", "28079", "40.4984", "-3.7314", "Europe/Madrid"),("8285535", "Villa de Vallecas", "", "ES", "724", "", "29", "M", "28079", "40.36695", "-3.60146", "Europe/Madrid"),("8629192", "Natahoyo", "", "ES", "724", "", "34", "O", "33024", "43.54035", "-5.68233", "Europe/Madrid"),("8740851", "Son Ferrer", "", "ES", "724", "", "07", "PM", "07011", "39.49666", "2.50102", "Europe/Madrid"),("10942282", "La Pobla de Farnals", "", "ES", "724", "", "60", "V", "46199", "39.56571", "-0.28425", "Europe/Madrid"),("11169232", "La Gangosa Vistasol", "", "ES", "724", "", "51", "AL", "04102", "36.80581", "-2.62174", "Europe/Madrid"),("325579", "Ziway", "", "ET", "231", "", "51", "", "", "7.93333", "38.71667", "Africa/Addis_Ababa"),("325780", "Yirga ‘Alem", "", "ET", "231", "", "54", "", "", "6.75", "38.41667", "Africa/Addis_Ababa"),("326036", "Yabēlo", "", "ET", "231", "", "51", "", "", "4.88333", "38.08333", "Africa/Addis_Ababa"),("326206", "Werota", "", "ET", "231", "", "46", "", "", "11.91667", "37.7", "Africa/Addis_Ababa"),("326259", "Were Īlu", "", "ET", "231", "", "46", "", "", "10.58964", "39.43767", "Africa/Addis_Ababa"),("326308", "Wenjī", "", "ET", "231", "", "51", "", "", "8.45", "39.28333", "Africa/Addis_Ababa"),("326321", "Wendo", "", "ET", "231", "", "54", "", "", "6.6", "38.41667", "Africa/Addis_Ababa"),("327234", "Tulu Bolo", "", "ET", "231", "", "51", "", "", "8.66667", "38.21667", "Africa/Addis_Ababa"),("327694", "Tippi", "", "ET", "231", "", "54", "", "", "7.2", "35.45", "Africa/Addis_Ababa"),("328316", "Sirre", "", "ET", "231", "", "51", "", "", "8.31667", "39.48333", "Africa/Addis_Ababa"),("328689", "Shashemenē", "", "ET", "231", "", "51", "", "", "7.2", "38.6", "Africa/Addis_Ababa"),("328709", "Shambu", "", "ET", "231", "", "51", "", "", "9.56667", "37.1", "Africa/Addis_Ababa"),("328716", "Shakīso", "", "ET", "231", "", "51", "", "", "5.75", "38.91667", "Africa/Addis_Ababa"),("328880", "Sendafa", "", "ET", "231", "", "51", "", "", "9.15203", "39.02335", "Africa/Addis_Ababa"),("329114", "Sebeta", "", "ET", "231", "", "51", "", "", "8.91667", "38.61667", "Africa/Addis_Ababa"),("329586", "Robīt", "", "ET", "231", "", "46", "", "", "12.01667", "39.63333", "Africa/Addis_Ababa"),("330120", "Nejo", "", "ET", "231", "", "51", "", "", "9.5", "35.5", "Africa/Addis_Ababa"),("330186", "Nazrēt", "", "ET", "231", "", "51", "", "", "8.55", "39.26667", "Africa/Addis_Ababa"),("330491", "Mojo", "", "ET", "231", "", "51", "", "", "8.58679", "39.12111", "Africa/Addis_Ababa"),("330534", "Mīzan Teferī", "", "ET", "231", "", "54", "", "", "6.99674", "35.58948", "Africa/Addis_Ababa"),("330764", "Metu", "", "ET", "231", "", "51", "", "", "8.3", "35.58333", "Africa/Addis_Ababa"),("330811", "Metahāra", "", "ET", "231", "", "51", "", "", "8.9", "39.91667", "Africa/Addis_Ababa"),("331038", "Mendī", "Менди", "ET", "231", "", "51", "", "", "9.8", "35.1", "Africa/Addis_Ababa"),("331180", "Mek'ele", "", "ET", "231", "", "53", "", "", "13.49667", "39.47528", "Africa/Addis_Ababa"),("331259", "Mēga", "", "ET", "231", "", "51", "", "", "4.05", "38.3", "Africa/Addis_Ababa"),("331416", "Maych’ew", "", "ET", "231", "", "53", "", "", "12.7875", "39.54222", "Africa/Addis_Ababa"),("332129", "Leku", "", "ET", "231", "", "54", "", "", "6.87309", "38.44425", "Africa/Addis_Ababa"),("332288", "Lalībela", "", "ET", "231", "", "46", "", "", "12.03219", "39.04756", "Africa/Addis_Ababa"),("332746", "Korem", "", "ET", "231", "", "53", "", "", "12.50583", "39.52278", "Africa/Addis_Ababa"),("332880", "K’olīto", "", "ET", "231", "", "54", "", "", "7.31667", "38.08333", "Africa/Addis_Ababa"),("332938", "Kofelē", "", "ET", "231", "", "51", "", "", "7.06667", "38.78333", "Africa/Addis_Ababa"),("333103", "Kibre Mengist", "", "ET", "231", "", "51", "", "", "5.88333", "38.98333", "Africa/Addis_Ababa"),("333356", "Kemisē", "", "ET", "231", "", "46", "", "", "10.71668", "39.86997", "Africa/Addis_Ababa"),("333373", "Kombolcha", "Комбольча", "ET", "231", "", "46", "", "", "11.08155", "39.74339", "Africa/Addis_Ababa"),("333750", "Jinka", "", "ET", "231", "", "54", "", "", "5.65", "36.65", "Africa/Addis_Ababa"),("333772", "Jimma", "", "ET", "231", "", "51", "", "", "7.67344", "36.83441", "Africa/Addis_Ababa"),("333795", "Jijiga", "Джиджига", "ET", "231", "", "52", "", "", "9.35", "42.8", "Africa/Addis_Ababa"),("334227", "Inda Silasē", "", "ET", "231", "", "53", "", "", "14.10307", "38.28289", "Africa/Addis_Ababa"),("334529", "Huruta", "", "ET", "231", "", "51", "", "", "8.15", "39.35", "Africa/Addis_Ababa"),("334700", "Hīrna", "", "ET", "231", "", "51", "", "", "9.21667", "41.1", "Africa/Addis_Ababa"),("335035", "Harar", "Харэр", "ET", "231", "", "50", "", "", "9.31387", "42.11815", "Africa/Addis_Ababa"),("335286", "Hāgere Selam", "", "ET", "231", "", "54", "", "", "6.48333", "38.51667", "Africa/Addis_Ababa"),("335288", "Hāgere Hiywet", "", "ET", "231", "", "51", "", "", "8.98333", "37.85", "Africa/Addis_Ababa"),("335733", "Guder", "", "ET", "231", "", "51", "", "", "8.96667", "37.76667", "Africa/Addis_Ababa"),("335943", "Gorē", "", "ET", "231", "", "51", "", "", "8.15", "35.53333", "Africa/Addis_Ababa"),("336014", "Gondar", "Гондэр", "ET", "231", "", "46", "", "", "12.6", "37.46667", "Africa/Addis_Ababa"),("336350", "Goba", "Гоба", "ET", "231", "", "51", "", "", "7.01667", "39.98333", "Africa/Addis_Ababa"),("336372", "Waliso", "", "ET", "231", "", "51", "", "", "8.53417", "37.96515", "Africa/Addis_Ababa"),("336454", "Ginir", "", "ET", "231", "", "51", "", "", "7.13952", "40.71083", "Africa/Addis_Ababa"),("336496", "Gimbi", "", "ET", "231", "", "51", "", "", "9.17031", "35.83491", "Africa/Addis_Ababa"),("336526", "Gīdolē", "", "ET", "231", "", "54", "", "", "5.65", "37.36667", "Africa/Addis_Ababa"),("336745", "Gewanē", "", "ET", "231", "", "45", "", "", "10.16658", "40.64689", "Africa/Addis_Ababa"),("336931", "Genet", "Женя", "ET", "231", "", "51", "", "", "9.06667", "38.5", "Africa/Addis_Ababa"),("337010", "Gelemso", "", "ET", "231", "", "51", "", "", "8.81667", "40.51667", "Africa/Addis_Ababa"),("337083", "Gēdo", "", "ET", "231", "", "51", "", "", "9.01667", "37.45", "Africa/Addis_Ababa"),("337152", "Gebre Guracha", "", "ET", "231", "", "51", "", "", "9.8", "38.4", "Africa/Addis_Ababa"),("337405", "Gambēla", "Гамбеле", "ET", "231", "", "49", "", "", "8.25", "34.58333", "Africa/Addis_Ababa"),("337712", "Finote Selam", "", "ET", "231", "", "46", "", "", "10.7", "37.26667", "Africa/Addis_Ababa"),("337771", "Fichē", "", "ET", "231", "", "51", "", "", "9.8", "38.73333", "Africa/Addis_Ababa"),("337853", "Felege Neway", "", "ET", "231", "", "54", "", "", "6.3", "36.88333", "Africa/Addis_Ababa"),("338554", "Dubti", "", "ET", "231", "", "45", "", "", "11.73292", "41.082", "Africa/Addis_Ababa"),("338726", "Dodola", "Додола", "ET", "231", "", "51", "", "", "6.98333", "39.18333", "Africa/Addis_Ababa"),("338832", "Dire Dawa", "Диредавы", "ET", "231", "", "48", "", "", "9.59306", "41.86611", "Africa/Addis_Ababa"),("338998", "Dīla", "Дила", "ET", "231", "", "54", "", "", "6.41667", "38.31667", "Africa/Addis_Ababa"),("339219", "Desē", "", "ET", "231", "", "46", "", "", "11.13333", "39.63333", "Africa/Addis_Ababa"),("339448", "Dembī Dolo", "", "ET", "231", "", "51", "", "", "8.53333", "34.8", "Africa/Addis_Ababa"),("339551", "Dejen", "", "ET", "231", "", "46", "", "", "10.16667", "38.13333", "Africa/Addis_Ababa"),("339629", "Deder", "", "ET", "231", "", "51", "", "", "9.31168", "41.44301", "Africa/Addis_Ababa"),("339666", "Bishoftu", "", "ET", "231", "", "51", "", "", "8.75225", "38.97846", "Africa/Addis_Ababa"),("339671", "Debre Werk’", "", "ET", "231", "", "46", "", "", "10.66667", "38.16667", "Africa/Addis_Ababa"),("339686", "Debre Tabor", "", "ET", "231", "", "46", "", "", "11.85", "38.01667", "Africa/Addis_Ababa"),("339692", "Debre Sīna", "", "ET", "231", "", "46", "", "", "9.84752", "39.76027", "Africa/Addis_Ababa"),("339708", "Debre Mark’os", "", "ET", "231", "", "46", "", "", "10.35", "37.73333", "Africa/Addis_Ababa"),("339734", "Debre Birhan", "", "ET", "231", "", "46", "", "", "9.67954", "39.53262", "Africa/Addis_Ababa"),("339823", "Debark’", "", "ET", "231", "", "46", "", "", "13.15611", "37.89806", "Africa/Addis_Ababa"),("340358", "Dabat", "", "ET", "231", "", "46", "", "", "12.98417", "37.765", "Africa/Addis_Ababa"),("341297", "Butajīra", "", "ET", "231", "", "54", "", "", "8.11667", "38.36667", "Africa/Addis_Ababa"),("341397", "Burē", "Буря", "ET", "231", "", "46", "", "", "10.7", "37.06667", "Africa/Addis_Ababa"),("341742", "Bonga", "Бонга", "ET", "231", "", "54", "", "", "7.28333", "36.23333", "Africa/Addis_Ababa"),("341877", "Bodītī", "", "ET", "231", "", "54", "", "", "6.96667", "37.86667", "Africa/Addis_Ababa"),("342190", "Bichena", "", "ET", "231", "", "46", "", "", "10.45", "38.2", "Africa/Addis_Ababa"),("342559", "Bedēsa", "", "ET", "231", "", "51", "", "", "8.9", "40.78333", "Africa/Addis_Ababa"),("342567", "Bedelē", "", "ET", "231", "", "51", "", "", "8.456", "36.35302", "Africa/Addis_Ababa"),("342641", "Batī", "", "ET", "231", "", "46", "", "", "11.19152", "40.01675", "Africa/Addis_Ababa"),("342856", "Bako", "Бако", "ET", "231", "", "54", "", "", "5.78333", "36.56667", "Africa/Addis_Ababa"),("342884", "Bahir Dar", "Бахр-Дар", "ET", "231", "", "46", "", "", "11.59364", "37.39077", "Africa/Addis_Ababa"),("343134", "Āwash", "", "ET", "231", "", "45", "", "", "8.98333", "40.16667", "Africa/Addis_Ababa"),("343137", "Hawassa", "Авасе", "ET", "231", "", "54", "", "", "7.06205", "38.47635", "Africa/Addis_Ababa"),("343292", "Āsosa", "", "ET", "231", "", "47", "343291", "", "10.06667", "34.53333", "Africa/Addis_Ababa"),("343402", "Āsbe Teferī", "", "ET", "231", "", "51", "", "", "9.08569", "40.86708", "Africa/Addis_Ababa"),("343409", "Asaita", "Асайита", "ET", "231", "", "45", "", "", "11.56838", "41.43869", "Africa/Addis_Ababa"),("343413", "Āsasa", "", "ET", "231", "", "51", "", "", "7.1", "39.2", "Africa/Addis_Ababa"),("343593", "Āreka", "", "ET", "231", "", "54", "", "", "7.06667", "37.7", "Africa/Addis_Ababa"),("343663", "Arba Minch", "", "ET", "231", "", "54", "", "", "6.03333", "37.55", "Africa/Addis_Ababa"),("344420", "Axum", "", "ET", "231", "", "53", "", "", "14.12109", "38.72337", "Africa/Addis_Ababa"),("344620", "Hagere Maryam", "", "ET", "231", "", "51", "", "", "5.63418", "38.23603", "Africa/Addis_Ababa"),("344661", "Āgaro", "", "ET", "231", "", "51", "", "", "7.85", "36.65", "Africa/Addis_Ababa"),("344923", "Ādīs Zemen", "", "ET", "231", "", "46", "", "", "12.11667", "37.78333", "Africa/Addis_Ababa"),("344976", "Ādīs ‘Alem", "", "ET", "231", "", "51", "", "", "9.03333", "38.4", "Africa/Addis_Ababa"),("344979", "Addis Ababa", "Аддис-Абеба", "ET", "231", "", "44", "", "", "9.02497", "38.74689", "Africa/Addis_Ababa"),("345149", "Ādīgrat", "", "ET", "231", "", "53", "", "", "14.277", "39.462", "Africa/Addis_Ababa"),("345353", "Addiet Canna", "", "ET", "231", "", "46", "", "", "11.26667", "37.48333", "Africa/Addis_Ababa"),("345704", "Abomsa", "", "ET", "231", "", "46", "", "", "9.98333", "39.98333", "Africa/Addis_Ababa"),("6913519", "Semera", "", "ET", "231", "", "45", "", "", "11.79342", "41.00578", "Africa/Addis_Ababa"),("630752", "Ylöjärvi", "", "FI", "246", "", "06", "064", "980", "61.55632", "23.59606", "Europe/Helsinki"),("630768", "Ylivieska", "", "FI", "246", "", "17", "177", "977", "64.08333", "24.55", "Europe/Helsinki"),("630779", "Ylitornio", "", "FI", "246", "", "19", "193", "976", "66.30893", "23.67734", "Europe/Helsinki"),("630805", "Ylistaro", "", "FI", "246", "", "14", "142", "743", "62.93958", "22.51306", "Europe/Helsinki"),("631204", "Vuokatti", "", "FI", "246", "", "18", "182", "765", "64.14466", "28.28196", "Europe/Helsinki"),("631376", "Virrat", "", "FI", "246", "FI", "06", "069", "936", "62.24759", "23.78004", "Europe/Helsinki"),("631459", "Vilppula", "", "FI", "246", "FI", "06", "069", "508", "62.02121", "24.50483", "Europe/Helsinki"),("631560", "Viitasaari", "", "FI", "246", "", "13", "138", "931", "63.06667", "25.86667", "Europe/Helsinki"),("631693", "Viiala", "", "FI", "246", "", "06", "063", "020", "61.21023", "23.76738", "Europe/Helsinki"),("631707", "Vihti", "Вихти", "FI", "246", "", "01", "011", "927", "60.41699", "24.31965", "Europe/Helsinki"),("632370", "Varkaus", "Варкаус", "FI", "246", "", "11", "114", "915", "62.31533", "27.873", "Europe/Helsinki"),("632453", "Vantaa", "Вантаа", "FI", "246", "", "01", "011", "092", "60.29414", "25.04099", "Europe/Helsinki"),("632542", "Vammala", "", "FI", "246", "", "06", "068", "790", "61.33333", "22.9", "Europe/Helsinki"),("632672", "Valkeakoski", "Валкеакоски", "FI", "246", "", "06", "063", "908", "61.26421", "24.03122", "Europe/Helsinki"),("632978", "Vaasa", "Вааса", "FI", "246", "", "15", "152", "905", "63.096", "21.61577", "Europe/Helsinki"),("633221", "Uusikaupunki", "Уусикаупунки", "FI", "246", "", "02", "024", "895", "60.80043", "21.40841", "Europe/Helsinki"),("633332", "Urjala", "", "FI", "246", "", "06", "063", "887", "61.08333", "23.53333", "Europe/Helsinki"),("633395", "Ulvila", "", "FI", "246", "", "04", "043", "886", "61.42844", "21.87103", "Europe/Helsinki"),("633541", "Tyrnävä", "", "FI", "246", "", "17", "171", "859", "64.76469", "25.6523", "Europe/Helsinki"),("633591", "Tuusula", "Туусула", "FI", "246", "", "01", "011", "858", "60.40368", "25.02638", "Europe/Helsinki"),("633679", "Turku", "Турку", "FI", "246", "", "02", "023", "853", "60.45148", "22.26869", "Europe/Helsinki"),("634093", "Tornio", "Торнио", "FI", "246", "", "19", "192", "851", "65.84811", "24.14662", "Europe/Helsinki"),("634317", "Akaa", "", "FI", "246", "", "06", "063", "020", "61.16667", "23.86667", "Europe/Helsinki"),("634561", "Teuva", "", "FI", "246", "", "14", "141", "846", "62.4819", "21.74156", "Europe/Helsinki"),("634963", "Tampere", "Тампере", "FI", "246", "", "06", "064", "837", "61.49911", "23.78712", "Europe/Helsinki"),("634992", "Tammela", "", "FI", "246", "", "05", "053", "834", "60.81035", "23.76823", "Europe/Helsinki"),("635692", "Suonenjoki", "", "FI", "246", "", "11", "115", "778", "62.61667", "27.13333", "Europe/Helsinki"),("635696", "Suomussalmi", "", "FI", "246", "", "18", "181", "777", "64.88685", "28.90778", "Europe/Helsinki"),("635745", "Suolahti", "", "FI", "246", "", "13", "135", "992", "62.56421", "25.85363", "Europe/Helsinki"),("636173", "Sotkamo", "", "FI", "246", "", "18", "182", "765", "64.13333", "28.41667", "Europe/Helsinki"),("636345", "Somero", "", "FI", "246", "", "02", "022", "761", "60.61667", "23.53333", "Europe/Helsinki"),("636464", "Sodankylä", "", "FI", "246", "", "19", "197", "758", "67.41667", "26.6", "Europe/Helsinki"),("636608", "Siuntio", "", "FI", "246", "", "01", "011", "755", "60.13862", "24.22715", "Europe/Helsinki"),("636947", "Siilinjärvi", "Силинъярви", "FI", "246", "", "11", "112", "749", "63.08333", "27.66667", "Europe/Helsinki"),("637035", "Sievi", "", "FI", "246", "", "17", "177", "746", "63.9", "24.5", "Europe/Helsinki"),("637067", "Sibbo", "", "FI", "246", "", "01", "011", "753", "60.37752", "25.26906", "Europe/Helsinki"),("637219", "Seinäjoki", "", "FI", "246", "", "14", "142", "743", "62.79446", "22.82822", "Europe/Helsinki"),("637292", "Savonlinna", "Савонлинна", "FI", "246", "", "10", "103", "740", "61.8699", "28.87999", "Europe/Helsinki"),("637948", "Salo", "Сало", "FI", "246", "", "02", "022", "734", "60.38333", "23.13333", "Europe/Helsinki"),("638321", "Saarijärvi", "", "FI", "246", "", "13", "138", "729", "62.70486", "25.25396", "Europe/Helsinki"),("638691", "Ruovesi", "", "FI", "246", "", "06", "069", "702", "61.98575", "24.05714", "Europe/Helsinki"),("638803", "Ruokolahti", "", "FI", "246", "", "09", "093", "700", "61.28333", "28.83333", "Europe/Helsinki"),("638936", "Rovaniemi", "Рованиеми", "FI", "246", "", "19", "191", "698", "66.5", "25.71667", "Europe/Helsinki"),("639248", "Ristiina", "", "FI", "246", "", "10", "101", "491", "61.50579", "27.24643", "Europe/Helsinki"),("639406", "Riihimäki", "Рийхимяки", "FI", "246", "", "05", "052", "694", "60.73769", "24.77726", "Europe/Helsinki"),("639734", "Rauma", "Раума", "FI", "246", "", "04", "041", "684", "61.12724", "21.51127", "Europe/Helsinki"),("640124", "Raisio", "", "FI", "246", "", "02", "023", "680", "60.48592", "22.16895", "Europe/Helsinki"),("640276", "Raahe", "Рахе", "FI", "246", "", "17", "174", "678", "64.68333", "24.48333", "Europe/Helsinki"),("640398", "Pyhäselkä", "", "FI", "246", "", "12", "122", "167", "62.43333", "29.96667", "Europe/Helsinki"),("640440", "Pyhäjärvi", "", "FI", "246", "", "19", "194", "583", "67.0701", "27.21763", "Europe/Helsinki"),("640441", "Pyhäjärvi", "", "FI", "246", "", "17", "176", "626", "63.66667", "25.9", "Europe/Helsinki"),("640803", "Pudasjärvi", "", "FI", "246", "", "17", "173", "615", "65.38333", "26.91667", "Europe/Helsinki"),("640999", "Pori", "Пори", "FI", "246", "", "04", "043", "609", "61.48333", "21.78333", "Europe/Helsinki"),("641124", "Pohja", "", "FI", "246", "", "01", "014", "710", "60.09626", "23.52757", "Europe/Helsinki"),("641489", "Pirkkala", "", "FI", "246", "", "06", "064", "604", "61.46125", "23.63228", "Europe/Helsinki"),("641651", "Piikkiö", "", "FI", "246", "", "02", "023", "202", "60.42481", "22.51601", "Europe/Helsinki"),("641861", "Pielavesi", "", "FI", "246", "", "11", "111", "595", "63.23333", "26.75", "Europe/Helsinki"),("641869", "Pieksämäki", "", "FI", "246", "", "10", "105", "593", "62.3", "27.13333", "Europe/Helsinki"),("642113", "Perniö", "", "FI", "246", "", "02", "022", "734", "60.2", "23.13333", "Europe/Helsinki"),("642455", "Pedersöre", "", "FI", "246", "", "15", "154", "599", "63.65", "22.68333", "Europe/Helsinki"),("642657", "Parkano", "", "FI", "246", "", "06", "061", "581", "62.01667", "23.01667", "Europe/Helsinki"),("642673", "Pargas", "", "FI", "246", "", "02", "021", "445", "60.30672", "22.30097", "Europe/Helsinki"),("643153", "Paimio", "", "FI", "246", "", "02", "023", "577", "60.45671", "22.68694", "Europe/Helsinki"),("643453", "Outokumpu", "", "FI", "246", "", "12", "122", "309", "62.72685", "29.01592", "Europe/Helsinki"),("643481", "Oulunsalo", "", "FI", "246", "", "17", "171", "564", "64.93456", "25.41121", "Europe/Helsinki"),("643492", "Oulu", "Оулу", "FI", "246", "", "17", "171", "564", "65.01236", "25.46816", "Europe/Helsinki"),("643497", "Oulainen", "", "FI", "246", "", "17", "177", "563", "64.26667", "24.8", "Europe/Helsinki"),("643629", "Orivesi", "", "FI", "246", "", "06", "064", "562", "61.67766", "24.3572", "Europe/Helsinki"),("643644", "Orimattila", "", "FI", "246", "", "07", "071", "560", "60.80487", "25.72964", "Europe/Helsinki"),("644100", "Nykarleby", "", "FI", "246", "", "15", "154", "893", "63.52277", "22.53073", "Europe/Helsinki"),("644159", "Nurmo", "", "FI", "246", "", "14", "142", "743", "62.8287", "22.9099", "Europe/Helsinki"),("644171", "Nurmijärvi", "Нурмиярви", "FI", "246", "", "01", "011", "543", "60.46407", "24.8073", "Europe/Helsinki"),("644187", "Nurmes", "", "FI", "246", "", "12", "125", "541", "63.54205", "29.13965", "Europe/Helsinki"),("644436", "Noormarkku", "", "FI", "246", "", "04", "043", "609", "61.59274", "21.86846", "Europe/Helsinki"),("644450", "Nokia", "Нокиа", "FI", "246", "", "06", "064", "536", "61.46667", "23.5", "Europe/Helsinki"),("644499", "Nivala", "", "FI", "246", "", "17", "176", "535", "63.91667", "24.96667", "Europe/Helsinki"),("644632", "Nilsiä", "", "FI", "246", "", "11", "112", "297", "63.20746", "28.08222", "Europe/Helsinki"),("645035", "Nastola", "", "FI", "246", "", "07", "071", "398", "60.95", "25.93333", "Europe/Helsinki"),("645148", "Nakkila", "", "FI", "246", "", "04", "043", "531", "61.36667", "22", "Europe/Helsinki"),("645211", "Naantali", "", "FI", "246", "", "02", "023", "529", "60.46744", "22.02428", "Europe/Helsinki"),("645243", "Mynämäki", "", "FI", "246", "", "02", "023", "503", "60.67915", "21.99274", "Europe/Helsinki"),("645385", "Muurame", "", "FI", "246", "", "13", "131", "500", "62.13333", "25.66667", "Europe/Helsinki"),("645765", "Muhos", "", "FI", "246", "", "17", "171", "494", "64.80798", "25.99314", "Europe/Helsinki"),("646005", "Mikkeli", "Миккели", "FI", "246", "", "10", "101", "491", "61.68857", "27.27227", "Europe/Helsinki"),("646486", "Masku", "", "FI", "246", "", "02", "023", "481", "60.57082", "22.09883", "Europe/Helsinki"),("646699", "Mäntyharju", "", "FI", "246", "", "10", "101", "507", "61.41667", "26.88333", "Europe/Helsinki"),("646705", "Mänttä", "", "FI", "246", "", "06", "069", "508", "62.03014", "24.62791", "Europe/Helsinki"),("646723", "Mäntsälä", "Мянтсяля", "FI", "246", "", "01", "011", "505", "60.63333", "25.31667", "Europe/Helsinki"),("646875", "Malax", "", "FI", "246", "", "15", "152", "475", "62.94225", "21.57311", "Europe/Helsinki"),("647288", "Luumäki", "", "FI", "246", "", "09", "091", "441", "60.92618", "27.58135", "Europe/Helsinki"),("647571", "Lovisa", "", "FI", "246", "", "01", "016", "434", "60.45659", "26.22505", "Europe/Helsinki"),("647660", "Loppi", "", "FI", "246", "", "05", "052", "433", "60.71667", "24.45", "Europe/Helsinki"),("647751", "Lohja", "", "FI", "246", "", "01", "011", "444", "60.24859", "24.06534", "Europe/Helsinki"),("647851", "Liperi", "", "FI", "246", "", "12", "122", "426", "62.53333", "29.36667", "Europe/Helsinki"),("647930", "Liminka", "", "FI", "246", "", "17", "171", "425", "64.80985", "25.41545", "Europe/Helsinki"),("648056", "Lieto", "", "FI", "246", "", "02", "023", "423", "60.51032", "22.46176", "Europe/Helsinki"),("648090", "Lieksa", "", "FI", "246", "", "12", "125", "422", "63.31667", "30.01667", "Europe/Helsinki"),("648227", "Leppävirta", "", "FI", "246", "", "11", "114", "420", "62.49009", "27.78262", "Europe/Helsinki"),("648366", "Lempäälä", "", "FI", "246", "", "06", "064", "418", "61.31667", "23.75", "Europe/Helsinki"),("648738", "Laukaa", "Лаука", "FI", "246", "", "13", "131", "410", "62.41407", "25.95194", "Europe/Helsinki"),("648855", "Lapua", "", "FI", "246", "", "14", "142", "408", "62.96927", "23.0088", "Europe/Helsinki"),("648900", "Lappeenranta", "Лаппенранта", "FI", "246", "", "09", "091", "405", "61.05871", "28.18871", "Europe/Helsinki"),("648953", "Lapinlahti", "", "FI", "246", "", "11", "111", "402", "63.36667", "27.4", "Europe/Helsinki"),("649223", "Lammi", "", "FI", "246", "", "05", "051", "109", "61.08333", "25.01667", "Europe/Helsinki"),("649302", "Laitila", "", "FI", "246", "", "02", "024", "400", "60.87575", "21.69765", "Europe/Helsinki"),("649348", "Laihia", "", "FI", "246", "", "15", "151", "399", "62.97609", "22.01143", "Europe/Helsinki"),("649360", "Lahti", "Лахти", "FI", "246", "", "07", "071", "398", "60.98267", "25.66151", "Europe/Helsinki"),("649630", "Kirkkonummi", "", "FI", "246", "", "01", "011", "257", "60.12381", "24.43853", "Europe/Helsinki"),("649924", "Kuusamo", "Куусамо", "FI", "246", "", "17", "178", "305", "65.96667", "29.18333", "Europe/Helsinki"),("650095", "Kurikka", "", "FI", "246", "", "14", "142", "301", "62.61667", "22.41667", "Europe/Helsinki"),("650224", "Kuopio", "Куопио", "FI", "246", "", "11", "112", "297", "62.89238", "27.67703", "Europe/Helsinki"),("650705", "Kuhmo", "", "FI", "246", "", "18", "181", "290", "64.13333", "29.51667", "Europe/Helsinki"),("650754", "Kronoby", "", "FI", "246", "", "15", "154", "288", "63.72859", "23.03387", "Europe/Helsinki"),("650769", "Kristinestad", "", "FI", "246", "", "15", "153", "287", "62.27429", "21.37596", "Europe/Helsinki"),("650859", "Kouvola", "Коувола", "FI", "246", "", "08", "081", "286", "60.86667", "26.7", "Europe/Helsinki");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("650946", "Kotka", "Котка", "FI", "246", "", "08", "082", "285", "60.46667", "26.91667", "Europe/Helsinki"),("651299", "Korsholm", "", "FI", "246", "", "15", "152", "499", "63.11418", "21.68216", "Europe/Helsinki"),("651350", "Korpilahti", "", "FI", "246", "", "13", "131", "179", "62.01667", "25.55", "Europe/Helsinki"),("651659", "Kontiolahti", "", "FI", "246", "", "12", "122", "276", "62.76023", "29.84711", "Europe/Helsinki"),("651943", "Kokkola", "Коккола", "FI", "246", "", "16", "162", "272", "63.83847", "23.13066", "Europe/Helsinki"),("651980", "Kokemäki", "", "FI", "246", "", "04", "043", "271", "61.25647", "22.35643", "Europe/Helsinki"),("652559", "Kiuruvesi", "", "FI", "246", "", "11", "111", "263", "63.65", "26.61667", "Europe/Helsinki"),("652590", "Kittilä", "", "FI", "246", "", "19", "196", "261", "67.66474", "24.89356", "Europe/Helsinki"),("652615", "Kitee", "", "FI", "246", "", "12", "124", "260", "62.1", "30.15", "Europe/Helsinki"),("652858", "Kiiminki", "", "FI", "246", "", "17", "171", "564", "65.13139", "25.79744", "Europe/Helsinki"),("652977", "Keuruu", "", "FI", "246", "", "13", "133", "249", "62.26667", "24.7", "Europe/Helsinki"),("653180", "Kerimäki", "", "FI", "246", "", "10", "103", "740", "61.91069", "29.28228", "Europe/Helsinki"),("653185", "Kerava", "Керава", "FI", "246", "", "01", "011", "245", "60.40338", "25.105", "Europe/Helsinki"),("653252", "Kempele", "", "FI", "246", "", "17", "171", "244", "64.91314", "25.50339", "Europe/Helsinki"),("653272", "Kemijärvi", "", "FI", "246", "", "19", "194", "320", "66.66667", "27.41667", "Europe/Helsinki"),("653280", "Keminmaa", "", "FI", "246", "", "19", "192", "241", "65.80158", "24.54483", "Europe/Helsinki"),("653281", "Kemi", "Кеми", "FI", "246", "", "19", "192", "240", "65.73641", "24.56371", "Europe/Helsinki"),("653559", "Kauniainen", "", "FI", "246", "", "01", "011", "235", "60.21209", "24.72756", "Europe/Helsinki"),("653616", "Kauhava", "", "FI", "246", "", "14", "142", "233", "63.10299", "23.07129", "Europe/Helsinki"),("653627", "Kauhajoki", "", "FI", "246", "", "14", "141", "232", "62.43333", "22.18333", "Europe/Helsinki"),("653960", "Karkkila", "", "FI", "246", "", "01", "011", "224", "60.53418", "24.20977", "Europe/Helsinki"),("654047", "Karis", "", "FI", "246", "", "01", "014", "710", "60.07178", "23.66163", "Europe/Helsinki"),("654137", "Karhula", "Кархула", "FI", "246", "", "08", "082", "285", "60.52156", "26.93125", "Europe/Helsinki"),("654314", "Kannus", "", "FI", "246", "", "16", "162", "217", "63.9", "23.9", "Europe/Helsinki"),("654363", "Kankaanpää", "", "FI", "246", "", "04", "044", "214", "61.8", "22.41667", "Europe/Helsinki"),("654405", "Kangasniemi", "", "FI", "246", "", "10", "101", "213", "61.99357", "26.64785", "Europe/Helsinki"),("654440", "Kangasala", "Кангасала", "FI", "246", "", "06", "064", "211", "61.46383", "24.07602", "Europe/Helsinki"),("654837", "Kalajoki", "", "FI", "246", "", "17", "177", "208", "64.25", "23.95", "Europe/Helsinki"),("654899", "Kajaani", "Каяни", "FI", "246", "", "18", "182", "205", "64.22728", "27.72846", "Europe/Helsinki"),("655130", "Kaarina", "Каарина", "FI", "246", "", "02", "023", "202", "60.40724", "22.36904", "Europe/Helsinki"),("655194", "Jyväskylä", "Ювяскюля", "FI", "246", "", "13", "131", "179", "62.24147", "25.72088", "Europe/Helsinki"),("655253", "Juva", "", "FI", "246", "", "10", "105", "178", "61.9", "27.85", "Europe/Helsinki"),("655312", "Juuka", "", "FI", "246", "", "12", "122", "176", "63.23333", "29.25", "Europe/Helsinki"),("655533", "Juankoski", "", "FI", "246", "", "11", "112", "297", "63.06667", "28.35", "Europe/Helsinki"),("655563", "Joutseno", "", "FI", "246", "", "09", "091", "405", "61.11796", "28.50763", "Europe/Helsinki"),("655626", "Joroinen", "", "FI", "246", "", "10", "105", "171", "62.17823", "27.83165", "Europe/Helsinki"),("655692", "Jokioinen", "", "FI", "246", "", "05", "053", "169", "60.80162", "23.48004", "Europe/Helsinki"),("655808", "Joensuu", "Йоэнсуу", "FI", "246", "", "12", "122", "167", "62.60118", "29.76316", "Europe/Helsinki"),("655958", "Järvenpää", "Ярвенпяя", "FI", "246", "", "01", "011", "186", "60.47369", "25.08992", "Europe/Helsinki"),("656073", "Janakkala", "Янаккала", "FI", "246", "", "05", "051", "165", "60.9", "24.6", "Europe/Helsinki"),("656076", "Jämsänkoski", "", "FI", "246", "", "13", "134", "182", "61.919", "25.17011", "Europe/Helsinki"),("656083", "Jämsä", "Йямся", "FI", "246", "", "13", "134", "182", "61.8642", "25.19002", "Europe/Helsinki"),("656117", "Jalasjärvi", "", "FI", "246", "", "14", "142", "301", "62.5", "22.75", "Europe/Helsinki"),("656130", "Jakobstad", "Якобстад", "FI", "246", "", "15", "154", "598", "63.67486", "22.70256", "Europe/Helsinki"),("656456", "Isokyrö", "", "FI", "246", "", "15", "151", "152", "63.01172", "22.33332", "Europe/Helsinki"),("656652", "Ingå", "", "FI", "246", "", "01", "014", "149", "60.04587", "24.00459", "Europe/Helsinki"),("656657", "Inari", "", "FI", "246", "", "19", "197", "148", "68.90596", "27.02881", "Europe/Helsinki"),("656688", "Imatra", "Иматра", "FI", "246", "", "09", "093", "153", "61.17185", "28.75242", "Europe/Helsinki"),("656709", "Ilomantsi", "", "FI", "246", "", "12", "122", "146", "62.67162", "30.93276", "Europe/Helsinki"),("656739", "Ilmajoki", "", "FI", "246", "", "14", "142", "145", "62.73333", "22.56667", "Europe/Helsinki"),("656789", "Ikaalinen", "", "FI", "246", "", "06", "061", "143", "61.76951", "23.0658", "Europe/Helsinki"),("656807", "Iitti", "", "FI", "246", "", "08", "081", "142", "60.89488", "26.33869", "Europe/Helsinki"),("656820", "Iisalmi", "Исалми", "FI", "246", "", "11", "111", "140", "63.55915", "27.19067", "Europe/Helsinki"),("656851", "Ii", "", "FI", "246", "", "17", "173", "139", "65.31735", "25.3731", "Europe/Helsinki"),("656913", "Hyvinge", "Хювинкяя", "FI", "246", "", "01", "011", "106", "60.63333", "24.86667", "Europe/Helsinki"),("657180", "Huittinen", "", "FI", "246", "", "04", "043", "102", "61.18333", "22.7", "Europe/Helsinki"),("657530", "Hollola", "Холлола", "FI", "246", "", "07", "071", "098", "61.05", "25.43333", "Europe/Helsinki"),("658225", "Helsinki", "Хельсинки", "FI", "246", "", "01", "011", "091", "60.16952", "24.93545", "Europe/Helsinki"),("658288", "Heinola", "Хейнола", "FI", "246", "", "07", "071", "111", "61.20564", "26.03811", "Europe/Helsinki"),("658581", "Hausjärvi", "", "FI", "246", "", "05", "052", "086", "60.78333", "24.93333", "Europe/Helsinki"),("658629", "Haukipudas", "Хаукипудас", "FI", "246", "", "17", "171", "564", "65.17654", "25.35233", "Europe/Helsinki"),("658921", "Harjavalta", "", "FI", "246", "", "04", "043", "079", "61.31667", "22.13333", "Europe/Helsinki"),("659024", "Hankasalmi", "", "FI", "246", "", "13", "131", "077", "62.38333", "26.43333", "Europe/Helsinki"),("659101", "Hanko", "", "FI", "246", "", "01", "014", "078", "59.83333", "22.95", "Europe/Helsinki"),("659169", "Hamina", "Хамина", "FI", "246", "", "08", "082", "075", "60.56974", "27.19794", "Europe/Helsinki"),("659180", "Hämeenlinna", "Хямеэнлинна", "FI", "246", "", "05", "051", "109", "60.99596", "24.46434", "Europe/Helsinki"),("659184", "Hämeenkyrö", "", "FI", "246", "", "06", "064", "108", "61.63913", "23.19531", "Europe/Helsinki"),("659350", "Halikko", "", "FI", "246", "", "02", "022", "734", "60.4", "23.08333", "Europe/Helsinki"),("659554", "Haapavesi", "", "FI", "246", "", "17", "175", "071", "64.13333", "25.36667", "Europe/Helsinki"),("659681", "Haapajärvi", "", "FI", "246", "", "17", "176", "069", "63.75", "25.33333", "Europe/Helsinki"),("659935", "Forssa", "Форсса", "FI", "246", "", "05", "053", "061", "60.81462", "23.62146", "Europe/Helsinki"),("660073", "Eurajoki", "", "FI", "246", "", "04", "041", "051", "61.2", "21.73333", "Europe/Helsinki"),("660077", "Eura", "", "FI", "246", "", "04", "041", "050", "61.13333", "22.13333", "Europe/Helsinki"),("660158", "Espoo", "Эспоо", "FI", "246", "", "01", "011", "049", "60.2052", "24.6522", "Europe/Helsinki"),("660242", "Eno", "", "FI", "246", "", "12", "122", "167", "62.80511", "30.15422", "Europe/Helsinki"),("660294", "Elimäki", "", "FI", "246", "", "08", "081", "286", "60.71667", "26.46667", "Europe/Helsinki"),("660325", "Ekenäs", "", "FI", "246", "", "01", "014", "710", "59.97359", "23.43389", "Europe/Helsinki"),("660561", "Porvoo", "Порвоо", "FI", "246", "", "01", "015", "638", "60.39233", "25.66507", "Europe/Helsinki"),("660949", "Asikkala", "", "FI", "246", "", "07", "071", "016", "61.21667", "25.5", "Europe/Helsinki"),("661164", "Anjala", "Анъяла", "FI", "246", "", "08", "081", "286", "60.68333", "26.83333", "Europe/Helsinki"),("661352", "Alavus", "", "FI", "246", "", "14", "144", "010", "62.58333", "23.61667", "Europe/Helsinki"),("661576", "Alajärvi", "", "FI", "246", "", "14", "146", "005", "63", "23.81667", "Europe/Helsinki"),("661896", "Ähtäri", "", "FI", "246", "", "14", "144", "989", "62.55403", "24.06186", "Europe/Helsinki"),("662095", "Äänekoski", "", "FI", "246", "", "13", "135", "992", "62.6", "25.73333", "Europe/Helsinki"),("7910855", "Toijala", "", "FI", "246", "", "06", "063", "020", "61.1678", "23.83819", "Europe/Helsinki"),("7911309", "Länsi-Turunmaa", "", "FI", "246", "", "02", "021", "445", "60.29972", "22.3004", "Europe/Helsinki"),("2967108", "Blaye", "", "FR", "250", "", "75", "33", "331", "45.13333", "-0.66667", "Europe/Paris"),("2967166", "Yzeure", "", "FR", "250", "", "84", "03", "032", "46.56438", "3.35495", "Europe/Paris"),("2967189", "Yvetot", "", "FR", "250", "", "28", "76", "763", "49.61744", "0.75814", "Europe/Paris"),("2967203", "Yssingeaux", "", "FR", "250", "", "84", "43", "433", "45.13333", "4.11667", "Europe/Paris"),("2967245", "Yerres", "Йер", "FR", "250", "", "11", "91", "912", "48.71785", "2.49338", "Europe/Paris"),("2967288", "Wormhout", "", "FR", "250", "", "32", "59", "594", "50.88129", "2.46901", "Europe/Paris"),("2967297", "Woippy", "", "FR", "250", "", "44", "57", "574", "49.14946", "6.14909", "Europe/Paris"),("2967318", "Wittenheim", "", "FR", "250", "", "44", "68", "684", "47.8078", "7.33702", "Europe/Paris"),("2967319", "Wittelsheim", "", "FR", "250", "", "44", "68", "686", "47.80947", "7.24154", "Europe/Paris"),("2967325", "Wissembourg", "", "FR", "250", "", "44", "67", "677", "49.03708", "7.94548", "Europe/Paris"),("2967337", "Wintzenheim", "", "FR", "250", "", "44", "68", "682", "48.07269", "7.29072", "Europe/Paris"),("2967343", "Wingles", "", "FR", "250", "", "32", "62", "627", "50.49382", "2.855", "Europe/Paris"),("2967351", "Wimereux", "", "FR", "250", "", "32", "62", "623", "50.76963", "1.61139", "Europe/Paris"),("2967410", "Waziers", "", "FR", "250", "", "32", "59", "593", "50.38717", "3.1149", "Europe/Paris"),("2967411", "Wavrin", "", "FR", "250", "", "32", "59", "595", "50.57386", "2.9363", "Europe/Paris"),("2967421", "Wattrelos", "Ваттрело", "FR", "250", "", "32", "59", "595", "50.70118", "3.21812", "Europe/Paris"),("2967423", "Wattignies", "", "FR", "250", "", "32", "59", "595", "50.58639", "3.04394", "Europe/Paris"),("2967437", "Wasselonne", "", "FR", "250", "", "44", "67", "673", "48.63723", "7.44731", "Europe/Paris"),("2967438", "Wasquehal", "Васкеаль", "FR", "250", "", "32", "59", "595", "50.67043", "3.13382", "Europe/Paris"),("2967482", "Wambrechies", "", "FR", "250", "", "32", "59", "595", "50.68276", "3.04784", "Europe/Paris"),("2967494", "Wallers", "", "FR", "250", "", "32", "59", "596", "50.37432", "3.39188", "Europe/Paris"),("2967695", "Voreppe", "", "FR", "250", "", "84", "38", "381", "45.29476", "5.63324", "Europe/Paris"),("2967745", "Voisins-le-Bretonneux", "", "FR", "250", "", "11", "78", "782", "48.75793", "2.05137", "Europe/Paris"),("2967758", "Voiron", "Вуарон", "FR", "250", "", "84", "38", "381", "45.36395", "5.59209", "Europe/Paris"),("2967796", "Vizille", "", "FR", "250", "", "84", "38", "381", "45.07819", "5.77074", "Europe/Paris"),("2967845", "Vittel", "", "FR", "250", "", "44", "88", "882", "48.20085", "5.94843", "Europe/Paris"),("2967849", "Vitry-sur-Seine", "Витри-сюр-Сен", "FR", "250", "", "11", "94", "941", "48.78716", "2.40332", "Europe/Paris"),("2967856", "Vitry-le-François", "Витри-ле-Франсуа", "FR", "250", "", "44", "51", "514", "48.73333", "4.58333", "Europe/Paris"),("2967870", "Vitrolles", "Витроль", "FR", "250", "", "93", "13", "134", "43.46", "5.24861", "Europe/Paris"),("2967879", "Vitré", "Витрэ", "FR", "250", "", "53", "35", "351", "48.11776", "-1.20577", "Europe/Paris"),("2967917", "Viry-Châtillon", "Вири-Шатиллон", "FR", "250", "", "11", "91", "912", "48.67211", "2.39318", "Europe/Paris"),("2967934", "Viroflay", "Вирофле", "FR", "250", "", "11", "78", "784", "48.80078", "2.16181", "Europe/Paris"),("2967949", "Viriat", "", "FR", "250", "", "84", "01", "012", "46.25484", "5.21567", "Europe/Paris"),("2967972", "Vire", "", "FR", "250", "", "28", "14", "144", "48.83333", "-0.88333", "Europe/Paris"),("2968035", "Vineuil", "", "FR", "250", "", "24", "41", "411", "47.5838", "1.37601", "Europe/Paris"),("2968054", "Vincennes", "Венсен", "FR", "250", "", "11", "94", "942", "48.8486", "2.43769", "Europe/Paris"),("2968142", "Villiers-sur-Marne", "Вилье-сюр-Марн", "FR", "250", "", "11", "94", "942", "48.831", "2.54844", "Europe/Paris"),("2968176", "Villiers-le-Bel", "Вилье-ле-Бель", "FR", "250", "", "11", "95", "952", "49.00875", "2.39819", "Europe/Paris"),("2968254", "Villeurbanne", "Вийёрбан", "FR", "250", "", "84", "69", "691", "45.76667", "4.88333", "Europe/Paris"),("2968275", "Villetaneuse", "", "FR", "250", "", "11", "93", "933", "48.95833", "2.34167", "Europe/Paris"),("2968316", "Villerupt", "", "FR", "250", "", "44", "54", "541", "49.46737", "5.93285", "Europe/Paris"),("2968348", "Villers-Saint-Paul", "", "FR", "250", "", "32", "60", "604", "49.28885", "2.48968", "Europe/Paris"),("2968368", "Villers-lès-Nancy", "Виллер-ле-Нанси", "FR", "250", "", "44", "54", "543", "48.67103", "6.15083", "Europe/Paris"),("2968405", "Villers-Cotterêts", "", "FR", "250", "", "32", "02", "024", "49.25311", "3.09003", "Europe/Paris"),("2968475", "Villepreux", "", "FR", "250", "", "11", "78", "783", "48.82815", "1.9976", "Europe/Paris"),("2968482", "Villepinte", "", "FR", "250", "", "11", "93", "932", "48.96203", "2.53253", "Europe/Paris"),("2968496", "Villeparisis", "Вильпаризи", "FR", "250", "", "11", "77", "775", "48.94208", "2.61463", "Europe/Paris"),("2968507", "Villennes-sur-Seine", "", "FR", "250", "", "11", "78", "783", "48.94137", "1.99137", "Europe/Paris"),("2968510", "Villeneuve-Tolosane", "", "FR", "250", "", "76", "31", "313", "43.52316", "1.34102", "Europe/Paris"),("2968511", "Villeneuve-sur-Yonne", "", "FR", "250", "", "27", "89", "893", "48.08247", "3.29688", "Europe/Paris"),("2968515", "Villeneuve-sur-Lot", "Вильнев-сюр-Ло", "FR", "250", "", "75", "47", "473", "44.40854", "0.70415", "Europe/Paris"),("2968529", "Villeneuve-Saint-Georges", "Вильнёв-Сен-Жорж", "FR", "250", "", "11", "94", "941", "48.73219", "2.44925", "Europe/Paris"),("2968533", "Villeneuve-Loubet", "", "FR", "250", "", "93", "06", "061", "43.66663", "7.1204", "Europe/Paris"),("2968536", "Villeneuve-lès-Maguelone", "", "FR", "250", "", "76", "34", "343", "43.53333", "3.86667", "Europe/Paris"),("2968545", "Villeneuve-lès-Avignon", "", "FR", "250", "", "76", "30", "302", "43.9684", "4.7963", "Europe/Paris"),("2968546", "Villeneuve-le-Roi", "", "FR", "250", "", "11", "94", "941", "48.73684", "2.40081", "Europe/Paris"),("2968555", "Villeneuve-la-Garenne", "", "FR", "250", "", "11", "92", "922", "48.93935", "2.31478", "Europe/Paris"),("2968620", "Villenave-d’Ornon", "", "FR", "250", "", "75", "33", "332", "44.77327", "-0.5442", "Europe/Paris"),("2968626", "Villemur-sur-Tarn", "", "FR", "250", "", "76", "31", "313", "43.86708", "1.50281", "Europe/Paris"),("2968653", "Villemomble", "", "FR", "250", "", "11", "93", "931", "48.88333", "2.5", "Europe/Paris"),("2968655", "Villemoisson-sur-Orge", "", "FR", "250", "", "11", "91", "913", "48.66632", "2.33657", "Europe/Paris"),("2968682", "Villemandeur", "", "FR", "250", "", "24", "45", "451", "47.98701", "2.71802", "Europe/Paris"),("2968703", "Ville-la-Grand", "", "FR", "250", "", "84", "74", "743", "46.203", "6.2501", "Europe/Paris"),("2968705", "Villejuif", "Вильжюиф", "FR", "250", "", "11", "94", "943", "48.7939", "2.35992", "Europe/Paris"),("2968748", "Villefranche-sur-Saône", "Вильфранш-сюр-Сон", "FR", "250", "", "84", "69", "692", "45.98333", "4.71667", "Europe/Paris"),("2968749", "Villefranche-sur-Mer", "", "FR", "250", "", "93", "06", "062", "43.7047", "7.30776", "Europe/Paris"),("2968755", "Villefranche-de-Rouergue", "", "FR", "250", "", "76", "12", "123", "44.35166", "2.03702", "Europe/Paris"),("2968771", "Villefontaine", "", "FR", "250", "", "84", "38", "382", "45.6125", "5.14558", "Europe/Paris"),("2968819", "Ville-d’Avray", "", "FR", "250", "", "11", "92", "923", "48.82358", "2.19311", "Europe/Paris"),("2968823", "Villecresnes", "", "FR", "250", "", "11", "94", "941", "48.72002", "2.5394", "Europe/Paris"),("2968861", "Villebon-sur-Yvette", "", "FR", "250", "", "11", "91", "913", "48.70594", "2.24019", "Europe/Paris"),("2968935", "Villars", "", "FR", "250", "", "84", "42", "423", "45.47118", "4.35447", "Europe/Paris"),("2968985", "Villard-Bonnot", "", "FR", "250", "", "84", "38", "381", "45.24", "5.89015", "Europe/Paris"),("2969058", "Villabé", "", "FR", "250", "", "11", "91", "912", "48.58949", "2.45096", "Europe/Paris"),("2969109", "Vigneux-sur-Seine", "", "FR", "250", "", "11", "91", "912", "48.70291", "2.41357", "Europe/Paris"),("2969111", "Vigneux-de-Bretagne", "", "FR", "250", "", "52", "44", "442", "47.32547", "-1.73678", "Europe/Paris"),("2969160", "Vif", "", "FR", "250", "", "84", "38", "381", "45.05436", "5.67757", "Europe/Paris"),("2969213", "Vieux-Condé", "", "FR", "250", "", "32", "59", "596", "50.45944", "3.56738", "Europe/Paris"),("2969257", "Vierzon", "Вьерзон", "FR", "250", "", "24", "18", "183", "47.21667", "2.08333", "Europe/Paris"),("2969284", "Vienne", "Вьенн", "FR", "250", "", "84", "38", "383", "45.51667", "4.86667", "Europe/Paris"),("2969353", "Vidauban", "", "FR", "250", "", "93", "83", "831", "43.4278", "6.4329", "Europe/Paris"),("2969392", "Vichy", "Виши", "FR", "250", "", "84", "03", "033", "46.11667", "3.41667", "Europe/Paris"),("2969401", "Vic-en-Bigorre", "", "FR", "250", "", "76", "65", "653", "43.38682", "0.05471", "Europe/Paris"),("2969543", "Vétraz-Monthoux", "", "FR", "250", "", "84", "74", "743", "46.1743", "6.25852", "Europe/Paris"),("2969562", "Vesoul", "Везуль", "FR", "250", "", "27", "70", "702", "47.63333", "6.16667", "Europe/Paris"),("2969608", "Vert-Saint-Denis", "", "FR", "250", "", "11", "77", "772", "48.56818", "2.62007", "Europe/Paris"),("2969612", "Vertou", "", "FR", "250", "", "52", "44", "442", "47.16869", "-1.46929", "Europe/Paris"),("2969679", "Versailles", "Версаль", "FR", "250", "", "11", "78", "784", "48.8", "2.13333", "Europe/Paris"),("2969692", "Verrières-le-Buisson", "", "FR", "250", "", "11", "91", "913", "48.74565", "2.26796", "Europe/Paris"),("2969741", "Vern-sur-Seiche", "", "FR", "250", "", "53", "35", "353", "48.04514", "-1.60057", "Europe/Paris"),("2969751", "Vernouillet", "", "FR", "250", "", "11", "78", "783", "48.97146", "1.98082", "Europe/Paris"),("2969752", "Vernouillet", "", "FR", "250", "", "24", "28", "283", "48.7209", "1.36951", "Europe/Paris"),("2969766", "Vernon", "", "FR", "250", "", "28", "27", "273", "49.09292", "1.46332", "Europe/Paris"),("2969796", "Verneuil-sur-Seine", "", "FR", "250", "", "11", "78", "783", "48.97388", "1.9648", "Europe/Paris"),("2969799", "Verneuil-sur-Avre", "", "FR", "250", "", "28", "27", "273", "48.73949", "0.92731", "Europe/Paris"),("2969958", "Verdun", "Верден", "FR", "250", "", "44", "55", "553", "49.16667", "5.38333", "Europe/Paris"),("2970072", "Vénissieux", "Венисье", "FR", "250", "", "84", "69", "691", "45.70254", "4.87147", "Europe/Paris"),("2970080", "Veneux-les-Sablons", "", "FR", "250", "", "11", "77", "774", "48.37872", "2.79499", "Europe/Paris"),("2970092", "Venelles", "", "FR", "250", "", "93", "13", "131", "43.59839", "5.48529", "Europe/Paris"),("2970110", "Vendôme", "Вандом", "FR", "250", "", "24", "41", "412", "47.8", "1.06667", "Europe/Paris"),("2970113", "Vendin-le-Vieil", "", "FR", "250", "", "32", "62", "627", "50.47385", "2.86674", "Europe/Paris"),("2970128", "Vendenheim", "", "FR", "250", "", "44", "67", "676", "48.66948", "7.70983", "Europe/Paris"),("2970144", "Vendargues", "", "FR", "250", "", "76", "34", "343", "43.65833", "3.97", "Europe/Paris"),("2970148", "Vence", "", "FR", "250", "", "93", "06", "061", "43.72254", "7.11183", "Europe/Paris"),("2970203", "Vélizy-Villacoublay", "", "FR", "250", "", "11", "78", "784", "48.78198", "2.19395", "Europe/Paris"),("2970216", "Velaux", "", "FR", "250", "", "93", "13", "131", "43.52839", "5.25661", "Europe/Paris"),("2970237", "Veigné", "", "FR", "250", "", "24", "37", "372", "47.28556", "0.74079", "Europe/Paris"),("2970253", "Vedène", "", "FR", "250", "", "93", "84", "842", "43.97744", "4.90428", "Europe/Paris"),("2970275", "Veauche", "", "FR", "250", "", "84", "42", "421", "45.56294", "4.29031", "Europe/Paris"),("2970338", "Vaux-le-Pénil", "", "FR", "250", "", "11", "77", "772", "48.52803", "2.69165", "Europe/Paris"),("2970407", "Vauvert", "", "FR", "250", "", "76", "30", "302", "43.69529", "4.27705", "Europe/Paris"),("2970432", "Vauréal", "Вореаль", "FR", "250", "", "11", "95", "953", "49.03333", "2.03333", "Europe/Paris"),("2970456", "Vaulx-en-Velin", "", "FR", "250", "", "84", "69", "691", "45.7818", "4.92085", "Europe/Paris"),("2970469", "Vaujours", "", "FR", "250", "", "11", "93", "932", "48.93022", "2.5711", "Europe/Paris"),("2970540", "Vaucresson", "", "FR", "250", "", "11", "92", "923", "48.84078", "2.15652", "Europe/Paris"),("2970761", "Vanves", "Ванв", "FR", "250", "", "11", "92", "921", "48.82345", "2.29025", "Europe/Paris"),("2970777", "Vannes", "Ванн", "FR", "250", "", "53", "56", "563", "47.66667", "-2.75", "Europe/Paris"),("2970797", "Vandœuvre-lès-Nancy", "Вандёвр-ле-Нанси", "FR", "250", "", "44", "54", "543", "48.65", "6.18333", "Europe/Paris"),("2970838", "Valréas", "", "FR", "250", "", "93", "84", "842", "44.38366", "4.99084", "Europe/Paris"),("2970860", "Valognes", "", "FR", "250", "", "28", "50", "502", "49.50881", "-1.47047", "Europe/Paris"),("2970923", "Vallet", "", "FR", "250", "", "52", "44", "442", "47.16227", "-1.26607", "Europe/Paris"),("2970962", "Vallauris", "Валлорис", "FR", "250", "", "93", "06", "061", "43.57803", "7.05451", "Europe/Paris"),("2971006", "Valfin-lès-Saint-Claude", "", "FR", "250", "", "27", "39", "393", "46.43758", "5.85513", "Europe/Paris"),("2971027", "Valenton", "", "FR", "250", "", "11", "94", "941", "48.74527", "2.46467", "Europe/Paris"),("2971030", "Valentigney", "", "FR", "250", "", "27", "25", "252", "47.46388", "6.83168", "Europe/Paris"),("2971041", "Valenciennes", "Валансьен", "FR", "250", "", "32", "59", "596", "50.35", "3.53333", "Europe/Paris"),("2971053", "Valence", "", "FR", "250", "", "84", "26", "263", "44.93333", "4.9", "Europe/Paris"),("2971054", "Valence", "", "FR", "250", "", "76", "82", "821", "44.10823", "0.89101", "Europe/Paris"),("2971072", "Valdoie", "", "FR", "250", "", "27", "90", "901", "47.66799", "6.84446", "Europe/Paris"),("2971117", "Valbonne", "", "FR", "250", "", "93", "06", "061", "43.63292", "6.99911", "Europe/Paris"),("2971154", "Vaison-la-Romaine", "", "FR", "250", "", "93", "84", "843", "44.23896", "5.07461", "Europe/Paris"),("2971157", "Vaires-sur-Marne", "", "FR", "250", "", "11", "77", "775", "48.87649", "2.63982", "Europe/Paris"),("2971258", "Uzès", "", "FR", "250", "", "76", "30", "302", "44.01362", "4.41529", "Europe/Paris"),("2971286", "Ustaritz", "", "FR", "250", "", "75", "64", "641", "43.3965", "-1.45603", "Europe/Paris"),("2971298", "Ussel", "", "FR", "250", "", "75", "19", "193", "45.55", "2.31667", "Europe/Paris"),("2971336", "Urrugne", "", "FR", "250", "", "75", "64", "641", "43.36361", "-1.69921", "Europe/Paris"),("2971377", "Unieux", "", "FR", "250", "", "84", "42", "423", "45.4004", "4.27812", "Europe/Paris"),("2971399", "Ugine", "", "FR", "250", "", "84", "73", "731", "45.75084", "6.41611", "Europe/Paris"),("2971407", "Uckange", "", "FR", "250", "", "44", "57", "578", "49.30304", "6.1492", "Europe/Paris"),("2971480", "Tullins", "", "FR", "250", "", "84", "38", "381", "45.29861", "5.48609", "Europe/Paris"),("2971482", "Tulle", "Тюль", "FR", "250", "", "75", "19", "192", "45.26667", "1.76667", "Europe/Paris"),("2971549", "Troyes", "Труа", "FR", "250", "", "44", "10", "103", "48.3", "4.08333", "Europe/Paris"),("2971555", "Trouville-sur-Mer", "", "FR", "250", "", "28", "14", "143", "49.3657", "0.08041", "Europe/Paris"),("2971651", "Trith-Saint-Léger", "", "FR", "250", "", "32", "59", "596", "50.31667", "3.48333", "Europe/Paris"),("2971673", "Trilport", "", "FR", "250", "", "11", "77", "771", "48.95685", "2.95076", "Europe/Paris"),("2971680", "Trignac", "", "FR", "250", "", "52", "44", "443", "47.31809", "-2.18895", "Europe/Paris"),("2971689", "Triel-sur-Seine", "", "FR", "250", "", "11", "78", "783", "48.97818", "2.00743", "Europe/Paris"),("2971722", "Trévoux", "", "FR", "250", "", "84", "01", "012", "45.94111", "4.76727", "Europe/Paris"),("2971765", "Trets", "", "FR", "250", "", "93", "13", "131", "43.44818", "5.68328", "Europe/Paris"),("2971874", "Tremblay-en-France", "Трамбле-ан-Франс", "FR", "250", "FR", "11", "93", "932", "48.94956", "2.5684", "Europe/Paris"),("2971890", "Trélissac", "", "FR", "250", "", "75", "24", "243", "45.19766", "0.78615", "Europe/Paris"),("2971896", "Trélazé", "", "FR", "250", "", "52", "49", "491", "47.44565", "-0.4654", "Europe/Paris"),("2971908", "Treillières", "", "FR", "250", "", "52", "44", "442", "47.3306", "-1.61918", "Europe/Paris"),("2971926", "Trégunc", "", "FR", "250", "", "53", "29", "294", "47.85", "-3.85", "Europe/Paris"),("2972010", "Trèbes", "", "FR", "250", "", "76", "11", "111", "43.21064", "2.44165", "Europe/Paris"),("2972049", "Trappes", "", "FR", "250", "", "11", "78", "784", "48.77413", "2.01781", "Europe/Paris"),("2972058", "Trans-en-Provence", "", "FR", "250", "", "93", "83", "831", "43.505", "6.48571", "Europe/Paris"),("2972191", "Tours", "Тур", "FR", "250", "", "24", "37", "372", "47.38333", "0.68333", "Europe/Paris"),("2972203", "Tournus", "", "FR", "250", "", "27", "71", "715", "46.56758", "4.90574", "Europe/Paris"),("2972214", "Tournon-sur-Rhône", "", "FR", "250", "", "84", "07", "073", "45.06667", "4.83333", "Europe/Paris"),("2972237", "Tournefeuille", "", "FR", "250", "", "76", "31", "313", "43.58872", "1.31922", "Europe/Paris"),("2972253", "Tournan-en-Brie", "", "FR", "250", "", "11", "77", "772", "48.74146", "2.772", "Europe/Paris"),("2972270", "Tourlaville", "", "FR", "250", "", "28", "50", "502", "49.63829", "-1.56639", "Europe/Paris"),("2972284", "Tourcoing", "Туркуэн", "FR", "250", "", "32", "59", "595", "50.72391", "3.16117", "Europe/Paris"),("2972315", "Toulouse", "Тулуза", "FR", "250", "", "76", "31", "313", "43.60426", "1.44367", "Europe/Paris"),("2972317", "Toulouges", "", "FR", "250", "", "76", "66", "662", "42.66961", "2.83008", "Europe/Paris"),("2972328", "Toulon", "Тулон", "FR", "250", "", "93", "83", "832", "43.11667", "5.93333", "Europe/Paris"),("2972350", "Toul", "Туль", "FR", "250", "", "44", "54", "544", "48.68333", "5.9", "Europe/Paris"),("2972444", "Torcy", "", "FR", "250", "", "11", "77", "775", "48.85", "2.65", "Europe/Paris"),("2972467", "Tonnerre", "", "FR", "250", "", "27", "89", "892", "47.85628", "3.97369", "Europe/Paris"),("2972468", "Tonneins", "", "FR", "250", "", "75", "47", "472", "44.39206", "0.31241", "Europe/Paris"),("2972470", "Tonnay-Charente", "", "FR", "250", "", "75", "17", "172", "45.949", "-0.8935", "Europe/Paris"),("2972486", "Tomblaine", "", "FR", "250", "", "44", "54", "543", "48.68333", "6.21312", "Europe/Paris"),("2972546", "Tinqueux", "", "FR", "250", "", "44", "51", "513", "49.25", "3.98333", "Europe/Paris"),("2972605", "Tignieu-Jameyzieu", "", "FR", "250", "", "84", "38", "382", "45.73564", "5.18046", "Europe/Paris"),("2972633", "Thyez", "", "FR", "250", "", "84", "74", "742", "46.08249", "6.53777", "Europe/Paris"),("2972665", "Thuir", "", "FR", "250", "", "76", "66", "662", "42.6329", "2.75471", "Europe/Paris"),("2972684", "Thourotte", "", "FR", "250", "", "32", "60", "603", "49.47591", "2.8821", "Europe/Paris"),("2972695", "Thouars", "", "FR", "250", "", "75", "79", "791", "46.97602", "-0.21507", "Europe/Paris"),("2972696", "Thouaré-sur-Loire", "", "FR", "250", "", "52", "44", "442", "47.26893", "-1.43834", "Europe/Paris"),("2972711", "Thorigny-sur-Marne", "", "FR", "250", "", "11", "77", "775", "48.88689", "2.71806", "Europe/Paris"),("2972742", "Thonon-les-Bains", "Тонон-ле-Бен", "FR", "250", "", "84", "74", "744", "46.36667", "6.48333", "Europe/Paris"),("2972749", "Thônes", "", "FR", "250", "", "84", "74", "741", "45.88123", "6.32572", "Europe/Paris"),("2972811", "Thionville", "Тьонвиль", "FR", "250", "", "44", "57", "577", "49.36667", "6.16667", "Europe/Paris"),("2972857", "Thiers", "", "FR", "250", "", "84", "63", "635", "45.85", "3.56667", "Europe/Paris"),("2972893", "Thiais", "Тие", "FR", "250", "", "11", "94", "943", "48.76496", "2.3961", "Europe/Paris"),("2972979", "Theix", "", "FR", "250", "", "53", "56", "563", "47.62916", "-2.65186", "Europe/Paris"),("2973008", "Thaon-les-Vosges", "", "FR", "250", "", "44", "88", "881", "48.25", "6.41667", "Europe/Paris"),("2973013", "Thann", "", "FR", "250", "", "44", "68", "686", "47.81667", "7.08333", "Europe/Paris"),("2973049", "Téteghem", "", "FR", "250", "", "32", "59", "594", "51.01859", "2.44454", "Europe/Paris"),("2973073", "Terville", "", "FR", "250", "", "44", "57", "577", "49.34714", "6.13802", "Europe/Paris"),("2973108", "Terrasson-Lavilledieu", "", "FR", "250", "", "75", "24", "244", "45.13011", "1.30136", "Europe/Paris"),("2973146", "Tergnier", "Тернье", "FR", "250", "", "32", "02", "022", "49.65607", "3.30107", "Europe/Paris"),("2973187", "Templeuve", "", "FR", "250", "", "32", "59", "595", "50.52336", "3.17809", "Europe/Paris"),("2973258", "Taverny", "Таверни", "FR", "250", "", "11", "95", "953", "49.02542", "2.21691", "Europe/Paris"),("2973317", "Tassin-la-Demi-Lune", "", "FR", "250", "", "84", "69", "691", "45.75499", "4.78812", "Europe/Paris"),("2973355", "Tarnos", "", "FR", "250", "", "75", "40", "401", "43.5417", "-1.46281", "Europe/Paris"),("2973385", "Tarbes", "Тарб", "FR", "250", "", "76", "65", "653", "43.23333", "0.08333", "Europe/Paris"),("2973393", "Tarascon", "", "FR", "250", "", "93", "13", "132", "43.80583", "4.66028", "Europe/Paris"),("2973394", "Tarare", "", "FR", "250", "", "84", "69", "692", "45.89761", "4.43272", "Europe/Paris"),("2973495", "Talence", "Таланс", "FR", "250", "", "75", "33", "332", "44.80477", "-0.59543", "Europe/Paris"),("2973510", "Talant", "", "FR", "250", "", "27", "21", "212", "47.33693", "5.00888", "Europe/Paris"),("2973511", "Talange", "", "FR", "250", "", "44", "57", "574", "49.23669", "6.17282", "Europe/Paris"),("2973531", "Tain-l’Hermitage", "", "FR", "250", "", "84", "26", "263", "45.07217", "4.83708", "Europe/Paris"),("2973639", "Sury-le-Comtal", "", "FR", "250", "", "84", "42", "421", "45.5342", "4.18642", "Europe/Paris"),("2973672", "Surgères", "", "FR", "250", "", "75", "17", "172", "46.1082", "-0.75148", "Europe/Paris"),("2973675", "Suresnes", "Сюрен", "FR", "250", "", "11", "92", "922", "48.87143", "2.22929", "Europe/Paris"),("2973703", "Sully-sur-Loire", "", "FR", "250", "", "24", "45", "452", "47.76372", "2.37238", "Europe/Paris"),("2973745", "Sucy-en-Brie", "", "FR", "250", "", "11", "94", "941", "48.76872", "2.53474", "Europe/Paris"),("2973748", "Sucé-sur-Erdre", "", "FR", "250", "", "52", "44", "442", "47.33333", "-1.53333", "Europe/Paris"),("2973783", "Strasbourg", "Страсбург", "FR", "250", "", "44", "67", "678", "48.58392", "7.74553", "Europe/Paris"),("2973795", "Stiring-Wendel", "", "FR", "250", "", "44", "57", "573", "49.2", "6.93333", "Europe/Paris"),("2973841", "Stains", "", "FR", "250", "", "11", "93", "933", "48.95", "2.38333", "Europe/Paris"),("2973882", "Soyaux", "", "FR", "250", "", "75", "16", "161", "45.65", "0.2", "Europe/Paris"),("2973918", "Soustons", "", "FR", "250", "", "75", "40", "401", "43.75328", "-1.3278", "Europe/Paris"),("2973963", "Souppes-sur-Loing", "", "FR", "250", "", "11", "77", "774", "48.18297", "2.73521", "Europe/Paris"),("2973993", "Soultz-Haut-Rhin", "", "FR", "250", "", "44", "68", "683", "47.8874", "7.23042", "Europe/Paris"),("2974087", "Souffelweyersheim", "", "FR", "250", "", "44", "67", "676", "48.6354", "7.74141", "Europe/Paris"),("2974153", "Sotteville-lès-Rouen", "Соттевиль-ле-Руан", "FR", "250", "", "28", "76", "763", "49.40972", "1.09005", "Europe/Paris"),("2974188", "Sorgues", "", "FR", "250", "", "93", "84", "842", "44.01023", "4.87381", "Europe/Paris"),("2974215", "Sorbiers", "", "FR", "250", "", "84", "42", "423", "45.48815", "4.44933", "Europe/Paris"),("2974324", "Somain", "", "FR", "250", "", "32", "59", "593", "50.35961", "3.28108", "Europe/Paris"),("2974338", "Solliès-Pont", "", "FR", "250", "", "93", "83", "832", "43.18978", "6.04321", "Europe/Paris"),("2974383", "Soisy-sur-Seine", "", "FR", "250", "", "11", "91", "912", "48.64875", "2.45223", "Europe/Paris"),("2974385", "Soisy-sous-Montmorency", "Суази-су-Монморанси", "FR", "250", "", "11", "95", "952", "48.98813", "2.30156", "Europe/Paris"),("2974389", "Soissons", "Суассон", "FR", "250", "", "32", "02", "024", "49.38167", "3.32361", "Europe/Paris"),("2974427", "Six-Fours-les-Plages", "", "FR", "250", "FR", "93", "83", "832", "43.1", "5.85", "Europe/Paris"),("2974446", "Sisteron", "", "FR", "250", "", "93", "04", "044", "44.18758", "5.94623", "Europe/Paris"),("2974494", "Sin-le-Noble", "", "FR", "250", "", "32", "59", "593", "50.36159", "3.13113", "Europe/Paris"),("2974519", "Simiane-Collongue", "", "FR", "250", "", "93", "13", "131", "43.43067", "5.43454", "Europe/Paris"),("2974640", "Sézanne", "", "FR", "250", "", "44", "51", "512", "48.72047", "3.72339", "Europe/Paris"),("2974644", "Seyssins", "", "FR", "250", "", "84", "38", "381", "45.15513", "5.67921", "Europe/Paris"),("2974645", "Seyssinet-Pariset", "", "FR", "250", "", "84", "38", "381", "45.17675", "5.69387", "Europe/Paris"),("2974648", "Seysses", "", "FR", "250", "", "76", "31", "311", "43.49801", "1.31081", "Europe/Paris"),("2974655", "Seynod", "", "FR", "250", "", "84", "74", "741", "45.88549", "6.08831", "Europe/Paris"),("2974678", "Sèvres", "Севр", "FR", "250", "", "11", "92", "923", "48.82292", "2.21757", "Europe/Paris"),("2974681", "Sevran", "", "FR", "250", "", "11", "93", "932", "48.94472", "2.52746", "Europe/Paris"),("2974733", "Sète", "Сет", "FR", "250", "", "76", "34", "343", "43.4028", "3.69278", "Europe/Paris"),("2974925", "Sérignan", "", "FR", "250", "", "76", "34", "341", "43.27873", "3.27712", "Europe/Paris"),("2975020", "Septèmes-les-Vallons", "", "FR", "250", "", "93", "13", "131", "43.39834", "5.36596", "Europe/Paris"),("2975050", "Sens", "", "FR", "250", "", "27", "89", "893", "48.2", "3.28333", "Europe/Paris"),("2975088", "Senlis", "", "FR", "250", "", "32", "60", "604", "49.2", "2.58333", "Europe/Paris"),("2975113", "Séné", "", "FR", "250", "", "53", "56", "563", "47.619", "-2.737", "Europe/Paris"),("2975120", "Sénas", "", "FR", "250", "", "93", "13", "132", "43.74375", "5.078", "Europe/Paris"),("2975143", "Semur-en-Auxois", "", "FR", "250", "", "27", "21", "213", "47.48333", "4.33333", "Europe/Paris"),("2975204", "Seloncourt", "", "FR", "250", "", "27", "25", "252", "47.45989", "6.85535", "Europe/Paris"),("2975233", "Sélestat", "Селеста", "FR", "250", "", "44", "67", "675", "48.26667", "7.45", "Europe/Paris"),("2975292", "Seichamps", "", "FR", "250", "", "44", "54", "543", "48.71114", "6.26186", "Europe/Paris"),("2975314", "Segré", "", "FR", "250", "", "52", "49", "494", "47.68333", "-0.86667", "Europe/Paris"),("2975349", "Sedan", "Седан", "FR", "250", "", "44", "08", "083", "49.7", "4.95", "Europe/Paris"),("2975361", "Seclin", "", "FR", "250", "", "32", "59", "595", "50.54873", "3.02731", "Europe/Paris"),("2975408", "Scionzier", "", "FR", "250", "", "84", "74", "742", "46.05447", "6.55757", "Europe/Paris"),("2975446", "Schiltigheim", "", "FR", "250", "", "44", "67", "676", "48.60749", "7.74931", "Europe/Paris"),("2975469", "Sceaux", "", "FR", "250", "", "11", "92", "921", "48.77644", "2.29026", "Europe/Paris"),("2975485", "Scaër", "", "FR", "250", "", "53", "29", "294", "48.03333", "-3.7", "Europe/Paris"),("2975525", "Savigny-sur-Orge", "Савиньи-сюр-Орж", "FR", "250", "", "11", "91", "913", "48.67677", "2.34835", "Europe/Paris"),("2975536", "Savigny-le-Temple", "Савиньи-ле-храм", "FR", "250", "", "11", "77", "772", "48.57409", "2.58287", "Europe/Paris"),("2975588", "Saverne", "", "FR", "250", "", "44", "67", "674", "48.74164", "7.36221", "Europe/Paris"),("2975597", "Savenay", "", "FR", "250", "", "52", "44", "443", "47.36072", "-1.94215", "Europe/Paris"),("2975702", "Sautron", "", "FR", "250", "", "52", "44", "442", "47.26274", "-1.67107", "Europe/Paris"),("2975726", "Sausset-les-Pins", "", "FR", "250", "", "93", "13", "134", "43.33136", "5.10431", "Europe/Paris"),("2975743", "Sausheim", "", "FR", "250", "", "44", "68", "684", "47.78976", "7.37134", "Europe/Paris"),("2975758", "Saumur", "Сомюр", "FR", "250", "", "52", "49", "493", "47.26667", "-0.08333", "Europe/Paris"),("2975785", "Saulx-les-Chartreux", "", "FR", "250", "", "11", "91", "913", "48.69062", "2.26727", "Europe/Paris"),("2975844", "Saujon", "", "FR", "250", "", "75", "17", "174", "45.67309", "-0.9262", "Europe/Paris"),("2975908", "Sassenage", "", "FR", "250", "", "84", "38", "381", "45.20531", "5.66515", "Europe/Paris"),("2975916", "Sarzeau", "", "FR", "250", "", "53", "56", "563", "47.52772", "-2.76933", "Europe/Paris"),("2975921", "Sartrouville", "", "FR", "250", "", "11", "78", "783", "48.9482", "2.19169", "Europe/Paris"),("2975953", "Sarrians", "", "FR", "250", "", "93", "84", "843", "44.08401", "4.96965", "Europe/Paris"),("2975964", "Sarreguemines", "Саргемин", "FR", "250", "", "44", "57", "576", "49.10995", "7.06747", "Europe/Paris"),("2975967", "Sarrebourg", "", "FR", "250", "", "44", "57", "575", "48.73333", "7.05", "Europe/Paris"),("2976007", "Sarlat-la-Canéda", "", "FR", "250", "", "75", "24", "244", "44.88902", "1.21656", "Europe/Paris"),("2976043", "Sarcelles", "Сарсель", "FR", "250", "", "11", "95", "952", "49", "2.38333", "Europe/Paris"),("2976050", "Saran", "", "FR", "250", "", "24", "45", "452", "47.95013", "1.87601", "Europe/Paris"),("2976108", "Santes", "", "FR", "250", "", "32", "59", "595", "50.59316", "2.96289", "Europe/Paris"),("2976179", "Sannois", "Саннуа", "FR", "250", "", "11", "95", "951", "48.96667", "2.25", "Europe/Paris"),("2976258", "Sanary-sur-Mer", "Санари-сюр-Мер", "FR", "250", "", "93", "83", "832", "43.11783", "5.80007", "Europe/Paris"),("2976341", "Salon-de-Provence", "Салон-де-Прованс", "FR", "250", "", "93", "13", "131", "43.64074", "5.09545", "Europe/Paris"),("2976404", "Sallaumines", "", "FR", "250", "", "32", "62", "627", "50.41749", "2.86174", "Europe/Paris"),("2976406", "Sallanches", "", "FR", "250", "", "84", "74", "742", "45.94423", "6.63162", "Europe/Paris"),("2976444", "Salies-de-Béarn", "", "FR", "250", "", "75", "64", "643", "43.47422", "-0.92448", "Europe/Paris"),("2976490", "Salbris", "", "FR", "250", "", "24", "41", "413", "47.4242", "2.05124", "Europe/Paris"),("2976542", "Saint-Yrieix-sur-Charente", "", "FR", "250", "", "75", "16", "161", "45.68333", "0.11667", "Europe/Paris"),("2976546", "Saint-Yrieix-la-Perche", "", "FR", "250", "", "75", "87", "872", "45.51604", "1.20569", "Europe/Paris"),("2976600", "Saint-Vincent-de-Tyrosse", "", "FR", "250", "", "75", "40", "401", "43.66031", "-1.30799", "Europe/Paris"),("2976656", "Saint-Victoret", "", "FR", "250", "", "93", "13", "134", "43.41957", "5.23396", "Europe/Paris"),("2976697", "Saint-Vallier", "", "FR", "250", "", "27", "71", "712", "46.64107", "4.37107", "Europe/Paris"),("2976703", "Saint-Valery-en-Caux", "", "FR", "250", "", "28", "76", "761", "49.86667", "0.73333", "Europe/Paris"),("2976742", "Saint-Tropez", "", "FR", "250", "", "93", "83", "831", "43.26932", "6.63981", "Europe/Paris"),("2976780", "Saint-Thibault-des-Vignes", "", "FR", "250", "", "11", "77", "775", "48.87111", "2.68041", "Europe/Paris"),("2976879", "Saint-Sulpice-la-Pointe", "", "FR", "250", "", "76", "81", "812", "43.775", "1.68511", "Europe/Paris"),("2976984", "Saint-Sébastien-sur-Loire", "Санкт-Себастьян-сюр-Луар", "FR", "250", "", "52", "44", "442", "47.20768", "-1.50332", "Europe/Paris"),("2977058", "Saint-Saulve", "", "FR", "250", "", "32", "59", "596", "50.37141", "3.55612", "Europe/Paris"),("2977103", "Saintry-sur-Seine", "", "FR", "250", "", "11", "91", "912", "48.5964", "2.49515", "Europe/Paris"),("2977189", "Saint-Renan", "", "FR", "250", "", "53", "29", "291", "48.43333", "-4.61667", "Europe/Paris"),("2977197", "Saint-Rémy-lès-Chevreuse", "", "FR", "250", "", "11", "78", "782", "48.70708", "2.07692", "Europe/Paris"),("2977214", "Saint-Rémy-de-Provence", "", "FR", "250", "", "93", "13", "132", "43.78848", "4.83167", "Europe/Paris"),("2977229", "Saint-Rémy", "", "FR", "250", "", "27", "71", "712", "46.76334", "4.83928", "Europe/Paris"),("2977246", "Saint-Raphaël", "Сент-Рафаэль", "FR", "250", "", "93", "83", "831", "43.42332", "6.7735", "Europe/Paris"),("2977277", "Saint-Quentin-Fallavier", "", "FR", "250", "", "84", "38", "382", "45.6305", "5.10924", "Europe/Paris"),("2977295", "Saint-Quentin", "", "FR", "250", "", "32", "02", "023", "49.84889", "3.28757", "Europe/Paris"),("2977308", "Saint-Pryvé-Saint-Mesmin", "", "FR", "250", "", "24", "45", "452", "47.88177", "1.8695", "Europe/Paris"),("2977317", "Saint-Prix", "", "FR", "250", "", "11", "95", "953", "49.01667", "2.26667", "Europe/Paris"),("2977350", "Saint-Priest-en-Jarez", "", "FR", "250", "", "84", "42", "423", "45.47501", "4.37614", "Europe/Paris"),("2977356", "Saint-Priest", "", "FR", "250", "", "84", "69", "691", "45.69613", "4.93891", "Europe/Paris"),("2977365", "Saint-Pourçain-sur-Sioule", "", "FR", "250", "", "84", "03", "032", "46.30927", "3.28787", "Europe/Paris"),("2977387", "Saint-Pol-sur-Ternoise", "", "FR", "250", "", "32", "62", "621", "50.38113", "2.33407", "Europe/Paris"),("2977388", "Saint-Pol-sur-Mer", "Сен-Поль-сюр-Мер", "FR", "250", "", "32", "59", "594", "51.03116", "2.33983", "Europe/Paris"),("2977390", "Saint-Pol-de-Léon", "", "FR", "250", "", "53", "29", "293", "48.68333", "-3.98333", "Europe/Paris"),("2977425", "Saint-Pierre-lès-Nemours", "", "FR", "250", "", "11", "77", "774", "48.26733", "2.67966", "Europe/Paris"),("2977428", "Saint-Pierre-lès-Elbeuf", "", "FR", "250", "", "28", "76", "763", "49.27901", "1.04305", "Europe/Paris"),("2977458", "Saint-Pierre-du-Perray", "", "FR", "250", "", "11", "91", "912", "48.61064", "2.49429", "Europe/Paris"),("2977462", "Saint-Pierre-du-Mont", "", "FR", "250", "", "75", "40", "402", "43.88453", "-0.52185", "Europe/Paris"),("2977491", "Saint-Pierre-des-Corps", "", "FR", "250", "", "24", "37", "372", "47.38623", "0.74849", "Europe/Paris"),("2977602", "Saint-Philbert-de-Grand-Lieu", "", "FR", "250", "", "52", "44", "442", "47.0358", "-1.6412", "Europe/Paris"),("2977623", "Saint-Péray", "", "FR", "250", "", "84", "07", "073", "44.94799", "4.8463", "Europe/Paris"),("2977638", "Saint-Paul-Trois-Châteaux", "", "FR", "250", "", "84", "26", "262", "44.34909", "4.76574", "Europe/Paris"),("2977648", "Saint-Paul-lès-Dax", "", "FR", "250", "", "75", "40", "401", "43.72715", "-1.05162", "Europe/Paris"),("2977709", "Saint-Pathus", "", "FR", "250", "", "11", "77", "771", "49.07136", "2.79886", "Europe/Paris"),("2977800", "Saint-Ouen-l’Aumône", "Сент-Уан-л'Омон", "FR", "250", "", "11", "95", "953", "49.04353", "2.12134", "Europe/Paris"),("2977824", "Saint-Ouen", "Санкт-Оуэн", "FR", "250", "", "11", "93", "933", "48.90654", "2.33339", "Europe/Paris"),("2977832", "Saint-Orens-de-Gameville", "", "FR", "250", "", "76", "31", "313", "43.55402", "1.53411", "Europe/Paris"),("2977845", "Saint-Omer", "", "FR", "250", "", "32", "62", "625", "50.75", "2.25", "Europe/Paris"),("2977880", "Saint-Nicolas-de-Port", "", "FR", "250", "", "44", "54", "543", "48.63089", "6.30039", "Europe/Paris"),("2977901", "Saint-Nicolas", "", "FR", "250", "", "32", "62", "621", "50.30413", "2.77939", "Europe/Paris"),("2977921", "Saint-Nazaire", "Сен-Назер", "FR", "250", "", "52", "44", "443", "47.28333", "-2.2", "Europe/Paris"),("2977947", "Saint-Mitre-les-Remparts", "", "FR", "250", "", "93", "13", "134", "43.45488", "5.01702", "Europe/Paris"),("2977948", "Saint-Mihiel", "", "FR", "250", "", "44", "55", "552", "48.88746", "5.55099", "Europe/Paris"),("2977952", "Saint-Michel-sur-Orge", "Сен-Мишель-сюр-Орж", "FR", "250", "", "11", "91", "913", "48.63479", "2.30831", "Europe/Paris"),("2978056", "Saint-Memmie", "", "FR", "250", "", "44", "51", "511", "48.95247", "4.38409", "Europe/Paris"),("2978072", "Saint-Médard-en-Jalles", "Санкт-Медард-ан-Жалль", "FR", "250", "", "75", "33", "332", "44.89692", "-0.72136", "Europe/Paris"),("2978100", "Saint-Maximin-la-Sainte-Baume", "", "FR", "250", "", "93", "83", "833", "43.45214", "5.86219", "Europe/Paris"),("2978105", "Saint-Max", "", "FR", "250", "", "44", "54", "543", "48.70429", "6.20999", "Europe/Paris"),("2978170", "Saint-Maurice", "", "FR", "250", "", "11", "94", "941", "48.82182", "2.42716", "Europe/Paris"),("2978179", "Saint-Maur-des-Fossés", "Сен-Мор-де-Фоссе", "FR", "250", "", "11", "94", "941", "48.79395", "2.49323", "Europe/Paris"),("2978238", "Saint-Martin-le-Vinoux", "", "FR", "250", "", "84", "38", "381", "45.203", "5.71667", "Europe/Paris"),("2978317", "Saint-Martin-d’Hères", "Сен-Мартен-д'Эр", "FR", "250", "", "84", "38", "381", "45.16528", "5.76337", "Europe/Paris"),("2978351", "Saint-Martin-des-Champs", "", "FR", "250", "", "53", "29", "293", "48.58333", "-3.83333", "Europe/Paris"),("2978396", "Saint-Martin-de-Crau", "", "FR", "250", "", "93", "13", "132", "43.63955", "4.8127", "Europe/Paris"),("2978439", "Saint-Martin-Boulogne", "", "FR", "250", "", "32", "62", "623", "50.72691", "1.61864", "Europe/Paris"),("2978566", "Saint-Marcellin", "", "FR", "250", "", "84", "38", "381", "45.15192", "5.32388", "Europe/Paris"),("2978586", "Saint-Marcel", "", "FR", "250", "", "28", "27", "273", "49.1", "1.45", "Europe/Paris"),("2978618", "Saint-Mandrier-sur-Mer", "", "FR", "250", "", "93", "83", "832", "43.078", "5.929", "Europe/Paris"),("2978621", "Saint-Mandé", "Санкт-Манде", "FR", "250", "", "11", "94", "942", "48.83864", "2.41579", "Europe/Paris"),("2978640", "Saint-Malo", "Сен-Мало", "FR", "250", "", "53", "35", "354", "48.65", "-2.01667", "Europe/Paris"),("2978658", "Saint-Macaire-en-Mauges", "", "FR", "250", "", "52", "49", "492", "47.12357", "-0.9912", "Europe/Paris"),("2978661", "Saint-Lys", "", "FR", "250", "", "76", "31", "311", "43.51127", "1.17557", "Europe/Paris"),("2978742", "Saint-Louis", "Сен-Луи", "FR", "250", "", "44", "68", "684", "47.58836", "7.56247", "Europe/Paris"),("2978749", "Saint-Loubès", "", "FR", "250", "", "75", "33", "332", "44.91536", "-0.42703", "Europe/Paris"),("2978758", "Saint-Lô", "Сен-Ло", "FR", "250", "", "28", "50", "504", "49.11624", "-1.09031", "Europe/Paris"),("2978768", "Saint-Leu-la-Forêt", "Сен-Лё-ла-Форе", "FR", "250", "", "11", "95", "953", "49.01667", "2.25", "Europe/Paris"),("2978771", "Saint-Leu", "", "FR", "250", "", "27", "71", "712", "46.7306", "4.50083", "Europe/Paris"),("2978891", "Saint-Laurent-du-Var", "Сен-Лоран-дю-Вар", "FR", "250", "", "93", "06", "061", "43.67097", "7.17606", "Europe/Paris"),("2978925", "Saint-Laurent-de-la-Salanque", "", "FR", "250", "", "76", "66", "662", "42.7727", "2.98998", "Europe/Paris"),("2978949", "Saint-Laurent-Blangy", "", "FR", "250", "", "32", "62", "621", "50.29446", "2.80698", "Europe/Paris"),("2978997", "Saint-Just-Saint-Rambert", "", "FR", "250", "", "84", "42", "421", "45.49973", "4.24141", "Europe/Paris"),("2979010", "Saint-Just-en-Chaussée", "", "FR", "250", "", "32", "60", "602", "49.50503", "2.43285", "Europe/Paris"),("2979036", "Saint-Junien", "", "FR", "250", "", "75", "87", "873", "45.88867", "0.90143", "Europe/Paris"),("2979052", "Saint-Julien-les-Villas", "", "FR", "250", "", "44", "10", "103", "48.27127", "4.09901", "Europe/Paris"),("2979072", "Saint-Julien-en-Genevois", "", "FR", "250", "", "84", "74", "743", "46.14434", "6.08256", "Europe/Paris"),("2979109", "Saint-Julien-de-Concelles", "", "FR", "250", "", "52", "44", "442", "47.25285", "-1.38428", "Europe/Paris"),("2979148", "Saint-Juéry", "", "FR", "250", "", "76", "81", "811", "43.95", "2.21667", "Europe/Paris"),("2979175", "Saint-Jorioz", "", "FR", "250", "", "84", "74", "741", "45.83295", "6.16503", "Europe/Paris"),("2979226", "Saint-Jean-le-Blanc", "", "FR", "250", "", "24", "45", "452", "47.89327", "1.9154", "Europe/Paris"),("2979261", "Saint-Jean-de-Védas", "", "FR", "250", "", "76", "34", "343", "43.57759", "3.82603", "Europe/Paris"),("2979299", "Saint-Jean-de-Monts", "", "FR", "250", "", "52", "85", "853", "46.79088", "-2.08219", "Europe/Paris"),("2979303", "Saint-Jean-de-Maurienne", "", "FR", "250", "", "84", "73", "733", "45.28333", "6.35", "Europe/Paris"),("2979309", "Saint-Jean-de-Luz", "", "FR", "250", "", "75", "64", "641", "43.38871", "-1.66267", "Europe/Paris"),("2979316", "Saint-Jean-de-la-Ruelle", "", "FR", "250", "", "24", "45", "452", "47.91127", "1.86483", "Europe/Paris"),("2979341", "Saint-Jean-de-Braye", "", "FR", "250", "", "24", "45", "452", "47.91303", "1.97705", "Europe/Paris"),("2979371", "Saint-Jean-Bonnefonds", "", "FR", "250", "", "84", "42", "423", "45.45294", "4.45057", "Europe/Paris"),("2979394", "Saint-Jean", "", "FR", "250", "", "76", "31", "313", "43.6642", "1.49941", "Europe/Paris"),("2979415", "Saint-Jacques-de-la-Lande", "", "FR", "250", "", "53", "35", "353", "48.06514", "-1.72086", "Europe/Paris"),("2979431", "Saint-Ismier", "", "FR", "250", "", "84", "38", "381", "45.24708", "5.82863", "Europe/Paris"),("2979539", "Saint-Hilaire-de-Talmont", "", "FR", "250", "", "52", "85", "853", "46.47002", "-1.60359", "Europe/Paris"),("2979543", "Saint-Hilaire-de-Riez", "", "FR", "250", "", "52", "85", "853", "46.71308", "-1.92583", "Europe/Paris"),("2979590", "Saint-Herblain", "", "FR", "250", "", "52", "44", "442", "47.21765", "-1.64841", "Europe/Paris"),("2979619", "Saint-Grégoire", "", "FR", "250", "", "53", "35", "353", "48.15085", "-1.68706", "Europe/Paris"),("2979627", "Saint-Gratien", "", "FR", "250", "", "11", "95", "952", "48.9735", "2.28729", "Europe/Paris"),("2979657", "Saint-Girons", "", "FR", "250", "", "76", "09", "093", "42.98333", "1.15", "Europe/Paris"),("2979662", "Saint-Gilles-Croix-de-Vie", "", "FR", "250", "", "52", "85", "853", "46.69761", "-1.94561", "Europe/Paris"),("2979679", "Saint-Gilles", "", "FR", "250", "", "76", "30", "302", "43.67656", "4.43024", "Europe/Paris"),("2979698", "Saint-Gervais-les-Bains", "", "FR", "250", "", "84", "74", "742", "45.8929", "6.71381", "Europe/Paris"),("2979752", "Saint-Germain-lès-Corbeil", "", "FR", "250", "", "11", "91", "912", "48.62211", "2.48775", "Europe/Paris"),("2979755", "Saint-Germain-lès-Arpajon", "", "FR", "250", "", "11", "91", "913", "48.59733", "2.26481", "Europe/Paris"),("2979783", "Saint-Germain-en-Laye", "Сен-Жермен-ан-Ле", "FR", "250", "", "11", "78", "783", "48.9", "2.08333", "Europe/Paris"),("2979790", "Saint-Germain-du-Puy", "", "FR", "250", "", "24", "18", "181", "47.1", "2.48333", "Europe/Paris"),("2979941", "Saint-Georges-de-Didonne", "", "FR", "250", "", "75", "17", "172", "45.60342", "-1.00487", "Europe/Paris"),("2979983", "Saint-Genis-Pouilly", "", "FR", "250", "", "84", "01", "013", "46.24356", "6.02119", "Europe/Paris"),("2979984", "Saint-Genis-les-Ollières", "", "FR", "250", "", "84", "69", "691", "45.75719", "4.72892", "Europe/Paris"),("2979985", "Saint-Genis-Laval", "Сен-Жени-Лаваль", "FR", "250", "", "84", "69", "691", "45.69558", "4.7934", "Europe/Paris"),("2980012", "Saint-Genest-Lerpt", "", "FR", "250", "", "84", "42", "423", "45.44529", "4.33622", "Europe/Paris"),("2980033", "Saint-Gély-du-Fesc", "", "FR", "250", "", "76", "34", "343", "43.69272", "3.80492", "Europe/Paris"),("2980045", "Saint-Gaudens", "", "FR", "250", "", "76", "31", "312", "43.11667", "0.73333", "Europe/Paris"),("2980052", "Saint-Galmier", "", "FR", "250", "", "84", "42", "421", "45.59199", "4.31743", "Europe/Paris"),("2980080", "Saint-François", "", "FR", "250", "", "84", "03", "033", "46.41537", "3.90542", "Europe/Paris"),("2980097", "Saint-Fons", "", "FR", "250", "", "84", "69", "691", "45.7088", "4.86057", "Europe/Paris"),("2980104", "Saint-Flour", "", "FR", "250", "", "84", "15", "153", "45.03333", "3.08333", "Europe/Paris"),("2980107", "Saint-Florent-sur-Cher", "", "FR", "250", "", "24", "18", "181", "46.99552", "2.25076", "Europe/Paris"),("2980111", "Saint-Florentin", "", "FR", "250", "", "27", "89", "891", "48.00057", "3.72489", "Europe/Paris"),("2980169", "Saint-Fargeau-Ponthierry", "", "FR", "250", "FR", "11", "77", "772", "48.55713", "2.5284", "Europe/Paris"),("2980236", "Saint-Étienne-du-Rouvray", "Сент-Этьен-дю-Руврэ", "FR", "250", "", "28", "76", "763", "49.37794", "1.10467", "Europe/Paris"),("2980259", "Saint-Étienne-de-Montluc", "", "FR", "250", "", "52", "44", "442", "47.2769", "-1.78072", "Europe/Paris"),("2980283", "Saint-Étienne-au-Mont", "", "FR", "250", "", "32", "62", "623", "50.67794", "1.63084", "Europe/Paris"),("2980291", "Saint-Étienne", "Сент-Этьен", "FR", "250", "", "84", "42", "423", "45.43389", "4.39", "Europe/Paris"),("2980313", "Saint-Estève", "", "FR", "250", "", "76", "66", "662", "42.71175", "2.8449", "Europe/Paris"),("2980328", "Sainte-Sigolène", "", "FR", "250", "", "84", "43", "433", "45.24329", "4.23343", "Europe/Paris"),("2980335", "Sainte-Savine", "", "FR", "250", "", "44", "10", "103", "48.29637", "4.04642", "Europe/Paris"),("2980340", "Saintes", "", "FR", "250", "", "75", "17", "174", "45.75", "-0.63333", "Europe/Paris"),("2980400", "Sainte-Menehould", "", "FR", "250", "", "44", "51", "515", "49.08333", "4.9", "Europe/Paris"),("2980402", "Sainte-Maxime", "", "FR", "250", "", "93", "83", "831", "43.30907", "6.63849", "Europe/Paris"),("2980438", "Sainte-Marie-aux-Mines", "", "FR", "250", "", "44", "68", "685", "48.2468", "7.18528", "Europe/Paris"),("2980488", "Sainte-Luce-sur-Loire", "", "FR", "250", "", "52", "44", "442", "47.25381", "-1.4843", "Europe/Paris"),("2980519", "Sainte-Livrade-sur-Lot", "", "FR", "250", "", "75", "47", "473", "44.39929", "0.5912", "Europe/Paris"),("2980558", "Sainte-Geneviève-des-Bois", "Сент-Женевьев-де-Буа", "FR", "250", "", "11", "91", "913", "48.64682", "2.31965", "Europe/Paris"),("2980586", "Sainte-Foy-lès-Lyon", "Сент-Фуа-ле-Лион", "FR", "250", "", "84", "69", "691", "45.73692", "4.79688", "Europe/Paris"),("2980636", "Saint-Égrève", "", "FR", "250", "", "84", "38", "381", "45.23333", "5.68333", "Europe/Paris"),("2980795", "Sainte-Adresse", "", "FR", "250", "", "28", "76", "762", "49.5089", "0.08446", "Europe/Paris"),("2980801", "Saint-Doulchard", "", "FR", "250", "", "24", "18", "181", "47.10371", "2.352", "Europe/Paris"),("2980816", "Saint-Dizier", "Санкт-Дизье", "FR", "250", "", "44", "52", "523", "48.63333", "4.95", "Europe/Paris"),("2980827", "Saint-Dié-des-Vosges", "Сен-Дье-де-Вож", "FR", "250", "", "44", "88", "883", "48.28333", "6.95", "Europe/Paris"),("2980885", "Saint-Denis-en-Val", "", "FR", "250", "", "24", "45", "452", "47.87321", "1.96601", "Europe/Paris"),("2980916", "Saint-Denis", "Сен-Дени", "FR", "250", "", "11", "93", "933", "48.93333", "2.36667", "Europe/Paris"),("2980933", "Saint-Cyr-sur-Mer", "", "FR", "250", "", "93", "83", "832", "43.18352", "5.70914", "Europe/Paris"),("2980935", "Saint-Cyr-sur-Loire", "", "FR", "250", "", "24", "37", "372", "47.4", "0.66667", "Europe/Paris"),("2980942", "Saint-Cyr-l’École", "Сен-Сир-Леколь", "FR", "250", "", "11", "78", "784", "48.79865", "2.06814", "Europe/Paris"),("2980976", "Saint-Cyprien-Plage", "", "FR", "250", "", "76", "66", "662", "42.63229", "3.03333", "Europe/Paris"),("2981041", "Saint-Cloud", "Сен-Клу", "FR", "250", "", "11", "92", "923", "48.84598", "2.20289", "Europe/Paris"),("2981073", "Saint-Clément-de-Rivière", "", "FR", "250", "", "76", "34", "343", "43.68333", "3.83333", "Europe/Paris"),("2981077", "Saint-Claude", "", "FR", "250", "", "27", "39", "393", "46.38679", "5.86473", "Europe/Paris"),("2981173", "Saint-Christol-lès-Alès", "", "FR", "250", "", "76", "30", "301", "44.08256", "4.07506", "Europe/Paris"),("2981206", "Saint-Chamond", "Сен-Шамон", "FR", "250", "", "84", "42", "423", "45.47365", "4.52541", "Europe/Paris"),("2981209", "Saint-Chamas", "", "FR", "250", "", "93", "13", "134", "43.54946", "5.03324", "Europe/Paris"),("2981280", "Saint-Brieuc", "Сент-Брие", "FR", "250", "", "53", "22", "224", "48.51513", "-2.76838", "Europe/Paris"),("2981283", "Saint-Brice-sous-Forêt", "", "FR", "250", "", "11", "95", "952", "49.00132", "2.35361", "Europe/Paris"),("2981296", "Saint-Brevin-les-Pins", "", "FR", "250", "", "52", "44", "443", "47.25", "-2.16667", "Europe/Paris"),("2981338", "Saint-Bonnet-de-Mure", "", "FR", "250", "", "84", "69", "691", "45.69958", "5.02026", "Europe/Paris"),("2981382", "Saint-Berthevin", "", "FR", "250", "", "52", "53", "532", "48.06667", "-0.83333", "Europe/Paris"),("2981408", "Saint-Benoît", "", "FR", "250", "", "75", "86", "863", "46.55315", "0.3419", "Europe/Paris"),("2981492", "Saint-Avold", "", "FR", "250", "", "44", "57", "573", "49.1027", "6.70064", "Europe/Paris"),("2981512", "Saint-Avertin", "", "FR", "250", "", "24", "37", "372", "47.36357", "0.73993", "Europe/Paris"),("2981515", "Saint-Avé", "", "FR", "250", "", "53", "56", "563", "47.69085", "-2.74648", "Europe/Paris"),("2981547", "Saint-Aubin-lès-Elbeuf", "", "FR", "250", "", "28", "76", "763", "49.3036", "1.01056", "Europe/Paris"),("2981579", "Saint-Aubin-de-Médoc", "", "FR", "250", "", "75", "33", "332", "44.9118", "-0.7246", "Europe/Paris"),("2981629", "Saint-Arnoult-en-Yvelines", "", "FR", "250", "", "11", "78", "782", "48.57111", "1.9395", "Europe/Paris"),("2981655", "Saint-Apollinaire", "", "FR", "250", "", "27", "21", "212", "47.33333", "5.08333", "Europe/Paris"),("2981716", "Saint-André-les-Vergers", "", "FR", "250", "", "44", "10", "103", "48.28527", "4.0521", "Europe/Paris"),("2981779", "Saint-André-lez-Lille", "", "FR", "250", "FR", "32", "59", "595", "50.66667", "3.05", "Europe/Paris"),("2981837", "Saint-Amand-Montrond", "", "FR", "250", "", "24", "18", "182", "46.71667", "2.51667", "Europe/Paris"),("2981839", "Saint-Amand-les-Eaux", "Сент-Аман-лез-О", "FR", "250", "", "32", "59", "596", "50.44718", "3.43076", "Europe/Paris"),("2981878", "Saint-Alban-Leysse", "", "FR", "250", "", "84", "73", "732", "45.58333", "5.95", "Europe/Paris"),("2981879", "Saint-Alban", "", "FR", "250", "", "76", "31", "313", "43.6927", "1.4102", "Europe/Paris"),("2981925", "Saint-Affrique", "", "FR", "250", "", "76", "12", "121", "43.95575", "2.88915", "Europe/Paris"),("2981941", "Sains-en-Gohelle", "", "FR", "250", "", "32", "62", "627", "50.44512", "2.68301", "Europe/Paris"),("2981949", "Sainghin-en-Weppes", "", "FR", "250", "", "32", "59", "595", "50.56407", "2.89804", "Europe/Paris"),("2982076", "Sablé-sur-Sarthe", "", "FR", "250", "", "52", "72", "721", "47.83765", "-0.33294", "Europe/Paris"),("2982146", "Rungis", "", "FR", "250", "", "11", "94", "943", "48.74607", "2.35275", "Europe/Paris"),("2982159", "Rumilly", "", "FR", "250", "", "84", "74", "741", "45.86873", "5.93652", "Europe/Paris"),("2982231", "Ruelle-sur-Touvre", "", "FR", "250", "", "75", "16", "161", "45.68333", "0.23333", "Europe/Paris"),("2982235", "Rueil-Malmaison", "Рюэй-Мальмезон", "FR", "250", "", "11", "92", "922", "48.8765", "2.18967", "Europe/Paris"),("2982330", "Roye", "", "FR", "250", "", "32", "80", "803", "49.70038", "2.78959", "Europe/Paris"),("2982343", "Royan", "Руайян", "FR", "250", "", "75", "17", "172", "45.62846", "-1.0281", "Europe/Paris"),("2982383", "Rouvroy", "", "FR", "250", "", "32", "62", "627", "50.39247", "2.90396", "Europe/Paris"),("2982454", "Roussillon", "", "FR", "250", "", "84", "38", "383", "45.37302", "4.80725", "Europe/Paris"),("2982652", "Rouen", "Руан", "FR", "250", "", "28", "76", "763", "49.44313", "1.09932", "Europe/Paris"),("2982681", "Roubaix", "Рубе", "FR", "250", "", "32", "59", "595", "50.69421", "3.17456", "Europe/Paris"),("2982745", "Rosporden", "", "FR", "250", "", "53", "29", "294", "47.96667", "-3.83333", "Europe/Paris"),("2982757", "Rosny-sous-Bois", "Рони-су-Буа", "FR", "250", "", "11", "93", "931", "48.87017", "2.4991", "Europe/Paris"),("2982835", "Roquevaire", "", "FR", "250", "", "93", "13", "133", "43.35021", "5.60414", "Europe/Paris"),("2982851", "Roquemaure", "", "FR", "250", "", "76", "30", "302", "44.04944", "4.7774", "Europe/Paris"),("2982875", "Roquebrune-sur-Argens", "", "FR", "250", "", "93", "83", "831", "43.43333", "6.63333", "Europe/Paris"),("2982876", "Roquebrune-Cap-Martin", "", "FR", "250", "", "93", "06", "062", "43.76408", "7.48207", "Europe/Paris"),("2982890", "Roost-Warendin", "", "FR", "250", "", "32", "59", "593", "50.4192", "3.10374", "Europe/Paris"),("2982938", "Roncq", "", "FR", "250", "", "32", "59", "595", "50.7533", "3.12131", "Europe/Paris"),("2982944", "Ronchin", "", "FR", "250", "", "32", "59", "595", "50.59883", "3.09056", "Europe/Paris"),("2982967", "Romorantin-Lanthenay", "Роморантен-Лантене", "FR", "250", "", "24", "41", "413", "47.36667", "1.75", "Europe/Paris"),("2982972", "Romilly-sur-Seine", "", "FR", "250", "", "44", "10", "102", "48.51085", "3.72634", "Europe/Paris"),("2983005", "Rombas", "", "FR", "250", "", "44", "57", "574", "49.24911", "6.09405", "Europe/Paris"),("2983011", "Romans-sur-Isère", "Роман-сюр-Изер", "FR", "250", "", "84", "26", "263", "45.04639", "5.0562", "Europe/Paris"),("2983026", "Romainville", "Роменвиль", "FR", "250", "", "11", "93", "931", "48.8854", "2.43482", "Europe/Paris"),("2983050", "Romagnat", "", "FR", "250", "", "84", "63", "632", "45.72878", "3.09893", "Europe/Paris"),("2983074", "Roissy-en-Brie", "Руасси-ан-Бри", "FR", "250", "", "11", "77", "775", "48.79159", "2.64747", "Europe/Paris"),("2983130", "Rognac", "", "FR", "250", "", "93", "13", "134", "43.48761", "5.23387", "Europe/Paris"),("2983154", "Rodez", "Родез", "FR", "250", "", "76", "12", "122", "44.35258", "2.57338", "Europe/Paris"),("2983251", "Roche-la-Molière", "", "FR", "250", "", "84", "42", "423", "45.43408", "4.32277", "Europe/Paris"),("2983268", "Rochefort-du-Gard", "", "FR", "250", "", "76", "30", "302", "43.97652", "4.69023", "Europe/Paris"),("2983276", "Rochefort", "Рошфор", "FR", "250", "", "75", "17", "172", "45.93333", "-0.98333", "Europe/Paris"),("2983362", "Roanne", "Роанн", "FR", "250", "", "84", "42", "422", "46.03333", "4.06667", "Europe/Paris"),("2983369", "Rixheim", "", "FR", "250", "", "44", "68", "684", "47.7514", "7.40091", "Europe/Paris"),("2983393", "Rivesaltes", "", "FR", "250", "", "76", "66", "662", "42.76945", "2.87239", "Europe/Paris"),("2983395", "Rives", "", "FR", "250", "", "84", "38", "381", "45.35505", "5.49927", "Europe/Paris"),("2983408", "Rive-de-Gier", "", "FR", "250", "", "84", "42", "423", "45.52755", "4.61589", "Europe/Paris"),("2983440", "Ris-Orangis", "", "FR", "250", "", "11", "91", "912", "48.6511", "2.41406", "Europe/Paris"),("2983482", "Riorges", "", "FR", "250", "", "84", "42", "422", "46.04179", "4.04965", "Europe/Paris"),("2983489", "Riom", "Рьом", "FR", "250", "", "84", "63", "634", "45.9", "3.11667", "Europe/Paris"),("2983536", "Rillieux-la-Pape", "Риллиэукс-ла-Пап", "FR", "250", "", "84", "69", "691", "45.81667", "4.9", "Europe/Paris"),("2983629", "Riedisheim", "", "FR", "250", "", "44", "68", "684", "47.74757", "7.36665", "Europe/Paris"),("2983770", "Rezé", "Реза", "FR", "250", "", "52", "44", "442", "47.18144", "-1.54965", "Europe/Paris"),("2983806", "Revin", "", "FR", "250", "", "44", "08", "081", "49.94039", "4.63503", "Europe/Paris"),("2983833", "Revel", "", "FR", "250", "", "76", "31", "313", "43.45812", "2.00469", "Europe/Paris"),("2983891", "Rethel", "", "FR", "250", "", "44", "08", "082", "49.51667", "4.36667", "Europe/Paris"),("2983990", "Rennes", "Ренн", "FR", "250", "", "53", "35", "353", "48.11198", "-1.67429", "Europe/Paris"),("2984050", "Remiremont", "", "FR", "250", "", "44", "88", "881", "48.01754", "6.5882", "Europe/Paris"),("2984114", "Reims", "Реймс", "FR", "250", "", "44", "51", "513", "49.25", "4.03333", "Europe/Paris"),("2984127", "Reignier-Ésery", "", "FR", "250", "", "84", "74", "743", "46.13333", "6.26667", "Europe/Paris"),("2984135", "Reichstett", "", "FR", "250", "", "44", "67", "676", "48.64856", "7.75455", "Europe/Paris"),("2984136", "Reichshoffen", "", "FR", "250", "", "44", "67", "672", "48.93287", "7.66561", "Europe/Paris"),("2984192", "Redon", "", "FR", "250", "", "53", "35", "352", "47.65", "-2.08333", "Europe/Paris"),("2984493", "Ramonville-Saint-Agne", "", "FR", "250", "", "76", "31", "313", "43.54618", "1.47491", "Europe/Paris"),("2984513", "Rambouillet", "Рамбуйе", "FR", "250", "", "11", "78", "782", "48.65", "1.83333", "Europe/Paris"),("2984516", "Rambervillers", "", "FR", "250", "", "44", "88", "881", "48.3424", "6.6358", "Europe/Paris"),("2984537", "Raismes", "", "FR", "250", "", "32", "59", "596", "50.38333", "3.48333", "Europe/Paris"),("2984677", "Quincy-Voisins", "", "FR", "250", "", "11", "77", "771", "48.90114", "2.87559", "Europe/Paris"),("2984678", "Quincy-sous-Sénart", "", "FR", "250", "", "11", "91", "912", "48.67294", "2.53419", "Europe/Paris"),("2984699", "Quimperlé", "", "FR", "250", "", "53", "29", "294", "47.86667", "-3.55", "Europe/Paris"),("2984701", "Quimper", "Кемпер", "FR", "250", "", "53", "29", "294", "48", "-4.1", "Europe/Paris"),("2984728", "Quiévrechain", "", "FR", "250", "", "32", "59", "596", "50.39172", "3.66815", "Europe/Paris"),("2984741", "Quiberon", "", "FR", "250", "", "53", "56", "561", "47.48412", "-3.11963", "Europe/Paris"),("2984760", "Quéven", "", "FR", "250", "", "53", "56", "561", "47.78333", "-3.41667", "Europe/Paris"),("2984775", "Quetigny", "", "FR", "250", "", "27", "21", "212", "47.31667", "5.11667", "Europe/Paris"),("2984781", "Questembert", "", "FR", "250", "", "53", "56", "563", "47.66296", "-2.4522", "Europe/Paris"),("2984787", "Quesnoy-sur-Deûle", "", "FR", "250", "", "32", "59", "595", "50.71359", "2.99996", "Europe/Paris"),("2984799", "Querqueville", "", "FR", "250", "", "28", "50", "502", "49.66251", "-1.69119", "Europe/Paris"),("2985034", "Puteaux", "Пюто", "FR", "250", "", "11", "92", "922", "48.88341", "2.23894", "Europe/Paris"),("2985143", "Puget-sur-Argens", "", "FR", "250", "", "93", "83", "831", "43.45", "6.68333", "Europe/Paris"),("2985163", "Publier", "", "FR", "250", "", "84", "74", "744", "46.38773", "6.54356", "Europe/Paris"),("2985229", "Provins", "", "FR", "250", "", "11", "77", "773", "48.55", "3.3", "Europe/Paris"),("2985290", "Privas", "", "FR", "250", "", "84", "07", "072", "44.73333", "4.6", "Europe/Paris"),("2985653", "Prades", "", "FR", "250", "", "76", "66", "663", "42.61667", "2.43333", "Europe/Paris"),("2985708", "Pouzauges", "", "FR", "250", "", "52", "85", "851", "46.77941", "-0.83619", "Europe/Paris"),("2985934", "Port-Saint-Louis-du-Rhône", "", "FR", "250", "", "93", "13", "132", "43.38734", "4.82609", "Europe/Paris"),("2985947", "Porto-Vecchio", "", "FR", "250", "", "94", "2A", "2A4", "41.59101", "9.27947", "Europe/Paris"),("2985968", "Port-la-Nouvelle", "", "FR", "250", "", "76", "11", "113", "43.01991", "3.04366", "Europe/Paris"),("2985982", "Portet-sur-Garonne", "", "FR", "250", "", "76", "31", "311", "43.52333", "1.40651", "Europe/Paris"),("2985987", "Portes-lès-Valence", "", "FR", "250", "", "84", "26", "263", "44.8737", "4.881", "Europe/Paris"),("2986025", "Port-de-Bouc", "", "FR", "250", "", "93", "13", "134", "43.40657", "4.9809", "Europe/Paris"),("2986059", "Pornichet", "", "FR", "250", "", "52", "44", "443", "47.26682", "-2.33794", "Europe/Paris"),("2986060", "Pornic", "", "FR", "250", "", "52", "44", "443", "47.11205", "-2.08888", "Europe/Paris"),("2986066", "Pordic", "", "FR", "250", "", "53", "22", "224", "48.57051", "-2.81783", "Europe/Paris"),("2986106", "Pont-Saint-Martin", "", "FR", "250", "", "52", "44", "442", "47.12338", "-1.58455", "Europe/Paris"),("2986109", "Pont-Saint-Esprit", "", "FR", "250", "", "76", "30", "302", "44.25494", "4.64736", "Europe/Paris"),("2986110", "Pont-Sainte-Maxence", "", "FR", "250", "", "32", "60", "604", "49.30168", "2.60467", "Europe/Paris"),("2986111", "Pont-Sainte-Marie", "", "FR", "250", "", "44", "10", "103", "48.31848", "4.09447", "Europe/Paris"),("2986140", "Pontoise", "Понтуаз", "FR", "250", "", "11", "95", "953", "49.05", "2.1", "Europe/Paris"),("2986160", "Pontivy", "Понтиви", "FR", "250", "", "53", "56", "562", "48.06667", "-2.98333", "Europe/Paris"),("2986178", "Ponthierry", "", "FR", "250", "", "11", "77", "772", "48.53366", "2.54419", "Europe/Paris"),("2986191", "Pont-Évêque", "", "FR", "250", "", "84", "38", "383", "45.52691", "4.91432", "Europe/Paris"),("2986219", "Pont-du-Château", "", "FR", "250", "", "84", "63", "632", "45.80078", "3.25008", "Europe/Paris"),("2986271", "Pontchâteau", "", "FR", "250", "", "52", "44", "443", "47.43797", "-2.09011", "Europe/Paris"),("2986275", "Pontcharra", "", "FR", "250", "", "84", "38", "381", "45.4329", "6.01424", "Europe/Paris"),("2986294", "Pont-Audemer", "", "FR", "250", "", "28", "27", "272", "49.35", "0.51667", "Europe/Paris"),("2986302", "Pontarlier", "Понтарлье", "FR", "250", "", "27", "25", "253", "46.90347", "6.35542", "Europe/Paris"),("2986306", "Pont-à-Mousson", "Понт-а-Муссон", "FR", "250", "", "44", "54", "543", "48.90786", "6.0589", "Europe/Paris"),("2986335", "Pons", "", "FR", "250", "", "75", "17", "174", "45.57988", "-0.54783", "Europe/Paris"),("2986385", "Pompey", "", "FR", "250", "", "44", "54", "543", "48.76653", "6.12162", "Europe/Paris"),("2986495", "Poitiers", "Пуатье", "FR", "250", "", "75", "86", "863", "46.58333", "0.33333", "Europe/Paris"),("2986499", "Poisy", "", "FR", "250", "", "84", "74", "741", "45.92305", "6.06435", "Europe/Paris"),("2986501", "Poissy", "Пуасси", "FR", "250", "", "11", "78", "783", "48.92902", "2.04952", "Europe/Paris"),("2986593", "Pluvigner", "", "FR", "250", "", "53", "56", "561", "47.77627", "-3.01013", "Europe/Paris"),("2986626", "Plouzané", "", "FR", "250", "", "53", "29", "291", "48.38333", "-4.61667", "Europe/Paris"),("2986664", "Plouguerneau", "", "FR", "250", "", "53", "29", "291", "48.6", "-4.5", "Europe/Paris"),("2986674", "Plougastel-Daoulas", "", "FR", "250", "", "53", "29", "291", "48.36667", "-4.36667", "Europe/Paris"),("2986678", "Ploufragan", "", "FR", "250", "", "53", "22", "224", "48.49141", "-2.79458", "Europe/Paris"),("2986692", "Ploudalmézeau", "", "FR", "250", "", "53", "29", "291", "48.53333", "-4.65", "Europe/Paris"),("2986696", "Plouay", "", "FR", "250", "", "53", "56", "561", "47.91444", "-3.33384", "Europe/Paris"),("2986708", "Plonéour-Lanvern", "", "FR", "250", "", "53", "29", "294", "47.9", "-4.28333", "Europe/Paris"),("2986729", "Ploërmel", "", "FR", "250", "", "53", "56", "563", "47.93172", "-2.39781", "Europe/Paris"),("2986732", "Ploemeur", "", "FR", "250", "", "53", "56", "561", "47.73333", "-3.43333", "Europe/Paris"),("2986795", "Plérin", "", "FR", "250", "", "53", "22", "224", "48.54249", "-2.77983", "Europe/Paris"),("2986818", "Plédran", "", "FR", "250", "", "53", "22", "224", "48.446", "-2.74667", "Europe/Paris"),("2986889", "Plan-de-Cuques", "", "FR", "250", "", "93", "13", "133", "43.34753", "5.46398", "Europe/Paris"),("2986930", "Plaisir", "", "FR", "250", "", "11", "78", "784", "48.82319", "1.9541", "Europe/Paris"),("2986933", "Plaisance-du-Touch", "", "FR", "250", "", "76", "31", "313", "43.56566", "1.29749", "Europe/Paris"),("2986991", "Plabennec", "", "FR", "250", "", "53", "29", "291", "48.50244", "-4.42656", "Europe/Paris"),("2987003", "Pithiviers", "", "FR", "250", "", "24", "45", "453", "48.16667", "2.25", "Europe/Paris"),("2987180", "Pignan", "", "FR", "250", "", "76", "34", "343", "43.58365", "3.75981", "Europe/Paris"),("2987256", "Pierrelaye", "", "FR", "250", "", "11", "95", "953", "49.0211", "2.15481", "Europe/Paris"),("2987259", "Pierrelatte", "", "FR", "250", "", "84", "26", "262", "44.37756", "4.70198", "Europe/Paris"),("2987271", "Pierrefitte-sur-Seine", "", "FR", "250", "", "11", "93", "933", "48.96691", "2.36104", "Europe/Paris"),("2987314", "Pierre-Bénite", "", "FR", "250", "", "84", "69", "691", "45.7009", "4.82511", "Europe/Paris"),("2987376", "Pibrac", "", "FR", "250", "", "76", "31", "313", "43.62042", "1.2854", "Europe/Paris"),("2987409", "Pia", "", "FR", "250", "", "76", "66", "662", "42.7449", "2.9193", "Europe/Paris"),("2987429", "Pfastatt", "", "FR", "250", "", "44", "68", "684", "47.77044", "7.30103", "Europe/Paris"),("2987441", "Pézenas", "", "FR", "250", "", "76", "34", "341", "43.45953", "3.42384", "Europe/Paris"),("2987547", "Peypin", "", "FR", "250", "", "93", "13", "133", "43.38503", "5.57788", "Europe/Paris"),("2987554", "Peymeinade", "", "FR", "250", "", "93", "06", "061", "43.63636", "6.87776", "Europe/Paris"),("2987706", "Petite-Rosselle", "", "FR", "250", "", "44", "57", "573", "49.21177", "6.85607", "Europe/Paris"),("2987722", "Petite-Forêt", "", "FR", "250", "", "32", "59", "596", "50.36667", "3.48333", "Europe/Paris"),("2987805", "Pessac", "Пессаке", "FR", "250", "", "75", "33", "332", "44.81011", "-0.64129", "Europe/Paris"),("2987825", "Pertuis", "", "FR", "250", "", "93", "84", "841", "43.69252", "5.50285", "Europe/Paris"),("2987847", "Persan", "", "FR", "250", "", "11", "95", "953", "49.15335", "2.27218", "Europe/Paris"),("2987863", "Perros-Guirec", "", "FR", "250", "", "53", "22", "223", "48.81454", "-3.43963", "Europe/Paris"),("2987914", "Perpignan", "Перпиньян", "FR", "250", "", "76", "66", "662", "42.69764", "2.89541", "Europe/Paris"),("2987928", "Péronne", "", "FR", "250", "", "32", "80", "804", "49.93333", "2.93333", "Europe/Paris"),("2987930", "Péronnas", "", "FR", "250", "", "84", "01", "012", "46.19073", "5.20819", "Europe/Paris"),("2987936", "Pérols", "", "FR", "250", "", "76", "34", "343", "43.56313", "3.95203", "Europe/Paris"),("2987945", "Pernes-les-Fontaines", "", "FR", "250", "", "93", "84", "843", "44.00028", "5.05141", "Europe/Paris"),("2987967", "Périgueux", "Периге", "FR", "250", "", "75", "24", "243", "45.18333", "0.71667", "Europe/Paris"),("2987976", "Périgny", "", "FR", "250", "", "75", "17", "173", "46.15519", "-1.09822", "Europe/Paris"),("2988003", "Pérenchies", "", "FR", "250", "", "32", "59", "595", "50.67013", "2.97024", "Europe/Paris"),("2988186", "Pélissanne", "", "FR", "250", "", "93", "13", "131", "43.63512", "5.15131", "Europe/Paris"),("2988220", "Pégomas", "", "FR", "250", "", "93", "06", "061", "43.5985", "6.93032", "Europe/Paris"),("2988236", "Pecquencourt", "", "FR", "250", "", "32", "59", "593", "50.3785", "3.21277", "Europe/Paris"),("2988305", "Pavilly", "", "FR", "250", "", "28", "76", "763", "49.56703", "0.95445", "Europe/Paris"),("2988350", "Pauillac", "", "FR", "250", "", "75", "33", "334", "45.19644", "-0.74873", "Europe/Paris"),("2988358", "Pau", "Пау", "FR", "250", "", "75", "64", "643", "43.3", "-0.36667", "Europe/Paris"),("2988393", "Passy", "", "FR", "250", "", "84", "74", "742", "45.92028", "6.68765", "Europe/Paris"),("2988447", "Parthenay", "", "FR", "250", "", "75", "79", "793", "46.65", "-0.25", "Europe/Paris"),("2988490", "Parmain", "", "FR", "250", "", "11", "95", "953", "49.11247", "2.21487", "Europe/Paris"),("2988507", "Paris", "Париж", "FR", "250", "", "11", "75", "751", "48.85341", "2.3488", "Europe/Paris"),("2988548", "Parempuyre", "", "FR", "250", "", "75", "33", "332", "44.95038", "-0.60453", "Europe/Paris"),("2988589", "Paray-Vieille-Poste", "", "FR", "250", "", "11", "91", "913", "48.71402", "2.36283", "Europe/Paris"),("2988592", "Paray-le-Monial", "", "FR", "250", "", "27", "71", "713", "46.45457", "4.11584", "Europe/Paris"),("2988621", "Pantin", "Пантин", "FR", "250", "", "11", "93", "931", "48.89437", "2.40935", "Europe/Paris"),("2988657", "Panazol", "", "FR", "250", "", "75", "87", "872", "45.83465", "1.32759", "Europe/Paris"),("2988670", "Pamiers", "Памье", "FR", "250", "", "76", "09", "092", "43.11667", "1.6", "Europe/Paris"),("2988742", "Palavas-les-Flots", "", "FR", "250", "", "76", "34", "343", "43.52805", "3.92705", "Europe/Paris"),("2988758", "Palaiseau", "Палезо", "FR", "250", "", "11", "91", "913", "48.71667", "2.25", "Europe/Paris"),("2988796", "Paimpol", "", "FR", "250", "", "53", "22", "224", "48.77841", "-3.04375", "Europe/Paris"),("2988848", "Pacy-sur-Eure", "", "FR", "250", "", "28", "27", "273", "49.01667", "1.38333", "Europe/Paris"),("2988853", "Pacé", "", "FR", "250", "", "53", "35", "353", "48.14848", "-1.77327", "Europe/Paris"),("2988867", "Ozoir-la-Ferrière", "", "FR", "250", "", "11", "77", "775", "48.76699", "2.66871", "Europe/Paris"),("2988888", "Oyonnax", "Ойонна", "FR", "250", "", "84", "01", "014", "46.25917", "5.65727", "Europe/Paris"),("2988893", "Oye-Plage", "", "FR", "250", "", "32", "62", "625", "50.97713", "2.04276", "Europe/Paris"),("2988936", "Outreau", "", "FR", "250", "", "32", "62", "623", "50.70535", "1.5897", "Europe/Paris"),("2988998", "Oullins", "", "FR", "250", "", "84", "69", "691", "45.71774", "4.80382", "Europe/Paris"),("2989013", "Ouistreham", "", "FR", "250", "", "28", "14", "142", "49.27566", "-0.2591", "Europe/Paris"),("2989088", "Othis", "", "FR", "250", "", "11", "77", "771", "49.07387", "2.67502", "Europe/Paris"),("2989093", "Ostwald", "", "FR", "250", "", "44", "67", "676", "48.54369", "7.71099", "Europe/Paris"),("2989094", "Ostricourt", "", "FR", "250", "", "32", "59", "595", "50.45145", "3.03417", "Europe/Paris"),("2989130", "Osny", "Они", "FR", "250", "", "11", "95", "953", "49.0701", "2.06277", "Europe/Paris"),("2989170", "Orvault", "Орво", "FR", "250", "", "52", "44", "442", "47.27095", "-1.6219", "Europe/Paris"),("2989187", "Orthez", "", "FR", "250", "", "75", "64", "643", "43.48839", "-0.77244", "Europe/Paris"),("2989204", "Orsay", "Орсе", "FR", "250", "", "11", "91", "913", "48.69572", "2.18727", "Europe/Paris"),("2989271", "Ormesson-sur-Marne", "", "FR", "250", "", "11", "94", "942", "48.7863", "2.54471", "Europe/Paris"),("2989297", "Orly", "", "FR", "250", "", "11", "94", "941", "48.74792", "2.39253", "Europe/Paris"),("2989317", "Orléans", "Орлеан", "FR", "250", "", "24", "45", "452", "47.90289", "1.90389", "Europe/Paris"),("2989372", "Orgeval", "", "FR", "250", "", "11", "78", "783", "48.92162", "1.9779", "Europe/Paris"),("2989422", "Orchies", "", "FR", "250", "", "32", "59", "593", "50.46667", "3.23333", "Europe/Paris"),("2989460", "Orange", "Оранж", "FR", "250", "", "93", "84", "842", "44.1392", "4.80791", "Europe/Paris"),("2989506", "Onnaing", "", "FR", "250", "", "32", "59", "596", "50.38584", "3.59963", "Europe/Paris"),("2989569", "Oloron-Sainte-Marie", "", "FR", "250", "", "75", "64", "642", "43.19441", "-0.61069", "Europe/Paris"),("2989572", "Olonne-sur-Mer", "", "FR", "250", "", "52", "85", "853", "46.53524", "-1.77293", "Europe/Paris"),("2989590", "Ollioules", "", "FR", "250", "", "93", "83", "832", "43.13517", "5.848", "Europe/Paris"),("2989611", "Olivet", "Олива", "FR", "250", "", "24", "45", "452", "47.86219", "1.8991", "Europe/Paris"),("2989646", "Oissel", "", "FR", "250", "", "28", "76", "763", "49.33309", "1.09413", "Europe/Paris"),("2989680", "Oignies", "", "FR", "250", "", "32", "62", "627", "50.46331", "2.99376", "Europe/Paris"),("2989755", "Octeville", "", "FR", "250", "", "28", "50", "502", "49.62612", "-1.64349", "Europe/Paris"),("2989796", "Obernai", "", "FR", "250", "", "44", "67", "675", "48.46313", "7.481", "Europe/Paris"),("2989819", "Nyons", "", "FR", "250", "", "84", "26", "262", "44.36667", "5.13333", "Europe/Paris"),("2989837", "Nuits-Saint-Georges", "", "FR", "250", "", "27", "21", "211", "47.13683", "4.949", "Europe/Paris"),("2989852", "Nueil-les-Aubiers", "", "FR", "250", "", "75", "79", "791", "46.93333", "-0.58333", "Europe/Paris"),("2989877", "Noyon", "Нуайон", "FR", "250", "", "32", "60", "603", "49.58333", "3", "Europe/Paris"),("2989897", "Noyelles-sous-Lens", "", "FR", "250", "", "32", "62", "627", "50.43084", "2.87221", "Europe/Paris"),("2989901", "Noyelles-Godault", "", "FR", "250", "", "32", "62", "627", "50.41753", "2.99306", "Europe/Paris"),("2989943", "Nouzonville", "", "FR", "250", "", "44", "08", "081", "49.81369", "4.74736", "Europe/Paris"),("2990056", "Notre-Dame-de-Gravenchon", "", "FR", "250", "", "28", "76", "762", "49.4894", "0.57188", "Europe/Paris"),("2990064", "Notre-Dame-de-Bondeville", "", "FR", "250", "", "28", "76", "763", "49.48333", "1.05", "Europe/Paris"),("2990085", "Nort-sur-Erdre", "", "FR", "250", "", "52", "44", "441", "47.43881", "-1.49833", "Europe/Paris"),("2990187", "Noisy-le-Sec", "Шумная-ле-Сек", "FR", "250", "", "11", "93", "931", "48.89148", "2.46451", "Europe/Paris"),("2990188", "Noisy-le-Roi", "", "FR", "250", "", "11", "78", "783", "48.84445", "2.06345", "Europe/Paris"),("2990189", "Noisy-le-Grand", "Шумная-ле-Гран", "FR", "250", "", "11", "93", "932", "48.84979", "2.56266", "Europe/Paris"),("2990192", "Noisiel", "", "FR", "250", "", "11", "77", "775", "48.84868", "2.62435", "Europe/Paris"),("2990263", "Nogent-sur-Seine", "", "FR", "250", "", "44", "10", "102", "48.48333", "3.5", "Europe/Paris"),("2990264", "Nogent-sur-Oise", "Ножан-сюр-Уаз", "FR", "250", "", "32", "60", "604", "49.27158", "2.47074", "Europe/Paris"),("2990265", "Nogent-sur-Marne", "Ножан-сюр-Марн", "FR", "250", "", "11", "94", "942", "48.83333", "2.48333", "Europe/Paris"),("2990272", "Nogent-le-Rotrou", "", "FR", "250", "", "24", "28", "284", "48.31667", "0.83333", "Europe/Paris"),("2990287", "Nœux-les-Mines", "", "FR", "250", "", "32", "62", "622", "50.48333", "2.66667", "Europe/Paris"),("2990355", "Niort", "Ньор", "FR", "250", "", "75", "79", "792", "46.32313", "-0.45877", "Europe/Paris"),("2990363", "Nîmes", "Ним", "FR", "250", "", "76", "30", "302", "43.83333", "4.35", "Europe/Paris"),("2990364", "Nilvange", "", "FR", "250", "", "44", "57", "578", "49.33995", "6.05483", "Europe/Paris"),("2990377", "Nieul-sur-Mer", "", "FR", "250", "", "75", "17", "173", "46.20583", "-1.16449", "Europe/Paris"),("2990392", "Nieppe", "", "FR", "250", "", "32", "59", "594", "50.70425", "2.83506", "Europe/Paris"),("2990440", "Nice", "Ницца", "FR", "250", "", "93", "06", "062", "43.70313", "7.26608", "Europe/Paris"),("2990474", "Nevers", "Невер", "FR", "250", "", "27", "58", "583", "46.98956", "3.159", "Europe/Paris"),("2990516", "Neuville-sur-Saône", "", "FR", "250", "", "84", "69", "691", "45.87704", "4.8492", "Europe/Paris"),("2990543", "Neuville-en-Ferrain", "", "FR", "250", "", "32", "59", "595", "50.74839", "3.15676", "Europe/Paris"),("2990580", "Neuves-Maisons", "", "FR", "250", "", "44", "54", "543", "48.62029", "6.10698", "Europe/Paris"),("2990611", "Neuilly-sur-Seine", "Нёйи-сюр-Сен", "FR", "250", "", "11", "92", "922", "48.8846", "2.26965", "Europe/Paris"),("2990612", "Neuilly-sur-Marne", "Нейи-сюр-Марн", "FR", "250", "", "11", "93", "932", "48.85373", "2.54903", "Europe/Paris"),("2990616", "Neuilly-Plaisance", "", "FR", "250", "", "11", "93", "932", "48.86342", "2.506", "Europe/Paris"),("2990680", "Neufchâtel-en-Bray", "", "FR", "250", "", "28", "76", "761", "49.73315", "1.43956", "Europe/Paris"),("2990682", "Neufchâteau", "", "FR", "250", "", "44", "88", "882", "48.35", "5.7", "Europe/Paris"),("2990780", "Nérac", "", "FR", "250", "", "75", "47", "474", "44.13333", "0.35", "Europe/Paris"),("2990793", "Nemours", "", "FR", "250", "", "11", "77", "774", "48.27511", "2.69078", "Europe/Paris"),("2990919", "Narbonne", "Нарбонна", "FR", "250", "", "76", "11", "113", "43.18396", "3.00141", "Europe/Paris"),("2990957", "Nanteuil-lès-Meaux", "", "FR", "250", "", "11", "77", "771", "48.9294", "2.89594", "Europe/Paris"),("2990969", "Nantes", "Нант", "FR", "250", "", "52", "44", "442", "47.21725", "-1.55336", "Europe/Paris"),("2990970", "Nanterre", "Нантер", "FR", "250", "", "11", "92", "922", "48.89198", "2.20675", "Europe/Paris"),("2990992", "Nangis", "", "FR", "250", "", "11", "77", "773", "48.55535", "3.01306", "Europe/Paris"),("2990995", "Nandy", "", "FR", "250", "", "11", "77", "772", "48.58301", "2.56292", "Europe/Paris"),("2990999", "Nancy", "Нанси", "FR", "250", "", "44", "54", "543", "48.68439", "6.18496", "Europe/Paris"),("2991036", "Naintré", "", "FR", "250", "", "75", "86", "861", "46.76354", "0.48683", "Europe/Paris"),("2991086", "Mutzig", "", "FR", "250", "", "44", "67", "673", "48.53974", "7.45594", "Europe/Paris"),("2991128", "Mûrs-Erigné", "", "FR", "250", "", "52", "49", "491", "47.4", "-0.55", "Europe/Paris"),("2991153", "Muret", "Мюре", "FR", "250", "", "76", "31", "311", "43.46667", "1.35", "Europe/Paris"),("2991189", "Munster", "", "FR", "250", "", "44", "68", "682", "48.04089", "7.13338", "Europe/Paris"),("2991199", "Mundolsheim", "", "FR", "250", "", "44", "67", "676", "48.64215", "7.71378", "Europe/Paris"),("2991214", "Mulhouse", "Мюлуз", "FR", "250", "", "44", "68", "684", "47.75", "7.33333", "Europe/Paris"),("2991264", "Moyeuvre-Grande", "", "FR", "250", "", "44", "57", "578", "49.25165", "6.04754", "Europe/Paris"),("2991297", "Mouy", "", "FR", "250", "", "32", "60", "602", "49.31535", "2.31954", "Europe/Paris"),("2991302", "Mouvaux", "", "FR", "250", "", "32", "59", "595", "50.69944", "3.13429", "Europe/Paris"),("2991413", "Mourmelon-le-Grand", "", "FR", "250", "", "44", "51", "511", "49.13256", "4.3642", "Europe/Paris"),("2991431", "Mourenx", "", "FR", "250", "", "75", "64", "643", "43.38333", "-0.6", "Europe/Paris"),("2991481", "Moulins", "Мулин", "FR", "250", "", "84", "03", "032", "46.56667", "3.33333", "Europe/Paris"),("2991551", "Mougins", "Мужен", "FR", "250", "", "93", "06", "061", "43.59873", "7.00434", "Europe/Paris"),("2991579", "Mouans-Sartoux", "", "FR", "250", "", "93", "06", "061", "43.62224", "6.97312", "Europe/Paris"),("2991692", "Morteau", "", "FR", "250", "", "27", "25", "253", "47.05784", "6.60716", "Europe/Paris"),("2991700", "Mortagne-sur-Sèvre", "", "FR", "250", "", "52", "85", "852", "46.99203", "-0.94738", "Europe/Paris"),("2991719", "Morsang-sur-Orge", "", "FR", "250", "", "11", "91", "912", "48.66181", "2.35338", "Europe/Paris"),("2991743", "Mornant", "", "FR", "250", "", "84", "69", "691", "45.61897", "4.6737", "Europe/Paris"),("2991772", "Morlaix", "Морле", "FR", "250", "", "53", "29", "293", "48.58333", "-3.83333", "Europe/Paris"),("2991799", "Morières-lès-Avignon", "", "FR", "250", "", "93", "84", "842", "43.9403", "4.9011", "Europe/Paris"),("2991832", "Morez", "", "FR", "250", "", "27", "39", "393", "46.5254", "6.02589", "Europe/Paris"),("2991868", "Mordelles", "", "FR", "250", "", "53", "35", "353", "48.07571", "-1.84286", "Europe/Paris"),("2991891", "Morangis", "", "FR", "250", "", "11", "91", "913", "48.70383", "2.33908", "Europe/Paris"),("2991992", "Mont-Saint-Martin", "", "FR", "250", "", "44", "54", "541", "49.54669", "5.79375", "Europe/Paris"),("2992003", "Mont-Saint-Aignan", "", "FR", "250", "", "28", "76", "763", "49.46307", "1.09364", "Europe/Paris"),("2992008", "Monts", "", "FR", "250", "", "24", "37", "372", "47.27723", "0.62473", "Europe/Paris"),("2992017", "Montrouge", "Монруж", "FR", "250", "", "11", "92", "921", "48.8162", "2.31393", "Europe/Paris"),("2992090", "Montreuil", "Монтрей", "FR", "250", "", "11", "93", "931", "48.86415", "2.44322", "Europe/Paris"),("2992132", "Montpon-Ménestérol", "", "FR", "250", "", "75", "24", "243", "45", "0.16667", "Europe/Paris"),("2992166", "Montpellier", "Монпелье", "FR", "250", "", "76", "34", "343", "43.61092", "3.87723", "Europe/Paris"),("2992206", "Montoir-de-Bretagne", "", "FR", "250", "", "52", "44", "443", "47.33012", "-2.15107", "Europe/Paris"),("2992225", "Montmorillon", "", "FR", "250", "", "75", "86", "862", "46.43333", "0.86667", "Europe/Paris"),("2992229", "Montmorency", "Монморанси", "FR", "250", "", "11", "95", "952", "48.98826", "2.3434", "Europe/Paris"),("2992287", "Montmagny", "", "FR", "250", "", "11", "95", "952", "48.97338", "2.34688", "Europe/Paris"),("2992290", "Montluel", "", "FR", "250", "", "84", "01", "012", "45.8519", "5.0578", "Europe/Paris"),("2992292", "Montluçon", "Монлюсон", "FR", "250", "", "84", "03", "031", "46.33333", "2.6", "Europe/Paris"),("2992293", "Montlouis-sur-Loire", "", "FR", "250", "", "24", "37", "372", "47.38845", "0.83208", "Europe/Paris"),("2992309", "Montlhéry", "", "FR", "250", "", "11", "91", "913", "48.64004", "2.27465", "Europe/Paris"),("2992367", "Montivilliers", "", "FR", "250", "", "28", "76", "762", "49.54518", "0.18769", "Europe/Paris"),("2992402", "Montigny-lès-Metz", "", "FR", "250", "", "44", "57", "574", "49.09435", "6.15167", "Europe/Paris"),("2992404", "Montigny-lès-Cormeilles", "", "FR", "250", "", "11", "95", "951", "48.98201", "2.20035", "Europe/Paris"),("2992415", "Montigny-le-Bretonneux", "Монтиньи-ле-Бретоннё", "FR", "250", "", "11", "78", "784", "48.76636", "2.03405", "Europe/Paris"),("2992420", "Montigny-en-Gohelle", "", "FR", "250", "", "32", "62", "627", "50.4254", "2.93902", "Europe/Paris"),("2992536", "Montgeron", "Монжероне", "FR", "250", "", "11", "91", "912", "48.70543", "2.45039", "Europe/Paris"),("2992581", "Montfort-sur-Meu", "", "FR", "250", "", "53", "35", "353", "48.13542", "-1.95201", "Europe/Paris"),("2992616", "Montfermeil", "Монфермей", "FR", "250", "", "11", "93", "932", "48.8982", "2.57913", "Europe/Paris"),("2992618", "Montfavet", "", "FR", "250", "", "93", "84", "842", "43.93335", "4.87342", "Europe/Paris"),("2992638", "Monteux", "", "FR", "250", "", "93", "84", "843", "44.0348", "4.99719", "Europe/Paris"),("2992650", "Montesson", "", "FR", "250", "", "11", "78", "783", "48.90924", "2.13754", "Europe/Paris"),("2992671", "Montereau-Fault-Yonne", "Монтро-Фо-Йонна", "FR", "250", "FR", "11", "77", "773", "48.38333", "2.95", "Europe/Paris"),("2992703", "Montélimar", "Монтелимаре", "FR", "250", "", "84", "26", "262", "44.55838", "4.75094", "Europe/Paris"),("2992760", "Montdidier", "", "FR", "250", "", "32", "80", "803", "49.65", "2.56667", "Europe/Paris"),("2992771", "Mont-de-Marsan", "Мон-де-Марсан", "FR", "250", "", "75", "40", "402", "43.89022", "-0.49713", "Europe/Paris"),("2992838", "Montchanin", "", "FR", "250", "", "27", "71", "712", "46.74964", "4.4707", "Europe/Paris"),("2992863", "Montceau-les-Mines", "Монке-ле-Мине", "FR", "250", "", "27", "71", "712", "46.66667", "4.36667", "Europe/Paris"),("2992890", "Montbrison", "", "FR", "250", "", "84", "42", "421", "45.6", "4.05", "Europe/Paris"),("2992938", "Montbéliard", "Монбельяр", "FR", "250", "", "27", "25", "252", "47.51667", "6.8", "Europe/Paris"),("2992953", "Montbard", "", "FR", "250", "", "27", "21", "213", "47.61667", "4.33333", "Europe/Paris"),("2993002", "Montauban", "Монтобан", "FR", "250", "", "76", "82", "822", "44.01667", "1.35", "Europe/Paris"),("2993004", "Montataire", "", "FR", "250", "", "32", "60", "604", "49.259", "2.43777", "Europe/Paris"),("2993024", "Montargis", "Монтаржи", "FR", "250", "", "24", "45", "451", "48", "2.75", "Europe/Paris"),("2993092", "Montaigu", "", "FR", "250", "", "52", "85", "852", "46.97667", "-1.30846", "Europe/Paris"),("2993207", "Mons-en-Barœul", "", "FR", "250", "", "32", "59", "595", "50.63333", "3.11667", "Europe/Paris"),("2993277", "Monistrol-sur-Loire", "", "FR", "250", "", "84", "43", "433", "45.29335", "4.17161", "Europe/Paris"),("2993316", "Monéteau", "", "FR", "250", "", "27", "89", "891", "47.84923", "3.58178", "Europe/Paris"),("2993358", "Mondeville", "", "FR", "250", "", "28", "14", "142", "49.17497", "-0.32238", "Europe/Paris"),("2993367", "Mondelange", "", "FR", "250", "", "44", "57", "578", "49.26469", "6.17087", "Europe/Paris"),("2993476", "Molsheim", "", "FR", "250", "", "44", "67", "673", "48.54042", "7.49199", "Europe/Paris"),("2993572", "Moissy-Cramayel", "", "FR", "250", "", "11", "77", "772", "48.62605", "2.60125", "Europe/Paris"),("2993586", "Moissac", "", "FR", "250", "", "76", "82", "821", "44.10236", "1.0945", "Europe/Paris"),("2993605", "Moirans", "", "FR", "250", "", "84", "38", "381", "45.3283", "5.55342", "Europe/Paris"),("2993647", "Moëlan-sur-Mer", "", "FR", "250", "", "53", "29", "294", "47.81418", "-3.62892", "Europe/Paris"),("2993679", "Mitry-Mory", "", "FR", "250", "", "11", "77", "771", "48.98333", "2.61667", "Europe/Paris"),("2993712", "Miribel", "", "FR", "250", "", "84", "01", "012", "45.8258", "4.9544", "Europe/Paris"),("2993728", "Mirecourt", "", "FR", "250", "", "44", "88", "882", "48.30089", "6.13282", "Europe/Paris"),("2993760", "Miramas", "Мирама", "FR", "250", "", "93", "13", "134", "43.58666", "5.00464", "Europe/Paris"),("2993779", "Mios", "", "FR", "250", "", "75", "33", "336", "44.60489", "-0.93329", "Europe/Paris"),("2993780", "Mions", "", "FR", "250", "", "84", "69", "691", "45.66432", "4.94994", "Europe/Paris"),("2993830", "Mimizan", "", "FR", "250", "", "75", "40", "402", "44.20057", "-1.22886", "Europe/Paris"),("2993875", "Millau", "Мийо", "FR", "250", "", "76", "12", "121", "44.1", "3.08333", "Europe/Paris"),("2993889", "Milhaud", "", "FR", "250", "", "76", "30", "302", "43.78977", "4.31035", "Europe/Paris"),("2993918", "Migné-Auxances", "", "FR", "250", "", "75", "86", "863", "46.62745", "0.31458", "Europe/Paris"),("2993928", "Migennes", "", "FR", "250", "", "27", "89", "891", "47.96548", "3.51787", "Europe/Paris"),("2994043", "Mèze", "", "FR", "250", "", "76", "34", "343", "43.42504", "3.6059", "Europe/Paris"),("2994048", "Meyzieu", "", "FR", "250", "", "84", "69", "691", "45.76667", "5", "Europe/Paris"),("2994049", "Meythet", "", "FR", "250", "", "84", "74", "741", "45.91836", "6.09422", "Europe/Paris"),("2994087", "Meylan", "Мелан", "FR", "250", "", "84", "38", "381", "45.21988", "5.79007", "Europe/Paris"),("2994094", "Meximieux", "", "FR", "250", "", "84", "01", "012", "45.90841", "5.19527", "Europe/Paris"),("2994126", "Meung-sur-Loire", "", "FR", "250", "", "24", "45", "452", "47.83124", "1.69582", "Europe/Paris"),("2994139", "Meulan-en-Yvelines", "", "FR", "250", "", "11", "78", "781", "49.00768", "1.90602", "Europe/Paris"),("2994144", "Meudon", "Мёдон", "FR", "250", "", "11", "92", "923", "48.81381", "2.235", "Europe/Paris"),("2994160", "Metz", "Мец", "FR", "250", "", "44", "57", "579", "49.11911", "6.17269", "Europe/Paris"),("2994283", "Méry-sur-Oise", "", "FR", "250", "", "11", "95", "953", "49.05876", "2.19113", "Europe/Paris"),("2994297", "Merville", "", "FR", "250", "", "32", "59", "594", "50.64329", "2.64125", "Europe/Paris"),("2994306", "Méru", "", "FR", "250", "", "32", "60", "601", "49.23333", "2.13333", "Europe/Paris"),("2994393", "Mérignac", "", "FR", "250", "", "75", "33", "332", "44.83248", "-0.63381", "Europe/Paris"),("2994401", "Méricourt", "", "FR", "250", "", "32", "62", "627", "50.40116", "2.86246", "Europe/Paris"),("2994481", "Mer", "", "FR", "250", "", "24", "41", "411", "47.70555", "1.50621", "Europe/Paris"),("2994494", "Menucourt", "", "FR", "250", "", "11", "95", "953", "49.02841", "1.98046", "Europe/Paris"),("2994497", "Menton", "Ментона", "FR", "250", "", "93", "06", "062", "43.77649", "7.50435", "Europe/Paris"),("2994534", "Mennecy", "", "FR", "250", "", "11", "91", "912", "48.56903", "2.44384", "Europe/Paris"),("2994617", "Mende", "", "FR", "250", "", "76", "48", "482", "44.51667", "3.5", "Europe/Paris"),("2994651", "Melun", "Мелён", "FR", "250", "", "11", "77", "772", "48.53333", "2.66667", "Europe/Paris"),("2994697", "Melesse", "", "FR", "250", "", "53", "35", "353", "48.21771", "-1.69496", "Europe/Paris"),("2994756", "Mehun-sur-Yèvre", "", "FR", "250", "", "24", "18", "183", "47.13782", "2.21105", "Europe/Paris"),("2994768", "Megève", "", "FR", "250", "", "84", "74", "742", "45.85233", "6.61286", "Europe/Paris"),("2994798", "Meaux", "Мо", "FR", "250", "", "11", "77", "771", "48.96014", "2.87885", "Europe/Paris"),("2994837", "Mazingarbe", "", "FR", "250", "", "32", "62", "627", "50.47109", "2.71544", "Europe/Paris"),("2994901", "Mazan", "", "FR", "250", "", "93", "84", "843", "44.0568", "5.12747", "Europe/Paris"),("2994902", "Mazamet", "", "FR", "250", "", "76", "81", "812", "43.49001", "2.37304", "Europe/Paris"),("2994935", "Mayenne", "", "FR", "250", "", "52", "53", "533", "48.3", "-0.61667", "Europe/Paris"),("2994951", "Maxéville", "", "FR", "250", "", "44", "54", "543", "48.70816", "6.1696", "Europe/Paris"),("2995041", "Maurepas", "", "FR", "250", "", "11", "78", "782", "48.76486", "1.92923", "Europe/Paris"),("2995110", "Maule", "", "FR", "250", "", "11", "78", "781", "48.91056", "1.85264", "Europe/Paris"),("2995121", "Mauguio", "", "FR", "250", "", "76", "34", "343", "43.6181", "4.00739", "Europe/Paris"),("2995150", "Maubeuge", "Мобёж", "FR", "250", "", "32", "59", "591", "50.27875", "3.97267", "Europe/Paris"),("2995206", "Massy", "Масси", "FR", "250", "", "11", "91", "913", "48.72692", "2.28301", "Europe/Paris"),("2995339", "Marvejols", "", "FR", "250", "", "76", "48", "482", "44.55378", "3.29137", "Europe/Paris"),("2995387", "Martigues", "Мартиг", "FR", "250", "", "93", "13", "134", "43.40735", "5.05526", "Europe/Paris"),("2995404", "Martignas-sur-Jalle", "", "FR", "250", "", "75", "33", "332", "44.84528", "-0.7806", "Europe/Paris"),("2995456", "Marsillargues", "", "FR", "250", "", "76", "34", "343", "43.66424", "4.17448", "Europe/Paris"),("2995469", "Marseille", "Марсель", "FR", "250", "", "93", "13", "133", "43.29695", "5.38107", "Europe/Paris"),("2995471", "Marseillan", "", "FR", "250", "", "76", "34", "341", "43.35618", "3.52795", "Europe/Paris"),("2995489", "Marsannay-la-Côte", "", "FR", "250", "", "27", "21", "212", "47.27095", "4.98895", "Europe/Paris"),("2995536", "Marquette-lez-Lille", "", "FR", "250", "", "32", "59", "595", "50.67628", "3.06613", "Europe/Paris"),("2995563", "Maromme", "", "FR", "250", "", "28", "76", "763", "49.47925", "1.02375", "Europe/Paris"),("2995642", "Marmande", "Марманд", "FR", "250", "", "75", "47", "472", "44.5", "0.16667", "Europe/Paris"),("2995649", "Marly", "", "FR", "250", "", "44", "57", "574", "49.06667", "6.15", "Europe/Paris"),("2995652", "Marly-le-Roi", "Марли-ле-Руа", "FR", "250", "", "11", "78", "783", "48.86667", "2.08333", "Europe/Paris"),("2995653", "Marly-la-Ville", "", "FR", "250", "", "11", "95", "952", "49.08201", "2.50347", "Europe/Paris"),("2995656", "Marly", "", "FR", "250", "", "32", "59", "596", "50.34556", "3.54959", "Europe/Paris"),("2995669", "Marles-les-Mines", "", "FR", "250", "", "32", "62", "622", "50.50478", "2.50882", "Europe/Paris"),("2995744", "Marignier", "", "FR", "250", "", "84", "74", "742", "46.09014", "6.50004", "Europe/Paris"),("2995750", "Marignane", "Мариньян", "FR", "250", "", "93", "13", "134", "43.41604", "5.21453", "Europe/Paris"),("2995782", "Marguerittes", "", "FR", "250", "", "76", "30", "302", "43.8596", "4.44517", "Europe/Paris"),("2995790", "Margny-lès-Compiègne", "", "FR", "250", "", "32", "60", "603", "49.42559", "2.81806", "Europe/Paris"),("2995854", "Marennes", "", "FR", "250", "", "75", "17", "172", "45.8228", "-1.10546", "Europe/Paris"),("2995908", "Marcq-en-Barœul", "Марк-ан-Барёль", "FR", "250", "", "32", "59", "595", "50.66667", "3.08333", "Europe/Paris"),("2995916", "Marcoussis", "", "FR", "250", "", "11", "91", "913", "48.64026", "2.23858", "Europe/Paris"),("2995938", "Marck", "", "FR", "250", "", "32", "62", "626", "50.94897", "1.94328", "Europe/Paris"),("2996106", "Marange-Silvange", "", "FR", "250", "", "44", "57", "574", "49.20748", "6.10228", "Europe/Paris"),("2996146", "Mantes-la-Ville", "", "FR", "250", "", "11", "78", "781", "48.97374", "1.70253", "Europe/Paris"),("2996148", "Mantes-la-Jolie", "Мант-ля-Жоли", "FR", "250", "", "11", "78", "781", "48.98333", "1.71667", "Europe/Paris"),("2996180", "Manosque", "Маноске", "FR", "250", "", "93", "04", "044", "43.82883", "5.78688", "Europe/Paris"),("2996236", "Manduel", "", "FR", "250", "", "76", "30", "302", "43.81855", "4.47247", "Europe/Paris"),("2996251", "Mandeure", "", "FR", "250", "", "27", "25", "252", "47.44921", "6.80762", "Europe/Paris"),("2996255", "Mandelieu-la-Napoule", "", "FR", "250", "", "93", "06", "061", "43.55", "6.93333", "Europe/Paris"),("2996291", "Mamers", "", "FR", "250", "", "52", "72", "722", "48.35", "0.38333", "Europe/Paris"),("2996298", "Malzéville", "", "FR", "250", "", "44", "54", "543", "48.71181", "6.18176", "Europe/Paris"),("2996397", "Mallemort", "", "FR", "250", "", "93", "13", "132", "43.73172", "5.17945", "Europe/Paris"),("2996444", "Malesherbes", "", "FR", "250", "", "24", "45", "453", "48.29566", "2.40935", "Europe/Paris"),("2996448", "Malemort-sur-Corrèze", "", "FR", "250", "", "75", "19", "191", "45.17009", "1.56193", "Europe/Paris"),("2996492", "Malaunay", "", "FR", "250", "", "28", "76", "763", "49.5271", "1.04292", "Europe/Paris"),("2996514", "Malakoff", "", "FR", "250", "", "11", "92", "921", "48.81999", "2.29998", "Europe/Paris"),("2996538", "Maizières-lès-Metz", "", "FR", "250", "", "44", "57", "574", "49.20754", "6.16052", "Europe/Paris"),("2996564", "Maisons-Laffitte", "Мезон-Лафит", "FR", "250", "", "11", "78", "783", "48.95264", "2.14521", "Europe/Paris"),("2996568", "Maisons-Alfort", "Мезон-Альфор", "FR", "250", "", "11", "94", "941", "48.81171", "2.43945", "Europe/Paris"),("2996645", "Mainvilliers", "", "FR", "250", "", "24", "28", "281", "48.45003", "1.45607", "Europe/Paris"),("2996752", "Magny-les-Hameaux", "", "FR", "250", "", "11", "78", "782", "48.74345", "2.06154", "Europe/Paris"),("2996764", "Magny-en-Vexin", "", "FR", "250", "", "11", "95", "953", "49.15515", "1.78669", "Europe/Paris"),("2996802", "Magnanville", "", "FR", "250", "", "11", "78", "781", "48.96798", "1.67842", "Europe/Paris"),("2996882", "Mâcon", "Макон", "FR", "250", "", "27", "71", "715", "46.3", "4.83333", "Europe/Paris"),("2996905", "Machecoul", "", "FR", "250", "", "52", "44", "442", "46.99358", "-1.82352", "Europe/Paris"),("2996921", "Mably", "", "FR", "250", "", "84", "42", "422", "46.08623", "4.06607", "Europe/Paris"),("2996927", "Lys-lez-Lannoy", "", "FR", "250", "", "32", "59", "595", "50.66667", "3.21667", "Europe/Paris"),("2996944", "Lyon", "Лион", "FR", "250", "", "84", "69", "691", "45.74846", "4.84671", "Europe/Paris"),("2996986", "Luynes", "", "FR", "250", "", "24", "37", "372", "47.38441", "0.5547", "Europe/Paris"),("2996995", "Luxeuil-les-Bains", "", "FR", "250", "", "27", "70", "701", "47.8171", "6.365", "Europe/Paris"),("2997010", "Lutterbach", "", "FR", "250", "", "44", "68", "684", "47.75835", "7.27695", "Europe/Paris"),("2997076", "Lure", "", "FR", "250", "", "27", "70", "701", "47.68333", "6.5", "Europe/Paris"),("2997104", "L'Union", "", "FR", "250", "", "76", "31", "313", "43.66042", "1.48264", "Europe/Paris"),("2997110", "Lunéville", "Люневиль", "FR", "250", "", "44", "54", "542", "48.6", "6.5", "Europe/Paris"),("2997116", "Lunel", "Люнель", "FR", "250", "", "76", "34", "343", "43.67778", "4.13611", "Europe/Paris"),("2997148", "Luisant", "", "FR", "250", "", "24", "28", "281", "48.4295", "1.47383", "Europe/Paris"),("2997184", "Ludres", "", "FR", "250", "", "44", "54", "543", "48.62181", "6.16183", "Europe/Paris"),("2997210", "Luçon", "", "FR", "250", "", "52", "85", "851", "46.45773", "-1.16512", "Europe/Paris"),("2997246", "Lucé", "", "FR", "250", "", "24", "28", "281", "48.43689", "1.46359", "Europe/Paris"),("2997262", "Luc-la-Primaube", "", "FR", "250", "", "76", "12", "122", "44.31439", "2.53552", "Europe/Paris"),("2997316", "Louvroil", "", "FR", "250", "", "32", "59", "591", "50.26427", "3.96272", "Europe/Paris"),("2997317", "Louvres", "", "FR", "250", "", "11", "95", "952", "49.0446", "2.50479", "Europe/Paris"),("2997336", "Louviers", "", "FR", "250", "", "28", "27", "271", "49.21667", "1.16667", "Europe/Paris"),("2997351", "Louveciennes", "", "FR", "250", "", "11", "78", "783", "48.86115", "2.11463", "Europe/Paris"),("2997395", "Lourdes", "Лурд", "FR", "250", "", "76", "65", "651", "43.1", "-0.05", "Europe/Paris"),("2997439", "Louhans", "", "FR", "250", "", "27", "71", "714", "46.63333", "5.21667", "Europe/Paris"),("2997457", "Loudun", "", "FR", "250", "", "75", "86", "861", "47.00788", "0.08296", "Europe/Paris"),("2997465", "Loudéac", "", "FR", "250", "", "53", "22", "224", "48.17826", "-2.75433", "Europe/Paris"),("2997556", "Lormont", "Лормон", "FR", "250", "", "75", "33", "332", "44.87495", "-0.51782", "Europe/Paris"),("2997569", "Loriol-sur-Drôme", "", "FR", "250", "", "84", "26", "263", "44.75214", "4.82547", "Europe/Paris"),("2997577", "Lorient", "Лорьян", "FR", "250", "", "53", "56", "561", "47.75", "-3.36667", "Europe/Paris"),("2997581", "Lorgues", "", "FR", "250", "", "93", "83", "831", "43.49361", "6.3611", "Europe/Paris"),("2997619", "Loos-en-Gohelle", "", "FR", "250", "", "32", "62", "627", "50.45786", "2.79215", "Europe/Paris"),("2997620", "Loos", "", "FR", "250", "", "32", "59", "595", "50.60982", "3.01874", "Europe/Paris"),("2997621", "Loon-Plage", "", "FR", "250", "", "32", "59", "594", "50.99647", "2.2177", "Europe/Paris"),("2997626", "Lons-le-Saunier", "Лон-ле-Сонье", "FR", "250", "", "27", "39", "392", "46.66667", "5.55", "Europe/Paris"),("2997628", "Lons", "", "FR", "250", "", "75", "64", "643", "43.31667", "-0.4", "Europe/Paris"),("2997638", "Longwy", "", "FR", "250", "", "44", "54", "541", "49.51936", "5.76882", "Europe/Paris"),("2997644", "Longvic", "", "FR", "250", "", "27", "21", "212", "47.28754", "5.06341", "Europe/Paris"),("2997646", "Longuyon", "", "FR", "250", "", "44", "54", "541", "49.44548", "5.60145", "Europe/Paris"),("2997670", "Longuenesse", "", "FR", "250", "", "32", "62", "625", "50.73395", "2.2352", "Europe/Paris"),("2997681", "Longueau", "", "FR", "250", "", "32", "80", "802", "49.87226", "2.3588", "Europe/Paris"),("2997698", "Longpont-sur-Orge", "", "FR", "250", "", "11", "91", "913", "48.64171", "2.29278", "Europe/Paris"),("2997712", "Longjumeau", "Лонжюмо", "FR", "250", "", "11", "91", "913", "48.69503", "2.30735", "Europe/Paris"),("2997803", "Lomme", "Ломм", "FR", "250", "", "32", "59", "595", "50.64358", "2.98715", "Europe/Paris"),("2997841", "Loison-sous-Lens", "", "FR", "250", "", "32", "62", "627", "50.43796", "2.85322", "Europe/Paris"),("2997904", "Lognes", "", "FR", "250", "", "11", "77", "775", "48.83541", "2.62998", "Europe/Paris"),("2997936", "Lodève", "", "FR", "250", "", "76", "34", "342", "43.71667", "3.31667", "Europe/Paris"),("2997996", "Loches", "", "FR", "250", "", "24", "37", "373", "47.13333", "1", "Europe/Paris"),("2998056", "Livry-Gargan", "", "FR", "250", "", "11", "93", "932", "48.9193", "2.54305", "Europe/Paris"),("2998059", "Livron-sur-Drôme", "", "FR", "250", "", "84", "26", "263", "44.7731", "4.84705", "Europe/Paris"),("2998078", "Liverdun", "", "FR", "250", "", "44", "54", "544", "48.75084", "6.06424", "Europe/Paris"),("2998105", "Lisses", "", "FR", "250", "", "11", "91", "912", "48.60222", "2.42245", "Europe/Paris"),("2998127", "L’Isle-sur-la-Sorgue", "Л'Иль-сюр-ла-Сорг", "FR", "250", "", "93", "84", "842", "43.91915", "5.05092", "Europe/Paris"),("2998136", "L’Isle-d’Abeau", "", "FR", "250", "", "84", "38", "382", "45.61813", "5.23546", "Europe/Paris"),("2998140", "L’Isle-Adam", "", "FR", "250", "", "11", "95", "953", "49.10744", "2.22818", "Europe/Paris"),("2998150", "Lisieux", "Лизьё", "FR", "250", "", "28", "14", "143", "49.1466", "0.22925", "Europe/Paris"),("2998209", "Linselles", "", "FR", "250", "", "32", "59", "595", "50.73708", "3.07878", "Europe/Paris"),("2998224", "Lingolsheim", "", "FR", "250", "", "44", "67", "676", "48.55752", "7.68253", "Europe/Paris"),("2998251", "Linas", "", "FR", "250", "", "11", "91", "913", "48.63041", "2.26266", "Europe/Paris"),("2998264", "Limoux", "", "FR", "250", "", "76", "11", "112", "43.05487", "2.22173", "Europe/Paris"),("2998269", "Limours", "", "FR", "250", "", "11", "91", "913", "48.64625", "2.07688", "Europe/Paris"),("2998286", "Limoges", "Лимож", "FR", "250", "", "75", "87", "872", "45.83153", "1.25781", "Europe/Paris"),("2998305", "Limeil-Brévannes", "", "FR", "250", "", "11", "94", "941", "48.7448", "2.48705", "Europe/Paris"),("2998311", "Limay", "", "FR", "250", "", "11", "78", "781", "48.99553", "1.74081", "Europe/Paris"),("2998320", "Lillers", "", "FR", "250", "", "32", "62", "622", "50.56345", "2.48042", "Europe/Paris"),("2998322", "Lillebonne", "", "FR", "250", "", "28", "76", "762", "49.5203", "0.53617", "Europe/Paris"),("2998324", "Lille", "Лилль", "FR", "250", "", "32", "59", "595", "50.63297", "3.05858", "Europe/Paris"),("2998362", "Ligny-en-Barrois", "", "FR", "250", "", "44", "55", "551", "48.68861", "5.32543", "Europe/Paris"),("2998423", "Liffré", "", "FR", "250", "", "53", "35", "353", "48.21324", "-1.50838", "Europe/Paris"),("2998431", "Liévin", "Лиевен", "FR", "250", "", "32", "62", "627", "50.4198", "2.78068", "Europe/Paris"),("2998439", "Lieusaint", "", "FR", "250", "", "11", "77", "772", "48.63476", "2.54806", "Europe/Paris"),("2998517", "Libourne", "Либурн", "FR", "250", "", "75", "33", "335", "44.91667", "-0.23333", "Europe/Paris"),("2998520", "Libercourt", "", "FR", "250", "", "32", "62", "627", "50.48322", "3.01584", "Europe/Paris"),("2998532", "Liancourt", "", "FR", "250", "", "32", "60", "602", "49.33034", "2.46595", "Europe/Paris"),("2998632", "L'Haÿ-les-Roses", "", "FR", "250", "FR", "11", "94", "943", "48.78333", "2.33333", "Europe/Paris"),("2998639", "Lezoux", "", "FR", "250", "", "84", "63", "635", "45.82689", "3.37924", "Europe/Paris"),("2998644", "Lézignan-Corbières", "", "FR", "250", "", "76", "11", "113", "43.19765", "2.76142", "Europe/Paris"),("2998854", "Le Vésinet", "Ле-Везине", "FR", "250", "", "11", "78", "783", "48.89281", "2.13308", "Europe/Paris"),("2998975", "Levallois-Perret", "Леваллуа-Перре", "FR", "250", "", "11", "92", "922", "48.89389", "2.28864", "Europe/Paris"),("2998998", "Valdahon", "", "FR", "250", "", "27", "25", "253", "47.15", "6.35", "Europe/Paris"),("2999093", "Le Tréport", "", "FR", "250", "", "28", "76", "761", "50.05979", "1.37583", "Europe/Paris"),("2999126", "Le Trait", "", "FR", "250", "", "28", "76", "763", "49.46895", "0.81634", "Europe/Paris"),("2999139", "Le Touquet-Paris-Plage", "", "FR", "250", "", "32", "62", "624", "50.52432", "1.58571", "Europe/Paris"),("2999180", "Le Thor", "", "FR", "250", "", "93", "84", "842", "43.92943", "4.99543", "Europe/Paris"),("2999259", "Le Teil", "", "FR", "250", "", "84", "07", "072", "44.54679", "4.68165", "Europe/Paris"),("2999260", "Le Teich", "", "FR", "250", "", "75", "33", "336", "44.63177", "-1.02155", "Europe/Paris"),("2999296", "Le Taillan-Médoc", "", "FR", "250", "", "75", "33", "332", "44.90521", "-0.6706", "Europe/Paris"),("2999572", "Les Sorinières", "", "FR", "250", "", "52", "44", "442", "47.14831", "-1.52932", "Europe/Paris"),("2999683", "Les Sables-d'Olonne", "Ле-Сабль-д’Олон", "FR", "250", "", "52", "85", "853", "46.5", "-1.78333", "Europe/Paris"),("2999838", "Lesquin", "", "FR", "250", "", "32", "59", "595", "50.58232", "3.119", "Europe/Paris"),("2999908", "Les Ponts-de-Cé", "", "FR", "250", "", "52", "49", "491", "47.42315", "-0.52477", "Europe/Paris"),("3000047", "Les Pennes-Mirabeau", "", "FR", "250", "", "93", "13", "131", "43.41028", "5.31306", "Europe/Paris"),("3000060", "Les Pavillons-sous-Bois", "", "FR", "250", "", "11", "93", "931", "48.90683", "2.50648", "Europe/Paris"),("3000072", "Lesparre-Médoc", "", "FR", "250", "", "75", "33", "334", "45.3", "-0.93333", "Europe/Paris"),("3000139", "Le Soler", "", "FR", "250", "", "76", "66", "662", "42.68101", "2.79335", "Europe/Paris"),("3000174", "Lesneven", "", "FR", "250", "", "53", "29", "291", "48.57233", "-4.32133", "Europe/Paris"),("3000192", "Les Mureaux", "", "FR", "250", "", "11", "78", "781", "48.99173", "1.90972", "Europe/Paris"),("3000491", "Les Lilas", "", "FR", "250", "", "11", "93", "931", "48.87992", "2.42057", "Europe/Paris"),("3000602", "Lésigny", "", "FR", "250", "", "11", "77", "772", "48.74374", "2.61518", "Europe/Paris"),("3000648", "Les Herbiers", "", "FR", "250", "", "52", "85", "852", "46.86667", "-1.01667", "Europe/Paris"),("3001126", "Les Essarts-le-Roi", "", "FR", "250", "", "11", "78", "782", "48.71673", "1.90089", "Europe/Paris"),("3001402", "Les Clayes-sous-Bois", "", "FR", "250", "", "11", "78", "784", "48.82206", "1.98677", "Europe/Paris"),("3001617", "Lescar", "", "FR", "250", "", "75", "64", "643", "43.33333", "-0.41667", "Europe/Paris"),("3002138", "Les Arcs", "", "FR", "250", "", "93", "83", "831", "43.45702", "6.47905", "Europe/Paris"),("3002158", "Les Angles", "", "FR", "250", "", "76", "30", "302", "43.95806", "4.76342", "Europe/Paris"),("3002172", "Les Andelys", "", "FR", "250", "", "28", "27", "271", "49.25", "1.41667", "Europe/Paris"),("3002351", "Le Rheu", "", "FR", "250", "", "53", "35", "353", "48.10228", "-1.79733", "Europe/Paris"),("3002373", "Le Relecq-Kerhuon", "", "FR", "250", "", "53", "29", "291", "48.40691", "-4.39359", "Europe/Paris"),("3002401", "Le Raincy", "", "FR", "250", "", "11", "93", "932", "48.9", "2.51667", "Europe/Paris"),("3002443", "Le Puy-Sainte-Réparade", "", "FR", "250", "", "93", "13", "131", "43.66319", "5.43434", "Europe/Paris"),("3002465", "Le Puy-en-Velay", "Пюи-ан-Веле", "FR", "250", "", "84", "43", "432", "45.04366", "3.88523", "Europe/Paris"),("3002499", "Le Pré-Saint-Gervais", "", "FR", "250", "", "11", "93", "931", "48.88549", "2.40422", "Europe/Paris"),("3002510", "Le Pradet", "", "FR", "250", "", "93", "83", "832", "43.10661", "6.01718", "Europe/Paris"),("3002534", "Le Pouliguen", "", "FR", "250", "", "52", "44", "443", "47.26973", "-2.4278", "Europe/Paris"),("3002551", "Le Portel", "", "FR", "250", "", "32", "62", "623", "50.70559", "1.57574", "Europe/Paris"),("3002570", "Le Pontet", "", "FR", "250", "", "93", "84", "842", "43.96119", "4.86008", "Europe/Paris"),("3002585", "Le Pont-de-Claix", "", "FR", "250", "", "84", "38", "381", "45.12443", "5.7064", "Europe/Paris"),("3002620", "Le Poiré-sur-Vie", "", "FR", "250", "", "52", "85", "852", "46.76921", "-1.50938", "Europe/Paris"),("3002626", "Le Poinçonnet", "", "FR", "250", "", "24", "36", "362", "46.7641", "1.7179", "Europe/Paris"),("3002647", "Le Plessis-Trévise", "", "FR", "250", "", "11", "94", "942", "48.81074", "2.57363", "Europe/Paris"),("3002650", "Le Plessis-Robinson", "Ле-Плесси-Робинсон", "FR", "250", "", "11", "92", "921", "48.78889", "2.27078", "Europe/Paris"),("3002679", "Le Plessis-Bouchard", "", "FR", "250", "", "11", "95", "953", "49", "2.23333", "Europe/Paris"),("3002836", "Le Pian-Médoc", "", "FR", "250", "", "75", "33", "332", "44.95537", "-0.66227", "Europe/Paris"),("3002880", "Le Petit-Quevilly", "", "FR", "250", "", "28", "76", "763", "49.41338", "1.06155", "Europe/Paris"),("3002918", "Petit-Couronne", "", "FR", "250", "", "28", "76", "763", "49.38333", "1.01667", "Europe/Paris"),("3002965", "Le Perreux-sur-Marne", "", "FR", "250", "", "11", "94", "942", "48.85", "2.5", "Europe/Paris"),("3002967", "Le Perray-en-Yvelines", "", "FR", "250", "", "11", "78", "782", "48.69441", "1.85643", "Europe/Paris"),("3002984", "Le Pecq", "", "FR", "250", "", "11", "78", "783", "48.89317", "2.10371", "Europe/Paris"),("3002988", "Le Péage-de-Roussillon", "", "FR", "250", "", "84", "38", "383", "45.37179", "4.79791", "Europe/Paris"),("3003017", "Le Passage", "", "FR", "250", "", "75", "47", "471", "44.20143", "0.60275", "Europe/Paris"),("3003044", "Le Palais-sur-Vienne", "", "FR", "250", "", "75", "87", "872", "45.8638", "1.32207", "Europe/Paris"),("3003067", "Léognan", "", "FR", "250", "", "75", "33", "332", "44.73548", "-0.59738", "Europe/Paris"),("3003074", "Lentilly", "", "FR", "250", "", "84", "69", "691", "45.81984", "4.66352", "Europe/Paris"),("3003093", "Lens", "", "FR", "250", "", "32", "62", "627", "50.43302", "2.82791", "Europe/Paris"),("3003148", "Le Muy", "", "FR", "250", "", "93", "83", "831", "43.47381", "6.56452", "Europe/Paris"),("3003359", "Le Mesnil-Saint-Denis", "", "FR", "250", "", "11", "78", "782", "48.74485", "1.95594", "Europe/Paris"),("3003375", "Le Mesnil-le-Roi", "", "FR", "250", "", "11", "78", "783", "48.93825", "2.12554", "Europe/Paris"),("3003391", "Le Mesnil-Esnard", "", "FR", "250", "", "28", "76", "763", "49.41319", "1.14521", "Europe/Paris"),("3003481", "Le Mée-sur-Seine", "", "FR", "250", "", "11", "77", "772", "48.53157", "2.62829", "Europe/Paris"),("3003603", "Le Mans", "Ле-Ман", "FR", "250", "", "52", "72", "723", "48", "0.2", "Europe/Paris"),("3003650", "Le Luc", "", "FR", "250", "", "93", "83", "831", "43.39318", "6.31474", "Europe/Paris"),("3003661", "Le Loroux-Bottereau", "", "FR", "250", "", "52", "44", "442", "47.23763", "-1.34952", "Europe/Paris"),("3003713", "Le Lavandou", "", "FR", "250", "", "93", "83", "832", "43.137", "6.366", "Europe/Paris"),("3003737", "Le Kremlin-Bicêtre", "Ле-Кремлен-Бисетр", "FR", "250", "", "11", "94", "943", "48.81471", "2.36073", "Europe/Paris"),("3003796", "Le Havre", "Гавр", "FR", "250", "", "28", "76", "762", "49.4938", "0.10767", "Europe/Paris"),("3003859", "Le Haillan", "", "FR", "250", "", "75", "33", "332", "44.87225", "-0.67965", "Europe/Paris"),("3003874", "Léguevin", "", "FR", "250", "", "76", "31", "313", "43.60028", "1.23236", "Europe/Paris"),("3003918", "Le Grau-du-Roi", "", "FR", "250", "", "76", "30", "302", "43.53881", "4.13559", "Europe/Paris"),("3003952", "Le Grand-Quevilly", "Гран-Кевилли", "FR", "250", "", "28", "76", "763", "49.40076", "1.04582", "Europe/Paris"),("3004078", "Gond-Pontouvre", "", "FR", "250", "", "75", "16", "161", "45.68333", "0.16667", "Europe/Paris"),("3004213", "Leforest", "", "FR", "250", "", "32", "62", "627", "50.43866", "3.0648", "Europe/Paris"),("3004244", "Leffrinckoucke", "", "FR", "250", "", "32", "59", "594", "51.03457", "2.46452", "Europe/Paris"),("3004314", "Leers", "", "FR", "250", "", "32", "59", "595", "50.68217", "3.24429", "Europe/Paris"),("3004427", "Le Creusot", "Ле-Крёзо", "FR", "250", "", "27", "71", "711", "46.80714", "4.41632", "Europe/Paris"),("3004434", "Le Crès", "", "FR", "250", "", "76", "34", "343", "43.64807", "3.93976", "Europe/Paris"),("3004492", "Le Coteau", "", "FR", "250", "", "84", "42", "422", "46.02706", "4.0869", "Europe/Paris"),("3004630", "Le Chesnay", "Ле-Шене", "FR", "250", "", "11", "78", "784", "48.8222", "2.12213", "Europe/Paris"),("3004775", "Le Chambon-Feugerolles", "", "FR", "250", "", "84", "42", "423", "45.39689", "4.32592", "Europe/Paris"),("3004811", "Le Cendre", "", "FR", "250", "", "84", "63", "632", "45.72118", "3.18839", "Europe/Paris"),("3004871", "Le Cannet", "Ле-Канне", "FR", "250", "", "93", "06", "061", "43.57662", "7.01912", "Europe/Paris"),("3005066", "Le Bouscat", "Ле-Буска", "FR", "250", "", "75", "33", "332", "44.866", "-0.59411", "Europe/Paris"),("3005082", "Le Bourget", "", "FR", "250", "", "11", "93", "931", "48.93405", "2.43584", "Europe/Paris"),("3005269", "Le Blanc-Mesnil", "Ле-Блан-Мениль", "FR", "250", "", "11", "93", "932", "48.93872", "2.46138", "Europe/Paris"),("3005270", "Le Blanc", "", "FR", "250", "", "24", "36", "361", "46.63333", "1.06667", "Europe/Paris"),("3005326", "Le Beausset", "", "FR", "250", "", "93", "83", "832", "43.19853", "5.80155", "Europe/Paris"),("3005417", "Laxou", "Лаксу", "FR", "250", "", "44", "54", "543", "48.68315", "6.14799", "Europe/Paris"),("3005422", "La Wantzenau", "", "FR", "250", "", "44", "67", "676", "48.65786", "7.83068", "Europe/Paris"),("3005435", "La Voulte-sur-Rhône", "", "FR", "250", "", "84", "07", "072", "44.80072", "4.7716", "Europe/Paris"),("3005524", "La Ville-du-Bois", "", "FR", "250", "", "11", "91", "913", "48.65521", "2.26833", "Europe/Paris"),("3005639", "La Verrière", "", "FR", "250", "", "11", "78", "782", "48.752", "1.94649", "Europe/Paris"),("3005651", "La Verpillière", "", "FR", "250", "", "84", "38", "382", "45.63647", "5.14151", "Europe/Paris"),("3005712", "Lavelanet", "", "FR", "250", "", "76", "09", "091", "42.93127", "1.84656", "Europe/Paris"),("3005735", "Lavaur", "", "FR", "250", "", "76", "81", "812", "43.69847", "1.81858", "Europe/Paris"),("3005825", "La Valette-du-Var", "", "FR", "250", "", "93", "83", "832", "43.13741", "5.98314", "Europe/Paris"),("3005866", "Laval", "Лаваль", "FR", "250", "", "52", "53", "532", "48.06667", "-0.76667", "Europe/Paris"),("3006035", "Launaguet", "", "FR", "250", "", "76", "31", "313", "43.67818", "1.45603", "Europe/Paris"),("3006056", "Laudun-l'Ardoise", "", "FR", "250", "", "76", "30", "302", "44.1", "4.66667", "Europe/Paris"),("3006121", "Lattes", "", "FR", "250", "", "76", "34", "343", "43.56752", "3.9046", "Europe/Paris"),("3006131", "La Tronche", "", "FR", "250", "", "84", "38", "381", "45.20429", "5.73645", "Europe/Paris"),("3006152", "La Trinité", "", "FR", "250", "", "93", "06", "062", "43.74149", "7.31353", "Europe/Paris"),("3006202", "La Tour-du-Pin", "", "FR", "250", "", "84", "38", "382", "45.56667", "5.45", "Europe/Paris"),("3006283", "La Teste-de-Buch", "Ла-Тест-де-Буха", "FR", "250", "", "75", "33", "336", "44.62875", "-1.14059", "Europe/Paris"),("3006320", "La Talaudière", "", "FR", "250", "", "84", "42", "423", "45.48094", "4.43173", "Europe/Paris"),("3006387", "La Souterraine", "", "FR", "250", "", "75", "23", "232", "46.23714", "1.48701", "Europe/Paris"),("3006414", "La Seyne-sur-Mer", "Ла-Сейн-сюр-Мер", "FR", "250", "", "93", "83", "832", "43.09818", "5.88471", "Europe/Paris"),("3006531", "La Salvetat-Saint-Gilles", "", "FR", "250", "", "76", "31", "313", "43.57622", "1.27192", "Europe/Paris"),("3006767", "La Roche-sur-Yon", "Ла-Рош-сюр-Йон", "FR", "250", "", "52", "85", "852", "46.66667", "-1.43333", "Europe/Paris"),("3006770", "La Roche-sur-Foron", "", "FR", "250", "", "84", "74", "742", "46.0666", "6.31224", "Europe/Paris"),("3006787", "La Rochelle", "Ла-Рошель", "FR", "250", "", "75", "17", "173", "46.16667", "-1.15", "Europe/Paris"),("3006876", "Larmor-Plage", "", "FR", "250", "", "53", "56", "561", "47.70646", "-3.38339", "Europe/Paris"),("3006928", "La Riche", "", "FR", "250", "", "24", "37", "372", "47.38996", "0.67072", "Europe/Paris"),("3006930", "La Ricamarie", "", "FR", "250", "", "84", "42", "423", "45.41684", "4.31199", "Europe/Paris"),("3007064", "La Ravoire", "", "FR", "250", "", "84", "73", "732", "45.55978", "5.96871", "Europe/Paris"),("3007102", "La Queue-en-Brie", "", "FR", "250", "", "11", "94", "942", "48.7852", "2.58112", "Europe/Paris"),("3007401", "La Penne-sur-Huveaune", "", "FR", "250", "", "93", "13", "133", "43.28208", "5.51642", "Europe/Paris"),("3007477", "Laon", "Лана", "FR", "250", "", "32", "02", "022", "49.56667", "3.61667", "Europe/Paris"),("3007508", "Lanton", "", "FR", "250", "", "75", "33", "336", "44.70478", "-1.03562", "Europe/Paris"),("3007609", "Lannion", "Ланнион", "FR", "250", "", "53", "22", "223", "48.73333", "-3.46667", "Europe/Paris"),("3007622", "Lannemezan", "", "FR", "250", "", "76", "65", "652", "43.12517", "0.38401", "Europe/Paris"),("3007663", "Languidic", "", "FR", "250", "", "53", "56", "561", "47.83266", "-3.15821", "Europe/Paris"),("3007666", "Langueux", "", "FR", "250", "", "53", "22", "224", "48.495", "-2.7185", "Europe/Paris"),("3007680", "Langres", "", "FR", "250", "", "44", "52", "522", "47.86667", "5.33333", "Europe/Paris"),("3007691", "Langon", "", "FR", "250", "", "75", "33", "333", "44.55", "-0.25", "Europe/Paris"),("3007780", "Laneuveville-devant-Nancy", "", "FR", "250", "", "44", "54", "543", "48.65628", "6.2317", "Europe/Paris"),("3007794", "Lanester", "", "FR", "250", "", "53", "56", "561", "47.76132", "-3.33965", "Europe/Paris"),("3007842", "Landivisiau", "", "FR", "250", "", "53", "29", "293", "48.50784", "-4.06833", "Europe/Paris"),("3007874", "Landerneau", "", "FR", "250", "", "53", "29", "291", "48.45252", "-4.25252", "Europe/Paris"),("3007912", "Lançon-Provence", "", "FR", "250", "", "93", "13", "131", "43.59237", "5.13167", "Europe/Paris"),("3007957", "La Mure", "", "FR", "250", "", "84", "38", "381", "44.90257", "5.78659", "Europe/Paris"),("3007963", "La Mulatière", "", "FR", "250", "", "84", "69", "691", "45.7259", "4.80712", "Europe/Paris"),("3007998", "La Motte-Servolex", "", "FR", "250", "", "84", "73", "732", "45.59416", "5.87575", "Europe/Paris"),("3008074", "Lamorlaye", "", "FR", "250", "", "32", "60", "604", "49.16246", "2.44687", "Europe/Paris"),("3008096", "La Montagne", "", "FR", "250", "", "52", "44", "442", "47.18651", "-1.68272", "Europe/Paris"),("3008198", "Lambres-lez-Douai", "", "FR", "250", "", "32", "59", "593", "50.35", "3.06667", "Europe/Paris"),("3008208", "Lambesc", "", "FR", "250", "", "93", "13", "131", "43.65311", "5.26282", "Europe/Paris"),("3008218", "Lambersart", "Ламберсар", "FR", "250", "", "32", "59", "595", "50.65", "3.03333", "Europe/Paris"),("3008225", "Lamballe", "", "FR", "250", "", "53", "22", "224", "48.46762", "-2.51436", "Europe/Paris"),("3008379", "La Madeleine", "Мадлен", "FR", "250", "", "32", "59", "595", "50.64603", "3.07585", "Europe/Paris"),("3008432", "La Londe-les-Maures", "", "FR", "250", "", "93", "83", "832", "43.13714", "6.23499", "Europe/Paris"),("3008463", "Lallaing", "", "FR", "250", "", "32", "59", "593", "50.39012", "3.16949", "Europe/Paris"),("3008981", "La Grande-Motte", "", "FR", "250", "", "76", "34", "343", "43.56667", "4.08333", "Europe/Paris"),("3009015", "La Grand-Croix", "", "FR", "250", "", "84", "42", "423", "45.5", "4.55", "Europe/Paris"),("3009050", "La Gorgue", "", "FR", "250", "", "32", "59", "594", "50.6379", "2.71502", "Europe/Paris"),("3009052", "Lagord", "", "FR", "250", "", "75", "17", "173", "46.18822", "-1.15355", "Europe/Paris"),("3009071", "Lagny-sur-Marne", "", "FR", "250", "", "11", "77", "775", "48.86667", "2.71667", "Europe/Paris"),("3009073", "Lagnieu", "", "FR", "250", "", "84", "01", "011", "45.90038", "5.3466", "Europe/Paris"),("3009086", "La Glacerie", "", "FR", "250", "", "28", "50", "502", "49.60517", "-1.58185", "Europe/Paris"),("3009150", "La Gaude", "", "FR", "250", "", "93", "06", "061", "43.72235", "7.15083", "Europe/Paris"),("3009169", "La Garenne-Colombes", "", "FR", "250", "", "11", "92", "922", "48.90472", "2.2469", "Europe/Paris"),("3009223", "La Garde", "", "FR", "250", "", "93", "83", "832", "43.12277", "6.00745", "Europe/Paris"),("3009443", "La Flèche", "Ла-Флеш", "FR", "250", "", "52", "72", "721", "47.69815", "-0.07553", "Europe/Paris"),("3009481", "La Ferté-sous-Jouarre", "", "FR", "250", "", "11", "77", "771", "48.9514", "3.12724", "Europe/Paris"),("3009484", "La Ferté-Saint-Aubin", "", "FR", "250", "", "24", "45", "452", "47.71695", "1.93904", "Europe/Paris"),("3009486", "La Ferté-Macé", "", "FR", "250", "", "28", "61", "611", "48.58999", "-0.358", "Europe/Paris"),("3009494", "La Ferté-Bernard", "", "FR", "250", "", "52", "72", "722", "48.18633", "0.65357", "Europe/Paris"),("3009566", "La Farlède", "", "FR", "250", "", "93", "83", "832", "43.1677", "6.04266", "Europe/Paris"),("3009575", "La Fare-les-Oliviers", "", "FR", "250", "", "93", "13", "131", "43.55104", "5.1943", "Europe/Paris"),("3009791", "La Crau", "", "FR", "250", "", "93", "83", "832", "43.14981", "6.07425", "Europe/Paris"),("3009822", "La Couronne", "", "FR", "250", "", "75", "16", "161", "45.61128", "0.09948", "Europe/Paris"),("3009824", "La Courneuve", "Ла-Курнев", "FR", "250", "", "11", "93", "933", "48.92805", "2.39627", "Europe/Paris"),("3009978", "La Colle-sur-Loup", "", "FR", "250", "", "93", "06", "061", "43.6875", "7.10268", "Europe/Paris"),("3010025", "La Ciotat", "Ла-Сьота", "FR", "250", "", "93", "13", "133", "43.17476", "5.60449", "Europe/Paris"),("3010040", "La Chevrolière", "", "FR", "250", "", "52", "44", "442", "47.09124", "-1.60973", "Europe/Paris"),("3010201", "La Charité-sur-Loire", "", "FR", "250", "FR", "27", "58", "584", "47.18333", "3.01667", "Europe/Paris"),("3010237", "La Chapelle-sur-Erdre", "", "FR", "250", "", "52", "44", "442", "47.29583", "-1.55309", "Europe/Paris"),("3010265", "La Chapelle-Saint-Mesmin", "", "FR", "250", "", "24", "45", "452", "47.88648", "1.8345", "Europe/Paris"),("3010271", "La Chapelle-Saint-Luc", "", "FR", "250", "", "44", "10", "103", "48.31734", "4.03988", "Europe/Paris"),("3010529", "La Celle-Saint-Cloud", "", "FR", "250", "", "11", "78", "783", "48.85029", "2.14523", "Europe/Paris"),("3010720", "Labruguière", "", "FR", "250", "", "76", "81", "812", "43.53858", "2.26392", "Europe/Paris"),("3010815", "La Bresse", "", "FR", "250", "", "44", "88", "881", "47.99974", "6.86499", "Europe/Paris"),("3010905", "La Bouilladisse", "", "FR", "250", "", "93", "13", "133", "43.39619", "5.59307", "Europe/Paris"),("3011307", "La Bassée", "", "FR", "250", "", "32", "59", "595", "50.53424", "2.8062", "Europe/Paris"),("3011312", "Labarthe-sur-Lèze", "", "FR", "250", "", "76", "31", "311", "43.45206", "1.39968", "Europe/Paris"),("3011456", "Kingersheim", "", "FR", "250", "", "44", "68", "684", "47.79259", "7.33491", "Europe/Paris"),("3011988", "Juvisy-sur-Orge", "", "FR", "250", "", "11", "91", "913", "48.68333", "2.38333", "Europe/Paris"),("3012004", "Juvignac", "", "FR", "250", "", "76", "34", "343", "43.61389", "3.81056", "Europe/Paris"),("3012049", "Jurançon", "", "FR", "250", "", "75", "64", "643", "43.2883", "-0.38694", "Europe/Paris"),("3012073", "Jumelles", "", "FR", "250", "", "52", "49", "493", "47.43511", "-0.1037", "Europe/Paris"),("3012124", "Juigné", "", "FR", "250", "", "52", "49", "491", "47.71878", "-0.39405", "Europe/Paris"),("3012162", "Jouy-le-Moutier", "Жуи-ле-Мутье", "FR", "250", "", "11", "95", "953", "49.01068", "2.04028", "Europe/Paris"),("3012165", "Jouy-en-Josas", "", "FR", "250", "", "11", "78", "784", "48.75909", "2.16966", "Europe/Paris"),("3012219", "Joué-lés-Tours", "Жу-ле-Тур", "FR", "250", "", "24", "37", "372", "47.35223", "0.66905", "Europe/Paris"),("3012234", "Jouars-Pontchartrain", "", "FR", "250", "", "11", "78", "782", "48.78888", "1.89898", "Europe/Paris"),("3012303", "Jonage", "", "FR", "250", "", "84", "69", "691", "45.7964", "5.0453", "Europe/Paris"),("3012313", "Joinville-le-Pont", "", "FR", "250", "", "11", "94", "942", "48.82538", "2.47458", "Europe/Paris"),("3012319", "Joigny", "", "FR", "250", "", "27", "89", "891", "47.98288", "3.40096", "Europe/Paris"),("3012322", "Jœuf", "", "FR", "250", "", "44", "54", "541", "49.23333", "6.01667", "Europe/Paris"),("3012346", "Jeumont", "", "FR", "250", "", "32", "59", "591", "50.29658", "4.10108", "Europe/Paris"),("3012417", "Jaunay-Clan", "", "FR", "250", "", "75", "86", "863", "46.68453", "0.37128", "Europe/Paris"),("3012444", "Jassans-Riottier", "", "FR", "250", "", "84", "01", "012", "45.98352", "4.76004", "Europe/Paris"),("3012449", "Jarville-la-Malgrange", "", "FR", "250", "", "44", "54", "543", "48.66907", "6.20636", "Europe/Paris"),("3012467", "Jarny", "", "FR", "250", "", "44", "54", "541", "49.15736", "5.87877", "Europe/Paris"),("3012495", "Janzé", "", "FR", "250", "", "53", "35", "353", "47.95915", "-1.49829", "Europe/Paris"),("3012576", "Jacou", "", "FR", "250", "", "76", "34", "343", "43.66139", "3.91222", "Europe/Paris"),("3012621", "Ivry-sur-Seine", "Иври-сюр-Сен", "FR", "250", "", "11", "94", "941", "48.81568", "2.38487", "Europe/Paris"),("3012638", "Itteville", "", "FR", "250", "", "11", "91", "911", "48.51536", "2.34377", "Europe/Paris"),("3012647", "Istres", "Истра", "FR", "250", "", "93", "13", "134", "43.51667", "4.98333", "Europe/Paris"),("3012649", "Issy-les-Moulineaux", "Исси-ле-Мулино", "FR", "250", "", "11", "92", "923", "48.82104", "2.27718", "Europe/Paris"),("3012655", "Issoudun", "", "FR", "250", "", "24", "36", "364", "46.95", "2", "Europe/Paris"),("3012664", "Issoire", "Иссуар", "FR", "250", "", "84", "63", "633", "45.55", "3.25", "Europe/Paris"),("3012709", "Isle", "", "FR", "250", "", "75", "87", "872", "45.80272", "1.21213", "Europe/Paris"),("3012725", "Isbergues", "", "FR", "250", "", "32", "62", "622", "50.62328", "2.45902", "Europe/Paris"),("3012742", "Irigny", "", "FR", "250", "", "84", "69", "691", "45.67362", "4.81753", "Europe/Paris"),("3012780", "Ingré", "", "FR", "250", "", "24", "45", "452", "47.91995", "1.82778", "Europe/Paris"),("3012829", "Illzach", "", "FR", "250", "", "44", "68", "684", "47.78088", "7.34662", "Europe/Paris"),("3012834", "Illkirch-Graffenstaden", "Ийкирш-Граффанштадан", "FR", "250", "", "44", "67", "676", "48.52894", "7.71523", "Europe/Paris"),("3012848", "Ille-sur-Têt", "", "FR", "250", "", "76", "66", "663", "42.67069", "2.62162", "Europe/Paris"),("3012889", "Igny", "", "FR", "250", "", "11", "91", "913", "48.74437", "2.22428", "Europe/Paris"),("3012903", "Ifs", "", "FR", "250", "", "28", "14", "142", "49.14", "-0.34899", "Europe/Paris"),("3012937", "Hyères", "Иер", "FR", "250", "", "93", "83", "832", "43.11954", "6.13897", "Europe/Paris"),("3012979", "Huningue", "", "FR", "250", "", "44", "68", "684", "47.60477", "7.57782", "Europe/Paris"),("3013082", "Houplines", "", "FR", "250", "", "32", "59", "595", "50.69499", "2.91518", "Europe/Paris"),("3013097", "Houilles", "", "FR", "250", "", "11", "78", "783", "48.92161", "2.19263", "Europe/Paris"),("3013122", "Houdain", "", "FR", "250", "", "32", "62", "622", "50.4504", "2.53777", "Europe/Paris"),("3013155", "Horbourg-Wihr", "", "FR", "250", "", "44", "68", "682", "48.08106", "7.3938", "Europe/Paris"),("3013173", "Honfleur", "", "FR", "250", "", "28", "14", "143", "49.41985", "0.23294", "Europe/Paris"),("3013195", "Homécourt", "", "FR", "250", "", "44", "54", "541", "49.22111", "5.98445", "Europe/Paris"),("3013196", "Hombourg-Haut", "", "FR", "250", "", "44", "57", "573", "49.12359", "6.77397", "Europe/Paris"),("3013226", "Hœnheim", "", "FR", "250", "", "44", "67", "676", "48.62224", "7.75549", "Europe/Paris"),("3013258", "Hirson", "", "FR", "250", "", "32", "02", "025", "49.92262", "4.08259", "Europe/Paris"),("3013350", "Hettange-Grande", "", "FR", "250", "", "44", "57", "577", "49.40639", "6.15057", "Europe/Paris"),("3013380", "Hersin-Coupigny", "", "FR", "250", "", "32", "62", "627", "50.44796", "2.6494", "Europe/Paris"),("3013403", "Hérouville-Saint-Clair", "Эрувиль-Сен-Клер", "FR", "250", "", "28", "14", "142", "49.21088", "-0.30653", "Europe/Paris"),("3013456", "Héricourt", "", "FR", "250", "", "27", "70", "701", "47.57305", "6.76139", "Europe/Paris"),("3013477", "Herblay", "Эрбле", "FR", "250", "", "11", "95", "951", "48.98994", "2.1699", "Europe/Paris"),("3013521", "Hennebont", "", "FR", "250", "", "53", "56", "561", "47.80512", "-3.27337", "Europe/Paris"),("3013525", "Hénin-Beaumont", "Энен-Бомон", "FR", "250", "", "32", "62", "627", "50.41359", "2.96485", "Europe/Paris"),("3013534", "Hendaye", "", "FR", "250", "", "75", "64", "641", "43.37172", "-1.77382", "Europe/Paris"),("3013549", "Hem", "", "FR", "250", "", "32", "59", "595", "50.65256", "3.18681", "Europe/Paris"),("3013585", "Heillecourt", "", "FR", "250", "", "44", "54", "543", "48.65854", "6.20711", "Europe/Paris"),("3013619", "Hazebrouck", "Азбрук", "FR", "250", "", "32", "59", "594", "50.72374", "2.53729", "Europe/Paris"),("3013627", "Hayange", "", "FR", "250", "", "44", "57", "578", "49.33428", "6.05267", "Europe/Paris"),("3013681", "Hautmont", "Отмон", "FR", "250", "", "32", "59", "591", "50.25077", "3.92143", "Europe/Paris"),("3013701", "Yutz", "", "FR", "250", "", "44", "57", "577", "49.35571", "6.1926", "Europe/Paris"),("3013766", "Haute-Goulaine", "", "FR", "250", "", "52", "44", "442", "47.19905", "-1.42941", "Europe/Paris"),("3013862", "Haubourdin", "Обурден", "FR", "250", "", "32", "59", "595", "50.60826", "2.99143", "Europe/Paris"),("3013877", "Hasparren", "", "FR", "250", "", "75", "64", "641", "43.38377", "-1.30499", "Europe/Paris"),("3013908", "Harnes", "", "FR", "250", "", "32", "62", "627", "50.44643", "2.90481", "Europe/Paris"),("3013922", "Harfleur", "", "FR", "250", "", "28", "76", "762", "49.5066", "0.19827", "Europe/Paris"),("3014029", "Ham", "", "FR", "250", "", "32", "80", "804", "49.74721", "3.07301", "Europe/Paris"),("3014034", "Halluin", "Аллюэн", "FR", "250", "", "32", "59", "595", "50.78628", "3.12611", "Europe/Paris"),("3014067", "Haillicourt", "", "FR", "250", "", "32", "62", "622", "50.47519", "2.57458", "Europe/Paris"),("3014078", "Haguenau", "Агно", "FR", "250", "", "44", "67", "672", "48.81557", "7.79051", "Europe/Paris"),("3014080", "Hagondange", "", "FR", "250", "", "44", "57", "574", "49.25134", "6.16812", "Europe/Paris"),("3014143", "Guyancourt", "Гвианкур", "FR", "250", "", "11", "78", "784", "48.77334", "2.07393", "Europe/Paris"),("3014175", "Gujan-Mestras", "", "FR", "250", "", "75", "33", "336", "44.63333", "-1.06667", "Europe/Paris"),("3014195", "Guise", "", "FR", "250", "", "32", "02", "025", "49.90055", "3.62801", "Europe/Paris"),("3014213", "Guipavas", "", "FR", "250", "", "53", "29", "291", "48.43522", "-4.39722", "Europe/Paris"),("3014221", "Guingamp", "", "FR", "250", "", "53", "22", "222", "48.55", "-3.15", "Europe/Paris"),("3014224", "Guînes", "", "FR", "250", "", "32", "62", "626", "50.86708", "1.87025", "Europe/Paris"),("3014277", "Guilherand-Granges", "", "FR", "250", "", "84", "07", "073", "44.93278", "4.87372", "Europe/Paris"),("3014280", "Guilers", "", "FR", "250", "", "53", "29", "291", "48.42545", "-4.55801", "Europe/Paris"),("3014305", "Guichen", "", "FR", "250", "", "53", "35", "352", "47.96762", "-1.79534", "Europe/Paris"),("3014334", "Gueugnon", "", "FR", "250", "", "27", "71", "713", "46.60357", "4.06286", "Europe/Paris"),("3014383", "Guéret", "Гере", "FR", "250", "", "75", "23", "232", "46.16667", "1.86667", "Europe/Paris"),("3014392", "Guérande", "", "FR", "250", "", "52", "44", "443", "47.32911", "-2.42829", "Europe/Paris"),("3014393", "Guer", "", "FR", "250", "", "53", "56", "563", "47.90619", "-2.12314", "Europe/Paris"),("3014407", "Guénange", "", "FR", "250", "", "44", "57", "577", "49.29946", "6.20752", "Europe/Paris"),("3014433", "Guebwiller", "", "FR", "250", "", "44", "68", "683", "47.91667", "7.2", "Europe/Paris"),("3014540", "Groslay", "", "FR", "250", "", "11", "95", "952", "48.98561", "2.34736", "Europe/Paris"),("3014646", "Grigny", "", "FR", "250", "", "11", "91", "912", "48.65412", "2.39343", "Europe/Paris"),("3014647", "Grigny", "", "FR", "250", "", "84", "69", "691", "45.61128", "4.79589", "Europe/Paris"),("3014697", "Gretz-Armainvilliers", "", "FR", "250", "", "11", "77", "772", "48.7412", "2.73105", "Europe/Paris"),("3014728", "Grenoble", "Грeнобль", "FR", "250", "", "84", "38", "381", "45.16667", "5.71667", "Europe/Paris"),("3014739", "Grenay", "", "FR", "250", "", "32", "62", "627", "50.44962", "2.75168", "Europe/Paris"),("3014745", "Grenade", "", "FR", "250", "", "76", "31", "313", "43.76667", "1.28333", "Europe/Paris"),("3014784", "Gray", "", "FR", "250", "", "27", "70", "702", "47.44575", "5.59215", "Europe/Paris"),("3014816", "Gravelines", "", "FR", "250", "", "32", "59", "594", "50.98651", "2.12807", "Europe/Paris"),("3014828", "Graulhet", "", "FR", "250", "", "76", "81", "812", "43.76688", "1.98938", "Europe/Paris"),("3014856", "Grasse", "Грас", "FR", "250", "", "93", "06", "061", "43.66667", "6.91667", "Europe/Paris"),("3014867", "Granville", "", "FR", "250", "", "28", "50", "501", "48.83792", "-1.59714", "Europe/Paris"),("3015126", "Grand-Fort-Philippe", "", "FR", "250", "", "32", "59", "594", "50.99961", "2.10784", "Europe/Paris"),("3015160", "Grande-Synthe", "Гранд-Сент", "FR", "250", "", "32", "59", "594", "51.0154", "2.29975", "Europe/Paris"),("3015267", "Grand-Couronne", "", "FR", "250", "", "28", "76", "763", "49.35563", "1.00647", "Europe/Paris"),("3015292", "Grand-Charmont", "", "FR", "250", "", "27", "25", "252", "47.52674", "6.82604", "Europe/Paris"),("3015419", "Gradignan", "Градиньян", "FR", "250", "", "75", "33", "332", "44.77262", "-0.61393", "Europe/Paris"),("3015424", "Grabels", "", "FR", "250", "", "76", "34", "343", "43.64797", "3.79865", "Europe/Paris"),("3015460", "Gouvieux", "", "FR", "250", "", "32", "60", "604", "49.18705", "2.41439", "Europe/Paris"),("3015490", "Goussainville", "", "FR", "250", "", "11", "95", "952", "49.01367", "2.46595", "Europe/Paris"),("3015507", "Gournay-sur-Marne", "", "FR", "250", "", "11", "93", "932", "48.86223", "2.58452", "Europe/Paris"),("3015509", "Gournay-en-Bray", "", "FR", "250", "", "28", "76", "761", "49.48285", "1.72471", "Europe/Paris"),("3015522", "Gourin", "", "FR", "250", "", "53", "56", "562", "48.13866", "-3.60755", "Europe/Paris"),("3015546", "Gourdon", "", "FR", "250", "", "76", "46", "463", "44.73333", "1.38333", "Europe/Paris"),("3015601", "Gouesnou", "", "FR", "250", "", "53", "29", "291", "48.45267", "-4.46456", "Europe/Paris"),("3015689", "Gonesse", "Гонесс", "FR", "250", "", "11", "95", "952", "48.98693", "2.44892", "Europe/Paris"),("3015741", "Golbey", "", "FR", "250", "", "44", "88", "881", "48.19764", "6.43966", "Europe/Paris"),("3015823", "Gleizé", "", "FR", "250", "", "84", "69", "692", "45.99082", "4.70071", "Europe/Paris"),("3015902", "Givors", "Живор", "FR", "250", "", "84", "69", "691", "45.58415", "4.77256", "Europe/Paris"),("3015904", "Givet", "", "FR", "250", "", "44", "08", "081", "50.13796", "4.82545", "Europe/Paris"),("3015926", "Gisors", "", "FR", "250", "", "28", "27", "271", "49.28178", "1.7801", "Europe/Paris"),("3016070", "Gignac-la-Nerthe", "", "FR", "250", "", "93", "13", "134", "43.39145", "5.23348", "Europe/Paris"),("3016073", "Gignac", "", "FR", "250", "", "76", "34", "342", "43.652", "3.5509", "Europe/Paris"),("3016078", "Gif-sur-Yvette", "Жиф-сюр-Иветт", "FR", "250", "", "11", "91", "913", "48.68333", "2.13333", "Europe/Paris"),("3016089", "Gières", "", "FR", "250", "", "84", "38", "381", "45.18273", "5.79179", "Europe/Paris"),("3016097", "Gien", "", "FR", "250", "", "24", "45", "451", "47.69332", "2.63094", "Europe/Paris"),("3016143", "Gex", "", "FR", "250", "", "84", "01", "013", "46.33333", "6.06667", "Europe/Paris"),("3016177", "Gerzat", "", "FR", "250", "", "84", "63", "632", "45.82432", "3.14404", "Europe/Paris"),("3016274", "Gérardmer", "", "FR", "250", "", "44", "88", "883", "48.07346", "6.87787", "Europe/Paris"),("3016292", "Gentilly", "", "FR", "250", "", "11", "94", "943", "48.81294", "2.3417", "Europe/Paris"),("3016321", "Gennevilliers", "Женвилье", "FR", "250", "", "11", "92", "922", "48.93333", "2.3", "Europe/Paris"),("3016332", "Genlis", "", "FR", "250", "", "27", "21", "212", "47.24203", "5.22415", "Europe/Paris"),("3016387", "Genas", "", "FR", "250", "", "84", "69", "691", "45.73215", "4.99943", "Europe/Paris"),("3016398", "Gémenos", "", "FR", "250", "", "93", "13", "133", "43.29751", "5.62843", "Europe/Paris"),("3016424", "Geispolsheim", "", "FR", "250", "", "44", "67", "676", "48.51658", "7.64667", "Europe/Paris"),("3016524", "Gauchy", "", "FR", "250", "", "32", "02", "023", "49.82765", "3.27371", "Europe/Paris"),("3016621", "Garges-lès-Gonesse", "Гарж-ле-Гонесс", "FR", "250", "", "11", "95", "952", "48.96791", "2.39781", "Europe/Paris"),("3016622", "Gargenville", "", "FR", "250", "", "11", "78", "781", "48.98802", "1.81176", "Europe/Paris"),("3016635", "Garéoult", "", "FR", "250", "", "93", "83", "833", "43.32858", "6.04594", "Europe/Paris"),("3016667", "Gardanne", "", "FR", "250", "", "93", "13", "131", "43.45491", "5.46913", "Europe/Paris"),("3016675", "Garches", "Гарш", "FR", "250", "", "11", "92", "922", "48.84226", "2.18232", "Europe/Paris"),("3016702", "Gap", "", "FR", "250", "", "93", "05", "052", "44.56667", "6.08333", "Europe/Paris"),("3016711", "Gannat", "", "FR", "250", "", "84", "03", "033", "46.10015", "3.19886", "Europe/Paris"),("3016726", "Gan", "", "FR", "250", "", "75", "64", "643", "43.23333", "-0.38333", "Europe/Paris"),("3016807", "Gaillon", "", "FR", "250", "", "28", "27", "271", "49.16104", "1.34016", "Europe/Paris"),("3016817", "Gaillard", "", "FR", "250", "", "84", "74", "743", "46.1853", "6.20693", "Europe/Paris"),("3016824", "Gaillac", "", "FR", "250", "", "76", "81", "811", "43.9016", "1.89686", "Europe/Paris"),("3016830", "Gagny", "", "FR", "250", "", "11", "93", "932", "48.88333", "2.53333", "Europe/Paris"),("3016878", "Fuveau", "", "FR", "250", "", "93", "13", "131", "43.45578", "5.56149", "Europe/Paris"),("3016903", "Fumel", "", "FR", "250", "", "75", "47", "473", "44.49862", "0.96506", "Europe/Paris"),("3016940", "Frouzins", "", "FR", "250", "", "76", "31", "311", "43.51482", "1.32523", "Europe/Paris"),("3016944", "Frouard", "", "FR", "250", "", "44", "54", "543", "48.75998", "6.13163", "Europe/Paris"),("3016956", "Frontignan", "Фронтиньян", "FR", "250", "", "76", "34", "343", "43.44848", "3.754", "Europe/Paris"),("3017059", "Freyming-Merlebach", "", "FR", "250", "", "44", "57", "573", "49.15", "6.78333", "Europe/Paris"),("3017167", "Fresnes-sur-Escaut", "", "FR", "250", "", "32", "59", "596", "50.43382", "3.57752", "Europe/Paris"),("3017178", "Fresnes", "Френ", "FR", "250", "", "11", "94", "943", "48.75568", "2.32241", "Europe/Paris"),("3017253", "Fréjus", "Фрежюс", "FR", "250", "", "93", "83", "831", "43.43286", "6.73524", "Europe/Paris"),("3017341", "Franconville", "", "FR", "250", "", "11", "95", "953", "48.98333", "2.23333", "Europe/Paris"),("3017363", "Francheville", "", "FR", "250", "", "84", "69", "691", "45.73879", "4.77219", "Europe/Paris"),("3017512", "Fourmies", "", "FR", "250", "", "32", "59", "591", "50.01532", "4.04784", "Europe/Paris"),("3017556", "Fouquières-lès-Lens", "", "FR", "250", "", "32", "62", "627", "50.42842", "2.91321", "Europe/Paris"),("3017576", "Foulayronnes", "", "FR", "250", "", "75", "47", "471", "44.24029", "0.64516", "Europe/Paris"),("3017592", "Fouillard", "", "FR", "250", "", "53", "35", "353", "48.1582", "-1.57915", "Europe/Paris"),("3017609", "Fougères", "Фужер", "FR", "250", "", "53", "35", "351", "48.35", "-1.2", "Europe/Paris"),("3017624", "Fouesnant", "", "FR", "250", "", "53", "29", "294", "47.89187", "-4.01484", "Europe/Paris"),("3017651", "Fos-sur-Mer", "", "FR", "250", "", "93", "13", "134", "43.43774", "4.94457", "Europe/Paris"),("3017660", "Fosses", "", "FR", "250", "", "11", "95", "952", "49.09808", "2.50957", "Europe/Paris"),("3017805", "Forbach", "Форбах", "FR", "250", "", "44", "57", "573", "49.18333", "6.9", "Europe/Paris"),("3017902", "Fontenay-Trésigny", "", "FR", "250", "", "11", "77", "773", "48.70647", "2.87047", "Europe/Paris"),("3017910", "Fontenay-sous-Bois", "Фонтене-су-Буа", "FR", "250", "", "11", "94", "942", "48.85442", "2.48268", "Europe/Paris"),("3017919", "Fontenay-le-Fleury", "", "FR", "250", "", "11", "78", "784", "48.81253", "2.04863", "Europe/Paris"),("3017921", "Fontenay-le-Comte", "Фонтене-ле-Конт", "FR", "250", "", "52", "85", "851", "46.46667", "-0.81667", "Europe/Paris"),("3017924", "Fontenay-aux-Roses", "Фонтене-о-Роз", "FR", "250", "", "11", "92", "921", "48.79325", "2.29275", "Europe/Paris"),("3017994", "Fontaines-sur-Saône", "", "FR", "250", "", "84", "69", "691", "45.83377", "4.84834", "Europe/Paris"),("3018032", "Fontaine-lès-Dijon", "", "FR", "250", "", "27", "21", "212", "47.34238", "5.02007", "Europe/Paris"),("3018074", "Fontainebleau", "Фонтенбло", "FR", "250", "", "11", "77", "774", "48.4", "2.7", "Europe/Paris"),("3018095", "Fontaine", "Фонтейн", "FR", "250", "", "84", "38", "381", "45.19839", "5.68265", "Europe/Paris"),("3018103", "Fonsorbes", "", "FR", "250", "", "76", "31", "311", "43.53524", "1.22937", "Europe/Paris"),("3018124", "Fondettes", "", "FR", "250", "", "24", "37", "372", "47.4035", "0.59686", "Europe/Paris"),("3018174", "Foix", "", "FR", "250", "", "76", "09", "091", "42.96667", "1.6", "Europe/Paris"),("3018235", "Florange", "", "FR", "250", "", "44", "57", "578", "49.32373", "6.1212", "Europe/Paris"),("3018246", "Floirac", "", "FR", "250", "", "75", "33", "332", "44.83238", "-0.51411", "Europe/Paris"),("3018257", "Flines-lez-Raches", "", "FR", "250", "", "32", "59", "593", "50.41667", "3.18333", "Europe/Paris"),("3018279", "Fleury-Mérogis", "", "FR", "250", "", "11", "91", "912", "48.6373", "2.36378", "Europe/Paris"),("3018280", "Fleury-les-Aubrais", "", "FR", "250", "", "24", "45", "452", "47.93328", "1.91811", "Europe/Paris"),("3018323", "Fleurance", "", "FR", "250", "", "76", "32", "322", "43.84824", "0.66302", "Europe/Paris"),("3018336", "Flers-en-Escrebieux", "", "FR", "250", "", "32", "59", "593", "50.3979", "3.06038", "Europe/Paris"),("3018339", "Flers", "", "FR", "250", "", "28", "61", "612", "48.73722", "-0.57466", "Europe/Paris"),("3018453", "Fismes", "", "FR", "250", "", "44", "51", "513", "49.30773", "3.68607", "Europe/Paris"),("3018455", "Firminy", "", "FR", "250", "", "84", "42", "423", "45.38732", "4.29074", "Europe/Paris"),("3018506", "Figeac", "", "FR", "250", "", "76", "46", "462", "44.6", "2.03333", "Europe/Paris"),("3018544", "Feyzin", "", "FR", "250", "", "84", "69", "691", "45.66728", "4.85971", "Europe/Paris"),("3018545", "Feytiat", "", "FR", "250", "", "75", "87", "872", "45.80905", "1.33033", "Europe/Paris"),("3018560", "Feurs", "", "FR", "250", "", "84", "42", "421", "45.73988", "4.22706", "Europe/Paris"),("3018650", "Ferrière-la-Grande", "", "FR", "250", "", "32", "59", "591", "50.25521", "3.99288", "Europe/Paris"),("3018679", "Ferney-Voltaire", "", "FR", "250", "", "84", "01", "013", "46.25858", "6.11063", "Europe/Paris"),("3018739", "Fenain", "", "FR", "250", "", "32", "59", "593", "50.36667", "3.3", "Europe/Paris"),("3018778", "Feignies", "", "FR", "250", "", "32", "59", "591", "50.29806", "3.91534", "Europe/Paris"),("3018794", "Fécamp", "Фекан", "FR", "250", "", "28", "76", "762", "49.75787", "0.37457", "Europe/Paris"),("3018903", "Faverges", "", "FR", "250", "", "84", "74", "741", "45.74752", "6.29297", "Europe/Paris"),("3018946", "Faulquemont", "", "FR", "250", "", "44", "57", "571", "49.04711", "6.60314", "Europe/Paris"),("3019044", "Farébersviller", "", "FR", "250", "", "44", "57", "573", "49.11996", "6.87201", "Europe/Paris"),("3019077", "Fameck", "", "FR", "250", "", "44", "57", "578", "49.30335", "6.1086", "Europe/Paris"),("3019113", "Falaise", "", "FR", "250", "", "28", "14", "142", "48.89217", "-0.19527", "Europe/Paris"),("3019153", "Faches-Thumesnil", "", "FR", "250", "", "32", "59", "595", "50.58333", "3.06667", "Europe/Paris"),("3019160", "Fabrègues", "", "FR", "250", "", "76", "34", "343", "43.55057", "3.77637", "Europe/Paris"),("3019175", "Ézanville", "", "FR", "250", "", "11", "95", "952", "49.02794", "2.36787", "Europe/Paris"),("3019193", "Eysines", "", "FR", "250", "", "75", "33", "332", "44.88352", "-0.64686", "Europe/Paris"),("3019219", "Eyguières", "", "FR", "250", "", "93", "13", "132", "43.69481", "5.03131", "Europe/Paris"),("3019238", "Eybens", "", "FR", "250", "", "84", "38", "381", "45.14867", "5.74925", "Europe/Paris"),("3019256", "Évry", "", "FR", "250", "FR", "11", "91", "912", "48.63333", "2.45", "Europe/Paris"),("3019259", "Évron", "", "FR", "250", "", "52", "53", "532", "48.15642", "-0.3997", "Europe/Paris"),("3019265", "Évreux", "Эврё", "FR", "250", "", "28", "27", "273", "49.02414", "1.15082", "Europe/Paris"),("3019280", "Évian-les-Bains", "", "FR", "250", "", "84", "74", "744", "46.40111", "6.58793", "Europe/Paris"),("3019329", "Eu", "", "FR", "250", "", "28", "76", "761", "50.04606", "1.42079", "Europe/Paris"),("3019372", "Étréchy", "", "FR", "250", "", "11", "91", "911", "48.49465", "2.19489", "Europe/Paris"),("3019441", "Étaples", "", "FR", "250", "", "32", "62", "624", "50.52194", "1.63319", "Europe/Paris"),("3019459", "Étampes", "Этамп", "FR", "250", "", "11", "91", "911", "48.43333", "2.15", "Europe/Paris"),("3019578", "Estaires", "", "FR", "250", "", "32", "59", "594", "50.64574", "2.72782", "Europe/Paris"),("3019607", "Essey-lès-Nancy", "", "FR", "250", "", "44", "54", "543", "48.70179", "6.22425", "Europe/Paris"),("3019766", "La Baule-Escoublac", "Ла-Боль", "FR", "250", "", "52", "44", "443", "47.29221", "-2.36395", "Europe/Paris"),("3019827", "Escaudain", "", "FR", "250", "", "32", "59", "596", "50.33315", "3.3443", "Europe/Paris"),("3019843", "Escalquens", "", "FR", "250", "", "76", "31", "313", "43.51744", "1.55893", "Europe/Paris"),("3019854", "Esbly", "", "FR", "250", "", "11", "77", "771", "48.9052", "2.81235", "Europe/Paris"),("3019865", "Erstein", "", "FR", "250", "", "44", "67", "675", "48.42373", "7.66262", "Europe/Paris"),("3019895", "Ernée", "", "FR", "250", "", "52", "53", "533", "48.29764", "-0.93143", "Europe/Paris"),("3019897", "Ermont", "Эрмон", "FR", "250", "", "11", "95", "953", "48.99004", "2.25804", "Europe/Paris"),("3019920", "Ergué-Gabéric", "", "FR", "250", "", "53", "29", "294", "47.99562", "-4.02223", "Europe/Paris"),("3019952", "Éragny", "", "FR", "250", "", "11", "95", "953", "49.01667", "2.1", "Europe/Paris"),("3019960", "Équeurdreville-Hainneville", "", "FR", "250", "", "28", "50", "502", "49.64868", "-1.65306", "Europe/Paris"),("3019985", "Épône", "", "FR", "250", "", "11", "78", "781", "48.95476", "1.82233", "Europe/Paris"),("3020020", "Épinay-sur-Seine", "Эпине-сюр-Сен", "FR", "250", "", "11", "93", "933", "48.9535", "2.31514", "Europe/Paris"),("3020021", "Épinay-sur-Orge", "", "FR", "250", "", "11", "91", "913", "48.67338", "2.31074", "Europe/Paris"),("3020024", "Épinay-sous-Sénart", "", "FR", "250", "", "11", "91", "912", "48.6897", "2.51186", "Europe/Paris"),("3020035", "Épinal", "Эпиналь", "FR", "250", "", "44", "88", "881", "48.18333", "6.45", "Europe/Paris"),("3020057", "Épernon", "", "FR", "250", "", "24", "28", "281", "48.61031", "1.67218", "Europe/Paris"),("3020062", "Épernay", "Эперне", "FR", "250", "", "44", "51", "512", "49.05", "3.95", "Europe/Paris"),("3020142", "Entraigues-sur-la-Sorgue", "", "FR", "250", "", "93", "84", "843", "44", "4.91667", "Europe/Paris"),("3020152", "Ensisheim", "", "FR", "250", "", "44", "68", "683", "47.86695", "7.35212", "Europe/Paris"),("3020188", "Enghien-les-Bains", "", "FR", "250", "", "11", "95", "952", "48.96667", "2.31667", "Europe/Paris"),("3020247", "Émerainville", "", "FR", "250", "", "11", "77", "775", "48.81276", "2.62139", "Europe/Paris"),("3020251", "Embrun", "", "FR", "250", "", "93", "05", "052", "44.56387", "6.49526", "Europe/Paris"),("3020281", "Elne", "", "FR", "250", "", "76", "66", "662", "42.60031", "2.97146", "Europe/Paris"),("3020307", "Elbeuf", "Эльбёф", "FR", "250", "", "28", "76", "763", "49.28669", "1.00288", "Europe/Paris"),("3020310", "Élancourt", "", "FR", "250", "", "11", "78", "782", "48.78421", "1.9552", "Europe/Paris"),("3020330", "Éguilles", "", "FR", "250", "", "93", "13", "131", "43.56867", "5.35575", "Europe/Paris"),("3020346", "Égly", "", "FR", "250", "", "11", "91", "913", "48.57828", "2.22417", "Europe/Paris"),("3020358", "Égletons", "", "FR", "250", "", "75", "19", "192", "45.40336", "2.05073", "Europe/Paris"),("3020392", "Écully", "", "FR", "250", "", "84", "69", "691", "45.77726", "4.77481", "Europe/Paris"),("3020440", "Écouen", "", "FR", "250", "", "11", "95", "952", "49.02062", "2.38309", "Europe/Paris"),("3020489", "Eckbolsheim", "", "FR", "250", "", "44", "67", "676", "48.58075", "7.68768", "Europe/Paris"),("3020495", "Échirolles", "Эшироль", "FR", "250", "", "84", "38", "381", "45.1439", "5.72883", "Europe/Paris"),("3020601", "Eaubonne", "Обонн", "FR", "250", "", "11", "95", "953", "48.99712", "2.28249", "Europe/Paris"),("3020686", "Dunkerque", "Дюнкерк", "FR", "250", "", "32", "59", "594", "51.03297", "2.377", "Europe/Paris"),("3020712", "Dugny", "", "FR", "250", "", "11", "93", "931", "48.95371", "2.41734", "Europe/Paris"),("3020810", "Dreux", "Дрё", "FR", "250", "", "24", "28", "283", "48.73333", "1.36667", "Europe/Paris"),("3020832", "Draveil", "", "FR", "250", "", "11", "91", "912", "48.68466", "2.41418", "Europe/Paris"),("3020839", "Drancy", "Дранси", "FR", "250", "", "11", "93", "931", "48.92578", "2.44533", "Europe/Paris"),("3020850", "Draguignan", "Драгиньян", "FR", "250", "", "93", "83", "831", "43.53333", "6.46667", "Europe/Paris"),("3020886", "Douvrin", "", "FR", "250", "", "32", "62", "622", "50.50916", "2.83053", "Europe/Paris"),("3020887", "Douvres-la-Délivrande", "", "FR", "250", "", "28", "14", "142", "49.29472", "-0.38039", "Europe/Paris"),("3020917", "Dourges", "", "FR", "250", "", "32", "62", "627", "50.43636", "2.98589", "Europe/Paris"),("3020925", "Dourdan", "", "FR", "250", "", "11", "91", "911", "48.52772", "2.01113", "Europe/Paris"),("3020944", "Doullens", "", "FR", "250", "", "32", "80", "802", "50.15724", "2.34019", "Europe/Paris"),("3020964", "Doué-la-Fontaine", "", "FR", "250", "", "52", "49", "493", "47.19372", "-0.27492", "Europe/Paris"),("3020980", "Douchy-les-Mines", "", "FR", "250", "", "32", "59", "596", "50.3008", "3.3927", "Europe/Paris"),("3020996", "Douarnenez", "Дуарнене", "FR", "250", "", "53", "29", "294", "48.09542", "-4.32904", "Europe/Paris"),("3021000", "Douai", "Дуэ", "FR", "250", "", "32", "59", "593", "50.36667", "3.06667", "Europe/Paris"),("3021093", "Donges", "", "FR", "250", "", "52", "44", "443", "47.31824", "-2.07538", "Europe/Paris"),("3021128", "Dompierre-sur-Mer", "", "FR", "250", "", "75", "17", "173", "46.18817", "-1.06351", "Europe/Paris"),("3021150", "Domont", "Домон", "FR", "250", "", "11", "95", "952", "49.02782", "2.32638", "Europe/Paris"),("3021209", "Domérat", "", "FR", "250", "", "84", "03", "031", "46.36064", "2.53426", "Europe/Paris"),("3021210", "Domène", "", "FR", "250", "", "84", "38", "381", "45.20345", "5.83905", "Europe/Paris"),("3021221", "Dombasle-sur-Meurthe", "", "FR", "250", "", "44", "54", "543", "48.6252", "6.34967", "Europe/Paris"),("3021263", "Dole", "Доля", "FR", "250", "", "27", "39", "391", "47.1", "5.5", "Europe/Paris"),("3021264", "Dol-de-Bretagne", "", "FR", "250", "", "53", "35", "354", "48.54765", "-1.75018", "Europe/Paris"),("3021296", "Divonne-les-Bains", "", "FR", "250", "", "84", "01", "013", "46.35938", "6.13574", "Europe/Paris"),("3021298", "Divion", "", "FR", "250", "", "32", "62", "622", "50.47169", "2.50546", "Europe/Paris"),("3021301", "Dives-sur-Mer", "", "FR", "250", "", "28", "14", "143", "49.28176", "-0.10125", "Europe/Paris"),("3021351", "Dinard", "", "FR", "250", "", "53", "35", "354", "48.63143", "-2.06144", "Europe/Paris"),("3021356", "Dinan", "", "FR", "250", "", "53", "22", "221", "48.45", "-2.03333", "Europe/Paris"),("3021372", "Dijon", "Дижон", "FR", "250", "", "27", "21", "212", "47.31667", "5.01667", "Europe/Paris"),("3021377", "Digoin", "", "FR", "250", "", "27", "71", "713", "46.48124", "3.97946", "Europe/Paris"),("3021382", "Digne-les-Bains", "Динь-ле-Бен", "FR", "250", "", "93", "04", "043", "44.09252", "6.23199", "Europe/Paris"),("3021411", "Dieppe", "Дьеп", "FR", "250", "", "28", "76", "761", "49.93333", "1.08333", "Europe/Paris"),("3021484", "Déville-lès-Rouen", "", "FR", "250", "", "28", "76", "763", "49.46942", "1.05214", "Europe/Paris"),("3021516", "Deuil-la-Barre", "Дёй-ла-Барр", "FR", "250", "", "11", "95", "952", "48.97674", "2.32722", "Europe/Paris"),("3021524", "Desvres", "", "FR", "250", "", "32", "62", "623", "50.66884", "1.83478", "Europe/Paris"),("3021570", "Déols", "", "FR", "250", "", "24", "36", "362", "46.82934", "1.70428", "Europe/Paris"),("3021605", "Denain", "Денен", "FR", "250", "", "32", "59", "596", "50.3293", "3.3943", "Europe/Paris"),("3021629", "Delle", "", "FR", "250", "", "27", "90", "901", "47.51048", "6.99963", "Europe/Paris"),("3021661", "Decize", "", "FR", "250", "", "27", "58", "583", "46.82852", "3.46192", "Europe/Paris"),("3021662", "Décines-Charpieu", "", "FR", "250", "", "84", "69", "691", "45.76899", "4.97277", "Europe/Paris"),("3021663", "Dechy", "", "FR", "250", "", "32", "59", "593", "50.35", "3.11667", "Europe/Paris"),("3021664", "Decazeville", "", "FR", "250", "", "76", "12", "123", "44.56045", "2.25091", "Europe/Paris"),("3021670", "Dax", "", "FR", "250", "", "75", "40", "401", "43.71032", "-1.05366", "Europe/Paris"),("3021717", "Darnétal", "", "FR", "250", "", "28", "76", "763", "49.44533", "1.15144", "Europe/Paris"),("3021729", "Dardilly", "", "FR", "250", "", "84", "69", "691", "45.80506", "4.75342", "Europe/Paris"),("3021848", "Dammartin-en-Goële", "", "FR", "250", "", "11", "77", "771", "49.05423", "2.67777", "Europe/Paris"),("3021852", "Dammarie-les-Lys", "", "FR", "250", "", "11", "77", "772", "48.51667", "2.65", "Europe/Paris"),("3021911", "Dainville", "", "FR", "250", "", "32", "62", "621", "50.28097", "2.72603", "Europe/Paris"),("3021993", "Cusset", "", "FR", "250", "", "84", "03", "033", "46.13002", "3.45963", "Europe/Paris"),("3022133", "Cuincy", "", "FR", "250", "", "32", "59", "593", "50.37933", "3.05301", "Europe/Paris"),("3022151", "Cugnaux", "", "FR", "250", "", "76", "31", "313", "43.53635", "1.34428", "Europe/Paris"),("3022158", "Cuers", "", "FR", "250", "", "93", "83", "832", "43.23731", "6.07107", "Europe/Paris"),("3022167", "Cucq", "", "FR", "250", "", "32", "62", "624", "50.47733", "1.62018", "Europe/Paris"),("3022242", "Crozon", "", "FR", "250", "", "53", "29", "292", "48.24643", "-4.48993", "Europe/Paris"),("3022301", "Crosne", "", "FR", "250", "", "11", "91", "912", "48.71921", "2.45728", "Europe/Paris"),("3022331", "Crolles", "", "FR", "250", "", "84", "38", "381", "45.28198", "5.87824", "Europe/Paris"),("3022376", "Croix", "", "FR", "250", "", "32", "59", "595", "50.67846", "3.1493", "Europe/Paris"),("3022380", "Croissy-sur-Seine", "", "FR", "250", "", "11", "78", "783", "48.87925", "2.13836", "Europe/Paris"),("3022513", "Creutzwald", "", "FR", "250", "", "44", "57", "571", "49.2", "6.68333", "Europe/Paris"),("3022530", "Créteil", "Кретей", "FR", "250", "", "11", "94", "941", "48.78333", "2.46667", "Europe/Paris"),("3022540", "Crest", "", "FR", "250", "", "84", "26", "261", "44.72836", "5.02722", "Europe/Paris");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("3022569", "Crépy-en-Valois", "Крепи-ан-Валуа", "FR", "250", "", "32", "60", "604", "49.23359", "2.88807", "Europe/Paris"),("3022610", "Creil", "Крей", "FR", "250", "", "32", "60", "604", "49.25672", "2.48477", "Europe/Paris"),("3022683", "Craponne", "", "FR", "250", "", "84", "69", "691", "45.74684", "4.72661", "Europe/Paris"),("3022690", "Craon", "", "FR", "250", "", "52", "53", "531", "47.84687", "-0.94929", "Europe/Paris"),("3022700", "Cran-Gevrier", "", "FR", "250", "", "84", "74", "741", "45.9", "6.1", "Europe/Paris"),("3022751", "Couzeix", "", "FR", "250", "", "75", "87", "872", "45.87047", "1.23828", "Europe/Paris"),("3022799", "Coutras", "", "FR", "250", "", "75", "33", "335", "45.03333", "-0.13333", "Europe/Paris"),("3022826", "Coutances", "", "FR", "250", "", "28", "50", "503", "49.05", "-1.43333", "Europe/Paris"),("3022868", "Courtry", "", "FR", "250", "", "11", "77", "775", "48.91906", "2.60431", "Europe/Paris"),("3022897", "Courthézon", "", "FR", "250", "", "93", "84", "842", "44.08731", "4.88382", "Europe/Paris"),("3022956", "Coursan", "", "FR", "250", "", "76", "11", "113", "43.2337", "3.05712", "Europe/Paris"),("3022969", "Courrières", "", "FR", "250", "", "32", "62", "627", "50.45701", "2.94725", "Europe/Paris"),("3022986", "Cournonterral", "", "FR", "250", "", "76", "34", "343", "43.55889", "3.72", "Europe/Paris"),("3022988", "Cournon-d’Auvergne", "", "FR", "250", "", "84", "63", "632", "45.73543", "3.19608", "Europe/Paris"),("3023044", "Courdimanche", "", "FR", "250", "", "11", "95", "953", "49.03513", "2.00096", "Europe/Paris"),("3023056", "Courcouronnes", "", "FR", "250", "", "11", "91", "912", "48.61429", "2.40762", "Europe/Paris"),("3023097", "Courcelles-lès-Lens", "", "FR", "250", "", "32", "62", "627", "50.41667", "3.01667", "Europe/Paris"),("3023141", "Courbevoie", "Курбевуа", "FR", "250", "", "11", "92", "922", "48.89672", "2.25666", "Europe/Paris"),("3023214", "Coulounieix-Chamiers", "", "FR", "250", "", "75", "24", "243", "45.15289", "0.68852", "Europe/Paris"),("3023240", "Coulommiers", "", "FR", "250", "", "11", "77", "771", "48.81451", "3.08498", "Europe/Paris"),("3023254", "Coulogne", "", "FR", "250", "", "32", "62", "626", "50.92463", "1.88137", "Europe/Paris"),("3023291", "Coulaines", "", "FR", "250", "", "52", "72", "723", "48.02409", "0.20411", "Europe/Paris"),("3023324", "Couëron", "", "FR", "250", "", "52", "44", "442", "47.21508", "-1.72171", "Europe/Paris"),("3023356", "Coudekerque-Branche", "Кудкерк-Бранш", "FR", "250", "", "32", "59", "594", "51.02288", "2.39359", "Europe/Paris"),("3023476", "Cosne-Cours-sur-Loire", "", "FR", "250", "FR", "27", "58", "584", "47.41101", "2.92528", "Europe/Paris"),("3023506", "Corte", "", "FR", "250", "", "94", "2B", "2B3", "42.30956", "9.14917", "Europe/Paris"),("3023606", "Cornebarrieu", "", "FR", "250", "", "76", "31", "313", "43.64895", "1.32407", "Europe/Paris"),("3023628", "Cormontreuil", "", "FR", "250", "", "44", "51", "513", "49.21667", "4.05", "Europe/Paris"),("3023645", "Cormeilles-en-Parisis", "Кормей-ан-Паризи", "FR", "250", "", "11", "95", "951", "48.97111", "2.20491", "Europe/Paris"),("3023742", "Corbie", "", "FR", "250", "", "32", "80", "802", "49.90672", "2.50682", "Europe/Paris"),("3023763", "Corbeil-Essonnes", "Корбей-Эссон", "FR", "250", "", "11", "91", "912", "48.60603", "2.48757", "Europe/Paris"),("3023771", "Corbas", "", "FR", "250", "", "84", "69", "691", "45.6679", "4.89627", "Europe/Paris"),("3023842", "Contes", "", "FR", "250", "", "93", "06", "062", "43.81278", "7.31444", "Europe/Paris"),("3023924", "Conflans-Sainte-Honorine", "Конфлан-Сент-Онорин", "FR", "250", "", "11", "78", "783", "49.00158", "2.09694", "Europe/Paris"),("3023943", "Condom", "", "FR", "250", "", "76", "32", "322", "43.95816", "0.37199", "Europe/Paris"),("3023953", "Condé-sur-Noireau", "", "FR", "250", "", "28", "14", "144", "48.84881", "-0.55214", "Europe/Paris"),("3023955", "Condé-sur-l’Escaut", "", "FR", "250", "", "32", "59", "596", "50.45436", "3.58884", "Europe/Paris"),("3024035", "Concarneau", "Конкарно", "FR", "250", "", "53", "29", "294", "47.87502", "-3.92245", "Europe/Paris"),("3024066", "Compiègne", "Компьень", "FR", "250", "", "32", "60", "603", "49.41794", "2.82606", "Europe/Paris"),("3024086", "Commercy", "", "FR", "250", "", "44", "55", "552", "48.76128", "5.59067", "Europe/Paris"),("3024090", "Commentry", "", "FR", "250", "", "84", "03", "031", "46.29211", "2.7416", "Europe/Paris"),("3024102", "Comines", "", "FR", "250", "", "32", "59", "595", "50.7615", "3.01063", "Europe/Paris"),("3024107", "Combs-la-Ville", "", "FR", "250", "", "11", "77", "772", "48.66497", "2.56957", "Europe/Paris"),("3024137", "Combourg", "", "FR", "250", "", "53", "35", "354", "48.41267", "-1.74424", "Europe/Paris"),("3024195", "Pontault-Combault", "", "FR", "250", "", "11", "77", "775", "48.79813", "2.60676", "Europe/Paris"),("3024223", "Colomiers", "", "FR", "250", "", "76", "31", "313", "43.61058", "1.33467", "Europe/Paris"),("3024266", "Colombes", "Коломб", "FR", "250", "", "11", "92", "922", "48.91882", "2.25404", "Europe/Paris"),("3024267", "Colombelles", "", "FR", "250", "", "28", "14", "142", "49.2049", "-0.29571", "Europe/Paris"),("3024297", "Colmar", "Кольмар", "FR", "250", "", "44", "68", "682", "48.08333", "7.36667", "Europe/Paris"),("3024421", "Cogolin", "", "FR", "250", "", "93", "83", "831", "43.25221", "6.53002", "Europe/Paris"),("3024426", "Cognin", "", "FR", "250", "", "84", "73", "732", "45.56377", "5.89435", "Europe/Paris"),("3024440", "Cognac", "Коньяк", "FR", "250", "", "75", "16", "162", "45.7", "-0.33333", "Europe/Paris"),("3024532", "Cluses", "", "FR", "250", "", "84", "74", "742", "46.06251", "6.57497", "Europe/Paris"),("3024578", "Clisson", "", "FR", "250", "", "52", "44", "442", "47.08714", "-1.28286", "Europe/Paris"),("3024596", "Clichy-sous-Bois", "Клиши-су-Буа", "FR", "250", "", "11", "93", "932", "48.9102", "2.55323", "Europe/Paris"),("3024597", "Clichy", "Клиши", "FR", "250", "", "11", "92", "922", "48.90018", "2.30952", "Europe/Paris"),("3024635", "Clermont-Ferrand", "Клермон-Ферран", "FR", "250", "", "84", "63", "632", "45.77966", "3.08628", "Europe/Paris"),("3024643", "Clermont", "", "FR", "250", "", "32", "60", "602", "49.38333", "2.4", "Europe/Paris"),("3024669", "Cléon", "", "FR", "250", "", "28", "76", "763", "49.31235", "1.0295", "Europe/Paris"),("3024701", "Claye-Souilly", "", "FR", "250", "", "11", "77", "775", "48.94492", "2.68566", "Europe/Paris"),("3024759", "Clapiers", "", "FR", "250", "", "76", "34", "343", "43.65833", "3.88917", "Europe/Paris"),("3024783", "Clamart", "Кламар", "FR", "250", "", "11", "92", "921", "48.80299", "2.26692", "Europe/Paris"),("3024788", "Claix", "", "FR", "250", "", "84", "38", "381", "45.12254", "5.67481", "Europe/Paris"),("3024865", "Varennes-Vauzelles", "", "FR", "250", "", "27", "58", "583", "47.01678", "3.14037", "Europe/Paris"),("3024979", "Ciboure", "", "FR", "250", "", "75", "64", "641", "43.38287", "-1.676", "Europe/Paris"),("3025053", "Cholet", "Шоле", "FR", "250", "", "52", "49", "492", "47.06667", "-0.88333", "Europe/Paris"),("3025055", "Choisy-le-Roi", "Шуази-ле-Руа", "FR", "250", "", "11", "94", "941", "48.76846", "2.41874", "Europe/Paris"),("3025132", "Chinon", "", "FR", "250", "", "24", "37", "371", "47.16667", "0.25", "Europe/Paris"),("3025144", "Chilly-Mazarin", "", "FR", "250", "", "11", "91", "913", "48.71489", "2.31638", "Europe/Paris"),("3025294", "Chevreuse", "", "FR", "250", "", "11", "78", "782", "48.70662", "2.03329", "Europe/Paris"),("3025314", "Chevilly-Larue", "Шевильи-Ларю", "FR", "250", "", "11", "94", "943", "48.76476", "2.3503", "Europe/Paris"),("3025324", "Chevigny-Saint-Sauveur", "", "FR", "250", "", "27", "21", "212", "47.29908", "5.13367", "Europe/Paris"),("3025466", "Cherbourg-Octeville", "Шербур-Октевиль", "FR", "250", "", "28", "50", "502", "49.63984", "-1.61636", "Europe/Paris"),("3025496", "Chenôve", "", "FR", "250", "", "27", "21", "212", "47.29323", "5.00457", "Europe/Paris"),("3025509", "Chennevières-sur-Marne", "", "FR", "250", "", "11", "94", "942", "48.79702", "2.54046", "Europe/Paris"),("3025602", "Chemillé-Melay", "", "FR", "250", "", "52", "49", "492", "47.21476", "-0.72488", "Europe/Paris"),("3025622", "Chelles", "", "FR", "250", "", "11", "77", "775", "48.88109", "2.59295", "Europe/Paris"),("3025650", "Chécy", "", "FR", "250", "", "24", "45", "452", "47.89402", "2.02304", "Europe/Paris"),("3025715", "Chaville", "Шавиль", "FR", "250", "", "11", "92", "923", "48.80565", "2.18864", "Europe/Paris"),("3025809", "Chauvigny", "", "FR", "250", "", "75", "86", "862", "46.56747", "0.64928", "Europe/Paris"),("3025860", "Chauny", "", "FR", "250", "", "32", "02", "022", "49.61514", "3.21857", "Europe/Paris"),("3025892", "Chaumont", "Шомон", "FR", "250", "", "44", "52", "521", "48.11121", "5.14134", "Europe/Paris"),("3026033", "Chatou", "Шату", "FR", "250", "", "11", "78", "783", "48.8898", "2.15863", "Europe/Paris"),("3026046", "Châtillon-sur-Seine", "", "FR", "250", "", "27", "21", "213", "47.85851", "4.57375", "Europe/Paris"),("3026047", "Châtillon-sur-Seiche", "", "FR", "250", "", "53", "35", "353", "48.03448", "-1.67114", "Europe/Paris"),("3026083", "Châtillon", "", "FR", "250", "", "11", "92", "921", "48.8024", "2.29346", "Europe/Paris"),("3026094", "Châtenoy-le-Royal", "", "FR", "250", "", "27", "71", "712", "46.79797", "4.8119", "Europe/Paris"),("3026108", "Châtenay-Malabry", "Шатне-Малабри", "FR", "250", "", "11", "92", "921", "48.76507", "2.26655", "Europe/Paris"),("3026141", "Châtellerault", "Шательро", "FR", "250", "", "75", "86", "861", "46.8", "0.53333", "Europe/Paris"),("3026145", "Châtel-Guyon", "", "FR", "250", "", "84", "63", "634", "45.91667", "3.06667", "Europe/Paris"),("3026172", "Châtelaillon-Plage", "", "FR", "250", "", "75", "17", "173", "46.0719", "-1.08926", "Europe/Paris"),("3026194", "Château-Thierry", "Шато-Тьерри", "FR", "250", "", "32", "02", "021", "49.05", "3.4", "Europe/Paris"),("3026204", "Châteauroux", "Шатору", "FR", "250", "", "24", "36", "362", "46.81667", "1.7", "Europe/Paris"),("3026208", "Château-Renault", "", "FR", "250", "", "24", "37", "372", "47.59188", "0.91143", "Europe/Paris"),("3026211", "Châteaurenard", "", "FR", "250", "", "93", "13", "132", "43.88169", "4.85493", "Europe/Paris"),("3026222", "Châteauneuf-sur-Loire", "", "FR", "250", "", "24", "45", "452", "47.86575", "2.21903", "Europe/Paris"),("3026227", "Châteauneuf-les-Martigues", "", "FR", "250", "", "93", "13", "134", "43.38333", "5.16667", "Europe/Paris"),("3026262", "Châteaulin", "", "FR", "250", "", "53", "29", "292", "48.2", "-4.08333", "Europe/Paris"),("3026273", "Château-Gontier", "", "FR", "250", "", "52", "53", "531", "47.83333", "-0.7", "Europe/Paris"),("3026275", "Châteaugiron", "", "FR", "250", "", "53", "35", "353", "48.04629", "-1.50438", "Europe/Paris"),("3026285", "Châteaudun", "Шатодён", "FR", "250", "", "24", "28", "282", "48.08333", "1.33333", "Europe/Paris"),("3026286", "Château-du-Loir", "", "FR", "250", "", "52", "72", "721", "47.69492", "0.41851", "Europe/Paris"),("3026291", "Château-d’Olonne", "", "FR", "250", "", "52", "85", "853", "46.50382", "-1.74097", "Europe/Paris"),("3026303", "Châteaubriant", "", "FR", "250", "", "52", "44", "441", "47.71667", "-1.38333", "Europe/Paris"),("3026306", "Châteaubourg", "", "FR", "250", "", "53", "35", "351", "48.11119", "-1.40019", "Europe/Paris"),("3026374", "Chassieu", "", "FR", "250", "", "84", "69", "691", "45.74584", "4.97088", "Europe/Paris"),("3026384", "Chasse-sur-Rhône", "", "FR", "250", "", "84", "38", "383", "45.58339", "4.79823", "Europe/Paris"),("3026451", "Charvieu-Chavagneux", "", "FR", "250", "", "84", "38", "383", "45.75", "5.15", "Europe/Paris"),("3026465", "Chartres-de-Bretagne", "", "FR", "250", "", "53", "35", "353", "48.03924", "-1.70533", "Europe/Paris"),("3026467", "Chartres", "Шартр", "FR", "250", "", "24", "28", "281", "48.44685", "1.48925", "Europe/Paris"),("3026534", "Charnay-lès-Mâcon", "", "FR", "250", "", "27", "71", "715", "46.30751", "4.78479", "Europe/Paris"),("3026613", "Charleville-Mézières", "Шарлевиль-Мезьер", "FR", "250", "", "44", "08", "081", "49.76667", "4.71667", "Europe/Paris"),("3026637", "Charenton-le-Pont", "Шарантон-ле-Пон", "FR", "250", "", "11", "94", "941", "48.82209", "2.41217", "Europe/Paris"),("3026757", "Chaponost", "", "FR", "250", "", "84", "69", "691", "45.70592", "4.74441", "Europe/Paris"),("3026823", "Chantonnay", "", "FR", "250", "", "52", "85", "852", "46.68702", "-1.05024", "Europe/Paris"),("3026827", "Chantilly", "", "FR", "250", "", "32", "60", "604", "49.19461", "2.47124", "Europe/Paris"),("3026842", "Chantepie", "", "FR", "250", "", "53", "35", "353", "48.08885", "-1.61524", "Europe/Paris"),("3026862", "Chanteloup-les-Vignes", "", "FR", "250", "", "11", "78", "783", "48.97614", "2.03261", "Europe/Paris"),("3026940", "Changé", "", "FR", "250", "", "52", "53", "532", "48.09918", "-0.79292", "Europe/Paris"),("3026941", "Changé", "", "FR", "250", "", "52", "72", "723", "47.98499", "0.28328", "Europe/Paris"),("3027014", "Champs-sur-Marne", "Шан-сюр-Марн", "FR", "250", "", "11", "77", "775", "48.85", "2.6", "Europe/Paris"),("3027105", "Champigny-sur-Marne", "Шампиньи-сюр-Марн", "FR", "250", "", "11", "94", "942", "48.81642", "2.49366", "Europe/Paris"),("3027126", "Champigneulles", "", "FR", "250", "", "44", "54", "543", "48.73419", "6.16417", "Europe/Paris"),("3027235", "Champagnole", "", "FR", "250", "", "27", "39", "392", "46.74452", "5.91354", "Europe/Paris"),("3027242", "Champagne-sur-Seine", "", "FR", "250", "", "11", "77", "774", "48.39794", "2.79785", "Europe/Paris"),("3027301", "Chamonix-Mont-Blanc", "", "FR", "250", "", "84", "74", "742", "45.92375", "6.86933", "Europe/Paris"),("3027343", "Chambray-lès-Tours", "", "FR", "250", "", "24", "37", "372", "47.33537", "0.70286", "Europe/Paris"),("3027351", "Chambourcy", "", "FR", "250", "", "11", "78", "783", "48.90655", "2.041", "Europe/Paris"),("3027397", "Chambly", "", "FR", "250", "", "32", "60", "604", "49.16667", "2.25", "Europe/Paris"),("3027422", "Chambéry", "Шамбери", "FR", "250", "", "84", "73", "732", "45.56667", "5.93333", "Europe/Paris"),("3027453", "Chamalières", "Шамальер", "FR", "250", "", "84", "63", "632", "45.77559", "3.0631", "Europe/Paris"),("3027484", "Chalon-sur-Saône", "Шалон-сюр-Сон", "FR", "250", "", "27", "71", "712", "46.78333", "4.85", "Europe/Paris"),("3027487", "Châlons-en-Champagne", "Шалон-ан-Шампань", "FR", "250", "", "44", "51", "511", "48.95393", "4.36724", "Europe/Paris"),("3027491", "Chalonnes-sur-Loire", "", "FR", "250", "", "52", "49", "491", "47.3516", "-0.7631", "Europe/Paris"),("3027513", "Challans", "", "FR", "250", "", "52", "85", "853", "46.84363", "-1.87491", "Europe/Paris"),("3027531", "Châlette-sur-Loing", "", "FR", "250", "", "24", "45", "451", "48.01337", "2.73587", "Europe/Paris"),("3027642", "Chagny", "", "FR", "250", "", "27", "71", "712", "46.90953", "4.7519", "Europe/Paris"),("3027705", "Chabeuil", "", "FR", "250", "", "84", "26", "263", "44.89963", "5.01884", "Europe/Paris"),("3027746", "Ceyrat", "", "FR", "250", "", "84", "63", "632", "45.73176", "3.06335", "Europe/Paris"),("3027763", "Cestas", "", "FR", "250", "", "75", "33", "332", "44.74345", "-0.67905", "Europe/Paris"),("3027767", "Cesson-Sévigné", "", "FR", "250", "", "53", "35", "353", "48.1212", "-1.603", "Europe/Paris"),("3027768", "Cesson", "", "FR", "250", "", "11", "77", "772", "48.56204", "2.60816", "Europe/Paris"),("3027857", "Cernay", "", "FR", "250", "", "44", "68", "686", "47.8097", "7.17699", "Europe/Paris"),("3027883", "Cergy", "Сержи", "FR", "250", "", "11", "95", "953", "49.03645", "2.07613", "Europe/Paris"),("3027888", "Ceret", "", "FR", "250", "", "76", "66", "661", "42.48533", "2.74804", "Europe/Paris"),("3027950", "Cenon", "Сенон", "FR", "250", "", "75", "33", "332", "44.8559", "-0.51839", "Europe/Paris"),("3028028", "Cébazat", "", "FR", "250", "", "84", "63", "632", "45.83405", "3.10048", "Europe/Paris"),("3028129", "Cavalaire-sur-Mer", "", "FR", "250", "", "93", "83", "831", "43.17403", "6.52715", "Europe/Paris"),("3028134", "Cavaillon", "Кавайон", "FR", "250", "", "93", "84", "841", "43.83125", "5.03586", "Europe/Paris"),("3028162", "Caussade", "", "FR", "250", "", "76", "82", "822", "44.1608", "1.53913", "Europe/Paris"),("3028205", "Caudry", "", "FR", "250", "", "32", "59", "592", "50.1249", "3.41186", "Europe/Paris"),("3028214", "Caudebec-lès-Elbeuf", "", "FR", "250", "", "28", "76", "763", "49.28082", "1.02195", "Europe/Paris"),("3028217", "Caudan", "", "FR", "250", "", "53", "56", "561", "47.80877", "-3.3425", "Europe/Paris"),("3028258", "Castries", "", "FR", "250", "", "76", "34", "343", "43.67972", "3.98222", "Europe/Paris"),("3028263", "Castres", "Кастр", "FR", "250", "", "76", "81", "812", "43.6", "2.25", "Europe/Paris"),("3028322", "Castelsarrasin", "", "FR", "250", "", "76", "82", "821", "44.03333", "1.1", "Europe/Paris"),("3028337", "Castelnau-le-Lez", "", "FR", "250", "", "76", "34", "343", "43.63333", "3.9", "Europe/Paris"),("3028351", "Castelnaudary", "", "FR", "250", "", "76", "11", "111", "43.31829", "1.95449", "Europe/Paris"),("3028387", "Casteljaloux", "", "FR", "250", "", "75", "47", "474", "44.31762", "0.08605", "Europe/Paris"),("3028388", "Castelginest", "", "FR", "250", "", "76", "31", "313", "43.69382", "1.4344", "Europe/Paris"),("3028409", "Castanet-Tolosan", "", "FR", "250", "", "76", "31", "313", "43.51591", "1.49864", "Europe/Paris"),("3028431", "Cassis", "", "FR", "250", "", "93", "13", "133", "43.21241", "5.5451", "Europe/Paris"),("3028486", "Carvin", "Карвен", "FR", "250", "", "32", "62", "627", "50.49235", "2.95815", "Europe/Paris"),("3028510", "Carry-le-Rouet", "", "FR", "250", "", "93", "13", "134", "43.33139", "5.15237", "Europe/Paris"),("3028513", "Carros", "", "FR", "250", "", "93", "06", "061", "43.78941", "7.18395", "Europe/Paris"),("3028520", "Carrières-sur-Seine", "", "FR", "250", "", "11", "78", "783", "48.90687", "2.1792", "Europe/Paris"),("3028521", "Carrières-sous-Poissy", "", "FR", "250", "", "11", "78", "783", "48.94952", "2.04068", "Europe/Paris"),("3028534", "Carqueiranne", "", "FR", "250", "", "93", "83", "832", "43.09531", "6.07297", "Europe/Paris"),("3028535", "Carquefou", "", "FR", "250", "", "52", "44", "442", "47.29821", "-1.49024", "Europe/Paris"),("3028542", "Carpentras", "Карпантрас", "FR", "250", "", "93", "84", "843", "44.05", "5.05", "Europe/Paris"),("3028580", "Carmaux", "", "FR", "250", "", "76", "81", "811", "44.05099", "2.15795", "Europe/Paris"),("3028603", "Carhaix-Plouguer", "", "FR", "250", "", "53", "29", "292", "48.27594", "-3.57326", "Europe/Paris"),("3028610", "Carentan", "", "FR", "250", "", "28", "50", "504", "49.30312", "-1.24806", "Europe/Paris"),("3028641", "Carcassonne", "Каркасон", "FR", "250", "", "76", "11", "111", "43.21667", "2.35", "Europe/Paris"),("3028653", "Carbon-Blanc", "", "FR", "250", "", "75", "33", "332", "44.89642", "-0.50107", "Europe/Paris"),("3028690", "Cappelle-la-Grande", "", "FR", "250", "", "32", "59", "594", "50.99979", "2.35848", "Europe/Paris"),("3028745", "Capbreton", "", "FR", "250", "", "75", "40", "401", "43.64216", "-1.42816", "Europe/Paris"),("3028779", "Canteleu", "", "FR", "250", "", "28", "76", "763", "49.44065", "1.02459", "Europe/Paris"),("3028808", "Cannes", "Канны", "FR", "250", "", "93", "06", "061", "43.55135", "7.01275", "Europe/Paris"),("3028832", "Canet-en-Roussillon", "", "FR", "250", "", "76", "66", "662", "42.7", "3.01667", "Europe/Paris"),("3028838", "Canéjan", "", "FR", "250", "", "75", "33", "332", "44.76667", "-0.63333", "Europe/Paris"),("3028868", "Cancale", "", "FR", "250", "", "53", "35", "354", "48.67601", "-1.85231", "Europe/Paris"),("3029030", "Cambrai", "Камбре", "FR", "250", "", "32", "59", "592", "50.16667", "3.23333", "Europe/Paris"),("3029090", "Calvi", "", "FR", "250", "", "94", "2B", "2B5", "42.56604", "8.75713", "Europe/Paris"),("3029096", "Caluire-et-Cuire", "", "FR", "250", "", "84", "69", "691", "45.79041", "4.84112", "Europe/Paris"),("3029099", "Calonne-Ricouart", "", "FR", "250", "", "32", "62", "622", "50.48504", "2.47335", "Europe/Paris"),("3029162", "Calais", "Кале", "FR", "250", "", "32", "62", "626", "50.95194", "1.85635", "Europe/Paris"),("3029213", "Cahors", "Каор", "FR", "250", "", "76", "46", "461", "44.4491", "1.43663", "Europe/Paris"),("3029227", "Cagnes-sur-Mer", "Кань-сюр-Мер", "FR", "250", "", "93", "06", "061", "43.66459", "7.15339", "Europe/Paris"),("3029241", "Caen", "Кан", "FR", "250", "", "28", "14", "142", "49.18585", "-0.35912", "Europe/Paris"),("3029276", "Cachan", "Кашан", "FR", "250", "", "11", "94", "943", "48.79632", "2.33661", "Europe/Paris"),("3029283", "Cabriès", "", "FR", "250", "", "93", "13", "131", "43.44127", "5.37884", "Europe/Paris"),("3029302", "Cabestany", "", "FR", "250", "", "76", "66", "662", "42.68132", "2.94122", "Europe/Paris"),("3029365", "Buxerolles", "", "FR", "250", "", "75", "86", "863", "46.61667", "0.48333", "Europe/Paris"),("3029392", "Bussy-Saint-Georges", "", "FR", "250", "", "11", "77", "775", "48.84099", "2.70165", "Europe/Paris"),("3029522", "Bures-sur-Yvette", "", "FR", "250", "", "11", "91", "913", "48.69981", "2.17064", "Europe/Paris"),("3029566", "Bully-les-Mines", "", "FR", "250", "", "32", "62", "627", "50.4438", "2.72703", "Europe/Paris"),("3029695", "Buc", "", "FR", "250", "", "11", "78", "784", "48.77627", "2.12577", "Europe/Paris"),("3029706", "Bry-sur-Marne", "Бри-сюр-Марн", "FR", "250", "", "11", "94", "942", "48.83811", "2.52488", "Europe/Paris"),("3029713", "Bruz", "", "FR", "250", "", "53", "35", "353", "48.0242", "-1.74591", "Europe/Paris"),("3029746", "Brunstatt", "", "FR", "250", "", "44", "68", "684", "47.72004", "7.31784", "Europe/Paris"),("3029748", "Brunoy", "Брюнуа", "FR", "250", "", "11", "91", "912", "48.6942", "2.49223", "Europe/Paris"),("3029771", "Brumath", "", "FR", "250", "", "44", "67", "676", "48.73014", "7.7121", "Europe/Paris"),("3029799", "Bruges", "", "FR", "250", "", "75", "33", "332", "44.87981", "-0.61219", "Europe/Paris"),("3029824", "Bruay-sur-l’Escaut", "", "FR", "250", "", "32", "59", "596", "50.39918", "3.54379", "Europe/Paris"),("3029825", "Bruay-la-Buissière", "Брюэ-ла-Бюисьер", "FR", "250", "", "32", "62", "622", "50.48333", "2.55", "Europe/Paris"),("3029931", "Bron", "Брон", "FR", "250", "", "84", "69", "691", "45.73333", "4.91667", "Europe/Paris"),("3029974", "Brive-la-Gaillarde", "Бриве-ла-Гаилларде", "FR", "250", "", "75", "19", "191", "45.15", "1.53333", "Europe/Paris"),("3029995", "Brioude", "", "FR", "250", "", "84", "43", "431", "45.3", "3.4", "Europe/Paris"),("3030057", "Brignoles", "Бриньоль", "FR", "250", "", "93", "83", "833", "43.4", "6.06667", "Europe/Paris"),("3030063", "Brignais", "", "FR", "250", "", "84", "69", "691", "45.67358", "4.75484", "Europe/Paris"),("3030071", "Briey", "", "FR", "250", "", "44", "54", "541", "49.25", "5.93333", "Europe/Paris"),("3030101", "Brie-Comte-Robert", "", "FR", "250", "", "11", "77", "772", "48.69247", "2.6109", "Europe/Paris"),("3030132", "Briare", "", "FR", "250", "", "24", "45", "451", "47.63343", "2.7438", "Europe/Paris"),("3030142", "Briançon", "", "FR", "250", "", "93", "05", "051", "44.89978", "6.64201", "Europe/Paris"),("3030203", "Breuillet", "", "FR", "250", "", "11", "91", "911", "48.57064", "2.17424", "Europe/Paris"),("3030257", "Brétigny-sur-Orge", "", "FR", "250", "", "11", "91", "913", "48.61135", "2.30593", "Europe/Paris"),("3030300", "Brest", "Брест", "FR", "250", "", "53", "29", "291", "48.4", "-4.48333", "Europe/Paris"),("3030303", "Bressuire", "Брессюир", "FR", "250", "", "75", "79", "791", "46.85", "-0.48333", "Europe/Paris"),("3030440", "Brech", "", "FR", "250", "", "53", "56", "561", "47.72134", "-2.99862", "Europe/Paris"),("3030787", "Boussy-Saint-Antoine", "", "FR", "250", "", "11", "91", "912", "48.69101", "2.5306", "Europe/Paris"),("3030949", "Bourg-Saint-Maurice", "", "FR", "250", "", "84", "73", "731", "45.61716", "6.76902", "Europe/Paris"),("3030953", "Bourg-Saint-Andéol", "", "FR", "250", "", "84", "07", "072", "44.37566", "4.64273", "Europe/Paris"),("3030960", "Bourgoin", "", "FR", "250", "", "84", "38", "382", "45.58333", "5.28333", "Europe/Paris"),("3030985", "Bourg-lès-Valence", "", "FR", "250", "", "84", "26", "263", "44.95601", "4.91023", "Europe/Paris"),("3030990", "Bourg-la-Reine", "", "FR", "250", "", "11", "92", "921", "48.77888", "2.31781", "Europe/Paris"),("3031005", "Bourges", "Бурж", "FR", "250", "", "24", "18", "181", "47.08333", "2.4", "Europe/Paris"),("3031009", "Bourg-en-Bresse", "Бурк-ан-Брес", "FR", "250", "", "84", "01", "012", "46.20574", "5.2258", "Europe/Paris"),("3031020", "Bourg-de-Péage", "", "FR", "250", "", "84", "26", "263", "45.02825", "5.07162", "Europe/Paris"),("3031085", "Bourbourg", "", "FR", "250", "", "32", "59", "594", "50.94783", "2.19576", "Europe/Paris"),("3031090", "Bourbon-Lancy", "", "FR", "250", "", "27", "71", "713", "46.62214", "3.76953", "Europe/Paris"),("3031133", "Boulogne-sur-Mer", "Булонь-сюр-Мер", "FR", "250", "", "32", "62", "623", "50.71667", "1.61667", "Europe/Paris"),("3031137", "Boulogne-Billancourt", "Булонь-Бийанкур", "FR", "250", "", "11", "92", "923", "48.83333", "2.25", "Europe/Paris"),("3031180", "Boulazac", "", "FR", "250", "", "75", "24", "243", "45.11667", "0.75", "Europe/Paris"),("3031240", "Bouillargues", "", "FR", "250", "", "76", "30", "302", "43.79733", "4.42853", "Europe/Paris"),("3031268", "Bouguenais", "", "FR", "250", "", "52", "44", "442", "47.17762", "-1.62143", "Europe/Paris"),("3031277", "Bougival", "", "FR", "250", "", "11", "78", "783", "48.86223", "2.14148", "Europe/Paris"),("3031294", "Bouffémont", "", "FR", "250", "", "11", "95", "952", "49.04377", "2.29796", "Europe/Paris"),("3031368", "Bouchemaine", "", "FR", "250", "", "52", "49", "491", "47.42234", "-0.60888", "Europe/Paris"),("3031387", "Bouc-Bel-Air", "", "FR", "250", "", "93", "13", "131", "43.45217", "5.413", "Europe/Paris"),("3031389", "Boucau", "", "FR", "250", "", "75", "64", "641", "43.5277", "-1.46556", "Europe/Paris"),("3031403", "Bouaye", "", "FR", "250", "", "52", "44", "442", "47.14263", "-1.69306", "Europe/Paris"),("3031532", "Bormes-les-Mimosas", "", "FR", "250", "", "93", "83", "832", "43.14073", "6.33863", "Europe/Paris"),("3031537", "Borgo", "", "FR", "250", "", "94", "2B", "2B2", "42.55488", "9.42636", "Europe/Paris"),("3031582", "Bordeaux", "Бордо", "FR", "250", "", "75", "33", "332", "44.84044", "-0.5805", "Europe/Paris"),("3031679", "Bonneville", "", "FR", "250", "", "84", "74", "742", "46.0802", "6.40726", "Europe/Paris"),("3031709", "Bonneuil-sur-Marne", "", "FR", "250", "", "11", "94", "941", "48.7695", "2.4793", "Europe/Paris"),("3031813", "Bon-Encontre", "", "FR", "250", "", "75", "47", "471", "44.18518", "0.66759", "Europe/Paris"),("3031815", "Bondy", "Бонди", "FR", "250", "", "11", "93", "931", "48.9018", "2.48931", "Europe/Paris"),("3031817", "Bondues", "", "FR", "250", "", "32", "59", "595", "50.70196", "3.09497", "Europe/Paris"),("3031818", "Bondoufle", "", "FR", "250", "", "11", "91", "912", "48.61294", "2.37775", "Europe/Paris"),("3031835", "Bonchamp-lès-Laval", "", "FR", "250", "", "52", "53", "532", "48.07357", "-0.7", "Europe/Paris"),("3031848", "Bompas", "", "FR", "250", "", "76", "66", "662", "42.73333", "2.93333", "Europe/Paris"),("3031868", "Bollène", "", "FR", "250", "", "93", "84", "842", "44.28476", "4.75303", "Europe/Paris"),("3031871", "Bolbec", "", "FR", "250", "", "28", "76", "762", "49.57321", "0.47339", "Europe/Paris"),("3031898", "Boissy-Saint-Léger", "", "FR", "250", "", "11", "94", "941", "48.75149", "2.51163", "Europe/Paris"),("3032008", "Bois-le-Roi", "", "FR", "250", "", "11", "77", "774", "48.47348", "2.70464", "Europe/Paris"),("3032025", "Bois-Guillaume", "", "FR", "250", "", "28", "76", "763", "49.4602", "1.12219", "Europe/Paris"),("3032064", "Bois-d’Arcy", "", "FR", "250", "", "11", "78", "784", "48.79966", "2.02325", "Europe/Paris"),("3032070", "Bois-Colombes", "", "FR", "250", "", "11", "92", "922", "48.91936", "2.27485", "Europe/Paris"),("3032127", "Bohain-en-Vermandois", "", "FR", "250", "", "32", "02", "023", "49.9873", "3.453", "Europe/Paris"),("3032179", "Bobigny", "Бобиньи", "FR", "250", "", "11", "93", "931", "48.9", "2.45", "Europe/Paris"),("3032213", "Blois", "Блуа", "FR", "250", "", "24", "41", "411", "47.58333", "1.33333", "Europe/Paris"),("3032275", "Blénod-lès-Pont-à-Mousson", "", "FR", "250", "", "44", "54", "543", "48.88487", "6.04844", "Europe/Paris"),("3032279", "Blendecques", "", "FR", "250", "", "32", "62", "625", "50.71843", "2.28601", "Europe/Paris"),("3032326", "Blanzy", "", "FR", "250", "", "27", "71", "711", "46.70012", "4.38833", "Europe/Paris"),("3032340", "Blanquefort", "", "FR", "250", "", "75", "33", "332", "44.91248", "-0.63663", "Europe/Paris"),("3032462", "Blain", "", "FR", "250", "", "52", "44", "441", "47.47655", "-1.76285", "Europe/Paris"),("3032469", "Blagnac", "Бланьяк", "FR", "250", "", "76", "31", "313", "43.63276", "1.39399", "Europe/Paris"),("3032496", "Bizanos", "", "FR", "250", "", "75", "64", "643", "43.28333", "-0.35", "Europe/Paris"),("3032518", "Bitche", "", "FR", "250", "", "44", "57", "576", "49.05009", "7.42672", "Europe/Paris"),("3032544", "Bischwiller", "", "FR", "250", "", "44", "67", "672", "48.76588", "7.85831", "Europe/Paris"),("3032551", "Bischheim", "", "FR", "250", "", "44", "67", "676", "48.61612", "7.75343", "Europe/Paris"),("3032556", "Biscarrosse", "", "FR", "250", "", "75", "40", "402", "44.39454", "-1.16721", "Europe/Paris"),("3032579", "Biot", "", "FR", "250", "", "93", "06", "061", "43.62723", "7.09645", "Europe/Paris"),("3032618", "Billy-Montigny", "", "FR", "250", "", "32", "62", "627", "50.41711", "2.90286", "Europe/Paris"),("3032639", "Billère", "", "FR", "250", "", "75", "64", "643", "43.3", "-0.4", "Europe/Paris"),("3032662", "Bihorel", "", "FR", "250", "", "28", "76", "763", "49.45468", "1.1223", "Europe/Paris"),("3032668", "Biguglia", "", "FR", "250", "", "94", "2B", "2B2", "42.62589", "9.43324", "Europe/Paris"),("3032688", "Biganos", "", "FR", "250", "", "75", "33", "336", "44.64504", "-0.97367", "Europe/Paris"),("3032767", "Bidart", "", "FR", "250", "", "75", "64", "641", "43.4376", "-1.59127", "Europe/Paris"),("3032797", "Biarritz", "Биарриц", "FR", "250", "", "75", "64", "641", "43.48012", "-1.55558", "Europe/Paris"),("3032824", "Bezons", "Безон", "FR", "250", "", "11", "95", "951", "48.92426", "2.2128", "Europe/Paris"),("3032833", "Béziers", "Безье", "FR", "250", "", "76", "34", "341", "43.34122", "3.21402", "Europe/Paris"),("3032872", "Beynes", "", "FR", "250", "", "11", "78", "782", "48.85626", "1.87261", "Europe/Paris"),("3032903", "Beuvry", "", "FR", "250", "", "32", "62", "622", "50.51674", "2.68541", "Europe/Paris"),("3032915", "Beuvrages", "", "FR", "250", "", "32", "59", "596", "50.38414", "3.4942", "Europe/Paris"),("3032965", "Betton", "", "FR", "250", "", "53", "35", "353", "48.18048", "-1.63829", "Europe/Paris"),("3033002", "Béthune", "Бетюн", "FR", "250", "", "32", "62", "622", "50.53333", "2.63333", "Europe/Paris"),("3033006", "Bethoncourt", "", "FR", "250", "", "27", "25", "252", "47.53512", "6.80504", "Europe/Paris"),("3033014", "Bétheny", "", "FR", "250", "", "44", "51", "513", "49.28498", "4.05495", "Europe/Paris"),("3033098", "Bessancourt", "", "FR", "250", "", "11", "95", "953", "49.03765", "2.20936", "Europe/Paris"),("3033123", "Besançon", "Безансон", "FR", "250", "", "27", "25", "251", "47.24878", "6.01815", "Europe/Paris"),("3033241", "Berre-l'Étang", "", "FR", "250", "", "93", "13", "134", "43.47809", "5.17044", "Europe/Paris"),("3033308", "Bernay", "", "FR", "250", "", "28", "27", "272", "49.08888", "0.59858", "Europe/Paris"),("3033391", "Bergerac", "", "FR", "250", "", "75", "24", "241", "44.85", "0.48333", "Europe/Paris"),("3033415", "Berck", "", "FR", "250", "FR", "32", "62", "624", "50.4", "1.6", "Europe/Paris"),("3033416", "Berck-Plage", "", "FR", "250", "", "32", "62", "624", "50.40704", "1.56446", "Europe/Paris"),("3033488", "Benfeld", "", "FR", "250", "", "44", "67", "675", "48.37062", "7.5937", "Europe/Paris"),("3033625", "Belley", "", "FR", "250", "", "84", "01", "011", "45.76667", "5.68333", "Europe/Paris"),("3033636", "Belleville", "", "FR", "250", "", "84", "69", "692", "46.1", "4.75", "Europe/Paris"),("3033666", "Bellerive-sur-Allier", "", "FR", "250", "", "84", "03", "033", "46.11633", "3.40338", "Europe/Paris"),("3033685", "Bellegarde-sur-Valserine", "", "FR", "250", "", "84", "01", "014", "46.10787", "5.82421", "Europe/Paris"),("3033698", "Bellegarde", "", "FR", "250", "", "76", "30", "302", "43.75329", "4.51654", "Europe/Paris"),("3033791", "Belfort", "Бельфор", "FR", "250", "", "27", "90", "901", "47.63333", "6.86667", "Europe/Paris"),("3033853", "Behren-lès-Forbach", "", "FR", "250", "", "44", "57", "573", "49.1664", "6.94336", "Europe/Paris"),("3033881", "Bègles", "Беглесе", "FR", "250", "", "75", "33", "332", "44.80845", "-0.54809", "Europe/Paris"),("3033912", "Bédarrides", "", "FR", "250", "", "93", "84", "842", "44.04022", "4.89819", "Europe/Paris"),("3033913", "Bédarieux", "", "FR", "250", "", "76", "34", "341", "43.61553", "3.15714", "Europe/Paris"),("3033953", "Beauzelle", "", "FR", "250", "", "76", "31", "313", "43.66713", "1.37518", "Europe/Paris"),("3034006", "Beauvais", "Бове", "FR", "250", "", "32", "60", "601", "49.43333", "2.08333", "Europe/Paris"),("3034041", "Beausoleil", "", "FR", "250", "", "93", "06", "062", "43.74904", "7.41702", "Europe/Paris"),("3034111", "Beaupréau", "", "FR", "250", "", "52", "49", "492", "47.20464", "-0.98703", "Europe/Paris"),("3034126", "Beaune", "Бон", "FR", "250", "", "27", "21", "211", "47.03333", "4.83333", "Europe/Paris"),("3034141", "Beaumont-sur-Oise", "", "FR", "250", "", "11", "95", "953", "49.14232", "2.28705", "Europe/Paris"),("3034198", "Beaumont", "", "FR", "250", "", "84", "63", "632", "45.75123", "3.08355", "Europe/Paris"),("3034297", "Beaugency", "", "FR", "250", "", "24", "45", "452", "47.78019", "1.62705", "Europe/Paris"),("3034309", "Beaufort-en-Vallée", "", "FR", "250", "", "52", "49", "491", "47.43965", "-0.2189", "Europe/Paris"),("3034343", "Beaucourt", "", "FR", "250", "", "27", "90", "901", "47.4899", "6.92407", "Europe/Paris"),("3034369", "Beauchamp", "", "FR", "250", "", "11", "95", "953", "49.01667", "2.2", "Europe/Paris"),("3034382", "Beaucaire", "", "FR", "250", "", "76", "30", "302", "43.80806", "4.64417", "Europe/Paris"),("3034458", "Bazas", "", "FR", "250", "", "75", "33", "333", "44.43202", "-0.21327", "Europe/Paris"),("3034475", "Bayonne", "Байонна", "FR", "250", "", "75", "64", "641", "43.48333", "-1.48333", "Europe/Paris"),("3034483", "Bayeux", "Байё", "FR", "250", "", "28", "14", "141", "49.27732", "-0.7039", "Europe/Paris"),("3034521", "Bauvin", "", "FR", "250", "", "32", "59", "595", "50.51714", "2.89404", "Europe/Paris"),("3034535", "Baume-les-Dames", "", "FR", "250", "", "27", "25", "251", "47.35295", "6.36117", "Europe/Paris"),("3034582", "Baud", "", "FR", "250", "", "53", "56", "562", "47.87474", "-3.0176", "Europe/Paris"),("3034640", "Bastia", "Бастия", "FR", "250", "", "94", "2B", "2B2", "42.70278", "9.45", "Europe/Paris"),("3034691", "Bassens", "", "FR", "250", "", "75", "33", "332", "44.90226", "-0.51631", "Europe/Paris"),("3034699", "Basse-Goulaine", "", "FR", "250", "", "52", "44", "442", "47.21167", "-1.46748", "Europe/Paris"),("3034802", "Bar-sur-Aube", "", "FR", "250", "", "44", "10", "101", "48.23333", "4.71667", "Europe/Paris"),("3034868", "Barr", "", "FR", "250", "", "44", "67", "675", "48.40755", "7.44873", "Europe/Paris"),("3034903", "Barlin", "", "FR", "250", "", "32", "62", "622", "50.45238", "2.61955", "Europe/Paris"),("3034911", "Bar-le-Duc", "Бар-ле-Дюк", "FR", "250", "", "44", "55", "551", "48.78333", "5.16667", "Europe/Paris"),("3034951", "Barentin", "", "FR", "250", "", "28", "76", "763", "49.54533", "0.95515", "Europe/Paris"),("3035016", "Barbezieux-Saint-Hilaire", "", "FR", "250", "", "75", "16", "162", "45.47265", "-0.15218", "Europe/Paris"),("3035033", "Barberaz", "", "FR", "250", "", "84", "73", "732", "45.55", "5.93333", "Europe/Paris"),("3035092", "Banyuls de la Marenda", "", "FR", "250", "", "76", "66", "661", "42.48375", "3.12897", "Europe/Paris"),("3035139", "Bannalec", "", "FR", "250", "", "53", "29", "294", "47.93229", "-3.69759", "Europe/Paris"),("3035156", "Bandol", "", "FR", "250", "", "93", "83", "832", "43.13709", "5.7316", "Europe/Paris"),("3035204", "Balma", "", "FR", "250", "", "76", "31", "313", "43.61111", "1.49944", "Europe/Paris"),("3035226", "Ballan-Miré", "", "FR", "250", "", "24", "37", "372", "47.34057", "0.61466", "Europe/Paris"),("3035228", "Ballancourt-sur-Essonne", "", "FR", "250", "", "11", "91", "912", "48.52525", "2.38604", "Europe/Paris"),("3035268", "Balaruc-les-Bains", "", "FR", "250", "", "76", "34", "343", "43.4417", "3.6778", "Europe/Paris"),("3035324", "Bain-de-Bretagne", "", "FR", "250", "", "53", "35", "352", "47.84418", "-1.68486", "Europe/Paris"),("3035359", "Bailleul", "", "FR", "250", "", "32", "59", "594", "50.73592", "2.73594", "Europe/Paris"),("3035370", "Baillargues", "", "FR", "250", "", "76", "34", "343", "43.66267", "4.01681", "Europe/Paris"),("3035396", "Bagnols-sur-Cèze", "Баньоль-сюр-Сез", "FR", "250", "", "76", "30", "302", "44.1599", "4.61776", "Europe/Paris"),("3035403", "Bagnolet", "Баньоле", "FR", "250", "", "11", "93", "931", "48.86667", "2.41667", "Europe/Paris"),("3035409", "Bagneux", "", "FR", "250", "", "11", "92", "921", "48.79565", "2.30796", "Europe/Paris"),("3035418", "Bagnères-de-Bigorre", "", "FR", "250", "", "76", "65", "652", "43.06667", "0.15", "Europe/Paris"),("3035560", "Aytré", "", "FR", "250", "", "75", "17", "173", "46.1357", "-1.11452", "Europe/Paris"),("3035612", "Avrillé", "", "FR", "250", "", "52", "49", "491", "47.5", "-0.58333", "Europe/Paris"),("3035639", "Avranches", "", "FR", "250", "", "28", "50", "501", "48.68333", "-1.36667", "Europe/Paris"),("3035654", "Avon", "", "FR", "250", "", "11", "77", "774", "48.40219", "2.72022", "Europe/Paris"),("3035667", "Avion", "", "FR", "250", "", "32", "62", "627", "50.41038", "2.83053", "Europe/Paris"),("3035681", "Avignon", "Авиньон", "FR", "250", "", "93", "84", "842", "43.94834", "4.80892", "Europe/Paris"),("3035768", "Avallon", "", "FR", "250", "", "27", "89", "892", "47.48333", "3.9", "Europe/Paris"),("3035828", "Auxonne", "", "FR", "250", "", "27", "21", "212", "47.19255", "5.38726", "Europe/Paris"),("3035843", "Auxerre", "Осер", "FR", "250", "", "27", "89", "891", "47.8", "3.56667", "Europe/Paris"),("3035864", "Auvers-sur-Oise", "", "FR", "250", "", "11", "95", "953", "49.07158", "2.16978", "Europe/Paris"),("3035883", "Autun", "Отён", "FR", "250", "", "27", "71", "711", "46.95", "4.3", "Europe/Paris"),("3035970", "Auterive", "", "FR", "250", "", "76", "31", "311", "43.35103", "1.47797", "Europe/Paris"),("3035991", "Aussillon", "", "FR", "250", "", "76", "81", "812", "43.50293", "2.36791", "Europe/Paris"),("3036012", "Auriol", "", "FR", "250", "", "93", "13", "133", "43.37161", "5.6341", "Europe/Paris"),("3036016", "Aurillac", "Орийак", "FR", "250", "", "84", "15", "151", "44.91667", "2.45", "Europe/Paris"),("3036052", "Aureilhan", "", "FR", "250", "", "76", "65", "653", "43.24337", "0.09581", "Europe/Paris"),("3036054", "Aurec-sur-Loire", "", "FR", "250", "", "84", "43", "433", "45.36907", "4.2049", "Europe/Paris"),("3036059", "Auray", "", "FR", "250", "", "53", "56", "561", "47.67025", "-2.99183", "Europe/Paris"),("3036132", "Aulnoye-Aymeries", "", "FR", "250", "", "32", "59", "591", "50.20141", "3.83844", "Europe/Paris"),("3036133", "Aulnoy-lez-Valenciennes", "", "FR", "250", "", "32", "59", "596", "50.33333", "3.53333", "Europe/Paris"),("3036145", "Aulnay-sous-Bois", "Оне-су-Буа", "FR", "250", "", "11", "93", "932", "48.93814", "2.49402", "Europe/Paris"),("3036226", "Audun-le-Tiche", "", "FR", "250", "", "44", "57", "578", "49.47228", "5.95694", "Europe/Paris"),("3036240", "Audincourt", "", "FR", "250", "", "27", "25", "252", "47.48327", "6.85341", "Europe/Paris"),("3036256", "Audenge", "", "FR", "250", "", "75", "33", "336", "44.68686", "-1.01345", "Europe/Paris"),("3036278", "Auchel", "", "FR", "250", "", "32", "62", "622", "50.50345", "2.47346", "Europe/Paris"),("3036281", "Auch", "Ош", "FR", "250", "", "76", "32", "321", "43.65", "0.58333", "Europe/Paris"),("3036287", "Aucamville", "", "FR", "250", "", "76", "31", "313", "43.6702", "1.42808", "Europe/Paris"),("3036289", "Auby", "", "FR", "250", "", "32", "59", "593", "50.41457", "3.05396", "Europe/Paris"),("3036326", "Aubigny-sur-Nère", "", "FR", "250", "", "24", "18", "183", "47.48819", "2.43895", "Europe/Paris"),("3036364", "Aubière", "", "FR", "250", "", "84", "63", "632", "45.75157", "3.11251", "Europe/Paris"),("3036386", "Aubervilliers", "Обервилье", "FR", "250", "", "11", "93", "933", "48.91667", "2.38333", "Europe/Paris"),("3036402", "Aubergenville", "", "FR", "250", "", "11", "78", "781", "48.95996", "1.85467", "Europe/Paris"),("3036418", "Aubenas", "", "FR", "250", "", "84", "07", "071", "44.62006", "4.38994", "Europe/Paris"),("3036433", "Aubagne", "Обань", "FR", "250", "", "93", "13", "133", "43.29276", "5.57067", "Europe/Paris"),("3036460", "Athis-Mons", "", "FR", "250", "", "11", "91", "913", "48.70522", "2.39147", "Europe/Paris"),("3036572", "Asnières-sur-Seine", "Аньер-сюр-Сен", "FR", "250", "", "11", "92", "922", "48.91667", "2.28333", "Europe/Paris"),("3036655", "Artigues-près-Bordeaux", "", "FR", "250", "", "75", "33", "332", "44.85", "-0.51667", "Europe/Paris"),("3036711", "Ars-sur-Moselle", "", "FR", "250", "", "44", "57", "574", "49.07831", "6.07275", "Europe/Paris"),("3036784", "Arras", "Аррас", "FR", "250", "", "32", "62", "621", "50.29301", "2.78186", "Europe/Paris"),("3036791", "Arradon", "", "FR", "250", "", "53", "56", "563", "47.62709", "-2.8215", "Europe/Paris"),("3036800", "Arques", "", "FR", "250", "", "32", "62", "625", "50.73375", "2.30237", "Europe/Paris"),("3036822", "Arpajon-sur-Cère", "", "FR", "250", "", "84", "15", "151", "44.90262", "2.45809", "Europe/Paris"),("3036823", "Arpajon", "", "FR", "250", "", "11", "91", "913", "48.58875", "2.24672", "Europe/Paris"),("3036843", "Arnouville", "", "FR", "250", "", "11", "95", "952", "48.98333", "2.41667", "Europe/Paris"),("3036876", "Arnage", "", "FR", "250", "", "52", "72", "723", "47.92616", "0.18782", "Europe/Paris"),("3036903", "Armentières", "Армантьер", "FR", "250", "", "32", "59", "595", "50.68568", "2.88214", "Europe/Paris"),("3036938", "Arles", "Арль", "FR", "250", "", "93", "13", "132", "43.67681", "4.63031", "Europe/Paris"),("3037018", "Argenton-sur-Creuse", "", "FR", "250", "", "24", "36", "362", "46.58997", "1.51981", "Europe/Paris"),("3037044", "Argenteuil", "Аржантей", "FR", "250", "", "11", "95", "951", "48.95", "2.25", "Europe/Paris"),("3037051", "Argentan", "Аржантан", "FR", "250", "", "28", "61", "612", "48.75", "-0.01667", "Europe/Paris"),("3037068", "Argelers", "", "FR", "250", "", "76", "66", "661", "42.54714", "3.02253", "Europe/Paris"),("3037095", "Arès", "", "FR", "250", "", "75", "33", "336", "44.76667", "-1.13333", "Europe/Paris"),("3037157", "Arcueil", "", "FR", "250", "", "11", "94", "943", "48.79993", "2.33256", "Europe/Paris"),("3037253", "Arcachon", "", "FR", "250", "", "75", "33", "336", "44.65", "-1.16667", "Europe/Paris"),("3037352", "Apt", "", "FR", "250", "", "93", "84", "841", "43.88333", "5.4", "Europe/Paris"),("3037397", "Anzin", "", "FR", "250", "", "32", "59", "596", "50.37201", "3.50387", "Europe/Paris"),("3037423", "Antony", "", "FR", "250", "", "11", "92", "921", "48.75", "2.3", "Europe/Paris"),("3037456", "Antibes", "Антиб", "FR", "250", "", "93", "06", "061", "43.56241", "7.12777", "Europe/Paris"),("3037489", "Anse", "", "FR", "250", "", "84", "69", "692", "45.93023", "4.71576", "Europe/Paris"),("3037514", "Annonay", "Анноне", "FR", "250", "", "84", "07", "073", "45.23969", "4.67075", "Europe/Paris"),("3037520", "Annoeullin", "", "FR", "250", "", "32", "59", "595", "50.52925", "2.9318", "Europe/Paris"),("3037521", "Annezin", "", "FR", "250", "", "32", "62", "622", "50.53192", "2.61785", "Europe/Paris"),("3037538", "Annemasse", "", "FR", "250", "", "84", "74", "743", "46.19439", "6.23775", "Europe/Paris"),("3037540", "Annecy-le-Vieux", "Аннеси-ле-Вье", "FR", "250", "", "84", "74", "741", "45.91971", "6.14393", "Europe/Paris"),("3037543", "Annecy", "Анси", "FR", "250", "", "84", "74", "741", "45.9", "6.11667", "Europe/Paris"),("3037571", "Aniche", "", "FR", "250", "", "32", "59", "593", "50.32995", "3.25346", "Europe/Paris"),("3037598", "Angoulême", "Ангулем", "FR", "250", "", "75", "16", "161", "45.65", "0.15", "Europe/Paris"),("3037612", "Anglet", "Англет", "FR", "250", "", "75", "64", "641", "43.47664", "-1.51346", "Europe/Paris"),("3037656", "Angers", "Анже", "FR", "250", "", "52", "49", "491", "47.46667", "-0.55", "Europe/Paris"),("3037689", "Andrézieux-Bouthéon", "", "FR", "250", "", "84", "42", "421", "45.52625", "4.26021", "Europe/Paris"),("3037692", "Andrésy", "", "FR", "250", "", "11", "78", "783", "48.98235", "2.05687", "Europe/Paris"),("3037726", "Andernos-les-Bains", "", "FR", "250", "", "75", "33", "336", "44.74572", "-1.10355", "Europe/Paris"),("3037797", "Ancenis", "", "FR", "250", "", "52", "44", "444", "47.36667", "-1.16667", "Europe/Paris"),("3037818", "Amplepuis", "", "FR", "250", "", "84", "69", "692", "45.97259", "4.3316", "Europe/Paris"),("3037838", "Amnéville", "", "FR", "250", "", "44", "57", "574", "49.25749", "6.14203", "Europe/Paris"),("3037846", "Amilly", "", "FR", "250", "", "24", "45", "451", "47.97281", "2.77186", "Europe/Paris"),("3037854", "Amiens", "Амьен", "FR", "250", "", "32", "80", "802", "49.9", "2.3", "Europe/Paris"),("3037902", "Amboise", "", "FR", "250", "", "24", "37", "372", "47.41249", "0.98266", "Europe/Paris"),("3037937", "Ambert", "", "FR", "250", "", "84", "63", "631", "45.55", "3.75", "Europe/Paris"),("3037943", "Ambérieu-en-Bugey", "", "FR", "250", "", "84", "01", "011", "45.95885", "5.3432", "Europe/Paris"),("3037954", "Ambazac", "", "FR", "250", "", "75", "87", "872", "45.95983", "1.40063", "Europe/Paris"),("3037956", "Ambarès-et-Lagrave", "", "FR", "250", "FR", "75", "33", "332", "44.91667", "-0.48333", "Europe/Paris"),("3038012", "Altkirch", "", "FR", "250", "", "44", "68", "681", "47.61667", "7.25", "Europe/Paris"),("3038086", "Allonnes", "", "FR", "250", "", "52", "72", "723", "47.9674", "0.15807", "Europe/Paris"),("3038106", "Allières-et-Risset", "", "FR", "250", "", "84", "38", "381", "45.09934", "5.67924", "Europe/Paris"),("3038159", "Allauch", "Аллош", "FR", "250", "", "93", "13", "133", "43.33573", "5.48201", "Europe/Paris"),("3038204", "Algrange", "", "FR", "250", "", "44", "57", "578", "49.35863", "6.04748", "Europe/Paris"),("3038213", "Alfortville", "Альфорвилль", "FR", "250", "", "11", "94", "941", "48.80575", "2.4204", "Europe/Paris"),("3038224", "Alès", "Алес", "FR", "250", "", "76", "30", "301", "44.12489", "4.08082", "Europe/Paris"),("3038230", "Alençon", "Алансон", "FR", "250", "", "28", "61", "611", "48.43333", "0.08333", "Europe/Paris"),("3038261", "Albi", "Альби", "FR", "250", "", "76", "81", "811", "43.9298", "2.148", "Europe/Paris"),("3038266", "Albertville", "Альбервиль", "FR", "250", "", "84", "73", "731", "45.67452", "6.39061", "Europe/Paris"),("3038271", "Albert", "", "FR", "250", "", "32", "80", "804", "50.00091", "2.65096", "Europe/Paris"),("3038334", "Ajaccio", "Аяччо", "FR", "250", "", "94", "2A", "2A1", "41.92723", "8.73462", "Europe/Paris"),("3038341", "Aizenay", "", "FR", "250", "", "52", "85", "852", "46.74004", "-1.60834", "Europe/Paris"),("3038350", "Aix-les-Bains", "Экс-ле-Бен", "FR", "250", "", "84", "73", "732", "45.69173", "5.90863", "Europe/Paris"),("3038352", "Aixe-sur-Vienne", "", "FR", "250", "", "75", "87", "872", "45.79862", "1.13884", "Europe/Paris"),("3038354", "Aix-en-Provence", "Экс-ан-Прованс", "FR", "250", "", "93", "13", "131", "43.5283", "5.44973", "Europe/Paris"),("3038393", "Aire-sur-la-Lys", "", "FR", "250", "", "32", "62", "625", "50.63871", "2.39876", "Europe/Paris"),("3038493", "Aigues-Mortes", "", "FR", "250", "", "76", "30", "302", "43.56683", "4.19068", "Europe/Paris"),("3038611", "Agneaux", "", "FR", "250", "", "28", "50", "504", "49.11905", "-1.1061", "Europe/Paris"),("3038634", "Agen", "Ажен", "FR", "250", "", "75", "47", "471", "44.2", "0.63333", "Europe/Paris"),("3038638", "Agde", "Агд", "FR", "250", "", "76", "34", "341", "43.31083", "3.47583", "Europe/Paris"),("3038698", "Acigné", "", "FR", "250", "", "53", "35", "353", "48.13333", "-1.53704", "Europe/Paris"),("3038703", "Achicourt", "", "FR", "250", "", "32", "62", "621", "50.27429", "2.75779", "Europe/Paris"),("3038712", "Achères", "", "FR", "250", "", "11", "78", "783", "48.96115", "2.06882", "Europe/Paris"),("3038754", "Ablon-sur-Seine", "", "FR", "250", "", "11", "94", "941", "48.72732", "2.42686", "Europe/Paris"),("3038789", "Abbeville", "Абвиль", "FR", "250", "", "32", "80", "801", "50.1", "1.83333", "Europe/Paris"),("3232493", "Guidel-Plage", "", "FR", "250", "", "53", "56", "561", "47.76768", "-3.5218", "Europe/Paris"),("6543862", "Villeneuve-d'Ascq", "Вильнёв-д’Аск", "FR", "250", "", "32", "59", "595", "50.61669", "3.16664", "Europe/Paris"),("6615536", "Les Ulis", "Лез-Юлис", "FR", "250", "", "11", "91", "913", "48.68167", "2.16944", "Europe/Paris"),("6615537", "Carnoux-en-Provence", "", "FR", "250", "", "93", "13", "133", "43.25639", "5.56444", "Europe/Paris"),("6615539", "Bourgoin-Jallieu", "Бургуин-Жалльё", "FR", "250", "", "84", "38", "382", "45.58611", "5.27361", "Europe/Paris"),("6619659", "Val-de-Reuil", "", "FR", "250", "", "28", "27", "271", "49.27385", "1.21021", "Europe/Paris"),("7284882", "Marseille 01", "", "FR", "250", "", "93", "13", "133", "43.29814", "5.38407", "Europe/Paris"),("7284883", "Marseille 02", "", "FR", "250", "", "93", "13", "133", "43.29664", "5.37034", "Europe/Paris"),("7284884", "Marseille 03", "", "FR", "250", "", "93", "13", "133", "43.30257", "5.37583", "Europe/Paris"),("7284885", "Marseille 04", "", "FR", "250", "", "93", "13", "133", "43.30213", "5.40141", "Europe/Paris"),("7284886", "Marseille 05", "", "FR", "250", "", "93", "13", "133", "43.29551", "5.40055", "Europe/Paris"),("7284887", "Marseille 06", "", "FR", "250", "", "93", "13", "133", "43.28764", "5.37918", "Europe/Paris"),("7284888", "Marseille 07", "", "FR", "250", "", "93", "13", "133", "43.28289", "5.36021", "Europe/Paris"),("7284889", "Marseille 08", "", "FR", "250", "", "93", "13", "133", "43.27083", "5.3821", "Europe/Paris"),("7284890", "Marseille 10", "", "FR", "250", "", "93", "13", "133", "43.27889", "5.41523", "Europe/Paris"),("7284891", "Marseille 09", "", "FR", "250", "", "93", "13", "133", "43.25433", "5.4057", "Europe/Paris"),("7284892", "Marseille 11", "", "FR", "250", "", "93", "13", "133", "43.2907", "5.4384", "Europe/Paris"),("7284893", "Marseille 12", "", "FR", "250", "", "93", "13", "133", "43.29614", "5.43617", "Europe/Paris"),("7284894", "Marseille 13", "", "FR", "250", "", "93", "13", "133", "43.31856", "5.40836", "Europe/Paris"),("7284895", "Marseille 14", "", "FR", "250", "", "93", "13", "133", "43.34447", "5.38004", "Europe/Paris"),("7284896", "Marseille 15", "", "FR", "250", "", "93", "13", "133", "43.37224", "5.35386", "Europe/Paris"),("7284897", "Marseille 16", "", "FR", "250", "", "93", "13", "133", "43.35982", "5.33421", "Europe/Paris"),("8504417", "La Defense", "Ля Дефанс", "FR", "250", "", "11", "92", "922", "48.89198", "2.23881", "Europe/Paris"),("8533870", "Saint-Quentin-en-Yvelines", "", "FR", "250", "", "11", "78", "784", "48.77186", "2.01891", "Europe/Paris"),("8555643", "Cergy-Pontoise", "", "FR", "250", "", "11", "95", "953", "49.03894", "2.07805", "Europe/Paris"),("11238455", "Rd pt des Chataigniers, Rte de Milizac, Guilers, Finistère, France", "", "FR", "250", "", "53", "29", "291", "48.43387", "-4.56809", "Europe/Paris"),("2396253", "Tchibanga", "", "GA", "266", "", "05", "7870326", "", "-2.93323", "10.98178", "Africa/Libreville"),("2396518", "Port-Gentil", "", "GA", "266", "", "08", "", "", "-0.71933", "8.78151", "Africa/Libreville"),("2396646", "Oyem", "", "GA", "266", "", "09", "", "", "1.5995", "11.57933", "Africa/Libreville"),("2396898", "Okondja", "", "GA", "266", "", "02", "", "", "-0.65487", "13.67533", "Africa/Libreville"),("2397169", "Ntoum", "", "GA", "266", "", "01", "", "", "0.39051", "9.76096", "Africa/Libreville"),("2397614", "Ndendé", "", "GA", "266", "", "04", "", "", "-2.40077", "11.35813", "Africa/Libreville"),("2397674", "Ndjolé", "", "GA", "266", "", "03", "", "", "-0.17827", "10.76488", "Africa/Libreville"),("2397978", "Mounana", "", "GA", "266", "", "02", "", "", "-1.4085", "13.15857", "Africa/Libreville"),("2398073", "Mouila", "", "GA", "266", "", "04", "", "", "-1.86846", "11.05594", "Africa/Libreville"),("2398269", "Moanda", "", "GA", "266", "", "02", "", "", "-1.56652", "13.1987", "Africa/Libreville"),("2399371", "Makokou", "", "GA", "266", "", "06", "", "", "0.57381", "12.86419", "Africa/Libreville"),("2399697", "Libreville", "Либревиль", "GA", "266", "", "01", "", "", "0.39241", "9.45356", "Africa/Libreville"),("2399870", "Lastoursville", "", "GA", "266", "", "07", "", "", "-0.81742", "12.70818", "Africa/Libreville"),("2399888", "Lambaréné", "Ламбарене", "GA", "266", "", "03", "", "", "-0.7001", "10.24055", "Africa/Libreville"),("2399959", "Koulamoutou", "", "GA", "266", "", "07", "", "", "-1.13667", "12.46399", "Africa/Libreville"),("2400547", "Gamba", "", "GA", "266", "", "08", "", "", "-2.65", "10", "Africa/Libreville"),("2400555", "Franceville", "Франсвиль", "GA", "266", "", "02", "", "", "-1.63333", "13.58357", "Africa/Libreville"),("2400578", "Fougamou", "", "GA", "266", "", "04", "", "", "-1.21544", "10.58378", "Africa/Libreville"),("2401495", "Booué", "", "GA", "266", "", "06", "", "", "-0.09207", "11.93846", "Africa/Libreville"),("2401578", "Bitam", "", "GA", "266", "", "09", "", "", "2.07597", "11.50065", "Africa/Libreville"),("2633337", "Ystalyfera", "", "GB", "826", "", "WLS", "Y5", "00NZ031", "51.76716", "-3.78082", "Europe/London"),("2633352", "York", "Йорк", "GB", "826", "", "ENG", "Q5", "", "53.95763", "-1.08271", "Europe/London"),("2633373", "Yeovil", "Йеовиль", "GB", "826", "", "ENG", "M3", "40UD", "50.94159", "-2.63211", "Europe/London"),("2633397", "Yeadon", "", "GB", "826", "", "ENG", "H3", "", "53.86437", "-1.68743", "Europe/London"),("2633399", "Yaxley", "", "GB", "826", "", "ENG", "C3", "12UE", "52.51768", "-0.25852", "Europe/London"),("2633406", "Yate", "", "GB", "826", "", "ENG", "M6", "00HD044", "51.54074", "-2.41839", "Europe/London"),("2633445", "Wymondham", "", "GB", "826", "", "ENG", "H5", "31UG", "52.75978", "-0.74055", "Europe/London"),("2633476", "Wroughton", "", "GB", "826", "", "ENG", "N9", "00HX015", "51.52411", "-1.79559", "Europe/London"),("2633485", "Wrexham", "Рексем", "GB", "826", "", "WLS", "Z4", "00NL007", "53.04664", "-2.99132", "Europe/London"),("2633511", "Wotton-under-Edge", "", "GB", "826", "", "ENG", "E6", "23UF", "51.63242", "-2.34512", "Europe/London"),("2633521", "Worthing", "", "GB", "826", "", "ENG", "P6", "45UH", "50.81795", "-0.37538", "Europe/London"),("2633551", "Worksop", "Уорксоп", "GB", "826", "", "ENG", "J9", "37UC", "53.30182", "-1.12404", "Europe/London"),("2633553", "Workington", "", "GB", "826", "", "ENG", "C9", "16UB", "54.6425", "-3.54413", "Europe/London"),("2633563", "Worcester", "Вустер", "GB", "826", "", "ENG", "Q4", "47UE", "52.18935", "-2.22001", "Europe/London"),("2633571", "Royal Wootton Bassett", "", "GB", "826", "", "ENG", "P8", "00HY254", "51.5419", "-1.9045", "Europe/London"),("2633655", "Woodford Green", "", "GB", "826", "", "ENG", "GLA", "K8", "51.60938", "0.02329", "Europe/London"),("2633671", "Woodbridge", "", "GB", "826", "", "ENG", "N5", "42UG", "52.09332", "1.32042", "Europe/London"),("2633681", "Wombwell", "", "GB", "826", "", "ENG", "A3", "", "53.52189", "-1.39698", "Europe/London"),("2633691", "Wolverhampton", "Вулвергемптон", "GB", "826", "", "ENG", "Q3", "41UF", "52.58547", "-2.12296", "Europe/London"),("2633708", "Wokingham", "Уокингхем", "GB", "826", "", "ENG", "Q2", "00MF015", "51.4112", "-0.83565", "Europe/London"),("2633709", "Woking", "Уокинге", "GB", "826", "", "ENG", "N7", "43UM", "51.31903", "-0.55893", "Europe/London"),("2633710", "Woburn Sands", "", "GB", "826", "", "ENG", "I6", "00MG036", "52.01579", "-0.64982", "Europe/London"),("2633717", "Wivenhoe", "", "GB", "826", "", "ENG", "E4", "22UG", "51.85553", "0.95796", "Europe/London"),("2633729", "Witney", "Уитни", "GB", "826", "", "ENG", "K2", "38UF", "51.7836", "-1.4854", "Europe/London"),("2633744", "Withernsea", "", "GB", "826", "", "ENG", "E1", "00FB160", "53.7311", "0.03347", "Europe/London"),("2633749", "Witham", "", "GB", "826", "", "ENG", "E4", "22UC", "51.80007", "0.64038", "Europe/London"),("2633765", "Wishaw", "", "GB", "826", "", "SCT", "V8", "", "55.76667", "-3.91667", "Europe/London"),("2633771", "Wisbech", "Визбич", "GB", "826", "", "ENG", "C3", "12UD", "52.66622", "0.15938", "Europe/London"),("2633810", "Winsford", "", "GB", "826", "", "ENG", "Z8", "00EW163", "53.18333", "-2.51667", "Europe/London"),("2633824", "Wingerworth", "", "GB", "826", "", "ENG", "D3", "17UJ", "53.202", "-1.43359", "Europe/London"),("2633842", "Windsor", "Виндзор", "GB", "826", "GB", "ENG", "P9", "", "51.48333", "-0.6", "Europe/London"),("2633851", "Windermere", "", "GB", "826", "", "ENG", "C9", "16UG", "54.38086", "-2.90709", "Europe/London"),("2633858", "Winchester", "Винчестер", "GB", "826", "", "ENG", "F2", "24UP", "51.06513", "-1.3187", "Europe/London"),("2633863", "Wimborne Minster", "", "GB", "826", "", "ENG", "D6", "", "50.78333", "-1.98333", "Europe/London"),("2633883", "Wilmslow", "", "GB", "826", "", "ENG", "Z7", "00EQ004", "53.32803", "-2.23148", "Europe/London"),("2633912", "Willenhall", "", "GB", "826", "", "ENG", "O8", "", "52.58514", "-2.05934", "Europe/London"),("2633933", "Wigton", "", "GB", "826", "", "ENG", "C9", "16UB", "54.82482", "-3.16114", "Europe/London"),("2633936", "Wigston Magna", "", "GB", "826", "", "ENG", "H5", "31UJ", "52.58128", "-1.09248", "Europe/London"),("2633948", "Wigan", "Уиган", "GB", "826", "", "ENG", "P7", "", "53.53333", "-2.61667", "Europe/London"),("2633954", "Widnes", "", "GB", "826", "", "ENG", "E9", "00ET005", "53.3618", "-2.73406", "Europe/London"),("2633976", "Wickford", "", "GB", "826", "", "ENG", "E4", "22UB", "51.61101", "0.52331", "Europe/London"),("2633982", "Wick", "", "GB", "826", "", "SCT", "V3", "2654041", "58.43906", "-3.09424", "Europe/London"),("2633997", "Whitworth", "", "GB", "826", "", "ENG", "H2", "30UM", "53.65601", "-2.1771", "Europe/London"),("2634010", "Whittlesey", "", "GB", "826", "", "ENG", "C3", "12UD", "52.55804", "-0.13016", "Europe/London"),("2634021", "Whitstable", "Уитстабл", "GB", "826", "", "ENG", "G5", "6945807", "51.3607", "1.0257", "Europe/London"),("2634032", "Whitley Bay", "", "GB", "826", "", "ENG", "J5", "00EM167", "55.03973", "-1.44713", "Europe/London"),("2634096", "Whitehaven", "", "GB", "826", "", "ENG", "C9", "16UE", "54.54897", "-3.58412", "Europe/London"),("2634103", "Whitefield", "", "GB", "826", "", "ENG", "C1", "", "53.55", "-2.3", "Europe/London"),("2634124", "Whitchurch", "", "GB", "826", "", "ENG", "L6", "00GG192", "52.96667", "-2.68333", "Europe/London"),("2634135", "Whitby", "", "GB", "826", "", "ENG", "J7", "36UG", "54.48774", "-0.61498", "Europe/London"),("2634137", "Whitburn", "", "GB", "826", "", "SCT", "W9", "", "55.86667", "-3.68333", "Europe/London"),("2634138", "Whitburn", "", "GB", "826", "", "ENG", "M7", "", "54.95333", "-1.36861", "Europe/London"),("2634155", "Whickham", "", "GB", "826", "", "ENG", "E5", "00CH002", "54.94561", "-1.67635", "Europe/London"),("2634171", "Wheatley", "", "GB", "826", "", "ENG", "K2", "38UD", "51.74731", "-1.13936", "Europe/London"),("2634202", "Weymouth", "Уэймут", "GB", "826", "", "ENG", "D6", "19UJ", "50.61448", "-2.45991", "Europe/London"),("2634204", "Weybridge", "Вейбридж", "GB", "826", "", "ENG", "N7", "43UB", "51.37178", "-0.45975", "Europe/London"),("2634217", "Wetherby", "", "GB", "826", "", "ENG", "H3", "00DA028", "53.92836", "-1.38672", "Europe/London"),("2634234", "West Wickham", "", "GB", "826", "", "ENG", "GLA", "B8", "51.36667", "-0.01667", "Europe/London"),("2634251", "West Thurrock", "", "GB", "826", "", "ENG", "O3", "", "51.47828", "0.27672", "Europe/London"),("2634308", "Weston-super-Mare", "Уэстон-сьюпер-Мэр", "GB", "826", "", "ENG", "J4", "00HC038", "51.34603", "-2.97665", "Europe/London"),("2634340", "West Molesey", "", "GB", "826", "", "ENG", "N7", "43UB", "51.39985", "-0.37997", "Europe/London"),("2634345", "West Mersea", "", "GB", "826", "", "ENG", "E4", "22UG", "51.77798", "0.91873", "Europe/London"),("2634375", "West Kirby", "", "GB", "826", "", "ENG", "Q1", "", "53.37302", "-3.18417", "Europe/London"),("2634387", "Westhoughton", "", "GB", "826", "", "ENG", "B1", "00BL003", "53.54899", "-2.52464", "Europe/London"),("2634405", "West Hallam", "", "GB", "826", "", "ENG", "D3", "17UG", "52.97093", "-1.35846", "Europe/London"),("2634413", "Westgate on Sea", "", "GB", "826", "", "ENG", "G5", "29UE", "51.38239", "1.33673", "Europe/London"),("2634451", "West Drayton", "", "GB", "826", "", "ENG", "GLA", "F9", "51.5", "-0.46667", "Europe/London"),("2634478", "West Byfleet", "", "GB", "826", "", "ENG", "N7", "43UM", "51.33764", "-0.50649", "Europe/London"),("2634491", "West Bromwich", "Уэст-Бромидж", "GB", "826", "", "ENG", "L7", "47UB", "52.51868", "-1.9945", "Europe/London"),("2634493", "West Bridgford", "", "GB", "826", "", "ENG", "J9", "37UJ", "52.92979", "-1.12537", "Europe/London"),("2634538", "Wendover", "", "GB", "826", "", "ENG", "B9", "11UB", "51.76194", "-0.73986", "Europe/London"),("2634550", "Wem", "", "GB", "826", "", "ENG", "L6", "00GG184", "52.85835", "-2.71826", "Europe/London"),("2634552", "Welwyn Garden City", "Уэлин-Гарден-Сити", "GB", "826", "", "ENG", "F8", "26UL", "51.80174", "-0.20691", "Europe/London"),("2634560", "Welshpool", "", "GB", "826", "", "WLS", "Y8", "00NN106", "52.65973", "-3.1471", "Europe/London"),("2634569", "Wells", "", "GB", "826", "", "ENG", "M3", "40UB", "51.20794", "-2.64896", "Europe/London"),("2634573", "Wellington", "Веллингтон", "GB", "826", "", "ENG", "O2", "00GF026", "52.7", "-2.51667", "Europe/London"),("2634578", "Wellingborough", "Веллингборо", "GB", "826", "", "ENG", "J1", "34UH", "52.30273", "-0.69446", "Europe/London"),("2634579", "Welling", "", "GB", "826", "", "ENG", "GLA", "A6", "51.46246", "0.10759", "Europe/London"),("2634581", "Wellesbourne Mountford", "", "GB", "826", "", "ENG", "P3", "44UE", "52.18333", "-1.58333", "Europe/London"),("2634616", "Wednesfield", "", "GB", "826", "", "ENG", "Q3", "", "52.5963", "-2.08508", "Europe/London"),("2634617", "Wednesbury", "", "GB", "826", "", "ENG", "L7", "41UF", "52.5514", "-2.02355", "Europe/London"),("2634623", "Weaverham", "", "GB", "826", "", "ENG", "Z8", "00EW154", "53.26018", "-2.57291", "Europe/London"),("2634661", "Watton", "", "GB", "826", "", "ENG", "E1", "00FB154", "53.93333", "-0.45", "Europe/London"),("2634672", "Wath upon Dearne", "", "GB", "826", "", "ENG", "L3", "00CF003", "53.50291", "-1.3458", "Europe/London"),("2634677", "Watford", "Уотфорд", "GB", "826", "", "ENG", "F8", "26UK", "51.65531", "-0.39602", "Europe/London"),("2634686", "Waterlooville", "Уотерлувиль", "GB", "826", "", "ENG", "F2", "24UH", "50.88067", "-1.0304", "Europe/London"),("2634715", "Washington", "Вашингтон", "GB", "826", "", "ENG", "N6", "", "54.9", "-1.51667", "Europe/London"),("2634725", "Warwick", "Уорик", "GB", "826", "", "ENG", "P3", "44UF", "52.28333", "-1.58333", "Europe/London"),("2634736", "Warsop", "", "GB", "826", "", "ENG", "J9", "37UF", "53.21402", "-1.15091", "Europe/London"),("2634739", "Warrington", "Уоррингтон", "GB", "826", "", "ENG", "P2", "", "53.39254", "-2.58024", "Europe/London"),("2634743", "Warrenpoint", "", "GB", "826", "", "NIR", "N09000010", "", "54.10148", "-6.25731", "Europe/London"),("2634755", "Warminster", "", "GB", "826", "", "ENG", "P8", "00HY231", "51.20434", "-2.17873", "Europe/London"),("2634759", "Warlingham", "", "GB", "826", "", "ENG", "N7", "43UK", "51.30953", "-0.05794", "Europe/London"),("2634777", "Ware", "", "GB", "826", "", "ENG", "F8", "26UD", "51.81058", "-0.02875", "Europe/London"),("2634782", "Wardle", "", "GB", "826", "", "ENG", "L2", "", "53.65", "-2.13333", "Europe/London"),("2634801", "Wantage", "", "GB", "826", "", "ENG", "K2", "38UE", "51.58846", "-1.42565", "Europe/London"),("2634825", "Walton-on-Thames", "", "GB", "826", "", "ENG", "N7", "43UB", "51.38533", "-0.42066", "Europe/London"),("2634826", "Walton-on-the-Naze", "", "GB", "826", "", "ENG", "E4", "22UN", "51.84819", "1.26738", "Europe/London"),("2634842", "Waltham Cross", "", "GB", "826", "", "ENG", "F8", "26UB", "51.68602", "-0.03575", "Europe/London"),("2634843", "Waltham Abbey", "", "GB", "826", "", "ENG", "E4", "22UH", "51.687", "-0.00421", "Europe/London"),("2634844", "Waltham", "", "GB", "826", "", "ENG", "J2", "00FC018", "53.51667", "-0.1", "Europe/London"),("2634853", "Walsall", "Уолсолл", "GB", "826", "", "ENG", "O8", "41UF", "52.58528", "-1.98396", "Europe/London"),("2634864", "Wallsend", "Уолсенд", "GB", "826", "", "ENG", "J5", "", "54.99111", "-1.53397", "Europe/London"),("2634869", "Wallingford", "", "GB", "826", "", "ENG", "K2", "38UD", "51.59982", "-1.1248", "Europe/London"),("2634873", "Wallasey", "Уолласи", "GB", "826", "", "ENG", "Q1", "00CA009", "53.42324", "-3.06497", "Europe/London"),("2634887", "Walkden", "", "GB", "826", "", "ENG", "L5", "", "53.51667", "-2.4", "Europe/London"),("2634894", "Wales", "", "GB", "826", "", "ENG", "L3", "00CF023", "53.34061", "-1.28162", "Europe/London"),("2634910", "Wakefield", "", "GB", "826", "", "ENG", "O7", "", "53.68331", "-1.49768", "Europe/London"),("2634920", "Wadebridge", "", "GB", "826", "", "ENG", "C6", "00HE205", "50.51734", "-4.83633", "Europe/London"),("2634966", "Victoria", "", "GB", "826", "", "WLS", "X2", "00PL004", "51.75", "-3.2", "Europe/London"),("2634975", "Verwood", "", "GB", "826", "", "ENG", "D6", "19UD", "50.87575", "-1.87023", "Europe/London"),("2634985", "Ventnor", "", "GB", "826", "", "ENG", "G2", "00MW023", "50.5958", "-1.20751", "Europe/London"),("2635043", "Uttoxeter", "", "GB", "826", "", "ENG", "M9", "41UC", "52.89838", "-1.86488", "Europe/London"),("2635054", "Ushaw Moor", "", "GB", "826", "", "ENG", "D8", "00EJ014", "54.77803", "-1.6472", "Europe/London"),("2635062", "Urmston", "", "GB", "826", "", "ENG", "O6", "00BU001", "53.44852", "-2.35419", "Europe/London"),("2635150", "Upminster", "", "GB", "826", "", "ENG", "GLA", "F6", "51.55594", "0.2556", "Europe/London"),("2635183", "Ulverston", "", "GB", "826", "", "ENG", "C9", "16UG", "54.19594", "-3.09626", "Europe/London"),("2635239", "Uddingston", "", "GB", "826", "", "SCT", "W5", "", "55.81971", "-4.08362", "Europe/London"),("2635243", "Uckfield", "", "GB", "826", "", "ENG", "E2", "21UH", "50.96948", "0.09589", "Europe/London"),("2635269", "Tynemouth", "", "GB", "826", "", "ENG", "J5", "00EM167", "55.01788", "-1.42559", "Europe/London"),("2635281", "Tyldesley", "", "GB", "826", "", "ENG", "P7", "00BL003", "53.51393", "-2.46754", "Europe/London"),("2635294", "Twyford", "", "GB", "826", "", "ENG", "Q2", "00MF012", "51.47518", "-0.86037", "Europe/London"),("2635412", "Truro", "Труро", "GB", "826", "", "ENG", "C6", "00HE202", "50.26526", "-5.05436", "Europe/London"),("2635427", "Trowbridge", "Троубридже", "GB", "826", "", "ENG", "P8", "00HY226", "51.31889", "-2.20861", "Europe/London"),("2635442", "Troon", "", "GB", "826", "", "SCT", "W4", "", "55.54359", "-4.66335", "Europe/London"),("2635459", "Tring", "", "GB", "826", "", "ENG", "F8", "26UC", "51.79471", "-0.65824", "Europe/London"),("2635496", "Treorchy", "", "GB", "826", "", "WLS", "Y9", "00PF032", "51.65958", "-3.50587", "Europe/London"),("2635524", "Treharris", "", "GB", "826", "", "WLS", "Y3", "00PH010", "51.66457", "-3.30725", "Europe/London"),("2635547", "Tredegar", "", "GB", "826", "", "WLS", "X2", "00PL008", "51.77251", "-3.24679", "Europe/London"),("2635563", "Tranent", "", "GB", "826", "", "SCT", "U6", "", "55.94439", "-2.95412", "Europe/London"),("2635597", "Towcester", "", "GB", "826", "", "ENG", "J1", "34UG", "52.13359", "-0.99057", "Europe/London"),("2635603", "Totton", "", "GB", "826", "", "ENG", "F2", "24UJ", "50.91877", "-1.49037", "Europe/London"),("2635604", "Tottington", "", "GB", "826", "", "ENG", "C1", "00EX003", "53.61326", "-2.34071", "Europe/London"),("2635610", "Totnes", "", "GB", "826", "", "ENG", "D4", "18UG", "50.43107", "-3.6843", "Europe/London"),("2635650", "Torquay", "Торки", "GB", "826", "", "ENG", "O4", "", "50.46384", "-3.51434", "Europe/London"),("2635651", "Torpoint", "", "GB", "826", "", "ENG", "C6", "00HE193", "50.37505", "-4.19566", "Europe/London"),("2635689", "Tonyrefail", "", "GB", "826", "", "WLS", "Y9", "00PF028", "51.58402", "-3.43041", "Europe/London"),("2635703", "Tonbridge", "Тонбридж", "GB", "826", "", "ENG", "G5", "29UP", "51.19532", "0.27363", "Europe/London"),("2635744", "Todmorden", "", "GB", "826", "", "ENG", "C2", "00CY006", "53.71434", "-2.09701", "Europe/London"),("2635762", "Tiverton", "", "GB", "826", "", "ENG", "D4", "18UD", "50.90241", "-3.49232", "Europe/London"),("2635783", "Tiptree", "", "GB", "826", "", "ENG", "E4", "22UG", "51.8123", "0.7454", "Europe/London"),("2635785", "Tipton", "", "GB", "826", "", "ENG", "L7", "41UF", "52.52956", "-2.06773", "Europe/London"),("2635803", "Timperley", "", "GB", "826", "", "ENG", "O6", "", "53.4", "-2.33333", "Europe/London"),("2635829", "Tillicoultry", "", "GB", "826", "", "SCT", "U1", "", "56.15251", "-3.74015", "Europe/London"),("2635836", "Tilbury", "", "GB", "826", "", "ENG", "O3", "", "51.46248", "0.35856", "Europe/London"),("2635859", "Tickhill", "", "GB", "826", "", "ENG", "D5", "00CE041", "53.43194", "-1.10859", "Europe/London"),("2635881", "Thurso", "", "GB", "826", "", "SCT", "V3", "", "58.59271", "-3.52594", "Europe/London"),("2635963", "Thornton Heath", "", "GB", "826", "", "ENG", "GLA", "C8", "51.39884", "-0.09872", "Europe/London"),("2636005", "Thornaby-on-Tees", "", "GB", "826", "", "ENG", "N3", "00EF016", "54.53333", "-1.3", "Europe/London"),("2636021", "Thirsk", "", "GB", "826", "", "ENG", "J7", "36UC", "54.23298", "-1.34411", "Europe/London"),("2636032", "Thetford", "Тетфорд", "GB", "826", "", "ENG", "I9", "33UB", "52.41667", "0.75", "Europe/London"),("2636049", "Thatcham", "", "GB", "826", "", "ENG", "P4", "00MB049", "51.40366", "-1.26049", "Europe/London"),("2636062", "Thames Ditton", "", "GB", "826", "", "ENG", "N7", "43UB", "51.38964", "-0.33928", "Europe/London"),("2636066", "Thame", "", "GB", "826", "", "ENG", "K2", "38UD", "51.7484", "-0.97624", "Europe/London"),("2636071", "Tewkesbury", "", "GB", "826", "", "ENG", "E6", "23UG", "51.99244", "-2.1601", "Europe/London"),("2636083", "Tetbury", "", "GB", "826", "", "ENG", "E6", "23UC", "51.63944", "-2.16222", "Europe/London"),("2636101", "Tenterden", "", "GB", "826", "", "ENG", "G5", "29UB", "51.06845", "0.68776", "Europe/London"),("2636132", "Teignmouth", "Тинмут", "GB", "826", "", "ENG", "D4", "18UH", "50.54768", "-3.49637", "Europe/London"),("2636147", "Teddington", "", "GB", "826", "", "ENG", "GLA", "L1", "51.42233", "-0.33053", "Europe/London"),("2636174", "Tavistock", "", "GB", "826", "", "ENG", "D4", "18UL", "50.54944", "-4.14418", "Europe/London"),("2636177", "Taunton", "Тонтон", "GB", "826", "", "ENG", "M3", "40UE", "51.01494", "-3.10293", "Europe/London"),("2636215", "Tarleton", "", "GB", "826", "", "ENG", "H2", "30UP", "53.68005", "-2.82968", "Europe/London"),("2636276", "Tamworth", "", "GB", "826", "", "ENG", "M9", "41UK", "52.63399", "-1.69587", "Europe/London"),("2636331", "Tadworth", "", "GB", "826", "", "ENG", "N7", "43UF", "51.29169", "-0.23582", "Europe/London"),("2636333", "Tadley", "", "GB", "826", "", "ENG", "F2", "24UB", "51.35045", "-1.1285", "Europe/London"),("2636335", "Tadcaster", "", "GB", "826", "", "ENG", "J7", "36UH", "53.88322", "-1.26344", "Europe/London"),("2636341", "Syston", "", "GB", "826", "", "ENG", "H5", "31UC", "52.68333", "-1.06667", "Europe/London"),("2636373", "Swinton", "", "GB", "826", "", "ENG", "I2", "", "53.5", "-2.35", "Europe/London"),("2636389", "Swindon", "Свиндон", "GB", "826", "", "ENG", "N9", "00HX015", "51.55797", "-1.78116", "Europe/London"),("2636432", "Swansea", "Суонси", "GB", "826", "", "WLS", "Z1", "00NX004", "51.62079", "-3.94323", "Europe/London"),("2636433", "Swanscombe", "", "GB", "826", "", "ENG", "G5", "29UD", "51.44713", "0.31028", "Europe/London"),("2636439", "Swanley", "", "GB", "826", "", "ENG", "G5", "6945814", "51.39717", "0.17321", "Europe/London"),("2636445", "Swanage", "", "GB", "826", "", "ENG", "D6", "19UG", "50.60923", "-1.9626", "Europe/London"),("2636464", "Swaffham", "", "GB", "826", "", "ENG", "I9", "33UB", "52.6477", "0.6857", "Europe/London"),("2636465", "Swadlincote", "", "GB", "826", "", "ENG", "D3", "17UK", "52.774", "-1.55744", "Europe/London"),("2636484", "Sutton in Ashfield", "", "GB", "826", "", "ENG", "J9", "37UB", "53.12542", "-1.26135", "Europe/London"),("2636486", "Sutton Coldfield", "", "GB", "826", "", "ENG", "A7", "", "52.56667", "-1.81667", "Europe/London"),("2636503", "Sutton", "Саттон", "GB", "826", "", "ENG", "GLA", "N8", "51.35", "-0.2", "Europe/London"),("2636531", "Sunderland", "Сандерленд", "GB", "826", "", "ENG", "N6", "", "54.90465", "-1.38222", "Europe/London"),("2636534", "Sunbury-on-Thames", "", "GB", "826", "", "ENG", "N7", "43UH", "51.40424", "-0.41817", "Europe/London"),("2636564", "Sudbury", "", "GB", "826", "", "ENG", "N5", "42UB", "52.0389", "0.73117", "Europe/London"),("2636594", "Studley", "", "GB", "826", "", "ENG", "P3", "44UE", "52.27026", "-1.89188", "Europe/London"),("2636616", "Stroud", "Страуд", "GB", "826", "", "ENG", "E6", "23UF", "51.75", "-2.2", "Europe/London"),("2636619", "Strood", "", "GB", "826", "", "ENG", "G5", "", "51.39323", "0.47713", "Europe/London"),("2636663", "Stretford", "Стретфорд", "GB", "826", "", "ENG", "O6", "", "53.45", "-2.31667", "Europe/London"),("2636667", "Strensall", "", "GB", "826", "", "ENG", "Q5", "00FF033", "54.03999", "-1.03512", "Europe/London"),("2636670", "Streetly", "", "GB", "826", "", "ENG", "O8", "", "52.58333", "-1.88333", "Europe/London"),("2636671", "Street", "", "GB", "826", "", "ENG", "M3", "40UB", "51.12472", "-2.74", "Europe/London"),("2636710", "Strathaven", "", "GB", "826", "", "SCT", "W5", "", "55.6771", "-4.0668", "Europe/London"),("2636713", "Stratford-upon-Avon", "Стратфорд-на-Эйвоне", "GB", "826", "", "ENG", "P3", "44UE", "52.19166", "-1.70734", "Europe/London"),("2636719", "Stranraer", "", "GB", "826", "", "SCT", "U2", "", "54.90234", "-5.02731", "Europe/London"),("2636744", "Strabane", "", "GB", "826", "", "NIR", "N09000005", "", "54.82373", "-7.46916", "Europe/London"),("2636749", "Stowmarket", "", "GB", "826", "", "ENG", "N5", "42UE", "52.18893", "0.99774", "Europe/London"),("2636767", "Stourport-on-Severn", "", "GB", "826", "", "ENG", "Q4", "47UG", "52.35", "-2.26667", "Europe/London"),("2636769", "Stourbridge", "Стоурбридж", "GB", "826", "", "ENG", "D7", "47UB", "52.45608", "-2.14317", "Europe/London"),("2636782", "Stotfold", "", "GB", "826", "", "ENG", "Z6", "00KC065", "52.01632", "-0.23209", "Europe/London"),("2636786", "Storrington", "", "GB", "826", "", "ENG", "P6", "45UF", "50.91765", "-0.45473", "Europe/London"),("2636790", "Stornoway", "", "GB", "826", "", "SCT", "W8", "", "58.20925", "-6.38649", "Europe/London"),("2636804", "Stone", "", "GB", "826", "", "ENG", "G5", "29UD", "51.45032", "0.2647", "Europe/London"),("2636811", "Stonehouse", "", "GB", "826", "", "ENG", "E6", "23UF", "51.75", "-2.28333", "Europe/London"),("2636814", "Stonehaven", "", "GB", "826", "", "SCT", "T6", "", "56.96365", "-2.21177", "Europe/London"),("2636822", "Stone", "", "GB", "826", "", "ENG", "M9", "41UG", "52.9059", "-2.15409", "Europe/London"),("2636826", "Stone", "", "GB", "826", "", "ENG", "G5", "29UB", "51", "0.76667", "Europe/London"),("2636841", "Stoke-on-Trent", "Сток-он-Трент", "GB", "826", "", "ENG", "N4", "", "53.00415", "-2.18538", "Europe/London"),("2636854", "Stoke Gifford", "", "GB", "826", "", "ENG", "M6", "00HD035", "51.51686", "-2.54053", "Europe/London"),("2636876", "Stockton-on-Tees", "Стоктон-он-Тис", "GB", "826", "", "ENG", "N3", "", "54.56848", "-1.3187", "Europe/London"),("2636881", "Stocksbridge", "", "GB", "826", "", "ENG", "L9", "00CG003", "53.48249", "-1.59373", "Europe/London"),("2636882", "Stockport", "Стокпорт", "GB", "826", "", "ENG", "N2", "", "53.40979", "-2.15761", "Europe/London"),("2636910", "Stirling", "Стерлинг", "GB", "826", "", "SCT", "W6", "", "56.11903", "-3.93682", "Europe/London"),("2636928", "Steyning", "", "GB", "826", "", "ENG", "P6", "45UF", "50.88744", "-0.32787", "Europe/London"),("2636932", "Stewarton", "", "GB", "826", "", "SCT", "U4", "", "55.67986", "-4.51435", "Europe/London"),("2636938", "Stevenston", "", "GB", "826", "", "SCT", "V7", "", "55.6397", "-4.75339", "Europe/London"),("2636940", "Stevenage", "Стивенедж", "GB", "826", "", "ENG", "F8", "26UH", "51.90224", "-0.20256", "Europe/London"),("2636995", "Staveley", "", "GB", "826", "", "ENG", "D3", "17UD", "53.26667", "-1.35", "Europe/London"),("2637016", "Staplehurst", "", "GB", "826", "", "ENG", "G5", "29UH", "51.1611", "0.55249", "Europe/London"),("2637052", "Stansted", "", "GB", "826", "", "ENG", "E4", "22UQ", "51.9", "0.2", "Europe/London"),("2637087", "Stanford-le-Hope", "", "GB", "826", "", "ENG", "O3", "", "51.52274", "0.43422", "Europe/London"),("2637104", "Stamford", "Стамфорд", "GB", "826", "", "ENG", "H7", "32UG", "52.65", "-0.48333", "Europe/London"),("2637106", "Stalybridge", "Сталибридж", "GB", "826", "", "ENG", "O1", "00BT001", "53.48414", "-2.05908", "Europe/London"),("2637124", "Stainforth", "", "GB", "826", "", "ENG", "D5", "00CE036", "53.6", "-1.03333", "Europe/London"),("2637126", "Staines", "", "GB", "826", "", "ENG", "N7", "43UH", "51.43092", "-0.50606", "Europe/London"),("2637142", "Stafford", "Стаффорд", "GB", "826", "", "ENG", "M9", "41UG", "52.80521", "-2.11636", "Europe/London"),("2637235", "Spennymoor", "", "GB", "826", "", "ENG", "D8", "00EJ107", "54.6988", "-1.60229", "Europe/London"),("2637265", "Spalding", "", "GB", "826", "", "ENG", "H7", "32UF", "52.78709", "-0.15141", "Europe/London"),("2637268", "Sowerby Bridge", "", "GB", "826", "", "ENG", "C2", "00CY005", "53.70903", "-1.90929", "Europe/London"),("2637296", "Southwell", "", "GB", "826", "", "ENG", "J9", "37UG", "53.07804", "-0.95538", "Europe/London"),("2637298", "Southwater", "", "GB", "826", "", "ENG", "P6", "45UF", "51.02369", "-0.35173", "Europe/London"),("2637310", "Tidworth", "", "GB", "826", "", "ENG", "P8", "00HY221", "51.23142", "-1.66324", "Europe/London"),("2637329", "South Shields", "Саут-Шилдс", "GB", "826", "", "ENG", "M7", "00EM167", "54.99859", "-1.4323", "Europe/London"),("2637330", "Southsea", "", "GB", "826", "", "ENG", "K6", "", "50.79205", "-1.08593", "Europe/London"),("2637343", "Southport", "", "GB", "826", "", "ENG", "L8", "", "53.64581", "-3.01008", "Europe/London"),("2637355", "South Ockendon", "", "GB", "826", "", "ENG", "O3", "", "51.50799", "0.28333", "Europe/London"),("2637433", "Southend-on-Sea", "Саутенд-он-Си", "GB", "826", "", "ENG", "M5", "", "51.53782", "0.71433", "Europe/London"),("2637435", "South Elmsall", "", "GB", "826", "", "ENG", "O7", "00DB020", "53.59709", "-1.28034", "Europe/London"),("2637476", "South Benfleet", "", "GB", "826", "", "ENG", "E4", "22UE", "51.55295", "0.55962", "Europe/London"),("2637487", "Southampton", "Саутгемптон", "GB", "826", "", "ENG", "M4", "24UJ", "50.90395", "-1.40428", "Europe/London"),("2637488", "Southam", "", "GB", "826", "", "ENG", "P3", "44UE", "52.25266", "-1.3884", "Europe/London"),("2637490", "Southall", "", "GB", "826", "", "ENG", "GLA", "D9", "51.50896", "-0.3713", "Europe/London"),("2637546", "Solihull", "Солихалл", "GB", "826", "", "ENG", "M2", "00CT008", "52.41426", "-1.78094", "Europe/London"),("2637554", "Soham", "", "GB", "826", "", "ENG", "C3", "2650488", "52.33543", "0.33654", "Europe/London"),("2637571", "Snodland", "", "GB", "826", "", "ENG", "G5", "29UP", "51.32971", "0.44305", "Europe/London"),("2637607", "Smethwick", "", "GB", "826", "", "ENG", "L7", "", "52.49268", "-1.96745", "Europe/London"),("2637627", "Slough", "Слау", "GB", "826", "", "ENG", "M1", "", "51.50949", "-0.59541", "Europe/London"),("2637659", "Sleaford", "", "GB", "826", "", "ENG", "H7", "32UE", "52.99826", "-0.40941", "Europe/London"),("2637702", "Skipton", "", "GB", "826", "", "ENG", "J7", "36UB", "53.96144", "-2.01676", "Europe/London"),("2637748", "Skelton", "", "GB", "826", "", "ENG", "E1", "00FB082", "53.72521", "-0.84187", "Europe/London"),("2637752", "Skelmersdale", "", "GB", "826", "", "ENG", "H2", "30UP", "53.55024", "-2.77348", "Europe/London"),("2637762", "Skegness", "", "GB", "826", "", "ENG", "H7", "32UC", "53.14362", "0.3363", "Europe/London"),("2637802", "Sittingbourne", "", "GB", "826", "", "ENG", "G5", "29UM", "51.34128", "0.73282", "Europe/London"),("2637833", "Silsden", "", "GB", "826", "", "ENG", "B4", "00CX006", "53.91443", "-1.93802", "Europe/London"),("2637845", "Sileby", "", "GB", "826", "", "ENG", "H5", "31UC", "52.73286", "-1.10773", "Europe/London"),("2637853", "Sidmouth", "", "GB", "826", "", "ENG", "D4", "18UB", "50.69094", "-3.2397", "Europe/London"),("2637861", "Sidcup", "", "GB", "826", "", "ENG", "GLA", "A6", "51.42619", "0.1036", "Europe/London"),("2637891", "Shrewsbury", "Шрусбери", "GB", "826", "", "ENG", "L6", "00GG162", "52.71009", "-2.75208", "Europe/London"),("2637916", "Shoreham-by-Sea", "", "GB", "826", "", "ENG", "P6", "45UB", "50.83413", "-0.27431", "Europe/London"),("2637917", "Shoreham", "", "GB", "826", "", "ENG", "G5", "6945814", "51.3334", "0.17801", "Europe/London"),("2637941", "Shirebrook", "", "GB", "826", "", "ENG", "D3", "17UC", "53.20333", "-1.21336", "Europe/London"),("2637958", "Shipley", "", "GB", "826", "", "ENG", "B4", "", "53.83333", "-1.76667", "Europe/London"),("2637983", "Shildon", "", "GB", "826", "", "ENG", "D8", "00EJ102", "54.62997", "-1.64295", "Europe/London"),("2637985", "Shifnal", "", "GB", "826", "", "ENG", "L6", "00GG160", "52.67043", "-2.37248", "Europe/London"),("2638009", "Shevington", "", "GB", "826", "", "ENG", "P7", "00BW002", "53.57236", "-2.69316", "Europe/London"),("2638019", "Sheringham", "", "GB", "826", "", "ENG", "I9", "33UF", "52.94078", "1.20931", "Europe/London"),("2638027", "Sherburn in Elmet", "", "GB", "826", "", "ENG", "J7", "36UH", "53.79519", "-1.2466", "Europe/London"),("2638033", "Sherborne", "", "GB", "826", "", "ENG", "D6", "19UH", "50.94599", "-2.51776", "Europe/London"),("2638035", "Shepton Mallet", "", "GB", "826", "", "ENG", "M3", "40UB", "51.18972", "-2.54722", "Europe/London"),("2638036", "Shepshed", "", "GB", "826", "", "ENG", "H5", "31UC", "52.7657", "-1.29021", "Europe/London"),("2638039", "Shepperton", "", "GB", "826", "", "ENG", "N7", "43UH", "51.39546", "-0.44889", "Europe/London"),("2638065", "Shelley", "", "GB", "826", "", "ENG", "G8", "00CZ003", "53.6", "-1.68333", "Europe/London"),("2638077", "Sheffield", "Шеффилд", "GB", "826", "", "ENG", "L9", "", "53.38297", "-1.4659", "Europe/London"),("2638081", "Sheerness", "", "GB", "826", "", "ENG", "G5", "29UM", "51.44042", "0.76252", "Europe/London"),("2638138", "Shanklin", "", "GB", "826", "", "ENG", "G2", "00MW020", "50.62613", "-1.1785", "Europe/London"),("2638157", "Shaftesbury", "", "GB", "826", "", "ENG", "D6", "19UE", "51.00528", "-2.19333", "Europe/London"),("2638187", "Sevenoaks", "Севенокс", "GB", "826", "", "ENG", "G5", "6945814", "51.27266", "0.18883", "Europe/London"),("2638207", "Send", "", "GB", "826", "", "ENG", "N7", "43UD", "51.28875", "-0.52666", "Europe/London"),("2638219", "Selsey", "", "GB", "826", "", "ENG", "P6", "45UD", "50.73501", "-0.78979", "Europe/London"),("2638229", "Selkirk", "", "GB", "826", "", "SCT", "T9", "", "55.54738", "-2.83911", "Europe/London"),("2638235", "Selby", "Селби", "GB", "826", "", "ENG", "J7", "36UH", "53.78333", "-1.06667", "Europe/London"),("2638273", "Seaton Delaval", "", "GB", "826", "", "ENG", "J6", "00EM167", "55.07196", "-1.52609", "Europe/London"),("2638277", "Seaton", "", "GB", "826", "", "ENG", "L4", "00FP044", "52.57489", "-0.66759", "Europe/London"),("2638302", "Seaham", "Сихем", "GB", "826", "", "ENG", "D8", "00EJ096", "54.83903", "-1.34575", "Europe/London"),("2638311", "Seaford", "", "GB", "826", "", "ENG", "E2", "21UF", "50.77141", "0.10268", "Europe/London"),("2638324", "Scunthorpe", "Сканторпе", "GB", "826", "", "ENG", "J3", "", "53.57905", "-0.65437", "Europe/London"),("2638419", "Scarborough", "Скарборо", "GB", "826", "", "ENG", "J7", "36UG", "54.27966", "-0.40443", "Europe/London"),("2638448", "Scalby", "", "GB", "826", "", "ENG", "E1", "00FB100", "53.76667", "-0.71667", "Europe/London"),("2638473", "Sawtry", "", "GB", "826", "", "ENG", "C3", "12UE", "52.43984", "-0.28422", "Europe/London"),("2638474", "Sawston", "", "GB", "826", "", "ENG", "C3", "12UG", "52.12089", "0.16943", "Europe/London"),("2638481", "Sawbridgeworth", "", "GB", "826", "", "ENG", "F8", "26UD", "51.81667", "0.15", "Europe/London"),("2638530", "Sandy", "", "GB", "826", "", "ENG", "Z6", "00KC056", "52.12927", "-0.28925", "Europe/London"),("2638568", "Sandown", "Сандаун", "GB", "826", "", "ENG", "G2", "00MW018", "50.65158", "-1.16103", "Europe/London"),("2638600", "Sandbach", "", "GB", "826", "", "ENG", "Z7", "00EQ113", "53.14515", "-2.36251", "Europe/London"),("2638648", "Saltcoats", "", "GB", "826", "", "SCT", "V7", "", "55.63616", "-4.78588", "Europe/London"),("2638650", "Saltburn-by-the-Sea", "", "GB", "826", "", "ENG", "K9", "00EE004", "54.58237", "-0.97367", "Europe/London"),("2638651", "Saltash", "", "GB", "826", "", "ENG", "C6", "00HE121", "50.40959", "-4.22514", "Europe/London"),("2638664", "Salisbury", "Солсбери", "GB", "826", "", "ENG", "P8", "00HY261", "51.06931", "-1.79569", "Europe/London"),("2638671", "Salford", "Солфорд", "GB", "826", "", "ENG", "L5", "", "53.48771", "-2.29042", "Europe/London"),("2638678", "Sale", "Сейл", "GB", "826", "", "ENG", "O6", "00BU001", "53.42519", "-2.32443", "Europe/London"),("2638717", "Saint Neots", "", "GB", "826", "", "ENG", "C3", "12UE", "52.21667", "-0.26667", "Europe/London"),("2638756", "Saint Leonards-on-Sea", "", "GB", "826", "", "ENG", "E2", "21UD", "50.85565", "0.5452", "Europe/London"),("2638757", "St Leonards", "", "GB", "826", "", "ENG", "D6", "19UD", "50.83077", "-1.84377", "Europe/London"),("2638778", "St Ives", "", "GB", "826", "", "ENG", "C6", "00HE158", "50.20861", "-5.4875", "Europe/London"),("2638785", "St Helens", "Сент-Хеленс", "GB", "826", "", "ENG", "N1", "", "53.45", "-2.73333", "Europe/London"),("2638853", "St Austell", "", "GB", "826", "", "ENG", "C6", "00HE131", "50.3425", "-4.77442", "Europe/London"),("2638864", "Saint Andrews", "Сент-Андрус", "GB", "826", "", "SCT", "V1", "", "56.33871", "-2.79902", "Europe/London"),("2638867", "St Albans", "Сент-Олбанс", "GB", "826", "", "ENG", "F8", "6615330", "51.75", "-0.33333", "Europe/London"),("2638878", "Saffron Walden", "", "GB", "826", "", "ENG", "E4", "22UQ", "52.02337", "0.24234", "Europe/London"),("2638894", "Ryton", "", "GB", "826", "", "ENG", "L6", "00GG155", "52.61667", "-2.35", "Europe/London"),("2638899", "Ryhope", "", "GB", "826", "", "ENG", "N6", "", "54.87139", "-1.37", "Europe/London"),("2638911", "Ryde", "Райд", "GB", "826", "", "ENG", "G2", "00MW032", "50.72999", "-1.1621", "Europe/London"),("2638925", "Ruthin", "", "GB", "826", "", "WLS", "X9", "00NG036", "53.11368", "-3.31782", "Europe/London"),("2638926", "Rutherglen", "", "GB", "826", "", "SCT", "W5", "", "55.82885", "-4.21376", "Europe/London"),("2638930", "Rustington", "", "GB", "826", "", "ENG", "P6", "45UC", "50.81027", "-0.50674", "Europe/London"),("2638938", "Ruskington", "", "GB", "826", "", "ENG", "H7", "32UE", "53.04544", "-0.38692", "Europe/London"),("2638946", "Rushden", "", "GB", "826", "", "ENG", "J1", "34UD", "52.28927", "-0.60184", "Europe/London"),("2638960", "Runcorn", "", "GB", "826", "", "ENG", "E9", "00ET005", "53.34174", "-2.73124", "Europe/London"),("2638976", "Ruislip", "", "GB", "826", "", "ENG", "GLA", "F9", "51.57344", "-0.42341", "Europe/London"),("2638977", "Rugeley", "", "GB", "826", "", "ENG", "M9", "41UB", "52.7593", "-1.93694", "Europe/London"),("2638978", "Rugby", "Рагби", "GB", "826", "", "ENG", "P3", "44UD", "52.37092", "-1.26417", "Europe/London"),("2638995", "Ruddington", "", "GB", "826", "", "ENG", "J9", "37UJ", "52.89254", "-1.14953", "Europe/London"),("2639015", "Royton", "", "GB", "826", "", "ENG", "K1", "00BP002", "53.56507", "-2.12267", "Europe/London"),("2639017", "Royston", "", "GB", "826", "", "ENG", "A3", "", "53.6", "-1.45", "Europe/London"),("2639018", "Royston", "", "GB", "826", "", "ENG", "F8", "26UF", "52.04832", "-0.02438", "Europe/London"),("2639022", "Royal Tunbridge Wells", "", "GB", "826", "", "ENG", "G5", "29UQ", "51.13321", "0.26256", "Europe/London"),("2639042", "Rowlands Gill", "", "GB", "826", "", "ENG", "E5", "00EJ110", "54.91922", "-1.74489", "Europe/London"),("2639069", "Rottingdean", "", "GB", "826", "", "ENG", "B6", "00ML001", "50.80984", "-0.05939", "Europe/London"),("2639074", "Rothwell", "", "GB", "826", "", "ENG", "J1", "34UE", "52.41667", "-0.8", "Europe/London"),("2639093", "Rotherham", "Ротерем", "GB", "826", "", "ENG", "L3", "00CF004", "53.43012", "-1.35678", "Europe/London"),("2639104", "Rosyth", "", "GB", "826", "", "SCT", "V1", "", "56.03689", "-3.438", "Europe/London"),("2639110", "Ross on Wye", "", "GB", "826", "", "ENG", "F7", "00GA182", "51.91667", "-2.56667", "Europe/London"),("2639189", "Romsey", "", "GB", "826", "", "ENG", "F2", "24UN", "50.98906", "-1.49989", "Europe/London"),("2639265", "Rochford", "", "GB", "826", "", "ENG", "E4", "22UL", "51.58198", "0.70673", "Europe/London"),("2639268", "Rochester", "Рочестер", "GB", "826", "", "ENG", "I3", "", "51.38764", "0.50546", "Europe/London"),("2639272", "Rochdale", "Рочдейл", "GB", "826", "", "ENG", "L2", "30UM", "53.61766", "-2.1552", "Europe/London"),("2639310", "Rishton", "", "GB", "826", "", "ENG", "H2", "30UG", "53.76806", "-2.41444", "Europe/London"),("2639317", "Risca", "", "GB", "826", "", "WLS", "X4", "00PK023", "51.60799", "-3.10081", "Europe/London"),("2639323", "Ripon", "Рипон", "GB", "826", "", "ENG", "J7", "36UD", "54.13579", "-1.52826", "Europe/London"),("2639325", "Ripley", "Рипли", "GB", "826", "", "ENG", "D3", "17UB", "53.03333", "-1.4", "Europe/London"),("2639334", "Ringwood", "", "GB", "826", "", "ENG", "F2", "24UJ", "50.84541", "-1.78871", "Europe/London"),("2639381", "Rickmansworth", "", "GB", "826", "", "ENG", "F8", "26UJ", "51.63898", "-0.47718", "Europe/London"),("2639389", "Richmond", "", "GB", "826", "", "ENG", "GLA", "L1", "51.46171", "-0.30633", "Europe/London"),("2639407", "Rhymney", "", "GB", "826", "", "WLS", "X4", "00PK022", "51.75998", "-3.28553", "Europe/London"),("2639409", "Rhyl", "Рил", "GB", "826", "", "WLS", "X9", "00NG035", "53.31929", "-3.49228", "Europe/London"),("2639436", "Rhosllanerchrugog", "", "GB", "826", "", "WLS", "Z4", "00NL029", "53.00974", "-3.05814", "Europe/London"),("2639447", "Rhondda", "", "GB", "826", "", "WLS", "Y9", "00PF007", "51.65896", "-3.44885", "Europe/London"),("2639495", "Renfrew", "Ренфру", "GB", "826", "", "SCT", "W2", "", "55.87197", "-4.39253", "Europe/London"),("2639506", "Reigate", "Райгейт", "GB", "826", "", "ENG", "N7", "43UF", "51.23736", "-0.20582", "Europe/London"),("2639545", "Redhill", "", "GB", "826", "", "ENG", "N7", "43UF", "51.24048", "-0.17044", "Europe/London"),("2639557", "Redditch", "Реддитч", "GB", "826", "", "ENG", "Q4", "47UD", "52.3065", "-1.94569", "Europe/London"),("2639563", "Redcar", "", "GB", "826", "", "ENG", "K9", "00EE004", "54.61657", "-1.05999", "Europe/London"),("2639577", "Reading", "Рединг", "GB", "826", "", "ENG", "K7", "", "51.45625", "-0.97113", "Europe/London"),("2639583", "Rayleigh", "", "GB", "826", "", "ENG", "E4", "22UL", "51.58571", "0.60459", "Europe/London"),("2639586", "Rawtenstall", "", "GB", "826", "", "ENG", "H2", "30UM", "53.70076", "-2.28442", "Europe/London"),("2639588", "Rawmarsh", "", "GB", "826", "", "ENG", "L3", "00CF024", "53.46062", "-1.34437", "Europe/London"),("2639600", "Raunds", "", "GB", "826", "", "ENG", "J1", "34UD", "52.34428", "-0.53657", "Europe/London"),("2639653", "Randalstown", "", "GB", "826", "", "NIR", "N09000001", "", "54.75", "-6.3", "Europe/London"),("2639660", "Ramsgate", "Рамсгейт", "GB", "826", "", "ENG", "G5", "2636057", "51.33568", "1.41797", "Europe/London"),("2639664", "Ramsey", "", "GB", "826", "", "ENG", "C3", "12UE", "52.45058", "-0.10932", "Europe/London"),("2639668", "Ramsbottom", "", "GB", "826", "", "ENG", "C1", "", "53.64789", "-2.31683", "Europe/London"),("2639687", "Rainworth", "", "GB", "826", "", "ENG", "J9", "37UG", "53.11883", "-1.11852", "Europe/London"),("2639691", "Rainham", "", "GB", "826", "", "ENG", "G5", "", "51.36323", "0.60893", "Europe/London"),("2639693", "Rainford", "", "GB", "826", "", "ENG", "N1", "00BZ004", "53.50223", "-2.78839", "Europe/London"),("2639715", "Radstock", "", "GB", "826", "", "ENG", "A4", "00HA033", "51.28862", "-2.46003", "Europe/London"),("2639720", "Radlett", "", "GB", "826", "", "ENG", "F8", "26UE", "51.68593", "-0.31868", "Europe/London"),("2639727", "Radcliffe on Trent", "", "GB", "826", "", "ENG", "J9", "37UJ", "52.94802", "-1.03855", "Europe/London"),("2639755", "Quorndon", "", "GB", "826", "", "ENG", "H5", "31UC", "52.74461", "-1.17348", "Europe/London"),("2639788", "Queensferry", "", "GB", "826", "", "SCT", "U8", "", "55.99089", "-3.39847", "Europe/London"),("2639792", "Queensbury", "", "GB", "826", "", "ENG", "B4", "", "53.76667", "-1.91667", "Europe/London"),("2639823", "Pyle", "", "GB", "826", "", "WLS", "X3", "00PB021", "51.51667", "-3.7", "Europe/London"),("2639842", "Purley", "", "GB", "826", "", "ENG", "GLA", "C8", "51.33678", "-0.11201", "Europe/London"),("2639845", "Purfleet", "", "GB", "826", "", "ENG", "O3", "", "51.4839", "0.24247", "Europe/London"),("2639866", "Pudsey", "", "GB", "826", "", "ENG", "H3", "", "53.79538", "-1.66134", "Europe/London"),("2639874", "Prudhoe", "", "GB", "826", "", "ENG", "J6", "00EM128", "54.96154", "-1.85168", "Europe/London"),("2639888", "Princes Risborough", "", "GB", "826", "", "ENG", "B9", "11UF", "51.72549", "-0.83144", "Europe/London"),("2639896", "Prestwick", "Престуик", "GB", "826", "", "SCT", "W4", "", "55.48333", "-4.61667", "Europe/London"),("2639897", "Prestwich", "", "GB", "826", "", "ENG", "C1", "", "53.53333", "-2.28333", "Europe/London"),("2639902", "Prestonpans", "", "GB", "826", "", "SCT", "U6", "", "55.95939", "-2.98038", "Europe/London"),("2639912", "Preston", "Престон", "GB", "826", "", "ENG", "H2", "30UK", "53.76282", "-2.70452", "Europe/London"),("2639926", "Prestatyn", "", "GB", "826", "", "WLS", "X9", "00NG033", "53.33748", "-3.40776", "Europe/London"),("2639928", "Prescot", "", "GB", "826", "", "ENG", "G9", "00BX004", "53.42948", "-2.80031", "Europe/London"),("2639941", "Poynton", "", "GB", "826", "", "ENG", "Z7", "00EQ107", "53.35", "-2.11667", "Europe/London"),("2639958", "Poulton le Fylde", "", "GB", "826", "", "ENG", "H2", "30UQ", "53.83333", "-2.98333", "Europe/London"),("2639970", "Potters Bar", "", "GB", "826", "", "ENG", "F8", "26UE", "51.69353", "-0.17835", "Europe/London"),("2639991", "Portstewart", "", "GB", "826", "", "NIR", "N09000004", "", "55.18132", "-6.71402", "Europe/London"),("2639996", "Portsmouth", "Портсмут", "GB", "826", "", "ENG", "K6", "00MR001", "50.79899", "-1.09125", "Europe/London"),("2639998", "Portslade", "", "GB", "826", "", "ENG", "E2", "", "50.84286", "-0.21608", "Europe/London"),("2640004", "Portrush", "", "GB", "826", "", "NIR", "N09000004", "", "55.19592", "-6.6493", "Europe/London"),("2640030", "Portlethen", "", "GB", "826", "", "SCT", "T6", "", "57.05474", "-2.13066", "Europe/London"),("2640037", "Portishead", "", "GB", "826", "", "ENG", "J4", "00HC027", "51.48199", "-2.76973", "Europe/London"),("2640054", "Porthcawl", "", "GB", "826", "", "WLS", "X3", "00PB017", "51.47903", "-3.70362", "Europe/London"),("2640060", "Port Glasgow", "", "GB", "826", "", "SCT", "V4", "", "55.93464", "-4.6895", "Europe/London"),("2640085", "Portadown", "", "GB", "826", "", "NIR", "N09000002", "", "54.42302", "-6.44434", "Europe/London"),("2640101", "Poole", "Пул", "GB", "826", "", "ENG", "K5", "", "50.71429", "-1.98458", "Europe/London"),("2640104", "Pontypridd", "Понтиприте", "GB", "826", "", "WLS", "Y9", "00PF023", "51.6021", "-3.34211", "Europe/London"),("2640106", "Pontypool", "", "GB", "826", "", "WLS", "Z2", "00PM014", "51.70111", "-3.04444", "Europe/London"),("2640131", "Ponteland", "", "GB", "826", "", "ENG", "J6", "00EM127", "55.05024", "-1.74532", "Europe/London"),("2640132", "Pontefract", "", "GB", "826", "", "ENG", "O7", "", "53.69107", "-1.31269", "Europe/London"),("2640134", "Pontarddulais", "", "GB", "826", "", "WLS", "Z1", "00NX030", "51.71423", "-4.03859", "Europe/London"),("2640155", "Polmont", "Полмонте", "GB", "826", "", "SCT", "U9", "", "55.9905", "-3.70737", "Europe/London"),("2640185", "Pocklington", "", "GB", "826", "", "ENG", "E1", "00FB110", "53.93335", "-0.78106", "Europe/London"),("2640190", "Plymstock", "", "GB", "826", "", "ENG", "K4", "18UG", "50.35999", "-4.09049", "Europe/London"),("2640192", "Plympton", "", "GB", "826", "", "ENG", "D4", "", "50.39074", "-4.06022", "Europe/London"),("2640194", "Plymouth", "Плимут", "GB", "826", "", "ENG", "K4", "", "50.37153", "-4.14305", "Europe/London"),("2640246", "Pitsea", "", "GB", "826", "", "ENG", "E4", "22UB", "51.56387", "0.50859", "Europe/London"),("2640273", "Pinxton", "", "GB", "826", "", "ENG", "D3", "17UC", "53.09062", "-1.31767", "Europe/London"),("2640275", "Pinner", "", "GB", "826", "", "ENG", "GLA", "F4", "51.59384", "-0.38216", "Europe/London"),("2640312", "Pickering", "", "GB", "826", "", "ENG", "J7", "36UF", "54.25", "-0.76667", "Europe/London"),("2640348", "Petersfield", "", "GB", "826", "", "ENG", "F2", "24UC", "51.00495", "-0.93375", "Europe/London"),("2640349", "Peterlee", "Петерли", "GB", "826", "", "ENG", "D8", "00EJ088", "54.76032", "-1.33649", "Europe/London"),("2640351", "Peterhead", "", "GB", "826", "", "SCT", "T6", "", "57.50584", "-1.79806", "Europe/London"),("2640354", "Peterborough", "Питерборо", "GB", "826", "", "ENG", "K3", "00JA016", "52.57364", "-0.24777", "Europe/London"),("2640358", "Perth", "Перт", "GB", "826", "", "SCT", "W1", "", "56.39522", "-3.43139", "Europe/London"),("2640360", "Pershore", "", "GB", "826", "", "ENG", "Q4", "47UF", "52.11163", "-2.07586", "Europe/London"),("2640377", "Penzance", "Пензанс", "GB", "826", "", "ENG", "C6", "00HE107", "50.11861", "-5.53715", "Europe/London"),("2640413", "Penryn", "", "GB", "826", "", "ENG", "C6", "00HE105", "50.16812", "-5.10416", "Europe/London"),("2640416", "Penrith", "", "GB", "826", "", "ENG", "C9", "16UF", "54.66579", "-2.75757", "Europe/London"),("2640460", "Penkridge", "", "GB", "826", "", "ENG", "M9", "41UF", "52.72556", "-2.1156", "Europe/London"),("2640463", "Penistone", "", "GB", "826", "", "ENG", "A3", "00CC012", "53.52572", "-1.63027", "Europe/London"),("2640465", "Penicuik", "", "GB", "826", "", "SCT", "V5", "", "55.83116", "-3.22608", "Europe/London"),("2640484", "Pencoed", "", "GB", "826", "", "WLS", "X3", "00PB016", "51.52371", "-3.50016", "Europe/London"),("2640496", "Penarth", "", "GB", "826", "", "WLS", "Z3", "00PD014", "51.4386", "-3.17342", "Europe/London"),("2640498", "Pembury", "", "GB", "826", "", "ENG", "G5", "29UQ", "51.14296", "0.32187", "Europe/London"),("2640502", "Pembroke Dock", "", "GB", "826", "", "WLS", "Y7", "00NS054", "51.69161", "-4.94036", "Europe/London"),("2640503", "Pembroke", "", "GB", "826", "", "WLS", "Y7", "00NS053", "51.67464", "-4.91286", "Europe/London"),("2640511", "Pelton", "", "GB", "826", "", "ENG", "D8", "00EJ087", "54.87305", "-1.6095", "Europe/London"),("2640512", "Pelsall", "", "GB", "826", "", "ENG", "O8", "41UB", "52.6291", "-1.96738", "Europe/London"),("2640526", "Peebles", "", "GB", "826", "", "SCT", "T9", "", "55.6519", "-3.1888", "Europe/London"),("2640593", "Partington", "", "GB", "826", "", "ENG", "O6", "00BU003", "53.41884", "-2.42815", "Europe/London"),("2640601", "Parkstone", "", "GB", "826", "", "ENG", "D6", "", "50.72994", "-1.94492", "Europe/London"),("2640623", "Par", "", "GB", "826", "", "ENG", "C6", "00HE133", "50.35107", "-4.70288", "Europe/London"),("2640677", "Paisley", "Пейсли", "GB", "826", "", "SCT", "W2", "", "55.83173", "-4.43254", "Europe/London"),("2640681", "Paignton", "Пэйнтон", "GB", "826", "", "ENG", "O4", "18UG", "50.43565", "-3.56789", "Europe/London"),("2640687", "Padiham", "", "GB", "826", "", "ENG", "H2", "30UD", "53.80187", "-2.31511", "Europe/London"),("2640690", "Paddock Wood", "", "GB", "826", "", "ENG", "G5", "29UQ", "51.18187", "0.38229", "Europe/London"),("2640717", "Oxted", "", "GB", "826", "", "ENG", "N7", "43UK", "51.25687", "-0.00601", "Europe/London"),("2640729", "Oxford", "Оксфорд", "GB", "826", "", "ENG", "K2", "38UC", "51.75222", "-1.25596", "Europe/London"),("2640825", "Oundle", "", "GB", "826", "", "ENG", "J1", "34UD", "52.48093", "-0.46732", "Europe/London"),("2640857", "Otley", "", "GB", "826", "", "ENG", "H3", "00DA019", "53.90553", "-1.69383", "Europe/London"),("2640861", "Oswestry", "Освестри", "GB", "826", "", "ENG", "L6", "00GG140", "52.86195", "-3.05497", "Europe/London"),("2640869", "Ossett", "Оссетт", "GB", "826", "", "ENG", "O7", "", "53.67978", "-1.58006", "Europe/London"),("2640894", "Orpington", "", "GB", "826", "", "ENG", "GLA", "B8", "51.37457", "0.09785", "Europe/London"),("2640908", "Ormskirk", "", "GB", "826", "", "ENG", "H2", "30UP", "53.56685", "-2.88178", "Europe/London"),("2640967", "Omagh", "Ома", "GB", "826", "", "NIR", "N09000006", "", "54.6", "-7.3", "Europe/London"),("2640972", "Olney", "", "GB", "826", "", "ENG", "I6", "00MG025", "52.15345", "-0.70201", "Europe/London"),("2640981", "Old Windsor", "", "GB", "826", "", "ENG", "P9", "00ME009", "51.45807", "-0.58674", "Europe/London"),("2641022", "Oldham", "Олдем", "GB", "826", "", "ENG", "K1", "", "53.54051", "-2.1183", "Europe/London"),("2641036", "Oldbury", "", "GB", "826", "", "ENG", "L7", "", "52.5", "-2.01667", "Europe/London"),("2641049", "Okehampton", "", "GB", "826", "", "ENG", "D4", "18UL", "50.73841", "-4.0016", "Europe/London"),("2641108", "Oban", "", "GB", "826", "", "SCT", "T8", "", "56.41535", "-5.47184", "Europe/London"),("2641128", "Oakham", "", "GB", "826", "", "ENG", "L4", "00FP038", "52.66667", "-0.73333", "Europe/London"),("2641130", "Oakengates", "", "GB", "826", "", "ENG", "O2", "00GF018", "52.69501", "-2.45036", "Europe/London"),("2641134", "Oadby", "", "GB", "826", "", "ENG", "H5", "31UJ", "52.60621", "-1.08354", "Europe/London"),("2641157", "Nuneaton", "Нанитон", "GB", "826", "", "ENG", "P3", "44UC", "52.52323", "-1.46523", "Europe/London"),("2641170", "Nottingham", "Ноттингем", "GB", "826", "", "ENG", "J8", "", "52.9536", "-1.15047", "Europe/London"),("2641181", "Norwich", "Норидж", "GB", "826", "", "ENG", "I9", "33UG", "52.62783", "1.29834", "Europe/London"),("2641193", "Norton Canes", "", "GB", "826", "", "ENG", "M9", "41UB", "52.67142", "-1.96262", "Europe/London"),("2641224", "Northwich", "Нортвич", "GB", "826", "", "ENG", "Z8", "00EW119", "53.25882", "-2.52025", "Europe/London"),("2641233", "North Walsham", "", "GB", "826", "", "ENG", "I9", "33UF", "52.82121", "1.38746", "Europe/London"),("2641267", "North Shields", "", "GB", "826", "", "ENG", "J5", "", "55.01646", "-1.44925", "Europe/London"),("2641290", "Northolt", "", "GB", "826", "", "ENG", "GLA", "D9", "51.54855", "-0.36778", "Europe/London"),("2641319", "Lancing", "", "GB", "826", "", "ENG", "P6", "45UB", "50.82882", "-0.32247", "Europe/London"),("2641356", "North Ferriby", "", "GB", "826", "", "ENG", "E1", "00FB104", "53.72124", "-0.5052", "Europe/London"),("2641419", "North Berwick", "", "GB", "826", "", "SCT", "U6", "", "56.05825", "-2.7229", "Europe/London"),("2641430", "Northampton", "Нортгемптон", "GB", "826", "", "ENG", "J1", "34UF", "52.25", "-0.88333", "Europe/London"),("2641434", "Northam", "", "GB", "826", "", "ENG", "D4", "18UK", "51.03333", "-4.21667", "Europe/London"),("2641435", "Northallerton", "", "GB", "826", "", "ENG", "J7", "36UC", "54.33901", "-1.43243", "Europe/London"),("2641519", "Newtownards", "Ньютаунардс", "GB", "826", "", "NIR", "N09000011", "", "54.59236", "-5.69092", "Europe/London"),("2641520", "Newtownabbey", "Ньютонэббей", "GB", "826", "", "NIR", "N09000001", "", "54.65983", "-5.90858", "Europe/London"),("2641523", "Newtown", "", "GB", "826", "", "WLS", "Y8", "00NN089", "52.51667", "-3.3", "Europe/London"),("2641544", "Newton Mearns", "", "GB", "826", "", "SCT", "U7", "", "55.77334", "-4.33339", "Europe/London"),("2641546", "Newton-le-Willows", "", "GB", "826", "", "ENG", "N1", "", "53.45", "-2.6", "Europe/London"),("2641555", "Newton Aycliffe", "", "GB", "826", "", "ENG", "D8", "00EJ045", "54.61842", "-1.5719", "Europe/London"),("2641557", "Newton Abbot", "Ньютон-Эббот", "GB", "826", "", "ENG", "D4", "18UH", "50.52858", "-3.61186", "Europe/London"),("2641581", "Newry", "Ньюри", "GB", "826", "", "NIR", "N09000010", "", "54.17841", "-6.33739", "Europe/London"),("2641582", "New Romney", "", "GB", "826", "", "ENG", "G5", "6945806", "50.98599", "0.94122", "Europe/London"),("2641589", "Newquay", "", "GB", "826", "", "ENG", "C6", "00HE097", "50.41557", "-5.07319", "Europe/London"),("2641591", "Newport Pagnell", "", "GB", "826", "", "ENG", "I6", "00MG022", "52.08731", "-0.72218", "Europe/London"),("2641595", "Newport", "", "GB", "826", "", "ENG", "O2", "00GF017", "52.78333", "-2.38333", "Europe/London"),("2641598", "Newport", "Ньюпорт", "GB", "826", "", "WLS", "Y6", "00PR026", "51.58774", "-2.99835", "Europe/London"),("2641599", "Newport", "Ньюпорт", "GB", "826", "", "ENG", "G2", "00MW030", "50.70146", "-1.29124", "Europe/London"),("2641609", "New Milton", "", "GB", "826", "", "ENG", "F2", "24UJ", "50.75601", "-1.6658", "Europe/London"),("2641612", "New Mills", "", "GB", "826", "", "ENG", "D3", "17UH", "53.36592", "-1.99986", "Europe/London"),("2641616", "Newmarket", "Ньюмаркет", "GB", "826", "", "ENG", "N5", "42UC", "52.24467", "0.40418", "Europe/London"),("2641617", "New Malden", "", "GB", "826", "", "ENG", "GLA", "G7", "51.40065", "-0.2617", "Europe/London"),("2641618", "Newmains", "", "GB", "826", "", "SCT", "V8", "", "55.76667", "-3.88333", "Europe/London"),("2641637", "Newhaven", "", "GB", "826", "", "ENG", "E2", "21UF", "50.79693", "0.05545", "Europe/London"),("2641649", "New Ferry", "", "GB", "826", "", "ENG", "Q1", "00EW114", "53.36046", "-2.99377", "Europe/London"),("2641673", "Newcastle upon Tyne", "Ньюкасл", "GB", "826", "", "ENG", "I7", "", "54.97328", "-1.61396", "Europe/London"),("2641674", "Newcastle under Lyme", "", "GB", "826", "", "ENG", "M9", "41UE", "53", "-2.23333", "Europe/London"),("2641689", "Newbury", "Ньюбери", "GB", "826", "", "ENG", "P4", "00MB062", "51.40148", "-1.32471", "Europe/London"),("2641690", "Newburn", "", "GB", "826", "", "ENG", "I7", "00EM073", "54.9876", "-1.74415", "Europe/London"),("2641700", "Newbridge", "", "GB", "826", "", "WLS", "X4", "00PK016", "51.66667", "-3.13333", "Europe/London"),("2641718", "Newbiggin-by-the-Sea", "", "GB", "826", "", "ENG", "J6", "00EM113", "55.18532", "-1.51469", "Europe/London"),("2641729", "Newarthill", "", "GB", "826", "", "SCT", "V8", "", "55.8151", "-3.93733", "Europe/London"),("2641731", "Newark on Trent", "", "GB", "826", "", "ENG", "J9", "37UG", "53.06667", "-0.81667", "Europe/London"),("2641765", "Netley", "", "GB", "826", "", "ENG", "F2", "24UD", "50.87634", "-1.35398", "Europe/London"),("2641810", "Nelson", "", "GB", "826", "", "ENG", "H2", "30UJ", "53.83333", "-2.2", "Europe/London"),("2641811", "Nelson", "", "GB", "826", "", "WLS", "X4", "00PK015", "51.65333", "-3.28444", "Europe/London"),("2641815", "Neilston", "", "GB", "826", "", "SCT", "U7", "", "55.78574", "-4.42637", "Europe/London"),("2641843", "Neath", "Нит", "GB", "826", "", "WLS", "Y5", "00NZ020", "51.66317", "-3.80443", "Europe/London"),("2641884", "Narborough", "", "GB", "826", "", "ENG", "H5", "31UB", "52.56667", "-1.2", "Europe/London"),("2641892", "Nantwich", "", "GB", "826", "", "ENG", "Z7", "00EQ091", "53.06878", "-2.52051", "Europe/London"),("2641910", "Nairn", "", "GB", "826", "", "SCT", "V3", "", "57.58094", "-3.87973", "Europe/London"),("2641912", "Nailsworth", "", "GB", "826", "", "ENG", "E6", "23UF", "51.69382", "-2.2199", "Europe/London"),("2641913", "Nailsea", "", "GB", "826", "", "ENG", "J4", "00HC025", "51.43239", "-2.75847", "Europe/London"),("2641942", "Musselburgh", "Масселборо", "GB", "826", "", "SCT", "U6", "", "55.9417", "-3.04991", "Europe/London"),("2642096", "Mountsorrel", "", "GB", "826", "", "ENG", "H5", "31UC", "52.71667", "-1.15", "Europe/London"),("2642116", "Mountain Ash", "", "GB", "826", "", "WLS", "Y9", "00PF017", "51.68361", "-3.38008", "Europe/London"),("2642135", "Motherwell", "Мазервелл", "GB", "826", "", "SCT", "V8", "", "55.78924", "-3.99187", "Europe/London"),("2642143", "Mossley", "", "GB", "826", "", "ENG", "O1", "00BT001", "53.51454", "-2.03462", "Europe/London"),("2642182", "Morpeth", "", "GB", "826", "", "ENG", "J6", "00EM110", "55.16882", "-1.68893", "Europe/London"),("2642189", "Morley", "", "GB", "826", "", "ENG", "H3", "00DA030", "53.74013", "-1.59877", "Europe/London"),("2642204", "Moreton", "", "GB", "826", "", "ENG", "Q1", "", "53.4", "-3.11667", "Europe/London"),("2642214", "Morecambe", "Моркам", "GB", "826", "", "ENG", "H2", "30UH", "54.06835", "-2.86108", "Europe/London"),("2642302", "Montrose", "", "GB", "826", "", "SCT", "T7", "", "56.7", "-2.45", "Europe/London"),("2642313", "Monmouth", "", "GB", "826", "", "WLS", "Y4", "00PP025", "51.81265", "-2.71363", "Europe/London"),("2642372", "Mold", "", "GB", "826", "", "WLS", "Y1", "00NJ019", "53.16674", "-3.14143", "Europe/London"),("2642414", "Mitcham", "", "GB", "826", "", "ENG", "GLA", "I4", "51.40322", "-0.16831", "Europe/London"),("2642423", "Mirfield", "", "GB", "826", "", "ENG", "G8", "00CZ005", "53.67343", "-1.69636", "Europe/London"),("2642450", "Minehead", "", "GB", "826", "", "ENG", "M3", "40UF", "51.20452", "-3.48284", "Europe/London"),("2642465", "Milton Keynes", "Милтон-Кинс", "GB", "826", "", "ENG", "I6", "00MG041", "52.04172", "-0.75583", "Europe/London"),("2642483", "Milnrow", "", "GB", "826", "", "ENG", "L2", "00BP002", "53.61115", "-2.11266", "Europe/London"),("2642484", "Milngavie", "", "GB", "826", "", "SCT", "U5", "", "55.94071", "-4.32311", "Europe/London"),("2642505", "Millom", "", "GB", "826", "", "ENG", "C9", "16UE", "54.21072", "-3.272", "Europe/London"),("2642534", "Milford Haven", "", "GB", "826", "", "WLS", "Y7", "00NS045", "51.71278", "-5.0341", "Europe/London"),("2642537", "Milford", "", "GB", "826", "", "ENG", "N7", "43UL", "51.17272", "-0.65042", "Europe/London"),("2642557", "Midsomer Norton", "", "GB", "826", "", "ENG", "A4", "00HA033", "51.28567", "-2.48591", "Europe/London"),("2642567", "Midhurst", "", "GB", "826", "", "ENG", "P6", "45UD", "50.98559", "-0.74003", "Europe/London"),("2642573", "Middlewich", "", "GB", "826", "", "ENG", "Z7", "00EQ084", "53.19296", "-2.44402", "Europe/London"),("2642593", "Middleton", "", "GB", "826", "", "ENG", "L2", "", "53.55", "-2.2", "Europe/London"),("2642607", "Middlesbrough", "Мидлсбро", "GB", "826", "", "ENG", "I5", "00EF019", "54.57623", "-1.23483", "Europe/London"),("2642683", "Mexborough", "", "GB", "826", "", "ENG", "D5", "00CE017", "53.49389", "-1.29243", "Europe/London"),("2642705", "Merthyr Tydfil", "Мертир-Тидвил", "GB", "826", "", "WLS", "Y3", "00PH009", "51.74794", "-3.37779", "Europe/London"),("2642763", "Melton Mowbray", "", "GB", "826", "", "ENG", "H5", "31UG", "52.76588", "-0.88693", "Europe/London"),("2642766", "Meltham", "", "GB", "826", "", "ENG", "G8", "00CZ004", "53.58333", "-1.85", "Europe/London"),("2642786", "Melksham", "", "GB", "826", "", "ENG", "P8", "00HY156", "51.37281", "-2.14002", "Europe/London"),("2642910", "Matlock", "", "GB", "826", "", "ENG", "D3", "17UF", "53.13838", "-1.5556", "Europe/London"),("2642927", "Maryport", "", "GB", "826", "", "ENG", "C9", "16UB", "54.71434", "-3.49509", "Europe/London"),("2642974", "Marske-by-the-Sea", "", "GB", "826", "", "ENG", "K9", "00EE004", "54.59147", "-1.01959", "Europe/London"),("2642999", "Marple", "", "GB", "826", "", "ENG", "N2", "00EQ047", "53.39452", "-2.06292", "Europe/London"),("2643003", "Marlow", "", "GB", "826", "", "ENG", "B9", "11UF", "51.56933", "-0.77415", "Europe/London"),("2643010", "Marlborough", "", "GB", "826", "", "ENG", "P8", "00HY153", "51.42027", "-1.72949", "Europe/London"),("2643019", "Markfield", "", "GB", "826", "", "ENG", "H5", "31UE", "52.68747", "-1.27476", "Europe/London"),("2643027", "Market Harborough", "", "GB", "826", "", "ENG", "H5", "31UD", "52.4776", "-0.92053", "Europe/London"),("2643028", "Market Drayton", "", "GB", "826", "", "ENG", "L6", "00GG117", "52.90538", "-2.49012", "Europe/London"),("2643029", "Market Deeping", "", "GB", "826", "", "ENG", "H7", "32UG", "52.67654", "-0.31629", "Europe/London"),("2643044", "Margate", "Маргит", "GB", "826", "", "ENG", "G5", "2636057", "51.38132", "1.38617", "Europe/London"),("2643064", "Marchwood", "", "GB", "826", "", "ENG", "F2", "24UJ", "50.88966", "-1.4544", "Europe/London"),("2643071", "March", "", "GB", "826", "", "ENG", "C3", "12UD", "52.55131", "0.08828", "Europe/London"),("2643095", "Manston", "", "GB", "826", "", "ENG", "D6", "19UE", "50.95", "-2.26667", "Europe/London"),("2643096", "Mansfield Woodhouse", "", "GB", "826", "", "ENG", "J9", "37UF", "53.16495", "-1.19384", "Europe/London"),("2643097", "Mansfield", "Мэнсфилд", "GB", "826", "", "ENG", "J9", "37UF", "53.13333", "-1.2", "Europe/London"),("2643107", "Manningtree", "", "GB", "826", "", "ENG", "E4", "22UN", "51.94538", "1.06112", "Europe/London"),("2643116", "Mangotsfield", "", "GB", "826", "", "ENG", "M6", "00HD045", "51.4878", "-2.50403", "Europe/London"),("2643123", "Manchester", "Манчестер", "GB", "826", "", "ENG", "I2", "", "53.48095", "-2.23743", "Europe/London"),("2643142", "Malton", "", "GB", "826", "", "ENG", "J7", "36UF", "54.13695", "-0.7996", "Europe/London"),("2643144", "Maltby", "", "GB", "826", "", "ENG", "L3", "00CF029", "53.41667", "-1.2", "Europe/London"),("2643146", "Malmesbury", "", "GB", "826", "", "ENG", "P8", "00HY149", "51.58175", "-2.09708", "Europe/London"),("2643160", "Maldon", "Мелдона", "GB", "826", "", "ENG", "E4", "22UK", "51.7311", "0.67463", "Europe/London"),("2643179", "Maidstone", "Мейдстон", "GB", "826", "", "ENG", "G5", "29UH", "51.26667", "0.51667", "Europe/London"),("2643186", "Maidenhead", "Мейденхед", "GB", "826", "", "ENG", "P9", "", "51.52279", "-0.71986", "Europe/London"),("2643196", "Magor", "", "GB", "826", "", "WLS", "Y4", "00PP022", "51.57944", "-2.83139", "Europe/London"),("2643198", "Maghull", "", "GB", "826", "", "ENG", "L8", "00CA005", "53.51619", "-2.94117", "Europe/London"),("2643208", "Magherafelt", "", "GB", "826", "", "NIR", "N09000009", "", "54.75356", "-6.60656", "Europe/London"),("2643218", "Maesteg", "", "GB", "826", "", "WLS", "X3", "00PB012", "51.60926", "-3.65823", "Europe/London"),("2643266", "Macclesfield", "", "GB", "826", "", "ENG", "Z7", "00EQ124", "53.26023", "-2.12564", "Europe/London"),("2643269", "Mablethorpe", "", "GB", "826", "", "ENG", "H7", "32UC", "53.3409", "0.26102", "Europe/London"),("2643298", "Lyneham", "", "GB", "826", "", "ENG", "P8", "00HY147", "51.51667", "-1.96667", "Europe/London"),("2643309", "Lymm", "", "GB", "826", "", "ENG", "P2", "00EU010", "53.38105", "-2.47763", "Europe/London"),("2643312", "Lymington", "", "GB", "826", "", "ENG", "F2", "24UJ", "50.75767", "-1.5443", "Europe/London"),("2643318", "Lydney", "", "GB", "826", "", "ENG", "E6", "23UD", "51.72598", "-2.52605", "Europe/London"),("2643337", "Lutterworth", "", "GB", "826", "", "ENG", "H5", "31UD", "52.45634", "-1.20218", "Europe/London"),("2643339", "Luton", "Лутон", "GB", "826", "", "ENG", "I1", "00KC039", "51.87967", "-0.41748", "Europe/London"),("2643425", "Ludlow", "", "GB", "826", "", "ENG", "L6", "00GG113", "52.37431", "-2.71311", "Europe/London"),("2643490", "Lowestoft", "Лоустофт", "GB", "826", "", "ENG", "N5", "42UH", "52.4752", "1.75159", "Europe/London"),("2643553", "Louth", "Лаут", "GB", "826", "", "ENG", "H7", "32UC", "53.36664", "-0.00438", "Europe/London"),("2643567", "Loughborough", "Лафборо", "GB", "826", "", "ENG", "H5", "31UC", "52.76667", "-1.2", "Europe/London"),("2643587", "Lossiemouth", "", "GB", "826", "", "SCT", "V6", "", "57.72136", "-3.28341", "Europe/London"),("2643620", "Longton", "", "GB", "826", "", "ENG", "M9", "", "52.98333", "-2.13333", "Europe/London"),("2643646", "Longridge", "", "GB", "826", "", "ENG", "H2", "30UL", "53.83212", "-2.59964", "Europe/London"),("2643696", "Longfield", "", "GB", "826", "", "ENG", "G5", "29UD", "51.3969", "0.30212", "Europe/London"),("2643697", "Long Eaton", "", "GB", "826", "", "ENG", "D3", "17UG", "52.89855", "-1.27136", "Europe/London"),("2643704", "Longdendale", "", "GB", "826", "", "ENG", "O1", "", "53.46667", "-2", "Europe/London"),("2643734", "Londonderry County Borough", "", "GB", "826", "", "NIR", "N09000005", "", "54.99721", "-7.30917", "Europe/London"),("2643736", "Derry", "Дерри", "GB", "826", "GB", "NIR", "N09000005", "", "54.9981", "-7.30934", "Europe/London"),("2643741", "City of London", "Сити", "GB", "826", "", "ENG", "GLA", "H9", "51.51279", "-0.09184", "Europe/London"),("2643743", "London", "Лондон", "GB", "826", "", "ENG", "GLA", "", "51.50853", "-0.12574", "Europe/London"),("2643773", "Loftus", "", "GB", "826", "", "ENG", "K9", "00EE003", "54.55543", "-0.89459", "Europe/London"),("2643776", "Lofthouse", "", "GB", "826", "", "ENG", "H3", "", "53.72947", "-1.49697", "Europe/London"),("2643827", "Lochgelly", "", "GB", "826", "", "SCT", "V1", "", "56.12826", "-3.30964", "Europe/London"),("2643853", "Locharbriggs", "", "GB", "826", "", "SCT", "U2", "", "55.10337", "-3.58438", "Europe/London"),("2643862", "Loanhead", "", "GB", "826", "", "SCT", "V5", "", "55.87945", "-3.15874", "Europe/London"),("2643933", "Llantwit Major", "", "GB", "826", "", "WLS", "Z3", "00PD012", "51.4107", "-3.48632", "Europe/London"),("2643937", "Llantrisant", "", "GB", "826", "", "WLS", "Y9", "00PF012", "51.54028", "-3.37389", "Europe/London"),("2643994", "Llanharan", "", "GB", "826", "", "WLS", "Y9", "00PF010", "51.53805", "-3.43906", "Europe/London"),("2644100", "Llanelli", "Лланелли", "GB", "826", "", "WLS", "X7", "00NU032", "51.68195", "-4.16191", "Europe/London"),("2644120", "Llandudno", "Лландидно", "GB", "826", "", "WLS", "X8", "00NE018", "53.32498", "-3.83148", "Europe/London"),("2644122", "Llandrindod Wells", "", "GB", "826", "", "WLS", "Y8", "00NN047", "52.24164", "-3.37868", "Europe/London"),("2644204", "Livingston", "Ливингстон", "GB", "826", "", "SCT", "W9", "", "55.90288", "-3.52261", "Europe/London"),("2644207", "Liversedge", "", "GB", "826", "", "ENG", "G8", "", "53.70514", "-1.69327", "Europe/London"),("2644210", "Liverpool", "Ливерпуль", "GB", "826", "", "ENG", "H8", "", "53.41058", "-2.97794", "Europe/London"),("2644268", "Littleport", "", "GB", "826", "", "ENG", "C3", "2650488", "52.45784", "0.30603", "Europe/London"),("2644299", "Little Lever", "", "GB", "826", "", "ENG", "B1", "", "53.56346", "-2.37803", "Europe/London"),("2644305", "Little Hulton", "", "GB", "826", "", "ENG", "L5", "", "53.53333", "-2.41667", "Europe/London"),("2644319", "Littlehampton", "", "GB", "826", "", "ENG", "P6", "45UC", "50.81137", "-0.54078", "Europe/London"),("2644367", "Littleborough", "", "GB", "826", "", "ENG", "L2", "", "53.64413", "-2.09581", "Europe/London"),("2644386", "Litherland", "", "GB", "826", "", "ENG", "L8", "00CA007", "53.46993", "-2.99809", "Europe/London"),("2644398", "Liss", "", "GB", "826", "", "ENG", "F2", "24UC", "51.04277", "-0.89238", "Europe/London"),("2644409", "Liskeard", "", "GB", "826", "", "ENG", "C6", "00HE074", "50.4545", "-4.46517", "Europe/London"),("2644411", "Lisburn", "Лисберн", "GB", "826", "", "NIR", "N09000007", "", "54.52337", "-6.03527", "Europe/London"),("2644419", "Liphook", "", "GB", "826", "", "ENG", "F2", "24UC", "51.07673", "-0.8032", "Europe/London"),("2644444", "Linlithgow", "", "GB", "826", "", "SCT", "W9", "", "55.97639", "-3.60364", "Europe/London"),("2644487", "Lincoln", "Линкольн", "GB", "826", "", "ENG", "H7", "32UD", "53.22683", "-0.53792", "Europe/London"),("2644501", "Limavady", "", "GB", "826", "", "NIR", "N09000004", "", "55.05045", "-6.95074", "Europe/London"),("2644531", "Lichfield", "Личфилд", "GB", "826", "", "ENG", "M9", "41UD", "52.68154", "-1.82549", "Europe/London"),("2644547", "Leyland", "", "GB", "826", "", "ENG", "H2", "30UN", "53.69786", "-2.68758", "Europe/London"),("2644559", "Lewes", "Льюис", "GB", "826", "", "ENG", "E2", "21UF", "50.87398", "0.0088", "Europe/London"),("2644577", "Leven", "", "GB", "826", "", "SCT", "V1", "", "56.2", "-3", "Europe/London"),("2644597", "Letchworth", "Лечуорт", "GB", "826", "", "ENG", "F8", "26UF", "51.97944", "-0.2284", "Europe/London"),("2644605", "Lerwick", "", "GB", "826", "", "SCT", "W3", "", "60.15453", "-1.14941", "Europe/London"),("2644613", "Leominster", "", "GB", "826", "", "ENG", "F7", "00GA119", "52.22583", "-2.74491", "Europe/London"),("2644642", "Leiston", "", "GB", "826", "", "ENG", "N5", "42UG", "52.20611", "1.57757", "Europe/London"),("2644652", "Leighton Buzzard", "", "GB", "826", "", "ENG", "Z6", "00KC042", "51.91722", "-0.65802", "Europe/London"),("2644660", "Leigh", "", "GB", "826", "", "ENG", "P7", "", "53.49642", "-2.51973", "Europe/London"),("2644668", "Leicester", "Лестер", "GB", "826", "", "ENG", "H4", "31UC", "52.6386", "-1.13169", "Europe/London"),("2644680", "Lee-on-the-Solent", "", "GB", "826", "", "ENG", "F2", "24UF", "50.80169", "-1.20174", "Europe/London"),("2644684", "Leek", "", "GB", "826", "", "ENG", "M9", "41UH", "53.10434", "-2.02207", "Europe/London"),("2644688", "Leeds", "Лидс", "GB", "826", "", "ENG", "H3", "", "53.79648", "-1.54785", "Europe/London"),("2644707", "Ledbury", "", "GB", "826", "", "ENG", "F7", "00GA116", "52.03639", "-2.42635", "Europe/London"),("2644726", "Leatherhead", "", "GB", "826", "", "ENG", "N7", "43UE", "51.29652", "-0.3338", "Europe/London"),("2644737", "Royal Leamington Spa", "Лемингтон Спа", "GB", "826", "", "ENG", "P3", "44UF", "52.3", "-1.53333", "Europe/London"),("2644811", "Launceston", "", "GB", "826", "", "ENG", "C6", "00HE068", "50.63699", "-4.36006", "Europe/London"),("2644849", "Larne", "Ларн", "GB", "826", "", "NIR", "N09000008", "", "54.85", "-5.81667", "Europe/London"),("2644853", "Larkhall", "", "GB", "826", "", "SCT", "W5", "", "55.73333", "-3.96667", "Europe/London"),("2644860", "Largs", "", "GB", "826", "", "SCT", "V7", "", "55.79629", "-4.86337", "Europe/London"),("2644867", "Larbert", "", "GB", "826", "", "SCT", "U9", "", "56.02246", "-3.82872", "Europe/London"),("2644972", "Lancaster", "Ланкастер", "GB", "826", "", "ENG", "H2", "30UH", "54.04649", "-2.79988", "Europe/London"),("2644976", "Lanark", "", "GB", "826", "", "SCT", "W5", "", "55.67371", "-3.7817", "Europe/London"),("2645020", "Lakenheath", "", "GB", "826", "", "ENG", "N5", "42UC", "52.41755", "0.52211", "Europe/London"),("2645093", "Knutsford", "", "GB", "826", "", "ENG", "Z7", "00EQ072", "53.30289", "-2.37482", "Europe/London"),("2645099", "Knowle", "", "GB", "826", "", "ENG", "M2", "", "52.38333", "-1.73333", "Europe/London"),("2645102", "Knottingley", "", "GB", "826", "", "ENG", "O7", "", "53.70778", "-1.25639", "Europe/London"),("2645163", "Knaresborough", "", "GB", "826", "", "ENG", "J7", "36UD", "54.0091", "-1.46851", "Europe/London"),("2645191", "Kirriemuir", "", "GB", "826", "", "SCT", "T7", "", "56.67398", "-3.00343", "Europe/London"),("2645198", "Kirkwall", "", "GB", "826", "", "SCT", "V9", "", "58.98479", "-2.95873", "Europe/London"),("2645232", "Kirk Sandall", "", "GB", "826", "", "ENG", "D5", "00CE007", "53.56211", "-1.06876", "Europe/London"),("2645261", "Kirkintilloch", "Керкинтиллох", "GB", "826", "", "SCT", "U5", "", "55.93933", "-4.15262", "Europe/London"),("2645280", "Kirkham", "", "GB", "826", "", "ENG", "H2", "30UF", "53.78244", "-2.87189", "Europe/London"),("2645298", "Kirkcaldy", "Керколди", "GB", "826", "", "SCT", "V1", "", "56.11683", "-3.15999", "Europe/London"),("2645309", "Kirkby in Ashfield", "", "GB", "826", "", "ENG", "J9", "37UB", "53.09982", "-1.24379", "Europe/London"),("2645313", "Kirkby", "Керби", "GB", "826", "", "ENG", "G9", "", "53.48138", "-2.89215", "Europe/London"),("2645335", "Kirby Muxloe", "", "GB", "826", "", "ENG", "H5", "31UB", "52.63025", "-1.22755", "Europe/London"),("2645418", "Kingswood", "Кингсвуд", "GB", "826", "", "ENG", "M6", "00HD046", "51.45278", "-2.50833", "Europe/London"),("2645420", "Kingswinford", "", "GB", "826", "", "ENG", "D7", "41UF", "52.49755", "-2.16889", "Europe/London"),("2645425", "Hull", "Кингстон-апон-Халл", "GB", "826", "", "ENG", "G6", "", "53.7446", "-0.33525", "Europe/London"),("2645442", "Kingsteignton", "", "GB", "826", "", "ENG", "D4", "18UH", "50.55", "-3.58333", "Europe/London"),("2645456", "King's Lynn", "Кингслинн", "GB", "826", "GB", "ENG", "I9", "33UE", "52.75172", "0.39516", "Europe/London"),("2645460", "Kings Langley", "", "GB", "826", "", "ENG", "F8", "26UC", "51.71395", "-0.45044", "Europe/London"),("2645486", "Kingsbridge", "", "GB", "826", "", "ENG", "D4", "18UG", "50.28451", "-3.77638", "Europe/London"),("2645539", "Kimberley", "", "GB", "826", "", "ENG", "J9", "37UD", "52.98333", "-1.26667", "Europe/London"),("2645541", "Kilwinning", "Килуиннинг", "GB", "826", "", "SCT", "V7", "", "55.65333", "-4.70666", "Europe/London"),("2645548", "Kilsyth", "", "GB", "826", "", "SCT", "V8", "", "55.97596", "-4.05916", "Europe/London"),("2645605", "Kilmarnock", "Килмарнок", "GB", "826", "", "SCT", "U4", "", "55.61171", "-4.49581", "Europe/London"),("2645653", "Killamarsh", "", "GB", "826", "", "ENG", "D3", "17UJ", "53.32395", "-1.31688", "Europe/London"),("2645660", "Kilkeel", "", "GB", "826", "", "NIR", "N09000010", "", "54.06196", "-6.00308", "Europe/London"),("2645712", "Kilbirnie", "", "GB", "826", "", "SCT", "V7", "", "55.75082", "-4.68791", "Europe/London"),("2645721", "Kidsgrove", "", "GB", "826", "", "ENG", "M9", "41UE", "53.08691", "-2.23777", "Europe/London"),("2645722", "Kidlington", "", "GB", "826", "", "ENG", "K2", "38UB", "51.82166", "-1.2886", "Europe/London"),("2645724", "Kidderminster", "", "GB", "826", "", "ENG", "Q4", "47UG", "52.38819", "-2.25", "Europe/London"),("2645733", "Keynsham", "", "GB", "826", "", "ENG", "A4", "00HA026", "51.41387", "-2.4978", "Europe/London"),("2645753", "Kettering", "Кеттеринг", "GB", "826", "", "ENG", "J1", "34UE", "52.39836", "-0.72571", "Europe/London"),("2645822", "Kenilworth", "", "GB", "826", "", "ENG", "P3", "44UF", "52.34958", "-1.58276", "Europe/London"),("2645826", "Kendal", "Кендал", "GB", "826", "", "ENG", "C9", "16UG", "54.32681", "-2.74757", "Europe/London"),("2645830", "Kemsing", "", "GB", "826", "", "ENG", "G5", "29UP", "51.30604", "0.22917", "Europe/London"),("2645831", "Kempston", "", "GB", "826", "", "ENG", "Z5", "00KB018", "52.11599", "-0.50044", "Europe/London"),("2645836", "Kemnay", "", "GB", "826", "", "SCT", "T6", "", "57.23573", "-2.44395", "Europe/London"),("2645843", "Kelty", "", "GB", "826", "", "SCT", "V1", "", "56.13362", "-3.3869", "Europe/London"),("2645849", "Kelso", "", "GB", "826", "", "SCT", "T9", "00EM033", "55.59814", "-2.43382", "Europe/London"),("2645889", "Keighley", "Кейли", "GB", "826", "", "ENG", "B4", "00CX009", "53.86791", "-1.90664", "Europe/London"),("2645911", "Kearsley", "", "GB", "826", "", "ENG", "B1", "", "53.53333", "-2.38333", "Europe/London"),("2645943", "Jordanstown", "", "GB", "826", "", "NIR", "N09000001", "", "54.68333", "-5.9", "Europe/London"),("2645951", "Johnstone", "", "GB", "826", "", "SCT", "W2", "", "55.82906", "-4.51605", "Europe/London"),("2645972", "Jarrow", "Джарроу", "GB", "826", "", "ENG", "M7", "00EM167", "54.98036", "-1.48423", "Europe/London"),("2645988", "Ivybridge", "", "GB", "826", "", "ENG", "D4", "18UG", "50.39039", "-3.91914", "Europe/London"),("2645990", "Iver", "", "GB", "826", "", "ENG", "B9", "11UE", "51.5", "-0.5", "Europe/London"),("2646003", "Islington", "Ислингтон", "GB", "826", "", "ENG", "GLA", "G3", "51.53622", "-0.10304", "Europe/London"),("2646004", "Isleworth", "", "GB", "826", "", "ENG", "GLA", "G1", "51.47518", "-0.34246", "Europe/London"),("2646032", "Irvine", "Эрвин", "GB", "826", "", "SCT", "V7", "", "55.6194", "-4.65508", "Europe/London"),("2646034", "Irthlingborough", "", "GB", "826", "", "ENG", "J1", "34UD", "52.32674", "-0.61129", "Europe/London"),("2646042", "Irlam", "", "GB", "826", "", "ENG", "L5", "00BU001", "53.44253", "-2.42323", "Europe/London"),("2646057", "Ipswich", "Ипсуич", "GB", "826", "", "ENG", "N5", "42UD", "52.05917", "1.15545", "Europe/London"),("2646073", "Inverurie", "", "GB", "826", "", "SCT", "T6", "", "57.28446", "-2.37736", "Europe/London"),("2646088", "Inverness", "Инвернесс", "GB", "826", "", "SCT", "V3", "", "57.47908", "-4.22398", "Europe/London"),("2646104", "Inverkeithing", "", "GB", "826", "", "SCT", "V1", "", "56.03297", "-3.39555", "Europe/London"),("2646208", "Ingleby Greenhow", "", "GB", "826", "", "ENG", "J7", "36UC", "54.44983", "-1.10687", "Europe/London"),("2646253", "Ince-in-Makerfield", "", "GB", "826", "", "ENG", "P7", "", "53.53333", "-2.61667", "Europe/London"),("2646256", "Immingham", "", "GB", "826", "", "ENG", "J2", "00FC013", "53.61239", "-0.22219", "Europe/London"),("2646272", "Ilkley", "", "GB", "826", "", "ENG", "B4", "00CX004", "53.92449", "-1.82326", "Europe/London"),("2646274", "Ilkeston", "", "GB", "826", "", "ENG", "D3", "17UG", "52.97055", "-1.30951", "Europe/London"),("2646276", "Ilfracombe", "", "GB", "826", "", "ENG", "D4", "18UE", "51.2093", "-4.11344", "Europe/London"),("2646311", "Ibstock", "", "GB", "826", "", "ENG", "H5", "31UE", "52.68554", "-1.39965", "Europe/London"),("2646316", "Hythe", "", "GB", "826", "", "ENG", "G5", "6945806", "51.0715", "1.08421", "Europe/London"),("2646317", "Hythe", "", "GB", "826", "", "ENG", "F2", "24UJ", "50.86004", "-1.40162", "Europe/London"),("2646327", "Hyde", "", "GB", "826", "", "ENG", "O1", "", "53.45131", "-2.07943", "Europe/London"),("2646329", "Huyton", "Хейтон", "GB", "826", "", "ENG", "G9", "00BX006", "53.4115", "-2.83935", "Europe/London"),("2646355", "Hurstpierpoint", "", "GB", "826", "", "ENG", "P6", "45UG", "50.93388", "-0.18007", "Europe/London"),("2646393", "Huntingdon", "The Huntingdon", "GB", "826", "", "ENG", "C3", "12UE", "52.33049", "-0.18651", "Europe/London"),("2646411", "Hungerford", "", "GB", "826", "", "ENG", "P4", "00MB032", "51.41513", "-1.51556", "Europe/London"),("2646435", "Humberston", "", "GB", "826", "", "ENG", "J2", "00FC012", "53.53036", "-0.02465", "Europe/London"),("2646458", "Huddersfield", "Хаддерсфилд", "GB", "826", "", "ENG", "G8", "00CZ003", "53.64904", "-1.78416", "Europe/London"),("2646460", "Hucknall", "", "GB", "826", "", "ENG", "J9", "37UB", "53.03333", "-1.2", "Europe/London"),("2646471", "Hoyland Nether", "", "GB", "826", "", "ENG", "A3", "", "53.5", "-1.45", "Europe/London"),("2646472", "Hoylake", "", "GB", "826", "", "ENG", "Q1", "", "53.39046", "-3.18066", "Europe/London"),("2646504", "Hove", "Хов", "GB", "826", "", "ENG", "B6", "45UG", "50.83088", "-0.1672", "Europe/London"),("2646507", "Houston", "", "GB", "826", "", "SCT", "W2", "", "55.86859", "-4.55201", "Europe/London"),("2646525", "Houghton-Le-Spring", "", "GB", "826", "", "ENG", "D8", "", "54.84034", "-1.46427", "Europe/London"),("2646542", "Horwich", "", "GB", "826", "", "ENG", "B1", "00BL002", "53.60126", "-2.54975", "Europe/London"),("2646557", "Horsham", "Хоршэм", "GB", "826", "", "ENG", "P6", "45UF", "51.06314", "-0.32757", "Europe/London"),("2646558", "Horsforth", "", "GB", "826", "", "ENG", "H3", "00DA032", "53.8426", "-1.63754", "Europe/London"),("2646583", "Hornsea", "", "GB", "826", "", "ENG", "E1", "00FB073", "53.91041", "-0.16806", "Europe/London"),("2646595", "Horncastle", "", "GB", "826", "", "ENG", "H7", "32UC", "53.20775", "-0.1172", "Europe/London"),("2646606", "Horley", "", "GB", "826", "", "ENG", "N7", "43UF", "51.17423", "-0.15919", "Europe/London"),("2646613", "Horbury", "", "GB", "826", "", "ENG", "O7", "", "53.66051", "-1.56014", "Europe/London"),("2646653", "Hook", "", "GB", "826", "", "ENG", "GLA", "G7", "51.36803", "-0.3065", "Europe/London"),("2646654", "Hook", "", "GB", "826", "", "ENG", "F2", "24UG", "51.28425", "-0.95967", "Europe/London"),("2646656", "Hoo", "", "GB", "826", "", "ENG", "I3", "00LC008", "51.4205", "0.563", "Europe/London"),("2646658", "Honiton", "", "GB", "826", "", "ENG", "D4", "18UB", "50.7996", "-3.18899", "Europe/London"),("2646670", "Holywood", "", "GB", "826", "", "NIR", "N09000011", "", "54.63863", "-5.82473", "Europe/London"),("2646673", "Holywell", "", "GB", "826", "", "WLS", "Y1", "00NJ014", "53.27466", "-3.22895", "Europe/London"),("2646675", "Holytown", "", "GB", "826", "", "SCT", "V8", "", "55.82011", "-3.9727", "Europe/London"),("2646686", "Holyhead", "", "GB", "826", "", "WLS", "X1", "00NA010", "53.30621", "-4.63211", "Europe/London"),("2646720", "Holmes Chapel", "", "GB", "826", "", "ENG", "Z7", "00EQ066", "53.2014", "-2.35742", "Europe/London"),("2646787", "Holbeach", "", "GB", "826", "", "ENG", "H7", "32UF", "52.80401", "0.01442", "Europe/London"),("2646807", "Hoddesdon", "Ходдсдон", "GB", "826", "", "ENG", "F8", "26UB", "51.76148", "-0.01144", "Europe/London"),("2646814", "Hockley", "", "GB", "826", "", "ENG", "A7", "", "52.5", "-1.91667", "Europe/London"),("2646826", "Hitchin", "", "GB", "826", "", "ENG", "F8", "26UF", "51.94924", "-0.28496", "Europe/London"),("2646828", "Histon", "", "GB", "826", "", "ENG", "C3", "12UG", "52.25166", "0.10643", "Europe/London"),("2646862", "Hindley", "", "GB", "826", "", "ENG", "P7", "", "53.53333", "-2.58333", "Europe/London"),("2646863", "Hindhead", "", "GB", "826", "", "ENG", "N7", "43UL", "51.11381", "-0.73351", "Europe/London"),("2646867", "Hinckley", "Хинкли", "GB", "826", "", "ENG", "H5", "31UE", "52.5389", "-1.37613", "Europe/London"),("2646914", "High Wycombe", "Хай-Уиком", "GB", "826", "", "ENG", "B9", "11UF", "51.62907", "-0.74934", "Europe/London"),("2646916", "Highworth", "", "GB", "826", "", "ENG", "N9", "00HX008", "51.63051", "-1.711", "Europe/London"),("2646979", "High Blantyre", "", "GB", "826", "", "SCT", "W5", "", "55.78438", "-4.10007", "Europe/London"),("2646985", "Higham Ferrers", "", "GB", "826", "", "ENG", "J1", "34UD", "52.30596", "-0.59342", "Europe/London"),("2647007", "Hexham", "", "GB", "826", "", "ENG", "J6", "00EM080", "54.96986", "-2.104", "Europe/London"),("2647021", "Hetton-Le-Hole", "", "GB", "826", "", "ENG", "N6", "00CM002", "54.81667", "-1.45", "Europe/London"),("2647026", "Heswall", "", "GB", "826", "", "ENG", "Q1", "00EW114", "53.32733", "-3.09648", "Europe/London"),("2647044", "Hertford", "Хертфорд", "GB", "826", "", "ENG", "F8", "26UD", "51.79588", "-0.07854", "Europe/London"),("2647057", "Herne Bay", "", "GB", "826", "", "ENG", "G5", "6945807", "51.373", "1.12857", "Europe/London"),("2647074", "Hereford", "Херефорде", "GB", "826", "", "ENG", "F7", "00GA240", "52.05684", "-2.71482", "Europe/London"),("2647097", "Henlow", "", "GB", "826", "", "ENG", "Z6", "00KC033", "52.03021", "-0.28599", "Europe/London"),("2647101", "Henley on Thames", "", "GB", "826", "", "ENG", "K2", "38UD", "51.53333", "-0.9", "Europe/London"),("2647108", "Hengoed", "", "GB", "826", "", "WLS", "X4", "00PK012", "51.65083", "-3.23167", "Europe/London"),("2647120", "Hemsworth", "", "GB", "826", "", "ENG", "O7", "00DB010", "53.61267", "-1.35424", "Europe/London"),("2647123", "Hemsby", "", "GB", "826", "", "ENG", "I9", "33UD", "52.69714", "1.69181", "Europe/London"),("2647138", "Hemel Hempstead", "", "GB", "826", "", "ENG", "F8", "26UC", "51.75368", "-0.44975", "Europe/London"),("2647143", "Helston", "", "GB", "826", "", "ENG", "C6", "00HE049", "50.10319", "-5.27045", "Europe/London"),("2647178", "Helensburgh", "", "GB", "826", "", "SCT", "T8", "", "56.00614", "-4.72648", "Europe/London"),("2647187", "Heighington", "", "GB", "826", "", "ENG", "H7", "32UE", "53.21241", "-0.45902", "Europe/London"),("2647191", "Hedon", "", "GB", "826", "", "ENG", "E1", "00FB067", "53.73962", "-0.19655", "Europe/London"),("2647198", "Heckmondwike", "", "GB", "826", "", "ENG", "G8", "", "53.70646", "-1.67747", "Europe/London"),("2647209", "Hebburn", "", "GB", "826", "", "ENG", "M7", "", "54.97302", "-1.51546", "Europe/London"),("2647227", "Heanor", "", "GB", "826", "", "ENG", "D3", "17UB", "53.01372", "-1.35383", "Europe/London"),("2647246", "Hazel Grove", "", "GB", "826", "", "ENG", "N2", "", "53.38333", "-2.11667", "Europe/London"),("2647248", "Haywards Heath", "", "GB", "826", "", "ENG", "P6", "45UG", "50.99769", "-0.10313", "Europe/London"),("2647258", "Hayle", "", "GB", "826", "", "ENG", "C6", "00HE047", "50.18392", "-5.42137", "Europe/London"),("2647261", "Hayes", "", "GB", "826", "", "ENG", "GLA", "F9", "51.51579", "-0.4234", "Europe/London"),("2647265", "Haydock", "", "GB", "826", "", "ENG", "N1", "00EU003", "53.46723", "-2.68166", "Europe/London"),("2647269", "Haxby", "", "GB", "826", "", "ENG", "Q5", "00FF012", "54.01422", "-1.07121", "Europe/London"),("2647278", "Haworth", "", "GB", "826", "", "ENG", "B4", "00CX008", "53.82905", "-1.94827", "Europe/London"),("2647297", "Hawick", "", "GB", "826", "", "SCT", "T9", "", "55.42273", "-2.78666", "Europe/London"),("2647303", "Hawarden", "Хаварден", "GB", "826", "", "WLS", "Y1", "00NJ012", "53.18478", "-3.02578", "Europe/London"),("2647310", "Haverhill", "", "GB", "826", "", "ENG", "N5", "42UF", "52.08226", "0.43891", "Europe/London"),("2647311", "Haverfordwest", "", "GB", "826", "", "WLS", "Y7", "00NS022", "51.80169", "-4.96914", "Europe/London"),("2647317", "Havant", "Хавант", "GB", "826", "", "ENG", "F2", "24UH", "50.8567", "-0.98559", "Europe/London"),("2647349", "Hatfield", "", "GB", "826", "", "ENG", "F8", "26UL", "51.76338", "-0.22419", "Europe/London"),("2647356", "Hastings", "Гастингс", "GB", "826", "", "ENG", "E2", "21UD", "50.85519", "0.57292", "Europe/London"),("2647359", "Hassocks", "", "GB", "826", "", "ENG", "P6", "45UG", "50.92814", "-0.16617", "Europe/London"),("2647363", "Haslingden", "", "GB", "826", "", "ENG", "H2", "30UM", "53.70326", "-2.32382", "Europe/London"),("2647365", "Haslemere", "", "GB", "826", "", "ENG", "N7", "43UL", "51.09015", "-0.70785", "Europe/London"),("2647383", "Harwich", "Харвич", "GB", "826", "", "ENG", "E4", "22UN", "51.94194", "1.28437", "Europe/London"),("2647391", "Hartshill", "", "GB", "826", "", "ENG", "P3", "44UB", "52.54831", "-1.52221", "Europe/London"),("2647400", "Hartlepool", "Хартлпул", "GB", "826", "", "ENG", "F5", "", "54.68611", "-1.2125", "Europe/London"),("2647421", "Harrow on the Hill", "", "GB", "826", "", "ENG", "GLA", "F4", "51.57142", "-0.33371", "Europe/London"),("2647428", "Harrogate", "Харрогейт", "GB", "826", "", "ENG", "J7", "36UD", "53.99078", "-1.5373", "Europe/London"),("2647451", "Harpenden", "", "GB", "826", "", "ENG", "F8", "6615330", "51.81684", "-0.35706", "Europe/London"),("2647461", "Harlow", "Харлоу", "GB", "826", "", "ENG", "E4", "22UJ", "51.77655", "0.11158", "Europe/London"),("2647487", "Harefield", "", "GB", "826", "", "ENG", "GLA", "F9", "51.60333", "-0.48546", "Europe/London"),("2647497", "Hardingstone", "", "GB", "826", "", "ENG", "J1", "34UF", "52.21358", "-0.88582", "Europe/London"),("2647550", "Hampton", "", "GB", "826", "", "ENG", "GLA", "L1", "51.41334", "-0.36701", "Europe/London"),("2647570", "Hamilton", "Гамильтон", "GB", "826", "", "SCT", "W5", "", "55.76667", "-4.03333", "Europe/London"),("2647605", "Halstead", "", "GB", "826", "", "ENG", "G5", "6945814", "51.32796", "0.13269", "Europe/London"),("2647632", "Halifax", "Галифакс", "GB", "826", "", "ENG", "C2", "", "53.71667", "-1.85", "Europe/London"),("2647638", "Halesworth", "", "GB", "826", "", "ENG", "N5", "42UH", "52.3464", "1.5029", "Europe/London"),("2647639", "Halesowen", "Хейлсовен", "GB", "826", "", "ENG", "D7", "47UB", "52.44859", "-2.04938", "Europe/London"),("2647644", "Hale", "", "GB", "826", "", "ENG", "N7", "43UL", "51.22946", "-0.78908", "Europe/London"),("2647655", "Hailsham", "", "GB", "826", "", "ENG", "E2", "21UH", "50.8622", "0.25775", "Europe/London"),("2647662", "Hagley", "", "GB", "826", "", "ENG", "Q4", "47UB", "52.4262", "-2.12819", "Europe/London"),("2647677", "Hadley", "", "GB", "826", "", "ENG", "O2", "00GF009", "52.7", "-2.48333", "Europe/London"),("2647678", "Hadleigh", "", "GB", "826", "", "ENG", "N5", "42UB", "52.04499", "0.95298", "Europe/London"),("2647679", "Hadleigh", "", "GB", "826", "", "ENG", "E4", "22UE", "51.55269", "0.60983", "Europe/London"),("2647686", "Haddington", "", "GB", "826", "", "SCT", "U6", "", "55.95612", "-2.78332", "Europe/London"),("2647784", "Guiseley", "", "GB", "826", "", "ENG", "H3", "", "53.87561", "-1.71232", "Europe/London"),("2647785", "Guisborough", "", "GB", "826", "", "ENG", "K9", "00EE001", "54.53478", "-1.05606", "Europe/London"),("2647793", "Guildford", "Гилфорд", "GB", "826", "", "ENG", "N7", "43UD", "51.23536", "-0.57427", "Europe/London"),("2647837", "Grove", "", "GB", "826", "", "ENG", "K2", "38UE", "51.60954", "-1.42187", "Europe/London"),("2647919", "Gresford", "", "GB", "826", "", "WLS", "Z4", "00NL015", "53.08539", "-2.97062", "Europe/London"),("2647948", "Greenock", "Гринок", "GB", "826", "", "SCT", "V4", "", "55.94838", "-4.76121", "Europe/London"),("2647957", "Greenisland", "", "GB", "826", "", "NIR", "N09000008", "", "54.70081", "-5.87479", "Europe/London"),("2647972", "Greenford", "", "GB", "826", "", "ENG", "GLA", "D9", "51.52866", "-0.35508", "Europe/London"),("2647984", "Great Yarmouth", "Грейт-Ярмут", "GB", "826", "", "ENG", "I9", "33UD", "52.60831", "1.73052", "Europe/London"),("2647985", "Great Wyrley", "", "GB", "826", "", "ENG", "M9", "41UF", "52.66277", "-2.01111", "Europe/London"),("2648004", "Great Torrington", "", "GB", "826", "", "ENG", "D4", "18UK", "50.95309", "-4.14401", "Europe/London"),("2648026", "Great Sankey", "", "GB", "826", "", "ENG", "P2", "00EU008", "53.39234", "-2.63994", "Europe/London"),("2648057", "Great Missenden", "", "GB", "826", "", "ENG", "B9", "11UC", "51.70419", "-0.70797", "Europe/London"),("2648063", "Great Malvern", "", "GB", "826", "", "ENG", "Q4", "47UC", "52.11161", "-2.32515", "Europe/London"),("2648084", "Great Harwood", "", "GB", "826", "", "ENG", "H2", "30UG", "53.78512", "-2.40865", "Europe/London"),("2648096", "Great Gonerby", "", "GB", "826", "", "ENG", "H7", "32UG", "52.93507", "-0.66685", "Europe/London"),("2648117", "Great Dunmow", "", "GB", "826", "", "ENG", "E4", "22UQ", "51.8723", "0.36255", "Europe/London"),("2648120", "Driffield", "", "GB", "826", "", "ENG", "E1", "00FB038", "54.00613", "-0.44495", "Europe/London"),("2648154", "Great Bookham", "", "GB", "826", "", "ENG", "N7", "43UE", "51.27916", "-0.37423", "Europe/London"),("2648182", "Grays", "", "GB", "826", "", "ENG", "O3", "29UG", "51.47566", "0.32521", "Europe/London"),("2648187", "Gravesend", "Грейвзенд", "GB", "826", "", "ENG", "G5", "29UG", "51.44138", "0.37371", "Europe/London"),("2648208", "Grantham", "Гранты", "GB", "826", "", "ENG", "H7", "32UG", "52.91149", "-0.64184", "Europe/London"),("2648215", "Grangemouth", "", "GB", "826", "", "SCT", "U9", "", "56.01141", "-3.72183", "Europe/London"),("2648259", "Gourock", "", "GB", "826", "", "SCT", "V4", "", "55.96157", "-4.81789", "Europe/London"),("2648272", "Gosport", "Госпорт", "GB", "826", "", "ENG", "F2", "24UF", "50.79509", "-1.12902", "Europe/London"),("2648273", "Gosforth", "", "GB", "826", "", "ENG", "I7", "", "55", "-1.61667", "Europe/London"),("2648290", "Gorseinon", "", "GB", "826", "", "WLS", "Z1", "00NX009", "51.66931", "-4.04163", "Europe/London"),("2648299", "Gorleston-on-Sea", "", "GB", "826", "", "ENG", "I9", "33UD", "52.57301", "1.73069", "Europe/London"),("2648308", "Gorebridge", "", "GB", "826", "", "SCT", "V5", "", "55.84594", "-3.04563", "Europe/London"),("2648319", "Goole", "Гул", "GB", "826", "", "ENG", "E1", "00FB059", "53.70324", "-0.87732", "Europe/London"),("2648356", "Golborne", "", "GB", "826", "", "ENG", "P7", "00EU017", "53.47693", "-2.59651", "Europe/London"),("2648370", "Godmanchester", "", "GB", "826", "", "ENG", "C3", "12UE", "52.31939", "-0.17509", "Europe/London"),("2648372", "Godalming", "Годалминге", "GB", "826", "", "ENG", "N7", "43UL", "51.1858", "-0.61489", "Europe/London"),("2648396", "Glusburn", "", "GB", "826", "", "ENG", "J7", "36UB", "53.9", "-2", "Europe/London"),("2648404", "Gloucester", "Глостер", "GB", "826", "", "ENG", "E6", "23UE", "51.86568", "-2.2431", "Europe/London"),("2648405", "Glossop", "", "GB", "826", "", "ENG", "D3", "17UH", "53.44325", "-1.949", "Europe/London"),("2648438", "Glenrothes", "Гленротес", "GB", "826", "", "SCT", "V1", "", "56.19514", "-3.17316", "Europe/London"),("2648484", "Glenfield", "", "GB", "826", "", "ENG", "H5", "31UB", "52.6466", "-1.19493", "Europe/London"),("2648559", "Glastonbury", "", "GB", "826", "", "ENG", "M3", "40UB", "51.14745", "-2.72075", "Europe/London"),("2648579", "Glasgow", "Глазго", "GB", "826", "", "SCT", "V2", "", "55.86515", "-4.25763", "Europe/London"),("2648626", "Girvan", "", "GB", "826", "", "SCT", "W4", "", "55.24255", "-4.85551", "Europe/London"),("2648657", "Gillingham", "Джиллингем", "GB", "826", "", "ENG", "G5", "", "51.38914", "0.54863", "Europe/London"),("2648658", "Gillingham", "", "GB", "826", "", "ENG", "D6", "19UE", "51.03833", "-2.27611", "Europe/London"),("2648683", "Giffnock", "Гиффнок", "GB", "826", "", "SCT", "U7", "", "55.80373", "-4.29488", "Europe/London"),("2648728", "Gelligaer", "", "GB", "826", "", "WLS", "X4", "00PK012", "51.66444", "-3.25611", "Europe/London"),("2648773", "Gateshead", "Гейтсхед", "GB", "826", "", "ENG", "E5", "00CH002", "54.96209", "-1.60168", "Europe/London"),("2648829", "Garstang", "", "GB", "826", "", "ENG", "H2", "30UQ", "53.90081", "-2.77417", "Europe/London"),("2648875", "Garforth", "", "GB", "826", "", "ENG", "H3", "", "53.79173", "-1.38067", "Europe/London"),("2648928", "Galashiels", "", "GB", "826", "", "SCT", "T9", "", "55.61458", "-2.80695", "Europe/London"),("2648945", "Gainsborough", "", "GB", "826", "", "ENG", "H7", "32UH", "53.38333", "-0.76667", "Europe/London"),("2648970", "Fylde", "", "GB", "826", "", "ENG", "H2", "30UF", "53.83333", "-2.91667", "Europe/London"),("2649024", "Frome", "Фрум", "GB", "826", "", "ENG", "M3", "40UB", "51.22834", "-2.32211", "Europe/London"),("2649029", "Frodsham", "", "GB", "826", "", "ENG", "Z8", "00EW068", "53.29485", "-2.72745", "Europe/London"),("2649049", "Frinton-on-Sea", "", "GB", "826", "", "ENG", "E4", "22UN", "51.83061", "1.24424", "Europe/London"),("2649052", "Frimley", "", "GB", "826", "", "ENG", "N7", "43UJ", "51.31667", "-0.74544", "Europe/London"),("2649069", "Freshwater", "", "GB", "826", "", "ENG", "G2", "00MW008", "50.692", "-1.50787", "Europe/London"),("2649083", "Freckleton", "", "GB", "826", "", "ENG", "H2", "30UF", "53.75433", "-2.86489", "Europe/London"),("2649089", "Fraserburgh", "", "GB", "826", "", "SCT", "T6", "", "57.68744", "-2.01844", "Europe/London"),("2649169", "Fort William", "", "GB", "826", "", "SCT", "V3", "2646086", "56.81648", "-5.11208", "Europe/London"),("2649192", "Forres", "", "GB", "826", "", "SCT", "V6", "", "57.60997", "-3.62115", "Europe/London"),("2649198", "Formby", "", "GB", "826", "", "ENG", "L8", "00CA010", "53.55838", "-3.06999", "Europe/London"),("2649207", "Forfar", "", "GB", "826", "", "SCT", "T7", "", "56.64382", "-2.89001", "Europe/London"),("2649228", "Fordingbridge", "", "GB", "826", "", "ENG", "F2", "24UJ", "50.92747", "-1.79029", "Europe/London"),("2649258", "Folkestone", "Фолкстон", "GB", "826", "", "ENG", "G5", "6945806", "51.08169", "1.16734", "Europe/London"),("2649295", "Flitwick", "", "GB", "826", "", "ENG", "Z6", "00KC027", "52.00338", "-0.49472", "Europe/London"),("2649301", "Flint", "", "GB", "826", "", "WLS", "Y1", "00NJ008", "53.24488", "-3.13231", "Europe/London"),("2649312", "Fleetwood", "", "GB", "826", "", "ENG", "H2", "30UQ", "53.92527", "-3.01085", "Europe/London"),("2649322", "Fleet", "", "GB", "826", "", "ENG", "F2", "24UG", "51.28333", "-0.83333", "Europe/London"),("2649334", "Flamstead", "", "GB", "826", "", "ENG", "F8", "26UC", "51.81971", "-0.43707", "Europe/London"),("2649463", "Filey", "", "GB", "826", "", "ENG", "J7", "36UG", "54.21", "-0.28917", "Europe/London"),("2649516", "Ferryhill", "", "GB", "826", "", "ENG", "D8", "00EJ039", "54.68333", "-1.55", "Europe/London"),("2649531", "Ferndale", "", "GB", "826", "", "WLS", "Y9", "00PF007", "51.66056", "-3.4475", "Europe/London"),("2649571", "Feltham", "", "GB", "826", "", "ENG", "GLA", "G1", "51.4462", "-0.41388", "Europe/London"),("2649578", "Felling", "", "GB", "826", "", "ENG", "E5", "00CH002", "54.95297", "-1.57152", "Europe/London"),("2649579", "Felixstowe", "Филикстоу", "GB", "826", "", "ENG", "N5", "42UG", "51.96375", "1.3511", "Europe/London"),("2649593", "Featherstone", "", "GB", "826", "", "ENG", "O7", "00DB008", "53.67688", "-1.35647", "Europe/London"),("2649609", "Fazeley", "", "GB", "826", "", "ENG", "M9", "41UD", "52.61443", "-1.6985", "Europe/London"),("2649622", "Faversham", "", "GB", "826", "", "ENG", "G5", "29UM", "51.3148", "0.88856", "Europe/London"),("2649650", "Farnworth", "", "GB", "826", "", "ENG", "B1", "", "53.55", "-2.4", "Europe/London"),("2649657", "Farnham Royal", "", "GB", "826", "", "ENG", "B9", "11UE", "51.54208", "-0.61584", "Europe/London"),("2649660", "Farnham", "", "GB", "826", "", "ENG", "N7", "43UL", "51.21444", "-0.80054", "Europe/London"),("2649671", "Farnborough", "", "GB", "826", "", "ENG", "GLA", "B8", "51.35948", "0.06905", "Europe/London"),("2649672", "Farnborough", "Фарнборо", "GB", "826", "", "ENG", "F2", "24UL", "51.29424", "-0.75565", "Europe/London"),("2649686", "Faringdon", "", "GB", "826", "", "ENG", "K2", "38UE", "51.65644", "-1.58676", "Europe/London"),("2649692", "Fareham", "", "GB", "826", "", "ENG", "F2", "24UE", "50.85162", "-1.17929", "Europe/London"),("2649715", "Falmouth", "Фалмут", "GB", "826", "", "ENG", "C6", "00HE035", "50.15441", "-5.07113", "Europe/London"),("2649723", "Falkirk", "Фалкирк", "GB", "826", "", "SCT", "U9", "", "56.0021", "-3.78535", "Europe/London"),("2649730", "Fakenham", "", "GB", "826", "", "ENG", "I9", "33UF", "52.82996", "0.8477", "Europe/London"),("2649800", "Exmouth", "Эксмут", "GB", "826", "", "ENG", "D4", "18UB", "50.61723", "-3.40233", "Europe/London"),("2649808", "Exeter", "Эксетер", "GB", "826", "", "ENG", "D4", "18UC", "50.7236", "-3.52751", "Europe/London"),("2649833", "Evesham", "", "GB", "826", "", "ENG", "Q4", "47UF", "52.09237", "-1.94887", "Europe/London"),("2649852", "Euxton", "", "GB", "826", "", "ENG", "H2", "30UE", "53.6699", "-2.67615", "Europe/London"),("2649911", "Esher", "Эшер", "GB", "826", "", "ENG", "N7", "43UB", "51.36969", "-0.36693", "Europe/London"),("2649937", "Erith", "", "GB", "826", "", "ENG", "GLA", "A6", "51.48315", "0.17484", "Europe/London"),("2649957", "Epsom", "Эпсом", "GB", "826", "", "ENG", "N7", "43UC", "51.3305", "-0.27011", "Europe/London"),("2649963", "Epping", "", "GB", "826", "", "ENG", "E4", "22UH", "51.69815", "0.11055", "Europe/London"),("2649984", "Enniskillen", "", "GB", "826", "", "NIR", "N09000006", "", "54.34615", "-7.64133", "Europe/London"),("2649997", "Enfield Town", "", "GB", "826", "", "ENG", "GLA", "E3", "51.65147", "-0.08497", "Europe/London"),("2650000", "Enderby", "", "GB", "826", "", "ENG", "H5", "31UB", "52.58778", "-1.20619", "Europe/London"),("2650004", "Emsworth", "", "GB", "826", "", "ENG", "F2", "24UH", "50.84779", "-0.93697", "Europe/London"),("2650023", "Ely", "", "GB", "826", "", "ENG", "C3", "2650488", "52.39964", "0.26196", "Europe/London"),("2650086", "Ellon", "", "GB", "826", "", "SCT", "T6", "", "57.36405", "-2.07313", "Europe/London"),("2650096", "Ellesmere Port", "", "GB", "826", "", "ENG", "Z8", "00EW100", "53.27875", "-2.90134", "Europe/London"),("2650110", "Elland", "", "GB", "826", "", "ENG", "C2", "00CY005", "53.6851", "-1.83878", "Europe/London"),("2650122", "Elgin", "Элгин", "GB", "826", "", "SCT", "V6", "", "57.64947", "-3.31843", "Europe/London"),("2650128", "Elderslie", "", "GB", "826", "", "SCT", "W2", "", "55.83327", "-4.48598", "Europe/London"),("2650174", "Egremont", "", "GB", "826", "", "ENG", "C9", "16UE", "54.47941", "-3.52756", "Europe/London"),("2650188", "Egham", "Эгхем", "GB", "826", "", "ENG", "N7", "43UG", "51.43158", "-0.55239", "Europe/London"),("2650200", "Edwinstowe", "", "GB", "826", "", "ENG", "J9", "37UG", "53.19454", "-1.06439", "Europe/London"),("2650225", "Edinburgh", "Эдинбург", "GB", "826", "", "SCT", "U8", "", "55.95206", "-3.19648", "Europe/London"),("2650228", "Edgware", "", "GB", "826", "", "ENG", "GLA", "A2", "51.6128", "-0.27539", "Europe/London"),("2650246", "Edenbridge", "", "GB", "826", "", "ENG", "G5", "6945814", "51.19172", "0.06729", "Europe/London"),("2650278", "Eccles", "", "GB", "826", "", "ENG", "L5", "", "53.48333", "-2.33333", "Europe/London"),("2650285", "Ebbw Vale", "", "GB", "826", "", "WLS", "X2", "00PL005", "51.77714", "-3.20792", "Europe/London"),("2650293", "Eaton Socon", "", "GB", "826", "", "ENG", "C3", "12UE", "52.21752", "-0.28925", "Europe/London"),("2650309", "Eastwood", "", "GB", "826", "", "ENG", "J9", "37UD", "53", "-1.3", "Europe/London"),("2650311", "East Wittering", "", "GB", "826", "", "ENG", "P6", "45UD", "50.76969", "-0.87444", "Europe/London"),("2650346", "Retford", "", "GB", "826", "", "ENG", "J9", "37UC", "53.32213", "-0.94315", "Europe/London"),("2650368", "Easton", "", "GB", "826", "", "ENG", "D6", "19UJ", "50.53333", "-2.45", "Europe/London"),("2650376", "East Molesey", "", "GB", "826", "", "ENG", "N7", "43UB", "51.39872", "-0.34916", "Europe/London"),("2650396", "Eastleigh", "", "GB", "826", "", "ENG", "F2", "24UD", "50.96667", "-1.35", "Europe/London"),("2650397", "East Leake", "", "GB", "826", "", "ENG", "J9", "37UJ", "52.83015", "-1.18103", "Europe/London"),("2650405", "East Kilbride", "", "GB", "826", "", "SCT", "W5", "", "55.76412", "-4.17669", "Europe/London"),("2650411", "East Horsley", "", "GB", "826", "", "ENG", "N7", "43UD", "51.27358", "-0.43207", "Europe/London"),("2650435", "East Grinstead", "", "GB", "826", "", "ENG", "P6", "45UG", "51.12382", "-0.0061", "Europe/London"),("2650470", "East Dereham", "", "GB", "826", "", "ENG", "I9", "33UB", "52.68333", "0.93333", "Europe/London"),("2650489", "East Calder", "", "GB", "826", "", "SCT", "W9", "", "55.89186", "-3.46372", "Europe/London"),("2650497", "Eastbourne", "Истборн", "GB", "826", "", "ENG", "E2", "21UC", "50.76871", "0.28453", "Europe/London"),("2650498", "East Boldon", "", "GB", "826", "", "ENG", "M7", "", "54.94452", "-1.42815", "Europe/London"),("2650519", "Easington", "", "GB", "826", "", "ENG", "E1", "00FB039", "53.65359", "0.11501", "Europe/London"),("2650552", "Earls Barton", "", "GB", "826", "", "ENG", "J1", "34UH", "52.26627", "-0.75248", "Europe/London"),("2650563", "Earby", "", "GB", "826", "", "ENG", "H2", "30UJ", "53.91546", "-2.14285", "Europe/London"),("2650589", "Dymchurch", "", "GB", "826", "", "ENG", "G5", "6945806", "51.02544", "0.99392", "Europe/London"),("2650601", "Dyce", "", "GB", "826", "", "SCT", "T5", "", "57.20522", "-2.17676", "Europe/London"),("2650613", "Dursley", "", "GB", "826", "", "ENG", "E6", "23UF", "51.68139", "-2.35333", "Europe/London"),("2650628", "Durham", "Дарем", "GB", "826", "", "ENG", "D8", "", "54.77676", "-1.57566", "Europe/London"),("2650646", "Duntocher", "", "GB", "826", "", "SCT", "W7", "", "55.92437", "-4.41545", "Europe/London"),("2650657", "Dunstable", "", "GB", "826", "", "ENG", "Z6", "00KC018", "51.88571", "-0.52288", "Europe/London"),("2650681", "Dunoon", "", "GB", "826", "", "SCT", "T8", "", "55.94698", "-4.92303", "Europe/London"),("2650721", "Dunholme", "", "GB", "826", "", "ENG", "H7", "32UH", "53.30067", "-0.46541", "Europe/London"),("2650729", "Dungannon", "", "GB", "826", "", "NIR", "N09000009", "", "54.50344", "-6.76723", "Europe/London"),("2650732", "Dunfermline", "Данфермлин", "GB", "826", "", "SCT", "V1", "", "56.07156", "-3.45887", "Europe/London"),("2650749", "Dundonald", "", "GB", "826", "", "NIR", "N09000007", "", "54.59196", "-5.79803", "Europe/London"),("2650752", "Dundee", "Данди", "GB", "826", "", "SCT", "U3", "", "56.46913", "-2.97489", "Europe/London"),("2650769", "Dunblane", "", "GB", "826", "", "SCT", "W6", "", "56.18843", "-3.96417", "Europe/London"),("2650776", "Dunbar", "", "GB", "826", "", "SCT", "U6", "", "56.00062", "-2.51418", "Europe/London"),("2650802", "Dumbarton", "Дамбартон", "GB", "826", "", "SCT", "W7", "", "55.94433", "-4.57061", "Europe/London"),("2650815", "Dukinfield", "", "GB", "826", "", "ENG", "O1", "", "53.47497", "-2.08809", "Europe/London"),("2650839", "Dudley", "Дадли", "GB", "826", "", "ENG", "D7", "", "52.5", "-2.08333", "Europe/London"),("2650962", "Droylsden", "", "GB", "826", "", "ENG", "O1", "00BS001", "53.48005", "-2.14543", "Europe/London"),("2650967", "Dronfield", "", "GB", "826", "", "ENG", "D3", "17UJ", "53.30221", "-1.47507", "Europe/London"),("2650976", "Dromore", "", "GB", "826", "", "NIR", "N09000006", "", "54.51331", "-7.45886", "Europe/London"),("2650983", "Droitwich", "", "GB", "826", "", "ENG", "Q4", "47UF", "52.26667", "-2.15", "Europe/London"),("2651023", "Downpatrick", "", "GB", "826", "", "NIR", "N09000010", "", "54.32814", "-5.71529", "Europe/London"),("2651030", "Downham Market", "", "GB", "826", "", "ENG", "I9", "33UE", "52.60714", "0.38375", "Europe/London"),("2651048", "Dover", "Дувр", "GB", "826", "", "ENG", "G5", "29UE", "51.13333", "1.3", "Europe/London"),("2651082", "Dorridge", "", "GB", "826", "", "ENG", "M2", "44UF", "52.37259", "-1.75318", "Europe/London"),("2651095", "Dorking", "Доркинг", "GB", "826", "", "ENG", "N7", "43UE", "51.23228", "-0.3338", "Europe/London"),("2651101", "Dorchester", "Дорчестер", "GB", "826", "", "ENG", "D6", "19UH", "50.71667", "-2.43333", "Europe/London"),("2651123", "Doncaster", "Донкастер", "GB", "826", "", "ENG", "D5", "", "53.52285", "-1.13116", "Europe/London"),("2651133", "Donaghadee", "", "GB", "826", "", "NIR", "N09000011", "", "54.64126", "-5.53591", "Europe/London"),("2651172", "Dodworth", "", "GB", "826", "", "ENG", "A3", "", "53.54306", "-1.52779", "Europe/London"),("2651214", "Diss", "", "GB", "826", "", "ENG", "I9", "33UH", "52.37675", "1.1091", "Europe/London"),("2651245", "Dingwall", "", "GB", "826", "", "SCT", "V3", "", "57.59531", "-4.42721", "Europe/London"),("2651248", "Dinas Powys", "", "GB", "826", "", "WLS", "Z3", "00PD004", "51.43486", "-3.21398", "Europe/London"),("2651269", "Didcot", "Дидкот", "GB", "826", "", "ENG", "K2", "38UD", "51.60928", "-1.24214", "Europe/London"),("2651286", "Dewsbury", "Дьюсбери", "GB", "826", "", "ENG", "G8", "", "53.69076", "-1.62907", "Europe/London"),("2651294", "Devizes", "", "GB", "826", "", "ENG", "P8", "00HY079", "51.35084", "-1.99421", "Europe/London"),("2651311", "Desborough", "", "GB", "826", "", "ENG", "J1", "34UE", "52.44183", "-0.82126", "Europe/London"),("2651347", "Derby", "Дерби", "GB", "826", "", "ENG", "D2", "", "52.92277", "-1.47663", "Europe/London"),("2651357", "Denton", "", "GB", "826", "", "ENG", "O1", "", "53.45678", "-2.11822", "Europe/London"),("2651366", "Denny", "", "GB", "826", "", "SCT", "U9", "", "56.0235", "-3.90812", "Europe/London"),("2651378", "Denham", "", "GB", "826", "", "ENG", "B9", "11UE", "51.56667", "-0.5", "Europe/London"),("2651386", "Denbigh", "", "GB", "826", "", "WLS", "X9", "00NG012", "53.18333", "-3.41667", "Europe/London"),("2651407", "Deganwy", "", "GB", "826", "", "WLS", "X8", "00NE010", "53.30446", "-3.82735", "Europe/London"),("2651468", "Deal", "", "GB", "826", "", "ENG", "G5", "29UE", "51.22322", "1.40432", "Europe/London"),("2651474", "Dawlish", "", "GB", "826", "", "ENG", "D4", "18UH", "50.58118", "-3.46644", "Europe/London"),("2651485", "Daventry", "Давентри", "GB", "826", "", "ENG", "J1", "34UC", "52.25688", "-1.16066", "Europe/London"),("2651495", "Darwen", "Дарвен", "GB", "826", "", "ENG", "A8", "00EX001", "53.69803", "-2.46494", "Europe/London"),("2651497", "Darton", "", "GB", "826", "", "ENG", "A3", "", "53.58705", "-1.52676", "Europe/London"),("2651498", "Dartmouth", "", "GB", "826", "", "ENG", "D4", "18UG", "50.3522", "-3.5794", "Europe/London"),("2651500", "Dartford", "Дартфорде", "GB", "826", "", "ENG", "G5", "29UD", "51.44657", "0.21423", "Europe/London"),("2651513", "Darlington", "Дарлингтон", "GB", "826", "", "ENG", "D1", "00EH013", "54.52429", "-1.55039", "Europe/London"),("2651520", "Darfield", "", "GB", "826", "", "ENG", "A3", "00CC010", "53.5339", "-1.37595", "Europe/London"),("2651532", "Danbury", "", "GB", "826", "", "ENG", "E4", "22UF", "51.71645", "0.58245", "Europe/London"),("2651551", "Dalton in Furness", "", "GB", "826", "", "ENG", "C9", "16UC", "54.15", "-3.16667", "Europe/London"),("2651558", "Dalserf", "", "GB", "826", "", "SCT", "W5", "", "55.73333", "-3.91667", "Europe/London"),("2651561", "Dalry", "", "GB", "826", "", "SCT", "V7", "", "55.70956", "-4.72167", "Europe/London"),("2651587", "Dalkeith", "", "GB", "826", "", "SCT", "V5", "", "55.89317", "-3.06806", "Europe/London"),("2651621", "Dagenham", "", "GB", "826", "", "ENG", "GLA", "A1", "51.55", "0.16667", "Europe/London"),("2651654", "Cwmbran", "", "GB", "826", "", "WLS", "Z2", "00PM004", "51.65446", "-3.02281", "Europe/London"),("2651656", "Cwmafan", "", "GB", "826", "GB", "WLS", "Y5", "00NZ024", "51.6", "-3.75", "Europe/London"),("2651685", "Currie", "", "GB", "826", "", "SCT", "U8", "", "55.8964", "-3.30845", "Europe/London"),("2651698", "Cupar", "", "GB", "826", "", "SCT", "V1", "", "56.31876", "-3.01204", "Europe/London"),("2651706", "Cumnock", "", "GB", "826", "", "SCT", "U4", "", "55.45445", "-4.26644", "Europe/London"),("2651715", "Cumbernauld", "", "GB", "826", "", "SCT", "V8", "", "55.94685", "-3.99051", "Europe/London");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("2651739", "Cullompton", "", "GB", "826", "", "ENG", "D4", "18UD", "50.8553", "-3.39268", "Europe/London"),("2651763", "Culcheth", "", "GB", "826", "", "ENG", "P2", "00EU006", "53.4511", "-2.52104", "Europe/London"),("2651778", "Cudworth", "", "GB", "826", "", "ENG", "A3", "", "53.57131", "-1.41595", "Europe/London"),("2651804", "Crumlin", "", "GB", "826", "", "NIR", "N09000001", "", "54.62054", "-6.21414", "Europe/London"),("2651805", "Crumlin", "", "GB", "826", "", "WLS", "X4", "00PK010", "51.67778", "-3.13528", "Europe/London"),("2651817", "Croydon", "", "GB", "826", "", "ENG", "GLA", "C8", "51.38333", "-0.1", "Europe/London"),("2651831", "Crowthorne", "", "GB", "826", "", "ENG", "B3", "00MA003", "51.37027", "-0.79219", "Europe/London"),("2651852", "Crowborough", "", "GB", "826", "", "ENG", "E2", "21UH", "51.06098", "0.16342", "Europe/London"),("2651915", "Crook", "", "GB", "826", "", "ENG", "D8", "", "54.7", "-1.73333", "Europe/London"),("2651930", "Cromer", "", "GB", "826", "", "ENG", "I9", "33UF", "52.93123", "1.29892", "Europe/London"),("2651948", "Crofton", "", "GB", "826", "", "ENG", "O7", "00DB005", "53.65639", "-1.42968", "Europe/London"),("2651983", "Crieff", "", "GB", "826", "", "SCT", "W1", "", "56.37268", "-3.83891", "Europe/London"),("2652000", "Crewkerne", "", "GB", "826", "", "ENG", "M3", "40UD", "50.88298", "-2.79588", "Europe/London"),("2652002", "Crewe", "Кру", "GB", "826", "", "ENG", "Z7", "00EQ114", "53.09787", "-2.44161", "Europe/London"),("2652034", "Crediton", "", "GB", "826", "", "ENG", "D4", "18UD", "50.78333", "-3.65", "Europe/London"),("2652053", "Crawley", "Кроули", "GB", "826", "", "ENG", "P6", "45UE", "51.11303", "-0.18312", "Europe/London"),("2652082", "Cranleigh", "", "GB", "826", "", "ENG", "N7", "43UL", "51.14209", "-0.48374", "Europe/London"),("2652095", "Cramlington", "Крамлингтон", "GB", "826", "", "ENG", "J6", "00EM166", "55.08652", "-1.58598", "Europe/London"),("2652191", "Cowley", "", "GB", "826", "", "ENG", "K2", "38UC", "51.73213", "-1.20631", "Europe/London"),("2652204", "Cowes", "Каус", "GB", "826", "", "ENG", "G2", "00MW007", "50.76306", "-1.29772", "Europe/London"),("2652207", "Cowdenbeath", "", "GB", "826", "", "SCT", "V1", "", "56.11194", "-3.34426", "Europe/London"),("2652221", "Coventry", "Ковентри", "GB", "826", "", "ENG", "C7", "", "52.40656", "-1.51217", "Europe/London"),("2652239", "Countesthorpe", "", "GB", "826", "", "ENG", "H5", "31UB", "52.55379", "-1.14526", "Europe/London"),("2652249", "Coulsdon", "", "GB", "826", "", "ENG", "GLA", "C8", "51.32002", "-0.14088", "Europe/London"),("2652269", "Cottenham", "", "GB", "826", "", "ENG", "C3", "12UG", "52.28743", "0.1254", "Europe/London"),("2652282", "Cotgrave", "", "GB", "826", "", "ENG", "J9", "37UJ", "52.90859", "-1.03752", "Europe/London"),("2652294", "Cosham", "", "GB", "826", "", "ENG", "K6", "", "50.84654", "-1.06344", "Europe/London"),("2652318", "Corsham", "", "GB", "826", "", "ENG", "P8", "00HY073", "51.43433", "-2.18437", "Europe/London"),("2652381", "Corby", "Корби", "GB", "826", "", "ENG", "J1", "34UB", "52.49637", "-0.68939", "Europe/London"),("2652389", "Coppull", "", "GB", "826", "", "ENG", "H2", "30UE", "53.62527", "-2.65854", "Europe/London"),("2652417", "Cookstown", "", "GB", "826", "", "NIR", "N09000009", "", "54.64305", "-6.74595", "Europe/London"),("2652423", "Cookham", "", "GB", "826", "", "ENG", "P9", "00ME003", "51.55936", "-0.7081", "Europe/London"),("2652437", "Consett", "Консетт", "GB", "826", "", "ENG", "D8", "00EJ053", "54.85404", "-1.8316", "Europe/London"),("2652458", "Conisbrough", "", "GB", "826", "", "ENG", "D5", "00CE016", "53.48188", "-1.23214", "Europe/London"),("2652464", "Congleton", "Конглтон", "GB", "826", "", "ENG", "Z7", "00EQ043", "53.16314", "-2.21253", "Europe/London"),("2652505", "Comber", "", "GB", "826", "", "NIR", "N09000011", "", "54.54937", "-5.74379", "Europe/London"),("2652513", "Colwyn Bay", "", "GB", "826", "", "WLS", "X8", "00NE009", "53.29483", "-3.72674", "Europe/London"),("2652544", "Colne", "", "GB", "826", "", "ENG", "H2", "30UJ", "53.85713", "-2.16851", "Europe/London"),("2652546", "Colnbrook", "", "GB", "826", "", "ENG", "M1", "00MD002", "51.48384", "-0.52142", "Europe/London"),("2652577", "Colinton", "", "GB", "826", "", "SCT", "U8", "", "55.90739", "-3.25609", "Europe/London"),("2652586", "Coleraine", "Колрэйн", "GB", "826", "", "NIR", "N09000004", "", "55.13333", "-6.66667", "Europe/London"),("2652591", "Coleford", "", "GB", "826", "", "ENG", "E6", "23UD", "51.79535", "-2.61354", "Europe/London"),("2652618", "Colchester", "Колчестер", "GB", "826", "", "ENG", "E4", "22UG", "51.88921", "0.90421", "Europe/London"),("2652622", "Coity", "", "GB", "826", "", "WLS", "X3", "00PB004", "51.522", "-3.55531", "Europe/London"),("2652648", "Coedpoeth", "", "GB", "826", "", "WLS", "Z4", "00NL011", "53.05391", "-3.06234", "Europe/London"),("2652653", "Codsall", "", "GB", "826", "", "ENG", "M9", "41UF", "52.62989", "-2.20148", "Europe/London"),("2652656", "Codicote", "", "GB", "826", "", "ENG", "F8", "26UF", "51.85052", "-0.2367", "Europe/London"),("2652676", "Cockermouth", "", "GB", "826", "", "ENG", "C9", "16UB", "54.66209", "-3.36086", "Europe/London"),("2652681", "Cockenzie", "", "GB", "826", "", "SCT", "U6", "", "55.96823", "-2.96562", "Europe/London"),("2652689", "Cobham", "", "GB", "826", "", "ENG", "N7", "43UB", "51.32997", "-0.4113", "Europe/London"),("2652696", "Coatbridge", "Котбридж", "GB", "826", "", "SCT", "V8", "", "55.86216", "-4.02469", "Europe/London"),("2652698", "Coalville", "", "GB", "826", "", "ENG", "H5", "6896157", "52.72247", "-1.3702", "Europe/London"),("2652703", "Coalisland", "", "GB", "826", "", "NIR", "N09000009", "", "54.5418", "-6.70166", "Europe/London"),("2652730", "Clydebank", "", "GB", "826", "", "SCT", "W7", "", "55.90137", "-4.4057", "Europe/London"),("2652734", "Clydach", "", "GB", "826", "", "WLS", "Z1", "00NX005", "51.68333", "-3.9", "Europe/London"),("2652771", "Clowne", "", "GB", "826", "", "ENG", "D3", "17UC", "53.27449", "-1.26406", "Europe/London"),("2652819", "Clitheroe", "", "GB", "826", "", "ENG", "H2", "30UL", "53.86667", "-2.4", "Europe/London"),("2652857", "Cleveleys", "", "GB", "826", "", "ENG", "H2", "30UQ", "53.8775", "-3.03987", "Europe/London"),("2652861", "Clevedon", "", "GB", "826", "", "ENG", "J4", "00HC013", "51.44227", "-2.85786", "Europe/London"),("2652885", "Cleethorpes", "Клитхорпс", "GB", "826", "", "ENG", "J2", "00FC016", "53.56047", "-0.03225", "Europe/London"),("2652890", "Cleckheaton", "", "GB", "826", "", "ENG", "G8", "00CZ005", "53.72405", "-1.71294", "Europe/London"),("2652891", "Cleator Moor", "", "GB", "826", "", "ENG", "C9", "16UE", "54.52143", "-3.5159", "Europe/London"),("2652898", "Clayton West", "", "GB", "826", "", "ENG", "G8", "00CZ001", "53.59501", "-1.61107", "Europe/London"),("2652899", "Clayton le Moors", "", "GB", "826", "", "ENG", "H2", "30UG", "53.76667", "-2.38333", "Europe/London"),("2652974", "Clacton-on-Sea", "Клактон-он-Си", "GB", "826", "", "ENG", "E4", "22UN", "51.78967", "1.15597", "Europe/London"),("2652995", "Cirencester", "", "GB", "826", "", "ENG", "E6", "23UC", "51.71927", "-1.97145", "Europe/London"),("2652997", "Cinderford", "", "GB", "826", "", "ENG", "E6", "23UD", "51.82421", "-2.4987", "Europe/London"),("2653043", "Churchdown", "", "GB", "826", "", "ENG", "E6", "23UG", "51.87739", "-2.17087", "Europe/London"),("2653075", "Christchurch", "Крайстчерч", "GB", "826", "", "ENG", "D6", "19UC", "50.73583", "-1.78129", "Europe/London"),("2653085", "Chorleywood", "", "GB", "826", "", "ENG", "F8", "26UJ", "51.65472", "-0.51404", "Europe/London"),("2653086", "Chorley", "", "GB", "826", "", "ENG", "H2", "30UE", "53.65", "-2.61667", "Europe/London"),("2653123", "Chislehurst", "Чизлхёрст", "GB", "826", "", "ENG", "GLA", "B8", "51.41709", "0.06858", "Europe/London"),("2653137", "Chipping Sodbury", "", "GB", "826", "", "ENG", "M6", "00HD034", "51.53813", "-2.39379", "Europe/London"),("2653138", "Chipping Ongar", "", "GB", "826", "", "ENG", "E4", "22UH", "51.70379", "0.24548", "Europe/London"),("2653139", "Chipping Norton", "", "GB", "826", "", "ENG", "K2", "38UF", "51.94109", "-1.5453", "Europe/London"),("2653144", "Chippenham", "Чиппенем", "GB", "826", "", "ENG", "P8", "00HY056", "51.46", "-2.12472", "Europe/London"),("2653145", "Chinnor", "", "GB", "826", "", "ENG", "K2", "38UD", "51.70177", "-0.91161", "Europe/London"),("2653178", "Chigwell", "", "GB", "826", "", "ENG", "E4", "22UH", "51.61999", "0.07596", "Europe/London"),("2653192", "Chichester", "Чичестер", "GB", "826", "", "ENG", "P6", "45UD", "50.83673", "-0.78003", "Europe/London"),("2653224", "Chester-le-Street", "", "GB", "826", "", "ENG", "D8", "00EJ084", "54.85862", "-1.57408", "Europe/London"),("2653225", "Chesterfield", "Честерфилд", "GB", "826", "", "ENG", "D3", "17UD", "53.25", "-1.41667", "Europe/London"),("2653228", "Chester", "Честер", "GB", "826", "", "ENG", "Z8", "", "53.1905", "-2.89189", "Europe/London"),("2653229", "Chessington", "", "GB", "826", "", "ENG", "GLA", "G7", "51.3624", "-0.30427", "Europe/London"),("2653232", "Cheshunt", "", "GB", "826", "", "ENG", "F8", "26UB", "51.7002", "-0.03026", "Europe/London"),("2653235", "Chesham", "", "GB", "826", "", "ENG", "B9", "11UC", "51.7", "-0.6", "Europe/London"),("2653239", "Chertsey", "", "GB", "826", "", "ENG", "N7", "43UG", "51.38812", "-0.50782", "Europe/London"),("2653256", "Chepstow", "", "GB", "826", "", "WLS", "Y4", "00PP004", "51.64087", "-2.67683", "Europe/London"),("2653261", "Cheltenham", "Челтнем", "GB", "826", "", "ENG", "E6", "23UB", "51.90006", "-2.07972", "Europe/London"),("2653265", "Chelsea", "Челси", "GB", "826", "", "ENG", "GLA", "G4", "51.48755", "-0.16936", "Europe/London"),("2653266", "Chelmsford", "Челмсфорд", "GB", "826", "", "ENG", "E4", "22UF", "51.73575", "0.46958", "Europe/London"),("2653281", "Cheddar", "", "GB", "826", "", "ENG", "M3", "40UC", "51.27537", "-2.77662", "Europe/London"),("2653289", "Cheam", "", "GB", "826", "", "ENG", "GLA", "N8", "51.36179", "-0.21977", "Europe/London"),("2653290", "Cheadle Hulme", "", "GB", "826", "", "ENG", "N2", "", "53.3761", "-2.1897", "Europe/London"),("2653292", "Cheadle", "", "GB", "826", "", "ENG", "M9", "41UH", "52.98333", "-1.98333", "Europe/London"),("2653298", "Chatteris", "", "GB", "826", "", "ENG", "C3", "12UD", "52.45624", "0.05236", "Europe/London"),("2653305", "Chatham", "Чатем", "GB", "826", "", "ENG", "G5", "", "51.37891", "0.52786", "Europe/London"),("2653307", "Chasetown", "", "GB", "826", "", "ENG", "M9", "41UD", "52.67232", "-1.92535", "Europe/London"),("2653324", "Charlton Kings", "", "GB", "826", "", "ENG", "E6", "23UB", "51.88374", "-2.04239", "Europe/London"),("2653346", "Chard", "", "GB", "826", "", "ENG", "M3", "40UD", "50.8727", "-2.96597", "Europe/London"),("2653353", "Chapletown", "", "GB", "826", "", "ENG", "L9", "00CG002", "53.46506", "-1.47217", "Europe/London"),("2653366", "Chapelhall", "", "GB", "826", "", "SCT", "V8", "", "55.84349", "-3.94881", "Europe/London"),("2653368", "Chapel en le Frith", "", "GB", "826", "", "ENG", "D3", "17UH", "53.32407", "-1.91291", "Europe/London"),("2653392", "Chalford", "", "GB", "826", "", "ENG", "E6", "23UF", "51.72583", "-2.15139", "Europe/London"),("2653393", "Chalfont Saint Peter", "", "GB", "826", "", "ENG", "B9", "11UC", "51.60885", "-0.55618", "Europe/London"),("2653394", "Chalfont St Giles", "", "GB", "826", "", "ENG", "B9", "11UC", "51.63184", "-0.57026", "Europe/London"),("2653520", "Caterham", "", "GB", "826", "", "ENG", "N7", "43UK", "51.2823", "-0.07889", "Europe/London"),("2653558", "Castlereagh", "", "GB", "826", "", "NIR", "N09000003", "", "54.5735", "-5.88472", "Europe/London"),("2653584", "Castleford", "", "GB", "826", "", "ENG", "O7", "", "53.72587", "-1.36256", "Europe/London"),("2653591", "Castle Donington", "", "GB", "826", "", "ENG", "H5", "6896157", "52.84291", "-1.34188", "Europe/London"),("2653634", "Carterton", "", "GB", "826", "", "ENG", "K2", "38UF", "51.75905", "-1.59435", "Europe/London"),("2653646", "Carshalton", "", "GB", "826", "", "ENG", "GLA", "N8", "51.36829", "-0.16755", "Europe/London"),("2653656", "Carryduff", "", "GB", "826", "", "NIR", "N09000007", "", "54.51799", "-5.88713", "Europe/London"),("2653680", "Carrickfergus", "Каррикфергус", "GB", "826", "", "NIR", "N09000008", "", "54.7158", "-5.8058", "Europe/London"),("2653704", "Carnoustie", "", "GB", "826", "", "SCT", "T7", "", "56.50263", "-2.7053", "Europe/London"),("2653715", "Carnforth", "", "GB", "826", "", "ENG", "H2", "30UH", "54.11667", "-2.76667", "Europe/London"),("2653755", "Carmarthen", "Кармартен", "GB", "826", "", "WLS", "X7", "00NU006", "51.85552", "-4.30535", "Europe/London"),("2653756", "Carluke", "", "GB", "826", "", "SCT", "W5", "", "55.73595", "-3.83019", "Europe/London"),("2653775", "Carlisle", "Карлайл", "GB", "826", "", "ENG", "C9", "16UD", "54.8951", "-2.9382", "Europe/London"),("2653822", "Cardiff", "Кардифф", "GB", "826", "", "WLS", "X5", "00PT005", "51.48", "-3.18", "Europe/London"),("2653825", "Carcroft", "", "GB", "826", "", "ENG", "D5", "", "53.58282", "-1.17648", "Europe/London"),("2653877", "Canterbury", "Кентербери", "GB", "826", "", "ENG", "G5", "6945807", "51.27904", "1.07992", "Europe/London"),("2653883", "Cannock", "Каннок", "GB", "826", "", "ENG", "M9", "41UB", "52.69045", "-2.03085", "Europe/London"),("2653941", "Cambridge", "Кембридж", "GB", "826", "", "ENG", "C3", "12UB", "52.2", "0.11667", "Europe/London"),("2653945", "Camborne", "", "GB", "826", "", "ENG", "C6", "00HE015", "50.21306", "-5.29731", "Europe/London"),("2653947", "Camberley", "Кемберли", "GB", "826", "", "ENG", "N7", "43UJ", "51.33705", "-0.74261", "Europe/London"),("2653974", "Calne", "", "GB", "826", "", "ENG", "P8", "00HY044", "51.43879", "-2.00571", "Europe/London"),("2654014", "Caldicot", "", "GB", "826", "", "WLS", "Y4", "00PP003", "51.58661", "-2.75736", "Europe/London"),("2654044", "Caister-on-Sea", "", "GB", "826", "", "ENG", "I9", "33UD", "52.64809", "1.72648", "Europe/London"),("2654089", "Caerphilly", "Керфили", "GB", "826", "", "WLS", "X4", "00PK007", "51.57452", "-3.218", "Europe/London"),("2654092", "Caernarfon", "", "GB", "826", "", "WLS", "Y2", "00NC016", "53.14126", "-4.27016", "Europe/London"),("2654093", "Caerleon", "", "GB", "826", "", "WLS", "Y6", "00PR006", "51.60952", "-2.95378", "Europe/London"),("2654141", "Buxton", "", "GB", "826", "", "ENG", "D3", "17UH", "53.25741", "-1.90982", "Europe/London"),("2654179", "Bushey", "", "GB", "826", "", "ENG", "F8", "26UE", "51.64316", "-0.36053", "Europe/London"),("2654186", "Bury St Edmunds", "Бери-Сент-Эдмендс", "GB", "826", "", "ENG", "N5", "42UF", "52.2463", "0.71111", "Europe/London"),("2654187", "Bury", "Бери", "GB", "826", "", "ENG", "C1", "", "53.6", "-2.3", "Europe/London"),("2654194", "Burwell", "", "GB", "826", "", "ENG", "H7", "32UC", "53.29305", "0.03463", "Europe/London"),("2654200", "Burton upon Trent", "Бертон-апон-Трент", "GB", "826", "", "ENG", "M9", "41UC", "52.80728", "-1.64263", "Europe/London"),("2654208", "Burton Latimer", "", "GB", "826", "", "ENG", "J1", "34UE", "52.36368", "-0.67853", "Europe/London"),("2654226", "Bursledon", "", "GB", "826", "", "ENG", "F2", "24UD", "50.88658", "-1.31596", "Europe/London"),("2654229", "Burry Port", "", "GB", "826", "", "WLS", "X7", "00NU007", "51.68435", "-4.24687", "Europe/London"),("2654252", "Burntwood", "", "GB", "826", "", "ENG", "M9", "41UD", "52.68075", "-1.92759", "Europe/London"),("2654255", "Burntisland", "", "GB", "826", "", "SCT", "V1", "", "56.06248", "-3.23176", "Europe/London"),("2654264", "Burnley", "Бернли", "GB", "826", "", "ENG", "H2", "30UD", "53.8", "-2.23333", "Europe/London"),("2654269", "Burnham-on-Sea", "", "GB", "826", "", "ENG", "M3", "40UC", "51.23862", "-2.9978", "Europe/London"),("2654270", "Burnham-on-Crouch", "", "GB", "826", "", "ENG", "E4", "22UK", "51.63272", "0.81488", "Europe/London"),("2654285", "Burley in Wharfedale", "", "GB", "826", "", "ENG", "B4", "00CX014", "53.9102", "-1.75798", "Europe/London"),("2654308", "Burgess Hill", "", "GB", "826", "", "ENG", "P6", "45UG", "50.95843", "-0.13287", "Europe/London"),("2654327", "Bungay", "", "GB", "826", "", "ENG", "N5", "42UH", "52.45434", "1.43818", "Europe/London"),("2654357", "Bulford", "", "GB", "826", "", "ENG", "P8", "00HY039", "51.1893", "-1.76009", "Europe/London"),("2654380", "Bude", "", "GB", "826", "", "ENG", "C6", "00HE011", "50.82435", "-4.5413", "Europe/London"),("2654394", "Buckley", "", "GB", "826", "", "WLS", "Y1", "00NJ004", "53.16667", "-3.08333", "Europe/London"),("2654410", "Buckingham", "", "GB", "826", "", "ENG", "B9", "11UB", "51.99968", "-0.98779", "Europe/London"),("2654411", "Buckie", "", "GB", "826", "", "SCT", "V6", "", "57.6757", "-2.96238", "Europe/London"),("2654412", "Buckhurst Hill", "", "GB", "826", "", "ENG", "E4", "22UH", "51.62409", "0.03262", "Europe/London"),("2654415", "Buckhaven", "", "GB", "826", "", "SCT", "V1", "", "56.17149", "-3.03377", "Europe/London"),("2654437", "Brynmawr", "", "GB", "826", "", "WLS", "X2", "00PL003", "51.8", "-3.18333", "Europe/London"),("2654447", "Brynamman", "", "GB", "826", "", "WLS", "Y5", "00NZ017", "51.8", "-3.86667", "Europe/London"),("2654450", "Brymbo", "", "GB", "826", "", "WLS", "Z4", "00NL006", "53.06667", "-3.06667", "Europe/London"),("2654461", "Brundall", "", "GB", "826", "", "ENG", "I9", "33UC", "52.62426", "1.43509", "Europe/London"),("2654480", "Broxburn", "", "GB", "826", "", "SCT", "W9", "", "55.93415", "-3.47133", "Europe/London"),("2654481", "Broxbourne", "", "GB", "826", "", "ENG", "F8", "26UB", "51.74712", "-0.01923", "Europe/London"),("2654490", "Brownhills", "Браунхиллс", "GB", "826", "", "ENG", "O8", "", "52.63333", "-1.93333", "Europe/London"),("2654502", "Broughton Astley", "", "GB", "826", "", "ENG", "H5", "31UD", "52.52787", "-1.21768", "Europe/London"),("2654532", "Brough", "", "GB", "826", "", "ENG", "E1", "00FB045", "53.72861", "-0.57215", "Europe/London"),("2654539", "Broseley", "", "GB", "826", "", "ENG", "L6", "00GG034", "52.61321", "-2.48269", "Europe/London"),("2654579", "Bromsgrove", "", "GB", "826", "", "ENG", "Q4", "47UB", "52.33574", "-2.05983", "Europe/London"),("2654596", "Bromborough", "", "GB", "826", "", "ENG", "Q1", "", "53.3485", "-2.97935", "Europe/London"),("2654630", "Broadwater", "", "GB", "826", "", "ENG", "P6", "45UH", "50.82887", "-0.37594", "Europe/London"),("2654634", "Broadstone", "", "GB", "826", "", "ENG", "D6", "", "50.75717", "-1.99406", "Europe/London"),("2654635", "Broadstairs", "", "GB", "826", "", "ENG", "G5", "2636057", "51.35908", "1.43938", "Europe/London"),("2654660", "Brixworth", "", "GB", "826", "", "ENG", "J1", "34UC", "52.32912", "-0.9035", "Europe/London"),("2654663", "Brixham", "", "GB", "826", "", "ENG", "O4", "00HH001", "50.39431", "-3.51585", "Europe/London"),("2654668", "Briton Ferry", "", "GB", "826", "", "WLS", "Y5", "00NZ006", "51.63106", "-3.81898", "Europe/London"),("2654675", "Bristol", "Бристоль", "GB", "826", "", "ENG", "B7", "", "51.45523", "-2.59665", "Europe/London"),("2654710", "Brighton", "Брайтон", "GB", "826", "", "ENG", "B6", "", "50.82838", "-0.13947", "Europe/London"),("2654711", "Brightlingsea", "", "GB", "826", "", "ENG", "E4", "22UN", "51.81164", "1.02336", "Europe/London"),("2654715", "Brighouse", "", "GB", "826", "", "ENG", "C2", "00CZ003", "53.70322", "-1.78428", "Europe/London"),("2654721", "Brigg", "", "GB", "826", "", "ENG", "J3", "00FD010", "53.55201", "-0.49214", "Europe/London"),("2654724", "Brierley Hill", "", "GB", "826", "", "ENG", "D7", "", "52.48173", "-2.12139", "Europe/London"),("2654725", "Brierfield", "", "GB", "826", "", "ENG", "H2", "30UJ", "53.82468", "-2.23415", "Europe/London"),("2654726", "Bridport", "", "GB", "826", "", "ENG", "D6", "19UH", "50.7338", "-2.75831", "Europe/London"),("2654728", "Bridlington", "", "GB", "826", "", "ENG", "E1", "00FB169", "54.08306", "-0.19192", "Europe/London"),("2654730", "Bridgwater", "Бриджуотер", "GB", "826", "", "ENG", "M3", "40UC", "51.12837", "-3.00356", "Europe/London"),("2654731", "Bridgnorth", "", "GB", "826", "", "ENG", "L6", "00GG032", "52.53661", "-2.42033", "Europe/London"),("2654747", "Bridge of Allan", "", "GB", "826", "", "SCT", "W6", "", "56.15402", "-3.94631", "Europe/London"),("2654755", "Bridgend", "Бридженд", "GB", "826", "", "WLS", "X3", "00PB002", "51.50583", "-3.57722", "Europe/London"),("2654782", "Brentwood", "Брентвуд", "GB", "826", "", "ENG", "E4", "22UD", "51.62127", "0.30556", "Europe/London"),("2654787", "Brentford", "", "GB", "826", "", "ENG", "GLA", "D9", "51.48619", "-0.3083", "Europe/London"),("2654814", "Bredbury", "", "GB", "826", "", "ENG", "N2", "", "53.41667", "-2.11667", "Europe/London"),("2654817", "Brecon", "", "GB", "826", "", "WLS", "Y8", "00NN009", "51.94612", "-3.38887", "Europe/London"),("2654824", "Brechin", "", "GB", "826", "", "SCT", "T7", "", "56.72993", "-2.65729", "Europe/London"),("2654858", "Braunton", "", "GB", "826", "", "ENG", "D4", "18UE", "51.10847", "-4.16131", "Europe/London"),("2654897", "Brandon", "", "GB", "826", "", "ENG", "P3", "44UD", "52.38432", "-1.3996", "Europe/London"),("2654919", "Brampton", "", "GB", "826", "", "ENG", "C3", "12UE", "52.32039", "-0.22007", "Europe/London"),("2654927", "Bramhall", "", "GB", "826", "", "ENG", "N2", "00EQ107", "53.35801", "-2.16539", "Europe/London"),("2654938", "Braintree", "", "GB", "826", "", "ENG", "E4", "22UC", "51.87819", "0.55292", "Europe/London"),("2654991", "Bradford-on-Avon", "", "GB", "826", "", "ENG", "P8", "00HY026", "51.34772", "-2.25065", "Europe/London"),("2654993", "Bradford", "Брадфорд", "GB", "826", "", "ENG", "B4", "", "53.79391", "-1.75206", "Europe/London"),("2655009", "Bracknell", "", "GB", "826", "", "ENG", "B3", "00MA002", "51.41363", "-0.75054", "Europe/London"),("2655012", "Brackley", "", "GB", "826", "", "ENG", "J1", "34UG", "52.03333", "-1.15", "Europe/London"),("2655069", "Bowdon", "", "GB", "826", "", "ENG", "O6", "", "53.37644", "-2.36532", "Europe/London"),("2655095", "Bournemouth", "Борнмут", "GB", "826", "", "ENG", "B2", "19UC", "50.72048", "-1.8795", "Europe/London"),("2655097", "Bourne End", "", "GB", "826", "", "ENG", "B9", "11UF", "51.57622", "-0.71291", "Europe/London"),("2655099", "Bourne", "", "GB", "826", "", "ENG", "H7", "32UG", "52.76667", "-0.38333", "Europe/London"),("2655117", "Boughton", "", "GB", "826", "", "ENG", "J9", "37UG", "53.2", "-0.98333", "Europe/London"),("2655130", "Bothwell", "", "GB", "826", "", "SCT", "W5", "", "55.80272", "-4.06835", "Europe/London"),("2655136", "Boston Spa", "", "GB", "826", "", "ENG", "H3", "00DA006", "53.90419", "-1.34523", "Europe/London"),("2655138", "Boston", "Бостон", "GB", "826", "", "ENG", "H7", "32UB", "52.97633", "-0.02664", "Europe/London"),("2655168", "Borrowash", "", "GB", "826", "", "ENG", "D3", "17UG", "52.90673", "-1.38411", "Europe/London"),("2655186", "Borehamwood", "", "GB", "826", "", "ENG", "F8", "26UE", "51.65468", "-0.27762", "Europe/London"),("2655198", "Bootle", "Бутл", "GB", "826", "", "ENG", "L8", "", "53.46667", "-3.01667", "Europe/London"),("2655210", "Bonnyrigg", "", "GB", "826", "", "SCT", "V5", "", "55.87329", "-3.1051", "Europe/London"),("2655211", "Bonnybridge", "", "GB", "826", "", "SCT", "U9", "", "56.00152", "-3.8886", "Europe/London"),("2655214", "Bonhill", "", "GB", "826", "", "SCT", "W7", "", "55.97944", "-4.5638", "Europe/London"),("2655215", "Bo’ness", "", "GB", "826", "", "SCT", "U9", "", "56.01667", "-3.61667", "Europe/London"),("2655230", "Bolton upon Dearne", "", "GB", "826", "", "ENG", "A3", "", "53.51667", "-1.31667", "Europe/London"),("2655232", "Bolton le Sands", "", "GB", "826", "", "ENG", "H2", "30UH", "54.08333", "-2.78333", "Europe/London"),("2655237", "Bolton", "Болтон", "GB", "826", "", "ENG", "B1", "", "53.58333", "-2.43333", "Europe/London"),("2655242", "Bolsover", "", "GB", "826", "", "ENG", "D3", "17UC", "53.22846", "-1.29204", "Europe/London"),("2655245", "Bollington", "", "GB", "826", "", "ENG", "Z7", "00EQ022", "53.29446", "-2.10963", "Europe/London"),("2655250", "The Boldons", "", "GB", "826", "", "ENG", "M7", "", "54.9426", "-1.45349", "Europe/London"),("2655262", "Bognor Regis", "", "GB", "826", "", "ENG", "P6", "45UC", "50.78206", "-0.67978", "Europe/London"),("2655273", "Bodmin", "", "GB", "826", "", "ENG", "C6", "00HE006", "50.47151", "-4.7243", "Europe/London"),("2655315", "Blyth", "Блит", "GB", "826", "", "ENG", "J6", "00EM165", "55.12708", "-1.50856", "Europe/London"),("2655329", "Bloxwich", "", "GB", "826", "", "ENG", "O8", "41UF", "52.61806", "-2.00431", "Europe/London"),("2655351", "Bletchley", "", "GB", "826", "", "ENG", "I6", "00MG039", "51.99334", "-0.73471", "Europe/London"),("2655369", "Blaydon-on-Tyne", "", "GB", "826", "", "ENG", "E5", "", "54.96461", "-1.71392", "Europe/London"),("2655378", "Blandford Forum", "", "GB", "826", "", "ENG", "D6", "19UE", "50.86073", "-2.16174", "Europe/London"),("2655394", "Blairgowrie", "", "GB", "826", "", "SCT", "W1", "", "56.59157", "-3.34045", "Europe/London"),("2655413", "Blaenavon", "", "GB", "826", "", "WLS", "Z2", "00PM002", "51.77402", "-3.08537", "Europe/London"),("2655454", "Blackrod", "", "GB", "826", "", "ENG", "B1", "00BL001", "53.59229", "-2.58026", "Europe/London"),("2655459", "Blackpool", "Блэкпул", "GB", "826", "", "ENG", "A9", "", "53.81667", "-3.05", "Europe/London"),("2655524", "Blackburn", "Блэкберн", "GB", "826", "", "ENG", "A8", "", "53.75", "-2.48333", "Europe/London"),("2655532", "Blaby", "", "GB", "826", "", "ENG", "H5", "31UB", "52.57577", "-1.16403", "Europe/London"),("2655548", "Bishopton", "", "GB", "826", "", "SCT", "W2", "", "55.90969", "-4.5056", "Europe/London"),("2655551", "Bishops Waltham", "", "GB", "826", "", "ENG", "F2", "24UP", "50.95", "-1.21667", "Europe/London"),("2655557", "Bishopstoke", "", "GB", "826", "", "ENG", "F2", "24UD", "50.96643", "-1.32832", "Europe/London"),("2655562", "Bishops Stortford", "", "GB", "826", "", "ENG", "F8", "26UD", "51.87113", "0.15868", "Europe/London"),("2655582", "Bishopbriggs", "Бишопбриггс", "GB", "826", "", "SCT", "U5", "", "55.90669", "-4.21869", "Europe/London"),("2655583", "Bishop Auckland", "Бишоп-Окленд", "GB", "826", "", "ENG", "D8", "00EJ006", "54.65554", "-1.67706", "Europe/London"),("2655603", "Birmingham", "Бирмингем", "GB", "826", "", "ENG", "A7", "", "52.48142", "-1.89983", "Europe/London"),("2655613", "Birkenhead", "Биркенхед", "GB", "826", "", "ENG", "Q1", "00EW114", "53.39337", "-3.01479", "Europe/London"),("2655624", "Bircotes", "", "GB", "826", "", "ENG", "J9", "37UC", "53.41933", "-1.04905", "Europe/London"),("2655627", "Birchington-on-Sea", "", "GB", "826", "", "ENG", "G5", "2636057", "51.37575", "1.3048", "Europe/London"),("2655642", "Bingley", "", "GB", "826", "", "ENG", "B4", "00CX017", "53.84861", "-1.83857", "Europe/London"),("2655643", "Bingham", "", "GB", "826", "", "ENG", "J9", "37UJ", "52.94978", "-0.95907", "Europe/London"),("2655662", "Billingshurst", "", "GB", "826", "", "ENG", "P6", "45UF", "51.02312", "-0.45359", "Europe/London"),("2655664", "Billingham", "Биллингем", "GB", "826", "", "ENG", "N3", "00EF019", "54.58881", "-1.29034", "Europe/London"),("2655666", "Billinge", "", "GB", "826", "", "ENG", "N1", "00BZ001", "53.49795", "-2.7081", "Europe/London"),("2655672", "Billericay", "Биллерикей", "GB", "826", "", "ENG", "E4", "22UB", "51.62867", "0.41963", "Europe/London"),("2655689", "Biggleswade", "", "GB", "826", "", "ENG", "Z6", "00KC008", "52.08652", "-0.26493", "Europe/London"),("2655690", "Biggin Hill", "", "GB", "826", "", "ENG", "GLA", "B8", "51.31329", "0.03433", "Europe/London"),("2655707", "Bideford", "", "GB", "826", "", "ENG", "D4", "18UK", "51.01678", "-4.20832", "Europe/London"),("2655708", "Biddulph", "", "GB", "826", "", "ENG", "M9", "41UH", "53.11724", "-2.17584", "Europe/London"),("2655729", "Bicester", "", "GB", "826", "", "ENG", "K2", "38UB", "51.89998", "-1.15357", "Europe/London"),("2655775", "Bexley", "", "GB", "826", "", "ENG", "GLA", "A6", "51.44162", "0.14866", "Europe/London"),("2655777", "Bexhill-on-Sea", "", "GB", "826", "", "ENG", "E2", "21UG", "50.85023", "0.47095", "Europe/London"),("2655781", "Bewdley", "", "GB", "826", "", "ENG", "Q4", "47UG", "52.3757", "-2.31833", "Europe/London"),("2655785", "Beverley", "", "GB", "826", "", "ENG", "E1", "00FB166", "53.84587", "-0.42332", "Europe/London"),("2655819", "Berwick-Upon-Tweed", "Бервик-апон-Твид", "GB", "826", "", "ENG", "J6", "00EM020", "55.78333", "-2", "Europe/London"),("2655858", "Berkhamsted", "", "GB", "826", "", "ENG", "F8", "26UC", "51.7604", "-0.56528", "Europe/London"),("2655882", "Bentley", "", "GB", "826", "", "ENG", "D5", "", "53.53333", "-1.15", "Europe/London"),("2655886", "Benson", "", "GB", "826", "", "ENG", "K2", "38UD", "51.62073", "-1.10979", "Europe/London"),("2655929", "Belvedere", "", "GB", "826", "", "ENG", "GLA", "A6", "51.49114", "0.15136", "Europe/London"),("2655942", "Belper", "Белпер", "GB", "826", "", "ENG", "D3", "17UB", "53.0233", "-1.48119", "Europe/London"),("2655952", "Bellshill", "", "GB", "826", "", "SCT", "V8", "", "55.81667", "-4.01667", "Europe/London"),("2655984", "Belfast", "Белфаст", "GB", "826", "", "NIR", "N09000003", "", "54.59682", "-5.92541", "Europe/London"),("2655994", "Beith", "", "GB", "826", "", "SCT", "V7", "", "55.74923", "-4.6368", "Europe/London"),("2656000", "Beighton", "", "GB", "826", "", "ENG", "L9", "", "53.33333", "-1.33333", "Europe/London"),("2656031", "Bedworth", "Бедворс", "GB", "826", "", "ENG", "P3", "44UC", "52.4791", "-1.46909", "Europe/London"),("2656033", "Bedwas", "", "GB", "826", "", "WLS", "X4", "00PK005", "51.59183", "-3.19886", "Europe/London"),("2656039", "Bedlington", "", "GB", "826", "", "ENG", "J6", "00EM156", "55.13061", "-1.59319", "Europe/London"),("2656046", "Bedford", "Бедфорд", "GB", "826", "", "ENG", "Z5", "", "52.13459", "-0.46632", "Europe/London"),("2656065", "Beckenham", "", "GB", "826", "", "ENG", "GLA", "B8", "51.40878", "-0.02526", "Europe/London"),("2656067", "Beccles", "", "GB", "826", "", "ENG", "N5", "42UH", "52.45936", "1.56465", "Europe/London"),("2656070", "Bebington", "", "GB", "826", "", "ENG", "Q1", "", "53.35", "-3.01667", "Europe/London"),("2656086", "Bearsden", "Берсден", "GB", "826", "", "SCT", "U5", "", "55.91536", "-4.33279", "Europe/London"),("2656120", "Beaconsfield", "", "GB", "826", "", "ENG", "B9", "11UE", "51.61219", "-0.64732", "Europe/London"),("2656161", "Battle", "", "GB", "826", "", "ENG", "E2", "21UG", "50.91732", "0.48417", "Europe/London"),("2656168", "Batley", "", "GB", "826", "", "ENG", "G8", "", "53.70291", "-1.6337", "Europe/London"),("2656169", "Bathgate", "", "GB", "826", "", "SCT", "W9", "", "55.90204", "-3.64398", "Europe/London"),("2656173", "Bath", "Бат", "GB", "826", "", "ENG", "A4", "", "51.3751", "-2.36172", "Europe/London"),("2656192", "Basingstoke", "", "GB", "826", "", "ENG", "F2", "24UB", "51.26249", "-1.08708", "Europe/London"),("2656194", "Basildon", "Басилдон", "GB", "826", "", "ENG", "E4", "22UB", "51.56844", "0.45782", "Europe/London"),("2656206", "Barton upon Humber", "", "GB", "826", "", "ENG", "J3", "00FD006", "53.68004", "-0.43765", "Europe/London"),("2656235", "Barry", "Барри", "GB", "826", "", "WLS", "Z3", "00PD001", "51.39979", "-3.2838", "Europe/London"),("2656239", "Barrow upon Soar", "", "GB", "826", "", "ENG", "H5", "31UC", "52.75178", "-1.14601", "Europe/London"),("2656241", "Barrow in Furness", "", "GB", "826", "", "ENG", "C9", "16UC", "54.11094", "-3.22758", "Europe/London"),("2656243", "Barrowford", "", "GB", "826", "", "ENG", "H2", "30UJ", "53.8465", "-2.21838", "Europe/London"),("2656258", "Barrhead", "Баррхед", "GB", "826", "", "SCT", "U7", "", "55.79916", "-4.39285", "Europe/London"),("2656277", "Barnt Green", "", "GB", "826", "", "ENG", "Q4", "47UB", "52.35902", "-2.00715", "Europe/London"),("2656281", "Barnstaple", "Барнстапл", "GB", "826", "", "ENG", "D4", "18UE", "51.08022", "-4.05808", "Europe/London"),("2656284", "Barnsley", "Барнсли", "GB", "826", "", "ENG", "A3", "", "53.55", "-1.48333", "Europe/London"),("2656287", "Barnoldswick", "", "GB", "826", "", "ENG", "H2", "30UJ", "53.91711", "-2.18705", "Europe/London"),("2656293", "Barnham", "", "GB", "826", "", "ENG", "P6", "45UC", "50.8312", "-0.63789", "Europe/London"),("2656295", "Barnet", "Барнет", "GB", "826", "", "ENG", "GLA", "A2", "51.65", "-0.2", "Europe/London"),("2656305", "Barnard Castle", "", "GB", "826", "", "ENG", "D8", "00EJ002", "54.5415", "-1.919", "Europe/London"),("2656333", "Barking", "", "GB", "826", "", "ENG", "GLA", "A1", "51.53333", "0.08333", "Europe/London"),("2656340", "Bargoed", "", "GB", "826", "", "WLS", "X4", "00PK004", "51.68333", "-3.23333", "Europe/London"),("2656379", "Banstead", "", "GB", "826", "", "ENG", "N7", "43UF", "51.32233", "-0.20685", "Europe/London"),("2656382", "Bannockburn", "", "GB", "826", "", "SCT", "W6", "", "56.08978", "-3.91092", "Europe/London"),("2656396", "Bangor", "Бангор", "GB", "826", "", "NIR", "N09000011", "", "54.65338", "-5.66895", "Europe/London"),("2656397", "Bangor", "Бангор", "GB", "826", "", "WLS", "Y2", "00NC006", "53.22752", "-4.12936", "Europe/London"),("2656405", "Banchory", "", "GB", "826", "", "SCT", "T6", "", "57.05168", "-2.48824", "Europe/London"),("2656406", "Banbury", "Банбери", "GB", "826", "", "ENG", "K2", "38UB", "52.0632", "-1.34222", "Europe/London"),("2656407", "Banbridge", "Банбридж", "GB", "826", "", "NIR", "N09000002", "", "54.35", "-6.28333", "Europe/London"),("2656483", "Ballynahinch", "", "GB", "826", "", "NIR", "N09000010", "", "54.4023", "-5.89717", "Europe/London"),("2656488", "Ballymoney", "", "GB", "826", "", "NIR", "N09000004", "", "55.0708", "-6.51009", "Europe/London"),("2656490", "Ballymena", "Бэллимена", "GB", "826", "", "NIR", "N09000008", "", "54.86357", "-6.27628", "Europe/London"),("2656528", "Ballyclare", "", "GB", "826", "", "NIR", "N09000001", "", "54.75089", "-5.99944", "Europe/London"),("2656531", "Ballycastle", "", "GB", "826", "", "NIR", "N09000004", "", "55.20444", "-6.24298", "Europe/London"),("2656551", "Ballingry", "", "GB", "826", "", "SCT", "V1", "", "56.16392", "-3.32841", "Europe/London"),("2656586", "Balerno", "", "GB", "826", "", "SCT", "U8", "", "55.88437", "-3.33975", "Europe/London"),("2656594", "Baldock", "", "GB", "826", "", "ENG", "F8", "26UF", "51.98781", "-0.18835", "Europe/London"),("2656627", "Baildon", "", "GB", "826", "", "ENG", "B4", "00CX016", "53.84711", "-1.78785", "Europe/London"),("2656632", "Bagshot", "", "GB", "826", "", "ENG", "N7", "43UJ", "51.36069", "-0.68802", "Europe/London"),("2656666", "Bacup", "", "GB", "826", "", "ENG", "H2", "30UM", "53.70336", "-2.2007", "Europe/London"),("2656708", "Ayr", "Эр", "GB", "826", "", "SCT", "W4", "", "55.46273", "-4.63393", "Europe/London"),("2656713", "Aylsham", "", "GB", "826", "", "ENG", "I9", "33UC", "52.79672", "1.25107", "Europe/London"),("2656719", "Aylesbury", "Эйлсбери", "GB", "826", "", "ENG", "B9", "11UB", "51.81665", "-0.81458", "Europe/London"),("2656725", "Axminster", "", "GB", "826", "", "ENG", "D4", "18UB", "50.78259", "-2.99787", "Europe/London"),("2656759", "Aveley", "", "GB", "826", "", "ENG", "O3", "", "51.49987", "0.25174", "Europe/London"),("2656792", "Audley", "", "GB", "826", "", "ENG", "M9", "41UE", "53.05", "-2.3", "Europe/London"),("2656837", "Attleborough", "", "GB", "826", "", "ENG", "P3", "44UC", "52.51293", "-1.45487", "Europe/London"),("2656847", "Atherton", "", "GB", "826", "", "ENG", "P7", "00BL003", "53.52371", "-2.49354", "Europe/London"),("2656848", "Atherstone", "", "GB", "826", "", "ENG", "P3", "44UB", "52.57536", "-1.54693", "Europe/London"),("2656907", "Askern", "", "GB", "826", "", "ENG", "D5", "00CE003", "53.61639", "-1.15237", "Europe/London"),("2656915", "Ashton-under-Lyne", "Эштон-андер-Лайн", "GB", "826", "", "ENG", "O1", "", "53.48876", "-2.0989", "Europe/London"),("2656918", "Ashton in Makerfield", "", "GB", "826", "", "ENG", "P7", "", "53.48333", "-2.65", "Europe/London"),("2656924", "Ashtead", "", "GB", "826", "", "ENG", "N7", "43UE", "51.30873", "-0.29972", "Europe/London"),("2656955", "Ashford", "Эшфорд", "GB", "826", "", "ENG", "G5", "29UB", "51.14648", "0.87376", "Europe/London"),("2656970", "Ashby de la Zouch", "", "GB", "826", "", "ENG", "H5", "6896157", "52.74632", "-1.4732", "Europe/London"),("2656981", "Ashbourne", "", "GB", "826", "", "ENG", "D3", "17UF", "53.01667", "-1.73333", "Europe/London"),("2656992", "Ascot", "Аскот", "GB", "826", "", "ENG", "P9", "00ME012", "51.41082", "-0.6748", "Europe/London"),("2657030", "Arnold", "Арнольд", "GB", "826", "", "ENG", "J9", "37UE", "53", "-1.13333", "Europe/London"),("2657051", "Armthorpe", "", "GB", "826", "", "ENG", "D5", "00CE002", "53.53518", "-1.05341", "Europe/London"),("2657054", "Armitage", "", "GB", "826", "", "ENG", "M9", "41UD", "52.74193", "-1.88266", "Europe/London"),("2657060", "Armagh", "", "GB", "826", "", "NIR", "N09000002", "", "54.35", "-6.66667", "Europe/London"),("2657067", "Armadale", "", "GB", "826", "", "SCT", "W9", "", "55.88333", "-3.7", "Europe/London"),("2657125", "Ardrossan", "", "GB", "826", "", "SCT", "V7", "", "55.65018", "-4.80659", "Europe/London"),("2657215", "Arbroath", "Арброт", "GB", "826", "", "SCT", "T7", "", "56.56317", "-2.58736", "Europe/London"),("2657224", "Appley Bridge", "", "GB", "826", "", "ENG", "H2", "30UP", "53.57781", "-2.7209", "Europe/London"),("2657255", "Antrim", "Антрим", "GB", "826", "", "NIR", "N09000001", "", "54.7", "-6.2", "Europe/London"),("2657268", "Anstey", "", "GB", "826", "", "ENG", "H5", "31UC", "52.67368", "-1.18841", "Europe/London"),("2657282", "Annfield Plain", "", "GB", "826", "", "ENG", "D8", "00EJ110", "54.85749", "-1.73827", "Europe/London"),("2657293", "Annan", "", "GB", "826", "", "SCT", "U2", "16UB", "54.98839", "-3.25647", "Europe/London"),("2657324", "Andover", "Андовер", "GB", "826", "", "ENG", "F2", "24UN", "51.21135", "-1.49393", "Europe/London"),("2657337", "Ampthill", "", "GB", "826", "", "ENG", "Z6", "00KC001", "52.02694", "-0.49567", "Europe/London"),("2657345", "Ammanford", "", "GB", "826", "", "WLS", "X7", "00NU003", "51.79279", "-3.98833", "Europe/London"),("2657355", "Amesbury", "", "GB", "826", "", "ENG", "P8", "00HY007", "51.17509", "-1.78064", "Europe/London"),("2657356", "Amersham", "Амершам", "GB", "826", "", "ENG", "B9", "11UC", "51.66667", "-0.61667", "Europe/London"),("2657362", "Amble", "", "GB", "826", "", "ENG", "J6", "00EM010", "55.33333", "-1.58333", "Europe/London"),("2657397", "Alva", "", "GB", "826", "", "SCT", "U1", "", "56.15284", "-3.80505", "Europe/London"),("2657402", "Altrincham", "", "GB", "826", "", "ENG", "O6", "00EQ008", "53.38752", "-2.34848", "Europe/London"),("2657408", "Alton", "", "GB", "826", "", "ENG", "F2", "24UC", "51.14931", "-0.97469", "Europe/London"),("2657430", "Alsager", "", "GB", "826", "", "ENG", "Z7", "00EQ006", "53.09617", "-2.30649", "Europe/London"),("2657433", "Alresford", "", "GB", "826", "", "ENG", "E4", "22UN", "51.85389", "1.00203", "Europe/London"),("2657438", "Alnwick", "", "GB", "826", "", "ENG", "J6", "00EM008", "55.41318", "-1.70563", "Europe/London"),("2657471", "Alloa", "Аллоа", "GB", "826", "", "SCT", "U1", "", "56.11586", "-3.78997", "Europe/London"),("2657508", "Alfreton", "Алфретон", "GB", "826", "", "ENG", "D3", "17UB", "53.09766", "-1.38376", "Europe/London"),("2657513", "Alexandria", "", "GB", "826", "", "SCT", "W7", "", "55.99379", "-4.5864", "Europe/London"),("2657528", "Aldridge", "", "GB", "826", "", "ENG", "O8", "41UD", "52.60549", "-1.91715", "Europe/London"),("2657540", "Aldershot", "Олдершот", "GB", "826", "", "ENG", "F2", "24UL", "51.24827", "-0.76389", "Europe/London"),("2657566", "Alcester", "", "GB", "826", "", "ENG", "P3", "44UE", "52.21667", "-1.86667", "Europe/London"),("2657571", "Albrighton", "", "GB", "826", "", "ENG", "L6", "00GG007", "52.6364", "-2.27966", "Europe/London"),("2657613", "Airdrie", "", "GB", "826", "", "SCT", "V8", "", "55.86602", "-3.98025", "Europe/London"),("2657668", "Adlington", "", "GB", "826", "", "ENG", "H2", "30UE", "53.61323", "-2.60676", "Europe/London"),("2657676", "Addlestone", "", "GB", "826", "", "ENG", "N7", "43UG", "51.37135", "-0.49353", "Europe/London"),("2657697", "Acton", "", "GB", "826", "", "ENG", "GLA", "D9", "51.50901", "-0.2762", "Europe/London"),("2657703", "Acocks Green", "", "GB", "826", "", "ENG", "A7", "", "52.45", "-1.81667", "Europe/London"),("2657770", "Accrington", "Аккрингтон", "GB", "826", "", "ENG", "H2", "30UG", "53.75379", "-2.35863", "Europe/London"),("2657774", "Abram", "", "GB", "826", "", "ENG", "P7", "00BL003", "53.50855", "-2.59266", "Europe/London"),("2657780", "Abingdon", "Абингдон", "GB", "826", "", "ENG", "K2", "38UE", "51.67109", "-1.28278", "Europe/London"),("2657782", "Aberystwyth", "Аберистуит", "GB", "826", "", "WLS", "X6", "00NQ003", "52.41548", "-4.08292", "Europe/London"),("2657784", "Abertillery", "", "GB", "826", "", "WLS", "X2", "00PL001", "51.72981", "-3.13432", "Europe/London"),("2657804", "Aberkenfig", "", "GB", "826", "", "WLS", "X3", "00PB014", "51.54", "-3.59556", "Europe/London"),("2657812", "Abergele", "Абергеле", "GB", "826", "", "WLS", "X8", "00NE001", "53.28436", "-3.5822", "Europe/London"),("2657815", "Abergavenny", "", "GB", "826", "", "WLS", "Y4", "00PP001", "51.82098", "-3.01743", "Europe/London"),("2657832", "Aberdeen", "Абердин", "GB", "826", "", "SCT", "T5", "", "57.14369", "-2.09814", "Europe/London"),("2657835", "Aberdare", "Абердэйр", "GB", "826", "", "WLS", "Y9", "00PF003", "51.71438", "-3.44918", "Europe/London"),("2657844", "Abercarn", "", "GB", "826", "", "WLS", "X4", "00PK001", "51.64733", "-3.13476", "Europe/London"),("2657845", "Abercanaid", "", "GB", "826", "", "WLS", "Y3", "00PH011", "51.72361", "-3.36611", "Europe/London"),("2657863", "Abbots Langley", "", "GB", "826", "", "ENG", "F8", "26UJ", "51.70573", "-0.41757", "Europe/London"),("3209584", "Crosby", "", "GB", "826", "", "ENG", "L8", "", "53.47778", "-3.03333", "Europe/London"),("3234498", "East Cowes", "", "GB", "826", "", "ENG", "G2", "00MW027", "50.75774", "-1.28815", "Europe/London"),("3345093", "Looe", "", "GB", "826", "", "ENG", "C6", "00HE075", "50.35778", "-4.45418", "Europe/London"),("3345315", "Abertridwr", "", "GB", "826", "", "WLS", "X4", "00PK002", "51.59583", "-3.26833", "Europe/London"),("3345316", "Beddau", "", "GB", "826", "", "WLS", "Y9", "00PF012", "51.55398", "-3.35814", "Europe/London"),("3345317", "Blackwood", "", "GB", "826", "", "WLS", "X4", "00PK006", "51.66778", "-3.2075", "Europe/London"),("3345396", "Peasedown Saint John", "", "GB", "826", "", "ENG", "A4", "00HA035", "51.31667", "-2.42417", "Europe/London"),("3345432", "Neston", "", "GB", "826", "", "ENG", "P8", "00HY073", "51.41222", "-2.20056", "Europe/London"),("3345437", "Camden Town", "", "GB", "826", "", "ENG", "GLA", "C4", "51.54057", "-0.14334", "Europe/London"),("3345439", "Telford", "Телфорд", "GB", "826", "", "ENG", "O2", "00GF013", "52.67659", "-2.44926", "Europe/London"),("3345440", "Craigavon", "Крейгавон", "GB", "826", "", "NIR", "N09000002", "", "54.44709", "-6.387", "Europe/London"),("6301921", "Kesgrave", "", "GB", "826", "", "ENG", "N5", "42UG", "52.06241", "1.2365", "Europe/London"),("6301962", "Meltham Mills", "", "GB", "826", "", "ENG", "G8", "00CZ004", "53.59388", "-1.83989", "Europe/London"),("6545243", "Bayswater", "", "GB", "826", "", "ENG", "GLA", "P5", "51.51116", "-0.18426", "Europe/London"),("6545250", "Lambeth", "", "GB", "826", "", "ENG", "GLA", "H1", "51.49635", "-0.11152", "Europe/London"),("6615338", "West End of London", "", "GB", "826", "", "ENG", "GLA", "P5", "51.51414", "-0.1551", "Europe/London"),("6615542", "Thorpe Hamlet", "", "GB", "826", "", "ENG", "I9", "33UG", "52.6277", "1.31175", "Europe/London"),("6620293", "Yateley", "", "GB", "826", "", "ENG", "F2", "24UG", "51.34305", "-0.82985", "Europe/London"),("6620310", "Didsbury", "", "GB", "826", "", "ENG", "I2", "00BN001", "53.41698", "-2.23145", "Europe/London"),("6620355", "Bowthorpe", "", "GB", "826", "", "ENG", "I9", "33UG", "52.63884", "1.21885", "Europe/London"),("6620360", "Hedge End", "", "GB", "826", "", "ENG", "F2", "24UD", "50.91234", "-1.30076", "Europe/London"),("6620444", "Gerrards Cross", "", "GB", "826", "", "ENG", "B9", "11UE", "51.5861", "-0.55543", "Europe/London"),("6621541", "Maidenbower", "", "GB", "826", "", "ENG", "P6", "45UE", "51.10781", "-0.15286", "Europe/London"),("6621542", "Furnace Green", "", "GB", "826", "", "ENG", "P6", "45UE", "51.10742", "-0.16889", "Europe/London"),("6621545", "Broadfield", "", "GB", "826", "", "ENG", "P6", "45UE", "51.09714", "-0.20664", "Europe/London"),("6621546", "Bewbush", "", "GB", "826", "", "ENG", "P6", "45UE", "51.10329", "-0.22312", "Europe/London"),("6621547", "Gossops Green", "", "GB", "826", "", "ENG", "P6", "45UE", "51.11105", "-0.21728", "Europe/London"),("6621548", "Langley Green", "", "GB", "826", "", "ENG", "P6", "45UE", "51.12817", "-0.19835", "Europe/London"),("6639623", "Erskine", "", "GB", "826", "", "SCT", "W2", "", "55.9005", "-4.45028", "Europe/London"),("6640028", "Hale", "", "GB", "826", "", "ENG", "I2", "", "53.37831", "-2.33271", "Europe/London"),("6640068", "Westhill", "", "GB", "826", "", "SCT", "T6", "", "57.15263", "-2.27966", "Europe/London"),("6690565", "Crouch End", "", "GB", "826", "", "ENG", "GLA", "F3", "51.57971", "-0.12373", "Europe/London"),("6690581", "Belsize Park", "", "GB", "826", "", "ENG", "GLA", "C4", "51.54767", "-0.17228", "Europe/London"),("6690590", "Barnsbury", "", "GB", "826", "", "ENG", "GLA", "G3", "51.54067", "-0.11675", "Europe/London"),("6690592", "Amersham on the Hill", "", "GB", "826", "", "ENG", "B9", "11UC", "51.67468", "-0.60742", "Europe/London"),("6690602", "Battersea", "", "GB", "826", "", "ENG", "GLA", "P1", "51.47475", "-0.15547", "Europe/London"),("6690801", "Grange Hill", "", "GB", "826", "", "ENG", "E4", "22UH", "51.61185", "0.08612", "Europe/London"),("6690802", "Collier Row", "", "GB", "826", "", "ENG", "GLA", "F6", "51.59893", "0.166", "Europe/London"),("6690805", "Elm Park", "", "GB", "826", "", "ENG", "GLA", "F6", "51.5497", "0.20136", "Europe/London"),("6690808", "Chafford Hundred", "", "GB", "826", "", "ENG", "O3", "29UD", "51.4892", "0.2944", "Europe/London"),("6690812", "Chadwell St Mary", "", "GB", "826", "", "ENG", "O3", "29UG", "51.4814", "0.36343", "Europe/London"),("6690829", "Kingston upon Thames", "", "GB", "826", "", "ENG", "GLA", "G7", "51.41259", "-0.2974", "Europe/London"),("6690862", "South Croydon", "", "GB", "826", "", "ENG", "GLA", "C8", "51.36217", "-0.09421", "Europe/London"),("6690863", "Hornchurch", "", "GB", "826", "", "ENG", "GLA", "F6", "51.55685", "0.21664", "Europe/London"),("6690865", "Hainault", "", "GB", "826", "", "ENG", "GLA", "K8", "51.60836", "0.10716", "Europe/London"),("6690866", "Surbiton", "Сурбитон", "GB", "826", "", "ENG", "GLA", "G7", "51.39148", "-0.29825", "Europe/London"),("6690867", "Ewell", "", "GB", "826", "", "ENG", "N7", "43UC", "51.34948", "-0.2494", "Europe/London"),("6690868", "Harold Wood", "", "GB", "826", "", "ENG", "GLA", "F6", "51.59462", "0.23294", "Europe/London"),("6690869", "Chadwell Heath", "", "GB", "826", "", "ENG", "GLA", "A1", "51.57121", "0.13271", "Europe/London"),("6690870", "Becontree", "", "GB", "826", "", "ENG", "GLA", "A1", "51.5529", "0.129", "Europe/London"),("6690877", "Brixton", "Брикстон", "GB", "826", "", "ENG", "GLA", "H1", "51.46593", "-0.10652", "Europe/London"),("6690989", "Bethnal Green", "", "GB", "826", "", "ENG", "GLA", "O5", "51.52718", "-0.06109", "Europe/London"),("6691216", "Cheetham Hill", "", "GB", "826", "", "ENG", "I2", "", "53.49862", "-2.23846", "Europe/London"),("6691219", "Failsworth", "Фэйлзуорт", "GB", "826", "", "ENG", "I2", "", "53.50484", "-2.16568", "Europe/London"),("6691221", "Crumpsall", "", "GB", "826", "", "ENG", "I2", "", "53.51827", "-2.24447", "Europe/London"),("6691222", "Blackley", "", "GB", "826", "", "ENG", "I2", "", "53.51765", "-2.21443", "Europe/London"),("6691227", "Radcliffe", "", "GB", "826", "", "ENG", "C1", "", "53.56178", "-2.32455", "Europe/London"),("6691235", "Heywood", "", "GB", "826", "", "ENG", "I2", "", "53.59245", "-2.21941", "Europe/London"),("6691251", "Burnage", "", "GB", "826", "", "ENG", "I2", "", "53.43265", "-2.19967", "Europe/London"),("6691252", "Fallowfield", "", "GB", "826", "", "ENG", "I2", "", "53.43981", "-2.21572", "Europe/London"),("6691255", "Haughton Green", "", "GB", "826", "", "ENG", "O1", "00BS001", "53.44118", "-2.09827", "Europe/London"),("6691257", "Hulme", "", "GB", "826", "", "ENG", "I2", "", "53.46572", "-2.24885", "Europe/London"),("6691766", "Longsight", "", "GB", "826", "", "ENG", "I2", "", "53.45801", "-2.20104", "Europe/London"),("6691884", "Heavitree", "", "GB", "826", "", "ENG", "D4", "18UC", "50.72044", "-3.49646", "Europe/London"),("6691927", "Ferndown", "", "GB", "826", "", "ENG", "D6", "19UD", "50.80743", "-1.89975", "Europe/London"),("6691951", "Clayton-le-Woods", "", "GB", "826", "", "ENG", "H2", "30UE", "53.69689", "-2.66818", "Europe/London"),("6692041", "Portland", "", "GB", "826", "", "ENG", "D6", "19UJ", "50.56748", "-2.44472", "Europe/London"),("6692280", "Canary Wharf", "", "GB", "826", "", "ENG", "GLA", "O5", "51.50519", "-0.02085", "Europe/London"),("6692466", "Brixton Hill", "", "GB", "826", "", "ENG", "GLA", "H1", "51.45213", "-0.123", "Europe/London"),("6692918", "Featherstone", "", "GB", "826", "", "ENG", "M9", "41UF", "52.64483", "-2.09315", "Europe/London"),("6692920", "Calcot", "", "GB", "826", "", "ENG", "P4", "00MB063", "51.44058", "-1.05091", "Europe/London"),("6693001", "Benwell", "", "GB", "826", "", "ENG", "I7", "00CJ006", "54.97296", "-1.66926", "Europe/London"),("6693007", "Earl Shilton", "", "GB", "826", "", "ENG", "H5", "31UE", "52.57682", "-1.31536", "Europe/London"),("6693242", "Bordon", "", "GB", "826", "", "ENG", "F2", "24UC", "51.11357", "-0.86245", "Europe/London"),("6693245", "Knaphill", "", "GB", "826", "", "ENG", "N7", "43UM", "51.3201", "-0.61584", "Europe/London"),("6693470", "Lytham St Annes", "", "GB", "826", "", "ENG", "H2", "30UF", "53.7426", "-2.997", "Europe/London"),("6693668", "Larkfield", "", "GB", "826", "", "ENG", "G5", "29UP", "51.29456", "0.42615", "Europe/London"),("6693771", "Hadley Wood", "", "GB", "826", "", "ENG", "GLA", "E3", "51.66669", "-0.16981", "Europe/London"),("6693776", "Greenhill", "", "GB", "826", "", "ENG", "GLA", "F4", "51.58342", "-0.3386", "Europe/London"),("6693989", "Grappenhall", "", "GB", "826", "", "ENG", "P2", "00EU007", "53.37204", "-2.54675", "Europe/London"),("6694080", "Prenton", "", "GB", "826", "", "ENG", "Q1", "", "53.36762", "-3.05479", "Europe/London"),("6694830", "Eaglescliffe", "", "GB", "826", "", "ENG", "N3", "00EF004", "54.52521", "-1.35043", "Europe/London"),("6695247", "Chapel Allerton", "", "GB", "826", "", "ENG", "H3", "", "53.82901", "-1.53834", "Europe/London"),("6695976", "Newcastle", "", "GB", "826", "", "NIR", "N09000010", "", "54.21804", "-5.88979", "Europe/London"),("6696772", "Darras Hall", "", "GB", "826", "", "ENG", "J6", "00EM127", "55.0356", "-1.76425", "Europe/London"),("6698329", "Appleton Thorn", "", "GB", "826", "", "ENG", "P2", "00EU001", "53.35045", "-2.54488", "Europe/London"),("6698331", "Blacon", "", "GB", "826", "", "ENG", "Z8", "00EW110", "53.20832", "-2.9253", "Europe/London"),("6698373", "Chelmsley Wood", "", "GB", "826", "", "ENG", "M2", "00CT006", "52.4781", "-1.73813", "Europe/London"),("6940296", "Cowplain", "", "GB", "826", "", "ENG", "F2", "24UH", "50.89411", "-1.01824", "Europe/London"),("6940518", "Canford Heath", "", "GB", "826", "", "ENG", "K5", "19UD", "50.751", "-1.96862", "Europe/London"),("6941037", "High Barnet", "", "GB", "826", "", "ENG", "GLA", "A2", "51.65621", "-0.20768", "Europe/London"),("6941086", "Balsall Common", "", "GB", "826", "", "ENG", "M2", "00CT001", "52.39186", "-1.6504", "Europe/London"),("6947041", "Blackheath", "", "GB", "826", "", "ENG", "GLA", "H6", "51.4647", "0.0079", "Europe/London"),("6947168", "Kempston Hardwick", "", "GB", "826", "", "ENG", "Z5", "00KB038", "52.08956", "-0.49908", "Europe/London"),("6947756", "Mendip", "", "GB", "826", "", "ENG", "M3", "40UB", "51.2372", "-2.6266", "Europe/London"),("7290015", "Lower Earley", "", "GB", "826", "", "ENG", "Q2", "00MF004", "51.42708", "-0.91979", "Europe/London"),("7302130", "Bartley Green", "", "GB", "826", "", "ENG", "A7", "47UB", "52.43532", "-1.99707", "Europe/London"),("7302135", "Abbey Wood", "", "GB", "826", "", "ENG", "GLA", "E7", "51.48688", "0.10747", "Europe/London"),("8015341", "Shotts", "", "GB", "826", "", "SCT", "V8", "", "55.81951", "-3.79749", "Europe/London"),("8063096", "Earlsfield", "", "GB", "826", "", "ENG", "GLA", "P1", "51.4439", "-0.1854", "Europe/London"),("8128721", "Peacehaven", "", "GB", "826", "", "ENG", "E2", "21UF", "50.7927", "-0.00652", "Europe/London"),("8224216", "Letchworth Garden City", "", "GB", "826", "", "ENG", "F8", "26UF", "51.97938", "-0.22664", "Europe/London"),("8224780", "Cradley Heath", "", "GB", "826", "", "ENG", "L7", "", "52.47214", "-2.08212", "Europe/London"),("8224782", "Shirley", "", "GB", "826", "", "ENG", "M2", "", "52.41074", "-1.81952", "Europe/London"),("8224783", "Stanley", "", "GB", "826", "", "ENG", "D8", "00EJ110", "54.86796", "-1.69846", "Europe/London"),("8224784", "Stockton Heath", "", "GB", "826", "", "ENG", "P2", "00EU014", "53.37084", "-2.57406", "Europe/London"),("8260052", "Pontyclun", "", "GB", "826", "", "WLS", "Y9", "00PF022", "51.52162", "-3.39145", "Europe/London"),("8260056", "Pentre", "", "GB", "826", "", "WLS", "Y9", "00PF019", "51.65429", "-3.49133", "Europe/London"),("8260059", "Catterick Garrison", "", "GB", "826", "", "ENG", "J7", "36UE", "54.37748", "-1.72232", "Europe/London"),("8299614", "Rossendale", "", "GB", "826", "", "ENG", "H2", "30UM", "53.68456", "-2.2769", "Europe/London"),("8299615", "Thornton-Cleveleys", "", "GB", "826", "", "ENG", "H2", "30UQ", "53.87389", "-3.02244", "Europe/London"),("8299616", "Deeside", "", "GB", "826", "", "WLS", "Y1", "00NJ030", "53.20053", "-3.03841", "Europe/London"),("8299617", "High Peak", "", "GB", "826", "", "ENG", "D3", "17UH", "53.36797", "-1.84536", "Europe/London"),("8299619", "Hayling Island", "", "GB", "826", "", "ENG", "F2", "24UH", "50.7838", "-0.96869", "Europe/London"),("8299620", "Isle of Lewis", "", "GB", "826", "", "SCT", "W8", "", "58.21901", "-6.38803", "Europe/London"),("8299621", "Shetland", "", "GB", "826", "", "SCT", "W3", "", "60.15456", "-1.14899", "Europe/London"),("8299622", "Isle of Bute", "", "GB", "826", "", "SCT", "T8", "", "55.83663", "-5.05586", "Europe/London"),("8299623", "Orkney", "Оркнейские острова", "GB", "826", "", "SCT", "V9", "", "58.98465", "-2.95953", "Europe/London"),("8299836", "Isle of Arran", "", "GB", "826", "", "SCT", "V7", "", "55.58145", "-5.21233", "Europe/London"),("8315400", "Holloway", "", "GB", "826", "", "ENG", "GLA", "G3", "51.55237", "-0.12497", "Europe/London"),("8468720", "Water Eaton", "", "GB", "826", "", "ENG", "I6", "00MG039", "51.98697", "-0.72188", "Europe/London"),("8581595", "Harringay", "", "GB", "826", "", "ENG", "GLA", "F3", "51.5824", "-0.09956", "Europe/London"),("10793747", "Shortlands", "", "GB", "826", "", "ENG", "GLA", "B8", "51.39914", "0.0044", "Europe/London"),("11153048", "Ravenshead", "", "GB", "826", "", "ENG", "J9", "37UE", "53.0865", "-1.16026", "Europe/London"),("11239661", "Cockington", "", "GB", "826", "", "ENG", "O4", "", "50.46335", "-3.55691", "Europe/London"),("11281273", "Greasby", "", "GB", "826", "", "ENG", "Q1", "", "53.373", "-3.1233", "Europe/London"),("610824", "Zugdidi", "Зугдиди", "GE", "268", "", "71", "610823", "", "42.5088", "41.87088", "Asia/Tbilisi"),("610864", "Zestap’oni", "Зестафони", "GE", "268", "", "66", "", "", "42.11", "43.0525", "Asia/Tbilisi"),("611373", "Tsnori", "", "GE", "268", "", "00", "", "", "41.62088", "45.96943", "Asia/Tbilisi"),("611403", "Ts’khinvali", "Цхинвали", "GE", "268", "", "73", "", "", "42.22764", "43.96861", "Asia/Tbilisi"),("611551", "Tsalenjikha", "", "GE", "268", "", "71", "", "", "42.60444", "42.06825", "Asia/Tbilisi"),("611583", "Tqvarch'eli", "Ткуарчал", "GE", "268", "", "02", "", "", "42.84035", "41.68007", "Asia/Tbilisi"),("611584", "Tqibuli", "", "GE", "268", "", "00", "", "", "42.35121", "42.99874", "Asia/Tbilisi"),("611694", "Telavi", "Телави", "GE", "268", "", "67", "7667581", "", "41.91978", "45.47315", "Asia/Tbilisi"),("611717", "Tbilisi", "Тбилиси", "GE", "268", "", "51", "", "", "41.69411", "44.83368", "Asia/Tbilisi"),("611809", "Surami", "", "GE", "268", "", "28", "", "", "42.02431", "43.55556", "Asia/Tbilisi"),("611847", "Sokhumi", "Сухум", "GE", "268", "", "02", "", "", "43.00697", "40.9893", "Asia/Tbilisi"),("612012", "Naghvarevi", "", "GE", "268", "", "00", "", "", "41.35272", "44.76178", "Asia/Tbilisi"),("612053", "Senak’i", "Сенаки", "GE", "268", "", "71", "", "", "42.27042", "42.0675", "Asia/Tbilisi"),("612126", "Samtredia", "Самтредиа", "GE", "268", "", "66", "", "", "42.1537", "42.33517", "Asia/Tbilisi"),("612230", "Sagarejo", "", "GE", "268", "", "67", "", "", "41.73397", "45.33149", "Asia/Tbilisi"),("612287", "Rust’avi", "Рустави", "GE", "268", "", "68", "", "", "41.54949", "44.99323", "Asia/Tbilisi"),("612338", "Qvareli", "", "GE", "268", "", "67", "", "", "41.95493", "45.81716", "Asia/Tbilisi"),("612366", "P’ot’i", "Поти", "GE", "268", "", "71", "", "", "42.14616", "41.67197", "Asia/Tbilisi"),("612536", "Ozurgeti", "Озургети", "GE", "268", "", "65", "", "", "41.92442", "42.00682", "Asia/Tbilisi"),("612652", "Och’amch’ire", "Очамчира", "GE", "268", "", "02", "", "", "42.71232", "41.46863", "Asia/Tbilisi"),("612691", "Ninotsminda", "", "GE", "268", "", "72", "7667662", "", "41.26458", "43.59161", "Asia/Tbilisi"),("612890", "Mtskheta", "", "GE", "268", "", "69", "", "", "41.84514", "44.71875", "Asia/Tbilisi"),("613065", "Mart’vili", "", "GE", "268", "", "71", "", "", "42.41436", "42.37924", "Asia/Tbilisi"),("613074", "Marneuli", "Марнеули", "GE", "268", "", "68", "7667578", "", "41.47588", "44.80895", "Asia/Tbilisi"),("613226", "Lent’ekhi", "", "GE", "268", "", "70", "", "", "42.78893", "42.72226", "Asia/Tbilisi"),("613342", "Lagodekhi", "", "GE", "268", "", "67", "", "", "41.82681", "46.27667", "Asia/Tbilisi"),("613607", "Kutaisi", "Кутаиси", "GE", "268", "", "66", "", "", "42.26791", "42.69459", "Asia/Tbilisi"),("613762", "Kobuleti", "Кобулети", "GE", "268", "", "04", "", "", "41.82", "41.77528", "Asia/Tbilisi"),("613902", "Khoni", "", "GE", "268", "", "66", "", "", "42.3226", "42.42061", "Asia/Tbilisi"),("613918", "Khobi", "", "GE", "268", "", "71", "", "", "42.31558", "41.89871", "Asia/Tbilisi"),("613988", "Khashuri", "Хашури", "GE", "268", "", "73", "613987", "", "41.99414", "43.59994", "Asia/Tbilisi"),("614104", "Kaspi", "", "GE", "268", "", "73", "", "", "41.9252", "44.42568", "Asia/Tbilisi"),("614351", "Gurjaani", "", "GE", "268", "", "67", "7667580", "", "41.74292", "45.80111", "Asia/Tbilisi"),("614409", "Gudauta", "", "GE", "268", "", "02", "", "", "43.10547", "40.62067", "Asia/Tbilisi"),("614410", "Gudauri", "", "GE", "268", "", "00", "", "", "42.47797", "44.47616", "Asia/Tbilisi"),("614455", "Gori", "Гори", "GE", "268", "", "73", "", "", "41.98422", "44.11578", "Asia/Tbilisi"),("614575", "Gardabani", "", "GE", "268", "", "68", "7667577", "", "41.46054", "45.09283", "Asia/Tbilisi"),("614580", "Gantiadi", "", "GE", "268", "", "00", "", "", "43.38111", "40.07944", "Asia/Tbilisi"),("614613", "Gali", "", "GE", "268", "", "02", "", "", "42.62655", "41.73808", "Asia/Tbilisi"),("614622", "Gagra", "", "GE", "268", "", "02", "", "", "43.27858", "40.27124", "Asia/Tbilisi"),("614897", "Dioknisi", "", "GE", "268", "", "04", "", "", "41.62933", "42.39171", "Asia/Tbilisi"),("615297", "Chakvi", "", "GE", "268", "", "04", "", "", "41.72528", "41.73278", "Asia/Tbilisi"),("615403", "Borjomi", "", "GE", "268", "", "72", "", "", "41.85272", "43.41284", "Asia/Tbilisi"),("615419", "Bolnisi", "", "GE", "268", "", "68", "615418", "", "41.44794", "44.53838", "Asia/Tbilisi"),("615460", "Bich’vinta", "", "GE", "268", "", "02", "", "", "43.16197", "40.34102", "Asia/Tbilisi"),("615532", "Batumi", "Батуми", "GE", "268", "", "04", "", "", "41.64228", "41.63392", "Asia/Tbilisi"),("615844", "Akhmet’a", "", "GE", "268", "", "67", "", "", "42.03111", "45.2075", "Asia/Tbilisi"),("615860", "Akhaltsikhe", "Ахалцихе", "GE", "268", "", "72", "", "", "41.63901", "42.98262", "Asia/Tbilisi"),("615893", "Akhalk’alak’i", "", "GE", "268", "", "06", "", "", "41.40514", "43.48629", "Asia/Tbilisi"),("615912", "Stantsiya Novyy Afon", "Новый Афон", "GE", "268", "GE", "02", "", "", "43.08056", "40.83833", "Asia/Tbilisi"),("615943", "Agara", "", "GE", "268", "", "25", "", "", "42.03761", "43.82382", "Asia/Tbilisi"),("616022", "Abasha", "", "GE", "268", "", "71", "", "", "42.20959", "42.22111", "Asia/Tbilisi"),("824288", "Tsqaltubo", "Цхалтубо", "GE", "268", "", "66", "", "", "42.34129", "42.5976", "Asia/Tbilisi"),("3419842", "Sisimiut", "", "GL", "304", "", "06", "", "", "66.93946", "-53.6735", "America/Godthab"),("3420846", "Qaqortoq", "", "GL", "304", "", "04", "", "", "60.71667", "-46.03333", "America/Godthab"),("3421319", "Nuuk", "Нуук", "GL", "304", "", "07", "", "", "64.18347", "-51.72157", "America/Godthab"),("3423146", "Ilulissat", "", "GL", "304", "", "05", "", "", "69.21667", "-51.1", "America/Godthab"),("2414055", "Youkounkoun", "", "GN", "324", "", "B", "18", "", "12.5311", "-13.1224", "Africa/Conakry"),("2414545", "Tougué", "", "GN", "324", "", "L", "28", "", "11.44503", "-11.66422", "Africa/Conakry"),("2414616", "Tondon", "", "GN", "324", "", "D", "31", "", "10.36667", "-13.35", "Africa/Conakry"),("2414659", "Tokonou", "", "GN", "324", "", "K", "32", "", "9.65", "-9.78333", "Africa/Conakry"),("2414926", "Télimélé", "", "GN", "324", "", "D", "27", "", "10.9", "-13.03333", "Africa/Conakry"),("2415703", "Siguiri", "Сигири", "GN", "324", "", "K", "39", "", "11.42282", "-9.16852", "Africa/Conakry"),("2416061", "Sanguéya", "", "GN", "324", "", "B", "03", "", "10.7", "-14.36667", "Africa/Conakry"),("2416443", "Pita", "", "GN", "324", "", "M", "25", "", "11.05915", "-12.39498", "Africa/Conakry"),("2416969", "Nzérékoré", "Нзерекоре", "GN", "324", "", "N", "38", "", "7.75624", "-8.8179", "Africa/Conakry"),("2417795", "Mandiana", "", "GN", "324", "", "K", "37", "", "10.62577", "-8.69413", "Africa/Conakry"),("2417833", "Mamou", "", "GN", "324", "", "M", "23", "", "10.37546", "-12.09148", "Africa/Conakry"),("2417886", "Mali", "", "GN", "324", "", "L", "22", "", "12.079", "-12.2982", "Africa/Conakry"),("2417988", "Macenta", "Масента", "GN", "324", "", "N", "21", "", "8.54351", "-9.47099", "Africa/Conakry"),("2418362", "Labé", "Лаба", "GN", "324", "", "L", "34", "", "11.31823", "-12.28332", "Africa/Conakry"),("2418437", "Kouroussa", "", "GN", "324", "", "K", "19", "", "10.65", "-9.88333", "Africa/Conakry"),("2418596", "Koundara", "", "GN", "324", "", "B", "18", "", "12.48333", "-13.3", "Africa/Conakry"),("2418764", "Koubia", "", "GN", "324", "", "L", "33", "", "11.58632", "-11.89485", "Africa/Conakry"),("2419472", "Kissidougou", "Кисидугу", "GN", "324", "", "F", "17", "", "9.1848", "-10.09987", "Africa/Conakry"),("2419533", "Kindia", "Киндиа", "GN", "324", "", "D", "16", "", "10.05692", "-12.86576", "Africa/Conakry"),("2419538", "Kimbo", "", "GN", "324", "", "B", "11", "", "10.4", "-13.55", "Africa/Conakry"),("2419622", "Kérouané", "", "GN", "324", "", "K", "15", "", "9.26667", "-9.01667", "Africa/Conakry"),("2419992", "Kankan", "", "GN", "324", "", "K", "32", "", "10.38542", "-9.30568", "Africa/Conakry"),("2420056", "Kamsar", "Комсар", "GN", "324", "GN", "B", "03", "", "10.66667", "-14.6", "Africa/Conakry"),("2420562", "Gueckedou", "", "GN", "324", "GN", "N", "13", "", "8.56744", "-10.1336", "Africa/Conakry"),("2420826", "Gaoual", "", "GN", "324", "", "B", "12", "", "11.75", "-13.2", "Africa/Conakry"),("2420884", "Fria", "Фриа", "GN", "324", "", "B", "11", "", "10.36676", "-13.58253", "Africa/Conakry"),("2420985", "Forécariah", "", "GN", "324", "", "D", "10", "", "9.43056", "-13.08806", "Africa/Conakry"),("2421273", "Faranah", "", "GN", "324", "", "F", "09", "", "10.04036", "-10.74343", "Africa/Conakry"),("2421535", "Dubréka", "", "GN", "324", "", "D", "31", "", "9.79111", "-13.52333", "Africa/Conakry"),("2421903", "Dinguiraye", "", "GN", "324", "", "F", "07", "", "11.29062", "-10.7121", "Africa/Conakry"),("2422383", "Dalaba", "", "GN", "324", "", "M", "06", "", "10.69249", "-12.24967", "Africa/Conakry"),("2422442", "Dabola", "", "GN", "324", "", "F", "05", "", "10.7433", "-11.10778", "Africa/Conakry"),("2422457", "Coyah", "", "GN", "324", "", "D", "30", "", "9.70643", "-13.38465", "Africa/Conakry"),("2422465", "Conakry", "Конакри", "GN", "324", "", "04", "", "", "9.53795", "-13.67729", "Africa/Conakry"),("2422488", "Camayenne", "", "GN", "324", "", "04", "", "", "9.535", "-13.68778", "Africa/Conakry"),("2422924", "Boké", "", "GN", "324", "", "B", "03", "", "10.93217", "-14.29055", "Africa/Conakry"),("2423126", "Beyla", "", "GN", "324", "", "N", "01", "", "8.69011", "-8.64869", "Africa/Conakry"),("2306774", "San Antonio de Palé", "", "GQ", "226", "", "03", "", "", "-1.4068", "5.63178", "Africa/Malabo"),("2306824", "Rebola", "", "GQ", "226", "", "04", "", "", "3.71667", "8.83333", "Africa/Malabo"),("2307795", "Mongomo", "", "GQ", "226", "", "09", "", "", "1.62742", "11.31346", "Africa/Malabo"),("2307970", "Mikomeseng", "", "GQ", "226", "", "07", "", "", "2.13609", "10.61322", "Africa/Malabo"),("2308994", "Evinayong", "", "GQ", "226", "", "06", "", "", "1.43677", "10.55124", "Africa/Malabo"),("2309332", "Ebebiyin", "Эбебьин", "GQ", "226", "", "07", "", "", "2.15106", "11.33528", "Africa/Malabo"),("2309527", "Malabo", "Малабо", "GQ", "226", "", "04", "", "", "3.75", "8.78333", "Africa/Malabo"),("2309528", "Luba", "", "GQ", "226", "", "05", "", "", "3.45683", "8.55465", "Africa/Malabo"),("2310046", "Bata", "Бата", "GQ", "226", "", "08", "", "", "1.86391", "9.76582", "Africa/Malabo"),("2310309", "Añisoc", "", "GQ", "226", "", "09", "", "", "1.8658", "10.76892", "Africa/Malabo"),("2310547", "Aconibe", "", "GQ", "226", "", "09", "", "", "1.29683", "10.93691", "Africa/Malabo"),("251280", "Zakynthos", "", "GR", "300", "", "ESYE22", "28", "9116", "37.78022", "20.89555", "Europe/Athens"),("251283", "Zacháro", "", "GR", "300", "", "ESYE23", "39", "9138", "37.48333", "21.65", "Europe/Athens"),("251332", "Giánnouli", "", "GR", "300", "", "ESYE14", "21", "9100", "39.66717", "22.39597", "Europe/Athens"),("251525", "Xylókastro", "", "GR", "300", "", "ESYE25", "37", "9246", "38.07762", "22.63166", "Europe/Athens"),("251606", "Vrontádos", "", "GR", "300", "", "ESYE41", "50", "9266", "38.40876", "26.12948", "Europe/Athens"),("251780", "Voúla", "Вуле", "GR", "300", "", "ESYE31", "445406", "9216", "37.84221", "23.77651", "Europe/Athens"),("251833", "Volos", "", "GR", "300", "", "ESYE14", "24", "9105", "39.36103", "22.94248", "Europe/Athens"),("251948", "Výronas", "", "GR", "300", "", "ESYE31", "445408", "9187", "37.96105", "23.753", "Europe/Athens"),("252190", "Vasilikón", "", "GR", "300", "", "ESYE24", "34", "9155", "38.42586", "23.67189", "Europe/Athens"),("252270", "Vári", "", "GR", "300", "", "ESYE31", "445406", "9216", "37.8332", "23.80311", "Europe/Athens"),("252601", "Trípoli", "Триполи", "GR", "300", "", "ESYE25", "41", "9241", "37.50889", "22.37944", "Europe/Athens"),("252664", "Tríkala", "Трикала", "GR", "300", "", "ESYE14", "22", "9114", "39.55493", "21.76837", "Europe/Athens"),("252685", "Ialysós", "", "GR", "300", "", "ESYE42", "47", "9296", "36.41352", "28.15516", "Europe/Athens"),("252848", "Týrnavos", "", "GR", "300", "", "ESYE14", "21", "9102", "39.73778", "22.28917", "Europe/Athens"),("252862", "Tympáki", "", "GR", "300", "", "ESYE43", "45", "9308", "35.07286", "24.76851", "Europe/Athens"),("252910", "Thívai", "", "GR", "300", "", "ESYE24", "33", "9144", "38.325", "23.31889", "Europe/Athens"),("253025", "Távros", "", "GR", "300", "", "ESYE31", "445408", "9199", "37.97064", "23.69043", "Europe/Athens"),("253376", "Spáta", "", "GR", "300", "", "ESYE31", "445406", "9226", "37.96163", "23.91514", "Europe/Athens"),("253394", "Spárti", "", "GR", "300", "", "ESYE25", "42", "9252", "37.07446", "22.43009", "Europe/Athens"),("253456", "Soúda", "", "GR", "300", "", "ESYE43", "43", "9325", "35.48717", "24.07344", "Europe/Athens"),("253643", "Skiáthos", "", "GR", "300", "", "ESYE14", "24", "9110", "39.16227", "23.49089", "Europe/Athens"),("253759", "Sitia", "", "GR", "300", "", "ESYE43", "46", "9313", "35.20783", "26.10467", "Europe/Athens"),("254144", "Salamína", "Саламина", "GR", "300", "", "ESYE31", "406101", "9211", "37.96427", "23.49649", "Europe/Athens"),("254352", "Rethymno", "Ретимнон", "GR", "300", "", "ESYE43", "44", "9318", "35.36555", "24.48232", "Europe/Athens"),("254425", "Rafína", "", "GR", "300", "", "ESYE31", "445406", "9224", "38.01812", "24.00599", "Europe/Athens"),("254505", "Psychikó", "", "GR", "300", "", "ESYE31", "445408", "9177", "38.01324", "23.77223", "Europe/Athens"),("254546", "Psachná", "", "GR", "300", "", "ESYE24", "34", "9148", "38.58333", "23.63333", "Europe/Athens"),("254698", "Préveza", "", "GR", "300", "", "ESYE21", "19", "9090", "38.95617", "20.7505", "Europe/Athens"),("255229", "Pýrgos", "Пиргос", "GR", "300", "", "ESYE23", "39", "9141", "37.67513", "21.44102", "Europe/Athens"),("255274", "Piraeus", "Пирей", "GR", "300", "", "ESYE31", "35", "", "37.94745", "23.63708", "Europe/Athens"),("255377", "Petroúpolis", "Петроуполис", "GR", "300", "", "ESYE31", "445408", "9184", "38.04187", "23.68494", "Europe/Athens"),("255524", "Peristéri", "Перистерион", "GR", "300", "", "ESYE31", "445408", "9183", "38.01539", "23.69187", "Europe/Athens"),("255588", "Pérama", "Перама", "GR", "300", "", "ESYE31", "406101", "9206", "37.96775", "23.5721", "Europe/Athens"),("255683", "Pátra", "", "GR", "300", "", "ESYE23", "38", "9134", "38.24444", "21.73444", "Europe/Athens"),("255721", "Páros", "", "GR", "300", "", "ESYE42", "49", "9294", "37.08333", "25.15", "Europe/Athens"),("255777", "Paralía", "", "GR", "300", "", "ESYE23", "38", "9134", "38.19833", "21.70263", "Europe/Athens"),("255971", "Pallíni", "", "GR", "300", "", "ESYE31", "445406", "9223", "38.00514", "23.88302", "Europe/Athens"),("256047", "Palamás", "", "GR", "300", "", "ESYE14", "23", "9095", "39.46667", "22.08333", "Europe/Athens"),("256075", "Palaió Fáliro", "", "GR", "300", "", "ESYE31", "445408", "9201", "37.92812", "23.70105", "Europe/Athens"),("256197", "Paianía", "", "GR", "300", "", "ESYE31", "445406", "9222", "37.95527", "23.85443", "Europe/Athens"),("256223", "Ovriá", "", "GR", "300", "", "ESYE23", "38", "9134", "38.18866", "21.72903", "Europe/Athens"),("256268", "Orchomenós", "", "GR", "300", "", "ESYE24", "33", "9146", "38.4929", "22.97962", "Europe/Athens"),("256342", "Papágou", "", "GR", "300", "", "ESYE31", "445408", "9175", "37.98642", "23.79347", "Europe/Athens"),("256429", "Níkaia", "", "GR", "300", "", "ESYE31", "406101", "9204", "37.96667", "23.65", "Europe/Athens"),("256492", "Néon Karlovásion", "", "GR", "300", "", "ESYE41", "48", "9264", "37.79209", "26.7049", "Europe/Athens"),("256575", "Néa Smýrni", "", "GR", "300", "", "ESYE31", "445408", "9200", "37.94504", "23.71416", "Europe/Athens"),("256592", "Néa Péramos", "", "GR", "300", "", "ESYE31", "445407", "9231", "38.00647", "23.42348", "Europe/Athens"),("256598", "Néa Mákri", "", "GR", "300", "", "ESYE31", "445406", "9220", "38.08733", "23.97642", "Europe/Athens"),("256601", "Ílion", "", "GR", "300", "", "ESYE31", "445408", "9182", "38.03333", "23.7", "Europe/Athens"),("256614", "Néa Ionía", "", "GR", "300", "", "ESYE31", "445408", "9174", "38.0357", "23.75733", "Europe/Athens"),("256621", "Néa Filadélfeia", "", "GR", "300", "", "ESYE31", "445408", "9193", "38.03491", "23.73811", "Europe/Athens"),("256622", "Néa Erythraía", "", "GR", "300", "", "ESYE31", "445408", "9171", "38.0927", "23.82223", "Europe/Athens"),("256626", "Néa Artáki", "", "GR", "300", "", "ESYE24", "34", "9155", "38.52027", "23.63296", "Europe/Athens"),("256627", "Néa Anchiálos", "", "GR", "300", "", "ESYE14", "24", "9105", "39.28015", "22.81819", "Europe/Athens"),("256632", "Náxos", "", "GR", "300", "", "ESYE42", "49", "9292", "37.10556", "25.37639", "Europe/Athens"),("256637", "Náfplio", "", "GR", "300", "", "ESYE25", "36", "9236", "37.56863", "22.80691", "Europe/Athens"),("256639", "Náfpaktos", "", "GR", "300", "", "ESYE23", "31", "9128", "38.39167", "21.8275", "Europe/Athens"),("256696", "Mourniés", "", "GR", "300", "", "ESYE43", "43", "9325", "35.48228", "24.01253", "Europe/Athens"),("256750", "Moskháton", "", "GR", "300", "", "ESYE31", "445408", "9199", "37.94789", "23.6788", "Europe/Athens"),("256842", "Moíres", "", "GR", "300", "", "ESYE43", "45", "9308", "35.05143", "24.8733", "Europe/Athens"),("256866", "Mytilene", "Митилини", "GR", "300", "", "ESYE41", "51", "9261", "39.10772", "26.55529", "Europe/Athens"),("256930", "Mýrina", "", "GR", "300", "", "ESYE41", "51", "9263", "39.87483", "25.06359", "Europe/Athens"),("257152", "Messíni", "", "GR", "300", "", "ESYE25", "40", "9255", "37.05111", "22.00778", "Europe/Athens"),("257186", "Mesolóngi", "", "GR", "300", "", "ESYE23", "31", "9127", "38.37138", "21.43151", "Europe/Athens"),("257302", "Melíssia", "Мелиссия", "GR", "300", "", "ESYE31", "445408", "9176", "38.05", "23.83333", "Europe/Athens"),("257365", "Mégara", "Мегара", "GR", "300", "", "ESYE31", "445407", "9231", "37.99471", "23.34324", "Europe/Athens"),("257395", "Megalópoli", "", "GR", "300", "", "ESYE25", "41", "9239", "37.40111", "22.14222", "Europe/Athens"),("257671", "Markópoulo", "", "GR", "300", "", "ESYE31", "445406", "9221", "37.88333", "23.93333", "Europe/Athens"),("257717", "Marathónas", "", "GR", "300", "", "ESYE31", "445406", "9220", "38.15317", "23.96278", "Europe/Athens"),("257811", "Mándra", "", "GR", "300", "", "ESYE31", "445407", "9230", "38.06667", "23.5", "Europe/Athens"),("258038", "Artémida", "", "GR", "300", "", "ESYE31", "445406", "9226", "37.96727", "23.99684", "Europe/Athens"),("258066", "Loutráki", "", "GR", "300", "", "ESYE25", "37", "9244", "37.9783", "22.97781", "Europe/Athens"),("258314", "Limín Mesoyaías", "", "GR", "300", "", "ESYE31", "445406", "9221", "37.89108", "24.00307", "Europe/Athens"),("258332", "Lykóvrysi", "", "GR", "300", "", "ESYE31", "445408", "9172", "38.06933", "23.78223", "Europe/Athens"),("258438", "Lefkáda", "", "GR", "300", "", "ESYE22", "26", "9121", "38.83036", "20.70442", "Europe/Athens"),("258463", "Livadeiá", "Левадия", "GR", "300", "", "ESYE24", "33", "9145", "38.43616", "22.87665", "Europe/Athens"),("258508", "Leondárion", "", "GR", "300", "", "ESYE31", "445406", "9223", "37.987", "23.85518", "Europe/Athens"),("258543", "Lávrio", "", "GR", "300", "", "ESYE31", "445406", "9219", "37.71445", "24.05647", "Europe/Athens"),("258576", "Lárisa", "Лариса", "GR", "300", "", "ESYE14", "21", "9100", "39.63689", "22.41761", "Europe/Athens"),("258620", "Lamía", "Ламия", "GR", "300", "", "ESYE24", "29", "9160", "38.9", "22.43333", "Europe/Athens"),("258793", "Kryonéri", "", "GR", "300", "", "ESYE31", "445406", "9217", "38.13712", "23.83055", "Europe/Athens"),("259128", "Metamórfosi", "", "GR", "300", "", "ESYE31", "445408", "9173", "38.06576", "23.76356", "Europe/Athens"),("259245", "Kos", "Кос", "GR", "300", "", "ESYE42", "47", "9284", "36.89333", "27.28889", "Europe/Athens"),("259251", "Koropí", "", "GR", "300", "", "ESYE31", "445406", "9218", "37.89886", "23.87181", "Europe/Athens"),("259289", "Kórinthos", "Коринф", "GR", "300", "", "ESYE25", "37", "9243", "37.94007", "22.9513", "Europe/Athens"),("259782", "Kyparissía", "", "GR", "300", "", "ESYE25", "40", "9258", "37.25111", "21.67361", "Europe/Athens"),("259824", "Kifisiá", "", "GR", "300", "", "ESYE31", "445408", "9171", "38.07438", "23.81106", "Europe/Athens"),("259830", "Kiáto", "", "GR", "300", "", "ESYE25", "37", "9247", "38.01321", "22.74839", "Europe/Athens"),("259949", "Cholargós", "", "GR", "300", "", "ESYE31", "445408", "9175", "38", "23.8", "Europe/Athens"),("259973", "Chios", "Хиос", "GR", "300", "", "ESYE41", "50", "9266", "38.36778", "26.13583", "Europe/Athens"),("260114", "Chaniá", "Ханья", "GR", "300", "", "ESYE43", "43", "9325", "35.51124", "24.02921", "Europe/Athens"),("260133", "Chalkída", "Халкида", "GR", "300", "", "ESYE24", "34", "9155", "38.46354", "23.60284", "Europe/Athens"),("260172", "Khalándrion", "", "GR", "300", "", "ESYE31", "445408", "9178", "38.02369", "23.80068", "Europe/Athens"),("260183", "Chaïdári", "", "GR", "300", "", "ESYE31", "445408", "9185", "38.01135", "23.66597", "Europe/Athens"),("260204", "Keratsíni", "", "GR", "300", "", "ESYE31", "406101", "9202", "37.9625", "23.61972", "Europe/Athens"),("260210", "Keratéa", "", "GR", "300", "", "ESYE31", "445406", "9219", "37.80585", "23.9774", "Europe/Athens"),("260644", "Káto Achaḯa", "", "GR", "300", "", "ESYE23", "38", "9131", "38.15", "21.55", "Europe/Athens"),("260891", "Karpenísi", "", "GR", "300", "", "ESYE24", "30", "9157", "38.91218", "21.79836", "Europe/Athens"),("260935", "Kárystos", "", "GR", "300", "", "ESYE24", "34", "9151", "38.01333", "24.41611", "Europe/Athens"),("260989", "Kardítsa", "Кардица", "GR", "300", "", "ESYE14", "23", "9092", "39.36485", "21.92191", "Europe/Athens"),("261249", "Kamaterón", "", "GR", "300", "", "ESYE31", "445408", "9180", "38.05586", "23.70515", "Europe/Athens"),("261414", "Kallithéa", "Каллифея", "GR", "300", "", "ESYE31", "445408", "9198", "37.95", "23.7", "Europe/Athens"),("261445", "Kalývia Thorikoú", "", "GR", "300", "", "ESYE31", "445406", "9225", "37.83894", "23.92505", "Europe/Athens"),("261507", "Kálymnos", "", "GR", "300", "", "ESYE42", "47", "9276", "36.95447", "26.9769", "Europe/Athens"),("261601", "Kalampáka", "", "GR", "300", "", "ESYE14", "22", "9112", "39.70444", "21.62694", "Europe/Athens"),("261604", "Kalamata", "Каламата", "GR", "300", "", "ESYE25", "40", "9254", "37.03913", "22.11265", "Europe/Athens"),("261614", "Álimos", "", "GR", "300", "", "ESYE31", "445408", "9195", "37.91033", "23.72361", "Europe/Athens"),("261678", "Kaisarianí", "Кесариани", "GR", "300", "", "ESYE31", "445408", "9192", "37.9634", "23.76523", "Europe/Athens"),("261743", "Irákleio", "", "GR", "300", "", "ESYE31", "445408", "9173", "38.05282", "23.76523", "Europe/Athens"),("261745", "Irákleion", "Ираклион", "GR", "300", "", "ESYE43", "45", "9305", "35.32787", "25.14341", "Europe/Athens"),("261779", "Ioánnina", "", "GR", "300", "", "ESYE21", "17", "9084", "39.66486", "20.85189", "Europe/Athens"),("261807", "Igoumenítsa", "", "GR", "300", "", "ESYE21", "18", "9077", "39.50342", "20.26728", "Europe/Athens"),("261814", "Ierápetra", "", "GR", "300", "", "ESYE43", "46", "9311", "35.01186", "25.74234", "Europe/Athens"),("262036", "Glyfáda", "", "GR", "300", "", "ESYE31", "445408", "9196", "37.86289", "23.75802", "Europe/Athens"),("262067", "Gázi", "", "GR", "300", "", "ESYE43", "45", "9306", "35.32531", "25.06694", "Europe/Athens"),("262098", "Gastoúni", "", "GR", "300", "", "ESYE23", "39", "9140", "37.85", "21.25", "Europe/Athens"),("262104", "Gargaliánoi", "", "GR", "300", "", "ESYE25", "40", "9258", "37.06518", "21.63809", "Europe/Athens"),("262135", "Galátsi", "", "GR", "300", "", "ESYE31", "445408", "9188", "38.01667", "23.75", "Europe/Athens"),("262398", "Filothéi", "", "GR", "300", "", "ESYE31", "445408", "9168", "38.02524", "23.78257", "Europe/Athens"),("262418", "Filiatrá", "", "GR", "300", "", "ESYE25", "40", "9258", "37.15637", "21.58532", "Europe/Athens"),("262462", "Fársala", "", "GR", "300", "", "ESYE14", "21", "9103", "39.29472", "22.38472", "Europe/Athens"),("262603", "Ermoúpolis", "", "GR", "300", "", "ESYE42", "49", "", "37.44227", "24.94248", "Europe/Athens"),("262719", "Ellinikó", "", "GR", "300", "", "ESYE31", "445408", "9197", "37.89013", "23.74406", "Europe/Athens"),("262752", "Elefsína", "", "GR", "300", "", "ESYE31", "445407", "9229", "38.04135", "23.54295", "Europe/Athens"),("262784", "Elassóna", "", "GR", "300", "", "ESYE14", "21", "9098", "39.89472", "22.18861", "Europe/Athens"),("262833", "Ekáli", "", "GR", "300", "", "ESYE31", "445408", "9171", "38.11035", "23.83505", "Europe/Athens"),("262869", "Dhrosiá", "", "GR", "300", "", "ESYE24", "34", "9155", "38.48413", "23.54774", "Europe/Athens"),("262871", "Drosiá", "", "GR", "300", "", "ESYE31", "445406", "9217", "38.11977", "23.86428", "Europe/Athens"),("263064", "Diónysos", "", "GR", "300", "", "ESYE31", "445406", "9217", "38.10458", "23.87938", "Europe/Athens"),("263312", "Dhafní", "", "GR", "300", "", "ESYE31", "445408", "9189", "37.95002", "23.73437", "Europe/Athens"),("263725", "Ágios Stéfanos", "", "GR", "300", "", "ESYE31", "445406", "9217", "38.14657", "23.85608", "Europe/Athens"),("263824", "Ágios Nikólaos", "", "GR", "300", "", "ESYE43", "46", "9310", "35.19106", "25.71524", "Europe/Athens"),("263854", "Áyios Konstandínos", "", "GR", "300", "", "ESYE23", "31", "9123", "38.63337", "21.3995", "Europe/Athens"),("263986", "Agios Dimitrios", "", "GR", "300", "", "ESYE31", "445408", "9194", "37.93333", "23.73333", "Europe/Athens"),("264111", "Agía Varvára", "", "GR", "300", "", "ESYE31", "445408", "9179", "37.98938", "23.66011", "Europe/Athens"),("264194", "Agía Paraskeví", "", "GR", "300", "", "ESYE31", "445408", "9167", "38.01667", "23.83333", "Europe/Athens"),("264310", "Avlónas", "", "GR", "300", "", "ESYE31", "445406", "9227", "38.25149", "23.69554", "Europe/Athens"),("264371", "Athens", "Афины", "GR", "300", "", "ESYE31", "445408", "9186", "37.97945", "23.71622", "Europe/Athens"),("264445", "Asprópyrgos", "", "GR", "300", "", "ESYE31", "445407", "9228", "38.06134", "23.58971", "Europe/Athens"),("264516", "Argyroúpoli", "", "GR", "300", "", "ESYE31", "445408", "9197", "37.90594", "23.75035", "Europe/Athens"),("264559", "Árta", "", "GR", "300", "", "ESYE21", "20", "9073", "39.16014", "20.98561", "Europe/Athens"),("264668", "Argostólion", "", "GR", "300", "", "ESYE22", "27", "9120", "38.18109", "20.48903", "Europe/Athens"),("264670", "Árgos", "Аргос", "GR", "300", "", "ESYE25", "36", "9233", "37.63333", "22.73333", "Europe/Athens"),("264888", "Áno Liósia", "", "GR", "300", "", "ESYE31", "445407", "9232", "38.08333", "23.7", "Europe/Athens"),("264929", "Anoixi", "", "GR", "300", "", "ESYE31", "445406", "9217", "38.13267", "23.85874", "Europe/Athens"),("265100", "Anávyssos", "", "GR", "300", "", "ESYE31", "445406", "9225", "37.73414", "23.94389", "Europe/Athens"),("265107", "Anatolí", "", "GR", "300", "", "ESYE21", "17", "9084", "39.63531", "20.86578", "Europe/Athens"),("265187", "Ámfissa", "", "GR", "300", "", "ESYE24", "32", "9165", "38.52813", "22.37713", "Europe/Athens"),("265206", "Ampelóna", "", "GR", "300", "", "ESYE14", "21", "9102", "39.74481", "22.36575", "Europe/Athens"),("265243", "Maroúsi", "", "GR", "300", "", "ESYE31", "445408", "9168", "38.05", "23.8", "Europe/Athens"),("265252", "Amaliáda", "", "GR", "300", "", "ESYE23", "39", "9139", "37.79842", "21.35068", "Europe/Athens"),("265292", "Almyrós", "", "GR", "300", "", "ESYE14", "24", "9104", "39.18222", "22.75944", "Europe/Athens"),("265309", "Alivéri", "", "GR", "300", "", "ESYE24", "34", "9152", "38.41667", "24.03333", "Europe/Athens"),("265488", "Acharnés", "", "GR", "300", "", "ESYE31", "445406", "9215", "38.08333", "23.73333", "Europe/Athens"),("265500", "Aígio", "Эйо", "GR", "300", "", "ESYE23", "38", "9130", "38.24861", "22.08194", "Europe/Athens"),("265502", "Aegina", "", "GR", "300", "", "ESYE31", "406101", "9208", "37.74667", "23.4275", "Europe/Athens"),("265533", "Aigáleo", "", "GR", "300", "", "ESYE31", "445408", "9181", "37.98333", "23.68333", "Europe/Athens"),("265560", "Agrínio", "Агринион", "GR", "300", "", "ESYE23", "31", "9123", "38.62139", "21.40778", "Europe/Athens"),("265601", "Agriá", "", "GR", "300", "", "ESYE14", "24", "9105", "39.34078", "23.01258", "Europe/Athens"),("400666", "Ródos", "Родос", "GR", "300", "", "ESYE42", "47", "9296", "36.43556", "28.22199", "Europe/Athens"),("408628", "Néa Alikarnassós", "", "GR", "300", "", "ESYE43", "45", "9305", "35.33977", "25.15895", "Europe/Athens"),("408685", "Afántou", "", "GR", "300", "", "ESYE42", "47", "9296", "36.29354", "28.16225", "Europe/Athens"),("408686", "Archángelos", "", "GR", "300", "", "ESYE42", "47", "9296", "36.21492", "28.11487", "Europe/Athens"),("733776", "Giannitsá", "Яница", "GR", "300", "", "ESYE12", "07", "9044", "40.79194", "22.4075", "Europe/Athens"),("733840", "Xánthi", "Ксанти", "GR", "300", "", "ESYE11", "03", "9017", "41.13488", "24.888", "Europe/Athens"),("733905", "Véroia", "Верия", "GR", "300", "", "ESYE12", "12", "9024", "40.52437", "22.20242", "Europe/Athens"),("734014", "Trílofos", "", "GR", "300", "", "ESYE12", "13", "9030", "40.46898", "22.9718", "Europe/Athens"),("734077", "Thessaloníki", "Салоники", "GR", "300", "", "ESYE12", "13", "9031", "40.64361", "22.93086", "Europe/Athens"),("734080", "Thérmi", "", "GR", "300", "", "ESYE12", "13", "9030", "40.54712", "23.01967", "Europe/Athens"),("734284", "Síndos", "", "GR", "300", "", "ESYE12", "13", "9028", "40.67045", "22.80545", "Europe/Athens"),("734301", "Sykiés", "", "GR", "300", "", "ESYE12", "13", "9035", "40.64944", "22.95083", "Europe/Athens"),("734310", "Sidirókastro", "", "GR", "300", "", "ESYE12", "05", "9055", "41.23499", "23.38899", "Europe/Athens"),("734315", "Siátista", "", "GR", "300", "", "ESYE13", "11", "9066", "40.26194", "21.54417", "Europe/Athens"),("734330", "Sérres", "", "GR", "300", "", "ESYE12", "05", "9054", "41.08499", "23.54757", "Europe/Athens"),("734426", "Ptolemaḯda", "", "GR", "300", "", "ESYE13", "11", "9067", "40.51472", "21.67861", "Europe/Athens"),("734517", "Polýgyros", "", "GR", "300", "", "ESYE12", "15", "9059", "40.37704", "23.44135", "Europe/Athens"),("734538", "Políchni", "Полихни", "GR", "300", "", "ESYE12", "13", "9036", "40.66671", "22.94881", "Europe/Athens"),("734540", "Polýkastro", "", "GR", "300", "", "ESYE12", "06", "9041", "40.99444", "22.56909", "Europe/Athens"),("734564", "Plagiári", "", "GR", "300", "", "ESYE12", "13", "9030", "40.47276", "22.9579", "Europe/Athens"),("734622", "Chalástra", "", "GR", "300", "", "ESYE12", "13", "9028", "40.62643", "22.73291", "Europe/Athens"),("734643", "Pylaía", "Пилеа", "GR", "300", "", "ESYE12", "13", "9037", "40.59918", "22.98613", "Europe/Athens"),("734712", "Peraía", "", "GR", "300", "", "ESYE12", "13", "9029", "40.49874", "22.92617", "Europe/Athens"),("734771", "Panórama", "", "GR", "300", "", "ESYE12", "13", "9037", "40.58779", "23.0315", "Europe/Athens"),("734880", "Orestiáda", "", "GR", "300", "", "ESYE11", "01", "9008", "41.50306", "26.52972", "Europe/Athens"),("734883", "Oraiókastro", "", "GR", "300", "", "ESYE12", "13", "9039", "40.73083", "22.91722", "Europe/Athens"),("734973", "Néoi Epivátes", "", "GR", "300", "", "ESYE12", "13", "9029", "40.49863", "22.91192", "Europe/Athens"),("734999", "Néa Moudhaniá", "", "GR", "300", "", "ESYE12", "15", "9058", "40.2439", "23.28484", "Europe/Athens"),("735001", "Néa Michanióna", "", "GR", "300", "", "ESYE12", "13", "9029", "40.46371", "22.8617", "Europe/Athens"),("735016", "Néa Kallikráteia", "", "GR", "300", "", "ESYE12", "15", "9058", "40.31312", "23.06343", "Europe/Athens"),("735030", "Náousa", "", "GR", "300", "", "ESYE12", "12", "9025", "40.62944", "22.06806", "Europe/Athens"),("735215", "Meneméni", "", "GR", "300", "", "ESYE12", "13", "9026", "40.65829", "22.89712", "Europe/Athens"),("735399", "Litóchoro", "", "GR", "300", "", "ESYE12", "16", "9046", "40.10056", "22.49778", "Europe/Athens"),("735481", "Lagkadás", "", "GR", "300", "GR", "ESYE12", "13", "9034", "40.75", "23.06667", "Europe/Athens"),("735546", "Krýa Vrýsi", "", "GR", "300", "", "ESYE12", "07", "9044", "40.68738", "22.30516", "Europe/Athens"),("735563", "Kozáni", "Козани", "GR", "300", "", "ESYE13", "11", "9068", "40.30069", "21.78896", "Europe/Athens"),("735588", "Koufália", "", "GR", "300", "", "ESYE12", "13", "9038", "40.77778", "22.57194", "Europe/Athens"),("735640", "Komotiní", "Комотини", "GR", "300", "", "ESYE11", "02", "9021", "41.11917", "25.40535", "Europe/Athens"),("735736", "Kilkís", "", "GR", "300", "", "ESYE12", "06", "9040", "40.99302", "22.87433", "Europe/Athens"),("735747", "Chrysoúpolis", "", "GR", "300", "", "ESYE11", "14", "9013", "40.98556", "24.69389", "Europe/Athens"),("735861", "Kavála", "Кавала", "GR", "300", "", "ESYE11", "14", "9012", "40.93959", "24.40687", "Europe/Athens"),("735914", "Kateríni", "", "GR", "300", "", "ESYE12", "16", "9047", "40.26956", "22.50608", "Europe/Athens"),("735927", "Kastoria", "", "GR", "300", "", "ESYE13", "09", "9063", "40.52165", "21.26341", "Europe/Athens"),("735972", "Karyes", "", "GR", "300", "", "736572", "", "", "40.25715", "24.24498", "Europe/Athens"),("736083", "Kalamariá", "Каламария", "GR", "300", "", "ESYE12", "13", "9032", "40.5825", "22.95028", "Europe/Athens"),("736151", "Grevená", "", "GR", "300", "", "ESYE13", "10", "9061", "40.08452", "21.42744", "Europe/Athens"),("736229", "Flórina", "", "GR", "300", "", "ESYE13", "08", "9072", "40.78197", "21.40981", "Europe/Athens"),("736261", "Féres", "", "GR", "300", "", "ESYE11", "01", "9006", "40.89305", "26.17234", "Europe/Athens"),("736319", "Epanomí", "", "GR", "300", "", "ESYE12", "13", "9029", "40.42614", "22.92782", "Europe/Athens"),("736357", "Édessa", "", "GR", "300", "", "ESYE12", "07", "9043", "40.8026", "22.04751", "Europe/Athens"),("736364", "Dráma", "", "GR", "300", "", "ESYE11", "04", "9002", "41.15283", "24.1473", "Europe/Athens"),("736447", "Didymóteicho", "", "GR", "300", "", "ESYE11", "01", "9007", "41.34806", "26.49611", "Europe/Athens"),("736450", "Diavatá", "", "GR", "300", "", "ESYE12", "13", "9028", "40.68744", "22.85799", "Europe/Athens"),("736687", "Asvestochóri", "", "GR", "300", "", "ESYE12", "13", "9037", "40.64125", "23.02528", "Europe/Athens"),("736753", "Aridaía", "", "GR", "300", "", "ESYE12", "07", "9042", "40.97306", "22.05639", "Europe/Athens"),("736754", "Argos Orestiko", "", "GR", "300", "", "ESYE13", "09", "9065", "40.45354", "21.25889", "Europe/Athens"),("736928", "Alexandroupoli", "Александруполис", "GR", "300", "", "ESYE11", "01", "9006", "40.84995", "25.87644", "Europe/Athens"),("736929", "Alexándreia", "", "GR", "300", "", "ESYE12", "12", "9023", "40.62667", "22.44417", "Europe/Athens"),("865290", "Ágios Pávlos", "", "GR", "300", "", "ESYE12", "13", "9031", "40.64075", "22.96039", "Europe/Athens"),("865291", "Triandría", "", "GR", "300", "", "ESYE12", "13", "9031", "40.615", "22.9762", "Europe/Athens"),("2463679", "Corfu", "Корфу", "GR", "300", "", "ESYE22", "25", "9118", "39.62069", "19.91975", "Europe/Athens"),("6324534", "Vrilissia", "", "GR", "300", "", "ESYE31", "445408", "9169", "38.03381", "23.82962", "Europe/Athens"),("6354951", "Faliraki", "", "GR", "300", "", "ESYE42", "47", "9296", "36.33981", "28.19942", "Europe/Athens"),("7667930", "Ymittos", "", "GR", "300", "", "ESYE31", "445408", "9189", "37.95342", "23.74897", "Europe/Athens"),("8201845", "Gérakas", "", "GR", "300", "", "ESYE31", "445406", "9223", "38.02277", "23.8576", "Europe/Athens"),("8310138", "Ilioúpoli", "", "GR", "300", "", "ESYE31", "445408", "9191", "37.93149", "23.76779", "Europe/Athens"),("8310183", "Korydallós", "", "GR", "300", "", "ESYE31", "406101", "9203", "37.98468", "23.64711", "Europe/Athens"),("8358544", "Zográfos", "", "GR", "300", "", "ESYE31", "445408", "9190", "37.97574", "23.76911", "Europe/Athens"),("8358562", "Péfki", "", "GR", "300", "", "ESYE31", "445408", "9172", "38.06019", "23.79264", "Europe/Athens"),("8358563", "Ágioi Anárgyroi", "", "GR", "300", "", "ESYE31", "445408", "9180", "38.03013", "23.72379", "Europe/Athens"),("8478257", "Agios Ioannis Rentis", "", "GR", "300", "", "ESYE31", "406101", "9204", "37.96491", "23.66511", "Europe/Athens"),("8644195", "Drapetsóna", "", "GR", "300", "", "ESYE31", "406101", "9202", "37.94988", "23.62309", "Europe/Athens"),("8657513", "Néo Psychikó", "", "GR", "300", "", "ESYE31", "445408", "9177", "38.00624", "23.78373", "Europe/Athens"),("9034728", "Néa Ionía", "", "GR", "300", "", "ESYE14", "24", "9105", "39.37904", "22.92752", "Europe/Athens"),("9035858", "Zefyri", "", "GR", "300", "", "ESYE31", "445407", "9232", "38.06647", "23.71701", "Europe/Athens"),("9035859", "Thrakomakedónes", "", "GR", "300", "", "ESYE31", "445406", "9215", "38.12964", "23.75751", "Europe/Athens"),("9035866", "Néa Pentéli", "", "GR", "300", "", "ESYE31", "445408", "9176", "38.06059", "23.85926", "Europe/Athens"),("9035867", "Néa Chalkidóna", "", "GR", "300", "", "ESYE31", "445408", "9193", "38.0271", "23.73051", "Europe/Athens"),("3186294", "Županja", "", "HR", "191", "", "18", "3186293", "", "45.0775", "18.6975", "Europe/Zagreb"),("3186781", "Zaprešić", "Запрешич", "HR", "191", "", "20", "3186780", "", "45.85639", "15.80778", "Europe/Zagreb"),("3186886", "Zagreb", "Загреб", "HR", "191", "", "21", "3186885", "", "45.81444", "15.97798", "Europe/Zagreb"),("3186952", "Zadar", "Задар", "HR", "191", "", "19", "", "", "44.11972", "15.24222", "Europe/Zagreb"),("3187047", "Vukovar", "Вуковар", "HR", "191", "", "18", "", "", "45.34333", "18.99972", "Europe/Zagreb"),("3187489", "Vodice", "", "HR", "191", "", "13", "11054525", "", "43.76083", "15.78278", "Europe/Zagreb"),("3187657", "Višnjevac", "", "HR", "191", "", "10", "3193934", "", "45.56861", "18.61389", "Europe/Zagreb"),("3187694", "Virovitica", "", "HR", "191", "", "17", "3187693", "", "45.83194", "17.38389", "Europe/Zagreb"),("3187719", "Vinkovci", "Винковцы", "HR", "191", "", "18", "3187718", "", "45.28833", "18.80472", "Europe/Zagreb"),("3188244", "Velika Gorica", "Велика-Горица", "HR", "191", "", "20", "3188243", "", "45.7125", "16.07556", "Europe/Zagreb"),("3188383", "Varaždin", "Вараждин", "HR", "191", "", "16", "", "", "46.30444", "16.33778", "Europe/Zagreb"),("3188395", "Valpovo", "", "HR", "191", "", "10", "3188394", "", "45.66083", "18.41861", "Europe/Zagreb"),("3188498", "Umag", "", "HR", "191", "", "04", "11129767", "", "45.43139", "13.52389", "Europe/Zagreb"),("3188763", "Trogir", "", "HR", "191", "", "15", "3188762", "", "43.5125", "16.25167", "Europe/Zagreb"),("3189161", "Tenja", "", "HR", "191", "", "10", "3193934", "", "45.49806", "18.74722", "Europe/Zagreb"),("3190261", "Split", "Сплит", "HR", "191", "", "15", "3190259", "", "43.50891", "16.43915", "Europe/Zagreb"),("3190359", "Solin", "Солин", "HR", "191", "", "15", "11054720", "", "43.5432", "16.49314", "Europe/Zagreb"),("3190586", "Slavonski Brod", "Славонски-Брод", "HR", "191", "", "02", "3190585", "", "45.16028", "18.01556", "Europe/Zagreb"),("3190589", "Požega", "Пожега", "HR", "191", "", "11", "3190588", "", "45.34028", "17.68528", "Europe/Zagreb"),("3190813", "Sisak", "Сисак", "HR", "191", "", "14", "3190812", "", "45.46611", "16.37833", "Europe/Zagreb"),("3190865", "Sinj", "", "HR", "191", "", "15", "3190864", "", "43.70361", "16.63944", "Europe/Zagreb"),("3190941", "Šibenik", "Шибеник", "HR", "191", "", "13", "3190938", "", "43.72722", "15.90583", "Europe/Zagreb"),("3190966", "Sesvete", "Сесвете", "HR", "191", "", "21", "3190965", "", "45.83111", "16.11639", "Europe/Zagreb"),("3191055", "Senj", "", "HR", "191", "", "08", "11049293", "", "44.98944", "14.90583", "Europe/Zagreb"),("3191316", "Samobor", "", "HR", "191", "", "20", "3191315", "", "45.80306", "15.71806", "Europe/Zagreb"),("3191518", "Rovinj", "", "HR", "191", "", "04", "3191516", "", "45.08", "13.64", "Europe/Zagreb"),("3191648", "Rijeka", "Риека", "HR", "191", "", "12", "", "", "45.34306", "14.40917", "Europe/Zagreb"),("3192224", "Pula", "Пула", "HR", "191", "", "04", "3192222", "", "44.86833", "13.84806", "Europe/Zagreb"),("3192699", "Poreč", "", "HR", "191", "", "04", "3192696", "", "45.22567", "13.59511", "Europe/Zagreb"),("3192910", "Podstrana", "", "HR", "191", "", "15", "11054619", "", "43.48668", "16.55013", "Europe/Zagreb"),("3192932", "Slatina", "", "HR", "191", "", "17", "3192931", "", "45.70333", "17.70278", "Europe/Zagreb"),("3193305", "Pitomača", "", "HR", "191", "", "17", "11049466", "", "45.95056", "17.22944", "Europe/Zagreb"),("3193420", "Petrinja", "", "HR", "191", "", "14", "3193419", "", "45.4375", "16.29", "Europe/Zagreb"),("3193561", "Pazin", "", "HR", "191", "", "04", "3193560", "", "45.24028", "13.93667", "Europe/Zagreb"),("3193781", "Otok", "", "HR", "191", "", "18", "11054955", "", "45.14667", "18.88389", "Europe/Zagreb"),("3193935", "Osijek", "Осиек", "HR", "191", "", "10", "3193934", "", "45.55111", "18.69389", "Europe/Zagreb"),("3194099", "Opatija", "", "HR", "191", "", "12", "3194097", "", "45.33917", "14.30833", "Europe/Zagreb"),("3194114", "Omiš", "", "HR", "191", "", "15", "3194113", "", "43.44472", "16.68861", "Europe/Zagreb"),("3194183", "Ogulin", "", "HR", "191", "", "05", "3194182", "", "45.26611", "15.22861", "Europe/Zagreb"),("3194319", "Novska", "", "HR", "191", "", "14", "3194318", "", "45.34056", "16.97694", "Europe/Zagreb"),("3194355", "Novi Vinodolski", "", "HR", "191", "", "12", "11049447", "", "45.12806", "14.78889", "Europe/Zagreb"),("3194449", "Nova Gradiška", "", "HR", "191", "", "02", "3194448", "", "45.255", "17.38306", "Europe/Zagreb"),("3194581", "Našice", "", "HR", "191", "", "10", "3194580", "", "45.48861", "18.08778", "Europe/Zagreb"),("3195222", "Metković", "", "HR", "191", "", "03", "11054969", "", "43.05417", "17.64833", "Europe/Zagreb"),("3195890", "Makarska", "", "HR", "191", "", "15", "3195888", "", "43.29694", "17.01778", "Europe/Zagreb"),("3196834", "Labin", "", "HR", "191", "", "04", "3196833", "", "45.095", "14.11972", "Europe/Zagreb"),("3196864", "Kutina", "", "HR", "191", "", "14", "3196862", "", "45.475", "16.78194", "Europe/Zagreb"),("3197230", "Križevci", "", "HR", "191", "", "06", "3197228", "", "46.02194", "16.5425", "Europe/Zagreb"),("3197369", "Krapina", "", "HR", "191", "", "07", "3197366", "", "46.16083", "15.87889", "Europe/Zagreb"),("3197728", "Koprivnica", "Копривница", "HR", "191", "", "06", "3197726", "", "46.16278", "16.8275", "Europe/Zagreb"),("3197986", "Knin", "", "HR", "191", "", "13", "11054516", "", "44.04063", "16.19662", "Europe/Zagreb"),("3198212", "Kaštel Stari", "", "HR", "191", "HR", "15", "11054606", "", "43.55", "16.35", "Europe/Zagreb"),("3198214", "Kaštel Novi", "", "HR", "191", "HR", "15", "11054606", "", "43.55", "16.33333", "Europe/Zagreb"),("3198215", "Kaštel Lukšić", "", "HR", "191", "HR", "15", "11054606", "", "43.55528", "16.3675", "Europe/Zagreb"),("3198216", "Kaštel Kambelovac", "", "HR", "191", "HR", "15", "11054606", "", "43.55", "16.38333", "Europe/Zagreb"),("3198259", "Karlovac", "Карловац", "HR", "191", "", "05", "3198257", "", "45.48722", "15.54778", "Europe/Zagreb"),("3198799", "Jastrebarsko", "", "HR", "191", "", "20", "3198798", "", "45.66833", "15.64861", "Europe/Zagreb"),("3199051", "Ivankovo", "", "HR", "191", "", "18", "11054538", "", "45.28861", "18.68389", "Europe/Zagreb"),("3199076", "Ivanec", "", "HR", "191", "", "16", "3199075", "", "46.22306", "16.12", "Europe/Zagreb"),("3199128", "Ilok", "", "HR", "191", "", "18", "11054537", "", "45.22222", "19.37694", "Europe/Zagreb"),("3199473", "Gunja", "", "HR", "191", "", "18", "11054536", "", "44.88", "18.85333", "Europe/Zagreb"),("3199873", "Gospić", "", "HR", "191", "", "08", "11049286", "", "44.54611", "15.37472", "Europe/Zagreb"),("3200961", "Đurđevac", "", "HR", "191", "", "06", "3200960", "", "46.04111", "17.06972", "Europe/Zagreb"),("3201047", "Dubrovnik", "Дубровник", "HR", "191", "", "03", "7577034", "", "42.64807", "18.09216", "Europe/Zagreb"),("3201217", "Drenova", "", "HR", "191", "HR", "12", "", "", "45.35", "14.43028", "Europe/Zagreb"),("3202184", "Daruvar", "", "HR", "191", "", "01", "3202183", "", "45.59056", "17.225", "Europe/Zagreb"),("3202186", "Darda", "", "HR", "191", "", "10", "11054454", "", "45.62806", "18.69972", "Europe/Zagreb"),("3202220", "Đakovo", "", "HR", "191", "", "10", "3202219", "", "45.30833", "18.41056", "Europe/Zagreb"),("3202507", "Crikvenica", "", "HR", "191", "", "12", "3202506", "", "45.17722", "14.69278", "Europe/Zagreb"),("3202743", "Čepin", "", "HR", "191", "", "10", "11054395", "", "45.52361", "18.56333", "Europe/Zagreb"),("3202888", "Čakovec", "Чаковец", "HR", "191", "", "09", "3202887", "", "46.38444", "16.43389", "Europe/Zagreb"),("3202942", "Buzet", "", "HR", "191", "", "04", "3202941", "", "45.40944", "13.96667", "Europe/Zagreb"),("3203344", "Brezovica", "", "HR", "191", "", "21", "", "", "45.72919", "15.91069", "Europe/Zagreb"),("3203670", "Borovo", "", "HR", "191", "", "18", "11054530", "", "45.37639", "18.96694", "Europe/Zagreb"),("3203982", "Bjelovar", "Беловар", "HR", "191", "", "01", "", "", "45.89861", "16.84889", "Europe/Zagreb"),("3204121", "Biograd na Moru", "", "HR", "191", "", "19", "3204122", "", "43.94333", "15.45194", "Europe/Zagreb"),("3204317", "Belišće", "", "HR", "191", "", "10", "11054391", "", "45.68028", "18.40583", "Europe/Zagreb"),("3204320", "Beli Manastir", "", "HR", "191", "", "10", "3204319", "", "45.77", "18.60361", "Europe/Zagreb"),("3209380", "Zagreb- Stenjevec", "", "HR", "191", "", "21", "", "", "45.80846", "15.88245", "Europe/Zagreb"),("3345300", "Karlovac", "", "HR", "191", "HR", "05", "3198257", "", "45.49167", "15.55", "Europe/Zagreb"),("6618983", "Zagreb - Centar", "", "HR", "191", "", "21", "3186885", "", "45.81313", "15.97753", "Europe/Zagreb"),("714073", "Vésztő", "", "HU", "348", "", "03", "", "", "46.91667", "21.26667", "Europe/Budapest"),("714188", "Vásárosnamény", "", "HU", "348", "", "18", "", "", "48.12542", "22.31325", "Europe/Budapest"),("714265", "Vámospércs", "", "HU", "348", "", "10", "", "", "47.53333", "21.9", "Europe/Budapest"),("714421", "Újszász", "", "HU", "348", "", "20", "", "", "47.3", "20.08333", "Europe/Budapest"),("714449", "Újkígyós", "", "HU", "348", "", "03", "", "", "46.58333", "21.03333", "Europe/Budapest"),("714464", "Újfehértó", "", "HU", "348", "", "18", "", "", "47.8", "21.68333", "Europe/Budapest"),("714504", "Túrkeve", "", "HU", "348", "", "20", "", "", "47.1", "20.75", "Europe/Budapest"),("714548", "Tótkomlós", "", "HU", "348", "", "03", "", "", "46.41667", "20.73333", "Europe/Budapest"),("714581", "Törökszentmiklós", "Тороксентмиклош", "HU", "348", "", "20", "", "", "47.18333", "20.41667", "Europe/Budapest"),("714659", "Tokaj", "", "HU", "348", "", "04", "", "", "48.11667", "21.41667", "Europe/Budapest"),("714692", "Tiszavasvári", "", "HU", "348", "", "18", "", "", "47.96667", "21.35", "Europe/Budapest"),("714697", "Tiszaújváros", "", "HU", "348", "", "04", "", "", "47.93333", "21.08333", "Europe/Budapest"),("714739", "Tiszalúc", "", "HU", "348", "", "04", "", "", "48.03774", "21.07261", "Europe/Budapest"),("714742", "Tiszalök", "", "HU", "348", "", "18", "", "", "48.01667", "21.38333", "Europe/Budapest"),("714754", "Tiszakécske", "", "HU", "348", "", "01", "", "", "46.93261", "20.10349", "Europe/Budapest"),("714772", "Tiszafüred", "", "HU", "348", "", "20", "", "", "47.61667", "20.76667", "Europe/Budapest"),("714774", "Tiszaföldvár", "", "HU", "348", "", "20", "", "", "46.98333", "20.25", "Europe/Budapest"),("714914", "Téglás", "", "HU", "348", "", "10", "", "", "47.71667", "21.68333", "Europe/Budapest"),("715126", "Szolnok", "Сольнок", "HU", "348", "", "20", "", "", "47.18333", "20.2", "Europe/Budapest"),("715259", "Szikszó", "", "HU", "348", "", "04", "", "", "48.2", "20.93333", "Europe/Budapest"),("715302", "Szerencs", "", "HU", "348", "", "04", "", "", "48.15993", "21.2097", "Europe/Budapest"),("715338", "Szentes", "", "HU", "348", "", "06", "", "", "46.65627", "20.27201", "Europe/Budapest"),("715422", "Szeghalom", "", "HU", "348", "", "03", "", "", "47.03333", "21.16667", "Europe/Budapest"),("715429", "Szeged", "", "HU", "348", "", "06", "", "", "46.253", "20.14824", "Europe/Budapest"),("715466", "Szarvas", "Сарваш", "HU", "348", "", "03", "", "", "46.86667", "20.55", "Europe/Budapest"),("715839", "Sátoraljaújhely", "Шаторальяуйхей", "HU", "348", "", "04", "", "", "48.39492", "21.65871", "Europe/Budapest"),("715867", "Sárospatak", "", "HU", "348", "", "04", "", "", "48.3245", "21.57383", "Europe/Budapest"),("715888", "Sarkad", "", "HU", "348", "", "03", "", "", "46.75", "21.38333", "Europe/Budapest"),("715924", "Sándorfalva", "", "HU", "348", "", "06", "", "", "46.36087", "20.09889", "Europe/Budapest"),("715945", "Sajószentpéter", "", "HU", "348", "", "04", "", "", "48.21667", "20.71667", "Europe/Budapest"),("716197", "Rákóczifalva", "", "HU", "348", "", "20", "", "", "47.08333", "20.23333", "Europe/Budapest"),("716204", "Rakamaz", "", "HU", "348", "", "18", "", "", "48.12372", "21.46429", "Europe/Budapest"),("716247", "Putnok", "", "HU", "348", "", "04", "", "", "48.3", "20.43333", "Europe/Budapest"),("716301", "Püspökladány", "", "HU", "348", "", "10", "", "", "47.31667", "21.11667", "Europe/Budapest"),("716356", "Polgár", "", "HU", "348", "", "10", "", "", "47.86667", "21.11667", "Europe/Budapest"),("716671", "Ózd", "Озд", "HU", "348", "", "04", "", "", "48.21667", "20.3", "Europe/Budapest"),("716736", "Orosháza", "Орошхаза", "HU", "348", "", "03", "", "", "46.56667", "20.66667", "Europe/Budapest"),("716893", "Nyírtelek", "", "HU", "348", "", "18", "", "", "48.01667", "21.63333", "Europe/Budapest"),("716935", "Nyíregyháza", "Ньиредьхаза", "HU", "348", "", "18", "", "", "47.95539", "21.71671", "Europe/Budapest"),("716948", "Nyírbátor", "", "HU", "348", "", "18", "", "", "47.83333", "22.13333", "Europe/Budapest"),("716951", "Nyíradony", "", "HU", "348", "", "10", "", "", "47.69746", "21.91878", "Europe/Budapest"),("717130", "Nagyszénás", "", "HU", "348", "", "03", "", "", "46.68333", "20.66667", "Europe/Budapest"),("717281", "Nagykálló", "", "HU", "348", "", "18", "", "", "47.87491", "21.84082", "Europe/Budapest"),("717345", "Nagyhalász", "", "HU", "348", "", "18", "", "", "48.13266", "21.76104", "Europe/Budapest"),("717397", "Nagyecsed", "", "HU", "348", "", "18", "", "", "47.86547", "22.39159", "Europe/Budapest"),("717449", "Nádudvar", "", "HU", "348", "", "10", "", "", "47.41667", "21.16667", "Europe/Budapest"),("717582", "Miskolc", "Мишкольц", "HU", "348", "", "04", "", "", "48.1", "20.78333", "Europe/Budapest"),("717591", "Mindszent", "", "HU", "348", "", "06", "", "", "46.52362", "20.19038", "Europe/Budapest"),("717635", "Mezőtúr", "", "HU", "348", "", "20", "", "", "47", "20.63333", "Europe/Budapest"),("717652", "Mezőkövesd", "", "HU", "348", "", "04", "", "", "47.81667", "20.58333", "Europe/Budapest"),("717656", "Mezőkovácsháza", "", "HU", "348", "", "03", "", "", "46.4", "20.91667", "Europe/Budapest"),("717662", "Mezőhegyes", "", "HU", "348", "", "03", "", "", "46.31667", "20.81667", "Europe/Budapest"),("717667", "Mezőcsát", "", "HU", "348", "", "04", "", "", "47.81667", "20.91667", "Europe/Budapest"),("717669", "Mezőberény", "", "HU", "348", "", "03", "", "", "46.81667", "21.03333", "Europe/Budapest"),("717771", "Mátészalka", "", "HU", "348", "", "18", "", "", "47.95528", "22.32348", "Europe/Budapest"),("717902", "Makó", "Мако", "HU", "348", "", "06", "", "", "46.21667", "20.48333", "Europe/Budapest"),("718113", "Létavértes", "", "HU", "348", "", "10", "", "", "47.38333", "21.9", "Europe/Budapest"),("718312", "Kunszentmárton", "", "HU", "348", "", "20", "", "", "46.83916", "20.28879", "Europe/Budapest"),("718315", "Kunmadaras", "", "HU", "348", "", "20", "", "", "47.43333", "20.8", "Europe/Budapest"),("718321", "Kunhegyes", "", "HU", "348", "", "20", "", "", "47.36667", "20.63333", "Europe/Budapest"),("718528", "Körösladány", "", "HU", "348", "", "03", "", "", "46.96667", "21.08333", "Europe/Budapest"),("718615", "Kondoros", "", "HU", "348", "", "03", "", "", "46.76667", "20.8", "Europe/Budapest"),("718637", "Komádi", "", "HU", "348", "", "10", "", "", "47", "21.5", "Europe/Budapest"),("718739", "Kisvárda", "", "HU", "348", "", "18", "", "", "48.21667", "22.08333", "Europe/Budapest"),("718744", "Kisújszállás", "", "HU", "348", "", "20", "", "", "47.21667", "20.76667", "Europe/Budapest"),("719252", "Kenderes", "", "HU", "348", "", "20", "", "", "47.25", "20.68333", "Europe/Budapest"),("719260", "Kemecse", "", "HU", "348", "", "18", "", "", "48.07532", "21.80625", "Europe/Budapest"),("719311", "Kazincbarcika", "Казинцбарцика", "HU", "348", "", "04", "", "", "48.25", "20.63333", "Europe/Budapest"),("719404", "Karcag", "Карцаге", "HU", "348", "", "20", "", "", "47.31667", "20.93333", "Europe/Budapest"),("719555", "Kaba", "", "HU", "348", "", "10", "", "", "47.35", "21.28333", "Europe/Budapest"),("719640", "Jászladány", "", "HU", "348", "", "20", "", "", "47.36667", "20.16667", "Europe/Budapest"),("719643", "Jászkisér", "", "HU", "348", "", "20", "", "", "47.45", "20.21667", "Europe/Budapest"),("719655", "Jászapáti", "", "HU", "348", "", "20", "", "", "47.51667", "20.15", "Europe/Budapest"),("719806", "Ibrány", "", "HU", "348", "", "18", "", "", "48.12329", "21.70953", "Europe/Budapest"),("719843", "Hosszúpályi", "", "HU", "348", "", "10", "", "", "47.39303", "21.7328", "Europe/Budapest"),("719965", "Hódmezővásárhely", "Ходмезевашархей", "HU", "348", "", "06", "", "", "46.41667", "20.33333", "Europe/Budapest"),("720006", "Heves", "", "HU", "348", "", "11", "", "", "47.6", "20.28333", "Europe/Budapest"),("720276", "Hajdúszoboszló", "Хайдусобосло", "HU", "348", "", "10", "", "", "47.45", "21.4", "Europe/Budapest"),("720280", "Hajdúsámson", "", "HU", "348", "", "10", "", "", "47.6", "21.76667", "Europe/Budapest"),("720284", "Hajdúnánás", "", "HU", "348", "", "10", "", "", "47.85", "21.43333", "Europe/Budapest"),("720287", "Hajdúhadház", "", "HU", "348", "", "10", "", "", "47.68333", "21.66667", "Europe/Budapest"),("720290", "Hajdúdorog", "", "HU", "348", "", "10", "", "", "47.81667", "21.5", "Europe/Budapest"),("720292", "Hajdúböszörmény", "", "HU", "348", "", "10", "", "", "47.66667", "21.51667", "Europe/Budapest"),("720334", "Gyula", "Дьюла", "HU", "348", "", "03", "", "", "46.65", "21.28333", "Europe/Budapest"),("720364", "Gyomaendrőd", "", "HU", "348", "", "03", "", "", "46.93333", "20.83333", "Europe/Budapest"),("720679", "Füzesgyarmat", "", "HU", "348", "", "03", "", "", "47.1", "21.21667", "Europe/Budapest"),("720687", "Füzesabony", "", "HU", "348", "", "11", "", "", "47.75", "20.41667", "Europe/Budapest"),("720857", "Felsőzsolca", "", "HU", "348", "", "04", "", "", "48.1", "20.86667", "Europe/Budapest"),("720988", "Fehérgyarmat", "", "HU", "348", "", "18", "", "", "47.98333", "22.51667", "Europe/Budapest"),("720992", "Fegyvernek", "", "HU", "348", "", "20", "", "", "47.26667", "20.53333", "Europe/Budapest"),("721159", "Encs", "", "HU", "348", "", "04", "", "", "48.33333", "21.13333", "Europe/Budapest"),("721161", "Emőd", "", "HU", "348", "", "04", "", "", "47.93333", "20.81667", "Europe/Budapest"),("721189", "Elek", "", "HU", "348", "", "03", "", "", "46.53333", "21.25", "Europe/Budapest"),("721208", "Egyek", "", "HU", "348", "", "10", "", "", "47.63333", "20.9", "Europe/Budapest"),("721239", "Eger", "Эгер", "HU", "348", "", "11", "", "", "47.90265", "20.37329", "Europe/Budapest"),("721246", "Edelény", "", "HU", "348", "", "04", "", "", "48.3", "20.73333", "Europe/Budapest"),("721404", "Dévaványa", "", "HU", "348", "", "03", "", "", "47.03333", "20.96667", "Europe/Budapest"),("721428", "Derecske", "", "HU", "348", "", "10", "", "", "47.35", "21.56667", "Europe/Budapest"),("721472", "Debrecen", "Дебрецен", "HU", "348", "", "10", "", "", "47.53333", "21.63333", "Europe/Budapest"),("721559", "Csorvás", "", "HU", "348", "", "03", "", "", "46.63333", "20.83333", "Europe/Budapest"),("721592", "Csongrád", "", "HU", "348", "", "06", "", "", "46.71332", "20.14241", "Europe/Budapest"),("721789", "Csenger", "", "HU", "348", "", "18", "", "", "47.83582", "22.68096", "Europe/Budapest"),("722324", "Berettyóújfalu", "", "HU", "348", "", "10", "", "", "47.21667", "21.55", "Europe/Budapest"),("722437", "Békéscsaba", "Бекешчаба", "HU", "348", "", "03", "", "", "46.68333", "21.1", "Europe/Budapest"),("722439", "Békés", "Бекеш", "HU", "348", "", "03", "", "", "46.76667", "21.13333", "Europe/Budapest"),("722477", "Battonya", "", "HU", "348", "", "03", "", "", "46.28333", "21.01667", "Europe/Budapest"),("722636", "Balmazújváros", "", "HU", "348", "", "10", "", "", "47.61667", "21.35", "Europe/Budapest"),("722650", "Balkány", "", "HU", "348", "", "18", "", "", "47.77066", "21.86314", "Europe/Budapest"),("722882", "Alsózsolca", "", "HU", "348", "", "04", "", "", "48.06982", "20.88046", "Europe/Budapest"),("723030", "Abony", "", "HU", "348", "", "16", "", "", "47.1899", "20.00476", "Europe/Budapest"),("3042536", "Zirc", "", "HU", "348", "", "23", "", "", "47.26362", "17.87373", "Europe/Budapest"),("3042603", "Zalaszentgrót", "", "HU", "348", "", "24", "", "", "46.94474", "17.07925", "Europe/Budapest"),("3042638", "Zalaegerszeg", "Залаэгерсег", "HU", "348", "", "24", "", "", "46.84", "16.84389", "Europe/Budapest"),("3042929", "Veszprém", "Веспрем", "HU", "348", "", "23", "", "", "47.09327", "17.91149", "Europe/Budapest"),("3042968", "Veresegyház", "", "HU", "348", "", "16", "", "", "47.6459", "19.29536", "Europe/Budapest"),("3043019", "Vecsés", "", "HU", "348", "", "16", "", "", "47.40705", "19.28648", "Europe/Budapest"),("3043095", "Várpalota", "", "HU", "348", "", "23", "", "", "47.19936", "18.13954", "Europe/Budapest"),("3043293", "Vác", "Вац", "HU", "348", "", "16", "", "", "47.77591", "19.13612", "Europe/Budapest"),("3043356", "Üllő", "", "HU", "348", "", "16", "", "", "47.38771", "19.35533", "Europe/Budapest"),("3043678", "Tura", "", "HU", "348", "", "16", "", "", "47.60924", "19.60279", "Europe/Budapest"),("3043778", "Törökbálint", "", "HU", "348", "", "16", "", "", "47.42931", "18.91356", "Europe/Budapest"),("3043849", "Tolna", "", "HU", "348", "", "21", "", "", "46.42677", "18.78248", "Europe/Budapest"),("3043860", "Tököl", "", "HU", "348", "", "16", "", "", "47.32178", "18.96249", "Europe/Budapest"),("3044082", "Tatabánya", "Татабанья", "HU", "348", "", "12", "", "", "47.58494", "18.39325", "Europe/Budapest"),("3044083", "Tata", "", "HU", "348", "", "12", "", "", "47.65289", "18.31838", "Europe/Budapest"),("3044084", "Tát", "", "HU", "348", "", "12", "", "", "47.74148", "18.64813", "Europe/Budapest"),("3044103", "Tárnok", "", "HU", "348", "", "16", "", "", "47.37327", "18.84579", "Europe/Budapest"),("3044141", "Tapolca", "", "HU", "348", "", "23", "", "", "46.88152", "17.44117", "Europe/Budapest"),("3044149", "Tápiószentmárton", "", "HU", "348", "", "16", "", "", "47.3399", "19.74648", "Europe/Budapest"),("3044151", "Tápiószele", "", "HU", "348", "", "16", "", "", "47.33609", "19.87724", "Europe/Budapest"),("3044153", "Tápiószecső", "", "HU", "348", "", "16", "", "", "47.45", "19.60923", "Europe/Budapest"),("3044154", "Sülysáp", "", "HU", "348", "", "16", "", "", "47.45206", "19.53369", "Europe/Budapest"),("3044171", "Tamási", "", "HU", "348", "", "21", "", "", "46.63333", "18.28333", "Europe/Budapest"),("3044181", "Taksony", "", "HU", "348", "", "16", "", "", "47.32968", "19.06695", "Europe/Budapest"),("3044310", "Szombathely", "Сомбатхей", "HU", "348", "", "22", "", "", "47.23088", "16.62155", "Europe/Budapest"),("3044469", "Szigetvár", "", "HU", "348", "", "02", "", "", "46.04865", "17.80554", "Europe/Budapest"),("3044475", "Szigetszentmiklós", "Сигетсентмиклош", "HU", "348", "", "16", "", "", "47.34382", "19.04335", "Europe/Budapest"),("3044487", "Szigethalom", "", "HU", "348", "", "16", "", "", "47.32228", "19.00262", "Europe/Budapest"),("3044575", "Szentlőrinc", "", "HU", "348", "", "02", "", "", "46.04016", "17.98719", "Europe/Budapest"),("3044669", "Szentgotthárd", "", "HU", "348", "", "22", "", "", "46.95261", "16.27358", "Europe/Budapest"),("3044681", "Szentendre", "Сентендре", "HU", "348", "", "16", "", "", "47.66943", "19.07561", "Europe/Budapest"),("3044760", "Szekszárd", "Сексард", "HU", "348", "", "21", "", "", "46.35014", "18.70905", "Europe/Budapest"),("3044774", "Székesfehérvár", "Секешфехервар", "HU", "348", "", "08", "", "", "47.18995", "18.41034", "Europe/Budapest"),("3044809", "Szécsény", "", "HU", "348", "", "14", "", "", "48.08057", "19.52019", "Europe/Budapest"),("3044821", "Százhalombatta", "", "HU", "348", "", "16", "", "", "47.32579", "18.92141", "Europe/Budapest"),("3045017", "Szabadszállás", "", "HU", "348", "", "01", "", "", "46.87575", "19.22324", "Europe/Budapest"),("3045070", "Sümeg", "", "HU", "348", "", "23", "", "", "46.97703", "17.28209", "Europe/Budapest"),("3045190", "Sopron", "Шопрон", "HU", "348", "", "09", "", "", "47.68501", "16.59049", "Europe/Budapest"),("3045294", "Solymár", "", "HU", "348", "", "16", "", "", "47.59246", "18.93212", "Europe/Budapest"),("3045298", "Soltvadkert", "", "HU", "348", "", "01", "", "", "46.57889", "19.39389", "Europe/Budapest"),("3045303", "Solt", "", "HU", "348", "", "01", "", "", "46.80067", "18.99993", "Europe/Budapest"),("3045332", "Siófok", "Шиофок", "HU", "348", "", "17", "", "", "46.90413", "18.058", "Europe/Budapest"),("3045364", "Siklós", "", "HU", "348", "", "02", "", "", "45.85499", "18.29752", "Europe/Budapest"),("3045487", "Sárvár", "", "HU", "348", "", "22", "", "", "47.25395", "16.93525", "Europe/Budapest"),("3045564", "Sárbogárd", "", "HU", "348", "", "08", "", "", "46.88692", "18.62041", "Europe/Budapest"),("3045643", "Salgótarján", "Шальготарьян", "HU", "348", "", "14", "", "", "48.09872", "19.80303", "Europe/Budapest"),("3046026", "Ráckeve", "", "HU", "348", "", "16", "", "", "47.16095", "18.94478", "Europe/Budapest"),("3046087", "Pusztaszabolcs", "", "HU", "348", "", "08", "", "", "47.13718", "18.76704", "Europe/Budapest"),("3046230", "Pomáz", "", "HU", "348", "", "16", "", "", "47.64227", "19.02784", "Europe/Budapest"),("3046249", "Polgárdi", "", "HU", "348", "", "08", "", "", "47.06099", "18.302", "Europe/Budapest"),("3046340", "Pilisvörösvár", "", "HU", "348", "", "16", "", "", "47.61386", "18.90893", "Europe/Budapest"),("3046353", "Piliscsaba", "", "HU", "348", "", "16", "", "", "47.63417", "18.82886", "Europe/Budapest"),("3046355", "Pilis", "", "HU", "348", "", "16", "", "", "47.28904", "19.54848", "Europe/Budapest"),("3046526", "Pécs", "Печ", "HU", "348", "", "02", "", "", "46.08333", "18.23333", "Europe/Budapest"),("3046531", "Pécel", "", "HU", "348", "", "16", "", "", "47.48962", "19.34162", "Europe/Budapest"),("3046546", "Páty", "", "HU", "348", "", "16", "", "", "47.51709", "18.82851", "Europe/Budapest"),("3046580", "Pásztó", "", "HU", "348", "", "14", "", "", "47.92019", "19.69829", "Europe/Budapest"),("3046619", "Parádsasvár", "Парадшашвар", "HU", "348", "HU", "11", "", "", "47.9126", "19.97709", "Europe/Budapest"),("3046686", "Pápa", "Папы", "HU", "348", "", "23", "", "", "47.33004", "17.4674", "Europe/Budapest"),("3046768", "Paks", "", "HU", "348", "", "21", "", "", "46.62648", "18.85962", "Europe/Budapest"),("3046888", "Oroszlány", "Орослане", "HU", "348", "", "12", "", "", "47.48671", "18.31225", "Europe/Budapest"),("3046916", "Örkény", "", "HU", "348", "", "16", "", "", "47.12991", "19.43324", "Europe/Budapest"),("3047127", "Őrbottyán", "", "HU", "348", "", "16", "", "", "47.68711", "19.28239", "Europe/Budapest"),("3047206", "Ócsa", "", "HU", "348", "", "16", "", "", "47.29986", "19.23057", "Europe/Budapest"),("3047282", "Nyergesújfalu", "", "HU", "348", "", "12", "", "", "47.76027", "18.55694", "Europe/Budapest"),("3047651", "Nagykőrös", "", "HU", "348", "", "16", "", "", "47.03419", "19.77857", "Europe/Budapest"),("3047669", "Nagykáta", "", "HU", "348", "", "16", "", "", "47.41514", "19.7441", "Europe/Budapest"),("3047679", "Nagykanizsa", "Надьканижа", "HU", "348", "", "24", "", "", "46.45347", "16.99104", "Europe/Budapest"),("3047819", "Nagyatád", "", "HU", "348", "", "17", "", "", "46.22961", "17.35788", "Europe/Budapest"),("3047896", "Mosonmagyaróvár", "Мошонмадьяровар", "HU", "348", "", "09", "", "", "47.86789", "17.26994", "Europe/Budapest"),("3047922", "Mórahalom", "", "HU", "348", "", "06", "", "", "46.21806", "19.8851", "Europe/Budapest"),("3047927", "Mór", "", "HU", "348", "", "08", "", "", "47.37787", "18.20353", "Europe/Budapest"),("3047942", "Monor", "", "HU", "348", "", "16", "", "", "47.35133", "19.44733", "Europe/Budapest"),("3047967", "Mohács", "Мохач", "HU", "348", "", "02", "", "", "45.99306", "18.68306", "Europe/Budapest"),("3048194", "Mélykút", "", "HU", "348", "", "01", "", "", "46.21509", "19.38102", "Europe/Budapest"),("3048326", "Martonvásár", "", "HU", "348", "", "08", "", "", "47.31601", "18.79045", "Europe/Budapest"),("3048456", "Marcali", "", "HU", "348", "", "17", "", "", "46.58498", "17.41196", "Europe/Budapest"),("3048630", "Maglód", "", "HU", "348", "", "16", "", "", "47.44258", "19.36438", "Europe/Budapest"),("3048725", "Lőrinci", "", "HU", "348", "", "11", "", "", "47.73295", "19.67867", "Europe/Budapest"),("3048847", "Lenti", "", "HU", "348", "", "24", "", "", "46.62403", "16.53863", "Europe/Budapest"),("3049002", "Lajosmizse", "", "HU", "348", "", "01", "", "", "47.02133", "19.56171", "Europe/Budapest"),("3049036", "Lábatlan", "", "HU", "348", "", "12", "", "", "47.74735", "18.49623", "Europe/Budapest"),("3049100", "Kunszentmiklós", "", "HU", "348", "", "01", "", "", "47.02699", "19.12575", "Europe/Budapest"),("3049366", "Kőszeg", "", "HU", "348", "", "22", "", "", "47.38922", "16.541", "Europe/Budapest"),("3049430", "Körmend", "", "HU", "348", "", "22", "", "", "47.01096", "16.60596", "Europe/Budapest"),("3049512", "Komló", "", "HU", "348", "", "02", "", "", "46.19278", "18.26494", "Europe/Budapest"),("3049519", "Komárom", "", "HU", "348", "", "12", "", "", "47.74318", "18.11913", "Europe/Budapest"),("3049719", "Kistelek", "", "HU", "348", "", "06", "", "", "46.4725", "19.97972", "Europe/Budapest"),("3049875", "Kiskunmajsa", "", "HU", "348", "", "01", "", "", "46.49028", "19.74", "Europe/Budapest"),("3049878", "Kiskunlacháza", "", "HU", "348", "", "16", "", "", "47.18839", "19.0093", "Europe/Budapest"),("3049880", "Kiskunhalas", "Кишкунхалаш", "HU", "348", "", "01", "", "", "46.43402", "19.48479", "Europe/Budapest"),("3049885", "Kiskunfélegyháza", "", "HU", "348", "", "01", "", "", "46.71213", "19.84458", "Europe/Budapest"),("3049896", "Kiskőrös", "", "HU", "348", "", "01", "", "", "46.62139", "19.28528", "Europe/Budapest"),("3050088", "Kisbér", "", "HU", "348", "", "12", "", "", "47.50289", "18.03665", "Europe/Budapest"),("3050212", "Keszthely", "Кестхей", "HU", "348", "", "24", "", "", "46.76812", "17.24317", "Europe/Budapest"),("3050290", "Kistarcsa", "", "HU", "348", "HU", "16", "", "", "47.54757", "19.26247", "Europe/Budapest"),("3050311", "Kerekegyháza", "", "HU", "348", "", "01", "", "", "46.93722", "19.47806", "Europe/Budapest"),("3050434", "Kecskemét", "Кечкемет", "HU", "348", "HU", "01", "", "", "46.90618", "19.69128", "Europe/Budapest"),("3050454", "Kecel", "", "HU", "348", "", "01", "", "", "46.52528", "19.25194", "Europe/Budapest"),("3050526", "Kartal", "", "HU", "348", "", "16", "", "", "47.67133", "19.542", "Europe/Budapest"),("3050594", "Kapuvár", "", "HU", "348", "", "09", "", "", "47.59224", "17.02886", "Europe/Budapest"),("3050616", "Kaposvár", "Капошвар", "HU", "348", "", "17", "", "", "46.36667", "17.8", "Europe/Budapest"),("3050719", "Kalocsa", "Калоча", "HU", "348", "", "01", "", "", "46.52639", "18.98583", "Europe/Budapest"),("3050907", "Jászberény", "", "HU", "348", "", "20", "", "", "47.5", "19.91667", "Europe/Budapest"),("3050909", "Jászárokszállás", "", "HU", "348", "", "20", "", "", "47.64238", "19.98038", "Europe/Budapest"),("3050927", "Jánossomorja", "", "HU", "348", "", "09", "", "", "47.78621", "17.13603", "Europe/Budapest"),("3050967", "Jánoshalma", "", "HU", "348", "", "01", "", "", "46.29861", "19.32583", "Europe/Budapest"),("3051016", "Izsák", "", "HU", "348", "", "01", "", "", "46.80454", "19.35172", "Europe/Budapest"),("3051077", "Isaszeg", "", "HU", "348", "", "16", "", "", "47.53011", "19.40205", "Europe/Budapest"),("3051621", "Hatvan", "", "HU", "348", "", "11", "", "", "47.66667", "19.68333", "Europe/Budapest"),("3051822", "Halásztelek", "", "HU", "348", "", "16", "", "", "47.36173", "18.98119", "Europe/Budapest"),("3052009", "Győr", "Дьёр", "HU", "348", "HU", "09", "", "", "47.68333", "17.63512", "Europe/Budapest"),("3052040", "Gyöngyös", "Дьёндьёш", "HU", "348", "", "11", "", "", "47.78257", "19.928", "Europe/Budapest"),("3052045", "Gyömrő", "", "HU", "348", "", "16", "", "", "47.42733", "19.40133", "Europe/Budapest"),("3052101", "Gyál", "", "HU", "348", "", "16", "", "", "47.38449", "19.2214", "Europe/Budapest"),("3052236", "Gödöllő", "Гёдёллё", "HU", "348", "", "16", "", "", "47.59657", "19.35515", "Europe/Budapest"),("3052241", "Göd", "", "HU", "348", "", "16", "", "", "47.68324", "19.13417", "Europe/Budapest"),("3052381", "Gárdony", "", "HU", "348", "", "08", "", "", "47.20942", "18.63607", "Europe/Budapest"),("3052542", "Fót", "", "HU", "348", "", "16", "", "", "47.6177", "19.1887", "Europe/Budapest"),("3052574", "Fonyód", "", "HU", "348", "", "17", "", "", "46.75552", "17.57945", "Europe/Budapest"),("3053163", "Esztergom", "Эстергом", "HU", "348", "", "12", "", "", "47.7928", "18.74148", "Europe/Budapest"),("3053176", "Erzsébetváros", "", "HU", "348", "", "16", "", "", "47.50207", "19.07218", "Europe/Budapest"),("3053253", "Erdőkertes", "", "HU", "348", "", "16", "", "", "47.67261", "19.30786", "Europe/Budapest"),("3053281", "Érd", "Эрд", "HU", "348", "", "16", "", "", "47.39489", "18.91361", "Europe/Budapest"),("3053283", "Ercsi", "", "HU", "348", "", "08", "", "", "47.25194", "18.89623", "Europe/Budapest"),("3053297", "Enying", "", "HU", "348", "", "08", "", "", "46.93046", "18.24202", "Europe/Budapest"),("3053434", "Dunavarsány", "", "HU", "348", "", "16", "", "", "47.27859", "19.06617", "Europe/Budapest"),("3053438", "Dunaújváros", "Дунауйварош", "HU", "348", "", "08", "", "", "46.96479", "18.93974", "Europe/Budapest"),("3053476", "Dunakeszi", "", "HU", "348", "", "16", "", "", "47.63641", "19.13864", "Europe/Budapest"),("3053485", "Dunaharaszti", "", "HU", "348", "", "16", "", "", "47.3545", "19.09822", "Europe/Budapest"),("3053489", "Dunaföldvár", "", "HU", "348", "", "21", "", "", "46.80799", "18.92638", "Europe/Budapest"),("3053562", "Dorog", "", "HU", "348", "", "12", "", "", "47.72095", "18.73641", "Europe/Budapest"),("3053577", "Dömsöd", "", "HU", "348", "", "16", "", "", "47.09005", "19.01106", "Europe/Budapest"),("3053590", "Dombóvár", "", "HU", "348", "", "21", "", "", "46.37657", "18.13696", "Europe/Budapest"),("3053684", "Diósd", "", "HU", "348", "", "16", "", "", "47.4095", "18.94898", "Europe/Budapest"),("3053712", "Devecser", "", "HU", "348", "", "23", "", "", "47.10316", "17.43802", "Europe/Budapest"),("3053836", "Dabas", "", "HU", "348", "", "16", "", "", "47.18594", "19.31091", "Europe/Budapest"),("3053863", "Csurgó", "", "HU", "348", "", "17", "", "", "46.25314", "17.1006", "Europe/Budapest"),("3053918", "Csorna", "", "HU", "348", "", "09", "", "", "47.61155", "17.25012", "Europe/Budapest"),("3053971", "Csömör", "", "HU", "348", "", "16", "", "", "47.55", "19.23333", "Europe/Budapest"),("3054434", "Csákvár", "", "HU", "348", "", "08", "", "", "47.39184", "18.46501", "Europe/Budapest"),("3054533", "Celldömölk", "", "HU", "348", "", "22", "", "", "47.25713", "17.15027", "Europe/Budapest"),("3054543", "Cegléd", "Цеглед", "HU", "348", "", "16", "", "", "47.17266", "19.79952", "Europe/Budapest"),("3054606", "Bugyi", "", "HU", "348", "", "16", "", "", "47.22748", "19.14664", "Europe/Budapest"),("3054643", "Budapest", "Будапешт", "HU", "348", "", "05", "", "", "47.49801", "19.03991", "Europe/Budapest"),("3054646", "Budaörs", "", "HU", "348", "", "16", "", "", "47.46181", "18.95845", "Europe/Budapest"),("3054648", "Budakeszi", "", "HU", "348", "", "16", "", "", "47.51083", "18.92717", "Europe/Budapest"),("3054693", "Aszód", "", "HU", "348", "", "16", "", "", "47.65174", "19.4785", "Europe/Budapest"),("3054809", "Bonyhád", "", "HU", "348", "", "21", "", "", "46.29921", "18.53024", "Europe/Budapest"),("3055030", "Bicske", "", "HU", "348", "", "08", "", "", "47.48419", "18.64404", "Europe/Budapest"),("3055038", "Biatorbágy", "", "HU", "348", "", "16", "", "", "47.4706", "18.81892", "Europe/Budapest"),("3055091", "Berhida", "", "HU", "348", "", "23", "", "", "47.11131", "18.12948", "Europe/Budapest"),("3055287", "Bátonyterenye", "", "HU", "348", "", "14", "", "", "47.96962", "19.84076", "Europe/Budapest"),("3055298", "Bátaszék", "", "HU", "348", "", "21", "", "", "46.19373", "18.72307", "Europe/Budapest"),("3055368", "Barcs", "", "HU", "348", "", "17", "", "", "45.96", "17.45861", "Europe/Budapest"),("3055566", "Balatonfüred", "", "HU", "348", "", "23", "", "", "46.96188", "17.87187", "Europe/Budapest"),("3055584", "Balatonboglár", "", "HU", "348", "", "17", "", "", "46.77525", "17.64415", "Europe/Budapest"),("3055590", "Balatonalmádi", "", "HU", "348", "", "23", "", "", "47.03526", "18.02076", "Europe/Budapest"),("3055601", "Balassagyarmat", "", "HU", "348", "", "14", "", "", "48.07296", "19.29614", "Europe/Budapest"),("3055685", "Baja", "Бая", "HU", "348", "", "01", "", "", "46.17496", "18.95639", "Europe/Budapest"),("3055760", "Bácsalmás", "", "HU", "348", "", "01", "", "", "46.12648", "19.3326", "Europe/Budapest"),("3056326", "Albertirsa", "", "HU", "348", "", "16", "", "", "47.24315", "19.61686", "Europe/Budapest"),("3056357", "Ajka", "Айка", "HU", "348", "", "23", "", "", "47.10196", "17.55892", "Europe/Budapest"),("3056437", "Ács", "", "HU", "348", "", "12", "", "", "47.71231", "18.01131", "Europe/Budapest"),("3338787", "Tiszaalpár", "", "HU", "348", "", "01", "", "", "46.81279", "19.99841", "Europe/Budapest"),("7284823", "Budapest XII. kerület", "", "HU", "348", "", "05", "", "", "47.49192", "19.01493", "Europe/Budapest"),("7284824", "Budapest XI. kerület", "", "HU", "348", "", "05", "", "", "47.47603", "19.03605", "Europe/Budapest"),("7284826", "Budapest VIII. kerület", "", "HU", "348", "", "05", "", "", "47.48919", "19.07012", "Europe/Budapest"),("7284828", "Budapest VI. kerület", "", "HU", "348", "", "05", "", "", "47.50369", "19.06583", "Europe/Budapest"),("7284830", "Budapest XIII. kerület", "", "HU", "348", "", "05", "", "", "47.52978", "19.08068", "Europe/Budapest"),("7284831", "Budapest IV. kerület", "", "HU", "348", "", "05", "", "", "47.56182", "19.08909", "Europe/Budapest"),("7284832", "Budapest XV. kerület", "", "HU", "348", "", "05", "", "", "47.56263", "19.11681", "Europe/Budapest"),("7284833", "Budapest XVI. kerület", "", "HU", "348", "", "05", "", "", "47.51482", "19.17028", "Europe/Budapest"),("7284834", "Budapest X. kerület", "", "HU", "348", "", "05", "", "", "47.4791", "19.15835", "Europe/Budapest"),("7284835", "Budapest XIX. kerület", "", "HU", "348", "", "05", "", "", "47.45293", "19.14943", "Europe/Budapest"),("7284836", "Budapest XVIII. kerület", "", "HU", "348", "", "05", "", "", "47.44417", "19.17595", "Europe/Budapest"),("7284837", "Budapest XXIII. kerület", "", "HU", "348", "", "05", "", "", "47.39788", "19.11492", "Europe/Budapest"),("7284838", "Budapest XXII. kerület", "", "HU", "348", "", "05", "", "", "47.42698", "19.04016", "Europe/Budapest"),("7284839", "Budapest XXI. kerület", "", "HU", "348", "", "05", "", "", "47.43047", "19.07098", "Europe/Budapest"),("7284840", "Budapest XX. kerület", "", "HU", "348", "", "05", "", "", "47.43674", "19.10093", "Europe/Budapest"),("7284841", "Budapest XVII. kerület", "", "HU", "348", "", "05", "", "", "47.47997", "19.25388", "Europe/Budapest"),("7284842", "Budapest III. kerület", "", "HU", "348", "", "05", "", "", "47.54157", "19.04501", "Europe/Budapest"),("7284843", "Budapest II. kerület", "", "HU", "348", "", "05", "", "", "47.51984", "19.02218", "Europe/Budapest"),("7284844", "Budapest I. kerület", "", "HU", "348", "", "05", "", "", "47.49705", "19.03961", "Europe/Budapest"),("7284899", "Algyő", "", "HU", "348", "", "06", "", "", "46.33472", "20.20849", "Europe/Budapest"),("7284912", "Kerepes", "", "HU", "348", "", "16", "", "", "47.56008", "19.28289", "Europe/Budapest"),("1213442", "Tongging", "", "ID", "360", "", "26", "", "", "2.8985", "98.5231", "Asia/Jakarta"),("1213443", "Tomok Bolon", "", "ID", "360", "", "26", "", "", "2.6521", "98.8608", "Asia/Jakarta"),("1213493", "Teluk Nibung", "", "ID", "360", "", "26", "", "", "3.001", "99.8164", "Asia/Jakarta"),("1213500", "Tebingtinggi", "", "ID", "360", "", "26", "", "", "3.3285", "99.1625", "Asia/Jakarta"),("1213530", "Tanjungtiram", "", "ID", "360", "", "26", "", "", "4.0613", "98.3699", "Asia/Jakarta"),("1213547", "Tanjungbalai", "", "ID", "360", "", "26", "", "", "2.96667", "99.8", "Asia/Jakarta"),("1213614", "Sunggal", "", "ID", "360", "", "26", "", "", "3.5765", "98.6151", "Asia/Jakarta"),("1213655", "Stabat", "", "ID", "360", "", "26", "1213", "", "3.73335", "98.45025", "Asia/Jakarta"),("1213713", "Singkil", "", "ID", "360", "", "01", "", "", "2.2874", "97.7884", "Asia/Jakarta"),("1213721", "Sinabang", "", "ID", "360", "", "01", "", "", "2.4803", "96.3801", "Asia/Jakarta"),("1213821", "Sigli", "", "ID", "360", "", "01", "", "", "5.3848", "95.9609", "Asia/Jakarta"),("1213855", "Sibolga", "Сиболга", "ID", "360", "", "26", "", "", "1.74016", "98.78117", "Asia/Jakarta"),("1214026", "Sabang", "", "ID", "360", "", "01", "", "", "5.88969", "95.31644", "Asia/Jakarta"),("1214055", "Reuleuet", "", "ID", "360", "", "01", "", "", "5.21667", "96.28333", "Asia/Jakarta"),("1214073", "Rantauprapat", "", "ID", "360", "", "26", "", "", "2.1", "99.83333", "Asia/Jakarta"),("1214135", "Parapat", "", "ID", "360", "", "26", "1206", "", "2.663", "98.9349", "Asia/Jakarta"),("1214189", "Percut", "", "ID", "360", "", "26", "", "", "3.6253", "98.864", "Asia/Jakarta"),("1214191", "Perbaungan", "", "ID", "360", "", "26", "", "", "3.5679", "98.956", "Asia/Jakarta"),("1214204", "Pematangsiantar", "", "ID", "360", "", "26", "", "", "2.9595", "99.0687", "Asia/Jakarta"),("1214302", "Pangkalan Brandan", "", "ID", "360", "", "26", "", "", "4.0238", "98.2782", "Asia/Jakarta"),("1214369", "Padangsidempuan", "", "ID", "360", "", "26", "", "", "1.37952", "99.27146", "Asia/Jakarta"),("1214488", "Meulaboh", "Мелабоха", "ID", "360", "", "01", "", "", "4.14402", "96.12664", "Asia/Jakarta"),("1214520", "Medan", "Медан", "ID", "360", "", "26", "", "", "3.58333", "98.66667", "Asia/Jakarta"),("1214658", "Lhokseumawe", "Локсеумаве", "ID", "360", "", "01", "", "", "5.1801", "97.1507", "Asia/Jakarta"),("1214724", "Langsa", "", "ID", "360", "", "01", "", "", "4.4683", "97.9683", "Asia/Jakarta"),("1214800", "Labuhan Deli", "", "ID", "360", "", "26", "", "", "3.7278", "98.6738", "Asia/Jakarta"),("1214882", "Kisaran", "", "ID", "360", "", "26", "", "", "2.9845", "99.6158", "Asia/Jakarta"),("1214965", "Kabanjahe", "", "ID", "360", "", "26", "", "", "3.1001", "98.4908", "Asia/Jakarta"),("1215199", "Deli Tua", "", "ID", "360", "", "26", "", "", "3.5078", "98.6839", "Asia/Jakarta"),("1215350", "Bireun", "", "ID", "360", "", "01", "", "", "5.203", "96.7009", "Asia/Jakarta"),("1215355", "Binjai", "", "ID", "360", "", "26", "", "", "3.6001", "98.4854", "Asia/Jakarta"),("1215395", "Berastagi", "", "ID", "360", "", "26", "", "", "3.19468", "98.50889", "Asia/Jakarta"),("1215412", "Belawan", "", "ID", "360", "", "26", "", "", "3.7755", "98.6832", "Asia/Jakarta"),("1215498", "Bandar", "", "ID", "360", "", "26", "", "", "2.05", "99.75", "Asia/Jakarta"),("1215502", "Banda Aceh", "Банда-Ачех", "ID", "360", "", "01", "1171", "", "5.54167", "95.33333", "Asia/Jakarta"),("1621177", "Yogyakarta", "Джокьякарта", "ID", "360", "", "10", "", "", "-7.80139", "110.36472", "Asia/Jakarta"),("1621395", "Wonosobo", "", "ID", "360", "", "07", "", "", "-7.35889", "109.90306", "Asia/Jakarta"),("1621416", "Wonopringgo", "", "ID", "360", "", "07", "", "", "-6.98333", "109.61667", "Asia/Jakarta"),("1621439", "Wongsorejo", "", "ID", "360", "", "08", "", "", "-7.9908", "114.4009", "Asia/Jakarta"),("1621520", "Wiradesa", "", "ID", "360", "", "07", "", "", "-6.8922", "109.619", "Asia/Jakarta"),("1621613", "Weru", "", "ID", "360", "", "30", "", "", "-6.711", "108.5037", "Asia/Jakarta"),("1621655", "Weleri", "", "ID", "360", "", "07", "", "", "-6.9713", "110.0666", "Asia/Jakarta"),("1621659", "Welahan", "", "ID", "360", "", "07", "", "", "-6.8", "110.71667", "Asia/Jakarta"),("1621678", "Wedi", "", "ID", "360", "", "07", "", "", "-7.74306", "110.57944", "Asia/Jakarta"),("1621884", "Watampone", "", "ID", "360", "", "38", "", "", "-4.5386", "120.3279", "Asia/Makassar"),("1622090", "Wangon", "", "ID", "360", "", "07", "", "", "-7.51611", "109.05389", "Asia/Jakarta"),("1622138", "Wanaraja", "", "ID", "360", "", "30", "", "", "-7.1749", "107.9808", "Asia/Jakarta"),("1622318", "Waingapu", "", "ID", "360", "", "18", "", "", "-9.6567", "120.2641", "Asia/Makassar"),("1622636", "Ungaran", "", "ID", "360", "", "07", "", "", "-7.13972", "110.405", "Asia/Jakarta"),("1622786", "Makassar", "Макассар", "ID", "360", "", "38", "", "", "-5.14861", "119.43194", "Asia/Makassar"),("1622846", "Ubud", "Убуд", "ID", "360", "", "02", "5104", "", "-8.5098", "115.2654", "Asia/Makassar"),("1623080", "Tulungagung", "", "ID", "360", "", "08", "", "", "-8.0657", "111.9025", "Asia/Jakarta"),("1623096", "Tulangan Utara", "", "ID", "360", "", "08", "", "", "-7.4737", "112.6505", "Asia/Jakarta"),("1623180", "Tuban", "Тубан", "ID", "360", "", "08", "", "", "-6.8976", "112.0649", "Asia/Jakarta"),("1623197", "Tual", "", "ID", "360", "", "28", "", "", "-5.6193", "132.7886", "Asia/Jayapura"),("1623223", "Trucuk", "", "ID", "360", "", "07", "", "", "-7.71833", "110.65889", "Asia/Jakarta"),("1623251", "Trenggalek", "", "ID", "360", "", "08", "", "", "-8.0764", "111.70641", "Asia/Jakarta"),("1623424", "Tondano", "", "ID", "360", "", "31", "", "", "1.3054", "124.91261", "Asia/Makassar"),("1623446", "Tomohon", "", "ID", "360", "", "31", "", "", "1.31678", "124.80379", "Asia/Makassar"),("1623651", "Tobelo", "", "ID", "360", "", "29", "", "", "1.72837", "128.00948", "Asia/Jayapura"),("1624041", "Ternate", "Тернате", "ID", "360", "", "29", "", "", "0.79065", "127.38424", "Asia/Jayapura"),("1624058", "Terbanggi Besar", "", "ID", "360", "", "15", "", "", "-4.87898", "105.21818", "Asia/Jakarta"),("1624494", "Tegal", "", "ID", "360", "", "07", "", "", "-6.8694", "109.1402", "Asia/Jakarta"),("1624545", "Tayu", "", "ID", "360", "", "07", "", "", "-6.5397", "111.0518", "Asia/Jakarta"),("1624647", "Tasikmalaya", "", "ID", "360", "", "30", "", "", "-7.3274", "108.2207", "Asia/Jakarta"),("1624668", "Tarub", "", "ID", "360", "", "07", "", "", "-6.93333", "109.16667", "Asia/Jakarta"),("1624725", "Tarakan", "Таракан", "ID", "360", "", "42", "", "", "3.31332", "117.59152", "Asia/Makassar"),("1624827", "Tanjung Selor", "", "ID", "360", "", "42", "", "", "2.8375", "117.36528", "Asia/Makassar"),("1624863", "Tanjungpinang", "", "ID", "360", "", "40", "", "", "0.91667", "104.45833", "Asia/Pontianak"),("1624877", "Tanjung Pandan", "", "ID", "360", "", "35", "", "", "-2.73353", "107.63477", "Asia/Jakarta"),("1624917", "Bandar Lampung", "", "ID", "360", "", "15", "", "", "-5.42917", "105.26111", "Asia/Jakarta"),("1624987", "Tanjungagung", "", "ID", "360", "", "32", "", "", "-3.93728", "103.80465", "Asia/Jakarta"),("1625067", "Tanggulangin", "", "ID", "360", "", "08", "", "", "-7.49958", "112.69992", "Asia/Jakarta"),("1625084", "Tangerang", "Тангеранг", "ID", "360", "", "33", "", "", "-6.17806", "106.63", "Asia/Jakarta"),("1625708", "Tabanan", "", "ID", "360", "", "02", "", "", "-8.5413", "115.12522", "Asia/Makassar"),("1625812", "Surakarta", "Суракарте", "ID", "360", "", "07", "", "", "-7.55611", "110.83167", "Asia/Jakarta"),("1625822", "Surabaya", "Сурабая", "ID", "360", "", "08", "3578", "", "-7.24917", "112.75083", "Asia/Jakarta"),("1625908", "Sungai Raya", "", "ID", "360", "", "11", "", "", "0.7", "108.9", "Asia/Pontianak"),("1625929", "Sungai Penuh", "", "ID", "360", "", "05", "", "", "-2.0561", "101.3913", "Asia/Jakarta"),("1625958", "Sungailiat", "", "ID", "360", "", "35", "", "", "-1.85442", "106.12215", "Asia/Jakarta"),("1626099", "Sumenep", "", "ID", "360", "", "08", "", "", "-7.01667", "113.86667", "Asia/Jakarta"),("1626100", "Sumedang Utara", "", "ID", "360", "", "30", "3211", "6581356", "-6.85", "107.91667", "Asia/Jakarta"),("1626103", "Sumedang", "", "ID", "360", "", "30", "3211", "", "-6.85861", "107.91639", "Asia/Jakarta"),("1626134", "Sumberpucung", "", "ID", "360", "", "08", "", "", "-8.15856", "112.48292", "Asia/Jakarta"),("1626183", "Sumber", "", "ID", "360", "", "30", "", "", "-6.76028", "108.48306", "Asia/Jakarta"),("1626185", "Sumbawa Besar", "", "ID", "360", "", "17", "Sumbawa (undefined)", "7377422", "-8.49317", "117.42024", "Asia/Makassar"),("1626312", "Sokaraja", "", "ID", "360", "", "07", "", "", "-7.45806", "109.28806", "Asia/Jakarta"),("1626381", "Sukabumi", "Сукабуми", "ID", "360", "", "30", "", "", "-6.91806", "106.92667", "Asia/Jakarta"),("1626486", "Srono", "", "ID", "360", "", "08", "", "", "-8.40003", "114.26661", "Asia/Jakarta"),("1626493", "Srandakan", "", "ID", "360", "", "10", "", "", "-7.93861", "110.25056", "Asia/Jakarta"),("1626498", "Sragen", "", "ID", "360", "", "07", "", "", "-7.42639", "111.02222", "Asia/Jakarta"),("1626542", "Sorong", "Соронг", "ID", "360", "", "39", "", "", "-0.87956", "131.26104", "Asia/Jayapura"),("1626560", "Soreang", "", "ID", "360", "", "30", "", "", "-7.03306", "107.51833", "Asia/Jakarta"),("1626649", "Solok", "", "ID", "360", "", "24", "", "", "-0.8006", "100.6571", "Asia/Jakarta"),("1626673", "Soko", "", "ID", "360", "", "08", "", "", "-7.48315", "112.42704", "Asia/Jakarta"),("1626698", "Sofifi", "", "ID", "360", "", "29", "", "", "0.73729", "127.5588", "Asia/Jayapura"),("1626703", "Soe", "Сое", "ID", "360", "", "18", "", "", "-9.86071", "124.28395", "Asia/Makassar"),("1626754", "Sleman", "", "ID", "360", "", "10", "", "", "-7.71556", "110.35556", "Asia/Jakarta"),("1626758", "Slawi", "", "ID", "360", "", "07", "", "", "-6.9816", "109.1407", "Asia/Jakarta"),("1626801", "Situbondo", "", "ID", "360", "", "08", "", "", "-7.70623", "114.00976", "Asia/Jakarta"),("1626895", "Sinjai", "", "ID", "360", "", "38", "", "", "-5.1241", "120.253", "Asia/Makassar"),("1626899", "Singosari", "Сингосари", "ID", "360", "", "08", "", "", "-7.8924", "112.6658", "Asia/Jakarta"),("1626903", "Singojuruh", "", "ID", "360", "", "08", "", "", "-8.31667", "114.23333", "Asia/Jakarta"),("1626916", "Singkawang", "", "ID", "360", "", "11", "", "", "0.90925", "108.98463", "Asia/Pontianak"),("1626921", "Sengkang", "", "ID", "360", "", "38", "", "", "-4.1279", "120.0297", "Asia/Makassar"),("1626932", "Singaraja", "Сингараджа", "ID", "360", "", "02", "", "", "-8.112", "115.08818", "Asia/Makassar"),("1626936", "Singaparna", "", "ID", "360", "", "30", "", "", "-7.3515", "108.111", "Asia/Jakarta"),("1627035", "Simpang", "", "ID", "360", "", "05", "", "", "-1.26424", "104.09701", "Asia/Jakarta"),("1627185", "Sijunjung", "", "ID", "360", "", "24", "", "", "-0.7005", "100.9774", "Asia/Jakarta"),("1627253", "Sidoarjo", "", "ID", "360", "", "08", "", "", "-7.4478", "112.7183", "Asia/Jakarta"),("1627267", "Sidareja", "", "ID", "360", "", "07", "", "", "-7.4846", "108.7923", "Asia/Jakarta"),("1627357", "Sewon", "", "ID", "360", "", "10", "", "", "-7.87639", "110.35889", "Asia/Jakarta"),("1627459", "Serpong", "", "ID", "360", "", "30", "", "", "-6.31694", "106.66417", "Asia/Jakarta"),("1627549", "Serang", "", "ID", "360", "", "33", "", "", "-6.11528", "106.15417", "Asia/Jakarta"),("1627610", "Sepatan", "", "ID", "360", "", "30", "", "", "-6.11889", "106.575", "Asia/Jakarta"),("1627877", "Sembakung", "", "ID", "360", "", "14", "", "", "3.81667", "117.25", "Asia/Makassar"),("1627896", "Semarang", "Семаранг", "ID", "360", "", "07", "", "", "-6.99306", "110.42083", "Asia/Jakarta"),("1627969", "Selogiri", "", "ID", "360", "", "07", "", "", "-7.78333", "110.86667", "Asia/Jakarta"),("1628453", "Sawangan", "", "ID", "360", "", "30", "", "", "-6.40278", "106.77444", "Asia/Jakarta"),("1628884", "Sampit", "", "ID", "360", "", "13", "", "", "-2.5315", "112.9496", "Asia/Pontianak"),("1628899", "Sampang", "", "ID", "360", "", "08", "", "", "-7.1872", "113.2394", "Asia/Jakarta"),("1629001", "Samarinda", "Самаринда", "ID", "360", "", "14", "", "", "-0.49167", "117.14583", "Asia/Makassar"),("1629131", "Salatiga", "", "ID", "360", "", "07", "", "", "-7.33194", "110.49278", "Asia/Jakarta"),("1629380", "Ruteng", "", "ID", "360", "", "18", "", "", "-8.61139", "120.46444", "Asia/Makassar"),("1629710", "Rengasdengklok", "", "ID", "360", "", "30", "", "", "-6.15917", "107.29806", "Asia/Jakarta"),("1629749", "Rembangan", "", "ID", "360", "", "07", "", "", "-6.7036", "111.3416", "Asia/Jakarta"),("1629974", "Rantepao", "", "ID", "360", "", "38", "", "", "-2.9701", "119.8978", "Asia/Makassar"),("1630058", "Rangkasbitung", "", "ID", "360", "", "33", "", "", "-6.3591", "106.2494", "Asia/Jakarta"),("1630088", "Randudongkal", "", "ID", "360", "", "07", "", "", "-7.0981", "109.3243", "Asia/Jakarta"),("1630200", "Rajapolah", "", "ID", "360", "", "30", "", "", "-7.221", "108.1896", "Asia/Jakarta"),("1630328", "Purwokerto", "", "ID", "360", "", "07", "", "", "-7.42139", "109.23444", "Asia/Jakarta"),("1630333", "Purwodadi", "", "ID", "360", "", "07", "", "", "-7.0868", "110.9158", "Asia/Jakarta"),("1630341", "Purwakarta", "", "ID", "360", "", "30", "", "", "-6.55694", "107.44333", "Asia/Jakarta"),("1630366", "Purbalingga", "", "ID", "360", "", "07", "", "", "-7.38806", "109.36389", "Asia/Jakarta"),("1630416", "Pundong", "", "ID", "360", "", "10", "", "", "-7.95222", "110.34861", "Asia/Jakarta"),("1630634", "Probolinggo", "", "ID", "360", "", "08", "", "", "-7.7543", "113.2159", "Asia/Jakarta"),("1630649", "Prigen", "", "ID", "360", "", "08", "", "", "-7.68333", "112.61667", "Asia/Jakarta"),("1630662", "Praya", "Прая", "ID", "360", "", "17", "Lombok (undefined)", "", "-8.70536", "116.27036", "Asia/Makassar"),("1630681", "Candi Prambanan", "", "ID", "360", "", "07", "", "", "-7.75", "110.49417", "Asia/Jakarta"),("1630723", "Poso", "Посо", "ID", "360", "", "21", "", "", "-1.3959", "120.7524", "Asia/Makassar"),("1630789", "Pontianak", "Понтианак", "ID", "360", "", "11", "", "", "-0.03194", "109.325", "Asia/Pontianak"),("1630798", "Ponorogo", "", "ID", "360", "", "08", "", "", "-7.8685", "111.462", "Asia/Jakarta"),("1630935", "Polewali", "", "ID", "360", "", "41", "", "", "-3.4324", "119.3435", "Asia/Makassar"),("1630997", "Plumbon", "", "ID", "360", "", "30", "", "", "-6.705", "108.47278", "Asia/Jakarta"),("1631271", "Petarukan", "", "ID", "360", "", "07", "", "", "-6.88333", "109.43333", "Asia/Jakarta"),("1631393", "Prabumulih", "", "ID", "360", "", "32", "", "", "-3.43447", "104.23056", "Asia/Jakarta"),("1631637", "Pemangkat", "", "ID", "360", "", "11", "", "", "1.16667", "108.96667", "Asia/Pontianak"),("1631648", "Pemalang", "", "ID", "360", "", "07", "", "", "-6.9", "109.36667", "Asia/Jakarta"),("1631733", "Pelabuhanratu", "", "ID", "360", "", "30", "", "", "-6.9875", "106.55139", "Asia/Jakarta"),("1631761", "Pekanbaru", "Пеканбару", "ID", "360", "", "37", "", "", "0.51667", "101.44167", "Asia/Jakarta"),("1631766", "Pekalongan", "", "ID", "360", "", "07", "", "", "-6.8886", "109.6753", "Asia/Jakarta"),("1631851", "Pecangaan", "", "ID", "360", "", "07", "", "", "-6.6978", "110.7107", "Asia/Jakarta"),("1631905", "Payakumbuh", "", "ID", "360", "", "24", "", "", "-0.2159", "100.6334", "Asia/Jakarta"),("1631992", "Pati", "Пати", "ID", "360", "", "07", "", "", "-6.7559", "111.038", "Asia/Jakarta"),("1632033", "Pasuruan", "", "ID", "360", "", "08", "", "", "-7.6453", "112.9075", "Asia/Jakarta"),("1632197", "Paseh", "", "ID", "360", "", "30", "", "", "-7.1026", "107.7641", "Asia/Jakarta"),("1632228", "Pasarkemis", "", "ID", "360", "", "30", "", "", "-6.17028", "106.53028", "Asia/Jakarta"),("1632276", "Parung", "", "ID", "360", "", "30", "", "", "-6.42139", "106.73306", "Asia/Jakarta"),("1632334", "Pariaman", "", "ID", "360", "", "24", "", "", "-0.61898", "100.11997", "Asia/Jakarta"),("1632353", "Parepare", "", "ID", "360", "", "38", "", "", "-4.0135", "119.6255", "Asia/Makassar"),("1632358", "Pare", "", "ID", "360", "", "08", "", "", "-7.7679", "112.198", "Asia/Jakarta"),("1632566", "Panji", "", "ID", "360", "", "08", "", "", "-7.72528", "114.09954", "Asia/Jakarta"),("1632654", "Pangkalpinang", "", "ID", "360", "", "35", "", "", "-2.12914", "106.11377", "Asia/Jakarta"),("1632694", "Pangkalanbuun", "", "ID", "360", "", "13", "", "", "-2.6832", "111.6259", "Asia/Pontianak"),("1632823", "Pandeglang", "", "ID", "360", "", "33", "", "", "-6.3084", "106.1067", "Asia/Jakarta"),("1632859", "Pandaan", "", "ID", "360", "", "08", "", "", "-7.65268", "112.6875", "Asia/Jakarta"),("1632861", "Pandak", "", "ID", "360", "", "10", "", "", "-7.91306", "110.29361", "Asia/Jakarta"),("1632903", "Panarukan", "", "ID", "360", "", "08", "", "", "-7.70181", "113.91844", "Asia/Jakarta"),("1632937", "Pamulang", "", "ID", "360", "", "30", "", "", "-6.34278", "106.73833", "Asia/Jakarta"),("1632974", "Pameungpeuk", "", "ID", "360", "", "30", "", "", "-7.01833", "107.60389", "Asia/Jakarta"),("1632978", "Pamekasan", "", "ID", "360", "", "08", "", "", "-7.1568", "113.4746", "Asia/Jakarta"),("1632998", "Pamanukan", "", "ID", "360", "", "30", "", "", "-6.28417", "107.81056", "Asia/Jakarta"),("1633034", "Palu", "Пал", "ID", "360", "", "21", "", "", "-0.90833", "119.87083", "Asia/Makassar"),("1633037", "Palopo", "", "ID", "360", "", "38", "", "", "-2.9925", "120.19694", "Asia/Makassar"),("1633056", "Palimanan", "", "ID", "360", "", "30", "", "", "-6.70694", "108.42417", "Asia/Jakarta"),("1633070", "Palembang", "Палембанг", "ID", "360", "", "32", "", "", "-2.91673", "104.7458", "Asia/Jakarta"),("1633118", "Palangkaraya", "", "ID", "360", "", "13", "", "", "-2.20833", "113.91667", "Asia/Pontianak"),("1633182", "Pakisaji", "", "ID", "360", "", "08", "", "", "-8.0665", "112.5981", "Asia/Jakarta"),("1633308", "Pagar Alam", "", "ID", "360", "", "32", "1604", "", "-4.02506", "103.24694", "Asia/Jakarta"),("1633419", "Padang", "Паданг", "ID", "360", "", "24", "", "", "-0.94924", "100.35427", "Asia/Jakarta"),("1633442", "Paciran", "", "ID", "360", "", "08", "", "", "-6.87666", "112.37606", "Asia/Jakarta"),("1633986", "Ngunut", "", "ID", "360", "", "08", "", "", "-8.1058", "112.01591", "Asia/Jakarta"),("1634010", "Ngoro", "", "ID", "360", "", "08", "", "", "-7.68386", "112.25804", "Asia/Jakarta"),("1634098", "Ngawi", "", "ID", "360", "", "30", "", "", "-7.4038", "111.4461", "Asia/Jakarta"),("1634131", "Nganjuk", "", "ID", "360", "", "08", "", "", "-7.6051", "111.9035", "Asia/Jakarta"),("1634266", "Negara", "", "ID", "360", "", "02", "", "", "-8.35694", "114.61694", "Asia/Makassar"),("1634614", "Nabire", "", "ID", "360", "", "36", "", "", "-3.35989", "135.50074", "Asia/Jayapura"),("1634678", "Muntok", "", "ID", "360", "", "35", "", "", "-2.06719", "105.16228", "Asia/Jakarta"),("1634680", "Muntilan", "", "ID", "360", "", "07", "", "", "-7.58111", "110.29278", "Asia/Jakarta"),("1634710", "Munduk", "", "ID", "360", "", "02", "", "", "-8.26866", "115.07947", "Asia/Makassar"),("1634718", "Muncar", "", "ID", "360", "", "08", "", "", "-8.43333", "114.33333", "Asia/Jakarta"),("1634954", "Mranggen", "", "ID", "360", "", "07", "", "", "-7.0268", "110.5158", "Asia/Jakarta"),("1635111", "Mojokerto", "", "ID", "360", "", "08", "", "", "-7.4664", "112.4338", "Asia/Jakarta"),("1635116", "Mojoagung", "", "ID", "360", "", "08", "", "", "-7.56667", "112.35", "Asia/Jakarta"),("1635164", "Mlonggo", "", "ID", "360", "", "07", "", "", "-6.53333", "110.7", "Asia/Jakarta"),("1635283", "Metro", "Метро", "ID", "360", "", "15", "", "", "-5.11306", "105.30667", "Asia/Jakarta"),("1635342", "Mertoyudan", "", "ID", "360", "", "07", "", "", "-7.52", "110.22639", "Asia/Jakarta"),("1635660", "Melati", "", "ID", "360", "", "10", "", "", "-7.73333", "110.36667", "Asia/Jakarta"),("1635815", "Maumere", "", "ID", "360", "", "18", "", "", "-8.6199", "122.2111", "Asia/Makassar"),("1635882", "Mataram", "Матарам", "ID", "360", "", "17", "Lombok (undefined)", "", "-8.58333", "116.11667", "Asia/Makassar"),("1636022", "Martapura", "", "ID", "360", "", "12", "", "", "-3.4109", "114.8642", "Asia/Makassar"),("1636029", "Maros", "", "ID", "360", "", "38", "", "", "-5.006", "119.5727", "Asia/Makassar"),("1636121", "Margasari", "", "ID", "360", "", "07", "", "", "-7.1", "109.01667", "Asia/Jakarta"),("1636125", "Margahayukencana", "", "ID", "360", "", "30", "", "", "-6.97083", "107.5675", "Asia/Jakarta"),("1636308", "Manokwari", "Маноквари", "ID", "360", "", "39", "9105", "", "-0.86291", "134.06402", "Asia/Jayapura"),("1636322", "Manismata", "", "ID", "360", "", "11", "", "", "-2.46667", "111.03333", "Asia/Pontianak"),("1636426", "Manggar", "", "ID", "360", "", "35", "", "", "-2.88333", "108.26667", "Asia/Jakarta"),("1636507", "Mendaha", "", "ID", "360", "", "05", "", "", "-1.0163", "103.59331", "Asia/Jakarta"),("1636544", "Manado", "Манадо", "ID", "360", "", "31", "", "", "1.48218", "124.84892", "Asia/Makassar"),("1636556", "Mamuju", "", "ID", "360", "", "41", "", "", "-2.68056", "118.88611", "Asia/Makassar"),("1636722", "Malang", "Маланг", "ID", "360", "", "08", "", "", "-7.9797", "112.6304", "Asia/Jakarta"),("1636806", "Majene", "", "ID", "360", "", "41", "", "", "-3.5403", "118.9707", "Asia/Makassar"),("1636808", "Majenang", "", "ID", "360", "", "07", "", "", "-7.2975", "108.7642", "Asia/Jakarta"),("1636816", "Majalengka", "", "ID", "360", "", "30", "", "", "-6.83611", "108.22778", "Asia/Jakarta"),("1636884", "Magelang", "Магеланг", "ID", "360", "", "07", "", "", "-7.47056", "110.21778", "Asia/Jakarta"),("1636930", "Madiun", "", "ID", "360", "", "08", "", "", "-7.6298", "111.5239", "Asia/Jakarta"),("1637001", "Luwuk", "", "ID", "360", "", "21", "7202", "", "-0.9516", "122.7875", "Asia/Makassar"),("1637090", "Lumajang", "", "ID", "360", "", "08", "", "", "-8.1335", "113.2248", "Asia/Jakarta"),("1637158", "Lubuklinggau", "", "ID", "360", "", "32", "", "", "-3.2945", "102.8614", "Asia/Jakarta"),("1637372", "Labuan Lombok", "", "ID", "360", "", "17", "", "", "-8.5", "116.66667", "Asia/Makassar"),("1637510", "Loa Janan", "", "ID", "360", "", "14", "", "", "-0.58295", "117.09503", "Asia/Makassar"),("1638059", "Lembar", "", "ID", "360", "", "17", "", "", "-8.7264", "116.0744", "Asia/Makassar"),("1638063", "Lembang", "Лембанге", "ID", "360", "", "30", "", "", "-6.81167", "107.6175", "Asia/Jakarta"),("1638217", "Lebaksiu", "", "ID", "360", "", "07", "", "", "-7.0496", "109.1441", "Asia/Jakarta"),("1638284", "Lawang", "", "ID", "360", "", "08", "", "", "-7.8353", "112.6947", "Asia/Jakarta"),("1638352", "Lasem", "", "ID", "360", "", "07", "", "", "-6.6922", "111.4527", "Asia/Jakarta"),("1638562", "Lamongan", "", "ID", "360", "", "08", "", "", "-7.11667", "112.41667", "Asia/Jakarta"),("1638754", "Laikit, Laikit II (Dimembe)", "", "ID", "360", "ID", "31", "", "", "1.48833", "124.97444", "Asia/Makassar"),("1638775", "Lahat", "", "ID", "360", "", "32", "1604", "", "-3.78514", "103.54279", "Asia/Jakarta"),("1638868", "Labuan Bajo", "Лабуанбаджо", "ID", "360", "", "18", "", "", "-8.4964", "119.8877", "Asia/Makassar"),("1638870", "Labuan", "", "ID", "360", "", "33", "", "", "-6.3784", "105.83", "Asia/Jakarta"),("1638981", "Kutoarjo", "", "ID", "360", "", "07", "", "", "-7.71694", "109.91278", "Asia/Jakarta"),("1639002", "Kuta", "Кута", "ID", "360", "", "02", "", "", "-8.72332", "115.17234", "Asia/Makassar"),("1639094", "Kuningan", "", "ID", "360", "", "30", "", "", "-6.97583", "108.48306", "Asia/Jakarta"),("1639215", "Kudus", "", "ID", "360", "", "07", "", "", "-6.8048", "110.8405", "Asia/Jakarta"),("1639286", "Kuala Tungkal", "", "ID", "360", "", "05", "", "", "-0.81623", "103.46111", "Asia/Jakarta"),("1639304", "Kualakapuas", "", "ID", "360", "", "13", "", "", "-3.00913", "114.38759", "Asia/Pontianak"),("1639337", "Kroya", "", "ID", "360", "", "07", "", "", "-7.63306", "109.24611", "Asia/Jakarta"),("1639356", "Krian", "", "ID", "360", "", "08", "", "", "-7.4104", "112.5792", "Asia/Jakarta"),("1639362", "Kresek", "", "ID", "360", "", "30", "", "", "-6.13139", "106.37972", "Asia/Jakarta"),("1639431", "Kraksaan", "", "ID", "360", "", "08", "", "", "-7.75845", "113.39624", "Asia/Jakarta"),("1639524", "Kotabumi", "", "ID", "360", "", "15", "", "", "-4.82505", "104.8817", "Asia/Jakarta"),("1639850", "Klungkung", "", "ID", "360", "", "02", "", "", "-8.53333", "115.4", "Asia/Makassar"),("1639900", "Klaten", "", "ID", "360", "", "07", "", "", "-7.70583", "110.60639", "Asia/Jakarta"),("1639925", "Klangenan", "", "ID", "360", "", "30", "", "", "-6.70944", "108.44", "Asia/Jakarta"),("1640044", "Kijang", "", "ID", "360", "", "40", "", "", "0.9", "104.63333", "Asia/Jakarta"),("1640138", "Ketanggungan", "", "ID", "360", "", "07", "", "", "-6.9383", "108.891", "Asia/Jakarta"),("1640185", "Kertosono", "", "ID", "360", "", "08", "", "", "-7.58333", "112.1", "Asia/Jakarta"),("1640296", "Kepanjen", "", "ID", "360", "", "08", "", "", "-8.1303", "112.5727", "Asia/Jakarta"),("1640344", "Kendari", "Кендари", "ID", "360", "", "22", "", "", "-3.9778", "122.51507", "Asia/Makassar"),("1640354", "Kencong", "", "ID", "360", "", "08", "", "", "-8.28333", "113.36667", "Asia/Jakarta"),("1640576", "Kefamenanu", "", "ID", "360", "", "18", "", "", "-9.44667", "124.47806", "Asia/Makassar"),("1640581", "Kedungwuni", "", "ID", "360", "", "07", "", "", "-6.97038", "109.64794", "Asia/Jakarta"),("1640585", "Kedungwaru", "", "ID", "360", "", "08", "", "", "-8.06667", "111.91667", "Asia/Jakarta"),("1640660", "Kediri", "", "ID", "360", "", "08", "", "", "-7.81667", "112.01667", "Asia/Jakarta"),("1640755", "Kebonarun", "", "ID", "360", "", "07", "", "", "-7.70028", "110.56306", "Asia/Jakarta"),("1640765", "Kebomas", "", "ID", "360", "", "08", "", "", "-7.16667", "112.6333", "Asia/Jakarta"),("1640902", "Kawalu", "", "ID", "360", "", "30", "", "", "-7.3817", "108.2082", "Asia/Jakarta"),("1640972", "Katabu", "", "ID", "360", "", "22", "", "", "-4.9333", "122.5167", "Asia/Makassar"),("1641184", "Karangsembung", "", "ID", "360", "", "30", "", "", "-6.8487", "108.6422", "Asia/Jakarta"),("1641301", "Karangasem", "Денпасар", "ID", "360", "", "02", "", "", "-8.45", "115.61667", "Asia/Makassar"),("1641333", "Karanganom", "", "ID", "360", "", "07", "", "", "-7.64889", "110.625", "Asia/Jakarta"),("1641342", "Karangampel", "", "ID", "360", "", "30", "", "", "-6.46222", "108.45194", "Asia/Jakarta"),("1641792", "Kamal", "Камаль", "ID", "360", "", "08", "", "", "-7.16778", "112.71917", "Asia/Jakarta"),("1641977", "Kalianget", "", "ID", "360", "", "08", "", "", "-7.0537", "113.94244", "Asia/Jakarta"),("1642317", "Juwana", "", "ID", "360", "", "07", "", "", "-6.715", "111.1514", "Asia/Jakarta"),("1642414", "Jombang", "", "ID", "360", "", "08", "", "", "-7.54595", "112.23307", "Asia/Jakarta"),("1642437", "Jogonalan", "", "ID", "360", "", "07", "", "", "-7.70361", "110.53611", "Asia/Jakarta"),("1642588", "Jember", "", "ID", "360", "", "08", "", "", "-8.17211", "113.69953", "Asia/Jakarta"),("1642628", "Jekulo", "", "ID", "360", "", "07", "", "", "-6.8057", "110.9262", "Asia/Jakarta"),("1642684", "Jatiwangi", "", "ID", "360", "", "30", "", "", "-6.73361", "108.26278", "Asia/Jakarta"),("1642692", "Jatiroto", "", "ID", "360", "", "07", "", "", "-7.88333", "111.11667", "Asia/Jakarta"),("1642726", "Jatibarang", "", "ID", "360", "", "30", "", "", "-6.47472", "108.31528", "Asia/Jakarta");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("1642754", "Jaten", "", "ID", "360", "", "07", "", "", "-7.57722", "110.8975", "Asia/Jakarta"),("1642858", "Jambi City", "Джамби", "ID", "360", "", "05", "", "", "-1.6", "103.61667", "Asia/Jakarta"),("1642911", "Jakarta", "Джакарта", "ID", "360", "", "04", "", "", "-6.21462", "106.84513", "Asia/Jakarta"),("1643078", "Indramayu", "", "ID", "360", "", "30", "", "", "-6.32639", "108.32", "Asia/Jakarta"),("1643761", "Grogol", "", "ID", "360", "", "07", "", "", "-7.60111", "110.81861", "Asia/Jakarta"),("1643776", "Gresik", "", "ID", "360", "", "08", "", "", "-7.15389", "112.65611", "Asia/Jakarta"),("1643837", "Gorontalo", "Горонтало", "ID", "360", "", "34", "", "", "0.5375", "123.0625", "Asia/Makassar"),("1643898", "Gongdanglegi Kulon", "", "ID", "360", "", "08", "", "", "-8.17529", "112.63594", "Asia/Jakarta"),("1643920", "Gombong", "", "ID", "360", "", "07", "", "", "-7.60722", "109.51417", "Asia/Jakarta"),("1643981", "Godean", "", "ID", "360", "", "10", "", "", "-7.76972", "110.29389", "Asia/Jakarta"),("1644178", "Genteng", "", "ID", "360", "", "08", "", "", "-8.36667", "114.15", "Asia/Jakarta"),("1644349", "Gedangan", "", "ID", "360", "", "08", "", "", "-7.39083", "112.72667", "Asia/Jakarta"),("1644360", "Gebog", "", "ID", "360", "", "07", "", "", "-6.735", "110.8444", "Asia/Jakarta"),("1644522", "Gampengrejo", "", "ID", "360", "", "08", "", "", "-7.76667", "112.01667", "Asia/Jakarta"),("1644557", "Gambiran Satu", "", "ID", "360", "", "08", "", "", "-8.3939", "114.1464", "Asia/Jakarta"),("1644605", "Galesong", "", "ID", "360", "", "38", "", "", "-5.3166", "119.3661", "Asia/Makassar"),("1644932", "Ende", "", "ID", "360", "", "18", "", "", "-8.8432", "121.6623", "Asia/Makassar"),("1645133", "Dumai", "Думай", "ID", "360", "", "37", "", "", "1.66711", "101.44316", "Asia/Jakarta"),("1645154", "Dukuhturi", "", "ID", "360", "", "07", "", "", "-6.9", "109.08333", "Asia/Jakarta"),("1645220", "Driyorejo", "", "ID", "360", "", "08", "", "", "-7.3659", "112.6219", "Asia/Jakarta"),("1645343", "Dompu", "", "ID", "360", "", "17", "5205", "", "-8.5365", "118.4634", "Asia/Makassar"),("1645428", "Diwek", "", "ID", "360", "", "08", "", "", "-7.57897", "112.23109", "Asia/Jakarta"),("1645518", "Depok", "", "ID", "360", "", "10", "", "", "-7.7625", "110.43167", "Asia/Jakarta"),("1645524", "Depok", "", "ID", "360", "", "30", "", "", "-6.4", "106.81861", "Asia/Jakarta"),("1645528", "Denpasar", "Денпасар", "ID", "360", "", "02", "", "", "-8.65", "115.21667", "Asia/Makassar"),("1645559", "Demak", "Демак", "ID", "360", "", "07", "", "", "-6.8909", "110.6396", "Asia/Jakarta"),("1645565", "Delanggu", "", "ID", "360", "", "07", "", "", "-7.61667", "110.68333", "Asia/Jakarta"),("1645749", "Dampit", "", "ID", "360", "", "08", "", "", "-8.21162", "112.74934", "Asia/Jakarta"),("1645875", "Curup", "", "ID", "360", "", "03", "", "", "-3.4703", "102.5207", "Asia/Jakarta"),("1645895", "Curug", "", "ID", "360", "", "33", "", "", "-6.26583", "106.55639", "Asia/Jakarta"),("1645976", "Comal", "", "ID", "360", "", "07", "", "", "-6.9053", "109.5347", "Asia/Jakarta"),("1645978", "Colomadu", "", "ID", "360", "", "07", "", "", "-7.53333", "110.75", "Asia/Jakarta"),("1646034", "Citeureup", "", "ID", "360", "", "30", "", "", "-6.48556", "106.88194", "Asia/Jakarta"),("1646170", "Cirebon", "Чиребон", "ID", "360", "", "30", "", "", "-6.7063", "108.557", "Asia/Jakarta"),("1646194", "Ciputat", "", "ID", "360", "", "30", "", "", "-6.2375", "106.69556", "Asia/Jakarta"),("1646448", "Cimahi", "", "ID", "360", "", "30", "", "", "-6.87222", "107.5425", "Asia/Jakarta"),("1646492", "Cileunyi", "", "ID", "360", "", "30", "", "", "-6.93889", "107.75278", "Asia/Jakarta"),("1646494", "Cileungsir", "", "ID", "360", "", "30", "", "", "-6.39472", "106.95917", "Asia/Jakarta"),("1646678", "Cikarang", "", "ID", "360", "", "30", "", "", "-6.26111", "107.15278", "Asia/Jakarta"),("1646698", "Cikampek", "", "ID", "360", "", "30", "", "", "-6.41972", "107.45583", "Asia/Jakarta"),("1646893", "Cicurug", "", "ID", "360", "", "30", "", "", "-6.78139", "106.7825", "Asia/Jakarta"),("1647003", "Cibinong", "Сибинонге", "ID", "360", "", "30", "", "", "-6.48167", "106.85417", "Asia/Jakarta"),("1647149", "Ciamis", "", "ID", "360", "", "30", "", "", "-7.3257", "108.3534", "Asia/Jakarta"),("1647179", "Cepu", "", "ID", "360", "", "07", "", "", "-7.1475", "111.5906", "Asia/Jakarta"),("1647187", "Ceper", "", "ID", "360", "", "07", "", "", "-7.67417", "110.67889", "Asia/Jakarta"),("1647298", "Caringin", "", "ID", "360", "", "30", "", "", "-6.70611", "106.82139", "Asia/Jakarta"),("1647383", "Ciampea", "", "ID", "360", "", "30", "", "", "-6.55472", "106.70083", "Asia/Jakarta"),("1647834", "Bulakamba", "", "ID", "360", "", "07", "", "", "-6.8748", "108.9559", "Asia/Jakarta"),("1647866", "Bukittinggi", "", "ID", "360", "", "24", "", "", "-0.30907", "100.37055", "Asia/Jakarta"),("1647936", "Buduran", "", "ID", "360", "", "08", "", "", "-7.4281", "112.7234", "Asia/Jakarta"),("1647991", "Buaran", "", "ID", "360", "", "07", "", "", "-7.05", "109.55", "Asia/Jakarta"),("1648082", "Boyolangu", "", "ID", "360", "", "08", "", "", "-8.1181", "111.8935", "Asia/Jakarta"),("1648084", "Boyolali", "", "ID", "360", "", "07", "", "", "-7.53306", "110.59583", "Asia/Jakarta"),("1648186", "Bontang", "", "ID", "360", "", "14", "", "", "0.1324", "117.4854", "Asia/Makassar"),("1648266", "Bondowoso", "", "ID", "360", "", "08", "", "", "-7.91346", "113.82145", "Asia/Jakarta"),("1648451", "Bojonegoro", "", "ID", "360", "", "08", "", "", "-7.1502", "111.8817", "Asia/Jakarta"),("1648473", "Bogor", "Богор", "ID", "360", "", "30", "", "", "-6.59444", "106.78917", "Asia/Jakarta"),("1648568", "Blora", "", "ID", "360", "", "07", "", "", "-6.9698", "111.4186", "Asia/Jakarta"),("1648580", "Blitar", "", "ID", "360", "", "08", "", "", "-8.0983", "112.1681", "Asia/Jakarta"),("1648636", "Bitung", "", "ID", "360", "", "31", "", "", "1.45697", "125.1895", "Asia/Makassar"),("1648759", "Bima", "Бим", "ID", "360", "", "17", "Bima City (undefined)", "", "-8.46006", "118.72667", "Asia/Makassar"),("1648918", "Besuki", "", "ID", "360", "", "08", "", "", "-7.73379", "113.69785", "Asia/Jakarta"),("1649150", "Bengkulu", "Бенгкулу", "ID", "360", "", "03", "", "", "-3.80044", "102.26554", "Asia/Jakarta"),("1649378", "Bekasi", "Бекаси", "ID", "360", "", "30", "", "", "-6.2349", "106.9896", "Asia/Jakarta"),("1649383", "Bejubang Dua", "", "ID", "360", "", "05", "", "", "-1.7923", "103.3167", "Asia/Jakarta"),("1649593", "Baturaja", "", "ID", "360", "", "32", "", "", "-4.12891", "104.16695", "Asia/Jakarta"),("1649595", "Baturaden", "", "ID", "360", "", "07", "", "", "-7.3", "109.21667", "Asia/Jakarta"),("1649824", "Batu", "Батый", "ID", "360", "", "08", "", "", "-7.87", "112.52833", "Asia/Jakarta"),("1649881", "Batang", "", "ID", "360", "", "07", "", "", "-6.4846", "110.7083", "Asia/Jakarta"),("1650064", "Barabai", "", "ID", "360", "", "12", "", "", "-2.58333", "115.38333", "Asia/Makassar"),("1650077", "Banyuwangi", "", "ID", "360", "", "08", "", "", "-8.2325", "114.35755", "Asia/Jakarta"),("1650095", "Banyumas", "", "ID", "360", "", "07", "", "", "-7.51417", "109.29417", "Asia/Jakarta"),("1650119", "Bantul", "", "ID", "360", "", "10", "", "", "-7.88806", "110.32889", "Asia/Jakarta"),("1650213", "Banjarmasin", "", "ID", "360", "", "12", "", "", "-3.31987", "114.59075", "Asia/Makassar"),("1650227", "Banjaran", "", "ID", "360", "", "30", "", "", "-7.04528", "107.58778", "Asia/Jakarta"),("1650232", "Banjar", "", "ID", "360", "", "02", "", "", "-8.19", "114.9675", "Asia/Makassar"),("1650234", "Banjar", "", "ID", "360", "", "30", "", "", "-7.1955", "107.4313", "Asia/Jakarta"),("1650298", "Bangkalan", "", "ID", "360", "", "08", "", "", "-7.0455", "112.7351", "Asia/Jakarta"),("1650319", "Bangil", "", "ID", "360", "", "08", "", "", "-7.59939", "112.8186", "Asia/Jakarta"),("1650357", "Bandung", "Бандунг", "ID", "360", "", "30", "", "", "-6.92222", "107.60694", "Asia/Jakarta"),("1650434", "Bambanglipuro", "", "ID", "360", "", "10", "", "", "-7.95", "110.28333", "Asia/Jakarta"),("1650460", "Balung", "", "ID", "360", "", "08", "", "", "-7.73333", "113.91667", "Asia/Jakarta"),("1650527", "Balikpapan", "Баликпапан", "ID", "360", "", "14", "", "", "-1.26753", "116.82887", "Asia/Makassar"),("1650572", "Balapulang", "", "ID", "360", "", "07", "", "", "-7.05", "109.08333", "Asia/Jakarta"),("1650600", "Balaipungut", "", "ID", "360", "", "37", "", "", "1.05949", "101.29054", "Asia/Jakarta"),("1650670", "Baki", "", "ID", "360", "", "07", "", "", "-7.61278", "110.78389", "Asia/Jakarta"),("1650815", "Baekrajan", "Бэ", "ID", "360", "", "07", "", "", "-6.7674", "110.8541", "Asia/Jakarta"),("1650888", "Babat", "Бабат", "ID", "360", "", "08", "", "", "-7.11282", "112.16354", "Asia/Jakarta"),("1651103", "Atambua", "Атамбуа", "ID", "360", "", "18", "", "", "-9.10611", "124.8925", "Asia/Makassar"),("1651112", "Astanajapura", "", "ID", "360", "", "30", "", "", "-6.8017", "108.6311", "Asia/Jakarta"),("1651226", "Arjawinangun", "", "ID", "360", "", "30", "", "", "-6.64528", "108.41028", "Asia/Jakarta"),("1651461", "Amuntai", "", "ID", "360", "", "12", "", "", "-2.41773", "115.24941", "Asia/Makassar"),("1651531", "Ambon", "Амбон", "ID", "360", "", "28", "", "", "-3.69583", "128.18333", "Asia/Jayapura"),("1651555", "Ambarawa", "", "ID", "360", "", "07", "", "", "-7.26333", "110.3975", "Asia/Jakarta"),("1651591", "Amahai", "", "ID", "360", "", "28", "", "", "-3.33984", "128.91975", "Asia/Jayapura"),("1651887", "Adiwerna", "", "ID", "360", "", "07", "", "", "-6.9375", "109.1325", "Asia/Jakarta"),("1963770", "Padalarang", "", "ID", "360", "", "30", "", "", "-6.83778", "107.47278", "Asia/Jakarta"),("1964032", "Ciranjang-hilir", "", "ID", "360", "", "30", "", "", "-6.82", "107.25722", "Asia/Jakarta"),("1985663", "Cikupa", "", "ID", "360", "", "30", "", "", "-6.23639", "106.50833", "Asia/Jakarta"),("1990589", "Teluknaga", "", "ID", "360", "", "30", "", "", "-6.09889", "106.63806", "Asia/Jakarta"),("2002872", "Wonosari", "", "ID", "360", "", "10", "", "", "-7.96556", "110.60361", "Asia/Jakarta"),("2005057", "Gamping Lor", "", "ID", "360", "", "10", "", "", "-7.79556", "110.32639", "Asia/Jakarta"),("2005237", "Kasihan", "", "ID", "360", "", "10", "", "", "-7.82694", "110.32917", "Asia/Jakarta"),("2010971", "Ngemplak", "", "ID", "360", "", "07", "", "", "-7.54972", "110.71639", "Asia/Jakarta"),("2010985", "Kartasura", "", "ID", "360", "", "07", "", "", "-7.55194", "110.73778", "Asia/Jakarta"),("2011457", "Gatak", "", "ID", "360", "", "07", "", "", "-7.59083", "110.70444", "Asia/Jakarta"),("2057087", "Kupang", "Купанге", "ID", "360", "", "18", "", "", "-10.17083", "123.60694", "Asia/Makassar"),("2082600", "Jayapura", "Джаяпура", "ID", "360", "", "36", "", "", "-2.53371", "140.71813", "Asia/Jayapura"),("2082727", "Abepura", "", "ID", "360", "", "36", "", "", "-2.5964", "140.6324", "Asia/Jayapura"),("7084521", "Seririt", "Серирит", "ID", "360", "", "02", "", "", "-8.1928", "114.9388", "Asia/Makassar"),("7302172", "Legian", "", "ID", "360", "", "02", "", "", "-8.70415", "115.17028", "Asia/Makassar"),("8224624", "City of Balikpapan", "", "ID", "360", "", "14", "", "", "-1.24204", "116.89419", "Asia/Makassar"),("8449493", "Pekan Bahapal", "", "ID", "360", "", "26", "", "", "3.11313", "99.17352", "Asia/Jakarta"),("8581443", "South Tangerang", "", "ID", "360", "", "33", "", "", "-6.28862", "106.71789", "Asia/Jakarta"),("2654332", "Buncrana", "", "IE", "372", "", "U", "06", "", "55.13333", "-7.45", "Europe/Dublin"),("2960869", "Youghal", "", "IE", "372", "", "M", "04", "", "51.95", "-7.85056", "Europe/Dublin"),("2960936", "Wicklow", "", "IE", "372", "", "L", "31", "", "52.975", "-6.04944", "Europe/Dublin"),("2960964", "Loch Garman", "", "IE", "372", "", "L", "30", "", "52.33417", "-6.4575", "Europe/Dublin"),("2960970", "Westport", "", "IE", "372", "", "C", "20", "", "53.8", "-9.51667", "Europe/Dublin"),("2960992", "Waterford", "Уотерфорд", "IE", "372", "", "M", "27", "", "52.25833", "-7.11194", "Europe/Dublin"),("2961086", "Tullamore", "", "IE", "372", "", "L", "23", "", "53.27389", "-7.48889", "Europe/Dublin"),("2961099", "Tuam", "", "IE", "372", "", "C", "10", "", "53.51667", "-8.85", "Europe/Dublin"),("2961120", "Trá Mhór", "", "IE", "372", "", "M", "27", "", "52.16235", "-7.15244", "Europe/Dublin"),("2961123", "Tralee", "Трали", "IE", "372", "", "M", "11", "", "52.27042", "-9.70264", "Europe/Dublin"),("2961214", "Thurles", "", "IE", "372", "", "M", "26", "", "52.68194", "-7.80222", "Europe/Dublin"),("2961235", "Terenure", "", "IE", "372", "", "L", "39", "", "53.30972", "-6.28528", "Europe/Dublin"),("2961284", "Tallaght", "Талла", "IE", "372", "", "L", "39", "", "53.2859", "-6.37344", "Europe/Dublin"),("2961297", "Swords", "Сордс", "IE", "372", "", "L", "35", "", "53.45972", "-6.21806", "Europe/Dublin"),("2961423", "Sligo", "Слайго", "IE", "372", "", "C", "25", "", "54.26969", "-8.46943", "Europe/Dublin"),("2961461", "Skerries", "", "IE", "372", "", "L", "35", "", "53.58278", "-6.10833", "Europe/Dublin"),("2961523", "Shankill", "", "IE", "372", "", "L", "34", "", "53.22611", "-6.12444", "Europe/Dublin"),("2961589", "Sandymount", "", "IE", "372", "", "L", "33", "", "53.335", "-6.21139", "Europe/Dublin"),("2961607", "Sallins", "", "IE", "372", "", "L", "12", "", "53.24889", "-6.66611", "Europe/Dublin"),("2961651", "An Ros", "", "IE", "372", "", "L", "35", "", "53.52424", "-6.10497", "Europe/Dublin"),("2961730", "Roscrea", "", "IE", "372", "", "M", "26", "", "52.95111", "-7.80167", "Europe/Dublin"),("2961732", "Roscommon", "", "IE", "372", "", "C", "24", "", "53.63333", "-8.18333", "Europe/Dublin"),("2961816", "Ringsend", "", "IE", "372", "", "L", "07", "", "53.34194", "-6.22639", "Europe/Dublin"),("2961872", "Ratoath", "", "IE", "372", "", "L", "21", "", "53.50806", "-6.4625", "Europe/Dublin"),("2961896", "Rathmines", "", "IE", "372", "", "L", "33", "", "53.32028", "-6.26333", "Europe/Dublin"),("2961960", "Raheny", "", "IE", "372", "", "L", "07", "", "53.38681", "-6.18067", "Europe/Dublin"),("2962019", "Portmarnock", "", "IE", "372", "", "L", "35", "", "53.42306", "-6.1375", "Europe/Dublin"),("2962026", "Portlaoise", "", "IE", "372", "", "L", "15", "", "53.03441", "-7.29979", "Europe/Dublin"),("2962029", "Portarlington", "", "IE", "372", "", "L", "15", "", "53.16222", "-7.19111", "Europe/Dublin"),("2962222", "Newtown Trim", "", "IE", "372", "", "L", "21", "", "53.55611", "-6.77", "Europe/Dublin"),("2962252", "New Ross", "", "IE", "372", "", "L", "30", "", "52.39667", "-6.93667", "Europe/Dublin"),("2962283", "Newcastle West", "", "IE", "372", "", "M", "16", "", "52.44917", "-9.06111", "Europe/Dublin"),("2962290", "Droichead Nua", "", "IE", "372", "", "L", "12", "", "53.18194", "-6.79667", "Europe/Dublin"),("2962304", "Nenagh", "", "IE", "372", "", "M", "26", "", "52.86194", "-8.19667", "Europe/Dublin"),("2962308", "Navan", "Ан-Уавь", "IE", "372", "", "L", "21", "", "53.65278", "-6.68139", "Europe/Dublin"),("2962334", "Naas", "", "IE", "372", "", "L", "12", "", "53.21583", "-6.66694", "Europe/Dublin"),("2962361", "An Muileann gCearr", "", "IE", "372", "", "L", "29", "", "53.53333", "-7.35", "Europe/Dublin"),("2962543", "Monkstown", "", "IE", "372", "", "L", "34", "", "53.29308", "-6.15312", "Europe/Dublin"),("2962568", "Monaghan", "", "IE", "372", "", "U", "22", "", "54.25", "-6.96667", "Europe/Dublin"),("2962630", "Midleton", "", "IE", "372", "", "M", "04", "", "51.91526", "-8.18052", "Europe/Dublin"),("2962638", "Mount Merrion", "", "IE", "372", "IE", "L", "07", "", "53.30008", "-6.21504", "Europe/Dublin"),("2962668", "Maynooth", "", "IE", "372", "", "L", "12", "", "53.385", "-6.59361", "Europe/Dublin"),("2962696", "Marino", "", "IE", "372", "", "L", "07", "", "53.37022", "-6.23646", "Europe/Dublin"),("2962714", "Mallow", "", "IE", "372", "", "M", "04", "", "52.13333", "-8.63333", "Europe/Dublin"),("2962725", "Malahide", "Малахайд", "IE", "372", "", "L", "35", "", "53.45083", "-6.15444", "Europe/Dublin"),("2962769", "Lusk", "", "IE", "372", "", "L", "35", "", "53.52743", "-6.16423", "Europe/Dublin"),("2962785", "Lucan", "", "IE", "372", "IE", "L", "39", "", "53.35736", "-6.44859", "Europe/Dublin"),("2962800", "Loughrea", "", "IE", "372", "", "C", "10", "", "53.19694", "-8.56694", "Europe/Dublin"),("2962840", "Longford", "", "IE", "372", "", "L", "18", "", "53.72536", "-7.79823", "Europe/Dublin"),("2962943", "Luimneach", "Лимерик", "IE", "372", "", "M", "16", "", "52.66472", "-8.62306", "Europe/Dublin"),("2962961", "Letterkenny", "Леттеркенни", "IE", "372", "", "U", "06", "", "54.95", "-7.73333", "Europe/Dublin"),("2962974", "Leixlip", "Лейкслип", "IE", "372", "", "L", "12", "", "53.36583", "-6.49556", "Europe/Dublin"),("2963007", "Laytown", "", "IE", "372", "", "L", "21", "", "53.68194", "-6.23917", "Europe/Dublin"),("2963370", "Cill Airne", "", "IE", "372", "IE", "M", "11", "", "52.05", "-9.51667", "Europe/Dublin"),("2963398", "Kilkenny", "Килкенни", "IE", "372", "", "L", "13", "", "52.65417", "-7.25222", "Europe/Dublin"),("2963436", "Kildare", "", "IE", "372", "", "L", "12", "", "53.15611", "-6.91444", "Europe/Dublin"),("2963472", "Kilcock", "", "IE", "372", "", "L", "12", "", "53.40222", "-6.67083", "Europe/Dublin"),("2963848", "Greystones", "", "IE", "372", "", "L", "31", "", "53.14083", "-6.06306", "Europe/Dublin"),("2963962", "Gorey", "", "IE", "372", "", "L", "30", "", "52.67472", "-6.2925", "Europe/Dublin"),("2964180", "Gaillimh", "Голуэй", "IE", "372", "", "C", "10", "", "53.27194", "-9.04889", "Europe/Dublin"),("2964303", "Finglas", "", "IE", "372", "", "L", "33", "", "53.38917", "-6.29694", "Europe/Dublin"),("2964403", "Enniscorthy", "", "IE", "372", "", "L", "30", "", "52.50083", "-6.55778", "Europe/Dublin"),("2964405", "Ennis", "Эннис", "IE", "372", "", "M", "32", "", "52.84361", "-8.98639", "Europe/Dublin"),("2964506", "Dún Laoghaire", "Дун-Лэаре", "IE", "372", "IE", "L", "34", "", "53.29395", "-6.13586", "Europe/Dublin"),("2964528", "Dungarvan", "", "IE", "372", "", "M", "27", "", "52.08806", "-7.62528", "Europe/Dublin"),("2964532", "Dundrum", "", "IE", "372", "", "L", "34", "", "53.29067", "-6.25714", "Europe/Dublin"),("2964540", "Dundalk", "Дандолк", "IE", "372", "", "L", "19", "", "54", "-6.41667", "Europe/Dublin"),("2964547", "Dunboyne", "", "IE", "372", "", "L", "21", "", "53.4", "-6.46667", "Europe/Dublin"),("2964574", "Dublin", "Дублин", "IE", "372", "", "L", "33", "", "53.33306", "-6.24889", "Europe/Dublin"),("2964661", "Drogheda", "Дроэда", "IE", "372", "", "L", "19", "", "53.71889", "-6.34778", "Europe/Dublin"),("2964745", "Donnybrook", "", "IE", "372", "", "L", "07", "", "53.31375", "-6.22274", "Europe/Dublin"),("2964765", "Donabate", "", "IE", "372", "", "L", "35", "", "53.48722", "-6.15194", "Europe/Dublin"),("2964767", "Dollymount", "", "IE", "372", "", "L", "07", "", "53.36489", "-6.18032", "Europe/Dublin"),("2964820", "Derry", "", "IE", "372", "", "M", "04", "", "51.58666", "-9.05026", "Europe/Dublin"),("2964892", "Dalkey", "", "IE", "372", "IE", "L", "34", "", "53.27833", "-6.10028", "Europe/Dublin"),("2964963", "Crumlin", "", "IE", "372", "", "L", "07", "", "53.32417", "-6.32861", "Europe/Dublin"),("2965140", "Cork", "Корк", "IE", "372", "", "M", "04", "", "51.89797", "-8.47061", "Europe/Dublin"),("2965260", "Cobh", "", "IE", "372", "", "M", "04", "", "51.85722", "-8.29917", "Europe/Dublin"),("2965353", "Cluain Meala", "", "IE", "372", "", "M", "26", "", "52.355", "-7.70389", "Europe/Dublin"),("2965381", "Clondalkin", "", "IE", "372", "IE", "L", "39", "", "53.32444", "-6.39722", "Europe/Dublin"),("2965484", "Clane", "", "IE", "372", "", "L", "12", "", "53.29139", "-6.68917", "Europe/Dublin"),("2965509", "Cherryville", "", "IE", "372", "", "L", "12", "", "53.15694", "-6.96667", "Europe/Dublin"),("2965525", "Chapelizod", "", "IE", "372", "", "L", "33", "", "53.34889", "-6.34667", "Europe/Dublin"),("2965529", "Celbridge", "Селбридж", "IE", "372", "", "L", "12", "", "53.33861", "-6.54361", "Europe/Dublin"),("2965535", "Cavan", "", "IE", "372", "", "U", "02", "", "53.99083", "-7.36056", "Europe/Dublin"),("2965599", "Castleknock", "", "IE", "372", "", "L", "35", "", "53.37483", "-6.36336", "Europe/Dublin"),("2965654", "Castlebar", "", "IE", "372", "", "C", "20", "", "53.85", "-9.3", "Europe/Dublin"),("2965715", "Carrigaline", "", "IE", "372", "", "M", "04", "", "51.81167", "-8.39861", "Europe/Dublin"),("2965726", "Carrick-on-Suir", "", "IE", "372", "", "M", "26", "", "52.34917", "-7.41306", "Europe/Dublin"),("2965768", "Carlow", "", "IE", "372", "", "L", "01", "", "52.84083", "-6.92611", "Europe/Dublin"),("2965882", "Cabinteely", "", "IE", "372", "", "L", "34", "", "53.26973", "-6.16058", "Europe/Dublin"),("2966022", "Bray", "", "IE", "372", "", "L", "31", "", "53.20278", "-6.09833", "Europe/Dublin"),("2966101", "Blessington", "", "IE", "372", "", "L", "31", "", "53.17", "-6.5325", "Europe/Dublin"),("2966110", "Blanchardstown", "", "IE", "372", "", "L", "35", "", "53.38806", "-6.37556", "Europe/Dublin"),("2966131", "Blackrock", "", "IE", "372", "", "L", "07", "", "53.3015", "-6.1778", "Europe/Dublin"),("2966370", "Bandon", "", "IE", "372", "", "M", "04", "", "51.74694", "-8.7425", "Europe/Dublin"),("2966670", "Ballyboden", "", "IE", "372", "", "L", "07", "", "53.28056", "-6.31639", "Europe/Dublin"),("2966753", "Ballinasloe", "", "IE", "372", "", "C", "10", "", "53.3275", "-8.21944", "Europe/Dublin"),("2966778", "Ballina", "", "IE", "372", "", "C", "20", "", "54.11667", "-9.16667", "Europe/Dublin"),("2966793", "Baldoyle", "", "IE", "372", "", "L", "35", "", "53.39972", "-6.12583", "Europe/Dublin"),("2966794", "Balbriggan", "Балбригган", "IE", "372", "", "L", "35", "", "53.61278", "-6.18194", "Europe/Dublin"),("2966837", "Athy", "", "IE", "372", "", "L", "12", "", "52.99139", "-6.98028", "Europe/Dublin"),("2966839", "Athlone", "", "IE", "372", "", "L", "29", "", "53.43333", "-7.95", "Europe/Dublin"),("2966870", "Ashbourne", "", "IE", "372", "", "L", "21", "", "53.51163", "-6.39821", "Europe/Dublin"),("2966883", "Arklow", "", "IE", "372", "", "L", "31", "", "52.79306", "-6.14139", "Europe/Dublin"),("3306439", "Nenagh Bridge", "", "IE", "372", "", "M", "26", "", "52.88167", "-8.19583", "Europe/Dublin"),("3310247", "Shannon", "", "IE", "372", "", "M", "03", "", "52.70389", "-8.86417", "Europe/Dublin"),("3315200", "Eadestown", "", "IE", "372", "", "L", "12", "", "53.20278", "-6.57806", "Europe/Dublin"),("3315204", "Little Bray", "", "IE", "372", "", "L", "07", "", "53.20444", "-6.12083", "Europe/Dublin"),("3315276", "Firhouse", "", "IE", "372", "", "L", "07", "", "53.28167", "-6.33917", "Europe/Dublin"),("3315278", "Sandyford", "", "IE", "372", "", "L", "07", "", "53.2747", "-6.2253", "Europe/Dublin"),("3315280", "Foxrock", "", "IE", "372", "", "L", "34", "", "53.26667", "-6.17417", "Europe/Dublin"),("3315282", "Sallynoggin", "", "IE", "372", "", "L", "07", "", "53.27917", "-6.14058", "Europe/Dublin"),("3315287", "Rathgar", "", "IE", "372", "", "L", "33", "", "53.31457", "-6.275", "Europe/Dublin"),("3315304", "Artane", "", "IE", "372", "", "L", "07", "", "53.38712", "-6.2138", "Europe/Dublin"),("3315311", "Beaumont", "", "IE", "372", "", "L", "33", "", "53.39139", "-6.24056", "Europe/Dublin"),("3315315", "Ballymun", "", "IE", "372", "", "L", "33", "", "53.39807", "-6.26693", "Europe/Dublin"),("3315332", "Hartstown", "", "IE", "372", "", "L", "07", "", "53.39306", "-6.42694", "Europe/Dublin"),("3315378", "Ballyfermot", "", "IE", "372", "", "L", "07", "", "53.34528", "-6.35889", "Europe/Dublin"),("3315404", "Templeogue", "", "IE", "372", "", "L", "07", "", "53.29528", "-6.30889", "Europe/Dublin"),("3315430", "Oldbawn", "", "IE", "372", "", "L", "07", "", "53.27556", "-6.3675", "Europe/Dublin"),("6619871", "Cherry Orchard", "", "IE", "372", "", "L", "33", "", "53.33605", "-6.37799", "Europe/Dublin"),("6691006", "Booterstown", "", "IE", "372", "", "", "", "", "53.30447", "-6.19985", "Europe/Dublin"),("6691010", "Ballinteer", "", "IE", "372", "", "L", "", "", "53.27409", "-6.25397", "Europe/Dublin"),("6691017", "Greenhills", "", "IE", "372", "", "L", "39", "", "53.33467", "-6.30302", "Europe/Dublin"),("6691033", "Donaghmede", "", "IE", "372", "", "L", "", "", "53.39845", "-6.16179", "Europe/Dublin"),("6691035", "Darndale", "", "IE", "372", "", "", "", "", "53.39948", "-6.18886", "Europe/Dublin"),("6691048", "Donnycarney", "", "IE", "372", "", "", "", "", "53.3735", "-6.20976", "Europe/Dublin"),("7838921", "Knocklyon", "", "IE", "372", "", "L", "39", "", "53.2803", "-6.3313", "Europe/Dublin"),("7838923", "Palmerstown", "", "IE", "372", "", "", "", "", "53.35019", "-6.37778", "Europe/Dublin"),("7869995", "Jobstown", "", "IE", "372", "", "", "", "", "53.27866", "-6.40803", "Europe/Dublin"),("7869996", "Killester", "", "IE", "372", "", "L", "33", "", "53.37322", "-6.20431", "Europe/Dublin"),("7870938", "Confey", "", "IE", "372", "", "", "", "", "53.37923", "-6.49052", "Europe/Dublin"),("7870988", "Kilquade", "", "IE", "372", "", "", "", "", "53.09743", "-6.08411", "Europe/Dublin"),("8642910", "Balally", "", "IE", "372", "", "L", "", "", "53.27504", "-6.23594", "Europe/Dublin"),("8658946", "Kinsealy-Drinan", "", "IE", "372", "", "L", "", "", "53.44395", "-6.20334", "Europe/Dublin"),("281184", "Jerusalem", "Иерусалим", "IL", "376", "", "06", "", "", "31.76904", "35.21633", "Asia/Jerusalem"),("293100", "Safed", "Цфат", "IL", "376", "", "03", "", "", "32.96465", "35.496", "Asia/Jerusalem"),("293203", "Yeroẖam", "", "IL", "376", "", "01", "", "", "30.98822", "34.93176", "Asia/Jerusalem"),("293207", "Yehud", "Йехуд", "IL", "376", "", "02", "", "", "32.03317", "34.89091", "Asia/Jerusalem"),("293222", "Yavné", "Явне", "IL", "376", "", "02", "", "", "31.88078", "34.73843", "Asia/Jerusalem"),("293253", "Yafo", "Яффа", "IL", "376", "IL", "05", "", "", "32.05043", "34.75224", "Asia/Jerusalem"),("293286", "Umm el Faḥm", "", "IL", "376", "", "04", "", "", "32.51725", "35.15349", "Asia/Jerusalem"),("293308", "Tirat Karmel", "Тират Кармель", "IL", "376", "", "04", "", "", "32.76021", "34.97183", "Asia/Jerusalem"),("293322", "Tiberias", "Тверия", "IL", "376", "", "03", "", "", "32.79221", "35.53124", "Asia/Jerusalem"),("293354", "Tel Mond", "", "IL", "376", "", "02", "", "", "32.24995", "34.91737", "Asia/Jerusalem"),("293397", "Tel Aviv", "Тель-Авив", "IL", "376", "", "05", "", "", "32.08088", "34.78057", "Asia/Jerusalem"),("293420", "maalot Tarshīhā", "Маалот-Таршиха", "IL", "376", "IL", "03", "", "", "33.01667", "35.26667", "Asia/Jerusalem"),("293426", "Tamra", "Тамра", "IL", "376", "", "03", "", "", "32.85301", "35.1987", "Asia/Jerusalem"),("293522", "Shelomi", "", "IL", "376", "", "03", "", "", "33.07216", "35.14452", "Asia/Jerusalem"),("293619", "Sederot", "Сдерот", "IL", "376", "", "01", "", "", "31.525", "34.59693", "Asia/Jerusalem"),("293655", "Sakhnīn", "Сахнин", "IL", "376", "", "03", "", "", "32.86422", "35.29707", "Asia/Jerusalem"),("293690", "Rosh Ha‘Ayin", "", "IL", "376", "", "02", "", "", "32.09556", "34.95664", "Asia/Jerusalem"),("293703", "Rishon LeẔiyyon", "Ришон-ле-Цион", "IL", "376", "", "02", "", "", "31.97102", "34.78939", "Asia/Jerusalem"),("293721", "Rekhasim", "", "IL", "376", "", "04", "", "", "32.74907", "35.09901", "Asia/Jerusalem"),("293768", "Ramla", "Рамла", "IL", "376", "", "02", "", "", "31.92923", "34.86563", "Asia/Jerusalem"),("293773", "Ramat Yishay", "", "IL", "376", "", "03", "", "", "32.70444", "35.1707", "Asia/Jerusalem"),("293783", "Ramat HaSharon", "", "IL", "376", "", "05", "", "", "32.14613", "34.8394", "Asia/Jerusalem"),("293788", "Ramat Gan", "Рамат-Ган", "IL", "376", "", "05", "", "", "32.08227", "34.81065", "Asia/Jerusalem"),("293807", "Ra'anana", "", "IL", "376", "", "02", "", "", "32.1836", "34.87386", "Asia/Jerusalem"),("293822", "Qiryat Yam", "Кирьят-Ям", "IL", "376", "", "04", "", "", "32.84966", "35.06973", "Asia/Jerusalem"),("293825", "Qiryat Shemona", "Кирьят-Шмона", "IL", "376", "", "03", "", "", "33.20733", "35.57212", "Asia/Jerusalem"),("293831", "Qiryat Moẕqin", "Кирьят-Моцкин", "IL", "376", "", "04", "", "", "32.83706", "35.0776", "Asia/Jerusalem"),("293842", "Qiryat Gat", "Кирьят-Гат", "IL", "376", "", "01", "", "", "31.60998", "34.76422", "Asia/Jerusalem"),("293844", "Qiryat Bialik", "Кирьят-Бялик", "IL", "376", "", "04", "", "", "32.8275", "35.08583", "Asia/Jerusalem"),("293845", "Qiryat Ata", "Кирьят-Ата", "IL", "376", "", "04", "", "", "32.81149", "35.11323", "Asia/Jerusalem"),("293896", "Qalansuwa", "", "IL", "376", "", "02", "", "", "32.28493", "34.98106", "Asia/Jerusalem"),("293918", "Petaẖ Tiqwa", "", "IL", "376", "", "02", "", "", "32.08707", "34.88747", "Asia/Jerusalem"),("293942", "Pardesiyya", "", "IL", "376", "", "02", "", "", "32.30577", "34.90911", "Asia/Jerusalem"),("293962", "Or Yehuda", "", "IL", "376", "", "05", "", "", "32.02923", "34.85788", "Asia/Jerusalem"),("293992", "Ofaqim", "", "IL", "376", "", "01", "", "", "31.3141", "34.62025", "Asia/Jerusalem"),("294068", "Netivot", "Нетивот", "IL", "376", "", "01", "", "", "31.42305", "34.58911", "Asia/Jerusalem"),("294071", "Netanya", "Нетания", "IL", "376", "", "02", "", "", "32.33291", "34.85992", "Asia/Jerusalem"),("294074", "Ness Ziona", "", "IL", "376", "IL", "02", "", "", "31.92933", "34.79868", "Asia/Jerusalem"),("294078", "Nesher", "Нешер", "IL", "376", "", "04", "", "", "32.76622", "35.04425", "Asia/Jerusalem"),("294098", "Nazareth", "Назарет", "IL", "376", "", "03", "", "", "32.69925", "35.30483", "Asia/Jerusalem"),("294114", "Naḥf", "", "IL", "376", "", "03", "", "", "32.93444", "35.31679", "Asia/Jerusalem"),("294117", "Nahariya", "Нагария", "IL", "376", "", "03", "", "", "33.01135", "35.09467", "Asia/Jerusalem"),("294210", "Migdal Ha‘Emeq", "Мигдаль ХаЭмек", "IL", "376", "", "03", "", "", "32.67597", "35.23986", "Asia/Jerusalem"),("294244", "Mevo Betar", "", "IL", "376", "", "06", "", "", "31.72177", "35.10669", "Asia/Jerusalem"),("294303", "Mazkeret Batya", "", "IL", "376", "", "02", "", "", "31.85357", "34.84646", "Asia/Jerusalem"),("294387", "Maghār", "", "IL", "376", "", "03", "", "", "32.88984", "35.40703", "Asia/Jerusalem"),("294421", "Lod", "Лод", "IL", "376", "", "02", "", "", "31.9467", "34.8903", "Asia/Jerusalem"),("294492", "Kefar Yona", "", "IL", "376", "", "02", "", "", "32.31669", "34.93507", "Asia/Jerusalem"),("294514", "Kfar Saba", "Кефар-Сава", "IL", "376", "", "02", "", "", "32.175", "34.90694", "Asia/Jerusalem"),("294577", "Karmi’el", "Кармиэль", "IL", "376", "", "03", "", "", "32.91708", "35.30501", "Asia/Jerusalem"),("294600", "Kafir Yasif", "", "IL", "376", "", "03", "", "", "32.95451", "35.1623", "Asia/Jerusalem"),("294604", "Kafr Qāsim", "", "IL", "376", "", "02", "", "", "32.11406", "34.97624", "Asia/Jerusalem"),("294608", "Kafr Mandā", "", "IL", "376", "", "03", "", "", "32.81034", "35.26009", "Asia/Jerusalem"),("294610", "Kafr Kannā", "", "IL", "376", "", "03", "", "", "32.7466", "35.34242", "Asia/Jerusalem"),("294615", "Kābūl", "", "IL", "376", "", "03", "", "", "32.86856", "35.21171", "Asia/Jerusalem"),("294622", "Judeida Makr", "", "IL", "376", "", "03", "", "", "32.9282", "35.15705", "Asia/Jerusalem"),("294634", "Jaljūlya", "", "IL", "376", "", "02", "", "", "32.1547", "34.95372", "Asia/Jerusalem"),("294658", "Iksāl", "", "IL", "376", "", "03", "", "", "32.68164", "35.32365", "Asia/Jerusalem"),("294666", "Ḥurfeish", "", "IL", "376", "", "03", "", "", "33.01711", "35.34835", "Asia/Jerusalem"),("294751", "H̱olon", "Холон", "IL", "376", "", "05", "", "", "32.01034", "34.77918", "Asia/Jerusalem"),("294760", "Hod HaSharon", "Ход-ха-Шарон", "IL", "376", "", "02", "", "", "32.15934", "34.8932", "Asia/Jerusalem"),("294778", "Herzliyya", "Герцлия", "IL", "376", "", "05", "", "", "32.16627", "34.82536", "Asia/Jerusalem"),("294801", "Haifa", "Хайфа", "IL", "376", "", "04", "", "", "32.81841", "34.9885", "Asia/Jerusalem"),("294946", "H̱adera", "Хадера", "IL", "376", "", "04", "", "", "32.44192", "34.9039", "Asia/Jerusalem"),("294981", "Giv‘at Shemu’él", "", "IL", "376", "", "05", "", "", "32.07817", "34.84858", "Asia/Jerusalem"),("294999", "Giv‘atayim", "Гиватаим", "IL", "376", "", "05", "", "", "32.07225", "34.81253", "Asia/Jerusalem"),("295064", "Gedera", "", "IL", "376", "", "02", "", "", "31.81456", "34.77998", "Asia/Jerusalem"),("295080", "Gan Yavne", "", "IL", "376", "", "02", "", "", "31.78737", "34.70659", "Asia/Jerusalem"),("295089", "Ganné Tiqwa", "", "IL", "376", "", "02", "", "", "32.05971", "34.8732", "Asia/Jerusalem"),("295122", "Even Yehuda", "", "IL", "376", "", "02", "", "", "32.26959", "34.88759", "Asia/Jerusalem"),("295127", "Tirah", "", "IL", "376", "", "02", "", "", "32.2341", "34.95023", "Asia/Jerusalem"),("295130", "Eṭ Ṭaiyiba", "", "IL", "376", "", "02", "", "", "32.26616", "35.00893", "Asia/Jerusalem"),("295174", "Er Reina", "", "IL", "376", "", "03", "", "", "32.72339", "35.31622", "Asia/Jerusalem"),("295269", "El Fureidīs", "", "IL", "376", "", "04", "", "", "32.59812", "34.95153", "Asia/Jerusalem"),("295277", "Eilat", "Эйлат", "IL", "376", "", "01", "", "", "29.55805", "34.94821", "Asia/Jerusalem"),("295328", "Dimona", "Димона", "IL", "376", "", "01", "", "", "31.07079", "35.03269", "Asia/Jerusalem"),("295339", "Deir Ḥannā", "", "IL", "376", "", "03", "", "", "32.86196", "35.36365", "Asia/Jerusalem"),("295365", "Dāliyat el Karmil", "Кармель", "IL", "376", "", "04", "", "", "32.69383", "35.04686", "Asia/Jerusalem"),("295370", "Dabbūrīya", "", "IL", "376", "", "03", "", "", "32.69256", "35.37123", "Asia/Jerusalem"),("295379", "Buqei‘a", "", "IL", "376", "", "03", "", "", "32.97747", "35.33345", "Asia/Jerusalem"),("295380", "Bu‘eina", "", "IL", "376", "", "03", "", "", "32.80636", "35.36486", "Asia/Jerusalem"),("295404", "Bīr el Maksūr", "", "IL", "376", "", "03", "", "", "32.77732", "35.22069", "Asia/Jerusalem"),("295432", "Bet Shemesh", "Бейт-Шемеш", "IL", "376", "", "06", "", "", "31.73072", "34.99293", "Asia/Jerusalem"),("295435", "Bet She’an", "Бейт-Шеан", "IL", "376", "", "03", "", "", "32.49728", "35.49632", "Asia/Jerusalem"),("295475", "Bet Dagan", "", "IL", "376", "", "02", "", "", "32.00191", "34.82977", "Asia/Jerusalem"),("295514", "Bené Beraq", "", "IL", "376", "", "05", "", "", "32.08074", "34.8338", "Asia/Jerusalem"),("295515", "Bene 'Ayish", "", "IL", "376", "", "02", "", "", "31.78333", "34.75", "Asia/Jerusalem"),("295523", "Beit Jann", "", "IL", "376", "", "03", "", "", "32.96464", "35.38152", "Asia/Jerusalem"),("295530", "Beersheba", "Беэр-Шева", "IL", "376", "IL", "01", "", "", "31.25181", "34.7913", "Asia/Jerusalem"),("295548", "Bat Yam", "Бат-Ям", "IL", "376", "", "05", "", "", "32.02379", "34.75185", "Asia/Jerusalem"),("295553", "Basmat Ṭab‘ūn", "", "IL", "376", "", "03", "", "", "32.73898", "35.15716", "Asia/Jerusalem"),("295584", "Azor", "", "IL", "376", "", "05", "", "", "32.0243", "34.80632", "Asia/Jerusalem"),("295620", "Ashqelon", "Ашкелон", "IL", "376", "", "01", "", "", "31.66926", "34.57149", "Asia/Jerusalem"),("295629", "Ashdod", "Ашдод", "IL", "376", "", "01", "", "", "31.79213", "34.64966", "Asia/Jerusalem"),("295657", "‘Arad", "Арад", "IL", "376", "", "01", "", "", "31.25882", "35.21282", "Asia/Jerusalem"),("295721", "‘Akko", "Акко", "IL", "376", "", "03", "", "", "32.92814", "35.07647", "Asia/Jerusalem"),("295739", "‘Afula ‘Illit", "", "IL", "376", "", "03", "", "", "32.63221", "35.32533", "Asia/Jerusalem"),("295772", "Abū Ghaush", "", "IL", "376", "", "06", "", "", "31.80592", "35.1093", "Asia/Jerusalem"),("386445", "Kefar Weradim", "", "IL", "376", "", "03", "", "", "32.99385", "35.27793", "Asia/Jerusalem"),("6693244", "Lehavim", "", "IL", "376", "", "01", "", "", "31.37284", "34.81619", "Asia/Jerusalem"),("6693679", "Modiin", "", "IL", "376", "IL", "02", "", "", "31.89825", "35.01051", "Asia/Jerusalem"),("7498240", "West Jerusalem", "", "IL", "376", "", "06", "", "", "31.78199", "35.21961", "Asia/Jerusalem"),("8199378", "Modiin Ilit", "", "IL", "376", "IL", "06", "", "", "31.93221", "35.04416", "Asia/Jerusalem"),("8199394", "Ariel", "", "IL", "376", "IL", "06", "", "", "32.1065", "35.18449", "Asia/Jerusalem"),("8478264", "Herzliya Pituah", "", "IL", "376", "", "05", "", "", "32.17409", "34.8028", "Asia/Jerusalem"),("1167718", "Pūnch", "", "IN", "356", "", "12", "005", "", "33.77033", "74.09254", "Asia/Kolkata"),("1252646", "Keelakarai", "", "IN", "356", "", "25", "626", "", "9.23183", "78.78545", "Asia/Kolkata"),("1252653", "Zunheboto", "", "IN", "356", "", "20", "263", "", "25.96667", "94.51667", "Asia/Kolkata"),("1252668", "Ziro", "", "IN", "356", "", "30", "255", "", "27.59497", "93.83854", "Asia/Kolkata"),("1252692", "Zamānia", "", "IN", "356", "", "36", "195", "", "25.41961", "83.55786", "Asia/Kolkata"),("1252698", "Zaidpur", "", "IN", "356", "", "36", "176", "", "26.83093", "81.32929", "Asia/Kolkata"),("1252699", "Zahirābād", "", "IN", "356", "", "40", "535", "", "17.68138", "77.60743", "Asia/Kolkata"),("1252702", "Zafarābād", "", "IN", "356", "", "36", "194", "", "25.69867", "82.73354", "Asia/Kolkata"),("1252714", "Yol", "", "IN", "356", "", "11", "024", "", "32.16423", "76.19622", "Asia/Kolkata"),("1252738", "Yeola", "", "IN", "356", "", "16", "516", "", "20.0424", "74.48944", "Asia/Kolkata"),("1252744", "Yellāpur", "", "IN", "356", "", "19", "563", "", "14.9637", "74.70929", "Asia/Kolkata"),("1252745", "Yellandu", "", "IN", "356", "", "40", "541", "", "17.59064", "80.32146", "Asia/Kolkata"),("1252753", "Yelbarga", "", "IN", "356", "", "19", "560", "", "15.61545", "76.01184", "Asia/Kolkata"),("1252756", "Yelandūr", "", "IN", "356", "", "19", "578", "", "12.04629", "77.03034", "Asia/Kolkata"),("1252758", "Yelahanka", "", "IN", "356", "", "19", "572", "", "13.10073", "77.59632", "Asia/Kolkata"),("1252770", "Yavatmāl", "", "IN", "356", "", "16", "510", "", "20.39324", "78.13201", "Asia/Kolkata"),("1252773", "Yāval", "", "IN", "356", "", "16", "499", "", "21.16772", "75.69762", "Asia/Kolkata"),("1252795", "Yanam", "Янам", "IN", "356", "", "02", "545", "", "16.73308", "82.21364", "Asia/Kolkata"),("1252797", "Yamunānagar", "", "IN", "356", "", "10", "071", "", "30.12796", "77.28371", "Asia/Kolkata"),("1252810", "Yairipok", "", "IN", "356", "", "17", "276", "", "24.67792", "94.04767", "Asia/Kolkata"),("1252822", "Yādgīr", "", "IN", "356", "", "19", "580", "", "16.77007", "77.13755", "Asia/Kolkata"),("1252840", "Wokha", "", "IN", "356", "", "20", "264", "", "26.09717", "94.25817", "Asia/Kolkata"),("1252885", "Wer", "", "IN", "356", "", "24", "105", "", "27.0186", "77.17636", "Asia/Kolkata"),("1252887", "Wellington", "Веллингтон", "IN", "356", "", "25", "611", "", "11.36552", "76.78442", "Asia/Kolkata"),("1252892", "Wazīrganj", "", "IN", "356", "", "36", "149", "", "28.21145", "79.05665", "Asia/Kolkata"),("1252908", "Wāshīm", "", "IN", "356", "", "16", "502", "", "20.11128", "77.133", "Asia/Kolkata"),("1252919", "Warud", "", "IN", "356", "", "16", "503", "", "21.47101", "78.26965", "Asia/Kolkata"),("1252925", "Warora", "", "IN", "356", "", "16", "509", "", "20.22885", "79.00277", "Asia/Kolkata"),("1252930", "Wāris Alīganj", "", "IN", "356", "", "34", "237", "", "25.0172", "85.64047", "Asia/Kolkata"),("1252942", "Wardha", "Вардха", "IN", "356", "", "16", "504", "", "20.73933", "78.59784", "Asia/Kolkata"),("1252946", "Wārāseonī", "", "IN", "356", "", "35", "457", "", "21.76184", "80.04301", "Asia/Kolkata"),("1252948", "Warangal", "Варангал", "IN", "356", "", "40", "540", "", "18", "79.58333", "Asia/Kolkata"),("1252956", "Wanparti", "", "IN", "356", "", "40", "538", "", "16.36738", "78.06889", "Asia/Kolkata"),("1252958", "Wānkāner", "", "IN", "356", "", "09", "476", "", "22.61198", "70.94379", "Asia/Kolkata"),("1252960", "Wani", "Ваня", "IN", "356", "", "16", "510", "", "20.05507", "78.95313", "Asia/Kolkata"),("1252964", "Wāngjing", "", "IN", "356", "", "17", "276", "", "24.58921", "94.06386", "Asia/Kolkata"),("1252997", "Walajapet", "", "IN", "356", "", "25", "605", "", "12.9251", "79.36626", "Asia/Kolkata"),("1252998", "Wallajahbad", "", "IN", "356", "", "25", "604", "", "12.79041", "79.82358", "Asia/Kolkata"),("1253013", "Wai", "Вай", "IN", "356", "", "16", "527", "", "17.95276", "73.89058", "Asia/Kolkata"),("1253024", "Waghāi", "", "IN", "356", "", "09", "489", "", "20.77048", "73.50074", "Asia/Kolkata"),("1253041", "Wādi", "Вади", "IN", "356", "", "19", "579", "", "17.05183", "76.99048", "Asia/Kolkata"),("1253052", "Wadgaon", "", "IN", "356", "", "16", "521", "", "18.7392", "73.63945", "Asia/Kolkata"),("1253074", "Vyāra", "", "IN", "356", "", "09", "493", "", "21.11079", "73.39365", "Asia/Kolkata"),("1253077", "Vuyyūru", "", "IN", "356", "", "02", "547", "", "16.36307", "80.84406", "Asia/Kolkata"),("1253079", "Vrindāvan", "Вриндаван", "IN", "356", "", "36", "145", "", "27.58105", "77.69662", "Asia/Kolkata"),("1253080", "Vriddhāchalam", "", "IN", "356", "", "25", "617", "", "11.51528", "79.32186", "Asia/Kolkata"),("1253084", "Vizianagaram", "Визианагарам", "IN", "356", "", "02", "543", "", "18.11692", "83.41148", "Asia/Kolkata"),("1253091", "Vite", "Вита", "IN", "356", "", "16", "531", "", "17.27343", "74.53792", "Asia/Kolkata"),("1253095", "Visnagar", "", "IN", "356", "", "09", "471", "", "23.69855", "72.5521", "Asia/Kolkata"),("1253102", "Visakhapatnam", "Вишакхапатнам", "IN", "356", "", "02", "544", "", "17.68009", "83.20161", "Asia/Kolkata"),("1253105", "Vīsāvadar", "", "IN", "356", "", "09", "479", "", "21.33954", "70.74966", "Asia/Kolkata"),("1253113", "Virudunagar", "", "IN", "356", "", "25", "625", "", "9.58509", "77.95787", "Asia/Kolkata"),("1253115", "Virpur", "", "IN", "356", "", "09", "483", "", "23.1892", "73.47987", "Asia/Kolkata"),("1253127", "Viravanallūr", "", "IN", "356", "", "25", "628", "", "8.6961", "77.51895", "Asia/Kolkata"),("1253132", "Vīrarājendrapet", "", "IN", "356", "", "19", "576", "", "12.19644", "75.80512", "Asia/Kolkata"),("1253133", "Virār", "", "IN", "356", "", "16", "517", "", "19.45591", "72.81136", "Asia/Kolkata"),("1253147", "Vīraganūr", "", "IN", "356", "", "25", "608", "", "11.47491", "78.73725", "Asia/Kolkata"),("1253150", "Vinukonda", "", "IN", "356", "", "02", "548", "", "16.0531", "79.73964", "Asia/Kolkata"),("1253162", "Vinchia", "", "IN", "356", "", "09", "476", "", "22.21027", "71.37967", "Asia/Kolkata"),("1253166", "Villupuram", "", "IN", "356", "", "25", "607", "", "11.93975", "79.49244", "Asia/Kolkata"),("1253175", "Vilattikulam", "", "IN", "356", "", "25", "627", "", "9.13227", "78.16635", "Asia/Kolkata"),("1253177", "Vikravāndi", "", "IN", "356", "", "25", "607", "", "12.0369", "79.54595", "Asia/Kolkata"),("1253182", "Vikārābād", "", "IN", "356", "", "40", "537", "", "17.3381", "77.90441", "Asia/Kolkata"),("1253184", "Vijayawada", "Виджаявада", "IN", "356", "", "02", "547", "", "16.50745", "80.6466", "Asia/Kolkata"),("1253186", "Vijayapuri", "", "IN", "356", "", "25", "610", "", "11.24423", "77.5025", "Asia/Kolkata"),("1253193", "Vijāpur", "", "IN", "356", "", "09", "471", "", "23.5623", "72.74848", "Asia/Kolkata"),("1253200", "Vidisha", "", "IN", "356", "", "35", "443", "", "23.52604", "77.81092", "Asia/Kolkata"),("1253216", "Vettūr", "", "IN", "356", "", "13", "", "", "8.71742", "76.72582", "Asia/Kolkata"),("1253217", "Vettavalam", "", "IN", "356", "", "25", "606", "", "12.10769", "79.24516", "Asia/Kolkata"),("1253219", "Vettaikkaranpudur", "", "IN", "356", "", "25", "632", "", "10.56207", "76.91305", "Asia/Kolkata"),("1253220", "Vetapālem", "", "IN", "356", "", "02", "549", "", "15.78502", "80.30663", "Asia/Kolkata"),("1253237", "Verāval", "", "IN", "356", "", "09", "479", "", "20.9077", "70.36786", "Asia/Kolkata"),("1253242", "Vepagunta", "", "IN", "356", "", "02", "544", "", "17.77844", "83.21577", "Asia/Kolkata"),("1253251", "Venkatagiri", "", "IN", "356", "", "02", "550", "", "13.96005", "79.58032", "Asia/Kolkata"),("1253257", "Vengurla", "", "IN", "356", "", "16", "529", "", "15.86125", "73.63182", "Asia/Kolkata"),("1253275", "Vemalwāda", "", "IN", "356", "", "40", "534", "", "18.46523", "78.86894", "Asia/Kolkata"),("1253278", "Velur", "", "IN", "356", "", "25", "609", "", "11.10825", "78.00113", "Asia/Kolkata"),("1253286", "Vellore", "Веллор", "IN", "356", "", "25", "605", "", "12.9184", "79.13255", "Asia/Kolkata"),("1253308", "Velankanni", "", "IN", "356", "", "25", "618", "", "10.68333", "79.83333", "Asia/Kolkata"),("1253315", "Vejalpur", "", "IN", "356", "", "09", "484", "", "22.69021", "73.56299", "Asia/Kolkata"),("1253328", "Vedasandūr", "", "IN", "356", "", "25", "612", "", "10.53054", "77.9497", "Asia/Kolkata"),("1253330", "Vedaraniyam", "", "IN", "356", "", "25", "618", "", "10.37208", "79.85095", "Asia/Kolkata"),("1253340", "Vayalār", "", "IN", "356", "", "13", "598", "", "9.7", "76.33333", "Asia/Kolkata"),("1253352", "Vattalkundu", "", "IN", "356", "", "25", "612", "", "10.16069", "77.75883", "Asia/Kolkata"),("1253357", "Vāsudevanallūr", "", "IN", "356", "", "25", "628", "", "9.23921", "77.41132", "Asia/Kolkata"),("1253363", "Vasind", "", "IN", "356", "", "16", "517", "", "19.40844", "73.26285", "Asia/Kolkata"),("1253367", "Vāsco Da Gāma", "Васко-да-Гама", "IN", "356", "", "33", "586", "", "15.39585", "73.81568", "Asia/Kolkata"),("1253374", "Vasa", "", "IN", "356", "", "09", "483", "", "22.66079", "72.75519", "Asia/Kolkata"),("1253381", "Vartej", "", "IN", "356", "", "09", "481", "", "21.73947", "72.06553", "Asia/Kolkata"),("1253392", "Varkala", "Варкала", "IN", "356", "", "13", "601", "", "8.7333", "76.7167", "Asia/Kolkata"),("1253401", "Varca", "", "IN", "356", "", "33", "586", "", "15.23237", "73.94311", "Asia/Kolkata"),("1253403", "Varangaon", "", "IN", "356", "", "16", "499", "", "21.01767", "75.91042", "Asia/Kolkata"),("1253405", "Varanasi", "Варанаси", "IN", "356", "", "36", "197", "", "25.31668", "83.01041", "Asia/Kolkata"),("1253425", "Vānsada", "", "IN", "356", "", "09", "490", "", "20.75817", "73.36389", "Asia/Kolkata"),("1253437", "Vaniyambadi", "", "IN", "356", "", "25", "605", "", "12.68162", "78.62014", "Asia/Kolkata"),("1253452", "Vandavāsi", "", "IN", "356", "", "25", "606", "", "12.50429", "79.60556", "Asia/Kolkata"),("1253454", "Vandalūr", "", "IN", "356", "", "25", "604", "", "12.8924", "80.08079", "Asia/Kolkata"),("1253468", "Valsād", "", "IN", "356", "", "09", "491", "", "20.61013", "72.93428", "Asia/Kolkata"),("1253471", "Valpoy", "", "IN", "356", "", "33", "585", "", "15.53239", "74.13671", "Asia/Kolkata"),("1253472", "Valparai", "", "IN", "356", "", "25", "632", "", "10.32691", "76.95116", "Asia/Kolkata"),("1253481", "Vallam", "", "IN", "356", "", "25", "620", "", "10.71966", "79.05924", "Asia/Kolkata"),("1253482", "Vallabh Vidyanagar", "", "IN", "356", "", "09", "482", "", "22.53333", "72.9", "Asia/Kolkata"),("1253490", "Valavanur", "", "IN", "356", "", "25", "607", "", "11.92094", "79.58239", "Asia/Kolkata"),("1253500", "Azhikkal", "", "IN", "356", "", "13", "589", "", "11.91524", "75.34761", "Asia/Kolkata"),("1253504", "Valangaiman", "", "IN", "356", "", "25", "619", "", "10.89012", "79.39322", "Asia/Kolkata"),("1253512", "Valabhīpur", "", "IN", "356", "", "09", "481", "", "21.88868", "71.87935", "Asia/Kolkata"),("1253544", "Vaikam", "", "IN", "356", "", "13", "597", "", "9.74713", "76.39522", "Asia/Kolkata"),("1253545", "Vaijāpur", "", "IN", "356", "", "16", "515", "", "19.92672", "74.7275", "Asia/Kolkata"),("1253559", "Vāghodia", "", "IN", "356", "", "09", "486", "", "22.30505", "73.40016", "Asia/Kolkata"),("1253573", "Vadodara", "Вадодара", "IN", "356", "", "09", "486", "", "22.29941", "73.20812", "Asia/Kolkata"),("1253577", "Vadnagar", "", "IN", "356", "", "09", "471", "", "23.78593", "72.63893", "Asia/Kolkata"),("1253578", "Vadlapūdi", "", "IN", "356", "", "02", "550", "", "14.31119", "79.8043", "Asia/Kolkata"),("1253579", "Vādippatti", "", "IN", "356", "", "25", "623", "", "10.08481", "77.96113", "Asia/Kolkata"),("1253595", "Vadamadurai", "", "IN", "356", "", "25", "612", "", "10.44026", "78.09999", "Asia/Kolkata"),("1253605", "Vadakku Valliyūr", "", "IN", "356", "", "25", "628", "", "8.38095", "77.6132", "Asia/Kolkata"),("1253610", "Vāda", "", "IN", "356", "", "16", "517", "", "19.65347", "73.14811", "Asia/Kolkata"),("1253621", "Ūttukkuli", "", "IN", "356", "", "25", "633", "", "11.16892", "77.45431", "Asia/Kolkata"),("1253623", "Uttiramerūr", "", "IN", "356", "", "25", "604", "", "12.61433", "79.75748", "Asia/Kolkata"),("1253628", "Uttarkāshi", "", "IN", "356", "", "39", "056", "", "30.72986", "78.44342", "Asia/Kolkata"),("1253635", "Uttamapālaiyam", "", "IN", "356", "", "25", "624", "", "9.80701", "77.32718", "Asia/Kolkata"),("1253638", "Utraula", "", "IN", "356", "", "36", "182", "", "27.31933", "82.41872", "Asia/Kolkata"),("1253640", "Utrān", "", "IN", "356", "", "09", "492", "", "21.23333", "72.86667", "Asia/Kolkata"),("1253671", "Usilampatti", "", "IN", "356", "", "25", "623", "", "9.96936", "77.78621", "Asia/Kolkata"),("1253673", "Usehat", "", "IN", "356", "", "36", "149", "", "27.79796", "79.23763", "Asia/Kolkata"),("1253694", "Uri", "", "IN", "356", "", "12", "", "", "34.08064", "74.05088", "Asia/Kolkata"),("1253698", "Uravakonda", "", "IN", "356", "", "02", "553", "", "14.9456", "77.25928", "Asia/Kolkata"),("1253702", "Uran", "Уран", "IN", "356", "", "16", "520", "", "18.87813", "72.93924", "Asia/Kolkata"),("1253719", "Uppiliyapuram", "", "IN", "356", "", "25", "614", "", "11.26316", "78.51326", "Asia/Kolkata"),("1253736", "Upleta", "", "IN", "356", "", "09", "476", "", "21.74015", "70.28256", "Asia/Kolkata"),("1253744", "Uppal Kalan", "", "IN", "356", "", "40", "537", "", "17.40577", "78.55911", "Asia/Kolkata"),("1253747", "Unnāo", "", "IN", "356", "", "36", "156", "", "26.54706", "80.48781", "Asia/Kolkata"),("1253750", "Unjha", "", "IN", "356", "", "09", "471", "", "23.80366", "72.39101", "Asia/Kolkata"),("1253751", "Uniāra", "", "IN", "356", "", "24", "120", "", "26.15336", "75.21523", "Asia/Kolkata"),("1253754", "Unhel", "", "IN", "356", "", "35", "435", "", "23.33794", "75.55931", "Asia/Kolkata"),("1253782", "Una", "", "IN", "356", "", "11", "029", "", "31.46493", "76.26914", "Asia/Kolkata"),("1253783", "Una", "", "IN", "356", "", "09", "479", "", "20.82318", "71.03795", "Asia/Kolkata"),("1253785", "Ūn", "", "IN", "356", "", "36", "133", "", "29.58479", "77.2554", "Asia/Kolkata"),("1253786", "Un", "", "IN", "356", "", "09", "469", "", "23.88745", "71.76975", "Asia/Kolkata"),("1253796", "Umri", "", "IN", "356", "", "35", "420", "", "26.51056", "78.93667", "Asia/Kolkata"),("1253805", "Umreth", "", "IN", "356", "", "09", "482", "", "22.69881", "73.11561", "Asia/Kolkata"),("1253807", "Umred", "", "IN", "356", "", "16", "505", "", "20.85396", "79.32466", "Asia/Kolkata"),("1253815", "Umrāla", "", "IN", "356", "", "09", "481", "", "21.84353", "71.80305", "Asia/Kolkata"),("1253860", "Umarkot", "", "IN", "356", "", "37", "", "", "19.66529", "82.20629", "Asia/Kolkata"),("1253861", "Umarkhed", "", "IN", "356", "", "16", "510", "", "19.60144", "77.68878", "Asia/Kolkata"),("1253863", "Umaria", "", "IN", "356", "", "35", "431", "", "23.52473", "80.83716", "Asia/Kolkata"),("1253870", "Umarga", "", "IN", "356", "", "16", "525", "", "17.83841", "76.62331", "Asia/Kolkata"),("1253888", "Ullal", "", "IN", "356", "", "19", "575", "", "12.80569", "74.86058", "Asia/Kolkata"),("1253894", "Ulhasnagar", "", "IN", "356", "", "16", "517", "", "19.21667", "73.15", "Asia/Kolkata"),("1253898", "Ukwā", "", "IN", "356", "", "35", "457", "", "21.97102", "80.46625", "Asia/Kolkata"),("1253901", "Uklāna", "", "IN", "356", "", "10", "080", "", "29.51124", "75.87823", "Asia/Kolkata"),("1253914", "Ujjain", "Удджайн", "IN", "356", "", "35", "435", "", "23.18239", "75.77643", "Asia/Kolkata"),("1253918", "Ujhāni", "", "IN", "356", "", "36", "149", "", "28.00311", "79.00821", "Asia/Kolkata"),("1253930", "Ugu", "", "IN", "356", "", "36", "156", "", "26.79681", "80.32093", "Asia/Kolkata"),("1253944", "Udumalaippettai", "", "IN", "356", "", "25", "633", "", "10.58806", "77.24779", "Asia/Kolkata"),("1253947", "Udpura", "", "IN", "356", "", "24", "127", "", "24.73355", "75.97514", "Asia/Kolkata"),("1253952", "Udipi", "", "IN", "356", "", "19", "569", "", "13.33467", "74.74617", "Asia/Kolkata"),("1253956", "Udhampur", "", "IN", "356", "", "12", "019", "", "32.92431", "75.13573", "Asia/Kolkata"),("1253958", "Udgīr", "", "IN", "356", "", "16", "524", "", "18.39258", "77.11756", "Asia/Kolkata"),("1253972", "Udankudi", "", "IN", "356", "", "25", "627", "", "8.43048", "78.02882", "Asia/Kolkata"),("1253977", "Udalguri", "", "IN", "356", "", "03", "326", "", "26.75367", "92.10215", "Asia/Kolkata"),("1253984", "Udaipura", "", "IN", "356", "", "35", "446", "", "23.07434", "78.51108", "Asia/Kolkata"),("1253985", "Udaipur", "", "IN", "356", "", "24", "103", "", "27.72297", "75.47178", "Asia/Kolkata"),("1253986", "Udaipur", "Удайпур", "IN", "356", "", "24", "130", "", "24.58584", "73.71346", "Asia/Kolkata"),("1253987", "Udaipur", "Удайпур", "IN", "356", "", "26", "290", "", "23.53333", "91.48333", "Asia/Kolkata"),("1253992", "Udaigiri", "", "IN", "356", "", "21", "390", "", "20.12345", "84.36906", "Asia/Kolkata"),("1253993", "Ooty", "Утакаманд", "IN", "356", "", "25", "611", "", "11.4134", "76.69521", "Asia/Kolkata"),("1254000", "Bara Uchāna", "", "IN", "356", "", "10", "077", "", "29.46747", "76.17798", "Asia/Kolkata"),("1254025", "Turuvekere", "", "IN", "356", "", "19", "571", "", "13.16374", "76.66641", "Asia/Kolkata"),("1254043", "Turaiyūr", "", "IN", "356", "", "25", "614", "", "11.14985", "78.59888", "Asia/Kolkata"),("1254046", "Tura", "", "IN", "356", "", "18", "293", "", "25.51421", "90.20239", "Asia/Kolkata"),("1254054", "Tuni", "", "IN", "356", "", "02", "545", "", "17.35905", "82.54607", "Asia/Kolkata"),("1254069", "Tūndla", "", "IN", "356", "", "36", "147", "", "27.2146", "78.23683", "Asia/Kolkata"),("1254080", "Tumsar", "", "IN", "356", "", "16", "506", "", "21.38333", "79.73333", "Asia/Kolkata"),("1254089", "Tumkūr", "", "IN", "356", "", "19", "571", "", "13.34136", "77.1022", "Asia/Kolkata"),("1254102", "Tulsīpur", "", "IN", "356", "", "36", "182", "", "27.5337", "82.41653", "Asia/Kolkata"),("1254111", "Tuljāpur", "", "IN", "356", "", "16", "525", "", "18.00804", "76.07011", "Asia/Kolkata"),("1254131", "Tufānganj", "", "IN", "356", "", "28", "329", "", "26.31688", "89.66549", "Asia/Kolkata"),("1254133", "Tuensang", "", "IN", "356", "", "20", "267", "", "26.26704", "94.82415", "Asia/Kolkata"),("1254142", "Tsrār Sharīf", "", "IN", "356", "", "12", "002", "", "33.86319", "74.76524", "Asia/Kolkata"),("1254163", "Thiruvananthapuram", "Тируванантапурам", "IN", "356", "", "13", "601", "", "8.4855", "76.94924", "Asia/Kolkata"),("1254177", "Trimbak", "", "IN", "356", "", "16", "516", "", "19.93268", "73.52907", "Asia/Kolkata"),("1254187", "Trichūr", "Тричура", "IN", "356", "", "13", "594", "", "10.51667", "76.21667", "Asia/Kolkata"),("1254198", "Trāl", "", "IN", "356", "", "12", "012", "", "33.92708", "75.11585", "Asia/Kolkata"),("1254214", "Toshām", "", "IN", "356", "", "10", "081", "", "28.86993", "75.9165", "Asia/Kolkata"),("1254222", "Tori-Fatehpur", "", "IN", "356", "", "36", "166", "", "25.45505", "79.11428", "Asia/Kolkata"),("1254231", "Topchānchi", "", "IN", "356", "", "38", "354", "", "23.90381", "86.19792", "Asia/Kolkata"),("1254241", "Tonk", "", "IN", "356", "", "24", "120", "", "26.16638", "75.78824", "Asia/Kolkata"),("1254249", "Tondi", "", "IN", "356", "", "25", "626", "", "9.74173", "79.01774", "Asia/Kolkata"),("1254274", "Tohāna", "", "IN", "356", "", "10", "078", "", "29.71332", "75.90441", "Asia/Kolkata"),("1254282", "Todaraisingh", "", "IN", "356", "", "24", "120", "", "26.02401", "75.48182", "Asia/Kolkata"),("1254283", "Todabhim", "", "IN", "356", "", "24", "107", "", "26.91667", "76.81667", "Asia/Kolkata"),("1254302", "Titron", "", "IN", "356", "", "36", "132", "", "29.66824", "77.32391", "Asia/Kolkata"),("1254304", "Titlāgarh", "", "IN", "356", "", "21", "393", "", "20.28961", "83.15233", "Asia/Kolkata"),("1254309", "Titāgarh", "", "IN", "356", "", "28", "337", "", "22.74252", "88.37326", "Asia/Kolkata"),("1254310", "Titābar", "", "IN", "356", "", "03", "312", "", "26.6014", "94.20386", "Asia/Kolkata"),("1254317", "Tisaiyanvilai", "", "IN", "356", "", "25", "628", "", "8.33249", "77.86586", "Asia/Kolkata"),("1254320", "Tiruvottiyūr", "", "IN", "356", "", "25", "602", "", "13.15823", "80.30181", "Asia/Kolkata"),("1254321", "Thiruvidaimaruthur", "", "IN", "356", "", "25", "620", "", "10.99857", "79.45227", "Asia/Kolkata"),("1254322", "Cheyyar", "", "IN", "356", "", "25", "606", "", "12.66052", "79.54308", "Asia/Kolkata"),("1254327", "Tiruvannāmalai", "Тируваннамалай", "IN", "356", "", "25", "606", "", "12.22662", "79.07461", "Asia/Kolkata"),("1254331", "Tiruvallur", "Тируваллур", "IN", "356", "", "25", "602", "", "13.14376", "79.90889", "Asia/Kolkata"),("1254335", "Tiruvalla", "", "IN", "356", "", "13", "599", "", "9.3816", "76.57489", "Asia/Kolkata"),("1254342", "Thiruthani", "", "IN", "356", "", "25", "602", "", "13.17594", "79.61637", "Asia/Kolkata"),("1254343", "Tiruttangal", "", "IN", "356", "", "25", "625", "", "9.48333", "77.83333", "Asia/Kolkata"),("1254346", "Tirur", "", "IN", "356", "", "13", "592", "", "10.91368", "75.92118", "Asia/Kolkata"),("1254347", "Tiruppuvanam", "", "IN", "356", "", "25", "622", "", "9.82556", "78.25792", "Asia/Kolkata"),("1254348", "Tiruppur", "Тируппур", "IN", "356", "", "25", "633", "", "11.11541", "77.35456", "Asia/Kolkata"),("1254356", "Tirupparangunram", "", "IN", "356", "", "25", "623", "", "9.88085", "78.07252", "Asia/Kolkata"),("1254360", "Tirupati", "Тирупати", "IN", "356", "", "02", "554", "", "13.63551", "79.41989", "Asia/Kolkata"),("1254361", "Tirunelveli", "Тирунелвели", "IN", "356", "", "25", "628", "", "8.72518", "77.68452", "Asia/Kolkata"),("1254367", "Tirumullaivāsal", "", "IN", "356", "", "25", "618", "", "11.24025", "79.83801", "Asia/Kolkata"),("1254373", "Tirumala", "", "IN", "356", "", "02", "554", "", "13.68333", "79.35", "Asia/Kolkata"),("1254374", "Tirumakūdal Narsipur", "", "IN", "356", "", "19", "577", "", "12.21207", "76.9018", "Asia/Kolkata"),("1254377", "Tirukkoyilur", "", "IN", "356", "", "25", "607", "", "11.9662", "79.20259", "Asia/Kolkata"),("1254378", "Thirukattupalli", "", "IN", "356", "", "25", "620", "", "10.84431", "78.95647", "Asia/Kolkata"),("1254385", "Tiruchengode", "", "IN", "356", "", "25", "609", "", "11.38016", "77.89444", "Asia/Kolkata"),("1254388", "Tiruchirappalli", "Тируччираппалли", "IN", "356", "", "25", "614", "", "10.8155", "78.69651", "Asia/Kolkata"),("1254390", "Tiruchchendur", "", "IN", "356", "", "25", "627", "", "8.49725", "78.11906", "Asia/Kolkata"),("1254396", "Tīrthahalli", "", "IN", "356", "", "19", "568", "", "13.68835", "75.24548", "Asia/Kolkata"),("1254400", "Tirodi", "", "IN", "356", "", "35", "457", "", "21.68522", "79.71906", "Asia/Kolkata"),("1254415", "Tīra Sujānpur", "", "IN", "356", "", "11", "028", "", "31.83364", "76.50539", "Asia/Kolkata"),("1254420", "Tiptūr", "", "IN", "356", "", "19", "571", "", "13.2563", "76.47768", "Asia/Kolkata"),("1254432", "Tinsukia", "", "IN", "356", "", "03", "309", "", "27.48905", "95.35992", "Asia/Kolkata"),("1254436", "Tinnanūr", "", "IN", "356", "", "25", "604", "", "13.11448", "80.02713", "Asia/Kolkata"),("1254442", "Tindwāri", "", "IN", "356", "", "36", "170", "", "25.61739", "80.52718", "Asia/Kolkata"),("1254444", "Tindivanam", "", "IN", "356", "", "25", "607", "", "12.234", "79.65551", "Asia/Kolkata"),("1254481", "Tilhar", "", "IN", "356", "", "36", "152", "", "27.96282", "79.73827", "Asia/Kolkata"),("1254513", "Tīkri", "", "IN", "356", "", "36", "139", "", "29.2291", "77.35479", "Asia/Kolkata"),("1254534", "Tīkamgarh", "", "IN", "356", "", "35", "424", "", "24.74327", "78.83061", "Asia/Kolkata"),("1254536", "Tikaitnagar", "", "IN", "356", "", "36", "176", "", "26.94612", "81.56583", "Asia/Kolkata"),("1254538", "Tijāra", "", "IN", "356", "", "24", "104", "", "27.93411", "76.85541", "Asia/Kolkata"),("1254570", "Thoubāl", "", "IN", "356", "", "17", "276", "", "24.63881", "93.99639", "Asia/Kolkata"),("1254589", "Thiruvarur", "", "IN", "356", "", "25", "619", "", "10.77269", "79.6368", "Asia/Kolkata"),("1254590", "Thiruvaiyaru", "", "IN", "356", "", "25", "620", "", "10.88405", "79.10362", "Asia/Kolkata"),("1254609", "Thenzawl", "", "IN", "356", "", "31", "283", "", "23.31667", "92.75", "Asia/Kolkata"),("1254624", "Thāsra", "", "IN", "356", "", "09", "483", "", "22.79831", "73.21174", "Asia/Kolkata"),("1254638", "Tharād", "", "IN", "356", "", "09", "469", "", "24.39597", "71.62577", "Asia/Kolkata"),("1254645", "Thanniyam", "", "IN", "356", "", "13", "594", "", "10.41667", "76.13333", "Asia/Kolkata"),("1254649", "Thanjāvūr", "Тханджавур", "IN", "356", "", "25", "620", "", "10.78523", "79.13909", "Asia/Kolkata"),("1254657", "Thānesar", "", "IN", "356", "", "10", "072", "", "29.97323", "76.83214", "Asia/Kolkata"),("1254661", "Thāne", "Таня", "IN", "356", "", "16", "517", "", "19.19704", "72.96355", "Asia/Kolkata"),("1254663", "Thandla", "", "IN", "356", "", "35", "464", "", "23.00959", "74.57747", "Asia/Kolkata"),("1254673", "Thāna Bhawan", "", "IN", "356", "", "36", "133", "", "29.58605", "77.41811", "Asia/Kolkata"),("1254675", "Thān", "", "IN", "356", "", "09", "475", "", "22.57422", "71.19942", "Asia/Kolkata"),("1254694", "Thākurganj", "", "IN", "356", "", "34", "210", "", "26.42742", "88.13112", "Asia/Kolkata"),("1254695", "Thakurdwara", "", "IN", "356", "", "36", "135", "", "29.19203", "78.86145", "Asia/Kolkata"),("1254709", "Tezu", "", "IN", "356", "", "30", "259", "", "27.91256", "96.12882", "Asia/Kolkata"),("1254710", "Tezpur", "Тезпур", "IN", "356", "", "03", "306", "", "26.63333", "92.8", "Asia/Kolkata"),("1254727", "Terdāl", "", "IN", "356", "", "19", "556", "", "16.49379", "75.04667", "Asia/Kolkata"),("1254732", "Teonthar", "", "IN", "356", "", "35", "430", "", "24.98207", "81.64194", "Asia/Kolkata"),("1254744", "Thenkasi", "", "IN", "356", "", "25", "628", "", "8.96003", "77.31525", "Asia/Kolkata"),("1254745", "Teni", "Тхени", "IN", "356", "", "25", "624", "", "10.01531", "77.482", "Asia/Kolkata"),("1254751", "Tendūkheda", "", "IN", "356", "", "35", "428", "", "23.3962", "79.53947", "Asia/Kolkata"),("1254780", "Tellicherry", "", "IN", "356", "", "13", "589", "", "11.74811", "75.4929", "Asia/Kolkata"),("1254787", "Telhāra", "", "IN", "356", "", "16", "501", "", "21.02694", "76.83889", "Asia/Kolkata"),("1254794", "Tekkali", "", "IN", "356", "", "02", "542", "", "18.6057", "84.23546", "Asia/Kolkata"),("1254795", "Tekkalakote", "", "IN", "356", "", "19", "565", "", "15.53444", "76.87703", "Asia/Kolkata"),("1254797", "Tekāri", "", "IN", "356", "", "34", "236", "", "24.94253", "84.84265", "Asia/Kolkata"),("1254798", "Tekanpur", "", "IN", "356", "", "35", "421", "", "25.99401", "78.28322", "Asia/Kolkata"),("1254808", "Tehri", "Техри", "IN", "356", "", "39", "059", "", "30.39086", "78.4803", "Asia/Kolkata"),("1254813", "Teghra", "", "IN", "356", "", "34", "222", "", "25.49043", "85.94001", "Asia/Kolkata"),("1254842", "Tāttayyangārpettai", "", "IN", "356", "", "25", "614", "", "11.12337", "78.44972", "Asia/Kolkata"),("1254858", "Tāsgaon", "", "IN", "356", "", "16", "531", "", "17.037", "74.60171", "Asia/Kolkata"),("1254868", "Tarn Tāran", "", "IN", "356", "", "23", "050", "", "31.45191", "74.92777", "Asia/Kolkata"),("1254880", "Tarikere", "", "IN", "356", "", "19", "570", "", "13.70954", "75.81382", "Asia/Kolkata"),("1254900", "Tārāpur", "", "IN", "356", "", "16", "517", "", "19.86499", "72.68426", "Asia/Kolkata"),("1254904", "Tharangambadi", "", "IN", "356", "", "25", "618", "", "11.02764", "79.85425", "Asia/Kolkata"),("1254908", "Tārānagar", "", "IN", "356", "", "24", "102", "", "28.6686", "75.03207", "Asia/Kolkata"),("1254909", "Tarāna", "Тарана", "IN", "356", "", "35", "435", "", "23.33383", "76.04253", "Asia/Kolkata"),("1254910", "Tāramangalam", "", "IN", "356", "", "25", "608", "", "11.7", "77.98333", "Asia/Kolkata"),("1254912", "Tarakeswar", "", "IN", "356", "", "28", "338", "", "22.88605", "88.01363", "Asia/Kolkata"),("1254925", "Tarabha", "", "IN", "356", "", "21", "392", "", "20.73252", "83.67443", "Asia/Kolkata"),("1254948", "Tāoru", "", "IN", "356", "", "10", "087", "", "28.21173", "76.94984", "Asia/Kolkata"),("1254953", "Tanuku", "", "IN", "356", "", "02", "546", "", "16.75438", "81.68143", "Asia/Kolkata"),("1254972", "Tankāra", "", "IN", "356", "", "09", "476", "", "22.65622", "70.74945", "Asia/Kolkata"),("1255004", "Tāndūr", "", "IN", "356", "", "40", "537", "", "17.24849", "77.57698", "Asia/Kolkata"),("1255023", "Tānda", "", "IN", "356", "", "36", "136", "", "28.97621", "78.94187", "Asia/Kolkata"),("1255024", "Tāndā", "", "IN", "356", "", "36", "178", "", "26.54953", "82.65841", "Asia/Kolkata"),("1255027", "Tanakpur", "", "IN", "356", "", "39", "067", "", "29.074", "80.11139", "Asia/Kolkata"),("1255046", "Tamlūk", "", "IN", "356", "", "28", "345", "", "22.30083", "87.92593", "Asia/Kolkata"),("1255076", "Talwāra", "", "IN", "356", "", "23", "038", "", "31.9376", "75.88657", "Asia/Kolkata"),("1255082", "Talwandi Bhai", "", "IN", "356", "", "23", "043", "", "30.85584", "74.92979", "Asia/Kolkata"),("1255104", "Taloda", "", "IN", "356", "", "16", "497", "", "21.56128", "74.21238", "Asia/Kolkata"),("1255121", "Talipparamba", "", "IN", "356", "", "13", "589", "", "12.04161", "75.35927", "Asia/Kolkata"),("1255122", "Tālīkota", "", "IN", "356", "", "19", "557", "", "16.47311", "76.31085", "Asia/Kolkata"),("1255127", "Tālgrām", "", "IN", "356", "", "36", "160", "", "27.04753", "79.64811", "Asia/Kolkata"),("1255130", "Talen", "", "IN", "356", "", "35", "442", "", "23.56949", "76.72821", "Asia/Kolkata"),("1255131", "Taleigao", "", "IN", "356", "", "33", "585", "", "15.46915", "73.83285", "Asia/Kolkata"),("1255134", "Talegaon Dābhāde", "", "IN", "356", "", "16", "521", "", "18.73502", "73.67561", "Asia/Kolkata"),("1255143", "Tālcher", "", "IN", "356", "", "21", "384", "", "20.94927", "85.23354", "Asia/Kolkata"),("1255146", "Tālbahat", "", "IN", "356", "", "36", "167", "", "25.04357", "78.43441", "Asia/Kolkata"),("1255175", "Talāja", "", "IN", "356", "", "09", "481", "", "21.3527", "72.03524", "Asia/Kolkata"),("1255187", "Tāl", "", "IN", "356", "", "35", "434", "", "23.71979", "75.38514", "Asia/Kolkata"),("1255211", "Tāki", "Такой", "IN", "356", "", "28", "337", "", "22.58867", "88.93253", "Asia/Kolkata"),("1255212", "Takhatpur", "", "IN", "356", "", "37", "406", "", "22.12915", "81.86959", "Asia/Kolkata"),("1255213", "Takhatgarh", "", "IN", "356", "", "24", "118", "", "25.32235", "73.00487", "Asia/Kolkata"),("1255224", "Tājpur", "", "IN", "356", "", "36", "134", "", "29.16242", "78.48458", "Asia/Kolkata"),("1255254", "Tādpatri", "", "IN", "356", "", "02", "553", "", "14.90832", "78.01031", "Asia/Kolkata"),("1255264", "Tādepallegūdem", "", "IN", "356", "", "02", "546", "", "16.81467", "81.52717", "Asia/Kolkata"),("1255265", "Tādepalle", "", "IN", "356", "", "02", "548", "", "16.48333", "80.6", "Asia/Kolkata"),("1255283", "Swamimalai", "", "IN", "356", "", "25", "620", "", "10.95749", "79.32776", "Asia/Kolkata"),("1255301", "Susner", "", "IN", "356", "", "35", "436", "", "23.94667", "76.08825", "Asia/Kolkata"),("1255344", "Suriāpet", "", "IN", "356", "", "40", "539", "", "17.14054", "79.62045", "Asia/Kolkata"),("1255346", "Suriānwān", "", "IN", "356", "", "36", "198", "", "25.46387", "82.41922", "Asia/Kolkata"),("1255348", "Surgāna", "", "IN", "356", "", "16", "516", "", "20.55956", "73.63747", "Asia/Kolkata"),("1255349", "Surendranagar", "", "IN", "356", "", "09", "475", "", "22.72706", "71.64856", "Asia/Kolkata"),("1255361", "Sūratgarh", "Суратгарх", "IN", "356", "", "24", "099", "", "29.3215", "73.89979", "Asia/Kolkata"),("1255364", "Sūrat", "", "IN", "356", "", "09", "492", "", "21.19594", "72.83023", "Asia/Kolkata"),("1255372", "Sūrandai", "", "IN", "356", "", "25", "628", "", "8.97574", "77.41923", "Asia/Kolkata"),("1255383", "Sūrajgarh", "", "IN", "356", "", "24", "103", "", "28.31005", "75.73271", "Asia/Kolkata"),("1255396", "Supaul", "", "IN", "356", "", "34", "208", "", "26.11503", "86.59527", "Asia/Kolkata"),("1255425", "Sunel", "", "IN", "356", "", "24", "129", "", "24.37065", "75.95708", "Asia/Kolkata"),("1255434", "Sundarnagar", "", "IN", "356", "", "11", "027", "", "31.53523", "76.905", "Asia/Kolkata"),("1255437", "Sundargarh", "", "IN", "356", "", "21", "374", "", "22.11667", "84.03333", "Asia/Kolkata"),("1255449", "Sunām", "", "IN", "356", "", "23", "053", "", "30.12883", "75.79943", "Asia/Kolkata"),("1255478", "Sumbal", "", "IN", "356", "", "12", "008", "", "34.23072", "74.6472", "Asia/Kolkata"),("1255482", "Sulya", "", "IN", "356", "", "19", "575", "", "12.561", "75.38741", "Asia/Kolkata"),("1255483", "Sūlūru", "", "IN", "356", "", "02", "550", "", "13.7", "80.01667", "Asia/Kolkata"),("1255484", "Sulur", "", "IN", "356", "", "25", "632", "", "11.02427", "77.12565", "Asia/Kolkata"),("1255488", "Sultanpur", "", "IN", "356", "", "23", "036", "", "31.21468", "75.19602", "Asia/Kolkata"),("1255489", "Sultānpur", "", "IN", "356", "", "39", "068", "", "29.75534", "78.11034", "Asia/Kolkata"),("1255491", "Sultānpur", "", "IN", "356", "", "36", "179", "", "26.25788", "82.07269", "Asia/Kolkata"),("1255493", "Sultānpur", "", "IN", "356", "", "35", "446", "", "23.13812", "77.93404", "Asia/Kolkata"),("1255551", "Suket", "", "IN", "356", "", "24", "127", "", "24.64609", "76.0417", "Asia/Kolkata"),("1255560", "Sūjāngarh", "", "IN", "356", "", "24", "102", "", "27.7", "74.46667", "Asia/Kolkata"),("1255584", "Suchindram", "", "IN", "356", "", "25", "629", "", "8.1531", "77.46596", "Asia/Kolkata"),("1255597", "Suār", "Суар", "IN", "356", "", "36", "136", "", "29.02841", "79.05654", "Asia/Kolkata"),("1255616", "Srivilliputhur", "", "IN", "356", "", "25", "625", "", "9.51272", "77.63369", "Asia/Kolkata"),("1255619", "Srīvardhan", "", "IN", "356", "", "16", "520", "", "18.04592", "73.01552", "Asia/Kolkata"),("1255620", "Srivaikuntam", "", "IN", "356", "", "25", "627", "", "8.62931", "77.91281", "Asia/Kolkata"),("1255621", "Srīsailain", "", "IN", "356", "", "02", "552", "", "16.07217", "78.86816", "Asia/Kolkata"),("1255625", "Srīrāmnagar", "", "IN", "356", "", "40", "537", "", "17.26652", "78.25544", "Asia/Kolkata"),("1255630", "Srīperumbūdūr", "", "IN", "356", "", "25", "604", "", "12.96763", "79.94197", "Asia/Kolkata"),("1255631", "Srīnivāspur", "", "IN", "356", "", "19", "581", "", "13.33914", "78.21175", "Asia/Kolkata"),("1255634", "Srinagar", "Шринагар", "IN", "356", "", "12", "010", "", "34.08565", "74.80555", "Asia/Kolkata"),("1255635", "Srīnagar", "Шринагар", "IN", "356", "", "39", "061", "", "30.22243", "78.78341", "Asia/Kolkata"),("1255640", "Srīmushnam", "", "IN", "356", "", "25", "617", "", "11.40103", "79.40403", "Asia/Kolkata"),("1255643", "Sri Mādhopur", "", "IN", "356", "", "24", "111", "", "27.46599", "75.59736", "Asia/Kolkata"),("1255646", "Karanpur", "", "IN", "356", "", "24", "099", "", "29.84042", "73.45519", "Asia/Kolkata"),("1255647", "Chicacole", "", "IN", "356", "", "02", "542", "", "18.2989", "83.89751", "Asia/Kolkata"),("1255654", "Sri Dūngargarh", "", "IN", "356", "", "24", "101", "", "28.09617", "74.00868", "Asia/Kolkata"),("1255667", "Soygaon", "", "IN", "356", "", "16", "515", "", "20.59606", "75.61765", "Asia/Kolkata"),("1255704", "Soron", "Сорон", "IN", "356", "", "36", "202", "", "27.89055", "78.74621", "Asia/Kolkata"),("1255705", "Soro", "", "IN", "356", "", "21", "377", "", "21.27851", "86.68833", "Asia/Kolkata"),("1255708", "Sorbhog", "", "IN", "356", "", "03", "303", "", "26.48612", "90.8859", "Asia/Kolkata"),("1255712", "Sorada", "", "IN", "356", "", "21", "388", "", "19.76082", "84.42997", "Asia/Kolkata"),("1255713", "Sorab", "", "IN", "356", "", "19", "568", "", "14.38144", "75.09183", "Asia/Kolkata"),("1255714", "Sopur", "", "IN", "356", "", "12", "008", "", "34.28671", "74.47228", "Asia/Kolkata"),("1255744", "Sonīpat", "", "IN", "356", "", "10", "076", "", "28.99478", "77.01937", "Asia/Kolkata"),("1255762", "Songadh", "", "IN", "356", "", "09", "493", "", "21.16966", "73.56357", "Asia/Kolkata"),("1255763", "Sonepur", "", "IN", "356", "", "21", "392", "", "20.83333", "83.91667", "Asia/Kolkata"),("1255766", "Sonegaon", "", "IN", "356", "", "16", "504", "", "20.62915", "78.69207", "Asia/Kolkata"),("1255788", "Sonāri", "", "IN", "356", "", "03", "311", "", "27.02462", "95.01629", "Asia/Kolkata"),("1255791", "Sonāmura", "", "IN", "356", "", "26", "289", "", "23.47547", "91.2659", "Asia/Kolkata"),("1255792", "Sonāmukhi", "", "IN", "356", "", "28", "339", "", "23.30521", "87.41336", "Asia/Kolkata"),("1255811", "Somvārpet", "", "IN", "356", "", "19", "576", "", "12.59698", "75.84957", "Asia/Kolkata"),("1255816", "Sompeta", "", "IN", "356", "", "02", "542", "", "18.94419", "84.58449", "Asia/Kolkata"),("1255823", "Someshwar", "", "IN", "356", "", "19", "569", "", "13.49112", "75.06646", "Asia/Kolkata"),("1255844", "Solim", "", "IN", "356", "", "33", "585", "", "15.61521", "73.7674", "Asia/Kolkata"),("1255850", "Solan", "Солана", "IN", "356", "", "11", "031", "", "30.90908", "77.10869", "Asia/Kolkata"),("1255858", "Sojītra", "", "IN", "356", "", "09", "482", "", "22.53884", "72.71984", "Asia/Kolkata"),("1255860", "Sojat", "", "IN", "356", "", "24", "118", "", "25.92493", "73.66633", "Asia/Kolkata"),("1255870", "Sohna", "", "IN", "356", "", "10", "086", "", "28.24737", "77.06544", "Asia/Kolkata"),("1255884", "Sohāgpur", "", "IN", "356", "", "35", "449", "", "22.70055", "78.19522", "Asia/Kolkata"),("1255887", "Sohāgi", "", "IN", "356", "", "35", "430", "", "24.98181", "81.69558", "Asia/Kolkata"),("1255893", "Sodpur", "", "IN", "356", "", "28", "337", "", "22.70428", "88.39166", "Asia/Kolkata"),("1255910", "Soalkuchi", "", "IN", "356", "", "03", "321", "", "26.16806", "91.57111", "Asia/Kolkata"),("1255925", "Siwāna", "", "IN", "356", "", "24", "115", "", "25.65154", "72.42243", "Asia/Kolkata"),("1255927", "Siwān", "Сиван", "IN", "356", "", "34", "218", "", "26.22096", "84.35609", "Asia/Kolkata"),("1255947", "Sivakasi", "", "IN", "356", "", "25", "625", "", "9.44999", "77.79797", "Asia/Kolkata"),("1255950", "Sivagiri", "", "IN", "356", "", "25", "610", "", "11.1194", "77.78788", "Asia/Kolkata"),("1255951", "Sivagiri", "", "IN", "356", "", "25", "628", "", "9.34461", "77.42911", "Asia/Kolkata"),("1255953", "Sivaganga", "Шиваганга", "IN", "356", "", "25", "622", "", "9.84701", "78.48358", "Asia/Kolkata"),("1255955", "Siuri", "", "IN", "356", "", "28", "334", "", "23.90806", "87.52773", "Asia/Kolkata"),("1255963", "Sitārganj", "", "IN", "356", "", "39", "067", "", "28.9293", "79.70436", "Asia/Kolkata"),("1255969", "Sītāpur", "", "IN", "356", "", "36", "154", "", "27.56192", "80.68265", "Asia/Kolkata"),("1255981", "Sītāmau", "", "IN", "356", "", "35", "433", "", "24.01473", "75.35324", "Asia/Kolkata"),("1255983", "Sītāmarhi", "", "IN", "356", "", "34", "206", "", "26.59357", "85.4906", "Asia/Kolkata"),("1255995", "Siswā Bāzār", "", "IN", "356", "", "36", "187", "", "27.14652", "83.75803", "Asia/Kolkata"),("1256003", "Sisauli", "", "IN", "356", "", "36", "133", "", "29.41386", "77.4689", "Asia/Kolkata"),("1256025", "Sirūr", "", "IN", "356", "", "16", "521", "", "18.8276", "74.37475", "Asia/Kolkata"),("1256027", "Sirumugai", "", "IN", "356", "", "25", "632", "", "11.32137", "77.00521", "Asia/Kolkata"),("1256029", "Siruguppa", "", "IN", "356", "", "19", "565", "", "15.63", "76.89217", "Asia/Kolkata"),("1256039", "Sirsilla", "", "IN", "356", "", "40", "534", "", "18.38865", "78.81048", "Asia/Kolkata"),("1256040", "Sirsi", "", "IN", "356", "", "36", "135", "", "28.63916", "78.64303", "Asia/Kolkata"),("1256047", "Sirsi", "", "IN", "356", "", "19", "563", "", "14.62072", "74.83554", "Asia/Kolkata"),("1256050", "Sirsāganj", "", "IN", "356", "", "36", "147", "", "27.05715", "78.68661", "Asia/Kolkata"),("1256052", "Sirsa", "", "IN", "356", "", "10", "079", "", "29.53489", "75.02898", "Asia/Kolkata"),("1256053", "Sirsā", "", "IN", "356", "", "36", "175", "", "25.2634", "82.0919", "Asia/Kolkata"),("1256063", "Sirpur", "", "IN", "356", "", "40", "532", "", "19.47953", "79.57558", "Asia/Kolkata"),("1256064", "Sironj", "", "IN", "356", "", "35", "443", "", "24.10313", "77.69055", "Asia/Kolkata"),("1256067", "Sirohi", "", "IN", "356", "", "24", "117", "", "24.88838", "72.84794", "Asia/Kolkata"),("1256072", "Sirmaur", "", "IN", "356", "", "35", "430", "", "24.83648", "81.36448", "Asia/Kolkata"),("1256075", "Sīrkāzhi", "", "IN", "356", "", "25", "618", "", "11.23725", "79.73585", "Asia/Kolkata"),("1256087", "Sirhind", "", "IN", "356", "", "23", "040", "", "30.64321", "76.38421", "Asia/Kolkata"),("1256096", "Sirāthu", "", "IN", "356", "", "36", "174", "", "25.64292", "81.31855", "Asia/Kolkata"),("1256104", "Sīra", "", "IN", "356", "", "19", "571", "", "13.74155", "76.9043", "Asia/Kolkata"),("1256117", "Sinor", "", "IN", "356", "", "09", "486", "", "21.91117", "73.33974", "Asia/Kolkata"),("1256119", "Sinnar", "Синнар", "IN", "356", "", "16", "516", "", "19.84505", "73.99866", "Asia/Kolkata"),("1256122", "Sini", "", "IN", "356", "", "38", "369", "", "22.79193", "85.9485", "Asia/Kolkata"),("1256124", "Singur", "", "IN", "356", "", "28", "338", "", "22.80917", "88.22944", "Asia/Kolkata"),("1256126", "Singtam", "", "IN", "356", "", "29", "244", "", "27.23467", "88.50168", "Asia/Kolkata"),("1256146", "Singoli", "", "IN", "356", "", "35", "432", "", "24.96667", "75.3", "Asia/Kolkata"),("1256176", "Singarāyakonda", "", "IN", "356", "", "02", "549", "", "15.23046", "80.02794", "Asia/Kolkata"),("1256181", "Singapperumālkovil", "", "IN", "356", "", "25", "604", "", "12.75947", "80.0075", "Asia/Kolkata"),("1256184", "Singānallūr", "", "IN", "356", "", "25", "632", "", "10.99816", "77.03375", "Asia/Kolkata"),("1256206", "Sindi", "", "IN", "356", "", "16", "504", "", "20.80509", "78.88752", "Asia/Kolkata"),("1256207", "Sindhnūr", "", "IN", "356", "", "19", "559", "", "15.76983", "76.75581", "Asia/Kolkata"),("1256214", "Sindgi", "", "IN", "356", "", "19", "557", "", "16.91883", "76.23368", "Asia/Kolkata"),("1256237", "Shimla", "Шимла", "IN", "356", "", "11", "033", "", "31.10442", "77.16662", "Asia/Kolkata"),("1256245", "Simga", "", "IN", "356", "", "37", "410", "", "21.6281", "81.70376", "Asia/Kolkata"),("1256246", "Simdega", "", "IN", "356", "", "38", "367", "", "22.61523", "84.50208", "Asia/Kolkata"),("1256251", "Simaria", "", "IN", "356", "", "35", "430", "", "24.79497", "81.152", "Asia/Kolkata"),("1256259", "Silvassa", "", "IN", "356", "", "06", "496", "", "20.27386", "72.99673", "Asia/Kolkata"),("1256269", "Sillod", "", "IN", "356", "", "16", "515", "", "20.30303", "75.65284", "Asia/Kolkata"),("1256287", "Silchar", "Силчар", "IN", "356", "", "03", "316", "", "24.82733", "92.79787", "Asia/Kolkata"),("1256295", "Silao", "Силао", "IN", "356", "", "34", "229", "", "25.08358", "85.42804", "Asia/Kolkata"),("1256320", "Sīkar", "", "IN", "356", "", "24", "111", "", "27.61206", "75.13996", "Asia/Kolkata"),("1256322", "Sikandra Rao", "", "IN", "356", "", "36", "144", "", "27.68859", "78.37985", "Asia/Kolkata"),("1256324", "Sikandra", "", "IN", "356", "", "36", "163", "", "26.36722", "79.6298", "Asia/Kolkata"),("1256328", "Sikandarpur", "", "IN", "356", "", "36", "193", "", "26.04327", "84.05298", "Asia/Kolkata"),("1256329", "Sikandarābād", "", "IN", "356", "", "36", "142", "", "28.45226", "77.70004", "Asia/Kolkata"),("1256333", "Sikka", "", "IN", "356", "", "09", "477", "", "22.43218", "69.84158", "Asia/Kolkata"),("1256335", "Sijua", "", "IN", "356", "", "38", "354", "", "23.77617", "86.33028", "Asia/Kolkata"),("1256340", "Sihorā", "", "IN", "356", "", "35", "451", "", "23.4871", "80.10404", "Asia/Kolkata"),("1256343", "Sihor", "", "IN", "356", "", "09", "481", "", "21.71134", "71.96179", "Asia/Kolkata"),("1256363", "Sidlaghatta", "", "IN", "356", "", "19", "582", "", "13.38896", "77.86444", "Asia/Kolkata"),("1256367", "Sidhpura", "", "IN", "356", "", "36", "202", "", "27.63312", "78.86918", "Asia/Kolkata"),("1256369", "Sidhi", "Сидхи", "IN", "356", "", "35", "462", "", "24.4038", "81.87954", "Asia/Kolkata"),("1256372", "Sidhaulī", "", "IN", "356", "", "36", "154", "", "27.28202", "80.8345", "Asia/Kolkata"),("1256377", "Siddipet", "", "IN", "356", "", "40", "535", "", "18.10483", "78.84858", "Asia/Kolkata"),("1256382", "Siddhapur", "", "IN", "356", "", "09", "470", "", "23.91783", "72.37212", "Asia/Kolkata"),("1256385", "Siddāpur", "", "IN", "356", "", "19", "563", "", "14.34322", "74.894", "Asia/Kolkata"),("1256388", "Sibsāgar", "Сибсагар", "IN", "356", "", "03", "311", "", "26.98427", "94.63784", "Asia/Kolkata"),("1256409", "Shyamnagar", "", "IN", "356", "IN", "28", "338", "", "22.83333", "88.36667", "Asia/Kolkata"),("1256414", "Shupīyan", "", "IN", "356", "", "12", "013", "", "33.71723", "74.83413", "Asia/Kolkata"),("1256418", "Shujālpur", "", "IN", "356", "", "35", "436", "", "23.40673", "76.7098", "Asia/Kolkata"),("1256421", "Shrīrangapattana", "", "IN", "356", "", "19", "573", "", "12.42264", "76.68439", "Asia/Kolkata"),("1256422", "Shrīrāmpur", "", "IN", "356", "", "28", "338", "", "22.75278", "88.34222", "Asia/Kolkata"),("1256426", "Shrīgonda", "", "IN", "356", "", "16", "522", "", "18.61527", "74.69895", "Asia/Kolkata"),("1256428", "Srāvana Belgola", "", "IN", "356", "", "19", "574", "", "12.85737", "76.48886", "Asia/Kolkata"),("1256431", "Shorāpur", "", "IN", "356", "", "19", "580", "", "16.521", "76.75738", "Asia/Kolkata"),("1256432", "Shōranūr", "", "IN", "356", "", "13", "593", "", "10.76181", "76.27078", "Asia/Kolkata"),("1256435", "Sholinghur", "", "IN", "356", "", "25", "605", "", "13.1181", "79.42025", "Asia/Kolkata"),("1256436", "Solāpur", "Солапур", "IN", "356", "", "16", "526", "", "17.67152", "75.91044", "Asia/Kolkata"),("1256450", "Shivrājpur", "", "IN", "356", "", "09", "484", "", "22.42319", "73.60865", "Asia/Kolkata"),("1256451", "Shivpuri", "", "IN", "356", "", "35", "423", "", "25.42378", "77.66223", "Asia/Kolkata"),("1256468", "Shīshgarh", "", "IN", "356", "", "36", "136", "", "28.72928", "79.31469", "Asia/Kolkata"),("1256469", "Shirwal", "", "IN", "356", "", "16", "527", "", "18.15059", "73.97788", "Asia/Kolkata"),("1256475", "Shirpur", "Ширпуре", "IN", "356", "", "16", "498", "", "21.34821", "74.88035", "Asia/Kolkata"),("1256483", "Shirhatti", "", "IN", "356", "", "19", "561", "", "15.23352", "75.57996", "Asia/Kolkata"),("1256486", "Shirgaon", "", "IN", "356", "", "16", "517", "", "19.69589", "72.71527", "Asia/Kolkata"),("1256489", "Shirdi", "Ширди", "IN", "356", "", "16", "522", "", "19.76616", "74.47738", "Asia/Kolkata"),("1256515", "Shimoga", "", "IN", "356", "", "19", "568", "", "13.93157", "75.56791", "Asia/Kolkata"),("1256523", "Shillong", "Шиллонг", "IN", "356", "", "18", "298", "", "25.56892", "91.88313", "Asia/Kolkata"),("1256525", "Shiliguri", "Силигури", "IN", "356", "", "28", "327", "", "26.71004", "88.42851", "Asia/Kolkata"),("1256529", "Shikohābād", "", "IN", "356", "", "36", "147", "", "27.108", "78.58661", "Asia/Kolkata"),("1256532", "Shikārpūr", "", "IN", "356", "", "36", "142", "", "28.28072", "78.01411", "Asia/Kolkata"),("1256537", "Shikārpur", "", "IN", "356", "", "19", "568", "", "14.2698", "75.35643", "Asia/Kolkata"),("1256539", "Shiggaon", "", "IN", "356", "", "19", "564", "", "14.99053", "75.22499", "Asia/Kolkata"),("1256558", "Shertallai", "", "IN", "356", "", "13", "598", "", "9.68428", "76.35337", "Asia/Kolkata"),("1256569", "Sherkot", "", "IN", "356", "", "36", "134", "", "29.32704", "78.57429", "Asia/Kolkata"),("1256572", "Sherghāti", "", "IN", "356", "", "34", "236", "", "24.5595", "84.79162", "Asia/Kolkata"),("1256574", "Shergarh", "", "IN", "356", "", "36", "150", "", "28.65128", "79.36815", "Asia/Kolkata"),("1256593", "Sheopur", "", "IN", "356", "", "35", "418", "", "25.66472", "76.69616", "Asia/Kolkata"),("1256597", "Sheohar", "", "IN", "356", "", "34", "205", "", "26.51393", "85.29341", "Asia/Kolkata"),("1256598", "Sheoganj", "", "IN", "356", "", "24", "117", "", "25.13915", "73.06784", "Asia/Kolkata"),("1256620", "Shegaon", "", "IN", "356", "", "16", "500", "", "20.7932", "76.69921", "Asia/Kolkata"),("1256639", "Shāntipur", "", "IN", "356", "", "28", "336", "", "23.24723", "88.43302", "Asia/Kolkata"),("1256650", "Shankargarh", "", "IN", "356", "", "36", "175", "", "25.182", "81.61769", "Asia/Kolkata"),("1256659", "Shamsābād", "", "IN", "356", "", "36", "159", "", "27.5371", "79.43796", "Asia/Kolkata"),("1256660", "Shamsābād", "", "IN", "356", "", "36", "146", "", "27.01718", "78.12358", "Asia/Kolkata"),("1256671", "Shāmli", "", "IN", "356", "", "36", "133", "", "29.4497", "77.30959", "Asia/Kolkata"),("1256673", "Shāmgarh", "", "IN", "356", "", "35", "433", "", "24.18817", "75.63903", "Asia/Kolkata"),("1256693", "Shājāpur", "", "IN", "356", "", "35", "436", "", "23.42637", "76.27775", "Asia/Kolkata"),("1256698", "Sheikhpura", "", "IN", "356", "", "34", "228", "", "25.13994", "85.84096", "Asia/Kolkata"),("1256705", "Shāhpura", "", "IN", "356", "", "24", "110", "", "27.3912", "75.95956", "Asia/Kolkata"),("1256706", "Shāhpura", "", "IN", "356", "", "24", "122", "", "25.62094", "74.92487", "Asia/Kolkata"),("1256708", "Shāhpura", "", "IN", "356", "", "35", "451", "", "23.13663", "79.66402", "Asia/Kolkata"),("1256713", "Shāhpur", "Шахпура", "IN", "356", "", "36", "133", "", "29.3501", "77.5516", "Asia/Kolkata"),("1256715", "Shāhpur", "", "IN", "356", "", "34", "231", "", "25.60293", "84.40412", "Asia/Kolkata"),("1256716", "Shāhpur", "", "IN", "356", "", "35", "427", "", "23.89371", "79.05074", "Asia/Kolkata"),("1256717", "Shāhpur", "", "IN", "356", "", "35", "453", "", "23.02446", "81.0038", "Asia/Kolkata"),("1256719", "Shāhpur", "", "IN", "356", "", "09", "476", "", "22.15611", "70.77068", "Asia/Kolkata"),("1256720", "Shāhpur", "", "IN", "356", "", "35", "467", "", "21.23742", "76.22558", "Asia/Kolkata"),("1256722", "Shāhpur", "Шахпура", "IN", "356", "", "19", "580", "", "16.69605", "76.8422", "Asia/Kolkata"),("1256725", "Shāhkot", "", "IN", "356", "", "23", "037", "", "31.08173", "75.33708", "Asia/Kolkata"),("1256728", "Shāhjānpur", "", "IN", "356", "", "36", "152", "", "27.88165", "79.90918", "Asia/Kolkata"),("1256731", "Shāhi", "", "IN", "356", "", "36", "150", "", "28.55023", "79.31761", "Asia/Kolkata"),("1256734", "Shāhgarh", "", "IN", "356", "", "35", "427", "", "24.31365", "79.11806", "Asia/Kolkata"),("1256735", "Shāhganj", "", "IN", "356", "", "36", "194", "", "26.04965", "82.68423", "Asia/Kolkata"),("1256739", "Shahdol", "", "IN", "356", "", "35", "460", "", "23.29356", "81.3619", "Asia/Kolkata"),("1256747", "Shāhāpur", "", "IN", "356", "", "16", "517", "", "19.45231", "73.32572", "Asia/Kolkata"),("1256750", "Shāhāda", "", "IN", "356", "", "16", "497", "", "21.54538", "74.47106", "Asia/Kolkata"),("1256752", "Shāhābād", "", "IN", "356", "", "10", "072", "", "30.16776", "76.87046", "Asia/Kolkata"),("1256753", "Shāhābād", "", "IN", "356", "", "36", "136", "", "28.56681", "79.00956", "Asia/Kolkata"),("1256755", "Shāhābād", "", "IN", "356", "", "36", "155", "", "27.6431", "79.9402", "Asia/Kolkata"),("1256759", "Shāhābād", "", "IN", "356", "", "19", "579", "", "17.1307", "76.94361", "Asia/Kolkata"),("1256796", "Serula", "", "IN", "356", "", "33", "585", "", "15.54774", "73.84329", "Asia/Kolkata"),("1256812", "Serchhīp", "", "IN", "356", "", "31", "285", "", "23.29312", "92.84679", "Asia/Kolkata"),("1256814", "Seram", "Серам", "IN", "356", "", "19", "579", "", "17.17859", "77.28998", "Asia/Kolkata"),("1256820", "Seorīnārāyan", "", "IN", "356", "", "37", "405", "", "21.72055", "82.59344", "Asia/Kolkata"),("1256823", "Seoni Mālwa", "", "IN", "356", "", "35", "449", "", "22.45046", "77.4665", "Asia/Kolkata"),("1256826", "Seoni", "", "IN", "356", "", "35", "456", "", "22.08503", "79.55037", "Asia/Kolkata"),("1256828", "Seondha", "", "IN", "356", "", "35", "422", "", "26.15422", "78.7812", "Asia/Kolkata"),("1256832", "Seohāra", "", "IN", "356", "", "36", "134", "", "29.20904", "78.58837", "Asia/Kolkata"),("1256854", "Sendhwa", "", "IN", "356", "", "35", "441", "", "21.68562", "75.09622", "Asia/Kolkata"),("1256913", "Sehore", "", "IN", "356", "", "35", "445", "", "23.2", "77.08333", "Asia/Kolkata"),("1256922", "Secunderabad", "", "IN", "356", "IN", "40", "537", "", "17.50427", "78.54263", "Asia/Kolkata"),("1256929", "Sāyla", "", "IN", "356", "", "09", "475", "", "22.54925", "71.48324", "Asia/Kolkata"),("1256934", "Sāyalkudi", "", "IN", "356", "", "25", "626", "", "9.16931", "78.44708", "Asia/Kolkata"),("1256949", "Sawāi Mādhopur", "", "IN", "356", "", "24", "108", "", "26.02301", "76.34408", "Asia/Kolkata"),("1256959", "Sāvda", "", "IN", "356", "", "16", "499", "", "21.15054", "75.88938", "Asia/Kolkata"),("1256967", "Savanūr", "", "IN", "356", "", "19", "564", "", "14.97335", "75.33724", "Asia/Kolkata"),("1256968", "Sāvantvādi", "", "IN", "356", "", "16", "529", "", "15.90413", "73.82191", "Asia/Kolkata"),("1256974", "Sausar", "", "IN", "356", "", "35", "455", "", "21.65576", "78.79669", "Asia/Kolkata"),("1256976", "Saurikh", "", "IN", "356", "", "36", "160", "", "27.03051", "79.48813", "Asia/Kolkata"),("1256983", "Saundatti", "", "IN", "356", "", "19", "555", "", "15.76615", "75.11778", "Asia/Kolkata"),("1256989", "Sathyamangalam", "", "IN", "356", "", "25", "610", "", "11.50526", "77.23826", "Asia/Kolkata"),("1256990", "Satwās", "", "IN", "356", "", "35", "437", "", "22.53628", "76.68452", "Asia/Kolkata"),("1256995", "Sattur", "", "IN", "356", "", "25", "625", "", "9.35592", "77.92457", "Asia/Kolkata"),("1257001", "Sattenapalle", "", "IN", "356", "", "02", "548", "", "16.39381", "80.15221", "Asia/Kolkata"),("1257004", "Sathankulam", "", "IN", "356", "", "25", "627", "", "8.44164", "77.91349", "Asia/Kolkata"),("1257005", "Satrikh", "", "IN", "356", "", "36", "176", "", "26.86045", "81.19567", "Asia/Kolkata"),("1257022", "Satna", "", "IN", "356", "", "35", "429", "", "24.57726", "80.82719", "Asia/Kolkata"),("1257055", "Satara", "Сатара", "IN", "356", "", "16", "527", "", "17.68589", "73.99333", "Asia/Kolkata"),("1257060", "Satānā", "", "IN", "356", "", "16", "516", "", "20.59483", "74.20301", "Asia/Kolkata"),("1257066", "Sāsvad", "", "IN", "356", "", "16", "521", "", "18.34351", "74.03102", "Asia/Kolkata"),("1257077", "Sāsni", "", "IN", "356", "", "36", "144", "", "27.70287", "78.08278", "Asia/Kolkata"),("1257093", "Sarwār", "", "IN", "356", "", "24", "119", "", "26.06272", "75.01104", "Asia/Kolkata"),("1257149", "Sarkhej", "", "IN", "356", "", "09", "474", "", "22.98297", "72.50196", "Asia/Kolkata"),("1257167", "Sarīla", "", "IN", "356", "", "36", "168", "", "25.77579", "79.67535", "Asia/Kolkata"),("1257178", "Sargūr", "", "IN", "356", "", "19", "577", "", "11.99971", "76.39611", "Asia/Kolkata"),("1257191", "Sardulgarh", "", "IN", "356", "", "23", "047", "", "29.69224", "75.23608", "Asia/Kolkata"),("1257196", "Sardhana", "", "IN", "356", "", "36", "138", "", "29.14551", "77.61433", "Asia/Kolkata"),("1257198", "Sardārshahr", "", "IN", "356", "", "24", "102", "", "28.44062", "74.491", "Asia/Kolkata"),("1257219", "Sarauli", "", "IN", "356", "", "36", "136", "", "28.49404", "79.09177", "Asia/Kolkata"),("1257237", "Sārangpur", "", "IN", "356", "", "35", "442", "", "23.56651", "76.47306", "Asia/Kolkata"),("1257242", "Sārangarh", "", "IN", "356", "", "37", "403", "", "21.58614", "83.0785", "Asia/Kolkata"),("1257259", "Saraipali", "", "IN", "356", "", "37", "411", "", "21.3153", "83.00629", "Asia/Kolkata"),("1257260", "Sarāi Mīr", "", "IN", "356", "", "36", "191", "", "26.02705", "82.91843", "Asia/Kolkata"),("1257263", "Saraikela", "", "IN", "356", "", "38", "369", "", "22.69904", "85.93154", "Asia/Kolkata"),("1257264", "Sarai Ekdil", "", "IN", "356", "", "36", "161", "", "26.74442", "79.09353", "Asia/Kolkata"),("1257268", "Sarāi Ākil", "", "IN", "356", "", "36", "174", "", "25.3789", "81.51035", "Asia/Kolkata"),("1257298", "Sapatgrām", "", "IN", "356", "", "03", "301", "", "26.33732", "90.1236", "Asia/Kolkata"),("1257307", "Saoner", "", "IN", "356", "", "16", "505", "", "21.3851", "78.92155", "Asia/Kolkata"),("1257313", "Sānwer", "", "IN", "356", "", "35", "439", "", "22.97415", "75.8271", "Asia/Kolkata"),("1257316", "Sanvordem", "", "IN", "356", "", "33", "586", "", "15.26269", "74.11965", "Asia/Kolkata"),("1257325", "Santoshpur", "", "IN", "356", "", "28", "343", "", "22.52038", "88.26973", "Asia/Kolkata"),("1257326", "Santokhgarh", "", "IN", "356", "", "11", "029", "", "31.35205", "76.31775", "Asia/Kolkata"),("1257347", "Sanquelim", "", "IN", "356", "", "33", "585", "", "15.56422", "74.00799", "Asia/Kolkata"),("1257354", "Sānkrāil", "", "IN", "356", "", "28", "341", "", "22.54997", "88.22515", "Asia/Kolkata"),("1257366", "Sankheda", "", "IN", "356", "", "09", "486", "", "22.17021", "73.5782", "Asia/Kolkata"),("1257369", "Sankeshwar", "", "IN", "356", "", "19", "555", "", "16.25649", "74.48195", "Asia/Kolkata"),("1257399", "Sanguem", "", "IN", "356", "", "33", "586", "", "15.22901", "74.15149", "Asia/Kolkata"),("1257402", "Sangrūr", "", "IN", "356", "", "23", "053", "", "30.24506", "75.84488", "Asia/Kolkata"),("1257409", "Sāngola", "", "IN", "356", "", "16", "526", "", "17.43948", "75.19379", "Asia/Kolkata"),("1257410", "Sangod", "", "IN", "356", "", "24", "127", "", "24.92707", "76.28649", "Asia/Kolkata"),("1257416", "Sāngli", "", "IN", "356", "IN", "16", "531", "", "16.85438", "74.56417", "Asia/Kolkata"),("1257429", "Sangariā", "", "IN", "356", "", "24", "100", "", "29.79886", "74.46683", "Asia/Kolkata"),("1257431", "Sangāreddi", "", "IN", "356", "", "40", "535", "", "17.62477", "78.08669", "Asia/Kolkata"),("1257436", "Sangamner", "", "IN", "356", "", "16", "522", "", "19.56784", "74.21154", "Asia/Kolkata"),("1257456", "Sandūr", "", "IN", "356", "", "19", "565", "", "15.08613", "76.54692", "Asia/Kolkata"),("1257459", "Sandīla", "", "IN", "356", "", "36", "155", "", "27.06989", "80.51497", "Asia/Kolkata"),("1257461", "Sāndi", "", "IN", "356", "", "36", "155", "", "27.28867", "79.9519", "Asia/Kolkata"),("1257476", "Sancoale", "", "IN", "356", "", "33", "586", "", "15.37794", "73.90352", "Asia/Kolkata"),("1257477", "Sānchor", "", "IN", "356", "", "24", "116", "", "24.75361", "71.7728", "Asia/Kolkata"),("1257479", "Sānchi", "", "IN", "356", "", "35", "446", "", "23.48646", "77.7378", "Asia/Kolkata"),("1257481", "Sanāwad", "", "IN", "356", "", "35", "440", "", "22.17391", "76.06993", "Asia/Kolkata"),("1257482", "Sanaur", "", "IN", "356", "", "23", "048", "", "30.30182", "76.45786", "Asia/Kolkata"),("1257486", "Sānand", "", "IN", "356", "", "09", "474", "", "22.99227", "72.38177", "Asia/Kolkata"),("1257498", "Samthar", "", "IN", "356", "", "36", "166", "", "25.84348", "78.90683", "Asia/Kolkata"),("1257503", "Samrāla", "", "IN", "356", "", "23", "041", "", "30.83601", "76.19324", "Asia/Kolkata"),("1257528", "Samdari", "", "IN", "356", "", "24", "115", "", "25.81299", "72.57879", "Asia/Kolkata"),("1257539", "Sāmbhar", "Самбхара", "IN", "356", "", "24", "110", "", "26.90806", "75.19137", "Asia/Kolkata"),("1257540", "Sambhal", "", "IN", "356", "", "36", "135", "", "28.58498", "78.56959", "Asia/Kolkata"),("1257542", "Sambalpur", "Самбалпур", "IN", "356", "", "21", "372", "", "21.46527", "83.97573", "Asia/Kolkata"),("1257545", "Sāmba", "", "IN", "356", "", "12", "022", "", "32.56245", "75.11993", "Asia/Kolkata"),("1257551", "Samāstipur", "", "IN", "356", "", "34", "221", "", "25.86222", "85.77953", "Asia/Kolkata"),("1257565", "Sāmalkot", "", "IN", "356", "", "02", "545", "", "17.05675", "82.17639", "Asia/Kolkata"),("1257566", "Samālkha", "", "IN", "356", "", "10", "075", "", "29.23552", "77.01273", "Asia/Kolkata"),("1257587", "Sālūr", "", "IN", "356", "", "02", "543", "", "18.51716", "83.20548", "Asia/Kolkata"),("1257588", "Sālūmbar", "", "IN", "356", "", "24", "130", "", "24.13524", "74.04442", "Asia/Kolkata"),("1257599", "Salon", "", "IN", "356", "", "36", "158", "", "26.02857", "81.45403", "Asia/Kolkata"),("1257611", "Saligao", "", "IN", "356", "", "33", "585", "", "15.55359", "73.79036", "Asia/Kolkata"),("1257629", "Salem", "Салем", "IN", "356", "", "25", "608", "", "11.65117", "78.15867", "Asia/Kolkata"),("1257638", "Salāya", "", "IN", "356", "", "09", "477", "", "22.31038", "69.60376", "Asia/Kolkata"),("1257673", "Saktī", "Шакти", "IN", "356", "", "37", "405", "", "22.02662", "82.96091", "Asia/Kolkata"),("1257698", "Sakleshpur", "", "IN", "356", "", "19", "574", "", "12.94119", "75.78467", "Asia/Kolkata"),("1257703", "Sakīt", "", "IN", "356", "", "36", "201", "", "27.43463", "78.77903", "Asia/Kolkata"),("1257737", "Sāitlaw", "", "IN", "356", "", "31", "281", "", "23.97187", "92.57454", "Asia/Kolkata"),("1257743", "Sairang", "", "IN", "356", "", "31", "283", "", "23.81034", "92.65226", "Asia/Kolkata"),("1257749", "Saint Thomas Mount", "", "IN", "356", "", "25", "604", "", "13.00334", "80.19614", "Asia/Kolkata"),("1257751", "Sainthia", "", "IN", "356", "", "28", "334", "", "23.94826", "87.68045", "Asia/Kolkata"),("1257762", "Selu", "", "IN", "356", "", "16", "513", "", "19.45512", "76.44073", "Asia/Kolkata"),("1257765", "Sailāna", "", "IN", "356", "", "35", "434", "", "23.46219", "74.92318", "Asia/Kolkata"),("1257771", "Saiha", "", "IN", "356", "", "31", "288", "", "22.49183", "92.98143", "Asia/Kolkata"),("1257775", "Saidpur", "", "IN", "356", "", "36", "142", "", "28.61089", "77.90896", "Asia/Kolkata"),("1257776", "Saidpur", "", "IN", "356", "", "36", "195", "", "25.53749", "83.22378", "Asia/Kolkata"),("1257794", "Sāhibganj", "", "IN", "356", "", "38", "352", "", "25.24425", "87.63481", "Asia/Kolkata"),("1257799", "Sahāwar", "", "IN", "356", "", "36", "202", "", "27.79603", "78.83373", "Asia/Kolkata"),("1257800", "Sahaswān", "", "IN", "356", "", "36", "149", "", "28.07227", "78.75082", "Asia/Kolkata"),("1257802", "Sahaspur", "", "IN", "356", "", "36", "134", "", "29.12125", "78.62273", "Asia/Kolkata"),("1257804", "Saharsa", "", "IN", "356", "", "34", "214", "", "25.87498", "86.59611", "Asia/Kolkata"),("1257806", "Sahāranpur", "", "IN", "356", "", "36", "132", "", "29.9679", "77.54522", "Asia/Kolkata"),("1257830", "Sagauli", "", "IN", "356", "", "34", "204", "", "26.7639", "84.74341", "Asia/Kolkata"),("1257845", "Saugor", "Сагар", "IN", "356", "", "35", "427", "", "23.83877", "78.73874", "Asia/Kolkata"),("1257851", "Sāgar", "", "IN", "356", "", "19", "568", "", "14.16498", "75.02901", "Asia/Kolkata"),("1257854", "Safīpur", "", "IN", "356", "", "36", "156", "", "26.73783", "80.3435", "Asia/Kolkata"),("1257855", "Safidon", "", "IN", "356", "", "10", "077", "", "29.40596", "76.67042", "Asia/Kolkata"),("1257865", "Sādri", "", "IN", "356", "", "24", "118", "", "25.18555", "73.45288", "Asia/Kolkata"),("1257887", "Sādāt", "", "IN", "356", "", "36", "195", "", "25.67117", "83.30269", "Asia/Kolkata"),("1257890", "Sadāseopet", "", "IN", "356", "", "40", "535", "", "17.61925", "77.95263", "Asia/Kolkata"),("1257895", "Sadalgi", "", "IN", "356", "", "19", "555", "", "16.5587", "74.53211", "Asia/Kolkata"),("1257896", "Sadābād", "", "IN", "356", "", "36", "144", "", "27.43818", "78.03758", "Asia/Kolkata"),("1257901", "Sachīn", "", "IN", "356", "", "09", "492", "", "21.08718", "72.88153", "Asia/Kolkata"),("1257908", "Sabrūm", "", "IN", "356", "", "26", "290", "", "23.00153", "91.72427", "Asia/Kolkata"),("1257919", "Sabāthu", "", "IN", "356", "", "11", "031", "", "30.97494", "76.99137", "Asia/Kolkata"),("1257928", "Sabalgarh", "", "IN", "356", "", "35", "419", "", "26.24918", "77.40786", "Asia/Kolkata"),("1257936", "Rusera", "", "IN", "356", "", "34", "221", "", "25.75355", "86.02597", "Asia/Kolkata"),("1257940", "Rura", "", "IN", "356", "", "36", "163", "", "26.49001", "79.90108", "Asia/Kolkata"),("1257951", "Ropar", "", "IN", "356", "", "23", "051", "", "30.96896", "76.52695", "Asia/Kolkata"),("1258012", "Rūdarpur", "", "IN", "356", "", "36", "190", "", "26.44467", "83.61302", "Asia/Kolkata"),("1258044", "Roorkee", "Рурки", "IN", "356", "", "39", "068", "", "29.86632", "77.89118", "Asia/Kolkata"),("1258061", "Ron", "Рона", "IN", "356", "", "19", "561", "", "15.69935", "75.73408", "Asia/Kolkata"),("1258076", "Rohtak", "Рохтак", "IN", "356", "", "10", "082", "", "28.89447", "76.58917", "Asia/Kolkata"),("1258078", "Rohru", "", "IN", "356", "", "11", "033", "", "31.20269", "77.75484", "Asia/Kolkata"),("1258098", "Roha", "", "IN", "356", "", "09", "468", "", "23.19646", "69.27076", "Asia/Kolkata"),("1258099", "Roha", "", "IN", "356", "", "16", "520", "", "18.43687", "73.11964", "Asia/Kolkata"),("1258109", "Robertsonpet", "", "IN", "356", "", "19", "581", "", "12.95629", "78.27539", "Asia/Kolkata"),("1258111", "Robertsganj", "", "IN", "356", "", "36", "200", "", "24.6886", "83.06784", "Asia/Kolkata"),("1258124", "Risod", "", "IN", "356", "", "16", "502", "", "19.97671", "76.78799", "Asia/Kolkata"),("1258126", "Rishra", "", "IN", "356", "", "28", "338", "", "22.72394", "88.34563", "Asia/Kolkata"),("1258128", "Rishīkesh", "Ришикеш", "IN", "356", "", "39", "060", "", "30.10778", "78.29255", "Asia/Kolkata"),("1258140", "Rīngas", "", "IN", "356", "", "24", "111", "", "27.3636", "75.56838", "Asia/Kolkata"),("1258164", "Richha", "", "IN", "356", "", "36", "150", "", "28.69467", "79.52284", "Asia/Kolkata"),("1258167", "Riāsi", "", "IN", "356", "", "12", "020", "", "33.08115", "74.83242", "Asia/Kolkata"),("1258178", "Rewāri", "", "IN", "356", "", "10", "085", "", "28.199", "76.6183", "Asia/Kolkata"),("1258182", "Rewa", "Рева", "IN", "356", "", "35", "430", "", "24.53256", "81.29234", "Asia/Kolkata"),("1258186", "Revelganj", "", "IN", "356", "", "34", "219", "", "25.78976", "84.63596", "Asia/Kolkata"),("1258190", "Revadanda", "", "IN", "356", "", "16", "520", "", "18.55363", "72.92559", "Asia/Kolkata"),("1258201", "Repalle", "Репалле", "IN", "356", "", "02", "548", "", "16.0184", "80.82958", "Asia/Kolkata"),("1258203", "Reoti", "", "IN", "356", "", "36", "193", "", "25.85091", "84.3778", "Asia/Kolkata"),("1258207", "Renukūt", "", "IN", "356", "", "36", "200", "", "24.21641", "83.0358", "Asia/Kolkata"),("1258213", "Renigunta", "", "IN", "356", "", "02", "554", "", "13.65143", "79.51256", "Asia/Kolkata"),("1258221", "Rengāli", "", "IN", "356", "", "21", "372", "", "21.63885", "84.04434", "Asia/Kolkata"),("1258229", "Remuna", "", "IN", "356", "", "21", "377", "", "21.52798", "86.87156", "Asia/Kolkata"),("1258242", "Rehti", "", "IN", "356", "", "35", "445", "", "22.73781", "77.43399", "Asia/Kolkata"),("1258247", "Rehli", "", "IN", "356", "", "35", "427", "", "23.63722", "79.06275", "Asia/Kolkata"),("1258269", "Rāzole", "", "IN", "356", "", "02", "545", "", "16.47608", "81.83912", "Asia/Kolkata"),("1258270", "Rāzām", "", "IN", "356", "", "02", "542", "", "18.44909", "83.65957", "Asia/Kolkata"),("1258278", "Rāybāg", "", "IN", "356", "", "19", "555", "", "16.49178", "74.77391", "Asia/Kolkata"),("1258290", "Rāyadrug", "", "IN", "356", "", "02", "553", "", "14.69971", "76.85241", "Asia/Kolkata"),("1258291", "Rāyachoti", "", "IN", "356", "", "02", "551", "", "14.05723", "78.75056", "Asia/Kolkata"),("1258292", "Rāya", "Рая", "IN", "356", "", "36", "145", "", "27.55607", "77.78972", "Asia/Kolkata"),("1258293", "Rāy", "", "IN", "356", "", "38", "364", "", "23.68464", "85.05545", "Asia/Kolkata"),("1258294", "Raxaul", "Раксаул", "IN", "356", "", "34", "204", "", "26.97982", "84.85065", "Asia/Kolkata"),("1258295", "Rāwatsār", "", "IN", "356", "", "24", "100", "", "29.26724", "74.40288", "Asia/Kolkata"),("1258297", "Rāwatbhāta", "", "IN", "356", "", "24", "126", "", "24.92981", "75.59209", "Asia/Kolkata"),("1258307", "Rāver", "", "IN", "356", "", "16", "499", "", "21.24757", "76.03509", "Asia/Kolkata"),("1258338", "Ratnagiri", "Ратнагири", "IN", "356", "", "16", "528", "1258340", "16.99154", "73.31022", "Asia/Kolkata"),("1258342", "Ratlām", "", "IN", "356", "", "35", "434", "", "23.33033", "75.04032", "Asia/Kolkata"),("1258347", "Ratia", "Ратиа", "IN", "356", "", "10", "078", "", "29.69029", "75.57688", "Asia/Kolkata"),("1258352", "Rāth", "Рата", "IN", "356", "", "36", "168", "", "25.59474", "79.5666", "Asia/Kolkata"),("1258362", "Ratanpur", "", "IN", "356", "", "37", "406", "", "22.2866", "82.16823", "Asia/Kolkata"),("1258366", "Ratangarh", "", "IN", "356", "", "24", "102", "", "28.08137", "74.61854", "Asia/Kolkata"),("1258367", "Ratangarh", "", "IN", "356", "", "35", "432", "", "24.81667", "75.11667", "Asia/Kolkata"),("1258375", "Rasūlābād", "", "IN", "356", "", "36", "156", "", "26.74491", "80.49012", "Asia/Kolkata"),("1258380", "Rasrā", "", "IN", "356", "", "36", "193", "", "25.8576", "83.85487", "Asia/Kolkata"),("1258386", "Rasipuram", "", "IN", "356", "", "25", "609", "", "11.46009", "78.18635", "Asia/Kolkata"),("1258406", "Rāpar", "", "IN", "356", "", "09", "468", "", "23.57267", "70.64718", "Asia/Kolkata"),("1258447", "Rānīr Bāzār", "", "IN", "356", "", "26", "289", "", "23.83463", "91.36614", "Asia/Kolkata"),("1258449", "Rānīpur", "", "IN", "356", "", "36", "166", "", "25.25034", "79.06204", "Asia/Kolkata"),("1258455", "Rānikhet", "", "IN", "356", "", "39", "064", "", "29.64082", "79.43229", "Asia/Kolkata"),("1258470", "Rānīganj", "Ранигандже", "IN", "356", "", "28", "335", "", "23.6164", "87.13061", "Asia/Kolkata"),("1258474", "Rānībennur", "", "IN", "356", "", "19", "564", "", "14.62239", "75.62951", "Asia/Kolkata"),("1258477", "Rānia", "Рания", "IN", "356", "", "10", "079", "", "29.52454", "74.83689", "Asia/Kolkata"),("1258478", "Rāni", "", "IN", "356", "", "24", "118", "", "25.35031", "73.30885", "Asia/Kolkata"),("1258492", "Rangia", "", "IN", "356", "", "03", "321", "", "26.44931", "91.61356", "Asia/Kolkata"),("1258501", "Rangāpāra", "", "IN", "356", "", "03", "306", "", "26.83772", "92.66876", "Asia/Kolkata"),("1258526", "Ranchi", "Ранчи", "IN", "356", "", "38", "364", "", "23.34316", "85.3094", "Asia/Kolkata"),("1258534", "Rānāvāv", "", "IN", "356", "", "09", "478", "", "21.68734", "69.74485", "Asia/Kolkata"),("1258537", "Rānāpur", "", "IN", "356", "", "35", "464", "", "22.64704", "74.52118", "Asia/Kolkata"),("1258546", "Rānāghāt", "", "IN", "356", "", "28", "336", "", "23.17623", "88.56667", "Asia/Kolkata"),("1258553", "Rāmtek", "Рамтек", "IN", "356", "", "16", "505", "", "21.39562", "79.32725", "Asia/Kolkata"),("1258581", "Rampur Hat", "", "IN", "356", "", "28", "334", "", "24.17737", "87.78275", "Asia/Kolkata"),("1258584", "Rāmpura", "", "IN", "356", "", "23", "046", "", "30.256", "75.24116", "Asia/Kolkata"),("1258590", "Rāmpura", "", "IN", "356", "", "36", "165", "", "26.34967", "79.18234", "Asia/Kolkata"),("1258592", "Rāmpura", "", "IN", "356", "", "35", "432", "", "24.467", "75.43996", "Asia/Kolkata"),("1258596", "Rāmpur", "", "IN", "356", "", "11", "026", "", "31.44943", "77.63087", "Asia/Kolkata"),("1258598", "Rāmpur", "", "IN", "356", "", "36", "132", "", "29.8062", "77.45251", "Asia/Kolkata"),("1258599", "Rāmpur", "", "IN", "356", "", "36", "136", "", "28.81014", "79.02699", "Asia/Kolkata"),("1258635", "Rāmnagar", "", "IN", "356", "", "12", "019", "", "32.80728", "75.31119", "Asia/Kolkata"),("1258637", "Rāmnagar", "", "IN", "356", "", "39", "066", "", "29.3925", "79.1283", "Asia/Kolkata"),("1258639", "Rāmnagar", "", "IN", "356", "", "34", "203", "", "27.16371", "84.32342", "Asia/Kolkata"),("1258640", "Rāmnagar", "", "IN", "356", "", "36", "176", "", "27.08499", "81.40575", "Asia/Kolkata"),("1258642", "Rāmnagar", "", "IN", "356", "", "36", "197", "", "25.26907", "83.02971", "Asia/Kolkata"),("1258652", "Rāmkola", "", "IN", "356", "", "36", "189", "", "26.90172", "83.83758", "Asia/Kolkata"),("1258658", "Rāmjībanpur", "", "IN", "356", "", "28", "344", "", "22.82815", "87.60888", "Asia/Kolkata"),("1258662", "Rāmgundam", "", "IN", "356", "", "40", "534", "", "18.80084", "79.45206", "Asia/Kolkata"),("1258677", "Rāmgarh", "", "IN", "356", "", "24", "111", "", "27.25097", "75.17893", "Asia/Kolkata"),("1258686", "Rāmgarh", "", "IN", "356", "", "38", "361", "", "23.63018", "85.51926", "Asia/Kolkata"),("1258692", "Rāmganj Mandi", "", "IN", "356", "", "24", "127", "", "24.64648", "75.94325", "Asia/Kolkata"),("1258698", "Rameswaram", "Рамешварам", "IN", "356", "", "25", "625", "", "9.2885", "79.31271", "Asia/Kolkata"),("1258708", "Rām Dās", "", "IN", "356", "", "23", "049", "", "31.96739", "74.9087", "Asia/Kolkata"),("1258714", "Rambha", "", "IN", "356", "", "21", "388", "", "19.51667", "85.1", "Asia/Kolkata"),("1258715", "Rāmban", "", "IN", "356", "", "12", "017", "", "33.24278", "75.23513", "Asia/Kolkata"),("1258724", "Rāmāpuram", "", "IN", "356", "", "02", "552", "", "15.28749", "77.86722", "Asia/Kolkata"),("1258726", "Rāmāpuram", "", "IN", "356", "", "02", "554", "", "13.10091", "79.1841", "Asia/Kolkata"),("1258731", "Rāmānuj Ganj", "", "IN", "356", "", "37", "401", "", "23.80637", "83.69981", "Asia/Kolkata"),("1258740", "Ramanathapuram", "Раманатхапурама", "IN", "356", "", "25", "626", "", "9.37158", "78.83077", "Asia/Kolkata"),("1258744", "Closepet", "Раманагарам", "IN", "356", "", "19", "584", "", "12.72181", "77.28149", "Asia/Kolkata"),("1258747", "Rāmamangalam", "", "IN", "356", "", "13", "595", "", "9.93333", "76.5", "Asia/Kolkata"),("1258756", "Rāmachandrapuram", "", "IN", "356", "", "02", "545", "", "16.83636", "82.02871", "Asia/Kolkata"),("1258786", "Rājūra", "", "IN", "356", "", "16", "509", "", "19.77947", "79.36459", "Asia/Kolkata"),("1258788", "Rājur", "", "IN", "356", "", "16", "510", "", "20.11087", "78.89311", "Asia/Kolkata"),("1258795", "Rājula", "", "IN", "356", "", "09", "480", "", "21.03854", "71.44345", "Asia/Kolkata"),("1258797", "Rājsamand", "", "IN", "356", "", "24", "123", "", "25.07145", "73.8798", "Asia/Kolkata"),("1258803", "Rājpura", "", "IN", "356", "", "23", "048", "", "30.47856", "76.59284", "Asia/Kolkata"),("1258815", "Rajpur", "", "IN", "356", "", "35", "465", "", "22.30393", "74.35568", "Asia/Kolkata"),("1258816", "Rajpur", "", "IN", "356", "", "35", "441", "", "21.94022", "75.13608", "Asia/Kolkata"),("1258819", "Rājpīpla", "", "IN", "356", "", "09", "487", "", "21.86667", "73.5", "Asia/Kolkata"),("1258831", "Rāj-Nāndgaon", "", "IN", "356", "", "37", "408", "", "21.09687", "81.0289", "Asia/Kolkata"),("1258835", "Rājnagar", "", "IN", "356", "", "35", "425", "", "24.88929", "79.91178", "Asia/Kolkata"),("1258843", "Rājmahal", "", "IN", "356", "", "28", "", "", "25.05303", "87.83048", "Asia/Kolkata"),("1258847", "Rājkot", "Раджкот", "IN", "356", "", "09", "476", "", "22.29161", "70.79322", "Asia/Kolkata"),("1258859", "Rājgurunagar", "", "IN", "356", "", "16", "521", "", "18.86667", "73.9", "Asia/Kolkata"),("1258864", "Rājgīr", "Раджгир", "IN", "356", "", "34", "229", "", "25.02828", "85.42079", "Asia/Kolkata"),("1258868", "Rājgarh", "", "IN", "356", "", "24", "102", "", "28.64201", "75.38612", "Asia/Kolkata"),("1258869", "Rājgarh", "", "IN", "356", "", "24", "104", "", "27.23731", "76.62243", "Asia/Kolkata"),("1258875", "Rājgarh", "", "IN", "356", "", "35", "442", "", "24.00826", "76.7325", "Asia/Kolkata"),("1258876", "Rājgarh", "", "IN", "356", "", "35", "438", "", "22.67821", "74.94483", "Asia/Kolkata"),("1258891", "Rajaori", "", "IN", "356", "", "12", "006", "", "33.37526", "74.3092", "Asia/Kolkata"),("1258903", "Rāja Sānsi", "", "IN", "356", "", "23", "049", "", "31.72021", "74.8008", "Asia/Kolkata"),("1258911", "Rājāpur", "", "IN", "356", "", "36", "171", "", "25.38725", "81.15125", "Asia/Kolkata"),("1258914", "Rājāpur", "", "IN", "356", "", "16", "528", "", "16.65679", "73.51701", "Asia/Kolkata"),("1258916", "Rajapalaiyam", "", "IN", "356", "", "25", "625", "", "9.45296", "77.55335", "Asia/Kolkata"),("1258922", "Rāzampeta", "", "IN", "356", "", "02", "551", "", "14.19544", "79.15896", "Asia/Kolkata"),("1258928", "Rājaldesar", "", "IN", "356", "", "24", "102", "", "28.02849", "74.47442", "Asia/Kolkata"),("1258930", "Rājākhera", "", "IN", "356", "", "24", "106", "", "26.89802", "78.171", "Asia/Kolkata"),("1258932", "Rājahmundry", "Раджамандри", "IN", "356", "", "02", "545", "", "17.00517", "81.77784", "Asia/Kolkata"),("1258942", "Rāīwāla Bara", "", "IN", "356", "", "39", "060", "", "30.01864", "78.2293", "Asia/Kolkata"),("1258950", "Rāisinghnagar", "", "IN", "356", "", "24", "099", "", "29.53583", "73.44917", "Asia/Kolkata"),("1258952", "Raisen", "", "IN", "356", "", "35", "446", "", "23.33033", "77.7811", "Asia/Kolkata"),("1258967", "Rāipur", "", "IN", "356", "", "39", "060", "", "30.31097", "78.08979", "Asia/Kolkata"),("1258972", "Raipur", "", "IN", "356", "", "24", "118", "", "26.04259", "74.02373", "Asia/Kolkata"),("1258980", "Raipur", "", "IN", "356", "", "37", "410", "", "21.23333", "81.63333", "Asia/Kolkata"),("1258993", "Rāikot", "", "IN", "356", "", "23", "041", "", "30.65", "75.6", "Asia/Kolkata"),("1259005", "Raigarh", "Райгарх", "IN", "356", "", "37", "403", "", "21.89764", "83.3966", "Asia/Kolkata"),("1259009", "Rāiganj", "", "IN", "356", "", "28", "330", "", "25.61281", "88.12449", "Asia/Kolkata"),("1259012", "Rāichūr", "Райчур", "IN", "356", "", "19", "559", "", "16.20546", "77.35567", "Asia/Kolkata"),("1259017", "Raia", "", "IN", "356", "", "33", "586", "", "15.30499", "73.97096", "Asia/Kolkata"),("1259019", "Rāhuri", "", "IN", "356", "", "16", "522", "", "19.39069", "74.64979", "Asia/Kolkata"),("1259022", "Rāhon", "", "IN", "356", "", "23", "039", "", "31.05275", "76.11907", "Asia/Kolkata"),("1259026", "Rahimatpur", "", "IN", "356", "", "16", "527", "", "17.5921", "74.19966", "Asia/Kolkata"),("1259034", "Rāhatgarh", "", "IN", "356", "", "35", "427", "", "23.78968", "78.39473", "Asia/Kolkata"),("1259047", "Raghunāthpur", "", "IN", "356", "", "34", "212", "", "25.64492", "87.91762", "Asia/Kolkata"),("1259049", "Raghunathpur", "", "IN", "356", "", "28", "340", "", "23.53878", "86.6735", "Asia/Kolkata"),("1259056", "Rāghogarh", "", "IN", "356", "", "35", "458", "", "24.44318", "77.19768", "Asia/Kolkata"),("1259060", "Rafiganj", "", "IN", "356", "", "34", "235", "", "24.81757", "84.63445", "Asia/Kolkata"),("1259064", "Raebareli", "", "IN", "356", "", "36", "158", "", "26.2309", "81.23315", "Asia/Kolkata"),("1259069", "Rādhanpur", "", "IN", "356", "", "09", "470", "", "23.83238", "71.6047", "Asia/Kolkata"),("1259072", "Rādhākund", "", "IN", "356", "", "36", "145", "", "27.52432", "77.49101", "Asia/Kolkata"),("1259075", "Radaur", "", "IN", "356", "", "10", "071", "", "30.02706", "77.15177", "Asia/Kolkata"),("1259082", "Rabūpura", "", "IN", "356", "", "36", "141", "", "28.25153", "77.60253", "Asia/Kolkata"),("1259083", "Rabkavi", "", "IN", "356", "", "19", "556", "", "16.47567", "75.1106", "Asia/Kolkata"),("1259091", "Kollam", "Квилон", "IN", "356", "", "13", "600", "", "8.88113", "76.58469", "Asia/Kolkata"),("1259094", "Queula", "", "IN", "356", "", "33", "585", "", "15.39011", "73.98557", "Asia/Kolkata"),("1259098", "Quepem", "", "IN", "356", "", "33", "586", "", "15.2128", "74.0772", "Asia/Kolkata"),("1259102", "Qāzigund", "", "IN", "356", "", "12", "014", "", "33.63828", "75.14261", "Asia/Kolkata"),("1259108", "Kasba", "", "IN", "356", "", "34", "211", "", "25.85643", "87.53836", "Asia/Kolkata"),("1259110", "Qādiān", "", "IN", "356", "", "23", "035", "", "31.82198", "75.37663", "Asia/Kolkata"),("1259123", "Puttūr", "", "IN", "356", "", "02", "554", "", "13.44189", "79.55314", "Asia/Kolkata"),("1259124", "Puttūr", "", "IN", "356", "", "19", "575", "", "12.75975", "75.20169", "Asia/Kolkata"),("1259148", "Pushkar", "", "IN", "356", "", "24", "119", "", "26.49022", "74.55211", "Asia/Kolkata"),("1259154", "Pusad", "", "IN", "356", "", "16", "510", "", "19.91274", "77.57838", "Asia/Kolkata"),("1259157", "Purwā", "", "IN", "356", "", "36", "156", "", "26.45756", "80.77403", "Asia/Kolkata"),("1259158", "Purushottampur", "", "IN", "356", "", "21", "388", "", "19.52024", "84.88514", "Asia/Kolkata"),("1259163", "Puruliya", "", "IN", "356", "", "28", "340", "", "23.33062", "86.36303", "Asia/Kolkata"),("1259166", "Purnia", "Пурния", "IN", "356", "", "34", "211", "", "25.77895", "87.47422", "Asia/Kolkata"),("1259177", "Pūrna", "Пурна", "IN", "356", "", "16", "513", "", "19.1817", "77.02566", "Asia/Kolkata"),("1259184", "Puri", "Пури", "IN", "356", "", "21", "387", "", "19.79825", "85.82494", "Asia/Kolkata"),("1259190", "Pūranpur", "", "IN", "356", "", "36", "151", "", "28.51283", "80.14829", "Asia/Kolkata"),("1259210", "Pupri", "", "IN", "356", "", "34", "206", "", "26.47079", "85.70311", "Asia/Kolkata"),("1259222", "Punjai Puliyampatti", "", "IN", "356", "", "25", "610", "", "11.35163", "77.16671", "Asia/Kolkata"),("1259228", "Punganūru", "", "IN", "356", "", "02", "554", "", "13.36672", "78.57186", "Asia/Kolkata"),("1259229", "Pune", "Пуна", "IN", "356", "", "16", "521", "", "18.51957", "73.85535", "Asia/Kolkata"),("1259231", "Pūndri", "", "IN", "356", "", "10", "073", "", "29.76096", "76.56034", "Asia/Kolkata"),("1259239", "Punāsa", "", "IN", "356", "", "35", "466", "", "22.23507", "76.39335", "Asia/Kolkata"),("1259243", "Punalūr", "", "IN", "356", "", "13", "600", "", "9.01956", "76.92261", "Asia/Kolkata"),("1259244", "Pūnāhāna", "", "IN", "356", "", "10", "087", "", "27.86371", "77.20432", "Asia/Kolkata"),("1259251", "Pulwama", "", "IN", "356", "", "12", "012", "", "33.87405", "74.89955", "Asia/Kolkata"),("1259259", "Pullambādi", "", "IN", "356", "", "25", "614", "", "10.94108", "78.90816", "Asia/Kolkata"),("1259261", "Puliyūr", "", "IN", "356", "", "25", "621", "", "10.63292", "78.84103", "Asia/Kolkata"),("1259263", "Puliyangudi", "", "IN", "356", "", "25", "628", "", "9.17489", "77.39799", "Asia/Kolkata"),("1259264", "Pulivendla", "", "IN", "356", "", "02", "551", "", "14.42139", "78.22502", "Asia/Kolkata"),("1259272", "Pulgaon", "", "IN", "356", "", "16", "504", "", "20.72204", "78.32056", "Asia/Kolkata"),("1259283", "Pukhrāyān", "", "IN", "356", "", "36", "163", "", "26.22375", "79.83739", "Asia/Kolkata"),("1259290", "Puduvāyal", "", "IN", "356", "", "25", "602", "", "13.33015", "80.14577", "Asia/Kolkata"),("1259292", "Pudūr", "", "IN", "356", "", "25", "605", "", "12.99801", "79.14352", "Asia/Kolkata"),("1259293", "Pudūr", "", "IN", "356", "", "25", "627", "", "9.29147", "78.13545", "Asia/Kolkata"),("1259294", "Puduppatti", "", "IN", "356", "", "25", "609", "", "11.15083", "78.21197", "Asia/Kolkata"),("1259297", "Pudukkottai", "Пудуккоттай", "IN", "356", "", "25", "621", "", "10.38128", "78.82141", "Asia/Kolkata"),("1259312", "Proddatūr", "", "IN", "356", "", "02", "551", "", "14.7502", "78.54813", "Asia/Kolkata"),("1259337", "Pratāpgarh", "", "IN", "356", "", "36", "173", "", "25.89509", "81.9424", "Asia/Kolkata"),("1259338", "Pratāpgarh", "", "IN", "356", "", "24", "131", "", "24.03215", "74.78162", "Asia/Kolkata"),("1259385", "Port Blair", "Порт-Блэр", "IN", "356", "", "01", "640", "", "11.66667", "92.75", "Asia/Kolkata"),("1259388", "Porsa", "Порса", "IN", "356", "", "35", "419", "", "26.67444", "78.37081", "Asia/Kolkata"),("1259395", "Porbandar", "Порбандаром", "IN", "356", "", "09", "478", "", "21.64219", "69.60929", "Asia/Kolkata"),("1259400", "Poonamalle", "", "IN", "356", "", "25", "604", "", "13.04888", "80.11488", "Asia/Kolkata"),("1259408", "Ponnūru", "", "IN", "356", "", "02", "548", "", "16.06547", "80.55203", "Asia/Kolkata"),("1259409", "Ponneri", "", "IN", "356", "", "25", "602", "", "13.33868", "80.19487", "Asia/Kolkata"),("1259411", "Ponnāni", "", "IN", "356", "", "13", "592", "", "10.76695", "75.92523", "Asia/Kolkata"),("1259412", "Ponnampet", "", "IN", "356", "", "19", "576", "", "12.14473", "75.94514", "Asia/Kolkata"),("1259413", "Ponnamarāvati", "", "IN", "356", "", "25", "621", "", "10.28178", "78.53554", "Asia/Kolkata"),("1259425", "Puducherry", "Пондишери", "IN", "356", "", "22", "635", "", "11.93381", "79.82979", "Asia/Kolkata"),("1259429", "Ponda", "", "IN", "356", "", "33", "585", "", "15.40341", "74.01519", "Asia/Kolkata"),("1259434", "Polūr", "", "IN", "356", "", "25", "606", "", "12.51217", "79.12405", "Asia/Kolkata"),("1259440", "Pollachi", "", "IN", "356", "", "25", "632", "", "10.65825", "77.0085", "Asia/Kolkata"),("1259444", "Polavaram", "", "IN", "356", "", "02", "546", "", "17.24754", "81.64372", "Asia/Kolkata"),("1259446", "Polasara", "", "IN", "356", "", "21", "388", "", "19.69386", "84.81401", "Asia/Kolkata"),("1259460", "Pokaran", "", "IN", "356", "", "24", "114", "", "26.92007", "71.91631", "Asia/Kolkata"),("1259503", "Pithorāgarh", "", "IN", "356", "", "39", "062", "", "29.58349", "80.20947", "Asia/Kolkata"),("1259505", "Pithora", "", "IN", "356", "", "37", "411", "", "21.25021", "82.51707", "Asia/Kolkata"),("1259508", "Pithāpuram", "", "IN", "356", "", "02", "545", "", "17.1168", "82.25284", "Asia/Kolkata"),("1259530", "Piro", "", "IN", "356", "", "34", "231", "", "25.33218", "84.40454", "Asia/Kolkata"),("1259535", "Piriyāpatna", "", "IN", "356", "", "19", "577", "", "12.33497", "76.10073", "Asia/Kolkata"),("1259540", "Pirāwa", "", "IN", "356", "", "24", "129", "", "24.15506", "76.02728", "Asia/Kolkata"),("1259541", "Piravam", "", "IN", "356", "", "13", "595", "", "9.86667", "76.5", "Asia/Kolkata"),("1259552", "Pīpri", "", "IN", "356", "", "16", "515", "", "19.79371", "75.53519", "Asia/Kolkata"),("1259554", "Pipraich", "", "IN", "356", "", "36", "188", "", "26.82745", "83.52632", "Asia/Kolkata"),("1259562", "Pippara", "", "IN", "356", "", "02", "546", "", "16.71667", "81.55", "Asia/Kolkata"),("1259571", "Piploda", "", "IN", "356", "", "35", "435", "", "23.35", "75.43333", "Asia/Kolkata"),("1259592", "Pipili", "", "IN", "356", "", "21", "387", "", "20.11357", "85.83147", "Asia/Kolkata"),("1259608", "Pīpār", "", "IN", "356", "", "24", "113", "", "26.38441", "73.54394", "Asia/Kolkata"),("1259630", "Pinjaur", "", "IN", "356", "", "10", "069", "", "30.79873", "76.91822", "Asia/Kolkata"),("1259638", "Pindwāra", "", "IN", "356", "", "24", "117", "", "24.79749", "73.05505", "Asia/Kolkata"),("1259647", "Pināhat", "", "IN", "356", "", "36", "146", "", "26.88487", "78.37647", "Asia/Kolkata"),("1259652", "Pimpri", "", "IN", "356", "", "16", "521", "", "18.62292", "73.80696", "Asia/Kolkata"),("1259680", "Pilkhua", "", "IN", "356", "", "36", "140", "", "28.71271", "77.656", "Asia/Kolkata"),("1259686", "Pīlibhīt", "Пилибхит", "IN", "356", "", "36", "151", "", "28.63124", "79.80436", "Asia/Kolkata"),("1259688", "Pilibangan", "", "IN", "356", "", "24", "100", "", "29.44964", "74.10093", "Asia/Kolkata"),("1259693", "Pilāni", "", "IN", "356", "", "24", "103", "", "28.36725", "75.60352", "Asia/Kolkata"),("1259701", "Pihānī", "", "IN", "356", "", "36", "155", "", "27.61987", "80.20343", "Asia/Kolkata"),("1259734", "Phūlpur", "", "IN", "356", "", "36", "191", "", "26.07779", "82.87608", "Asia/Kolkata"),("1259735", "Phulpur", "", "IN", "356", "", "36", "175", "", "25.54895", "82.0895", "Asia/Kolkata"),("1259744", "Phulera", "", "IN", "356", "", "24", "110", "", "26.87401", "75.24171", "Asia/Kolkata"),("1259756", "Phulabāni", "", "IN", "356", "", "21", "390", "", "20.47916", "84.23162", "Asia/Kolkata"),("1259773", "Phirangipuram", "", "IN", "356", "", "02", "548", "", "16.29078", "80.26233", "Asia/Kolkata"),("1259775", "Phillaur", "", "IN", "356", "", "23", "037", "", "31.01887", "75.79111", "Asia/Kolkata"),("1259784", "Phek", "", "IN", "356", "", "17", "", "", "25.66667", "94.5", "Asia/Kolkata"),("1259795", "Pharihā", "", "IN", "356", "", "36", "147", "", "27.32166", "78.47267", "Asia/Kolkata"),("1259801", "Phaphūnd", "", "IN", "356", "", "36", "162", "", "26.59888", "79.46437", "Asia/Kolkata"),("1259811", "Phaltan", "", "IN", "356", "", "16", "527", "", "17.99113", "74.43177", "Asia/Kolkata"),("1259813", "Phalodi", "", "IN", "356", "", "24", "113", "", "27.13102", "72.36826", "Asia/Kolkata"),("1259818", "Phalauda", "", "IN", "356", "", "36", "138", "", "29.18824", "77.82996", "Asia/Kolkata"),("1259827", "Phagwāra", "", "IN", "356", "", "23", "036", "", "31.22452", "75.77387", "Asia/Kolkata"),("1259840", "Petlāwad", "", "IN", "356", "", "35", "464", "", "23.01102", "74.79772", "Asia/Kolkata"),("1259841", "Petlād", "", "IN", "356", "", "09", "482", "", "22.47681", "72.79995", "Asia/Kolkata"),("1259853", "Perūr", "", "IN", "356", "", "25", "632", "", "10.97509", "76.91552", "Asia/Kolkata"),("1259855", "Perundurai", "", "IN", "356", "", "25", "610", "", "11.27564", "77.58794", "Asia/Kolkata"),("1259857", "Perumpāvūr", "", "IN", "356", "", "13", "595", "", "10.11544", "76.47611", "Asia/Kolkata"),("1259869", "Pernem", "", "IN", "356", "", "33", "585", "", "15.723", "73.79511", "Asia/Kolkata"),("1259875", "Periyapatti", "", "IN", "356", "", "25", "633", "", "10.75723", "77.27127", "Asia/Kolkata"),("1259877", "Periyanegamam", "", "IN", "356", "", "25", "632", "", "10.74049", "77.10446", "Asia/Kolkata"),("1259878", "Periyanayakkanpalaiyam", "", "IN", "356", "", "25", "632", "", "11.15255", "76.95159", "Asia/Kolkata"),("1259879", "Periyakulam", "", "IN", "356", "", "25", "624", "", "10.12127", "77.54392", "Asia/Kolkata"),("1259880", "Perya", "", "IN", "356", "", "13", "590", "", "11.83334", "75.85408", "Asia/Kolkata"),("1259890", "Peravurani", "", "IN", "356", "", "25", "620", "", "10.29035", "79.20156", "Asia/Kolkata"),("1259892", "Peranāmpattu", "", "IN", "356", "", "25", "605", "", "12.9343", "78.7189", "Asia/Kolkata"),("1259893", "Peranamallūr", "", "IN", "356", "", "25", "606", "", "12.57052", "79.43332", "Asia/Kolkata"),("1259896", "Perambalur", "", "IN", "356", "", "25", "615", "", "11.23333", "78.88333", "Asia/Kolkata"),("1259898", "Peraiyur", "", "IN", "356", "", "25", "623", "", "9.73579", "77.78955", "Asia/Kolkata"),("1259905", "Penukonda", "", "IN", "356", "", "02", "553", "", "14.08286", "77.59473", "Asia/Kolkata"),("1259907", "Penugonda", "", "IN", "356", "", "02", "546", "", "16.65363", "81.7455", "Asia/Kolkata"),("1259914", "Pennāthur", "", "IN", "356", "", "25", "606", "", "12.24681", "79.22592", "Asia/Kolkata"),("1259916", "Pennāgaram", "", "IN", "356", "", "25", "630", "", "12.13433", "77.89525", "Asia/Kolkata"),("1259917", "Pennādam", "", "IN", "356", "", "25", "617", "", "11.40316", "79.24103", "Asia/Kolkata"),("1259924", "Pendra", "", "IN", "356", "", "37", "406", "", "22.77548", "81.95968", "Asia/Kolkata"),("1259931", "Pen", "", "IN", "356", "", "16", "520", "", "18.73734", "73.09603", "Asia/Kolkata"),("1259939", "Pehowa", "", "IN", "356", "", "10", "072", "", "29.97897", "76.58249", "Asia/Kolkata"),("1259954", "Peddāpuram", "", "IN", "356", "", "02", "545", "", "17.07701", "82.13836", "Asia/Kolkata"),("1259961", "Peddapalli", "", "IN", "356", "", "40", "534", "", "18.61357", "79.37442", "Asia/Kolkata"),("1259986", "Pedana", "", "IN", "356", "", "02", "547", "", "16.25582", "81.14378", "Asia/Kolkata"),("1259994", "Payyannūr", "", "IN", "356", "", "13", "589", "", "12.0935", "75.20249", "Asia/Kolkata"),("1260003", "Pawāyan", "", "IN", "356", "", "36", "152", "", "28.06626", "80.10305", "Asia/Kolkata"),("1260009", "Pawai", "", "IN", "356", "", "35", "426", "", "24.26635", "80.16196", "Asia/Kolkata"),("1260014", "Pāvugada", "", "IN", "356", "", "19", "571", "", "14.09953", "77.28018", "Asia/Kolkata"),("1260016", "Pauri", "", "IN", "356", "", "39", "061", "", "30.15286", "78.7771", "Asia/Kolkata"),("1260022", "Pawni", "", "IN", "356", "", "16", "506", "", "20.79229", "79.63644", "Asia/Kolkata"),("1260035", "Pātūr", "", "IN", "356", "", "16", "501", "", "20.46093", "76.93725", "Asia/Kolkata"),("1260040", "Pattukkottai", "", "IN", "356", "", "25", "620", "", "10.42358", "79.31949", "Asia/Kolkata"),("1260045", "Patti", "", "IN", "356", "", "23", "050", "", "31.28092", "74.85849", "Asia/Kolkata"),("1260046", "Patti", "", "IN", "356", "", "36", "173", "", "25.9215", "82.20048", "Asia/Kolkata"),("1260050", "Pattan", "", "IN", "356", "", "12", "008", "", "34.16125", "74.55634", "Asia/Kolkata"),("1260064", "Pātrasāer", "", "IN", "356", "", "28", "339", "", "23.19697", "87.53319", "Asia/Kolkata"),("1260082", "Patnāgarh", "", "IN", "356", "", "21", "393", "", "20.70833", "83.13263", "Asia/Kolkata"),("1260086", "Patna", "Патна", "IN", "356", "", "34", "230", "", "25.59408", "85.13563", "Asia/Kolkata"),("1260104", "Patiāli", "", "IN", "356", "", "36", "202", "", "27.69086", "78.99823", "Asia/Kolkata"),("1260107", "Patiāla", "Патьяла", "IN", "356", "", "23", "048", "", "30.33625", "76.3922", "Asia/Kolkata"),("1260120", "Pāthri", "Патри", "IN", "356", "", "16", "513", "", "19.2588", "76.43412", "Asia/Kolkata"),("1260129", "Patharia", "", "IN", "356", "", "35", "428", "", "23.89921", "79.19393", "Asia/Kolkata"),("1260134", "Pāthardih", "", "IN", "356", "", "38", "354", "", "23.6658", "86.43166", "Asia/Kolkata"),("1260135", "Pāthardi", "", "IN", "356", "", "16", "522", "", "19.17279", "75.17425", "Asia/Kolkata"),("1260137", "Pathānkot", "Патханкот", "IN", "356", "", "23", "8408318", "", "32.27484", "75.65287", "Asia/Kolkata"),("1260138", "Pathanāmthitta", "", "IN", "356", "", "13", "599", "", "9.26667", "76.78333", "Asia/Kolkata"),("1260141", "Pathalgaon", "", "IN", "356", "", "37", "402", "", "22.55656", "83.46355", "Asia/Kolkata"),("1260156", "Pataudi", "", "IN", "356", "", "10", "086", "", "28.32547", "76.77858", "Asia/Kolkata"),("1260168", "Patancheru", "", "IN", "356", "", "40", "535", "", "17.53334", "78.2645", "Asia/Kolkata"),("1260173", "Pātan", "Патан", "IN", "356", "", "09", "470", "", "23.8507", "72.12963", "Asia/Kolkata"),("1260174", "Pātan", "", "IN", "356", "", "35", "451", "", "23.28636", "79.68962", "Asia/Kolkata"),("1260176", "Pātan", "", "IN", "356", "", "37", "409", "", "21.03333", "81.53333", "Asia/Kolkata"),("1260177", "Pātan", "", "IN", "356", "", "16", "527", "", "17.37513", "73.90143", "Asia/Kolkata"),("1260178", "Patāmundai", "", "IN", "356", "", "21", "379", "", "20.57806", "86.56063", "Asia/Kolkata"),("1260206", "Pāsighāt", "", "IN", "356", "", "30", "251", "", "28.06631", "95.32678", "Asia/Kolkata"),("1260210", "Pasān", "", "IN", "356", "", "37", "404", "", "22.84412", "82.19823", "Asia/Kolkata"),("1260221", "Parvatsar", "", "IN", "356", "", "24", "112", "", "26.88604", "74.76602", "Asia/Kolkata"),("1260222", "Pārvatipuram", "", "IN", "356", "", "02", "543", "", "18.78392", "83.42569", "Asia/Kolkata"),("1260228", "Partūr", "", "IN", "356", "", "16", "514", "", "19.59925", "76.21541", "Asia/Kolkata"),("1260232", "Partāpur", "", "IN", "356", "", "24", "125", "", "23.59276", "74.17396", "Asia/Kolkata"),("1260249", "Parshādepur", "", "IN", "356", "", "36", "158", "", "26.07354", "81.49207", "Asia/Kolkata"),("1260274", "Parola", "", "IN", "356", "", "16", "499", "", "20.88098", "75.11937", "Asia/Kolkata"),("1260275", "Parol", "", "IN", "356", "", "12", "007", "", "32.34598", "75.43441", "Asia/Kolkata"),("1260281", "Parnera", "", "IN", "356", "", "09", "491", "", "20.56101", "72.94846", "Asia/Kolkata"),("1260290", "Parli Vaijnāth", "", "IN", "356", "", "16", "523", "", "18.85057", "76.53163", "Asia/Kolkata"),("1260296", "Parlākimidi", "", "IN", "356", "", "02", "", "", "18.78113", "84.08836", "Asia/Kolkata"),("1260304", "Pariyāpuram", "", "IN", "356", "", "13", "592", "", "11.01667", "75.86667", "Asia/Kolkata"),("1260313", "Parīchhatgarh", "", "IN", "356", "", "36", "138", "", "28.97841", "77.93422", "Asia/Kolkata"),("1260314", "Pārīchha", "", "IN", "356", "", "36", "166", "", "25.50789", "78.75954", "Asia/Kolkata"),("1260335", "Pārdi", "", "IN", "356", "", "09", "491", "", "20.5087", "72.94569", "Asia/Kolkata"),("1260341", "Parbhani", "", "IN", "356", "", "16", "513", "", "19.26855", "76.77081", "Asia/Kolkata"),("1260354", "Paravūr", "", "IN", "356", "", "13", "601", "", "8.78333", "76.7", "Asia/Kolkata"),("1260368", "Parāsia", "", "IN", "356", "", "35", "455", "", "22.1913", "78.75904", "Asia/Kolkata"),("1260387", "Paramagudi", "", "IN", "356", "", "25", "626", "", "9.54633", "78.5907", "Asia/Kolkata"),("1260393", "Parādīp Garh", "", "IN", "356", "", "21", "380", "", "20.31641", "86.6085", "Asia/Kolkata"),("1260406", "Pāppinisshēri", "", "IN", "356", "", "13", "589", "", "11.95655", "75.34034", "Asia/Kolkata"),("1260407", "Pāppārappatti", "", "IN", "356", "", "25", "630", "", "12.22086", "78.0592", "Asia/Kolkata"),("1260410", "Pāpireddippatti", "", "IN", "356", "", "25", "630", "", "11.91774", "78.36865", "Asia/Kolkata"),("1260417", "Papanasam", "", "IN", "356", "", "25", "620", "", "10.92687", "79.27056", "Asia/Kolkata"),("1260421", "Pāonta Sāhib", "", "IN", "356", "", "11", "032", "", "30.43666", "77.62462", "Asia/Kolkata"),("1260434", "Panvel", "", "IN", "356", "", "16", "520", "", "18.98878", "73.11013", "Asia/Kolkata"),("1260447", "Pānsemāl", "", "IN", "356", "", "35", "441", "", "21.65981", "74.69937", "Asia/Kolkata"),("1260448", "Panruti", "", "IN", "356", "", "25", "617", "", "11.77662", "79.55269", "Asia/Kolkata"),("1260454", "Panna", "", "IN", "356", "", "35", "426", "", "24.72094", "80.18772", "Asia/Kolkata"),("1260456", "Panmana", "", "IN", "356", "", "13", "600", "", "9.01667", "76.51667", "Asia/Kolkata"),("1260476", "Pānīpat", "Панипата", "IN", "356", "", "10", "075", "", "29.38747", "76.96825", "Asia/Kolkata"),("1260482", "Pānihāti", "", "IN", "356", "", "28", "337", "", "22.69089", "88.37404", "Asia/Kolkata"),("1260527", "Pandua", "", "IN", "356", "", "28", "338", "", "23.07492", "88.28637", "Asia/Kolkata"),("1260543", "Pāndhurnā", "", "IN", "356", "", "35", "455", "", "21.59556", "78.52628", "Asia/Kolkata"),("1260546", "Pandharpur", "Пандхарпур", "IN", "356", "", "16", "526", "", "17.67924", "75.33098", "Asia/Kolkata"),("1260548", "Pandhāna", "", "IN", "356", "", "35", "466", "", "21.69816", "76.22487", "Asia/Kolkata"),("1260553", "French Rocks", "", "IN", "356", "", "19", "573", "", "12.50094", "76.67416", "Asia/Kolkata"),("1260555", "Pāndātarai", "", "IN", "356", "", "37", "407", "", "22.18714", "81.32815", "Asia/Kolkata"),("1260556", "Pandaria", "", "IN", "356", "", "37", "407", "", "22.22495", "81.40994", "Asia/Kolkata"),("1260577", "Pānchgani", "", "IN", "356", "", "16", "527", "", "17.92449", "73.8008", "Asia/Kolkata"),("1260606", "Panamaram", "", "IN", "356", "", "13", "590", "", "11.74014", "76.07369", "Asia/Kolkata"),("1260607", "Panaji", "Панаджи", "IN", "356", "", "33", "585", "", "15.49574", "73.82624", "Asia/Kolkata"),("1260612", "Panāgar", "", "IN", "356", "", "35", "451", "", "23.28539", "79.99509", "Asia/Kolkata"),("1260637", "Palwal", "", "IN", "356", "", "10", "089", "", "28.14469", "77.32546", "Asia/Kolkata"),("1260667", "Pāloncha", "", "IN", "356", "", "40", "541", "", "17.60184", "80.70509", "Asia/Kolkata"),("1260671", "Palani", "Палани", "IN", "356", "", "25", "612", "", "10.45034", "77.5209", "Asia/Kolkata"),("1260674", "Palmaner", "", "IN", "356", "", "02", "554", "", "13.2", "78.74725", "Asia/Kolkata"),("1260681", "Pallippatti", "", "IN", "356", "", "25", "630", "", "11.93956", "78.40152", "Asia/Kolkata"),("1260683", "Pallipattu", "", "IN", "356", "", "25", "", "", "13.3386", "79.44489", "Asia/Kolkata"),("1260685", "Pallikondai", "", "IN", "356", "", "25", "605", "", "12.90518", "78.9427", "Asia/Kolkata"),("1260691", "Palle", "", "IN", "356", "", "33", "585", "", "15.46667", "74.08333", "Asia/Kolkata"),("1260692", "Pallāvaram", "", "IN", "356", "", "25", "604", "", "12.96796", "80.15025", "Asia/Kolkata"),("1260693", "Pallattūr", "", "IN", "356", "", "25", "622", "", "10.1456", "78.80263", "Asia/Kolkata"),("1260694", "Pallappatti", "", "IN", "356", "", "25", "613", "", "10.72057", "77.87951", "Asia/Kolkata"),("1260697", "Palladam", "", "IN", "356", "", "25", "633", "", "10.99175", "77.28633", "Asia/Kolkata"),("1260702", "Pālkonda", "", "IN", "356", "", "02", "542", "", "18.60374", "83.75568", "Asia/Kolkata"),("1260706", "Pāliyād", "", "IN", "356", "", "09", "481", "", "22.25757", "71.56024", "Asia/Kolkata"),("1260707", "Pālitāna", "Палитана", "IN", "356", "", "09", "481", "", "21.52519", "71.82309", "Asia/Kolkata"),("1260713", "Paliā Kalān", "", "IN", "356", "", "36", "153", "", "28.43205", "80.58137", "Asia/Kolkata"),("1260716", "Pāli", "Пали", "IN", "356", "", "24", "118", "", "25.77276", "73.32335", "Asia/Kolkata"),("1260717", "Pāli", "", "IN", "356", "", "36", "167", "", "24.49188", "78.41617", "Asia/Kolkata"),("1260718", "Pāli", "Пали", "IN", "356", "", "35", "431", "", "23.36453", "81.04374", "Asia/Kolkata"),("1260728", "Pālghāt", "Палаккад", "IN", "356", "", "13", "593", "", "10.77319", "76.65366", "Asia/Kolkata"),("1260730", "Pālghar", "", "IN", "356", "", "16", "517", "", "19.69693", "72.76543", "Asia/Kolkata"),("1260734", "Palera", "", "IN", "356", "", "35", "424", "", "25.02013", "79.22818", "Asia/Kolkata"),("1260771", "Palāsa", "", "IN", "356", "", "02", "542", "", "18.77257", "84.41012", "Asia/Kolkata"),("1260777", "Pālanpur", "", "IN", "356", "", "09", "469", "", "24.17128", "72.43827", "Asia/Kolkata"),("1260786", "Pālamedu", "", "IN", "356", "", "25", "623", "", "10.10492", "78.11348", "Asia/Kolkata"),("1260792", "Pālakollu", "", "IN", "356", "", "02", "546", "", "16.5167", "81.73", "Asia/Kolkata"),("1260793", "Pālakkodu", "", "IN", "356", "", "25", "630", "", "12.30696", "78.07022", "Asia/Kolkata"),("1260824", "Pākaur", "", "IN", "356", "", "38", "353", "", "24.63925", "87.84239", "Asia/Kolkata"),("1260830", "Pākāla", "", "IN", "356", "", "02", "554", "", "13.44903", "79.11493", "Asia/Kolkata"),("1260833", "Paithan", "", "IN", "356", "", "16", "515", "", "19.47506", "75.38558", "Asia/Kolkata"),("1260868", "Pahāsu", "", "IN", "356", "", "36", "142", "", "28.1722", "78.06376", "Asia/Kolkata"),("1260880", "Pahlgām", "", "IN", "356", "", "12", "014", "", "34.01592", "75.31899", "Asia/Kolkata"),("1260909", "Padrauna", "", "IN", "356", "", "36", "189", "", "26.90403", "83.98087", "Asia/Kolkata"),("1260911", "Padra", "", "IN", "356", "", "09", "486", "", "22.2398", "73.08451", "Asia/Kolkata"),("1260918", "Padmanābhapuram", "", "IN", "356", "", "25", "629", "", "8.24462", "77.32581", "Asia/Kolkata"),("1260933", "Paddhari", "", "IN", "356", "", "09", "476", "", "22.43654", "70.60162", "Asia/Kolkata"),("1260938", "Padampur", "", "IN", "356", "", "24", "099", "", "29.70885", "73.62539", "Asia/Kolkata"),("1260940", "Padampur", "", "IN", "356", "", "21", "370", "", "20.99932", "83.06325", "Asia/Kolkata"),("1260942", "Padam", "", "IN", "356", "", "12", "004", "", "33.46659", "76.88488", "Asia/Kolkata"),("1260954", "Pachperwa", "", "IN", "356", "", "36", "182", "", "27.51234", "82.64297", "Asia/Kolkata"),("1260959", "Pāchora", "", "IN", "356", "", "16", "499", "", "20.66727", "75.35305", "Asia/Kolkata"),("1261008", "Ottappālam", "", "IN", "356", "", "13", "593", "", "10.7735", "76.37758", "Asia/Kolkata"),("1261012", "Osmanabad", "Османабад", "IN", "356", "", "16", "525", "1261013", "18.18158", "76.03889", "Asia/Kolkata"),("1261033", "Orchha", "", "IN", "356", "", "35", "424", "", "25.35192", "78.64033", "Asia/Kolkata"),("1261037", "Oran", "", "IN", "356", "", "36", "170", "", "25.36882", "80.7423", "Asia/Kolkata"),("1261039", "Orai", "", "IN", "356", "", "36", "165", "", "25.99023", "79.45334", "Asia/Kolkata"),("1261045", "Ongole", "Онголе", "IN", "356", "", "02", "549", "", "15.50357", "80.04454", "Asia/Kolkata"),("1261049", "Omalur", "", "IN", "356", "", "25", "608", "", "11.74099", "78.04559", "Asia/Kolkata"),("1261050", "Olpād", "", "IN", "356", "", "09", "492", "", "21.33649", "72.75161", "Asia/Kolkata"),("1261066", "Okha", "Оха", "IN", "356", "", "09", "477", "", "22.46756", "69.07002", "Asia/Kolkata"),("1261068", "Ozar", "", "IN", "356", "", "16", "516", "", "20.09473", "73.92816", "Asia/Kolkata"),("1261076", "Odugattūr", "", "IN", "356", "", "25", "605", "", "12.76793", "78.88304", "Asia/Kolkata"),("1261077", "Odlābāri", "", "IN", "356", "", "28", "328", "", "26.83644", "88.62943", "Asia/Kolkata"),("1261086", "Obra", "", "IN", "356", "", "36", "200", "", "24.41863", "82.98797", "Asia/Kolkata"),("1261107", "Nyāmti", "", "IN", "356", "", "19", "567", "", "14.14869", "75.57641", "Asia/Kolkata"),("1261110", "Nūzvīd", "", "IN", "356", "", "02", "547", "", "16.78854", "80.84593", "Asia/Kolkata"),("1261120", "Nūrpur Kalān", "", "IN", "356", "", "23", "051", "", "31.16667", "76.48333", "Asia/Kolkata"),("1261122", "Nūrpur", "", "IN", "356", "", "36", "134", "", "29.14956", "78.4084", "Asia/Kolkata"),("1261124", "Nūrmahal", "", "IN", "356", "", "23", "037", "", "31.09662", "75.59386", "Asia/Kolkata"),("1261142", "Numāligarh", "", "IN", "356", "", "03", "313", "", "26.62249", "93.72225", "Asia/Kolkata"),("1261145", "Nūh", "", "IN", "356", "", "10", "087", "", "28.10296", "77.00144", "Asia/Kolkata"),("1261162", "Nowrangapur", "", "IN", "356", "", "21", "397", "", "19.23114", "82.54826", "Asia/Kolkata"),("1261181", "North Lakhimpur", "", "IN", "356", "", "03", "307", "", "27.23517", "94.10357", "Asia/Kolkata"),("1261186", "North Guwāhāti", "", "IN", "356", "", "03", "321", "", "26.19749", "91.7202", "Asia/Kolkata"),("1261205", "Nongstoin", "", "IN", "356", "", "18", "296", "", "25.51704", "91.26484", "Asia/Kolkata"),("1261208", "Nongpoh", "", "IN", "356", "", "18", "297", "", "25.9023", "91.87694", "Asia/Kolkata"),("1261227", "Nokha", "", "IN", "356", "", "24", "101", "", "27.56155", "73.47141", "Asia/Kolkata"),("1261234", "Nohar", "", "IN", "356", "", "24", "100", "", "29.18292", "74.77064", "Asia/Kolkata"),("1261242", "Noāmundi", "", "IN", "356", "", "38", "368", "", "22.16094", "85.50416", "Asia/Kolkata"),("1261257", "Nizāmābād", "", "IN", "356", "", "36", "191", "", "26.05295", "83.05787", "Asia/Kolkata"),("1261258", "Nizāmābād", "", "IN", "356", "", "40", "533", "", "18.67154", "78.0988", "Asia/Kolkata"),("1261262", "Niwāri", "", "IN", "356", "", "36", "140", "", "28.87611", "77.5382", "Asia/Kolkata"),("1261283", "Nirsā", "", "IN", "356", "", "38", "354", "", "23.78438", "86.70692", "Asia/Kolkata"),("1261285", "Nirmāli", "", "IN", "356", "", "34", "208", "", "26.31397", "86.58537", "Asia/Kolkata"),("1261288", "Nirmal", "Нирмала", "IN", "356", "", "40", "532", "", "19.09685", "78.34407", "Asia/Kolkata"),("1261309", "Nipāni", "", "IN", "356", "", "16", "", "", "16.399", "74.38285", "Asia/Kolkata"),("1261342", "Neem ka Thana", "", "IN", "356", "", "24", "111", "", "27.73976", "75.78652", "Asia/Kolkata"),("1261369", "Nīmbāhera", "", "IN", "356", "", "24", "126", "", "24.62166", "74.67999", "Asia/Kolkata"),("1261375", "Nimāparha", "", "IN", "356", "", "21", "387", "", "20.05756", "86.00436", "Asia/Kolkata"),("1261378", "Nīmāj", "", "IN", "356", "", "24", "118", "", "26.14995", "74.00094", "Asia/Kolkata"),("1261382", "Nīlokheri", "", "IN", "356", "", "10", "074", "", "29.83671", "76.93191", "Asia/Kolkata"),("1261394", "Nīlēshwar", "", "IN", "356", "", "13", "588", "", "12.25953", "75.1352", "Asia/Kolkata"),("1261396", "Nilanga", "", "IN", "356", "", "16", "524", "", "18.11675", "76.75279", "Asia/Kolkata"),("1261401", "Nilakottai", "", "IN", "356", "", "25", "612", "", "10.165", "77.85024", "Asia/Kolkata"),("1261402", "Nīlgiri", "", "IN", "356", "", "21", "377", "", "21.46235", "86.76794", "Asia/Kolkata"),("1261415", "Nihtaur", "", "IN", "356", "", "36", "134", "", "29.32416", "78.38724", "Asia/Kolkata"),("1261444", "Needamangalam", "", "IN", "356", "", "25", "619", "", "10.77378", "79.41875", "Asia/Kolkata"),("1261446", "Nidadavole", "", "IN", "356", "", "02", "546", "", "16.90572", "81.67222", "Asia/Kolkata"),("1261451", "Nichlaul", "", "IN", "356", "", "36", "187", "", "27.31247", "83.7253", "Asia/Kolkata"),("1261470", "Neyyāttinkara", "", "IN", "356", "", "13", "601", "", "8.39854", "77.08586", "Asia/Kolkata"),("1261481", "New Delhi", "Нью-Дели", "IN", "356", "", "07", "094", "", "28.63576", "77.22445", "Asia/Kolkata"),("1261512", "Neral", "", "IN", "356", "", "16", "520", "", "19.02475", "73.31688", "Asia/Kolkata"),("1261517", "Nepānagar", "", "IN", "356", "", "35", "467", "", "21.4538", "76.39335", "Asia/Kolkata"),("1261529", "Nellore", "Неллор", "IN", "356", "", "02", "550", "", "14.44992", "79.98697", "Asia/Kolkata"),("1261532", "Nellikkuppam", "", "IN", "356", "", "25", "617", "", "11.77577", "79.66789", "Asia/Kolkata"),("1261539", "Nelamangala", "", "IN", "356", "", "19", "583", "", "13.09978", "77.39364", "Asia/Kolkata"),("1261553", "Nedumangād", "", "IN", "356", "", "13", "601", "", "8.60267", "77.00139", "Asia/Kolkata"),("1261563", "Nāzirā", "", "IN", "356", "", "03", "311", "", "26.91649", "94.73611", "Asia/Kolkata"),("1261567", "Nāyudupet", "", "IN", "356", "", "02", "550", "", "13.90742", "79.89465", "Asia/Kolkata"),("1261580", "Nayāgarh", "", "IN", "356", "", "21", "385", "", "20.12856", "85.09563", "Asia/Kolkata"),("1261598", "Nawāshahr", "", "IN", "356", "", "23", "039", "", "31.1245", "76.11613", "Asia/Kolkata"),("1261607", "Nawānshahr", "", "IN", "356", "", "12", "021", "", "32.76505", "74.52772", "Asia/Kolkata"),("1261613", "Nawalgarh", "", "IN", "356", "", "24", "103", "", "27.85161", "75.27384", "Asia/Kolkata"),("1261614", "Niwai", "", "IN", "356", "", "24", "120", "", "26.36073", "75.91836", "Asia/Kolkata"),("1261631", "Nawāda", "", "IN", "356", "", "34", "237", "", "24.8867", "85.54364", "Asia/Kolkata"),("1261638", "Nawābganj", "", "IN", "356", "", "36", "164", "", "26.49716", "80.30934", "Asia/Kolkata"),("1261639", "Nawābganj", "", "IN", "356", "", "36", "150", "", "28.54103", "79.63462", "Asia/Kolkata"),("1261641", "Nawābganj", "", "IN", "356", "", "36", "176", "", "26.93129", "81.19841", "Asia/Kolkata"),("1261642", "Nawābganj", "", "IN", "356", "", "36", "183", "", "26.86396", "82.14103", "Asia/Kolkata"),("1261647", "Nāwa", "", "IN", "356", "", "24", "112", "", "27.0195", "75.00226", "Asia/Kolkata"),("1261660", "Navelim", "", "IN", "356", "", "33", "585", "", "15.53333", "73.98333", "Asia/Kolkata"),("1261667", "Navalgund", "", "IN", "356", "", "19", "562", "", "15.55877", "75.35305", "Asia/Kolkata"),("1261669", "Navadwīp", "Навадвип", "IN", "356", "", "28", "336", "", "23.4067", "88.36861", "Asia/Kolkata"),("1261672", "Nautanwa", "", "IN", "356", "", "36", "187", "", "27.42752", "83.41789", "Asia/Kolkata"),("1261696", "Naugachhia", "", "IN", "356", "", "34", "224", "", "25.38807", "87.09906", "Asia/Kolkata"),("1261704", "Nāttarasankottai", "", "IN", "356", "", "25", "622", "", "9.87144", "78.55211", "Asia/Kolkata"),("1261705", "Nattam", "", "IN", "356", "", "25", "612", "", "10.22776", "78.22969", "Asia/Kolkata"),("1261711", "Nāthdwāra", "", "IN", "356", "", "24", "123", "", "24.93805", "73.82392", "Asia/Kolkata"),("1261721", "Nasrullāhganj", "", "IN", "356", "", "35", "445", "", "22.6837", "77.27069", "Asia/Kolkata"),("1261722", "Nāsriganj", "", "IN", "356", "", "34", "234", "", "25.0514", "84.32839", "Asia/Kolkata"),("1261726", "Nāspur", "", "IN", "356", "", "40", "532", "", "18.84577", "79.46165", "Asia/Kolkata"),("1261727", "Nasīrābād", "", "IN", "356", "", "24", "119", "", "26.30473", "74.73364", "Asia/Kolkata"),("1261731", "Nashik", "Насик", "IN", "356", "", "16", "516", "", "19.99727", "73.79096", "Asia/Kolkata"),("1261736", "Narwar", "", "IN", "356", "", "35", "423", "", "25.6439", "77.9129", "Asia/Kolkata"),("1261739", "Narwāna", "", "IN", "356", "", "10", "077", "", "29.59903", "76.11927", "Asia/Kolkata"),("1261748", "Narsīpatnam", "", "IN", "356", "", "02", "544", "", "17.66709", "82.61245", "Asia/Kolkata"),("1261750", "Nārsingi", "", "IN", "356", "", "40", "535", "", "18.04468", "78.42516", "Asia/Kolkata"),("1261752", "Narsinghgarh", "", "IN", "356", "", "35", "442", "", "23.70758", "77.09319", "Asia/Kolkata"),("1261754", "Narsimhapur", "", "IN", "356", "", "35", "452", "", "22.94936", "79.18357", "Asia/Kolkata"),("1261768", "Naroda", "", "IN", "356", "", "09", "474", "", "23.07041", "72.65702", "Asia/Kolkata"),("1261771", "Nārnaund", "", "IN", "356", "", "10", "080", "", "29.22047", "76.14278", "Asia/Kolkata"),("1261772", "Nārnaul", "", "IN", "356", "", "10", "084", "", "28.04444", "76.10833", "Asia/Kolkata"),("1261798", "Narharpur", "", "IN", "356", "", "37", "413", "", "20.44892", "81.62004", "Asia/Kolkata"),("1261800", "Nargund", "", "IN", "356", "", "19", "561", "", "15.72299", "75.38666", "Asia/Kolkata"),("1261810", "Naregal", "", "IN", "356", "", "19", "561", "", "15.57316", "75.80805", "Asia/Kolkata"),("1261823", "Nārāyanpet", "", "IN", "356", "", "40", "538", "", "16.74799", "77.4954", "Asia/Kolkata"),("1261828", "Narāyangarh", "", "IN", "356", "", "10", "070", "", "30.47798", "77.12804", "Asia/Kolkata"),("1261829", "Nārāyangarh", "", "IN", "356", "", "35", "433", "", "24.27083", "75.05007", "Asia/Kolkata"),("1261832", "Nārāyanavanam", "", "IN", "356", "", "02", "554", "", "13.42565", "79.58881", "Asia/Kolkata"),("1261835", "Nāravārikuppam", "", "IN", "356", "", "25", "602", "", "13.19133", "80.18473", "Asia/Kolkata"),("1261837", "Naraura", "", "IN", "356", "", "36", "142", "", "28.20147", "78.38723", "Asia/Kolkata"),("1261839", "Narauli", "", "IN", "356", "", "36", "135", "", "28.48547", "78.71484", "Asia/Kolkata"),("1261844", "Narasingāpuram", "", "IN", "356", "", "02", "554", "", "13.60759", "79.31652", "Asia/Kolkata"),("1261847", "Narasimharājapura", "", "IN", "356", "", "19", "570", "", "13.61075", "75.512", "Asia/Kolkata"),("1261848", "Narasaraopet", "", "IN", "356", "", "02", "548", "", "16.23488", "80.04927", "Asia/Kolkata"),("1261852", "Narasapur", "", "IN", "356", "", "02", "545", "", "16.43425", "81.69845", "Asia/Kolkata"),("1261853", "Narasannapeta", "", "IN", "356", "", "02", "542", "", "18.41428", "84.04463", "Asia/Kolkata"),("1261871", "Naraini", "", "IN", "356", "", "35", "", "", "25.19033", "80.475", "Asia/Kolkata"),("1261872", "Naraina", "", "IN", "356", "", "24", "110", "", "26.79069", "75.20608", "Asia/Kolkata"),("1261882", "Napāsar", "", "IN", "356", "", "24", "101", "", "27.96059", "73.55913", "Asia/Kolkata"),("1261901", "Nānpāra", "", "IN", "356", "", "36", "180", "", "27.86459", "81.50036", "Asia/Kolkata"),("1261906", "Nannilam", "", "IN", "356", "", "25", "619", "", "10.87933", "79.61062", "Asia/Kolkata"),("1261910", "Nanjangūd", "", "IN", "356", "", "19", "577", "", "12.11764", "76.68397", "Asia/Kolkata"),("1261911", "Nanguneri", "", "IN", "356", "", "25", "628", "", "8.49326", "77.65806", "Asia/Kolkata"),("1261913", "Nāngloi Jāt", "", "IN", "356", "", "07", "096", "", "28.67957", "77.06799", "Asia/Kolkata"),("1261915", "Nangavalli", "", "IN", "356", "", "25", "608", "", "11.76108", "77.89137", "Asia/Kolkata"),("1261922", "Nāngal Township", "Нангал", "IN", "356", "", "23", "051", "", "31.38966", "76.37574", "Asia/Kolkata"),("1261927", "Nandyāl", "", "IN", "356", "", "02", "552", "", "15.47799", "78.4836", "Asia/Kolkata"),("1261931", "Nandurbar", "", "IN", "356", "", "16", "497", "", "21.36671", "74.24051", "Asia/Kolkata"),("1261932", "Nāndūra Buzurg", "", "IN", "356", "", "16", "500", "", "20.83417", "76.45924", "Asia/Kolkata"),("1261957", "Nandikotkūr", "", "IN", "356", "", "02", "552", "", "15.85668", "78.26569", "Asia/Kolkata"),("1261960", "Nandigāma", "", "IN", "356", "", "02", "547", "", "16.7717", "80.28596", "Asia/Kolkata"),("1261968", "Nandgaon", "", "IN", "356", "", "36", "145", "", "27.71102", "77.38653", "Asia/Kolkata"),("1261971", "Nāndgaon", "", "IN", "356", "", "16", "516", "", "20.3068", "74.65501", "Asia/Kolkata"),("1261977", "Nanded", "Нандед", "IN", "356", "", "16", "511", "1261978", "19.16023", "77.31497", "Asia/Kolkata"),("1261998", "Nanauta", "", "IN", "356", "", "36", "132", "", "29.71215", "77.41728", "Asia/Kolkata"),("1262013", "Nāmrup", "", "IN", "356", "", "03", "310", "", "27.19395", "95.31929", "Asia/Kolkata"),("1262020", "Namli", "", "IN", "356", "", "35", "434", "", "23.46115", "75.06036", "Asia/Kolkata"),("1262032", "Nambutalai", "", "IN", "356", "", "25", "626", "", "9.72766", "79.00707", "Asia/Kolkata"),("1262034", "Nambiyūr", "", "IN", "356", "", "25", "610", "", "11.35833", "77.32099", "Asia/Kolkata"),("1262039", "Nāmakkal", "", "IN", "356", "", "25", "609", "", "11.22126", "78.16524", "Asia/Kolkata"),("1262040", "Nāmagiripettai", "", "IN", "356", "", "25", "609", "", "11.455", "78.269", "Asia/Kolkata"),("1262062", "Naliya", "", "IN", "356", "", "09", "468", "", "23.26058", "68.82655", "Asia/Kolkata"),("1262065", "Nalhāti", "", "IN", "356", "", "28", "334", "", "24.29704", "87.82899", "Asia/Kolkata"),("1262067", "Nalgonda", "Налгонда", "IN", "356", "", "40", "539", "", "17.05439", "79.26707", "Asia/Kolkata"),("1262073", "Naldurg", "", "IN", "356", "", "16", "525", "", "17.81667", "76.28182", "Asia/Kolkata"),("1262083", "Nālāgarh", "", "IN", "356", "", "11", "031", "", "31.04168", "76.72285", "Asia/Kolkata"),("1262089", "Nakūr", "", "IN", "356", "", "36", "132", "", "29.91964", "77.30438", "Asia/Kolkata"),("1262092", "Naksalbāri", "", "IN", "356", "", "28", "327", "", "26.6827", "88.22001", "Asia/Kolkata"),("1262097", "Nakodar", "", "IN", "356", "", "23", "037", "", "31.12586", "75.47508", "Asia/Kolkata"),("1262109", "Najībābād", "", "IN", "356", "", "36", "134", "", "29.61194", "78.34274", "Asia/Kolkata"),("1262115", "Nainwa", "", "IN", "356", "", "24", "121", "", "25.77145", "75.84978", "Asia/Kolkata"),("1262116", "Nainpur", "", "IN", "356", "", "35", "454", "", "22.42996", "80.10561", "Asia/Kolkata"),("1262117", "Naini Tāl", "", "IN", "356", "", "39", "066", "", "29.39743", "79.44686", "Asia/Kolkata"),("1262131", "Naihāti", "", "IN", "356", "", "28", "337", "", "22.89396", "88.41521", "Asia/Kolkata"),("1262134", "Naīgarhi", "", "IN", "356", "", "35", "430", "", "24.78686", "81.77868", "Asia/Kolkata"),("1262140", "Nahorkatiya", "", "IN", "356", "", "03", "310", "", "27.28912", "95.3418", "Asia/Kolkata"),("1262151", "Nāhan", "", "IN", "356", "", "11", "032", "", "30.56029", "77.29426", "Asia/Kolkata");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("1262162", "Nagrota", "", "IN", "356", "", "11", "024", "", "32.0571", "76.09139", "Asia/Kolkata"),("1262168", "Nagrām", "", "IN", "356", "", "36", "157", "", "26.61872", "81.14043", "Asia/Kolkata"),("1262180", "Nagpur", "Нагпур", "IN", "356", "", "16", "505", "", "21.14631", "79.08491", "Asia/Kolkata"),("1262183", "Nāgothana", "", "IN", "356", "", "16", "520", "", "18.54225", "73.13493", "Asia/Kolkata"),("1262187", "Nāgod", "", "IN", "356", "", "35", "429", "", "24.56924", "80.58809", "Asia/Kolkata"),("1262196", "Nāgireddipalli", "", "IN", "356", "", "02", "551", "", "14.27005", "79.10131", "Asia/Kolkata"),("1262200", "Nagīna", "", "IN", "356", "", "36", "134", "", "29.44433", "78.43646", "Asia/Kolkata"),("1262204", "Nāgercoil", "", "IN", "356", "", "25", "629", "", "8.17731", "77.43437", "Asia/Kolkata"),("1262209", "Nagda", "", "IN", "356", "", "35", "435", "", "23.45834", "75.41759", "Asia/Kolkata"),("1262216", "Nāgaur", "", "IN", "356", "", "24", "112", "", "27.20201", "73.73394", "Asia/Kolkata"),("1262230", "Nāgar Karnūl", "", "IN", "356", "", "40", "538", "", "16.4821", "78.32471", "Asia/Kolkata"),("1262240", "Nagari", "", "IN", "356", "", "02", "554", "", "13.32139", "79.58557", "Asia/Kolkata"),("1262253", "Nagar", "", "IN", "356", "", "24", "105", "", "27.42397", "77.09922", "Asia/Kolkata"),("1262260", "Nāgappattinam", "", "IN", "356", "", "25", "618", "", "10.76393", "79.84454", "Asia/Kolkata"),("1262266", "Nāgamangala", "", "IN", "356", "", "19", "573", "", "12.81939", "76.75456", "Asia/Kolkata"),("1262284", "Naduvattam", "", "IN", "356", "", "25", "611", "", "11.48075", "76.54365", "Asia/Kolkata"),("1262285", "Naduvannūr", "", "IN", "356", "", "13", "591", "", "11.48772", "75.77511", "Asia/Kolkata"),("1262291", "Nadīgaon", "", "IN", "356", "", "36", "165", "", "26.10784", "79.02283", "Asia/Kolkata"),("1262292", "Nadiād", "", "IN", "356", "", "09", "483", "", "22.69385", "72.86157", "Asia/Kolkata"),("1262296", "Nādbai", "", "IN", "356", "", "24", "105", "", "27.22288", "77.19569", "Asia/Kolkata"),("1262302", "Nādāpuram", "", "IN", "356", "", "13", "591", "", "11.68465", "75.65493", "Asia/Kolkata"),("1262318", "Nabīnagar", "", "IN", "356", "", "34", "235", "", "24.60681", "84.12624", "Asia/Kolkata"),("1262319", "Nābha", "", "IN", "356", "", "23", "048", "", "30.37577", "76.15292", "Asia/Kolkata"),("1262321", "Mysore", "Майсур", "IN", "356", "", "19", "577", "", "12.29791", "76.63925", "Asia/Kolkata"),("1262330", "Muzaffarpur", "", "IN", "356", "", "34", "216", "", "26.12259", "85.39055", "Asia/Kolkata"),("1262332", "Muzaffarnagar", "", "IN", "356", "", "36", "133", "", "29.47091", "77.70332", "Asia/Kolkata"),("1262338", "Mūvattupula", "", "IN", "356", "", "13", "595", "", "9.98493", "76.57728", "Asia/Kolkata"),("1262346", "Muttupet", "", "IN", "356", "", "25", "619", "", "10.39531", "79.49425", "Asia/Kolkata"),("1262369", "Mustafābād", "", "IN", "356", "", "10", "071", "", "30.2022", "77.14873", "Asia/Kolkata"),("1262374", "Mussoorie", "Муссури", "IN", "356", "", "39", "060", "", "30.45498", "78.07068", "Asia/Kolkata"),("1262380", "Musiri", "", "IN", "356", "", "25", "614", "", "10.95299", "78.44427", "Asia/Kolkata"),("1262382", "Mushābani", "", "IN", "356", "", "38", "357", "", "22.51135", "86.45713", "Asia/Kolkata"),("1262392", "Musāfir-Khāna", "", "IN", "356", "", "36", "179", "", "26.37837", "81.79607", "Asia/Kolkata"),("1262395", "Murwāra", "", "IN", "356", "", "35", "450", "", "23.83776", "80.39405", "Asia/Kolkata"),("1262403", "Murud", "", "IN", "356", "", "16", "520", "", "18.32817", "72.9621", "Asia/Kolkata"),("1262410", "Murtajāpur", "", "IN", "356", "", "16", "501", "", "20.73299", "77.36694", "Asia/Kolkata"),("1262412", "Murshidābād", "Муршидабад", "IN", "356", "", "28", "333", "", "24.1839", "88.27171", "Asia/Kolkata"),("1262414", "Mursān", "", "IN", "356", "", "36", "144", "", "27.57788", "77.94091", "Asia/Kolkata"),("1262419", "Murlīganj", "", "IN", "356", "", "34", "213", "", "25.8969", "86.99577", "Asia/Kolkata"),("1262426", "Morinda", "Моринда", "IN", "356", "", "23", "051", "", "30.79014", "76.49883", "Asia/Kolkata"),("1262429", "Muri", "", "IN", "356", "", "28", "", "", "23.37074", "85.86236", "Asia/Kolkata"),("1262435", "Murgūd", "", "IN", "356", "", "16", "530", "", "16.39604", "74.19142", "Asia/Kolkata"),("1262444", "Murbād", "", "IN", "356", "", "16", "517", "", "19.25395", "73.38993", "Asia/Kolkata"),("1262452", "Muragācha", "", "IN", "356", "", "28", "336", "", "23.53631", "88.39425", "Asia/Kolkata"),("1262453", "Murādnagar", "", "IN", "356", "", "36", "140", "", "28.78069", "77.49865", "Asia/Kolkata"),("1262463", "Munnar", "Муннар", "IN", "356", "", "13", "596", "", "10.08873", "77.06269", "Asia/Kolkata"),("1262469", "Munirābād", "", "IN", "356", "", "19", "560", "", "15.30928", "76.3383", "Asia/Kolkata"),("1262482", "Monghyr", "Мангер", "IN", "356", "", "34", "226", "", "25.37459", "86.47455", "Asia/Kolkata"),("1262484", "Mungeli", "", "IN", "356", "", "37", "406", "", "22.06566", "81.68543", "Asia/Kolkata"),("1262485", "Mungaoli", "", "IN", "356", "", "35", "459", "", "24.40837", "78.09588", "Asia/Kolkata"),("1262491", "Mūndwa", "", "IN", "356", "", "24", "112", "", "27.0631", "73.82304", "Asia/Kolkata"),("1262497", "Mundra", "", "IN", "356", "", "09", "468", "", "22.83918", "69.7219", "Asia/Kolkata"),("1262504", "Mundi", "", "IN", "356", "", "35", "466", "", "22.06693", "76.49326", "Asia/Kolkata"),("1262510", "Mundgod", "", "IN", "356", "", "19", "563", "", "14.97144", "75.03658", "Asia/Kolkata"),("1262516", "Mundargi", "", "IN", "356", "", "19", "561", "", "15.20677", "75.8839", "Asia/Kolkata"),("1262534", "Multai", "", "IN", "356", "", "35", "447", "", "21.77463", "78.25756", "Asia/Kolkata"),("1262546", "Mūlki", "", "IN", "356", "", "19", "575", "", "13.09101", "74.79353", "Asia/Kolkata"),("1262553", "Mulgund", "", "IN", "356", "", "19", "561", "", "15.2807", "75.52132", "Asia/Kolkata"),("1262562", "Mulbāgal", "", "IN", "356", "", "19", "581", "", "13.16352", "78.39346", "Asia/Kolkata"),("1262566", "Muluppilagadu", "", "IN", "356", "", "13", "589", "", "11.79788", "75.45111", "Asia/Kolkata"),("1262567", "Mūlanūr", "", "IN", "356", "", "25", "633", "", "10.79436", "77.71175", "Asia/Kolkata"),("1262574", "Mūl", "", "IN", "356", "", "16", "509", "", "20.06987", "79.67826", "Asia/Kolkata"),("1262578", "Muktsar", "", "IN", "356", "", "23", "044", "", "30.47426", "74.5166", "Asia/Kolkata"),("1262591", "Mukher", "", "IN", "356", "", "16", "511", "", "18.70636", "77.36795", "Asia/Kolkata"),("1262596", "Mukeriān", "", "IN", "356", "", "23", "038", "", "31.95394", "75.61716", "Asia/Kolkata"),("1262624", "Muhammadābād", "", "IN", "356", "", "36", "159", "", "27.30895", "79.43252", "Asia/Kolkata"),("1262625", "Muhammadābād", "", "IN", "356", "", "36", "192", "", "26.03404", "83.38114", "Asia/Kolkata"),("1262626", "Muhammadābād", "", "IN", "356", "", "36", "195", "", "25.61907", "83.75576", "Asia/Kolkata"),("1262634", "Mughal Sarāi", "", "IN", "356", "", "36", "196", "", "25.28307", "83.11968", "Asia/Kolkata"),("1262648", "Mudukulattūr", "", "IN", "356", "", "25", "626", "", "9.34169", "78.51388", "Asia/Kolkata"),("1262651", "Mudkhed", "", "IN", "356", "", "16", "511", "", "19.15657", "77.50304", "Asia/Kolkata"),("1262658", "Mudgere", "", "IN", "356", "", "19", "570", "", "13.13353", "75.6416", "Asia/Kolkata"),("1262663", "Mudhol", "", "IN", "356", "", "19", "556", "", "16.33354", "75.28305", "Asia/Kolkata"),("1262664", "Mudgal", "", "IN", "356", "", "19", "559", "", "16.01191", "76.44203", "Asia/Kolkata"),("1262669", "Muddebihāl", "", "IN", "356", "", "19", "557", "", "16.33782", "76.13173", "Asia/Kolkata"),("1262672", "Mūdbidri", "", "IN", "356", "", "19", "569", "", "13.06653", "74.99525", "Asia/Kolkata"),("1262678", "Mubārakpur", "", "IN", "356", "", "36", "191", "", "26.08866", "83.29088", "Asia/Kolkata"),("1262689", "Mowād", "", "IN", "356", "", "16", "505", "", "21.46475", "78.45103", "Asia/Kolkata"),("1262710", "Mothīhāri", "", "IN", "356", "", "34", "204", "", "26.64862", "84.91656", "Asia/Kolkata"),("1262715", "Moth", "", "IN", "356", "", "36", "166", "", "25.72595", "78.95029", "Asia/Kolkata"),("1262734", "Morwa", "", "IN", "356", "", "09", "484", "", "22.90469", "73.83912", "Asia/Kolkata"),("1262740", "Morsi", "", "IN", "356", "", "16", "503", "", "21.3403", "78.01258", "Asia/Kolkata"),("1262771", "Morena", "Морена", "IN", "356", "", "35", "419", "", "26.49892", "77.99534", "Asia/Kolkata"),("1262775", "Morbi", "", "IN", "356", "", "09", "476", "", "22.81731", "70.8377", "Asia/Kolkata"),("1262783", "Morār", "", "IN", "356", "", "35", "421", "", "26.2264", "78.22482", "Asia/Kolkata"),("1262787", "Morānha", "", "IN", "356", "", "03", "310", "", "27.18735", "94.91557", "Asia/Kolkata"),("1262794", "Moram", "", "IN", "356", "", "16", "525", "", "17.78812", "76.47077", "Asia/Kolkata"),("1262801", "Morādābād", "Морадабад", "IN", "356", "", "36", "135", "", "28.83893", "78.77684", "Asia/Kolkata"),("1262824", "Mon", "", "IN", "356", "", "20", "261", "", "26.73583", "95.05841", "Asia/Kolkata"),("1262843", "Mokokchūng", "", "IN", "356", "", "20", "262", "", "26.3248", "94.51834", "Asia/Kolkata"),("1262852", "Mokameh", "", "IN", "356", "", "34", "230", "", "25.39662", "85.9219", "Asia/Kolkata"),("1262863", "Moirāng", "", "IN", "356", "", "17", "275", "", "24.4975", "93.77791", "Asia/Kolkata"),("1262873", "Mohpa", "", "IN", "356", "", "16", "505", "", "21.31012", "78.82969", "Asia/Kolkata"),("1262884", "Mohiuddinnagar", "", "IN", "356", "", "34", "221", "", "25.57374", "85.66944", "Asia/Kolkata"),("1262891", "Mohgaon", "", "IN", "356", "", "35", "455", "", "21.63941", "78.73638", "Asia/Kolkata"),("1262905", "Mohanūr", "", "IN", "356", "", "25", "609", "", "11.05896", "78.13992", "Asia/Kolkata"),("1262909", "Mohanpur", "", "IN", "356", "", "36", "152", "", "28.25261", "80.24498", "Asia/Kolkata"),("1262928", "Mohān", "", "IN", "356", "", "36", "156", "", "26.78008", "80.67497", "Asia/Kolkata"),("1262951", "Moga", "Могу", "IN", "356", "", "23", "042", "", "30.81383", "75.16878", "Asia/Kolkata"),("1262958", "Modāsa", "", "IN", "356", "", "09", "472", "", "23.46253", "73.29857", "Asia/Kolkata"),("1262971", "Meethari Marwar", "", "IN", "356", "", "24", "112", "", "27.57615", "74.68661", "Asia/Kolkata"),("1262988", "Misrikh", "", "IN", "356", "", "36", "154", "", "27.43137", "80.53157", "Asia/Kolkata"),("1262995", "Mirzāpur", "Мирзапур", "IN", "356", "", "36", "199", "", "25.1449", "82.56534", "Asia/Kolkata"),("1263010", "Mirik", "", "IN", "356", "", "28", "327", "", "26.88817", "88.19007", "Asia/Kolkata"),("1263012", "Miriālgūda", "", "IN", "356", "", "40", "539", "", "16.8722", "79.56247", "Asia/Kolkata"),("1263015", "Mīrganj", "", "IN", "356", "", "36", "150", "", "28.54012", "79.20817", "Asia/Kolkata"),("1263021", "Mīrānpur Katra", "", "IN", "356", "", "36", "152", "", "28.02963", "79.66778", "Asia/Kolkata"),("1263022", "Mīrānpur", "", "IN", "356", "", "36", "133", "", "29.29026", "77.94939", "Asia/Kolkata"),("1263034", "Mīnjūr", "", "IN", "356", "", "25", "602", "", "13.27951", "80.25815", "Asia/Kolkata"),("1263051", "Milak", "Милак", "IN", "356", "", "36", "136", "", "28.61031", "79.16997", "Asia/Kolkata"),("1263057", "Mihona", "", "IN", "356", "", "35", "420", "", "26.28373", "78.98048", "Asia/Kolkata"),("1263083", "Mhāsvād", "", "IN", "356", "", "16", "527", "", "17.63359", "74.78773", "Asia/Kolkata"),("1263087", "Mhasla", "", "IN", "356", "", "16", "520", "", "18.1334", "73.11162", "Asia/Kolkata"),("1263101", "Mettur", "", "IN", "356", "", "25", "608", "", "11.78796", "77.8008", "Asia/Kolkata"),("1263103", "Mettupalayam", "", "IN", "356", "", "25", "632", "", "11.29971", "76.93485", "Asia/Kolkata"),("1263104", "Mettuppālaiyam", "", "IN", "356", "", "25", "614", "", "11.16812", "78.45232", "Asia/Kolkata"),("1263120", "Merta", "", "IN", "356", "", "24", "112", "", "26.64859", "74.03414", "Asia/Kolkata"),("1263142", "Mendarda", "", "IN", "356", "", "09", "479", "", "21.32112", "70.44078", "Asia/Kolkata"),("1263148", "Memāri", "", "IN", "356", "", "28", "335", "", "23.17647", "88.09749", "Asia/Kolkata"),("1263151", "Melur", "", "IN", "356", "", "25", "623", "", "10.03241", "78.3393", "Asia/Kolkata"),("1263185", "Mehndāwal", "", "IN", "356", "", "36", "186", "", "26.97579", "83.10995", "Asia/Kolkata"),("1263189", "Mehnagar", "", "IN", "356", "", "36", "191", "", "25.87889", "83.11611", "Asia/Kolkata"),("1263195", "Mehekar", "", "IN", "356", "", "16", "500", "", "20.1505", "76.56841", "Asia/Kolkata"),("1263201", "Meghraj", "", "IN", "356", "", "09", "472", "", "23.49805", "73.51352", "Asia/Kolkata"),("1263214", "Meerut", "Меерут", "IN", "356", "", "36", "138", "", "28.98002", "77.70636", "Asia/Kolkata"),("1263220", "Medinīpur", "Миднапор", "IN", "356", "", "28", "344", "", "22.42114", "87.32257", "Asia/Kolkata"),("1263230", "Medak", "Медак", "IN", "356", "", "40", "535", "", "18.04531", "78.26078", "Asia/Kolkata"),("1263247", "Mayiladuthurai", "", "IN", "356", "", "25", "618", "", "11.10354", "79.655", "Asia/Kolkata"),("1263255", "Mayāng Imphāl", "", "IN", "356", "", "17", "278", "", "24.60998", "93.88873", "Asia/Kolkata"),("1263257", "Māyakonda", "", "IN", "356", "", "19", "567", "", "14.28894", "76.08305", "Asia/Kolkata"),("1263275", "Mawāna", "", "IN", "356", "", "36", "138", "", "29.10288", "77.92199", "Asia/Kolkata"),("1263280", "Mavoor", "", "IN", "356", "", "13", "591", "", "11.26667", "75.91667", "Asia/Kolkata"),("1263285", "Māvelikara", "", "IN", "356", "", "13", "598", "", "9.25929", "76.55642", "Asia/Kolkata"),("1263291", "Maurānwān", "", "IN", "356", "", "36", "156", "", "26.42876", "80.88008", "Asia/Kolkata"),("1263293", "Maur", "", "IN", "356", "", "23", "046", "", "30.08333", "75.25", "Asia/Kolkata"),("1263300", "Mauganj", "", "IN", "356", "", "35", "430", "", "24.66721", "81.87339", "Asia/Kolkata"),("1263303", "Maudaha", "", "IN", "356", "", "36", "168", "", "25.68312", "80.11419", "Asia/Kolkata"),("1263306", "Mau Aimma", "", "IN", "356", "", "36", "175", "", "25.69515", "81.92336", "Asia/Kolkata"),("1263309", "Mau", "", "IN", "356", "", "35", "420", "", "26.26584", "78.67108", "Asia/Kolkata"),("1263311", "Mau", "", "IN", "356", "", "36", "192", "", "25.94167", "83.56111", "Asia/Kolkata"),("1263324", "Māttūr", "", "IN", "356", "", "25", "616", "", "11.31881", "79.20724", "Asia/Kolkata"),("1263331", "Mattanūr", "", "IN", "356", "", "13", "589", "", "11.93018", "75.57152", "Asia/Kolkata"),("1263364", "Mathura", "Матхура", "IN", "356", "", "36", "145", "", "27.5035", "77.67215", "Asia/Kolkata"),("1263370", "Mātherān", "", "IN", "356", "", "16", "520", "", "18.98281", "73.2652", "Asia/Kolkata"),("1263384", "Mataundh", "", "IN", "356", "", "36", "170", "", "25.43594", "80.15653", "Asia/Kolkata"),("1263395", "Mātābhānga", "", "IN", "356", "", "28", "329", "", "26.34197", "89.21555", "Asia/Kolkata"),("1263418", "Masinigudi", "", "IN", "356", "", "25", "611", "", "11.56831", "76.64087", "Asia/Kolkata"),("1263427", "Masaurhi Buzurg", "", "IN", "356", "", "34", "230", "", "25.35417", "85.03195", "Asia/Kolkata"),("1263494", "Marmagao", "Мармагао", "IN", "356", "", "33", "586", "", "15.40927", "73.78869", "Asia/Kolkata"),("1263504", "Mārkāpur", "", "IN", "356", "", "02", "549", "", "15.73534", "79.26848", "Asia/Kolkata"),("1263522", "Mariāni", "Мариани", "IN", "356", "", "03", "312", "", "26.65725", "94.31529", "Asia/Kolkata"),("1263523", "Mariāhu", "", "IN", "356", "", "36", "194", "", "25.60404", "82.60379", "Asia/Kolkata"),("1263528", "Marhaura", "", "IN", "356", "", "34", "219", "", "25.97349", "84.86796", "Asia/Kolkata"),("1263532", "Margherita", "", "IN", "356", "", "30", "", "", "27.28482", "95.66796", "Asia/Kolkata"),("1263557", "Mārāndahalli", "", "IN", "356", "", "25", "630", "", "12.38826", "78.00316", "Asia/Kolkata"),("1263564", "Marakkanam", "", "IN", "356", "", "25", "607", "", "12.19214", "79.94193", "Asia/Kolkata"),("1263566", "Marayur", "", "IN", "356", "", "13", "596", "", "10.27641", "77.16205", "Asia/Kolkata"),("1263567", "Mārahra", "", "IN", "356", "", "36", "201", "", "27.7368", "78.56891", "Asia/Kolkata"),("1263580", "Māpuca", "Мапуса", "IN", "356", "", "33", "585", "", "15.59154", "73.80898", "Asia/Kolkata"),("1263591", "Mānwat", "", "IN", "356", "", "16", "513", "", "19.30133", "76.49735", "Asia/Kolkata"),("1263594", "Mānvi", "", "IN", "356", "", "19", "559", "", "15.99126", "77.05034", "Asia/Kolkata"),("1263610", "Manthani", "", "IN", "356", "", "40", "534", "", "18.65087", "79.66501", "Asia/Kolkata"),("1263621", "Mansar", "", "IN", "356", "", "16", "505", "", "21.39602", "79.2635", "Asia/Kolkata"),("1263622", "Mānsa", "", "IN", "356", "", "23", "047", "", "29.98844", "75.40167", "Asia/Kolkata"),("1263623", "Mānsa", "", "IN", "356", "", "09", "473", "", "23.42564", "72.65739", "Asia/Kolkata"),("1263636", "Mānpur", "", "IN", "356", "", "35", "439", "", "22.43151", "75.62107", "Asia/Kolkata"),("1263646", "Manor", "", "IN", "356", "", "16", "517", "", "19.7244", "72.90966", "Asia/Kolkata"),("1263648", "Manohar Thāna", "", "IN", "356", "", "24", "129", "", "24.24", "76.80182", "Asia/Kolkata"),("1263649", "Manoharpur", "", "IN", "356", "", "24", "110", "", "27.29769", "75.9495", "Asia/Kolkata"),("1263651", "Manoharpur", "", "IN", "356", "", "38", "368", "", "22.37456", "85.19234", "Asia/Kolkata"),("1263659", "Mannargudi", "", "IN", "356", "", "25", "619", "", "10.66626", "79.45064", "Asia/Kolkata"),("1263661", "Mannārakkāt", "", "IN", "356", "", "13", "593", "", "10.99223", "76.46418", "Asia/Kolkata"),("1263664", "Manmād", "", "IN", "356", "", "16", "516", "", "20.25334", "74.43755", "Asia/Kolkata"),("1263677", "Mankāpur", "", "IN", "356", "", "36", "183", "", "27.05189", "82.22961", "Asia/Kolkata"),("1263678", "Mankāchar", "", "IN", "356", "", "18", "", "", "25.53347", "89.86373", "Asia/Kolkata"),("1263684", "Mājalgaon", "", "IN", "356", "", "16", "523", "", "19.15988", "76.20832", "Asia/Kolkata"),("1263691", "Manjhanpur", "", "IN", "356", "", "36", "174", "", "25.53046", "81.37566", "Asia/Kolkata"),("1263692", "Manjēshvar", "", "IN", "356", "", "13", "588", "", "12.71287", "74.88857", "Asia/Kolkata"),("1263694", "Manjeri", "", "IN", "356", "", "13", "592", "", "11.12018", "76.11996", "Asia/Kolkata"),("1263707", "Manipala", "", "IN", "356", "IN", "19", "569", "", "13.35", "74.78333", "Asia/Kolkata"),("1263715", "Mānikpur", "", "IN", "356", "", "36", "171", "", "25.06083", "81.09961", "Asia/Kolkata"),("1263723", "Manihāri", "", "IN", "356", "", "34", "212", "", "25.33891", "87.61998", "Asia/Kolkata"),("1263730", "Maniar", "", "IN", "356", "", "36", "193", "", "25.98546", "84.17233", "Asia/Kolkata"),("1263744", "Mangrūl Pīr", "", "IN", "356", "", "16", "502", "", "20.31379", "77.34178", "Asia/Kolkata"),("1263751", "Māngrol", "", "IN", "356", "", "24", "128", "", "25.33061", "76.50973", "Asia/Kolkata"),("1263752", "Māngrol", "", "IN", "356", "", "09", "479", "", "21.12268", "70.11484", "Asia/Kolkata"),("1263761", "Manglaur", "", "IN", "356", "", "39", "068", "", "29.79094", "77.87836", "Asia/Kolkata"),("1263764", "Mangawān", "", "IN", "356", "", "35", "430", "", "24.66754", "81.54644", "Asia/Kolkata"),("1263780", "Mangalore", "Мангалуру", "IN", "356", "", "19", "575", "", "12.91723", "74.85603", "Asia/Kolkata"),("1263787", "Mangaldai", "", "IN", "356", "", "03", "325", "", "26.44212", "92.03047", "Asia/Kolkata"),("1263795", "Mangalam", "", "IN", "356", "", "25", "622", "", "9.76572", "78.63969", "Asia/Kolkata"),("1263797", "Mangalagiri", "", "IN", "356", "", "02", "548", "", "16.43083", "80.56815", "Asia/Kolkata"),("1263807", "Maner", "Манера", "IN", "356", "", "34", "230", "", "25.64602", "84.87291", "Asia/Kolkata"),("1263814", "Mandya", "Мандья", "IN", "356", "", "19", "573", "", "12.5223", "76.89746", "Asia/Kolkata"),("1263824", "Māndvi", "Мандви", "IN", "356", "", "09", "468", "", "22.83282", "69.35237", "Asia/Kolkata"),("1263826", "Māndvi", "", "IN", "356", "", "09", "492", "", "21.25526", "73.30412", "Asia/Kolkata"),("1263833", "Māndu", "", "IN", "356", "", "35", "438", "", "22.36667", "75.38333", "Asia/Kolkata"),("1263834", "Mandsaur", "", "IN", "356", "", "35", "433", "", "24.07184", "75.06986", "Asia/Kolkata"),("1263850", "Māndleshwar", "", "IN", "356", "", "35", "440", "", "22.17598", "75.65995", "Asia/Kolkata"),("1263852", "Mandlā", "Мандла", "IN", "356", "", "35", "454", "", "22.59879", "80.37115", "Asia/Kolkata"),("1263862", "Mandi", "Манди", "IN", "356", "", "11", "027", "", "31.71194", "76.93273", "Asia/Kolkata"),("1263879", "Mandāwar", "", "IN", "356", "", "36", "134", "", "29.48655", "78.12732", "Asia/Kolkata"),("1263880", "Mandāwar", "", "IN", "356", "", "24", "104", "", "27.86374", "76.54999", "Asia/Kolkata"),("1263888", "Mandasa", "", "IN", "356", "", "02", "542", "", "18.8683", "84.46296", "Asia/Kolkata"),("1263898", "Mandapeta", "", "IN", "356", "", "02", "545", "", "16.86254", "81.92921", "Asia/Kolkata"),("1263900", "Mandapam", "", "IN", "356", "", "25", "626", "", "9.27571", "79.12362", "Asia/Kolkata"),("1263911", "Māndalgarh", "", "IN", "356", "", "24", "122", "", "25.19407", "75.07215", "Asia/Kolkata"),("1263917", "Māndal", "", "IN", "356", "", "24", "122", "", "25.44126", "74.56979", "Asia/Kolkata"),("1263918", "Māndal", "", "IN", "356", "", "09", "474", "", "23.28865", "71.91854", "Asia/Kolkata"),("1263936", "Mancherāl", "", "IN", "356", "", "40", "532", "", "18.87074", "79.42863", "Asia/Kolkata"),("1263937", "Manchar", "", "IN", "356", "", "16", "521", "", "19.00436", "73.94346", "Asia/Kolkata"),("1263940", "Manāwar", "", "IN", "356", "", "35", "438", "", "22.23566", "75.08917", "Asia/Kolkata"),("1263942", "Manavalakurichi", "", "IN", "356", "", "25", "629", "", "8.14812", "77.30634", "Asia/Kolkata"),("1263943", "Mānāvadar", "", "IN", "356", "", "09", "479", "", "21.49813", "70.13775", "Asia/Kolkata"),("1263949", "Manāsa", "", "IN", "356", "", "35", "432", "", "24.48371", "75.26871", "Asia/Kolkata"),("1263952", "Manapparai", "", "IN", "356", "", "25", "614", "", "10.60772", "78.42582", "Asia/Kolkata"),("1263965", "Manamadurai", "", "IN", "356", "", "25", "622", "", "9.67318", "78.47096", "Asia/Kolkata"),("1263966", "Manalūrpettai", "", "IN", "356", "", "25", "607", "", "12.00788", "79.09184", "Asia/Kolkata"),("1263967", "Manāli", "", "IN", "356", "", "11", "026", "", "32.2574", "77.17481", "Asia/Kolkata"),("1263968", "Manali", "", "IN", "356", "", "25", "602", "", "13.16667", "80.26667", "Asia/Kolkata"),("1263983", "Mamit", "", "IN", "356", "", "31", "281", "", "23.92703", "92.48968", "Asia/Kolkata"),("1263997", "Seven Pagodas", "", "IN", "356", "", "25", "604", "", "12.62091", "80.19331", "Asia/Kolkata"),("1264007", "Mālvan", "", "IN", "356", "", "16", "529", "", "16.05981", "73.4629", "Asia/Kolkata"),("1264010", "Mālūr", "", "IN", "356", "", "19", "581", "", "13.00322", "77.93798", "Asia/Kolkata"),("1264032", "Mālpura", "", "IN", "356", "", "24", "120", "", "26.2838", "75.36458", "Asia/Kolkata"),("1264033", "Mālpur", "", "IN", "356", "", "09", "472", "", "23.36035", "73.46595", "Asia/Kolkata"),("1264037", "Malpe", "", "IN", "356", "", "19", "569", "", "13.34962", "74.70394", "Asia/Kolkata"),("1264041", "Māllur", "", "IN", "356", "", "25", "608", "", "11.54299", "78.14017", "Asia/Kolkata"),("1264047", "Mallasamudram", "", "IN", "356", "", "25", "609", "", "11.4892", "78.03277", "Asia/Kolkata"),("1264050", "Mallāpuram", "", "IN", "356", "", "25", "630", "", "11.98123", "78.24829", "Asia/Kolkata"),("1264070", "Malkera", "", "IN", "356", "", "38", "354", "", "23.78213", "86.28767", "Asia/Kolkata"),("1264071", "Malkāpur", "", "IN", "356", "", "16", "500", "", "20.88555", "76.19932", "Asia/Kolkata"),("1264074", "Malkāpur", "", "IN", "356", "", "16", "530", "", "16.91999", "73.9347", "Asia/Kolkata"),("1264075", "Malakanagiri", "", "IN", "356", "", "21", "399", "", "18.36428", "81.888", "Asia/Kolkata"),("1264085", "Malīhābād", "", "IN", "356", "", "36", "157", "", "26.92223", "80.71078", "Asia/Kolkata"),("1264099", "Malhārgarh", "", "IN", "356", "", "35", "433", "", "24.28286", "74.99024", "Asia/Kolkata"),("1264111", "Māler Kotla", "", "IN", "356", "", "23", "053", "", "30.5309", "75.87949", "Asia/Kolkata"),("1264115", "Mālegaon", "Малегаон", "IN", "356", "", "16", "516", "", "20.54966", "74.53462", "Asia/Kolkata"),("1264136", "Malavalli", "", "IN", "356", "", "19", "573", "", "12.38556", "77.06045", "Asia/Kolkata"),("1264138", "Malaut", "", "IN", "356", "", "23", "044", "", "30.21121", "74.4818", "Asia/Kolkata"),("1264154", "Malappuram", "Малаппурам", "IN", "356", "", "13", "592", "", "11.04199", "76.08154", "Asia/Kolkata"),("1264196", "Mākum", "", "IN", "356", "", "03", "309", "", "27.48652", "95.43646", "Asia/Kolkata"),("1264198", "Maksi", "Макси", "IN", "356", "", "35", "436", "", "23.25999", "76.14567", "Asia/Kolkata"),("1264206", "Makrāna", "", "IN", "356", "", "24", "112", "", "27.04361", "74.72445", "Asia/Kolkata"),("1264215", "Makhu", "", "IN", "356", "", "23", "043", "", "31.10335", "74.99631", "Asia/Kolkata"),("1264217", "Mākhjan", "", "IN", "356", "", "16", "528", "", "17.2698", "73.50031", "Asia/Kolkata"),("1264241", "Majītha", "", "IN", "356", "", "23", "049", "", "31.75711", "74.95891", "Asia/Kolkata"),("1264244", "Majholi", "", "IN", "356", "", "35", "451", "", "23.50114", "79.92396", "Asia/Kolkata"),("1264282", "Mairwa", "", "IN", "356", "", "34", "218", "", "26.23218", "84.16349", "Asia/Kolkata"),("1264285", "Mairang", "", "IN", "356", "", "18", "296", "", "25.56165", "91.63602", "Asia/Kolkata"),("1264292", "Mainpuri", "", "IN", "356", "", "36", "148", "", "27.22857", "79.02882", "Asia/Kolkata"),("1264297", "Maindargi", "", "IN", "356", "", "16", "526", "", "17.45739", "76.2932", "Asia/Kolkata"),("1264301", "Maināguri", "", "IN", "356", "", "28", "328", "", "26.56263", "88.8204", "Asia/Kolkata"),("1264310", "Mailāni", "", "IN", "356", "", "36", "153", "", "28.29088", "80.3438", "Asia/Kolkata"),("1264317", "Maihar", "", "IN", "356", "", "35", "429", "", "24.26594", "80.76063", "Asia/Kolkata"),("1264322", "Maibong", "", "IN", "356", "", "03", "315", "", "25.30125", "93.13811", "Asia/Kolkata"),("1264323", "Mahwah", "", "IN", "356", "", "24", "109", "", "27.04594", "76.93152", "Asia/Kolkata"),("1264331", "Mahur", "", "IN", "356", "", "03", "315", "", "25.18305", "93.11342", "Asia/Kolkata"),("1264344", "Mahudha", "", "IN", "356", "", "09", "483", "", "22.82082", "72.94032", "Asia/Kolkata"),("1264351", "Mahroni", "", "IN", "356", "", "36", "167", "", "24.58624", "78.72771", "Asia/Kolkata"),("1264356", "Maholi", "", "IN", "356", "", "36", "154", "", "27.66368", "80.47371", "Asia/Kolkata"),("1264359", "Mahobā", "", "IN", "356", "", "36", "169", "", "25.2905", "79.87533", "Asia/Kolkata"),("1264363", "Mahmudābād", "", "IN", "356", "", "36", "154", "", "27.29191", "81.11775", "Asia/Kolkata"),("1264368", "Mahīshādal", "", "IN", "356", "", "28", "345", "", "22.18616", "87.98072", "Asia/Kolkata"),("1264383", "Mahgawān", "", "IN", "356", "", "35", "420", "", "26.49471", "78.61593", "Asia/Kolkata"),("1264385", "Maheshwar", "Махешвар", "IN", "356", "", "35", "440", "", "22.17592", "75.58715", "Asia/Kolkata"),("1264395", "Mahendragarh", "", "IN", "356", "", "10", "084", "", "28.26935", "76.15253", "Asia/Kolkata"),("1264398", "Mahemdāvād", "", "IN", "356", "", "09", "483", "", "22.82359", "72.75551", "Asia/Kolkata"),("1264403", "Mahē", "Мах", "IN", "356", "", "13", "", "", "11.70172", "75.53474", "Asia/Kolkata"),("1264407", "Mahbūbnagar", "", "IN", "356", "", "40", "538", "", "16.74385", "77.98597", "Asia/Kolkata"),("1264409", "Mahbūbābād", "", "IN", "356", "", "40", "540", "", "17.59728", "80.00207", "Asia/Kolkata"),("1264414", "Mahāsamund", "", "IN", "356", "", "37", "411", "", "21.10743", "82.0948", "Asia/Kolkata"),("1264433", "Mahārāganj", "", "IN", "356", "", "36", "187", "", "27.14456", "83.56214", "Asia/Kolkata"),("1264434", "Mahārājganj", "", "IN", "356", "", "36", "158", "", "26.38126", "81.27436", "Asia/Kolkata"),("1264435", "Bishunpur Urf Mahārājganj", "", "IN", "356", "", "36", "191", "", "26.25914", "83.11643", "Asia/Kolkata"),("1264436", "Mahārājgani", "", "IN", "356", "", "34", "218", "", "26.11017", "84.50365", "Asia/Kolkata"),("1264455", "Maham", "", "IN", "356", "", "10", "082", "", "28.96912", "76.29495", "Asia/Kolkata"),("1264457", "Mahālingpur", "", "IN", "356", "", "19", "556", "", "16.3888", "75.10873", "Asia/Kolkata"),("1264489", "Mahād", "Махад", "IN", "356", "", "16", "520", "", "18.08333", "73.41667", "Asia/Kolkata"),("1264490", "Mahāban", "", "IN", "356", "", "36", "145", "", "27.43262", "77.74338", "Asia/Kolkata"),("1264491", "Mahābaleshwar", "", "IN", "356", "", "16", "527", "", "17.92369", "73.65857", "Asia/Kolkata"),("1264504", "Maghar", "", "IN", "356", "", "36", "186", "", "26.75586", "83.12773", "Asia/Kolkata"),("1264514", "Māgadi", "Магади", "IN", "356", "", "19", "584", "", "12.95706", "77.22374", "Asia/Kolkata"),("1264520", "Madurāntakam", "", "IN", "356", "", "25", "604", "", "12.51167", "79.88485", "Asia/Kolkata"),("1264521", "Madurai", "Мадурай", "IN", "356", "", "25", "623", "", "9.91735", "78.11962", "Asia/Kolkata"),("1264523", "Madukkūr", "", "IN", "356", "", "25", "620", "", "10.48134", "79.39681", "Asia/Kolkata"),("1264524", "Madukkarai", "", "IN", "356", "", "25", "632", "", "10.90481", "76.96461", "Asia/Kolkata"),("1264525", "Mādugula", "", "IN", "356", "", "02", "544", "", "17.91589", "82.81578", "Asia/Kolkata"),("1264527", "Chennai", "Ченнаи", "IN", "356", "", "25", "603", "", "13.08784", "80.27847", "Asia/Kolkata"),("1264540", "Madikeri", "", "IN", "356", "", "19", "576", "", "12.42602", "75.7382", "Asia/Kolkata"),("1264543", "Madhyamgram", "", "IN", "356", "", "28", "337", "", "22.68944", "88.44594", "Asia/Kolkata"),("1264551", "Madhupur", "", "IN", "356", "", "38", "350", "", "24.27419", "86.63929", "Asia/Kolkata"),("1264553", "Maddagiri", "", "IN", "356", "", "19", "571", "", "13.66035", "77.21239", "Asia/Kolkata"),("1264555", "Madhubani", "Мадхубани", "IN", "356", "", "34", "207", "", "26.35367", "86.07169", "Asia/Kolkata"),("1264567", "Mādhogarh", "", "IN", "356", "", "36", "165", "", "26.27522", "79.1859", "Asia/Kolkata"),("1264568", "Madhogarh", "", "IN", "356", "", "35", "429", "", "24.56401", "80.91126", "Asia/Kolkata"),("1264569", "Mādhoganj", "", "IN", "356", "", "36", "155", "", "27.11807", "80.14058", "Asia/Kolkata"),("1264570", "Madhipura", "", "IN", "356", "", "34", "213", "", "25.92127", "86.79271", "Asia/Kolkata"),("1264588", "Madgaon", "Маргао", "IN", "356", "", "33", "586", "", "15.27501", "73.95786", "Asia/Kolkata"),("1264592", "Maddūr", "", "IN", "356", "", "19", "573", "", "12.58283", "77.04294", "Asia/Kolkata"),("1264614", "Madanpur", "", "IN", "356", "", "28", "336", "", "23.00589", "88.49168", "Asia/Kolkata"),("1264621", "Madanapalle", "", "IN", "356", "", "02", "554", "", "13.5503", "78.50288", "Asia/Kolkata"),("1264637", "Machilīpatnam", "", "IN", "356", "", "02", "547", "", "16.18747", "81.13888", "Asia/Kolkata"),("1264643", "Machhlīshahr", "", "IN", "356", "", "36", "194", "", "25.68564", "82.41106", "Asia/Kolkata"),("1264644", "Māchhīwāra", "", "IN", "356", "", "23", "041", "", "30.91557", "76.20016", "Asia/Kolkata"),("1264647", "Mācherla", "", "IN", "356", "", "02", "548", "", "16.47635", "79.43533", "Asia/Kolkata"),("1264653", "Māchalpur", "", "IN", "356", "", "35", "442", "", "24.12767", "76.31672", "Asia/Kolkata"),("1264688", "Lunglei", "Лунглеи", "IN", "356", "", "31", "286", "", "22.89247", "92.74218", "Asia/Kolkata"),("1264700", "Lūnāvāda", "", "IN", "356", "", "09", "484", "", "23.12841", "73.61043", "Asia/Kolkata"),("1264728", "Ludhiāna", "Лудхияна", "IN", "356", "", "23", "041", "", "30.91204", "75.85379", "Asia/Kolkata"),("1264733", "Lucknow", "Лакхнау", "IN", "356", "", "36", "157", "", "26.83928", "80.92313", "Asia/Kolkata"),("1264735", "Luckeesarai", "", "IN", "356", "", "34", "227", "", "25.1765", "86.0947", "Asia/Kolkata"),("1264756", "Losal", "", "IN", "356", "", "24", "111", "", "27.4", "74.91667", "Asia/Kolkata"),("1264757", "Lormi", "", "IN", "356", "", "37", "406", "", "22.27434", "81.70181", "Asia/Kolkata"),("1264773", "Loni", "Лоне", "IN", "356", "", "36", "140", "", "28.75143", "77.29023", "Asia/Kolkata"),("1264792", "Londa", "", "IN", "356", "", "19", "555", "", "15.46907", "74.51906", "Asia/Kolkata"),("1264793", "Lonavla", "", "IN", "356", "", "16", "521", "", "18.75275", "73.40575", "Asia/Kolkata"),("1264794", "Lonār", "", "IN", "356", "", "16", "500", "", "19.98533", "76.52046", "Asia/Kolkata"),("1264816", "Lohogaon", "", "IN", "356", "", "16", "521", "", "18.59921", "73.92701", "Asia/Kolkata"),("1264829", "Lohāru", "", "IN", "356", "", "10", "081", "", "28.42993", "75.80779", "Asia/Kolkata"),("1264839", "Lohārdaga", "", "IN", "356", "", "38", "356", "", "23.43313", "84.67982", "Asia/Kolkata"),("1264850", "Lohaghāt", "", "IN", "356", "", "39", "065", "", "29.40356", "80.08965", "Asia/Kolkata"),("1264860", "Lodhīkheda", "", "IN", "356", "", "35", "455", "", "21.58235", "78.85911", "Asia/Kolkata"),("1264890", "Lingsugūr", "", "IN", "356", "", "19", "559", "", "16.15876", "76.52174", "Asia/Kolkata"),("1264912", "Limbdi", "", "IN", "356", "", "09", "475", "", "22.56507", "71.81076", "Asia/Kolkata"),("1264949", "Leteri", "", "IN", "356", "", "35", "443", "", "24.05979", "77.40858", "Asia/Kolkata"),("1264976", "Leh", "Лех", "IN", "356", "", "12", "003", "", "34.16504", "77.58402", "Asia/Kolkata"),("1264989", "Lāwar Khās", "", "IN", "356", "", "36", "138", "", "29.11091", "77.77767", "Asia/Kolkata"),("1265007", "Laungowāl", "", "IN", "356", "", "23", "053", "", "30.19393", "75.68089", "Asia/Kolkata"),("1265014", "Latur", "Латур", "IN", "356", "", "16", "524", "", "18.39721", "76.56784", "Asia/Kolkata"),("1265022", "Lāthi", "", "IN", "356", "", "09", "480", "", "21.7231", "71.38843", "Asia/Kolkata"),("1265025", "Lātehār", "", "IN", "356", "", "38", "359", "", "23.74395", "84.499", "Asia/Kolkata"),("1265041", "Lāsalgaon", "", "IN", "356", "", "16", "516", "", "20.1427", "74.23946", "Asia/Kolkata"),("1265053", "Lar", "", "IN", "356", "", "36", "190", "", "26.20394", "83.96906", "Asia/Kolkata"),("1265074", "Lansdowne", "", "IN", "356", "", "39", "061", "", "29.84183", "78.68014", "Asia/Kolkata"),("1265085", "Lānja", "", "IN", "356", "", "16", "528", "", "16.86086", "73.54993", "Asia/Kolkata"),("1265143", "Lālsot", "", "IN", "356", "", "24", "109", "", "26.55951", "76.32915", "Asia/Kolkata"),("1265150", "Lālpur", "", "IN", "356", "", "09", "477", "", "22.19073", "69.96351", "Asia/Kolkata"),("1265157", "Lalitpur", "Лалитпур", "IN", "356", "", "36", "167", "", "24.69007", "78.41915", "Asia/Kolkata"),("1265163", "Lalgudi", "", "IN", "356", "", "25", "614", "", "10.87419", "78.81935", "Asia/Kolkata"),("1265166", "Lālgola", "", "IN", "356", "", "28", "333", "", "24.42244", "88.25238", "Asia/Kolkata"),("1265169", "Lālganj", "", "IN", "356", "", "36", "173", "", "25.93182", "81.70478", "Asia/Kolkata"),("1265170", "Lālganj", "", "IN", "356", "", "34", "220", "", "25.86894", "85.17394", "Asia/Kolkata"),("1265184", "Lālam", "", "IN", "356", "", "13", "597", "", "9.71667", "76.7", "Asia/Kolkata"),("1265190", "Lāla", "", "IN", "356", "", "03", "318", "", "24.55418", "92.61592", "Asia/Kolkata"),("1265201", "Lakshmeshwar", "", "IN", "356", "", "19", "561", "", "15.12689", "75.46935", "Asia/Kolkata"),("1265205", "Lakshettipet", "", "IN", "356", "", "40", "534", "", "18.86667", "79.21667", "Asia/Kolkata"),("1265208", "Laksar", "", "IN", "356", "", "39", "068", "", "29.7587", "78.04148", "Asia/Kolkata"),("1265220", "Lakhyabad", "", "IN", "356", "", "28", "340", "", "23.66667", "86.66667", "Asia/Kolkata"),("1265225", "Lakhtar", "", "IN", "356", "", "09", "475", "", "22.85683", "71.78844", "Asia/Kolkata"),("1265233", "Lakhnādon", "", "IN", "356", "", "35", "456", "", "22.60049", "79.60094", "Asia/Kolkata"),("1265234", "Lakhnā", "", "IN", "356", "", "36", "161", "", "26.64822", "79.1477", "Asia/Kolkata"),("1265239", "Lakhipur", "", "IN", "356", "", "03", "302", "", "26.03001", "90.30611", "Asia/Kolkata"),("1265240", "Lakhipur", "", "IN", "356", "", "03", "316", "", "24.79281", "93.0091", "Asia/Kolkata"),("1265242", "Lakhīmpur", "", "IN", "356", "", "36", "153", "", "27.94822", "80.77935", "Asia/Kolkata"),("1265246", "Lākheri", "", "IN", "356", "", "24", "121", "", "25.67237", "76.17692", "Asia/Kolkata"),("1265310", "Lāharpur", "", "IN", "356", "", "36", "154", "", "27.70827", "80.90256", "Asia/Kolkata"),("1265311", "Lahār", "", "IN", "356", "", "35", "420", "", "26.19401", "78.94137", "Asia/Kolkata"),("1265323", "Lādwa", "", "IN", "356", "", "10", "072", "", "29.9935", "77.04563", "Asia/Kolkata"),("1265331", "Lādnūn", "", "IN", "356", "", "24", "112", "", "27.65312", "74.39993", "Asia/Kolkata"),("1265354", "Lachhmangarh Sīkar", "", "IN", "356", "", "24", "111", "", "27.82294", "75.02754", "Asia/Kolkata"),("1265376", "Kyelang", "", "IN", "356", "", "11", "025", "", "32.5717", "77.02448", "Asia/Kolkata"),("1265387", "Kuzhithurai", "", "IN", "356", "", "25", "629", "", "8.31792", "77.19192", "Asia/Kolkata"),("1265400", "Koothanallur", "", "IN", "356", "", "25", "619", "", "10.7199", "79.5157", "Asia/Kolkata"),("1265401", "Kuttampuzha", "", "IN", "356", "", "13", "596", "", "10.15", "76.73333", "Asia/Kolkata"),("1265415", "Kutiyāna", "", "IN", "356", "", "09", "478", "", "21.6241", "69.98494", "Asia/Kolkata"),("1265418", "Kutiatodu", "", "IN", "356", "IN", "13", "598", "", "9.8", "76.33333", "Asia/Kolkata"),("1265446", "Kushtagi", "", "IN", "356", "", "19", "560", "", "15.75623", "76.19112", "Asia/Kolkata"),("1265451", "Kushālnagar", "", "IN", "356", "", "19", "576", "", "12.45795", "75.95904", "Asia/Kolkata"),("1265452", "Kushālgarh", "", "IN", "356", "", "24", "125", "", "23.19899", "74.45074", "Asia/Kolkata"),("1265472", "Kurud", "", "IN", "356", "", "37", "412", "", "20.83073", "81.72212", "Asia/Kolkata"),("1265504", "Kurinjippādi", "", "IN", "356", "", "25", "617", "", "11.55028", "79.59066", "Asia/Kolkata"),("1265515", "Kurgunta", "", "IN", "356", "", "19", "579", "", "17.19321", "77.35772", "Asia/Kolkata"),("1265521", "Kurduvādi", "", "IN", "356", "", "16", "526", "", "18.09339", "75.41567", "Asia/Kolkata"),("1265534", "Kurāra", "", "IN", "356", "", "36", "168", "", "25.98046", "79.98984", "Asia/Kolkata"),("1265539", "Kurandvād", "", "IN", "356", "", "16", "530", "", "16.68317", "74.58892", "Asia/Kolkata"),("1265555", "Kuppam", "", "IN", "356", "", "02", "554", "", "12.74931", "78.34189", "Asia/Kolkata"),("1265577", "Kunnattūr", "", "IN", "356", "", "25", "631", "", "12.34782", "78.51046", "Asia/Kolkata"),("1265579", "Kunnamkulam", "", "IN", "356", "", "13", "594", "", "10.64667", "76.06695", "Asia/Kolkata"),("1265580", "Kunnamangalam", "", "IN", "356", "", "13", "591", "", "11.30459", "75.87772", "Asia/Kolkata"),("1265591", "Kunigal", "", "IN", "356", "", "19", "571", "", "13.02319", "77.02518", "Asia/Kolkata"),("1265605", "Kundla", "", "IN", "356", "", "09", "480", "", "21.34222", "71.30633", "Asia/Kolkata"),("1265607", "Kundgol", "", "IN", "356", "", "19", "562", "", "15.25612", "75.24735", "Asia/Kolkata"),("1265613", "Kundarkhi", "", "IN", "356", "", "36", "135", "", "28.68304", "78.78559", "Asia/Kolkata"),("1265632", "Kunda", "", "IN", "356", "", "36", "173", "", "25.71702", "81.51396", "Asia/Kolkata"),("1265645", "Kumta", "", "IN", "356", "", "19", "563", "", "14.42853", "74.4189", "Asia/Kolkata"),("1265646", "Kumsi", "", "IN", "356", "", "19", "568", "", "14.05455", "75.39992", "Asia/Kolkata"),("1265655", "Kūmher", "", "IN", "356", "", "24", "105", "", "27.31657", "77.37079", "Asia/Kolkata"),("1265660", "Kumhāri", "", "IN", "356", "", "37", "409", "", "21.26667", "81.51667", "Asia/Kolkata"),("1265670", "Kumbhrāj", "", "IN", "356", "", "35", "458", "", "24.37338", "77.04841", "Asia/Kolkata"),("1265683", "Kumbakonam", "Кумбаконам", "IN", "356", "", "25", "620", "", "10.96209", "79.39124", "Asia/Kolkata"),("1265697", "Kumaralingam", "", "IN", "356", "", "25", "633", "", "10.48801", "77.35053", "Asia/Kolkata"),("1265709", "Kulu", "", "IN", "356", "", "11", "026", "", "31.95835", "77.10823", "Asia/Kolkata"),("1265711", "Kulti", "Култи", "IN", "356", "", "28", "335", "", "23.73166", "86.84372", "Asia/Kolkata"),("1265716", "Kulpahār", "", "IN", "356", "", "36", "169", "", "25.32007", "79.63931", "Asia/Kolkata"),("1265723", "Kulittalai", "", "IN", "356", "", "25", "613", "", "10.93487", "78.41251", "Asia/Kolkata"),("1265734", "Kulgam", "", "IN", "356", "", "12", "015", "", "33.64456", "75.01923", "Asia/Kolkata"),("1265740", "Kulattūr", "", "IN", "356", "", "25", "627", "", "9.00234", "78.1925", "Asia/Kolkata"),("1265752", "Kukshi", "", "IN", "356", "", "35", "438", "", "22.20677", "74.75788", "Asia/Kolkata"),("1265767", "Kūkatpalli", "", "IN", "356", "", "40", "537", "", "17.48486", "78.41376", "Asia/Kolkata"),("1265773", "Kuju", "", "IN", "356", "", "38", "361", "", "23.72757", "85.50616", "Asia/Kolkata"),("1265795", "Kūdligi", "", "IN", "356", "", "19", "565", "", "14.905", "76.38527", "Asia/Kolkata"),("1265809", "Kudāl", "", "IN", "356", "", "16", "529", "", "16.01148", "73.68867", "Asia/Kolkata"),("1265811", "Kudachi", "", "IN", "356", "", "19", "555", "", "16.62784", "74.85408", "Asia/Kolkata"),("1265821", "Kuchera", "Кучер", "IN", "356", "", "24", "112", "", "26.98747", "73.97108", "Asia/Kolkata"),("1265828", "Kuchāman", "", "IN", "356", "", "24", "112", "", "27.14745", "74.85655", "Asia/Kolkata"),("1265830", "Kuchaiburi", "", "IN", "356", "", "21", "376", "", "22.26675", "86.17385", "Asia/Kolkata"),("1265852", "Krishnarājpet", "", "IN", "356", "", "19", "573", "", "12.66621", "76.4877", "Asia/Kolkata"),("1265859", "Krishnanagar", "Кришнанагар", "IN", "356", "", "28", "336", "", "23.40576", "88.49073", "Asia/Kolkata"),("1265863", "Krishnagiri", "Кришнагири", "IN", "356", "", "25", "631", "", "12.51921", "78.21382", "Asia/Kolkata"),("1265873", "Kozhikode", "Калькутта", "IN", "356", "", "13", "591", "", "11.24802", "75.7804", "Asia/Kolkata"),("1265881", "Koynanagar", "", "IN", "356", "", "16", "527", "", "17.4", "73.76667", "Asia/Kolkata"),("1265886", "Kovvūr", "", "IN", "356", "", "02", "546", "", "17.0162", "81.72934", "Asia/Kolkata"),("1265888", "Kovūr", "", "IN", "356", "", "02", "550", "", "14.5005", "79.98518", "Asia/Kolkata"),("1265891", "Kovilpatti", "", "IN", "356", "", "25", "627", "", "9.17167", "77.86989", "Asia/Kolkata"),("1265896", "Kovalam", "", "IN", "356", "IN", "13", "", "", "8.36667", "76.99667", "Asia/Kolkata"),("1265901", "Kotwa", "", "IN", "356", "", "35", "430", "", "25.0308", "81.31908", "Asia/Kolkata"),("1265905", "Kottūru", "", "IN", "356", "", "19", "565", "", "14.82442", "76.22005", "Asia/Kolkata"),("1265911", "Kottayam", "Коттаям", "IN", "356", "", "13", "597", "", "9.58692", "76.52132", "Asia/Kolkata"),("1265923", "Kottapalli", "", "IN", "356", "", "40", "534", "", "18.49543", "79.0943", "Asia/Kolkata"),("1265933", "Kottaiyūr", "", "IN", "356", "", "25", "622", "", "10.11007", "78.79555", "Asia/Kolkata"),("1265938", "Kottagūdem", "", "IN", "356", "", "40", "541", "", "17.55106", "80.61779", "Asia/Kolkata"),("1265954", "Kotra", "", "IN", "356", "", "36", "165", "", "25.8077", "79.30909", "Asia/Kolkata"),("1265961", "Kotputli", "", "IN", "356", "", "24", "110", "", "27.70207", "76.19911", "Asia/Kolkata"),("1265964", "Kotma", "", "IN", "356", "", "35", "461", "", "23.20383", "81.97904", "Asia/Kolkata"),("1265974", "Kot Īsa Khān", "", "IN", "356", "", "23", "042", "", "30.94659", "75.1378", "Asia/Kolkata"),("1265983", "Kothi", "", "IN", "356", "", "35", "429", "", "24.7526", "80.77751", "Asia/Kolkata"),("1266014", "Kotdwāra", "", "IN", "356", "", "39", "061", "", "29.74612", "78.52219", "Asia/Kolkata"),("1266028", "Kotār", "", "IN", "356", "", "35", "429", "", "24.69802", "80.98073", "Asia/Kolkata"),("1266029", "Kotapārh", "", "IN", "356", "", "37", "", "", "19.14256", "82.32536", "Asia/Kolkata"),("1266031", "Kotamangalam", "", "IN", "356", "", "13", "595", "", "10.06178", "76.62681", "Asia/Kolkata"),("1266038", "Kotagiri", "", "IN", "356", "", "25", "611", "", "11.42072", "76.86035", "Asia/Kolkata"),("1266049", "Kota", "Кота", "IN", "356", "", "24", "127", "", "25.18254", "75.83907", "Asia/Kolkata"),("1266050", "Kota", "", "IN", "356", "", "36", "200", "", "24.44643", "83.13063", "Asia/Kolkata"),("1266051", "Kotā", "", "IN", "356", "", "37", "406", "", "22.29507", "82.02366", "Asia/Kolkata"),("1266070", "Kosigi", "", "IN", "356", "", "02", "552", "", "15.8551", "77.24463", "Asia/Kolkata"),("1266073", "Kosi", "", "IN", "356", "", "36", "145", "", "27.79449", "77.4368", "Asia/Kolkata"),("1266087", "Kosamba", "", "IN", "356", "", "09", "492", "", "21.46202", "72.95842", "Asia/Kolkata"),("1266092", "Korwai", "", "IN", "356", "", "35", "443", "", "24.11774", "78.04007", "Asia/Kolkata"),("1266094", "Korukollu", "", "IN", "356", "", "02", "547", "", "16.5", "81.25", "Asia/Kolkata"),("1266116", "Koregaon", "", "IN", "356", "", "16", "521", "", "18.64573", "74.05909", "Asia/Kolkata"),("1266122", "Korba", "Корба", "IN", "356", "", "37", "404", "", "22.3458", "82.69633", "Asia/Kolkata"),("1266124", "Koratla", "", "IN", "356", "", "40", "534", "", "18.82154", "78.71186", "Asia/Kolkata"),("1266126", "Koratagere", "", "IN", "356", "", "19", "571", "", "13.522", "77.2373", "Asia/Kolkata"),("1266128", "Korāput", "Корапут", "IN", "356", "", "21", "398", "", "18.81199", "82.71048", "Asia/Kolkata"),("1266144", "Koradāchcheri", "", "IN", "356", "", "25", "619", "", "10.76987", "79.49209", "Asia/Kolkata"),("1266154", "Koppal", "Коппал", "IN", "356", "", "19", "560", "", "15.34522", "76.15478", "Asia/Kolkata"),("1266155", "Koppa", "", "IN", "356", "", "19", "570", "", "13.53044", "75.36329", "Asia/Kolkata"),("1266162", "Kopargaon", "", "IN", "356", "", "16", "522", "", "19.88239", "74.47605", "Asia/Kolkata"),("1266164", "Kopāganj", "", "IN", "356", "", "36", "192", "", "26.01923", "83.5663", "Asia/Kolkata"),("1266178", "Konnūr", "", "IN", "356", "", "19", "555", "", "16.20138", "74.74886", "Asia/Kolkata"),("1266179", "Konnagar", "", "IN", "356", "", "28", "338", "", "22.70508", "88.34446", "Asia/Kolkata"),("1266189", "Konganāpuram", "", "IN", "356", "", "25", "608", "", "11.58333", "77.91667", "Asia/Kolkata"),("1266209", "Kondapalle", "", "IN", "356", "", "02", "547", "", "16.61989", "80.54244", "Asia/Kolkata"),("1266210", "Kondalwādi", "", "IN", "356", "", "16", "511", "", "18.80727", "77.77031", "Asia/Kolkata"),("1266216", "Kondagaon", "", "IN", "356", "", "37", "414", "", "19.59083", "81.664", "Asia/Kolkata"),("1266217", "Konch", "", "IN", "356", "", "36", "165", "", "25.99451", "79.15127", "Asia/Kolkata"),("1266220", "Konārka", "", "IN", "356", "", "21", "387", "", "19.89758", "86.11413", "Asia/Kolkata"),("1266222", "Konanūr", "", "IN", "356", "", "19", "574", "", "12.63016", "76.05037", "Asia/Kolkata"),("1266240", "Kombai", "", "IN", "356", "", "25", "624", "", "9.84672", "77.29577", "Asia/Kolkata"),("1266258", "Kolasib", "", "IN", "356", "", "31", "282", "", "24.22388", "92.67869", "Asia/Kolkata"),("1266267", "Kollegāl", "", "IN", "356", "", "19", "578", "", "12.15449", "77.11051", "Asia/Kolkata"),("1266285", "Kolhāpur", "", "IN", "356", "", "16", "530", "", "16.69563", "74.23167", "Asia/Kolkata"),("1266302", "Kolāras", "", "IN", "356", "", "35", "423", "", "25.21928", "77.61167", "Asia/Kolkata"),("1266305", "Kolār", "Колар", "IN", "356", "", "19", "581", "", "13.13768", "78.12999", "Asia/Kolkata"),("1266322", "Colachel", "", "IN", "356", "", "25", "629", "", "8.17938", "77.25818", "Asia/Kolkata"),("1266330", "Kokrajhar", "Кокраджар", "IN", "356", "", "03", "300", "", "26.40107", "90.27286", "Asia/Kolkata"),("1266366", "Kohima", "Кохима", "IN", "356", "", "20", "270", "", "25.67467", "94.11099", "Asia/Kolkata"),("1266372", "Koelwār", "", "IN", "356", "", "34", "231", "", "25.58055", "84.79751", "Asia/Kolkata"),("1266385", "Kodungallūr", "", "IN", "356", "", "13", "594", "", "10.23263", "76.19513", "Asia/Kolkata"),("1266387", "Kodumudi", "", "IN", "356", "", "25", "610", "", "11.07751", "77.88363", "Asia/Kolkata"),("1266390", "Kodoli", "", "IN", "356", "", "16", "530", "", "16.87639", "74.1909", "Asia/Kolkata"),("1266397", "Kodīnar", "", "IN", "356", "", "09", "480", "", "20.79393", "70.70216", "Asia/Kolkata"),("1266402", "Kodigenahalli", "", "IN", "356", "", "19", "571", "", "13.72136", "77.38629", "Asia/Kolkata"),("1266414", "Kodarmā", "", "IN", "356", "", "38", "348", "", "24.46753", "85.59397", "Asia/Kolkata"),("1266416", "Kodār", "", "IN", "356", "", "40", "539", "", "16.9985", "79.9656", "Asia/Kolkata"),("1266422", "Kodala", "", "IN", "356", "", "21", "388", "", "19.62425", "84.94075", "Asia/Kolkata"),("1266425", "Kodaikānāl", "Кодайканал", "IN", "356", "", "25", "612", "", "10.23925", "77.48932", "Asia/Kolkata"),("1266433", "Kochinda", "", "IN", "356", "", "21", "372", "", "21.7457", "84.35105", "Asia/Kolkata"),("1266436", "Koch Bihār", "", "IN", "356", "", "28", "329", "", "26.32539", "89.44508", "Asia/Kolkata"),("1266448", "Koāth", "", "IN", "356", "", "34", "234", "", "25.32643", "84.25983", "Asia/Kolkata"),("1266452", "Kizhake Chālakudi", "", "IN", "356", "", "13", "594", "", "10.30067", "76.33763", "Asia/Kolkata"),("1266461", "Kithor", "", "IN", "356", "", "36", "138", "", "28.86684", "77.93861", "Asia/Kolkata"),("1266475", "Kishtwār", "Киштваре", "IN", "356", "", "12", "018", "", "33.31346", "75.76726", "Asia/Kolkata"),("1266477", "Kishni", "", "IN", "356", "", "36", "148", "", "27.02487", "79.262", "Asia/Kolkata"),("1266481", "Kishanpur", "", "IN", "356", "", "36", "172", "", "25.64232", "81.0227", "Asia/Kolkata"),("1266484", "Kishangarh", "", "IN", "356", "", "24", "104", "", "27.81889", "76.72972", "Asia/Kolkata"),("1266486", "Kishangarh", "Кишангарх", "IN", "356", "", "24", "119", "", "26.5741", "74.86685", "Asia/Kolkata"),("1266489", "Kishanganj", "", "IN", "356", "", "34", "210", "", "26.10224", "87.95534", "Asia/Kolkata"),("1266503", "Kiri Buru", "", "IN", "356", "", "21", "375", "", "22.08333", "85.35", "Asia/Kolkata"),("1266509", "Kīratpur", "", "IN", "356", "", "36", "134", "", "29.50671", "78.20613", "Asia/Kolkata"),("1266510", "Kiraoli", "", "IN", "356", "", "36", "146", "", "27.13768", "77.78516", "Asia/Kolkata"),("1266512", "Kīranūr", "", "IN", "356", "", "25", "612", "", "10.59358", "77.5028", "Asia/Kolkata"),("1266513", "Kīranūr", "", "IN", "356", "", "25", "621", "", "10.56988", "78.78682", "Asia/Kolkata"),("1266516", "Kirākat", "", "IN", "356", "", "36", "194", "", "25.63745", "82.91596", "Asia/Kolkata"),("1266518", "Kinwat", "", "IN", "356", "", "16", "511", "", "19.62557", "78.1987", "Asia/Kolkata"),("1266540", "Kilvelur", "", "IN", "356", "", "25", "618", "", "10.76721", "79.74186", "Asia/Kolkata"),("1266575", "Kichha", "", "IN", "356", "", "39", "067", "", "28.91154", "79.52009", "Asia/Kolkata"),("1266596", "Khūtār", "", "IN", "356", "", "36", "152", "", "28.20307", "80.27046", "Asia/Kolkata"),("1266598", "Khusropur", "", "IN", "356", "", "34", "230", "", "25.48174", "85.38492", "Asia/Kolkata"),("1266607", "Khurja", "", "IN", "356", "", "36", "142", "", "28.25382", "77.85535", "Asia/Kolkata"),("1266616", "Khurda", "", "IN", "356", "", "21", "386", "", "20.18268", "85.61629", "Asia/Kolkata"),("1266620", "Khurai", "", "IN", "356", "", "35", "427", "", "24.04372", "78.33014", "Asia/Kolkata"),("1266622", "Khunti", "", "IN", "356", "", "38", "365", "", "23.07533", "85.27903", "Asia/Kolkata"),("1266631", "Khuldābād", "", "IN", "356", "", "16", "515", "", "20.00671", "75.19245", "Asia/Kolkata"),("1266632", "Khujner", "", "IN", "356", "", "35", "442", "", "23.78597", "76.61773", "Asia/Kolkata"),("1266640", "Khudāganj", "", "IN", "356", "", "36", "152", "", "28.14607", "79.71472", "Asia/Kolkata"),("1266649", "Khowai", "", "IN", "356", "", "26", "", "", "24.07964", "91.59972", "Asia/Kolkata"),("1266666", "Khopoli", "", "IN", "356", "", "16", "520", "", "18.78562", "73.34589", "Asia/Kolkata"),("1266668", "Khonsa", "", "IN", "356", "", "30", "254", "", "27.01667", "95.56667", "Asia/Kolkata"),("1266710", "Khirkiyān", "", "IN", "356", "", "35", "448", "", "22.16732", "76.86137", "Asia/Kolkata"),("1266731", "Khilchipur", "", "IN", "356", "", "35", "442", "", "24.03943", "76.578", "Asia/Kolkata"),("1266744", "Khetri", "", "IN", "356", "", "24", "103", "", "28.00069", "75.78644", "Asia/Kolkata"),("1266746", "Khetia", "", "IN", "356", "", "16", "", "", "21.67124", "74.58535", "Asia/Kolkata"),("1266762", "Kheri", "", "IN", "356", "", "36", "153", "", "27.90354", "80.79754", "Asia/Kolkata"),("1266774", "Kherālu", "", "IN", "356", "", "09", "471", "", "23.88534", "72.61869", "Asia/Kolkata"),("1266787", "Khem Karan", "", "IN", "356", "", "23", "050", "", "31.14443", "74.55938", "Asia/Kolkata"),("1266794", "Khekra", "", "IN", "356", "", "36", "139", "", "28.86586", "77.2841", "Asia/Kolkata"),("1266806", "Khed Brahma", "", "IN", "356", "", "09", "472", "", "24.0299", "73.04632", "Asia/Kolkata"),("1266809", "Kheda", "Хеда", "IN", "356", "", "09", "483", "", "22.75218", "72.68533", "Asia/Kolkata"),("1266813", "Khed", "", "IN", "356", "", "16", "521", "", "18.33811", "73.84677", "Asia/Kolkata"),("1266814", "Khed", "", "IN", "356", "", "16", "528", "", "17.71888", "73.39693", "Asia/Kolkata"),("1266829", "Khaur", "", "IN", "356", "", "12", "021", "", "32.6027", "74.80918", "Asia/Kolkata"),("1266838", "Khātra", "", "IN", "356", "", "28", "339", "", "22.97617", "86.85462", "Asia/Kolkata"),("1266843", "Khatīma", "", "IN", "356", "", "39", "067", "", "28.92134", "79.97075", "Asia/Kolkata"),("1266847", "Khātegaon", "", "IN", "356", "", "35", "437", "", "22.59573", "76.9133", "Asia/Kolkata"),("1266849", "Khatauli", "", "IN", "356", "", "36", "133", "", "29.27844", "77.73302", "Asia/Kolkata"),("1266862", "Khārupatia", "", "IN", "356", "", "03", "325", "", "26.51839", "92.14722", "Asia/Kolkata"),("1266872", "Kharsia", "", "IN", "356", "", "37", "403", "", "21.98953", "83.10476", "Asia/Kolkata"),("1266873", "Kharsāwān", "", "IN", "356", "", "38", "369", "", "22.79041", "85.83132", "Asia/Kolkata"),("1266882", "Kharod", "", "IN", "356", "", "37", "405", "", "21.7442", "82.5788", "Asia/Kolkata"),("1266891", "Kharkhauda", "", "IN", "356", "", "10", "076", "", "28.8787", "76.91069", "Asia/Kolkata"),("1266892", "Kharkhauda", "", "IN", "356", "", "36", "138", "", "28.83644", "77.74159", "Asia/Kolkata"),("1266924", "Kharhiāl", "", "IN", "356", "", "21", "394", "", "20.28845", "82.7606", "Asia/Kolkata"),("1266926", "Khargupur", "", "IN", "356", "", "36", "183", "", "27.37611", "81.9882", "Asia/Kolkata"),("1266928", "Khargone", "", "IN", "356", "", "35", "440", "", "21.82292", "75.61394", "Asia/Kolkata"),("1266931", "Khargāpur", "", "IN", "356", "", "35", "424", "", "24.823", "79.144", "Asia/Kolkata"),("1266937", "Kharela", "", "IN", "356", "", "36", "168", "", "25.54277", "79.81235", "Asia/Kolkata"),("1266945", "Khardah", "", "IN", "356", "", "28", "337", "", "22.71861", "88.37806", "Asia/Kolkata"),("1266960", "Kharar", "", "IN", "356", "", "23", "052", "", "30.74632", "76.64689", "Asia/Kolkata"),("1266962", "Kharar", "", "IN", "356", "", "28", "344", "", "22.72211", "87.67824", "Asia/Kolkata"),("1266966", "Kharakvasla", "", "IN", "356", "", "16", "521", "", "18.43997", "73.77545", "Asia/Kolkata"),("1266975", "Kharagpur", "Харагпур", "IN", "356", "", "34", "226", "", "25.12446", "86.55578", "Asia/Kolkata"),("1266976", "Kharagpur", "Харагпур", "IN", "356", "", "28", "344", "", "22.33971", "87.32501", "Asia/Kolkata"),("1267006", "Khāpa", "", "IN", "356", "", "16", "505", "", "21.42243", "78.98168", "Asia/Kolkata"),("1267014", "Khānpur", "", "IN", "356", "", "36", "142", "", "28.53446", "78.06546", "Asia/Kolkata"),("1267015", "Khānpur", "", "IN", "356", "", "24", "129", "", "24.73241", "76.39601", "Asia/Kolkata"),("1267016", "Khanna", "Ханна", "IN", "356", "", "23", "041", "", "30.70547", "76.22196", "Asia/Kolkata"),("1267031", "Khandwa", "", "IN", "356", "", "35", "466", "", "21.82427", "76.35086", "Asia/Kolkata"),("1267044", "Khandela", "", "IN", "356", "", "24", "111", "", "27.60499", "75.502", "Asia/Kolkata"),("1267065", "Khānāpur", "", "IN", "356", "", "19", "555", "", "15.63969", "74.50847", "Asia/Kolkata"),("1267076", "Khammam", "Кхаммам", "IN", "356", "", "40", "541", "", "17.24767", "80.14368", "Asia/Kolkata"),("1267083", "Khamharia", "", "IN", "356", "", "37", "411", "", "20.976", "82.25116", "Asia/Kolkata"),("1267084", "Khāmgaon", "", "IN", "356", "", "16", "500", "", "20.70738", "76.56827", "Asia/Kolkata"),("1267090", "Khambhāt", "", "IN", "356", "", "09", "482", "", "22.31744", "72.61916", "Asia/Kolkata"),("1267091", "Khambhāliya", "", "IN", "356", "", "09", "477", "", "22.20685", "69.65031", "Asia/Kolkata"),("1267097", "Khamaria", "", "IN", "356", "", "35", "451", "", "23.22558", "79.88007", "Asia/Kolkata"),("1267105", "Khamānon Kalān", "", "IN", "356", "", "23", "040", "", "30.81725", "76.35478", "Asia/Kolkata"),("1267112", "Khallikot", "", "IN", "356", "", "21", "388", "", "19.60908", "85.08609", "Asia/Kolkata"),("1267115", "Khalīlābād", "", "IN", "356", "", "36", "186", "", "26.77268", "83.07179", "Asia/Kolkata"),("1267154", "Khajuraho Group of Monuments", "Кхаджурахо", "IN", "356", "", "35", "425", "", "24.84809", "79.93351", "Asia/Kolkata"),("1267173", "Khairāgarh", "", "IN", "356", "", "37", "", "", "26.94269", "77.8189", "Asia/Kolkata"),("1267174", "Khairāgarh", "", "IN", "356", "", "37", "408", "", "21.41859", "80.97942", "Asia/Kolkata"),("1267175", "Khairābād", "", "IN", "356", "", "36", "154", "", "27.52698", "80.75461", "Asia/Kolkata"),("1267182", "Khair", "", "IN", "356", "", "36", "143", "", "27.94195", "77.84243", "Asia/Kolkata"),("1267185", "Khailār", "", "IN", "356", "", "35", "166", "", "25.34127", "78.53133", "Asia/Kolkata"),("1267187", "Khagaul", "", "IN", "356", "", "34", "230", "", "25.57898", "85.04564", "Asia/Kolkata"),("1267189", "Khagaria", "", "IN", "356", "", "34", "223", "", "25.5022", "86.46708", "Asia/Kolkata"),("1267190", "Khāga", "", "IN", "356", "", "36", "172", "", "25.77215", "81.10393", "Asia/Kolkata"),("1267195", "Khadki", "", "IN", "356", "", "16", "521", "", "18.5635", "73.85205", "Asia/Kolkata"),("1267202", "Khada", "", "IN", "356", "", "36", "189", "", "27.18333", "83.88333", "Asia/Kolkata"),("1267203", "Khāchrod", "", "IN", "356", "", "35", "435", "", "23.42322", "75.28185", "Asia/Kolkata"),("1267222", "Kesinga", "", "IN", "356", "", "21", "395", "", "20.18778", "83.21949", "Asia/Kolkata"),("1267226", "Keshorai Pātan", "", "IN", "356", "", "24", "121", "", "25.29275", "75.93948", "Asia/Kolkata"),("1267227", "Keshod", "", "IN", "356", "", "09", "479", "", "21.30328", "70.24861", "Asia/Kolkata"),("1267239", "Kerūr", "", "IN", "356", "", "19", "556", "", "16.01384", "75.54631", "Asia/Kolkata"),("1267280", "Kenduadīh", "", "IN", "356", "", "38", "354", "", "23.77574", "86.37609", "Asia/Kolkata"),("1267283", "Kendrāparha", "", "IN", "356", "", "21", "379", "", "20.50166", "86.42227", "Asia/Kolkata"),("1267290", "Kenda", "", "IN", "356", "", "28", "340", "", "23.1959", "86.51499", "Asia/Kolkata"),("1267297", "Kemrī", "", "IN", "356", "", "36", "136", "", "28.80673", "79.2048", "Asia/Kolkata"),("1267331", "Kelamangalam", "", "IN", "356", "", "25", "631", "", "12.60307", "77.85193", "Asia/Kolkata"),("1267336", "Kekri", "", "IN", "356", "", "24", "119", "", "25.97132", "75.14992", "Asia/Kolkata"),("1267357", "Kayattār", "", "IN", "356", "", "25", "627", "", "8.94708", "77.77206", "Asia/Kolkata"),("1267360", "Kāyankulam", "", "IN", "356", "", "13", "598", "", "9.17243", "76.50017", "Asia/Kolkata"),("1267361", "Kayalpattinam", "", "IN", "356", "", "25", "627", "", "8.57143", "78.11992", "Asia/Kolkata"),("1267369", "Kawardha", "", "IN", "356", "", "37", "407", "", "22.00853", "81.23148", "Asia/Kolkata"),("1267370", "Kawānt", "", "IN", "356", "", "09", "486", "", "22.09282", "74.05078", "Asia/Kolkata"),("1267385", "Kāveripatnam", "", "IN", "356", "", "25", "631", "", "12.42186", "78.2188", "Asia/Kolkata"),("1267390", "Kavaratti", "", "IN", "356", "", "14", "587", "", "10.56688", "72.64203", "Asia/Kolkata"),("1267394", "Kāvali", "", "IN", "356", "", "02", "550", "", "14.9163", "79.99449", "Asia/Kolkata"),("1267428", "Kāttuputtūr", "", "IN", "356", "", "25", "614", "", "10.99367", "78.21929", "Asia/Kolkata"),("1267433", "Kattivākkam", "", "IN", "356", "", "25", "602", "", "13.21667", "80.31667", "Asia/Kolkata"),("1267435", "Kattanam", "", "IN", "356", "", "13", "598", "", "9.18333", "76.55", "Asia/Kolkata"),("1267439", "Kātrās", "", "IN", "356", "", "38", "354", "", "23.79752", "86.29834", "Asia/Kolkata"),("1267448", "Katra", "", "IN", "356", "", "12", "020", "", "32.99167", "74.93195", "Asia/Kolkata"),("1267449", "Katra", "", "IN", "356", "", "36", "181", "", "27.50871", "82.02636", "Asia/Kolkata"),("1267454", "Katpur", "", "IN", "356", "", "09", "481", "", "21.05869", "71.79457", "Asia/Kolkata"),("1267456", "Kātpādi", "", "IN", "356", "", "25", "605", "", "12.96951", "79.14552", "Asia/Kolkata"),("1267457", "Kātoya", "", "IN", "356", "", "28", "335", "", "23.64558", "88.13258", "Asia/Kolkata"),("1267461", "Kātol", "", "IN", "356", "", "16", "505", "", "21.27388", "78.5858", "Asia/Kolkata"),("1267480", "Katihar", "", "IN", "356", "", "34", "212", "", "25.53852", "87.57044", "Asia/Kolkata"),("1267481", "Kāti", "", "IN", "356", "", "16", "525", "", "17.96137", "75.88895", "Asia/Kolkata"),("1267486", "Kathua", "", "IN", "356", "", "12", "007", "", "32.36941", "75.52539", "Asia/Kolkata"),("1267492", "Kāthor", "", "IN", "356", "", "09", "492", "", "21.28854", "72.9407", "Asia/Kolkata"),("1267517", "Katghora", "", "IN", "356", "", "37", "404", "", "22.50247", "82.54279", "Asia/Kolkata"),("1267537", "Katangi", "", "IN", "356", "", "35", "451", "", "23.44124", "79.79621", "Asia/Kolkata"),("1267538", "Katangi", "", "IN", "356", "", "35", "457", "", "21.77369", "79.80513", "Asia/Kolkata"),("1267558", "Kasrāwad", "", "IN", "356", "", "35", "440", "", "22.12745", "75.61101", "Asia/Kolkata"),("1267579", "Kashipur", "", "IN", "356", "", "39", "067", "", "29.21399", "78.95693", "Asia/Kolkata"),("1267588", "Kāsganj", "", "IN", "356", "", "36", "202", "", "27.80882", "78.64579", "Asia/Kolkata"),("1267605", "Kasauli", "", "IN", "356", "", "11", "031", "", "30.89856", "76.96587", "Asia/Kolkata"),("1267616", "Kāsaragod", "", "IN", "356", "", "13", "588", "", "12.49838", "74.98959", "Asia/Kolkata"),("1267635", "Karwar", "Карвар", "IN", "356", "", "19", "563", "", "14.81361", "74.12972", "Asia/Kolkata"),("1267648", "Karur", "Карур", "IN", "356", "", "25", "613", "", "10.95771", "78.08095", "Asia/Kolkata"),("1267660", "Karumbākkam", "", "IN", "356", "", "25", "604", "", "12.70203", "80.0911", "Asia/Kolkata"),("1267669", "Kartārpur", "", "IN", "356", "", "23", "037", "", "31.44268", "75.49847", "Asia/Kolkata"),("1267675", "Kārsiyāng", "", "IN", "356", "", "28", "327", "", "26.88251", "88.27729", "Asia/Kolkata"),("1267680", "Karrāpur", "", "IN", "356", "", "35", "427", "", "23.94891", "78.86584", "Asia/Kolkata"),("1267696", "Karol Bāgh", "", "IN", "356", "", "07", "095", "", "28.65136", "77.19072", "Asia/Kolkata"),("1267708", "Karnāl", "Карнал", "IN", "356", "", "10", "074", "", "29.69197", "76.98448", "Asia/Kolkata"),("1267716", "Karmāla", "", "IN", "356", "", "16", "526", "", "18.4077", "75.19386", "Asia/Kolkata"),("1267739", "Kārkala", "", "IN", "356", "", "19", "569", "", "13.21428", "74.99234", "Asia/Kolkata"),("1267742", "Karjat", "", "IN", "356", "", "16", "520", "", "18.9107", "73.32354", "Asia/Kolkata"),("1267745", "Kariapatti", "", "IN", "356", "", "25", "625", "", "9.67505", "78.09992", "Asia/Kolkata"),("1267754", "Karīmpur", "", "IN", "356", "", "28", "336", "", "23.97594", "88.61917", "Asia/Kolkata"),("1267755", "Karīmnagar", "", "IN", "356", "", "40", "534", "", "18.43915", "79.12856", "Asia/Kolkata"),("1267758", "Karīmganj", "", "IN", "356", "", "03", "317", "", "24.86919", "92.35543", "Asia/Kolkata"),("1267772", "Karhal", "", "IN", "356", "", "36", "148", "", "27.00089", "78.93935", "Asia/Kolkata"),("1267776", "Kargil", "", "IN", "356", "", "12", "004", "", "34.55765", "76.12622", "Asia/Kolkata"),("1267786", "Karera", "Кареры", "IN", "356", "", "35", "423", "", "25.45815", "78.13583", "Asia/Kolkata"),("1267794", "Kareli", "Карели", "IN", "356", "", "35", "452", "", "22.91533", "79.06378", "Asia/Kolkata"),("1267819", "Karauli", "", "IN", "356", "", "24", "107", "", "26.49831", "77.02755", "Asia/Kolkata"),("1267827", "Karārī", "", "IN", "356", "", "36", "174", "", "25.45241", "81.42675", "Asia/Kolkata"),("1267853", "Kāranja", "Каранджа", "IN", "356", "", "16", "502", "", "20.48273", "77.48857", "Asia/Kolkata"),("1267862", "Karamsad", "", "IN", "356", "", "09", "482", "", "22.54243", "72.90392", "Asia/Kolkata"),("1267867", "Karambakkudi", "", "IN", "356", "", "25", "621", "", "10.45787", "79.13971", "Asia/Kolkata"),("1267869", "Kāramadai", "", "IN", "356", "", "25", "632", "", "11.24058", "76.96009", "Asia/Kolkata"),("1267885", "Kāraikkudi", "", "IN", "356", "", "25", "622", "", "10.0661", "78.76787", "Asia/Kolkata"),("1267887", "Kāraikāl", "", "IN", "356", "", "22", "637", "", "10.91667", "79.83333", "Asia/Kolkata"),("1267904", "Karād", "", "IN", "356", "", "16", "527", "", "17.28937", "74.18183", "Asia/Kolkata"),("1267911", "Kapūrthala", "", "IN", "356", "", "23", "036", "", "31.38011", "75.38105", "Asia/Kolkata"),("1267919", "Captainganj", "", "IN", "356", "", "36", "189", "", "26.9264", "83.71334", "Asia/Kolkata"),("1267923", "Kāpren", "", "IN", "356", "", "24", "121", "", "25.40529", "76.07431", "Asia/Kolkata"),("1267939", "Kapadvanj", "", "IN", "356", "", "09", "483", "", "23.02302", "73.07113", "Asia/Kolkata"),("1267964", "Kantilo", "", "IN", "356", "", "21", "385", "", "20.36436", "85.19634", "Asia/Kolkata"),("1267972", "Kānth", "", "IN", "356", "", "36", "135", "", "29.05939", "78.62951", "Asia/Kolkata"),("1267978", "Kantābānji", "", "IN", "356", "", "21", "393", "", "20.46709", "82.92042", "Asia/Kolkata"),("1267979", "Kānt", "", "IN", "356", "", "36", "152", "", "27.81049", "79.79185", "Asia/Kolkata"),("1267995", "Kanpur", "Канпур", "IN", "356", "", "36", "164", "", "26.46523", "80.34975", "Asia/Kolkata"),("1268001", "Kānor", "", "IN", "356", "", "24", "130", "", "24.43437", "74.26546", "Asia/Kolkata"),("1268004", "Kānodar", "", "IN", "356", "", "09", "469", "", "24.08932", "72.39354", "Asia/Kolkata"),("1268007", "Kannod", "", "IN", "356", "", "35", "437", "", "22.66764", "76.74286", "Asia/Kolkata"),("1268008", "Kanniyākumāri", "Каньякумари", "IN", "356", "", "25", "629", "", "8.09008", "77.53841", "Asia/Kolkata"),("1268010", "Kannavam", "", "IN", "356", "", "13", "589", "", "11.8445", "75.66266", "Asia/Kolkata"),("1268011", "Kannauj", "Каннаудж", "IN", "356", "", "36", "160", "", "27.05524", "79.9188", "Asia/Kolkata"),("1268015", "Kānnangād", "", "IN", "356", "", "13", "588", "", "12.30814", "75.10632", "Asia/Kolkata"),("1268020", "Kannad", "", "IN", "356", "", "16", "515", "", "20.25684", "75.13786", "Asia/Kolkata"),("1268022", "Kānkon", "", "IN", "356", "", "33", "586", "", "15.02698", "74.04617", "Asia/Kolkata"),("1268024", "Kankipādu", "", "IN", "356", "", "02", "547", "", "16.4353", "80.76715", "Asia/Kolkata"),("1268031", "Kānker", "", "IN", "356", "", "37", "413", "", "20.27193", "81.49177", "Asia/Kolkata"),("1268032", "Kānke", "", "IN", "356", "", "38", "364", "", "23.43362", "85.3211", "Asia/Kolkata"),("1268035", "Kankauli", "", "IN", "356", "", "16", "529", "", "16.26609", "73.71217", "Asia/Kolkata"),("1268059", "Kanigiri", "", "IN", "356", "", "02", "549", "", "15.40555", "79.50694", "Asia/Kolkata"),("1268084", "Kāngar", "", "IN", "356", "", "11", "024", "", "32.09135", "76.26267", "Asia/Kolkata"),("1268095", "Kangayam", "", "IN", "356", "", "25", "633", "", "11.00599", "77.5609", "Asia/Kolkata"),("1268111", "Kandukūr", "", "IN", "356", "", "02", "549", "", "15.21542", "79.9039", "Asia/Kolkata"),("1268114", "Kāndri", "", "IN", "356", "", "16", "505", "", "21.4203", "79.27663", "Asia/Kolkata"),("1268116", "Kāndra", "", "IN", "356", "", "38", "369", "", "22.8517", "86.05192", "Asia/Kolkata"),("1268124", "Kāndla", "Кандла", "IN", "356", "", "09", "468", "", "23.03333", "70.21667", "Asia/Kolkata"),("1268135", "Kāndi", "", "IN", "356", "", "28", "333", "", "23.95946", "88.04018", "Asia/Kolkata"),("1268138", "Kāndhla", "", "IN", "356", "", "36", "133", "", "29.32104", "77.27101", "Asia/Kolkata"),("1268159", "Kānchipuram", "Канчипурам", "IN", "356", "", "25", "604", "", "12.83515", "79.70006", "Asia/Kolkata"),("1268189", "Kānkānhalli", "", "IN", "356", "", "19", "584", "", "12.54654", "77.42005", "Asia/Kolkata"),("1268202", "Kamuthi", "", "IN", "356", "", "25", "626", "", "9.40732", "78.37337", "Asia/Kolkata"),("1268205", "Kāmthi", "", "IN", "356", "", "16", "505", "", "21.21615", "79.1973", "Asia/Kolkata"),("1268214", "Kampli", "", "IN", "356", "", "19", "565", "", "15.40626", "76.60013", "Asia/Kolkata"),("1268215", "Kampil", "", "IN", "356", "", "36", "159", "", "27.61268", "79.27687", "Asia/Kolkata"),("1268246", "Cumbum", "", "IN", "356", "", "25", "624", "", "9.73647", "77.2847", "Asia/Kolkata"),("1268257", "Kāmārhāti", "", "IN", "356", "", "28", "337", "", "22.67111", "88.37472", "Asia/Kolkata"),("1268259", "Kāmāreddi", "", "IN", "356", "", "40", "533", "", "18.32001", "78.34177", "Asia/Kolkata"),("1268266", "Kāman", "Каман", "IN", "356", "", "24", "105", "", "27.65791", "77.26908", "Asia/Kolkata"),("1268271", "Kamalpur", "", "IN", "356", "", "26", "291", "", "24.19593", "91.83438", "Asia/Kolkata"),("1268276", "Kamalganj", "", "IN", "356", "", "36", "159", "", "27.26181", "79.63134", "Asia/Kolkata"),("1268277", "Kāmalāpuram", "", "IN", "356", "", "02", "551", "", "14.5983", "78.66948", "Asia/Kolkata"),("1268279", "Kāmākhyānagar", "", "IN", "356", "", "21", "383", "", "20.93385", "85.54489", "Asia/Kolkata"),("1268293", "Kalyani", "", "IN", "356", "", "28", "336", "", "22.98333", "88.48333", "Asia/Kolkata"),("1268295", "Kalyān", "Кальян", "IN", "356", "", "16", "517", "", "19.2437", "73.13554", "Asia/Kolkata"),("1268308", "Kālundri", "", "IN", "356", "", "16", "520", "", "18.9802", "73.12708", "Asia/Kolkata"),("1268310", "Kalugumalai", "", "IN", "356", "", "25", "627", "", "9.14726", "77.70424", "Asia/Kolkata"),("1268325", "Kālpi", "Калпи", "IN", "356", "", "36", "165", "", "26.11667", "79.73333", "Asia/Kolkata"),("1268327", "Kalpatta", "", "IN", "356", "", "13", "590", "", "11.60871", "76.08343", "Asia/Kolkata"),("1268339", "Kālol", "", "IN", "356", "", "09", "484", "", "22.60777", "73.46272", "Asia/Kolkata"),("1268341", "Kālna", "Кална", "IN", "356", "", "28", "335", "", "23.21944", "88.36295", "Asia/Kolkata"),("1268344", "Kalmeshwar", "", "IN", "356", "", "16", "505", "", "21.23219", "78.91988", "Asia/Kolkata"),("1268355", "Kallupatti", "", "IN", "356", "", "25", "623", "", "9.71667", "77.86667", "Asia/Kolkata"),("1268360", "Kallidaikurichchi", "", "IN", "356", "", "25", "628", "", "8.68301", "77.46455", "Asia/Kolkata"),("1268376", "Kallakkurichchi", "", "IN", "356", "", "25", "607", "", "11.7404", "78.959", "Asia/Kolkata"),("1268381", "Kālka", "Калки", "IN", "356", "", "11", "", "", "30.83982", "76.94065", "Asia/Kolkata"),("1268383", "Kāliyāganj", "", "IN", "356", "", "28", "330", "", "25.63442", "88.32665", "Asia/Kolkata"),("1268398", "Kanīna Khās", "", "IN", "356", "", "10", "084", "", "28.33093", "76.31099", "Asia/Kolkata"),("1268399", "Kālīnagar", "", "IN", "356", "", "36", "151", "", "28.62019", "80.08152", "Asia/Kolkata"),("1268403", "Kālimpong", "Калимпонг", "IN", "356", "", "28", "327", "", "27.07059", "88.47529", "Asia/Kolkata"),("1268434", "Kalghatgi", "", "IN", "356", "", "19", "562", "", "15.18315", "74.97099", "Asia/Kolkata"),("1268449", "Kalavai", "", "IN", "356", "", "25", "605", "", "12.77029", "79.41999", "Asia/Kolkata"),("1268450", "Kālāvad", "", "IN", "356", "", "09", "477", "", "22.20789", "70.38343", "Asia/Kolkata"),("1268460", "Kalas", "", "IN", "356", "", "16", "521", "", "18.17241", "74.79045", "Asia/Kolkata"),("1268469", "Kālānwāli", "", "IN", "356", "", "10", "079", "", "29.83573", "74.9717", "Asia/Kolkata"),("1268475", "Kalanaur", "", "IN", "356", "", "23", "035", "", "32.01227", "75.15063", "Asia/Kolkata"),("1268476", "Kalānaur", "", "IN", "356", "", "10", "082", "", "28.82823", "76.3955", "Asia/Kolkata"),("1268480", "Kalamnūri", "", "IN", "356", "", "16", "512", "", "19.67386", "77.31149", "Asia/Kolkata"),("1268484", "Kalamb", "", "IN", "356", "", "16", "521", "", "19.04437", "73.95554", "Asia/Kolkata"),("1268495", "Kalakkādu", "", "IN", "356", "", "25", "628", "", "8.51228", "77.5535", "Asia/Kolkata"),("1268510", "Kālāgarh Project Colony", "", "IN", "356", "", "39", "061", "", "29.4778", "78.78449", "Asia/Kolkata"),("1268513", "Kālādhūngi", "", "IN", "356", "", "39", "066", "", "29.28351", "79.351", "Asia/Kolkata"),("1268540", "Kakrāla", "", "IN", "356", "", "36", "149", "", "27.89269", "79.1945", "Asia/Kolkata"),("1268545", "Kākori", "", "IN", "356", "", "36", "157", "", "26.868", "80.7857", "Asia/Kolkata"),("1268561", "Kākināda", "Какинада", "IN", "356", "", "02", "545", "", "16.96036", "82.23809", "Asia/Kolkata"),("1268567", "Kakching", "", "IN", "356", "", "17", "276", "", "24.4982", "93.98126", "Asia/Kolkata"),("1268593", "Kaithal", "", "IN", "356", "", "10", "073", "", "29.80153", "76.39959", "Asia/Kolkata"),("1268601", "Kairāna", "", "IN", "356", "", "36", "133", "", "29.39541", "77.2054", "Asia/Kolkata"),("1268610", "Kaintarāgarh", "", "IN", "356", "", "21", "384", "", "20.72102", "84.53505", "Asia/Kolkata"),("1268615", "Kaimori", "", "IN", "356", "", "35", "451", "", "23.38465", "79.7442", "Asia/Kolkata"),("1268616", "Kaimganj", "", "IN", "356", "", "36", "159", "", "27.55441", "79.33525", "Asia/Kolkata"),("1268622", "Kailāshahar", "", "IN", "356", "", "26", "292", "", "24.33199", "92.00391", "Asia/Kolkata"),("1268624", "Kailāras", "", "IN", "356", "", "35", "419", "", "26.30498", "77.616", "Asia/Kolkata"),("1268627", "Kaikalūr", "", "IN", "356", "", "02", "547", "", "16.55154", "81.214", "Asia/Kolkata"),("1268651", "Kāgal", "", "IN", "356", "", "16", "530", "", "16.57702", "74.31544", "Asia/Kolkata"),("1268662", "Kadūr", "", "IN", "356", "", "19", "570", "", "13.55285", "76.01164", "Asia/Kolkata"),("1268667", "Kadod", "", "IN", "356", "", "09", "492", "", "21.21717", "73.21972", "Asia/Kolkata"),("1268673", "Kadiri", "Кадири", "IN", "356", "", "02", "553", "", "14.11168", "78.15982", "Asia/Kolkata"),("1268677", "Kādīpur", "", "IN", "356", "", "36", "179", "", "26.16779", "82.37028", "Asia/Kolkata"),("1268680", "Kadi", "", "IN", "356", "", "09", "471", "", "23.29908", "72.33362", "Asia/Kolkata"),("1268686", "Kadaura", "", "IN", "356", "", "36", "165", "", "25.98537", "79.83842", "Asia/Kolkata"),("1268707", "Kadayanallur", "", "IN", "356", "", "25", "628", "", "9.07277", "77.34152", "Asia/Kolkata"),("1268715", "Kānchrāpāra", "", "IN", "356", "", "28", "336", "", "22.95998", "88.42849", "Asia/Kolkata"),("1268722", "Kachhwa", "", "IN", "356", "", "36", "199", "", "25.20615", "82.71442", "Asia/Kolkata"),("1268739", "Kabrāi", "", "IN", "356", "", "36", "169", "", "25.40281", "79.9997", "Asia/Kolkata"),("1268761", "Junnar", "", "IN", "356", "", "16", "521", "", "19.20815", "73.8752", "Asia/Kolkata"),("1268772", "Jūnāgarh", "", "IN", "356", "", "37", "", "", "19.85993", "82.93385", "Asia/Kolkata"),("1268773", "Jūnāgadh", "", "IN", "356", "", "09", "479", "", "21.51966", "70.45981", "Asia/Kolkata"),("1268775", "Jumri Tilaiyā", "", "IN", "356", "", "38", "348", "", "24.4349", "85.52951", "Asia/Kolkata"),("1268782", "Jalandhar", "Джаландхар", "IN", "356", "", "23", "037", "", "31.32556", "75.57917", "Asia/Kolkata"),("1268785", "Shādīpur Julāna", "", "IN", "356", "", "10", "077", "", "29.12368", "76.40516", "Asia/Kolkata"),("1268799", "Jugsālai", "", "IN", "356", "", "38", "357", "", "22.77668", "86.18351", "Asia/Kolkata"),("1268806", "Jua", "", "IN", "356", "", "33", "585", "", "15.5307", "73.95047", "Asia/Kolkata"),("1268814", "Joshīmath", "", "IN", "356", "", "39", "057", "", "30.55543", "79.56436", "Asia/Kolkata"),("1268820", "Jorhāt", "Джорхат", "IN", "356", "", "03", "312", "", "26.75751", "94.20306", "Asia/Kolkata"),("1268823", "Jora", "Жора", "IN", "356", "", "35", "419", "", "26.34209", "77.8092", "Asia/Kolkata"),("1268834", "Jalārpet", "", "IN", "356", "", "25", "605", "", "12.57025", "78.57318", "Asia/Kolkata"),("1268849", "Jogindarnagar", "", "IN", "356", "", "11", "027", "", "31.98727", "76.78906", "Asia/Kolkata"),("1268855", "Jogbani", "", "IN", "356", "", "34", "209", "", "26.39905", "87.26525", "Asia/Kathmandu"),("1268863", "Jodiya Bandar", "", "IN", "356", "", "09", "477", "", "22.71667", "70.28333", "Asia/Kolkata"),("1268865", "Jodhpur", "Джодхпур", "IN", "356", "", "24", "113", "", "26.26841", "73.00594", "Asia/Kolkata"),("1268866", "Jodhpur", "", "IN", "356", "", "09", "477", "", "21.90174", "70.0327", "Asia/Kolkata"),("1268874", "Jobner", "", "IN", "356", "", "24", "110", "", "26.97257", "75.38752", "Asia/Kolkata"),("1268875", "Jobat", "", "IN", "356", "", "35", "465", "", "22.41599", "74.56828", "Asia/Kolkata"),("1268893", "Jīran", "", "IN", "356", "", "35", "432", "", "24.30871", "74.89087", "Asia/Kolkata"),("1268896", "Jintūr", "", "IN", "356", "", "16", "513", "", "19.61186", "76.6874", "Asia/Kolkata"),("1268907", "Jīnd", "", "IN", "356", "", "10", "077", "", "29.31577", "76.31502", "Asia/Kolkata"),("1268929", "Jhūsi", "", "IN", "356", "", "36", "175", "", "25.43745", "81.9055", "Asia/Kolkata"),("1268936", "Jhunjhunūn", "", "IN", "356", "", "24", "103", "", "28.12559", "75.39797", "Asia/Kolkata"),("1268961", "Jhinjhāna", "", "IN", "356", "", "36", "133", "", "29.52118", "77.2247", "Asia/Kolkata"),("1268962", "Jhīnjhak", "", "IN", "356", "", "36", "163", "", "26.56093", "79.73423", "Asia/Kolkata"),("1268977", "Jhārsuguda", "", "IN", "356", "", "21", "371", "", "21.86159", "84.01788", "Asia/Kolkata"),("1268988", "Jharia", "", "IN", "356", "", "38", "354", "", "23.74079", "86.41456", "Asia/Kolkata"),("1268990", "Jhārgrām", "", "IN", "356", "", "28", "344", "", "22.45384", "86.99497", "Asia/Kolkata"),("1269006", "Jhānsi", "", "IN", "356", "", "36", "166", "", "25.45887", "78.57994", "Asia/Kolkata"),("1269012", "Jhanjhārpur", "", "IN", "356", "", "34", "207", "", "26.26467", "86.27993", "Asia/Kolkata"),("1269019", "Jhālu", "", "IN", "356", "", "36", "134", "", "29.33609", "78.22608", "Asia/Kolkata"),("1269020", "Jhālrapātan", "", "IN", "356", "", "24", "129", "", "24.54205", "76.17242", "Asia/Kolkata"),("1269026", "Jhalida", "", "IN", "356", "", "28", "340", "", "23.36541", "85.97581", "Asia/Kolkata"),("1269027", "Jhālāwār", "", "IN", "356", "", "24", "129", "", "24.59633", "76.16499", "Asia/Kolkata"),("1269042", "Jhajjar", "", "IN", "356", "", "10", "083", "", "28.6063", "76.6565", "Asia/Kolkata"),("1269046", "Jhā Jhā", "", "IN", "356", "", "34", "238", "", "24.77418", "86.38005", "Asia/Kolkata"),("1269053", "Jhābua", "Дхабуа", "IN", "356", "", "35", "464", "", "22.76772", "74.59087", "Asia/Kolkata"),("1269056", "Jewar", "", "IN", "356", "", "36", "141", "", "28.122", "77.55734", "Asia/Kolkata"),("1269057", "Jevargi", "", "IN", "356", "", "19", "579", "", "17.01394", "76.77317", "Asia/Kolkata"),("1269064", "Jetpur", "", "IN", "356", "", "09", "486", "", "22.34472", "73.84093", "Asia/Kolkata"),("1269065", "Jetpur", "", "IN", "356", "", "09", "476", "", "21.75482", "70.62347", "Asia/Kolkata"),("1269070", "Jetalsar", "", "IN", "356", "", "09", "476", "", "21.70891", "70.57695", "Asia/Kolkata"),("1269087", "Jejūri", "", "IN", "356", "", "16", "521", "", "18.27658", "74.16008", "Asia/Kolkata"),("1269092", "Jeypore", "", "IN", "356", "", "21", "398", "", "18.8563", "82.5716", "Asia/Kolkata"),("1269093", "Jaynagar", "", "IN", "356", "", "34", "207", "", "26.59048", "86.13791", "Asia/Kolkata"),("1269094", "Jaynagar-Majilpur", "", "IN", "356", "", "28", "343", "", "22.17583", "88.41778", "Asia/Kolkata"),("1269102", "Jayamkondacholapuram", "", "IN", "356", "", "25", "616", "", "11.21206", "79.36473", "Asia/Kolkata"),("1269106", "Jawhār", "", "IN", "356", "", "16", "517", "", "19.91213", "73.22679", "Asia/Kolkata"),("1269110", "Iāwar", "", "IN", "356", "", "35", "445", "", "23.00943", "76.5007", "Asia/Kolkata"),("1269119", "Jawāla Mukhi", "", "IN", "356", "", "11", "024", "", "31.87456", "76.32013", "Asia/Kolkata"),("1269126", "Jāwad", "", "IN", "356", "", "35", "432", "", "24.59916", "74.86261", "Asia/Kolkata"),("1269135", "Jaunpur", "Джаунпур", "IN", "356", "", "36", "194", "", "25.75356", "82.68689", "Asia/Kolkata"),("1269153", "Jatāra", "", "IN", "356", "", "35", "424", "", "25.00964", "79.04869", "Asia/Kolkata"),("1269154", "Jatani", "", "IN", "356", "", "21", "386", "", "20.15975", "85.70742", "Asia/Kolkata"),("1269158", "Jaswantnagar", "", "IN", "356", "", "36", "161", "", "26.88271", "78.90256", "Asia/Kolkata"),("1269165", "Jasrāna", "", "IN", "356", "", "36", "147", "", "27.23587", "78.65244", "Asia/Kolkata"),("1269168", "Jaspur", "", "IN", "356", "", "39", "067", "", "29.27919", "78.82798", "Asia/Kolkata"),("1269175", "Jasidih", "", "IN", "356", "", "38", "350", "", "24.51379", "86.64576", "Asia/Kolkata"),("1269177", "Jashpurnagar", "", "IN", "356", "", "37", "402", "", "22.88772", "84.13925", "Asia/Kolkata"),("1269179", "Jasdan", "", "IN", "356", "", "09", "476", "", "22.03709", "71.20794", "Asia/Kolkata"),("1269183", "Jarwal", "", "IN", "356", "", "36", "180", "", "27.1629", "81.54179", "Asia/Kolkata"),("1269217", "Jaorā", "", "IN", "356", "", "35", "434", "", "23.63783", "75.12711", "Asia/Kolkata"),("1269227", "Jānsath", "", "IN", "356", "", "36", "133", "", "29.32502", "77.85044", "Asia/Kolkata"),("1269239", "Jānjgīr", "", "IN", "356", "", "37", "405", "", "22.00922", "82.5778", "Asia/Kolkata"),("1269247", "Jangipur", "", "IN", "356", "", "28", "333", "", "24.47001", "88.07659", "Asia/Kolkata"),("1269256", "Jangaon", "", "IN", "356", "", "40", "540", "", "17.72602", "79.15236", "Asia/Kolkata"),("1269267", "Jandiāla Gurū", "", "IN", "356", "", "23", "049", "", "31.56198", "75.0277", "Asia/Kolkata"),("1269269", "Jandiāla", "", "IN", "356", "", "23", "037", "", "31.1593", "75.61755", "Asia/Kolkata"),("1269280", "Jāmuria", "", "IN", "356", "", "28", "335", "", "23.70468", "87.07872", "Asia/Kolkata"),("1269291", "Jamūī", "", "IN", "356", "", "34", "238", "", "24.92606", "86.22531", "Asia/Kolkata"),("1269298", "Jāmtāra", "", "IN", "356", "", "38", "363", "", "23.963", "86.80285", "Asia/Kolkata"),("1269300", "Jamshedpur", "Джамшедпур", "IN", "356", "", "38", "357", "", "22.80278", "86.18545", "Asia/Kolkata"),("1269317", "Jamnagar", "Джамнагаром", "IN", "356", "", "09", "477", "", "22.47292", "70.06673", "Asia/Kolkata"),("1269321", "Jammu", "Джамму", "IN", "356", "", "12", "021", "", "32.73569", "74.86911", "Asia/Kolkata"),("1269323", "Jammalamadugu", "", "IN", "356", "", "02", "551", "", "14.84677", "78.38314", "Asia/Kolkata"),("1269328", "Jamkhandi", "", "IN", "356", "", "19", "556", "", "16.50461", "75.29146", "Asia/Kolkata"),("1269350", "Jambusar", "", "IN", "356", "", "09", "488", "", "22.05236", "72.80074", "Asia/Kolkata"),("1269374", "Jamālpur", "", "IN", "356", "", "34", "226", "", "25.31258", "86.48888", "Asia/Kolkata"),("1269377", "Jāmai", "", "IN", "356", "", "35", "455", "", "22.19644", "78.59191", "Asia/Kolkata"),("1269379", "Jāmadoba", "", "IN", "356", "", "38", "354", "", "23.71667", "86.4", "Asia/Kolkata"),("1269388", "Jalpāiguri", "", "IN", "356", "", "28", "328", "", "26.51667", "88.73333", "Asia/Kolkata"),("1269392", "Jalor", "", "IN", "356", "", "24", "116", "", "25.34558", "72.61559", "Asia/Kolkata"),("1269395", "Jālna", "", "IN", "356", "", "16", "514", "", "19.84102", "75.88636", "Asia/Kolkata"),("1269406", "Jalgaon Jamod", "Джалгаоне", "IN", "356", "", "16", "500", "", "21.05194", "76.53464", "Asia/Kolkata"),("1269407", "Jalgaon", "Джалгаоне", "IN", "356", "", "16", "499", "", "21.00292", "75.56602", "Asia/Kolkata"),("1269410", "Jalgaon", "", "IN", "356", "", "16", "528", "", "17.74026", "73.19087", "Asia/Kolkata"),("1269413", "Jaleshwar", "", "IN", "356", "", "21", "377", "", "21.80176", "87.2225", "Asia/Kolkata"),("1269415", "Jalesar", "", "IN", "356", "", "36", "201", "", "27.47315", "78.3031", "Asia/Kolkata"),("1269422", "Jālaun", "", "IN", "356", "", "36", "165", "", "26.1451", "79.3366", "Asia/Kolkata"),("1269435", "Jalālpur", "", "IN", "356", "", "36", "178", "", "26.31162", "82.73859", "Asia/Kolkata"),("1269439", "Jalālpur", "", "IN", "356", "", "09", "490", "", "20.94896", "72.89829", "Asia/Kolkata"),("1269441", "Jalālī", "", "IN", "356", "", "36", "143", "", "27.8668", "78.25267", "Asia/Kolkata"),("1269445", "Jalālābād", "", "IN", "356", "", "23", "043", "", "30.60622", "74.25727", "Asia/Kolkata"),("1269446", "Jalālābad", "", "IN", "356", "", "36", "133", "", "29.61853", "77.43908", "Asia/Kolkata"),("1269447", "Jalālābād", "", "IN", "356", "", "36", "152", "", "27.72625", "79.65523", "Asia/Kolkata"),("1269449", "Jalakandapuram", "", "IN", "356", "", "25", "608", "", "11.69779", "77.87298", "Asia/Kolkata"),("1269470", "Jākhal", "", "IN", "356", "", "10", "078", "", "29.79627", "75.82392", "Asia/Kolkata"),("1269477", "Jājpur", "", "IN", "356", "", "21", "382", "", "20.84852", "86.33729", "Asia/Kolkata"),("1269488", "Jaito", "", "IN", "356", "", "23", "045", "", "30.45126", "74.89189", "Asia/Kolkata"),("1269495", "Jaithāri", "", "IN", "356", "", "35", "446", "", "23.20856", "78.61487", "Asia/Kolkata"),("1269498", "Jaitāran", "", "IN", "356", "", "24", "118", "", "26.20446", "73.93676", "Asia/Kolkata"),("1269502", "Jaisingpur", "", "IN", "356", "", "16", "530", "", "16.77639", "74.55361", "Asia/Kolkata"),("1269503", "Jaisinghnagar", "", "IN", "356", "", "35", "460", "", "23.68582", "81.39085", "Asia/Kolkata"),("1269507", "Jaisalmer", "Джайсалмер", "IN", "356", "", "24", "114", "", "26.91763", "70.90387", "Asia/Kolkata"),("1269509", "Jais", "", "IN", "356", "", "36", "158", "", "26.2649", "81.54855", "Asia/Kolkata"),("1269515", "Jaipur", "Джайпур", "IN", "356", "", "24", "110", "", "26.91962", "75.78781", "Asia/Kolkata"),("1269525", "Jainpur", "", "IN", "356", "", "36", "191", "", "26.15389", "83.33505", "Asia/Kolkata"),("1269545", "Jahāzpur", "", "IN", "356", "", "24", "122", "", "25.61994", "75.27609", "Asia/Kolkata"),("1269548", "Jahāngīrpur", "", "IN", "356", "", "36", "142", "", "28.17919", "77.70501", "Asia/Kolkata"),("1269551", "Jahāngīrābād", "", "IN", "356", "", "36", "142", "", "28.40549", "78.10588", "Asia/Kolkata"),("1269555", "Jahānābād", "", "IN", "356", "", "36", "151", "", "28.63025", "79.71818", "Asia/Kolkata"),("1269557", "Jahānābād", "", "IN", "356", "", "34", "239", "", "25.21368", "84.9871", "Asia/Kolkata"),("1269562", "Jagtiāl", "", "IN", "356", "", "40", "534", "", "18.79473", "78.91661", "Asia/Kolkata"),("1269564", "Jagraon", "", "IN", "356", "", "23", "041", "", "30.78783", "75.47391", "Asia/Kolkata"),("1269567", "Jagnair", "", "IN", "356", "", "36", "146", "", "26.8636", "77.60231", "Asia/Kolkata"),("1269570", "Jaggayyapeta", "", "IN", "356", "", "02", "547", "", "16.8938", "80.09807", "Asia/Kolkata"),("1269573", "Jagdīspur", "", "IN", "356", "", "34", "231", "", "25.46811", "84.41939", "Asia/Kolkata"),("1269574", "Jagdīshpur", "", "IN", "356", "", "36", "156", "", "26.74967", "80.5451", "Asia/Kolkata"),("1269578", "Jagdalpur", "Джагдалпур", "IN", "356", "", "37", "414", "", "19.08136", "82.02131", "Asia/Kolkata"),("1269581", "Jagatsinghapur", "", "IN", "356", "", "21", "380", "", "20.2557", "86.17112", "Asia/Kolkata"),("1269592", "Jagannāthpur", "", "IN", "356", "", "38", "368", "", "22.22172", "85.63801", "Asia/Kolkata"),("1269602", "Jagalūr", "", "IN", "356", "", "19", "567", "", "14.51957", "76.33915", "Asia/Kolkata"),("1269605", "Jagādhri", "", "IN", "356", "", "10", "071", "", "30.16719", "77.30367", "Asia/Kolkata"),("1269633", "Jabalpur", "Джабалпур", "IN", "356", "", "35", "451", "", "23.16697", "79.95006", "Asia/Kolkata"),("1269646", "Itimādpur", "", "IN", "356", "", "36", "146", "", "27.23541", "78.19829", "Asia/Kolkata"),("1269652", "Itaunja", "", "IN", "356", "", "36", "157", "", "27.08347", "80.89672", "Asia/Kolkata"),("1269653", "Itārsi", "", "IN", "356", "", "35", "449", "", "22.61477", "77.76222", "Asia/Kolkata"),("1269655", "Itānagar", "Итанагар", "IN", "356", "", "30", "248", "", "27.08694", "93.60987", "Asia/Kolkata"),("1269665", "Islāmpur", "", "IN", "356", "", "28", "330", "", "26.26541", "88.18982", "Asia/Kolkata"),("1269666", "Islāmpur", "", "IN", "356", "", "34", "229", "", "25.14075", "85.20587", "Asia/Kolkata"),("1269670", "Islāmnagar", "", "IN", "356", "", "36", "149", "", "28.32896", "78.72524", "Asia/Kolkata"),("1269685", "Isāgarh", "", "IN", "356", "", "35", "459", "", "24.83906", "77.88274", "Asia/Kolkata"),("1269690", "Irugūr", "", "IN", "356", "", "25", "632", "", "11.01782", "77.06285", "Asia/Kolkata"),("1269693", "Irinjālakuda", "", "IN", "356", "", "13", "594", "", "10.34238", "76.21124", "Asia/Kolkata"),("1269694", "Iringal", "", "IN", "356", "", "13", "591", "", "11.55929", "75.61663", "Asia/Kolkata"),("1269723", "Ingrāj Bāzār", "", "IN", "356", "", "28", "332", "", "25.00447", "88.14573", "Asia/Kolkata"),("1269731", "Indri", "", "IN", "356", "", "10", "074", "", "29.87999", "77.05972", "Asia/Kolkata"),("1269743", "Indore", "Индор", "IN", "356", "", "35", "439", "", "22.71792", "75.8333", "Asia/Kolkata"),("1269751", "Indi", "", "IN", "356", "", "19", "557", "", "17.17735", "75.9526", "Asia/Kolkata"),("1269752", "Indergarh", "", "IN", "356", "", "36", "160", "", "26.93521", "79.6712", "Asia/Kolkata"),("1269761", "Indāpur", "", "IN", "356", "", "16", "520", "", "18.3", "73.25", "Asia/Kolkata"),("1269771", "Imphal", "Импхал", "IN", "356", "", "17", "278", "", "24.80805", "93.9442", "Asia/Kolkata"),("1269782", "Iluppūr", "", "IN", "356", "", "25", "621", "", "10.51347", "78.62357", "Asia/Kolkata"),("1269784", "Ilkal", "", "IN", "356", "", "19", "556", "", "15.95923", "76.11351", "Asia/Kolkata"),("1269792", "Ilampillai", "", "IN", "356", "", "25", "608", "", "11.60553", "78.00665", "Asia/Kolkata"),("1269801", "Iklehra", "", "IN", "356", "", "35", "437", "", "23.14667", "76.39044", "Asia/Kolkata"),("1269805", "Ikauna", "", "IN", "356", "", "36", "181", "", "27.53097", "81.96917", "Asia/Kolkata"),("1269809", "Iglās", "", "IN", "356", "", "36", "143", "", "27.711", "77.93967", "Asia/Kolkata"),("1269810", "Igatpuri", "", "IN", "356", "", "16", "516", "", "19.69522", "73.5626", "Asia/Kolkata"),("1269811", "Idukki", "", "IN", "356", "", "13", "596", "", "9.85", "76.96667", "Asia/Kolkata"),("1269819", "Idappadi", "", "IN", "356", "", "25", "608", "", "11.58624", "77.83891", "Asia/Kolkata"),("1269824", "Ichhāwar", "", "IN", "356", "", "35", "445", "", "23.02816", "77.01729", "Asia/Kolkata"),("1269827", "Ichchāpuram", "", "IN", "356", "", "02", "542", "", "19.11393", "84.68721", "Asia/Kolkata"),("1269834", "Ichalkaranji", "", "IN", "356", "", "16", "530", "", "16.69117", "74.46054", "Asia/Kolkata"),("1269843", "Hyderabad", "Хайдарабад", "IN", "356", "", "40", "536", "", "17.38405", "78.45636", "Asia/Kolkata"),("1269849", "Hadagalli", "", "IN", "356", "", "19", "565", "", "15.02048", "75.93185", "Asia/Kolkata"),("1269862", "Husainābād", "", "IN", "356", "", "38", "358", "", "24.52849", "84", "Asia/Kolkata"),("1269873", "Hunsūr", "Хунсур", "IN", "356", "", "19", "577", "", "12.30359", "76.29275", "Asia/Kolkata"),("1269876", "Hungund", "", "IN", "356", "", "19", "556", "", "16.06213", "76.0586", "Asia/Kolkata"),("1269908", "Hukeri", "", "IN", "356", "", "19", "555", "", "16.23082", "74.60244", "Asia/Kolkata"),("1269910", "Hugli", "Хугли", "IN", "356", "", "28", "338", "", "22.90877", "88.39674", "Asia/Kolkata"),("1269920", "Hubli", "", "IN", "356", "", "19", "562", "", "15.34776", "75.13378", "Asia/Kolkata"),("1269927", "Howli", "", "IN", "356", "", "03", "303", "", "26.42237", "90.98004", "Asia/Kolkata"),("1269934", "Hosūr", "", "IN", "356", "", "25", "631", "", "12.73647", "77.83264", "Asia/Kolkata"),("1269935", "Hospet", "Хоспет", "IN", "356", "", "19", "565", "", "15.26954", "76.3871", "Asia/Kolkata"),("1269936", "Hoskote", "", "IN", "356", "", "19", "583", "", "13.0707", "77.79814", "Asia/Kolkata"),("1269939", "Hoshangābād", "", "IN", "356", "", "35", "449", "", "22.74747", "77.72736", "Asia/Kolkata"),("1269943", "Hosdurga", "", "IN", "356", "", "19", "566", "", "13.79631", "76.28408", "Asia/Kolkata"),("1269946", "Hosanagara", "", "IN", "356", "", "19", "568", "", "13.91387", "75.06503", "Asia/Kolkata"),("1269947", "Hosakote", "", "IN", "356", "", "19", "571", "", "14.27603", "77.16827", "Asia/Kolkata"),("1269970", "Honnāli", "", "IN", "356", "", "19", "567", "", "14.23976", "75.64507", "Asia/Kolkata"),("1269976", "Honāvar", "", "IN", "356", "", "19", "563", "", "14.28088", "74.44497", "Asia/Kolkata"),("1269979", "Homnābād", "", "IN", "356", "", "19", "558", "", "17.77074", "77.12519", "Asia/Kolkata"),("1269985", "Hole Narsipur", "", "IN", "356", "", "19", "574", "", "12.78635", "76.24331", "Asia/Kolkata"),("1269990", "Holalkere", "", "IN", "356", "", "19", "566", "", "14.04295", "76.18496", "Asia/Kolkata"),("1269993", "Hojāi", "", "IN", "356", "", "03", "305", "", "26.00281", "92.85605", "Asia/Kolkata"),("1270000", "Hodal", "", "IN", "356", "", "10", "089", "", "27.89196", "77.36744", "Asia/Kolkata"),("1270021", "Hisuā", "", "IN", "356", "", "34", "237", "", "24.8336", "85.41729", "Asia/Kolkata"),("1270022", "Hisar", "Хисар", "IN", "356", "", "10", "080", "", "29.15394", "75.72294", "Asia/Kolkata"),("1270032", "Hiriyūr", "", "IN", "356", "", "19", "566", "", "13.94455", "76.61723", "Asia/Kolkata"),("1270036", "Hirekerūr", "", "IN", "356", "", "19", "564", "", "14.45506", "75.3952", "Asia/Kolkata"),("1270048", "Hīrāpur Hamesha", "", "IN", "356", "", "16", "506", "", "21.55546", "79.78581", "Asia/Kolkata"),("1270056", "Hirānagar", "", "IN", "356", "", "12", "007", "", "32.45493", "75.27187", "Asia/Kolkata"),("1270059", "Hīrākud", "", "IN", "356", "", "21", "372", "", "21.52502", "83.87275", "Asia/Kolkata"),("1270066", "Hinjilikatu", "", "IN", "356", "", "21", "388", "", "19.48166", "84.74489", "Asia/Kolkata"),("1270072", "Hingoli", "", "IN", "356", "", "16", "512", "", "19.71464", "77.14238", "Asia/Kolkata"),("1270077", "Hinganghāt", "", "IN", "356", "", "16", "504", "", "20.54875", "78.83978", "Asia/Kolkata"),("1270079", "Hindupur", "", "IN", "356", "", "02", "553", "", "13.82807", "77.49143", "Asia/Kolkata"),("1270082", "Hindoria", "", "IN", "356", "", "35", "428", "", "23.90345", "79.56861", "Asia/Kolkata"),("1270090", "Hindaun", "", "IN", "356", "", "24", "107", "", "26.73411", "77.03519", "Asia/Kolkata"),("1270099", "Himatnagar", "", "IN", "356", "", "09", "472", "", "23.59893", "72.96602", "Asia/Kolkata"),("1270102", "Hilsa", "", "IN", "356", "", "34", "229", "", "25.31642", "85.28234", "Asia/Kolkata"),("1270118", "Hesla", "", "IN", "356", "", "38", "349", "", "24.06318", "85.87915", "Asia/Kolkata"),("1270127", "Harbatpur", "", "IN", "356", "", "39", "060", "", "30.43863", "77.74058", "Asia/Kolkata"),("1270151", "Heggadadevankote", "", "IN", "356", "", "19", "577", "", "12.08809", "76.32957", "Asia/Kolkata"),("1270164", "Hazārībāg", "Хазарибаг", "IN", "356", "", "38", "360", "", "23.99507", "85.36109", "Asia/Kolkata"),("1270171", "Hāveri", "", "IN", "356", "", "19", "564", "", "14.79354", "75.40448", "Asia/Kolkata"),("1270185", "Hatta", "Хатта", "IN", "356", "", "35", "428", "", "24.13406", "79.60119", "Asia/Kolkata"),("1270192", "Hātod", "", "IN", "356", "", "35", "439", "", "22.79378", "75.73928", "Asia/Kolkata"),("1270216", "Hāthras", "", "IN", "356", "", "36", "144", "", "27.59551", "78.05201", "Asia/Kolkata"),("1270232", "Hātā", "", "IN", "356", "", "36", "189", "", "26.7412", "83.74526", "Asia/Kolkata"),("1270237", "Hastināpur", "", "IN", "356", "", "36", "138", "", "29.16042", "78.00762", "Asia/Kolkata"),("1270239", "Hassan", "Хасан", "IN", "356", "", "19", "574", "", "13.00715", "76.0962", "Asia/Kolkata"),("1270245", "Hāsimāra", "", "IN", "356", "", "28", "328", "", "26.7469", "89.35385", "Asia/Kolkata"),("1270251", "Hasanpur", "", "IN", "356", "", "36", "137", "", "28.72249", "78.28436", "Asia/Kolkata"),("1270252", "Hasanpur", "", "IN", "356", "", "10", "089", "", "27.96944", "77.49544", "Asia/Kolkata"),("1270265", "Harūr", "", "IN", "356", "", "25", "630", "", "12.05267", "78.48023", "Asia/Kolkata"),("1270271", "Harsūd", "", "IN", "356", "", "35", "466", "", "22.09947", "76.73423", "Asia/Kolkata"),("1270286", "Harrai", "", "IN", "356", "", "35", "455", "", "22.61428", "79.22207", "Asia/Kolkata"),("1270287", "Harpanahalli", "", "IN", "356", "", "19", "567", "", "14.78766", "75.98863", "Asia/Kolkata"),("1270291", "Harpālpur", "", "IN", "356", "", "35", "425", "", "25.28773", "79.33279", "Asia/Kolkata"),("1270304", "Harnai", "", "IN", "356", "", "16", "", "", "17.8134", "73.09668", "Asia/Kolkata"),("1270336", "Haringhāta", "", "IN", "356", "", "28", "336", "", "22.96474", "88.57451", "Asia/Kolkata"),("1270343", "Hārij", "", "IN", "356", "", "09", "470", "", "23.69356", "71.907", "Asia/Kolkata"),("1270349", "Harihar", "", "IN", "356", "", "19", "567", "", "14.51288", "75.80716", "Asia/Kolkata"),("1270351", "Haridwar", "Харидвар", "IN", "356", "", "39", "068", "", "29.94791", "78.16025", "Asia/Kolkata"),("1270357", "Hariāna", "", "IN", "356", "", "23", "038", "", "31.63512", "75.83887", "Asia/Kolkata"),("1270364", "Harduāganj", "", "IN", "356", "", "36", "143", "", "27.94361", "78.15789", "Asia/Kolkata"),("1270370", "Hardoī", "", "IN", "356", "", "36", "155", "", "27.39491", "80.13165", "Asia/Kolkata"),("1270375", "Harda Khās", "", "IN", "356", "", "35", "448", "", "22.34414", "77.09536", "Asia/Kolkata"),("1270391", "Haraiya", "", "IN", "356", "", "36", "185", "", "26.79477", "82.46436", "Asia/Kolkata"),("1270393", "Hāpur", "", "IN", "356", "", "36", "140", "", "28.72985", "77.78068", "Asia/Kolkata"),("1270396", "Hāora", "", "IN", "356", "", "28", "341", "", "22.57688", "88.31857", "Asia/Kolkata"),("1270407", "Hanumāngarh", "", "IN", "356", "", "24", "100", "", "29.58182", "74.32938", "Asia/Kolkata"),("1270413", "Hansot", "", "IN", "356", "", "09", "488", "", "21.58496", "72.80764", "Asia/Kolkata"),("1270417", "Hānsi", "Ханси", "IN", "356", "", "10", "080", "", "29.10239", "75.96253", "Asia/Kolkata"),("1270435", "Hāngal", "", "IN", "356", "", "19", "564", "", "14.76465", "75.1246", "Asia/Kolkata"),("1270437", "Handiā", "", "IN", "356", "", "36", "175", "", "25.36379", "82.18655", "Asia/Kolkata"),("1270448", "Hampi", "", "IN", "356", "", "19", "565", "", "15.3352", "76.4603", "Asia/Kolkata"),("1270454", "Hamīrpur", "", "IN", "356", "", "11", "028", "", "31.68411", "76.52506", "Asia/Kolkata"),("1270455", "Hamīrpur", "", "IN", "356", "", "36", "168", "", "25.9553", "80.14842", "Asia/Kolkata"),("1270466", "Halvad", "", "IN", "356", "", "09", "475", "", "23.01516", "71.18029", "Asia/Kolkata"),("1270474", "Hālol", "", "IN", "356", "", "09", "484", "", "22.50321", "73.47242", "Asia/Kolkata"),("1270482", "Haliyal", "", "IN", "356", "", "19", "563", "", "15.32864", "74.75638", "Asia/Kolkata"),("1270484", "Hālīsahar", "", "IN", "356", "", "28", "337", "", "22.93218", "88.41859", "Asia/Kolkata"),("1270498", "Haldwani", "", "IN", "356", "", "39", "066", "", "29.22254", "79.5286", "Asia/Kolkata"),("1270504", "Haldībāri", "", "IN", "356", "", "28", "329", "", "26.33887", "88.7822", "Asia/Kolkata"),("1270509", "Haldaur", "", "IN", "356", "", "36", "134", "", "29.28988", "78.28437", "Asia/Kolkata"),("1270522", "Hājo", "", "IN", "356", "", "03", "321", "", "26.2452", "91.52525", "Asia/Kolkata"),("1270523", "Hājipur", "", "IN", "356", "", "23", "038", "", "31.97714", "75.75438", "Asia/Kolkata"),("1270525", "Hājīpur", "Хаджипур", "IN", "356", "", "34", "220", "", "25.68544", "85.20981", "Asia/Kolkata"),("1270529", "Hājan", "", "IN", "356", "", "12", "008", "", "34.29895", "74.61681", "Asia/Kolkata"),("1270530", "Hailākāndi", "", "IN", "356", "", "03", "318", "", "24.68394", "92.56097", "Asia/Kolkata"),("1270543", "Hāflong", "", "IN", "356", "", "03", "315", "", "25.16478", "93.01744", "Asia/Kolkata"),("1270554", "Hadgāon", "", "IN", "356", "", "16", "511", "", "19.49552", "77.65863", "Asia/Kolkata"),("1270568", "Hābra", "", "IN", "356", "", "28", "337", "", "22.84202", "88.65606", "Asia/Kolkata"),("1270576", "Gyānpur", "", "IN", "356", "", "36", "198", "", "25.33268", "82.46637", "Asia/Kolkata"),("1270583", "Gwalior", "Гвалиор", "IN", "356", "", "35", "421", "", "26.22983", "78.17337", "Asia/Kolkata"),("1270598", "Guskhara", "", "IN", "356", "", "28", "335", "", "23.49276", "87.73484", "Asia/Kolkata"),("1270603", "Guruvāyūr", "", "IN", "356", "", "13", "594", "", "10.5943", "76.0411", "Asia/Kolkata"),("1270612", "Guru Har Sahāi", "", "IN", "356", "", "23", "043", "", "30.70862", "74.40407", "Asia/Kolkata"),("1270618", "Gursarāi", "", "IN", "356", "", "36", "166", "", "25.61677", "79.18053", "Asia/Kolkata"),("1270619", "Gursahāiganj", "", "IN", "356", "", "36", "160", "", "27.11518", "79.73174", "Asia/Kolkata"),("1270627", "Gurmatkāl", "", "IN", "356", "", "19", "580", "", "16.86773", "77.39088", "Asia/Kolkata"),("1270640", "Gurh", "", "IN", "356", "", "35", "430", "", "24.50265", "81.50037", "Asia/Kolkata"),("1270642", "Gurgaon", "Гургаон", "IN", "356", "", "10", "086", "", "28.4601", "77.02635", "Asia/Kolkata"),("1270667", "Gunupur", "", "IN", "356", "", "21", "396", "", "19.0804", "83.80879", "Asia/Kolkata"),("1270668", "Guntur", "Гунтура", "IN", "356", "", "02", "548", "", "16.29974", "80.45729", "Asia/Kolkata"),("1270670", "Guntakal Junction", "", "IN", "356", "", "02", "553", "", "15.17112", "77.36244", "Asia/Kolkata"),("1270674", "Gunnaur", "", "IN", "356", "", "36", "149", "", "28.23995", "78.43994", "Asia/Kolkata"),("1270686", "Gundlupēt", "", "IN", "356", "", "19", "578", "", "11.81004", "76.69027", "Asia/Kolkata"),("1270711", "Guna", "", "IN", "356", "", "35", "458", "", "24.64691", "77.3113", "Asia/Kolkata"),("1270718", "Gummidipundi", "", "IN", "356", "", "25", "602", "", "13.40765", "80.10879", "Asia/Kolkata"),("1270722", "Gumla", "", "IN", "356", "", "37", "", "", "23.04156", "84.54397", "Asia/Kolkata"),("1270723", "Gumia", "", "IN", "356", "", "38", "355", "", "23.79896", "85.82383", "Asia/Kolkata"),("1270750", "Guledagudda", "", "IN", "356", "", "19", "556", "", "16.05025", "75.78997", "Asia/Kolkata"),("1270752", "Gulbarga", "Гульбарга", "IN", "356", "", "19", "579", "", "17.33583", "76.83757", "Asia/Kolkata"),("1270759", "Gulāothi", "", "IN", "356", "", "36", "142", "", "28.58938", "77.79318", "Asia/Kolkata"),("1270763", "Gulābpura", "", "IN", "356", "", "24", "122", "", "25.90448", "74.66025", "Asia/Kolkata"),("1270774", "Guirim", "", "IN", "356", "", "33", "585", "", "15.57552", "73.80722", "Asia/Kolkata"),("1270787", "Gūduvāncheri", "", "IN", "356", "", "25", "604", "", "12.84519", "80.06055", "Asia/Kolkata"),("1270789", "Gūdūr", "", "IN", "356", "", "40", "539", "", "17.49174", "78.82302", "Asia/Kolkata"),("1270791", "Gūdūr", "", "IN", "356", "", "02", "550", "", "14.15093", "79.8521", "Asia/Kolkata"),("1270798", "Gudlavalleru", "", "IN", "356", "", "02", "547", "", "16.35", "81.05", "Asia/Kolkata"),("1270800", "Gudiyatham", "", "IN", "356", "", "25", "605", "", "12.94601", "78.87377", "Asia/Kolkata"),("1270801", "Gudivāda", "", "IN", "356", "", "02", "547", "", "16.43547", "80.99555", "Asia/Kolkata"),("1270806", "Gudibanda", "", "IN", "356", "", "19", "582", "", "13.67099", "77.70414", "Asia/Kolkata"),("1270818", "Gudāri", "", "IN", "356", "", "21", "396", "", "19.34762", "83.78128", "Asia/Kolkata"),("1270820", "Gudalur", "", "IN", "356", "", "25", "624", "", "9.67826", "77.24951", "Asia/Kolkata"),("1270824", "Gubbi", "", "IN", "356", "", "19", "571", "", "13.31216", "76.94102", "Asia/Kolkata"),("1270827", "Gua", "", "IN", "356", "", "38", "368", "", "22.21361", "85.38774", "Asia/Kolkata"),("1270845", "Goyerkāta", "", "IN", "356", "", "28", "328", "", "26.69984", "89.02565", "Asia/Kolkata"),("1270854", "Govindgarh", "", "IN", "356", "", "24", "104", "", "27.50423", "76.99938", "Asia/Kolkata"),("1270856", "Govindgarh", "", "IN", "356", "", "35", "430", "", "24.37845", "81.29644", "Asia/Kolkata"),("1270863", "Govardhan", "Говардхан", "IN", "356", "", "36", "145", "", "27.49658", "77.46263", "Asia/Kolkata"),("1270888", "Goshaingaon", "", "IN", "356", "", "03", "300", "", "26.43946", "89.96307", "Asia/Kolkata"),("1270890", "Goshāīnganj", "", "IN", "356", "", "36", "157", "", "26.76793", "81.10752", "Asia/Kolkata"),("1270895", "Goshāinganj", "", "IN", "356", "", "36", "177", "", "26.57115", "82.38091", "Asia/Kolkata"),("1270896", "Gosāba", "", "IN", "356", "", "28", "337", "", "22.16547", "88.8007", "Asia/Kolkata"),("1270898", "Gorūr", "", "IN", "356", "", "19", "574", "", "12.82297", "76.06463", "Asia/Kolkata"),("1270914", "Goregaon", "", "IN", "356", "", "16", "520", "", "18.15483", "73.29147", "Asia/Kolkata"),("1270926", "Gorakhpur", "Горакпура", "IN", "356", "", "10", "078", "", "29.44768", "75.67206", "Asia/Kolkata"),("1270927", "Gorakhpur", "Горакпура", "IN", "356", "", "36", "188", "", "26.76628", "83.36889", "Asia/Kolkata"),("1270944", "Gopināthpur", "", "IN", "356", "", "38", "369", "", "22.66301", "86.075", "Asia/Kolkata"),("1270947", "Gobichettipalayam", "", "IN", "356", "", "25", "610", "", "11.45496", "77.4422", "Asia/Kolkata"),("1270951", "Gopāmau", "", "IN", "356", "", "36", "155", "", "27.53468", "80.28507", "Asia/Kolkata"),("1270961", "Gopālpur", "", "IN", "356", "", "21", "388", "", "19.25861", "84.90517", "Asia/Kolkata"),("1270965", "Gopālganj", "", "IN", "356", "", "34", "217", "", "26.46734", "84.44041", "Asia/Kolkata"),("1270990", "Gondiā", "Гондия", "IN", "356", "", "16", "507", "", "21.46026", "80.19205", "Asia/Kolkata"),("1270994", "Gondal", "", "IN", "356", "", "09", "476", "", "21.96074", "70.80255", "Asia/Kolkata"),("1270996", "Gondā City", "Гонда", "IN", "356", "", "36", "183", "", "27.13181", "81.95332", "Asia/Kolkata"),("1271005", "Gomoh", "", "IN", "356", "", "38", "354", "", "23.87355", "86.1516", "Asia/Kolkata"),("1271047", "Golakganj", "", "IN", "356", "", "03", "301", "", "26.10216", "89.82275", "Asia/Kolkata"),("1271049", "Gola Gokarannāth", "", "IN", "356", "", "36", "153", "", "28.07837", "80.47054", "Asia/Kolkata"),("1271050", "Golāghāt", "", "IN", "356", "", "03", "313", "", "26.51167", "93.95951", "Asia/Kolkata"),("1271052", "Gola Bāzār", "", "IN", "356", "", "36", "188", "", "26.3446", "83.35303", "Asia/Kolkata"),("1271064", "Gokarna", "Гокарн", "IN", "356", "", "19", "563", "", "14.55", "74.31667", "Asia/Kolkata"),("1271067", "Gokak", "Гокак", "IN", "356", "", "19", "555", "", "16.16901", "74.82393", "Asia/Kolkata"),("1271074", "Gohpur", "", "IN", "356", "", "03", "306", "", "26.88184", "93.6156", "Asia/Kolkata"),("1271078", "Gohānd", "", "IN", "356", "", "36", "168", "", "25.69871", "79.54567", "Asia/Kolkata"),("1271079", "Gohāna", "", "IN", "356", "", "10", "076", "", "29.13777", "76.70247", "Asia/Kolkata"),("1271083", "Gohadi", "", "IN", "356", "", "35", "420", "", "26.43278", "78.44205", "Asia/Kolkata"),("1271093", "Gogāpur", "", "IN", "356", "", "35", "435", "", "23.55746", "75.51665", "Asia/Kolkata"),("1271107", "Godhra", "Годхре", "IN", "356", "", "09", "484", "", "22.77547", "73.61488", "Asia/Kolkata"),("1271113", "Godda", "", "IN", "356", "", "38", "351", "", "24.827", "87.2125", "Asia/Kolkata"),("1271130", "Gobindpur", "", "IN", "356", "", "38", "354", "", "23.83556", "86.51853", "Asia/Kolkata"),("1271131", "Gobindpur", "", "IN", "356", "", "38", "369", "", "22.63393", "86.07162", "Asia/Kolkata"),("1271142", "Gobārdānga", "", "IN", "356", "", "28", "337", "", "22.8774", "88.75479", "Asia/Kolkata"),("1271146", "Goa Velha", "", "IN", "356", "", "33", "585", "", "15.44384", "73.88572", "Asia/Kolkata"),("1271151", "Goālpāra", "", "IN", "356", "", "03", "302", "", "26.17668", "90.62634", "Asia/Kolkata"),("1271175", "Girīdīh", "", "IN", "356", "", "38", "349", "", "24.18561", "86.30772", "Asia/Kolkata"),("1271199", "Gingee", "", "IN", "356", "", "25", "607", "", "12.25282", "79.41727", "Asia/Kolkata"),("1271212", "Giddarbāha", "", "IN", "356", "", "23", "044", "", "30.19953", "74.66627", "Asia/Kolkata"),("1271213", "Giddalūr", "", "IN", "356", "", "02", "549", "", "15.37439", "78.92609", "Asia/Kolkata"),("1271215", "Gīdam", "", "IN", "356", "", "37", "416", "", "18.97431", "81.39894", "Asia/Kolkata"),("1271244", "Ghugus", "", "IN", "356", "", "16", "509", "", "19.9381", "79.11192", "Asia/Kolkata"),("1271250", "Ghoti Budrukh", "", "IN", "356", "", "16", "516", "", "19.71641", "73.62821", "Asia/Kolkata"),("1271259", "Ghosī", "", "IN", "356", "", "36", "192", "", "26.10587", "83.5393", "Asia/Kolkata"),("1271264", "Ghorāwal", "", "IN", "356", "", "36", "200", "", "24.75459", "82.77965", "Asia/Kolkata"),("1271285", "Ghogha", "", "IN", "356", "", "09", "481", "", "21.68813", "72.2763", "Asia/Kolkata"),("1271295", "Ghiror", "", "IN", "356", "", "36", "148", "", "27.18912", "78.79312", "Asia/Kolkata"),("1271306", "Ghazīpur", "", "IN", "356", "", "36", "195", "", "25.58333", "83.58526", "Asia/Kolkata"),("1271308", "Ghāziābād", "Газиабад", "IN", "356", "", "36", "140", "", "28.66535", "77.43915", "Asia/Kolkata"),("1271319", "Ghātsīla", "", "IN", "356", "", "38", "357", "", "22.58531", "86.47682", "Asia/Kolkata"),("1271343", "Ghātanji", "", "IN", "356", "", "16", "510", "", "20.14183", "78.31333", "Asia/Kolkata"),("1271345", "Ghātampur", "", "IN", "356", "", "36", "164", "", "26.15272", "80.16803", "Asia/Kolkata"),("1271346", "Ghātāl", "", "IN", "356", "", "28", "344", "", "22.66244", "87.73399", "Asia/Kolkata"),("1271361", "Gharghoda", "", "IN", "356", "", "37", "403", "", "22.17427", "83.3517", "Asia/Kolkata"),("1271363", "Gharaunda", "", "IN", "356", "", "10", "074", "", "29.53692", "76.97142", "Asia/Kolkata"),("1271374", "Ghansor", "", "IN", "356", "", "35", "456", "", "22.65976", "79.95013", "Asia/Kolkata"),("1271386", "Ghanaur", "", "IN", "356", "", "23", "048", "", "30.33092", "76.61203", "Asia/Kolkata"),("1271393", "Ghumārwīn", "", "IN", "356", "", "11", "030", "", "31.44166", "76.71509", "Asia/Kolkata"),("1271413", "Gevrai", "", "IN", "356", "", "16", "523", "", "19.26372", "75.75007", "Asia/Kolkata"),("1271439", "Gaya", "", "IN", "356", "", "34", "236", "", "24.79686", "85.00385", "Asia/Kolkata"),("1271444", "Gawān", "", "IN", "356", "", "36", "149", "", "28.41969", "78.35186", "Asia/Kolkata"),("1271449", "Gautampura", "", "IN", "356", "", "35", "439", "", "22.98664", "75.51921", "Asia/Kolkata"),("1271453", "Gauripur", "", "IN", "356", "", "03", "301", "", "26.08334", "89.96118", "Asia/Kolkata"),("1271459", "Goribidnūr", "", "IN", "356", "", "19", "582", "", "13.61072", "77.51738", "Asia/Kolkata"),("1271464", "Gaurela", "", "IN", "356", "", "37", "406", "", "22.75449", "81.90107", "Asia/Kolkata"),("1271476", "Guwahati", "Гувахати", "IN", "356", "", "03", "322", "", "26.1844", "91.7458", "Asia/Kolkata"),("1271493", "Garhwa", "", "IN", "356", "", "38", "346", "", "24.16002", "83.80755", "Asia/Kolkata"),("1271495", "Garui", "", "IN", "356", "", "28", "337", "", "22.63333", "88.4", "Asia/Kolkata"),("1271533", "Gariadhar", "", "IN", "356", "", "09", "481", "", "21.53889", "71.57737", "Asia/Kolkata"),("1271534", "Gariāband", "", "IN", "356", "", "37", "410", "", "20.63323", "82.06221", "Asia/Kolkata"),("1271538", "Garhshankar", "", "IN", "356", "", "23", "038", "", "31.21537", "76.14149", "Asia/Kolkata"),("1271543", "Garhmuktesar", "", "IN", "356", "", "36", "140", "", "28.78732", "78.10214", "Asia/Kolkata"),("1271551", "Garhi Pūkhta", "", "IN", "356", "", "36", "133", "", "29.5498", "77.30881", "Asia/Kolkata"),("1271563", "Garhākota", "", "IN", "356", "", "35", "427", "", "23.7791", "79.14321", "Asia/Kolkata"),("1271575", "Garhdiwāla", "", "IN", "356", "", "23", "038", "", "31.74147", "75.75567", "Asia/Kolkata"),("1271582", "Garautha", "", "IN", "356", "", "36", "166", "", "25.5719", "79.29764", "Asia/Kolkata"),("1271613", "Gannavaram", "", "IN", "356", "", "02", "547", "", "16.54092", "80.80213", "Asia/Kolkata"),("1271616", "Ganj Murādābād", "", "IN", "356", "", "36", "156", "", "26.95733", "80.184", "Asia/Kolkata"),("1271621", "Ganjām", "", "IN", "356", "", "21", "388", "", "19.38705", "85.05079", "Asia/Kolkata"),("1271631", "Gangtok", "Гангток", "IN", "356", "", "29", "244", "", "27.32574", "88.61216", "Asia/Kolkata"),("1271642", "Gangolli", "", "IN", "356", "", "19", "", "", "13.65024", "74.67072", "Asia/Kolkata"),("1271644", "Gangoh", "", "IN", "356", "", "36", "132", "", "29.78004", "77.26346", "Asia/Kolkata"),("1271662", "Gangāwati", "", "IN", "356", "", "19", "560", "", "15.4313", "76.52933", "Asia/Kolkata"),("1271663", "Gangavalli", "", "IN", "356", "", "25", "608", "", "11.49828", "78.64966", "Asia/Kolkata"),("1271670", "Gangārāmpur", "", "IN", "356", "", "28", "331", "", "25.40138", "88.52978", "Asia/Kolkata"),("1271675", "Gangāpur", "", "IN", "356", "", "24", "108", "", "26.47249", "76.71744", "Asia/Kolkata"),("1271676", "Gangāpur", "", "IN", "356", "", "24", "122", "", "25.21954", "74.26028", "Asia/Kolkata"),("1271680", "Gangāpur", "", "IN", "356", "", "16", "515", "", "19.69718", "75.01045", "Asia/Kolkata"),("1271685", "Gangānagar", "", "IN", "356", "", "24", "099", "", "29.92009", "73.87496", "Asia/Kolkata"),("1271688", "Gangākher", "", "IN", "356", "", "16", "513", "", "18.96962", "76.74946", "Asia/Kolkata"),("1271692", "Gangaikondān", "", "IN", "356", "", "25", "628", "", "8.85597", "77.77951", "Asia/Kolkata"),("1271714", "Gāndhī Nagar", "", "IN", "356", "", "25", "603", "", "13.00639", "80.25417", "Asia/Kolkata"),("1271715", "Ghandinagar", "Гандинагар", "IN", "356", "", "09", "473", "", "23.21667", "72.68333", "Asia/Kolkata"),("1271717", "Gāndhīdhām", "", "IN", "356", "IN", "09", "468", "", "23.08333", "70.13333", "Asia/Kolkata"),("1271722", "Gandevi", "", "IN", "356", "", "09", "490", "", "20.81214", "72.99811", "Asia/Kolkata"),("1271729", "Gāndarbal", "", "IN", "356", "", "12", "010", "", "34.22619", "74.77478", "Asia/Kolkata"),("1271734", "Gandai", "", "IN", "356", "", "37", "408", "", "21.66667", "81.10013", "Asia/Kolkata"),("1271771", "Galiākot", "", "IN", "356", "", "24", "124", "", "23.51995", "74.02028", "Asia/Kolkata"),("1271780", "Gajraula", "", "IN", "356", "", "36", "137", "", "28.8457", "78.2396", "Asia/Kolkata"),("1271789", "Gajendragarh", "", "IN", "356", "", "19", "561", "", "15.73628", "75.96976", "Asia/Kolkata"),("1271819", "Gadwāl", "", "IN", "356", "", "40", "538", "", "16.23504", "77.79556", "Asia/Kolkata"),("1271834", "Gadhinglaj", "", "IN", "356", "", "16", "530", "", "16.22291", "74.3501", "Asia/Kolkata"),("1271839", "Gadhada", "", "IN", "356", "", "09", "481", "", "21.96957", "71.57828", "Asia/Kolkata"),("1271847", "Gādarwāra", "", "IN", "356", "", "35", "452", "", "22.9235", "78.7849", "Asia/Kolkata"),("1271850", "Gadag", "", "IN", "356", "", "19", "561", "", "15.42977", "75.62971", "Asia/Kolkata"),("1271871", "Fort Gloster", "", "IN", "356", "", "28", "341", "", "22.50444", "88.18333", "Asia/Kolkata"),("1271874", "Forbesganj", "", "IN", "356", "", "34", "209", "", "26.30253", "87.26556", "Asia/Kolkata"),("1271881", "Fīrozpur Jhirka", "", "IN", "356", "", "10", "087", "", "27.78853", "76.94496", "Asia/Kolkata"),("1271883", "Ferozepore", "", "IN", "356", "", "23", "043", "", "30.92574", "74.61311", "Asia/Kolkata"),("1271885", "Fīrozābād", "", "IN", "356", "", "36", "147", "", "27.15092", "78.39781", "Asia/Kolkata"),("1271888", "Ferokh", "", "IN", "356", "", "13", "591", "", "11.17989", "75.84141", "Asia/Kolkata"),("1271891", "Fāzilka", "", "IN", "356", "", "23", "8407166", "", "30.40207", "74.02836", "Asia/Kolkata"),("1271892", "Fatwa", "", "IN", "356", "", "34", "230", "", "25.50958", "85.30504", "Asia/Kolkata"),("1271900", "Fatehpur Sīkri", "", "IN", "356", "", "36", "146", "", "27.0937", "77.66003", "Asia/Kolkata"),("1271902", "Fatehpur Chaurāsi", "", "IN", "356", "", "36", "156", "", "26.78925", "80.26547", "Asia/Kolkata"),("1271910", "Fatehpur", "", "IN", "356", "", "24", "111", "", "27.99486", "74.95628", "Asia/Kolkata"),("1271911", "Fatehpur", "", "IN", "356", "", "36", "176", "", "27.17281", "81.21061", "Asia/Kolkata"),("1271912", "Fatehpur", "Фатехпур", "IN", "356", "", "36", "172", "", "25.92774", "80.81266", "Asia/Kolkata"),("1271923", "Fatehgarh Chūriān", "", "IN", "356", "", "23", "035", "", "31.86431", "74.95665", "Asia/Kolkata"),("1271925", "Fatehgarh", "", "IN", "356", "", "36", "159", "", "27.36409", "79.63111", "Asia/Kolkata"),("1271929", "Fatehganj West", "", "IN", "356", "", "36", "150", "", "28.4662", "79.30657", "Asia/Kolkata"),("1271934", "Fatehābād", "", "IN", "356", "", "10", "078", "", "29.51525", "75.45554", "Asia/Kolkata"),("1271936", "Fatehābād", "", "IN", "356", "", "36", "146", "", "27.02645", "78.3027", "Asia/Kolkata"),("1271939", "Farrukhnagar", "", "IN", "356", "", "10", "086", "", "28.44745", "76.82391", "Asia/Kolkata"),("1271940", "Farrukhnagar", "", "IN", "356", "", "40", "538", "", "17.07787", "78.20339", "Asia/Kolkata"),("1271942", "Farrukhābād", "", "IN", "356", "", "36", "159", "", "27.39134", "79.5793", "Asia/Kolkata"),("1271947", "Farīdpur", "", "IN", "356", "", "36", "150", "", "28.20997", "79.54149", "Asia/Kolkata"),("1271948", "Farīdnagar", "", "IN", "356", "", "36", "140", "", "28.76923", "77.62934", "Asia/Kolkata"),("1271949", "Farīdkot", "", "IN", "356", "", "23", "045", "", "30.67399", "74.75579", "Asia/Kolkata"),("1271951", "Farīdābād", "Фаридабад", "IN", "356", "", "10", "088", "", "28.41124", "77.31316", "Asia/Kolkata"),("1271954", "Farakka", "", "IN", "356", "", "28", "333", "", "24.81667", "87.9", "Asia/Kolkata"),("1271956", "Farah", "", "IN", "356", "", "36", "145", "", "27.32081", "77.76185", "Asia/Kolkata"),("1271965", "Fālākāta", "", "IN", "356", "", "28", "328", "", "26.51963", "89.20423", "Asia/Kolkata"),("1271975", "Faizpur", "", "IN", "356", "", "16", "499", "", "21.16766", "75.86006", "Asia/Kolkata"),("1271976", "Fyzābād", "Файзабад", "IN", "356", "", "36", "177", "", "26.77549", "82.15018", "Asia/Kolkata"),("1271984", "Ettaiyapuram", "", "IN", "356", "", "25", "627", "", "9.14405", "77.99066", "Asia/Kolkata"),("1271985", "Etikoppāka", "", "IN", "356", "", "02", "544", "", "17.5", "82.73333", "Asia/Kolkata"),("1271987", "Etāwah", "", "IN", "356", "", "36", "161", "", "26.77615", "79.02133", "Asia/Kolkata"),("1272001", "Erumaippatti", "", "IN", "356", "", "25", "609", "", "11.14555", "78.29095", "Asia/Kolkata"),("1272008", "Erraguntla", "", "IN", "356", "", "02", "551", "", "14.63853", "78.53974", "Asia/Kolkata"),("1272013", "Erode", "Брод", "IN", "356", "", "25", "610", "", "11.3428", "77.72741", "Asia/Kolkata"),("1272022", "Erāttupetta", "", "IN", "356", "", "13", "597", "", "9.68747", "76.77891", "Asia/Kolkata"),("1272023", "Eraniel", "", "IN", "356", "", "25", "629", "", "8.2025", "77.31538", "Asia/Kolkata"),("1272025", "Erandol", "", "IN", "356", "", "16", "499", "", "20.92206", "75.32641", "Asia/Kolkata"),("1272027", "Eral", "", "IN", "356", "", "25", "627", "", "8.62392", "78.02191", "Asia/Kolkata"),("1272045", "Emmiganūr", "", "IN", "356", "", "02", "552", "", "15.77203", "77.48345", "Asia/Kolkata"),("1272051", "Ellore", "", "IN", "356", "", "02", "546", "", "16.71311", "81.10437", "Asia/Kolkata"),("1272052", "Elūr", "", "IN", "356", "", "13", "595", "", "10.06667", "76.28333", "Asia/Kolkata"),("1272053", "Elumalai", "", "IN", "356", "", "25", "623", "", "9.86376", "77.69939", "Asia/Kolkata"),("1272061", "Ellenabad", "", "IN", "356", "", "10", "079", "", "29.45282", "74.66122", "Asia/Kolkata"),("1272074", "Elāyirampannai", "", "IN", "356", "", "25", "625", "", "9.27033", "77.82494", "Asia/Kolkata"),("1272084", "Elamanchili", "", "IN", "356", "", "02", "544", "", "17.54907", "82.85749", "Asia/Kolkata"),("1272101", "Egra", "", "IN", "356", "", "28", "345", "", "21.89947", "87.53794", "Asia/Kolkata"),("1272140", "Dwārka", "Дварка", "IN", "356", "", "09", "477", "", "22.23944", "68.96778", "Asia/Kolkata"),("1272156", "Dūsi", "", "IN", "356", "", "25", "606", "", "12.77574", "79.67892", "Asia/Kolkata"),("1272175", "Durgapur", "Дургапур", "IN", "356", "", "28", "335", "", "23.51583", "87.30801", "Asia/Kolkata"),("1272177", "Durgāpur", "", "IN", "356", "", "16", "509", "", "20.0054", "79.30273", "Asia/Kolkata"),("1272181", "Durg", "", "IN", "356", "", "37", "409", "", "21.19147", "81.27619", "Asia/Kolkata"),("1272201", "Dūngarpur", "", "IN", "356", "", "24", "124", "", "23.84306", "73.71466", "Asia/Kolkata"),("1272202", "Dungarpur", "", "IN", "356", "", "09", "481", "", "21.28777", "71.7556", "Asia/Kolkata"),("1272207", "Ganj Dundwāra", "", "IN", "356", "", "36", "202", "", "27.73308", "78.94119", "Asia/Kolkata"),("1272225", "Dumraon", "", "IN", "356", "", "34", "232", "", "25.55265", "84.15149", "Asia/Kolkata"),("1272229", "Dumra", "", "IN", "356", "", "34", "206", "", "26.56708", "85.5204", "Asia/Kolkata"),("1272237", "Dumka", "Думка", "IN", "356", "", "38", "362", "", "24.26778", "87.24855", "Asia/Kolkata"),("1272242", "Dum Duma", "", "IN", "356", "", "03", "309", "", "27.56884", "95.55664", "Asia/Kolkata"),("1272243", "Dam Dam", "", "IN", "356", "", "28", "337", "", "22.63341", "88.42286", "Asia/Kolkata"),("1272259", "Duliāgaon", "", "IN", "356", "", "03", "310", "", "27.37227", "95.30754", "Asia/Kolkata"),("1272277", "Dugda", "", "IN", "356", "", "38", "355", "", "23.74516", "86.17175", "Asia/Kolkata"),("1272302", "Dūdhi", "", "IN", "356", "", "36", "200", "", "24.21357", "83.24067", "Asia/Kolkata"),("1272307", "Dudhani", "", "IN", "356", "", "16", "526", "", "17.35792", "76.36688", "Asia/Kolkata"),("1272320", "Dubrājpur", "", "IN", "356", "", "28", "334", "", "23.7902", "87.37648", "Asia/Kolkata"),("1272358", "Dostpur", "", "IN", "356", "", "36", "179", "", "26.27486", "82.47091", "Asia/Kolkata"),("1272367", "Dornakal", "", "IN", "356", "", "40", "540", "", "17.44475", "80.14905", "Asia/Kolkata"),("1272375", "Dorāha", "", "IN", "356", "", "23", "041", "", "30.79953", "76.02355", "Asia/Kolkata"),("1272396", "Dongargarh", "", "IN", "356", "", "37", "408", "", "21.18893", "80.75459", "Asia/Kolkata"),("1272400", "Dongargaon", "", "IN", "356", "", "37", "408", "", "20.97172", "80.85077", "Asia/Kolkata"),("1272411", "Dondaicha", "", "IN", "356", "", "16", "498", "", "21.3236", "74.56804", "Asia/Kolkata"),("1272423", "Dombivli", "", "IN", "356", "", "16", "517", "", "19.21667", "73.08333", "Asia/Kolkata"),("1272444", "Doiwāla", "", "IN", "356", "", "39", "060", "", "30.17667", "78.11659", "Asia/Kolkata"),("1272446", "Dohrighāt", "", "IN", "356", "", "36", "192", "", "26.27217", "83.50916", "Asia/Kolkata"),("1272473", "Dod Ballāpur", "", "IN", "356", "", "19", "583", "", "13.29452", "77.53777", "Asia/Kolkata"),("1272476", "Doda", "", "IN", "356", "", "12", "016", "", "33.14916", "75.54746", "Asia/Kolkata"),("1272502", "Diu", "Диу", "IN", "356", "", "32", "494", "", "20.71405", "70.98224", "Asia/Kolkata"),("1272508", "Dispur", "", "IN", "356", "", "03", "322", "", "26.13564", "91.80069", "Asia/Kolkata"),("1272513", "Dīsa", "Дис", "IN", "356", "", "09", "469", "", "24.25612", "72.17928", "Asia/Kolkata"),("1272517", "Dirba", "", "IN", "356", "", "23", "053", "", "30.07222", "75.99607", "Asia/Kolkata"),("1272525", "Diphu", "", "IN", "356", "", "03", "314", "", "25.84341", "93.43116", "Asia/Kolkata"),("1272532", "Dīnhāta", "", "IN", "356", "", "28", "329", "", "26.13526", "89.46129", "Asia/Kolkata"),("1272540", "Dindori", "", "IN", "356", "", "35", "453", "", "22.94141", "81.07975", "Asia/Kolkata"),("1272543", "Dindigul", "Диндуккал", "IN", "356", "", "25", "612", "", "10.36896", "77.98036", "Asia/Kolkata"),("1272546", "Dīnānagar", "", "IN", "356", "", "23", "035", "", "32.13664", "75.47291", "Asia/Kolkata"),("1272552", "Dimāpur", "Димапур", "IN", "356", "", "20", "265", "", "25.91174", "93.7217", "Asia/Kolkata"),("1272587", "Diguvametta", "", "IN", "356", "", "02", "549", "", "15.39507", "78.8293", "Asia/Kolkata"),("1272596", "Digras", "", "IN", "356", "", "16", "510", "", "20.1035", "77.71846", "Asia/Kolkata"),("1272606", "Dīglūr", "", "IN", "356", "", "16", "511", "", "18.54829", "77.57695", "Asia/Kolkata"),("1272610", "Dighwāra", "", "IN", "356", "", "34", "219", "", "25.74434", "85.01003", "Asia/Kolkata"),("1272629", "Digboi", "", "IN", "356", "", "03", "309", "", "27.39321", "95.61839", "Asia/Kolkata"),("1272634", "Digapahandi", "", "IN", "356", "", "21", "388", "", "19.37275", "84.57184", "Asia/Kolkata"),("1272639", "Dīg", "", "IN", "356", "", "24", "105", "", "27.47188", "77.32564", "Asia/Kolkata"),("1272640", "Dīdwāna", "", "IN", "356", "", "24", "112", "", "27.40096", "74.57537", "Asia/Kolkata"),("1272646", "Dicholi", "", "IN", "356", "", "33", "585", "", "15.59319", "73.94571", "Asia/Kolkata"),("1272648", "Dibrugarh", "Дибругарх", "IN", "356", "", "03", "310", "", "27.47989", "94.90837", "Asia/Kolkata"),("1272653", "Dibai", "", "IN", "356", "", "36", "142", "", "28.20849", "78.26173", "Asia/Kolkata"),("1272657", "Diamond Harbour", "", "IN", "356", "", "28", "343", "", "22.19303", "88.18466", "Asia/Kolkata"),("1272660", "Dhuwaran", "", "IN", "356", "", "09", "482", "", "22.23779", "72.7591", "Asia/Kolkata"),("1272670", "Dhūri", "", "IN", "356", "", "23", "053", "", "30.36846", "75.86791", "Asia/Kolkata"),("1272674", "Dhupgāri", "", "IN", "356", "", "28", "328", "", "26.58904", "89.00732", "Asia/Kolkata"),("1272689", "Dhuliān", "", "IN", "356", "", "28", "333", "", "24.68127", "87.9535", "Asia/Kolkata"),("1272691", "Dhūlia", "Дхуле", "IN", "356", "", "16", "498", "", "20.9013", "74.77737", "Asia/Kolkata"),("1272694", "Dhuburi", "", "IN", "356", "", "03", "301", "", "26.01856", "89.98564", "Asia/Kolkata"),("1272699", "Dhrol", "", "IN", "356", "", "09", "477", "", "22.567", "70.41769", "Asia/Kolkata"),("1272701", "Dhrāngadhra", "", "IN", "356", "", "09", "475", "", "22.99167", "71.46793", "Asia/Kolkata"),("1272720", "Dhorāji", "", "IN", "356", "", "09", "476", "", "21.73359", "70.45004", "Asia/Kolkata"),("1272722", "Dhone", "", "IN", "356", "", "02", "552", "", "15.3952", "77.8715", "Asia/Kolkata"),("1272733", "Dholka", "", "IN", "356", "", "09", "474", "", "22.72732", "72.44128", "Asia/Kolkata"),("1272744", "Dhola", "", "IN", "356", "", "09", "481", "", "21.88129", "71.77269", "Asia/Kolkata"),("1272768", "Dhing", "", "IN", "356", "", "03", "305", "", "26.46793", "92.47336", "Asia/Kolkata"),("1272771", "Dhilwan", "", "IN", "356", "", "23", "036", "", "31.51432", "75.34574", "Asia/Kolkata"),("1272780", "Dhenkānāl", "", "IN", "356", "", "21", "383", "", "20.65744", "85.59693", "Asia/Kolkata"),("1272783", "Dhemāji", "", "IN", "356", "", "03", "308", "", "27.48333", "94.58333", "Asia/Kolkata"),("1272790", "Dhekiajuli", "", "IN", "356", "", "03", "306", "", "26.70367", "92.47808", "Asia/Kolkata"),("1272802", "Dhaurahra", "", "IN", "356", "", "36", "153", "", "27.99814", "81.08975", "Asia/Kolkata"),("1272805", "Dhaulpur", "", "IN", "356", "", "24", "106", "", "26.69286", "77.87968", "Asia/Kolkata"),("1272819", "Dhārūr", "", "IN", "356", "", "16", "523", "", "18.82017", "76.10937", "Asia/Kolkata"),("1272822", "Dhāruhera", "", "IN", "356", "", "10", "085", "", "28.20553", "76.79691", "Asia/Kolkata"),("1272832", "Dharamsala", "Дармсала", "IN", "356", "", "11", "024", "", "32.22006", "76.32013", "Asia/Kolkata"),("1272842", "Dharmavaram", "", "IN", "356", "", "02", "553", "", "14.41435", "77.72035", "Asia/Kolkata"),("1272847", "Dharmapuri", "", "IN", "356", "", "25", "630", "", "12.1277", "78.15794", "Asia/Kolkata"),("1272852", "Dharmanagar", "", "IN", "356", "", "26", "292", "", "24.36667", "92.16667", "Asia/Kolkata"),("1272856", "Dharmadam", "", "IN", "356", "", "13", "589", "", "11.77538", "75.46459", "Asia/Kolkata"),("1272857", "Dharmābād", "", "IN", "356", "", "16", "511", "", "18.89116", "77.8494", "Asia/Kolkata"),("1272860", "Dhāriwāl", "", "IN", "356", "", "23", "035", "", "31.95616", "75.32386", "Asia/Kolkata"),("1272861", "Dhāri", "", "IN", "356", "", "09", "480", "", "21.32855", "71.02645", "Asia/Kolkata"),("1272864", "Dhārchula", "", "IN", "356", "", "39", "062", "", "29.84707", "80.51951", "Asia/Kolkata"),("1272873", "Dharapuram", "", "IN", "356", "", "25", "633", "", "10.73828", "77.53223", "Asia/Kolkata"),("1272874", "Dharangaon", "", "IN", "356", "", "16", "499", "", "21.01187", "75.27407", "Asia/Kolkata"),("1272878", "Dharampuri", "", "IN", "356", "", "35", "438", "", "22.14951", "75.34439", "Asia/Kolkata"),("1272881", "Dharampur", "", "IN", "356", "", "09", "491", "", "20.53693", "73.17368", "Asia/Kolkata"),("1272892", "Dhār", "Дхар", "IN", "356", "", "35", "438", "", "22.59373", "75.29774", "Asia/Kolkata"),("1272902", "Dhanwār", "", "IN", "356", "", "38", "349", "", "24.41099", "85.98189", "Asia/Kolkata"),("1272962", "Dhanera", "", "IN", "356", "", "09", "469", "", "24.50967", "72.02343", "Asia/Kolkata"),("1272970", "Dhandhuka", "", "IN", "356", "", "09", "474", "", "22.38185", "71.98664", "Asia/Kolkata"),("1272979", "Dhanbād", "Дханбад", "IN", "356", "", "38", "354", "", "23.80199", "86.44324", "Asia/Kolkata"),("1272983", "Dhanaura", "", "IN", "356", "", "36", "137", "", "28.95912", "78.25629", "Asia/Kolkata"),("1272985", "Dhanaula", "", "IN", "356", "", "23", "054", "", "30.28216", "75.57341", "Asia/Kolkata"),("1272996", "Dhāna", "", "IN", "356", "", "35", "427", "", "23.74697", "78.86234", "Asia/Kolkata"),("1272997", "Dhamtari", "", "IN", "356", "", "37", "412", "", "20.70718", "81.54874", "Asia/Kolkata"),("1273002", "Dhāmpur", "", "IN", "356", "", "36", "134", "", "29.30883", "78.51083", "Asia/Kolkata"),("1273006", "Dhāmnod", "", "IN", "356", "", "35", "438", "", "22.20928", "75.47057", "Asia/Kolkata"),("1273033", "Dhali", "", "IN", "356", "", "25", "633", "", "10.50947", "77.18837", "Asia/Kolkata"),("1273043", "Dhāka", "", "IN", "356", "", "34", "204", "", "26.67479", "85.16698", "Asia/Kolkata"),("1273066", "Dewas", "", "IN", "356", "", "35", "437", "", "22.96585", "76.05526", "Asia/Kolkata"),("1273077", "Dewā", "", "IN", "356", "", "36", "176", "", "27.03621", "81.16692", "Asia/Kolkata"),("1273083", "Deoli", "", "IN", "356", "", "24", "122", "", "25.75728", "75.37991", "Asia/Kolkata"),("1273098", "Devgarh", "", "IN", "356", "", "24", "123", "", "25.52533", "73.90812", "Asia/Kolkata"),("1273104", "Devgadh Bāriya", "", "IN", "356", "", "09", "485", "", "22.70517", "73.90882", "Asia/Kolkata"),("1273109", "Devarkonda", "", "IN", "356", "", "40", "539", "", "16.69186", "78.92073", "Asia/Kolkata"),("1273123", "Devanhalli", "", "IN", "356", "", "19", "583", "", "13.24655", "77.71183", "Asia/Kolkata"),("1273128", "Devakottai", "", "IN", "356", "", "25", "622", "", "9.94704", "78.8233", "Asia/Kolkata"),("1273132", "Devadānappatti", "", "IN", "356", "", "25", "624", "", "10.14625", "77.64371", "Asia/Kolkata"),("1273136", "Deūlgaon Rāja", "", "IN", "356", "", "16", "500", "", "20.01757", "76.03755", "Asia/Kolkata"),("1273145", "Desūr", "", "IN", "356", "", "25", "606", "", "12.43727", "79.48145", "Asia/Kolkata"),("1273153", "Deshnoke", "", "IN", "356", "", "24", "101", "", "27.79836", "73.34297", "Asia/Kolkata"),("1273166", "Dergaon", "", "IN", "356", "", "03", "313", "", "26.7", "93.96667", "Asia/Kolkata"),("1273173", "Derā Nānak", "", "IN", "356", "", "23", "035", "", "32.03733", "75.02787", "Asia/Kolkata"),("1273181", "Depālpur", "", "IN", "356", "", "35", "439", "", "22.85095", "75.54224", "Asia/Kolkata"),("1273191", "Deori Khās", "", "IN", "356", "", "35", "427", "", "23.39017", "79.0163", "Asia/Kolkata"),("1273193", "Deoria", "", "IN", "356", "", "36", "190", "", "26.50167", "83.77936", "Asia/Kolkata"),("1273201", "Deori", "", "IN", "356", "", "37", "410", "", "21.45", "82.61667", "Asia/Kolkata"),("1273206", "Deoraniān", "", "IN", "356", "", "36", "150", "", "28.62989", "79.47648", "Asia/Kolkata"),("1273228", "Deoli", "", "IN", "356", "", "16", "504", "", "20.6492", "78.48023", "Asia/Kolkata"),("1273232", "Deolāli", "", "IN", "356", "", "16", "516", "", "19.94404", "73.83441", "Asia/Kolkata"),("1273246", "Deogarh", "", "IN", "356", "", "21", "373", "", "21.53768", "84.73372", "Asia/Kolkata"),("1273265", "Deoband", "Деобанде", "IN", "356", "", "36", "132", "", "29.69505", "77.67964", "Asia/Kolkata"),("1273272", "Denkanikota", "", "IN", "356", "", "25", "631", "", "12.5301", "77.78887", "Asia/Kolkata"),("1273287", "Delvāda", "", "IN", "356", "", "09", "479", "", "20.77544", "71.04646", "Asia/Kolkata"),("1273294", "Delhi", "Дели", "IN", "356", "", "07", "091", "", "28.65195", "77.23149", "Asia/Kolkata"),("1273304", "Dehu", "", "IN", "356", "", "16", "521", "", "18.71851", "73.76635", "Asia/Kolkata"),("1273309", "Dehri", "", "IN", "356", "", "34", "234", "", "24.90247", "84.18217", "Asia/Kolkata"),("1273313", "Dehra Dūn", "Дехрадуне", "IN", "356", "", "39", "060", "", "30.32443", "78.03392", "Asia/Kolkata"),("1273347", "Debīpur", "", "IN", "356", "", "28", "333", "", "24.25029", "88.61824", "Asia/Kolkata"),("1273367", "Davorlim", "", "IN", "356", "", "33", "586", "", "15.27221", "73.99242", "Asia/Kolkata"),("1273369", "Dausa", "Дауса", "IN", "356", "", "24", "109", "", "26.89", "76.33584", "Asia/Kolkata"),("1273371", "Daurāla", "", "IN", "356", "", "36", "138", "", "29.11344", "77.70467", "Asia/Kolkata"),("1273374", "Daund", "", "IN", "356", "", "16", "521", "", "18.46515", "74.58375", "Asia/Kolkata"),("1273379", "Daulatpur", "", "IN", "356", "", "28", "331", "", "25.32605", "88.32989", "Asia/Kolkata"),("1273390", "Daudnagar", "", "IN", "356", "", "34", "235", "", "25.03473", "84.40095", "Asia/Kolkata"),("1273397", "Dattāpur", "", "IN", "356", "", "16", "503", "", "20.78075", "78.1407", "Asia/Kolkata"),("1273403", "Datia", "", "IN", "356", "", "35", "422", "", "25.67312", "78.45908", "Asia/Kolkata"),("1273409", "Dātāganj", "", "IN", "356", "", "36", "149", "", "28.0253", "79.40819", "Asia/Kolkata"),("1273410", "Dasūya", "", "IN", "356", "", "23", "038", "", "31.81679", "75.6531", "Asia/Kolkata"),("1273416", "Dāsna", "", "IN", "356", "", "36", "140", "", "28.67736", "77.52252", "Asia/Kolkata"),("1273434", "Daryāpur", "", "IN", "356", "", "16", "503", "", "20.92489", "77.32644", "Asia/Kolkata"),("1273440", "Dārwha", "", "IN", "356", "", "16", "510", "", "20.31017", "77.77257", "Asia/Kolkata"),("1273467", "Dārjiling", "Дарджилинг", "IN", "356", "", "28", "327", "", "27.03333", "88.26667", "Asia/Kolkata"),("1273491", "Darbhanga", "Дарбханга", "IN", "356", "", "34", "215", "", "26.15216", "85.89707", "Asia/Kolkata"),("1273534", "Dankaur", "", "IN", "356", "", "36", "141", "", "28.35121", "77.55508", "Asia/Kolkata"),("1273574", "Dandeli", "", "IN", "356", "", "19", "563", "", "15.26667", "74.61667", "Asia/Kolkata"),("1273581", "Dinapore", "", "IN", "356", "", "34", "230", "", "25.63705", "85.04794", "Asia/Kolkata"),("1273587", "Damoh", "", "IN", "356", "", "35", "428", "", "23.83312", "79.4419", "Asia/Kolkata"),("1273593", "Dāmnagar", "", "IN", "356", "", "09", "480", "", "21.69232", "71.51747", "Asia/Kolkata"),("1273618", "Daman", "Даман", "IN", "356", "", "32", "495", "", "20.41431", "72.83236", "Asia/Kolkata"),("1273626", "Daltonganj", "", "IN", "356", "", "38", "358", "", "24.03971", "84.0658", "Asia/Kolkata"),("1273628", "Dalsingh Sarai", "", "IN", "356", "", "34", "221", "", "25.66795", "85.83636", "Asia/Kolkata"),("1273637", "Dalmau", "", "IN", "356", "", "36", "158", "", "26.06477", "81.0298", "Asia/Kolkata"),("1273642", "Dalkola", "", "IN", "356", "", "28", "330", "", "25.87577", "87.84009", "Asia/Kolkata"),("1273648", "Dalhousie", "", "IN", "356", "", "11", "023", "", "32.55219", "75.94663", "Asia/Kolkata"),("1273665", "Dākor", "Дакор", "IN", "356", "", "09", "483", "", "22.75268", "73.14967", "Asia/Kolkata"),("1273687", "Dohad", "", "IN", "356", "", "09", "485", "", "22.83283", "74.25986", "Asia/Kolkata"),("1273704", "Dahegām", "", "IN", "356", "", "09", "473", "", "23.16903", "72.82161", "Asia/Kolkata"),("1273708", "Dāhānu", "", "IN", "356", "", "16", "", "", "19.96778", "72.71263", "Asia/Kolkata"),("1273724", "Dādri", "", "IN", "356", "", "36", "141", "", "28.55257", "77.55403", "Asia/Kolkata"),("1273745", "Dabwāli", "", "IN", "356", "", "10", "079", "", "29.94906", "74.73832", "Asia/Kolkata"),("1273751", "Dabra", "", "IN", "356", "", "35", "421", "", "25.88572", "78.33221", "Asia/Kolkata"),("1273756", "Daboh", "", "IN", "356", "", "35", "420", "", "26.00239", "78.87658", "Asia/Kolkata"),("1273765", "Dābhol", "", "IN", "356", "", "16", "528", "", "17.58971", "73.18001", "Asia/Kolkata"),("1273766", "Dabhoi", "", "IN", "356", "", "09", "486", "", "22.18333", "73.43333", "Asia/Kolkata"),("1273780", "Cuttack", "Каттаке", "IN", "356", "", "21", "381", "", "20.46497", "85.87927", "Asia/Kolkata"),("1273784", "Curti", "", "IN", "356", "", "33", "585", "", "15.41667", "74.01667", "Asia/Kolkata"),("1273788", "Curchorem", "", "IN", "356", "", "33", "586", "", "15.26349", "74.10875", "Asia/Kolkata"),("1273793", "Cuncolim", "", "IN", "356", "", "33", "586", "", "15.1773", "73.99392", "Asia/Kolkata"),("1273795", "Cumbum", "", "IN", "356", "", "02", "549", "", "15.58171", "79.11059", "Asia/Kolkata"),("1273800", "Cuddapah", "", "IN", "356", "", "02", "551", "", "14.47995", "78.82346", "Asia/Kolkata"),("1273802", "Cuddalore", "Куддалоре", "IN", "356", "", "25", "617", "", "11.74629", "79.76436", "Asia/Kolkata"),("1273817", "Cortalim", "", "IN", "356", "", "33", "586", "", "15.40247", "73.90881", "Asia/Kolkata"),("1273834", "Coondapoor", "", "IN", "356", "", "19", "569", "", "13.63126", "74.6902", "Asia/Kolkata"),("1273847", "Colva", "", "IN", "356", "", "33", "586", "", "15.27976", "73.92285", "Asia/Kolkata"),("1273848", "Colovale", "", "IN", "356", "", "33", "585", "", "15.63522", "73.82426", "Asia/Kolkata"),("1273850", "Colonelganj", "", "IN", "356", "", "36", "183", "", "27.13432", "81.69868", "Asia/Kolkata"),("1273856", "Colgong", "", "IN", "356", "", "34", "224", "", "25.26328", "87.23264", "Asia/Kolkata"),("1273858", "Calangute", "Калангут", "IN", "356", "", "33", "", "", "15.5439", "73.7553", "Asia/Kolkata"),("1273865", "Coimbatore", "Коимбатур", "IN", "356", "", "25", "632", "", "11.00555", "76.96612", "Asia/Kolkata"),("1273874", "Cochin", "Кочин", "IN", "356", "", "13", "595", "", "9.93988", "76.26022", "Asia/Kolkata"),("1273880", "Clement Town", "", "IN", "356", "", "39", "060", "", "30.26361", "78.00862", "Asia/Kolkata"),("1273892", "Chūru", "", "IN", "356", "", "24", "102", "", "28.30415", "74.96718", "Asia/Kolkata"),("1273909", "Churāchāndpur", "", "IN", "356", "", "17", "274", "", "24.33353", "93.66999", "Asia/Kolkata"),("1273923", "Chunār", "", "IN", "356", "", "36", "199", "", "25.12776", "82.8821", "Asia/Kolkata"),("1273943", "Vikāsnagar", "", "IN", "356", "", "39", "060", "", "30.46944", "77.77275", "Asia/Kolkata"),("1273960", "Chotila", "", "IN", "356", "", "09", "475", "", "22.42347", "71.19641", "Asia/Kolkata"),("1273978", "Chorhat", "", "IN", "356", "", "35", "462", "", "24.42743", "81.66948", "Asia/Kolkata"),("1273992", "Chopda", "", "IN", "356", "", "16", "499", "", "21.24578", "75.29946", "Asia/Kolkata"),("1273993", "Chopan", "", "IN", "356", "", "36", "200", "", "24.51954", "83.02287", "Asia/Kolkata"),("1274006", "Cholapuram", "", "IN", "356", "", "25", "628", "", "9.35193", "77.56839", "Asia/Kolkata"),("1274020", "Chodavaram", "", "IN", "356", "", "02", "544", "", "17.82884", "82.93526", "Asia/Kolkata"),("1274021", "Rampachodavaram", "", "IN", "356", "", "02", "545", "", "17.44088", "81.77558", "Asia/Kolkata"),("1274032", "Chittūr", "", "IN", "356", "", "13", "593", "", "10.69967", "76.7471", "Asia/Kolkata"),("1274040", "Chittaurgarh", "", "IN", "356", "", "24", "126", "", "24.88963", "74.62403", "Asia/Kolkata"),("1274043", "Chittaranjan", "Читтаранджан", "IN", "356", "", "28", "335", "", "23.85681", "86.90324", "Asia/Kolkata"),("1274055", "Chittarkonda", "", "IN", "356", "", "21", "399", "", "18.12533", "82.1089", "Asia/Kolkata"),("1274056", "Chitradurga", "Читрадурга", "IN", "356", "", "19", "566", "", "14.22262", "76.40038", "Asia/Kolkata"),("1274077", "Chītāpur", "", "IN", "356", "", "19", "579", "", "17.12357", "77.0824", "Asia/Kolkata"),("1274099", "Chirgaon", "", "IN", "356", "", "36", "166", "", "25.57198", "78.81432", "Asia/Kolkata"),("1274102", "Chidawa", "", "IN", "356", "", "24", "103", "", "28.23937", "75.64035", "Asia/Kolkata"),("1274106", "Chīrāla", "", "IN", "356", "", "02", "549", "", "15.82385", "80.35219", "Asia/Kolkata"),("1274116", "Chīpurupalle", "", "IN", "356", "", "02", "542", "", "18.31142", "83.56846", "Asia/Kolkata"),("1274119", "Chiplūn", "", "IN", "356", "", "16", "528", "", "17.53339", "73.50935", "Asia/Kolkata"),("1274129", "Chintāmani", "Чинтамани", "IN", "356", "", "19", "582", "", "13.40051", "78.05172", "Asia/Kolkata"),("1274146", "Chinna Salem", "", "IN", "356", "", "25", "607", "", "11.63325", "78.87223", "Asia/Kolkata"),("1274151", "Chinnamanūr", "", "IN", "356", "", "25", "624", "", "9.83999", "77.38109", "Asia/Kolkata"),("1274169", "Chincholi", "", "IN", "356", "", "19", "579", "", "17.46508", "77.41874", "Asia/Kolkata"),("1274172", "Chinchinim", "", "IN", "356", "", "33", "586", "", "15.21447", "73.97555", "Asia/Kolkata"),("1274175", "Chinchani", "", "IN", "356", "", "16", "517", "", "19.87458", "72.6851", "Asia/Kolkata"),("1274195", "Chillupār", "", "IN", "356", "", "36", "188", "", "26.28221", "83.5064", "Asia/Kolkata"),("1274213", "Chilakalūrupet", "", "IN", "356", "", "02", "548", "", "16.08987", "80.16705", "Asia/Kolkata"),("1274218", "Chikodi", "", "IN", "356", "", "19", "555", "", "16.42898", "74.58591", "Asia/Kolkata"),("1274219", "Chiknāyakanhalli", "", "IN", "356", "", "19", "571", "", "13.41609", "76.62063", "Asia/Kolkata"),("1274220", "Chikmagalūr", "", "IN", "356", "", "19", "570", "", "13.32231", "75.774", "Asia/Kolkata"),("1274229", "Chikitigarh", "", "IN", "356", "", "21", "388", "", "19.20233", "84.6145", "Asia/Kolkata"),("1274235", "Chikhli", "", "IN", "356", "", "09", "490", "", "20.75751", "73.06268", "Asia/Kolkata"),("1274237", "Chikhli", "", "IN", "356", "", "16", "500", "", "20.35046", "76.25774", "Asia/Kolkata"),("1274243", "Chik Ballāpur", "", "IN", "356", "", "19", "582", "", "13.43512", "77.72787", "Asia/Kolkata"),("1274256", "Chidambaram", "Чидамбарам", "IN", "356", "", "25", "617", "", "11.39907", "79.69113", "Asia/Kolkata"),("1274265", "Chicholi", "", "IN", "356", "", "16", "506", "", "21.46926", "79.70151", "Asia/Kolkata"),("1274267", "Chichli", "", "IN", "356", "", "35", "452", "", "22.83363", "78.82611", "Asia/Kolkata"),("1274270", "Chicalim", "", "IN", "356", "", "33", "586", "", "15.39835", "73.84216", "Asia/Kolkata"),("1274278", "Chhuīkhadān", "", "IN", "356", "", "37", "408", "", "21.52316", "80.99788", "Asia/Kolkata"),("1274284", "Chhoti Sādri", "", "IN", "356", "", "24", "131", "", "24.38145", "74.7012", "Asia/Kolkata"),("1274285", "Chhota Udepur", "", "IN", "356", "", "09", "486", "", "22.30401", "74.0158", "Asia/Kolkata"),("1274304", "Chhindwāra", "", "IN", "356", "", "35", "455", "", "22.05697", "78.93958", "Asia/Kolkata"),("1274315", "Chhibrāmau", "", "IN", "356", "", "36", "160", "", "27.14872", "79.50078", "Asia/Kolkata"),("1274337", "Chhatarpur", "", "IN", "356", "", "35", "425", "", "24.9177", "79.58871", "Asia/Kolkata"),("1274342", "Chhātāpur", "", "IN", "356", "", "34", "208", "", "26.21965", "87.00479", "Asia/Kolkata"),("1274343", "Chhāta", "", "IN", "356", "", "36", "145", "", "27.72374", "77.5081", "Asia/Kolkata"),("1274346", "Chharra", "", "IN", "356", "", "36", "143", "", "27.9247", "78.40102", "Asia/Kolkata"),("1274351", "Chhaprauli", "", "IN", "356", "", "36", "139", "", "29.20989", "77.17454", "Asia/Kolkata"),("1274353", "Chāpra", "", "IN", "356", "", "34", "219", "", "25.78031", "84.74709", "Asia/Kolkata"),("1274359", "Chhāpar", "", "IN", "356", "", "24", "102", "", "27.819", "74.43936", "Asia/Kolkata"),("1274369", "Chhala", "", "IN", "356", "", "09", "473", "", "23.30779", "72.77404", "Asia/Kolkata"),("1274380", "Chhachhrauli", "", "IN", "356", "", "10", "071", "", "30.24492", "77.36027", "Asia/Kolkata"),("1274381", "Chhabra", "", "IN", "356", "", "24", "128", "", "24.66472", "76.84379", "Asia/Kolkata"),("1274383", "Cheyyur", "", "IN", "356", "", "25", "604", "", "12.34948", "80.00304", "Asia/Kolkata"),("1274389", "Chettipālaiyam", "", "IN", "356", "", "25", "632", "", "10.91209", "77.03762", "Asia/Kolkata"),("1274394", "Chetput", "", "IN", "356", "", "25", "603", "", "13.07", "80.24083", "Asia/Kolkata"),("1274406", "Cherrapunji", "", "IN", "356", "", "18", "298", "", "25.30089", "91.69619", "Asia/Kolkata"),("1274422", "Chennimalai", "", "IN", "356", "", "25", "610", "", "11.16394", "77.60414", "Asia/Kolkata"),("1274428", "Chengannūr", "", "IN", "356", "", "13", "598", "", "9.31575", "76.61513", "Asia/Kolkata"),("1274429", "Chengam", "", "IN", "356", "", "25", "606", "", "12.30889", "78.79137", "Asia/Kolkata"),("1274430", "Chingleput", "", "IN", "356", "", "25", "604", "", "12.69184", "79.97661", "Asia/Kolkata"),("1274450", "Chēlakara", "", "IN", "356", "", "13", "594", "", "10.69289", "76.34387", "Asia/Kolkata"),("1274457", "Chechat", "", "IN", "356", "", "24", "127", "", "24.76667", "75.88333", "Asia/Kolkata"),("1274468", "Chetwayi", "", "IN", "356", "", "13", "", "", "10.52885", "76.04793", "Asia/Kolkata"),("1274532", "Chaksu", "", "IN", "356", "", "24", "110", "", "26.6051", "75.94814", "Asia/Kolkata"),("1274533", "Chatrapur", "", "IN", "356", "", "21", "388", "", "19.35574", "84.98359", "Asia/Kolkata"),("1274536", "Chatra", "", "IN", "356", "", "38", "347", "", "24.20376", "84.87032", "Asia/Kolkata"),("1274553", "Chās", "Час", "IN", "356", "", "38", "355", "", "23.63556", "86.16712", "Asia/Kolkata"),("1274560", "Charthāwal", "", "IN", "356", "", "36", "133", "", "29.54687", "77.59438", "Asia/Kolkata"),("1274571", "Charkhi Dādri", "", "IN", "356", "", "10", "081", "", "28.59166", "76.27161", "Asia/Kolkata"),("1274574", "Charkhāri", "", "IN", "356", "", "36", "169", "", "25.40304", "79.74877", "Asia/Kolkata"),("1274618", "Chāpar", "", "IN", "356", "", "03", "301", "", "26.27266", "90.44556", "Asia/Kolkata"),("1274640", "Channarāyapatna", "", "IN", "356", "", "19", "574", "", "12.90642", "76.38775", "Asia/Kolkata"),("1274641", "Channapatna", "", "IN", "356", "", "19", "584", "", "12.65143", "77.20672", "Asia/Kolkata"),("1274642", "Channagiri", "", "IN", "356", "", "19", "567", "", "14.02399", "75.92577", "Asia/Kolkata"),("1274664", "Changanācheri", "", "IN", "356", "", "13", "597", "", "9.44203", "76.53604", "Asia/Kolkata"),("1274673", "Chāndor", "", "IN", "356", "", "16", "516", "", "20.3306", "74.24467", "Asia/Kolkata"),("1274674", "Chāndūr Bāzār", "", "IN", "356", "", "16", "503", "", "21.23853", "77.74713", "Asia/Kolkata"),("1274675", "Chāndūr", "", "IN", "356", "", "16", "503", "", "20.81408", "77.98015", "Asia/Kolkata"),("1274676", "Chāndur", "", "IN", "356", "", "16", "509", "", "19.73444", "79.17167", "Asia/Kolkata"),("1274693", "Chānda", "Чандрапур", "IN", "356", "", "16", "509", "", "19.95076", "79.29523", "Asia/Kolkata"),("1274699", "Chandrakona", "", "IN", "356", "", "28", "344", "", "22.73333", "87.51667", "Asia/Kolkata"),("1274714", "Chāndpur", "", "IN", "356", "", "36", "134", "", "29.13489", "78.27187", "Asia/Kolkata"),("1274735", "Chandla", "", "IN", "356", "", "35", "425", "", "25.07148", "80.19294", "Asia/Kolkata"),("1274746", "Chandigarh", "Чандигарх", "IN", "356", "", "05", "055", "", "30.73629", "76.7884", "Asia/Kolkata"),("1274747", "Chandia", "", "IN", "356", "", "35", "431", "", "23.65647", "80.70911", "Asia/Kolkata"),("1274755", "Chanderi", "Чандери", "IN", "356", "", "35", "459", "", "24.71312", "78.13809", "Asia/Kolkata"),("1274761", "Chāndbāli", "", "IN", "356", "", "21", "378", "", "20.77519", "86.74139", "Asia/Kolkata"),("1274767", "Chanduasi", "", "IN", "356", "", "36", "135", "", "28.45178", "78.78277", "Asia/Kolkata"),("1274770", "Chandauli", "", "IN", "356", "", "36", "196", "", "25.25803", "83.26825", "Asia/Kolkata"),("1274784", "Chandannagar", "Чанданнагар", "IN", "356", "", "28", "338", "", "22.86225", "88.36796", "Asia/Kolkata"),("1274807", "Chānasma", "", "IN", "356", "", "09", "470", "", "23.71472", "72.11279", "Asia/Kolkata"),("1274821", "Chamrajnagar", "", "IN", "356", "", "19", "578", "", "11.92312", "76.93949", "Asia/Kolkata"),("1274822", "Chāmpua", "", "IN", "356", "", "21", "375", "", "22.06734", "85.66463", "Asia/Kolkata"),("1274834", "Chāmpāhāti", "", "IN", "356", "", "28", "343", "", "22.40026", "88.49209", "Asia/Kolkata"),("1274837", "Chāmpa", "", "IN", "356", "", "37", "405", "", "22.03532", "82.64234", "Asia/Kolkata"),("1274848", "Chamba", "", "IN", "356", "", "11", "023", "", "32.55531", "76.12647", "Asia/Kolkata"),("1274861", "Challapalle", "", "IN", "356", "", "02", "547", "", "16.11756", "80.93139", "Asia/Kolkata"),("1274862", "Challakere", "", "IN", "356", "", "19", "566", "", "14.318", "76.65165", "Asia/Kolkata"),("1274868", "Chālisgaon", "", "IN", "356", "", "16", "499", "", "20.45781", "75.01596", "Asia/Kolkata"),("1274874", "Chalāla", "", "IN", "356", "", "09", "480", "", "21.41073", "71.16621", "Asia/Kolkata"),("1274881", "Chākuliā", "", "IN", "356", "", "38", "357", "", "22.48301", "86.71793", "Asia/Kolkata"),("1274890", "Chakradharpur", "", "IN", "356", "", "38", "368", "", "22.67626", "85.62906", "Asia/Kolkata"),("1274896", "Chaklāsi", "", "IN", "356", "", "09", "483", "", "22.6532", "72.94497", "Asia/Kolkata"),("1274899", "Chākia", "", "IN", "356", "", "34", "204", "", "26.41598", "85.04665", "Asia/Kolkata"),("1274900", "Chakia", "", "IN", "356", "", "36", "196", "", "25.04891", "83.22155", "Asia/Kolkata"),("1274914", "Chākan", "", "IN", "356", "", "16", "521", "", "18.76059", "73.86351", "Asia/Kolkata"),("1274927", "Chail", "", "IN", "356", "", "36", "174", "", "25.42654", "81.63198", "Asia/Kolkata"),("1274928", "Chāībāsa", "", "IN", "356", "", "38", "368", "", "22.54825", "85.80458", "Asia/Kolkata"),("1274954", "Chābua", "", "IN", "356", "", "03", "310", "", "27.48253", "95.17451", "Asia/Kolkata"),("1274961", "Cavelossim", "", "IN", "356", "IN", "33", "586", "", "15.17255", "73.94194", "Asia/Kolkata"),("1274974", "Carapur", "", "IN", "356", "", "33", "585", "", "15.56588", "73.98713", "Asia/Kolkata"),("1274984", "Canning", "", "IN", "356", "", "28", "343", "", "22.31453", "88.66248", "Asia/Kolkata"),("1274987", "Cannanore", "Кананорском", "IN", "356", "", "13", "589", "", "11.86752", "75.35763", "Asia/Kolkata"),("1274989", "Candolim", "", "IN", "356", "", "33", "585", "", "15.51807", "73.76259", "Asia/Kolkata"),("1275004", "Kolkata", "Колката", "IN", "356", "", "28", "342", "", "22.56263", "88.36304", "Asia/Kolkata"),("1275016", "Byādgi", "", "IN", "356", "", "19", "564", "", "14.67325", "75.4868", "Asia/Kolkata"),("1275019", "Buxar", "", "IN", "356", "", "34", "232", "", "25.57548", "83.98043", "Asia/Kolkata"),("1275050", "Burla", "", "IN", "356", "", "21", "372", "", "21.50976", "83.87259", "Asia/Kolkata"),("1275053", "Būriya", "", "IN", "356", "", "10", "071", "", "30.15911", "77.35814", "Asia/Kolkata"),("1275066", "Burhar", "", "IN", "356", "", "35", "460", "", "23.21494", "81.53204", "Asia/Kolkata"),("1275068", "Burhānpur", "", "IN", "356", "", "35", "467", "", "21.30868", "76.23026", "Asia/Kolkata"),("1275097", "Būndu", "", "IN", "356", "", "38", "364", "", "23.16139", "85.58925", "Asia/Kolkata"),("1275103", "Būndi", "Бунди", "IN", "356", "", "24", "121", "", "25.43855", "75.63735", "Asia/Kolkata"),("1275117", "Buldāna", "", "IN", "356", "", "16", "500", "", "20.52933", "76.18457", "Asia/Kolkata"),("1275120", "Bulandshahr", "Буландшахре", "IN", "356", "", "36", "142", "", "28.40392", "77.85773", "Asia/Kolkata"),("1275132", "Buguda", "", "IN", "356", "", "21", "388", "", "19.80806", "84.79084", "Asia/Kolkata"),("1275147", "Budhlāda", "", "IN", "356", "", "23", "047", "", "29.92799", "75.56205", "Asia/Kolkata"),("1275152", "Budhāna", "", "IN", "356", "", "36", "133", "", "29.28805", "77.47534", "Asia/Kolkata"),("1275163", "Budaun", "", "IN", "356", "", "36", "149", "", "28.03811", "79.12668", "Asia/Kolkata"),("1275194", "Brājarājnagar", "", "IN", "356", "", "21", "371", "", "21.81667", "83.91667", "Asia/Kolkata"),("1275198", "Brahmapur", "Берхампур", "IN", "356", "", "21", "388", "", "19.31151", "84.7929", "Asia/Kolkata"),("1275218", "Botād", "", "IN", "356", "", "09", "481", "", "22.16917", "71.66671", "Asia/Kolkata"),("1275230", "Borsad", "", "IN", "356", "", "09", "482", "", "22.40788", "72.89817", "Asia/Kolkata"),("1275248", "Borivli", "", "IN", "356", "", "16", "518", "", "19.23496", "72.85976", "Asia/Kolkata"),("1275321", "Bongaigaon", "", "IN", "356", "", "03", "320", "", "26.47703", "90.55815", "Asia/Kolkata"),("1275334", "Bomdila", "", "IN", "356", "", "30", "246", "", "27.26475", "92.42472", "Asia/Kolkata"),("1275339", "Mumbai", "Мумбаи", "IN", "356", "", "16", "518", "", "19.07283", "72.88261", "Asia/Kolkata"),("1275346", "Bolpur", "", "IN", "356", "", "28", "334", "", "23.66278", "87.69695", "Asia/Kolkata"),("1275354", "Bolānīkhodān", "", "IN", "356", "", "21", "375", "", "22.11312", "85.33645", "Asia/Kolkata"),("1275362", "Bokāro", "Бокаро", "IN", "356", "", "38", "355", "", "23.78732", "85.95622", "Asia/Kolkata"),("1275363", "Bokākhāt", "", "IN", "356", "", "03", "313", "", "26.64018", "93.60052", "Asia/Kolkata");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("1275364", "Bokajān", "", "IN", "356", "", "03", "314", "", "26.02131", "93.77945", "Asia/Kolkata"),("1275368", "Boisar", "", "IN", "356", "", "16", "517", "", "19.80362", "72.75598", "Asia/Kolkata"),("1275384", "Bodri", "", "IN", "356", "", "35", "460", "", "23.16524", "81.43262", "Asia/Kolkata"),("1275388", "Bodināyakkanūr", "", "IN", "356", "", "25", "624", "", "10.01171", "77.34976", "Asia/Kolkata"),("1275389", "Buddh Gaya", "Бодх-Гая", "IN", "356", "", "34", "236", "", "24.69808", "84.9869", "Asia/Kolkata"),("1275391", "Bodhan", "", "IN", "356", "", "40", "533", "", "18.66208", "77.88581", "Asia/Kolkata"),("1275406", "Bobbili", "", "IN", "356", "", "02", "543", "", "18.57366", "83.35925", "Asia/Kolkata"),("1275426", "Bithūr", "", "IN", "356", "", "36", "164", "", "26.60664", "80.27098", "Asia/Kolkata"),("1275435", "Biswān", "", "IN", "356", "", "36", "154", "", "27.49581", "80.99618", "Asia/Kolkata"),("1275441", "Bissāu", "Бисау", "IN", "356", "", "24", "103", "", "28.24737", "75.07666", "Asia/Kolkata"),("1275462", "Bishnupur", "Бишнупур", "IN", "356", "", "28", "339", "", "23.0738", "87.31991", "Asia/Kolkata"),("1275466", "Bishnāh", "", "IN", "356", "", "12", "021", "", "32.6106", "74.85557", "Asia/Kolkata"),("1275474", "Bisenda Buzurg", "", "IN", "356", "", "36", "170", "", "25.4035", "80.61889", "Asia/Kolkata"),("1275476", "Bisauli", "", "IN", "356", "", "36", "149", "", "28.30772", "78.93678", "Asia/Kolkata"),("1275481", "Bīsalpur", "", "IN", "356", "", "36", "151", "", "28.29253", "79.80472", "Asia/Kolkata"),("1275488", "Birūr", "", "IN", "356", "", "19", "570", "", "13.59723", "75.97167", "Asia/Kolkata"),("1275499", "Bīrpur", "", "IN", "356", "", "34", "208", "", "26.50823", "87.01194", "Asia/Kolkata"),("1275506", "Birmitrapur", "", "IN", "356", "", "21", "374", "", "22.4", "84.76667", "Asia/Kolkata"),("1275526", "Birbhaddar", "", "IN", "356", "", "39", "060", "", "30.0712", "78.28189", "Asia/Kolkata"),("1275558", "Binka", "", "IN", "356", "", "21", "392", "", "21.02626", "83.81197", "Asia/Kolkata"),("1275572", "Bindki", "", "IN", "356", "", "36", "172", "", "26.03613", "80.57617", "Asia/Kolkata"),("1275582", "Etāwa", "", "IN", "356", "", "35", "427", "", "24.18351", "78.20289", "Asia/Kolkata"),("1275589", "Bilthra", "", "IN", "356", "", "36", "193", "", "26.12705", "83.89148", "Asia/Kolkata"),("1275590", "Bilsi", "", "IN", "356", "", "36", "149", "", "28.12941", "78.9109", "Asia/Kolkata"),("1275593", "Bilsanda", "", "IN", "356", "", "36", "151", "", "28.24341", "79.95135", "Asia/Kolkata"),("1275601", "Biloli", "", "IN", "356", "", "16", "511", "", "18.77385", "77.72463", "Asia/Kolkata"),("1275609", "Bilkha", "", "IN", "356", "", "09", "479", "", "21.4415", "70.60063", "Asia/Kolkata"),("1275610", "Bilimora", "", "IN", "356", "", "09", "490", "", "20.76957", "72.96134", "Asia/Kolkata"),("1275614", "Bilhaur", "", "IN", "356", "", "36", "164", "", "26.84345", "80.06388", "Asia/Kolkata"),("1275618", "Bilgrām", "", "IN", "356", "", "36", "155", "", "27.17509", "80.03201", "Asia/Kolkata"),("1275619", "Bilgi", "", "IN", "356", "", "19", "556", "", "16.34714", "75.61804", "Asia/Kolkata"),("1275631", "Bilaspur", "", "IN", "356", "", "11", "030", "", "31.33027", "76.75663", "Asia/Kolkata"),("1275633", "Bilāspur", "", "IN", "356", "", "10", "071", "", "30.3045", "77.30424", "Asia/Kolkata"),("1275634", "Bīlāspur", "", "IN", "356", "", "36", "136", "", "28.88655", "79.2703", "Asia/Kolkata"),("1275635", "Bīlāspur", "", "IN", "356", "", "36", "141", "", "28.39128", "77.62421", "Asia/Kolkata"),("1275637", "Bilāspur", "Биласпура", "IN", "356", "", "37", "406", "", "22.08005", "82.15543", "Asia/Kolkata"),("1275641", "Bilāsipāra", "", "IN", "356", "", "03", "301", "", "26.23285", "90.2341", "Asia/Kolkata"),("1275645", "Bilariāganj", "", "IN", "356", "", "36", "191", "", "26.19593", "83.2269", "Asia/Kolkata"),("1275646", "Bilāri", "", "IN", "356", "", "36", "135", "", "28.62146", "78.80361", "Asia/Kolkata"),("1275647", "Bilāra", "", "IN", "356", "", "24", "113", "", "26.18067", "73.7055", "Asia/Kolkata"),("1275655", "Bikramganj", "", "IN", "356", "", "34", "234", "", "25.21073", "84.25508", "Asia/Kolkata"),("1275661", "Bīkāpur", "", "IN", "356", "", "36", "177", "", "26.59534", "82.13272", "Asia/Kolkata"),("1275665", "Bīkaner", "Биканер", "IN", "356", "", "24", "101", "", "28.01762", "73.31495", "Asia/Kolkata"),("1275674", "Bijrauni", "", "IN", "356", "", "35", "423", "", "24.93296", "77.64352", "Asia/Kolkata"),("1275679", "Bijnor", "Биджнор", "IN", "356", "", "36", "134", "", "29.373", "78.13636", "Asia/Kolkata"),("1275682", "Bijni", "", "IN", "356", "", "03", "320", "", "26.49588", "90.70298", "Asia/Kolkata"),("1275692", "Bijbehara", "", "IN", "356", "", "12", "014", "", "33.79378", "75.107", "Asia/Kolkata"),("1275694", "Bijāwar", "", "IN", "356", "", "35", "425", "", "24.62351", "79.48994", "Asia/Kolkata"),("1275701", "Bijapur", "Биджапур", "IN", "356", "", "19", "557", "", "16.82442", "75.71537", "Asia/Kolkata"),("1275713", "Bihpuriāgaon", "", "IN", "356", "", "03", "307", "", "27.01718", "93.91673", "Asia/Kolkata"),("1275716", "Bihār Sharīf", "", "IN", "356", "", "34", "229", "", "25.20084", "85.52389", "Asia/Kolkata"),("1275719", "Bihārīganj", "", "IN", "356", "", "34", "213", "", "25.73415", "86.98837", "Asia/Kolkata"),("1275722", "Bīghāpur Khurd", "", "IN", "356", "", "36", "156", "", "26.34734", "80.65698", "Asia/Kolkata"),("1275732", "Bidhūna", "", "IN", "356", "", "36", "162", "", "26.80172", "79.50829", "Asia/Kolkata"),("1275738", "Bīdar", "Бидар", "IN", "356", "", "19", "558", "", "17.91331", "77.53011", "Asia/Kolkata"),("1275762", "Biaora", "", "IN", "356", "", "35", "442", "", "23.86667", "76.91667", "Asia/Kolkata"),("1275768", "Bhuvanagiri", "", "IN", "356", "", "25", "617", "", "11.44154", "79.64568", "Asia/Kolkata"),("1275778", "Bhusāval", "", "IN", "356", "", "16", "499", "", "21.04365", "75.78506", "Asia/Kolkata"),("1275803", "Bhuma", "", "IN", "356", "", "24", "111", "", "27.78333", "74.93333", "Asia/Kolkata"),("1275804", "Bhūm", "", "IN", "356", "", "16", "525", "", "18.45908", "75.65877", "Asia/Kolkata"),("1275812", "Bhuj", "Бхудж", "IN", "356", "", "09", "468", "", "23.25397", "69.66928", "Asia/Kolkata"),("1275814", "Bhudgaon", "", "IN", "356", "", "16", "531", "", "16.90742", "74.59954", "Asia/Kolkata"),("1275817", "Bhubaneshwar", "Бхубанешвар", "IN", "356", "", "21", "386", "", "20.27241", "85.83385", "Asia/Kolkata"),("1275818", "Bhuban", "", "IN", "356", "", "21", "383", "", "20.88197", "85.83334", "Asia/Kolkata"),("1275826", "Bhowali", "", "IN", "356", "", "39", "066", "", "29.38985", "79.50481", "Asia/Kolkata"),("1275836", "Bhor", "", "IN", "356", "", "16", "521", "", "18.14861", "73.84336", "Asia/Kolkata"),("1275841", "Bhopal", "Бхопал", "IN", "356", "", "35", "444", "", "23.25469", "77.40289", "Asia/Kolkata"),("1275848", "Bhongīr", "", "IN", "356", "", "40", "539", "", "17.51544", "78.88563", "Asia/Kolkata"),("1275849", "Bhongaon", "", "IN", "356", "", "36", "148", "", "27.25515", "79.18118", "Asia/Kolkata"),("1275859", "Bhulath Gharbi", "", "IN", "356", "", "23", "036", "", "31.54279", "75.50755", "Asia/Kolkata"),("1275866", "Bhojudih", "", "IN", "356", "", "38", "354", "", "23.63962", "86.44105", "Asia/Kolkata"),("1275882", "Bhogpur", "", "IN", "356", "", "23", "037", "", "31.55442", "75.64271", "Asia/Kolkata"),("1275899", "Bhiwāni", "", "IN", "356", "", "10", "081", "", "28.79304", "76.13968", "Asia/Kolkata"),("1275901", "Bhiwandi", "", "IN", "356", "", "16", "517", "", "19.30023", "73.05881", "Asia/Kolkata"),("1275905", "Bhitarwār", "", "IN", "356", "", "35", "421", "", "25.79216", "78.11085", "Asia/Kolkata"),("1275920", "Bhīnmāl", "", "IN", "356", "", "24", "116", "", "24.99944", "72.27141", "Asia/Kolkata"),("1275921", "Bhinga", "", "IN", "356", "", "36", "181", "", "27.70283", "81.9343", "Asia/Kolkata"),("1275925", "Bhindār", "", "IN", "356", "", "24", "130", "", "24.50235", "74.18551", "Asia/Kolkata"),("1275926", "Bhind", "", "IN", "356", "", "35", "420", "", "26.56671", "78.78728", "Asia/Kolkata"),("1275930", "Bhīmunipatnam", "", "IN", "356", "", "02", "544", "", "17.89017", "83.45203", "Asia/Kolkata"),("1275931", "Bhīm Tāl", "", "IN", "356", "", "39", "066", "", "29.34447", "79.56336", "Asia/Kolkata"),("1275947", "Bhīmavaram", "", "IN", "356", "", "02", "546", "", "16.54078", "81.52322", "Asia/Kolkata"),("1275960", "Bhīlwāra", "", "IN", "356", "", "24", "122", "", "25.34707", "74.64081", "Asia/Kolkata"),("1275971", "Bhilai", "Бхилаи", "IN", "356", "", "37", "409", "", "21.20919", "81.4285", "Asia/Kolkata"),("1275977", "Bhīkhi", "", "IN", "356", "", "23", "047", "", "30.05918", "75.535", "Asia/Kolkata"),("1275978", "Bhikangaon", "", "IN", "356", "", "35", "440", "", "21.86764", "75.96391", "Asia/Kolkata"),("1275980", "Bhigvan", "", "IN", "356", "", "16", "521", "", "18.3007", "74.76701", "Asia/Kolkata"),("1276013", "Bhāyāvadar", "", "IN", "356", "", "09", "476", "", "21.85523", "70.24791", "Asia/Kolkata"),("1276014", "Bhayandar", "", "IN", "356", "", "16", "517", "", "19.30157", "72.85107", "Asia/Kolkata"),("1276023", "Bhawānipatna", "", "IN", "356", "", "21", "395", "", "19.90717", "83.16697", "Asia/Kolkata"),("1276026", "Bhawānīgarh", "", "IN", "356", "", "23", "053", "", "30.26685", "76.03854", "Asia/Kolkata"),("1276027", "Bhawāniganj", "", "IN", "356", "", "35", "", "", "24.41582", "75.83552", "Asia/Kolkata"),("1276032", "Bhavnagar", "Бхавнагаром", "IN", "356", "", "09", "481", "", "21.76287", "72.15331", "Asia/Kolkata"),("1276037", "Bhavāni", "", "IN", "356", "", "25", "610", "", "11.44713", "77.68424", "Asia/Kolkata"),("1276054", "Bhattiprolu", "", "IN", "356", "", "02", "548", "", "16.1026", "80.78074", "Asia/Kolkata"),("1276058", "Bhātpāra", "", "IN", "356", "", "28", "337", "", "22.86643", "88.40113", "Asia/Kolkata"),("1276067", "Bhatkal", "", "IN", "356", "", "19", "563", "", "13.98534", "74.55531", "Asia/Kolkata"),("1276070", "Bathinda", "", "IN", "356", "", "23", "046", "", "30.20747", "74.93893", "Asia/Kolkata"),("1276079", "Bhatgaon", "", "IN", "356", "", "37", "410", "", "21.15", "81.7", "Asia/Kolkata"),("1276084", "Bhātāpāra", "", "IN", "356", "", "37", "410", "", "21.735", "81.94711", "Asia/Kolkata"),("1276092", "Bhasāwar", "", "IN", "356", "", "24", "105", "", "27.03895", "77.04849", "Asia/Kolkata"),("1276095", "Bharwāri", "", "IN", "356", "", "36", "174", "", "25.56078", "81.49164", "Asia/Kolkata"),("1276100", "Bharūch", "", "IN", "356", "", "09", "488", "", "21.69482", "72.9805", "Asia/Kolkata"),("1276103", "Bharthana", "", "IN", "356", "", "36", "161", "", "26.75231", "79.2218", "Asia/Kolkata"),("1276128", "Bharatpur", "Бхаратпур", "IN", "356", "", "24", "105", "", "27.21731", "77.49009", "Asia/Kolkata"),("1276147", "Bhānvad", "", "IN", "356", "", "09", "477", "", "21.93053", "69.78081", "Asia/Kolkata"),("1276151", "Bhānpurī", "", "IN", "356", "", "37", "408", "", "21.0919", "80.93218", "Asia/Kolkata"),("1276152", "Bhānpura", "", "IN", "356", "", "35", "433", "", "24.513", "75.7469", "Asia/Kolkata"),("1276159", "Bhanjanagar", "", "IN", "356", "", "21", "388", "", "19.92719", "84.58201", "Asia/Kolkata"),("1276178", "Bhānder", "", "IN", "356", "", "35", "421", "", "25.73581", "78.74555", "Asia/Kolkata"),("1276191", "Bhandāra", "Бхандара", "IN", "356", "", "16", "506", "", "21.16817", "79.64885", "Asia/Kolkata"),("1276219", "Bhālki", "", "IN", "356", "", "19", "558", "", "18.04348", "77.206", "Asia/Kolkata"),("1276249", "Bhaisa", "", "IN", "356", "", "40", "532", "", "19.11285", "77.96336", "Asia/Kolkata"),("1276265", "Bhainsdehi", "", "IN", "356", "", "35", "447", "", "21.64491", "77.63023", "Asia/Kolkata"),("1276275", "Bhagwantnagar", "", "IN", "356", "", "36", "156", "", "26.22383", "80.7575", "Asia/Kolkata"),("1276300", "Bhāgalpur", "", "IN", "356", "", "34", "224", "", "25.24446", "86.97183", "Asia/Kolkata"),("1276320", "Bhadreswar", "", "IN", "356", "", "28", "338", "", "22.82449", "88.33841", "Asia/Kolkata"),("1276321", "Bhadrāvati", "", "IN", "356", "", "19", "568", "", "13.84846", "75.70502", "Asia/Kolkata"),("1276325", "Bhadrakh", "", "IN", "356", "", "21", "378", "", "21.05447", "86.5156", "Asia/Kolkata"),("1276328", "Bhadrāchalam", "", "IN", "356", "", "40", "541", "", "17.66846", "80.88887", "Asia/Kolkata"),("1276330", "Bhādra", "Бхадра", "IN", "356", "", "24", "100", "", "29.10298", "75.17138", "Asia/Kolkata"),("1276335", "Bhadohi", "", "IN", "356", "", "36", "198", "", "25.39526", "82.5703", "Asia/Kolkata"),("1276353", "Bhadaur", "", "IN", "356", "", "23", "054", "", "30.47651", "75.33049", "Asia/Kolkata"),("1276355", "Bhādāsar", "", "IN", "356", "", "24", "102", "", "28.31457", "74.28952", "Asia/Kolkata"),("1276358", "Bhadarwāh", "", "IN", "356", "", "12", "016", "", "32.97941", "75.71723", "Asia/Kolkata"),("1276370", "Bhachāu", "", "IN", "356", "", "09", "468", "", "23.29858", "70.34279", "Asia/Kolkata"),("1276371", "Bhabhua", "", "IN", "356", "", "34", "233", "", "25.04049", "83.60749", "Asia/Kolkata"),("1276374", "Bhābhra", "", "IN", "356", "", "35", "465", "", "22.53048", "74.32846", "Asia/Kolkata"),("1276378", "Beypore", "", "IN", "356", "", "13", "591", "", "11.17151", "75.80611", "Asia/Kolkata"),("1276381", "Bewar", "", "IN", "356", "", "36", "148", "", "27.21869", "79.29761", "Asia/Kolkata"),("1276388", "Betūl Bazār", "", "IN", "356", "", "35", "447", "", "21.85572", "77.92913", "Asia/Kolkata"),("1276389", "Betūl", "", "IN", "356", "", "35", "447", "", "21.90056", "77.90229", "Asia/Kolkata"),("1276393", "Bettiah", "", "IN", "356", "", "34", "203", "", "26.80229", "84.50311", "Asia/Kolkata"),("1276400", "Betma", "", "IN", "356", "", "35", "439", "", "22.68653", "75.61456", "Asia/Kolkata"),("1276416", "Betamcherla", "", "IN", "356", "", "02", "552", "", "15.45144", "78.14797", "Asia/Kolkata"),("1276419", "Beswān", "", "IN", "356", "", "36", "143", "", "27.63792", "77.88019", "Asia/Kolkata"),("1276437", "Beri Khās", "", "IN", "356", "", "10", "083", "", "28.70146", "76.57708", "Asia/Kolkata"),("1276449", "Berasia", "", "IN", "356", "", "35", "444", "", "23.63134", "77.43351", "Asia/Kolkata"),("1276455", "Beohāri", "", "IN", "356", "", "35", "460", "", "24.02423", "81.37831", "Asia/Kolkata"),("1276463", "Benīganj", "", "IN", "356", "", "36", "155", "", "27.29293", "80.44364", "Asia/Kolkata"),("1276472", "Benaulim", "", "IN", "356", "", "33", "586", "", "15.26435", "73.92812", "Asia/Kolkata"),("1276478", "Bemetāra", "", "IN", "356", "", "37", "409", "", "21.71556", "81.53423", "Asia/Kolkata"),("1276486", "Belūr", "Белур", "IN", "356", "", "19", "574", "", "13.16558", "75.86519", "Asia/Kolkata"),("1276487", "Belūr", "", "IN", "356", "", "25", "608", "", "11.70691", "78.4157", "Asia/Kolkata"),("1276491", "Beltangadi", "", "IN", "356", "", "19", "568", "", "13.98333", "75.3", "Asia/Kolkata"),("1276495", "Belsand", "", "IN", "356", "", "34", "206", "", "26.44365", "85.40076", "Asia/Kolkata"),("1276502", "Belonia", "", "IN", "356", "", "26", "290", "", "23.25178", "91.45407", "Asia/Kolkata"),("1276506", "Bellūru", "", "IN", "356", "", "19", "573", "", "12.9814", "76.73308", "Asia/Kolkata"),("1276509", "Bellary", "Беллари", "IN", "356", "", "19", "565", "", "15.14205", "76.92398", "Asia/Kolkata"),("1276520", "Beliātor", "", "IN", "356", "", "28", "339", "", "23.32052", "87.22081", "Asia/Kolkata"),("1276533", "Belgaum", "Белгаум", "IN", "356", "", "19", "555", "", "15.85212", "74.50447", "Asia/Kolkata"),("1276548", "Beldānga", "", "IN", "356", "", "28", "333", "", "23.93428", "88.26018", "Asia/Kolkata"),("1276568", "Belaguntha", "", "IN", "356", "", "21", "388", "", "19.88249", "84.63801", "Asia/Kolkata"),("1276574", "Bela", "Бела", "IN", "356", "", "36", "173", "", "25.92058", "81.99629", "Asia/Kolkata"),("1276589", "Behror", "", "IN", "356", "", "24", "104", "", "27.88832", "76.28108", "Asia/Kolkata"),("1276600", "Behat", "", "IN", "356", "", "36", "132", "", "30.1718", "77.6139", "Asia/Kolkata"),("1276609", "Begusarai", "", "IN", "356", "", "34", "222", "", "25.41853", "86.13389", "Asia/Kolkata"),("1276615", "Begūn", "Бегун", "IN", "356", "", "24", "126", "", "24.98333", "75", "Asia/Kolkata"),("1276616", "Begowāl", "", "IN", "356", "", "23", "036", "", "31.61152", "75.52135", "Asia/Kolkata"),("1276621", "Begamganj", "", "IN", "356", "", "35", "446", "", "23.59917", "78.34064", "Asia/Kolkata"),("1276627", "Bedi", "Беда", "IN", "356", "", "09", "477", "", "22.50143", "70.04363", "Asia/Kolkata"),("1276634", "Beāwar", "", "IN", "356", "", "24", "119", "", "26.10119", "74.32028", "Asia/Kolkata"),("1276642", "Bāzpur", "", "IN", "356", "", "39", "067", "", "29.15299", "79.10814", "Asia/Kolkata"),("1276652", "Bayāna", "Баян", "IN", "356", "", "24", "105", "", "26.90791", "77.28985", "Asia/Kolkata"),("1276663", "Bawāna", "", "IN", "356", "", "07", "090", "", "28.7982", "77.03431", "Asia/Kolkata"),("1276666", "Bāwal", "", "IN", "356", "", "10", "085", "", "28.07184", "76.58312", "Asia/Kolkata"),("1276686", "Bauda", "", "IN", "356", "", "21", "391", "", "20.83333", "84.31667", "Asia/Kolkata"),("1276720", "Batāla", "", "IN", "356", "", "23", "035", "", "31.80921", "75.20294", "Asia/Kolkata"),("1276724", "Baswa", "", "IN", "356", "", "24", "109", "", "27.14955", "76.58345", "Asia/Kolkata"),("1276728", "Bāsugaon", "", "IN", "356", "", "03", "320", "", "26.46742", "90.41951", "Asia/Kolkata"),("1276731", "Bāsudebpur", "", "IN", "356", "", "21", "378", "", "21.11974", "86.72896", "Asia/Kolkata"),("1276736", "Bastī", "Басти", "IN", "356", "", "36", "185", "", "26.78817", "82.71617", "Asia/Kolkata"),("1276752", "Bāsoda", "", "IN", "356", "", "35", "443", "", "23.85153", "77.93652", "Asia/Kolkata"),("1276754", "Basni", "Басни", "IN", "356", "", "24", "112", "", "27.17232", "73.64519", "Asia/Kolkata"),("1276756", "Basna", "", "IN", "356", "", "37", "411", "", "21.27885", "82.8267", "Asia/Kolkata"),("1276757", "Basmat", "", "IN", "356", "", "16", "512", "", "19.32872", "77.15746", "Asia/Kolkata"),("1276764", "Basi", "", "IN", "356", "", "23", "040", "", "30.6885", "76.40111", "Asia/Kolkata"),("1276765", "Basi", "", "IN", "356", "", "23", "052", "", "30.58813", "76.84498", "Asia/Kolkata"),("1276767", "Basi", "", "IN", "356", "", "24", "110", "", "26.8315", "76.04856", "Asia/Kolkata"),("1276782", "Basavana Bāgevādi", "", "IN", "356", "", "19", "557", "", "16.57278", "75.97252", "Asia/Kolkata"),("1276783", "Basavakalyān", "", "IN", "356", "", "19", "558", "", "17.87445", "76.94972", "Asia/Kolkata"),("1276810", "Barwāni", "", "IN", "356", "", "35", "441", "", "22.03232", "74.89982", "Asia/Kolkata"),("1276815", "Barwāla", "", "IN", "356", "", "10", "080", "", "29.36747", "75.90809", "Asia/Kolkata"),("1276819", "Barwādih", "", "IN", "356", "", "38", "359", "", "23.84753", "84.11122", "Asia/Kolkata"),("1276829", "Bāruni", "Баруни", "IN", "356", "", "34", "222", "", "25.47509", "85.96813", "Asia/Kolkata"),("1276832", "Bāruipur", "", "IN", "356", "", "28", "343", "", "22.35253", "88.43882", "Asia/Kolkata"),("1276856", "Bārsi", "", "IN", "356", "", "16", "526", "", "18.23454", "75.69275", "Asia/Kolkata"),("1276857", "Barsāna", "", "IN", "356", "", "36", "145", "", "27.64802", "77.3764", "Asia/Kolkata"),("1276867", "Barpeta", "", "IN", "356", "", "03", "303", "", "26.32293", "91.00632", "Asia/Kolkata"),("1276869", "Barpathār", "", "IN", "356", "", "03", "313", "", "26.28709", "93.88844", "Asia/Kolkata"),("1276870", "Barpāli", "", "IN", "356", "", "21", "370", "", "21.19005", "83.58721", "Asia/Kolkata"),("1276895", "Barnāla", "Барнала", "IN", "356", "", "23", "054", "", "30.37451", "75.5487", "Asia/Kolkata"),("1276901", "Bārmer", "", "IN", "356", "", "24", "115", "", "25.74572", "71.39211", "Asia/Kolkata"),("1276917", "Barkot", "", "IN", "356", "", "39", "056", "", "30.80861", "78.20596", "Asia/Kolkata"),("1276919", "Barki Saria", "", "IN", "356", "", "38", "349", "", "24.17543", "85.89077", "Asia/Kolkata"),("1276922", "Barkhera Kalān", "", "IN", "356", "", "36", "151", "", "28.45209", "79.80655", "Asia/Kolkata"),("1276927", "Barka Kāna", "", "IN", "356", "", "38", "361", "", "23.62199", "85.46714", "Asia/Kolkata"),("1276932", "Barjora", "", "IN", "356", "", "28", "339", "", "23.42754", "87.29037", "Asia/Kolkata"),("1276938", "Barjala", "", "IN", "356", "", "26", "289", "", "23.6182", "91.35596", "Asia/Kolkata"),("1276939", "Bari Sādri", "", "IN", "356", "", "24", "126", "", "24.41339", "74.47331", "Asia/Kolkata"),("1276945", "Bariārpur", "", "IN", "356", "", "34", "226", "", "25.28848", "86.57578", "Asia/Kolkata"),("1276948", "Bāri", "", "IN", "356", "", "24", "106", "", "26.64661", "77.61634", "Asia/Kolkata"),("1276954", "Barhiya", "", "IN", "356", "", "34", "227", "", "25.28814", "86.02055", "Asia/Kolkata"),("1276955", "patamda", "", "IN", "356", "", "38", "360", "", "24.3", "85.41667", "Asia/Kolkata"),("1276956", "Barhi", "", "IN", "356", "", "35", "450", "", "23.90326", "80.81516", "Asia/Kolkata"),("1276977", "Bārh", "Барх", "IN", "356", "", "34", "230", "", "25.48339", "85.70928", "Asia/Kolkata"),("1276982", "Bargi", "", "IN", "356", "", "35", "451", "", "22.99138", "79.8755", "Asia/Kolkata"),("1276983", "Barghāt", "", "IN", "356", "", "35", "456", "", "22.03065", "79.7328", "Asia/Kolkata"),("1276988", "Bargarh", "", "IN", "356", "", "21", "370", "", "21.33348", "83.61905", "Asia/Kolkata"),("1277008", "Barela", "", "IN", "356", "", "35", "451", "", "23.09678", "80.05084", "Asia/Kolkata"),("1277013", "Bareilly", "Барейли", "IN", "356", "", "36", "150", "", "28.34702", "79.42193", "Asia/Kolkata"),("1277022", "Bārdoli", "Бардоли", "IN", "356", "", "09", "492", "", "21.12297", "73.11151", "Asia/Kolkata"),("1277029", "Barddhamān", "", "IN", "356", "", "28", "335", "", "23.25572", "87.85691", "Asia/Kolkata"),("1277038", "Bar Bigha", "", "IN", "356", "", "34", "228", "", "25.21855", "85.7332", "Asia/Kolkata"),("1277044", "Baraut", "", "IN", "356", "", "36", "139", "", "29.10199", "77.26334", "Asia/Kolkata"),("1277053", "Barauli", "", "IN", "356", "", "34", "217", "", "26.38109", "84.58648", "Asia/Kolkata"),("1277065", "Bārāsat", "", "IN", "356", "", "28", "337", "", "22.72154", "88.48198", "Asia/Kolkata"),("1277066", "Bārāsat", "", "IN", "356", "", "28", "343", "", "22.22516", "88.45086", "Asia/Kolkata"),("1277082", "Baranagar", "", "IN", "356", "", "28", "337", "", "22.64132", "88.37727", "Asia/Kolkata"),("1277084", "Bārān", "Баран", "IN", "356", "", "24", "128", "", "25.1", "76.51667", "Asia/Kolkata"),("1277085", "Bāramūla", "", "IN", "356", "", "12", "008", "", "34.209", "74.34285", "Asia/Kolkata"),("1277091", "Bārāmati", "Барамати", "IN", "356", "", "16", "521", "", "18.15174", "74.57767", "Asia/Kolkata"),("1277100", "Bārākpur", "", "IN", "356", "", "28", "337", "", "22.76602", "88.36336", "Asia/Kolkata"),("1277134", "Barāgaon", "", "IN", "356", "", "36", "166", "", "25.47554", "78.71224", "Asia/Kolkata"),("1277135", "Barāgaon", "", "IN", "356", "", "36", "197", "", "25.42936", "82.81709", "Asia/Kolkata"),("1277155", "Bara Bazar", "", "IN", "356", "", "28", "342", "", "22.56667", "88.35", "Asia/Kolkata"),("1277183", "Bāpatla", "", "IN", "356", "", "02", "548", "", "15.90422", "80.46743", "Asia/Kolkata"),("1277200", "Banūr", "", "IN", "356", "", "23", "048", "", "30.55407", "76.71948", "Asia/Kolkata"),("1277201", "Bantvāl", "", "IN", "356", "", "19", "575", "", "12.8905", "75.03489", "Asia/Kolkata"),("1277202", "Bāntva", "", "IN", "356", "", "09", "479", "", "21.48815", "70.07576", "Asia/Kolkata"),("1277214", "Bānswāra", "", "IN", "356", "", "24", "125", "", "23.54109", "74.4425", "Asia/Kolkata"),("1277216", "Bānswāda", "", "IN", "356", "", "40", "533", "", "18.37725", "77.88007", "Asia/Kolkata"),("1277232", "Bānsi", "", "IN", "356", "", "36", "184", "", "27.17749", "82.93442", "Asia/Kolkata"),("1277235", "Bānsgāon", "", "IN", "356", "", "36", "188", "", "26.55032", "83.34503", "Asia/Kolkata"),("1277238", "Bānsdīh", "", "IN", "356", "", "36", "193", "", "25.88377", "84.21827", "Asia/Kolkata"),("1277240", "Bānsbāria", "", "IN", "356", "", "28", "338", "", "22.95387", "88.40098", "Asia/Kolkata"),("1277247", "Bānposh", "", "IN", "356", "", "21", "374", "", "22.24834", "84.81044", "Asia/Kolkata"),("1277255", "Bannūr", "", "IN", "356", "", "19", "577", "", "12.33295", "76.86201", "Asia/Kolkata"),("1277263", "Banmankhi", "", "IN", "356", "", "34", "211", "", "25.88857", "87.19421", "Asia/Kolkata"),("1277264", "Bānkura", "Банкура", "IN", "356", "", "28", "339", "", "23.23241", "87.0716", "Asia/Kolkata"),("1277273", "Bānki", "", "IN", "356", "", "21", "381", "", "20.37912", "85.52953", "Asia/Kolkata"),("1277289", "Bānka", "", "IN", "356", "", "34", "225", "", "24.88091", "86.92257", "Asia/Kolkata"),("1277318", "Bāngarmau", "", "IN", "356", "", "36", "156", "", "26.8912", "80.21149", "Asia/Kolkata"),("1277320", "Bowringpet", "", "IN", "356", "", "19", "581", "", "12.99116", "78.17804", "Asia/Kolkata"),("1277322", "Bangaon", "", "IN", "356", "", "34", "214", "", "25.86728", "86.51152", "Asia/Kolkata"),("1277324", "Bangaon", "Бангаон", "IN", "356", "", "28", "337", "", "23.04553", "88.83084", "Asia/Kolkata"),("1277330", "Banganapalle", "", "IN", "356", "", "02", "552", "", "15.31771", "78.22669", "Asia/Kolkata"),("1277333", "Bengaluru", "Бангалор", "IN", "356", "", "19", "572", "", "12.97194", "77.59369", "Asia/Kolkata"),("1277338", "Banga", "", "IN", "356", "", "23", "039", "", "31.18874", "75.99495", "Asia/Kolkata"),("1277353", "Bandora", "", "IN", "356", "", "33", "585", "", "15.40823", "73.98129", "Asia/Kolkata"),("1277358", "Bandipura", "", "IN", "356", "", "12", "009", "", "34.41728", "74.64308", "Asia/Kolkata"),("1277362", "Bāndīkūi", "", "IN", "356", "", "24", "109", "", "27.05087", "76.57325", "Asia/Kolkata"),("1277397", "Bānda", "", "IN", "356", "", "36", "170", "", "25.47758", "80.33491", "Asia/Kolkata"),("1277398", "Banda", "", "IN", "356", "", "35", "427", "", "24.04488", "78.96094", "Asia/Kolkata"),("1277408", "Bānāvar", "", "IN", "356", "", "19", "574", "", "13.41029", "76.16314", "Asia/Kolkata"),("1277409", "Banat", "Банат", "IN", "356", "", "36", "133", "", "29.46355", "77.35478", "Asia/Kolkata"),("1277426", "Bānapur", "", "IN", "356", "", "21", "386", "", "19.77889", "85.17033", "Asia/Kolkata"),("1277442", "Bāmor Kalān", "", "IN", "356", "", "35", "423", "", "24.89298", "78.15105", "Asia/Kolkata"),("1277450", "Bamora", "", "IN", "356", "", "35", "427", "", "24.05539", "78.08925", "Asia/Kolkata"),("1277455", "Bamna", "", "IN", "356", "", "35", "464", "", "23.09454", "74.76164", "Asia/Kolkata"),("1277476", "Bamboo Flat", "", "IN", "356", "", "01", "", "", "11.7", "92.71667", "Asia/Kolkata"),("1277477", "Bambolim", "", "IN", "356", "", "33", "585", "", "15.46361", "73.8531", "Asia/Kolkata"),("1277508", "Bālurghāt", "", "IN", "356", "", "28", "331", "", "25.22099", "88.77732", "Asia/Kolkata"),("1277514", "Bālugaon", "", "IN", "356", "", "21", "385", "", "20.17811", "85.11225", "Asia/Kolkata"),("1277525", "Balrāmpur", "", "IN", "356", "", "36", "182", "", "27.42949", "82.18545", "Asia/Kolkata"),("1277527", "Bālotra", "", "IN", "356", "", "24", "115", "", "25.83242", "72.24", "Asia/Kolkata"),("1277530", "Baloda Bāzār", "", "IN", "356", "", "37", "410", "", "21.65678", "82.16062", "Asia/Kolkata"),("1277533", "Baloda", "", "IN", "356", "", "37", "405", "", "22.1389", "82.48171", "Asia/Kolkata"),("1277535", "Balod", "", "IN", "356", "", "37", "409", "", "20.73081", "81.20578", "Asia/Kolkata"),("1277539", "Bāli", "Бали", "IN", "356", "", "28", "341", "", "22.64859", "88.34115", "Asia/Kolkata"),("1277557", "Ballālpur", "", "IN", "356", "", "16", "509", "", "19.84696", "79.34578", "Asia/Kolkata"),("1277570", "Balimila", "", "IN", "356", "", "21", "399", "", "18.25167", "82.10659", "Asia/Kolkata"),("1277581", "Bāli Chak", "", "IN", "356", "", "28", "344", "", "22.36482", "87.55304", "Asia/Kolkata"),("1277590", "Bāli", "", "IN", "356", "", "24", "118", "", "25.19725", "73.29117", "Asia/Kolkata"),("1277599", "Balasore", "Баласор", "IN", "356", "", "21", "377", "", "21.49266", "86.93348", "Asia/Kolkata"),("1277613", "Baldeogarh", "", "IN", "356", "", "35", "424", "", "24.75619", "79.06715", "Asia/Kolkata"),("1277614", "Baldev", "", "IN", "356", "", "36", "145", "", "27.40684", "77.82214", "Asia/Kolkata"),("1277634", "Balarāmpur", "", "IN", "356", "", "28", "340", "", "23.09714", "86.22292", "Asia/Kolkata"),("1277636", "Bālāpur", "", "IN", "356", "", "16", "501", "", "20.66612", "76.77386", "Asia/Kolkata"),("1277643", "Balāngīr", "", "IN", "356", "", "21", "393", "", "20.70419", "83.49029", "Asia/Kolkata"),("1277661", "Bālāghāt", "", "IN", "356", "", "35", "457", "", "21.8156", "80.18845", "Asia/Kolkata"),("1277666", "Bālāchor", "", "IN", "356", "", "23", "039", "", "31.06062", "76.30166", "Asia/Kolkata"),("1277671", "Bakshwāho", "", "IN", "356", "", "35", "425", "", "24.25106", "79.28618", "Asia/Kolkata"),("1277684", "Bakhtiyārpur", "", "IN", "356", "", "34", "230", "", "25.46179", "85.53179", "Asia/Kolkata"),("1277695", "Bakewar", "", "IN", "356", "", "36", "161", "", "26.66226", "79.17625", "Asia/Kolkata"),("1277699", "Bakāni", "", "IN", "356", "", "24", "129", "", "24.28624", "76.23709", "Asia/Kolkata"),("1277716", "Bājna", "", "IN", "356", "", "36", "145", "", "27.89793", "77.67836", "Asia/Kolkata"),("1277723", "Baj Baj", "", "IN", "356", "", "28", "343", "", "22.47514", "88.17767", "Asia/Kolkata"),("1277748", "Bairāgnia", "", "IN", "356", "", "34", "206", "", "26.74063", "85.27323", "Asia/Kolkata"),("1277759", "Byndoor", "", "IN", "356", "", "19", "569", "", "13.86667", "74.63333", "Asia/Kolkata"),("1277765", "Bail-Hongal", "", "IN", "356", "", "19", "555", "", "15.8137", "74.85895", "Asia/Kolkata"),("1277769", "Baikunthpur", "", "IN", "356", "", "37", "400", "", "23.26206", "82.56051", "Asia/Kolkata"),("1277770", "Baikunthpur", "", "IN", "356", "", "35", "430", "", "24.72768", "81.40975", "Asia/Kolkata"),("1277776", "Baihar", "", "IN", "356", "", "35", "457", "", "22.10133", "80.54967", "Asia/Kolkata"),("1277780", "Baidyabāti", "", "IN", "356", "", "28", "338", "", "22.78498", "88.32586", "Asia/Kolkata"),("1277793", "Bahua", "", "IN", "356", "", "36", "172", "", "25.83942", "80.62255", "Asia/Kolkata"),("1277795", "Bahsūma", "", "IN", "356", "", "36", "138", "", "29.20063", "77.97221", "Asia/Kolkata"),("1277799", "Bahraigh", "", "IN", "356", "", "36", "180", "", "27.57429", "81.59474", "Asia/Kolkata"),("1277808", "Bahjoi", "", "IN", "356", "", "36", "135", "", "28.39502", "78.62659", "Asia/Kolkata"),("1277814", "Baheri", "", "IN", "356", "", "36", "150", "", "28.77416", "79.4974", "Asia/Kolkata"),("1277820", "Baharampur", "", "IN", "356", "", "28", "333", "", "24.10473", "88.25155", "Asia/Kolkata"),("1277835", "Bahādurgarh", "", "IN", "356", "", "10", "083", "", "28.69287", "76.93555", "Asia/Kolkata"),("1277836", "Bahādurganj", "", "IN", "356", "", "34", "210", "", "26.26172", "87.82443", "Asia/Kolkata"),("1277841", "Bāh", "", "IN", "356", "", "36", "146", "", "26.86912", "78.59385", "Asia/Kolkata"),("1277844", "Bagulā", "", "IN", "356", "", "28", "336", "", "23.33664", "88.64109", "Asia/Kolkata"),("1277863", "Bagra", "", "IN", "356", "", "38", "354", "", "23.73333", "86.31667", "Asia/Kolkata"),("1277874", "Bāgli", "", "IN", "356", "", "35", "437", "", "22.64124", "76.34877", "Asia/Kolkata"),("1277882", "Bāghpat", "", "IN", "356", "", "36", "139", "", "28.94485", "77.21865", "Asia/Kolkata"),("1277897", "Bagdogra", "", "IN", "356", "", "28", "327", "", "26.69929", "88.31177", "Asia/Kolkata"),("1277902", "Bāgha Purāna", "", "IN", "356", "", "23", "042", "", "30.68809", "75.09838", "Asia/Kolkata"),("1277905", "Bāg", "", "IN", "356", "", "35", "438", "", "22.35905", "74.79052", "Asia/Kolkata"),("1277907", "Bāgeshwar", "", "IN", "356", "", "39", "063", "", "29.83738", "79.77161", "Asia/Kolkata"),("1277909", "Bāgepalli", "", "IN", "356", "", "19", "582", "", "13.78338", "77.79667", "Asia/Kolkata"),("1277924", "Bagasra", "", "IN", "356", "", "09", "480", "", "21.48719", "70.95516", "Asia/Kolkata"),("1277930", "Bagar", "", "IN", "356", "", "24", "103", "", "28.18784", "75.50012", "Asia/Kolkata"),("1277936", "Bagalkot", "Багалкот", "IN", "356", "", "19", "556", "", "16.18673", "75.69614", "Asia/Kolkata"),("1277939", "Bagaha", "", "IN", "356", "", "34", "203", "", "27.09918", "84.09003", "Asia/Kolkata"),("1277940", "Bagaha", "", "IN", "356", "", "34", "236", "", "24.52898", "85.06019", "Asia/Kolkata"),("1277949", "Badvel", "", "IN", "356", "", "02", "551", "", "14.7451", "79.06288", "Asia/Kolkata"),("1277950", "Badūria", "Бадурии", "IN", "356", "", "28", "337", "", "22.74431", "88.78655", "Asia/Kolkata"),("1277970", "Badnāwar", "", "IN", "356", "", "35", "438", "", "23.02181", "75.23268", "Asia/Kolkata"),("1277976", "Badlapur", "", "IN", "356", "", "16", "517", "", "19.15516", "73.26553", "Asia/Kolkata"),("1277992", "Badhni Kalān", "", "IN", "356", "", "23", "042", "", "30.6813", "75.29087", "Asia/Kolkata"),("1278006", "Badarwās", "", "IN", "356", "", "35", "423", "", "24.97516", "77.5649", "Asia/Kolkata"),("1278008", "Badarpur", "", "IN", "356", "", "03", "318", "", "24.86852", "92.59606", "Asia/Kolkata"),("1278017", "Bādāmi", "Бадами", "IN", "356", "", "19", "556", "", "15.91495", "75.67683", "Asia/Kolkata"),("1278023", "Badagara", "", "IN", "356", "", "13", "591", "", "11.59776", "75.58142", "Asia/Kolkata"),("1278026", "Bada Barabīl", "", "IN", "356", "", "21", "375", "", "22.11186", "85.38684", "Asia/Kolkata"),("1278035", "Bachhrāwān", "", "IN", "356", "", "36", "158", "", "26.4709", "81.1158", "Asia/Kolkata"),("1278036", "Bachhraon", "", "IN", "356", "", "36", "137", "", "28.92694", "78.23456", "Asia/Kolkata"),("1278051", "Babugarh", "", "IN", "356", "", "36", "140", "", "28.72353", "77.84677", "Asia/Kolkata"),("1278052", "Babrāla", "", "IN", "356", "", "36", "149", "", "28.26419", "78.4056", "Asia/Kolkata"),("1278054", "Bābra", "", "IN", "356", "", "09", "480", "", "21.84577", "71.30544", "Asia/Kolkata"),("1278058", "Babīna", "Бабина", "IN", "356", "", "36", "166", "", "25.23947", "78.47028", "Asia/Kolkata"),("1278064", "Baberu", "", "IN", "356", "", "36", "170", "", "25.54711", "80.70443", "Asia/Kolkata"),("1278073", "Bābai", "", "IN", "356", "", "35", "449", "", "22.70256", "77.93494", "Asia/Kolkata"),("1278083", "Azamgarh", "", "IN", "356", "", "36", "191", "", "26.06832", "83.18358", "Asia/Kolkata"),("1278090", "Ayyampettāi", "", "IN", "356", "", "25", "620", "", "10.90141", "79.17984", "Asia/Kolkata"),("1278094", "Ajodhya", "Айодхье", "IN", "356", "", "36", "177", "", "26.79909", "82.2047", "Asia/Kolkata"),("1278100", "Ayakudi", "", "IN", "356", "", "25", "612", "", "10.44992", "77.55198", "Asia/Kolkata"),("1278103", "Awantipur", "", "IN", "356", "", "12", "012", "", "33.91978", "75.01515", "Asia/Kolkata"),("1278122", "Avanigadda", "", "IN", "356", "", "02", "547", "", "16.02148", "80.91808", "Asia/Kolkata"),("1278124", "Avinashi", "", "IN", "356", "", "25", "633", "", "11.19297", "77.26865", "Asia/Kolkata"),("1278130", "Āvadi", "Авади", "IN", "356", "", "25", "604", "", "13.1147", "80.10981", "Asia/Kolkata"),("1278139", "Ausa", "", "IN", "356", "", "16", "524", "", "18.24728", "76.4993", "Asia/Kolkata"),("1278142", "Aurās", "", "IN", "356", "", "36", "156", "", "26.91414", "80.50792", "Asia/Kolkata"),("1278148", "Aurangābād", "", "IN", "356", "", "34", "235", "", "24.75204", "84.3742", "Asia/Kolkata"),("1278149", "Aurangabad", "Аурангабад", "IN", "356", "", "16", "515", "", "19.87757", "75.34226", "Asia/Kolkata"),("1278152", "Auraiya", "", "IN", "356", "", "36", "162", "", "26.46517", "79.50918", "Asia/Kolkata"),("1278156", "Aurād", "", "IN", "356", "", "19", "558", "", "18.25397", "77.41761", "Asia/Kolkata"),("1278173", "Attur", "", "IN", "356", "", "25", "608", "", "11.59414", "78.60143", "Asia/Kolkata"),("1278176", "Attingal", "", "IN", "356", "", "13", "601", "", "8.69609", "76.81507", "Asia/Kolkata"),("1278178", "Attili", "", "IN", "356", "", "02", "546", "", "16.7", "81.6", "Asia/Kolkata"),("1278182", "Āttayyāmpatti", "", "IN", "356", "", "25", "608", "", "11.53187", "78.05416", "Asia/Kolkata"),("1278189", "Atraulia", "", "IN", "356", "", "36", "191", "", "26.3333", "82.94727", "Asia/Kolkata"),("1278190", "Atraulī", "", "IN", "356", "", "36", "143", "", "28.02964", "78.28571", "Asia/Kolkata"),("1278201", "Atmakūr", "", "IN", "356", "", "02", "552", "", "15.88109", "78.58704", "Asia/Kolkata"),("1278204", "Adirampattinam", "", "IN", "356", "", "25", "620", "", "10.34059", "79.37905", "Asia/Kolkata"),("1278208", "Athni", "", "IN", "356", "", "19", "555", "", "16.72613", "75.06421", "Asia/Kolkata"),("1278216", "Āthagarh", "", "IN", "356", "", "21", "381", "", "20.51999", "85.62965", "Asia/Kolkata"),("1278223", "Ateli Mandi", "", "IN", "356", "", "10", "084", "", "28.1008", "76.2598", "Asia/Kolkata"),("1278228", "Atarra", "", "IN", "356", "", "36", "170", "", "25.28618", "80.57155", "Asia/Kolkata"),("1278278", "Āsind", "", "IN", "356", "", "24", "122", "", "25.7342", "74.33278", "Asia/Kolkata"),("1278279", "Āsika", "", "IN", "356", "", "21", "388", "", "19.61114", "84.65998", "Asia/Kolkata"),("1278282", "Asifābād", "", "IN", "356", "", "40", "532", "", "19.35851", "79.28415", "Asia/Kolkata"),("1278290", "Ashti", "", "IN", "356", "", "16", "514", "", "19.37671", "76.2252", "Asia/Kolkata"),("1278294", "Ashta", "Ашта", "IN", "356", "", "35", "445", "", "23.01754", "76.72208", "Asia/Kolkata"),("1278296", "Ashta", "Ашта", "IN", "356", "", "16", "531", "", "16.94943", "74.40936", "Asia/Kolkata"),("1278297", "Ashoknagar", "", "IN", "356", "", "35", "459", "", "24.57578", "77.73123", "Asia/Kolkata"),("1278308", "Asarganj", "", "IN", "356", "", "34", "226", "", "25.15046", "86.68639", "Asia/Kolkata"),("1278314", "Āsansol", "Асансол", "IN", "356", "", "28", "335", "", "23.68333", "86.98333", "Asia/Kolkata"),("1278320", "Āsandh", "", "IN", "356", "", "10", "074", "", "29.52119", "76.60552", "Asia/Kolkata"),("1278335", "Ārvi", "", "IN", "356", "", "16", "504", "", "20.99585", "78.22914", "Asia/Kolkata"),("1278340", "Aruppukkottai", "", "IN", "356", "", "25", "625", "", "9.50842", "78.09449", "Asia/Kolkata"),("1278343", "Arumuganeri", "", "IN", "356", "", "25", "627", "", "8.5688", "78.09091", "Asia/Kolkata"),("1278344", "Arumbāvūr", "", "IN", "356", "", "25", "615", "", "11.38167", "78.72885", "Asia/Kolkata"),("1278345", "Arukutti", "", "IN", "356", "", "13", "598", "", "9.86667", "76.35", "Asia/Kolkata"),("1278354", "Arsikere", "", "IN", "356", "", "19", "574", "", "13.31446", "76.25704", "Asia/Kolkata"),("1278365", "Āron", "", "IN", "356", "", "35", "458", "", "24.38109", "77.41739", "Asia/Kolkata"),("1278373", "Norīa", "", "IN", "356", "", "12", "021", "", "32.52095", "74.79845", "Asia/Kolkata"),("1278393", "Arkalgūd", "", "IN", "356", "", "19", "574", "", "12.76171", "76.06035", "Asia/Kolkata"),("1278405", "Ariyalūr", "", "IN", "356", "", "25", "616", "", "11.13849", "79.07556", "Asia/Kolkata"),("1278409", "Arimalam", "", "IN", "356", "", "25", "621", "", "10.25639", "78.88712", "Asia/Kolkata"),("1278432", "Arcot", "Аркота", "IN", "356", "", "25", "605", "", "12.90569", "79.31897", "Asia/Kolkata"),("1278433", "Aruvankad", "", "IN", "356", "", "25", "611", "", "11.36315", "76.7579", "Asia/Kolkata"),("1278446", "Arāria", "Арария", "IN", "356", "", "34", "209", "", "26.14934", "87.51323", "Asia/Kolkata"),("1278448", "Arantāngi", "", "IN", "356", "", "25", "621", "", "10.17235", "78.99118", "Asia/Kolkata"),("1278454", "Arni", "", "IN", "356", "", "25", "606", "", "12.66771", "79.28529", "Asia/Kolkata"),("1278455", "Ārangaon", "", "IN", "356", "", "16", "522", "", "18.67458", "75.17976", "Asia/Kolkata"),("1278458", "Arang", "", "IN", "356", "", "37", "410", "", "21.19639", "81.96912", "Asia/Kolkata"),("1278464", "Arambol", "", "IN", "356", "", "33", "585", "", "15.68681", "73.70449", "Asia/Kolkata"),("1278466", "Arāmbāgh", "", "IN", "356", "", "28", "338", "", "22.88333", "87.78333", "Asia/Kolkata"),("1278471", "Arakkonam", "", "IN", "356", "", "25", "605", "", "13.08449", "79.67053", "Asia/Kolkata"),("1278483", "Arrah", "Ара", "IN", "356", "", "34", "231", "", "25.55629", "84.66335", "Asia/Kolkata"),("1278498", "Aonla", "", "IN", "356", "", "36", "150", "", "28.27402", "79.16521", "Asia/Kolkata"),("1278507", "Anūpshahr", "", "IN", "356", "", "36", "142", "", "28.35748", "78.26914", "Asia/Kolkata"),("1278508", "Anūppur", "", "IN", "356", "", "35", "461", "", "23.10344", "81.69083", "Asia/Kolkata"),("1278510", "Anūpgarh", "", "IN", "356", "", "24", "099", "", "29.19111", "73.20861", "Asia/Kolkata"),("1278515", "Antu", "", "IN", "356", "", "36", "173", "", "26.05654", "81.90267", "Asia/Kolkata"),("1278516", "Antri", "", "IN", "356", "", "35", "421", "", "26.05804", "78.21027", "Asia/Kolkata"),("1278532", "Anta", "", "IN", "356", "", "24", "128", "", "25.15", "76.3", "Asia/Kolkata"),("1278534", "Anshing", "", "IN", "356", "", "16", "502", "", "20.0409", "77.31501", "Asia/Kolkata"),("1278539", "Annur", "", "IN", "356", "", "25", "632", "", "11.23616", "77.10514", "Asia/Kolkata"),("1278540", "Annigeri", "", "IN", "356", "", "19", "562", "", "15.42513", "75.4335", "Asia/Kolkata"),("1278541", "Annavāsal", "", "IN", "356", "", "25", "621", "", "10.46057", "78.70002", "Asia/Kolkata"),("1278546", "Annāmalainagar", "", "IN", "356", "", "25", "617", "", "11.4", "79.73333", "Asia/Kolkata"),("1278551", "Ankola", "", "IN", "356", "", "19", "563", "", "14.66049", "74.3047", "Asia/Kolkata"),("1278553", "Ankleshwar", "", "IN", "356", "", "09", "488", "", "21.63236", "72.99001", "Asia/Kolkata"),("1278573", "Anjār", "Анджаром", "IN", "356", "", "09", "468", "", "23.11316", "70.02671", "Asia/Kolkata"),("1278580", "Anjangaon", "", "IN", "356", "", "16", "503", "", "21.16516", "77.3091", "Asia/Kolkata"),("1278588", "Anjad", "", "IN", "356", "", "35", "441", "", "22.04171", "75.05519", "Asia/Kolkata"),("1278593", "Angul", "", "IN", "356", "", "21", "384", "", "20.84089", "85.10192", "Asia/Kolkata"),("1278602", "Angamāli", "", "IN", "356", "", "13", "595", "", "10.19055", "76.38789", "Asia/Kolkata"),("1278609", "Anekal", "", "IN", "356", "", "19", "572", "", "12.7111", "77.69557", "Asia/Kolkata"),("1278621", "Andol", "", "IN", "356", "", "40", "535", "", "17.81458", "78.07713", "Asia/Kolkata"),("1278622", "Anthiyur", "", "IN", "356", "", "25", "610", "", "11.57506", "77.59043", "Asia/Kolkata"),("1278625", "Āndippatti", "", "IN", "356", "", "25", "624", "", "9.99854", "77.62122", "Asia/Kolkata"),("1278667", "Anantnag", "", "IN", "356", "", "12", "014", "", "33.73068", "75.15418", "Asia/Kolkata"),("1278672", "Anantapur", "Анантапуре", "IN", "356", "", "02", "553", "", "14.67784", "77.60813", "Asia/Kolkata"),("1278676", "Anandpur", "", "IN", "356", "", "23", "051", "", "31.23926", "76.50253", "Asia/Kolkata"),("1278682", "Anandnagar", "", "IN", "356", "", "36", "187", "", "27.10062", "83.27156", "Asia/Kolkata"),("1278685", "Ānand", "Ананд", "IN", "356", "", "09", "482", "", "22.55251", "72.9552", "Asia/Kolkata"),("1278688", "Anakāpalle", "", "IN", "356", "", "02", "544", "", "17.69134", "83.00395", "Asia/Kolkata"),("1278692", "Anamalais", "", "IN", "356", "", "25", "632", "", "10.58303", "76.93441", "Asia/Kolkata"),("1278698", "Amudālavalasa", "", "IN", "356", "", "02", "542", "", "18.41025", "83.90295", "Asia/Kolkata"),("1278703", "Āmta", "", "IN", "356", "", "28", "341", "", "22.58344", "88.01039", "Asia/Kolkata"),("1278707", "Amroli", "", "IN", "356", "", "09", "492", "", "21.25084", "72.83878", "Asia/Kolkata"),("1278708", "Amroha", "", "IN", "356", "", "36", "137", "", "28.90314", "78.46984", "Asia/Kolkata"),("1278710", "Amritsar", "Амритсар", "IN", "356", "", "23", "049", "", "31.62234", "74.87534", "Asia/Kolkata"),("1278715", "Amreli", "", "IN", "356", "", "09", "480", "", "21.59983", "71.21169", "Asia/Kolkata"),("1278718", "Amrāvati", "", "IN", "356", "", "16", "503", "", "20.93333", "77.75", "Asia/Kolkata"),("1278742", "Amod", "", "IN", "356", "", "09", "488", "", "21.99317", "72.87047", "Asia/Kolkata"),("1278751", "Ammāpettai", "", "IN", "356", "", "25", "610", "", "11.61905", "77.74302", "Asia/Kolkata"),("1278752", "Ammāpettai", "", "IN", "356", "", "25", "620", "", "10.79588", "79.31836", "Asia/Kolkata"),("1278758", "Amloh", "", "IN", "356", "", "23", "040", "", "30.60837", "76.23199", "Asia/Kolkata"),("1278768", "Āmli", "", "IN", "356", "", "06", "496", "", "20.28333", "73.01667", "Asia/Kolkata"),("1278774", "Āmlāgora", "", "IN", "356", "", "28", "344", "", "22.84616", "87.33559", "Asia/Kolkata"),("1278775", "Amla", "", "IN", "356", "", "35", "447", "", "21.92485", "78.12786", "Asia/Kolkata"),("1278796", "Amguri", "", "IN", "356", "", "03", "311", "", "26.81482", "94.52614", "Asia/Kolkata"),("1278805", "Amethi", "", "IN", "356", "", "36", "153", "", "28.01667", "81.05", "Asia/Kolkata"),("1278806", "Amethī", "", "IN", "356", "", "36", "179", "", "26.15696", "81.80519", "Asia/Kolkata"),("1278808", "Amet", "", "IN", "356", "", "24", "123", "", "25.30609", "73.9258", "Asia/Kolkata"),("1278815", "Ambur", "", "IN", "356", "", "25", "605", "", "12.79163", "78.71644", "Asia/Kolkata"),("1278827", "Ambikāpur", "", "IN", "356", "", "37", "401", "", "23.11892", "83.19537", "Asia/Kolkata"),("1278840", "Ambattūr", "", "IN", "356", "", "25", "602", "", "13.09818", "80.16152", "Asia/Kolkata"),("1278841", "Ambasamudram", "", "IN", "356", "", "25", "628", "", "8.71068", "77.4519", "Asia/Kolkata"),("1278842", "Āmbāsa", "", "IN", "356", "", "26", "291", "", "23.936", "91.85436", "Asia/Kolkata"),("1278860", "Ambāla", "", "IN", "356", "", "10", "070", "", "30.36099", "76.79782", "Asia/Kolkata"),("1278862", "Ambājogāi", "", "IN", "356", "", "16", "523", "", "18.73312", "76.38616", "Asia/Kolkata"),("1278867", "Ambahta", "", "IN", "356", "", "36", "132", "", "29.85706", "77.33583", "Asia/Kolkata"),("1278868", "Ambāh", "", "IN", "356", "", "35", "419", "", "26.70423", "78.22678", "Asia/Kolkata"),("1278869", "Ambāgarh Chauki", "", "IN", "356", "", "37", "408", "", "20.77644", "80.74608", "Asia/Kolkata"),("1278871", "Ambad", "", "IN", "356", "", "16", "514", "", "19.61301", "75.78906", "Asia/Kolkata"),("1278889", "Amarwāra", "", "IN", "356", "", "35", "455", "", "22.2978", "79.16943", "Asia/Kolkata"),("1278895", "Amarpur", "", "IN", "356", "", "34", "225", "", "25.03967", "86.90247", "Asia/Kolkata"),("1278897", "Amarpur", "", "IN", "356", "", "26", "290", "", "23.5257", "91.65879", "Asia/Kolkata"),("1278899", "Amarpātan", "", "IN", "356", "", "35", "429", "", "24.31371", "80.97703", "Asia/Kolkata"),("1278903", "Amarnāth", "Амарнатх", "IN", "356", "", "16", "517", "", "19.2", "73.16667", "Asia/Kolkata"),("1278905", "Amarkantak", "", "IN", "356", "", "35", "461", "", "22.67486", "81.75908", "Asia/Kolkata"),("1278921", "Amānpur", "", "IN", "356", "", "36", "202", "", "27.71222", "78.73788", "Asia/Kolkata"),("1278923", "Amānganj", "", "IN", "356", "", "35", "426", "", "24.42664", "80.03579", "Asia/Kolkata"),("1278931", "Amalner", "", "IN", "356", "", "16", "499", "", "21.03983", "75.05887", "Asia/Kolkata"),("1278935", "Amalāpuram", "", "IN", "356", "", "02", "545", "", "16.57868", "82.00609", "Asia/Kolkata"),("1278941", "Alwaye", "", "IN", "356", "", "13", "595", "", "10.10649", "76.35484", "Asia/Kolkata"),("1278943", "Ālwār Tirunagari", "", "IN", "356", "", "25", "627", "", "8.60511", "77.93754", "Asia/Kolkata"),("1278946", "Alwar", "Алвар", "IN", "356", "", "24", "104", "", "27.56246", "76.625", "Asia/Kolkata"),("1278953", "Alūr", "", "IN", "356", "", "19", "574", "", "12.97805", "75.99094", "Asia/Kolkata"),("1278964", "Alot", "", "IN", "356", "", "35", "434", "", "23.76336", "75.55662", "Asia/Kolkata"),("1278969", "Along", "", "IN", "356", "", "30", "250", "", "28.16951", "94.8006", "Asia/Kolkata"),("1278973", "Alnāvar", "", "IN", "356", "", "19", "562", "", "15.42727", "74.74111", "Asia/Kolkata"),("1278974", "Almora", "Альмора", "IN", "356", "", "39", "064", "", "29.59713", "79.65911", "Asia/Kolkata"),("1278985", "Alleppey", "Алаппужа", "IN", "356", "", "13", "598", "", "9.49004", "76.3264", "Asia/Kolkata"),("1278987", "Allāpalli", "", "IN", "356", "", "16", "508", "", "19.43172", "80.06377", "Asia/Kolkata"),("1278990", "Allāhganj", "", "IN", "356", "", "36", "152", "", "27.5454", "79.68715", "Asia/Kolkata"),("1278994", "Allahābād", "Аллахабад", "IN", "356", "", "36", "175", "", "25.44478", "81.84322", "Asia/Kolkata"),("1279005", "Alīpur", "", "IN", "356", "", "07", "090", "", "28.79862", "77.13314", "Asia/Kolkata"),("1279017", "Alīgarh", "Алигарх", "IN", "356", "", "36", "143", "", "27.88145", "78.07464", "Asia/Kolkata"),("1279023", "Alīganj", "", "IN", "356", "", "36", "201", "", "27.49358", "79.17127", "Asia/Kolkata"),("1279027", "Alībāg", "", "IN", "356", "", "16", "520", "", "18.64813", "72.87579", "Asia/Kolkata"),("1279045", "Aldona", "", "IN", "356", "", "33", "585", "", "15.59337", "73.87482", "Asia/Kolkata"),("1279050", "Alāwalpur", "", "IN", "356", "", "23", "037", "", "31.43161", "75.65614", "Asia/Kolkata"),("1279056", "Ālappākkam", "", "IN", "356", "", "25", "617", "", "11.59895", "79.71893", "Asia/Kolkata"),("1279058", "Ālangulam", "", "IN", "356", "", "25", "628", "", "8.86404", "77.49937", "Asia/Kolkata"),("1279059", "Ālangudi", "", "IN", "356", "", "25", "621", "", "10.3606", "78.98492", "Asia/Kolkata"),("1279061", "Alangāyam", "", "IN", "356", "", "25", "605", "", "12.62235", "78.75207", "Asia/Kolkata"),("1279062", "Alangānallūr", "", "IN", "356", "", "25", "623", "", "10.0469", "78.09061", "Asia/Kolkata"),("1279064", "Alandur", "", "IN", "356", "", "25", "604", "", "13.0025", "80.20611", "Asia/Kolkata"),("1279066", "Alandi", "", "IN", "356", "", "16", "521", "", "18.67756", "73.89868", "Asia/Kolkata"),("1279068", "Aland", "", "IN", "356", "", "19", "579", "", "17.56425", "76.56854", "Asia/Kolkata"),("1279072", "Alampur", "", "IN", "356", "", "35", "420", "", "26.02514", "78.79697", "Asia/Kolkata"),("1279074", "Ālampur", "", "IN", "356", "", "40", "538", "", "15.87987", "78.13352", "Asia/Kolkata"),("1279084", "Alagāpuram", "", "IN", "356", "", "25", "607", "", "11.88705", "78.91758", "Asia/Kolkata"),("1279094", "Akot", "", "IN", "356", "", "16", "501", "", "21.0963", "77.0588", "Asia/Kolkata"),("1279105", "Akola", "Акола", "IN", "356", "", "16", "501", "", "20.70957", "76.9981", "Asia/Kolkata"),("1279110", "Akodia", "", "IN", "356", "", "35", "436", "", "23.38027", "76.59875", "Asia/Kolkata"),("1279115", "Aklera", "", "IN", "356", "", "24", "129", "", "24.41288", "76.56719", "Asia/Kolkata"),("1279123", "Akivīdu", "", "IN", "356", "", "02", "546", "", "16.58225", "81.38112", "Asia/Kolkata"),("1279126", "Akhnūr", "", "IN", "356", "", "12", "021", "", "32.86667", "74.73333", "Asia/Kolkata"),("1279134", "Akbarpur", "", "IN", "356", "", "36", "178", "", "26.42953", "82.53431", "Asia/Kolkata"),("1279135", "Akbarpur", "", "IN", "356", "", "36", "163", "", "26.38371", "79.94926", "Asia/Kolkata"),("1279144", "Akaltara", "", "IN", "356", "", "37", "405", "", "22.02463", "82.42641", "Asia/Kolkata"),("1279147", "Akalkot", "", "IN", "356", "", "16", "526", "", "17.52532", "76.20611", "Asia/Kolkata"),("1279148", "Akālgarh", "", "IN", "356", "", "23", "053", "", "29.82074", "75.89078", "Asia/Kolkata"),("1279154", "Ajra", "", "IN", "356", "", "16", "530", "", "16.11601", "74.21097", "Asia/Kolkata"),("1279158", "Ajnāla", "", "IN", "356", "", "23", "049", "", "31.84473", "74.76295", "Asia/Kolkata"),("1279159", "Ajmer", "Аджмер", "IN", "356", "", "24", "119", "", "26.4521", "74.63867", "Asia/Kolkata"),("1279161", "Ajjampur", "", "IN", "356", "", "19", "570", "", "13.72794", "76.0068", "Asia/Kolkata"),("1279181", "Ajaigarh", "", "IN", "356", "", "35", "426", "", "24.89879", "80.25921", "Asia/Kolkata"),("1279186", "Aizawl", "Аиджал", "IN", "356", "", "31", "283", "", "23.72894", "92.71791", "Asia/Kolkata"),("1279213", "Ahwa", "", "IN", "356", "", "09", "489", "", "20.75718", "73.68626", "Asia/Kolkata"),("1279219", "Ahraura", "", "IN", "356", "", "36", "199", "", "25.01579", "83.03294", "Asia/Kolkata"),("1279225", "Ahmadpur", "", "IN", "356", "", "28", "334", "", "23.83009", "87.68661", "Asia/Kolkata"),("1279227", "Ahmadpur", "", "IN", "356", "", "16", "524", "", "18.70622", "76.93731", "Asia/Kolkata"),("1279228", "Ahmadnagar", "", "IN", "356", "", "16", "522", "", "19.09457", "74.73843", "Asia/Kolkata"),("1279233", "Ahmedabad", "Ахмадабад", "IN", "356", "", "09", "474", "", "23.02579", "72.58727", "Asia/Kolkata"),("1279237", "Ahiri", "", "IN", "356", "", "16", "508", "", "19.41386", "80.00359", "Asia/Kolkata"),("1279259", "Agra", "Агра", "IN", "356", "", "36", "146", "", "27.18333", "78.01667", "Asia/Kolkata"),("1279290", "Agartala", "Агартала", "IN", "356", "", "26", "289", "", "23.83605", "91.27939", "Asia/Kolkata"),("1279299", "Agar", "Агар-агар", "IN", "356", "", "35", "436", "", "23.71177", "76.01571", "Asia/Kolkata"),("1279306", "Afzalpur", "", "IN", "356", "", "19", "579", "", "17.19986", "76.36018", "Asia/Kolkata"),("1279307", "Afzalgarh", "", "IN", "356", "", "36", "134", "", "29.3937", "78.67393", "Asia/Kolkata"),("1279318", "Aduthurai", "", "IN", "356", "", "25", "620", "", "11.01542", "79.48093", "Asia/Kolkata"),("1279323", "Adūr", "", "IN", "356", "", "13", "599", "", "9.16667", "76.73333", "Asia/Kolkata"),("1279334", "Adra", "Адра", "IN", "356", "", "28", "340", "", "23.49668", "86.68363", "Asia/Kolkata"),("1279335", "Ādoni", "Адони", "IN", "356", "", "02", "552", "", "15.62788", "77.27495", "Asia/Kolkata"),("1279344", "Ādilābād", "", "IN", "356", "", "40", "532", "", "19.67203", "78.5359", "Asia/Kolkata"),("1279356", "Addanki", "", "IN", "356", "", "02", "549", "", "15.81061", "79.97338", "Asia/Kolkata"),("1279373", "Adalaj", "", "IN", "356", "", "09", "473", "", "23.16453", "72.58107", "Asia/Kolkata"),("1279382", "Achhnera", "", "IN", "356", "", "36", "146", "", "27.17826", "77.75674", "Asia/Kolkata"),("1279390", "Achalpur", "", "IN", "356", "", "16", "503", "", "21.25665", "77.51006", "Asia/Kolkata"),("1279394", "Ābu Road", "", "IN", "356", "", "24", "117", "", "24.48012", "72.78186", "Asia/Kolkata"),("1279396", "Ābu", "Абу", "IN", "356", "", "24", "117", "", "24.59365", "72.71756", "Asia/Kolkata"),("1279403", "Abohar", "", "IN", "356", "", "23", "043", "", "30.14453", "74.19552", "Asia/Kolkata"),("1279405", "Abirāmam", "", "IN", "356", "", "25", "626", "", "9.44125", "78.44065", "Asia/Kolkata"),("1279407", "Abhayāpuri", "", "IN", "356", "", "03", "319", "", "26.32255", "90.68526", "Asia/Kolkata"),("1344069", "Contai", "", "IN", "356", "", "28", "345", "", "21.77985", "87.74892", "Asia/Kolkata"),("1344377", "Haldia", "", "IN", "356", "", "28", "345", "", "22.06046", "88.10975", "Asia/Kolkata"),("1348562", "Srirāmpur", "", "IN", "356", "", "28", "338", "", "22.94849", "88.01954", "Asia/Kolkata"),("1348581", "Haripur", "", "IN", "356", "", "28", "338", "", "22.93611", "88.23194", "Asia/Kolkata"),("1348583", "Kesabpur", "", "IN", "356", "", "28", "338", "", "22.96833", "88.26278", "Asia/Kolkata"),("1348600", "Rāmchandrapur", "", "IN", "356", "", "28", "337", "", "22.89639", "88.47528", "Asia/Kolkata"),("1348615", "Bāgnān", "", "IN", "356", "", "28", "338", "", "22.93338", "88.13856", "Asia/Kolkata"),("1348671", "Rāmnagar", "", "IN", "356", "", "28", "338", "", "22.77778", "88.24639", "Asia/Kolkata"),("1348676", "Sankarpur", "", "IN", "356", "", "28", "337", "", "22.84839", "88.45126", "Asia/Kolkata"),("1348694", "Begampur", "", "IN", "356", "", "28", "338", "", "22.7307", "88.25764", "Asia/Kolkata"),("1348734", "Parbatipur", "", "IN", "356", "", "28", "341", "", "22.6625", "88.22222", "Asia/Kolkata"),("1348737", "Bhandārdaha", "", "IN", "356", "", "28", "341", "", "22.61476", "88.1919", "Asia/Kolkata"),("1348739", "Dumjor", "", "IN", "356", "", "28", "341", "", "22.61993", "88.24566", "Asia/Kolkata"),("1348742", "Krishnapur", "", "IN", "356", "", "28", "338", "", "22.67028", "88.26944", "Asia/Kolkata"),("1348747", "Bankra", "", "IN", "356", "", "28", "341", "", "22.60291", "88.27751", "Asia/Kolkata"),("1348753", "Chakapara", "", "IN", "356", "", "28", "341", "", "22.63222", "88.34861", "Asia/Kolkata"),("1348775", "Mahiari", "", "IN", "356", "", "28", "341", "", "22.58826", "88.23544", "Asia/Kolkata"),("1348776", "Masila", "", "IN", "356", "", "28", "341", "", "22.58083", "88.23278", "Asia/Kolkata"),("1348780", "Dhulagari", "", "IN", "356", "", "28", "341", "", "22.58213", "88.171", "Asia/Kolkata"),("1348785", "Pānchla", "", "IN", "356", "", "28", "341", "", "22.53665", "88.13785", "Asia/Kolkata"),("1348788", "Sāhāpur", "", "IN", "356", "", "28", "341", "", "22.52444", "88.16694", "Asia/Kolkata"),("1348789", "Raghudebbati", "", "IN", "356", "", "28", "341", "", "22.52556", "88.19583", "Asia/Kolkata"),("1348791", "Gobindapur", "", "IN", "356", "", "28", "341", "", "22.59306", "88.09139", "Asia/Kolkata"),("1348818", "Nangi", "", "IN", "356", "", "28", "343", "", "22.50833", "88.21528", "Asia/Kolkata"),("1348820", "Pujali", "", "IN", "356", "", "28", "343", "", "22.4711", "88.1453", "Asia/Kolkata"),("1348870", "Amtala", "", "IN", "356", "", "28", "343", "", "22.37046", "88.27864", "Asia/Kolkata"),("1348872", "Bāwāli", "", "IN", "356", "", "28", "343", "", "22.42563", "88.19336", "Asia/Kolkata"),("1348944", "Jāfarpur", "", "IN", "356", "", "28", "343", "", "22.31878", "88.2305", "Asia/Kolkata"),("1348947", "Serpur", "", "IN", "356", "", "28", "343", "", "22.32344", "88.30775", "Asia/Kolkata"),("1349041", "Monoharpur", "", "IN", "356", "", "28", "345", "", "22.10833", "88.07889", "Asia/Kolkata"),("1349047", "Solap", "", "IN", "356", "", "28", "345", "", "22.12778", "88.15861", "Asia/Kolkata"),("1349090", "Harindānga", "", "IN", "356", "", "28", "343", "", "22.03833", "88.32139", "Asia/Kolkata"),("1349229", "Gurdaha", "", "IN", "356", "", "28", "337", "", "22.73472", "88.75944", "Asia/Kolkata"),("1349247", "Ula", "", "IN", "356", "", "28", "337", "", "22.7225", "88.55556", "Asia/Kolkata"),("1349263", "Gopālpur", "", "IN", "356", "", "28", "337", "", "22.61845", "88.75119", "Asia/Kolkata"),("1349355", "Raypur", "", "IN", "356", "", "28", "343", "", "22.41083", "88.50944", "Asia/Kolkata"),("1349357", "Nabagrām", "", "IN", "356", "", "28", "343", "", "22.28806", "88.50917", "Asia/Kolkata"),("1430991", "Soyībug", "", "IN", "356", "", "12", "008", "", "34.07677", "74.7057", "Asia/Kolkata"),("1436610", "Chīma", "", "IN", "356", "", "23", "041", "", "30.6854", "76.08643", "Asia/Kolkata"),("1436767", "Kheri Sāmpla", "", "IN", "356", "", "10", "082", "", "28.7781", "76.7756", "Asia/Kolkata"),("1441210", "Chhutmalpur", "", "IN", "356", "", "36", "132", "", "30.03209", "77.75329", "Asia/Kolkata"),("1445156", "Singāpur", "", "IN", "356", "", "40", "537", "", "17.46982", "78.12574", "Asia/Kolkata"),("1445310", "Bālāpur", "", "IN", "356", "", "40", "537", "", "17.31018", "78.49969", "Asia/Kolkata"),("1445378", "Ghatkesar", "", "IN", "356", "", "40", "537", "", "17.45081", "78.68366", "Asia/Kolkata"),("1445624", "Chandūr", "", "IN", "356", "", "40", "535", "", "17.87455", "78.10017", "Asia/Kolkata"),("1462711", "Vadigenhalli", "", "IN", "356", "", "19", "583", "", "13.29724", "77.80184", "Asia/Kolkata"),("1462733", "Ādampur", "", "IN", "356", "", "23", "037", "", "31.43224", "75.71484", "Asia/Kolkata"),("1465595", "Chinnasekkadu", "", "IN", "356", "", "25", "602", "", "13.16089", "80.25727", "Asia/Kolkata"),("1465622", "Porur", "", "IN", "356", "", "25", "602", "", "13.03565", "80.15821", "Asia/Kolkata"),("1465624", "Manappakkam", "", "IN", "356", "", "25", "604", "", "13.01083", "80.16861", "Asia/Kolkata"),("1465825", "Madipakkam", "", "IN", "356", "", "25", "604", "", "12.96226", "80.19864", "Asia/Kolkata"),("1465828", "Perungudi", "", "IN", "356", "", "25", "604", "", "12.96095", "80.24094", "Asia/Kolkata"),("1465879", "Nandambakkam", "", "IN", "356", "", "25", "604", "", "12.97795", "80.06781", "Asia/Kolkata"),("1465910", "Madambakkam", "", "IN", "356", "", "25", "604", "", "12.8525", "80.04667", "Asia/Kolkata"),("1466027", "Vellānūr", "", "IN", "356", "", "25", "602", "", "13.15804", "80.10634", "Asia/Kolkata"),("6268046", "Kupwāra", "", "IN", "356", "", "12", "Kupwāra", "", "34.03056", "74.26417", "Asia/Kolkata"),("6324621", "Powai", "", "IN", "356", "", "16", "518", "", "19.1164", "72.90471", "Asia/Kolkata"),("6619347", "Navi Mumbai", "Нави Мумбаи", "IN", "356", "", "16", "517", "", "19.03681", "73.01582", "Asia/Kolkata"),("6621344", "Puttaparthi", "", "IN", "356", "", "02", "553", "", "14.1652", "77.8117", "Asia/Kolkata"),("6697165", "Canacona", "", "IN", "356", "", "19", "", "", "14.9959", "74.05056", "Asia/Kolkata"),("6941937", "Murudeshwara", "Мурудешвара", "IN", "356", "", "19", "", "", "14.0943", "74.4845", "Asia/Kolkata"),("6943660", "Shivaji Nagar", "", "IN", "356", "", "16", "521", "", "18.53017", "73.85263", "Asia/Kolkata"),("6954929", "Greater Noida", "", "IN", "356", "", "36", "141", "7279602", "28.49615", "77.53601", "Asia/Kolkata"),("6992326", "Mohali", "", "IN", "356", "", "23", "052", "", "30.67995", "76.72211", "Asia/Kolkata"),("7117985", "Banbasa", "", "IN", "356", "", "36", "", "", "28.99132", "80.07608", "Asia/Kolkata"),("7180617", "vadlamuru", "", "IN", "356", "", "02", "545", "", "17.09545", "82.16565", "Asia/Kolkata"),("7279595", "Pithampur", "", "IN", "356", "", "35", "439", "", "22.60197", "75.69649", "Asia/Kolkata"),("7279597", "Barbil", "", "IN", "356", "", "21", "375", "", "21.65685", "85.64349", "Asia/Kolkata"),("7279599", "Airoli", "", "IN", "356", "", "16", "517", "", "19.15096", "72.99625", "Asia/Kolkata"),("7279600", "Aluva", "", "IN", "356", "", "13", "595", "", "10.10764", "76.35158", "Asia/Kolkata"),("7279734", "Kotkapura", "", "IN", "356", "", "23", "045", "", "30.5819", "74.83298", "Asia/Kolkata"),("7279735", "Muvattupuzha", "", "IN", "356", "", "13", "595", "", "9.97985", "76.57381", "Asia/Kolkata"),("7279739", "Perumbavoor", "", "IN", "356", "", "13", "595", "", "10.10695", "76.47366", "Asia/Kolkata"),("7279741", "Vapi", "", "IN", "356", "", "09", "491", "", "20.37175", "72.90493", "Asia/Kolkata"),("7279742", "Baddi", "", "IN", "356", "", "11", "031", "", "30.95783", "76.79136", "Asia/Kolkata"),("7279746", "Noida", "Ноида", "IN", "356", "", "36", "141", "7279602", "28.58", "77.33", "Asia/Kolkata"),("7279747", "Bhiwadi", "", "IN", "356", "", "24", "104", "", "28.21024", "76.86056", "Asia/Kolkata"),("7279750", "Parwanoo", "", "IN", "356", "", "11", "031", "", "30.83716", "76.96143", "Asia/Kolkata"),("7279752", "Mandideep", "", "IN", "356", "", "35", "446", "", "23.08166", "77.53328", "Asia/Kolkata"),("7279754", "Singrauli", "", "IN", "356", "", "35", "463", "", "24.19973", "82.67535", "Asia/Kolkata"),("7284803", "Birpara", "", "IN", "356", "", "28", "328", "", "26.70421", "89.14547", "Asia/Kolkata"),("7284820", "Jaigaon", "", "IN", "356", "", "28", "328", "", "26.84766", "89.37558", "Asia/Kolkata"),("7290222", "Periyapattinam", "", "IN", "356", "", "25", "626", "", "9.27263", "78.90232", "Asia/Kolkata"),("7302453", "Vagator", "", "IN", "356", "", "33", "585", "", "15.59766", "73.74496", "Asia/Kolkata"),("7302805", "Akkarampalle", "", "IN", "356", "", "02", "554", "", "13.65", "79.42", "Asia/Kolkata"),("7302806", "Bellampalli", "", "IN", "356", "", "40", "532", "", "19.05577", "79.493", "Asia/Kolkata"),("7302808", "Chemmumiahpet", "", "IN", "356", "", "02", "549", "", "15.89794", "79.32129", "Asia/Kolkata"),("7302810", "Gaddi Annaram", "", "IN", "356", "", "40", "537", "", "17.36687", "78.5242", "Asia/Kolkata"),("7302812", "Dasnapur", "", "IN", "356", "", "40", "532", "", "19.65399", "78.51213", "Asia/Kolkata"),("7302825", "Kanuru", "", "IN", "356", "", "02", "547", "", "16.28584", "81.25464", "Asia/Kolkata"),("7302826", "Lal Bahadur Nagar", "", "IN", "356", "", "40", "537", "", "17.34769", "78.55757", "Asia/Kolkata"),("7302828", "Malkajgiri", "", "IN", "356", "", "40", "536", "", "17.44781", "78.52633", "Asia/Kolkata"),("7302829", "Mandamarri", "", "IN", "356", "", "40", "532", "", "18.96506", "79.47475", "Asia/Kolkata"),("7302830", "Chinnachowk", "", "IN", "356", "", "02", "551", "", "14.47516", "78.8354", "Asia/Kolkata"),("7302832", "Kyathampalle", "", "IN", "356", "", "40", "532", "", "19.66781", "78.5289", "Asia/Kolkata"),("7302833", "Gajuwaka", "", "IN", "356", "", "02", "544", "", "17.7", "83.21667", "Asia/Kolkata"),("7302836", "Manuguru", "", "IN", "356", "", "40", "541", "", "17.98102", "80.7547", "Asia/Kolkata"),("7302838", "Kalyandurg", "", "IN", "356", "", "02", "553", "", "14.54519", "77.10552", "Asia/Kolkata"),("7302844", "Ponnur", "", "IN", "356", "", "02", "548", "", "16.07114", "80.54944", "Asia/Kolkata"),("7302845", "Quthbullapur", "", "IN", "356", "", "40", "537", "", "17.50107", "78.45818", "Asia/Kolkata"),("7302846", "Ramanayyapeta", "", "IN", "356", "", "02", "545", "", "16.94516", "82.2385", "Asia/Kolkata"),("7302847", "Palwancha", "", "IN", "356", "", "40", "541", "", "17.58152", "80.67651", "Asia/Kolkata"),("7302849", "Barpeta Road", "", "IN", "356", "", "03", "303", "", "26.50284", "90.96937", "Asia/Kolkata"),("7302851", "Sathupalli", "", "IN", "356", "", "40", "541", "", "17.24968", "80.86899", "Asia/Kolkata"),("7302853", "Yanamalakuduru", "", "IN", "356", "", "02", "547", "", "16.48531", "80.66746", "Asia/Kolkata"),("7302854", "Morigaon", "", "IN", "356", "", "03", "304", "", "26.24908", "92.34764", "Asia/Kolkata"),("7302855", "Naharlagun", "", "IN", "356", "", "30", "248", "", "27.10467", "93.69518", "Asia/Kolkata"),("7302856", "Serilingampalle", "", "IN", "356", "", "40", "535", "", "17.49313", "78.30196", "Asia/Kolkata"),("7302857", "Silapathar", "", "IN", "356", "", "03", "308", "", "27.59441", "94.72402", "Asia/Kolkata"),("7302858", "Sarupathar", "", "IN", "356", "", "03", "314", "", "26.206", "96.81", "Asia/Rangoon"),("7302859", "Lumding Railway Colony", "", "IN", "356", "", "03", "305", "", "25.74903", "93.16998", "Asia/Kolkata"),("7302860", "Aistala", "", "IN", "356", "", "28", "336", "", "23.18", "88.58", "Asia/Kolkata"),("7302861", "Ashoknagar Kalyangarh", "", "IN", "356", "", "28", "337", "", "22.86416", "88.63701", "Asia/Kolkata"),("7302862", "Bahula", "", "IN", "356", "", "28", "335", "", "23.65176", "87.16475", "Asia/Kolkata"),("7303913", "Pavuluru", "", "IN", "356", "", "02", "549", "", "15.85292", "80.16468", "Asia/Kolkata"),("7303983", "Jhulasan", "", "IN", "356", "", "09", "471", "", "23.3286", "72.47314", "Asia/Kolkata"),("7626554", "Bhawanipur", "", "IN", "356", "", "34", "208", "", "26.45352", "87.02744", "Asia/Kolkata"),("7645176", "Zira", "", "IN", "356", "", "23", "043", "", "30.96853", "74.99106", "Asia/Kolkata"),("8199556", "Artist Village", "", "IN", "356", "", "16", "517", "", "19.03227", "73.04276", "Asia/Kolkata"),("8347656", "Ramagundam", "", "IN", "356", "", "40", "534", "", "18.755", "79.474", "Asia/Kolkata"),("8504418", "Cherpulassery", "", "IN", "356", "", "13", "593", "", "10.87655", "76.30932", "Asia/Kolkata"),("8581647", "Kirandul", "", "IN", "356", "", "37", "416", "", "18.63649", "81.25827", "Asia/Kolkata"),("8593959", "Dayapar", "", "IN", "356", "", "09", "468", "", "23.63371", "68.90192", "Asia/Kolkata"),("8714565", "Shiraguppi", "", "IN", "356", "", "16", "", "", "16.61875", "74.70907", "Asia/Kolkata"),("8948694", "V.S.K.Valasai (Dindigul-Dist.)", "В.С.К.Валасаи", "IN", "356", "", "25", "612", "", "10.31549", "78.15141", "Asia/Kolkata"),("8985894", "Gangadharpur", "", "IN", "356", "", "28", "338", "", "22.7556", "88.22128", "Asia/Kolkata"),("9212568", "Neelankarai", "", "IN", "356", "", "25", "604", "", "12.9495", "80.2592", "Asia/Kolkata"),("9212569", "Injambakkam", "", "IN", "356", "", "25", "604", "", "12.9162", "80.2488", "Asia/Kolkata"),("9212571", "Palavakkam", "", "IN", "356", "", "25", "604", "", "12.9535", "80.2572", "Asia/Kolkata"),("9781227", "Kultali", "", "IN", "356", "", "28", "343", "", "21.9", "88.4", "Asia/Kolkata"),("9794300", "Shahbazpur", "", "IN", "356", "", "34", "209", "", "26.30511", "87.28865", "Asia/Kolkata"),("10627510", "Kumbalam", "", "IN", "356", "", "13", "595", "", "9.9063", "76.31127", "Asia/Kolkata"),("10628607", "Aroor", "", "IN", "356", "", "13", "598", "", "9.8694", "76.30498", "Asia/Kolkata"),("10628608", "Kadakkavoor", "", "IN", "356", "", "13", "601", "", "8.67921", "76.76714", "Asia/Kolkata"),("10629189", "Kalavoor", "", "IN", "356", "", "13", "598", "", "9.57046", "76.32756", "Asia/Kolkata"),("10630431", "Kalamassery", "", "IN", "356", "", "13", "595", "", "10.0614", "76.32631", "Asia/Kolkata"),("10792588", "Cherthala", "", "IN", "356", "", "13", "598", "", "9.68444", "76.33558", "Asia/Kolkata"),("10793684", "Kunnumma", "", "IN", "356", "", "13", "598", "", "9.35672", "76.41343", "Asia/Kolkata"),("11102685", "Abrama", "", "IN", "356", "", "09", "490", "", "20.85865", "72.90648", "Asia/Kolkata"),("11185528", "Malkapur", "", "IN", "356", "", "16", "527", "", "17.26214", "74.17574", "Asia/Kolkata"),("89570", "Zaxo", "Заху", "IQ", "368", "", "08", "89569", "", "37.14871", "42.68591", "Asia/Baghdad"),("89824", "Umm Qaşr", "", "IQ", "368", "", "02", "98247", "", "30.0362", "47.91951", "Asia/Baghdad"),("90026", "Tozkhurmato", "", "IQ", "368", "", "18", "9166598", "", "34.88808", "44.63256", "Asia/Baghdad"),("90150", "Tikrīt", "Тикрит", "IQ", "368", "", "18", "90148", "", "34.61581", "43.67861", "Asia/Baghdad"),("90353", "Tallkayf", "Талль-Кайф", "IQ", "368", "", "15", "9166618", "", "36.49109", "43.12026", "Asia/Baghdad"),("90708", "Sīnah", "", "IQ", "368", "", "08", "9166607", "", "36.80752", "43.03831", "Asia/Baghdad"),("91597", "Sāmarrā’", "", "IQ", "368", "", "18", "6783103", "", "34.1959", "43.88568", "Asia/Baghdad"),("91812", "Nāḩīyat Saddat al Hindīyah", "", "IQ", "368", "", "06", "99040", "", "32.71557", "44.27857", "Asia/Baghdad"),("92002", "Ruwāndiz", "Равандуз", "IQ", "368", "", "11", "9166592", "", "36.61207", "44.52372", "Asia/Baghdad"),("92004", "Rāwah", "", "IQ", "368", "", "01", "9166650", "", "34.48229", "41.91898", "Asia/Baghdad"),("92430", "Al-Hamdaniya", "", "IQ", "368", "", "15", "9166541", "", "36.27093", "43.37758", "Asia/Baghdad"),("93709", "Mandalī", "Мандали", "IQ", "368", "", "10", "9166680", "", "33.7481", "45.55503", "Asia/Baghdad"),("94220", "Koysinceq", "", "IQ", "368", "", "11", "9166588", "", "36.08289", "44.62873", "Asia/Baghdad"),("94298", "Kifrī", "Кифри", "IQ", "368", "", "10", "94296", "", "34.68963", "44.96057", "Asia/Baghdad"),("94787", "Kirkuk", "Киркук", "IQ", "368", "", "13", "94786", "", "35.46806", "44.39222", "Asia/Baghdad"),("94824", "Karbala", "Кербела", "IQ", "368", "", "12", "94822", "", "32.61603", "44.02488", "Asia/Baghdad"),("95446", "Erbil", "", "IQ", "368", "", "11", "95444", "", "36.19257", "44.01062", "Asia/Baghdad"),("95788", "Hīt", "", "IQ", "368", "", "01", "9166579", "", "33.63664", "42.82768", "Asia/Baghdad"),("96205", "Ḩalabjah", "Халабджа", "IQ", "368", "", "05", "96204", "", "35.17778", "45.98611", "Asia/Baghdad"),("96309", "Ḩadīthah", "Хадита", "IQ", "368", "", "01", "6765480", "", "34.13661", "42.37727", "Asia/Baghdad"),("96994", "Dihok", "", "IQ", "368", "", "08", "97269", "", "36.86709", "42.98845", "Asia/Baghdad"),("97417", "Jamjamāl", "", "IQ", "368", "", "05", "97416", "", "35.53356", "44.8343", "Asia/Baghdad"),("97783", "Bayjī", "Байджи", "IQ", "368", "", "18", "6872046", "", "34.92915", "43.48878", "Asia/Baghdad"),("97990", "Baqubah", "", "IQ", "368", "", "10", "99063", "", "33.75403", "44.60518", "Asia/Baghdad"),("98012", "Baynjiwayn", "", "IQ", "368", "", "05", "9166684", "", "35.62329", "45.94714", "Asia/Baghdad"),("98112", "Balad", "Балада", "IQ", "368", "", "18", "6805736", "", "34.01485", "44.14574", "Asia/Baghdad"),("98182", "Baghdad", "Багдад", "IQ", "368", "", "07", "9166668", "", "33.34058", "44.40088", "Asia/Baghdad"),("98245", "Az Zubayr", "", "IQ", "368", "", "02", "98247", "", "30.39213", "47.70175", "Asia/Baghdad"),("98459", "Aş Şuwayrah", "Сувайра", "IQ", "368", "", "16", "98460", "", "32.92556", "44.77583", "Asia/Baghdad"),("98463", "As Sulaymānīyah", "Сулеймания", "IQ", "368", "", "05", "98464", "", "35.56496", "45.4329", "Asia/Baghdad"),("98530", "As Samawah", "Самава", "IQ", "368", "", "03", "98532", "", "31.33198", "45.2944", "Asia/Baghdad"),("98589", "Nāḩiyat ash Shināfīyah", "", "IQ", "368", "", "04", "6850588", "", "31.58376", "44.64675", "Asia/Baghdad"),("98622", "Ash Shaţrah", "", "IQ", "368", "", "09", "98623", "", "31.40906", "46.1727", "Asia/Baghdad"),("98629", "Ash Shāmīyah", "", "IQ", "368", "", "04", "98634", "", "31.96257", "44.60075", "Asia/Baghdad"),("98677", "Ar Ruţbah", "", "IQ", "368", "", "01", "98678", "", "33.03718", "40.28586", "Asia/Baghdad"),("98685", "Ar Rumaythah", "", "IQ", "368", "", "03", "9166568", "", "31.52845", "45.20377", "Asia/Baghdad"),("98717", "Ramadi", "", "IQ", "368", "", "01", "98718", "", "33.42056", "43.30778", "Asia/Baghdad"),("98822", "‘Aqrah", "", "IQ", "368", "", "15", "98820", "", "36.73322", "43.87964", "Asia/Baghdad"),("98854", "An Nāşirīyah", "Насирия", "IQ", "368", "", "09", "98855", "", "31.05799", "46.25726", "Asia/Baghdad"),("98860", "Najaf", "Ан-Наджаф", "IQ", "368", "", "17", "9166629", "", "32.02594", "44.34625", "Asia/Baghdad"),("98885", "‘Anat al Qadīmah", "", "IQ", "368", "", "01", "9166650", "", "34.46934", "41.94223", "Asia/Baghdad"),("99010", "Imam Qasim", "Аль-Касим", "IQ", "368", "", "06", "99358", "", "32.29799", "44.68282", "Asia/Baghdad"),("99039", "Al Musayyib", "Аль-Эль-Мусайибе", "IQ", "368", "", "06", "99040", "", "32.77872", "44.29005", "Asia/Baghdad"),("99060", "Al Mishkhāb", "", "IQ", "368", "", "17", "9166552", "", "31.80437", "44.4893", "Asia/Baghdad"),("99062", "Al Miqdādīyah", "", "IQ", "368", "", "10", "99063", "", "33.97861", "44.93694", "Asia/Baghdad"),("99071", "Al Mawşil al Jadīdah", "", "IQ", "368", "", "15", "9166649", "", "36.33271", "43.10555", "Asia/Baghdad"),("99072", "Mosul", "Мосул", "IQ", "368", "", "15", "9166649", "", "36.335", "43.11889", "Asia/Baghdad"),("99131", "Al Kūt", "", "IQ", "368", "", "16", "99132", "", "32.5128", "45.81817", "Asia/Baghdad"),("99135", "Kufa", "Эль-Куфа", "IQ", "368", "", "17", "9166629", "", "32.05114", "44.44017", "Asia/Baghdad"),("99169", "Khāliş", "Аль-Халиса", "IQ", "368", "", "10", "99063", "", "33.80809", "44.53343", "Asia/Baghdad"),("99306", "‘Alī al Gharbī", "", "IQ", "368", "", "14", "99305", "", "32.46186", "46.68794", "Asia/Baghdad"),("99344", "Al Hindīyah", "", "IQ", "368", "", "12", "", "", "32.54671", "44.22765", "Asia/Baghdad"),("99347", "Al Ḩillah", "Аль-Хилла", "IQ", "368", "", "06", "99040", "", "32.46367", "44.41963", "Asia/Baghdad"),("99350", "Al Ḩayy", "Аль-Хая", "IQ", "368", "", "16", "99351", "", "32.17419", "46.04345", "Asia/Baghdad"),("99369", "Al Hārithah", "Аль-Харриса", "IQ", "368", "", "02", "99534", "", "30.58481", "47.76114", "Asia/Baghdad"),("99434", "Nahiyat Ghammas", "", "IQ", "368", "", "04", "98634", "", "31.74311", "44.6196", "Asia/Baghdad"),("99439", "Nāḩiyat al Fuhūd", "", "IQ", "368", "", "09", "90509", "", "30.96972", "46.72278", "Asia/Baghdad"),("99446", "Al Fāw", "Аль-Фау", "IQ", "368", "", "02", "9166549", "", "29.97421", "48.47309", "Asia/Baghdad"),("99454", "Al Fallūjah", "", "IQ", "368", "", "01", "99455", "", "33.34913", "43.78599", "Asia/Baghdad"),("99532", "Basrah", "Басра", "IQ", "368", "", "02", "99534", "", "30.50852", "47.7804", "Asia/Baghdad"),("99548", "Al ‘Azīzīyah", "", "IQ", "368", "", "16", "9166961", "", "32.90941", "45.06359", "Asia/Baghdad"),("99608", "Al ‘Amārah", "", "IQ", "368", "", "14", "99610", "", "31.83561", "47.14483", "Asia/Baghdad"),("99738", "‘Afak", "Афак", "IQ", "368", "", "04", "99737", "", "32.0643", "45.24743", "Asia/Baghdad"),("99759", "Ad Dujayl", "", "IQ", "368", "", "18", "9166616", "", "33.84667", "44.23444", "Asia/Baghdad"),("99762", "Ad Dīwānīyah", "Дивания", "IQ", "368", "", "04", "99763", "", "31.99289", "44.92552", "Asia/Baghdad"),("100077", "Abū Ghurayb", "Абу-Грейб", "IQ", "368", "", "07", "9166542", "", "33.30563", "44.18477", "Asia/Baghdad"),("388349", "Al Başrah al Qadīmah", "", "IQ", "368", "", "02", "99534", "", "30.50316", "47.81507", "Asia/Baghdad"),("448149", "Sinjār", "", "IQ", "368", "", "15", "9166620", "", "36.3209", "41.87656", "Asia/Baghdad"),("6765385", "‘Anah", "", "IQ", "368", "", "01", "98884", "", "34.36857", "41.98194", "Asia/Baghdad"),("14256", "Āzādshahr", "", "IR", "364", "", "09", "", "", "34.79049", "48.57011", "Asia/Tehran"),("23814", "Kahrīz", "", "IR", "364", "", "13", "", "", "34.3838", "47.0553", "Asia/Tehran"),("24851", "Nūrābād", "Нурабад", "IR", "364", "", "23", "", "", "34.0734", "47.9725", "Asia/Tehran"),("32723", "Īstgāh-e Rāh Āhan-e Garmsār", "", "IR", "364", "", "25", "", "", "35.23455", "52.30942", "Asia/Tehran"),("32767", "Qarchak", "", "IR", "364", "", "26", "", "", "35.42867", "51.57544", "Asia/Tehran"),("32904", "Shahrak-e Emām Ḩasan", "", "IR", "364", "", "26", "", "", "35.48846", "51.34567", "Asia/Tehran"),("32909", "Shahre Jadide Andisheh", "", "IR", "364", "", "26", "", "", "35.6803", "51.0193", "Asia/Tehran"),("39874", "Āq Qāyeh", "", "IR", "364", "", "37", "", "", "37.27472", "55.15889", "Asia/Tehran"),("41210", "Khorramdarreh", "", "IR", "364", "", "36", "", "", "36.20898", "49.19152", "Asia/Tehran"),("66093", "Yasuj", "Ясудж", "IR", "364", "", "05", "", "", "30.66824", "51.58796", "Asia/Tehran"),("110831", "Āzādshahr", "", "IR", "364", "", "37", "", "", "37.08641", "55.17222", "Asia/Tehran"),("111421", "Zarand", "", "IR", "364", "", "29", "", "", "30.81271", "56.56399", "Asia/Tehran"),("111453", "Zanjān", "Зенджан", "IR", "364", "", "36", "", "", "36.67642", "48.49628", "Asia/Tehran"),("111822", "Yazd", "Йезд", "IR", "364", "", "40", "", "", "31.89722", "54.3675", "Asia/Tehran"),("112214", "Varāmīn", "Варамин", "IR", "364", "", "26", "", "", "35.3242", "51.6457", "Asia/Tehran"),("112646", "Torbat-e Ḩeydarīyeh", "", "IR", "364", "", "42", "", "", "35.27401", "59.21949", "Asia/Tehran"),("112656", "Tonekābon", "Тонекабон", "IR", "364", "", "35", "", "", "36.81626", "50.87376", "Asia/Tehran"),("112931", "Tehran", "Тегеран", "IR", "364", "", "26", "", "", "35.69439", "51.42151", "Asia/Tehran"),("113343", "Hashtpar", "", "IR", "364", "", "08", "", "", "37.79658", "48.90521", "Asia/Tehran"),("113491", "Tākestān", "", "IR", "364", "", "38", "", "", "36.0696", "49.6959", "Asia/Tehran"),("113508", "Takāb", "", "IR", "364", "", "01", "", "", "36.4009", "47.1133", "Asia/Tehran"),("113632", "Taft", "Тафт", "IR", "364", "", "40", "", "", "31.74384", "54.20278", "Asia/Tehran"),("113636", "Tafresh", "", "IR", "364", "", "34", "", "", "34.69307", "50.01601", "Asia/Tehran"),("113646", "Tabriz", "Тебриз", "IR", "364", "", "33", "", "", "38.08", "46.2919", "Asia/Tehran"),("113659", "Tabas", "Табас", "IR", "364", "", "40", "", "", "33.59586", "56.92437", "Asia/Tehran"),("114049", "Sonqor", "", "IR", "364", "", "13", "", "", "34.78187", "47.59945", "Asia/Tehran"),("114259", "Sirjan", "", "IR", "364", "", "29", "", "", "29.45137", "55.6809", "Asia/Tehran"),("114584", "Shūshtar", "Шуштэр", "IR", "364", "", "15", "", "", "32.04972", "48.84843", "Asia/Tehran"),("114593", "Shūsh", "Сузы", "IR", "364", "", "15", "", "", "32.1942", "48.2436", "Asia/Tehran"),("114930", "Shīrvān", "", "IR", "364", "", "43", "", "", "37.39669", "57.92952", "Asia/Tehran"),("115019", "Shiraz", "Шираз", "IR", "364", "", "07", "", "", "29.61031", "52.53113", "Asia/Tehran"),("115388", "Sharīfābād", "", "IR", "364", "", "26", "", "", "35.4275", "51.78528", "Asia/Tehran"),("115770", "Shahr-e Kord", "Шахре-Корд", "IR", "364", "", "03", "", "", "32.32556", "50.86444", "Asia/Tehran"),("115781", "Shahr-e Bābak", "", "IR", "364", "", "29", "", "", "30.1165", "55.1186", "Asia/Tehran"),("116102", "Shādegān", "Шадеганские", "IR", "364", "", "15", "", "", "30.64924", "48.66497", "Asia/Tehran"),("116402", "Semnān", "Семнан", "IR", "364", "", "25", "", "", "35.57691", "53.39205", "Asia/Tehran"),("116406", "Semīrom", "", "IR", "364", "", "28", "", "", "31.41667", "51.56667", "Asia/Tehran"),("116667", "Sāveh", "Сава", "IR", "364", "", "34", "", "", "35.0213", "50.3566", "Asia/Tehran"),("116996", "Sari", "Сари", "IR", "364", "", "35", "", "", "36.56332", "53.06009", "Asia/Tehran"),("117392", "Saqqez", "", "IR", "364", "", "16", "", "", "36.24992", "46.2735", "Asia/Tehran"),("117574", "Sanandaj", "Сенендедж", "IR", "364", "", "16", "", "", "35.31495", "46.99883", "Asia/Tehran"),("117656", "Salmās", "Салмас", "IR", "364", "", "01", "", "", "38.1973", "44.7653", "Asia/Tehran"),("117793", "Shāhīn Dezh", "", "IR", "364", "", "01", "", "", "36.6793", "46.5669", "Asia/Tehran"),("118063", "Sabzevar", "Себзевар", "IR", "364", "", "42", "", "", "36.2126", "57.68191", "Asia/Tehran"),("118191", "Rūdsar", "", "IR", "364", "", "08", "", "", "37.13761", "50.288", "Asia/Tehran"),("118367", "Robāţ Karīm", "", "IR", "364", "", "26", "", "", "35.4846", "51.0829", "Asia/Tehran"),("118704", "Rāvar", "", "IR", "364", "", "29", "", "", "31.26562", "56.80545", "Asia/Tehran"),("118743", "Rasht", "Решт", "IR", "364", "", "08", "", "", "37.27611", "49.58862", "Asia/Tehran"),("118805", "Rāmshīr", "", "IR", "364", "", "15", "", "", "30.89315", "49.40787", "Asia/Tehran"),("118826", "Rāmhormoz", "", "IR", "364", "", "15", "", "", "31.27997", "49.60351", "Asia/Tehran"),("118994", "Rafsanjān", "Рафсанджане", "IR", "364", "", "29", "", "", "30.4067", "55.9939", "Asia/Tehran"),("119115", "Qūchān", "", "IR", "364", "", "42", "", "", "37.106", "58.50955", "Asia/Tehran"),("119161", "Qorveh", "", "IR", "364", "", "16", "", "", "35.1664", "47.80564", "Asia/Tehran"),("119208", "Qom", "Кум", "IR", "364", "", "39", "", "", "34.6401", "50.8764", "Asia/Tehran"),("119374", "Qeshm", "Кешм", "IR", "364", "", "11", "449706", "", "26.9492", "56.2691", "Asia/Tehran"),("119505", "Qazvin", "Казвин", "IR", "364", "", "38", "", "", "36.26877", "50.0041", "Asia/Tehran"),("119730", "Qarah Ẕīā’ od Dīn", "", "IR", "364", "", "01", "", "", "38.8915", "45.0255", "Asia/Tehran"),("120678", "Farrokh Shahr", "", "IR", "364", "", "03", "", "", "32.27174", "50.98008", "Asia/Tehran"),("120694", "Qā’en", "", "IR", "364", "", "41", "", "", "33.72654", "59.18439", "Asia/Tehran"),("120931", "Sarpol-e Z̄ahāb", "", "IR", "364", "", "13", "", "", "34.46109", "45.86264", "Asia/Tehran"),("120972", "Pīshvā", "", "IR", "364", "", "26", "", "", "35.308", "51.7267", "Asia/Tehran"),("121110", "Piranshahr", "", "IR", "364", "", "01", "", "", "36.701", "45.1413", "Asia/Tehran"),("121240", "Pāveh", "", "IR", "364", "", "13", "", "", "35.0434", "46.3565", "Asia/Tehran"),("121380", "Pārsābād", "Парсабад", "IR", "364", "", "32", "", "", "39.6482", "47.9174", "Asia/Tehran"),("121795", "Oshnavīyeh", "Ошнуйе", "IR", "364", "", "01", "", "", "37.0397", "45.0983", "Asia/Tehran"),("121801", "Orūmīyeh", "Урмия", "IR", "364", "", "01", "", "", "37.55274", "45.07605", "Asia/Tehran"),("121861", "Omīdīyeh", "", "IR", "364", "", "15", "", "", "30.75972", "49.705", "Asia/Tehran"),("121925", "Nūrābād", "", "IR", "364", "", "07", "", "", "30.11405", "51.52174", "Asia/Tehran"),("121959", "Nowshahr", "", "IR", "364", "", "35", "449688", "", "36.64852", "51.49621", "Asia/Tehran"),("122285", "Nīshābūr", "Нишапур", "IR", "364", "", "42", "", "", "36.21329", "58.79575", "Asia/Tehran"),("122289", "Neyrīz", "", "IR", "364", "", "07", "", "", "29.1988", "54.3278", "Asia/Tehran"),("122397", "Nekā", "Нека", "IR", "364", "", "35", "", "", "36.65079", "53.29905", "Asia/Tehran"),("122438", "Naz̧arābād", "", "IR", "364", "", "44", "", "", "35.95411", "50.60607", "Asia/Tehran"),("122560", "Nashtārūd", "", "IR", "364", "", "35", "", "", "36.7509", "51.02362", "Asia/Tehran"),("122698", "Naqadeh", "", "IR", "364", "", "01", "", "", "36.9553", "45.388", "Asia/Tehran"),("122915", "Nahāvand", "Нагаванде", "IR", "364", "", "09", "", "", "34.19088", "48.37446", "Asia/Tehran"),("123485", "Mohr", "", "IR", "364", "", "07", "", "", "27.5552", "52.8836", "Asia/Tehran"),("123941", "Mīnāb", "Минаб", "IR", "364", "", "11", "", "", "27.13104", "57.08716", "Asia/Tehran"),("124085", "Mīāndoāb", "Миандоаб", "IR", "364", "", "01", "", "", "36.96667", "46.10961", "Asia/Tehran"),("124193", "Meybod", "", "IR", "364", "", "40", "", "", "32.25014", "54.01658", "Asia/Tehran"),("124274", "Mahrīz", "", "IR", "364", "", "40", "", "", "31.58428", "54.4428", "Asia/Tehran"),("124291", "Mehrān", "", "IR", "364", "", "10", "", "", "33.1222", "46.1646", "Asia/Tehran"),("124620", "Masjed Soleymān", "", "IR", "364", "", "15", "", "", "31.9364", "49.3039", "Asia/Tehran"),("124647", "Bardsīr", "", "IR", "364", "", "29", "", "", "29.92266", "56.57433", "Asia/Tehran"),("124665", "Mashhad", "Мешхед", "IR", "364", "", "42", "", "", "36.31559", "59.56796", "Asia/Tehran"),("124778", "Marīvān", "", "IR", "364", "", "16", "", "", "35.51829", "46.18298", "Asia/Tehran"),("124862", "Marand", "Маранд", "IR", "364", "", "33", "", "", "38.4329", "45.7749", "Asia/Tehran"),("125185", "Malāyer", "", "IR", "364", "", "09", "", "", "34.30158", "48.82166", "Asia/Tehran"),("125188", "Malārd", "", "IR", "364", "", "26", "", "", "35.6659", "50.9767", "Asia/Tehran"),("125446", "Mahābād", "Махабад", "IR", "364", "", "01", "", "", "36.7631", "45.7222", "Asia/Tehran"),("125897", "Langarūd", "", "IR", "364", "", "08", "", "", "37.19701", "50.15351", "Asia/Tehran"),("126409", "Kūhdasht", "", "IR", "364", "", "23", "", "", "33.53335", "47.60999", "Asia/Tehran"),("126914", "Kīsh", "Киш", "IR", "364", "", "11", "", "", "26.55778", "54.01944", "Asia/Tehran"),("126972", "Khvoy", "", "IR", "364", "", "01", "", "", "38.5503", "44.9521", "Asia/Tehran"),("127033", "Khvānsār", "", "IR", "364", "", "28", "", "", "33.22052", "50.31497", "Asia/Tehran"),("127319", "Khorramshahr", "Хорремшехр", "IR", "364", "", "15", "", "", "30.44079", "48.18428", "Asia/Tehran"),("127349", "Khorramabad", "", "IR", "364", "", "23", "", "", "33.48778", "48.35583", "Asia/Tehran"),("127403", "Khomeyn", "", "IR", "364", "", "34", "", "", "33.64225", "50.0789", "Asia/Tehran"),("128008", "Khalkhāl", "", "IR", "364", "", "32", "", "", "37.6189", "48.5258", "Asia/Tehran"),("128226", "Kermanshah", "Керманшах", "IR", "364", "", "13", "", "", "34.31417", "47.065", "Asia/Tehran"),("128234", "Kerman", "Керман", "IR", "364", "", "29", "", "", "30.28321", "57.07879", "Asia/Tehran"),("128321", "Kāzerūn", "Казеруна", "IR", "364", "", "07", "", "", "29.61949", "51.65415", "Asia/Tehran"),("128447", "Kāshmar", "", "IR", "364", "", "42", "", "", "35.23831", "58.46558", "Asia/Tehran"),("128747", "Karaj", "Карай", "IR", "364", "", "44", "", "", "35.83266", "50.99155", "Asia/Tehran"),("128831", "Kangāvar", "", "IR", "364", "", "13", "", "", "34.5043", "47.9653", "Asia/Tehran"),("128905", "Kāmyārān", "", "IR", "364", "", "16", "", "", "34.7956", "46.9355", "Asia/Tehran"),("129512", "Kalāleh", "", "IR", "364", "", "37", "", "", "37.37899", "55.493", "Asia/Tehran"),("129933", "Jūybār", "", "IR", "364", "", "35", "", "", "36.64115", "52.91244", "Asia/Tehran"),("130216", "Khārk", "", "IR", "364", "IR", "22", "", "", "29.26139", "50.33056", "Asia/Tehran"),("130245", "Javānrūd", "", "IR", "364", "", "13", "", "", "34.79611", "46.51722", "Asia/Tehran"),("130802", "Īlām", "Илам", "IR", "364", "", "10", "", "", "33.6374", "46.4227", "Asia/Tehran"),("131962", "Harsīn", "", "IR", "364", "", "13", "", "", "34.2721", "47.5861", "Asia/Tehran"),("132144", "Hamadān", "Хамадан", "IR", "364", "", "09", "", "", "34.79922", "48.51456", "Asia/Tehran"),("132892", "Gorgān", "Горган", "IR", "364", "", "37", "", "", "36.8427", "54.44391", "Asia/Tehran"),("132938", "Gonbad-e Kāvūs", "", "IR", "364", "", "37", "", "", "37.25004", "55.16721", "Asia/Tehran"),("132961", "Gonābād", "", "IR", "364", "", "42", "", "", "34.35287", "58.68365", "Asia/Tehran"),("133037", "Golpāyegān", "", "IR", "364", "", "28", "", "", "33.4537", "50.28836", "Asia/Tehran"),("133595", "Gerāsh", "", "IR", "364", "", "07", "", "", "27.66966", "54.13586", "Asia/Tehran"),("134217", "Bandar-e Ganāveh", "", "IR", "364", "", "22", "", "", "29.5791", "50.517", "Asia/Tehran"),("134441", "Fūman", "", "IR", "364", "", "08", "", "", "37.224", "49.3125", "Asia/Tehran"),("134518", "Fīrūzābād", "", "IR", "364", "", "07", "", "", "28.8438", "52.5707", "Asia/Tehran"),("134601", "Fareydūnshahr", "", "IR", "364", "", "28", "", "", "32.94098", "50.121", "Asia/Tehran"),("134602", "Fereydūnkenār", "", "IR", "364", "", "35", "", "", "36.68642", "52.52255", "Asia/Tehran"),("134721", "Fasā", "", "IR", "364", "", "07", "", "", "28.9383", "53.6482", "Asia/Tehran"),("134762", "Fārsān", "", "IR", "364", "", "03", "", "", "32.25694", "50.56095", "Asia/Tehran"),("135298", "Esfarāyen", "", "IR", "364", "", "43", "", "", "37.07645", "57.51009", "Asia/Tehran"),("135423", "Shahrud", "", "IR", "364", "", "25", "", "", "36.41819", "54.97628", "Asia/Tehran"),("136014", "Dogonbadan", "", "IR", "364", "", "05", "", "", "30.3586", "50.7981", "Asia/Tehran"),("136399", "Delījān", "", "IR", "364", "", "34", "", "", "33.9905", "50.6838", "Asia/Tehran"),("136702", "Dehlorān", "Дехлорана", "IR", "364", "", "10", "", "", "32.6941", "47.2679", "Asia/Tehran"),("136987", "Dehdasht", "", "IR", "364", "", "05", "", "", "30.7949", "50.56457", "Asia/Tehran"),("137268", "Sūsangerd", "", "IR", "364", "", "15", "", "", "31.5635", "48.18958", "Asia/Tehran"),("137436", "Darreh Shahr", "", "IR", "364", "", "10", "449461", "", "33.14447", "47.3799", "Asia/Tehran"),("137956", "Dārāb", "", "IR", "364", "", "07", "", "", "28.75194", "54.54444", "Asia/Tehran"),("138025", "Dāmghān", "", "IR", "364", "", "25", "", "", "36.1679", "54.34292", "Asia/Tehran"),("138042", "Damāvand", "Дамаванд", "IR", "364", "", "26", "", "", "35.71842", "52.06958", "Asia/Tehran"),("138742", "Chenārān", "", "IR", "364", "", "42", "", "", "36.64546", "59.12123", "Asia/Tehran"),("139223", "Chālūs", "Чалус", "IR", "364", "", "35", "", "", "36.655", "51.4204", "Asia/Tehran"),("139817", "Bandar-e Būshehr", "Бушир", "IR", "364", "", "22", "", "", "28.9684", "50.8385", "Asia/Tehran"),("139889", "Būkān", "Букан", "IR", "364", "", "01", "", "", "36.521", "46.2089", "Asia/Tehran"),("140044", "Borūjerd", "Боруджерд", "IR", "364", "", "23", "", "", "33.8973", "48.7516", "Asia/Tehran"),("140046", "Borūjen", "", "IR", "364", "", "03", "", "", "31.96523", "51.2873", "Asia/Tehran"),("140097", "Borāzjān", "", "IR", "364", "", "22", "", "", "29.2699", "51.2188", "Asia/Tehran"),("140380", "Bojnūrd", "Боджнурд", "IR", "364", "", "43", "", "", "37.47473", "57.32903", "Asia/Tehran"),("140463", "Bīrjand", "Бирдженд", "IR", "364", "", "41", "", "", "32.86628", "59.22114", "Asia/Tehran"),("140521", "Bījār", "Биджар", "IR", "364", "", "16", "", "", "35.8668", "47.60506", "Asia/Tehran"),("140889", "Bonāb", "Бонаб", "IR", "364", "", "33", "", "", "37.3404", "46.0561", "Asia/Tehran"),("140918", "Behshahr", "Бехшехр", "IR", "364", "", "35", "", "", "36.69235", "53.55262", "Asia/Tehran"),("140951", "Behbahān", "", "IR", "364", "", "15", "", "", "30.5959", "50.2417", "Asia/Tehran"),("141584", "Bāneh", "Бани", "IR", "364", "", "16", "", "", "35.9975", "45.8853", "Asia/Tehran"),("141665", "Bandar-e Lengeh", "", "IR", "364", "", "11", "", "", "26.55792", "54.88067", "Asia/Tehran"),("141679", "Bandar-e Anzalī", "", "IR", "364", "", "08", "", "", "37.47318", "49.45785", "Asia/Tehran"),("141681", "Bandar Abbas", "Бендер-Аббас", "IR", "364", "", "11", "", "", "27.1865", "56.2808", "Asia/Tehran"),("141736", "Bam", "Бам", "IR", "364", "", "29", "", "", "29.106", "58.357", "Asia/Tehran"),("142000", "Bahār", "Бахар", "IR", "364", "", "09", "", "", "34.9072", "48.4414", "Asia/Tehran"),("142255", "Bāfq", "Бафк", "IR", "364", "", "40", "", "", "31.6035", "55.40249", "Asia/Tehran"),("142358", "Bābolsar", "", "IR", "364", "", "35", "", "", "36.70251", "52.6576", "Asia/Tehran"),("142363", "Bābol", "Баболь", "IR", "364", "", "35", "", "", "36.55132", "52.67895", "Asia/Tehran"),("142496", "Aznā", "", "IR", "364", "", "23", "", "", "33.6095", "48.9307", "Asia/Tehran"),("142554", "Hashtrūd", "", "IR", "364", "", "33", "", "", "37.4779", "47.0508", "Asia/Tehran"),("142676", "Āstārā", "Астара", "IR", "364", "", "08", "449649", "", "38.4291", "48.872", "Asia/Tehran"),("142679", "Āstāneh-ye Ashrafīyeh", "", "IR", "364", "", "08", "", "", "37.26318", "49.94325", "Asia/Tehran"),("142872", "Asadābād", "Асадабада", "IR", "364", "", "09", "", "", "34.78241", "48.12012", "Asia/Tehran"),("143052", "Ardestān", "", "IR", "364", "", "28", "", "", "33.3761", "52.3694", "Asia/Tehran"),("143073", "Ardakān", "", "IR", "364", "", "40", "", "", "32.31001", "54.01747", "Asia/Tehran"),("143083", "Ardabīl", "", "IR", "364", "", "32", "", "", "38.2498", "48.2933", "Asia/Tehran"),("143127", "Arāk", "Эрак", "IR", "364", "", "34", "", "", "34.09174", "49.68916", "Asia/Tehran"),("143534", "Āmol", "Амоль", "IR", "364", "", "35", "", "", "36.46961", "52.35072", "Asia/Tehran"),("143748", "Alvand", "Алванд", "IR", "364", "", "36", "", "", "36.3187", "49.1678", "Asia/Tehran"),("143860", "Shahrīār", "Шахрияр", "IR", "364", "", "26", "", "", "35.65884", "51.05775", "Asia/Tehran"),("143921", "Alīgūdarz", "Алигударз", "IR", "364", "", "23", "", "", "33.40063", "49.6949", "Asia/Tehran"),("144269", "Aleshtar", "", "IR", "364", "", "23", "", "", "33.86419", "48.26258", "Asia/Tehran"),("144410", "Akbarābād", "Акбарабад", "IR", "364", "", "07", "", "", "29.2464", "52.7793", "Asia/Tehran"),("144443", "‘Ajab Shīr", "", "IR", "364", "", "33", "", "", "37.4776", "45.8943", "Asia/Tehran"),("144448", "Ahvaz", "Ахваз", "IR", "364", "", "15", "", "", "31.31901", "48.6842", "Asia/Tehran"),("144616", "Ahar", "Ахар", "IR", "364", "", "33", "", "", "38.4774", "47.0699", "Asia/Tehran"),("144696", "Aghajari", "", "IR", "364", "", "15", "", "", "30.7006", "49.8315", "Asia/Tehran"),("144794", "Ābyek", "", "IR", "364", "", "34", "", "", "36.06667", "50.55", "Asia/Tehran"),("145034", "Abhar", "Абхар", "IR", "364", "", "36", "", "", "36.1468", "49.218", "Asia/Tehran"),("145233", "Ābdānān", "", "IR", "364", "", "10", "", "", "32.9926", "47.4198", "Asia/Tehran"),("145449", "Ābādeh", "", "IR", "364", "", "07", "", "", "31.1608", "52.6506", "Asia/Tehran"),("145459", "Abadan", "Абадан", "IR", "364", "", "15", "", "", "30.3392", "48.3043", "Asia/Tehran"),("401202", "Pāsārgād", "", "IR", "364", "", "07", "", "", "30.20194", "53.18", "Asia/Tehran"),("403126", "Shahrak-e Pābedānā", "", "IR", "364", "IR", "29", "", "", "31.13444", "56.39806", "Asia/Tehran"),("406993", "Eqbālīyeh", "", "IR", "364", "", "26", "", "", "35.3022", "51.5358", "Asia/Tehran"),("417594", "Shāhreẕā", "", "IR", "364", "", "28", "", "", "32.03389", "51.87944", "Asia/Tehran"),("418521", "Rehnān", "", "IR", "364", "", "28", "", "", "32.68325", "51.60158", "Asia/Tehran"),("418571", "Qahderījān", "", "IR", "364", "", "28", "", "", "32.5767", "51.455", "Asia/Tehran"),("418606", "Najafābād", "Наджафабад", "IR", "364", "", "28", "", "", "32.6344", "51.3668", "Asia/Tehran"),("418710", "Khomeynī Shahr", "", "IR", "364", "", "28", "", "", "32.6856", "51.53609", "Asia/Tehran"),("418723", "Kelīshād va Sūdarjān", "", "IR", "364", "", "28", "", "", "32.55118", "51.52758", "Asia/Tehran"),("418851", "Falāvarjān", "", "IR", "364", "", "28", "", "", "32.5553", "51.50973", "Asia/Tehran"),("418863", "Isfahan", "Исфахан", "IR", "364", "", "28", "", "", "32.65246", "51.67462", "Asia/Tehran"),("418868", "Dowlatābād", "", "IR", "364", "", "28", "", "", "32.79978", "51.69553", "Asia/Tehran"),("418896", "Dorcheh Pīāz", "", "IR", "364", "", "28", "", "", "32.61528", "51.55556", "Asia/Tehran"),("1113217", "Zābol", "Заболь", "IR", "364", "", "04", "", "", "31.0306", "61.4949", "Asia/Tehran"),("1159301", "Zahedan", "Захедан", "IR", "364", "", "04", "", "", "29.4963", "60.8629", "Asia/Tehran"),("1159362", "Torbat-e Jām", "", "IR", "364", "", "42", "", "", "35.244", "60.6225", "Asia/Tehran"),("1159384", "Tāybād", "", "IR", "364", "", "42", "", "", "34.74", "60.7756", "Asia/Tehran"),("1159716", "Sarakhs", "Сарахс", "IR", "364", "", "42", "", "", "36.5449", "61.1577", "Asia/Tehran"),("1159877", "Qaşr-e Qand", "", "IR", "364", "", "04", "", "", "26.24833", "60.7525", "Asia/Tehran"),("1160571", "Khāsh", "Хаш", "IR", "364", "", "04", "", "", "28.22107", "61.21582", "Asia/Tehran"),("1160939", "Iranshahr", "", "IR", "364", "", "04", "", "", "27.20245", "60.68476", "Asia/Tehran"),("1161724", "Chabahar", "Чабахар", "IR", "364", "", "04", "", "", "25.2919", "60.643", "Asia/Tehran"),("7100777", "Mahdishahr", "", "IR", "364", "", "25", "124337", "", "35.71071", "53.35394", "Asia/Tehran"),("10630176", "Pasragad Branch", "", "IR", "364", "", "09", "", "", "34.77772", "48.47168", "Asia/Tehran"),("2627309", "Sauðárkrókur", "", "IS", "352", "", "41", "5200", "", "65.74611", "-19.63944", "Atlantic/Reykjavik"),("2632132", "Egilsstaðir", "", "IS", "352", "", "38", "7620", "", "65.26687", "-14.39485", "Atlantic/Reykjavik"),("2633274", "Akureyri", "Акюрейри", "IS", "352", "", "40", "6000", "", "65.68353", "-18.0878", "Atlantic/Reykjavik"),("3413604", "Selfoss", "", "IS", "352", "", "42", "8200", "", "63.93311", "-20.99712", "Atlantic/Reykjavik"),("3413829", "Reykjavík", "Рейкьявик", "IS", "352", "", "39", "0000", "", "64.13548", "-21.89541", "Atlantic/Reykjavik"),("3415021", "Mosfellsbær", "", "IS", "352", "", "39", "1604", "", "64.16667", "-21.7", "Atlantic/Reykjavik"),("3415212", "Kópavogur", "Коупавогюр", "IS", "352", "", "39", "1000", "", "64.11234", "-21.91298", "Atlantic/Reykjavik"),("3415496", "Keflavík", "", "IS", "352", "", "43", "2000", "", "64.00492", "-22.56242", "Atlantic/Reykjavik"),("3415667", "Ísafjörður", "", "IS", "352", "", "44", "4200", "", "66.07475", "-23.13498", "Atlantic/Reykjavik"),("3416706", "Hafnarfjörður", "Хабнарфьордюр", "IS", "352", "", "39", "1400", "", "64.0671", "-21.93774", "Atlantic/Reykjavik"),("3417195", "Garðabær", "", "IS", "352", "", "39", "1300", "", "64.08865", "-21.92298", "Atlantic/Reykjavik"),("3418076", "Borgarnes", "", "IS", "352", "", "45", "3609", "", "64.53834", "-21.92064", "Atlantic/Reykjavik"),("3418653", "Akranes", "", "IS", "352", "", "45", "3000", "", "64.32179", "-22.0749", "Atlantic/Reykjavik"),("2522696", "Zafferana Etnea", "", "IT", "380", "", "15", "CT", "087055", "37.67895", "15.10432", "Europe/Rome"),("2522709", "Vizzini", "", "IT", "380", "", "15", "CT", "087054", "37.16188", "14.75712", "Europe/Rome"),("2522713", "Vittoria", "", "IT", "380", "", "15", "RG", "088012", "36.95151", "14.52788", "Europe/Rome"),("2522725", "Villasor", "", "IT", "380", "", "14", "CA", "092101", "39.3813", "8.9427", "Europe/Rome"),("2522730", "Villa San Giovanni", "", "IT", "380", "", "03", "RC", "080096", "38.21991", "15.63689", "Europe/Rome"),("2522761", "Villafranca Tirrena", "", "IT", "380", "", "15", "ME", "083105", "38.23952", "15.43885", "Europe/Rome"),("2522766", "Villacidro", "", "IT", "380", "", "14", "VS", "106025", "39.45734", "8.74105", "Europe/Rome"),("2522767", "Villabate", "", "IT", "380", "", "15", "PA", "082079", "38.07789", "13.44275", "Europe/Rome"),("2522776", "Vibo Valentia", "Вибо-Валентия", "IT", "380", "", "03", "VV", "102047", "38.67618", "16.10094", "Europe/Rome"),("2522777", "Viagrande", "", "IT", "380", "", "15", "CT", "087053", "37.61032", "15.09794", "Europe/Rome"),("2522805", "Valguarnera Caropepe", "", "IT", "380", "", "15", "EN", "086019", "37.49527", "14.39025", "Europe/Rome"),("2522816", "Uta", "", "IT", "380", "", "14", "CA", "092090", "39.29186", "8.95234", "Europe/Rome"),("2522833", "Ugento", "", "IT", "380", "", "13", "LE", "075090", "39.92724", "18.15832", "Europe/Rome"),("2522847", "Tropea", "", "IT", "380", "", "03", "VV", "102044", "38.67449", "15.89505", "Europe/Rome"),("2522849", "Troina", "", "IT", "380", "", "15", "EN", "086018", "37.78437", "14.59605", "Europe/Rome"),("2522857", "Tricase", "", "IT", "380", "", "13", "LE", "075088", "39.93018", "18.35421", "Europe/Rome"),("2522865", "Trecastagni", "", "IT", "380", "", "15", "CT", "087050", "37.61543", "15.07796", "Europe/Rome"),("2522867", "Trebisacce", "", "IT", "380", "", "03", "CS", "078150", "39.87128", "16.5342", "Europe/Rome"),("2522876", "Trapani", "Трапани", "IT", "380", "", "15", "TP", "081021", "38.0176", "12.53617", "Europe/Rome"),("2522883", "Trabia", "", "IT", "380", "", "15", "PA", "082073", "38.0042", "13.63393", "Europe/Rome"),("2522890", "Tortolì", "", "IT", "380", "", "14", "OG", "105018", "39.92626", "9.65569", "Europe/Rome"),("2522908", "Torregrotta", "", "IT", "380", "", "15", "ME", "083098", "38.20262", "15.3501", "Europe/Rome"),("2522952", "Terrasini", "", "IT", "380", "", "15", "PA", "082071", "38.14621", "13.08319", "Europe/Rome"),("2522958", "Terralba", "", "IT", "380", "", "14", "OR", "095065", "39.72056", "8.63504", "Europe/Rome"),("2522960", "Termini Imerese", "", "IT", "380", "", "15", "PA", "082070", "37.98225", "13.69729", "Europe/Rome"),("2522968", "Taviano", "", "IT", "380", "", "13", "LE", "075085", "39.98224", "18.08151", "Europe/Rome"),("2522970", "Taurisano", "", "IT", "380", "", "13", "LE", "075084", "39.95746", "18.21498", "Europe/Rome"),("2522971", "Taurianova", "", "IT", "380", "", "03", "RC", "080093", "38.35525", "16.01306", "Europe/Rome"),("2522975", "Taormina", "", "IT", "380", "", "15", "ME", "083097", "37.85358", "15.28851", "Europe/Rome"),("2523025", "Spezzano Albanese", "", "IT", "380", "", "03", "CS", "078142", "39.66854", "16.30939", "Europe/Rome"),("2523045", "Soverato Marina", "", "IT", "380", "IT", "03", "CZ", "079137", "38.68498", "16.54991", "Europe/Rome"),("2523049", "Sortino", "", "IT", "380", "", "15", "SR", "089019", "37.15881", "15.02998", "Europe/Rome"),("2523056", "Sommatino", "", "IT", "380", "", "15", "CL", "085019", "37.33471", "13.99739", "Europe/Rome"),("2523066", "Solarino", "", "IT", "380", "", "15", "SR", "089018", "37.10136", "15.11988", "Europe/Rome"),("2523083", "Siracusa", "Сиракуза", "IT", "380", "", "15", "SR", "089017", "37.08415", "15.27628", "Europe/Rome"),("2523087", "Sinnai", "", "IT", "380", "", "14", "CA", "092080", "39.30286", "9.20283", "Europe/Rome"),("2523113", "Siderno", "", "IT", "380", "IT", "03", "RC", "080088", "38.26993", "16.29607", "Europe/Rome"),("2523135", "Settimo San Pietro", "", "IT", "380", "", "14", "CA", "092075", "39.2911", "9.1857", "Europe/Rome"),("2523136", "Sestu", "", "IT", "380", "", "14", "CA", "092074", "39.29846", "9.09248", "Europe/Rome"),("2523146", "Serra San Bruno", "", "IT", "380", "", "03", "VV", "102037", "38.57474", "16.32622", "Europe/Rome"),("2523148", "Serramanna", "", "IT", "380", "", "14", "VS", "106018", "39.42335", "8.92243", "Europe/Rome"),("2523151", "Serradifalco", "", "IT", "380", "", "15", "CL", "085018", "37.45384", "13.88046", "Europe/Rome"),("2523166", "Selargius", "", "IT", "380", "", "14", "CA", "092068", "39.25779", "9.16323", "Europe/Rome"),("2523180", "Scordia", "", "IT", "380", "", "15", "CT", "087049", "37.29548", "14.84058", "Europe/Rome"),("2523192", "Scicli", "Шикли", "IT", "380", "", "15", "RG", "088011", "36.79014", "14.7028", "Europe/Rome"),("2523194", "Sciacca", "", "IT", "380", "", "15", "AG", "084041", "37.50693", "13.08399", "Europe/Rome"),("2523207", "Scalea", "", "IT", "380", "", "03", "CS", "078138", "39.80605", "15.79635", "Europe/Rome"),("2523255", "San Sperate", "", "IT", "380", "", "14", "CA", "092059", "39.35758", "9.00814", "Europe/Rome"),("2523282", "Santa Teresa di Riva", "", "IT", "380", "", "15", "ME", "083089", "37.94635", "15.36671", "Europe/Rome"),("2523297", "Sant'Antioco", "", "IT", "380", "", "14", "CI", "107020", "39.07017", "8.45243", "Europe/Rome"),("2523320", "Santa Maria di Licodia", "", "IT", "380", "", "15", "CT", "087047", "37.61684", "14.89337", "Europe/Rome"),("2523330", "Santa Margherita di Belice", "", "IT", "380", "", "15", "AG", "084038", "37.69281", "13.01584", "Europe/Rome"),("2523347", "Sant'Agata di Militello", "", "IT", "380", "IT", "15", "ME", "083084", "38.06838", "14.636", "Europe/Rome"),("2523352", "Santa Flavia", "", "IT", "380", "", "15", "PA", "082067", "38.10448", "13.5334", "Europe/Rome"),("2523362", "Santa Croce Camerina", "", "IT", "380", "", "15", "RG", "088010", "36.82842", "14.52538", "Europe/Rome"),("2523366", "Santa Caterina Villarmosa", "", "IT", "380", "", "15", "CL", "085017", "37.59034", "14.03554", "Europe/Rome"),("2523434", "Sanluri", "", "IT", "380", "", "14", "VS", "106015", "39.56176", "8.89969", "Europe/Rome"),("2523441", "San Leone Mosè", "", "IT", "380", "", "15", "AG", "084001", "37.26497", "13.58434", "Europe/Rome"),("2523448", "San Gregorio di Catania", "", "IT", "380", "", "15", "CT", "087042", "37.56764", "15.1112", "Europe/Rome"),("2523451", "San Giuseppe Jato", "", "IT", "380", "", "15", "PA", "082064", "37.97331", "13.18889", "Europe/Rome"),("2523460", "San Giovanni la Punta", "", "IT", "380", "", "15", "CT", "087041", "37.5769", "15.09371", "Europe/Rome"),("2523461", "San Giovanni in Fiore", "", "IT", "380", "", "03", "CS", "078119", "39.25446", "16.69699", "Europe/Rome"),("2523462", "San Giovanni Gemini", "", "IT", "380", "", "15", "AG", "084036", "37.62785", "13.64357", "Europe/Rome"),("2523482", "San Gavino Monreale", "", "IT", "380", "", "14", "VS", "106014", "39.55008", "8.79065", "Europe/Rome"),("2523511", "San Cipirello", "", "IT", "380", "", "15", "PA", "082063", "37.96067", "13.17732", "Europe/Rome"),("2523513", "San Cataldo", "", "IT", "380", "", "15", "CL", "085016", "37.48412", "13.98542", "Europe/Rome"),("2523533", "Sambuca di Sicilia", "", "IT", "380", "", "15", "AG", "084034", "37.65294", "13.11462", "Europe/Rome"),("2523537", "Samassi", "", "IT", "380", "", "14", "VS", "106013", "39.48208", "8.90538", "Europe/Rome"),("2523557", "Salemi", "", "IT", "380", "", "15", "TP", "081018", "37.82199", "12.80506", "Europe/Rome"),("2523569", "Ruffano", "", "IT", "380", "", "13", "LE", "075064", "39.98195", "18.24974", "Europe/Rome"),("2523577", "Rossano Stazione", "", "IT", "380", "", "03", "CS", "078108", "39.59855", "16.63485", "Europe/Rome"),("2523578", "Rossano", "", "IT", "380", "", "03", "CS", "078108", "39.57622", "16.63447", "Europe/Rome"),("2523581", "Rosolini", "", "IT", "380", "", "15", "SR", "089016", "36.82145", "14.95132", "Europe/Rome"),("2523585", "Rosarno", "", "IT", "380", "", "03", "RC", "080069", "38.48717", "15.97956", "Europe/Rome"),("2523591", "Roggiano Gravina", "", "IT", "380", "", "03", "CS", "078104", "39.61786", "16.16173", "Europe/Rome"),("2523595", "Roccella Ionica", "", "IT", "380", "", "03", "RC", "080067", "38.32117", "16.39689", "Europe/Rome"),("2523612", "Riposto", "", "IT", "380", "", "15", "CT", "087039", "37.73183", "15.20576", "Europe/Rome"),("2523616", "Riesi", "", "IT", "380", "", "15", "CL", "085015", "37.28079", "14.08317", "Europe/Rome"),("2523619", "Ribera", "Рибера", "IT", "380", "", "15", "AG", "084033", "37.49773", "13.26676", "Europe/Rome"),("2523630", "Reggio Calabria", "Реджо-ди-Калабрия", "IT", "380", "", "03", "RC", "080063", "38.11047", "15.66129", "Europe/Rome"),("2523632", "Regalbuto", "", "IT", "380", "", "15", "EN", "086016", "37.65195", "14.63915", "Europe/Rome"),("2523638", "Ravanusa", "", "IT", "380", "", "15", "AG", "084031", "37.26659", "13.96834", "Europe/Rome"),("2523641", "Randazzo", "", "IT", "380", "", "15", "CT", "087038", "37.87736", "14.95012", "Europe/Rome"),("2523644", "Ramacca", "", "IT", "380", "", "15", "CT", "087037", "37.38616", "14.69241", "Europe/Rome"),("2523650", "Ragusa", "Рагуза", "IT", "380", "", "15", "RG", "088009", "36.92574", "14.72443", "Europe/Rome"),("2523654", "Raffadali", "", "IT", "380", "", "15", "AG", "084030", "37.40214", "13.53175", "Europe/Rome"),("2523659", "Racalmuto", "", "IT", "380", "", "15", "AG", "084029", "37.40498", "13.72995", "Europe/Rome"),("2523660", "Racale", "", "IT", "380", "", "13", "LE", "075063", "39.96086", "18.09154", "Europe/Rome"),("2523664", "Quattromiglia", "", "IT", "380", "", "03", "CS", "078102", "39.34474", "16.23802", "Europe/Rome"),("2523665", "Quartu Sant'Elena", "", "IT", "380", "", "14", "CA", "092051", "39.22935", "9.25004", "Europe/Rome"),("2523666", "Quartucciu", "", "IT", "380", "", "14", "CA", "092105", "39.25262", "9.17764", "Europe/Rome"),("2523679", "Priolo Gargallo", "", "IT", "380", "", "15", "SR", "089021", "37.15512", "15.18248", "Europe/Rome"),("2523681", "Presicce", "", "IT", "380", "", "13", "LE", "075062", "39.90055", "18.26282", "Europe/Rome"),("2523687", "Praia a Mare", "", "IT", "380", "", "03", "CS", "078101", "39.8941", "15.78421", "Europe/Rome"),("2523693", "Pozzallo", "", "IT", "380", "", "15", "RG", "088008", "36.73028", "14.84672", "Europe/Rome"),("2523705", "Porto Empedocle", "", "IT", "380", "", "15", "AG", "084028", "37.28942", "13.52494", "Europe/Rome"),("2523738", "Polistena", "", "IT", "380", "", "03", "RC", "080061", "38.40544", "16.0733", "Europe/Rome"),("2523762", "Pizzo", "", "IT", "380", "", "03", "VV", "102027", "38.75259", "16.18696", "Europe/Rome"),("2523784", "Pietraperzia", "", "IT", "380", "", "15", "EN", "086015", "37.41852", "14.13739", "Europe/Rome"),("2523796", "Piazza Armerina", "", "IT", "380", "", "15", "EN", "086014", "37.38417", "14.36921", "Europe/Rome"),("2523808", "Piana degli Albanesi", "", "IT", "380", "", "15", "PA", "082057", "37.99372", "13.28464", "Europe/Rome"),("2523816", "Petrosino", "", "IT", "380", "", "15", "TP", "081024", "37.71271", "12.49964", "Europe/Rome"),("2523825", "Petilia Policastro", "", "IT", "380", "", "03", "KR", "101017", "39.11293", "16.78167", "Europe/Rome"),("2523850", "Pedara", "", "IT", "380", "", "15", "CT", "087034", "37.62386", "15.05672", "Europe/Rome"),("2523864", "Patti", "", "IT", "380", "", "15", "ME", "083066", "38.14736", "14.96409", "Europe/Rome"),("2523866", "Paternò", "Патерно", "IT", "380", "", "15", "CT", "087033", "37.56675", "14.90254", "Europe/Rome"),("2523871", "Partinico", "", "IT", "380", "", "15", "PA", "082054", "38.04657", "13.11785", "Europe/Rome"),("2523872", "Partanna", "", "IT", "380", "", "15", "TP", "081015", "37.7268", "12.88917", "Europe/Rome"),("2523888", "Paola", "", "IT", "380", "", "03", "CS", "078091", "39.36313", "16.03691", "Europe/Rome"),("2523902", "Palmi", "", "IT", "380", "", "03", "RC", "080057", "38.35943", "15.85155", "Europe/Rome"),("2523908", "Palma di Montechiaro", "", "IT", "380", "", "15", "AG", "084027", "37.19066", "13.76603", "Europe/Rome"),("2523920", "Palermo", "Палермо", "IT", "380", "", "15", "PA", "082053", "38.13205", "13.33561", "Europe/Rome"),("2523922", "Palazzolo Acreide", "", "IT", "380", "", "15", "SR", "089015", "37.06261", "14.90593", "Europe/Rome"),("2523927", "Palagonia", "", "IT", "380", "", "15", "CT", "087032", "37.32955", "14.74474", "Europe/Rome"),("2523938", "Pachino", "Пакино", "IT", "380", "", "15", "SR", "089014", "36.71522", "15.09019", "Europe/Rome"),("2523942", "Paceco", "", "IT", "380", "", "15", "TP", "081013", "37.98026", "12.55766", "Europe/Rome"),("2523964", "Oristano", "Ористано", "IT", "380", "", "14", "OR", "095038", "39.9036", "8.59257", "Europe/Rome"),("2523998", "Noto", "Ното", "IT", "380", "", "15", "SR", "089013", "36.89244", "15.06977", "Europe/Rome"),("2524006", "Niscemi", "Нишеми", "IT", "380", "", "15", "CL", "085013", "37.14649", "14.39381", "Europe/Rome"),("2524009", "Nicosia", "", "IT", "380", "", "15", "EN", "086012", "37.74747", "14.39218", "Europe/Rome"),("2524010", "Nicolosi", "", "IT", "380", "", "15", "CT", "087031", "37.62148", "15.02785", "Europe/Rome"),("2524013", "Nicastro-Sambiase", "Никастро", "IT", "380", "", "03", "CZ", "079160", "38.97089", "16.31285", "Europe/Rome"),("2524022", "Naro", "", "IT", "380", "", "15", "AG", "084026", "37.29248", "13.79337", "Europe/Rome"),("2524028", "Mussomeli", "", "IT", "380", "", "15", "CL", "085012", "37.58067", "13.75214", "Europe/Rome"),("2524041", "Motta Sant'Anastasia", "", "IT", "380", "", "15", "CT", "087030", "37.51205", "14.96628", "Europe/Rome"),("2524084", "Monserrato", "", "IT", "380", "", "14", "CA", "092109", "39.25642", "9.1444", "Europe/Rome"),("2524085", "Monreale", "Монреаль", "IT", "380", "", "15", "PA", "082049", "38.08125", "13.28947", "Europe/Rome"),("2524119", "Modica", "Модика", "IT", "380", "", "15", "RG", "088006", "36.85868", "14.75966", "Europe/Rome"),("2524123", "Misterbianco", "", "IT", "380", "", "15", "CT", "087029", "37.51803", "15.00913", "Europe/Rome"),("2524126", "Misilmeri", "", "IT", "380", "", "15", "PA", "082048", "38.03183", "13.44795", "Europe/Rome"),("2524129", "Mirto", "", "IT", "380", "", "03", "CS", "078047", "39.60069", "16.7739", "Europe/Rome"),("2524135", "Mirabella Imbaccari", "", "IT", "380", "", "15", "CT", "087028", "37.32702", "14.44605", "Europe/Rome"),("2524145", "Militello in Val di Catania", "", "IT", "380", "", "15", "CT", "087025", "37.27594", "14.79342", "Europe/Rome"),("2524155", "Milazzo", "Милаццо", "IT", "380", "", "15", "ME", "083049", "38.22008", "15.24023", "Europe/Rome"),("2524170", "Messina", "Мессина", "IT", "380", "", "15", "ME", "083048", "38.19394", "15.55256", "Europe/Rome"),("2524172", "Mesoraca", "", "IT", "380", "", "03", "KR", "101015", "39.07948", "16.78808", "Europe/Rome"),("2524179", "Menfi", "", "IT", "380", "", "15", "AG", "084023", "37.60409", "12.96889", "Europe/Rome"),("2524181", "Melito di Porto Salvo", "", "IT", "380", "", "03", "RC", "080050", "37.92629", "15.7499", "Europe/Rome"),("2524184", "Melissano", "", "IT", "380", "", "13", "LE", "075044", "39.97315", "18.12113", "Europe/Rome"),("2524186", "Melilli", "", "IT", "380", "", "15", "SR", "089012", "37.17821", "15.1302", "Europe/Rome"),("2524200", "Mazzarino", "", "IT", "380", "", "15", "CL", "085009", "37.30188", "14.20959", "Europe/Rome"),("2524205", "Mazara del Vallo", "", "IT", "380", "", "15", "TP", "081012", "37.65535", "12.58986", "Europe/Rome"),("2524208", "Maracalagonis", "", "IT", "380", "", "14", "CA", "092037", "39.28574", "9.22874", "Europe/Rome"),("2524236", "Mascalucia", "Маскалуча", "IT", "380", "", "15", "CT", "087024", "37.57465", "15.04964", "Europe/Rome"),("2524237", "Mascali", "", "IT", "380", "", "15", "CT", "087023", "37.75816", "15.20153", "Europe/Rome"),("2524245", "Marsala", "Марсала", "IT", "380", "", "15", "TP", "081011", "37.7992", "12.4367", "Europe/Rome"),("2524255", "Marineo", "", "IT", "380", "", "15", "PA", "082046", "37.95185", "13.41781", "Europe/Rome"),("2524258", "Marina di Schiavonea", "", "IT", "380", "IT", "03", "CS", "078044", "39.65", "16.53333", "Europe/Rome"),("2524266", "Marina di Gioiosa Ionica", "", "IT", "380", "", "03", "RC", "080045", "38.30159", "16.33148", "Europe/Rome"),("2524371", "Locri", "", "IT", "380", "", "03", "RC", "080043", "38.23868", "16.25957", "Europe/Rome"),("2524382", "Linguaglossa", "", "IT", "380", "", "15", "CT", "087021", "37.84243", "15.13774", "Europe/Rome"),("2524393", "Licata", "", "IT", "380", "", "15", "AG", "084021", "37.10267", "13.93972", "Europe/Rome"),("2524402", "Lercara Friddi", "", "IT", "380", "", "15", "PA", "082045", "37.74657", "13.60391", "Europe/Rome"),("2524404", "Leonforte", "", "IT", "380", "", "15", "EN", "086011", "37.64197", "14.39766", "Europe/Rome"),("2524410", "Lentini", "Лентини", "IT", "380", "", "15", "SR", "089011", "37.28556", "14.99737", "Europe/Rome"),("2524463", "La Maddalena", "", "IT", "380", "", "14", "CA", "092011", "39.14429", "9.01223", "Europe/Rome"),("2524493", "Ispica", "", "IT", "380", "", "15", "RG", "088005", "36.78622", "14.9053", "Europe/Rome"),("2524494", "Isola delle Femmine", "", "IT", "380", "", "15", "PA", "082043", "38.19123", "13.24691", "Europe/Rome"),("2524495", "Isola di Capo Rizzuto", "", "IT", "380", "", "03", "KR", "101013", "38.95844", "17.09242", "Europe/Rome"),("2524533", "Iglesias", "Иглезиас", "IT", "380", "", "14", "CI", "107009", "39.3092", "8.5372", "Europe/Rome"),("2524546", "Guspini", "", "IT", "380", "", "14", "VS", "106008", "39.53954", "8.63502", "Europe/Rome"),("2524561", "Grotte", "", "IT", "380", "", "15", "AG", "084018", "37.40346", "13.69889", "Europe/Rome"),("2524583", "Grammichele", "", "IT", "380", "", "15", "CT", "087018", "37.21326", "14.63311", "Europe/Rome"),("2524587", "Gonnosfanadiga", "", "IT", "380", "", "14", "VS", "106007", "39.49426", "8.662", "Europe/Rome"),("2524600", "Girifalco", "", "IT", "380", "", "03", "CZ", "079059", "38.82594", "16.42688", "Europe/Rome"),("2524605", "Gioiosa Ionica", "", "IT", "380", "", "03", "RC", "080039", "38.32723", "16.30407", "Europe/Rome"),("2524606", "Gioia Tauro", "", "IT", "380", "", "03", "RC", "080038", "38.4251", "15.8975", "Europe/Rome"),("2524618", "Giarre", "Джарре", "IT", "380", "", "15", "CT", "087017", "37.7244", "15.18165", "Europe/Rome"),("2524622", "Giardini-Naxos", "", "IT", "380", "", "15", "ME", "083032", "37.82755", "15.26713", "Europe/Rome"),("2524653", "Gela", "", "IT", "380", "", "15", "CL", "085007", "37.07381", "14.24038", "Europe/Rome"),("2524661", "Gangi", "", "IT", "380", "", "15", "PA", "082036", "37.79565", "14.20437", "Europe/Rome"),("2524685", "Gagliano del Capo", "", "IT", "380", "", "13", "LE", "075028", "39.84323", "18.36962", "Europe/Rome"),("2524704", "Francofonte", "", "IT", "380", "", "15", "SR", "089010", "37.22477", "14.87488", "Europe/Rome"),("2524734", "Floridia", "Флоридии", "IT", "380", "", "15", "SR", "089009", "37.08343", "15.15332", "Europe/Rome"),("2524742", "Fiumefreddo Sicilia", "", "IT", "380", "", "15", "CT", "087016", "37.79146", "15.20919", "Europe/Rome"),("2524765", "Ficarazzi", "", "IT", "380", "", "15", "PA", "082035", "38.09229", "13.4639", "Europe/Rome"),("2524786", "Favara", "", "IT", "380", "", "15", "AG", "084017", "37.31754", "13.66226", "Europe/Rome"),("2524819", "Enna", "Энна", "IT", "380", "", "15", "EN", "086009", "37.5655", "14.27433", "Europe/Rome"),("2524820", "Elmas", "", "IT", "380", "", "14", "CA", "092108", "39.26878", "9.05021", "Europe/Rome"),("2524841", "Domusnovas", "", "IT", "380", "", "14", "CI", "107005", "39.32404", "8.64921", "Europe/Rome"),("2524844", "Dolianova", "", "IT", "380", "", "14", "CA", "092017", "39.37791", "9.17697", "Europe/Rome"),("2524865", "Decimomannu", "", "IT", "380", "", "14", "CA", "092015", "39.31033", "8.96964", "Europe/Rome"),("2524869", "Cutro", "", "IT", "380", "", "03", "KR", "101012", "39.03484", "16.98658", "Europe/Rome"),("2524881", "Crotone", "Кротоне", "IT", "380", "", "03", "KR", "101010", "39.08077", "17.12764", "Europe/Rome"),("2524901", "Cotronei", "", "IT", "380", "", "03", "KR", "101009", "39.15935", "16.77688", "Europe/Rome"),("2524907", "Cosenza", "Козенца", "IT", "380", "", "03", "CS", "078045", "39.2989", "16.25307", "Europe/Rome"),("2524918", "Corsano", "", "IT", "380", "", "13", "LE", "075024", "39.88911", "18.36747", "Europe/Rome"),("2524928", "Corleone", "", "IT", "380", "", "15", "PA", "082034", "37.81338", "13.3017", "Europe/Rome"),("2524929", "Corigliano Calabro", "", "IT", "380", "", "03", "CS", "078044", "39.59553", "16.51907", "Europe/Rome"),("2524955", "Comiso", "Комизо", "IT", "380", "", "15", "RG", "088003", "36.94893", "14.60731", "Europe/Rome"),("2524976", "Cittanova", "", "IT", "380", "", "03", "RC", "080028", "38.35431", "16.07898", "Europe/Rome"),("2524979", "Cirò Marina", "", "IT", "380", "", "03", "KR", "101008", "39.36876", "17.12477", "Europe/Rome"),("2524985", "Cinque Frondi", "", "IT", "380", "", "03", "RC", "080027", "38.41618", "16.0842", "Europe/Rome"),("2524987", "Cinisi", "", "IT", "380", "", "15", "PA", "082031", "38.16082", "13.10099", "Europe/Rome"),("2525026", "Cerda", "", "IT", "380", "", "15", "PA", "082028", "37.90578", "13.81496", "Europe/Rome"),("2525041", "Cefalù", "", "IT", "380", "", "15", "PA", "082027", "38.03856", "14.02285", "Europe/Rome"),("2525059", "Catanzaro", "Катандзаро", "IT", "380", "", "03", "CZ", "079023", "38.88247", "16.60086", "Europe/Rome"),("2525068", "Catania", "Катания", "IT", "380", "", "15", "CT", "087015", "37.49223", "15.07041", "Europe/Rome"),("2525070", "Castrovillari", "Кастровиллари", "IT", "380", "", "03", "CS", "078033", "39.81632", "16.20183", "Europe/Rome"),("2525083", "Castelvetrano", "Кастельветрано", "IT", "380", "", "15", "TP", "081006", "37.68081", "12.79194", "Europe/Rome"),("2525084", "Casteltermini", "", "IT", "380", "", "15", "AG", "084012", "37.53874", "13.64601", "Europe/Rome"),("2525095", "Castellammare del Golfo", "", "IT", "380", "", "15", "TP", "081005", "38.02653", "12.88183", "Europe/Rome"),("2525102", "Casteldaccia", "", "IT", "380", "", "15", "PA", "082023", "38.05121", "13.53041", "Europe/Rome"),("2525103", "Castelbuono", "", "IT", "380", "", "15", "PA", "082022", "37.9253", "14.08665", "Europe/Rome"),("2525110", "Cassano Allo Ionio", "", "IT", "380", "IT", "03", "CS", "078029", "39.78142", "16.32738", "Europe/Rome"),("2525207", "Casarano", "", "IT", "380", "", "13", "LE", "075016", "40.01131", "18.16237", "Europe/Rome"),("2525348", "Carloforte", "", "IT", "380", "", "14", "CI", "107004", "39.14081", "8.3039", "Europe/Rome"),("2525349", "Carlentini", "", "IT", "380", "", "15", "SR", "089006", "37.28071", "15.0102", "Europe/Rome"),("2525350", "Carini", "Карина", "IT", "380", "", "15", "PA", "082021", "38.1324", "13.18274", "Europe/Rome"),("2525352", "Cariati", "", "IT", "380", "", "03", "CS", "078025", "39.49627", "16.95495", "Europe/Rome"),("2525362", "Carbonia", "Карбония", "IT", "380", "", "14", "CI", "107003", "39.16465", "8.5213", "Europe/Rome"),("2525379", "Capoterra", "", "IT", "380", "", "14", "CA", "092011", "39.1752", "8.97199", "Europe/Rome"),("2525384", "Capo d'Orlando", "", "IT", "380", "", "15", "ME", "083009", "38.14262", "14.73292", "Europe/Rome"),("2525392", "Capaci", "", "IT", "380", "", "15", "PA", "082020", "38.17107", "13.2393", "Europe/Rome"),("2525404", "Canicattini Bagni", "", "IT", "380", "", "15", "SR", "089005", "37.03171", "15.06388", "Europe/Rome"),("2525405", "Canicattì", "", "IT", "380", "", "15", "AG", "084011", "37.35842", "13.84786", "Europe/Rome"),("2525423", "Campofelice di Roccella", "", "IT", "380", "", "15", "PA", "082017", "37.9927", "13.87648", "Europe/Rome"),("2525425", "Campobello di Mazara", "", "IT", "380", "", "15", "TP", "081004", "37.63464", "12.74946", "Europe/Rome"),("2525426", "Campobello di Licata", "", "IT", "380", "", "15", "AG", "084010", "37.25759", "13.91811", "Europe/Rome"),("2525433", "Cammarata", "", "IT", "380", "", "15", "AG", "084009", "37.63361", "13.62722", "Europe/Rome"),("2525448", "Caltanissetta", "Кальтаниссетта", "IT", "380", "", "15", "CL", "085004", "37.49025", "14.06216", "Europe/Rome"),("2525450", "Caltagirone", "Кальтаджироне", "IT", "380", "", "15", "CT", "087011", "37.23785", "14.51551", "Europe/Rome"),("2525473", "Cagliari", "Кальяри", "IT", "380", "", "14", "CA", "092009", "39.23054", "9.11917", "Europe/Rome"),("2525476", "Caccamo", "", "IT", "380", "", "15", "PA", "082014", "37.93357", "13.66808", "Europe/Rome"),("2525478", "Cabras", "", "IT", "380", "", "14", "OR", "095018", "39.92871", "8.53242", "Europe/Rome"),("2525498", "Bronte", "Бронте", "IT", "380", "", "15", "CT", "087009", "37.78863", "14.83377", "Europe/Rome"),("2525512", "Bovalino Superiore", "", "IT", "380", "", "03", "RC", "080012", "38.16905", "16.15849", "Europe/Rome"),("2525513", "Bovalino", "", "IT", "380", "IT", "03", "RC", "080012", "38.15376", "16.17232", "Europe/Rome"),("2525526", "Borgetto", "", "IT", "380", "", "15", "PA", "082013", "38.04664", "13.14071", "Europe/Rome"),("2525550", "Bisignano", "", "IT", "380", "", "03", "CS", "078017", "39.50727", "16.28106", "Europe/Rome"),("2525560", "Biancavilla", "", "IT", "380", "", "15", "CT", "087008", "37.64442", "14.86685", "Europe/Rome"),("2525566", "Belvedere", "", "IT", "380", "IT", "15", "SR", "089017", "37.08839", "15.21314", "Europe/Rome"),("2525567", "Belvedere Marittimo", "", "IT", "380", "", "03", "CS", "078015", "39.63641", "15.84463", "Europe/Rome"),("2525571", "Belpasso", "", "IT", "380", "", "15", "CT", "087007", "37.59192", "14.97985", "Europe/Rome"),("2525573", "Belmonte Mezzagno", "", "IT", "380", "", "15", "PA", "082009", "38.04653", "13.39207", "Europe/Rome"),("2525593", "Barrafranca", "", "IT", "380", "", "15", "EN", "086004", "37.3785", "14.2027", "Europe/Rome"),("2525597", "Barcellona Pozzo di Gotto", "", "IT", "380", "", "15", "ME", "083005", "38.14772", "15.21469", "Europe/Rome"),("2525609", "Balestrate", "", "IT", "380", "", "15", "PA", "082007", "38.05125", "13.00724", "Europe/Rome"),("2525616", "Bagnara Calabra", "", "IT", "380", "", "03", "RC", "080007", "38.28778", "15.80591", "Europe/Rome"),("2525628", "Bagheria", "Багерия", "IT", "380", "", "15", "PA", "082006", "38.07892", "13.51237", "Europe/Rome"),("2525643", "Avola", "", "IT", "380", "", "15", "SR", "089002", "36.9084", "15.13937", "Europe/Rome"),("2525646", "Augusta", "", "IT", "380", "", "15", "SR", "089001", "37.24065", "15.22121", "Europe/Rome"),("2525655", "Assemini", "Ассемини", "IT", "380", "", "14", "CA", "092003", "39.29123", "8.99879", "Europe/Rome"),("2525688", "Arbus", "", "IT", "380", "", "14", "VS", "106001", "39.52616", "8.5997", "Europe/Rome"),("2525693", "Aragona", "", "IT", "380", "", "15", "AG", "084003", "37.39904", "13.61974", "Europe/Rome"),("2525725", "Amato", "", "IT", "380", "", "03", "RC", "080071", "38.38333", "16.13333", "Europe/Rome"),("2525727", "Amantea", "", "IT", "380", "", "03", "CS", "078010", "39.12658", "16.07512", "Europe/Rome"),("2525729", "Altofonte", "", "IT", "380", "", "15", "PA", "082005", "38.04298", "13.29434", "Europe/Rome"),("2525734", "Altavilla Milicia", "", "IT", "380", "", "15", "PA", "082004", "38.038", "13.54947", "Europe/Rome"),("2525748", "Alessano", "", "IT", "380", "", "13", "LE", "075002", "39.89381", "18.33221", "Europe/Rome"),("2525755", "Alcamo", "Алькамо", "IT", "380", "", "15", "TP", "081001", "37.9779", "12.96473", "Europe/Rome"),("2525764", "Agrigento", "Агридженто", "IT", "380", "", "15", "AG", "084001", "37.31065", "13.57661", "Europe/Rome"),("2525767", "Agira", "", "IT", "380", "", "15", "EN", "086001", "37.6558", "14.51972", "Europe/Rome"),("2525769", "Adrano", "Адрано", "IT", "380", "", "15", "CT", "087006", "37.66358", "14.83283", "Europe/Rome"),("2525772", "Acri", "", "IT", "380", "", "03", "CS", "078003", "39.49624", "16.38635", "Europe/Rome"),("2525789", "Aci Sant'Antonio", "", "IT", "380", "", "15", "CT", "087005", "37.60499", "15.12294", "Europe/Rome"),("2525790", "Acireale", "", "IT", "380", "", "15", "CT", "087004", "37.60886", "15.16577", "Europe/Rome"),("2525791", "Aci Catena", "", "IT", "380", "", "15", "CT", "087003", "37.60614", "15.14165", "Europe/Rome"),("2525792", "Aci Castello", "", "IT", "380", "", "15", "CT", "087002", "37.55564", "15.14535", "Europe/Rome"),("2525796", "Acate", "", "IT", "380", "", "15", "RG", "088001", "37.02318", "14.49302", "Europe/Rome"),("3163830", "Granarolo dell'Emilia e Viadagola", "", "IT", "380", "IT", "05", "BO", "037030", "44.55327", "11.44291", "Europe/Rome"),("3163853", "Zola Predosa", "", "IT", "380", "", "05", "BO", "037060", "44.48967", "11.21831", "Europe/Rome"),("3163854", "Zogno", "", "IT", "380", "", "09", "BG", "016246", "45.79378", "9.65992", "Europe/Rome"),("3163878", "Zevio", "", "IT", "380", "", "20", "VR", "023097", "45.37209", "11.12929", "Europe/Rome"),("3163879", "Zero Branco", "", "IT", "380", "", "20", "TV", "026095", "45.59952", "12.16381", "Europe/Rome"),("3163894", "Zelo Buon Persico", "", "IT", "380", "", "09", "LO", "098061", "45.4117", "9.43171", "Europe/Rome"),("3163898", "Zelarino", "", "IT", "380", "", "20", "VE", "027042", "45.51508", "12.2079", "Europe/Rome"),("3163911", "Zanica", "", "IT", "380", "", "09", "BG", "016245", "45.64088", "9.68566", "Europe/Rome"),("3163916", "Zanè", "", "IT", "380", "", "20", "VI", "024119", "45.722", "11.44932", "Europe/Rome"),("3163932", "Zagarolo", "", "IT", "380", "", "07", "RM", "058114", "41.84159", "12.8154", "Europe/Rome"),("3163950", "Volvera", "", "IT", "380", "", "12", "TO", "001315", "44.95484", "7.51142", "Europe/Rome"),("3163962", "Volterra", "", "IT", "380", "", "16", "PI", "050039", "43.40251", "10.86152", "Europe/Rome"),("3163974", "Volpiano", "", "IT", "380", "", "12", "TO", "001314", "45.1994", "7.77546", "Europe/Rome"),("3163995", "Voghera", "", "IT", "380", "", "09", "PV", "018182", "44.99151", "9.01175", "Europe/Rome"),("3164002", "Vobarno", "", "IT", "380", "", "09", "BS", "017204", "45.64153", "10.49866", "Europe/Rome"),("3164024", "Vitulazio", "", "IT", "380", "", "04", "CE", "061100", "41.16302", "14.21341", "Europe/Rome"),("3164026", "Vittuone", "", "IT", "380", "", "09", "MI", "015243", "45.48792", "8.95141", "Europe/Rome"),("3164028", "Vittorio Veneto", "Витторио-Венето", "IT", "380", "", "20", "TV", "026092", "45.98026", "12.30065", "Europe/Rome"),("3164039", "Viterbo", "Витербо", "IT", "380", "", "07", "VT", "056059", "42.41937", "12.1056", "Europe/Rome"),("3164065", "Vipiteno", "", "IT", "380", "", "17", "BZ", "021115", "46.89313", "11.42961", "Europe/Rome"),("3164080", "Vimodrone", "", "IT", "380", "", "09", "MI", "015242", "45.51461", "9.28772", "Europe/Rome"),("3164083", "Vimercate", "Вимеркате", "IT", "380", "", "09", "MB", "108050", "45.61545", "9.36801", "Europe/Rome"),("3164090", "Lancenigo-Villorba", "", "IT", "380", "", "20", "TV", "026091", "45.71289", "12.25697", "Europe/Rome"),("3164092", "Villongo", "", "IT", "380", "", "09", "BG", "016242", "45.66939", "9.93076", "Europe/Rome"),("3164115", "Villa Verucchio", "", "IT", "380", "", "05", "RN", "099020", "44.0051", "12.43575", "Europe/Rome"),("3164138", "Villasanta", "", "IT", "380", "", "09", "MB", "108049", "45.60634", "9.30797", "Europe/Rome"),("3164153", "Villaricca", "Вилларикка", "IT", "380", "", "04", "NA", "063087", "40.92006", "14.19339", "Europe/Rome"),("3164172", "Villanuova sul Clisi", "", "IT", "380", "", "09", "BS", "017201", "45.59938", "10.45275", "Europe/Rome"),("3164219", "Villa Literno", "", "IT", "380", "", "04", "CE", "061099", "41.00942", "14.07612", "Europe/Rome"),("3164227", "Villa Guardia", "", "IT", "380", "", "09", "CO", "013245", "45.77505", "9.02321", "Europe/Rome"),("3164241", "Villafranca di Verona", "", "IT", "380", "", "20", "VR", "023096", "45.35405", "10.84462", "Europe/Rome"),("3164253", "Villadossola", "", "IT", "380", "IT", "12", "VB", "103075", "46.0708", "8.26709", "Europe/Rome"),("3164254", "Villadose", "", "IT", "380", "", "20", "RO", "029048", "45.07219", "11.89899", "Europe/Rome"),("3164258", "Villa di Serio", "", "IT", "380", "", "09", "BG", "016240", "45.7226", "9.73522", "Europe/Rome"),("3164270", "Villa d'Almè", "", "IT", "380", "", "09", "BG", "016239", "45.74843", "9.61702", "Europe/Rome"),("3164274", "Villa Cortese", "", "IT", "380", "", "09", "MI", "015248", "45.56666", "8.88712", "Europe/Rome"),("3164282", "Villa Castelli", "", "IT", "380", "", "13", "BR", "074020", "40.58293", "17.47468", "Europe/Rome"),("3164308", "Villa Carcina", "", "IT", "380", "", "09", "BS", "017199", "45.63329", "10.19556", "Europe/Rome"),("3164318", "Vigonza", "", "IT", "380", "", "20", "PD", "028100", "45.43484", "11.97465", "Europe/Rome"),("3164319", "Vigonovo-Fontanafredda", "", "IT", "380", "", "06", "PN", "093022", "45.98927", "12.54707", "Europe/Rome"),("3164332", "Vigodarzere", "", "IT", "380", "", "20", "PD", "028099", "45.45751", "11.88555", "Europe/Rome"),("3164342", "Vignola", "", "IT", "380", "", "05", "MO", "036046", "44.48383", "11.01096", "Europe/Rome"),("3164352", "Vignate", "", "IT", "380", "", "09", "MI", "015237", "45.49939", "9.37719", "Europe/Rome"),("3164368", "Vigliano Biellese", "", "IT", "380", "", "12", "BI", "096077", "45.56317", "8.10509", "Europe/Rome"),("3164376", "Vigevano", "Виджевано", "IT", "380", "", "09", "PV", "018177", "45.31407", "8.85437", "Europe/Rome"),("3164381", "Vigasio", "", "IT", "380", "", "20", "VR", "023094", "45.3178", "10.94371", "Europe/Rome"),("3164387", "Vieste", "", "IT", "380", "", "13", "FG", "071060", "41.88209", "16.17139", "Europe/Rome"),("3164396", "Vicopisano", "", "IT", "380", "", "16", "PI", "050038", "43.69305", "10.58359", "Europe/Rome"),("3164407", "Vico Equense", "", "IT", "380", "", "04", "NA", "063086", "40.65977", "14.43386", "Europe/Rome"),("3164409", "Vico del Gargano", "", "IT", "380", "IT", "13", "FG", "071059", "41.89661", "15.95682", "Europe/Rome"),("3164419", "Vicenza", "Виченца", "IT", "380", "", "20", "VI", "024116", "45.54672", "11.5475", "Europe/Rome"),("3164433", "Viareggio", "Виареджио", "IT", "380", "", "16", "LU", "046033", "43.86693", "10.2502", "Europe/Rome"),("3164440", "Viadana", "", "IT", "380", "", "09", "MN", "020066", "44.93553", "10.51898", "Europe/Rome"),("3164472", "Vetralla", "", "IT", "380", "", "07", "VT", "056057", "42.31787", "12.07323", "Europe/Rome"),("3164527", "Verona", "Верона", "IT", "380", "", "20", "VR", "023091", "45.4299", "10.98444", "Europe/Rome"),("3164531", "Verolanuova", "", "IT", "380", "", "09", "BS", "017195", "45.32834", "10.07857", "Europe/Rome"),("3164533", "Vernio", "", "IT", "380", "", "16", "PO", "100007", "44.04755", "11.15052", "Europe/Rome"),("3164548", "Vergiate", "", "IT", "380", "", "09", "VA", "012138", "45.7221", "8.6953", "Europe/Rome"),("3164557", "Verdello", "", "IT", "380", "", "09", "BG", "016233", "45.60372", "9.62852", "Europe/Rome"),("3164565", "Vercelli", "Верчелли", "IT", "380", "", "12", "VC", "002158", "45.32163", "8.41989", "Europe/Rome"),("3164572", "Venturina", "", "IT", "380", "", "16", "LI", "049002", "43.02883", "10.60147", "Europe/Rome"),("3164582", "Ventimiglia", "Вентимилья", "IT", "380", "", "08", "IM", "008065", "43.78956", "7.60872", "Europe/Rome"),("3164592", "Venosa", "", "IT", "380", "", "02", "PZ", "076095", "40.96283", "15.81285", "Europe/Rome"),("3164603", "Venice", "Венеция", "IT", "380", "", "20", "VE", "027042", "45.43713", "12.33265", "Europe/Rome"),("3164608", "Venegono Superiore", "", "IT", "380", "", "09", "VA", "012137", "45.75246", "8.89734", "Europe/Rome"),("3164609", "Venegono Inferiore", "", "IT", "380", "", "09", "VA", "012136", "45.73569", "8.89545", "Europe/Rome"),("3164617", "Venaria Reale", "", "IT", "380", "", "12", "TO", "001292", "45.12597", "7.63136", "Europe/Rome"),("3164621", "Venafro", "", "IT", "380", "", "11", "IS", "094052", "41.48275", "14.04773", "Europe/Rome"),("3164630", "Velletri", "", "IT", "380", "", "07", "RM", "058111", "41.68573", "12.77753", "Europe/Rome"),("3164646", "Veglie", "", "IT", "380", "", "13", "LE", "075092", "40.33474", "17.96238", "Europe/Rome"),("3164657", "Vedano Olona", "", "IT", "380", "", "09", "VA", "012134", "45.7757", "8.88771", "Europe/Rome"),("3164663", "Vecchiano-Nodica", "", "IT", "380", "", "16", "PI", "050037", "43.78334", "10.3844", "Europe/Rome"),("3164665", "Vazzola", "", "IT", "380", "", "20", "TV", "026088", "45.83511", "12.40851", "Europe/Rome"),("3164672", "Vasto", "Васто", "IT", "380", "", "01", "CH", "069099", "42.1115", "14.70649", "Europe/Rome"),("3164699", "Varese", "Варезе", "IT", "380", "", "09", "VA", "012133", "45.82058", "8.82511", "Europe/Rome"),("3164702", "Varedo", "", "IT", "380", "", "09", "MB", "108045", "45.59761", "9.16323", "Europe/Rome"),("3164709", "Varazze", "", "IT", "380", "", "08", "SV", "009065", "44.36412", "8.5963", "Europe/Rome"),("3164718", "Varallo", "", "IT", "380", "", "12", "VC", "002156", "45.81383", "8.25814", "Europe/Rome"),("3164723", "Vaprio d'Adda", "", "IT", "380", "IT", "09", "MI", "015230", "45.5764", "9.52407", "Europe/Rome"),("3164727", "Vanzago", "", "IT", "380", "", "09", "MI", "015229", "45.52566", "8.99097", "Europe/Rome"),("3164728", "Vanzaghello", "", "IT", "380", "", "09", "MI", "015249", "45.57964", "8.78234", "Europe/Rome"),("3164778", "Valmontone", "", "IT", "380", "", "07", "RM", "058110", "41.77323", "12.91856", "Europe/Rome"),("3164782", "Valmadrera-Caserta", "", "IT", "380", "", "09", "LC", "097083", "45.84628", "9.35824", "Europe/Rome"),("3164794", "Vallo della Lucania", "", "IT", "380", "IT", "04", "SA", "065154", "40.22786", "15.26635", "Europe/Rome"),("3164862", "Vallecrosia", "", "IT", "380", "", "08", "IM", "008063", "43.78671", "7.63902", "Europe/Rome"),("3164919", "Valenzano", "", "IT", "380", "", "13", "BA", "072048", "41.04376", "16.88491", "Europe/Rome"),("3164920", "Valenza", "Валенса", "IT", "380", "", "12", "AL", "006177", "45.01242", "8.64379", "Europe/Rome"),("3164924", "Valeggio sul Mincio", "", "IT", "380", "", "20", "VR", "023089", "45.35333", "10.73635", "Europe/Rome"),("3164931", "Valdobbiadene", "", "IT", "380", "", "20", "TV", "026087", "45.89689", "11.98245", "Europe/Rome"),("3164954", "Valdagno", "", "IT", "380", "", "20", "VI", "024111", "45.64498", "11.29886", "Europe/Rome"),("3164973", "Vaiano", "", "IT", "380", "", "16", "PO", "100006", "43.96792", "11.12374", "Europe/Rome"),("3164988", "Vado Ligure", "", "IT", "380", "", "08", "SV", "009064", "44.26913", "8.43375", "Europe/Rome"),("3165018", "Usmate-Velate", "", "IT", "380", "", "09", "MB", "108044", "45.64798", "9.36245", "Europe/Rome"),("3165031", "Urgnano", "", "IT", "380", "", "09", "BG", "016222", "45.59943", "9.69473", "Europe/Rome"),("3165035", "Urbino", "", "IT", "380", "", "10", "PU", "041067", "43.72621", "12.63633", "Europe/Rome"),("3165038", "Urbania", "", "IT", "380", "", "10", "PU", "041066", "43.66832", "12.52093", "Europe/Rome"),("3165052", "Umbertide", "", "IT", "380", "", "18", "PG", "054056", "43.30341", "12.33749", "Europe/Rome"),("3165072", "Udine", "Удине", "IT", "380", "", "06", "UD", "030129", "46.0693", "13.23715", "Europe/Rome"),("3165083", "Tuscania", "", "IT", "380", "", "07", "VT", "056052", "42.41889", "11.86846", "Europe/Rome"),("3165094", "Turi", "", "IT", "380", "", "13", "BA", "072047", "40.91657", "17.02038", "Europe/Rome"),("3165100", "Turbigo", "", "IT", "380", "", "09", "MI", "015226", "45.53076", "8.73671", "Europe/Rome"),("3165116", "Tuglie", "", "IT", "380", "", "13", "LE", "075089", "40.07346", "18.09872", "Europe/Rome"),("3165141", "Troia", "", "IT", "380", "", "13", "FG", "071058", "41.36428", "15.3173", "Europe/Rome"),("3165142", "Trofarello", "", "IT", "380", "", "12", "TO", "001280", "44.98238", "7.74688", "Europe/Rome"),("3165157", "Trissino", "", "IT", "380", "", "20", "VI", "024110", "45.55994", "11.37678", "Europe/Rome"),("3165165", "Trino", "", "IT", "380", "", "12", "VC", "002148", "45.19538", "8.29621", "Europe/Rome"),("3165166", "Trinitapoli", "", "IT", "380", "", "13", "BT", "110010", "41.35654", "16.08924", "Europe/Rome"),("3165178", "Triggiano", "", "IT", "380", "", "13", "BA", "072046", "41.06549", "16.92501", "Europe/Rome"),("3165185", "Trieste", "Триест", "IT", "380", "", "06", "TS", "032006", "45.64325", "13.7903", "Europe/Rome"),("3165189", "Tricesimo", "", "IT", "380", "", "06", "UD", "030127", "46.16058", "13.21566", "Europe/Rome"),("3165197", "Trezzo sull'Adda", "", "IT", "380", "", "09", "MI", "015221", "45.60523", "9.51417", "Europe/Rome"),("3165198", "Trezzano sul Naviglio", "", "IT", "380", "", "09", "MI", "015220", "45.42212", "9.06342", "Europe/Rome"),("3165201", "Treviso", "Тревизо", "IT", "380", "", "20", "TV", "026086", "45.66673", "12.2416", "Europe/Rome"),("3165207", "Treviglio", "Тревильо", "IT", "380", "", "09", "BG", "016219", "45.52081", "9.59102", "Europe/Rome"),("3165226", "Trescore Balneario", "", "IT", "380", "", "09", "BG", "016218", "45.69409", "9.84173", "Europe/Rome"),("3165227", "Trescine", "", "IT", "380", "", "04", "AV", "064025", "41.02256", "14.62039", "Europe/Rome"),("3165233", "Trepuzzi", "", "IT", "380", "", "13", "LE", "075087", "40.40535", "18.07625", "Europe/Rome"),("3165240", "Trentola-Ducenta", "", "IT", "380", "", "04", "CE", "061094", "40.97517", "14.1749", "Europe/Rome"),("3165243", "Trento", "Тренто", "IT", "380", "", "17", "TN", "022205", "46.06787", "11.12108", "Europe/Rome"),("3165275", "Trecate", "", "IT", "380", "", "12", "NO", "003149", "45.43399", "8.7364", "Europe/Rome"),("3165286", "Trebaseleghe", "", "IT", "380", "", "20", "PD", "028093", "45.59295", "12.04392", "Europe/Rome"),("3165291", "Traversetolo", "", "IT", "380", "", "05", "PR", "034042", "44.64244", "10.38036", "Europe/Rome"),("3165301", "Travagliato", "", "IT", "380", "", "09", "BS", "017188", "45.52391", "10.08013", "Europe/Rome"),("3165314", "Trasacco", "", "IT", "380", "", "01", "AQ", "066102", "41.95742", "13.5327", "Europe/Rome"),("3165322", "Trani", "Трани", "IT", "380", "", "13", "BT", "110009", "41.27733", "16.41011", "Europe/Rome"),("3165340", "Tradate", "", "IT", "380", "", "09", "VA", "012127", "45.70843", "8.90763", "Europe/Rome"),("3165356", "Toscolano Maderno", "", "IT", "380", "", "09", "BS", "017187", "45.63977", "10.6076", "Europe/Rome"),("3165370", "Tortona", "Тортона", "IT", "380", "", "12", "AL", "006174", "44.89784", "8.86374", "Europe/Rome"),("3165381", "Torrita di Siena", "", "IT", "380", "", "16", "SI", "052035", "43.17245", "11.78376", "Europe/Rome"),("3165394", "Torri di Quartesolo", "", "IT", "380", "", "20", "VI", "024108", "45.51901", "11.62469", "Europe/Rome"),("3165420", "Torre Santa Susanna", "", "IT", "380", "", "13", "BR", "074019", "40.46762", "17.73864", "Europe/Rome"),("3165435", "Torremaggiore", "", "IT", "380", "", "13", "FG", "071056", "41.68894", "15.29408", "Europe/Rome"),("3165438", "Torreglia", "", "IT", "380", "", "20", "PD", "028092", "45.33617", "11.73608", "Europe/Rome"),("3165455", "Torre del Lago Puccini", "", "IT", "380", "IT", "16", "LU", "046033", "43.82887", "10.28912", "Europe/Rome"),("3165456", "Torre del Greco", "Торре-дель-Греко", "IT", "380", "", "04", "NA", "063084", "40.78931", "14.36806", "Europe/Rome"),("3165471", "Torre Boldone", "", "IT", "380", "", "09", "BG", "016214", "45.71725", "9.70792", "Europe/Rome"),("3165475", "Torre Annunziata", "Торре-Аннунциата", "IT", "380", "", "04", "NA", "063083", "40.75337", "14.45251", "Europe/Rome"),("3165513", "Toritto", "", "IT", "380", "", "13", "BA", "072044", "40.99774", "16.67945", "Europe/Rome"),("3165524", "Turin", "Турин", "IT", "380", "", "12", "TO", "001272", "45.07049", "7.68682", "Europe/Rome"),("3165535", "Torchiarolo", "", "IT", "380", "", "13", "BR", "074018", "40.48349", "18.05122", "Europe/Rome"),("3165542", "Torbole Casaglia", "", "IT", "380", "IT", "09", "BS", "017186", "45.51279", "10.117", "Europe/Rome"),("3165576", "Tombolo", "", "IT", "380", "", "20", "PD", "028091", "45.63916", "11.82435", "Europe/Rome"),("3165584", "Tolmezzo", "", "IT", "380", "", "06", "UD", "030121", "46.39996", "13.02051", "Europe/Rome"),("3165595", "Tolentino", "", "IT", "380", "", "10", "MC", "043053", "43.20918", "13.28524", "Europe/Rome"),("3165612", "Todi", "", "IT", "380", "", "18", "PG", "054052", "42.77881", "12.41202", "Europe/Rome"),("3165624", "Tivoli", "Тиволи", "IT", "380", "", "07", "RM", "058104", "41.95952", "12.8016", "Europe/Rome"),("3165639", "Marina di Pisa-Tirrenia-Calambrone", "", "IT", "380", "", "16", "PI", "050026", "43.62719", "10.29204", "Europe/Rome"),("3165647", "Tirano", "", "IT", "380", "", "09", "SO", "014066", "46.21482", "10.16335", "Europe/Rome"),("3165685", "Tecchiena", "", "IT", "380", "IT", "07", "FR", "060003", "41.68822", "13.34538", "Europe/Rome"),("3165698", "Thiene", "Тьене", "IT", "380", "", "20", "VI", "024105", "45.7088", "11.47959", "Europe/Rome"),("3165737", "Terzigno", "", "IT", "380", "", "04", "NA", "063082", "40.804", "14.49309", "Europe/Rome"),("3165751", "Terranuova Bracciolini", "", "IT", "380", "", "16", "AR", "051039", "43.55081", "11.58075", "Europe/Rome"),("3165762", "Terracina", "Террачина", "IT", "380", "", "07", "LT", "059032", "41.29174", "13.24359", "Europe/Rome"),("3165771", "Terni", "Терни", "IT", "380", "", "18", "TR", "055032", "42.56335", "12.64329", "Europe/Rome"),("3165773", "Termoli", "Термоли", "IT", "380", "", "11", "CB", "070078", "41.99994", "14.99389", "Europe/Rome"),("3165788", "Terlizzi", "Терлицци", "IT", "380", "", "13", "BA", "072043", "41.12905", "16.54536", "Europe/Rome"),("3165803", "Teramo", "Терамо", "IT", "380", "", "01", "TE", "067041", "42.66123", "13.69901", "Europe/Rome"),("3165824", "Tencarola", "", "IT", "380", "", "20", "PD", "028086", "45.3949", "11.80919", "Europe/Rome"),("3165828", "Tempio Pausania", "", "IT", "380", "", "14", "OT", "104025", "40.90068", "9.10456", "Europe/Rome"),("3165842", "Telese", "", "IT", "380", "", "04", "BN", "062074", "41.21752", "14.52681", "Europe/Rome"),("3165856", "Teano", "", "IT", "380", "", "04", "CE", "061091", "41.25132", "14.06652", "Europe/Rome"),("3165892", "Tavazzano", "", "IT", "380", "", "09", "LO", "098056", "45.32783", "9.40473", "Europe/Rome"),("3165896", "Tavagnacco", "", "IT", "380", "", "06", "UD", "030118", "46.10976", "13.22251", "Europe/Rome"),("3165919", "Tarquinia", "", "IT", "380", "", "07", "VT", "056050", "42.25419", "11.75657", "Europe/Rome"),("3165923", "Tarcento", "", "IT", "380", "", "06", "UD", "030116", "46.21251", "13.21514", "Europe/Rome"),("3165926", "Taranto", "Таранто", "IT", "380", "", "13", "TA", "073027", "40.41639", "17.25478", "Europe/Rome"),("3165981", "Taglio di Po", "", "IT", "380", "", "20", "RO", "029046", "45.00189", "12.21386", "Europe/Rome"),("3165986", "Taglio", "", "IT", "380", "", "20", "RO", "029052", "45.02222", "12.21083", "Europe/Rome"),("3165993", "Taggia", "", "IT", "380", "", "08", "IM", "008059", "43.84612", "7.85223", "Europe/Rome"),("3166006", "Suzzara", "", "IT", "380", "", "09", "MN", "020065", "44.99242", "10.74407", "Europe/Rome"),("3166018", "Susa", "", "IT", "380", "", "12", "TO", "001270", "45.13677", "7.05809", "Europe/Rome"),("3166021", "Surbo", "", "IT", "380", "", "13", "LE", "075083", "40.39383", "18.13456", "Europe/Rome"),("3166032", "Sumirago", "", "IT", "380", "", "09", "VA", "012124", "45.73651", "8.78356", "Europe/Rome"),("3166034", "Sulmona", "Сулмона", "IT", "380", "", "01", "AQ", "066098", "42.04945", "13.92578", "Europe/Rome"),("3166052", "Subiaco", "", "IT", "380", "", "07", "RM", "058103", "41.92619", "13.08906", "Europe/Rome"),("3166096", "Striano", "", "IT", "380", "", "04", "NA", "063081", "40.81543", "14.57534", "Europe/Rome"),("3166114", "Stradella", "", "IT", "380", "", "09", "PV", "018153", "45.07445", "9.30169", "Europe/Rome"),("3166122", "Stra", "", "IT", "380", "", "20", "VE", "027039", "45.41123", "12.01418", "Europe/Rome"),("3166125", "Stornara", "", "IT", "380", "", "13", "FG", "071054", "41.28672", "15.77003", "Europe/Rome"),("3166151", "Stezzano", "", "IT", "380", "", "09", "BG", "016207", "45.64968", "9.65192", "Europe/Rome"),("3166189", "Statte", "", "IT", "380", "", "13", "TA", "073029", "40.52856", "17.20122", "Europe/Rome"),("3166193", "Staranzano", "", "IT", "380", "", "06", "GO", "031023", "45.80233", "13.50226", "Europe/Rome"),("3166224", "Squinzano", "", "IT", "380", "", "13", "LE", "075079", "40.43513", "18.04086", "Europe/Rome"),("3166227", "Spresiano", "", "IT", "380", "", "20", "TV", "026082", "45.77908", "12.25628", "Europe/Rome"),("3166236", "Spoleto", "Сполето", "IT", "380", "", "18", "PG", "054051", "42.74071", "12.73899", "Europe/Rome"),("3166238", "Spirano", "", "IT", "380", "", "09", "BG", "016206", "45.58144", "9.66863", "Europe/Rome"),("3166241", "Spino d'Adda", "", "IT", "380", "", "09", "CR", "019102", "45.40086", "9.48674", "Europe/Rome"),("3166243", "Spinetta Marengo", "", "IT", "380", "IT", "12", "AL", "006003", "44.88554", "8.6775", "Europe/Rome"),("3166253", "Spinazzola", "", "IT", "380", "", "13", "BT", "110008", "40.96399", "16.09111", "Europe/Rome"),("3166262", "Spilimbergo", "", "IT", "380", "", "06", "PN", "093044", "46.11345", "12.89241", "Europe/Rome"),("3166263", "Spilamberto", "", "IT", "380", "", "05", "MO", "036045", "44.53273", "11.01697", "Europe/Rome"),("3166301", "Sparanise", "", "IT", "380", "", "04", "CE", "061089", "41.18788", "14.09628", "Europe/Rome"),("3166346", "Sorso", "", "IT", "380", "", "14", "SS", "090069", "40.79949", "8.5757", "Europe/Rome"),("3166350", "Sorrento", "", "IT", "380", "", "04", "NA", "063080", "40.62375", "14.38096", "Europe/Rome"),("3166356", "Sorisole", "", "IT", "380", "", "09", "BG", "016202", "45.7314", "9.63715", "Europe/Rome"),("3166357", "Soriano nel Cimino", "", "IT", "380", "", "07", "VT", "056048", "42.4182", "12.23414", "Europe/Rome"),("3166365", "Soresina", "", "IT", "380", "", "09", "CR", "019098", "45.28819", "9.85862", "Europe/Rome"),("3166374", "Sorbolo", "", "IT", "380", "", "05", "PR", "034037", "44.84587", "10.44375", "Europe/Rome"),("3166387", "Sora", "Сора", "IT", "380", "", "07", "FR", "060074", "41.71829", "13.61356", "Europe/Rome"),("3166397", "Sondrio", "Сондрио", "IT", "380", "", "09", "SO", "014061", "46.16852", "9.87134", "Europe/Rome"),("3166399", "Soncino", "", "IT", "380", "", "09", "CR", "019097", "45.40033", "9.86845", "Europe/Rome"),("3166404", "Somma Vesuviana", "", "IT", "380", "", "04", "NA", "063079", "40.87329", "14.43865", "Europe/Rome"),("3166407", "Sommariva del Bosco", "", "IT", "380", "", "12", "CN", "004222", "44.77257", "7.78177", "Europe/Rome"),("3166409", "Somma Lombardo", "", "IT", "380", "", "09", "VA", "012123", "45.68213", "8.70759", "Europe/Rome"),("3166410", "Sommacampagna", "", "IT", "380", "", "20", "VR", "023082", "45.40528", "10.84382", "Europe/Rome"),("3166420", "Solofra", "", "IT", "380", "", "04", "AV", "064101", "40.83343", "14.83705", "Europe/Rome"),("3166426", "Soliera", "", "IT", "380", "", "05", "MO", "036044", "44.73387", "10.92177", "Europe/Rome"),("3166428", "Soleto", "", "IT", "380", "", "13", "LE", "075076", "40.18781", "18.2063", "Europe/Rome"),("3166429", "Solesino", "", "IT", "380", "", "20", "PD", "028087", "45.17922", "11.74647", "Europe/Rome"),("3166439", "Solbiate Olona", "", "IT", "380", "", "09", "VA", "012122", "45.65028", "8.88198", "Europe/Rome"),("3166448", "Solaro", "", "IT", "380", "", "09", "MI", "015213", "45.61427", "9.08304", "Europe/Rome"),("3166449", "Solaro", "", "IT", "380", "", "09", "PV", "018166", "44.8799", "9.17315", "Europe/Rome"),("3166468", "Soave", "", "IT", "380", "", "20", "VR", "023081", "45.41955", "11.24594", "Europe/Rome"),("3166479", "Siziano", "", "IT", "380", "", "09", "PV", "018150", "45.31606", "9.20357", "Europe/Rome"),("3166499", "Sirmione", "", "IT", "380", "", "09", "BS", "017179", "45.49744", "10.60507", "Europe/Rome"),("3166509", "Siniscola", "", "IT", "380", "", "14", "NU", "091085", "40.57344", "9.69695", "Europe/Rome"),("3166516", "Sinalunga", "", "IT", "380", "", "16", "SI", "052033", "43.21492", "11.74507", "Europe/Rome"),("3166520", "Silvi", "", "IT", "380", "", "01", "TE", "067040", "42.54984", "14.11759", "Europe/Rome"),("3166532", "Silea", "", "IT", "380", "", "20", "TV", "026081", "45.65444", "12.29701", "Europe/Rome"),("3166540", "Signa", "", "IT", "380", "", "16", "FI", "048044", "43.7942", "11.1036", "Europe/Rome"),("3166548", "Siena", "Сиена", "IT", "380", "", "16", "SI", "052032", "43.31822", "11.33064", "Europe/Rome"),("3166561", "Siano", "", "IT", "380", "", "04", "SA", "065142", "40.80207", "14.69334", "Europe/Rome"),("3166571", "Sezze", "", "IT", "380", "", "07", "LT", "059028", "41.50032", "13.06176", "Europe/Rome"),("3166574", "Seveso", "", "IT", "380", "", "09", "MB", "108040", "45.6467", "9.14296", "Europe/Rome"),("3166576", "Settimo Torinese", "", "IT", "380", "", "12", "TO", "001265", "45.13925", "7.77008", "Europe/Rome"),("3166595", "Sestri Levante", "", "IT", "380", "", "08", "GE", "010059", "44.27317", "9.39683", "Europe/Rome"),("3166598", "Sesto San Giovanni", "", "IT", "380", "", "09", "MI", "015209", "45.53329", "9.22585", "Europe/Rome"),("3166601", "Sesto Fiorentino", "", "IT", "380", "", "16", "FI", "048043", "43.83193", "11.19924", "Europe/Rome"),("3166604", "Sesto Calende", "", "IT", "380", "", "09", "VA", "012120", "45.72608", "8.63397", "Europe/Rome"),("3166614", "Sessa Aurunca", "", "IT", "380", "", "04", "CE", "061088", "41.23987", "13.92966", "Europe/Rome"),("3166637", "Serravalle Scrivia", "", "IT", "380", "", "12", "AL", "006160", "44.72277", "8.85635", "Europe/Rome"),("3166656", "Serra Riccò", "", "IT", "380", "", "08", "GE", "010058", "44.51071", "8.93806", "Europe/Rome"),("3166702", "Serino", "", "IT", "380", "", "04", "AV", "064099", "40.85481", "14.87224", "Europe/Rome"),("3166706", "Seriate", "Сериате", "IT", "380", "", "09", "BG", "016198", "45.68532", "9.72487", "Europe/Rome"),("3166711", "Seregno", "", "IT", "380", "", "09", "MB", "108039", "45.65002", "9.20548", "Europe/Rome"),("3166729", "Sennori", "", "IT", "380", "", "14", "SS", "090067", "40.7878", "8.59285", "Europe/Rome"),("3166737", "Senise", "", "IT", "380", "", "02", "PZ", "076085", "40.14616", "16.28867", "Europe/Rome"),("3166740", "Senigallia", "Сенигаллия", "IT", "380", "", "10", "AN", "042045", "43.71626", "13.20882", "Europe/Rome"),("3166753", "Senago", "", "IT", "380", "", "09", "MI", "015206", "45.57562", "9.1262", "Europe/Rome"),("3166766", "Selvazzano Dentro", "", "IT", "380", "", "20", "PD", "028086", "45.38764", "11.79232", "Europe/Rome"),("3166808", "Segrate", "", "IT", "380", "", "09", "MI", "015205", "45.49185", "9.29812", "Europe/Rome"),("3166813", "Segni", "", "IT", "380", "", "07", "RM", "058102", "41.68893", "13.01934", "Europe/Rome"),("3166822", "Sedriano", "", "IT", "380", "", "09", "MI", "015204", "45.49105", "8.97161", "Europe/Rome"),("3166826", "Sedico", "", "IT", "380", "", "20", "BL", "025053", "46.10563", "12.0933", "Europe/Rome"),("3166850", "Seano", "", "IT", "380", "", "16", "PO", "100002", "43.83035", "11.02122", "Europe/Rome"),("3166866", "Scorzè", "", "IT", "380", "", "20", "VE", "027037", "45.57405", "12.11156", "Europe/Rome"),("3166872", "Scorrano", "", "IT", "380", "", "13", "LE", "075073", "40.09018", "18.29993", "Europe/Rome"),("3166917", "Schio", "Скио", "IT", "380", "", "20", "VI", "024100", "45.71262", "11.35671", "Europe/Rome"),("3166955", "Scarperia", "", "IT", "380", "", "16", "FI", "048053", "43.99357", "11.35415", "Europe/Rome"),("3166988", "Scandicci", "Скандиччи", "IT", "380", "", "16", "FI", "048041", "43.75423", "11.18794", "Europe/Rome"),("3166989", "Scandiano", "", "IT", "380", "", "05", "RE", "035040", "44.5983", "10.69558", "Europe/Rome"),("3167010", "Scafati", "", "IT", "380", "", "04", "SA", "065137", "40.7602", "14.53723", "Europe/Rome"),("3167022", "Savona", "Савона", "IT", "380", "", "08", "SV", "009056", "44.30905", "8.47715", "Europe/Rome"),("3167030", "Savignano sul Rubicone", "", "IT", "380", "", "05", "FC", "040045", "44.09009", "12.39935", "Europe/Rome"),("3167034", "Savigliano", "", "IT", "380", "", "12", "CN", "004215", "44.64808", "7.65677", "Europe/Rome"),("3167035", "Saviano", "", "IT", "380", "", "04", "NA", "063076", "40.90507", "14.50498", "Europe/Rome"),("3167044", "Sava", "", "IT", "380", "", "13", "TA", "073026", "40.40203", "17.55267", "Europe/Rome"),("3167053", "Sassuolo", "Сассуоло", "IT", "380", "", "05", "MO", "036040", "44.5432", "10.7848", "Europe/Rome"),("3167062", "Sasso Marconi", "", "IT", "380", "", "05", "BO", "037057", "44.40064", "11.25177", "Europe/Rome"),("3167096", "Sassari", "Сассари", "IT", "380", "", "14", "SS", "090064", "40.72586", "8.55552", "Europe/Rome"),("3167104", "Sarzana", "", "IT", "380", "", "08", "SP", "011027", "44.11178", "9.9622", "Europe/Rome"),("3167113", "Saronno", "", "IT", "380", "", "09", "VA", "012119", "45.62513", "9.03517", "Europe/Rome"),("3167116", "Sarno", "Сарно", "IT", "380", "", "04", "SA", "065135", "40.80748", "14.62151", "Europe/Rome"),("3167117", "Sarnico", "", "IT", "380", "", "09", "BG", "016193", "45.67099", "9.96152", "Europe/Rome"),("3167120", "Sarmeola", "", "IT", "380", "", "20", "PD", "028072", "45.424", "11.81674", "Europe/Rome"),("3167128", "Sarezzo", "", "IT", "380", "", "09", "BS", "017174", "45.66067", "10.1969", "Europe/Rome"),("3167152", "Sapri", "", "IT", "380", "IT", "04", "SA", "065134", "40.07464", "15.63212", "Europe/Rome"),("3167161", "San Zenone degli Ezzelini", "", "IT", "380", "", "20", "TV", "026077", "45.7804", "11.8372", "Europe/Rome"),("3167184", "San Vito dei Normanni", "", "IT", "380", "", "13", "BR", "074017", "40.65642", "17.70814", "Europe/Rome"),("3167186", "San Vito al Tagliamento", "", "IT", "380", "", "06", "PN", "093041", "45.9168", "12.85945", "Europe/Rome"),("3167207", "San Vincenzo", "", "IT", "380", "", "16", "LI", "049018", "43.09061", "10.54246", "Europe/Rome"),("3167213", "San Vendemiano", "", "IT", "380", "", "20", "TV", "026076", "45.88732", "12.35164", "Europe/Rome"),("3167219", "San Valentino Torio", "", "IT", "380", "", "04", "SA", "065132", "40.79109", "14.60333", "Europe/Rome"),("3167239", "Santo Stino di Livenza", "", "IT", "380", "", "20", "VE", "027036", "45.72559", "12.68971", "Europe/Rome"),("3167243", "Santo Stefano di Magra", "", "IT", "380", "", "08", "SP", "011026", "44.14891", "9.92185", "Europe/Rome"),("3167268", "Santorso", "", "IT", "380", "", "20", "VI", "024095", "45.73383", "11.38785", "Europe/Rome"),("3167304", "Sant'Ilario d'Enza", "", "IT", "380", "IT", "05", "RE", "035039", "44.7589", "10.44737", "Europe/Rome"),("3167314", "Santhià", "", "IT", "380", "", "12", "VC", "002133", "45.36795", "8.17012", "Europe/Rome");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("3167327", "Santeramo in Colle", "", "IT", "380", "", "13", "BA", "072041", "40.79236", "16.75873", "Europe/Rome"),("3167333", "Sant'Elpidio a Mare", "", "IT", "380", "IT", "10", "FM", "109037", "43.23024", "13.68819", "Europe/Rome"),("3167347", "Sant'Egidio alla Vibrata", "", "IT", "380", "", "01", "TE", "067038", "42.81705", "13.72164", "Europe/Rome"),("3167368", "Sant'Arpino", "", "IT", "380", "IT", "04", "CE", "061087", "40.95716", "14.25075", "Europe/Rome"),("3167373", "Santarcangelo", "", "IT", "380", "", "05", "RN", "099018", "44.06326", "12.44657", "Europe/Rome"),("3167393", "Sant'Antonio Abate", "", "IT", "380", "", "04", "NA", "063074", "40.72152", "14.54021", "Europe/Rome"),("3167409", "Sant'Antonio", "", "IT", "380", "", "09", "MN", "020045", "45.19649", "10.79381", "Europe/Rome"),("3167419", "Sant'Antimo", "", "IT", "380", "", "04", "NA", "063073", "40.94223", "14.23476", "Europe/Rome"),("3167439", "Sant'Angelo Lodigiano", "", "IT", "380", "", "09", "LO", "098050", "45.23526", "9.40651", "Europe/Rome"),("3167448", "Sant'Angelo di Piove di Sacco", "", "IT", "380", "", "20", "PD", "028082", "45.31735", "12.00941", "Europe/Rome"),("3167509", "Sant'Anastasia", "", "IT", "380", "", "04", "NA", "063072", "40.86842", "14.40196", "Europe/Rome"),("3167513", "Sant'Ambrogio di Valpollicella", "", "IT", "380", "IT", "20", "VR", "023077", "45.52089", "10.83618", "Europe/Rome"),("3167520", "Santa Marinella", "", "IT", "380", "", "07", "RM", "058097", "42.03425", "11.85416", "Europe/Rome"),("3167529", "Santa Maria Maddalena", "", "IT", "380", "", "20", "RO", "029033", "44.90231", "11.60663", "Europe/Rome"),("3167559", "Santa Maria degli Angeli", "", "IT", "380", "IT", "18", "PG", "054001", "43.05691", "12.57497", "Europe/Rome"),("3167561", "Santa Maria Capua Vetere", "Санта-Мария-Капуа-Ветере", "IT", "380", "", "04", "CE", "061083", "41.08156", "14.25342", "Europe/Rome"),("3167562", "Santa Maria A Vico", "", "IT", "380", "", "04", "CE", "061082", "41.02611", "14.46515", "Europe/Rome"),("3167567", "Santa Maria a Monte", "", "IT", "380", "", "16", "PI", "050035", "43.70793", "10.69196", "Europe/Rome"),("3167595", "Santa Margherita Ligure", "", "IT", "380", "", "08", "GE", "010054", "44.33456", "9.21204", "Europe/Rome"),("3167632", "Sant'Agnello", "", "IT", "380", "", "04", "NA", "063071", "40.62942", "14.39957", "Europe/Rome"),("3167647", "Sant'Agata de'Goti", "", "IT", "380", "IT", "04", "BN", "062070", "41.08932", "14.49743", "Europe/Rome"),("3167648", "Sant'Agata Bolognese", "", "IT", "380", "", "05", "BO", "037056", "44.66016", "11.13292", "Europe/Rome"),("3167658", "Santa Croce sull'Arno", "", "IT", "380", "", "16", "PI", "050033", "43.71709", "10.77242", "Europe/Rome"),("3167731", "San Severo", "", "IT", "380", "", "13", "FG", "071051", "41.68564", "15.38148", "Europe/Rome"),("3167732", "San Severino Marche", "", "IT", "380", "", "10", "MC", "043047", "43.23028", "13.1799", "Europe/Rome"),("3167736", "Sansepolcro", "", "IT", "380", "", "16", "AR", "051034", "43.57258", "12.13858", "Europe/Rome"),("3167742", "San Sebastiano al Vesuvio", "", "IT", "380", "", "04", "NA", "063070", "40.84344", "14.36428", "Europe/Rome"),("3167744", "San Sebastiano", "", "IT", "380", "", "09", "BS", "017096", "45.65192", "10.25681", "Europe/Rome"),("3167751", "San Salvo", "", "IT", "380", "", "01", "CH", "069083", "42.04413", "14.73335", "Europe/Rome"),("3167777", "San Remo", "Сан-Ремо", "IT", "380", "", "08", "IM", "008055", "43.81725", "7.7772", "Europe/Rome"),("3167793", "San Prisco", "", "IT", "380", "", "04", "CE", "061081", "41.08592", "14.27675", "Europe/Rome"),("3167811", "San Pietro Vernotico", "", "IT", "380", "", "13", "BR", "074016", "40.4889", "17.99752", "Europe/Rome"),("3167824", "San Pietro in Casale", "", "IT", "380", "", "05", "BO", "037055", "44.70079", "11.40492", "Europe/Rome"),("3167888", "San Paolo di Civitate", "", "IT", "380", "IT", "13", "FG", "071050", "41.73893", "15.2608", "Europe/Rome"),("3167903", "San Pancrazio Salentino", "", "IT", "380", "", "13", "BR", "074015", "40.418", "17.83419", "Europe/Rome"),("3167940", "Sannicandro Garganico", "", "IT", "380", "", "13", "FG", "071049", "41.83844", "15.56535", "Europe/Rome"),("3167941", "Sannicandro di Bari", "", "IT", "380", "", "13", "BA", "072040", "41.00047", "16.79714", "Europe/Rome"),("3167945", "Sannazzaro de' Burgondi", "", "IT", "380", "", "09", "PV", "018138", "45.10226", "8.90635", "Europe/Rome"),("3167953", "San Miniato", "", "IT", "380", "IT", "16", "PI", "050032", "43.67954", "10.84975", "Europe/Rome"),("3167954", "San Miniato Basso", "", "IT", "380", "", "16", "PI", "050032", "43.69332", "10.84119", "Europe/Rome"),("3167955", "San Michele Salentino", "", "IT", "380", "", "13", "BR", "074014", "40.63163", "17.63254", "Europe/Rome"),("3167969", "San Michele-San Giorgio", "", "IT", "380", "", "09", "CO", "013028", "45.69594", "9.05856", "Europe/Rome"),("3167978", "San Mauro Torinese", "", "IT", "380", "", "12", "TO", "001249", "45.10359", "7.76803", "Europe/Rome"),("3167979", "San Mauro Pascoli", "", "IT", "380", "", "05", "FC", "040041", "44.1089", "12.41953", "Europe/Rome"),("3167990", "San Maurizio", "", "IT", "380", "", "12", "TO", "001248", "45.21705", "7.63052", "Europe/Rome"),("3167996", "San Marzano sul Sarno", "", "IT", "380", "", "04", "SA", "065122", "40.77801", "14.58006", "Europe/Rome"),("3167997", "San Marzano di San Giuseppe", "", "IT", "380", "", "13", "TA", "073025", "40.45455", "17.50351", "Europe/Rome"),("3168007", "San Martino in Rio", "", "IT", "380", "", "05", "RE", "035037", "44.73368", "10.7849", "Europe/Rome"),("3168018", "San Martino di Lupari", "", "IT", "380", "", "20", "PD", "028077", "45.65128", "11.86004", "Europe/Rome"),("3168030", "San Martino Buon Albergo", "", "IT", "380", "", "20", "VR", "023073", "45.42083", "11.09562", "Europe/Rome"),("3168075", "San Marco in Lamis", "", "IT", "380", "", "13", "FG", "071047", "41.7121", "15.63825", "Europe/Rome"),("3168076", "San Marco Evangelista", "", "IT", "380", "", "04", "CE", "061104", "41.03702", "14.33979", "Europe/Rome"),("3168175", "San Lazzaro", "", "IT", "380", "", "05", "BO", "037054", "44.4705", "11.40851", "Europe/Rome"),("3168209", "San Giuseppe Vesuviano", "", "IT", "380", "", "04", "NA", "063068", "40.8356", "14.50487", "Europe/Rome"),("3168222", "San Giuliano Milanese", "", "IT", "380", "", "09", "MI", "015195", "45.39402", "9.29109", "Europe/Rome"),("3168231", "San Giovanni Valdarno", "", "IT", "380", "", "16", "AR", "051033", "43.56757", "11.52987", "Europe/Rome"),("3168234", "San Giovanni Rotondo", "", "IT", "380", "", "13", "FG", "071046", "41.70643", "15.7277", "Europe/Rome"),("3168236", "San Giovanni Lupatoto", "", "IT", "380", "", "20", "VR", "023071", "45.38193", "11.04474", "Europe/Rome"),("3168239", "San Giovanni in Persiceto", "", "IT", "380", "", "05", "BO", "037053", "44.63838", "11.18419", "Europe/Rome"),("3168240", "San Giovanni in Marignano", "", "IT", "380", "", "05", "RN", "099017", "43.93989", "12.71166", "Europe/Rome"),("3168295", "San Giorgio Ionico", "", "IT", "380", "", "13", "TA", "073024", "40.45796", "17.38034", "Europe/Rome"),("3168300", "San Giorgio di Piano", "", "IT", "380", "", "05", "BO", "037052", "44.64724", "11.37446", "Europe/Rome"),("3168302", "San Giorgio di Nogaro", "", "IT", "380", "", "06", "UD", "030100", "45.82745", "13.21088", "Europe/Rome"),("3168305", "San Giorgio del Sannio", "", "IT", "380", "", "04", "BN", "062058", "41.06844", "14.85322", "Europe/Rome"),("3168309", "San Giorgio a Cremano", "", "IT", "380", "", "04", "NA", "063067", "40.83261", "14.34162", "Europe/Rome"),("3168341", "San Gennaro Vesuviano", "", "IT", "380", "", "04", "NA", "063066", "40.86226", "14.52414", "Europe/Rome"),("3168388", "San Ferdinando di Puglia", "", "IT", "380", "", "13", "BT", "110007", "41.30263", "16.07046", "Europe/Rome"),("3168389", "San Felice sul Panaro", "", "IT", "380", "", "05", "MO", "036037", "44.83671", "11.13791", "Europe/Rome"),("3168393", "San Felice Circeo", "", "IT", "380", "", "07", "LT", "059025", "41.23716", "13.09416", "Europe/Rome"),("3168407", "Sandrigo", "", "IT", "380", "", "20", "VI", "024091", "45.66083", "11.58921", "Europe/Rome"),("3168414", "San Donato Milanese", "", "IT", "380", "", "09", "MI", "015192", "45.41047", "9.26838", "Europe/Rome"),("3168429", "San Donà di Piave", "", "IT", "380", "", "20", "VE", "027033", "45.63019", "12.5681", "Europe/Rome"),("3168430", "San Donaci", "", "IT", "380", "", "13", "BR", "074013", "40.44853", "17.92252", "Europe/Rome"),("3168438", "San Daniele del Friuli", "", "IT", "380", "", "06", "UD", "030099", "46.15714", "13.00726", "Europe/Rome"),("3168463", "San Colombano al Lambro", "", "IT", "380", "", "09", "MI", "015191", "45.18322", "9.49028", "Europe/Rome"),("3168484", "San Cesario di Lecce", "", "IT", "380", "", "13", "LE", "075068", "40.30221", "18.16098", "Europe/Rome"),("3168485", "San Cesareo", "", "IT", "380", "", "07", "RM", "058119", "41.82113", "12.80447", "Europe/Rome"),("3168498", "San Casciano in Val di Pesa", "", "IT", "380", "", "16", "FI", "048038", "43.65975", "11.18494", "Europe/Rome"),("3168514", "San Bonifacio", "", "IT", "380", "", "20", "VR", "023069", "45.39595", "11.27352", "Europe/Rome"),("3168544", "San Benigno Canavese", "", "IT", "380", "", "12", "TO", "001236", "45.22617", "7.78427", "Europe/Rome"),("3168546", "San Benedetto Po", "", "IT", "380", "", "09", "MN", "020055", "45.04612", "10.93367", "Europe/Rome"),("3168550", "San Benedetto del Tronto", "", "IT", "380", "", "10", "AP", "044066", "42.9568", "13.87676", "Europe/Rome"),("3168583", "Sammichele di Bari", "", "IT", "380", "", "13", "BA", "072039", "40.88711", "16.94919", "Europe/Rome"),("3168599", "Samarate", "", "IT", "380", "", "09", "VA", "012118", "45.6241", "8.78507", "Europe/Rome"),("3168601", "Salzano", "", "IT", "380", "", "20", "VE", "027032", "45.52221", "12.10151", "Europe/Rome"),("3168609", "Saluzzo", "", "IT", "380", "", "12", "CN", "004203", "44.64671", "7.49309", "Europe/Rome"),("3168627", "Salsomaggiore Terme", "", "IT", "380", "", "05", "PR", "034032", "44.81592", "9.98637", "Europe/Rome"),("3168633", "Salò", "", "IT", "380", "", "09", "BS", "017170", "45.60685", "10.5205", "Europe/Rome"),("3168658", "Salice Salentino", "", "IT", "380", "", "13", "LE", "075065", "40.38485", "17.96134", "Europe/Rome"),("3168660", "Salgareda", "", "IT", "380", "", "20", "TV", "026070", "45.705", "12.48833", "Europe/Rome"),("3168673", "Salerno", "Салерно", "IT", "380", "", "04", "SA", "065116", "40.67545", "14.79328", "Europe/Rome"),("3168699", "Sala Consilina", "", "IT", "380", "IT", "04", "SA", "065114", "40.40134", "15.5914", "Europe/Rome"),("3168730", "Sacile", "", "IT", "380", "", "06", "PN", "093037", "45.95412", "12.50274", "Europe/Rome"),("3168764", "Sabaudia", "", "IT", "380", "", "07", "LT", "059024", "41.30025", "13.02815", "Europe/Rome"),("3168770", "Ruvo di Puglia", "", "IT", "380", "", "13", "BA", "072038", "41.11758", "16.48421", "Europe/Rome"),("3168775", "Rutigliano", "", "IT", "380", "", "13", "BA", "072037", "41.00997", "17.00558", "Europe/Rome"),("3168784", "Russi", "", "IT", "380", "", "05", "RA", "039016", "44.37645", "12.03335", "Europe/Rome"),("3168816", "Rudiano", "", "IT", "380", "", "09", "BS", "017167", "45.48952", "9.88606", "Europe/Rome"),("3168820", "Rubiera", "", "IT", "380", "", "05", "RE", "035036", "44.65158", "10.7794", "Europe/Rome"),("3168837", "Rozzano", "", "IT", "380", "", "09", "MI", "015189", "45.38193", "9.1559", "Europe/Rome"),("3168843", "Rovigo", "Ровиго", "IT", "380", "", "20", "RO", "029041", "45.06982", "11.79022", "Europe/Rome"),("3168854", "Rovereto", "Роверето", "IT", "380", "", "17", "TN", "022161", "45.8904", "11.04053", "Europe/Rome"),("3168858", "Roveredo in Piano", "", "IT", "380", "", "06", "PN", "093036", "46.00847", "12.61938", "Europe/Rome"),("3168868", "Rovello Porro", "", "IT", "380", "", "09", "CO", "013202", "45.6521", "9.0394", "Europe/Rome"),("3168870", "Rovellasca", "", "IT", "380", "", "09", "CO", "013201", "45.66664", "9.04884", "Europe/Rome"),("3168874", "Rovato", "", "IT", "380", "", "09", "BS", "017166", "45.56342", "10.00213", "Europe/Rome"),("3168913", "Rossano Veneto", "", "IT", "380", "", "20", "VI", "024088", "45.70308", "11.80369", "Europe/Rome"),("3168927", "Rosolina", "", "IT", "380", "", "20", "RO", "029040", "45.07674", "12.22977", "Europe/Rome"),("3168930", "Rosignano Solvay-Castiglioncello", "", "IT", "380", "", "16", "LI", "049017", "43.38946", "10.43615", "Europe/Rome"),("3168936", "Roseto degli Abruzzi", "", "IT", "380", "", "01", "TE", "067037", "42.67164", "14.01481", "Europe/Rome"),("3168954", "Rosate", "", "IT", "380", "", "09", "MI", "015188", "45.34965", "9.01659", "Europe/Rome"),("3168969", "Rosa", "", "IT", "380", "", "06", "PN", "093041", "45.93056", "12.87083", "Europe/Rome"),("3168970", "Rosà", "", "IT", "380", "", "20", "VI", "024087", "45.70198", "11.76141", "Europe/Rome"),("3169012", "Ronciglione", "", "IT", "380", "", "07", "VT", "056045", "42.28899", "12.21479", "Europe/Rome"),("3169015", "Ronchi dei Legionari", "", "IT", "380", "", "06", "GO", "031016", "45.82735", "13.50417", "Europe/Rome"),("3169029", "Roncade", "", "IT", "380", "", "20", "TV", "026069", "45.62165", "12.37643", "Europe/Rome"),("3169035", "Romentino", "", "IT", "380", "", "12", "NO", "003131", "45.46296", "8.71811", "Europe/Rome"),("3169056", "Romano di Lombardia", "", "IT", "380", "", "09", "BG", "016183", "45.52081", "9.7544", "Europe/Rome"),("3169070", "Rome", "Рим", "IT", "380", "", "07", "RM", "058091", "41.89193", "12.51133", "Europe/Rome"),("3169147", "Roccarainola", "", "IT", "380", "", "04", "NA", "063065", "40.9725", "14.54283", "Europe/Rome"),("3169149", "Rocca Priora", "", "IT", "380", "", "07", "RM", "058088", "41.76585", "12.76577", "Europe/Rome"),("3169156", "Roccapiemonte", "", "IT", "380", "", "04", "SA", "065108", "40.76009", "14.69089", "Europe/Rome"),("3169181", "Rocca di Papa", "", "IT", "380", "", "07", "RM", "058086", "41.7658", "12.70188", "Europe/Rome"),("3169212", "Robbio", "", "IT", "380", "", "09", "PV", "018123", "45.28901", "8.59289", "Europe/Rome"),("3169213", "Robbiate", "", "IT", "380", "", "09", "LC", "097071", "45.68829", "9.43712", "Europe/Rome"),("3169228", "Rivolta d'Adda", "", "IT", "380", "IT", "09", "CR", "019084", "45.46962", "9.51251", "Europe/Rome"),("3169231", "Rivoli", "Риволи", "IT", "380", "", "12", "TO", "001219", "45.07073", "7.51465", "Europe/Rome"),("3169253", "Rivarolo Canavese", "", "IT", "380", "", "12", "TO", "001217", "45.32829", "7.7211", "Europe/Rome"),("3169262", "Rivalta di Torino", "", "IT", "380", "", "12", "TO", "001214", "45.03268", "7.52042", "Europe/Rome"),("3169272", "Riva del Garda", "", "IT", "380", "IT", "17", "TN", "022153", "45.88577", "10.84117", "Europe/Rome"),("3169324", "Rio Saliceto", "", "IT", "380", "", "05", "RE", "035034", "44.81147", "10.80414", "Europe/Rome"),("3169326", "Rionero in Vulture", "", "IT", "380", "", "02", "PZ", "076066", "40.92328", "15.6711", "Europe/Rome"),("3169361", "Rimini", "Римини", "IT", "380", "", "05", "RN", "099014", "44.05755", "12.56528", "Europe/Rome"),("3169395", "Rignano Flaminio", "", "IT", "380", "", "07", "RM", "058082", "42.2055", "12.48068", "Europe/Rome"),("3169412", "Rieti", "Риети", "IT", "380", "", "07", "RI", "057059", "42.40476", "12.85735", "Europe/Rome"),("3169424", "Riccione", "", "IT", "380", "", "05", "RN", "099013", "43.99942", "12.65689", "Europe/Rome"),("3169443", "Riano", "", "IT", "380", "", "07", "RM", "058081", "42.09347", "12.51462", "Europe/Rome"),("3169447", "Rho", "Ро", "IT", "380", "", "09", "MI", "015182", "45.53245", "9.0402", "Europe/Rome"),("3169452", "Rezzato", "", "IT", "380", "", "09", "BS", "017161", "45.51182", "10.31731", "Europe/Rome"),("3169481", "Rescaldina", "", "IT", "380", "", "09", "MI", "015181", "45.62002", "8.94878", "Europe/Rome"),("3169522", "Reggio nell'Emilia", "Реджо-Эмилия", "IT", "380", "", "05", "RE", "035033", "44.69825", "10.63125", "Europe/Rome"),("3169523", "Reggiolo", "", "IT", "380", "", "05", "RE", "035032", "44.91824", "10.81016", "Europe/Rome"),("3169539", "Recco", "", "IT", "380", "", "08", "GE", "010047", "44.36227", "9.14354", "Europe/Rome"),("3169540", "Recanati", "", "IT", "380", "", "10", "MC", "043044", "43.40381", "13.55379", "Europe/Rome"),("3169541", "Recale", "", "IT", "380", "", "04", "CE", "061067", "41.05702", "14.3027", "Europe/Rome"),("3169561", "Ravenna", "Равенна", "IT", "380", "", "05", "RA", "039014", "44.41344", "12.20121", "Europe/Rome"),("3169602", "Rapallo", "Рапалло", "IT", "380", "", "08", "GE", "010046", "44.3496", "9.22796", "Europe/Rome"),("3169647", "Racconigi", "", "IT", "380", "", "12", "CN", "004179", "44.76598", "7.67893", "Europe/Rome"),("3169660", "Quinzano d'Oglio", "", "IT", "380", "IT", "09", "BS", "017159", "45.3143", "10.00785", "Europe/Rome"),("3169663", "Quinto di Treviso", "", "IT", "380", "", "20", "TV", "026064", "45.64351", "12.16509", "Europe/Rome"),("3169682", "Ripa-Pozzi-Querceta-Ponterosso", "", "IT", "380", "", "16", "LU", "046028", "43.97806", "10.20372", "Europe/Rome"),("3169700", "Quarto d'Altino", "", "IT", "380", "", "20", "VE", "027031", "45.57944", "12.37333", "Europe/Rome"),("3169713", "Quarrata", "", "IT", "380", "", "16", "PT", "047017", "43.84837", "10.97888", "Europe/Rome"),("3169724", "Qualiano", "", "IT", "380", "", "04", "NA", "063062", "40.91899", "14.15352", "Europe/Rome"),("3169742", "Putignano", "Путиньяно", "IT", "380", "", "13", "BA", "072036", "40.85106", "17.1219", "Europe/Rome"),("3169760", "Pulsano", "", "IT", "380", "", "13", "TA", "073022", "40.38109", "17.35612", "Europe/Rome"),("3169807", "Procida", "", "IT", "380", "", "04", "NA", "063061", "40.75636", "14.01457", "Europe/Rome"),("3169811", "Priverno", "", "IT", "380", "", "07", "LT", "059019", "41.47047", "13.17867", "Europe/Rome"),("3169869", "Preganziol", "", "IT", "380", "", "20", "TV", "026063", "45.60139", "12.23722", "Europe/Rome"),("3169908", "Pratola Peligna", "", "IT", "380", "", "01", "AQ", "066075", "42.09701", "13.87467", "Europe/Rome"),("3169921", "Prato", "Прато", "IT", "380", "", "16", "PO", "100005", "43.8805", "11.09699", "Europe/Rome"),("3169984", "Pozzuoli", "", "IT", "380", "", "04", "NA", "063060", "40.84394", "14.0952", "Europe/Rome"),("3170019", "Povegliano Veronese", "", "IT", "380", "", "20", "VR", "023060", "45.3473", "10.88056", "Europe/Rome"),("3170027", "Potenza", "", "IT", "380", "", "02", "PZ", "076063", "40.64175", "15.80794", "Europe/Rome"),("3170069", "Porto Torres", "Порто-Торрес", "IT", "380", "", "14", "SS", "090058", "40.83375", "8.40531", "Europe/Rome"),("3170070", "Porto Tolle", "", "IT", "380", "", "20", "RO", "029039", "44.94969", "12.32453", "Europe/Rome"),("3170071", "Porto Santo Stefano", "", "IT", "380", "", "16", "GR", "053016", "42.43825", "11.11542", "Europe/Rome"),("3170072", "Porto Sant'Elpidio", "", "IT", "380", "IT", "10", "FM", "109034", "43.25297", "13.7597", "Europe/Rome"),("3170073", "Porto San Giorgio", "", "IT", "380", "", "10", "FM", "109033", "43.17784", "13.79411", "Europe/Rome"),("3170075", "Porto Recanati", "", "IT", "380", "", "10", "MC", "043042", "43.43296", "13.66165", "Europe/Rome"),("3170076", "Porto Potenza Picena", "", "IT", "380", "IT", "10", "MC", "043043", "43.35751", "13.69746", "Europe/Rome"),("3170082", "Portomaggiore", "", "IT", "380", "", "05", "FE", "038019", "44.69763", "11.8076", "Europe/Rome"),("3170086", "Portogruaro", "", "IT", "380", "", "20", "VE", "027029", "45.78071", "12.84052", "Europe/Rome"),("3170094", "Portoferraio", "", "IT", "380", "", "16", "LI", "049014", "42.81233", "10.31297", "Europe/Rome"),("3170102", "Civitanova Marche", "", "IT", "380", "", "10", "MC", "043013", "43.30491", "13.72068", "Europe/Rome"),("3170115", "Portico di Caserta", "", "IT", "380", "", "04", "CE", "061062", "41.05562", "14.28022", "Europe/Rome"),("3170116", "Portici", "Портичи", "IT", "380", "", "04", "NA", "063059", "40.81563", "14.33716", "Europe/Rome"),("3170147", "Pordenone", "Порденоне", "IT", "380", "", "06", "PN", "093033", "45.95689", "12.66051", "Europe/Rome"),("3170154", "Porcia", "", "IT", "380", "", "06", "PN", "093032", "45.96301", "12.61642", "Europe/Rome"),("3170163", "Porcari", "", "IT", "380", "", "16", "LU", "046026", "43.84152", "10.61632", "Europe/Rome"),("3170175", "Popoli", "", "IT", "380", "", "01", "PE", "068033", "42.16866", "13.82997", "Europe/Rome"),("3170191", "Pontremoli", "", "IT", "380", "", "16", "MS", "045014", "44.37515", "9.87888", "Europe/Rome"),("3170196", "Pontinia", "", "IT", "380", "", "07", "LT", "059017", "41.41097", "13.04259", "Europe/Rome"),("3170208", "Pontevico", "", "IT", "380", "", "09", "BS", "017149", "45.27315", "10.09248", "Europe/Rome"),("3170213", "Lavena Ponte Tresa", "", "IT", "380", "", "09", "VA", "012086", "45.9671", "8.85725", "Europe/Rome"),("3170218", "Ponte San Pietro", "", "IT", "380", "", "09", "BG", "016170", "45.70596", "9.5905", "Europe/Rome"),("3170220", "Ponte San Nicolò", "", "IT", "380", "IT", "20", "PD", "028069", "45.36718", "11.92341", "Europe/Rome"),("3170232", "Pontenure", "", "IT", "380", "", "05", "PC", "033037", "44.99821", "9.79139", "Europe/Rome"),("3170239", "Ponte nelle Alpi", "", "IT", "380", "", "20", "BL", "025040", "46.18083", "12.28333", "Europe/Rome"),("3170272", "Pontedera", "", "IT", "380", "", "16", "PI", "050029", "43.66141", "10.63067", "Europe/Rome"),("3170286", "Pontecorvo", "", "IT", "380", "", "07", "FR", "060056", "41.45861", "13.66618", "Europe/Rome"),("3170293", "Pontecagnano", "", "IT", "380", "", "04", "SA", "065099", "40.64448", "14.87628", "Europe/Rome"),("3170305", "Grassina Ponte a Ema", "", "IT", "380", "", "16", "FI", "048001", "43.73333", "11.3", "Europe/Rome"),("3170317", "Pontassieve", "", "IT", "380", "", "16", "FI", "048033", "43.77477", "11.43109", "Europe/Rome"),("3170321", "Ponsacco", "", "IT", "380", "", "16", "PI", "050028", "43.62307", "10.62661", "Europe/Rome"),("3170335", "Pompei", "Помпеи", "IT", "380", "", "04", "NA", "063058", "40.74574", "14.49698", "Europe/Rome"),("3170341", "Pomigliano d'Arco", "", "IT", "380", "", "04", "NA", "063057", "40.90975", "14.38316", "Europe/Rome"),("3170342", "Pomezia", "", "IT", "380", "", "07", "RM", "058079", "41.66931", "12.50124", "Europe/Rome"),("3170367", "Ponte nelle Alpi-Polpet", "", "IT", "380", "", "20", "BL", "025040", "46.18833", "12.27833", "Europe/Rome"),("3170376", "Polla", "", "IT", "380", "", "04", "SA", "065097", "40.51433", "15.49715", "Europe/Rome"),("3170382", "Polignano a Mare", "", "IT", "380", "", "13", "BA", "072035", "40.99221", "17.22149", "Europe/Rome"),("3170384", "Policoro", "", "IT", "380", "", "02", "MT", "077021", "40.2128", "16.67795", "Europe/Rome"),("3170408", "Poirino", "", "IT", "380", "", "12", "TO", "001197", "44.92047", "7.84465", "Europe/Rome"),("3170422", "Pogliano Milanese", "", "IT", "380", "", "09", "MI", "015176", "45.53786", "8.99403", "Europe/Rome"),("3170441", "Poggio Rusco", "", "IT", "380", "", "09", "MN", "020042", "44.96693", "11.10419", "Europe/Rome"),("3170442", "Poggio Renatico", "", "IT", "380", "", "05", "FE", "038018", "44.76581", "11.48695", "Europe/Rome"),("3170443", "Villa Opicina", "", "IT", "380", "IT", "06", "TS", "032006", "45.6878", "13.78861", "Europe/Rome"),("3170457", "Poggiomarino", "", "IT", "380", "", "04", "NA", "063055", "40.80114", "14.54066", "Europe/Rome"),("3170487", "Poggio A Caiano", "", "IT", "380", "", "16", "PO", "100004", "43.81378", "11.05186", "Europe/Rome"),("3170504", "Poggibonsi", "Поджибонси", "IT", "380", "", "16", "SI", "052022", "43.47064", "11.14804", "Europe/Rome"),("3170505", "Poggiardo", "", "IT", "380", "", "13", "LE", "075061", "40.05315", "18.37819", "Europe/Rome"),("3170537", "Podenzano", "", "IT", "380", "", "05", "PC", "033035", "44.95484", "9.68315", "Europe/Rome"),("3170621", "Pistoia", "Пистойя", "IT", "380", "", "16", "PT", "047014", "43.93064", "10.92365", "Europe/Rome"),("3170622", "Pisticci", "", "IT", "380", "", "02", "MT", "077020", "40.39017", "16.55919", "Europe/Rome"),("3170627", "Pisogne", "", "IT", "380", "", "09", "BS", "017143", "45.80777", "10.11023", "Europe/Rome"),("3170647", "Pisa", "Пиза", "IT", "380", "", "16", "PI", "050026", "43.70853", "10.4036", "Europe/Rome"),("3170655", "Piovene Rocchette", "", "IT", "380", "", "20", "VI", "024078", "45.75601", "11.43273", "Europe/Rome"),("3170657", "Piove di Sacco-Piovega", "", "IT", "380", "", "20", "PD", "028065", "45.29665", "12.03683", "Europe/Rome"),("3170659", "Piossasco", "", "IT", "380", "", "12", "TO", "001194", "44.98802", "7.4601", "Europe/Rome"),("3170674", "Piombino", "Пьомбино", "IT", "380", "", "16", "LI", "049012", "42.92554", "10.52585", "Europe/Rome"),("3170676", "Pioltello", "", "IT", "380", "", "09", "MI", "015175", "45.50147", "9.33053", "Europe/Rome"),("3170692", "Pineto", "", "IT", "380", "", "01", "TE", "067035", "42.60879", "14.06639", "Europe/Rome"),("3170694", "Pinerolo", "Пинероло", "IT", "380", "", "12", "TO", "001191", "44.88534", "7.33135", "Europe/Rome"),("3170699", "Pimonte", "", "IT", "380", "", "04", "NA", "063054", "40.67361", "14.50984", "Europe/Rome"),("3170718", "Pignataro Maggiore", "", "IT", "380", "", "04", "CE", "061060", "41.19006", "14.16978", "Europe/Rome"),("3170744", "Pieve di Soligo", "", "IT", "380", "", "20", "TV", "026057", "45.89836", "12.17128", "Europe/Rome"),("3170752", "Pieve di Cento", "", "IT", "380", "", "05", "BO", "037048", "44.71293", "11.30922", "Europe/Rome"),("3170778", "Pietrasanta", "Пиетрасанта", "IT", "380", "", "16", "LU", "046024", "43.95952", "10.22784", "Europe/Rome"),("3170797", "Pietra Ligure", "", "IT", "380", "", "08", "SV", "009049", "44.1492", "8.28206", "Europe/Rome"),("3170899", "Piazza", "", "IT", "380", "", "09", "BS", "017081", "45.58725", "10.15526", "Europe/Rome"),("3170937", "Pianoro", "", "IT", "380", "", "05", "BO", "037047", "44.38893", "11.34262", "Europe/Rome"),("3170943", "Piano di Sorrento", "", "IT", "380", "", "04", "NA", "063053", "40.62806", "14.41729", "Europe/Rome"),("3170962", "Pianillo", "", "IT", "380", "", "04", "NA", "063003", "40.63416", "14.54922", "Europe/Rome"),("3170963", "Pianiga", "", "IT", "380", "", "20", "VE", "027028", "45.45708", "12.00762", "Europe/Rome"),("3170978", "Pianezza", "", "IT", "380", "", "12", "TO", "001189", "45.1042", "7.55003", "Europe/Rome"),("3171058", "Piacenza", "Пьяченца", "IT", "380", "", "05", "PC", "033032", "45.05242", "9.69342", "Europe/Rome"),("3171148", "Pescia", "", "IT", "380", "", "16", "PT", "047012", "43.8871", "10.68849", "Europe/Rome"),("3171152", "Peschiera del Garda", "", "IT", "380", "", "20", "VR", "023059", "45.43912", "10.68614", "Europe/Rome"),("3171155", "Bettola-Zeloforomagno", "", "IT", "380", "", "09", "MI", "015171", "45.4308", "9.3087", "Europe/Rome"),("3171168", "Pescara", "Пескара", "IT", "380", "", "01", "PE", "068028", "42.4584", "14.20283", "Europe/Rome"),("3171169", "Pescantina", "", "IT", "380", "", "20", "VR", "023058", "45.48548", "10.86796", "Europe/Rome"),("3171173", "Pesaro", "Пезаро", "IT", "380", "", "10", "PU", "041044", "43.90921", "12.9164", "Europe/Rome"),("3171180", "Perugia", "Перуджа", "IT", "380", "", "18", "PG", "054039", "43.1122", "12.38878", "Europe/Rome"),("3171214", "Pergine Valsugana", "", "IT", "380", "", "17", "TN", "022139", "46.06434", "11.23758", "Europe/Rome"),("3171247", "Penne", "", "IT", "380", "", "01", "PE", "068027", "42.45474", "13.92754", "Europe/Rome"),("3171355", "Pavullo nel Frignano", "", "IT", "380", "", "05", "MO", "036030", "44.33352", "10.83544", "Europe/Rome"),("3171366", "Pavia", "Павия", "IT", "380", "", "09", "PV", "018110", "45.19205", "9.15917", "Europe/Rome"),("3171370", "Paullo", "", "IT", "380", "", "09", "MI", "015169", "45.41834", "9.40042", "Europe/Rome"),("3171416", "Passirano", "", "IT", "380", "", "09", "BS", "017136", "45.59673", "10.06986", "Europe/Rome"),("3171432", "Pasian di Prato", "", "IT", "380", "", "06", "UD", "030072", "46.04667", "13.1878", "Europe/Rome"),("3171457", "Parma", "Парма", "IT", "380", "", "05", "PR", "034027", "44.79935", "10.32618", "Europe/Rome"),("3171483", "Parabita", "", "IT", "380", "", "13", "LE", "075059", "40.05139", "18.12651", "Europe/Rome"),("3171484", "Parabiago", "", "IT", "380", "", "09", "MI", "015168", "45.56034", "8.94545", "Europe/Rome"),("3171502", "Pantigliate", "", "IT", "380", "", "09", "MI", "015167", "45.43526", "9.3522", "Europe/Rome"),("3171529", "Pandino", "", "IT", "380", "", "09", "CR", "019067", "45.40559", "9.55218", "Europe/Rome"),("3171550", "Palosco", "", "IT", "380", "", "09", "BG", "016157", "45.58928", "9.83646", "Europe/Rome"),("3171558", "Palombara Sabina", "", "IT", "380", "", "07", "RM", "058075", "42.06909", "12.76684", "Europe/Rome"),("3171562", "Palo del Colle", "Пало-дель-Колле", "IT", "380", "", "13", "BA", "072033", "41.05562", "16.70321", "Europe/Rome"),("3171576", "Palma Campania", "", "IT", "380", "", "04", "NA", "063052", "40.86608", "14.5517", "Europe/Rome"),("3171586", "Palazzolo sull'Oglio", "", "IT", "380", "IT", "09", "BS", "017133", "45.59665", "9.88688", "Europe/Rome"),("3171603", "Paliano", "", "IT", "380", "", "07", "FR", "060046", "41.77975", "13.07661", "Europe/Rome"),("3171606", "Palestrina", "", "IT", "380", "IT", "07", "RM", "058074", "41.83274", "12.88178", "Europe/Rome"),("3171664", "Palagiano", "", "IT", "380", "", "13", "TA", "073021", "40.57762", "17.03812", "Europe/Rome"),("3171665", "Palagianello", "", "IT", "380", "", "13", "TA", "073020", "40.60851", "16.97802", "Europe/Rome"),("3171703", "Pagani", "", "IT", "380", "", "04", "SA", "065088", "40.74199", "14.61448", "Europe/Rome"),("3171710", "Paese", "", "IT", "380", "", "20", "TV", "026055", "45.67417", "12.16389", "Europe/Rome"),("3171728", "Padova", "Падуя", "IT", "380", "", "20", "PD", "028060", "45.40797", "11.88586", "Europe/Rome"),("3171737", "Paderno Dugnano", "", "IT", "380", "", "09", "MI", "015166", "45.56899", "9.16483", "Europe/Rome"),("3171760", "Ozieri", "", "IT", "380", "", "14", "SS", "090052", "40.5863", "9.0034", "Europe/Rome"),("3171771", "Ovada", "", "IT", "380", "", "12", "AL", "006121", "44.63727", "8.64196", "Europe/Rome"),("3171778", "Ottaviano", "", "IT", "380", "", "04", "NA", "063051", "40.85193", "14.47826", "Europe/Rome"),("3171786", "Ostuni", "Остуни", "IT", "380", "", "13", "BR", "074012", "40.72913", "17.57675", "Europe/Rome"),("3171792", "Ostiglia", "", "IT", "380", "", "09", "MN", "020038", "45.06978", "11.13499", "Europe/Rome"),("3171814", "Ossi", "", "IT", "380", "", "14", "SS", "090051", "40.67483", "8.59254", "Europe/Rome"),("3171819", "Ospitaletto", "", "IT", "380", "", "09", "BS", "017127", "45.55221", "10.07562", "Europe/Rome"),("3171829", "Ospedaletto Euganeo", "", "IT", "380", "", "20", "PD", "028059", "45.21842", "11.60345", "Europe/Rome"),("3171848", "Osimo", "Осимо", "IT", "380", "", "10", "AN", "042034", "43.48539", "13.48222", "Europe/Rome"),("3171869", "Orzinuovi", "", "IT", "380", "", "09", "BS", "017125", "45.40191", "9.92319", "Europe/Rome"),("3171874", "Orvieto", "", "IT", "380", "", "18", "TR", "055023", "42.71924", "12.11249", "Europe/Rome"),("3171886", "Ortona", "", "IT", "380", "", "01", "CH", "069058", "42.35087", "14.40342", "Europe/Rome"),("3171900", "Orta Nova", "", "IT", "380", "", "13", "FG", "071036", "41.32879", "15.70994", "Europe/Rome"),("3171921", "Orosei", "", "IT", "380", "", "14", "NU", "091063", "40.37826", "9.69248", "Europe/Rome"),("3171955", "Origgio", "", "IT", "380", "", "09", "VA", "012109", "45.59676", "9.01645", "Europe/Rome"),("3171961", "Oria", "", "IT", "380", "", "13", "BR", "074011", "40.49999", "17.6428", "Europe/Rome"),("3171985", "Orbetello", "", "IT", "380", "", "16", "GR", "053018", "42.44158", "11.2214", "Europe/Rome"),("3171986", "Orbassano", "Орбассано", "IT", "380", "", "12", "TO", "001171", "45.00547", "7.53813", "Europe/Rome"),("3172000", "Opera", "", "IT", "380", "", "09", "MI", "015159", "45.37355", "9.21084", "Europe/Rome"),("3172023", "Omegna", "", "IT", "380", "", "12", "VB", "103050", "45.88002", "8.40665", "Europe/Rome"),("3172059", "Oliena", "", "IT", "380", "", "14", "NU", "091055", "40.27617", "9.40193", "Europe/Rome"),("3172064", "Olginate", "", "IT", "380", "", "09", "LC", "097059", "45.79126", "9.41869", "Europe/Rome"),("3172065", "Olgiate Olona", "", "IT", "380", "", "09", "VA", "012108", "45.63706", "8.88147", "Europe/Rome"),("3172067", "Olgiate Comasco", "", "IT", "380", "", "09", "CO", "013165", "45.78436", "8.96816", "Europe/Rome"),("3172073", "Olevano sul Tusciano", "", "IT", "380", "", "04", "SA", "065082", "40.65721", "15.02305", "Europe/Rome"),("3172074", "Olevano Romano", "", "IT", "380", "", "07", "RM", "058073", "41.85869", "13.03601", "Europe/Rome"),("3172079", "Oleggio", "", "IT", "380", "", "12", "NO", "003108", "45.59674", "8.64213", "Europe/Rome"),("3172087", "Olbia", "Ольбия", "IT", "380", "IT", "14", "OT", "104017", "40.92337", "9.49802", "Europe/Rome"),("3172101", "Oggiono", "", "IT", "380", "", "09", "LC", "097057", "45.79133", "9.34815", "Europe/Rome"),("3172107", "Offanengo", "", "IT", "380", "", "09", "CR", "019062", "45.37887", "9.74236", "Europe/Rome"),("3172116", "Oderzo", "", "IT", "380", "", "20", "TV", "026051", "45.78114", "12.49442", "Europe/Rome"),("3172154", "Nuoro", "Нуоро", "IT", "380", "", "14", "NU", "091051", "40.31991", "9.32568", "Europe/Rome"),("3172168", "Novoli", "", "IT", "380", "", "13", "LE", "075055", "40.37673", "18.04757", "Europe/Rome"),("3172170", "Novi Ligure", "Нови-Лигуре", "IT", "380", "", "12", "AL", "006114", "44.76246", "8.787", "Europe/Rome"),("3172172", "Novi di Modena", "", "IT", "380", "", "05", "MO", "036028", "44.88974", "10.90027", "Europe/Rome"),("3172173", "Noventa Vicentina", "", "IT", "380", "", "20", "VI", "024074", "45.29438", "11.54843", "Europe/Rome"),("3172175", "Noventa di Piave", "", "IT", "380", "", "20", "VE", "027027", "45.65981", "12.53322", "Europe/Rome"),("3172177", "Novellara", "", "IT", "380", "", "05", "RE", "035028", "44.84488", "10.72745", "Europe/Rome"),("3172184", "Novate Milanese", "", "IT", "380", "", "09", "MI", "015157", "45.5305", "9.13954", "Europe/Rome"),("3172189", "Novara", "Новара", "IT", "380", "", "12", "NO", "003106", "45.44694", "8.62118", "Europe/Rome"),("3172191", "Nova Milanese", "", "IT", "380", "", "09", "MB", "108035", "45.58882", "9.19792", "Europe/Rome"),("3172215", "None", "", "IT", "380", "", "12", "TO", "001168", "44.93645", "7.54015", "Europe/Rome"),("3172217", "Nonantola", "", "IT", "380", "", "05", "MO", "036027", "44.67785", "11.03785", "Europe/Rome"),("3172226", "Nole", "", "IT", "380", "", "12", "TO", "001166", "45.24159", "7.56983", "Europe/Rome"),("3172227", "Nola", "", "IT", "380", "", "04", "NA", "063050", "40.92606", "14.52816", "Europe/Rome"),("3172228", "Noicattaro", "", "IT", "380", "", "13", "BA", "072032", "41.03449", "16.98963", "Europe/Rome"),("3172235", "Nogara", "", "IT", "380", "", "20", "VR", "023053", "45.18109", "11.06008", "Europe/Rome"),("3172240", "Noci", "", "IT", "380", "", "13", "BA", "072031", "40.79356", "17.12681", "Europe/Rome"),("3172241", "Noceto", "", "IT", "380", "", "05", "PR", "034025", "44.80953", "10.1773", "Europe/Rome"),("3172243", "Nocera Superiore", "", "IT", "380", "", "04", "SA", "065079", "40.74248", "14.67447", "Europe/Rome"),("3172244", "Nocera Inferiore", "", "IT", "380", "", "04", "SA", "065078", "40.7454", "14.64542", "Europe/Rome"),("3172252", "Noale", "", "IT", "380", "", "20", "VE", "027026", "45.54596", "12.06445", "Europe/Rome"),("3172253", "Nizza Monferrato", "", "IT", "380", "", "12", "AT", "005080", "44.77416", "8.35784", "Europe/Rome"),("3172269", "Nichelino", "Никелино", "IT", "380", "", "12", "TO", "001164", "45.00031", "7.65305", "Europe/Rome"),("3172283", "Neviano", "", "IT", "380", "", "13", "LE", "075053", "40.1065", "18.11517", "Europe/Rome"),("3172287", "Nettuno", "Неттуно", "IT", "380", "", "07", "RM", "058072", "41.45794", "12.66393", "Europe/Rome"),("3172297", "Nerviano", "", "IT", "380", "", "09", "MI", "015154", "45.55343", "8.9792", "Europe/Rome"),("3172322", "Nepi", "", "IT", "380", "", "07", "VT", "056039", "42.24221", "12.34355", "Europe/Rome"),("3172330", "Nembro", "", "IT", "380", "", "09", "BG", "016144", "45.74411", "9.76127", "Europe/Rome"),("3172338", "Negrar", "", "IT", "380", "", "20", "VR", "023052", "45.52918", "10.93899", "Europe/Rome"),("3172363", "Nave", "", "IT", "380", "", "09", "BS", "017117", "45.5848", "10.27947", "Europe/Rome"),("3172376", "Narni Scalo", "", "IT", "380", "", "18", "TR", "055022", "42.5362", "12.5168", "Europe/Rome"),("3172377", "Narni", "", "IT", "380", "", "18", "TR", "055022", "42.51956", "12.52758", "Europe/Rome"),("3172379", "Nardò", "", "IT", "380", "", "13", "LE", "075052", "40.17953", "18.03174", "Europe/Rome"),("3172394", "Naples", "Неаполь", "IT", "380", "", "04", "NA", "063049", "40.85631", "14.24641", "Europe/Rome"),("3172422", "Musile di Piave", "", "IT", "380", "", "20", "VE", "027025", "45.62057", "12.54177", "Europe/Rome"),("3172472", "Mugnano di Napoli", "", "IT", "380", "", "04", "NA", "063048", "40.90936", "14.20984", "Europe/Rome"),("3172473", "Mugnano del Cardinale", "", "IT", "380", "", "04", "AV", "064065", "40.94248", "14.6361", "Europe/Rome"),("3172479", "Muggiò", "", "IT", "380", "", "09", "MB", "108034", "45.58878", "9.22784", "Europe/Rome"),("3172483", "Muggia", "", "IT", "380", "", "06", "TS", "032003", "45.60419", "13.76754", "Europe/Rome"),("3172495", "Mozzate", "", "IT", "380", "", "09", "CO", "013159", "45.67473", "8.95644", "Europe/Rome"),("3172499", "Mottola", "", "IT", "380", "", "13", "TA", "073019", "40.6389", "17.03432", "Europe/Rome"),("3172502", "Motta Visconti", "", "IT", "380", "", "09", "MI", "015151", "45.28774", "8.99254", "Europe/Rome"),("3172508", "Motta di Livenza", "", "IT", "380", "", "20", "TV", "026049", "45.77552", "12.60411", "Europe/Rome"),("3172557", "Mortara", "", "IT", "380", "", "09", "PV", "018102", "45.2494", "8.73302", "Europe/Rome"),("3172586", "Morlupo", "", "IT", "380", "", "07", "RM", "058068", "42.15002", "12.50306", "Europe/Rome"),("3172598", "Mori", "", "IT", "380", "", "17", "TN", "022123", "45.85187", "10.98052", "Europe/Rome"),("3172614", "Morciano di Romagna", "", "IT", "380", "", "05", "RN", "099011", "43.9144", "12.65104", "Europe/Rome"),("3172617", "Morbegno", "", "IT", "380", "", "09", "SO", "014045", "46.1372", "9.57415", "Europe/Rome"),("3172629", "Monza", "Монца", "IT", "380", "", "09", "MB", "108033", "45.58005", "9.27246", "Europe/Rome"),("3172642", "Montorio", "", "IT", "380", "IT", "20", "VR", "023091", "45.45826", "11.06589", "Europe/Rome"),("3172646", "Montorio al Vomano", "", "IT", "380", "", "01", "TE", "067028", "42.58123", "13.63715", "Europe/Rome"),("3172669", "Montignoso", "", "IT", "380", "", "16", "MS", "045011", "44.02405", "10.17259", "Europe/Rome"),("3172681", "Montichiari", "", "IT", "380", "", "09", "BS", "017113", "45.41317", "10.39799", "Europe/Rome"),("3172682", "Monticello Conte Otto", "", "IT", "380", "", "20", "VI", "024067", "45.59784", "11.57234", "Europe/Rome"),("3172718", "Montevarchi", "Монтеварки", "IT", "380", "", "16", "AR", "051026", "43.5252", "11.57238", "Europe/Rome"),("3172720", "Monte Urano", "", "IT", "380", "", "10", "FM", "109024", "43.19039", "13.6618", "Europe/Rome"),("3172729", "Montesilvano Marina", "", "IT", "380", "", "01", "PE", "068024", "42.5114", "14.14507", "Europe/Rome"),("3172739", "Montescaglioso", "", "IT", "380", "", "02", "MT", "077017", "40.55024", "16.66541", "Europe/Rome"),("3172740", "Montesarchio", "", "IT", "380", "", "04", "BN", "062043", "41.06227", "14.64096", "Europe/Rome"),("3172747", "Monte Sant'Angelo", "", "IT", "380", "", "13", "FG", "071033", "41.7053", "15.96068", "Europe/Rome"),("3172756", "Monte San Giusto", "", "IT", "380", "", "10", "MC", "043031", "43.23565", "13.59316", "Europe/Rome"),("3172768", "Monterotondo", "Монтеротондо", "IT", "380", "", "07", "RM", "058065", "42.05159", "12.61969", "Europe/Rome"),("3172774", "Monteroni di Lecce", "", "IT", "380", "", "13", "LE", "075048", "40.31929", "18.09163", "Europe/Rome"),("3172797", "Monte Porzio Catone", "", "IT", "380", "", "07", "RM", "058064", "41.81585", "12.71432", "Europe/Rome"),("3172821", "Montenero di Bisaccia", "", "IT", "380", "", "11", "CB", "070046", "41.96437", "14.78103", "Europe/Rome"),("3172828", "Montemurlo", "", "IT", "380", "", "16", "PO", "100003", "43.92686", "11.03718", "Europe/Rome"),("3172861", "Montelupo Fiorentino", "", "IT", "380", "", "16", "FI", "048028", "43.72958", "11.00997", "Europe/Rome"),("3172886", "Monteiasi", "", "IT", "380", "", "13", "TA", "073016", "40.49992", "17.3826", "Europe/Rome"),("3172890", "Montegrotto Terme", "", "IT", "380", "", "20", "PD", "028057", "45.33119", "11.78634", "Europe/Rome"),("3172896", "Montegranaro", "", "IT", "380", "", "10", "FM", "109018", "43.23099", "13.63047", "Europe/Rome"),("3172921", "Monteforte Irpino", "", "IT", "380", "", "04", "AV", "064054", "40.90246", "14.744", "Europe/Rome"),("3172922", "Monteforte d'Alpone", "", "IT", "380", "IT", "20", "VR", "023050", "45.42013", "11.28446", "Europe/Rome"),("3172931", "Montefiascone", "", "IT", "380", "", "07", "VT", "056036", "42.54255", "12.03192", "Europe/Rome"),("3172946", "Monte di Procida", "", "IT", "380", "", "04", "NA", "063047", "40.79809", "14.05023", "Europe/Rome"),("3172963", "Montecorvino Rovella", "", "IT", "380", "", "04", "SA", "065073", "40.6918", "14.97862", "Europe/Rome"),("3172969", "Montecompatri", "", "IT", "380", "", "07", "RM", "058060", "41.80892", "12.73778", "Europe/Rome"),("3172979", "Montecchio Maggiore-Alte Ceccato", "", "IT", "380", "", "20", "VI", "024061", "45.50369", "11.412", "Europe/Rome"),("3172980", "Montecchio Emilia", "", "IT", "380", "", "05", "RE", "035027", "44.69937", "10.45211", "Europe/Rome"),("3172996", "Montecatini-Terme", "", "IT", "380", "", "16", "PT", "047011", "43.88153", "10.7723", "Europe/Rome"),("3173029", "Montebelluna", "Монтебеллуна", "IT", "380", "", "20", "TV", "026046", "45.77504", "12.04904", "Europe/Rome"),("3173030", "Montebello Vicentino", "", "IT", "380", "", "20", "VI", "024060", "45.45919", "11.38272", "Europe/Rome"),("3173074", "Montanaro", "", "IT", "380", "", "12", "TO", "001161", "45.23274", "7.85492", "Europe/Rome"),("3173093", "Montale", "", "IT", "380", "", "16", "PT", "047010", "43.93486", "11.01655", "Europe/Rome"),("3173098", "Montalbano Jonico", "", "IT", "380", "", "02", "MT", "077016", "40.28591", "16.5696", "Europe/Rome"),("3173110", "Montagnana", "", "IT", "380", "", "20", "PD", "028056", "45.23229", "11.46483", "Europe/Rome"),("3173122", "Monsummano Terme", "", "IT", "380", "", "16", "PT", "047009", "43.8672", "10.81295", "Europe/Rome"),("3173124", "Monselice", "", "IT", "380", "", "20", "PD", "028055", "45.239", "11.74984", "Europe/Rome"),("3173131", "Monopoli", "Монополи", "IT", "380", "", "13", "BA", "072030", "40.94918", "17.29717", "Europe/Rome"),("3173153", "Monfalcone", "Монфальконе", "IT", "380", "", "06", "GO", "031012", "45.80463", "13.53292", "Europe/Rome"),("3173160", "Mondragone", "", "IT", "380", "", "04", "CE", "061052", "41.11399", "13.89157", "Europe/Rome"),("3173162", "Mondovì", "", "IT", "380", "", "12", "CN", "004130", "44.39603", "7.81764", "Europe/Rome"),("3173180", "Moncalieri", "", "IT", "380", "", "12", "TO", "001156", "44.9994", "7.68236", "Europe/Rome"),("3173276", "Molinella", "", "IT", "380", "", "05", "BO", "037039", "44.61758", "11.66719", "Europe/Rome"),("3173287", "Molfetta", "Мольфетта", "IT", "380", "", "13", "BA", "072029", "41.20036", "16.59905", "Europe/Rome"),("3173302", "Mola di Bari", "", "IT", "380", "", "13", "BA", "072028", "41.05997", "17.09001", "Europe/Rome"),("3173314", "Mogliano Veneto", "", "IT", "380", "", "20", "TV", "026043", "45.55594", "12.24294", "Europe/Rome"),("3173326", "Modugno", "Модуньо", "IT", "380", "", "13", "BA", "072027", "41.08433", "16.78342", "Europe/Rome"),("3173331", "Modena", "Модена", "IT", "380", "", "05", "MO", "036023", "44.64783", "10.92539", "Europe/Rome"),("3173350", "Missaglia", "", "IT", "380", "", "09", "LC", "097049", "45.70656", "9.33471", "Europe/Rome"),("3173369", "Mirano", "Мирано", "IT", "380", "", "20", "VE", "027024", "45.49458", "12.10775", "Europe/Rome"),("3173370", "Mirandola", "Мирандола", "IT", "380", "", "05", "MO", "036022", "44.88515", "11.06902", "Europe/Rome"),("3173385", "Mira Taglio", "Мира", "IT", "380", "", "20", "VE", "027023", "45.4346", "12.12942", "Europe/Rome"),("3173391", "Minturno", "", "IT", "380", "", "07", "LT", "059014", "41.26294", "13.74583", "Europe/Rome"),("3173404", "Minervino Murge", "", "IT", "380", "", "13", "BT", "110006", "41.08264", "16.07861", "Europe/Rome"),("3173435", "Milan", "Милан", "IT", "380", "", "09", "MI", "015146", "45.46427", "9.18951", "Europe/Rome"),("3173480", "Mezzolombardo", "", "IT", "380", "", "17", "TN", "022117", "46.20774", "11.09636", "Europe/Rome"),("3173524", "Meta", "", "IT", "380", "", "04", "NA", "063046", "40.64081", "14.41582", "Europe/Rome"),("3173528", "Mestrino", "", "IT", "380", "", "20", "PD", "028054", "45.44139", "11.75931", "Europe/Rome"),("3173529", "Mestre", "Местре", "IT", "380", "", "20", "VE", "027042", "45.49167", "12.24538", "Europe/Rome"),("3173537", "Mesagne", "", "IT", "380", "", "13", "BR", "074010", "40.55851", "17.80774", "Europe/Rome"),("3173555", "Mercogliano", "", "IT", "380", "", "04", "AV", "064049", "40.92157", "14.74491", "Europe/Rome"),("3173560", "Mercato San Severino", "", "IT", "380", "", "04", "SA", "065067", "40.78468", "14.75369", "Europe/Rome"),("3173561", "Mercato", "", "IT", "380", "", "04", "SA", "065056", "40.71612", "14.9401", "Europe/Rome"),("3173576", "Merate", "", "IT", "380", "", "09", "LC", "097048", "45.68858", "9.4208", "Europe/Rome"),("3173577", "Merano", "Мерано", "IT", "380", "", "17", "BZ", "021051", "46.66817", "11.15953", "Europe/Rome"),("3173582", "Mentana", "", "IT", "380", "", "07", "RM", "058059", "42.03539", "12.64413", "Europe/Rome"),("3173599", "Melzo", "", "IT", "380", "", "09", "MI", "015142", "45.4981", "9.42043", "Europe/Rome"),("3173614", "Melito di Napoli", "", "IT", "380", "", "04", "NA", "063045", "40.91948", "14.23104", "Europe/Rome"),("3173615", "Melfi", "", "IT", "380", "", "02", "PZ", "076048", "40.99571", "15.65578", "Europe/Rome"),("3173630", "Melendugno", "", "IT", "380", "", "13", "LE", "075043", "40.27252", "18.33798", "Europe/Rome"),("3173631", "Melegnano", "", "IT", "380", "", "09", "MI", "015140", "45.35781", "9.3236", "Europe/Rome"),("3173635", "Meldola", "", "IT", "380", "", "05", "FC", "040019", "44.12775", "12.0626", "Europe/Rome"),("3173660", "Medicina-Buda", "", "IT", "380", "", "05", "BO", "037037", "44.47867", "11.63812", "Europe/Rome"),("3173667", "Mede", "", "IT", "380", "", "09", "PV", "018088", "45.09678", "8.73679", "Europe/Rome"),("3173671", "Meda", "Мед", "IT", "380", "", "09", "MB", "108030", "45.66121", "9.15337", "Europe/Rome"),("3173699", "Mattinata", "", "IT", "380", "", "13", "FG", "071031", "41.71112", "16.05087", "Europe/Rome"),("3173704", "Mattarello", "", "IT", "380", "", "17", "TN", "022205", "46.00865", "11.12984", "Europe/Rome"),("3173711", "Matino", "", "IT", "380", "", "13", "LE", "075042", "40.03083", "18.1363", "Europe/Rome"),("3173721", "Matera", "Матера", "IT", "380", "", "02", "MT", "077014", "40.66599", "16.60463", "Europe/Rome"),("3173722", "Matelica", "", "IT", "380", "", "10", "MC", "043024", "43.25788", "13.0075", "Europe/Rome"),("3173754", "Massarosa", "", "IT", "380", "", "16", "LU", "046018", "43.86638", "10.34458", "Europe/Rome"),("3173758", "Massa Marittima", "", "IT", "380", "", "16", "GR", "053015", "43.04779", "10.89293", "Europe/Rome"),("3173760", "Massa Lubrense", "", "IT", "380", "", "04", "NA", "063044", "40.60937", "14.37202", "Europe/Rome"),("3173761", "Massa Lombarda", "", "IT", "380", "", "05", "RA", "039013", "44.44703", "11.82095", "Europe/Rome"),("3173762", "Massafra", "", "IT", "380", "", "13", "TA", "073015", "40.58618", "17.11635", "Europe/Rome"),("3173775", "Massa", "Масса", "IT", "380", "", "16", "MS", "045010", "44.03541", "10.13927", "Europe/Rome"),("3173800", "Maserà di Padova", "", "IT", "380", "", "20", "PD", "028048", "45.31827", "11.86543", "Europe/Rome"),("3173833", "Martinsicuro", "", "IT", "380", "", "01", "TE", "067047", "42.88031", "13.91326", "Europe/Rome"),("3173839", "Martinengo", "", "IT", "380", "", "09", "BG", "016133", "45.57216", "9.7675", "Europe/Rome"),("3173841", "Martina Franca", "", "IT", "380", "", "13", "TA", "073013", "40.70355", "17.33814", "Europe/Rome"),("3173845", "Martignacco", "", "IT", "380", "", "06", "UD", "030057", "46.09313", "13.13973", "Europe/Rome"),("3173852", "Martellago", "", "IT", "380", "", "20", "VE", "027021", "45.54383", "12.16363", "Europe/Rome"),("3173857", "Martano", "", "IT", "380", "", "13", "LE", "075040", "40.20205", "18.30193", "Europe/Rome"),("3173870", "Marsciano", "", "IT", "380", "", "18", "PG", "054027", "42.92093", "12.35066", "Europe/Rome"),("3173877", "Marotta", "", "IT", "380", "", "10", "PU", "041029", "43.76397", "13.14772", "Europe/Rome"),("3173878", "Marostica", "", "IT", "380", "", "20", "VI", "024057", "45.74541", "11.66237", "Europe/Rome"),("3173888", "Marnate", "", "IT", "380", "", "09", "VA", "012098", "45.62855", "8.90916", "Europe/Rome"),("3173895", "Marmirolo", "", "IT", "380", "", "09", "MN", "020033", "45.21928", "10.75609", "Europe/Rome"),("3173914", "Marino", "", "IT", "380", "", "07", "RM", "058057", "41.76984", "12.65917", "Europe/Rome"),("3173935", "Marina di Carrara", "", "IT", "380", "", "16", "MS", "045003", "44.03837", "10.04142", "Europe/Rome"),("3173937", "Marina di Andora", "", "IT", "380", "IT", "08", "SV", "009006", "43.95353", "8.1546", "Europe/Rome"),("3173945", "Marigliano", "Марильяно", "IT", "380", "", "04", "NA", "063043", "40.9248", "14.45612", "Europe/Rome"),("3173946", "Mariglianella", "", "IT", "380", "", "04", "NA", "063042", "40.92962", "14.43703", "Europe/Rome"),("3173949", "Mariano Comense", "", "IT", "380", "", "09", "CO", "013143", "45.69651", "9.1818", "Europe/Rome"),("3173958", "Margherita di Savoia", "", "IT", "380", "", "13", "BT", "110005", "41.37174", "16.15275", "Europe/Rome"),("3173985", "Marcon-Gaggio-Colmello", "", "IT", "380", "", "20", "VE", "027020", "45.56444", "12.29889", "Europe/Rome"),("3173995", "Marcianise", "Марчанизе", "IT", "380", "", "04", "CE", "061049", "41.03064", "14.29868", "Europe/Rome"),("3174006", "Marcellina", "", "IT", "380", "", "07", "RM", "058056", "42.02436", "12.80445", "Europe/Rome"),("3174014", "Marano Vicentino", "", "IT", "380", "", "20", "VI", "024056", "45.696", "11.43237", "Europe/Rome"),("3174021", "Marano di Napoli", "", "IT", "380", "", "04", "NA", "063041", "40.8971", "14.18824", "Europe/Rome"),("3174032", "Maranello", "", "IT", "380", "", "05", "MO", "036019", "44.53101", "10.86888", "Europe/Rome"),("3174043", "Manziana", "", "IT", "380", "", "07", "RM", "058054", "42.12998", "12.12537", "Europe/Rome"),("3174045", "Manzano", "", "IT", "380", "", "06", "UD", "030055", "45.98843", "13.37674", "Europe/Rome"),("3174051", "Mantova", "Мантуя", "IT", "380", "", "09", "MN", "020030", "45.16031", "10.79784", "Europe/Rome"),("3174084", "Maniago", "", "IT", "380", "", "06", "PN", "093025", "46.16644", "12.70602", "Europe/Rome"),("3174092", "Manfredonia", "Манфредония", "IT", "380", "", "13", "FG", "071029", "41.63065", "15.91876", "Europe/Rome"),("3174093", "Manerbio", "", "IT", "380", "", "09", "BS", "017103", "45.3539", "10.13803", "Europe/Rome"),("3174096", "Manduria", "Мандурия", "IT", "380", "", "13", "TA", "073012", "40.39899", "17.63726", "Europe/Rome"),("3174107", "Mandello del Lario", "", "IT", "380", "", "09", "LC", "097046", "45.92199", "9.31974", "Europe/Rome"),("3174139", "Malo", "", "IT", "380", "", "20", "VI", "024055", "45.6591", "11.41601", "Europe/Rome"),("3174141", "Malnate", "", "IT", "380", "", "09", "VA", "012096", "45.79377", "8.88104", "Europe/Rome"),("3174214", "Maiori", "", "IT", "380", "", "04", "SA", "065066", "40.64848", "14.6407", "Europe/Rome"),("3174250", "Magnago", "", "IT", "380", "", "09", "MI", "015131", "45.5792", "8.80245", "Europe/Rome"),("3174254", "Maglie", "", "IT", "380", "", "13", "LE", "075039", "40.12069", "18.29797", "Europe/Rome"),("3174273", "Magione", "", "IT", "380", "", "18", "PG", "054026", "43.14179", "12.21169", "Europe/Rome"),("3174295", "Magenta", "", "IT", "380", "", "09", "MI", "015130", "45.46456", "8.88453", "Europe/Rome"),("3174308", "Maerne", "", "IT", "380", "", "20", "VE", "027021", "45.52313", "12.15477", "Europe/Rome"),("3174358", "Maddaloni", "Маддалони", "IT", "380", "", "04", "CE", "061048", "41.03578", "14.3823", "Europe/Rome"),("3174367", "Macomer", "", "IT", "380", "", "14", "NU", "091044", "40.26233", "8.76733", "Europe/Rome"),("3174378", "Macerata Campania", "", "IT", "380", "", "04", "CE", "061047", "41.06327", "14.2775", "Europe/Rome"),("3174380", "Macerata", "Мачерата", "IT", "380", "", "10", "MC", "043023", "43.29789", "13.45293", "Europe/Rome"),("3174435", "Lurate Caccivio", "", "IT", "380", "", "09", "CO", "013138", "45.76701", "8.99897", "Europe/Rome"),("3174483", "Luino", "", "IT", "380", "", "09", "VA", "012092", "46.00185", "8.74512", "Europe/Rome"),("3174494", "Lugo", "Луго", "IT", "380", "", "05", "RA", "039012", "44.42137", "11.91094", "Europe/Rome"),("3174505", "Lugagnano", "", "IT", "380", "", "20", "VR", "023083", "45.43327", "10.88402", "Europe/Rome"),("3174508", "Lucrezia", "", "IT", "380", "IT", "10", "PU", "041010", "43.7731", "12.93995", "Europe/Rome"),("3174510", "Luco dei Marsi", "", "IT", "380", "", "01", "AQ", "066051", "41.95925", "13.47349", "Europe/Rome"),("3174526", "Lucera", "Лучера", "IT", "380", "", "13", "FG", "071028", "41.5055", "15.3391", "Europe/Rome"),("3174530", "Lucca", "Лукка", "IT", "380", "", "16", "LU", "046017", "43.84369", "10.50447", "Europe/Rome"),("3174543", "Lovere", "", "IT", "380", "", "09", "BG", "016128", "45.81379", "10.06995", "Europe/Rome"),("3174567", "Loreto", "", "IT", "380", "", "10", "AN", "042022", "43.43617", "13.61232", "Europe/Rome"),("3174587", "Lonigo", "", "IT", "380", "", "20", "VI", "024052", "45.38576", "11.38402", "Europe/Rome"),("3174607", "Lonato", "", "IT", "380", "", "09", "BS", "017092", "45.46079", "10.47732", "Europe/Rome"),("3174608", "Lonate Pozzolo", "", "IT", "380", "", "09", "VA", "012090", "45.59213", "8.75194", "Europe/Rome"),("3174621", "Lomazzo", "", "IT", "380", "", "09", "CO", "013133", "45.6967", "9.03427", "Europe/Rome"),("3174636", "Lodi Vecchio", "", "IT", "380", "", "09", "LO", "098032", "45.30422", "9.4176", "Europe/Rome"),("3174638", "Lodi", "Лоди", "IT", "380", "", "09", "LO", "098031", "45.30989", "9.50085", "Europe/Rome"),("3174641", "Locorotondo", "", "IT", "380", "", "13", "BA", "072025", "40.75661", "17.32392", "Europe/Rome"),("3174645", "Locate di Triulzi", "", "IT", "380", "", "09", "MI", "015125", "45.35691", "9.22516", "Europe/Rome"),("3174649", "Loano", "", "IT", "380", "", "08", "SV", "009034", "44.12777", "8.25743", "Europe/Rome"),("3174653", "Lizzano", "", "IT", "380", "", "13", "TA", "073011", "40.39301", "17.44571", "Europe/Rome"),("3174654", "Lizzanello", "", "IT", "380", "", "13", "LE", "075038", "40.30475", "18.22283", "Europe/Rome"),("3174659", "Livorno", "Ливорно", "IT", "380", "", "16", "LI", "049009", "43.54427", "10.32615", "Europe/Rome"),("3174679", "Lissone", "Лиссоне", "IT", "380", "", "09", "MB", "108028", "45.61236", "9.23985", "Europe/Rome"),("3174718", "Limena", "", "IT", "380", "", "20", "PD", "028045", "45.46948", "11.84574", "Europe/Rome"),("3174719", "Limbiate", "Лимбьяте", "IT", "380", "", "09", "MB", "108027", "45.59951", "9.12509", "Europe/Rome"),("3174729", "Lignano Sabbiadoro", "", "IT", "380", "", "06", "UD", "030049", "45.6759", "13.11727", "Europe/Rome"),("3174741", "Lido di Ostia", "Лидо-ди-Рома", "IT", "380", "IT", "07", "RM", "058091", "41.73212", "12.27654", "Europe/Rome"),("3174742", "Lido di Iesolo", "", "IT", "380", "", "20", "VE", "027019", "45.50694", "12.64694", "Europe/Rome"),("3174748", "Lido", "", "IT", "380", "IT", "20", "VE", "027042", "45.4105", "12.36649", "Europe/Rome"),("3174784", "Levico Terme", "", "IT", "380", "", "17", "TN", "022104", "46.01217", "11.30427", "Europe/Rome"),("3174789", "Leverano", "", "IT", "380", "", "13", "LE", "075037", "40.28852", "17.9965", "Europe/Rome"),("3174833", "Lesina", "", "IT", "380", "", "13", "FG", "071027", "41.86125", "15.35322", "Europe/Rome"),("3174856", "Lerici", "", "IT", "380", "", "08", "SP", "011016", "44.07587", "9.91121", "Europe/Rome"),("3174859", "Lequile", "", "IT", "380", "", "13", "LE", "075036", "40.30583", "18.14022", "Europe/Rome"),("3174888", "Lentate sul Seveso", "", "IT", "380", "", "09", "MB", "108054", "45.67637", "9.11774", "Europe/Rome"),("3174892", "Leno", "", "IT", "380", "", "09", "BS", "017088", "45.3693", "10.21675", "Europe/Rome"),("3174896", "Lendinara", "", "IT", "380", "", "20", "RO", "029029", "45.08301", "11.60318", "Europe/Rome"),("3174911", "Leini", "", "IT", "380", "", "12", "TO", "001130", "45.18275", "7.71422", "Europe/Rome"),("3174915", "Le Grazie di Ancona", "", "IT", "380", "IT", "10", "AN", "042002", "43.60081", "13.51529", "Europe/Rome"),("3174920", "Legnaro", "", "IT", "380", "", "20", "PD", "028044", "45.34238", "11.96482", "Europe/Rome"),("3174921", "Legnano", "Леньяно", "IT", "380", "", "09", "MI", "015118", "45.59788", "8.91506", "Europe/Rome"),("3174922", "Legnago", "Леньяго", "IT", "380", "", "20", "VR", "023044", "45.19365", "11.30227", "Europe/Rome"),("3174945", "Lecco", "Лекко", "IT", "380", "", "09", "LC", "097042", "45.85589", "9.39704", "Europe/Rome"),("3174953", "Lecce", "Лечче", "IT", "380", "", "13", "LE", "075035", "40.35481", "18.17244", "Europe/Rome"),("3174984", "Lavis", "", "IT", "380", "", "17", "TN", "022103", "46.14131", "11.10931", "Europe/Rome"),("3175003", "Laveno", "", "IT", "380", "", "09", "VA", "012087", "45.90888", "8.62036", "Europe/Rome"),("3175009", "Lavello", "", "IT", "380", "", "02", "PZ", "076043", "41.04769", "15.78915", "Europe/Rome"),("3175024", "Lavagna", "", "IT", "380", "", "08", "GE", "010028", "44.3062", "9.35383", "Europe/Rome"),("3175055", "Latisana", "", "IT", "380", "", "06", "UD", "030046", "45.76859", "13.00618", "Europe/Rome"),("3175058", "Latina", "Латина", "IT", "380", "", "07", "LT", "059011", "41.46614", "12.9043", "Europe/Rome"),("3175061", "Latiano", "", "IT", "380", "", "13", "BR", "074009", "40.55052", "17.71856", "Europe/Rome"),("3175064", "Laterza", "", "IT", "380", "", "13", "TA", "073009", "40.62881", "16.79947", "Europe/Rome"),("3175074", "Lastra a Signa", "", "IT", "380", "", "16", "FI", "048024", "43.76998", "11.11271", "Europe/Rome"),("3175081", "La Spezia", "Специя", "IT", "380", "", "08", "SP", "011015", "44.103", "9.82375", "Europe/Rome"),("3175105", "Larino", "", "IT", "380", "", "11", "CB", "070031", "41.80449", "14.91843", "Europe/Rome"),("3175106", "Lariano", "", "IT", "380", "", "07", "RM", "058115", "41.71847", "12.82868", "Europe/Rome"),("3175121", "L'Aquila", "Л’Аквила", "IT", "380", "", "01", "AQ", "066049", "42.35055", "13.39954", "Europe/Rome"),("3175156", "Lanuvio", "", "IT", "380", "", "07", "RM", "058050", "41.67297", "12.69403", "Europe/Rome"),("3175163", "Langhirano", "", "IT", "380", "", "05", "PR", "034018", "44.61913", "10.26652", "Europe/Rome"),("3175173", "Lanciano", "Ланчано", "IT", "380", "", "01", "CH", "069046", "42.22718", "14.39024", "Europe/Rome"),("3175177", "Lana", "", "IT", "380", "", "17", "BZ", "021041", "46.61209", "11.15653", "Europe/Rome"),("3175182", "Lamporecchio", "", "IT", "380", "", "16", "PT", "047005", "43.80742", "10.87733", "Europe/Rome"),("3175217", "La Maddalena", "", "IT", "380", "", "14", "OT", "104012", "41.21424", "9.40833", "Europe/Rome"),("3175228", "La Loggia", "", "IT", "380", "", "12", "TO", "001127", "44.95495", "7.66864", "Europe/Rome"),("3175235", "Laives", "", "IT", "380", "", "17", "BZ", "021040", "46.42679", "11.33841", "Europe/Rome"),("3175238", "Lainate", "", "IT", "380", "", "09", "MI", "015116", "45.57176", "9.02681", "Europe/Rome"),("3175253", "Lagonegro", "", "IT", "380", "", "02", "PZ", "076039", "40.12785", "15.76212", "Europe/Rome"),("3175265", "Giudecca", "", "IT", "380", "IT", "20", "VE", "027042", "45.42477", "12.32906", "Europe/Rome"),("3175298", "Ladispoli", "Ладисполи", "IT", "380", "", "07", "RM", "058116", "41.95068", "12.075", "Europe/Rome"),("3175337", "Lacchiarella", "", "IT", "380", "", "09", "MI", "015115", "45.3229", "9.13777", "Europe/Rome"),("3175384", "Ivrea", "Ивреа", "IT", "380", "", "12", "TO", "001125", "45.46723", "7.87617", "Europe/Rome"),("3175388", "Ittiri", "", "IT", "380", "", "14", "SS", "090033", "40.59151", "8.56976", "Europe/Rome"),("3175392", "Itri", "", "IT", "380", "", "07", "LT", "059010", "41.29034", "13.53", "Europe/Rome"),("3175427", "Isola del Liri", "", "IT", "380", "", "07", "FR", "060043", "41.68678", "13.59679", "Europe/Rome"),("3175428", "Isola della Scala", "", "IT", "380", "", "20", "VR", "023040", "45.26943", "11.00824", "Europe/Rome"),("3175445", "Isernia", "Изерния", "IT", "380", "", "11", "IS", "094023", "41.59603", "14.23399", "Europe/Rome"),("3175447", "Iseo", "", "IT", "380", "", "09", "BS", "017085", "45.65883", "10.05024", "Europe/Rome"),("3175453", "Ischia Porto", "", "IT", "380", "", "04", "NA", "063037", "40.73913", "13.951", "Europe/Rome"),("3175458", "Ischia", "Искья", "IT", "380", "IT", "04", "NA", "063037", "40.73793", "13.94862", "Europe/Rome"),("3175491", "Inzago", "", "IT", "380", "", "09", "MI", "015114", "45.53991", "9.48343", "Europe/Rome"),("3175494", "Inveruno", "", "IT", "380", "", "09", "MI", "015113", "45.51399", "8.84954", "Europe/Rome"),("3175497", "Inverigo", "", "IT", "380", "", "09", "CO", "013118", "45.73795", "9.21836", "Europe/Rome"),("3175500", "Pallanza-Intra-Suna", "", "IT", "380", "", "12", "VB", "103072", "45.93778", "8.57088", "Europe/Rome"),("3175521", "Induno Olona", "", "IT", "380", "", "09", "VA", "012083", "45.84571", "8.84056", "Europe/Rome"),("3175532", "Imperia", "Империя", "IT", "380", "", "08", "IM", "008031", "43.88917", "8.03933", "Europe/Rome"),("3175537", "Imola", "", "IT", "380", "", "05", "BO", "037032", "44.35916", "11.7132", "Europe/Rome"),("3175627", "Iesolo", "", "IT", "380", "IT", "20", "VE", "027019", "45.53311", "12.64475", "Europe/Rome"),("3175628", "Jesi", "Джези", "IT", "380", "", "10", "AN", "042021", "43.52142", "13.24368", "Europe/Rome"),("3175670", "Gussago", "", "IT", "380", "", "09", "BS", "017081", "45.58358", "10.15717", "Europe/Rome"),("3175678", "Guidonia", "", "IT", "380", "", "07", "RM", "058047", "41.99232", "12.71876", "Europe/Rome"),("3175687", "Gubbio", "", "IT", "380", "", "18", "PG", "054024", "43.34996", "12.57309", "Europe/Rome"),("3175693", "Guastalla", "", "IT", "380", "", "05", "RE", "035024", "44.91172", "10.66186", "Europe/Rome"),("3175722", "Gualdo Tadino", "", "IT", "380", "", "18", "PG", "054023", "43.22941", "12.77862", "Europe/Rome"),("3175743", "Grumo Nevano", "", "IT", "380", "", "04", "NA", "063036", "40.93591", "14.25983", "Europe/Rome"),("3175746", "Grumo Appula", "", "IT", "380", "", "13", "BA", "072024", "41.01089", "16.70844", "Europe/Rome"),("3175752", "Grumello del Monte", "", "IT", "380", "", "09", "BG", "016120", "45.63535", "9.87526", "Europe/Rome"),("3175755", "Grugliasco", "", "IT", "380", "", "12", "TO", "001120", "45.06516", "7.57954", "Europe/Rome"),("3175771", "Grottammare", "", "IT", "380", "", "10", "AP", "044023", "42.98182", "13.86765", "Europe/Rome"),("3175772", "Grottaminarda", "", "IT", "380", "", "04", "AV", "064038", "41.06972", "15.05894", "Europe/Rome"),("3175773", "Grottaglie", "Гротталье", "IT", "380", "", "13", "TA", "073008", "40.53694", "17.43723", "Europe/Rome"),("3175775", "Grottaferrata", "", "IT", "380", "", "07", "RM", "058046", "41.78664", "12.67144", "Europe/Rome"),("3175786", "Grosseto", "Гроссето", "IT", "380", "", "16", "GR", "053011", "42.76296", "11.10941", "Europe/Rome"),("3175825", "Gricignano di Aversa", "", "IT", "380", "IT", "04", "CE", "061043", "40.97973", "14.23087", "Europe/Rome"),("3175856", "Grazzanise", "", "IT", "380", "", "04", "CE", "061042", "41.0897", "14.09878", "Europe/Rome"),("3175860", "Gravina in Puglia", "", "IT", "380", "", "13", "BA", "072023", "40.81748", "16.41915", "Europe/Rome"),("3175864", "Gravellona Toce", "", "IT", "380", "", "12", "VB", "103035", "45.92859", "8.43209", "Europe/Rome"),("3175880", "Grassano", "", "IT", "380", "", "02", "MT", "077011", "40.63457", "16.27792", "Europe/Rome"),("3175952", "Gragnano", "Граньяно", "IT", "380", "", "04", "NA", "063035", "40.68907", "14.52036", "Europe/Rome"),("3175960", "Grado", "", "IT", "380", "", "06", "GO", "031009", "45.67774", "13.40323", "Europe/Rome"),("3175961", "Gradisca d'Isonzo", "", "IT", "380", "", "06", "GO", "031008", "45.8925", "13.50167", "Europe/Rome"),("3175983", "Gorle", "", "IT", "380", "", "09", "BG", "016115", "45.70127", "9.71382", "Europe/Rome"),("3175984", "Gorla Maggiore", "", "IT", "380", "", "09", "VA", "012078", "45.66388", "8.89537", "Europe/Rome"),("3175986", "Gorizia", "Гориция", "IT", "380", "", "06", "GO", "031007", "45.94088", "13.62167", "Europe/Rome"),("3175990", "Gorgonzola", "", "IT", "380", "", "09", "MI", "015108", "45.53069", "9.40531", "Europe/Rome"),("3176002", "Gonzaga", "", "IT", "380", "", "09", "MN", "020027", "44.95193", "10.81913", "Europe/Rome"),("3176014", "Goito", "", "IT", "380", "", "09", "MN", "020026", "45.25076", "10.66121", "Europe/Rome"),("3176041", "Giussano", "", "IT", "380", "", "09", "MB", "108024", "45.70004", "9.2089", "Europe/Rome"),("3176053", "Giulianova", "", "IT", "380", "", "01", "TE", "067025", "42.75381", "13.9665", "Europe/Rome"),("3176059", "Giugliano in Campania", "", "IT", "380", "", "04", "NA", "063034", "40.92849", "14.20197", "Europe/Rome"),("3176072", "Giovinazzo", "Джовинаццо", "IT", "380", "", "13", "BA", "072022", "41.185", "16.67054", "Europe/Rome"),("3176090", "Gioia del Colle", "Джоя-дель-Колле", "IT", "380", "", "13", "BA", "072021", "40.79968", "16.92298", "Europe/Rome"),("3176097", "Ginosa", "", "IT", "380", "", "13", "TA", "073007", "40.5769", "16.75655", "Europe/Rome"),("3176125", "Giffoni Valle Piana", "", "IT", "380", "", "04", "SA", "065056", "40.71811", "14.94235", "Europe/Rome"),("3176130", "Giaveno", "", "IT", "380", "", "12", "TO", "001115", "45.04435", "7.34722", "Europe/Rome"),("3176163", "Ghisalba", "", "IT", "380", "", "09", "BG", "016113", "45.59354", "9.75765", "Europe/Rome"),("3176177", "Ghedi", "Геди", "IT", "380", "", "09", "BS", "017078", "45.40204", "10.27681", "Europe/Rome"),("3176203", "Genzano di Roma", "Дженцано-ди-Рома", "IT", "380", "", "07", "RM", "058043", "41.70706", "12.68904", "Europe/Rome"),("3176204", "Genzano di Lucania", "", "IT", "380", "", "02", "PZ", "076036", "40.84589", "16.03124", "Europe/Rome"),("3176219", "Genoa", "Генуя", "IT", "380", "", "08", "GE", "010025", "44.4264", "8.91519", "Europe/Rome"),("3176234", "Gemona", "", "IT", "380", "", "06", "UD", "030043", "46.27405", "13.12237", "Europe/Rome"),("3176261", "Gavirate", "", "IT", "380", "", "09", "VA", "012072", "45.83707", "8.72619", "Europe/Rome"),("3176277", "Gavardo-Sopraponte", "", "IT", "380", "", "09", "BS", "017077", "45.58939", "10.44257", "Europe/Rome"),("3176282", "Gattinara", "", "IT", "380", "", "12", "VC", "002061", "45.61309", "8.36463", "Europe/Rome"),("3176285", "Gassino Torinese", "", "IT", "380", "", "12", "TO", "001112", "45.12907", "7.82934", "Europe/Rome"),("3176299", "Garlasco", "", "IT", "380", "", "09", "PV", "018069", "45.1954", "8.92314", "Europe/Rome"),("3176311", "Gardone Val Trompia", "", "IT", "380", "", "09", "BS", "017075", "45.69137", "10.18635", "Europe/Rome"),("3176322", "Garbagnate Milanese", "", "IT", "380", "", "09", "MI", "015105", "45.57438", "9.07537", "Europe/Rome"),("3176330", "Gandino", "", "IT", "380", "", "09", "BG", "016108", "45.81088", "9.89767", "Europe/Rome"),("3176333", "Gambolò", "", "IT", "380", "", "09", "PV", "018068", "45.26209", "8.8582", "Europe/Rome"),("3176334", "Gambettola", "", "IT", "380", "", "05", "FC", "040015", "44.11748", "12.33705", "Europe/Rome"),("3176366", "Gallipoli", "Галлиполи", "IT", "380", "", "13", "LE", "075031", "40.05594", "17.99088", "Europe/Rome"),("3176373", "Galliera Veneta", "", "IT", "380", "", "20", "PD", "028039", "45.6675", "11.82217", "Europe/Rome"),("3176379", "Galliate", "", "IT", "380", "", "12", "NO", "003068", "45.47942", "8.69815", "Europe/Rome"),("3176391", "Gallarate", "Галларате", "IT", "380", "", "09", "VA", "012070", "45.66019", "8.79164", "Europe/Rome"),("3176406", "Galatone", "", "IT", "380", "", "13", "LE", "075030", "40.14673", "18.06937", "Europe/Rome"),("3176407", "Galatina", "", "IT", "380", "", "13", "LE", "075029", "40.17416", "18.17032", "Europe/Rome"),("3176436", "Gaggiano", "", "IT", "380", "", "09", "MI", "015103", "45.40484", "9.03488", "Europe/Rome"),("3176438", "Gaeta", "Гаета", "IT", "380", "", "07", "LT", "059009", "41.21408", "13.57082", "Europe/Rome"),("3176467", "Fusignano", "", "IT", "380", "", "05", "RA", "039011", "44.46656", "11.95636", "Europe/Rome"),("3176504", "Fucecchio", "", "IT", "380", "", "16", "FI", "048019", "43.73292", "10.79749", "Europe/Rome"),("3176515", "Frosinone", "Фрозиноне", "IT", "380", "", "07", "FR", "060038", "41.63976", "13.34109", "Europe/Rome"),("3176544", "Fregene", "", "IT", "380", "", "07", "RM", "058120", "41.85051", "12.19671", "Europe/Rome"),("3176560", "Frattaminore", "", "IT", "380", "", "04", "NA", "063033", "40.9558", "14.27201", "Europe/Rome"),("3176561", "Frattamaggiore", "Фраттамаджоре", "IT", "380", "", "04", "NA", "063032", "40.9414", "14.27588", "Europe/Rome"),("3176589", "Frascati", "", "IT", "380", "", "07", "RM", "058039", "41.8091", "12.67942", "Europe/Rome"),("3176603", "Francavilla Fontana", "", "IT", "380", "", "13", "BR", "074008", "40.53123", "17.58522", "Europe/Rome"),("3176605", "Francavilla al Mare", "", "IT", "380", "", "01", "CH", "069035", "42.42158", "14.28217", "Europe/Rome"),("3176616", "Fragagnano", "", "IT", "380", "", "13", "TA", "073006", "40.4302", "17.47553", "Europe/Rome"),("3176630", "Fossombrone", "", "IT", "380", "", "10", "PU", "041015", "43.69017", "12.81173", "Europe/Rome"),("3176639", "Fossano", "", "IT", "380", "", "12", "CN", "004089", "44.55077", "7.71922", "Europe/Rome"),("3176640", "San Vendemiano-Fossamerlo", "", "IT", "380", "", "20", "TV", "026076", "45.8918", "12.32992", "Europe/Rome"),("3176674", "Forte dei Marmi", "", "IT", "380", "", "16", "LU", "046013", "43.96388", "10.17478", "Europe/Rome"),("3176718", "Fornacette", "", "IT", "380", "", "16", "PI", "050004", "43.67023", "10.58512", "Europe/Rome"),("3176722", "Fornacelle", "", "IT", "380", "", "16", "PO", "100003", "43.92377", "11.03525", "Europe/Rome"),("3176733", "Formigine", "", "IT", "380", "", "05", "MO", "036015", "44.57268", "10.84737", "Europe/Rome"),("3176738", "Formia", "", "IT", "380", "", "07", "LT", "059008", "41.25632", "13.60888", "Europe/Rome"),("3176739", "Formello", "", "IT", "380", "", "07", "RM", "058038", "42.06246", "12.39435", "Europe/Rome"),("3176743", "Forlimpopoli", "", "IT", "380", "", "05", "FC", "040013", "44.19107", "12.12873", "Europe/Rome"),("3176746", "Forlì", "Форли", "IT", "380", "", "05", "FC", "040012", "44.22177", "12.04144", "Europe/Rome"),("3176748", "Forio", "", "IT", "380", "", "04", "NA", "063031", "40.73757", "13.86003", "Europe/Rome"),("3176797", "Fontaniva", "", "IT", "380", "", "20", "PD", "028038", "45.63516", "11.75381", "Europe/Rome"),("3176843", "Fondi", "Фонда", "IT", "380", "", "07", "LT", "059007", "41.35787", "13.42718", "Europe/Rome"),("3176849", "Follonica", "Фоллоника", "IT", "380", "", "16", "GR", "053009", "42.92779", "10.76451", "Europe/Rome"),("3176854", "Foligno", "Фолиньо", "IT", "380", "", "18", "PG", "054018", "42.95488", "12.70268", "Europe/Rome"),("3176860", "Foiano della Chiana", "", "IT", "380", "", "16", "AR", "051018", "43.25318", "11.81647", "Europe/Rome"),("3176885", "Foggia", "Фоджа", "IT", "380", "", "13", "FG", "071024", "41.45845", "15.55188", "Europe/Rome"),("3176907", "Flero", "", "IT", "380", "", "09", "BS", "017072", "45.48254", "10.17694", "Europe/Rome"),("3176923", "Fiumicino-Isola Sacra", "Фьюмичино", "IT", "380", "", "07", "RM", "058120", "41.77093", "12.23662", "Europe/Rome"),("3176927", "Fiume Veneto", "", "IT", "380", "", "06", "PN", "093021", "45.92865", "12.73811", "Europe/Rome"),("3176946", "Fiuggi", "", "IT", "380", "", "07", "FR", "060035", "41.7978", "13.22386", "Europe/Rome"),("3176959", "Florence", "Флоренция", "IT", "380", "", "16", "FI", "048017", "43.77925", "11.24626", "Europe/Rome"),("3176964", "Fiorenzuola d'Arda", "", "IT", "380", "", "05", "PC", "033021", "44.92435", "9.91329", "Europe/Rome"),("3176970", "Fiorano", "", "IT", "380", "", "05", "MO", "036013", "44.53889", "10.81166", "Europe/Rome"),("3176976", "Fino Mornasco", "", "IT", "380", "", "09", "CO", "013102", "45.7429", "9.04996", "Europe/Rome"),("3176982", "Finale Ligure", "", "IT", "380", "", "08", "SV", "009029", "44.16952", "8.3436", "Europe/Rome"),("3176983", "Finale Emilia", "", "IT", "380", "", "05", "MO", "036012", "44.83373", "11.29378", "Europe/Rome"),("3176988", "Filottrano", "", "IT", "380", "", "10", "AN", "042019", "43.43553", "13.35141", "Europe/Rome"),("3177009", "Figline Valdarno", "", "IT", "380", "", "16", "FI", "048052", "43.61995", "11.47191", "Europe/Rome"),("3177029", "Fidenza", "Фиденцы", "IT", "380", "", "05", "PR", "034014", "44.86694", "10.06039", "Europe/Rome"),("3177046", "Fiano Romano", "", "IT", "380", "", "07", "RM", "058036", "42.15538", "12.59467", "Europe/Rome"),("3177090", "Ferrara", "Феррара", "IT", "380", "", "05", "FE", "038008", "44.83804", "11.62057", "Europe/Rome"),("3177094", "Ferrandina", "", "IT", "380", "", "02", "MT", "077008", "40.50084", "16.45258", "Europe/Rome"),("3177098", "Ferno", "", "IT", "380", "", "09", "VA", "012068", "45.61496", "8.75695", "Europe/Rome"),("3177099", "Fermo", "Фермо", "IT", "380", "", "10", "FM", "109006", "43.16296", "13.72274", "Europe/Rome"),("3177100", "Fermignano", "", "IT", "380", "", "10", "PU", "041014", "43.69311", "12.65437", "Europe/Rome"),("3177102", "Ferentino", "", "IT", "380", "", "07", "FR", "060033", "41.69119", "13.2562", "Europe/Rome"),("3177120", "Feltre", "", "IT", "380", "", "20", "BL", "025021", "46.02085", "11.90031", "Europe/Rome"),("3177171", "Fasano", "Фазано", "IT", "380", "", "13", "BR", "074007", "40.83625", "17.36007", "Europe/Rome"),("3177177", "Farra di Soligo", "", "IT", "380", "", "20", "TV", "026026", "45.90528", "12.12444", "Europe/Rome"),("3177209", "Fara Gera d'Adda", "", "IT", "380", "", "09", "BG", "016096", "45.55656", "9.53656", "Europe/Rome"),("3177219", "Fano", "Фано", "IT", "380", "", "10", "PU", "041013", "43.84052", "13.01665", "Europe/Rome"),("3177250", "Falconara Marittima", "", "IT", "380", "", "10", "AN", "042018", "43.62558", "13.39954", "Europe/Rome"),("3177279", "Fagnano Olona-Bergoro", "", "IT", "380", "", "09", "VA", "012067", "45.66977", "8.85994", "Europe/Rome"),("3177300", "Faenza", "", "IT", "380", "", "05", "RA", "039010", "44.29007", "11.87948", "Europe/Rome"),("3177314", "Fabrica di Roma", "", "IT", "380", "", "07", "VT", "056024", "42.33444", "12.29873", "Europe/Rome"),("3177315", "Fabriano", "Фабриано", "IT", "380", "", "10", "AN", "042017", "43.33941", "12.90327", "Europe/Rome"),("3177317", "Fabbrico", "", "IT", "380", "", "05", "RE", "035021", "44.87214", "10.80893", "Europe/Rome"),("3177337", "Este", "", "IT", "380", "", "20", "PD", "028037", "45.22338", "11.66379", "Europe/Rome"),("3177363", "Ercolano", "Геркуланум", "IT", "380", "", "04", "NA", "063064", "40.80783", "14.35012", "Europe/Rome"),("3177366", "Erchie", "", "IT", "380", "", "13", "BR", "074006", "40.43609", "17.7361", "Europe/Rome"),("3177372", "Erba", "", "IT", "380", "", "09", "CO", "013095", "45.8088", "9.22609", "Europe/Rome"),("3177400", "Empoli", "", "IT", "380", "", "16", "FI", "048014", "43.71795", "10.94758", "Europe/Rome"),("3177438", "Eboli", "", "IT", "380", "", "04", "SA", "065050", "40.61747", "15.05693", "Europe/Rome"),("3177456", "Dueville", "", "IT", "380", "", "20", "VI", "024038", "45.63556", "11.55135", "Europe/Rome"),("3177471", "Druento", "", "IT", "380", "", "12", "TO", "001099", "45.13306", "7.57512", "Europe/Rome"),("3177474", "Dronero", "", "IT", "380", "", "12", "CN", "004082", "44.46476", "7.36242", "Europe/Rome"),("3177496", "Dosson", "", "IT", "380", "", "20", "TV", "026010", "45.63605", "12.25409", "Europe/Rome"),("3177497", "Dossobuono", "", "IT", "380", "", "20", "VR", "023096", "45.39333", "10.91054", "Europe/Rome"),("3177513", "Dorgali", "", "IT", "380", "", "14", "NU", "091017", "40.29221", "9.58702", "Europe/Rome"),("3177532", "Domodossola", "", "IT", "380", "", "12", "VB", "103028", "46.1165", "8.29313", "Europe/Rome"),("3177547", "Dolo", "", "IT", "380", "", "20", "VE", "027012", "45.42528", "12.08429", "Europe/Rome"),("3177595", "Diano Marina", "", "IT", "380", "", "08", "IM", "008027", "43.91088", "8.08029", "Europe/Rome"),("3177608", "Desio", "Дезио", "IT", "380", "", "09", "MB", "108023", "45.61831", "9.20249", "Europe/Rome"),("3177610", "Desenzano del Garda", "Дезенцано дель Гарда", "IT", "380", "", "09", "BS", "017067", "45.47127", "10.53559", "Europe/Rome"),("3177640", "Decima", "", "IT", "380", "", "05", "BO", "037053", "44.71045", "11.22978", "Europe/Rome"),("3177650", "Dalmine", "Дальмине", "IT", "380", "", "09", "BG", "016091", "45.64933", "9.60617", "Europe/Rome"),("3177651", "Dairago", "", "IT", "380", "", "09", "MI", "015099", "45.5658", "8.86265", "Europe/Rome"),("3177654", "Cutrofiano", "", "IT", "380", "", "13", "LE", "075026", "40.12616", "18.2026", "Europe/Rome"),("3177664", "Cusano Milanino", "", "IT", "380", "", "09", "MI", "015098", "45.55187", "9.18373", "Europe/Rome"),("3177672", "Curno", "", "IT", "380", "", "09", "BG", "016089", "45.68876", "9.60872", "Europe/Rome"),("3177695", "Cuorgnè", "", "IT", "380", "", "12", "TO", "001098", "45.39341", "7.65015", "Europe/Rome"),("3177700", "Cuneo", "Кунео", "IT", "380", "", "12", "CN", "004078", "44.39071", "7.54828", "Europe/Rome"),("3177704", "Cumiana", "", "IT", "380", "", "12", "TO", "001097", "44.97629", "7.37761", "Europe/Rome"),("3177720", "Cuggiono", "", "IT", "380", "", "09", "MI", "015096", "45.50683", "8.8155", "Europe/Rome"),("3177773", "Crocetta del Montello", "", "IT", "380", "", "20", "TV", "026025", "45.83667", "12.03361", "Europe/Rome"),("3177808", "Crispiano", "", "IT", "380", "", "13", "TA", "073004", "40.60379", "17.2329", "Europe/Rome"),("3177814", "Crevalcore", "", "IT", "380", "", "05", "BO", "037024", "44.71966", "11.14765", "Europe/Rome"),("3177833", "Crescentino", "", "IT", "380", "", "12", "VC", "002049", "45.19941", "8.08635", "Europe/Rome"),("3177838", "Cremona", "Кремона", "IT", "380", "", "09", "CR", "019036", "45.13325", "10.02129", "Europe/Rome"),("3177841", "Crema", "Крема", "IT", "380", "", "09", "CR", "019035", "45.36264", "9.68176", "Europe/Rome"),("3177845", "Creazzo", "", "IT", "380", "IT", "20", "VI", "024036", "45.53154", "11.47789", "Europe/Rome"),("3177885", "Costa Volpino", "", "IT", "380", "", "09", "BG", "016086", "45.82768", "10.10076", "Europe/Rome"),("3177924", "Cossato", "", "IT", "380", "", "12", "BI", "096020", "45.57032", "8.18471", "Europe/Rome"),("3177952", "Cortina d'Ampezzo", "", "IT", "380", "", "20", "BL", "025016", "46.5369", "12.13903", "Europe/Rome"),("3177983", "Corte Franca", "", "IT", "380", "", "09", "BS", "017062", "45.62998", "9.98846", "Europe/Rome"),("3178004", "Corsico", "Корсико", "IT", "380", "", "09", "MI", "015093", "45.43099", "9.11093", "Europe/Rome"),("3178014", "Corridonia", "", "IT", "380", "", "10", "MC", "043015", "43.24677", "13.5069", "Europe/Rome"),("3178019", "Correggio", "Корреджо", "IT", "380", "", "05", "RE", "035020", "44.76737", "10.78345", "Europe/Rome"),("3178039", "Cornuda", "", "IT", "380", "", "20", "TV", "026023", "45.83152", "12.00598", "Europe/Rome"),("3178072", "Cornedo Vicentino", "", "IT", "380", "", "20", "VI", "024034", "45.61626", "11.33225", "Europe/Rome"),("3178073", "Cornate d'Adda", "", "IT", "380", "IT", "09", "MB", "108053", "45.62811", "9.47378", "Europe/Rome"),("3178074", "Cornaredo", "", "IT", "380", "", "09", "MI", "015087", "45.50128", "9.02681", "Europe/Rome"),("3178085", "Cormons", "", "IT", "380", "", "06", "GO", "031002", "45.95531", "13.46683", "Europe/Rome"),("3178087", "Cormano", "", "IT", "380", "", "09", "MI", "015086", "45.54917", "9.15964", "Europe/Rome"),("3178095", "Corigliano d'Otranto", "", "IT", "380", "", "13", "LE", "075023", "40.15925", "18.25598", "Europe/Rome"),("3178099", "Cori", "", "IT", "380", "", "07", "LT", "059006", "41.64358", "12.91121", "Europe/Rome"),("3178112", "Cordenons", "", "IT", "380", "", "06", "PN", "093017", "45.9836", "12.70038", "Europe/Rome"),("3178116", "Corcolle", "", "IT", "380", "IT", "07", "RM", "058091", "41.90421", "12.73654", "Europe/Rome"),("3178125", "Corbetta", "", "IT", "380", "", "09", "MI", "015085", "45.46723", "8.91867", "Europe/Rome"),("3178131", "Corato", "Корато", "IT", "380", "", "13", "BA", "072020", "41.15171", "16.41143", "Europe/Rome"),("3178137", "Copparo", "", "IT", "380", "", "05", "FE", "038007", "44.89263", "11.82287", "Europe/Rome"),("3178141", "Copertino", "", "IT", "380", "", "13", "LE", "075022", "40.26821", "18.0543", "Europe/Rome"),("3178147", "Conversano", "Конверсано", "IT", "380", "", "13", "BA", "072019", "40.96836", "17.11329", "Europe/Rome"),("3178180", "Conselve", "", "IT", "380", "", "20", "PD", "028034", "45.23154", "11.87498", "Europe/Rome"),("3178197", "Conegliano", "Конельяно", "IT", "380", "", "20", "TV", "026021", "45.88805", "12.30201", "Europe/Rome"),("3178201", "Concorezzo", "", "IT", "380", "", "09", "MB", "108021", "45.58854", "9.33393", "Europe/Rome"),("3178203", "Concordia Sagittaria", "", "IT", "380", "", "20", "VE", "027011", "45.76118", "12.82362", "Europe/Rome"),("3178229", "Como", "Комо", "IT", "380", "", "09", "CO", "013075", "45.80819", "9.0832", "Europe/Rome"),("3178245", "Comacchio", "", "IT", "380", "", "05", "FE", "038006", "44.69478", "12.18194", "Europe/Rome"),("3178263", "Colorno", "", "IT", "380", "", "05", "PR", "034010", "44.92572", "10.37361", "Europe/Rome"),("3178283", "Cologno Monzese", "", "IT", "380", "", "09", "MI", "015081", "45.53004", "9.27795", "Europe/Rome"),("3178285", "Cologno al Serio", "", "IT", "380", "", "09", "BG", "016079", "45.57604", "9.70892", "Europe/Rome"),("3178287", "Cologne", "", "IT", "380", "", "09", "BS", "017059", "45.57862", "9.9418", "Europe/Rome"),("3178360", "Collepasso", "", "IT", "380", "", "13", "LE", "075021", "40.07115", "18.16222", "Europe/Rome"),("3178388", "Collegno", "Колленьо", "IT", "380", "", "12", "TO", "001090", "45.07873", "7.56735", "Europe/Rome"),("3178398", "Colleferro", "Коллеферро", "IT", "380", "", "07", "RM", "058034", "41.72722", "13.00481", "Europe/Rome"),("3178402", "Colle di Val d'Elsa", "Колле-ди-Валь-д'Эльса", "IT", "380", "IT", "16", "SI", "052012", "43.42107", "11.12739", "Europe/Rome"),("3178416", "Collecchio", "", "IT", "380", "", "05", "PR", "034009", "44.75197", "10.2154", "Europe/Rome"),("3178451", "Colico Piano", "", "IT", "380", "", "09", "LC", "097023", "46.13205", "9.37714", "Europe/Rome"),("3178479", "Cogoleto", "", "IT", "380", "", "08", "GE", "010017", "44.38996", "8.64692", "Europe/Rome"),("3178496", "Codroipo", "", "IT", "380", "", "06", "UD", "030027", "45.96469", "12.97985", "Europe/Rome"),("3178499", "Codogno", "", "IT", "380", "", "09", "LO", "098019", "45.16187", "9.70216", "Europe/Rome"),("3178505", "Codigoro", "", "IT", "380", "", "05", "FE", "038005", "44.83093", "12.11073", "Europe/Rome"),("3178534", "Coccaglio", "", "IT", "380", "", "09", "BS", "017056", "45.56399", "9.97224", "Europe/Rome"),("3178541", "Clusone", "", "IT", "380", "", "09", "BG", "016077", "45.88663", "9.94646", "Europe/Rome"),("3178548", "Cles", "", "IT", "380", "", "17", "TN", "022062", "46.36294", "11.03276", "Europe/Rome"),("3178587", "Civitavecchia", "Чивитавеккья", "IT", "380", "", "07", "RM", "058032", "42.09325", "11.79674", "Europe/Rome"),("3178595", "Civita Castellana", "", "IT", "380", "", "07", "VT", "056021", "42.29304", "12.40885", "Europe/Rome"),("3178605", "Cividale del Friuli", "", "IT", "380", "", "06", "UD", "030026", "46.09019", "13.42861", "Europe/Rome"),("3178619", "Città di Castello", "", "IT", "380", "", "18", "PG", "054013", "43.46556", "12.2375", "Europe/Rome"),("3178622", "Cittadella", "", "IT", "380", "", "20", "PD", "028032", "45.64523", "11.78453", "Europe/Rome"),("3178630", "Cisternino", "", "IT", "380", "", "13", "BR", "074005", "40.74326", "17.42587", "Europe/Rome"),("3178631", "Cisterna di Latina", "", "IT", "380", "IT", "07", "LT", "059005", "41.5908", "12.82808", "Europe/Rome"),("3178640", "Cislago", "", "IT", "380", "", "09", "VA", "012050", "45.65928", "8.97272", "Europe/Rome"),("3178642", "Ciserano", "", "IT", "380", "", "09", "BG", "016075", "45.58792", "9.60115", "Europe/Rome"),("3178650", "Ciriè", "", "IT", "380", "", "12", "TO", "001086", "45.23486", "7.60125", "Europe/Rome"),("3178670", "Capanne-Prato-Cinquale", "", "IT", "380", "", "16", "MS", "045011", "43.9972", "10.15636", "Europe/Rome"),("3178671", "Cinisello Balsamo", "", "IT", "380", "", "09", "MI", "015077", "45.55823", "9.21495", "Europe/Rome"),("3178683", "Cimitile", "", "IT", "380", "", "04", "NA", "063028", "40.94231", "14.52558", "Europe/Rome"),("3178698", "Cilavegna", "", "IT", "380", "", "09", "PV", "018050", "45.31067", "8.74469", "Europe/Rome"),("3178726", "Cicciano", "", "IT", "380", "", "04", "NA", "063027", "40.96402", "14.53487", "Europe/Rome"),("3178738", "Ciampino", "Чампино", "IT", "380", "", "07", "RM", "058118", "41.80064", "12.60158", "Europe/Rome"),("3178745", "Chivasso", "Кивассо", "IT", "380", "", "12", "TO", "001082", "45.19093", "7.88981", "Europe/Rome"),("3178784", "Chioggia", "", "IT", "380", "", "20", "VE", "027008", "45.21857", "12.27774", "Europe/Rome"),("3178796", "Chieti", "Кьети", "IT", "380", "", "01", "CH", "069022", "42.34827", "14.16494", "Europe/Rome"),("3178818", "Chieri", "", "IT", "380", "", "12", "TO", "001078", "45.01054", "7.82133", "Europe/Rome"),("3178829", "Chiavenna", "", "IT", "380", "", "09", "SO", "014018", "46.32063", "9.39816", "Europe/Rome"),("3178832", "Chiavari", "Киавари", "IT", "380", "", "08", "GE", "010015", "44.31771", "9.32241", "Europe/Rome"),("3178850", "Chiari", "", "IT", "380", "", "09", "BS", "017052", "45.53763", "9.92699", "Europe/Rome"),("3178855", "Chiaravalle", "", "IT", "380", "", "10", "AN", "042014", "43.60114", "13.32511", "Europe/Rome"),("3178874", "Chianciano Terme", "", "IT", "380", "", "16", "SI", "052009", "43.04181", "11.81205", "Europe/Rome"),("3178884", "Chiampo", "", "IT", "380", "", "20", "VI", "024029", "45.54746", "11.28285", "Europe/Rome"),("3178956", "Cesenatico", "Чезенатико", "IT", "380", "", "05", "FC", "040008", "44.19987", "12.3991", "Europe/Rome"),("3178957", "Cesena", "", "IT", "380", "", "05", "FC", "040007", "44.1391", "12.24315", "Europe/Rome"),("3178972", "Cesano Maderno", "", "IT", "380", "", "09", "MB", "108019", "45.62915", "9.15189", "Europe/Rome"),("3178974", "Cesano", "", "IT", "380", "", "07", "RM", "058091", "42.07375", "12.33711", "Europe/Rome"),("3178984", "Cesa", "", "IT", "380", "", "04", "CE", "061029", "40.96287", "14.23081", "Europe/Rome"),("3178992", "Cervignano del Friuli", "", "IT", "380", "", "06", "UD", "030023", "45.82082", "13.33929", "Europe/Rome"),("3178998", "Cervia", "Червиа", "IT", "380", "", "05", "RA", "039007", "44.26204", "12.34812", "Europe/Rome"),("3178999", "Cerveteri", "Черветери", "IT", "380", "", "07", "RM", "058029", "41.9908", "12.09082", "Europe/Rome"),("3179024", "Certaldo", "", "IT", "380", "", "16", "FI", "048012", "43.54768", "11.03924", "Europe/Rome"),("3179027", "Cerro Maggiore", "", "IT", "380", "", "09", "MI", "015072", "45.59366", "8.95428", "Europe/Rome"),("3179066", "Cernusco sul Naviglio", "", "IT", "380", "", "09", "MI", "015070", "45.52526", "9.33297", "Europe/Rome"),("3179067", "Cernobbio", "", "IT", "380", "", "09", "CO", "013065", "45.84307", "9.07194", "Europe/Rome"),("3179070", "Cermenate", "", "IT", "380", "", "09", "CO", "013064", "45.70198", "9.08361", "Europe/Rome"),("3179075", "Cerignola", "", "IT", "380", "", "13", "FG", "071020", "41.26523", "15.89559", "Europe/Rome"),("3179076", "Ceriano Laghetto", "", "IT", "380", "", "09", "MB", "108018", "45.62928", "9.08017", "Europe/Rome"),("3179079", "Ceriale", "", "IT", "380", "", "08", "SV", "009024", "44.09128", "8.22893", "Europe/Rome"),("3179097", "Cerese", "", "IT", "380", "", "09", "MN", "020071", "45.11814", "10.78877", "Europe/Rome"),("3179106", "Cerea", "", "IT", "380", "", "20", "VR", "023025", "45.18936", "11.21661", "Europe/Rome"),("3179109", "Cercola", "", "IT", "380", "", "04", "NA", "063026", "40.86043", "14.35733", "Europe/Rome"),("3179137", "Cerano", "", "IT", "380", "", "12", "NO", "003049", "45.40915", "8.78351", "Europe/Rome"),("3179141", "Ceprano", "", "IT", "380", "", "07", "FR", "060025", "41.54572", "13.51473", "Europe/Rome"),("3179149", "Ceparana-Carpena", "", "IT", "380", "IT", "08", "SP", "011004", "44.16667", "9.88333", "Europe/Rome"),("3179162", "Cento", "Ченто", "IT", "380", "", "05", "FE", "038004", "44.73099", "11.28716", "Europe/Rome"),("3179188", "Cellole", "", "IT", "380", "", "04", "CE", "061102", "41.20338", "13.85332", "Europe/Rome"),("3179190", "Cellino San Marco", "", "IT", "380", "", "13", "BR", "074004", "40.47133", "17.96427", "Europe/Rome"),("3179208", "Cellamare", "", "IT", "380", "", "13", "BA", "072018", "41.01969", "16.92741", "Europe/Rome"),("3179216", "Celano", "", "IT", "380", "", "01", "AQ", "066032", "42.08077", "13.517", "Europe/Rome"),("3179218", "Ceglie Messapica", "", "IT", "380", "", "13", "BR", "074003", "40.6462", "17.51661", "Europe/Rome"),("3179220", "Ceggia", "", "IT", "380", "", "20", "VE", "027007", "45.687", "12.64228", "Europe/Rome"),("3179235", "Cecina", "Чечина", "IT", "380", "", "16", "LI", "049007", "43.30621", "10.51729", "Europe/Rome"),("3179241", "Cecchina", "", "IT", "380", "", "07", "RM", "058003", "41.70161", "12.64972", "Europe/Rome"),("3179243", "Ceccano", "", "IT", "380", "", "07", "FR", "060024", "41.57236", "13.32901", "Europe/Rome"),("3179254", "Cavriago", "", "IT", "380", "", "05", "RE", "035017", "44.69457", "10.52591", "Europe/Rome"),("3179272", "Cavezzo", "", "IT", "380", "", "05", "MO", "036009", "44.835", "11.0289", "Europe/Rome"),("3179279", "Cavenago di Brianza", "", "IT", "380", "", "09", "MB", "108017", "45.58297", "9.41261", "Europe/Rome"),("3179288", "Cave", "", "IT", "380", "", "07", "RM", "058026", "41.81682", "12.94055", "Europe/Rome"),("3179294", "Cavarzere", "", "IT", "380", "", "20", "VE", "027006", "45.13518", "12.08453", "Europe/Rome"),("3179297", "Cavaria Con Premezzo", "", "IT", "380", "", "09", "VA", "012048", "45.69247", "8.80299", "Europe/Rome"),("3179323", "Cavallino", "", "IT", "380", "", "13", "LE", "075020", "40.3102", "18.20221", "Europe/Rome"),("3179337", "Cava Dè Tirreni", "", "IT", "380", "", "04", "SA", "065037", "40.69954", "14.70773", "Europe/Rome"),("3179347", "Cattolica", "", "IT", "380", "", "05", "RN", "099002", "43.96182", "12.73631", "Europe/Rome"),("3179405", "Castiglion Fiorentino", "", "IT", "380", "", "16", "AR", "051012", "43.34308", "11.91995", "Europe/Rome"),("3179407", "Castiglione Olona", "", "IT", "380", "", "09", "VA", "012046", "45.75256", "8.87278", "Europe/Rome"),("3179415", "Castiglione delle Stiviere", "", "IT", "380", "", "09", "MN", "020017", "45.3902", "10.48619", "Europe/Rome"),("3179419", "Castiglione del Lago", "", "IT", "380", "", "18", "PG", "054009", "43.12457", "12.03982", "Europe/Rome"),("3179440", "Castenedolo", "", "IT", "380", "", "09", "BS", "017043", "45.4743", "10.29131", "Europe/Rome"),("3179441", "Castenaso", "", "IT", "380", "", "05", "BO", "037021", "44.51398", "11.46842", "Europe/Rome"),("3179443", "Castel Volturno", "", "IT", "380", "", "04", "CE", "061027", "41.03288", "13.94354", "Europe/Rome"),("3179479", "Castel San Pietro Terme", "", "IT", "380", "", "05", "BO", "037020", "44.39854", "11.58546", "Europe/Rome"),("3179485", "Castel San Giovanni", "", "IT", "380", "", "05", "PC", "033013", "45.06014", "9.43784", "Europe/Rome"),("3179488", "Castel San Giorgio", "", "IT", "380", "", "04", "SA", "065034", "40.78198", "14.7009", "Europe/Rome"),("3179514", "Castelnuovo Rangone", "", "IT", "380", "", "05", "MO", "036007", "44.54935", "10.9335", "Europe/Rome"),("3179546", "Castelnovo ne'Monti", "", "IT", "380", "", "05", "RE", "035016", "44.43556", "10.40329", "Europe/Rome"),("3179547", "Castelnovo di Sotto", "", "IT", "380", "", "05", "RE", "035015", "44.81253", "10.56694", "Europe/Rome"),("3179555", "Castel Mella", "", "IT", "380", "", "09", "BS", "017042", "45.49913", "10.14553", "Europe/Rome"),("3179560", "Castel Maggiore", "", "IT", "380", "", "05", "BO", "037019", "44.57707", "11.36071", "Europe/Rome"),("3179561", "Castel Madama", "", "IT", "380", "", "07", "RM", "058023", "41.9735", "12.86782", "Europe/Rome"),("3179596", "Aviano-Castello", "", "IT", "380", "", "06", "PN", "093004", "46.06759", "12.58324", "Europe/Rome"),("3179625", "Castelli Calepio", "", "IT", "380", "", "09", "BG", "016062", "45.61316", "9.8854", "Europe/Rome"),("3179629", "Castelletto Sopra Ticino", "", "IT", "380", "", "12", "NO", "003043", "45.72002", "8.63362", "Europe/Rome"),("3179636", "Castelleone", "", "IT", "380", "", "09", "CR", "019025", "45.29579", "9.76091", "Europe/Rome"),("3179649", "Castellarano", "", "IT", "380", "", "05", "RE", "035014", "44.51825", "10.73727", "Europe/Rome"),("3179650", "Castellanza", "", "IT", "380", "", "09", "VA", "012042", "45.61079", "8.89616", "Europe/Rome"),("3179655", "Castellaneta", "", "IT", "380", "", "13", "TA", "073003", "40.62794", "16.9329", "Europe/Rome"),("3179656", "Castellana", "", "IT", "380", "", "13", "BA", "072017", "40.88643", "17.16549", "Europe/Rome"),("3179659", "Castellamonte", "", "IT", "380", "", "12", "TO", "001066", "45.38267", "7.70886", "Europe/Rome"),("3179661", "Castellammare di Stabia", "", "IT", "380", "", "04", "NA", "063024", "40.70211", "14.48685", "Europe/Rome"),("3179675", "Castel Goffredo", "", "IT", "380", "", "09", "MN", "020015", "45.29403", "10.473", "Europe/Rome"),("3179684", "Castelfranco Veneto", "", "IT", "380", "", "20", "TV", "026012", "45.67146", "11.92755", "Europe/Rome"),("3179686", "Castelfranco Emilia", "", "IT", "380", "", "05", "MO", "036006", "44.59445", "11.04979", "Europe/Rome"),("3179687", "Castelfranco di Sotto", "", "IT", "380", "", "16", "PI", "050009", "43.70368", "10.7463", "Europe/Rome"),("3179696", "Castelfiorentino", "", "IT", "380", "", "16", "FI", "048010", "43.60963", "10.96772", "Europe/Rome"),("3179697", "Castelfidardo", "", "IT", "380", "", "10", "AN", "042010", "43.45916", "13.55044", "Europe/Rome"),("3179703", "Castel di Sangro", "", "IT", "380", "", "01", "AQ", "066028", "41.78392", "14.10653", "Europe/Rome"),("3179735", "Castel Bolognese", "", "IT", "380", "", "05", "RA", "039006", "44.31981", "11.79903", "Europe/Rome"),("3179744", "Castegnato", "", "IT", "380", "", "09", "BS", "017040", "45.56129", "10.11449", "Europe/Rome"),("3179745", "Casteggio", "", "IT", "380", "", "09", "PV", "018037", "45.01396", "9.12528", "Europe/Rome"),("3179749", "Castano Primo", "", "IT", "380", "", "09", "MI", "015062", "45.55175", "8.77562", "Europe/Rome"),("3179778", "Cassolnovo", "", "IT", "380", "", "09", "PV", "018035", "45.36106", "8.8123", "Europe/Rome"),("3179781", "Cassino", "Кассино", "IT", "380", "", "07", "FR", "060019", "41.48581", "13.82835", "Europe/Rome"),("3179787", "Cassina de' Pecchi", "", "IT", "380", "", "09", "MI", "015060", "45.51637", "9.35975", "Europe/Rome"),("3179794", "Cassano delle Murge", "", "IT", "380", "", "13", "BA", "072016", "40.89112", "16.76531", "Europe/Rome"),("3179795", "Cassano d'Adda", "", "IT", "380", "", "09", "MI", "015059", "45.52637", "9.51528", "Europe/Rome"),("3179806", "Casoria", "", "IT", "380", "", "04", "NA", "063023", "40.90751", "14.293", "Europe/Rome"),("3179807", "Casorezzo", "", "IT", "380", "", "09", "MI", "015058", "45.52265", "8.90186", "Europe/Rome"),("3179808", "Casorate Sempione", "", "IT", "380", "", "09", "VA", "012039", "45.67079", "8.74513", "Europe/Rome"),("3179809", "Casorate Primo", "", "IT", "380", "", "09", "PV", "018034", "45.31142", "9.01703", "Europe/Rome"),("3179866", "Caserta", "Казерта", "IT", "380", "", "04", "CE", "061022", "41.07262", "14.33231", "Europe/Rome"),("3179911", "Caselle Torinese", "", "IT", "380", "", "12", "TO", "001063", "45.17458", "7.6429", "Europe/Rome"),("3179977", "Cascina", "", "IT", "380", "", "16", "PI", "050008", "43.67557", "10.55494", "Europe/Rome"),("3180014", "Casatenovo", "", "IT", "380", "", "09", "LC", "097016", "45.69514", "9.31338", "Europe/Rome"),("3180045", "Casarsa della Delizia", "", "IT", "380", "", "06", "PN", "093010", "45.95091", "12.8425", "Europe/Rome"),("3180072", "Casapulla", "", "IT", "380", "", "04", "CE", "061021", "41.07665", "14.28927", "Europe/Rome"),("3180110", "Casandrino", "", "IT", "380", "", "04", "NA", "063020", "40.92845", "14.24744", "Europe/Rome"),("3180133", "Casamassima", "", "IT", "380", "", "13", "BA", "072015", "40.95653", "16.92075", "Europe/Rome"),("3180161", "Casaluce", "", "IT", "380", "", "04", "CE", "061020", "40.99785", "14.19671", "Europe/Rome"),("3180168", "Casalpusterlengo", "", "IT", "380", "", "09", "LO", "098010", "45.17921", "9.64834", "Europe/Rome"),("3180172", "Casalnuovo di Napoli", "", "IT", "380", "", "04", "NA", "063017", "40.90969", "14.34205", "Europe/Rome"),("3180177", "Casalmaggiore", "", "IT", "380", "", "09", "CR", "019021", "44.98981", "10.42055", "Europe/Rome"),("3180191", "Casalgrande", "", "IT", "380", "", "05", "RE", "035012", "44.58466", "10.7355", "Europe/Rome"),("3180197", "Casale sul Sile", "", "IT", "380", "", "20", "TV", "026009", "45.59638", "12.32655", "Europe/Rome"),("3180208", "Casale Monferrato", "", "IT", "380", "", "12", "AL", "006039", "45.13338", "8.4525", "Europe/Rome"),("3180224", "Casalecchio di Reno", "", "IT", "380", "", "05", "BO", "037011", "44.47563", "11.27495", "Europe/Rome"),("3180240", "Casal di Principe", "", "IT", "380", "", "04", "CE", "061019", "41.00996", "14.13013", "Europe/Rome"),("3180247", "Casalbordino-Miracoli", "", "IT", "380", "", "01", "CH", "069015", "42.15354", "14.59912", "Europe/Rome"),("3180389", "Carugate", "", "IT", "380", "", "09", "MI", "015051", "45.54983", "9.34044", "Europe/Rome"),("3180423", "Carrara", "Каррара", "IT", "380", "", "16", "MS", "045003", "44.07926", "10.09789", "Europe/Rome"),("3180445", "Carpi Centro", "Карпи", "IT", "380", "", "05", "MO", "036005", "44.78237", "10.8777", "Europe/Rome"),("3180450", "Carpenedolo", "", "IT", "380", "", "09", "BS", "017039", "45.36169", "10.43124", "Europe/Rome"),("3180462", "Carovigno", "", "IT", "380", "", "13", "BR", "074002", "40.70626", "17.65847", "Europe/Rome"),("3180466", "Carosino", "", "IT", "380", "", "13", "TA", "073002", "40.46538", "17.39857", "Europe/Rome"),("3180483", "Carnate", "", "IT", "380", "", "09", "MB", "108016", "45.64843", "9.37813", "Europe/Rome"),("3180488", "Carnago", "", "IT", "380", "", "09", "VA", "012033", "45.72207", "8.83423", "Europe/Rome"),("3180491", "Carmignano di Brenta", "", "IT", "380", "", "20", "PD", "028023", "45.62578", "11.70599", "Europe/Rome"),("3180495", "Carmiano", "", "IT", "380", "", "13", "LE", "075014", "40.34404", "18.04195", "Europe/Rome"),("3180496", "Carmagnola", "Карманьола", "IT", "380", "", "12", "TO", "001059", "44.84963", "7.72032", "Europe/Rome"),("3180511", "Carignano", "", "IT", "380", "", "12", "TO", "001058", "44.90599", "7.67253", "Europe/Rome"),("3180541", "Cardito", "", "IT", "380", "", "04", "NA", "063016", "40.9459", "14.29952", "Europe/Rome"),("3180557", "Carcare", "", "IT", "380", "", "08", "SV", "009018", "44.35465", "8.29039", "Europe/Rome"),("3180580", "Caravaggio", "", "IT", "380", "", "09", "BG", "016053", "45.49627", "9.64165", "Europe/Rome"),("3180581", "Carate Brianza", "", "IT", "380", "", "09", "MB", "108015", "45.67574", "9.23723", "Europe/Rome"),("3180588", "Carapelle", "", "IT", "380", "", "13", "FG", "071010", "41.36365", "15.69384", "Europe/Rome"),("3180600", "Capurso", "", "IT", "380", "", "13", "BA", "072014", "41.04598", "16.92168", "Europe/Rome"),("3180601", "Capua", "Капуя", "IT", "380", "", "04", "CE", "061015", "41.10519", "14.21269", "Europe/Rome"),("3180608", "Capriolo", "", "IT", "380", "", "09", "BS", "017038", "45.63333", "9.93189", "Europe/Rome"),("3180625", "Capriate San Gervasio", "", "IT", "380", "", "09", "BG", "016051", "45.61258", "9.52875", "Europe/Rome"),("3180626", "Capriate San Gervasio", "", "IT", "380", "", "09", "BG", "016051", "45.61281", "9.52974", "Europe/Rome"),("3180630", "Capri", "", "IT", "380", "", "04", "NA", "063014", "40.55073", "14.24263", "Europe/Rome"),("3180644", "Capranica", "", "IT", "380", "", "07", "VT", "056014", "42.25849", "12.17278", "Europe/Rome"),("3180682", "Capodrise", "", "IT", "380", "", "04", "CE", "061013", "41.04268", "14.30607", "Europe/Rome"),("3180725", "Capena", "", "IT", "380", "", "07", "RM", "058018", "42.14247", "12.54513", "Europe/Rome"),("3180733", "Capannori", "Капаннори", "IT", "380", "", "16", "LU", "046007", "43.84171", "10.57271", "Europe/Rome"),("3180749", "Caorle", "", "IT", "380", "", "20", "VE", "027005", "45.59656", "12.8758", "Europe/Rome"),("3180754", "Canzo", "", "IT", "380", "", "09", "CO", "013042", "45.84867", "9.27063", "Europe/Rome"),("3180758", "Cantù", "", "IT", "380", "", "09", "CO", "013041", "45.74096", "9.13084", "Europe/Rome"),("3180789", "Olgiate Molgora", "", "IT", "380", "", "09", "LC", "097058", "45.73028", "9.40335", "Europe/Rome"),("3180792", "Canosa di Puglia", "", "IT", "380", "", "13", "BT", "110004", "41.21954", "16.06768", "Europe/Rome"),("3180844", "Caneva", "", "IT", "380", "", "06", "PN", "093009", "45.97078", "12.45261", "Europe/Rome"),("3180850", "Canelli", "", "IT", "380", "", "12", "AT", "005017", "44.72084", "8.29282", "Europe/Rome"),("3180852", "Canegrate", "", "IT", "380", "", "09", "MI", "015046", "45.56825", "8.92689", "Europe/Rome"),("3180861", "Candiolo", "", "IT", "380", "", "12", "TO", "001051", "44.95858", "7.59812", "Europe/Rome"),("3180871", "Candelo", "", "IT", "380", "", "12", "BI", "096012", "45.54093", "8.10659", "Europe/Rome"),("3180902", "Camucia-Monsigliolo", "", "IT", "380", "", "16", "AR", "051017", "43.25926", "11.97114", "Europe/Rome"),("3180918", "Camposano", "", "IT", "380", "", "04", "NA", "063013", "40.95242", "14.52991", "Europe/Rome"),("3180920", "Camposampiero", "", "IT", "380", "", "20", "PD", "028019", "45.56368", "11.93534", "Europe/Rome"),("3180937", "Camponogara", "", "IT", "380", "", "20", "VE", "027004", "45.37954", "12.08638", "Europe/Rome"),("3180970", "Campogalliano", "", "IT", "380", "", "05", "MO", "036003", "44.68874", "10.84705", "Europe/Rome"),("3180983", "Campodarsego", "", "IT", "380", "", "20", "PD", "028017", "45.49815", "11.92194", "Europe/Rome"),("3180991", "Campobasso", "Кампобассо", "IT", "380", "", "11", "CB", "070006", "41.55947", "14.66737", "Europe/Rome"),("3181005", "Campi Salentina", "", "IT", "380", "", "13", "LE", "075011", "40.39747", "18.02141", "Europe/Rome"),("3181018", "Campi Bisenzio", "", "IT", "380", "", "16", "FI", "048006", "43.8245", "11.13027", "Europe/Rome"),("3181061", "Campagnano di Roma", "", "IT", "380", "", "07", "RM", "058015", "42.1357", "12.37358", "Europe/Rome"),("3181075", "Camisano Vicentino", "", "IT", "380", "", "20", "VI", "024021", "45.52156", "11.70817", "Europe/Rome"),("3181096", "Cameri", "", "IT", "380", "", "12", "NO", "003032", "45.50159", "8.66245", "Europe/Rome"),("3181102", "Camerano", "", "IT", "380", "", "10", "AN", "042006", "43.52774", "13.55257", "Europe/Rome"),("3181111", "Cambiano", "", "IT", "380", "", "12", "TO", "001048", "44.97113", "7.77447", "Europe/Rome"),("3181112", "Cambiago", "", "IT", "380", "", "09", "MI", "015044", "45.58035", "9.43528", "Europe/Rome"),("3181125", "Camaiore", "Камайоре", "IT", "380", "", "16", "LU", "046005", "43.94265", "10.29754", "Europe/Rome"),("3181140", "Calvizzano", "", "IT", "380", "", "04", "NA", "063012", "40.90782", "14.18581", "Europe/Rome"),("3181164", "Caluso", "", "IT", "380", "", "12", "TO", "001047", "45.30466", "7.89101", "Europe/Rome"),("3181165", "Calusco d'Adda", "", "IT", "380", "", "09", "BG", "016046", "45.68841", "9.47109", "Europe/Rome"),("3181176", "Calolziocorte", "", "IT", "380", "", "09", "LC", "097013", "45.79538", "9.43765", "Europe/Rome"),("3181189", "Calimera", "", "IT", "380", "", "13", "LE", "075010", "40.24948", "18.27982", "Europe/Rome"),("3181199", "Calenzano", "", "IT", "380", "", "16", "FI", "048005", "43.85447", "11.16608", "Europe/Rome"),("3181209", "Caldogno-Rettorgole-Cresole", "", "IT", "380", "", "20", "VI", "024018", "45.6078", "11.5028", "Europe/Rome"),("3181212", "Calderara di Reno", "", "IT", "380", "", "05", "BO", "037009", "44.56307", "11.27111", "Europe/Rome"),("3181215", "Caldaro sulla Strada del Vino", "", "IT", "380", "IT", "17", "BZ", "021015", "46.41326", "11.24616", "Europe/Rome"),("3181222", "Calcinelli", "", "IT", "380", "", "10", "PU", "041050", "43.75398", "12.91959", "Europe/Rome"),("3181223", "Calcinato", "", "IT", "380", "", "09", "BS", "017032", "45.45739", "10.40949", "Europe/Rome"),("3181224", "Calcinate", "", "IT", "380", "", "09", "BG", "016043", "45.61975", "9.79843", "Europe/Rome"),("3181258", "Caivano", "Кайвано", "IT", "380", "", "04", "NA", "063011", "40.95753", "14.30591", "Europe/Rome"),("3181259", "Cairo Montenotte", "", "IT", "380", "", "08", "SV", "009015", "44.3979", "8.27775", "Europe/Rome"),("3181274", "Cagnano Varano", "", "IT", "380", "IT", "13", "FG", "071008", "41.82832", "15.77203", "Europe/Rome"),("3181277", "Cagli", "", "IT", "380", "", "10", "PU", "041007", "43.54771", "12.65229", "Europe/Rome"),("3181284", "Caerano di San Marco", "", "IT", "380", "", "20", "TV", "026006", "45.7816", "11.99851", "Europe/Rome"),("3181311", "Cadelbosco di Sopra", "", "IT", "380", "", "05", "RE", "035008", "44.76573", "10.59898", "Europe/Rome"),("3181354", "Busto Garolfo", "", "IT", "380", "", "09", "MI", "015041", "45.54809", "8.88298", "Europe/Rome"),("3181355", "Busto Arsizio", "", "IT", "380", "", "09", "VA", "012026", "45.61128", "8.84914", "Europe/Rome"),("3181358", "Bussoleno", "", "IT", "380", "", "12", "TO", "001044", "45.1397", "7.14432", "Europe/Rome"),("3181359", "Bussolengo", "", "IT", "380", "", "20", "VR", "023015", "45.46903", "10.85371", "Europe/Rome"),("3181380", "Busca", "", "IT", "380", "", "12", "CN", "004034", "44.51625", "7.47662", "Europe/Rome"),("3181383", "Busalla", "", "IT", "380", "", "08", "GE", "010006", "44.5706", "8.94545", "Europe/Rome"),("3181424", "Buia", "", "IT", "380", "", "06", "UD", "030013", "46.21222", "13.11691", "Europe/Rome"),("3181443", "Budrio", "", "IT", "380", "", "05", "BO", "037008", "44.53745", "11.53439", "Europe/Rome"),("3181471", "Brusciano", "", "IT", "380", "", "04", "NA", "063010", "40.92237", "14.42386", "Europe/Rome"),("3181480", "Brunico", "", "IT", "380", "", "17", "BZ", "021013", "46.79942", "11.93429", "Europe/Rome"),("3181488", "Bruino", "", "IT", "380", "", "12", "TO", "001038", "45.01506", "7.47754", "Europe/Rome"),("3181492", "Brugnera", "", "IT", "380", "", "06", "PN", "093007", "45.89947", "12.54178", "Europe/Rome"),("3181495", "Brugherio", "Бругерио", "IT", "380", "", "09", "MB", "108012", "45.55301", "9.29907", "Europe/Rome"),("3181507", "Broni", "", "IT", "380", "", "09", "PV", "018024", "45.06394", "9.25993", "Europe/Rome"),("3181528", "Brindisi", "Бриндизи", "IT", "380", "", "13", "BR", "074001", "40.63215", "17.93607", "Europe/Rome"),("3181532", "Brignano Gera d'Adda", "", "IT", "380", "", "09", "BG", "016040", "45.54324", "9.64424", "Europe/Rome"),("3181548", "Bresso", "Брессо", "IT", "380", "", "09", "MI", "015032", "45.53792", "9.18921", "Europe/Rome"),("3181550", "Bressanone", "Брессаноне", "IT", "380", "", "17", "BZ", "021011", "46.71503", "11.65598", "Europe/Rome"),("3181554", "Brescia", "Брешия", "IT", "380", "", "09", "BS", "017029", "45.53558", "10.21472", "Europe/Rome"),("3181577", "Brembate", "", "IT", "380", "", "09", "BG", "016037", "45.60468", "9.5548", "Europe/Rome"),("3181583", "Breganze", "", "IT", "380", "", "20", "VI", "024014", "45.70489", "11.56074", "Europe/Rome"),("3181605", "Brandizzo", "", "IT", "380", "", "12", "TO", "001034", "45.17706", "7.83581", "Europe/Rome"),("3181622", "Bracigliano", "", "IT", "380", "", "04", "SA", "065016", "40.8188", "14.70772", "Europe/Rome"),("3181628", "Bracciano", "", "IT", "380", "", "07", "RM", "058013", "42.10271", "12.16565", "Europe/Rome"),("3181631", "Bra", "", "IT", "380", "", "12", "CN", "004029", "44.69776", "7.85128", "Europe/Rome"),("3181637", "Bovolone", "", "IT", "380", "", "20", "VR", "023012", "45.26142", "11.11786", "Europe/Rome"),("3181641", "Bovisio-Masciago", "", "IT", "380", "", "09", "MB", "108010", "45.61019", "9.15301", "Europe/Rome"),("3181647", "Bovezzo", "", "IT", "380", "", "09", "BS", "017025", "45.58998", "10.24184", "Europe/Rome"),("3181648", "Boves", "", "IT", "380", "", "12", "CN", "004028", "44.32985", "7.54733", "Europe/Rome"),("3181662", "Botticino", "", "IT", "380", "", "09", "BS", "017023", "45.52972", "10.31085", "Europe/Rome"),("3181668", "Bottanuco", "", "IT", "380", "", "09", "BG", "016034", "45.63931", "9.50903", "Europe/Rome"),("3181680", "Boscotrecase", "", "IT", "380", "", "04", "NA", "063009", "40.77296", "14.46185", "Europe/Rome"),("3181683", "Boscoreale", "Боскореале", "IT", "380", "", "04", "NA", "063008", "40.77274", "14.48118", "Europe/Rome"),("3181706", "Bosa", "", "IT", "380", "", "14", "OR", "095079", "40.29927", "8.49827", "Europe/Rome"),("3181746", "Borgo Val di Taro", "", "IT", "380", "", "05", "PR", "034006", "44.48899", "9.76906", "Europe/Rome"),("3181749", "Borgosesia", "", "IT", "380", "", "12", "VC", "002016", "45.72045", "8.27466", "Europe/Rome"),("3181750", "Borgosatollo", "", "IT", "380", "", "09", "BS", "017021", "45.4769", "10.2403", "Europe/Rome"),("3181754", "Borgo San Lorenzo", "", "IT", "380", "", "16", "FI", "048004", "43.95548", "11.38561", "Europe/Rome"),("3181757", "Borgo San Dalmazzo", "", "IT", "380", "", "12", "CN", "004025", "44.33785", "7.4931", "Europe/Rome"),("3181762", "Borgoricco-San Michele delle Badesse-Sant'Eufemia", "", "IT", "380", "", "20", "PD", "028013", "45.5352", "11.94111", "Europe/Rome"),("3181779", "Borgonovo Valtidone", "", "IT", "380", "", "05", "PC", "033006", "45.01436", "9.44346", "Europe/Rome"),("3181790", "Borgomanero", "", "IT", "380", "", "12", "NO", "003024", "45.69935", "8.46222", "Europe/Rome"),("3181819", "Borgo a Buggiano", "", "IT", "380", "", "16", "PT", "047003", "43.87522", "10.73482", "Europe/Rome"),("3181822", "Borgo", "", "IT", "380", "", "17", "TN", "022022", "46.05119", "11.45756", "Europe/Rome"),("3181850", "Borgaro Torinese", "", "IT", "380", "", "12", "TO", "001028", "45.15122", "7.65543", "Europe/Rome"),("3181854", "Boretto", "", "IT", "380", "", "05", "RE", "035005", "44.90157", "10.55147", "Europe/Rome"),("3181864", "Bordighera", "", "IT", "380", "", "08", "IM", "008008", "43.78064", "7.66451", "Europe/Rome"),("3181891", "Bondeno", "", "IT", "380", "", "05", "FE", "038003", "44.88944", "11.41542", "Europe/Rome"),("3181896", "Bonate Sopra", "", "IT", "380", "", "09", "BG", "016030", "45.68179", "9.55956", "Europe/Rome"),("3181913", "Bolzano", "Больцано", "IT", "380", "", "17", "BZ", "021008", "46.49067", "11.33982", "Europe/Rome"),("3181928", "Bologna", "Болонья", "IT", "380", "", "05", "BO", "037006", "44.49381", "11.33875", "Europe/Rome"),("3181931", "Bollate", "", "IT", "380", "", "09", "MI", "015027", "45.54647", "9.12054", "Europe/Rome"),("3181939", "Bojano", "", "IT", "380", "", "11", "CB", "070003", "41.4853", "14.47075", "Europe/Rome"),("3181971", "Darfo Boario Terme", "", "IT", "380", "", "09", "BS", "017065", "45.8915", "10.18879", "Europe/Rome"),("3181994", "Bitritto", "", "IT", "380", "", "13", "BA", "072012", "41.04336", "16.82682", "Europe/Rome"),("3181995", "Bitonto", "", "IT", "380", "", "13", "BA", "072011", "41.11006", "16.69086", "Europe/Rome"),("3181996", "Bitetto", "", "IT", "380", "", "13", "BA", "072010", "41.04146", "16.74806", "Europe/Rome"),("3182007", "Bisceglie", "Бишеллье", "IT", "380", "", "13", "BT", "110003", "41.24264", "16.50104", "Europe/Rome"),("3182027", "Binasco", "", "IT", "380", "", "09", "MI", "015024", "45.33102", "9.0944", "Europe/Rome"),("3182040", "Bientina", "", "IT", "380", "", "16", "PI", "050001", "43.70826", "10.62116", "Europe/Rome"),("3182043", "Biella", "Бьелла", "IT", "380", "", "12", "BI", "096004", "45.56304", "8.05796", "Europe/Rome"),("3182059", "Bibbiena", "", "IT", "380", "", "16", "AR", "051004", "43.69876", "11.81474", "Europe/Rome"),("3182060", "Bibbiano", "", "IT", "380", "", "05", "RE", "035004", "44.66292", "10.47391", "Europe/Rome"),("3182066", "Biassono", "", "IT", "380", "", "09", "MB", "108009", "45.62864", "9.27124", "Europe/Rome"),("3182111", "Besozzo", "", "IT", "380", "", "09", "VA", "012013", "45.84889", "8.66517", "Europe/Rome"),("3182112", "Besnate", "", "IT", "380", "", "09", "VA", "012012", "45.69858", "8.76734", "Europe/Rome"),("3182119", "Besana in Brianza", "", "IT", "380", "", "09", "MB", "108008", "45.70235", "9.2947", "Europe/Rome"),("3182153", "Bernalda", "", "IT", "380", "", "02", "MT", "077003", "40.41261", "16.68919", "Europe/Rome"),("3182164", "Bergamo", "Бергамо", "IT", "380", "", "09", "BG", "016024", "45.69601", "9.66721", "Europe/Rome"),("3182179", "Benevento", "Беневенто", "IT", "380", "", "04", "BN", "062008", "41.1307", "14.77816", "Europe/Rome"),("3182210", "Belluno", "Беллуно", "IT", "380", "", "20", "BL", "025006", "46.14262", "12.2156", "Europe/Rome"),("3182221", "Bellinzago Novarese", "", "IT", "380", "", "12", "NO", "003016", "45.56877", "8.64323", "Europe/Rome"),("3182237", "Belgioioso", "", "IT", "380", "", "09", "PV", "018013", "45.15933", "9.31347", "Europe/Rome"),("3182245", "Beinasco", "", "IT", "380", "", "12", "TO", "001024", "45.02472", "7.58564", "Europe/Rome"),("3182260", "Bazzano", "", "IT", "380", "", "05", "BO", "037061", "44.50176", "11.08675", "Europe/Rome"),("3182272", "Battipaglia", "", "IT", "380", "", "04", "SA", "065014", "40.60861", "14.98209", "Europe/Rome"),("3182289", "Bastia umbra", "", "IT", "380", "", "18", "PG", "054002", "43.06425", "12.54612", "Europe/Rome"),("3182297", "Bassano del Grappa", "Бассано-дель-Граппа", "IT", "380", "", "20", "VI", "024012", "45.76656", "11.72739", "Europe/Rome"),("3182325", "Barzanò", "", "IT", "380", "", "09", "LC", "097006", "45.73257", "9.3136", "Europe/Rome"),("3182337", "Baronissi", "", "IT", "380", "", "04", "SA", "065013", "40.74817", "14.7738", "Europe/Rome"),("3182340", "Barletta", "Барлетта", "IT", "380", "", "13", "BT", "110002", "41.31429", "16.28165", "Europe/Rome"),("3182341", "Barlassina", "", "IT", "380", "", "09", "MB", "108005", "45.65558", "9.12878", "Europe/Rome"),("3182351", "Bari", "Бари", "IT", "380", "", "13", "BA", "072006", "41.11148", "16.8554", "Europe/Rome"),("3182361", "Bareggio", "", "IT", "380", "", "09", "MI", "015012", "45.47927", "8.99789", "Europe/Rome"),("3182390", "Barberino di Mugello", "", "IT", "380", "", "16", "FI", "048002", "43.9993", "11.23676", "Europe/Rome"),("3182410", "Baranzate", "", "IT", "380", "", "09", "MI", "015250", "45.52717", "9.11724", "Europe/Rome"),("3182411", "Barano d'Ischia", "", "IT", "380", "IT", "04", "NA", "063007", "40.71472", "13.92522", "Europe/Rome"),("3182500", "Bagnolo Mella", "", "IT", "380", "", "09", "BS", "017009", "45.42765", "10.18638", "Europe/Rome"),("3182501", "Bagnolo in Piano", "", "IT", "380", "", "05", "RE", "035002", "44.76437", "10.67358", "Europe/Rome"),("3182518", "Bagnoli", "Баньоли", "IT", "380", "", "04", "NA", "063049", "40.81322", "14.16807", "Europe/Rome"),("3182522", "Bagno a Ripoli", "", "IT", "380", "", "16", "FI", "048001", "43.75115", "11.32252", "Europe/Rome"),("3182533", "Bagni di Tivoli", "", "IT", "380", "", "07", "RM", "058104", "41.95", "12.71667", "Europe/Rome"),("3182552", "Bagnacavallo", "", "IT", "380", "", "05", "RA", "039002", "44.41402", "11.97813", "Europe/Rome"),("3182576", "Badia Polesine", "", "IT", "380", "", "20", "RO", "029004", "45.09508", "11.49443", "Europe/Rome"),("3182599", "Bacoli", "", "IT", "380", "", "04", "NA", "063006", "40.79672", "14.07349", "Europe/Rome"),("3182608", "Azzano Decimo", "", "IT", "380", "", "06", "PN", "093005", "45.90937", "12.6642", "Europe/Rome"),("3182633", "Avigliano", "", "IT", "380", "", "02", "PZ", "076007", "40.73291", "15.72004", "Europe/Rome"),("3182634", "Avigliana", "", "IT", "380", "", "12", "TO", "001013", "45.07978", "7.39647", "Europe/Rome"),("3182635", "Aviano", "", "IT", "380", "", "06", "PN", "093004", "46.07056", "12.59472", "Europe/Rome"),("3182636", "Avezzano", "Авеццано", "IT", "380", "", "01", "AQ", "066006", "42.02896", "13.42641", "Europe/Rome"),("3182637", "Avetrana", "", "IT", "380", "", "13", "TA", "073001", "40.3507", "17.7326", "Europe/Rome"),("3182640", "Aversa", "Аверса", "IT", "380", "", "04", "CE", "061005", "40.97259", "14.20745", "Europe/Rome"),("3182650", "Avellino", "Авеллино", "IT", "380", "", "04", "AV", "064008", "40.91494", "14.79103", "Europe/Rome"),("3182651", "Avella", "", "IT", "380", "", "04", "AV", "064007", "40.95995", "14.60087", "Europe/Rome"),("3182696", "Atripalda", "", "IT", "380", "", "04", "AV", "064006", "40.91867", "14.82721", "Europe/Rome"),("3182697", "Atri", "", "IT", "380", "", "01", "TE", "067004", "42.57642", "13.98899", "Europe/Rome"),("3182714", "Asti", "Асти", "IT", "380", "", "12", "AT", "005005", "44.90162", "8.20751", "Europe/Rome"),("3182734", "Asola", "", "IT", "380", "", "09", "MN", "020002", "45.22018", "10.41214", "Europe/Rome"),("3182747", "Ascoli Satriano", "", "IT", "380", "", "13", "FG", "071005", "41.20365", "15.56646", "Europe/Rome"),("3182749", "Ascoli Piceno", "Асколи-Пичено", "IT", "380", "", "10", "AP", "044007", "42.85351", "13.57395", "Europe/Rome"),("3182757", "Arzignano", "Арциньяно", "IT", "380", "", "20", "VI", "024008", "45.52027", "11.33446", "Europe/Rome"),("3182765", "Arzano", "", "IT", "380", "", "04", "NA", "063005", "40.90959", "14.26519", "Europe/Rome"),("3182769", "Arzachena", "", "IT", "380", "", "14", "OT", "104004", "41.0762", "9.39055", "Europe/Rome"),("3182778", "Artena", "", "IT", "380", "", "07", "RM", "058011", "41.74126", "12.90667", "Europe/Rome"),("3182812", "Arona", "", "IT", "380", "", "12", "NO", "003008", "45.7589", "8.55715", "Europe/Rome"),("3182835", "Arluno", "", "IT", "380", "", "09", "MI", "015010", "45.50344", "8.94222", "Europe/Rome"),("3182848", "Arienzo", "", "IT", "380", "", "04", "CE", "061004", "41.02734", "14.4977", "Europe/Rome"),("3182851", "Ariccia", "", "IT", "380", "", "07", "RM", "058009", "41.72063", "12.6723", "Europe/Rome"),("3182854", "Ariano Irpino-Martiri", "", "IT", "380", "", "04", "AV", "064005", "41.16024", "15.10625", "Europe/Rome"),("3182878", "Argenta", "", "IT", "380", "", "05", "FE", "038001", "44.61397", "11.83547", "Europe/Rome"),("3182884", "Arezzo", "Ареццо", "IT", "380", "", "16", "AR", "051002", "43.46276", "11.88068", "Europe/Rome"),("3182886", "Arese", "", "IT", "380", "", "09", "MI", "015009", "45.55048", "9.07741", "Europe/Rome"),("3182887", "Arenzano", "", "IT", "380", "", "08", "GE", "010001", "44.40521", "8.68315", "Europe/Rome"),("3182897", "Ardea", "Ардеа", "IT", "380", "", "07", "RM", "058117", "41.60742", "12.54158", "Europe/Rome"),("3182904", "Arcore", "", "IT", "380", "", "09", "MB", "108004", "45.62675", "9.32454", "Europe/Rome"),("3182906", "Arconate", "", "IT", "380", "", "09", "MI", "015007", "45.54134", "8.84891", "Europe/Rome"),("3182908", "Arcola", "", "IT", "380", "", "08", "SP", "011002", "44.11778", "9.91175", "Europe/Rome"),("3182910", "Arco", "", "IT", "380", "", "17", "TN", "022006", "45.91772", "10.88672", "Europe/Rome"),("3182935", "Aradeo", "", "IT", "380", "", "13", "LE", "075006", "40.12921", "18.12951", "Europe/Rome"),("3182957", "Aprilia", "Априлия", "IT", "380", "", "07", "LT", "059001", "41.59452", "12.65419", "Europe/Rome"),("3182958", "Apricena", "", "IT", "380", "", "13", "FG", "071004", "41.78629", "15.44394", "Europe/Rome"),("3182965", "Appiano Gentile", "", "IT", "380", "", "09", "CO", "013010", "45.73499", "8.98103", "Europe/Rome"),("3182966", "San Michele", "", "IT", "380", "", "17", "BZ", "021004", "46.45472", "11.26178", "Europe/Rome"),("3182997", "Aosta", "Аоста", "IT", "380", "", "19", "AO", "007003", "45.73764", "7.31722", "Europe/Rome"),("3183002", "Anzola dell'Emilia", "", "IT", "380", "IT", "05", "BO", "037001", "44.54197", "11.20548", "Europe/Rome"),("3183005", "Anzio", "Анцио", "IT", "380", "", "07", "RM", "058007", "41.45263", "12.62157", "Europe/Rome"),("3183061", "Anguillara Sabazia", "", "IT", "380", "", "07", "RM", "058005", "42.0792", "12.28368", "Europe/Rome"),("3183063", "Angri", "", "IT", "380", "", "04", "SA", "065007", "40.73815", "14.5707", "Europe/Rome"),("3183072", "Andria", "Андрия", "IT", "380", "", "13", "BT", "110001", "41.23117", "16.29797", "Europe/Rome"),("3183089", "Ancona", "Анкона", "IT", "380", "", "10", "AN", "042002", "43.5942", "13.50337", "Europe/Rome"),("3183098", "Anagni", "", "IT", "380", "", "07", "FR", "060006", "41.7435", "13.15542", "Europe/Rome"),("3183099", "Anacapri", "", "IT", "380", "", "04", "NA", "063004", "40.5517", "14.21225", "Europe/Rome"),("3183113", "Amelia", "", "IT", "380", "", "18", "TR", "055004", "42.55177", "12.42076", "Europe/Rome"),("3183135", "Alzano Lombardo", "", "IT", "380", "", "09", "BG", "016008", "45.73681", "9.72638", "Europe/Rome"),("3183147", "Altopascio", "", "IT", "380", "", "16", "LU", "046001", "43.81618", "10.67668", "Europe/Rome"),("3183169", "Altavilla Vicentina", "", "IT", "380", "", "20", "VI", "024004", "45.51329", "11.46877", "Europe/Rome"),("3183178", "Altamura", "Алтамура", "IT", "380", "", "13", "BA", "072004", "40.82664", "16.54952", "Europe/Rome"),("3183187", "Alpignano", "", "IT", "380", "", "12", "TO", "001008", "45.09346", "7.52392", "Europe/Rome"),("3183257", "Almese-Rivera", "", "IT", "380", "", "12", "TO", "001006", "45.11915", "7.40111", "Europe/Rome"),("3183258", "Almenno San Salvatore", "", "IT", "380", "", "09", "BG", "016007", "45.74971", "9.59699", "Europe/Rome"),("3183260", "Almè", "", "IT", "380", "", "09", "BG", "016005", "45.73883", "9.61558", "Europe/Rome"),("3183284", "Alghero", "", "IT", "380", "", "14", "SS", "090003", "40.55969", "8.31953", "Europe/Rome"),("3183287", "Alfonsine", "", "IT", "380", "", "05", "RA", "039001", "44.50768", "12.03743", "Europe/Rome"),("3183295", "Alezio", "", "IT", "380", "", "13", "LE", "075003", "40.06226", "18.05712", "Europe/Rome"),("3183299", "Alessandria", "Алессандрия", "IT", "380", "", "12", "AL", "006003", "44.90924", "8.61007", "Europe/Rome"),("3183311", "Albizzate", "", "IT", "380", "", "09", "VA", "012002", "45.72698", "8.80312", "Europe/Rome"),("3183314", "Albisola Marina", "", "IT", "380", "", "08", "SV", "009003", "44.33079", "8.5096", "Europe/Rome"),("3183316", "Albino", "", "IT", "380", "", "09", "BG", "016004", "45.76444", "9.79904", "Europe/Rome"),("3183319", "Albignasego", "", "IT", "380", "", "20", "PD", "028003", "45.34705", "11.86781", "Europe/Rome"),("3183321", "Albiate", "", "IT", "380", "", "09", "MB", "108003", "45.65537", "9.25035", "Europe/Rome"),("3183330", "Alberobello", "", "IT", "380", "", "13", "BA", "072003", "40.78448", "17.23618", "Europe/Rome"),("3183343", "Albenga", "", "IT", "380", "", "08", "SV", "009002", "44.04997", "8.21829", "Europe/Rome"),("3183355", "Albano Sant'Alessandro", "", "IT", "380", "IT", "09", "BG", "016003", "45.68762", "9.76651", "Europe/Rome"),("3183356", "Albano Laziale", "", "IT", "380", "", "07", "RM", "058003", "41.72748", "12.659", "Europe/Rome"),("3183364", "Alba", "Альбом", "IT", "380", "", "12", "CN", "004003", "44.6999", "8.0347", "Europe/Rome"),("3183365", "Alatri", "", "IT", "380", "", "07", "FR", "060003", "41.73187", "13.3412", "Europe/Rome"),("3183366", "Alassio", "", "IT", "380", "", "08", "SV", "009001", "44.00393", "8.16713", "Europe/Rome"),("3183374", "Ala", "", "IT", "380", "", "17", "TN", "022001", "45.76072", "11.00458", "Europe/Rome"),("3183378", "Airola", "", "IT", "380", "", "04", "BN", "062001", "41.05871", "14.55924", "Europe/Rome"),("3183412", "Agropoli", "", "IT", "380", "", "04", "SA", "065002", "40.34923", "14.99067", "Europe/Rome"),("3183417", "Agrate Brianza", "", "IT", "380", "", "09", "MB", "108001", "45.57431", "9.34793", "Europe/Rome"),("3183441", "Agliana", "", "IT", "380", "", "16", "PT", "047002", "43.90246", "11.00531", "Europe/Rome"),("3183446", "Agerola", "", "IT", "380", "", "04", "NA", "063003", "40.63771", "14.53884", "Europe/Rome"),("3183455", "Afragola", "Афрагола", "IT", "380", "", "04", "NA", "063002", "40.92298", "14.30935", "Europe/Rome"),("3183461", "Adro", "", "IT", "380", "", "09", "BS", "017002", "45.62059", "9.96159", "Europe/Rome"),("3183466", "Adria", "", "IT", "380", "", "20", "RO", "029001", "45.05445", "12.05599", "Europe/Rome"),("3183472", "Adelfia", "", "IT", "380", "", "13", "BA", "072002", "41.0033", "16.87208", "Europe/Rome"),("3183490", "Acqui Terme", "", "IT", "380", "", "12", "AL", "006001", "44.67552", "8.46934", "Europe/Rome"),("3183494", "Acquaviva delle Fonti", "", "IT", "380", "", "13", "BA", "072001", "40.89704", "16.8433", "Europe/Rome"),("3183539", "Acilia-Castel Fusano-Ostia Antica", "", "IT", "380", "", "07", "RM", "058091", "41.76337", "12.33078", "Europe/Rome"),("3183541", "Acerra", "", "IT", "380", "", "04", "NA", "063001", "40.94477", "14.3714", "Europe/Rome"),("3183573", "Abbiategrasso", "Аббиатеграссо", "IT", "380", "", "09", "MI", "015002", "45.39821", "8.91678", "Europe/Rome"),("3183581", "Abbadia San Salvatore", "", "IT", "380", "", "16", "SI", "052001", "42.8812", "11.6722", "Europe/Rome"),("3183587", "Abano Terme", "Абано-Терме", "IT", "380", "", "20", "PD", "028001", "45.35753", "11.78725", "Europe/Rome"),("3205826", "Li Punti-San Giovanni", "", "IT", "380", "", "14", "SS", "090064", "40.76338", "8.489", "Europe/Rome"),("3215081", "Gatteo-Sant'Angelo", "", "IT", "380", "", "05", "FC", "040016", "44.11194", "12.39139", "Europe/Rome"),("3215209", "Rivazzurra", "", "IT", "380", "", "05", "RN", "099014", "44.04186", "12.60894", "Europe/Rome"),("3215340", "Lido Adriano", "", "IT", "380", "", "05", "RA", "039014", "44.41673", "12.30552", "Europe/Rome"),("3218581", "Santa Lucia di Piave", "", "IT", "380", "", "20", "TV", "026075", "45.86159", "12.2939", "Europe/Rome"),("3218582", "Mareno di Piave", "", "IT", "380", "", "20", "TV", "026038", "45.84572", "12.33703", "Europe/Rome"),("3218772", "Ponzano", "", "IT", "380", "", "20", "TV", "026059", "45.71541", "12.20444", "Europe/Rome"),("3218993", "Fossò", "", "IT", "380", "", "20", "VE", "027017", "45.3858", "12.04627", "Europe/Rome"),("3218998", "Fiesso d'Artico", "", "IT", "380", "", "20", "VE", "027014", "45.42139", "12.02944", "Europe/Rome"),("3219114", "Spinea-Orgnano", "", "IT", "380", "", "20", "VE", "027038", "45.49107", "12.155", "Europe/Rome"),("3219783", "Col San Martino", "", "IT", "380", "", "20", "TV", "026026", "45.9002", "12.11575", "Europe/Rome"),("6301942", "Brusaporto", "", "IT", "380", "", "09", "BG", "016042", "45.6714", "9.76041", "Europe/Rome"),("6457398", "Verbania", "Вербания", "IT", "380", "", "12", "VB", "103072", "45.92136", "8.55183", "Europe/Rome"),("6534212", "Pieve Emanuele", "", "IT", "380", "", "09", "MI", "015173", "45.35052", "9.20268", "Europe/Rome"),("6534213", "Osio Sotto", "", "IT", "380", "", "09", "BG", "016153", "45.61608", "9.58905", "Europe/Rome"),("6534214", "Scanzo-Rosciate", "", "IT", "380", "", "09", "BG", "016194", "45.71078", "9.73505", "Europe/Rome"),("6534215", "Bedizzole", "", "IT", "380", "", "09", "BS", "017014", "45.51038", "10.42327", "Europe/Rome"),("6534216", "Lumezzane", "", "IT", "380", "", "09", "BS", "017096", "45.64789", "10.26487", "Europe/Rome"),("6534219", "Beccacivetta-Azzano", "", "IT", "380", "", "20", "VR", "023021", "45.37435", "10.96133", "Europe/Rome"),("6534220", "Noventa", "", "IT", "380", "", "20", "PD", "028058", "45.41429", "11.95101", "Europe/Rome"),("6534221", "Castelnuovo del Garda", "", "IT", "380", "", "20", "VR", "023022", "45.43878", "10.75978", "Europe/Rome"),("6534222", "Romano d'Ezzelino", "", "IT", "380", "", "20", "VI", "024086", "45.77902", "11.76657", "Europe/Rome"),("6534227", "Monte Argentario", "", "IT", "380", "", "16", "GR", "053016", "42.43452", "11.11954", "Europe/Rome"),("6534228", "Guidonia Montecelio", "", "IT", "380", "", "07", "RM", "058047", "41.99362", "12.72238", "Europe/Rome"),("6534229", "Cervinara", "", "IT", "380", "", "04", "AV", "064025", "41.02042", "14.61444", "Europe/Rome"),("6534231", "Montoro Superiore", "", "IT", "380", "", "04", "AV", "064121", "40.81699", "14.79841", "Europe/Rome"),("6534232", "Lamezia Terme", "", "IT", "380", "", "03", "CZ", "079160", "38.96255", "16.30938", "Europe/Rome"),("6534233", "Cardano al Campo", "", "IT", "380", "", "09", "VA", "012032", "45.64887", "8.76933", "Europe/Rome"),("6534234", "Caronno Pertusella", "", "IT", "380", "", "09", "VA", "012034", "45.59777", "9.04634", "Europe/Rome"),("6534235", "Cassano Magnago", "", "IT", "380", "", "09", "VA", "012040", "45.67206", "8.82691", "Europe/Rome"),("6534236", "Gerenzano", "", "IT", "380", "", "09", "VA", "012075", "45.63967", "9.00104", "Europe/Rome"),("6534237", "Uboldo", "", "IT", "380", "", "09", "VA", "012130", "45.61527", "9.00394", "Europe/Rome"),("6534238", "Pero", "", "IT", "380", "", "09", "MI", "015170", "45.51017", "9.08704", "Europe/Rome"),("6534239", "Pessano Con Bornago", "", "IT", "380", "", "09", "MI", "015172", "45.54937", "9.38145", "Europe/Rome"),("6534240", "Settimo Milanese", "", "IT", "380", "", "09", "MI", "015211", "45.47771", "9.05574", "Europe/Rome"),("6534242", "Pieve a Nievole", "", "IT", "380", "", "16", "PT", "047013", "43.88119", "10.7999", "Europe/Rome"),("6534243", "Albisola Superiore", "", "IT", "380", "", "08", "SV", "009004", "44.33889", "8.51046", "Europe/Rome"),("6534244", "Arcisate", "", "IT", "380", "", "09", "VA", "012004", "45.85578", "8.86823", "Europe/Rome"),("6534245", "Basiglio", "", "IT", "380", "", "09", "MI", "015015", "45.35917", "9.15855", "Europe/Rome"),("6534246", "Bussero", "", "IT", "380", "", "09", "MI", "015040", "45.53407", "9.37205", "Europe/Rome"),("6534247", "Verano Brianza", "", "IT", "380", "", "09", "MB", "108048", "45.68868", "9.22454", "Europe/Rome"),("6534248", "Treviolo", "", "IT", "380", "", "09", "BG", "016220", "45.67368", "9.61195", "Europe/Rome"),("6534249", "Concesio", "", "IT", "380", "", "09", "BS", "017061", "45.60518", "10.21697", "Europe/Rome"),("6534250", "Pino Torinese", "", "IT", "380", "", "12", "TO", "001192", "45.03955", "7.77712", "Europe/Rome"),("6534251", "San Cipriano d'Aversa", "", "IT", "380", "", "04", "CE", "061074", "40.99881", "14.13173", "Europe/Rome"),("6534252", "San Felice A Cancello", "", "IT", "380", "", "04", "CE", "061075", "41.01702", "14.48736", "Europe/Rome"),("6534253", "San Nicola la Strada", "", "IT", "380", "", "04", "CE", "061078", "41.05237", "14.33334", "Europe/Rome"),("6534254", "Crispano", "", "IT", "380", "", "04", "NA", "063030", "40.95251", "14.28993", "Europe/Rome"),("6534255", "Pollena Trocchia", "", "IT", "380", "", "04", "NA", "063056", "40.85134", "14.37911", "Europe/Rome"),("6534256", "Quarto", "Кварто", "IT", "380", "", "04", "NA", "063063", "40.87822", "14.14352", "Europe/Rome"),("6534257", "Tremestieri Etneo", "", "IT", "380", "", "15", "CT", "087051", "37.56494", "15.07863", "Europe/Rome"),("6534258", "Santena", "", "IT", "380", "", "12", "TO", "001257", "44.94624", "7.77303", "Europe/Rome"),("6534259", "Vinovo", "", "IT", "380", "", "12", "TO", "001309", "44.94674", "7.63252", "Europe/Rome"),("6534260", "San Pietro in Cariano", "", "IT", "380", "", "20", "VR", "023076", "45.51751", "10.88624", "Europe/Rome"),("6534261", "Ozzano dell'Emilia", "", "IT", "380", "", "05", "BO", "037046", "44.44427", "11.47552", "Europe/Rome"),("6534262", "Casagiove", "", "IT", "380", "", "04", "CE", "061018", "41.07124", "14.31163", "Europe/Rome"),("6534263", "Frignano", "", "IT", "380", "", "04", "CE", "061037", "40.99811", "14.17913", "Europe/Rome"),("6534264", "Orta di Atella", "", "IT", "380", "", "04", "CE", "061053", "40.96441", "14.26854", "Europe/Rome"),("6534265", "San Marcellino", "", "IT", "380", "", "04", "CE", "061077", "40.99001", "14.17583", "Europe/Rome"),("6534266", "Teverola", "", "IT", "380", "", "04", "CE", "061092", "40.99561", "14.20763", "Europe/Rome"),("6534267", "Casavatore", "", "IT", "380", "", "04", "NA", "063021", "40.89921", "14.27663", "Europe/Rome"),("6534268", "Volla", "", "IT", "380", "", "04", "NA", "063089", "40.87363", "14.34085", "Europe/Rome"),("6534269", "Santa Maria La Carità", "", "IT", "380", "", "04", "NA", "063090", "40.71611", "14.50984", "Europe/Rome"),("6534270", "Trecase", "", "IT", "380", "", "04", "NA", "063091", "40.76941", "14.43773", "Europe/Rome"),("6534271", "Sant'Egidio del Monte Albino", "", "IT", "380", "", "04", "SA", "065130", "40.73871", "14.59454", "Europe/Rome"),("6534272", "Bellizzi", "", "IT", "380", "", "04", "SA", "065158", "40.61981", "14.94685", "Europe/Rome"),("6534273", "Alba Adriatica", "", "IT", "380", "", "01", "TE", "067001", "42.83176", "13.9259", "Europe/Rome"),("6534274", "Valderice", "", "IT", "380", "", "15", "TP", "081022", "38.04005", "12.61505", "Europe/Rome"),("6534275", "Gravina di Catania", "", "IT", "380", "", "15", "CT", "087019", "37.56085", "15.06292", "Europe/Rome"),("6534276", "Sant'Agata Li Battiati", "", "IT", "380", "", "15", "CT", "087045", "37.55745", "15.07999", "Europe/Rome"),("6534277", "Lusciano", "", "IT", "380", "", "04", "CE", "061046", "40.97001", "14.19043", "Europe/Rome"),("6534278", "Parete", "", "IT", "380", "", "04", "CE", "061054", "40.95891", "14.16193", "Europe/Rome"),("6534279", "Piedimonte Matese", "", "IT", "380", "", "04", "CE", "061057", "41.35082", "14.36803", "Europe/Rome"),("6534280", "Cesano Boscone", "", "IT", "380", "", "09", "MI", "015074", "45.44207", "9.09445", "Europe/Rome"),("6534281", "Cesate", "", "IT", "380", "", "09", "MI", "015076", "45.59587", "9.07574", "Europe/Rome"),("6534282", "Carrara San Giorgio", "", "IT", "380", "", "20", "PD", "028106", "45.29259", "11.81841", "Europe/Rome"),("6534283", "Porto Viro", "", "IT", "380", "", "20", "RO", "029052", "45.02678", "12.21754", "Europe/Rome"),("6534284", "Tor Lupara", "", "IT", "380", "", "07", "RM", "058122", "41.99771", "12.61814", "Europe/Rome"),("6534286", "Bernareggio", "", "IT", "380", "", "09", "MB", "108007", "45.64778", "9.40505", "Europe/Rome"),("6534382", "Casarza Ligure", "", "IT", "380", "", "08", "GE", "010011", "44.27188", "9.44704", "Europe/Rome"),("6534413", "Cadorago-Caslino al Piano", "", "IT", "380", "", "09", "CO", "013036", "45.72728", "9.03784", "Europe/Rome"),("6534432", "Andora", "", "IT", "380", "", "08", "SV", "009006", "43.95514", "8.14121", "Europe/Rome"),("6534462", "Albavilla", "", "IT", "380", "", "09", "CO", "013003", "45.80038", "9.18504", "Europe/Rome"),("6534464", "Bregnano", "", "IT", "380", "", "09", "CO", "013028", "45.69778", "9.05934", "Europe/Rome"),("6534466", "Assago", "", "IT", "380", "", "09", "MI", "015011", "45.40887", "9.12565", "Europe/Rome"),("6534468", "Bellusco", "", "IT", "380", "", "09", "MB", "108006", "45.61958", "9.41905", "Europe/Rome"),("6534488", "Pozzuolo Martesana", "", "IT", "380", "", "09", "MI", "015178", "45.51398", "9.45625", "Europe/Rome"),("6534497", "Mozzo", "", "IT", "380", "", "09", "BG", "016143", "45.69868", "9.60865", "Europe/Rome"),("6534499", "Pedrengo", "", "IT", "380", "", "09", "BG", "016160", "45.69598", "9.73495", "Europe/Rome"),("6534505", "Ponteranica", "", "IT", "380", "", "09", "BG", "016169", "45.73248", "9.65175", "Europe/Rome"),("6534524", "Verdellino", "", "IT", "380", "", "09", "BG", "016232", "45.60108", "9.60805", "Europe/Rome"),("6534559", "Prevalle", "", "IT", "380", "", "09", "BS", "017155", "45.55138", "10.42207", "Europe/Rome"),("6534565", "Mottella", "", "IT", "380", "", "09", "MN", "020057", "45.16382", "10.84436", "Europe/Rome"),("6534600", "Lavagno", "", "IT", "380", "", "20", "VR", "023042", "45.43869", "11.13409", "Europe/Rome"),("6534675", "Castel di Lama", "", "IT", "380", "", "10", "AP", "044011", "42.86435", "13.71929", "Europe/Rome"),("6534684", "Capraia e Limite", "", "IT", "380", "", "16", "FI", "048008", "43.74535", "10.98342", "Europe/Rome"),("6534685", "Tavarnelle Val di Pesa", "", "IT", "380", "", "16", "FI", "048045", "43.56184", "11.17152", "Europe/Rome"),("6534726", "Cosio Valtellino", "", "IT", "380", "", "09", "SO", "014024", "46.13509", "9.55164", "Europe/Rome"),("6534745", "Provaglio d'Iseo", "", "IT", "380", "", "09", "BS", "017156", "45.63538", "10.04466", "Europe/Rome"),("6534749", "Rodengo-Saiano", "", "IT", "380", "", "09", "BS", "017163", "45.59958", "10.10717", "Europe/Rome"),("6534758", "Lettere", "", "IT", "380", "", "04", "NA", "063039", "40.70491", "14.54494", "Europe/Rome"),("6534786", "Renon - Ritten", "", "IT", "380", "", "17", "BZ", "021072", "46.54152", "11.45728", "Europe/Rome"),("6534793", "Valle Aurina - Ahrntal", "", "IT", "380", "", "17", "BZ", "021108", "46.99623", "11.97988", "Europe/Rome"),("6534801", "Montecorvino Pugliano", "", "IT", "380", "", "04", "SA", "065072", "40.67921", "14.94475", "Europe/Rome"),("6534814", "Terme", "", "IT", "380", "", "15", "ME", "083106", "38.13586", "15.15658", "Europe/Rome"),("6534921", "Gorla Minore", "", "IT", "380", "", "09", "VA", "012079", "45.64117", "8.90264", "Europe/Rome"),("6534937", "Cogliate", "", "IT", "380", "", "09", "MB", "108020", "45.64597", "9.07884", "Europe/Rome"),("6534940", "Gessate", "", "IT", "380", "", "09", "MI", "015106", "45.54838", "9.43775", "Europe/Rome"),("6534942", "Lazzate", "", "IT", "380", "", "09", "MB", "108025", "45.67207", "9.08424", "Europe/Rome"),("6534943", "Lesmo", "", "IT", "380", "", "09", "MB", "108026", "45.64858", "9.30735", "Europe/Rome"),("6534944", "Macherio", "", "IT", "380", "", "09", "MB", "108029", "45.63974", "9.27394", "Europe/Rome"),("6534948", "San Vittore Olona", "", "IT", "380", "", "09", "MI", "015201", "45.58577", "8.94134", "Europe/Rome"),("6534957", "Boltiere", "", "IT", "380", "", "09", "BG", "016029", "45.60088", "9.57845", "Europe/Rome"),("6534958", "Bonate Sotto", "", "IT", "380", "", "09", "BG", "016031", "45.66818", "9.55865", "Europe/Rome"),("6534975", "Castelcovati", "", "IT", "380", "", "09", "BS", "017041", "45.50198", "9.94596", "Europe/Rome"),("6535115", "Capiago-Intimiano-Olmeda", "", "IT", "380", "", "09", "CO", "013043", "45.76898", "9.12764", "Europe/Rome"),("6535116", "Carugo", "", "IT", "380", "", "09", "CO", "013048", "45.70848", "9.19684", "Europe/Rome"),("6535125", "Guanzate", "", "IT", "380", "", "09", "CO", "013114", "45.72758", "9.01984", "Europe/Rome"),("6535128", "Lipomo", "", "IT", "380", "", "09", "CO", "013129", "45.79288", "9.12024", "Europe/Rome"),("6535147", "Busnago", "", "IT", "380", "", "09", "MB", "108051", "45.61648", "9.46375", "Europe/Rome"),("6535150", "San Giorgio Su Legnano", "", "IT", "380", "", "09", "MI", "015194", "45.57377", "8.91374", "Europe/Rome"),("6535152", "Sovico", "", "IT", "380", "", "09", "MB", "108041", "45.64598", "9.26275", "Europe/Rome"),("6535153", "Vedano al Lambro", "", "IT", "380", "", "09", "MB", "108046", "45.60878", "9.26785", "Europe/Rome"),("6535157", "Azzano San Paolo", "", "IT", "380", "", "09", "BG", "016016", "45.65798", "9.67305", "Europe/Rome"),("6535162", "Bolgare", "", "IT", "380", "", "09", "BG", "016028", "45.63242", "9.81412", "Europe/Rome"),("6535164", "Chiuduno", "", "IT", "380", "", "09", "BG", "016073", "45.65068", "9.84946", "Europe/Rome"),("6535170", "Grassobbio", "", "IT", "380", "", "09", "BG", "016117", "45.65688", "9.72565", "Europe/Rome"),("6535184", "Terno d'Isola", "", "IT", "380", "", "09", "BG", "016213", "45.68548", "9.53095", "Europe/Rome"),("6535193", "Castrezzato", "", "IT", "380", "", "09", "BS", "017045", "45.51128", "9.98086", "Europe/Rome"),("6535202", "Pontoglio", "", "IT", "380", "", "09", "BS", "017150", "45.56938", "9.85346", "Europe/Rome"),("6535203", "Roncadelle", "", "IT", "380", "", "09", "BS", "017165", "45.52718", "10.15407", "Europe/Rome"),("6535205", "Trenzano", "", "IT", "380", "", "09", "BS", "017190", "45.47728", "10.01066", "Europe/Rome"),("6535292", "Succivo", "", "IT", "380", "", "04", "CE", "061090", "40.96801", "14.25563", "Europe/Rome"),("6535295", "Casamicciola Terme", "", "IT", "380", "", "04", "NA", "063019", "40.74661", "13.91202", "Europe/Rome"),("6535296", "Castello di Cisterna", "", "IT", "380", "", "04", "NA", "063025", "40.91594", "14.41117", "Europe/Rome"),("6535297", "San Vitaliano", "", "IT", "380", "", "04", "NA", "063075", "40.92442", "14.47463", "Europe/Rome"),("6535327", "San Pietro Clarenza", "", "IT", "380", "", "15", "CT", "087044", "37.56885", "15.02289", "Europe/Rome"),("6535390", "Castiglione Torinese", "", "IT", "380", "", "12", "TO", "001068", "45.11905", "7.80712", "Europe/Rome"),("6535572", "Caldiero", "", "IT", "380", "", "20", "VR", "023017", "45.41439", "11.17739", "Europe/Rome"),("6535594", "San Giorgio delle Pertiche", "", "IT", "380", "", "20", "PD", "028075", "45.541", "11.89401", "Europe/Rome"),("6535597", "Majano", "", "IT", "380", "", "06", "UD", "030053", "46.18752", "13.06162", "Europe/Rome"),("6535626", "Carinaro", "", "IT", "380", "", "04", "CE", "061016", "40.98291", "14.21963", "Europe/Rome"),("6535628", "Curti", "", "IT", "380", "", "04", "CE", "061032", "41.07616", "14.28039", "Europe/Rome"),("6535630", "Villa di Briano", "", "IT", "380", "", "04", "CE", "061098", "41.00001", "14.16073", "Europe/Rome"),("6535632", "Casapesenna", "", "IT", "380", "", "04", "CE", "061103", "40.99151", "14.13613", "Europe/Rome"),("6535637", "Massa di Somma", "", "IT", "380", "", "04", "NA", "063092", "40.84551", "14.37513", "Europe/Rome"),("6535638", "Montella", "", "IT", "380", "", "04", "AV", "064057", "40.84372", "15.01785", "Europe/Rome"),("6535740", "Zuni", "", "IT", "380", "", "04", "CE", "061010", "41.21722", "14.13082", "Europe/Rome"),("6535748", "Cabiate", "", "IT", "380", "", "09", "CO", "013035", "45.67418", "9.17374", "Europe/Rome"),("6535756", "Tavernerio", "", "IT", "380", "", "09", "CO", "013222", "45.80068", "9.14054", "Europe/Rome"),("6535757", "Turate", "", "IT", "380", "", "09", "CO", "013227", "45.65727", "9.00424", "Europe/Rome"),("6535768", "Caponago", "", "IT", "380", "", "09", "MB", "108052", "45.56647", "9.37585", "Europe/Rome"),("6535772", "Pregnana Milanese", "", "IT", "380", "", "09", "MI", "015179", "45.51597", "9.00704", "Europe/Rome"),("6535775", "Brembate di Sopra", "", "IT", "380", "", "09", "BG", "016038", "45.71668", "9.57945", "Europe/Rome"),("6535785", "Ranica", "", "IT", "380", "", "09", "BG", "016178", "45.72328", "9.71335", "Europe/Rome"),("6543990", "Cantagrillo-Casalguidi", "", "IT", "380", "", "16", "PT", "047020", "43.86937", "10.91386", "Europe/Rome"),("6589958", "Tortoreto Lido", "", "IT", "380", "", "01", "TE", "067044", "42.79956", "13.94205", "Europe/Rome"),("6620312", "Torvaianica", "", "IT", "380", "", "07", "RM", "058079", "41.62112", "12.46197", "Europe/Rome"),("6692061", "Rastignano-Carteria di Sesto", "", "IT", "380", "", "05", "BO", "037047", "44.43623", "11.35695", "Europe/Rome"),("6693938", "Marina di Cerveteri", "", "IT", "380", "", "07", "RM", "058029", "41.97997", "12.05295", "Europe/Rome"),("6694861", "Ara Nova", "", "IT", "380", "", "07", "RM", "058120", "41.933", "12.2398", "Europe/Rome"),("6698334", "Vitinia", "", "IT", "380", "", "07", "RM", "058091", "41.79124", "12.4081", "Europe/Rome"),("6698405", "Donoratico", "", "IT", "380", "", "16", "LI", "049006", "43.16927", "10.56744", "Europe/Rome"),("7302105", "Lavinio", "", "IT", "380", "", "07", "RM", "058007", "41.5035", "12.58973", "Europe/Rome"),("7506720", "Villa Adriana", "", "IT", "380", "", "07", "RM", "058104", "41.95499", "12.77216", "Europe/Rome"),("8129098", "Arbizzano-Santa Maria", "", "IT", "380", "", "20", "VR", "023052", "45.49489", "10.93831", "Europe/Rome"),("8224091", "Castrocaro Terme e Terra del Sole", "", "IT", "380", "", "05", "FC", "040005", "44.18676", "11.96068", "Europe/Rome"),("8224092", "Bellaria-Igea Marina", "", "IT", "380", "", "05", "RN", "099001", "44.14255", "12.47154", "Europe/Rome"),("8224698", "Ca' Savio", "", "IT", "380", "", "20", "VE", "027044", "45.45375", "12.45729", "Europe/Rome"),("8224859", "Marconia", "", "IT", "380", "", "02", "MT", "077020", "40.36355", "16.68823", "Europe/Rome"),("8378869", "Priula-Colfosco", "", "IT", "380", "", "20", "TV", "026083", "45.81998", "12.25847", "Europe/Rome"),("8378897", "Sambuceto", "", "IT", "380", "", "01", "CH", "069081", "42.42168", "14.18747", "Europe/Rome"),("8378910", "Villanova", "", "IT", "380", "", "07", "RM", "058047", "41.96357", "12.75633", "Europe/Rome"),("8394282", "Margine Coperta-Traversagna", "", "IT", "380", "", "16", "PT", "047008", "43.87977", "10.75733", "Europe/Rome"),("8394392", "Marina di Ardea-Tor San Lorenzo", "", "IT", "380", "", "07", "RM", "058117", "41.55439", "12.54115", "Europe/Rome"),("8394394", "Villalba", "", "IT", "380", "", "07", "RM", "058047", "41.95387", "12.72938", "Europe/Rome"),("8410825", "Marco Simone", "", "IT", "380", "", "07", "RM", "058047", "41.95544", "12.64775", "Europe/Rome"),("8426434", "Latina Scalo", "", "IT", "380", "", "07", "LT", "059011", "41.53157", "12.94567", "Europe/Rome"),("8449950", "La Pigna-Pigna Bassa", "", "IT", "380", "", "10", "AP", "044020", "42.83324", "13.63446", "Europe/Rome"),("8449991", "Villaseta", "", "IT", "380", "", "15", "AG", "084001", "37.29877", "13.55919", "Europe/Rome"),("8468835", "Centobuchi", "", "IT", "380", "", "10", "AP", "044045", "42.89521", "13.84809", "Europe/Rome"),("8556235", "San Nicolò", "", "IT", "380", "", "05", "PC", "033039", "45.05685", "9.6054", "Europe/Rome"),("8616976", "Santa Lucia", "", "IT", "380", "", "07", "RM", "058122", "41.9824", "12.65625", "Europe/Rome"),("8948703", "San Paolo", "", "IT", "380", "", "13", "BA", "072006", "41.12476", "16.79258", "Europe/Rome"),("8948704", "Monterusciello", "", "IT", "380", "", "04", "NA", "063060", "40.86874", "14.08276", "Europe/Rome"),("8948705", "Romano Banco", "", "IT", "380", "", "09", "MI", "015036", "45.42309", "9.10707", "Europe/Rome"),("8948706", "Casa Santa", "", "IT", "380", "", "15", "TP", "081008", "38.02514", "12.5484", "Europe/Rome"),("8948708", "Arpino", "", "IT", "380", "", "04", "NA", "063023", "40.88882", "14.32015", "Europe/Rome"),("8948709", "Paolo VI", "", "IT", "380", "", "13", "TA", "073027", "40.52218", "17.27401", "Europe/Rome"),("8948728", "Breo", "", "IT", "380", "", "12", "CN", "004130", "44.39865", "7.81903", "Europe/Rome"),("8948729", "Progresso", "", "IT", "380", "", "05", "BO", "037019", "44.56892", "11.3642", "Europe/Rome"),("8948732", "Mejaniga", "", "IT", "380", "", "20", "PD", "028016", "45.45768", "11.90644", "Europe/Rome"),("8948733", "La Massimina-Casal Lumbroso", "", "IT", "380", "", "07", "RM", "058091", "41.87332", "12.35694", "Europe/Rome"),("8948749", "Chiugiana-La Commenda", "", "IT", "380", "", "18", "PG", "054015", "43.09823", "12.30818", "Europe/Rome"),("8948750", "San Zeno-San Giuseppe", "", "IT", "380", "", "20", "VI", "024026", "45.75727", "11.76208", "Europe/Rome"),("8948751", "Piazza", "", "IT", "380", "", "09", "BS", "017014", "45.50933", "10.42408", "Europe/Rome"),("8948752", "Spicchio-Sovigliana", "", "IT", "380", "", "16", "FI", "048050", "43.73016", "10.93921", "Europe/Rome"),("8948753", "Ponte Cingoli", "", "IT", "380", "", "09", "BS", "017163", "45.59751", "10.10687", "Europe/Rome"),("8948754", "Piattoni-Villa Sant'Antonio", "", "IT", "380", "", "10", "AP", "044011", "42.8663", "13.7112", "Europe/Rome"),("8948755", "Fiesso", "", "IT", "380", "", "20", "VE", "027014", "45.41954", "12.03378", "Europe/Rome"),("8948756", "Canalicchio", "", "IT", "380", "", "15", "CT", "087051", "37.54097", "15.09645", "Europe/Rome"),("8948757", "Colombiera-Molicciara", "", "IT", "380", "", "08", "SP", "011011", "44.0875", "10.01037", "Europe/Rome"),("8948758", "Belvedere", "", "IT", "380", "", "20", "VI", "024104", "45.69001", "11.7718", "Europe/Rome"),("8948759", "Selcetta", "", "IT", "380", "", "07", "RM", "058091", "41.76529", "12.47533", "Europe/Rome"),("8948760", "Andreotta", "", "IT", "380", "", "03", "CS", "078031", "39.3075", "16.2177", "Europe/Rome"),("8948761", "Casano-Dogana-Isola", "", "IT", "380", "", "08", "SP", "011020", "44.07565", "10.03381", "Europe/Rome"),("8948762", "Ciaculli", "", "IT", "380", "", "15", "PA", "082053", "38.0753", "13.40719", "Europe/Rome"),("8948763", "Vill'Albese", "", "IT", "380", "", "09", "CO", "013003", "45.79684", "9.18859", "Europe/Rome"),("8948764", "Sala", "", "IT", "380", "", "04", "AV", "064099", "40.85536", "14.87343", "Europe/Rome"),("8948765", "Villatora", "", "IT", "380", "", "20", "PD", "028085", "45.38768", "11.96736", "Europe/Rome"),("8948766", "Pontasserchio", "", "IT", "380", "", "16", "PI", "050031", "43.77953", "10.41673", "Europe/Rome"),("8948767", "Veggia-Villalunga", "", "IT", "380", "", "05", "RE", "035012", "44.5607", "10.75621", "Europe/Rome"),("8948768", "Quadrivio", "", "IT", "380", "", "04", "SA", "065022", "40.62494", "15.10353", "Europe/Rome"),("8948769", "Mandriola-Sant'Agostino", "", "IT", "380", "", "20", "PD", "028003", "45.36926", "11.85101", "Europe/Rome"),("8948770", "Gerbole", "", "IT", "380", "", "12", "TO", "001214", "45.00115", "7.5067", "Europe/Rome"),("8948771", "Lancusi-Penta-Bolano", "", "IT", "380", "", "04", "SA", "065052", "40.76125", "14.78524", "Europe/Rome"),("8948772", "Pedemonte", "", "IT", "380", "", "08", "GE", "010058", "44.50307", "8.92614", "Europe/Rome"),("8948773", "Frescada", "", "IT", "380", "", "20", "TV", "026063", "45.62878", "12.23671", "Europe/Rome"),("8948774", "San Donnino", "", "IT", "380", "", "16", "FI", "048006", "43.79547", "11.14654", "Europe/Rome"),("8948775", "Caselle", "", "IT", "380", "", "20", "PD", "028086", "45.41129", "11.81663", "Europe/Rome"),("8948776", "Piazza del Galdo-Sant'Angelo", "", "IT", "380", "", "04", "SA", "065067", "40.7739", "14.71696", "Europe/Rome"),("8948777", "Lanzara", "", "IT", "380", "", "04", "SA", "065034", "40.77473", "14.67619", "Europe/Rome"),("8948778", "Airali", "", "IT", "380", "", "12", "TO", "001139", "44.8167", "7.25157", "Europe/Rome"),("8948779", "Vado Centro", "", "IT", "380", "", "08", "SV", "009064", "44.26857", "8.43225", "Europe/Rome"),("8948780", "Eremo", "", "IT", "380", "", "09", "MN", "020021", "45.13119", "10.74271", "Europe/Rome"),("8948781", "San Nicolò a Tordino", "", "IT", "380", "", "01", "TE", "067041", "42.69648", "13.79708", "Europe/Rome"),("8948782", "Villa Raspa", "", "IT", "380", "", "01", "PE", "068041", "42.45542", "14.18457", "Europe/Rome"),("9003711", "Corigliano Scalo", "", "IT", "380", "", "03", "CS", "078044", "39.62713", "16.51368", "Europe/Rome"),("9036384", "Molinetto", "", "IT", "380", "", "09", "BS", "017107", "45.49409", "10.35888", "Europe/Rome"),("9036385", "Marotta", "", "IT", "380", "", "10", "PU", "041013", "43.79893", "13.09452", "Europe/Rome"),("9036386", "Calvi Risorta", "", "IT", "380", "", "04", "CE", "061010", "41.21598", "14.13092", "Europe/Rome"),("3487963", "Yallahs", "", "JM", "388", "", "14", "343", "", "17.8748", "-76.56245", "America/Jamaica"),("3488380", "Stony Hill", "", "JM", "388", "", "08", "15024", "", "18.07916", "-76.78473", "America/Jamaica"),("3488465", "Spanish Town", "Спаниш-Таун", "JM", "388", "", "10", "1438", "", "17.99107", "-76.95742", "America/Jamaica"),("3488613", "Savanna-la-Mar", "", "JM", "388", "", "16", "1057", "", "18.21895", "-78.1332", "America/Jamaica"),("3488620", "Santa Cruz", "", "JM", "388", "", "11", "1134", "", "18.05336", "-77.69836", "America/Jamaica"),("3488713", "Saint Ann’s Bay", "", "JM", "388", "", "09", "606", "", "18.43581", "-77.20098", "America/Jamaica"),("3488726", "Runaway Bay", "", "JM", "388", "", "09", "602", "", "18.45962", "-77.3357", "America/Jamaica"),("3488977", "Porus", "", "JM", "388", "", "04", "1245", "", "18.03535", "-77.41166", "America/Jamaica"),("3488981", "Portmore", "", "JM", "388", "", "10", "1449", "", "17.95032", "-76.88215", "America/Jamaica"),("3488985", "Port Maria", "", "JM", "388", "", "13", "510", "", "18.36849", "-76.88946", "America/Jamaica"),("3489005", "Port Antonio", "", "JM", "388", "", "07", "415", "", "18.17615", "-76.4509", "America/Jamaica"),("3489011", "Point Hill", "", "JM", "388", "", "10", "1424", "", "18.08988", "-77.10759", "America/Jamaica"),("3489225", "Old Harbour Bay", "", "JM", "388", "", "10", "1430", "", "17.90918", "-77.09718", "America/Jamaica"),("3489227", "Old Harbour", "", "JM", "388", "", "10", "1429", "", "17.94144", "-77.10898", "America/Jamaica"),("3489239", "Ocho Rios", "", "JM", "388", "", "09", "608", "", "18.4025", "-77.1048", "America/Jamaica"),("3489297", "New Kingston", "", "JM", "388", "", "08", "15017", "", "18.00747", "-76.78319", "America/Jamaica"),("3489440", "Morant Bay", "", "JM", "388", "", "14", "348", "", "17.88145", "-76.40927", "America/Jamaica"),("3489460", "Montego Bay", "Монтего-Бей", "JM", "388", "", "12", "816", "", "18.47116", "-77.91883", "America/Jamaica"),("3489523", "May Pen", "", "JM", "388", "", "01", "1351", "", "17.96454", "-77.24515", "America/Jamaica"),("3489577", "Mandeville", "Мандевиль", "JM", "388", "", "04", "1242", "", "18.04168", "-77.50714", "America/Jamaica"),("3489657", "Lucea", "", "JM", "388", "", "02", "904", "", "18.45095", "-78.17356", "America/Jamaica"),("3489758", "Lionel Town", "", "JM", "388", "", "01", "1380", "", "17.81007", "-77.24061", "America/Jamaica"),("3489760", "Linstead", "", "JM", "388", "", "10", "1403", "", "18.13683", "-77.03171", "America/Jamaica"),("3489854", "Kingston", "Кингстон", "JM", "388", "", "17", "", "", "17.99702", "-76.79358", "America/Jamaica"),("3490106", "Hayes", "", "JM", "388", "", "01", "1372", "", "17.87569", "-77.23711", "America/Jamaica"),("3490165", "Half Way Tree", "", "JM", "388", "", "08", "15018", "", "18.01248", "-76.79928", "America/Jamaica"),("3490520", "Falmouth", "", "JM", "388", "", "15", "702", "", "18.49358", "-77.65587", "America/Jamaica"),("3490539", "Ewarton", "", "JM", "388", "", "10", "1402", "", "18.18333", "-77.08536", "America/Jamaica"),("3490880", "Constant Spring", "", "JM", "388", "", "08", "15025", "", "18.05078", "-76.79372", "America/Jamaica"),("3491161", "Bull Savanna", "", "JM", "388", "", "11", "1161", "", "17.88678", "-77.59022", "America/Jamaica"),("3491293", "Bog Walk", "", "JM", "388", "", "10", "1413", "", "18.10205", "-77.00541", "America/Jamaica"),("3491355", "Black River", "", "JM", "388", "", "11", "1124", "", "18.02636", "-77.84873", "America/Jamaica"),("3491556", "Annotto Bay", "", "JM", "388", "", "13", "534", "", "18.2717", "-76.76523", "America/Jamaica"),("245989", "Waqqāş", "", "JO", "400", "", "18", "", "", "32.54179", "35.60496", "Asia/Amman"),("246008", "Petra", "", "JO", "400", "", "19", "", "", "30.32096", "35.47895", "Asia/Amman"),("246013", "Wādī as Sīr", "", "JO", "400", "", "16", "", "", "31.9545", "35.81831", "Asia/Amman"),("246314", "Umm as Summāq", "", "JO", "400", "", "16", "", "", "31.88542", "35.8543", "Asia/Amman"),("246522", "Tibnah", "", "JO", "400", "", "18", "", "", "32.47548", "35.7303", "Asia/Amman"),("246725", "Sūf", "", "JO", "400", "", "22", "", "", "32.31372", "35.83713", "Asia/Amman"),("247015", "Şammā", "", "JO", "400", "", "18", "", "", "32.57192", "35.68798", "Asia/Amman"),("247061", "Sāl", "", "JO", "400", "", "18", "", "", "32.56994", "35.91292", "Asia/Amman"),("247068", "Sakib", "", "JO", "400", "", "22", "", "", "32.2833", "35.80946", "Asia/Amman"),("247074", "Şakhrah", "", "JO", "400", "", "20", "", "", "32.37055", "35.84327", "Asia/Amman"),("247103", "Saḩam al Kaffārāt", "", "JO", "400", "", "18", "", "", "32.69763", "35.7762", "Asia/Amman"),("247105", "Saḩāb", "Сахаб", "JO", "400", "", "16", "", "", "31.87032", "36.00479", "Asia/Amman"),("247176", "Şabḩā", "", "JO", "400", "", "15", "", "", "32.32696", "36.50159", "Asia/Amman"),("247336", "Rehab", "", "JO", "400", "", "15", "", "", "32.32341", "36.09087", "Asia/Amman"),("247340", "Raymūn", "", "JO", "400", "", "22", "", "", "32.28339", "35.82532", "Asia/Amman"),("247496", "Qumaym", "", "JO", "400", "", "18", "", "", "32.57108", "35.73467", "Asia/Amman"),("248250", "Malkā", "", "JO", "400", "", "18", "", "", "32.67496", "35.74923", "Asia/Amman"),("248370", "Ma’dabā", "Мадаба", "JO", "400", "", "23", "", "", "31.71599", "35.79392", "Asia/Amman"),("248382", "Ma'an", "", "JO", "400", "", "19", "", "", "30.19624", "35.73405", "Asia/Amman"),("248414", "Kurayyimah", "", "JO", "400", "", "18", "", "", "32.27639", "35.59938", "Asia/Amman"),("248434", "Kitim", "", "JO", "400", "", "18", "", "", "32.43962", "35.89597", "Asia/Amman"),("248627", "Kharjā", "", "JO", "400", "", "18", "", "", "32.6592", "35.88725", "Asia/Amman"),("248719", "Kafr Sawm", "", "JO", "400", "", "18", "", "", "32.67995", "35.80285", "Asia/Amman"),("248734", "Kafr Asad", "", "JO", "400", "", "18", "", "", "32.59341", "35.71368", "Asia/Amman"),("248738", "Kafr Abīl", "", "JO", "400", "", "18", "", "", "32.41736", "35.66276", "Asia/Amman"),("248803", "Judita", "", "JO", "400", "", "18", "", "", "32.40792", "35.70802", "Asia/Amman"),("248843", "Jāwā", "", "JO", "400", "", "16", "", "", "31.85247", "35.93928", "Asia/Amman"),("248875", "Jarash", "Джераш", "JO", "400", "", "22", "", "", "32.28082", "35.89929", "Asia/Amman"),("248923", "‘Izrā", "", "JO", "400", "", "09", "", "", "31.15889", "35.69278", "Asia/Amman"),("248946", "Irbid", "Ирбид", "JO", "400", "", "18", "", "", "32.55556", "35.85", "Asia/Amman"),("249184", "Ḩātim", "", "JO", "400", "", "18", "", "", "32.645", "35.77812", "Asia/Amman"),("249310", "Ḩalāwah", "", "JO", "400", "", "20", "", "", "32.38464", "35.66147", "Asia/Amman"),("249318", "Ḩakamā", "", "JO", "400", "", "18", "", "", "32.59345", "35.88292", "Asia/Amman"),("249676", "Dayr Yūsuf", "", "JO", "400", "", "18", "", "", "32.48934", "35.79505", "Asia/Amman"),("249842", "Buşayrā", "", "JO", "400", "", "12", "", "", "30.7318", "35.60983", "Asia/Amman"),("249930", "Bayt Yāfā", "", "JO", "400", "", "18", "", "", "32.52237", "35.78482", "Asia/Amman"),("250052", "Balīlā", "", "JO", "400", "", "22", "", "", "32.39325", "35.9403", "Asia/Amman"),("250090", "Zarqa", "Эз-Зарка", "JO", "400", "", "17", "", "", "32.07275", "36.08796", "Asia/Amman"),("250095", "Al Azraq ash Shamālī", "", "JO", "400", "", "17", "", "", "31.88209", "36.83017", "Asia/Amman"),("250106", "‘Ayy", "", "JO", "400", "", "09", "", "", "31.13371", "35.64375", "Asia/Amman"),("250124", "‘Ayn Jannah", "", "JO", "400", "", "20", "", "", "32.33466", "35.7637", "Asia/Amman"),("250152", "Aydūn", "", "JO", "400", "", "18", "", "", "32.51031", "35.85444", "Asia/Amman"),("250179", "Aţ Ţurrah", "", "JO", "400", "", "18", "", "", "32.6368", "35.99004", "Asia/Amman"),("250186", "Aţ Ţayyibah", "", "JO", "400", "", "18", "", "", "32.54388", "35.7186", "Asia/Amman"),("250187", "Aţ Ţayyibah", "", "JO", "400", "", "09", "", "", "31.05672", "35.60168", "Asia/Amman"),("250198", "Aţ Ţafīlah", "Тафила", "JO", "400", "", "12", "", "", "30.83752", "35.60442", "Asia/Amman"),("250258", "As Salţ", "Ас-Сальт", "JO", "400", "", "02", "", "", "32.03917", "35.72722", "Asia/Amman"),("250267", "Safi", "Сафи", "JO", "400", "", "09", "", "", "31.03608", "35.46544", "Asia/Amman"),("250294", "Ash Shajarah", "", "JO", "400", "", "18", "", "", "32.64299", "35.94206", "Asia/Amman"),("250336", "Ar Ramthā", "", "JO", "400", "", "18", "", "", "32.55873", "36.00816", "Asia/Amman"),("250420", "‘Anjarah", "", "JO", "400", "", "20", "", "", "32.3063", "35.75653", "Asia/Amman"),("250441", "Amman", "Амман", "JO", "400", "", "16", "", "", "31.95522", "35.94503", "Asia/Amman"),("250461", "Ḩayy al Quwaysimah", "", "JO", "400", "", "16", "", "", "31.91037", "35.94975", "Asia/Amman"),("250462", "Al Quwayrah", "", "JO", "400", "", "19", "", "", "29.80045", "35.3116", "Asia/Amman"),("250540", "Al Mazār al Janūbī", "", "JO", "400", "", "09", "", "", "31.06722", "35.69486", "Asia/Amman"),("250582", "Mafraq", "", "JO", "400", "", "15", "", "", "32.34289", "36.20804", "Asia/Amman"),("250603", "Al Kittah", "", "JO", "400", "", "22", "", "", "32.27685", "35.84114", "Asia/Amman"),("250623", "Al Karāmah", "", "JO", "400", "", "02", "", "", "31.95439", "35.58033", "Asia/Amman"),("250624", "Qīr Moāv", "Эль-Карак", "JO", "400", "JO", "19", "", "", "31.18248", "35.69999", "Asia/Amman"),("250637", "Al Jubayhah", "", "JO", "400", "", "16", "", "", "32.01071", "35.89802", "Asia/Amman"),("250697", "Al Ḩamrā’", "", "JO", "400", "", "15", "", "", "32.44017", "36.15265", "Asia/Amman"),("250738", "Ḩayy al Bunayyāt", "", "JO", "400", "", "16", "", "", "31.89603", "35.88465", "Asia/Amman"),("250774", "Aqaba", "Акаба", "JO", "400", "", "21", "", "", "29.52667", "35.00778", "Asia/Amman"),("250799", "‘Ajlūn", "Аджлун", "JO", "400", "", "20", "", "", "32.33326", "35.75279", "Asia/Amman"),("6946409", "Karak City", "Карак", "JO", "400", "", "09", "", "", "31.16368", "35.76204", "Asia/Amman"),("7838895", "Russeifa", "", "JO", "400", "", "17", "", "", "32.01778", "36.04639", "Asia/Amman"),("11428685", "Rukban", "", "JO", "400", "", "15", "", "", "33.31405", "38.70342", "Asia/Amman"),("1847947", "Shingū", "Синг", "JP", "392", "", "43", "", "", "33.73333", "135.98333", "Asia/Tokyo"),("1847963", "Atsugi", "Ацуги", "JP", "392", "", "19", "", "", "35.44272", "139.36931", "Asia/Tokyo"),("1847966", "Akashi", "Акаси", "JP", "392", "", "13", "", "", "34.63333", "134.98333", "Asia/Tokyo"),("1847968", "Zushi", "", "JP", "392", "", "19", "", "", "35.29483", "139.57812", "Asia/Tokyo"),("1848004", "Zama", "Зама", "JP", "392", "", "19", "", "", "35.4879", "139.39101", "Asia/Tokyo"),("1848016", "Yuza", "", "JP", "392", "", "44", "7450462", "", "39.01573", "139.92909", "Asia/Tokyo"),("1848055", "Gero", "", "JP", "392", "", "09", "", "", "35.8", "137.23333", "Asia/Tokyo"),("1848087", "Yukuhashi", "", "JP", "392", "", "07", "", "", "33.72873", "130.983", "Asia/Tokyo"),("1848096", "Yūki", "Юки", "JP", "392", "", "14", "", "", "36.3", "139.88333", "Asia/Tokyo"),("1848113", "Yugawara", "", "JP", "392", "", "19", "", "", "35.15", "139.06667", "Asia/Tokyo"),("1848169", "Yoshino-chō", "", "JP", "392", "", "28", "1848164", "1848169", "34.39611", "135.85768", "Asia/Tokyo"),("1848188", "Yoshikawa", "Есикава", "JP", "392", "", "34", "", "", "35.89232", "139.84184", "Asia/Tokyo"),("1848194", "Yoshii", "", "JP", "392", "", "10", "", "", "36.25", "138.98333", "Asia/Tokyo"),("1848210", "Yoshida-kasugachō", "", "JP", "392", "", "29", "", "", "37.68333", "138.88333", "Asia/Tokyo"),("1848243", "Yorii", "", "JP", "392", "", "34", "7458573", "", "36.11567", "139.19429", "Asia/Tokyo"),("1848254", "Yono", "", "JP", "392", "", "34", "", "", "35.88333", "139.63333", "Asia/Tokyo"),("1848277", "Yonago", "", "JP", "392", "", "41", "1848276", "", "35.43333", "133.33333", "Asia/Tokyo"),("1848313", "Yokosuka", "Йокосука", "JP", "392", "", "19", "", "", "35.28361", "139.66722", "Asia/Tokyo");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("1848354", "Yokohama", "Иокогама", "JP", "392", "", "19", "1848350", "", "35.43333", "139.65", "Asia/Tokyo"),("1848373", "Yokkaichi", "Йоккаичи", "JP", "392", "", "23", "1848370", "", "34.96667", "136.61667", "Asia/Tokyo"),("1848382", "Youkaichi", "", "JP", "392", "", "35", "", "", "35.11626", "136.19768", "Asia/Tokyo"),("1848439", "Yawata", "", "JP", "392", "", "22", "", "", "34.87009", "135.7027", "Asia/Tokyo"),("1848445", "Honmachi", "Яцусиро", "JP", "392", "", "21", "", "", "32.50439", "130.59952", "Asia/Tokyo"),("1848447", "Yatsuomachi-higashikumisaka", "", "JP", "392", "", "42", "", "", "36.56667", "137.13333", "Asia/Tokyo"),("1848482", "Yasugichō", "", "JP", "392", "", "36", "", "", "35.42146", "133.24224", "Asia/Tokyo"),("1848498", "Yashiro", "", "JP", "392", "", "13", "", "", "34.91667", "134.96667", "Asia/Tokyo"),("1848499", "Yashio-shi", "", "JP", "392", "JP", "34", "", "", "35.82255", "139.83905", "Asia/Tokyo"),("1848522", "Yao", "Яо", "JP", "392", "", "32", "", "", "34.61667", "135.6", "Asia/Tokyo"),("1848550", "Yanai", "Янаи", "JP", "392", "", "45", "", "", "33.96667", "132.11667", "Asia/Tokyo"),("1848573", "Yanagawa", "Янагава", "JP", "392", "", "07", "", "", "33.16667", "130.4", "Asia/Tokyo"),("1848633", "Yamazakichō-nakabirose", "", "JP", "392", "", "13", "", "", "35", "134.55", "Asia/Tokyo"),("1848689", "Yamaguchi", "Ямагути", "JP", "392", "", "45", "", "", "34.18333", "131.46667", "Asia/Tokyo"),("1848705", "Yamaga", "Ямага", "JP", "392", "", "21", "", "", "33.01667", "130.68911", "Asia/Tokyo"),("1848774", "Yaizu", "Яидзу", "JP", "392", "", "37", "", "", "34.86877", "138.31952", "Asia/Tokyo"),("1848776", "Yaita", "", "JP", "392", "", "38", "", "", "36.8", "139.93333", "Asia/Tokyo"),("1848933", "Wakimachi", "", "JP", "392", "", "39", "", "", "34.06667", "134.15", "Asia/Tokyo"),("1849053", "Utsunomiya", "Уцуномия", "JP", "392", "", "38", "", "", "36.56667", "139.88333", "Asia/Tokyo"),("1849069", "Uto", "", "JP", "392", "", "21", "", "", "32.68333", "130.66667", "Asia/Tokyo"),("1849094", "Usuki", "", "JP", "392", "", "30", "", "", "33.12342", "131.80401", "Asia/Tokyo"),("1849154", "Ushibukamachi", "", "JP", "392", "", "21", "", "", "32.20142", "130.02171", "Asia/Tokyo"),("1849183", "Ureshinomachi-shimojuku", "", "JP", "392", "", "33", "", "", "33.11358", "130.00292", "Asia/Tokyo"),("1849186", "Urayasu", "Ураясу", "JP", "392", "", "40", "", "", "35.67056", "139.88861", "Asia/Tokyo"),("1849237", "Uozu", "", "JP", "392", "", "42", "", "", "36.8", "137.4", "Asia/Tokyo"),("1849299", "Umi", "", "JP", "392", "", "07", "1859874", "", "33.56826", "130.51009", "Asia/Tokyo"),("1849367", "Ujiie", "", "JP", "392", "", "38", "", "", "36.68333", "139.96667", "Asia/Tokyo"),("1849372", "Uji", "Удзи", "JP", "392", "", "22", "", "", "34.89044", "135.80325", "Asia/Tokyo"),("1849407", "Uenohara", "", "JP", "392", "", "46", "", "", "35.61667", "139.11667", "Asia/Tokyo"),("1849414", "Ueno-ebisumachi", "", "JP", "392", "", "23", "", "", "34.75856", "136.13108", "Asia/Tokyo"),("1849424", "Uekimachi-mōno", "", "JP", "392", "", "21", "", "", "32.89964", "130.68898", "Asia/Tokyo"),("1849429", "Ueda", "Уэда", "JP", "392", "", "26", "", "", "36.40265", "138.28161", "Asia/Tokyo"),("1849498", "Ube", "Убе", "JP", "392", "", "45", "", "", "33.94306", "131.25111", "Asia/Tokyo"),("1849519", "Tsuyama", "Цуяма", "JP", "392", "", "31", "", "", "35.05215", "133.99885", "Asia/Tokyo"),("1849539", "Tsushima", "Цусима", "JP", "392", "", "01", "1849535", "", "35.16667", "136.71667", "Asia/Tokyo"),("1849561", "Tsurusaki", "", "JP", "392", "", "30", "", "", "33.24528", "131.69165", "Asia/Tokyo"),("1849563", "Tsuruoka", "Цуруока", "JP", "392", "", "44", "", "", "38.72167", "139.82167", "Asia/Tokyo"),("1849584", "Tsurugi-asahimachi", "", "JP", "392", "", "15", "", "", "36.45", "136.63333", "Asia/Tokyo"),("1849592", "Tsuruga", "Цуруга", "JP", "392", "", "06", "", "", "35.64547", "136.0558", "Asia/Tokyo"),("1849647", "Tsuma", "", "JP", "392", "", "25", "", "", "32.1", "131.4", "Asia/Tokyo"),("1849661", "Tsukumiura", "", "JP", "392", "", "30", "", "", "33.07539", "131.86907", "Asia/Tokyo"),("1849706", "Tsukawaki", "", "JP", "392", "", "30", "1858008", "", "33.27668", "131.15628", "Asia/Tokyo"),("1849729", "Tsuiki", "", "JP", "392", "JP", "07", "1864588", "", "33.67307", "131.03776", "Asia/Tokyo"),("1849782", "Tsubata", "", "JP", "392", "", "15", "1860811", "", "36.67012", "136.7403", "Asia/Tokyo"),("1849788", "Tsubame", "Цубамэ", "JP", "392", "", "29", "", "", "37.6645", "138.92518", "Asia/Tokyo"),("1849796", "Tsu", "Цу", "JP", "392", "", "23", "", "", "34.73333", "136.51667", "Asia/Tokyo"),("1849814", "Toyota", "Тоёта", "JP", "392", "", "01", "1849809", "", "35.08333", "137.15", "Asia/Tokyo"),("1849817", "Toyoshina", "", "JP", "392", "", "26", "", "", "36.29991", "137.90108", "Asia/Tokyo"),("1849831", "Toyooka", "", "JP", "392", "", "13", "", "", "35.54008", "134.82038", "Asia/Tokyo"),("1849837", "Toyonaka", "", "JP", "392", "", "32", "", "", "34.78244", "135.46932", "Asia/Tokyo"),("1849845", "Toyokawa", "Тоёкава", "JP", "392", "", "01", "1850219", "", "34.81667", "137.4", "Asia/Tokyo"),("1849846", "Toyohashi", "Тойохаши", "JP", "392", "", "01", "", "", "34.76667", "137.38333", "Asia/Tokyo"),("1849850", "Toyohama", "", "JP", "392", "", "01", "1864542", "", "34.70933", "136.93425", "Asia/Tokyo"),("1849876", "Toyama", "Тояма", "JP", "392", "", "42", "", "", "36.7", "137.21667", "Asia/Tokyo"),("1849892", "Tottori", "", "JP", "392", "", "41", "", "", "35.5", "134.23333", "Asia/Tokyo"),("1849904", "Tosu", "", "JP", "392", "", "33", "", "", "33.36667", "130.51667", "Asia/Tokyo"),("1850004", "Tonoshō", "", "JP", "392", "", "17", "1851654", "", "34.48047", "134.17017", "Asia/Tokyo"),("1850034", "Tondabayashichō", "", "JP", "392", "", "32", "", "", "34.50065", "135.60211", "Asia/Tokyo"),("1850091", "Tomioka", "", "JP", "392", "", "10", "", "", "36.25411", "138.89813", "Asia/Tokyo"),("1850108", "Tomigusuku", "", "JP", "392", "", "47", "", "", "26.18583", "127.68192", "Asia/Tokyo"),("1850147", "Tokyo", "Токио", "JP", "392", "", "40", "1852083", "", "35.6895", "139.69171", "Asia/Tokyo"),("1850152", "Tokuyama", "", "JP", "392", "", "45", "", "", "34.05", "131.81667", "Asia/Tokyo"),("1850158", "Tokushima", "Токусима", "JP", "392", "", "39", "", "", "34.06667", "134.56667", "Asia/Tokyo"),("1850181", "Tokorozawa", "Токородзава", "JP", "392", "", "34", "", "", "35.79916", "139.46903", "Asia/Tokyo"),("1850185", "Tokoname", "Токонамэ", "JP", "392", "", "01", "", "", "34.88333", "136.85", "Asia/Tokyo"),("1850207", "Toki", "Тока", "JP", "392", "", "09", "", "", "35.35", "137.18333", "Asia/Tokyo"),("1850217", "Tōkamachi", "Токамати", "JP", "392", "", "29", "", "", "37.13333", "138.76667", "Asia/Tokyo"),("1850269", "Togitsu", "", "JP", "392", "", "27", "", "", "32.83333", "129.85", "Asia/Tokyo"),("1850307", "Tochio-honchō", "", "JP", "392", "", "29", "", "", "37.47642", "138.99513", "Asia/Tokyo"),("1850311", "Tochigi", "Тотиги", "JP", "392", "", "38", "", "", "36.38333", "139.73333", "Asia/Tokyo"),("1850345", "Toba", "Тоба", "JP", "392", "", "23", "1850342", "", "34.4833", "136.84186", "Asia/Tokyo"),("1850396", "Tenri", "Тэнри", "JP", "392", "", "28", "", "", "34.58333", "135.83333", "Asia/Tokyo"),("1850405", "Tennō", "", "JP", "392", "", "02", "", "", "39.9", "139.96667", "Asia/Tokyo"),("1850472", "Tawaramoto", "", "JP", "392", "", "28", "1852501", "", "34.5542", "135.79297", "Asia/Tokyo"),("1850498", "Tatsuno", "", "JP", "392", "", "26", "", "", "35.98426", "137.99721", "Asia/Tokyo"),("1850499", "Tatsunochō-tominaga", "", "JP", "392", "", "13", "", "", "34.86437", "134.552", "Asia/Tokyo"),("1850523", "Tateyama", "Татеяма", "JP", "392", "", "04", "", "", "34.98333", "139.86667", "Asia/Tokyo"),("1850559", "Tatebayashi", "", "JP", "392", "", "10", "", "", "36.25", "139.53333", "Asia/Tokyo"),("1850589", "Tarumizu", "", "JP", "392", "", "18", "", "", "31.48333", "130.7", "Asia/Tokyo"),("1850600", "Tarui", "Таруи", "JP", "392", "", "09", "1863710", "", "35.36667", "136.53333", "Asia/Tokyo"),("1850627", "Tanushimarumachi-toyoki", "", "JP", "392", "", "07", "", "", "33.35", "130.68333", "Asia/Tokyo"),("1850630", "Tanuma", "", "JP", "392", "", "38", "", "", "36.36667", "139.58333", "Asia/Tokyo"),("1850692", "Nishi-Tokyo-shi", "", "JP", "392", "JP", "40", "", "", "35.72526", "139.5383", "Asia/Tokyo"),("1850693", "Tanashichō", "", "JP", "392", "", "40", "", "", "35.72922", "139.53813", "Asia/Tokyo"),("1850707", "Tanabe", "", "JP", "392", "", "22", "", "", "34.82242", "135.76604", "Asia/Tokyo"),("1850708", "Tanabe", "Танабэ", "JP", "392", "", "43", "", "", "33.73333", "135.36667", "Asia/Tokyo"),("1850742", "Tamano", "Тамано", "JP", "392", "", "31", "", "", "34.48333", "133.95", "Asia/Tokyo"),("1850745", "Tamana", "Тамана", "JP", "392", "", "21", "", "", "32.94716", "130.57446", "Asia/Tokyo"),("1850746", "Tamamura", "", "JP", "392", "", "10", "1852846", "", "36.3", "139.11667", "Asia/Tokyo"),("1850818", "Taketoyo", "", "JP", "392", "", "01", "1864542", "", "34.85", "136.91667", "Asia/Tokyo"),("1850834", "Takeochō-takeo", "Такео", "JP", "392", "", "33", "", "", "33.19009", "130.02084", "Asia/Tokyo"),("1850860", "Takehara", "", "JP", "392", "", "11", "", "", "34.33833", "132.91667", "Asia/Tokyo"),("1850872", "Takefu", "", "JP", "392", "", "06", "", "", "35.90393", "136.16687", "Asia/Tokyo"),("1850878", "Takedamachi", "", "JP", "392", "", "30", "", "", "32.96667", "131.4", "Asia/Tokyo"),("1850892", "Takayama", "Такаяма", "JP", "392", "", "09", "", "", "36.13333", "137.25", "Asia/Tokyo"),("1850910", "Takatsuki", "", "JP", "392", "", "32", "", "", "34.84833", "135.61678", "Asia/Tokyo"),("1851002", "Takasaki", "Такасаки", "JP", "392", "", "10", "", "", "36.33333", "139.01667", "Asia/Tokyo"),("1851012", "Takarazuka", "", "JP", "392", "", "13", "", "", "34.79936", "135.35697", "Asia/Tokyo"),("1851032", "Takaoka", "", "JP", "392", "", "42", "", "", "36.75", "137.01667", "Asia/Tokyo"),("1851068", "Takanabe", "", "JP", "392", "", "25", "1858599", "", "32.13333", "131.5", "Asia/Tokyo"),("1851100", "Takamatsu", "Такамацу", "JP", "392", "", "17", "", "", "34.33333", "134.05", "Asia/Tokyo"),("1851125", "Takaishi", "", "JP", "392", "", "32", "", "", "34.51667", "135.43333", "Asia/Tokyo"),("1851137", "Takahashi", "Такахаси", "JP", "392", "", "31", "", "", "34.78333", "133.61667", "Asia/Tokyo"),("1851155", "Takahama", "Такахама", "JP", "392", "", "01", "", "", "34.91667", "136.98333", "Asia/Tokyo"),("1851170", "Bungo-Takada-shi", "", "JP", "392", "", "30", "", "", "33.5567", "131.44506", "Asia/Tokyo"),("1851193", "Tajimi", "", "JP", "392", "", "09", "", "", "35.31667", "137.13333", "Asia/Tokyo"),("1851259", "Tahara", "", "JP", "392", "", "01", "", "", "34.66667", "137.26667", "Asia/Tokyo"),("1851273", "Tagawa", "Тагава", "JP", "392", "", "07", "", "", "33.63333", "130.8", "Asia/Tokyo"),("1851282", "Tadotsu", "", "JP", "392", "", "17", "1855768", "", "34.275", "133.75", "Asia/Tokyo"),("1851348", "Suzuka", "Судзука", "JP", "392", "", "23", "", "", "34.88333", "136.58333", "Asia/Tokyo"),("1851357", "Suzaka", "", "JP", "392", "", "26", "", "", "36.65", "138.31667", "Asia/Tokyo"),("1851368", "Suwa", "Сува", "JP", "392", "", "26", "", "", "36.03799", "138.11308", "Asia/Tokyo"),("1851390", "Susaki", "", "JP", "392", "", "20", "", "", "33.39471", "133.29128", "Asia/Tokyo"),("1851426", "Sumoto", "Сумото", "JP", "392", "", "13", "", "", "34.35", "134.9", "Asia/Tokyo"),("1851462", "Sukumo", "", "JP", "392", "", "20", "", "", "32.93333", "132.73333", "Asia/Tokyo"),("1851483", "Suita", "Суита", "JP", "392", "", "32", "", "", "34.76143", "135.51567", "Asia/Tokyo"),("1851494", "Suibara", "", "JP", "392", "", "29", "", "", "37.84608", "139.23039", "Asia/Tokyo"),("1851504", "Sugito", "", "JP", "392", "", "34", "", "", "36.03107", "139.72636", "Asia/Tokyo"),("1851542", "Sueyoshichō-ninokata", "", "JP", "392", "", "18", "", "", "31.65", "131.01667", "Asia/Tokyo"),("1851604", "Sōka", "Сок", "JP", "392", "", "34", "", "", "35.83643", "139.79957", "Asia/Tokyo"),("1851606", "Sōja", "", "JP", "392", "", "31", "", "", "34.67534", "133.75091", "Asia/Tokyo"),("1851622", "Sobue", "", "JP", "392", "", "01", "", "", "35.25", "136.71667", "Asia/Tokyo"),("1851711", "Shōbu", "Себу", "JP", "392", "", "34", "", "", "36.06667", "139.6", "Asia/Tokyo"),("1851713", "Shōbara", "", "JP", "392", "", "11", "", "", "34.85", "133.01667", "Asia/Tokyo"),("1851717", "Shizuoka", "Сидзуока", "JP", "392", "", "37", "1851714", "", "34.98333", "138.38333", "Asia/Tokyo"),("1851813", "Shirone", "", "JP", "392", "", "29", "1855427", "", "37.76354", "139.02199", "Asia/Tokyo"),("1851883", "Shiraoka", "", "JP", "392", "", "34", "", "", "36.01839", "139.66034", "Asia/Tokyo"),("1851935", "Shirahamachō-usazakiminami", "Ширахама", "JP", "392", "", "13", "", "", "34.78333", "134.71667", "Asia/Tokyo"),("1851952", "Shiozawa", "", "JP", "392", "", "29", "", "", "37.03757", "138.84867", "Asia/Tokyo"),("1852003", "Shiojiri", "", "JP", "392", "", "26", "", "", "36.1", "137.96667", "Asia/Tokyo"),("1852046", "Shinshiro", "Синсиро", "JP", "392", "", "01", "", "", "34.9", "137.5", "Asia/Tokyo"),("1852102", "Shin’ichi", "", "JP", "392", "", "11", "", "", "34.55543", "133.27297", "Asia/Tokyo"),("1852109", "Shingū", "Синг", "JP", "392", "", "07", "1859874", "", "33.71399", "130.4313", "Asia/Tokyo"),("1852225", "Shimonoseki", "Симоносеки", "JP", "392", "", "45", "", "", "33.95", "130.95", "Asia/Tokyo"),("1852347", "Shimodate", "", "JP", "392", "", "14", "", "", "36.3", "139.98333", "Asia/Tokyo"),("1852357", "Shimoda", "Симода", "JP", "392", "", "37", "", "", "34.66667", "138.95", "Asia/Tokyo"),("1852383", "Minato", "", "JP", "392", "", "43", "", "", "34.2152", "135.1501", "Asia/Tokyo"),("1852385", "Nishishinminato", "", "JP", "392", "", "42", "", "", "36.77957", "137.07576", "Asia/Tokyo"),("1852472", "Shimada", "Симада", "JP", "392", "", "37", "", "", "34.81667", "138.18333", "Asia/Tokyo"),("1852479", "Shimabara", "", "JP", "392", "", "27", "", "", "32.78333", "130.36667", "Asia/Tokyo"),("1852502", "Shiki", "Сики", "JP", "392", "", "34", "", "", "35.83333", "139.58333", "Asia/Tokyo"),("1852534", "Shiida", "", "JP", "392", "JP", "07", "1864588", "", "33.65341", "131.05797", "Asia/Tokyo"),("1852561", "Shido", "", "JP", "392", "", "17", "", "", "34.32333", "134.17333", "Asia/Tokyo"),("1852588", "Shibushi", "", "JP", "392", "", "18", "", "", "31.46667", "131.105", "Asia/Tokyo"),("1852595", "Shibukawa", "", "JP", "392", "", "10", "", "", "36.48333", "139", "Asia/Tokyo"),("1852607", "Shibata", "Шибата", "JP", "392", "", "29", "", "", "37.95", "139.33333", "Asia/Tokyo"),("1852663", "Seto", "Сету", "JP", "392", "", "01", "", "", "35.23333", "137.1", "Asia/Tokyo"),("1852673", "Setakamachi-takayanagi", "", "JP", "392", "", "07", "", "", "33.14858", "130.46548", "Asia/Tokyo"),("1852736", "Satsumasendai", "Сендай", "JP", "392", "", "18", "", "", "31.81667", "130.3", "Asia/Tokyo"),("1852849", "Satte", "", "JP", "392", "", "34", "", "", "36.07254", "139.72615", "Asia/Tokyo"),("1852899", "Sasebo", "Сасебо", "JP", "392", "", "27", "", "", "33.15917", "129.72278", "Asia/Tokyo"),("1852901", "Sasayama", "Сасаяма", "JP", "392", "", "13", "", "", "35.06667", "135.21667", "Asia/Tokyo"),("1852915", "Sasaguri", "", "JP", "392", "", "07", "1859874", "", "33.61561", "130.55105", "Asia/Tokyo"),("1852964", "Sano", "Сана", "JP", "392", "", "38", "", "", "36.31667", "139.58333", "Asia/Tokyo"),("1852984", "Sanjō", "Сандзе", "JP", "392", "", "29", "", "", "37.61667", "138.95", "Asia/Tokyo"),("1853008", "Sandachō", "Санда", "JP", "392", "", "13", "", "", "34.88444", "135.22694", "Asia/Tokyo"),("1853066", "Sakurai", "Сакураи", "JP", "392", "", "28", "", "", "34.5", "135.85", "Asia/Tokyo"),("1853081", "Saku", "Саку", "JP", "392", "", "26", "", "", "36.21667", "138.48333", "Asia/Tokyo"),("1853140", "Sakata", "Саката", "JP", "392", "", "44", "", "", "38.91667", "139.855", "Asia/Tokyo"),("1853174", "Sakaiminato", "", "JP", "392", "", "36", "", "", "35.55", "133.23333", "Asia/Tokyo"),("1853190", "Sakaidechō", "", "JP", "392", "", "17", "", "", "34.32278", "133.8356", "Asia/Tokyo"),("1853192", "Sakai-nakajima", "", "JP", "392", "", "10", "", "", "36.26667", "139.25", "Asia/Tokyo"),("1853193", "Sakai", "Сакаи", "JP", "392", "", "14", "1852883", "", "36.1", "139.8", "Asia/Tokyo"),("1853195", "Sakai", "Сакаи", "JP", "392", "", "32", "1853167", "", "34.58333", "135.46667", "Asia/Tokyo"),("1853209", "Sakado", "", "JP", "392", "", "34", "", "", "35.95694", "139.38889", "Asia/Tokyo"),("1853237", "Saiki", "", "JP", "392", "", "30", "", "", "32.95", "131.9", "Asia/Tokyo"),("1853280", "Sagara", "", "JP", "392", "", "37", "", "", "34.68503", "138.20461", "Asia/Tokyo"),("1853303", "Saga", "Сага Япония", "JP", "392", "", "33", "", "", "33.23333", "130.3", "Asia/Tokyo"),("1853338", "Sabae", "", "JP", "392", "", "06", "", "", "35.94647", "136.18498", "Asia/Tokyo"),("1853354", "Ryūō", "", "JP", "392", "", "46", "", "", "35.65", "138.5", "Asia/Tokyo"),("1853371", "Ryōtsu-minato", "", "JP", "392", "", "29", "", "", "38.07817", "138.43939", "Asia/Tokyo"),("1853433", "Ōzu", "Одзу", "JP", "392", "", "21", "1859490", "", "32.8804", "130.87161", "Asia/Tokyo"),("1853483", "Oyama", "Ояма", "JP", "392", "", "38", "", "", "36.3", "139.8", "Asia/Tokyo"),("1853486", "Ōyama", "", "JP", "392", "", "37", "", "", "34.60359", "138.21719", "Asia/Tokyo"),("1853514", "Owase", "Овасэ", "JP", "392", "", "23", "", "", "34.06667", "136.2", "Asia/Tokyo"),("1853564", "Ōtsuki", "Оцуки", "JP", "392", "", "46", "", "", "35.6", "138.93333", "Asia/Tokyo"),("1853574", "Ōtsu", "Оцу", "JP", "392", "", "35", "", "", "35", "135.86667", "Asia/Tokyo"),("1853662", "Ōtake", "Отакэ", "JP", "392", "", "45", "1858484", "", "34.2", "132.21667", "Asia/Tokyo"),("1853677", "Ōta", "Ота", "JP", "392", "", "10", "", "", "36.3", "139.36667", "Asia/Tokyo"),("1853909", "Osaka", "Осака", "JP", "392", "", "32", "1853897", "", "34.69374", "135.50218", "Asia/Tokyo"),("1853992", "Onomichi", "", "JP", "392", "", "11", "", "", "34.41667", "133.2", "Asia/Tokyo"),("1854018", "Onoda", "", "JP", "392", "", "45", "", "", "34.00139", "131.18361", "Asia/Tokyo"),("1854022", "Ono", "Оно", "JP", "392", "", "06", "", "", "35.98106", "136.48727", "Asia/Tokyo"),("1854026", "Ono", "Оно", "JP", "392", "", "13", "", "", "34.85", "134.93333", "Asia/Tokyo"),("1854028", "Ōno-hara", "Оно", "JP", "392", "", "11", "", "", "34.28333", "132.26667", "Asia/Tokyo"),("1854083", "Ōmuta", "Омута", "JP", "392", "", "07", "", "", "33.03333", "130.45", "Asia/Tokyo"),("1854093", "Ōmura", "Омура", "JP", "392", "", "27", "", "", "32.92139", "129.95389", "Asia/Tokyo"),("1854162", "Ōme", "Оме", "JP", "392", "", "40", "", "", "35.78389", "139.24306", "Asia/Tokyo"),("1854177", "Ōmamachō-ōmama", "", "JP", "392", "", "10", "", "", "36.43181", "139.27534", "Asia/Tokyo"),("1854186", "Ōmachi", "", "JP", "392", "", "26", "", "", "36.5", "137.86667", "Asia/Tokyo"),("1854246", "Ōkuchi-shinohara", "", "JP", "392", "", "18", "", "", "32.06779", "130.62439", "Asia/Tokyo"),("1854371", "Okegawa", "", "JP", "392", "", "34", "", "", "36", "139.55722", "Asia/Tokyo"),("1854376", "Okazaki", "Окадзаки", "JP", "392", "", "01", "", "", "34.95", "137.16667", "Asia/Tokyo"),("1854383", "Okayama", "Окаяма", "JP", "392", "", "31", "1854380", "", "34.65", "133.93333", "Asia/Tokyo"),("1854384", "Okaya", "", "JP", "392", "", "26", "", "", "36.05659", "138.0451", "Asia/Tokyo"),("1854405", "Ōkawa", "Окава", "JP", "392", "", "33", "", "", "33.2", "130.35", "Asia/Tokyo"),("1854444", "Ojiya", "", "JP", "392", "", "29", "", "", "37.3", "138.8", "Asia/Tokyo"),("1854487", "Ōita", "Оита", "JP", "392", "", "30", "", "", "33.23333", "131.6", "Asia/Tokyo"),("1854492", "Ōiso", "", "JP", "392", "", "19", "1855966", "", "35.31558", "139.31625", "Asia/Tokyo"),("1854530", "Ōi", "", "JP", "392", "", "34", "", "", "35.85091", "139.51998", "Asia/Tokyo"),("1854629", "Ogōri-shimogō", "", "JP", "392", "", "45", "", "", "34.1", "131.4", "Asia/Tokyo"),("1854665", "Ogawa", "Огава", "JP", "392", "", "34", "1862655", "", "36.05342", "139.26612", "Asia/Tokyo"),("1854703", "Ōgaki", "", "JP", "392", "", "09", "", "", "35.35", "136.61667", "Asia/Tokyo"),("1854747", "Odawara", "Одавара", "JP", "392", "", "19", "", "", "35.25556", "139.15972", "Asia/Tokyo"),("1854774", "Ōdachō-ōda", "Ода", "JP", "392", "", "36", "", "", "35.19025", "132.50846", "Asia/Tokyo"),("1854803", "Ōbu", "Обу", "JP", "392", "", "01", "1864542", "", "35", "136.96667", "Asia/Tokyo"),("1854807", "Obita", "", "JP", "392", "", "27", "1855163", "", "32.81667", "129.88333", "Asia/Tokyo"),("1854849", "Obama", "Обама", "JP", "392", "", "06", "", "", "35.49576", "135.74604", "Asia/Tokyo"),("1854868", "Nyūzen", "", "JP", "392", "", "42", "", "", "36.93744", "137.50059", "Asia/Tokyo"),("1854902", "Numazu", "Нумадзу", "JP", "392", "", "37", "", "", "35.1", "138.86667", "Asia/Tokyo"),("1854905", "Numata", "", "JP", "392", "", "10", "", "", "36.63333", "139.05", "Asia/Tokyo"),("1854979", "Nonoichi", "Ноноичи", "JP", "392", "", "15", "1861388", "", "36.53333", "136.61667", "Asia/Tokyo"),("1855066", "Nōgata", "", "JP", "392", "", "07", "", "", "33.74051", "130.72263", "Asia/Tokyo"),("1855078", "Noda", "Нода", "JP", "392", "", "04", "", "", "35.94897", "139.86793", "Asia/Tokyo"),("1855095", "Nobeoka", "Нобеока", "JP", "392", "", "25", "", "", "32.58333", "131.66667", "Asia/Tokyo"),("1855134", "Nishiwaki", "Нишиваки", "JP", "392", "", "13", "", "", "34.98419", "134.97407", "Asia/Tokyo"),("1855189", "Nishio", "Нисио", "JP", "392", "", "01", "", "", "34.86667", "137.05", "Asia/Tokyo"),("1855203", "Nishinoomote", "", "JP", "392", "", "18", "", "", "30.73333", "131", "Asia/Tokyo"),("1855207", "Nishinomiya-hama", "Нисиномия", "JP", "392", "", "13", "", "", "34.71562", "135.33199", "Asia/Tokyo"),("1855363", "Nirasaki", "", "JP", "392", "", "46", "", "", "35.7", "138.45", "Asia/Tokyo"),("1855380", "Ninomiya", "Ниномия", "JP", "392", "", "19", "1855966", "", "35.3015", "139.25581", "Asia/Tokyo"),("1855395", "Nikkō", "Никко", "JP", "392", "", "38", "", "", "36.75", "139.61667", "Asia/Tokyo"),("1855410", "Niitsu-honchō", "", "JP", "392", "", "29", "1855427", "", "37.80024", "139.1224", "Asia/Tokyo"),("1855416", "Niimi", "Ниими", "JP", "392", "", "31", "", "", "34.98333", "133.46667", "Asia/Tokyo"),("1855425", "Niihama", "", "JP", "392", "", "05", "", "", "33.96047", "133.30522", "Asia/Tokyo"),("1855431", "Niigata", "Ниигата", "JP", "392", "", "29", "1855427", "", "37.88637", "139.00589", "Asia/Tokyo"),("1855476", "Nichinan", "Нитинан", "JP", "392", "", "25", "", "", "31.6", "131.36667", "Asia/Tokyo"),("1855540", "Naze", "", "JP", "392", "", "18", "", "", "28.36667", "129.48333", "Asia/Tokyo"),("1855580", "Narutochō-mitsuishi", "Наруто", "JP", "392", "", "39", "", "", "34.19933", "134.60932", "Asia/Tokyo"),("1855612", "Nara-shi", "Нара", "JP", "392", "", "28", "", "", "34.68505", "135.80485", "Asia/Tokyo"),("1855670", "Nanao", "Нанао", "JP", "392", "", "15", "", "", "37.05", "136.96667", "Asia/Tokyo"),("1855694", "Namerikawa", "Намэрикава", "JP", "392", "", "42", "", "", "36.76667", "137.33333", "Asia/Tokyo"),("1855753", "Nakatsugawa", "", "JP", "392", "", "09", "", "", "35.48333", "137.5", "Asia/Tokyo"),("1855757", "Nakatsu", "", "JP", "392", "", "07", "", "", "33.59811", "131.1883", "Asia/Tokyo"),("1855852", "Nakanojōmachi", "", "JP", "392", "", "10", "7453747", "", "36.58717", "138.84083", "Asia/Tokyo"),("1855863", "Nakano", "Накано", "JP", "392", "", "26", "", "", "36.75", "138.36667", "Asia/Tokyo"),("1855891", "Nakamura", "Накамура", "JP", "392", "", "20", "", "", "32.98333", "132.93333", "Asia/Tokyo"),("1855907", "Nakama", "", "JP", "392", "", "07", "", "", "33.81688", "130.70962", "Asia/Tokyo"),("1856035", "Naha", "Наха", "JP", "392", "", "47", "", "", "26.21667", "127.68333", "Asia/Tokyo"),("1856057", "Nagoya", "Нагоя", "JP", "392", "", "01", "", "", "35.18147", "136.90641", "Asia/Tokyo"),("1856068", "Nago", "Нага", "JP", "392", "", "47", "", "", "26.61502", "127.98543", "Asia/Tokyo"),("1856177", "Nagasaki", "Нагасаки", "JP", "392", "", "27", "", "", "32.75", "129.88333", "Asia/Tokyo"),("1856184", "Nagareyama", "", "JP", "392", "", "04", "1856183", "", "35.8563", "139.90266", "Asia/Tokyo"),("1856199", "Nagaoka", "Нагаока", "JP", "392", "", "29", "", "", "37.45", "138.85", "Asia/Tokyo"),("1856215", "Nagano", "Нагано", "JP", "392", "", "26", "", "", "36.65", "138.18333", "Asia/Tokyo"),("1856243", "Nagahama", "Нагахама", "JP", "392", "", "35", "", "", "35.38333", "136.26667", "Asia/Tokyo"),("1856293", "Nabari", "", "JP", "392", "", "23", "", "", "34.61667", "136.08333", "Asia/Tokyo"),("1856367", "Musashino", "Мусасино", "JP", "392", "", "40", "", "", "35.70611", "139.55944", "Asia/Tokyo"),("1856392", "Muroto-misakicho", "", "JP", "392", "", "20", "", "", "33.28662", "134.16832", "Asia/Tokyo"),("1856426", "Muramatsu", "", "JP", "392", "", "29", "", "", "37.69257", "139.17127", "Asia/Tokyo"),("1856434", "Murakami", "Мураками", "JP", "392", "", "29", "", "", "38.23333", "139.48333", "Asia/Tokyo"),("1856456", "Mukō", "Мука", "JP", "392", "", "22", "1857906", "", "34.96545", "135.70415", "Asia/Tokyo"),("1856476", "Muikamachi", "", "JP", "392", "", "29", "", "", "37.06667", "138.88333", "Asia/Tokyo"),("1856560", "Morohongō", "", "JP", "392", "", "34", "1861470", "", "35.93556", "139.30444", "Asia/Tokyo"),("1856569", "Moriyama", "Морияма", "JP", "392", "", "35", "", "", "35.06667", "135.98333", "Asia/Tokyo"),("1856584", "Moriguchi", "", "JP", "392", "", "32", "", "", "34.73333", "135.56667", "Asia/Tokyo"),("1856586", "Mori", "Море", "JP", "392", "", "37", "7418312", "", "34.83333", "137.93333", "Asia/Tokyo"),("1856667", "Mizunami", "", "JP", "392", "", "09", "", "", "35.36667", "137.25", "Asia/Tokyo"),("1856698", "Miyoshi", "", "JP", "392", "", "11", "", "", "34.8", "132.85", "Asia/Tokyo"),("1856703", "Miyazu", "", "JP", "392", "", "22", "", "", "35.53333", "135.18333", "Asia/Tokyo"),("1856717", "Miyazaki", "Миядзаки", "JP", "392", "", "25", "", "", "31.91667", "131.41667", "Asia/Tokyo"),("1856741", "Miyanoura", "", "JP", "392", "", "18", "", "", "30.4269", "130.57151", "Asia/Tokyo"),("1856775", "Miyakonojō", "", "JP", "392", "", "25", "", "", "31.73333", "131.06667", "Asia/Tokyo"),("1856828", "Miyata", "", "JP", "392", "", "07", "", "", "33.70811", "130.65297", "Asia/Tokyo"),("1856878", "Mitsuke", "", "JP", "392", "", "29", "", "", "37.53333", "138.93333", "Asia/Tokyo"),("1856881", "Mitsukaidō", "", "JP", "392", "", "14", "", "", "36.01667", "139.98333", "Asia/Tokyo"),("1856938", "Mitake", "", "JP", "392", "", "09", "1860188", "", "35.41667", "137.13333", "Asia/Tokyo"),("1856942", "Mitaka-shi", "", "JP", "392", "", "40", "", "", "35.68351", "139.55963", "Asia/Tokyo"),("1856977", "Mishima", "Мисима", "JP", "392", "", "37", "", "", "35.11667", "138.91667", "Asia/Tokyo"),("1857046", "Mino", "", "JP", "392", "", "32", "", "", "34.82691", "135.47057", "Asia/Tokyo"),("1857062", "Mino", "Мина", "JP", "392", "", "09", "", "", "35.53333", "136.91667", "Asia/Tokyo"),("1857144", "Minamirinkan", "", "JP", "392", "", "19", "", "", "35.49527", "139.44279", "Asia/Tokyo"),("1857208", "Minamata", "Минамата", "JP", "392", "", "21", "", "", "32.21667", "130.4", "Asia/Tokyo"),("1857209", "Minakuchichō-matoba", "", "JP", "392", "", "35", "", "", "34.96667", "136.16667", "Asia/Tokyo"),("1857260", "Mikuni", "", "JP", "392", "", "06", "", "", "36.21706", "136.15185", "Asia/Tokyo"),("1857276", "Miki", "Мики", "JP", "392", "", "13", "", "", "34.8", "134.98333", "Asia/Tokyo"),("1857334", "Mihara", "", "JP", "392", "", "11", "", "", "34.4", "133.08333", "Asia/Tokyo"),("1857379", "Mibu", "Мибу", "JP", "392", "", "38", "", "", "36.41667", "139.8", "Asia/Tokyo"),("1857403", "Menuma", "", "JP", "392", "", "34", "", "", "36.22245", "139.38205", "Asia/Tokyo"),("1857470", "Matsutō", "", "JP", "392", "", "15", "", "", "36.51667", "136.56667", "Asia/Tokyo"),("1857519", "Matsumoto", "Мацумото", "JP", "392", "", "26", "", "", "36.23333", "137.96667", "Asia/Tokyo"),("1857550", "Matsue", "Мацуэ", "JP", "392", "", "36", "", "", "35.48333", "133.05", "Asia/Tokyo"),("1857553", "Matsudo", "Мацудо", "JP", "392", "", "04", "", "", "35.77995", "139.90144", "Asia/Tokyo"),("1857560", "Matsubase", "", "JP", "392", "", "21", "", "", "32.65", "130.66667", "Asia/Tokyo"),("1857568", "Matsubara", "", "JP", "392", "", "32", "", "", "34.56667", "135.55", "Asia/Tokyo"),("1857594", "Masuda", "Масуд", "JP", "392", "", "36", "", "", "34.66667", "131.85", "Asia/Tokyo"),("1857651", "Maruoka", "", "JP", "392", "", "06", "", "", "36.1534", "136.27029", "Asia/Tokyo"),("1857659", "Kamimaruko", "Маруко", "JP", "392", "", "26", "", "", "36.31865", "138.27329", "Asia/Tokyo"),("1857665", "Marugame", "", "JP", "392", "", "17", "", "", "34.28333", "133.78333", "Asia/Tokyo"),("1857712", "Makurazaki", "", "JP", "392", "", "18", "", "", "31.26667", "130.31667", "Asia/Tokyo"),("1857751", "Maki", "", "JP", "392", "", "29", "1855427", "", "37.75", "138.88333", "Asia/Tokyo"),("1857766", "Maizuru", "Майдзуру", "JP", "392", "", "22", "", "", "35.45", "135.33333", "Asia/Tokyo"),("1857843", "Maebashi", "Маэбаси", "JP", "392", "", "10", "", "", "36.4", "139.08333", "Asia/Tokyo"),("1857844", "Maebaru-chūō", "", "JP", "392", "", "07", "", "", "33.55916", "130.20148", "Asia/Tokyo"),("1857871", "Machida", "Мачида", "JP", "392", "", "40", "1857869", "", "35.54028", "139.45083", "Asia/Tokyo"),("1857910", "Kyoto", "Киото", "JP", "392", "", "22", "1857906", "", "35.02107", "135.75385", "Asia/Tokyo"),("1858041", "Kushikino", "", "JP", "392", "", "18", "", "", "31.71667", "130.26667", "Asia/Tokyo"),("1858067", "Kusatsu", "Кусацу", "JP", "392", "", "35", "", "", "35.01667", "135.96667", "Asia/Tokyo"),("1858088", "Kurume", "Куруме", "JP", "392", "", "07", "", "", "33.31667", "130.51667", "Asia/Tokyo"),("1858249", "Kuroda", "Курода", "JP", "392", "", "01", "", "", "35.35", "136.78333", "Asia/Tokyo"),("1858283", "Kurihashi", "", "JP", "392", "", "34", "", "", "36.13333", "139.7", "Asia/Tokyo"),("1858296", "Kure", "Куре", "JP", "392", "", "11", "", "", "34.23222", "132.56658", "Asia/Tokyo"),("1858301", "Kurayoshi", "", "JP", "392", "", "41", "", "", "35.43333", "133.81667", "Asia/Tokyo"),("1858311", "Kurashiki", "Курашики", "JP", "392", "", "31", "", "", "34.58333", "133.76667", "Asia/Tokyo"),("1858421", "Kumamoto", "", "JP", "392", "", "21", "", "", "32.80589", "130.69181", "Asia/Tokyo"),("1858428", "Kumagaya", "Кумагая", "JP", "392", "", "34", "", "", "36.13497", "139.39004", "Asia/Tokyo"),("1858445", "Kukichūō", "Куки", "JP", "392", "", "34", "", "", "36.06739", "139.67498", "Asia/Tokyo"),("1858498", "Kudamatsu", "", "JP", "392", "", "45", "", "", "34", "131.86667", "Asia/Tokyo"),("1858591", "Kozakai-chō", "", "JP", "392", "", "01", "1862294", "", "34.8", "137.35889", "Asia/Tokyo"),("1858729", "Koshigaya", "", "JP", "392", "", "34", "", "", "35.89035", "139.78916", "Asia/Tokyo"),("1858756", "Kosai-shi", "", "JP", "392", "", "37", "", "", "34.7184", "137.53175", "Asia/Tokyo"),("1858794", "Kōnosu", "", "JP", "392", "", "34", "", "", "36.06868", "139.51684", "Asia/Tokyo"),("1858836", "Kōnan", "Конан", "JP", "392", "", "01", "", "", "35.33165", "136.87042", "Asia/Tokyo"),("1858858", "Komoro", "", "JP", "392", "", "26", "", "", "36.31667", "138.43333", "Asia/Tokyo"),("1858866", "Komono", "", "JP", "392", "", "23", "1857355", "", "35", "136.51667", "Asia/Tokyo"),("1858902", "Komatsushimachō", "", "JP", "392", "", "39", "", "", "34", "134.58333", "Asia/Tokyo"),("1858910", "Komatsu", "", "JP", "392", "", "15", "", "", "36.40263", "136.45088", "Asia/Tokyo"),("1858926", "Komaki", "Комаки", "JP", "392", "", "01", "", "", "35.28333", "136.91667", "Asia/Tokyo"),("1858964", "Kokubunji", "Кокубундзи", "JP", "392", "", "40", "", "", "35.70222", "139.47556", "Asia/Tokyo"),("1858972", "Kokubu-matsuki", "Кокубу", "JP", "392", "", "18", "", "", "31.73333", "130.76667", "Asia/Tokyo"),("1859093", "Koga", "Кога", "JP", "392", "", "14", "", "", "36.18333", "139.71667", "Asia/Tokyo"),("1859094", "Koga", "Кога", "JP", "392", "", "07", "", "", "33.73333", "130.46667", "Asia/Tokyo"),("1859100", "Kōfu", "Кофе", "JP", "392", "", "46", "", "", "35.66667", "138.56667", "Asia/Tokyo"),("1859113", "Kodamachō-kodamaminami", "Кодама", "JP", "392", "", "34", "", "", "36.18497", "139.13191", "Asia/Tokyo"),("1859146", "Kochi", "Кочин", "JP", "392", "", "20", "", "", "33.55", "133.53333", "Asia/Tokyo"),("1859171", "Kobe", "Кобе", "JP", "392", "", "13", "1859161", "", "34.6913", "135.183", "Asia/Tokyo"),("1859175", "Kobayashi", "Кобаяси", "JP", "392", "", "25", "", "", "31.98333", "130.98333", "Asia/Tokyo"),("1859234", "Kitsuki", "Кицуки", "JP", "392", "", "30", "", "", "33.41998", "131.61837", "Asia/Tokyo"),("1859307", "Kitakyushu", "Китакюсю", "JP", "392", "", "07", "1859306", "", "33.85181", "130.85034", "Asia/Tokyo"),("1859319", "Kitakata", "Китаката", "JP", "392", "", "08", "", "", "37.65", "139.86667", "Asia/Tokyo"),("1859335", "Kitahama", "", "JP", "392", "", "35", "", "", "35.16667", "135.91667", "Asia/Tokyo"),("1859383", "Kishiwada", "Кисивада", "JP", "392", "", "32", "", "", "34.46667", "135.36667", "Asia/Tokyo"),("1859393", "Kisarazu", "Кисарадзу", "JP", "392", "", "04", "", "", "35.38329", "139.93254", "Asia/Tokyo"),("1859400", "Kisai", "", "JP", "392", "", "34", "", "", "36.1", "139.58333", "Asia/Tokyo"),("1859405", "Kiryū", "Кири", "JP", "392", "", "10", "", "", "36.4", "139.33333", "Asia/Tokyo"),("1859492", "Kikuchi", "Кикути", "JP", "392", "", "21", "", "", "32.98333", "130.81667", "Asia/Tokyo"),("1859586", "Kazo", "", "JP", "392", "", "34", "", "", "36.11667", "139.6", "Asia/Tokyo"),("1859642", "Kawasaki", "Кавасаки", "JP", "392", "", "19", "1859635", "", "35.52056", "139.71722", "Asia/Tokyo"),("1859647", "Kawasaki", "", "JP", "392", "", "07", "1851269", "", "33.59993", "130.81495", "Asia/Tokyo"),("1859675", "Kawanishi", "", "JP", "392", "", "13", "", "", "34.81667", "135.41667", "Asia/Tokyo"),("1859730", "Kawaguchi", "Кавагути", "JP", "392", "", "34", "", "", "35.80521", "139.71072", "Asia/Tokyo"),("1859740", "Kawagoe", "Кавагоэ", "JP", "392", "", "34", "", "", "35.90861", "139.48528", "Asia/Tokyo"),("1859765", "Katsuyama", "", "JP", "392", "", "06", "", "", "36.06173", "136.50101", "Asia/Tokyo"),("1859884", "Kasukabe", "", "JP", "392", "", "34", "", "", "35.98308", "139.74966", "Asia/Tokyo"),("1859891", "Kasugai", "Касугай", "JP", "392", "", "01", "", "", "35.24762", "136.97229", "Asia/Tokyo"),("1859908", "Kashiwazaki", "Касивадзаки", "JP", "392", "", "29", "", "", "37.36667", "138.55", "Asia/Tokyo"),("1859924", "Kashiwa", "Касива", "JP", "392", "", "04", "", "", "35.86224", "139.97732", "Asia/Tokyo"),("1859941", "Kashima", "Касима", "JP", "392", "", "33", "", "", "33.10611", "130.09056", "Asia/Tokyo"),("1859951", "Kashihara-shi", "", "JP", "392", "JP", "28", "", "", "34.50896", "135.7929", "Asia/Tokyo"),("1859952", "Kashihara", "", "JP", "392", "", "32", "", "", "34.58333", "135.61667", "Asia/Tokyo"),("1859964", "Kaseda-shirakame", "", "JP", "392", "", "18", "", "", "31.41667", "130.31667", "Asia/Tokyo"),("1859990", "Kasaoka", "", "JP", "392", "", "31", "", "", "34.50597", "133.50391", "Asia/Tokyo"),("1859998", "Kasamatsuchō", "", "JP", "392", "", "09", "1863085", "", "35.36667", "136.76667", "Asia/Tokyo"),("1860034", "Kariya", "Кария", "JP", "392", "", "01", "", "", "34.98333", "136.98333", "Asia/Tokyo"),("1860063", "Karatsu", "Карацу", "JP", "392", "", "33", "", "", "33.4425", "129.96972", "Asia/Tokyo"),("1860095", "Kanzakimachi-kanzaki", "", "JP", "392", "", "33", "", "", "33.30895", "130.37383", "Asia/Tokyo"),("1860098", "Kanuma", "Канума", "JP", "392", "", "38", "", "", "36.55", "139.73333", "Asia/Tokyo"),("1860112", "Kanoya", "Каноя", "JP", "392", "", "18", "", "", "31.38333", "130.85", "Asia/Tokyo"),("1860122", "Kan’onjichō", "", "JP", "392", "", "17", "1860119", "", "34.1276", "133.64598", "Asia/Tokyo"),("1860176", "Kannabechō-yahiro", "", "JP", "392", "", "11", "", "", "34.55808", "133.41796", "Asia/Tokyo"),("1860191", "Kanie", "", "JP", "392", "", "01", "1865365", "", "35.13333", "136.8", "Asia/Tokyo"),("1860211", "Kanekomachi", "", "JP", "392", "", "10", "", "", "36.41097", "138.99621", "Asia/Tokyo"),("1860234", "Kanda", "Канда", "JP", "392", "", "07", "7406950", "", "33.78333", "130.98333", "Asia/Tokyo"),("1860243", "Kanazawa", "Канадзава", "JP", "392", "", "15", "", "", "36.6", "136.61667", "Asia/Tokyo"),("1860256", "Kanaya", "", "JP", "392", "", "37", "", "", "34.82022", "138.12775", "Asia/Tokyo"),("1860321", "Kamojimachō-jōgejima", "", "JP", "392", "", "39", "", "", "34.06803", "134.35033", "Asia/Tokyo"),("1860335", "Kamogatachō-kamogata", "", "JP", "392", "", "31", "", "", "34.53745", "133.58967", "Asia/Tokyo"),("1860341", "Kamo", "Камо", "JP", "392", "", "29", "", "", "37.66442", "139.03502", "Asia/Tokyo"),("1860437", "Kamirenjaku", "Митака", "JP", "392", "", "40", "", "", "35.69423", "139.55495", "Asia/Tokyo"),("1860458", "Kaminokawa", "", "JP", "392", "", "38", "1859750", "", "36.43333", "139.91667", "Asia/Tokyo"),("1860563", "Kamiichi", "", "JP", "392", "", "42", "", "", "36.7", "137.36667", "Asia/Tokyo"),("1860626", "Kameyama", "", "JP", "392", "", "23", "", "", "34.85", "136.45", "Asia/Tokyo"),("1860635", "Kameoka", "Камеока", "JP", "392", "", "22", "", "", "35", "135.58333", "Asia/Tokyo"),("1860648", "Kameda-honchō", "", "JP", "392", "", "29", "1855427", "", "37.87214", "139.1099", "Asia/Tokyo"),("1860672", "Kamakura", "Камакура", "JP", "392", "", "19", "", "", "35.30889", "139.55028", "Asia/Tokyo"),("1860704", "Kakogawachō-honmachi", "", "JP", "392", "", "13", "", "", "34.76943", "134.82905", "Asia/Tokyo"),("1860728", "Kakegawa", "Какэгава", "JP", "392", "", "37", "", "", "34.76667", "138.01667", "Asia/Tokyo"),("1860735", "Kakamigahara", "", "JP", "392", "", "09", "", "", "35.41667", "136.86667", "Asia/Tokyo"),("1860748", "Kashima-shi", "", "JP", "392", "JP", "14", "", "", "35.96536", "140.64474", "Asia/Tokyo"),("1860750", "Kajiki", "", "JP", "392", "", "18", "", "", "31.73333", "130.66667", "Asia/Tokyo"),("1860765", "Kaizuka", "", "JP", "392", "", "32", "", "", "34.45", "135.35", "Asia/Tokyo"),("1860785", "Kainan", "", "JP", "392", "", "43", "", "", "34.15", "135.2", "Asia/Tokyo"),("1860827", "Kagoshima", "", "JP", "392", "", "18", "", "", "31.56667", "130.55", "Asia/Tokyo"),("1860871", "Kadoma", "Кадоме", "JP", "392", "", "32", "", "", "34.7381", "135.57442", "Asia/Tokyo"),("1861084", "Izumo", "Идзумо", "JP", "392", "", "36", "", "", "35.36667", "132.76667", "Asia/Tokyo"),("1861095", "Izumiōtsu", "Идзумотсу", "JP", "392", "", "32", "", "", "34.5", "135.4", "Asia/Tokyo"),("1861107", "Izumi", "", "JP", "392", "", "32", "", "", "34.48333", "135.43333", "Asia/Tokyo"),("1861108", "Izumi", "Изуми", "JP", "392", "", "18", "", "", "32.08333", "130.36667", "Asia/Tokyo"),("1861164", "Iwatsuki", "", "JP", "392", "", "34", "", "", "35.96474", "139.69644", "Asia/Tokyo"),("1861171", "Iwata", "Ивата", "JP", "392", "", "37", "", "", "34.7", "137.85", "Asia/Tokyo"),("1861207", "Iwakura", "", "JP", "392", "", "01", "", "", "35.28333", "136.86667", "Asia/Tokyo"),("1861212", "Iwakuni", "Ивакуни", "JP", "392", "", "45", "", "", "34.16297", "132.22", "Asia/Tokyo"),("1861223", "Iwai", "", "JP", "392", "", "14", "", "", "36.05", "139.9", "Asia/Tokyo"),("1861244", "Iwade", "", "JP", "392", "", "43", "", "", "34.25", "135.31667", "Asia/Tokyo"),("1861261", "Itsukaichi", "", "JP", "392", "", "40", "", "", "35.72528", "139.21778", "Asia/Tokyo"),("1861280", "Itoman", "", "JP", "392", "", "47", "", "", "26.12647", "127.66918", "Asia/Tokyo"),("1861285", "Itoigawa", "", "JP", "392", "", "29", "", "", "37.03333", "137.85", "Asia/Tokyo"),("1861290", "Itō", "Ито", "JP", "392", "", "37", "", "", "34.96667", "139.08333", "Asia/Tokyo"),("1861310", "Itami", "Итами", "JP", "392", "", "13", "", "", "34.78427", "135.40126", "Asia/Tokyo"),("1861383", "Ishiki", "", "JP", "392", "", "01", "", "", "34.8", "137.01667", "Asia/Tokyo"),("1861393", "Ishikawa", "Исикава", "JP", "392", "", "47", "", "", "26.42333", "127.82139", "Asia/Tokyo"),("1861400", "Ishii", "Исии", "JP", "392", "", "39", "1856299", "", "34.06752", "134.44208", "Asia/Tokyo"),("1861406", "Ishige", "", "JP", "392", "", "14", "", "", "36.11667", "139.96667", "Asia/Tokyo"),("1861416", "Ishigaki", "Ишигаки", "JP", "392", "", "47", "", "", "24.34478", "124.15717", "Asia/Tokyo"),("1861436", "Isesaki", "", "JP", "392", "", "10", "", "", "36.31667", "139.2", "Asia/Tokyo"),("1861449", "Isehara", "", "JP", "392", "", "19", "", "", "35.39932", "139.31019", "Asia/Tokyo"),("1861450", "Ise", "Исэ", "JP", "392", "", "23", "", "", "34.48333", "136.7", "Asia/Tokyo"),("1861454", "Isawa", "", "JP", "392", "", "46", "", "", "35.65", "138.63333", "Asia/Tokyo"),("1861464", "Isahaya", "", "JP", "392", "", "27", "8301120", "", "32.84111", "130.04306", "Asia/Tokyo"),("1861528", "Inuyama", "Инуяма", "JP", "392", "", "09", "", "", "35.37995", "136.94295", "Asia/Tokyo"),("1861584", "Ino", "Ино", "JP", "392", "", "20", "1865726", "", "33.55", "133.43333", "Asia/Tokyo"),("1861586", "Innoshima", "", "JP", "392", "", "11", "", "", "34.28333", "133.18333", "Asia/Tokyo"),("1861602", "Inazawa", "", "JP", "392", "", "01", "", "", "35.25", "136.78333", "Asia/Tokyo"),("1861641", "Ina", "Ина", "JP", "392", "", "26", "", "", "35.82756", "137.95378", "Asia/Tokyo"),("1861677", "Imarichō-kō", "Имари", "JP", "392", "", "33", "", "", "33.27362", "129.87877", "Asia/Tokyo"),("1861699", "Imaichi", "", "JP", "392", "", "38", "", "", "36.71667", "139.68333", "Asia/Tokyo"),("1861749", "Ikoma", "Икома", "JP", "392", "", "28", "1861747", "", "34.68333", "135.7", "Asia/Tokyo"),("1861795", "Ikeda", "Икеда", "JP", "392", "", "32", "", "", "34.82208", "135.4298", "Asia/Tokyo"),("1861799", "Ikedachō", "", "JP", "392", "", "39", "", "", "34.02849", "133.80616", "Asia/Tokyo"),("1861825", "Ijūin", "", "JP", "392", "", "18", "", "", "31.61667", "130.4", "Asia/Tokyo"),("1861835", "Iizuka", "Иидзука", "JP", "392", "", "07", "", "", "33.63654", "130.68678", "Asia/Tokyo"),("1861838", "Iiyama", "", "JP", "392", "", "26", "", "", "36.85", "138.36667", "Asia/Tokyo"),("1861864", "Iida", "Иида", "JP", "392", "", "26", "", "", "35.51965", "137.82074", "Asia/Tokyo"),("1861949", "Ichinomiya", "", "JP", "392", "", "01", "", "", "35.3", "136.8", "Asia/Tokyo"),("1862010", "Ibusuki", "", "JP", "392", "", "18", "", "", "31.23333", "130.65", "Asia/Tokyo"),("1862033", "Ibaraki", "Ибараки", "JP", "392", "", "32", "1862032", "", "34.81641", "135.56828", "Asia/Tokyo"),("1862034", "Ibara", "", "JP", "392", "", "31", "", "", "34.6", "133.46667", "Asia/Tokyo"),("1862098", "Hotaka", "", "JP", "392", "", "26", "", "", "36.3396", "137.88254", "Asia/Tokyo"),("1862198", "Honjō", "", "JP", "392", "", "34", "", "", "36.2378", "139.19023", "Asia/Tokyo"),("1862230", "Hondomachi-hondo", "Хондо", "JP", "392", "", "21", "", "", "32.45993", "130.16713", "Asia/Tokyo"),("1862302", "Hōfu", "", "JP", "392", "", "45", "", "", "34.05", "131.56667", "Asia/Tokyo"),("1862352", "Hitoyoshi", "", "JP", "392", "", "21", "", "", "32.21667", "130.75", "Asia/Tokyo"),("1862373", "Hita", "Хиты", "JP", "392", "", "30", "", "", "33.3213", "130.94098", "Asia/Tokyo"),("1862389", "Hisai-motomachi", "", "JP", "392", "", "23", "", "", "34.66667", "136.46667", "Asia/Tokyo"),("1862415", "Hiroshima", "Хиросима", "JP", "392", "", "11", "1862412", "", "34.4", "132.45", "Asia/Tokyo"),("1862462", "Hiratsuka", "Хирацука", "JP", "392", "", "19", "", "", "35.32785", "139.33735", "Asia/Tokyo"),("1862471", "Hiratachō", "", "JP", "392", "", "36", "", "", "35.43333", "132.81667", "Asia/Tokyo"),("1862505", "Hirara", "", "JP", "392", "", "47", "", "", "24.80379", "125.30222", "Asia/Tokyo"),("1862540", "Hirakata", "", "JP", "392", "", "32", "1862538", "", "34.81352", "135.64914", "Asia/Tokyo"),("1862555", "Hirado", "Хирадо", "JP", "392", "", "27", "7418805", "", "33.36853", "129.55247", "Asia/Tokyo"),("1862599", "Hino", "", "JP", "392", "", "40", "", "", "35.67306", "139.40028", "Asia/Tokyo"),("1862601", "Hino", "", "JP", "392", "", "35", "1863686", "", "35", "136.25", "Asia/Tokyo"),("1862612", "Himimachi", "Хими", "JP", "392", "", "42", "1862610", "", "36.85", "136.98333", "Asia/Tokyo"),("1862627", "Himeji", "Химэдзи", "JP", "392", "", "13", "", "", "34.81667", "134.7", "Asia/Tokyo"),("1862636", "Hikone", "Хиконэ", "JP", "392", "", "35", "", "", "35.25", "136.25", "Asia/Tokyo"),("1862689", "Hiji", "", "JP", "392", "", "30", "7414041", "", "33.37081", "131.53025", "Asia/Tokyo"),("1862912", "Hekinan", "Хекинан", "JP", "392", "", "01", "", "", "34.88333", "136.98333", "Asia/Tokyo"),("1862992", "Hayama", "Хаяма", "JP", "392", "", "19", "1856851", "", "35.27651", "139.57733", "Asia/Tokyo"),("1863018", "Hatsukaichi", "", "JP", "392", "", "11", "", "", "34.35", "132.33333", "Asia/Tokyo"),("1863023", "Hatogaya-honchō", "", "JP", "392", "", "34", "1859726", "", "35.83314", "139.7425", "Asia/Tokyo"),("1863082", "Hashimoto", "Хасимото", "JP", "392", "", "43", "", "", "34.31667", "135.61667", "Asia/Tokyo"),("1863173", "Hanyū", "Ханьюй", "JP", "392", "", "34", "", "", "36.16667", "139.53333", "Asia/Tokyo"),("1863183", "Hannō", "Ханно", "JP", "392", "", "34", "", "", "35.85194", "139.31806", "Asia/Tokyo"),("1863209", "Handa", "Ханда", "JP", "392", "", "01", "", "", "34.88333", "136.93333", "Asia/Tokyo"),("1863279", "Hamanoichi", "", "JP", "392", "", "18", "", "", "31.71667", "130.73333", "Asia/Tokyo"),("1863289", "Hamamatsu", "Хамамацу", "JP", "392", "", "37", "1863288", "", "34.7", "137.73333", "Asia/Tokyo"),("1863293", "Hamakita", "", "JP", "392", "", "37", "1863288", "", "34.8", "137.78333", "Asia/Tokyo"),("1863310", "Hamada", "Хамада", "JP", "392", "", "36", "", "", "34.88333", "132.08333", "Asia/Tokyo"),("1863341", "Hakui", "", "JP", "392", "", "15", "", "", "36.88333", "136.78333", "Asia/Tokyo"),("1863357", "Hakone", "", "JP", "392", "", "19", "", "", "35.18945", "139.02649", "Asia/Tokyo"),("1863398", "Haibara-akanedai", "", "JP", "392", "", "28", "", "", "34.53333", "135.95", "Asia/Tokyo"),("1863418", "Hagi", "", "JP", "392", "", "45", "", "", "34.4", "131.41667", "Asia/Tokyo"),("1863426", "Katsuren-haebaru", "", "JP", "392", "", "47", "", "", "26.33294", "127.87403", "Asia/Tokyo"),("1863431", "Hadano", "Хадано", "JP", "392", "", "19", "", "", "35.37111", "139.22361", "Asia/Tokyo"),("1863440", "Hachiōji", "Хатиодзи", "JP", "392", "", "40", "", "", "35.65583", "139.32389", "Asia/Tokyo"),("1863451", "Ōmihachiman", "", "JP", "392", "", "35", "", "", "35.12861", "136.0976", "Asia/Tokyo"),("1863482", "Gyōda", "", "JP", "392", "", "34", "", "", "36.14074", "139.46011", "Asia/Tokyo"),("1863495", "Gushikawa", "", "JP", "392", "", "47", "", "", "26.35937", "127.86735", "Asia/Tokyo"),("1863521", "Gōtsuchō", "", "JP", "392", "", "36", "", "", "35.00856", "132.2257", "Asia/Tokyo"),("1863528", "Gotenba", "Готемба", "JP", "392", "", "37", "", "", "35.31859", "138.94343", "Asia/Tokyo"),("1863540", "Gosen", "Госен", "JP", "392", "", "29", "", "", "37.73333", "139.16667", "Asia/Tokyo"),("1863541", "Gose", "", "JP", "392", "", "28", "", "", "34.45", "135.73333", "Asia/Tokyo"),("1863592", "Gojō", "", "JP", "392", "", "28", "", "", "34.35", "135.7", "Asia/Tokyo"),("1863611", "Gōdo", "Года", "JP", "392", "", "09", "", "", "35.41667", "136.6", "Asia/Tokyo"),("1863614", "Gobō", "Гобо", "JP", "392", "", "43", "1862875", "", "33.88333", "135.15", "Asia/Tokyo"),("1863627", "Ginowan", "", "JP", "392", "", "47", "", "", "26.26265", "127.76147", "Asia/Tokyo"),("1863641", "Gifu-shi", "Гифу", "JP", "392", "", "09", "", "", "35.42291", "136.76039", "Asia/Tokyo"),("1863693", "Gamagōri", "", "JP", "392", "", "01", "", "", "34.83333", "137.23333", "Asia/Tokyo"),("1863713", "Futtsu", "Фуццу", "JP", "392", "", "04", "", "", "35.3108", "139.81877", "Asia/Tokyo"),("1863905", "Honchō", "Фунабаси", "JP", "392", "", "04", "", "", "35.70129", "139.98648", "Asia/Tokyo"),("1863917", "Fukuyama", "Фукуяма", "JP", "392", "", "11", "", "", "34.48333", "133.36667", "Asia/Tokyo"),("1863945", "Fukuroi", "Фукурои", "JP", "392", "", "37", "", "", "34.75", "137.91667", "Asia/Tokyo"),("1863953", "Fukura", "", "JP", "392", "", "13", "", "", "34.25765", "134.71535", "Asia/Tokyo"),("1863967", "Fukuoka", "Фукуока", "JP", "392", "", "07", "1863955", "", "33.6", "130.41667", "Asia/Tokyo"),("1863973", "Fukumitsu", "", "JP", "392", "", "42", "", "", "36.55751", "136.86945", "Asia/Tokyo"),("1863978", "Nishifukuma", "", "JP", "392", "", "07", "", "", "33.76627", "130.47461", "Asia/Tokyo"),("1863985", "Fukui-shi", "Фукуй", "JP", "392", "", "06", "", "", "36.06443", "136.22257", "Asia/Tokyo"),("1863997", "Fukuechō", "", "JP", "392", "", "27", "", "", "32.69732", "128.84561", "Asia/Tokyo"),("1864009", "Fukuchiyama", "", "JP", "392", "", "22", "", "", "35.3", "135.11667", "Asia/Tokyo"),("1864025", "Fukiage-fujimi", "", "JP", "392", "", "34", "", "", "36.1", "139.45", "Asia/Tokyo"),("1864031", "Fukayachō", "", "JP", "392", "", "34", "", "", "36.2", "139.28333", "Asia/Tokyo"),("1864092", "Fujisawa", "Фудзисава", "JP", "392", "", "19", "", "", "35.34926", "139.47666", "Asia/Tokyo"),("1864098", "Fujioka", "Фудзиока", "JP", "392", "", "38", "", "", "36.25", "139.65", "Asia/Tokyo"),("1864099", "Fujioka", "Фудзиока", "JP", "392", "", "10", "", "", "36.24624", "139.07204", "Asia/Tokyo"),("1864105", "Fujinomiya", "Фудзиномия", "JP", "392", "", "37", "", "", "35.21667", "138.61667", "Asia/Tokyo"),("1864132", "Fujieda", "Фудзиэда", "JP", "392", "", "37", "", "", "34.86667", "138.26667", "Asia/Tokyo"),("1864134", "Fuji", "Фудзи", "JP", "392", "", "37", "", "", "35.16667", "138.68333", "Asia/Tokyo"),("1864155", "Fuchūchō", "Фучу", "JP", "392", "", "11", "", "", "34.5735", "133.23513", "Asia/Tokyo"),("1864180", "Enzan", "", "JP", "392", "", "46", "", "", "35.7", "138.73333", "Asia/Tokyo"),("1864416", "Daitōchō", "", "JP", "392", "", "32", "", "", "34.71378", "135.62033", "Asia/Tokyo"),("1864518", "Chōfugaoka", "", "JP", "392", "", "40", "", "", "35.65924", "139.54837", "Asia/Tokyo"),("1864549", "Chiryū", "", "JP", "392", "", "01", "", "", "35", "137.03333", "Asia/Tokyo"),("1864557", "Chino", "", "JP", "392", "", "26", "", "", "35.9944", "138.15428", "Asia/Tokyo"),("1864572", "Chikushino-shi", "", "JP", "392", "", "07", "", "", "33.49631", "130.5156", "Asia/Tokyo"),("1864624", "Chigasaki", "", "JP", "392", "", "19", "", "", "35.33638", "139.40434", "Asia/Tokyo"),("1864637", "Chichibu", "", "JP", "392", "", "34", "", "", "35.99028", "139.07639", "Asia/Tokyo"),("1864652", "Chatan", "", "JP", "392", "", "47", "1855990", "", "26.30948", "127.77024", "Asia/Tokyo"),("1864750", "Beppu", "Бэппу", "JP", "392", "", "30", "", "", "33.27945", "131.49751", "Asia/Tokyo"),("1864873", "Ayabe", "Аябе", "JP", "392", "", "22", "", "", "35.3", "135.25", "Asia/Tokyo"),("1864945", "Atami", "Атами", "JP", "392", "", "37", "", "", "35.08834", "139.05325", "Asia/Tokyo"),("1864985", "Ashiya", "", "JP", "392", "", "13", "", "", "34.72807", "135.30264", "Asia/Tokyo"),("1865005", "Ashikaga", "Асикага", "JP", "392", "", "38", "", "", "36.33333", "139.45", "Asia/Tokyo"),("1865207", "Arai", "", "JP", "392", "", "29", "", "", "37.00059", "138.2259", "Asia/Tokyo"),("1865290", "Annaka", "", "JP", "392", "", "10", "", "", "36.33011", "138.89585", "Asia/Tokyo"),("1865294", "Anjō", "Андзё", "JP", "392", "JP", "01", "", "", "34.95828", "137.08054", "Asia/Tokyo"),("1865309", "Anan", "Анан", "JP", "392", "", "39", "", "", "33.91667", "134.65", "Asia/Tokyo"),("1865375", "Amagi", "", "JP", "392", "", "07", "", "", "33.41804", "130.65413", "Asia/Tokyo"),("1865387", "Amagasaki", "", "JP", "392", "", "13", "", "", "34.71667", "135.41667", "Asia/Tokyo"),("1865401", "Akune", "", "JP", "392", "", "18", "", "", "32.01667", "130.2", "Asia/Tokyo"),("1865412", "Kariya", "Ако", "JP", "392", "", "13", "", "", "34.75136", "134.38734", "Asia/Tokyo"),("1865449", "Aki", "Аки", "JP", "392", "", "20", "", "", "33.5", "133.9", "Asia/Tokyo"),("1865661", "Aioi", "", "JP", "392", "", "13", "", "", "34.80361", "134.46806", "Asia/Tokyo"),("1865714", "Ageoshimo", "", "JP", "392", "", "34", "", "", "35.97145", "139.61382", "Asia/Tokyo"),("1894616", "Okinawa", "Окинава", "JP", "392", "", "47", "", "", "26.33583", "127.80139", "Asia/Tokyo"),("1895695", "Kushima", "", "JP", "392", "", "25", "", "", "31.48621", "131.2421", "Asia/Tokyo"),("1896348", "Hikari", "Хикари", "JP", "392", "", "45", "", "", "33.955", "131.95", "Asia/Tokyo"),("1899102", "Nagato", "Нагато", "JP", "392", "", "45", "", "", "34.38333", "131.2", "Asia/Tokyo"),("1907123", "Hasuda", "", "JP", "392", "", "34", "", "", "35.97113", "139.6491", "Asia/Tokyo"),("1907125", "Kamifukuoka", "", "JP", "392", "", "34", "", "", "35.87266", "139.51369", "Asia/Tokyo"),("1907146", "Sayama", "Саяма", "JP", "392", "", "34", "", "", "35.85295", "139.41212", "Asia/Tokyo"),("1907148", "Fussa", "", "JP", "392", "", "40", "", "", "35.73667", "139.32361", "Asia/Tokyo"),("1907299", "Asaka", "Асака", "JP", "392", "", "34", "", "", "35.80472", "139.60194", "Asia/Tokyo"),("1907300", "Wako", "Вако", "JP", "392", "", "34", "", "", "35.78944", "139.62333", "Asia/Tokyo"),("1907301", "Shimotoda", "Тода", "JP", "392", "", "34", "", "", "35.815", "139.6853", "Asia/Tokyo"),("1907307", "Kimitsu", "Кимицу", "JP", "392", "", "04", "", "", "35.35043", "139.87029", "Asia/Tokyo"),("1907309", "Miura", "Миура", "JP", "392", "", "19", "", "", "35.14", "139.61917", "Asia/Tokyo"),("1926004", "Wakayama", "Вакаяма", "JP", "392", "", "43", "", "", "34.23333", "135.16667", "Asia/Tokyo"),("1926006", "Iyo", "Ие", "JP", "392", "", "05", "", "", "33.75139", "132.70139", "Asia/Tokyo"),("1926020", "Uwajima", "Увадзима", "JP", "392", "", "05", "", "", "33.22375", "132.56001", "Asia/Tokyo"),("1926054", "Saijō", "Сайдзё", "JP", "392", "", "05", "", "", "33.91667", "133.18333", "Asia/Tokyo"),("1926055", "Ōzu", "Одзу", "JP", "392", "", "05", "", "", "33.5", "132.55", "Asia/Tokyo"),("1926099", "Matsuyama", "Мацуяма", "JP", "392", "", "05", "7406319", "", "33.83916", "132.76574", "Asia/Tokyo"),("1926101", "Masaki-chō", "", "JP", "392", "", "05", "1861141", "1926101", "33.78757", "132.71124", "Asia/Tokyo"),("1926116", "Kawanoechō", "", "JP", "392", "", "05", "", "", "34.01654", "133.57844", "Asia/Tokyo"),("1926142", "Hōjō", "Ходзе", "JP", "392", "", "05", "", "", "33.97661", "132.77767", "Asia/Tokyo"),("2110460", "Yuzawa", "Юдзава", "JP", "392", "", "02", "", "", "39.16667", "140.5", "Asia/Tokyo"),("2110480", "Yotsukaidō", "", "JP", "392", "", "04", "", "", "35.65", "140.16667", "Asia/Tokyo"),("2110498", "Yonezawa", "Йонезава", "JP", "392", "", "44", "", "", "37.91", "140.11667", "Asia/Tokyo"),("2110506", "Yokotemachi", "", "JP", "392", "", "02", "", "", "39.31691", "140.55034", "Asia/Tokyo"),("2110518", "Yōkaichiba", "", "JP", "392", "", "04", "", "", "35.7", "140.55", "Asia/Tokyo"),("2110538", "Yanagawamachi-saiwaichō", "Янагава", "JP", "392", "", "08", "", "", "37.85", "140.6", "Asia/Tokyo"),("2110541", "Yamoto", "", "JP", "392", "", "24", "", "", "38.42738", "141.21487", "Asia/Tokyo"),("2110556", "Yamagata", "Ямагата", "JP", "392", "", "44", "", "", "38.23333", "140.36667", "Asia/Tokyo"),("2110560", "Yamada", "Ямада", "JP", "392", "", "16", "", "", "39.46667", "141.95", "Asia/Tokyo"),("2110579", "Yachimata", "", "JP", "392", "", "04", "", "", "35.65", "140.31667", "Asia/Tokyo"),("2110586", "Watari", "Ватари", "JP", "392", "", "24", "7446988", "", "38.035", "140.85111", "Asia/Tokyo"),("2110596", "Wakuya", "", "JP", "392", "", "24", "7446987", "", "38.54465", "141.13461", "Asia/Tokyo"),("2110629", "Ushiku", "", "JP", "392", "", "14", "", "", "35.96667", "140.13333", "Asia/Tokyo"),("2110683", "Tsukuba", "", "JP", "392", "", "14", "", "", "36.2", "140.1", "Asia/Tokyo"),("2110729", "Toride", "", "JP", "392", "", "14", "", "", "35.9", "140.08333", "Asia/Tokyo"),("2110735", "Tōno", "Тона", "JP", "392", "", "16", "", "", "39.31667", "141.53333", "Asia/Tokyo"),("2110743", "Tomobe", "", "JP", "392", "", "14", "", "", "36.35", "140.3", "Asia/Tokyo"),("2110744", "Tomiya", "", "JP", "392", "", "24", "2112074", "", "38.39306", "140.88611", "Asia/Tokyo"),("2110774", "Tōgane", "", "JP", "392", "", "04", "", "", "35.55", "140.36667", "Asia/Tokyo"),("2110793", "Tendō", "Тендо", "JP", "392", "", "44", "", "", "38.35361", "140.36972", "Asia/Tokyo"),("2110891", "Takahata", "Такахата", "JP", "392", "", "44", "", "", "38.0025", "140.19111", "Asia/Tokyo"),("2110893", "Takahagi", "", "JP", "392", "", "14", "", "", "36.71667", "140.71667", "Asia/Tokyo"),("2110959", "Sukagawa", "", "JP", "392", "", "08", "", "", "37.28333", "140.38333", "Asia/Tokyo"),("2110994", "Shizukuishi", "", "JP", "392", "", "16", "7441804", "", "39.69414", "140.98442", "Asia/Tokyo"),("2111008", "Shisui", "", "JP", "392", "", "04", "", "", "35.71667", "140.26667", "Asia/Tokyo"),("2111016", "Shiroishi", "", "JP", "392", "", "24", "", "", "38.00333", "140.61833", "Asia/Tokyo"),("2111018", "Shiroi", "", "JP", "392", "", "04", "", "", "35.8", "140.06667", "Asia/Tokyo"),("2111049", "Shiogama", "Сиогама", "JP", "392", "", "24", "", "", "38.31667", "141.03333", "Asia/Tokyo"),("2111065", "Shinjō", "Синдзе", "JP", "392", "", "44", "", "", "38.75861", "140.30083", "Asia/Tokyo"),("2111149", "Sendai", "Сендай", "JP", "392", "", "24", "2111147", "", "38.26667", "140.86667", "Asia/Tokyo"),("2111173", "Sawara", "", "JP", "392", "", "04", "", "", "35.88333", "140.5", "Asia/Tokyo"),("2111220", "Sakura", "Сакура", "JP", "392", "", "04", "", "", "35.71667", "140.23333", "Asia/Tokyo"),("2111248", "Sagae", "", "JP", "392", "", "44", "", "", "38.3725", "140.2725", "Asia/Tokyo"),("2111258", "Ryūgasaki", "", "JP", "392", "", "14", "", "", "35.9", "140.18333", "Asia/Tokyo"),("2111277", "Rifu", "", "JP", "392", "", "24", "2111889", "", "38.33092", "140.97691", "Asia/Tokyo"),("2111310", "Ōtsuchi", "", "JP", "392", "", "16", "", "", "39.36667", "141.9", "Asia/Tokyo"),("2111325", "Ōtawara", "", "JP", "392", "", "38", "", "", "36.86667", "140.03333", "Asia/Tokyo"),("2111425", "Ōmiya", "", "JP", "392", "", "14", "", "", "36.55", "140.41667", "Asia/Tokyo"),("2111429", "Omigawa", "", "JP", "392", "", "04", "", "", "35.85", "140.61667", "Asia/Tokyo"),("2111435", "Ōmagari", "", "JP", "392", "", "02", "", "", "39.45", "140.48333", "Asia/Tokyo"),("2111441", "Okunoya", "", "JP", "392", "", "14", "", "", "36.28333", "140.41667", "Asia/Tokyo"),("2111461", "Ōkawara", "", "JP", "392", "", "24", "2111130", "", "38.05", "140.73361", "Asia/Tokyo"),("2111495", "Ōhara", "", "JP", "392", "", "04", "", "", "35.24761", "140.39289", "Asia/Tokyo"),("2111530", "Ōfunato", "", "JP", "392", "", "16", "", "", "39.07167", "141.71667", "Asia/Tokyo"),("2111559", "Obanazawa", "", "JP", "392", "", "44", "", "", "38.60333", "140.40194", "Asia/Tokyo"),("2111567", "Ōarai", "", "JP", "392", "", "14", "2112766", "", "36.31409", "140.58389", "Asia/Tokyo"),("2111568", "Ōami", "", "JP", "392", "", "04", "2111211", "", "35.51667", "140.31667", "Asia/Tokyo"),("2111656", "Nihommatsu", "", "JP", "392", "", "08", "", "", "37.58333", "140.43333", "Asia/Tokyo"),("2111677", "Narutō", "", "JP", "392", "", "04", "", "", "35.6", "140.41667", "Asia/Tokyo"),("2111684", "Narita", "Нарита", "JP", "392", "", "04", "", "", "35.78333", "140.31667", "Asia/Tokyo"),("2111704", "Namie", "", "JP", "392", "", "08", "7451488", "", "37.48333", "141", "Asia/Tokyo"),("2111749", "Naka", "", "JP", "392", "", "14", "", "", "36.05", "140.16667", "Asia/Tokyo"),("2111781", "Nagai", "Нагаи", "JP", "392", "", "44", "", "", "38.10361", "140.035", "Asia/Tokyo"),("2111824", "Motomiya", "", "JP", "392", "", "08", "", "", "37.51391", "140.40063", "Asia/Tokyo"),("2111827", "Motegi", "", "JP", "392", "", "38", "2112845", "", "36.51667", "140.18333", "Asia/Tokyo"),("2111831", "Moriya", "Мория", "JP", "392", "", "14", "", "", "35.93333", "140", "Asia/Tokyo"),("2111834", "Morioka", "Мориока", "JP", "392", "", "16", "", "", "39.7", "141.15", "Asia/Tokyo"),("2111836", "Mooka", "", "JP", "392", "", "38", "", "", "36.43333", "140.01667", "Asia/Tokyo"),("2111855", "Mobara", "", "JP", "392", "", "04", "", "", "35.42583", "140.29608", "Asia/Tokyo"),("2111859", "Mizusawa", "Мидзусава", "JP", "392", "", "16", "", "", "39.13333", "141.13333", "Asia/Tokyo"),("2111884", "Miyako", "Мияко", "JP", "392", "", "16", "", "", "39.64691", "141.94057", "Asia/Tokyo"),("2111901", "Mito", "", "JP", "392", "", "14", "", "", "36.35", "140.45", "Asia/Tokyo"),("2111943", "Miharu", "", "JP", "392", "", "08", "2110839", "", "37.43333", "140.48333", "Asia/Tokyo"),("2111964", "Matsushima", "Мацусима", "JP", "392", "", "24", "2111889", "", "38.37357", "141.06105", "Asia/Tokyo"),("2111999", "Mashiko", "", "JP", "392", "", "38", "2112845", "", "36.46667", "140.1", "Asia/Tokyo"),("2112008", "Marumori", "", "JP", "392", "", "24", "7446984", "", "37.91667", "140.76667", "Asia/Tokyo"),("2112019", "Makabe", "", "JP", "392", "", "14", "", "", "36.26667", "140.1", "Asia/Tokyo"),("2112077", "Kuroiso", "", "JP", "392", "", "38", "", "", "36.96667", "140.05", "Asia/Tokyo"),("2112141", "Kōriyama", "Корияма", "JP", "392", "", "08", "", "", "37.4", "140.38333", "Asia/Tokyo"),("2112182", "Kogota", "", "JP", "392", "", "24", "7446987", "", "38.55", "141.05", "Asia/Tokyo"),("2112227", "Kitakami", "Китаками", "JP", "392", "", "16", "", "", "39.28333", "141.11667", "Asia/Tokyo"),("2112232", "Kitaibaraki", "", "JP", "392", "", "14", "", "", "36.78671", "140.74901", "Asia/Tokyo"),("2112297", "Kamogawa", "Кавагути", "JP", "392", "", "04", "", "", "35.0969", "140.1003", "Asia/Tokyo"),("2112309", "Katsuura", "Кацуура", "JP", "392", "", "04", "", "", "35.14621", "140.31507", "Asia/Tokyo"),("2112312", "Katsuta", "", "JP", "392", "", "14", "", "", "36.38333", "140.53333", "Asia/Tokyo"),("2112319", "Katori-shi", "", "JP", "392", "", "04", "", "", "35.89767", "140.49943", "Asia/Tokyo"),("2112343", "Kasama", "Касама", "JP", "392", "", "14", "", "", "36.38333", "140.26667", "Asia/Tokyo"),("2112354", "Karasuyama", "", "JP", "392", "", "38", "", "", "36.65", "140.15", "Asia/Tokyo"),("2112409", "Kaminoyama", "", "JP", "392", "", "44", "", "", "38.15389", "140.27361", "Asia/Tokyo"),("2112444", "Kamaishi", "Камаиси", "JP", "392", "", "16", "", "", "39.27694", "141.86801", "Asia/Tokyo"),("2112454", "Kakunodatemachi", "", "JP", "392", "", "02", "", "", "39.58926", "140.56724", "Asia/Tokyo"),("2112455", "Kakuda", "Какудский", "JP", "392", "", "24", "", "", "37.97451", "140.77202", "Asia/Tokyo"),("2112521", "Iwase", "Ивасэ", "JP", "392", "", "14", "", "", "36.35", "140.1", "Asia/Tokyo"),("2112527", "Iwanuma", "", "JP", "392", "", "24", "", "", "38.10472", "140.85944", "Asia/Tokyo"),("2112539", "Iwaki", "Иваки", "JP", "392", "", "08", "", "", "37.05", "140.88333", "Asia/Tokyo"),("2112555", "Itako", "", "JP", "392", "", "14", "", "", "35.93333", "140.55", "Asia/Tokyo"),("2112571", "Ishioka", "Исиока", "JP", "392", "", "14", "", "", "36.18333", "140.26667", "Asia/Tokyo"),("2112576", "Ishinomaki", "", "JP", "392", "", "24", "", "", "38.41667", "141.3", "Asia/Tokyo"),("2112583", "Ishikawa", "Исикава", "JP", "392", "", "08", "7451502", "", "37.15", "140.45", "Asia/Tokyo"),("2112615", "Inawashiro", "", "JP", "392", "", "08", "1848677", "", "37.56667", "140.11667", "Asia/Tokyo"),("2112656", "Ichinoseki", "", "JP", "392", "", "16", "", "", "38.91667", "141.13333", "Asia/Tokyo"),("2112664", "Ichihara", "Итихара", "JP", "392", "", "04", "", "", "35.51667", "140.08333", "Asia/Tokyo"),("2112692", "Hobaramachi", "", "JP", "392", "", "08", "", "", "37.81667", "140.55", "Asia/Tokyo"),("2112708", "Hitachi", "", "JP", "392", "", "14", "", "", "36.6", "140.65", "Asia/Tokyo"),("2112758", "Higashine", "", "JP", "392", "", "44", "", "", "38.43889", "140.40056", "Asia/Tokyo"),("2112802", "Hasaki", "", "JP", "392", "", "04", "", "", "35.73333", "140.83333", "Asia/Tokyo"),("2112823", "Hanamaki", "", "JP", "392", "", "16", "", "", "39.38333", "141.11667", "Asia/Tokyo"),("2112899", "Furukawa", "", "JP", "392", "", "24", "", "", "38.57167", "140.95556", "Asia/Tokyo"),("2112903", "Funehikimachi-funehiki", "", "JP", "392", "", "08", "", "", "37.44722", "140.5771", "Asia/Tokyo"),("2112913", "Funaishikawa", "", "JP", "392", "", "14", "2111742", "", "36.46667", "140.56667", "Asia/Tokyo"),("2112923", "Fukushima", "Фукусима", "JP", "392", "", "08", "", "", "37.75", "140.46667", "Asia/Tokyo"),("2112940", "Fujishiro", "", "JP", "392", "", "14", "", "", "35.91667", "140.11667", "Asia/Tokyo"),("2112963", "Edosaki", "", "JP", "392", "", "14", "", "", "35.95", "140.31667", "Asia/Tokyo"),("2112989", "Daigo", "Даиго", "JP", "392", "", "14", "2112115", "", "36.76667", "140.35", "Asia/Tokyo"),("2113015", "Chiba", "Чиба", "JP", "392", "", "04", "2113012", "", "35.6", "140.11667", "Asia/Tokyo"),("2113077", "Asahi", "Асахи", "JP", "392", "", "04", "", "", "35.71667", "140.65", "Asia/Tokyo"),("2113115", "Ami", "Ами", "JP", "392", "", "14", "2112616", "", "36.03333", "140.2", "Asia/Tokyo"),("2113126", "Akita", "", "JP", "392", "", "02", "", "", "39.71667", "140.11667", "Asia/Tokyo"),("2113164", "Abiko", "", "JP", "392", "", "04", "", "", "35.86667", "140.01667", "Asia/Tokyo"),("2113719", "Akita", "", "JP", "392", "", "02", "", "", "39.71667", "140.1", "Asia/Tokyo"),("2127383", "Bihoro", "", "JP", "392", "", "12", "7428076", "", "43.82278", "144.10444", "Asia/Tokyo"),("2127515", "Wakkanai", "Вакканай", "JP", "392", "", "12", "", "", "45.40944", "141.67389", "Asia/Tokyo"),("2127545", "Utashinai", "", "JP", "392", "", "12", "", "", "43.51667", "142.05", "Asia/Tokyo"),("2127733", "Tomakomai", "Томакомай", "JP", "392", "", "12", "", "", "42.63694", "141.60333", "Asia/Tokyo"),("2127802", "Tōbetsu", "", "JP", "392", "", "12", "7428085", "", "43.21694", "141.51694", "Asia/Tokyo"),("2127878", "Mutsu", "Муцу", "JP", "392", "", "03", "", "", "41.28944", "141.21694", "Asia/Tokyo"),("2127896", "Takikawa", "", "JP", "392", "", "12", "", "", "43.55278", "141.90639", "Asia/Tokyo"),("2127910", "Takanosu", "", "JP", "392", "", "02", "", "", "40.22268", "140.36611", "Asia/Tokyo"),("2127955", "Sunagawa", "", "JP", "392", "", "12", "", "", "43.48639", "141.90556", "Asia/Tokyo"),("2128025", "Shizunai-furukawachō", "", "JP", "392", "", "12", "7428083", "", "42.33389", "142.36694", "Asia/Tokyo"),("2128072", "Shiraoi", "", "JP", "392", "", "12", "7428110", "", "42.55", "141.35", "Asia/Tokyo"),("2128147", "Shimo-furano", "", "JP", "392", "", "12", "", "", "43.35", "142.38333", "Asia/Tokyo"),("2128206", "Shibetsu", "", "JP", "392", "", "12", "7428107", "", "43.65899", "145.13197", "Asia/Tokyo"),("2128295", "Sapporo", "Саппоро", "JP", "392", "", "12", "2128291", "", "43.06667", "141.35", "Asia/Tokyo"),("2128382", "Rumoi", "", "JP", "392", "", "12", "", "", "43.93444", "141.64278", "Asia/Tokyo"),("2128558", "Otofuke", "", "JP", "392", "", "12", "7428089", "", "42.99167", "143.20028", "Asia/Tokyo"),("2128574", "Otaru", "Отару", "JP", "392", "", "12", "", "", "43.18944", "141.00222", "Asia/Tokyo"),("2128787", "Ōdate", "Одатэ", "JP", "392", "", "02", "2128783", "", "40.27178", "140.55756", "Asia/Tokyo"),("2128815", "Obihiro", "Обихиро", "JP", "392", "", "12", "", "", "42.91722", "143.20444", "Asia/Tokyo"),("2128867", "Noshiro", "Носирский", "JP", "392", "", "02", "", "", "40.20838", "140.0274", "Asia/Tokyo"),("2128975", "Nemuro", "Нэмуро", "JP", "392", "", "12", "", "", "43.32361", "145.575", "Asia/Tokyo"),("2128983", "Nayoro", "Наеро", "JP", "392", "", "12", "", "", "44.35056", "142.45778", "Asia/Tokyo"),("2129003", "Nanae", "", "JP", "392", "", "12", "2129779", "", "41.88333", "140.68333", "Asia/Tokyo"),("2129005", "Namioka", "Намиока", "JP", "392", "", "03", "", "", "40.71069", "140.59048", "Asia/Tokyo"),("2129101", "Muroran", "Муроран", "JP", "392", "", "12", "", "", "42.31722", "140.98806", "Asia/Tokyo"),("2129163", "Mombetsu", "Момбецу", "JP", "392", "", "12", "", "", "44.3525", "143.3525", "Asia/Tokyo"),("2129211", "Misawa", "Мисава", "JP", "392", "", "03", "", "", "40.68682", "141.38969", "Asia/Tokyo"),("2129218", "Yoichi", "", "JP", "392", "", "12", "2127440", "", "43.20389", "140.77028", "Asia/Tokyo"),("2129324", "Makubetsu", "", "JP", "392", "", "12", "", "", "45.37139", "141.82111", "Asia/Tokyo"),("2129376", "Kushiro", "", "JP", "392", "", "12", "", "", "42.975", "144.37472", "Asia/Tokyo"),("2129395", "Kuroishi", "", "JP", "392", "", "03", "", "", "40.64581", "140.58354", "Asia/Tokyo"),("2129513", "Shimokizukuri", "", "JP", "392", "", "03", "", "", "40.81609", "140.37539", "Asia/Tokyo"),("2129537", "Kitami", "Киты", "JP", "392", "", "12", "", "", "43.80306", "143.89083", "Asia/Tokyo"),("2129761", "Kamikawa", "", "JP", "392", "", "12", "2129758", "", "43.84", "142.77111", "Asia/Tokyo"),("2129766", "Kamiiso", "", "JP", "392", "", "12", "", "", "41.82013", "140.64482", "Asia/Tokyo"),("2129868", "Iwanai", "", "JP", "392", "", "12", "2129864", "", "42.97444", "140.50889", "Asia/Tokyo"),("2129870", "Iwamizawa", "", "JP", "392", "", "12", "", "", "43.20028", "141.75972", "Asia/Tokyo"),("2129909", "Ishikari", "Исикари", "JP", "392", "", "12", "", "", "43.23972", "141.35389", "Asia/Tokyo"),("2129961", "Ichinohe", "", "JP", "392", "", "16", "2128941", "", "40.21965", "141.28986", "Asia/Tokyo"),("2130054", "Kitahiroshima", "Хиросима", "JP", "392", "", "12", "", "", "42.97583", "141.56722", "Asia/Tokyo"),("2130057", "Hirosaki", "Хиросаки", "JP", "392", "", "03", "", "", "40.59306", "140.4725", "Asia/Tokyo"),("2130146", "Hanawa", "", "JP", "392", "", "02", "", "", "40.18361", "140.78722", "Asia/Tokyo"),("2130188", "Hakodate", "Хакодате", "JP", "392", "", "12", "", "", "41.77583", "140.73667", "Asia/Tokyo"),("2130203", "Hachinohe", "", "JP", "392", "", "03", "", "", "40.5", "141.5", "Asia/Tokyo"),("2130332", "Fukagawa", "Фукагава", "JP", "392", "", "12", "", "", "43.70806", "142.03917", "Asia/Tokyo"),("2130404", "Ebetsu", "", "JP", "392", "", "12", "", "", "43.10806", "141.55056", "Asia/Tokyo"),("2130421", "Date", "", "JP", "392", "", "12", "", "", "42.46806", "140.86806", "Asia/Tokyo"),("2130452", "Chitose", "", "JP", "392", "", "12", "", "", "42.81944", "141.65222", "Asia/Tokyo"),("2130534", "Bibai", "", "JP", "392", "", "12", "", "", "43.32472", "141.85861", "Asia/Tokyo"),("2130612", "Ashibetsu", "", "JP", "392", "", "12", "", "", "43.50972", "142.18556", "Asia/Tokyo"),("2130629", "Asahikawa", "Асахикава", "JP", "392", "", "12", "2130628", "", "43.77063", "142.36489", "Asia/Tokyo"),("2130658", "Aomorishi", "Аомори", "JP", "392", "", "03", "", "", "40.81667", "140.73333", "Asia/Tokyo"),("2130705", "Akabira", "", "JP", "392", "", "12", "", "", "43.55139", "142.05306", "Asia/Tokyo"),("2130741", "Abashiri", "Абасири", "JP", "392", "", "12", "", "", "44.02127", "144.26971", "Asia/Tokyo"),("2131612", "Goshogawara", "Госёгавара", "JP", "392", "", "03", "", "", "40.80444", "140.44139", "Asia/Tokyo"),("6324583", "Aso", "Асо", "JP", "392", "", "21", "", "", "32.93726", "131.08008", "Asia/Tokyo"),("6417596", "Kōya", "", "JP", "392", "", "43", "1861287", "", "34.21294", "135.62244", "Asia/Tokyo"),("6691616", "Kihoku-chō", "", "JP", "392", "", "05", "1859256", "6691616", "33.25592", "132.68343", "Asia/Tokyo"),("6694821", "Nanto-shi", "", "JP", "392", "", "42", "", "", "36.56922", "136.91162", "Asia/Tokyo"),("6696932", "Kawage", "", "JP", "392", "", "23", "", "", "34.80447", "136.54645", "Asia/Tokyo"),("6697514", "Asahi", "", "JP", "392", "", "06", "1854875", "", "35.97259", "136.12455", "Asia/Tokyo"),("6697563", "Neyagawa", "", "JP", "392", "", "32", "", "", "34.76615", "135.62759", "Asia/Tokyo"),("6822096", "Hitachi-Naka", "", "JP", "392", "", "14", "", "", "36.39659", "140.53479", "Asia/Tokyo"),("6822108", "Inashiki", "", "JP", "392", "", "14", "", "", "35.95633", "140.32356", "Asia/Tokyo"),("6822126", "Kurobe-shi", "", "JP", "392", "", "42", "", "", "36.90123", "137.44955", "Asia/Tokyo"),("6822146", "Ōnojō", "", "JP", "392", "", "07", "", "", "33.53567", "130.47861", "Asia/Tokyo"),("6822217", "Minokamo", "Минокамо", "JP", "392", "", "09", "", "", "35.48199", "137.02166", "Asia/Tokyo"),("6822219", "Gujō", "Гудзё", "JP", "392", "", "09", "", "", "35.73691", "136.95852", "Asia/Tokyo"),("6825489", "Jōetsu", "", "JP", "392", "", "29", "", "", "37.14828", "138.23642", "Asia/Tokyo"),("6940394", "Saitama", "Саитама", "JP", "392", "", "34", "", "", "35.90807", "139.65657", "Asia/Tokyo"),("7279570", "Higashimurayama-shi", "", "JP", "392", "", "40", "", "", "35.75459", "139.46852", "Asia/Tokyo"),("7281819", "Fujikawaguchiko", "Фудзикавагутико", "JP", "392", "JP", "46", "", "", "35.48933", "138.68832", "Asia/Tokyo"),("7303471", "Arashiyama", "", "JP", "392", "", "22", "1857906", "", "35.01481", "135.67755", "Asia/Tokyo"),("7422816", "Dazaifu", "Дадзайфу", "JP", "392", "", "07", "", "", "33.51278", "130.52389", "Asia/Tokyo"),("8125829", "Kamigyō-ku", "", "JP", "392", "JP", "22", "1857906", "", "35.02954", "135.75666", "Asia/Tokyo"),("8198709", "Buzen", "", "JP", "392", "", "07", "1864660", "", "33.61153", "131.13002", "Asia/Tokyo"),("8198710", "Yoshitomi", "", "JP", "392", "", "07", "1864588", "", "33.60247", "131.17599", "Asia/Tokyo"),("8630153", "Hakuba", "", "JP", "392", "", "26", "1859364", "", "36.69818", "137.86185", "Asia/Tokyo"),("178073", "Wundanyi", "", "KE", "404", "", "47", "", "", "-3.40193", "38.36402", "Africa/Nairobi"),("178077", "Wote", "", "KE", "404", "", "32", "", "", "-1.78079", "37.62882", "Africa/Nairobi"),("178093", "Witu", "", "KE", "404", "", "30", "", "", "-2.38885", "40.43821", "Africa/Nairobi"),("178202", "Webuye", "", "KE", "404", "", "12", "", "", "0.60751", "34.76966", "Africa/Nairobi"),("178443", "Wajir", "", "KE", "404", "", "54", "", "", "1.7471", "40.05732", "Africa/Nairobi"),("178522", "Voi", "", "KE", "404", "", "47", "", "", "-3.39605", "38.55609", "Africa/Nairobi"),("179330", "Thika", "Тик", "KE", "404", "", "05", "", "", "-1.03326", "37.06933", "Africa/Nairobi"),("179525", "Taveta", "", "KE", "404", "", "02", "", "", "-3.39879", "37.68336", "Africa/Nairobi"),("179634", "Takaungu", "", "KE", "404", "", "23", "", "", "-3.68367", "39.85661", "Africa/Nairobi"),("180646", "Sawa Sawa", "", "KE", "404", "", "28", "", "", "-4.47166", "39.48463", "Africa/Nairobi"),("181135", "Rongai", "", "KE", "404", "", "39", "", "", "-0.17333", "35.86382", "Africa/Nairobi"),("181501", "Pumwani", "", "KE", "404", "KE", "05", "", "", "-1.28333", "36.85", "Africa/Nairobi"),("181702", "Oyugis", "", "KE", "404", "", "17", "", "", "-0.50898", "34.73583", "Africa/Nairobi"),("182701", "Nyeri", "Ньери", "KE", "404", "", "44", "", "", "-0.42013", "36.94759", "Africa/Nairobi"),("183027", "Nyahururu", "", "KE", "404", "", "29", "", "", "0.0421", "36.36734", "Africa/Nairobi"),("183595", "Ngong", "", "KE", "404", "", "19", "", "", "-1.36175", "36.6566", "Africa/Nairobi"),("184367", "Naro Moru", "", "KE", "404", "", "29", "", "", "-0.16756", "37.02129", "Africa/Nairobi"),("184379", "Narok", "", "KE", "404", "", "41", "", "", "-1.07829", "35.86012", "Africa/Nairobi"),("184433", "Nanyuki", "", "KE", "404", "", "29", "", "", "0.01667", "37.07283", "Africa/Nairobi"),("184570", "Namanga", "", "KE", "404", "", "19", "", "", "-2.54327", "36.79053", "Africa/Nairobi"),("184622", "Nakuru", "Накуру", "KE", "404", "", "39", "", "", "-0.28333", "36.06667", "Africa/Nairobi"),("184707", "Naivasha", "Найваша", "KE", "404", "", "39", "", "", "-0.71667", "36.43591", "Africa/Nairobi"),("184745", "Nairobi", "Найроби", "KE", "404", "", "05", "", "", "-1.28333", "36.81667", "Africa/Nairobi"),("184921", "Mwingi", "", "KE", "404", "", "27", "", "", "-0.93435", "38.06005", "Africa/Nairobi"),("185579", "Murang’a", "", "KE", "404", "", "38", "", "", "-0.71667", "37.15", "Africa/Nairobi"),("185702", "Mumias", "", "KE", "404", "", "20", "", "", "0.33511", "34.4864", "Africa/Nairobi"),("185939", "Muhoroni", "", "KE", "404", "", "26", "", "", "-0.15406", "35.19878", "Africa/Nairobi"),("186180", "Moyale", "", "KE", "404", "", "34", "", "", "3.5216", "39.05472", "Africa/Nairobi"),("186301", "Mombasa", "Момбаса", "KE", "404", "", "37", "", "", "-4.05466", "39.66359", "Africa/Nairobi"),("186315", "Molo", "Моло", "KE", "404", "", "39", "", "", "-0.2479", "35.73743", "Africa/Nairobi"),("186731", "Migori", "", "KE", "404", "", "36", "", "", "-1.06343", "34.47313", "Africa/Nairobi"),("186827", "Meru", "Меры", "KE", "404", "", "35", "", "", "0.04626", "37.65587", "Africa/Nairobi"),("187110", "Mbale", "", "KE", "404", "", "53", "", "", "-3.4", "38.38333", "Africa/Nairobi"),("187231", "Maua", "", "KE", "404", "", "18", "", "", "0.23206", "37.94052", "Africa/Nairobi"),("187585", "Marsabit", "", "KE", "404", "", "34", "", "", "2.32839", "37.98986", "Africa/Nairobi"),("187661", "Mariakani", "", "KE", "404", "", "28", "", "", "-3.86332", "39.47362", "Africa/Nairobi"),("187725", "Maralal", "", "KE", "404", "", "45", "", "", "1.09679", "36.69799", "Africa/Nairobi"),("187896", "Mandera", "Мандере", "KE", "404", "", "33", "", "", "3.93726", "41.85688", "Africa/Nairobi"),("187968", "Malindi", "Малинди", "KE", "404", "", "23", "", "", "-3.21799", "40.11692", "Africa/Nairobi"),("188025", "Malaba", "", "KE", "404", "", "13", "", "", "0.63457", "34.2756", "Africa/Nairobi"),("188080", "Makueni", "", "KE", "404", "", "32", "", "", "-1.80409", "37.62034", "Africa/Nairobi"),("188408", "Magadi", "", "KE", "404", "", "19", "", "", "-1.90122", "36.287", "Africa/Nairobi"),("188492", "Machakos", "Мачакосский", "KE", "404", "", "31", "", "", "-1.51667", "37.26667", "Africa/Nairobi"),("188657", "Lugulu", "", "KE", "404", "", "13", "", "", "0.39361", "34.30528", "Africa/Nairobi"),("188714", "Luanda", "", "KE", "404", "", "13", "", "", "0.29668", "34.06459", "Africa/Nairobi"),("189280", "Lodwar", "Лодвар", "KE", "404", "", "51", "", "", "3.11911", "35.59727", "Africa/Nairobi"),("189386", "Limuru", "", "KE", "404", "", "22", "", "", "-1.1", "36.65", "Africa/Nairobi"),("189741", "Lamu", "Лама", "KE", "404", "", "30", "", "", "-2.27169", "40.90201", "Africa/Nairobi"),("190108", "Kwale", "", "KE", "404", "", "28", "", "", "-4.17375", "39.45206", "Africa/Nairobi"),("191038", "Kitui", "", "KE", "404", "", "27", "", "", "-1.36696", "38.01055", "Africa/Nairobi"),("191220", "Kitale", "Китале", "KE", "404", "", "50", "", "", "1.01572", "35.00622", "Africa/Nairobi"),("191245", "Kisumu", "Кисуму", "KE", "404", "", "26", "", "", "-0.10221", "34.76171", "Africa/Nairobi"),("191299", "Kisii", "", "KE", "404", "", "25", "", "", "-0.68174", "34.76666", "Africa/Nairobi"),("191833", "Kinango", "", "KE", "404", "", "28", "", "", "-4.13723", "39.31528", "Africa/Nairobi"),("191837", "Kihancha", "", "KE", "404", "", "36", "", "", "-1.18376", "34.62616", "Africa/Nairobi"),("192067", "Kilifi", "Килифи", "KE", "404", "", "23", "", "", "-3.63045", "39.84992", "Africa/Nairobi"),("192710", "Kiambu", "Киамбу", "KE", "404", "", "22", "", "", "-1.16667", "36.83333", "Africa/Nairobi"),("192859", "Keruguya", "", "KE", "404", "", "24", "", "", "-0.49887", "37.28031", "Africa/Nairobi"),("192900", "Kericho", "", "KE", "404", "", "21", "", "", "-0.36774", "35.28314", "Africa/Nairobi"),("193627", "Karuri", "", "KE", "404", "", "38", "", "", "-0.7", "37.18333", "Africa/Nairobi"),("193985", "Kapsowar", "", "KE", "404", "", "14", "", "", "0.98119", "35.56145", "Africa/Nairobi"),("194038", "Kapsabet", "", "KE", "404", "", "40", "", "", "0.20387", "35.105", "Africa/Nairobi"),("194160", "Kapenguria", "", "KE", "404", "", "55", "", "", "1.23333", "35.11667", "Africa/Nairobi"),("194406", "Kangundo", "", "KE", "404", "", "31", "", "", "-1.29792", "37.34705", "Africa/Nairobi"),("195272", "Kakamega", "Какамеге", "KE", "404", "", "20", "", "", "0.28422", "34.75229", "Africa/Nairobi"),("195298", "Kajiado", "", "KE", "404", "", "19", "", "", "-1.85238", "36.77683", "Africa/Nairobi"),("195821", "Kabarnet", "", "KE", "404", "", "10", "", "", "0.49194", "35.74303", "Africa/Nairobi"),("196231", "Isiolo", "Исиоло", "KE", "404", "", "18", "", "", "0.35462", "37.58218", "Africa/Nairobi"),("196742", "Homa Bay", "", "KE", "404", "", "17", "", "", "-0.52731", "34.45714", "Africa/Nairobi"),("196752", "Hola", "", "KE", "404", "", "48", "", "", "-1.48256", "40.03341", "Africa/Nairobi"),("197514", "Gazi", "", "KE", "404", "", "28", "", "", "-4.42402", "39.50588", "Africa/Nairobi"),("197745", "Garissa", "", "KE", "404", "", "16", "", "", "-0.45275", "39.64601", "Africa/Nairobi"),("198476", "Embu", "Эмба", "KE", "404", "", "15", "", "", "-0.53112", "37.45061", "Africa/Nairobi"),("198629", "Eldoret", "Элдорет", "KE", "404", "", "52", "", "", "0.52036", "35.26993", "Africa/Nairobi"),("198636", "Eldama Ravine", "", "KE", "404", "", "10", "", "", "0.05158", "35.73078", "Africa/Nairobi"),("199284", "Chuka", "", "KE", "404", "", "49", "", "", "-0.33316", "37.64587", "Africa/Nairobi"),("199971", "Butere", "", "KE", "404", "", "20", "", "", "0.20636", "34.49348", "Africa/Nairobi"),("199989", "Busia", "", "KE", "404", "", "13", "", "", "0.46005", "34.11169", "Africa/Nairobi"),("200061", "Port Bunyala", "", "KE", "404", "", "13", "", "", "0.09388", "33.97559", "Africa/Nairobi"),("200067", "Bungoma", "Бунгома", "KE", "404", "", "12", "", "", "0.5635", "34.56055", "Africa/Nairobi"),("200304", "Bondo", "", "KE", "404", "", "46", "", "", "0.23861", "34.26944", "Africa/Nairobi"),("200308", "Bomet", "", "KE", "404", "", "11", "", "", "-0.78129", "35.34156", "Africa/Nairobi"),("200575", "Baringo", "", "KE", "404", "", "10", "", "", "0.46667", "35.96667", "Africa/Nairobi"),("200787", "Athi River", "", "KE", "404", "", "31", "", "", "-1.4563", "36.97826", "Africa/Nairobi"),("201229", "Ahero", "", "KE", "404", "", "26", "", "", "-0.17462", "34.9163", "Africa/Nairobi"),("383388", "Siaya", "", "KE", "404", "", "46", "", "", "0.06116", "34.28823", "Africa/Nairobi"),("7931933", "Ol Kalou", "", "KE", "404", "", "43", "", "", "-0.27088", "36.37917", "Africa/Nairobi"),("8051336", "Nyamira", "", "KE", "404", "", "42", "", "", "-0.648", "34.967", "Africa/Nairobi"),("10942514", "Kathwana", "", "KE", "404", "", "49", "", "", "-0.12817", "37.93579", "Africa/Nairobi"),("1222562", "Suluktu", "Сулюкта", "KG", "417", "", "09", "", "", "39.93652", "69.56779", "Asia/Bishkek"),("1222635", "Aydarken", "", "KG", "417", "", "09", "", "", "39.94319", "71.34184", "Asia/Bishkek"),("1222662", "Isfana", "Исфана", "KG", "417", "", "09", "", "", "39.83895", "69.5276", "Asia/Bishkek"),("1527004", "Balykchy", "Балыкчи", "KG", "417", "", "07", "", "", "42.46017", "76.18709", "Asia/Bishkek"),("1527121", "Tyup", "", "KG", "417", "", "07", "", "", "42.7276", "78.36476", "Asia/Bishkek"),("1527199", "Tokmok", "Токмак", "KG", "417", "", "02", "", "", "42.84194", "75.30149", "Asia/Bishkek"),("1527232", "Ak-Suu", "", "KG", "417", "", "07", "", "", "42.49948", "78.52702", "Asia/Bishkek"),("1527260", "Tash-Kumyr", "Таш-Кумыр", "KG", "417", "", "03", "", "", "41.34612", "72.21707", "Asia/Bishkek"),("1527299", "Talas", "Талас", "KG", "417", "", "06", "", "", "42.52277", "72.24274", "Asia/Bishkek"),("1527351", "Sosnovka", "", "KG", "417", "", "02", "", "", "42.63707", "73.89608", "Asia/Bishkek"),("1527497", "Kyzyl-Suu", "Покровка", "KG", "417", "", "07", "", "", "42.34211", "78.00644", "Asia/Bishkek"),("1527513", "Uzgen", "Узген", "KG", "417", "", "08", "", "", "40.76994", "73.30068", "Asia/Bishkek"),("1527534", "Osh", "Ош", "KG", "417", "", "08", "", "", "40.52828", "72.7985", "Asia/Bishkek"),("1527592", "Naryn", "Нарын", "KG", "417", "", "04", "", "", "41.42866", "75.99111", "Asia/Bishkek"),("1527719", "Kyzyl-Kyya", "Кызыл-Кия", "KG", "417", "", "09", "", "", "40.25684", "72.12793", "Asia/Bishkek"),("1528091", "Kara Suu", "Кара-Суу", "KG", "417", "", "08", "", "", "40.7046", "72.86666", "Asia/Bishkek"),("1528121", "Karakol", "Каракол", "KG", "417", "", "07", "", "", "42.49068", "78.39362", "Asia/Bishkek"),("1528182", "Kara-Balta", "Кара-Балта", "KG", "417", "", "02", "", "", "42.81423", "73.84813", "Asia/Bishkek"),("1528193", "Kant", "Кант", "KG", "417", "", "02", "", "", "42.89106", "74.85077", "Asia/Bishkek"),("1528234", "Kaindy", "", "KG", "417", "", "02", "", "", "42.82469", "73.67585", "Asia/Bishkek"),("1528249", "Jalal-Abad", "Джалал-Абад", "KG", "417", "KG", "03", "", "", "40.93333", "73", "Asia/Bishkek"),("1528283", "Iradan", "", "KG", "417", "KG", "09", "", "", "40.26667", "72.1", "Asia/Bishkek"),("1528339", "Nookat", "", "KG", "417", "", "00", "", "", "40.26597", "72.61834", "Asia/Bishkek"),("1528512", "Cholpon-Ata", "Чолпон-Ата", "KG", "417", "", "07", "", "", "42.64944", "77.08225", "Asia/Bishkek"),("1528606", "Kemin", "", "KG", "417", "", "02", "", "", "42.78458", "75.68917", "Asia/Bishkek"),("1528675", "Bishkek", "Бишкек", "KG", "417", "KG", "01", "", "", "42.87", "74.59", "Asia/Bishkek"),("1528717", "Bazar-Korgon", "Базар-Коргон", "KG", "417", "", "03", "", "", "41.0376", "72.74586", "Asia/Bishkek"),("1528735", "Batken", "", "KG", "417", "", "09", "", "", "40.06259", "70.81939", "Asia/Bishkek"),("1528796", "At-Bashi", "Ат-Баши", "KG", "417", "", "04", "", "", "41.16951", "75.80099", "Asia/Bishkek"),("1538648", "Toktogul", "Токтогул", "KG", "417", "", "03", "", "", "41.87442", "72.94192", "Asia/Bishkek"),("11054823", "Osh City", "", "KG", "417", "", "10", "", "", "40.53957", "72.81034", "Asia/Bishkek"),("1821306", "Phnom Penh", "Пномпень", "KH", "116", "", "22", "", "", "11.56245", "104.91601", "Asia/Phnom_Penh"),("1821935", "Ta Khmau", "Такхмау", "KH", "116", "", "07", "", "", "11.48333", "104.95", "Asia/Phnom_Penh"),("1821940", "Takeo", "", "KH", "116", "", "19", "", "", "10.99081", "104.78498", "Asia/Phnom_Penh"),("1821993", "Svay Rieng", "", "KH", "116", "", "18", "", "", "11.08785", "105.79935", "Asia/Phnom_Penh"),("1822019", "Suŏng", "", "KH", "116", "", "31", "8403889", "", "11.91178", "105.65821", "Asia/Phnom_Penh"),("1822029", "Stung Treng", "", "KH", "116", "", "17", "", "", "13.52586", "105.9683", "Asia/Phnom_Penh"),("1822207", "Sisŏphŏn", "", "KH", "116", "", "25", "", "", "13.58588", "102.97369", "Asia/Phnom_Penh"),("1822214", "Siem Reap", "Сием-Реап", "KH", "116", "", "24", "", "", "13.36179", "103.86056", "Asia/Phnom_Penh"),("1822227", "Sênmônoŭrôm", "", "KH", "116", "", "10", "", "", "12.45583", "107.18811", "Asia/Phnom_Penh"),("1822610", "Prey Veng", "", "KH", "116", "", "14", "", "", "11.48682", "105.32533", "Asia/Phnom_Penh"),("1822768", "Pursat", "", "KH", "116", "", "12", "", "", "12.53878", "103.9192", "Asia/Phnom_Penh"),("1822906", "Phumĭ Véal Srê", "", "KH", "116", "", "19", "", "", "10.98081", "104.77828", "Asia/Phnom_Penh"),("1825093", "Sâmraông", "", "KH", "116", "", "27", "", "", "14.18175", "103.51761", "Asia/Phnom_Penh"),("1830098", "Tbêng Méanchey", "", "KH", "116", "", "13", "", "", "13.80731", "104.98046", "Asia/Phnom_Penh"),("1830194", "Paoy Paet", "Пойпет", "KH", "116", "", "25", "", "", "13.65805", "102.56365", "Asia/Phnom_Penh"),("1830205", "Pailin", "", "KH", "116", "", "30", "", "", "12.84895", "102.60928", "Asia/Phnom_Penh"),("1830377", "Lumphăt", "", "KH", "116", "", "23", "", "", "13.48784", "106.98158", "Asia/Phnom_Penh"),("1830467", "Krong Kep", "", "KH", "116", "", "26", "", "", "10.48291", "104.31672", "Asia/Phnom_Penh"),("1830468", "Koh Kong", "", "KH", "116", "", "08", "", "", "11.61531", "102.9838", "Asia/Phnom_Penh"),("1830564", "Kratié", "", "KH", "116", "", "09", "", "", "12.48811", "106.01879", "Asia/Phnom_Penh"),("1831112", "Kampot", "Кампот", "KH", "116", "", "21", "", "", "10.61041", "104.18145", "Asia/Phnom_Penh"),("1831125", "Kampong Thom", "", "KH", "116", "", "05", "", "", "12.71112", "104.88873", "Asia/Phnom_Penh"),("1831133", "Kampong Speu", "", "KH", "116", "", "04", "", "", "11.45332", "104.52085", "Asia/Phnom_Penh"),("1831142", "Sihanoukville", "Сиануквиль", "KH", "116", "", "28", "", "", "10.60932", "103.52958", "Asia/Phnom_Penh"),("1831167", "Kampong Chhnang", "Кампонгчнанг", "KH", "116", "", "03", "", "", "12.25", "104.66667", "Asia/Phnom_Penh"),("1831173", "Kampong Cham", "Кампонгтям", "KH", "116", "", "02", "", "", "11.99339", "105.4635", "Asia/Phnom_Penh"),("1831732", "Ban Lŭng", "", "KH", "116", "", "23", "", "", "13.73939", "106.98727", "Asia/Phnom_Penh"),("1831797", "Battambang", "Баттамбанг", "KH", "116", "", "29", "", "", "13.10271", "103.19822", "Asia/Phnom_Penh"),("8740221", "Smach Mean Chey", "", "KH", "116", "", "08", "", "", "11.54665", "103.03569", "Asia/Phnom_Penh"),("1832015", "Heunghae", "", "KR", "411", "", "14", "", "", "36.10945", "129.34517", "Asia/Seoul"),("1832215", "Yeonil", "", "KR", "411", "", "14", "", "", "35.99526", "129.35162", "Asia/Seoul"),("1832257", "Neietsu", "", "KR", "411", "", "06", "", "", "37.18447", "128.46821", "Asia/Seoul"),("1832384", "Eisen", "", "KR", "411", "", "14", "", "", "36.82167", "128.63083", "Asia/Seoul"),("1832501", "Reiko", "", "KR", "411", "", "16", "", "", "35.275", "126.50944", "Asia/Seoul"),("1832566", "Yŏng-dong", "", "KR", "411", "", "05", "", "", "36.175", "127.77639", "Asia/Seoul"),("1832617", "Eisen", "", "KR", "411", "", "14", "", "", "35.9675", "128.93083", "Asia/Seoul"),("1832743", "Yeoju", "", "KR", "411", "", "13", "", "", "37.29583", "127.63389", "Asia/Seoul"),("1832771", "Yesan", "Есан", "KR", "411", "", "17", "", "", "36.67756", "126.84272", "Asia/Seoul"),("1832828", "Yangsan", "Янсан", "KR", "411", "", "20", "", "", "35.34199", "129.03358", "Asia/Seoul"),("1832830", "Yangp'yŏng", "", "KR", "411", "", "13", "", "", "37.48972", "127.49056", "Asia/Seoul"),("1832847", "Yangju", "Янджу", "KR", "411", "", "13", "", "", "37.83311", "127.06169", "Asia/Seoul"),("1832909", "Yanggu", "", "KR", "411", "", "06", "", "", "38.10583", "127.98944", "Asia/Seoul"),("1833105", "Wŏnju", "", "KR", "411", "", "06", "", "", "37.35139", "127.94528", "Asia/Seoul"),("1833466", "Wanju", "", "KR", "411", "", "03", "", "", "35.84509", "127.14752", "Asia/Seoul"),("1833514", "Waegwan", "", "KR", "411", "", "14", "", "", "35.99251", "128.39785", "Asia/Seoul"),("1833747", "Ulsan", "Ульсан", "KR", "411", "", "21", "", "", "35.53722", "129.31667", "Asia/Seoul"),("1833788", "Uijeongbu-si", "", "KR", "411", "", "13", "", "", "37.7415", "127.0474", "Asia/Seoul"),("1834885", "Tangjin", "", "KR", "411", "", "17", "", "", "36.89444", "126.62972", "Asia/Seoul"),("1835096", "Taesal-li", "", "KR", "411", "", "17", "", "", "36.9714", "126.4542", "Asia/Seoul"),("1835235", "Daejeon", "Тэджон", "KR", "411", "", "19", "", "", "36.32139", "127.41972", "Asia/Seoul"),("1835329", "Daegu", "Тэгу", "KR", "411", "", "15", "", "", "35.87028", "128.59111", "Asia/Seoul"),("1835447", "Taisen-ri", "", "KR", "411", "", "17", "", "", "36.34931", "126.59772", "Asia/Seoul"),("1835515", "T’aebaek", "Тхэбэк", "KR", "411", "", "06", "", "", "37.1759", "128.9889", "Asia/Seoul"),("1835553", "Suwon-si", "", "KR", "411", "", "13", "", "", "37.29111", "127.00889", "Asia/Seoul"),("1835648", "Suncheon", "", "KR", "411", "", "16", "", "", "34.94808", "127.48947", "Asia/Seoul"),("1835848", "Seoul", "Сеул", "KR", "411", "", "11", "", "", "37.566", "126.9784", "Asia/Seoul"),("1835895", "Seosan", "Сосан", "KR", "411", "", "17", "", "", "36.78167", "126.45222", "Asia/Seoul"),("1835967", "Jenzan", "", "KR", "411", "", "14", "", "", "36.24083", "128.2975", "Asia/Seoul"),("1836208", "Seonghwan", "", "KR", "411", "", "17", "", "", "36.91556", "127.13139", "Asia/Seoul"),("1836553", "Sokcho", "Сокчхо", "KR", "411", "", "06", "", "", "38.20701", "128.59181", "Asia/Seoul"),("1836839", "Sintansin", "", "KR", "411", "", "19", "", "", "36.45361", "127.43111", "Asia/Seoul"),("1837706", "Sangju", "Санджу", "KR", "411", "", "14", "", "", "36.41528", "128.16056", "Asia/Seoul"),("1838069", "Santyoku", "", "KR", "411", "", "06", "", "", "37.44056", "129.17083", "Asia/Seoul"),("1838508", "Fuyo", "Пуйо", "KR", "411", "", "17", "", "", "36.28194", "126.9125", "Asia/Seoul"),("1838524", "Busan", "Пусан", "KR", "411", "", "10", "", "", "35.10278", "129.04028", "Asia/Seoul"),("1838716", "Bucheon-si", "", "KR", "411", "", "13", "", "", "37.49889", "126.78306", "Asia/Seoul"),("1838722", "Puan", "", "KR", "411", "", "03", "", "", "35.72806", "126.73194", "Asia/Seoul"),("1839011", "Beolgyo", "", "KR", "411", "", "16", "", "", "34.84495", "127.34293", "Asia/Seoul"),("1839071", "Pohang", "", "KR", "411", "", "14", "1832431", "", "36.02917", "129.36481", "Asia/Seoul"),("1839652", "Osan", "", "KR", "411", "", "13", "", "", "37.15222", "127.07056", "Asia/Seoul"),("1839726", "Asan", "Асан", "KR", "411", "", "17", "", "", "36.78361", "127.00417", "Asia/Seoul"),("1839873", "Okcheon", "", "KR", "411", "", "05", "", "", "36.3012", "127.568", "Asia/Seoul"),("1840179", "Kosong", "", "KR", "411", "KR", "06", "", "", "38.37881", "128.4676", "Asia/Seoul"),("1840211", "Nonsan", "Нонсан", "KR", "411", "", "17", "", "", "36.20389", "127.08472", "Asia/Seoul"),("1840379", "Nangen", "Намвон", "KR", "411", "", "03", "", "", "35.41", "127.38583", "Asia/Seoul"),("1840536", "Naju", "Наджу", "KR", "411", "", "16", "", "", "35.0292", "126.7175", "Asia/Seoul"),("1840862", "Munsan", "Мунсан", "KR", "411", "", "13", "", "", "37.85944", "126.785", "Asia/Seoul"),("1840886", "Mungyeong", "Мунгён", "KR", "411", "", "14", "", "", "36.59458", "128.19946", "Asia/Seoul"),("1840982", "Muan", "", "KR", "411", "", "16", "", "", "34.99014", "126.47899", "Asia/Seoul"),("1841066", "Moppo", "Могпхо", "KR", "411", "", "16", "", "", "34.79361", "126.38861", "Asia/Seoul"),("1841149", "Miryang", "Мирян", "KR", "411", "", "20", "", "", "35.49333", "128.74889", "Asia/Seoul"),("1841598", "Gyeongsan-si", "", "KR", "411", "", "14", "", "", "35.82333", "128.73778", "Asia/Seoul"),("1841603", "Kyonju", "Кёнджу", "KR", "411", "", "14", "", "", "35.84278", "129.21167", "Asia/Seoul"),("1841775", "Kwangyang", "", "KR", "411", "", "16", "", "", "34.97528", "127.58917", "Asia/Seoul"),("1841810", "Gwangju", "", "KR", "411", "", "13", "", "", "37.41", "127.25722", "Asia/Seoul"),("1841811", "Gwangju", "Кванджу", "KR", "411", "", "18", "", "", "35.15472", "126.91556", "Asia/Seoul"),("1841976", "Kurye", "", "KR", "411", "", "16", "", "", "35.20944", "127.46444", "Asia/Seoul"),("1841988", "Guri-si", "", "KR", "411", "", "13", "", "", "37.5986", "127.1394", "Asia/Seoul"),("1842016", "Kunwi", "", "KR", "411", "", "14", "", "", "36.23472", "128.57278", "Asia/Seoul"),("1842025", "Gunsan", "Кунсан", "KR", "411", "", "03", "", "", "35.97861", "126.71139", "Asia/Seoul"),("1842153", "Kinzan", "", "KR", "411", "", "17", "", "", "36.10306", "127.48889", "Asia/Seoul"),("1842225", "Gumi", "Куми", "KR", "411", "", "14", "", "", "36.1136", "128.336", "Asia/Seoul"),("1842485", "Goyang-si", "", "KR", "411", "", "13", "", "", "37.65639", "126.835", "Asia/Seoul"),("1842518", "Goseong", "Косон", "KR", "411", "", "20", "", "", "34.97631", "128.32361", "Asia/Seoul"),("1842616", "Gongju", "Конджу", "KR", "411", "", "17", "", "", "36.45556", "127.12472", "Asia/Seoul"),("1842754", "Kyosai", "", "KR", "411", "", "20", "", "", "34.85028", "128.58861", "Asia/Seoul"),("1842800", "Koesan", "", "KR", "411", "KR", "05", "", "", "36.81083", "127.79472", "Asia/Seoul"),("1842859", "Koch'ang", "", "KR", "411", "KR", "03", "", "", "35.43333", "126.7", "Asia/Seoul"),("1842939", "Kimje", "", "KR", "411", "", "03", "", "", "35.80167", "126.88889", "Asia/Seoul"),("1842943", "Kimhae", "", "KR", "411", "", "20", "", "", "35.23417", "128.88111", "Asia/Seoul"),("1842944", "Gimcheon", "", "KR", "411", "", "14", "", "", "36.12176", "128.11981", "Asia/Seoul"),("1842966", "Gijang", "", "KR", "411", "", "10", "", "", "35.24417", "129.21389", "Asia/Seoul"),("1843082", "Gapyeong", "Капхён", "KR", "411", "", "13", "", "", "37.83101", "127.51059", "Asia/Seoul"),("1843137", "Kang-neung", "Каннын", "KR", "411", "", "06", "", "", "37.75556", "128.89611", "Asia/Seoul"),("1843163", "Ganghwa-gun", "", "KR", "411", "", "12", "", "", "37.74722", "126.48556", "Asia/Seoul"),("1843491", "Iksan", "Иксан", "KR", "411", "", "03", "", "", "35.94389", "126.95444", "Asia/Seoul"),("1843564", "Incheon", "Инчхон", "KR", "411", "", "12", "", "", "37.45646", "126.70515", "Asia/Seoul"),("1843585", "Imsil", "", "KR", "411", "KR", "03", "", "", "35.61306", "127.27944", "Asia/Seoul"),("1843702", "Icheon-si", "", "KR", "411", "", "13", "", "", "37.27917", "127.4425", "Asia/Seoul"),("1843841", "Hwasun", "Хвасун", "KR", "411", "", "16", "", "", "35.06125", "126.98746", "Asia/Seoul"),("1843847", "Hwaseong-si", "", "KR", "411", "", "13", "", "", "37.20682", "126.8169", "Asia/Seoul"),("1844045", "Hwacheon", "", "KR", "411", "", "06", "", "", "38.10705", "127.70632", "Asia/Seoul"),("1844174", "Hongsung", "", "KR", "411", "", "17", "", "", "36.6009", "126.665", "Asia/Seoul"),("1844191", "Hongch’ŏn", "", "KR", "411", "", "06", "", "", "37.6918", "127.8857", "Asia/Seoul"),("1844308", "Hayang", "", "KR", "411", "", "14", "", "", "35.91333", "128.82", "Asia/Seoul"),("1844751", "Haenam", "", "KR", "411", "", "16", "", "", "34.57111", "126.59889", "Asia/Seoul"),("1845136", "Chuncheon", "Чхунчхон", "KR", "411", "", "06", "", "", "37.87472", "127.73417", "Asia/Seoul"),("1845457", "Jeonju", "Чонджу", "KR", "411", "", "03", "", "", "35.82194", "127.14889", "Asia/Seoul"),("1845519", "Cheongsong gun", "", "KR", "411", "", "14", "", "", "36.43351", "129.057", "Asia/Seoul"),("1845604", "Cheongju-si", "", "KR", "411", "", "05", "", "", "36.63722", "127.48972", "Asia/Seoul"),("1845759", "Cheonan", "Чхонан", "KR", "411", "", "17", "", "", "36.8065", "127.1522", "Asia/Seoul"),("1846052", "Chinju", "Чинджу", "KR", "411", "", "20", "", "", "35.19278", "128.08472", "Asia/Seoul"),("1846095", "Chinch'ŏn", "", "KR", "411", "KR", "05", "", "", "36.85667", "127.44333", "Asia/Seoul"),("1846114", "Jinan-gun", "", "KR", "411", "", "03", "", "", "35.79167", "127.42528", "Asia/Seoul"),("1846266", "Jeju City", "Чеджу", "KR", "411", "", "01", "", "", "33.50972", "126.52194", "Asia/Seoul"),("1846326", "Changwon", "Чханвон", "KR", "411", "", "20", "", "", "35.22806", "128.68111", "Asia/Seoul"),("1846355", "Changsu", "", "KR", "411", "", "03", "", "", "35.64842", "127.51523", "Asia/Seoul"),("1846898", "Anyang-si", "", "KR", "411", "", "13", "", "", "37.3925", "126.92694", "Asia/Seoul"),("1846912", "Anseong", "Ансон", "KR", "411", "", "13", "Ansŏng-si", "", "37.01083", "127.27028", "Asia/Seoul"),("1846918", "Ansan-si", "", "KR", "411", "", "13", "", "", "37.32361", "126.82194", "Asia/Seoul"),("1846986", "Andong", "Андон", "KR", "411", "", "14", "", "", "36.56636", "128.72275", "Asia/Seoul"),("1847050", "Gaigeturi", "", "KR", "411", "", "01", "", "", "33.46444", "126.31833", "Asia/Seoul"),("1882056", "Sinhyeon", "", "KR", "411", "", "20", "", "", "34.8825", "128.62667", "Asia/Seoul"),("1884138", "Yeosu", "Йосу", "KR", "411", "KR", "16", "1832149", "", "34.76278", "127.66528", "Asia/Seoul"),("1886598", "Yŏnmu", "", "KR", "411", "", "17", "", "", "36.12944", "127.1", "Asia/Seoul"),("1892823", "Tonghae", "", "KR", "411", "", "06", "", "", "37.54389", "129.10694", "Asia/Seoul"),("1896953", "Pubal", "", "KR", "411", "", "13", "", "", "37.29167", "127.50778", "Asia/Seoul"),("1897000", "Seongnam-si", "", "KR", "411", "", "13", "", "", "37.43861", "127.13778", "Asia/Seoul"),("1897007", "Hanam", "", "KR", "411", "", "13", "", "", "37.54", "127.20556", "Asia/Seoul"),("1897118", "Hwado", "", "KR", "411", "", "13", "", "", "37.6525", "127.3075", "Asia/Seoul"),("1897122", "Namyangju", "Намянджу", "KR", "411", "", "13", "", "", "37.63667", "127.21417", "Asia/Seoul"),("1912205", "Ungsang", "", "KR", "411", "", "20", "", "", "35.40611", "129.16861", "Asia/Seoul"),("1912209", "Wabu", "", "KR", "411", "", "13", "", "", "37.58972", "127.22028", "Asia/Seoul"),("1925936", "Naesŏ", "", "KR", "411", "", "20", "", "", "35.24972", "128.52", "Asia/Seoul"),("1925943", "Hwawŏn", "", "KR", "411", "", "15", "", "", "35.80167", "128.50083", "Asia/Seoul"),("1948005", "Kwangmyŏng", "", "KR", "411", "", "13", "", "", "37.47722", "126.86639", "Asia/Seoul"),("6395804", "Sinan", "", "KR", "411", "", "16", "", "", "34.8262", "126.10863", "Asia/Seoul"),("6621166", "Seogwipo", "Сеогвипо", "KR", "411", "", "01", "", "", "33.25333", "126.56181", "Asia/Seoul"),("6888788", "Songgangdong", "", "KR", "411", "", "19", "", "", "36.43406", "127.37559", "Asia/Seoul"),("6903078", "Changnyeong", "", "KR", "411", "", "20", "", "6903078", "35.54145", "128.49506", "Asia/Seoul"),("607510", "Zhumysker", "", "KZ", "398", "", "00", "", "", "49.33333", "49.4", "Asia/Oral"),("607551", "Zhetibay", "", "KZ", "398", "", "09", "", "", "43.59417", "52.07889", "Asia/Aqtau"),("607610", "Zhanaozen", "", "KZ", "398", "", "09", "", "", "43.34116", "52.86192", "Asia/Aqtau"),("608270", "Shubarshi", "", "KZ", "398", "", "04", "", "", "48.58022", "57.18289", "Asia/Aqtobe"),("608271", "Shubarkuduk", "", "KZ", "398", "", "04", "", "", "49.14391", "56.48196", "Asia/Aqtobe"),("608324", "Shetpe", "", "KZ", "398", "", "09", "", "", "44.16667", "52.11667", "Asia/Aqtau"),("608359", "Shalqar", "", "KZ", "398", "", "04", "", "", "47.83333", "59.6", "Asia/Aqtobe"),("608362", "Shalkar", "Шалкар", "KZ", "398", "", "06", "", "", "48.03333", "48.9", "Asia/Oral"),("608668", "Oral", "Уральск", "KZ", "398", "", "07", "", "", "51.23333", "51.36667", "Asia/Oral"),("608679", "Kandyagash", "Октябрьск", "KZ", "398", "", "04", "", "", "49.46912", "57.41914", "Asia/Aqtobe"),("608816", "Miyaly", "", "KZ", "398", "", "06", "", "", "48.88504", "53.79194", "Asia/Oral"),("608867", "Martuk", "", "KZ", "398", "", "04", "", "", "50.74746", "56.50611", "Asia/Aqtobe"),("608872", "Maqat", "", "KZ", "398", "", "06", "", "", "47.65", "53.31667", "Asia/Oral"),("608901", "Maloye Ganyushkino", "", "KZ", "398", "", "06", "", "", "46.6", "49.26667", "Asia/Oral"),("608915", "Makhambet", "", "KZ", "398", "", "06", "", "", "47.66667", "51.58333", "Asia/Oral"),("609123", "Qulsary", "Кульсары", "KZ", "398", "KZ", "06", "", "", "46.95307", "54.01978", "Asia/Oral"),("609404", "Khromtau", "Хромтау", "KZ", "398", "", "04", "", "", "50.25117", "58.44003", "Asia/Aqtobe"),("609537", "Qaraton", "", "KZ", "398", "", "06", "", "", "46.43528", "53.48639", "Asia/Oral"),("609655", "Karagandy", "Караганда", "KZ", "398", "KZ", "12", "1537266", "", "49.83333", "73.1658", "Asia/Almaty"),("609721", "Kamenka", "", "KZ", "398", "", "07", "", "", "51.11073", "50.29454", "Asia/Oral"),("609798", "Īnderbor", "", "KZ", "398", "", "06", "", "", "48.55", "51.78333", "Asia/Oral"),("609906", "Fort-Shevchenko", "", "KZ", "398", "", "09", "", "", "44.50654", "50.26388", "Asia/Aqtau"),("609915", "Fedorovka", "", "KZ", "398", "", "07", "", "", "51.22102", "51.95723", "Asia/Oral"),("609919", "Yeraliyev", "", "KZ", "398", "", "09", "", "", "43.18032", "51.68116", "Asia/Aqtau"),("609924", "Embi", "Эмба", "KZ", "398", "", "04", "", "", "48.82981", "58.15042", "Asia/Aqtobe"),("609953", "Zhänibek", "", "KZ", "398", "", "07", "", "", "49.42207", "46.84705", "Asia/Oral"),("609965", "Dzhangala", "", "KZ", "398", "", "00", "", "", "49.21667", "50.33333", "Asia/Oral"),("609977", "Dzhambeyty", "", "KZ", "398", "", "07", "", "", "50.25676", "52.59895", "Asia/Oral"),("610023", "Dossor", "", "KZ", "398", "", "06", "", "", "47.52722", "52.98111", "Asia/Oral"),("610091", "Chingirlau", "", "KZ", "398", "", "07", "", "", "51.09878", "54.08426", "Asia/Oral"),("610132", "Chapaev", "", "KZ", "398", "KZ", "07", "", "", "50.2", "51.16667", "Asia/Oral"),("610298", "Beyneu", "", "KZ", "398", "", "09", "", "", "45.31667", "55.2", "Asia/Aqtau"),("610386", "Bayganin", "", "KZ", "398", "", "04", "", "", "48.68975", "55.87512", "Asia/Aqtobe"),("610416", "Batamshinskiy", "", "KZ", "398", "", "04", "", "", "50.56022", "58.27715", "Asia/Aqtobe"),("610445", "Balyqshy", "Балыкши", "KZ", "398", "", "06", "", "", "47.06667", "51.86667", "Asia/Oral"),("610529", "Atyrau", "Атырау", "KZ", "398", "", "06", "", "", "47.11667", "51.88333", "Asia/Oral"),("610611", "Aqtöbe", "Актобе", "KZ", "398", "", "04", "", "", "50.27969", "57.20718", "Asia/Aqtobe"),("610612", "Aktau", "Актау", "KZ", "398", "", "09", "", "", "43.65", "51.16667", "Asia/Aqtau"),("610613", "Aqsay", "Аксай", "KZ", "398", "", "07", "", "", "51.1681", "52.99782", "Asia/Oral"),("1516438", "Zyryanovsk", "Зыряновск", "KZ", "398", "", "15", "", "", "49.72654", "84.27318", "Asia/Almaty"),("1516519", "Zhosaly", "Джусалы", "KZ", "398", "", "14", "", "", "45.48778", "64.07806", "Asia/Qyzylorda"),("1516527", "Zholymbet", "", "KZ", "398", "", "03", "", "", "51.74211", "71.71245", "Asia/Almaty"),("1516589", "Zhezqazghan", "Джезказган", "KZ", "398", "", "12", "", "", "47.78333", "67.76667", "Asia/Almaty"),("1516590", "Zhezkent", "", "KZ", "398", "", "15", "", "", "50.93112", "81.3615", "Asia/Almaty"),("1516601", "Dzhetygara", "Джетыгара", "KZ", "398", "", "13", "", "", "52.19019", "61.19894", "Asia/Qyzylorda"),("1516634", "Zhelezinka", "", "KZ", "398", "", "11", "", "", "53.5388", "75.31326", "Asia/Almaty"),("1516788", "Zhangatas", "", "KZ", "398", "", "17", "", "", "43.56222", "69.73428", "Asia/Almaty"),("1516789", "Ayteke Bi", "", "KZ", "398", "", "14", "", "", "45.84607", "62.15264", "Asia/Qyzylorda"),("1516905", "Taraz", "Тараз", "KZ", "398", "", "17", "", "", "42.9", "71.36667", "Asia/Almaty"),("1517020", "Zhaqsy", "", "KZ", "398", "", "03", "", "", "51.91058", "67.31665", "Asia/Almaty"),("1517060", "Zaysan", "", "KZ", "398", "", "15", "", "", "47.46657", "84.87144", "Asia/Almaty"),("1517323", "Yanykurgan", "", "KZ", "398", "", "14", "", "", "43.90652", "67.24637", "Asia/Qyzylorda"),("1517501", "Vannovka", "", "KZ", "398", "", "10", "", "", "42.5334", "70.3496", "Asia/Almaty"),("1517610", "Ūst’-Talovka", "", "KZ", "398", "", "15", "", "", "50.54927", "81.84997", "Asia/Almaty"),("1517637", "Ush-Tyube", "Уштобе", "KZ", "398", "", "01", "", "", "45.25201", "77.98007", "Asia/Almaty"),("1517721", "Urzhar", "", "KZ", "398", "", "15", "", "", "47.09302", "81.62939", "Asia/Almaty"),("1517945", "Turkestan", "Туркестан", "KZ", "398", "", "10", "", "", "43.29733", "68.25175", "Asia/Almaty"),("1517957", "Turgen", "", "KZ", "398", "", "01", "", "", "43.40056", "77.59333", "Asia/Almaty"),("1518062", "Torghay", "", "KZ", "398", "", "13", "", "", "49.63389", "63.49806", "Asia/Almaty"),("1518139", "Tobol", "", "KZ", "398", "", "13", "", "", "52.69658", "62.58101", "Asia/Qyzylorda"),("1518203", "Terenozek", "", "KZ", "398", "", "14", "", "", "45.05053", "64.98395", "Asia/Qyzylorda"),("1518262", "Temirtau", "Темиртау", "KZ", "398", "", "12", "", "", "50.05494", "72.96464", "Asia/Almaty"),("1518266", "Temirlanovka", "", "KZ", "398", "", "10", "", "", "42.59998", "69.25836", "Asia/Almaty"),("1518296", "Tekeli", "Текели", "KZ", "398", "", "01", "", "", "44.83322", "78.83089", "Asia/Almaty"),("1518431", "Tasböget", "", "KZ", "398", "", "14", "", "", "44.77384", "65.55227", "Asia/Qyzylorda"),("1518518", "Talghar", "", "KZ", "398", "", "01", "", "", "43.30348", "77.24085", "Asia/Almaty"),("1518542", "Taldykorgan", "Талдыкорган", "KZ", "398", "", "01", "", "", "45.01556", "78.37389", "Asia/Almaty"),("1518543", "Taldyqorghan", "Талды - Курган", "KZ", "398", "KZ", "01", "", "", "45", "77.91667", "Asia/Almaty"),("1518936", "Smirnovo", "", "KZ", "398", "", "16", "", "", "54.5148", "69.42732", "Asia/Almaty"),("1518945", "Slavyanka", "", "KZ", "398", "", "10", "", "", "40.66338", "68.5451", "Asia/Almaty"),("1518980", "Shymkent", "Шымкент", "KZ", "398", "", "10", "", "", "42.3", "69.6", "Asia/Almaty"),("1519030", "Chu", "Шу", "KZ", "398", "", "17", "", "", "43.60334", "73.75919", "Asia/Almaty"),("1519050", "Shortandy", "", "KZ", "398", "", "03", "", "", "51.69946", "70.99457", "Asia/Almaty"),("1519226", "Shemonaīkha", "Шемонаиха", "KZ", "398", "", "15", "", "", "50.62811", "81.91213", "Asia/Almaty"),("1519244", "Shchuchinsk", "Щучинск", "KZ", "398", "", "03", "", "", "52.93592", "70.18895", "Asia/Almaty"),("1519275", "Shar", "", "KZ", "398", "", "15", "", "", "49.58559", "81.04851", "Asia/Almaty"),("1519277", "Shantobe", "", "KZ", "398", "", "03", "", "", "52.45376", "68.17475", "Asia/Almaty"),("1519333", "Shakhan", "", "KZ", "398", "", "12", "", "", "49.81958", "72.65407", "Asia/Almaty"),("1519385", "Sergeyevka", "", "KZ", "398", "", "16", "", "", "53.88139", "67.40882", "Asia/Almaty"),("1519422", "Semey", "Семей", "KZ", "398", "", "15", "", "", "50.42675", "80.26669", "Asia/Almaty"),("1519516", "Sastobe", "", "KZ", "398", "", "10", "", "", "42.5533", "69.99835", "Asia/Almaty"),("1519580", "Saryozek", "", "KZ", "398", "", "01", "", "", "44.36178", "77.97279", "Asia/Almaty"),("1519673", "Saryaghash", "Сарыагаш", "KZ", "398", "", "10", "", "", "41.46042", "69.16791", "Asia/Almaty"),("1519691", "Sarkand", "Сарканд", "KZ", "398", "", "01", "", "", "45.41126", "79.91545", "Asia/Almaty"),("1519725", "Soran", "Сарань", "KZ", "398", "", "12", "", "", "49.7908", "72.83744", "Asia/Almaty"),("1519776", "Sekseūil", "", "KZ", "398", "", "14", "", "", "47.09", "61.15194", "Asia/Qyzylorda"),("1519843", "Rudnyy", "Рудный", "KZ", "398", "", "13", "", "", "52.9729", "63.11677", "Asia/Qyzylorda"),("1519922", "Kyzylorda", "Кызылорда", "KZ", "398", "", "14", "", "", "44.85278", "65.50917", "Asia/Qyzylorda"),("1519924", "Qusmuryn", "", "KZ", "398", "", "13", "", "", "52.45107", "64.61977", "Asia/Qyzylorda"),("1519928", "Kostanay", "Костанай", "KZ", "398", "", "13", "1537246", "", "53.21435", "63.62463", "Asia/Qyzylorda"),("1519932", "Qashar", "", "KZ", "398", "", "13", "", "", "53.36799", "62.86839", "Asia/Qyzylorda"),("1519934", "Qarqaraly", "", "KZ", "398", "", "12", "", "", "49.41287", "75.47286", "Asia/Almaty"),("1519935", "Qarazhal", "", "KZ", "398", "", "12", "", "", "48.00627", "70.79607", "Asia/Almaty"),("1519936", "Qaraūyl", "", "KZ", "398", "", "15", "", "", "48.94509", "79.25502", "Asia/Almaty"),("1519938", "Karatau", "", "KZ", "398", "", "17", "", "", "43.17869", "70.46768", "Asia/Almaty"),("1519948", "Kapshagay", "Капшагай", "KZ", "398", "", "01", "", "", "43.86681", "77.06304", "Asia/Almaty"),("1520025", "Tūghyl", "", "KZ", "398", "", "15", "", "", "47.72521", "84.20629", "Asia/Almaty"),("1520172", "Petropavl", "Петропавловск", "KZ", "398", "", "16", "", "", "54.86667", "69.15", "Asia/Almaty"),("1520208", "Pervomayskiy", "", "KZ", "398", "", "01", "", "", "43.37361", "76.94", "Asia/Almaty"),("1520240", "Pavlodar", "Павлодар", "KZ", "398", "", "11", "", "", "52.28333", "76.96667", "Asia/Almaty"),("1520253", "Zharkent", "Жаркент", "KZ", "398", "", "01", "", "", "44.1666", "80.00655", "Asia/Almaty"),("1520281", "Oytal", "", "KZ", "398", "", "17", "", "", "42.90573", "73.26972", "Asia/Almaty"),("1520316", "Ust-Kamenogorsk", "Усть-Каменогорск", "KZ", "398", "", "15", "", "", "49.97143", "82.60586", "Asia/Almaty"),("1520327", "Osakarovka", "", "KZ", "398", "", "12", "", "", "50.56219", "72.57089", "Asia/Almaty"),("1520627", "Novodolinskiy", "", "KZ", "398", "", "12", "", "", "49.7065", "72.70807", "Asia/Almaty"),("1520660", "Zhanga Buqtyrma", "", "KZ", "398", "", "15", "", "", "49.6295", "83.52475", "Asia/Almaty"),("1520885", "Kurchatov", "", "KZ", "398", "", "15", "", "", "50.75617", "78.54188", "Asia/Almaty"),("1520947", "Mikhaylovka", "", "KZ", "398", "", "17", "", "", "43", "71.5", "Asia/Almaty"),("1520969", "Merke", "Мерке", "KZ", "398", "", "15", "", "", "42.86976", "73.18463", "Asia/Almaty"),("1521048", "Mayqayyng", "", "KZ", "398", "", "11", "", "", "51.45981", "75.80232", "Asia/Almaty"),("1521230", "Makinsk", "Макинск", "KZ", "398", "", "03", "", "", "52.6329", "70.41911", "Asia/Almaty"),("1521292", "Lugovoye", "", "KZ", "398", "", "17", "", "", "42.9101", "72.72066", "Asia/Almaty"),("1521293", "Lugovoy", "", "KZ", "398", "", "17", "", "", "42.94197", "72.76098", "Asia/Almaty"),("1521315", "Lisakovsk", "Лисаковка", "KZ", "398", "", "13", "", "", "52.54707", "62.49987", "Asia/Qyzylorda"),("1521333", "Lepsy", "", "KZ", "398", "", "01", "", "", "46.235", "78.94556", "Asia/Almaty"),("1521351", "Leninskoye", "", "KZ", "398", "", "10", "", "", "41.7564", "69.3839", "Asia/Almaty"),("1521365", "Leninskiy", "", "KZ", "398", "", "11", "", "", "52.25346", "76.78211", "Asia/Almaty"),("1521368", "Baikonur", "Байконур", "KZ", "398", "", "08", "", "", "45.61667", "63.31667", "Asia/Almaty"),("1521370", "Ridder", "Лениногорск", "KZ", "398", "", "15", "", "", "50.34413", "83.51287", "Asia/Almaty"),("1521379", "Lenger", "Ленгер", "KZ", "398", "", "10", "", "", "42.18152", "69.88582", "Asia/Almaty"),("1521401", "Kzyltu", "", "KZ", "398", "", "16", "", "", "53.63589", "72.34079", "Asia/Almaty"),("1521762", "Kurchum", "", "KZ", "398", "", "15", "", "", "48.56603", "83.66146", "Asia/Almaty"),("1522035", "Taiynsha", "", "KZ", "398", "", "16", "", "", "53.84796", "69.76773", "Asia/Almaty"),("1522203", "Kokshetau", "Кокшетау", "KZ", "398", "", "03", "", "", "53.28333", "69.4", "Asia/Almaty"),("1522348", "Komsomolets", "", "KZ", "398", "", "13", "", "", "53.75019", "62.0584", "Asia/Qyzylorda"),("1522503", "Kokpekty", "", "KZ", "398", "", "00", "", "", "48.75", "82.4", "Asia/Almaty"),("1522605", "Kīevka", "", "KZ", "398", "", "12", "", "", "50.26212", "71.54839", "Asia/Almaty"),("1522642", "Balpyk Bī", "", "KZ", "398", "", "01", "", "", "44.90225", "78.23157", "Asia/Almaty"),("1522643", "Asyqata", "", "KZ", "398", "", "10", "", "", "40.8946", "68.3643", "Asia/Almaty"),("1522751", "Kentau", "Кентау", "KZ", "398", "", "10", "", "", "43.51672", "68.50463", "Asia/Almaty"),("1522818", "Kegen", "", "KZ", "398", "", "01", "", "", "43.02055", "79.22194", "Asia/Almaty"),("1522862", "Qazaly", "", "KZ", "398", "", "14", "", "", "45.76278", "62.1075", "Asia/Qyzylorda"),("1523512", "Kantagi", "", "KZ", "398", "", "10", "", "", "43.52786", "68.58287", "Asia/Almaty"),("1523605", "Kalkaman", "", "KZ", "398", "", "11", "", "", "51.95349", "76.02723", "Asia/Almaty"),("1523662", "Qashyr", "", "KZ", "398", "", "11", "", "", "53.06649", "76.10489", "Asia/Almaty"),("1523741", "Esik", "Есик", "KZ", "398", "", "01", "", "", "43.3552", "77.45245", "Asia/Almaty"),("1523768", "Irtyshsk", "", "KZ", "398", "", "11", "", "", "53.33365", "75.45775", "Asia/Almaty"),("1524138", "Atakent", "", "KZ", "398", "", "10", "", "", "40.84782", "68.50643", "Asia/Almaty"),("1524227", "Glubokoye", "", "KZ", "398", "", "15", "", "", "50.14112", "82.31329", "Asia/Almaty"),("1524243", "Georgiyevka", "", "KZ", "398", "", "17", "", "", "43.03882", "74.71287", "Asia/Almaty"),("1524245", "Georgīevka", "Георгиевка", "KZ", "398", "", "15", "", "", "49.32671", "81.57373", "Asia/Almaty"),("1524265", "Moyynkum", "", "KZ", "398", "", "17", "", "", "44.28461", "72.9392", "Asia/Almaty"),("1524282", "Fyodorovka", "", "KZ", "398", "", "13", "", "", "53.63809", "62.69653", "Asia/Qyzylorda"),("1524296", "Esil", "", "KZ", "398", "", "03", "", "", "51.95495", "66.40841", "Asia/Almaty"),("1524298", "Aksu", "Аксу", "KZ", "398", "", "11", "", "", "52.04023", "76.92748", "Asia/Almaty"),("1524302", "Yermentau", "", "KZ", "398", "", "03", "", "", "51.62364", "73.10265", "Asia/Almaty"),("1524308", "Otegen Batyra", "", "KZ", "398", "", "01", "", "", "43.41949", "77.0202", "Asia/Almaty"),("1524325", "Ekibastuz", "Экибастуз", "KZ", "398", "", "11", "", "", "51.72371", "75.32287", "Asia/Almaty"),("1524478", "Dzhalagash", "", "KZ", "398", "", "14", "", "", "45.08333", "64.66667", "Asia/Qyzylorda"),("1524606", "Derzhavīnsk", "", "KZ", "398", "", "03", "", "", "51.09922", "66.31557", "Asia/Almaty"),("1524703", "Chulakkurgan", "", "KZ", "398", "", "10", "", "", "43.76453", "69.17856", "Asia/Almaty"),("1524801", "Shīeli", "Шиели", "KZ", "398", "", "14", "", "", "44.16882", "66.73887", "Asia/Qyzylorda"),("1524871", "Chayan", "", "KZ", "398", "", "10", "", "", "43.03399", "69.38048", "Asia/Almaty"),("1524889", "Chardara", "Шардара", "KZ", "398", "", "10", "", "", "41.25832", "67.96991", "Asia/Almaty"),("1524958", "Burunday", "Бурундай", "KZ", "398", "", "01", "", "", "43.36028", "76.85778", "Asia/Almaty"),("1525014", "Bulayevo", "", "KZ", "398", "", "16", "", "", "54.90596", "70.44155", "Asia/Almaty"),("1525121", "Borovskoy", "", "KZ", "398", "", "13", "", "", "53.7927", "64.18268", "Asia/Qyzylorda"),("1525126", "Būrabay", "", "KZ", "398", "KZ", "16", "", "", "53.08382", "70.31379", "Asia/Almaty"),("1525134", "Borodulikha", "", "KZ", "398", "", "15", "", "", "50.71841", "80.9295", "Asia/Almaty"),("1525295", "Bishkul", "", "KZ", "398", "", "16", "", "", "54.77763", "69.09951", "Asia/Almaty"),("1525376", "Bestobe", "", "KZ", "398", "", "03", "", "", "52.49795", "73.09592", "Asia/Almaty"),("1525462", "Belyye Vody", "Аксу", "KZ", "398", "", "10", "", "", "42.42193", "69.82709", "Asia/Almaty"),("1525490", "Belūsovka", "", "KZ", "398", "", "15", "", "", "50.13287", "82.52481", "Asia/Almaty"),("1525650", "Bayanaul", "", "KZ", "398", "", "11", "", "", "50.79304", "75.70123", "Asia/Almaty"),("1525798", "Balqash", "Балхаш", "KZ", "398", "", "12", "", "", "46.84806", "74.995", "Asia/Almaty"),("1525809", "Balkashino", "", "KZ", "398", "", "03", "", "", "52.51779", "68.7516", "Asia/Almaty"),("1525850", "Bakanas", "", "KZ", "398", "", "01", "", "", "44.80838", "76.27214", "Asia/Almaty"),("1525988", "Ayagoz", "", "KZ", "398", "", "15", "", "", "47.96447", "80.43437", "Asia/Almaty"),("1526038", "Atbasar", "Атбасар", "KZ", "398", "", "03", "", "", "51.80652", "68.35996", "Asia/Almaty"),("1526041", "Atasū", "", "KZ", "398", "", "12", "", "", "48.68659", "71.64469", "Asia/Almaty"),("1526055", "Asūbulaq", "", "KZ", "398", "", "15", "", "", "49.55688", "83.06355", "Asia/Almaty"),("1526059", "Astrakhan", "", "KZ", "398", "", "03", "", "", "51.53092", "69.79684", "Asia/Almaty"),("1526081", "Ashchysay", "", "KZ", "398", "", "10", "", "", "43.5537", "68.89792", "Asia/Almaty"),("1526168", "Arys", "Арысь", "KZ", "398", "", "10", "", "", "42.43015", "68.8087", "Asia/Almaty"),("1526193", "Arkalyk", "Аркалык", "KZ", "398", "", "13", "", "", "50.24915", "66.92027", "Asia/Almaty"),("1526265", "Aral", "Аральск", "KZ", "398", "", "14", "", "", "46.8", "61.66667", "Asia/Qyzylorda"),("1526269", "Aktau", "", "KZ", "398", "", "12", "", "", "50.23466", "73.06662", "Asia/Almaty"),("1526271", "Aksu", "", "KZ", "398", "", "03", "", "", "52.44422", "71.95761", "Asia/Almaty"),("1526273", "Astana", "Астана", "KZ", "398", "", "05", "", "", "51.1801", "71.44598", "Asia/Almaty"),("1526274", "Aqadyr", "", "KZ", "398", "", "12", "", "", "48.2606", "72.85825", "Asia/Almaty"),("1526384", "Almaty", "Алма-Ата", "KZ", "398", "", "02", "", "", "43.25667", "76.92861", "Asia/Almaty"),("1526601", "Aktau", "", "KZ", "398", "", "12", "", "", "48.03333", "72.83333", "Asia/Almaty"),("1526619", "Aktas", "", "KZ", "398", "", "12", "", "", "49.77952", "72.96128", "Asia/Almaty"),("1526648", "Aksuat", "", "KZ", "398", "", "00", "", "", "48.71667", "83.7", "Asia/Almaty"),("1526797", "Akkol’", "Акколь", "KZ", "398", "", "03", "", "", "53.29617", "69.59997", "Asia/Almaty"),("1526970", "Abay", "Абай", "KZ", "398", "", "12", "", "", "49.63575", "72.86164", "Asia/Almaty"),("1535379", "Novoishimskiy", "", "KZ", "398", "", "16", "", "", "53.19806", "66.76944", "Asia/Almaty"),("1537939", "Stepnogorsk", "Степногорск", "KZ", "398", "", "03", "", "", "52.35062", "71.88161", "Asia/Almaty"),("1537947", "Zavodskoy", "", "KZ", "398", "", "03", "", "", "52.47031", "72.01514", "Asia/Almaty"),("7536148", "Priozersk", "", "KZ", "398", "", "", "", "", "46.03106", "73.70247", "Asia/Almaty"),("9858283", "Tyuratam", "", "KZ", "398", "", "08", "", "", "45.65005", "63.31163", "Asia/Almaty"),("9862222", "Kyzyl-Orda", "", "KZ", "398", "", "14", "", "", "44.8479", "65.49989", "Asia/Almaty"),("266045", "Zahlé", "Захле", "LB", "422", "", "08", "", "", "33.84675", "35.90203", "Asia/Beirut"),("266826", "Tripoli", "Триполи", "LB", "422", "", "09", "", "", "34.43667", "35.84972", "Asia/Beirut"),("267008", "Tyre", "Тир", "LB", "422", "", "06", "", "", "33.27333", "35.19389", "Asia/Beirut"),("268064", "Sidon", "Сайда", "LB", "422", "", "06", "", "", "33.55993", "35.37564", "Asia/Beirut"),("268743", "Ra’s Bayrūt", "", "LB", "422", "", "04", "", "", "33.9", "35.48333", "Asia/Beirut"),("273140", "Jounieh", "", "LB", "422", "", "05", "", "", "33.98083", "35.61778", "Asia/Beirut"),("273203", "Jbaïl", "Библ (Bibl)", "LB", "422", "", "05", "", "", "34.12111", "35.64806", "Asia/Beirut"),("274723", "Halba", "", "LB", "422", "", "10", "", "", "34.54278", "36.07972", "Asia/Beirut"),("274874", "Habboûch", "Хаббуше", "LB", "422", "", "07", "", "", "33.40729", "35.48169", "Asia/Beirut"),("276359", "Bcharré", "Бишари", "LB", "422", "", "09", "", "", "34.25083", "36.01056", "Asia/Beirut"),("276781", "Beirut", "Бейрут", "LB", "422", "", "04", "", "", "33.88894", "35.49442", "Asia/Beirut"),("277130", "Baalbek", "Баальбек", "LB", "422", "", "11", "", "", "34.00583", "36.21806", "Asia/Beirut"),("277226", "Baabda", "", "LB", "422", "", "05", "", "", "33.83389", "35.54417", "Asia/Beirut"),("278832", "En Nâqoûra", "", "LB", "422", "", "06", "", "", "33.11806", "35.13972", "Asia/Beirut"),("278913", "Nabatîyé et Tahta", "", "LB", "422", "", "07", "", "", "33.37889", "35.48389", "Asia/Beirut"),("280328", "Batroûn", "", "LB", "422", "", "09", "", "", "34.25528", "35.65806", "Asia/Beirut"),("3042030", "Vaduz", "Вадуц", "LI", "438", "", "11", "", "", "47.14151", "9.52154", "Europe/Vaduz"),("3042033", "Triesenberg", "", "LI", "438", "", "10", "", "", "47.11815", "9.54197", "Europe/Vaduz"),("3042035", "Triesen", "", "LI", "438", "", "09", "", "", "47.10752", "9.52815", "Europe/Vaduz"),("3042037", "Schellenberg", "", "LI", "438", "", "08", "", "", "47.23123", "9.54678", "Europe/Vaduz"),("3042041", "Schaan", "", "LI", "438", "", "07", "", "", "47.16498", "9.50867", "Europe/Vaduz"),("3042046", "Ruggell", "", "LI", "438", "", "06", "", "", "47.23799", "9.5254", "Europe/Vaduz"),("3042049", "Planken", "", "LI", "438", "", "05", "", "", "47.18516", "9.54437", "Europe/Vaduz"),("3042055", "Mauren", "", "LI", "438", "", "04", "", "", "47.21805", "9.5442", "Europe/Vaduz"),("3042062", "Gamprin", "", "LI", "438", "", "03", "", "", "47.22038", "9.50935", "Europe/Vaduz"),("3042068", "Eschen", "", "LI", "438", "", "02", "", "", "47.21071", "9.52223", "Europe/Vaduz"),("3042073", "Balzers", "", "LI", "438", "", "01", "", "", "47.06665", "9.50251", "Europe/Vaduz"),("1223648", "Welisara", "", "LK", "144", "", "36", "", "", "7.0281", "79.9014", "Asia/Colombo"),("1223738", "Weligama", "", "LK", "144", "", "34", "", "", "5.97501", "80.42968", "Asia/Colombo"),("1224061", "Wattegama", "", "LK", "144", "", "35", "", "", "6.7989", "81.4808", "Asia/Colombo"),("1224085", "Wattala", "", "LK", "144", "", "36", "", "", "6.9779", "79.8898", "Asia/Colombo"),("1225018", "Vavuniya", "Вавуния", "LK", "144", "", "38", "", "", "8.7514", "80.4971", "Asia/Colombo"),("1225142", "Valvedditturai", "", "LK", "144", "", "38", "", "", "9.81667", "80.16667", "Asia/Colombo"),("1226260", "Trincomalee", "Тринкомали", "LK", "144", "", "37", "", "", "8.5711", "81.2335", "Asia/Colombo"),("1227037", "Tangalla", "", "LK", "144", "", "34", "", "", "6.024", "80.7911", "Asia/Colombo"),("1228730", "Ratnapura", "Ратнапуры", "LK", "144", "", "33", "", "", "6.68278", "80.39917", "Asia/Colombo"),("1229293", "Puttalam", "", "LK", "144", "", "32", "", "", "8.0362", "79.8283", "Asia/Colombo"),("1229901", "Polonnaruwa", "", "LK", "144", "", "30", "", "", "7.93965", "81.00274", "Asia/Colombo"),("1229989", "Point Pedro", "Пойнт-Педро", "LK", "144", "", "38", "", "", "9.81667", "80.23333", "Asia/Colombo"),("1230089", "Pita Kotte", "", "LK", "144", "", "36", "", "", "6.8905", "79.9015", "Asia/Colombo"),("1230613", "Peliyagoda", "", "LK", "144", "", "36", "", "", "6.9685", "79.8836", "Asia/Colombo"),("1231410", "Panadura", "", "LK", "144", "", "36", "", "", "6.7132", "79.9026", "Asia/Colombo"),("1232783", "Nuwara Eliya", "Нувара-Элия", "LK", "144", "", "29", "1232781", "", "6.97078", "80.78286", "Asia/Colombo"),("1233369", "Negombo", "Негомбо", "LK", "144", "", "36", "", "", "7.2083", "79.8358", "Asia/Colombo"),("1234378", "Mulleriyawa", "", "LK", "144", "", "36", "", "", "6.933", "79.9297", "Asia/Colombo"),("1234569", "Dehiwala-Mount Lavinia", "", "LK", "144", "", "36", "1248990", "7545420", "6.84019", "79.87116", "Asia/Colombo"),("1234633", "Moratuwa", "", "LK", "144", "", "36", "", "", "6.773", "79.8816", "Asia/Colombo"),("1234808", "Monaragala", "", "LK", "144", "", "35", "", "", "6.8714", "81.3487", "Asia/Colombo"),("1235000", "Minuwangoda", "", "LK", "144", "", "36", "", "", "7.1663", "79.9533", "Asia/Colombo"),("1235846", "Matara", "Матара", "LK", "144", "", "34", "", "", "5.94851", "80.53528", "Asia/Colombo"),("1236854", "Maharagama", "", "LK", "144", "", "36", "", "", "6.848", "79.9265", "Asia/Colombo"),("1237980", "Kurunegala", "Курунегала", "LK", "144", "", "32", "", "", "7.4863", "80.3623", "Asia/Colombo"),("1238427", "Kuliyapitiya", "", "LK", "144", "", "32", "", "", "7.4688", "80.0401", "Asia/Colombo"),("1238992", "Sri Jayewardenepura Kotte", "Шри-Джаяварденепура-Котте", "LK", "144", "", "36", "", "", "6.88297", "79.90708", "Asia/Colombo"),("1239047", "Kotikawatta", "", "LK", "144", "", "36", "", "", "6.9269", "79.9095", "Asia/Colombo"),("1239593", "Kolonnawa", "", "LK", "144", "", "36", "", "", "6.9329", "79.8848", "Asia/Colombo"),("1240372", "Kilinochchi", "", "LK", "144", "", "38", "", "", "9.3961", "80.3982", "Asia/Colombo"),("1240622", "Kelaniya", "", "LK", "144", "", "36", "", "", "6.9553", "79.922", "Asia/Colombo"),("1240935", "Katunayaka", "", "LK", "144", "", "36", "", "", "7.16992", "79.88837", "Asia/Colombo"),("1241622", "Kandy", "Канди", "LK", "144", "", "29", "", "", "7.2955", "80.6356", "Asia/Colombo"),("1241750", "Kandana", "", "LK", "144", "", "36", "", "", "7.048", "79.8937", "Asia/Colombo"),("1241964", "Kalutara", "Калутара", "LK", "144", "", "36", "", "", "6.5831", "79.9593", "Asia/Colombo"),("1242110", "Kalmunai", "", "LK", "144", "", "37", "", "", "7.40902", "81.83472", "Asia/Colombo"),("1242833", "Jaffna", "Джафна", "LK", "144", "", "38", "", "", "9.66845", "80.00742", "Asia/Colombo"),("1242835", "Ja Ela", "", "LK", "144", "", "36", "", "", "7.0744", "79.8919", "Asia/Colombo"),("1243867", "Horana South", "", "LK", "144", "", "36", "", "", "6.7159", "80.0626", "Asia/Colombo"),("1243936", "Homagama", "", "LK", "144", "", "36", "", "", "6.844", "80.0024", "Asia/Colombo"),("1244397", "Hendala", "", "LK", "144", "", "36", "", "", "6.9909", "79.883", "Asia/Colombo"),("1244596", "Hatton", "", "LK", "144", "", "29", "", "", "6.8916", "80.5955", "Asia/Colombo"),("1244773", "Hanwella Ihala", "", "LK", "144", "", "36", "", "", "6.9012", "80.0852", "Asia/Colombo"),("1246000", "Gampola", "", "LK", "144", "", "29", "", "", "7.1643", "80.5696", "Asia/Colombo"),("1246007", "Gampaha", "", "LK", "144", "", "36", "", "", "7.0897", "79.9925", "Asia/Colombo"),("1246294", "Galle", "Галле", "LK", "144", "", "34", "", "", "6.0367", "80.217", "Asia/Colombo"),("1246321", "Galkissa", "", "LK", "144", "", "36", "", "", "6.8293", "79.863", "Asia/Colombo"),("1246924", "Eravur Town", "Эравуре", "LK", "144", "", "37", "", "", "7.7782", "81.6038", "Asia/Colombo"),("1248749", "Dambulla", "Дамбулла", "LK", "144", "", "29", "1235854", "7434910", "7.86", "80.65167", "Asia/Colombo"),("1248991", "Colombo", "Коломбо", "LK", "144", "", "36", "", "", "6.93194", "79.84778", "Asia/Colombo"),("1249145", "Chilaw", "", "LK", "144", "", "32", "", "", "7.57583", "79.79528", "Asia/Colombo"),("1249931", "Beruwala", "", "LK", "144", "", "36", "", "", "6.4788", "79.9828", "Asia/Colombo"),("1249978", "Bentota", "Бентота", "LK", "144", "", "34", "", "", "6.42598", "79.99575", "Asia/Colombo"),("1250161", "Batticaloa", "Баттикалоа", "LK", "144", "", "37", "", "", "7.7102", "81.6924", "Asia/Colombo"),("1250164", "Battaramulla South", "", "LK", "144", "", "36", "", "", "6.8964", "79.9181", "Asia/Colombo"),("1250615", "Badulla", "Бадуллы", "LK", "144", "", "35", "", "", "6.9895", "81.0557", "Asia/Colombo"),("1251081", "Anuradhapura", "Анурадхапура", "LK", "144", "", "30", "", "", "8.31223", "80.41306", "Asia/Colombo"),("1251459", "Ampara", "", "LK", "144", "", "37", "", "", "7.29754", "81.68202", "Asia/Colombo"),("1251574", "Ambalangoda", "", "LK", "144", "", "34", "", "", "6.2355", "80.0538", "Asia/Colombo"),("6285792", "Horawala Junction", "", "LK", "144", "", "36", "", "", "6.48088", "80.12708", "Asia/Colombo"),("8260318", "Shanjeev Home", "", "LK", "144", "", "37", "", "", "7.38216", "81.84198", "Asia/Colombo"),("9259456", "Mount Lavinia", "", "LK", "144", "", "36", "1248990", "7545420", "6.83947", "79.86451", "Asia/Colombo"),("932035", "Teyateyaneng", "", "LS", "426", "", "10", "", "", "-29.14719", "27.74895", "Africa/Maseru"),("932183", "Quthing", "Цгутинг", "LS", "426", "", "18", "", "", "-30.40001", "27.70027", "Africa/Maseru"),("932218", "Qacha’s Nek", "", "LS", "426", "", "17", "", "", "-30.11537", "28.68936", "Africa/Maseru"),("932320", "Nako", "", "LS", "426", "LS", "14", "", "", "-29.61667", "27.76667", "Africa/Maseru"),("932416", "Mokhotlong", "", "LS", "426", "", "16", "", "", "-29.28939", "29.06751", "Africa/Maseru"),("932438", "Mohale’s Hoek", "", "LS", "426", "", "15", "", "", "-30.15137", "27.47691", "Africa/Maseru"),("932505", "Maseru", "Масеру", "LS", "426", "", "14", "", "", "-29.31667", "27.48333", "Africa/Maseru"),("932521", "Maputsoe", "", "LS", "426", "", "12", "", "", "-28.8866", "27.89915", "Africa/Maseru"),("932614", "Mafeteng", "", "LS", "426", "", "13", "", "", "-29.82299", "27.23744", "Africa/Maseru"),("932698", "Leribe", "Лерибе", "LS", "426", "", "12", "", "", "-28.87185", "28.04501", "Africa/Maseru"),("932886", "Butha-Buthe", "Бута-Бутэ", "LS", "426", "", "11", "", "", "-28.76659", "28.24937", "Africa/Maseru"),("1106835", "Thaba-Tseka", "", "LS", "426", "", "19", "", "", "-29.52204", "28.6084", "Africa/Maseru"),("592891", "Zarasai", "", "LT", "440", "", "64", "43", "", "55.73225", "26.25115", "Europe/Vilnius"),("593063", "Visaginas", "Висагинас", "LT", "440", "", "64", "30", "", "55.59678", "26.43984", "Europe/Vilnius"),("593116", "Vilnius", "Вильнюс", "LT", "440", "", "65", "41", "", "54.68916", "25.2798", "Europe/Vilnius"),("593153", "Vilkaviskis", "", "LT", "440", "", "00", "", "", "54.65167", "23.03222", "Europe/Vilnius"),("593191", "Vievis", "", "LT", "440", "", "65", "13", "", "54.76667", "24.8", "Europe/Vilnius"),("593406", "Varėna", "", "LT", "440", "", "56", "38", "", "54.21546", "24.57538", "Europe/Vilnius"),("593672", "Utena", "Утена", "LT", "440", "", "64", "82", "", "55.49764", "25.59918", "Europe/Vilnius"),("593733", "Ukmerge", "Укмерге", "LT", "440", "", "65", "", "", "55.25", "24.75", "Europe/Vilnius"),("593871", "Trakai", "", "LT", "440", "", "00", "", "", "54.63783", "24.93433", "Europe/Vilnius"),("593926", "Telsiai", "Тельшяй", "LT", "440", "", "63", "78", "", "55.98139", "22.24722", "Europe/Vilnius"),("593959", "Taurage", "Таураге", "LT", "440", "", "62", "", "", "55.25222", "22.28972", "Europe/Vilnius"),("594064", "Švenčionys", "", "LT", "440", "", "65", "86", "", "55.135", "26.159", "Europe/Vilnius"),("594067", "Švenčionėliai", "", "LT", "440", "", "65", "86", "", "55.16163", "26.00177", "Europe/Vilnius"),("594488", "Skuodas", "", "LT", "440", "", "58", "75", "", "56.27057", "21.53208", "Europe/Vilnius"),("594607", "Širvintos", "", "LT", "440", "", "65", "89", "", "55.044", "24.95446", "Europe/Vilnius"),("594656", "Silute", "Шилуте", "LT", "440", "", "58", "", "", "55.34889", "21.48306", "Europe/Vilnius"),("594693", "Šilalė", "", "LT", "440", "", "62", "87", "", "55.4898", "22.18692", "Europe/Vilnius"),("594739", "Šiauliai", "Шяуляй", "LT", "440", "", "61", "91", "", "55.93333", "23.31667", "Europe/Vilnius"),("595016", "Šalčininkai", "", "LT", "440", "", "65", "85", "", "54.30864", "25.38677", "Europe/Vilnius"),("595044", "Šakiai", "", "LT", "440", "", "59", "84", "", "54.95339", "23.04779", "Europe/Vilnius"),("595213", "Rokiškis", "Рокишкис", "LT", "440", "", "60", "73", "", "55.95867", "25.59466", "Europe/Vilnius"),("595378", "Raseiniai", "", "LT", "440", "", "57", "72", "", "55.37973", "23.12386", "Europe/Vilnius"),("595449", "Radviliskis", "Радвилишкис", "LT", "440", "", "61", "", "", "55.81667", "23.53333", "Europe/Vilnius"),("595596", "Prienai", "", "LT", "440", "", "57", "69", "", "54.636", "23.94585", "Europe/Vilnius"),("595689", "Plunge", "Плунге", "LT", "440", "", "63", "", "", "55.91139", "21.84417", "Europe/Vilnius"),("595997", "Pasvalys", "", "LT", "440", "", "60", "595998", "", "56.05944", "24.40361", "Europe/Vilnius"),("596128", "Panevėžys", "Паневежис", "LT", "440", "", "60", "27", "", "55.73333", "24.35", "Europe/Vilnius"),("596238", "Palanga", "Паланга", "LT", "440", "", "58", "55", "", "55.9175", "21.06861", "Europe/Vilnius"),("596260", "Pakruojis", "", "LT", "440", "", "61", "65", "", "55.97889", "23.85508", "Europe/Vilnius"),("596473", "Pabradė", "", "LT", "440", "", "65", "", "", "54.981", "25.761", "Europe/Vilnius"),("596479", "Fabijoniškės", "", "LT", "440", "", "65", "41", "", "54.73333", "25.24167", "Europe/Vilnius"),("596664", "Nemenčinė", "", "LT", "440", "", "65", "13", "", "54.84776", "25.46992", "Europe/Vilnius"),("596719", "Naujoji Akmene", "", "LT", "440", "", "00", "", "", "56.31667", "22.9", "Europe/Vilnius"),("596867", "Molėtai", "", "LT", "440", "", "64", "62", "", "55.22469", "25.41688", "Europe/Vilnius"),("597188", "Mazeikiai", "Мажейкяй", "LT", "440", "", "63", "", "", "56.31667", "22.33333", "Europe/Vilnius"),("597231", "Marijampolė", "Мариямполе", "LT", "440", "", "59", "18", "", "54.55991", "23.35412", "Europe/Vilnius"),("597532", "Lentvaris", "", "LT", "440", "", "65", "79", "", "54.64364", "25.05162", "Europe/Vilnius"),("597729", "Kybartai", "", "LT", "440", "", "59", "", "", "54.63858", "22.76316", "Europe/Vilnius"),("597769", "Kuršėnai", "", "LT", "440", "", "61", "29", "", "56.00318", "22.93662", "Europe/Vilnius"),("597806", "Kupiskis", "", "LT", "440", "", "00", "", "", "55.83333", "24.96667", "Europe/Vilnius"),("597989", "Kretinga", "Кретинга", "LT", "440", "", "58", "56", "", "55.8888", "21.24448", "Europe/Vilnius"),("598098", "Klaipėda", "Клайпеда", "LT", "440", "", "58", "55", "", "55.70888", "21.14312", "Europe/Vilnius"),("598257", "Kelmė", "", "LT", "440", "", "61", "54", "", "55.63009", "22.9349", "Europe/Vilnius"),("598272", "Kėdainiai", "Кедайняй", "LT", "440", "", "57", "53", "", "55.28782", "23.97275", "Europe/Vilnius"),("598286", "Kazlų Rūda", "", "LT", "440", "", "59", "58", "", "54.749", "23.49", "Europe/Vilnius"),("598316", "Kaunas", "Каунас", "LT", "440", "", "57", "52", "", "54.90272", "23.90961", "Europe/Vilnius"),("598567", "Kaišiadorys", "", "LT", "440", "", "57", "49", "", "54.86528", "24.46815", "Europe/Vilnius"),("598655", "Jurbarkas", "", "LT", "440", "", "62", "94", "", "55.07556", "22.76416", "Europe/Vilnius"),("598796", "Joniškis", "", "LT", "440", "", "61", "47", "", "56.23939", "23.61541", "Europe/Vilnius"),("598818", "Jonava", "Ионава", "LT", "440", "", "57", "598814", "", "55.08333", "24.28333", "Europe/Vilnius"),("598998", "Ignalina", "", "LT", "440", "", "64", "45", "", "55.34063", "26.16049", "Europe/Vilnius"),("599161", "Grigiškės", "", "LT", "440", "", "00", "", "", "54.68333", "25.08333", "Europe/Vilnius"),("599504", "Garliava", "", "LT", "440", "", "57", "19", "", "54.82139", "23.8713", "Europe/Vilnius"),("599506", "Gargždai", "Гаргждай", "LT", "440", "", "58", "21", "", "55.70951", "21.39441", "Europe/Vilnius"),("599602", "Elektrėnai", "", "LT", "440", "", "65", "", "", "54.78544", "24.66302", "Europe/Vilnius"),("599757", "Druskininkai", "Друскининкай", "LT", "440", "", "56", "15", "", "54.01573", "23.98703", "Europe/Vilnius"),("600438", "Birzai", "", "LT", "440", "", "60", "36", "", "56.2", "24.75", "Europe/Vilnius"),("600994", "Anyksciai", "", "LT", "440", "", "64", "34", "", "55.52557", "25.10264", "Europe/Vilnius"),("601084", "Alytus", "Алитус", "LT", "440", "", "56", "33", "", "54.39635", "24.04142", "Europe/Vilnius"),("601138", "Aleksotas", "", "LT", "440", "", "57", "52", "", "54.88037", "23.90842", "Europe/Vilnius"),("6618486", "Dainava (Kaunas)", "", "LT", "440", "", "57", "", "", "54.91525", "23.96831", "Europe/Vilnius"),("9610004", "Šilainiai", "", "LT", "440", "", "57", "52", "", "54.92911", "23.88599", "Europe/Vilnius"),("9610008", "Eiguliai", "", "LT", "440", "", "57", "52", "", "54.93133", "23.93243", "Europe/Vilnius"),("10062599", "Pašilaičiai", "", "LT", "440", "", "65", "", "", "54.73429", "25.21912", "Europe/Vilnius"),("10062600", "Pilaitė", "", "LT", "440", "", "65", "", "", "54.69981", "25.18393", "Europe/Vilnius"),("10062601", "Justiniškės", "", "LT", "440", "", "65", "", "", "54.71664", "25.2174", "Europe/Vilnius"),("10062602", "Šeškinė", "", "LT", "440", "", "65", "", "", "54.70972", "25.25053", "Europe/Vilnius"),("10062605", "Lazdynai", "", "LT", "440", "", "65", "", "", "54.66815", "25.20684", "Europe/Vilnius"),("10062606", "Vilkpėdė", "", "LT", "440", "", "65", "", "", "54.66969", "25.2477", "Europe/Vilnius"),("10062607", "Naujamiestis", "", "LT", "440", "", "65", "", "", "54.67951", "25.26855", "Europe/Vilnius"),("10062609", "Rasos", "", "LT", "440", "", "65", "", "", "54.67877", "25.31173", "Europe/Vilnius"),("2960054", "Strassen", "", "LU", "442", "", "LU", "08", "", "49.62056", "6.07333", "Europe/Luxembourg"),("2960102", "Schifflange", "", "LU", "442", "", "ES", "14", "", "49.50639", "6.01278", "Europe/Luxembourg"),("2960187", "Pétange", "", "LU", "442", "", "ES", "09", "", "49.55833", "5.88056", "Europe/Luxembourg"),("2960299", "Mamer", "", "LU", "442", "", "CA", "09", "", "49.6275", "6.02333", "Europe/Luxembourg"),("2960316", "Luxembourg", "Люксембург", "LU", "442", "", "LU", "2960317", "", "49.61167", "6.13", "Europe/Luxembourg"),("2960515", "Grevenmacher", "", "LU", "442", "", "GR", "04", "", "49.67472", "6.44194", "Europe/Luxembourg"),("2960589", "Ettelbruck", "", "LU", "442", "", "DI", "07", "", "49.8475", "6.10417", "Europe/Luxembourg"),("2960596", "Esch-sur-Alzette", "Эш-сюр-Алзетте", "LU", "442", "", "ES", "04", "", "49.49583", "5.98056", "Europe/Luxembourg"),("2960634", "Dudelange", "Дюделанж", "LU", "442", "", "ES", "03", "", "49.48056", "6.0875", "Europe/Luxembourg"),("2960651", "Differdange", "", "LU", "442", "", "ES", "02", "", "49.52417", "5.89139", "Europe/Luxembourg"),("2960657", "Diekirch", "", "LU", "442", "", "DI", "04", "", "49.86778", "6.15583", "Europe/Luxembourg"),("2960777", "Bettembourg", "", "LU", "442", "", "ES", "01", "", "49.51861", "6.10278", "Europe/Luxembourg"),("2960782", "Bertrange", "", "LU", "442", "", "LU", "01", "", "49.61111", "6.05", "Europe/Luxembourg"),("2960800", "Belvaux", "", "LU", "442", "", "ES", "13", "", "49.51278", "5.92944", "Europe/Luxembourg"),("453754", "Valmiera", "Валмиера", "LV", "428", "", "31", "0250000", "", "57.54108", "25.42751", "Europe/Riga"),("453850", "Zilupe", "", "LV", "428", "", "E9", "0681817", "", "56.38616", "28.12165", "Europe/Riga"),("453922", "Zelmeņi", "", "LV", "428", "", "D5", "0468988", "", "56.45167", "23.35194", "Europe/Riga"),("454130", "Viļaka", "", "LV", "428", "", "E7", "0381615", "", "57.18458", "27.6722", "Europe/Riga"),("454178", "Viļāni", "", "LV", "428", "", "E8", "0781817", "", "56.55253", "26.92449", "Europe/Riga"),("454216", "Viesīte", "", "LV", "428", "", "E6", "0561815", "", "56.34751", "25.55514", "Europe/Riga"),("454273", "Vecumnieki", "", "LV", "428", "", "E4", "0409594", "", "56.60639", "24.52222", "Europe/Riga"),("454310", "Ventspils", "Вентспилс", "LV", "428", "", "32", "0270000", "", "57.38988", "21.57288", "Europe/Riga"),("454372", "Vecvārkava", "", "LV", "428", "", "E2", "0769190", "", "56.19838", "26.50811", "Europe/Riga"),("454408", "Vecpiebalga", "", "LV", "428", "", "E3", "0429392", "", "57.0609", "25.81624", "Europe/Riga"),("454530", "Varakļāni", "", "LV", "428", "", "E1", "0701817", "", "56.60826", "26.75377", "Europe/Riga"),("454572", "Valka", "", "LV", "428", "", "30", "0940201", "", "57.7752", "26.01013", "Europe/Riga"),("454602", "Vaiņode", "", "LV", "428", "", "D7", "0649392", "", "56.43333", "21.86667", "Europe/Riga"),("454714", "Ulbroka", "", "LV", "428", "", "D2", "0809600", "", "56.9363", "24.30387", "Europe/Riga"),("454768", "Tukums", "Тукумс", "LV", "428", "", "29", "0900201", "", "56.96694", "23.15528", "Europe/Riga"),("454970", "Talsi", "", "LV", "428", "", "28", "0880201", "", "57.24562", "22.58137", "Europe/Riga"),("455166", "Strenči", "", "LV", "428", "", "D3", "0941817", "", "57.62574", "25.68535", "Europe/Riga"),("455293", "Stalbe", "", "LV", "428", "", "A4", "0427580", "", "57.37065", "25.03106", "Europe/Riga"),("455406", "Smiltene", "", "LV", "428", "", "D1", "0941615", "", "57.42444", "25.90164", "Europe/Riga"),("455427", "Smārde", "", "LV", "428", "", "62", "0905182", "", "56.9542", "23.33736", "Europe/Riga"),("455520", "Skrunda", "", "LV", "428", "", "C9", "0621209", "", "56.68333", "22.01667", "Europe/Riga"),("455523", "Skrīveri", "", "LV", "428", "", "C8", "0328200", "", "56.645", "25.12058", "Europe/Riga"),("455718", "Sigulda", "", "LV", "428", "", "C7", "0801615", "", "57.15194", "24.86472", "Europe/Riga"),("455812", "Saulkrasti", "", "LV", "428", "", "C5", "0801413", "", "57.26224", "24.41471", "Europe/Riga"),("455890", "Saldus", "", "LV", "428", "", "27", "0840201", "", "56.66363", "22.48807", "Europe/Riga"),("455898", "Salaspils", "Саласпилс", "LV", "428", "", "C3", "0801211", "", "56.86014", "24.36544", "Europe/Riga"),("455910", "Salacgrīva", "", "LV", "428", "", "C1", "0661415", "", "57.75361", "24.35806", "Europe/Riga"),("455915", "Sala", "", "LV", "428", "", "C2", "0568786", "", "56.50675", "25.76423", "Europe/Riga"),("456008", "Rūjiena", "", "LV", "428", "", "B8", "0961615", "", "57.89752", "25.33155", "Europe/Riga"),("456015", "Rugāji", "", "LV", "428", "", "B7", "0387574", "", "57", "27.13333", "Europe/Riga"),("456050", "Rucava", "", "LV", "428", "", "B6", "0648584", "", "56.16314", "21.16156", "Europe/Riga"),("456089", "Garkalne", "", "LV", "428", "", "64", "0806000", "", "57.04486", "24.41951", "Europe/Riga"),("456090", "Ropaži", "", "LV", "428", "", "B5", "0808400", "", "56.97389", "24.63361", "Europe/Riga"),("456107", "Roja", "", "LV", "428", "", "B4", "0888301", "", "57.50146", "22.80881", "Europe/Riga"),("456172", "Riga", "Рига", "LV", "428", "", "25", "0010000", "", "56.946", "24.10589", "Europe/Riga"),("456185", "Riebiņi", "", "LV", "428", "", "B3", "0766362", "", "56.3428", "26.79995", "Europe/Riga"),("456202", "Rēzekne", "Резекне", "LV", "428", "", "23", "0210000", "", "56.5", "27.31667", "Europe/Riga"),("456272", "Rauna", "", "LV", "428", "", "B1", "0427776", "", "57.33173", "25.60947", "Europe/Riga"),("456341", "Ragana", "", "LV", "428", "", "84", "0806968", "", "57.18074", "24.70731", "Europe/Riga"),("456503", "Priekuļi", "", "LV", "428", "", "A9", "0427372", "", "57.315", "25.36147", "Europe/Riga"),("456506", "Priekule", "", "LV", "428", "", "A8", "0641615", "", "56.44679", "21.58968", "Europe/Riga"),("456530", "Preiļi", "", "LV", "428", "", "22", "0760201", "", "56.29444", "26.72459", "Europe/Riga"),("456635", "Pļaviņas", "", "LV", "428", "", "A6", "0321413", "", "56.6178", "25.72552", "Europe/Riga"),("456685", "Piņķi", "", "LV", "428", "", "45", "0804948", "", "56.94189", "23.91365", "Europe/Riga"),("456698", "Pilsrundāle", "", "LV", "428", "", "B9", "0407776", "", "56.41667", "24", "Europe/Riga"),("456827", "Pāvilosta", "", "LV", "428", "", "A5", "0641413", "", "56.88791", "21.18593", "Europe/Riga"),("456954", "Ozolnieki", "", "LV", "428", "", "A3", "0546766", "", "56.68639", "23.78778", "Europe/Riga"),("457052", "Olaine", "", "LV", "428", "", "A2", "0801009", "", "56.78528", "23.93806", "Europe/Riga"),("457065", "Ogre", "Огре", "LV", "428", "", "21", "0740201", "", "56.8162", "24.61401", "Europe/Riga"),("457142", "Nīca", "", "LV", "428", "", "99", "0647978", "", "56.34601", "21.06401", "Europe/Riga"),("457148", "Nereta", "", "LV", "428", "", "98", "0327170", "", "56.20279", "25.30752", "Europe/Riga"),("457161", "Naukšēni", "", "LV", "428", "", "97", "0967372", "", "57.88349", "25.45609", "Europe/Riga"),("457211", "Murmuiža", "", "LV", "428", "", "50", "0964762", "", "57.48333", "25.48333", "Europe/Riga"),("457408", "Mērsrags", "", "LV", "428", "", "F1", "0887600", "", "57.33535", "23.12455", "Europe/Riga"),("457533", "Mazsalaca", "", "LV", "428", "", "96", "0961011", "", "57.86329", "25.05475", "Europe/Riga"),("457615", "Matīši", "", "LV", "428", "", "52", "0967170", "", "57.69892", "25.15886", "Europe/Riga"),("457676", "Mālpils", "", "LV", "428", "", "94", "0807400", "", "57.01111", "24.96306", "Europe/Riga"),("457714", "Madona", "", "LV", "428", "", "20", "0700201", "", "56.85329", "26.21698", "Europe/Riga"),("457776", "Ludza", "", "LV", "428", "", "19", "0680201", "", "56.53958", "27.71891", "Europe/Riga"),("457799", "Lubāna", "", "LV", "428", "", "91", "0701413", "", "56.9", "26.71667", "Europe/Riga"),("457822", "Loja", "", "LV", "428", "", "C6", "0809200", "", "57.15444", "24.64444", "Europe/Riga"),("457860", "Līvāni", "", "LV", "428", "", "90", "0761211", "", "56.35431", "26.17579", "Europe/Riga"),("457890", "Limbaži", "", "LV", "428", "", "18", "0660201", "", "57.51287", "24.71941", "Europe/Riga"),("457912", "Līgatne", "", "LV", "428", "", "88", "0421211", "", "57.23429", "25.04059", "Europe/Riga"),("457954", "Liepāja", "Лиепая", "LV", "428", "", "16", "0170000", "", "56.51667", "21.01667", "Europe/Riga"),("457965", "Lielvārde", "", "LV", "428", "", "87", "0741413", "", "56.72066", "24.80743", "Europe/Riga"),("458065", "Lieģi", "", "LV", "428", "", "61", "0640888", "", "56.58173", "21.33399", "Europe/Riga"),("458460", "Kuldīga", "", "LV", "428", "", "15", "0620201", "", "56.97399", "21.95721", "Europe/Riga"),("458511", "Krustpils", "", "LV", "428", "", "10", "", "", "56.51068", "25.86117", "Europe/Riga"),("458623", "Krāslava", "", "LV", "428", "", "14", "0600201", "", "55.89514", "27.16799", "Europe/Riga"),("458687", "Koknese", "", "LV", "428", "", "82", "0326160", "", "56.65", "25.43333", "Europe/Riga"),("458695", "Kocēni", "", "LV", "428", "", "81", "0960264", "", "57.52057", "25.33821", "Europe/Riga"),("458880", "Ķekava", "", "LV", "428", "", "80", "0800870", "", "56.82662", "24.23", "Europe/Riga"),("458892", "Ķegums", "", "LV", "428", "", "79", "0741009", "", "56.7451", "24.72439", "Europe/Riga"),("458972", "Kārsava", "", "LV", "428", "", "78", "0681009", "", "56.78405", "27.68829", "Europe/Riga"),("458995", "Karosta", "", "LV", "428", "", "16", "0170000", "", "56.55", "21.01667", "Europe/Riga"),("459031", "Kandava", "", "LV", "428", "", "77", "0901211", "", "57.04087", "22.77466", "Europe/Riga"),("459201", "Jūrmala", "Юрмала", "LV", "428", "", "13", "0130000", "", "56.968", "23.77038", "Europe/Riga"),("459279", "Jelgava", "Елгава", "LV", "428", "", "11", "0090000", "", "56.65", "23.71278", "Europe/Riga"),("459283", "Jēkabpils", "Екабпилс", "LV", "428", "", "10", "", "", "56.49903", "25.85735", "Europe/Riga"),("459357", "Jaunpils", "", "LV", "428", "", "73", "0905756", "", "56.7325", "23.01361", "Europe/Riga"),("459359", "Jaunpiebalga", "", "LV", "428", "", "72", "0425756", "", "57.18333", "26.05", "Europe/Riga"),("459402", "Jaunjelgava", "", "LV", "428", "", "71", "0321007", "", "56.61319", "25.08316", "Europe/Riga"),("459563", "Inčukalns", "", "LV", "428", "", "70", "0801864", "", "57.09806", "24.68639", "Europe/Riga"),("459586", "Ilūkste", "", "LV", "428", "", "69", "0440807", "", "55.97754", "26.29655", "Europe/Riga"),("459598", "Ikšķile", "", "LV", "428", "", "68", "0740605", "", "56.83333", "24.5", "Europe/Riga"),("459624", "Iecava", "", "LV", "428", "", "67", "0406400", "", "56.59861", "24.20222", "Europe/Riga"),("459668", "Gulbene", "", "LV", "428", "", "09", "0500201", "", "57.17767", "26.75291", "Europe/Riga"),("459692", "Grobiņa", "", "LV", "428", "", "65", "0641009", "", "56.53521", "21.16782", "Europe/Riga"),("459984", "Cibla", "", "LV", "428", "", "56", "0684948", "", "56.5498", "27.8837", "Europe/Riga"),("460001", "Ērgļi", "", "LV", "428", "", "63", "0705554", "", "56.89752", "25.63668", "Europe/Riga"),("460187", "Dundaga", "", "LV", "428", "", "60", "0885150", "", "57.50498", "22.35041", "Europe/Riga"),("460285", "Drabeši", "", "LV", "428", "", "42", "0424746", "", "57.24316", "25.27748", "Europe/Riga"),("460312", "Dobele", "", "LV", "428", "", "08", "0460201", "", "56.625", "23.27861", "Europe/Riga"),("460413", "Daugavpils", "Даугавпилс", "LV", "428", "", "07", "", "", "55.88333", "26.53333", "Europe/Riga"),("460416", "Daugavgrīva", "", "LV", "428", "LV", "25", "0010000", "", "57.04315", "24.03613", "Europe/Riga"),("460474", "Dagda", "", "LV", "428", "", "57", "0601009", "", "56.09512", "27.53723", "Europe/Riga"),("460568", "Cesvaine", "", "LV", "428", "", "55", "0700807", "", "56.96667", "26.31667", "Europe/Riga"),("460570", "Cēsis", "Цесис", "LV", "428", "", "05", "0420201", "", "57.31188", "25.27456", "Europe/Riga"),("460659", "Carnikava", "", "LV", "428", "", "53", "0805200", "", "57.12935", "24.28423", "Europe/Riga"),("460786", "Brocēni", "", "LV", "428", "", "51", "0840625", "", "56.7", "22.53333", "Europe/Riga"),("460885", "Bolderaja", "", "LV", "428", "LV", "25", "0010000", "", "57.03132", "24.05571", "Europe/Riga"),("461064", "Berģi", "", "LV", "428", "", "25", "0010000", "", "56.98639", "24.29917", "Europe/Riga"),("461114", "Bauska", "", "LV", "428", "", "04", "0400201", "", "56.40794", "24.19443", "Europe/Riga"),("461163", "Balvi", "", "LV", "428", "", "03", "0380201", "", "57.1313", "27.26583", "Europe/Riga"),("461180", "Baltinava", "", "LV", "428", "", "47", "0384400", "", "56.94394", "27.64401", "Europe/Riga"),("461224", "Baldone", "", "LV", "428", "", "46", "0800605", "", "56.74278", "24.39444", "Europe/Riga"),("461336", "Auce", "", "LV", "428", "", "44", "0460805", "", "56.45981", "22.90169", "Europe/Riga"),("461442", "Ape", "", "LV", "428", "", "43", "0360805", "", "57.53928", "26.69291", "Europe/Riga"),("461528", "Alūksne", "", "LV", "428", "", "02", "0360201", "", "57.42162", "27.04662", "Europe/Riga"),("461534", "Alsunga", "", "LV", "428", "", "40", "0624200", "", "56.98194", "21.55938", "Europe/Riga"),("461539", "Aloja", "", "LV", "428", "", "39", "0661007", "", "57.76694", "24.8825", "Europe/Riga"),("461566", "Aknīste", "", "LV", "428", "", "38", "0560805", "", "56.16152", "25.74783", "Europe/Riga"),("461602", "Aizpute", "", "LV", "428", "", "37", "0640605", "", "56.71667", "21.6", "Europe/Riga"),("461615", "Aizkraukle", "", "LV", "428", "", "01", "0320201", "", "56.60477", "25.25534", "Europe/Riga"),("461631", "Aglona", "", "LV", "428", "", "35", "0604342", "", "56.13333", "27.01667", "Europe/Riga"),("461650", "Ādaži", "", "LV", "428", "", "34", "0804400", "", "57.07045", "24.33713", "Europe/Riga"),("864723", "Mārupe", "", "LV", "428", "", "95", "0807600", "", "56.90544", "24.05113", "Europe/Riga"),("2526435", "Zaïo", "", "MA", "504", "", "02", "381", "0838101071", "34.94282", "-2.7329", "Africa/Casablanca"),("2526452", "Zagora", "Загора", "MA", "504", "", "08", "587", "0458701131", "30.33241", "-5.8384", "Africa/Casablanca");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("2526488", "Youssoufia", "", "MA", "504", "", "07", "431", "1143101131", "32.24634", "-8.52941", "Africa/Casablanca"),("2527089", "Tiznit", "Тизнит", "MA", "504", "", "09", "581", "0458101071", "29.69742", "-9.73162", "Africa/Casablanca"),("2527645", "Tirhanimîne", "", "MA", "504", "", "01", "051", "", "35.23619", "-3.95453", "Africa/Casablanca"),("2527915", "Tinghir", "", "MA", "504", "", "08", "577", "", "31.51472", "-5.53278", "Africa/Casablanca"),("2528659", "Tiflet", "", "MA", "504", "", "04", "291", "1029101051", "33.89469", "-6.30649", "Africa/Casablanca"),("2528910", "Tétouan", "Тетуан", "MA", "504", "", "01", "571", "", "35.57845", "-5.36837", "Africa/Casablanca"),("2529317", "Taza", "Таза", "MA", "504", "", "03", "561", "1556101111", "34.21", "-4.01", "Africa/Casablanca"),("2529649", "Taroudant", "Тарудант", "MA", "504", "", "09", "541", "0454101131", "30.47028", "-8.87695", "Africa/Casablanca"),("2529923", "Tarfaya", "", "MA", "504", "", "59", "", "", "27.9392", "-12.92604", "Africa/Casablanca"),("2530048", "Taourirt", "", "MA", "504", "", "02", "533", "0853301331", "34.40731", "-2.89732", "Africa/Casablanca"),("2530155", "Taounate", "Таунат", "MA", "504", "", "03", "531", "1553101051", "34.53661", "-4.64009", "Africa/Casablanca"),("2530241", "Tan-Tan", "Тан-Тан", "MA", "504", "", "10", "521", "", "28.43799", "-11.10321", "Africa/Casablanca"),("2530335", "Tangier", "Танжер", "MA", "504", "", "01", "511", "1651101071", "35.76727", "-5.79975", "Africa/Casablanca"),("2531480", "Tahla", "", "MA", "504", "", "03", "561", "1556101071", "34.04965", "-4.42162", "Africa/Casablanca"),("2532394", "Souq Larb’a al Gharb", "", "MA", "504", "", "04", "281", "0528101111", "34.68664", "-6.00272", "Africa/Casablanca"),("2532822", "Sidi Yahia El Gharb", "", "MA", "504", "", "04", "491", "0528101091", "34.30494", "-6.30404", "Africa/Casablanca"),("2532945", "Sidi Slimane", "Сиди-Слимане", "MA", "504", "", "04", "281", "0528101071", "34.26479", "-5.92598", "Africa/Casablanca"),("2533191", "Sidi Qacem", "", "MA", "504", "", "04", "481", "", "34.22149", "-5.70775", "Africa/Casablanca"),("2534515", "Sidi Ifni", "Сиди Ифни", "MA", "504", "", "09", "581", "0458101031", "29.37975", "-10.17299", "Africa/Casablanca"),("2536074", "Sidi Bennour", "", "MA", "504", "", "06", "181", "1118101071", "32.65236", "-8.42769", "Africa/Casablanca"),("2537406", "Settat", "Сеттат", "MA", "504", "", "06", "461", "0646101151", "33.00103", "-7.61662", "Africa/Casablanca"),("2537545", "Sefrou", "", "MA", "504", "", "03", "451", "1445101091", "33.83186", "-4.828", "Africa/Casablanca"),("2537763", "Sale", "Сале", "MA", "504", "", "04", "441", "", "34.0531", "-6.79846", "Africa/Casablanca"),("2537881", "Safi", "Сафи", "MA", "504", "", "07", "431", "1143101031", "32.29939", "-9.23718", "Africa/Casablanca"),("2538475", "Rabat", "Рабат", "MA", "504", "", "04", "421", "", "34.01325", "-6.83255", "Africa/Casablanca"),("2539134", "Oulad Teïma", "", "MA", "504", "", "09", "541", "0454101091", "30.39467", "-9.20897", "Africa/Casablanca"),("2540483", "Oujda-Angad", "Уджда", "MA", "504", "", "02", "411", "0841101231", "34.68139", "-1.90858", "Africa/Casablanca"),("2540689", "Oued Zem", "", "MA", "504", "", "05", "311", "0631101091", "32.8627", "-6.57359", "Africa/Casablanca"),("2540810", "Ouezzane", "", "MA", "504", "", "01", "405", "", "34.79584", "-5.57849", "Africa/Casablanca"),("2540850", "Ouarzazat", "Варзазат", "MA", "504", "", "08", "401", "", "30.91894", "-6.89341", "Africa/Casablanca"),("2541210", "Nouaseur", "", "MA", "504", "", "50", "", "", "33.3802", "-7.62105", "Africa/Casablanca"),("2541479", "Nador", "Надор", "MA", "504", "", "02", "381", "0838101051", "35.16813", "-2.93352", "Africa/Casablanca"),("2542051", "Mohammedia", "Мохаммедия", "MA", "504", "", "06", "371", "0937101011", "33.68607", "-7.38298", "Africa/Casablanca"),("2542227", "Midelt", "", "MA", "504", "", "05", "301", "1330101031", "32.6852", "-4.74512", "Africa/Casablanca"),("2542715", "Meknès", "Мекнес", "MA", "504", "", "03", "061", "1306101011", "33.89352", "-5.54727", "Africa/Casablanca"),("2542866", "Mechraa Bel Ksiri", "", "MA", "504", "", "04", "481", "0548101071", "34.57373", "-5.95585", "Africa/Casablanca"),("2542987", "Martil", "", "MA", "504", "", "01", "571", "1657101031", "35.61662", "-5.27522", "Africa/Casablanca"),("2542997", "Marrakesh", "Марракеш", "MA", "504", "", "07", "351", "0735101071", "31.63416", "-7.99994", "Africa/Casablanca"),("2543394", "Ifrane", "", "MA", "504", "", "56", "", "", "31.70217", "-6.3494", "Africa/Casablanca"),("2543549", "Larache", "Лараша", "MA", "504", "", "01", "331", "1633101031", "35.19321", "-6.15572", "Africa/Casablanca"),("2544001", "Ksar El Kebir", "", "MA", "504", "", "01", "331", "", "35.00044", "-5.90378", "Africa/Casablanca"),("2544248", "Khouribga", "", "MA", "504", "", "05", "311", "0631101071", "32.88108", "-6.9063", "Africa/Casablanca"),("2544333", "Khenifra", "Хенифра", "MA", "504", "", "05", "301", "1330101011", "32.93492", "-5.66167", "Africa/Casablanca"),("2544571", "Kenitra", "Кенитра", "MA", "504", "", "04", "281", "0528101011", "34.26101", "-6.5802", "Africa/Casablanca"),("2544720", "Kasba Tadla", "", "MA", "504", "", "05", "091", "1209101071", "32.5977", "-6.26844", "Africa/Casablanca"),("2545017", "Jerada", "Джерада", "MA", "504", "", "02", "275", "0827501171", "34.31", "-2.16", "Africa/Casablanca"),("2548489", "Guercif", "", "MA", "504", "", "03", "561", "1556101031", "34.22568", "-3.35361", "Africa/Casablanca"),("2548526", "Guelmim", "", "MA", "504", "", "10", "261", "0326101031", "28.98696", "-10.05738", "Africa/Casablanca"),("2548830", "Al Fqih Ben Çalah", "", "MA", "504", "", "05", "255", "", "32.50213", "-6.68771", "Africa/Casablanca"),("2548851", "Figuig (Centre)", "", "MA", "504", "", "54", "", "", "32.10891", "-1.22855", "Africa/Casablanca"),("2548880", "Fès al Bali", "", "MA", "504", "", "03", "231", "", "34.0701", "-4.95473", "Africa/Casablanca"),("2548885", "Fès", "Фес", "MA", "504", "", "03", "231", "1423101071", "34.03313", "-5.00028", "Africa/Casablanca"),("2549263", "Essaouira", "Эссуэйра", "MA", "504", "", "07", "211", "0721101051", "31.5125", "-9.77", "Africa/Casablanca"),("2550078", "El Jadid", "Эль-Джадида", "MA", "504", "", "06", "181", "", "33.25682", "-8.50882", "Africa/Casablanca"),("2550252", "El Hajeb", "", "MA", "504", "", "03", "171", "1317101051", "33.68786", "-5.371", "Africa/Casablanca"),("2550806", "El Aïoun", "", "MA", "504", "", "02", "", "", "34.58319", "-2.50612", "Africa/Casablanca"),("2550898", "Imzouren", "", "MA", "504", "", "01", "051", "1505101051", "35.14637", "-3.85063", "Africa/Casablanca"),("2553455", "Chefchaouene", "Шефшауен", "MA", "504", "", "01", "151", "", "35.16878", "-5.2636", "Africa/Casablanca"),("2553604", "Casablanca", "Касабланка", "MA", "504", "", "06", "141", "", "33.58831", "-7.61138", "Africa/Casablanca"),("2553751", "Bouznika", "Бузнике", "MA", "504", "", "06", "111", "0611101031", "33.78942", "-7.15968", "Africa/Casablanca"),("2555467", "Berkane", "", "MA", "504", "", "02", "113", "0811301091", "34.92", "-2.32", "Africa/Casablanca"),("2555745", "Beni Mellal", "Бени-Меллаль", "MA", "504", "", "05", "091", "1209109012", "32.33725", "-6.34983", "Africa/Casablanca"),("2556272", "Berrechid", "", "MA", "504", "", "06", "461", "0646101031", "33.26553", "-7.58754", "Africa/Casablanca"),("2556464", "Azrou", "", "MA", "504", "", "03", "271", "1327101011", "33.43443", "-5.22126", "Africa/Casablanca"),("2556657", "Azemmour", "", "MA", "504", "", "06", "181", "1118101011", "33.28952", "-8.3425", "Africa/Casablanca"),("2557055", "Asilah", "Асилах", "MA", "504", "", "01", "511", "", "35.46522", "-6.03415", "Africa/Casablanca"),("2558470", "Khemisset", "", "MA", "504", "", "04", "291", "1029101011", "33.82404", "-6.06627", "Africa/Casablanca"),("2558545", "Al Hoceïma", "", "MA", "504", "", "01", "051", "", "35.25165", "-3.93723", "Africa/Casablanca"),("2561124", "Ahfir", "", "MA", "504", "", "02", "113", "0811301011", "34.95368", "-2.10027", "Africa/Casablanca"),("2561668", "Agadir", "Агадир", "MA", "504", "", "09", "001", "0400101011", "30.42018", "-9.59815", "Africa/Casablanca"),("2562055", "Skhirate", "", "MA", "504", "", "04", "501", "1050101051", "33.8527", "-7.03171", "Africa/Casablanca"),("2565267", "Mhamid", "", "MA", "504", "", "55", "", "", "29.82", "-5.72", "Africa/Casablanca"),("6546693", "Boujniba", "", "MA", "504", "", "05", "311", "0631101031", "32.90046", "-6.77464", "Africa/Casablanca"),("8542188", "Dakhla", "", "MA", "504", "", "EH", "", "", "30.41071", "-9.55572", "Africa/Casablanca"),("9645313", "Gueltat Zemmour", "", "MA", "504", "", "11", "121", "0212103012", "25.14276", "-12.37168", "Africa/Casablanca"),("2992741", "Monte-Carlo", "Монте-Карло", "MC", "492", "", "00", "", "", "43.73976", "7.42732", "Europe/Monaco"),("2993458", "Monaco", "Монако", "MC", "492", "", "00", "", "", "43.73333", "7.41667", "Europe/Monaco"),("3009937", "La Condamine", "", "MC", "492", "", "00", "", "", "43.73439", "7.42024", "Europe/Monaco"),("617076", "Edineţ", "Единцы", "MD", "498", "", "73", "", "", "48.17215", "27.30337", "Europe/Chisinau"),("617081", "Iargara", "", "MD", "498", "", "65", "", "", "46.4252", "28.42676", "Europe/Chisinau"),("617096", "Vulcăneşti", "", "MD", "498", "", "51", "", "", "45.68492", "28.40613", "Europe/Chisinau"),("617164", "Vadul lui Vodă", "", "MD", "498", "", "57", "", "", "47.09009", "29.0757", "Europe/Chisinau"),("617180", "Ungheni", "Унгень", "MD", "498", "", "92", "", "", "47.21079", "27.80047", "Europe/Chisinau"),("617187", "Tvardița", "", "MD", "498", "", "90", "", "", "46.14826", "28.96491", "Europe/Chisinau"),("617239", "Tiraspolul", "Тирасполь", "MD", "498", "", "58", "", "", "46.84274", "29.62909", "Europe/Chisinau"),("617254", "Teleneşti", "", "MD", "498", "", "91", "", "", "47.5011", "28.36536", "Europe/Chisinau"),("617270", "Taraclia", "", "MD", "498", "", "90", "", "", "45.90273", "28.66816", "Europe/Chisinau"),("617279", "Sîngera", "", "MD", "498", "", "57", "", "", "46.91557", "28.96673", "Europe/Chisinau"),("617284", "Ştefan Vodă", "", "MD", "498", "", "88", "", "", "46.51287", "29.66193", "Europe/Chisinau"),("617302", "Strășeni", "Страшенский район", "MD", "498", "", "89", "", "", "47.14216", "28.60774", "Europe/Chisinau"),("617317", "Stăuceni", "", "MD", "498", "", "57", "", "", "47.09643", "28.86791", "Europe/Chisinau"),("617345", "Bilicenii Vechi", "", "MD", "498", "", "85", "", "", "47.6558", "28.04734", "Europe/Chisinau"),("617367", "Soroca", "Сорока", "MD", "498", "", "87", "", "", "48.15659", "28.28489", "Europe/Chisinau"),("617372", "Şoldăneşti", "", "MD", "498", "", "86", "", "", "47.81608", "28.79718", "Europe/Chisinau"),("617381", "Slobozia", "", "MD", "498", "", "58", "", "", "46.72927", "29.70446", "Europe/Chisinau"),("617482", "Rîşcani", "", "MD", "498", "", "84", "", "", "47.94792", "27.56376", "Europe/Chisinau"),("617486", "Rîbniţa", "Рыбница", "MD", "498", "", "58", "", "", "47.76817", "29.01", "Europe/Chisinau"),("617502", "Rezina", "", "MD", "498", "", "83", "", "", "47.74928", "28.96583", "Europe/Chisinau"),("617602", "Pervomaisc", "", "MD", "498", "", "58", "", "", "46.73253", "29.9617", "Europe/Chisinau"),("617638", "Orhei", "Оргеев", "MD", "498", "", "82", "", "", "47.38494", "28.82446", "Europe/Chisinau"),("617659", "Ocniţa", "", "MD", "498", "", "81", "", "", "48.38274", "27.43805", "Europe/Chisinau"),("617702", "Anenii Noi", "", "MD", "498", "", "59", "", "", "46.87839", "29.23483", "Europe/Chisinau"),("617753", "Nisporeni", "", "MD", "498", "", "80", "", "", "47.08139", "28.17833", "Europe/Chisinau"),("617778", "Mîndreşti", "", "MD", "498", "", "91", "", "", "47.50525", "28.27687", "Europe/Chisinau"),("617904", "Leova", "", "MD", "498", "", "79", "", "", "46.4823", "28.25301", "Europe/Chisinau"),("617914", "Sîngerei", "", "MD", "498", "", "85", "", "", "47.63632", "28.14296", "Europe/Chisinau"),("617965", "Cricova", "", "MD", "498", "", "57", "", "", "47.13835", "28.86156", "Europe/Chisinau"),("617993", "Hînceşti", "Хынчешты", "MD", "498", "", "77", "", "", "46.83047", "28.59064", "Europe/Chisinau"),("618057", "Cocieri", "", "MD", "498", "", "72", "", "", "47.3017", "29.11755", "Europe/Chisinau"),("618067", "Chiţcani", "", "MD", "498", "MD", "67", "", "", "46.78296", "29.61682", "Europe/Chisinau"),("618120", "Căuşeni", "Каушаны", "MD", "498", "", "67", "", "", "46.63674", "29.41114", "Europe/Chisinau"),("618196", "Ialoveni", "", "MD", "498", "", "78", "", "", "46.94346", "28.78233", "Europe/Chisinau"),("618234", "Grigoriopol", "", "MD", "498", "", "58", "", "", "47.15413", "29.30008", "Europe/Chisinau"),("618261", "Glodeni", "", "MD", "498", "", "76", "", "", "47.77513", "27.51891", "Europe/Chisinau"),("618329", "Floreşti", "Флорешты", "MD", "498", "", "75", "", "", "47.89137", "28.29312", "Europe/Chisinau"),("618344", "Fălești", "", "MD", "498", "", "74", "", "", "47.57667", "27.71264", "Europe/Chisinau"),("618365", "Dubăsari", "Дубоссары", "MD", "498", "", "58", "", "", "47.26562", "29.16667", "Europe/Chisinau"),("618370", "Drochia", "Дрокия", "MD", "498", "", "71", "", "", "48.03555", "27.81293", "Europe/Chisinau"),("618382", "Donduşeni", "", "MD", "498", "", "70", "", "", "48.24268", "27.6101", "Europe/Chisinau"),("618387", "Dnestrovsc", "", "MD", "498", "", "58", "", "", "46.6164", "29.91926", "Europe/Chisinau"),("618400", "Dancu", "", "MD", "498", "", "77", "", "", "46.75818", "28.20716", "Europe/Chisinau"),("618403", "Criuleni", "", "MD", "498", "", "69", "", "", "47.21307", "29.15926", "Europe/Chisinau"),("618405", "Comrat", "Комрат", "MD", "498", "", "51", "", "", "46.29456", "28.6565", "Europe/Chisinau"),("618406", "Cimişlia", "", "MD", "498", "", "68", "", "", "46.52685", "28.76441", "Europe/Chisinau"),("618426", "Chisinau", "Кишинёв", "MD", "498", "", "57", "", "", "47.00556", "28.8575", "Europe/Chisinau"),("618450", "Ceadîr-Lunga", "Чадыр-Лунга", "MD", "498", "", "51", "", "", "46.06169", "28.83078", "Europe/Chisinau"),("618452", "Cantemir", "", "MD", "498", "", "65", "", "", "46.27743", "28.2027", "Europe/Chisinau"),("618453", "Camenca", "", "MD", "498", "", "58", "", "", "48.03233", "28.69899", "Europe/Chisinau"),("618454", "Călăraşi", "", "MD", "498", "", "66", "", "", "47.25444", "28.30806", "Europe/Chisinau"),("618456", "Cahul", "Кахул", "MD", "498", "", "64", "", "", "45.90425", "28.19929", "Europe/Chisinau"),("618510", "Briceni", "", "MD", "498", "", "63", "", "", "48.36289", "27.07787", "Europe/Kiev"),("618512", "Briceni", "", "MD", "498", "", "70", "", "", "48.35628", "27.70293", "Europe/Chisinau"),("618577", "Bender", "Бендеры", "MD", "498", "", "62", "", "", "46.83156", "29.47769", "Europe/Chisinau"),("618594", "Basarabeasca", "", "MD", "498", "", "61", "", "", "46.3317", "28.96365", "Europe/Chisinau"),("618605", "Bălţi", "Бельцы", "MD", "498", "", "60", "", "", "47.76314", "27.92932", "Europe/Chisinau"),("618631", "Otaci", "", "MD", "498", "", "81", "", "", "48.43285", "27.79912", "Europe/Chisinau"),("824153", "Ciorescu", "", "MD", "498", "", "57", "", "", "47.13", "28.88937", "Europe/Chisinau"),("786234", "Rožaje", "", "ME", "499", "", "17", "", "", "42.83299", "20.16652", "Europe/Podgorica"),("3186999", "Žabljak", "", "ME", "499", "", "21", "", "", "43.15423", "19.12325", "Europe/Podgorica"),("3188516", "Ulcinj", "", "ME", "499", "", "20", "", "", "41.92936", "19.22436", "Europe/Podgorica"),("3189073", "Tivat", "", "ME", "499", "", "19", "", "", "42.43639", "18.69611", "Europe/Podgorica"),("3191222", "Šavnik", "", "ME", "499", "", "18", "", "", "42.95639", "19.09667", "Europe/Podgorica"),("3193044", "Podgorica", "Подгорица", "ME", "499", "", "16", "", "", "42.44111", "19.26361", "Europe/Podgorica"),("3193131", "Plužine", "", "ME", "499", "", "15", "", "", "43.15278", "18.83944", "Europe/Podgorica"),("3193161", "Pljevlja", "Плевля", "ME", "499", "", "14", "", "", "43.3567", "19.35843", "Europe/Podgorica"),("3193228", "Plav", "", "ME", "499", "", "13", "", "", "42.59694", "19.94556", "Europe/Podgorica"),("3194494", "Nikšić", "Никшич", "ME", "499", "", "12", "", "", "42.7731", "18.94446", "Europe/Podgorica"),("3194926", "Mojkovac", "", "ME", "499", "", "11", "", "", "42.96044", "19.5833", "Europe/Podgorica"),("3197538", "Kotor", "", "ME", "499", "", "10", "", "", "42.42067", "18.76825", "Europe/Podgorica"),("3197896", "Kolašin", "", "ME", "499", "", "09", "", "", "42.82229", "19.51653", "Europe/Podgorica"),("3199071", "Berane", "", "ME", "499", "", "03", "", "", "42.8425", "19.87333", "Europe/Podgorica"),("3199394", "Herceg-Novi", "Херцег-Нови", "ME", "499", "", "08", "", "", "42.45306", "18.5375", "Europe/Podgorica"),("3201903", "Dobrota", "", "ME", "499", "", "00", "", "", "42.45417", "18.76833", "Europe/Podgorica"),("3202194", "Danilovgrad", "", "ME", "499", "", "07", "", "", "42.55384", "19.14608", "Europe/Podgorica"),("3202641", "Cetinje", "Цетине", "ME", "499", "", "06", "", "", "42.39063", "18.91417", "Europe/Podgorica"),("3203106", "Budva", "Будва", "ME", "499", "", "05", "", "", "42.28639", "18.84", "Europe/Podgorica"),("3204176", "Bijelo Polje", "Биело-Поле", "ME", "499", "", "04", "", "", "43.03834", "19.74758", "Europe/Podgorica"),("3204509", "Bar", "Бар", "ME", "499", "", "02", "", "", "42.09306", "19.10028", "Europe/Podgorica"),("3204816", "Andrijevica", "", "ME", "499", "", "01", "", "", "42.73389", "19.79194", "Europe/Podgorica"),("1053384", "Toamasina", "Туамасина", "MG", "450", "", "7670857", "", "", "-18.1492", "49.40234", "Indian/Antananarivo"),("1053507", "Vondrozo", "", "MG", "450", "", "7670908", "", "", "-22.81667", "47.28333", "Indian/Antananarivo"),("1053778", "Vohipaho", "", "MG", "450", "MG", "7670908", "", "", "-23.55", "47.5", "Indian/Antananarivo"),("1053900", "Vohimanitra", "", "MG", "450", "", "7670906", "", "", "-21.7", "47.7", "Indian/Antananarivo"),("1054035", "Vohibinany", "", "MG", "450", "", "7670857", "", "", "-17.35", "49.03333", "Indian/Antananarivo"),("1054192", "Vavatenina", "", "MG", "450", "", "7670848", "", "", "-17.46667", "49.2", "Indian/Antananarivo"),("1054329", "Vangaindrano", "", "MG", "450", "", "7670908", "", "", "-23.35", "47.6", "Indian/Antananarivo"),("1054463", "Tsiroanomandidy", "", "MG", "450", "", "7670853", "", "", "-18.76969", "46.04653", "Indian/Antananarivo"),("1054500", "Tsiombe", "", "MG", "450", "", "7670911", "", "", "-25.3", "45.48333", "Indian/Antananarivo"),("1055059", "Tsaratanana", "", "MG", "450", "", "7670850", "", "", "-16.79706", "47.65165", "Indian/Antananarivo"),("1055317", "Tranovaho", "", "MG", "450", "MG", "7670911", "", "", "-25.3", "44.96667", "Indian/Antananarivo"),("1055429", "Toliara", "Тулиара", "MG", "450", "", "7670913", "8299677", "", "-23.35", "43.66667", "Indian/Antananarivo"),("1055433", "Fort Dauphin", "", "MG", "450", "", "7670910", "", "", "-25.03249", "46.98329", "Indian/Antananarivo"),("1056151", "Soavinandriana", "", "MG", "450", "", "7670855", "", "", "-19.16667", "46.73333", "Indian/Antananarivo"),("1056381", "Soanindrariny", "", "MG", "450", "", "7670854", "", "", "-19.9", "47.23333", "Indian/Antananarivo"),("1056386", "Soanierana Ivongo", "", "MG", "450", "", "7670848", "", "", "-16.91667", "49.58333", "Indian/Antananarivo"),("1056531", "Sitampiky", "", "MG", "450", "MG", "7670849", "", "", "-16.66667", "46.1", "Indian/Antananarivo"),("1056899", "Sambava", "Самбава", "MG", "450", "", "7670846", "", "", "-14.26667", "50.16667", "Indian/Antananarivo"),("1056922", "Sambaina", "", "MG", "450", "", "7670856", "", "", "-18.9", "47.78333", "Indian/Antananarivo"),("1057095", "Sakaraha", "", "MG", "450", "", "7670913", "", "", "-22.9", "44.53333", "Indian/Antananarivo"),("1057277", "Sahavato", "", "MG", "450", "", "7670906", "", "", "-20.6", "48.33333", "Indian/Antananarivo"),("1057330", "Sahatavy", "", "MG", "450", "", "7670848", "", "", "-17.45", "49", "Indian/Antananarivo"),("1057681", "Sadjoavato", "", "MG", "450", "MG", "7670842", "", "", "-12.61667", "49.35", "Indian/Antananarivo"),("1057688", "Sadabe", "", "MG", "450", "", "7670856", "", "", "-18.63333", "47.7", "Indian/Antananarivo"),("1057922", "Ranohira", "", "MG", "450", "", "7670907", "", "", "-22.48333", "45.4", "Indian/Antananarivo"),("1058080", "Nosy Varika", "", "MG", "450", "", "7670906", "", "", "-20.58333", "48.53333", "Indian/Antananarivo"),("1058381", "Morondava", "", "MG", "450", "", "7670902", "", "", "-20.28869", "44.31782", "Indian/Antananarivo"),("1058532", "Moramanga", "", "MG", "450", "", "7670851", "", "", "-18.94948", "48.23007", "Indian/Antananarivo"),("1059011", "Miarinarivo", "", "MG", "450", "", "7670855", "", "", "-18.95873", "46.90553", "Indian/Antananarivo"),("1059051", "Miandrivazo", "", "MG", "450", "", "7670902", "", "", "-19.52905", "45.45559", "Indian/Antananarivo"),("1059059", "Miandrarivo", "", "MG", "450", "", "7670854", "", "", "-19.43333", "46.75", "Indian/Antananarivo"),("1059098", "Miadanandriana", "", "MG", "450", "", "7670856", "", "", "-19.03333", "47.78333", "Indian/Antananarivo"),("1059136", "Merikanjaka", "", "MG", "450", "", "7670856", "", "", "-19.13333", "47.85", "Indian/Antananarivo"),("1059507", "Marovoay", "", "MG", "450", "", "7670849", "", "", "-16.11064", "46.64383", "Indian/Antananarivo"),("1060007", "Marolambo", "", "MG", "450", "", "7670857", "", "", "-20.05", "48.11667", "Indian/Antananarivo"),("1060283", "Maroantsetra", "Маруанцентре", "MG", "450", "", "7670848", "", "", "-15.43527", "49.73794", "Indian/Antananarivo"),("1060527", "Mantasoa", "", "MG", "450", "", "7670856", "", "", "-19.01667", "47.83333", "Indian/Antananarivo"),("1060673", "Manjakandriana", "", "MG", "450", "", "7670856", "", "", "-18.91667", "47.8", "Indian/Antananarivo"),("1061216", "Manato", "", "MG", "450", "", "7670908", "", "", "-22.4", "47.48333", "Indian/Antananarivo"),("1061335", "Mananjary", "", "MG", "450", "", "7670906", "", "", "-21.23034", "48.34173", "Indian/Antananarivo"),("1061412", "Mananara", "", "MG", "450", "", "7670848", "", "", "-16.16864", "49.76622", "Indian/Antananarivo"),("1061605", "Manakara", "Манакара", "MG", "450", "", "7670906", "", "", "-22.14862", "48.01055", "Indian/Antananarivo"),("1061912", "Maintirano", "", "MG", "450", "", "7670852", "", "", "-18.06354", "44.02951", "Indian/Antananarivo"),("1062146", "Mahavelona", "", "MG", "450", "MG", "7670857", "", "", "-17.68475", "49.50869", "Indian/Antananarivo"),("1062553", "Mahanoro", "", "MG", "450", "", "7670857", "", "", "-19.9", "48.8", "Indian/Antananarivo"),("1062663", "Mahajanga", "Махадзанга", "MG", "450", "", "7670849", "", "", "-15.71667", "46.31667", "Indian/Antananarivo"),("1062818", "Mahabe", "", "MG", "450", "MG", "7670852", "", "", "-17.08333", "45.33333", "Indian/Antananarivo"),("1062842", "Maevatanana", "", "MG", "450", "", "7670850", "", "", "-16.95", "46.83333", "Indian/Antananarivo"),("1063368", "Kopoky", "", "MG", "450", "", "7670911", "", "", "-25.2", "45.2", "Indian/Antananarivo"),("1064234", "Ikongo", "", "MG", "450", "", "7670906", "", "", "-21.88333", "47.43333", "Indian/Antananarivo"),("1064258", "Ikalamavony", "", "MG", "450", "", "7670905", "", "", "-21.15", "46.58333", "Indian/Antananarivo"),("1064275", "Ihosy", "", "MG", "450", "", "7670907", "", "", "-22.40293", "46.12576", "Indian/Antananarivo"),("1064334", "Ifatsy", "", "MG", "450", "MG", "7670906", "", "", "-22.4", "47.75", "Indian/Antananarivo"),("1064366", "Ifanadiana", "", "MG", "450", "", "7670906", "", "", "-21.3", "47.63333", "Indian/Antananarivo"),("1064890", "Fianarantsoa", "Фианаранцуа", "MG", "450", "", "7670905", "", "", "-21.45267", "47.08569", "Indian/Antananarivo"),("1064978", "Fenoarivo Be", "", "MG", "450", "", "7670853", "", "", "-18.43333", "46.56667", "Indian/Antananarivo"),("1064980", "Fenoarivo Atsinanana", "", "MG", "450", "", "7670848", "", "", "-17.38095", "49.40826", "Indian/Antananarivo"),("1065140", "Faratsiho", "", "MG", "450", "", "7670854", "", "", "-19.4", "46.95", "Indian/Antananarivo"),("1065158", "Farafangana", "", "MG", "450", "", "7670908", "8299290", "", "-22.82223", "47.82615", "Indian/Antananarivo"),("1065222", "Fandriana", "", "MG", "450", "", "7670904", "", "", "-20.23333", "47.38333", "Indian/Antananarivo"),("1065230", "Fandrandava", "", "MG", "450", "MG", "7670905", "", "", "-21.51667", "47.25", "Indian/Antananarivo"),("1066310", "Betioky", "", "MG", "450", "", "7670913", "", "", "-23.72065", "44.38069", "Indian/Antananarivo"),("1066317", "Beteza", "", "MG", "450", "", "7670911", "", "", "-24.45", "45.11667", "Indian/Antananarivo"),("1066514", "Betafo", "", "MG", "450", "", "7670854", "", "", "-19.83333", "46.85", "Indian/Antananarivo"),("1066831", "Beroroha", "", "MG", "450", "", "7670913", "", "", "-21.66667", "45.16667", "Indian/Antananarivo"),("1067487", "Bemaitso", "", "MG", "450", "", "7670851", "", "", "-17.06667", "48.5", "Indian/Antananarivo"),("1067531", "Belo sur Tsiribihina", "", "MG", "450", "", "7670902", "", "", "-19.69787", "44.54587", "Indian/Antananarivo"),("1067565", "Beloha", "", "MG", "450", "", "7670911", "", "", "-25.16667", "45.05", "Indian/Antananarivo"),("1068130", "Behompy", "", "MG", "450", "", "7670913", "", "", "-23.25", "43.85", "Indian/Antananarivo"),("1068670", "Bealanana", "", "MG", "450", "", "7670847", "", "", "-14.54329", "48.74981", "Indian/Antananarivo"),("1068865", "Arivonimamo", "", "MG", "450", "", "7670855", "", "", "-19.01667", "47.18333", "Indian/Antananarivo"),("1068955", "Antsohimbondrona", "", "MG", "450", "MG", "7670842", "", "", "-13.08333", "48.85", "Indian/Antananarivo"),("1068971", "Antsohihy", "", "MG", "450", "", "7670847", "", "", "-14.87959", "47.98751", "Indian/Antananarivo"),("1069129", "Antsiranana", "Анцеранана", "MG", "450", "", "7670842", "", "", "-12.31732", "49.29188", "Indian/Antananarivo"),("1069164", "Antsirabe Afovoany", "", "MG", "450", "MG", "7670847", "", "", "-15.95", "48.96667", "Indian/Antananarivo"),("1069166", "Antsirabe", "Анцирабе", "MG", "450", "", "7670854", "", "", "-19.86586", "47.03333", "Indian/Antananarivo"),("1070661", "Antanifotsy", "", "MG", "450", "", "7670854", "", "", "-19.65", "47.31667", "Indian/Antananarivo"),("1070940", "Antananarivo", "Антананариву", "MG", "450", "", "7670856", "", "", "-18.91368", "47.53613", "Indian/Antananarivo"),("1071296", "Antalaha", "Анталахи", "MG", "450", "", "7670846", "", "", "-14.90033", "50.27876", "Indian/Antananarivo"),("1071299", "Antakotako", "", "MG", "450", "", "7670848", "", "", "-15.31667", "49.8", "Indian/Antananarivo"),("1072711", "Ankazondandy", "", "MG", "450", "", "7670856", "", "", "-18.7", "47.78333", "Indian/Antananarivo"),("1072849", "Ankazobe", "", "MG", "450", "", "7670856", "", "", "-18.31667", "47.11667", "Indian/Antananarivo"),("1072879", "Ankazoabo", "", "MG", "450", "", "7670913", "", "", "-22.28333", "44.51667", "Indian/Antananarivo"),("1073482", "Anjozorobe", "", "MG", "450", "", "7670856", "", "", "-18.4", "47.86667", "Indian/Antananarivo"),("1073665", "Anjepy", "", "MG", "450", "", "7670856", "", "", "-18.85", "47.71667", "Indian/Antananarivo"),("1076105", "Hell-Ville", "", "MG", "450", "", "7670842", "", "", "-13.39718", "48.26663", "Indian/Antananarivo"),("1076194", "Andilamena", "", "MG", "450", "", "7670851", "8335145", "", "-17.01009", "48.57313", "Indian/Antananarivo"),("1076227", "Andovoranto", "", "MG", "450", "", "7670857", "", "", "-18.95443", "49.1094", "Indian/Antananarivo"),("1076454", "Andapa", "", "MG", "450", "", "7670846", "7910099", "", "-14.65", "49.65", "Indian/Antananarivo"),("1078171", "Ampasimanolotra", "", "MG", "450", "", "7670857", "", "", "-18.81667", "49.06667", "Indian/Antananarivo"),("1078446", "Amparafaravola", "", "MG", "450", "", "7670851", "7670894", "", "-17.5876", "48.22391", "Indian/Antananarivo"),("1078553", "Ampanihy", "", "MG", "450", "", "7670913", "", "", "-24.6937", "44.74581", "Indian/Antananarivo"),("1078966", "Ampahana", "", "MG", "450", "MG", "7670846", "", "", "-14.75", "50.21667", "Indian/Antananarivo"),("1079048", "Ambovombe", "", "MG", "450", "", "7670911", "", "", "-25.17838", "46.08722", "Indian/Antananarivo"),("1079088", "Ambositra", "", "MG", "450", "", "7670904", "", "", "-20.53034", "47.24344", "Indian/Antananarivo"),("1079681", "Ambohitseheno", "", "MG", "450", "", "7670856", "", "", "-18.78333", "47.8", "Indian/Antananarivo"),("1079777", "Ambohitrolomahitsy", "", "MG", "450", "", "7670856", "", "", "-18.7", "47.68333", "Indian/Antananarivo"),("1079846", "Ambohitrandriamanitra", "", "MG", "450", "MG", "7670856", "", "", "-19.08333", "47.78333", "Indian/Antananarivo"),("1080809", "Ambodivoara", "", "MG", "450", "", "7670846", "", "", "-14.33333", "49.98333", "Indian/Antananarivo"),("1081530", "Ambodifotatra", "", "MG", "450", "", "7670848", "", "", "-16.98333", "49.85", "Indian/Antananarivo"),("1081790", "Amboasary", "", "MG", "450", "", "7670910", "", "", "-25.03333", "46.38333", "Indian/Antananarivo"),("1081863", "Amboanjo", "", "MG", "450", "", "7670906", "", "", "-22", "47.85", "Indian/Antananarivo"),("1082243", "Ambilobe", "", "MG", "450", "", "7670842", "11427437", "", "-13.2", "49.05", "Indian/Antananarivo"),("1082639", "Ambatondrazaka", "", "MG", "450", "", "7670851", "", "", "-17.83333", "48.41667", "Indian/Antananarivo"),("1082992", "Ambatolampy", "", "MG", "450", "", "7670854", "", "", "-19.38333", "47.41667", "Indian/Antananarivo"),("1083239", "Ambatofinandrahana", "", "MG", "450", "", "7670904", "8335147", "", "-20.55284", "46.80365", "Indian/Antananarivo"),("1083257", "Ambato Boeny", "", "MG", "450", "", "7670849", "", "", "-16.46667", "46.71667", "Indian/Antananarivo"),("1083676", "Ambarakaraka", "", "MG", "450", "", "7670842", "", "", "-13.5", "48.86667", "Indian/Antananarivo"),("1083724", "Ambanja", "", "MG", "450", "", "7670842", "", "", "-13.669", "48.453", "Indian/Antananarivo"),("1083968", "Ambalavao", "", "MG", "450", "", "7670905", "", "", "-21.83333", "46.93333", "Indian/Antananarivo"),("1084740", "Alarobia", "", "MG", "450", "", "7670856", "", "", "-18.96667", "47.73333", "Indian/Antananarivo"),("2448442", "Yorosso", "Йоросо", "ML", "466", "", "06", "", "", "12.35811", "-4.77688", "Africa/Bamako"),("2449067", "Timbuktu", "Тимбукту", "ML", "466", "", "08", "", "", "16.77348", "-3.00742", "Africa/Bamako"),("2449938", "Ténenkou", "", "ML", "466", "", "04", "", "", "14.45722", "-4.9169", "Africa/Bamako"),("2451185", "Sikasso", "Сикасо", "ML", "466", "", "06", "", "", "11.31755", "-5.66654", "Africa/Bamako"),("2451478", "Ségou", "Сеги", "ML", "466", "", "05", "", "", "13.4317", "-6.2157", "Africa/Bamako"),("2451778", "San", "", "ML", "466", "", "05", "", "", "13.30335", "-4.89562", "Africa/Bamako"),("2451935", "Sagalo", "", "ML", "466", "ML", "03", "", "", "12.2", "-10.7", "Africa/Bamako"),("2452510", "Ntossoni", "", "ML", "466", "", "06", "7670554", "", "12.5304", "-5.77003", "Africa/Bamako"),("2452830", "Niafunké", "", "ML", "466", "", "08", "", "", "15.9322", "-3.9906", "Africa/Bamako"),("2453348", "Mopti", "Мопти", "ML", "466", "", "04", "", "", "14.4843", "-4.18296", "Africa/Bamako"),("2453514", "Ménaka", "", "ML", "466", "", "09", "", "", "15.9182", "2.4022", "Africa/Bamako"),("2453662", "Markala", "", "ML", "466", "", "05", "", "", "13.7021", "-6.0659", "Africa/Bamako"),("2454268", "Koutiala", "Кутиала", "ML", "466", "", "06", "", "", "12.39173", "-5.46421", "Africa/Bamako"),("2454530", "Koulikoro", "Куликоро", "ML", "466", "", "07", "", "", "12.86273", "-7.55985", "Africa/Bamako"),("2454934", "Kolondiéba", "", "ML", "466", "", "06", "", "", "11.08943", "-6.8929", "Africa/Bamako"),("2454955", "Kolokani", "Колокани", "ML", "466", "", "07", "", "", "13.5728", "-8.0339", "Africa/Bamako"),("2455055", "Kokofata", "", "ML", "466", "", "00", "", "", "12.88333", "-9.95", "Africa/Bamako"),("2455216", "Kita", "", "ML", "466", "", "03", "", "", "13.0349", "-9.4895", "Africa/Bamako"),("2455290", "Kidal", "", "ML", "466", "", "10", "", "", "18.44111", "1.40778", "Africa/Bamako"),("2455456", "Kinmparana", "", "ML", "466", "", "05", "", "", "12.84217", "-4.9245", "Africa/Bamako"),("2455465", "Ké-Macina", "", "ML", "466", "", "05", "", "", "13.9641", "-5.35791", "Africa/Bamako"),("2455518", "Kayes", "Каес", "ML", "466", "", "03", "", "", "14.44693", "-11.44448", "Africa/Bamako"),("2455558", "Kati", "Кати", "ML", "466", "", "07", "", "", "12.74409", "-8.07257", "Africa/Bamako"),("2455735", "Kangaba", "Кангаба", "ML", "466", "", "07", "", "", "11.93333", "-8.41667", "Africa/Bamako"),("2456917", "Goundam", "", "ML", "466", "", "08", "", "", "16.41453", "-3.67075", "Africa/Bamako"),("2457163", "Gao", "Гао", "ML", "466", "", "09", "", "", "16.27167", "-0.04472", "Africa/Bamako"),("2458334", "Douentza", "", "ML", "466", "", "04", "", "", "15.00155", "-2.94978", "Africa/Bamako"),("2458589", "Djénné", "", "ML", "466", "", "04", "", "", "13.90608", "-4.55332", "Africa/Bamako"),("2458624", "Diré", "", "ML", "466", "", "00", "", "", "12.28333", "-10.96667", "Africa/Bamako"),("2459775", "Bougouni", "", "ML", "466", "", "06", "", "", "11.41769", "-7.48323", "Africa/Bamako"),("2460489", "Bandiagara", "", "ML", "466", "", "04", "", "", "14.35005", "-3.61038", "Africa/Bamako"),("2460546", "Banamba", "", "ML", "466", "", "07", "", "", "13.54773", "-7.44808", "Africa/Bamako"),("2460596", "Bamako", "Бамако", "ML", "466", "", "01", "", "", "12.65", "-8", "Africa/Bamako"),("2460755", "Bafoulabé", "", "ML", "466", "", "03", "", "", "13.8065", "-10.8321", "Africa/Bamako"),("2596483", "Inékar", "", "ML", "466", "", "09", "", "", "15.95944", "3.14111", "Africa/Bamako"),("1285173", "Yenangyaung", "", "MM", "104", "", "15", "MMR009D001", "MMR009002", "20.46504", "94.8712", "Asia/Rangoon"),("1285871", "Nyaungdon", "", "MM", "104", "", "03", "MMR017D005", "MMR017021", "17.04459", "95.63957", "Asia/Rangoon"),("1285899", "Yamethin", "", "MM", "104", "", "08", "MMR010D006", "MMR010023", "20.43189", "96.13875", "Asia/Rangoon"),("1289828", "Wakema", "", "MM", "104", "", "03", "MMR017D003", "MMR017017", "16.60333", "95.18278", "Asia/Rangoon"),("1290374", "Twante", "", "MM", "104", "", "17", "MMR013D003", "MMR013027", "16.71047", "95.92866", "Asia/Rangoon"),("1290596", "Taungoo", "Таунгу", "MM", "104", "", "16", "MMR007D002", "MMR007009", "18.94291", "96.43408", "Asia/Rangoon"),("1291193", "Thongwa", "", "MM", "104", "", "17", "MMR013D003", "MMR013025", "16.75998", "96.52498", "Asia/Rangoon"),("1292037", "Thayetmyo", "", "MM", "104", "", "15", "MMR009D003", "MMR009012", "19.32076", "95.18272", "Asia/Rangoon"),("1292288", "Thaton", "", "MM", "104", "", "13", "MMR011D002", "MMR011007", "16.91867", "97.37001", "Asia/Rangoon"),("1292313", "Tharyarwady", "", "MM", "104", "", "16", "MMR008D002", "MMR008007", "17.65399", "95.78813", "Asia/Rangoon"),("1292579", "Thanatpin", "", "MM", "104", "", "16", "MMR007D001", "MMR007002", "17.29136", "96.57523", "Asia/Rangoon"),("1292580", "Thanatpin", "", "MM", "104", "", "16", "MMR007D001", "MMR007001", "17.21194", "96.30333", "Asia/Rangoon"),("1293625", "Dawei", "", "MM", "104", "", "12", "MMR006D001", "MMR006001", "14.0823", "98.19151", "Asia/Rangoon"),("1293960", "Taunggyi", "", "MM", "104", "", "11", "MMR014D001", "MMR014001", "20.78919", "97.03776", "Asia/Rangoon"),("1294041", "Taungdwingyi", "", "MM", "104", "", "15", "MMR009D001", "MMR009004", "20.0065", "95.54531", "Asia/Rangoon"),("1295301", "Tachilek", "", "MM", "104", "", "11", "MMR016D003", "MMR016009", "20.4475", "99.88083", "Asia/Rangoon"),("1295395", "Syriam", "", "MM", "104", "", "17", "MMR013D003", "MMR013023", "16.76887", "96.24503", "Asia/Rangoon"),("1295765", "Sittwe", "Ситуэ", "MM", "104", "", "01", "MMR012D001", "MMR012001", "20.14624", "92.89835", "Asia/Rangoon"),("1296736", "Shwebo", "", "MM", "104", "", "10", "MMR005D002", "MMR005004", "22.56925", "95.69818", "Asia/Rangoon"),("1298482", "Sagaing", "Сагайн", "MM", "104", "", "10", "MMR005D001", "MMR005001", "21.8787", "95.97965", "Asia/Rangoon"),("1298824", "Yangon", "Янгон", "MM", "104", "", "17", "MMR013D004", "MMR013044", "16.80528", "96.15611", "Asia/Rangoon"),("1298911", "Pyu", "", "MM", "104", "", "16", "MMR007D002", "MMR007012", "18.4813", "96.43742", "Asia/Rangoon"),("1298987", "Pyinmana", "Пьинмана", "MM", "104", "", "18", "MMR018D002", "MMR018006", "19.7381", "96.20742", "Asia/Rangoon"),("1299154", "Pyay", "Проме", "MM", "104", "", "16", "MMR008D001", "MMR008001", "18.82464", "95.22216", "Asia/Rangoon"),("1299237", "Pyapon", "Пьяпон", "MM", "104", "", "03", "MMR017D006", "MMR017023", "16.28543", "95.67882", "Asia/Rangoon"),("1300466", "Bago", "Пегу", "MM", "104", "", "16", "MMR007D001", "MMR007001", "17.33521", "96.48135", "Asia/Rangoon"),("1300969", "Paungde", "", "MM", "104", "", "16", "MMR008D001", "MMR008004", "18.49167", "95.50591", "Asia/Rangoon"),("1302439", "Pakokku", "Пакокку", "MM", "104", "", "15", "MMR009D004", "MMR009018", "21.33489", "95.08438", "Asia/Rangoon"),("1302849", "Hpa-an", "", "MM", "104", "", "05", "MMR003D001", "MMR003001", "16.88953", "97.63482", "Asia/Rangoon"),("1303406", "Nyaunglebin", "", "MM", "104", "", "16", "MMR007D001", "MMR007005", "17.95363", "96.72247", "Asia/Rangoon"),("1307741", "Myitkyina", "Мьичина", "MM", "104", "", "04", "MMR001D001", "MMR001001", "25.38327", "97.39637", "Asia/Rangoon"),("1307835", "Myingyan", "", "MM", "104", "", "08", "MMR010D004", "MMR010017", "21.46002", "95.3884", "Asia/Rangoon"),("1308052", "Myawadi", "", "MM", "104", "", "05", "MMR003D002", "MMR003005", "16.68911", "98.50893", "Asia/Rangoon"),("1308204", "Myanaung", "", "MM", "104", "", "03", "MMR017D002", "MMR017011", "18.28651", "95.32014", "Asia/Rangoon"),("1308415", "Mudon", "", "MM", "104", "", "13", "MMR011D001", "MMR011005", "16.25624", "97.7246", "Asia/Rangoon"),("1308464", "Mawlamyinegyunn", "", "MM", "104", "", "03", "MMR017D004", "MMR017018", "16.3772", "95.26488", "Asia/Rangoon"),("1308465", "Mawlamyine", "Моламьяйн", "MM", "104", "", "13", "MMR011D001", "MMR011001", "16.49051", "97.62825", "Asia/Rangoon"),("1308522", "Monywa", "", "MM", "104", "", "10", "MMR005D003", "MMR005012", "22.10856", "95.13583", "Asia/Rangoon"),("1308937", "Mogok", "Могок", "MM", "104", "", "08", "MMR010D002", "MMR010011", "22.91766", "96.50982", "Asia/Rangoon"),("1309289", "Minbu", "", "MM", "104", "", "15", "MMR009D002", "MMR009007", "20.18059", "94.87595", "Asia/Rangoon"),("1309611", "Myeik", "", "MM", "104", "", "12", "MMR006D002", "MMR006005", "12.43954", "98.60028", "Asia/Rangoon"),("1309793", "Meiktila", "", "MM", "104", "", "08", "MMR010D007", "MMR010028", "20.87776", "95.85844", "Asia/Rangoon"),("1309937", "Pyin Oo Lwin", "", "MM", "104", "", "08", "MMR010D002", "MMR010008", "22.03501", "96.45683", "Asia/Rangoon"),("1310120", "Mawlaik", "", "MM", "104", "", "10", "MMR005D007", "MMR005031", "23.64254", "94.40478", "Asia/Rangoon"),("1310362", "Maubin", "", "MM", "104", "", "03", "MMR017D005", "MMR017019", "16.73148", "95.65441", "Asia/Rangoon"),("1310460", "Martaban", "Мартабан", "MM", "104", "", "13", "MMR011D002", "MMR011008", "16.52834", "97.6157", "Asia/Rangoon"),("1311874", "Mandalay", "Мандалай", "MM", "104", "", "08", "MMR010D001", "MMR010002", "21.97473", "96.08359", "Asia/Rangoon"),("1312609", "Magway", "Магуэ", "MM", "104", "", "15", "MMR009D001", "MMR009001", "20.14956", "94.93246", "Asia/Rangoon"),("1313479", "Loikaw", "", "MM", "104", "", "06", "MMR002D001", "MMR002001", "19.67798", "97.20975", "Asia/Rangoon"),("1314042", "Letpandan", "", "MM", "104", "", "16", "MMR008D002", "MMR008008", "17.78664", "95.75076", "Asia/Rangoon"),("1314759", "Lashio", "Лаша", "MM", "104", "", "11", "MMR015D001", "MMR015001", "22.9359", "97.7498", "Asia/Rangoon"),("1316703", "Kyaukse", "", "MM", "104", "", "08", "MMR010D003", "MMR010013", "21.6056", "96.13508", "Asia/Rangoon"),("1317375", "Kyaikto", "", "MM", "104", "", "13", "MMR011D002", "MMR011009", "17.30858", "97.01124", "Asia/Rangoon"),("1317397", "Kyaiklat", "", "MM", "104", "", "03", "MMR017D006", "MMR017025", "16.44502", "95.72373", "Asia/Rangoon"),("1317402", "Kyaikkami", "", "MM", "104", "", "13", "MMR011D001", "MMR011004", "16.07686", "97.56388", "Asia/Rangoon"),("1319533", "Kayan", "", "MM", "104", "", "17", "MMR013D003", "MMR013026", "16.90802", "96.56037", "Asia/Rangoon"),("1320944", "Kanbe", "Канбе", "MM", "104", "", "17", "MMR013D003", "MMR013027", "16.70728", "96.00168", "Asia/Rangoon"),("1325211", "Hinthada", "", "MM", "104", "", "03", "MMR017D002", "MMR017008", "17.64944", "95.45705", "Asia/Rangoon"),("1325443", "Hakha", "", "MM", "104", "", "02", "MMR004D003", "MMR004002", "22.65", "93.61667", "Asia/Rangoon"),("1326105", "Falam", "", "MM", "104", "", "02", "MMR004D001", "MMR004001", "22.91335", "93.67779", "Asia/Rangoon"),("1327659", "Chauk", "Чаук", "MM", "104", "", "15", "MMR009D001", "MMR009003", "20.89921", "94.81784", "Asia/Rangoon"),("1328121", "Bogale", "", "MM", "104", "", "03", "MMR017D006", "MMR017024", "16.29415", "95.39742", "Asia/Rangoon"),("1328218", "Bhamo", "Бамо", "MM", "104", "", "04", "MMR001D003", "MMR001010", "24.25256", "97.23357", "Asia/Rangoon"),("1328421", "Pathein", "Патейн", "MM", "104", "", "03", "MMR017D001", "MMR017001", "16.77919", "94.73212", "Asia/Rangoon"),("1329239", "Myaydo", "", "MM", "104", "", "15", "MMR009D003", "MMR009016", "19.36838", "95.21512", "Asia/Rangoon"),("6611854", "Nay Pyi Taw", "", "MM", "104", "", "18", "MMR018D002", "MMR018002", "19.745", "96.12972", "Asia/Rangoon"),("1515007", "Uliastay", "", "MN", "496", "", "09", "", "", "47.74167", "96.84444", "Asia/Hovd"),("1515029", "Ulaangom", "Улангом", "MN", "496", "", "19", "", "", "49.98111", "92.06667", "Asia/Hovd"),("1515167", "Tosontsengel", "", "MN", "496", "", "09", "", "", "48.75667", "98.28389", "Asia/Hovd"),("1515436", "Ölgii", "Улгий", "MN", "496", "", "03", "", "", "48.96833", "89.9625", "Asia/Hovd"),("1516048", "Khovd", "Ховд", "MN", "496", "", "12", "6987767", "", "48.00556", "91.64194", "Asia/Hovd"),("1516393", "Altai", "", "MN", "496", "", "10", "", "", "46.37222", "96.25833", "Asia/Hovd"),("2028462", "Ulan Bator", "Улан-Батор", "MN", "496", "", "20", "", "", "47.90771", "106.88324", "Asia/Ulaanbaatar"),("2028606", "Tsetserleg", "", "MN", "496", "", "01", "", "", "47.475", "101.45417", "Asia/Ulaanbaatar"),("2029156", "Sühbaatar", "Сухэ-Батор", "MN", "496", "", "16", "", "", "50.23139", "106.20778", "Asia/Ulaanbaatar"),("2029656", "Undurkhaan", "", "MN", "496", "", "11", "", "", "47.31944", "110.65556", "Asia/Ulaanbaatar"),("2029945", "Murun-kuren", "Мурэн", "MN", "496", "", "13", "", "", "49.63417", "100.1625", "Asia/Ulaanbaatar"),("2030065", "Mandalgovi", "", "MN", "496", "", "08", "", "", "45.7625", "106.27083", "Asia/Ulaanbaatar"),("2030474", "Hovd", "Ховд", "MN", "496", "", "15", "", "", "44.67024", "102.17491", "Asia/Ulaanbaatar"),("2030927", "Harhorin", "", "MN", "496", "MN", "15", "", "", "47.19753", "102.82379", "Asia/Ulaanbaatar"),("2031405", "Erdenet", "Эрдэнэт", "MN", "496", "", "25", "", "", "49.03333", "104.08333", "Asia/Ulaanbaatar"),("2031517", "Dzuunmod", "", "MN", "496", "", "18", "", "", "47.70694", "106.95278", "Asia/Ulaanbaatar"),("2031533", "Dzüünharaa", "Дзунхара", "MN", "496", "", "16", "", "", "48.85229", "106.45786", "Asia/Ulaanbaatar"),("2031964", "Darhan", "Дархан", "MN", "496", "", "23", "", "", "49.48667", "105.92278", "Asia/Ulaanbaatar"),("2032007", "Dalandzadgad", "", "MN", "496", "", "14", "", "", "43.57083", "104.425", "Asia/Ulaanbaatar"),("2032050", "Choyr", "", "MN", "496", "", "24", "", "", "46.36111", "108.36111", "Asia/Ulaanbaatar"),("2032054", "Choibalsan", "", "MN", "496", "", "06", "", "", "48.07257", "114.53264", "Asia/Choibalsan"),("2032081", "Saynshand", "Сайншанд", "MN", "496", "", "07", "", "", "44.88239", "110.11631", "Asia/Ulaanbaatar"),("2032201", "Bulgan", "Булган", "MN", "496", "", "21", "6618895", "", "48.8125", "103.53472", "Asia/Ulaanbaatar"),("2032532", "Bayanhongor", "Баянхонгор", "MN", "496", "", "02", "", "", "46.71667", "100.11667", "Asia/Ulaanbaatar"),("2032533", "Bayanhongor", "", "MN", "496", "", "02", "", "", "46.19444", "100.71806", "Asia/Ulaanbaatar"),("2032614", "Baruun-Urt", "", "MN", "496", "", "17", "", "", "46.68056", "113.27917", "Asia/Choibalsan"),("2032814", "Arvayheer", "", "MN", "496", "", "15", "", "", "46.26389", "102.775", "Asia/Ulaanbaatar"),("7648817", "Зуунмод", "", "MN", "496", "", "18", "", "", "47.70693", "106.95276", "Asia/Ulaanbaatar"),("7648891", "Kharkhorin", "", "MN", "496", "", "15", "", "", "47.19245", "102.81349", "Asia/Ulaanbaatar"),("2375558", "Zouerate", "", "MR", "478", "", "11", "", "", "22.73542", "-12.47134", "Africa/Nouakchott"),("2376189", "Tékane", "", "MR", "478", "MR", "06", "", "", "16.57806", "-15.45972", "Africa/Nouakchott"),("2376193", "Tidjikja", "", "MR", "478", "", "09", "", "", "18.55644", "-11.42715", "Africa/Nouakchott"),("2376719", "Sélibaby", "", "MR", "478", "", "10", "", "", "15.15846", "-12.1843", "Africa/Nouakchott"),("2376898", "Rosso", "", "MR", "478", "", "06", "", "", "16.51378", "-15.80503", "Africa/Nouakchott"),("2377450", "Nouakchott", "Нуакшот", "MR", "478", "", "NKC", "", "", "18.08581", "-15.9785", "Africa/Nouakchott"),("2377457", "Nouadhibou", "Нуадибу", "MR", "478", "", "08", "", "", "20.94188", "-17.03842", "Africa/Nouakchott"),("2377539", "Néma", "", "MR", "478", "", "01", "", "", "16.61702", "-7.25649", "Africa/Nouakchott"),("2378538", "Kiffa", "Киффа", "MR", "478", "", "03", "", "", "16.62073", "-11.40208", "Africa/Nouakchott"),("2378736", "Kaédi", "", "MR", "478", "", "04", "", "", "16.15027", "-13.5037", "Africa/Nouakchott"),("2381291", "Aioun", "", "MR", "478", "", "02", "", "", "16.6614", "-9.6149", "Africa/Nouakchott"),("2381334", "Atar", "", "MR", "478", "", "07", "", "", "20.5177", "-13.04857", "Africa/Nouakchott"),("2381659", "Aleg", "", "MR", "478", "", "05", "", "", "17.05314", "-13.91312", "Africa/Nouakchott"),("2381690", "Akjoujt", "", "MR", "478", "", "12", "", "", "19.74657", "-14.38531", "Africa/Nouakchott"),("11009418", "Tevragh Zeina", "", "MR", "478", "", "NKC", "", "", "18.09894", "-15.98848", "Africa/Nouakchott"),("933945", "Vacoas", "", "MU", "480", "MU", "17", "", "", "-20.29806", "57.47833", "Indian/Mauritius"),("933959", "Triolet", "Триолет", "MU", "480", "", "16", "", "", "-20.05472", "57.54528", "Indian/Mauritius"),("933974", "Terre Rouge", "", "MU", "480", "", "16", "", "", "-20.12611", "57.52444", "Indian/Mauritius"),("933982", "Tamarin", "", "MU", "480", "", "12", "", "", "-20.32556", "57.37056", "Indian/Mauritius"),("933988", "Surinam", "", "MU", "480", "", "20", "", "", "-20.50972", "57.50528", "Indian/Mauritius"),("933995", "Souillac", "", "MU", "480", "", "20", "", "", "-20.51667", "57.51667", "Indian/Mauritius"),("934013", "Sebastopol", "", "MU", "480", "", "13", "", "", "-20.2907", "57.68779", "Indian/Mauritius"),("934032", "Saint Pierre", "", "MU", "480", "", "15", "", "", "-20.2175", "57.52083", "Indian/Mauritius"),("934058", "Morcellemont Saint André", "", "MU", "480", "", "16", "", "", "-20.07306", "57.55806", "Indian/Mauritius"),("934072", "Rose Belle", "", "MU", "480", "", "14", "", "", "-20.40028", "57.59667", "Indian/Mauritius"),("934085", "Roches Noire", "", "MU", "480", "", "19", "", "", "-20.11111", "57.71222", "Indian/Mauritius"),("934091", "Rivière du Rempart", "", "MU", "480", "", "19", "", "", "-20.10306", "57.68472", "Indian/Mauritius"),("934095", "Rivière des Anguilles", "", "MU", "480", "", "20", "", "", "-20.48528", "57.55083", "Indian/Mauritius"),("934131", "Quatre Bornes", "", "MU", "480", "", "17", "", "", "-20.26381", "57.4791", "Indian/Mauritius"),("934133", "Quartier Militaire", "", "MU", "480", "", "15", "", "", "-20.2479", "57.59737", "Indian/Mauritius"),("934149", "Poste de Flacq", "", "MU", "480", "", "13", "", "", "-20.16306", "57.73056", "Indian/Mauritius"),("934154", "Port Louis", "Порт-Луи", "MU", "480", "", "18", "", "", "-20.16194", "57.49889", "Indian/Mauritius"),("934169", "Plaine Magnien", "", "MU", "480", "", "14", "", "", "-20.42967", "57.66968", "Indian/Mauritius"),("934170", "Plaine des Papayes", "", "MU", "480", "", "16", "", "", "-20.065", "57.5725", "Indian/Mauritius"),("934184", "Petit Raffray", "", "MU", "480", "", "19", "", "", "-20.01333", "57.61194", "Indian/Mauritius"),("934195", "Petite Rivière", "", "MU", "480", "", "12", "", "", "-20.19551", "57.44592", "Indian/Mauritius"),("934213", "Pamplemousses", "", "MU", "480", "", "16", "", "", "-20.10389", "57.57028", "Indian/Mauritius"),("934219", "Pailles", "", "MU", "480", "", "15", "", "", "-20.19271", "57.48826", "Indian/Mauritius"),("934229", "Nouvelle France", "", "MU", "480", "", "14", "", "", "-20.37056", "57.56111", "Indian/Mauritius"),("934240", "New Grove", "", "MU", "480", "", "14", "", "", "-20.40861", "57.61361", "Indian/Mauritius"),("934255", "Piton", "", "MU", "480", "", "19", "", "", "-20.09028", "57.63028", "Indian/Mauritius"),("934262", "Montagne Blanche", "", "MU", "480", "", "00", "", "", "-20.28538", "57.65865", "Indian/Mauritius"),("934277", "Moka", "", "MU", "480", "", "15", "", "", "-20.21889", "57.49583", "Indian/Mauritius"),("934322", "Mahébourg", "", "MU", "480", "", "14", "", "", "-20.40806", "57.7", "Indian/Mauritius"),("934333", "Long Mountain", "", "MU", "480", "", "16", "", "", "-20.14306", "57.56222", "Indian/Mauritius"),("934390", "Lalmatie", "", "MU", "480", "", "13", "", "", "-20.18972", "57.66111", "Indian/Mauritius"),("934400", "Dagotière", "", "MU", "480", "", "15", "", "", "-20.24476", "57.56188", "Indian/Mauritius"),("934479", "Grand Gaube", "", "MU", "480", "", "19", "", "", "-20.00639", "57.66083", "Indian/Mauritius"),("934482", "Grand Baie", "", "MU", "480", "", "19", "", "", "-20.01816", "57.58015", "Indian/Mauritius"),("934485", "Grand Bois", "", "MU", "480", "", "20", "", "", "-20.41889", "57.54417", "Indian/Mauritius"),("934488", "Goodlands", "", "MU", "480", "", "19", "", "", "-20.035", "57.64306", "Indian/Mauritius"),("934513", "Fond du Sac", "", "MU", "480", "", "16", "", "", "-20.04306", "57.57861", "Indian/Mauritius"),("934570", "Curepipe", "Кюрпип", "MU", "480", "", "17", "", "", "-20.31472", "57.52028", "Indian/Mauritius"),("934614", "Chemin Grenier", "", "MU", "480", "", "20", "", "", "-20.48722", "57.46556", "Indian/Mauritius"),("934631", "Centre de Flacq", "", "MU", "480", "", "13", "", "", "-20.18972", "57.71444", "Indian/Mauritius"),("934660", "Camp Diable", "", "MU", "480", "", "20", "", "", "-20.46278", "57.57889", "Indian/Mauritius"),("934677", "Brisée Verdière", "", "MU", "480", "", "13", "", "", "-20.16389", "57.64667", "Indian/Mauritius"),("934693", "Bon Accueil", "", "MU", "480", "", "13", "", "", "-20.17083", "57.65639", "Indian/Mauritius"),("934750", "Bel Air Rivière Sèche", "", "MU", "480", "", "13", "", "", "-20.25777", "57.74976", "Indian/Mauritius"),("934753", "Beau Vallon", "", "MU", "480", "", "14", "", "", "-20.41889", "57.69528", "Indian/Mauritius"),("934765", "Beau Bassin", "", "MU", "480", "", "17", "", "", "-20.21944", "57.45833", "Indian/Mauritius"),("1106584", "Laventure", "", "MU", "480", "", "13", "", "", "-20.14583", "57.67667", "Indian/Mauritius"),("1106614", "Grande Pointe aux Piments", "", "MU", "480", "", "16", "", "", "-20.06278", "57.51306", "Indian/Mauritius"),("1106643", "Quatre Cocos", "", "MU", "480", "", "13", "", "", "-20.20778", "57.7625", "Indian/Mauritius"),("1106660", "Ecroignard", "", "MU", "480", "", "13", "", "", "-20.22611", "57.73611", "Indian/Mauritius"),("1106809", "Le Hochet", "", "MU", "480", "", "16", "", "", "-20.135", "57.52111", "Indian/Mauritius"),("1545752", "Port Mathurin", "", "MU", "480", "", "23", "", "", "-19.68333", "63.41667", "Indian/Mauritius"),("8199111", "Cargados Carajos", "", "MU", "480", "", "22", "", "", "-16.60329", "59.65851", "Indian/Mauritius"),("1282027", "Male", "Мале", "MV", "462", "", "38", "", "", "4.1748", "73.50888", "Indian/Maldives"),("1282256", "Hithadhoo", "", "MV", "462", "", "48", "", "", "-0.6", "73.08333", "Indian/Maldives"),("1337606", "Eydhafushi", "", "MV", "462", "", "31", "", "", "5.10327", "73.07078", "Indian/Maldives"),("1337607", "Kudahuvadhoo", "", "MV", "462", "", "32", "", "", "2.67075", "72.89437", "Indian/Maldives"),("1337609", "Viligili", "", "MV", "462", "", "34", "", "", "0.75906", "73.43296", "Indian/Maldives"),("1337610", "Thinadhoo", "", "MV", "462", "", "35", "", "", "0.5306", "72.99969", "Indian/Maldives"),("1337611", "Fuvahmulah", "", "MV", "462", "", "42", "", "", "-0.29878", "73.42403", "Indian/Maldives"),("1337612", "Dhidhdhoo", "", "MV", "462", "", "36", "", "", "6.88744", "73.11402", "Indian/Maldives"),("1337613", "Kulhudhuffushi", "", "MV", "462", "", "37", "", "", "6.62207", "73.06998", "Indian/Maldives"),("1337616", "Naifaru", "", "MV", "462", "", "39", "", "", "5.44438", "73.36571", "Indian/Maldives"),("1337617", "Muli", "", "MV", "462", "", "41", "", "", "2.91667", "73.56667", "Indian/Maldives"),("1337618", "Manadhoo", "", "MV", "462", "", "43", "", "", "5.76687", "73.4136", "Indian/Maldives"),("1337619", "Ugoofaaru", "", "MV", "462", "", "44", "", "", "5.66812", "73.03017", "Indian/Maldives"),("1337620", "Funadhoo", "", "MV", "462", "", "45", "", "", "6.15091", "73.29013", "Indian/Maldives"),("1337622", "Veymandoo", "", "MV", "462", "", "46", "", "", "2.18772", "73.09556", "Indian/Maldives"),("1337623", "Felidhoo", "", "MV", "462", "", "47", "", "", "3.47182", "73.54699", "Indian/Maldives"),("7874641", "Fonadhoo", "", "MV", "462", "", "05", "", "", "1.83243", "73.50257", "Indian/Maldives"),("235715", "Karonga", "Каронга", "MW", "454", "", "N", "08", "", "-9.93333", "33.93333", "Africa/Blantyre"),("235751", "Chitipa", "", "MW", "454", "", "N", "04", "", "-9.70237", "33.26969", "Africa/Blantyre"),("923295", "Zomba", "Зомба", "MW", "454", "", "S", "23", "", "-15.38596", "35.3188", "Africa/Blantyre"),("923652", "Thyolo", "", "MW", "454", "", "S", "05", "", "-16.06775", "35.14046", "Africa/Blantyre"),("924055", "Salima", "Салима", "MW", "454", "", "C", "22", "", "-13.7804", "34.4587", "Africa/Blantyre"),("924102", "Rumphi", "", "MW", "454", "", "N", "21", "", "-11.01863", "33.85746", "Africa/Blantyre"),("924491", "Ntchisi", "", "MW", "454", "", "C", "20", "", "-13.52775", "33.9149", "Africa/Blantyre"),("924492", "Ntcheu", "", "MW", "454", "", "C", "16", "", "-14.82027", "34.63586", "Africa/Blantyre"),("924572", "Nsanje", "", "MW", "454", "", "S", "19", "", "-16.91995", "35.26199", "Africa/Blantyre"),("924705", "Nkhotakota", "", "MW", "454", "", "C", "18", "", "-12.92744", "34.29614", "Africa/Blantyre"),("924732", "Nkhata Bay", "", "MW", "454", "", "N", "17", "", "-11.60659", "34.29073", "Africa/Blantyre"),("925475", "Mzuzu", "Мзузу", "MW", "454", "", "N", "15", "", "-11.46556", "34.02071", "Africa/Blantyre"),("925498", "Mzimba", "Мзимба", "MW", "454", "", "N", "15", "", "-11.9", "33.6", "Africa/Blantyre"),("925596", "Mwanza", "", "MW", "454", "", "S", "25", "", "-15.60262", "34.52479", "Africa/Blantyre"),("925789", "Mulanje", "", "MW", "454", "", "S", "29", "", "-16.03163", "35.5", "Africa/Blantyre"),("926087", "Mponela", "", "MW", "454", "", "C", "07", "", "-13.53194", "33.74008", "Africa/Blantyre"),("926308", "Monkey Bay", "", "MW", "454", "", "S", "12", "", "-14.08239", "34.91652", "Africa/Blantyre"),("926747", "Mchinji", "", "MW", "454", "", "C", "13", "", "-13.79841", "32.88019", "Africa/Blantyre"),("927246", "Mangochi", "Мангочи", "MW", "454", "", "S", "12", "", "-14.47815", "35.26448", "Africa/Blantyre"),("927792", "Luchenza", "", "MW", "454", "", "S", "05", "", "-16.00693", "35.30947", "Africa/Blantyre"),("927834", "Liwonde", "", "MW", "454", "", "S", "28", "", "-15.06665", "35.22543", "Africa/Blantyre"),("927856", "Livingstonia", "", "MW", "454", "", "N", "21", "", "-10.60602", "34.10628", "Africa/Blantyre"),("927967", "Lilongwe", "Лилонгве", "MW", "454", "", "C", "11", "", "-13.96692", "33.78725", "Africa/Blantyre"),("928534", "Kasungu", "Касунгу", "MW", "454", "", "C", "09", "", "-13.03333", "33.48333", "Africa/Blantyre"),("929977", "Dowa", "", "MW", "454", "", "C", "07", "", "-13.65399", "33.93754", "Africa/Blantyre"),("930025", "Dedza", "", "MW", "454", "", "C", "06", "", "-14.3779", "34.33322", "Africa/Blantyre"),("931070", "Chikwawa", "", "MW", "454", "", "S", "02", "", "-16.03352", "34.80091", "Africa/Blantyre"),("931755", "Blantyre", "Блантайр", "MW", "454", "", "S", "24", "", "-15.78499", "35.00854", "Africa/Blantyre"),("931865", "Balaka", "Балака", "MW", "454", "", "S", "26", "", "-14.97928", "34.95575", "Africa/Blantyre"),("3482886", "Cuauhtémoc", "", "MX", "484", "", "28", "003", "", "22.54408", "-98.15074", "America/Monterrey"),("3483063", "Xicoténcatl", "", "MX", "484", "", "28", "043", "", "22.99623", "-98.94218", "America/Monterrey"),("3483197", "San Fernando", "", "MX", "484", "", "28", "035", "", "24.84749", "-98.14828", "America/Monterrey"),("3483393", "Ciudad Díaz Ordaz", "", "MX", "484", "", "28", "015", "", "26.23186", "-98.5956", "America/Monterrey"),("3513966", "Zumpango", "Зумпанго-де-Окампо", "MX", "484", "", "15", "120", "", "19.7967", "-99.09946", "America/Mexico_City"),("3513967", "Zumpango del Río", "Зумпанго-дель-Рио", "MX", "484", "", "12", "075", "", "17.65437", "-99.52725", "America/Mexico_City"),("3514008", "Zongolica", "", "MX", "484", "", "30", "201", "", "18.66673", "-96.99707", "America/Mexico_City"),("3514013", "Santa María Zolotepec", "", "MX", "484", "", "15", "115", "", "19.41728", "-99.49327", "America/Mexico_City"),("3514021", "Zitlala", "", "MX", "484", "", "12", "074", "", "17.69049", "-99.18642", "America/Mexico_City"),("3514027", "Zimatlán de Álvarez", "", "MX", "484", "", "20", "570", "", "16.86939", "-96.78435", "America/Mexico_City"),("3514031", "Zimapan", "", "MX", "484", "", "13", "084", "", "20.73814", "-99.3818", "America/Mexico_City"),("3514043", "Zempoala", "", "MX", "484", "", "13", "083", "", "19.91587", "-98.666", "America/Mexico_City"),("3514044", "Villa Zempoala", "", "MX", "484", "", "30", "191", "", "19.44422", "-96.40773", "America/Mexico_City"),("3514049", "Zaragoza", "", "MX", "484", "", "30", "013", "", "21.27975", "-97.72055", "America/Mexico_City"),("3514051", "Zaragoza", "", "MX", "484", "", "21", "211", "", "19.77097", "-97.55506", "America/Mexico_City"),("3514052", "Zaragoza de Guadalupe", "", "MX", "484", "", "17", "", "", "19.1483", "-99.64405", "America/Mexico_City"),("3514060", "Zapotlán de Juárez", "", "MX", "484", "", "13", "082", "", "19.97709", "-98.8642", "America/Mexico_City"),("3514134", "Zacualtipán", "", "MX", "484", "", "13", "081", "", "20.65002", "-98.65628", "America/Mexico_City"),("3514148", "Zacatlán", "Сакатлан", "MX", "484", "", "21", "208", "", "19.9355", "-97.96125", "America/Mexico_City"),("3514162", "Zacatepec", "", "MX", "484", "", "21", "108", "", "19.26631", "-97.5328", "America/Mexico_City"),("3514163", "Zacatepec", "", "MX", "484", "", "17", "031", "", "18.65409", "-99.18981", "America/Mexico_City"),("3514179", "Zacapoaxtla", "", "MX", "484", "", "21", "207", "", "19.87271", "-97.58899", "America/Mexico_City"),("3514189", "Villa de Zaachila", "", "MX", "484", "", "20", "565", "", "16.95098", "-96.74938", "America/Mexico_City"),("3514272", "Yehualtepec", "", "MX", "484", "", "21", "205", "", "18.79504", "-97.66248", "America/Mexico_City"),("3514278", "Yecapixtla", "", "MX", "484", "", "17", "030", "", "18.88333", "-98.865", "America/Mexico_City"),("3514321", "Yautepec", "", "MX", "484", "", "17", "029", "", "18.88188", "-99.06715", "America/Mexico_City"),("3514329", "Yanga", "", "MX", "484", "", "30", "196", "", "18.83321", "-96.79823", "America/Mexico_City"),("3514349", "Yajalón", "", "MX", "484", "", "05", "109", "", "17.17276", "-92.33315", "America/Mexico_City"),("3514398", "Xoxocotla", "", "MX", "484", "", "17", "017", "", "18.68415", "-99.24577", "America/Mexico_City"),("3514409", "Xonacatlán", "", "MX", "484", "", "15", "115", "", "19.40513", "-99.52807", "America/Mexico_City"),("3514437", "Xochitepec", "", "MX", "484", "", "17", "028", "", "18.7808", "-99.23049", "America/Mexico_City"),("3514450", "Xochimilco", "", "MX", "484", "", "09", "013", "", "19.25785", "-99.10513", "America/Mexico_City"),("3514454", "Xochihuehuetlán", "", "MX", "484", "", "12", "070", "", "17.90619", "-98.48818", "America/Mexico_City"),("3514502", "Xilitla", "", "MX", "484", "", "24", "054", "", "21.38681", "-98.99009", "America/Mexico_City"),("3514510", "Xicotepec de Juárez", "", "MX", "484", "", "21", "197", "", "20.27605", "-97.96111", "America/Mexico_City"),("3514518", "Xico", "", "MX", "484", "", "30", "092", "", "19.42178", "-97.00819", "America/Mexico_City"),("3514519", "San Miguel Xico Viejo", "", "MX", "484", "", "15", "122", "", "19.27022", "-98.93588", "America/Mexico_City"),("3514583", "Xaltianguis", "", "MX", "484", "", "12", "001", "", "17.09834", "-99.71557", "America/Mexico_City"),("3514589", "Xaltepec", "", "MX", "484", "", "21", "110", "", "18.87584", "-97.61203", "America/Mexico_City"),("3514597", "Santa Ana Xalmimilulco", "", "MX", "484", "", "21", "074", "", "19.21287", "-98.38207", "America/Mexico_City"),("3514633", "Vista Hermosa", "", "MX", "484", "", "15", "104", "", "19.51667", "-99.21667", "America/Mexico_City"),("3514663", "Álvaro Obregón", "", "MX", "484", "", "09", "010", "", "19.35867", "-99.20329", "America/Mexico_City"),("3514670", "Villahermosa", "Вильяэрмоса", "MX", "484", "", "27", "004", "", "17.98689", "-92.93028", "America/Mexico_City"),("3514674", "Gustavo A. Madero", "", "MX", "484", "", "09", "005", "", "19.49016", "-99.10978", "America/Mexico_City"),("3514675", "Villa Guerrero", "", "MX", "484", "", "15", "113", "", "18.96211", "-99.64061", "America/Mexico_City"),("3514678", "El Triunfo", "", "MX", "484", "", "27", "001", "", "17.92241", "-91.16946", "America/Mexico_City"),("3514682", "Villa Cuauhtemoc", "", "MX", "484", "", "30", "133", "", "22.18439", "-97.83472", "America/Mexico_City"),("3514683", "Villa Cuauhtémoc Otzolotepec", "", "MX", "484", "", "15", "067", "", "19.41676", "-99.55872", "America/Mexico_City"),("3514684", "Villa Corzo", "", "MX", "484", "", "05", "107", "", "16.1851", "-93.26881", "America/Mexico_City"),("3514685", "Villa Comaltitlán", "", "MX", "484", "", "05", "071", "", "15.21397", "-92.57659", "America/Mexico_City"),("3514686", "Tesechoacan", "", "MX", "484", "", "30", "169", "", "18.13749", "-95.65835", "America/Mexico_City"),("3514783", "Veracruz", "Веракрус", "MX", "484", "", "30", "193", "", "19.18095", "-96.1429", "America/Mexico_City"),("3514785", "Venustiano Carranza", "", "MX", "484", "", "05", "106", "", "16.33815", "-92.563", "America/Mexico_City"),("3514843", "Vega de Alatorre", "", "MX", "484", "", "30", "192", "", "20.02823", "-96.64751", "America/Mexico_City"),("3514868", "Valle Hermoso", "", "MX", "484", "", "28", "040", "", "25.67207", "-97.81313", "America/Monterrey"),("3514876", "Valladolid", "Вальядолид", "MX", "484", "", "31", "102", "", "20.68812", "-88.19936", "America/Merida"),("3514906", "Úrsulo Galván", "", "MX", "484", "", "30", "191", "", "19.40531", "-96.3609", "America/Mexico_City"),("3514916", "Unión Hidalgo", "", "MX", "484", "", "20", "557", "", "16.4723", "-94.82952", "America/Mexico_City"),("3514929", "Uman", "Умань", "MX", "484", "", "31", "101", "", "20.88213", "-89.74649", "America/Merida"),("3514961", "Tzucacab", "", "MX", "484", "", "31", "098", "", "20.07237", "-89.05022", "America/Merida"),("3514998", "Tuzamapan", "", "MX", "484", "", "30", "038", "", "19.40253", "-96.8636", "America/Mexico_City"),("3515001", "Tuxtla", "Тустла-Гутьеррес", "MX", "484", "", "05", "101", "", "16.75973", "-93.11308", "America/Mexico_City"),("3515002", "Tuxtla Chico", "", "MX", "484", "", "05", "102", "", "14.93945", "-92.1673", "America/Mexico_City"),("3515011", "Túxpam de Rodríguez Cano", "", "MX", "484", "", "30", "189", "", "20.95777", "-97.40805", "America/Mexico_City"),("3515040", "Tulum", "", "MX", "484", "", "23", "009", "", "20.21173", "-87.46325", "America/Cancun"),("3515042", "Tultitlán", "Тультитлан", "MX", "484", "", "15", "109", "", "19.64756", "-99.16796", "America/Mexico_City"),("3515044", "Tultepec", "", "MX", "484", "", "15", "108", "", "19.685", "-99.12806", "America/Mexico_City"),("3515056", "Tulcingo de Valle", "", "MX", "484", "", "21", "191", "", "18.0437", "-98.44074", "America/Mexico_City"),("3515062", "Tulancingo", "", "MX", "484", "", "13", "077", "", "20.08355", "-98.36288", "America/Mexico_City"),("3515064", "Tula de Allende", "Тула-де-Альенде", "MX", "484", "", "13", "076", "", "20.05161", "-99.34397", "America/Mexico_City"),("3515068", "Tula", "", "MX", "484", "", "28", "039", "", "22.99645", "-99.71171", "America/Monterrey"),("3515086", "Trinidad Zaachila", "", "MX", "484", "", "20", "555", "", "16.92135", "-96.76384", "America/Mexico_City"),("3515195", "Totolapan", "", "MX", "484", "", "17", "027", "", "18.98487", "-98.92073", "America/Mexico_City"),("3515205", "San Miguel Totocuitlapilco", "", "MX", "484", "", "17", "", "", "19.23107", "-99.59116", "America/Mexico_City"),("3515302", "Toluca", "Толука", "MX", "484", "", "15", "106", "", "19.28786", "-99.65324", "America/Mexico_City"),("3515321", "Tolcayuca", "", "MX", "484", "", "13", "075", "", "19.95814", "-98.91941", "America/Mexico_City"),("3515330", "Tochtepec", "", "MX", "484", "", "21", "189", "", "18.83928", "-97.82282", "America/Mexico_City"),("3515333", "Tocatlán", "", "MX", "484", "", "29", "035", "", "19.38865", "-98.0274", "America/Mexico_City"),("3515343", "Tlayacapan", "", "MX", "484", "", "17", "026", "", "18.95556", "-98.98111", "America/Mexico_City"),("3515349", "Tlaxco", "", "MX", "484", "", "29", "034", "", "19.61442", "-98.11997", "America/Mexico_City"),("3515351", "Tlaxcoapan", "", "MX", "484", "", "13", "074", "", "20.09163", "-99.22042", "America/Mexico_City"),("3515354", "Tlaxco", "", "MX", "484", "", "21", "187", "", "20.42345", "-98.02917", "America/Mexico_City"),("3515358", "San Bernardino Tlaxcalancingo", "", "MX", "484", "", "21", "119", "", "19.02867", "-98.27698", "America/Mexico_City"),("3515363", "Tlatlauquitepec", "", "MX", "484", "", "21", "186", "", "19.84765", "-97.49718", "America/Mexico_City"),("3515369", "Tlatenchi", "", "MX", "484", "", "17", "012", "", "18.59639", "-99.18639", "America/Mexico_City"),("3515373", "Tlaquiltenango", "", "MX", "484", "", "17", "025", "", "18.63429", "-99.1632", "America/Mexico_City"),("3515384", "Tlapa de Comonfort", "Тлапа-де-Комонфорт", "MX", "484", "", "12", "066", "", "17.54528", "-98.57599", "America/Mexico_City"),("3515386", "Tlapacoyan", "", "MX", "484", "", "30", "183", "", "19.96268", "-97.21141", "America/Mexico_City"),("3515399", "Tlanalapa", "", "MX", "484", "", "13", "072", "", "19.81868", "-98.60396", "America/Mexico_City"),("3515401", "Tlanalapan", "", "MX", "484", "", "21", "093", "", "19.25084", "-97.27604", "America/Mexico_City"),("3515410", "Tlamacazapa", "", "MX", "484", "", "12", "055", "", "18.49649", "-99.50037", "America/Mexico_City"),("3515415", "Tlaltizapán", "", "MX", "484", "", "17", "024", "", "18.6863", "-99.11868", "America/Mexico_City"),("3515420", "Tlaltenango", "", "MX", "484", "", "21", "181", "", "19.17165", "-98.34072", "America/Mexico_City"),("3515428", "Tlalpan", "", "MX", "484", "", "09", "012", "", "19.29707", "-99.16787", "America/Mexico_City"),("3515431", "Tlalnepantla", "Тлалнепантла", "MX", "484", "", "15", "104", "", "19.54005", "-99.19538", "America/Mexico_City"),("3515438", "Tlalmanalco de Velázquez", "", "MX", "484", "", "15", "103", "", "19.20807", "-98.80138", "America/Mexico_City"),("3515442", "Tlalixtac de Cabrera", "", "MX", "484", "", "20", "553", "", "17.07112", "-96.6471", "America/Mexico_City"),("3515459", "Tlahuelilpan", "", "MX", "484", "", "13", "070", "", "20.13076", "-99.23145", "America/Mexico_City"),("3515463", "Tlahuac", "", "MX", "484", "", "09", "011", "", "19.28348", "-99.00317", "America/Mexico_City"),("3515477", "Tlacotepec", "", "MX", "484", "", "12", "032", "", "17.78978", "-99.97961", "America/Mexico_City"),("3515479", "Tlacotalpan", "", "MX", "484", "", "30", "178", "", "18.61333", "-95.6589", "America/Mexico_City"),("3515484", "Tlacolula de Matamoros", "", "MX", "484", "", "20", "551", "", "16.95471", "-96.4759", "America/Mexico_City"),("3515496", "Tlachichuca", "", "MX", "484", "", "21", "179", "", "19.11485", "-97.41915", "America/Mexico_City"),("3515504", "Tizimín", "Тисимин", "MX", "484", "", "31", "096", "", "21.14268", "-88.15101", "America/Merida"),("3515505", "Tizayuca", "", "MX", "484", "", "13", "069", "", "19.83721", "-98.97607", "America/Mexico_City"),("3515510", "Tixtla de Guerrero", "Тихтла-де-Герреро", "MX", "484", "", "12", "061", "", "17.56732", "-99.39799", "America/Mexico_City"),("3515521", "Tixkokob", "", "MX", "484", "", "31", "093", "", "21.0022", "-89.39484", "America/Merida"),("3515570", "Tilzapotla", "", "MX", "484", "", "17", "017", "", "18.48916", "-99.27442", "America/Mexico_City"),("3515600", "Tila", "", "MX", "484", "", "05", "096", "", "17.30054", "-92.4273", "America/Mexico_City"),("3515603", "Tihuatlan", "", "MX", "484", "", "30", "175", "", "20.71449", "-97.53335", "America/Mexico_City"),("3515643", "Tierra Colorada", "", "MX", "484", "", "12", "039", "", "17.16571", "-99.52791", "America/Mexico_City"),("3515665", "Ticul", "", "MX", "484", "", "31", "089", "", "20.39833", "-89.53541", "America/Merida"),("3515679", "Santiago Tíanguistenco", "", "MX", "484", "", "15", "101", "", "19.18024", "-99.46644", "America/Mexico_City"),("3515690", "Tezontepec de Aldama", "", "MX", "484", "", "13", "067", "", "20.19073", "-99.27429", "America/Mexico_City"),("3515691", "Tezontepec", "", "MX", "484", "", "13", "066", "", "19.88063", "-98.81972", "America/Mexico_City"),("3515696", "Teziutlan", "", "MX", "484", "", "21", "174", "", "19.8173", "-97.35992", "America/Mexico_City"),("3515710", "Texistepec", "", "MX", "484", "", "30", "172", "", "17.89476", "-94.81711", "America/Mexico_City"),("3515715", "Texcoco", "", "MX", "484", "", "15", "099", "", "19.51194", "-98.88293", "America/Mexico_City"),("3515735", "San Gabriel Tetzoyocán", "", "MX", "484", "", "21", "205", "", "18.75727", "-97.70324", "America/Mexico_City"),("3515751", "Tetepango", "", "MX", "484", "", "13", "065", "", "20.10168", "-99.15108", "America/Mexico_City"),("3515763", "Tetela del Volcán", "", "MX", "484", "", "17", "022", "", "18.89306", "-98.72972", "America/Mexico_City"),("3515767", "Tetecala", "", "MX", "484", "", "17", "021", "", "18.73009", "-99.40021", "America/Mexico_City"),("3515794", "Tequixquiac", "", "MX", "484", "", "15", "096", "", "19.90944", "-99.14472", "America/Mexico_City"),("3515796", "Tequisquiapan", "", "MX", "484", "", "22", "017", "", "20.5225", "-99.89167", "America/Mexico_City"),("3515806", "San Juan Tepulco", "", "MX", "484", "", "21", "001", "", "19.11709", "-97.98847", "America/Mexico_City"),("3515807", "Cuautitlán Izcalli", "", "MX", "484", "", "15", "121", "", "19.64388", "-99.21598", "America/Mexico_City"),("3515811", "Tepoztlán", "", "MX", "484", "", "17", "020", "", "18.98622", "-99.10051", "America/Mexico_City"),("3515827", "Tepotzotlán", "", "MX", "484", "", "15", "095", "", "19.71981", "-99.2237", "America/Mexico_City"),("3515862", "Tepetlaoxtoc", "", "MX", "484", "", "15", "093", "", "19.57437", "-98.81835", "America/Mexico_City"),("3515870", "Tepetitla", "", "MX", "484", "", "29", "019", "", "19.26531", "-98.37645", "America/Mexico_City"),("3515877", "Tepeojuma", "", "MX", "484", "", "21", "166", "", "18.72468", "-98.44633", "America/Mexico_City"),("3515887", "Tepeji de Ocampo", "", "MX", "484", "", "13", "063", "", "19.9063", "-99.34297", "America/Mexico_City"),("3515900", "Tepecoacuilco de Trujano", "", "MX", "484", "", "12", "059", "", "18.2875", "-99.46423", "America/Mexico_City"),("3515902", "Tepeapulco", "", "MX", "484", "", "13", "061", "", "19.7884", "-98.55266", "America/Mexico_City"),("3515904", "Tepeaca", "", "MX", "484", "", "21", "164", "", "18.96688", "-97.8998", "America/Mexico_City"),("3515906", "Tepatlaxco de Hidalgo", "", "MX", "484", "", "21", "001", "", "19.06747", "-97.96595", "America/Mexico_City"),("3515909", "Tepatepec", "", "MX", "484", "", "13", "023", "", "20.24568", "-99.08981", "America/Mexico_City"),("3515921", "Tepalcingo", "", "MX", "484", "", "17", "019", "", "18.59582", "-98.84302", "America/Mexico_City"),("3515938", "Teopisca", "", "MX", "484", "", "05", "094", "", "16.54182", "-92.47405", "America/Mexico_City"),("3515942", "Teoloyucan", "", "MX", "484", "", "15", "091", "", "19.7458", "-99.17855", "America/Mexico_City"),("3515946", "Teocelo", "", "MX", "484", "", "30", "164", "", "19.3856", "-96.97371", "America/Mexico_City"),("3515956", "Tenosique de Pino Suárez", "", "MX", "484", "", "27", "017", "", "17.4729", "-91.4236", "America/Mexico_City"),("3515991", "Tenango del Aire", "", "MX", "484", "", "15", "089", "", "19.15774", "-98.85687", "America/Mexico_City"),("3515993", "Tenango de Arista", "", "MX", "484", "", "15", "090", "", "19.10446", "-99.5898", "America/Mexico_City"),("3516006", "Tenancingo", "", "MX", "484", "", "15", "088", "", "18.96136", "-99.5903", "America/Mexico_City"),("3516017", "Tenabo", "", "MX", "484", "", "04", "008", "", "20.03981", "-90.22573", "America/Merida"),("3516019", "Tempoal de Sánchez", "", "MX", "484", "", "30", "161", "", "21.51998", "-98.38829", "America/Mexico_City"),("3516022", "Temozon", "", "MX", "484", "", "31", "085", "", "20.80393", "-88.20155", "America/Merida"),("3516031", "Temoac", "", "MX", "484", "", "17", "033", "", "18.77222", "-98.7775", "America/Mexico_City"),("3516035", "Temixco", "", "MX", "484", "", "17", "018", "", "18.85254", "-99.22537", "America/Mexico_City"),("3516048", "Temax", "", "MX", "484", "", "31", "084", "", "21.15105", "-88.94039", "America/Merida"),("3516049", "Temascalcingo de José María Velazco", "", "MX", "484", "", "15", "085", "", "19.91635", "-100.00369", "America/Mexico_City"),("3516050", "Temascalapa", "", "MX", "484", "", "15", "084", "", "19.82766", "-98.90171", "America/Mexico_City"),("3516053", "Temapache", "", "MX", "484", "", "30", "160", "", "21.06611", "-97.64207", "America/Mexico_City"),("3516056", "Temamatla", "", "MX", "484", "", "15", "083", "", "19.20306", "-98.86921", "America/Mexico_City"),("3516060", "Teloloapan", "", "MX", "484", "", "12", "058", "", "18.3674", "-99.86776", "America/Mexico_City"),("3516072", "Tekit", "", "MX", "484", "", "31", "080", "", "20.53465", "-89.33315", "America/Merida"),("3516076", "Tecax", "", "MX", "484", "", "31", "079", "", "20.2052", "-89.28522", "America/Merida"),("3516098", "Tehuixtla", "", "MX", "484", "", "17", "012", "", "18.55944", "-99.27119", "America/Mexico_City"),("3516109", "Tehuacán", "Теуакан", "MX", "484", "", "21", "156", "", "18.46148", "-97.39282", "America/Mexico_City"),("3516127", "Tecozautla", "", "MX", "484", "", "13", "059", "", "20.53359", "-99.63449", "America/Mexico_City"),("3516149", "Villa Tecolutilla", "", "MX", "484", "", "27", "005", "", "18.28338", "-93.33398", "America/Mexico_City"),("3516168", "Tekoh", "", "MX", "484", "", "31", "076", "", "20.74361", "-89.47406", "America/Merida"),("3516188", "Tecamachalco", "", "MX", "484", "", "21", "154", "", "18.88352", "-97.73344", "America/Mexico_City"),("3516210", "Teapa", "", "MX", "484", "", "27", "016", "", "17.5497", "-92.95211", "America/Mexico_City"),("3516212", "Teabo", "", "MX", "484", "", "31", "075", "", "20.40059", "-89.28316", "America/Merida"),("3516225", "Taxco de Alarcón", "Таско-де-Аларкон", "MX", "484", "", "12", "055", "", "18.55462", "-99.60592", "America/Mexico_City"),("3516234", "Tatahuicapan", "", "MX", "484", "", "30", "209", "", "18.24621", "-94.76124", "America/Mexico_City"),("3516252", "Tapilula", "", "MX", "484", "", "05", "091", "", "17.2495", "-93.0167", "America/Mexico_City"),("3516266", "Tapachula", "Тапачуле", "MX", "484", "", "05", "089", "", "14.90385", "-92.25749", "America/Mexico_City"),("3516271", "Tantoyuca", "", "MX", "484", "", "30", "155", "", "21.35064", "-98.2257", "America/Mexico_City"),("3516281", "Tanquián de Escobedo", "", "MX", "484", "", "24", "042", "", "21.60587", "-98.66275", "America/Mexico_City"),("3516344", "Tamulte de las Sabanas", "", "MX", "484", "", "27", "004", "", "18.16168", "-92.78354", "America/Mexico_City"),("3516347", "Tamuin", "", "MX", "484", "", "24", "040", "", "22.00554", "-98.77972", "America/Mexico_City"),("3516355", "Tampico", "Тампико", "MX", "484", "", "28", "038", "", "22.27817", "-97.86772", "America/Monterrey"),("3516376", "Tamiahua", "", "MX", "484", "", "30", "151", "", "21.27881", "-97.4462", "America/Mexico_City"),("3516385", "Tamazunchale", "", "MX", "484", "", "24", "037", "", "21.25993", "-98.78935", "America/Mexico_City"),("3516439", "Tacotalpa", "", "MX", "484", "", "27", "015", "", "17.59638", "-92.82596", "America/Mexico_City"),("3516497", "Brisas Barra de Suchiate", "", "MX", "484", "", "05", "087", "", "14.53588", "-92.22414", "America/Merida"),("3516499", "Suchiapa", "", "MX", "484", "", "05", "086", "", "16.62555", "-93.10074", "America/Mexico_City"),("3516515", "Sotuta", "", "MX", "484", "", "31", "069", "", "20.59678", "-89.00815", "America/Merida"),("3516522", "Soto la Marina", "", "MX", "484", "", "28", "037", "", "23.76953", "-98.20442", "America/Monterrey"),("3516552", "Soltepec", "", "MX", "484", "", "21", "152", "", "19.12111", "-97.70861", "America/Mexico_City"),("3516563", "Soledad de Doblado", "", "MX", "484", "", "30", "148", "", "19.04637", "-96.42142", "America/Mexico_City"),("3516611", "Soconusco", "", "MX", "484", "", "30", "145", "", "17.96315", "-94.88097", "America/Mexico_City"),("3516651", "Simojovel de Allende", "", "MX", "484", "", "05", "039", "", "17.2", "-92.63333", "America/Mexico_City"),("3516683", "Seyé", "", "MX", "484", "", "31", "067", "", "20.83568", "-89.37174", "America/Merida"),("3516685", "Seybaplaya", "", "MX", "484", "", "04", "004", "", "19.63994", "-90.68706", "America/Merida"),("3516723", "Sayula de Alemán", "", "MX", "484", "", "30", "144", "", "17.88191", "-94.95986", "America/Mexico_City"),("3516764", "San Vicente Tancuayalab", "", "MX", "484", "", "30", "", "", "21.71886", "-98.58769", "America/Mexico_City"),("3516818", "Santo Tomás Chautla", "", "MX", "484", "", "21", "114", "", "18.96573", "-98.15288", "America/Mexico_City"),("3516837", "Santo Domingo Zanatepec", "", "MX", "484", "", "20", "525", "", "16.48307", "-94.34754", "America/Mexico_City"),("3516843", "Santo Domingo Tehuantepec", "Санто-Доминго-Теуантепек", "MX", "484", "", "20", "515", "", "16.32463", "-95.24104", "America/Mexico_City"),("3516881", "Santo Domingo de Guzmán", "", "MX", "484", "", "15", "042", "", "19.59306", "-99.77972", "America/Mexico_City"),("3516912", "Santiago Tuxtla", "", "MX", "484", "", "30", "143", "", "18.46576", "-95.3006", "America/Mexico_City"),("3516919", "Sección Primera Santiago Tetla", "", "MX", "484", "", "29", "031", "", "19.43276", "-98.10407", "America/Mexico_City"),("3516923", "Santiago Suchilquitongo", "", "MX", "484", "", "20", "483", "", "17.25316", "-96.87825", "America/Mexico_City"),("3516926", "Pinotepa", "", "MX", "484", "", "20", "482", "", "16.34014", "-98.05297", "America/Mexico_City"),("3516936", "Santiago Miahuatlán", "", "MX", "484", "", "21", "149", "", "18.54524", "-97.43747", "America/Mexico_City"),("3516945", "Santiago Juxtlahuaca", "", "MX", "484", "", "20", "469", "", "17.33462", "-98.01147", "America/Mexico_City"),("3516948", "Jamiltepec", "", "MX", "484", "", "20", "467", "", "16.28258", "-97.82446", "America/Mexico_City"),("3516956", "Santiago de la Peña", "", "MX", "484", "", "30", "189", "", "20.94512", "-97.40493", "America/Mexico_City"),("3516973", "Santiago Alseseca", "", "MX", "484", "", "21", "154", "", "18.84511", "-97.70716", "America/Mexico_City"),("3516974", "Santiago Acutzilapan", "", "MX", "484", "", "15", "056", "", "19.7864", "-99.76569", "America/Mexico_City"),("3516975", "Santiago Acatlán", "", "MX", "484", "", "21", "164", "", "18.99334", "-97.93375", "America/Mexico_City"),("3516982", "Santiago Tulantepec", "", "MX", "484", "", "13", "056", "", "20.03618", "-98.35563", "America/Mexico_City"),("3517029", "Santa Rosalía", "", "MX", "484", "", "27", "002", "", "18.08851", "-93.35806", "America/Mexico_City"),("3517095", "Santa Rita Tlahuapan", "", "MX", "484", "", "21", "180", "", "19.33211", "-98.57688", "America/Mexico_City"),("3517151", "Santander Jiménez", "", "MX", "484", "", "28", "018", "", "24.21682", "-98.48433", "America/Monterrey"),("3517190", "Santa María Xonacatepec", "", "MX", "484", "MX", "21", "114", "", "19.08944", "-98.10361", "America/Mexico_City"),("3517191", "Santa María Xadani", "", "MX", "484", "", "20", "266", "", "15.94825", "-96.07364", "America/Mexico_City"),("3517217", "Santa María Rayón", "", "MX", "484", "", "15", "072", "", "19.14808", "-99.57974", "America/Mexico_City"),("3517228", "Santa María Nativitas", "", "MX", "484", "", "15", "047", "", "19.58081", "-99.60919", "America/Mexico_City"),("3517231", "Moyotzingo", "", "MX", "484", "", "21", "132", "", "19.24811", "-98.40486", "America/Mexico_City"),("3517241", "Santa María la Alta", "", "MX", "484", "", "21", "177", "", "18.59965", "-97.65835", "America/Mexico_City"),("3517246", "Santa María Ixtiyucán", "", "MX", "484", "", "21", "104", "", "19.18688", "-97.81094", "America/Mexico_City"),("3517251", "Santa María Huatulco", "", "MX", "484", "", "20", "413", "", "15.83267", "-96.32063", "America/Mexico_City"),("3517254", "Santa María del Tule", "", "MX", "484", "", "20", "409", "", "17.04712", "-96.63573", "America/Mexico_City"),("3517256", "Santa María del Monte", "", "MX", "484", "", "15", "118", "", "19.28973", "-99.82355", "America/Mexico_City"),("3517265", "Coronango", "", "MX", "484", "", "21", "034", "", "19.1209", "-98.30594", "America/Mexico_City"),("3517270", "Santa María Chimalhuacán", "", "MX", "484", "MX", "15", "031", "", "19.42155", "-98.95038", "America/Mexico_City"),("3517281", "Ayoquezco de Aldama", "", "MX", "484", "", "20", "398", "", "16.6837", "-96.84287", "America/Mexico_City"),("3517285", "Heroica Ciudad de Tlaxiaco", "", "MX", "484", "", "20", "397", "", "17.26916", "-97.68053", "America/Mexico_City"),("3517293", "Santa María Ajoloapan", "", "MX", "484", "", "15", "036", "", "19.97694", "-99.04472", "America/Mexico_City"),("3517449", "Santa Gertrudis", "", "MX", "484", "", "15", "095", "", "19.73333", "-99.36667", "America/Mexico_City"),("3517482", "Guillermo Zúñiga", "", "MX", "484", "", "28", "016", "", "24.01548", "-99.20074", "America/Monterrey"),("3517517", "Santa Cruz Xoxocotlán", "", "MX", "484", "", "20", "385", "", "17.02958", "-96.73518", "America/Mexico_City"),("3517524", "Tecámac", "", "MX", "484", "", "15", "081", "", "19.71288", "-98.96895", "America/Mexico_City"),("3517543", "Santa Cruz Cuauhtenco", "", "MX", "484", "", "15", "118", "", "19.24907", "-99.72939", "America/Mexico_City"),("3517659", "Pantelhó", "", "MX", "484", "", "05", "066", "", "17.00563", "-92.47165", "America/Mexico_City"),("3517669", "Santa Catarina Juquila", "", "MX", "484", "", "20", "364", "", "16.23819", "-97.29161", "America/Mexico_City"),("3517673", "Santa Catarina Ayotzingo", "", "MX", "484", "", "15", "025", "", "19.20948", "-98.92985", "America/Mexico_City"),("3517731", "Nextlalpan", "", "MX", "484", "", "15", "059", "", "19.74413", "-99.06997", "America/Mexico_City"),("3517733", "Santa Ana Jilotzingo", "", "MX", "484", "", "15", "046", "", "19.54151", "-99.39449", "America/Mexico_City"),("3517734", "Santa Anita Huiloac", "", "MX", "484", "", "29", "005", "", "19.38841", "-98.14362", "America/Mexico_City"),("3517735", "Santa Ana Hueytlalpan", "", "MX", "484", "", "13", "077", "", "20.17484", "-98.31209", "America/Mexico_City"),("3517742", "Chiautempan", "", "MX", "484", "", "29", "033", "", "19.30633", "-98.21773", "America/Mexico_City"),("3517763", "Santa Ana Ixtlahuatzingo (Santa Ana)", "", "MX", "484", "", "15", "088", "", "18.97056", "-99.62361", "America/Mexico_City"),("3517795", "Zinacatepec", "", "MX", "484", "", "21", "214", "", "18.33516", "-97.24621", "America/Mexico_City"),("3517797", "San Sebastián Villanueva", "", "MX", "484", "", "21", "004", "", "19.06085", "-97.71935", "America/Mexico_City"),("3517831", "San Salvador El Seco", "", "MX", "484", "", "21", "142", "", "19.13325", "-97.64167", "America/Mexico_City"),("3517832", "San Salvador Atenco", "", "MX", "484", "", "15", "011", "", "19.5517", "-98.91867", "America/Mexico_City"),("3517915", "San Rafael", "", "MX", "484", "", "30", "211", "", "20.18862", "-96.86737", "America/Mexico_City"),("3517937", "Villa de Etla", "", "MX", "484", "", "20", "338", "", "17.20615", "-96.7989", "America/Mexico_City"),("3517954", "San Pedro Tlanixco", "", "MX", "484", "", "30", "", "", "19.06259", "-99.65237", "America/Mexico_City"),("3517962", "San Pedro Tapanatepec", "", "MX", "484", "", "20", "327", "", "16.37107", "-94.19313", "America/Mexico_City"),("3517970", "San Pedro Pochutla", "", "MX", "484", "", "20", "324", "", "15.74587", "-96.46601", "America/Mexico_City"),("3517984", "San Pedro Los Baños", "", "MX", "484", "", "15", "042", "", "19.62537", "-99.8217", "America/Mexico_City"),("3518014", "San Pedro Buenavista", "", "MX", "484", "", "05", "107", "", "16.08333", "-93.11667", "America/Mexico_City"),("3518117", "San Pablo Villa de Mitla", "", "MX", "484", "", "20", "298", "", "16.92283", "-96.3599", "America/Mexico_City"),("3518128", "San Pablo Huixtepec", "", "MX", "484", "", "20", "295", "", "16.81948", "-96.78128", "America/Mexico_City"),("3518135", "San Pablo de las Salinas", "", "MX", "484", "", "15", "109", "", "19.6667", "-99.09527", "America/Mexico_City"),("3518138", "San Pablo Autopan", "", "MX", "484", "", "17", "", "", "19.35638", "-99.65724", "America/Mexico_City"),("3518139", "San Pablo Atlazalpan", "", "MX", "484", "", "15", "025", "", "19.21742", "-98.90763", "America/Mexico_City"),("3518140", "Apetatitlán Antonio Carbajal", "", "MX", "484", "", "29", "018", "", "19.33622", "-98.17912", "America/Mexico_City"),("3518181", "San Nicolás de los Ranchos", "", "MX", "484", "", "21", "138", "", "19.07139", "-98.48601", "America/Mexico_City"),("3518183", "San Nicolás Coatepec", "", "MX", "484", "", "17", "", "", "19.13735", "-99.42948", "America/Mexico_City"),("3518220", "San Miguel Zozutla", "", "MX", "484", "", "21", "205", "", "18.75501", "-97.65425", "America/Mexico_City"),("3518221", "San Miguel Zinacantepec", "", "MX", "484", "", "15", "118", "", "19.28428", "-99.73394", "America/Mexico_City"),("3518224", "San Miguel Xoxtla", "", "MX", "484", "", "21", "136", "", "19.16763", "-98.30758", "America/Mexico_City"),("3518230", "San Miguel Contla", "", "MX", "484", "MX", "29", "026", "", "19.36111", "-98.1325", "America/Mexico_City"),("3518253", "San Miguel Panixtlahuaca", "", "MX", "484", "", "20", "272", "", "16.24844", "-97.38427", "America/Mexico_City"),("3518277", "San Miguel Coatlinchán", "", "MX", "484", "", "15", "099", "", "19.44999", "-98.87274", "America/Mexico_City"),("3518280", "Chapultepec", "", "MX", "484", "", "15", "027", "", "19.20216", "-99.56176", "America/Mexico_City"),("3518281", "San Miguel Canoa", "", "MX", "484", "", "21", "114", "", "19.15194", "-98.10306", "America/Mexico_City"),("3518326", "San Miguel Tenochtitlán", "", "MX", "484", "", "15", "048", "", "19.76028", "-99.9225", "America/Mexico_City"),("3518352", "San Matias Tlalancaleca", "", "MX", "484", "", "21", "134", "", "19.32536", "-98.49863", "America/Mexico_City"),("3518361", "San Mateo Xoloc", "", "MX", "484", "", "15", "095", "", "19.70719", "-99.25097", "America/Mexico_City"),("3518363", "Tlaixpan", "", "MX", "484", "", "21", "154", "", "18.91217", "-97.73818", "America/Mexico_City"),("3518377", "San Mateo Mexicaltzingo", "", "MX", "484", "", "15", "055", "", "19.2113", "-99.58469", "America/Mexico_City"),("3518382", "San Mateo del Mar", "", "MX", "484", "", "20", "248", "", "16.21054", "-94.98218", "America/Mexico_City"),("3518387", "San Mateo Atenco", "", "MX", "484", "", "15", "076", "", "19.26757", "-99.53214", "America/Mexico_City"),("3518407", "San Martin Texmelucan de Labastida", "", "MX", "484", "", "21", "132", "", "19.28431", "-98.43885", "America/Mexico_City"),("3518414", "San Martín de las Pirámides", "", "MX", "484", "", "15", "075", "", "19.70582", "-98.83554", "America/Mexico_City"),("3518439", "San Marcos Tlacoyalco", "", "MX", "484", "", "21", "177", "", "18.67312", "-97.60324", "America/Mexico_City"),("3518451", "Vega de San Marcos", "", "MX", "484", "", "30", "211", "", "20.18539", "-96.94877", "America/Mexico_City"),("3518453", "San Marcos", "", "MX", "484", "", "13", "076", "", "20.06667", "-99.33333", "America/Mexico_City"),("3518461", "San Marcos", "", "MX", "484", "", "12", "053", "", "16.79772", "-99.38921", "America/Mexico_City"),("3518475", "Teolocholco", "", "MX", "484", "", "29", "028", "", "19.24333", "-98.19083", "America/Mexico_City"),("3518518", "San Lucas Ojitlán", "", "MX", "484", "", "20", "232", "", "18.06149", "-96.39823", "America/Mexico_City"),("3518538", "San Lorenzo Oyamel", "", "MX", "484", "", "17", "", "", "19.43355", "-99.57761", "America/Mexico_City"),("3518542", "San Lorenzo Chiautzingo", "", "MX", "484", "", "21", "048", "", "19.20432", "-98.46747", "America/Mexico_City"),("3518543", "Almecatla", "", "MX", "484", "", "21", "041", "", "19.14286", "-98.23597", "America/Mexico_City"),("3518602", "San Juan Xiutetelco", "", "MX", "484", "", "21", "199", "", "19.79563", "-97.32578", "America/Mexico_City"),("3518611", "Tianguismanalco", "", "MX", "484", "", "21", "175", "", "18.97624", "-98.44861", "America/Mexico_City"),("3518617", "San Juan Tepa", "", "MX", "484", "", "13", "023", "", "20.21579", "-99.06592", "America/Mexico_City"),("3518618", "Teotihuacán", "", "MX", "484", "", "15", "092", "", "19.68862", "-98.8611", "America/Mexico_City"),("3518692", "San Juan del Río", "", "MX", "484", "", "22", "016", "", "20.38886", "-99.99577", "America/Mexico_City"),("3518702", "San Juan de las Huertas", "", "MX", "484", "", "15", "118", "", "19.24755", "-99.75834", "America/Mexico_City"),("3518722", "Valle Nacional", "", "MX", "484", "", "20", "559", "", "17.77579", "-96.30174", "America/Mexico_City"),("3518723", "Tuxtepec", "", "MX", "484", "", "20", "184", "", "18.0883", "-96.12535", "America/Mexico_City"),("3518835", "Miahuatlán", "", "MX", "484", "", "21", "129", "", "18.29163", "-97.28789", "America/Mexico_City"),("3519207", "San Hipólito", "", "MX", "484", "", "21", "164", "", "18.94069", "-97.87322", "America/Mexico_City"),("3519227", "San Gaspar Tonatico", "", "MX", "484", "", "15", "107", "", "18.80671", "-99.66917", "America/Mexico_City"),("3519230", "San Gabriel Chilac", "", "MX", "484", "", "21", "124", "", "18.32598", "-97.34777", "America/Mexico_City"),("3519231", "Casa Blanca", "", "MX", "484", "", "20", "109", "", "18.14976", "-97.13729", "America/Mexico_City"),("3519243", "San Francisco Zacacalco", "", "MX", "484", "", "17", "", "", "19.92875", "-98.98279", "America/Mexico_City"),("3519249", "San Francisco Tlalcilalcalpan", "", "MX", "484", "", "15", "005", "", "19.29474", "-99.76771", "America/Mexico_City"),("3519255", "San Francisco Telixtlahuaca", "", "MX", "484", "", "20", "150", "", "17.29684", "-96.90529", "America/Mexico_City"),("3519290", "San Francisco Acuautla", "", "MX", "484", "", "15", "039", "", "19.34317", "-98.85557", "America/Mexico_City"),("3519396", "San Fernando", "", "MX", "484", "", "05", "079", "", "16.87153", "-93.20759", "America/Mexico_City"),("3519402", "San Felipe Usila", "", "MX", "484", "", "20", "136", "", "17.88639", "-96.52624", "America/Mexico_City"),("3519405", "Teotlaltzingo", "", "MX", "484", "", "21", "122", "", "19.23088", "-98.50077", "America/Mexico_City"),("3519409", "San Felipe Jalapa de Díaz", "", "MX", "484", "", "20", "134", "", "18.0716", "-96.53518", "America/Mexico_City"),("3519410", "Villa Mariano Matamoros", "", "MX", "484", "", "29", "015", "", "19.32661", "-98.37746", "America/Mexico_City"),("3519480", "San Dionisio Ocotepec", "", "MX", "484", "", "20", "131", "", "16.80457", "-96.39334", "America/Mexico_City"),("3519531", "Sanctorum", "", "MX", "484", "", "21", "041", "", "19.09917", "-98.25417", "America/Mexico_City"),("3519537", "San Cristóbal de las Casas", "", "MX", "484", "", "05", "078", "", "16.73176", "-92.64126", "America/Mexico_City"),("3519570", "San Ciro de Acosta", "", "MX", "484", "", "24", "027", "", "21.65072", "-99.81916", "America/Mexico_City"),("3519588", "San Carlos", "", "MX", "484", "", "27", "001", "", "17.55221", "-91.15408", "America/Mexico_City"),("3519601", "San Buenaventura", "", "MX", "484", "", "15", "106", "", "19.26595", "-99.67332", "America/Mexico_City"),("3519622", "Amaxac de Guerrero", "", "MX", "484", "", "29", "001", "", "19.34661", "-98.17057", "America/Mexico_City"),("3519632", "San Bartolo Teontepec", "", "MX", "484", "", "21", "161", "", "18.48924", "-97.52598", "America/Mexico_City"),("3519642", "San Bartolo del Llano", "", "MX", "484", "", "15", "047", "", "19.59069", "-99.74099", "America/Mexico_City"),("3519644", "San Bartolo Cuautlalpan", "", "MX", "484", "", "15", "120", "", "19.8151", "-99.01044", "America/Mexico_City"),("3519907", "San Andres Tuxtla", "", "MX", "484", "", "30", "141", "", "18.4487", "-95.21327", "America/Mexico_City"),("3519930", "San Andrés Calpan", "", "MX", "484", "", "21", "026", "", "19.10356", "-98.46188", "America/Mexico_City"),("3519972", "San Agustín Tlaxiaca", "", "MX", "484", "", "13", "052", "", "20.1151", "-98.8864", "America/Mexico_City"),("3520064", "Salina Cruz", "Салина-Крус", "MX", "484", "", "20", "079", "", "16.18405", "-95.20143", "America/Mexico_City"),("3520161", "Sabancuy", "", "MX", "484", "", "04", "003", "", "18.9727", "-91.17783", "America/Merida"),("3520235", "Ríoverde", "", "MX", "484", "", "24", "024", "", "21.93115", "-99.99488", "America/Mexico_City"),("3520260", "Río Frío de Juárez", "", "MX", "484", "", "15", "039", "", "19.35234", "-98.67049", "America/Mexico_City"),("3520271", "Río Bravo", "Рио-Браво", "MX", "484", "", "28", "033", "", "25.98729", "-98.09414", "America/Monterrey"),("3520274", "Río Blanco", "Рио-Бланко", "MX", "484", "", "30", "138", "", "18.83036", "-97.156", "America/Mexico_City"),("3520281", "Colonia Rincón Viejo", "", "MX", "484", "", "20", "057", "", "16.88678", "-95.04731", "America/Mexico_City"),("3520319", "Rinconada", "", "MX", "484", "", "30", "065", "", "19.35438", "-96.56581", "America/Mexico_City"),("3520339", "Reynosa", "Рейноса", "MX", "484", "", "28", "032", "", "26.08061", "-98.28835", "America/Matamoros"),("3520427", "Rayón", "", "MX", "484", "", "24", "023", "", "21.84329", "-99.64258", "America/Mexico_City"),("3520875", "Grajales", "", "MX", "484", "", "21", "117", "", "19.22796", "-97.80307", "America/Mexico_City"),("3520877", "Rafael Delgado", "", "MX", "484", "", "30", "135", "", "18.81014", "-97.07172", "America/Mexico_City"),("3520922", "Quechultenango", "", "MX", "484", "", "12", "051", "", "17.41425", "-99.24221", "America/Mexico_City"),("3520926", "Quecholac", "", "MX", "484", "", "21", "115", "", "18.95422", "-97.66041", "America/Mexico_City"),("3520935", "Putla Villa de Guerrero", "", "MX", "484", "", "20", "073", "", "17.0263", "-97.92854", "America/Mexico_City"),("3520989", "Puerto Madero", "", "MX", "484", "", "05", "089", "", "14.72076", "-92.42146", "America/Mexico_City"),("3520994", "Puerto Escondido", "Пуэрто-Эскондидо", "MX", "484", "", "20", "318", "", "15.87037", "-97.07726", "America/Mexico_City"),("3521051", "Puente de Ixtla", "", "MX", "484", "", "17", "017", "", "18.61472", "-99.31806", "America/Mexico_City"),("3521070", "Pueblo Nuevo Jolistahuacan", "", "MX", "484", "", "05", "072", "", "17.16027", "-92.89977", "America/Mexico_City"),("3521074", "Pueblo Nuevo", "", "MX", "484", "", "15", "112", "", "19.67595", "-99.61093", "America/Mexico_City"),("3521081", "Puebla", "", "MX", "484", "", "21", "114", "", "19.03793", "-98.20346", "America/Mexico_City"),("3521103", "Progreso de Alvaro Obregon", "", "MX", "484", "", "13", "050", "", "20.24929", "-99.18988", "America/Mexico_City"),("3521108", "Progreso", "Прогресо", "MX", "484", "", "31", "059", "", "21.28306", "-89.66123", "America/Merida"),("3521111", "Progreso Industrial", "", "MX", "484", "", "15", "060", "", "19.63679", "-99.35688", "America/Mexico_City"),("3521168", "Poza Rica de Hidalgo", "", "MX", "484", "", "30", "131", "", "20.53315", "-97.45946", "America/Mexico_City"),("3521283", "Pomuch", "", "MX", "484", "", "04", "005", "", "20.13727", "-90.17488", "America/Merida"),("3521305", "Polanco", "", "MX", "484", "", "09", "016", "", "19.41667", "-99.2", "America/Mexico_City"),("3521334", "Playa Vicente", "", "MX", "484", "", "30", "130", "", "17.83031", "-95.81361", "America/Mexico_City"),("3521342", "Playa del Carmen", "Плая-дель-Кармен", "MX", "484", "", "23", "008", "", "20.6274", "-87.07987", "America/Cancun"),("3521344", "Platón Sánchez", "", "MX", "484", "", "30", "129", "", "21.27182", "-98.37456", "America/Mexico_City"),("3521424", "Pinotepa de Don Luis", "", "MX", "484", "", "20", "070", "", "16.42716", "-97.97678", "America/Mexico_City"),("3521476", "Pijijiapan", "", "MX", "484", "", "05", "069", "", "15.68618", "-93.20938", "America/Mexico_City"),("3521482", "Piedras Negras", "", "MX", "484", "", "30", "181", "", "18.77026", "-96.17178", "America/Mexico_City"),("3521574", "Pichucalco", "", "MX", "484", "", "05", "068", "", "17.51", "-93.11591", "America/Mexico_City"),("3521596", "Peto", "", "MX", "484", "", "31", "058", "", "20.12776", "-88.92282", "America/Merida"),("3521607", "Petaquillas", "", "MX", "484", "", "12", "029", "", "17.48636", "-99.45633", "America/Mexico_City"),("3521610", "Petalcingo", "", "MX", "484", "", "05", "096", "", "17.22715", "-92.41511", "America/Mexico_City"),("3521628", "Perote", "", "MX", "484", "", "30", "128", "", "19.56233", "-97.24235", "America/Mexico_City"),("3521825", "Paso de Ovejas", "", "MX", "484", "", "30", "126", "", "19.2845", "-96.44037", "America/Mexico_City"),("3521833", "Paso del Macho", "", "MX", "484", "", "30", "125", "", "18.97191", "-96.72445", "America/Mexico_City"),("3521912", "Paraiso", "", "MX", "484", "", "27", "014", "", "18.40116", "-93.21406", "America/Mexico_City"),("3521922", "Papantla de Olarte", "", "MX", "484", "", "30", "124", "", "20.44655", "-97.32495", "America/Mexico_City"),("3521941", "Pánuco", "", "MX", "484", "", "30", "123", "", "22.05373", "-98.18498", "America/Mexico_City"),("3521951", "Panotla", "", "MX", "484", "", "29", "024", "", "19.31619", "-98.27013", "America/Mexico_City"),("3521972", "Panabá", "", "MX", "484", "", "31", "057", "", "21.29598", "-88.26982", "America/Merida"),("3522118", "Palmarito Tochapán", "", "MX", "484", "", "21", "115", "", "18.89891", "-97.63892", "America/Mexico_City"),("3522164", "Palenque", "Паленке", "MX", "484", "", "05", "065", "", "17.50953", "-91.98248", "America/Mexico_City"),("3522186", "Pajapan", "", "MX", "484", "", "30", "122", "", "18.26267", "-94.69172", "America/Mexico_City"),("3522210", "Pachuca de Soto", "Пачука-де-Сото", "MX", "484", "", "13", "048", "", "20.11697", "-98.73329", "America/Mexico_City"),("3522232", "Ozumba de Alzate", "", "MX", "484", "", "15", "068", "", "19.03689", "-98.79516", "America/Mexico_City"),("3522251", "Oxkutzkab", "", "MX", "484", "", "31", "056", "", "20.30734", "-89.41809", "America/Merida"),("3522265", "Otumba", "", "MX", "484", "", "15", "065", "", "19.69985", "-98.75638", "America/Mexico_City"),("3522279", "Oteapan", "", "MX", "484", "", "30", "120", "", "18.00173", "-94.66615", "America/Mexico_City"),("3522302", "San Felipe Orizatlán", "", "MX", "484", "", "13", "046", "", "21.17109", "-98.60744", "America/Mexico_City"),("3522307", "Orizaba", "Орисаба", "MX", "484", "", "30", "118", "", "18.85195", "-97.09957", "America/Mexico_City"),("3522317", "Oriental", "", "MX", "484", "", "21", "108", "", "19.37614", "-97.62051", "America/Mexico_City"),("3522343", "Ometepec", "", "MX", "484", "", "12", "046", "", "16.69008", "-98.40797", "America/Mexico_City"),("3522350", "Oluta", "", "MX", "484", "", "30", "116", "", "17.92972", "-94.89662", "America/Mexico_City"),("3522364", "Olinalá", "", "MX", "484", "", "12", "045", "", "17.77861", "-98.73944", "America/Mexico_City"),("3522444", "Ocozocoautla de Espinosa", "", "MX", "484", "", "05", "061", "", "16.76231", "-93.37476", "America/Mexico_City"),("3522445", "Ocoyoacac", "", "MX", "484", "", "15", "062", "", "19.27127", "-99.45787", "America/Mexico_City"),("3522454", "San Francisco Ocotlán", "", "MX", "484", "", "21", "034", "", "19.13411", "-98.28345", "America/Mexico_City"),("3522484", "Ocosingo", "", "MX", "484", "", "05", "059", "", "16.90639", "-92.09374", "America/Mexico_City"),("3522493", "Ocampo", "", "MX", "484", "", "28", "029", "", "22.84695", "-99.33866", "America/Monterrey"),("3522505", "Oaxtepec", "", "MX", "484", "", "17", "029", "", "18.91825", "-98.95644", "America/Mexico_City"),("3522507", "Oaxaca", "Оахака-де-Хуарес", "MX", "484", "", "20", "067", "", "17.06542", "-96.72365", "America/Mexico_City"),("3522514", "Nunkiní", "", "MX", "484", "", "04", "001", "", "20.40046", "-90.14803", "America/Merida"),("3522526", "Nuevo Progreso", "", "MX", "484", "", "28", "002", "", "23.17605", "-97.95", "America/Monterrey"),("3522531", "Nuevo Padilla", "", "MX", "484", "", "28", "030", "", "24.04784", "-98.90085", "America/Monterrey"),("3522551", "Nuevo Laredo", "Нуэво-Ларедо", "MX", "484", "", "28", "027", "", "27.47629", "-99.51639", "America/Matamoros"),("3522605", "Nueva Palestina", "", "MX", "484", "", "05", "008", "", "15.8061", "-92.75067", "America/Mexico_City"),("3522645", "Nopalucán", "", "MX", "484", "", "21", "104", "", "19.2184", "-97.82272", "America/Mexico_City"),("3522696", "Nogales", "", "MX", "484", "", "30", "115", "", "18.82776", "-97.16311", "America/Mexico_City"),("3522732", "Nicolás Romero", "", "MX", "484", "", "15", "060", "", "19.63658", "-99.30682", "America/Mexico_City"),("3522777", "Necaxa", "", "MX", "484", "", "21", "091", "", "20.21271", "-98.01188", "America/Mexico_City"),("3522781", "Nealtican", "", "MX", "484", "", "21", "102", "", "19.0499", "-98.4272", "America/Mexico_City"),("3522790", "Naucalpan de Juárez", "Наукальпан-де-Хуарес", "MX", "484", "", "15", "057", "", "19.47851", "-99.23963", "America/Mexico_City"),("3522804", "Naranjos", "", "MX", "484", "", "30", "013", "", "21.35087", "-97.68656", "America/Mexico_City"),("3522836", "Naolinco de Victoria", "", "MX", "484", "", "30", "112", "", "19.65474", "-96.8732", "America/Mexico_City"),("3522845", "Villa Nanchital", "", "MX", "484", "", "30", "206", "", "18.07117", "-94.40756", "America/Mexico_City"),("3522855", "Ciudad de Nanacamilpa", "", "MX", "484", "", "29", "021", "", "19.49241", "-98.53526", "America/Mexico_City"),("3522865", "Nacajuca", "", "MX", "484", "", "27", "013", "", "18.16971", "-93.01843", "America/Mexico_City"),("3522886", "Muna", "", "MX", "484", "", "31", "053", "", "20.48794", "-89.71387", "America/Merida"),("3522924", "Motul", "", "MX", "484", "", "31", "052", "", "21.09571", "-89.28332", "America/Merida"),("3522926", "Motozintla", "", "MX", "484", "", "05", "057", "", "15.36694", "-92.24605", "America/Mexico_City"),("3522973", "Moralillo", "", "MX", "484", "", "30", "123", "", "22.22552", "-97.91213", "America/Mexico_City"),("3523011", "Montemorelos", "", "MX", "484", "", "19", "038", "", "25.18909", "-99.82865", "America/Monterrey"),("3523034", "Montecillo", "", "MX", "484", "", "15", "099", "", "19.45711", "-98.90835", "America/Mexico_City"),("3523040", "Monte Blanco", "", "MX", "484", "", "30", "068", "", "18.96642", "-97.01684", "America/Mexico_City"),("3523061", "Santiago Momoxpan", "", "MX", "484", "", "21", "140", "", "19.07361", "-98.26694", "America/Mexico_City"),("3523127", "Mixquiahuala de Juarez", "", "MX", "484", "", "13", "041", "", "20.23031", "-99.21396", "America/Mexico_City"),("3523141", "Misantla", "", "MX", "484", "", "30", "109", "", "19.92992", "-96.85194", "America/Mexico_City"),("3523149", "Miramar", "", "MX", "484", "", "28", "038", "", "22.32085", "-97.8595", "America/Monterrey"),("3523180", "Mineral del Monte", "", "MX", "484", "", "13", "039", "", "20.1383", "-98.67364", "America/Mexico_City"),("3523183", "Minatitlán", "Минатитлан", "MX", "484", "", "30", "108", "", "18.00011", "-94.5569", "America/Mexico_City"),("3523202", "Milpa Alta", "", "MX", "484", "", "09", "009", "", "19.19251", "-99.02317", "America/Mexico_City"),("3523222", "Mier", "", "MX", "484", "", "28", "024", "", "26.42969", "-99.15212", "America/Monterrey"),("3523240", "Miahuatlán de Porfirio Díaz", "", "MX", "484", "", "20", "059", "", "16.33276", "-96.59562", "America/Mexico_City"),("3523247", "Miacatlán", "", "MX", "484", "", "17", "015", "", "18.76203", "-99.35944", "America/Mexico_City"),("3523303", "Metepec", "Метепек", "MX", "484", "", "15", "054", "", "19.25934", "-99.60175", "America/Mexico_City"),("3523349", "Mérida", "Мерида", "MX", "484", "", "31", "050", "", "20.97537", "-89.61696", "America/Merida"),("3523397", "Mecayapan", "", "MX", "484", "", "30", "104", "", "18.22001", "-94.83794", "America/Mexico_City"),("3523418", "Mazatán", "", "MX", "484", "", "05", "054", "", "14.86319", "-92.4503", "America/Mexico_City"),("3523436", "Maxcanú", "", "MX", "484", "", "31", "048", "", "20.58456", "-90.001", "America/Merida"),("3523450", "Matías Romero", "", "MX", "484", "", "20", "057", "", "16.87902", "-95.03939", "America/Mexico_City"),("3523466", "Heroica Matamoros", "Матаморос", "MX", "484", "", "28", "022", "", "25.87972", "-97.50417", "America/Matamoros"),("3523513", "Martínez de la Torre", "", "MX", "484", "", "30", "102", "", "20.07082", "-97.06078", "America/Mexico_City"),("3523590", "Mapastepec", "", "MX", "484", "", "05", "051", "", "15.43358", "-92.90039", "America/Mexico_City"),("3523608", "Ursulo Galván", "", "MX", "484", "", "28", "012", "", "22.72779", "-98.32191", "America/Monterrey"),("3523670", "Maltrata", "", "MX", "484", "", "30", "099", "", "18.81091", "-97.27538", "America/Mexico_City"),("3523683", "Malinaltepec", "", "MX", "484", "", "12", "041", "", "17.24501", "-98.67091", "America/Mexico_City"),("3523686", "Malinalco", "", "MX", "484", "", "15", "052", "", "18.94847", "-99.49619", "America/Mexico_City"),("3523756", "Magdalena Cuayucatepec", "", "MX", "484", "", "21", "156", "", "18.54972", "-97.48472", "America/Mexico_City"),("3523760", "Magdalena Contreras", "", "MX", "484", "", "09", "008", "", "19.33212", "-99.21118", "America/Mexico_City"),("3523791", "Macuspana", "", "MX", "484", "", "27", "012", "", "17.76052", "-92.59539", "America/Mexico_City"),("3523794", "Macultepec", "", "MX", "484", "", "27", "004", "", "18.15026", "-92.86092", "America/Mexico_City"),("3523828", "Luis Gil Pérez", "", "MX", "484", "", "27", "004", "", "17.87541", "-93.07124", "America/Mexico_City"),("3523900", "Reyes Acozac", "", "MX", "484", "", "17", "", "", "19.7755", "-98.98079", "America/Mexico_City"),("3523908", "Los Reyes Acaquilpan", "", "MX", "484", "", "15", "070", "", "19.36357", "-98.97707", "America/Mexico_City"),("3524348", "Linares", "Линарес", "MX", "484", "", "19", "033", "", "24.85798", "-99.56768", "America/Monterrey"),("3524374", "Libres", "", "MX", "484", "", "21", "094", "", "19.46574", "-97.68737", "America/Mexico_City"),("3524389", "Lerma de Villada", "", "MX", "484", "", "15", "051", "", "19.28881", "-99.51163", "America/Mexico_City"),("3524391", "Lerdo de Tejada", "", "MX", "484", "", "30", "097", "", "18.62936", "-95.51968", "America/Mexico_City"),("3524527", "La Trinitaria", "", "MX", "484", "", "05", "099", "", "16.11859", "-92.05201", "America/Mexico_City"),("3524580", "Las Vigas de Ramírez", "", "MX", "484", "", "30", "132", "", "19.63722", "-97.09821", "America/Mexico_City"),("3524744", "Las Margaritas", "", "MX", "484", "", "05", "052", "", "16.31265", "-91.98107", "America/Mexico_City"),("3524903", "Las Choapas", "", "MX", "484", "", "30", "061", "", "17.91177", "-94.09646", "America/Mexico_City"),("3524965", "Las Amilpas", "", "MX", "484", "", "20", "130", "", "16.36667", "-94.61667", "America/Mexico_City"),("3525067", "La Reforma", "", "MX", "484", "", "19", "033", "", "24.69822", "-99.54127", "America/Monterrey"),("3525570", "La Joya", "", "MX", "484", "", "17", "005", "", "18.66667", "-99.46667", "America/Mexico_City"),("3525596", "La Isla", "", "MX", "484", "", "30", "174", "", "18.6", "-96.15", "America/Mexico_City"),("3525956", "La Concepción de los Baños", "", "MX", "484", "", "15", "042", "", "19.68249", "-99.86104", "America/Mexico_City"),("3526056", "La Ceiba", "", "MX", "484", "", "30", "", "", "20.75287", "-97.9084", "America/Mexico_City"),("3526284", "Kinchil", "", "MX", "484", "", "31", "044", "", "20.91519", "-89.94825", "America/Merida"),("3526323", "Kanasín", "", "MX", "484", "", "31", "041", "", "20.93482", "-89.55871", "America/Merida"),("3526355", "Juchitepec", "", "MX", "484", "", "15", "050", "", "19.10059", "-98.8788", "America/Mexico_City"),("3526357", "Juchitán de Zaragoza", "Хучитан-де-Сарагоса", "MX", "484", "", "20", "043", "", "16.43603", "-95.01975", "America/Mexico_City"),("3526453", "Jonuta", "", "MX", "484", "", "27", "011", "", "18.08984", "-92.13807", "America/Mexico_City"),("3526458", "Jonacatepec de Leandro Valle", "", "MX", "484", "", "17", "013", "", "18.68308", "-98.80302", "America/Mexico_City"),("3526467", "Jojutla", "", "MX", "484", "", "17", "012", "", "18.61472", "-99.18028", "America/Mexico_City"),("3526473", "Jocotitlán", "", "MX", "484", "", "15", "048", "", "19.70991", "-99.78867", "America/Mexico_City"),("3526485", "Jiutepec", "", "MX", "484", "", "17", "011", "", "18.88139", "-99.17778", "America/Mexico_City"),("3526488", "Jiquipilas", "", "MX", "484", "", "05", "046", "", "16.66806", "-93.64667", "America/Mexico_City"),("3526499", "Jilotzingo", "", "MX", "484", "", "15", "036", "", "19.86889", "-99.06194", "America/Mexico_City"),("3526501", "Jilotepec de Molina Enríquez", "", "MX", "484", "", "15", "045", "", "19.95194", "-99.53278", "America/Mexico_City"),("3526536", "Jesús del Monte", "", "MX", "484", "", "15", "086", "", "19.12089", "-99.98786", "America/Mexico_City"),("3526591", "Jaltocan", "", "MX", "484", "", "13", "032", "", "21.13284", "-98.53898", "America/Mexico_City"),("3526599", "Jaltepec", "", "MX", "484", "", "17", "", "", "19.7296", "-98.63456", "America/Mexico_City"),("3526600", "Jaltenco", "", "MX", "484", "", "15", "044", "", "19.75399", "-99.09367", "America/Mexico_City"),("3526601", "Jalpan", "", "MX", "484", "", "22", "009", "", "21.21802", "-99.47152", "America/Mexico_City"),("3526603", "Jalpa de Méndez", "", "MX", "484", "", "27", "010", "", "18.17633", "-93.063", "America/Mexico_City"),("3526611", "Xalatlaco", "", "MX", "484", "", "15", "043", "", "19.18314", "-99.41844", "America/Mexico_City"),("3526613", "Jalapilla", "", "MX", "484", "", "30", "135", "", "18.82642", "-97.08865", "America/Mexico_City"),("3526617", "Xalapa de Enríquez", "", "MX", "484", "", "30", "087", "", "19.53124", "-96.91589", "America/Mexico_City"),("3526621", "Jalapa", "", "MX", "484", "", "20", "418", "", "16.5", "-95.46667", "America/Mexico_City"),("3526625", "Jalacingo", "", "MX", "484", "", "30", "086", "", "19.80333", "-97.3083", "America/Mexico_City"),("3526657", "Izúcar de Matamoros", "", "MX", "484", "", "21", "085", "", "18.60157", "-98.46152", "America/Mexico_City"),("3526662", "Izamal", "", "MX", "484", "", "31", "040", "", "20.93537", "-89.01802", "America/Merida"),("3526670", "Ixtlahuaca de Rayón", "", "MX", "484", "MX", "15", "042", "", "19.56889", "-99.76694", "America/Mexico_City"),("3526674", "San Jerónimo Ixtepec", "", "MX", "484", "", "20", "014", "", "16.57855", "-95.10223", "America/Mexico_City"),("3526681", "Ixtapan de la Sal", "", "MX", "484", "", "15", "040", "", "18.84369", "-99.67671", "America/Mexico_City"),("3526682", "Ixtapaluca", "", "MX", "484", "", "15", "039", "", "19.31556", "-98.88284", "America/Mexico_City"),("3526683", "Iztapalapa", "Истапалапа", "MX", "484", "", "09", "007", "", "19.35738", "-99.0671", "America/Mexico_City"),("3526696", "Ixtaczoquitlán", "", "MX", "484", "", "30", "085", "", "18.85364", "-97.06229", "America/Mexico_City"),("3526700", "Iztacalco", "", "MX", "484", "MX", "09", "006", "", "19.39528", "-99.09778", "America/Mexico_City"),("3526708", "Ixmiquilpan", "", "MX", "484", "", "13", "030", "", "20.47841", "-99.21697", "America/Mexico_City"),("3526715", "San Francisco Ixhuatan", "", "MX", "484", "", "20", "143", "", "16.35109", "-94.48402", "America/Mexico_City"),("3526756", "Isla Mujeres", "", "MX", "484", "", "23", "003", "", "21.23114", "-86.73105", "America/Cancun"),("3526798", "Iguala de la Independencia", "Игуала-де-ла-Индепенденсия", "MX", "484", "", "12", "035", "", "18.34536", "-99.5413", "America/Mexico_City"),("3526816", "Itzincab Palomeque", "", "MX", "484", "", "31", "101", "", "20.91644", "-89.69823", "America/Merida"),("3526838", "Hunucmá", "", "MX", "484", "", "31", "038", "", "21.01723", "-89.87551", "America/Merida"),("3526855", "Huixtla", "", "MX", "484", "", "05", "040", "", "15.1402", "-92.46587", "America/Mexico_City"),("3526864", "Ciudad de Huitzuco", "", "MX", "484", "", "12", "034", "", "18.30334", "-99.33376", "America/Mexico_City"),("3526908", "Huimanguillo", "", "MX", "484", "", "27", "008", "", "17.83366", "-93.38926", "America/Mexico_City"),("3526923", "Huichapan", "", "MX", "484", "", "13", "029", "", "20.37593", "-99.64869", "America/Mexico_City"),("3526934", "Hueyapan", "", "MX", "484", "", "17", "022", "", "18.8897", "-98.682", "America/Mexico_City"),("3526952", "Huejutla de Reyes", "Уэхутла-де-Рейес", "MX", "484", "", "13", "028", "", "21.14", "-98.41944", "America/Mexico_City"),("3526953", "Huejotzingo", "", "MX", "484", "", "21", "074", "", "19.15892", "-98.40824", "America/Mexico_City"),("3526957", "Huehuetoca", "", "MX", "484", "", "15", "035", "", "19.83567", "-99.20131", "America/Mexico_City"),("3526966", "Huehuetán", "", "MX", "484", "", "05", "037", "", "15.01981", "-92.38249", "America/Mexico_City"),("3526987", "Huautla de Jiménez", "", "MX", "484", "", "21", "", "", "18.1315", "-96.84088", "America/Mexico_City"),("3526992", "Huauchinango", "", "MX", "484", "", "21", "071", "", "20.17376", "-98.05491", "America/Mexico_City"),("3526993", "Huatusco de Chicuellar", "", "MX", "484", "", "30", "071", "", "19.14876", "-96.9676", "America/Mexico_City"),("3527017", "Huamuxtitlán", "", "MX", "484", "", "12", "033", "", "17.80287", "-98.56417", "America/Mexico_City"),("3527021", "Hualahuises", "", "MX", "484", "", "19", "029", "", "24.88295", "-99.6749", "America/Monterrey"),("3527023", "Ciudad de Huajuapan de León", "", "MX", "484", "", "20", "039", "", "17.80787", "-97.77956", "America/Mexico_City"),("3527065", "Hopelchén", "", "MX", "484", "", "04", "006", "", "19.74671", "-89.84437", "America/Merida"),("3527080", "Homun", "", "MX", "484", "", "31", "036", "", "20.73918", "-89.2849", "America/Merida"),("3527121", "Santa Cruz Hidalgo", "", "MX", "484", "", "30", "109", "", "19.96663", "-96.87998", "America/Mexico_City"),("3527149", "Hecelchakán", "", "MX", "484", "", "04", "005", "", "20.17735", "-90.13357", "America/Merida"),("3527164", "Halachó", "", "MX", "484", "", "31", "033", "", "20.4777", "-90.08104", "America/Merida"),("3527186", "Gutiérrez Zamora", "", "MX", "484", "", "30", "069", "", "20.45347", "-97.08588", "America/Mexico_City"),("3527451", "General Teran", "", "MX", "484", "", "19", "022", "", "25.25857", "-99.68371", "America/Monterrey"),("3527542", "Frontera Comalapa", "", "MX", "484", "", "05", "034", "", "15.66046", "-92.14282", "America/Mexico_City"),("3527545", "Frontera", "Фронтера", "MX", "484", "", "27", "003", "", "18.54326", "-92.6453", "America/Mexico_City"),("3527596", "Fortín de las Flores", "", "MX", "484", "", "30", "068", "", "18.90806", "-97", "America/Mexico_City"),("3527624", "Filomeno Mata", "", "MX", "484", "", "21", "", "", "20.20004", "-97.70392", "America/Mexico_City"),("3527639", "Felipe Carrillo Puerto", "", "MX", "484", "", "23", "002", "", "19.5775", "-88.04529", "America/Cancun"),("3527656", "Ezequiel Montes", "", "MX", "484", "", "22", "007", "", "20.66481", "-99.8996", "America/Mexico_City"),("3527720", "Espita", "", "MX", "484", "", "31", "032", "", "21.01098", "-88.30681", "America/Merida"),("3527748", "San José Esperanza", "", "MX", "484", "", "21", "063", "", "18.86279", "-97.40628", "America/Mexico_City"),("3527768", "Escuintla", "", "MX", "484", "", "05", "032", "", "15.31944", "-92.65833", "America/Mexico_City"),("3527795", "Escárcega", "Эскарсега", "MX", "484", "", "04", "009", "", "18.60891", "-90.74544", "America/Merida"),("3527869", "Villa Emilio Carranza", "", "MX", "484", "", "30", "192", "", "19.9702", "-96.61162", "America/Mexico_City"),("3527876", "Emiliano Zapata", "", "MX", "484", "", "13", "021", "", "19.6549", "-98.54497", "America/Mexico_City"),("3527879", "Emiliano Zapata", "", "MX", "484", "", "17", "008", "", "18.84065", "-99.18463", "America/Mexico_City"),("3527880", "Emiliano Zapata", "Эмилиано Сапата", "MX", "484", "", "05", "", "", "17.74058", "-91.76635", "America/Mexico_City"),("3528046", "El Tejar", "", "MX", "484", "", "30", "105", "", "19.07433", "-96.16097", "America/Mexico_City"),("3528601", "El Ocotito", "", "MX", "484", "", "12", "029", "", "17.24603", "-99.51525", "America/Mexico_City"),("3528756", "Ciudad Mante", "", "MX", "484", "", "28", "021", "", "22.74304", "-98.9739", "America/Monterrey"),("3528788", "El Llano", "", "MX", "484", "", "13", "076", "", "20.06537", "-99.31976", "America/Mexico_City"),("3528894", "El Higo", "", "MX", "484", "", "30", "205", "", "21.76708", "-98.45186", "America/Mexico_City"),("3528975", "El Espinal", "", "MX", "484", "", "05", "", "", "16.36862", "-94.10449", "America/Mexico_City"),("3529510", "Ejutla de Crespo", "", "MX", "484", "", "20", "028", "", "16.56623", "-96.73123", "America/Mexico_City"),("3529609", "Ecatzingo de Hidalgo", "", "MX", "484", "", "15", "034", "", "18.95508", "-98.75198", "America/Mexico_City"),("3529612", "Ecatepec", "", "MX", "484", "", "15", "033", "", "19.61725", "-99.06601", "America/Mexico_City"),("3529650", "Dzitbalché", "", "MX", "484", "", "04", "001", "", "20.31857", "-90.05611", "America/Merida"),("3529654", "Dzilam González", "", "MX", "484", "", "31", "029", "", "21.28098", "-88.92957", "America/Merida"),("3529660", "Dzidzantun", "", "MX", "484", "", "31", "027", "", "21.24898", "-89.04205", "America/Merida"),("3529689", "Doxey", "", "MX", "484", "", "13", "074", "", "20.09169", "-99.24362", "America/Mexico_City"),("3529730", "Domingo Arenas", "", "MX", "484", "", "21", "060", "", "19.13998", "-98.45678", "America/Mexico_City"),("3529886", "Cunduacán", "", "MX", "484", "", "27", "006", "", "18.06557", "-93.17302", "America/Mexico_City"),("3529911", "Cuitláhuac", "", "MX", "484", "", "30", "053", "", "18.8138", "-96.72392", "America/Mexico_City"),("3529915", "Cuilapan de Guerrero", "", "MX", "484", "", "20", "023", "", "16.97756", "-96.78081", "America/Mexico_City"),("3529918", "Cuichapa", "", "MX", "484", "", "30", "052", "", "18.77223", "-96.8698", "America/Mexico_City"),("3529932", "Cuetzalan", "", "MX", "484", "", "21", "043", "", "20.01766", "-97.52277", "America/Mexico_City"),("3529947", "Cuernavaca", "Куэрнавака", "MX", "484", "", "17", "007", "", "18.9261", "-99.23075", "America/Mexico_City"),("3529980", "Cuautlapán", "", "MX", "484", "", "30", "085", "", "18.87747", "-97.02291", "America/Mexico_City"),("3529981", "Cuautlancingo", "", "MX", "484", "", "21", "041", "", "19.08995", "-98.27319", "America/Mexico_City"),("3529982", "Cuautla", "", "MX", "484", "", "17", "006", "", "18.8106", "-98.93525", "America/Mexico_City"),("3529983", "Santiago Cuautlalpan", "", "MX", "484", "", "15", "095", "", "19.68486", "-99.28608", "America/Mexico_City"),("3529986", "Cuautitlán", "Куаутитлан", "MX", "484", "", "15", "024", "", "19.67029", "-99.17865", "America/Mexico_City"),("3529989", "Cuautepec de Hinojosa", "", "MX", "484", "", "13", "016", "", "20.03557", "-98.31015", "America/Mexico_City"),("3530032", "Cuapiaxtla de Madero", "", "MX", "484", "", "21", "038", "", "18.91544", "-97.82382", "America/Mexico_City"),("3530033", "Cuapiaxtla", "", "MX", "484", "", "29", "008", "", "19.29588", "-97.7688", "America/Mexico_City"),("3530040", "Cuanalá", "", "MX", "484", "", "21", "090", "", "19.10917", "-98.32788", "America/Mexico_City"),("3530046", "Cuajinicuilapa de Santa Maria", "", "MX", "484", "", "12", "023", "", "16.47347", "-98.41389", "America/Mexico_City"),("3530049", "Cuajimalpa", "", "MX", "484", "", "09", "004", "", "19.35993", "-99.29388", "America/Mexico_City"),("3530056", "Cuacnopalan", "", "MX", "484", "", "21", "110", "", "18.81699", "-97.51017", "America/Mexico_City"),("3530066", "Cruz Grande", "", "MX", "484", "", "12", "030", "", "16.72241", "-99.12356", "America/Mexico_City"),("3530103", "San Miguel de Cozumel", "", "MX", "484", "", "23", "001", "", "20.501", "-86.94598", "America/Cancun"),("3530110", "Coyutla", "", "MX", "484", "", "30", "051", "", "20.2472", "-97.65824", "America/Mexico_City"),("3530123", "Coyotepec", "", "MX", "484", "", "15", "023", "", "19.77722", "-99.21295", "America/Mexico_City"),("3530139", "Coyoacán", "", "MX", "484", "", "09", "003", "", "19.3467", "-99.16174", "America/Mexico_City"),("3530150", "Coxcatlán", "", "MX", "484", "", "21", "035", "", "18.26709", "-97.15078", "America/Mexico_City"),("3530167", "Cosoleacaque", "", "MX", "484", "", "30", "048", "", "17.99913", "-94.6359", "America/Mexico_City"),("3530168", "Cosolapa", "", "MX", "484", "", "30", "", "", "18.60055", "-96.68524", "America/Mexico_City"),("3530175", "Heroica Coscomatepec de Bravo", "", "MX", "484", "", "30", "047", "", "19.07275", "-97.04685", "America/Mexico_City"),("3530177", "Cosamaloapan de Carpio", "", "MX", "484", "", "30", "045", "", "18.36759", "-95.79857", "America/Mexico_City"),("3530240", "Córdoba", "Кордова", "MX", "484", "", "30", "044", "", "18.8842", "-96.92559", "America/Mexico_City"),("3530248", "Copoya", "", "MX", "484", "", "05", "101", "", "16.71191", "-93.12089", "America/Mexico_City"),("3530259", "Copalillo", "", "MX", "484", "", "12", "019", "", "18.03427", "-99.04124", "America/Mexico_City"),("3530264", "Copala", "", "MX", "484", "", "12", "018", "", "16.60774", "-98.97821", "America/Mexico_City"),("3530267", "Copainalá", "", "MX", "484", "", "05", "021", "", "17.09366", "-93.21059", "America/Mexico_City"),("3530276", "San Bernardino Contla", "", "MX", "484", "", "29", "018", "", "19.32932", "-98.1664", "America/Mexico_City"),("3530295", "Conkal", "", "MX", "484", "", "31", "013", "", "21.07365", "-89.51995", "America/Merida"),("3530367", "Comitán", "Комитан-де-Домингес", "MX", "484", "", "05", "019", "", "16.24471", "-92.13425", "America/Mexico_City"),("3530385", "Comalcalco", "", "MX", "484", "", "27", "005", "", "18.26316", "-93.22397", "America/Mexico_City"),("3530492", "Cocoyoc", "", "MX", "484", "", "17", "029", "", "18.88417", "-98.98194", "America/Mexico_City"),("3530494", "Cocotitlán", "", "MX", "484", "", "15", "022", "", "19.23336", "-98.86596", "America/Mexico_City"),("3530513", "Coatzintla", "", "MX", "484", "", "30", "040", "", "20.48699", "-97.46823", "America/Mexico_City"),("3530517", "Coatzacoalcos", "Коацакоалькос", "MX", "484", "", "30", "039", "", "18.13346", "-94.44242", "America/Mexico_City"),("3530523", "Coatetelco", "", "MX", "484", "", "17", "015", "", "18.72963", "-99.32605", "America/Mexico_City"),("3530527", "Coatepec Harinas", "", "MX", "484", "", "15", "040", "", "18.89492", "-99.72153", "America/Mexico_City"),("3530531", "Coatepec", "", "MX", "484", "", "30", "038", "", "19.45229", "-96.96148", "America/Mexico_City"),("3530532", "Santa Maria Coatepec", "", "MX", "484", "", "21", "142", "", "19.10924", "-97.59253", "America/Mexico_City"),("3530556", "San Juan Coajomulco", "", "MX", "484", "MX", "15", "048", "", "19.75306", "-99.96861", "America/Mexico_City"),("3530569", "Coacalco", "", "MX", "484", "", "15", "020", "", "19.63453", "-99.1005", "America/Mexico_City"),("3530580", "Ciudad Victoria", "Сьюдад-Виктория", "MX", "484", "", "28", "041", "", "23.74174", "-99.14599", "America/Monterrey"),("3530582", "Ciudad Valles", "Сьюдад-Вальес", "MX", "484", "", "24", "013", "", "21.98333", "-99.01667", "America/Mexico_City"),("3530584", "Ciudad Serdán", "", "MX", "484", "", "21", "045", "", "18.9894", "-97.44702", "America/Mexico_City"),("3530587", "Ciudad Sahagun", "", "MX", "484", "", "13", "061", "", "19.77557", "-98.57471", "America/Mexico_City"),("3530588", "Ciudad Pemex", "", "MX", "484", "", "27", "012", "", "17.88268", "-92.48406", "America/Mexico_City"),("3530589", "Ciudad Nezahualcoyotl", "Несауалькойотль", "MX", "484", "", "15", "058", "", "19.40061", "-99.01483", "America/Mexico_City"),("3530590", "Ciudad Miguel Alemán", "", "MX", "484", "", "28", "025", "", "26.39952", "-99.02836", "America/Monterrey"),("3530592", "Ciudad Mendoza", "Сьюдад-Мендоса", "MX", "484", "", "30", "030", "", "18.80645", "-97.1787", "America/Mexico_City"),("3530594", "Ciudad Madero", "Сьюдад-Мадеро", "MX", "484", "", "28", "009", "", "22.27228", "-97.83623", "America/Monterrey"),("3530596", "Ciudad Fernández", "Сьюдад-Фернандес", "MX", "484", "", "24", "011", "", "21.94045", "-100.01153", "America/Mexico_City"),("3530597", "Mexico City", "Мехико", "MX", "484", "", "09", "015", "", "19.42847", "-99.12766", "America/Mexico_City"),("3530598", "Ciudad del Maiz", "", "MX", "484", "", "24", "010", "", "22.40187", "-99.60468", "America/Mexico_City"),("3530599", "Ciudad del Carmen", "Сьюдад-дель-Кармен", "MX", "484", "", "04", "003", "", "18.64592", "-91.82991", "America/Merida"),("3530617", "Cintalapa de Figueroa", "", "MX", "484", "", "05", "017", "", "16.68393", "-93.71814", "America/Mexico_City"),("3530691", "Chunhuhub", "", "MX", "484", "", "23", "002", "", "19.58533", "-88.5922", "America/Cancun"),("3530749", "Chontalpa", "", "MX", "484", "", "27", "008", "", "17.66614", "-93.48115", "America/Mexico_City"),("3530756", "San Pedro Chochula", "", "MX", "484", "", "17", "", "", "19.26359", "-99.4859", "America/Mexico_City"),("3530757", "Cholula", "Чолула", "MX", "484", "", "21", "140", "", "19.06406", "-98.30352", "America/Mexico_City"),("3530778", "Chocaman", "", "MX", "484", "", "30", "062", "", "19.01214", "-97.03291", "America/Mexico_City"),("3530834", "Chinampa de Gorostiza", "", "MX", "484", "", "30", "060", "", "21.35959", "-97.73484", "America/Mexico_City"),("3530836", "Chinameca", "", "MX", "484", "", "30", "059", "", "18.02195", "-94.67945", "America/Mexico_City"),("3530839", "China", "", "MX", "484", "", "19", "013", "", "25.69997", "-99.23454", "America/Monterrey"),("3530840", "Chiná", "", "MX", "484", "", "04", "002", "", "19.76993", "-90.49595", "America/Merida"),("3530852", "San Francisco Chimalpa", "", "MX", "484", "", "17", "", "", "19.44279", "-99.34398", "America/Mexico_City"),("3530870", "Chilpancingo", "", "MX", "484", "", "12", "029", "", "17.5506", "-99.50578", "America/Mexico_City"),("3530871", "Chilón", "", "MX", "484", "", "05", "096", "", "17.23333", "-92.41667", "America/Mexico_City"),("3530886", "Chilapa de Alvarez", "", "MX", "484", "", "12", "028", "", "17.59459", "-99.17639", "America/Mexico_City"),("3530907", "Chinautla", "", "MX", "484", "", "21", "054", "", "19.81996", "-97.38859", "America/Mexico_City"),("3530908", "Chignahuapan", "", "MX", "484", "", "21", "053", "", "19.83866", "-98.03171", "America/Mexico_City"),("3530913", "Chietla", "", "MX", "484", "", "21", "051", "", "18.52028", "-98.57889", "America/Mexico_City"),("3530932", "Chiconcuac", "", "MX", "484", "", "15", "030", "", "19.55939", "-98.89884", "America/Mexico_City"),("3530937", "Chicoloapan", "", "MX", "484", "", "15", "029", "", "19.41687", "-98.90202", "America/Mexico_City"),("3530955", "Chichihualco", "", "MX", "484", "", "12", "040", "", "17.65902", "-99.67624", "America/Mexico_City"),("3530978", "Chichén-Itzá", "Чичен-Ица", "MX", "484", "", "31", "091", "", "20.66667", "-88.56667", "America/Merida"),("3531006", "Chiautla de Tapia", "", "MX", "484", "", "21", "047", "", "18.30149", "-98.60339", "America/Mexico_City"),("3531007", "Chiautla", "", "MX", "484", "", "15", "028", "", "19.54895", "-98.88236", "America/Mexico_City"),("3531013", "Chiapa de Corzo", "Чьяпа-де-Корсо", "MX", "484", "", "05", "027", "", "16.7077", "-93.01184", "America/Mexico_City"),("3531023", "Chetumal", "Четумаль", "MX", "484", "", "23", "004", "", "18.51413", "-88.30381", "America/Cancun"),("3531042", "Chemax", "", "MX", "484", "", "31", "019", "", "20.65613", "-87.9364", "America/Merida"),("3531168", "Chanal", "", "MX", "484", "", "05", "038", "", "16.71667", "-92.4", "America/Mexico_City"),("3531177", "Champotón", "Чампотон", "MX", "484", "", "04", "004", "", "19.34441", "-90.72576", "America/Merida"),("3531200", "Chalco", "", "MX", "484", "", "15", "025", "", "19.26174", "-98.89775", "America/Mexico_City"),("3531221", "Chahuite", "", "MX", "484", "", "20", "025", "", "16.3", "-94.18333", "America/Mexico_City"),("3531321", "Cerro Azul", "", "MX", "484", "", "30", "034", "", "21.192", "-97.74088", "America/Mexico_City"),("3531368", "Celestún", "", "MX", "484", "", "31", "011", "", "20.85973", "-90.39902", "America/Merida"),("3531406", "Caucel", "", "MX", "484", "", "31", "050", "", "21.01539", "-89.70347", "America/Merida"),("3531416", "Catemaco", "", "MX", "484", "", "30", "032", "", "18.42131", "-95.11398", "America/Mexico_City"),("3531556", "Carlos A. Carrillo", "", "MX", "484", "", "30", "208", "", "18.37477", "-95.75444", "America/Mexico_City"),("3531574", "Cardenas", "Карденас", "MX", "484", "", "24", "005", "", "22.00144", "-99.64247", "America/Mexico_City"),("3531576", "Cárdenas", "Карденас", "MX", "484", "", "27", "002", "", "18.00135", "-93.37559", "America/Mexico_City"),("3531598", "Capulhuac", "", "MX", "484", "", "15", "019", "", "19.19354", "-99.46585", "America/Mexico_City"),("3531673", "Cancún", "Канкун", "MX", "484", "", "23", "005", "", "21.17429", "-86.84656", "America/Cancun"),("3531732", "Campeche", "Кампече", "MX", "484", "", "04", "002", "", "19.84386", "-90.52554", "America/Merida"),("3531764", "Camargo", "", "MX", "484", "", "28", "007", "", "26.25457", "-98.84353", "America/Monterrey"),("3531784", "Calpulalpan", "Кальпулальпане", "MX", "484", "", "29", "006", "", "19.58867", "-98.56972", "America/Mexico_City"),("3531793", "Calkiní", "", "MX", "484", "", "04", "001", "", "20.36905", "-90.05119", "America/Merida"),("3531794", "Calixtlahuaca", "", "MX", "484", "", "15", "106", "", "19.33651", "-99.68923", "America/Mexico_City"),("3531798", "Calimaya de Díaz González", "", "MX", "484", "", "15", "018", "", "19.16324", "-99.6181", "America/Mexico_City"),("3531816", "Calderitas", "", "MX", "484", "", "23", "004", "", "18.55564", "-88.25518", "America/Cancun"),("3531863", "Cadereyta", "", "MX", "484", "", "22", "004", "", "20.69701", "-99.81624", "America/Mexico_City"),("3531865", "Cadereyta", "", "MX", "484", "", "19", "009", "", "25.58333", "-99.98333", "America/Monterrey"),("3531875", "San Lorenzo Cacaotepec", "", "MX", "484", "", "20", "227", "", "17.12774", "-96.80244", "America/Mexico_City"),("3531889", "Cacalomacan", "", "MX", "484", "", "15", "106", "", "19.25311", "-99.70623", "America/Mexico_City"),("3531892", "Cacalchen", "", "MX", "484", "", "31", "007", "", "20.98358", "-89.22686", "America/Merida"),("3531904", "Cacahoatán", "", "MX", "484", "", "05", "015", "", "14.99201", "-92.16376", "America/Mexico_City"),("3531972", "Buenavista de Cuéllar", "", "MX", "484", "", "12", "015", "", "18.45958", "-99.40868", "America/Mexico_City"),("3532089", "Buctzotz", "", "MX", "484", "", "31", "006", "", "21.20303", "-88.79271", "America/Merida"),("3532182", "Bochil", "", "MX", "484", "", "05", "013", "", "16.99625", "-92.89218", "America/Mexico_City"),("3532188", "Miguel Bocanegra", "", "MX", "484", "", "17", "", "", "19.84574", "-99.11193", "America/Mexico_City"),("3532193", "Boca del Río", "", "MX", "484", "", "30", "", "", "19.1", "-96.1", "America/Mexico_City"),("3532254", "Berriozábal", "", "MX", "484", "", "05", "012", "", "16.79853", "-93.27163", "America/Mexico_City"),("3532276", "Benito Juárez", "", "MX", "484", "", "13", "", "", "20.88635", "-98.20594", "America/Mexico_City"),("3532279", "Benito Juárez", "", "MX", "484", "", "29", "013", "", "19.37391", "-97.909", "America/Mexico_City"),("3532310", "Belén", "", "MX", "484", "", "27", "012", "", "17.78907", "-92.61137", "America/Mexico_City"),("3532326", "Bécal", "", "MX", "484", "", "04", "001", "", "20.44172", "-90.02738", "America/Merida"),("3532414", "Banderilla", "", "MX", "484", "", "30", "026", "", "19.58893", "-96.93727", "America/Mexico_City"),("3532443", "Balancán", "", "MX", "484", "", "27", "001", "", "17.80903", "-91.53682", "America/Mexico_City"),("3532446", "Bajos del Ejido", "", "MX", "484", "", "12", "021", "", "16.96086", "-99.97169", "America/Mexico_City"),("3532465", "Bacalar", "", "MX", "484", "", "23", "004", "", "18.68109", "-88.39333", "America/Cancun"),("3532497", "Azcapotzalco", "", "MX", "484", "MX", "09", "002", "", "19.48698", "-99.18594", "America/Mexico_City"),("3532499", "Ayutla de los Libres", "", "MX", "484", "", "12", "012", "", "16.96376", "-99.09616", "America/Mexico_City"),("3532506", "Ayutla", "", "MX", "484", "", "21", "085", "", "18.54503", "-98.50537", "America/Mexico_City"),("3532525", "Ayapango", "", "MX", "484", "", "15", "017", "", "19.12692", "-98.79988", "America/Mexico_City"),("3532530", "Ciudad Ayala", "", "MX", "484", "", "17", "004", "", "18.76694", "-98.98222", "America/Mexico_City"),("3532545", "Axochiapan", "", "MX", "484", "", "17", "003", "", "18.50307", "-98.75219", "America/Mexico_City"),("3532565", "Atzacan", "", "MX", "484", "", "30", "022", "", "18.90724", "-97.08307", "America/Mexico_City"),("3532569", "Atoyatempan", "", "MX", "484", "", "21", "020", "", "18.81925", "-97.9139", "America/Mexico_City"),("3532577", "Atotonilco el Grande", "", "MX", "484", "", "13", "012", "", "20.28632", "-98.6685", "America/Mexico_City"),("3532592", "Atlixco", "Атликско", "MX", "484", "", "21", "019", "", "18.90815", "-98.43613", "America/Mexico_City"),("3532597", "Atliaca", "", "MX", "484", "", "12", "061", "", "17.65168", "-99.37471", "America/Mexico_City"),("3532601", "Atlautla", "", "MX", "484", "", "15", "015", "", "19.02188", "-98.77859", "America/Mexico_City"),("3532603", "Atlatlahucan", "", "MX", "484", "", "17", "002", "", "18.93413", "-98.8982", "America/Mexico_City"),("3532604", "San Bartolomé Atlatlahuca", "", "MX", "484", "", "15", "090", "", "19.06963", "-99.60981", "America/Mexico_City"),("3532617", "Atlacomulco de Fabela", "Атлакомулько", "MX", "484", "", "15", "014", "", "19.79919", "-99.875", "America/Mexico_City"),("3532624", "Ciudad López Mateos", "Сьюдад-Лопес-Матеус", "MX", "484", "", "15", "013", "", "19.58547", "-99.26035", "America/Mexico_City"),("3532625", "Atizapán", "", "MX", "484", "", "15", "076", "", "19.25", "-99.55", "America/Mexico_City"),("3532627", "Atitalaquia", "", "MX", "484", "", "13", "010", "", "20.05964", "-99.22163", "America/Mexico_City"),("3532634", "Atengo", "", "MX", "484", "", "13", "067", "", "20.17526", "-99.32714", "America/Mexico_City"),("3532636", "Atencingo", "", "MX", "484", "", "21", "051", "", "18.51347", "-98.60542", "America/Mexico_City"),("3532639", "Atempan", "", "MX", "484", "", "21", "017", "", "19.83945", "-97.45855", "America/Mexico_City"),("3532656", "Asunción Nochixtlán", "", "MX", "484", "", "20", "006", "", "17.45916", "-97.22605", "America/Mexico_City"),("3532658", "Asunción Ixtaltepec", "", "MX", "484", "", "20", "005", "", "16.50315", "-95.06121", "America/Mexico_City"),("3532792", "Apizaco", "", "MX", "484", "", "29", "005", "", "19.41333", "-98.14358", "America/Mexico_City"),("3532802", "Apaxtla de Castrejón", "", "MX", "484", "", "12", "006", "", "18.13127", "-99.93255", "America/Mexico_City"),("3532803", "Apaxco de Ocampo", "", "MX", "484", "", "15", "010", "", "19.97512", "-99.17112", "America/Mexico_City"),("3532808", "San Pedro Apatlaco", "", "MX", "484", "", "17", "004", "", "18.79306", "-98.95972", "America/Mexico_City"),("3532815", "Apan", "", "MX", "484", "", "13", "008", "", "19.71128", "-98.45086", "America/Mexico_City"),("3532821", "Antón Lizardo", "", "MX", "484", "", "30", "011", "", "19.05962", "-95.99272", "America/Mexico_City"),("3532852", "Angel R. Cabadas", "", "MX", "484", "", "30", "015", "", "18.59601", "-95.4458", "America/Mexico_City"),("3532856", "Angel Albino Corzo", "", "MX", "484", "", "05", "008", "", "15.87314", "-92.72437", "America/Mexico_City"),("3532858", "Anenecuilco", "", "MX", "484", "", "17", "004", "", "18.77738", "-98.98907", "America/Mexico_City"),("3532870", "Anahuac", "", "MX", "484", "", "30", "133", "", "22.20275", "-97.85506", "America/Mexico_City"),("3532881", "Amozoc de Mota", "", "MX", "484", "", "21", "015", "", "19.04611", "-98.045", "America/Mexico_City"),("3532895", "San Miguel Ameyalco", "", "MX", "484", "", "17", "", "", "19.30681", "-99.4588", "America/Mexico_City"),("3532899", "Amecameca", "", "MX", "484", "", "15", "009", "", "19.12384", "-98.76649", "America/Mexico_City"),("3532909", "Amatlán de los Reyes", "", "MX", "484", "", "30", "014", "", "18.84575", "-96.91494", "America/Mexico_City"),("3532951", "Amacuzac", "", "MX", "484", "", "17", "001", "", "18.59861", "-99.36944", "America/Mexico_City"),("3532964", "Heroica Alvarado", "Альварадо", "MX", "484", "", "30", "011", "", "18.77143", "-95.76181", "America/Mexico_City"),("3532969", "Altotonga", "", "MX", "484", "", "30", "010", "", "19.76613", "-97.24514", "America/Mexico_City"),("3532989", "Altepexi", "", "MX", "484", "", "21", "013", "", "18.37035", "-97.29966", "America/Mexico_City"),("3532996", "Altamirano", "", "MX", "484", "", "05", "059", "", "16.88333", "-92.15", "America/Mexico_City"),("3533005", "Altamira", "Альтамира", "MX", "484", "", "28", "003", "", "22.39215", "-97.93867", "America/Monterrey"),("3533020", "Alpuyeca", "", "MX", "484", "", "17", "028", "", "18.74006", "-99.25937", "America/Mexico_City"),("3533037", "Almoloya del Río", "", "MX", "484", "", "15", "006", "", "19.16046", "-99.4874", "America/Mexico_City"),("3533056", "Allende", "", "MX", "484", "", "30", "039", "", "18.15514", "-94.39289", "America/Mexico_City"),("3533067", "Villa Terrazas", "", "MX", "484", "", "24", "053", "", "21.43923", "-98.87508", "America/Mexico_City"),("3533079", "Aldama", "", "MX", "484", "", "28", "002", "", "22.92157", "-98.07519", "America/Monterrey"),("3533107", "Álamo", "", "MX", "484", "", "30", "160", "", "20.91154", "-97.67554", "America/Mexico_City"),("3533117", "Akil", "", "MX", "484", "", "31", "003", "", "20.26547", "-89.34787", "America/Merida"),("3533126", "Ajalpan", "", "MX", "484", "", "21", "010", "", "18.37908", "-97.25867", "America/Mexico_City"),("3533268", "Agua Dulce", "", "MX", "484", "", "30", "124", "", "20.36337", "-97.29315", "America/Mexico_City"),("3533269", "Agua Dulce", "", "MX", "484", "", "30", "204", "", "18.13909", "-94.14527", "America/Mexico_City"),("3533376", "Acultzingo", "", "MX", "484", "", "30", "006", "", "18.71894", "-97.30367", "America/Mexico_City"),("3533389", "Actopan", "", "MX", "484", "", "13", "003", "", "20.26961", "-98.94377", "America/Mexico_City"),("3533422", "San Jerónimo Acazulco", "", "MX", "484", "", "17", "", "", "19.26563", "-99.41629", "America/Mexico_City"),("3533426", "Acayucan", "", "MX", "484", "", "30", "003", "", "17.94979", "-94.91386", "America/Mexico_City"),("3533428", "Acayuca", "", "MX", "484", "", "13", "082", "", "20.02567", "-98.8411", "America/Mexico_City"),("3533433", "Acatzingo", "", "MX", "484", "", "21", "004", "", "18.98196", "-97.78363", "America/Mexico_City"),("3533439", "Acatlán de Pérez Figueroa", "", "MX", "484", "", "20", "002", "", "18.53973", "-96.60568", "America/Mexico_City"),("3533440", "Acatlán de Osorio", "", "MX", "484", "", "21", "003", "", "18.2025", "-98.04864", "America/Mexico_City"),("3533462", "Acapulco de Juárez", "Акапулько", "MX", "484", "", "12", "001", "", "16.86336", "-99.8901", "America/Mexico_City"),("3533466", "Acapetahua", "", "MX", "484", "", "05", "003", "", "15.28189", "-92.68987", "America/Mexico_City"),("3533472", "Acanceh", "", "MX", "484", "", "31", "002", "", "20.81269", "-89.45295", "America/Merida"),("3533475", "Acambay", "", "MX", "484", "", "15", "001", "", "19.95522", "-99.84428", "America/Mexico_City"),("3533483", "Acala", "", "MX", "484", "", "05", "002", "", "16.55625", "-92.80449", "America/Mexico_City"),("3533486", "Acajete", "", "MX", "484", "", "21", "001", "", "19.11154", "-97.95231", "America/Mexico_City"),("3533490", "San Antonio Acahualco", "", "MX", "484", "", "15", "118", "", "19.274", "-99.77169", "America/Mexico_City"),("3533491", "Acacoyagua", "", "MX", "484", "", "05", "001", "", "15.34054", "-92.67519", "America/Mexico_City"),("3533505", "Abasolo", "", "MX", "484", "", "28", "001", "", "24.05844", "-98.37333", "America/Monterrey"),("3761012", "Ajacuba", "", "MX", "484", "", "13", "005", "", "20.0917", "-99.12246", "America/Mexico_City"),("3761194", "Miraflores", "", "MX", "484", "", "15", "025", "", "19.22492", "-98.81333", "America/Mexico_City"),("3761883", "San Lorenzo Cacaotepec", "", "MX", "484", "", "20", "227", "", "17.12833", "-96.8", "America/Mexico_City"),("3762210", "Santiago Tlacotepec", "", "MX", "484", "", "15", "106", "", "19.22708", "-99.67083", "America/Mexico_City"),("3762770", "San Antonio de la Cal", "", "MX", "484", "", "20", "107", "", "17.02833", "-96.70056", "America/Mexico_City"),("3792044", "Hidalgo", "", "MX", "484", "", "19", "042", "", "25.8579", "-99.61898", "America/Monterrey"),("3801045", "Tamazulapam Villa del Progreso", "", "MX", "484", "", "20", "540", "", "17.6771", "-97.57315", "America/Mexico_City"),("3801145", "Teotitlán", "", "MX", "484", "", "20", "545", "", "18.13179", "-97.07056", "America/Mexico_City"),("3801225", "Tezonapa", "", "MX", "484", "", "30", "173", "", "18.60706", "-96.68417", "America/Mexico_City"),("3801262", "Isla Soyaltepec", "", "MX", "484", "", "20", "278", "", "18.20138", "-96.48278", "America/Mexico_City"),("3802082", "Miguel Hidalgo", "", "MX", "484", "", "27", "005", "", "18.25691", "-93.31073", "America/Mexico_City"),("3802196", "Villa la Venta", "", "MX", "484", "", "27", "008", "", "18.09863", "-94.04593", "America/Mexico_City"),("3802739", "Río de Teapa", "", "MX", "484", "", "27", "009", "", "17.78342", "-92.90033", "America/Mexico_City"),("3803064", "Jalapa", "", "MX", "484", "", "27", "009", "", "17.72168", "-92.81272", "America/Mexico_City"),("3814128", "Presas", "", "MX", "484", "", "13", "067", "", "20.15946", "-99.25242", "America/Mexico_City"),("3814409", "Emiliano Zapata", "", "MX", "484", "", "13", "021", "", "19.65417", "-98.54639", "America/Mexico_City"),("3815199", "San José Teacalco", "", "MX", "484", "", "29", "052", "", "19.33558", "-98.06455", "America/Mexico_City"),("3815299", "El Carmen Tequesquitla", "", "MX", "484", "", "29", "007", "", "19.32426", "-97.6535", "America/Mexico_City"),("3815324", "Huamantla", "Уамантла", "MX", "484", "", "29", "013", "", "19.31451", "-97.9252", "America/Mexico_City"),("3815326", "Ixtenco", "", "MX", "484", "", "29", "016", "", "19.25111", "-97.89472", "America/Mexico_City"),("3815329", "Zitlaltépec", "", "MX", "484", "", "29", "037", "", "19.20389", "-97.90722", "America/Mexico_City"),("3815359", "Tetlanohcán", "", "MX", "484", "", "29", "050", "", "19.2603", "-98.16433", "America/Mexico_City"),("3815362", "Mazatecochco", "", "MX", "484", "", "29", "017", "", "19.17861", "-98.18917", "America/Mexico_City"),("3815363", "Xicohtzinco", "", "MX", "484", "", "29", "042", "", "19.17371", "-98.23377", "America/Mexico_City"),("3815375", "La Magdalena Tlaltelulco", "", "MX", "484", "", "29", "048", "", "19.28287", "-98.19609", "America/Mexico_City"),("3815392", "Zacatelco", "", "MX", "484", "", "29", "044", "", "19.21583", "-98.23972", "America/Mexico_City"),("3815415", "Tlaxcala", "Тласкала", "MX", "484", "", "29", "010", "", "19.31905", "-98.19982", "America/Mexico_City"),("3815419", "Totolac", "", "MX", "484", "", "29", "036", "", "19.3258", "-98.25834", "America/Mexico_City"),("3815447", "Papalotla", "", "MX", "484", "", "29", "041", "", "19.16861", "-98.20389", "America/Mexico_City"),("3815451", "Tenancingo", "", "MX", "484", "", "29", "027", "", "19.14725", "-98.20132", "America/Mexico_City"),("3815453", "Villa Vicente Guerrero", "", "MX", "484", "", "29", "025", "", "19.12123", "-98.16572", "America/Mexico_City"),("3815459", "Guadalupe Texcalac", "", "MX", "484", "", "29", "005", "", "19.43839", "-98.07806", "America/Mexico_City"),("3815479", "Pueblo Juárez", "", "MX", "484", "", "05", "048", "", "17.64341", "-93.15964", "America/Mexico_City"),("3815728", "Pantelhó", "", "MX", "484", "", "05", "066", "", "17.00556", "-92.46889", "America/Mexico_City"),("3815772", "Rincón Chamula", "", "MX", "484", "", "05", "072", "", "17.20718", "-92.93912", "America/Mexico_City"),("3816362", "Benemérito de las Américas", "", "MX", "484", "", "05", "114", "", "16.51599", "-90.65371", "America/Mexico_City"),("3816721", "Tonalá", "Тонала", "MX", "484", "", "05", "097", "", "16.0887", "-93.75588", "America/Mexico_City"),("3816739", "Arriaga", "", "MX", "484", "", "05", "009", "", "16.2375", "-93.90184", "America/Mexico_City"),("3816753", "Paredón", "", "MX", "484", "", "05", "097", "", "16.05083", "-93.86667", "America/Mexico_City"),("3817501", "Villa Guerrero", "", "MX", "484", "", "15", "113", "", "18.96", "-99.64", "America/Mexico_City"),("3817731", "Tezoyuca", "", "MX", "484", "", "15", "100", "", "19.59283", "-98.91084", "America/Mexico_City"),("3818579", "Venustiano Carranza", "", "MX", "484", "", "21", "194", "", "20.50667", "-97.66806", "America/Mexico_City"),("3818673", "Ciudad de Tlatlauquitepec", "", "MX", "484", "", "21", "186", "", "19.85278", "-97.49528", "America/Mexico_City"),("3818742", "San Andrés Cholula", "", "MX", "484", "", "21", "119", "", "19.05144", "-98.29526", "America/Mexico_City"),("3818786", "Guadalupe Victoria", "", "MX", "484", "", "21", "067", "", "19.2911", "-97.3429", "America/Mexico_City"),("3818846", "Actipan de Morelos", "", "MX", "484", "", "21", "004", "", "18.96003", "-97.79904", "America/Mexico_City"),("3818938", "Huehuetlán El Chico", "", "MX", "484", "", "21", "073", "", "18.37355", "-98.69061", "America/Mexico_City"),("3818957", "Ciudad de Chiautla de Tapia", "", "MX", "484", "", "21", "047", "", "18.3", "-98.60389", "America/Mexico_City"),("3819050", "Jolalpan", "", "MX", "484", "", "21", "087", "", "18.32779", "-98.84566", "America/Mexico_City"),("3822029", "Marquelia", "", "MX", "484", "", "12", "077", "", "16.58335", "-98.81686", "America/Mexico_City"),("3822167", "San Luis Acatlán", "", "MX", "484", "", "12", "052", "", "16.80722", "-98.73417", "America/Mexico_City"),("3822253", "Panabá", "", "MX", "484", "", "31", "057", "", "21.29639", "-88.27056", "America/Merida"),("3822702", "Kantunilkin", "", "MX", "484", "", "23", "007", "", "21.10182", "-87.48644", "America/Cancun"),("3822723", "Alfredo V. Bonfil", "", "MX", "484", "", "23", "005", "", "21.08776", "-86.84706", "America/Cancun"),("3822745", "Leona Vicario", "", "MX", "484", "", "23", "005", "", "20.9897", "-87.20224", "America/Cancun"),("3823333", "Cabezas", "", "MX", "484", "", "30", "134", "", "19.37167", "-96.38278", "America/Mexico_City"),("3823668", "Las Amapolas", "", "MX", "484", "", "30", "193", "", "19.15194", "-96.19778", "America/Mexico_City"),("3824081", "Coacotla", "", "MX", "484", "", "30", "048", "", "17.93611", "-94.66667", "America/Mexico_City"),("3824166", "Tampico", "Тампико", "MX", "484", "", "28", "038", "", "22.25528", "-97.86861", "America/Monterrey"),("3824177", "San Vicente Tancuayalab", "", "MX", "484", "", "24", "034", "", "21.71833", "-98.58778", "America/Mexico_City"),("3824536", "Alto Lucero", "", "MX", "484", "", "30", "189", "", "20.95361", "-97.44194", "America/Mexico_City"),("3824674", "Mecatlán", "", "MX", "484", "", "30", "103", "", "20.20917", "-97.68083", "America/Mexico_City"),("3824675", "Hueytamalco", "", "MX", "484", "", "21", "076", "", "19.93889", "-97.28722", "America/Mexico_City"),("3824898", "Cosolapa", "", "MX", "484", "", "20", "021", "", "18.60194", "-96.68278", "America/Mexico_City"),("3825174", "Juan Rodríguez Clara", "", "MX", "484", "", "30", "094", "", "17.99389", "-95.40139", "America/Mexico_City"),("3825948", "La Llave", "", "MX", "484", "", "22", "016", "", "20.46628", "-99.99373", "America/Mexico_City"),("3826966", "Emiliano Zapata (Santo Domingo)", "", "MX", "484", "", "15", "042", "", "19.57972", "-99.78806", "America/Mexico_City"),("3827000", "San Agustín Mextepec", "", "MX", "484", "", "15", "074", "", "19.63292", "-99.92654", "America/Mexico_City"),("3827022", "Santiago Citendejé", "", "MX", "484", "", "15", "048", "", "19.78139", "-99.92917", "America/Mexico_City"),("3827030", "San Lorenzo Tlacotepec", "", "MX", "484", "", "15", "014", "", "19.8125", "-99.91222", "America/Mexico_City"),("3827041", "Santiago Acutzilapan", "", "MX", "484", "MX", "15", "014", "", "19.78222", "-99.76417", "America/Mexico_City"),("3827229", "San Pedro Abajo", "", "MX", "484", "", "15", "087", "", "19.48093", "-99.567", "America/Mexico_City"),("3827250", "La Cabecera", "", "MX", "484", "", "15", "005", "", "19.35611", "-99.74806", "America/Mexico_City"),("3827254", "San Mateo Otzacatipan", "", "MX", "484", "", "17", "", "", "19.33273", "-99.60345", "America/Mexico_City"),("3827256", "Santa María Totoltepec", "", "MX", "484", "", "15", "106", "", "19.30653", "-99.59279", "America/Mexico_City"),("3827257", "El Cerrillo Vista Hermosa", "", "MX", "484", "", "15", "106", "", "19.32337", "-99.5425", "America/Mexico_City"),("3827260", "San Antonio Buenavista", "", "MX", "484", "", "15", "106", "", "19.26083", "-99.71194", "America/Mexico_City"),("3827267", "San Pedro Tultepec", "", "MX", "484", "", "17", "", "", "19.26514", "-99.50934", "America/Mexico_City"),("3827273", "San Bartolomé Tlaltelulco", "", "MX", "484", "", "17", "", "", "19.22738", "-99.62964", "America/Mexico_City"),("3827274", "San Juan Tilapa", "", "MX", "484", "", "17", "", "", "19.22021", "-99.66012", "America/Mexico_City"),("3827276", "Santa María Nativitas", "", "MX", "484", "", "15", "018", "", "19.21139", "-99.62944", "America/Mexico_City"),("3827278", "San Pedro Tlaltizapan", "", "MX", "484", "", "17", "", "", "19.19973", "-99.49956", "America/Mexico_City"),("3827283", "San Andrés Ocotlán", "", "MX", "484", "", "17", "", "", "19.19297", "-99.58612", "America/Mexico_City"),("3827299", "San Pedro Zictepec", "", "MX", "484", "", "17", "", "", "19.03659", "-99.57771", "America/Mexico_City"),("3827304", "Santa María Jajalpa", "", "MX", "484", "", "15", "090", "", "19.11167", "-99.53583", "America/Mexico_City"),("3827306", "San Antonio la Isla", "", "MX", "484", "", "15", "073", "", "19.16306", "-99.56722", "America/Mexico_City"),("3827335", "Santiago Tílapa", "", "MX", "484", "", "17", "", "", "19.18953", "-99.42089", "America/Mexico_City"),("3827341", "Tres Marías", "", "MX", "484", "", "17", "009", "", "19.0549", "-99.24301", "America/Mexico_City"),("3827358", "San Pedro Cholula", "", "MX", "484", "", "15", "062", "", "19.26444", "-99.48639", "America/Mexico_City"),("3827367", "San Miguel Ameyalco", "", "MX", "484", "", "15", "051", "", "19.30639", "-99.45806", "America/Mexico_City"),("3827368", "San Mateo Atarasquíllo", "", "MX", "484", "", "17", "", "", "19.32304", "-99.46156", "America/Mexico_City"),("3827403", "San Lorenzo Acopilco", "", "MX", "484", "", "09", "004", "", "19.32889", "-99.32556", "America/Mexico_City"),("3827406", "Benito Juarez", "", "MX", "484", "", "09", "014", "", "19.3984", "-99.15766", "America/Mexico_City"),("3827407", "Venustiano Carranza", "", "MX", "484", "", "09", "017", "", "19.44286", "-99.09724", "America/Mexico_City"),("3827408", "Miguel Hidalgo", "", "MX", "484", "", "09", "016", "", "19.43471", "-99.20091", "America/Mexico_City"),("3827409", "Cuauhtémoc", "", "MX", "484", "", "09", "015", "", "19.44506", "-99.14612", "America/Mexico_City"),("3827414", "Huixquilucan", "", "MX", "484", "", "15", "037", "", "19.35985", "-99.35016", "America/Mexico_City"),("3827416", "Zacamulpa", "", "MX", "484", "", "15", "037", "", "19.35551", "-99.333", "America/Mexico_City"),("3827448", "San Francisco Chimalpa", "", "MX", "484", "", "15", "057", "", "19.44194", "-99.34194", "America/Mexico_City"),("3827476", "San José el Vidrio", "", "MX", "484", "", "15", "060", "", "19.65333", "-99.38417", "America/Mexico_City"),("3827537", "San Miguel Vindho", "", "MX", "484", "", "13", "076", "", "19.99447", "-99.31782", "America/Mexico_City"),("3827566", "San Pedro Xalpa", "", "MX", "484", "", "17", "", "", "19.82666", "-99.18466", "America/Mexico_City"),("3827586", "Melchor Ocampo", "", "MX", "484", "", "15", "053", "", "19.70246", "-99.1438", "America/Mexico_City"),("3827588", "Huilango", "", "MX", "484", "", "15", "121", "", "19.68056", "-99.25639", "America/Mexico_City"),("3827596", "Santiago Teyahualco", "", "MX", "484", "", "15", "108", "", "19.65791", "-99.1234", "America/Mexico_City"),("3827597", "Santa María Tonatitla", "", "MX", "484", "", "15", "125", "", "19.68921", "-99.05384", "America/Mexico_City"),("3827598", "Ojo de Agua", "", "MX", "484", "", "15", "081", "", "19.68028", "-99.01", "America/Mexico_City"),("3827600", "Santo Tomas Chiconautla", "", "MX", "484", "", "15", "033", "", "19.64056", "-99.00833", "America/Mexico_City"),("3827606", "Buenavista", "", "MX", "484", "", "15", "109", "", "19.60833", "-99.16944", "America/Mexico_City"),("3970558", "San Ignacio Río Muerto", "", "MX", "484", "", "26", "072", "", "27.41656", "-110.24584", "America/Hermosillo"),("3970634", "Vicam", "", "MX", "484", "", "26", "029", "", "27.64354", "-110.29351", "America/Hermosillo"),("3970972", "Miguel Alemán (La Doce)", "", "MX", "484", "", "26", "030", "", "28.84028", "-111.4775", "America/Hermosillo"),("3974149", "Los Zacatones", "", "MX", "484", "", "24", "049", "", "22.96139", "-102.05556", "America/Mexico_City"),("3974329", "Dulce Grande", "", "MX", "484", "", "24", "049", "", "23.00175", "-102.17405", "America/Mexico_City"),("3976059", "Ejido Benito Juárez", "", "MX", "484", "", "06", "010", "", "30.14937", "-106.88362", "America/Chihuahua"),("3976161", "Adolfo López Mateos", "", "MX", "484", "", "06", "031", "", "28.46667", "-107.3", "America/Chihuahua"),("3976232", "Isla del Bosque", "", "MX", "484", "", "25", "009", "", "22.73306", "-105.84556", "America/Mazatlan"),("3976324", "Concordia", "", "MX", "484", "", "25", "004", "", "23.28694", "-106.06389", "America/Mazatlan"),("3976535", "Eldorado", "", "MX", "484", "", "25", "006", "", "24.32444", "-107.36722", "America/Mazatlan"),("3976775", "Leyva Solano", "", "MX", "484", "", "25", "011", "", "25.66163", "-108.637", "America/Mazatlan"),("3976999", "Cihuatlán", "", "MX", "484", "", "14", "022", "", "19.2366", "-104.56512", "America/Mexico_City"),("3977811", "Minas de Barroterán", "", "MX", "484", "", "07", "020", "", "27.65144", "-101.28212", "America/Monterrey"),("3979216", "Camalú", "", "MX", "484", "", "02", "001", "", "30.84222", "-116.06328", "America/Tijuana"),("3979430", "Primo Tapia", "", "MX", "484", "", "02", "005", "", "32.22226", "-116.9139", "America/Tijuana"),("3979439", "Progreso", "", "MX", "484", "", "02", "002", "", "32.58039", "-115.58479", "America/Tijuana"),("3979494", "Estación Coahuila", "", "MX", "484", "", "02", "002", "", "32.19304", "-114.99933", "America/Tijuana"),("3979497", "Doctor Alberto Oviedo Mota", "", "MX", "484", "", "02", "002", "", "32.22756", "-115.16792", "America/Tijuana"),("3979505", "Guadalupe Victoria", "", "MX", "484", "", "02", "002", "", "32.28924", "-115.10534", "America/Tijuana"),("3979510", "Delta", "", "MX", "484", "", "02", "002", "", "32.35497", "-115.19617", "America/Tijuana"),("3979665", "Zinapécuaro", "", "MX", "484", "", "16", "110", "", "19.86006", "-100.82857", "America/Mexico_City"),("3979673", "Ixtapa-Zihuatanejo", "Сиуатанехо", "MX", "484", "", "12", "038", "", "17.64344", "-101.55212", "America/Mexico_City"),("3979706", "Zaragoza", "", "MX", "484", "", "07", "038", "", "28.4932", "-100.9223", "America/Monterrey"),("3979714", "Villa Zaragoza", "", "MX", "484", "", "24", "055", "", "22.03716", "-100.73088", "America/Mexico_City"),("3979717", "Zapotlanejo", "", "MX", "484", "", "14", "124", "", "20.62248", "-103.06766", "America/Mexico_City"),("3979727", "Zapotiltic", "", "MX", "484", "", "14", "121", "", "19.62749", "-103.41752", "America/Mexico_City"),("3979770", "Zapopan", "Сапопан", "MX", "484", "", "14", "120", "", "20.72356", "-103.38479", "America/Mexico_City"),("3979802", "Zamora", "Самора-де-Идальго", "MX", "484", "", "16", "108", "", "19.9855", "-102.28387", "America/Mexico_City"),("3979819", "Zacualpan", "", "MX", "484", "", "18", "004", "", "21.24715", "-105.1657", "America/Mazatlan"),("3979822", "Zacoalco de Torres", "", "MX", "484", "", "14", "119", "", "20.22816", "-103.5687", "America/Mexico_City"),("3979844", "Zacatecas", "Сакатекас", "MX", "484", "", "32", "056", "", "22.76843", "-102.58141", "America/Mexico_City"),("3979846", "Zacapú", "Сакапу", "MX", "484", "", "16", "107", "", "19.81396", "-101.79157", "America/Mexico_City"),("3979855", "Yuriria", "", "MX", "484", "", "11", "046", "", "20.21081", "-101.13212", "America/Mexico_City"),("3979856", "Yurécuaro", "", "MX", "484", "", "16", "106", "", "20.33606", "-102.28382", "America/Mexico_City"),("3979982", "Yahualica de González Gallo", "", "MX", "484", "", "14", "118", "", "21.17978", "-102.88611", "America/Mexico_City"),("3980037", "Vista Hermosa de Negrete", "", "MX", "484", "", "16", "105", "", "20.27169", "-102.47488", "America/Mexico_City"),("3980123", "Villa Union", "", "MX", "484", "", "07", "037", "", "28.21667", "-100.71667", "America/Monterrey"),("3980125", "Villa Unión", "", "MX", "484", "", "25", "012", "", "23.18992", "-106.21947", "America/Mazatlan"),("3980140", "Villanueva", "", "MX", "484", "", "32", "055", "", "22.35527", "-102.88264", "America/Mexico_City"),("3980152", "Villa Madero", "", "MX", "484", "", "16", "049", "", "19.3915", "-101.27883", "America/Mexico_City"),("3980161", "Villa Juarez", "", "MX", "484", "", "26", "071", "", "27.12851", "-109.83921", "America/Hermosillo"),("3980168", "Villa Hidalgo", "", "MX", "484", "", "18", "015", "", "21.74185", "-105.23096", "America/Mazatlan"),("3980169", "Villa Hidalgo", "", "MX", "484", "", "14", "116", "", "21.67616", "-102.58803", "America/Mexico_City"),("3980174", "Villagrán", "Вильягран", "MX", "484", "", "11", "044", "", "20.51452", "-100.99745", "America/Mexico_City"),("3980175", "Villa González Ortega", "", "MX", "484", "", "32", "053", "", "22.51222", "-101.91616", "America/Mexico_City"),("3980177", "Villa García", "", "MX", "484", "", "32", "052", "", "22.16169", "-101.95556", "America/Mexico_City"),("3980180", "Ciudad Frontera", "Вилла-Фронтера", "MX", "484", "", "07", "010", "", "26.92814", "-101.45212", "America/Monterrey"),("3980184", "Santa Clara del Cobre", "", "MX", "484", "", "16", "079", "", "19.4058", "-101.63998", "America/Mexico_City"),("3980186", "Villa de Reyes", "", "MX", "484", "", "24", "050", "", "21.80309", "-100.93418", "America/Mexico_City"),("3980190", "García", "Вилья-де-Гарсиа", "MX", "484", "", "19", "018", "", "25.81201", "-100.59874", "America/Monterrey"),("3980194", "Ciudad de Villa de Álvarez", "Вилья-де-Альварес", "MX", "484", "", "08", "010", "", "19.26722", "-103.73778", "America/Mexico_City"),("3980198", "Villa Corona", "", "MX", "484", "", "14", "114", "", "20.41564", "-103.66416", "America/Mexico_City"),("3980207", "Miguel Ahumada", "", "MX", "484", "", "06", "001", "", "30.61861", "-106.51222", "America/Chihuahua"),("3980390", "Venustiano Carranza", "", "MX", "484", "", "16", "103", "", "20.11553", "-102.65391", "America/Mexico_City"),("3980580", "Valtierrilla", "", "MX", "484", "", "11", "027", "", "20.53244", "-101.12761", "America/Mexico_City"),("3980586", "Valparaíso", "", "MX", "484", "", "32", "049", "", "22.77104", "-103.56991", "America/Mexico_City"),("3980605", "Valle de Santiago", "Валье-де-Сантьяго", "MX", "484", "", "11", "042", "", "20.3914", "-101.19222", "America/Mexico_City"),("3980621", "Valle de Bravo", "Валье-де-Браво", "MX", "484", "", "15", "110", "", "19.19501", "-100.13132", "America/Mexico_City"),("3980622", "Valle de Banderas", "", "MX", "484", "", "18", "020", "", "20.80792", "-105.24813", "America/Bahia_Banderas"),("3980683", "Valentín Gómez Farías", "", "MX", "484", "", "06", "026", "", "28.21667", "-106.58333", "America/Chihuahua"),("3980756", "Usmajac", "", "MX", "484", "", "14", "082", "", "19.87458", "-103.54085", "America/Mexico_City"),("3980760", "Uruapan", "Уруапан", "MX", "484", "", "16", "102", "", "19.41116", "-102.05644", "America/Mexico_City"),("3980777", "Uriangato", "", "MX", "484", "", "11", "041", "", "20.14085", "-101.18251", "America/Mexico_City"),("3980798", "Unión de Tula", "", "MX", "484", "", "14", "110", "", "19.95646", "-104.26805", "America/Mexico_City"),("3980799", "Unión de San Antonio", "", "MX", "484", "", "14", "109", "", "21.12714", "-102.00619", "America/Mexico_City"),("3980843", "Tuxpan", "", "MX", "484", "", "16", "098", "", "19.56788", "-100.46189", "America/Mexico_City"),("3980844", "Tuxpan", "", "MX", "484", "", "14", "108", "", "19.55555", "-103.37587", "America/Mexico_City"),("3981145", "Trancoso", "", "MX", "484", "", "32", "057", "", "22.73542", "-102.36697", "America/Mexico_City"),("3981165", "Tototlán", "", "MX", "484", "", "14", "105", "", "20.54217", "-102.79222", "America/Mexico_City"),("3981254", "Torreon", "Торреон", "MX", "484", "", "07", "035", "", "25.54389", "-103.41898", "America/Monterrey"),("3981345", "Topolobampo", "", "MX", "484", "", "25", "001", "", "25.60084", "-109.0523", "America/Mazatlan"),("3981369", "Tonalá", "Тонала", "MX", "484", "", "14", "101", "", "20.62445", "-103.23423", "America/Mexico_City"),("3981391", "Tomatlán", "", "MX", "484", "", "14", "100", "", "19.93664", "-105.2501", "America/Mexico_City"),("3981461", "Tlaquepaque", "Тлакепаке", "MX", "484", "", "14", "098", "", "20.64091", "-103.29327", "America/Mexico_City"),("3981462", "Tlapehuala", "", "MX", "484", "", "12", "067", "", "18.24101", "-100.5379", "America/Mexico_City"),("3981467", "Tlajomulco de Zúñiga", "", "MX", "484", "", "14", "097", "", "20.47421", "-103.44654", "America/Mexico_City"),("3981469", "Tlahualilo de Zaragoza", "", "MX", "484", "", "10", "036", "", "26.10593", "-103.44257", "America/Monterrey"),("3981483", "Tlacote el Bajo", "", "MX", "484", "", "22", "014", "", "20.66139", "-100.50769", "America/Mexico_City"),("3981491", "Tizapán el Alto", "", "MX", "484", "", "14", "096", "", "20.16137", "-103.04397", "America/Mexico_City"),("3981516", "Tingüindín", "", "MX", "484", "", "16", "091", "", "19.73921", "-102.4812", "America/Mexico_City"),("3981517", "Tingambato", "", "MX", "484", "", "16", "090", "", "19.50109", "-101.85327", "America/Mexico_City"),("3981609", "Tijuana", "Тихуана", "MX", "484", "", "02", "004", "", "32.5027", "-117.00371", "America/Tijuana"),("3981652", "Tierra Nueva", "", "MX", "484", "", "24", "043", "", "21.66904", "-100.57287", "America/Mexico_City"),("3981791", "Tesistán", "", "MX", "484", "", "14", "120", "", "20.80051", "-103.46993", "America/Mexico_City"),("3981885", "Tequila", "Текила", "MX", "484", "", "14", "094", "", "20.88205", "-103.83599", "America/Mexico_City"),("3981941", "Tepic", "Тепик", "MX", "484", "", "18", "017", "", "21.50951", "-104.89569", "America/Mazatlan"),("3981984", "Tepatitlán de Morelos", "", "MX", "484", "", "14", "093", "", "20.81692", "-102.76347", "America/Mexico_City"),("3982007", "Tepalcatepec", "", "MX", "484", "", "16", "089", "", "19.18666", "-102.8493", "America/Mexico_City"),("3982034", "Teocaltiche", "", "MX", "484", "", "14", "091", "", "21.43421", "-102.57449", "America/Mexico_City"),("3982121", "Tejupilco de Hidalgo", "", "MX", "484", "", "15", "082", "", "18.90475", "-100.15275", "America/Mexico_City"),("3982168", "Tecuala", "", "MX", "484", "", "18", "016", "", "22.39815", "-105.45808", "America/Mazatlan"),("3982170", "Técpan de Galeana", "", "MX", "484", "", "12", "057", "", "17.21976", "-100.63032", "America/Mexico_City"),("3982213", "Tecoman", "Текомане", "MX", "484", "", "08", "009", "", "18.91678", "-103.87786", "America/Mexico_City"),("3982215", "Tecolots", "", "MX", "484", "", "02", "002", "", "32.56667", "-114.98333", "America/Tijuana"),("3982217", "Tecolotlán", "", "MX", "484", "", "14", "088", "", "20.20167", "-104.04748", "America/Mexico_City"),("3982266", "Tecate", "", "MX", "484", "", "02", "003", "", "32.56717", "-116.62509", "America/Tijuana"),("3982269", "Tecalitlan", "", "MX", "484", "", "14", "087", "", "19.47182", "-103.3072", "America/Mexico_City"),("3982292", "Tayoltita", "", "MX", "484", "", "10", "026", "", "24.10278", "-105.93083", "America/Mazatlan"),("3982364", "Tarimoro", "", "MX", "484", "", "11", "039", "", "20.28704", "-100.75612", "America/Mexico_City"),("3982377", "Taretán", "", "MX", "484", "", "16", "087", "", "19.3342", "-101.91849", "America/Mexico_City"),("3982401", "Tarandacuao", "", "MX", "484", "", "11", "038", "", "20.00094", "-100.51856", "America/Mexico_City"),("3982461", "Tapalpa", "", "MX", "484", "", "14", "086", "", "19.94563", "-103.75954", "America/Mexico_City"),("3982542", "Tanhuato de Guerrero", "", "MX", "484", "", "16", "086", "", "20.28552", "-102.33113", "America/Mexico_City"),("3982545", "Tangancícuaro de Arista", "", "MX", "484", "", "15", "", "", "19.88733", "-102.20636", "America/Mexico_City"),("3982548", "Tancítaro", "", "MX", "484", "", "16", "083", "", "19.33843", "-102.36264", "America/Mexico_City"),("3982567", "Tamazula de Gordiano", "", "MX", "484", "", "14", "085", "", "19.68006", "-103.2514", "America/Mexico_City"),("3982589", "Talpa de Allende", "", "MX", "484", "", "14", "084", "", "20.38084", "-104.82213", "America/Mexico_City"),("3982616", "Tala", "", "MX", "484", "", "14", "083", "", "20.6536", "-103.70092", "America/Mexico_City"),("3982668", "Tacoaleche", "", "MX", "484", "", "32", "017", "", "22.8201", "-102.40476", "America/Mexico_City"),("3982693", "Tacámbaro de Codallos", "", "MX", "484", "", "16", "082", "", "19.23502", "-101.45824", "America/Mexico_City"),("3982729", "Tabasco", "", "MX", "484", "", "32", "044", "", "21.86286", "-102.91105", "America/Mexico_City"),("3982837", "Sonoyta", "", "MX", "484", "", "26", "070", "", "31.86165", "-112.85129", "America/Hermosillo"),("3982887", "Sombrerete", "", "MX", "484", "", "32", "042", "", "23.63466", "-103.64244", "America/Mexico_City"),("3982912", "Soledad de Graciano Sánchez", "", "MX", "484", "", "24", "035", "", "22.18912", "-100.93792", "America/Mexico_City"),("3983058", "Silao", "", "MX", "484", "", "11", "037", "", "20.94356", "-101.42703", "America/Mexico_City"),("3983216", "Sayula", "", "MX", "484", "", "14", "082", "", "19.88225", "-103.60027", "America/Mexico_City"),("3983312", "Saucillo", "", "MX", "484", "", "06", "062", "", "28.03055", "-105.29376", "America/Chihuahua"),("3983630", "Santiago Tangamandapio", "", "MX", "484", "", "16", "084", "", "19.95568", "-102.43546", "America/Mexico_City"),("3983631", "Santiago Papasquiaro", "", "MX", "484", "", "10", "032", "", "25.04389", "-105.41917", "America/Monterrey"),("3983636", "Santiago Ixcuintla", "", "MX", "484", "", "18", "015", "", "21.81295", "-105.20844", "America/Mazatlan"),("3983641", "Santiago de Cuenda", "", "MX", "484", "", "11", "035", "", "20.59956", "-100.99405", "America/Mexico_City"),("3983671", "Santiago", "Сантьяго", "MX", "484", "", "19", "049", "", "25.42533", "-100.15205", "America/Monterrey"),("3983805", "Santa Rosalia", "", "MX", "484", "", "03", "002", "", "27.34045", "-112.26761", "America/Mazatlan"),("3983820", "Santa Rosa Jauregui", "", "MX", "484", "", "22", "014", "", "20.74122", "-100.44843", "America/Mexico_City"),("3984074", "Santa María del Río", "", "MX", "484", "", "24", "032", "", "21.79615", "-100.73815", "America/Mexico_City"),("3984078", "Santa María del Oro", "", "MX", "484", "", "10", "018", "", "25.94944", "-105.36444", "America/Monterrey"),("3984437", "Santa Cruz del Valle", "", "MX", "484", "", "14", "097", "", "20.53333", "-103.43333", "America/Mexico_City"),("3984444", "Santa Cruz de las Flores", "", "MX", "484", "", "14", "097", "", "20.48056", "-103.50278", "America/Mexico_City"),("3984583", "Santa Catarina", "", "MX", "484", "", "19", "048", "", "25.67325", "-100.45813", "America/Monterrey"),("3984629", "Santa Bárbara", "", "MX", "484", "", "06", "060", "", "26.80381", "-105.82024", "America/Chihuahua"),("3984679", "Santa Anita", "", "MX", "484", "", "14", "098", "", "20.5509", "-103.44396", "America/Mexico_City"),("3984680", "Santa Anita", "", "MX", "484", "", "14", "098", "", "20.55056", "-103.44", "America/Mexico_City"),("3984690", "Santa Ana Pacueco", "", "MX", "484", "", "11", "023", "", "20.34722", "-102.01583", "America/Mexico_City"),("3984691", "Santa Ana Maya", "", "MX", "484", "", "16", "078", "", "20.0069", "-101.02189", "America/Mexico_City"),("3984717", "Santa Ana", "", "MX", "484", "", "26", "058", "", "30.54075", "-111.11888", "America/Hermosillo"),("3984791", "San Sebastián el Grande", "", "MX", "484", "", "14", "097", "", "20.51667", "-103.41667", "America/Mexico_City"),("3984997", "San Quintín", "", "MX", "484", "", "02", "001", "", "30.5606", "-115.94464", "America/Tijuana"),("3985008", "San Pedro Piedra Gorda", "", "MX", "484", "", "32", "008", "", "22.44753", "-102.34875", "America/Mexico_City"),("3985129", "San Pedro", "", "MX", "484", "", "07", "017", "", "25.43333", "-103.21667", "America/Monterrey"),("3985168", "San Patricio", "", "MX", "484", "", "14", "022", "", "19.22534", "-104.70447", "America/Mexico_City"),("3985241", "San Nicolás de los Garza", "", "MX", "484", "", "19", "046", "", "25.74167", "-100.30222", "America/Monterrey"),("3985301", "San Miguel Zapotitlan", "", "MX", "484", "", "25", "001", "", "25.94831", "-109.04738", "America/Mazatlan"),("3985307", "San Miguel Octopan", "", "MX", "484", "", "11", "007", "", "20.57428", "-100.7478", "America/Mexico_City");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("3985323", "San Miguel el Alto", "", "MX", "484", "", "14", "078", "", "21.03011", "-102.40414", "America/Mexico_City"),("3985327", "San Miguel de Papasquiaro", "", "MX", "484", "", "10", "032", "", "24.83078", "-105.3364", "America/Monterrey"),("3985344", "San Miguel de Allende", "Сан-Мигель-де-Альенде", "MX", "484", "", "11", "003", "", "20.91528", "-100.74389", "America/Mexico_City"),("3985504", "San Martín Hidalgo", "", "MX", "484", "", "14", "077", "", "20.43538", "-103.92878", "America/Mexico_City"),("3985604", "San Luis Río Colorado", "Сан-Луис-Рио-Колорадо", "MX", "484", "", "26", "055", "", "32.45612", "-114.77186", "America/Hermosillo"),("3985606", "San Luis Potosí", "Сан-Луис-Потоси", "MX", "484", "", "24", "028", "", "22.14982", "-100.97916", "America/Mexico_City"),("3985620", "San Luis de la Paz", "", "MX", "484", "", "11", "033", "", "21.29861", "-100.51639", "America/Mexico_City"),("3985621", "San Luis de la Paz", "", "MX", "484", "", "11", "033", "", "21.29771", "-100.51736", "America/Mexico_City"),("3985665", "San Luis", "", "MX", "484", "", "02", "001", "", "28.43333", "-113.75", "America/Tijuana"),("3985710", "Cabo San Lucas", "Кабо-Сан-Лукас", "MX", "484", "", "03", "008", "", "22.89088", "-109.91238", "America/Mazatlan"),("3985797", "San Julián", "", "MX", "484", "", "14", "074", "", "21.01035", "-102.17967", "America/Mexico_City"),("3985865", "San Juan de los Lagos", "", "MX", "484", "", "14", "073", "", "21.24893", "-102.33036", "America/Mexico_City"),("3985878", "San Juan de la Vega", "", "MX", "484", "", "11", "007", "", "20.62521", "-100.76141", "America/Mexico_City"),("3985912", "San Juan de Abajo", "", "MX", "484", "", "18", "020", "", "20.81484", "-105.19154", "America/Mazatlan"),("3985913", "San Juan Cosalá", "", "MX", "484", "", "14", "050", "", "20.28756", "-103.34109", "America/Mexico_City"),("3986088", "San José Iturbide", "", "MX", "484", "", "11", "032", "", "21.00153", "-100.38416", "America/Mexico_City"),("3986090", "San José el Alto", "", "MX", "484", "", "22", "014", "", "20.65339", "-100.38218", "America/Mexico_City"),("3986165", "San José del Castillo", "", "MX", "484", "", "14", "070", "", "20.51405", "-103.23796", "America/Mexico_City"),("3986172", "San José del Cabo", "Сан-Хосе-дель-Кабо", "MX", "484", "", "03", "008", "", "23.05888", "-109.69771", "America/Mazatlan"),("3986228", "San José de Gracia", "", "MX", "484", "", "14", "093", "", "20.67474", "-102.56989", "America/Mexico_City"),("3986553", "San Jerónimo de Juárez", "", "MX", "484", "", "12", "014", "", "17.13915", "-100.47067", "America/Mexico_City"),("3986600", "San Jeronimito", "", "MX", "484", "", "12", "048", "", "17.56818", "-101.34499", "America/Mexico_City"),("3986959", "San Gabriel", "", "MX", "484", "", "14", "102", "", "19.76667", "-104", "America/Mexico_City"),("3986984", "San Francisco del Rincón", "", "MX", "484", "", "11", "031", "", "21.01843", "-101.85515", "America/Mexico_City"),("3987224", "San Felipe", "", "MX", "484", "", "02", "002", "", "31.02468", "-114.83919", "America/Tijuana"),("3987245", "San Felipe Aztatán", "", "MX", "484", "", "18", "016", "", "22.38374", "-105.4198", "America/Mazatlan"),("3987246", "San Felipe", "", "MX", "484", "", "11", "030", "", "21.47831", "-101.21566", "America/Mexico_City"),("3987309", "San Diego de la Unión", "", "MX", "484", "", "11", "029", "", "21.46749", "-100.8731", "America/Mexico_City"),("3987402", "Tlaltenango de Sánchez Román", "", "MX", "484", "", "32", "048", "", "21.78221", "-103.30298", "America/Mexico_City"),("3987500", "San Buenaventura", "", "MX", "484", "", "07", "031", "", "27.06193", "-101.54891", "America/Monterrey"),("3987538", "San Blas", "", "MX", "484", "", "25", "010", "", "26.08019", "-108.7611", "America/Mazatlan"),("3987544", "San Blas", "", "MX", "484", "", "18", "012", "", "21.54333", "-105.28558", "America/Mazatlan"),("3987619", "San Bartolo", "", "MX", "484", "", "15", "007", "", "19.24496", "-100.05329", "America/Mexico_City"),("3988025", "Nicolás R Casillas", "", "MX", "484", "", "14", "097", "", "20.54638", "-103.46622", "America/Mexico_City"),("3988050", "Salvatierra", "Сальватьерра", "MX", "484", "", "11", "028", "", "20.21249", "-100.87923", "America/Mexico_City"),("3988086", "Saltillo", "Салтилло", "MX", "484", "", "07", "030", "", "25.42321", "-101.0053", "America/Monterrey"),("3988169", "Salinas de Hidalgo", "", "MX", "484", "", "24", "025", "", "22.62795", "-101.71417", "America/Mexico_City"),("3988214", "Salamanca", "Саламанка", "MX", "484", "", "11", "027", "", "20.57196", "-101.19154", "America/Mexico_City"),("3988258", "Sahuayo de Morelos", "", "MX", "484", "", "16", "076", "", "20.05859", "-102.71575", "America/Mexico_City"),("3988327", "Sabinas Hidalgo", "", "MX", "484", "", "19", "044", "", "26.50358", "-100.18187", "America/Monterrey"),("3988333", "Ciudad Sabinas", "", "MX", "484", "", "07", "028", "", "27.85591", "-101.11738", "America/Monterrey"),("3988361", "Estación Ruiz", "", "MX", "484", "", "18", "011", "", "21.95107", "-105.1438", "America/Mazatlan"),("3988392", "Rosarito", "Росарито", "MX", "484", "", "02", "005", "", "32.36044", "-117.04645", "America/Tijuana"),("3988430", "Rosales", "", "MX", "484", "", "06", "055", "", "28.18753", "-105.55717", "America/Chihuahua"),("3988462", "Romita", "", "MX", "484", "", "11", "026", "", "20.87127", "-101.51683", "America/Mexico_City"),("3988594", "Río Grande", "", "MX", "484", "", "32", "039", "", "23.82647", "-103.03034", "America/Mexico_City"),("3988648", "Rincón de Tamayo", "", "MX", "484", "", "11", "007", "", "20.42403", "-100.75513", "America/Mexico_City"),("3988651", "Rincón de Romos", "Ринкон-де-Ромос", "MX", "484", "", "01", "007", "", "22.22819", "-102.32216", "America/Mexico_City"),("3991043", "Ramos Arizpe", "Рамос-Ариспе", "MX", "484", "", "07", "027", "", "25.53928", "-100.94742", "America/Monterrey"),("3991110", "Quiroga", "", "MX", "484", "", "16", "073", "", "19.66557", "-101.52287", "America/Mexico_City"),("3991148", "Quila", "", "MX", "484", "", "25", "006", "", "24.42362", "-107.22186", "America/Mazatlan"),("3991164", "Santiago de Querétaro", "Керетаро", "MX", "484", "", "22", "014", "", "20.58806", "-100.38806", "America/Mexico_City"),("3991169", "Estación Queréndaro", "", "MX", "484", "", "16", "110", "", "19.88285", "-100.94861", "America/Mexico_City"),("3991218", "Puruarán", "", "MX", "484", "", "16", "097", "", "19.0963", "-101.52234", "America/Mexico_City"),("3991219", "Puruándiro", "", "MX", "484", "", "16", "071", "", "20.08886", "-101.51579", "America/Mexico_City"),("3991253", "Puréparo de Echaíz", "", "MX", "484", "", "16", "070", "", "19.91039", "-102.00625", "America/Mexico_City"),("3991323", "Puga", "", "MX", "484", "", "18", "017", "", "21.58443", "-104.82318", "America/Mazatlan"),("3991328", "Puerto Vallarta", "Пуэрто-Вальярта", "MX", "484", "", "14", "067", "", "20.617", "-105.23018", "America/Mexico_City"),("3991347", "Puerto Peñasco", "Пуэрто-Пеньяско", "MX", "484", "", "26", "048", "", "31.31716", "-113.53799", "America/Hermosillo"),("3991350", "Puerto Palomas", "", "MX", "484", "", "06", "005", "", "31.77718", "-107.63439", "America/Chihuahua"),("3991547", "Pueblo Yaqui", "", "MX", "484", "", "26", "018", "", "27.35521", "-110.03444", "America/Hermosillo"),("3992154", "Potam", "", "MX", "484", "", "26", "029", "", "27.626", "-110.4158", "America/Hermosillo"),("3992212", "Poncitlán", "", "MX", "484", "", "14", "066", "", "20.37963", "-102.92557", "America/Mexico_City"),("3992278", "Poanas", "", "MX", "484", "", "10", "007", "", "25.77046", "-103.60707", "America/Monterrey"),("3992405", "Pitiquito", "", "MX", "484", "", "26", "047", "", "30.67663", "-112.05466", "America/Hermosillo"),("3992599", "Pihuamo", "", "MX", "484", "", "14", "065", "", "19.24991", "-103.38275", "America/Mexico_City"),("3992619", "Piedras Negras", "", "MX", "484", "", "07", "025", "", "28.70007", "-100.52353", "America/Matamoros"),("3992842", "Petatlán", "Петатлан", "MX", "484", "", "12", "048", "", "17.53768", "-101.26798", "America/Mexico_City"),("3992857", "Pesquería", "", "MX", "484", "", "19", "041", "", "25.78543", "-100.05098", "America/Monterrey"),("3992858", "Pesqueira", "", "MX", "484", "", "26", "056", "", "29.37972", "-110.89611", "America/Hermosillo"),("3992919", "Peribán de Ramos", "", "MX", "484", "", "16", "068", "", "19.5201", "-102.41397", "America/Mexico_City"),("3992967", "Peñón Blanco", "", "MX", "484", "", "10", "021", "", "24.79289", "-104.02659", "America/Monterrey"),("3992986", "Pénjamo", "", "MX", "484", "", "11", "023", "", "20.43108", "-101.72261", "America/Mexico_City"),("3993126", "Pedro Escobedo", "", "MX", "484", "", "22", "012", "", "20.49963", "-100.14278", "America/Mexico_City"),("3993155", "Pedernales", "", "MX", "484", "", "16", "082", "", "19.14133", "-101.46889", "America/Mexico_City"),("3993179", "Pátzcuaro", "Пацкуаро", "MX", "484", "", "16", "066", "", "19.51594", "-101.60887", "America/Mexico_City"),("3993335", "Parras de la Fuente", "Паррас", "MX", "484", "", "07", "024", "", "25.44185", "-102.17808", "America/Monterrey"),("3993455", "Parácuaro", "", "MX", "484", "", "11", "002", "", "20.14473", "-100.76211", "America/Mexico_City"),("3993457", "Paracho de Verduzco", "", "MX", "484", "", "16", "065", "", "19.64745", "-102.04897", "America/Mexico_City"),("3993519", "Panindícuaro", "", "MX", "484", "", "16", "063", "", "19.98518", "-101.76096", "America/Mexico_City"),("3993893", "Palau", "", "MX", "484", "", "07", "020", "", "27.89232", "-101.42319", "America/Monterrey"),("3993926", "Pajacuarán", "", "MX", "484", "", "16", "062", "", "20.11909", "-102.56623", "America/Mexico_City"),("3994164", "Opopeo", "", "MX", "484", "", "16", "079", "", "19.41163", "-101.60515", "America/Mexico_City"),("3994216", "Ojuelos de Jalisco", "", "MX", "484", "", "14", "064", "", "21.86614", "-101.59269", "America/Mexico_City"),("3994469", "Ojinaga", "", "MX", "484", "", "06", "052", "", "29.56689", "-104.54487", "America/Ojinaga"),("3994489", "Ocotlán", "", "MX", "484", "", "14", "063", "", "20.3553", "-102.77358", "America/Mexico_City"),("3994535", "Ocampo", "", "MX", "484", "", "11", "022", "", "21.64653", "-101.48012", "America/Mexico_City"),("3994594", "Nuevo San Juan Parangaricutiro", "", "MX", "484", "", "16", "058", "", "19.41857", "-102.13087", "America/Mexico_City"),("3994604", "Nuevo México", "Нуэво-Мексико", "MX", "484", "", "14", "120", "", "20.7565", "-103.44297", "America/Mexico_City"),("3994607", "Nuevo Ideal", "", "MX", "484", "", "10", "039", "", "24.88544", "-105.07552", "America/Monterrey"),("3994616", "Nuevo Casas Grandes", "Нуэво-Касас-Грандес", "MX", "484", "", "06", "050", "", "30.41552", "-107.91166", "America/Chihuahua"),("3994667", "Nueva Rosita", "Нуэва-Росита", "MX", "484", "", "07", "032", "", "27.94028", "-101.21812", "America/Monterrey"),("3994674", "Nueva Italia de Ruiz", "", "MX", "484", "", "16", "055", "", "19.02492", "-102.09318", "America/Mexico_City"),("3994912", "Nochistlán de Mejía", "", "MX", "484", "", "32", "034", "", "21.36435", "-102.8459", "America/Mexico_City"),("3994939", "Nieves", "", "MX", "484", "", "32", "014", "", "23.99609", "-103.02013", "America/Mexico_City"),("3995010", "Nazareno", "", "MX", "484", "", "10", "012", "", "25.39916", "-103.42065", "America/Monterrey"),("3995017", "Navolato", "", "MX", "484", "", "25", "018", "", "24.7661", "-107.70225", "America/Mazatlan"),("3995019", "Navojoa", "Навохоа", "MX", "484", "", "26", "042", "", "27.07028", "-109.44372", "America/Hermosillo"),("3995050", "Nava", "", "MX", "484", "", "07", "022", "", "28.42071", "-100.76565", "America/Monterrey"),("3995142", "Naica", "", "MX", "484", "", "06", "062", "", "27.85736", "-105.49233", "America/Chihuahua"),("3995146", "Nahuatzén", "", "MX", "484", "", "16", "056", "", "19.65506", "-101.91704", "America/Mexico_City"),("3995155", "Nacozari Viejo", "", "MX", "484", "", "26", "041", "", "30.4", "-109.65", "America/Hermosillo"),("3995171", "Naco", "", "MX", "484", "", "26", "039", "", "31.32701", "-109.94669", "America/Hermosillo"),("3995343", "Moroleón", "", "MX", "484", "", "11", "021", "", "20.12571", "-101.19208", "America/Mexico_City"),("3995398", "Morelos", "", "MX", "484", "", "32", "032", "", "22.86215", "-102.61061", "America/Mexico_City"),("3995402", "Morelia", "Морелия", "MX", "484", "", "16", "053", "", "19.70078", "-101.18443", "America/Mexico_City"),("3995465", "Monterrey", "Монтеррей", "MX", "484", "", "19", "039", "", "25.67507", "-100.31847", "America/Monterrey"),("3995523", "Monclova", "", "MX", "484", "", "07", "018", "", "26.90687", "-101.42056", "America/Monterrey"),("3995652", "Mocorito", "", "MX", "484", "", "25", "013", "", "25.48202", "-107.92008", "America/Mazatlan"),("3995943", "Miguel Auza", "", "MX", "484", "", "32", "029", "", "24.29421", "-103.4509", "America/Mexico_City"),("3996069", "Mexicali", "Мехикали", "MX", "484", "", "02", "002", "", "32.62781", "-115.45446", "America/Tijuana"),("3996234", "Meoqui", "", "MX", "484", "", "06", "045", "", "28.27226", "-105.48046", "America/Chihuahua"),("3996271", "Melchor Múzquiz", "", "MX", "484", "", "07", "020", "", "27.87933", "-101.51615", "America/Monterrey"),("3996299", "Medina", "", "MX", "484", "", "11", "020", "", "21.14972", "-101.6225", "America/Mexico_City"),("3996322", "Mazatlán", "Масатлан", "MX", "484", "", "25", "012", "", "23.2329", "-106.4062", "America/Mazatlan"),("3996336", "Mazamitla", "", "MX", "484", "", "14", "059", "", "19.9161", "-103.02027", "America/Mexico_City"),("3996387", "Matehuala", "Матеуала", "MX", "484", "", "24", "020", "", "23.64824", "-100.64334", "America/Mexico_City"),("3996426", "Matamoros", "Матаморос", "MX", "484", "", "07", "017", "", "25.52699", "-103.2285", "America/Monterrey"),("3996472", "Mascota", "", "MX", "484", "", "14", "058", "", "20.52613", "-104.78781", "America/Mexico_City"),("3996585", "Jesús Gómez Portugal", "", "MX", "484", "", "01", "005", "", "21.99607", "-102.29095", "America/Mexico_City"),("3996595", "Marfil", "", "MX", "484", "", "11", "015", "", "20.99165", "-101.28434", "America/Mexico_City"),("3996626", "Maravatío de Ocampo", "", "MX", "484", "", "16", "050", "", "19.89113", "-100.44443", "America/Mexico_City"),("3996663", "Manzanillo", "Мансанильо", "MX", "484", "", "08", "007", "", "19.11695", "-104.34214", "America/Mexico_City"),("3996737", "Rodolfo Sánchez Taboada", "", "MX", "484", "", "02", "001", "", "31.72099", "-116.57184", "America/Tijuana"),("3996893", "Magdalena de Kino", "Магдалена-де-Кино", "MX", "484", "", "26", "036", "", "30.62789", "-110.96203", "America/Hermosillo"),("3996956", "San Pedro Madera", "", "MX", "484", "", "06", "040", "", "29.19366", "-108.14684", "America/Chihuahua"),("3997000", "Luvianos", "", "MX", "484", "", "15", "123", "", "18.91667", "-100.4", "America/Mexico_City"),("3997017", "Luis Moya", "", "MX", "484", "", "32", "025", "", "22.43237", "-102.24864", "America/Mexico_City"),("3997479", "Los Mochis", "Лос-Мочис", "MX", "484", "", "25", "001", "", "25.79302", "-108.99808", "America/Mazatlan"),("3998287", "Loreto", "", "MX", "484", "", "03", "009", "", "26.01217", "-111.34888", "America/Mazatlan"),("3998291", "Loreto", "", "MX", "484", "", "32", "024", "", "22.27248", "-101.98898", "America/Mexico_City"),("3998318", "Lombardía", "", "MX", "484", "", "16", "033", "", "19.15806", "-102.05111", "America/Mexico_City"),("3998655", "León de los Aldama", "", "MX", "484", "", "11", "020", "", "21.12908", "-101.67374", "America/Mexico_City"),("3998913", "La Unión", "", "MX", "484", "", "26", "033", "", "26.81961", "-109.60831", "America/Hermosillo"),("3999056", "La Tijera", "", "MX", "484", "", "14", "015", "", "19.9", "-104.4", "America/Mexico_City"),("3999162", "Las Varas", "", "MX", "484", "", "18", "004", "", "21.18021", "-105.13595", "America/Mazatlan"),("3999325", "Las Pintas de Arriba", "", "MX", "484", "", "14", "070", "", "20.57376", "-103.32345", "America/Mexico_City"),("3999741", "Las Juntas", "", "MX", "484", "", "14", "043", "", "19.43061", "-104.70646", "America/Mexico_City"),("4000490", "La Reforma", "", "MX", "484", "", "25", "002", "", "25.08164", "-108.05673", "America/Mazatlan"),("4000524", "Quesería", "", "MX", "484", "", "08", "005", "", "19.38708", "-103.57243", "America/Mexico_City"),("4000811", "La Pila", "", "MX", "484", "", "24", "028", "", "22.03425", "-100.86786", "America/Mexico_City"),("4000821", "La Piedad", "", "MX", "484", "", "16", "069", "", "20.34239", "-102.0305", "America/Mexico_City"),("4000900", "La Paz", "Ла-Пас", "MX", "484", "", "03", "003", "", "24.14437", "-110.3005", "America/Mazatlan"),("4001056", "La Orilla", "", "MX", "484", "", "16", "052", "", "17.99583", "-102.22694", "America/Mexico_City"),("4001240", "Lampazos de Naranjo", "", "MX", "484", "", "19", "032", "", "27.02549", "-100.50528", "America/Monterrey"),("4001325", "La Mira Tumbiscatio", "", "MX", "484", "", "16", "096", "", "18.68333", "-102.28333", "America/Mexico_City"),("4001597", "La Lira", "", "MX", "484", "", "22", "012", "", "20.47554", "-100.16145", "America/Mexico_City"),("4001947", "La Huerta", "", "MX", "484", "", "14", "043", "", "19.4844", "-104.64378", "America/Mexico_City"),("4001956", "La Huacana", "", "MX", "484", "", "16", "035", "", "18.96312", "-101.8072", "America/Mexico_City"),("4002224", "Lagos de Moreno", "", "MX", "484", "", "14", "053", "", "21.35666", "-101.93768", "America/Mexico_City"),("4002462", "La Estancia", "", "MX", "484", "", "22", "016", "", "20.42123", "-100.06616", "America/Mexico_City"),("4002745", "La Cruz", "", "MX", "484", "", "25", "008", "", "23.92126", "-106.8925", "America/Mazatlan"),("4003211", "La Cañada", "", "MX", "484", "", "22", "011", "", "20.60805", "-100.33275", "America/Mexico_City"),("4003270", "La Calera", "", "MX", "484", "", "11", "017", "", "20.80119", "-101.33207", "America/Mexico_City"),("4003526", "La Barca", "", "MX", "484", "", "14", "018", "", "20.28784", "-102.54514", "America/Mexico_City"),("4003574", "Puente Grande", "", "MX", "484", "", "14", "101", "", "20.56977", "-103.15377", "America/Mexico_City"),("4003618", "La Aldea", "", "MX", "484", "", "11", "037", "", "20.90166", "-101.47852", "America/Mexico_City"),("4003662", "Santa Cruz de Juventino Rosas", "", "MX", "484", "", "11", "035", "", "20.64337", "-100.99286", "America/Mexico_City"),("4003703", "Jungapeo de Juárez", "", "MX", "484", "", "16", "047", "", "19.45915", "-100.49483", "America/Mexico_City"),("4003739", "Juchipila", "", "MX", "484", "", "32", "023", "", "21.40862", "-103.11663", "America/Mexico_City"),("4003757", "Juárez", "", "MX", "484", "", "19", "031", "", "25.64724", "-100.09582", "America/Monterrey"),("4003804", "Juan Aldama", "", "MX", "484", "", "32", "022", "", "24.29188", "-103.39272", "America/Mexico_City"),("4003810", "Juanacatlán", "", "MX", "484", "", "14", "051", "", "20.50888", "-103.17025", "America/Mexico_City"),("4003908", "Jocotepec", "", "MX", "484", "", "14", "050", "", "20.28527", "-103.42897", "America/Mexico_City"),("4003923", "Jiquílpan de Juárez", "", "MX", "484", "", "16", "045", "", "19.99482", "-102.71969", "America/Mexico_City"),("4003938", "Jiménez", "", "MX", "484", "", "06", "045", "", "28.33333", "-105.4", "America/Chihuahua"),("4003995", "Jesús María", "", "MX", "484", "", "01", "005", "", "21.96111", "-102.34333", "America/Mexico_City"),("4004024", "Jerez de García Salinas", "Херес-де-Гарсия-Салинас", "MX", "484", "", "32", "020", "", "22.64862", "-102.99034", "America/Mexico_City"),("4004026", "Jerécuaro", "", "MX", "484", "", "11", "019", "", "20.15467", "-100.5086", "America/Mexico_City"),("4004092", "Jaral del Progreso", "", "MX", "484", "", "11", "018", "", "20.37237", "-101.06249", "America/Mexico_City"),("4004126", "Jamay", "", "MX", "484", "", "14", "047", "", "20.29349", "-102.70754", "America/Mexico_City"),("4004148", "Jalpa", "", "MX", "484", "", "32", "019", "", "21.63448", "-102.97919", "America/Mexico_City"),("4004153", "Jalostotitlán", "Халостотитлан", "MX", "484", "", "14", "046", "", "21.16741", "-102.46386", "America/Mexico_City"),("4004170", "Jala", "", "MX", "484", "", "18", "007", "", "21.10484", "-104.43764", "America/Mazatlan"),("4004267", "Ixtlán del Río", "", "MX", "484", "", "18", "006", "", "21.03907", "-104.37116", "America/Mazatlan"),("4004271", "Ixtlán de los Hervores", "", "MX", "484", "", "16", "042", "", "20.16895", "-102.3948", "America/Mexico_City"),("4004274", "Ixtlahuacán del Río", "", "MX", "484", "", "14", "045", "", "20.86405", "-103.24029", "America/Mexico_City"),("4004275", "Ixtlahuacán de los Membrillos", "", "MX", "484", "", "14", "044", "", "20.3486", "-103.19336", "America/Mexico_City"),("4004293", "Ixtapa", "", "MX", "484", "", "14", "067", "", "20.71641", "-105.20487", "America/Mexico_City"),("4004294", "Ixtapa", "", "MX", "484", "", "12", "038", "", "17.66782", "-101.64165", "America/Mexico_City"),("4004330", "Irapuato", "Ирапуато", "MX", "484", "", "11", "017", "", "20.67675", "-101.35628", "America/Mexico_City"),("4004331", "Irámuco", "", "MX", "484", "", "11", "002", "", "19.96156", "-100.92202", "America/Mexico_City"),("4004394", "Indaparapeo", "", "MX", "484", "", "16", "040", "", "19.78767", "-100.96907", "America/Mexico_City"),("4004399", "Imuris", "", "MX", "484", "", "26", "035", "", "30.78955", "-110.84596", "America/Hermosillo"),("4004555", "Huetamo de Núñez", "", "MX", "484", "", "16", "038", "", "18.62926", "-100.897", "America/Mexico_City"),("4004647", "Huatabampo", "Уатабампо", "MX", "484", "", "26", "033", "", "26.8261", "-109.6422", "America/Hermosillo"),("4004690", "Huandacareo", "", "MX", "484", "", "16", "036", "", "19.99136", "-101.2761", "America/Mexico_City"),("4004850", "Higuera de Zaragoza", "", "MX", "484", "", "25", "001", "", "25.96892", "-109.3042", "America/Mazatlan"),("4004867", "Parral", "", "MX", "484", "", "06", "032", "", "26.93022", "-105.6664", "America/Chihuahua"),("4004885", "Heróica Zitácuaro", "", "MX", "484", "", "16", "112", "", "19.43612", "-100.35733", "America/Mexico_City"),("4004886", "Nogales", "Ногалес", "MX", "484", "", "26", "043", "", "31.30862", "-110.94217", "America/Hermosillo"),("4004887", "Heroica Caborca", "", "MX", "484", "", "26", "017", "", "30.71825", "-112.15822", "America/Hermosillo"),("4004898", "Hermosillo", "Эрмосильо", "MX", "484", "", "26", "030", "", "29.1026", "-110.97732", "America/Hermosillo"),("4005143", "Heroica Guaymas", "Гуаймас", "MX", "484", "", "26", "029", "", "27.91928", "-110.89755", "America/Hermosillo"),("4005219", "Guasave", "", "MX", "484", "", "25", "011", "", "25.56745", "-108.46756", "America/Mazatlan"),("4005270", "Guanajuato", "Гуанахуато", "MX", "484", "", "11", "015", "", "21.01858", "-101.2591", "America/Mexico_City"),("4005297", "Guamúchil", "", "MX", "484", "", "25", "015", "", "25.4587", "-108.07732", "America/Mazatlan"),("4005380", "Guadalupe Victoria", "", "MX", "484", "", "10", "008", "", "24.44401", "-104.12156", "America/Monterrey"),("4005492", "Guadalupe", "Гвадалупе", "MX", "484", "", "19", "026", "", "25.67678", "-100.25646", "America/Monterrey"),("4005509", "Guadalupe", "Гвадалупе", "MX", "484", "", "32", "017", "", "22.74753", "-102.51874", "America/Mexico_City"),("4005539", "Guadalajara", "Гвадалахара", "MX", "484", "", "14", "039", "", "20.66682", "-103.39182", "America/Mexico_City"),("4005775", "Gomez Palacio", "", "MX", "484", "", "10", "007", "", "25.56985", "-103.49588", "America/Monterrey"),("4005856", "General Zuazua", "", "MX", "484", "", "19", "025", "", "25.89491", "-100.108", "America/Monterrey"),("4005857", "Vicente Guerrero", "", "MX", "484", "", "10", "038", "", "23.73429", "-103.98487", "America/Monterrey"),("4005864", "Juan José Ríos", "", "MX", "484", "", "25", "011", "", "25.75781", "-108.8242", "America/Mazatlan"),("4005867", "Ciudad General Escobedo", "", "MX", "484", "", "19", "021", "", "25.79698", "-100.31791", "America/Monterrey"),("4005937", "Garza García", "", "MX", "484", "", "19", "019", "", "25.65384", "-100.37758", "America/Monterrey"),("4006081", "Galeana", "", "MX", "484", "", "19", "017", "", "24.82455", "-100.07601", "America/Monterrey"),("4006163", "Fresnillo", "", "MX", "484", "", "32", "010", "", "23.18126", "-102.87136", "America/Mexico_City"),("4006337", "Felipe Carrillo Puerto", "", "MX", "484", "", "16", "012", "", "19.16325", "-102.70834", "America/Mexico_City"),("4006380", "Etzatlán", "", "MX", "484", "", "14", "036", "", "20.76839", "-104.07735", "America/Mexico_City"),("4006388", "Etchojoa", "", "MX", "484", "", "26", "026", "", "26.91094", "-109.6261", "America/Hermosillo"),("4006532", "Esqueda", "", "MX", "484", "", "26", "027", "", "30.72412", "-109.5893", "America/Hermosillo"),("4006622", "Escuinapa de Hidalgo", "", "MX", "484", "", "25", "009", "", "22.83253", "-105.77539", "America/Mazatlan"),("4006702", "Ensenada", "Энсенада", "MX", "484", "", "02", "001", "", "31.87149", "-116.60071", "America/Tijuana"),("4006783", "Encarnación de Díaz", "Энкарнасьон-де-Диас", "MX", "484", "", "14", "035", "", "21.52705", "-102.24013", "America/Mexico_City"),("4006804", "Empalme Escobedo", "", "MX", "484", "", "11", "009", "", "20.6725", "-100.74675", "America/Mexico_City"),("4006806", "Empalme", "", "MX", "484", "", "26", "025", "", "27.96166", "-110.81411", "America/Hermosillo"),("4006971", "El Verde", "", "MX", "484", "", "14", "070", "", "20.55567", "-103.27901", "America/Mexico_City"),("4007210", "El Tobarito", "", "MX", "484", "", "26", "018", "", "27.37057", "-109.89379", "America/Hermosillo"),("4007503", "El Sauzal", "", "MX", "484", "", "02", "001", "", "31.89329", "-116.69256", "America/Tijuana"),("4007554", "El Saúz", "", "MX", "484", "", "22", "012", "", "20.47774", "-100.1154", "America/Mexico_City"),("4007676", "Pueblo Nuevo", "Эль-Сальто", "MX", "484", "", "10", "023", "", "23.37927", "-105.38313", "America/Monterrey"),("4007684", "El Salto", "", "MX", "484", "", "14", "012", "", "20.33333", "-104.5", "America/Mexico_City"),("4007812", "El Rosario", "", "MX", "484", "", "25", "006", "", "24.25556", "-107.18278", "America/Mazatlan"),("4008080", "El Refugio", "", "MX", "484", "", "14", "083", "", "20.6714", "-103.73929", "America/Mexico_City"),("4008224", "El Quince", "", "MX", "484", "", "14", "070", "", "20.54387", "-103.28467", "America/Mexico_City"),("4008303", "El Pueblito", "", "MX", "484", "", "22", "006", "", "20.53972", "-100.44139", "America/Mexico_City"),("4008868", "El Oro de Hidalgo", "", "MX", "484", "", "15", "064", "", "19.80272", "-100.13081", "America/Mexico_City"),("4009697", "El Grullo", "", "MX", "484", "", "14", "037", "", "19.80603", "-104.21805", "America/Mexico_City"),("4009788", "El Fuerte de Montes Claros", "", "MX", "484", "", "25", "010", "", "26.41686", "-108.61828", "America/Mazatlan"),("4009984", "El Dorado", "", "MX", "484", "", "25", "006", "", "24.32283", "-107.36298", "America/Mazatlan"),("4010155", "Coyote", "", "MX", "484", "", "07", "017", "", "25.6951", "-103.2842", "America/Monterrey"),("4010273", "El Colomo", "", "MX", "484", "", "08", "007", "", "19.06101", "-104.25853", "America/Mexico_City"),("4010311", "El Coacoyul", "", "MX", "484", "", "12", "038", "", "17.6381", "-101.47571", "America/Mexico_City"),("4011119", "El Arenal", "", "MX", "484", "", "14", "009", "", "20.77538", "-103.69353", "America/Mexico_City"),("4011469", "Puebla", "", "MX", "484", "", "02", "002", "", "32.56654", "-115.3534", "America/Tijuana"),("4011574", "Ciudad Insurgentes", "", "MX", "484", "", "03", "001", "", "25.26345", "-111.77444", "America/Mazatlan"),("4011587", "Hermosillo", "", "MX", "484", "", "02", "002", "", "32.51097", "-114.92278", "America/Tijuana"),("4011703", "Ecuandureo", "", "MX", "484", "", "16", "030", "", "20.16188", "-102.1934", "America/Mexico_City"),("4011743", "Victoria de Durango", "Дуранго", "MX", "484", "", "10", "005", "", "24.02032", "-104.65756", "America/Monterrey"),("4011755", "Duarte", "", "MX", "484", "", "11", "020", "", "21.08712", "-101.52431", "America/Mexico_City"),("4011873", "Doctor Arroyo", "", "MX", "484", "", "19", "014", "", "23.67211", "-100.18134", "America/Monterrey"),("4012045", "Degollado", "", "MX", "484", "", "14", "033", "", "20.46702", "-102.14976", "America/Mexico_City"),("4012080", "San Miguel Cuyutlán", "", "MX", "484", "", "14", "097", "", "20.41633", "-103.38987", "America/Mexico_City"),("4012085", "Cutzamala de Pinzón", "", "MX", "484", "", "12", "027", "", "18.46783", "-100.58089", "America/Mexico_City"),("4012176", "Culiacán", "Кулиакан", "MX", "484", "", "25", "006", "", "24.79032", "-107.38782", "America/Mazatlan"),("4012194", "Cuitzeo del Porvenir", "", "MX", "484", "", "16", "020", "", "19.97025", "-101.1429", "America/Mexico_City"),("4012196", "Cuitzeo (La Estancia)", "", "MX", "484", "", "14", "066", "", "20.34278", "-102.78389", "America/Mexico_City"),("4012341", "Cuerámaro", "", "MX", "484", "", "11", "012", "", "20.62546", "-101.67242", "America/Mexico_City"),("4012344", "Cuencamé", "", "MX", "484", "", "10", "004", "", "24.87116", "-103.69731", "America/Monterrey"),("4012406", "Cuauhtémoc", "", "MX", "484", "", "06", "017", "", "28.40884", "-106.86319", "America/Chihuahua"),("4012408", "Cuauhtémoc", "", "MX", "484", "", "08", "005", "", "19.32861", "-103.60284", "America/Mexico_City"),("4012466", "Cuanajo", "", "MX", "484", "", "16", "066", "", "19.48485", "-101.50794", "America/Mexico_City"),("4012559", "El Crucero de Santa María", "", "MX", "484", "", "14", "077", "", "20.38317", "-103.86131", "America/Mexico_City"),("4012593", "Creel", "", "MX", "484", "", "06", "009", "", "27.75054", "-107.6352", "America/Chihuahua"),("4012606", "Coyula", "", "MX", "484", "", "14", "101", "", "20.63333", "-103.2", "America/Mexico_City"),("4012607", "Coyuca de Catalán", "", "MX", "484", "", "12", "022", "", "18.32614", "-100.69898", "America/Mexico_City"),("4012608", "Coyuca de Benítez", "", "MX", "484", "", "12", "021", "", "17.00895", "-100.08714", "America/Mexico_City"),("4012685", "Cotija de la Paz", "", "MX", "484", "", "16", "019", "", "19.80922", "-102.70198", "America/Mexico_City"),("4012693", "Villa de Costa Rica", "Коста-Рика", "MX", "484", "", "25", "006", "", "24.59167", "-107.38836", "America/Mazatlan"),("4012707", "Cosalá", "", "MX", "484", "", "25", "005", "", "24.41501", "-106.69073", "America/Mazatlan"),("4012721", "Cortazar", "Кортасар", "MX", "484", "", "11", "011", "", "20.48008", "-100.96067", "America/Mexico_City"),("4012905", "Coquimatlán", "", "MX", "484", "", "08", "004", "", "19.20625", "-103.80952", "America/Mexico_City"),("4012966", "La Constancia", "", "MX", "484", "", "25", "006", "", "24.22363", "-107.1861", "America/Mazatlan"),("4013024", "Concordia", "", "MX", "484", "", "07", "033", "", "25.77982", "-103.11696", "America/Monterrey"),("4013039", "Concepcion del Oro", "", "MX", "484", "", "32", "007", "", "24.61326", "-101.41844", "America/Mexico_City"),("4013085", "Compostela", "", "MX", "484", "", "18", "004", "", "21.23777", "-104.9001", "America/Mazatlan"),("4013094", "Comonfort", "Комонфорт", "MX", "484", "", "11", "009", "", "20.72278", "-100.75946", "America/Mexico_City"),("4013130", "Comala", "", "MX", "484", "", "08", "003", "", "19.32717", "-103.75926", "America/Mexico_City"),("4013136", "Colotlán", "", "MX", "484", "", "14", "025", "", "22.11299", "-103.26707", "America/Mexico_City"),("4013141", "Colorines", "", "MX", "484", "", "15", "110", "", "19.17829", "-100.21817", "America/Mexico_City"),("4013142", "Colorines", "", "MX", "484", "", "15", "110", "", "19.17639", "-100.21639", "America/Mexico_City"),("4013292", "Vicente Guerrero", "", "MX", "484", "", "02", "001", "", "30.73097", "-115.99071", "America/Tijuana"),("4013377", "Ampliación Colonia Lázaro Cárdenas", "", "MX", "484", "", "06", "045", "", "28.38333", "-105.61667", "America/Chihuahua"),("4013487", "Colón", "", "MX", "484", "", "22", "005", "", "20.78323", "-100.05149", "America/Mexico_City"),("4013516", "Colima", "Колима", "MX", "484", "", "08", "002", "", "19.24997", "-103.72714", "America/Mexico_City"),("4013522", "Cojumatlán de Régules", "", "MX", "484", "", "16", "074", "", "20.11858", "-102.85182", "America/Mexico_City"),("4013567", "Cofradía", "", "MX", "484", "", "08", "", "", "19.43333", "-103.55", "America/Mexico_City"),("4013579", "Cocula", "", "MX", "484", "", "14", "024", "", "20.36517", "-103.82215", "America/Mexico_City"),("4013593", "Cocorit", "", "MX", "484", "", "26", "018", "", "27.57519", "-109.9591", "America/Hermosillo"),("4013669", "Coalcomán de Vázquez Pallares", "", "MX", "484", "", "16", "015", "", "18.7775", "-103.16", "America/Mexico_City"),("4013679", "Coahuayana Viejo", "", "MX", "484", "", "16", "014", "", "18.75119", "-103.66798", "America/Mexico_City"),("4013704", "Ciudad Obregón", "Сьюдад-Обрегон", "MX", "484", "", "26", "018", "", "27.48642", "-109.94083", "America/Hermosillo"),("4013705", "Ciudad Manuel Doblado", "", "MX", "484", "", "11", "008", "", "20.72888", "-101.95226", "America/Mexico_City"),("4013706", "Ciudad Lerdo", "", "MX", "484", "", "07", "", "", "25.53718", "-103.52456", "America/Monterrey"),("4013708", "Ciudad Juárez", "Сьюдад-Хуарес", "MX", "484", "", "06", "037", "", "31.73333", "-106.48333", "America/Ojinaga"),("4013712", "Ciudad Hidalgo", "Сьюдад-Идальго", "MX", "484", "", "16", "034", "", "19.6927", "-100.55445", "America/Mexico_City"),("4013714", "Ciudad Guzmán", "Сьюдад-Гусман", "MX", "484", "", "14", "023", "", "19.70466", "-103.4617", "America/Mexico_City"),("4013720", "Ciudad Delicias", "Делисьяс", "MX", "484", "", "06", "021", "", "28.19013", "-105.47012", "America/Chihuahua"),("4013723", "Ciudad Constitución", "", "MX", "484", "", "03", "001", "", "25.0321", "-111.66256", "America/Mazatlan"),("4013724", "Ciudad Camargo", "", "MX", "484", "", "06", "011", "", "27.67842", "-105.17136", "America/Chihuahua"),("4013726", "Ciudad Anáhuac", "", "MX", "484", "", "19", "005", "", "27.24457", "-100.13229", "America/Matamoros"),("4013727", "Ciudad Altamirano", "Сьюдад-Альтамирано", "MX", "484", "", "12", "050", "", "18.3582", "-100.66965", "America/Mexico_City"),("4013728", "Ciudad Acuña", "", "MX", "484", "", "07", "002", "", "29.32322", "-100.95217", "America/Matamoros"),("4013892", "Ciénega de Flores", "", "MX", "484", "", "19", "012", "", "25.95467", "-100.16695", "America/Monterrey"),("4014109", "Choix", "", "MX", "484", "", "25", "007", "", "26.70901", "-108.32545", "America/Mazatlan"),("4014296", "Chilchota", "", "MX", "484", "", "15", "025", "", "19.84654", "-102.11716", "America/Mexico_City"),("4014338", "Chihuahua", "Чиуауа", "MX", "484", "", "06", "019", "", "28.63528", "-106.08889", "America/Chihuahua"),("4014409", "Cherán", "", "MX", "484", "", "16", "024", "", "19.68536", "-101.95368", "America/Mexico_City"),("4014420", "Chavinda", "", "MX", "484", "", "16", "023", "", "20.00625", "-102.46015", "America/Mexico_City"),("4014501", "Charcas", "", "MX", "484", "", "24", "015", "", "23.12943", "-101.11346", "America/Mexico_City"),("4014553", "Chapala", "", "MX", "484", "", "14", "030", "", "20.29616", "-103.19123", "America/Mexico_City"),("4014795", "Cerritos", "", "MX", "484", "", "24", "008", "", "22.42835", "-100.28474", "America/Mexico_City"),("4014842", "Cerano", "", "MX", "484", "", "11", "046", "", "20.10877", "-101.3871", "America/Mexico_City"),("4014875", "Celaya", "Селая", "MX", "484", "", "11", "007", "", "20.52353", "-100.8157", "America/Mexico_City"),("4015022", "Castaños", "", "MX", "484", "", "07", "006", "", "26.78932", "-101.43211", "America/Monterrey"),("4015040", "Casimiro Castillo", "", "MX", "484", "", "14", "021", "", "19.6052", "-104.43433", "America/Mexico_City"),("4015546", "Capilla de Guadalupe", "", "MX", "484", "", "14", "093", "", "20.82739", "-102.59185", "America/Mexico_City"),("4015566", "Capácuaro", "", "MX", "484", "", "16", "102", "", "19.54741", "-102.05184", "America/Mexico_City"),("4015633", "Cañitas de Felipe Pescador", "", "MX", "484", "", "32", "006", "", "23.60371", "-102.72704", "America/Mexico_City"),("4015683", "Canatlán", "", "MX", "484", "", "10", "001", "", "24.52576", "-104.77327", "America/Monterrey"),("4015700", "Cananea", "Кананеа", "MX", "484", "", "26", "019", "", "30.98699", "-110.29062", "America/Hermosillo"),("4015842", "Campo Sesenta", "", "MX", "484", "", "26", "012", "", "27.45", "-110.1", "America/Hermosillo"),("4015938", "Villa Juárez", "", "MX", "484", "", "25", "018", "", "24.65869", "-107.54059", "America/Mazatlan"),("4016086", "Calvillo", "", "MX", "484", "", "01", "003", "", "21.84583", "-102.71849", "America/Mexico_City"),("4016132", "Víctor Rosales", "", "MX", "484", "", "32", "005", "", "22.94889", "-102.70222", "America/Mexico_City"),("4016589", "Buenos Aires", "", "MX", "484", "", "16", "064", "", "19.07499", "-102.17999", "America/Mexico_City"),("4016599", "Buena Vista Tomatlán", "", "MX", "484", "", "16", "012", "", "19.21281", "-102.58735", "America/Mexico_City"),("4016722", "Buenaventura", "", "MX", "484", "", "06", "010", "", "29.8432", "-107.46067", "America/Chihuahua"),("4016734", "Bucerías", "", "MX", "484", "", "18", "020", "", "20.75626", "-105.33438", "America/Bahia_Banderas"),("4017144", "Bermejillo", "", "MX", "484", "", "10", "013", "", "25.88682", "-103.62069", "America/Monterrey"),("4017152", "Benjamin Hill", "", "MX", "484", "", "26", "016", "", "30.16904", "-111.11403", "America/Hermosillo"),("4017154", "Benito Juárez", "", "MX", "484", "", "06", "034", "", "29.74624", "-107.93966", "America/Chihuahua"),("4017199", "Bellavista", "", "MX", "484", "", "14", "002", "", "20.43408", "-103.63742", "America/Mexico_City"),("4017728", "Bahía de Kino", "", "MX", "484", "", "26", "030", "", "28.82278", "-111.94083", "America/Hermosillo"),("4017924", "Ayutla", "", "MX", "484", "", "14", "017", "", "20.12907", "-104.34355", "America/Mexico_City"),("4017957", "Autlán de Navarro", "", "MX", "484", "", "14", "015", "", "19.76822", "-104.36664", "America/Mexico_City"),("4017984", "Atoyac de Álvarez", "Атояк-де-Альварес", "MX", "484", "", "12", "011", "", "17.20667", "-100.43306", "America/Mexico_City"),("4017987", "Atoyac", "", "MX", "484", "", "14", "014", "", "20.0097", "-103.51652", "America/Mexico_City"),("4017990", "Atotonilquillo", "", "MX", "484", "", "14", "030", "", "20.39287", "-103.12356", "America/Mexico_City"),("4017992", "Atotonilco el Alto", "", "MX", "484", "", "14", "013", "", "20.55079", "-102.50942", "America/Mexico_City"),("4018027", "Atequiza", "", "MX", "484", "", "14", "044", "", "20.39006", "-103.14065", "America/Mexico_City"),("4018109", "Ascención", "", "MX", "484", "", "06", "005", "", "31.1", "-107.98333", "America/Chihuahua"),("4018127", "Arteaga", "", "MX", "484", "", "07", "004", "", "25.44528", "-100.84667", "America/Monterrey"),("4018128", "Arteaga", "", "MX", "484", "", "16", "010", "", "18.35779", "-102.29122", "America/Mexico_City"),("4018227", "Armeria", "", "MX", "484", "", "08", "001", "", "18.9378", "-103.96417", "America/Mexico_City"),("4018254", "Ario de Rosales", "", "MX", "484", "", "16", "009", "", "19.209", "-101.70743", "America/Mexico_City"),("4018255", "Ario de Rayón", "", "MX", "484", "", "16", "108", "", "20.02651", "-102.34814", "America/Mexico_City"),("4018320", "Arcelia", "", "MX", "484", "", "12", "007", "", "18.31847", "-100.28148", "America/Mexico_City"),("4018348", "Arandas", "", "MX", "484", "", "14", "008", "", "20.70519", "-102.34635", "America/Mexico_City"),("4018390", "Ciudad Apodaca", "Аподака", "MX", "484", "", "19", "006", "", "25.78195", "-100.18839", "America/Monterrey"),("4018400", "Apatzingán", "", "MX", "484", "", "16", "006", "", "19.08864", "-102.35704", "America/Mexico_City"),("4018403", "Apaseo el Grande", "Апасео-эль-Гранде", "MX", "484", "", "11", "005", "", "20.54495", "-100.68462", "America/Mexico_City"),("4018404", "Apaseo el Alto", "Апасео-эль-Альто", "MX", "484", "", "11", "004", "", "20.45798", "-100.62081", "America/Mexico_City"),("4018430", "Antúnez", "", "MX", "484", "", "16", "064", "", "19.01451", "-102.20432", "America/Mexico_City"),("4018435", "Antonio Escobedo", "", "MX", "484", "", "14", "007", "", "20.8", "-104.01667", "America/Mexico_City"),("4018518", "Angamacutiro de la Unión", "", "MX", "484", "", "16", "004", "", "20.14998", "-101.71113", "America/Mexico_City"),("4018543", "Anáhuac", "", "MX", "484", "", "06", "017", "", "28.48396", "-106.7472", "America/Chihuahua"),("4018582", "Ameca", "", "MX", "484", "", "14", "006", "", "20.54629", "-104.04508", "America/Mexico_City"),("4018584", "Amealco", "", "MX", "484", "", "22", "001", "", "20.18758", "-100.14485", "America/Mexico_City"),("4018597", "Amatitán", "", "MX", "484", "", "14", "005", "", "20.83388", "-103.73076", "America/Mexico_City"),("4018625", "Amanalco de Becerra", "", "MX", "484", "", "15", "111", "", "19.31667", "-100.01667", "America/Mexico_City"),("4018648", "Álvaro Obregón", "", "MX", "484", "", "16", "003", "", "19.82096", "-101.04008", "America/Mexico_City"),("4018700", "Altar", "", "MX", "484", "", "26", "004", "", "30.71626", "-111.83653", "America/Hermosillo"),("4018761", "Allende", "", "MX", "484", "", "07", "003", "", "28.34124", "-100.85111", "America/Monterrey"),("4018762", "Allende", "", "MX", "484", "", "19", "004", "", "25.27673", "-100.01442", "America/Monterrey"),("4018904", "Alamos", "", "MX", "484", "", "26", "003", "", "27.02326", "-108.9344", "America/Hermosillo"),("4019039", "Ajuchitlán del Progreso", "", "MX", "484", "", "12", "003", "", "18.15189", "-100.48353", "America/Mexico_City"),("4019054", "Ajijic", "", "MX", "484", "", "14", "030", "", "20.30325", "-103.25476", "America/Mexico_City"),("4019082", "Ahualulco de Mercado", "", "MX", "484", "", "14", "003", "", "20.70137", "-103.97461", "America/Mexico_City"),("4019089", "Ahuacatlán", "", "MX", "484", "", "18", "002", "", "21.05405", "-104.48398", "America/Mazatlan"),("4019098", "Ahome", "", "MX", "484", "", "25", "001", "", "25.91985", "-109.1732", "America/Mazatlan"),("4019152", "Aguililla", "", "MX", "484", "", "16", "002", "", "18.73742", "-102.78934", "America/Mexico_City"),("4019233", "Aguascalientes", "Агуаскальентес", "MX", "484", "", "01", "001", "", "21.88234", "-102.28259", "America/Mexico_City"),("4019260", "Agua Prieta", "", "MX", "484", "", "26", "002", "", "31.33071", "-109.54876", "America/Hermosillo"),("4019727", "Adolfo Ruíz Cortínes", "", "MX", "484", "", "25", "011", "", "25.75", "-108.75", "America/Mazatlan"),("4019757", "Acuítzio del Canje", "", "MX", "484", "", "16", "001", "", "19.49585", "-101.33321", "America/Mexico_City"),("4019807", "Acatic", "", "MX", "484", "", "14", "001", "", "20.77995", "-102.91056", "America/Mexico_City"),("4019819", "Acaponeta", "", "MX", "484", "", "18", "001", "", "22.49396", "-105.36369", "America/Mazatlan"),("4019827", "Acámbaro", "Акамбаро", "MX", "484", "", "11", "002", "", "20.03024", "-100.72249", "America/Mexico_City"),("4019869", "Abasolo", "Абасоло", "MX", "484", "", "11", "001", "", "20.44997", "-101.53073", "America/Mexico_City"),("4021296", "Jesús Gómez Portugal (Margaritas)", "", "MX", "484", "", "01", "005", "", "21.99917", "-102.29139", "America/Mexico_City"),("4022908", "Anáhuac", "", "MX", "484", "", "19", "005", "", "27.24056", "-100.13222", "America/Matamoros"),("4022983", "Doctor Mora", "", "MX", "484", "", "11", "013", "", "21.14246", "-100.31966", "America/Mexico_City"),("4023117", "Dolores Hidalgo Cuna de la Independencia Nacional", "", "MX", "484", "", "11", "014", "", "21.15611", "-100.9325", "America/Mexico_City"),("4024263", "Sarabia", "", "MX", "484", "", "11", "044", "", "20.52256", "-101.06163", "America/Mexico_City"),("4024264", "Mexicanos", "", "MX", "484", "", "11", "044", "", "20.52903", "-101.07064", "America/Mexico_City"),("4025340", "Tancítaro", "", "MX", "484", "", "16", "083", "", "19.3375", "-102.36306", "America/Mexico_City"),("4026075", "Guacamayas", "", "MX", "484", "", "16", "052", "", "18.01932", "-102.21225", "America/Mexico_City"),("4026082", "Ciudad Lázaro Cárdenas", "", "MX", "484", "", "16", "052", "", "17.97066", "-102.22124", "America/Mexico_City"),("4026954", "San José Ixtapa (Barrio Viejo)", "", "MX", "484", "", "12", "038", "", "17.70222", "-101.61944", "America/Mexico_City"),("4029337", "Las Jarretaderas", "", "MX", "484", "", "18", "020", "", "20.6925", "-105.27389", "America/Mazatlan"),("7280708", "Colonia del Valle", "", "MX", "484", "", "09", "014", "", "19.38611", "-99.16204", "America/Mexico_City"),("7280711", "Colonia Lindavista", "", "MX", "484", "", "15", "", "", "19.49156", "-99.12475", "America/Mexico_City"),("7280712", "Col. Bosques de las Lomas", "", "MX", "484", "", "09", "004", "", "19.37893", "-99.26587", "America/Mexico_City"),("7280718", "Colonia Nativitas", "", "MX", "484", "", "09", "014", "", "19.38119", "-99.13685", "America/Mexico_City"),("8599025", "San Luis", "", "MX", "484", "", "02", "004", "", "32.43167", "-116.95361", "America/Tijuana"),("8599061", "Las Delicias", "", "MX", "484", "", "02", "004", "", "32.40889", "-116.94361", "America/Tijuana"),("8617692", "San Pedro Garza Garcia", "", "MX", "484", "", "19", "019", "", "25.65716", "-100.40268", "America/Monterrey"),("8669542", "Estación Santa Engracia", "", "MX", "484", "", "28", "016", "", "24.01528", "-99.20194", "America/Monterrey"),("8708781", "Ponciano Arriaga", "", "MX", "484", "", "24", "016", "", "22.26222", "-98.58972", "America/Mexico_City"),("8770088", "Bacobampo", "", "MX", "484", "", "26", "026", "", "26.98278", "-109.65194", "America/Hermosillo"),("8858078", "Soledad de Graciano Sánchez", "", "MX", "484", "", "24", "035", "", "22.18306", "-100.94083", "America/Mexico_City"),("8858079", "Manzanillo", "", "MX", "484", "", "08", "007", "", "19.05222", "-104.31583", "America/Mexico_City"),("8858082", "Naucalpan de Juárez", "", "MX", "484", "", "15", "037", "", "19.39694", "-99.27667", "America/Mexico_City"),("8858085", "Hacienda Santa Fe", "", "MX", "484", "", "14", "097", "", "20.51806", "-103.38056", "America/Mexico_City"),("8858086", "Fuentes del Valle", "", "MX", "484", "", "15", "109", "", "19.6325", "-99.13861", "America/Mexico_City"),("8858087", "San Salvador Tizatlalli", "", "MX", "484", "", "15", "054", "", "19.26028", "-99.59083", "America/Mexico_City"),("8858088", "Jardines de la Silla (Jardines)", "", "MX", "484", "", "19", "031", "", "25.62944", "-100.18778", "America/Monterrey"),("8858089", "San Buenaventura", "", "MX", "484", "", "15", "039", "", "19.3025", "-98.86306", "America/Mexico_City"),("8858090", "Colonia Santa Teresa", "", "MX", "484", "", "15", "035", "", "19.845", "-99.23333", "America/Mexico_City"),("8858091", "San Jerónimo Cuatro Vientos", "", "MX", "484", "", "15", "039", "", "19.29306", "-98.84167", "America/Mexico_City"),("8858092", "San Martín Azcatepec", "", "MX", "484", "", "15", "081", "", "19.68667", "-98.97278", "America/Mexico_City"),("8858093", "Fraccionamiento Real Palmas", "", "MX", "484", "", "19", "025", "", "25.90417", "-100.15972", "America/Monterrey"),("8858094", "Pórticos de San Antonio", "", "MX", "484", "", "02", "004", "", "32.4425", "-117.03417", "America/Tijuana"),("8858095", "San Isidro", "", "MX", "484", "", "15", "070", "", "19.33972", "-98.95056", "America/Mexico_City"),("8858096", "Centro Familiar la Soledad", "", "MX", "484", "", "11", "020", "", "21.135", "-101.74972", "America/Mexico_City"),("8858097", "San José Guadalupe Otzacatipan", "", "MX", "484", "", "15", "106", "", "19.34472", "-99.59194", "America/Mexico_City"),("8858098", "Las Pintitas", "", "MX", "484", "", "14", "070", "", "20.56444", "-103.30222", "America/Mexico_City"),("8858099", "Emiliano Zapata", "", "MX", "484", "", "15", "070", "", "19.34361", "-98.97472", "America/Mexico_City"),("8858100", "San Antonio Tecómitl", "", "MX", "484", "", "09", "009", "", "19.21778", "-98.98806", "America/Mexico_City"),("8858101", "Licenciado Benito Juárez (Campo Gobierno)", "", "MX", "484", "", "25", "018", "", "24.65667", "-107.545", "America/Mazatlan"),("8858102", "Teotihuacán de Arista", "", "MX", "484", "", "15", "092", "", "19.68972", "-98.86083", "America/Mexico_City"),("8858103", "Jesús del Monte", "", "MX", "484", "", "15", "037", "", "19.375", "-99.29444", "America/Mexico_City"),("8858104", "San Jorge Pueblo Nuevo", "", "MX", "484", "", "15", "054", "", "19.25417", "-99.62778", "America/Mexico_City"),("8858105", "Manuel Ojinaga", "", "MX", "484", "", "06", "052", "", "29.56444", "-104.41639", "America/Ojinaga"),("8858106", "Terrazas del Valle", "", "MX", "484", "", "02", "004", "", "32.4875", "-116.82667", "America/Tijuana"),("8858107", "La Ermita", "", "MX", "484", "", "11", "020", "", "21.15194", "-101.73306", "America/Mexico_City"),("8858108", "Lomas del Sur", "", "MX", "484", "", "14", "097", "", "20.4925", "-103.4175", "America/Mexico_City"),("8858109", "Parque Industrial Ciudad Mitras", "", "MX", "484", "", "19", "018", "", "25.78861", "-100.44778", "America/Monterrey"),("8858110", "Mitras Poniente", "", "MX", "484", "", "19", "018", "", "25.77583", "-100.42583", "America/Monterrey"),("8858111", "Villa del Prado 2da Sección", "", "MX", "484", "", "02", "004", "", "32.42389", "-116.97167", "America/Tijuana"),("8858112", "Tres de Mayo", "", "MX", "484", "", "17", "008", "", "18.86861", "-99.20833", "America/Mexico_City"),("8858113", "Don Antonio", "", "MX", "484", "", "13", "069", "", "19.87444", "-98.93472", "America/Mexico_City"),("8858114", "Heroica Ciudad de Tlaxiaco", "", "MX", "484", "", "20", "397", "", "17.26944", "-97.67917", "America/Mexico_City"),("8858115", "Ciudad de Huitzuco", "", "MX", "484", "", "12", "034", "", "18.30111", "-99.33111", "America/Mexico_City"),("8858116", "Casa Blanca", "", "MX", "484", "", "21", "015", "", "19.04222", "-98.11889", "America/Mexico_City"),("8858117", "La Providencia Siglo XXI", "", "MX", "484", "", "13", "051", "", "20.06417", "-98.71722", "America/Mexico_City"),("8858118", "Ampliación San Mateo (Colonia Solidaridad)", "", "MX", "484", "", "15", "109", "", "19.61639", "-99.14722", "America/Mexico_City"),("8858119", "Fraccionamiento Ciudad Olmeca", "", "MX", "484", "", "30", "039", "", "18.15056", "-94.5525", "America/Mexico_City"),("8858120", "San Rafael Tlanalapan", "", "MX", "484", "", "21", "132", "", "19.29167", "-98.46806", "America/Mexico_City"),("8858121", "Tecámac de Felipe Villanueva", "", "MX", "484", "", "15", "081", "", "19.71306", "-98.96833", "America/Mexico_City"),("8858122", "Venceremos", "", "MX", "484", "", "22", "006", "", "20.55083", "-100.39806", "America/Mexico_City"),("8858123", "Alborada Jaltenco", "", "MX", "484", "", "15", "044", "", "19.66194", "-99.06889", "America/Mexico_City"),("8858124", "Crucecita", "", "MX", "484", "", "20", "413", "", "15.76889", "-96.135", "America/Mexico_City"),("8858125", "Progreso", "", "MX", "484", "", "17", "011", "", "18.88008", "-99.1526", "America/Mexico_City"),("8858126", "Santa Clara del Cobre", "", "MX", "484", "", "16", "079", "", "19.40528", "-101.63833", "America/Mexico_City"),("8858127", "Palmira", "", "MX", "484", "", "30", "101", "", "18.88278", "-97.11139", "America/Mexico_City"),("8858128", "Villa de El Carmen Tequexquitla", "", "MX", "484", "", "29", "007", "", "19.32444", "-97.65583", "America/Mexico_City"),("8858129", "Real del Valle (El Paraíso) [Fraccionamiento]", "", "MX", "484", "", "14", "097", "", "20.54556", "-103.36972", "America/Mexico_City"),("8858130", "Villa del Campo", "", "MX", "484", "", "02", "004", "", "32.5075", "-116.73833", "America/Tijuana"),("8858131", "Vicente Guerrero", "", "MX", "484", "", "20", "565", "", "16.93306", "-96.70139", "America/Mexico_City"),("8858132", "Morelos", "", "MX", "484", "", "16", "053", "", "19.64889", "-101.23889", "America/Mexico_City"),("8858133", "Centro de Readaptación Social", "", "MX", "484", "", "14", "101", "", "20.55444", "-103.19361", "America/Mexico_City"),("8858134", "Veintidós de Febrero", "", "MX", "484", "", "15", "060", "", "19.61139", "-99.34667", "America/Mexico_City"),("8858135", "Fraccionamiento Geovillas los Pinos", "", "MX", "484", "", "30", "193", "", "19.21722", "-96.22639", "America/Mexico_City"),("8858136", "Juan Morales", "", "MX", "484", "", "17", "030", "", "18.81139", "-98.92194", "America/Mexico_City"),("8858137", "Santa María Zacatepec", "", "MX", "484", "", "21", "090", "", "19.12333", "-98.36528", "America/Mexico_City"),("8858138", "La Tijera", "", "MX", "484", "", "14", "097", "", "20.58167", "-103.44056", "America/Mexico_City"),("8858139", "Lomas de San Agustín", "", "MX", "484", "", "14", "097", "", "20.5275", "-103.46778", "America/Mexico_City"),("8858140", "Córdoba (Santa Leticia)", "", "MX", "484", "", "30", "068", "", "18.90861", "-96.97889", "America/Mexico_City"),("8858141", "Las Palmas", "", "MX", "484", "", "03", "008", "", "22.93672", "-109.94235", "America/Mazatlan"),("8858142", "San Francisco Tecoxpa", "", "MX", "484", "", "09", "009", "", "19.19167", "-99.00639", "America/Mexico_City"),("8858143", "La Resolana", "", "MX", "484", "", "14", "021", "", "19.60361", "-104.43472", "America/Mexico_City"),("8858144", "Villas de la Hacienda [Fraccionamiento]", "", "MX", "484", "", "14", "097", "", "20.53111", "-103.38278", "America/Mexico_City"),("8858150", "Conjunto Habitacional Villas del Pedregal", "", "MX", "484", "", "16", "053", "", "19.68361", "-101.30361", "America/Mexico_City"),("8858151", "Pomoca", "", "MX", "484", "", "27", "013", "", "18.04972", "-92.93056", "America/Mexico_City"),("8858152", "Simojovel de Allende", "", "MX", "484", "", "05", "081", "", "17.14", "-92.715", "America/Mexico_City"),("8858153", "Puerto Escondido (Tepeolulco Puerto Escondido)", "", "MX", "484", "", "15", "104", "", "19.55194", "-99.09806", "America/Mexico_City"),("8858154", "Unidad Habitacional José María Morelos y Pavón", "", "MX", "484", "", "17", "028", "", "18.82028", "-99.26222", "America/Mexico_City"),("8858155", "Nueva Palestina", "", "MX", "484", "", "05", "059", "", "16.81722", "-91.26", "America/Mexico_City"),("8858156", "Las Veredas", "", "MX", "484", "", "03", "008", "", "23.15028", "-109.70611", "America/Mazatlan"),("8858157", "Profesor Carlos Hank González", "", "MX", "484", "", "15", "070", "", "19.37222", "-98.93889", "America/Mexico_City"),("8858158", "Fraccionamiento la Trinidad", "", "MX", "484", "", "15", "120", "", "19.82917", "-99.08278", "America/Mexico_City"),("8858159", "Santa Cruz Amilpas", "", "MX", "484", "", "20", "375", "", "17.05833", "-96.68333", "America/Mexico_City"),("8858160", "Paseos de San Juan", "", "MX", "484", "", "15", "120", "", "19.78194", "-99.0175", "America/Mexico_City"),("8858161", "Valle Dorado Inn", "", "MX", "484", "", "14", "097", "", "20.52444", "-103.36194", "America/Mexico_City"),("8858162", "Buenos Aires", "", "MX", "484", "", "16", "052", "", "18.02444", "-102.28583", "America/Mexico_City"),("8858163", "General Ángel Flores (La Palma)", "", "MX", "484", "", "25", "018", "", "24.81917", "-107.65667", "America/Mazatlan"),("8858164", "Brisas de Zicatela", "", "MX", "484", "", "20", "401", "", "15.83694", "-97.04194", "America/Mexico_City"),("8858165", "San Antonio del Coyote", "", "MX", "484", "", "07", "017", "", "25.69444", "-103.28556", "America/Monterrey"),("8858166", "Jorge Jiménez Cantú", "", "MX", "484", "", "15", "039", "", "19.30972", "-98.84667", "America/Mexico_City"),("8858167", "Galaxia Bonito Jalisco", "", "MX", "484", "", "14", "070", "", "20.505", "-103.20472", "America/Mexico_City"),("8858168", "Antúnez (Morelos)", "", "MX", "484", "", "16", "064", "", "19.01278", "-102.20389", "America/Mexico_City"),("8858169", "La Alameda", "", "MX", "484", "", "14", "097", "", "20.49528", "-103.24833", "America/Mexico_City"),("8858170", "El Niño", "", "MX", "484", "", "02", "004", "", "32.5075", "-116.79194", "America/Tijuana"),("8858171", "Fraccionamiento Lomas de Ahuatlán", "", "MX", "484", "", "17", "007", "", "18.95444", "-99.25722", "America/Mexico_City"),("8858172", "Lomas de Barrillas", "", "MX", "484", "", "30", "039", "", "18.14806", "-94.52639", "America/Mexico_City"),("8858173", "Marte R. Gómez (Tobarito)", "", "MX", "484", "", "26", "018", "", "27.36778", "-109.88583", "America/Hermosillo"),("8858174", "Fraccionamiento Misión del Valle", "", "MX", "484", "", "16", "053", "", "19.76556", "-101.12167", "America/Mexico_City"),("8858175", "Colonia Santa Bárbara", "", "MX", "484", "", "30", "087", "", "19.50191", "-96.87817", "America/Mexico_City"),("8858176", "Bosque de Saloya", "", "MX", "484", "", "27", "013", "", "18.01611", "-92.95806", "America/Mexico_City"),("8858177", "San Lucas el Grande", "", "MX", "484", "", "21", "143", "", "19.30583", "-98.47833", "America/Mexico_City"),("8858178", "San Andrés Azumiatla", "", "MX", "484", "", "21", "114", "", "18.90417", "-98.25278", "America/Mexico_City"),("8858179", "Rancho Alegre [Fraccionamiento]", "", "MX", "484", "", "14", "097", "", "20.47361", "-103.25778", "America/Mexico_City"),("8858180", "Ex-Rancho San Dimas", "", "MX", "484", "", "15", "073", "", "19.17389", "-99.56528", "America/Mexico_City"),("8858181", "Jacarandas", "", "MX", "484", "", "30", "065", "", "19.49556", "-96.85278", "America/Mexico_City"),("8858182", "El Pino", "", "MX", "484", "", "15", "070", "", "19.35139", "-98.94833", "America/Mexico_City"),("8858183", "Unión y Progreso", "", "MX", "484", "", "30", "081", "", "18.87278", "-97.11917", "America/Mexico_City"),("8858184", "Misión San Pablo", "", "MX", "484", "", "19", "006", "", "25.74", "-100.14417", "America/Monterrey"),("8858185", "Tenextepango", "", "MX", "484", "", "17", "004", "", "18.72889", "-98.95778", "America/Mexico_City"),("8858186", "Ejido San Lorenzo Cuauhtenco", "", "MX", "484", "", "15", "118", "", "19.30139", "-99.75028", "America/Mexico_City"),("8858187", "Santa Catarina Ayometla", "", "MX", "484", "", "29", "058", "", "19.19833", "-98.21361", "America/Mexico_City"),("8858188", "El Espinal", "", "MX", "484", "", "20", "030", "", "16.48472", "-95.04167", "America/Mexico_City"),("8858189", "Cuichapa", "", "MX", "484", "", "30", "111", "", "17.93889", "-94.28", "America/Mexico_City"),("8858190", "La Selva", "", "MX", "484", "", "27", "013", "", "18.02333", "-92.96306", "America/Mexico_City"),("8858191", "Los Olivos", "", "MX", "484", "", "14", "044", "", "20.43917", "-103.23778", "America/Mexico_City"),("8858192", "Villa Luvianos", "", "MX", "484", "", "15", "123", "", "18.92", "-100.29833", "America/Mexico_City"),("8858193", "Los Ruiseñores", "", "MX", "484", "", "14", "083", "", "20.71083", "-103.69139", "America/Mexico_City"),("8858194", "Barrio de México", "", "MX", "484", "", "15", "118", "", "19.2825", "-99.82833", "America/Mexico_City"),("8858195", "Tenango de las Flores", "", "MX", "484", "", "21", "071", "", "20.20583", "-97.98806", "America/Mexico_City"),("8858196", "Independencia", "", "MX", "484", "", "17", "011", "", "18.87716", "-99.12237", "America/Mexico_City"),("8858197", "Maclovio Rojas", "", "MX", "484", "", "02", "004", "", "32.47306", "-116.80278", "America/Tijuana"),("8858198", "San Sebastián del Sur", "", "MX", "484", "", "14", "079", "", "19.79444", "-103.47306", "America/Mexico_City"),("8858199", "Chiconcuac", "", "MX", "484", "", "17", "028", "", "18.78278", "-99.20722", "America/Mexico_City"),("8858200", "Chanal", "", "MX", "484", "", "05", "024", "", "16.6575", "-92.2575", "America/Mexico_City"),("8858201", "El Súchil", "", "MX", "484", "", "12", "057", "", "17.22694", "-100.63917", "America/Mexico_City"),("8858202", "El Campanario y Oradel", "", "MX", "484", "", "28", "027", "", "27.47306", "-99.62", "America/Matamoros"),("8858203", "El Diez", "", "MX", "484", "", "25", "006", "", "24.72389", "-107.45194", "America/Mazatlan"),("8858204", "Villa Alberto Andrés Alvarado Arámburo", "", "MX", "484", "", "03", "002", "", "27.64444", "-113.38472", "America/Mazatlan"),("8858205", "San Antonio Mihuacán", "", "MX", "484", "", "21", "034", "", "19.15333", "-98.30472", "America/Mexico_City"),("8858206", "Raudales Malpaso", "", "MX", "484", "", "05", "092", "", "17.18833", "-93.60583", "America/Mexico_City"),("8858207", "San Nicolás Tolentino", "", "MX", "484", "", "15", "106", "", "19.35889", "-99.57167", "America/Mexico_City"),("8858208", "Santa Cruz del Monte", "", "MX", "484", "", "15", "095", "", "19.76702", "-99.22867", "America/Mexico_City"),("8858209", "Arenal", "", "MX", "484", "", "15", "070", "", "19.38111", "-98.94278", "America/Mexico_City"),("8858210", "San Juan Huactzinco", "", "MX", "484", "", "29", "053", "", "19.23222", "-98.2525", "America/Mexico_City"),("8858211", "San Sebastián de Aparicio", "", "MX", "484", "", "21", "114", "", "19.10333", "-98.16083", "America/Mexico_City"),("8858212", "Fraccionamiento Colinas del Sol", "", "MX", "484", "", "15", "005", "", "19.37222", "-99.74028", "America/Mexico_City"),("8858213", "La Pradera", "", "MX", "484", "", "22", "011", "", "20.65889", "-100.34222", "America/Mexico_City"),("8858214", "Lomas de Santa Anita", "", "MX", "484", "", "02", "003", "", "32.54278", "-116.65139", "America/Tijuana"),("8858215", "Benito García (El Zorrillo)", "", "MX", "484", "", "02", "001", "", "31.67111", "-116.51139", "America/Tijuana"),("8858216", "Lomas Verdes", "", "MX", "484", "", "30", "087", "", "19.50446", "-96.88899", "America/Mexico_City"),("8858217", "Vida Mejor I", "", "MX", "484", "", "05", "089", "", "14.86972", "-92.30778", "America/Mexico_City"),("8858218", "La Constitución Toltepec", "", "MX", "484", "", "15", "106", "", "19.34861", "-99.54917", "America/Mexico_City"),("8858219", "Kilómetro 30", "", "MX", "484", "", "12", "001", "", "16.99778", "-99.78", "America/Mexico_City"),("8858220", "San Bartolomé Atlatlahuca", "", "MX", "484", "", "15", "090", "", "19.06861", "-99.61111", "America/Mexico_City"),("8858221", "Fraccionamiento los Ángeles", "", "MX", "484", "", "25", "012", "", "23.18833", "-106.33", "America/Mazatlan"),("8858222", "Rincón de Nicolás Romero (Cedros Tercera Manzana)", "", "MX", "484", "", "16", "112", "", "19.41361", "-100.2975", "America/Mexico_City"),("8858223", "Campestre Villas del Álamo", "", "MX", "484", "", "13", "051", "", "20.10167", "-98.70722", "America/Mexico_City"),("8858224", "Conjunto Urbano la Loma I", "", "MX", "484", "", "15", "118", "", "19.32639", "-99.73194", "America/Mexico_City"),("8858225", "Javier Rojo Gómez", "", "MX", "484", "", "13", "077", "", "20.06972", "-98.41778", "America/Mexico_City"),("8858226", "Emiliano Zapata", "", "MX", "484", "", "19", "045", "", "25.91028", "-100.28056", "America/Monterrey"),("8858227", "Parque Urbano Napateco", "", "MX", "484", "", "13", "077", "", "20.14278", "-98.34083", "America/Mexico_City"),("8858228", "La Aldea", "", "MX", "484", "", "16", "053", "", "19.74306", "-101.135", "America/Mexico_City"),("8858229", "Guadalupe Victoria", "", "MX", "484", "", "30", "182", "", "19.55472", "-96.96056", "America/Mexico_City"),("8858230", "El Cóporo", "", "MX", "484", "", "15", "118", "", "19.28306", "-99.83528", "America/Mexico_City"),("8858231", "Fraccionamiento Arboledas San Ramón", "", "MX", "484", "", "30", "105", "", "19.09417", "-96.15667", "America/Mexico_City"),("8858232", "Fraccionamiento Galaxia Tarímbaro", "", "MX", "484", "", "16", "088", "", "19.76167", "-101.19444", "America/Mexico_City"),("8858233", "Real del Sol", "", "MX", "484", "", "19", "012", "", "25.93833", "-100.18111", "America/Monterrey"),("8858234", "Fraccionamiento Metrópolis II", "", "MX", "484", "", "16", "088", "", "19.75639", "-101.20444", "America/Mexico_City"),("8858235", "Ciudad de Cuetzalan", "", "MX", "484", "", "21", "043", "", "20.01861", "-97.52111", "America/Mexico_City"),("8858236", "Colinas del Roble", "", "MX", "484", "", "14", "097", "", "20.50417", "-103.39833", "America/Mexico_City"),("8858237", "Granjas Ampliación Santa Rosa", "", "MX", "484", "", "15", "011", "", "19.59278", "-98.96667", "America/Mexico_City"),("8858238", "Héctor Caballero", "", "MX", "484", "", "19", "031", "", "25.63556", "-100.12667", "America/Monterrey"),("8858239", "Quinto Barrio (Ejido Cahuacán)", "", "MX", "484", "", "15", "060", "", "19.62222", "-99.41806", "America/Mexico_City"),("8858240", "Valle de Lincoln", "", "MX", "484", "", "19", "018", "", "25.79333", "-100.47778", "America/Monterrey"),("8858241", "Emiliano Zapata", "", "MX", "484", "", "02", "001", "", "30.75417", "-116.00306", "America/Tijuana"),("8858242", "Quinta del Cedro", "", "MX", "484", "", "02", "004", "", "32.4375", "-117.06583", "America/Tijuana"),("8858243", "Lomas de Altavista", "", "MX", "484", "", "15", "070", "", "19.36139", "-98.94472", "America/Mexico_City"),("8858244", "Unidad Minera 11 de Julio", "", "MX", "484", "", "13", "051", "", "20.10472", "-98.72278", "America/Mexico_City"),("8858245", "Galaxia la Noria", "", "MX", "484", "", "14", "097", "", "20.45722", "-103.41889", "America/Mexico_City"),("8858246", "Monte Kristal", "", "MX", "484", "", "19", "031", "", "25.62611", "-100.15694", "America/Monterrey"),("8858247", "La Lima", "", "MX", "484", "", "27", "004", "", "17.91056", "-92.93389", "America/Mexico_City"),("8858248", "Loma la Paz", "", "MX", "484", "", "19", "006", "", "25.71111", "-100.13472", "America/Monterrey"),("8858249", "Ciudad Coahuila (Kilómetro Cincuenta y Siete)", "", "MX", "484", "", "02", "002", "", "32.19556", "-115.0025", "America/Tijuana"),("8858250", "Pedro Amaro", "", "MX", "484", "", "17", "012", "", "18.59639", "-99.17306", "America/Mexico_City"),("8858251", "Adolfo López Mateos (El Tamarindo)", "", "MX", "484", "", "25", "006", "", "24.89639", "-107.63278", "America/Mazatlan"),("8858252", "Los Arcos", "", "MX", "484", "", "17", "029", "", "18.88722", "-99.02417", "America/Mexico_City"),("8858253", "Villas de Alcalá", "", "MX", "484", "", "19", "025", "", "25.91528", "-100.18528", "America/Monterrey"),("8858254", "Calera Chica", "", "MX", "484", "", "17", "011", "", "18.85833", "-99.18194", "America/Mexico_City"),("8858255", "El Rincón Citlaltépetl", "", "MX", "484", "", "21", "104", "", "19.15556", "-97.89444", "America/Mexico_City"),("8858256", "San Francisco de Asís", "", "MX", "484", "", "14", "013", "", "20.59694", "-102.56361", "America/Mexico_City"),("8858257", "Jicaltepec Autopan", "", "MX", "484", "", "15", "106", "", "19.37167", "-99.64083", "America/Mexico_City"),("8858258", "Villas de Irapuato", "", "MX", "484", "", "11", "017", "", "20.68722", "-101.40528", "America/Mexico_City"),("8858259", "Arbolada los Sauces", "", "MX", "484", "", "15", "120", "", "19.81583", "-99.04417", "America/Mexico_City"),("8858260", "Atoluca", "", "MX", "484", "", "21", "174", "", "19.855", "-97.35361", "America/Mexico_City"),("8858261", "Frontera Corozal", "", "MX", "484", "", "05", "059", "", "16.82111", "-90.89028", "America/Guatemala"),("8858262", "Pocitos", "", "MX", "484", "", "01", "001", "", "21.92167", "-102.33472", "America/Mexico_City"),("8858263", "Anacleto Canabal 2da. Sección", "", "MX", "484", "", "27", "004", "", "17.97556", "-93.02417", "America/Mexico_City"),("8858264", "La Pastoría", "", "MX", "484", "", "15", "011", "", "19.54306", "-98.91111", "America/Mexico_City"),("8858265", "Tzimol", "", "MX", "484", "", "05", "104", "", "16.1875", "-92.19694", "America/Mexico_City"),("8858266", "Los Tuzos", "", "MX", "484", "", "13", "051", "", "20.05389", "-98.75639", "America/Mexico_City"),("8858267", "Ex-Hacienda Santa Inés", "", "MX", "484", "", "15", "059", "", "19.70667", "-99.0725", "America/Mexico_City"),("8858268", "San Lorenzo Axocomanitla", "", "MX", "484", "", "29", "054", "", "19.22389", "-98.24861", "America/Mexico_City"),("1222387", "Padang Mat Sirat", "", "MY", "458", "", "02", "", "", "6.35423", "99.73404", "Asia/Kuala_Lumpur"),("1222391", "Ayer Hangat", "", "MY", "458", "", "02", "", "", "6.42062", "99.82199", "Asia/Kuala_Lumpur"),("1222396", "Kuah", "", "MY", "458", "", "02", "1222381", "", "6.32649", "99.8432", "Asia/Kuala_Lumpur"),("1732602", "Jerantut", "", "MY", "458", "", "06", "", "", "3.936", "102.3626", "Asia/Kuala_Lumpur"),("1732663", "Raub", "", "MY", "458", "", "06", "", "", "3.7899", "101.857", "Asia/Kuala_Lumpur"),("1732687", "Batu Pahat", "", "MY", "458", "", "01", "1732686", "", "1.8548", "102.9325", "Asia/Kuala_Lumpur"),("1732698", "Parit Raja", "", "MY", "458", "", "01", "", "", "1.8681", "103.1124", "Asia/Kuala_Lumpur"),("1732706", "Pekan Nenas", "", "MY", "458", "", "01", "", "", "1.51", "103.5141", "Asia/Kuala_Lumpur"),("1732711", "Pontian Kechil", "", "MY", "458", "", "01", "", "", "1.4866", "103.3896", "Asia/Kuala_Lumpur"),("1732721", "Kampung Pasir Gudang Baru", "", "MY", "458", "", "01", "", "", "1.4726", "103.878", "Asia/Kuala_Lumpur"),("1732738", "Kota Tinggi", "", "MY", "458", "", "01", "", "", "1.7381", "103.8999", "Asia/Kuala_Lumpur"),("1732741", "Taman Senai", "Сенаи", "MY", "458", "", "01", "", "", "1.6006", "103.6419", "Asia/Kuala_Lumpur"),("1732742", "Kulai", "", "MY", "458", "", "01", "", "", "1.6561", "103.6032", "Asia/Kuala_Lumpur"),("1732745", "Skudai", "", "MY", "458", "", "01", "", "", "1.53741", "103.65779", "Asia/Kuala_Lumpur"),("1732752", "Johor Bahru", "Джохор-Бару", "MY", "458", "", "01", "", "", "1.4655", "103.7578", "Asia/Kuala_Lumpur"),("1732811", "Kluang", "", "MY", "458", "", "01", "", "", "2.03046", "103.31689", "Asia/Kuala_Lumpur"),("1732814", "Yong Peng", "", "MY", "458", "", "01", "", "", "2.0136", "103.0659", "Asia/Kuala_Lumpur"),("1732826", "Mersing", "", "MY", "458", "", "01", "1732827", "", "2.4312", "103.8405", "Asia/Kuala_Lumpur"),("1732846", "Segamat", "", "MY", "458", "", "01", "", "", "2.5148", "102.8158", "Asia/Kuala_Lumpur"),("1732857", "Tangkak", "", "MY", "458", "", "01", "", "", "2.2673", "102.5453", "Asia/Kuala_Lumpur"),("1732869", "Muar", "Муар", "MY", "458", "", "01", "", "", "2.0442", "102.5689", "Asia/Kuala_Lumpur"),("1732871", "Bakri", "Бакри", "MY", "458", "", "01", "", "", "2.0441", "102.6527", "Asia/Kuala_Lumpur"),("1732877", "Labis", "", "MY", "458", "", "01", "", "", "2.385", "103.021", "Asia/Kuala_Lumpur"),("1732884", "Chaah", "", "MY", "458", "", "01", "", "", "2.249", "103.048", "Asia/Kuala_Lumpur"),("1732891", "Kuala Selangor", "Куала-Селангор", "MY", "458", "", "12", "", "", "3.35", "101.25", "Asia/Kuala_Lumpur"),("1732892", "Batang Berjuntai", "", "MY", "458", "", "12", "", "", "3.38333", "101.41667", "Asia/Kuala_Lumpur"),("1732893", "Batu Arang", "", "MY", "458", "", "12", "", "", "3.31667", "101.46667", "Asia/Kuala_Lumpur"),("1732903", "Shah Alam", "Шах-Алам", "MY", "458", "", "12", "", "", "3.08507", "101.53281", "Asia/Kuala_Lumpur"),("1732905", "Klang", "", "MY", "458", "", "12", "", "", "3.03333", "101.45", "Asia/Kuala_Lumpur"),("1732945", "Cukai", "", "MY", "458", "", "13", "", "", "4.25", "103.41667", "Asia/Kuala_Lumpur"),("1733023", "Kuala Lipis", "", "MY", "458", "", "06", "", "", "4.1842", "102.0468", "Asia/Kuala_Lumpur"),("1733353", "Papar", "", "MY", "458", "", "16", "", "", "5.73333", "115.93333", "Asia/Kuching"),("1733432", "Kota Kinabalu", "Кота-Кинабалу", "MY", "458", "", "16", "", "", "5.9749", "116.0724", "Asia/Kuching"),("1733438", "Donggongon", "", "MY", "458", "", "16", "", "", "5.90702", "116.10146", "Asia/Kuching"),("1733440", "Putatan", "", "MY", "458", "", "16", "", "", "5.9258", "116.06094", "Asia/Kuching"),("1733449", "Kinarut", "", "MY", "458", "", "16", "", "", "5.8231", "116.0466", "Asia/Kuching"),("1733502", "Ranau", "", "MY", "458", "", "16", "", "", "5.9538", "116.6641", "Asia/Kuching"),("1733697", "Semporna", "Семпорна", "MY", "458", "", "16", "", "", "4.48178", "118.61119", "Asia/Kuching"),("1733782", "Victoria", "Виктория", "MY", "458", "", "15", "", "", "5.27667", "115.24167", "Asia/Kuching"),("1733874", "Beaufort", "", "MY", "458", "", "16", "", "", "5.3473", "115.7455", "Asia/Kuching"),("1733953", "Lahad Datu", "", "MY", "458", "", "16", "", "", "5.0268", "118.327", "Asia/Kuching"),("1734052", "Sandakan", "Сандакан", "MY", "458", "", "16", "", "", "5.8402", "118.1179", "Asia/Kuching"),("1734098", "Keningau", "", "MY", "458", "", "16", "", "", "5.3378", "116.1602", "Asia/Kuching"),("1734199", "Tawau", "Тавау", "MY", "458", "", "16", "1733595", "", "4.24482", "117.89115", "Asia/Kuching"),("1734313", "Paka", "Пак", "MY", "458", "", "13", "", "", "4.6374", "103.4368", "Asia/Kuala_Lumpur"),("1734316", "Kertih", "", "MY", "458", "", "13", "", "", "4.5141", "103.4483", "Asia/Kuala_Lumpur"),("1734393", "Kulim", "", "MY", "458", "", "02", "", "", "5.36499", "100.56177", "Asia/Kuala_Lumpur"),("1734409", "Bagan Serai", "", "MY", "458", "", "07", "", "", "5.0108", "100.54101", "Asia/Kuala_Lumpur"),("1734439", "Bedong", "", "MY", "458", "", "02", "", "", "5.72743", "100.50876", "Asia/Kuala_Lumpur"),("1734576", "Simpang Empat", "", "MY", "458", "", "07", "", "", "4.95", "100.63333", "Asia/Kuala_Lumpur"),("1734586", "Taiping", "Тайпин", "MY", "458", "", "07", "", "", "4.85", "100.73333", "Asia/Kuala_Lumpur"),("1734599", "Kuala Kangsar", "", "MY", "458", "", "07", "", "", "4.76667", "100.93333", "Asia/Kuala_Lumpur"),("1734634", "Ipoh", "Ипо", "MY", "458", "", "07", "", "", "4.5841", "101.0829", "Asia/Kuala_Lumpur"),("1734651", "Gua Musang", "", "MY", "458", "", "03", "", "", "4.8823", "101.9644", "Asia/Kuala_Lumpur"),("1734705", "Kuala Terengganu", "Куала-Тренгану", "MY", "458", "", "13", "", "", "5.3302", "103.1408", "Asia/Kuala_Lumpur"),("1734715", "Marang", "Маранг", "MY", "458", "", "13", "", "", "5.2056", "103.2059", "Asia/Kuala_Lumpur"),("1734738", "Tampin", "", "MY", "458", "", "05", "", "", "2.4701", "102.2302", "Asia/Kuala_Lumpur"),("1734745", "Alor Gajah", "", "MY", "458", "", "04", "", "", "2.3804", "102.2089", "Asia/Kuala_Lumpur"),("1734753", "Kampung Ayer Keroh", "", "MY", "458", "", "04", "", "", "2.2654", "102.2801", "Asia/Kuala_Lumpur"),("1734757", "Sungai Udang", "", "MY", "458", "", "04", "", "", "2.269", "102.1427", "Asia/Kuala_Lumpur"),("1734759", "Malacca", "Малакка", "MY", "458", "", "04", "", "", "2.196", "102.2405", "Asia/Kuala_Lumpur"),("1734769", "Pelabuhan Klang", "", "MY", "458", "", "12", "", "", "3", "101.4", "Asia/Kuala_Lumpur"),("1734781", "Banting", "", "MY", "458", "", "12", "", "", "2.8136", "101.50185", "Asia/Kuala_Lumpur"),("1734793", "Jenjarum", "", "MY", "458", "", "12", "", "", "2.8724", "101.49484", "Asia/Kuala_Lumpur"),("1734798", "Semenyih", "", "MY", "458", "", "12", "1735173", "1734798", "2.9516", "101.843", "Asia/Kuala_Lumpur"),("1734810", "Seremban", "Серембан", "MY", "458", "", "05", "", "", "2.7297", "101.9381", "Asia/Kuala_Lumpur"),("1734815", "Port Dickson", "", "MY", "458", "", "05", "", "", "2.53718", "101.80571", "Asia/Kuala_Lumpur"),("1734821", "Sepang", "", "MY", "458", "", "12", "", "", "2.6931", "101.7498", "Asia/Kuala_Lumpur"),("1734839", "Bahau", "", "MY", "458", "", "05", "", "", "2.8079", "102.4049", "Asia/Kuala_Lumpur"),("1734841", "Kuala Pilah", "", "MY", "458", "", "05", "", "", "2.7389", "102.2487", "Asia/Kuala_Lumpur"),("1734879", "Buloh Kasap", "", "MY", "458", "", "01", "", "", "2.5536", "102.764", "Asia/Kuala_Lumpur"),("1734971", "Pekan", "Пекан", "MY", "458", "", "06", "", "", "3.4836", "103.3996", "Asia/Kuala_Lumpur"),("1735018", "Mentekab", "", "MY", "458", "", "06", "", "", "3.4854", "102.3484", "Asia/Kuala_Lumpur"),("1735022", "Temerluh", "", "MY", "458", "", "06", "", "", "3.4506", "102.4176", "Asia/Kuala_Lumpur"),("1735074", "Batu Feringgi", "", "MY", "458", "", "09", "", "", "5.4709", "100.24529", "Asia/Kuala_Lumpur"),("1735076", "Butterworth", "", "MY", "458", "", "09", "", "", "5.3991", "100.36382", "Asia/Kuala_Lumpur"),("1735077", "Perai", "", "MY", "458", "", "09", "", "", "5.38333", "100.38333", "Asia/Kuala_Lumpur"),("1735079", "Bukit Mertajam", "", "MY", "458", "", "09", "", "", "5.36301", "100.4667", "Asia/Kuala_Lumpur"),("1735086", "Nibong Tebal", "", "MY", "458", "", "09", "", "", "5.16586", "100.47793", "Asia/Kuala_Lumpur"),("1735089", "Parit Buntar", "", "MY", "458", "", "07", "", "", "5.12671", "100.49316", "Asia/Kuala_Lumpur"),("1735093", "Tasek Glugor", "", "MY", "458", "", "09", "", "", "5.48032", "100.49849", "Asia/Kuala_Lumpur"),("1735106", "George Town", "Джорджтаун", "MY", "458", "", "09", "", "", "5.41123", "100.33543", "Asia/Kuala_Lumpur"),("1735133", "Kampung Bukit Tinggi, Bentong", "", "MY", "458", "", "06", "", "", "3.34944", "101.82631", "Asia/Kuala_Lumpur"),("1735148", "Serendah", "", "MY", "458", "", "12", "", "", "3.3646", "101.6041", "Asia/Kuala_Lumpur"),("1735150", "Rawang", "", "MY", "458", "", "12", "", "", "3.3213", "101.5767", "Asia/Kuala_Lumpur"),("1735158", "Petaling Jaya", "Петалинг-Джая", "MY", "458", "", "12", "1735156", "", "3.10726", "101.60671", "Asia/Kuala_Lumpur"),("1735161", "Kuala Lumpur", "Куала-Лумпур", "MY", "458", "", "14", "", "", "3.1412", "101.68653", "Asia/Kuala_Lumpur"),("1735195", "Sabak Bernam", "", "MY", "458", "", "12", "", "", "3.7698", "100.9879", "Asia/Kuala_Lumpur"),("1735199", "Sungai Besar", "", "MY", "458", "", "12", "", "", "3.6746", "100.9867", "Asia/Kuala_Lumpur"),("1735227", "Kuantan", "Куантан", "MY", "458", "", "06", "", "", "3.8077", "103.326", "Asia/Kuala_Lumpur"),("1735262", "Tanah Rata", "", "MY", "458", "", "06", "1735261", "", "4.46361", "101.3763", "Asia/Kuala_Lumpur"),("1735268", "Batu Gajah", "", "MY", "458", "", "07", "", "", "4.46916", "101.04107", "Asia/Kuala_Lumpur"),("1735274", "Kampar", "", "MY", "458", "", "07", "", "", "4.3", "101.15", "Asia/Kuala_Lumpur"),("1735282", "Tapah Road", "", "MY", "458", "", "07", "", "", "4.16667", "101.2", "Asia/Kuala_Lumpur"),("1735287", "Bidur", "", "MY", "458", "", "07", "", "", "4.11667", "101.28333", "Asia/Kuala_Lumpur"),("1735450", "Lumut", "", "MY", "458", "", "07", "", "", "4.2323", "100.6298", "Asia/Kuala_Lumpur"),("1735459", "Teluk Intan", "", "MY", "458", "", "07", "", "", "4.0259", "101.0213", "Asia/Kuala_Lumpur"),("1735485", "Gurun", "", "MY", "458", "", "02", "", "", "5.81717", "100.47381", "Asia/Kuala_Lumpur"),("1735498", "Sungai Petani", "", "MY", "458", "", "02", "", "", "5.647", "100.48772", "Asia/Kuala_Lumpur"),("1735506", "Kepala Batas", "", "MY", "458", "", "09", "", "", "5.51707", "100.4265", "Asia/Kuala_Lumpur"),("1735553", "Tanah Merah", "", "MY", "458", "", "03", "", "", "5.8", "102.15", "Asia/Kuala_Lumpur"),("1735634", "Kuching", "Кучинг", "MY", "458", "", "11", "", "", "1.55", "110.33333", "Asia/Kuching"),("1735799", "Simanggang", "", "MY", "458", "", "11", "", "", "1.24722", "111.45278", "Asia/Kuching"),("1735837", "Sarikei", "", "MY", "458", "", "11", "", "", "2.11667", "111.51667", "Asia/Kuching"),("1735902", "Sibu", "Сибу", "MY", "458", "", "11", "", "", "2.3", "111.81667", "Asia/Kuching"),("1736278", "Kangar", "Кангар", "MY", "458", "", "08", "", "", "6.4414", "100.19862", "Asia/Kuala_Lumpur"),("1736292", "Kuala Perlis", "", "MY", "458", "", "08", "", "", "6.4", "100.13333", "Asia/Kuala_Lumpur"),("1736302", "Jitra", "", "MY", "458", "", "02", "", "", "6.26812", "100.42167", "Asia/Kuala_Lumpur"),("1736305", "Kuala Kedah", "", "MY", "458", "", "02", "", "", "6.1", "100.3", "Asia/Kuala_Lumpur"),("1736309", "Alor Setar", "Алор-Сетар", "MY", "458", "", "02", "", "", "6.12104", "100.36014", "Asia/Kuala_Lumpur"),("1736356", "Tumpat", "", "MY", "458", "", "03", "", "", "6.19775", "102.17098", "Asia/Kuala_Lumpur"),("1736372", "Pasir Mas", "", "MY", "458", "", "03", "", "", "6.04934", "102.13987", "Asia/Kuala_Lumpur"),("1736376", "Kota Bharu", "Кота-Бару", "MY", "458", "", "03", "", "", "6.13328", "102.2386", "Asia/Kuala_Lumpur"),("1736405", "Jertih", "", "MY", "458", "", "13", "", "", "5.7336", "102.4897", "Asia/Kuala_Lumpur"),("1736458", "Kudat", "", "MY", "458", "", "16", "", "", "6.88732", "116.82364", "Asia/Kuching"),("1736660", "Kota Belud", "", "MY", "458", "", "16", "", "", "6.351", "116.4305", "Asia/Kuching"),("1737185", "Kapit", "", "MY", "458", "", "11", "", "", "2.01667", "112.93333", "Asia/Kuching"),("1737486", "Bintulu", "Бинтулу", "MY", "458", "", "11", "", "", "3.16667", "113.03333", "Asia/Kuching"),("1737714", "Limbang", "", "MY", "458", "", "11", "", "", "4.75", "115", "Asia/Kuching"),("1738050", "Miri", "Мири", "MY", "458", "", "11", "", "", "4.4148", "114.0089", "Asia/Kuching"),("1738294", "Ulu Tiram", "", "MY", "458", "", "01", "", "", "1.6", "103.81667", "Asia/Kuala_Lumpur"),("1740836", "Telaga Batu", "", "MY", "458", "", "09", "", "", "5.46667", "100.23333", "Asia/Kuala_Lumpur"),("1741550", "Tanjung Tokong", "", "MY", "458", "", "09", "", "", "5.46061", "100.30742", "Asia/Kuala_Lumpur"),("1741562", "Tanjung Sepat", "", "MY", "458", "", "12", "", "", "2.6579", "101.5629", "Asia/Kuala_Lumpur"),("1742667", "Sungai Pelek New Village", "", "MY", "458", "", "00", "", "", "2.65", "101.7", "Asia/Kuala_Lumpur"),("1749659", "Pulau Sebang", "", "MY", "458", "", "04", "", "", "2.455", "102.2329", "Asia/Kuala_Lumpur"),("1750500", "Permatang Kuching", "", "MY", "458", "", "09", "", "", "5.46339", "100.38144", "Asia/Kuala_Lumpur"),("1750582", "Peringat", "", "MY", "458", "", "03", "", "", "6.03333", "102.28333", "Asia/Kuala_Lumpur"),("1750974", "Ladang Seri Kundang", "", "MY", "458", "", "12", "", "", "3.2856", "101.519", "Asia/Kuala_Lumpur"),("1752256", "Pantai Remis", "", "MY", "458", "", "07", "", "", "4.4557", "100.6288", "Asia/Kuala_Lumpur"),("1759486", "Kuang", "Куанг", "MY", "458", "", "12", "", "", "3.2594", "101.5541", "Asia/Kuala_Lumpur"),("1759513", "Kuala Sungai Baru", "", "MY", "458", "", "04", "", "", "2.3594", "102.0353", "Asia/Kuala_Lumpur"),("1761242", "Klebang Besar", "", "MY", "458", "", "04", "", "", "2.2186", "102.1995", "Asia/Kuala_Lumpur"),("1761293", "Kelapa Sawit", "", "MY", "458", "", "01", "", "", "1.6698", "103.5327", "Asia/Kuala_Lumpur"),("1763412", "Kampung Tanjung Karang", "", "MY", "458", "", "12", "", "", "3.4242", "101.1849", "Asia/Kuala_Lumpur"),("1764160", "Kampung Sungai Ara", "", "MY", "458", "", "09", "", "", "5.32699", "100.27348", "Asia/Kuala_Lumpur"),("1764318", "Kampung Simpang Renggam", "", "MY", "458", "", "01", "", "", "1.8278", "103.3", "Asia/Kuala_Lumpur"),("1766249", "Kampong Pangkal Kalong", "", "MY", "458", "", "03", "", "", "5.91667", "102.21667", "Asia/Kuala_Lumpur"),("1767021", "Kampong Masjid Tanah", "", "MY", "458", "", "04", "", "", "2.35", "102.11667", "Asia/Kuala_Lumpur"),("1768664", "Kampong Kadok", "", "MY", "458", "", "03", "", "", "6", "102.25", "Asia/Kuala_Lumpur"),("1769612", "Kampong Dungun", "", "MY", "458", "", "07", "", "", "3.21667", "101.31667", "Asia/Kuala_Lumpur"),("1770351", "Kampung Bukit Baharu", "", "MY", "458", "", "04", "", "", "2.2152", "102.2851", "Asia/Kuala_Lumpur"),("1771023", "Kampung Baru Subang", "", "MY", "458", "", "12", "", "", "3.15", "101.53333", "Asia/Kuala_Lumpur"),("1771287", "Kampung Baharu Nilai", "", "MY", "458", "", "05", "", "", "2.8033", "101.7972", "Asia/Kuala_Lumpur"),("1771304", "Kampong Baharu Balakong", "", "MY", "458", "", "12", "", "", "3.03333", "101.75", "Asia/Kuala_Lumpur"),("1771485", "Kampung Ayer Molek", "", "MY", "458", "", "04", "", "", "2.2139", "102.3278", "Asia/Kuala_Lumpur"),("1772148", "Juru", "", "MY", "458", "", "09", "", "", "5.31201", "100.44229", "Asia/Kuala_Lumpur"),("1778290", "Bukit Rambai", "", "MY", "458", "", "04", "", "", "2.2594", "102.1838", "Asia/Kuala_Lumpur"),("1779790", "Bentong Town", "", "MY", "458", "", "06", "", "", "3.52229", "101.90866", "Asia/Kuala_Lumpur"),("1779926", "Bemban", "", "MY", "458", "", "04", "", "", "2.2684", "102.3746", "Asia/Kuala_Lumpur"),("1780890", "Batu Berendam", "", "MY", "458", "", "04", "", "", "2.2487", "102.246", "Asia/Kuala_Lumpur"),("6697380", "Putrajaya", "", "MY", "458", "", "17", "", "", "2.93527", "101.69112", "Asia/Kuala_Lumpur"),("7302815", "Bandar Labuan", "", "MY", "458", "", "16", "", "", "5.28883", "115.26924", "Asia/Kuching"),("8504423", "Subang Jaya", "", "MY", "458", "", "12", "", "", "3.04384", "101.58062", "Asia/Kuala_Lumpur"),("8714611", "Taman Rajawali", "", "MY", "458", "", "16", "", "", "5.89477", "118.04576", "Asia/Kuala_Lumpur"),("10792382", "Putra Heights", "", "MY", "458", "", "12", "", "", "2.99361", "101.57255", "Asia/Kuala_Lumpur"),("11002069", "Pantai Cenang", "", "MY", "458", "", "08", "", "", "6.29369", "99.72786", "Asia/Kuala_Lumpur"),("1024552", "Xai-Xai", "Шаи-Шаи", "MZ", "508", "", "02", "9408663", "", "-25.05194", "33.64417", "Africa/Maputo"),("1024696", "Dondo", "Дондо", "MZ", "508", "", "05", "", "", "-19.60944", "34.74306", "Africa/Maputo"),("1024701", "Macia", "", "MZ", "508", "", "02", "", "", "-25.02694", "33.09889", "Africa/Maputo"),("1026014", "Tete", "", "MZ", "508", "", "08", "", "", "-16.15639", "33.58667", "Africa/Maputo"),("1028079", "Ressano Garcia", "", "MZ", "508", "MZ", "04", "", "", "-25.44278", "31.99528", "Africa/Maputo"),("1028434", "Quelimane", "Келимане", "MZ", "508", "", "09", "", "", "-17.87861", "36.88833", "Africa/Maputo"),("1028918", "Pemba", "Пемба", "MZ", "508", "", "01", "", "", "-12.97395", "40.51775", "Africa/Maputo"),("1033356", "Nampula", "Нампула", "MZ", "508", "", "06", "", "", "-15.11646", "39.2666", "Africa/Maputo"),("1035025", "Nacala", "Город-де-Накала", "MZ", "508", "", "06", "", "", "-14.56257", "40.68538", "Africa/Maputo"),("1037125", "Montepuez", "Монтепвезе", "MZ", "508", "", "01", "", "", "-13.12556", "38.99972", "Africa/Maputo"),("1037370", "Mocímboa", "", "MZ", "508", "", "01", "", "", "-11.31667", "40.35", "Africa/Maputo"),("1037390", "Ilha de Moçambique", "", "MZ", "508", "", "06", "", "", "-15.03417", "40.73583", "Africa/Maputo"),("1039536", "Maxixe", "", "MZ", "508", "", "03", "", "", "-23.85972", "35.34722", "Africa/Maputo"),("1039854", "Matola", "Матола", "MZ", "508", "", "04", "", "", "-25.96222", "32.45889", "Africa/Maputo"),("1040652", "Maputo", "Мапуту", "MZ", "508", "", "11", "", "", "-25.96553", "32.58322", "Africa/Maputo"),("1040938", "Manjacaze", "", "MZ", "508", "", "02", "", "", "-24.71167", "33.88278", "Africa/Maputo"),("1043893", "Lichinga", "", "MZ", "508", "", "07", "", "", "-13.31278", "35.24056", "Africa/Maputo"),("1045114", "Inhambane", "Иньямбане", "MZ", "508", "", "03", "", "", "-23.865", "35.38333", "Africa/Maputo"),("1047660", "Cuamba", "", "MZ", "508", "", "07", "", "", "-14.80306", "36.53722", "Africa/Maputo"),("1048364", "Chokwé", "", "MZ", "508", "", "02", "7874104", "", "-24.53333", "32.98333", "Africa/Maputo"),("1049261", "Chimoio", "Шимойо", "MZ", "508", "", "10", "", "", "-19.11639", "33.48333", "Africa/Maputo"),("1049861", "Chibuto", "", "MZ", "508", "", "02", "", "", "-24.68667", "33.53056", "Africa/Maputo"),("1052373", "Beira", "Бейра", "MZ", "508", "", "05", "", "", "-19.84361", "34.83889", "Africa/Maputo"),("1052944", "António Enes", "", "MZ", "508", "", "06", "", "", "-16.2325", "39.90861", "Africa/Maputo"),("1088155", "Mutuáli", "", "MZ", "508", "", "06", "", "", "-14.87056", "37.00444", "Africa/Maputo"),("877178", "Katima Mulilo", "", "NA", "516", "", "28", "", "", "-17.5", "24.26667", "Africa/Windhoek"),("3352136", "Windhoek", "Виндхук", "NA", "516", "", "21", "", "", "-22.55941", "17.08323", "Africa/Windhoek"),("3352263", "Warmbad", "", "NA", "516", "", "31", "", "", "-28.45", "18.73333", "Africa/Windhoek"),("3352461", "Usakos", "", "NA", "516", "", "29", "", "", "-22", "15.6", "Africa/Windhoek"),("3352593", "Tsumeb", "", "NA", "516", "", "38", "", "", "-19.23333", "17.71667", "Africa/Windhoek"),("3352844", "Swakopmund", "Свакопмунд", "NA", "516", "", "29", "", "", "-22.68333", "14.53333", "Africa/Windhoek"),("3353383", "Rundu", "Рунду", "NA", "516", "", "40", "", "", "-17.93333", "19.76667", "Africa/Windhoek"),("3353540", "Rehoboth", "Рехобот", "NA", "516", "", "30", "", "", "-23.317", "17.09", "Africa/Windhoek"),("3353715", "Outjo", "", "NA", "516", "", "32", "", "", "-20.11667", "16.15", "Africa/Windhoek"),("3353811", "Otjiwarongo", "Отьиваронго", "NA", "516", "", "39", "", "", "-20.46369", "16.64772", "Africa/Windhoek"),("3353871", "Otjimbingwe", "", "NA", "516", "", "29", "", "", "-22.35", "16.13333", "Africa/Windhoek"),("3354021", "Oshakati", "Ошакати", "NA", "516", "", "37", "", "", "-17.78333", "15.68333", "Africa/Windhoek"),("3354071", "Oranjemund", "", "NA", "516", "", "31", "", "", "-28.55", "16.43333", "Africa/Windhoek"),("3354077", "Opuwo", "", "NA", "516", "", "32", "", "", "-18.06068", "13.83998", "Africa/Windhoek"),("3354147", "Ongwediva", "", "NA", "516", "", "37", "", "", "-17.78333", "15.76667", "Africa/Windhoek"),("3354247", "Ondangwa", "", "NA", "516", "", "37", "", "", "-17.91667", "15.95", "Africa/Windhoek"),("3354367", "Omuthiya", "", "NA", "516", "", "38", "", "", "-17.71667", "16.21667", "Africa/Windhoek"),("3354540", "Omaruru", "", "NA", "516", "", "29", "", "", "-21.43333", "15.93333", "Africa/Windhoek"),("3354876", "Okakarara", "", "NA", "516", "", "39", "", "", "-20.58333", "17.43333", "Africa/Windhoek"),("3354898", "Okahandja", "", "NA", "516", "", "39", "", "", "-21.98333", "16.91667", "Africa/Windhoek"),("3355137", "Nkurenkuru", "", "NA", "516", "", "41", "", "", "-17.61667", "18.6", "Africa/Windhoek"),("3355595", "Mariental", "", "NA", "516", "", "30", "", "", "-24.63333", "17.96667", "Africa/Windhoek"),("3355672", "Lüderitz", "Людериц", "NA", "516", "", "31", "", "", "-26.64806", "15.15944", "Africa/Windhoek"),("3356213", "Khorixas", "", "NA", "516", "", "32", "", "", "-20.36667", "14.96667", "Africa/Windhoek"),("3356264", "Keetmanshoop", "Китмансхуп", "NA", "516", "", "31", "", "", "-26.58333", "18.13333", "Africa/Windhoek"),("3356332", "Karibib", "", "NA", "516", "", "29", "", "", "-21.93333", "15.83333", "Africa/Windhoek"),("3356343", "Karasburg", "", "NA", "516", "", "31", "", "", "-28.01667", "18.75", "Africa/Windhoek"),("3357114", "Grootfontein", "", "NA", "516", "", "39", "", "", "-19.56667", "18.11667", "Africa/Windhoek"),("3357247", "Gobabis", "", "NA", "516", "", "35", "", "", "-22.45", "18.96667", "Africa/Windhoek"),("3357804", "Eenhana", "", "NA", "516", "NA", "33", "", "", "-17.46667", "16.33333", "Africa/Windhoek"),("3358416", "Bethanie", "", "NA", "516", "", "31", "", "", "-26.48333", "17.15", "Africa/Windhoek"),("3359638", "Walvis Bay", "Уолфиш-Бей", "NA", "516", "", "29", "", "", "-22.9575", "14.50528", "Africa/Windhoek"),("3371197", "Outapi", "", "NA", "516", "", "36", "", "", "-17.5", "14.98333", "Africa/Windhoek"),("2437732", "Birni N Konni", "Бирнин-Конни", "NE", "562", "", "06", "", "", "13.79599", "5.25026", "Africa/Niamey"),("2437798", "Zinder", "Зиндер", "NE", "562", "", "07", "", "", "13.80716", "8.9881", "Africa/Niamey"),("2438678", "Tillabéri", "", "NE", "562", "", "09", "", "", "14.20711", "1.45418", "Africa/Niamey"),("2438774", "Tibiri", "", "NE", "562", "", "04", "", "", "13.56271", "7.04848", "Africa/Niamey"),("2438823", "Tessaoua", "", "NE", "562", "", "04", "", "", "13.75737", "7.9874", "Africa/Niamey"),("2438855", "Téra", "Тера", "NE", "562", "", "09", "", "", "14.00776", "0.75306", "Africa/Niamey"),("2438974", "Tchintabaraden", "", "NE", "562", "", "06", "", "", "15.8969", "5.7985", "Africa/Niamey"),("2439155", "Tanout", "", "NE", "562", "", "07", "", "", "14.97089", "8.88786", "Africa/Niamey"),("2439376", "Tahoua", "Тахуа", "NE", "562", "", "06", "", "", "14.8888", "5.2692", "Africa/Niamey"),("2439812", "Say", "", "NE", "562", "", "09", "", "", "13.1007", "2.3689", "Africa/Niamey"),("2440371", "Ouallam", "", "NE", "562", "", "09", "", "", "14.31641", "2.08597", "Africa/Niamey"),("2440485", "Niamey", "Ниамей", "NE", "562", "", "08", "", "", "13.51366", "2.1098", "Africa/Niamey"),("2440495", "Nguigmi", "", "NE", "562", "", "02", "", "", "14.24953", "13.10921", "Africa/Niamey"),("2440921", "Mirriah", "Мирриа", "NE", "562", "", "07", "", "", "13.70727", "9.15013", "Africa/Niamey"),("2441194", "Mayahi", "Майахи", "NE", "562", "", "04", "", "", "13.95532", "7.67122", "Africa/Niamey"),("2441217", "Matamey", "", "NE", "562", "", "07", "", "", "13.42309", "8.47485", "Africa/Niamey"),("2441291", "Maradi", "Маради", "NE", "562", "", "04", "", "", "13.5", "7.10174", "Africa/Niamey"),("2441447", "Maïné Soroa", "", "NE", "562", "", "02", "", "", "13.21139", "12.0241", "Africa/Niamey"),("2441482", "Magaria", "", "NE", "562", "", "07", "", "", "12.99826", "8.90991", "Africa/Niamey"),("2441526", "Madarounfa", "", "NE", "562", "", "04", "", "", "13.30867", "7.15602", "Africa/Niamey"),("2441530", "Madaoua", "", "NE", "562", "", "06", "", "", "14.073", "5.96", "Africa/Niamey"),("2442248", "Kollo", "", "NE", "562", "", "09", "", "", "13.3043", "2.339", "Africa/Niamey"),("2442478", "Keïta", "", "NE", "562", "", "06", "", "", "14.7551", "5.7749", "Africa/Niamey"),("2443304", "Illéla", "", "NE", "562", "", "06", "", "", "14.4605", "5.2437", "Africa/Niamey"),("2444219", "Gouré", "", "NE", "562", "", "07", "", "", "13.9835", "10.27035", "Africa/Niamey"),("2444489", "Gaya", "", "NE", "562", "", "03", "", "", "11.88435", "3.44919", "Africa/Niamey"),("2444995", "Filingué", "", "NE", "562", "", "09", "", "", "14.3521", "3.3168", "Africa/Niamey"),("2445488", "Dosso", "Доссо", "NE", "562", "", "03", "", "", "13.049", "3.1937", "Africa/Niamey"),("2445553", "Dogondoutchi", "", "NE", "562", "", "03", "", "", "13.63933", "4.02875", "Africa/Niamey"),("2445704", "Diffa", "Диффа", "NE", "562", "", "02", "", "", "13.31536", "12.61135", "Africa/Niamey"),("2446267", "Dakoro", "", "NE", "562", "", "04", "", "", "14.51056", "6.765", "Africa/Niamey"),("2446466", "Bouza", "", "NE", "562", "", "06", "", "", "14.42293", "6.04278", "Africa/Niamey"),("2447416", "Ayorou", "", "NE", "562", "", "09", "", "", "14.73075", "0.91739", "Africa/Niamey"),("2447938", "Alaghsas", "", "NE", "562", "", "01", "", "", "17.0187", "8.0168", "Africa/Niamey"),("2448024", "Aguié", "", "NE", "562", "", "04", "", "", "13.50601", "7.77863", "Africa/Niamey"),("2448085", "Agadez", "Агадес", "NE", "562", "", "01", "", "", "16.97333", "7.99111", "Africa/Niamey"),("2448245", "Abalak", "", "NE", "562", "", "06", "", "", "15.4509", "6.2793", "Africa/Niamey"),("2317548", "Zuru", "", "NG", "566", "", "40", "521", "52105", "11.43522", "5.23494", "Africa/Lagos"),("2317569", "Zungeru", "", "NG", "566", "", "31", "27025", "", "9.80726", "6.15238", "Africa/Lagos"),("2317765", "Zaria", "Заря", "NG", "566", "", "23", "19019", "KD1903", "11.11128", "7.7227", "Africa/Lagos"),("2317818", "Zango", "", "NG", "566", "", "24", "434", "43410", "13.05313", "8.48574", "Africa/Lagos"),("2317887", "Zalanga", "", "NG", "566", "", "46", "5008", "BA0805", "10.61432", "10.17647", "Africa/Lagos"),("2317899", "Zaki Biam", "", "NG", "566", "", "26", "7021", "", "7.50671", "9.6104", "Africa/Lagos"),("2317936", "Zadawa", "", "NG", "566", "", "46", "5014", "BA1401", "11.4496", "10.3672", "Africa/Lagos"),("2317982", "Yuli", "", "NG", "566", "", "46", "5001", "BA0108", "9.69707", "10.2735", "Africa/Lagos"),("2318044", "Yola", "Йола", "NG", "566", "", "35", "2020", "", "9.20839", "12.48146", "Africa/Lagos"),("2318123", "Yenagoa", "", "NG", "566", "", "52", "6008", "", "4.92675", "6.26764", "Africa/Lagos"),("2318166", "Yelwa", "", "NG", "566", "", "49", "32016", "", "8.83333", "9.63333", "Africa/Lagos"),("2318238", "Yashikera", "", "NG", "566", "", "30", "24002", "", "9.76667", "3.4", "Africa/Lagos"),("2318374", "Yandev", "", "NG", "566", "", "26", "7005", "", "7.36308", "9.04235", "Africa/Lagos"),("2318383", "Yanda Bayo", "", "NG", "566", "", "46", "5004", "BA0404", "11.5071", "10.7459", "Africa/Lagos"),("2318399", "Yamrat", "", "NG", "566", "", "46", "5002", "BA0220", "10.11161", "9.82604", "Africa/Lagos"),("2318480", "Yajiwa", "", "NG", "566", "", "27", "114", "11405", "11.38623", "12.71992", "Africa/Lagos"),("2318534", "Wuyo", "", "NG", "566", "", "27", "104", "10409", "10.38522", "11.69678", "Africa/Lagos"),("2318858", "Wurno", "", "NG", "566", "", "51", "622", "62210", "13.29048", "5.42373", "Africa/Lagos"),("2318921", "Wukari", "", "NG", "566", "", "43", "35014", "", "7.87139", "9.77786", "Africa/Lagos"),("2318933", "Wudil", "", "NG", "566", "", "29", "20027", "KN4410", "11.80937", "8.84422", "Africa/Lagos"),("2319078", "Wawa", "", "NG", "566", "", "31", "27004", "", "9.90222", "4.41917", "Africa/Lagos"),("2319123", "Wasagu", "", "NG", "566", "", "40", "519", "51909", "11.3764", "5.79536", "Africa/Lagos"),("2319133", "Warri", "Варри", "NG", "566", "", "36", "10024", "", "5.51737", "5.75006", "Africa/Lagos"),("2319257", "Wamba", "", "NG", "566", "", "56", "26013", "", "8.94153", "8.60315", "Africa/Lagos"),("2319345", "Wagini", "", "NG", "566", "", "24", "403", "40310", "12.68781", "7.19579", "Africa/Lagos"),("2319407", "Vom", "", "NG", "566", "", "49", "32006", "", "9.7291", "8.79138", "Africa/Lagos"),("2319480", "Uyo", "", "NG", "566", "", "21", "3031", "", "5.05127", "7.9335", "Africa/Lagos"),("2319642", "Uruobo-Okija", "", "NG", "566", "", "25", "4012", "", "5.90016", "6.84312", "Africa/Lagos"),("2319668", "Uromi", "", "NG", "566", "", "37", "12003", "", "6.7", "6.33333", "Africa/Lagos"),("2320417", "Umunede", "", "NG", "566", "", "36", "10007", "", "6.26549", "6.30962", "Africa/Lagos"),("2320576", "Umuahia", "", "NG", "566", "", "45", "1016", "", "5.52491", "7.49461", "Africa/Lagos"),("2320746", "Ukata", "", "NG", "566", "", "31", "27015", "", "10.83122", "5.82494", "Africa/Lagos"),("2320829", "Ughelli", "", "NG", "566", "", "36", "10019", "", "5.48956", "6.00407", "Africa/Lagos"),("2320831", "Ugep", "", "NG", "566", "", "22", "9017", "", "5.80865", "8.08098", "Africa/Lagos"),("2320920", "Uga", "", "NG", "566", "", "25", "4001", "", "5.93576", "7.0793", "Africa/Lagos"),("2320966", "Udi", "", "NG", "566", "", "47", "14016", "", "6.31592", "7.42086", "Africa/Lagos"),("2321031", "Ubiaja", "", "NG", "566", "", "37", "12005", "", "6.65581", "6.38494", "Africa/Lagos"),("2321057", "Uba", "", "NG", "566", "", "27", "102", "10211", "10.45509", "13.22233", "Africa/Lagos"),("2321926", "Toungo", "", "NG", "566", "", "35", "2019", "", "8.11733", "12.04611", "Africa/Lagos"),("2322021", "Tokombere", "", "NG", "566", "", "27", "111", "11102", "11.22135", "13.48783", "Africa/Lagos"),("2322263", "Tegina", "", "NG", "566", "", "31", "27020", "", "10.0706", "6.1906", "Africa/Lagos"),("2322495", "Tambuwal", "", "NG", "566", "", "51", "618", "61811", "12.40592", "4.64605", "Africa/Lagos"),("2322529", "Talata Mafara", "", "NG", "566", "", "57", "812", "81201", "12.56841", "6.06225", "Africa/Lagos"),("2322552", "Takum", "", "NG", "566", "", "26", "", "", "7.26667", "9.98333", "Africa/Lagos"),("2322592", "Takai", "", "NG", "566", "", "29", "20002", "KN3709", "11.57569", "9.1088", "Africa/Lagos"),("2322722", "Suya", "", "NG", "566", "", "30", "24002", "", "9.46667", "3.18333", "Africa/Lagos"),("2322794", "Suleja", "Абуджа", "NG", "566", "", "31", "27023", "", "9.18059", "7.17939", "Africa/Lagos"),("2322911", "Sokoto", "Сокото", "NG", "566", "", "51", "616", "61604", "13.06269", "5.24322", "Africa/Lagos"),("2322957", "Soba", "", "NG", "566", "", "23", "19021", "KD2111", "10.98133", "8.05749", "Africa/Lagos"),("2323011", "Siluko", "", "NG", "566", "", "37", "12015", "", "6.53858", "5.1609", "Africa/Lagos"),("2323146", "Shinkafi", "", "NG", "566", "", "57", "811", "81109", "13.07296", "6.50574", "Africa/Lagos"),("2323344", "Shani", "", "NG", "566", "", "27", "127", "12710", "10.21824", "12.06059", "Africa/Lagos"),("2323349", "Shanga", "", "NG", "566", "", "40", "517", "51708", "11.21374", "4.57941", "Africa/Lagos"),("2323390", "Saki", "Саки", "NG", "566", "", "32", "31032", "", "8.66762", "3.39393", "Africa/Lagos"),("2323411", "Shagamu", "", "NG", "566", "", "16", "28020", "", "6.8485", "3.64633", "Africa/Lagos"),("2323418", "Shaffa", "", "NG", "566", "", "27", "112", "11212", "10.50673", "12.33315", "Africa/Lagos"),("2323579", "Sauri", "", "NG", "566", "", "57", "813", "81303", "11.72655", "6.78374", "Africa/Lagos"),("2323675", "Sapele", "", "NG", "566", "", "36", "10017", "", "5.89405", "5.67666", "Africa/Lagos"),("2323858", "Samamiya", "", "NG", "566", "", "39", "18022", "JI0310", "11.34873", "9.63989", "Africa/Lagos"),("2324024", "Sade", "", "NG", "566", "", "46", "5005", "BA0506", "11.3595", "10.6732", "Africa/Lagos"),("2324281", "Runka", "", "NG", "566", "", "24", "432", "43205", "12.44788", "7.30918", "Africa/Lagos"),("2324325", "Ruma", "", "NG", "566", "", "24", "403", "40309", "12.8626", "7.23469", "Africa/Lagos"),("2324439", "Riti", "", "NG", "566", "", "43", "35014", "", "7.90844", "9.61688", "Africa/Lagos"),("2324460", "Ringim", "", "NG", "566", "", "39", "18020", "JI2306", "12.15143", "9.16216", "Africa/Lagos"),("2324504", "Rijau", "", "NG", "566", "", "31", "27021", "", "11.10389", "5.25556", "Africa/Lagos"),("2324575", "Rano", "", "NG", "566", "", "29", "20014", "KN3204", "11.55684", "8.58065", "Africa/Lagos"),("2324623", "Saminaka", "", "NG", "566", "", "23", "19017", "KD1711", "10.41227", "8.68748", "Africa/Lagos"),("2324706", "Rabah", "", "NG", "566", "", "51", "612", "61206", "13.12257", "5.50762", "Africa/Lagos"),("2324767", "Potiskum", "", "NG", "566", "", "44", "714", "71401", "11.71391", "11.08108", "Africa/Lagos"),("2324774", "Port Harcourt", "Порт-Харкорт", "NG", "566", "", "50", "33022", "", "4.77742", "7.0134", "Africa/Lagos"),("2324857", "Pindiga", "", "NG", "566", "", "55", "16001", "", "9.98433", "10.95229", "Africa/Lagos"),("2324960", "Patigi", "", "NG", "566", "", "30", "24016", "", "8.72851", "5.75561", "Africa/Lagos"),("2324962", "Patani", "", "NG", "566", "", "36", "10016", "", "5.22885", "6.19139", "Africa/Lagos"),("2325032", "Panyam", "", "NG", "566", "", "49", "32011", "", "9.40756", "9.21481", "Africa/Lagos"),("2325060", "Pankshin", "", "NG", "566", "", "49", "32013", "", "9.32541", "9.4352", "Africa/Lagos"),("2325161", "Ozubulu", "", "NG", "566", "", "25", "4009", "", "5.95753", "6.85305", "Africa/Lagos"),("2325200", "Oyo", "Ойо", "NG", "566", "", "32", "31030", "", "7.85257", "3.93125", "Africa/Lagos"),("2325249", "Oyan", "", "NG", "566", "", "42", "30025", "", "8.05", "4.76667", "Africa/Lagos"),("2325307", "Owode", "", "NG", "566", "", "16", "28015", "", "6.94851", "3.50561", "Africa/Lagos"),("2325314", "Owo", "Ово", "NG", "566", "", "48", "29018", "", "7.1962", "5.58681", "Africa/Lagos"),("2325330", "Owerri", "Оверри", "NG", "566", "", "28", "17024", "", "5.48363", "7.03325", "Africa/Lagos"),("2325437", "Otukpa", "", "NG", "566", "", "26", "7015", "", "7.10168", "7.65945", "Africa/Lagos"),("2325506", "Otan Ayegbaju", "", "NG", "566", "", "42", "30005", "", "7.94783", "4.78836", "Africa/Lagos"),("2325590", "Osogbo", "", "NG", "566", "", "42", "30030", "", "7.77104", "4.55698", "Africa/Lagos"),("2325713", "Orodo", "", "NG", "566", "", "28", "17011", "", "5.61667", "7.03333", "Africa/Lagos"),("2325725", "Orlu", "", "NG", "566", "", "28", "17020", "", "5.79565", "7.03513", "Africa/Lagos"),("2325733", "Orita Eruwa", "", "NG", "566", "", "32", "31012", "", "7.55", "3.43333", "Africa/Lagos"),("2325803", "Orerokpe", "", "NG", "566", "", "36", "10013", "", "5.63747", "5.89013", "Africa/Lagos"),("2325821", "Ore", "", "NG", "566", "", "48", "29013", "", "6.74716", "4.8761", "Africa/Lagos"),("2325902", "Opi", "", "NG", "566", "", "47", "14013", "", "6.78223", "7.43319", "Africa/Lagos"),("2326016", "Onitsha", "Онича", "NG", "566", "", "25", "4017", "", "6.14978", "6.78569", "Africa/Lagos"),("2326171", "Ondo", "Ондо", "NG", "566", "", "48", "29016", "", "7.09316", "4.83528", "Africa/Lagos"),("2326188", "Omuo-Ekiti", "", "NG", "566", "", "54", "13003", "", "7.75833", "5.72227", "Africa/Lagos"),("2326200", "Omu-Aran", "", "NG", "566", "", "30", "24009", "", "8.13857", "5.1026", "Africa/Lagos"),("2326221", "Omoku", "", "NG", "566", "", "50", "33016", "", "5.34388", "6.65684", "Africa/Lagos"),("2326302", "Olupona", "", "NG", "566", "", "42", "30002", "", "7.6", "4.18333", "Africa/Lagos"),("2326811", "Okuta", "", "NG", "566", "", "30", "24002", "", "9.21667", "3.18333", "Africa/Lagos"),("2326899", "Okrika", "", "NG", "566", "", "50", "33018", "", "4.74215", "7.08368", "Africa/Lagos"),("2327143", "Okigwe", "", "NG", "566", "", "28", "17019", "", "5.82917", "7.35056", "Africa/Lagos"),("2327220", "Okene", "", "NG", "566", "", "41", "23017", "", "7.55122", "6.23589", "Africa/Lagos"),("2327223", "Oke Mesi", "", "NG", "566", "", "42", "", "", "7.81667", "4.91667", "Africa/Lagos"),("2327233", "Oke Ila", "", "NG", "566", "", "54", "", "", "7.95", "4.98333", "Africa/Lagos"),("2327236", "Okeho", "", "NG", "566", "", "32", "31019", "", "8.03386", "3.34759", "Africa/Lagos"),("2327494", "Ohafia-Ifigh", "", "NG", "566", "", "45", "1010", "", "5.61455", "7.81191", "Africa/Lagos"),("2327513", "Ogwashi-Uku", "Огваши-Уку", "NG", "566", "", "36", "10002", "", "6.17811", "6.52461", "Africa/Lagos"),("2327521", "Oguta", "", "NG", "566", "", "28", "17017", "", "5.71044", "6.80936", "Africa/Lagos"),("2327523", "Ogurugu", "", "NG", "566", "", "41", "", "", "6.78636", "6.95017", "Africa/Lagos"),("2327650", "Ogoja", "", "NG", "566", "", "22", "9016", "", "6.6584", "8.79923", "Africa/Lagos"),("2327827", "Ogaminana", "", "NG", "566", "", "41", "23001", "", "7.59383", "6.21798", "Africa/Lagos"),("2327879", "Offa", "Оффа", "NG", "566", "", "30", "24013", "", "8.14911", "4.72074", "Africa/Lagos"),("2328090", "Ode", "Ода", "NG", "566", "", "48", "", "", "7.7899", "5.7117", "Africa/Lagos"),("2328113", "Ochobo", "", "NG", "566", "", "26", "7016", "", "7.18045", "7.9824", "Africa/Lagos"),("2328151", "Obudu", "", "NG", "566", "", "22", "9014", "", "6.66819", "9.16453", "Africa/Lagos"),("2328153", "Obubra", "", "NG", "566", "", "22", "9013", "", "6.07672", "8.33241", "Africa/Lagos"),("2328185", "Obonoma", "", "NG", "566", "", "50", "33008", "", "4.71131", "6.79084", "Africa/Lagos"),("2328192", "Obolo-Eke (1)", "", "NG", "566", "", "47", "14015", "", "6.88333", "7.63333", "Africa/Lagos"),("2328276", "Obiaruku", "", "NG", "566", "", "36", "10021", "", "5.84672", "6.1529", "Africa/Lagos"),("2328617", "Numan", "", "NG", "566", "", "35", "2016", "", "9.46374", "12.03062", "Africa/Lagos"),("2328684", "Nsukka", "Нсукка", "NG", "566", "", "47", "14013", "", "6.85783", "7.39577", "Africa/Lagos"),("2328765", "Nnewi", "Ннюви", "NG", "566", "", "25", "4014", "", "6.01962", "6.91729", "Africa/Lagos"),("2328790", "Nkwerre", "", "NG", "566", "", "28", "17014", "", "5.75917", "7.10384", "Africa/Lagos"),("2328811", "Nkpor", "", "NG", "566", "", "25", "4010", "", "6.15038", "6.83042", "Africa/Lagos"),("2328952", "Nguru", "", "NG", "566", "", "44", "713", "71312", "12.87695", "10.45536", "Africa/Lagos"),("2328960", "Ngurore", "", "NG", "566", "", "35", "2020", "", "9.28871", "12.24026", "Africa/Lagos"),("2329087", "Ngala", "", "NG", "566", "", "27", "125", "12507", "12.34053", "14.1867", "Africa/Lagos"),("2329114", "New Shagunnu", "", "NG", "566", "", "31", "27004", "", "10.33957", "4.4688", "Africa/Lagos"),("2329451", "Nasarawa", "Нассарава", "NG", "566", "", "56", "26009", "", "8.53895", "7.70821", "Africa/Lagos"),("2329562", "Nafada", "", "NG", "566", "", "55", "16009", "", "11.09596", "11.33261", "Africa/Lagos"),("2329639", "Mutum Biyu", "", "NG", "566", "", "43", "35005", "", "8.64138", "10.77355", "Africa/Lagos"),("2329664", "Musawa", "", "NG", "566", "", "24", "429", "42909", "12.12949", "7.67023", "Africa/Lagos"),("2329821", "Mubi", "Муби", "NG", "566", "", "35", "2014", "", "10.26858", "13.26701", "Africa/Lagos"),("2329920", "Moriki", "", "NG", "566", "", "57", "814", "81408", "12.87405", "6.48754", "Africa/Lagos"),("2329946", "Monguno", "", "NG", "566", "", "27", "123", "12303", "12.67059", "13.61224", "Africa/Lagos"),("2329981", "Mokwa", "", "NG", "566", "", "31", "27017", "", "9.29482", "5.05412", "Africa/Lagos"),("2330028", "Modakeke", "", "NG", "566", "", "42", "30021", "", "7.38333", "4.26667", "Africa/Lagos"),("2330082", "Misau", "", "NG", "566", "", "46", "5014", "BA1415", "11.3137", "10.46664", "Africa/Lagos"),("2330087", "Miringa", "", "NG", "566", "", "27", "105", "10508", "10.73115", "12.14626", "Africa/Lagos"),("2330100", "Minna", "Минна", "NG", "566", "", "31", "27006", "", "9.61524", "6.54776", "Africa/Lagos"),("2330241", "Imeko", "", "NG", "566", "", "16", "28013", "", "7.44888", "2.84289", "Africa/Lagos"),("2330369", "Mberubu", "", "NG", "566", "", "47", "14011", "", "6.1731", "7.63017", "Africa/Lagos"),("2330543", "Mayo-Belwa", "", "NG", "566", "", "35", "2012", "", "9.05421", "12.05794", "Africa/Lagos"),("2330589", "Machina", "", "NG", "566", "", "44", "711", "71111", "13.13639", "10.04924", "Africa/Lagos"),("2330664", "Mashi", "", "NG", "566", "", "24", "427", "42708", "12.98044", "7.94703", "Africa/Lagos"),("2330717", "Maru", "", "NG", "566", "", "57", "810", "81008", "12.3336", "6.40372", "Africa/Lagos"),("2330719", "Marte", "", "NG", "566", "", "27", "121", "12109", "12.36532", "13.8293", "Africa/Lagos"),("2330937", "Mando", "", "NG", "566", "", "23", "19001", "KD0104", "10.71667", "6.56667", "Africa/Lagos"),("2331005", "Malumfashi", "", "NG", "566", "", "24", "425", "42507", "11.78935", "7.62061", "Africa/Lagos"),("2331037", "Mallammaduri", "", "NG", "566", "", "39", "18017", "JI2105", "12.56427", "9.95727", "Africa/Lagos"),("2331140", "Makurdi", "Макурди", "NG", "566", "", "26", "7013", "", "7.73375", "8.52139", "Africa/Lagos"),("2331158", "Makoko", "", "NG", "566", "", "05", "", "", "6.49611", "3.38778", "Africa/Lagos"),("2331267", "Maiyama", "", "NG", "566", "", "40", "514", "51408", "12.08225", "4.36907", "Africa/Lagos"),("2331447", "Maiduguri", "Майдугури", "NG", "566", "", "27", "124", "12414", "11.84692", "13.15712", "Africa/Lagos"),("2331493", "Mahuta", "", "NG", "566", "", "40", "509", "50904", "11.55338", "4.98138", "Africa/Lagos"),("2331528", "Magumeri", "", "NG", "566", "", "27", "120", "12013", "12.11451", "12.8262", "Africa/Lagos"),("2331686", "Madara", "", "NG", "566", "", "46", "5012", "BA1204", "11.7798", "10.4479", "Africa/Lagos"),("2331694", "Madala", "", "NG", "566", "", "11", "15003", "", "9.10444", "7.21333", "Africa/Lagos"),("2331715", "Madagali", "", "NG", "566", "", "35", "2010", "", "10.88942", "13.62832", "Africa/Lagos"),("2331939", "Lokoja", "", "NG", "566", "", "41", "23012", "", "7.79688", "6.74048", "Africa/Lagos"),("2332079", "Lere", "Лера", "NG", "566", "", "23", "19017", "KD1708", "10.38584", "8.57286", "Africa/Lagos"),("2332080", "Lere", "", "NG", "566", "", "46", "5017", "BA1703", "9.71052", "9.34029", "Africa/Lagos"),("2332197", "Lau", "", "NG", "566", "", "43", "35010", "", "9.20827", "11.27541", "Africa/Lagos"),("2332249", "Lapai", "", "NG", "566", "", "31", "27012", "", "9.04439", "6.57089", "Africa/Lagos"),("2332280", "Langtang", "", "NG", "566", "", "49", "32009", "", "9.14164", "9.79101", "Africa/Lagos"),("2332337", "Lame", "", "NG", "566", "", "46", "5018", "BA1807", "10.44154", "9.23955", "Africa/Lagos"),("2332357", "Lalupon", "", "NG", "566", "", "32", "31020", "", "7.46667", "4.06667", "Africa/Lagos"),("2332459", "Lagos", "Лагос", "NG", "566", "", "05", "", "", "6.45407", "3.39467", "Africa/Lagos"),("2332504", "Lafiagi", "", "NG", "566", "", "30", "24003", "", "8.85299", "5.41641", "Africa/Lagos"),("2332515", "Lafia", "", "NG", "566", "", "56", "26008", "", "8.4939", "8.51532", "Africa/Lagos"),("2332662", "Kwolla", "", "NG", "566", "", "49", "32014", "", "8.90361", "9.29086", "Africa/Lagos"),("2332733", "Kwatarkwashi", "", "NG", "566", "", "57", "805", "80507", "12.14082", "6.82196", "Africa/Lagos"),("2332865", "Kwali", "", "NG", "566", "", "11", "15005", "", "8.88346", "7.01858", "Africa/Lagos"),("2332871", "Kwale", "", "NG", "566", "", "36", "10012", "", "5.70773", "6.43402", "Africa/Lagos"),("2333064", "Kuta", "", "NG", "566", "", "31", "27022", "", "9.86864", "6.71042", "Africa/Lagos"),("2333096", "Kusheriki", "", "NG", "566", "", "31", "27020", "", "10.53283", "6.44222", "Africa/Lagos"),("2333312", "Kura", "", "NG", "566", "", "29", "20035", "KN2708", "11.77232", "8.42631", "Africa/Lagos"),("2333451", "Kumo", "", "NG", "566", "", "55", "16001", "", "10.04807", "11.21055", "Africa/Lagos"),("2333490", "Kumagunnam", "", "NG", "566", "", "44", "717", "71708", "13.15498", "10.63468", "Africa/Lagos"),("2333563", "Kukawa", "", "NG", "566", "", "27", "110", "11007", "12.92475", "13.56617", "Africa/Lagos"),("2333604", "Kuje", "", "NG", "566", "", "11", "15004", "", "8.87952", "7.22756", "Africa/Lagos"),("2333606", "Kujama", "", "NG", "566", "", "23", "19002", "KD0204", "10.45767", "7.63808", "Africa/Lagos"),("2333884", "Koton-Karfe", "", "NG", "566", "", "41", "23011", "", "8.0912", "6.79782", "Africa/Lagos"),("2334008", "Kontagora", "", "NG", "566", "", "31", "27011", "", "10.40319", "5.4708", "Africa/Lagos"),("2334018", "Konkwesso", "", "NG", "566", "", "31", "27004", "", "10.84686", "4.09835", "Africa/Lagos"),("2334044", "Konduga", "", "NG", "566", "", "27", "116", "11611", "11.65331", "13.41787", "Africa/Lagos"),("2334306", "Kiyawa", "", "NG", "566", "", "39", "18025", "JI1907", "11.78442", "9.6069", "Africa/Lagos"),("2334327", "Kisi", "", "NG", "566", "", "32", "31015", "", "9.08297", "3.85196", "Africa/Lagos"),("2334502", "Kibiya", "", "NG", "566", "", "29", "20033", "KN2308", "11.528", "8.66108", "Africa/Lagos"),("2334592", "Kende", "", "NG", "566", "", "40", "505", "50506", "11.51966", "4.2603", "Africa/Lagos"),("2334649", "Kafin Hausa", "", "NG", "566", "", "39", "18027", "JI1505", "12.23933", "9.91105", "Africa/Lagos"),("2334652", "Keffi", "", "NG", "566", "", "56", "26006", "", "8.84651", "7.87354", "Africa/Lagos"),("2334674", "Kazaure", "", "NG", "566", "", "39", "18010", "JI1706", "12.64846", "8.41178", "Africa/Lagos"),("2334756", "Kaura Namoda", "", "NG", "566", "", "57", "808", "80804", "12.59371", "6.58648", "Africa/Lagos"),("2334801", "Katsina-Ala", "", "NG", "566", "", "26", "7009", "", "7.16938", "9.28465", "Africa/Lagos"),("2334802", "Katsina", "Катсина", "NG", "566", "", "24", "421", "42103", "12.99082", "7.60177", "Africa/Lagos"),("2334861", "Katagum", "", "NG", "566", "", "46", "5020", "BA2002", "12.28507", "10.35027", "Africa/Lagos"),("2335015", "Kari", "", "NG", "566", "", "46", "5005", "BA0505", "11.2471", "10.561", "Africa/Lagos"),("2335204", "Kano", "Кано", "NG", "566", "", "29", "20043", "KN2106", "12.00012", "8.51672", "Africa/Lagos"),("2335219", "Kankara", "", "NG", "566", "", "24", "419", "41905", "11.93114", "7.41115", "Africa/Lagos"),("2335333", "Kamba", "Камба", "NG", "566", "", "40", "508", "50806", "11.85172", "3.65478", "Africa/Lagos"),("2335369", "Kaltungo", "", "NG", "566", "", "55", "16007", "", "9.81998", "11.30871", "Africa/Lagos"),("2335500", "Kajuru", "", "NG", "566", "", "23", "19012", "KD1204", "10.32281", "7.68462", "Africa/Lagos"),("2335568", "Kangiwa", "", "NG", "566", "", "40", "502", "50208", "12.55339", "3.81814", "Africa/Lagos"),("2335596", "Kaiama", "", "NG", "566", "", "30", "24011", "", "9.6053", "3.94101", "Africa/Lagos"),("2335614", "Kagoro", "", "NG", "566", "", "23", "19013", "KD1303", "9.60776", "8.39043", "Africa/Lagos"),("2335709", "Kafarati", "", "NG", "566", "", "55", "16008", "", "10.38304", "11.09567", "Africa/Lagos"),("2335713", "Kafanchan", "", "NG", "566", "", "23", "19007", "KD0707", "9.58126", "8.2926", "Africa/Lagos"),("2335727", "Kaduna", "Кадуна", "NG", "566", "", "23", "19009", "KD0910", "10.52641", "7.43879", "Africa/Lagos"),("2335798", "Kachia", "", "NG", "566", "", "23", "19008", "KD0808", "9.87342", "7.95407", "Africa/Lagos"),("2335843", "Kabba", "", "NG", "566", "", "41", "23010", "", "7.82719", "6.07502", "Africa/Lagos"),("2335953", "Jos", "Йос", "NG", "566", "", "49", "32005", "", "9.92849", "8.89212", "Africa/Lagos"),("2336056", "Jimeta", "", "NG", "566", "", "35", "2004", "", "9.27949", "12.45819", "Africa/Lagos"),("2336092", "Jikamshi", "", "NG", "566", "", "24", "429", "42905", "12.17328", "7.77424", "Africa/Lagos"),("2336137", "Jibia", "", "NG", "566", "", "24", "416", "41607", "13.09378", "7.22624", "Africa/Lagos"),("2336237", "Jega", "", "NG", "566", "", "40", "511", "51109", "12.22219", "4.37963", "Africa/Lagos"),("2336251", "Jebba", "", "NG", "566", "", "30", "24012", "", "9.13333", "4.83333", "Africa/Lagos"),("2336589", "Jalingo", "", "NG", "566", "", "43", "35007", "", "8.89367", "11.3596", "Africa/Lagos"),("2336624", "Lajere", "", "NG", "566", "", "44", "705", "70512", "11.98022", "11.44002", "Africa/Lagos"),("2336905", "Iwo", "Иво", "NG", "566", "", "42", "30023", "", "7.63527", "4.18156", "Africa/Lagos"),("2336985", "Itu", "", "NG", "566", "", "21", "3016", "", "5.20131", "7.98373", "Africa/Lagos"),("2337148", "Isieke", "", "NG", "566", "", "53", "11012", "", "6.38186", "8.03736", "Africa/Lagos"),("2337207", "Ise-Ekiti", "", "NG", "566", "", "54", "13014", "", "7.46478", "5.42333", "Africa/Lagos"),("2337227", "Isara", "", "NG", "566", "", "16", "28019", "", "6.99345", "3.68148", "Africa/Lagos"),("2337235", "Isanlu-Itedoijowa", "", "NG", "566", "", "41", "23020", "", "8.27445", "5.83528", "Africa/Lagos"),("2337352", "Ipoti", "", "NG", "566", "", "54", "13009", "", "7.87377", "5.07691", "Africa/Lagos"),("2337379", "Iperu", "", "NG", "566", "", "16", "28012", "", "6.91002", "3.66557", "Africa/Lagos"),("2337490", "Inisa", "", "NG", "566", "", "42", "30010", "", "7.85", "4.33333", "Africa/Lagos"),("2337639", "Ilorin", "", "NG", "566", "", "30", "24006", "", "8.49664", "4.54214", "Africa/Lagos"),("2337659", "Ilobu", "", "NG", "566", "", "42", "30020", "", "7.84036", "4.48557", "Africa/Lagos"),("2337666", "Illushi", "", "NG", "566", "", "37", "12005", "", "6.67033", "6.62907", "Africa/Lagos"),("2337680", "Illela", "", "NG", "566", "", "51", "608", "60807", "13.73064", "5.29777", "Africa/Lagos"),("2337704", "Ilesa", "", "NG", "566", "", "42", "30019", "", "7.62789", "4.74161", "Africa/Lagos"),("2337759", "Ilaro", "", "NG", "566", "", "16", "28005", "", "6.88901", "3.01416", "Africa/Lagos"),("2337762", "Ilare", "", "NG", "566", "", "48", "29009", "", "7.35067", "5.11333", "Africa/Lagos"),("2337765", "Ila Orangun", "", "NG", "566", "", "42", "30017", "", "8.01714", "4.90421", "Africa/Lagos"),("2338106", "Ikot Ekpene", "", "NG", "566", "", "21", "3014", "", "5.18194", "7.71481", "Africa/Lagos"),("2338242", "Ikom", "", "NG", "566", "", "22", "9011", "", "5.96669", "8.70632", "Africa/Lagos"),("2338269", "Ikirun", "", "NG", "566", "", "42", "30016", "", "7.91283", "4.66741", "Africa/Lagos"),("2338273", "Ikire", "", "NG", "566", "", "42", "30021", "", "7.37241", "4.18739", "Africa/Lagos"),("2338287", "Ikere-Ekiti", "", "NG", "566", "", "54", "13010", "", "7.49748", "5.23041", "Africa/Lagos"),("2338305", "Ikem", "", "NG", "566", "", "47", "14010", "", "6.77993", "7.71484", "Africa/Lagos"),("2338313", "Ikeja", "", "NG", "566", "", "05", "25011", "", "6.59651", "3.34205", "Africa/Lagos"),("2338334", "Ikang", "", "NG", "566", "", "22", "9003", "", "4.78978", "8.5316", "Africa/Lagos"),("2338385", "Ijero-Ekiti", "", "NG", "566", "", "54", "13009", "", "7.81514", "5.06716", "Africa/Lagos"),("2338400", "Ijebu-Ode", "", "NG", "566", "", "16", "28011", "", "6.81944", "3.91731", "Africa/Lagos"),("2338401", "Ijebu-Jesa", "", "NG", "566", "", "42", "30028", "", "7.68267", "4.81436", "Africa/Lagos"),("2338403", "Ijebu-Igbo", "", "NG", "566", "", "16", "28009", "", "6.97198", "3.99938", "Africa/Lagos"),("2338404", "Ijebu-Ife", "", "NG", "566", "", "16", "28008", "", "6.77837", "4.03386", "Africa/Lagos"),("2338469", "Iho", "", "NG", "566", "", "28", "17008", "", "5.58225", "7.09896", "Africa/Lagos"),("2338497", "Ihiala", "", "NG", "566", "", "25", "4012", "", "5.85475", "6.85944", "Africa/Lagos"),("2338630", "Igede-Ekiti", "", "NG", "566", "", "54", "13013", "", "7.6685", "5.12627", "Africa/Lagos"),("2338640", "Igbo-Ukwu", "", "NG", "566", "", "25", "4001", "", "6.01798", "7.02027", "Africa/Lagos"),("2338660", "Igbor", "", "NG", "566", "", "26", "7007", "", "7.45123", "8.60805", "Africa/Lagos"),("2338669", "Igbo-Ora", "", "NG", "566", "", "32", "31011", "", "7.43383", "3.28788", "Africa/Lagos"),("2338711", "Igboho", "", "NG", "566", "", "32", "31027", "", "8.83784", "3.75628", "Africa/Lagos"),("2338772", "Igbeti", "", "NG", "566", "", "32", "31024", "", "8.74921", "4.13113", "Africa/Lagos"),("2338810", "Igbara-Odo", "", "NG", "566", "", "54", "13004", "", "7.50251", "5.06258", "Africa/Lagos"),("2338840", "Igarra", "", "NG", "566", "", "37", "12001", "", "7.29366", "6.10432", "Africa/Lagos"),("2338863", "Igabi", "", "NG", "566", "", "23", "19004", "KD0411", "10.80603", "7.71443", "Africa/Lagos"),("2338873", "Ifon", "", "NG", "566", "", "48", "29017", "", "6.92973", "5.77368", "Africa/Lagos"),("2338876", "Ifo", "", "NG", "566", "", "16", "28007", "", "6.81491", "3.19518", "Africa/Lagos"),("2338908", "Ifaki", "", "NG", "566", "", "54", "13008", "", "7.78942", "5.24852", "Africa/Lagos"),("2339065", "Idi Iroko", "", "NG", "566", "", "16", "", "", "6.63333", "2.73333", "Africa/Lagos"),("2339150", "Idanre", "", "NG", "566", "", "48", "29008", "", "7.1127", "5.1159", "Africa/Lagos"),("2339156", "Idah", "", "NG", "566", "", "41", "23007", "", "7.11345", "6.73866", "Africa/Lagos"),("2339170", "Icheu", "", "NG", "566", "", "41", "23004", "", "7.7067", "6.7718", "Africa/Lagos"),("2339287", "Ibi", "", "NG", "566", "", "43", "35006", "", "8.18122", "9.74431", "Africa/Lagos"),("2339293", "Ibeto", "", "NG", "566", "", "31", "27014", "", "10.48536", "5.14501", "Africa/Lagos"),("2339354", "Ibadan", "Ибадан", "NG", "566", "", "32", "31008", "", "7.37756", "3.90591", "Africa/Lagos"),("2339403", "Hunkuyi", "", "NG", "566", "", "23", "19016", "KD1603", "11.2668", "7.64916", "Africa/Lagos"),("2339468", "Holma", "", "NG", "566", "", "35", "2011", "", "9.89863", "13.0545", "Africa/Lagos"),("2339483", "Hinna", "", "NG", "566", "", "55", "16011", "", "10.30426", "11.49905", "Africa/Lagos"),("2339631", "Hadejia", "", "NG", "566", "", "39", "18011", "JI1303", "12.45347", "10.04115", "Africa/Lagos"),("2339665", "Gwoza", "", "NG", "566", "", "27", "111", "11108", "11.08313", "13.69595", "Africa/Lagos"),("2339706", "Gwio Kura", "", "NG", "566", "", "44", "701", "70102", "12.67479", "11.0669", "Africa/Lagos"),("2339753", "Gwasero", "", "NG", "566", "", "30", "24002", "", "9.48333", "3.5", "Africa/Lagos"),("2339756", "Gwarzo", "", "NG", "566", "", "29", "20017", "KN1903", "11.91597", "7.9337", "Africa/Lagos"),("2339786", "Gwaram", "", "NG", "566", "", "39", "18008", "JI1105", "11.27727", "9.88385", "Africa/Lagos"),("2339789", "Gwaram", "", "NG", "566", "", "46", "5001", "BA0104", "10.23295", "10.28572", "Africa/Lagos"),("2339811", "Gwandu", "", "NG", "566", "", "40", "510", "51005", "12.50204", "4.64295", "Africa/Lagos"),("2339892", "Gwadabawa", "", "NG", "566", "", "51", "607", "60706", "13.35819", "5.23812", "Africa/Lagos"),("2339937", "Gusau", "Гусау", "NG", "566", "", "57", "807", "80708", "12.17024", "6.66412", "Africa/Lagos"),("2340086", "Gummi", "Кунми", "NG", "566", "", "57", "806", "80609", "12.14484", "5.11776", "Africa/Lagos"),("2340091", "Gumel", "", "NG", "566", "", "39", "18006", "JI0907", "12.6269", "9.38807", "Africa/Lagos"),("2340132", "Gulma", "", "NG", "566", "", "40", "503", "50305", "12.64231", "4.35545", "Africa/Lagos"),("2340170", "Gujba", "", "NG", "566", "", "44", "707", "70708", "11.49959", "11.93396", "Africa/Lagos"),("2340323", "Goronyo", "", "NG", "566", "", "51", "605", "60504", "13.44226", "5.67234", "Africa/Lagos"),("2340350", "Gorgoram", "", "NG", "566", "", "44", "709", "70904", "12.63958", "10.70422", "Africa/Lagos"),("2340389", "Gora", "", "NG", "566", "", "24", "425", "42512", "11.91294", "7.66531", "Africa/Lagos"),("2340404", "Goniri", "", "NG", "566", "", "44", "707", "70704", "11.48451", "12.31264", "Africa/Lagos"),("2340446", "Gombi", "", "NG", "566", "", "35", "2005", "", "10.16756", "12.73684", "Africa/Lagos"),("2340451", "Gombe", "", "NG", "566", "", "55", "16006", "", "10.28969", "11.16729", "Africa/Lagos"),("2341275", "Gembu", "", "NG", "566", "", "43", "35011", "", "6.72556", "11.25652", "Africa/Lagos"),("2341294", "Geidam", "", "NG", "566", "", "44", "706", "70611", "12.89439", "11.92649", "Africa/Lagos"),("2341355", "Gbongan", "", "NG", "566", "", "42", "30001", "", "7.47734", "4.35351", "Africa/Lagos"),("2341580", "Gaya", "", "NG", "566", "", "29", "20007", "KN1604", "11.86064", "9.0027", "Africa/Lagos"),("2341641", "Gassol", "", "NG", "566", "", "43", "35005", "", "8.53535", "10.44615", "Africa/Lagos"),("2341656", "Gashua", "", "NG", "566", "", "44", "701", "70107", "12.87398", "11.04057", "Africa/Lagos"),("2341758", "Garko", "", "NG", "566", "", "55", "16001", "", "10.17506", "11.16458", "Africa/Lagos"),("2341955", "Ganye", "", "NG", "566", "", "35", "2003", "", "8.43497", "12.05107", "Africa/Lagos"),("2342125", "Gandi", "", "NG", "566", "", "51", "612", "61201", "12.96358", "5.74337", "Africa/Lagos"),("2342192", "Gamboru", "", "NG", "566", "", "27", "125", "12503", "12.37299", "14.2069", "Africa/Lagos"),("2342199", "Gamawa", "", "NG", "566", "", "46", "5007", "BA0701", "12.13379", "10.53785", "Africa/Lagos"),("2342291", "Gakem", "", "NG", "566", "", "22", "", "", "6.76963", "8.9912", "Africa/Lagos"),("2342340", "Gagarawa", "", "NG", "566", "", "39", "18016", "JI0701", "12.40848", "9.52881", "Africa/Lagos"),("2342439", "Gabarin", "", "NG", "566", "", "46", "5005", "BA0503", "11.1093", "10.4441", "Africa/Lagos"),("2342490", "Funtua", "", "NG", "566", "", "24", "414", "41403", "11.52351", "7.31174", "Africa/Lagos"),("2342628", "Fiditi", "", "NG", "566", "", "32", "31001", "", "7.71361", "3.91722", "Africa/Lagos"),("2342883", "Ezza-Ohu", "", "NG", "566", "", "53", "11004", "", "6.44094", "8.08432", "Africa/Lagos"),("2343057", "Etinan", "", "NG", "566", "", "21", "3007", "", "4.84262", "7.85252", "Africa/Lagos"),("2343073", "Ete", "", "NG", "566", "", "47", "14008", "", "7.08956", "7.45341", "Africa/Lagos"),("2343093", "Esuk Oron", "", "NG", "566", "", "21", "3025", "", "4.80293", "8.25341", "Africa/Lagos"),("2343252", "Epe", "Эпе", "NG", "566", "", "05", "25007", "", "6.58412", "3.98336", "Africa/Lagos"),("2343270", "Enugu-Ukwu", "", "NG", "566", "", "25", "4013", "", "6.17146", "7.00525", "Africa/Lagos"),("2343273", "Enugu-Ezike", "", "NG", "566", "", "47", "14008", "", "6.9827", "7.45534", "Africa/Lagos"),("2343279", "Enugu", "Энугу", "NG", "566", "", "47", "14004", "", "6.44132", "7.49883", "Africa/Lagos"),("2343299", "Emure-Ekiti", "", "NG", "566", "", "54", "13006", "", "7.43636", "5.45925", "Africa/Lagos"),("2343512", "Elele", "", "NG", "566", "", "50", "33013", "", "5.1009", "6.81411", "Africa/Lagos"),("2343641", "Ekpoma", "", "NG", "566", "", "37", "12006", "", "6.743", "6.14029", "Africa/Lagos"),("2343720", "Eket", "", "NG", "566", "", "21", "3003", "", "4.64231", "7.92438", "Africa/Lagos"),("2343776", "Ejirin", "", "NG", "566", "", "05", "25007", "", "6.61423", "3.90019", "Africa/Lagos"),("2343784", "Ejigbo", "", "NG", "566", "", "42", "30010", "", "7.90292", "4.31419", "Africa/Lagos"),("2343822", "Eha Amufu", "", "NG", "566", "", "47", "14010", "", "6.65915", "7.75961", "Africa/Lagos"),("2343943", "Egbe", "", "NG", "566", "", "41", "23021", "", "8.21667", "5.51667", "Africa/Lagos"),("2343983", "Efon-Alaaye", "", "NG", "566", "", "54", "13002", "", "7.65649", "4.92235", "Africa/Lagos"),("2343985", "Effium", "", "NG", "566", "", "53", "11012", "", "6.63105", "8.05814", "Africa/Lagos"),("2344082", "Ebute Ikorodu", "", "NG", "566", "", "05", "25012", "", "6.60086", "3.48818", "Africa/Lagos"),("2344217", "Dutsin-Ma", "", "NG", "566", "", "24", "412", "41204", "12.45392", "7.49723", "Africa/Lagos"),("2344229", "Dutsen Wai", "", "NG", "566", "", "23", "19015", "KD1503", "10.85009", "8.199", "Africa/Lagos"),("2344245", "Dutse", "", "NG", "566", "", "39", "18012", "JI0609", "11.75618", "9.33896", "Africa/Lagos"),("2344415", "Duku", "", "NG", "566", "", "31", "27021", "", "11.2361", "4.90727", "Africa/Lagos"),("2344418", "Dukku", "", "NG", "566", "", "55", "16004", "", "10.82379", "10.77221", "Africa/Lagos"),("2344600", "Doma", "", "NG", "566", "", "56", "26003", "", "8.39307", "8.35544", "Africa/Lagos"),("2344760", "Disina", "", "NG", "566", "", "46", "5016", "BA1604", "11.48135", "9.91903", "Africa/Lagos"),("2344804", "Dindima", "", "NG", "566", "", "46", "5002", "BA0210", "10.22629", "10.15132", "Africa/Lagos"),("2344854", "Dikwa", "", "NG", "566", "", "27", "108", "10803", "12.03609", "13.91815", "Africa/Lagos"),("2344941", "Dengi", "", "NG", "566", "", "49", "32007", "", "9.36872", "9.96223", "Africa/Lagos"),("2344981", "Dekina", "", "NG", "566", "", "41", "23005", "", "7.68967", "7.0438", "Africa/Lagos"),("2345029", "Deba", "", "NG", "566", "", "55", "16011", "", "10.21187", "11.3871", "Africa/Lagos"),("2345094", "Daura", "Даура", "NG", "566", "", "24", "410", "41009", "13.03299", "8.32351", "Africa/Lagos"),("2345096", "Daura", "", "NG", "566", "", "44", "705", "70503", "11.5541", "11.406", "Africa/Lagos"),("2345152", "Darazo", "", "NG", "566", "", "46", "5005", "BA0501", "10.9992", "10.41062", "Africa/Lagos"),("2345172", "Dapchi", "", "NG", "566", "", "44", "702", "70205", "12.49536", "11.49977", "Africa/Lagos"),("2345213", "Dan Sadau", "", "NG", "566", "", "57", "810", "81005", "11.29621", "6.4952", "Africa/Lagos"),("2345282", "Dankama", "", "NG", "566", "", "24", "418", "41804", "13.29782", "7.79492", "Africa/Lagos"),("2345283", "Dankalwa", "", "NG", "566", "", "44", "703", "70304", "11.74449", "12.18545", "Africa/Lagos"),("2345306", "Danja", "", "NG", "566", "", "24", "408", "40803", "11.3771", "7.56097", "Africa/Lagos"),("2345336", "Dan Gora", "", "NG", "566", "", "29", "20034", "KN2404", "11.53485", "8.15224", "Africa/Lagos"),("2345349", "Dange", "", "NG", "566", "", "51", "603", "60302", "12.85313", "5.34572", "Africa/Lagos"),("2345498", "Damboa", "", "NG", "566", "", "27", "107", "10703", "11.15534", "12.75638", "Africa/Lagos"),("2345505", "Dambatta", "", "NG", "566", "", "29", "20023", "KN0802", "12.435", "8.51531", "Africa/Lagos"),("2345521", "Damaturu", "", "NG", "566", "", "44", "703", "70311", "11.74697", "11.96083", "Africa/Lagos"),("2345526", "Damasak", "", "NG", "566", "", "27", "122", "12203", "13.10518", "12.50854", "Africa/Lagos"),("2345643", "Dakingari", "", "NG", "566", "", "40", "518", "51805", "11.64809", "4.06177", "Africa/Lagos"),("2345785", "Dadiya", "", "NG", "566", "", "55", "16002", "", "9.61667", "11.43333", "Africa/Lagos"),("2345872", "Dabai", "", "NG", "566", "", "40", "521", "52104", "11.47651", "5.20625", "Africa/Lagos"),("2346199", "Tsafe", "", "NG", "566", "", "57", "813", "81307", "11.95775", "6.92083", "Africa/Lagos"),("2346229", "Calabar", "Калабар", "NG", "566", "", "22", "9008", "", "4.95893", "8.32695", "Africa/Lagos"),("2346317", "Burutu", "", "NG", "566", "", "36", "10004", "", "5.35328", "5.50826", "Africa/Lagos"),("2346322", "Burumburum", "", "NG", "566", "", "23", "", "", "11.39106", "8.72341", "Africa/Lagos"),("2346396", "Bunza", "", "NG", "566", "", "40", "507", "50702", "12.08444", "4.02111", "Africa/Lagos"),("2346399", "Bununu", "", "NG", "566", "", "46", "5017", "BA1711", "9.88224", "9.68058", "Africa/Lagos"),("2346401", "Dass", "", "NG", "566", "", "46", "5006", "BA0603", "10.00065", "9.51596", "Africa/Lagos"),("2346561", "Bukuru", "", "NG", "566", "", "49", "32006", "", "9.79399", "8.86397", "Africa/Lagos"),("2346615", "Buguma", "", "NG", "566", "", "50", "33006", "", "4.73614", "6.86236", "Africa/Lagos"),("2346632", "Buga", "", "NG", "566", "", "56", "26012", "", "8.49056", "7.34139", "Africa/Lagos"),("2346734", "Twon-Brass", "", "NG", "566", "", "52", "", "", "4.31231", "6.24091", "Africa/Lagos"),("2346788", "Bornu Yassu", "", "NG", "566", "", "27", "120", "12003", "12.27503", "12.56856", "Africa/Lagos"),("2346800", "Bori", "", "NG", "566", "", "50", "33014", "", "4.67629", "7.36519", "Africa/Lagos"),("2346805", "Ugbokpo", "", "NG", "566", "", "26", "7003", "", "7.65321", "7.8841", "Africa/Lagos"),("2346812", "Bonny", "", "NG", "566", "", "50", "", "", "4.4516", "7.17074", "Africa/Lagos"),("2346843", "Bomadi", "", "NG", "566", "", "36", "10003", "", "5.16073", "5.92375", "Africa/Lagos"),("2346887", "Bokkos", "", "NG", "566", "", "49", "32003", "", "9.29921", "8.99467", "Africa/Lagos"),("2346893", "Bokani", "", "NG", "566", "", "31", "27017", "", "9.43333", "5.2", "Africa/Lagos"),("2346896", "Boju", "", "NG", "566", "", "26", "7016", "", "7.35572", "7.89303", "Africa/Lagos"),("2346906", "Boi", "", "NG", "566", "", "46", "5003", "BA0304", "9.56109", "9.50154", "Africa/Lagos"),("2346951", "Bode Saadu", "", "NG", "566", "", "30", "24012", "", "8.939", "4.78227", "Africa/Lagos"),("2346995", "Biu", "", "NG", "566", "", "27", "105", "10509", "10.61285", "12.19458", "Africa/Lagos"),("2347041", "Birniwa", "", "NG", "566", "", "39", "18021", "JI0402", "12.7907", "10.23614", "Africa/Lagos"),("2347057", "Birnin Kudu", "", "NG", "566", "", "39", "18022", "JI0301", "11.45207", "9.47856", "Africa/Lagos"),("2347059", "Birnin Kebbi", "", "NG", "566", "", "40", "506", "50613", "12.45389", "4.1975", "Africa/Lagos"),("2347061", "Sofo-Birnin-Gwari", "", "NG", "566", "", "23", "19001", "KD0105", "11.01537", "6.78036", "Africa/Lagos"),("2347109", "Bin Yauri", "", "NG", "566", "", "40", "515", "51501", "10.7823", "4.81135", "Africa/Lagos"),("2347116", "Binji", "", "NG", "566", "", "51", "601", "60101", "13.22294", "4.90888", "Africa/Lagos"),("2347155", "Billiri", "", "NG", "566", "", "55", "16003", "", "9.86545", "11.22624", "Africa/Lagos"),("2347209", "Bida", "Бида", "NG", "566", "", "31", "27003", "", "9.08044", "6.0099", "Africa/Lagos"),("2347279", "Benisheikh", "", "NG", "566", "", "27", "114", "11401", "11.80919", "12.49151", "Africa/Lagos"),("2347283", "Benin City", "Бенин-Сити", "NG", "566", "", "37", "12012", "", "6.33815", "5.62575", "Africa/Lagos"),("2347303", "Bende", "", "NG", "566", "", "45", "1004", "", "5.55874", "7.63359", "Africa/Lagos"),("2347304", "Bena", "", "NG", "566", "", "40", "519", "51902", "11.28444", "5.93472", "Africa/Lagos"),("2347330", "Beli", "", "NG", "566", "", "43", "35002", "", "7.85868", "10.97187", "Africa/Lagos"),("2347383", "Bebeji", "", "NG", "566", "", "29", "20025", "KN0403", "11.66768", "8.262", "Africa/Lagos"),("2347470", "Bauchi", "Баучи", "NG", "566", "", "46", "5002", "BA0215", "10.31032", "9.84388", "Africa/Lagos"),("2347483", "Batsari", "", "NG", "566", "", "24", "403", "40302", "12.75551", "7.24809", "Africa/Lagos"),("2347592", "Baro", "Баро", "NG", "566", "", "31", "27012", "", "8.6", "6.41667", "Africa/Lagos"),("2347758", "Bara", "", "NG", "566", "", "55", "", "", "10.37444", "10.72884", "Africa/Lagos"),("2347954", "Bama", "", "NG", "566", "", "27", "103", "10310", "11.52134", "13.68952", "Africa/Lagos"),("2348118", "Bakori", "", "NG", "566", "", "24", "401", "40102", "11.55559", "7.42419", "Africa/Lagos"),("2348228", "Baissa", "", "NG", "566", "", "43", "35009", "", "7.23087", "10.62444", "Africa/Lagos"),("2348259", "Bagudo", "", "NG", "566", "", "40", "505", "50501", "11.40351", "4.22571", "Africa/Lagos"),("2348298", "Bugana", "", "NG", "566", "", "41", "23019", "", "7.99917", "7.58361", "Africa/Lagos"),("2348365", "Badeggi", "", "NG", "566", "", "31", "27010", "", "9.0563", "6.143", "Africa/Lagos"),("2348395", "Badagry", "", "NG", "566", "", "05", "25006", "", "6.41502", "2.88132", "Africa/Lagos"),("2348419", "Babura", "", "NG", "566", "", "39", "18004", "JI0201", "12.77256", "9.01525", "Africa/Lagos"),("2348507", "Babana", "", "NG", "566", "", "31", "27004", "", "10.42949", "3.81495", "Africa/Lagos"),("2348595", "Azare", "", "NG", "566", "", "46", "5012", "BA1202", "11.67478", "10.19069", "Africa/Lagos"),("2348773", "Awka", "", "NG", "566", "", "25", "4006", "", "6.21269", "7.07199", "Africa/Lagos"),("2348783", "Awgu", "", "NG", "566", "", "47", "14002", "", "6.07278", "7.47739", "Africa/Lagos"),("2348874", "Auna", "", "NG", "566", "", "31", "27014", "", "10.18805", "4.72318", "Africa/Lagos"),("2348892", "Auchi", "", "NG", "566", "", "37", "12009", "", "7.06756", "6.2636", "Africa/Lagos"),("2349276", "Asaba", "Асаба", "NG", "566", "", "36", "10015", "", "6.19824", "6.73187", "Africa/Lagos"),("2349360", "Arochukwu", "", "NG", "566", "", "45", "1003", "", "5.38941", "7.91235", "Africa/Lagos"),("2349431", "Argungu", "", "NG", "566", "", "40", "503", "50302", "12.74482", "4.52514", "Africa/Lagos"),("2349529", "Aramoko-Ekiti", "", "NG", "566", "", "54", "13005", "", "7.70483", "5.04054", "Africa/Lagos"),("2349558", "Apomu", "", "NG", "566", "", "42", "30022", "", "7.35156", "4.18335", "Africa/Lagos"),("2349788", "Ankpa", "", "NG", "566", "", "41", "23003", "", "7.40249", "7.63196", "Africa/Lagos"),("2349797", "Anka", "", "NG", "566", "", "57", "801", "80103", "12.11347", "5.92681", "Africa/Lagos"),("2349951", "Anchau", "", "NG", "566", "", "23", "19015", "KD1501", "10.96245", "8.39233", "Africa/Lagos"),("2350027", "Amper", "", "NG", "566", "", "49", "32008", "", "9.35509", "9.70121", "Africa/Lagos"),("2350172", "Amassoma", "", "NG", "566", "", "52", "6007", "", "4.97032", "6.10915", "Africa/Lagos"),("2350249", "Amaigbo", "", "NG", "566", "", "45", "", "", "5.78917", "7.83829", "Africa/Lagos"),("2350259", "Amagunze", "", "NG", "566", "", "47", "14011", "", "6.33063", "7.65247", "Africa/Lagos"),("2350436", "Aliade", "", "NG", "566", "", "26", "7007", "", "7.29627", "8.48278", "Africa/Lagos"),("2350592", "Alapa", "", "NG", "566", "", "32", "", "", "8.61667", "4.38333", "Africa/Lagos"),("2350806", "Akwanga", "", "NG", "566", "", "56", "26001", "", "8.91077", "8.40655", "Africa/Lagos"),("2350841", "Akure", "", "NG", "566", "", "48", "29006", "", "7.25256", "5.19312", "Africa/Lagos"),("2350886", "Aku", "", "NG", "566", "", "47", "14007", "", "6.70902", "7.31826", "Africa/Lagos"),("2351027", "Akko", "", "NG", "566", "", "55", "16001", "", "10.28899", "10.9732", "Africa/Lagos"),("2351156", "Ake-Eze", "", "NG", "566", "", "47", "", "", "5.91677", "7.67615", "Africa/Lagos"),("2351209", "Akankpa", "", "NG", "566", "", "22", "9015", "", "5.1264", "8.1898", "Africa/Lagos"),("2351461", "Ajasse Ipo", "", "NG", "566", "", "30", "24009", "", "8.23333", "4.81667", "Africa/Lagos"),("2351470", "Ajaokuta", "", "NG", "566", "", "41", "23002", "", "7.56229", "6.65497", "Africa/Lagos"),("2351657", "Ahoada", "", "NG", "566", "", "50", "33002", "", "5.0828", "6.64981", "Africa/Lagos"),("2351740", "Agulu", "", "NG", "566", "", "25", "4004", "", "6.10045", "7.061", "Africa/Lagos"),("2351850", "Ago Are", "", "NG", "566", "", "32", "31004", "", "8.5", "3.41667", "Africa/Lagos"),("2351927", "Agenebode", "", "NG", "566", "", "37", "12008", "", "7.10512", "6.69381", "Africa/Lagos"),("2351979", "Agbor", "Агбор", "NG", "566", "", "36", "10008", "", "6.25375", "6.1942", "Africa/Lagos"),("2352110", "Agbabu", "", "NG", "566", "", "48", "29014", "", "6.58862", "4.8343", "Africa/Lagos"),("2352175", "Agaie", "", "NG", "566", "", "31", "27001", "", "9.0085", "6.31821", "Africa/Lagos"),("2352250", "Afikpo", "", "NG", "566", "", "53", "11002", "", "5.89258", "7.93534", "Africa/Lagos"),("2352352", "Adoru", "", "NG", "566", "", "41", "23008", "", "6.97694", "7.16262", "Africa/Lagos"),("2352356", "Ado Odo", "", "NG", "566", "", "16", "28003", "", "6.6", "2.93333", "Africa/Lagos"),("2352379", "Ado-Ekiti", "", "NG", "566", "", "54", "13001", "", "7.62329", "5.22087", "Africa/Lagos"),("2352589", "Adani", "", "NG", "566", "", "47", "14017", "", "6.73971", "7.01117", "Africa/Lagos"),("2352778", "Abuja", "Абуджа", "NG", "566", "", "11", "15006", "", "9.05785", "7.49508", "Africa/Lagos"),("2352804", "Abraka", "", "NG", "566", "", "36", "10005", "", "5.79023", "6.10473", "Africa/Lagos"),("2352857", "Abocho", "", "NG", "566", "", "41", "23005", "", "7.5677", "6.9863", "Africa/Lagos"),("2352947", "Abeokuta", "Абеокута", "NG", "566", "", "16", "28002", "", "7.15571", "3.34509", "Africa/Lagos"),("2353099", "Abakaliki", "", "NG", "566", "", "53", "11004", "", "6.32485", "8.11368", "Africa/Lagos"),("2353100", "Abak", "", "NG", "566", "", "21", "3001", "", "4.98236", "7.78922", "Africa/Lagos"),("2353151", "Aba", "Аба", "NG", "566", "", "45", "1002", "", "5.10658", "7.36667", "Africa/Lagos"),("2591159", "Degema Hulk", "", "NG", "566", "", "50", "33001", "", "4.76145", "6.74957", "Africa/Lagos"),("2743477", "Zwolle", "Зволле", "NL", "528", "", "15", "0193", "", "52.5125", "6.09444", "Europe/Amsterdam"),("2743493", "Zwijndrecht", "Звейндрехте", "NL", "528", "", "11", "0642", "", "51.8175", "4.63333", "Europe/Amsterdam"),("2743590", "De Westereen", "", "NL", "528", "", "02", "1891", "", "53.25731", "6.0363", "Europe/Amsterdam"),("2743608", "Zutphen", "Зютфен", "NL", "528", "", "03", "0301", "", "52.13833", "6.20139", "Europe/Amsterdam"),("2743619", "Zundert", "Зюндерт", "NL", "528", "", "06", "0879", "", "51.47167", "4.65556", "Europe/Amsterdam"),("2743680", "Zuidlaren", "", "NL", "528", "", "01", "1730", "", "53.09417", "6.68194", "Europe/Amsterdam"),("2743694", "Zuidhorn", "", "NL", "528", "", "04", "0056", "", "53.24667", "6.40278", "Europe/Amsterdam"),("2743856", "Zoetermeer", "", "NL", "528", "", "11", "0637", "", "52.0575", "4.49306", "Europe/Amsterdam"),("2743949", "Zevenaar", "Зевенар", "NL", "528", "", "03", "0299", "", "51.93", "6.07083", "Europe/Amsterdam"),("2743952", "Zetten", "", "NL", "528", "", "03", "1734", "", "51.92833", "5.71389", "Europe/Amsterdam"),("2743963", "Zelhem", "", "NL", "528", "", "03", "1876", "", "52.00667", "6.34861", "Europe/Amsterdam"),("2743977", "Zeist", "Зейст", "NL", "528", "", "09", "0355", "", "52.09", "5.23333", "Europe/Amsterdam"),("2743997", "Zeewolde", "", "NL", "528", "", "16", "0050", "", "52.33", "5.54167", "Europe/Amsterdam"),("2744014", "Zeeland", "", "NL", "528", "", "06", "1685", "", "51.6975", "5.67639", "Europe/Amsterdam"),("2744042", "Zandvoort", "Зандвоорт", "NL", "528", "", "07", "0473", "", "52.37125", "4.53306", "Europe/Amsterdam"),("2744102", "Zaltbommel", "", "NL", "528", "", "03", "0297", "", "51.81", "5.24444", "Europe/Amsterdam"),("2744114", "Zaanstad", "", "NL", "528", "", "07", "0479", "", "52.45313", "4.81356", "Europe/Amsterdam"),("2744116", "Zaandijk", "", "NL", "528", "", "07", "0479", "", "52.47494", "4.80686", "Europe/Amsterdam"),("2744118", "Zaandam", "Заандам", "NL", "528", "", "07", "0479", "", "52.43854", "4.82643", "Europe/Amsterdam"),("2744129", "Yerseke", "", "NL", "528", "NL", "10", "0703", "", "51.4925", "4.05", "Europe/Amsterdam"),("2744156", "Woudrichem", "", "NL", "528", "", "06", "0874", "", "51.815", "5.00139", "Europe/Amsterdam"),("2744163", "Woudenberg", "", "NL", "528", "", "09", "0351", "", "52.08083", "5.41667", "Europe/Amsterdam"),("2744194", "Wolvega", "Вольвега", "NL", "528", "", "02", "0098", "", "52.87545", "5.99691", "Europe/Amsterdam"),("2744248", "Woerden", "Верден", "NL", "528", "", "09", "0632", "", "52.085", "4.88333", "Europe/Amsterdam"),("2744257", "Woensdrecht", "Вонсдрехт", "NL", "528", "", "06", "0873", "", "51.42897", "4.30355", "Europe/Amsterdam"),("2744324", "Wisch", "", "NL", "528", "", "03", "1509", "", "51.92648", "6.41705", "Europe/Amsterdam"),("2744332", "Winterswijk", "Винтерсвейк", "NL", "528", "", "03", "0294", "", "51.9725", "6.71944", "Europe/Amsterdam"),("2744337", "Winsum", "", "NL", "528", "", "04", "0053", "", "53.33", "6.52083", "Europe/Amsterdam"),("2744344", "Winschoten", "Винсхотен", "NL", "528", "", "04", "1895", "", "53.14417", "7.03472", "Europe/Amsterdam"),("2744483", "Wijk bij Duurstede", "", "NL", "528", "", "09", "0352", "", "51.97417", "5.34167", "Europe/Amsterdam"),("2744489", "Wijhe", "", "NL", "528", "NL", "15", "1773", "", "52.38667", "6.13472", "Europe/Amsterdam"),("2744514", "Wijchen", "Вийчен", "NL", "528", "", "03", "0296", "", "51.80917", "5.725", "Europe/Amsterdam"),("2744549", "Wierden", "Виерден", "NL", "528", "", "15", "0189", "", "52.35917", "6.59306", "Europe/Amsterdam"),("2744675", "Westervoort", "", "NL", "528", "", "03", "0293", "", "51.95583", "5.97222", "Europe/Amsterdam"),("2744827", "Werkendam", "Веркендам", "NL", "528", "", "06", "0870", "", "51.81", "4.89444", "Europe/Amsterdam"),("2744904", "Weesp", "Весп", "NL", "528", "", "07", "0457", "", "52.3075", "5.04167", "Europe/Amsterdam"),("2744911", "Weert", "Верт", "NL", "528", "", "05", "0988", "", "51.25167", "5.70694", "Europe/Amsterdam"),("2744991", "Wassenaar", "", "NL", "528", "", "11", "0629", "", "52.14583", "4.40278", "Europe/Amsterdam"),("2744994", "Waspik", "", "NL", "528", "", "06", "0867", "", "51.68667", "4.94444", "Europe/Amsterdam"),("2745003", "Warnsveld", "", "NL", "528", "", "03", "0301", "", "52.1375", "6.23056", "Europe/Amsterdam"),("2745088", "Wageningen", "Вагенинген", "NL", "528", "", "03", "0289", "", "51.97", "5.66667", "Europe/Amsterdam"),("2745096", "Waddinxveen", "", "NL", "528", "NL", "11", "0627", "", "52.045", "4.65139", "Europe/Amsterdam"),("2745123", "Waalwijk", "", "NL", "528", "", "06", "0867", "", "51.6825", "5.07083", "Europe/Amsterdam"),("2745127", "Waalre", "", "NL", "528", "", "06", "0866", "", "51.38667", "5.44444", "Europe/Amsterdam"),("2745154", "Vught", "", "NL", "528", "", "06", "0865", "", "51.65333", "5.2875", "Europe/Amsterdam"),("2745169", "Vroomshoop", "", "NL", "528", "", "15", "1700", "", "52.46083", "6.56528", "Europe/Amsterdam"),("2745182", "Vriezenveen", "", "NL", "528", "NL", "15", "1700", "", "52.40833", "6.62222", "Europe/Amsterdam"),("2745271", "Voorthuizen", "", "NL", "528", "", "03", "0203", "", "52.18667", "5.60556", "Europe/Amsterdam"),("2745297", "Voorst", "Воорст", "NL", "528", "", "03", "0285", "", "52.17", "6.14167", "Europe/Amsterdam"),("2745301", "Voorschoten", "", "NL", "528", "", "11", "0626", "", "52.1275", "4.44861", "Europe/Amsterdam"),("2745311", "Voorhout", "", "NL", "528", "", "11", "1525", "", "52.22167", "4.48472", "Europe/Amsterdam"),("2745321", "Voorburg", "Воорбург", "NL", "528", "", "11", "1916", "", "52.07417", "4.35972", "Europe/Amsterdam"),("2745340", "Volendam", "Волендам", "NL", "528", "", "07", "0385", "", "52.495", "5.07083", "Europe/Amsterdam"),("2745388", "Vlist", "", "NL", "528", "", "11", "1931", "", "51.98", "4.81944", "Europe/Amsterdam"),("2745392", "Vlissingen", "Влиссинген", "NL", "528", "", "10", "0718", "", "51.4425", "3.57361", "Europe/Amsterdam"),("2745461", "Vlagtwedde", "", "NL", "528", "", "04", "0048", "", "53.0275", "7.10833", "Europe/Amsterdam"),("2745467", "Vlaardingen", "", "NL", "528", "", "11", "0622", "", "51.9125", "4.34167", "Europe/Amsterdam"),("2745580", "Vianen", "", "NL", "528", "", "09", "0620", "", "51.9925", "5.09167", "Europe/Amsterdam"),("2745634", "Venray", "", "NL", "528", "", "05", "0984", "", "51.525", "5.975", "Europe/Amsterdam"),("2745641", "Venlo", "Венло", "NL", "528", "", "05", "0983", "", "51.37", "6.16806", "Europe/Amsterdam"),("2745673", "Velsen-Zuid", "", "NL", "528", "", "07", "0453", "", "52.46", "4.65", "Europe/Amsterdam"),("2745677", "Velp", "", "NL", "528", "", "03", "0275", "", "51.995", "5.97361", "Europe/Amsterdam"),("2745706", "Veldhoven", "", "NL", "528", "", "06", "0861", "", "51.41833", "5.40278", "Europe/Amsterdam"),("2745726", "Veghel", "Вегел", "NL", "528", "", "06", "0860", "", "51.61667", "5.54861", "Europe/Amsterdam"),("2745739", "Veere", "Веера", "NL", "528", "", "10", "0717", "", "51.54833", "3.66667", "Europe/Amsterdam"),("2745774", "Veenendaal", "", "NL", "528", "", "09", "0345", "", "52.02863", "5.55891", "Europe/Amsterdam"),("2745783", "Veendam", "", "NL", "528", "", "04", "0047", "", "53.10667", "6.87917", "Europe/Amsterdam"),("2745800", "Varsseveld", "", "NL", "528", "NL", "03", "1509", "", "51.94333", "6.45833", "Europe/Amsterdam"),("2745860", "Valkenswaard", "", "NL", "528", "", "06", "0858", "", "51.35083", "5.45972", "Europe/Amsterdam"),("2745874", "Valkenburg", "", "NL", "528", "", "05", "0994", "", "50.86523", "5.83205", "Europe/Amsterdam"),("2745892", "Vaassen", "", "NL", "528", "NL", "03", "0232", "", "52.28583", "5.96667", "Europe/Amsterdam"),("2745906", "Vaals", "", "NL", "528", "", "05", "0981", "", "50.77083", "6.01806", "Europe/Amsterdam"),("2745912", "Utrecht", "Утрехт", "NL", "528", "", "09", "0344", "", "52.09083", "5.12222", "Europe/Amsterdam"),("2745932", "Urk", "", "NL", "528", "", "16", "0184", "", "52.6625", "5.60139", "Europe/Amsterdam"),("2745944", "Ulrum", "", "NL", "528", "", "04", "1663", "", "53.35917", "6.33333", "Europe/Amsterdam"),("2745973", "Uithoorn", "", "NL", "528", "", "07", "0451", "", "52.2375", "4.82639", "Europe/Amsterdam"),("2745978", "Uitgeest", "", "NL", "528", "", "07", "0450", "", "52.52917", "4.70972", "Europe/Amsterdam"),("2746005", "Uden", "Уден", "NL", "528", "", "06", "0856", "", "51.66083", "5.61944", "Europe/Amsterdam"),("2746060", "Twello", "", "NL", "528", "", "03", "0285", "", "52.23667", "6.10278", "Europe/Amsterdam"),("2746133", "Tubbergen", "Тубберген", "NL", "528", "", "15", "0183", "", "52.4075", "6.78472", "Europe/Amsterdam"),("2746215", "Tongelre", "", "NL", "528", "", "06", "0772", "", "51.44889", "5.51978", "Europe/Amsterdam"),("2746301", "Tilburg", "Тилбург", "NL", "528", "", "06", "0855", "", "51.55551", "5.0913", "Europe/Amsterdam"),("2746331", "Tiel", "Тил", "NL", "528", "", "03", "0281", "", "51.88667", "5.42917", "Europe/Amsterdam"),("2746351", "Tholen", "", "NL", "528", "", "10", "0716", "", "51.53167", "4.22083", "Europe/Amsterdam"),("2746420", "Terneuzen", "Тернезен", "NL", "528", "", "10", "0715", "", "51.33583", "3.82778", "Europe/Amsterdam"),("2746504", "Tegelen", "", "NL", "528", "", "05", "0983", "", "51.34417", "6.13611", "Europe/Amsterdam"),("2746558", "Surhuisterveen", "", "NL", "528", "", "02", "0059", "", "53.18477", "6.17031", "Europe/Amsterdam"),("2746609", "Strijen", "", "NL", "528", "", "11", "0617", "", "51.74521", "4.55083", "Europe/Amsterdam"),("2746705", "Stiens", "", "NL", "528", "", "02", "0081", "", "53.26234", "5.75769", "Europe/Amsterdam"),("2746748", "Stein", "", "NL", "528", "", "05", "0971", "", "50.96917", "5.76667", "Europe/Amsterdam"),("2746766", "Steenwijk", "", "NL", "528", "", "15", "1708", "", "52.7875", "6.12083", "Europe/Amsterdam"),("2746804", "Steenbergen", "", "NL", "528", "", "06", "0851", "", "51.58417", "4.31944", "Europe/Amsterdam"),("2746839", "Staphorst", "", "NL", "528", "", "15", "0180", "", "52.645", "6.21111", "Europe/Amsterdam"),("2746860", "Stadskanaal", "", "NL", "528", "NL", "04", "0037", "", "52.98947", "6.9504", "Europe/Amsterdam"),("2746932", "Spijkenisse", "", "NL", "528", "", "11", "1930", "", "51.845", "4.32917", "Europe/Amsterdam"),("2747010", "Son", "", "NL", "528", "", "06", "0848", "", "51.51136", "5.49282", "Europe/Amsterdam"),("2747021", "Someren", "", "NL", "528", "", "06", "0847", "", "51.385", "5.71111", "Europe/Amsterdam"),("2747034", "Soest", "Зоест", "NL", "528", "", "09", "0342", "", "52.17333", "5.29167", "Europe/Amsterdam"),("2747063", "Sneek", "Снек", "NL", "528", "", "02", "1900", "", "53.03297", "5.6589", "Europe/Amsterdam"),("2747143", "Slochteren", "", "NL", "528", "", "04", "0040", "", "53.22078", "6.80547", "Europe/Amsterdam"),("2747169", "Sliedrecht", "Слидрехт", "NL", "528", "", "11", "0610", "", "51.82083", "4.77639", "Europe/Amsterdam"),("2747203", "Sittard", "Ситтард", "NL", "528", "", "05", "1883", "", "50.99833", "5.86944", "Europe/Amsterdam"),("2747227", "Sint-Oedenrode", "", "NL", "528", "", "06", "0846", "", "51.5675", "5.45972", "Europe/Amsterdam"),("2747234", "Sint-Michielsgestel", "", "NL", "528", "", "06", "0845", "", "51.64167", "5.35278", "Europe/Amsterdam"),("2747290", "Sint Anthonis", "", "NL", "528", "", "06", "1702", "", "51.62667", "5.88194", "Europe/Amsterdam"),("2747312", "Simpelveld", "", "NL", "528", "", "05", "0965", "", "50.83417", "5.98194", "Europe/Amsterdam"),("2747351", "'s-Hertogenbosch", "Хертогенбос", "NL", "528", "", "06", "0796", "", "51.69917", "5.30417", "Europe/Amsterdam"),("2747357", "'s-Heerenberg", "", "NL", "528", "", "03", "1955", "", "51.8767", "6.25877", "Europe/Amsterdam"),("2747364", "'s-Gravenzande", "", "NL", "528", "", "11", "1783", "", "52.00167", "4.16528", "Europe/Amsterdam"),("2747373", "The Hague", "Гаага", "NL", "528", "", "11", "0518", "", "52.07667", "4.29861", "Europe/Amsterdam"),("2747506", "Schoonhoven", "", "NL", "528", "", "11", "1931", "", "51.9475", "4.84861", "Europe/Amsterdam"),("2747584", "Schijndel", "", "NL", "528", "", "06", "0844", "", "51.6225", "5.43194", "Europe/Amsterdam"),("2747596", "Schiedam", "Схидам", "NL", "528", "", "11", "0606", "", "51.91917", "4.38889", "Europe/Amsterdam"),("2747599", "Scheveningen", "Схевенинген", "NL", "528", "", "11", "0518", "", "52.10461", "4.27557", "Europe/Amsterdam"),("2747713", "Schaijk", "", "NL", "528", "NL", "06", "1685", "", "51.74583", "5.63194", "Europe/Amsterdam"),("2747720", "Schagen", "Схаген", "NL", "528", "", "07", "0441", "", "52.7875", "4.79861", "Europe/Amsterdam"),("2747751", "Sassenheim", "", "NL", "528", "", "11", "1525", "", "52.225", "4.52222", "Europe/Amsterdam"),("2747758", "Sappemeer", "", "NL", "528", "", "04", "0018", "", "53.16417", "6.79028", "Europe/Amsterdam"),("2747858", "Rucphen", "", "NL", "528", "", "06", "0840", "", "51.53167", "4.55833", "Europe/Amsterdam"),("2747891", "Rotterdam", "Роттердам", "NL", "528", "", "11", "0599", "", "51.9225", "4.47917", "Europe/Amsterdam"),("2747930", "Roosendaal", "Розендаль", "NL", "528", "", "06", "1674", "", "51.53083", "4.46528", "Europe/Amsterdam"),("2748000", "Roermond", "Рурмонда", "NL", "528", "", "05", "0957", "", "51.19417", "5.9875", "Europe/Amsterdam"),("2748076", "Rijswijk", "", "NL", "528", "", "11", "0603", "", "52.03634", "4.32501", "Europe/Amsterdam"),("2748104", "Rijnsburg", "", "NL", "528", "", "11", "0537", "", "52.19", "4.44167", "Europe/Amsterdam"),("2748172", "Ridderkerk", "Риддеркерк", "NL", "528", "", "11", "0597", "", "51.8725", "4.60278", "Europe/Amsterdam"),("2748178", "Rhoon", "", "NL", "528", "NL", "11", "0613", "", "51.8575", "4.42222", "Europe/Amsterdam"),("2748185", "Rhenen", "", "NL", "528", "", "09", "0340", "", "51.95917", "5.56806", "Europe/Amsterdam"),("2748201", "Rheden", "", "NL", "528", "", "03", "0275", "", "52.005", "6.02917", "Europe/Amsterdam"),("2748208", "Reuver", "", "NL", "528", "", "05", "0889", "", "51.28417", "6.07778", "Europe/Amsterdam"),("2748236", "Renkum", "", "NL", "528", "", "03", "0274", "", "51.97667", "5.73333", "Europe/Amsterdam"),("2748280", "Reeuwijk", "", "NL", "528", "", "11", "1901", "", "52.04667", "4.725", "Europe/Amsterdam"),("2748371", "Raalte", "Раалт", "NL", "528", "", "15", "0177", "", "52.38583", "6.275", "Europe/Amsterdam"),("2748392", "Putten", "Путтен", "NL", "528", "", "03", "0273", "", "52.25917", "5.60694", "Europe/Amsterdam"),("2748413", "Purmerend", "", "NL", "528", "", "07", "0439", "", "52.505", "4.95972", "Europe/Amsterdam"),("2748533", "Poeldijk", "", "NL", "528", "", "11", "1783", "", "52.02417", "4.21944", "Europe/Amsterdam"),("2748591", "Pijnacker", "", "NL", "528", "NL", "11", "1926", "", "52.01954", "4.42946", "Europe/Amsterdam"),("2748729", "Papendrecht", "Папендрехт", "NL", "528", "", "11", "0590", "", "51.83167", "4.6875", "Europe/Amsterdam"),("2748979", "Oudewater", "", "NL", "528", "", "09", "0589", "", "52.025", "4.86806", "Europe/Amsterdam"),("2749017", "Ouderkerk aan de Amstel", "", "NL", "528", "NL", "07", "0437", "", "52.29504", "4.90746", "Europe/Amsterdam"),("2749034", "Oude Pekela", "", "NL", "528", "", "04", "0765", "", "53.10417", "7.00972", "Europe/Amsterdam"),("2749164", "Ouddorp", "", "NL", "528", "", "11", "1924", "", "51.81167", "3.93472", "Europe/Amsterdam"),("2749182", "Oud-Beijerland", "", "NL", "528", "", "11", "0584", "", "51.82417", "4.4125", "Europe/Amsterdam"),("2749234", "Oss", "Осс", "NL", "528", "", "06", "0828", "", "51.765", "5.51806", "Europe/Amsterdam"),("2749286", "Opmeer", "", "NL", "528", "", "07", "0432", "", "52.70667", "4.94444", "Europe/Amsterdam"),("2749423", "Oosterpark", "", "NL", "528", "", "04", "0014", "", "53.2237", "6.5853", "Europe/Amsterdam"),("2749450", "Oosterhout", "Остерхоут", "NL", "528", "", "06", "0826", "", "51.645", "4.85972", "Europe/Amsterdam"),("2749503", "Oosterbeek", "", "NL", "528", "", "03", "0274", "", "51.98583", "5.84583", "Europe/Amsterdam"),("2749644", "Oldenzaal", "Олдензал", "NL", "528", "", "15", "0173", "", "52.31333", "6.92917", "Europe/Amsterdam"),("2749668", "Oldebroek", "Олдебрук", "NL", "528", "", "03", "0269", "", "52.445", "5.90139", "Europe/Amsterdam"),("2749680", "Oisterwijk", "Ойстервейк", "NL", "528", "", "06", "0824", "", "51.57917", "5.18889", "Europe/Amsterdam"),("2749683", "Oirschot", "", "NL", "528", "", "06", "0823", "", "51.505", "5.31389", "Europe/Amsterdam"),("2749723", "Oegstgeest", "", "NL", "528", "", "11", "0579", "", "52.18", "4.46944", "Europe/Amsterdam"),("2749753", "Nuth", "", "NL", "528", "", "05", "0951", "", "50.9175", "5.88611", "Europe/Amsterdam"),("2749756", "Nunspeet", "", "NL", "528", "", "03", "0302", "", "52.37917", "5.78611", "Europe/Amsterdam"),("2749780", "Nuenen", "Нюнен", "NL", "528", "", "06", "0820", "", "51.47", "5.55278", "Europe/Amsterdam"),("2749811", "Noordwijkerhout", "", "NL", "528", "", "11", "0576", "", "52.26167", "4.49306", "Europe/Amsterdam"),("2749812", "Noordwijk-Binnen", "", "NL", "528", "", "11", "0575", "", "52.234", "4.44474", "Europe/Amsterdam"),("2750053", "Nijmegen", "Неймеген", "NL", "528", "", "03", "0268", "", "51.8425", "5.85278", "Europe/Amsterdam"),("2750065", "Nijkerk", "", "NL", "528", "", "03", "0267", "", "52.22", "5.48611", "Europe/Amsterdam"),("2750158", "Nieuw-Loosdrecht", "", "NL", "528", "", "07", "1696", "", "52.19917", "5.13889", "Europe/Amsterdam"),("2750163", "Nieuw-Lekkerland", "", "NL", "528", "", "11", "1927", "", "51.88915", "4.68653", "Europe/Amsterdam"),("2750187", "Nieuwkoop", "", "NL", "528", "", "11", "0569", "", "52.15083", "4.77639", "Europe/Amsterdam"),("2750194", "Nieuw-Helvoet", "", "NL", "528", "NL", "11", "0530", "", "51.83843", "4.12897", "Europe/Amsterdam"),("2750325", "Nieuwegein", "", "NL", "528", "", "09", "0356", "", "52.02917", "5.08056", "Europe/Amsterdam"),("2750444", "Neerijnen", "", "NL", "528", "", "03", "0304", "", "51.83167", "5.28194", "Europe/Amsterdam"),("2750460", "Neede", "", "NL", "528", "", "03", "1859", "", "52.13417", "6.61389", "Europe/Amsterdam"),("2750467", "Nederweert", "Недерверт", "NL", "528", "", "05", "0946", "", "51.28583", "5.74861", "Europe/Amsterdam"),("2750484", "Neder-Hardinxveld", "", "NL", "528", "", "11", "0523", "", "51.82879", "4.85489", "Europe/Amsterdam"),("2750521", "Naarden", "", "NL", "528", "", "07", "1942", "", "52.29583", "5.1625", "Europe/Amsterdam"),("2750523", "Naaldwijk", "", "NL", "528", "", "11", "1783", "", "51.99417", "4.20972", "Europe/Amsterdam"),("2750626", "Montfoort", "", "NL", "528", "", "09", "0335", "", "52.04583", "4.95278", "Europe/Amsterdam"),("2750630", "Monster", "", "NL", "528", "", "11", "1783", "", "52.02583", "4.175", "Europe/Amsterdam"),("2750641", "Monnickendam", "", "NL", "528", "NL", "07", "0852", "", "52.45833", "5.0375", "Europe/Amsterdam"),("2750815", "Mijdrecht", "", "NL", "528", "", "09", "0736", "", "52.20667", "4.8625", "Europe/Amsterdam"),("2750821", "Mierlo", "", "NL", "528", "NL", "06", "1771", "", "51.44", "5.61944", "Europe/Amsterdam"),("2750884", "Middelharnis", "Мидделхарнис", "NL", "528", "", "11", "1924", "", "51.7575", "4.16528", "Europe/Amsterdam"),("2750896", "Middelburg", "Мидделбург", "NL", "528", "", "10", "0687", "", "51.5", "3.61389", "Europe/Amsterdam"),("2750939", "Merenwijk", "", "NL", "528", "", "11", "0546", "", "52.17655", "4.50885", "Europe/Amsterdam"),("2750947", "Meppel", "Меппел", "NL", "528", "", "01", "0119", "", "52.69583", "6.19444", "Europe/Amsterdam"),("2751037", "Meerssen", "", "NL", "528", "", "05", "0938", "", "50.8875", "5.75", "Europe/Amsterdam"),("2751073", "Medemblik", "", "NL", "528", "", "07", "0420", "", "52.77167", "5.10556", "Europe/Amsterdam"),("2751199", "Margraten", "", "NL", "528", "", "05", "1903", "", "50.82083", "5.82083", "Europe/Amsterdam"),("2751272", "Made", "", "NL", "528", "", "06", "1719", "", "51.67667", "4.79306", "Europe/Amsterdam"),("2751283", "Maastricht", "Маастрихт", "NL", "528", "", "05", "0935", "", "50.84833", "5.68889", "Europe/Amsterdam"),("2751285", "Maassluis", "", "NL", "528", "", "11", "0556", "", "51.92333", "4.25", "Europe/Amsterdam"),("2751301", "Maasbree", "", "NL", "528", "", "05", "1894", "", "51.3575", "6.04861", "Europe/Amsterdam"),("2751303", "Maasbracht", "", "NL", "528", "", "05", "1641", "", "51.13929", "5.88627", "Europe/Amsterdam"),("2751316", "Maarssen", "", "NL", "528", "", "09", "1904", "", "52.13917", "5.04167", "Europe/Amsterdam"),("2751385", "Lunteren", "", "NL", "528", "", "03", "0228", "", "52.085", "5.62222", "Europe/Amsterdam"),("2751424", "Losser", "Лоссер", "NL", "528", "", "15", "0168", "", "52.26083", "7.00417", "Europe/Amsterdam"),("2751436", "Lopik", "", "NL", "528", "", "09", "0331", "", "51.9725", "4.94861", "Europe/Amsterdam"),("2751456", "Loon op Zand", "", "NL", "528", "", "06", "0809", "", "51.6275", "5.075", "Europe/Amsterdam"),("2751537", "Lochem", "", "NL", "528", "", "03", "0262", "", "52.15917", "6.41111", "Europe/Amsterdam"),("2751547", "Lisse", "", "NL", "528", "", "11", "0553", "", "52.26", "4.55694", "Europe/Amsterdam"),("2751582", "Lindenholt", "", "NL", "528", "", "03", "0268", "", "51.8327", "5.7934", "Europe/Amsterdam"),("2751621", "Liesveld", "", "NL", "528", "", "11", "1927", "", "51.9325", "4.83194", "Europe/Amsterdam"),("2751651", "Lichtenvoorde", "", "NL", "528", "", "03", "1586", "", "51.98667", "6.56667", "Europe/Amsterdam"),("2751687", "Leusden", "Леусден", "NL", "528", "", "09", "0327", "", "52.1325", "5.43194", "Europe/Amsterdam"),("2751729", "Lemmer", "", "NL", "528", "", "02", "1921", "", "52.84618", "5.70912", "Europe/Amsterdam"),("2751738", "Lelystad", "", "NL", "528", "", "16", "0995", "", "52.50833", "5.475", "Europe/Amsterdam"),("2751750", "Leimuiden", "", "NL", "528", "", "11", "1884", "", "52.22417", "4.66944", "Europe/Amsterdam"),("2751771", "Leiderdorp", "Лейдердорпе", "NL", "528", "", "11", "0547", "", "52.15833", "4.52917", "Europe/Amsterdam"),("2751773", "Leiden", "Лейден", "NL", "528", "", "11", "0546", "", "52.15833", "4.49306", "Europe/Amsterdam"),("2751792", "Leeuwarden", "Леуварден", "NL", "528", "", "02", "0080", "", "53.20139", "5.80859", "Europe/Amsterdam"),("2751793", "Leesten", "", "NL", "528", "", "03", "0301", "", "52.1279", "6.23217", "Europe/Amsterdam"),("2751801", "Leersum", "", "NL", "528", "", "09", "1581", "", "52.01167", "5.42778", "Europe/Amsterdam"),("2751808", "Leerdam", "Лердам", "NL", "528", "", "11", "0545", "", "51.89333", "5.09167", "Europe/Amsterdam"),("2751834", "Leek", "Лек", "NL", "528", "", "04", "0022", "", "53.1625", "6.37639", "Europe/Amsterdam"),("2751874", "Laren", "", "NL", "528", "", "07", "0417", "", "52.25667", "5.22778", "Europe/Amsterdam"),("2751980", "Landsmeer", "", "NL", "528", "", "07", "0415", "", "52.43083", "4.91528", "Europe/Amsterdam"),("2752264", "Krimpen aan den IJssel", "", "NL", "528", "", "11", "0542", "", "51.91667", "4.60278", "Europe/Amsterdam"),("2752409", "Kortenhoef", "", "NL", "528", "", "07", "1696", "", "52.23917", "5.10694", "Europe/Amsterdam"),("2752420", "Korrewegwijk", "", "NL", "528", "", "04", "0014", "", "53.23235", "6.56804", "Europe/Amsterdam"),("2752524", "Kollum", "", "NL", "528", "", "02", "0079", "", "53.27695", "6.15293", "Europe/Amsterdam"),("2752600", "Klundert", "", "NL", "528", "", "06", "1709", "", "51.665", "4.53472", "Europe/Amsterdam"),("2752798", "Klazienaveen", "", "NL", "528", "", "01", "0114", "", "52.72417", "6.99028", "Europe/Amsterdam"),("2752923", "Kerkrade", "Керкраде", "NL", "528", "", "05", "0928", "", "50.86583", "6.0625", "Europe/Amsterdam"),("2753010", "Katwijk aan Zee", "", "NL", "528", "", "11", "0537", "", "52.20333", "4.39861", "Europe/Amsterdam"),("2753011", "Katwijk aan den Rijn", "", "NL", "528", "NL", "11", "0537", "", "52.19417", "4.42222", "Europe/Amsterdam"),("2753106", "Kampen", "Кампен", "NL", "528", "", "15", "0166", "", "52.555", "5.91111", "Europe/Amsterdam"),("2753197", "Joure", "", "NL", "528", "", "02", "1921", "", "52.9657", "5.80301", "Europe/Amsterdam"),("2753355", "IJsselstein", "Иссельстейн", "NL", "528", "", "09", "0353", "", "52.02", "5.04306", "Europe/Amsterdam"),("2753439", "Hulst", "", "NL", "528", "", "10", "0677", "", "51.28", "4.05278", "Europe/Amsterdam");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("2753468", "Huizen", "", "NL", "528", "", "07", "0406", "", "52.29917", "5.24167", "Europe/Amsterdam"),("2753470", "Huizum", "", "NL", "528", "NL", "02", "0080", "", "53.1917", "5.81119", "Europe/Amsterdam"),("2753557", "Houten", "", "NL", "528", "", "09", "0321", "", "52.02833", "5.16806", "Europe/Amsterdam"),("2753587", "Horst", "Хорст", "NL", "528", "", "03", "0233", "", "52.30833", "5.58194", "Europe/Amsterdam"),("2753638", "Hoorn", "Хоорн", "NL", "528", "", "07", "0405", "", "52.6425", "5.05972", "Europe/Amsterdam"),("2753686", "Hoogland", "", "NL", "528", "", "09", "0307", "", "52.1825", "5.37361", "Europe/Amsterdam"),("2753706", "Hoogezand", "", "NL", "528", "", "04", "0018", "", "53.16167", "6.76111", "Europe/Amsterdam"),("2753719", "Hoogeveen", "Хоогевеен", "NL", "528", "", "01", "0118", "", "52.7225", "6.47639", "Europe/Amsterdam"),("2753801", "Hoofddorp", "", "NL", "528", "", "07", "0394", "", "52.3025", "4.68889", "Europe/Amsterdam"),("2753806", "Honselersdijk", "", "NL", "528", "NL", "11", "1783", "", "52.00665", "4.22441", "Europe/Amsterdam"),("2753955", "Hoge Vucht", "", "NL", "528", "", "06", "0758", "", "51.60794", "4.7915", "Europe/Amsterdam"),("2753996", "Hoensbroek", "", "NL", "528", "NL", "05", "0917", "", "50.92387", "5.92528", "Europe/Amsterdam"),("2754007", "Hoek van Holland", "", "NL", "528", "NL", "11", "0599", "", "51.9775", "4.13333", "Europe/Amsterdam"),("2754064", "Hilversum", "Хилверсюм", "NL", "528", "NL", "07", "0402", "", "52.22333", "5.17639", "Europe/Amsterdam"),("2754066", "Hilvarenbeek", "", "NL", "528", "", "06", "0798", "", "51.48583", "5.1375", "Europe/Amsterdam"),("2754073", "Hillegom", "", "NL", "528", "NL", "11", "0534", "", "52.29083", "4.58333", "Europe/Amsterdam"),("2754111", "Heythuysen", "", "NL", "528", "NL", "05", "1640", "", "51.25", "5.89861", "Europe/Amsterdam"),("2754135", "Heusden", "", "NL", "528", "", "06", "0797", "", "51.73417", "5.13889", "Europe/Amsterdam"),("2754287", "Heteren", "", "NL", "528", "", "03", "1734", "", "51.95667", "5.75556", "Europe/Amsterdam"),("2754394", "Hengelo", "", "NL", "528", "NL", "15", "0164", "", "52.26583", "6.79306", "Europe/Amsterdam"),("2754395", "Hengelo", "", "NL", "528", "", "03", "1876", "", "52.05083", "6.30972", "Europe/Amsterdam"),("2754408", "Hendrik-Ido-Ambacht", "Хендрик-Идо-Амбахт", "NL", "528", "", "11", "0531", "", "51.84417", "4.63889", "Europe/Amsterdam"),("2754447", "Helmond", "Хелмонд", "NL", "528", "", "06", "0794", "", "51.48167", "5.66111", "Europe/Amsterdam"),("2754454", "Hellevoetsluis", "Хеллевутслёйс", "NL", "528", "", "11", "0530", "", "51.83333", "4.13333", "Europe/Amsterdam"),("2754502", "Heino", "", "NL", "528", "", "15", "0177", "", "52.43661", "6.23282", "Europe/Amsterdam"),("2754516", "Heiloo", "", "NL", "528", "", "07", "0399", "", "52.60252", "4.68815", "Europe/Amsterdam"),("2754618", "Heeze", "", "NL", "528", "", "06", "1658", "", "51.3828", "5.57145", "Europe/Amsterdam"),("2754635", "Heesch", "", "NL", "528", "", "06", "1721", "", "51.73362", "5.52672", "Europe/Amsterdam"),("2754652", "Heerlen", "", "NL", "528", "", "05", "0917", "", "50.88365", "5.98154", "Europe/Amsterdam"),("2754659", "Heerhugowaard", "Херхюговард", "NL", "528", "", "07", "0398", "", "52.67144", "4.84862", "Europe/Amsterdam"),("2754669", "Heerenveen", "Херенвен", "NL", "528", "", "02", "0074", "", "52.95929", "5.91854", "Europe/Amsterdam"),("2754681", "Heerde", "", "NL", "528", "", "03", "0246", "", "52.38723", "6.04016", "Europe/Amsterdam"),("2754682", "Heer", "", "NL", "528", "NL", "05", "0935", "", "50.83836", "5.72989", "Europe/Amsterdam"),("2754692", "Heemstede", "", "NL", "528", "", "07", "0397", "", "52.34992", "4.62301", "Europe/Amsterdam"),("2754697", "Heemskerk", "Хеемскерк", "NL", "528", "", "07", "0396", "", "52.51108", "4.67165", "Europe/Amsterdam"),("2754768", "Hattem", "", "NL", "528", "", "03", "0244", "", "52.475", "6.06389", "Europe/Amsterdam"),("2754779", "Hasselt", "", "NL", "528", "", "15", "1896", "", "52.59267", "6.09527", "Europe/Amsterdam"),("2754817", "Harlingen", "Харлинген", "NL", "528", "", "02", "0072", "", "53.17477", "5.42244", "Europe/Amsterdam"),("2754837", "Harenkarspel", "Харенкарспел", "NL", "528", "", "07", "0441", "", "52.73416", "4.77682", "Europe/Amsterdam"),("2754841", "Haren", "Харен", "NL", "528", "", "04", "0017", "", "53.17209", "6.60931", "Europe/Amsterdam"),("2754848", "Harderwijk", "", "NL", "528", "", "03", "0243", "", "52.34167", "5.62083", "Europe/Amsterdam"),("2754861", "Hardenberg", "Харденберге", "NL", "528", "", "15", "0160", "", "52.57583", "6.61944", "Europe/Amsterdam"),("2754864", "Hurdegaryp", "", "NL", "528", "", "02", "0737", "", "53.21333", "5.94137", "Europe/Amsterdam"),("2754922", "Halsteren", "", "NL", "528", "", "06", "0748", "", "51.52834", "4.26785", "Europe/Amsterdam"),("2754975", "Haelen", "", "NL", "528", "", "05", "1640", "", "51.23583", "5.95694", "Europe/Amsterdam"),("2755003", "Haarlem", "Харлем", "NL", "528", "", "07", "0392", "", "52.38084", "4.63683", "Europe/Amsterdam"),("2755009", "Haaren", "", "NL", "528", "", "06", "0788", "", "51.6025", "5.22222", "Europe/Amsterdam"),("2755030", "Haaksbergen", "Хааксберген", "NL", "528", "", "15", "0158", "", "52.15667", "6.73889", "Europe/Amsterdam"),("2755052", "Grou", "", "NL", "528", "", "02", "0080", "", "53.09456", "5.83745", "Europe/Amsterdam"),("2755204", "Grootegast", "", "NL", "528", "", "04", "0015", "", "53.2125", "6.27361", "Europe/Amsterdam"),("2755251", "Groningen", "Гронинген", "NL", "528", "", "04", "0014", "", "53.21917", "6.56667", "Europe/Amsterdam"),("2755272", "Groesbeek", "", "NL", "528", "", "03", "0241", "", "51.77667", "5.93611", "Europe/Amsterdam"),("2755358", "Grave", "", "NL", "528", "", "06", "0786", "", "51.75902", "5.73882", "Europe/Amsterdam"),("2755420", "Gouda", "Гауда", "NL", "528", "", "11", "0513", "", "52.01667", "4.70833", "Europe/Amsterdam"),("2755429", "Gorredijk", "", "NL", "528", "", "02", "0086", "", "53.00659", "6.06402", "Europe/Amsterdam"),("2755434", "Gorinchem", "Горинхем", "NL", "528", "", "11", "0512", "", "51.83652", "4.97243", "Europe/Amsterdam"),("2755449", "Goor", "", "NL", "528", "", "15", "1735", "", "52.23333", "6.58611", "Europe/Amsterdam"),("2755464", "Goirle", "Гоирл", "NL", "528", "", "06", "0785", "", "51.52083", "5.06667", "Europe/Amsterdam"),("2755476", "Goes", "Гус", "NL", "528", "", "10", "0664", "", "51.50417", "3.88889", "Europe/Amsterdam"),("2755485", "Goedereede", "", "NL", "528", "", "11", "1924", "", "51.8175", "3.98056", "Europe/Amsterdam"),("2755584", "Gennep", "", "NL", "528", "", "05", "0907", "", "51.69833", "5.97361", "Europe/Amsterdam"),("2755599", "Gendringen", "Гендринген", "NL", "528", "", "03", "1509", "", "51.87333", "6.37639", "Europe/Amsterdam"),("2755616", "Geleen", "", "NL", "528", "", "05", "1883", "", "50.97417", "5.82917", "Europe/Amsterdam"),("2755619", "Geldrop", "Гельдроп", "NL", "528", "", "06", "1771", "", "51.42167", "5.55972", "Europe/Amsterdam"),("2755633", "Geldermalsen", "Гельдермалсен", "NL", "528", "", "03", "0236", "", "51.88083", "5.28889", "Europe/Amsterdam"),("2755645", "Geffen", "", "NL", "528", "", "06", "0828", "", "51.74", "5.46389", "Europe/Amsterdam"),("2755669", "Geertruidenberg", "Гетруденберг", "NL", "528", "", "06", "0779", "", "51.70167", "4.85694", "Europe/Amsterdam"),("2755845", "Franeker", "", "NL", "528", "", "02", "0070", "", "53.18546", "5.54123", "Europe/Amsterdam"),("2756039", "Ermelo", "Эрмело", "NL", "528", "", "03", "0233", "", "52.29833", "5.62222", "Europe/Amsterdam"),("2756059", "Epe", "Эпе", "NL", "528", "", "03", "0232", "", "52.3475", "5.98333", "Europe/Amsterdam"),("2756071", "Enschede", "Энсхеде", "NL", "528", "", "15", "0153", "", "52.21833", "6.89583", "Europe/Amsterdam"),("2756077", "Enkhuizen", "", "NL", "528", "", "07", "0388", "", "52.70333", "5.29167", "Europe/Amsterdam"),("2756133", "Emmer-Compascuum", "", "NL", "528", "", "01", "0114", "", "52.81167", "7.04722", "Europe/Amsterdam"),("2756136", "Emmen", "Эммен", "NL", "528", "", "01", "0114", "", "52.77917", "6.90694", "Europe/Amsterdam"),("2756139", "Emmeloord", "Эммелорд", "NL", "528", "", "16", "0171", "", "52.71083", "5.74861", "Europe/Amsterdam"),("2756161", "Elst", "", "NL", "528", "", "03", "1734", "", "51.91917", "5.84167", "Europe/Amsterdam"),("2756169", "Elsloo", "", "NL", "528", "NL", "05", "0971", "", "50.94917", "5.77083", "Europe/Amsterdam"),("2756232", "Elburg", "Элбург", "NL", "528", "", "03", "0230", "", "52.4475", "5.84306", "Europe/Amsterdam"),("2756253", "Eindhoven", "Эйндховен", "NL", "528", "", "06", "0772", "", "51.44083", "5.47778", "Europe/Amsterdam"),("2756283", "Eijsden", "", "NL", "528", "", "05", "1903", "", "50.78", "5.7177", "Europe/Amsterdam"),("2756295", "Eibergen", "", "NL", "528", "", "03", "1859", "", "52.1", "6.64861", "Europe/Amsterdam"),("2756301", "Egmond aan Zee", "", "NL", "528", "", "07", "0373", "", "52.6204", "4.62705", "Europe/Amsterdam"),("2756342", "Eersel", "", "NL", "528", "", "06", "0770", "", "51.3575", "5.31806", "Europe/Amsterdam"),("2756351", "Eerbeek", "", "NL", "528", "", "03", "0213", "", "52.105", "6.05833", "Europe/Amsterdam"),("2756429", "Ede", "Эде", "NL", "528", "", "03", "0228", "", "52.03333", "5.65833", "Europe/Amsterdam"),("2756431", "Edam", "", "NL", "528", "", "07", "0385", "", "52.51215", "5.04805", "Europe/Amsterdam"),("2756507", "Duiven", "", "NL", "528", "", "03", "0226", "", "51.94667", "6.01389", "Europe/Amsterdam"),("2756539", "Druten", "", "NL", "528", "", "03", "0225", "", "51.88833", "5.60556", "Europe/Amsterdam"),("2756559", "Dronten", "Дронтен", "NL", "528", "", "16", "0303", "", "52.525", "5.71806", "Europe/Amsterdam"),("2756569", "Drimmelen", "Дримлен", "NL", "528", "", "06", "1719", "", "51.70667", "4.80417", "Europe/Amsterdam"),("2756619", "Driebergen-Rijsenburg", "", "NL", "528", "", "09", "1581", "", "52.05333", "5.28056", "Europe/Amsterdam"),("2756644", "Drachten", "Драхтен", "NL", "528", "", "02", "0090", "", "53.11254", "6.0989", "Europe/Amsterdam"),("2756669", "Dordrecht", "", "NL", "528", "", "11", "0505", "", "51.81", "4.67361", "Europe/Amsterdam"),("2756686", "Doorn", "", "NL", "528", "", "09", "1581", "", "52.03343", "5.34571", "Europe/Amsterdam"),("2756723", "Dongen", "Донген", "NL", "528", "", "06", "0766", "", "51.62667", "4.93889", "Europe/Amsterdam"),("2756759", "Dokkum", "", "NL", "528", "", "02", "0058", "", "53.32224", "5.99697", "Europe/Amsterdam"),("2756767", "Doetinchem", "Дутинхем", "NL", "528", "", "03", "0222", "", "51.965", "6.28889", "Europe/Amsterdam"),("2756772", "Doesburg", "", "NL", "528", "", "03", "0221", "", "52.0125", "6.13889", "Europe/Amsterdam"),("2756800", "Dinteloord", "", "NL", "528", "", "06", "0851", "", "51.635", "4.36944", "Europe/Amsterdam"),("2756865", "Dieren", "", "NL", "528", "", "03", "0275", "", "52.0525", "6.1", "Europe/Amsterdam"),("2756888", "Diemen", "Димен", "NL", "528", "NL", "07", "0384", "", "52.33964", "4.96256", "Europe/Amsterdam"),("2756987", "Deventer", "Девентер", "NL", "528", "", "15", "0150", "", "52.255", "6.16389", "Europe/Amsterdam"),("2757220", "Den Helder", "Ден-Хелдер", "NL", "528", "", "07", "0400", "", "52.95988", "4.75933", "Europe/Amsterdam"),("2757244", "Den Burg", "", "NL", "528", "NL", "07", "0448", "", "53.05417", "4.79722", "Europe/Amsterdam"),("2757336", "De Lier", "", "NL", "528", "NL", "11", "1783", "", "51.975", "4.24861", "Europe/Amsterdam"),("2757340", "Delfzijl", "Делфзейл", "NL", "528", "", "04", "0010", "", "53.33", "6.91806", "Europe/Amsterdam"),("2757345", "Delft", "Делфт", "NL", "528", "", "11", "0503", "", "52.00667", "4.35556", "Europe/Amsterdam"),("2757347", "Delfshaven", "", "NL", "528", "", "11", "0599", "", "51.90488", "4.45315", "Europe/Amsterdam"),("2757370", "Delden", "", "NL", "528", "", "15", "1735", "", "52.26", "6.71111", "Europe/Amsterdam"),("2757685", "De Doornakkers", "", "NL", "528", "NL", "06", "0772", "", "51.43844", "5.50887", "Europe/Amsterdam"),("2757783", "De Bilt", "", "NL", "528", "", "09", "0310", "", "52.11", "5.18056", "Europe/Amsterdam"),("2757838", "Damwâld", "", "NL", "528", "", "02", "1891", "", "53.29046", "5.99785", "Europe/Amsterdam"),("2757850", "Dalfsen", "Дальфсен", "NL", "528", "", "15", "0148", "", "52.51167", "6.25694", "Europe/Amsterdam"),("2757872", "Culemborg", "Кулемборг", "NL", "528", "", "03", "0216", "", "51.955", "5.22778", "Europe/Amsterdam"),("2757874", "Cuijk", "", "NL", "528", "", "06", "1684", "", "51.73083", "5.87917", "Europe/Amsterdam"),("2757890", "Cranendonck", "", "NL", "528", "", "06", "1706", "", "51.30417", "5.58889", "Europe/Amsterdam"),("2757937", "Coevorden", "", "NL", "528", "", "01", "0109", "", "52.66103", "6.74046", "Europe/Amsterdam"),("2757991", "Castricum", "", "NL", "528", "", "07", "0383", "", "52.54833", "4.66944", "Europe/Amsterdam"),("2758012", "Capelle aan den IJssel", "Капелле-ан-ден-Эйссел", "NL", "528", "NL", "11", "0502", "", "51.92917", "4.57778", "Europe/Amsterdam"),("2758064", "Bussum", "Бюссюм", "NL", "528", "", "07", "1942", "", "52.27333", "5.16111", "Europe/Amsterdam"),("2758104", "Bunschoten", "", "NL", "528", "", "09", "0313", "", "52.24304", "5.37884", "Europe/Amsterdam"),("2758106", "Bunnik", "", "NL", "528", "", "09", "0312", "", "52.06667", "5.19861", "Europe/Amsterdam"),("2758131", "Buitenpost", "", "NL", "528", "", "02", "0059", "", "53.25166", "6.14483", "Europe/Amsterdam"),("2758174", "Brunssum", "Брюнссуме", "NL", "528", "", "05", "0899", "", "50.94667", "5.97083", "Europe/Amsterdam"),("2758177", "Brummen", "Бруммен", "NL", "528", "", "03", "0213", "", "52.09", "6.15556", "Europe/Amsterdam"),("2758245", "Broek op Langedijk", "", "NL", "528", "", "07", "0416", "", "52.67417", "4.80556", "Europe/Amsterdam"),("2758258", "Broek in Waterland", "", "NL", "528", "", "07", "0852", "", "52.43417", "4.99583", "Europe/Amsterdam"),("2758326", "Brielle", "", "NL", "528", "", "11", "0501", "", "51.90167", "4.1625", "Europe/Amsterdam"),("2758333", "Breukelen", "", "NL", "528", "", "09", "1904", "", "52.17417", "5.00139", "Europe/Amsterdam"),("2758401", "Breda", "Бреда", "NL", "528", "", "06", "0758", "", "51.58656", "4.77596", "Europe/Amsterdam"),("2758460", "Boxtel", "Бокстел", "NL", "528", "", "06", "0757", "", "51.59083", "5.32917", "Europe/Amsterdam"),("2758462", "Boxmeer", "", "NL", "528", "", "06", "0756", "", "51.64667", "5.94722", "Europe/Amsterdam"),("2758547", "Boskoop", "", "NL", "528", "", "11", "0484", "", "52.075", "4.65556", "Europe/Amsterdam"),("2758587", "Borssele", "Борссель", "NL", "528", "", "10", "0654", "", "51.42333", "3.73472", "Europe/Amsterdam"),("2758598", "Borne", "Борне", "NL", "528", "", "15", "0147", "", "52.30136", "6.7482", "Europe/Amsterdam"),("2758602", "Born", "", "NL", "528", "", "05", "1883", "", "51.03167", "5.80972", "Europe/Amsterdam"),("2758621", "Borger", "Боргер", "NL", "528", "", "01", "1681", "", "52.92333", "6.79306", "Europe/Amsterdam"),("2758626", "Borculo", "", "NL", "528", "", "03", "1859", "", "52.11583", "6.52222", "Europe/Amsterdam"),("2758682", "Bolsward", "", "NL", "528", "", "02", "1900", "", "53.06555", "5.53176", "Europe/Amsterdam"),("2758759", "Boekel", "", "NL", "528", "", "06", "0755", "", "51.60333", "5.675", "Europe/Amsterdam"),("2758765", "Bodegraven", "", "NL", "528", "", "11", "1901", "", "52.0825", "4.75", "Europe/Amsterdam"),("2758803", "Bloemendaal", "", "NL", "528", "", "11", "0513", "", "52.02878", "4.6944", "Europe/Amsterdam"),("2758804", "Bloemendaal", "", "NL", "528", "", "07", "0377", "", "52.4025", "4.62222", "Europe/Amsterdam"),("2758838", "Bleiswijk", "", "NL", "528", "", "11", "1621", "", "52.01083", "4.53194", "Europe/Amsterdam"),("2758868", "Blaricum", "", "NL", "528", "", "07", "0376", "", "52.2725", "5.24167", "Europe/Amsterdam"),("2758878", "Bladel", "", "NL", "528", "", "06", "1728", "", "51.36833", "5.22083", "Europe/Amsterdam"),("2758930", "Bilgaard", "", "NL", "528", "", "02", "0080", "", "53.21551", "5.79574", "Europe/Amsterdam"),("2758992", "Biddinghuizen", "", "NL", "528", "", "16", "0303", "", "52.455", "5.69306", "Europe/Amsterdam"),("2758998", "Beverwijk", "", "NL", "528", "", "07", "0375", "", "52.48333", "4.65694", "Europe/Amsterdam"),("2759016", "Beuningen", "", "NL", "528", "", "03", "0209", "", "51.86083", "5.76667", "Europe/Amsterdam"),("2759040", "Best", "", "NL", "528", "", "06", "0753", "", "51.5075", "5.39028", "Europe/Amsterdam"),("2759103", "Burgum", "", "NL", "528", "", "02", "0737", "", "53.19243", "5.99009", "Europe/Amsterdam"),("2759113", "Bergschenhoek", "", "NL", "528", "", "11", "1621", "", "51.99", "4.49861", "Europe/Amsterdam"),("2759126", "Berghem", "", "NL", "528", "NL", "06", "0828", "", "51.76991", "5.56827", "Europe/Amsterdam"),("2759132", "Bergeijk", "", "NL", "528", "", "06", "1724", "", "51.31917", "5.35833", "Europe/Amsterdam"),("2759145", "Bergen op Zoom", "Берген-оп-Зом", "NL", "528", "", "06", "0748", "", "51.495", "4.29167", "Europe/Amsterdam"),("2759178", "Benthuizen", "", "NL", "528", "", "11", "0484", "", "52.0775", "4.54444", "Europe/Amsterdam"),("2759197", "Bennekom", "", "NL", "528", "", "03", "0228", "", "51.99833", "5.67639", "Europe/Amsterdam"),("2759199", "Bennebroek", "", "NL", "528", "", "07", "0377", "", "52.32083", "4.59861", "Europe/Amsterdam"),("2759350", "Beek", "", "NL", "528", "", "05", "0888", "", "50.94083", "5.79722", "Europe/Amsterdam"),("2759356", "Bedum", "", "NL", "528", "", "04", "0005", "", "53.30083", "6.60278", "Europe/Amsterdam"),("2759407", "Barneveld", "Барневелд", "NL", "528", "", "03", "0203", "", "52.14", "5.58472", "Europe/Amsterdam"),("2759426", "Barendrecht", "Барендрехт", "NL", "528", "", "11", "0489", "", "51.85667", "4.53472", "Europe/Amsterdam"),("2759544", "Baarn", "Баан", "NL", "528", "", "09", "0308", "", "52.21167", "5.2875", "Europe/Amsterdam"),("2759554", "Baarle-Nassau", "", "NL", "528", "", "06", "0744", "", "51.4475", "4.92917", "Europe/Amsterdam"),("2759594", "Axel", "", "NL", "528", "NL", "10", "0715", "", "51.26667", "3.90833", "Europe/Amsterdam"),("2759621", "Asten", "", "NL", "528", "", "06", "0743", "", "51.40417", "5.74861", "Europe/Amsterdam"),("2759633", "Assen", "Ассен", "NL", "528", "", "01", "0106", "", "52.99667", "6.5625", "Europe/Amsterdam"),("2759661", "Arnhem", "Арнем", "NL", "528", "", "03", "0202", "", "51.98", "5.91111", "Europe/Amsterdam"),("2759684", "Arcen", "", "NL", "528", "", "05", "0983", "", "51.47667", "6.18056", "Europe/Amsterdam"),("2759687", "Appingedam", "", "NL", "528", "", "04", "0003", "", "53.32167", "6.85833", "Europe/Amsterdam"),("2759706", "Apeldoorn", "Апелдорн", "NL", "528", "", "03", "0200", "", "52.21", "5.96944", "Europe/Amsterdam"),("2759746", "Anloo", "", "NL", "528", "", "01", "1680", "", "53.04417", "6.70139", "Europe/Amsterdam"),("2759794", "Amsterdam", "Амстердам", "NL", "528", "", "07", "0363", "", "52.37403", "4.88969", "Europe/Amsterdam"),("2759798", "Amstelveen", "Амстелвин", "NL", "528", "", "07", "0362", "", "52.30083", "4.86389", "Europe/Amsterdam"),("2759821", "Amersfoort", "Амерсфорт", "NL", "528", "", "09", "0307", "", "52.155", "5.3875", "Europe/Amsterdam"),("2759828", "Amerongen", "", "NL", "528", "", "09", "1581", "", "52.0025", "5.45972", "Europe/Amsterdam"),("2759875", "Alphen aan den Rijn", "", "NL", "528", "", "11", "0484", "", "52.12917", "4.65546", "Europe/Amsterdam"),("2759879", "Almere Stad", "", "NL", "528", "", "16", "0034", "", "52.37025", "5.21413", "Europe/Amsterdam"),("2759887", "Almelo", "Алмело", "NL", "528", "", "15", "0141", "", "52.35667", "6.6625", "Europe/Amsterdam"),("2759899", "Alkmaar", "Алкмаар", "NL", "528", "", "07", "0361", "", "52.63167", "4.74861", "Europe/Amsterdam"),("2759915", "Alblasserdam", "Алблассердам", "NL", "528", "", "11", "0482", "", "51.86583", "4.66111", "Europe/Amsterdam"),("2760123", "Aalten", "", "NL", "528", "", "03", "0197", "", "51.925", "6.58056", "Europe/Amsterdam"),("2760134", "Aalsmeer", "Алсмер", "NL", "528", "", "07", "0358", "", "52.25917", "4.75972", "Europe/Amsterdam"),("2760144", "Aalburg", "", "NL", "528", "", "06", "0738", "", "51.75482", "5.13156", "Europe/Amsterdam"),("6251994", "Klundert", "", "NL", "528", "", "06", "1709", "", "51.66297", "4.53461", "Europe/Amsterdam"),("6324403", "Camminghaburen", "", "NL", "528", "", "02", "0080", "", "53.20973", "5.84318", "Europe/Amsterdam"),("6544881", "Amsterdam-Zuidoost", "", "NL", "528", "", "07", "0363", "", "52.3075", "4.97222", "Europe/Amsterdam"),("6695503", "Meerhoven", "", "NL", "528", "", "06", "0772", "", "51.44267", "5.41102", "Europe/Amsterdam"),("6698635", "Lunetten", "", "NL", "528", "", "09", "0344", "", "52.06178", "5.13474", "Europe/Amsterdam"),("6698718", "Aarle-Rixtel", "", "NL", "528", "", "06", "1659", "", "51.50976", "5.63839", "Europe/Amsterdam"),("6929992", "Berkel en Rodenrijs", "", "NL", "528", "", "11", "1621", "", "51.99313", "4.47865", "Europe/Amsterdam"),("6941548", "Ypenburg", "", "NL", "528", "", "11", "0518", "", "52.04098", "4.36981", "Europe/Amsterdam"),("6948947", "Groenswaard", "", "NL", "528", "", "11", "0627", "", "52.05154", "4.64541", "Europe/Amsterdam"),("6950811", "Randenbroek", "", "NL", "528", "", "09", "0307", "", "52.14863", "5.4012", "Europe/Amsterdam"),("8379268", "'s-Gravenland", "", "NL", "528", "", "11", "0599", "", "51.92336", "4.55315", "Europe/Amsterdam"),("777073", "Vadsø", "", "NO", "578", "", "05", "2003", "", "70.07348", "29.74943", "Europe/Oslo"),("779683", "Hammerfest", "", "NO", "578", "", "05", "2004", "", "70.66336", "23.68209", "Europe/Oslo"),("847633", "Alta", "", "NO", "578", "", "05", "2012", "", "69.96887", "23.27165", "Europe/Oslo"),("3131329", "Voss", "", "NO", "578", "", "07", "1235", "", "60.62869", "6.41474", "Europe/Oslo"),("3131449", "Volda", "", "NO", "578", "", "08", "1519", "", "62.146", "6.07108", "Europe/Oslo"),("3132058", "Vestby", "", "NO", "578", "", "01", "0211", "", "59.60511", "10.75233", "Europe/Oslo"),("3132176", "Verdal", "", "NO", "578", "", "10", "1721", "", "63.79332", "11.4817", "Europe/Oslo"),("3132208", "Vennesla", "", "NO", "578", "", "19", "1014", "", "58.26856", "7.97314", "Europe/Oslo"),("3133349", "Ulsteinvik", "", "NO", "578", "", "08", "1516", "", "62.34317", "5.84869", "Europe/Oslo"),("3133880", "Trondheim", "Тронхейм", "NO", "578", "", "16", "1601", "", "63.43049", "10.39506", "Europe/Oslo"),("3133895", "Tromsø", "Тромсё", "NO", "578", "", "18", "1902", "", "69.6489", "18.95508", "Europe/Oslo"),("3134070", "Tranby", "", "NO", "578", "", "04", "0626", "", "59.8085", "10.26114", "Europe/Oslo"),("3134331", "Tønsberg", "Тёнсберг", "NO", "578", "", "20", "0704", "", "59.26754", "10.40762", "Europe/Oslo"),("3134865", "Tananger", "", "NO", "578", "", "14", "1124", "", "58.93618", "5.5741", "Europe/Oslo"),("3136765", "Stjørdalshalsen", "", "NO", "578", "", "10", "1714", "", "63.4681", "10.92618", "Europe/Oslo"),("3136947", "Steinkjer", "", "NO", "578", "", "10", "1702", "", "64.01487", "11.49537", "Europe/Oslo"),("3137091", "Stavern", "", "NO", "578", "", "20", "0709", "", "59", "10.03333", "Europe/Oslo"),("3137115", "Stavanger", "Ставангер", "NO", "578", "", "14", "1103", "", "58.97005", "5.73332", "Europe/Oslo"),("3137971", "Søgne", "", "NO", "578", "", "19", "1018", "", "58.09328", "7.78294", "Europe/Oslo"),("3139075", "Skien", "Шиен", "NO", "578", "", "17", "0806", "", "59.20962", "9.60897", "Europe/Oslo"),("3139081", "Ski", "", "NO", "578", "", "01", "0213", "", "59.71949", "10.83576", "Europe/Oslo"),("3140084", "Sarpsborg", "Сарпсборг", "NO", "578", "", "13", "0105", "", "59.28391", "11.10962", "Europe/Oslo"),("3140301", "Sandnessjøen", "", "NO", "578", "", "09", "1820", "", "66.02166", "12.63158", "Europe/Oslo"),("3140321", "Sandnes", "", "NO", "578", "", "14", "1102", "", "58.85244", "5.73521", "Europe/Oslo"),("3140390", "Sandefjord", "Саннефьорд", "NO", "578", "", "20", "0706", "", "59.13118", "10.21665", "Europe/Oslo"),("3142228", "Raufoss", "", "NO", "578", "", "11", "0529", "", "60.72604", "10.6133", "Europe/Oslo"),("3142539", "Råholt", "", "NO", "578", "", "01", "0237", "", "60.27513", "11.17901", "Europe/Oslo"),("3142657", "Porsgrunn", "Пушгрён", "NO", "578", "NO", "17", "0805", "", "59.14054", "9.6561", "Europe/Oslo"),("3143244", "Oslo", "Осло", "NO", "578", "", "12", "0301", "", "59.91273", "10.74609", "Europe/Oslo"),("3143830", "Odda", "", "NO", "578", "", "07", "1228", "", "60.06912", "6.54565", "Europe/Oslo"),("3144075", "Notodden", "", "NO", "578", "", "17", "0807", "", "59.55936", "9.25853", "Europe/Oslo"),("3144987", "Narvik", "", "NO", "578", "", "09", "1805", "", "68.43838", "17.4272", "Europe/Oslo"),("3145023", "Namsos", "", "NO", "578", "", "10", "1703", "", "64.46624", "11.49572", "Europe/Oslo"),("3145094", "Mysen", "", "NO", "578", "", "13", "0125", "", "59.55354", "11.32578", "Europe/Oslo"),("3145375", "Moss", "Мосс", "NO", "578", "", "13", "0104", "", "59.43403", "10.65771", "Europe/Oslo"),("3145386", "Mosjøen", "", "NO", "578", "", "09", "1824", "", "65.83599", "13.19076", "Europe/Oslo"),("3145580", "Molde", "Молде", "NO", "578", "", "08", "1502", "", "62.73752", "7.15912", "Europe/Oslo"),("3145614", "Mo i Rana", "Му-и-Рана", "NO", "578", "", "09", "1833", "", "66.31278", "14.14278", "Europe/Oslo"),("3146463", "Mandal", "", "NO", "578", "", "19", "1002", "", "58.0274", "7.45342", "Europe/Oslo"),("3146470", "Malvik", "", "NO", "578", "", "16", "1663", "", "63.43333", "10.68333", "Europe/Oslo"),("3147465", "Lillestrøm", "", "NO", "578", "", "01", "0231", "", "59.95597", "11.04918", "Europe/Oslo"),("3147467", "Lillesand", "", "NO", "578", "", "02", "0926", "", "58.24879", "8.3778", "Europe/Oslo"),("3147474", "Lillehammer", "Лиллехаммер", "NO", "578", "", "11", "0501", "", "61.11514", "10.46628", "Europe/Oslo"),("3147698", "Levanger", "", "NO", "578", "", "10", "1719", "", "63.74644", "11.29963", "Europe/Oslo"),("3147822", "Leirvik", "", "NO", "578", "", "07", "1221", "", "59.77977", "5.50051", "Europe/Oslo"),("3148129", "Larvik", "Ларвик", "NO", "578", "", "20", "0709", "", "59.05328", "10.03517", "Europe/Oslo"),("3149312", "Kristiansund", "Кристиансунн", "NO", "578", "", "08", "1505", "", "63.11045", "7.72795", "Europe/Oslo"),("3149318", "Kristiansand", "Кристиансанн", "NO", "578", "", "19", "1001", "", "58.14671", "7.9956", "Europe/Oslo"),("3149412", "Kragerø", "", "NO", "578", "", "17", "0815", "", "58.8693", "9.41494", "Europe/Oslo"),("3149512", "Kopervik", "", "NO", "578", "", "14", "1149", "", "59.28354", "5.30669", "Europe/Oslo"),("3149533", "Kongsvinger", "", "NO", "578", "", "06", "0402", "", "60.19049", "11.99772", "Europe/Oslo"),("3149563", "Kongsberg", "Конгсберг", "NO", "578", "", "04", "0604", "", "59.66858", "9.65017", "Europe/Oslo"),("3149813", "Kløfta", "", "NO", "578", "", "01", "0235", "", "60.07407", "11.13805", "Europe/Oslo"),("3150742", "Jørpeland", "", "NO", "578", "", "14", "1130", "", "59.02251", "6.04078", "Europe/Oslo"),("3150851", "Jessheim", "", "NO", "578", "", "01", "0235", "", "60.14151", "11.17515", "Europe/Oslo"),("3151770", "Horten", "Хортен", "NO", "578", "", "20", "0701", "", "59.41721", "10.48343", "Europe/Oslo"),("3151917", "Hønefoss", "", "NO", "578", "", "04", "0605", "", "60.16804", "10.25647", "Europe/Oslo"),("3152132", "Holmestrand", "", "NO", "578", "", "20", "0702", "", "59.48761", "10.31761", "Europe/Oslo"),("3152884", "Hermansverk", "", "NO", "578", "", "15", "1419", "", "61.18461", "6.85016", "Europe/Oslo"),("3153623", "Haugesund", "Хаугезунд", "NO", "578", "", "14", "1106", "", "59.41378", "5.268", "Europe/Oslo"),("3153823", "Harstad", "Харстад", "NO", "578", "", "18", "1903", "", "68.79833", "16.54165", "Europe/Oslo"),("3154084", "Hamar", "Хамар", "NO", "578", "", "06", "0403", "", "60.7945", "11.06798", "Europe/Oslo"),("3154209", "Halden", "Халден", "NO", "578", "", "13", "0101", "", "59.12478", "11.38754", "Europe/Oslo"),("3155041", "Grimstad", "", "NO", "578", "", "02", "0904", "", "58.3405", "8.59343", "Europe/Oslo"),("3155573", "Gjøvik", "Йёвик", "NO", "578", "", "11", "0502", "", "60.79574", "10.69155", "Europe/Oslo"),("3156529", "Fredrikstad", "Фредрикстад", "NO", "578", "NO", "13", "0106", "", "59.2181", "10.9298", "Europe/Oslo"),("3156804", "Førde", "", "NO", "578", "", "15", "1432", "", "61.45217", "5.85717", "Europe/Oslo"),("3156980", "Florø", "", "NO", "578", "", "15", "1401", "", "61.59957", "5.0328", "Europe/Oslo"),("3157090", "Flekkefjord", "", "NO", "578", "", "19", "1004", "", "58.29705", "6.66069", "Europe/Oslo"),("3157686", "Fetsund", "", "NO", "578", "", "01", "0227", "", "59.92463", "11.15711", "Europe/Oslo"),("3157781", "Fauske", "", "NO", "578", "", "09", "1841", "", "67.25883", "15.39181", "Europe/Oslo"),("3158300", "Elverum", "", "NO", "578", "", "06", "0427", "", "60.88191", "11.56231", "Europe/Oslo"),("3158792", "Egersund", "", "NO", "578", "", "14", "1101", "", "58.45133", "5.9997", "Europe/Oslo"),("3158960", "Drøbak", "", "NO", "578", "", "01", "0215", "", "59.66333", "10.62975", "Europe/Oslo"),("3159016", "Drammen", "Драммен", "NO", "578", "", "04", "0602", "", "59.74389", "10.20449", "Europe/Oslo"),("3159822", "Bryne", "", "NO", "578", "", "14", "1121", "", "58.73536", "5.64766", "Europe/Oslo"),("3159894", "Brumunddal", "", "NO", "578", "", "06", "0412", "", "60.88095", "10.93948", "Europe/Oslo"),("3160881", "Bodø", "Бодо", "NO", "578", "", "09", "1804", "", "67.28", "14.40501", "Europe/Oslo"),("3161732", "Bergen", "Берген", "NO", "578", "", "07", "1201", "", "60.39299", "5.32415", "Europe/Oslo"),("3162651", "Askim", "", "NO", "578", "", "13", "0124", "", "59.58326", "11.16286", "Europe/Oslo"),("3162797", "Ås", "", "NO", "578", "", "01", "0214", "", "59.66472", "10.79465", "Europe/Oslo"),("3162924", "Indre Arna", "", "NO", "578", "", "07", "1201", "", "60.41768", "5.47087", "Europe/Oslo"),("3162955", "Arendal", "Арендал", "NO", "578", "", "02", "0906", "", "58.46151", "8.77253", "Europe/Oslo"),("3163392", "Ålesund", "Олесунн", "NO", "578", "", "08", "1504", "", "62.47225", "6.15492", "Europe/Oslo"),("3163443", "Åkrehamn", "", "NO", "578", "NO", "14", "1149", "", "59.26053", "5.18689", "Europe/Oslo"),("3227582", "Hommersåk", "", "NO", "578", "", "14", "1102", "", "58.92556", "5.85104", "Europe/Oslo"),("3336585", "Nesoddtangen", "", "NO", "578", "", "01", "0216", "", "59.86244", "10.66308", "Europe/Oslo"),("3336587", "Askøy", "Аскёй", "NO", "578", "", "07", "1247", "", "60.4", "5.18333", "Europe/Oslo"),("3336588", "Ørsta", "", "NO", "578", "", "08", "1520", "", "62.19983", "6.12904", "Europe/Oslo"),("6697344", "Ytrebygda", "", "NO", "578", "", "07", "1201", "", "60.30504", "5.28236", "Europe/Oslo"),("7288345", "Sogndal", "", "NO", "578", "", "15", "1420", "", "61.22908", "7.09674", "Europe/Oslo"),("1282616", "Wāling", "", "NP", "524", "", "WR", "", "", "27.98333", "83.76667", "Asia/Kathmandu"),("1282635", "Tulsīpur", "", "NP", "524", "", "MR", "", "", "28.13099", "82.29726", "Asia/Kathmandu"),("1282666", "Tīkāpur", "", "NP", "524", "", "FR", "", "", "28.5", "81.13333", "Asia/Kathmandu"),("1282714", "Tānsen", "Тансен", "NP", "524", "", "WR", "", "", "27.86731", "83.5467", "Asia/Kathmandu"),("1282770", "Sirāhā", "Сираха", "NP", "524", "", "ER", "", "", "26.65411", "86.2087", "Asia/Kathmandu"),("1282884", "Rājbirāj", "", "NP", "524", "", "ER", "", "", "26.53333", "86.75", "Asia/Kathmandu"),("1282898", "Pokhara", "Покхара", "NP", "524", "NP", "WR", "04", "", "28.26689", "83.96851", "Asia/Kathmandu"),("1282931", "Pātan", "Лалитпур", "NP", "524", "", "CR", "01", "25", "27.67658", "85.31417", "Asia/Kathmandu"),("1282950", "Panauti̇̄", "", "NP", "524", "", "CR", "", "", "27.58453", "85.51484", "Asia/Kathmandu"),("1283082", "Malangwa", "", "NP", "524", "", "CR", "", "", "26.85679", "85.55811", "Asia/Kathmandu"),("1283095", "Mahendranagar", "", "NP", "524", "", "FR", "", "", "28.91667", "80.33333", "Asia/Kathmandu"),("1283119", "Lobujya", "", "NP", "524", "NP", "ER", "", "", "27.95", "86.81667", "Asia/Kathmandu"),("1283161", "Lahān", "", "NP", "524", "", "ER", "", "", "26.72958", "86.49515", "Asia/Kathmandu"),("1283190", "Kirtipur", "", "NP", "524", "", "CR", "", "", "27.67872", "85.2775", "Asia/Kathmandu"),("1283217", "Khāndbāri", "", "NP", "524", "", "ER", "", "", "27.37469", "87.2039", "Asia/Kathmandu"),("1283240", "Kathmandu", "Катманду", "NP", "524", "", "CR", "01", "", "27.70169", "85.3206", "Asia/Kathmandu"),("1283285", "Jumla", "", "NP", "524", "", "MR", "06", "", "29.27472", "82.18383", "Asia/Kathmandu"),("1283318", "Janakpur", "", "NP", "524", "", "CR", "", "", "26.71828", "85.90646", "Asia/Kathmandu"),("1283323", "Jaleswar", "", "NP", "524", "", "CR", "", "", "26.64711", "85.80081", "Asia/Kathmandu"),("1283329", "Ithari", "", "NP", "524", "", "ER", "", "", "26.66667", "87.28333", "Asia/Kathmandu"),("1283333", "Ilām", "", "NP", "524", "", "ER", "10", "3", "26.90943", "87.92824", "Asia/Kathmandu"),("1283339", "Hetauda", "", "NP", "524", "", "CR", "11", "", "27.42839", "85.03219", "Asia/Kathmandu"),("1283368", "Gulariyā", "", "NP", "524", "", "MR", "", "", "28.23333", "81.33333", "Asia/Kathmandu"),("1283401", "Gaur", "Гаура", "NP", "524", "", "CR", "", "", "26.76448", "85.27841", "Asia/Kathmandu"),("1283460", "Dharān Bāzār", "", "NP", "524", "", "ER", "", "", "26.81248", "87.28355", "Asia/Kathmandu"),("1283465", "Dhankutā", "", "NP", "524", "", "ER", "", "", "26.98333", "87.33333", "Asia/Kathmandu"),("1283467", "Dhangarhi", "", "NP", "524", "", "FR", "", "", "28.70792", "80.59611", "Asia/Kathmandu"),("1283484", "Dārchulā", "", "NP", "524", "", "WR", "", "", "29.84121", "80.52874", "Asia/Kathmandu"),("1283496", "Dailekh", "", "NP", "524", "", "MR", "02", "60", "28.84434", "81.71011", "Asia/Kathmandu"),("1283499", "Dadeldhurā", "", "NP", "524", "", "FR", "", "", "29.29842", "80.58059", "Asia/Kathmandu"),("1283562", "Butwāl", "", "NP", "524", "", "WR", "", "", "27.70055", "83.44836", "Asia/Kathmandu"),("1283581", "Bīrganj", "", "NP", "524", "", "CR", "", "", "27.01043", "84.87735", "Asia/Kathmandu"),("1283582", "Biratnagar", "Биратнагар", "NP", "524", "", "ER", "07", "", "26.45505", "87.27007", "Asia/Kathmandu"),("1283613", "Bharatpur", "", "NP", "524", "", "CR", "11", "35", "27.68333", "84.43333", "Asia/Kathmandu"),("1283621", "Siddharthanagar", "", "NP", "524", "", "WR", "08", "49", "27.5", "83.45", "Asia/Kathmandu"),("1283628", "Bhadrapur", "", "NP", "524", "", "ER", "", "", "26.54404", "88.09436", "Asia/Kathmandu"),("1283679", "Banepā", "", "NP", "524", "", "CR", "", "", "27.63245", "85.52192", "Asia/Kathmandu"),("1283711", "Bāglung", "Баглунг", "NP", "524", "", "WR", "", "", "28.27189", "83.58975", "Asia/Kathmandu"),("6254842", "Besisahar", "", "NP", "524", "", "00", "", "", "28.23417", "82.41278", "Asia/Kathmandu"),("6254843", "Birendranagar", "Бирендранаган", "NP", "524", "", "MR", "", "", "28.60194", "81.63389", "Asia/Kathmandu"),("6254845", "Dipayal", "", "NP", "524", "", "FR", "", "", "29.26083", "80.94", "Asia/Kathmandu"),("6941099", "Nepalgunj", "Непалгун", "NP", "524", "", "MR", "02", "", "28.05", "81.61667", "Asia/Kathmandu"),("8199102", "kankrabari Dovan", "", "NP", "524", "", "CR", "01", "", "27.62881", "85.45934", "Asia/Kathmandu"),("8504556", "Hari Bdr Tamang House", "", "NP", "524", "", "CR", "01", "", "27.6289", "85.45893", "Asia/Kathmandu"),("11154397", "Bhattarai Danda", "", "NP", "524", "", "WR", "04", "39", "27.88381", "83.93115", "Asia/Kathmandu"),("286245", "Sur", "Сур", "OM", "512", "", "04", "", "", "22.56667", "59.52889", "Asia/Muscat"),("286282", "Sohar", "Сухар", "OM", "512", "", "11", "", "", "24.35022", "56.70765", "Asia/Muscat"),("286293", "Sufālat Samā’il", "", "OM", "512", "", "01", "", "", "23.31667", "58.01667", "Asia/Muscat"),("286402", "Shināş", "", "OM", "512", "", "11", "", "", "24.74333", "56.46583", "Asia/Muscat"),("286621", "Şalālah", "Салала", "OM", "512", "", "08", "", "", "17.01505", "54.09237", "Asia/Muscat"),("286647", "Şaḩam", "Салам", "OM", "512", "", "11", "", "", "24.17222", "56.88861", "Asia/Muscat"),("286987", "Nizwá", "Низва", "OM", "512", "", "01", "", "", "22.93333", "57.53333", "Asia/Muscat"),("287286", "Muscat", "Маскат", "OM", "512", "", "06", "", "", "23.58413", "58.40778", "Asia/Muscat"),("287614", "Khasab", "", "OM", "512", "", "07", "", "", "26.17993", "56.24774", "Asia/Muscat"),("287814", "Izkī", "", "OM", "512", "", "01", "", "", "22.93333", "57.76667", "Asia/Muscat"),("287830", "‘Ibrī", "", "OM", "512", "", "09", "", "", "23.22573", "56.51572", "Asia/Muscat"),("287832", "Ibrā’", "Ибра", "OM", "512", "", "12", "", "", "22.69057", "58.53337", "Asia/Muscat"),("287939", "Haymā’", "", "OM", "512", "", "03", "", "", "19.95931", "56.27575", "Asia/Muscat"),("288721", "Bidbid", "", "OM", "512", "", "01", "", "", "23.40787", "58.1283", "Asia/Muscat"),("288764", "Bawshar", "", "OM", "512", "", "06", "", "", "23.55563", "58.3989", "Asia/Muscat"),("288789", "Barkā’", "", "OM", "512", "", "02", "", "", "23.70739", "57.88908", "Asia/Muscat"),("288899", "Bahlā’", "", "OM", "512", "", "01", "", "", "22.97339", "57.29958", "Asia/Muscat"),("288902", "Badīyah", "", "OM", "512", "", "12", "", "", "22.45", "58.8", "Asia/Muscat"),("288955", "As Suwayq", "", "OM", "512", "", "11", "", "", "23.84944", "57.43861", "Asia/Muscat"),("288967", "Seeb", "", "OM", "512", "", "06", "", "", "23.67027", "58.18911", "Asia/Muscat"),("289011", "Rustaq", "Рустака", "OM", "512", "", "02", "", "", "23.39083", "57.42444", "Asia/Muscat"),("289142", "Al Qābil", "", "OM", "512", "", "12", "", "", "22.571", "58.69472", "Asia/Muscat"),("289174", "Al Liwā’", "", "OM", "512", "", "11", "", "", "24.53611", "56.56556", "Asia/Muscat"),("289199", "Al Khābūrah", "", "OM", "512", "", "11", "", "", "23.98864", "57.09838", "Asia/Muscat"),("289317", "Al Buraymī", "", "OM", "512", "", "10", "", "", "24.25088", "55.79312", "Asia/Muscat"),("289433", "Ādam", "", "OM", "512", "", "01", "", "", "22.3756", "57.52334", "Asia/Muscat"),("411849", "Yanqul", "", "OM", "512", "", "09", "", "", "23.59051", "56.55007", "Asia/Muscat"),("412084", "Bayt al ‘Awābī", "", "OM", "512", "", "02", "", "", "23.30324", "57.52459", "Asia/Muscat"),("1108161", "Chuhar Jamāli", "", "PK", "586", "", "05", "", "", "24.38953", "67.99234", "Asia/Karachi"),("1161983", "Rāwala Kot", "", "PK", "586", "", "06", "", "", "33.85782", "73.76043", "Asia/Karachi"),("1161991", "Pir Jo Goth", "", "PK", "586", "", "05", "", "", "27.59178", "68.61848", "Asia/Karachi"),("1162004", "Khairpur", "Хайрпура", "PK", "586", "", "05", "", "", "27.52948", "68.7617", "Asia/Karachi"),("1162035", "Ādilpur", "", "PK", "586", "", "05", "", "", "27.93697", "69.31869", "Asia/Karachi"),("1162105", "Zhob", "", "PK", "586", "", "02", "", "", "31.34082", "69.4493", "Asia/Karachi"),("1162261", "Zaida", "", "PK", "586", "", "03", "", "", "34.0595", "72.4669", "Asia/Karachi"),("1162275", "Zāhir Pīr", "", "PK", "586", "", "04", "", "", "28.81239", "70.52405", "Asia/Karachi"),("1162285", "Zafarwāl", "", "PK", "586", "", "04", "", "", "32.34464", "74.8999", "Asia/Karachi"),("1162316", "Yazman", "", "PK", "586", "", "04", "", "", "29.12122", "71.74459", "Asia/Karachi"),("1162456", "Wazīrābād", "", "PK", "586", "", "04", "", "", "32.44324", "74.12", "Asia/Karachi"),("1162572", "Warburton", "Уорбертон", "PK", "586", "", "04", "", "", "31.55", "73.83333", "Asia/Karachi"),("1162589", "Wārāh", "", "PK", "586", "", "05", "", "", "27.44805", "67.79654", "Asia/Karachi"),("1162813", "Vihāri", "", "PK", "586", "", "04", "", "", "30.0445", "72.3556", "Asia/Karachi"),("1162855", "Utmānzai", "", "PK", "586", "", "03", "", "", "34.18775", "71.76274", "Asia/Karachi"),("1162862", "Uthal", "", "PK", "586", "", "02", "", "", "25.80722", "66.62194", "Asia/Karachi"),("1162868", "Usta Muhammad", "", "PK", "586", "", "02", "", "", "28.17723", "68.04367", "Asia/Karachi"),("1162959", "Umarkot", "", "PK", "586", "", "05", "", "", "25.36157", "69.73624", "Asia/Karachi"),("1163021", "Ubauro", "", "PK", "586", "", "05", "", "", "28.16429", "69.73114", "Asia/Karachi"),("1163054", "Turbat", "", "PK", "586", "", "02", "", "", "26.00122", "63.04849", "Asia/Karachi"),("1163224", "Topi", "Топи", "PK", "586", "", "03", "", "", "34.07034", "72.62147", "Asia/Karachi"),("1163272", "Toba Tek Singh", "", "PK", "586", "", "04", "", "", "30.97433", "72.48269", "Asia/Karachi"),("1163414", "Thul", "", "PK", "586", "", "05", "", "", "28.24035", "68.77588", "Asia/Karachi"),("1163582", "Thatta", "Татта", "PK", "586", "", "05", "", "", "24.74745", "67.92353", "Asia/Karachi"),("1163595", "Thāru Shāh", "", "PK", "586", "", "05", "", "", "26.9423", "68.11759", "Asia/Karachi"),("1163724", "Taunsa", "", "PK", "586", "", "04", "", "", "30.70483", "70.65051", "Asia/Karachi"),("1163905", "Tānk", "", "PK", "586", "", "03", "", "", "32.21707", "70.38315", "Asia/Karachi"),("1163912", "Tangwāni", "", "PK", "586", "", "05", "", "", "28.27886", "68.9976", "Asia/Karachi"),("1163927", "Tangi", "", "PK", "586", "", "03", "", "", "34.3009", "71.65238", "Asia/Karachi"),("1163952", "Tando Muhammad Khān", "", "PK", "586", "", "05", "", "", "25.12301", "68.53577", "Asia/Karachi"),("1163958", "Tando Jām", "", "PK", "586", "", "05", "", "", "25.42718", "68.53619", "Asia/Karachi"),("1163964", "Tando Bāgo", "", "PK", "586", "", "05", "", "", "24.78857", "68.96614", "Asia/Karachi"),("1163965", "Tando Allāhyār", "", "PK", "586", "", "05", "", "", "25.46263", "68.71923", "Asia/Karachi"),("1163967", "Tando Ādam", "", "PK", "586", "", "05", "", "", "25.76818", "68.66196", "Asia/Karachi"),("1163968", "Tāndliānwāla", "", "PK", "586", "", "04", "", "", "31.03333", "73.13333", "Asia/Karachi"),("1164045", "Talhār", "", "PK", "586", "", "05", "", "", "24.88333", "68.81667", "Asia/Karachi"),("1164064", "Talamba", "", "PK", "586", "", "04", "", "", "30.52708", "72.24011", "Asia/Karachi"),("1164069", "Talagang", "", "PK", "586", "", "04", "", "", "32.92973", "72.41583", "Asia/Karachi"),("1164076", "Tāl", "Таль", "PK", "586", "", "03", "", "", "35.47908", "72.24385", "Asia/Karachi"),("1164216", "Swābi", "", "PK", "586", "", "03", "", "", "34.12018", "72.46982", "Asia/Karachi"),("1164245", "Surkhpur", "", "PK", "586", "", "04", "1177651", "", "32.71667", "74.45", "Asia/Karachi"),("1164306", "Sūrāb", "", "PK", "586", "", "02", "", "", "28.49276", "66.25999", "Asia/Karachi"),("1164408", "Sukkur", "Суккур", "PK", "586", "", "05", "", "", "27.70516", "68.85738", "Asia/Karachi"),("1164419", "Sukheke Mandi", "", "PK", "586", "", "04", "", "", "31.86388", "73.51122", "Asia/Karachi"),("1164660", "Sohbatpur", "", "PK", "586", "", "02", "", "", "28.52038", "68.54298", "Asia/Karachi"),("1164679", "Sodhri", "", "PK", "586", "", "04", "", "", "32.46211", "74.18207", "Asia/Karachi"),("1164698", "Sobhodero", "", "PK", "586", "", "05", "", "", "27.30475", "68.39715", "Asia/Karachi"),("1164716", "Sīta Road", "", "PK", "586", "", "05", "", "", "27.03333", "67.85", "Asia/Karachi"),("1164776", "Sinjhoro", "", "PK", "586", "", "05", "", "", "26.03031", "68.80898", "Asia/Karachi"),("1164825", "Sillānwāli", "", "PK", "586", "", "04", "", "", "31.82539", "72.54064", "Asia/Karachi"),("1164896", "Sibi", "Сиби", "PK", "586", "", "02", "", "", "29.54299", "67.87726", "Asia/Karachi"),("1164909", "Sialkot", "Сиалкот", "PK", "586", "", "04", "", "", "32.49268", "74.53134", "Asia/Karachi"),("1164970", "Shujāābād", "", "PK", "586", "", "04", "", "", "29.87967", "71.29313", "Asia/Karachi"),("1164987", "Shorko", "", "PK", "586", "", "03", "", "", "31.90991", "70.87741", "Asia/Karachi"),("1165108", "Shikārpur", "", "PK", "586", "", "05", "", "", "27.95706", "68.63789", "Asia/Karachi"),("1165221", "Sheikhupura", "", "PK", "586", "", "04", "", "", "31.71306", "73.97833", "Asia/Karachi"),("1165260", "Sharqpur", "", "PK", "586", "", "04", "", "", "31.46333", "74.1", "Asia/Karachi"),("1165388", "Shakargarh", "", "PK", "586", "", "04", "", "", "32.26361", "75.16008", "Asia/Karachi"),("1165486", "Shahr Sultān", "", "PK", "586", "", "04", "", "", "29.57646", "71.02116", "Asia/Karachi"),("1165507", "Shāhpur Chākar", "", "PK", "586", "", "05", "", "", "26.15497", "68.65093", "Asia/Karachi"),("1165518", "Shāhpur", "", "PK", "586", "", "04", "", "", "32.2676", "72.47204", "Asia/Karachi"),("1165569", "Shahkot", "", "PK", "586", "", "04", "7419159", "", "31.5709", "73.48531", "Asia/Karachi"),("1165635", "Shāhdādpur", "", "PK", "586", "", "05", "", "", "25.92539", "68.6228", "Asia/Karachi"),("1165638", "Shahdād Kot", "", "PK", "586", "", "05", "", "", "27.84726", "67.90679", "Asia/Karachi"),("1165744", "Shabqadar", "", "PK", "586", "", "03", "", "", "34.21599", "71.5548", "Asia/Karachi"),("1165789", "Sehwān", "", "PK", "586", "", "05", "", "", "26.42495", "67.86126", "Asia/Karachi"),("1166000", "Sargodha", "Саргодха", "PK", "586", "", "04", "", "", "32.08361", "72.67111", "Asia/Karachi"),("1166062", "Sarāi Sidhu", "", "PK", "586", "", "04", "", "", "30.59489", "71.96977", "Asia/Karachi"),("1166066", "Sarāi Naurang", "", "PK", "586", "", "03", "", "", "32.82591", "70.78136", "Asia/Karachi"),("1166073", "Sarāi Ālamgīr", "", "PK", "586", "", "04", "1177651", "", "32.90495", "73.75518", "Asia/Karachi"),("1166115", "Sann", "", "PK", "586", "", "05", "", "", "26.0403", "68.13763", "Asia/Karachi"),("1166118", "Sanjwāl", "", "PK", "586", "", "04", "", "", "33.76105", "72.43315", "Asia/Karachi"),("1166146", "Sangla Hill", "", "PK", "586", "", "04", "7419159", "", "31.71667", "73.38333", "Asia/Karachi"),("1166164", "Sānghar", "", "PK", "586", "", "05", "", "", "26.04656", "68.9481", "Asia/Karachi"),("1166265", "Sambriāl", "", "PK", "586", "", "04", "", "", "32.47835", "74.35338", "Asia/Karachi"),("1166275", "Samaro", "", "PK", "586", "", "05", "", "", "25.28143", "69.39623", "Asia/Karachi"),("1166381", "Sakrand", "", "PK", "586", "", "05", "", "", "26.13839", "68.27361", "Asia/Karachi"),("1166547", "Sāhīwāl", "Сахивале", "PK", "586", "", "04", "1165999", "", "31.97386", "72.33109", "Asia/Karachi"),("1166548", "Sahiwal", "Сахивал", "PK", "586", "", "04", "1166545", "", "30.66667", "73.1", "Asia/Karachi"),("1166652", "Sādiqābād", "", "PK", "586", "", "04", "", "", "28.30623", "70.13065", "Asia/Karachi"),("1166720", "Rustam", "", "PK", "586", "", "05", "", "", "27.96705", "68.80386", "Asia/Karachi"),("1166819", "Rojhān", "", "PK", "586", "", "04", "", "", "28.68677", "69.95343", "Asia/Karachi"),("1166827", "Rohri", "", "PK", "586", "", "05", "", "", "27.69223", "68.89506", "Asia/Karachi"),("1166933", "Renāla Khurd", "", "PK", "586", "", "04", "", "", "30.88333", "73.6", "Asia/Karachi"),("1166993", "Rawalpindi", "Равалпинди", "PK", "586", "", "04", "", "", "33.6007", "73.0679", "Asia/Karachi"),("1167031", "Ratodero", "", "PK", "586", "", "05", "", "", "27.80296", "68.28708", "Asia/Karachi"),("1167064", "Rasūlnagar", "", "PK", "586", "", "04", "", "", "32.32853", "73.78136", "Asia/Karachi"),("1167142", "Rānīpur", "", "PK", "586", "", "05", "", "", "27.28792", "68.50505", "Asia/Karachi"),("1167342", "Rājo Khanāni", "", "PK", "586", "", "05", "", "", "24.98405", "68.85357", "Asia/Karachi"),("1167380", "Rājanpur", "", "PK", "586", "", "04", "", "", "29.10351", "70.32504", "Asia/Karachi"),("1167386", "Rāja Jang", "", "PK", "586", "", "04", "", "", "31.22083", "74.25194", "Asia/Karachi"),("1167398", "Rāiwind", "", "PK", "586", "", "04", "", "", "31.25444", "74.21778", "Asia/Karachi"),("1167501", "Rādhan", "", "PK", "586", "", "05", "", "", "27.18333", "67.95", "Asia/Karachi"),("1167507", "Chenāb Nagar", "", "PK", "586", "", "04", "", "", "31.75511", "72.91403", "Asia/Karachi"),("1167528", "Quetta", "Кветта", "PK", "586", "", "02", "", "", "30.18414", "67.00141", "Asia/Karachi"),("1167622", "Kambar", "Камбар", "PK", "586", "", "05", "", "", "27.58753", "68.00066", "Asia/Karachi"),("1167648", "Qādirpur Rān", "", "PK", "586", "", "04", "", "", "30.29238", "71.67117", "Asia/Karachi"),("1167798", "Pithoro", "", "PK", "586", "", "05", "", "", "25.51122", "69.37803", "Asia/Karachi"),("1167821", "Pishin", "Пишин", "PK", "586", "", "02", "", "", "30.58176", "66.99406", "Asia/Karachi"),("1167873", "Pīr Mahal", "", "PK", "586", "", "04", "", "", "30.76667", "72.43333", "Asia/Karachi"),("1168015", "Pindi Gheb", "", "PK", "586", "", "04", "", "", "33.24023", "72.26609", "Asia/Karachi"),("1168021", "Pindi Bhattiān", "", "PK", "586", "", "04", "", "", "31.89781", "73.27302", "Asia/Karachi"),("1168036", "Pind Dādan Khān", "", "PK", "586", "", "04", "", "", "32.58662", "73.04456", "Asia/Karachi"),("1168101", "Phūlji", "", "PK", "586", "", "05", "", "", "26.88251", "67.6807", "Asia/Karachi"),("1168166", "Phālia", "", "PK", "586", "", "04", "", "", "32.42973", "73.57745", "Asia/Karachi"),("1168197", "Peshawar", "Пешавар", "PK", "586", "", "03", "", "", "34.008", "71.57849", "Asia/Karachi"),("1168226", "Pattoki", "", "PK", "586", "", "04", "", "", "31.01667", "73.85", "Asia/Karachi"),("1168307", "Pasrūr", "", "PK", "586", "", "04", "", "", "32.26286", "74.66327", "Asia/Karachi"),("1168312", "Pasni", "Пасни", "PK", "586", "", "02", "", "", "25.26316", "63.46809", "Asia/Karachi"),("1168394", "Parachinar", "", "PK", "586", "", "01", "", "", "33.89968", "70.10012", "Asia/Karachi"),("1168412", "Pāno Āqil", "", "PK", "586", "", "05", "", "", "27.85619", "69.11111", "Asia/Karachi"),("1168555", "Pākpattan", "", "PK", "586", "", "04", "", "", "30.34104", "73.38664", "Asia/Karachi"),("1168633", "Pahārpur", "", "PK", "586", "", "03", "", "", "32.10384", "70.97235", "Asia/Karachi"),("1168652", "Pad Īdan", "", "PK", "586", "", "05", "", "", "26.77475", "68.30197", "Asia/Karachi"),("1168680", "Pabbi", "", "PK", "586", "", "03", "", "", "34.00968", "71.79445", "Asia/Karachi"),("1168700", "Ormāra", "", "PK", "586", "", "02", "", "", "25.2088", "64.6357", "Asia/Karachi"),("1168718", "Okāra", "Окара", "PK", "586", "", "04", "", "", "30.80806", "73.44583", "Asia/Karachi"),("1168749", "Nushki", "", "PK", "586", "", "02", "", "", "29.55218", "66.02288", "Asia/Karachi"),("1169116", "Nawābshāh", "", "PK", "586", "", "05", "", "", "26.24833", "68.40955", "Asia/Karachi"),("1169143", "Naushahro Fīroz", "", "PK", "586", "", "05", "", "", "26.8401", "68.12265", "Asia/Karachi"),("1169145", "Naushahra Virkān", "", "PK", "586", "", "04", "", "", "31.96283", "73.97225", "Asia/Karachi"),("1169187", "Naudero", "", "PK", "586", "", "05", "", "", "27.66684", "68.3609", "Asia/Karachi"),("1169254", "Nasīrābād", "", "PK", "586", "", "05", "", "", "27.38137", "67.91644", "Asia/Karachi"),("1169278", "Nārowāl", "", "PK", "586", "", "04", "", "", "32.10197", "74.87303", "Asia/Karachi"),("1169334", "Nārang", "Наранг", "PK", "586", "", "04", "", "", "31.9132", "74.51756", "Asia/Karachi"),("1169367", "Naukot", "", "PK", "586", "", "05", "", "", "24.85869", "69.40238", "Asia/Karachi"),("1169372", "Nankāna Sāhib", "", "PK", "586", "", "04", "", "", "31.4475", "73.69722", "Asia/Karachi"),("1169580", "Nabīsar", "", "PK", "586", "", "05", "", "", "25.06854", "69.64186", "Asia/Karachi"),("1169605", "Muzaffargarh", "Музаффаргар", "PK", "586", "", "04", "", "", "30.07258", "71.19379", "Asia/Karachi"),("1169607", "Muzaffarābād", "", "PK", "586", "", "06", "", "", "34.37002", "73.47082", "Asia/Karachi"),("1169620", "Mustafābād", "", "PK", "586", "", "04", "", "", "30.89222", "73.49889", "Asia/Karachi"),("1169684", "Murree", "", "PK", "586", "", "04", "", "", "33.90836", "73.3903", "Asia/Karachi"),("1169692", "Murīdke", "", "PK", "586", "", "04", "", "", "31.8025", "74.26167", "Asia/Karachi"),("1169825", "Multān", "Мултан", "PK", "586", "", "04", "", "", "30.19679", "71.47824", "Asia/Karachi"),("1170013", "Moro", "", "PK", "586", "", "05", "", "", "26.66459", "68.00156", "Asia/Karachi"),("1170219", "Mithi", "", "PK", "586", "", "05", "", "", "24.73701", "69.79707", "Asia/Karachi"),("1170222", "Mitha Tiwāna", "", "PK", "586", "", "04", "", "", "32.2454", "72.10615", "Asia/Karachi"),("1170281", "Mīrwāh Gorchani", "", "PK", "586", "", "05", "", "", "25.30928", "69.05211", "Asia/Karachi"),("1170290", "Mīrpur Sakro", "", "PK", "586", "", "05", "", "", "24.54743", "67.62771", "Asia/Karachi"),("1170294", "Mīrpur Mathelo", "", "PK", "586", "", "05", "", "", "28.02136", "69.54914", "Asia/Karachi"),("1170295", "Mirpur Khas", "Мирпур-Хас", "PK", "586", "", "05", "", "", "25.5251", "69.0159", "Asia/Karachi"),("1170299", "Mīrpur Batoro", "", "PK", "586", "", "05", "", "", "24.72861", "68.26026", "Asia/Karachi"),("1170312", "Mīro Khān", "", "PK", "586", "", "05", "", "", "27.75991", "68.09212", "Asia/Karachi"),("1170395", "Mingora", "", "PK", "586", "", "03", "", "", "34.7795", "72.36265", "Asia/Karachi"),("1170398", "Minchinābād", "", "PK", "586", "", "04", "", "", "30.163", "73.56854", "Asia/Karachi"),("1170425", "Miānwāli", "", "PK", "586", "", "04", "", "", "32.57409", "71.52639", "Asia/Karachi"),("1170486", "Miān Channūn", "", "PK", "586", "", "04", "", "", "30.44004", "72.35431", "Asia/Karachi"),("1170564", "Mehrābpur", "", "PK", "586", "", "02", "", "", "28.10773", "68.02554", "Asia/Karachi"),("1170584", "Mehar", "", "PK", "586", "", "05", "", "", "27.18067", "67.82288", "Asia/Karachi"),("1170667", "Mātli", "", "PK", "586", "", "05", "", "", "25.04312", "68.65568", "Asia/Karachi"),("1170677", "Matiāri", "", "PK", "586", "", "05", "", "", "25.59709", "68.4467", "Asia/Karachi"),("1170706", "Mastung", "", "PK", "586", "", "02", "", "", "29.79966", "66.84553", "Asia/Karachi"),("1170880", "Mardan", "Мардан", "PK", "586", "", "03", "", "", "34.19794", "72.04965", "Asia/Karachi"),("1170951", "Mānsehra", "Мансехра", "PK", "586", "", "03", "", "", "34.33023", "73.19679", "Asia/Karachi"),("1170974", "Mankera", "", "PK", "586", "", "04", "", "", "31.38656", "71.44067", "Asia/Karachi"),("1171050", "Mangla", "", "PK", "586", "", "04", "", "", "31.89306", "72.38167", "Asia/Karachi"),("1171123", "Mandi Bahāuddīn", "", "PK", "586", "", "04", "", "", "32.58704", "73.49123", "Asia/Karachi"),("1171165", "Mānānwāla", "", "PK", "586", "", "04", "", "", "31.58417", "73.68778", "Asia/Karachi"),("1171198", "Māmu Kānjan", "", "PK", "586", "", "04", "", "", "30.83333", "72.8", "Asia/Karachi"),("1171305", "Malīr Cantonment", "", "PK", "586", "", "05", "", "", "24.94343", "67.20591", "Asia/Karachi"),("1171376", "Malakwāl", "", "PK", "586", "", "04", "", "", "32.55449", "73.21274", "Asia/Karachi"),("1171502", "Mailsi", "", "PK", "586", "", "04", "", "", "29.80028", "72.17583", "Asia/Karachi"),("1171677", "Madeji", "", "PK", "586", "", "05", "", "", "27.75443", "68.45256", "Asia/Karachi"),("1171757", "Mach", "", "PK", "586", "", "02", "", "", "29.86371", "67.32979", "Asia/Karachi"),("1171868", "Loralai", "", "PK", "586", "", "02", "", "", "30.37051", "68.59795", "Asia/Karachi"),("1171965", "Lodhrān", "", "PK", "586", "", "04", "", "", "29.54051", "71.63357", "Asia/Karachi"),("1171991", "Liliāni", "", "PK", "586", "", "04", "", "", "32.20651", "72.95372", "Asia/Karachi"),("1172035", "Layyah", "", "PK", "586", "", "04", "7418967", "", "30.96128", "70.93904", "Asia/Karachi"),("1172128", "Lārkāna", "Ларкане", "PK", "586", "", "05", "", "", "27.55898", "68.21204", "Asia/Karachi"),("1172295", "Lāliān", "", "PK", "586", "", "04", "", "", "31.82462", "72.80116", "Asia/Karachi"),("1172318", "Lāla Mūsa", "", "PK", "586", "", "04", "", "", "32.70138", "73.95746", "Asia/Karachi"),("1172339", "Lakki Marwat", "", "PK", "586", "", "03", "", "", "32.60795", "70.91142", "Asia/Karachi"),("1172389", "Lakhi", "", "PK", "586", "", "05", "", "", "27.84958", "68.69936", "Asia/Karachi"),("1172451", "Lahore", "Лахор", "PK", "586", "", "04", "", "", "31.54972", "74.34361", "Asia/Karachi"),("1172488", "Ladhewāla Warāich", "", "PK", "586", "", "04", "", "", "32.15692", "74.11564", "Asia/Karachi"),("1172513", "Lāchi", "", "PK", "586", "", "03", "", "", "33.38325", "71.33858", "Asia/Karachi"),("1172657", "Kunri", "", "PK", "586", "", "05", "", "", "25.17847", "69.56913", "Asia/Karachi"),("1172663", "Kunjāh", "", "PK", "586", "", "04", "", "", "32.52982", "73.97486", "Asia/Karachi"),("1172682", "Kundiān", "", "PK", "586", "", "04", "", "", "32.45775", "71.47892", "Asia/Karachi"),("1172779", "Kulāchi", "", "PK", "586", "", "03", "", "", "31.92861", "70.45917", "Asia/Karachi"),("1172866", "Kot Sultan", "", "PK", "586", "", "04", "7418967", "", "30.7737", "70.93125", "Asia/Karachi"),("1172888", "Kot Samāba", "", "PK", "586", "", "04", "", "", "28.55221", "70.46837", "Asia/Karachi"),("1172904", "Kotri", "", "PK", "586", "", "05", "", "", "25.36566", "68.30831", "Asia/Karachi"),("1172915", "Kot Rādha Kishan", "", "PK", "586", "", "04", "", "", "31.1725", "74.09972", "Asia/Karachi"),("1172964", "Kot Mūmin", "", "PK", "586", "", "04", "", "", "32.18954", "73.02797", "Asia/Karachi"),("1172993", "Kot Malik Barkhurdār", "", "PK", "586", "", "02", "", "", "30.20379", "66.98723", "Asia/Karachi"),("1173025", "Kotli Lohārān", "", "PK", "586", "", "04", "", "", "32.5883", "74.49321", "Asia/Karachi"),("1173055", "Kotli", "", "PK", "586", "", "06", "", "", "33.51836", "73.9022", "Asia/Karachi"),("1173272", "Kot Ghulām Muhammad", "", "PK", "586", "", "04", "", "", "32.33311", "74.54694", "Asia/Karachi"),("1173302", "Kot Diji", "", "PK", "586", "", "05", "", "", "27.34272", "68.70834", "Asia/Karachi"),("1173378", "Kot Addu", "", "PK", "586", "", "04", "", "", "30.4692", "70.96714", "Asia/Karachi"),("1173464", "Kohlu", "", "PK", "586", "", "02", "", "", "29.89651", "69.25324", "Asia/Karachi"),("1173491", "Kohāt", "Кохат", "PK", "586", "", "03", "", "", "33.58196", "71.44929", "Asia/Karachi"),("1173664", "Khuzdār", "", "PK", "586", "", "02", "", "", "27.81193", "66.61096", "Asia/Karachi"),("1173687", "Khushāb", "", "PK", "586", "", "04", "", "", "32.29667", "72.3525", "Asia/Karachi"),("1173692", "Khurriānwāla", "", "PK", "586", "", "04", "", "", "31.50056", "73.26667", "Asia/Karachi"),("1173920", "Khewra", "", "PK", "586", "", "04", "", "", "32.6491", "73.01059", "Asia/Karachi"),("1174042", "Khāriān", "", "PK", "586", "", "04", "", "", "32.81612", "73.88697", "Asia/Karachi"),("1174062", "Khārān", "", "PK", "586", "", "02", "", "", "28.58459", "65.41501", "Asia/Karachi"),("1174074", "Karak", "", "PK", "586", "", "03", "", "", "33.11633", "71.09354", "Asia/Karachi"),("1174167", "Khānpur", "", "PK", "586", "", "04", "", "", "28.64534", "70.6567", "Asia/Karachi"),("1174171", "Khānpur", "", "PK", "586", "", "05", "", "", "27.84358", "69.41373", "Asia/Karachi"),("1174211", "Khāngarh", "", "PK", "586", "", "04", "", "", "29.91446", "71.16067", "Asia/Karachi"),("1174217", "Khāngāh Dogrān", "", "PK", "586", "", "04", "", "", "31.83167", "73.62306", "Asia/Karachi"),("1174301", "Khalābat", "", "PK", "586", "", "03", "", "", "34.05997", "72.88963", "Asia/Karachi"),("1174344", "Khairpur Nathan Shāh", "", "PK", "586", "", "05", "", "", "27.09064", "67.73489", "Asia/Karachi"),("1174355", "Khairpur Tāmewah", "", "PK", "586", "", "04", "", "", "29.58139", "72.23804", "Asia/Karachi"),("1174357", "Khairpur", "Хайрпура", "PK", "586", "", "05", "", "", "28.06437", "69.70363", "Asia/Karachi"),("1174408", "Khadro", "", "PK", "586", "", "05", "", "", "26.14723", "68.71764", "Asia/Karachi"),("1174625", "Kasūr", "Касур", "PK", "586", "", "04", "", "", "31.11556", "74.44667", "Asia/Karachi"),("1174653", "Kashmor", "", "PK", "586", "", "05", "", "", "28.4326", "69.58364", "Asia/Karachi"),("1174720", "Karor", "", "PK", "586", "", "04", "", "", "31.22741", "70.94923", "Asia/Karachi"),("1174765", "Kario", "", "PK", "586", "", "05", "", "", "24.80817", "68.60448", "Asia/Karachi"),("1174815", "Karaundi", "", "PK", "586", "", "05", "", "", "26.89745", "68.40681", "Asia/Karachi"),("1174872", "Karachi", "Карачи", "PK", "586", "", "05", "1174870", "", "24.9056", "67.0822", "Asia/Karachi"),("1174984", "Kanganpur", "", "PK", "586", "", "04", "", "", "30.76629", "74.12311", "Asia/Karachi"),("1175010", "Kandiāro", "", "PK", "586", "", "05", "", "", "27.05918", "68.21022", "Asia/Karachi"),("1175012", "Kandiāri", "", "PK", "586", "", "05", "", "", "26.9155", "68.52193", "Asia/Karachi"),("1175021", "Kandhkot", "", "PK", "586", "", "05", "", "", "28.24396", "69.18235", "Asia/Karachi"),("1175082", "Kāmra", "", "PK", "586", "", "04", "", "", "33.74698", "73.51229", "Asia/Karachi"),("1175088", "Kamoke", "", "PK", "586", "", "04", "", "", "31.97444", "74.22444", "Asia/Karachi"),("1175098", "Kamīr", "", "PK", "586", "", "04", "", "", "30.43333", "73.05", "Asia/Karachi"),("1175125", "Kamar Mushāni", "", "PK", "586", "", "04", "", "", "32.84389", "71.36694", "Asia/Karachi"),("1175156", "Kamālia", "", "PK", "586", "", "04", "", "", "30.73333", "72.65", "Asia/Karachi"),("1175180", "Kalūr Kot", "", "PK", "586", "", "04", "", "", "32.15512", "71.26631", "Asia/Karachi"),("1175232", "Kallar Kahār", "", "PK", "586", "", "04", "", "", "32.77998", "72.69793", "Asia/Karachi"),("1175283", "Kāleke Mandi", "", "PK", "586", "", "04", "", "", "31.97717", "73.60259", "Asia/Karachi"),("1175296", "Kalāt", "Калат", "PK", "586", "", "02", "", "", "29.02663", "66.59361", "Asia/Karachi"),("1175297", "Kālaswāla", "", "PK", "586", "", "04", "", "", "32.20081", "74.64858", "Asia/Karachi"),("1175365", "Kālābāgh", "", "PK", "586", "", "04", "", "", "32.96164", "71.54638", "Asia/Karachi"),("1175436", "Kahuta", "Кахуте", "PK", "586", "", "04", "", "", "33.59183", "73.38736", "Asia/Karachi"),("1175446", "Kohror Pakka", "", "PK", "586", "", "04", "", "", "29.62382", "71.91673", "Asia/Karachi"),("1175453", "Kāhna", "", "PK", "586", "", "04", "", "", "31.36917", "74.36528", "Asia/Karachi"),("1175506", "Kadhan", "", "PK", "586", "", "05", "", "", "24.48041", "68.98551", "Asia/Karachi"),("1175560", "Kabīrwāla", "", "PK", "586", "", "04", "", "", "30.40472", "71.86269", "Asia/Karachi"),("1175678", "Johi", "", "PK", "586", "", "05", "", "", "26.69206", "67.6133", "Asia/Karachi"),("1175712", "Jīwani", "", "PK", "586", "", "02", "", "", "25.04852", "61.74573", "Asia/Karachi"),("1175748", "Chak Jhumra", "", "PK", "586", "", "04", "", "", "31.56808", "73.18317", "Asia/Karachi"),("1175762", "Jhol", "", "PK", "586", "", "05", "", "", "25.95507", "68.88821", "Asia/Karachi"),("1175864", "Jhelum", "Джелам", "PK", "586", "", "04", "", "", "32.93448", "73.73102", "Asia/Karachi"),("1175870", "Jhāwāriān", "", "PK", "586", "", "04", "", "", "32.36192", "72.62275", "Asia/Karachi"),("1175892", "Jhang Sadr", "", "PK", "586", "", "04", "", "", "31.26981", "72.31687", "Asia/Karachi"),("1176022", "Jauharābād", "", "PK", "586", "", "04", "", "", "32.2898", "72.2813", "Asia/Karachi"),("1176035", "Jatoi Shimāli", "", "PK", "586", "", "04", "", "", "29.51654", "70.85032", "Asia/Karachi"),("1176048", "Jāti", "", "PK", "586", "", "05", "", "", "24.3539", "68.26706", "Asia/Karachi"),("1176106", "Jarānwāla", "", "PK", "586", "", "04", "", "", "31.33333", "73.43333", "Asia/Karachi"),("1176206", "Jāndiāla Sher Khān", "", "PK", "586", "", "04", "", "", "31.81986", "73.91812", "Asia/Karachi"),("1176218", "Jand", "", "PK", "586", "", "04", "", "", "33.42985", "72.01928", "Asia/Karachi"),("1176241", "Jāmpur", "", "PK", "586", "", "04", "", "", "29.64414", "70.59544", "Asia/Karachi"),("1176358", "Jalālpur Pīrwāla", "", "PK", "586", "", "04", "", "", "29.50687", "71.21917", "Asia/Karachi"),("1176368", "Jalalpur Jattān", "", "PK", "586", "", "04", "", "", "32.64118", "74.20561", "Asia/Karachi"),("1176444", "Jahāniān Shāh", "", "PK", "586", "", "04", "", "", "31.80541", "72.2774", "Asia/Karachi"),("1176515", "Jacobābād", "", "PK", "586", "", "05", "", "", "28.28187", "68.43761", "Asia/Karachi"),("1176608", "Islāmkot", "", "PK", "586", "", "05", "", "", "24.69904", "70.17982", "Asia/Karachi"),("1176615", "Islamabad", "Исламабад", "PK", "586", "", "08", "", "", "33.72148", "73.04329", "Asia/Karachi"),("1176734", "Hyderabad", "Хайдарабад", "PK", "586", "", "05", "", "", "25.39242", "68.37366", "Asia/Karachi"),("1176800", "Hujra", "", "PK", "586", "", "04", "", "", "30.74179", "73.82358", "Asia/Karachi"),("1176889", "Hingorja", "", "PK", "586", "", "05", "", "", "27.21088", "68.41598", "Asia/Karachi"),("1176948", "Hazro City", "", "PK", "586", "", "04", "", "", "33.9099", "72.49179", "Asia/Karachi"),("1176995", "Haveliān", "", "PK", "586", "", "03", "", "", "34.05348", "73.15993", "Asia/Karachi"),("1176997", "Haveli", "", "PK", "586", "", "04", "", "", "30.45016", "73.69888", "Asia/Karachi"),("1177042", "Hāsilpur", "", "PK", "586", "", "04", "", "", "29.69221", "72.54566", "Asia/Karachi"),("1177064", "Hasan Abdāl", "", "PK", "586", "", "04", "", "", "30.43333", "72.7", "Asia/Karachi"),("1177073", "Haru Zbad", "", "PK", "586", "", "04", "", "", "29.61206", "73.13802", "Asia/Karachi"),("1177089", "Harnoli", "", "PK", "586", "", "04", "", "", "32.27917", "71.55389", "Asia/Karachi"),("1177098", "Harnāi", "", "PK", "586", "", "02", "", "", "30.10077", "67.93824", "Asia/Karachi"),("1177107", "Harīpur", "Харипур", "PK", "586", "", "03", "", "", "33.99997", "72.93409", "Asia/Karachi"),("1177203", "Hangu", "", "PK", "586", "", "03", "", "", "33.53198", "71.0595", "Asia/Karachi"),("1177278", "Hāla", "Хала", "PK", "586", "", "05", "", "", "25.81308", "68.42273", "Asia/Karachi"),("1177384", "Hāfizābād", "", "PK", "586", "", "04", "", "", "32.06786", "73.68545", "Asia/Karachi"),("1177397", "Hadāli", "", "PK", "586", "", "04", "", "", "32.64132", "74.56904", "Asia/Karachi"),("1177446", "Gwadar", "Гвадар", "PK", "586", "", "02", "", "", "25.12163", "62.32541", "Asia/Karachi"),("1177654", "Gujrāt", "Гуджарат", "PK", "586", "", "04", "", "", "32.5742", "74.07542", "Asia/Karachi"),("1177662", "Gujrānwāla", "Гайранвала", "PK", "586", "", "04", "", "", "32.15567", "74.18705", "Asia/Karachi"),("1177682", "Gujar Khān", "", "PK", "586", "", "04", "", "", "33.25411", "73.30433", "Asia/Karachi"),("1178231", "Gojra", "", "PK", "586", "", "04", "", "", "31.14926", "72.68323", "Asia/Karachi"),("1178338", "Gilgit", "", "PK", "586", "", "07", "", "", "35.91869", "74.31245", "Asia/Karachi"),("1178456", "Ghotki", "", "PK", "586", "", "05", "", "", "28.00604", "69.31608", "Asia/Karachi"),("1178560", "Ghauspur", "", "PK", "586", "", "05", "", "", "28.13906", "69.08305", "Asia/Karachi"),("1178587", "Ghāro", "", "PK", "586", "", "05", "", "", "24.74241", "67.58565", "Asia/Karachi"),("1178841", "Garh Mahārāja", "", "PK", "586", "", "04", "", "", "30.83383", "71.90491", "Asia/Karachi"),("1178843", "Garhi Yāsīn", "", "PK", "586", "", "05", "", "", "27.90689", "68.51096", "Asia/Karachi"),("1178858", "Garhi Khairo", "", "PK", "586", "", "02", "", "", "28.06029", "67.98033", "Asia/Karachi"),("1178902", "Goth Garelo", "", "PK", "586", "", "05", "", "", "27.43517", "68.0755", "Asia/Karachi"),("1179061", "Gambat", "", "PK", "586", "", "05", "", "", "27.35145", "68.52051", "Asia/Karachi"),("1179185", "Gadāni", "", "PK", "586", "", "02", "", "", "25.11853", "66.72985", "Asia/Karachi"),("1179223", "Fort Abbās", "", "PK", "586", "", "04", "", "", "29.19344", "72.85525", "Asia/Karachi"),("1179255", "Fāzilpur", "", "PK", "586", "", "04", "", "", "32.17629", "75.06583", "Asia/Karachi"),("1179305", "Chak Two Hundred Forty-Nine TDA", "", "PK", "586", "", "04", "", "", "31.17959", "71.20946", "Asia/Karachi"),("1179346", "Farūka", "", "PK", "586", "", "04", "", "", "31.88642", "72.41362", "Asia/Karachi"),("1179377", "Faqīrwāli", "", "PK", "586", "", "04", "", "", "29.46799", "73.03489", "Asia/Karachi"),("1179400", "Faisalābād", "Фейсалабаде", "PK", "586", "", "04", "", "", "31.41667", "73.08333", "Asia/Karachi"),("1179406", "Eminābād", "", "PK", "586", "", "04", "", "", "32.04237", "74.25996", "Asia/Karachi"),("1179450", "Dunyāpur", "", "PK", "586", "", "04", "", "", "29.7995", "71.71958", "Asia/Karachi"),("1179463", "Dūnga Būnga", "", "PK", "586", "", "04", "", "", "29.74975", "73.24294", "Asia/Karachi"),("1179496", "Dullewāla", "", "PK", "586", "", "04", "", "", "31.83587", "71.43625", "Asia/Karachi"),("1179515", "Duki", "", "PK", "586", "", "02", "", "", "30.15307", "68.57323", "Asia/Karachi"),("1179660", "Dokri", "", "PK", "586", "", "05", "", "", "27.37427", "68.09673", "Asia/Karachi"),("1179724", "Doāba", "", "PK", "586", "", "03", "", "", "33.4245", "70.73676", "Asia/Karachi"),("1179757", "Upper Dir", "", "PK", "586", "", "03", "", "", "35.2074", "71.8768", "Asia/Karachi"),("1179758", "Diplo", "", "PK", "586", "", "05", "", "", "24.46688", "69.58114", "Asia/Karachi"),("1179760", "Dīpālpur", "", "PK", "586", "", "04", "", "", "30.67091", "73.65292", "Asia/Karachi"),("1179762", "Dinan Bashnoian Wala", "", "PK", "586", "", "04", "1183882", "", "29.76584", "73.26557", "Asia/Karachi"),("1179790", "Dinga", "", "PK", "586", "", "04", "", "", "32.64101", "73.72039", "Asia/Karachi"),("1179834", "Dijkot", "", "PK", "586", "", "04", "", "", "31.21735", "72.99621", "Asia/Karachi"),("1179837", "Digri", "", "PK", "586", "", "05", "", "", "25.15579", "69.11129", "Asia/Karachi"),("1179902", "Dhoro Naro", "", "PK", "586", "", "05", "", "", "25.50484", "69.5709", "Asia/Karachi"),("1180071", "Dhaunkal", "", "PK", "586", "", "04", "", "", "32.40613", "74.13706", "Asia/Karachi"),("1180133", "Dhanot", "", "PK", "586", "", "04", "", "", "29.57991", "71.75213", "Asia/Karachi"),("1180281", "Dera Ismāīl Khān", "", "PK", "586", "", "03", "", "", "31.83269", "70.9024", "Asia/Karachi"),("1180289", "Dera Ghazi Khan", "Дера-Гази-Хан", "PK", "586", "", "04", "", "", "30.05614", "70.63477", "Asia/Karachi"),("1180295", "Dera Bugti", "", "PK", "586", "", "02", "", "", "29.03619", "69.15849", "Asia/Karachi"),("1180374", "Daur", "", "PK", "586", "", "05", "", "", "26.45834", "68.31915", "Asia/Karachi"),("1180379", "Daultāla", "", "PK", "586", "", "04", "", "", "33.19282", "73.14099", "Asia/Karachi"),("1180397", "Daulatpūr", "", "PK", "586", "", "05", "", "", "26.50158", "67.97079", "Asia/Karachi"),("1180419", "Dāūd Khel", "", "PK", "586", "", "04", "", "", "32.87533", "71.57118", "Asia/Karachi"),("1180436", "Daska Kalān", "", "PK", "586", "", "04", "", "", "32.32422", "74.35039", "Asia/Karachi"),("1180453", "Darya Khān Marri", "", "PK", "586", "", "05", "", "", "26.67765", "68.28666", "Asia/Karachi"),("1180454", "Darya Khān", "", "PK", "586", "", "04", "", "", "31.79123", "71.10394", "Asia/Karachi"),("1180491", "Dāro Mehar", "", "PK", "586", "", "05", "", "", "24.79463", "68.18052", "Asia/Karachi"),("1180729", "Dālbandīn", "", "PK", "586", "", "02", "", "", "28.88846", "64.40616", "Asia/Karachi"),("1180752", "Dājal", "", "PK", "586", "", "04", "", "", "29.55767", "70.37615", "Asia/Karachi"),("1180757", "Dāira Din Panah", "", "PK", "586", "", "04", "", "", "30.57053", "70.93722", "Asia/Karachi"),("1180809", "Dadu", "", "PK", "586", "", "05", "", "", "26.73287", "67.77631", "Asia/Karachi"),("1180825", "Dādhar", "", "PK", "586", "", "02", "", "", "29.47489", "67.65167", "Asia/Karachi"),("1180942", "Chūniān", "", "PK", "586", "", "04", "", "", "30.96397", "73.98029", "Asia/Karachi"),("1180983", "Chūhar Kāna", "", "PK", "586", "", "04", "", "", "31.75", "73.8", "Asia/Karachi"),("1181022", "Chhor", "", "PK", "586", "", "05", "", "", "25.5126", "69.78437", "Asia/Karachi"),("1181053", "Choa Saidān Shāh", "", "PK", "586", "", "04", "", "", "32.71962", "72.98625", "Asia/Karachi"),("1181073", "Chishtiān", "", "PK", "586", "", "04", "", "", "29.79713", "72.85772", "Asia/Karachi"),("1181096", "Chiniot", "Чиниот", "PK", "586", "", "04", "", "", "31.72", "72.97889", "Asia/Karachi"),("1181163", "Chīchāwatni", "", "PK", "586", "", "04", "", "", "30.53333", "72.7", "Asia/Karachi"),("1181352", "Chawinda", "", "PK", "586", "", "04", "", "", "32.34434", "74.70507", "Asia/Karachi"),("1181439", "Chārsadda", "", "PK", "586", "", "03", "", "", "34.14822", "71.7406", "Asia/Karachi"),("1181600", "Chambar", "", "PK", "586", "", "05", "", "", "25.29313", "68.81201", "Asia/Karachi"),("1181611", "Chaman", "", "PK", "586", "", "02", "", "", "30.91769", "66.45259", "Asia/Karachi"),("1181636", "Chakwāl", "", "PK", "586", "", "04", "", "", "32.93338", "72.85853", "Asia/Karachi"),("1181887", "Chak Āzam Saffo", "", "PK", "586", "", "04", "", "", "30.75", "73.03333", "Asia/Karachi"),("1181910", "Chak", "", "PK", "586", "", "05", "", "", "27.85838", "68.83378", "Asia/Karachi"),("1182092", "Būrewāla", "", "PK", "586", "", "04", "", "", "30.16667", "72.65", "Asia/Karachi"),("1182295", "Bozdar", "", "PK", "586", "", "05", "", "", "27.18275", "68.63604", "Asia/Karachi"),("1182577", "Bhopālwāla", "", "PK", "586", "", "04", "", "", "32.42968", "74.3635", "Asia/Karachi"),("1182607", "Bhit Shāh", "", "PK", "586", "", "05", "", "", "25.80437", "68.49265", "Asia/Karachi"),("1182622", "Bhiria", "", "PK", "586", "", "05", "", "", "26.91041", "68.19466", "Asia/Karachi"),("1182637", "Bhimbar", "", "PK", "586", "", "06", "", "", "32.97465", "74.07846", "Asia/Karachi"),("1182665", "Bhera", "", "PK", "586", "", "04", "", "", "32.48318", "72.9097", "Asia/Karachi"),("1182682", "Bhawāna", "", "PK", "586", "", "04", "", "", "31.56884", "72.64917", "Asia/Karachi"),("1182775", "Bhān", "", "PK", "586", "", "05", "", "", "26.55831", "67.72139", "Asia/Karachi"),("1182787", "Bhalwāl", "", "PK", "586", "", "04", "", "", "32.27204", "72.90425", "Asia/Karachi"),("1182815", "Bhakkar", "", "PK", "586", "", "04", "", "", "31.62525", "71.06574", "Asia/Karachi"),("1182829", "Bhāi Pheru", "", "PK", "586", "PK", "04", "", "", "31.2", "73.95", "Asia/Karachi"),("1182872", "Bhāg", "", "PK", "586", "", "02", "", "", "29.0415", "67.8239", "Asia/Karachi"),("1182953", "Berāni", "", "PK", "586", "", "05", "", "", "25.78501", "68.80686", "Asia/Karachi"),("1182998", "Bela", "Бела", "PK", "586", "", "02", "", "", "26.22718", "66.31178", "Asia/Karachi"),("1183018", "Begowāla", "", "PK", "586", "", "04", "", "", "32.43816", "74.26794", "Asia/Karachi"),("1183090", "Bat Khela", "", "PK", "586", "", "03", "", "", "34.6178", "71.97247", "Asia/Karachi"),("1183105", "Battagram", "", "PK", "586", "", "03", "8224052", "", "34.67719", "73.02329", "Asia/Karachi"),("1183224", "Basīrpur", "", "PK", "586", "", "04", "", "", "30.58319", "73.829", "Asia/Karachi"),("1183307", "Bārkhān", "", "PK", "586", "", "02", "", "", "29.89773", "69.52558", "Asia/Karachi"),("1183460", "Bannu", "", "PK", "586", "", "03", "", "", "32.98541", "70.6027", "Asia/Karachi"),("1183511", "Bāndhi", "", "PK", "586", "", "05", "", "", "26.58761", "68.30215", "Asia/Karachi"),("1183880", "Bahāwalpur", "Бахавалпура", "PK", "586", "", "04", "", "", "29.4", "71.68333", "Asia/Karachi"),("1183883", "Bahāwalnagar", "", "PK", "586", "", "04", "", "", "29.99866", "73.2536", "Asia/Karachi"),("1184008", "Bāgarji", "", "PK", "586", "", "05", "", "", "27.75431", "68.75866", "Asia/Karachi"),("1184020", "Baffa", "", "PK", "586", "", "03", "", "", "34.4377", "73.22368", "Asia/Karachi"),("1184055", "Badin", "", "PK", "586", "", "05", "", "", "24.656", "68.837", "Asia/Karachi"),("1184075", "Baddomalhi", "", "PK", "586", "", "04", "", "", "31.99283", "74.66833", "Asia/Karachi"),("1184249", "Attock City", "", "PK", "586", "", "04", "", "", "33.76671", "72.35977", "Asia/Karachi"),("1184370", "Ārifwāla", "", "PK", "586", "", "04", "", "", "30.29399", "73.07354", "Asia/Karachi"),("1184569", "Amān Garh", "", "PK", "586", "", "03", "", "", "34.00584", "71.92971", "Asia/Karachi"),("1184655", "Alīpur", "", "PK", "586", "", "04", "", "", "29.38464", "70.91157", "Asia/Karachi"),("1184752", "Akora", "Акора", "PK", "586", "", "03", "", "", "34.00337", "72.12561", "Asia/Karachi"),("1184845", "Ahmadpur East", "", "PK", "586", "", "04", "", "", "29.14309", "71.25976", "Asia/Karachi"),("1185056", "Abbottābād", "", "PK", "586", "", "03", "", "", "34.1463", "73.21168", "Asia/Karachi"),("1332083", "Bahāwalnagar", "", "PK", "586", "PK", "04", "", "", "30.55083", "73.39083", "Asia/Karachi"),("1341204", "Nowshera Cantonment", "", "PK", "586", "", "03", "", "", "33.99829", "71.99834", "Asia/Karachi"),("1347134", "Alik Ghund", "", "PK", "586", "", "02", "", "", "30.48976", "67.52177", "Asia/Karachi"),("1347927", "Khadan Khāk", "", "PK", "586", "", "02", "", "", "30.75236", "67.71133", "Asia/Karachi"),("1356491", "Ahmadpur Siāl", "", "PK", "586", "", "04", "", "", "30.67539", "71.74828", "Asia/Karachi"),("1357699", "New Bādāh", "", "PK", "586", "", "05", "", "", "27.34167", "68.03194", "Asia/Karachi"),("1360491", "Tando Ghulām Ali", "", "PK", "586", "", "05", "", "", "25.13111", "68.86759", "Asia/Karachi"),("1403734", "Jām Sāhib", "", "PK", "586", "", "05", "", "", "26.29583", "68.62917", "Asia/Karachi"),("1412008", "Sethārja Old", "", "PK", "586", "", "05", "", "", "27.2127", "68.46883", "Asia/Karachi"),("1448637", "Risalpur Cantonment", "", "PK", "586", "", "03", "", "", "34.06048", "71.99276", "Asia/Karachi"),("6457378", "Malakwal City", "", "PK", "586", "", "04", "", "", "32.55492", "73.2122", "Asia/Karachi"),("7649128", "Nazir Town", "", "PK", "586", "", "04", "1180287", "", "33.30614", "73.4833", "Asia/Karachi"),("752967", "Żyrardów", "Жирардув", "PL", "616", "", "78", "1438", "143801", "52.0488", "20.44599", "Europe/Warsaw"),("753004", "Zwoleń", "", "PL", "616", "", "78", "1436", "143605", "51.35542", "21.58768", "Europe/Warsaw"),("753130", "Żołynia", "", "PL", "616", "", "80", "1810", "181007", "50.162", "22.30825", "Europe/Warsaw"),("753142", "Żoliborz", "", "PL", "616", "PL", "78", "1465", "146501", "52.26896", "20.98644", "Europe/Warsaw"),("753276", "Zielonka", "Зеленка", "PL", "616", "", "78", "1434", "143404", "52.30376", "21.16018", "Europe/Warsaw"),("753866", "Zamość", "Замосць", "PL", "616", "", "75", "0664", "066401", "50.72314", "23.25196", "Europe/Warsaw"),("753895", "Zambrów", "Замбрув", "PL", "616", "", "81", "2014", "201401", "52.9855", "22.24319", "Europe/Warsaw"),("754195", "Zagórz", "", "PL", "616", "", "80", "1817", "181707", "49.51457", "22.26706", "Europe/Warsaw"),("754351", "Ząbki", "Зомбки", "PL", "616", "", "78", "1434", "143403", "52.29271", "21.10539", "Europe/Warsaw"),("754454", "Wyszków", "Вышкув", "PL", "616", "", "78", "1435", "143505", "52.59278", "21.4584", "Europe/Warsaw"),("754479", "Wysokie Mazowieckie", "", "PL", "616", "", "81", "2013", "201301", "52.91661", "22.51712", "Europe/Warsaw"),("754800", "Wołomin", "Воломин", "PL", "616", "", "78", "1434", "143412", "52.34006", "21.24207", "Europe/Warsaw"),("755330", "Wola", "", "PL", "616", "", "78", "1465", "146501", "52.2401", "20.98869", "Europe/Warsaw"),("755474", "Włodawa", "", "PL", "616", "", "75", "0619", "061901", "51.55", "23.55", "Europe/Warsaw"),("755475", "Włochy", "", "PL", "616", "", "78", "1465", "146501", "52.17941", "20.94612", "Europe/Warsaw"),("755726", "Wilanów", "", "PL", "616", "", "78", "1465", "146501", "52.16311", "21.08748", "Europe/Warsaw"),("755889", "Wieliczka", "Величка", "PL", "616", "", "77", "1219", "121905", "49.98738", "20.06473", "Europe/Warsaw"),("756004", "Wesoła", "", "PL", "616", "", "78", "1465", "146501", "52.25451", "21.22407", "Europe/Warsaw"),("756046", "Węgrów", "", "PL", "616", "", "78", "1433", "143301", "52.39954", "22.01634", "Europe/Warsaw"),("756048", "Węgorzewo", "", "PL", "616", "", "85", "2819", "281903", "54.21567", "21.7372", "Europe/Warsaw"),("756092", "Wawer", "", "PL", "616", "", "78", "1465", "146501", "52.19656", "21.17752", "Europe/Warsaw"),("756120", "Wasilków", "", "PL", "616", "", "81", "2002", "200213", "53.19909", "23.20776", "Europe/Warsaw"),("756135", "Warsaw", "Варшава", "PL", "616", "", "78", "1465", "146501", "52.22977", "21.01178", "Europe/Warsaw"),("756151", "Warka", "", "PL", "616", "", "78", "1406", "140611", "51.7843", "21.19091", "Europe/Warsaw"),("756280", "Ustrzyki Dolne", "", "PL", "616", "", "80", "1801", "180108", "49.4304", "22.59381", "Europe/Warsaw"),("756320", "Ursus", "", "PL", "616", "", "78", "1465", "146501", "52.19517", "20.88419", "Europe/Warsaw"),("756634", "Tuchów", "", "PL", "616", "", "77", "1216", "121610", "49.89485", "21.05407", "Europe/Warsaw"),("756867", "Tomaszów Mazowiecki", "Томашув-Мазовецкий", "PL", "616", "", "74", "1016", "101601", "51.53131", "20.00855", "Europe/Warsaw"),("756868", "Tomaszów Lubelski", "Томашув-Любельски", "PL", "616", "", "75", "0618", "061801", "50.44767", "23.41616", "Europe/Warsaw"),("756919", "Tłuszcz", "", "PL", "616", "", "78", "1434", "143411", "52.43058", "21.43561", "Europe/Warsaw"),("756938", "Terespol", "", "PL", "616", "", "75", "0601", "060116", "52.0755", "23.61614", "Europe/Warsaw"),("757026", "Tarnów", "Тарнув", "PL", "616", "", "77", "1263", "126301", "50.01381", "20.98698", "Europe/Warsaw"),("757033", "Tarnobrzeg", "Тарнобжеге", "PL", "616", "", "80", "1864", "186401", "50.57304", "21.67937", "Europe/Warsaw"),("757065", "Targówek", "", "PL", "616", "", "78", "1465", "146501", "52.29185", "21.04845", "Europe/Warsaw"),("757178", "Szydłowiec", "", "PL", "616", "", "78", "1430", "143005", "51.22823", "20.86106", "Europe/Warsaw"),("757357", "Szczytno", "Щитно", "PL", "616", "", "85", "2817", "281706", "53.56259", "20.98747", "Europe/Warsaw"),("757452", "Szczebrzeszyn", "", "PL", "616", "", "75", "0620", "062013", "50.69499", "22.97954", "Europe/Warsaw"),("757461", "Szczawnica", "", "PL", "616", "PL", "77", "1211", "121102", "49.42437", "20.48487", "Europe/Warsaw"),("757692", "Świdnik", "", "PL", "616", "PL", "75", "0617", "061701", "51.21898", "22.69621", "Europe/Warsaw"),("757718", "Suwałki", "Сувалки", "PL", "616", "", "81", "2063", "206301", "54.11175", "22.93087", "Europe/Warsaw"),("757809", "Sulejówek", "", "PL", "616", "", "78", "1412", "141215", "52.25221", "21.26902", "Europe/Warsaw"),("757886", "Suchedniów", "", "PL", "616", "", "84", "2610", "261005", "51.04776", "20.82922", "Europe/Warsaw"),("757957", "Strzyżów", "", "PL", "616", "PL", "80", "1819", "181904", "49.87074", "21.79413", "Europe/Warsaw"),("758252", "Staszów", "Сташув", "PL", "616", "", "84", "2612", "261207", "50.56307", "21.16593", "Europe/Warsaw"),("758282", "Stary Sącz", "", "PL", "616", "", "77", "1210", "121016", "49.56364", "20.63496", "Europe/Warsaw"),("758390", "Starachowice", "Стараховице", "PL", "616", "", "84", "2611", "261101", "51.0374", "21.07126", "Europe/Warsaw"),("758393", "Stąporków", "", "PL", "616", "", "84", "2605", "260508", "51.13762", "20.57173", "Europe/Warsaw"),("758445", "Stalowa Wola", "Сталёва-Воля", "PL", "616", "", "80", "1818", "181801", "50.58286", "22.05334", "Europe/Warsaw"),("758470", "Śródmieście", "Средместье", "PL", "616", "", "78", "1465", "146501", "52.22904", "21.01644", "Europe/Warsaw"),("758626", "Sokołów Podlaski", "Соколув-Подляски", "PL", "616", "", "78", "1429", "142901", "52.40677", "22.25307", "Europe/Warsaw"),("758651", "Sokółka", "Сокулка", "PL", "616", "", "81", "2011", "201108", "53.40715", "23.50228", "Europe/Warsaw"),("758682", "Sochaczew", "Сохачев", "PL", "616", "", "78", "1428", "142801", "52.22944", "20.23838", "Europe/Warsaw"),("759123", "Skierniewice", "Скерневице", "PL", "616", "", "74", "1063", "106301", "51.95485", "20.15837", "Europe/Warsaw"),("759141", "Skarżysko-Kamienna", "Скаржиско-Каменна", "PL", "616", "", "84", "2610", "261001", "51.11311", "20.87162", "Europe/Warsaw"),("759320", "Siemiatycze", "Семятыче", "PL", "616", "", "81", "2010", "201001", "52.42719", "22.86231", "Europe/Warsaw"),("759412", "Siedlce", "Седльце", "PL", "616", "", "78", "1464", "146401", "52.16772", "22.29006", "Europe/Warsaw"),("759503", "Sejny", "", "PL", "616", "", "81", "2009", "200901", "54.10802", "23.34698", "Europe/Warsaw"),("759504", "Sędziszów Małopolski", "", "PL", "616", "PL", "80", "1815", "181504", "50.07069", "21.70062", "Europe/Warsaw"),("759507", "Sędziszów", "", "PL", "616", "", "84", "2602", "260206", "50.5659", "20.05563", "Europe/Warsaw"),("759591", "Sanok", "Санок", "PL", "616", "", "80", "1817", "181701", "49.55573", "22.2056", "Europe/Warsaw"),("759603", "Sandomierz", "Сандомир", "PL", "616", "", "84", "2609", "260901", "50.68265", "21.74898", "Europe/Warsaw"),("759734", "Rzeszów", "Жешув", "PL", "616", "", "80", "1863", "186301", "50.04132", "21.99901", "Europe/Warsaw"),("759852", "Ryki", "", "PL", "616", "", "75", "0616", "061604", "51.62574", "21.93274", "Europe/Warsaw"),("760055", "Rudnik nad Sanem", "", "PL", "616", "", "80", "1812", "181206", "50.44152", "22.24856", "Europe/Warsaw"),("760343", "Ropczyce", "Ропчице", "PL", "616", "", "80", "1815", "181503", "50.05229", "21.60891", "Europe/Warsaw"),("760488", "Reszel", "", "PL", "616", "PL", "85", "2808", "280805", "54.05042", "21.14585", "Europe/Warsaw"),("760503", "Rembertów", "", "PL", "616", "PL", "78", "1465", "146501", "52.26059", "21.16355", "Europe/Warsaw"),("760584", "Rawa Mazowiecka", "Рава-Мазовецкая", "PL", "616", "", "74", "1013", "101301", "51.76437", "20.25493", "Europe/Warsaw"),("760607", "Raszyn", "", "PL", "616", "PL", "78", "1421", "142106", "52.15603", "20.9226", "Europe/Warsaw"),("760632", "Rakszawa", "", "PL", "616", "", "80", "1810", "181006", "50.16051", "22.23907", "Europe/Warsaw"),("760680", "Radzyń Podlaski", "Радзынь-Подляский", "PL", "616", "", "75", "0615", "061501", "51.78333", "22.61667", "Europe/Warsaw"),("760684", "Radzymin", "", "PL", "616", "", "78", "1434", "143409", "52.41592", "21.18415", "Europe/Warsaw"),("760727", "Radymno", "", "PL", "616", "", "80", "1804", "180402", "49.9472", "22.82375", "Europe/Warsaw"),("760778", "Radom", "Радом", "PL", "616", "", "78", "1463", "146301", "51.40253", "21.14714", "Europe/Warsaw"),("760917", "Pułtusk", "Пултуск", "PL", "616", "", "78", "1424", "142404", "52.7025", "21.08276", "Europe/Warsaw"),("760924", "Puławy", "Пулавы", "PL", "616", "", "75", "0614", "061401", "51.41655", "21.96939", "Europe/Warsaw"),("761008", "Przysucha", "", "PL", "616", "", "78", "1423", "142306", "51.35858", "20.62889", "Europe/Warsaw"),("761131", "Przeworsk", "Пшеворск", "PL", "616", "", "80", "1814", "181401", "50.05912", "22.49408", "Europe/Warsaw"),("761168", "Przemyśl", "Перемышль", "PL", "616", "", "80", "1862", "186201", "49.78498", "22.76728", "Europe/Warsaw"),("761218", "Przasnysz", "Пшасныш", "PL", "616", "", "78", "1422", "142201", "53.01907", "20.88029", "Europe/Warsaw"),("761228", "Pruszków", "Прушкув", "PL", "616", "PL", "78", "1421", "142102", "52.17072", "20.81214", "Europe/Warsaw"),("761258", "Proszowice", "", "PL", "616", "", "77", "1214", "121405", "50.19275", "20.28909", "Europe/Warsaw"),("761546", "Poniatowa", "", "PL", "616", "", "75", "0612", "061206", "51.17983", "22.13093", "Europe/Warsaw"),("761652", "Połaniec", "", "PL", "616", "", "84", "2612", "261205", "50.43324", "21.2812", "Europe/Warsaw"),("762021", "Płońsk", "Плоньск", "PL", "616", "", "78", "1420", "142001", "52.62348", "20.37552", "Europe/Warsaw"),("762106", "Piwniczna-Zdrój", "", "PL", "616", "", "77", "1210", "121013", "49.44056", "20.71423", "Europe/Warsaw"),("762120", "Pisz", "Пиш", "PL", "616", "", "85", "2816", "281603", "53.62744", "21.81253", "Europe/Warsaw"),("762199", "Pionki", "Пёнки", "PL", "616", "", "78", "1425", "142501", "51.47604", "21.44995", "Europe/Warsaw"),("762201", "Pińczów", "", "PL", "616", "", "84", "2608", "260804", "50.52052", "20.52649", "Europe/Warsaw"),("762381", "Piastów", "", "PL", "616", "", "78", "1421", "142101", "52.18435", "20.83952", "Europe/Warsaw"),("762423", "Piaseczno", "Пясечно", "PL", "616", "", "78", "1418", "141804", "52.0814", "21.02397", "Europe/Warsaw"),("762643", "Parczew", "", "PL", "616", "", "75", "0613", "061304", "51.64021", "22.90057", "Europe/Warsaw"),("762769", "Ożarów Mazowiecki", "", "PL", "616", "", "78", "1432", "143206", "52.21039", "20.79716", "Europe/Warsaw"),("762788", "Otwock", "Отвоцк", "PL", "616", "PL", "78", "1417", "141702", "52.10577", "21.26129", "Europe/Warsaw"),("762850", "Ostrów Mazowiecka", "Острув-Мазовецка", "PL", "616", "", "78", "1416", "141601", "52.80245", "21.89507", "Europe/Warsaw"),("762863", "Ostrowiec Świętokrzyski", "Островец-Свентокшиский", "PL", "616", "", "84", "2607", "260701", "50.92936", "21.38525", "Europe/Warsaw"),("762909", "Ostrołęka", "Остроленка", "PL", "616", "", "78", "1461", "146101", "53.08621", "21.57566", "Europe/Warsaw"),("763028", "Orzysz", "", "PL", "616", "PL", "85", "2816", "281602", "53.80967", "21.94811", "Europe/Warsaw"),("763066", "Orneta", "", "PL", "616", "", "85", "2809", "280905", "54.11483", "20.13328", "Europe/Warsaw"),("763107", "Opole Lubelskie", "", "PL", "616", "", "75", "0612", "061205", "51.14775", "21.96897", "Europe/Warsaw"),("763111", "Opoczno", "Опочно", "PL", "616", "", "74", "1007", "100704", "51.37569", "20.27827", "Europe/Warsaw"),("763121", "Opatów", "", "PL", "616", "", "84", "2606", "260604", "50.80058", "21.42538", "Europe/Warsaw"),("763165", "Olsztynek", "", "PL", "616", "PL", "85", "2814", "281409", "53.58374", "20.28471", "Europe/Warsaw"),("763166", "Olsztyn", "Ольштын", "PL", "616", "", "85", "2862", "286201", "53.77995", "20.49416", "Europe/Warsaw"),("763260", "Oleszyce", "", "PL", "616", "", "80", "1809", "180906", "50.1675", "23.03481", "Europe/Warsaw"),("763291", "Olecko", "Олецко", "PL", "616", "", "85", "2813", "281304", "54.03374", "22.50704", "Europe/Warsaw"),("763442", "Ochota", "", "PL", "616", "", "78", "1465", "146501", "52.22096", "20.98526", "Europe/Warsaw"),("763523", "Nowy Targ", "Новы-Тарг", "PL", "616", "", "77", "1211", "121101", "49.47783", "20.03228", "Europe/Warsaw"),("763534", "Nowy Sącz", "Новы-Сонч", "PL", "616", "", "77", "1262", "126201", "49.62177", "20.69705", "Europe/Warsaw"),("763556", "Nowy Dwór Mazowiecki", "Новы-Двур-Мазовецки", "PL", "616", "", "78", "1414", "141401", "52.43022", "20.71652", "Europe/Warsaw"),("763765", "Nowa Sarzyna", "", "PL", "616", "PL", "80", "1808", "180805", "50.32086", "22.34456", "Europe/Warsaw"),("763783", "Nowa Dęba", "", "PL", "616", "", "80", "1820", "182004", "50.42974", "21.75078", "Europe/Warsaw"),("763829", "Nisko", "Ниско", "PL", "616", "", "80", "1812", "181205", "50.51987", "22.13968", "Europe/Warsaw"),("763903", "Niepołomice", "", "PL", "616", "", "77", "1219", "121904", "50.04066", "20.22257", "Europe/Warsaw"),("764039", "Nidzica", "", "PL", "616", "", "85", "2811", "281104", "53.36052", "20.42749", "Europe/Warsaw"),("764100", "Nasielsk", "", "PL", "616", "", "78", "1414", "141404", "52.58887", "20.80553", "Europe/Warsaw"),("764194", "Nadarzyn", "", "PL", "616", "", "78", "1421", "142105", "52.09438", "20.80776", "Europe/Warsaw"),("764241", "Muszyna", "", "PL", "616", "", "77", "1210", "121011", "49.35661", "20.89718", "Europe/Warsaw"),("764269", "Mszczonów", "", "PL", "616", "", "78", "1438", "143802", "51.97415", "20.52083", "Europe/Warsaw"),("764276", "Mszana Dolna", "", "PL", "616", "", "77", "1207", "120702", "49.67432", "20.07992", "Europe/Warsaw"),("764312", "Mrągowo", "Мронгово", "PL", "616", "", "85", "2810", "281001", "53.86437", "21.30507", "Europe/Warsaw"),("764421", "Mońki", "", "PL", "616", "", "81", "2008", "200806", "53.40496", "22.79791", "Europe/Warsaw"),("764484", "Mokotów", "", "PL", "616", "", "78", "1465", "146501", "52.1934", "21.03487", "Europe/Warsaw"),("764634", "Mława", "Млава", "PL", "616", "", "78", "1413", "141301", "53.11278", "20.3841", "Europe/Warsaw"),("764679", "Mińsk Mazowiecki", "Миньск-Мазовецки", "PL", "616", "", "78", "1412", "141201", "52.17935", "21.57251", "Europe/Warsaw"),("764749", "Milanówek", "Милянувек", "PL", "616", "", "78", "1405", "140501", "52.11879", "20.67155", "Europe/Warsaw"),("764849", "Mielec", "Мелец", "PL", "616", "", "80", "1811", "181101", "50.28709", "21.4239", "Europe/Warsaw"),("764862", "Międzyrzec Podlaski", "Мендзыжец-Подляский", "PL", "616", "", "75", "0601", "060110", "51.9864", "22.78248", "Europe/Warsaw"),("764917", "Miechów", "", "PL", "616", "", "77", "1208", "120805", "50.35648", "20.02788", "Europe/Warsaw"),("765191", "Marki", "Марки", "PL", "616", "", "78", "1434", "143402", "52.32065", "21.10474", "Europe/Warsaw"),("765328", "Małkinia Górna", "", "PL", "616", "PL", "78", "1416", "141605", "52.6922", "22.02836", "Europe/Warsaw"),("765430", "Maków Mazowiecki", "", "PL", "616", "", "78", "1411", "141101", "52.86493", "21.10053", "Europe/Warsaw"),("765749", "Łuków", "Лукув", "PL", "616", "", "75", "0611", "061101", "51.929", "22.37956", "Europe/Warsaw"),("765804", "Ludwin", "", "PL", "616", "", "75", "0610", "061002", "51.34605", "22.90581", "Europe/Warsaw"),("765876", "Lublin", "Люблин", "PL", "616", "", "75", "0663", "066301", "51.25", "22.56667", "Europe/Warsaw"),("765927", "Lubartów", "Любартув", "PL", "616", "", "75", "0608", "060801", "51.46026", "22.60952", "Europe/Warsaw"),("765932", "Lubaczów", "", "PL", "616", "", "80", "1809", "180901", "50.157", "23.12339", "Europe/Warsaw"),("765976", "Łosice", "", "PL", "616", "", "78", "1410", "141002", "52.21129", "22.71801", "Europe/Warsaw"),("766027", "Łomża", "Ломжа", "PL", "616", "", "81", "2062", "206201", "53.17806", "22.05935", "Europe/Warsaw"),("766042", "Łomianki", "Ломянки", "PL", "616", "", "78", "1432", "143205", "52.33413", "20.88602", "Europe/Warsaw"),("766073", "Łochów", "", "PL", "616", "", "78", "1433", "143305", "52.53076", "21.68158", "Europe/Warsaw"),("766137", "Lipsko", "", "PL", "616", "", "78", "1409", "140903", "51.15954", "21.64933", "Europe/Warsaw"),("766301", "Limanowa", "", "PL", "616", "", "77", "1207", "120701", "49.70594", "20.42204", "Europe/Warsaw"),("766307", "Lidzbark Warmiński", "Лидзбарк-Варминьски", "PL", "616", "", "85", "2809", "280901", "54.12588", "20.57954", "Europe/Warsaw"),("766332", "Leżajsk", "", "PL", "616", "", "80", "1808", "180801", "50.26257", "22.41932", "Europe/Warsaw"),("766369", "Lesznowola", "", "PL", "616", "", "78", "1418", "141803", "52.09095", "20.93479", "Europe/Warsaw"),("766452", "Lesko", "", "PL", "616", "PL", "80", "1821", "182103", "49.4701", "22.33042", "Europe/Warsaw"),("766555", "Legionowo", "Легионово", "PL", "616", "", "78", "1408", "140801", "52.40149", "20.92664", "Europe/Warsaw"),("766583", "Łęczna", "Ленчна", "PL", "616", "", "75", "0610", "061003", "51.30121", "22.88135", "Europe/Warsaw"),("766783", "Łapy", "Лапы", "PL", "616", "", "81", "2002", "200206", "52.9911", "22.88422", "Europe/Warsaw"),("766810", "Łańcut", "Ланьцут", "PL", "616", "", "80", "1810", "181001", "50.06871", "22.22912", "Europe/Warsaw"),("767374", "Krynica-Zdrój", "", "PL", "616", "", "77", "1210", "121007", "49.42225", "20.95942", "Europe/Warsaw"),("767470", "Krosno", "Кросно", "PL", "616", "", "80", "1861", "186101", "49.68866", "21.77058", "Europe/Warsaw"),("767605", "Krasnystaw", "Красныстав", "PL", "616", "", "75", "0606", "060601", "50.98464", "23.1742", "Europe/Warsaw"),("767623", "Kraśnik", "Красник", "PL", "616", "", "75", "0607", "060701", "50.9236", "22.22706", "Europe/Warsaw"),("767814", "Kozienice", "Козенице", "PL", "616", "", "78", "1407", "140705", "51.58294", "21.54779", "Europe/Warsaw"),("768136", "Korczyna", "", "PL", "616", "", "80", "1807", "180705", "49.71555", "21.80941", "Europe/Warsaw"),("768216", "Konstancin-Jeziorna", "Констанцин-Езерна", "PL", "616", "", "78", "1418", "141802", "52.0938", "21.11761", "Europe/Warsaw"),("768218", "Końskie", "Коньске", "PL", "616", "", "84", "2605", "260503", "51.19166", "20.40607", "Europe/Warsaw"),("768315", "Komorów", "", "PL", "616", "", "78", "1421", "142104", "52.1456", "20.81566", "Europe/Warsaw"),("768785", "Kolno", "", "PL", "616", "", "81", "2006", "200601", "53.41148", "21.92905", "Europe/Warsaw"),("768805", "Kolbuszowa", "", "PL", "616", "", "80", "1806", "180602", "50.2441", "21.7761", "Europe/Warsaw"),("768905", "Kobyłka", "", "PL", "616", "", "78", "1434", "143401", "52.33953", "21.19589", "Europe/Warsaw"),("769250", "Kielce", "Кельце", "PL", "616", "", "84", "2661", "266101", "50.87033", "20.62752", "Europe/Warsaw"),("769274", "Kętrzyn", "Кентшин", "PL", "616", "", "85", "2808", "280801", "54.07676", "21.37527", "Europe/Warsaw"),("769346", "Kazimierza Wielka", "", "PL", "616", "", "84", "2603", "260303", "50.26564", "20.49358", "Europe/Warsaw"),("769539", "Karczew", "", "PL", "616", "", "78", "1417", "141704", "52.07655", "21.24962", "Europe/Warsaw"),("769893", "Kabaty", "", "PL", "616", "", "78", "1465", "146501", "52.13012", "21.08148", "Europe/Warsaw"),("769981", "Józefów", "Юзефув", "PL", "616", "", "78", "1417", "141701", "52.13707", "21.23589", "Europe/Warsaw"),("770045", "Jeżowe", "", "PL", "616", "", "80", "1812", "181203", "50.37486", "22.12749", "Europe/Warsaw"),("770157", "Jędrzejów", "", "PL", "616", "", "84", "2602", "260202", "50.63945", "20.30454", "Europe/Warsaw"),("770169", "Jedlicze", "", "PL", "616", "", "80", "1807", "180704", "49.71749", "21.64886", "Europe/Warsaw"),("770293", "Jasło", "Ясло", "PL", "616", "", "80", "1805", "180501", "49.74506", "21.47252", "Europe/Warsaw"),("770380", "Jarosław", "Ярослав", "PL", "616", "", "80", "1804", "180401", "50.01623", "22.67776", "Europe/Warsaw"),("770425", "Janów Lubelski", "", "PL", "616", "", "75", "0605", "060505", "50.70695", "22.41039", "Europe/Warsaw"),("770706", "Jabłonna", "", "PL", "616", "", "78", "1408", "140802", "52.37885", "20.91745", "Europe/Warsaw"),("770792", "Iłża", "", "PL", "616", "", "78", "1425", "142503", "51.16313", "21.23979", "Europe/Warsaw"),("770966", "Hrubieszów", "Грубешов", "PL", "616", "", "75", "0604", "060401", "50.80502", "23.89251", "Europe/Warsaw"),("771158", "Hajnówka", "Хайнувка", "PL", "616", "", "81", "2005", "200506", "52.74328", "23.58122", "Europe/Warsaw"),("771313", "Grybów", "", "PL", "616", "", "77", "1210", "121001", "49.62439", "20.94797", "Europe/Warsaw"),("771348", "Grudki", "", "PL", "616", "", "81", "2002", "200204", "53.09488", "23.66848", "Europe/Warsaw"),("771384", "Grójec", "", "PL", "616", "", "78", "1406", "140605", "51.86252", "20.86757", "Europe/Warsaw"),("771401", "Grodzisk Mazowiecki", "Гродзиск-Мазовецки", "PL", "616", "", "78", "1405", "140504", "52.10387", "20.6337", "Europe/Warsaw"),("771506", "Grajewo", "Граево", "PL", "616", "", "81", "2004", "200401", "53.64728", "22.45537", "Europe/Warsaw"),("771729", "Gorzyce", "", "PL", "616", "", "80", "1820", "182002", "50.6672", "21.84013", "Europe/Warsaw"),("771804", "Gorlice", "Горлице", "PL", "616", "", "77", "1205", "120501", "49.65563", "21.16035", "Europe/Warsaw"),("771870", "Góra Kalwaria", "", "PL", "616", "", "78", "1418", "141801", "51.97653", "21.21537", "Europe/Warsaw"),("771953", "Gołdap", "", "PL", "616", "", "85", "2818", "281803", "54.30631", "22.30362", "Europe/Warsaw"),("772086", "Głogów Małopolski", "", "PL", "616", "PL", "80", "1816", "181606", "50.15122", "21.96287", "Europe/Warsaw"),("772195", "Giżycko", "Гижицко", "PL", "616", "", "85", "2806", "280604", "54.03811", "21.76441", "Europe/Warsaw"),("772227", "Gierłoż", "", "PL", "616", "", "85", "2808", "280803", "54.08134", "21.49551", "Europe/Warsaw"),("772339", "Garwolin", "Гарволин", "PL", "616", "", "78", "1403", "140301", "51.89747", "21.61466", "Europe/Warsaw"),("772621", "Ełk", "Элк", "PL", "616", "", "85", "2805", "280501", "53.82824", "22.36469", "Europe/Warsaw"),("772748", "Działdowo", "Дзялдово", "PL", "616", "", "85", "2803", "280302", "53.23958", "20.17004", "Europe/Warsaw"),("772772", "Dynów", "", "PL", "616", "", "80", "1816", "181601", "49.81506", "22.23388", "Europe/Warsaw"),("773148", "Dobre Miasto", "", "PL", "616", "", "85", "2814", "281403", "53.98668", "20.39749", "Europe/Warsaw"),("773176", "Dobczyce", "", "PL", "616", "", "77", "1209", "120901", "49.88109", "20.08936", "Europe/Warsaw"),("773357", "Dęblin", "Демблин", "PL", "616", "", "75", "0616", "061601", "51.55912", "21.84829", "Europe/Warsaw"),("773380", "Dębica", "Дембица", "PL", "616", "", "80", "1803", "180301", "50.05146", "21.41141", "Europe/Warsaw"),("773569", "Dąbrowa Tarnowska", "", "PL", "616", "", "77", "1204", "120402", "50.17462", "20.98633", "Europe/Warsaw"),("773593", "Dąbrowa Białostocka", "", "PL", "616", "PL", "81", "2011", "201101", "53.65364", "23.34792", "Europe/Warsaw"),("773941", "Czarna Białostocka", "", "PL", "616", "", "81", "2002", "200202", "53.30509", "23.28146", "Europe/Warsaw"),("774208", "Ciechanów", "Цеханув", "PL", "616", "", "78", "1402", "140201", "52.88141", "20.61996", "Europe/Warsaw"),("774393", "Choroszcz", "", "PL", "616", "", "81", "2002", "200201", "53.14332", "22.98889", "Europe/Warsaw"),("774558", "Chełm", "Хелм", "PL", "616", "", "75", "0662", "066201", "51.14312", "23.4716", "Europe/Warsaw"),("774730", "Bychawa", "", "PL", "616", "", "75", "0609", "060903", "51.01608", "22.53296", "Europe/Warsaw"),("774747", "Busko-Zdrój", "Буско-Здруй", "PL", "616", "", "84", "2601", "260101", "50.47078", "20.71884", "Europe/Warsaw"),("775086", "Brzozów", "", "PL", "616", "", "80", "1802", "180201", "49.69501", "22.01926", "Europe/Warsaw"),("775183", "Brzesko", "", "PL", "616", "", "77", "1202", "120202", "49.96911", "20.60606", "Europe/Warsaw"),("775224", "Brwinów", "", "PL", "616", "", "78", "1421", "142103", "52.14269", "20.71697", "Europe/Warsaw"),("775717", "Boguchwała", "", "PL", "616", "", "80", "1816", "181603", "49.98473", "21.94528", "Europe/Warsaw"),("775758", "Bochnia", "Бохня", "PL", "616", "", "77", "1201", "120101", "49.96905", "20.43028", "Europe/Warsaw"),("775820", "Błonie", "", "PL", "616", "", "78", "1432", "143201", "52.19849", "20.61709", "Europe/Warsaw"),("775890", "Biskupiec", "", "PL", "616", "", "85", "2814", "281402", "53.86467", "20.95692", "Europe/Warsaw"),("775922", "Biłgoraj", "Билгорай", "PL", "616", "", "75", "0602", "060201", "50.54114", "22.72204", "Europe/Warsaw"),("775986", "Bielsk Podlaski", "Бельск-Подляски", "PL", "616", "PL", "81", "2003", "200301", "52.76512", "23.18647", "Europe/Warsaw"),("776029", "Bielany", "", "PL", "616", "", "78", "1465", "146501", "52.29242", "20.93531", "Europe/Warsaw"),("776069", "Białystok", "Белосток", "PL", "616", "", "81", "2061", "206101", "53.13333", "23.16433", "Europe/Warsaw"),("776103", "Białołeka", "", "PL", "616", "", "78", "1465", "146501", "52.32127", "20.97204", "Europe/Warsaw"),("776114", "Białobrzegi", "", "PL", "616", "", "78", "1401", "140101", "51.64695", "20.95041", "Europe/Warsaw"),("776175", "Biała Podlaska", "Бяла-Подляска", "PL", "616", "", "75", "0661", "066101", "52.03238", "23.11652", "Europe/Warsaw"),("776251", "Bemowo", "", "PL", "616", "PL", "78", "1465", "146501", "52.2546", "20.90844", "Europe/Warsaw"),("776252", "Bełżyce", "", "PL", "616", "", "75", "0609", "060901", "51.17415", "22.28027", "Europe/Warsaw"),("776337", "Bartoszyce", "Бартошице", "PL", "616", "", "85", "2801", "280101", "54.25354", "20.80819", "Europe/Warsaw"),("776384", "Barczewo", "", "PL", "616", "PL", "85", "2814", "281401", "53.83055", "20.69112", "Europe/Warsaw"),("776597", "Augustów", "Августов", "PL", "616", "", "81", "2001", "200102", "53.84321", "22.97979", "Europe/Warsaw"),("3079855", "Żywiec", "Живец", "PL", "616", "PL", "83", "2417", "241701", "49.68529", "19.19243", "Europe/Warsaw"),("3079897", "Żychlin", "", "PL", "616", "", "74", "1002", "100211", "52.24404", "19.62613", "Europe/Warsaw"),("3079942", "Żuromin", "", "PL", "616", "PL", "78", "1437", "143706", "53.06611", "19.90894", "Europe/Warsaw"),("3079969", "Żukowo", "", "PL", "616", "", "82", "2205", "220508", "54.3422", "18.36476", "Europe/Warsaw"),("3080004", "Żory", "Жоры", "PL", "616", "", "83", "2479", "247901", "50.04523", "18.70062", "Europe/Warsaw"),("3080047", "Żnin", "", "PL", "616", "", "73", "0419", "041906", "52.84958", "17.71992", "Europe/Warsaw"),("3080058", "Żmigród", "", "PL", "616", "PL", "72", "0220", "022006", "51.46672", "16.90564", "Europe/Warsaw"),("3080071", "Złotów", "Злотув", "PL", "616", "", "86", "3031", "303108", "53.36346", "17.04082", "Europe/Warsaw"),("3080074", "Złotoryja", "Злоторыя", "PL", "616", "", "72", "0226", "022602", "51.12637", "15.91979", "Europe/Warsaw"),("3080102", "Złocieniec", "", "PL", "616", "", "87", "3203", "320306", "53.53286", "16.01132", "Europe/Warsaw"),("3080165", "Zielona Góra", "Зелёна-Гура", "PL", "616", "", "76", "0862", "086201", "51.93548", "15.50643", "Europe/Warsaw"),("3080226", "Ziębice", "", "PL", "616", "", "72", "0224", "022406", "50.60122", "17.04065", "Europe/Warsaw"),("3080231", "Zgorzelec", "Згожелец", "PL", "616", "", "72", "0225", "022502", "51.14942", "15.00835", "Europe/Warsaw"),("3080251", "Zgierz", "Згеж", "PL", "616", "", "74", "1020", "102003", "51.85561", "19.40623", "Europe/Warsaw"),("3080295", "Zelów", "", "PL", "616", "", "74", "1001", "100108", "51.46452", "19.21972", "Europe/Warsaw"),("3080369", "Zebrzydowice", "", "PL", "616", "", "83", "2403", "240312", "49.87793", "18.61127", "Europe/Warsaw"),("3080389", "Zdzieszowice", "", "PL", "616", "", "79", "1605", "160505", "50.42482", "18.12349", "Europe/Warsaw"),("3080414", "Zduńska Wola", "Здуньская-Воля", "PL", "616", "", "74", "1019", "101901", "51.59915", "18.93974", "Europe/Warsaw"),("3080494", "Zbąszynek", "", "PL", "616", "PL", "76", "0808", "080806", "52.24315", "15.81654", "Europe/Warsaw"),("3080495", "Zbąszyń", "", "PL", "616", "", "86", "3015", "301506", "52.2509", "15.9252", "Europe/Warsaw"),("3080508", "Zawoja", "", "PL", "616", "", "77", "1215", "121508", "49.64396", "19.54227", "Europe/Warsaw"),("3080526", "Zawiercie", "Заверце", "PL", "616", "", "83", "2416", "241602", "50.48766", "19.41679", "Europe/Warsaw"),("3080538", "Zawadzkie", "", "PL", "616", "", "79", "1611", "161107", "50.60503", "18.48467", "Europe/Warsaw"),("3080644", "Żary", "Жара", "PL", "616", "", "76", "0811", "081102", "51.64205", "15.13727", "Europe/Warsaw"),("3080652", "Żarów", "", "PL", "616", "PL", "72", "0219", "021908", "50.94116", "16.49466", "Europe/Warsaw"),("3080866", "Zakopane", "Закопане", "PL", "616", "", "77", "1217", "121701", "49.29899", "19.94885", "Europe/Warsaw"),("3080944", "Żagań", "Жагань", "PL", "616", "", "76", "0810", "081002", "51.61759", "15.31486", "Europe/Warsaw"),("3080985", "Zabrze", "Забже", "PL", "616", "", "83", "2478", "247801", "50.32492", "18.78576", "Europe/Warsaw"),("3081046", "Ząbkowice Śląskie", "Зомбковице-Слёнске", "PL", "616", "", "72", "0224", "022405", "50.58969", "16.81239", "Europe/Warsaw"),("3081158", "Wyrzysk", "", "PL", "616", "PL", "86", "3019", "301908", "53.153", "17.26802", "Europe/Warsaw"),("3081300", "Wschowa", "", "PL", "616", "", "76", "0812", "081203", "51.80705", "16.31663", "Europe/Warsaw"),("3081324", "Września", "Вжесня", "PL", "616", "", "86", "3030", "303005", "52.32512", "17.56519", "Europe/Warsaw"),("3081350", "Wronki", "", "PL", "616", "", "86", "3024", "302408", "52.71051", "16.38044", "Europe/Warsaw"),("3081368", "Wrocław", "Вроцлав", "PL", "616", "", "72", "0264", "026401", "51.1", "17.03333", "Europe/Warsaw"),("3081419", "Wolsztyn", "", "PL", "616", "", "86", "3029", "302903", "52.11552", "16.11712", "Europe/Warsaw"),("3081430", "Wołów", "", "PL", "616", "", "72", "0222", "022203", "51.33656", "16.64429", "Europe/Warsaw"),("3081471", "Wolin", "", "PL", "616", "PL", "87", "3207", "320706", "53.84214", "14.61465", "Europe/Warsaw"),("3081488", "Wołczyn", "", "PL", "616", "PL", "79", "1604", "160404", "51.01845", "18.04994", "Europe/Warsaw"),("3081495", "Wolbrom", "", "PL", "616", "", "77", "1212", "121207", "50.37957", "19.75831", "Europe/Warsaw"),("3081604", "Wola", "", "PL", "616", "", "83", "2410", "241003", "50.01745", "19.12333", "Europe/Warsaw"),("3081636", "Wojkowice", "", "PL", "616", "PL", "83", "2401", "240103", "50.36509", "19.03652", "Europe/Warsaw"),("3081677", "Wodzisław Śląski", "Водзислав-Слёнски", "PL", "616", "", "83", "2415", "241504", "50.00377", "18.47205", "Europe/Warsaw"),("3081699", "Włoszczowa", "", "PL", "616", "", "84", "2613", "261306", "50.85256", "19.96593", "Europe/Warsaw"),("3081741", "Włocławek", "Влоцлавек", "PL", "616", "", "73", "0464", "046401", "52.64817", "19.0678", "Europe/Warsaw"),("3081752", "Władysławowo", "", "PL", "616", "", "82", "2211", "221104", "54.79086", "18.4009", "Europe/Warsaw"),("3081818", "Witnica", "", "PL", "616", "", "76", "0801", "080107", "52.67318", "14.89765", "Europe/Warsaw"),("3081826", "Witkowo", "", "PL", "616", "", "86", "3003", "300310", "52.43964", "17.77264", "Europe/Warsaw"),("3081874", "Wisła", "", "PL", "616", "", "83", "2403", "240303", "49.65629", "18.8591", "Europe/Warsaw"),("3081942", "Wilkowice", "", "PL", "616", "", "83", "2402", "240210", "49.76282", "19.08973", "Europe/Warsaw"),("3082176", "Wieruszów", "", "PL", "616", "", "74", "1018", "101807", "51.29488", "18.15547", "Europe/Warsaw"),("3082192", "Wieprz", "", "PL", "616", "", "77", "1218", "121810", "49.89093", "19.35688", "Europe/Warsaw"),("3082197", "Wieluń", "Велюнь", "PL", "616", "", "74", "1017", "101709", "51.22097", "18.56964", "Europe/Warsaw"),("3082319", "Wieleń", "", "PL", "616", "PL", "86", "3002", "300208", "52.89461", "16.17136", "Europe/Warsaw"),("3082364", "Więcbork", "", "PL", "616", "PL", "73", "0413", "041304", "53.35384", "17.49064", "Europe/Warsaw"),("3082473", "Wejherowo", "Вейхерово", "PL", "616", "", "82", "2215", "221503", "54.60568", "18.23559", "Europe/Warsaw"),("3082704", "Wałcz", "Валч", "PL", "616", "", "87", "3217", "321701", "53.27787", "16.47122", "Europe/Warsaw"),("3082707", "Wałbrzych", "Валбжих", "PL", "616", "", "72", "0221", "022109", "50.77141", "16.28432", "Europe/Warsaw"),("3082712", "Wągrowiec", "Вонгровец", "PL", "616", "", "86", "3028", "302801", "52.80842", "17.19961", "Europe/Warsaw"),("3082722", "Wadowice", "Вадовице", "PL", "616", "", "77", "1218", "121809", "49.88335", "19.49292", "Europe/Warsaw"),("3082734", "Wąbrzeźno", "", "PL", "616", "", "73", "0417", "041701", "53.27989", "18.94773", "Europe/Warsaw"),("3082751", "Ustroń", "Устронь", "PL", "616", "", "83", "2403", "240302", "49.72153", "18.80198", "Europe/Warsaw"),("3082756", "Ustka", "Устка", "PL", "616", "", "82", "2212", "221201", "54.58048", "16.86194", "Europe/Warsaw"),("3082914", "Tychy", "Тыхы", "PL", "616", "", "83", "2477", "247701", "50.13717", "18.96641", "Europe/Warsaw"),("3082938", "Twardogóra", "", "PL", "616", "PL", "72", "0214", "021408", "51.36487", "17.46878", "Europe/Warsaw"),("3082945", "Tuszyn", "", "PL", "616", "", "74", "1006", "100611", "51.60949", "19.53009", "Europe/Warsaw"),("3082998", "Turek", "Турек", "PL", "616", "", "86", "3027", "302701", "52.01548", "18.50055", "Europe/Warsaw"),("3083043", "Tuchola", "", "PL", "616", "", "73", "0416", "041606", "53.58792", "17.85905", "Europe/Warsaw"),("3083077", "Trzemeszno", "", "PL", "616", "", "86", "3003", "300309", "52.56139", "17.82311", "Europe/Warsaw"),("3083103", "Trzebnica", "", "PL", "616", "", "72", "0220", "022003", "51.31076", "17.06331", "Europe/Warsaw"),("3083111", "Trzebinia", "Тшебиня", "PL", "616", "", "77", "1203", "120305", "50.15931", "19.46966", "Europe/Warsaw"),("3083145", "Trzebiatów", "", "PL", "616", "", "87", "3205", "320508", "54.06147", "15.26475", "Europe/Warsaw"),("3083185", "Trzcianka", "Тшчанка", "PL", "616", "", "86", "3002", "300207", "53.04063", "16.45629", "Europe/Warsaw"),("3083271", "Toruń", "Торунь", "PL", "616", "", "73", "0463", "046301", "53.01375", "18.59814", "Europe/Warsaw"),("3083426", "Tczew", "Тчев", "PL", "616", "", "82", "2214", "221401", "54.09242", "18.77787", "Europe/Warsaw"),("3083440", "Tarnowskie Góry", "Тарновске-Гуры", "PL", "616", "", "83", "2413", "241304", "50.44548", "18.86147", "Europe/Warsaw"),("3083611", "Szubin", "", "PL", "616", "", "73", "0410", "041005", "53.00967", "17.74", "Europe/Warsaw"),("3083616", "Sztum", "", "PL", "616", "", "82", "2216", "221605", "53.92077", "19.03072", "Europe/Warsaw"),("3083632", "Szprotawa", "", "PL", "616", "", "76", "0810", "081007", "51.56563", "15.53664", "Europe/Warsaw"),("3083677", "Szklarska Poręba", "", "PL", "616", "PL", "72", "0206", "020604", "50.82567", "15.52274", "Europe/Warsaw"),("3083749", "Szczytna", "", "PL", "616", "", "72", "0208", "020814", "50.41343", "16.44743", "Europe/Warsaw"),("3083752", "Szczyrk", "", "PL", "616", "", "83", "2402", "240201", "49.71724", "19.03183", "Europe/Warsaw"),("3083826", "Szczecinek", "Щецинек", "PL", "616", "", "87", "3215", "321501", "53.70791", "16.69937", "Europe/Warsaw"),("3083829", "Szczecin", "Щецин", "PL", "616", "PL", "87", "3262", "326201", "53.42894", "14.55302", "Europe/Warsaw"),("3083835", "Szczawno-Zdrój", "", "PL", "616", "PL", "72", "0221", "022103", "50.80352", "16.25655", "Europe/Warsaw"),("3083878", "Szamotuły", "Шамотулы", "PL", "616", "", "86", "3024", "302407", "52.61201", "16.57794", "Europe/Warsaw"),("3083921", "Syców", "", "PL", "616", "", "72", "0214", "021407", "51.30814", "17.71979", "Europe/Warsaw"),("3083955", "Świnoujście", "Свиноуйсьце", "PL", "616", "", "87", "3263", "326301", "53.91053", "14.24712", "Europe/Warsaw"),("3083988", "Świętochłowice", "Свентохловице", "PL", "616", "", "83", "2476", "247601", "50.29636", "18.91726", "Europe/Warsaw"),("3084062", "Świebodzin", "Свебодзин", "PL", "616", "PL", "76", "0808", "080805", "52.24751", "15.53355", "Europe/Warsaw"),("3084074", "Świecie", "", "PL", "616", "", "73", "0414", "041409", "53.40953", "18.44742", "Europe/Warsaw"),("3084084", "Świebodzice", "Свебодзице", "PL", "616", "", "72", "0219", "021902", "50.85975", "16.3282", "Europe/Warsaw"),("3084085", "Świdwin", "Свидвин", "PL", "616", "", "87", "3216", "321601", "53.77464", "15.77671", "Europe/Warsaw"),("3084093", "Świdnica", "Свидница", "PL", "616", "", "72", "0219", "021901", "50.84378", "16.48859", "Europe/Warsaw"),("3084130", "Swarzędz", "Сважендз", "PL", "616", "", "86", "3021", "302116", "52.41289", "17.08503", "Europe/Warsaw"),("3084143", "Susz", "", "PL", "616", "PL", "85", "2807", "280706", "53.71743", "19.33645", "Europe/Warsaw"),("3084194", "Sułkowice", "", "PL", "616", "", "77", "1209", "120907", "49.84053", "19.80097", "Europe/Warsaw"),("3084230", "Sulejów", "", "PL", "616", "", "74", "1010", "101009", "51.35436", "19.88538", "Europe/Warsaw"),("3084237", "Sulęcin", "", "PL", "616", "", "77", "", "", "52.44429", "15.11676", "Europe/Warsaw"),("3084241", "Sulechów", "Сулехув", "PL", "616", "", "76", "0809", "080906", "52.08362", "15.62513", "Europe/Warsaw"),("3084300", "Sucha Beskidzka", "", "PL", "616", "", "77", "1215", "121502", "49.74188", "19.59429", "Europe/Warsaw"),("3084396", "Strzelno", "", "PL", "616", "PL", "73", "0409", "040904", "52.62789", "18.17246", "Europe/Warsaw"),("3084404", "Strzelin", "", "PL", "616", "", "72", "0217", "021704", "50.78157", "17.06477", "Europe/Warsaw"),("3084415", "Strzelce Opolskie", "Стшельце-Опольске", "PL", "616", "", "79", "1611", "161105", "50.5107", "18.30056", "Europe/Warsaw"),("3084421", "Strzelce Krajeńskie", "", "PL", "616", "", "76", "0806", "080604", "52.87726", "15.52978", "Europe/Warsaw"),("3084440", "Strzegom", "Стшегом", "PL", "616", "", "72", "0219", "021906", "50.96264", "16.35006", "Europe/Warsaw"),("3084449", "Strzałkowo", "", "PL", "616", "", "86", "3023", "302307", "52.30701", "17.81811", "Europe/Warsaw"),("3084460", "Stryszawa", "", "PL", "616", "", "77", "1215", "121507", "49.71327", "19.52185", "Europe/Warsaw"),("3084515", "Stronie Śląskie", "", "PL", "616", "PL", "72", "0208", "020813", "50.29554", "16.87397", "Europe/Warsaw"),("3084647", "Stęszew", "", "PL", "616", "", "86", "3021", "302114", "52.2837", "16.70085", "Europe/Warsaw"),("3084826", "Starogard Gdański", "Старогард-Гданьски", "PL", "616", "", "82", "2213", "221303", "53.96396", "18.52638", "Europe/Warsaw"),("3084840", "Stargard Szczeciński", "Старгард-Щециньски", "PL", "616", "", "87", "3214", "321401", "53.33672", "15.0499", "Europe/Warsaw"),("3085045", "Środa Wielkopolska", "Сьрода-Велькопольска", "PL", "616", "", "86", "3025", "302504", "52.22843", "17.27617", "Europe/Warsaw"),("3085047", "Środa Śląska", "", "PL", "616", "PL", "72", "0218", "021804", "51.16406", "16.59508", "Europe/Warsaw"),("3085056", "Śrem", "Срем", "PL", "616", "", "86", "3026", "302604", "52.08868", "17.01508", "Europe/Warsaw"),("3085128", "Sosnowiec", "Сосновец", "PL", "616", "", "83", "2475", "247501", "50.28682", "19.10385", "Europe/Warsaw"),("3085151", "Sopot", "Сопот", "PL", "616", "", "82", "2264", "226401", "54.4418", "18.56003", "Europe/Warsaw"),("3085172", "Solec Kujawski", "Солец-Куявски", "PL", "616", "", "73", "0403", "040308", "53.08371", "18.22572", "Europe/Warsaw"),("3085252", "Sobótka", "", "PL", "616", "PL", "72", "0223", "022307", "50.89992", "16.74441", "Europe/Warsaw"),("3085391", "Śmigiel", "", "PL", "616", "", "86", "3011", "301105", "52.01339", "16.52704", "Europe/Warsaw"),("3085450", "Słupsk", "Слупск", "PL", "616", "", "82", "2263", "226301", "54.46405", "17.02872", "Europe/Warsaw"),("3085481", "Słupca", "", "PL", "616", "", "86", "3023", "302301", "52.28733", "17.87192", "Europe/Warsaw"),("3085495", "Słubice", "Слубице", "PL", "616", "", "76", "0805", "080505", "52.35088", "14.56065", "Europe/Warsaw"),("3085610", "Sławno", "", "PL", "616", "", "87", "3213", "321302", "54.36276", "16.67888", "Europe/Warsaw"),("3085616", "Sławków", "", "PL", "616", "", "83", "2401", "240108", "50.29943", "19.38967", "Europe/Warsaw"),("3085656", "Skwierzyna", "", "PL", "616", "", "76", "0803", "080305", "52.59914", "15.50652", "Europe/Warsaw"),("3085786", "Skoczów", "", "PL", "616", "", "83", "2403", "240310", "49.80089", "18.7877", "Europe/Warsaw"),("3085807", "Skawina", "Скавина", "PL", "616", "", "77", "1206", "120611", "49.97524", "19.82869", "Europe/Warsaw"),("3085826", "Skarszewy", "", "PL", "616", "", "82", "2213", "221309", "54.06911", "18.44416", "Europe/Warsaw"),("3085925", "Siewierz", "", "PL", "616", "", "83", "2401", "240107", "50.46657", "19.23028", "Europe/Warsaw"),("3085941", "Sierpc", "Серпц", "PL", "616", "", "78", "1427", "142701", "52.8568", "19.66913", "Europe/Warsaw"),("3085970", "Sierakowice", "", "PL", "616", "", "82", "2205", "220504", "54.3461", "17.89252", "Europe/Warsaw"),("3085974", "Sieraków", "", "PL", "616", "", "86", "3014", "301404", "52.65134", "16.08047", "Europe/Warsaw"),("3085978", "Sieradz", "Серадз", "PL", "616", "", "74", "1014", "101401", "51.59584", "18.73023", "Europe/Warsaw"),("3086024", "Siemianowice Śląskie", "Семяновице-Слёнске", "PL", "616", "", "83", "2474", "247401", "50.32738", "19.02901", "Europe/Warsaw"),("3086134", "Sianów", "", "PL", "616", "PL", "87", "3209", "320907", "54.22646", "16.29127", "Europe/Warsaw"),("3086153", "Sępólno Krajeńskie", "", "PL", "616", "", "73", "0413", "041302", "53.45198", "17.53169", "Europe/Warsaw"),("3086206", "Ścinawa", "", "PL", "616", "PL", "72", "0211", "021104", "51.41626", "16.4251", "Europe/Warsaw"),("3086435", "Rzepin", "", "PL", "616", "PL", "76", "0805", "080504", "52.3464", "14.83227", "Europe/Warsaw"),("3086511", "Rypin", "Рыпин", "PL", "616", "", "73", "0412", "041201", "53.06603", "19.40941", "Europe/Warsaw"),("3086531", "Rydułtowy", "Рыдултовы", "PL", "616", "", "83", "2415", "241503", "50.05857", "18.41703", "Europe/Warsaw"),("3086586", "Rybnik", "Рыбник", "PL", "616", "", "83", "2473", "247301", "50.09713", "18.54179", "Europe/Warsaw"),("3086706", "Rumia", "Румя", "PL", "616", "", "82", "2215", "221502", "54.57092", "18.38802", "Europe/Warsaw"),("3086800", "Ruda Śląska", "Руда-Сленска", "PL", "616", "", "83", "2472", "247201", "50.2584", "18.85632", "Europe/Warsaw"),("3087072", "Rogoźno", "", "PL", "616", "", "86", "3016", "301602", "52.75226", "16.99049", "Europe/Warsaw"),("3087281", "Reda", "Реда", "PL", "616", "", "82", "2215", "221501", "54.60528", "18.34717", "Europe/Warsaw"),("3087307", "Rawicz", "Равич", "PL", "616", "", "86", "3022", "302205", "51.60946", "16.85852", "Europe/Warsaw"),("3087418", "Radzionków", "", "PL", "616", "", "83", "2413", "241303", "50.40026", "18.90232", "Europe/Warsaw"),("3087427", "Radziejów", "", "PL", "616", "", "73", "0411", "041101", "52.62481", "18.52771", "Europe/Warsaw"),("3087497", "Radomsko", "Радомско", "PL", "616", "", "74", "1012", "101201", "51.06713", "19.44477", "Europe/Warsaw"),("3087529", "Radlin", "", "PL", "616", "", "83", "2415", "241502", "50.0502", "18.47626", "Europe/Warsaw"),("3087584", "Racibórz", "Ратибор", "PL", "616", "", "83", "2411", "241101", "50.09195", "18.21928", "Europe/Warsaw"),("3087601", "Rabka-Zdrój", "", "PL", "616", "", "77", "1211", "121112", "49.60889", "19.96654", "Europe/Warsaw"),("3087628", "Pyskowice", "Пысковице", "PL", "616", "", "83", "2405", "240502", "50.4", "18.63333", "Europe/Warsaw"),("3087630", "Pyrzyce", "", "PL", "616", "", "87", "3212", "321205", "53.1462", "14.89257", "Europe/Warsaw"),("3087640", "Puszczykowo", "", "PL", "616", "", "86", "3021", "302102", "52.2857", "16.84925", "Europe/Warsaw"),("3087691", "Puck", "", "PL", "616", "", "82", "2211", "221103", "54.7179", "18.40841", "Europe/Warsaw"),("3087701", "Pszów", "", "PL", "616", "", "83", "2415", "241501", "50.03994", "18.39472", "Europe/Warsaw"),("3087705", "Pszczyna", "Пщина", "PL", "616", "", "83", "2410", "241005", "49.98037", "18.95382", "Europe/Warsaw"),("3087954", "Przemków", "", "PL", "616", "PL", "72", "0216", "021605", "51.5253", "15.79441", "Europe/Warsaw"),("3088034", "Pruszcz Gdański", "Прущ-Гданьский", "PL", "616", "", "82", "2204", "220401", "54.26217", "18.63625", "Europe/Warsaw"),("3088065", "Prudnik", "Прудник", "PL", "616", "", "79", "1610", "161004", "50.32124", "17.57461", "Europe/Warsaw"),("3088135", "Praszka", "", "PL", "616", "", "79", "1608", "160804", "51.05375", "18.45317", "Europe/Warsaw"),("3088161", "Prabuty", "", "PL", "616", "", "82", "2207", "220704", "53.755", "19.20547", "Europe/Warsaw"),("3088171", "Poznań", "Познань", "PL", "616", "", "86", "3064", "306401", "52.40692", "16.92993", "Europe/Warsaw"),("3088273", "Poręba", "", "PL", "616", "", "83", "2416", "241601", "50.48831", "19.33903", "Europe/Warsaw"),("3088435", "Polkowice", "Польковице", "PL", "616", "", "72", "0216", "021604", "51.50391", "16.07261", "Europe/Warsaw"),("3088461", "Police", "Полиция", "PL", "616", "", "87", "3211", "321104", "53.55214", "14.57182", "Europe/Warsaw"),("3088477", "Połczyn-Zdrój", "", "PL", "616", "", "87", "3216", "321603", "53.76424", "16.09574", "Europe/Warsaw"),("3088496", "Polanica-Zdrój", "", "PL", "616", "", "72", "0208", "020805", "50.40373", "16.51271", "Europe/Warsaw"),("3088710", "Poddębice", "", "PL", "616", "", "74", "1011", "101103", "51.89344", "18.9573", "Europe/Warsaw"),("3088749", "Pobiedziska", "", "PL", "616", "", "86", "3021", "302112", "52.47753", "17.28767", "Europe/Warsaw"),("3088759", "Pniewy", "", "PL", "616", "PL", "86", "3024", "302406", "52.50943", "16.25668", "Europe/Warsaw"),("3088825", "Płock", "Плоцк", "PL", "616", "", "78", "1462", "146201", "52.54682", "19.70638", "Europe/Warsaw"),("3088846", "Plewiska", "", "PL", "616", "", "86", "3021", "302107", "52.36706", "16.80985", "Europe/Warsaw"),("3088848", "Pleszew", "Плешев", "PL", "616", "", "86", "3020", "302006", "51.89636", "17.78549", "Europe/Warsaw"),("3088972", "Piotrków Trybunalski", "Пётркув-Трыбунальский", "PL", "616", "", "74", "1062", "106201", "51.40547", "19.70321", "Europe/Warsaw"),("3088977", "Piotrków Kujawski", "", "PL", "616", "PL", "73", "0411", "041105", "52.55111", "18.49905", "Europe/Warsaw"),("3089025", "Piława Górna", "", "PL", "616", "", "72", "0202", "020204", "50.68357", "16.74359", "Europe/Warsaw"),("3089033", "Piła", "Пилы", "PL", "616", "", "86", "3019", "301901", "53.15145", "16.73782", "Europe/Warsaw"),("3089065", "Pieszyce", "", "PL", "616", "", "72", "0202", "020203", "50.71287", "16.58232", "Europe/Warsaw"),("3089098", "Pieńsk", "", "PL", "616", "", "72", "0225", "022504", "51.249", "15.04685", "Europe/Warsaw"),("3089125", "Piekary Śląskie", "Пекары-Слёнске", "PL", "616", "", "83", "2471", "247101", "50.38017", "18.92653", "Europe/Warsaw"),("3089152", "Piechowice", "", "PL", "616", "PL", "72", "0206", "020603", "50.84963", "15.59887", "Europe/Warsaw"),("3089282", "Pelplin", "", "PL", "616", "", "82", "2214", "221404", "53.92834", "18.6977", "Europe/Warsaw"),("3089340", "Pawłowice", "", "PL", "616", "", "83", "2410", "241004", "49.96127", "18.71778", "Europe/Warsaw"),("3089392", "Pasłęk", "", "PL", "616", "", "85", "2804", "280407", "54.0616", "19.65932", "Europe/Warsaw"),("3089547", "Pakość", "", "PL", "616", "", "73", "0407", "040707", "52.80178", "18.0853", "Europe/Warsaw"),("3089553", "Pajęczno", "", "PL", "616", "", "74", "1009", "100904", "51.14449", "18.99612", "Europe/Warsaw"),("3089566", "Paczków", "", "PL", "616", "PL", "79", "1607", "160707", "50.46395", "17.00658", "Europe/Warsaw"),("3089578", "Pabianice", "Пабьянице", "PL", "616", "", "74", "1008", "100802", "51.66446", "19.35473", "Europe/Warsaw"),("3089582", "Ozorków", "Озоркув", "PL", "616", "", "74", "1020", "102002", "51.96336", "19.29139", "Europe/Warsaw"),("3089583", "Ozimek", "", "PL", "616", "", "79", "1609", "160908", "50.67944", "18.2137", "Europe/Warsaw"),("3089642", "Otmuchów", "", "PL", "616", "PL", "79", "1607", "160706", "50.46627", "17.17348", "Europe/Warsaw"),("3089658", "Oświęcim", "Освенцим", "PL", "616", "", "77", "1213", "121301", "50.03437", "19.21037", "Europe/Warsaw"),("3089670", "Ostrzeszów", "", "PL", "616", "", "86", "3018", "301807", "51.4264", "17.93355", "Europe/Warsaw"),("3089684", "Ostrów Wielkopolski", "Острув-Велькопольски", "PL", "616", "", "86", "3017", "301701", "51.65501", "17.80686", "Europe/Warsaw"),("3089779", "Ostróda", "Оструда", "PL", "616", "", "85", "2815", "281501", "53.69671", "19.96486", "Europe/Warsaw"),("3089924", "Osiek", "", "PL", "616", "", "77", "1213", "121305", "49.95067", "19.26444", "Europe/Warsaw"),("3089965", "Orzesze", "Ожеше", "PL", "616", "", "83", "2408", "240803", "50.15595", "18.77923", "Europe/Warsaw"),("3089987", "Ornontowice", "", "PL", "616", "PL", "83", "2408", "240804", "50.19377", "18.75435", "Europe/Warsaw"),("3090048", "Opole", "Ополе", "PL", "616", "", "79", "1661", "166101", "50.67211", "17.92533", "Europe/Warsaw"),("3090076", "Opalenica", "", "PL", "616", "", "86", "3015", "301505", "52.30887", "16.41278", "Europe/Warsaw"),("3090146", "Olkusz", "Олькуш", "PL", "616", "", "77", "1212", "121205", "50.2813", "19.56503", "Europe/Warsaw"),("3090158", "Olesno", "", "PL", "616", "", "79", "1608", "160803", "50.87698", "18.42094", "Europe/Warsaw"),("3090170", "Oleśnica", "Олесница", "PL", "616", "", "72", "0214", "021401", "51.21338", "17.38986", "Europe/Warsaw"),("3090205", "Oława", "Олава", "PL", "616", "", "72", "0215", "021501", "50.9466", "17.2926", "Europe/Warsaw"),("3090401", "Oborniki Śląskie", "", "PL", "616", "PL", "72", "0220", "022001", "51.30137", "16.91465", "Europe/Warsaw"),("3090403", "Oborniki", "Оборники", "PL", "616", "", "86", "3016", "301601", "52.64739", "16.81406", "Europe/Warsaw"),("3090436", "Nysa", "Ныса", "PL", "616", "PL", "79", "1607", "160705", "50.47379", "17.33437", "Europe/Warsaw"),("3090452", "Nowy Tomyśl", "", "PL", "616", "", "86", "3015", "301504", "52.3195", "16.12844", "Europe/Warsaw"),("3090502", "Nowy Dwór Gdański", "", "PL", "616", "", "82", "2210", "221002", "54.21305", "19.11771", "Europe/Warsaw"),("3090553", "Nowogród Bobrzański", "", "PL", "616", "PL", "76", "0809", "080905", "51.79856", "15.2352", "Europe/Warsaw"),("3090558", "Nowogard", "Новогард", "PL", "616", "", "87", "3204", "320404", "53.67437", "15.1163", "Europe/Warsaw"),("3090613", "Nowe Miasto Lubawskie", "", "PL", "616", "", "85", "2812", "281201", "53.42079", "19.59515", "Europe/Warsaw"),("3090660", "Nowe", "", "PL", "616", "", "73", "0414", "041406", "53.64906", "18.72716", "Europe/Warsaw"),("3090764", "Nowa Sól", "Нова-Суль", "PL", "616", "", "76", "0804", "080401", "51.80333", "15.71702", "Europe/Warsaw"),("3090768", "Nowa Ruda", "Нова-Руда", "PL", "616", "", "72", "0208", "020804", "50.58008", "16.50164", "Europe/Warsaw"),("3090951", "Niemodlin", "", "PL", "616", "PL", "79", "1609", "160907", "50.642", "17.61932", "Europe/Warsaw"),("3091031", "Niedobczyce", "", "PL", "616", "", "83", "2473", "247301", "50.0654", "18.49531", "Europe/Warsaw"),("3091141", "Namysłów", "Намыслув", "PL", "616", "", "79", "1606", "160602", "51.07592", "17.72284", "Europe/Warsaw"),("3091150", "Nakło nad Notecią", "Накло-над-Нотецью", "PL", "616", "", "73", "0410", "041003", "53.14214", "17.60181", "Europe/Warsaw"),("3091217", "Myszków", "Мышков", "PL", "616", "", "83", "2409", "240901", "50.5752", "19.32461", "Europe/Warsaw"),("3091232", "Mysłowice", "Мысловице", "PL", "616", "", "83", "2470", "247001", "50.20745", "19.16668", "Europe/Warsaw"),("3091253", "Myślibórz", "", "PL", "616", "", "87", "3210", "321004", "52.92382", "14.86785", "Europe/Warsaw"),("3091256", "Myślenice", "Мысленице", "PL", "616", "", "77", "1209", "120903", "49.83383", "19.9383", "Europe/Warsaw"),("3091263", "Mysłakowice", "", "PL", "616", "", "72", "0206", "020607", "50.84123", "15.77894", "Europe/Warsaw"),("3091293", "Murowana Goślina", "", "PL", "616", "", "86", "3021", "302111", "52.57463", "17.00933", "Europe/Warsaw"),("3091297", "Murcki", "", "PL", "616", "PL", "83", "2469", "246901", "50.20036", "19.04351", "Europe/Warsaw"),("3091407", "Mosina", "", "PL", "616", "", "86", "3021", "302110", "52.24543", "16.84709", "Europe/Warsaw"),("3091462", "Morąg", "", "PL", "616", "", "85", "2815", "281508", "53.91711", "19.92602", "Europe/Warsaw"),("3091523", "Mogilno", "", "PL", "616", "", "73", "0409", "040903", "52.65806", "17.95578", "Europe/Warsaw"),("3091788", "Milicz", "", "PL", "616", "", "72", "0213", "021303", "51.5277", "17.27137", "Europe/Warsaw"),("3091831", "Mikołów", "Миколув", "PL", "616", "", "83", "2408", "240802", "50.17103", "18.9041", "Europe/Warsaw"),("3091961", "Międzyzdroje", "", "PL", "616", "PL", "87", "3207", "320704", "53.92921", "14.45097", "Europe/Warsaw"),("3091969", "Międzyrzecz", "Мендзыжеч", "PL", "616", "", "76", "0803", "080302", "52.44461", "15.57801", "Europe/Warsaw"),("3091983", "Międzychód", "", "PL", "616", "", "86", "3014", "301403", "52.59882", "15.89696", "Europe/Warsaw"),("3092080", "Miastko", "", "PL", "616", "", "82", "2201", "220106", "54.00283", "16.98263", "Europe/Warsaw"),("3092082", "Miasteczko Śląskie", "", "PL", "616", "PL", "83", "2413", "241302", "50.50262", "18.93949", "Europe/Warsaw"),("3092276", "Markłowice", "", "PL", "616", "", "83", "2415", "241508", "50.01695", "18.52098", "Europe/Warsaw"),("3092472", "Malbork", "Мальборк", "PL", "616", "", "82", "2209", "220901", "54.03591", "19.0266", "Europe/Warsaw"),("3092517", "Maków Podhalański", "", "PL", "616", "", "77", "1215", "121506", "49.73008", "19.67711", "Europe/Warsaw"),("3092638", "Lwówek Śląski", "", "PL", "616", "", "72", "0212", "021203", "51.11074", "15.58582", "Europe/Warsaw"),("3092643", "Luzino", "", "PL", "616", "", "82", "2215", "221507", "54.56604", "18.10907", "Europe/Warsaw"),("3092813", "Lubsko", "", "PL", "616", "", "76", "0811", "081106", "51.78467", "14.97196", "Europe/Warsaw"),("3092856", "Luboń", "Любон", "PL", "616", "", "86", "3021", "302101", "52.34705", "16.89267", "Europe/Warsaw"),("3092906", "Lubliniec", "Люблинец", "PL", "616", "", "83", "2407", "240701", "50.66897", "18.6844", "Europe/Warsaw"),("3092931", "Lubin", "Любин", "PL", "616", "", "72", "0211", "021101", "51.40089", "16.20149", "Europe/Warsaw"),("3093027", "Lubawka", "", "PL", "616", "PL", "72", "0207", "020703", "50.70456", "16.00026", "Europe/Warsaw"),("3093028", "Lubawa", "", "PL", "616", "", "85", "2807", "280705", "53.50428", "19.74966", "Europe/Warsaw"),("3093040", "Lubań", "Любань", "PL", "616", "", "72", "0210", "021001", "51.12014", "15.28768", "Europe/Warsaw"),("3093066", "Łowicz", "Лович", "PL", "616", "", "74", "1005", "100501", "52.10714", "19.94525", "Europe/Warsaw"),("3093133", "Łódź", "Лодзь", "PL", "616", "", "74", "1061", "106101", "51.75", "19.46667", "Europe/Warsaw"),("3093136", "Łodygowice", "", "PL", "616", "", "83", "2417", "241708", "49.72992", "19.13939", "Europe/Warsaw"),("3093158", "Łobez", "", "PL", "616", "", "87", "3218", "321802", "53.63918", "15.62129", "Europe/Warsaw"),("3093268", "Lipno", "", "PL", "616", "", "73", "0408", "040801", "52.84436", "19.17852", "Europe/Warsaw"),("3093439", "Lidzbark", "", "PL", "616", "", "85", "2803", "280304", "53.26283", "19.82663", "Europe/Warsaw"),("3093457", "Libiąż", "", "PL", "616", "", "77", "1203", "120304", "50.10396", "19.31568", "Europe/Warsaw"),("3093501", "Lewin Brzeski", "", "PL", "616", "PL", "79", "1601", "160104", "50.7487", "17.61688", "Europe/Warsaw"),("3093524", "Leszno", "Лешно", "PL", "616", "", "86", "3063", "306301", "51.84034", "16.57494", "Europe/Warsaw"),("3093692", "Legnica", "Легница", "PL", "616", "", "72", "0262", "026201", "51.21006", "16.1619", "Europe/Warsaw"),("3093708", "Lędziny", "", "PL", "616", "", "83", "2414", "241403", "50.14264", "19.13149", "Europe/Warsaw"),("3093726", "Łęczyca", "Ленчица", "PL", "616", "", "74", "1004", "100401", "52.05959", "19.19972", "Europe/Warsaw"),("3093739", "Lębork", "Лемборк", "PL", "616", "", "82", "2208", "220801", "54.53921", "17.75012", "Europe/Warsaw"),("3093768", "Łazy", "", "PL", "616", "", "83", "2416", "241605", "50.42769", "19.39465", "Europe/Warsaw"),("3093785", "Łaziska Górne", "Лазиска-Гурне", "PL", "616", "PL", "83", "2408", "240801", "50.14952", "18.84215", "Europe/Warsaw"),("3093902", "Łask", "Ласк", "PL", "616", "", "74", "1003", "100302", "51.59056", "19.13278", "Europe/Warsaw"),("3094016", "Lądek-Zdrój", "", "PL", "616", "PL", "72", "0208", "020808", "50.34371", "16.87946", "Europe/Warsaw"),("3094086", "Kwidzyn", "Квидзын", "PL", "616", "", "82", "2207", "220701", "53.72495", "18.93114", "Europe/Warsaw"),("3094164", "Kuźnia Raciborska", "", "PL", "616", "PL", "83", "2411", "241105", "50.20058", "18.31146", "Europe/Warsaw"),("3094170", "Kutno", "Кутно", "PL", "616", "", "74", "1002", "100201", "52.23064", "19.36409", "Europe/Warsaw"),("3094303", "Kudowa-Zdrój", "", "PL", "616", "", "72", "0208", "020803", "50.44297", "16.24397", "Europe/Warsaw"),("3094370", "Ksawerów", "", "PL", "616", "", "74", "1008", "100805", "51.68288", "19.4028", "Europe/Warsaw"),("3094408", "Krzyż Wielkopolski", "", "PL", "616", "PL", "86", "3002", "300204", "52.88097", "16.01116", "Europe/Warsaw"),("3094490", "Krzeszowice", "", "PL", "616", "", "77", "1206", "120606", "50.14248", "19.63223", "Europe/Warsaw"),("3094585", "Kruszwica", "", "PL", "616", "", "73", "0407", "040706", "52.67562", "18.33131", "Europe/Warsaw"),("3094625", "Krotoszyn", "Кротошин", "PL", "616", "", "86", "3012", "301204", "51.69868", "17.43738", "Europe/Warsaw"),("3094633", "Krosno Odrzańskie", "", "PL", "616", "", "76", "0802", "080206", "52.05492", "15.09882", "Europe/Warsaw"),("3094788", "Krapkowice", "Крапковице", "PL", "616", "", "79", "1605", "160502", "50.47515", "17.96539", "Europe/Warsaw"),("3094802", "Kraków", "Краков", "PL", "616", "", "77", "1261", "126101", "50.06143", "19.93658", "Europe/Warsaw"),("3094831", "Kozy", "", "PL", "616", "PL", "83", "2402", "240207", "49.84756", "19.14891", "Europe/Warsaw"),("3094832", "Kożuchów", "", "PL", "616", "", "76", "0804", "080404", "51.74558", "15.59492", "Europe/Warsaw"),("3094852", "Koźmin Wielkopolski", "", "PL", "616", "", "86", "3012", "301203", "51.82712", "17.45391", "Europe/Warsaw"),("3094871", "Koźle", "", "PL", "616", "PL", "79", "1603", "160301", "50.3356", "18.14332", "Europe/Warsaw"),("3094934", "Kowary", "", "PL", "616", "", "72", "0206", "020602", "50.79313", "15.83559", "Europe/Warsaw"),("3095049", "Koszalin", "Кошалин", "PL", "616", "", "87", "3261", "326101", "54.19438", "16.17222", "Europe/Warsaw"),("3095057", "Kostrzyn nad Odrą", "Костшин-над-Одрой", "PL", "616", "", "76", "0801", "080101", "52.58713", "14.64953", "Europe/Warsaw"),("3095058", "Kostrzyn", "", "PL", "616", "", "86", "3021", "302108", "52.39847", "17.22811", "Europe/Warsaw"),("3095126", "Kościerzyna", "Косцежина", "PL", "616", "", "82", "2206", "220601", "54.12226", "17.98119", "Europe/Warsaw"),("3095151", "Kościan", "Косьцян", "PL", "616", "", "86", "3011", "301101", "52.08829", "16.64866", "Europe/Warsaw"),("3095192", "Koronowo", "", "PL", "616", "", "73", "0403", "040304", "53.3137", "17.93698", "Europe/Warsaw"),("3095194", "Kórnik", "", "PL", "616", "", "86", "3021", "302109", "52.24772", "17.08949", "Europe/Warsaw"),("3095277", "Konstantynów Łódzki", "", "PL", "616", "", "74", "1008", "100801", "51.74776", "19.32564", "Europe/Warsaw"),("3095321", "Konin", "Конин", "PL", "616", "", "86", "3062", "306201", "52.22338", "18.25121", "Europe/Warsaw"),("3095330", "Koniecpol", "", "PL", "616", "", "83", "2404", "240406", "50.77468", "19.68896", "Europe/Warsaw"),("3095396", "Komorniki", "", "PL", "616", "", "86", "3021", "302107", "52.3387", "16.81063", "Europe/Warsaw"),("3095413", "Koluszki", "", "PL", "616", "", "74", "1006", "100607", "51.73872", "19.81994", "Europe/Warsaw"),("3095795", "Kołobrzeg", "Колобжег", "PL", "616", "", "87", "3208", "320804", "54.17565", "15.58342", "Europe/Warsaw"),("3095797", "Koło", "Коло", "PL", "616", "", "86", "3009", "300901", "52.20024", "18.63865", "Europe/Warsaw"),("3095971", "Knurów", "", "PL", "616", "", "83", "2405", "240501", "50.21971", "18.65067", "Europe/Warsaw"),("3096002", "Klucze", "", "PL", "616", "", "77", "1212", "121204", "50.33565", "19.56236", "Europe/Warsaw"),("3096003", "Kluczbork", "Ключборк", "PL", "616", "", "79", "1604", "160402", "50.97281", "18.21816", "Europe/Warsaw"),("3096053", "Kłodzko", "Клодзко", "PL", "616", "", "72", "0208", "020802", "50.43488", "16.66145", "Europe/Warsaw"),("3096079", "Kłodawa", "", "PL", "616", "", "86", "3009", "300906", "52.25447", "18.91352", "Europe/Warsaw"),("3096090", "Kłobuck", "", "PL", "616", "", "83", "2406", "240601", "50.90081", "18.93674", "Europe/Warsaw"),("3096240", "Kietrz", "", "PL", "616", "PL", "79", "1602", "160204", "50.08042", "18.00432", "Europe/Warsaw"),("3096328", "Kęty", "Кенты", "PL", "616", "", "77", "1213", "121304", "49.88214", "19.22333", "Europe/Warsaw"),("3096338", "Kępno", "", "PL", "616", "", "86", "3008", "300803", "51.2784", "17.98908", "Europe/Warsaw"),("3096372", "Kędzierzyn-Koźle", "Кендзежин-Козле", "PL", "616", "", "79", "1603", "160301", "50.34984", "18.22606", "Europe/Warsaw"),("3096444", "Kąty Wrocławskie", "", "PL", "616", "PL", "72", "0223", "022304", "51.03098", "16.76767", "Europe/Warsaw"),("3096472", "Katowice", "Катовице", "PL", "616", "", "83", "2469", "246901", "50.25841", "19.02754", "Europe/Warsaw"),("3096525", "Kartuzy", "Картузы", "PL", "616", "", "82", "2205", "220502", "54.33424", "18.19735", "Europe/Warsaw"),("3096630", "Karlino", "", "PL", "616", "PL", "87", "3201", "320103", "54.03515", "15.87739", "Europe/Warsaw"),("3096765", "Kamień Pomorski", "", "PL", "616", "", "87", "3207", "320703", "53.96849", "14.77262", "Europe/Warsaw"),("3096779", "Kamienna Góra", "Каменна-Гура", "PL", "616", "", "72", "0207", "020701", "50.78314", "16.03037", "Europe/Warsaw"),("3096880", "Kalisz", "Калиш", "PL", "616", "", "86", "3061", "306101", "51.76109", "18.09102", "Europe/Warsaw"),("3096911", "Kalety", "", "PL", "616", "", "83", "2413", "241301", "50.5627", "18.8926", "Europe/Warsaw"),("3096986", "Wielki Kack", "", "PL", "616", "PL", "82", "2262", "226201", "54.46754", "18.4881", "Europe/Warsaw"),("3097107", "Jordanów", "", "PL", "616", "", "77", "1215", "121501", "49.64935", "19.82981", "Europe/Warsaw"),("3097257", "Jelenia Góra", "", "PL", "616", "", "72", "0261", "026101", "50.89973", "15.72899", "Europe/Warsaw"),("3097271", "Jelcz", "", "PL", "616", "", "72", "0215", "021503", "51.02102", "17.32095", "Europe/Warsaw"),("3097301", "Jedlina-Zdrój", "", "PL", "616", "PL", "72", "0221", "022102", "50.72005", "16.34645", "Europe/Warsaw"),("3097328", "Jaworzyna Śląska", "", "PL", "616", "PL", "72", "0219", "021904", "50.9134", "16.43241", "Europe/Warsaw"),("3097333", "Jaworzno", "Явожно", "PL", "616", "", "83", "2468", "246801", "50.20528", "19.27498", "Europe/Warsaw"),("3097339", "Jaworze", "", "PL", "616", "", "83", "2402", "240206", "49.79351", "18.9479", "Europe/Warsaw"),("3097367", "Jawor", "Явор", "PL", "616", "", "72", "0205", "020501", "51.05132", "16.19347", "Europe/Warsaw"),("3097391", "Jastrzębie Zdrój", "", "PL", "616", "", "83", "2467", "246701", "49.95542", "18.57479", "Europe/Warsaw"),("3097420", "Jastrowie", "", "PL", "616", "", "86", "3031", "303102", "53.42048", "16.81756", "Europe/Warsaw"),("3097528", "Jarocin", "Яроцин", "PL", "616", "", "86", "3006", "300602", "51.97266", "17.50256", "Europe/Warsaw"),("3097594", "Janowiec Wielkopolski", "", "PL", "616", "PL", "73", "0419", "041903", "52.75583", "17.48981", "Europe/Warsaw"),("3097688", "Janikowo", "", "PL", "616", "", "73", "0407", "040705", "52.75328", "18.11328", "Europe/Warsaw"),("3097872", "Inowrocław", "Иновроцлав", "PL", "616", "", "73", "0407", "040701", "52.79886", "18.26387", "Europe/Warsaw"),("3097886", "Imielin", "", "PL", "616", "", "83", "2414", "241402", "50.14534", "19.18599", "Europe/Warsaw"),("3097902", "Iława", "Илава", "PL", "616", "", "85", "2807", "280701", "53.59601", "19.56849", "Europe/Warsaw"),("3098130", "Gubin", "Губин", "PL", "616", "", "76", "0802", "080201", "51.94956", "14.72837", "Europe/Warsaw"),("3098199", "Gryfów Śląski", "", "PL", "616", "", "72", "0212", "021201", "51.03081", "15.42017", "Europe/Warsaw"),("3098200", "Gryfino", "Грыфино", "PL", "616", "", "87", "3206", "320604", "53.25243", "14.48831", "Europe/Warsaw"),("3098201", "Gryfice", "Грыфице", "PL", "616", "", "87", "3205", "320502", "53.9165", "15.20027", "Europe/Warsaw"),("3098218", "Grudziądz", "Грудзендз", "PL", "616", "", "73", "0462", "046201", "53.48411", "18.75366", "Europe/Warsaw"),("3098288", "Grodzisk Wielkopolski", "", "PL", "616", "", "86", "3005", "300502", "52.22762", "16.36534", "Europe/Warsaw"),("3098333", "Grodków", "", "PL", "616", "", "79", "1601", "160103", "50.69836", "17.38449", "Europe/Warsaw"),("3098619", "Gostynin", "Гостынин", "PL", "616", "PL", "78", "1404", "140401", "52.42938", "19.46194", "Europe/Warsaw"),("3098625", "Gostyń", "Гостын", "PL", "616", "", "86", "3004", "300402", "51.88247", "17.01225", "Europe/Warsaw"),("3098686", "Gościcino", "", "PL", "616", "", "82", "2215", "221510", "54.60459", "18.15491", "Europe/Warsaw"),("3098722", "Gorzów Wielkopolski", "Гожув-Велькопольски", "PL", "616", "", "76", "0861", "086101", "52.73679", "15.22878", "Europe/Warsaw"),("3098898", "Góra", "", "PL", "616", "", "72", "0204", "020401", "51.66638", "16.53494", "Europe/Warsaw"),("3098925", "Golub-Dobrzyń", "", "PL", "616", "", "73", "0405", "040501", "53.11087", "19.05381", "Europe/Warsaw"),("3098966", "Goleniów", "Голенюв", "PL", "616", "", "87", "3204", "320402", "53.56392", "14.82854", "Europe/Warsaw"),("3099048", "Gogolin", "", "PL", "616", "", "79", "1605", "160501", "50.49222", "18.01994", "Europe/Warsaw"),("3099095", "Goczałkowice Zdrój", "", "PL", "616", "PL", "83", "2410", "241001", "49.94454", "18.96927", "Europe/Warsaw"),("3099112", "Gniezno", "Гнезно", "PL", "616", "", "86", "3003", "300301", "52.53481", "17.58259", "Europe/Warsaw"),("3099120", "Gniewkowo", "", "PL", "616", "PL", "73", "0407", "040703", "52.89461", "18.40785", "Europe/Warsaw"),("3099127", "Gniew", "", "PL", "616", "", "82", "2214", "221402", "53.83602", "18.8231", "Europe/Warsaw"),("3099146", "Głuszyca", "", "PL", "616", "PL", "72", "0221", "022105", "50.68743", "16.37173", "Europe/Warsaw"),("3099169", "Głuchołazy", "Глухолазы", "PL", "616", "", "79", "1607", "160701", "50.31505", "17.38355", "Europe/Warsaw"),("3099174", "Głubczyce", "", "PL", "616", "", "79", "1602", "160203", "50.20086", "17.82858", "Europe/Warsaw"),("3099180", "Głowno", "Гловно", "PL", "616", "", "74", "1020", "102001", "51.96463", "19.71565", "Europe/Warsaw"),("3099209", "Głogówek", "", "PL", "616", "PL", "79", "1610", "161002", "50.35355", "17.86405", "Europe/Warsaw"),("3099213", "Głogów", "Глогув", "PL", "616", "", "72", "0203", "020301", "51.66361", "16.0845", "Europe/Warsaw"),("3099230", "Gliwice", "Гливице", "PL", "616", "", "83", "2466", "246601", "50.29761", "18.67658", "Europe/Warsaw"),("3099424", "Gdynia", "Гдыня", "PL", "616", "", "82", "2262", "226201", "54.51889", "18.53188", "Europe/Warsaw"),("3099434", "Gdańsk", "Гданьск", "PL", "616", "", "82", "2261", "226101", "54.35205", "18.64637", "Europe/Warsaw"),("3099654", "Fordon", "", "PL", "616", "", "73", "0461", "046101", "53.14821", "18.17036", "Europe/Warsaw"),("3099759", "Elbląg", "Эльблонг", "PL", "616", "", "85", "2861", "286101", "54.1522", "19.40884", "Europe/Warsaw"),("3099828", "Dzierżoniów", "Дзержонюв", "PL", "616", "", "72", "0202", "020202", "50.7282", "16.65141", "Europe/Warsaw"),("3099842", "Dzierzgoń", "", "PL", "616", "", "82", "2216", "221601", "53.92196", "19.34705", "Europe/Warsaw"),("3099923", "Działoszyn", "", "PL", "616", "", "74", "1009", "100901", "51.11699", "18.86524", "Europe/Warsaw"),("3100127", "Drezdenko", "", "PL", "616", "", "76", "0806", "080602", "52.83831", "15.83079", "Europe/Warsaw"),("3100139", "Drawsko Pomorskie", "", "PL", "616", "", "87", "3203", "320302", "53.53056", "15.80967", "Europe/Warsaw"),("3100489", "Debrzno", "", "PL", "616", "PL", "82", "2203", "220304", "53.53817", "17.23643", "Europe/Warsaw"),("3100545", "Dębno", "", "PL", "616", "", "87", "3210", "321003", "52.73901", "14.698", "Europe/Warsaw"),("3100637", "Darłowo", "", "PL", "616", "", "87", "3213", "321301", "54.42095", "16.4107", "Europe/Warsaw"),("3100796", "Dąbrowa Górnicza", "Домброва-Гурнича", "PL", "616", "", "83", "2465", "246501", "50.31818", "19.2374", "Europe/Warsaw"),("3100933", "Człuchów", "", "PL", "616", "", "82", "2203", "220301", "53.66722", "17.35883", "Europe/Warsaw"),("3100946", "Częstochowa", "Ченстохова", "PL", "616", "", "83", "2464", "246401", "50.79646", "19.12409", "Europe/Warsaw"),("3100971", "Czerwonak", "", "PL", "616", "", "86", "3021", "302104", "52.46459", "16.98169", "Europe/Warsaw"),("3100974", "Czerwionka-Leszczyny", "", "PL", "616", "", "83", "2412", "241201", "50.15007", "18.67762", "Europe/Warsaw"),("3100984", "Czersk", "", "PL", "616", "", "82", "2202", "220204", "53.79589", "17.97647", "Europe/Warsaw"),("3101053", "Czempiń", "", "PL", "616", "", "86", "3011", "301102", "52.14404", "16.76408", "Europe/Warsaw"),("3101057", "Czeladź", "", "PL", "616", "", "83", "2401", "240102", "50.31542", "19.07824", "Europe/Warsaw"),("3101076", "Czechowice-Dziedzice", "Чеховице-Дзедзице", "PL", "616", "", "83", "2402", "240204", "49.91342", "19.00479", "Europe/Warsaw"),("3101145", "Czarnków", "", "PL", "616", "", "86", "3002", "300202", "52.90214", "16.56413", "Europe/Warsaw"),("3101161", "Czarne", "", "PL", "616", "PL", "82", "2203", "220302", "53.6842", "16.93834", "Europe/Warsaw"),("3101204", "Czaplinek", "", "PL", "616", "PL", "87", "3203", "320301", "53.55775", "16.23333", "Europe/Warsaw"),("3101220", "Czaniec", "", "PL", "616", "", "83", "2402", "240208", "49.85071", "19.25354", "Europe/Warsaw"),("3101321", "Cieszyn", "Цешин", "PL", "616", "", "83", "2403", "240301", "49.75133", "18.63213", "Europe/Warsaw"),("3101367", "Cieplice Śląskie Zdrój", "", "PL", "616", "PL", "72", "0261", "026101", "50.86545", "15.68367", "Europe/Warsaw"),("3101426", "Ciechocinek", "", "PL", "616", "", "73", "0401", "040102", "52.87908", "18.79505", "Europe/Warsaw"),("3101547", "Chrzanów", "Хшанув", "PL", "616", "", "77", "1203", "120303", "50.13546", "19.40203", "Europe/Warsaw"),("3101613", "Choszczno", "Хощно", "PL", "616", "", "87", "3202", "320202", "53.16905", "15.42054", "Europe/Warsaw"),("3101619", "Chorzów", "Хожув", "PL", "616", "", "83", "2463", "246301", "50.30582", "18.9742", "Europe/Warsaw"),("3101660", "Chojnów", "", "PL", "616", "", "72", "0209", "020902", "51.27373", "15.93661", "Europe/Warsaw"),("3101672", "Chojnice", "Хойнице", "PL", "616", "", "82", "2202", "220201", "53.69554", "17.55701", "Europe/Warsaw"),("3101675", "Chojna", "", "PL", "616", "PL", "87", "3206", "320603", "52.96389", "14.42797", "Europe/Warsaw"),("3101680", "Chodzież", "Ходзеж", "PL", "616", "", "86", "3001", "300101", "52.99505", "16.9198", "Europe/Warsaw"),("3101691", "Chocznia", "", "PL", "616", "", "77", "1218", "121809", "49.87417", "19.45438", "Europe/Warsaw"),("3101722", "Chocianów", "", "PL", "616", "PL", "72", "0216", "021601", "51.41867", "15.90172", "Europe/Warsaw"),("3101787", "Chełmża", "Хелмжа", "PL", "616", "", "73", "0415", "041501", "53.18463", "18.60466", "Europe/Warsaw"),("3101788", "Chełm Śląski", "", "PL", "616", "", "83", "2414", "241405", "50.10825", "19.19552", "Europe/Warsaw"),("3101795", "Chełmno", "Хелмно", "PL", "616", "", "73", "0404", "040401", "53.34855", "18.4251", "Europe/Warsaw"),("3101812", "Chełmek", "", "PL", "616", "", "77", "1213", "121303", "50.10163", "19.24801", "Europe/Warsaw"),("3101943", "Bytów", "Бытув", "PL", "616", "", "82", "2201", "220102", "54.17057", "17.49187", "Europe/Warsaw"),("3101950", "Bytom", "Бытом", "PL", "616", "", "83", "2462", "246201", "50.34802", "18.93282", "Europe/Warsaw"),("3101968", "Bystrzyca Kłodzka", "", "PL", "616", "", "72", "0208", "020806", "50.30179", "16.64231", "Europe/Warsaw"),("3102014", "Bydgoszcz", "Быдгощ", "PL", "616", "", "73", "0461", "046101", "53.1235", "18.00762", "Europe/Warsaw"),("3102076", "Bukowno", "", "PL", "616", "", "77", "1212", "121201", "50.26474", "19.45962", "Europe/Warsaw"),("3102138", "Buk", "", "PL", "616", "", "86", "3021", "302103", "52.35532", "16.51958", "Europe/Warsaw"),("3102390", "Brzeziny", "", "PL", "616", "", "74", "1021", "102101", "51.80023", "19.75144", "Europe/Warsaw"),("3102444", "Brzeszcze", "", "PL", "616", "", "77", "1213", "121302", "49.98203", "19.15157", "Europe/Warsaw"),("3102456", "Brzeg Dolny", "", "PL", "616", "", "72", "0222", "022201", "51.27299", "16.70815", "Europe/Warsaw"),("3102459", "Brzeg", "Бжег", "PL", "616", "", "79", "1601", "160101", "50.86079", "17.4674", "Europe/Warsaw"),("3102627", "Brodnica", "Бродница", "PL", "616", "", "73", "0402", "040201", "53.25967", "19.39653", "Europe/Warsaw"),("3102652", "Brenna", "", "PL", "616", "", "83", "2403", "240304", "49.72576", "18.90249", "Europe/Warsaw"),("3102677", "Braniewo", "Бранево", "PL", "616", "", "85", "2802", "280201", "54.37971", "19.81959", "Europe/Warsaw"),("3102961", "Bolszewo", "", "PL", "616", "", "82", "2215", "221510", "54.61801", "18.17585", "Europe/Warsaw"),("3102969", "Bolków", "", "PL", "616", "PL", "72", "0205", "020502", "50.92203", "16.10111", "Europe/Warsaw"),("3102987", "Bolesławiec", "Болеславец", "PL", "616", "", "72", "0201", "020102", "51.26418", "15.5697", "Europe/Warsaw"),("3103034", "Boguszów-Gorce", "Богушув-Горце", "PL", "616", "", "72", "0221", "022101", "50.75514", "16.20494", "Europe/Warsaw"),("3103096", "Bogatynia", "Богатыня", "PL", "616", "", "72", "0225", "022503", "50.90747", "14.95634", "Europe/Warsaw"),("3103274", "Blachownia", "", "PL", "616", "", "83", "2404", "240401", "50.78015", "18.96389", "Europe/Warsaw"),("3103364", "Bierutów", "", "PL", "616", "PL", "72", "0214", "021402", "51.12443", "17.54607", "Europe/Warsaw"),("3103365", "Bieruń", "Берунь", "PL", "616", "", "83", "2414", "241401", "50.09", "19.09291", "Europe/Warsaw"),("3103402", "Bielsko-Biala", "Бельско-Бяла", "PL", "616", "", "83", "2461", "246101", "49.82245", "19.04686", "Europe/Warsaw"),("3103476", "Bielawa", "Белява", "PL", "616", "", "72", "0202", "020201", "50.69075", "16.623", "Europe/Warsaw"),("3103556", "Białogard", "Бялогард", "PL", "616", "", "87", "3201", "320101", "54.00696", "15.98751", "Europe/Warsaw"),("3103588", "Białe Błota", "", "PL", "616", "", "73", "0403", "040301", "53.09516", "17.91621", "Europe/Warsaw"),("3103709", "Bełchatów", "Белхатув", "PL", "616", "", "74", "1001", "100101", "51.36883", "19.35671", "Europe/Warsaw"),("3103719", "Będzin", "Бендзин", "PL", "616", "", "83", "2401", "240101", "50.32607", "19.12565", "Europe/Warsaw"),("3103824", "Barlinek", "", "PL", "616", "", "87", "3210", "321001", "52.99464", "15.21864", "Europe/Warsaw"),("3103856", "Barcin", "", "PL", "616", "", "73", "0419", "041901", "52.86607", "17.94625", "Europe/Warsaw"),("3104115", "Andrychów", "Андрыхув", "PL", "616", "", "77", "1218", "121801", "49.85497", "19.33834", "Europe/Warsaw"),("3104132", "Aleksandrów Łódzki", "Александрув-Лодзинский", "PL", "616", "", "74", "1020", "102004", "51.81965", "19.30384", "Europe/Warsaw"),("3104133", "Aleksandrów Kujawski", "", "PL", "616", "", "73", "0401", "040101", "52.87659", "18.69345", "Europe/Warsaw"),("6545326", "Ursynów", "", "PL", "616", "", "78", "1465", "146501", "52.15051", "21.05041", "Europe/Warsaw"),("6545347", "Praga Północ", "", "PL", "616", "", "78", "1465", "146501", "52.25443", "21.03472", "Europe/Warsaw"),("6545348", "Praga Południe", "", "PL", "616", "", "78", "1465", "146501", "52.24424", "21.08545", "Europe/Warsaw"),("7303641", "Jelcz Laskowice", "", "PL", "616", "", "72", "0215", "021503", "51.02134", "17.31649", "Europe/Warsaw"),("2261577", "Vila Viçosa", "", "PT", "620", "", "08", "0714", "071405", "38.7777", "-7.41793", "Europe/Lisbon"),("2261598", "Vila Real de Santo António", "", "PT", "620", "", "09", "0816", "081602", "37.195", "-7.41766", "Europe/Lisbon"),("2261639", "Vila Franca de Xira", "", "PT", "620", "", "14", "1114", "111409", "38.95525", "-8.98966", "Europe/Lisbon"),("2261673", "Vieira de Leiria", "", "PT", "620", "", "13", "1010", "101002", "39.86945", "-8.93238", "Europe/Lisbon"),("2261697", "Vialonga", "", "PT", "620", "", "14", "1114", "111411", "38.87094", "-9.06823", "Europe/Lisbon"),("2261732", "Ventosa", "", "PT", "620", "", "14", "1101", "110113", "39.12696", "-9.08423", "Europe/Lisbon"),("2261740", "Vendas Novas", "", "PT", "620", "", "08", "0712", "071201", "38.67706", "-8.45792", "Europe/Lisbon"),("2262373", "Vale da Amoreira", "", "PT", "620", "", "16", "1208", "120802", "39.06969", "-7.69849", "Europe/Lisbon"),("2262465", "Unhos", "", "PT", "620", "", "14", "1107", "110717", "38.82589", "-9.12231", "Europe/Lisbon"),("2262544", "Trafaria", "", "PT", "620", "", "19", "1503", "150305", "38.67222", "-9.23268", "Europe/Lisbon"),("2262581", "Torres Vedras", "Торреш", "PT", "620", "", "14", "1113", "111315", "39.09109", "-9.2586", "Europe/Lisbon"),("2262582", "Torres Novas", "", "PT", "620", "", "18", "1419", "141912", "39.48114", "-8.53949", "Europe/Lisbon"),("2262644", "Tomar", "Томар", "PT", "620", "", "18", "1418", "141811", "39.60199", "-8.40924", "Europe/Lisbon"),("2262744", "Tavira", "", "PT", "620", "", "09", "0814", "081405", "37.12734", "-7.64861", "Europe/Lisbon"),("2262865", "Sobreda", "", "PT", "620", "", "19", "1503", "150308", "38.64961", "-9.18977", "Europe/Lisbon"),("2262912", "Sintra", "Синтра", "PT", "620", "", "14", "1111", "111109", "38.80097", "-9.37826", "Europe/Lisbon"),("2262917", "Sines", "", "PT", "620", "", "19", "1513", "151301", "37.95622", "-8.86979", "Europe/Lisbon"),("2262926", "Silves", "", "PT", "620", "", "09", "0813", "081307", "37.18921", "-8.43822", "Europe/Lisbon"),("2262944", "Silveira", "", "PT", "620", "", "14", "1113", "111316", "39.1112", "-9.3643", "Europe/Lisbon"),("2262957", "Sesimbra", "Сесимбра", "PT", "620", "", "19", "1511", "151102", "38.44451", "-9.10149", "Europe/Lisbon"),("2262963", "Setúbal", "Сетубал", "PT", "620", "", "19", "1512", "151202", "38.5244", "-8.8882", "Europe/Lisbon"),("2262987", "Sertã", "", "PT", "620", "", "06", "0509", "050912", "39.80846", "-8.09883", "Europe/Lisbon"),("2263049", "Serpa", "", "PT", "620", "", "03", "0213", "021305", "37.94581", "-7.59754", "Europe/Lisbon"),("2263197", "São Vicente", "", "PT", "620", "", "10", "3110", "311003", "32.79673", "-17.04323", "Atlantic/Madeira"),("2263326", "São João da Talha", "", "PT", "620", "", "14", "1107", "110715", "38.82183", "-9.09079", "Europe/Lisbon"),("2263327", "São João das Lampas", "", "PT", "620", "", "14", "1111", "111110", "38.87376", "-9.39842", "Europe/Lisbon"),("2263352", "São Domingos de Rana", "", "PT", "620", "", "14", "1105", "110502", "38.70123", "-9.3276", "Europe/Lisbon"),("2263377", "São Brás de Alportel", "", "PT", "620", "", "09", "0812", "081201", "37.1531", "-7.88751", "Europe/Lisbon"),("2263393", "São Bartolomeu de Messines", "", "PT", "620", "", "09", "0813", "081305", "37.26024", "-8.2867", "Europe/Lisbon"),("2263426", "Santo António da Charneca", "", "PT", "620", "", "19", "1504", "150407", "38.62561", "-9.03043", "Europe/Lisbon"),("2263438", "Santo André", "", "PT", "620", "", "16", "1213", "121302", "39.05532", "-8.24414", "Europe/Lisbon"),("2263439", "Santo André", "", "PT", "620", "", "19", "1509", "150907", "38.05445", "-8.75211", "Europe/Lisbon"),("2263458", "Santiago do Cacém", "", "PT", "620", "", "19", "1509", "150906", "38.01693", "-8.69475", "Europe/Lisbon"),("2263480", "Santarém", "Сантарен", "PT", "620", "", "18", "1416", "141612", "39.23333", "-8.68333", "Europe/Lisbon"),("2263491", "Santana", "", "PT", "620", "", "10", "3109", "310903", "32.8", "-16.88333", "Atlantic/Madeira"),("2263523", "Santa Iria da Azóia", "", "PT", "620", "", "14", "1107", "110713", "38.84629", "-9.08748", "Europe/Lisbon"),("2263540", "Santa Cruz", "", "PT", "620", "", "10", "3108", "310805", "32.68333", "-16.8", "Atlantic/Madeira"),("2263586", "Samora Correia", "", "PT", "620", "", "18", "1405", "140502", "38.93709", "-8.87178", "Europe/Lisbon"),("2263596", "Salvaterra de Magos", "", "PT", "620", "", "18", "1415", "141504", "39.02788", "-8.7935", "Europe/Lisbon"),("2263667", "Sacavém", "Сакавен", "PT", "620", "", "14", "1107", "110712", "38.79202", "-9.10801", "Europe/Lisbon"),("2263823", "Rio Maior", "", "PT", "620", "", "18", "1414", "141408", "39.33732", "-8.93906", "Europe/Lisbon"),("2263827", "Rio de Mouro", "", "PT", "620", "", "14", "1111", "111108", "38.77457", "-9.3276", "Europe/Lisbon"),("2263905", "Ribeira Brava", "", "PT", "620", "", "10", "", "", "32.65", "-17.06667", "Atlantic/Madeira"),("2263923", "Riachos", "", "PT", "620", "", "18", "1419", "141910", "39.44472", "-8.5142", "Europe/Lisbon"),("2263974", "Reguengos de Monsaraz", "", "PT", "620", "", "08", "0711", "071104", "38.42529", "-7.53494", "Europe/Lisbon"),("2264009", "Redondo", "", "PT", "620", "", "08", "0710", "071002", "38.64872", "-7.54708", "Europe/Lisbon"),("2264087", "Ramada", "", "PT", "620", "", "14", "1116", "111607", "38.80235", "-9.19216", "Europe/Lisbon"),("2264169", "Quinta do Anjo", "", "PT", "620", "", "19", "1508", "150804", "38.56753", "-8.94228", "Europe/Lisbon"),("2264268", "Queluz", "Келуш", "PT", "620", "", "14", "1111", "111107", "38.75657", "-9.25451", "Europe/Lisbon"),("2264270", "Quejas", "", "PT", "620", "", "14", "1110", "111010", "38.72236", "-9.26593", "Europe/Lisbon"),("2264299", "Quarteira", "", "PT", "620", "", "09", "0808", "080805", "37.06946", "-8.10064", "Europe/Lisbon"),("2264341", "Pragal", "", "PT", "620", "", "19", "1503", "150307", "38.67459", "-9.16981", "Europe/Lisbon"),("2264357", "Póvoa de Santo Adrião", "", "PT", "620", "", "14", "1116", "111606", "38.8", "-9.16667", "Europe/Lisbon"),("2264359", "Póvoa de Santa Iria", "Повуа-де-Санта-Ирия", "PT", "620", "", "14", "1114", "111406", "38.86101", "-9.06453", "Europe/Lisbon"),("2264403", "Porto Salvo", "", "PT", "620", "", "14", "1110", "111009", "38.71745", "-9.29833", "Europe/Lisbon"),("2264427", "Porto de Mós", "", "PT", "620", "", "13", "1016", "101611", "39.60191", "-8.81839", "Europe/Lisbon"),("2264456", "Portimão", "Портимао", "PT", "620", "", "09", "0811", "081103", "37.13856", "-8.53775", "Europe/Lisbon"),("2264508", "Portalegre", "Порталегре", "PT", "620", "", "16", "1214", "121408", "39.29379", "-7.43122", "Europe/Lisbon"),("2264526", "Pontinha", "", "PT", "620", "", "14", "1116", "111605", "38.76771", "-9.19935", "Europe/Lisbon"),("2264538", "Ponte de Sôr", "", "PT", "620", "", "16", "1213", "121303", "39.24964", "-8.01009", "Europe/Lisbon"),("2264575", "Pombal", "Помбал", "PT", "620", "", "13", "1015", "101509", "39.91674", "-8.62847", "Europe/Lisbon"),("2264718", "Pinhal Novo", "", "PT", "620", "", "19", "1508", "150803", "38.63106", "-8.91376", "Europe/Lisbon"),("2264736", "Piedade", "", "PT", "620", "", "19", "1503", "150310", "38.66667", "-9.15", "Europe/Lisbon"),("2264923", "Peniche", "", "PT", "620", "", "13", "1014", "101403", "39.3558", "-9.38112", "Europe/Lisbon"),("2265120", "Pataias", "", "PT", "620", "", "13", "1001", "100110", "39.66978", "-8.9958", "Europe/Lisbon"),("2265169", "Parede", "", "PT", "620", "", "14", "1105", "110505", "38.69282", "-9.35412", "Europe/Lisbon"),("2265223", "Palmela", "", "PT", "620", "", "19", "1508", "150802", "38.56902", "-8.90126", "Europe/Lisbon"),("2265326", "Paço de Arcos", "", "PT", "620", "", "14", "1110", "111005", "38.69569", "-9.29143", "Europe/Lisbon"),("2265388", "Ourém", "", "PT", "620", "", "18", "1421", "142111", "39.64167", "-8.5919", "Europe/Lisbon"),("2265422", "Olival do Basto", "", "PT", "620", "", "14", "1116", "111604", "38.79079", "-9.16621", "Europe/Lisbon"),("2265447", "Olhão", "", "PT", "620", "", "09", "0810", "081003", "37.0286", "-7.8411", "Europe/Lisbon"),("2265467", "Odivelas", "", "PT", "620", "", "14", "1116", "111603", "38.79269", "-9.1838", "Europe/Lisbon"),("2265472", "Odemira", "", "PT", "620", "", "03", "0211", "021108", "37.59798", "-8.63972", "Europe/Lisbon"),("2265485", "Óbidos", "", "PT", "620", "", "13", "1012", "101205", "39.36055", "-9.1567", "Europe/Lisbon"),("2265494", "Nossa Senhora do Monte", "", "PT", "620", "", "10", "3103", "310302", "32.66667", "-16.9", "Atlantic/Madeira"),("2265552", "Nazaré", "", "PT", "620", "", "13", "1011", "101102", "39.60289", "-9.06836", "Europe/Lisbon"),("2265686", "Moura", "", "PT", "620", "", "03", "0210", "021004", "38.1401", "-7.44856", "Europe/Lisbon"),("2265726", "Moscavide", "", "PT", "620", "", "14", "1107", "110709", "38.77929", "-9.10222", "Europe/Lisbon"),("2265788", "Montijo", "Монтихо", "PT", "620", "", "19", "1507", "150702", "38.70675", "-8.97388", "Europe/Lisbon"),("2265888", "Montemor-o-Novo", "", "PT", "620", "", "08", "0706", "070603", "38.64812", "-8.21455", "Europe/Lisbon"),("2265927", "Monte Estoril", "", "PT", "620", "", "14", "1105", "110503", "38.70279", "-9.41606", "Europe/Lisbon"),("2266249", "Monsanto", "Монсанто", "PT", "620", "", "18", "1402", "140208", "39.46203", "-8.7118", "Europe/Lisbon"),("2266268", "Monchique", "", "PT", "620", "", "09", "0809", "080903", "37.31775", "-8.55529", "Europe/Lisbon"),("2266272", "Moncarapacho", "", "PT", "620", "", "09", "0810", "081002", "37.08863", "-7.78722", "Europe/Lisbon"),("2266319", "Moita", "", "PT", "620", "", "19", "1506", "150603", "38.65078", "-8.99038", "Europe/Lisbon"),("2266411", "Milharado", "", "PT", "620", "", "14", "1109", "110911", "38.94732", "-9.19914", "Europe/Lisbon"),("2266702", "Marinhais", "", "PT", "620", "", "18", "1415", "141502", "39.0473", "-8.70236", "Europe/Lisbon"),("2266703", "Marinha Grande", "", "PT", "620", "", "13", "1010", "101001", "39.74769", "-8.93228", "Europe/Lisbon"),("2266865", "Mafra", "", "PT", "620", "", "14", "1109", "110909", "38.93793", "-9.32756", "Europe/Lisbon"),("2266895", "Machico", "", "PT", "620", "", "10", "3104", "", "32.7", "-16.76667", "Atlantic/Madeira"),("2266914", "Maceira", "", "PT", "620", "", "13", "1009", "100913", "39.68853", "-8.89423", "Europe/Lisbon"),("2266961", "Lourinhã", "", "PT", "620", "", "14", "1108", "110811", "39.23333", "-9.31667", "Europe/Lisbon"),("2266974", "Louriçal", "", "PT", "620", "", "13", "1015", "101506", "40.0039", "-8.73736", "Europe/Lisbon");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("2266977", "Loures", "", "PT", "620", "", "14", "1107", "110707", "38.83091", "-9.16845", "Europe/Lisbon"),("2266988", "Loulé", "Лола", "PT", "620", "", "09", "0808", "080808", "37.13772", "-8.01968", "Europe/Lisbon"),("2267057", "Lisbon", "Лиссабон", "PT", "620", "", "14", "1106", "110653", "38.71667", "-9.13333", "Europe/Lisbon"),("2267067", "Linda-a-Velha", "", "PT", "620", "", "14", "1110", "111008", "38.71446", "-9.2422", "Europe/Lisbon"),("2267095", "Leiria", "Лейрия", "PT", "620", "", "13", "1009", "100912", "39.74362", "-8.80705", "Europe/Lisbon"),("2267131", "Laranjeiro", "", "PT", "620", "", "09", "0810", "081002", "37.06831", "-7.7937", "Europe/Lisbon"),("2267226", "Lagos", "", "PT", "620", "", "09", "0807", "080706", "37.10202", "-8.67422", "Europe/Lisbon"),("2267254", "Lagoa", "", "PT", "620", "", "09", "0806", "080603", "37.13535", "-8.45319", "Europe/Lisbon"),("2267538", "Grândola", "", "PT", "620", "", "19", "1505", "150502", "38.17718", "-8.56675", "Europe/Lisbon"),("2267827", "Funchal", "Фуншал", "PT", "620", "", "10", "3103", "310309", "32.66568", "-16.92547", "Atlantic/Madeira"),("2268250", "Ferreiras", "", "PT", "620", "", "09", "0801", "080104", "37.12926", "-8.23759", "Europe/Lisbon"),("2268313", "Fazendas de Almeirim", "", "PT", "620", "", "18", "1403", "140303", "39.17553", "-8.56927", "Europe/Lisbon"),("2268326", "Fátima", "", "PT", "620", "", "18", "1421", "142106", "39.62071", "-8.65237", "Europe/Lisbon"),("2268339", "Faro", "Фару", "PT", "620", "", "09", "0805", "080505", "37.01937", "-7.93223", "Europe/Lisbon"),("2268358", "Famões", "", "PT", "620", "", "14", "1116", "111602", "38.78804", "-9.21033", "Europe/Lisbon"),("2268406", "Évora", "Эвора", "PT", "620", "PT", "08", "0705", "070521", "38.56667", "-7.9", "Europe/Lisbon"),("2268411", "Estremoz", "", "PT", "620", "", "08", "0704", "070406", "38.84432", "-7.58585", "Europe/Lisbon"),("2268436", "Estoril", "Эшторил", "PT", "620", "PT", "14", "1105", "110504", "38.70571", "-9.39773", "Europe/Lisbon"),("2268437", "Estômbar", "", "PT", "620", "", "09", "0806", "080601", "37.14629", "-8.48505", "Europe/Lisbon"),("2268563", "Ericeira", "", "PT", "620", "", "14", "1109", "110906", "38.96275", "-9.41563", "Europe/Lisbon"),("2268575", "Entroncamento", "", "PT", "620", "", "18", "1410", "141001", "39.46667", "-8.46667", "Europe/Lisbon"),("2268615", "Elvas", "", "PT", "620", "", "16", "1207", "120702", "38.8815", "-7.16282", "Europe/Lisbon"),("2268916", "Costa de Caparica", "", "PT", "620", "", "19", "1503", "150303", "38.64458", "-9.23556", "Europe/Lisbon"),("2268946", "Coruche", "", "PT", "620", "", "18", "1409", "140901", "38.95955", "-8.52524", "Europe/Lisbon"),("2269041", "Corroios", "", "PT", "620", "", "19", "1510", "151005", "38.64502", "-9.14843", "Europe/Lisbon"),("2269142", "Colares", "", "PT", "620", "", "14", "1111", "111105", "38.79921", "-9.44691", "Europe/Lisbon"),("2269282", "Charneca", "Шарнека", "PT", "620", "", "19", "1503", "150309", "38.62059", "-9.19149", "Europe/Lisbon"),("2269496", "Castro Marim", "", "PT", "620", "", "09", "0804", "080402", "37.22068", "-7.4435", "Europe/Lisbon"),("2269514", "Castelo Branco", "Каштелу-Бранку", "PT", "620", "", "06", "0502", "050205", "39.82219", "-7.49087", "Europe/Lisbon"),("2269556", "Castanheira do Ribatejo", "", "PT", "620", "", "14", "1114", "111405", "38.99298", "-8.97346", "Europe/Lisbon"),("2269594", "Cascais", "Кашкайш", "PT", "620", "", "14", "1105", "110503", "38.6979", "-9.42146", "Europe/Lisbon"),("2270023", "Cartaxo", "", "PT", "620", "", "18", "1406", "140601", "39.16022", "-8.78741", "Europe/Lisbon"),("2270084", "Carregado", "", "PT", "620", "", "14", "1101", "110115", "39.02362", "-8.97692", "Europe/Lisbon"),("2270157", "Carnaxide", "Карнашиде", "PT", "620", "", "14", "1110", "111003", "38.72706", "-9.24671", "Europe/Lisbon"),("2270184", "Carcavelos", "", "PT", "620", "", "14", "1110", "111004", "38.69105", "-9.32215", "Europe/Lisbon"),("2270211", "Caranguejeira", "", "PT", "620", "", "13", "1009", "100907", "39.74619", "-8.7074", "Europe/Lisbon"),("2270229", "Caparica", "", "PT", "620", "", "19", "1503", "150302", "38.66667", "-9.2", "Europe/Lisbon"),("2270258", "Caniço", "", "PT", "620", "", "10", "", "", "32.63333", "-16.85", "Atlantic/Madeira"),("2270290", "Caneças", "", "PT", "620", "", "14", "1116", "111601", "38.81321", "-9.22679", "Europe/Lisbon"),("2270336", "Campo Maior", "", "PT", "620", "", "16", "1204", "120403", "39.01774", "-7.06497", "Europe/Lisbon"),("2270377", "Camarate", "Камарате", "PT", "620", "", "14", "1107", "110703", "38.80358", "-9.12809", "Europe/Lisbon"),("2270380", "Câmara de Lobos", "Камара-де-Лобос", "PT", "620", "", "10", "", "", "32.63333", "-16.96667", "Atlantic/Madeira"),("2270385", "Camacha", "", "PT", "620", "", "10", "3201", "320101", "33.08665", "-16.34253", "Atlantic/Madeira"),("2270386", "Camacha", "", "PT", "620", "", "10", "3108", "310802", "32.67919", "-16.84462", "Atlantic/Madeira"),("2270437", "Caldas da Rainha", "Калдаш-да-Раинья", "PT", "620", "", "13", "1006", "100603", "39.40326", "-9.13839", "Europe/Lisbon"),("2270486", "Cacilhas", "", "PT", "620", "", "19", "1503", "150306", "38.68773", "-9.14663", "Europe/Lisbon"),("2270503", "Cacém", "", "PT", "620", "", "14", "1111", "111118", "38.76698", "-9.29793", "Europe/Lisbon"),("2270770", "Bombarral", "", "PT", "620", "", "13", "1005", "100501", "39.26723", "-9.15795", "Europe/Lisbon"),("2270813", "Bobadela", "", "PT", "620", "", "14", "1107", "110722", "38.80774", "-9.09925", "Europe/Lisbon"),("2270935", "Benedita", "", "PT", "620", "", "13", "1001", "100105", "39.4247", "-8.96996", "Europe/Lisbon"),("2270940", "Benavente", "", "PT", "620", "", "18", "1405", "140501", "38.97919", "-8.80759", "Europe/Lisbon"),("2270981", "Belas", "", "PT", "620", "", "14", "1111", "111104", "38.77721", "-9.26078", "Europe/Lisbon"),("2270985", "Beja", "", "PT", "620", "", "03", "0205", "020511", "38.01506", "-7.86323", "Europe/Lisbon"),("2271006", "Batalha", "", "PT", "620", "", "13", "1004", "100401", "39.66025", "-8.82475", "Europe/Lisbon"),("2271071", "Barreiro", "Баррейру", "PT", "620", "", "19", "1504", "150401", "38.66314", "-9.0724", "Europe/Lisbon"),("2271140", "Barcarena", "", "PT", "620", "", "14", "1110", "111002", "38.73245", "-9.28", "Europe/Lisbon"),("2271337", "Azambuja", "", "PT", "620", "", "14", "1103", "110304", "39.07029", "-8.86822", "Europe/Lisbon"),("2271354", "Atouguia da Baleia", "", "PT", "620", "", "13", "1014", "101402", "39.33814", "-9.3263", "Europe/Lisbon"),("2271438", "Arruda dos Vinhos", "", "PT", "620", "", "14", "1102", "110202", "38.98411", "-9.07746", "Europe/Lisbon"),("2271473", "Arrentela", "Аррентела", "PT", "620", "", "19", "1510", "151003", "38.61667", "-9.1", "Europe/Lisbon"),("2271623", "Apelação", "", "PT", "620", "", "14", "1107", "110701", "38.81387", "-9.13225", "Europe/Lisbon"),("2271680", "Amora", "", "PT", "620", "", "19", "1510", "151002", "38.62961", "-9.11557", "Europe/Lisbon"),("2271772", "Amadora", "Амадора", "PT", "620", "", "14", "1115", "111507", "38.75382", "-9.23083", "Europe/Lisbon"),("2271782", "Alvor", "", "PT", "620", "", "09", "0811", "081101", "37.12994", "-8.59174", "Europe/Lisbon"),("2271878", "Alpiarça", "", "PT", "620", "", "18", "1404", "140401", "39.25712", "-8.58187", "Europe/Lisbon"),("2271926", "Almeirim", "", "PT", "620", "", "18", "1403", "140301", "39.20903", "-8.61643", "Europe/Lisbon"),("2271945", "Almargem", "", "PT", "620", "", "14", "1111", "111103", "38.84485", "-9.27315", "Europe/Lisbon"),("2271947", "Almancil", "", "PT", "620", "", "09", "0808", "080801", "37.08686", "-8.03074", "Europe/Lisbon"),("2271961", "Almada", "Алмада", "PT", "620", "", "19", "1503", "150301", "38.67902", "-9.1569", "Europe/Lisbon"),("2271965", "Aljustrel", "", "PT", "620", "", "03", "0201", "020101", "37.87759", "-8.16516", "Europe/Lisbon"),("2271966", "Aljubarrota", "", "PT", "620", "", "13", "1001", "100111", "39.56715", "-8.92925", "Europe/Lisbon"),("2271970", "Alhos Vedros", "", "PT", "620", "", "19", "1506", "150601", "38.65486", "-9.02368", "Europe/Lisbon"),("2271975", "Alhandra", "", "PT", "620", "", "14", "1114", "111401", "38.92732", "-9.00864", "Europe/Lisbon"),("2271985", "Algés", "", "PT", "620", "", "14", "1110", "111006", "38.70245", "-9.22936", "Europe/Lisbon"),("2272036", "Alenquer", "", "PT", "620", "", "14", "1101", "110111", "39.05315", "-9.00928", "Europe/Lisbon"),("2272091", "Aldeia de Paio Pires", "", "PT", "620", "", "19", "1510", "151001", "38.61667", "-9.08333", "Europe/Lisbon"),("2272144", "Alcochete", "", "PT", "620", "", "19", "1502", "150201", "38.75534", "-8.96086", "Europe/Lisbon"),("2272147", "Alcobaça", "", "PT", "620", "", "13", "1001", "100101", "39.55223", "-8.97749", "Europe/Lisbon"),("2272190", "Alcanede", "", "PT", "620", "", "18", "1416", "141604", "39.41501", "-8.82189", "Europe/Lisbon"),("2272197", "Alcains", "", "PT", "620", "", "11", "", "", "39.91642", "-7.45655", "Europe/Lisbon"),("2272212", "Alcácer do Sal", "", "PT", "620", "", "19", "1501", "150101", "38.37326", "-8.51444", "Europe/Lisbon"),("2272215", "Alcabideche", "Алкабидеше", "PT", "620", "", "14", "1105", "110501", "38.73366", "-9.40928", "Europe/Lisbon"),("2272222", "Albufeira", "", "PT", "620", "", "09", "0801", "080101", "37.08819", "-8.2503", "Europe/Lisbon"),("2272379", "A dos Cunhados", "", "PT", "620", "", "14", "1113", "111301", "39.15237", "-9.2972", "Europe/Lisbon"),("2272447", "Abrantes", "", "PT", "620", "", "18", "1401", "140113", "39.46667", "-8.2", "Europe/Lisbon"),("2732265", "Viseu", "Визеу", "PT", "620", "", "22", "1823", "182328", "40.66101", "-7.90971", "Europe/Lisbon"),("2732312", "Vilela", "", "PT", "620", "", "21", "1710", "171007", "41.22511", "-7.60338", "Europe/Lisbon"),("2732438", "Vila Real", "Вила-Реал", "PT", "620", "", "21", "1714", "171424", "41.30062", "-7.74413", "Europe/Lisbon"),("2732444", "Vilar do Paraíso", "", "PT", "620", "", "17", "1317", "131724", "41.08974", "-8.6211", "Europe/Lisbon"),("2732475", "Vilar de Andorinho", "", "PT", "620", "", "17", "1317", "131710", "41.10751", "-8.59632", "Europe/Lisbon"),("2732544", "Vila Nova de Gaia", "Вила-Нова-де-Гайя", "PT", "620", "", "17", "1317", "131716", "41.13363", "-8.61742", "Europe/Lisbon"),("2732547", "Vila Nova de Famalicão", "", "PT", "620", "", "04", "0312", "031248", "41.40797", "-8.51978", "Europe/Lisbon"),("2732551", "Vila Nova da Telha", "", "PT", "620", "", "17", "1317", "131707", "41.0717", "-8.64146", "Europe/Lisbon"),("2732649", "Vila do Conde", "Вила-ду-Конде", "PT", "620", "", "17", "1316", "131628", "41.35481", "-8.7434", "Europe/Lisbon"),("2732773", "Viana do Castelo", "", "PT", "620", "", "20", "1609", "160919", "41.69323", "-8.83287", "Europe/Lisbon"),("2732978", "Valongo", "Валонгу", "PT", "620", "", "17", "1315", "131505", "41.19501", "-8.51027", "Europe/Lisbon"),("2732980", "Valongo", "", "PT", "620", "", "02", "0101", "010119", "40.61667", "-8.45", "Europe/Lisbon"),("2733038", "Válega", "", "PT", "620", "", "02", "0115", "011507", "40.83629", "-8.58061", "Europe/Lisbon"),("2733153", "Vale de Cambra", "", "PT", "620", "", "02", "0119", "011908", "40.8497", "-8.39389", "Europe/Lisbon"),("2733249", "Valbom", "", "PT", "620", "", "17", "1304", "130411", "41.13247", "-8.56414", "Europe/Lisbon"),("2733262", "Valadares", "", "PT", "620", "", "17", "1302", "130219", "41.14737", "-7.9812", "Europe/Lisbon"),("2733304", "Urgeses", "", "PT", "620", "", "04", "0308", "030871", "41.4272", "-8.29796", "Europe/Lisbon"),("2733533", "Tondela", "", "PT", "620", "", "22", "1821", "182123", "40.51682", "-8.08087", "Europe/Lisbon"),("2733660", "Tavarede", "", "PT", "620", "", "07", "0605", "060512", "40.17079", "-8.84566", "Europe/Lisbon"),("2733851", "Soure", "", "PT", "620", "", "07", "0615", "061509", "40.05989", "-8.62605", "Europe/Lisbon"),("2733941", "Sobrado", "", "PT", "620", "", "17", "1315", "131504", "41.21041", "-8.45488", "Europe/Lisbon"),("2733992", "Silvalde", "", "PT", "620", "", "02", "0107", "010705", "40.99397", "-8.62608", "Europe/Lisbon"),("2734028", "Serzedo", "", "PT", "620", "", "04", "0308", "030867", "41.40502", "-8.22926", "Europe/Lisbon"),("2734106", "Sequeira", "", "PT", "620", "", "11", "0907", "090755", "40.55364", "-7.22594", "Europe/Lisbon"),("2734140", "Senhora da Hora", "", "PT", "620", "", "17", "1308", "130810", "41.18641", "-8.65172", "Europe/Lisbon"),("2734170", "Selho", "", "PT", "620", "", "04", "0308", "030850", "41.41938", "-8.34599", "Europe/Lisbon"),("2734215", "Seia", "", "PT", "620", "", "11", "0912", "091220", "40.4151", "-7.70859", "Europe/Lisbon"),("2734338", "São Roque", "", "PT", "620", "", "02", "0113", "011318", "40.87216", "-8.47149", "Europe/Lisbon"),("2734339", "São Romão do Coronado", "", "PT", "620", "", "17", "1318", "131805", "41.28544", "-8.5632", "Europe/Lisbon"),("2734363", "São Pedro da Cova", "", "PT", "620", "", "17", "1304", "130410", "41.15508", "-8.50412", "Europe/Lisbon"),("2734395", "São Miguel do Couto", "", "PT", "620", "", "17", "1314", "131427", "41.33167", "-8.46185", "Europe/Lisbon"),("2734434", "São Mamede de Infesta", "Сан-Мамед-де-Инфешта", "PT", "620", "", "17", "1308", "130809", "41.20042", "-8.60251", "Europe/Lisbon"),("2734473", "São João de Ver", "", "PT", "620", "", "02", "0109", "010926", "40.95527", "-8.55117", "Europe/Lisbon"),("2734484", "São João da Madeira", "Сан-Жуан-да-Мадейра", "PT", "620", "", "02", "0116", "011601", "40.90229", "-8.48969", "Europe/Lisbon"),("2734493", "São João", "", "PT", "620", "", "02", "0115", "011508", "40.86802", "-8.60672", "Europe/Lisbon"),("2734523", "São Félix da Marinha", "", "PT", "620", "", "17", "1317", "131717", "41.03555", "-8.62259", "Europe/Lisbon"),("2734570", "Santo Tirso", "", "PT", "620", "", "17", "1314", "131422", "41.34257", "-8.47746", "Europe/Lisbon"),("2734729", "Santa Cruz do Bispo", "", "PT", "620", "", "17", "1308", "130807", "41.2255", "-8.68361", "Europe/Lisbon"),("2734803", "Sandim", "", "PT", "620", "", "17", "1317", "131715", "41.03508", "-8.507", "Europe/Lisbon"),("2734809", "Sande", "", "PT", "620", "", "04", "0313", "031341", "41.7019", "-8.39246", "Europe/Lisbon"),("2735083", "Rio Tinto", "", "PT", "620", "", "17", "1304", "130408", "41.18259", "-8.55811", "Europe/Lisbon"),("2735116", "Rio de Loba", "", "PT", "620", "", "22", "1823", "182323", "40.66596", "-7.87781", "Europe/Lisbon"),("2735167", "Ribeirão", "", "PT", "620", "", "04", "0312", "031235", "41.36081", "-8.56774", "Europe/Lisbon"),("2735340", "Refojos de Basto", "", "PT", "620", "", "04", "0304", "030414", "41.51318", "-7.99517", "Europe/Lisbon"),("2735377", "Rebordosa", "", "PT", "620", "", "17", "1310", "131018", "41.22405", "-8.40669", "Europe/Lisbon"),("2735415", "Real", "", "PT", "620", "", "04", "0311", "031118", "41.63882", "-8.18098", "Europe/Lisbon"),("2735787", "Póvoa de Varzim", "Повуа-ди-Варзин", "PT", "620", "", "17", "1313", "131310", "41.38344", "-8.76364", "Europe/Lisbon"),("2735803", "Póvoa de Lanhoso", "", "PT", "620", "", "04", "0309", "030915", "41.57873", "-8.28197", "Europe/Lisbon"),("2735943", "Porto", "Порту", "PT", "620", "", "17", "1312", "131212", "41.14961", "-8.61099", "Europe/Lisbon"),("2736041", "Ponte de Lima", "Понте де Лима", "PT", "620", "", "20", "1607", "160735", "41.76719", "-8.58393", "Europe/Lisbon"),("2736067", "Ponte", "", "PT", "620", "", "04", "0308", "030838", "41.47057", "-8.3299", "Europe/Lisbon"),("2736124", "Poiares", "", "PT", "620", "", "07", "0617", "061703", "40.21026", "-8.25746", "Europe/Lisbon"),("2736316", "Peso da Régua", "", "PT", "620", "", "21", "1708", "170807", "41.16491", "-7.78703", "Europe/Lisbon"),("2736327", "Perozinho", "", "PT", "620", "", "17", "1317", "131714", "41.06513", "-8.58531", "Europe/Lisbon"),("2736391", "Perafita", "", "PT", "620", "", "17", "1311", "131109", "41.18252", "-8.2545", "Europe/Lisbon"),("2736469", "Penafiel", "", "PT", "620", "", "17", "1311", "131124", "41.20835", "-8.28285", "Europe/Lisbon"),("2736520", "Pedrouços", "", "PT", "620", "", "17", "1306", "130617", "41.19315", "-8.58167", "Europe/Lisbon"),("2736521", "Pedroso", "", "PT", "620", "", "17", "1313", "131303", "41.41103", "-8.74897", "Europe/Lisbon"),("2736883", "Paços de Ferreira", "", "PT", "620", "", "17", "1309", "130912", "41.27657", "-8.37617", "Europe/Lisbon"),("2736930", "Ovar", "Овар", "PT", "620", "", "02", "0115", "011505", "40.85862", "-8.62513", "Europe/Lisbon"),("2737039", "Oliveira do Douro", "", "PT", "620", "", "17", "1317", "131712", "41.12466", "-8.58463", "Europe/Lisbon"),("2737042", "Oliveira do Bairro", "", "PT", "620", "", "02", "0114", "011404", "40.5146", "-8.49386", "Europe/Lisbon"),("2737046", "Oliveira de Azemeis", "", "PT", "620", "", "02", "0113", "011309", "40.84101", "-8.47555", "Europe/Lisbon"),("2737053", "Oliveira", "", "PT", "620", "", "04", "0303", "030348", "41.47819", "-8.46965", "Europe/Lisbon"),("2737064", "Olival", "", "PT", "620", "", "17", "1317", "131711", "41.05024", "-8.54416", "Europe/Lisbon"),("2737088", "Oiã", "", "PT", "620", "", "02", "0114", "011403", "40.54264", "-8.53856", "Europe/Lisbon"),("2737137", "Nogueira da Regedoura", "", "PT", "620", "", "02", "0109", "010917", "41.0053", "-8.59195", "Europe/Lisbon"),("2737194", "Negrelos", "", "PT", "620", "", "17", "1314", "131430", "41.34946", "-8.40145", "Europe/Lisbon"),("2737268", "Mozelos", "", "PT", "620", "", "20", "1601", "160104", "41.86774", "-8.39776", "Europe/Lisbon"),("2737393", "Moreira de Conegos", "", "PT", "620", "", "04", "0308", "030831", "41.3868", "-8.3394", "Europe/Lisbon"),("2737399", "Moreira", "", "PT", "620", "", "17", "1304", "130407", "41.056", "-8.38939", "Europe/Lisbon"),("2737523", "Monção", "", "PT", "620", "PT", "20", "1604", "160417", "42.07892", "-8.48076", "Europe/Madrid"),("2737639", "Mirandela", "", "PT", "620", "", "05", "0407", "040721", "41.48739", "-7.18695", "Europe/Lisbon"),("2737641", "Miranda do Corvo", "", "PT", "620", "", "07", "0609", "060902", "40.09318", "-8.33261", "Europe/Lisbon"),("2737651", "Mira", "", "PT", "620", "", "07", "0608", "060801", "40.42892", "-8.73746", "Europe/Lisbon"),("2737810", "Meadela", "", "PT", "620", "", "20", "1609", "160917", "41.70654", "-8.79628", "Europe/Lisbon"),("2737824", "Matosinhos", "Матозиньюш", "PT", "620", "", "17", "1308", "130806", "41.18207", "-8.68908", "Europe/Lisbon"),("2737904", "Marinhas", "", "PT", "620", "", "04", "0306", "030612", "41.55906", "-8.78297", "Europe/Lisbon"),("2737914", "Margaride", "", "PT", "620", "", "17", "1303", "130320", "41.36829", "-8.20072", "Europe/Lisbon"),("2737949", "Mangualde", "", "PT", "620", "", "22", "1806", "180610", "40.60425", "-7.76115", "Europe/Lisbon"),("2738014", "Maia", "Майя", "PT", "620", "", "17", "1306", "130615", "41.23574", "-8.6199", "Europe/Lisbon"),("2738038", "Madalena", "", "PT", "620", "", "17", "1310", "131015", "41.21616", "-8.33451", "Europe/Lisbon"),("2738082", "Macedo de Cavaleiros", "", "PT", "620", "", "05", "0405", "040520", "41.53816", "-6.9611", "Europe/Lisbon"),("2738154", "Lousã", "", "PT", "620", "", "07", "0607", "060703", "40.11673", "-8.24921", "Europe/Lisbon"),("2738159", "Lourosa", "", "PT", "620", "", "02", "0109", "010913", "40.9842", "-8.55142", "Europe/Lisbon"),("2738224", "Lordelo", "", "PT", "620", "", "17", "1310", "131013", "41.23451", "-8.40297", "Europe/Lisbon"),("2738277", "Lobão", "", "PT", "620", "", "02", "0109", "010911", "40.98664", "-8.48566", "Europe/Lisbon"),("2738347", "Leça do Bailio", "", "PT", "620", "", "17", "1306", "130606", "41.21457", "-8.61348", "Europe/Lisbon"),("2738348", "Leça da Palmeira", "", "PT", "620", "", "17", "1308", "130805", "41.191", "-8.70027", "Europe/Lisbon"),("2738360", "Lavra", "", "PT", "620", "", "17", "1308", "130803", "41.25935", "-8.71849", "Europe/Lisbon"),("2738459", "Lamego", "", "PT", "620", "", "22", "1805", "180501", "41.09741", "-7.80991", "Europe/Lisbon"),("2738479", "Lamas", "", "PT", "620", "", "02", "0109", "010925", "40.98597", "-8.56923", "Europe/Lisbon"),("2738643", "Jovim", "", "PT", "620", "", "17", "1304", "130404", "41.11102", "-8.51903", "Europe/Lisbon"),("2738658", "Joane", "", "PT", "620", "", "04", "0312", "031219", "41.43906", "-8.40846", "Europe/Lisbon"),("2738707", "Ílhavo", "", "PT", "620", "", "02", "0110", "011004", "40.5999", "-8.66732", "Europe/Lisbon"),("2738737", "Gulpilhares", "", "PT", "620", "", "17", "1317", "131724", "41.08292", "-8.62679", "Europe/Lisbon"),("2738752", "Guimarães", "Гимарайнш", "PT", "620", "", "04", "0308", "030860", "41.44443", "-8.29619", "Europe/Lisbon"),("2738766", "Guifões", "", "PT", "620", "", "17", "1308", "130802", "41.20039", "-8.66719", "Europe/Lisbon"),("2738785", "Guarda", "Гуарда", "PT", "620", "", "11", "0907", "090742", "40.53733", "-7.26575", "Europe/Lisbon"),("2738803", "Grijó", "", "PT", "620", "", "17", "1317", "131706", "41.02836", "-8.58017", "Europe/Lisbon"),("2738925", "Gondomar", "Гондомар", "PT", "620", "", "17", "1304", "130409", "41.14454", "-8.53223", "Europe/Lisbon"),("2739034", "Gemunde", "", "PT", "620", "", "17", "1306", "130604", "41.26766", "-8.64515", "Europe/Lisbon"),("2739080", "Gandra", "", "PT", "620", "", "17", "1310", "131011", "41.20116", "-8.43376", "Europe/Lisbon"),("2739118", "Galegos", "", "PT", "620", "", "04", "0302", "030268", "41.56268", "-8.57204", "Europe/Lisbon"),("2739152", "Gafanha da Nazaré", "", "PT", "620", "", "02", "0110", "011003", "40.63621", "-8.71338", "Europe/Lisbon"),("2739187", "Fundão", "", "PT", "620", "", "06", "0504", "050417", "40.14025", "-7.50135", "Europe/Lisbon"),("2739285", "Freamunde", "", "PT", "620", "", "17", "1309", "130908", "41.28835", "-8.33533", "Europe/Lisbon"),("2739333", "Foz do Sousa", "", "PT", "620", "", "17", "1304", "130403", "41.09668", "-8.50184", "Europe/Lisbon"),("2739590", "Figueira da Foz", "", "PT", "620", "", "07", "0605", "060511", "40.15085", "-8.86179", "Europe/Lisbon"),("2739613", "Fiães", "", "PT", "620", "", "02", "0109", "010907", "40.99446", "-8.52537", "Europe/Lisbon"),("2739636", "Ferreiros", "", "PT", "620", "", "04", "0312", "031235", "41.35", "-8.55", "Europe/Lisbon"),("2739723", "Feira", "", "PT", "620", "", "02", "0109", "010906", "40.92535", "-8.54277", "Europe/Lisbon"),("2739756", "Fânzeres", "", "PT", "620", "", "17", "1304", "130402", "41.17087", "-8.5257", "Europe/Lisbon"),("2739788", "Fafe", "Фафе", "PT", "620", "", "04", "0307", "030709", "41.45423", "-8.168", "Europe/Lisbon"),("2739848", "Esposende", "", "PT", "620", "", "04", "0306", "030605", "41.5361", "-8.78201", "Europe/Lisbon"),("2739849", "Esposende", "Эшпозенде", "PT", "620", "PT", "04", "0306", "030605", "41.53333", "-8.78333", "Europe/Lisbon"),("2739868", "Espinho", "", "PT", "620", "", "02", "0107", "010702", "41.00763", "-8.64125", "Europe/Lisbon"),("2739915", "Esmoriz", "", "PT", "620", "", "02", "0115", "011503", "40.95773", "-8.62753", "Europe/Lisbon"),("2739997", "Ermesinde", "Эрмезинде", "PT", "620", "", "17", "1315", "131503", "41.22176", "-8.55462", "Europe/Lisbon"),("2740031", "Eixo", "", "PT", "620", "", "02", "0105", "010504", "40.62758", "-8.56922", "Europe/Lisbon"),("2740159", "Darque", "", "PT", "620", "", "20", "1609", "160916", "41.68333", "-8.76667", "Europe/Lisbon"),("2740174", "Custoias", "", "PT", "620", "", "11", "0914", "091405", "41.1053", "-7.32097", "Europe/Lisbon"),("2740221", "Cucujães", "", "PT", "620", "", "02", "0113", "011319", "40.87413", "-8.50687", "Europe/Lisbon"),("2740313", "Covilhã", "Ковильян", "PT", "620", "", "06", "0503", "050307", "40.28601", "-7.50396", "Europe/Lisbon"),("2740637", "Coimbra", "Коимбра", "PT", "620", "", "07", "0603", "060325", "40.20564", "-8.41955", "Europe/Lisbon"),("2740761", "Chaves", "", "PT", "620", "", "21", "1703", "170350", "41.74019", "-7.46879", "Europe/Lisbon"),("2740992", "Castelões de Cepeda", "", "PT", "620", "", "17", "1310", "131007", "41.20265", "-8.33516", "Europe/Lisbon"),("2741405", "Carregal do Sal", "", "PT", "620", "", "22", "1802", "180203", "40.43333", "-8", "Europe/Lisbon"),("2741547", "Cantanhede", "", "PT", "620", "", "07", "0602", "060204", "40.34671", "-8.59419", "Europe/Lisbon"),("2741551", "Canidelo", "", "PT", "620", "", "17", "1317", "131704", "41.12402", "-8.65104", "Europe/Lisbon"),("2741566", "Canelas", "", "PT", "620", "", "17", "1317", "131703", "41.08333", "-8.6", "Europe/Lisbon"),("2741648", "Campo", "", "PT", "620", "", "17", "1315", "131502", "41.18516", "-8.46493", "Europe/Lisbon"),("2741724", "Calendário", "", "PT", "620", "", "04", "0312", "031208", "41.40361", "-8.52967", "Europe/Lisbon"),("2741728", "Caldelas", "", "PT", "620", "", "04", "0301", "030106", "41.67101", "-8.38148", "Europe/Lisbon"),("2741738", "Caldas de Vizela", "", "PT", "620", "", "04", "0314", "031403", "41.38212", "-8.3089", "Europe/Lisbon"),("2741961", "Buarcos", "", "PT", "620", "", "07", "0605", "060504", "40.16604", "-8.8768", "Europe/Lisbon"),("2741985", "Brito", "", "PT", "620", "", "04", "0308", "030807", "41.45821", "-8.36103", "Europe/Lisbon"),("2742024", "Branca", "", "PT", "620", "", "02", "0102", "010204", "40.76653", "-8.48262", "Europe/Lisbon"),("2742027", "Bragança", "Браганца", "PT", "620", "", "05", "0402", "040245", "41.80582", "-6.75719", "Europe/Lisbon"),("2742032", "Braga", "Брага", "PT", "620", "", "04", "0303", "030342", "41.55032", "-8.42005", "Europe/Lisbon"),("2742051", "Bougado", "", "PT", "620", "", "17", "1318", "131803", "41.33979", "-8.5518", "Europe/Lisbon"),("2742309", "Beduido", "", "PT", "620", "", "02", "0108", "010802", "40.76427", "-8.5611", "Europe/Lisbon"),("2742330", "Barrosas", "", "PT", "620", "", "17", "", "", "41.35534", "-8.29943", "Europe/Lisbon"),("2742416", "Barcelos", "Барселуш", "PT", "620", "", "04", "0302", "030209", "41.53876", "-8.61505", "Europe/Lisbon"),("2742506", "Baguim do Monte", "", "PT", "620", "", "17", "1304", "130412", "41.19392", "-8.54133", "Europe/Lisbon"),("2742557", "Azenha", "", "PT", "620", "", "17", "1317", "131707", "41.07651", "-8.62468", "Europe/Lisbon"),("2742565", "Avintes", "", "PT", "620", "", "17", "1317", "131702", "41.11747", "-8.54986", "Europe/Lisbon"),("2742577", "Aves", "", "PT", "620", "", "17", "1314", "131405", "41.37034", "-8.4101", "Europe/Lisbon"),("2742578", "Aver-o-Mar", "", "PT", "620", "", "17", "1313", "131301", "41.40778", "-8.78118", "Europe/Lisbon"),("2742611", "Aveiro", "Авейру", "PT", "620", "", "02", "0105", "010512", "40.64427", "-8.64554", "Europe/Lisbon"),("2742617", "Avanca", "", "PT", "620", "", "02", "0108", "010801", "40.80771", "-8.5722", "Europe/Lisbon"),("2742681", "Arrifana", "", "PT", "620", "", "02", "0109", "010902", "40.91565", "-8.49657", "Europe/Lisbon"),("2742750", "Argoncilhe", "", "PT", "620", "", "02", "0109", "010901", "41.02541", "-8.53885", "Europe/Lisbon"),("2742797", "Arcozelo", "", "PT", "620", "", "17", "1317", "131701", "41.05327", "-8.64326", "Europe/Lisbon"),("2742811", "Arcos", "", "PT", "620", "", "02", "0103", "010303", "40.44779", "-8.44171", "Europe/Lisbon"),("2742827", "Arazede", "", "PT", "620", "", "07", "0610", "061002", "40.28627", "-8.64999", "Europe/Lisbon"),("2742833", "Aradas", "", "PT", "620", "", "02", "0105", "010501", "40.62084", "-8.64195", "Europe/Lisbon"),("2742856", "Antas", "", "PT", "620", "", "04", "0310", "031009", "41.73644", "-8.30888", "Europe/Lisbon"),("2742868", "Anta", "", "PT", "620", "", "17", "1306", "130604", "41.26634", "-8.62844", "Europe/Lisbon"),("2742965", "Amarante", "", "PT", "620", "", "17", "1301", "130133", "41.27271", "-8.08245", "Europe/Lisbon"),("2743095", "Alfena", "", "PT", "620", "", "17", "1315", "131501", "41.23671", "-8.52454", "Europe/Lisbon"),("2743233", "Albergaria-a-Velha", "", "PT", "620", "", "02", "0102", "010201", "40.69318", "-8.47994", "Europe/Lisbon"),("2743292", "Águeda", "", "PT", "620", "", "02", "0101", "010104", "40.5772", "-8.44442", "Europe/Lisbon"),("2743304", "Águas Santas", "", "PT", "620", "", "17", "1306", "130608", "41.21061", "-8.5866", "Europe/Lisbon"),("2743428", "Abraveses", "", "PT", "620", "", "22", "1823", "182301", "40.68137", "-7.92102", "Europe/Lisbon"),("3372472", "Vila Franca do Campo", "", "PT", "620", "", "23", "4206", "420604", "37.71667", "-25.43333", "Atlantic/Azores"),("3372677", "Rosto de Cão", "", "PT", "620", "", "23", "4203", "420314", "37.75", "-25.65", "Atlantic/Azores"),("3372707", "Ribeira Grande", "", "PT", "620", "", "23", "", "", "38.51667", "-28.7", "Atlantic/Azores"),("3372745", "Rabo de Peixe", "", "PT", "620", "", "23", "4205", "420508", "37.8", "-25.58333", "Atlantic/Azores"),("3372760", "Praia da Vitória", "", "PT", "620", "", "23", "4302", "430207", "38.73333", "-27.06667", "Atlantic/Azores"),("3372783", "Ponta Delgada", "", "PT", "620", "", "23", "", "", "37.73333", "-25.66667", "Atlantic/Azores"),("3372908", "Madalena", "", "PT", "620", "PT", "23", "4602", "460204", "38.53642", "-28.5266", "Atlantic/Azores"),("3372964", "Lagoa", "", "PT", "620", "", "23", "4401", "440103", "39.05", "-27.98333", "Atlantic/Azores"),("3372988", "Horta", "", "PT", "620", "", "23", "4701", "470106", "38.53333", "-28.63333", "Atlantic/Azores"),("3373329", "Arrifes", "", "PT", "620", "", "23", "4203", "420301", "37.76667", "-25.7", "Atlantic/Azores"),("3373348", "Angra do Heroísmo", "", "PT", "620", "", "23", "4301", "", "38.65", "-27.21667", "Atlantic/Azores"),("6697257", "Valenza", "", "PT", "620", "", "20", "1608", "160815", "42.02418", "-8.63474", "Europe/Lisbon"),("289523", "Umm Şalāl Muḩammad", "", "QA", "634", "", "09", "", "", "25.41524", "51.40647", "Asia/Qatar"),("289524", "Umm Şalāl ‘Alī", "", "QA", "634", "", "09", "", "", "25.46972", "51.3975", "Asia/Qatar"),("289525", "Musay‘īd", "", "QA", "634", "", "10", "", "", "24.99226", "51.55067", "Asia/Qatar"),("289739", "Madīnat ash Shamāl", "", "QA", "634", "", "08", "", "", "26.12933", "51.2009", "Asia/Qatar"),("289813", "Dukhān", "", "QA", "634", "", "06", "", "", "25.42485", "50.78227", "Asia/Qatar"),("289847", "Az̧ Z̧a‘āyin", "", "QA", "634", "", "13", "", "", "25.57744", "51.48306", "Asia/Qatar"),("289877", "Ash Shayḩānīyah", "", "QA", "634", "", "06", "", "", "25.37088", "51.22264", "Asia/Qatar"),("289888", "Ar Rayyān", "", "QA", "634", "", "06", "", "", "25.29194", "51.42444", "Asia/Qatar"),("289913", "Al Wukayr", "", "QA", "634", "", "10", "", "", "25.15107", "51.53718", "Asia/Qatar"),("289915", "Al Wakrah", "", "QA", "634", "", "10", "", "", "25.17151", "51.60337", "Asia/Qatar"),("289962", "Al Khawr", "", "QA", "634", "", "04", "", "", "25.68389", "51.50583", "Asia/Qatar"),("290030", "Doha", "Доха", "QA", "634", "", "01", "", "", "25.27932", "51.52245", "Asia/Qatar"),("935146", "Les Trois-Bassins", "", "RE", "638", "", "RE", "974", "9744", "-21.1", "55.3", "Indian/Reunion"),("935210", "Salazie", "", "RE", "638", "", "RE", "974", "9743", "-21.02734", "55.539", "Indian/Reunion"),("935214", "Saint-Pierre", "Сент-Пьер", "RE", "638", "", "RE", "974", "9742", "-21.3393", "55.47811", "Indian/Reunion"),("935215", "Saint-Philippe", "", "RE", "638", "", "RE", "974", "9742", "-21.35852", "55.76795", "Indian/Reunion"),("935221", "Saint-Paul", "", "RE", "638", "", "RE", "974", "9744", "-21.00963", "55.27071", "Indian/Reunion"),("935223", "Saint-Louis", "Сен-Луи", "RE", "638", "", "RE", "974", "9742", "-21.28585", "55.41124", "Indian/Reunion"),("935225", "Saint-Leu", "Санкт-Леу", "RE", "638", "", "RE", "974", "9744", "-21.17059", "55.28824", "Indian/Reunion"),("935227", "Saint-Joseph", "Сент-Джозеф", "RE", "638", "", "RE", "974", "9742", "-21.37839", "55.61918", "Indian/Reunion"),("935248", "Sainte-Suzanne", "", "RE", "638", "", "RE", "974", "9741", "-20.90614", "55.60886", "Indian/Reunion"),("935251", "Sainte-Rose", "", "RE", "638", "", "RE", "974", "9743", "-21.12983", "55.79629", "Indian/Reunion"),("935255", "Sainte-Marie", "Сент-Мари", "RE", "638", "", "RE", "974", "9741", "-20.89684", "55.5496", "Indian/Reunion"),("935264", "Saint-Denis", "Сен-Дени", "RE", "638", "", "RE", "974", "9741", "-20.88231", "55.4504", "Indian/Reunion"),("935267", "Saint-Benoît", "Санкт-Бенуа", "RE", "638", "", "RE", "974", "9743", "-21.03801", "55.71937", "Indian/Reunion"),("935268", "Saint-André", "Санкт-Андре", "RE", "638", "", "RE", "974", "9743", "-20.96333", "55.65031", "Indian/Reunion"),("935416", "Petite-Île", "", "RE", "638", "", "RE", "974", "9742", "-21.35", "55.56667", "Indian/Reunion"),("935582", "Le Tampon", "Ле-Тампон", "RE", "638", "", "RE", "974", "9742", "-21.28309", "55.51802", "Indian/Reunion"),("935608", "Les Avirons", "", "RE", "638", "", "RE", "974", "9742", "-21.24181", "55.33938", "Indian/Reunion"),("935616", "Le Port", "", "RE", "638", "", "RE", "974", "9744", "-20.9373", "55.29189", "Indian/Reunion"),("935691", "La Possession", "", "RE", "638", "", "RE", "974", "9744", "-20.92892", "55.33513", "Indian/Reunion"),("935915", "Entre-Deux", "", "RE", "638", "", "RE", "974", "9742", "-21.23333", "55.46667", "Indian/Reunion"),("935975", "Cilaos", "", "RE", "638", "", "RE", "974", "9742", "-21.13357", "55.4719", "Indian/Reunion"),("936048", "Bras-Panon", "", "RE", "638", "", "RE", "974", "9743", "-20.99667", "55.67823", "Indian/Reunion"),("7932385", "Piton Saint-Leu", "", "RE", "638", "", "RE", "974", "9744", "-21.21962", "55.31513", "Indian/Reunion"),("662118", "Zvoriştea", "", "RO", "642", "", "34", "151344", "", "47.83333", "26.28333", "Europe/Bucharest"),("662130", "Zorleni", "", "RO", "642", "", "38", "167179", "", "46.26667", "27.71667", "Europe/Bucharest"),("662161", "Zlatna", "", "RO", "642", "", "01", "1936", "", "46.10633", "23.23162", "Europe/Bucharest"),("662187", "Zimnicea", "", "RO", "642", "", "35", "151978", "", "43.66667", "25.36667", "Europe/Bucharest"),("662217", "Zetea", "", "RO", "642", "", "20", "86366", "", "46.38333", "25.36667", "Europe/Bucharest"),("662225", "Zemeş", "", "RO", "642", "", "04", "26289", "", "46.58333", "26.41667", "Europe/Bucharest"),("662284", "Zărnești", "", "RO", "642", "RO", "09", "40492", "", "45.56093", "25.31787", "Europe/Bucharest"),("662285", "Zărneşti", "", "RO", "642", "", "11", "50415", "", "45.3", "26.86667", "Europe/Bucharest"),("662315", "Zăneşti", "", "RO", "642", "", "28", "125061", "", "46.81667", "26.55", "Europe/Bucharest"),("662334", "Zalău", "Залэу", "RO", "642", "", "31", "139704", "", "47.2", "23.05", "Europe/Bucharest"),("662352", "Zagon", "", "RO", "642", "", "15", "65011", "", "45.76667", "26.11667", "Europe/Bucharest"),("662379", "Vurpăr", "", "RO", "642", "", "01", "8826", "", "46", "23.46667", "Europe/Bucharest"),("662431", "Vulcan", "", "RO", "642", "", "09", "42398", "", "45.63333", "25.41667", "Europe/Bucharest"),("662432", "Vulcan", "", "RO", "642", "", "21", "87175", "", "45.38333", "23.26667", "Europe/Bucharest"),("662463", "Vorona Teodoru", "", "RO", "642", "", "07", "39872", "", "47.55", "26.6", "Europe/Bucharest"),("662476", "Voluntari", "Волунтари", "RO", "642", "", "43", "179551", "", "44.49002", "26.17338", "Europe/Bucharest"),("662478", "Volovăţ", "", "RO", "642", "", "34", "151120", "", "47.81667", "25.9", "Europe/Bucharest"),("662516", "Voineşti", "", "RO", "642", "", "23", "100219", "", "47.06667", "27.41667", "Europe/Bucharest"),("662521", "Voineşti", "", "RO", "642", "", "16", "69526", "", "45.06667", "25.25", "Europe/Bucharest"),("662570", "Vlăhiţa", "", "RO", "642", "", "20", "83749", "", "46.35", "25.51667", "Europe/Bucharest"),("662600", "Vladimirescu", "", "RO", "642", "", "02", "9397", "", "46.16628", "21.40102", "Europe/Bucharest"),("662651", "Viziru", "", "RO", "642", "", "08", "44505", "", "45.01667", "27.7", "Europe/Bucharest"),("662695", "Vişina", "", "RO", "642", "", "16", "69330", "", "44.58333", "25.33333", "Europe/Bucharest"),("662699", "Vişeu de Sus", "", "RO", "642", "", "25", "106979", "", "47.71667", "24.43333", "Europe/Bucharest"),("662702", "Vişeu de Jos", "", "RO", "642", "", "25", "109504", "", "47.72558", "24.36613", "Europe/Bucharest"),("662805", "Vânju-Mare", "", "RO", "642", "", "26", "110232", "", "44.42528", "22.86972", "Europe/Bucharest"),("662811", "Vinga", "", "RO", "642", "", "02", "12643", "", "46.01667", "21.2", "Europe/Bucharest"),("662822", "Vânători-Neamţ", "", "RO", "642", "", "28", "125016", "", "47.2", "26.31667", "Europe/Bucharest"),("662841", "Vânători", "", "RO", "642", "", "40", "178607", "", "45.73333", "27.25", "Europe/Bucharest"),("662918", "Viişoara", "", "RO", "642", "", "28", "123601", "", "46.93333", "26.23333", "Europe/Bucharest"),("662920", "Viişoara", "", "RO", "642", "", "13", "60062", "", "46.55", "23.91667", "Europe/Bucharest"),("662970", "Vidra", "", "RO", "642", "", "40", "178377", "", "45.91667", "26.9", "Europe/Bucharest"),("662971", "Vidra", "", "RO", "642", "", "43", "105936", "", "44.26056", "26.16972", "Europe/Bucharest"),("662976", "Videle", "", "RO", "642", "", "35", "151905", "", "44.27806", "25.52444", "Europe/Bucharest"),("662986", "Victoria", "", "RO", "642", "RO", "09", "40465", "", "45.72968", "24.7028", "Europe/Bucharest"),("662992", "Vicovu de Sus", "", "RO", "642", "", "34", "151095", "", "47.93333", "25.68333", "Europe/Bucharest"),("662994", "Vicovu de Jos", "", "RO", "642", "", "34", "151077", "", "47.9", "25.73333", "Europe/Bucharest"),("663035", "Verneşti", "", "RO", "642", "", "11", "50102", "", "45.21667", "26.73333", "Europe/Bucharest"),("663045", "Vereşti", "", "RO", "642", "", "34", "151022", "", "47.6", "26.43333", "Europe/Bucharest"),("663088", "Vedea", "", "RO", "642", "", "42", "105909", "", "43.78333", "25.78333", "Europe/Bucharest"),("663100", "Vatra Dornei", "", "RO", "642", "", "34", "146744", "", "47.35", "25.36667", "Europe/Bucharest"),("663118", "Vaslui", "Васлуй", "RO", "642", "", "38", "161945", "", "46.63333", "27.73333", "Europe/Bucharest"),("663128", "Vasilaţi", "", "RO", "642", "", "41", "105829", "", "44.28778", "26.4475", "Europe/Bucharest"),("663171", "Variaş", "", "RO", "642", "", "36", "159213", "", "46.01667", "20.95", "Europe/Bucharest"),("663178", "Vărbilău", "", "RO", "642", "", "30", "136134", "", "45.18333", "25.95", "Europe/Bucharest"),("663197", "Vărăşti", "", "RO", "642", "", "42", "105874", "", "44.23778", "26.24861", "Europe/Bucharest"),("663227", "Vama", "", "RO", "642", "", "34", "150935", "", "47.56667", "25.68333", "Europe/Bucharest"),("663234", "Valu lui Traian", "", "RO", "642", "", "14", "63125", "", "44.16667", "28.46667", "Europe/Bucharest"),("663256", "Vălenii de Munte", "", "RO", "642", "", "30", "131817", "", "45.18333", "26.03333", "Europe/Bucharest"),("663386", "Valea Stanciului", "", "RO", "642", "", "17", "74581", "", "43.98333", "23.86667", "Europe/Bucharest"),("663575", "Valea Moldovei", "", "RO", "642", "", "34", "150891", "", "47.46667", "26.03333", "Europe/Bucharest"),("663692", "Valea lui Mihai", "", "RO", "642", "", "05", "32027", "", "47.51667", "22.15", "Europe/Bucharest"),("663863", "Valea Călugărească", "", "RO", "642", "", "30", "135949", "", "44.96667", "26.15", "Europe/Bucharest"),("663996", "Vadu Paşii", "", "RO", "642", "", "11", "49956", "", "45.16667", "26.9", "Europe/Bucharest"),("664003", "Vadu Moldovei", "", "RO", "642", "", "34", "150766", "", "47.38333", "26.36667", "Europe/Bucharest"),("664041", "Văcăreşti", "", "RO", "642", "", "16", "69250", "", "44.85", "25.48333", "Europe/Bucharest"),("664074", "Urziceni", "", "RO", "642", "", "22", "100683", "", "44.71667", "26.63333", "Europe/Bucharest"),("664150", "Urlaţi", "", "RO", "642", "", "30", "131620", "", "44.98333", "26.23333", "Europe/Bucharest"),("664163", "Uricani", "", "RO", "642", "", "21", "87139", "", "45.33731", "23.1524", "Europe/Bucharest"),("664170", "Urecheşti", "", "RO", "642", "", "40", "178279", "", "45.6", "27.06667", "Europe/Bucharest"),("664215", "Ungureni-Jianu", "", "RO", "642", "", "07", "39417", "", "47.88333", "26.78333", "Europe/Bucharest"),("664271", "Ungheni", "", "RO", "642", "", "27", "119894", "", "46.48333", "24.46667", "Europe/Bucharest"),("664281", "Umbrăreşti", "", "RO", "642", "", "18", "77402", "", "45.71667", "27.46667", "Europe/Bucharest"),("664295", "Ulmi", "", "RO", "642", "", "42", "105623", "", "44.48667", "25.78028", "Europe/Bucharest"),("664311", "Ulmeni", "", "RO", "642", "", "25", "109265", "", "47.46667", "23.3", "Europe/Bucharest"),("664314", "Ulmeni", "", "RO", "642", "", "41", "105605", "", "44.15", "26.71667", "Europe/Bucharest"),("664372", "Udeşti", "", "RO", "642", "", "34", "150588", "", "47.56667", "26.41667", "Europe/Bucharest"),("664397", "Tuzla", "", "RO", "642", "", "14", "60721", "", "44", "28.63333", "Europe/Bucharest"),("664404", "Tutova", "", "RO", "642", "", "38", "166529", "", "46.11667", "27.55", "Europe/Bucharest"),("664432", "Turţ", "", "RO", "642", "", "32", "139170", "", "47.98333", "23.21667", "Europe/Bucharest"),("664437", "Turnu Măgurele", "", "RO", "642", "", "35", "151683", "", "43.75", "24.86667", "Europe/Bucharest"),("664460", "Turda", "Турда", "RO", "642", "", "13", "55259", "", "46.56667", "23.78333", "Europe/Bucharest"),("664475", "Turceni", "", "RO", "642", "", "19", "82617", "", "44.68333", "23.36667", "Europe/Bucharest"),("664505", "Tuluceşti", "", "RO", "642", "", "18", "77331", "", "45.56667", "28.03333", "Europe/Bucharest"),("664507", "Tulnici", "", "RO", "642", "", "40", "178117", "", "45.91667", "26.66667", "Europe/Bucharest"),("664518", "Tulcea", "Тулча", "RO", "642", "", "37", "159614", "", "45.16667", "28.8", "Europe/Bucharest"),("664539", "Tufeşti", "", "RO", "642", "", "08", "44300", "", "45.05", "27.81667", "Europe/Bucharest"),("664565", "Tudor Vladimirescu", "", "RO", "642", "", "18", "77313", "", "45.56667", "27.65", "Europe/Bucharest"),("664566", "Tudor Vladimirescu", "", "RO", "642", "", "08", "44257", "", "45.21667", "27.8", "Europe/Bucharest"),("664575", "Tudora", "", "RO", "642", "", "07", "39391", "", "47.51667", "26.63333", "Europe/Bucharest"),("664578", "Truşeşti", "", "RO", "642", "", "07", "39328", "", "47.76667", "27.01667", "Europe/Bucharest"),("664602", "Tritenii de Jos", "", "RO", "642", "", "13", "59693", "", "46.58333", "24", "Europe/Bucharest"),("664609", "Trifeşti", "", "RO", "642", "", "23", "99600", "", "47.45", "27.51667", "Europe/Bucharest"),("664610", "Trifeşti", "", "RO", "642", "", "28", "124723", "", "46.91667", "26.81667", "Europe/Bucharest"),("664722", "Topraisar", "", "RO", "642", "", "14", "63072", "", "44.01667", "28.45", "Europe/Bucharest"),("664729", "Topoloveni", "", "RO", "642", "", "03", "13757", "", "44.81667", "25.08333", "Europe/Bucharest"),("664819", "Tomeşti", "", "RO", "642", "", "23", "95293", "", "47.11667", "27.68333", "Europe/Bucharest"),("664858", "Todireşti", "", "RO", "642", "", "34", "150524", "", "47.7", "26.03333", "Europe/Bucharest"),("664859", "Todireşti", "", "RO", "642", "", "23", "99539", "", "47.31667", "26.83333", "Europe/Bucharest"),("664860", "Todireşti", "", "RO", "642", "", "38", "166413", "", "46.85", "27.36667", "Europe/Bucharest"),("664891", "Titu", "", "RO", "642", "", "16", "66081", "", "44.65", "25.53333", "Europe/Bucharest"),("664910", "Tismana", "", "RO", "642", "", "19", "82430", "", "45.05", "22.96667", "Europe/Bucharest"),("664957", "Târnova", "", "RO", "642", "", "02", "12509", "", "46.31667", "21.8", "Europe/Bucharest"),("664963", "Târnăveni", "", "RO", "642", "RO", "27", "114925", "", "46.33191", "24.29662", "Europe/Bucharest"),("664991", "Târgu Trotuş", "", "RO", "642", "", "04", "25825", "", "46.26667", "26.66667", "Europe/Bucharest"),("665000", "Târgu Secuiesc", "", "RO", "642", "", "15", "63740", "", "46", "26.13333", "Europe/Bucharest"),("665002", "Târgu Ocna", "", "RO", "642", "", "04", "20965", "", "46.27899", "26.61301", "Europe/Bucharest"),("665003", "Târgu Neamţ", "", "RO", "642", "", "28", "121055", "", "47.2", "26.36667", "Europe/Bucharest"),("665004", "Târgu-Mureş", "Тыргу-Муреш", "RO", "642", "", "27", "114319", "", "46.54245", "24.55747", "Europe/Bucharest"),("665010", "Târgu Jiu", "Тыргу-Жиу", "RO", "642", "", "19", "77812", "", "45.05", "23.28333", "Europe/Bucharest"),("665013", "Târgu Frumos", "", "RO", "642", "", "23", "95471", "", "47.2", "27", "Europe/Bucharest"),("665017", "Târgu Cărbuneşti", "", "RO", "642", "", "19", "78329", "", "44.95", "23.51667", "Europe/Bucharest"),("665019", "Târgşoru Vechi", "", "RO", "642", "", "30", "130892", "", "44.86667", "25.91667", "Europe/Bucharest"),("665024", "Târgovişte", "", "RO", "642", "", "16", "65342", "", "44.92543", "25.4567", "Europe/Bucharest"),("665087", "Timişoara", "Тимишоара", "RO", "642", "", "36", "155243", "", "45.75372", "21.22571", "Europe/Bucharest"),("665104", "Tileagd", "", "RO", "642", "", "05", "31716", "", "47.06667", "22.2", "Europe/Bucharest"),("665140", "Ţigăneşti", "", "RO", "642", "", "35", "154834", "", "43.9", "25.36667", "Europe/Bucharest"),("665151", "Ţifeşti", "", "RO", "642", "", "40", "178180", "", "45.85", "27.1", "Europe/Bucharest"),("665168", "Ţicleni", "", "RO", "642", "", "19", "78454", "", "44.88333", "23.4", "Europe/Bucharest"),("665193", "Ţibăneşti", "", "RO", "642", "", "23", "99780", "", "46.91667", "27.33333", "Europe/Bucharest"),("665196", "Ţibana", "", "RO", "642", "", "23", "99673", "", "46.98333", "27.33333", "Europe/Bucharest"),("665290", "Telega", "", "RO", "642", "", "30", "135789", "", "45.13333", "25.78333", "Europe/Bucharest"),("665304", "Telciu", "", "RO", "642", "", "06", "35054", "", "47.43333", "24.4", "Europe/Bucharest"),("665318", "Teiuş", "", "RO", "642", "", "01", "8096", "", "46.2", "23.68333", "Europe/Bucharest"),("665355", "Tecuci", "Текуч", "RO", "642", "", "18", "75203", "", "45.84973", "27.43441", "Europe/Bucharest"),("665359", "Techirghiol", "", "RO", "642", "", "14", "60534", "", "44.05", "28.6", "Europe/Bucharest"),("665371", "Teaca", "", "RO", "642", "", "06", "34985", "", "46.91667", "24.51667", "Europe/Bucharest"),("665425", "Tătăruşi", "", "RO", "642", "", "23", "99478", "", "47.35", "26.6", "Europe/Bucharest"),("665459", "Tătărani", "", "RO", "642", "", "16", "68921", "", "45", "25.26667", "Europe/Bucharest"),("665469", "Tăşnad", "", "RO", "642", "", "32", "136642", "", "47.48333", "22.58333", "Europe/Bucharest"),("665479", "Tărtăşeşti", "", "RO", "642", "", "16", "105534", "", "44.57722", "25.81278", "Europe/Bucharest"),("665497", "Tărlungeni", "", "RO", "642", "", "09", "42003", "", "45.63333", "25.75", "Europe/Bucharest"),("665540", "Ţăndărei", "", "RO", "642", "", "22", "92765", "", "44.65", "27.66667", "Europe/Bucharest"),("665550", "Tanacu", "", "RO", "642", "", "38", "166182", "", "46.68333", "27.81667", "Europe/Bucharest"),("665556", "Tamaşi", "", "RO", "642", "", "04", "25692", "", "46.48333", "26.98333", "Europe/Bucharest"),("665568", "Tămăşeni", "", "RO", "642", "", "28", "124634", "", "46.98333", "26.93333", "Europe/Bucharest"),("665606", "Tălmaciu", "", "RO", "642", "RO", "33", "145827", "", "45.66714", "24.26464", "Europe/Bucharest"),("665691", "Suseni", "", "RO", "642", "", "20", "85920", "", "46.66667", "25.55", "Europe/Bucharest"),("665754", "Suraia", "", "RO", "642", "", "40", "177842", "", "45.68333", "27.4", "Europe/Bucharest"),("665809", "Suharău", "", "RO", "642", "", "07", "38982", "", "48.13333", "26.41667", "Europe/Bucharest"),("665839", "Suciu de Sus", "", "RO", "642", "", "25", "109041", "", "47.43333", "24.03333", "Europe/Bucharest"),("665850", "Suceava", "Сучава", "RO", "642", "", "34", "146263", "", "47.63333", "26.25", "Europe/Bucharest"),("665899", "Stulpicani", "", "RO", "642", "", "34", "150356", "", "47.46667", "25.76667", "Europe/Bucharest"),("665997", "Strehaia", "", "RO", "642", "", "26", "110116", "", "44.61667", "23.2", "Europe/Bucharest"),("666012", "Straja", "", "RO", "642", "", "34", "150294", "", "47.91667", "25.55", "Europe/Bucharest"),("666031", "Storeşti", "", "RO", "642", "", "07", "37280", "", "47.55", "26.86667", "Europe/Bucharest"),("666037", "Stolniceni-Prăjescu", "", "RO", "642", "", "23", "99165", "", "47.19858", "26.7481", "Europe/Bucharest"),("666149", "Stâlpeni", "", "RO", "642", "", "03", "18778", "", "45.05", "24.96667", "Europe/Bucharest"),("666217", "Ştefăneşti-Sat", "", "RO", "642", "", "07", "39168", "", "47.78333", "27.18333", "Europe/Bucharest"),("666235", "Ştefăneşti", "", "RO", "642", "", "03", "13392", "", "44.86506", "24.94961", "Europe/Bucharest"),("666271", "Starchiojd", "", "RO", "642", "", "30", "135315", "", "45.31667", "26.18333", "Europe/Bucharest"),("666287", "Stănileşti", "", "RO", "642", "", "38", "165979", "", "46.61833", "28.17139", "Europe/Bucharest"),("666395", "Sovata", "", "RO", "642", "", "27", "114854", "", "46.58333", "25.06667", "Europe/Bucharest"),("666475", "Şomcuta Mare", "", "RO", "642", "", "25", "109176", "", "47.51667", "23.46667", "Europe/Bucharest"),("666611", "Snagov", "", "RO", "642", "", "43", "105160", "", "44.7", "26.18333", "Europe/Bucharest"),("666641", "Smeeni", "", "RO", "642", "", "11", "49545", "", "44.98333", "26.85", "Europe/Bucharest"),("666676", "Slobozia Bradului", "", "RO", "642", "", "40", "177655", "", "45.5", "27.05", "Europe/Bucharest"),("666716", "Slobozia", "", "RO", "642", "", "03", "18741", "", "44.52527", "25.24263", "Europe/Bucharest"),("666765", "Slatina", "", "RO", "642", "", "34", "150258", "", "47.45", "26.01667", "Europe/Bucharest"),("666767", "Slatina", "Слатина", "RO", "642", "", "29", "125347", "", "44.43333", "24.36667", "Europe/Bucharest"),("666775", "Slănic", "", "RO", "642", "", "30", "131577", "", "45.25", "25.93333", "Europe/Bucharest"),("666809", "Şirna", "", "RO", "642", "", "30", "135431", "", "44.8", "25.95", "Europe/Bucharest"),("666821", "Şiria", "", "RO", "642", "", "02", "12368", "", "46.26667", "21.63333", "Europe/Bucharest"),("666830", "Siret", "", "RO", "642", "", "34", "146655", "", "47.95", "26.06667", "Europe/Bucharest"),("666877", "Şipote", "", "RO", "642", "", "23", "99370", "", "47.46667", "27.21667", "Europe/Bucharest"),("666936", "Sântana", "", "RO", "642", "", "02", "12091", "", "46.35", "21.5", "Europe/Bucharest"),("666950", "Sânpetru Mare", "", "RO", "642", "", "36", "158733", "", "46.04515", "20.81834", "Europe/Bucharest"),("666973", "Sânnicolau Mare", "", "RO", "642", "", "36", "155528", "", "46.08333", "20.63333", "Europe/Bucharest"),("667023", "Sângeru", "", "RO", "642", "", "30", "135244", "", "45.13333", "26.35", "Europe/Bucharest"),("667029", "Sângeorz-Băi", "", "RO", "642", "RO", "06", "32599", "", "47.3685", "24.67212", "Europe/Bucharest"),("667034", "Sângeorgiu de Mureş", "", "RO", "642", "", "27", "114417", "", "46.5696", "24.59453", "Europe/Bucharest"),("667055", "Sândominic", "", "RO", "642", "", "20", "85760", "", "46.584", "25.78028", "Europe/Bucharest"),("667059", "Sâncraiu de Mureş", "", "RO", "642", "", "27", "114382", "", "46.55119", "24.52663", "Europe/Bucharest"),("667069", "Sâncrăieni", "", "RO", "642", "", "20", "85680", "", "46.31439", "25.83941", "Europe/Bucharest"),("667089", "Sânandrei", "", "RO", "642", "", "36", "158653", "", "45.85306", "21.16806", "Europe/Bucharest"),("667091", "Sinaia", "", "RO", "642", "", "30", "131540", "", "45.35", "25.55", "Europe/Bucharest"),("667101", "Şimleu Silvaniei", "", "RO", "642", "", "31", "139884", "", "47.23333", "22.8", "Europe/Bucharest"),("667119", "Şimian", "", "RO", "642", "", "26", "109826", "", "44.61417", "22.70722", "Europe/Bucharest"),("667121", "Simeria", "", "RO", "642", "", "21", "87665", "", "45.85", "23.01667", "Europe/Bucharest"),("667216", "Sihlea", "", "RO", "642", "", "40", "177600", "", "45.5", "27.11667", "Europe/Bucharest"),("667227", "Sighetu Marmaţiei", "", "RO", "642", "", "25", "106559", "", "47.93195", "23.88603", "Europe/Bucharest"),("667243", "Siculeni", "", "RO", "642", "", "20", "85626", "", "46.41667", "25.75", "Europe/Bucharest"),("667268", "Sibiu", "Сибиу", "RO", "642", "", "33", "143450", "", "45.8", "24.15", "Europe/Bucharest"),("667303", "Sfântu-Gheorghe", "Сфэнту-Георг", "RO", "642", "", "15", "63394", "", "45.86667", "25.78333", "Europe/Bucharest"),("667437", "Seini", "", "RO", "642", "", "25", "108963", "", "47.75", "23.28333", "Europe/Bucharest"),("667453", "Segarcea", "", "RO", "642", "", "17", "70502", "", "44.1", "23.75", "Europe/Bucharest"),("667458", "Secusigiu", "", "RO", "642", "", "02", "11940", "", "46.08333", "20.98333", "Europe/Bucharest"),("667515", "Sebiş", "", "RO", "642", "", "02", "9690", "", "46.36667", "22.11667", "Europe/Bucharest"),("667526", "Sebeş", "Себеш", "RO", "642", "", "01", "1874", "", "45.95646", "23.571", "Europe/Bucharest"),("667586", "Scorţeni", "", "RO", "642", "", "30", "135164", "", "45.1", "25.85", "Europe/Bucharest"),("667593", "Scorniceşti", "", "RO", "642", "", "29", "128711", "", "44.56667", "24.55", "Europe/Bucharest"),("667606", "Scobinţi", "", "RO", "642", "", "23", "98998", "", "47.38333", "26.93333", "Europe/Bucharest"),("667676", "Văleni", "", "RO", "642", "", "38", "165185", "", "46.59278", "28.0625", "Europe/Bucharest"),("667706", "Scheia", "", "RO", "642", "", "34", "146432", "", "47.65", "26.23333", "Europe/Bucharest"),("667751", "Săvineşti", "", "RO", "642", "", "28", "120824", "", "46.85", "26.46667", "Europe/Bucharest"),("667757", "Săveni", "", "RO", "642", "", "07", "36060", "", "47.95", "26.86667", "Europe/Bucharest"),("667759", "Săveni", "", "RO", "642", "", "22", "94376", "", "44.6", "27.65", "Europe/Bucharest"),("667873", "Satu Mare", "Сату-Маре", "RO", "642", "", "32", "136483", "", "47.79926", "22.86255", "Europe/Bucharest"),("667882", "Satulung", "", "RO", "642", "", "25", "108712", "", "47.56667", "23.43333", "Europe/Bucharest"),("667917", "Sascut", "", "RO", "642", "", "04", "25068", "", "46.2", "27.1", "Europe/Bucharest"),("667919", "Săsciori", "", "RO", "642", "", "01", "7099", "", "45.86667", "23.58333", "Europe/Bucharest"),("667966", "Sărmaşu", "", "RO", "642", "", "27", "119242", "", "46.75", "24.16667", "Europe/Bucharest"),("667970", "Şărmăşag", "", "RO", "642", "", "31", "142881", "", "47.35", "22.83333", "Europe/Bucharest"),("667991", "Sarichioi", "", "RO", "642", "", "37", "161179", "", "44.95", "28.85", "Europe/Bucharest"),("668096", "Sanislău", "", "RO", "642", "", "32", "138663", "", "47.63333", "22.33333", "Europe/Bucharest"),("668129", "Salonta", "Салонта", "RO", "642", "", "05", "26975", "", "46.8", "21.65", "Europe/Bucharest"),("668142", "Săliştea de Sus", "", "RO", "642", "", "25", "108892", "", "47.65", "24.35", "Europe/Bucharest"),("668153", "Sălişte", "", "RO", "642", "", "33", "145499", "", "45.79633", "23.88677", "Europe/Bucharest"),("668219", "Salcea", "", "RO", "642", "", "34", "146370", "", "47.65", "26.36667", "Europe/Bucharest"),("668263", "Sagna", "", "RO", "642", "", "28", "124153", "", "46.98333", "27.01667", "Europe/Bucharest"),("668266", "Săgeata", "", "RO", "642", "", "11", "49073", "", "45.1", "26.98333", "Europe/Bucharest"),("668287", "Sadova", "", "RO", "642", "", "17", "73996", "", "43.9", "23.95", "Europe/Bucharest"),("668297", "Săcueni", "", "RO", "642", "", "05", "30915", "", "47.35", "22.1", "Europe/Bucharest"),("668314", "Săcele", "Сэчеле", "RO", "642", "", "09", "40438", "", "45.61674", "25.71101", "Europe/Bucharest"),("668342", "Săcălaz", "", "RO", "642", "", "36", "158564", "", "45.75833", "21.11222", "Europe/Bucharest"),("668365", "Săbăoani", "", "RO", "642", "", "28", "124206", "", "47.01667", "26.85", "Europe/Bucharest"),("668411", "Ruscova", "", "RO", "642", "", "25", "108696", "", "47.79289", "24.28546", "Europe/Bucharest"),("668442", "Rupea", "", "RO", "642", "", "09", "40394", "", "46.03333", "25.21667", "Europe/Bucharest"),("668467", "Runcu", "", "RO", "642", "", "19", "81576", "", "45.11667", "23.13333", "Europe/Bucharest"),("668488", "Ruginoasa", "", "RO", "642", "", "23", "98774", "", "47.25", "26.85", "Europe/Bucharest"),("668542", "Rucăr", "", "RO", "642", "", "03", "18527", "", "45.4", "25.16667", "Europe/Bucharest"),("668546", "Roznov", "", "RO", "642", "", "28", "124117", "", "46.83333", "26.51667", "Europe/Bucharest"),("668548", "Rozavlea", "", "RO", "642", "", "25", "108669", "", "47.73333", "24.21667", "Europe/Bucharest"),("668552", "Pecica", "", "RO", "642", "", "02", "11584", "", "46.16667", "21.06667", "Europe/Bucharest"),("668555", "Rovinari", "", "RO", "642", "", "19", "82895", "", "44.91667", "23.18333", "Europe/Bucharest"),("668605", "Roșiorii de Vede", "", "RO", "642", "", "35", "151870", "", "44.11667", "24.98333", "Europe/Bucharest"),("668660", "Roseţi", "", "RO", "642", "", "41", "94312", "", "44.21482", "27.44848", "Europe/Bucharest"),("668732", "Roman", "Роман", "RO", "642", "", "28", "120860", "", "46.92119", "26.92646", "Europe/Bucharest"),("668772", "Rodna", "", "RO", "642", "", "06", "34333", "", "47.41667", "24.81667", "Europe/Bucharest"),("668799", "Roata de Jos", "", "RO", "642", "", "42", "104831", "", "44.41083", "25.54333", "Europe/Bucharest"),("668828", "Râşnov", "", "RO", "642", "", "09", "40367", "", "45.58333", "25.45", "Europe/Bucharest"),("668872", "Râmnicu Vâlcea", "Рымнику-Вылча", "RO", "642", "", "39", "167473", "", "45.1", "24.36667", "Europe/Bucharest"),("668873", "Râmnicu Sărat", "", "RO", "642", "", "11", "44845", "", "45.38333", "27.05", "Europe/Bucharest"),("668911", "Râfov", "", "RO", "642", "", "30", "135020", "", "44.86667", "26.13333", "Europe/Bucharest"),("668954", "Reşiţa", "", "RO", "642", "", "12", "50790", "", "45.30083", "21.88917", "Europe/Bucharest"),("668986", "Remetea", "", "RO", "642", "", "20", "85412", "", "46.78333", "25.45", "Europe/Bucharest"),("668995", "Reghin-Sat", "", "RO", "642", "", "27", "114809", "", "46.78333", "24.71667", "Europe/Bucharest"),("669013", "Rediu", "", "RO", "642", "", "23", "95239", "", "47.21667", "27.5", "Europe/Bucharest"),("669018", "Rediu", "", "RO", "642", "", "28", "124028", "", "46.75598", "26.56254", "Europe/Bucharest"),("669043", "Recea", "", "RO", "642", "", "25", "106407", "", "47.63333", "23.51667", "Europe/Bucharest"),("669058", "Recaş", "", "RO", "642", "", "36", "158314", "", "45.79889", "21.50083", "Europe/Bucharest"),("669072", "Răzvad", "", "RO", "642", "", "16", "65431", "", "44.93333", "25.53333", "Europe/Bucharest"),("669102", "Răuceşti", "", "RO", "642", "", "28", "123914", "", "47.25", "26.41667", "Europe/Bucharest"),("669156", "Răşinari", "", "RO", "642", "", "33", "143520", "", "45.7", "24.06667", "Europe/Bucharest"),("669241", "Răducăneni", "", "RO", "642", "", "23", "98685", "", "46.95", "27.93333", "Europe/Bucharest"),("669244", "Radovanu", "", "RO", "642", "", "41", "104751", "", "44.2", "26.51667", "Europe/Bucharest"),("669289", "Rădăuți", "Рэдэуци", "RO", "642", "", "34", "146628", "", "47.85", "25.91667", "Europe/Bucharest"),("669364", "Răchitoasa", "", "RO", "642", "", "04", "24837", "", "46.43333", "27.36667", "Europe/Bucharest"),("669405", "Răcari", "", "RO", "642", "", "16", "68627", "", "44.63333", "25.73333", "Europe/Bucharest"),("669408", "Răcăciuni", "", "RO", "642", "", "04", "24766", "", "46.33333", "26.98333", "Europe/Bucharest"),("669499", "Puieşti", "", "RO", "642", "", "38", "165470", "", "46.41667", "27.5", "Europe/Bucharest"),("669517", "Pucioasa", "", "RO", "642", "", "16", "65921", "", "45.07807", "25.43232", "Europe/Bucharest"),("669522", "Puchenii Mari", "", "RO", "642", "", "30", "134942", "", "44.81667", "26.08333", "Europe/Bucharest"),("669665", "Preuteşti", "", "RO", "642", "", "34", "149968", "", "47.45", "26.41667", "Europe/Bucharest"),("669691", "Prejmer", "", "RO", "642", "", "09", "41667", "", "45.71667", "25.76667", "Europe/Bucharest"),("669704", "Predeal", "", "RO", "642", "RO", "09", "40303", "", "45.5", "25.56667", "Europe/Bucharest"),("669735", "Praid", "", "RO", "642", "", "20", "85341", "", "46.55", "25.13333", "Europe/Bucharest"),("669753", "Potlogi", "", "RO", "642", "", "16", "68468", "", "44.55", "25.58333", "Europe/Bucharest"),("669772", "Potcoava", "", "RO", "642", "", "29", "128374", "", "44.48333", "24.65", "Europe/Bucharest"),("669783", "Poşta Câlnău", "", "RO", "642", "", "11", "48771", "", "45.23333", "26.85", "Europe/Bucharest"),("669847", "Popricani", "", "RO", "642", "", "23", "98505", "", "47.3", "27.51667", "Europe/Bucharest"),("669870", "Popeşti-Leordeni", "", "RO", "642", "", "43", "179533", "", "44.38333", "26.16667", "Europe/Bucharest"),("669882", "Popeşti", "", "RO", "642", "", "05", "30568", "", "47.23333", "22.41667", "Europe/Bucharest"),("669995", "Poienile de sub Munte", "", "RO", "642", "", "25", "108473", "", "47.81667", "24.43333", "Europe/Bucharest"),("670021", "Poiana Teiului", "", "RO", "642", "", "28", "123790", "", "47.1", "25.96667", "Europe/Bucharest"),("670064", "Poiana Mare", "", "RO", "642", "", "17", "73736", "", "43.91667", "23.06667", "Europe/Bucharest"),("670075", "Poiana Lacului", "", "RO", "642", "", "03", "18028", "", "44.81667", "24.73333", "Europe/Bucharest"),("670098", "Poiana Câmpina", "", "RO", "642", "", "30", "131274", "", "45.13333", "25.68333", "Europe/Bucharest"),("670167", "Pogoanele", "", "RO", "642", "", "11", "48744", "", "44.91667", "27", "Europe/Bucharest"),("670257", "Podu Turcului", "", "RO", "642", "", "04", "24524", "", "46.2", "27.38333", "Europe/Bucharest"),("670274", "Poduri", "", "RO", "642", "", "04", "24631", "", "46.46667", "26.53333", "Europe/Bucharest"),("670297", "Podu Iloaiei", "", "RO", "642", "", "23", "98373", "", "47.21667", "27.26667", "Europe/Bucharest"),("670319", "Podoleni", "", "RO", "642", "", "28", "123674", "", "46.8", "26.61667", "Europe/Bucharest"),("670353", "Podari", "", "RO", "642", "", "17", "70110", "", "44.25", "23.78333", "Europe/Bucharest"),("670409", "Plosca", "", "RO", "642", "", "35", "153605", "", "44.03333", "25.13333", "Europe/Bucharest"),("670432", "Plopşoru", "", "RO", "642", "", "19", "81264", "", "44.78333", "23.35", "Europe/Bucharest"),("670467", "Plopeni", "", "RO", "642", "", "30", "131443", "", "45.04955", "25.95202", "Europe/Bucharest"),("670474", "Ploieşti", "", "RO", "642", "", "30", "130534", "", "44.95", "26.01667", "Europe/Bucharest"),("670528", "Pleniţa", "", "RO", "642", "", "17", "73709", "", "44.21667", "23.18333", "Europe/Bucharest"),("670609", "Piteşti", "", "RO", "642", "", "03", "13169", "", "44.85", "24.86667", "Europe/Bucharest"),("670623", "Piscu Vechi", "", "RO", "642", "", "17", "73665", "", "43.9", "23.16667", "Europe/Bucharest"),("670649", "Piscu", "", "RO", "642", "", "18", "76996", "", "45.5", "27.73333", "Europe/Bucharest"),("670686", "Pârscov", "", "RO", "642", "", "11", "48557", "", "45.28333", "26.55", "Europe/Bucharest"),("670706", "Pârjol", "", "RO", "642", "", "04", "24338", "", "46.58333", "26.6", "Europe/Bucharest"),("670777", "Pipirig", "", "RO", "642", "", "28", "123521", "", "47.25", "26.06667", "Europe/Bucharest"),("670794", "Pâncota", "", "RO", "642", "", "02", "9654", "", "46.33333", "21.7", "Europe/Bucharest"),("670819", "Pietroşani", "", "RO", "642", "", "03", "17851", "", "45.18333", "24.85", "Europe/Bucharest"),("670884", "Piatra Şoimului", "", "RO", "642", "", "28", "123479", "", "46.83333", "26.43333", "Europe/Bucharest"),("670888", "Piatra Olt", "", "RO", "642", "", "29", "128105", "", "44.36667", "24.26667", "Europe/Bucharest"),("670889", "Piatra Neamţ", "", "RO", "642", "", "28", "120726", "", "46.91667", "26.33333", "Europe/Bucharest"),("670938", "Petroşani", "Петрошани", "RO", "642", "", "21", "86990", "", "45.41667", "23.36667", "Europe/Bucharest"),("670969", "Petrila", "", "RO", "642", "", "21", "87077", "", "45.45", "23.41667", "Europe/Bucharest"),("670981", "Petricani", "", "RO", "642", "", "28", "123424", "", "47.16667", "26.46667", "Europe/Bucharest"),("671003", "Petreşti", "", "RO", "642", "", "16", "65752", "", "44.65", "25.33333", "Europe/Bucharest"),("671110", "Perişoru", "", "RO", "642", "", "41", "94223", "", "44.45", "27.55", "Europe/Bucharest"),("671118", "Periş", "", "RO", "642", "", "43", "104546", "", "44.68472", "26.01389", "Europe/Bucharest"),("671132", "Perieni", "", "RO", "642", "", "38", "165274", "", "46.3", "27.61667", "Europe/Bucharest"),("671138", "Periam", "", "RO", "642", "", "36", "158109", "", "46.05", "20.86667", "Europe/Bucharest"),("671145", "Peretu", "", "RO", "642", "", "35", "153543", "", "44.05", "25.08333", "Europe/Bucharest"),("671187", "Pechea", "", "RO", "642", "", "18", "76969", "", "45.63333", "27.8", "Europe/Bucharest"),("671209", "Păuneşti", "", "RO", "642", "", "40", "177236", "", "46.03333", "27.1", "Europe/Bucharest"),("671228", "Păuleşti", "", "RO", "642", "", "30", "130847", "", "45", "25.98333", "Europe/Bucharest"),("671382", "Pantelimon", "", "RO", "642", "", "43", "179515", "", "44.45", "26.2", "Europe/Bucharest"),("671390", "Pănet", "", "RO", "642", "", "27", "118691", "", "46.55514", "24.46973", "Europe/Bucharest"),("671398", "Panciu", "", "RO", "642", "", "40", "175055", "", "45.9", "27.08333", "Europe/Bucharest"),("671418", "Păltinoasa", "", "RO", "642", "", "34", "149753", "", "47.55", "25.95", "Europe/Bucharest"),("671559", "Padeş", "", "RO", "642", "", "19", "81095", "", "45.01667", "22.85", "Europe/Bucharest"),("671584", "Ovidiu", "", "RO", "642", "", "14", "60687", "", "44.26667", "28.56667", "Europe/Bucharest"),("671590", "Otopeni", "", "RO", "642", "", "43", "179481", "", "44.55", "26.06667", "Europe/Bucharest"),("671603", "Oţelu Roşu", "", "RO", "642", "", "12", "51207", "", "45.53333", "22.36667", "Europe/Bucharest"),("671626", "Ostroveni", "", "RO", "642", "", "17", "73567", "", "43.8", "23.9", "Europe/Bucharest"),("671636", "Ostrov", "", "RO", "642", "", "14", "62538", "", "44.11667", "27.36667", "Europe/Bucharest"),("671657", "Osica de Sus", "", "RO", "642", "", "29", "127983", "", "44.25", "24.31667", "Europe/Bucharest"),("671681", "Orşova", "", "RO", "642", "", "26", "110063", "", "44.72528", "22.39611", "Europe/Bucharest"),("671738", "Orbeasca de Sus", "", "RO", "642", "", "35", "153507", "", "44.15", "25.31667", "Europe/Bucharest"),("671746", "Oraviţa", "", "RO", "642", "", "12", "51118", "", "45.0325", "21.68944", "Europe/Bucharest"),("671751", "Oraşu Nou", "", "RO", "642", "", "32", "138351", "", "47.83333", "23.28333", "Europe/Bucharest"),("671757", "Orăştie", "Орэштие", "RO", "642", "", "21", "87638", "", "45.83333", "23.2", "Europe/Bucharest"),("671768", "Oradea", "Орадя", "RO", "642", "", "05", "26564", "", "47.0458", "21.91833", "Europe/Bucharest"),("671832", "Olteniţa", "Олтенице", "RO", "642", "", "41", "100610", "", "44.08333", "26.63333", "Europe/Bucharest"),("671896", "Oituz", "", "RO", "642", "", "04", "23797", "", "46.2", "26.61667", "Europe/Bucharest"),("671964", "Odorheiu Secuiesc", "Одорхею-Секуйеск", "RO", "642", "", "20", "83133", "", "46.3", "25.3", "Europe/Bucharest"),("671974", "Odobeşti", "", "RO", "642", "", "40", "175019", "", "45.76667", "27.05", "Europe/Bucharest"),("671975", "Odobeşti", "", "RO", "642", "", "16", "68342", "", "44.61667", "25.56667", "Europe/Bucharest"),("672024", "Ocna Mureş", "", "RO", "642", "", "01", "1794", "", "46.38333", "23.85", "Europe/Bucharest"),("672123", "Nuşfalău", "", "RO", "642", "", "31", "142239", "", "47.2", "22.73333", "Europe/Bucharest"),("672216", "Nimigea de Sus", "", "RO", "642", "", "06", "33989", "", "47.28333", "24.31667", "Europe/Bucharest"),("672246", "Nicoreşti", "", "RO", "642", "", "18", "76807", "", "45.93223", "27.30866", "Europe/Bucharest"),("672275", "Nicolae Bălcescu", "", "RO", "642", "", "04", "23715", "", "46.46667", "26.91667", "Europe/Bucharest"),("672331", "Nehoiu", "", "RO", "642", "", "11", "47916", "", "45.41667", "26.3", "Europe/Bucharest"),("672343", "Negru Vodă", "", "RO", "642", "", "14", "62397", "", "43.81667", "28.2", "Europe/Bucharest"),("672365", "Negreşti-Oaş", "", "RO", "642", "", "32", "136599", "", "47.86667", "23.43333", "Europe/Bucharest"),("672375", "Negreşti", "", "RO", "642", "", "38", "161856", "", "46.83333", "27.43333", "Europe/Bucharest"),("672486", "Năvodari", "Нэводари", "RO", "642", "", "14", "60507", "", "44.31667", "28.6", "Europe/Bucharest"),("672497", "Năsăud", "", "RO", "642", "", "06", "32544", "", "47.28333", "24.4", "Europe/Bucharest"),("672546", "Nădlac", "", "RO", "642", "", "02", "9627", "", "46.16667", "20.75", "Europe/Bucharest"),("672615", "Murgeni", "", "RO", "642", "", "38", "164981", "", "46.20444", "28.01972", "Europe/Bucharest"),("672620", "Murfatlar", "", "RO", "642", "", "14", "62360", "", "44.18333", "28.41667", "Europe/Bucharest"),("672660", "Munteni", "", "RO", "642", "", "18", "75258", "", "45.93333", "27.43333", "Europe/Bucharest"),("672700", "Mugeni", "", "RO", "642", "", "20", "85127", "", "46.25", "25.21667", "Europe/Bucharest"),("672757", "Motru", "", "RO", "642", "", "19", "78141", "", "44.80333", "22.97194", "Europe/Bucharest"),("672781", "Moţca", "", "RO", "642", "", "23", "98220", "", "47.25", "26.61667", "Europe/Bucharest"),("672784", "Moţăţei", "", "RO", "642", "", "17", "73335", "", "44.08333", "23.2", "Europe/Bucharest"),("672847", "Moroeni", "", "RO", "642", "", "16", "68182", "", "45.21667", "25.43333", "Europe/Bucharest"),("672862", "Moreni", "", "RO", "642", "", "16", "65841", "", "44.98301", "25.64415", "Europe/Bucharest"),("672912", "Moldova Nouă", "", "RO", "642", "", "12", "51056", "", "44.7375", "21.66694", "Europe/Bucharest"),("672922", "Moisei", "", "RO", "642", "", "25", "108348", "", "47.65562", "24.54011", "Europe/Bucharest"),("672926", "Moineşti", "", "RO", "642", "", "04", "20876", "", "46.47523", "26.48907", "Europe/Bucharest"),("672937", "Mogoşoaia", "", "RO", "642", "", "43", "179463", "", "44.52917", "26", "Europe/Bucharest"),("672977", "Modelu", "", "RO", "642", "", "41", "92587", "", "44.19574", "27.3872", "Europe/Bucharest"),("672987", "Moceşti", "", "RO", "642", "", "30", "133722", "", "45.05", "26.25", "Europe/Bucharest"),("673033", "Mizil", "Мизил", "RO", "642", "", "30", "131407", "", "45.01667", "26.45", "Europe/Bucharest"),("673098", "Miroslava", "", "RO", "642", "", "23", "97919", "", "47.15", "27.51667", "Europe/Bucharest"),("673123", "Mireşu Mare", "", "RO", "642", "", "25", "108268", "", "47.5", "23.33333", "Europe/Bucharest"),("673140", "Mirceşti", "", "RO", "642", "", "23", "97811", "", "47.08333", "26.83333", "Europe/Bucharest"),("673150", "Călăraşi", "", "RO", "642", "", "41", "92569", "", "44.2051", "27.31356", "Europe/Bucharest"),("673154", "Mircea Vodă", "", "RO", "642", "", "14", "62280", "", "44.28333", "28.16667", "Europe/Bucharest"),("673275", "Mânăstirea", "", "RO", "642", "", "41", "104181", "", "44.21667", "26.9", "Europe/Bucharest"),("673305", "Milişăuţi", "", "RO", "642", "", "34", "146931", "", "47.78333", "26", "Europe/Bucharest"),("673316", "Milcovul", "", "RO", "642", "", "40", "176748", "", "45.65", "27.25", "Europe/Bucharest"),("673365", "Mihai Viteazu", "", "RO", "642", "", "13", "55277", "", "46.53333", "23.75", "Europe/Bucharest"),("673381", "Mihail Kogălniceanu", "", "RO", "642", "", "22", "93995", "", "44.68333", "27.73333", "Europe/Bucharest"),("673382", "Mihail Kogălniceanu", "", "RO", "642", "", "14", "62191", "", "44.36798", "28.46", "Europe/Bucharest"),("673387", "Mihăileşti", "", "RO", "642", "", "42", "104136", "", "44.32667", "25.90833", "Europe/Bucharest"),("673392", "Mihăileni", "", "RO", "642", "", "07", "38161", "", "47.96667", "26.15", "Europe/Bucharest"),("673416", "Mihăeşti", "", "RO", "642", "", "03", "17254", "", "45.11667", "25", "Europe/Bucharest"),("673417", "Mihăeşti", "", "RO", "642", "", "39", "171325", "", "45.03333", "24.25", "Europe/Bucharest"),("673440", "Miercurea Nirajului", "", "RO", "642", "", "27", "118281", "", "46.53333", "24.8", "Europe/Bucharest"),("673441", "Miercurea-Ciuc", "Меркуря-Чук", "RO", "642", "", "20", "83320", "", "46.35", "25.8", "Europe/Bucharest"),("673586", "Merei", "", "RO", "642", "", "11", "47453", "", "45.13333", "26.68333", "Europe/Bucharest"),("673632", "Medieşu Aurit", "", "RO", "642", "", "32", "138084", "", "47.78333", "23.15", "Europe/Bucharest"),("673634", "Mediaş", "", "RO", "642", "", "33", "143619", "", "46.16667", "24.35", "Europe/Bucharest"),("673636", "Medgidia", "Меджидия", "RO", "642", "", "14", "60847", "", "44.25", "28.28333", "Europe/Bucharest"),("673658", "Mavrodin", "", "RO", "642", "", "35", "153204", "", "44.03333", "25.25", "Europe/Bucharest"),("673685", "Matca", "", "RO", "642", "", "18", "76692", "", "45.85", "27.53333", "Europe/Bucharest"),("673691", "Mătăsaru", "", "RO", "642", "", "16", "68048", "", "44.71667", "25.41667", "Europe/Bucharest"),("673695", "Mătăsari", "", "RO", "642", "", "19", "80846", "", "44.85", "23.08333", "Europe/Bucharest"),("673702", "Măstăcani", "", "RO", "642", "", "18", "76718", "", "45.78333", "28.03333", "Europe/Bucharest"),("673783", "Mărgineni-Munteni", "", "RO", "642", "", "04", "20466", "", "46.6", "26.9", "Europe/Bucharest"),("673807", "Marginea", "", "RO", "642", "", "34", "149290", "", "47.81667", "25.81667", "Europe/Bucharest"),("673816", "Marghita", "", "RO", "642", "", "05", "26877", "", "47.35", "22.33333", "Europe/Bucharest"),("673881", "Mărășești", "", "RO", "642", "", "40", "174922", "", "45.88333", "27.23333", "Europe/Bucharest"),("673893", "Mărăcineni", "", "RO", "642", "", "11", "47373", "", "45.2", "26.8", "Europe/Bucharest"),("673921", "Mangalia", "Мангалия", "RO", "642", "", "14", "60482", "", "43.8", "28.58333", "Europe/Bucharest"),("673932", "Măneşti", "", "RO", "642", "", "30", "134194", "", "44.86667", "25.85", "Europe/Bucharest"),("674011", "Mălini", "", "RO", "642", "", "34", "149316", "", "47.46667", "26.08333", "Europe/Bucharest"),("674061", "Măieru", "", "RO", "642", "", "06", "33621", "", "47.4", "24.75", "Europe/Bucharest"),("674066", "Măicăneşti", "", "RO", "642", "", "40", "176613", "", "45.5", "27.5", "Europe/Bucharest"),("674105", "Măgureni", "", "RO", "642", "", "30", "134050", "", "45.06667", "25.73333", "Europe/Bucharest"),("674117", "Măgurele", "", "RO", "642", "", "43", "179409", "", "44.35", "26.03333", "Europe/Bucharest"),("674170", "Maglavit", "", "RO", "642", "", "17", "73031", "", "44.03333", "23.1", "Europe/Bucharest"),("674230", "Măcin", "", "RO", "642", "", "37", "159730", "", "45.24371", "28.13564", "Europe/Bucharest"),("674244", "Macea", "", "RO", "642", "", "02", "11398", "", "46.38333", "21.3", "Europe/Bucharest"),("674295", "Lupeni", "Лупени", "RO", "642", "", "21", "87059", "", "45.36029", "23.23832", "Europe/Bucharest"),("674307", "Lunguleţu", "", "RO", "642", "", "16", "67906", "", "44.61667", "25.65", "Europe/Bucharest"),("674323", "Lungani", "", "RO", "642", "", "23", "97722", "", "47.18333", "27.15", "Europe/Bucharest"),("674349", "Luncaviţa", "", "RO", "642", "", "37", "160680", "", "45.28333", "28.26667", "Europe/Bucharest"),("674419", "Lunca de Jos", "", "RO", "642", "", "20", "84656", "", "46.56667", "25.98333", "Europe/Bucharest"),("674497", "Lunca", "", "RO", "642", "", "35", "153151", "", "43.83333", "24.76667", "Europe/Bucharest"),("674517", "Lumina", "", "RO", "642", "", "14", "63152", "", "44.28333", "28.56667", "Europe/Bucharest"),("674531", "Lugoj", "Лугож", "RO", "642", "", "36", "155350", "", "45.68861", "21.90306", "Europe/Bucharest"),("674541", "Luduş", "", "RO", "642", "", "27", "114710", "", "46.48333", "24.1", "Europe/Bucharest"),("674550", "Ludeşti", "", "RO", "642", "", "16", "67835", "", "44.86667", "25.23333", "Europe/Bucharest"),("674560", "Lucieni", "", "RO", "642", "", "16", "67773", "", "44.85", "25.43333", "Europe/Bucharest"),("674586", "Lovrin", "", "RO", "642", "", "36", "157530", "", "45.96806", "20.77028", "Europe/Bucharest"),("674637", "Livezi-Vale", "", "RO", "642", "", "04", "23289", "", "46.41667", "26.73333", "Europe/Bucharest"),("674679", "Livada", "", "RO", "642", "", "32", "138039", "", "47.86667", "23.13333", "Europe/Bucharest"),("674696", "Liteni", "", "RO", "642", "", "34", "149414", "", "47.56667", "26.2", "Europe/Bucharest"),("674733", "Lipova", "", "RO", "642", "", "02", "9574", "", "46.09085", "21.69628", "Europe/Bucharest"),("674796", "Lieşti", "", "RO", "642", "", "18", "76674", "", "45.61667", "27.51667", "Europe/Bucharest"),("674823", "Leu", "", "RO", "642", "", "17", "72926", "", "44.18333", "24", "Europe/Bucharest"),("674834", "Leţcani", "", "RO", "642", "", "23", "97679", "", "47.18333", "27.41667", "Europe/Bucharest"),("674844", "Lespezi", "", "RO", "642", "", "23", "97606", "", "47.36667", "26.7", "Europe/Bucharest"),("674885", "Leordeni", "", "RO", "642", "", "03", "16757", "", "44.78333", "25.11667", "Europe/Bucharest"),("674895", "Lenauheim", "", "RO", "642", "", "36", "157451", "", "45.87194", "20.79944", "Europe/Bucharest"),("674916", "Lehliu-Gară", "", "RO", "642", "", "41", "93888", "", "44.43333", "26.85", "Europe/Bucharest"),("674933", "Lechinţa", "", "RO", "642", "", "06", "33435", "", "47.01667", "24.35", "Europe/Bucharest"),("674947", "Lazuri", "", "RO", "642", "", "32", "137960", "", "47.85", "22.86667", "Europe/Bucharest"),("674977", "Laza", "", "RO", "642", "", "38", "164598", "", "46.65", "27.58333", "Europe/Bucharest"),("675130", "Jurilovca", "", "RO", "642", "", "37", "160644", "", "44.76667", "28.86667", "Europe/Bucharest"),("675168", "Josenii Bârgăului", "", "RO", "642", "", "06", "33382", "", "47.21667", "24.68333", "Europe/Bucharest"),("675171", "Joseni", "", "RO", "642", "", "20", "84558", "", "46.7", "25.5", "Europe/Bucharest"),("675193", "Joiţa", "", "RO", "642", "", "42", "103997", "", "44.49417", "25.85389", "Europe/Bucharest"),("675223", "Jimbolia", "", "RO", "642", "", "36", "155494", "", "45.79139", "20.71722", "Europe/Bucharest"),("675231", "Jilava", "", "RO", "642", "", "43", "179383", "", "44.33333", "26.07806", "Europe/Bucharest"),("675235", "Jijila", "", "RO", "642", "", "37", "160617", "", "45.3", "28.15", "Europe/Bucharest"),("675261", "Jibou", "", "RO", "642", "", "31", "139811", "", "47.25896", "23.25651", "Europe/Bucharest"),("675290", "Jebel", "", "RO", "642", "", "36", "157424", "", "45.55556", "21.21361", "Europe/Bucharest"),("675385", "Izvoarele", "", "RO", "642", "", "16", "68921", "", "45.03333", "25.26667", "Europe/Bucharest"),("675407", "Izbiceni", "", "RO", "642", "", "29", "127368", "", "43.83333", "24.65", "Europe/Bucharest"),("675418", "Iveşti", "", "RO", "642", "", "18", "76601", "", "45.68333", "27.51667", "Europe/Bucharest"),("675480", "Islaz", "", "RO", "642", "", "35", "151736", "", "43.73333", "24.75", "Europe/Bucharest"),("675495", "Isaccea", "", "RO", "642", "", "37", "159687", "", "45.26667", "28.46667", "Europe/Bucharest"),("675585", "Întorsura Buzăului", "", "RO", "642", "", "15", "63580", "", "45.68333", "26.03333", "Europe/Bucharest"),("675590", "Însurăţei", "", "RO", "642", "", "08", "43411", "", "44.91667", "27.6", "Europe/Bucharest"),("675606", "Ineu", "", "RO", "642", "", "02", "9538", "", "46.43372", "21.84048", "Europe/Bucharest"),("675703", "Ighiu", "", "RO", "642", "", "01", "4927", "", "46.15", "23.51667", "Europe/Bucharest"),("675727", "Iernut", "", "RO", "642", "", "27", "117827", "", "46.45", "24.25", "Europe/Bucharest"),("675810", "Iaşi", "Яссы", "RO", "642", "", "23", "95060", "", "47.16667", "27.6", "Europe/Bucharest"),("675840", "Ianca", "", "RO", "642", "", "08", "43331", "", "45.13333", "27.45", "Europe/Bucharest"),("675892", "Huşi", "Гуси", "RO", "642", "", "38", "161829", "", "46.67361", "28.05944", "Europe/Bucharest"),("675918", "Hunedoara", "Хунедоара", "RO", "642", "", "21", "86810", "", "45.75", "22.9", "Europe/Bucharest"),("675937", "Huedin", "", "RO", "642", "", "13", "55446", "", "46.86667", "23.05", "Europe/Bucharest"),("675941", "Hudeşti", "", "RO", "642", "", "07", "37770", "", "48.15", "26.5", "Europe/Bucharest"),("675968", "Hotarele", "", "RO", "642", "", "42", "103639", "", "44.1725", "26.37028", "Europe/Bucharest"),("675983", "Horodnic de Sus", "", "RO", "642", "", "34", "151479", "", "47.84012", "25.82354", "Europe/Bucharest"),("676026", "Horezu", "", "RO", "642", "", "39", "168041", "", "45.15", "24.01667", "Europe/Bucharest"),("676063", "Homocea", "", "RO", "642", "", "40", "176445", "", "46.13333", "27.23333", "Europe/Bucharest"),("676078", "Holboca", "", "RO", "642", "", "23", "95159", "", "47.15", "27.7", "Europe/Bucharest"),("676163", "Hârşova", "", "RO", "642", "", "14", "60801", "", "44.68574", "27.94819", "Europe/Bucharest"),("676176", "Hârlău", "", "RO", "642", "", "23", "95355", "", "47.43333", "26.9", "Europe/Bucharest"),("676262", "Helegiu", "", "RO", "642", "", "04", "22898", "", "46.35", "26.75", "Europe/Bucharest"),("676268", "Havârna", "", "RO", "642", "", "07", "37547", "", "48.06667", "26.65", "Europe/Bucharest"),("676277", "Haţeg", "", "RO", "642", "", "21", "87576", "", "45.61667", "22.95", "Europe/Bucharest"),("676351", "Halmeu", "", "RO", "642", "", "32", "137764", "", "47.96667", "23.01667", "Europe/Bucharest"),("676368", "Hălchiu", "", "RO", "642", "", "09", "41033", "", "45.76667", "25.55", "Europe/Bucharest"),("676371", "Hălăuceşti", "", "RO", "642", "", "23", "97438", "", "47.1", "26.8", "Europe/Bucharest"),("676438", "Gurghiu", "", "RO", "642", "", "27", "117319", "", "46.76667", "24.85", "Europe/Bucharest"),("676455", "Gura Viţioarei", "", "RO", "642", "", "30", "131835", "", "45.15", "26.03333", "Europe/Bucharest"),("676462", "Gura Văii", "", "RO", "642", "", "04", "21454", "", "46.33333", "26.73333", "Europe/Bucharest"),("676481", "Gura Şuţii", "", "RO", "642", "", "16", "67648", "", "44.75", "25.51667", "Europe/Bucharest"),("676527", "Gura Humorului", "", "RO", "642", "", "34", "146584", "", "47.55", "25.9", "Europe/Bucharest"),("676588", "Gugeşti", "", "RO", "642", "", "40", "176301", "", "45.56667", "27.13333", "Europe/Bucharest"),("676604", "Grumăzeşti", "", "RO", "642", "", "28", "122908", "", "47.13333", "26.36667", "Europe/Bucharest"),("676617", "Gruiu", "", "RO", "642", "", "43", "103513", "", "44.73333", "26.23333", "Europe/Bucharest"),("676706", "Griviţa", "", "RO", "642", "", "38", "164133", "", "46.15", "27.65", "Europe/Bucharest"),("676708", "Griviţa", "", "RO", "642", "", "22", "93735", "", "44.73333", "27.28333", "Europe/Bucharest"),("676755", "Greci", "", "RO", "642", "", "37", "160430", "", "45.18333", "28.23333", "Europe/Bucharest"),("676819", "Grădiştea", "", "RO", "642", "", "41", "93664", "", "44.23333", "27.21667", "Europe/Bucharest"),("676892", "Gorneşti", "", "RO", "642", "", "27", "117177", "", "46.67129", "24.64757", "Europe/Bucharest"),("676907", "Gorgota", "", "RO", "642", "", "30", "133508", "", "44.78333", "26.08333", "Europe/Bucharest"),("676976", "Gogoşu", "", "RO", "642", "", "26", "111863", "", "44.37389", "22.59306", "Europe/Bucharest"),("677060", "Glina", "", "RO", "642", "", "43", "179347", "", "44.38333", "26.25", "Europe/Bucharest"),("677106", "Giurgiu", "", "RO", "642", "", "42", "100521", "", "43.88333", "25.96667", "Europe/Bucharest"),("677158", "Girov", "", "RO", "642", "", "28", "122702", "", "46.95", "26.51667", "Europe/Bucharest"),("677186", "Gârla-Mare", "", "RO", "642", "", "26", "111783", "", "44.20917", "22.775", "Europe/Bucharest"),("677283", "Gilău", "", "RO", "642", "", "13", "57902", "", "46.73245", "23.36174", "Europe/Bucharest"),("677294", "Giarmata", "", "RO", "642", "", "36", "157246", "", "45.83833", "21.31083", "Europe/Bucharest"),("677377", "Ghimeş-Făget", "", "RO", "642", "", "04", "22718", "", "46.58333", "26.06667", "Europe/Bucharest"),("677407", "Ghidigeni", "", "RO", "642", "", "18", "76406", "", "46.05", "27.5", "Europe/Bucharest"),("677429", "Gherla", "Герла", "RO", "642", "", "13", "55384", "", "47.03333", "23.91667", "Europe/Bucharest"),("677454", "Gherăeşti", "", "RO", "642", "", "28", "122668", "", "47.01667", "26.81667", "Europe/Bucharest"),("677458", "Gheorgheni", "", "RO", "642", "", "20", "83561", "", "46.72292", "25.60055", "Europe/Bucharest"),("677520", "Geoagiu", "", "RO", "642", "", "21", "89561", "", "45.91667", "23.2", "Europe/Bucharest"),("677581", "Gătaia", "", "RO", "642", "", "36", "157086", "", "45.43111", "21.43", "Europe/Bucharest"),("677697", "Galaţi", "Галац", "RO", "642", "", "18", "75098", "", "45.45", "28.05", "Europe/Bucharest"),("677709", "Gălăneşti", "", "RO", "642", "", "34", "148872", "", "47.91667", "25.8", "Europe/Bucharest"),("677712", "Găiseni", "", "RO", "642", "", "42", "103087", "", "44.515", "25.64528", "Europe/Bucharest"),("677742", "Găeşti", "", "RO", "642", "", "16", "65681", "", "44.71667", "25.31667", "Europe/Bucharest"),("677790", "Fundulea", "", "RO", "642", "", "41", "103032", "", "44.46667", "26.51667", "Europe/Bucharest"),("677812", "Fundeni", "", "RO", "642", "", "41", "103014", "", "44.38333", "26.35", "Europe/Bucharest"),("677870", "Frumuşiţa", "", "RO", "642", "", "18", "76317", "", "45.66667", "28.06667", "Europe/Bucharest"),("677872", "Frumuşica", "", "RO", "642", "", "07", "37324", "", "47.53333", "26.9", "Europe/Bucharest"),("677880", "Frumuşani", "", "RO", "642", "", "41", "102945", "", "44.29611", "26.32556", "Europe/Bucharest"),("677918", "Frăteşti", "", "RO", "642", "", "42", "102909", "", "43.96667", "25.96667", "Europe/Bucharest"),("677923", "Frătăuţii Noi", "", "RO", "642", "", "34", "148667", "", "47.94257", "25.84465", "Europe/Bucharest"),("677964", "Frasin", "", "RO", "642", "", "34", "148612", "", "47.53333", "25.8", "Europe/Bucharest"),("678013", "Focuri", "", "RO", "642", "", "23", "97063", "", "47.35", "27.21667", "Europe/Bucharest"),("678015", "Focșani", "", "RO", "642", "", "40", "174744", "", "45.7", "27.18333", "Europe/Bucharest"),("678050", "Floreşti", "", "RO", "642", "", "13", "57706", "", "46.74574", "23.49375", "Europe/Bucharest"),("678063", "Floreşti", "", "RO", "642", "", "30", "133330", "", "45.05", "25.78333", "Europe/Bucharest"),("678162", "Fântânele", "", "RO", "642", "", "02", "9280", "", "46.1237", "21.3842", "Europe/Bucharest"),("678243", "Filipeştii de Târg", "", "RO", "642", "", "30", "133214", "", "44.98333", "25.78333", "Europe/Bucharest"),("678245", "Filipeştii de Pădure", "", "RO", "642", "", "30", "133161", "", "45", "25.75", "Europe/Bucharest"),("678261", "Filiaşi", "", "RO", "642", "", "17", "70414", "", "44.55", "23.51667", "Europe/Bucharest"),("678290", "Fieni", "", "RO", "642", "", "16", "65609", "", "45.13333", "25.41667", "Europe/Bucharest"),("678301", "Fetești-Gară", "", "RO", "642", "", "22", "92701", "", "44.4196", "27.82536", "Europe/Bucharest"),("678306", "Feteşti", "", "RO", "642", "", "22", "92701", "", "44.38333", "27.83333", "Europe/Bucharest"),("678348", "Felnac", "", "RO", "642", "", "02", "10827", "", "46.11667", "21.15", "Europe/Bucharest"),("678358", "Feldru", "", "RO", "642", "", "06", "33248", "", "47.28333", "24.6", "Europe/Bucharest"),("678361", "Feldioara", "", "RO", "642", "", "09", "40955", "", "45.81667", "25.6", "Europe/Bucharest"),("678430", "Fărcaşele", "", "RO", "642", "", "29", "127019", "", "44.15", "24.43333", "Europe/Bucharest"),("678451", "Faraoaní", "", "RO", "642", "", "04", "22460", "", "46.43333", "26.9", "Europe/Bucharest"),("678459", "Fălticeni", "Фэлтичени", "RO", "642", "", "34", "146539", "", "47.45", "26.3", "Europe/Bucharest"),("678465", "Fălciu", "", "RO", "642", "", "38", "163832", "", "46.29611", "28.14083", "Europe/Bucharest"),("678490", "Făget", "", "RO", "642", "", "36", "156801", "", "45.85", "22.18333", "Europe/Bucharest"),("678499", "Făgăraș", "Фэгэраш", "RO", "642", "", "09", "40278", "", "45.85", "24.96667", "Europe/Bucharest"),("678513", "Făcăeni", "", "RO", "642", "", "22", "93575", "", "44.56667", "27.9", "Europe/Bucharest"),("678535", "Ernei", "", "RO", "642", "", "27", "116652", "", "46.60505", "24.64148", "Europe/Bucharest"),("678552", "Erbiceni", "", "RO", "642", "", "23", "97009", "", "47.26667", "27.23333", "Europe/Bucharest"),("678588", "Eforie Sud", "", "RO", "642", "", "14", "60455", "", "44.02294", "28.64943", "Europe/Bucharest"),("678700", "Dumbrăveni", "", "RO", "642", "", "34", "148426", "", "47.65", "26.41667", "Europe/Bucharest"),("678704", "Dumbrăveni", "", "RO", "642", "", "33", "143806", "", "46.23333", "24.56667", "Europe/Bucharest"),("678715", "Dumbrava Roşie", "", "RO", "642", "", "28", "120771", "", "46.88333", "26.43333", "Europe/Bucharest"),("678782", "Dudeştii Vechi", "", "RO", "642", "", "36", "156712", "", "46.05", "20.48333", "Europe/Bucharest"),("678792", "Duda", "", "RO", "642", "", "38", "163681", "", "46.7525", "28.03722", "Europe/Bucharest"),("678817", "Drobeta-Turnu Severin", "Дробета-Турну-Северин", "RO", "642", "", "26", "109773", "", "44.63194", "22.65611", "Europe/Bucharest"),("678831", "Dridu", "", "RO", "642", "", "22", "102703", "", "44.7", "26.45", "Europe/Bucharest"),("678868", "Drajna de Jos", "", "RO", "642", "", "30", "132896", "", "45.21667", "26.05", "Europe/Bucharest"),("678871", "Drăguţeşti", "", "RO", "642", "", "19", "78016", "", "44.96667", "23.23333", "Europe/Bucharest"),("678886", "Drăguşeni", "", "RO", "642", "", "18", "76175", "", "45.96667", "27.75", "Europe/Bucharest"),("678926", "Dragomireşti", "", "RO", "642", "", "16", "67407", "", "44.91667", "25.33333", "Europe/Bucharest"),("678954", "Dragodana", "", "RO", "642", "", "16", "67327", "", "44.73333", "25.35", "Europe/Bucharest"),("678978", "Drăgăşani", "Дрэгэшани", "RO", "642", "", "39", "167981", "", "44.65", "24.26667", "Europe/Bucharest"),("678987", "Drăgăneşti-Olt", "", "RO", "642", "", "29", "125622", "", "44.16667", "24.53333", "Europe/Bucharest"),("678999", "Drăgăneşti", "", "RO", "642", "", "18", "75221", "", "45.78333", "27.46667", "Europe/Bucharest"),("679002", "Drăgăneşti", "", "RO", "642", "", "30", "133018", "", "44.81667", "26.3", "Europe/Bucharest"),("679011", "Dragalina", "", "RO", "642", "", "41", "93487", "", "44.43333", "27.31667", "Europe/Bucharest"),("679065", "Dorohoi", "Дорохой", "RO", "642", "", "07", "36006", "", "47.95", "26.4", "Europe/Bucharest"),("679095", "Dor Mărunt", "", "RO", "642", "", "41", "93370", "", "44.45", "26.91667", "Europe/Bucharest"),("679112", "Domneşti-Sârbi", "", "RO", "642", "", "43", "102035", "", "44.38333", "25.91667", "Europe/Bucharest"),("679119", "Domnești", "", "RO", "642", "RO", "43", "102570", "", "44.39919", "25.91618", "Europe/Bucharest"),("679133", "Doljeşti", "", "RO", "642", "", "28", "122347", "", "47.03333", "26.98333", "Europe/Bucharest"),("679146", "Dolhasca", "", "RO", "642", "", "34", "148006", "", "47.43333", "26.6", "Europe/Bucharest"),("679167", "Dofteana", "", "RO", "642", "", "04", "22380", "", "46.31667", "26.51667", "Europe/Bucharest"),("679171", "Doftana", "", "RO", "642", "", "30", "135789", "", "45.15", "25.8", "Europe/Bucharest"),("679177", "Ștei", "", "RO", "642", "", "05", "26840", "", "46.53333", "22.45", "Europe/Bucharest"),("679202", "Dobroteşti", "", "RO", "642", "", "35", "152760", "", "44.28333", "24.88333", "Europe/Bucharest"),("679220", "Dobroeşti", "", "RO", "642", "", "43", "179310", "", "44.45", "26.18333", "Europe/Bucharest"),("679248", "Dobreşti", "", "RO", "642", "", "05", "29154", "", "46.85", "22.3", "Europe/Bucharest"),("679310", "Ditrău", "", "RO", "642", "", "20", "84344", "", "46.81667", "25.51667", "Europe/Bucharest"),("679340", "Diosig", "", "RO", "642", "", "05", "29092", "", "47.3", "22", "Europe/Bucharest"),("679452", "Deva", "Дева", "RO", "642", "", "21", "86687", "", "45.88333", "22.9", "Europe/Bucharest"),("679456", "Deta", "", "RO", "642", "", "36", "155458", "", "45.38889", "21.22444", "Europe/Bucharest"),("679467", "Dersca", "", "RO", "642", "", "07", "37011", "", "47.98333", "26.2", "Europe/Bucharest"),("679499", "Deleşti", "", "RO", "642", "", "38", "163379", "", "46.7", "27.55", "Europe/Bucharest"),("679518", "Deleni", "", "RO", "642", "", "23", "96815", "", "47.46667", "26.88333", "Europe/Bucharest"),("679550", "Dej", "Дей", "RO", "642", "", "13", "55008", "", "47.15", "23.86667", "Europe/Bucharest"),("679723", "Dărmăneşti", "", "RO", "642", "", "34", "147937", "", "47.73333", "26.15", "Europe/Bucharest"),("679724", "Dărmăneşti", "", "RO", "642", "", "04", "22166", "", "46.36667", "26.48333", "Europe/Bucharest"),("679726", "Dărmăneşti", "", "RO", "642", "", "16", "67256", "", "44.91667", "25.78333", "Europe/Bucharest"),("679736", "Darabani", "", "RO", "642", "", "07", "35946", "", "48.18333", "26.58333", "Europe/Bucharest"),("679749", "Dăneţi", "", "RO", "642", "", "17", "71956", "", "43.98333", "24.05", "Europe/Bucharest"),("679767", "Dancu", "", "RO", "642", "", "23", "95159", "", "47.15417", "27.66623", "Europe/Bucharest"),("679841", "Dăbuleni", "", "RO", "642", "", "17", "72007", "", "43.8", "24.08333", "Europe/Bucharest"),("679901", "Curtici", "", "RO", "642", "", "02", "9495", "", "46.35", "21.3", "Europe/Bucharest"),("679907", "Curtea de Argeş", "", "RO", "642", "", "03", "13622", "", "45.13422", "24.67409", "Europe/Bucharest"),("679936", "Curcani", "", "RO", "642", "", "41", "102419", "", "44.2", "26.58333", "Europe/Bucharest"),("679968", "Cumpăna", "", "RO", "642", "", "14", "61620", "", "44.11667", "28.56667", "Europe/Bucharest"),("679995", "Cugir", "", "RO", "642", "", "01", "1696", "", "45.83651", "23.36998", "Europe/Bucharest"),("680003", "Cudalbi", "", "RO", "642", "", "18", "76157", "", "45.78333", "27.7", "Europe/Bucharest"),("680148", "Cristuru Secuiesc", "", "RO", "642", "", "20", "83525", "", "46.28333", "25.03333", "Europe/Bucharest"),("680180", "Cristeşti", "", "RO", "642", "", "27", "114355", "", "46.5", "24.48333", "Europe/Bucharest"),("680262", "Crevedia", "", "RO", "642", "", "16", "102286", "", "44.6", "25.93333", "Europe/Bucharest"),("680316", "Crasna", "", "RO", "642", "", "31", "140627", "", "47.16667", "22.9", "Europe/Bucharest"),("680319", "Crasna", "", "RO", "642", "", "19", "79834", "", "45.16667", "23.5", "Europe/Bucharest"),("680332", "Craiova", "Крайова", "RO", "642", "", "17", "69900", "", "44.31667", "23.8", "Europe/Bucharest"),("680430", "Covasna", "", "RO", "642", "", "15", "63526", "", "45.85", "26.18333", "Europe/Bucharest"),("680440", "Coţuşca", "", "RO", "642", "", "07", "36809", "", "48.13333", "26.85", "Europe/Bucharest"),("680491", "Cotnari", "", "RO", "642", "", "23", "96478", "", "47.35", "26.98333", "Europe/Bucharest"),("680581", "Costeşti", "", "RO", "642", "", "03", "13668", "", "44.66667", "24.88333", "Europe/Bucharest"),("680601", "Coşoveni", "", "RO", "642", "", "17", "71885", "", "44.25", "23.93333", "Europe/Bucharest"),("680623", "Cosmeşti", "", "RO", "642", "", "18", "76040", "", "45.87017", "27.31115", "Europe/Bucharest"),("680645", "Coşeşti", "", "RO", "642", "", "03", "15901", "", "45.06667", "24.86667", "Europe/Bucharest"),("680649", "Coşereni", "", "RO", "642", "", "22", "102240", "", "44.68333", "26.56667", "Europe/Bucharest"),("680674", "Corund", "", "RO", "642", "", "20", "84175", "", "46.46667", "25.18333", "Europe/Bucharest"),("680708", "Corod", "", "RO", "642", "", "18", "75953", "", "45.9", "27.61667", "Europe/Bucharest"),("680720", "Cornu Luncii", "", "RO", "642", "", "34", "147786", "", "47.46667", "26.15", "Europe/Bucharest"),("680742", "Corni", "", "RO", "642", "", "07", "36756", "", "47.65", "26.58333", "Europe/Bucharest"),("680754", "Cornetu", "", "RO", "642", "", "43", "102213", "", "44.34167", "25.94083", "Europe/Bucharest"),("680783", "Corneşti", "", "RO", "642", "", "16", "67014", "", "44.78333", "25.86667", "Europe/Bucharest"),("680806", "Cormaia", "", "RO", "642", "", "06", "32599", "", "47.36667", "24.68333", "Europe/Bucharest"),("680831", "Cordun", "", "RO", "642", "", "28", "120888", "", "46.95", "26.86667", "Europe/Bucharest"),("680841", "Corcova", "", "RO", "642", "", "26", "111275", "", "44.7", "23.05", "Europe/Bucharest"),("680870", "Corbu", "", "RO", "642", "", "14", "61513", "", "44.38333", "28.65", "Europe/Bucharest"),("680876", "Corbii Mari", "", "RO", "642", "", "16", "66857", "", "44.55", "25.5", "Europe/Bucharest"),("680888", "Corbeni", "", "RO", "642", "", "03", "15741", "", "45.3", "24.65", "Europe/Bucharest"),("680894", "Corbasca", "", "RO", "642", "", "04", "21971", "", "46.28333", "27.16667", "Europe/Bucharest"),("680897", "Corabia", "", "RO", "642", "", "29", "125542", "", "43.78333", "24.5", "Europe/Bucharest"),("680901", "Copşa Mică", "", "RO", "642", "", "33", "143771", "", "46.11667", "24.25", "Europe/Bucharest"),("680907", "Copalnic Mănăştur", "", "RO", "642", "", "25", "107733", "", "47.5", "23.68333", "Europe/Bucharest"),("680911", "Copălău", "", "RO", "642", "", "07", "36569", "", "47.61667", "26.83333", "Europe/Bucharest"),("680963", "Constanţa", "Констанца", "RO", "642", "", "14", "60419", "", "44.18073", "28.63432", "Europe/Bucharest"),("680998", "Comişani", "", "RO", "642", "", "16", "66731", "", "44.88333", "25.58333", "Europe/Bucharest"),("681005", "Comarnic", "", "RO", "642", "", "30", "131336", "", "45.25", "25.63333", "Europe/Bucharest"),("681017", "Comăneşti", "", "RO", "642", "", "04", "20821", "", "46.42135", "26.43645", "Europe/Bucharest"),("681036", "Comana", "", "RO", "642", "", "42", "102106", "", "44.17056", "26.145", "Europe/Bucharest"),("681125", "Colceag", "", "RO", "642", "", "30", "132752", "", "44.95", "26.35", "Europe/Bucharest"),("681151", "Cojasca", "", "RO", "642", "", "16", "66697", "", "44.71667", "25.85", "Europe/Bucharest"),("681160", "Cogealac", "", "RO", "642", "", "14", "61372", "", "44.55", "28.56667", "Europe/Bucharest"),("681179", "Codlea", "", "RO", "642", "", "09", "40241", "", "45.7", "25.45", "Europe/Bucharest"),("681228", "Cochirleanca", "", "RO", "642", "", "11", "46377", "", "45.21667", "27.03333", "Europe/Bucharest"),("681257", "Cobadin", "", "RO", "642", "", "14", "61318", "", "44.08333", "28.21667", "Europe/Bucharest"),("681290", "Cluj-Napoca", "Клуж-Напока", "RO", "642", "", "13", "54975", "", "46.76667", "23.6", "Europe/Bucharest"),("681340", "Cleja", "", "RO", "642", "", "04", "21855", "", "46.41667", "26.9", "Europe/Bucharest"),("681384", "Ciurea", "", "RO", "642", "", "23", "96254", "", "47.05", "27.56667", "Europe/Bucharest"),("681397", "Ciupercenii Noi", "", "RO", "642", "", "17", "71858", "", "43.90972", "22.94833", "Europe/Bucharest"),("681502", "Cisnădie", "", "RO", "642", "", "33", "143735", "", "45.71667", "24.15", "Europe/Bucharest"),("681523", "Cârţa", "", "RO", "642", "", "20", "84102", "", "46.53333", "25.75", "Europe/Bucharest"),("681624", "Ciprian Porumbescu", "", "RO", "642", "", "34", "151567", "", "47.56667", "26.06667", "Europe/Bucharest"),("681669", "Cioranii de Jos", "", "RO", "642", "", "30", "132681", "", "44.81667", "26.41667", "Europe/Bucharest"),("681747", "Ciocăneşti", "", "RO", "642", "", "16", "101840", "", "44.6", "25.85", "Europe/Bucharest"),("681845", "Câmpulung Moldovenesc", "", "RO", "642", "", "34", "146502", "", "47.53333", "25.56667", "Europe/Bucharest"),("681862", "Câmpina", "Кымпина", "RO", "642", "RO", "30", "131256", "", "45.12619", "25.73496", "Europe/Bucharest"),("681865", "Câmpia Turzii", "", "RO", "642", "", "13", "55357", "", "46.55", "23.88333", "Europe/Bucharest"),("681876", "Câmpeni", "", "RO", "642", "", "01", "1455", "", "46.36667", "23.05", "Europe/Bucharest"),("681971", "Ciacova", "", "RO", "642", "", "36", "156357", "", "45.50806", "21.12861", "Europe/Bucharest"),("681990", "Chitila", "", "RO", "642", "", "43", "179285", "", "44.50806", "25.98222", "Europe/Bucharest"),("682009", "Chişineu-Criş", "", "RO", "642", "", "02", "9459", "", "46.52509", "21.51844", "Europe/Bucharest"),("682020", "Chiscani", "", "RO", "642", "", "08", "42708", "", "45.18333", "27.93333", "Europe/Bucharest"),("682036", "Chirnogi", "", "RO", "642", "", "41", "101804", "", "44.11667", "26.56667", "Europe/Bucharest"),("682159", "Chiajna", "", "RO", "642", "", "43", "179249", "", "44.46", "25.97333", "Europe/Bucharest"),("682268", "Cetate", "", "RO", "642", "", "17", "71787", "", "44.1", "23.05", "Europe/Bucharest"),("682282", "Certeze", "", "RO", "642", "", "32", "137407", "", "47.9", "23.46667", "Europe/Bucharest"),("682301", "Cernica", "", "RO", "642", "", "43", "101742", "", "44.41667", "26.28333", "Europe/Bucharest"),("682321", "Cernavodă", "", "RO", "642", "", "14", "60776", "", "44.33957", "28.03273", "Europe/Bucharest"),("682399", "Ceraşu", "", "RO", "642", "", "30", "132574", "", "45.31667", "26.03333", "Europe/Bucharest"),("682403", "Ceptura de Sus", "", "RO", "642", "", "30", "132510", "", "45.01667", "26.31667", "Europe/Bucharest"),("682436", "Celaru", "", "RO", "642", "", "17", "71634", "", "44.05", "24.13333", "Europe/Bucharest"),("682452", "Cefa", "", "RO", "642", "", "05", "28246", "", "46.91667", "21.73333", "Europe/Bucharest"),("682508", "Cavnic", "", "RO", "642", "", "25", "106782", "", "47.66667", "23.86667", "Europe/Bucharest"),("682589", "Castelu", "", "RO", "642", "", "14", "61121", "", "44.25", "28.33333", "Europe/Bucharest"),("682660", "Cărpiniş", "", "RO", "642", "", "36", "156213", "", "45.78722", "20.90417", "Europe/Bucharest"),("682685", "Carei", "Карей", "RO", "642", "", "32", "136526", "", "47.68333", "22.46667", "Europe/Bucharest"),("682729", "Caransebeş", "Карансебеше", "RO", "642", "", "12", "51010", "", "45.41667", "22.21667", "Europe/Bucharest"),("682747", "Caracal", "", "RO", "642", "", "29", "125472", "", "44.11667", "24.35", "Europe/Bucharest"),("682912", "Călugăreni", "", "RO", "642", "", "42", "101662", "", "44.17167", "25.99556", "Europe/Bucharest"),("682958", "Călineşti", "", "RO", "642", "", "03", "15108", "", "44.81667", "25.05", "Europe/Bucharest"),("682972", "Călimăneşti", "", "RO", "642", "", "39", "167909", "", "45.23333", "24.33333", "Europe/Bucharest"),("683023", "Călăraşi", "", "RO", "642", "", "17", "71607", "", "43.8", "24.05", "Europe/Bucharest"),("683030", "Călan", "", "RO", "642", "", "21", "87424", "", "45.73333", "22.98333", "Europe/Bucharest"),("683033", "Calafindeşti", "", "RO", "642", "", "34", "147580", "", "47.85", "26.11667", "Europe/Bucharest"),("683034", "Calafat", "", "RO", "642", "", "17", "70352", "", "43.99111", "22.93278", "Europe/Bucharest"),("683041", "Cajvana", "", "RO", "642", "", "34", "147633", "", "47.7", "25.96667", "Europe/Bucharest"),("683042", "Căiuţi-Sat", "", "RO", "642", "", "04", "21757", "", "46.18333", "26.93333", "Europe/Bucharest"),("683050", "Căianu Mic", "", "RO", "642", "", "06", "32811", "", "47.23333", "24.15", "Europe/Bucharest"),("683100", "Buzoeşti", "", "RO", "642", "", "03", "14940", "", "44.58333", "24.91667", "Europe/Bucharest"),("683105", "Buziaş", "", "RO", "642", "", "36", "155403", "", "45.64917", "21.60361", "Europe/Bucharest"),("683123", "Buzău", "Бузэу", "RO", "642", "", "11", "44818", "", "45.15", "26.83333", "Europe/Bucharest"),("683179", "Buşteni", "", "RO", "642", "", "30", "131210", "", "45.4", "25.53333", "Europe/Bucharest"),("683202", "Burueneşti", "", "RO", "642", "", "11", "48325", "", "45.31667", "26.35", "Europe/Bucharest"),("683294", "Bumbeşti-Jiu", "", "RO", "642", "", "19", "79308", "", "45.16667", "23.4", "Europe/Bucharest"),("683365", "Buhuşi", "", "RO", "642", "", "04", "20778", "", "46.71667", "26.7", "Europe/Bucharest"),("683394", "Buftea", "", "RO", "642", "", "43", "100576", "", "44.56139", "25.94889", "Europe/Bucharest"),("683445", "Budeşti", "", "RO", "642", "", "39", "168791", "", "45.05", "24.38333", "Europe/Bucharest"),("683447", "Budeşti", "", "RO", "642", "", "41", "101458", "", "44.23472", "26.46583", "Europe/Bucharest"),("683506", "Bucharest", "Бухарест", "RO", "642", "", "10", "179132", "11055044", "44.43225", "26.10626", "Europe/Bucharest"),("683517", "Bucu", "", "RO", "642", "", "22", "93021", "", "44.60532", "27.49337", "Europe/Bucharest"),("683528", "Bucşani", "", "RO", "642", "", "16", "66474", "", "44.86667", "25.65", "Europe/Bucharest"),("683547", "Bucov", "", "RO", "642", "", "30", "130785", "", "44.96667", "26.08333", "Europe/Bucharest"),("683602", "Bucecea", "", "RO", "642", "", "07", "36453", "", "47.76667", "26.43333", "Europe/Bucharest"),("683612", "Brusturi", "", "RO", "642", "", "28", "121938", "", "47.28333", "26.38333", "Europe/Bucharest"),("683637", "Broşteni", "", "RO", "642", "", "34", "147358", "", "47.23333", "25.7", "Europe/Bucharest"),("683695", "Brezoi", "", "RO", "642", "", "39", "167794", "", "45.33797", "24.24863", "Europe/Bucharest"),("683725", "Brebu Mânăstirei", "", "RO", "642", "", "30", "132404", "", "45.18333", "25.76667", "Europe/Bucharest"),("683749", "Breaza de Sus", "", "RO", "642", "RO", "30", "131103", "", "45.19879", "25.65578", "Europe/Bucharest"),("683760", "Breaza", "", "RO", "642", "", "30", "131103", "", "45.18333", "25.66667", "Europe/Bucharest"),("683765", "Brazii de Sus", "", "RO", "642", "", "30", "130712", "", "44.86667", "26.01667", "Europe/Bucharest"),("683837", "Bratca", "", "RO", "642", "", "05", "27686", "", "46.93333", "22.61667", "Europe/Bucharest"),("683844", "Braşov", "Брашов", "RO", "642", "", "09", "40198", "", "45.64861", "25.60613", "Europe/Bucharest"),("683884", "Brăneşti", "", "RO", "642", "", "16", "66009", "", "45.03333", "25.41667", "Europe/Bucharest"),("683886", "Brăneşti", "", "RO", "642", "", "43", "101298", "", "44.45", "26.33333", "Europe/Bucharest"),("683890", "Bran", "", "RO", "642", "", "09", "40633", "", "45.51667", "25.35", "Europe/Bucharest"),("683902", "Brăila", "", "RO", "642", "", "08", "42682", "", "45.26667", "27.98333", "Europe/Bucharest"),("683907", "Brăhăşeştii de Sus", "", "RO", "642", "", "18", "75766", "", "46.05", "27.35", "Europe/Bucharest"),("683914", "Bragadiru", "", "RO", "642", "", "43", "179221", "", "44.37111", "25.9775", "Europe/Bucharest"),("683933", "Bradu", "", "RO", "642", "", "03", "13276", "", "44.78333", "24.9", "Europe/Bucharest"),("683974", "Brad", "", "RO", "642", "", "21", "87291", "", "46.13333", "22.78333", "Europe/Bucharest"),("684039", "Botoşani", "", "RO", "642", "", "07", "35731", "", "47.75", "26.66667", "Europe/Bucharest"),("684045", "Botoroaga", "", "RO", "642", "", "35", "152172", "", "44.14833", "25.54472", "Europe/Bucharest"),("684116", "Bosanci", "", "RO", "642", "", "34", "147134", "", "47.58333", "26.31667", "Europe/Bucharest"),("684156", "Borşa", "", "RO", "642", "", "25", "106746", "", "47.65527", "24.66328", "Europe/Bucharest"),("684190", "Borleşti", "", "RO", "642", "", "28", "121732", "", "46.76667", "26.48333", "Europe/Bucharest"),("684203", "Borduşani", "", "RO", "642", "", "22", "92989", "", "44.48333", "27.9", "Europe/Bucharest"),("684226", "Borcea", "", "RO", "642", "", "41", "92961", "", "44.33333", "27.75", "Europe/Bucharest"),("684230", "Borca", "", "RO", "642", "", "28", "121652", "", "47.18333", "25.76667", "Europe/Bucharest"),("684266", "Bolintin Vale", "", "RO", "642", "", "42", "101190", "", "44.44889", "25.75778", "Europe/Bucharest"),("684269", "Bolintin Deal", "", "RO", "642", "", "42", "101163", "", "44.45917", "25.82111", "Europe/Bucharest"),("684280", "Boldeşti-Scăeni", "", "RO", "642", "", "30", "131069", "", "45.03333", "26.03333", "Europe/Bucharest"),("684461", "Bodeşti", "", "RO", "642", "", "28", "121607", "", "47.03333", "26.41667", "Europe/Bucharest"),("684490", "Bocşa", "", "RO", "642", "", "12", "50969", "", "45.37333", "21.70917", "Europe/Bucharest"),("684583", "Blejoi", "", "RO", "642", "", "30", "130678", "", "45", "26.01667", "Europe/Bucharest"),("684612", "Blaj", "Блай", "RO", "642", "", "01", "1348", "", "46.17508", "23.91578", "Europe/Bucharest"),("684619", "Blăgeşti", "", "RO", "642", "", "04", "21506", "", "46.68333", "26.65", "Europe/Bucharest"),("684630", "Bixad", "", "RO", "642", "", "32", "137069", "", "47.93333", "23.4", "Europe/Bucharest"),("684657", "Bistriţa", "", "RO", "642", "", "06", "32394", "", "47.13316", "24.50011", "Europe/Bucharest"),("684770", "Bârsana", "", "RO", "642", "", "25", "107314", "", "47.81667", "24.06667", "Europe/Bucharest"),("684802", "Bârlad", "", "RO", "642", "", "38", "161794", "", "46.23175", "27.66907", "Europe/Bucharest"),("684805", "Bârla", "", "RO", "642", "", "03", "14450", "", "44.42606", "24.77743", "Europe/Bucharest"),("684855", "Biled", "", "RO", "642", "", "36", "155911", "", "45.88639", "20.95889", "Europe/Bucharest"),("684924", "Bicaz", "", "RO", "642", "", "28", "120968", "", "46.91667", "26.06667", "Europe/Bucharest"),("684948", "Bezdead", "", "RO", "642", "", "16", "66330", "", "45.15", "25.51667", "Europe/Bucharest"),("684970", "Berzunţi", "", "RO", "642", "", "04", "21418", "", "46.4", "26.63333", "Europe/Bucharest"),("685018", "Berezeni", "", "RO", "642", "", "38", "162498", "", "46.37611", "28.14778", "Europe/Bucharest"),("685025", "Bereşti-Tazlău", "", "RO", "642", "", "04", "21338", "", "46.46667", "26.66667", "Europe/Bucharest"),("685076", "Berceni", "", "RO", "642", "", "30", "130614", "", "44.93333", "26.11667", "Europe/Bucharest"),("685081", "Berca", "", "RO", "642", "", "11", "45101", "", "45.28333", "26.68333", "Europe/Bucharest"),("685088", "Berbeşti", "", "RO", "642", "", "39", "168602", "", "44.98333", "23.88333", "Europe/Bucharest"),("685163", "Belceşti", "", "RO", "642", "", "23", "95872", "", "47.3", "27.08333", "Europe/Bucharest"),("685174", "Beiuş", "", "RO", "642", "", "05", "26804", "", "46.66667", "22.35", "Europe/Bucharest"),("685204", "Beclean", "", "RO", "642", "", "06", "32483", "", "47.18333", "24.18333", "Europe/Bucharest"),("685279", "Batăr", "", "RO", "642", "", "05", "27383", "", "46.7", "21.81667", "Europe/Bucharest"),("685305", "Başcov", "", "RO", "642", "", "03", "13187", "", "44.9", "24.81667", "Europe/Bucharest"),("685346", "Barcea", "", "RO", "642", "", "18", "75515", "", "45.75", "27.46667", "Europe/Bucharest"),("685354", "Bărcăneşti", "", "RO", "642", "", "30", "130552", "", "44.88333", "26.05", "Europe/Bucharest"),("685366", "Bărbuleţu", "", "RO", "642", "", "16", "66223", "", "45.13333", "25.3", "Europe/Bucharest"),("685419", "Baraolt", "", "RO", "642", "", "15", "63447", "", "46.07514", "25.60029", "Europe/Bucharest"),("685462", "Băneşti", "", "RO", "642", "", "30", "132315", "", "45.1", "25.76667", "Europe/Bucharest"),("685476", "Băneasa", "", "RO", "642", "", "14", "61069", "", "44.06667", "27.7", "Europe/Bucharest"),("685477", "Băneasa", "", "RO", "642", "", "42", "101001", "", "44.04611", "26.06417", "Europe/Bucharest"),("685481", "Band", "", "RO", "642", "", "27", "115389", "", "46.58333", "24.38333", "Europe/Bucharest"),("685490", "Banca", "", "RO", "642", "", "38", "162194", "", "46.3", "27.8", "Europe/Bucharest"),("685506", "Băluşeni", "", "RO", "642", "", "07", "36300", "", "47.66667", "26.8", "Europe/Bucharest"),("685547", "Bălţaţi", "", "RO", "642", "", "23", "95792", "", "47.21667", "27.15", "Europe/Bucharest"),("685551", "Bălţăteşti", "", "RO", "642", "", "28", "121242", "", "47.11667", "26.3", "Europe/Bucharest"),("685586", "Balş", "", "RO", "642", "", "29", "125418", "", "44.35", "24.1", "Europe/Bucharest"),("685590", "Baloteşti", "", "RO", "642", "", "43", "100969", "", "44.61667", "26.11667", "Europe/Bucharest"),("685628", "Băleşti", "", "RO", "642", "", "19", "77910", "", "45.01667", "23.21667", "Europe/Bucharest"),("685630", "Băleni Sârbi", "", "RO", "642", "", "16", "66198", "", "44.81667", "25.63333", "Europe/Bucharest"),("685657", "Bălceşti", "", "RO", "642", "", "39", "168452", "", "44.61667", "23.95", "Europe/Bucharest"),("685662", "Balcani", "", "RO", "642", "", "04", "21196", "", "46.63333", "26.55", "Europe/Bucharest"),("685707", "Bălan", "", "RO", "642", "", "20", "83464", "", "46.6505", "25.80834", "Europe/Bucharest"),("685785", "Băileşti", "", "RO", "642", "", "17", "70316", "", "44.01667", "23.35", "Europe/Bucharest"),("685796", "Băile Herculane", "", "RO", "642", "", "12", "50923", "", "44.87972", "22.4125", "Europe/Bucharest"),("685810", "Băiculeşti", "", "RO", "642", "", "03", "14165", "", "45.06667", "24.7", "Europe/Bucharest"),("685811", "Băicoi", "", "RO", "642", "", "30", "130981", "", "45.03333", "25.85", "Europe/Bucharest"),("685823", "Baia Sprie", "", "RO", "642", "", "25", "106684", "", "47.66189", "23.69215", "Europe/Bucharest"),("685826", "Baia Mare", "Бая-Маре", "RO", "642", "", "25", "106318", "", "47.65729", "23.56808", "Europe/Bucharest"),("685841", "Baia", "", "RO", "642", "", "34", "146904", "", "47.41667", "26.21667", "Europe/Bucharest"),("685927", "Baciu", "", "RO", "642", "", "13", "55838", "", "46.8", "23.51667", "Europe/Bucharest"),("685948", "Bacău", "", "RO", "642", "", "04", "20297", "", "46.56718", "26.91384", "Europe/Bucharest"),("685981", "Băbeni", "", "RO", "642", "", "39", "168372", "", "44.96667", "24.23333", "Europe/Bucharest"),("685994", "Băbăiţa", "", "RO", "642", "", "35", "152038", "", "44.16667", "25.38333", "Europe/Bucharest"),("685997", "Babadag", "", "RO", "642", "", "37", "159650", "", "44.9", "28.71667", "Europe/Bucharest"),("686011", "Avrig", "", "RO", "642", "", "33", "144054", "", "45.71667", "24.38333", "Europe/Bucharest"),("686028", "Avrămeni", "", "RO", "642", "", "07", "36202", "", "48.01667", "26.95", "Europe/Bucharest"),("686090", "Asău", "", "RO", "642", "", "04", "21123", "", "46.43333", "26.4", "Europe/Bucharest"),("686145", "Armăşeşti", "", "RO", "642", "", "22", "100870", "", "44.75", "26.58333", "Europe/Bucharest"),("686175", "Ariceştii-Rahtivani", "", "RO", "642", "", "30", "132075", "", "44.95", "25.83333", "Europe/Bucharest"),("686206", "Ardud", "", "RO", "642", "", "32", "136848", "", "47.63333", "22.88333", "Europe/Bucharest"),("686239", "Arbore", "", "RO", "642", "", "34", "146860", "", "47.73333", "25.93333", "Europe/Bucharest"),("686254", "Arad", "Арад", "RO", "642", "", "02", "9262", "", "46.18333", "21.31667", "Europe/Bucharest"),("686288", "Apahida", "", "RO", "642", "", "13", "55687", "", "46.81667", "23.75", "Europe/Bucharest"),("686317", "Aninoasa", "", "RO", "642", "", "16", "65379", "", "44.96667", "25.43333", "Europe/Bucharest"),("686324", "Anina", "", "RO", "642", "", "12", "50889", "", "45.07944", "21.85694", "Europe/Bucharest"),("686386", "Amărăştii de Jos", "", "RO", "642", "", "17", "70637", "", "43.95", "24.16667", "Europe/Bucharest"),("686399", "Amara", "", "RO", "642", "", "22", "92836", "", "44.61667", "27.31667", "Europe/Bucharest"),("686502", "Alexandria", "", "RO", "642", "", "35", "151790", "", "43.98333", "25.33333", "Europe/Bucharest"),("686507", "Aleşd", "", "RO", "642", "", "05", "26699", "", "47.06667", "22.41667", "Europe/Bucharest"),("686542", "Albeşti-Paleologu", "", "RO", "642", "", "30", "131933", "", "44.95", "26.21667", "Europe/Bucharest"),("686544", "Albeştii Pământeni", "", "RO", "642", "", "03", "13819", "", "45.21667", "24.66667", "Europe/Bucharest"),("686556", "Albeşti", "", "RO", "642", "", "07", "36131", "", "47.7", "27.06667", "Europe/Bucharest"),("686561", "Albeşti", "", "RO", "642", "", "27", "114603", "", "46.23333", "24.85", "Europe/Bucharest"),("686578", "Alba Iulia", "Алба-Юлия", "RO", "642", "", "01", "1017", "", "46.06667", "23.58333", "Europe/Bucharest"),("686590", "Aiud", "Айуд", "RO", "642", "", "01", "1213", "", "46.31006", "23.72128", "Europe/Bucharest"),("686616", "Agnita", "", "RO", "642", "", "33", "143682", "", "45.96667", "24.61667", "Europe/Bucharest"),("686626", "Agigea", "", "RO", "642", "", "14", "60570", "", "44.08333", "28.61667", "Europe/Bucharest"),("686636", "Agăş", "", "RO", "642", "", "04", "21007", "", "46.48333", "26.21667", "Europe/Bucharest"),("686648", "Afumaţi", "", "RO", "642", "", "43", "100834", "", "44.51667", "26.26667", "Europe/Bucharest"),("686669", "Adjud", "", "RO", "642", "", "40", "174860", "", "46.1", "27.16667", "Europe/Bucharest"),("686673", "Adâncata", "", "RO", "642", "", "34", "146799", "", "47.73333", "26.3", "Europe/Bucharest"),("686684", "Adămuş", "", "RO", "642", "", "27", "115076", "", "46.3", "24.23333", "Europe/Bucharest"),("686712", "Abrud", "", "RO", "642", "", "01", "1151", "", "46.27406", "23.06339", "Europe/Bucharest"),("856315", "1 Decembrie", "", "RO", "642", "", "43", "102543", "", "44.29083", "26.05806", "Europe/Bucharest"),("6697993", "Baia Mare", "Бая-Маре", "RO", "642", "", "32", "", "", "47.65331", "23.57949", "Europe/Bucharest"),("6945426", "Paşcani", "", "RO", "642", "", "23", "95391", "", "47.2469", "26.72291", "Europe/Bucharest"),("7733099", "Mioveni", "", "RO", "642", "", "03", "13301", "", "44.95905", "24.94198", "Europe/Bucharest"),("8436351", "Sighișoara", "Сигишоара", "RO", "642", "", "27", "114514", "", "46.22141", "24.79279", "Europe/Bucharest"),("8581467", "Slobozia", "", "RO", "642", "", "22", "92658", "", "44.5647", "27.3633", "Europe/Bucharest"),("11048317", "Sector 1", "", "RO", "642", "", "10", "179132", "11055041", "44.49239", "26.04831", "Europe/Bucharest"),("11048318", "Sector 2", "", "RO", "642", "", "10", "179132", "11055040", "44.4528", "26.13321", "Europe/Bucharest"),("11048319", "Sector 3", "", "RO", "642", "", "10", "179132", "11055044", "44.4234", "26.16874", "Europe/Bucharest"),("11048320", "Sector 4", "", "RO", "642", "", "10", "179132", "11055042", "44.37571", "26.12085", "Europe/Bucharest"),("11048322", "Sector 5", "", "RO", "642", "", "10", "179132", "11055043", "44.38808", "26.07144", "Europe/Bucharest"),("11048323", "Sector 6", "", "RO", "642", "", "10", "179132", "11055039", "44.43579", "26.01649", "Europe/Bucharest"),("783768", "Zvečka", "", "RS", "688", "", "00", "", "", "44.64025", "20.16432", "Europe/Belgrade"),("783814", "Zrenjanin", "Зренянин", "RS", "688", "", "VO", "2", "80152", "45.38361", "20.38194", "Europe/Belgrade"),("783920", "Zemun", "Земун", "RS", "688", "", "SE", "0", "70157", "44.84306", "20.40111", "Europe/Belgrade"),("784024", "Zaječar", "Заечар", "RS", "688", "", "SE", "15", "70556", "43.90358", "22.26405", "Europe/Belgrade"),("784068", "Žabalj", "", "RS", "688", "", "VO", "6", "784067", "45.37222", "20.06389", "Europe/Belgrade"),("784136", "Vršac", "Вршац", "RS", "688", "", "VO", "4", "784135", "45.11667", "21.30361", "Europe/Belgrade"),("784141", "Vrnjačka Banja", "", "RS", "688", "", "SE", "18", "70459", "43.62725", "20.89634", "Europe/Belgrade"),("784227", "Vranje", "Вране", "RS", "688", "", "SE", "24", "70432", "42.55139", "21.90028", "Europe/Belgrade"),("784352", "Vladimirovac", "", "RS", "688", "", "00", "", "", "45.03122", "20.86566", "Europe/Belgrade"),("784764", "Umka", "", "RS", "688", "", "00", "", "", "44.67806", "20.30472", "Europe/Belgrade"),("784873", "Trstenik", "Трстеник", "RS", "688", "", "SE", "19", "71170", "43.61694", "21.0025", "Europe/Belgrade"),("785062", "Titel", "", "RS", "688", "", "VO", "6", "80454", "45.20611", "20.29444", "Europe/Belgrade"),("785288", "Surčin", "", "RS", "688", "", "SE", "0", "71293", "44.79306", "20.28028", "Europe/Belgrade"),("785559", "Stara Pazova", "", "RS", "688", "", "VO", "7", "80420", "44.985", "20.16083", "Europe/Belgrade"),("785603", "Srpska Crnja", "", "RS", "688", "", "VO", "2", "80250", "45.72538", "20.69008", "Europe/Belgrade"),("785615", "Sremčica", "", "RS", "688", "", "SE", "", "", "44.67653", "20.39232", "Europe/Belgrade"),("785753", "Smederevska Palanka", "Смедеревска-Паланка", "RS", "688", "", "SE", "10", "71102", "44.36548", "20.95885", "Europe/Belgrade"),("785756", "Smederevo", "Смедерево", "RS", "688", "", "SE", "10", "71099", "44.66278", "20.93", "Europe/Belgrade"),("785965", "Senta", "Сента", "RS", "688", "", "VO", "3", "80365", "45.9275", "20.07722", "Europe/Belgrade"),("786690", "Prokuplje", "Прокупле", "RS", "688", "", "SE", "21", "70998", "43.23417", "21.58806", "Europe/Belgrade"),("786827", "Požarevac", "Пожаревац", "RS", "688", "", "SE", "11", "70947", "44.62133", "21.18782", "Europe/Belgrade"),("787050", "Pirot", "Пирот", "RS", "688", "", "SE", "22", "70939", "43.15306", "22.58611", "Europe/Belgrade"),("787215", "Paraćin", "", "RS", "688", "", "SE", "13", "70904", "43.86083", "21.40778", "Europe/Belgrade"),("787237", "Pančevo", "Панчево", "RS", "688", "", "VO", "4", "787236", "44.87083", "20.64028", "Europe/Belgrade"),("787271", "Padina", "", "RS", "688", "", "00", "", "", "45.11988", "20.7286", "Europe/Belgrade"),("787516", "Obrenovac", "", "RS", "688", "", "SE", "0", "70190", "44.65486", "20.20017", "Europe/Belgrade"),("787584", "Novo Miloševo", "", "RS", "688", "", "00", "", "", "45.71916", "20.30364", "Europe/Belgrade"),("787595", "Novi Pazar", "Нови-Пазар", "RS", "688", "", "SE", "18", "70874", "43.13667", "20.51222", "Europe/Belgrade"),("787600", "Novi Kneževac", "", "RS", "688", "", "VO", "3", "80276", "46.05", "20.1", "Europe/Belgrade"),("787615", "Nova Pazova", "", "RS", "688", "", "VO", "", "", "44.94366", "20.21931", "Europe/Belgrade"),("787657", "Niš", "Ниш", "RS", "688", "", "SE", "20", "", "43.32472", "21.90333", "Europe/Belgrade"),("787718", "Negotin", "Неготин", "RS", "688", "", "SE", "14", "70840", "44.22639", "22.53083", "Europe/Belgrade"),("787855", "Mol", "", "RS", "688", "", "00", "", "", "45.76457", "20.13286", "Europe/Belgrade"),("787857", "Mokrin", "", "RS", "688", "", "00", "", "", "45.93362", "20.41215", "Europe/Belgrade"),("788040", "Melenci", "", "RS", "688", "", "00", "", "", "45.5168", "20.31961", "Europe/Belgrade"),("788357", "Majdanpek", "", "RS", "688", "", "SE", "14", "70785", "44.42771", "21.94596", "Europe/Belgrade"),("788709", "Leskovac", "Лесковац", "RS", "688", "", "SE", "23", "70726", "42.99806", "21.94611", "Europe/Belgrade"),("788771", "Lazarevac", "Лазаревац", "RS", "688", "", "SE", "0", "70165", "44.38534", "20.2557", "Europe/Belgrade"),("788792", "Lapovo", "", "RS", "688", "", "SE", "12", "71277", "44.18424", "21.09727", "Europe/Belgrade"),("788975", "Kruševac", "Крушевац", "RS", "688", "", "SE", "19", "70670", "43.58", "21.33389", "Europe/Belgrade"),("789107", "Kraljevo", "Кралево", "RS", "688", "", "SE", "18", "70653", "43.72583", "20.68944", "Europe/Belgrade"),("789128", "Kragujevac", "Крагуевац", "RS", "688", "", "SE", "12", "70645", "44.01667", "20.91667", "Europe/Belgrade"),("789168", "Kovin", "", "RS", "688", "", "VO", "4", "789167", "44.7475", "20.97611", "Europe/Belgrade"),("789170", "Kovilj", "", "RS", "688", "", "VO", "6", "80284", "45.23422", "20.02327", "Europe/Belgrade"),("789178", "Kovačica", "", "RS", "688", "", "VO", "4", "789176", "45.11167", "20.62139", "Europe/Belgrade"),("789518", "Kikinda", "Кикинда", "RS", "688", "", "VO", "3", "80209", "45.82972", "20.46528", "Europe/Belgrade"),("789600", "Kanjiža", "", "RS", "688", "", "VO", "3", "80195", "46.06667", "20.05", "Europe/Belgrade"),("789923", "Jagodina", "Ягодина", "RS", "688", "", "SE", "13", "71048", "43.97713", "21.26121", "Europe/Belgrade"),("790015", "Inđija", "Инджия", "RS", "688", "", "VO", "7", "80179", "45.04816", "20.08165", "Europe/Belgrade"),("790367", "Gornji Milanovac", "", "RS", "688", "", "SE", "17", "70483", "44.02603", "20.46152", "Europe/Belgrade"),("790847", "Ečka", "", "RS", "688", "", "VO", "2", "80152", "45.32328", "20.44294", "Europe/Belgrade"),("791471", "Dobanovci", "", "RS", "688", "", "SE", "0", "71293", "44.82631", "20.22487", "Europe/Belgrade"),("791589", "Debeljača", "", "RS", "688", "", "VO", "4", "80217", "45.0707", "20.60153", "Europe/Belgrade"),("791672", "Čurug", "", "RS", "688", "", "VO", "6", "80136", "45.47221", "20.06861", "Europe/Belgrade"),("791678", "Ćuprija", "Чуприя", "RS", "688", "", "SE", "13", "71200", "43.9275", "21.37", "Europe/Belgrade"),("791887", "Crepaja", "", "RS", "688", "", "VO", "4", "80217", "45.00984", "20.63702", "Europe/Belgrade"),("791900", "Čoka", "", "RS", "688", "", "VO", "3", "80489", "45.9425", "20.14333", "Europe/Belgrade"),("792078", "Čačak", "Чачак", "RS", "688", "", "SE", "17", "71242", "43.89139", "20.34972", "Europe/Belgrade"),("792456", "Bor", "Бор", "RS", "688", "", "SE", "14", "70327", "44.07488", "22.09591", "Europe/Belgrade"),("792651", "Beška", "", "RS", "688", "", "00", "", "", "45.13092", "20.06698", "Europe/Belgrade"),("792680", "Belgrade", "Белград", "RS", "688", "", "SE", "", "", "44.80401", "20.46513", "Europe/Belgrade"),("792794", "Bela Crkva", "", "RS", "688", "", "VO", "4", "792793", "44.8975", "21.41722", "Europe/Belgrade"),("792814", "Bečej", "Бечей", "RS", "688", "", "VO", "6", "3204390", "45.61632", "20.03331", "Europe/Belgrade"),("792866", "Barič", "", "RS", "688", "", "00", "", "", "44.6507", "20.25941", "Europe/Belgrade"),("792945", "Banatski Karlovac", "", "RS", "688", "", "VO", "4", "80039", "45.04987", "21.018", "Europe/Belgrade"),("793014", "Bačko Petrovo Selo", "", "RS", "688", "", "VO", "6", "80110", "45.70681", "20.07928", "Europe/Belgrade"),("793015", "Bačko Gradište", "", "RS", "688", "", "VO", "6", "80110", "45.53271", "20.03082", "Europe/Belgrade"),("793093", "Arilje", "", "RS", "688", "", "SE", "16", "70041", "43.75306", "20.09556", "Europe/Belgrade"),("793111", "Aranđelovac", "Аранджеловац", "RS", "688", "", "SE", "12", "70033", "44.30694", "20.56", "Europe/Belgrade"),("3187297", "Vrbas", "Врбас", "RS", "688", "", "VO", "6", "3187295", "45.57139", "19.64083", "Europe/Belgrade"),("3187829", "Veternik", "", "RS", "688", "", "VO", "6", "80284", "45.25446", "19.7588", "Europe/Belgrade"),("3188402", "Valjevo", "Валево", "RS", "688", "", "SE", "9", "70360", "44.27513", "19.89821", "Europe/Belgrade"),("3188434", "Užice", "Ужице", "RS", "688", "", "SE", "16", "71145", "43.85861", "19.84878", "Europe/Belgrade"),("3189595", "Subotica", "Суботица", "RS", "688", "", "VO", "1", "80438", "46.1", "19.66667", "Europe/Belgrade"),("3190042", "Stanišić", "", "RS", "688", "", "00", "", "", "45.93895", "19.16709", "Europe/Belgrade"),("3190101", "Sremski Karlovci", "", "RS", "688", "", "VO", "6", "80411", "45.2025", "19.93444", "Europe/Belgrade"),("3190103", "Sremska Mitrovica", "", "RS", "688", "", "VO", "7", "80403", "44.97639", "19.61222", "Europe/Belgrade"),("3190335", "Sonta", "", "RS", "688", "", "00", "", "", "45.59427", "19.09719", "Europe/Belgrade"),("3190342", "Sombor", "Сомбор", "RS", "688", "", "VO", "5", "3190341", "45.77417", "19.11222", "Europe/Belgrade"),("3191376", "Šabac", "Шабац", "RS", "688", "", "SE", "8", "71269", "44.74667", "19.69", "Europe/Belgrade"),("3191429", "Ruma", "Рума", "RS", "688", "", "VO", "7", "80357", "45.00806", "19.82222", "Europe/Belgrade"),("3192420", "Prigrevica", "", "RS", "688", "", "VO", "5", "80047", "45.67636", "19.08809", "Europe/Belgrade"),("3193406", "Petrovaradin", "", "RS", "688", "", "VO", "6", "80519", "45.24667", "19.87944", "Europe/Belgrade"),("3194360", "Novi Sad", "Нови-Сад", "RS", "688", "", "VO", "6", "3194359", "45.25167", "19.83694", "Europe/Belgrade"),("3202798", "Čelarevo", "", "RS", "688", "", "VO", "6", "80063", "45.26999", "19.52484", "Europe/Belgrade"),("3203840", "Bogatić", "", "RS", "688", "", "SE", "8", "70289", "44.8375", "19.48056", "Europe/Belgrade"),("3204623", "Bajina Bašta", "", "RS", "688", "", "SE", "16", "70068", "43.97083", "19.5675", "Europe/Belgrade"),("3204635", "Badovinci", "", "RS", "688", "", "00", "", "", "44.78534", "19.37146", "Europe/Belgrade"),("3204665", "Bački Petrovac", "", "RS", "688", "", "VO", "6", "3204664", "45.36056", "19.59167", "Europe/Belgrade"),("3204672", "Bačka Topola", "", "RS", "688", "", "VO", "1", "80071", "45.81516", "19.6318", "Europe/Belgrade"),("3204674", "Bačka Palanka", "Бачка-Паланка", "RS", "688", "", "VO", "6", "3204673", "45.25083", "19.39194", "Europe/Belgrade"),("3204793", "Apatin", "Апатин", "RS", "688", "", "VO", "5", "3204792", "45.67111", "18.98472", "Europe/Belgrade"),("6619277", "Knjazevac", "", "RS", "688", "", "SE", "15", "70602", "43.56634", "22.25701", "Europe/Belgrade"),("452949", "Udomlya", "Удомля", "RU", "643", "", "77", "", "", "57.87944", "34.9925", "Europe/Moscow"),("461698", "Sosnovka", "Сосновка", "RU", "643", "RU", "66", "", "", "60.01667", "30.35", "Europe/Moscow"),("461699", "Sasovo", "Сасово", "RU", "643", "", "62", "", "", "54.35369", "41.91986", "Europe/Moscow"),("461704", "Novozavidovskiy", "", "RU", "643", "", "77", "", "", "56.55", "36.43333", "Europe/Moscow"),("461705", "Krasnolesnyy", "", "RU", "643", "", "86", "", "", "51.88072", "39.58772", "Europe/Moscow"),("461720", "Kosterevo", "", "RU", "643", "", "83", "", "", "55.9299", "39.61438", "Europe/Moscow"),("461740", "Zyuzino", "Зюзино", "RU", "643", "", "48", "", "", "55.65608", "37.56846", "Europe/Moscow"),("461835", "Zyablikovo", "Зябликово", "RU", "643", "", "48", "490025", "", "55.61667", "37.76667", "Europe/Moscow"),("461910", "Zverevo", "Зверево", "RU", "643", "", "61", "", "", "48.02108", "40.12282", "Europe/Moscow"),("461916", "Zvenigovo", "", "RU", "643", "", "45", "", "", "55.97539", "48.01304", "Europe/Moscow"),("461920", "Zvenigorod", "Звенигород", "RU", "643", "", "47", "", "", "55.73401", "36.85918", "Europe/Moscow"),("461964", "Zuyevka", "", "RU", "643", "", "33", "", "", "58.40503", "51.13355", "Europe/Kirov"),("462008", "Zubtsov", "", "RU", "643", "", "77", "", "", "56.17533", "34.58935", "Europe/Moscow"),("462050", "Zubova Polyana", "", "RU", "643", "", "46", "", "", "54.0771", "42.8372", "Europe/Moscow"),("462313", "Znamenskoye", "", "RU", "643", "", "12", "", "", "43.67898", "45.12867", "Europe/Moscow"),("462352", "Znamenka", "", "RU", "643", "", "56", "", "", "52.89789", "35.97703", "Europe/Moscow"),("462357", "Znamenka", "", "RU", "643", "", "72", "", "", "52.4167", "41.43108", "Europe/Moscow"),("462377", "Zmiyëvka", "", "RU", "643", "", "56", "", "", "52.66697", "36.37426", "Europe/Moscow"),("462383", "Zmeyskaya", "", "RU", "643", "", "68", "", "", "43.33617", "44.15733", "Europe/Moscow"),("462413", "Zlynka", "", "RU", "643", "", "10", "", "", "52.4267", "31.7378", "Europe/Moscow"),("462444", "Zlatoust", "Златоуст", "RU", "643", "", "13", "", "", "55.17111", "59.65083", "Asia/Yekaterinburg"),("462522", "Zimovniki", "Зимовники", "RU", "643", "", "61", "", "", "47.1474", "42.4721", "Europe/Moscow"),("462626", "Zilair", "", "RU", "643", "", "08", "", "", "52.2332", "57.4392", "Asia/Yekaterinburg"),("462745", "Zhulebino", "Жулебино", "RU", "643", "", "48", "", "", "55.7", "37.85", "Europe/Moscow"),("462755", "Zhukovskiy", "Жуковский", "RU", "643", "RU", "47", "", "", "55.59528", "38.12028", "Europe/Moscow"),("462792", "Zhukovo", "", "RU", "643", "", "25", "", "", "55.03178", "36.74402", "Europe/Moscow"),("462822", "Zhukovka", "Жуковка", "RU", "643", "", "10", "", "", "53.53395", "33.72798", "Europe/Moscow"),("462914", "Zhizdra", "", "RU", "643", "", "25", "", "", "53.74596", "34.73951", "Europe/Moscow"),("462984", "Zhirnovsk", "Жирновск", "RU", "643", "", "84", "", "", "50.98448", "44.77347", "Europe/Volgograd"),("462988", "Zhirnov", "", "RU", "643", "", "61", "", "", "48.17089", "41.12608", "Europe/Moscow"),("463082", "Zhigulevsk", "Жигулевск", "RU", "643", "RU", "65", "", "", "53.39972", "49.49528", "Europe/Samara"),("463144", "Zheshart", "", "RU", "643", "", "34", "", "", "62.07314", "49.57335", "Europe/Moscow"),("463217", "Zherdevka", "Жердевка", "RU", "643", "", "72", "", "", "51.84861", "41.46056", "Europe/Moscow"),("463340", "Zheleznovodsk", "Железноводск", "RU", "643", "", "70", "", "", "44.13944", "43.01972", "Europe/Moscow"),("463343", "Zheleznogorsk", "Железногорск", "RU", "643", "", "41", "", "", "52.331", "35.3711", "Europe/Moscow"),("463355", "Zheleznodorozhnyy", "Железнодорожный", "RU", "643", "", "47", "579462", "", "55.744", "38.01684", "Europe/Moscow"),("463637", "Zernograd", "Зерноград", "RU", "643", "", "61", "", "", "46.84518", "40.30834", "Europe/Moscow"),("463710", "Zemetchino", "", "RU", "643", "", "57", "", "", "53.4973", "42.61632", "Europe/Moscow"),("463824", "Zelenokumsk", "Зеленокумск", "RU", "643", "", "70", "", "", "44.40694", "43.88056", "Europe/Moscow"),("463828", "Zelenogradsk", "", "RU", "643", "", "23", "463825", "", "54.95893", "20.47668", "Europe/Kaliningrad"),("463829", "Zelenograd", "Зеленоград", "RU", "643", "", "48", "", "", "55.9825", "37.18139", "Europe/Moscow"),("463830", "Zelenogorsk", "", "RU", "643", "", "66", "", "", "60.19968", "29.70183", "Europe/Moscow"),("463835", "Zelenodolsk", "Зеленодольск", "RU", "643", "", "73", "Zelenodol'skiy Rayon", "", "55.84376", "48.51784", "Europe/Moscow"),("463838", "Zelenoborskiy", "", "RU", "643", "", "49", "", "", "66.845", "32.36222", "Europe/Moscow"),("463885", "Zelenchukskaya", "Зеленчукская", "RU", "643", "", "27", "", "", "43.85804", "41.5894", "Europe/Moscow"),("463966", "Zayukovo", "", "RU", "643", "", "22", "", "", "43.61611", "43.33389", "Europe/Moscow"),("464094", "Zavoronezhskoye", "", "RU", "643", "", "72", "", "", "52.8801", "40.5526", "Europe/Moscow"),("464101", "Zavolzh’ye", "Заволжье", "RU", "643", "", "51", "", "", "56.64051", "43.39446", "Europe/Moscow"),("464112", "Zavolzhsk", "", "RU", "643", "", "21", "", "", "57.4823", "42.13779", "Europe/Moscow"),("464130", "Masalovka", "", "RU", "643", "", "61", "", "", "48.40372", "40.26064", "Europe/Moscow"),("464159", "Zavidovo", "", "RU", "643", "", "77", "", "", "56.53333", "36.53333", "Europe/Moscow"),("464179", "Zavetnoye", "", "RU", "643", "", "61", "", "", "47.11944", "43.89028", "Europe/Moscow"),("464260", "Zaterechnyy", "", "RU", "643", "", "70", "", "", "44.79306", "45.20972", "Europe/Moscow"),("464625", "Zarechnyy", "Заречный", "RU", "643", "", "57", "", "", "53.20356", "45.19227", "Europe/Moscow"),("464687", "Zaraysk", "Зарайск", "RU", "643", "", "47", "", "", "54.7605", "38.87841", "Europe/Moscow"),("464708", "Zaprudnya", "", "RU", "643", "", "47", "", "", "56.56667", "37.43333", "Europe/Moscow"),("464790", "Zapolyarnyy", "Заполярный", "RU", "643", "", "49", "", "", "69.41541", "30.81355", "Europe/Moscow"),("464891", "Zapadnaya Dvina", "", "RU", "643", "", "77", "", "", "56.25901", "32.07454", "Europe/Moscow"),("464993", "Zaokskiy", "", "RU", "643", "", "76", "", "", "54.73227", "37.40539", "Europe/Moscow"),("465057", "Zamoskvorech’ye", "Замоскворечье", "RU", "643", "", "48", "", "", "55.73333", "37.63333", "Europe/Moscow"),("465174", "Zalukokoazhe", "", "RU", "643", "", "22", "", "", "43.90389", "43.21556", "Europe/Moscow"),("465291", "Zalegoshch’", "", "RU", "643", "", "56", "", "", "52.8989", "36.89093", "Europe/Moscow"),("465543", "Zainsk", "Заинск", "RU", "643", "", "73", "", "", "55.3195", "52.06942", "Europe/Moscow"),("465632", "Zagoryanskiy", "", "RU", "643", "", "47", "", "", "55.9325", "37.95806", "Europe/Moscow"),("465726", "Zadonsk", "", "RU", "643", "", "43", "", "", "52.3904", "38.9261", "Europe/Moscow"),("466060", "Yuzhno-Sukhokumsk", "", "RU", "643", "", "17", "", "", "44.65811", "45.6436", "Europe/Moscow"),("466084", "Yuzha", "", "RU", "643", "", "21", "", "", "56.58306", "42.01222", "Europe/Moscow"),("466200", "Yuryuzan’", "", "RU", "643", "", "13", "", "", "54.86333", "58.42194", "Asia/Yekaterinburg"),("466215", "Yur’yev-Pol’skiy", "Юрьев-Польский", "RU", "643", "", "83", "", "", "56.50339", "39.67911", "Europe/Moscow"),("466258", "Yur’yevets", "", "RU", "643", "", "21", "", "", "57.32007", "43.1041", "Europe/Moscow"),("466538", "Yumaguzino", "", "RU", "643", "", "08", "", "", "52.90412", "56.39329", "Asia/Yekaterinburg"),("466658", "Yukhnov", "", "RU", "643", "", "25", "", "", "54.74444", "35.22972", "Europe/Moscow"),("466699", "Yugo-Kamskiy", "", "RU", "643", "", "90", "", "", "57.7026", "55.5904", "Asia/Yekaterinburg"),("466806", "Yoshkar-Ola", "Йошкар-Ола", "RU", "643", "", "45", "", "", "56.63877", "47.89078", "Europe/Moscow"),("466885", "Yeysk", "Ейск", "RU", "643", "", "38", "", "", "46.7055", "38.2739", "Europe/Moscow"),("466989", "Yessentukskaya", "Ессентукская", "RU", "643", "", "70", "", "", "44.0328", "42.8813", "Europe/Moscow"),("466990", "Yessentuki", "Ессентуки", "RU", "643", "", "70", "", "", "44.04444", "42.86056", "Europe/Moscow"),("467104", "Yershovo", "", "RU", "643", "", "47", "", "", "55.76911", "36.85929", "Europe/Moscow"),("467120", "Yershov", "Ершов", "RU", "643", "", "67", "", "", "51.3513", "48.2766", "Europe/Volgograd"),("467238", "Yermolino", "", "RU", "643", "", "25", "", "", "55.19489", "36.59513", "Europe/Moscow"),("467246", "Yermolayevo", "", "RU", "643", "", "08", "", "", "52.71667", "55.8", "Asia/Yekaterinburg"),("467479", "Yenotayevka", "", "RU", "643", "", "07", "", "", "47.24559", "47.02814", "Europe/Astrakhan"),("467525", "Yemva", "Железнодорожный", "RU", "643", "", "34", "", "", "62.58999", "50.85939", "Europe/Moscow"),("467539", "Yemetsk", "", "RU", "643", "", "06", "", "", "63.47191", "41.78023", "Europe/Moscow"),("467711", "Yelovo", "", "RU", "643", "", "90", "", "", "57.05381", "54.9207", "Asia/Yekaterinburg"),("467753", "Yel’nya", "", "RU", "643", "", "69", "", "", "54.57864", "33.18373", "Europe/Moscow"),("467854", "Yelizavetinskaya", "Елизаветинская", "RU", "643", "", "38", "", "", "45.04616", "38.79491", "Europe/Moscow"),("467978", "Yelets", "Елец", "RU", "643", "", "43", "", "", "52.62366", "38.50169", "Europe/Moscow"),("468044", "Yelan’-Koleno", "", "RU", "643", "", "86", "", "", "51.1523", "41.2306", "Europe/Moscow"),("468063", "Yelan’", "Елань", "RU", "643", "", "84", "", "", "50.949", "43.73781", "Europe/Volgograd"),("468082", "Yelabuga", "Елабуга", "RU", "643", "", "73", "", "", "55.76127", "52.06493", "Europe/Moscow"),("468180", "Yekaterinovka", "", "RU", "643", "", "67", "", "", "52.05083", "44.34515", "Europe/Volgograd"),("468250", "Yegor’yevsk", "Егорьевск", "RU", "643", "", "47", "", "", "55.38283", "39.03233", "Europe/Moscow"),("468307", "Yegorlykskaya", "Егорлыкская", "RU", "643", "", "61", "", "", "46.56564", "40.65621", "Europe/Moscow"),("468390", "Yefremov", "Ефремов", "RU", "643", "", "76", "", "", "53.14806", "38.09924", "Europe/Moscow"),("468483", "Yazykovo", "", "RU", "643", "", "08", "", "", "55.21988", "56.13532", "Asia/Yekaterinburg"),("468560", "Yayva", "", "RU", "643", "", "90", "", "", "59.3347", "57.2592", "Asia/Yekaterinburg"),("468587", "Yavas", "", "RU", "643", "", "46", "", "", "54.4159", "42.8491", "Europe/Moscow"),("468657", "Yasnyy", "Ясный", "RU", "643", "", "55", "", "", "51.0333", "59.8742", "Asia/Yekaterinburg"),("468671", "Yasnogorsk", "Ясногорск", "RU", "643", "", "76", "", "", "54.48082", "37.69854", "Europe/Moscow"),("468747", "Yashkul’", "", "RU", "643", "", "24", "", "", "46.1711", "45.3435", "Europe/Moscow"),("468809", "Yasenevo", "Ясенево", "RU", "643", "", "48", "", "", "55.60686", "37.51991", "Europe/Moscow"),("468866", "Yartsevo", "Ярцево", "RU", "643", "", "69", "", "", "55.06667", "32.69639", "Europe/Moscow"),("468899", "Yaroslavskaya", "", "RU", "643", "", "38", "", "", "44.61056", "40.46417", "Europe/Moscow"),("468902", "Yaroslavl", "Ярославль", "RU", "643", "", "88", "", "", "57.62987", "39.87368", "Europe/Moscow"),("468991", "Yarega", "", "RU", "643", "", "34", "", "", "63.43543", "53.5765", "Europe/Moscow"),("469005", "Yaransk", "Яранск", "RU", "643", "", "33", "", "", "57.30331", "47.88611", "Europe/Kirov"),("469017", "Yar", "", "RU", "643", "", "80", "", "", "58.2458", "52.1054", "Europe/Samara"),("469178", "Yanaul", "Янаул", "RU", "643", "", "08", "", "", "56.2751", "54.9338", "Asia/Yekaterinburg"),("469655", "Yakhroma", "", "RU", "643", "", "47", "", "", "56.3", "37.48333", "Europe/Moscow"),("469707", "Yagry", "", "RU", "643", "", "06", "", "", "64.59417", "39.81028", "Europe/Moscow"),("469809", "Yadrin", "", "RU", "643", "", "16", "", "", "55.94052", "46.20622", "Europe/Moscow"),("469844", "Yablonovskiy", "Яблоновский", "RU", "643", "", "01", "", "", "44.98901", "38.94324", "Europe/Moscow"),("469933", "Vyyezdnoye", "", "RU", "643", "", "51", "", "", "55.38154", "43.78638", "Europe/Moscow"),("469960", "Vytegra", "", "RU", "643", "", "85", "", "", "61.00636", "36.44811", "Europe/Moscow"),("470083", "Vysokovsk", "", "RU", "643", "", "47", "", "", "56.31667", "36.55", "Europe/Moscow"),("470212", "Vysokaya Gora", "", "RU", "643", "", "73", "", "", "55.91278", "49.30167", "Europe/Moscow"),("470252", "Vyshniy Volochëk", "Вышний Волочек", "RU", "643", "", "77", "", "", "57.59125", "34.56453", "Europe/Moscow"),("470338", "Vyselki", "Выселки", "RU", "643", "", "38", "", "", "45.58128", "39.66409", "Europe/Moscow"),("470368", "Vyritsa", "", "RU", "643", "", "42", "", "", "59.40778", "30.34806", "Europe/Moscow"),("470444", "Vyksa", "Выкса", "RU", "643", "", "51", "", "", "55.3175", "42.17444", "Europe/Moscow"),("470451", "Vykhino-Zhulebino", "Выхино-Жулебино", "RU", "643", "", "48", "", "", "55.70196", "37.81178", "Europe/Moscow"),("470473", "Vygonichi", "", "RU", "643", "", "10", "", "", "53.09855", "34.06728", "Europe/Moscow"),("470530", "Vychegodskiy", "", "RU", "643", "", "06", "", "", "61.24702", "46.89842", "Europe/Moscow"),("470546", "Vyborg", "Выборг", "RU", "643", "", "42", "", "", "60.70763", "28.75283", "Europe/Moscow"),("470666", "Vyazniki", "Вязники", "RU", "643", "", "83", "", "", "56.24057", "42.15563", "Europe/Moscow"),("470676", "Vyaz’ma", "Вязьма", "RU", "643", "", "69", "", "", "55.21039", "34.29508", "Europe/Moscow"),("470734", "Vyatskiye Polyany", "Вятские Поляны", "RU", "643", "", "33", "", "", "56.22602", "51.06557", "Europe/Kirov"),("470845", "Vurnary", "", "RU", "643", "", "16", "", "", "55.49044", "46.96479", "Europe/Moscow"),("470905", "Vuktyl", "", "RU", "643", "", "34", "", "", "63.85667", "57.30944", "Europe/Moscow"),("471101", "Vsevolozhsk", "Всеволожск", "RU", "643", "", "42", "", "", "60.01512", "30.67314", "Europe/Moscow"),("471172", "Voznesenskoye", "", "RU", "643", "", "51", "", "", "54.89", "42.75694", "Europe/Moscow"),("471188", "Voznesenskaya", "", "RU", "643", "", "38", "", "", "44.5527", "41.0318", "Europe/Moscow"),("471189", "Voznesenskaya", "", "RU", "643", "", "19", "", "", "43.54379", "44.74614", "Europe/Moscow"),("471245", "Vozhega", "", "RU", "643", "", "85", "", "", "60.47246", "40.22134", "Europe/Moscow"),("471430", "Votkinsk", "Воткинск", "RU", "643", "", "80", "", "", "57.04865", "53.98717", "Europe/Samara"),("471456", "Vostryakovo", "Востряково", "RU", "643", "", "47", "", "", "55.66667", "37.45", "Europe/Moscow"),("471457", "Vostryakovo", "Востряково", "RU", "643", "", "47", "", "", "55.39934", "37.80829", "Europe/Moscow"),("471499", "Vostochnyy", "", "RU", "643", "", "33", "", "", "58.78811", "52.24513", "Europe/Kirov"),("471501", "Vostochnyy", "", "RU", "643", "", "48", "", "", "55.81667", "37.86667", "Europe/Moscow"),("471607", "Voskresenskoye", "", "RU", "643", "", "51", "", "", "56.83806", "45.43167", "Europe/Moscow"),("471656", "Voskresensk", "Воскресенск", "RU", "643", "", "47", "", "", "55.31733", "38.65264", "Europe/Moscow"),("471760", "Vorsma", "", "RU", "643", "", "51", "", "", "55.99062", "43.27249", "Europe/Moscow"),("471799", "Vorotynets", "", "RU", "643", "", "51", "", "", "56.06028", "45.8633", "Europe/Moscow"),("471909", "Vorontsovka", "", "RU", "643", "", "86", "", "", "50.6132", "40.3549", "Europe/Moscow"),("472045", "Voronezh", "Воронеж", "RU", "643", "", "86", "", "", "51.67204", "39.1843", "Europe/Moscow"),("472072", "Altuf’yevskiy", "Алтуфьевский", "RU", "643", "", "48", "", "", "55.88333", "37.58333", "Europe/Moscow"),("472079", "Vorob’yovo", "Воробьево", "RU", "643", "", "48", "", "", "55.71667", "37.53333", "Europe/Moscow"),("472229", "Volzhskiy", "", "RU", "643", "", "65", "", "", "53.43058", "50.119", "Europe/Samara"),("472231", "Volzhskiy", "Волжский", "RU", "643", "", "84", "", "", "48.78583", "44.77973", "Europe/Volgograd"),("472234", "Volzhsk", "Волжск", "RU", "643", "", "45", "", "", "55.86638", "48.3594", "Europe/Moscow"),("472271", "Volya", "", "RU", "643", "", "86", "", "", "51.7651", "39.5404", "Europe/Moscow"),("472278", "Vol’sk", "Вольск", "RU", "643", "", "67", "", "", "52.04541", "47.37993", "Europe/Volgograd"),("472357", "Volosovo", "", "RU", "643", "", "42", "", "", "59.44525", "29.48911", "Europe/Moscow"),("472428", "Volokonovka", "", "RU", "643", "", "09", "", "", "50.4827", "37.8563", "Europe/Moscow"),("472433", "Volokolamsk", "Волоколамск", "RU", "643", "", "47", "472430", "", "56.03361", "35.96944", "Europe/Moscow"),("472459", "Vologda", "Вологда", "RU", "643", "", "85", "", "", "59.2239", "39.88398", "Europe/Moscow"),("472490", "Volodarskiy", "", "RU", "643", "", "07", "", "", "46.40134", "48.54093", "Europe/Astrakhan"),("472494", "Volodarsk", "", "RU", "643", "", "51", "", "", "56.23105", "43.18767", "Europe/Moscow"),("472722", "Volkhov", "Волхов", "RU", "643", "", "42", "", "", "59.9258", "32.33819", "Europe/Moscow"),("472732", "Nagornyy", "Нагорный", "RU", "643", "", "48", "490025", "", "55.65", "37.61667", "Europe/Moscow"),("472750", "Volgorechensk", "Волгореченск", "RU", "643", "", "37", "", "", "57.43931", "41.15553", "Europe/Moscow"),("472757", "Volgograd", "Волгоград", "RU", "643", "", "84", "", "", "48.71939", "44.50183", "Europe/Volgograd"),("472761", "Volgodonsk", "Волгодонск", "RU", "643", "", "61", "", "", "47.51361", "42.15139", "Europe/Moscow"),("472878", "Vokhtoga", "", "RU", "643", "", "85", "", "", "58.80949", "41.06245", "Europe/Moscow"),("472961", "Yutsa", "", "RU", "643", "", "70", "", "", "43.95639", "43.01278", "Europe/Moscow"),("472976", "Vodnyy", "", "RU", "643", "", "34", "", "", "63.50464", "53.40947", "Europe/Moscow"),("473127", "Novovladykino", "Нововладыкино", "RU", "643", "", "48", "", "", "55.85", "37.58333", "Europe/Moscow"),("473166", "Vladimirskaya", "", "RU", "643", "", "38", "", "", "44.5455", "40.7933", "Europe/Moscow"),("473247", "Vladimir", "Владимир", "RU", "643", "", "83", "", "", "56.13655", "40.39658", "Europe/Moscow"),("473249", "Vladikavkaz", "Владикавказ", "RU", "643", "", "68", "", "", "43.03667", "44.66778", "Europe/Moscow"),("473263", "Vizinga", "", "RU", "643", "", "34", "", "", "61.07493", "50.10311", "Europe/Moscow"),("473295", "Vityazevo", "", "RU", "643", "", "38", "", "", "45.0013", "37.28211", "Europe/Moscow"),("473522", "Vinsady", "", "RU", "643", "", "70", "", "", "44.08083", "42.96528", "Europe/Moscow"),("473535", "Vinogradovo", "", "RU", "643", "", "47", "", "", "56.93333", "37.55", "Europe/Moscow"),("473762", "Vidyayevo", "", "RU", "643", "", "49", "", "", "68.88333", "33.01667", "Europe/Moscow"),("473778", "Vidnoye", "Видное", "RU", "643", "", "47", "536086", "", "55.55239", "37.70967", "Europe/Moscow"),("473788", "Vichuga", "Вичуга", "RU", "643", "", "21", "", "", "57.21276", "41.93012", "Europe/Moscow"),("473856", "Veydelevka", "", "RU", "643", "", "09", "", "", "50.1521", "38.4492", "Europe/Moscow"),("473903", "Vetluzhskiy", "", "RU", "643", "", "37", "", "", "58.39016", "45.46543", "Europe/Moscow"),("473904", "Vetluzhskiy", "", "RU", "643", "", "51", "", "", "57.17355", "45.12272", "Europe/Moscow"),("473910", "Vetluga", "", "RU", "643", "", "51", "", "", "57.85574", "45.78102", "Europe/Moscow"),("473943", "Ves’yegonsk", "", "RU", "643", "", "77", "", "", "58.66398", "37.2604", "Europe/Moscow"),("473972", "Veshnyaki", "Вешняки", "RU", "643", "", "48", "8520891", "9882961", "55.72393", "37.81952", "Europe/Moscow"),("473994", "Veshkayma", "", "RU", "643", "", "81", "", "", "54.0472", "47.13", "Europe/Ulyanovsk"),("473998", "Veshenskaya", "", "RU", "643", "", "61", "", "", "49.63033", "41.7334", "Europe/Moscow"),("474059", "Vesëlyy", "", "RU", "643", "", "61", "", "", "47.09338", "40.7422", "Europe/Moscow"),("474324", "Verkhov’ye", "", "RU", "643", "", "56", "", "", "52.81165", "37.24215", "Europe/Moscow"),("474354", "Verkhovazh’ye", "", "RU", "643", "", "85", "", "", "60.74717", "42.04652", "Europe/Moscow"),("474462", "Verkhnyaya Tura", "", "RU", "643", "", "71", "", "", "58.36083", "59.80667", "Asia/Yekaterinburg"),("474669", "Verkhnyaya Khava", "", "RU", "643", "", "86", "", "", "51.84045", "39.94134", "Europe/Moscow"),("474821", "Verkhniy Tagil", "", "RU", "643", "", "71", "", "", "57.3733", "59.9556", "Asia/Yekaterinburg"),("474902", "Lakkha Nëvre", "", "RU", "643", "", "12", "", "", "43.61033", "45.24542", "Europe/Moscow"),("474916", "Verkhniy Mamon", "", "RU", "643", "", "86", "", "", "50.1635", "40.3832", "Europe/Moscow"),("475030", "Verkhniye Tatyshly", "", "RU", "643", "", "08", "", "", "56.29117", "55.8575", "Asia/Yekaterinburg"),("475041", "Verkhniye Sergi", "", "RU", "643", "", "71", "", "", "56.64694", "59.55556", "Asia/Yekaterinburg"),("475100", "Verkhniye Kigi", "", "RU", "643", "", "08", "", "", "55.40833", "58.60444", "Asia/Yekaterinburg"),("475157", "Verkhniye Achaluki", "", "RU", "643", "", "19", "", "", "43.34694", "44.6975", "Europe/Moscow"),("475196", "Verkhniy Baskunchak", "", "RU", "643", "", "07", "", "", "48.22564", "46.72169", "Europe/Astrakhan"),("475369", "Verkhneye Kazanishche", "", "RU", "643", "", "17", "", "", "42.73547", "47.1378", "Europe/Moscow"),("475438", "Verkhneyarkeyevo", "", "RU", "643", "", "08", "", "", "55.45046", "54.31455", "Asia/Yekaterinburg"),("475463", "Verkhneural’sk", "", "RU", "643", "", "13", "", "", "53.87694", "59.21056", "Asia/Yekaterinburg"),("475614", "Verkhnedneprovskiy", "", "RU", "643", "", "69", "", "", "54.98131", "33.34573", "Europe/Moscow"),("475777", "Vereshchagino", "Верещагино", "RU", "643", "", "90", "", "", "58.07894", "54.6557", "Asia/Yekaterinburg"),("475845", "Verbilki", "", "RU", "643", "", "47", "", "", "56.53333", "37.6", "Europe/Moscow"),("475881", "Venëv", "Венёв", "RU", "643", "", "76", "", "", "54.35533", "38.26843", "Europe/Moscow"),("475938", "Vel’sk", "Вельск", "RU", "643", "", "06", "", "", "61.07006", "42.0983", "Europe/Moscow"),("475955", "Velizh", "", "RU", "643", "", "69", "", "", "55.60564", "31.19673", "Europe/Moscow"),("476028", "Velikovechnoye", "", "RU", "643", "", "38", "", "", "44.93402", "39.75499", "Europe/Moscow"),("476062", "Velikiy Ustyug", "Великий Устюг", "RU", "643", "", "85", "", "", "60.76186", "46.31352", "Europe/Moscow"),("476077", "Velikiye Luki", "Великие Луки", "RU", "643", "", "60", "", "", "56.34", "30.54517", "Europe/Moscow"),("476343", "Vavozh", "", "RU", "643", "", "80", "", "", "56.77513", "51.93098", "Europe/Samara"),("476368", "Vatutino", "", "RU", "643", "", "48", "", "", "55.88441", "37.69055", "Europe/Moscow"),("476372", "Vatutinki", "", "RU", "643", "", "48", "", "", "55.4965", "37.32988", "Europe/Moscow"),("476417", "Vasyurinskaya", "", "RU", "643", "", "38", "", "", "45.11809", "39.42399", "Europe/Moscow"),("476500", "Vaskelovo", "", "RU", "643", "", "42", "6695195", "", "60.39571", "30.35419", "Europe/Moscow"),("477039", "Varenikovskaya", "", "RU", "643", "", "38", "", "", "45.12085", "37.64171", "Europe/Moscow"),("477192", "Valuyki", "Валуйки", "RU", "643", "", "09", "", "", "50.2035", "38.1067", "Europe/Moscow"),("477279", "Valerik", "", "RU", "643", "", "12", "", "", "43.17972", "45.40806", "Europe/Moscow"),("477301", "Valday", "Валдай", "RU", "643", "", "52", "", "", "57.97472", "33.2525", "Europe/Moscow"),("477337", "Vakhtan", "", "RU", "643", "", "51", "", "", "57.96592", "46.68886", "Europe/Moscow"),("477340", "Vakhrushi", "", "RU", "643", "", "33", "", "", "58.68472", "50.02611", "Europe/Kirov"),("477377", "Vagonoremont", "", "RU", "643", "", "48", "", "", "55.9", "37.55", "Europe/Moscow"),("477424", "Vad", "", "RU", "643", "", "51", "", "", "55.53009", "44.21137", "Europe/Moscow"),("477440", "Vacha", "", "RU", "643", "", "51", "", "", "55.8035", "42.7709", "Europe/Moscow"),("477494", "Uzlovaya", "Узловая", "RU", "643", "", "76", "", "", "53.98179", "38.17118", "Europe/Moscow"),("477626", "Uvarovo", "Уварово", "RU", "643", "", "72", "", "", "51.98486", "42.26147", "Europe/Moscow"),("477656", "Uva", "Ува", "RU", "643", "", "80", "", "", "56.99081", "52.18517", "Europe/Samara"),("477795", "Ustyuzhna", "", "RU", "643", "", "85", "", "", "58.8394", "36.4321", "Europe/Moscow"),("477940", "Ust-Tsilma", "", "RU", "643", "", "34", "", "", "65.44104", "52.14978", "Europe/Moscow"),("478044", "Ust’-Labinsk", "Усть-Лабинск", "RU", "643", "", "38", "", "", "45.21077", "39.68914", "Europe/Moscow"),("478050", "Ust’-Kulom", "", "RU", "643", "", "34", "", "", "61.68636", "53.6902", "Europe/Moscow"),("478071", "Ust’-Katav", "Усть-Катав", "RU", "643", "", "13", "", "", "54.9366", "58.1757", "Asia/Yekaterinburg"),("478130", "Ust’-Dzheguta", "Усть-Джегута", "RU", "643", "", "27", "", "", "44.0834", "41.9763", "Europe/Moscow"),("478132", "Ust’-Donetskiy", "", "RU", "643", "", "61", "", "", "47.64189", "40.87182", "Europe/Moscow"),("478197", "Uspenskoye", "", "RU", "643", "", "38", "", "", "44.8311", "41.3927", "Europe/Moscow"),("478269", "Usol’ye", "", "RU", "643", "", "90", "", "", "59.4219", "56.6862", "Asia/Yekaterinburg"),("478297", "Usogorsk", "", "RU", "643", "", "34", "", "", "63.41064", "48.68722", "Europe/Moscow"),("478317", "Usman’", "Усмань", "RU", "643", "", "43", "", "", "52.04662", "39.7288", "Europe/Moscow"),("478532", "Urzhum", "", "RU", "643", "", "33", "", "", "57.11412", "49.99956", "Europe/Kirov"),("478538", "Uryv-Pokrovka", "", "RU", "643", "", "86", "", "", "51.1159", "39.16394", "Europe/Moscow"),("478544", "Uryupinsk", "Урюпинск", "RU", "643", "", "84", "", "", "50.8047", "42.0138", "Europe/Volgograd"),("478563", "Urvan’", "", "RU", "643", "", "22", "", "", "43.49222", "43.76056", "Europe/Moscow"),("478565", "Urussu", "", "RU", "643", "", "73", "", "", "54.59812", "53.46313", "Europe/Moscow"),("478581", "Urus-Martan", "Урус-Мартан", "RU", "643", "", "12", "", "", "43.13053", "45.53791", "Europe/Moscow"),("478689", "Urmary", "", "RU", "643", "", "16", "", "", "55.67894", "47.94396", "Europe/Moscow"),("478711", "Urkarakh", "", "RU", "643", "", "17", "", "", "42.16297", "47.63068", "Europe/Moscow"),("478724", "Uritsk", "Урицк", "RU", "643", "", "66", "", "", "59.83889", "30.17528", "Europe/Moscow"),("478757", "Uren’", "", "RU", "643", "", "51", "", "", "57.45516", "45.78522", "Europe/Moscow"),("478781", "Urazovo", "", "RU", "643", "", "09", "", "", "50.0836", "38.0395", "Europe/Moscow"),("478963", "Untsukul’", "", "RU", "643", "", "17", "", "", "42.71149", "46.78663", "Europe/Moscow"),("479028", "Unecha", "Унеча", "RU", "643", "", "10", "", "", "52.84591", "32.67394", "Europe/Moscow"),("479071", "Umba", "", "RU", "643", "", "49", "", "", "66.68706", "34.34291", "Europe/Moscow"),("479123", "Ulyanovsk", "Ульяновск", "RU", "643", "", "81", "479105", "", "54.32824", "48.38657", "Europe/Ulyanovsk"),("479140", "Ul’yanovka", "", "RU", "643", "", "42", "", "", "59.63944", "30.76472", "Europe/Moscow"),("479242", "Ulluaya", "", "RU", "643", "", "17", "", "", "42.37377", "47.37451", "Europe/Moscow"),("479411", "Ukhta", "Ухта", "RU", "643", "", "34", "", "", "63.56705", "53.68348", "Europe/Moscow"),("479426", "Ukholovo", "", "RU", "643", "", "62", "", "", "53.7929", "40.4892", "Europe/Moscow"),("479532", "Uglich", "Углич", "RU", "643", "", "88", "", "", "57.5275", "38.33167", "Europe/Moscow"),("479535", "Ugleural’skiy", "", "RU", "643", "", "90", "", "", "58.9443", "57.5937", "Asia/Yekaterinburg"),("479561", "Ufa", "Уфа", "RU", "643", "", "08", "", "", "54.74306", "55.96779", "Asia/Yekaterinburg"),("479596", "Udobnaya", "", "RU", "643", "", "38", "", "", "44.1932", "41.5529", "Europe/Moscow"),("479640", "Udel’naya", "", "RU", "643", "", "47", "", "", "55.62536", "38.00285", "Europe/Moscow"),("479687", "Uchkeken", "Учкекен", "RU", "643", "", "27", "", "", "43.93778", "42.51167", "Europe/Moscow"),("479703", "Uchaly", "Учалы", "RU", "643", "", "08", "", "", "54.35806", "59.43611", "Asia/Yekaterinburg"),("479704", "Uchaly", "Учалы", "RU", "643", "", "08", "", "", "54.2996", "59.4521", "Asia/Yekaterinburg"),("479871", "Tyul’gan", "", "RU", "643", "", "55", "", "", "52.34049", "56.16604", "Asia/Yekaterinburg"),("479933", "Tyrnyauz", "Тырныауз", "RU", "643", "", "22", "", "", "43.38278", "42.91833", "Europe/Moscow"),("480060", "Tver", "Тверь", "RU", "643", "", "77", "", "", "56.85836", "35.90057", "Europe/Moscow"),("480085", "Tuzha", "", "RU", "643", "", "33", "", "", "57.60615", "47.93597", "Europe/Kirov"),("480089", "Tuymazy", "Туймазы", "RU", "643", "", "08", "", "", "54.60666", "53.7097", "Asia/Yekaterinburg"),("480122", "Tutayev", "Тутаев", "RU", "643", "", "88", "", "", "57.88529", "39.5406", "Europe/Moscow"),("480267", "Turki", "", "RU", "643", "", "67", "", "", "51.98703", "43.2731", "Europe/Volgograd"),("480301", "Turgenevo", "", "RU", "643", "", "46", "Ardatovskiy Rayon (undefined)", "", "54.84555", "46.32968", "Europe/Moscow"),("480484", "Tuma", "", "RU", "643", "", "62", "", "", "55.14798", "40.55374", "Europe/Moscow"),("480562", "Tula", "Тула", "RU", "643", "", "76", "", "", "54.19609", "37.61822", "Europe/Moscow"),("480685", "Tuchkovo", "Тучково", "RU", "643", "", "47", "", "", "55.60111", "36.46806", "Europe/Moscow"),("480716", "Tuapse", "Туапсе", "RU", "643", "", "38", "", "", "44.1053", "39.0802", "Europe/Moscow"),("480851", "Tsivil’sk", "", "RU", "643", "", "16", "", "", "55.86974", "47.47874", "Europe/Moscow"),("480876", "Tsimlyansk", "Цимлянск", "RU", "643", "", "61", "", "", "47.64611", "42.10194", "Europe/Moscow"),("481007", "Tsentoroy", "", "RU", "643", "", "12", "", "", "43.00658", "46.22235", "Europe/Moscow"),("481036", "Tselina", "", "RU", "643", "", "61", "", "", "46.53381", "41.03284", "Europe/Moscow"),("481117", "Tsagan Aman", "", "RU", "643", "", "24", "", "", "47.5639", "46.7218", "Europe/Moscow"),("481181", "Trunovskoye", "", "RU", "643", "", "70", "", "", "45.48778", "42.13583", "Europe/Moscow"),("481275", "Trudobelikovskiy", "", "RU", "643", "", "38", "", "", "45.26853", "38.15376", "Europe/Moscow"),("481350", "Trubchevsk", "Трубчевск", "RU", "643", "", "10", "", "", "52.5798", "33.7644", "Europe/Moscow"),("481453", "Troparëvo", "Тропарёво", "RU", "643", "", "48", "", "", "55.65625", "37.48496", "Europe/Moscow"),("481542", "Troitskoye", "", "RU", "643", "", "24", "", "", "46.4206", "44.2591", "Europe/Moscow"),("481548", "Troitsko-Pechorsk", "", "RU", "643", "", "34", "", "", "62.70836", "56.19643", "Europe/Moscow"),("481580", "Troitskiy", "", "RU", "643", "", "09", "", "", "51.3588", "37.5253", "Europe/Moscow"),("481604", "Troitskaya", "", "RU", "643", "", "38", "", "", "45.13493", "38.12544", "Europe/Moscow"),("481605", "Troitskaya", "Троицкая", "RU", "643", "", "19", "", "", "43.30664", "44.98395", "Europe/Moscow"),("481608", "Troitsk", "Троицк", "RU", "643", "", "48", "8520893", "", "55.48498", "37.30736", "Europe/Moscow"),("481938", "Tovarkovskiy", "", "RU", "643", "", "76", "", "", "53.68217", "38.2092", "Europe/Moscow"),("481941", "Tovarkovo", "", "RU", "643", "", "25", "", "", "54.67617", "35.9386", "Europe/Moscow"),("481955", "Totskoye", "", "RU", "643", "", "55", "", "", "52.52478", "52.76228", "Asia/Yekaterinburg"),("481960", "Tot’ma", "", "RU", "643", "", "85", "", "", "59.97375", "42.76487", "Europe/Moscow"),("481964", "Tosno", "Тосно", "RU", "643", "", "42", "", "", "59.54", "30.8775", "Europe/Moscow"),("481985", "Torzhok", "Торжок", "RU", "643", "", "77", "", "", "57.0436", "34.96221", "Europe/Moscow"),("482042", "Toropets", "", "RU", "643", "", "77", "", "", "56.49779", "31.63528", "Europe/Moscow"),("482123", "Torbeyevo", "", "RU", "643", "", "46", "", "", "54.07972", "43.24732", "Europe/Moscow"),("482230", "Tonkino", "", "RU", "643", "", "51", "", "", "57.37257", "46.46294", "Europe/Moscow"),("482260", "Tomilino", "Томилино", "RU", "643", "", "47", "", "", "55.65619", "37.94713", "Europe/Moscow"),("482275", "Tomarovka", "", "RU", "643", "", "09", "", "", "50.68338", "36.23309", "Europe/Moscow"),("482283", "Tol’yatti", "Тольятти", "RU", "643", "", "65", "", "", "53.5303", "49.3461", "Europe/Samara"),("482309", "Tolstoy-Yurt", "", "RU", "643", "", "12", "", "", "43.44548", "45.77901", "Europe/Moscow"),("482432", "Tolbazy", "", "RU", "643", "", "08", "", "", "54.02408", "55.88248", "Asia/Yekaterinburg"),("482443", "Toksovo", "", "RU", "643", "", "42", "", "", "60.15323", "30.51646", "Europe/Moscow"),("482761", "Tirlyanskiy", "", "RU", "643", "", "08", "", "", "54.2109", "58.5806", "Asia/Yekaterinburg"),("482965", "Timashëvsk", "Тимашёвск", "RU", "643", "RU", "38", "", "", "45.61694", "38.94528", "Europe/Moscow"),("483019", "Tikhvin", "Тихвин", "RU", "643", "", "42", "", "", "59.64511", "33.52937", "Europe/Moscow"),("483029", "Tikhoretsk", "Тихорецк", "RU", "643", "", "38", "", "", "45.85472", "40.12528", "Europe/Moscow"),("483137", "Teykovo", "Тейково", "RU", "643", "", "21", "", "", "56.85796", "40.53692", "Europe/Moscow"),("483142", "Adygeysk", "", "RU", "643", "", "01", "11205695", "", "44.88414", "39.19071", "Europe/Moscow"),("483150", "Tetyushi", "", "RU", "643", "", "73", "", "", "54.93821", "48.83656", "Europe/Moscow"),("483326", "Ternevskaya", "", "RU", "643", "", "38", "", "", "45.8513", "40.4125", "Europe/Moscow"),("483386", "Tereze", "", "RU", "643", "", "27", "", "", "43.93608", "42.4434", "Europe/Moscow"),("483439", "Terekli-Mekteb", "", "RU", "643", "", "17", "", "", "44.1671", "45.86975", "Europe/Moscow"),("483495", "Terek", "Терек", "RU", "643", "", "22", "", "", "43.48333", "44.13611", "Europe/Moscow"),("483541", "Terbuny", "", "RU", "643", "", "43", "", "", "52.1493", "38.2834", "Europe/Moscow"),("483551", "Tyoply Stan", "Тёплый Стан", "RU", "643", "", "48", "562221", "", "55.62047", "37.49338", "Europe/Moscow"),("483575", "Tëploye", "", "RU", "643", "", "76", "", "", "53.62022", "37.59026", "Europe/Moscow"),("483661", "Temryuk", "Темрюк", "RU", "643", "", "38", "", "", "45.27055", "37.38716", "Europe/Moscow"),("483684", "Temnikov", "", "RU", "643", "", "46", "", "", "54.63023", "43.21483", "Europe/Moscow"),("483692", "Temizhbekskaya", "", "RU", "643", "", "38", "", "", "45.44556", "40.845", "Europe/Moscow"),("483696", "Temirgoyevskaya", "", "RU", "643", "", "38", "", "", "45.11414", "40.28027", "Europe/Moscow");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("483826", "Tekstil’shchiki", "Текстильщики", "RU", "643", "", "48", "", "", "55.70033", "37.74271", "Europe/Moscow"),("483873", "Teberda", "", "RU", "643", "", "27", "", "", "43.44565", "41.7448", "Europe/Moscow"),("483883", "Tbilisskaya", "Тбилисская", "RU", "643", "", "38", "", "", "45.36333", "40.19", "Europe/Moscow"),("484017", "Tatsinskiy", "", "RU", "643", "", "61", "", "", "48.19677", "41.27558", "Europe/Moscow"),("484034", "Tatishchevo", "", "RU", "643", "", "67", "", "", "51.67028", "45.59528", "Europe/Volgograd"),("484162", "Tatarka", "", "RU", "643", "", "70", "", "", "44.95889", "41.95171", "Europe/Moscow"),("484232", "Tashla", "", "RU", "643", "", "55", "", "", "51.77157", "52.7427", "Asia/Yekaterinburg"),("484287", "Tarusa", "", "RU", "643", "", "25", "", "", "54.72436", "37.17272", "Europe/Moscow"),("484290", "Tarumovka", "", "RU", "643", "", "17", "", "", "44.07606", "46.53613", "Europe/Moscow"),("484314", "Tarnogskiy Gorodok", "", "RU", "643", "", "85", "", "", "60.49972", "43.57611", "Europe/Moscow"),("484334", "Tarki", "", "RU", "643", "", "17", "", "", "42.94423", "47.49527", "Europe/Moscow"),("484340", "Tarkhovka", "", "RU", "643", "", "66", "", "", "60.06687", "29.97435", "Europe/Moscow"),("484396", "Tarasovskiy", "", "RU", "643", "", "61", "", "", "48.72727", "40.36267", "Europe/Moscow"),("484646", "Tambov", "Тамбов", "RU", "643", "", "72", "", "", "52.73169", "41.44326", "Europe/Moscow"),("484670", "Taman’", "", "RU", "643", "", "38", "", "", "45.2117", "36.71609", "Europe/Moscow"),("484674", "Tamala", "", "RU", "643", "", "57", "", "", "52.54097", "43.25145", "Europe/Moscow"),("484720", "Talovyy", "", "RU", "643", "", "61", "", "", "47.80765", "40.10943", "Europe/Moscow"),("484747", "Talovaya", "", "RU", "643", "", "86", "", "", "51.11444", "40.73", "Europe/Moscow"),("484770", "Talitsy", "", "RU", "643", "", "21", "", "", "56.52801", "42.3323", "Europe/Moscow"),("484826", "Taldom", "", "RU", "643", "", "47", "", "", "56.73333", "37.53333", "Europe/Moscow"),("484856", "Agidel’", "Агидель", "RU", "643", "", "08", "", "", "55.9077", "53.9355", "Asia/Yekaterinburg"),("484907", "Taganrog", "Таганрог", "RU", "643", "", "61", "", "", "47.23617", "38.89688", "Europe/Moscow"),("484912", "Taganskiy", "Таганский", "RU", "643", "", "48", "", "", "55.73333", "37.66667", "Europe/Moscow"),("484972", "Syzran’", "Сызрань", "RU", "643", "", "65", "", "", "53.1585", "48.4681", "Europe/Samara"),("485064", "Syumsi", "", "RU", "643", "", "80", "", "", "57.11108", "51.61494", "Europe/Samara"),("485230", "Sylva", "", "RU", "643", "", "90", "", "", "58.0327", "56.7713", "Asia/Yekaterinburg"),("485239", "Syktyvkar", "Сыктывкар", "RU", "643", "", "34", "485241", "", "61.67642", "50.80994", "Europe/Moscow"),("485280", "Sychëvka", "", "RU", "643", "", "69", "", "", "55.82515", "34.27361", "Europe/Moscow"),("485304", "Syava", "", "RU", "643", "", "51", "", "", "58.01457", "46.32216", "Europe/Moscow"),("485313", "Syas’stroy", "", "RU", "643", "", "42", "", "", "60.13669", "32.56906", "Europe/Moscow"),("485432", "Svobody", "Свободы", "RU", "643", "", "70", "", "", "44.02556", "43.05028", "Europe/Moscow"),("485630", "Sviblovo", "Свиблово", "RU", "643", "", "48", "", "", "55.85", "37.63333", "Europe/Moscow"),("485639", "Svetogorsk", "Светогорск", "RU", "643", "", "42", "", "", "61.11213", "28.86321", "Europe/Moscow"),("485643", "Svetlyy Yar", "", "RU", "643", "", "84", "", "", "48.4748", "44.78096", "Europe/Volgograd"),("485660", "Svetlyy", "Светлый", "RU", "643", "", "23", "", "", "54.67501", "20.13473", "Europe/Kaliningrad"),("485698", "Svetlograd", "Светлоград", "RU", "643", "", "70", "", "", "45.33528", "42.85472", "Europe/Moscow"),("485699", "Svetlogorsk", "", "RU", "643", "", "23", "825115", "", "54.93987", "20.15479", "Europe/Kaliningrad"),("485763", "Sverdlovskiy", "", "RU", "643", "", "47", "", "", "55.90968", "38.14978", "Europe/Moscow"),("485817", "Suzëmka", "", "RU", "643", "RU", "10", "", "", "52.31834", "34.07899", "Europe/Moscow"),("485824", "Suzdal’", "", "RU", "643", "", "83", "", "", "56.42274", "40.44668", "Europe/Moscow"),("485871", "Suvorovskaya", "Суворовская", "RU", "643", "", "70", "", "", "44.1901", "42.6595", "Europe/Moscow"),("485888", "Suvorov", "Суворов", "RU", "643", "", "76", "", "", "54.1223", "36.49657", "Europe/Moscow"),("486043", "Surskoye", "", "RU", "643", "", "81", "", "", "54.4821", "46.7214", "Europe/Ulyanovsk"),("486048", "Sursk", "", "RU", "643", "", "57", "", "", "53.07542", "45.68461", "Europe/Moscow"),("486071", "Surovikino", "Суровикино", "RU", "643", "", "84", "", "", "48.60734", "42.84621", "Europe/Volgograd"),("486110", "Surkhakhi", "Сурхахи", "RU", "643", "", "19", "", "", "43.1875", "44.90194", "Europe/Moscow"),("486148", "Surazh", "", "RU", "643", "", "10", "", "", "53.01747", "32.39178", "Europe/Moscow"),("486178", "Suponevo", "", "RU", "643", "", "10", "", "", "53.20492", "34.29597", "Europe/Moscow"),("486186", "Suoyarvi", "", "RU", "643", "", "28", "", "", "62.08333", "32.35", "Europe/Moscow"),("486203", "Sunzha", "", "RU", "643", "", "68", "", "", "43.05862", "44.82281", "Europe/Moscow"),("486398", "Sulak", "", "RU", "643", "", "17", "", "", "43.27342", "47.51463", "Europe/Moscow"),("486413", "Suksun", "", "RU", "643", "", "90", "", "", "57.1431", "57.3949", "Asia/Yekaterinburg"),("486626", "Sukhodol", "", "RU", "643", "", "65", "", "", "53.90063", "51.2117", "Europe/Samara"),("486645", "Sukhobezvodnoye", "", "RU", "643", "", "51", "", "", "57.04913", "44.88909", "Europe/Moscow"),("486665", "Sukhinichi", "Сухиничи", "RU", "643", "", "25", "", "", "54.09989", "35.34254", "Europe/Moscow"),("486816", "Sudzha", "", "RU", "643", "", "41", "", "", "51.1976", "35.2726", "Europe/Moscow"),("486834", "Sudogda", "", "RU", "643", "", "83", "", "", "55.95394", "40.86291", "Europe/Moscow"),("486848", "Sudislavl’", "", "RU", "643", "", "37", "", "", "57.88175", "41.70829", "Europe/Moscow"),("486874", "Suda", "", "RU", "643", "", "85", "", "", "59.15254", "37.5582", "Europe/Moscow"),("486894", "Subkhankulovo", "", "RU", "643", "", "08", "", "", "54.55741", "53.81153", "Asia/Yekaterinburg"),("486968", "Stupino", "Ступино", "RU", "643", "", "47", "", "", "54.90083", "38.07083", "Europe/Moscow"),("487095", "Strunino", "Струнино", "RU", "643", "", "83", "", "", "56.37328", "38.58321", "Europe/Moscow"),("487110", "Strugi-Krasnyye", "", "RU", "643", "", "60", "", "", "58.26754", "29.11137", "Europe/Moscow"),("487131", "Stromyn’", "", "RU", "643", "", "47", "", "", "56.04347", "38.48318", "Europe/Moscow"),("487147", "Stroitel’", "Строитель", "RU", "643", "", "09", "", "", "50.78543", "36.4831", "Europe/Moscow"),("487150", "Strogino", "Строгино", "RU", "643", "", "48", "", "", "55.81838", "37.41224", "Europe/Moscow"),("487227", "Strel'na", "", "RU", "643", "RU", "66", "", "", "59.85189", "30.03611", "Europe/Moscow"),("487246", "Strelka", "", "RU", "643", "", "38", "", "", "45.20633", "37.2865", "Europe/Moscow"),("487372", "Storozhevaya", "", "RU", "643", "", "27", "", "", "43.87886", "41.45143", "Europe/Moscow"),("487441", "Stolbovaya", "", "RU", "643", "", "47", "", "", "55.25021", "37.49249", "Europe/Moscow"),("487495", "Sterlitamak", "Стерлитамак", "RU", "643", "", "08", "", "", "53.62462", "55.95015", "Asia/Yekaterinburg"),("487498", "Sterlibashevo", "", "RU", "643", "", "08", "", "", "53.43755", "55.2578", "Asia/Yekaterinburg"),("487543", "Stepnoye", "", "RU", "643", "", "67", "", "", "51.37972", "46.84917", "Europe/Volgograd"),("487837", "Stavrovo", "", "RU", "643", "", "83", "", "", "56.13311", "40.01295", "Europe/Moscow"),("487846", "Stavropol’", "Ставрополь", "RU", "643", "", "70", "", "", "45.0428", "41.9734", "Europe/Moscow"),("487928", "Staryy Oskol", "Старый Оскол", "RU", "643", "", "09", "", "", "51.29667", "37.84167", "Europe/Moscow"),("488128", "Staryye Atagi", "", "RU", "643", "", "12", "", "", "43.12028", "45.74056", "Europe/Moscow"),("488142", "Staryy Cherek", "", "RU", "643", "", "22", "", "", "43.47139", "43.84694", "Europe/Moscow"),("488206", "Starozhilovo", "", "RU", "643", "", "62", "", "", "54.2254", "39.916", "Europe/Moscow"),("488214", "Staroyur’yevo", "", "RU", "643", "", "72", "", "", "53.31611", "40.70806", "Europe/Moscow"),("488587", "Starovelichkovskaya", "", "RU", "643", "", "38", "", "", "45.42884", "38.73261", "Europe/Moscow"),("488606", "Starotitarovskaya", "", "RU", "643", "", "38", "", "", "45.21938", "37.15476", "Europe/Moscow"),("488635", "Staroshcherbinovskaya", "Старощербиновская", "RU", "643", "", "38", "", "", "46.6311", "38.6742", "Europe/Moscow"),("488713", "Staronizhestebliyevskaya", "", "RU", "643", "", "38", "", "", "45.38315", "38.44304", "Europe/Moscow"),("488730", "Staromyshastovskaya", "", "RU", "643", "", "38", "", "", "45.34329", "39.07608", "Europe/Moscow"),("488742", "Starominskaya", "Староминская", "RU", "643", "", "38", "", "", "46.53", "39.04972", "Europe/Moscow"),("488758", "Staroleushkovskaya", "", "RU", "643", "", "38", "", "", "45.98666", "39.75987", "Europe/Moscow"),("488777", "Starokucherganovka", "", "RU", "643", "", "07", "", "", "46.32476", "47.9555", "Europe/Astrakhan"),("488785", "Starokorsunskaya", "", "RU", "643", "", "38", "", "", "45.05727", "39.31611", "Europe/Moscow"),("488852", "Starodub", "Стародуб", "RU", "643", "", "10", "", "", "52.58444", "32.76333", "Europe/Moscow"),("488859", "Staroderevyankovskaya", "", "RU", "643", "", "38", "", "", "46.1276", "38.9674", "Europe/Moscow"),("488864", "Starocherkasskaya", "", "RU", "643", "", "61", "", "", "47.24077", "40.04186", "Europe/Moscow"),("488881", "Starobaltachevo", "", "RU", "643", "", "08", "", "", "56.0017", "55.928", "Asia/Yekaterinburg"),("488946", "Staritsa", "", "RU", "643", "", "77", "", "", "56.50752", "34.93544", "Europe/Moscow"),("489021", "Staraya Vichuga", "", "RU", "643", "", "21", "", "", "57.26833", "41.87873", "Europe/Moscow"),("489057", "Staraya Sunzha", "", "RU", "643", "", "12", "", "", "43.33542", "45.74377", "Europe/Moscow"),("489062", "Staraya Stanitsa", "", "RU", "643", "", "61", "", "", "48.33633", "40.29588", "Europe/Moscow"),("489063", "Staraya Stanitsa", "", "RU", "643", "", "38", "", "", "45.0098", "41.1512", "Europe/Moscow"),("489088", "Staraya Russa", "Старая Русса", "RU", "643", "", "52", "", "", "57.99439", "31.36081", "Europe/Moscow"),("489135", "Staraya Mayna", "", "RU", "643", "", "81", "", "", "54.60417", "48.93056", "Europe/Ulyanovsk"),("489162", "Staraya Kupavna", "Старая Купавна", "RU", "643", "", "47", "", "", "55.80799", "38.1805", "Europe/Moscow"),("489164", "Staraya Kulatka", "", "RU", "643", "", "81", "", "", "52.72778", "47.61788", "Europe/Ulyanovsk"),("489226", "Staraya Derevnya", "Старая Деревня", "RU", "643", "", "66", "", "", "59.98834", "30.24296", "Europe/Moscow"),("489290", "Stanovoye", "", "RU", "643", "", "43", "", "", "52.76384", "38.35818", "Europe/Moscow"),("489393", "Srednyaya Yelyuzan’", "", "RU", "643", "", "57", "", "", "53.0241", "45.9529", "Europe/Moscow"),("489446", "Srednyaya Akhtuba", "", "RU", "643", "", "84", "", "", "48.70998", "44.86724", "Europe/Volgograd"),("489655", "Spokoynaya", "", "RU", "643", "", "38", "", "", "44.2468", "41.4015", "Europe/Moscow"),("489686", "Spirovo", "", "RU", "643", "", "77", "", "", "57.41905", "34.97658", "Europe/Moscow"),("489741", "Spassk-Ryazanskiy", "", "RU", "643", "", "62", "", "", "54.404", "40.3762", "Europe/Moscow"),("489862", "Spas-Klepiki", "", "RU", "643", "", "62", "", "", "55.13472", "40.17673", "Europe/Moscow"),("489868", "Spas-Demensk", "", "RU", "643", "", "25", "", "", "54.41222", "34.02257", "Europe/Moscow"),("489997", "Kashkhatau", "", "RU", "643", "", "22", "", "", "43.31848", "43.60804", "Europe/Moscow"),("490039", "Sovetskiy", "", "RU", "643", "", "42", "", "", "60.53945", "28.67756", "Europe/Moscow"),("490040", "Sovetskiy", "", "RU", "643", "", "45", "", "", "56.75833", "48.47611", "Europe/Moscow"),("490065", "Sovetskaya", "", "RU", "643", "", "38", "", "", "44.77694", "41.17222", "Europe/Moscow"),("490066", "Sovetskaya", "", "RU", "643", "", "70", "", "", "44.02667", "44.05", "Europe/Moscow"),("490067", "Sovetsk", "Советск", "RU", "643", "", "33", "", "", "57.58475", "48.95844", "Europe/Kirov"),("490068", "Sovetsk", "Совецк", "RU", "643", "", "23", "", "", "55.08392", "21.87851", "Europe/Kaliningrad"),("490108", "Sotnikovskoye", "", "RU", "643", "", "70", "", "", "45.00389", "43.77722", "Europe/Moscow"),("490172", "Sosnovyy Bor", "Сосновый Бор", "RU", "643", "", "42", "", "", "59.8996", "29.08574", "Europe/Moscow"),("490211", "Sosnovoborsk", "", "RU", "643", "", "57", "", "", "53.29066", "46.24849", "Europe/Moscow"),("490213", "Sosnovo", "", "RU", "643", "", "42", "", "", "60.55145", "30.21441", "Europe/Moscow"),("490276", "Sosnovka", "", "RU", "643", "", "33", "", "", "56.25496", "51.28419", "Europe/Kirov"),("490323", "Sosnovka", "", "RU", "643", "", "72", "", "", "53.23593", "41.36859", "Europe/Moscow"),("490377", "Sosnovaya Polyana", "Сосновая Поляна", "RU", "643", "", "66", "542231", "", "59.83528", "30.14667", "Europe/Moscow"),("490391", "Sosnogorsk", "Сосногорск", "RU", "643", "", "34", "", "", "63.60229", "53.88175", "Europe/Moscow"),("490437", "Sosenskiy", "", "RU", "643", "", "25", "", "", "54.05899", "35.96228", "Europe/Moscow"),("490466", "Sortavala", "Сортавала", "RU", "643", "", "28", "", "", "61.71233", "30.70953", "Europe/Moscow"),("490554", "Sorochinsk", "Сорочинск", "RU", "643", "", "55", "", "", "52.4338", "53.1583", "Asia/Yekaterinburg"),("490683", "Somovo", "", "RU", "643", "", "86", "", "", "51.74098", "39.36655", "Europe/Moscow"),("490750", "Sol’tsy", "", "RU", "643", "", "52", "", "", "58.12387", "30.32377", "Europe/Moscow"),("490971", "Solntsevo", "Солнцево", "RU", "643", "", "48", "", "", "55.63711", "37.38115", "Europe/Moscow"),("490996", "Solnechnogorsk", "Солнечногорск", "RU", "643", "", "47", "", "", "56.18333", "36.98333", "Europe/Moscow"),("491019", "Sol’-Iletsk", "Соль-Илецк", "RU", "643", "", "55", "", "", "51.1631", "54.99176", "Asia/Yekaterinburg"),("491023", "Solikamsk", "Соликамск", "RU", "643", "", "90", "", "", "59.6316", "56.7685", "Asia/Yekaterinburg"),("491025", "Soligalich", "", "RU", "643", "", "37", "", "", "59.0796", "42.28526", "Europe/Moscow"),("491085", "Soldato-Aleksandrovskoye", "", "RU", "643", "", "70", "", "", "44.26528", "43.75611", "Europe/Moscow"),("491145", "Sokol’skoye", "", "RU", "643", "", "51", "", "", "57.14122", "43.15895", "Europe/Moscow"),("491155", "Sokolovyy", "", "RU", "643", "", "67", "", "", "51.56857", "45.83312", "Europe/Volgograd"),("491171", "Sokolovo-Kundryuchenskiy", "", "RU", "643", "", "61", "", "", "47.83536", "39.94711", "Europe/Moscow"),("491250", "Sokol’niki", "Сокольники", "RU", "643", "", "48", "", "", "55.80202", "37.67159", "Europe/Moscow"),("491280", "Sokol", "Сокол", "RU", "643", "", "48", "", "", "55.8", "37.51667", "Europe/Moscow"),("491281", "Sokol", "Сокол", "RU", "643", "", "85", "", "", "59.46167", "40.12056", "Europe/Moscow"),("491352", "Sofrino", "", "RU", "643", "", "47", "", "", "56.15", "37.93333", "Europe/Moscow"),("491422", "Sochi", "Сочи", "RU", "643", "", "38", "6695246", "", "43.59917", "39.72569", "Europe/Moscow"),("491480", "Sobinka", "Собинка", "RU", "643", "", "83", "", "", "55.98553", "40.01111", "Europe/Moscow"),("491576", "Smyshlyayevka", "", "RU", "643", "", "65", "", "", "53.23913", "50.39072", "Europe/Samara"),("491685", "Smolenskaya", "", "RU", "643", "", "38", "", "", "44.78636", "38.80333", "Europe/Moscow"),("491687", "Smolensk", "Смоленск", "RU", "643", "", "69", "", "", "54.7818", "32.0401", "Europe/Moscow"),("491882", "Slobodskoy", "Слободской", "RU", "643", "", "33", "", "", "58.73222", "50.17722", "Europe/Kirov"),("491895", "Slobodka", "Слободка", "RU", "643", "", "48", "", "", "55.86667", "37.58333", "Europe/Moscow"),("492094", "Slavyansk-na-Kubani", "Славянск На Кубани", "RU", "643", "", "38", "", "", "45.2558", "38.1256", "Europe/Moscow"),("492112", "Slavsk", "", "RU", "643", "", "23", "", "", "55.0425", "21.67704", "Europe/Kaliningrad"),("492162", "Slantsy", "Сланцы", "RU", "643", "", "42", "", "", "59.11817", "28.09137", "Europe/Moscow"),("492218", "Skuratovskiy", "", "RU", "643", "", "76", "", "", "54.10152", "37.60384", "Europe/Moscow"),("492333", "Skoropuskovskiy", "", "RU", "643", "", "47", "", "", "56.36667", "38.16667", "Europe/Moscow"),("492376", "Skopin", "Скопин", "RU", "643", "", "62", "", "", "53.82486", "39.55053", "Europe/Moscow"),("492448", "Skhodnya", "Сходня", "RU", "643", "", "47", "", "", "55.94806", "37.29778", "Europe/Moscow"),("492579", "Siverskiy", "", "RU", "643", "", "42", "", "", "59.35444", "30.07833", "Europe/Moscow"),("492768", "Novosin’kovo", "", "RU", "643", "", "47", "", "", "56.37737", "37.32871", "Europe/Moscow"),("492853", "Sinegorskiy", "", "RU", "643", "", "61", "", "", "48.01389", "40.84468", "Europe/Moscow"),("492944", "Sim", "Сим", "RU", "643", "", "13", "", "", "54.993", "57.6982", "Asia/Yekaterinburg"),("493040", "Sigayevo", "", "RU", "643", "", "80", "", "", "56.42163", "53.77566", "Europe/Samara"),("493160", "Sibay", "Сибай", "RU", "643", "", "08", "", "", "52.71806", "58.66583", "Asia/Yekaterinburg"),("493184", "Shvartsevskiy", "", "RU", "643", "", "76", "", "", "54.09174", "37.99053", "Europe/Moscow"),("493231", "Shuya", "Шуя", "RU", "643", "", "21", "", "", "56.84865", "41.38833", "Europe/Moscow"),("493242", "Shuvalovo", "", "RU", "643", "", "66", "", "", "60.04903", "30.2936", "Europe/Moscow"),("493316", "Shushary", "Шушары", "RU", "643", "", "66", "", "", "59.80917", "30.38167", "Europe/Moscow"),("493463", "Shumerlya", "Шумерля", "RU", "643", "", "16", "", "", "55.5005", "46.41288", "Europe/Moscow"),("493702", "Mikhaylovsk", "Михайловск", "RU", "643", "", "70", "", "", "45.12833", "42.02556", "Europe/Moscow"),("493839", "Sholokhovskiy", "", "RU", "643", "", "61", "", "", "48.28071", "41.04592", "Europe/Moscow"),("493970", "Shlissel’burg", "", "RU", "643", "", "42", "472350", "", "59.9473", "31.03845", "Europe/Moscow"),("493997", "Shkurinskaya", "", "RU", "643", "", "38", "", "", "46.5858", "39.3599", "Europe/Moscow"),("494249", "Shirochanka", "", "RU", "643", "", "38", "", "", "46.64968", "38.39782", "Europe/Moscow"),("494427", "Shilovo", "Шилово", "RU", "643", "", "62", "", "", "54.3204", "40.874", "Europe/Moscow"),("494430", "Shilovo", "", "RU", "643", "", "86", "", "", "51.54583", "39.08917", "Europe/Moscow"),("494519", "Shikhany", "", "RU", "643", "", "67", "", "", "52.11776", "47.1986", "Europe/Volgograd"),("494531", "Shigony", "", "RU", "643", "", "65", "", "", "53.3875", "48.6777", "Europe/Samara"),("494806", "Sheremet’yevskiy", "", "RU", "643", "", "47", "", "", "55.97583", "37.49417", "Europe/Moscow"),("494877", "Shentala", "", "RU", "643", "", "65", "", "", "54.45", "51.48333", "Europe/Samara"),("494884", "Shenkursk", "", "RU", "643", "", "06", "", "", "62.1091", "42.89595", "Europe/Moscow"),("494900", "Shemysheyka", "", "RU", "643", "", "57", "", "", "52.89196", "45.39282", "Europe/Moscow"),("494925", "Shemordan", "", "RU", "643", "", "73", "", "", "56.1856", "50.3972", "Europe/Moscow"),("495000", "Shelkovskaya", "", "RU", "643", "", "12", "", "", "43.50804", "46.34016", "Europe/Moscow"),("495062", "Sheksna", "Шексна", "RU", "643", "", "85", "", "", "59.20998", "38.51066", "Europe/Moscow"),("495112", "Shebekino", "Шебекино", "RU", "643", "", "09", "", "", "50.40967", "36.9136", "Europe/Moscow"),("495136", "Shchukino", "Щукино", "RU", "643", "", "48", "", "", "55.8", "37.45", "Europe/Moscow"),("495206", "Shchigry", "Щигры", "RU", "643", "", "41", "", "", "51.87555", "36.90432", "Europe/Moscow"),("495260", "Shcherbinka", "Щербинка", "RU", "643", "", "48", "8520892", "", "55.49972", "37.55972", "Europe/Moscow"),("495344", "Shchelkovo", "Щёлково", "RU", "643", "", "47", "", "", "55.92497", "37.97218", "Europe/Moscow"),("495394", "Shchëkino", "Щекино", "RU", "643", "", "76", "", "", "54.00513", "37.52194", "Europe/Moscow"),("495518", "Shatura", "Шатура", "RU", "643", "", "47", "", "", "55.57253", "39.53682", "Europe/Moscow"),("495532", "Shatsk", "", "RU", "643", "", "62", "", "", "54.02576", "41.71191", "Europe/Moscow"),("495562", "Shatki", "", "RU", "643", "", "51", "", "", "55.18874", "44.12486", "Europe/Moscow"),("495619", "Shar’ya", "Шарья", "RU", "643", "", "37", "", "", "58.36909", "45.51558", "Europe/Moscow"),("495670", "Sharlyk", "", "RU", "643", "", "55", "", "", "52.91667", "54.75", "Asia/Yekaterinburg"),("495688", "Sharkan", "", "RU", "643", "", "80", "", "", "57.29885", "53.87122", "Europe/Samara"),("495767", "Sharanga", "", "RU", "643", "", "51", "", "", "57.17749", "46.53956", "Europe/Moscow"),("495770", "Sharan", "", "RU", "643", "", "08", "", "", "54.81667", "54", "Asia/Yekaterinburg"),("495891", "Shamkhal-Termen", "", "RU", "643", "", "17", "", "", "43.03389", "47.31053", "Europe/Moscow"),("495893", "Shamkhal", "", "RU", "643", "", "17", "", "", "43.05958", "47.33732", "Europe/Moscow"),("495915", "Shalya", "", "RU", "643", "", "71", "", "", "57.2471", "58.7298", "Asia/Yekaterinburg"),("495918", "Shalushka", "", "RU", "643", "", "22", "", "", "43.5325", "43.56611", "Europe/Moscow"),("495957", "Shali", "Шали", "RU", "643", "", "12", "", "", "43.14806", "45.90194", "Europe/Moscow"),("495969", "Shalazhi", "", "RU", "643", "", "12", "", "", "43.09476", "45.35898", "Europe/Moscow"),("496012", "Shakhun’ya", "Шахунья", "RU", "643", "", "51", "", "", "57.67579", "46.61136", "Europe/Moscow"),("496015", "Shakhty", "Шахты", "RU", "643", "", "61", "", "", "47.70911", "40.21443", "Europe/Moscow"),("496035", "Shakhovskaya", "", "RU", "643", "", "47", "", "", "56.03147", "35.50697", "Europe/Moscow"),("496246", "Sevsk", "", "RU", "643", "", "10", "", "", "52.1491", "34.4926", "Europe/Moscow"),("496267", "Severskaya", "Северская", "RU", "643", "", "38", "", "", "44.85407", "38.67686", "Europe/Moscow"),("496269", "Severo-Zadonsk", "Северо-Задонск", "RU", "643", "", "76", "", "", "54.03481", "38.40172", "Europe/Moscow"),("496275", "Severoural’sk", "Североуральск", "RU", "643", "", "71", "", "", "60.15328", "59.95205", "Asia/Yekaterinburg"),("496278", "Severomorsk", "Североморск", "RU", "643", "", "49", "", "", "69.06889", "33.41622", "Europe/Moscow"),("496285", "Severodvinsk", "Северодвинск", "RU", "643", "", "06", "", "", "64.5635", "39.8302", "Europe/Moscow"),("496348", "Severnyy", "Северный", "RU", "643", "", "48", "", "", "55.93583", "37.54889", "Europe/Moscow"),("496358", "Severnyy", "", "RU", "643", "", "09", "", "", "50.67704", "36.55324", "Europe/Moscow"),("496456", "Setun’", "Сетунь", "RU", "643", "", "48", "", "", "55.71667", "37.41667", "Europe/Moscow"),("496478", "Sestroretsk", "Сестрорецк", "RU", "643", "", "66", "", "", "60.09801", "29.96378", "Europe/Moscow"),("496503", "Seshcha", "", "RU", "643", "", "10", "", "", "53.7361", "33.3387", "Europe/Moscow"),("496519", "Sertolovo", "Сертолово", "RU", "643", "", "42", "", "", "60.1444", "30.20165", "Europe/Moscow"),("496527", "Serpukhov", "Серпухов", "RU", "643", "", "47", "", "", "54.91578", "37.41114", "Europe/Moscow"),("496561", "Sernur", "", "RU", "643", "", "45", "", "", "56.93333", "49.15361", "Europe/Moscow"),("496564", "Sernovodsk", "", "RU", "643", "", "19", "", "", "43.31172", "45.15939", "Europe/Moscow"),("496610", "Sergokala", "", "RU", "643", "", "17", "", "", "42.45468", "47.66119", "Europe/Moscow"),("496638", "Sergiyev Posad", "Сергиев Посад", "RU", "643", "", "47", "", "", "56.3", "38.13333", "Europe/Moscow"),("496802", "Sergach", "Сергач", "RU", "643", "", "51", "", "", "55.53079", "45.46611", "Europe/Moscow"),("496879", "Serebryanyye Prudy", "", "RU", "643", "", "47", "", "", "54.46923", "38.72095", "Europe/Moscow"),("496934", "Serdobsk", "Сердобск", "RU", "643", "", "57", "", "", "52.45861", "44.21689", "Europe/Moscow"),("496954", "Serafimovskiy", "", "RU", "643", "", "08", "", "", "54.42408", "53.7964", "Asia/Yekaterinburg"),("496957", "Serafimovich", "", "RU", "643", "", "84", "", "", "49.5786", "42.736", "Europe/Volgograd"),("497019", "Sennoy", "", "RU", "643", "", "67", "", "", "52.1509", "46.96309", "Europe/Volgograd"),("497094", "Sengiley", "", "RU", "643", "", "81", "", "", "53.96222", "48.79444", "Europe/Ulyanovsk"),("497206", "Semiluki", "Семилуки", "RU", "643", "", "86", "", "", "51.68525", "39.02787", "Europe/Moscow"),("497218", "Semikarakorsk", "Семикаракорск", "RU", "643", "", "61", "", "", "47.51943", "40.8112", "Europe/Moscow"),("497242", "Semibratovo", "", "RU", "643", "", "88", "", "", "57.30461", "39.53688", "Europe/Moscow"),("497271", "Semënovskoye", "Семёновское", "RU", "643", "", "47", "", "", "55.68333", "37.55", "Europe/Moscow"),("497450", "Semënov", "Семёнов", "RU", "643", "", "51", "", "", "56.78749", "44.49297", "Europe/Moscow"),("497534", "Selyatino", "", "RU", "643", "", "47", "", "", "55.51514", "36.97746", "Europe/Moscow"),("497547", "Selty", "", "RU", "643", "", "80", "", "", "57.3132", "52.1345", "Europe/Samara"),("497610", "Sel’tso", "Сельцо", "RU", "643", "", "10", "", "", "53.36831", "34.10328", "Europe/Moscow"),("497661", "Selizharovo", "", "RU", "643", "", "77", "", "", "56.85188", "33.44869", "Europe/Moscow"),("497927", "Segezha", "Сегежа", "RU", "643", "", "28", "", "", "63.74147", "34.32218", "Europe/Moscow"),("497984", "Sechenovo", "", "RU", "643", "", "51", "", "", "55.22444", "45.89056", "Europe/Moscow"),("498001", "Sebezh", "", "RU", "643", "", "60", "", "", "56.29546", "28.46538", "Europe/Moscow"),("498264", "Savino", "", "RU", "643", "", "21", "", "", "56.59285", "41.21814", "Europe/Moscow"),("498418", "Satka", "Сатка", "RU", "643", "", "13", "", "", "55.0425", "59.04", "Asia/Yekaterinburg"),("498501", "Sars", "", "RU", "643", "", "90", "", "", "56.55017", "57.13658", "Asia/Yekaterinburg"),("498525", "Sarov", "Саров", "RU", "643", "", "51", "", "", "54.93583", "43.32352", "Europe/Moscow"),("498537", "Sarmanovo", "", "RU", "643", "", "73", "", "", "55.25529", "52.58907", "Europe/Moscow"),("498538", "Sarmakovo", "", "RU", "643", "", "22", "", "", "43.74556", "43.20028", "Europe/Moscow"),("498672", "Saratovskaya", "", "RU", "643", "", "38", "", "", "44.70752", "39.22156", "Europe/Moscow"),("498677", "Saratov", "Саратов", "RU", "643", "", "67", "498661", "", "51.54056", "46.00861", "Europe/Volgograd"),("498687", "Sarapul", "Сарапул", "RU", "643", "", "80", "", "", "56.47633", "53.79782", "Europe/Samara"),("498698", "Saransk", "Саранск", "RU", "643", "", "46", "", "", "54.1838", "45.1749", "Europe/Moscow"),("498708", "Saraktash", "Саракташ", "RU", "643", "", "55", "", "", "51.78771", "56.36091", "Asia/Yekaterinburg"),("498711", "Sarai", "", "RU", "643", "", "62", "", "", "53.74577", "41.02126", "Europe/Moscow"),("498817", "Saint Petersburg", "Санкт-Петербург", "RU", "643", "", "66", "", "", "59.93863", "30.31413", "Europe/Moscow"),("498877", "Sanchursk", "", "RU", "643", "", "33", "", "", "56.94125", "47.24987", "Europe/Kirov"),("498956", "Samoylovka", "", "RU", "643", "", "67", "", "", "51.184", "43.7081", "Europe/Volgograd"),("499040", "Sambek", "", "RU", "643", "", "61", "", "", "47.74306", "39.83083", "Europe/Moscow"),("499051", "Samashki", "", "RU", "643", "", "12", "", "", "43.29056", "45.30139", "Europe/Moscow"),("499055", "Samarskoye", "", "RU", "643", "", "61", "", "", "46.937", "39.6881", "Europe/Moscow"),("499099", "Samara", "Самара", "RU", "643", "", "65", "", "", "53.20007", "50.15", "Europe/Samara"),("499161", "Sal’sk", "Сальск", "RU", "643", "", "61", "", "", "46.4747", "41.54114", "Europe/Moscow"),("499292", "Salavat", "Салават", "RU", "643", "", "08", "", "", "53.38365", "55.90773", "Asia/Yekaterinburg"),("499404", "Sagopshi", "", "RU", "643", "", "19", "", "", "43.48515", "44.59063", "Europe/Moscow"),("499452", "Safonovo", "Сафоново", "RU", "643", "", "69", "", "", "55.15", "33.21667", "Europe/Moscow"),("499528", "Sadovoye", "", "RU", "643", "", "86", "", "", "51.53111", "40.50194", "Europe/Moscow"),("499535", "Sadovoye", "", "RU", "643", "", "24", "", "", "47.7772", "44.5208", "Europe/Moscow"),("499717", "Rzhev", "Ржев", "RU", "643", "", "77", "", "", "56.26241", "34.32817", "Europe/Moscow"),("499778", "Rzhanitsa", "", "RU", "643", "", "10", "", "", "53.42844", "33.92297", "Europe/Moscow"),("499782", "Rzhaksa", "", "RU", "643", "", "72", "", "", "52.13384", "42.0264", "Europe/Moscow"),("499811", "Ryzdvyanyy", "", "RU", "643", "", "70", "", "", "45.2656", "41.8389", "Europe/Moscow"),("499975", "Rybnoye", "Рыбное", "RU", "643", "", "62", "", "", "54.72774", "39.51731", "Europe/Moscow"),("499987", "Rybnaya Sloboda", "", "RU", "643", "", "73", "", "", "55.46129", "50.1409", "Europe/Moscow"),("500004", "Rybinsk", "Рыбинск", "RU", "643", "", "88", "", "", "58.0446", "38.84259", "Europe/Moscow"),("500019", "Rybatskoye", "Рыбатское", "RU", "643", "RU", "42", "", "", "59.8393", "30.49873", "Europe/Moscow"),("500047", "Ryazhsk", "Ряжск", "RU", "643", "", "62", "", "", "53.7038", "40.1109", "Europe/Moscow"),("500060", "Ryazanskaya", "", "RU", "643", "", "38", "", "", "44.95528", "39.58894", "Europe/Moscow"),("500096", "Ryazan’", "Рязань", "RU", "643", "", "62", "", "", "54.6269", "39.6916", "Europe/Moscow"),("500299", "Ruzayevka", "Рузаевка", "RU", "643", "", "46", "", "", "54.06387", "44.9509", "Europe/Moscow"),("500303", "Ruza", "", "RU", "643", "", "47", "", "", "55.69898", "36.19522", "Europe/Moscow"),("500400", "Russkiy Kameshkir", "", "RU", "643", "", "57", "", "", "52.85955", "46.08861", "Europe/Moscow"),("500589", "Rumyantsevo", "", "RU", "643", "RU", "47", "", "", "55.97278", "36.53417", "Europe/Moscow"),("500667", "Rudnya", "", "RU", "643", "", "69", "", "", "54.94698", "31.0934", "Europe/Moscow"),("500678", "Rudnya", "", "RU", "643", "", "84", "", "", "50.79898", "44.55856", "Europe/Volgograd"),("500695", "Rudnichnyy", "", "RU", "643", "", "33", "", "", "59.61702", "52.47033", "Europe/Kirov"),("500843", "Rublëvo", "Рублево", "RU", "643", "", "48", "", "", "55.78514", "37.35481", "Europe/Moscow"),("500886", "Rtishchevo", "Ртищево", "RU", "643", "", "67", "", "", "52.26041", "43.78745", "Europe/Volgograd"),("501027", "Rozhdestveno", "", "RU", "643", "", "65", "", "", "53.23745", "50.05971", "Europe/Samara"),("501091", "Rovnoye", "", "RU", "643", "", "67", "", "", "50.7765", "46.05085", "Europe/Volgograd"),("501175", "Rostov-na-Donu", "Ростов-на-Дону", "RU", "643", "", "61", "", "", "47.23135", "39.72328", "Europe/Moscow"),("501183", "Rostov", "Ростов", "RU", "643", "", "88", "", "", "57.1914", "39.41394", "Europe/Moscow"),("501187", "Rostokino", "Ростокино", "RU", "643", "", "48", "", "", "55.83333", "37.66667", "Europe/Moscow"),("501215", "Rossosh’", "Россошь", "RU", "643", "", "86", "", "", "51.1209", "38.5116", "Europe/Moscow"),("501231", "Rossosh’", "Россошь", "RU", "643", "", "86", "", "", "50.19828", "39.56726", "Europe/Moscow"),("501265", "Roslyakovo", "", "RU", "643", "", "49", "", "", "69.04303", "33.19906", "Europe/Moscow"),("501283", "Roslavl’", "Рославль", "RU", "643", "", "69", "", "", "53.95278", "32.86389", "Europe/Moscow"),("501296", "Roshchino", "", "RU", "643", "", "42", "undefined = Vyborgskiy Rayon", "", "60.25191", "29.6085", "Europe/Moscow"),("501318", "Mariyenburg", "", "RU", "643", "", "42", "", "", "59.57139", "30.06472", "Europe/Moscow"),("501320", "Roshal’", "Рошаль", "RU", "643", "", "47", "", "", "55.66853", "39.87488", "Europe/Moscow"),("501349", "Romodanovo", "", "RU", "643", "", "46", "", "", "54.42753", "45.32962", "Europe/Moscow"),("501405", "Romanovskaya", "", "RU", "643", "", "61", "", "", "47.5426", "42.0285", "Europe/Moscow"),("501440", "Romanovka", "", "RU", "643", "", "42", "", "", "60.0443", "30.714", "Europe/Moscow"),("501468", "Romanovka", "", "RU", "643", "", "67", "", "", "51.74427", "42.7527", "Europe/Volgograd"),("501579", "Rogovskaya", "", "RU", "643", "", "38", "", "", "45.73117", "38.7396", "Europe/Moscow"),("501716", "Rodnikovskaya", "", "RU", "643", "", "38", "", "", "44.76444", "40.66556", "Europe/Moscow"),("501730", "Rodniki", "Родники", "RU", "643", "", "21", "", "", "57.10513", "41.73048", "Europe/Moscow"),("501774", "Rodionovo-Nesvetayskaya", "", "RU", "643", "", "61", "", "", "47.61033", "39.71212", "Europe/Moscow"),("501775", "Rodionovo-Nesvetaiskoye", "", "RU", "643", "", "61", "", "", "47.6", "39.7", "Europe/Moscow"),("502010", "Revda", "", "RU", "643", "", "49", "", "", "67.9371", "34.56149", "Europe/Moscow"),("502011", "Revda", "Ревда", "RU", "643", "", "71", "", "", "56.80097", "59.93028", "Asia/Yekaterinburg"),("502018", "Reutov", "Реутов", "RU", "643", "", "47", "", "", "55.76111", "37.8575", "Europe/Moscow"),("502078", "Reshetikha", "", "RU", "643", "", "51", "", "", "56.21566", "43.28802", "Europe/Moscow"),("502185", "Remontnoye", "", "RU", "643", "", "61", "", "", "46.5614", "43.6501", "Europe/Moscow"),("502265", "Redkino", "", "RU", "643", "", "77", "", "", "56.64754", "36.29674", "Europe/Moscow"),("502400", "Razumnoye", "Разумное", "RU", "643", "", "09", "", "", "50.53439", "36.68462", "Europe/Moscow"),("502540", "Rayevskiy", "Раевский", "RU", "643", "", "08", "", "", "54.0658", "54.9468", "Asia/Yekaterinburg"),("502542", "Rayevskaya", "", "RU", "643", "", "38", "", "", "44.83571", "37.55577", "Europe/Moscow"),("502793", "Rasskazovo", "Рассказово", "RU", "643", "", "72", "", "", "52.65599", "41.88461", "Europe/Moscow"),("502797", "Rasshevatskaya", "", "RU", "643", "", "70", "", "", "45.5748", "41.03496", "Europe/Moscow"),("502895", "Ramon’", "", "RU", "643", "", "86", "", "", "51.91569", "39.33609", "Europe/Moscow"),("502965", "Ramenskoye", "", "RU", "643", "", "47", "502966", "", "55.56694", "38.23028", "Europe/Moscow"),("502971", "Ramenki", "Раменки", "RU", "643", "", "48", "", "", "55.7", "37.5", "Europe/Moscow"),("503067", "Rakitnoye", "", "RU", "643", "", "09", "", "", "50.8389", "35.8515", "Europe/Moscow"),("503374", "Pytalovo", "", "RU", "643", "", "60", "", "", "57.06791", "27.91384", "Europe/Moscow"),("503550", "Pyatigorsk", "Пятигорск", "RU", "643", "", "70", "", "", "44.04861", "43.05944", "Europe/Moscow"),("503878", "Pustoshka", "", "RU", "643", "", "60", "", "", "56.33547", "29.36901", "Europe/Moscow"),("503965", "Pushkinskiye Gory", "", "RU", "643", "", "60", "", "", "57.02085", "28.9103", "Europe/Moscow"),("503977", "Pushkino", "Пушкино", "RU", "643", "", "47", "", "", "56.01722", "37.86667", "Europe/Moscow"),("504003", "Pushkin", "Пушкин", "RU", "643", "", "66", "", "", "59.71417", "30.39642", "Europe/Moscow"),("504042", "Pushchino", "Пущино", "RU", "643", "", "47", "", "", "54.83373", "37.61138", "Europe/Moscow"),("504250", "Pugachev", "", "RU", "643", "", "67", "", "", "52.01333", "48.8025", "Europe/Volgograd"),("504269", "Pudozh", "", "RU", "643", "", "28", "", "", "61.80415", "36.5277", "Europe/Moscow"),("504294", "Puchezh", "", "RU", "643", "", "21", "", "", "56.97878", "43.16761", "Europe/Moscow"),("504317", "Psyzh", "", "RU", "643", "", "27", "", "", "44.23306", "42.01833", "Europe/Moscow"),("504327", "Psygansu", "", "RU", "643", "", "22", "", "", "43.41944", "43.79361", "Europe/Moscow"),("504341", "Pskov", "Псков", "RU", "643", "", "60", "", "", "57.8136", "28.3496", "Europe/Moscow"),("504388", "Psedakh", "", "RU", "643", "", "19", "", "", "43.46722", "44.56917", "Europe/Moscow"),("504391", "Psebay", "", "RU", "643", "", "38", "", "", "44.1234", "40.8107", "Europe/Moscow"),("504416", "Pryamitsyno", "", "RU", "643", "", "41", "", "", "51.6561", "35.9314", "Europe/Moscow"),("504576", "Protvino", "Протвино", "RU", "643", "", "47", "", "", "54.86821", "37.21583", "Europe/Moscow"),("504806", "Proletarskiy", "", "RU", "643", "", "09", "", "", "50.79139", "35.77306", "Europe/Moscow"),("504831", "Proletarsk", "Пролетарск", "RU", "643", "", "61", "", "", "46.70289", "41.72717", "Europe/Moscow"),("504840", "Proletariy", "", "RU", "643", "", "52", "", "", "58.43423", "31.70462", "Europe/Moscow"),("504915", "Prokhorovka", "", "RU", "643", "", "09", "", "", "51.03741", "36.73252", "Europe/Moscow"),("504935", "Prokhladnyy", "Прохладный", "RU", "643", "", "22", "", "", "43.75741", "44.0297", "Europe/Moscow"),("505014", "Priyutovo", "Приютово", "RU", "643", "", "08", "", "", "53.9", "53.93333", "Asia/Yekaterinburg"),("505019", "Priyutnoye", "", "RU", "643", "", "24", "", "", "46.10111", "43.50722", "Europe/Moscow"),("505057", "Privolzhskiy", "Приволжский", "RU", "643", "", "67", "", "", "51.40944", "46.04833", "Europe/Volgograd"),("505060", "Privolzhsk", "Приволжск", "RU", "643", "", "21", "", "", "57.38698", "41.28666", "Europe/Moscow"),("505154", "Pristen’", "", "RU", "643", "", "41", "", "", "51.23551", "36.69594", "Europe/Moscow"),("505230", "Priozërsk", "Приозерск", "RU", "643", "", "42", "", "", "61.03928", "30.12907", "Europe/Moscow"),("505259", "Primorsko-Akhtarsk", "Приморско-Ахтарск", "RU", "643", "", "38", "", "", "46.0497", "38.1747", "Europe/Moscow"),("505269", "Primorsk", "", "RU", "643", "", "42", "", "", "60.36593", "28.60737", "Europe/Moscow"),("505421", "Pridonskoy", "Придонской", "RU", "643", "", "86", "", "", "51.68406", "39.0727", "Europe/Moscow"),("505539", "Pregradnaya", "", "RU", "643", "", "27", "", "", "43.95395", "41.1891", "Europe/Moscow"),("505581", "Pravokumskoye", "", "RU", "643", "", "70", "", "", "44.76944", "44.64722", "Europe/Moscow"),("505597", "Pravdinskiy", "", "RU", "643", "", "47", "", "", "56.06034", "37.86266", "Europe/Moscow"),("505641", "Praskoveya", "", "RU", "643", "", "70", "", "", "44.74444", "44.20306", "Europe/Moscow"),("505806", "Povorino", "Поворино", "RU", "643", "", "86", "", "", "51.1945", "42.2457", "Europe/Moscow"),("505824", "Povarovo", "", "RU", "643", "", "47", "", "", "56.06667", "37.05", "Europe/Moscow"),("506029", "Poshekhon’ye", "", "RU", "643", "", "88", "", "", "58.49928", "39.13531", "Europe/Moscow"),("506043", "Kotlovka", "Котловка", "RU", "643", "", "48", "", "", "55.65928", "37.60404", "Europe/Moscow"),("506117", "Annino", "Аннино", "RU", "643", "", "48", "", "", "55.58333", "37.6", "Europe/Moscow"),("506278", "Porkhov", "", "RU", "643", "", "60", "", "", "57.76502", "29.55612", "Europe/Moscow"),("506286", "Poretskoye", "", "RU", "643", "", "16", "", "", "55.19742", "46.32908", "Europe/Moscow"),("506320", "Poputnaya", "", "RU", "643", "", "38", "", "", "44.5125", "41.4392", "Europe/Moscow"),("506612", "Pontonnyy", "", "RU", "643", "", "66", "", "", "59.78667", "30.61528", "Europe/Moscow"),("506762", "Polyarnyye Zori", "Полярные Зори", "RU", "643", "", "49", "", "", "67.36611", "32.49806", "Europe/Moscow"),("506763", "Polyarnyy", "Полярный", "RU", "643", "", "49", "", "", "69.19889", "33.44778", "Europe/Moscow"),("506782", "Polyany", "", "RU", "643", "", "62", "", "", "54.71801", "39.82932", "Europe/Moscow"),("507079", "Polotnyanyy Zavod", "", "RU", "643", "", "25", "", "", "54.72139", "35.96611", "Europe/Moscow"),("507291", "Polessk", "", "RU", "643", "", "23", "", "", "54.86205", "21.10279", "Europe/Kaliningrad"),("507318", "Polazna", "", "RU", "643", "", "90", "", "", "58.2922", "56.4156", "Asia/Yekaterinburg"),("507338", "Pokrovskoye-Streshnëvo", "Покровское-Стрешнёво", "RU", "643", "", "48", "", "", "55.80797", "37.45814", "Europe/Moscow"),("507427", "Pokrovskoye", "", "RU", "643", "", "61", "", "", "47.4157", "38.89706", "Europe/Moscow"),("507479", "Pokrovo-Prigorodnoye", "", "RU", "643", "", "72", "", "", "52.68405", "41.41752", "Europe/Moscow"),("507599", "Pokrov", "Покров", "RU", "643", "", "83", "", "", "55.91797", "39.17242", "Europe/Moscow"),("507612", "Pokoynoye", "", "RU", "643", "", "70", "", "", "44.80972", "44.25167", "Europe/Moscow"),("507624", "Pokhvistnevo", "Похвистнево", "RU", "643", "", "65", "", "", "53.65237", "52.12738", "Europe/Samara"),("507875", "Pogar", "", "RU", "643", "", "10", "", "", "52.55399", "33.25907", "Europe/Moscow"),("508034", "Podporozh’ye", "Подпорожье", "RU", "643", "", "42", "", "", "60.91124", "34.17064", "Europe/Moscow"),("508101", "Podolsk", "Подольск", "RU", "643", "", "47", "508091", "", "55.42419", "37.55472", "Europe/Moscow"),("508362", "Podgornoye", "", "RU", "643", "", "86", "", "", "51.73504", "39.14961", "Europe/Moscow"),("508390", "Podgornaya", "", "RU", "643", "", "70", "", "", "44.20306", "43.42972", "Europe/Moscow"),("508394", "Podgorenskiy", "", "RU", "643", "", "86", "", "", "50.40498", "39.64295", "Europe/Moscow"),("508606", "Pochinok", "", "RU", "643", "", "69", "", "", "54.40685", "32.44067", "Europe/Moscow"),("508635", "Pochinki", "", "RU", "643", "", "51", "", "", "54.69875", "44.86678", "Europe/Moscow"),("508656", "Pochep", "Почеп", "RU", "643", "", "10", "508648", "", "52.9336", "33.4464", "Europe/Moscow"),("508751", "Ryazanskiy", "Рязанский", "RU", "643", "", "48", "", "", "55.73333", "37.76667", "Europe/Moscow"),("509026", "Plesetsk", "", "RU", "643", "", "06", "", "", "62.70804", "40.29159", "Europe/Moscow"),("509052", "Plavsk", "Плавск", "RU", "643", "", "76", "", "", "53.70944", "37.29194", "Europe/Moscow"),("509113", "Platnirovskaya", "", "RU", "643", "", "38", "", "", "45.39531", "39.3842", "Europe/Moscow"),("509124", "Plastunovskaya", "", "RU", "643", "", "38", "", "", "45.29432", "39.26505", "Europe/Moscow"),("509234", "Pitkyaranta", "", "RU", "643", "", "28", "", "", "61.5734", "31.47915", "Europe/Moscow"),("509269", "Piterka", "", "RU", "643", "", "67", "", "", "50.6803", "47.44539", "Europe/Volgograd"),("509392", "Pirogovskiy", "", "RU", "643", "", "47", "", "", "55.97806", "37.73361", "Europe/Moscow"),("509437", "Pionerskiy", "", "RU", "643", "", "23", "825118", "", "54.95083", "20.22748", "Europe/Kaliningrad"),("509487", "Pindushi", "", "RU", "643", "", "28", "", "", "62.91519", "34.57996", "Europe/Moscow"),("509538", "Pil’na", "", "RU", "643", "", "51", "", "", "55.55394", "45.92194", "Europe/Moscow"),("509598", "Pikalëvo", "Пикалёво", "RU", "643", "", "42", "575409", "", "59.51833", "34.16639", "Europe/Moscow"),("509697", "Petushki", "Петушки", "RU", "643", "", "83", "", "", "55.92639", "39.46104", "Europe/Moscow"),("509820", "Petrozavodsk", "Петрозаводск", "RU", "643", "", "28", "", "", "61.78491", "34.34691", "Europe/Moscow"),("509826", "Petrov Val", "", "RU", "643", "", "84", "", "", "50.14337", "45.20958", "Europe/Volgograd"),("509850", "Petrovsk", "", "RU", "643", "", "88", "", "", "57.01039", "39.26928", "Europe/Moscow"),("509981", "Petrovskaya", "Петровская", "RU", "643", "", "47", "", "", "55.55", "37.78333", "Europe/Moscow"),("509985", "Petrovskaya", "", "RU", "643", "", "38", "", "", "45.43139", "37.955", "Europe/Moscow"),("509987", "Petrovsk", "Петровск", "RU", "643", "", "67", "", "", "52.30639", "45.39167", "Europe/Volgograd"),("510171", "Petropavlovskaya", "", "RU", "643", "", "38", "", "", "45.08189", "40.45125", "Europe/Moscow"),("510225", "Petrodvorets", "Петродворец", "RU", "643", "", "66", "", "", "59.89565", "29.80145", "Europe/Moscow"),("510291", "Peterhof", "Петергоф", "RU", "643", "", "66", "", "", "59.88333", "29.9", "Europe/Moscow"),("510342", "Pestretsy", "", "RU", "643", "", "73", "", "", "55.75313", "49.65454", "Europe/Moscow"),("510347", "Pestravka", "", "RU", "643", "", "65", "", "", "52.3982", "49.961", "Europe/Samara"),("510364", "Pestovo", "Пестово", "RU", "643", "", "52", "", "", "58.59382", "35.80244", "Europe/Moscow"),("510410", "Pesochnyy", "", "RU", "643", "", "66", "", "", "60.12295", "30.16404", "Europe/Moscow"),("510473", "Peskovka", "", "RU", "643", "", "33", "", "", "59.04478", "52.36057", "Europe/Kirov"),("510613", "Peschanokopskoye", "", "RU", "643", "", "61", "", "", "46.19517", "41.08143", "Europe/Moscow"),("510808", "Pervoural’sk", "Первоуральск", "RU", "643", "", "71", "", "", "56.90528", "59.94361", "Asia/Yekaterinburg"),("510842", "Pervomayskoye", "", "RU", "643", "", "27", "", "", "43.93847", "42.476", "Europe/Moscow"),("510899", "Pervomayskiy", "", "RU", "643", "", "76", "", "", "54.04482", "37.50875", "Europe/Moscow"),("510911", "Pervomayskiy", "", "RU", "643", "", "72", "", "", "53.2485", "40.2871", "Europe/Moscow"),("510997", "Pervomayskaya", "", "RU", "643", "", "12", "", "", "43.40331", "45.52343", "Europe/Moscow"),("511002", "Pervomaysk", "", "RU", "643", "", "51", "", "", "54.8689", "43.80272", "Europe/Moscow"),("511196", "Perm", "Пермь", "RU", "643", "", "90", "", "", "58.01046", "56.25017", "Asia/Yekaterinburg"),("511264", "Pereyaslovskaya", "", "RU", "643", "", "38", "", "", "45.84121", "39.02379", "Europe/Moscow"),("511287", "Perevoz", "", "RU", "643", "", "51", "", "", "55.59613", "44.54461", "Europe/Moscow"),("511291", "Perevolotskiy", "", "RU", "643", "", "55", "", "", "51.87633", "54.19378", "Asia/Yekaterinburg"),("511359", "Pereslavl’-Zalesskiy", "Переславль-Залесский", "RU", "643", "", "88", "", "", "56.73934", "38.85626", "Europe/Moscow"),("511416", "Perelyub", "", "RU", "643", "", "67", "", "", "51.86292", "50.35412", "Europe/Volgograd"),("511510", "Novo-Peredelkino", "Ново-Переделкино", "RU", "643", "", "48", "", "", "55.64528", "37.33583", "Europe/Moscow"),("511565", "Penza", "Пенза", "RU", "643", "", "57", "", "", "53.20066", "45.00464", "Europe/Moscow"),("511592", "Peno", "", "RU", "643", "", "77", "", "", "56.92624", "32.74262", "Europe/Moscow"),("511707", "Pelagiada", "", "RU", "643", "", "70", "", "", "45.20639", "42.02361", "Europe/Moscow"),("511785", "Pechory", "", "RU", "643", "", "60", "", "", "57.81642", "27.6119", "Europe/Moscow"),("511794", "Pechora", "Печора", "RU", "643", "", "34", "", "", "65.14717", "57.22439", "Europe/Moscow"),("512023", "Pavlovskiy Posad", "Павловский Посад", "RU", "643", "", "47", "", "", "55.78187", "38.65025", "Europe/Moscow"),("512039", "Pavlovskaya Sloboda", "", "RU", "643", "", "47", "", "", "55.81517", "37.08246", "Europe/Moscow"),("512051", "Pavlovskaya", "Павловская", "RU", "643", "", "38", "", "", "46.1377", "39.7832", "Europe/Moscow"),("512052", "Pavlovsk", "Павловск", "RU", "643", "", "66", "", "", "59.68333", "30.43472", "Europe/Moscow"),("512053", "Pavlovsk", "Павловск", "RU", "643", "", "86", "", "", "50.45778", "40.10806", "Europe/Moscow"),("512133", "Pavlovka", "", "RU", "643", "", "81", "", "", "53.59569", "46.76631", "Europe/Ulyanovsk"),("512152", "Pavlovka", "", "RU", "643", "", "81", "", "", "52.68966", "47.14046", "Europe/Ulyanovsk"),("512217", "Pavlodol’skaya", "", "RU", "643", "", "68", "", "", "43.71923", "44.47815", "Europe/Moscow"),("512382", "Pashkovskiy", "Пашковский", "RU", "643", "", "38", "", "", "45.02366", "39.10436", "Europe/Moscow"),("512566", "Pargolovo", "", "RU", "643", "", "66", "", "", "60.0812", "30.27626", "Europe/Moscow"),("512570", "Parfino", "", "RU", "643", "", "52", "", "", "57.97306", "31.64806", "Europe/Moscow"),("512618", "Paran’ga", "", "RU", "643", "", "45", "", "", "56.70389", "49.40472", "Europe/Moscow"),("512817", "Pankovka", "", "RU", "643", "", "52", "", "", "58.50004", "31.1999", "Europe/Moscow"),("512861", "Panino", "", "RU", "643", "", "86", "", "", "51.6467", "40.1346", "Europe/Moscow"),("513042", "Pallasovka", "Палласовка", "RU", "643", "", "84", "", "", "50.05", "46.88333", "Europe/Volgograd"),("513095", "Palekh", "", "RU", "643", "", "21", "", "", "56.80256", "41.85508", "Europe/Moscow"),("513309", "Pachelma", "", "RU", "643", "", "57", "", "", "53.24426", "43.35205", "Europe/Moscow"),("513329", "Staryye Ozinki", "", "RU", "643", "", "67", "", "", "51.1786", "49.6769", "Europe/Volgograd"),("513362", "Ozherel’ye", "", "RU", "643", "", "47", "", "", "54.79197", "38.26559", "Europe/Moscow"),("513378", "Ozëry", "Озеры", "RU", "643", "", "47", "", "", "54.85998", "38.55062", "Europe/Moscow"),("513406", "Ozërsk", "", "RU", "643", "", "23", "", "", "54.41056", "22.01167", "Europe/Kaliningrad"),("513426", "Ozërnyy", "", "RU", "643", "", "69", "", "", "55.5802", "32.4127", "Europe/Moscow"),("513471", "Ozerki", "Озерки", "RU", "643", "", "66", "", "", "60.03947", "30.31128", "Europe/Moscow"),("513883", "Otradnyy", "Отрадный", "RU", "643", "", "65", "", "", "53.37596", "51.3452", "Europe/Samara"),("513896", "Otradnoye", "Отрадное", "RU", "643", "", "48", "", "", "55.86667", "37.6", "Europe/Moscow"),("513898", "Otradnoye", "Отрадное", "RU", "643", "", "42", "", "", "59.7775", "30.81806", "Europe/Moscow"),("513911", "Otradnaya", "Отрадная", "RU", "643", "", "38", "", "", "44.39333", "41.52056", "Europe/Moscow"),("514052", "Ostrovskoye", "", "RU", "643", "", "37", "", "", "57.80574", "42.24332", "Europe/Moscow"),("514171", "Ostrov", "Остров", "RU", "643", "", "60", "", "", "57.34395", "28.35368", "Europe/Moscow"),("514198", "Ostrogozhsk", "Острогожск", "RU", "643", "", "86", "", "", "50.8664", "39.07561", "Europe/Moscow"),("514259", "Ostashkov", "Осташков", "RU", "643", "", "77", "", "", "57.14667", "33.10753", "Europe/Moscow"),("514284", "Ostankinskiy", "Останкинский", "RU", "643", "", "48", "", "", "55.82957", "37.61604", "Europe/Moscow"),("514460", "Osinovo", "", "RU", "643", "", "73", "", "", "55.8809", "48.881", "Europe/Moscow"),("514706", "Osa", "Оса", "RU", "643", "", "90", "", "", "57.283", "55.4589", "Asia/Yekaterinburg"),("514734", "Orsk", "Орск", "RU", "643", "", "55", "", "", "51.20487", "58.56685", "Asia/Yekaterinburg"),("514739", "Orshanka", "", "RU", "643", "", "45", "", "", "56.91607", "47.89335", "Europe/Moscow"),("514796", "Orlovskiy", "Орловский", "RU", "643", "", "61", "", "", "46.87139", "42.05917", "Europe/Moscow"),("514966", "Orichi", "", "RU", "643", "", "33", "", "", "58.40356", "49.05719", "Europe/Kirov"),("515003", "Orenburg", "Оренбург", "RU", "643", "", "55", "", "", "51.7727", "55.0988", "Asia/Yekaterinburg"),("515012", "Orël", "Орёл", "RU", "643", "", "56", "", "", "52.96508", "36.07849", "Europe/Moscow"),("515024", "Orekhovo-Zuyevo", "Орехово-Зуево", "RU", "643", "", "47", "", "", "55.80672", "38.96178", "Europe/Moscow"),("515027", "Orekhovo-Borisovo Severnoye", "Орехово-Борисово Северное", "RU", "643", "", "48", "490025", "", "55.61667", "37.68333", "Europe/Moscow"),("515083", "Sunzha", "Орджоникидзевская", "RU", "643", "", "19", "", "", "43.3195", "45.04911", "Europe/Moscow"),("515098", "Orda", "", "RU", "643", "", "90", "", "", "57.19509", "56.90908", "Asia/Yekaterinburg"),("515155", "Opochka", "", "RU", "643", "", "60", "", "", "56.71048", "28.66174", "Europe/Moscow"),("515186", "Opalikha", "", "RU", "643", "", "47", "", "", "55.82593", "37.25278", "Europe/Moscow"),("515246", "Onega", "Онега", "RU", "643", "", "06", "", "", "63.90692", "38.11112", "Europe/Moscow"),("515267", "Omutninsk", "Омутнинск", "RU", "643", "", "33", "", "", "58.67001", "52.1932", "Europe/Kirov"),("515403", "Olonets", "", "RU", "643", "", "28", "", "", "60.98475", "32.96976", "Europe/Moscow"),("515558", "Ol’gino", "", "RU", "643", "", "42", "", "", "59.83702", "29.92266", "Europe/Moscow"),("515582", "Ol’ginskaya", "", "RU", "643", "", "61", "", "", "47.18794", "39.94925", "Europe/Moscow"),("515687", "Olenino", "", "RU", "643", "", "77", "", "", "56.20917", "33.48888", "Europe/Moscow"),("515698", "Olenegorsk", "Оленегорск", "RU", "643", "", "49", "", "", "68.1432", "33.25287", "Europe/Moscow"),("515771", "Okulovka", "", "RU", "643", "", "52", "", "", "58.40083", "33.29083", "Europe/Moscow"),("515804", "Tsotsin-Yurt", "Цоцин-Юрт", "RU", "643", "", "12", "", "", "43.24206", "46.00013", "Europe/Moscow"),("515873", "Oktyabr’skiy", "", "RU", "643", "", "47", "", "", "55.60806", "37.97738", "Europe/Moscow"),("515879", "Oktyabr’skiy", "Октябрьский", "RU", "643", "", "08", "", "", "54.48147", "53.47103", "Asia/Yekaterinburg"),("515882", "Oktyabr’skiy", "", "RU", "643", "", "62", "", "", "54.22675", "38.89402", "Europe/Moscow"),("515921", "Takhtamukay", "", "RU", "643", "", "01", "", "", "44.9215", "38.99583", "Europe/Moscow"),("516073", "Okhansk", "", "RU", "643", "", "90", "", "", "57.7203", "55.3882", "Asia/Yekaterinburg"),("516197", "Odoyev", "", "RU", "643", "", "76", "", "", "53.93933", "36.68639", "Europe/Moscow"),("516215", "Odintsovo", "Одинцово", "RU", "643", "", "47", "", "", "55.67798", "37.27773", "Europe/Moscow"),("516256", "Ochër", "Очер", "RU", "643", "", "90", "", "", "57.89035", "54.72019", "Asia/Yekaterinburg"),("516264", "Ochakovo-Matveyevskoye", "Очаково-Матвеевское", "RU", "643", "", "48", "", "", "55.68432", "37.44654", "Europe/Moscow"),("516305", "Obukhovo", "", "RU", "643", "", "47", "", "", "55.83278", "38.2725", "Europe/Moscow"),("516342", "Obsharovka", "", "RU", "643", "", "65", "", "", "53.125", "48.85306", "Europe/Samara"),("516400", "Oboyan’", "", "RU", "643", "", "41", "", "", "51.20981", "36.27919", "Europe/Moscow"),("516436", "Obninsk", "Обнинск", "RU", "643", "", "25", "", "", "55.09681", "36.61006", "Europe/Moscow"),("516454", "Oblivskaya", "", "RU", "643", "", "61", "", "", "48.53616", "42.50138", "Europe/Moscow"),("516576", "Nytva", "Нытва", "RU", "643", "", "90", "", "", "57.9437", "55.3396", "Asia/Yekaterinburg"),("516588", "Nyrob", "", "RU", "643", "", "90", "", "", "60.733", "56.72024", "Asia/Yekaterinburg"),("516615", "Nyazepetrovsk", "", "RU", "643", "", "13", "", "", "56.05306", "59.60278", "Asia/Yekaterinburg"),("516647", "Nyandoma", "Няндома", "RU", "643", "", "06", "", "", "61.6656", "40.2013", "Europe/Moscow"),("516716", "Nurlat", "Нурлат", "RU", "643", "", "73", "515836", "", "54.42766", "50.80511", "Europe/Moscow"),("516780", "Nozhay-Yurt", "", "RU", "643", "", "12", "", "", "43.0929", "46.37868", "Europe/Moscow"),("516875", "Novyy Rogachik", "", "RU", "643", "", "84", "", "", "48.67685", "44.06081", "Europe/Volgograd"),("516931", "Novyy Oskol", "Новый Оскол", "RU", "643", "", "09", "", "", "50.7633", "37.86402", "Europe/Moscow"),("517111", "Novyye Lyady", "", "RU", "643", "", "90", "", "", "58.0552", "56.6104", "Asia/Yekaterinburg"),("517121", "Novyye Kuz’minki", "Новые Кузьминки", "RU", "643", "", "48", "", "", "55.7", "37.75", "Europe/Moscow"),("517161", "Novyye Cherëmushki", "Новые Черёмушки", "RU", "643", "", "48", "", "", "55.7", "37.58333", "Europe/Moscow"),("517172", "Novyye Burasy", "", "RU", "643", "", "67", "", "", "52.13236", "46.07144", "Europe/Volgograd"),("517191", "Novyye Atagi", "", "RU", "643", "", "12", "", "", "43.13528", "45.77306", "Europe/Moscow"),("517269", "Novozybkov", "Новозыбков", "RU", "643", "", "10", "", "", "52.5396", "31.9275", "Europe/Moscow"),("517303", "Novozavedennoye", "", "RU", "643", "", "70", "", "", "44.26278", "43.63806", "Europe/Moscow"),("517577", "Novoye Devyatkino", "", "RU", "643", "", "42", "", "", "60.06364", "30.48328", "Europe/Moscow"),("517698", "Novovyazniki", "", "RU", "643", "", "83", "", "", "56.1975", "42.17111", "Europe/Moscow"),("517716", "Novovoronezh", "Нововоронеж", "RU", "643", "", "86", "", "", "51.30719", "39.21732", "Europe/Moscow"),("517725", "Novovelichkovskaya", "", "RU", "643", "", "38", "", "", "45.27638", "38.84165", "Europe/Moscow"),("517739", "Novouzensk", "Новоузенск", "RU", "643", "", "67", "", "", "50.45917", "48.14306", "Europe/Volgograd"),("517744", "Novoutkinsk", "", "RU", "643", "", "71", "", "", "56.99295", "59.55714", "Asia/Yekaterinburg"),("517766", "Novoul’yanovsk", "Новоульяновск", "RU", "643", "", "81", "", "", "54.14961", "48.38907", "Europe/Ulyanovsk"),("517767", "Novoukrainskoye", "", "RU", "643", "", "38", "", "", "45.37833", "40.52972", "Europe/Moscow"),("517813", "Novotroitskaya", "", "RU", "643", "", "70", "", "", "45.32667", "41.52528", "Europe/Moscow"),("517836", "Novotroitsk", "Новотроицк", "RU", "643", "", "55", "", "", "51.20301", "58.32665", "Asia/Yekaterinburg"),("517842", "Novotitarovskaya", "Новотитаровская", "RU", "643", "", "38", "", "", "45.23756", "38.98059", "Europe/Moscow"),("517856", "Novo-Talitsy", "", "RU", "643", "", "21", "", "", "57.00392", "40.85936", "Europe/Moscow"),("517897", "Novospasskoye", "", "RU", "643", "", "81", "", "", "53.14683", "47.75138", "Europe/Ulyanovsk"),("517921", "Novosokol’niki", "", "RU", "643", "", "60", "", "", "56.34634", "30.15778", "Europe/Moscow"),("517926", "Novosmolinskiy", "", "RU", "643", "", "51", "", "", "56.2841", "43.05071", "Europe/Moscow"),("517959", "Novoshcherbinovskaya", "", "RU", "643", "", "38", "", "", "46.47669", "38.64757", "Europe/Moscow"),("517963", "Novoshakhtinsk", "Новошахтинск", "RU", "643", "", "61", "", "", "47.76037", "39.93335", "Europe/Moscow"),("517982", "Novosergiyevka", "", "RU", "643", "", "55", "", "", "52.0934", "53.6528", "Asia/Yekaterinburg"),("517992", "Novosemeykino", "", "RU", "643", "", "65", "", "", "53.37056", "50.35428", "Europe/Samara"),("518209", "Novoselitskoye", "", "RU", "643", "", "70", "", "", "44.75083", "43.43694", "Europe/Moscow"),("518249", "Novorozhdestvenskaya", "", "RU", "643", "", "38", "", "", "45.86057", "39.94968", "Europe/Moscow"),("518255", "Novorossiysk", "Новороссийск", "RU", "643", "", "38", "", "", "44.72439", "37.76752", "Europe/Moscow"),("518325", "Novopokrovskaya", "Новопокровская", "RU", "643", "", "38", "", "", "45.95139", "40.70056", "Europe/Moscow"),("518337", "Novopodrezkovo", "", "RU", "643", "", "47", "", "", "55.93972", "37.34417", "Europe/Moscow"),("518346", "Novopetrovskoye", "", "RU", "643", "", "47", "", "", "55.99278", "36.47194", "Europe/Moscow"),("518383", "Novopavlovsk", "Новопавловск", "RU", "643", "", "70", "", "", "43.96222", "43.63417", "Europe/Moscow"),("518418", "Novoorsk", "", "RU", "643", "", "55", "", "", "51.381", "58.9813", "Asia/Yekaterinburg"),("518488", "Novonikolayevskiy", "", "RU", "643", "", "84", "", "", "50.9738", "42.3649", "Europe/Volgograd"),("518540", "Novomyshastovskaya", "", "RU", "643", "", "38", "", "", "45.19909", "38.58272", "Europe/Moscow"),("518557", "Novomoskovsk", "Новомосковск", "RU", "643", "", "76", "", "", "54.0105", "38.2846", "Europe/Moscow"),("518568", "Novominskaya", "", "RU", "643", "", "38", "", "", "46.3163", "38.9586", "Europe/Moscow"),("518585", "Novomikhaylovskiy", "", "RU", "643", "", "38", "", "", "44.2626", "38.8585", "Europe/Moscow"),("518602", "Novomichurinsk", "Новомичуринск", "RU", "643", "", "62", "", "", "54.0384", "39.7479", "Europe/Moscow"),("518621", "Novomalorossiyskaya", "", "RU", "643", "", "38", "", "", "45.63483", "39.89481", "Europe/Moscow"),("518643", "Novoleushkovskaya", "", "RU", "643", "", "38", "", "", "45.9956", "39.9921", "Europe/Moscow"),("518657", "Novokuz’minki", "Новокузьминки", "RU", "643", "", "48", "", "", "55.71667", "37.78333", "Europe/Moscow"),("518659", "Novokuybyshevsk", "Новокуйбышевск", "RU", "643", "", "65", "", "", "53.0959", "49.9462", "Europe/Samara"),("518682", "Novokubansk", "Новокубанск", "RU", "643", "", "38", "", "", "45.117", "41.0267", "Europe/Moscow"),("518701", "Novokorsunskaya", "", "RU", "643", "", "38", "", "", "45.6408", "39.14641", "Europe/Moscow"),("518740", "Novokhovrino", "Новоховрино", "RU", "643", "", "48", "", "", "55.86667", "37.5", "Europe/Moscow"),("518745", "Novokhopërsk", "", "RU", "643", "", "86", "", "", "51.0969", "41.6252", "Europe/Moscow"),("518764", "Novokayakent", "", "RU", "643", "", "17", "", "", "42.39368", "47.98608", "Europe/Moscow"),("518805", "Novoivanovskoye", "", "RU", "643", "", "47", "", "", "55.70381", "37.3651", "Europe/Moscow"),("518851", "Oyskhara", "", "RU", "643", "", "12", "", "", "43.26402", "46.24803", "Europe/Moscow"),("518879", "Novogireyevo", "Новогиреево", "RU", "643", "", "48", "8520891", "", "55.75378", "37.81885", "Europe/Moscow"),("518907", "Novodzhereliyevskaya", "", "RU", "643", "", "38", "", "", "45.77373", "38.67227", "Europe/Moscow"),("518909", "Novodvinsk", "Новодвинск", "RU", "643", "", "06", "", "", "64.4165", "40.8122", "Europe/Moscow"),("518928", "Novodmitriyevskaya", "", "RU", "643", "", "38", "", "", "44.83276", "38.87847", "Europe/Moscow"),("518944", "Novoderevyankovskaya", "", "RU", "643", "", "38", "", "", "46.32312", "38.74724", "Europe/Moscow"),("518970", "Novocherkassk", "Новочеркасск", "RU", "643", "", "61", "", "", "47.42018", "40.09132", "Europe/Moscow"),("518976", "Novocheboksarsk", "Новочебоксарск", "RU", "643", "", "16", "", "", "56.11095", "47.47755", "Europe/Moscow"),("519027", "Novobelokatay", "", "RU", "643", "", "08", "", "", "55.7062", "58.9549", "Asia/Yekaterinburg"),("519033", "Novobataysk", "", "RU", "643", "", "61", "", "", "46.89806", "39.78194", "Europe/Moscow"),("519062", "Novoanninskiy", "Новоаннинский", "RU", "643", "", "84", "", "", "50.5287", "42.6747", "Europe/Volgograd"),("519106", "Novoaleksandrovsk", "Новоалександровск", "RU", "643", "", "70", "", "", "45.4948", "41.22075", "Europe/Moscow"),("519336", "Velikiy Novgorod", "Великий Новгород", "RU", "643", "", "52", "", "", "58.52131", "31.27104", "Europe/Moscow"),("519447", "Novaya Usman’", "Новая Усмань", "RU", "643", "", "86", "", "", "51.64177", "39.40863", "Europe/Moscow"),("519473", "Novaya Tavolzhanka", "", "RU", "643", "", "09", "", "", "50.35123", "36.8298", "Europe/Moscow"),("519611", "Novaya Mayna", "", "RU", "643", "", "81", "", "", "54.15", "49.75", "Europe/Ulyanovsk"),("519630", "Novaya Ladoga", "", "RU", "643", "", "42", "", "", "60.10246", "32.30191", "Europe/Moscow"),("519711", "Novaya Derevnya", "Новая деревня", "RU", "643", "", "66", "", "", "59.98748", "30.28682", "Europe/Moscow"),("520041", "Nolinsk", "", "RU", "643", "", "33", "", "", "57.55962", "49.93629", "Europe/Kirov"),("520065", "Nogir", "", "RU", "643", "", "68", "", "", "43.08162", "44.6365", "Europe/Moscow"),("520068", "Noginsk", "Ногинск", "RU", "643", "", "47", "", "", "55.86647", "38.4438", "Europe/Moscow"),("520204", "Nizhnyaya Tura", "Нижняя Тура", "RU", "643", "", "71", "", "", "58.6293", "59.8118", "Asia/Yekaterinburg"),("520318", "Nizhnyaya Maktama", "", "RU", "643", "", "73", "", "", "54.86356", "52.4281", "Europe/Moscow"),("520494", "Nizhniy Tagil", "Нижний Тагил", "RU", "643", "", "71", "", "", "57.91944", "59.965", "Asia/Yekaterinburg"),("520552", "Nizhniy Odes", "", "RU", "643", "", "34", "", "", "63.64451", "54.85598", "Europe/Moscow"),("520555", "Nizhniy Novgorod", "Нижний Новгород", "RU", "643", "", "51", "", "", "56.32867", "44.00205", "Europe/Moscow"),("520574", "Nizhniy Lomov", "Ниж.Ломов", "RU", "643", "", "57", "", "", "53.53041", "43.67663", "Europe/Moscow"),("520642", "Nizhniye Vyazovyye", "", "RU", "643", "", "73", "", "", "55.79877", "48.52476", "Europe/Moscow"),("520667", "Nizhniye Sergi", "", "RU", "643", "", "71", "", "", "56.66139", "59.30333", "Asia/Yekaterinburg"),("520769", "Nizhniye Achaluki", "", "RU", "643", "", "19", "", "", "43.4028", "44.75908", "Europe/Moscow"),("520775", "Nizhniy Dzhengutay", "", "RU", "643", "", "17", "", "", "42.70008", "47.24488", "Europe/Moscow"),("520955", "Nizhneye Kazanishche", "", "RU", "643", "", "17", "", "", "42.76369", "47.16027", "Europe/Moscow"),("521118", "Nizhnekamsk", "Нижнекамск", "RU", "643", "", "73", "", "", "55.63657", "51.82447", "Europe/Moscow"),("521148", "Nizhnedevitsk", "", "RU", "643", "", "86", "", "", "51.5419", "38.3657", "Europe/Moscow"),("521416", "Nikulino", "Никулино", "RU", "643", "", "48", "", "", "55.66943", "37.46598", "Europe/Moscow"),("521500", "Nikol’skoye", "Никольское", "RU", "643", "", "48", "", "", "55.68333", "37.48333", "Europe/Moscow"),("521509", "Nikol’skoye", "Никольское", "RU", "643", "", "42", "", "", "59.70056", "30.78472", "Europe/Moscow"),("521773", "Nikol’sk", "", "RU", "643", "", "85", "", "", "59.53531", "45.45743", "Europe/Moscow"),("521776", "Nikol’sk", "Никольск", "RU", "643", "", "57", "", "", "53.71886", "46.07118", "Europe/Moscow"),("521807", "Nikologory", "", "RU", "643", "", "83", "", "", "56.1413", "41.99218", "Europe/Moscow"),("521814", "Nikolo-Berëzovka", "", "RU", "643", "RU", "08", "", "", "56.12422", "54.15573", "Asia/Yekaterinburg"),("521821", "Nikolina Gora", "", "RU", "643", "", "47", "", "", "55.73433", "37.04364", "Europe/Moscow"),("521874", "Nikolayevsk", "Николаевск", "RU", "643", "", "84", "", "", "50.02824", "45.45953", "Europe/Volgograd"),("521931", "Nikolayevka", "", "RU", "643", "", "46", "", "", "54.1451", "45.1444", "Europe/Moscow"),("521966", "Nikolayevka", "", "RU", "643", "", "81", "", "", "53.1257", "47.2041", "Europe/Ulyanovsk"),("522260", "Nikel", "Никель", "RU", "643", "", "49", "", "", "69.41285", "30.22198", "Europe/Moscow"),("522301", "Nezlobnaya", "Незлобная", "RU", "643", "", "70", "", "", "44.11806", "43.40278", "Europe/Moscow"),("522312", "Nezhinka", "", "RU", "643", "", "55", "", "", "51.7676", "55.3694", "Asia/Yekaterinburg"),("522353", "Neya", "", "RU", "643", "", "37", "", "", "58.29719", "43.86808", "Europe/Moscow"),("522377", "Nevinnomyssk", "Невинномысск", "RU", "643", "", "70", "", "", "44.6333", "41.9444", "Europe/Moscow"),("522402", "Neverkino", "", "RU", "643", "", "57", "", "", "52.78541", "46.74174", "Europe/Moscow"),("522410", "Nevel’", "Невель", "RU", "643", "", "60", "", "", "56.02094", "29.92844", "Europe/Moscow"),("522470", "Nesterovskaya", "Нестеровская", "RU", "643", "", "19", "", "", "43.23861", "45.05028", "Europe/Moscow"),("522508", "Nesterov", "", "RU", "643", "", "23", "", "", "54.63056", "22.57139", "Europe/Kaliningrad"),("522594", "Nerekhta", "Нерехта", "RU", "643", "", "37", "", "", "57.45881", "40.57471", "Europe/Moscow"),("522742", "Neman", "", "RU", "643", "", "23", "", "", "55.03111", "22.02639", "Europe/Kaliningrad"),("522775", "Nelidovo", "Нелидово", "RU", "643", "", "77", "", "", "56.22107", "32.77738", "Europe/Moscow"),("522799", "Nekrasovskoye", "", "RU", "643", "", "88", "", "", "57.67663", "40.36567", "Europe/Moscow"),("522803", "Nekrasovskiy", "", "RU", "643", "", "47", "", "", "56.09349", "37.49934", "Europe/Moscow"),("522839", "Nekrasovka", "", "RU", "643", "", "48", "", "", "55.69328", "37.91148", "Europe/Moscow"),("522871", "Neklyudovo", "", "RU", "643", "", "51", "", "", "56.41421", "43.97721", "Europe/Moscow"),("522942", "Neftekamsk", "Нефтекамск", "RU", "643", "", "08", "", "", "56.092", "54.2661", "Asia/Yekaterinburg"),("522945", "Neftegorsk", "Нефтегорск", "RU", "643", "", "65", "", "", "52.802", "51.166", "Europe/Samara"),("523064", "Nazran’", "Назрань", "RU", "643", "", "19", "", "", "43.22597", "44.77323", "Europe/Moscow"),("523161", "Navoloki", "", "RU", "643", "", "21", "", "", "57.46572", "41.96344", "Europe/Moscow"),("523186", "Navlya", "", "RU", "643", "", "10", "", "", "52.82544", "34.4996", "Europe/Moscow"),("523198", "Navashino", "Навашино", "RU", "643", "", "51", "", "", "55.5441", "42.1968", "Europe/Moscow"),("523206", "Naurskaya", "", "RU", "643", "", "12", "", "", "43.65075", "45.31173", "Europe/Moscow"),("523210", "Alpatovo", "", "RU", "643", "", "12", "", "", "43.7028", "45.24154", "Europe/Moscow"),("523382", "Naryshkino", "", "RU", "643", "", "56", "", "", "52.96778", "35.72677", "Europe/Moscow"),("523392", "Nar'yan-Mar", "Нарьян-Мар", "RU", "643", "", "50", "", "", "67.63869", "53.00371", "Europe/Moscow"),("523405", "Nartkala", "Нарткала", "RU", "643", "", "22", "", "", "43.5575", "43.85083", "Europe/Moscow"),("523408", "Nartan", "", "RU", "643", "", "22", "", "", "43.51083", "43.69944", "Europe/Moscow"),("523426", "Naro-Fominsk", "Наро-Фоминск", "RU", "643", "", "47", "", "", "55.38752", "36.73307", "Europe/Moscow"),("523443", "Narimanov", "", "RU", "643", "", "07", "", "", "46.6927", "47.8498", "Europe/Astrakhan"),("523523", "Nal’chik", "Нальчик", "RU", "643", "", "22", "825098", "", "43.49806", "43.61889", "Europe/Moscow"),("523553", "Nakhabino", "Нахабино", "RU", "643", "", "47", "", "", "55.84854", "37.17789", "Europe/Moscow"),("523655", "Lakha Nëvre", "", "RU", "643", "", "12", "", "", "43.62271", "45.33969", "Europe/Moscow"),("523662", "Nadvoitsy", "", "RU", "643", "", "28", "", "", "63.86667", "34.31667", "Europe/Moscow"),("523715", "Nadezhda", "", "RU", "643", "", "70", "", "", "44.1", "44.6", "Europe/Moscow"),("523750", "Naberezhnyye Chelny", "Набережные Челны", "RU", "643", "", "73", "480620", "", "55.72545", "52.41122", "Europe/Moscow"),("523812", "Mytishchi", "Мытищи", "RU", "643", "", "47", "", "", "55.91163", "37.73076", "Europe/Moscow"),("523859", "Myshkin", "", "RU", "643", "", "88", "", "", "57.78973", "38.45448", "Europe/Moscow"),("524113", "Mutsalaul", "", "RU", "643", "", "17", "", "", "43.27548", "46.73078", "Europe/Moscow"),("524183", "Muslyumovo", "", "RU", "643", "", "73", "", "", "55.30333", "53.19472", "Europe/Moscow"),("524243", "Murygino", "", "RU", "643", "", "33", "", "", "58.73831", "49.45822", "Europe/Kirov"),("524294", "Murom", "Муром", "RU", "643", "", "83", "", "", "55.575", "42.0426", "Europe/Moscow"),("524299", "Murmashi", "", "RU", "643", "", "49", "", "", "68.81542", "32.81147", "Europe/Moscow"),("524305", "Murmansk", "Мурманск", "RU", "643", "", "49", "", "", "68.97917", "33.09251", "Europe/Moscow"),("524311", "Murino", "", "RU", "643", "", "42", "", "", "60.04796", "30.45204", "Europe/Moscow"),("524414", "Murashi", "", "RU", "643", "", "33", "", "", "59.3999", "48.9615", "Europe/Kirov"),("524423", "Muranovo", "", "RU", "643", "", "47", "", "", "56.18333", "37.9", "Europe/Moscow"),("524489", "Mullovka", "", "RU", "643", "", "81", "", "", "54.2", "49.4", "Europe/Ulyanovsk"),("524504", "Mulino", "", "RU", "643", "", "51", "", "", "56.28923", "42.92005", "Europe/Moscow"),("524534", "Mukhtolovo", "", "RU", "643", "", "51", "", "", "55.46751", "43.19973", "Europe/Moscow"),("524627", "Muchkapskiy", "", "RU", "643", "", "72", "", "", "51.85133", "42.47175", "Europe/Moscow"),("524640", "Mtsensk", "Мценск", "RU", "643", "", "56", "", "", "53.27657", "36.57334", "Europe/Moscow"),("524651", "Mstera", "", "RU", "643", "", "83", "", "", "56.37889", "41.92", "Europe/Moscow"),("524681", "Mrakovo", "", "RU", "643", "", "08", "", "", "52.71611", "56.62444", "Asia/Yekaterinburg"),("524699", "Mozhga", "Можга", "RU", "643", "", "80", "", "", "56.44469", "52.22763", "Europe/Samara"),("524712", "Mozhaysk", "Можайск", "RU", "643", "", "47", "", "524708", "55.50194", "36.02722", "Europe/Moscow"),("524736", "Mozdok", "Моздок", "RU", "643", "", "68", "", "", "43.74359", "44.65177", "Europe/Moscow"),("524809", "Mostovskoy", "Мостовской", "RU", "643", "", "38", "", "", "44.41222", "40.79361", "Europe/Moscow"),("524901", "Moscow", "Москва", "RU", "643", "", "48", "", "", "55.75222", "37.61556", "Europe/Moscow"),("524907", "Moskovskoye", "", "RU", "643", "", "70", "", "", "45.2842", "41.9103", "Europe/Moscow"),("525138", "Morshansk", "Моршанск", "RU", "643", "", "72", "", "", "53.44354", "41.81065", "Europe/Moscow"),("525162", "Morozovsk", "Морозовск", "RU", "643", "", "61", "", "", "48.35502", "41.82627", "Europe/Moscow"),("525262", "Morki", "", "RU", "643", "", "45", "", "", "56.43028", "48.99472", "Europe/Moscow"),("525365", "Mordovo", "", "RU", "643", "", "72", "", "", "52.0834", "40.77", "Europe/Moscow"),("525396", "Monino", "Монино", "RU", "643", "", "47", "", "", "55.84244", "38.19362", "Europe/Moscow"),("525404", "Monchegorsk", "Мончегорск", "RU", "643", "", "49", "", "", "67.93972", "32.87389", "Europe/Moscow"),("525585", "Molochnoye", "", "RU", "643", "", "85", "", "", "59.29166", "39.67868", "Europe/Moscow"),("525659", "Mokshan", "", "RU", "643", "", "57", "", "", "53.4365", "44.61322", "Europe/Moscow"),("525719", "Mokrous", "", "RU", "643", "", "67", "", "", "51.2373", "47.5137", "Europe/Volgograd"),("526083", "Mitrofanovka", "", "RU", "643", "", "86", "", "", "49.97083", "39.69389", "Europe/Moscow"),("526247", "Mishkino", "", "RU", "643", "", "08", "", "", "53.9997", "59.1064", "Asia/Yekaterinburg"),("526346", "Mirnyy", "Мирный", "RU", "643", "", "06", "", "", "61.33289", "44.53598", "Europe/Moscow"),("526357", "Mirnyy", "", "RU", "643", "", "65", "", "", "53.50642", "50.27658", "Europe/Samara"),("526480", "Mineralnye Vody", "Минеральные Воды", "RU", "643", "", "70", "", "", "44.21028", "43.13528", "Europe/Moscow"),("526558", "Millerovo", "Миллерово", "RU", "643", "", "61", "", "", "48.92265", "40.39673", "Europe/Moscow"),("526600", "Mikun’", "", "RU", "643", "", "34", "", "", "62.35472", "50.07714", "Europe/Moscow"),("526651", "Mikhnëvo", "", "RU", "643", "", "47", "", "", "55.12747", "37.95451", "Europe/Moscow"),("526652", "Mikhnëvo", "", "RU", "643", "", "47", "", "", "55.13396", "37.94425", "Europe/Moscow"),("526749", "Mikhaylovskoye", "", "RU", "643", "", "68", "", "", "43.09972", "44.63164", "Europe/Moscow"),("526814", "Mikhaylovskaya", "", "RU", "643", "", "38", "", "", "44.99472", "40.59639", "Europe/Moscow"),("526815", "Mikhaylovsk", "", "RU", "643", "", "71", "", "", "56.43583", "59.12", "Asia/Yekaterinburg"),("527012", "Mikhaylovka", "Михайловка", "RU", "643", "", "84", "", "", "50.06", "43.2379", "Europe/Volgograd"),("527034", "Mikhaylov", "", "RU", "643", "", "62", "", "", "54.2298", "39.0269", "Europe/Moscow"),("527057", "Mikhalkovo", "Михалково", "RU", "643", "", "48", "", "", "55.68333", "37.43333", "Europe/Moscow"),("527191", "Michurinsk", "Мичуринск", "RU", "643", "", "72", "", "", "52.8978", "40.4907", "Europe/Moscow"),("527217", "Mglin", "", "RU", "643", "", "10", "", "", "53.05907", "32.84753", "Europe/Moscow"),("527220", "Mga", "", "RU", "643", "", "42", "", "", "59.75", "31.06667", "Europe/Moscow"),("527361", "Metallostroy", "Металлострой", "RU", "643", "", "66", "", "", "59.80083", "30.54778", "Europe/Moscow"),("527370", "Mesyagutovo", "", "RU", "643", "", "08", "", "", "55.53028", "58.25278", "Asia/Yekaterinburg"),("527388", "Mesker-Yurt", "", "RU", "643", "", "12", "", "", "43.25147", "45.90716", "Europe/Moscow"),("527529", "Menzelinsk", "Мензелинск", "RU", "643", "", "73", "", "", "55.72706", "53.10258", "Europe/Moscow"),("527578", "Mendeleyevskiy", "", "RU", "643", "", "76", "", "", "54.13745", "37.58742", "Europe/Moscow"),("527579", "Mendeleyevsk", "Менделеевск", "RU", "643", "", "73", "", "", "55.90819", "52.29047", "Europe/Moscow"),("527581", "Mendeleyevo", "", "RU", "643", "", "47", "", "", "56.03333", "37.21667", "Europe/Moscow"),("527717", "Meleuz", "Мелеуз", "RU", "643", "", "08", "", "", "52.96467", "55.93277", "Asia/Yekaterinburg"),("527740", "Melenki", "Меленки", "RU", "643", "", "83", "", "", "55.3343", "41.6295", "Europe/Moscow"),("527761", "Melekhovo", "", "RU", "643", "", "83", "", "", "56.2773", "41.29346", "Europe/Moscow"),("527869", "Medyn’", "", "RU", "643", "", "25", "", "", "54.96917", "35.85861", "Europe/Moscow"),("527888", "Medvezh’yegorsk", "Медвежьегорск", "RU", "643", "", "28", "", "", "62.91713", "34.45689", "Europe/Moscow"),("527968", "Medvedovskaya", "Медведовская", "RU", "643", "", "38", "", "", "45.45151", "39.02485", "Europe/Moscow"),("528056", "Medvedevo", "Медведево", "RU", "643", "", "45", "", "", "56.63388", "47.80405", "Europe/Moscow"),("528109", "Mednogorsk", "Медногорск", "RU", "643", "", "55", "", "", "51.4128", "57.595", "Asia/Yekaterinburg"),("528137", "Mechetinskaya", "", "RU", "643", "", "61", "", "", "46.7713", "40.45597", "Europe/Moscow"),("528239", "Mayskiy", "", "RU", "643", "", "09", "", "", "50.51988", "36.45878", "Europe/Moscow"),("528242", "Mayskiy", "", "RU", "643", "", "61", "", "", "47.696", "40.10259", "Europe/Moscow"),("528258", "Mayrtup", "", "RU", "643", "", "12", "", "", "43.20348", "46.13215", "Europe/Moscow"),("528278", "Mayna", "", "RU", "643", "", "81", "", "", "54.1135", "47.6231", "Europe/Ulyanovsk"),("528293", "Maykop", "Майкоп", "RU", "643", "", "01", "11205694", "", "44.60778", "40.10583", "Europe/Moscow"),("528454", "Matveyevskoye", "Матвеевское", "RU", "643", "", "48", "", "", "55.71112", "37.47502", "Europe/Moscow"),("528495", "Matveyev Kurgan", "", "RU", "643", "", "61", "", "", "47.5645", "38.86947", "Europe/Moscow"),("528734", "Maslovka", "", "RU", "643", "", "86", "", "", "51.55346", "39.23573", "Europe/Moscow"),("528741", "Maslova Pristan’", "", "RU", "643", "", "09", "", "", "50.45874", "36.74081", "Europe/Moscow"),("529073", "Marks", "Маркс", "RU", "643", "", "67", "", "", "51.71111", "46.74861", "Europe/Volgograd"),("529195", "Mari-Turek", "", "RU", "643", "", "45", "", "", "56.78946", "49.62349", "Europe/Moscow"),("529237", "Mar’ino", "Марьино", "RU", "643", "", "48", "", "", "55.65", "37.71667", "Europe/Moscow"),("529343", "Mariinskiy Posad", "", "RU", "643", "", "16", "", "", "56.11497", "47.71805", "Europe/Moscow"),("529505", "Manturovo", "Мантурово", "RU", "643", "", "37", "", "", "58.32889", "44.76406", "Europe/Moscow"),("529610", "Manas", "", "RU", "643", "", "17", "", "", "42.72749", "47.67846", "Europe/Moscow"),("529638", "Mamontovka", "", "RU", "643", "", "47", "", "", "55.98083", "37.81972", "Europe/Moscow"),("529679", "Mamedkala", "", "RU", "643", "", "17", "", "", "42.16773", "48.11988", "Europe/Moscow"),("529709", "Mamadysh", "", "RU", "643", "", "73", "Mamadyshkiy Rayon", "", "55.71525", "51.40797", "Europe/Moscow"),("530088", "Yaroslavskiy", "Ярославский", "RU", "643", "", "48", "", "", "55.88333", "37.71667", "Europe/Moscow"),("530196", "Malyye Derbety", "", "RU", "643", "", "24", "", "", "47.95472", "44.68083", "Europe/Moscow"),("530849", "Maloyaroslavets", "Малоярославец", "RU", "643", "", "25", "", "", "55.01457", "36.47185", "Europe/Moscow"),("530972", "Malmyzh", "", "RU", "643", "", "33", "", "", "56.5205", "50.6818", "Europe/Kirov"),("530994", "Malka", "", "RU", "643", "", "22", "", "", "43.80389", "43.32417", "Europe/Moscow"),("531129", "Malgobek", "Малгобек", "RU", "643", "", "19", "", "", "43.51118", "44.58821", "Europe/Moscow"),("531257", "Malaya Vishera", "", "RU", "643", "", "52", "", "", "58.84538", "32.22218", "Europe/Moscow"),("531426", "Malaya Purga", "", "RU", "643", "", "80", "", "", "56.55666", "53.00434", "Europe/Samara"),("531820", "Malakhovka", "Малаховка", "RU", "643", "", "47", "", "", "55.64776", "38.02486", "Europe/Moscow"),("531979", "Maksatikha", "", "RU", "643", "", "77", "", "", "57.79695", "35.88254", "Europe/Moscow"),("532092", "Makhalino", "", "RU", "643", "", "57", "", "", "53.08543", "46.22108", "Europe/Moscow"),("532096", "Makhachkala", "Махачкала", "RU", "643", "", "17", "", "", "42.97638", "47.50236", "Europe/Moscow"),("532138", "Makar’yev", "", "RU", "643", "", "37", "", "", "57.88501", "43.8049", "Europe/Moscow"),("532288", "Magnitogorsk", "Магнитогорск", "RU", "643", "", "13", "825030", "", "53.41861", "59.04722", "Asia/Yekaterinburg"),("532292", "Magnitka", "", "RU", "643", "", "13", "", "", "55.3475", "59.69611", "Asia/Yekaterinburg"),("532307", "Magaramkent", "", "RU", "643", "", "17", "", "", "41.61586", "48.34797", "Europe/Moscow"),("532314", "Madzhalis", "", "RU", "643", "", "17", "", "", "42.12167", "47.83333", "Europe/Moscow"),("532459", "Lyudinovo", "Людиново", "RU", "643", "", "25", "", "", "53.86639", "34.44778", "Europe/Moscow"),("532518", "Lyubokhna", "", "RU", "643", "", "10", "", "", "53.50332", "34.38847", "Europe/Moscow"),("532535", "Lyublino", "Люблино", "RU", "643", "", "48", "", "", "55.67923", "37.7525", "Europe/Moscow"),("532600", "Lyubim", "", "RU", "643", "", "88", "", "", "58.3625", "40.68433", "Europe/Moscow"),("532615", "Lyubertsy", "Люберцы", "RU", "643", "", "47", "", "", "55.67719", "37.89322", "Europe/Moscow"),("532657", "Lytkarino", "Лыткарино", "RU", "643", "", "47", "", "", "55.58271", "37.90516", "Europe/Moscow"),("532664", "Lysyye Gory", "", "RU", "643", "", "67", "", "", "51.55063", "44.84144", "Europe/Volgograd"),("532675", "Lys’va", "Лысьва", "RU", "643", "", "90", "", "", "58.10861", "57.80528", "Asia/Yekaterinburg"),("532706", "Lysogorskaya", "", "RU", "643", "", "70", "", "", "44.10639", "43.27556", "Europe/Moscow"),("532715", "Lyskovo", "Лысково", "RU", "643", "", "51", "", "", "56.03282", "45.0422", "Europe/Moscow"),("532860", "Lyangasovo", "", "RU", "643", "", "33", "", "", "58.51759", "49.44718", "Europe/Kirov"),("532895", "Lyambir’", "", "RU", "643", "", "46", "", "", "54.28172", "45.12494", "Europe/Moscow"),("533008", "L’vovskiy", "", "RU", "643", "", "47", "", "", "55.31872", "37.52337", "Europe/Moscow"),("533067", "Luzhniki", "Лужники", "RU", "643", "", "48", "", "", "55.71599", "37.55376", "Europe/Moscow"),("533143", "Luza", "", "RU", "643", "", "33", "", "", "60.63081", "47.25118", "Europe/Kirov"),("533284", "Lunino", "", "RU", "643", "", "57", "", "", "53.59176", "45.22709", "Europe/Moscow"),("533400", "Lukoyanov", "", "RU", "643", "", "51", "", "", "55.02772", "44.47865", "Europe/Moscow"),("533541", "Lukhovka", "", "RU", "643", "", "46", "", "", "54.14844", "45.25728", "Europe/Moscow"),("533543", "Lukhovitsy", "Луховицы", "RU", "643", "", "47", "", "", "54.97661", "39.0444", "Europe/Moscow"),("533690", "Luga", "Луга", "RU", "643", "", "42", "", "", "58.73722", "29.84528", "Europe/Moscow"),("533964", "Loukhi", "", "RU", "643", "", "28", "", "", "66.07616", "33.04745", "Europe/Moscow"),("533975", "Lotoshino", "", "RU", "643", "", "47", "", "", "56.23489", "35.64273", "Europe/Moscow"),("534015", "Losino-Petrovskiy", "Лосино-Петровский", "RU", "643", "", "47", "", "", "55.86959", "38.20065", "Europe/Moscow"),("534174", "Lopatinskiy", "", "RU", "643", "", "47", "", "", "55.34101", "38.72366", "Europe/Moscow"),("534341", "Lomonosov", "Ломоносов", "RU", "643", "", "66", "", "", "59.90612", "29.77253", "Europe/Moscow"),("534413", "Lokot’", "", "RU", "643", "", "10", "", "", "52.565", "34.5776", "Europe/Moscow"),("534560", "Lodeynoye Pole", "Лодейное Поле", "RU", "643", "", "42", "", "", "60.726", "33.55306", "Europe/Moscow"),("534595", "Lobnya", "Лобня", "RU", "643", "", "47", "", "", "56.00972", "37.48194", "Europe/Moscow"),("534701", "Livny", "Ливны", "RU", "643", "", "56", "", "", "52.42534", "37.60689", "Europe/Moscow"),("534838", "Liski", "Лиски", "RU", "643", "", "86", "", "", "50.98405", "39.51545", "Europe/Moscow"),("535121", "Lipetsk", "Липецк", "RU", "643", "", "43", "", "", "52.60311", "39.57076", "Europe/Moscow"),("535183", "Linda", "", "RU", "643", "", "51", "", "", "56.61571", "44.09544", "Europe/Moscow"),("535229", "Liman", "", "RU", "643", "", "07", "", "", "45.78457", "47.22405", "Europe/Astrakhan"),("535243", "Likino-Dulevo", "Ликино-Дулево", "RU", "643", "", "47", "", "", "55.7083", "38.9542", "Europe/Moscow"),("535254", "Likhovskoy", "", "RU", "643", "", "61", "", "", "48.15188", "40.17925", "Europe/Moscow"),("535261", "Likhoslavl’", "", "RU", "643", "", "77", "", "", "57.12747", "35.46404", "Europe/Moscow"),("535270", "Likhobory", "Лихоборы", "RU", "643", "", "48", "", "", "55.85", "37.56667", "Europe/Moscow"),("535330", "Lianozovo", "Лианозово", "RU", "643", "", "48", "", "", "55.89783", "37.5868", "Europe/Moscow"),("535334", "L’govskiy", "Льгов", "RU", "643", "", "41", "", "", "51.63069", "35.2775", "Europe/Moscow"),("535366", "Lezhnevo", "", "RU", "643", "", "21", "", "", "56.77508", "40.89174", "Europe/Moscow"),("535417", "Lev Tolstoy", "", "RU", "643", "", "43", "", "", "53.21344", "39.44604", "Europe/Moscow"),("535438", "Levokumskoye", "", "RU", "643", "", "70", "", "", "44.82194", "44.66056", "Europe/Moscow"),("535440", "Levokumka", "", "RU", "643", "", "70", "", "", "44.23167", "43.15", "Europe/Moscow"),("535542", "Levashi", "", "RU", "643", "", "17", "", "", "42.43036", "47.32148", "Europe/Moscow"),("535695", "Lesnoy Gorodok", "", "RU", "643", "", "47", "", "", "55.63893", "37.20829", "Europe/Moscow"),("535729", "Komendantsky aerodrom", "Комендантский аэродром", "RU", "643", "", "66", "", "", "60.00448", "30.27523", "Europe/Moscow"),("535734", "Lesnoy", "", "RU", "643", "", "33", "", "", "59.781", "52.12838", "Europe/Kirov"),("535741", "Lesnoy", "", "RU", "643", "", "47", "", "", "56.06667", "37.91667", "Europe/Moscow"),("535744", "Lesnoy", "", "RU", "643", "", "62", "", "", "54.2125", "40.4713", "Europe/Moscow"),("535886", "Lermontov", "Лермонтов", "RU", "643", "", "70", "", "", "44.10667", "42.97333", "Europe/Moscow"),("535966", "Leonovo", "Леоново", "RU", "643", "", "48", "", "", "55.85", "37.65", "Europe/Moscow"),("536035", "Leninskoye", "", "RU", "643", "", "33", "", "", "58.31637", "47.08856", "Europe/Kirov"),("536098", "Leninskiye Gory", "Ленинские горы", "RU", "643", "", "47", "", "", "55.7", "37.56667", "Europe/Moscow"),("536111", "Leninskiy", "", "RU", "643", "", "76", "", "", "54.28768", "37.45926", "Europe/Moscow"),("536156", "Leninsk", "Ленинск", "RU", "643", "", "84", "", "", "48.70233", "45.19798", "Europe/Volgograd"),("536162", "Leninogorsk", "Лениногорск", "RU", "643", "", "73", "", "", "54.60256", "52.46087", "Europe/Moscow"),("536164", "Tsaritsyno", "Царицино", "RU", "643", "", "48", "", "", "55.6254", "37.65032", "Europe/Moscow"),("536186", "Leninkent", "", "RU", "643", "", "17", "", "", "42.96895", "47.35202", "Europe/Moscow"),("536200", "Leningradskaya", "Ленинградская", "RU", "643", "", "38", "", "", "46.3214", "39.3877", "Europe/Moscow"),("536206", "Yubileyny", "Юбилейный", "RU", "643", "", "47", "", "", "55.93333", "37.83333", "Europe/Moscow"),("536209", "Leninaul", "", "RU", "643", "", "17", "", "", "43.09138", "46.57434", "Europe/Moscow"),("536219", "Lenina", "", "RU", "643", "", "38", "", "", "46.06667", "39.78333", "Europe/Moscow"),("536398", "Lefortovo", "Лефортово", "RU", "643", "", "48", "", "", "55.76667", "37.7", "Europe/Moscow"),("536466", "Lebyazh’ye", "", "RU", "643", "", "42", "", "", "59.96124", "29.41487", "Europe/Moscow"),("536518", "Lebedyan’", "Лебедянь", "RU", "643", "", "43", "", "", "53.01942", "39.16639", "Europe/Moscow"),("536625", "Lazarevskoye", "Лазаревское", "RU", "643", "", "38", "6695246", "", "43.90886", "39.33137", "Europe/Moscow"),("536818", "Latnaya", "", "RU", "643", "", "86", "", "", "51.6586", "38.9011", "Europe/Moscow"),("537107", "Lakinsk", "Лакинск", "RU", "643", "", "83", "", "", "56.01931", "39.94848", "Europe/Moscow"),("537127", "Lakhtinskiy", "", "RU", "643", "", "66", "", "", "59.99521", "30.14717", "Europe/Moscow"),("537147", "Lakhdenpokh’ya", "", "RU", "643", "", "28", "", "", "61.51981", "30.19917", "Europe/Moscow"),("537158", "Laishevo", "", "RU", "643", "", "73", "", "", "55.40464", "49.55037", "Europe/Moscow"),("537235", "Ladozhskaya", "", "RU", "643", "", "38", "", "", "45.30902", "39.93803", "Europe/Moscow"),("537238", "Ladovskaya Balka", "", "RU", "643", "", "70", "", "", "45.62965", "41.40231", "Europe/Moscow"),("537281", "Labinsk", "Лабинск", "RU", "643", "", "38", "", "", "44.63417", "40.73556", "Europe/Moscow"),("537344", "Islamey", "", "RU", "643", "", "22", "", "", "43.67556", "43.455", "Europe/Moscow"),("537345", "Dugulubgey", "Дугулубгей", "RU", "643", "", "22", "", "", "43.6625", "43.53694", "Europe/Moscow"),("537346", "Kyzburun Pervyy", "", "RU", "643", "", "22", "", "", "43.65167", "43.395", "Europe/Moscow"),("537508", "Kyakhulay", "", "RU", "643", "", "17", "", "", "42.96839", "47.48301", "Europe/Moscow"),("537598", "Kuzovatovo", "", "RU", "643", "", "81", "", "", "53.54681", "47.68659", "Europe/Ulyanovsk"),("537737", "Kuznetsk", "Кузнецк", "RU", "643", "", "57", "", "", "53.11675", "46.60037", "Europe/Moscow"),("537832", "Kuz’minki", "Кузьминки", "RU", "643", "", "48", "", "", "55.7", "37.8", "Europe/Moscow"),("537939", "Kuzhener", "", "RU", "643", "", "45", "", "", "56.81111", "48.91278", "Europe/Moscow"),("538046", "Kuyeda", "", "RU", "643", "", "90", "", "", "56.4311", "55.58861", "Asia/Yekaterinburg"),("538061", "Kuybyshevo", "", "RU", "643", "", "61", "", "", "47.81228", "38.90731", "Europe/Moscow"),("538104", "Kuvshinovo", "", "RU", "643", "", "77", "", "", "57.02953", "34.17252", "Europe/Moscow"),("538138", "Kuvandyk", "Кувандык", "RU", "643", "", "55", "", "", "51.4781", "57.3552", "Asia/Yekaterinburg"),("538321", "Kuskovo", "Кусково", "RU", "643", "", "47", "", "", "55.73423", "37.82616", "Europe/Moscow"),("538340", "Kushva", "Кушва", "RU", "643", "", "71", "", "", "58.29056", "59.75917", "Asia/Yekaterinburg"),("538368", "Kushnarënkovo", "", "RU", "643", "", "08", "", "", "55.105", "55.35083", "Asia/Yekaterinburg"),("538416", "Kushchëvskaya", "Кущёвская", "RU", "643", "", "38", "", "", "46.5599", "39.6321", "Europe/Moscow"),("538442", "Kusa", "Куса", "RU", "643", "", "13", "", "", "55.33833", "59.44056", "Asia/Yekaterinburg"),("538472", "Kur’yanovo", "Курьяново", "RU", "643", "", "48", "532527", "9882973", "55.65", "37.7", "Europe/Moscow"),("538505", "Kurush", "", "RU", "643", "", "17", "", "", "41.28413", "47.83454", "Europe/Moscow"),("538508", "Kurumoch", "", "RU", "643", "", "65", "", "", "53.48963", "50.03748", "Europe/Samara"),("538558", "Kurskaya", "", "RU", "643", "", "70", "", "", "44.05", "44.45", "Europe/Moscow"),("538560", "Kursk", "Курск", "RU", "643", "", "41", "", "", "51.73733", "36.18735", "Europe/Moscow"),("538582", "Kursavka", "", "RU", "643", "", "70", "", "", "44.4564", "42.5093", "Europe/Moscow"),("538601", "Kurovskoye", "Куровское", "RU", "643", "", "47", "", "", "55.58183", "38.91994", "Europe/Moscow"),("538696", "Kurlovo", "", "RU", "643", "", "83", "", "", "55.43252", "40.48539", "Europe/Moscow"),("538733", "Kurkino", "", "RU", "643", "", "76", "", "", "53.42567", "38.65824", "Europe/Moscow"),("538836", "Kurganinsk", "Курганинск", "RU", "643", "", "38", "", "", "44.88", "40.59861", "Europe/Moscow"),("538908", "Kurchatov", "Курчатов", "RU", "643", "", "41", "", "", "51.6601", "35.6521", "Europe/Moscow"),("538913", "Kurchaloy", "Курчалой", "RU", "643", "", "12", "", "", "43.20184", "46.0881", "Europe/Moscow"),("539061", "Kupchino", "Купчино", "RU", "643", "RU", "66", "", "", "59.85278", "30.35667", "Europe/Moscow"),("539069", "Kupavna", "", "RU", "643", "", "47", "", "", "55.74576", "38.13136", "Europe/Moscow"),("539147", "Kungur", "Кунгур", "RU", "643", "", "90", "", "", "57.4368", "56.9593", "Asia/Yekaterinburg"),("539221", "Kumylzhenskaya", "", "RU", "643", "", "84", "", "", "49.8809", "42.5898", "Europe/Volgograd"),("539283", "Kumertau", "Кумертау", "RU", "643", "", "08", "", "", "52.76667", "55.78333", "Asia/Yekaterinburg"),("539284", "Kumëny", "", "RU", "643", "", "33", "", "", "58.10887", "49.91614", "Europe/Kirov"),("539385", "Kuloy", "", "RU", "643", "", "06", "", "", "61.03049", "42.49252", "Europe/Moscow"),("539537", "Kuleshovka", "", "RU", "643", "", "61", "", "", "47.07802", "39.55794", "Europe/Moscow"),("539555", "Kulebaki", "Кулебаки", "RU", "643", "", "51", "", "", "55.41333", "42.5325", "Europe/Moscow"),("539689", "Kukmor", "Кукмор", "RU", "643", "", "73", "", "", "56.1855", "50.8944", "Europe/Moscow"),("539794", "Kugesi", "", "RU", "643", "", "16", "", "", "56.02895", "47.29255", "Europe/Moscow"),("539817", "Kudymkar", "Кудымкар", "RU", "643", "", "90", "", "", "59.01306", "54.65556", "Asia/Yekaterinburg"),("539907", "Kudepsta", "Кудепста", "RU", "643", "", "38", "", "", "43.49547", "39.89294", "Europe/Moscow"),("540030", "Kubinka", "Кубинка", "RU", "643", "", "47", "", "", "55.57957", "36.70392", "Europe/Moscow"),("540103", "Kstovo", "Кстово", "RU", "643", "", "51", "", "", "56.14733", "44.19787", "Europe/Moscow"),("540121", "Kshenskiy", "", "RU", "643", "", "41", "", "", "51.84083", "37.71361", "Europe/Moscow"),("540251", "Krymsk", "Крымск", "RU", "643", "", "38", "", "", "44.92934", "37.99117", "Europe/Moscow"),("540267", "Krylovskaya", "", "RU", "643", "", "38", "undefined = Krylovskiy Rayon", "", "46.31944", "39.97111", "Europe/Moscow"),("540268", "Krylovskaya", "", "RU", "643", "", "38", "", "", "46.1097", "39.3035", "Europe/Moscow"),("540740", "Krotovka", "", "RU", "643", "", "65", "", "", "53.2858", "51.1686", "Europe/Samara"),("540761", "Kropotkin", "Кропоткин", "RU", "643", "", "38", "", "", "45.4375", "40.57556", "Europe/Moscow"),("540769", "Kropachëvo", "", "RU", "643", "", "13", "", "", "55.0112", "57.9896", "Asia/Yekaterinburg"),("540771", "Kronshtadt", "Кронштадт", "RU", "643", "", "66", "", "", "59.99541", "29.76668", "Europe/Moscow"),("540776", "Kromy", "", "RU", "643", "", "56", "", "", "52.68762", "35.76665", "Europe/Moscow"),("540797", "Krivyanskaya", "", "RU", "643", "", "61", "", "", "47.39625", "40.1662", "Europe/Moscow"),("541116", "Kresttsy", "", "RU", "643", "", "52", "", "", "58.2452", "32.51647", "Europe/Moscow"),("541235", "Kremenki", "", "RU", "643", "", "25", "", "", "54.88626", "37.11955", "Europe/Moscow"),("541286", "Kratovo", "", "RU", "643", "", "47", "", "", "55.59728", "38.17743", "Europe/Moscow"),("541337", "Krasnyy Yar", "", "RU", "643", "", "65", "", "", "53.49988", "50.39312", "Europe/Samara"),("541344", "Krasnyy Yar", "", "RU", "643", "", "84", "", "", "50.69652", "44.72792", "Europe/Volgograd"),("541349", "Krasnyy Yar", "", "RU", "643", "", "07", "", "", "46.53314", "48.34559", "Europe/Astrakhan"),("541404", "Krasnyy Sulin", "Красный Сулин", "RU", "643", "", "61", "", "", "47.89221", "40.07037", "Europe/Moscow"),("541406", "Biryulëvo Zapadnoye", "Красный Строитель", "RU", "643", "", "47", "", "", "55.58766", "37.64282", "Europe/Moscow"),("541549", "Krasnyy Oktyabr’", "", "RU", "643", "", "83", "", "", "56.11667", "38.88333", "Europe/Moscow"),("541647", "Krasnyy Kut", "", "RU", "643", "", "67", "", "", "50.95", "46.96667", "Europe/Volgograd"),("541704", "Krasnyy Kholm", "", "RU", "643", "", "77", "", "", "58.0607", "37.12032", "Europe/Moscow"),("541795", "Krasnyye Barrikady", "", "RU", "643", "", "07", "", "", "46.2045", "47.8535", "Europe/Astrakhan"),("541796", "Krasnyye Baki", "", "RU", "643", "", "51", "", "", "57.131", "45.15992", "Europe/Moscow"),("541950", "Krasnozavodsk", "", "RU", "643", "", "47", "", "", "56.45", "38.21667", "Europe/Moscow"),("542000", "Krasnoye Selo", "Красное Село", "RU", "643", "", "66", "", "", "59.73833", "30.08944", "Europe/Moscow"),("542024", "Krasnoye-na-Volge", "", "RU", "643", "", "37", "", "", "57.51483", "41.239", "Europe/Moscow"),("542143", "Krasnoyarskaya", "", "RU", "643", "", "61", "", "", "47.6501", "42.0443", "Europe/Moscow"),("542184", "Krasnovishersk", "Красновишерск", "RU", "643", "", "90", "", "", "60.40783", "57.08199", "Asia/Yekaterinburg"),("542199", "Krasnoufimsk", "Красноуфимск", "RU", "643", "", "71", "", "", "56.60585", "57.76686", "Asia/Yekaterinburg"),("542212", "Krasnoslobodsk", "", "RU", "643", "", "46", "", "", "54.4253", "43.78963", "Europe/Moscow"),("542213", "Krasnoslobodsk", "", "RU", "643", "", "84", "", "", "48.70708", "44.57702", "Europe/Volgograd"),("542287", "Golovinskiy", "", "RU", "643", "", "48", "", "", "55.85381", "37.49604", "Europe/Moscow"),("542298", "Krasnomayskiy", "", "RU", "643", "", "77", "", "", "57.61941", "34.40987", "Europe/Moscow"),("542312", "Krasnokumskoye", "", "RU", "643", "", "70", "", "", "44.17806", "43.50194", "Europe/Moscow"),("542322", "Krasnokholm", "", "RU", "643", "", "55", "", "", "51.59787", "54.1567", "Asia/Yekaterinburg"),("542327", "Krasnokamsk", "Краснокамск", "RU", "643", "", "90", "", "", "58.0796", "55.7552", "Asia/Yekaterinburg"),("542333", "Krasnogvardeyskoye", "", "RU", "643", "", "09", "", "", "50.6492", "38.4036", "Europe/Moscow"),("542334", "Krasnogvardeyskoye", "Красногвардейское", "RU", "643", "", "70", "", "", "45.84604", "41.51885", "Europe/Moscow"),("542335", "Krasnogvardeyskoye", "", "RU", "643", "", "01", "", "", "45.1278", "39.57246", "Europe/Moscow"),("542366", "Krasnogorskiy", "", "RU", "643", "", "45", "", "", "56.1525", "48.32583", "Europe/Moscow"),("542374", "Krasnogorsk", "Красногорск", "RU", "643", "", "47", "", "", "55.82036", "37.33017", "Europe/Moscow"),("542420", "Krasnodar", "Краснодар", "RU", "643", "", "38", "", "", "45.04484", "38.97603", "Europe/Moscow"),("542461", "Krasnoarmeyskaya", "Полтавская", "RU", "643", "", "38", "", "", "45.36614", "38.21171", "Europe/Moscow"),("542463", "Krasnoarmeysk", "Красноармейск", "RU", "643", "", "47", "", "", "56.1", "38.13333", "Europe/Moscow"),("542464", "Krasnoarmeysk", "Красноармейск", "RU", "643", "", "67", "", "", "51.02389", "45.69694", "Europe/Volgograd"),("542571", "Krasnaya Yaruga", "", "RU", "643", "", "09", "", "", "50.80083", "35.65833", "Europe/Moscow"),("542634", "Presnenskiy", "Красная Пресня", "RU", "643", "", "47", "", "", "55.75", "37.55", "Europe/Moscow"),("542640", "Krasnaya Polyana", "", "RU", "643", "", "33", "", "", "56.24204", "51.14425", "Europe/Kirov"),("542776", "Krasnaya Gorbatka", "", "RU", "643", "", "83", "", "", "55.8703", "41.7641", "Europe/Moscow"),("542788", "Krasnaya Gora", "", "RU", "643", "", "10", "", "", "52.9995", "31.6023", "Europe/Moscow"),("542841", "Kraskovo", "", "RU", "643", "", "47", "", "", "55.64972", "37.98778", "Europe/Moscow"),("542908", "Krasavino", "", "RU", "643", "", "85", "", "", "60.96225", "46.48321", "Europe/Moscow"),("542965", "Krasnokholmskiy", "", "RU", "643", "", "08", "", "", "55.98729", "55.04659", "Asia/Yekaterinburg"),("543018", "Koz’modem’yansk", "Козьмодемьянск", "RU", "643", "", "45", "", "", "56.3419", "46.56353", "Europe/Moscow"),("543133", "Kozlovka", "", "RU", "643", "", "16", "", "", "55.84284", "48.2492", "Europe/Moscow"),("543254", "Kozhukhovo", "Кожухово", "RU", "643", "", "47", "", "", "55.7", "37.66667", "Europe/Moscow"),("543344", "Kozeyevo", "Козеево", "RU", "643", "", "48", "", "", "55.86667", "37.61667", "Europe/Moscow"),("543348", "Kozel’sk", "Козельск", "RU", "643", "", "25", "", "", "54.03746", "35.77159", "Europe/Moscow"),("543436", "Kovylkino", "Ковылкино", "RU", "643", "", "46", "", "", "54.03876", "43.91385", "Europe/Moscow"),("543460", "Kovrov", "Ковров", "RU", "643", "", "83", "543454", "", "56.35722", "41.31917", "Europe/Moscow"),("543494", "Kovernino", "", "RU", "643", "", "51", "", "", "57.12818", "43.8135", "Europe/Moscow"),("543508", "Kovdor", "Ковдор", "RU", "643", "", "49", "", "", "67.56616", "30.47576", "Europe/Moscow"),("543605", "Kotovsk", "Котовск", "RU", "643", "", "72", "", "", "52.58666", "41.5021", "Europe/Moscow"),("543633", "Kotovo", "Котово", "RU", "643", "", "84", "", "", "50.32113", "44.80119", "Europe/Volgograd"),("543704", "Kotlas", "Котлас", "RU", "643", "", "06", "", "", "61.25745", "46.64963", "Europe/Moscow"),("543728", "Kotel’nikovo", "Котельниково", "RU", "643", "", "84", "", "", "47.63009", "43.14068", "Europe/Volgograd"),("543731", "Kotel’niki", "Котельники", "RU", "643", "", "47", "", "", "55.63546", "37.8445", "Europe/Moscow"),("543737", "Kotel’nich", "Котельнич", "RU", "643", "", "33", "", "", "58.3089", "48.348", "Europe/Kirov"),("543878", "Kostroma", "Кострома", "RU", "643", "", "37", "543869", "", "57.76647", "40.92686", "Europe/Moscow"),("543899", "Kostomuksha", "Костомукша", "RU", "643", "", "28", "", "", "64.571", "30.57667", "Europe/Moscow"),("544203", "Koshki", "", "RU", "643", "", "65", "", "", "54.20914", "50.46767", "Europe/Samara"),("544263", "Koshekhabl’", "", "RU", "643", "", "01", "", "", "44.89722", "40.51194", "Europe/Moscow"),("544293", "Kosaya Gora", "Косая Гора", "RU", "643", "", "76", "", "", "54.11896", "37.54459", "Europe/Moscow"),("544370", "Koryazhma", "Коряжма", "RU", "643", "", "06", "", "", "61.31433", "47.16914", "Europe/Moscow"),("544707", "Korocha", "", "RU", "643", "", "09", "", "", "50.8132", "37.18598", "Europe/Moscow"),("544896", "Korenovsk", "Кореновск", "RU", "643", "", "38", "", "", "45.46899", "39.45136", "Europe/Moscow"),("544904", "Korenëvo", "", "RU", "643", "", "47", "", "", "55.67194", "38.00778", "Europe/Moscow"),("544906", "Korenëvo", "", "RU", "643", "", "41", "", "", "51.4119", "34.908", "Europe/Moscow"),("545001", "Korablino", "", "RU", "643", "", "62", "", "", "53.91639", "40.01333", "Europe/Moscow"),("545078", "Koptëvo", "", "RU", "643", "", "47", "", "", "55.81667", "37.51667", "Europe/Moscow"),("545267", "Konstantinovskoye", "", "RU", "643", "", "70", "", "", "45.29917", "42.63667", "Europe/Moscow"),("545272", "Konstantinovskiy", "", "RU", "643", "", "88", "", "", "57.83005", "39.58989", "Europe/Moscow"),("545276", "Konstantinovskaya", "", "RU", "643", "", "70", "", "", "44.04556", "43.15833", "Europe/Moscow"),("545277", "Konstantinovsk", "Константиновск", "RU", "643", "", "61", "", "", "47.58278", "41.09222", "Europe/Moscow"),("545353", "Konosha", "", "RU", "643", "", "06", "", "", "60.9736", "40.257", "Europe/Moscow"),("545400", "Konokovo", "", "RU", "643", "", "38", "", "", "44.8616", "41.3266", "Europe/Moscow"),("545405", "Konobeyevo", "", "RU", "643", "", "47", "", "", "55.40776", "38.66261", "Europe/Moscow"),("545575", "Kondrovo", "Кондрово", "RU", "643", "", "25", "", "", "54.80639", "35.92778", "Europe/Moscow"),("545626", "Kondopoga", "Кондопога", "RU", "643", "", "28", "", "", "62.20565", "34.26138", "Europe/Moscow"),("545673", "Konakovo", "Конаково", "RU", "643", "", "77", "", "", "56.7", "36.76667", "Europe/Moscow"),("545727", "Komsomol’skiy", "", "RU", "643", "", "24", "", "", "45.33", "46.0428", "Europe/Moscow"),("545736", "Komsomol’sk", "", "RU", "643", "", "21", "", "", "57.02913", "40.37266", "Europe/Moscow"),("545788", "Kommunar", "Коммунар", "RU", "643", "", "42", "", "", "59.62056", "30.39", "Europe/Moscow"),("545946", "Komarichi", "", "RU", "643", "", "10", "", "", "52.4151", "34.7905", "Europe/Moscow"),("545982", "Kolyshley", "", "RU", "643", "", "57", "", "", "52.7005", "44.5367", "Europe/Moscow"),("546055", "Koltushi", "", "RU", "643", "", "42", "", "", "59.92969", "30.64465", "Europe/Moscow"),("546092", "Kolpny", "", "RU", "643", "", "56", "", "", "52.22823", "37.03683", "Europe/Moscow"),("546105", "Kolpino", "Колпино", "RU", "643", "", "66", "", "", "59.75069", "30.58856", "Europe/Moscow"),("546225", "Kolomyagi", "Коломяги", "RU", "643", "", "66", "", "", "60.02427", "30.28491", "Europe/Moscow"),("546230", "Kolomna", "Коломна", "RU", "643", "", "47", "", "", "55.07944", "38.77833", "Europe/Moscow"),("546244", "Kolomenskoye", "Коломенское", "RU", "643", "", "48", "", "", "55.66667", "37.68333", "Europe/Moscow"),("546316", "Kolodeznyy", "", "RU", "643", "", "86", "", "", "51.33333", "39.18333", "Europe/Moscow"),("546521", "Kol’chugino", "Кольчугино", "RU", "643", "", "83", "", "", "56.29929", "39.38304", "Europe/Moscow"),("546554", "Kola", "", "RU", "643", "", "49", "", "", "68.88062", "33.01842", "Europe/Moscow"),("546579", "Koksovyy", "", "RU", "643", "", "61", "", "", "48.20058", "40.65089", "Europe/Moscow"),("546606", "Kokoshkino", "", "RU", "643", "", "48", "8520892", "", "55.59769", "37.1695", "Europe/Moscow"),("546672", "Kokhma", "Кохма", "RU", "643", "", "21", "", "", "56.93487", "41.0915", "Europe/Moscow"),("547162", "Knyaginino", "", "RU", "643", "", "51", "", "", "55.82278", "45.03489", "Europe/Moscow"),("547383", "Klyavlino", "", "RU", "643", "", "65", "", "", "54.26491", "52.02674", "Europe/Samara"),("547475", "Klintsy", "Клинцы", "RU", "643", "", "10", "", "", "52.76019", "32.23935", "Europe/Moscow"),("547523", "Klin", "Клин", "RU", "643", "", "47", "", "", "56.33333", "36.73333", "Europe/Moscow"),("547560", "Klimovsk", "Климовск", "RU", "643", "", "47", "", "", "55.36352", "37.52984", "Europe/Moscow"),("547591", "Klimovo", "", "RU", "643", "", "10", "", "", "52.38053", "32.19233", "Europe/Moscow"),("547677", "Kletskaya", "", "RU", "643", "", "84", "", "", "49.31455", "43.05844", "Europe/Volgograd"),("547681", "Kletnya", "", "RU", "643", "", "10", "", "", "53.38967", "33.21714", "Europe/Moscow"),("547831", "Kizner", "", "RU", "643", "", "80", "", "", "56.27489", "51.508", "Europe/Samara"),("547840", "Kizlyar", "Кизляр", "RU", "643", "", "17", "", "", "43.84712", "46.71445", "Europe/Moscow"),("547841", "Kizlyar", "", "RU", "643", "", "68", "", "", "43.70379", "44.5944", "Europe/Moscow"),("547849", "Kizilyurt", "Кизилюрт", "RU", "643", "", "17", "", "", "43.20697", "46.8679", "Europe/Moscow"),("547875", "Kizel", "Кизел", "RU", "643", "", "90", "", "", "59.04709", "57.64767", "Asia/Yekaterinburg"),("548097", "Kislyakovskaya", "", "RU", "643", "", "38", "", "", "46.4417", "39.675", "Europe/Moscow"),("548114", "Kislovodsk", "Кисловодск", "RU", "643", "", "70", "", "", "43.91333", "42.72083", "Europe/Moscow"),("548278", "Kirzhach", "Киржач", "RU", "643", "", "83", "", "", "56.15273", "38.85509", "Europe/Moscow"),("548330", "Kirsanov", "Кирсанов", "RU", "643", "", "72", "", "", "52.65494", "42.72236", "Europe/Moscow"),("548333", "Kirs", "", "RU", "643", "", "33", "", "", "59.33882", "52.24467", "Europe/Kirov"),("548390", "Kirovskaya", "", "RU", "643", "", "61", "", "", "46.9748", "40.0402", "Europe/Moscow"),("548391", "Kirovsk", "Кировск", "RU", "643", "", "49", "", "", "67.61475", "33.67274", "Europe/Moscow"),("548392", "Kirovsk", "Кировск", "RU", "643", "", "42", "", "", "59.88101", "30.99507", "Europe/Moscow"),("548395", "Kirovo-Chepetsk", "Кирово-Чепецк", "RU", "643", "", "33", "", "", "58.55386", "50.03986", "Europe/Kirov"),("548408", "Kirov", "Киров", "RU", "643", "", "33", "548394", "", "58.59665", "49.66007", "Europe/Kirov"),("548410", "Kirov", "Киров", "RU", "643", "", "25", "", "", "54.06686", "34.29955", "Europe/Moscow"),("548442", "Kirishi", "Кириши", "RU", "643", "", "42", "", "", "59.44712", "32.02049", "Europe/Moscow"),("548478", "Kirillov", "", "RU", "643", "", "85", "", "", "59.86299", "38.38128", "Europe/Moscow"),("548493", "Kirgiz-Miyaki", "", "RU", "643", "", "08", "", "", "53.6324", "54.7979", "Asia/Yekaterinburg"),("548506", "Kireyevsk", "Киреевск", "RU", "643", "", "76", "", "", "53.93361", "37.92792", "Europe/Moscow"),("548602", "Kingisepp", "Кингисепп", "RU", "643", "", "42", "", "", "59.37331", "28.61343", "Europe/Moscow"),("548605", "Kineshma", "Кинешма", "RU", "643", "", "21", "", "", "57.43914", "42.12894", "Europe/Moscow"),("548622", "Kinel’-Cherkassy", "Кинель-Черкассы", "RU", "643", "", "65", "", "", "53.4706", "51.47431", "Europe/Samara"),("548625", "Kinel’", "Кинель", "RU", "643", "", "65", "", "", "53.22571", "50.62907", "Europe/Samara"),("548652", "Kimry", "Кимры", "RU", "643", "", "77", "", "", "56.86667", "37.35", "Europe/Moscow"),("548658", "Kimovsk", "Кимовск", "RU", "643", "", "76", "", "", "53.97164", "38.53186", "Europe/Moscow"),("548695", "Kil’mez’", "", "RU", "643", "", "33", "", "", "56.94389", "51.065", "Europe/Kirov"),("548740", "Kikvidze", "", "RU", "643", "", "84", "", "", "50.74161", "43.0518", "Europe/Volgograd"),("548747", "Kiknur", "", "RU", "643", "", "33", "", "", "57.30341", "47.20105", "Europe/Kirov"),("548781", "Kideksha", "", "RU", "643", "", "83", "", "", "56.42381", "40.52146", "Europe/Moscow"),("548791", "Kichmengskiy Gorodok", "", "RU", "643", "", "85", "", "", "59.98164", "45.78543", "Europe/Moscow"),("548890", "Khvoynaya", "", "RU", "643", "", "52", "", "", "58.9", "34.53333", "Europe/Moscow"),("548982", "Khvalynsk", "", "RU", "643", "", "67", "", "", "52.4906", "48.1058", "Europe/Volgograd"),("549266", "Khrenovoye", "", "RU", "643", "", "86", "", "", "51.12", "40.28889", "Europe/Moscow"),("549373", "Khot'kovo", "Хотьково", "RU", "643", "", "47", "", "", "56.25699", "37.99544", "Europe/Moscow"),("549424", "Khosta", "Хоста", "RU", "643", "", "38", "6695246", "", "43.51484", "39.86825", "Europe/Moscow"),("549479", "Khoroshëvo-Mnevniki", "Хорошёво", "RU", "643", "", "47", "", "", "55.78363", "37.47137", "Europe/Moscow"),("549741", "Kholmskiy", "Холмская", "RU", "643", "", "38", "", "", "44.84694", "38.385", "Europe/Moscow"),("550102", "Khlevnoye", "", "RU", "643", "", "43", "", "", "52.19512", "39.09316", "Europe/Moscow"),("550280", "Khimki", "Химки", "RU", "643", "", "47", "550279", "", "55.89704", "37.42969", "Europe/Moscow"),("550478", "Khasavyurt", "Хасавюрт", "RU", "643", "", "17", "Gorod Khasavyurt", "", "43.2509", "46.58766", "Europe/Moscow"),("550512", "Kharovsk", "", "RU", "643", "", "85", "", "", "59.96425", "40.19121", "Europe/Moscow"),("550671", "Kharabali", "Харабали", "RU", "643", "", "07", "", "", "47.41958", "47.25678", "Europe/Astrakhan"),("550708", "Khanskaya", "", "RU", "643", "", "01", "11205694", "", "44.67702", "39.9616", "Europe/Moscow"),("550785", "Orlov", "", "RU", "643", "", "33", "", "", "58.53946", "48.89173", "Europe/Kirov"),("550844", "Khadzhalmakhi", "", "RU", "643", "", "17", "", "", "42.42", "47.18206", "Europe/Moscow"),("550846", "Khadyzhensk", "Хадыженск", "RU", "643", "", "38", "", "", "44.4258", "39.5362", "Europe/Moscow"),("550868", "Khabez", "", "RU", "643", "", "27", "", "", "44.0434", "41.772", "Europe/Moscow"),("550902", "Kez", "", "RU", "643", "", "80", "", "", "57.8957", "53.7132", "Europe/Samara"),("551070", "Kenzhe", "", "RU", "643", "", "22", "", "", "43.50167", "43.55722", "Europe/Moscow"),("551145", "Kem’", "", "RU", "643", "", "28", "", "", "64.95546", "34.57929", "Europe/Moscow"),("551439", "Kazanskaya", "", "RU", "643", "", "38", "", "", "45.4106", "40.4361", "Europe/Moscow"),("551487", "Kazan", "Казань", "RU", "643", "", "73", "862913", "", "55.78874", "49.12214", "Europe/Moscow"),("551646", "Kayakent", "", "RU", "643", "", "17", "", "", "42.38736", "47.90301", "Europe/Moscow"),("551669", "Kavkazskaya", "", "RU", "643", "", "38", "", "", "45.4453", "40.6765", "Europe/Moscow"),("551729", "Katyr-Yurt", "", "RU", "643", "", "12", "", "", "43.17007", "45.37114", "Europe/Moscow"),("551794", "Katav-Ivanovsk", "Катав-Ивановск", "RU", "643", "", "13", "", "", "54.75306", "58.19556", "Asia/Yekaterinburg"),("551816", "Kasumkent", "", "RU", "643", "", "17", "", "", "41.67725", "48.14601", "Europe/Moscow"),("551835", "Kastanayevo", "Кастанаево", "RU", "643", "", "47", "", "", "55.71667", "37.5", "Europe/Moscow"),("551846", "Kaspiyskiy", "", "RU", "643", "", "24", "", "", "45.39288", "47.37073", "Europe/Moscow"),("551847", "Kaspiysk", "Каспийск", "RU", "643", "", "17", "", "", "42.88165", "47.63919", "Europe/Moscow"),("551891", "Kasimov", "Касимов", "RU", "643", "", "62", "", "", "54.94111", "41.39528", "Europe/Moscow"),("551964", "Kashira", "Кашира", "RU", "643", "", "47", "", "", "54.84444", "38.16694", "Europe/Moscow"),("551986", "Kashin", "Кашин", "RU", "643", "", "77", "", "", "57.35917", "37.60806", "Europe/Moscow"),("552006", "Kashary", "", "RU", "643", "", "61", "", "", "49.04001", "41.00557", "Europe/Moscow"),("552133", "Karsun", "", "RU", "643", "", "81", "", "", "54.19941", "46.9827", "Europe/Ulyanovsk"),("552312", "Karmaskaly", "", "RU", "643", "", "08", "", "", "54.3709", "56.1837", "Asia/Yekaterinburg"),("552465", "Kargopol’", "", "RU", "643", "", "06", "", "", "61.50359", "38.9486", "Europe/Moscow"),("552500", "Kargalinskaya", "", "RU", "643", "", "12", "", "", "43.74381", "46.47821", "Europe/Moscow"),("552562", "Kardonikskaya", "", "RU", "643", "", "27", "", "", "43.86577", "41.71432", "Europe/Moscow"),("552830", "Karakulino", "", "RU", "643", "", "80", "", "", "56.012", "53.70669", "Europe/Samara"),("552862", "Karaidel’", "", "RU", "643", "", "08", "", "", "55.83373", "56.90692", "Asia/Yekaterinburg"),("552887", "Karagay", "", "RU", "643", "", "90", "", "", "58.26669", "54.93678", "Asia/Yekaterinburg"),("552895", "Karagach", "", "RU", "643", "", "22", "", "", "43.80528", "43.775", "Europe/Moscow"),("552920", "Karachev", "Карачев", "RU", "643", "", "10", "", "", "53.12292", "34.98517", "Europe/Moscow"),("552924", "Karachayevsk", "Карачаевск", "RU", "643", "", "27", "", "", "43.77399", "41.91419", "Europe/Moscow"),("552951", "Karabulak", "Карабулак", "RU", "643", "", "19", "", "", "43.30513", "44.89949", "Europe/Moscow"),("552953", "Karabudakhkent", "", "RU", "643", "", "17", "", "", "42.7087", "47.56735", "Europe/Moscow"),("552974", "Karabash", "", "RU", "643", "", "73", "", "", "54.693", "52.58359", "Europe/Moscow"),("552977", "Karabanovo", "Карабаново", "RU", "643", "", "83", "", "", "56.31667", "38.7", "Europe/Moscow"),("552999", "Kapustin Yar", "", "RU", "643", "", "07", "", "", "48.58175", "45.74481", "Europe/Astrakhan"),("553034", "Kapotnya", "Капотня", "RU", "643", "", "48", "", "", "55.63806", "37.79306", "Europe/Moscow"),("553092", "Kantyshevo", "Кантышево", "RU", "643", "", "19", "", "", "43.22824", "44.63322", "Europe/Moscow"),("553099", "Kantemirovka", "", "RU", "643", "", "86", "", "", "49.70887", "39.85922", "Europe/Moscow"),("553152", "Kanevskaya", "Каневская", "RU", "643", "", "38", "", "", "46.0849", "38.9596", "Europe/Moscow"),("553169", "Kandry", "", "RU", "643", "", "08", "", "", "54.56667", "54.11667", "Asia/Yekaterinburg"),("553190", "Kandalaksha", "Кандалакша", "RU", "643", "", "49", "", "", "67.162", "32.41229", "Europe/Moscow"),("553216", "Kanash", "Канаш", "RU", "643", "", "16", "", "", "55.50962", "47.49127", "Europe/Moscow"),("553248", "Kamyzyak", "Камызяк", "RU", "643", "", "07", "", "", "46.10995", "48.07364", "Europe/Astrakhan"),("553287", "Kamyshin", "Камышин", "RU", "643", "", "84", "", "", "50.09833", "45.41601", "Europe/Volgograd"),("553310", "Kamyshevatskaya", "", "RU", "643", "", "38", "", "", "46.41316", "37.95632", "Europe/Moscow"),("553389", "Kameshkovo", "", "RU", "643", "", "83", "", "", "56.35305", "41.00941", "Europe/Moscow"),("553399", "Kamensk-Shakhtinskiy", "Каменск", "RU", "643", "", "61", "", "", "48.31779", "40.25948", "Europe/Moscow"),("553427", "Kamenolomni", "", "RU", "643", "", "61", "", "", "47.66853", "40.2051", "Europe/Moscow"),("553513", "Kamennomostskoye", "", "RU", "643", "", "22", "", "", "43.73722", "43.05139", "Europe/Moscow"),("553514", "Kamennomostskiy", "", "RU", "643", "", "01", "", "", "44.2891", "40.188", "Europe/Moscow"),("553518", "Kamennogorsk", "", "RU", "643", "", "42", "", "", "60.95451", "29.13391", "Europe/Moscow"),("553615", "Kamenka", "", "RU", "643", "", "42", "", "", "60.44639", "29.0829", "Europe/Moscow"),("553766", "Kamenka", "", "RU", "643", "", "86", "", "", "51.3223", "42.7678", "Europe/Moscow"),("553769", "Kamenka", "", "RU", "643", "", "86", "", "", "50.71499", "39.42189", "Europe/Moscow"),("553828", "Kambileyevskoye", "", "RU", "643", "", "68", "", "", "43.07858", "44.75216", "Europe/Moscow"),("553835", "Kambarka", "", "RU", "643", "", "80", "", "", "56.2666", "54.2056", "Europe/Samara"),("553884", "Kalyazin", "", "RU", "643", "", "77", "", "", "57.24028", "37.84333", "Europe/Moscow"),("553915", "Kaluga", "Калуга", "RU", "643", "", "25", "", "", "54.5293", "36.27542", "Europe/Moscow"),("553955", "Kalnibolotskaya", "", "RU", "643", "", "38", "", "", "46.00583", "40.45682", "Europe/Moscow"),("554077", "Kalinovskaya", "", "RU", "643", "", "12", "", "", "43.57383", "45.5209", "Europe/Moscow"),("554173", "Kalininskaya", "", "RU", "643", "", "38", "undefined = Kalininskiy Rayon", "", "45.4844", "38.66221", "Europe/Moscow"),("554199", "Kalininsk", "Калининск", "RU", "643", "", "67", "", "", "51.5", "44.4758", "Europe/Volgograd"),("554233", "Korolev", "Королёв", "RU", "643", "", "47", "", "", "55.91417", "37.82556", "Europe/Moscow"),("554234", "Kaliningrad", "Калининград", "RU", "643", "", "23", "825118", "", "54.70649", "20.51095", "Europe/Kaliningrad"),("554318", "Kalevala", "", "RU", "643", "", "28", "", "", "65.19873", "31.18999", "Europe/Moscow"),("554363", "Kalashnikovo", "", "RU", "643", "", "77", "", "", "57.28237", "35.22617", "Europe/Moscow"),("554397", "Kalach-na-Donu", "Калач-на-Дону", "RU", "643", "", "84", "", "", "48.69099", "43.52638", "Europe/Volgograd"),("554410", "Kalach", "Калач", "RU", "643", "", "86", "", "", "50.4258", "41.0261", "Europe/Moscow"),("554444", "Kakhun", "", "RU", "643", "", "22", "", "", "43.54306", "43.87639", "Europe/Moscow"),("554482", "Kagal’nitskaya", "", "RU", "643", "", "61", "", "", "46.88056", "40.14657", "Europe/Moscow"),("554535", "Kaduy", "", "RU", "643", "", "85", "", "", "59.2", "37.15", "Europe/Moscow"),("554549", "Kadom", "", "RU", "643", "", "62", "", "", "54.55917", "42.4675", "Europe/Moscow"),("554554", "Kadnikov", "", "RU", "643", "", "85", "", "", "59.50218", "40.33803", "Europe/Moscow"),("554599", "Kachkanar", "Качканар", "RU", "643", "", "71", "", "", "58.7002", "59.4839", "Asia/Yekaterinburg"),("554668", "Kabardinka", "", "RU", "643", "", "38", "", "", "44.65139", "37.94278", "Europe/Moscow"),("554679", "Kabanovo", "", "RU", "643", "", "47", "", "", "55.74815", "38.93511", "Europe/Moscow"),("554770", "Izobil’nyy", "", "RU", "643", "", "70", "", "", "45.37092", "41.70839", "Europe/Moscow"),("554787", "Izmaylovo", "Измайлово", "RU", "643", "", "47", "", "", "55.78677", "37.80165", "Europe/Moscow"),("554840", "Izhevsk", "Ижевск", "RU", "643", "", "80", "", "", "56.84976", "53.20448", "Europe/Samara"),("554894", "Izberbash", "Избербаш", "RU", "643", "", "17", "", "", "42.56955", "47.86447", "Europe/Moscow"),("554950", "Ivot", "", "RU", "643", "", "10", "", "", "53.67556", "34.18722", "Europe/Moscow"),("554973", "Ivnya", "", "RU", "643", "", "09", "", "", "51.06294", "36.13426", "Europe/Moscow"),("555111", "Ivanteyevka", "Ивантеевка", "RU", "643", "", "47", "", "", "55.97111", "37.92083", "Europe/Moscow"),("555112", "Ivanteyevka", "", "RU", "643", "", "67", "", "", "52.2667", "49.1055", "Europe/Volgograd"),("555129", "Ivanovskoye", "Ивановское", "RU", "643", "", "48", "8520891", "", "55.76667", "37.83333", "Europe/Moscow"),("555206", "Ivanovskoye", "", "RU", "643", "", "70", "", "", "44.5795", "41.8764", "Europe/Moscow"),("555312", "Ivanovo", "Иваново", "RU", "643", "", "21", "825094", "", "56.99719", "40.97139", "Europe/Moscow"),("555624", "Ivangorod", "", "RU", "643", "", "42", "", "", "59.37155", "28.21625", "Europe/Moscow"),("555717", "Isyangulovo", "", "RU", "643", "", "08", "", "", "52.18584", "56.58043", "Asia/Yekaterinburg"),("555746", "Istra", "Истра", "RU", "643", "", "47", "", "", "55.91997", "36.86867", "Europe/Moscow"),("555798", "Issa", "", "RU", "643", "", "57", "", "", "53.87049", "44.85781", "Europe/Moscow"),("555980", "Ishimbay", "Ишимбай", "RU", "643", "", "08", "", "", "53.45446", "56.04149", "Asia/Yekaterinburg"),("555984", "Isheyevka", "", "RU", "643", "", "81", "", "", "54.42789", "48.26675", "Europe/Ulyanovsk"),("556230", "Ipatovo", "Ипатово", "RU", "643", "", "70", "", "", "45.71806", "42.90361", "Europe/Moscow"),("556275", "Inzhavino", "", "RU", "643", "", "72", "", "", "52.31847", "42.49369", "Europe/Moscow"),("556283", "Inza", "Инза", "RU", "643", "", "81", "", "", "53.85672", "46.35622", "Europe/Ulyanovsk"),("556318", "Insar", "", "RU", "643", "", "46", "", "", "53.86531", "44.37382", "Europe/Moscow"),("556320", "Inozemtsevo", "Иноземцево", "RU", "643", "", "70", "", "", "44.09264", "43.09113", "Europe/Moscow"),("556463", "Imeni Vorovskogo", "", "RU", "643", "", "47", "", "", "55.7319", "38.32368", "Europe/Moscow"),("556511", "Imeni Sverdlova", "", "RU", "643", "", "42", "", "", "59.79611", "30.66583", "Europe/Moscow"),("556575", "Imeni Morozova", "", "RU", "643", "", "42", "", "", "59.97572", "31.03762", "Europe/Moscow"),("556951", "Il’skiy", "Ильский", "RU", "643", "", "38", "", "", "44.84222", "38.56686", "Europe/Moscow"),("556961", "Ilovlya", "", "RU", "643", "", "84", "", "", "49.30334", "43.97965", "Europe/Volgograd"),("557140", "Il’inskiy", "", "RU", "643", "", "47", "", "", "55.61902", "38.11818", "Europe/Moscow"),("557340", "Ilek", "", "RU", "643", "", "55", "", "", "51.52709", "53.38306", "Asia/Yekaterinburg"),("557390", "Ikryanoye", "", "RU", "643", "", "07", "", "", "46.09323", "47.73078", "Europe/Astrakhan"),("557469", "Igra", "Игра", "RU", "643", "", "80", "", "", "57.5549", "53.0544", "Europe/Samara"),("557563", "Iglino", "", "RU", "643", "", "08", "", "", "54.83244", "56.41264", "Asia/Yekaterinburg"),("557588", "Idritsa", "", "RU", "643", "", "60", "", "", "56.33157", "28.89884", "Europe/Moscow"),("557628", "Ibresi", "", "RU", "643", "", "16", "", "", "55.3011", "47.038", "Europe/Moscow"),("557657", "Gzhel’", "", "RU", "643", "", "47", "", "", "55.61008", "38.39399", "Europe/Moscow"),("557706", "Elin-Yurt", "", "RU", "643", "", "12", "", "", "43.67306", "44.95889", "Europe/Moscow"),("557710", "Gvardeysk", "", "RU", "643", "", "23", "", "", "54.64772", "21.06513", "Europe/Kaliningrad"),("557775", "Gus’-Khrustal’nyy", "Гусь-Хрустальный", "RU", "643", "", "83", "", "", "55.61113", "40.65186", "Europe/Moscow"),("557882", "Gusev", "Гусев", "RU", "643", "", "23", "", "", "54.59222", "22.19972", "Europe/Kaliningrad"),("557906", "Gur’yevsk", "", "RU", "643", "", "23", "", "", "54.77323", "20.60521", "Europe/Kaliningrad"),("557984", "Gundorovskiy", "", "RU", "643", "", "61", "", "", "46.78047", "41.8968", "Europe/Moscow"),("557988", "Gundelen", "", "RU", "643", "", "22", "", "", "43.5975", "43.17194", "Europe/Moscow"),("557992", "Gumrak", "", "RU", "643", "", "84", "", "", "48.78255", "44.3824", "Europe/Volgograd"),("558066", "Gul’kevichi", "Гулькевичи", "RU", "643", "", "38", "", "", "45.35383", "40.69465", "Europe/Moscow"),("558082", "Gukovo", "Гуково", "RU", "643", "", "61", "", "", "48.06212", "39.9355", "Europe/Moscow"),("558118", "Gudermes", "Гудермес", "RU", "643", "", "12", "", "", "43.35071", "46.10925", "Europe/Moscow"),("558146", "Gubkin", "Губкин", "RU", "643", "", "09", "", "", "51.28167", "37.54583", "Europe/Moscow"),("558186", "Gubden", "", "RU", "643", "", "17", "", "", "42.56808", "47.56579", "Europe/Moscow"),("558209", "Gubakha", "Губаха", "RU", "643", "RU", "90", "", "", "58.83862", "57.55325", "Asia/Yekaterinburg"),("558236", "Gryazovets", "Грязовец", "RU", "643", "", "85", "", "", "58.88", "40.2525", "Europe/Moscow"),("558312", "Gryazi", "Грязи", "RU", "643", "", "43", "", "", "52.49657", "39.93593", "Europe/Moscow"),("558385", "Martan-Chu", "", "RU", "643", "", "12", "", "", "43.06366", "45.56217", "Europe/Moscow"),("558418", "Groznyy", "Грозный", "RU", "643", "", "12", "", "", "43.31195", "45.68895", "Europe/Moscow"),("558487", "Grivenskaya", "", "RU", "643", "", "38", "", "", "45.6473", "38.17597", "Europe/Moscow"),("558497", "Gritsovskiy", "", "RU", "643", "", "76", "", "", "54.13761", "38.16043", "Europe/Moscow"),("558707", "Grigoropolisskaya", "", "RU", "643", "", "70", "", "", "45.29722", "41.05667", "Europe/Moscow"),("558799", "Gribanovskiy", "Грибановский", "RU", "643", "", "86", "", "", "51.45792", "41.97637", "Europe/Moscow"),("558885", "Gremyachinsk", "", "RU", "643", "", "90", "", "", "58.5603", "57.851", "Asia/Yekaterinburg"),("558998", "Grebenskaya", "", "RU", "643", "", "12", "", "", "43.53086", "46.37174", "Europe/Moscow"),("559029", "Grazhdanka", "Гражданка", "RU", "643", "", "66", "", "", "60.03587", "30.40518", "Europe/Moscow"),("559034", "Grayvoron", "", "RU", "643", "", "09", "", "", "50.4767", "35.6773", "Europe/Moscow"),("559158", "Grabovo", "", "RU", "643", "", "57", "", "", "53.38751", "45.06395", "Europe/Moscow"),("559179", "Goyty", "", "RU", "643", "", "12", "", "", "43.16417", "45.62278", "Europe/Moscow"),("559252", "Gostagayevskaya", "", "RU", "643", "", "38", "", "", "45.02284", "37.50511", "Europe/Moscow"),("559317", "Goryachiy Klyuch", "Горячий Ключ", "RU", "643", "", "38", "", "", "44.63083", "39.13", "Europe/Moscow"),("559320", "Goryachevodskiy", "Горячеводский", "RU", "643", "", "70", "", "", "44.02361", "43.09222", "Europe/Moscow"),("559400", "Gorshechnoye", "", "RU", "643", "", "41", "", "", "51.5244", "38.0365", "Europe/Moscow"),("559459", "Gorokhovets", "", "RU", "643", "", "83", "", "", "56.20152", "42.69351", "Europe/Moscow"),("559475", "Gorodovikovsk", "", "RU", "643", "", "24", "", "", "46.08785", "41.93353", "Europe/Moscow"),("559478", "Gorodoviki", "", "RU", "643", "", "24", "", "", "46.13528", "41.96556", "Europe/Moscow"),("559643", "Gorodishche", "", "RU", "643", "", "57", "", "", "53.2775", "45.7017", "Europe/Moscow"),("559654", "Gorodishche", "Городище", "RU", "643", "", "84", "", "", "48.80454", "44.47439", "Europe/Volgograd"),("559678", "Gorodets", "Городец", "RU", "643", "", "51", "", "", "56.65493", "43.47273", "Europe/Moscow"),("559731", "Gornyy", "", "RU", "643", "", "67", "", "", "51.7578", "48.5413", "Europe/Volgograd"),("559740", "Gornyatskiy", "", "RU", "643", "", "61", "", "", "48.29147", "40.9575", "Europe/Moscow"),("559752", "Gornozavodsk", "", "RU", "643", "", "90", "", "", "58.37583", "58.32111", "Asia/Yekaterinburg"),("560142", "Gorelovo", "Горелово", "RU", "643", "", "66", "", "", "59.77234", "30.13455", "Europe/Moscow"),("560154", "Gorelki", "", "RU", "643", "", "76", "", "", "54.25617", "37.6108", "Europe/Moscow"),("560255", "Gorbunki", "", "RU", "643", "", "42", "", "", "59.81307", "29.98478", "Europe/Moscow"),("560465", "Gol’yanovo", "Гольяново", "RU", "643", "", "48", "", "", "55.82299", "37.81306", "Europe/Moscow"),("560674", "Golovchino", "", "RU", "643", "", "09", "", "", "50.5341", "35.797", "Europe/Moscow"),("560756", "Golitsyno", "Голицыно", "RU", "643", "", "47", "", "", "55.60928", "36.98212", "Europe/Moscow"),("560852", "Gofitskoye", "", "RU", "643", "", "70", "", "", "45.07917", "43.04639", "Europe/Moscow"),("560995", "Glushkovo", "", "RU", "643", "", "41", "", "", "51.33917", "34.63278", "Europe/Moscow"),("561146", "Glubokiy", "", "RU", "643", "", "61", "", "", "48.52759", "40.32792", "Europe/Moscow"),("561313", "Glazunovka", "", "RU", "643", "", "56", "", "", "52.50057", "36.31997", "Europe/Moscow"),("561347", "Glazov", "Глазов", "RU", "643", "", "80", "", "", "58.1393", "52.658", "Europe/Samara"),("561437", "Gizel’", "", "RU", "643", "", "68", "", "", "43.04", "44.57083", "Europe/Moscow"),("561462", "Girey", "", "RU", "643", "", "38", "", "", "45.4012", "40.6587", "Europe/Moscow"),("561501", "Gigant", "", "RU", "643", "", "61", "", "", "46.50665", "41.34185", "Europe/Moscow"),("561504", "Gidrotorf", "", "RU", "643", "", "51", "", "", "56.47562", "43.53813", "Europe/Moscow"),("561515", "Giaginskaya", "Гиагинская", "RU", "643", "", "01", "561514", "", "44.86208", "40.07195", "Europe/Moscow"),("561549", "Germenchuk", "", "RU", "643", "", "12", "", "", "43.1857", "45.921", "Europe/Moscow"),("561560", "Gergebil’", "", "RU", "643", "", "17", "", "", "42.50472", "47.06611", "Europe/Moscow"),("561626", "Georgiyevskaya", "", "RU", "643", "", "70", "", "", "44.11139", "43.49222", "Europe/Moscow"),("561627", "Georgiyevsk", "Георгиевск", "RU", "643", "", "70", "", "", "44.15194", "43.46972", "Europe/Moscow"),("561667", "Gelendzhik", "Геленджик", "RU", "643", "", "38", "", "", "44.5622", "38.0848", "Europe/Moscow"),("561670", "Gekhi", "", "RU", "643", "", "12", "", "", "43.16354", "45.47238", "Europe/Moscow"),("561679", "Gdov", "", "RU", "643", "", "60", "", "", "58.74424", "27.81977", "Europe/Moscow"),("561722", "Gayduk", "", "RU", "643", "", "38", "", "", "44.78489", "37.7005", "Europe/Moscow"),("561731", "Gay", "Гай", "RU", "643", "", "55", "", "", "51.4666", "58.4552", "Asia/Yekaterinburg"),("561762", "Gavrilov-Yam", "Гаврилов-Ям", "RU", "643", "", "88", "", "", "57.30185", "39.85331", "Europe/Moscow"),("561783", "Gavrilov Posad", "", "RU", "643", "", "21", "", "", "56.5593", "40.121", "Europe/Moscow"),("561887", "Gatchina", "Гатчина", "RU", "643", "", "42", "", "", "59.57639", "30.12833", "Europe/Moscow"),("562161", "Galich", "Галич", "RU", "643", "", "37", "", "", "58.37884", "42.34633", "Europe/Moscow"),("562237", "Gagarin", "Гагарин", "RU", "643", "", "69", "", "", "55.55291", "34.99537", "Europe/Moscow"),("562245", "Gadzhiyevo", "", "RU", "643", "", "49", "", "", "69.25506", "33.33616", "Europe/Moscow"),("562309", "Furmanov", "Фурманов", "RU", "643", "", "21", "", "", "57.25363", "41.10849", "Europe/Moscow"),("562319", "Fryazino", "Фрязино", "RU", "643", "", "47", "", "", "55.96056", "38.04556", "Europe/Moscow"),("562321", "Fryazevo", "Фрязево", "RU", "643", "", "47", "", "", "55.73321", "38.46458", "Europe/Moscow"),("562322", "Fryanovo", "", "RU", "643", "", "47", "", "", "56.13333", "38.45", "Europe/Moscow"),("562389", "Frolovo", "Фролово", "RU", "643", "", "84", "", "", "49.77133", "43.66222", "Europe/Volgograd"),("562820", "Fili", "Фили", "RU", "643", "", "47", "", "", "55.74819", "37.47969", "Europe/Moscow"),("563300", "Fatezh", "", "RU", "643", "", "41", "", "", "52.0891", "35.8632", "Europe/Moscow"),("563306", "Fastovetskaya", "", "RU", "643", "", "38", "", "", "45.91889", "40.15889", "Europe/Moscow"),("563344", "Falënki", "", "RU", "643", "", "33", "", "", "58.36127", "51.59461", "Europe/Kirov"),("563379", "Ezhva", "Эжва", "RU", "643", "", "34", "", "", "61.81281", "50.72834", "Europe/Moscow"),("563420", "Ertil’", "", "RU", "643", "", "86", "", "", "51.84056", "40.80556", "Europe/Moscow"),("563461", "Engel’-Yurt", "", "RU", "643", "", "12", "", "", "43.32633", "46.36048", "Europe/Moscow"),("563464", "Engel’s", "Энгельс", "RU", "643", "", "67", "", "", "51.48389", "46.10528", "Europe/Volgograd"),("563471", "Energetik", "", "RU", "643", "", "55", "", "", "51.7445", "58.7934", "Asia/Yekaterinburg"),("563472", "Enem", "Энем", "RU", "643", "", "01", "", "", "44.9264", "38.90584", "Europe/Moscow"),("563514", "Elista", "Элиста", "RU", "643", "", "24", "", "", "46.30778", "44.25583", "Europe/Moscow"),("563522", "Elektrougli", "Электроугли", "RU", "643", "", "47", "", "", "55.72445", "38.20908", "Europe/Moscow"),("563523", "Elektrostal’", "Электросталь", "RU", "643", "", "47", "", "", "55.78959", "38.44671", "Europe/Moscow"),("563524", "Elektrogorsk", "Электрогорск", "RU", "643", "", "47", "", "", "55.88431", "38.7864", "Europe/Moscow"),("563551", "Ekazhevo", "Экажево", "RU", "643", "", "19", "", "", "43.21222", "44.82306", "Europe/Moscow"),("563556", "Edissiya", "", "RU", "643", "", "70", "", "", "44.05111", "44.54083", "Europe/Moscow"),("563601", "Dzhubga", "", "RU", "643", "", "38", "", "", "44.3211", "38.7073", "Europe/Moscow"),("563678", "Dzhalka", "", "RU", "643", "", "12", "", "", "43.3186", "45.98787", "Europe/Moscow"),("563681", "Dzhalil’", "", "RU", "643", "", "73", "", "", "55.0239", "52.7358", "Europe/Moscow"),("563705", "Dzerzhinskiy", "Дзержинский", "RU", "643", "", "47", "", "", "55.62945", "37.85654", "Europe/Moscow"),("563708", "Dzerzhinsk", "Дзержинск", "RU", "643", "", "51", "", "", "56.24143", "43.45539", "Europe/Moscow"),("563719", "Dyurtyuli", "Дюртюли", "RU", "643", "", "08", "", "", "55.49106", "54.86883", "Asia/Yekaterinburg"),("563792", "Dylym", "", "RU", "643", "", "17", "", "", "43.07099", "46.63454", "Europe/Moscow"),("563822", "Dyat’kovo", "Дятьково", "RU", "643", "", "10", "", "", "53.59782", "34.33825", "Europe/Moscow"),("564098", "Dorgeli", "", "RU", "643", "", "17", "", "", "42.667", "47.29435", "Europe/Moscow"),("564191", "Duminichi", "", "RU", "643", "", "25", "", "", "53.93446", "35.10993", "Europe/Moscow"),("564241", "Dukhovnitskoye", "", "RU", "643", "", "67", "", "", "52.4828", "48.2137", "Europe/Volgograd"),("564487", "Dubrovka", "", "RU", "643", "", "10", "", "", "53.6907", "33.5071", "Europe/Moscow"),("564593", "Dubovskoye", "", "RU", "643", "", "61", "", "", "47.4142", "42.7697", "Europe/Moscow"),("564654", "Dubovka", "Дубовка", "RU", "643", "", "84", "", "", "49.05825", "44.829", "Europe/Volgograd"),("564719", "Dubna", "Дубна", "RU", "643", "", "47", "", "", "56.73333", "37.16667", "Europe/Moscow"),("564723", "Dubna", "", "RU", "643", "", "76", "", "", "54.15416", "36.96173", "Europe/Moscow"),("564764", "Dubki", "", "RU", "643", "", "17", "", "", "43.02116", "46.83746", "Europe/Moscow"),("564821", "Duba-Yurt", "", "RU", "643", "", "12", "", "", "43.03534", "45.73046", "Europe/Moscow"),("565007", "Drezna", "", "RU", "643", "", "47", "", "", "55.74208", "38.84753", "Europe/Moscow"),("565108", "Doschatoye", "", "RU", "643", "", "51", "", "", "55.3886", "42.1032", "Europe/Moscow"),("565197", "Dorogomilovo", "Дорогомилово", "RU", "643", "", "47", "", "", "55.75", "37.56667", "Europe/Moscow"),("565202", "Dorogobuzh", "", "RU", "643", "", "69", "", "", "54.915", "33.29722", "Europe/Moscow"),("565289", "Donskoye", "Донское", "RU", "643", "", "70", "", "", "45.45518", "41.97411", "Europe/Moscow"),("565290", "Donskoy", "Донской", "RU", "643", "", "76", "", "", "53.97106", "38.33627", "Europe/Moscow"),("565300", "Donskoy", "", "RU", "643", "", "61", "", "", "47.41404", "40.25742", "Europe/Moscow"),("565348", "Donetsk", "Донецк", "RU", "643", "", "61", "", "", "48.33487", "39.9459", "Europe/Moscow"),("565357", "Dondukovskaya", "", "RU", "643", "", "01", "561514", "", "44.8819", "40.36271", "Europe/Moscow"),("565381", "Domodedovo", "Домодедово", "RU", "643", "", "47", "565379", "", "55.4413", "37.75367", "Europe/Moscow"),("565407", "Dombarovskiy", "", "RU", "643", "", "55", "", "", "50.7587", "59.5386", "Asia/Yekaterinburg"),("565456", "Dolzhanskaya", "", "RU", "643", "", "38", "", "", "46.63369", "37.80246", "Europe/Moscow"),("565611", "Dolgorukovo", "", "RU", "643", "", "43", "", "", "52.31945", "38.34527", "Europe/Moscow"),("565614", "Dolgoprudnyy", "Долгопрудный", "RU", "643", "", "47", "", "", "55.94958", "37.50183", "Europe/Moscow"),("565778", "Dobryanka", "Добрянка", "RU", "643", "", "90", "565775", "", "58.4644", "56.4127", "Asia/Yekaterinburg"),("565803", "Dobroye", "", "RU", "643", "", "43", "", "", "52.8678", "39.8109", "Europe/Moscow"),("565857", "Dobrinka", "", "RU", "643", "", "43", "", "", "52.16528", "40.47306", "Europe/Moscow"),("565885", "Dno", "", "RU", "643", "", "60", "", "", "57.82772", "29.96368", "Europe/Moscow"),("565908", "Dmitrovsk-Orlovskiy", "", "RU", "643", "", "56", "", "", "52.505", "35.1464", "Europe/Moscow"),("565955", "Dmitrov", "Дмитров", "RU", "643", "", "47", "", "", "56.34485", "37.52041", "Europe/Moscow"),("566155", "Divnoye", "Дивное", "RU", "643", "", "70", "", "", "45.90889", "43.35472", "Europe/Moscow"),("566157", "Divnomorskoye", "", "RU", "643", "", "38", "", "", "44.5017", "38.1342", "Europe/Moscow"),("566165", "Diveyevo", "", "RU", "643", "", "51", "", "", "55.04329", "43.24178", "Europe/Moscow"),("566181", "Dinskaya", "Динская", "RU", "643", "", "38", "", "", "45.21516", "39.2265", "Europe/Moscow"),("566199", "Dimitrovgrad", "Димитровград", "RU", "643", "", "81", "", "", "54.21386", "49.61838", "Europe/Ulyanovsk"),("566243", "Digora", "", "RU", "643", "", "68", "", "", "43.15806", "44.15694", "Europe/Moscow"),("566384", "Desnogorsk", "Десногорск", "RU", "643", "", "69", "", "", "54.15077", "33.28151", "Europe/Moscow"),("566456", "Dergachi", "", "RU", "643", "", "67", "", "", "51.2328", "48.7659", "Europe/Volgograd"),("566532", "Derbent", "Дербент", "RU", "643", "", "17", "", "", "42.06779", "48.28987", "Europe/Moscow"),("566629", "Demyansk", "", "RU", "643", "", "52", "", "", "57.64301", "32.466", "Europe/Moscow"),("566635", "Dem’yanovo", "", "RU", "643", "", "33", "", "", "60.35111", "47.08417", "Europe/Kirov"),("566712", "Demikhovo", "", "RU", "643", "", "47", "", "", "55.79685", "38.88404", "Europe/Moscow"),("566751", "Demidov", "", "RU", "643", "", "69", "", "", "55.27063", "31.51497", "Europe/Moscow"),("566854", "Dedovsk", "Дедовск", "RU", "643", "", "47", "", "", "55.86861", "37.12222", "Europe/Moscow"),("566868", "Dedovichi", "", "RU", "643", "", "60", "", "", "57.55166", "29.95018", "Europe/Moscow"),("566891", "Dedenëvo", "", "RU", "643", "", "47", "", "", "56.24283", "37.51769", "Europe/Moscow"),("566908", "Debesy", "", "RU", "643", "", "80", "", "", "57.6515", "53.8089", "Europe/Samara"),("566950", "Davydovo", "", "RU", "643", "", "47", "", "", "55.60859", "38.86109", "Europe/Moscow"),("566969", "Davydovka", "", "RU", "643", "", "86", "", "", "51.15781", "39.42915", "Europe/Moscow"),("566976", "Davydkovo", "Давыдково", "RU", "643", "", "48", "", "", "55.71815", "37.47271", "Europe/Moscow"),("567006", "Davlekanovo", "Давлеканово", "RU", "643", "", "08", "", "", "54.22145", "55.03434", "Asia/Yekaterinburg"),("567047", "Darovskoy", "", "RU", "643", "", "33", "", "", "58.76999", "47.95642", "Europe/Kirov"),("567109", "Dankov", "Данков", "RU", "643", "", "43", "", "", "53.25155", "39.15553", "Europe/Moscow"),("567177", "Danilovka", "", "RU", "643", "", "84", "", "", "50.35573", "44.11681", "Europe/Volgograd"),("567183", "Danilov", "Данилов", "RU", "643", "", "88", "", "", "58.1908", "40.17171", "Europe/Moscow"),("567280", "Dalakovo", "", "RU", "643", "", "19", "", "", "43.23759", "44.58964", "Europe/Moscow"),("567290", "Dagestanskiye Ogni", "Дагестанские Огни", "RU", "643", "", "17", "", "", "42.11589", "48.19204", "Europe/Moscow"),("567311", "Dachnoye", "Дачное", "RU", "643", "", "66", "548375", "", "59.84167", "30.25583", "Europe/Moscow"),("567434", "Chusovoy", "Чусовой", "RU", "643", "", "90", "", "", "58.3013", "57.8131", "Asia/Yekaterinburg"),("567695", "Chukhloma", "", "RU", "643", "", "37", "", "", "58.75375", "42.68318", "Europe/Moscow"),("567774", "Chudovo", "Чудово", "RU", "643", "", "52", "", "", "59.11667", "31.68333", "Europe/Moscow"),("567859", "Chontaul", "", "RU", "643", "", "17", "", "", "43.30481", "46.85967", "Europe/Moscow"),("567902", "Chkalovsk", "", "RU", "643", "", "51", "", "", "56.76776", "43.25135", "Europe/Moscow"),("567990", "Chistopol’", "Чистополь", "RU", "643", "", "73", "Chistopol'skiy Rayon", "", "55.36311", "50.64244", "Europe/Moscow"),("568012", "Chishmy", "Чишмы", "RU", "643", "", "08", "", "", "54.57648", "55.37642", "Asia/Yekaterinburg"),("568077", "Chirkey", "", "RU", "643", "", "17", "", "", "42.96131", "46.97866", "Europe/Moscow"),("568085", "Chiri-Yurt", "", "RU", "643", "", "12", "", "", "43.08869", "45.74323", "Europe/Moscow"),("568184", "Chikola", "", "RU", "643", "", "68", "", "", "43.19055", "43.92093", "Europe/Moscow"),("568429", "Chertkovo", "", "RU", "643", "", "61", "", "", "49.3847", "40.15471", "Europe/Moscow"),("568464", "Chyorny Yar", "", "RU", "643", "", "07", "", "", "48.06242", "46.10911", "Europe/Astrakhan"),("568527", "Chernyshkovskiy", "", "RU", "643", "", "84", "", "", "48.42188", "42.23083", "Europe/Volgograd"),("568587", "Chernyanka", "Чернянка", "RU", "643", "", "09", "", "", "50.94095", "37.80693", "Europe/Moscow"),("568595", "Chernyakhovsk", "Черняховск", "RU", "643", "", "23", "", "", "54.63345", "21.81557", "Europe/Kaliningrad"),("568608", "Chernushka", "Чернушка", "RU", "643", "", "90", "", "", "56.50722", "56.07661", "Asia/Yekaterinburg"),("568785", "Chernomorskiy", "", "RU", "643", "", "38", "", "", "44.85056", "38.49361", "Europe/Moscow"),("568790", "Chernolesskoye", "", "RU", "643", "", "70", "", "", "44.71556", "43.71333", "Europe/Moscow"),("568808", "Chernogolovka", "Черноголовка", "RU", "643", "", "47", "", "", "56", "38.36667", "Europe/Moscow"),("569077", "Chornoye", "", "RU", "643", "", "47", "579462", "", "55.74611", "38.06889", "Europe/Moscow"),("569116", "Chern’", "", "RU", "643", "", "76", "", "", "53.45232", "36.9145", "Europe/Moscow"),("569132", "Chermen", "", "RU", "643", "", "68", "", "", "43.14861", "44.70694", "Europe/Moscow"),("569154", "Cherkessk", "Черкесск", "RU", "643", "RU", "27", "", "", "44.22333", "42.05778", "Europe/Moscow"),("569223", "Cherepovets", "Череповец", "RU", "643", "", "85", "", "", "59.13333", "37.9", "Europe/Moscow"),("569273", "Cherëmushki", "Черёмушки", "RU", "643", "", "48", "562221", "9883012", "55.66473", "37.56135", "Europe/Moscow"),("569295", "Cherëmukhovo", "", "RU", "643", "", "71", "", "", "60.34842", "59.98507", "Asia/Yekaterinburg"),("569318", "Cheremshan", "", "RU", "643", "", "73", "", "", "54.66667", "51.5", "Europe/Moscow"),("569359", "Cherdyn’", "", "RU", "643", "", "90", "", "", "60.40295", "56.47868", "Asia/Yekaterinburg"),("569360", "Cherdakly", "", "RU", "643", "", "81", "", "", "54.3594", "48.84497", "Europe/Ulyanovsk"),("569453", "Chemodanovka", "", "RU", "643", "", "57", "", "", "53.23162", "45.24738", "Europe/Moscow"),("569497", "Chelno-Vershiny", "", "RU", "643", "", "65", "", "", "54.4148", "51.08594", "Europe/Samara"),("569540", "Chelbasskaya", "", "RU", "643", "", "38", "", "", "45.97924", "39.37186", "Europe/Moscow"),("569579", "Chekmagush", "", "RU", "643", "", "08", "", "", "55.13194", "54.65556", "Asia/Yekaterinburg"),("569591", "Chekhov", "Чехов", "RU", "643", "", "47", "569587", "", "55.1477", "37.47728", "Europe/Moscow"),("569632", "Chegem Vtoroy", "", "RU", "643", "", "22", "", "", "43.59583", "43.59944", "Europe/Moscow"),("569639", "Chegem", "Чегем", "RU", "643", "", "22", "", "", "43.28333", "43.13333", "Europe/Moscow"),("569666", "Chechen-Aul", "", "RU", "643", "", "12", "", "", "43.2", "45.78889", "Europe/Moscow"),("569696", "Cheboksary", "Чебоксары", "RU", "643", "", "16", "569698", "", "56.13222", "47.25194", "Europe/Moscow"),("569742", "Chaykovskiy", "Чайковский", "RU", "643", "", "90", "", "", "56.76864", "54.11484", "Asia/Yekaterinburg"),("569934", "Chaplygin", "", "RU", "643", "", "43", "", "", "53.24319", "39.96288", "Europe/Moscow"),("569955", "Chapayevsk", "Чапаевск", "RU", "643", "", "65", "", "", "52.9771", "49.7086", "Europe/Samara"),("570003", "Chamzinka", "", "RU", "643", "", "46", "", "", "54.40188", "45.78387", "Europe/Moscow"),("570021", "Chaltyr", "", "RU", "643", "", "61", "", "", "47.28477", "39.48232", "Europe/Moscow"),("570086", "Chagoda", "", "RU", "643", "", "85", "", "", "59.164", "35.3285", "Europe/Moscow"),("570133", "Chaadayevka", "", "RU", "643", "", "57", "", "", "53.1427", "45.9122", "Europe/Moscow"),("570298", "Bykovo", "", "RU", "643", "", "47", "", "", "55.63614", "38.08027", "Europe/Moscow"),("570315", "Bykovo", "", "RU", "643", "", "84", "", "", "49.76618", "45.38866", "Europe/Volgograd"),("570427", "Buzuluk", "Бузулук", "RU", "643", "", "55", "", "", "52.7807", "52.2635", "Asia/Yekaterinburg"),("570455", "Buzdyak", "", "RU", "643", "", "08", "", "", "54.58333", "54.55", "Asia/Yekaterinburg"),("570479", "Buynaksk", "Буйнакск", "RU", "643", "", "17", "", "", "42.819", "47.1192", "Europe/Moscow"),("570508", "Buy", "Буй", "RU", "643", "", "37", "", "", "58.48067", "41.53699", "Europe/Moscow"),("570563", "Buturlinovka", "Бутурлиновка", "RU", "643", "", "86", "", "", "50.82389", "40.60917", "Europe/Moscow"),("570564", "Buturlino", "", "RU", "643", "", "51", "", "", "55.56673", "44.89738", "Europe/Moscow"),("570868", "Burayevo", "", "RU", "643", "", "08", "", "", "55.84069", "55.40834", "Asia/Yekaterinburg"),("570990", "Bolgar", "", "RU", "643", "", "73", "", "", "54.95", "49.06667", "Europe/Moscow"),("571155", "Buinsk", "Буинск", "RU", "643", "", "73", "", "", "54.97119", "48.29184", "Europe/Moscow"),("571159", "Buguruslan", "Бугуруслан", "RU", "643", "", "55", "", "", "53.6554", "52.442", "Asia/Yekaterinburg"),("571170", "Bugul’ma", "Бугульма", "RU", "643", "", "73", "Bugul'minskiy Rayon", "", "54.5378", "52.7985", "Europe/Moscow"),("571306", "Budënnovsk", "Буденновск", "RU", "643", "", "70", "", "", "44.78389", "44.16583", "Europe/Moscow"),("571420", "Bryukhovetskaya", "Брюховецкая", "RU", "643", "", "38", "", "", "45.80603", "38.99959", "Europe/Moscow"),("571476", "Bryansk", "Брянск", "RU", "643", "", "10", "571467", "", "53.25209", "34.37167", "Europe/Moscow"),("571557", "Bronnitsy", "Бронницы", "RU", "643", "", "47", "", "", "55.42112", "38.26188", "Europe/Moscow"),("571702", "Nogamerzin-Yurt", "", "RU", "643", "", "12", "", "", "43.65361", "44.88889", "Europe/Moscow"),("571741", "Brateyevo", "Братеево", "RU", "643", "", "48", "490025", "", "55.63755", "37.76438", "Europe/Moscow"),("571987", "Borskoye", "", "RU", "643", "", "65", "", "", "53.03333", "51.71667", "Europe/Samara"),("572070", "Borovsk", "", "RU", "643", "", "25", "", "", "55.20639", "36.48611", "Europe/Moscow"),("572154", "Borovichi", "Боровичи", "RU", "643", "", "52", "", "", "58.38778", "33.91546", "Europe/Moscow"),("572256", "Borodinskiy", "", "RU", "643", "", "76", "", "", "53.99859", "37.81792", "Europe/Moscow"),("572500", "Borisovka", "", "RU", "643", "", "09", "", "", "50.60155", "36.01549", "Europe/Moscow"),("572520", "Borisoglebskiy", "", "RU", "643", "", "88", "", "", "57.2586", "39.1508", "Europe/Moscow"),("572525", "Borisoglebsk", "Борисоглебск", "RU", "643", "", "86", "", "", "51.36713", "42.08494", "Europe/Moscow"),("572559", "Borinskoye", "", "RU", "643", "", "43", "", "", "52.4569", "39.3713", "Europe/Moscow"),("572665", "Bor", "Бор", "RU", "643", "", "51", "", "", "56.35808", "44.07477", "Europe/Moscow"),("572706", "Bamut", "", "RU", "643", "", "19", "", "", "43.15986", "45.19734", "Europe/Moscow"),("573471", "Bol’shoye Murashkino", "", "RU", "643", "", "51", "", "", "55.78261", "44.77541", "Europe/Moscow"),("573709", "Bol’shoye Boldino", "", "RU", "643", "", "51", "", "", "55.00588", "45.31419", "Europe/Moscow"),("574307", "Bolshevo", "", "RU", "643", "", "47", "", "", "55.93486", "37.83002", "Europe/Moscow"),("574675", "Bol’shaya Setun’", "Большая Сетунь", "RU", "643", "", "47", "", "", "55.71667", "37.41667", "Europe/Moscow"),("575343", "Bolokhovo", "", "RU", "643", "", "76", "", "", "54.08378", "37.82895", "Europe/Moscow"),("575349", "Bologoye", "Бологое", "RU", "643", "", "77", "", "", "57.8799", "34.10681", "Europe/Moscow"),("575364", "Bolkhov", "", "RU", "643", "", "56", "", "", "53.44295", "36.00546", "Europe/Moscow"),("575410", "Boksitogorsk", "Бокситогорск", "RU", "643", "", "42", "575409", "", "59.47405", "33.84853", "Europe/Moscow"),("575413", "Bokovskaya", "", "RU", "643", "", "61", "", "", "49.22899", "41.8306", "Europe/Moscow"),("575457", "Boguchar", "Богучар", "RU", "643", "", "86", "", "", "49.93577", "40.545", "Europe/Moscow"),("575505", "Bogorodskoye", "Богородское", "RU", "643", "", "48", "", "", "55.81353", "37.71617", "Europe/Moscow"),("575521", "Bogorodskoye", "", "RU", "643", "", "47", "", "", "56.55", "37.88333", "Europe/Moscow"),("575522", "Bogorodskoye", "", "RU", "643", "", "47", "", "", "56.5", "38.18333", "Europe/Moscow"),("575560", "Bogorodsk", "Богородск", "RU", "643", "", "51", "", "", "56.10513", "43.51294", "Europe/Moscow"),("575591", "Bogoroditsk", "Богородицк", "RU", "643", "", "76", "", "", "53.77166", "38.12408", "Europe/Moscow"),("575728", "Bogatyye Saby", "", "RU", "643", "", "73", "", "", "56.0102", "50.4483", "Europe/Moscow"),("575756", "Bogatoye", "", "RU", "643", "", "65", "", "", "53.0601", "51.3325", "Europe/Samara"),("575948", "Bobrov", "Бобров", "RU", "643", "", "86", "", "", "51.09611", "40.03333", "Europe/Moscow"),("576116", "Blagoveshchensk", "Благовещенск", "RU", "643", "", "08", "", "", "55.035", "55.97806", "Asia/Yekaterinburg"),("576147", "Blagodatnoye", "", "RU", "643", "", "70", "", "", "45.39972", "42.58667", "Europe/Moscow"),("576172", "Blagodarnyy", "Благодарный", "RU", "643", "", "70", "", "", "45.09778", "43.43639", "Europe/Moscow"),("576195", "Bizhbulyak", "", "RU", "643", "", "08", "", "", "53.6967", "54.2642", "Asia/Yekaterinburg"),("576260", "Bisert’", "", "RU", "643", "", "71", "", "", "56.86174", "59.05231", "Asia/Yekaterinburg"),("576279", "Biryulëvo", "Бирюлёво", "RU", "643", "", "48", "", "", "55.58635", "37.67781", "Europe/Moscow"),("576317", "Birsk", "Бирск", "RU", "643", "", "08", "", "", "55.42111", "55.54278", "Asia/Yekaterinburg"),("576351", "Bilimbay", "", "RU", "643", "", "71", "", "", "56.96889", "59.8149", "Asia/Yekaterinburg"),("576432", "Bibirevo", "Бибирево", "RU", "643", "", "48", "", "", "55.88333", "37.6", "Europe/Moscow"),("576519", "Bezopasnoye", "", "RU", "643", "", "70", "", "", "45.64833", "41.93603", "Europe/Moscow"),("576566", "Bezhetsk", "Бежецк", "RU", "643", "", "77", "", "", "57.78506", "36.69651", "Europe/Moscow"),("576590", "Bezenchuk", "Бородинский", "RU", "643", "", "65", "", "", "52.982", "49.4333", "Europe/Samara"),("576663", "Bessonovka", "", "RU", "643", "", "57", "", "", "53.30968", "45.04069", "Europe/Moscow"),("576672", "Besskorbnaya", "", "RU", "643", "", "38", "", "", "44.6447", "41.311", "Europe/Moscow"),("576697", "Beslan", "Беслан", "RU", "643", "", "68", "", "", "43.19217", "44.54313", "Europe/Moscow"),("577206", "Berezniki", "Березники", "RU", "643", "", "90", "", "", "59.4091", "56.8204", "Asia/Yekaterinburg"),("577240", "Berëznik", "", "RU", "643", "", "06", "", "", "62.852", "42.7071", "Europe/Moscow"),("577380", "Berezanskaya", "", "RU", "643", "", "38", "", "", "45.70562", "39.59324", "Europe/Moscow"),("577384", "Berëza", "", "RU", "643", "", "65", "", "", "53.51833", "50.13967", "Europe/Samara"),("577450", "Berdyaush", "", "RU", "643", "", "13", "", "", "55.1619", "59.1464", "Asia/Yekaterinburg"),("577485", "Benoy-Yurt", "", "RU", "643", "", "12", "", "", "43.69305", "45.05025", "Europe/Moscow"),("577551", "Belyye Stolby", "", "RU", "643", "", "47", "", "", "55.33136", "37.854", "Europe/Moscow"),("577560", "Belyye Berega", "", "RU", "643", "", "10", "", "", "53.20851", "34.66405", "Europe/Moscow"),("577630", "Belyayevka", "", "RU", "643", "", "55", "", "", "51.39742", "56.41667", "Asia/Yekaterinburg"),("577711", "Belozërsk", "", "RU", "643", "", "85", "", "", "60.0288", "37.8084", "Europe/Moscow"),("577856", "Belousovo", "", "RU", "643", "", "25", "", "", "55.09499", "36.6732", "Europe/Moscow"),("577881", "Beloretsk", "Белорецк", "RU", "643", "", "08", "", "", "53.96306", "58.39806", "Asia/Yekaterinburg"),("577893", "Belorechensk", "Белореченск", "RU", "643", "", "38", "", "", "44.77127", "39.87879", "Europe/Moscow"),("577901", "Beloozërskiy", "Белоозёрский", "RU", "643", "", "47", "", "", "55.45978", "38.44358", "Europe/Moscow"),("577908", "Beloomut", "", "RU", "643", "", "47", "", "", "54.94478", "39.33941", "Europe/Moscow"),("577922", "Belomorsk", "", "RU", "643", "", "28", "", "", "64.52322", "34.7668", "Europe/Moscow"),("578045", "Belinskiy", "", "RU", "643", "", "57", "", "", "52.96474", "43.41647", "Europe/Moscow"),("578072", "Belgorod", "Белгород", "RU", "643", "", "09", "578070", "", "50.61074", "36.58015", "Europe/Moscow"),("578091", "Belëv", "Белёв", "RU", "643", "", "76", "", "", "53.81194", "36.13194", "Europe/Moscow"),("578120", "Belebey", "Белебей", "RU", "643", "", "08", "", "", "54.11667", "54.11667", "Asia/Yekaterinburg"),("578152", "Belaya Kholunitsa", "", "RU", "643", "", "33", "", "", "58.84", "50.85278", "Europe/Kirov"),("578155", "Belaya Kalitva", "Белая-Калитва", "RU", "643", "", "61", "", "", "48.18585", "40.77424", "Europe/Moscow"),("578169", "Belaya Glina", "Белая Глина", "RU", "643", "", "38", "", "", "46.07802", "40.86651", "Europe/Moscow"),("578263", "Bekovo", "", "RU", "643", "", "57", "", "", "52.46632", "43.71199", "Europe/Moscow"),("578369", "Spassk", "", "RU", "643", "", "57", "", "", "53.92559", "43.18394", "Europe/Moscow"),("578465", "Bazarnyy Syzgan", "", "RU", "643", "", "81", "", "", "53.75117", "46.75354", "Europe/Ulyanovsk"),("578466", "Bazarnyy Karabulak", "", "RU", "643", "", "67", "", "", "52.26833", "46.41444", "Europe/Volgograd"),("578467", "Bazarnyye Mataki", "", "RU", "643", "", "73", "Al’keyevskiy Rayon", "", "54.88333", "49.93333", "Europe/Moscow"),("578534", "Baymak", "Баймак", "RU", "643", "", "08", "", "", "52.59333", "58.3225", "Asia/Yekaterinburg"),("578637", "Bavtugay", "", "RU", "643", "", "17", "Buynakskiy Rayon", "", "43.16808", "46.83415", "Europe/Moscow"),("578638", "Bavly", "Бавлы", "RU", "643", "", "73", "578639", "", "54.39304", "53.26023", "Europe/Moscow"),("578659", "Batyrevo", "", "RU", "643", "", "16", "", "", "55.0675", "47.61111", "Europe/Moscow"),("578740", "Bataysk", "Батайск", "RU", "643", "", "61", "", "", "47.13975", "39.75181", "Europe/Moscow"),("578842", "Bashmakovo", "", "RU", "643", "", "57", "", "", "53.21329", "43.0342", "Europe/Moscow"),("578931", "Barysh", "Барыш", "RU", "643", "", "81", "", "", "53.65533", "47.11229", "Europe/Ulyanovsk"),("578974", "Barsukovskaya", "", "RU", "643", "", "70", "", "", "44.7632", "41.8191", "Europe/Moscow"),("579132", "Barda", "", "RU", "643", "", "90", "", "", "56.9287", "55.5962", "Asia/Yekaterinburg"),("579266", "Baranchinskiy", "", "RU", "643", "", "71", "", "", "58.1617", "59.6991", "Asia/Yekaterinburg"),("579384", "Baltasi", "", "RU", "643", "", "73", "579382", "", "56.3462", "50.2062", "Europe/Moscow"),("579432", "Balezino", "Балезино", "RU", "643", "", "80", "", "", "57.9787", "53.0138", "Europe/Samara"),("579460", "Balashov", "Балашов", "RU", "643", "", "67", "", "", "51.5502", "43.1667", "Europe/Volgograd"),("579464", "Balashikha", "Балашиха", "RU", "643", "", "47", "", "", "55.80945", "37.95806", "Europe/Moscow"),("579492", "Balakovo", "Балаково", "RU", "643", "", "67", "", "", "52.02782", "47.8007", "Europe/Volgograd"),("579496", "Balakirevo", "", "RU", "643", "", "83", "", "", "56.50588", "38.84324", "Europe/Moscow"),("579514", "Novaya Balakhna", "Балахна", "RU", "643", "", "51", "", "", "56.48989", "43.60114", "Europe/Moscow"),("579529", "Balabanovo", "Балабаново", "RU", "643", "", "25", "", "", "55.18161", "36.6606", "Europe/Moscow"),("579571", "Baksanenok", "", "RU", "643", "", "22", "", "", "43.68972", "43.65472", "Europe/Moscow"),("579574", "Baksan", "Баксан", "RU", "643", "", "22", "", "", "43.68806", "43.53694", "Europe/Moscow"),("579728", "Bakaly", "", "RU", "643", "", "08", "", "", "55.17889", "53.80278", "Asia/Yekaterinburg"),("579738", "Bakal", "Бакал", "RU", "643", "", "13", "", "", "54.9417", "58.8083", "Asia/Yekaterinburg"),("579760", "Bagrationovsk", "", "RU", "643", "", "23", "", "", "54.38714", "20.64372", "Europe/Kaliningrad"),("579771", "Bagayevskaya", "Багаевская", "RU", "643", "", "61", "", "", "47.32411", "40.38791", "Europe/Moscow"),("579831", "Bachi-Yurt", "", "RU", "643", "", "12", "495940", "", "43.22417", "46.19423", "Europe/Moscow"),("579870", "Babushkin", "Бабушкин", "RU", "643", "", "48", "", "", "55.86931", "37.72966", "Europe/Moscow"),("579999", "Babayurt", "", "RU", "643", "", "17", "", "", "43.6002", "46.77888", "Europe/Moscow"),("580006", "Babayevo", "", "RU", "643", "", "85", "", "", "59.3936", "35.9371", "Europe/Moscow"),("580054", "Azov", "Азов", "RU", "643", "", "61", "", "", "47.10779", "39.41648", "Europe/Moscow"),("580139", "Ayutinskiy", "", "RU", "643", "", "61", "", "", "47.78228", "40.14763", "Europe/Moscow"),("580218", "Avtury", "Автуры", "RU", "643", "", "12", "495940", "", "43.16354", "46.0012", "Europe/Moscow"),("580222", "Avtovo", "Автово", "RU", "643", "", "66", "", "", "59.87167", "30.26583", "Europe/Moscow"),("580227", "Avsyunino", "", "RU", "643", "", "47", "", "", "55.56516", "39.12324", "Europe/Moscow"),("580375", "Atyashevo", "", "RU", "643", "", "46", "", "", "54.56443", "46.06905", "Europe/Moscow"),("580420", "Atkarsk", "Аткарск", "RU", "643", "", "67", "", "", "51.87185", "45.00775", "Europe/Volgograd"),("580497", "Astrakhan", "Астрахань", "RU", "643", "", "07", "824964", "", "46.34968", "48.04076", "Europe/Astrakhan"),("580545", "Assinovskaya", "", "RU", "643", "", "19", "", "", "43.24167", "45.18194", "Europe/Moscow"),("580577", "Askino", "", "RU", "643", "", "08", "", "", "56.09013", "56.57831", "Asia/Yekaterinburg"),("580597", "Ashukino", "", "RU", "643", "", "47", "", "", "56.16667", "37.95", "Europe/Moscow"),("580660", "Asha", "Аша", "RU", "643", "", "13", "", "", "54.9973", "57.2722", "Asia/Yekaterinburg"),("580676", "Asekeyevo", "", "RU", "643", "", "55", "", "", "53.57425", "52.79724", "Asia/Yekaterinburg"),("580716", "Arzgir", "Арзгир", "RU", "643", "", "70", "", "", "45.37278", "44.22056", "Europe/Moscow"),("580724", "Arzamas", "Арзамас", "RU", "643", "", "51", "", "", "55.39485", "43.83992", "Europe/Moscow"),("580783", "Arti", "", "RU", "643", "", "71", "", "", "56.42344", "58.53276", "Asia/Yekaterinburg"),("580850", "Arsk", "Арск", "RU", "643", "", "73", "580846", "", "56.09151", "49.87783", "Europe/Moscow"),("580922", "Armavir", "Армавир", "RU", "643", "", "38", "", "", "44.9892", "41.1234", "Europe/Moscow"),("580942", "Arkhonskaya", "", "RU", "643", "", "68", "", "", "43.11", "44.5125", "Europe/Moscow"),("580969", "Arkhipo-Osipovka", "", "RU", "643", "", "38", "", "", "44.37194", "38.52972", "Europe/Moscow"),("581049", "Arkhangel’sk", "Архангельск", "RU", "643", "", "06", "", "", "64.5401", "40.5433", "Europe/Moscow"),("581080", "Arkadak", "", "RU", "643", "", "67", "", "", "51.93261", "43.49779", "Europe/Volgograd"),("581126", "Argun", "Аргун", "RU", "643", "", "12", "", "", "43.29713", "45.87454", "Europe/Moscow"),("581128", "Argudan", "", "RU", "643", "", "22", "", "", "43.42139", "43.91583", "Europe/Moscow"),("581179", "Ardon", "Ардон", "RU", "643", "", "68", "", "", "43.1772", "44.29702", "Europe/Moscow"),("581186", "Ardatov", "", "RU", "643", "", "51", "", "", "55.24205", "43.09699", "Europe/Moscow"),("581187", "Ardatov", "", "RU", "643", "", "46", "Ardatovskiy Rayon (undefined)", "", "54.84767", "46.23878", "Europe/Moscow"),("581313", "Apsheronsk", "Апшеронск", "RU", "643", "", "38", "", "", "44.46472", "39.73417", "Europe/Moscow"),("581321", "Aprelevka", "Апрелевка", "RU", "643", "", "47", "523425", "", "55.55194", "37.0801", "Europe/Moscow"),("581357", "Apatity", "Апатиты", "RU", "643", "", "49", "", "", "67.56414", "33.4031", "Europe/Moscow"),("581568", "Ansalta", "", "RU", "643", "", "17", "571887", "", "42.68941", "46.11782", "Europe/Moscow"),("581671", "Anna", "Анна", "RU", "643", "", "86", "", "", "51.4842", "40.4299", "Europe/Moscow"),("581788", "Andzhiyevskiy", "", "RU", "643", "", "70", "", "", "44.23889", "43.08556", "Europe/Moscow"),("581928", "Andreyevskoye", "Андреевское", "RU", "643", "", "47", "", "", "55.55487", "37.92566", "Europe/Moscow"),("581989", "Andreyevo", "", "RU", "643", "", "83", "", "", "55.9465", "41.1505", "Europe/Moscow"),("582001", "Andreyevka", "", "RU", "643", "", "47", "", "", "55.98028", "37.135", "Europe/Moscow"),("582097", "Endirey", "", "RU", "643", "", "17", "", "", "43.16316", "46.65401", "Europe/Moscow"),("582105", "Andreapol’", "", "RU", "643", "", "77", "", "", "56.65134", "32.2664", "Europe/Moscow"),("582123", "Andi", "", "RU", "643", "", "17", "571887", "", "42.78359", "46.26171", "Europe/Moscow"),("582163", "Anastasiyevskaya", "", "RU", "643", "", "38", "", "", "45.21576", "37.89258", "Europe/Moscow"),("582181", "Anapskaya", "", "RU", "643", "", "38", "", "", "44.89671", "37.386", "Europe/Moscow"),("582182", "Anapa", "Анапа", "RU", "643", "", "38", "", "", "44.89084", "37.3239", "Europe/Moscow"),("582266", "Amin’yevo", "Аминьево", "RU", "643", "", "48", "", "", "55.7", "37.46667", "Europe/Moscow");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("582362", "Altud", "", "RU", "643", "", "22", "", "", "43.72194", "43.86583", "Europe/Moscow"),("582423", "Alnashi", "", "RU", "643", "", "80", "", "", "56.18738", "52.47919", "Europe/Samara"),("582432", "Al’met’yevsk", "Альметьевск", "RU", "643", "", "73", "Al’met’yevskiy Rayon", "", "54.90442", "52.3154", "Europe/Moscow"),("582462", "Alleroy", "", "RU", "643", "", "12", "495940", "", "43.21711", "46.28209", "Europe/Moscow"),("582490", "Alkhazurovo", "", "RU", "643", "", "12", "", "", "43.0639", "45.65134", "Europe/Moscow"),("582491", "Alkhan-Yurt", "", "RU", "643", "", "12", "", "", "43.23179", "45.57228", "Europe/Moscow"),("582493", "Alkhan-Kala", "", "RU", "643", "", "12", "", "", "43.25861", "45.53917", "Europe/Moscow"),("582504", "Ali-Yurt", "", "RU", "643", "", "19", "", "", "43.1425", "44.8525", "Europe/Moscow"),("582544", "Ali-Berdukovskiy", "", "RU", "643", "", "27", "", "", "43.98952", "41.74212", "Europe/Moscow"),("582750", "Aleksin", "Алексин", "RU", "643", "", "76", "", "", "54.50503", "37.0674", "Europe/Moscow"),("582775", "Alekseyevskoye", "", "RU", "643", "", "73", "582785", "", "55.30706", "50.11353", "Europe/Moscow"),("582846", "Alekseyevka", "Алексеевка", "RU", "643", "", "47", "", "", "55.63", "37.8", "Europe/Moscow"),("582956", "Alekseyevka", "Алексеевка", "RU", "643", "", "09", "", "", "50.6309", "38.6903", "Europe/Moscow"),("582993", "Aleksandrovskoye", "Александровское", "RU", "643", "", "70", "", "", "44.71417", "43.00083", "Europe/Moscow"),("583041", "Aleksandrovsk", "Александровск", "RU", "643", "", "90", "", "", "59.1581", "57.5695", "Asia/Yekaterinburg"),("583345", "Aleksandrov Gay", "", "RU", "643", "", "67", "", "", "50.14704", "48.57037", "Europe/Volgograd"),("583350", "Aleksandrov", "Александров", "RU", "643", "", "83", "", "", "56.39516", "38.71216", "Europe/Moscow"),("583368", "Aleksandriyskaya", "", "RU", "643", "", "70", "", "", "44.22722", "43.34528", "Europe/Moscow"),("583437", "Alatyr’", "Алатырь", "RU", "643", "", "16", "", "", "54.8421", "46.5813", "Europe/Moscow"),("583472", "Alakurtti", "", "RU", "643", "", "49", "", "", "66.9672", "30.34905", "Europe/Moscow"),("583509", "Ak”yar", "", "RU", "643", "", "08", "", "", "51.85905", "58.22136", "Asia/Yekaterinburg"),("583548", "Aktyubinskiy", "", "RU", "643", "", "73", "580061", "", "54.81372", "52.80559", "Europe/Moscow"),("583578", "Aktanysh", "", "RU", "643", "", "73", "583576", "", "55.72156", "54.08293", "Europe/Moscow"),("583589", "Levoberezhnyy", "Аксиньино", "RU", "643", "", "47", "", "", "55.85", "37.48333", "Europe/Moscow"),("583673", "Aksay", "Аксай", "RU", "643", "", "61", "", "", "47.25838", "39.86675", "Europe/Moscow"),("583674", "Aksay", "", "RU", "643", "", "17", "", "", "43.37254", "46.44497", "Europe/Moscow"),("583785", "Akhtyrskiy", "Ахтырский", "RU", "643", "", "38", "", "", "44.8546", "38.3031", "Europe/Moscow"),("583794", "Akhty", "", "RU", "643", "", "17", "", "", "41.45968", "47.73123", "Europe/Moscow"),("583798", "Akhtubinsk", "Ахтубинск", "RU", "643", "", "07", "583796", "", "48.27955", "46.17217", "Europe/Astrakhan"),("583983", "Agryz", "Агрыз", "RU", "643", "", "73", "", "", "56.52034", "52.99422", "Europe/Moscow"),("584021", "Ageyevo", "", "RU", "643", "", "76", "", "", "54.15883", "36.46927", "Europe/Moscow"),("584051", "Agapovka", "", "RU", "643", "", "13", "", "", "53.2973", "59.1348", "Asia/Yekaterinburg"),("584059", "Agalatovo", "", "RU", "643", "", "42", "", "", "60.2195", "30.27388", "Europe/Moscow"),("584126", "Afipskiy", "Афипский", "RU", "643", "", "38", "", "", "44.90005", "38.84265", "Europe/Moscow"),("584243", "Adler", "Адлер", "RU", "643", "", "38", "", "", "43.42896", "39.92391", "Europe/Moscow"),("584279", "Adamovka", "", "RU", "643", "", "55", "", "", "51.5223", "59.9396", "Asia/Yekaterinburg"),("584298", "Achkhoy-Martan", "Ачхой-Мартан", "RU", "643", "", "12", "", "", "43.18997", "45.28373", "Europe/Moscow"),("584308", "Achit", "", "RU", "643", "", "71", "", "", "56.7985", "57.8994", "Asia/Yekaterinburg"),("584310", "Achikulak", "", "RU", "643", "", "70", "", "", "44.55167", "44.83778", "Europe/Moscow"),("584441", "Abinsk", "Абинск", "RU", "643", "", "38", "", "", "44.86803", "38.15728", "Europe/Moscow"),("584471", "Abdulino", "Абдулино", "RU", "643", "", "55", "", "", "53.7", "53.66667", "Asia/Yekaterinburg"),("611182", "Vasil’yevo", "Васильево", "RU", "643", "", "73", "Zelenodol'skiy Rayon", "", "55.83595", "48.6582", "Europe/Moscow"),("695019", "Ryl’sk", "Рыльск", "RU", "643", "", "41", "", "", "51.5655", "34.6822", "Europe/Moscow"),("795067", "Gedzhukh", "", "RU", "643", "", "17", "", "", "42.12786", "48.06474", "Europe/Moscow"),("795235", "Vidyayevo", "", "RU", "643", "", "49", "", "", "69.31914", "32.80488", "Europe/Moscow"),("795243", "Snezhnogorsk", "", "RU", "643", "", "49", "", "", "69.19333", "33.25314", "Europe/Moscow"),("797213", "Pervomayskoye", "", "RU", "643", "", "17", "", "", "43.91904", "46.71019", "Europe/Moscow"),("797411", "Stepnoye", "", "RU", "643", "", "70", "", "", "44.27083", "44.585", "Europe/Moscow"),("797781", "Neftekumsk", "Нефтекумск", "RU", "643", "", "70", "", "", "44.75583", "44.9925", "Europe/Moscow"),("802078", "Alagir", "Алагир", "RU", "643", "", "68", "", "", "43.04222", "44.22222", "Europe/Moscow"),("802714", "Persianovka", "Персиановский", "RU", "643", "", "61", "", "", "47.52972", "39.41833", "Europe/Moscow"),("802799", "Alkhan-Churt", "", "RU", "643", "", "19", "", "", "43.35194", "44.78694", "Europe/Moscow"),("802921", "Novyy Khushet", "", "RU", "643", "", "17", "", "", "42.89941", "47.5604", "Europe/Moscow"),("805755", "Yasnaya Polyana", "", "RU", "643", "", "70", "", "", "44.0225", "42.7539", "Europe/Moscow"),("805775", "Borisovka", "", "RU", "643", "", "09", "", "", "50.62361", "35.99028", "Europe/Moscow"),("818487", "Vorotynsk", "", "RU", "643", "", "25", "", "", "54.42828", "36.04646", "Europe/Moscow"),("819552", "Annino", "Аннино", "RU", "643", "", "47", "", "", "55.58316", "37.26019", "Europe/Moscow"),("819827", "Razvilka", "", "RU", "643", "", "47", "", "", "55.59209", "37.74085", "Europe/Moscow"),("821801", "Dubovka", "", "RU", "643", "", "76", "", "", "53.95223", "38.06276", "Europe/Moscow"),("823674", "Dagomys", "Дагомыс", "RU", "643", "", "38", "", "", "43.66974", "39.66863", "Europe/Moscow"),("824070", "Bugry", "", "RU", "643", "", "42", "", "", "60.07121", "30.39225", "Europe/Moscow"),("824366", "Krasnoarmeyskoye", "", "RU", "643", "", "65", "", "", "52.71942", "50.03294", "Europe/Samara"),("825035", "Korkmaskala", "", "RU", "643", "", "17", "", "", "43.02379", "47.29436", "Europe/Moscow"),("827329", "Pavlovo", "Павлово", "RU", "643", "", "51", "", "", "55.9686", "43.0912", "Europe/Moscow"),("828055", "Belidzhi", "Белиджи", "RU", "643", "", "17", "", "", "41.89184", "48.41247", "Europe/Moscow"),("828218", "Zaozërsk", "", "RU", "643", "", "49", "", "", "69.40052", "32.44761", "Europe/Moscow"),("829005", "Lesnoy", "Лесной", "RU", "643", "", "71", "", "", "58.63667", "59.80222", "Asia/Yekaterinburg"),("829032", "Kondratovo", "", "RU", "643", "", "90", "", "", "57.9804", "56.1066", "Asia/Yekaterinburg"),("830844", "Trëkhgornyy", "Трёхгорный", "RU", "643", "RU", "13", "", "", "54.815", "58.45917", "Asia/Yekaterinburg"),("831129", "Mirnyy", "Мирный", "RU", "643", "", "06", "", "", "62.76409", "40.33746", "Europe/Moscow"),("831130", "Znamensk", "Капустин Яр", "RU", "643", "", "07", "", "", "48.5842", "45.7338", "Europe/Astrakhan"),("831137", "Svetlyy", "", "RU", "643", "", "67", "", "", "51.6737", "45.63054", "Europe/Volgograd"),("831140", "Zvëzdnyy", "", "RU", "643", "RU", "90", "", "", "57.7325", "56.31472", "Asia/Yekaterinburg"),("831165", "Zarechnyy", "Заречный", "RU", "643", "", "57", "", "", "53.13333", "46.58333", "Europe/Moscow"),("831208", "Ozërnyy", "", "RU", "643", "", "77", "", "", "57.9", "33.65", "Europe/Moscow"),("840909", "Dvubratskiy", "", "RU", "643", "", "38", "", "", "45.23888", "39.80499", "Europe/Moscow"),("841006", "Kochubeyevskoye", "Кочубеевское", "RU", "643", "", "70", "", "", "44.64417", "41.84528", "Europe/Moscow"),("857689", "Vnukovo", "Внуково", "RU", "643", "", "48", "490968", "473021", "55.61194", "37.29611", "Europe/Moscow"),("857690", "Moskovskiy", "Московский", "RU", "643", "", "48", "8520892", "", "55.59911", "37.35495", "Europe/Moscow"),("858701", "Shamil’kala", "", "RU", "643", "", "17", "", "", "42.68581", "46.86393", "Europe/Moscow"),("858712", "Novyy Sulak", "", "RU", "643", "", "17", "", "", "43.21239", "46.81426", "Europe/Moscow"),("863061", "Usinsk", "Усинск", "RU", "643", "", "34", "", "", "65.99389", "57.52806", "Europe/Moscow"),("865321", "Khankala", "", "RU", "643", "", "12", "", "", "43.30212", "45.75564", "Europe/Moscow"),("866053", "Novyye Lapsary", "", "RU", "643", "", "16", "", "", "56.0685", "47.2142", "Europe/Moscow"),("866054", "Raduzhnyy", "", "RU", "643", "", "33", "", "", "59.48333", "49.65", "Europe/Moscow"),("866055", "Priladozhskiy", "", "RU", "643", "", "42", "", "", "59.85", "31.48333", "Europe/Moscow"),("866057", "Molochnyy", "", "RU", "643", "", "49", "", "", "68.85389", "33.02046", "Europe/Moscow"),("866062", "Iskateley", "", "RU", "643", "", "50", "", "", "67.68026", "53.15117", "Europe/Moscow"),("866241", "Myskhako", "", "RU", "643", "", "38", "", "", "44.67139", "37.74333", "Europe/Moscow"),("867005", "Petra-Dubrava", "", "RU", "643", "", "65", "", "", "53.29613", "50.36554", "Europe/Samara"),("867006", "Povolzhskiy", "", "RU", "643", "", "65", "", "", "53.5854", "49.7629", "Europe/Samara"),("867425", "Verkhnebakanskiy", "", "RU", "643", "", "38", "", "", "44.84917", "37.65722", "Europe/Moscow"),("868355", "Kochubey", "", "RU", "643", "", "17", "", "", "44.38611", "46.5825", "Europe/Moscow"),("869342", "Tyube", "", "RU", "643", "", "17", "", "", "43.04926", "47.30742", "Europe/Moscow"),("869345", "Novyy Chirkey", "", "RU", "643", "", "17", "", "", "43.16205", "47.05585", "Europe/Moscow"),("873901", "Obukhovo", "Обухово", "RU", "643", "", "66", "", "", "59.84389", "30.45111", "Europe/Moscow"),("874034", "Galashki", "", "RU", "643", "", "19", "", "", "43.1174", "44.99055", "Europe/Moscow"),("874045", "Staryy Malgobek", "Старый Малгобек", "RU", "643", "", "19", "", "", "43.54437", "44.59592", "Europe/Moscow"),("1484871", "Krasnobrodskiy", "", "RU", "643", "", "29", "", "", "54.1581", "86.4486", "Asia/Novokuznetsk"),("1484892", "Zyryanskoye", "", "RU", "643", "", "75", "", "", "56.83058", "86.62734", "Asia/Tomsk"),("1484923", "Zykovo", "", "RU", "643", "", "91", "", "", "55.95503", "93.16093", "Asia/Krasnoyarsk"),("1485020", "Znamenskoye", "", "RU", "643", "", "54", "", "", "57.12806", "73.82821", "Asia/Omsk"),("1485042", "Zmeinogorsk", "", "RU", "643", "", "04", "", "", "51.15776", "82.19534", "Asia/Barnaul"),("1485193", "Zheleznodorozhnyy", "", "RU", "643", "", "13", "", "", "55.10183", "61.54926", "Asia/Yekaterinburg"),("1485284", "Zelenogorskiy", "", "RU", "643", "", "29", "", "", "55.03333", "87", "Asia/Novokuznetsk"),("1485312", "Zdvinsk", "", "RU", "643", "", "53", "", "", "54.70206", "78.66105", "Asia/Novosibirsk"),("1485339", "Zav’yalovo", "", "RU", "643", "", "04", "", "", "52.83805", "80.9197", "Asia/Barnaul"),("1485357", "Zavodoukovsk", "Заводоуковск", "RU", "643", "", "78", "", "", "56.5042", "66.55153", "Asia/Yekaterinburg"),("1485439", "Zarinsk", "Заринск", "RU", "643", "", "04", "", "", "53.7074", "84.9493", "Asia/Barnaul"),("1485445", "Zarechnyy", "Заречный", "RU", "643", "", "71", "", "", "56.811", "61.3254", "Asia/Yekaterinburg"),("1485528", "Zalesovo", "", "RU", "643", "", "04", "", "", "53.99389", "84.74306", "Asia/Barnaul"),("1485627", "Yuzhnyy", "Южный", "RU", "643", "", "04", "", "", "53.25417", "83.69361", "Asia/Barnaul"),("1485634", "Yuzhnoural’sk", "Южноуральск", "RU", "643", "", "13", "", "", "54.4418", "61.2536", "Asia/Yekaterinburg"),("1485680", "Yurty", "", "RU", "643", "", "20", "", "", "56.0498", "97.6348", "Asia/Irkutsk"),("1485721", "Yurgamysh", "", "RU", "643", "", "40", "", "", "55.37454", "64.46222", "Asia/Yekaterinburg"),("1485724", "Yurga", "Юрга", "RU", "643", "", "29", "", "", "55.72306", "84.88611", "Asia/Novokuznetsk"),("1485849", "Yetkul’", "", "RU", "643", "", "13", "", "", "54.8221", "61.588", "Asia/Yekaterinburg"),("1485904", "Yermakovskoye", "", "RU", "643", "", "91", "", "", "53.27545", "92.40021", "Asia/Krasnoyarsk"),("1485997", "Yeniseysk", "Енисейск", "RU", "643", "", "91", "", "", "58.44937", "92.17968", "Asia/Krasnoyarsk"),("1486031", "Yemel’yanovo", "", "RU", "643", "", "91", "", "", "56.16776", "92.67539", "Asia/Krasnoyarsk"),("1486039", "Yemanzhelinsk", "Еманжелинск", "RU", "643", "", "13", "", "", "54.75472", "61.32083", "Asia/Yekaterinburg"),("1486164", "Yelanskiy", "", "RU", "643", "", "71", "", "", "56.8419", "62.5014", "Asia/Yekaterinburg"),("1486209", "Yekaterinburg", "Екатеринбург", "RU", "643", "", "71", "", "", "56.8519", "60.6122", "Asia/Yekaterinburg"),("1486261", "Yaya", "", "RU", "643", "", "29", "", "", "56.206", "86.44", "Asia/Novokuznetsk"),("1486298", "Yashkino", "Яшкино", "RU", "643", "", "29", "", "", "55.8736", "85.4265", "Asia/Novokuznetsk"),("1486340", "Yarovoye", "Яровое", "RU", "643", "", "04", "", "", "52.9273", "78.58", "Asia/Barnaul"),("1486369", "Yarkovo", "", "RU", "643", "", "78", "", "", "57.40386", "67.0639", "Asia/Yekaterinburg"),("1486371", "Yarkovo", "", "RU", "643", "", "53", "", "", "54.8056", "82.5989", "Asia/Novosibirsk"),("1486468", "Yalutorovsk", "Ялуторовск", "RU", "643", "", "78", "", "", "56.65358", "66.30057", "Asia/Yekaterinburg"),("1486525", "Yagunovskiy", "", "RU", "643", "", "29", "", "", "55.2828", "85.978", "Asia/Novokuznetsk"),("1486795", "Vostochnyy", "", "RU", "643", "", "71", "", "", "58.79991", "61.81391", "Asia/Yekaterinburg"),("1486910", "Vorkuta", "Воркута", "RU", "643", "", "34", "", "", "67.49884", "64.05253", "Europe/Moscow"),("1486913", "Vorgashor", "Воргашор", "RU", "643", "", "34", "", "", "67.58355", "63.79399", "Europe/Moscow"),("1486983", "Volchikha", "", "RU", "643", "", "04", "", "", "52.01356", "80.35715", "Asia/Barnaul"),("1486984", "Volchansk", "", "RU", "643", "", "71", "", "", "59.9378", "60.081", "Asia/Yekaterinburg"),("1487048", "Vkhodnoy", "", "RU", "643", "", "54", "", "", "54.95181", "73.17108", "Asia/Omsk"),("1487074", "Vishnëvogorsk", "", "RU", "643", "", "13", "", "", "55.9913", "60.6579", "Asia/Yekaterinburg"),("1487086", "Vinzili", "", "RU", "643", "", "78", "", "", "56.95938", "65.7708", "Asia/Yekaterinburg"),("1487112", "Vikulovo", "", "RU", "643", "", "78", "", "", "56.81667", "70.61069", "Asia/Yekaterinburg"),("1487164", "Veseloyarsk", "", "RU", "643", "", "04", "", "", "51.28737", "81.10703", "Asia/Barnaul"),("1487219", "Verkhotur’ye", "", "RU", "643", "", "71", "", "", "58.86271", "60.80536", "Asia/Yekaterinburg"),("1487241", "Verkh-Tula", "", "RU", "643", "", "53", "", "", "54.8839", "82.7762", "Asia/Novosibirsk"),("1487272", "Verkhnyaya Sinyachikha", "", "RU", "643", "", "71", "", "", "57.97604", "61.66733", "Asia/Yekaterinburg"),("1487277", "Verkhnyaya Salda", "Верхняя Салда", "RU", "643", "", "71", "", "", "58.04874", "60.55949", "Asia/Yekaterinburg"),("1487281", "Verkhnyaya Pyshma", "Верхняя Пышма", "RU", "643", "", "71", "", "", "56.97047", "60.58219", "Asia/Yekaterinburg"),("1487394", "Verkhniy Ufaley", "Верхний Уфалей", "RU", "643", "", "13", "", "", "56.0556", "60.2397", "Asia/Yekaterinburg"),("1487504", "Verkh-Neyvinskiy", "", "RU", "643", "", "71", "", "", "57.27013", "60.13762", "Asia/Yekaterinburg"),("1487599", "Verkh-Chebula", "", "RU", "643", "", "29", "", "", "56.03062", "87.62215", "Asia/Novokuznetsk"),("1487615", "Vengerovo", "", "RU", "643", "", "53", "", "", "55.68485", "76.74707", "Asia/Novosibirsk"),("1487764", "Varna", "", "RU", "643", "", "13", "", "", "53.38194", "60.97472", "Asia/Yekaterinburg"),("1487784", "Vargashi", "", "RU", "643", "", "40", "", "", "55.35556", "65.84667", "Asia/Yekaterinburg"),("1487882", "Uzhur", "Ужур", "RU", "643", "", "91", "", "", "55.31246", "89.83301", "Asia/Krasnoyarsk"),("1487922", "Uyar", "", "RU", "643", "", "91", "", "", "55.8118", "94.3247", "Asia/Krasnoyarsk"),("1487933", "Uvel’skiy", "", "RU", "643", "", "13", "", "", "54.4446", "61.3574", "Asia/Yekaterinburg"),("1488200", "Ust’-Kalmanka", "", "RU", "643", "", "04", "", "", "52.1207", "83.305", "Asia/Barnaul"),("1488235", "Ust’-Charyshskaya Pristan’", "", "RU", "643", "", "04", "", "", "52.3934", "83.6635", "Asia/Barnaul"),("1488253", "Zelenogorsk", "Зеленогорск", "RU", "643", "", "91", "", "", "56.1124", "94.5985", "Asia/Krasnoyarsk"),("1488272", "Ust’-Abakan", "", "RU", "643", "", "31", "", "", "53.83651", "91.39077", "Asia/Krasnoyarsk"),("1488414", "Urengoy", "", "RU", "643", "", "87", "", "", "65.9655", "78.36929", "Asia/Yekaterinburg"),("1488429", "Uray", "Урай", "RU", "643", "", "32", "", "", "60.13044", "64.78896", "Asia/Yekaterinburg"),("1488465", "Uporovo", "", "RU", "643", "", "78", "", "", "56.31093", "66.26926", "Asia/Yekaterinburg"),("1488708", "Ubinskoye", "", "RU", "643", "", "53", "", "", "55.30675", "79.68016", "Asia/Novosibirsk"),("1488741", "Tyumentsevo", "", "RU", "643", "", "04", "", "", "53.3224", "81.498", "Asia/Barnaul"),("1488754", "Tyumen", "Тюмень", "RU", "643", "", "78", "", "", "57.15222", "65.52722", "Asia/Yekaterinburg"),("1488774", "Tyukhtet", "", "RU", "643", "", "91", "", "", "56.53939", "89.31221", "Asia/Krasnoyarsk"),("1488780", "Tyukalinsk", "", "RU", "643", "", "54", "", "", "55.87321", "72.19673", "Asia/Omsk"),("1488838", "Tyazhinskiy", "", "RU", "643", "", "29", "", "", "56.11607", "88.52279", "Asia/Novokuznetsk"),("1488920", "Turochak", "", "RU", "643", "", "03", "", "", "52.2576", "87.1224", "Asia/Omsk"),("1488931", "Turinskaya Sloboda", "", "RU", "643", "", "71", "", "", "57.6232", "64.38575", "Asia/Yekaterinburg"),("1488933", "Turinsk", "Туринск", "RU", "643", "", "71", "", "", "58.04575", "63.69605", "Asia/Yekaterinburg"),("1488950", "Turan", "", "RU", "643", "", "79", "", "", "52.1449", "93.91887", "Asia/Krasnoyarsk"),("1489057", "Tugulym", "", "RU", "643", "", "71", "", "", "57.05906", "64.64251", "Asia/Yekaterinburg"),("1489125", "Tsementnyy", "", "RU", "643", "", "71", "", "", "57.4693", "60.1536", "Asia/Yekaterinburg"),("1489137", "Tselinnoye", "", "RU", "643", "", "40", "", "", "54.50111", "63.67361", "Asia/Yekaterinburg"),("1489138", "Tselinnoye", "", "RU", "643", "", "04", "", "", "53.07822", "85.65363", "Asia/Barnaul"),("1489209", "Troitskoye", "", "RU", "643", "", "04", "", "", "52.9821", "84.6757", "Asia/Barnaul"),("1489218", "Troitskiy", "", "RU", "643", "", "71", "", "", "57.06028", "63.74811", "Asia/Yekaterinburg"),("1489246", "Troitsk", "Троицк", "RU", "643", "", "13", "", "", "54.0979", "61.5773", "Asia/Yekaterinburg"),("1489394", "Topki", "Топки", "RU", "643", "", "29", "", "", "55.2769", "85.6163", "Asia/Novokuznetsk"),("1489398", "Topchikha", "", "RU", "643", "", "04", "", "", "52.8192", "83.1185", "Asia/Barnaul"),("1489425", "Tomsk", "Томск", "RU", "643", "", "75", "1489419", "", "56.49771", "84.97437", "Asia/Tomsk"),("1489499", "Togur", "", "RU", "643", "", "75", "", "", "58.3631", "82.8265", "Asia/Tomsk"),("1489508", "Toguchin", "Тогучин", "RU", "643", "", "53", "", "", "55.23528", "84.38583", "Asia/Novosibirsk"),("1489530", "Tobol’sk", "Тобольск", "RU", "643", "", "78", "", "", "58.19807", "68.25457", "Asia/Yekaterinburg"),("1489554", "Tisul’", "", "RU", "643", "", "29", "", "", "55.76173", "88.31228", "Asia/Novokuznetsk"),("1489597", "Timiryazevskoye", "", "RU", "643", "", "75", "", "", "56.48988", "84.87795", "Asia/Tomsk"),("1489661", "Tevriz", "", "RU", "643", "", "54", "", "", "57.509", "72.4042", "Asia/Omsk"),("1489853", "Tazovskiy", "", "RU", "643", "", "87", "", "", "67.4715", "78.7162", "Asia/Yekaterinburg"),("1489863", "Tayzhina", "", "RU", "643", "", "29", "", "", "53.6679", "87.4362", "Asia/Novokuznetsk"),("1489870", "Tayshet", "Тайшет", "RU", "643", "", "20", "", "", "55.9342", "98.0044", "Asia/Irkutsk"),("1489907", "Tayga", "Тайга", "RU", "643", "", "29", "", "", "56.06402", "85.62238", "Asia/Novokuznetsk"),("1489938", "Tavricheskoye", "", "RU", "643", "", "54", "", "", "54.58508", "73.6395", "Asia/Omsk"),("1489962", "Tavda", "Тавда", "RU", "643", "", "71", "", "", "58.04254", "65.27258", "Asia/Yekaterinburg"),("1490003", "Tatarsk", "Татарск", "RU", "643", "", "53", "", "", "55.21903", "75.98283", "Asia/Novosibirsk"),("1490036", "Tashtyp", "", "RU", "643", "", "31", "", "", "52.79542", "89.89477", "Asia/Krasnoyarsk"),("1490042", "Tashtagol", "Таштагол", "RU", "643", "", "29", "", "", "52.7657", "87.8894", "Asia/Novokuznetsk"),("1490058", "Taseyevo", "", "RU", "643", "", "91", "", "", "57.21457", "94.89393", "Asia/Krasnoyarsk"),("1490085", "Tarko-Sale", "Тарко-Сале", "RU", "643", "", "87", "", "", "64.91611", "77.77457", "Asia/Yekaterinburg"),("1490140", "Tara", "Тара", "RU", "643", "", "54", "", "", "56.89436", "74.37096", "Asia/Omsk"),("1490256", "Talnakh", "Талнах", "RU", "643", "", "91", "", "", "69.4865", "88.3972", "Asia/Krasnoyarsk"),("1490266", "Tal’menka", "Тальменка", "RU", "643", "", "04", "", "", "53.8183", "83.5677", "Asia/Barnaul"),("1490277", "Talitsa", "Талица", "RU", "643", "", "71", "", "", "56.8804", "60.0213", "Asia/Yekaterinburg"),("1490281", "Talitsa", "Талица", "RU", "643", "", "71", "", "", "57.01095", "63.73254", "Asia/Yekaterinburg"),("1490402", "Sysert’", "Сысерть", "RU", "643", "", "71", "", "", "56.50243", "60.81917", "Asia/Yekaterinburg"),("1490496", "Svetlyy", "", "RU", "643", "", "75", "", "", "56.91667", "85.96667", "Asia/Tomsk"),("1490501", "Svetlyy", "", "RU", "643", "", "55", "", "", "50.81833", "60.85194", "Asia/Yekaterinburg"),("1490551", "Suzun", "Сузун", "RU", "643", "", "53", "", "", "53.7841", "82.3116", "Asia/Novosibirsk"),("1490624", "Surgut", "Сургут", "RU", "643", "", "32", "", "", "61.25", "73.41667", "Asia/Yekaterinburg"),("1490686", "Sukhoy Log", "Сухой Лог", "RU", "643", "", "71", "", "", "56.9094", "62.0296", "Asia/Yekaterinburg"),("1490796", "Strezhevoy", "Стрежевой", "RU", "643", "", "75", "", "", "60.7333", "77.5889", "Asia/Tomsk"),("1490805", "Strelka", "", "RU", "643", "", "91", "", "", "58.07278", "93.03444", "Asia/Krasnoyarsk"),("1491006", "Staroaleyskoye", "", "RU", "643", "", "04", "", "", "51.00611", "82", "Asia/Barnaul"),("1491159", "Sredneuralsk", "Среднеуральск", "RU", "643", "", "71", "", "", "56.98921", "60.46662", "Asia/Yekaterinburg"),("1491219", "Sovetskoye", "", "RU", "643", "", "04", "", "", "52.28556", "85.41424", "Asia/Barnaul"),("1491230", "Sovetskiy", "Советский", "RU", "643", "", "32", "", "", "61.36139", "63.58417", "Asia/Yekaterinburg"),("1491267", "Sos’va", "", "RU", "643", "", "71", "", "", "59.17662", "61.85579", "Asia/Yekaterinburg"),("1491291", "Sosnovoborsk", "Сосновоборск", "RU", "643", "", "91", "", "", "56.1217", "93.3385", "Asia/Krasnoyarsk"),("1491360", "Sorsk", "", "RU", "643", "", "31", "", "", "54.00333", "90.24667", "Asia/Krasnoyarsk"),("1491378", "Sorokino", "", "RU", "643", "", "04", "", "", "53.75", "84.91667", "Asia/Barnaul"),("1491525", "Sokur", "", "RU", "643", "", "53", "", "", "55.2093", "83.319", "Asia/Novosibirsk"),("1491633", "Smolenskoye", "", "RU", "643", "", "04", "", "", "52.30447", "85.0785", "Asia/Barnaul"),("1491706", "Slavgorod", "Славгород", "RU", "643", "", "04", "", "", "52.9978", "78.6449", "Asia/Barnaul"),("1491953", "Shushenskoye", "Шушенское", "RU", "643", "", "91", "", "", "53.325", "91.93556", "Asia/Krasnoyarsk"),("1491999", "Shumikha", "Шумиха", "RU", "643", "", "40", "", "", "55.22611", "63.29611", "Asia/Yekaterinburg"),("1492149", "Shira", "", "RU", "643", "", "31", "", "", "54.49111", "89.95306", "Asia/Krasnoyarsk"),("1492160", "Shipunovo", "", "RU", "643", "", "04", "", "", "52.1582", "82.2173", "Asia/Barnaul"),("1492252", "Sheregesh", "", "RU", "643", "", "29", "", "", "52.9209", "87.9869", "Asia/Novokuznetsk"),("1492255", "Sherbakul’", "", "RU", "643", "", "54", "", "", "54.63159", "72.39635", "Asia/Omsk"),("1492388", "Shatrovo", "", "RU", "643", "", "40", "", "", "56.5197", "64.632", "Asia/Yekaterinburg"),("1492401", "Sharypovo", "Шарыпово", "RU", "643", "", "91", "", "", "55.54028", "89.20083", "Asia/Krasnoyarsk"),("1492499", "Shagonar", "", "RU", "643", "", "79", "", "", "51.53333", "92.8", "Asia/Krasnoyarsk"),("1492517", "Shadrinsk", "Шадринск", "RU", "643", "", "40", "", "", "56.0852", "63.6335", "Asia/Yekaterinburg"),("1492566", "Severo-Yeniseyskiy", "", "RU", "643", "", "91", "", "", "60.37552", "93.03017", "Asia/Krasnoyarsk"),("1492607", "Severnoye", "", "RU", "643", "", "53", "", "", "56.34912", "78.36189", "Asia/Novosibirsk"),("1492663", "Serov", "Серов", "RU", "643", "", "71", "", "", "59.60334", "60.5787", "Asia/Yekaterinburg"),("1492893", "Sayanogorsk", "Саяногорск", "RU", "643", "", "31", "", "", "53.0875", "91.39972", "Asia/Krasnoyarsk"),("1493004", "Sargatskoye", "", "RU", "643", "", "54", "", "", "55.61006", "73.49716", "Asia/Omsk"),("1493110", "Samus’", "", "RU", "643", "", "75", "", "", "56.74482", "84.70422", "Asia/Tomsk"),("1493162", "Salym", "", "RU", "643", "", "32", "", "", "60.0625", "71.47889", "Asia/Yekaterinburg"),("1493197", "Salekhard", "Салехард", "RU", "643", "", "87", "", "", "66.53", "66.60194", "Asia/Yekaterinburg"),("1493224", "Salair", "", "RU", "643", "", "29", "", "", "54.2312", "85.7972", "Asia/Novokuznetsk"),("1493423", "Russkaya Polyana", "", "RU", "643", "", "54", "", "", "53.77944", "73.88056", "Asia/Omsk"),("1493467", "Rubtsovsk", "Рубцовск", "RU", "643", "", "04", "", "", "51.51473", "81.20613", "Asia/Barnaul"),("1493511", "Roza", "", "RU", "643", "", "13", "", "", "54.9163", "61.4586", "Asia/Yekaterinburg"),("1493523", "Rostovka", "", "RU", "643", "", "54", "", "", "55.3842", "71.88913", "Asia/Omsk"),("1493577", "Romanovo", "", "RU", "643", "", "04", "", "", "52.6182", "81.2271", "Asia/Barnaul"),("1493623", "Rodino", "", "RU", "643", "", "04", "", "", "52.49783", "80.20294", "Asia/Barnaul"),("1493648", "Rezh", "Реж", "RU", "643", "", "71", "", "", "57.37005", "61.40428", "Asia/Yekaterinburg"),("1493687", "Reftinskiy", "Рефтинский", "RU", "643", "", "71", "", "", "57.09013", "61.67692", "Asia/Yekaterinburg"),("1493722", "Rebrikha", "", "RU", "643", "", "04", "", "", "53.07333", "82.34083", "Asia/Barnaul"),("1493870", "Pyshma", "", "RU", "643", "", "71", "", "", "56.95226", "63.25129", "Asia/Yekaterinburg"),("1494090", "Promyshlennovskiy", "", "RU", "643", "", "29", "", "", "55.48333", "86.2", "Asia/Novokuznetsk"),("1494091", "Promyshlennaya", "Промышленная", "RU", "643", "", "29", "", "", "54.9159", "85.6385", "Asia/Novokuznetsk"),("1494111", "Prokudskoye", "", "RU", "643", "", "53", "", "", "55.0089", "82.4574", "Asia/Novosibirsk"),("1494114", "Prokop’yevsk", "Прокопьевск", "RU", "643", "", "29", "", "", "53.9059", "86.719", "Asia/Novokuznetsk"),("1494276", "Poykovskiy", "Пойковский", "RU", "643", "", "32", "", "", "61.23333", "73.33333", "Asia/Yekaterinburg"),("1494309", "Potanino", "", "RU", "643", "", "13", "", "", "55.1786", "61.6222", "Asia/Yekaterinburg"),("1494331", "Pospelikha", "", "RU", "643", "", "04", "", "", "51.95", "81.76667", "Asia/Barnaul"),("1494456", "Polysayevo", "Полысаево", "RU", "643", "", "29", "", "", "54.6012", "86.2459", "Asia/Novokuznetsk"),("1494500", "Poltavka", "", "RU", "643", "", "54", "", "", "54.36629", "71.76319", "Asia/Omsk"),("1494523", "Polovinnoye", "", "RU", "643", "", "40", "", "", "54.79139", "65.98639", "Asia/Yekaterinburg"),("1494573", "Polevskoy", "Полевской", "RU", "643", "", "71", "", "", "56.44222", "60.18778", "Asia/Yekaterinburg"),("1494587", "Poletayevo", "", "RU", "643", "", "13", "", "", "55.0336", "61.1138", "Asia/Yekaterinburg"),("1494790", "Podgornoye", "", "RU", "643", "", "75", "", "", "57.78861", "82.65194", "Asia/Tomsk"),("1494907", "Plast", "Пласт", "RU", "643", "", "13", "", "", "54.36914", "60.81361", "Asia/Yekaterinburg"),("1494949", "Pionerskiy", "", "RU", "643", "", "32", "", "", "61.19472", "62.86889", "Asia/Yekaterinburg"),("1494955", "Pioner", "", "RU", "643", "", "29", "", "", "55.3166", "85.9508", "Asia/Novokuznetsk"),("1495022", "Petukhovo", "", "RU", "643", "", "40", "", "", "55.06917", "67.90194", "Asia/Yekaterinburg"),("1495256", "Pervomayskoye", "", "RU", "643", "", "75", "", "", "57.0761", "86.2313", "Asia/Tomsk"),("1495259", "Pervomayskoye", "", "RU", "643", "", "04", "", "", "53.72111", "84.01833", "Asia/Barnaul"),("1495260", "Pervomayskiy", "", "RU", "643", "", "04", "", "", "52.9173", "81.6624", "Asia/Barnaul"),("1495448", "Pavlovsk", "", "RU", "643", "", "04", "", "", "53.31861", "82.98222", "Asia/Barnaul"),("1495480", "Pavlogradka", "", "RU", "643", "", "54", "", "", "54.2024", "73.5592", "Asia/Omsk"),("1495586", "Parabel’", "", "RU", "643", "", "75", "", "", "58.69778", "81.4825", "Asia/Tomsk"),("1495613", "Pankrushikha", "", "RU", "643", "", "04", "", "", "53.83194", "80.34056", "Asia/Barnaul"),("1495626", "Pangody", "", "RU", "643", "", "87", "", "", "65.85002", "74.48593", "Asia/Yekaterinburg"),("1495974", "Osinniki", "Осинники", "RU", "643", "", "29", "", "", "53.6239", "87.3598", "Asia/Novokuznetsk"),("1496100", "Ordynskoye", "", "RU", "643", "", "53", "", "", "54.3656", "81.8994", "Asia/Novosibirsk"),("1496130", "Onguday", "", "RU", "643", "", "03", "", "", "50.75", "86.15", "Asia/Omsk"),("1496142", "Omutinskiy", "", "RU", "643", "", "78", "", "", "56.47453", "67.67087", "Asia/Yekaterinburg"),("1496153", "Omsk", "Омск", "RU", "643", "", "54", "", "", "54.99244", "73.36859", "Asia/Omsk"),("1496329", "Okoneshnikovo", "", "RU", "643", "", "54", "", "", "54.83767", "75.08343", "Asia/Omsk"),("1496380", "Odesskoye", "", "RU", "643", "", "54", "", "", "54.215", "72.9651", "Asia/Omsk"),("1496421", "Ob’", "Обь", "RU", "643", "", "53", "", "", "54.9872", "82.7166", "Asia/Novosibirsk"),("1496476", "Nyagan", "Нягань", "RU", "643", "", "32", "", "", "62.14056", "65.39361", "Asia/Yekaterinburg"),("1496503", "Noyabrsk", "Ноябрьск", "RU", "643", "", "87", "", "", "63.19309", "75.43728", "Asia/Yekaterinburg"),("1496511", "Novyy Urengoy", "Новый Уренгой", "RU", "643", "", "87", "", "", "66.08333", "76.63333", "Asia/Yekaterinburg"),("1496633", "Novovarshavka", "", "RU", "643", "", "54", "", "", "54.1721", "74.6946", "Asia/Omsk"),("1496738", "Novosineglazovskiy", "", "RU", "643", "", "13", "", "", "55.03928", "61.3768", "Asia/Yekaterinburg"),("1496739", "Novosilikatnyy", "Новосиликатный", "RU", "643", "", "04", "", "", "53.30972", "83.62389", "Asia/Barnaul"),("1496747", "Novosibirsk", "Новосибирск", "RU", "643", "", "53", "1496742", "", "55.0415", "82.9346", "Asia/Novosibirsk"),("1496990", "Novokuznetsk", "Новокузнецк", "RU", "643", "", "29", "", "", "53.7557", "87.1099", "Asia/Novokuznetsk"),("1497095", "Novogornyy", "", "RU", "643", "", "13", "", "", "55.63", "60.7919", "Asia/Yekaterinburg"),("1497173", "Novoaltaysk", "Новоалтайск", "RU", "643", "", "04", "", "", "53.3917", "83.9363", "Asia/Barnaul"),("1497210", "Novoagansk", "", "RU", "643", "", "32", "", "", "61.9449", "76.6625", "Asia/Yekaterinburg"),("1497276", "Novaya Lyalya", "", "RU", "643", "", "71", "", "", "59.05503", "60.59899", "Asia/Yekaterinburg"),("1497337", "Norilsk", "Норильск", "RU", "643", "", "91", "", "", "69.3535", "88.2027", "Asia/Krasnoyarsk"),("1497376", "Nizhnyaya Tavda", "", "RU", "643", "", "78", "", "", "57.67306", "66.1725", "Asia/Yekaterinburg"),("1497393", "Nizhnyaya Salda", "Нижняя Салда", "RU", "643", "", "71", "", "", "58.07756", "60.7202", "Asia/Yekaterinburg"),("1497397", "Nizhnyaya Poyma", "", "RU", "643", "", "91", "", "", "56.1643", "97.2065", "Asia/Krasnoyarsk"),("1497406", "Nizhnyaya Omka", "", "RU", "643", "", "54", "", "", "55.43375", "74.94256", "Asia/Omsk"),("1497497", "Nizhniy Ingash", "", "RU", "643", "", "91", "", "", "56.2003", "96.5373", "Asia/Krasnoyarsk"),("1497543", "Nizhnevartovsk", "Нижневартовск", "RU", "643", "", "32", "", "", "60.9344", "76.5531", "Asia/Yekaterinburg"),("1497549", "Nizhneudinsk", "Нижнеудинск", "RU", "643", "", "20", "", "", "54.9076", "99.0276", "Asia/Irkutsk"),("1497795", "Nev’yansk", "Невьянск", "RU", "643", "", "71", "", "", "57.4953", "60.2112", "Asia/Yekaterinburg"),("1497917", "Nefteyugansk", "Нефтеюганск", "RU", "643", "", "32", "", "", "61.09979", "72.60349", "Asia/Yekaterinburg"),("1497932", "Nazyvayevsk", "", "RU", "643", "", "54", "", "", "55.56975", "71.35294", "Asia/Omsk"),("1497951", "Nazarovo", "Назарово", "RU", "643", "", "91", "", "", "56.0104", "90.4011", "Asia/Krasnoyarsk"),("1498067", "Nagornyy", "", "RU", "643", "", "04", "", "", "52.7959", "83.5498", "Asia/Barnaul"),("1498087", "Nadym", "Надым", "RU", "643", "", "87", "", "", "65.53333", "72.51667", "Asia/Yekaterinburg"),("1498129", "Myski", "Мыски", "RU", "643", "", "29", "", "", "53.709", "87.8014", "Asia/Novokuznetsk"),("1498205", "Muromtsevo", "", "RU", "643", "", "54", "", "", "56.37238", "75.24175", "Asia/Omsk"),("1498248", "Mundybash", "", "RU", "643", "", "29", "", "", "53.211", "87.2983", "Asia/Novokuznetsk"),("1498314", "Motygino", "", "RU", "643", "", "91", "", "", "58.18401", "94.69339", "Asia/Krasnoyarsk"),("1498389", "Moshkovo", "", "RU", "643", "", "53", "", "", "55.3053", "83.6104", "Asia/Novosibirsk"),("1498456", "Monetnyy", "", "RU", "643", "", "71", "", "", "57.0472", "60.8794", "Asia/Yekaterinburg"),("1498493", "Molchanovo", "", "RU", "643", "", "75", "", "", "57.58167", "83.76917", "Asia/Tomsk"),("1498633", "Mishkino", "", "RU", "643", "", "40", "", "", "55.33889", "63.9175", "Asia/Yekaterinburg"),("1498693", "Minusinsk", "Минусинск", "RU", "643", "", "91", "", "", "53.71028", "91.6875", "Asia/Krasnoyarsk"),("1498775", "Mikhaylovskoye", "", "RU", "643", "", "04", "", "", "51.82389", "79.71722", "Asia/Barnaul"),("1498887", "Miasskoye", "", "RU", "643", "", "13", "", "", "55.2784", "61.8905", "Asia/Yekaterinburg"),("1498894", "Miass", "Миасс", "RU", "643", "", "13", "", "", "55.045", "60.10833", "Asia/Yekaterinburg"),("1498919", "Mezhdurechenskiy", "", "RU", "643", "", "32", "", "", "59.6", "65.93333", "Asia/Yekaterinburg"),("1498920", "Mezhdurechensk", "Междуреченск", "RU", "643", "", "29", "", "", "53.69417", "88.06028", "Asia/Novokuznetsk"),("1499007", "Mel’nikovo", "", "RU", "643", "", "75", "", "", "56.55738", "84.0835", "Asia/Tomsk"),("1499042", "Melioratorov", "", "RU", "643", "", "78", "", "", "57.21065", "65.60774", "Asia/Yekaterinburg"),("1499053", "Megion", "Мегион", "RU", "643", "", "32", "", "", "61.0296", "76.1136", "Asia/Yekaterinburg"),("1499158", "Mayna", "", "RU", "643", "", "31", "", "", "53.00639", "91.48361", "Asia/Krasnoyarsk"),("1499163", "Mayma", "Майма", "RU", "643", "", "03", "", "", "52.01577", "85.90963", "Asia/Omsk"),("1499247", "Maslyanino", "", "RU", "643", "", "53", "", "", "54.34361", "84.21111", "Asia/Novosibirsk"),("1499350", "Mariinsk", "Мариинск", "RU", "643", "", "29", "", "", "56.21389", "87.74722", "Asia/Novokuznetsk"),("1499428", "Mamontovo", "", "RU", "643", "", "04", "", "", "52.7055", "81.6244", "Asia/Barnaul"),("1499668", "Malysheva", "", "RU", "643", "", "71", "", "", "57.11851", "61.40345", "Asia/Yekaterinburg"),("1500036", "Makushino", "", "RU", "643", "", "40", "", "", "55.21028", "67.24417", "Asia/Yekaterinburg"),("1500125", "Lyubinskiy", "", "RU", "643", "", "54", "", "", "55.15421", "72.69247", "Asia/Omsk"),("1500207", "Luzino", "", "RU", "643", "", "54", "", "", "54.94811", "73.03531", "Asia/Omsk"),("1500426", "Lobva", "", "RU", "643", "", "71", "", "", "59.18538", "60.51846", "Asia/Yekaterinburg"),("1500532", "Linëvo", "Линево", "RU", "643", "", "53", "", "", "54.4589", "83.3764", "Asia/Novosibirsk"),("1500607", "Lesosibirsk", "Новомаклаково", "RU", "643", "", "91", "", "", "58.23583", "92.48278", "Asia/Krasnoyarsk"),("1500609", "Lesogorsk", "", "RU", "643", "", "20", "", "", "56.0458", "99.5136", "Asia/Irkutsk"),("1500629", "Lesnikovo", "", "RU", "643", "", "40", "", "", "55.28222", "65.3175", "Asia/Yekaterinburg"),("1500665", "Leninsk-Kuznetsky", "Ленинск-Кузнецкий", "RU", "643", "", "29", "", "", "54.6567", "86.1737", "Asia/Novokuznetsk"),("1500764", "Lebyazh’ye", "", "RU", "643", "", "40", "", "", "55.26889", "66.49472", "Asia/Yekaterinburg"),("1500933", "Labytnangi", "Лабытнанги", "RU", "643", "", "87", "", "", "66.65722", "66.41833", "Asia/Yekaterinburg"),("1500957", "Kyzyl-Mazhalyk", "", "RU", "643", "", "79", "", "", "51.14594", "90.5808", "Asia/Krasnoyarsk"),("1500973", "Kyzyl", "Кызыл", "RU", "643", "", "79", "", "", "51.71472", "94.45338", "Asia/Krasnoyarsk"),("1500997", "Kyshtym", "Кыштым", "RU", "643", "", "13", "", "", "55.714", "60.5528", "Asia/Yekaterinburg"),("1501000", "Kyshtovka", "", "RU", "643", "", "53", "", "", "56.55498", "76.62713", "Asia/Novosibirsk"),("1501141", "Kuybyshev", "Куйбышев", "RU", "643", "", "53", "", "", "55.44753", "78.32181", "Asia/Novosibirsk"),("1501255", "Kurtamysh", "Куртамыш", "RU", "643", "", "40", "", "", "54.91028", "64.43194", "Asia/Yekaterinburg"),("1501321", "Kurgan", "Курган", "RU", "643", "", "40", "", "", "55.45", "65.33333", "Asia/Yekaterinburg"),("1501356", "Kuragino", "", "RU", "643", "", "91", "", "", "53.88785", "92.68152", "Asia/Krasnoyarsk"),("1501365", "Kupino", "Купино", "RU", "643", "", "53", "", "", "54.36635", "77.29805", "Asia/Novosibirsk"),("1501402", "Kunashak", "", "RU", "643", "", "13", "", "", "55.7032", "61.5498", "Asia/Yekaterinburg"),("1501460", "Kulunda", "Кулунда", "RU", "643", "", "04", "", "", "52.566", "78.9385", "Asia/Barnaul"),("1501690", "Krutinka", "", "RU", "643", "", "54", "", "", "56.0055", "71.51131", "Asia/Omsk"),("1501710", "Krutaya Gorka", "", "RU", "643", "", "54", "", "", "55.36493", "73.2231", "Asia/Omsk"),("1501795", "Krivosheino", "", "RU", "643", "", "75", "", "", "57.34306", "83.92611", "Asia/Tomsk"),("1501803", "Krivodanovka", "", "RU", "643", "", "53", "", "", "55.0881", "82.6551", "Asia/Novosibirsk"),("1501887", "Krasnyy Yar", "", "RU", "643", "", "54", "", "", "55.24242", "72.92635", "Asia/Omsk"),("1501988", "Krasnozërskoye", "", "RU", "643", "", "53", "", "", "53.98277", "79.23735", "Asia/Novosibirsk"),("1502026", "Krasnoyarsk", "Красноярск", "RU", "643", "", "91", "", "", "56.01839", "92.86717", "Asia/Krasnoyarsk"),("1502060", "Krasnoural’sk", "Красноуральск", "RU", "643", "", "71", "", "", "58.3638", "60.0407", "Asia/Yekaterinburg"),("1502061", "Krasnotur’insk", "Краснотурьинск", "RU", "643", "", "71", "", "", "59.7666", "60.2086", "Asia/Yekaterinburg"),("1502063", "Krasnoturansk", "", "RU", "643", "", "91", "", "", "54.31861", "91.56389", "Asia/Krasnoyarsk"),("1502066", "Krasnoshchekovo", "", "RU", "643", "", "04", "", "", "51.67083", "82.72889", "Asia/Barnaul"),("1502091", "Krasnoobsk", "Краснообск", "RU", "643", "", "53", "", "", "54.9198", "82.9909", "Asia/Novosibirsk"),("1502105", "Krasnogorskoye", "", "RU", "643", "", "04", "", "", "52.2953", "86.1979", "Asia/Barnaul"),("1502112", "Krasnogorskiy", "", "RU", "643", "", "13", "", "", "54.6025", "61.231", "Asia/Yekaterinburg"),("1502192", "Krapivinskiy", "", "RU", "643", "", "29", "", "", "54.9992", "86.8133", "Asia/Novokuznetsk"),("1502257", "Kozhevnikovo", "", "RU", "643", "", "75", "", "", "56.25889", "83.97139", "Asia/Tomsk"),("1502387", "Kosikha", "", "RU", "643", "", "04", "", "", "53.36167", "84.58222", "Asia/Barnaul"),("1502422", "Kosh-Agach", "", "RU", "643", "", "03", "", "", "49.99273", "88.67598", "Asia/Omsk"),("1502526", "Kormilovka", "", "RU", "643", "", "54", "", "", "55.00264", "74.10281", "Asia/Omsk"),("1502536", "Korkino", "Коркино", "RU", "643", "", "13", "", "", "54.8913", "61.3969", "Asia/Yekaterinburg"),("1502603", "Kopeysk", "Копейск", "RU", "643", "", "13", "", "", "55.11722", "61.62823", "Asia/Yekaterinburg"),("1502725", "Yugorsk", "Югорск", "RU", "643", "", "32", "", "", "61.31226", "63.33067", "Asia/Yekaterinburg"),("1502822", "Kolyvan’", "", "RU", "643", "", "53", "", "", "55.3053", "82.7391", "Asia/Novosibirsk"),("1502847", "Kol’tsovo", "", "RU", "643", "", "53", "", "", "54.9376", "83.1825", "Asia/Novosibirsk"),("1502862", "Kolpashevo", "Колпашево", "RU", "643", "", "75", "", "", "58.31306", "82.90889", "Asia/Tomsk"),("1502879", "Kolosovka", "", "RU", "643", "", "54", "", "", "56.46779", "73.61096", "Asia/Omsk"),("1503037", "Kodinsk", "Кодинск", "RU", "643", "", "91", "", "", "58.68806", "99.18444", "Asia/Krasnoyarsk"),("1503082", "Kochenëvo", "Коченёво", "RU", "643", "", "53", "", "", "55.0218", "82.202", "Asia/Novosibirsk"),("1503153", "Klyuchi", "", "RU", "643", "", "04", "", "", "52.25303", "79.16868", "Asia/Barnaul"),("1503277", "Kiselëvsk", "Киселевск", "RU", "643", "", "29", "", "", "53.99", "86.6621", "Asia/Novokuznetsk"),("1503335", "Kirovgrad", "Кировград", "RU", "643", "", "71", "", "", "57.42972", "60.05972", "Asia/Yekaterinburg"),("1503726", "Kharp", "", "RU", "643", "", "87", "", "", "66.80139", "65.80806", "Asia/Yekaterinburg"),("1503772", "Khanty-Mansiysk", "Ханты-Мансийск", "RU", "643", "RU", "32", "", "", "61.00417", "69.00194", "Asia/Yekaterinburg"),("1503856", "Khabary", "", "RU", "643", "", "04", "", "", "53.62588", "79.5345", "Asia/Barnaul"),("1503879", "Ketovo", "", "RU", "643", "", "40", "", "", "55.355", "65.32583", "Asia/Yekaterinburg"),("1503901", "Kemerovo", "Кемерово", "RU", "643", "", "29", "", "", "55.33333", "86.08333", "Asia/Novokuznetsk"),("1503940", "Kedrovka", "Кедровка", "RU", "643", "", "29", "", "", "55.53333", "86.05", "Asia/Novokuznetsk"),("1504019", "Kazanskoye", "", "RU", "643", "", "78", "", "", "55.64477", "69.235", "Asia/Yekaterinburg"),("1504139", "Kayyerkan", "Кайеркан", "RU", "643", "", "91", "", "", "69.37861", "87.74389", "Asia/Krasnoyarsk"),("1504212", "Kataysk", "Катайск", "RU", "643", "", "40", "", "", "56.289", "62.5841", "Asia/Yekaterinburg"),("1504251", "Kasli", "Касли", "RU", "643", "", "13", "", "", "55.8909", "60.7616", "Asia/Yekaterinburg"),("1504317", "Kartaly", "Карталы", "RU", "643", "", "13", "", "", "53.05285", "60.64903", "Asia/Yekaterinburg"),("1504343", "Karpinsk", "Карпинск", "RU", "643", "", "71", "", "", "59.7703", "59.9964", "Asia/Yekaterinburg"),("1504380", "Kargat", "", "RU", "643", "", "53", "", "", "55.19556", "80.28111", "Asia/Novosibirsk"),("1504382", "Kargasok", "", "RU", "643", "", "75", "", "", "59.05556", "80.85722", "Asia/Tomsk"),("1504442", "Karatuzskoye", "", "RU", "643", "", "91", "", "", "53.60722", "92.86667", "Asia/Krasnoyarsk"),("1504489", "Karasuk", "Карасук", "RU", "643", "", "53", "", "", "53.73772", "78.04026", "Asia/Novosibirsk"),("1504636", "Karabash", "Карабаш", "RU", "643", "", "13", "", "", "55.4808", "60.2157", "Asia/Yekaterinburg"),("1504682", "Kansk", "Канск", "RU", "643", "", "91", "", "", "56.20167", "95.7175", "Asia/Krasnoyarsk"),("1504769", "Kamyshlov", "Камышлов", "RU", "643", "", "71", "", "", "56.84278", "62.71111", "Asia/Yekaterinburg"),("1504826", "Kamensk-Ural’skiy", "Каменск-Уральский", "RU", "643", "", "71", "", "", "56.4185", "61.9329", "Asia/Yekaterinburg"),("1504871", "Kamen’-na-Obi", "Камень-на-Оби", "RU", "643", "", "04", "", "", "53.7884", "81.3423", "Asia/Barnaul"),("1504972", "Kaltan", "Калтан", "RU", "643", "", "29", "", "", "53.5347", "87.2457", "Asia/Novokuznetsk"),("1505074", "Kalachinsk", "Калачинск", "RU", "643", "", "54", "", "", "55.05286", "74.57511", "Asia/Omsk"),("1505187", "Kaa-Khem", "", "RU", "643", "", "79", "", "", "51.68333", "94.73333", "Asia/Krasnoyarsk"),("1505228", "Izhmorskiy", "", "RU", "643", "", "29", "", "", "56.19239", "86.64161", "Asia/Novokuznetsk"),("1505260", "Ivdel’", "Ивдель-1", "RU", "643", "", "71", "", "", "60.69111", "60.42056", "Asia/Yekaterinburg"),("1505429", "Iskitim", "Искитим", "RU", "643", "", "53", "", "", "54.6366", "83.3045", "Asia/Novosibirsk"),("1505453", "Ishim", "Ишим", "RU", "643", "", "78", "", "", "56.11281", "69.49015", "Asia/Yekaterinburg"),("1505466", "Isetskoye", "", "RU", "643", "", "78", "", "", "56.4858", "65.3226", "Asia/Yekaterinburg"),("1505526", "Irbit", "Ирбит", "RU", "643", "", "71", "", "", "57.67052", "63.071", "Asia/Yekaterinburg"),("1505584", "Inskoy", "", "RU", "643", "", "29", "", "", "54.4297", "86.44", "Asia/Novokuznetsk"),("1505933", "Ilanskiy", "Иланский", "RU", "643", "", "91", "", "", "56.2325", "96.0652", "Asia/Krasnoyarsk"),("1505946", "Ikovka", "", "RU", "643", "", "40", "", "", "55.60889", "64.9375", "Asia/Yekaterinburg"),("1505965", "Igrim", "", "RU", "643", "", "32", "", "", "63.1906", "64.4162", "Asia/Yekaterinburg"),("1505991", "Igarka", "", "RU", "643", "", "91", "", "", "67.4655", "86.6027", "Asia/Krasnoyarsk"),("1505998", "Idrinskoye", "", "RU", "643", "", "91", "", "", "54.37083", "92.13583", "Asia/Krasnoyarsk"),("1506073", "Gur’yevsk", "Гурьевск", "RU", "643", "", "29", "", "", "54.28333", "85.93333", "Asia/Novokuznetsk"),("1506192", "Gramoteino", "", "RU", "643", "", "29", "", "", "54.5368", "86.3839", "Asia/Novokuznetsk"),("1506254", "Gornyy", "", "RU", "643", "", "53", "", "", "55.1153", "83.9059", "Asia/Novosibirsk"),("1506258", "Gornyak", "", "RU", "643", "", "13", "", "", "55.13446", "61.68268", "Asia/Yekaterinburg"),("1506260", "Gornyak", "Горняк", "RU", "643", "", "04", "", "", "50.99417", "81.46611", "Asia/Barnaul"),("1506268", "Gornopravdinsk", "", "RU", "643", "", "32", "", "", "60.05", "69.9", "Asia/Yekaterinburg"),("1506271", "Gorno-Altaysk", "Горно-Алтайск", "RU", "643", "", "03", "11205727", "", "51.96056", "85.91892", "Asia/Krasnoyarsk"),("1506422", "Golyshmanovo", "", "RU", "643", "", "78", "", "", "56.3979", "68.37279", "Asia/Yekaterinburg"),("1507035", "Dzerzhinskoye", "", "RU", "643", "", "91", "", "", "56.83444", "95.22833", "Asia/Krasnoyarsk"),("1507059", "Dvurechensk", "", "RU", "643", "", "71", "", "", "56.5982", "61.0953", "Asia/Yekaterinburg"),("1507116", "Dudinka", "Дудинка", "RU", "643", "", "91", "", "", "69.40583", "86.17778", "Asia/Krasnoyarsk"),("1507172", "Dubinino", "", "RU", "643", "", "91", "", "", "55.61917", "89.09111", "Asia/Krasnoyarsk"),("1507300", "Dolgoderevenskoye", "", "RU", "643", "", "13", "", "", "55.34444", "61.34444", "Asia/Yekaterinburg"),("1507379", "Divnogorsk", "Дивногорск", "RU", "643", "", "91", "", "", "55.9581", "92.3726", "Asia/Krasnoyarsk"),("1507488", "Degtyarsk", "Дегтярск", "RU", "643", "", "71", "", "", "56.704", "60.0879", "Asia/Yekaterinburg"),("1507565", "Dalmatovo", "", "RU", "643", "", "40", "", "", "56.26", "62.9362", "Asia/Yekaterinburg"),("1507636", "Chunskiy", "Чунский", "RU", "643", "", "20", "", "", "56.0815", "99.6342", "Asia/Irkutsk"),("1507679", "Chulym", "", "RU", "643", "", "53", "", "", "55.09972", "80.95722", "Asia/Novosibirsk"),("1507926", "Chesma", "", "RU", "643", "", "13", "", "", "53.81111", "60.65333", "Asia/Yekaterinburg"),("1508054", "Chernogorsk", "Черногорск", "RU", "643", "", "31", "", "", "53.82361", "91.28417", "Asia/Krasnoyarsk"),("1508138", "Cherlak", "", "RU", "643", "", "54", "", "", "54.155", "74.8055", "Asia/Omsk"),("1508161", "Cherepanovo", "Черепаново", "RU", "643", "", "53", "", "", "54.2222", "83.381", "Asia/Novosibirsk"),("1508177", "Cherëmushki", "", "RU", "643", "", "31", "", "", "52.85576", "91.41672", "Asia/Krasnoyarsk"),("1508291", "Chelyabinsk", "Челябинск", "RU", "643", "", "13", "1535932", "", "55.15402", "61.42915", "Asia/Yekaterinburg"),("1508350", "Chebarkul’", "Чебаркуль", "RU", "643", "", "13", "", "", "54.9749", "60.3633", "Asia/Yekaterinburg"),("1508458", "Chany", "", "RU", "643", "", "53", "", "", "55.31205", "76.76468", "Asia/Novosibirsk"),("1508501", "Chadan", "", "RU", "643", "", "79", "", "", "51.28333", "91.58333", "Asia/Krasnoyarsk"),("1508715", "Bulanash", "", "RU", "643", "", "71", "", "", "57.27825", "61.9965", "Asia/Yekaterinburg"),("1508811", "Bredy", "", "RU", "643", "", "13", "", "", "52.41528", "60.34111", "Asia/Yekaterinburg"),("1508879", "Borovskiy", "Боровский", "RU", "643", "", "78", "", "", "57.04096", "65.72018", "Asia/Yekaterinburg"),("1508894", "Borovoy", "", "RU", "643", "", "29", "", "", "55.43333", "86.08333", "Asia/Novokuznetsk"),("1508918", "Borovikha", "", "RU", "643", "", "04", "", "", "53.5072", "83.8379", "Asia/Barnaul"),("1508943", "Borodino", "Бородино", "RU", "643", "", "91", "", "", "55.9061", "94.9079", "Asia/Krasnoyarsk"),("1509494", "Bol’sherech’ye", "", "RU", "643", "", "54", "", "", "56.09252", "74.62716", "Asia/Omsk"),("1509819", "Bolotnoye", "Болотное", "RU", "643", "", "53", "", "", "55.67167", "84.39806", "Asia/Novosibirsk"),("1509844", "Boguchany", "", "RU", "643", "", "91", "", "", "58.38139", "97.45306", "Asia/Krasnoyarsk"),("1509852", "Bogotol", "Боготол", "RU", "643", "", "91", "", "", "56.20778", "89.53417", "Asia/Krasnoyarsk"),("1509888", "Bogdanovich", "Богданович", "RU", "643", "", "71", "", "", "56.78028", "62.04944", "Asia/Yekaterinburg"),("1509902", "Bogandinskiy", "", "RU", "643", "", "78", "", "", "56.89375", "65.89378", "Asia/Yekaterinburg"),("1509929", "Bobrovskiy", "", "RU", "643", "", "71", "", "", "56.6732", "60.9807", "Asia/Yekaterinburg"),("1509999", "Blagoveshchenka", "", "RU", "643", "", "04", "", "", "52.83333", "79.86667", "Asia/Barnaul"),("1510018", "Biysk", "Бийск", "RU", "643", "", "04", "", "", "52.53639", "85.20722", "Asia/Barnaul"),("1510041", "Biryusinsk", "", "RU", "643", "", "20", "", "", "55.9634", "97.8235", "Asia/Irkutsk"),("1510131", "Beya", "", "RU", "643", "", "31", "", "", "53.05333", "90.91389", "Asia/Krasnoyarsk"),("1510203", "Beryozovsky", "Берёзовский", "RU", "643", "", "71", "", "", "56.9083", "60.8019", "Asia/Yekaterinburg"),("1510205", "Berëzovskiy", "Березовский", "RU", "643", "", "29", "", "", "55.6", "86.2", "Asia/Novokuznetsk"),("1510214", "Berëzovo", "", "RU", "643", "", "32", "", "", "63.93806", "65.04194", "Asia/Yekaterinburg"),("1510255", "Berëzovka", "Березовка", "RU", "643", "", "91", "", "", "56.03044", "93.11164", "Asia/Krasnoyarsk"),("1510335", "Beregovoy", "", "RU", "643", "", "54", "", "", "55.17301", "73.21984", "Asia/Omsk"),("1510350", "Berdsk", "Бердск", "RU", "643", "", "53", "", "", "54.7551", "83.0967", "Asia/Novosibirsk"),("1510370", "Belyy Yar", "", "RU", "643", "", "75", "", "", "58.44472", "85.0425", "Asia/Tomsk"),("1510377", "Belyy Yar", "", "RU", "643", "", "31", "", "", "53.60389", "91.39028", "Asia/Krasnoyarsk"),("1510450", "Beloyarskiy", "Белоярский", "RU", "643", "", "32", "", "", "63.71194", "66.67222", "Asia/Yekaterinburg"),("1510451", "Beloyarskiy", "", "RU", "643", "", "71", "", "", "56.7584", "61.4143", "Asia/Yekaterinburg"),("1510454", "Beloyarsk", "", "RU", "643", "", "04", "", "", "53.4461", "83.9048", "Asia/Barnaul"),("1510469", "Belovo", "Белово", "RU", "643", "", "29", "", "", "54.4165", "86.2976", "Asia/Novokuznetsk"),("1510502", "Belokurikha", "", "RU", "643", "", "04", "", "", "51.9959", "84.9896", "Asia/Barnaul"),("1510697", "Baykalovo", "", "RU", "643", "", "71", "", "", "57.39811", "63.76841", "Asia/Yekaterinburg"),("1510709", "Bayevo", "", "RU", "643", "", "04", "", "", "53.27065", "80.77921", "Asia/Barnaul"),("1510821", "Baryshevo", "", "RU", "643", "", "53", "", "", "54.9564", "83.1822", "Asia/Novosibirsk"),("1510842", "Barsovo", "", "RU", "643", "", "32", "", "", "61.16667", "73.16667", "Asia/Yekaterinburg"),("1510853", "Barnaul", "Барнаул", "RU", "643", "", "04", "1535931", "", "53.36056", "83.76361", "Asia/Barnaul"),("1510916", "Barabinsk", "Барабинск", "RU", "643", "", "53", "", "", "55.35709", "78.35697", "Asia/Novosibirsk"),("1510998", "Balakhta", "", "RU", "643", "", "91", "", "", "55.38425", "91.61872", "Asia/Krasnoyarsk"),("1511057", "Bakchar", "", "RU", "643", "", "75", "", "", "57.01861", "82.07111", "Asia/Tomsk"),("1511094", "Bagan", "", "RU", "643", "", "53", "", "", "54.10014", "77.66462", "Asia/Novosibirsk"),("1511103", "Bachatskiy", "", "RU", "643", "", "29", "", "", "54.2927", "86.1285", "Asia/Novokuznetsk"),("1511135", "Azovo", "", "RU", "643", "", "54", "", "", "54.69972", "73.02367", "Asia/Omsk"),("1511304", "Askiz", "", "RU", "643", "", "31", "", "", "53.13194", "90.52639", "Asia/Krasnoyarsk"),("1511309", "Asino", "Асино", "RU", "643", "", "75", "", "", "56.99987", "86.14393", "Asia/Tomsk"),("1511330", "Asbest", "Асбест", "RU", "643", "", "71", "", "", "57.00993", "61.45776", "Asia/Yekaterinburg"),("1511368", "Artëmovskiy", "Артемовский", "RU", "643", "", "71", "", "", "57.3555", "61.86865", "Asia/Yekaterinburg"),("1511381", "Aromashevo", "", "RU", "643", "", "78", "", "", "56.86018", "68.63754", "Asia/Yekaterinburg"),("1511428", "Argayash", "", "RU", "643", "", "13", "", "", "55.4888", "60.8767", "Asia/Yekaterinburg"),("1511466", "Aramil", "Арамиль", "RU", "643", "", "71", "", "", "56.6977", "60.8369", "Asia/Yekaterinburg"),("1511494", "Anzhero-Sudzhensk", "Анжеро-Судженск", "RU", "643", "", "29", "", "", "56.081", "86.0285", "Asia/Novokuznetsk"),("1511538", "Antipino", "", "RU", "643", "", "78", "", "", "57.10679", "65.75755", "Asia/Yekaterinburg"),("1511709", "Alzamay", "", "RU", "643", "", "20", "", "", "55.5562", "98.6644", "Asia/Irkutsk"),("1511736", "Altayskoye", "", "RU", "643", "", "04", "", "", "51.95333", "85.3325", "Asia/Barnaul"),("1511783", "Aleysk", "Алейск", "RU", "643", "", "04", "", "", "52.4926", "82.7822", "Asia/Barnaul"),("1511846", "Aleksandrovskoye", "", "RU", "643", "", "75", "", "", "56.74083", "85.39056", "Asia/Tomsk"),("1511954", "Alapayevsk", "Алапаевск", "RU", "643", "", "71", "", "", "57.85158", "61.69627", "Asia/Yekaterinburg"),("1512064", "Ak-Dovurak", "", "RU", "643", "", "79", "", "", "51.18333", "90.6", "Asia/Krasnoyarsk"),("1512086", "Akademgorodok", "Академгородок", "RU", "643", "", "53", "", "", "54.8523", "83.106", "Asia/Novosibirsk"),("1512102", "Aginskoye", "", "RU", "643", "", "91", "", "", "55.2586", "94.9079", "Asia/Krasnoyarsk"),("1512165", "Achinsk", "Ачинск", "RU", "643", "", "91", "", "", "56.2694", "90.4993", "Asia/Krasnoyarsk"),("1512205", "Abaza", "Абаза", "RU", "643", "", "31", "", "", "52.655", "90.09278", "Asia/Krasnoyarsk"),("1512210", "Abatskoye", "", "RU", "643", "", "78", "", "", "56.28748", "70.45553", "Asia/Yekaterinburg"),("1512218", "Aban", "", "RU", "643", "", "91", "", "", "56.6787", "96.0658", "Asia/Krasnoyarsk"),("1512223", "Abalak", "", "RU", "643", "", "78", "", "", "58.12861", "68.59444", "Asia/Yekaterinburg"),("1512236", "Abakan", "Абакан", "RU", "643", "", "31", "", "", "53.71556", "91.42917", "Asia/Krasnoyarsk"),("1512238", "Abagur", "", "RU", "643", "", "29", "", "", "53.7308", "87.2526", "Asia/Novokuznetsk"),("1536289", "Snezhinsk", "Снежинск", "RU", "643", "", "13", "", "", "56.085", "60.73139", "Asia/Yekaterinburg"),("1536648", "Istok", "", "RU", "643", "", "71", "", "", "56.79086", "60.77889", "Asia/Yekaterinburg"),("1536757", "Priob’ye", "", "RU", "643", "", "32", "", "", "62.52056", "65.59639", "Asia/Yekaterinburg"),("1538634", "Ozersk", "Озёрск", "RU", "643", "", "13", "", "", "55.75556", "60.70278", "Asia/Yekaterinburg"),("1538635", "Zheleznogorsk", "Железногорск", "RU", "643", "", "91", "", "", "56.25111", "93.53194", "Asia/Krasnoyarsk"),("1538636", "Novoural’sk", "Новоуральск", "RU", "643", "", "71", "", "", "57.24389", "60.08389", "Asia/Yekaterinburg"),("1538637", "Seversk", "Северск", "RU", "643", "", "75", "", "", "56.60056", "84.88639", "Asia/Tomsk"),("1538638", "Lokomotivnyy", "", "RU", "643", "", "13", "", "", "53.0118", "60.5684", "Asia/Yekaterinburg"),("1538639", "Solnechnyy", "", "RU", "643", "", "91", "", "", "56.11583", "92.92528", "Asia/Krasnoyarsk"),("1538640", "Svobodnyy", "", "RU", "643", "", "71", "", "", "58.03972", "60.39611", "Asia/Yekaterinburg"),("1538641", "Kedrovyy", "", "RU", "643", "", "91", "", "", "56.28232", "91.5376", "Asia/Krasnoyarsk"),("1538642", "Sibirskiy", "", "RU", "643", "", "04", "", "", "53.5777", "83.7577", "Asia/Barnaul"),("1539209", "Gubkinskiy", "Губкинский", "RU", "643", "", "87", "", "", "64.434", "76.50261", "Asia/Yekaterinburg"),("1539210", "Purpe", "", "RU", "643", "", "87", "", "", "64.48028", "76.68972", "Asia/Yekaterinburg"),("1540356", "Raduzhny", "Радужный", "RU", "643", "", "32", "", "", "62.09611", "77.475", "Asia/Yekaterinburg"),("1540475", "Turtas", "", "RU", "643", "", "78", "", "", "58.93867", "69.13393", "Asia/Yekaterinburg"),("1540711", "Muravlenko", "Муравленко", "RU", "643", "", "87", "", "", "63.78977", "74.52301", "Asia/Yekaterinburg"),("1540852", "Starokamyshinsk", "", "RU", "643", "", "13", "", "", "55.03912", "61.58778", "Asia/Yekaterinburg"),("1540882", "Bazhovo", "", "RU", "643", "", "13", "", "", "55.05955", "61.60445", "Asia/Yekaterinburg"),("1540905", "Roshchino", "", "RU", "643", "", "13", "", "", "55.31012", "61.26363", "Asia/Yekaterinburg"),("1541359", "Lyantor", "Лянтор", "RU", "643", "RU", "32", "", "", "61.61945", "72.15546", "Asia/Yekaterinburg"),("1544583", "Uyskoye", "", "RU", "643", "", "13", "", "", "54.3775", "60.00472", "Asia/Yekaterinburg"),("2012349", "Krasnyy Chikoy", "", "RU", "643", "", "93", "", "", "50.36321", "108.75445", "Asia/Chita"),("2012484", "Zima", "Зима", "RU", "643", "", "20", "", "", "53.9202", "102.0442", "Asia/Irkutsk"),("2012532", "Zhigalovo", "", "RU", "643", "", "20", "", "", "54.81061", "105.15808", "Asia/Irkutsk"),("2012557", "Zheleznogorsk-Ilimskiy", "Железногорск-Илимский", "RU", "643", "", "20", "", "", "56.5768", "104.1217", "Asia/Irkutsk"),("2012561", "Zheleznodorozhnyy", "", "RU", "643", "", "20", "", "", "57.90525", "102.77838", "Asia/Irkutsk"),("2012570", "Zhatay", "", "RU", "643", "", "63", "", "", "62.15975", "129.82843", "Asia/Yakutsk"),("2012593", "Zeya", "Зея", "RU", "643", "", "05", "", "", "53.73601", "127.257", "Asia/Yakutsk"),("2012623", "Zavodskoy", "", "RU", "643", "", "59", "", "", "43.46242", "132.28494", "Asia/Vladivostok"),("2012626", "Zavitinsk", "", "RU", "643", "", "05", "", "", "50.11118", "129.44156", "Asia/Yakutsk"),("2012655", "Zarechnyy", "", "RU", "643", "", "11", "", "", "51.84928", "107.521", "Asia/Irkutsk"),("2012702", "Zalari", "", "RU", "643", "", "20", "", "", "53.5584", "102.5065", "Asia/Irkutsk"),("2012728", "Zakamensk", "", "RU", "643", "", "11", "", "", "50.3741", "103.2863", "Asia/Irkutsk"),("2012735", "Zaigrayevo", "", "RU", "643", "", "11", "", "", "51.83487", "108.267", "Asia/Irkutsk"),("2012780", "Zabaykal’sk", "", "RU", "643", "", "93", "", "", "49.6513", "117.32557", "Asia/Chita"),("2012874", "Ytyk-Kyuyël’", "", "RU", "643", "", "63", "", "", "62.36119", "133.56044", "Asia/Yakutsk"),("2012938", "Yerofey Pavlovich", "", "RU", "643", "", "05", "", "", "53.96305", "121.95805", "Asia/Yakutsk"),("2013032", "Yekaterinoslavka", "", "RU", "643", "", "05", "", "", "50.37344", "129.10957", "Asia/Yakutsk"),("2013089", "Yaroslavskiy", "", "RU", "643", "", "59", "", "", "44.18578", "132.22862", "Asia/Vladivostok"),("2013159", "Yakutsk", "Якутск", "RU", "643", "RU", "63", "Yakutsk (undefined)", "", "62.03389", "129.73306", "Asia/Yakutsk"),("2013225", "Rechka-Vydrino", "", "RU", "643", "", "11", "", "", "51.4892", "104.8429", "Asia/Irkutsk"),("2013226", "Vydreno", "", "RU", "643", "", "11", "", "", "51.463", "104.6425", "Asia/Irkutsk"),("2013229", "Vyazemskiy", "Вяземский", "RU", "643", "", "30", "", "", "47.53757", "134.75556", "Asia/Vladivostok"),("2013258", "Vrangel’", "Врангель", "RU", "643", "", "59", "", "", "42.73021", "133.08322", "Asia/Vladivostok"),("2013272", "Vozdvizhenka", "", "RU", "643", "", "59", "", "", "43.89413", "131.94589", "Asia/Vladivostok"),("2013332", "Vol’no-Nadezhdinskoye", "", "RU", "643", "", "59", "", "", "43.37496", "131.99675", "Asia/Vladivostok"),("2013348", "Vladivostok", "Владивосток", "RU", "643", "", "59", "", "", "43.10562", "131.87353", "Asia/Vladivostok"),("2013362", "Vladimiro-Aleksandrovskoye", "", "RU", "643", "", "59", "", "", "42.89134", "133.07801", "Asia/Vladivostok"),("2013392", "Vilyuysk", "", "RU", "643", "", "63", "Vilyuysky District (undefined)", "", "63.74683", "121.63339", "Asia/Yakutsk"),("2013399", "Vikhorevka", "Вихоревка", "RU", "643", "", "20", "", "", "56.12128", "101.17767", "Asia/Irkutsk"),("2013442", "Vershino-Darasunskiy", "", "RU", "643", "", "93", "", "", "52.36604", "115.52661", "Asia/Chita"),("2013639", "Verkhnevilyuysk", "", "RU", "643", "", "63", "2013638", "", "63.44578", "120.30739", "Asia/Yakutsk"),("2013865", "Ust’-Uda", "", "RU", "643", "", "20", "", "", "54.1742", "103.0304", "Asia/Irkutsk"),("2013894", "Ust’-Ordynskiy", "", "RU", "643", "", "20", "", "", "52.805", "104.75083", "Asia/Irkutsk"),("2013923", "Ust’-Kut", "Усть-Кут", "RU", "643", "", "20", "", "", "56.7938", "105.7672", "Asia/Irkutsk"),("2013952", "Ust’-Ilimsk", "Усть-Илимск", "RU", "643", "", "20", "", "", "58.00056", "102.66194", "Asia/Irkutsk"),("2013986", "Ust’-Barguzin", "", "RU", "643", "", "11", "", "", "53.41116", "109.03103", "Asia/Irkutsk"),("2014006", "Ussuriysk", "Уссурийск", "RU", "643", "", "59", "", "", "43.80291", "131.94578", "Asia/Vladivostok"),("2014022", "Usol’ye-Sibirskoye", "Усолье-Сибирское", "RU", "643", "", "20", "", "", "52.75194", "103.64528", "Asia/Irkutsk"),("2014369", "Ulety", "", "RU", "643", "", "93", "", "", "51.35589", "112.4843", "Asia/Chita"),("2014407", "Ulan-Ude", "Улан-Удэ", "RU", "643", "", "11", "2050912", "", "51.82721", "107.60627", "Asia/Irkutsk"),("2014571", "Uglovoye", "", "RU", "643", "", "59", "", "", "43.32807", "132.08832", "Asia/Vladivostok"),("2014573", "Uglekamensk", "", "RU", "643", "", "59", "", "", "43.21996", "133.23177", "Asia/Vladivostok"),("2014624", "Udachny", "Удачный", "RU", "643", "", "63", "", "", "66.42989", "112.4021", "Asia/Yakutsk"),("2014718", "Tynda", "Тында", "RU", "643", "", "05", "", "", "55.156", "124.72479", "Asia/Yakutsk"),("2014779", "Turuntayevo", "", "RU", "643", "", "11", "", "", "52.20203", "107.64484", "Asia/Irkutsk"),("2014833", "Tura", "", "RU", "643", "", "91", "", "", "64.27769", "100.21849", "Asia/Krasnoyarsk"),("2014927", "Tulun", "Тулун", "RU", "643", "", "20", "", "", "54.56358", "100.58143", "Asia/Irkutsk"),("2015051", "Trudovoye", "Трудовое", "RU", "643", "", "59", "", "", "43.29823", "132.06877", "Asia/Vladivostok"),("2015179", "Tommot", "", "RU", "643", "", "63", "", "", "58.95717", "126.29158", "Asia/Yakutsk"),("2015306", "Tiksi", "", "RU", "643", "", "63", "", "", "71.69002", "128.86467", "Asia/Yakutsk"),("2015310", "Fokino", "Фокино", "RU", "643", "", "59", "", "", "42.97429", "132.40574", "Asia/Vladivostok"),("2015428", "Tayturka", "", "RU", "643", "", "20", "", "", "52.86917", "103.46083", "Asia/Irkutsk"),("2015455", "Tavrichanka", "", "RU", "643", "", "59", "", "", "43.32551", "131.86264", "Asia/Vladivostok"),("2015608", "Tambovka", "", "RU", "643", "", "05", "", "", "50.09968", "128.05724", "Asia/Yakutsk"),("2015686", "Talakan", "", "RU", "643", "", "05", "", "", "50.26378", "130.26755", "Asia/Yakutsk"),("2015701", "Taksimo", "", "RU", "643", "", "11", "", "", "56.34162", "114.90048", "Asia/Irkutsk"),("2015833", "Svobodnyy", "Свободный", "RU", "643", "", "05", "", "", "51.37525", "128.14097", "Asia/Yakutsk"),("2015842", "Svirsk", "", "RU", "643", "", "20", "", "", "53.08583", "103.3325", "Asia/Irkutsk"),("2015913", "Suntar", "", "RU", "643", "", "63", "", "", "62.14444", "117.63194", "Asia/Yakutsk"),("2016110", "Sretensk", "", "RU", "643", "", "93", "undefined = Sretenskiy Rayon", "", "52.2478", "117.70835", "Asia/Chita"),("2016170", "Srednebelaya", "", "RU", "643", "", "05", "", "", "50.65854", "128.00932", "Asia/Yakutsk"),("2016183", "Spasskoye", "", "RU", "643", "", "59", "", "", "44.61215", "132.80007", "Asia/Vladivostok"),("2016187", "Spassk-Dal’niy", "Спасск-Дальний", "RU", "643", "", "59", "", "", "44.59884", "132.82593", "Asia/Vladivostok"),("2016216", "Sosnovo-Ozerskoye", "", "RU", "643", "", "11", "", "", "52.52466", "111.54124", "Asia/Irkutsk"),("2016307", "Solnechnyy", "", "RU", "643", "", "30", "", "", "50.72367", "136.63831", "Asia/Vladivostok"),("2016308", "Solnechnyy", "", "RU", "643", "", "30", "", "", "50.58333", "137.03333", "Asia/Vladivostok"),("2016334", "Sokol", "", "RU", "643", "", "11", "", "", "51.80036", "107.44437", "Asia/Irkutsk"),("2016402", "Smolyaninovo", "", "RU", "643", "", "59", "", "", "43.28801", "132.45586", "Asia/Vladivostok"),("2016412", "Smidovich", "", "RU", "643", "", "89", "", "", "48.59647", "133.80866", "Asia/Vladivostok"),("2016422", "Slyudyanka", "Слюдянка", "RU", "643", "", "20", "", "", "51.65944", "103.70611", "Asia/Irkutsk"),("2016430", "Slavyanka", "", "RU", "643", "", "59", "", "", "42.86413", "131.3882", "Asia/Vladivostok"),("2016443", "Skovorodino", "", "RU", "643", "", "05", "", "", "53.98473", "123.9403", "Asia/Yakutsk"),("2016651", "Shkotovo", "", "RU", "643", "", "59", "", "", "43.32092", "132.35433", "Asia/Vladivostok"),("2016701", "Shimanovsk", "Шимановск", "RU", "643", "", "05", "", "", "52.00575", "127.67756", "Asia/Yakutsk"),("2016708", "Shilka", "", "RU", "643", "", "93", "", "", "51.85", "116.03333", "Asia/Chita"),("2016764", "Shelekhov", "Шелехов", "RU", "643", "", "20", "", "", "52.21389", "104.1", "Asia/Irkutsk"),("2016910", "Severobaykal’sk", "Северобайкальск", "RU", "643", "", "11", "", "", "55.63695", "109.32297", "Asia/Irkutsk"),("2016942", "Seryshevo", "", "RU", "643", "", "05", "", "", "51.09391", "128.38258", "Asia/Yakutsk"),("2016961", "Sergeyevka", "", "RU", "643", "", "59", "", "", "43.34909", "133.35972", "Asia/Vladivostok"),("2017364", "Russkiy", "", "RU", "643", "", "59", "", "", "43.0224", "131.8601", "Asia/Vladivostok"),("2017478", "Razdol’noye", "", "RU", "643", "", "59", "", "", "43.53894", "131.89691", "Asia/Vladivostok"),("2017487", "Raychikhinsk", "Райчихинск", "RU", "643", "", "05", "", "", "49.78998", "129.40992", "Asia/Yakutsk"),("2017646", "Priargunsk", "", "RU", "643", "", "93", "", "", "50.3691", "119.1012", "Asia/Chita"),("2017658", "Preobrazheniye", "", "RU", "643", "", "59", "", "", "42.90117", "133.9043", "Asia/Vladivostok"),("2017705", "Poyarkovo", "", "RU", "643", "", "05", "", "", "49.62678", "128.65352", "Asia/Yakutsk"),("2017824", "Pokrovsk", "", "RU", "643", "", "63", "", "", "61.47768", "129.13699", "Asia/Yakutsk"),("2017838", "Pokrovka", "", "RU", "643", "", "59", "", "", "43.95331", "131.63443", "Asia/Vladivostok"),("2017851", "Pogranichnyy", "", "RU", "643", "", "59", "", "", "44.4097", "131.3778", "Asia/Vladivostok"),("2017912", "Plastun", "", "RU", "643", "", "59", "", "", "44.76077", "136.28048", "Asia/Vladivostok"),("2017945", "Petrovsk-Zabaykal’skiy", "Петровск-Забайкальский", "RU", "643", "", "93", "", "", "51.2753", "108.84301", "Asia/Chita"),("2017979", "Petropavlovka", "", "RU", "643", "", "11", "", "", "50.6114", "105.3196", "Asia/Irkutsk"),("2018021", "Pervomayskiy", "", "RU", "643", "", "93", "", "", "51.67013", "115.62543", "Asia/Chita"),("2018116", "Partizansk", "Партизанск", "RU", "643", "", "59", "", "", "43.12165", "133.12347", "Asia/Vladivostok"),("2018436", "Onokhoy", "", "RU", "643", "", "11", "", "", "51.92859", "108.06693", "Asia/Irkutsk"),("2018498", "Olovyannaya", "", "RU", "643", "", "93", "", "", "50.95", "115.56667", "Asia/Chita"),("2018571", "Olyokminsk", "", "RU", "643", "", "63", "Olyokminsky District (undefined)", "", "60.3743", "120.4203", "Asia/Yakutsk"),("2018735", "Nyurba", "", "RU", "643", "", "63", "Nyurbinsky District (undefined)", "", "63.28417", "118.33194", "Asia/Yakutsk"),("2018864", "Novoshakhtinskiy", "", "RU", "643", "", "59", "", "", "44.02576", "132.16583", "Asia/Vladivostok"),("2018925", "Novokruchininskiy", "", "RU", "643", "", "93", "", "", "51.7836", "113.77591", "Asia/Chita"),("2018964", "Novobureyskiy", "", "RU", "643", "", "05", "", "", "49.79695", "129.87443", "Asia/Yakutsk"),("2019004", "Novaya Igirma", "", "RU", "643", "", "20", "", "", "57.1334", "103.9112", "Asia/Irkutsk"),("2019135", "Nizhniy Kuranakh", "", "RU", "643", "", "63", "", "", "58.8238", "125.52278", "Asia/Yakutsk"),("2019199", "Nizhneangarsk", "", "RU", "643", "", "11", "", "", "55.79326", "109.58029", "Asia/Irkutsk"),("2019309", "Neryungri", "Нерюнгри", "RU", "643", "", "63", "", "", "56.66637", "124.63825", "Asia/Yakutsk"),("2019326", "Nerchinsk", "Нерчинск", "RU", "643", "", "93", "", "", "51.98333", "116.58333", "Asia/Chita"),("2019388", "Nekrasovka", "", "RU", "643", "", "30", "", "", "48.35208", "135.23221", "Asia/Vladivostok"),("2019488", "Namtsy", "", "RU", "643", "", "63", "", "", "62.71959", "129.66722", "Asia/Yakutsk"),("2019528", "Nakhodka", "Находка", "RU", "643", "", "59", "", "", "42.81384", "132.87348", "Asia/Vladivostok"),("2019710", "Mukhorshibir’", "", "RU", "643", "", "11", "", "", "51.04986", "107.82997", "Asia/Irkutsk"),("2019867", "Mokhsogollokh", "", "RU", "643", "", "63", "", "", "61.39619", "128.9381", "Asia/Yakutsk"),("2019892", "Mogoytuy", "", "RU", "643", "", "93", "", "", "51.28333", "114.91667", "Asia/Chita"),("2019912", "Mogocha", "", "RU", "643", "", "93", "", "", "53.73417", "119.76515", "Asia/Chita"),("2019945", "Mishelevka", "", "RU", "643", "", "20", "", "", "52.8575", "103.17194", "Asia/Irkutsk"),("2019951", "Mirny", "Мирный", "RU", "643", "", "63", "", "", "62.53528", "113.96111", "Asia/Yakutsk"),("2020013", "Mikhaylovka", "", "RU", "643", "", "59", "", "", "43.93283", "132.00911", "Asia/Vladivostok"),("2020095", "Meget", "", "RU", "643", "", "20", "", "", "52.415", "104.04944", "Asia/Irkutsk"),("2020121", "Mayya", "", "RU", "643", "", "63", "", "", "61.73824", "130.28161", "Asia/Yakutsk"),("2020208", "Markovo", "", "RU", "643", "", "20", "", "", "57.32056", "107.08806", "Asia/Irkutsk"),("2020221", "Markha", "", "RU", "643", "", "63", "", "", "62.11454", "129.74403", "Asia/Yakutsk"),("2020584", "Magistral’nyy", "", "RU", "643", "", "20", "", "", "56.17148", "107.44166", "Asia/Irkutsk"),("2020591", "Magdagachi", "", "RU", "643", "", "05", "", "", "53.45398", "125.80932", "Asia/Yakutsk"),("2020689", "Luchegorsk", "Лучегорск", "RU", "643", "", "59", "", "", "46.47656", "134.19532", "Asia/Vladivostok"),("2020734", "Livadiya", "", "RU", "643", "", "59", "", "", "42.8682", "132.67367", "Asia/Vladivostok"),("2020752", "Lipovtsy", "", "RU", "643", "", "59", "", "", "44.20018", "131.72373", "Asia/Vladivostok"),("2020812", "Lesozavodsk", "Лесозаводск", "RU", "643", "", "59", "", "", "45.47885", "133.42825", "Asia/Vladivostok"),("2020838", "Lensk", "Ленск", "RU", "643", "", "63", "", "", "60.72528", "114.92778", "Asia/Yakutsk"),("2020841", "Leninskoye", "", "RU", "643", "", "89", "", "", "47.93501", "132.62025", "Asia/Vladivostok"),("2021031", "Kyren", "", "RU", "643", "", "11", "", "", "51.6828", "102.1408", "Asia/Irkutsk"),("2021066", "Kyakhta", "Кяхта", "RU", "643", "", "11", "", "", "50.35737", "106.45033", "Asia/Irkutsk"),("2021093", "Kuytun", "", "RU", "643", "", "20", "", "", "54.34241", "101.50917", "Asia/Irkutsk"),("2021116", "Kutulik", "", "RU", "643", "", "20", "", "", "53.35083", "102.78389", "Asia/Irkutsk"),("2021188", "Kurumkan", "", "RU", "643", "", "11", "", "", "54.32093", "110.30651", "Asia/Irkutsk"),("2021618", "Krasnokamensk", "Краснокаменск", "RU", "643", "", "93", "", "", "50.0979", "118.0369", "Asia/Chita"),("2021766", "Korfovskiy", "", "RU", "643", "", "30", "", "", "48.22259", "135.05966", "Asia/Vladivostok"),("2021799", "Konstantinovka", "", "RU", "643", "", "05", "", "", "49.61876", "127.99025", "Asia/Yakutsk"),("2021851", "Komsomolsk-on-Amur", "Комсомольск-на-Амуре", "RU", "643", "", "30", "", "", "50.55034", "137.00995", "Asia/Vladivostok"),("2021908", "Kokuy", "", "RU", "643", "", "93", "", "", "52.20634", "117.55412", "Asia/Chita"),("2021954", "Knyaze-Volkonskoye", "", "RU", "643", "", "30", "", "", "48.46547", "135.45582", "Asia/Vladivostok"),("2022003", "Kizhinga", "", "RU", "643", "", "11", "", "", "51.8476", "109.90795", "Asia/Irkutsk"),("2022064", "Kirovskiy", "", "RU", "643", "", "59", "", "", "45.09272", "133.50084", "Asia/Vladivostok"),("2022083", "Kirensk", "", "RU", "643", "", "20", "", "", "57.78528", "108.11194", "Asia/Irkutsk"),("2022174", "Khurba", "", "RU", "643", "", "30", "", "", "50.40657", "136.88276", "Asia/Vladivostok"),("2022289", "Khorol’", "", "RU", "643", "", "59", "", "", "44.42631", "132.07638", "Asia/Vladivostok"),("2022304", "Khorinsk", "", "RU", "643", "", "11", "", "", "52.16631", "109.77626", "Asia/Irkutsk"),("2022317", "Khor", "", "RU", "643", "", "30", "", "", "47.88696", "134.9463", "Asia/Vladivostok"),("2022463", "Khilok", "", "RU", "643", "", "93", "", "", "51.36777", "110.46804", "Asia/Chita"),("2022773", "Khandyga", "", "RU", "643", "", "63", "Tomponskiy District (undefined)", "", "62.65333", "135.5667", "Asia/Vladivostok"),("2022890", "Khabarovsk", "Хабаровск", "RU", "643", "", "30", "2022887", "", "48.48271", "135.08379", "Asia/Vladivostok"),("2023058", "Kavalerovo", "Кавалерово", "RU", "643", "", "59", "", "", "44.27221", "135.05227", "Asia/Vladivostok"),("2023094", "Karymskoye", "", "RU", "643", "", "93", "", "", "51.61667", "114.35", "Asia/Chita"),("2023226", "Kamen’-Rybolov", "", "RU", "643", "", "59", "", "", "44.7452", "132.0465", "Asia/Vladivostok"),("2023333", "Kachug", "", "RU", "643", "", "20", "", "", "53.96056", "105.88167", "Asia/Irkutsk"),("2023350", "Kabansk", "", "RU", "643", "", "11", "", "", "52.04861", "106.65278", "Asia/Irkutsk"),("2023377", "Ivolginsk", "", "RU", "643", "", "11", "", "", "51.74919", "107.28374", "Asia/Irkutsk"),("2023469", "Irkutsk", "Иркутск", "RU", "643", "", "20", "2023464", "", "52.29778", "104.29639", "Asia/Irkutsk"),("2023782", "Gusinoozyorsk", "Гусиноозёрск", "RU", "643", "", "11", "", "", "51.28333", "106.5", "Asia/Irkutsk"),("2023918", "Gornyye Klyuchi", "", "RU", "643", "", "59", "", "", "45.24221", "133.50601", "Asia/Vladivostok"),("2024800", "Dunay", "", "RU", "643", "", "59", "", "", "42.87881", "132.33521", "Asia/Vladivostok"),("2024812", "Dul’durga", "", "RU", "643", "", "93", "", "", "50.67611", "113.59306", "Asia/Chita"),("2024893", "Domna", "", "RU", "643", "", "93", "", "", "51.89712", "113.1573", "Asia/Chita"),("2025121", "Darasun", "", "RU", "643", "", "93", "", "", "51.6594", "113.97515", "Asia/Chita"),("2025159", "Dal’nerechensk", "Дальнереченск", "RU", "643", "", "59", "", "", "45.93149", "133.73906", "Asia/Vladivostok"),("2025241", "Churapcha", "", "RU", "643", "", "63", "", "", "61.99858", "132.43341", "Asia/Yakutsk"),("2025261", "Chul’man", "", "RU", "643", "", "63", "", "", "56.84735", "124.90812", "Asia/Yakutsk"),("2025286", "Chuguyevka", "", "RU", "643", "", "59", "", "", "44.16652", "133.86495", "Asia/Vladivostok"),("2025339", "Chita", "Чита", "RU", "643", "", "93", "", "", "52.03171", "113.50087", "Asia/Chita"),("2025456", "Chernyshevskiy", "", "RU", "643", "", "63", "", "", "63.01601", "112.46901", "Asia/Yakutsk"),("2025458", "Chernyshevsk", "", "RU", "643", "", "93", "", "", "52.52209", "117.01712", "Asia/Chita"),("2025489", "Chernigovka", "", "RU", "643", "", "59", "", "", "44.34216", "132.56937", "Asia/Vladivostok"),("2025527", "Cheremkhovo", "Черемхово", "RU", "643", "", "20", "", "", "53.15611", "103.0675", "Asia/Irkutsk"),("2025579", "Chegdomyn", "", "RU", "643", "", "30", "", "", "51.12853", "133.00827", "Asia/Vladivostok"),("2025917", "Bureya", "", "RU", "643", "", "05", "", "", "49.81212", "129.81278", "Asia/Yakutsk"),("2026126", "Borzya", "Борзя", "RU", "643", "", "93", "", "", "50.38333", "116.51667", "Asia/Chita"),("2026160", "Borogontsy", "", "RU", "643", "", "63", "", "", "62.6706", "131.16344", "Asia/Yakutsk"),("2026303", "Bol’shoy Kamen’", "Большой Камень", "RU", "643", "", "59", "", "", "43.11283", "132.354", "Asia/Vladivostok"),("2026544", "Bokhan", "", "RU", "643", "", "20", "", "", "53.153", "103.7714", "Asia/Irkutsk"),("2026583", "Bodaybo", "Бодайбо", "RU", "643", "", "20", "", "", "57.85056", "114.19333", "Asia/Irkutsk"),("2026609", "Blagoveshchensk", "Благовещенск", "RU", "643", "", "05", "", "", "50.27961", "127.5405", "Asia/Yakutsk"),("2026643", "Birobidzhan", "Биробиджан", "RU", "643", "", "89", "", "", "48.79284", "132.92386", "Asia/Vladivostok"),("2026696", "Bikin", "Бикин", "RU", "643", "", "30", "", "", "46.81293", "134.25012", "Asia/Vladivostok"),("2026708", "Bichura", "", "RU", "643", "", "11", "", "", "50.58806", "107.60222", "Asia/Irkutsk"),("2026786", "Berëzovyy", "", "RU", "643", "", "30", "", "", "51.66897", "135.66584", "Asia/Vladivostok"),("2026861", "Berdigestyakh", "", "RU", "643", "", "63", "", "", "62.09842", "126.69573", "Asia/Yakutsk"),("2026895", "Belogorsk", "Белогорск", "RU", "643", "", "05", "", "", "50.91644", "128.47726", "Asia/Yakutsk"),("2026979", "Baykal’sk", "Байкальск", "RU", "643", "", "20", "", "", "51.5151", "104.1402", "Asia/Irkutsk"),("2027109", "Barguzin", "", "RU", "643", "", "11", "", "", "53.61875", "109.63904", "Asia/Irkutsk"),("2027184", "Baley", "", "RU", "643", "", "93", "", "", "51.58166", "116.63395", "Asia/Chita"),("2027275", "Bada", "", "RU", "643", "", "93", "", "", "51.391", "109.86145", "Asia/Chita"),("2027296", "Aykhal", "Айхал", "RU", "643", "", "63", "", "", "65.93381", "111.4834", "Asia/Yakutsk"),("2027373", "Atamanovka", "", "RU", "643", "", "93", "", "", "51.93333", "113.63333", "Asia/Chita"),("2027456", "Artëm", "Артем", "RU", "643", "", "59", "", "", "43.3595", "132.18887", "Asia/Vladivostok"),("2027468", "Arsen’yev", "Арсеньев", "RU", "643", "", "59", "", "", "44.15254", "133.27791", "Asia/Vladivostok"),("2027487", "Arkhara", "", "RU", "643", "", "05", "", "", "49.42447", "130.08569", "Asia/Yakutsk"),("2027667", "Angarsk", "Ангарск", "RU", "643", "", "20", "", "", "52.53667", "103.88639", "Asia/Irkutsk"),("2027740", "Amurzet", "", "RU", "643", "", "89", "", "", "47.69541", "131.09493", "Asia/Vladivostok"),("2027749", "Amursk", "Амурск", "RU", "643", "", "30", "", "", "50.23685", "136.88136", "Asia/Vladivostok"),("2027786", "Amga", "", "RU", "643", "", "63", "", "", "60.90009", "131.97882", "Asia/Yakutsk"),("2027968", "Aldan", "Алдан", "RU", "643", "", "63", "", "", "58.61021", "125.39613", "Asia/Yakutsk"),("2028078", "Aginskoye", "", "RU", "643", "", "93", "2028094", "2028079", "51.1", "114.53", "Asia/Chita"),("2047258", "Novyy Urgal", "", "RU", "643", "", "30", "", "", "51.07089", "132.60075", "Asia/Vladivostok"),("2051471", "Dal'negorsk", "Дальнегорск", "RU", "643", "", "59", "", "", "44.56039", "135.57009", "Asia/Vladivostok"),("2051523", "Bratsk", "Братск", "RU", "643", "", "20", "", "", "56.1325", "101.61417", "Asia/Irkutsk"),("2055166", "Sayansk", "Саянск", "RU", "643", "", "20", "", "", "54.1088", "102.1648", "Asia/Irkutsk"),("2055815", "Kuanda", "", "RU", "643", "", "93", "", "", "56.31611", "116.08056", "Asia/Chita"),("2056752", "Khabarovsk Vtoroy", "Хабаровск Второй", "RU", "643", "", "30", "", "", "48.43776", "135.13329", "Asia/Vladivostok"),("2056881", "Markova", "", "RU", "643", "", "20", "", "", "52.20889", "104.21083", "Asia/Irkutsk"),("2118647", "Vilyuchinsk", "Вилючинск", "RU", "643", "", "92", "", "", "52.9311", "158.40469", "Asia/Kamchatka"),("2119370", "Zavety Il’icha", "", "RU", "643", "", "30", "", "", "49.03737", "140.26989", "Asia/Vladivostok"),("2119441", "Yuzhno-Sakhalinsk", "Южно-Сахалинск", "RU", "643", "", "64", "", "", "46.95407", "142.73603", "Asia/Sakhalin"),("2119447", "Yuzhno-Kurilsk", "", "RU", "643", "JP", "64", "2119443", "", "44.02734", "145.86146", "Asia/Sakhalin"),("2119538", "Yelizovo", "Елизово", "RU", "643", "", "92", "", "", "53.18909", "158.38135", "Asia/Kamchatka"),("2119932", "Vanino", "Ванино", "RU", "643", "", "30", "", "", "49.09848", "140.25313", "Asia/Vladivostok"),("2120048", "Ust-Nera", "", "RU", "643", "", "63", "2122308", "", "64.56968", "143.237", "Asia/Magadan"),("2120261", "Uglegorsk", "", "RU", "643", "", "64", "", "", "49.08047", "142.06449", "Asia/Sakhalin"),("2120334", "Tymovskoye", "", "RU", "643", "", "64", "", "", "50.84925", "142.6652", "Asia/Sakhalin"),("2120864", "Susuman", "", "RU", "643", "", "44", "", "", "62.78075", "148.15396", "Asia/Magadan"),("2121052", "Sovetskaya Gavan’", "Советская Гавань", "RU", "643", "", "30", "", "", "48.97215", "140.28919", "Asia/Vladivostok"),("2121126", "Smirnykh", "", "RU", "643", "", "64", "", "", "49.74596", "142.83716", "Asia/Sakhalin"),("2121367", "Shakhtersk", "", "RU", "643", "", "64", "", "", "49.17175", "142.1364", "Asia/Sakhalin"),("2121909", "Poronaysk", "Поронайск", "RU", "643", "", "64", "", "", "49.22188", "143.09694", "Asia/Sakhalin"),("2122104", "Petropavlovsk-Kamchatsky", "Петропавловск-Камчатский", "RU", "643", "", "92", "", "", "53.04444", "158.65076", "Asia/Kamchatka"),("2122574", "Ola", "", "RU", "643", "", "44", "", "", "59.57823", "151.29819", "Asia/Magadan"),("2122605", "Okhotsk", "", "RU", "643", "", "30", "", "", "59.362", "143.21468", "Asia/Vladivostok"),("2122614", "Okha", "Оха", "RU", "643", "", "64", "", "", "53.58991", "142.95313", "Asia/Sakhalin"),("2122783", "Nogliki", "", "RU", "643", "", "64", "", "", "51.79917", "143.13871", "Asia/Sakhalin"),("2122850", "Nikolayevsk-on-Amure", "Николаевск-на-Амуре", "RU", "643", "", "30", "", "", "53.14657", "140.72287", "Asia/Vladivostok"),("2122894", "Nevel’sk", "Невельск", "RU", "643", "", "64", "", "", "46.67902", "141.85629", "Asia/Sakhalin"),("2123614", "Makarov", "", "RU", "643", "", "64", "", "", "48.62698", "142.77999", "Asia/Sakhalin"),("2123628", "Magadan", "Магадан", "RU", "643", "", "44", "", "", "59.5638", "150.80347", "Asia/Magadan"),("2124286", "Korsakov", "Корсаков", "RU", "643", "", "64", "", "", "46.6342", "142.77722", "Asia/Sakhalin"),("2124440", "Klyuchi", "", "RU", "643", "", "92", "", "", "56.32035", "160.84541", "Asia/Kamchatka"),("2124615", "Kholmsk", "Холмск", "RU", "643", "", "64", "", "", "47.04737", "142.05048", "Asia/Sakhalin"),("2125472", "Gornozavodsk", "", "RU", "643", "", "64", "", "", "46.55984", "141.84358", "Asia/Sakhalin"),("2125945", "Dolinsk", "", "RU", "643", "", "64", "", "", "47.32946", "142.79291", "Asia/Sakhalin"),("2126682", "Bilibino", "", "RU", "643", "", "15", "2126681", "", "68.05464", "166.43721", "Asia/Anadyr"),("2127154", "Aniva", "", "RU", "643", "", "64", "", "", "46.71492", "142.52866", "Asia/Sakhalin"),("2127202", "Anadyr", "", "RU", "643", "", "15", "", "", "64.73424", "177.5103", "Asia/Anadyr"),("2127282", "Aleksandrovsk-Sakhalinskiy", "", "RU", "643", "", "64", "", "", "50.89926", "142.16215", "Asia/Sakhalin"),("2609894", "Yantarnyy", "", "RU", "643", "", "23", "825118", "", "54.87102", "19.94016", "Europe/Kaliningrad"),("2609901", "Mamonovo", "", "RU", "643", "", "23", "", "", "54.46427", "19.93801", "Europe/Kaliningrad"),("2609906", "Baltiysk", "Балтийск", "RU", "643", "", "23", "825118", "", "54.65455", "19.90929", "Europe/Kaliningrad"),("6267009", "Raduzhnyy", "", "RU", "643", "", "33", "", "", "58.49899", "49.64347", "Europe/Kirov"),("6313621", "Magas", "", "RU", "643", "", "19", "", "", "43.22257", "44.77261", "Europe/Moscow"),("6315399", "Isakogorka", "", "RU", "643", "", "06", "", "", "64.446", "40.6531", "Europe/Moscow"),("6417459", "Krasnoznamensk", "Краснознаменск", "RU", "643", "", "47", "", "", "55.59944", "37.03861", "Europe/Moscow"),("6417535", "Mosrentgen", "", "RU", "643", "", "47", "", "", "55.6197", "37.46402", "Europe/Moscow"),("6417635", "Zarech’ye", "", "RU", "643", "", "47", "", "", "55.68667", "37.3924", "Europe/Moscow"),("6418146", "Chertanovo Yuzhnoye", "Чертаново Второе", "RU", "643", "", "48", "", "", "55.59072", "37.59519", "Europe/Moscow"),("6418187", "Sredniy", "", "RU", "643", "", "20", "", "", "52.8884", "103.4904", "Asia/Irkutsk"),("6418201", "Zagor’ye", "", "RU", "643", "", "48", "", "", "55.57657", "37.66709", "Europe/Moscow"),("6418220", "Orekhovo-Borisovo", "Орехово-Борисово", "RU", "643", "", "48", "", "", "55.61252", "37.72639", "Europe/Moscow"),("6418787", "Metrogorodok", "Метрогородок", "RU", "643", "", "48", "", "", "55.80961", "37.78739", "Europe/Moscow"),("6422876", "Novyy", "", "RU", "643", "", "59", "", "", "43.36438", "132.02109", "Asia/Vladivostok"),("6610370", "Chistyye Bory", "", "RU", "643", "", "37", "", "", "58.36472", "41.62778", "Europe/Moscow"),("6610738", "Pervomayskoye", "", "RU", "643", "", "04", "", "", "52.59888", "85.25769", "Asia/Barnaul"),("6695754", "Kogalym", "Когалым", "RU", "643", "", "32", "", "", "62.26537", "74.47906", "Asia/Yekaterinburg"),("6696686", "Pyt-Yakh", "Пыть-Ях", "RU", "643", "", "32", "", "", "60.74985", "72.85824", "Asia/Yekaterinburg"),("6696767", "Langepas", "Лангепас", "RU", "643", "", "32", "", "", "61.25439", "75.2124", "Asia/Yekaterinburg"),("6697077", "Киевский", "", "RU", "643", "", "47", "", "", "55.42999", "36.8666", "Europe/Moscow"),("6730265", "Obolensk", "", "RU", "643", "", "47", "", "", "54.97741", "37.22449", "Europe/Moscow"),("6853140", "Lesnoy", "Лесной", "RU", "643", "", "71", "", "", "57.6198", "63.0784", "Asia/Yekaterinburg"),("6931086", "Peresvet", "", "RU", "643", "", "47", "", "", "56.42302", "38.17612", "Europe/Moscow"),("7117224", "Pribrezhnyy", "", "RU", "643", "", "65", "", "", "53.48662", "49.85836", "Europe/Samara"),("7117880", "Zarya", "Заря", "RU", "643", "", "47", "", "", "55.75533", "38.09578", "Europe/Moscow"),("7117885", "Raduzhnyy", "Радужный", "RU", "643", "", "83", "", "", "56.0038", "40.33905", "Europe/Moscow"),("7287775", "Nizhnesortymskiy", "Нижнесортымский", "RU", "643", "", "32", "", "", "62.43965", "71.76029", "Asia/Yekaterinburg"),("7289676", "Pokachi", "Покачи", "RU", "643", "", "32", "", "", "61.71982", "75.36827", "Asia/Yekaterinburg"),("7290697", "Izluchinsk", "Излучинск", "RU", "643", "", "32", "", "", "60.97944", "76.92421", "Asia/Yekaterinburg"),("7601828", "Noginsk-9", "", "RU", "643", "", "47", "", "", "56.06681", "38.50013", "Europe/Moscow"),("7760366", "Staroye Arakchino", "", "RU", "643", "", "73", "", "", "55.8041", "48.9709", "Europe/Moscow"),("8436165", "Kurortnyy", "", "RU", "643", "", "42", "", "", "60.16562", "29.908", "Europe/Moscow"),("8504946", "Chernaya Rechka", "Черная речка", "RU", "643", "", "42", "", "", "59.98594", "30.30338", "Europe/Moscow"),("8504947", "Untolovo", "Юнтолово", "RU", "643", "", "42", "", "", "60.0122", "30.20897", "Europe/Moscow"),("8504948", "Petrogradka", "Петроградка", "RU", "643", "", "66", "", "", "59.96567", "30.31154", "Europe/Moscow"),("8504949", "Vasyl'evsky Ostrov", "Васильевский остров", "RU", "643", "", "66", "", "", "59.94091", "30.25377", "Europe/Moscow"),("8504950", "Parnas", "Парнас", "RU", "643", "", "42", "", "", "60.06964", "30.3487", "Europe/Moscow"),("8504951", "Kalininskiy", "Калининский", "RU", "643", "", "42", "", "", "59.99675", "30.3899", "Europe/Moscow"),("8504952", "Krasnogvargeisky", "Красногвардейский", "RU", "643", "", "66", "", "", "59.97305", "30.47607", "Europe/Moscow"),("8504953", "Admiralteisky", "Адмиралтейский", "RU", "643", "", "66", "", "", "59.90839", "30.28484", "Europe/Moscow"),("8504955", "Krestovskiy ostrov", "Крестовский остров", "RU", "643", "", "42", "", "", "59.97091", "30.25789", "Europe/Moscow"),("8504958", "Akademicheskoe", "Академическое", "RU", "643", "", "42", "", "", "60.01375", "30.39471", "Europe/Moscow"),("8504959", "Finlyandskiy", "Финляндский", "RU", "643", "", "42", "", "", "59.96824", "30.36415", "Europe/Moscow"),("8504960", "Centralniy", "Центральный", "RU", "643", "", "66", "", "", "59.93111", "30.36072", "Europe/Moscow"),("8504964", "Svetlanovskiy", "Светлановское", "RU", "643", "", "42", "", "", "60.00276", "30.33051", "Europe/Moscow"),("8504965", "Sampsonievskiy", "Сампсониевское", "RU", "643", "", "42", "", "", "59.98499", "30.34295", "Europe/Moscow"),("8505053", "Vostochnoe Degunino", "Восточное Дегунино", "RU", "643", "", "47", "", "", "55.8801", "37.55758", "Europe/Moscow"),("11152665", "LMS", "", "RU", "643", "", "48", "8520893", "", "55.31425", "37.18546", "Europe/Moscow"),("201463", "Rwamagana", "Рвамагана", "RW", "646", "", "11", "51", "5106", "-1.9487", "30.4347", "Africa/Kigali"),("201521", "Musanze", "Рухенгери", "RW", "646", "", "13", "43", "4302", "-1.49984", "29.63497", "Africa/Kigali"),("201865", "Nzega", "", "RW", "646", "", "15", "25", "2503", "-2.479", "29.5564", "Africa/Kigali"),("202061", "Kigali", "Кигали", "RW", "646", "", "12", "11", "1109", "-1.94995", "30.05885", "Africa/Kigali"),("202065", "Kibuye", "Кибуе", "RW", "646", "", "14", "31", "3101", "-2.06028", "29.34778", "Africa/Kigali"),("202068", "Kibungo", "Кибунго", "RW", "646", "", "11", "56", "5605", "-2.1597", "30.5427", "Africa/Kigali"),("202217", "Gitarama", "Гитараме", "RW", "646", "", "15", "27", "2708", "-2.07444", "29.75667", "Africa/Kigali"),("202326", "Cyangugu", "Сиангугу", "RW", "646", "", "14", "36", "3609", "-2.4846", "28.9075", "Africa/Kigali"),("202905", "Gisenyi", "Гисеньи", "RW", "646", "", "14", "", "", "-1.70278", "29.25639", "Africa/Kigali"),("203104", "Byumba", "Биумба", "RW", "646", "", "13", "45", "4503", "-1.5763", "30.0675", "Africa/Kigali"),("203112", "Butare", "Бутаре", "RW", "646", "", "15", "24", "2409", "-2.59667", "29.73944", "Africa/Kigali"),("7062967", "Nyanza", "", "RW", "646", "", "15", "21", "2101", "-2.35187", "29.75089", "Africa/Kigali"),("100425", "Yanbu", "", "SA", "682", "", "05", "", "", "24.08912", "38.06374", "Asia/Riyadh"),("100926", "Umm Lajj", "", "SA", "682", "", "19", "", "", "25.02126", "37.2685", "Asia/Riyadh"),("101035", "Umm as Sāhik", "", "SA", "682", "", "06", "", "", "26.65361", "49.91639", "Asia/Riyadh"),("101312", "Turaif", "", "SA", "682", "", "15", "", "", "31.67252", "38.66374", "Asia/Riyadh"),("101322", "Turabah", "", "SA", "682", "", "14", "", "", "21.21406", "41.6331", "Asia/Riyadh"),("101344", "At Tūbī", "", "SA", "682", "", "06", "", "", "26.55778", "49.99167", "Asia/Riyadh"),("101554", "Tārūt", "", "SA", "682", "", "06", "", "", "26.57332", "50.03694", "Asia/Riyadh"),("101581", "Tanūmah", "", "SA", "682", "", "08", "", "", "27.1", "44.13333", "Asia/Riyadh"),("101628", "Tabuk", "Табук", "SA", "682", "", "19", "", "", "28.3998", "36.57151", "Asia/Riyadh"),("101631", "Ţubarjal", "", "SA", "682", "", "20", "", "", "30.49987", "38.21603", "Asia/Riyadh"),("101633", "Tabālah", "", "SA", "682", "", "11", "", "", "19.95", "42.4", "Asia/Riyadh"),("101760", "Sulţānah", "", "SA", "682", "", "05", "", "", "24.49258", "39.58572", "Asia/Riyadh"),("102318", "Sayhāt", "", "SA", "682", "", "06", "", "", "26.48522", "50.04046", "Asia/Riyadh"),("102451", "Şāmitah", "Самта", "SA", "682", "", "17", "", "", "16.59601", "42.94435", "Asia/Riyadh"),("102527", "Sakakah", "", "SA", "682", "", "20", "", "", "29.96974", "40.20641", "Asia/Riyadh"),("102585", "Şafwá", "", "SA", "682", "", "06", "", "", "26.64986", "49.95223", "Asia/Riyadh"),("102651", "Şabyā", "", "SA", "682", "", "17", "", "", "17.1495", "42.62537", "Asia/Riyadh"),("102985", "Raḩīmah", "", "SA", "682", "", "06", "", "", "26.70791", "50.06194", "Asia/Riyadh"),("103035", "Rābigh", "", "SA", "682", "", "14", "", "", "22.79856", "39.03493", "Asia/Riyadh"),("103369", "Qal‘at Bīshah", "", "SA", "682", "", "11", "", "", "20.00054", "42.6052", "Asia/Riyadh"),("103630", "Najrān", "", "SA", "682", "", "16", "", "", "17.49326", "44.12766", "Asia/Riyadh"),("103922", "Mulayjah", "", "SA", "682", "", "06", "", "", "27.27103", "48.42419", "Asia/Riyadh"),("104269", "Mislīyah", "", "SA", "682", "", "17", "", "", "17.45988", "42.5572", "Asia/Riyadh"),("104376", "Marāt", "", "SA", "682", "", "10", "", "", "25.07007", "45.46147", "Asia/Riyadh"),("104515", "Mecca", "Мекка", "SA", "682", "", "14", "", "", "21.42664", "39.82563", "Asia/Riyadh"),("105072", "Khamis Mushait", "", "SA", "682", "", "11", "", "", "18.3", "42.73333", "Asia/Riyadh"),("105252", "Julayjilah", "", "SA", "682", "", "06", "", "", "25.5", "49.6", "Asia/Riyadh"),("105299", "Jizan", "Джизан", "SA", "682", "", "17", "", "", "16.88917", "42.55111", "Asia/Riyadh"),("105343", "Jeddah", "Джидда", "SA", "682", "", "14", "", "", "21.54238", "39.19797", "Asia/Riyadh"),("106281", "Ha'il", "", "SA", "682", "", "13", "", "", "27.52188", "41.69073", "Asia/Riyadh"),("106744", "Farasān", "", "SA", "682", "", "17", "", "", "16.70222", "42.11833", "Asia/Riyadh"),("106909", "Duba", "Дуба", "SA", "682", "", "19", "", "", "27.35134", "35.69014", "Asia/Riyadh"),("107304", "Buraydah", "", "SA", "682", "", "08", "", "", "26.32599", "43.97497", "Asia/Riyadh"),("107312", "Abqaiq", "", "SA", "682", "", "06", "", "", "25.9371", "49.67761", "Asia/Riyadh"),("107744", "Badr Ḩunayn", "", "SA", "682", "", "05", "", "", "23.78292", "38.79047", "Asia/Riyadh"),("107781", "Az Zulfi", "", "SA", "682", "", "10", "", "", "26.29945", "44.81542", "Asia/Riyadh"),("107797", "Dhahran", "Дахран", "SA", "682", "", "06", "", "", "26.28864", "50.11396", "Asia/Riyadh"),("107959", "Aţ Ţaraf", "", "SA", "682", "", "06", "", "", "25.36276", "49.72504", "Asia/Riyadh"),("107968", "Ta’if", "", "SA", "682", "", "14", "", "", "21.27028", "40.41583", "Asia/Riyadh"),("108048", "As Sulayyil", "", "SA", "682", "", "10", "", "", "20.46067", "45.57792", "Asia/Riyadh"),("108121", "Sājir", "", "SA", "682", "", "10", "", "", "25.18251", "44.59964", "Asia/Riyadh"),("108142", "As Saffānīyah", "", "SA", "682", "SA", "06", "", "", "27.97083", "48.73", "Asia/Riyadh"),("108410", "Riyadh", "Эр-Рияд", "SA", "682", "", "10", "", "", "24.68773", "46.72185", "Asia/Riyadh"),("108435", "Ar Rass", "", "SA", "682", "", "08", "", "", "25.86944", "43.4973", "Asia/Riyadh"),("108512", "Arar", "", "SA", "682", "", "15", "", "", "30.97531", "41.03808", "Asia/Riyadh"),("108617", "An Nimāş", "", "SA", "682", "", "11", "", "", "19.14547", "42.12009", "Asia/Riyadh"),("108648", "Qurayyat", "", "SA", "682", "", "20", "10972289", "", "31.33176", "37.34282", "Asia/Riyadh"),("108773", "Al Wajh", "", "SA", "682", "", "19", "", "", "26.24551", "36.45249", "Asia/Riyadh"),("108841", "Al-`Ula", "Аль-Ула", "SA", "682", "", "05", "", "", "26.60853", "37.92316", "Asia/Riyadh"),("108890", "Al Qurayn", "", "SA", "682", "", "06", "", "", "25.48333", "49.6", "Asia/Riyadh"),("108918", "Qaisumah", "", "SA", "682", "", "06", "", "", "28.31117", "46.12729", "Asia/Riyadh"),("108927", "Al Qaţīf", "Эль-Катиф", "SA", "682", "", "06", "", "", "26.5208", "50.02452", "Asia/Riyadh"),("108957", "Al Qārah", "", "SA", "682", "", "06", "", "", "25.41667", "49.66667", "Asia/Riyadh"),("109008", "Al Muţayrifī", "", "SA", "682", "", "06", "", "", "25.47879", "49.55763", "Asia/Riyadh"),("109059", "Al Munayzilah", "", "SA", "682", "", "06", "", "", "25.38333", "49.66667", "Asia/Riyadh"),("109101", "Al Mubarraz", "", "SA", "682", "", "06", "", "", "25.41", "49.58083", "Asia/Riyadh"),("109118", "Al Mindak", "", "SA", "682", "", "02", "", "", "20.1588", "41.28337", "Asia/Riyadh"),("109131", "Al Mithnab", "", "SA", "682", "", "08", "", "", "25.86012", "44.22228", "Asia/Riyadh"),("109165", "Al Markaz", "", "SA", "682", "", "06", "", "", "25.4", "49.73333", "Asia/Riyadh"),("109223", "Medina", "Медина", "SA", "682", "SA", "05", "", "", "24.46861", "39.61417", "Asia/Riyadh"),("109323", "Khobar", "Эль-Хубар", "SA", "682", "", "06", "", "", "26.27944", "50.20833", "Asia/Riyadh"),("109380", "Al Khafjī", "", "SA", "682", "", "06", "", "", "28.43905", "48.49132", "Asia/Riyadh"),("109417", "Al Jumūm", "", "SA", "682", "", "14", "", "", "21.61694", "39.69806", "Asia/Riyadh"),("109435", "Al Jubayl", "Аль-Джубайль", "SA", "682", "", "06", "", "", "27.01122", "49.65825", "Asia/Riyadh"),("109436", "Al Jubayl", "", "SA", "682", "", "06", "", "", "25.4", "49.65", "Asia/Riyadh"),("109481", "Al Jarādīyah", "", "SA", "682", "", "17", "", "", "16.57946", "42.9124", "Asia/Riyadh"),("109502", "Al Jafr", "", "SA", "682", "", "06", "", "", "25.37694", "49.72361", "Asia/Riyadh"),("109571", "Al Hufūf", "", "SA", "682", "", "06", "", "", "25.36457", "49.56532", "Asia/Riyadh"),("109878", "Al Bukayrīyah", "", "SA", "682", "", "08", "", "", "26.14422", "43.65933", "Asia/Riyadh"),("109915", "Al Baţţālīyah", "", "SA", "682", "", "06", "", "", "25.43333", "49.63333", "Asia/Riyadh"),("109953", "Al Bahah", "", "SA", "682", "", "02", "", "", "20.01288", "41.46767", "Asia/Riyadh"),("110031", "Al Arţāwīyah", "", "SA", "682", "", "10", "", "", "26.50526", "45.34437", "Asia/Riyadh"),("110107", "Al Awjām", "", "SA", "682", "", "06", "", "", "26.56324", "49.94331", "Asia/Riyadh"),("110250", "‘Afīf", "", "SA", "682", "", "10", "", "", "23.9065", "42.91724", "Asia/Riyadh"),("110314", "Ad Dilam", "", "SA", "682", "", "10", "", "", "23.99104", "47.16181", "Asia/Riyadh"),("110325", "Ad Dawādimī", "", "SA", "682", "", "10", "", "", "24.50772", "44.39237", "Asia/Riyadh"),("110328", "Ad Darb", "", "SA", "682", "", "17", "", "", "17.72285", "42.25261", "Asia/Riyadh"),("110336", "Dammam", "Даммам", "SA", "682", "", "06", "", "", "26.43442", "50.10326", "Asia/Riyadh"),("110619", "Abū ‘Arīsh", "", "SA", "682", "", "17", "", "", "16.96887", "42.83251", "Asia/Riyadh"),("110690", "Abha", "Абха", "SA", "682", "", "11", "", "", "18.21639", "42.50528", "Asia/Riyadh"),("392753", "Şuwayr", "", "SA", "682", "", "20", "", "", "30.11713", "40.38925", "Asia/Riyadh"),("396550", "Tumayr", "", "SA", "682", "", "10", "", "", "25.70393", "45.86796", "Asia/Riyadh"),("397513", "Al Fuwayliq", "", "SA", "682", "", "08", "", "", "26.44322", "43.2534", "Asia/Riyadh"),("399518", "Al Majāridah", "", "SA", "682", "", "11", "", "", "19.12361", "41.91111", "Asia/Riyadh"),("409993", "Al Muwayh", "", "SA", "682", "", "14", "", "", "22.43333", "41.75829", "Asia/Riyadh"),("410084", "Al Hadā", "", "SA", "682", "", "14", "", "", "21.36753", "40.28694", "Asia/Riyadh"),("410096", "Ash Shafā", "Аш-Шафа", "SA", "682", "", "14", "", "", "21.0721", "40.31185", "Asia/Riyadh"),("410874", "Mizhirah", "", "SA", "682", "", "17", "", "", "16.82611", "42.73333", "Asia/Riyadh"),("8394316", "Unaizah", "Унайза", "SA", "682", "", "08", "", "", "26.08427", "43.99355", "Asia/Riyadh"),("363417", "Dongola", "", "SD", "736", "", "43", "", "", "19.18163", "30.47689", "Africa/Khartoum"),("363533", "Zalingei", "Залингее", "SD", "736", "", "61", "", "", "12.90918", "23.47058", "Africa/Khartoum"),("364027", "Wagar", "", "SD", "736", "", "52", "", "", "16.1525", "36.2032", "Africa/Khartoum"),("364071", "Wad Rāwah", "", "SD", "736", "", "38", "", "", "15.16028", "33.13972", "Africa/Khartoum"),("364103", "Wad Medani", "", "SD", "736", "", "38", "", "", "14.40118", "33.51989", "Africa/Khartoum"),("364216", "Wad az Zāki", "", "SD", "736", "", "41", "", "", "14.4619", "32.2065", "Africa/Khartoum"),("364706", "Umm Ruwaba", "", "SD", "736", "", "56", "", "", "12.9061", "31.2158", "Africa/Khartoum"),("364933", "Umm Kaddadah", "", "SD", "736", "", "55", "", "", "13.60169", "26.68759", "Africa/Khartoum"),("364949", "Um Jar Al Gharbiyya", "", "SD", "736", "", "41", "", "", "13.8013", "32.4078", "Africa/Khartoum"),("365137", "Omdurman", "Омдурман", "SD", "736", "SD", "29", "", "", "15.64453", "32.47773", "Africa/Khartoum"),("366323", "Tokār", "", "SD", "736", "", "36", "", "", "18.4254", "37.729", "Africa/Khartoum"),("366426", "Tandaltī", "", "SD", "736", "", "41", "", "", "13.01667", "31.86667", "Africa/Khartoum"),("366487", "Talodi", "", "SD", "736", "", "50", "", "", "10.63246", "30.3797", "Africa/Khartoum"),("366847", "Singa", "", "SD", "736", "", "58", "", "", "13.1483", "33.93117", "Africa/Khartoum"),("367308", "Shendi", "", "SD", "736", "", "53", "", "", "16.6915", "33.4341", "Africa/Khartoum"),("367544", "Sawākin", "Савакине", "SD", "736", "", "36", "", "", "19.1059", "37.3321", "Africa/Khartoum"),("367644", "Sinnar", "", "SD", "736", "", "58", "", "", "13.56907", "33.56718", "Africa/Khartoum"),("368277", "Rabak", "", "SD", "736", "", "41", "", "", "13.18087", "32.73999", "Africa/Khartoum"),("369004", "Nyala", "", "SD", "736", "", "49", "", "", "12.04888", "24.88069", "Africa/Khartoum"),("370481", "Merowe", "", "SD", "736", "", "43", "", "", "18.47036", "31.81126", "Africa/Khartoum"),("370510", "Marabba", "", "SD", "736", "", "41", "", "", "12.35", "32.18333", "Africa/Khartoum"),("370838", "Maiurno", "", "SD", "736", "", "58", "", "", "13.41667", "33.66667", "Africa/Khartoum"),("371745", "Kutum", "", "SD", "736", "", "55", "", "", "14.2", "24.66667", "Africa/Khartoum"),("371760", "Kosti", "Кусти", "SD", "736", "", "41", "", "", "13.1629", "32.66347", "Africa/Khartoum"),("371827", "Kurmuk", "", "SD", "736", "", "42", "", "", "10.55", "34.28333", "Africa/Khartoum"),("371870", "Kuraymah", "", "SD", "736", "", "43", "", "", "18.55", "31.85", "Africa/Khartoum"),("372386", "Kināna", "", "SD", "736", "", "58", "", "", "14.0361", "33.1712", "Africa/Khartoum"),("372753", "Kassala", "Кассале", "SD", "736", "", "52", "", "", "15.45099", "36.39998", "Africa/Khartoum"),("373141", "Kadugli", "Кадугли", "SD", "736", "", "50", "", "", "11.01111", "29.71833", "Africa/Khartoum"),("375046", "Gebeit", "", "SD", "736", "", "36", "", "", "21.06667", "36.31667", "Africa/Khartoum"),("375192", "Jalqani", "", "SD", "736", "", "58", "", "", "12.4486", "34.2186", "Africa/Khartoum"),("376332", "Doka", "", "SD", "736", "", "39", "", "", "13.51667", "35.76667", "Africa/Khartoum"),("376450", "Dilling", "Диллинг", "SD", "736", "", "50", "", "", "12.05", "29.65", "Africa/Khartoum"),("377039", "Port Sudan", "Порт-Судан", "SD", "736", "SD", "36", "", "", "19.61745", "37.21644", "Africa/Khartoum"),("377690", "Berber", "", "SD", "736", "", "53", "", "", "18.02158", "33.98299", "Africa/Khartoum"),("377724", "Bārah", "", "SD", "736", "", "56", "11239073", "", "13.7", "30.36667", "Africa/Khartoum"),("378231", "Atbara", "Атбаре", "SD", "736", "", "53", "", "", "17.70217", "33.98638", "Africa/Khartoum"),("378271", "As Sūkī", "", "SD", "736", "", "58", "", "", "13.31667", "33.88333", "Africa/Khartoum"),("378459", "Ar Ruseris", "", "SD", "736", "", "42", "", "", "11.8659", "34.3869", "Africa/Khartoum"),("378493", "Ar Rahad", "", "SD", "736", "", "56", "", "", "12.71667", "30.65", "Africa/Khartoum"),("378502", "Aroma", "", "SD", "736", "", "52", "", "", "15.81667", "36.13333", "Africa/Khartoum"),("378543", "Argo", "", "SD", "736", "", "43", "", "", "19.51667", "30.41667", "Africa/Khartoum"),("378699", "An Nuhūd", "", "SD", "736", "", "62", "", "", "12.7", "28.43333", "Africa/Khartoum"),("379003", "El Obeid", "", "SD", "736", "", "56", "", "", "13.18421", "30.21669", "Africa/Khartoum"),("379014", "Al Qiţena", "", "SD", "736", "", "41", "", "", "14.8648", "32.3668", "Africa/Khartoum"),("379062", "Al Qadarif", "", "SD", "736", "", "39", "", "", "14.03493", "35.38344", "Africa/Khartoum"),("379080", "Al Masallamiyya", "", "SD", "736", "", "38", "", "", "14.5748", "33.3373", "Africa/Khartoum"),("379102", "Al Mijlad", "", "SD", "736", "", "62", "", "", "11.03333", "27.73333", "Africa/Khartoum"),("379127", "El Matama", "", "SD", "736", "", "53", "", "", "16.7095", "33.3565", "Africa/Khartoum"),("379149", "Al Manāqil", "", "SD", "736", "", "38", "", "", "14.2459", "32.9891", "Africa/Khartoum"),("379198", "Al Lagowa", "", "SD", "736", "", "62", "", "", "11.4", "29.13333", "Africa/Khartoum"),("379252", "Khartoum", "Хартум", "SD", "736", "", "29", "", "", "15.55177", "32.53241", "Africa/Khartoum"),("379261", "Al Kiremit al ‘Arakiyyīn", "", "SD", "736", "", "38", "", "", "14.3476", "32.9437", "Africa/Khartoum"),("379272", "Al Kawa", "", "SD", "736", "", "41", "", "", "13.7463", "32.4996", "Africa/Khartoum"),("379303", "Geneina", "", "SD", "736", "", "47", "", "", "13.45262", "22.44725", "Africa/Khartoum"),("379406", "Al Hilāliyya", "", "SD", "736", "", "38", "", "", "14.9398", "33.234", "Africa/Khartoum"),("379416", "Al Ḩawātah", "", "SD", "736", "", "39", "", "", "13.41667", "34.63333", "Africa/Khartoum"),("379427", "Al Hasaheisa", "", "SD", "736", "", "38", "", "", "14.75264", "33.29836", "Africa/Khartoum"),("379535", "Al Fūlah", "", "SD", "736", "", "50", "", "", "11.73292", "28.35786", "Africa/Khartoum"),("379555", "El Fasher", "Эль-Фашир", "SD", "736", "", "55", "", "", "13.62793", "25.34936", "Africa/Khartoum"),("379630", "El Bauga", "", "SD", "736", "", "53", "", "", "18.26197", "33.90812", "Africa/Khartoum"),("380129", "Ad Douiem", "Эд-Дуэйм", "SD", "736", "", "41", "", "", "14.0012", "32.3116", "Africa/Khartoum"),("380148", "El Daein", "", "SD", "736", "", "60", "", "", "11.46186", "26.12583", "Africa/Khartoum"),("380151", "Ad Dindar", "", "SD", "736", "", "58", "", "", "13.2", "34.16667", "Africa/Khartoum"),("380173", "Ed Damer", "", "SD", "736", "", "53", "", "", "17.59898", "33.97205", "Africa/Khartoum"),("380174", "Ad-Damazin", "", "SD", "736", "", "42", "", "", "11.7891", "34.3592", "Africa/Khartoum"),("380186", "Ad Dabbah", "", "SD", "736", "", "43", "", "", "18.05", "30.95", "Africa/Khartoum"),("380348", "Abū Zabad", "", "SD", "736", "", "62", "", "", "12.35", "29.25", "Africa/Khartoum"),("380757", "Abu Jibeha", "", "SD", "736", "", "50", "", "", "11.4562", "31.2285", "Africa/Khartoum"),("11003055", "El Fula", "", "SD", "736", "", "62", "", "", "11.71195", "28.3462", "Africa/Khartoum"),("602150", "Umeå", "Умео", "SE", "752", "", "23", "2480", "", "63.82842", "20.25972", "Europe/Stockholm"),("602913", "Skellefteå", "Шеллефтео", "SE", "752", "", "23", "2482", "", "64.75067", "20.95279", "Europe/Stockholm"),("603570", "Piteå", "Питео", "SE", "752", "", "14", "2581", "", "65.31717", "21.47944", "Europe/Stockholm"),("604419", "Malmberget", "", "SE", "752", "", "14", "2523", "", "67.17529", "20.65495", "Europe/Stockholm"),("604490", "Luleå", "Лулео", "SE", "752", "", "14", "2580", "", "65.58415", "22.15465", "Europe/Stockholm"),("605155", "Kiruna", "Кируна", "SE", "752", "", "14", "2584", "", "67.85572", "20.22513", "Europe/Stockholm"),("605393", "Kalix", "", "SE", "752", "", "14", "2514", "", "65.85298", "23.15645", "Europe/Stockholm"),("605676", "Holmsund", "", "SE", "752", "", "23", "2480", "", "63.70602", "20.36409", "Europe/Stockholm"),("606086", "Gällivare", "", "SE", "752", "", "14", "2523", "", "67.13387", "20.65278", "Europe/Stockholm"),("606531", "Boden", "", "SE", "752", "", "14", "2582", "", "65.82518", "21.68864", "Europe/Stockholm"),("606834", "Älvsbyn", "", "SE", "752", "SE", "14", "2560", "", "65.67624", "21.00162", "Europe/Stockholm"),("2662149", "Ystad", "Истад", "SE", "752", "", "27", "1286", "", "55.42966", "13.82041", "Europe/Stockholm"),("2662689", "Visby", "Висбю", "SE", "752", "", "05", "0980", "", "57.64089", "18.29602", "Europe/Stockholm"),("2662881", "Vimmerby", "", "SE", "752", "", "09", "0884", "", "57.66588", "15.85515", "Europe/Stockholm"),("2663293", "Vetlanda", "", "SE", "752", "", "08", "0685", "", "57.42887", "15.07762", "Europe/Stockholm"),("2663399", "Vellinge", "", "SE", "752", "SE", "27", "1233", "", "55.47124", "13.01971", "Europe/Stockholm"),("2663536", "Växjö", "Векшё", "SE", "752", "", "12", "0780", "", "56.87767", "14.80906", "Europe/Stockholm"),("2664203", "Västervik", "", "SE", "752", "", "09", "0883", "", "57.7584", "16.63733", "Europe/Stockholm"),("2664454", "Västerås", "Вестерос", "SE", "752", "", "25", "1980", "", "59.61617", "16.55276", "Europe/Stockholm"),("2664740", "Vasastan", "", "SE", "752", "", "26", "0180", "", "59.34571", "18.04985", "Europe/Stockholm"),("2664855", "Värnamo", "", "SE", "752", "", "08", "0683", "", "57.18604", "14.04001", "Europe/Stockholm"),("2664939", "Vårgårda", "", "SE", "752", "", "28", "1442", "", "58.03706", "12.80907", "Europe/Stockholm"),("2664996", "Varberg", "Варберг", "SE", "752", "", "06", "1383", "", "57.10557", "12.25078", "Europe/Stockholm"),("2665171", "Vänersborg", "Венерсборг", "SE", "752", "", "28", "1487", "", "58.38075", "12.3234", "Europe/Stockholm"),("2665452", "Vallentuna", "", "SE", "752", "", "26", "0115", "", "59.53436", "18.07758", "Europe/Stockholm"),("2665691", "Valbo", "", "SE", "752", "", "03", "2180", "", "60.65", "17.03333", "Europe/Stockholm"),("2665902", "Vadstena", "", "SE", "752", "", "16", "0584", "", "58.44863", "14.88969", "Europe/Stockholm"),("2666199", "Uppsala", "Уппсала", "SE", "752", "", "21", "0380", "038001", "59.85882", "17.63889", "Europe/Stockholm"),("2666238", "Upplands Väsby", "", "SE", "752", "", "26", "0114", "", "59.51839", "17.91128", "Europe/Stockholm"),("2666493", "Ulricehamn", "", "SE", "752", "", "28", "1491", "", "57.79159", "13.41422", "Europe/Stockholm"),("2666670", "Uddevalla", "Уддевалла", "SE", "752", "", "28", "1485", "", "58.34784", "11.9424", "Europe/Stockholm"),("2667094", "Tumba", "Тумба", "SE", "752", "", "26", "0127", "", "59.19858", "17.83317", "Europe/Stockholm"),("2667109", "Tullinge", "", "SE", "752", "", "26", "0127", "", "59.2", "17.9", "Europe/Stockholm"),("2667303", "Trollhättan", "Трольхеттан", "SE", "752", "", "28", "1488", "", "58.28365", "12.28864", "Europe/Stockholm"),("2667402", "Trelleborg", "Треллеборг", "SE", "752", "", "27", "1287", "", "55.37514", "13.15691", "Europe/Stockholm"),("2667628", "Tranås", "", "SE", "752", "", "08", "0687", "", "58.03717", "14.9782", "Europe/Stockholm"),("2667809", "Torslanda", "", "SE", "752", "", "28", "1480", "", "57.72432", "11.77013", "Europe/Stockholm"),("2667847", "Torshälla", "", "SE", "752", "", "18", "0484", "", "59.41667", "16.46667", "Europe/Stockholm"),("2668365", "Tomelilla", "", "SE", "752", "", "27", "1270", "", "55.54293", "13.9546", "Europe/Stockholm"),("2669047", "Timrå", "", "SE", "752", "", "24", "2262", "226201", "62.48654", "17.32613", "Europe/Stockholm"),("2669098", "Tierp", "", "SE", "752", "", "21", "0360", "", "60.34269", "17.51812", "Europe/Stockholm"),("2669113", "Tidaholm", "", "SE", "752", "", "28", "1498", "", "58.18035", "13.95824", "Europe/Stockholm"),("2669118", "Tibro", "", "SE", "752", "", "28", "1472", "", "58.42453", "14.16162", "Europe/Stockholm"),("2669772", "Täby", "", "SE", "752", "", "26", "0160", "", "59.4439", "18.06872", "Europe/Stockholm"),("2670128", "Svedala", "", "SE", "752", "", "27", "1263", "", "55.50788", "13.23515", "Europe/Stockholm"),("2670603", "Surte", "", "SE", "752", "", "28", "1440", "144001", "57.82533", "12.01604", "Europe/Stockholm"),("2670613", "Surahammar", "", "SE", "752", "", "25", "1907", "", "59.70725", "16.22188", "Europe/Stockholm"),("2670781", "Sundsvall", "Сундсвалль", "SE", "752", "", "24", "2281", "", "62.39129", "17.3063", "Europe/Stockholm"),("2670879", "Sundbyberg", "", "SE", "752", "SE", "26", "0183", "", "59.36128", "17.97114", "Europe/Stockholm"),("2671224", "Strömstad", "", "SE", "752", "", "28", "1486", "", "58.93945", "11.1712", "Europe/Stockholm"),("2671392", "Strängnäs", "", "SE", "752", "", "18", "0486", "", "59.37741", "17.03119", "Europe/Stockholm"),("2671490", "Storvreta", "", "SE", "752", "SE", "21", "0380", "038025", "59.95933", "17.70588", "Europe/Stockholm"),("2673730", "Stockholm", "Стокгольм", "SE", "752", "", "26", "0180", "", "59.33258", "18.0649", "Europe/Stockholm"),("2673875", "Stenungsund", "", "SE", "752", "", "28", "1415", "", "58.07046", "11.8181", "Europe/Stockholm"),("2674649", "Staffanstorp", "", "SE", "752", "", "27", "1230", "", "55.64277", "13.20638", "Europe/Stockholm"),("2675365", "Sölvesborg", "", "SE", "752", "", "02", "1083", "", "56.05205", "14.57525", "Europe/Stockholm"),("2675397", "Solna", "", "SE", "752", "", "26", "0184", "", "59.36004", "18.00086", "Europe/Stockholm"),("2675408", "Sollentuna", "", "SE", "752", "", "26", "0163", "", "59.42804", "17.95093", "Europe/Stockholm"),("2675416", "Sollefteå", "", "SE", "752", "", "24", "2283", "", "63.16667", "17.26667", "Europe/Stockholm"),("2675691", "Södra Sandby", "", "SE", "752", "", "09", "0840", "", "56.56667", "16.61667", "Europe/Stockholm"),("2676176", "Södertälje", "Сёдертелье", "SE", "752", "", "26", "0181", "", "59.19554", "17.62525", "Europe/Stockholm"),("2676209", "Södermalm", "", "SE", "752", "", "26", "0180", "", "59.31278", "18.07577", "Europe/Stockholm"),("2676215", "Söderköping", "", "SE", "752", "", "16", "0582", "", "58.48057", "16.32221", "Europe/Stockholm"),("2676224", "Söderhamn", "", "SE", "752", "", "03", "2182", "", "61.30373", "17.05921", "Europe/Stockholm"),("2676586", "Smedjebacken", "", "SE", "752", "", "10", "2061", "", "60.14181", "15.41416", "Europe/Stockholm"),("2677019", "Skutskär", "", "SE", "752", "SE", "21", "0319", "031902", "60.62507", "17.41552", "Europe/Stockholm"),("2677025", "Skurup", "", "SE", "752", "", "27", "1264", "", "55.47839", "13.50186", "Europe/Stockholm"),("2677234", "Skövde", "Шёвде", "SE", "752", "", "28", "1496", "", "58.39118", "13.84506", "Europe/Stockholm"),("2677456", "Skoghall", "", "SE", "752", "", "22", "1761", "", "59.32324", "13.46552", "Europe/Stockholm"),("2678153", "Skåre", "", "SE", "752", "SE", "27", "1287", "", "55.38333", "13.05", "Europe/Stockholm"),("2678210", "Skara", "", "SE", "752", "", "28", "1495", "", "58.38659", "13.43836", "Europe/Stockholm"),("2678913", "Sjöbo", "", "SE", "752", "", "27", "1265", "", "55.63135", "13.70622", "Europe/Stockholm"),("2679107", "Simrishamn", "", "SE", "752", "", "27", "1291", "", "55.55653", "14.35037", "Europe/Stockholm"),("2679302", "Sigtuna", "", "SE", "752", "", "26", "0191", "", "59.61731", "17.72361", "Europe/Stockholm"),("2679567", "Segeltorp", "", "SE", "752", "", "26", "0126", "", "59.27597", "17.93072", "Europe/Stockholm"),("2679698", "Sävsjö", "", "SE", "752", "", "08", "0684", "", "57.40327", "14.66244", "Europe/Stockholm"),("2679721", "Sävja", "", "SE", "752", "", "21", "0380", "038005", "59.81872", "17.69958", "Europe/Stockholm"),("2680075", "Sandviken", "Сандвикен", "SE", "752", "", "03", "2181", "", "60.61667", "16.76667", "Europe/Stockholm"),("2680460", "Saltsjöbaden", "", "SE", "752", "", "26", "0182", "", "59.28333", "18.3", "Europe/Stockholm"),("2680662", "Sala", "", "SE", "752", "", "25", "1981", "", "59.91993", "16.60655", "Europe/Stockholm"),("2680764", "Säffle", "", "SE", "752", "", "22", "1785", "", "59.13229", "12.92888", "Europe/Stockholm"),("2681825", "Ronneby", "", "SE", "752", "", "02", "1081", "", "56.20999", "15.27602", "Europe/Stockholm"),("2683034", "Råsunda", "", "SE", "752", "", "26", "0184", "018401", "59.36588", "17.99569", "Europe/Stockholm"),("2684213", "Perstorp", "", "SE", "752", "", "27", "1275", "", "56.13829", "13.39476", "Europe/Stockholm"),("2684395", "Partille", "", "SE", "752", "", "28", "1402", "", "57.7395", "12.10642", "Europe/Stockholm"),("2684636", "Oxie", "", "SE", "752", "", "27", "1280", "128014", "55.54014", "13.09605", "Europe/Stockholm"),("2684653", "Oxelösund", "", "SE", "752", "", "18", "0481", "", "58.67057", "17.10152", "Europe/Stockholm"),("2685750", "Östersund", "Эстерсунд", "SE", "752", "", "07", "2380", "", "63.1792", "14.63566", "Europe/Stockholm"),("2685828", "Östermalm", "", "SE", "752", "", "26", "0180", "", "59.33879", "18.08487", "Europe/Stockholm"),("2686162", "Oskarshamn", "Оскарсхамн", "SE", "752", "", "09", "0882", "", "57.26455", "16.44837", "Europe/Stockholm"),("2686209", "Osby", "", "SE", "752", "", "27", "1273", "", "56.38165", "13.99364", "Europe/Stockholm"),("2686380", "Orsa", "", "SE", "752", "", "10", "2034", "", "61.12034", "14.6155", "Europe/Stockholm"),("2686469", "Örnsköldsvik", "Эрншёльдсвик", "SE", "752", "", "24", "2284", "", "63.29091", "18.71525", "Europe/Stockholm"),("2686657", "Örebro", "Эребру", "SE", "752", "", "15", "1880", "", "59.27412", "15.2066", "Europe/Stockholm"),("2687062", "Olofström", "", "SE", "752", "", "02", "1060", "", "56.2773", "14.53402", "Europe/Stockholm"),("2687636", "Nynäshamn", "", "SE", "752", "", "26", "0192", "", "58.90337", "17.94793", "Europe/Stockholm"),("2687690", "Nykvarn", "", "SE", "752", "", "26", "0188", "", "59.8", "18.3", "Europe/Stockholm"),("2687700", "Nyköping", "Нючёпинг", "SE", "752", "", "18", "0480", "", "58.753", "17.00788", "Europe/Stockholm"),("2687902", "Nybro", "", "SE", "752", "", "09", "0881", "", "56.74461", "15.90714", "Europe/Stockholm"),("2688250", "Norrtälje", "Норртелье", "SE", "752", "", "26", "0188", "", "59.75799", "18.70496", "Europe/Stockholm"),("2688368", "Norrköping", "Норрчёпинг", "SE", "752", "", "16", "0581", "", "58.59419", "16.1826", "Europe/Stockholm"),("2689471", "Nora", "", "SE", "752", "", "15", "1884", "", "59.51926", "15.03979", "Europe/Stockholm"),("2690170", "Nässjö", "", "SE", "752", "", "08", "0682", "", "57.65307", "14.69676", "Europe/Stockholm"),("2690580", "Nacka", "", "SE", "752", "", "26", "0182", "", "59.31053", "18.16372", "Europe/Stockholm"),("2690902", "Mullsjö", "", "SE", "752", "", "08", "0642", "", "57.9171", "13.87831", "Europe/Stockholm"),("2690960", "Motala", "Мутала", "SE", "752", "", "16", "0583", "", "58.53706", "15.03649", "Europe/Stockholm"),("2691400", "Mora", "", "SE", "752", "", "10", "2062", "", "61.00704", "14.54316", "Europe/Stockholm"),("2691440", "Mölnlycke", "", "SE", "752", "", "28", "1401", "", "57.65893", "12.11792", "Europe/Stockholm"),("2691459", "Mölndal", "", "SE", "752", "", "28", "1481", "", "57.6554", "12.01378", "Europe/Stockholm"),("2691743", "Mjölby", "", "SE", "752", "", "16", "0586", "", "58.32595", "15.12365", "Europe/Stockholm"),("2692475", "Märsta", "Мерста", "SE", "752", "", "26", "0191", "", "59.62157", "17.85476", "Europe/Stockholm"),("2692613", "Mariestad", "", "SE", "752", "", "28", "1493", "", "58.70971", "13.82367", "Europe/Stockholm"),("2692876", "Malung", "", "SE", "752", "", "10", "2023", "", "60.68329", "13.71542", "Europe/Stockholm"),("2692943", "Malmslätt", "", "SE", "752", "SE", "16", "0580", "", "58.41102", "15.51647", "Europe/Stockholm"),("2692969", "Malmö", "Мальмё", "SE", "752", "", "27", "1280", "", "55.60587", "13.00073", "Europe/Stockholm"),("2693301", "Lysekil", "", "SE", "752", "", "28", "1484", "", "58.27429", "11.43576", "Europe/Stockholm"),("2693347", "Lycksele", "", "SE", "752", "SE", "23", "2481", "", "64.59537", "18.67351", "Europe/Stockholm"),("2693678", "Lund", "Лунд", "SE", "752", "", "27", "1281", "", "55.70584", "13.19321", "Europe/Stockholm"),("2693759", "Ludvika", "", "SE", "752", "", "10", "2085", "", "60.14959", "15.18776", "Europe/Stockholm"),("2694264", "Lomma", "", "SE", "752", "", "27", "1262", "", "55.67244", "13.06849", "Europe/Stockholm"),("2694375", "Löddeköpinge", "", "SE", "752", "", "27", "1261", "", "55.76667", "13.01667", "Europe/Stockholm"),("2694503", "Ljusdal", "", "SE", "752", "", "03", "2161", "", "61.82883", "16.09126", "Europe/Stockholm"),("2694529", "Ljungsbro", "", "SE", "752", "SE", "16", "0580", "", "58.51667", "15.5", "Europe/Stockholm"),("2694560", "Ljungby", "", "SE", "752", "", "12", "0781", "", "56.83324", "13.94082", "Europe/Stockholm"),("2694762", "Linköping", "Линчёпинг", "SE", "752", "", "16", "0580", "058002", "58.41086", "15.62157", "Europe/Stockholm"),("2694808", "Lindsdal", "", "SE", "752", "", "09", "0880", "", "56.73333", "16.3", "Europe/Stockholm"),("2694831", "Lindome", "", "SE", "752", "", "28", "1481", "", "57.56667", "12.08333", "Europe/Stockholm"),("2694893", "Lindesberg", "", "SE", "752", "", "15", "1885", "", "59.59202", "15.2304", "Europe/Stockholm"),("2696329", "Lidköping", "Лидкопинг", "SE", "752", "", "28", "1494", "", "58.50517", "13.15765", "Europe/Stockholm"),("2696334", "Lidingö", "", "SE", "752", "", "26", "0186", "", "59.36667", "18.13333", "Europe/Stockholm"),("2696503", "Lerum", "", "SE", "752", "", "28", "1441", "", "57.77051", "12.26904", "Europe/Stockholm"),("2696650", "Leksand", "", "SE", "752", "", "10", "2029", "202902", "60.7303", "14.99994", "Europe/Stockholm"),("2697703", "Landvetter", "", "SE", "752", "", "28", "1401", "", "57.68665", "12.21169", "Europe/Stockholm"),("2697720", "Landskrona", "Ландскруна", "SE", "752", "", "27", "1282", "", "55.8708", "12.83016", "Europe/Stockholm"),("2697861", "Laholm", "", "SE", "752", "", "06", "1381", "", "56.51207", "13.04371", "Europe/Stockholm"),("2698681", "Kungsör", "", "SE", "752", "SE", "25", "1960", "", "59.42245", "16.09656", "Europe/Stockholm"),("2698691", "Kungsholmen", "", "SE", "752", "", "26", "0180", "", "59.33183", "18.04118", "Europe/Stockholm"),("2698729", "Kungsbacka", "", "SE", "752", "", "06", "1384", "", "57.48719", "12.07612", "Europe/Stockholm"),("2698733", "Kungsängen", "", "SE", "752", "", "26", "0139", "", "59.47857", "17.74834", "Europe/Stockholm"),("2698739", "Kungälv", "Кунглев", "SE", "752", "", "28", "1482", "", "57.87096", "11.98054", "Europe/Stockholm"),("2698767", "Kumla", "", "SE", "752", "", "15", "1881", "", "59.1277", "15.14341", "Europe/Stockholm"),("2699282", "Kristinehamn", "Кристинехамн", "SE", "752", "", "22", "1781", "", "59.30978", "14.10808", "Europe/Stockholm"),("2699310", "Kristianstad", "Кристианстад", "SE", "752", "", "27", "1290", "", "56.03129", "14.15242", "Europe/Stockholm"),("2699394", "Kramfors", "", "SE", "752", "", "24", "2282", "", "62.93161", "17.77646", "Europe/Stockholm"),("2699791", "Köping", "", "SE", "752", "", "25", "1983", "", "59.51404", "15.99255", "Europe/Stockholm"),("2700199", "Knivsta", "", "SE", "752", "", "21", "0330", "", "59.72564", "17.78753", "Europe/Stockholm"),("2700487", "Klippan", "", "SE", "752", "", "27", "1276", "", "56.13559", "13.13086", "Europe/Stockholm"),("2700791", "Kista", "", "SE", "752", "", "26", "0180", "", "59.40316", "17.94479", "Europe/Stockholm"),("2700839", "Kinna", "", "SE", "752", "", "28", "1463", "", "57.50728", "12.69463", "Europe/Stockholm"),("2700960", "Kil", "", "SE", "752", "", "22", "1715", "171501", "59.50234", "13.31277", "Europe/Stockholm"),("2701096", "Kävlinge", "", "SE", "752", "", "27", "1261", "", "55.79188", "13.11021", "Europe/Stockholm"),("2701223", "Katrineholm", "Катринехольм", "SE", "752", "", "18", "0483", "", "58.99587", "16.20721", "Europe/Stockholm"),("2701680", "Karlstad", "Карлстад", "SE", "752", "", "22", "1780", "", "59.3793", "13.50357", "Europe/Stockholm"),("2701713", "Karlskrona", "Карлскруна", "SE", "752", "", "02", "1080", "", "56.16156", "15.58661", "Europe/Stockholm"),("2701715", "Karlskoga", "", "SE", "752", "", "15", "1883", "", "59.32667", "14.52386", "Europe/Stockholm"),("2701727", "Karlshamn", "Карлсхамн", "SE", "752", "", "02", "1082", "", "56.1706", "14.86188", "Europe/Stockholm"),("2702261", "Kalmar", "Кальмар", "SE", "752", "", "09", "0880", "", "56.66157", "16.36163", "Europe/Stockholm"),("2702449", "Kållered", "", "SE", "752", "", "28", "1481", "", "57.60992", "12.05106", "Europe/Stockholm"),("2702908", "Jordbro", "", "SE", "752", "", "26", "0136", "", "59.14972", "18.11667", "Europe/Stockholm"),("2702979", "Jönköping", "Йёнчёпинг", "SE", "752", "", "08", "0680", "", "57.78145", "14.15618", "Europe/Stockholm"),("2703396", "Jakobsberg", "", "SE", "752", "", "26", "0123", "", "59.42268", "17.83508", "Europe/Stockholm"),("2704136", "Huskvarna", "Хускварна", "SE", "752", "", "08", "0680", "", "57.78596", "14.30214", "Europe/Stockholm"),("2704398", "Hultsfred", "", "SE", "752", "", "09", "0860", "", "57.48815", "15.84357", "Europe/Stockholm"),("2704613", "Hudiksvall", "", "SE", "752", "", "03", "2184", "218401", "61.72744", "17.10558", "Europe/Stockholm"),("2704620", "Huddinge", "", "SE", "752", "", "26", "0126", "", "59.23705", "17.98192", "Europe/Stockholm"),("2705049", "Hörby", "", "SE", "752", "", "27", "1266", "", "55.85238", "13.66094", "Europe/Stockholm"),("2705055", "Höör", "", "SE", "752", "", "27", "1267", "", "55.93444", "13.5385", "Europe/Stockholm"),("2705075", "Hönö", "", "SE", "752", "SE", "28", "1407", "", "57.68972", "11.64972", "Europe/Stockholm"),("2705402", "Höllviken", "", "SE", "752", "SE", "27", "1233", "123309", "55.40982", "12.9558", "Europe/Stockholm"),("2706003", "Höganäs", "", "SE", "752", "", "27", "1284", "", "56.19971", "12.55795", "Europe/Stockholm"),("2706057", "Hofors", "", "SE", "752", "", "03", "2104", "", "60.54573", "16.28668", "Europe/Stockholm"),("2706184", "Hjo", "", "SE", "752", "", "28", "1497", "", "58.30133", "14.28784", "Europe/Stockholm"),("2706767", "Helsingborg", "Хельсингборг", "SE", "752", "", "27", "1283", "", "56.04673", "12.69437", "Europe/Stockholm"),("2706982", "Hedemora", "", "SE", "752", "", "10", "2083", "", "60.27973", "15.98855", "Europe/Stockholm"),("2707399", "Hässleholm", "", "SE", "752", "", "27", "1293", "", "56.15905", "13.76638", "Europe/Stockholm"),("2707684", "Härnösand", "", "SE", "752", "", "24", "2280", "", "62.63228", "17.93794", "Europe/Stockholm"),("2707953", "Haninge", "", "SE", "752", "", "26", "0136", "", "59.16775", "18.14478", "Europe/Stockholm"),("2708016", "Handen", "", "SE", "752", "", "26", "0136", "", "59.16809", "18.13796", "Europe/Stockholm"),("2708365", "Halmstad", "Хальмстад", "SE", "752", "", "06", "1380", "", "56.67446", "12.85676", "Europe/Stockholm"),("2708429", "Hallstahammar", "", "SE", "752", "", "25", "1961", "", "59.61395", "16.22846", "Europe/Stockholm"),("2708511", "Hallsberg", "", "SE", "752", "", "15", "1861", "186101", "59.06463", "15.10993", "Europe/Stockholm"),("2709214", "Hagfors", "", "SE", "752", "SE", "22", "1783", "", "60.02378", "13.67214", "Europe/Stockholm"),("2709494", "Habo", "", "SE", "752", "", "08", "0643", "", "57.91185", "14.07444", "Europe/Stockholm"),("2709628", "Gustavsberg", "", "SE", "752", "SE", "26", "0120", "", "59.32684", "18.38975", "Europe/Stockholm"),("2710343", "Grums", "", "SE", "752", "", "22", "1764", "176401", "59.35141", "13.11105", "Europe/Stockholm"),("2711537", "Göteborg", "Гётеборг", "SE", "752", "", "28", "1480", "", "57.70716", "11.96679", "Europe/Stockholm"),("2711798", "Gnesta", "", "SE", "752", "", "18", "0461", "", "59.04751", "17.31191", "Europe/Stockholm"),("2712045", "Gislaved", "", "SE", "752", "", "08", "0662", "", "57.3044", "13.54078", "Europe/Stockholm"),("2712414", "Gävle", "Евле", "SE", "752", "", "03", "2180", "", "60.67452", "17.14174", "Europe/Stockholm"),("2712993", "Gamla Uppsala", "", "SE", "752", "", "21", "0380", "038001", "59.89817", "17.63386", "Europe/Stockholm"),("2713971", "Forshaga", "", "SE", "752", "", "22", "1763", "", "59.52541", "13.48127", "Europe/Stockholm"),("2714401", "Flen", "", "SE", "752", "", "18", "0482", "048201", "59.05834", "16.58781", "Europe/Stockholm"),("2714795", "Fittja", "", "SE", "752", "", "26", "0127", "", "59.24868", "17.85991", "Europe/Stockholm"),("2714903", "Finspång", "", "SE", "752", "", "16", "0562", "", "58.70578", "15.76739", "Europe/Stockholm"),("2715081", "Filipstad", "", "SE", "752", "", "22", "1782", "", "59.71236", "14.16831", "Europe/Stockholm"),("2715459", "Falun", "Фалун", "SE", "752", "", "10", "2080", "", "60.60357", "15.62597", "Europe/Stockholm"),("2715568", "Falköping", "Фальчёпинг", "SE", "752", "", "28", "1499", "", "58.17347", "13.55068", "Europe/Stockholm"),("2715573", "Falkenberg", "Фалькенберг", "SE", "752", "", "06", "1382", "", "56.90552", "12.49118", "Europe/Stockholm"),("2715656", "Fagersta", "", "SE", "752", "", "25", "1982", "", "60.00418", "15.79316", "Europe/Stockholm"),("2715946", "Eslöv", "", "SE", "752", "", "27", "1285", "", "55.83928", "13.30393", "Europe/Stockholm"),("2715953", "Eskilstuna", "Эскильстуна", "SE", "752", "", "18", "0484", "", "59.36661", "16.5077", "Europe/Stockholm"),("2716166", "Enköping", "", "SE", "752", "", "21", "0381", "", "59.63607", "17.07768", "Europe/Stockholm"),("2716437", "Eksjö", "", "SE", "752", "", "08", "0686", "", "57.66643", "14.97205", "Europe/Stockholm"),("2716586", "Ekerö", "", "SE", "752", "", "26", "0125", "", "59.291", "17.81212", "Europe/Stockholm"),("2717517", "Djursholm", "", "SE", "752", "", "26", "0162", "", "59.39926", "18.05619", "Europe/Stockholm"),("2717884", "Degerfors", "", "SE", "752", "", "15", "1862", "", "59.23797", "14.43077", "Europe/Stockholm"),("2718245", "Dalby", "", "SE", "752", "", "21", "0381", "", "59.53333", "17.35", "Europe/Stockholm"),("2718759", "Bunkeflostrand", "", "SE", "752", "", "27", "1280", "", "55.53333", "12.95", "Europe/Stockholm"),("2719106", "Bromölla", "", "SE", "752", "", "27", "1272", "", "56.07551", "14.46958", "Europe/Stockholm"),("2719111", "Bromma", "", "SE", "752", "SE", "26", "0180", "", "59.34", "17.94", "Europe/Stockholm"),("2719245", "Bro", "", "SE", "752", "", "26", "0139", "", "59.51667", "17.63333", "Europe/Stockholm"),("2719312", "Brevik", "", "SE", "752", "", "26", "0186", "", "59.35", "18.2", "Europe/Stockholm"),("2720383", "Borlänge", "Бурленге", "SE", "752", "", "10", "2081", "", "60.4858", "15.43714", "Europe/Stockholm"),("2720501", "Borås", "Бурос", "SE", "752", "", "28", "1490", "", "57.72101", "12.9401", "Europe/Stockholm"),("2720679", "Bollnäs", "", "SE", "752", "", "03", "2183", "", "61.34817", "16.39464", "Europe/Stockholm"),("2720689", "Bollebygd", "", "SE", "752", "", "28", "1443", "", "57.66866", "12.57272", "Europe/Stockholm"),("2721259", "Boo", "", "SE", "752", "SE", "26", "0182", "", "59.33333", "18.28333", "Europe/Stockholm"),("2721534", "Bjuv", "", "SE", "752", "", "27", "1260", "", "56.08372", "12.91914", "Europe/Stockholm"),("2722362", "Bjärred", "", "SE", "752", "", "27", "1262", "", "55.71667", "13.01667", "Europe/Stockholm"),("2722570", "Billdal", "", "SE", "752", "", "28", "1480", "", "57.56667", "11.93333", "Europe/Stockholm"),("2722742", "Bergshamra", "", "SE", "752", "", "26", "0188", "", "59.38083", "18.03427", "Europe/Stockholm"),("2723503", "Bankeryd", "", "SE", "752", "", "08", "0680", "068020", "57.86021", "14.124", "Europe/Stockholm"),("2723567", "Bålsta", "", "SE", "752", "", "21", "0305", "", "59.5671", "17.52781", "Europe/Stockholm"),("2724231", "Avesta", "", "SE", "752", "", "10", "2084", "208401", "60.14274", "16.16295", "Europe/Stockholm"),("2724321", "Åtvidaberg", "", "SE", "752", "", "16", "0561", "", "58.20152", "15.9977", "Europe/Stockholm"),("2724435", "Åstorp", "", "SE", "752", "", "27", "1277", "", "56.13566", "12.9443", "Europe/Stockholm"),("2725123", "Arvika", "", "SE", "752", "", "22", "1784", "", "59.65528", "12.58518", "Europe/Stockholm"),("2725201", "Årsta", "", "SE", "752", "", "26", "0180", "", "59.2978", "18.0514", "Europe/Stockholm"),("2725336", "Arlöv", "", "SE", "752", "", "27", "1231", "", "55.63248", "13.07141", "Europe/Stockholm"),("2725471", "Arboga", "", "SE", "752", "", "25", "1984", "", "59.39387", "15.83882", "Europe/Stockholm"),("2725901", "Ängelholm", "", "SE", "752", "", "27", "1292", "", "56.2428", "12.86219", "Europe/Stockholm"),("2726240", "Åmål", "", "SE", "752", "", "28", "1492", "", "59.051", "12.70492", "Europe/Stockholm"),("2726314", "Alvesta", "", "SE", "752", "", "12", "0764", "", "56.89935", "14.55559", "Europe/Stockholm"),("2726394", "Älta", "", "SE", "752", "", "26", "0182", "", "59.26667", "18.18333", "Europe/Stockholm"),("2726576", "Älmhult", "", "SE", "752", "", "12", "0765", "", "56.55146", "14.13827", "Europe/Stockholm"),("2726756", "Alingsås", "Алингсас", "SE", "752", "", "28", "1489", "", "57.93033", "12.53345", "Europe/Stockholm"),("2727234", "Åkersberga", "Акерсберга", "SE", "752", "", "26", "0117", "", "59.47944", "18.29967", "Europe/Stockholm"),("2727314", "Åkarp", "", "SE", "752", "", "28", "1499", "", "58.23333", "13.65", "Europe/Stockholm"),("2727363", "Åhus", "", "SE", "752", "", "27", "1290", "", "55.91667", "14.28333", "Europe/Stockholm"),("3336566", "Fisksätra", "", "SE", "752", "", "26", "0182", "018201", "59.29153", "18.2549", "Europe/Stockholm"),("3336568", "Skanör med Falsterbo", "", "SE", "752", "", "27", "1233", "", "55.4", "12.85", "Europe/Stockholm"),("3336569", "Nödinge-Nol", "", "SE", "752", "", "28", "1440", "", "57.91259", "12.05591", "Europe/Stockholm"),("6619708", "Majorna", "", "SE", "752", "", "28", "1480", "", "57.69195", "11.91605", "Europe/Stockholm"),("6943587", "Onsala", "", "SE", "752", "", "06", "1384", "", "57.42531", "12.02903", "Europe/Stockholm"),("7931985", "Alby", "", "SE", "752", "", "26", "0127", "", "59.2335", "17.8538", "Europe/Stockholm"),("8288543", "Hammarkullen", "", "SE", "752", "", "28", "1480", "148026", "57.78049", "12.03604", "Europe/Stockholm"),("8288547", "Gårdsten", "", "SE", "752", "", "28", "1480", "148026", "57.8048", "12.02883", "Europe/Stockholm"),("8288548", "Lövgärdet", "", "SE", "752", "", "28", "1480", "148026", "57.81555", "12.03861", "Europe/Stockholm"),("1880252", "Singapore", "Сингапур", "SG", "702", "", "01", "", "", "1.28967", "103.85007", "Asia/Singapore"),("3186270", "Žužemberk", "", "SI", "705", "", "N8", "", "", "45.83389", "14.92917", "Europe/Ljubljana"),("3186442", "Žirovnica", "", "SI", "705", "", "N7", "", "", "46.40472", "14.14", "Europe/Ljubljana"),("3186450", "Žiri", "", "SI", "705", "", "F2", "", "", "46.04222", "14.10722", "Europe/Ljubljana"),("3186509", "Zgornje Jezersko", "", "SI", "705", "", "H5", "", "", "46.3941", "14.50659", "Europe/Ljubljana"),("3186514", "Zgornje Gorje", "", "SI", "705", "", "O2", "", "", "46.37962", "14.06937", "Europe/Ljubljana"),("3186538", "Zgornja Kungota", "", "SI", "705", "", "55", "", "", "46.63917", "15.61556", "Europe/Ljubljana"),("3186557", "Žetale", "", "SI", "705", "", "N6", "", "", "46.27356", "15.82658", "Europe/Ljubljana"),("3186607", "Železniki", "", "SI", "705", "", "F1", "", "", "46.21999", "14.14159", "Europe/Ljubljana"),("3186705", "Zavrč", "", "SI", "705", "", "E9", "", "", "46.39167", "16.04972", "Europe/Ljubljana"),("3186844", "Žalec", "", "SI", "705", "", "N5", "", "", "46.25151", "15.16482", "Europe/Ljubljana"),("3186906", "Zagorje ob Savi", "", "SI", "705", "", "E7", "", "", "46.13179", "14.99694", "Europe/Ljubljana"),("3187020", "Vuzenica", "", "SI", "705", "", "E6", "", "", "46.59639", "15.16722", "Europe/Ljubljana"),("3187214", "Vrhnika", "", "SI", "705", "", "E5", "", "", "45.9635", "14.29484", "Europe/Ljubljana"),("3187336", "Vransko", "", "SI", "705", "", "N4", "", "", "46.24389", "14.95139", "Europe/Ljubljana"),("3187428", "Volčja Draga", "", "SI", "705", "", "P1", "", "", "45.90694", "13.6775", "Europe/Ljubljana"),("3187448", "Vojnik", "", "SI", "705", "", "N3", "", "", "46.29333", "15.30333", "Europe/Ljubljana"),("3187485", "Vodice", "", "SI", "705", "", "E3", "", "", "46.18987", "14.49492", "Europe/Ljubljana"),("3187575", "Vitomarci", "", "SI", "705", "", "M4", "", "", "46.5275", "15.93944", "Europe/Ljubljana"),("3187598", "Vitanje", "", "SI", "705", "", "E2", "", "", "46.38167", "15.29583", "Europe/Ljubljana"),("3187706", "Vipava", "", "SI", "705", "", "E1", "", "", "45.84667", "13.96306", "Europe/Ljubljana"),("3187813", "Videm", "", "SI", "705", "", "20", "", "", "45.85", "14.69417", "Europe/Ljubljana"),("3187840", "Veržej", "", "SI", "705", "", "N1", "", "", "46.58361", "16.16528", "Europe/Ljubljana"),("3188128", "Velike Lašče", "", "SI", "705", "", "D8", "", "", "45.83222", "14.63639", "Europe/Ljubljana"),("3188181", "Velika Polana", "", "SI", "705", "", "M9", "", "", "46.57194", "16.34694", "Europe/Ljubljana"),("3188606", "Turnišče", "", "SI", "705", "", "D6", "", "", "46.62778", "16.32028", "Europe/Ljubljana"),("3188684", "Trzin", "", "SI", "705", "", "M8", "", "", "46.13333", "14.56667", "Europe/Ljubljana"),("3188688", "Tržič", "", "SI", "705", "", "D5", "", "", "46.36357", "14.31046", "Europe/Ljubljana"),("3188767", "Trnovska Vas", "", "SI", "705", "", "M7", "", "", "46.52019", "15.88657", "Europe/Ljubljana"),("3188886", "Trebnje", "", "SI", "705", "", "D4", "", "", "45.90417", "15.02167", "Europe/Ljubljana"),("3188915", "Trbovlje", "", "SI", "705", "", "D3", "", "", "46.155", "15.05333", "Europe/Ljubljana"),("3189014", "Sveti Tomaž", "", "SI", "705", "", "P8", "", "", "46.48417", "16.08361", "Europe/Ljubljana"),("3189038", "Tolmin", "", "SI", "705", "", "D2", "", "", "46.18304", "13.73321", "Europe/Ljubljana"),("3189075", "Velenje", "Веленье", "SI", "705", "", "D7", "", "", "46.35917", "15.11028", "Europe/Ljubljana"),("3189098", "Tišina", "", "SI", "705", "", "M6", "", "", "46.65806", "16.09167", "Europe/Ljubljana"),("3189227", "Tabor", "", "SI", "705", "", "M5", "", "", "46.23611", "15.01833", "Europe/Ljubljana"),("3189403", "Sv. Ana v Slov. Goricah", "", "SI", "705", "", "M3", "", "", "46.64917", "15.84417", "Europe/Ljubljana"),("3189798", "Štore", "", "SI", "705", "", "C9", "", "", "46.22083", "15.31389", "Europe/Ljubljana"),("3189917", "Starše", "", "SI", "705", "", "C8", "", "", "46.46583", "15.76722", "Europe/Ljubljana"),("3190150", "Središče ob Dravi", "", "SI", "705", "", "P4", "", "", "46.39417", "16.26806", "Europe/Ljubljana"),("3190199", "Spodnji Duplek", "", "SI", "705", "", "26", "", "", "46.50306", "15.74528", "Europe/Ljubljana"),("3190219", "Spodnje Hoče", "", "SI", "705", "", "H1", "", "", "46.5", "15.65", "Europe/Ljubljana"),("3190249", "Spodnja Hajdina", "", "SI", "705", "", "G9", "", "", "46.40889", "15.84694", "Europe/Ljubljana"),("3190311", "Šoštanj", "", "SI", "705", "", "C7", "", "", "46.38", "15.04861", "Europe/Ljubljana"),("3190360", "Solčava", "", "SI", "705", "", "M2", "", "", "46.41944", "14.69361", "Europe/Ljubljana"),("3190391", "Sodražica", "", "SI", "705", "", "M1", "", "", "45.76111", "14.63556", "Europe/Ljubljana"),("3190495", "Šmartno pri Litiji", "", "SI", "705", "", "L9", "", "", "46.04444", "14.84417", "Europe/Ljubljana"),("3190498", "Šmartno ob Paki", "", "SI", "705", "", "C6", "", "", "46.33333", "15.03333", "Europe/Ljubljana"),("3190506", "Šmarjeta", "", "SI", "705", "", "P3", "", "", "45.88333", "15.25", "Europe/Ljubljana"),("3190510", "Šmarje pri Jelšah", "", "SI", "705", "", "C5", "", "", "46.22722", "15.51917", "Europe/Ljubljana"),("3190530", "Slovenske Konjice", "", "SI", "705", "", "C4", "", "", "46.33667", "15.42583", "Europe/Ljubljana"),("3190534", "Slovenska Bistrica", "", "SI", "705", "", "L8", "", "", "46.39278", "15.57444", "Europe/Ljubljana"),("3190536", "Slovenj Gradec", "", "SI", "705", "", "C2", "", "", "46.51028", "15.08056", "Europe/Ljubljana"),("3190712", "Škofljica", "", "SI", "705", "", "C1", "", "", "45.98333", "14.57667", "Europe/Ljubljana"),("3190717", "Škofja Loka", "", "SI", "705", "", "B9", "", "", "46.16551", "14.30626", "Europe/Ljubljana"),("3190722", "Škocjan", "", "SI", "705", "", "B8", "", "", "45.90667", "15.29139", "Europe/Ljubljana"),("3190945", "Sežana", "", "SI", "705", "", "B7", "", "", "45.70924", "13.87333", "Europe/Ljubljana"),("3190950", "Sevnica", "", "SI", "705", "", "B6", "", "", "46.00778", "15.31556", "Europe/Ljubljana"),("3191024", "Šentrupert", "", "SI", "705", "", "P2", "", "", "45.97778", "15.09556", "Europe/Ljubljana"),("3191029", "Šentjur", "", "SI", "705", "", "L7", "", "", "46.21722", "15.3975", "Europe/Ljubljana"),("3191033", "Šentjernej", "", "SI", "705", "", "B4", "", "", "45.84", "15.33611", "Europe/Ljubljana"),("3191039", "Šentilj v Slov. Goricah", "", "SI", "705", "", "B3", "", "", "46.68167", "15.64806", "Europe/Ljubljana"),("3191059", "Šenčur", "", "SI", "705", "", "B2", "", "", "46.24556", "14.41972", "Europe/Ljubljana"),("3191063", "Šempeter pri Gorici", "", "SI", "705", "", "L6", "", "", "45.9275", "13.64111", "Europe/Ljubljana"),("3191072", "Semič", "", "SI", "705", "", "B1", "", "", "45.64611", "15.18222", "Europe/Ljubljana"),("3191329", "Šalovci", "", "SI", "705", "", "L4", "", "", "46.825", "16.29806", "Europe/Ljubljana"),("3191401", "Ruše", "", "SI", "705", "", "L3", "", "", "46.53944", "15.51583", "Europe/Ljubljana"),("3191578", "Rogatec", "", "SI", "705", "", "A8", "", "", "46.22944", "15.70028", "Europe/Ljubljana"),("3191579", "Rogašovci", "", "SI", "705", "", "A6", "", "", "46.8", "16.03333", "Europe/Ljubljana"),("3191580", "Rogaška Slatina", "", "SI", "705", "", "A7", "", "", "46.2375", "15.63972", "Europe/Ljubljana"),("3191678", "Ribnica na Pohorju", "", "SI", "705", "", "L2", "", "", "46.535", "15.27278", "Europe/Ljubljana"),("3191685", "Ribnica", "", "SI", "705", "", "L1", "", "", "45.73861", "14.7275", "Europe/Ljubljana"),("3191756", "Rečica ob Savinji", "", "SI", "705", "", "O9", "", "", "46.31667", "14.91667", "Europe/Ljubljana"),("3191839", "Ravne na Koroškem", "", "SI", "705", "", "K8", "", "", "46.54306", "14.96917", "Europe/Ljubljana"),("3192063", "Radovljica", "", "SI", "705", "", "A3", "", "", "46.34444", "14.17444", "Europe/Ljubljana"),("3192121", "Radlje ob Dravi", "", "SI", "705", "", "A2", "", "", "46.61417", "15.22639", "Europe/Ljubljana"),("3192139", "Radenci", "", "SI", "705", "", "A1", "", "", "46.64201", "16.03781", "Europe/Ljubljana"),("3192144", "Radeče", "", "SI", "705", "", "99", "", "", "46.06806", "15.18389", "Europe/Ljubljana"),("3192165", "Rače", "", "SI", "705", "", "98", "", "", "46.45194", "15.68139", "Europe/Ljubljana"),("3192230", "Puconci", "", "SI", "705", "", "97", "", "", "46.70667", "16.15639", "Europe/Ljubljana"),("3192241", "Ptuj", "Птуй", "SI", "705", "", "K7", "", "", "46.42005", "15.87018", "Europe/Ljubljana"),("3192484", "Prevalje", "", "SI", "705", "", "K6", "", "", "46.54694", "14.92083", "Europe/Ljubljana"),("3192560", "Preddvor", "", "SI", "705", "", "K5", "", "", "46.3025", "14.42306", "Europe/Ljubljana"),("3192570", "Prebold", "", "SI", "705", "", "K4", "", "", "46.23694", "15.0925", "Europe/Ljubljana"),("3192673", "Postojna", "", "SI", "705", "", "94", "", "", "45.77435", "14.21528", "Europe/Ljubljana"),("3192762", "Polzela", "", "SI", "705", "", "K3", "", "", "46.28333", "15.06667", "Europe/Ljubljana"),("3192802", "Poljčane", "", "SI", "705", "", "O8", "", "", "46.31194", "15.57917", "Europe/Ljubljana"),("3192899", "Podvelka", "", "SI", "705", "", "K2", "", "", "46.58694", "15.33056", "Europe/Ljubljana"),("3192986", "Podlehnik", "", "SI", "705", "", "K1", "", "", "46.33528", "15.88", "Europe/Ljubljana"),("3193075", "Podčetrtek", "", "SI", "705", "", "92", "", "", "46.15694", "15.59861", "Europe/Ljubljana"),("3193299", "Pivka", "", "SI", "705", "", "91", "", "", "45.68292", "14.19588", "Europe/Ljubljana"),("3193341", "Piran", "", "SI", "705", "", "J9", "", "", "45.52778", "13.57056", "Europe/Ljubljana"),("3193463", "Pesnica pri Mariboru", "", "SI", "705", "", "89", "", "", "46.60694", "15.67667", "Europe/Ljubljana"),("3193930", "Osilnica", "", "SI", "705", "", "88", "", "", "45.52914", "14.69838", "Europe/Ljubljana"),("3193965", "Ormož", "", "SI", "705", "", "87", "", "", "46.41139", "16.15444", "Europe/Ljubljana"),("3194086", "Oplotnica", "", "SI", "705", "", "J8", "", "", "46.38778", "15.44667", "Europe/Ljubljana"),("3194213", "Odranci", "", "SI", "705", "", "86", "", "", "46.58667", "16.28028", "Europe/Ljubljana"),("3194351", "Novo Mesto", "Ново-Место", "SI", "705", "", "J7", "", "", "45.80397", "15.16886", "Europe/Ljubljana"),("3194403", "Nova Vas", "", "SI", "705", "", "F6", "", "", "45.77167", "14.50583", "Europe/Ljubljana"),("3194452", "Nova Gorica", "", "SI", "705", "", "84", "", "", "45.95604", "13.64837", "Europe/Ljubljana"),("3194595", "Naklo", "", "SI", "705", "", "82", "", "", "46.27278", "14.31722", "Europe/Ljubljana"),("3194622", "Muta", "", "SI", "705", "", "81", "", "", "46.61139", "15.16611", "Europe/Ljubljana"),("3194648", "Murska Sobota", "", "SI", "705", "", "80", "", "", "46.6625", "16.16639", "Europe/Ljubljana"),("3194792", "Mozirje", "", "SI", "705", "", "79", "", "", "46.33944", "14.96333", "Europe/Ljubljana"),("3194871", "Moravske Toplice", "", "SI", "705", "", "78", "", "", "46.68313", "16.2208", "Europe/Ljubljana"),("3194873", "Moravče", "", "SI", "705", "", "77", "", "", "46.13694", "14.745", "Europe/Ljubljana"),("3194904", "Mokronog", "", "SI", "705", "", "O7", "", "", "45.93417", "15.14083", "Europe/Ljubljana"),("3195011", "Mislinja", "", "SI", "705", "", "76", "", "", "46.44141", "15.20027", "Europe/Ljubljana"),("3195036", "Mirna Peč", "", "SI", "705", "", "J6", "", "", "45.86028", "15.08333", "Europe/Ljubljana"),("3195041", "Mirna", "", "SI", "705", "", "O6", "", "", "45.95528", "15.06194", "Europe/Ljubljana"),("3195054", "Miren", "", "SI", "705", "", "J5", "", "", "45.89556", "13.6075", "Europe/Ljubljana"),("3195162", "Miklavž na Dravskem Polju", "", "SI", "705", "", "J4", "", "", "46.50583", "15.69722", "Europe/Ljubljana"),("3195202", "Mežica", "", "SI", "705", "", "74", "", "", "46.52139", "14.85444", "Europe/Ljubljana"),("3195214", "Metlika", "", "SI", "705", "", "73", "", "", "45.64722", "15.31417", "Europe/Ljubljana"),("3195250", "Mengeš", "", "SI", "705", "", "72", "", "", "46.16694", "14.575", "Europe/Ljubljana"),("3195281", "Medvode", "", "SI", "705", "", "71", "", "", "46.1422", "14.41114", "Europe/Ljubljana"),("3195460", "Markovci", "", "SI", "705", "", "J3", "", "", "46.39557", "15.92831", "Europe/Ljubljana"),("3195506", "Maribor", "Марибор", "SI", "705", "", "J2", "", "", "46.55472", "15.64667", "Europe/Ljubljana"),("3195883", "Makole", "", "SI", "705", "", "O5", "", "", "46.31722", "15.66722", "Europe/Ljubljana"),("3195898", "Majšperk", "", "SI", "705", "", "J1", "", "", "46.35167", "15.73361", "Europe/Ljubljana"),("3196049", "Lukovica pri Domžalah", "", "SI", "705", "", "68", "", "", "46.16988", "14.69179", "Europe/Ljubljana"),("3196133", "Luče", "", "SI", "705", "", "I9", "", "", "46.35611", "14.74667", "Europe/Ljubljana"),("3196165", "Lovrenc na Pohorju", "", "SI", "705", "", "I8", "", "", "46.54056", "15.39306", "Europe/Ljubljana"),("3196281", "Log pri Brezovici", "", "SI", "705", "", "O4", "", "", "46.01667", "14.36667", "Europe/Ljubljana"),("3196307", "Ljutomer", "", "SI", "705", "", "I6", "", "", "46.52083", "16.1975", "Europe/Ljubljana"),("3196338", "Ljubno ob Savinji", "", "SI", "705", "", "62", "", "", "46.34358", "14.83377", "Europe/Ljubljana"),("3196359", "Ljubljana", "Любляна", "SI", "705", "", "61", "", "", "46.05108", "14.50513", "Europe/Ljubljana"),("3196425", "Litija", "", "SI", "705", "", "I5", "", "", "46.05861", "14.8225", "Europe/Ljubljana"),("3196681", "Lendava", "", "SI", "705", "", "I4", "", "", "46.56494", "16.45091", "Europe/Ljubljana"),("3196682", "Lenart v Slov. Goricah", "", "SI", "705", "", "I3", "", "", "46.57611", "15.83139", "Europe/Ljubljana"),("3196760", "Laško", "", "SI", "705", "", "57", "", "", "46.15463", "15.23555", "Europe/Ljubljana"),("3196842", "Kuzma", "", "SI", "705", "", "I2", "", "", "46.83694", "16.08333", "Europe/Ljubljana"),("3197147", "Krško", "", "SI", "705", "", "54", "", "", "45.95915", "15.49167", "Europe/Ljubljana"),("3197226", "Križevci pri Ljutomeru", "", "SI", "705", "", "I1", "", "", "46.56833", "16.13861", "Europe/Ljubljana"),("3197373", "Kranjska Gora", "", "SI", "705", "", "53", "", "", "46.45689", "13.77824", "Europe/Ljubljana"),("3197378", "Kranj", "Крань", "SI", "705", "", "52", "", "", "46.23887", "14.35561", "Europe/Ljubljana"),("3197442", "Kozje", "", "SI", "705", "", "51", "", "", "46.075", "15.56028", "Europe/Ljubljana"),("3197462", "Kozina", "", "SI", "705", "", "35", "", "", "45.61", "13.93556", "Europe/Ljubljana"),("3197581", "Kostanjevica na Krki", "", "SI", "705", "", "O3", "", "", "45.84611", "15.42222", "Europe/Ljubljana"),("3197753", "Koper", "Копер", "SI", "705", "", "50", "", "", "45.54694", "13.72944", "Europe/Ljubljana"),("3197842", "Komen", "", "SI", "705", "", "49", "", "", "45.81528", "13.74833", "Europe/Ljubljana"),("3197943", "Kočevje", "", "SI", "705", "", "H7", "", "", "45.64333", "14.86333", "Europe/Ljubljana"),("3197959", "Kobilje", "", "SI", "705", "", "47", "", "", "46.68472", "16.39778", "Europe/Ljubljana"),("3197983", "Kobarid", "", "SI", "705", "", "46", "", "", "46.24806", "13.57722", "Europe/Ljubljana"),("3198165", "Kidričevo", "", "SI", "705", "", "45", "", "", "46.40361", "15.79111", "Europe/Ljubljana"),("3198354", "Kanal", "", "SI", "705", "", "44", "", "", "46.08861", "13.63972", "Europe/Ljubljana"),("3198365", "Kamnik", "", "SI", "705", "", "H6", "", "", "46.22587", "14.61207", "Europe/Ljubljana"),("3198531", "Juršinci", "", "SI", "705", "", "42", "", "", "46.48472", "15.97139", "Europe/Ljubljana"),("3198533", "Jurovski Dol", "", "SI", "705", "", "P7", "", "", "46.60639", "15.78472", "Europe/Ljubljana"),("3198549", "Sveti Jurij ob Ščavnici", "", "SI", "705", "", "D1", "", "", "46.5695", "16.02347", "Europe/Ljubljana"),("3198647", "Jesenice", "", "SI", "705", "", "H4", "", "", "46.43056", "14.06694", "Europe/Ljubljana"),("3199017", "Izola", "", "SI", "705", "", "40", "", "", "45.53694", "13.66194", "Europe/Ljubljana"),("3199078", "Ivančna Gorica", "", "SI", "705", "", "39", "", "", "45.93833", "14.80444", "Europe/Ljubljana"),("3199131", "Ilirska Bistrica", "", "SI", "705", "", "38", "", "", "45.57878", "14.30652", "Europe/Ljubljana"),("3199162", "Ig", "", "SI", "705", "", "37", "", "", "45.96028", "14.52889", "Europe/Ljubljana"),("3199171", "Idrija", "", "SI", "705", "", "36", "", "", "46.00278", "14.03056", "Europe/Ljubljana"),("3199268", "Hrib-Loški Potok", "", "SI", "705", "", "66", "", "", "45.70688", "14.61674", "Europe/Ljubljana"),("3199297", "Hrastnik", "", "SI", "705", "", "34", "", "", "46.14611", "15.08139", "Europe/Ljubljana"),("3199347", "Horjul", "", "SI", "705", "", "H3", "", "", "46.02361", "14.29917", "Europe/Ljubljana"),("3199361", "Hodoš", "", "SI", "705", "", "H2", "", "", "46.82333", "16.33417", "Europe/Ljubljana"),("3199523", "Grosuplje", "", "SI", "705", "", "32", "", "", "45.95556", "14.65889", "Europe/Ljubljana"),("3199685", "Sv. Trojica v Slov. Goricah", "", "SI", "705", "", "P6", "", "", "46.57667", "15.87694", "Europe/Ljubljana"),("3199765", "Grad", "", "SI", "705", "", "G8", "", "", "46.8", "16.1", "Europe/Ljubljana"),("3199948", "Gornji Petrovci", "", "SI", "705", "", "31", "", "", "46.80528", "16.2225", "Europe/Ljubljana"),("3200016", "Gornji Grad", "", "SI", "705", "", "30", "", "", "46.29528", "14.80833", "Europe/Ljubljana"),("3200197", "Gornja Radgona", "", "SI", "705", "", "29", "", "", "46.67333", "15.99222", "Europe/Ljubljana"),("3200307", "Gorišnica", "", "SI", "705", "", "28", "", "", "46.41472", "16.01389", "Europe/Ljubljana"),("3200379", "Gorenja Vas", "", "SI", "705", "", "27", "", "", "46.10722", "14.14806", "Europe/Ljubljana"),("3200385", "Straža", "", "SI", "705", "", "P5", "", "", "45.78", "15.07278", "Europe/Ljubljana"),("3201253", "Dravograd", "", "SI", "705", "", "25", "", "", "46.58806", "15.01917", "Europe/Ljubljana"),("3201355", "Dornava", "", "SI", "705", "", "24", "", "", "46.43667", "15.95361", "Europe/Ljubljana"),("3201730", "Domžale", "", "SI", "705", "", "G7", "", "", "46.13774", "14.59371", "Europe/Ljubljana"),("3201748", "Dol pri Ljubljani", "", "SI", "705", "", "22", "", "", "46.08861", "14.60083", "Europe/Ljubljana"),("3201817", "Dolenjske Toplice", "", "SI", "705", "", "G6", "", "", "45.75657", "15.05917", "Europe/Ljubljana"),("3201896", "Dobrovo", "", "SI", "705", "", "07", "", "", "45.99639", "13.52639", "Europe/Ljubljana"),("3201897", "Dobrovnik", "", "SI", "705", "", "G5", "", "", "46.65139", "16.3525", "Europe/Ljubljana"),("3201901", "Dobrova", "", "SI", "705", "", "G4", "", "", "46.0458", "14.39186", "Europe/Ljubljana"),("3201927", "Dobrna", "", "SI", "705", "", "G3", "", "", "46.3375", "15.22639", "Europe/Ljubljana"),("3201988", "Dobje pri Planini", "", "SI", "705", "", "G2", "", "", "46.13747", "15.39412", "Europe/Ljubljana"),("3202019", "Divača", "", "SI", "705", "", "19", "", "", "45.68472", "13.97028", "Europe/Ljubljana"),("3202058", "Destrnik", "", "SI", "705", "", "G1", "", "", "46.49254", "15.87893", "Europe/Ljubljana"),("3202333", "Črnomelj", "", "SI", "705", "", "17", "", "", "45.57111", "15.18889", "Europe/Ljubljana"),("3202459", "Črna na Koroškem", "", "SI", "705", "", "16", "", "", "46.47045", "14.85009", "Europe/Ljubljana"),("3202524", "Črenšovci", "", "SI", "705", "", "15", "", "", "46.55794", "16.3041", "Europe/Ljubljana"),("3202704", "Cerkvenjak", "", "SI", "705", "", "F9", "", "", "46.57056", "15.94361", "Europe/Ljubljana"),("3202709", "Cerknica", "", "SI", "705", "", "13", "", "", "45.79306", "14.3625", "Europe/Ljubljana"),("3202711", "Cerklje na Gorenjskem", "", "SI", "705", "", "12", "", "", "46.25417", "14.48861", "Europe/Ljubljana"),("3202781", "Celje", "Целе", "SI", "705", "", "11", "", "", "46.23092", "15.26044", "Europe/Ljubljana"),("3202877", "Cankova", "", "SI", "705", "", "F8", "", "", "46.72083", "16.0225", "Europe/Ljubljana"),("3203338", "Brezovica pri Ljubljani", "", "SI", "705", "", "09", "3196350", "", "46.03333", "14.4", "Europe/Ljubljana"),("3203412", "Brežice", "", "SI", "705", "", "08", "", "", "45.90333", "15.59111", "Europe/Ljubljana"),("3203550", "Braslovče", "", "SI", "705", "", "F7", "", "", "46.28972", "15.03889", "Europe/Ljubljana"),("3203611", "Bovec", "", "SI", "705", "", "06", "", "", "46.3375", "13.55278", "Europe/Ljubljana"),("3203677", "Borovnica", "", "SI", "705", "", "05", "", "", "45.91583", "14.36306", "Europe/Ljubljana"),("3203808", "Bohinjska Bistrica", "", "SI", "705", "", "04", "", "", "46.27216", "13.9535", "Europe/Ljubljana"),("3203925", "Bled", "", "SI", "705", "", "03", "", "", "46.36917", "14.11361", "Europe/Ljubljana"),("3204044", "Bistrica ob Sotli", "", "SI", "705", "", "F5", "", "", "46.05889", "15.66417", "Europe/Ljubljana"),("3204296", "Benedikt", "", "SI", "705", "", "F4", "", "", "46.60861", "15.88833", "Europe/Ljubljana"),("3204303", "Beltinci", "", "SI", "705", "", "02", "", "", "46.60528", "16.24056", "Europe/Ljubljana"),("3204796", "Apače", "", "SI", "705", "", "N9", "", "", "46.69722", "15.91056", "Europe/Ljubljana"),("3204854", "Ajdovščina", "", "SI", "705", "", "01", "", "", "45.88601", "13.90946", "Europe/Ljubljana"),("3215453", "Razkrižje", "", "SI", "705", "", "K9", "", "", "46.52167", "16.28111", "Europe/Ljubljana"),("3218364", "Cerkno", "", "SI", "705", "", "14", "", "", "46.12556", "13.98167", "Europe/Ljubljana"),("3218745", "Leskova Dolina", "", "SI", "705", "", "I7", "", "", "45.62139", "14.46056", "Europe/Ljubljana"),("3218907", "Logatec", "", "SI", "705", "", "64", "", "", "45.91444", "14.22583", "Europe/Ljubljana"),("3220262", "Ankaran", "", "SI", "705", "", "P9", "", "", "45.57861", "13.73611", "Europe/Ljubljana"),("3339111", "Videm pri Ptuju", "", "SI", "705", "", "N2", "", "", "46.36861", "15.90639", "Europe/Ljubljana"),("3339120", "Zreče", "", "SI", "705", "", "F3", "", "", "46.38222", "15.37917", "Europe/Ljubljana"),("3339128", "Selnica ob Dravi", "", "SI", "705", "", "L5", "", "", "46.55", "15.495", "Europe/Ljubljana"),("3343512", "Lucija", "", "SI", "705", "", "J9", "", "", "45.50526", "13.6024", "Europe/Ljubljana"),("6956384", "Cirkulane", "", "SI", "705", "", "O1", "", "", "46.34408", "15.99472", "Europe/Ljubljana"),("6956393", "Komenda", "", "SI", "705", "", "H8", "", "", "46.20484", "14.53839", "Europe/Ljubljana"),("8358612", "Nazarje", "", "SI", "705", "", "83", "", "", "46.31757", "14.94674", "Europe/Ljubljana"),("8358613", "Kostel", "", "SI", "705", "", "H9", "", "", "45.50842", "14.91005", "Europe/Ljubljana"),("723195", "Vranov nad Topľou", "Вранов-над-Топлёу", "SK", "703", "", "05", "", "", "48.88836", "21.68479", "Europe/Bratislava"),("723358", "Trebišov", "Требишов", "SK", "703", "", "03", "", "", "48.62858", "21.71954", "Europe/Bratislava"),("723411", "Svit", "", "SK", "703", "", "05", "706", "", "49.06014", "20.20695", "Europe/Bratislava"),("723417", "Svidník", "", "SK", "703", "", "05", "", "", "49.30819", "21.5703", "Europe/Bratislava"),("723455", "Stropkov", "", "SK", "703", "", "05", "", "", "49.20211", "21.65216", "Europe/Bratislava"),("723505", "Stará Ľubovňa", "Стара Любовня", "SK", "703", "", "05", "", "", "49.29859", "20.6862", "Europe/Bratislava"),("723526", "Spišská Nová Ves", "Спишска Нова Вес", "SK", "703", "", "03", "", "", "48.94464", "20.56153", "Europe/Bratislava"),("723529", "Spišská Belá", "", "SK", "703", "", "05", "", "", "49.18725", "20.45948", "Europe/Bratislava"),("723554", "Sobrance", "", "SK", "703", "", "03", "", "", "48.74455", "22.18136", "Europe/Bratislava"),("723559", "Snina", "Снина", "SK", "703", "", "05", "", "", "48.98857", "22.15099", "Europe/Bratislava"),("723637", "Sečovce", "", "SK", "703", "", "03", "", "", "48.70074", "21.66104", "Europe/Bratislava"),("723674", "Sabinov", "", "SK", "703", "", "05", "", "", "49.10309", "21.0988", "Europe/Bratislava"),("723713", "Rožňava", "Рожнява", "SK", "703", "", "03", "", "", "48.66009", "20.53758", "Europe/Bratislava"),("723736", "Rimavská Sobota", "Римавска Собота", "SK", "703", "", "01", "", "", "48.38284", "20.02239", "Europe/Bratislava"),("723747", "Revúca", "", "SK", "703", "", "01", "", "", "48.68346", "20.11734", "Europe/Bratislava"),("723819", "Prešov", "Прешов", "SK", "703", "", "05", "707", "", "48.99839", "21.23393", "Europe/Bratislava"),("723846", "Poprad", "Попрад", "SK", "703", "", "05", "706", "", "49.06144", "20.29798", "Europe/Bratislava"),("724111", "Moldava nad Bodvou", "", "SK", "703", "", "03", "", "", "48.61428", "20.99957", "Europe/Bratislava"),("724144", "Michalovce", "Михаловце", "SK", "703", "", "03", "", "", "48.75434", "21.9195", "Europe/Bratislava"),("724156", "Medzilaborce", "", "SK", "703", "", "05", "", "", "49.27195", "21.90073", "Europe/Bratislava"),("724286", "Lipany", "", "SK", "703", "", "05", "", "", "49.15376", "20.96382", "Europe/Bratislava"),("724294", "Levoča", "", "SK", "703", "", "05", "704", "", "49.02173", "20.59212", "Europe/Bratislava"),("724377", "Krompachy", "", "SK", "703", "", "03", "", "", "48.91447", "20.87514", "Europe/Bratislava"),("724443", "Košice", "Кошице", "SK", "703", "", "03", "", "", "48.71395", "21.25808", "Europe/Bratislava"),("724503", "Kežmarok", "Кежмарок", "SK", "703", "", "05", "707", "", "49.13571", "20.43352", "Europe/Bratislava"),("724627", "Humenné", "Гуменне", "SK", "703", "", "05", "", "", "48.93707", "21.91625", "Europe/Bratislava"),("724800", "Gelnica", "", "SK", "703", "", "03", "", "", "48.85584", "20.93713", "Europe/Bratislava"),("724969", "Chlmec", "", "SK", "703", "", "05", "", "", "48.88628", "21.9393", "Europe/Bratislava"),("725168", "Bardejov", "Бардейов", "SK", "703", "", "05", "701", "", "49.29175", "21.27271", "Europe/Bratislava"),("3056459", "Zvolen", "Зволен", "SK", "703", "", "01", "611", "", "48.57442", "19.15324", "Europe/Bratislava"),("3056495", "Zlaté Moravce", "", "SK", "703", "", "04", "", "", "48.38553", "18.40063", "Europe/Bratislava"),("3056508", "Žilina", "Жилина", "SK", "703", "", "08", "511", "", "49.22315", "18.73941", "Europe/Bratislava"),("3056523", "Žiar nad Hronom", "", "SK", "703", "", "01", "", "", "48.59184", "18.84958", "Europe/Bratislava"),("3056547", "Želiezovce", "", "SK", "703", "", "04", "", "", "48.05075", "18.65421", "Europe/Bratislava"),("3056589", "Žarnovica", "", "SK", "703", "", "01", "", "", "48.48123", "18.71565", "Europe/Bratislava"),("3056683", "Vrútky", "", "SK", "703", "", "08", "511", "", "49.11328", "18.91714", "Europe/Bratislava"),("3056697", "Vrbové", "", "SK", "703", "", "07", "", "", "48.61973", "17.7226", "Europe/Bratislava"),("3056711", "Vráble", "", "SK", "703", "", "04", "403", "", "48.24371", "18.30846", "Europe/Bratislava"),("3056816", "Veľký Meder", "", "SK", "703", "", "07", "201", "", "47.85798", "17.76884", "Europe/Bratislava"),("3056825", "Veľký Krtíš", "", "SK", "703", "", "01", "", "", "48.21059", "19.35043", "Europe/Bratislava"),("3057063", "Tvrdošín", "", "SK", "703", "", "08", "", "", "49.337", "19.556", "Europe/Bratislava"),("3057069", "Turzovka", "", "SK", "703", "", "08", "", "", "49.40429", "18.62258", "Europe/Bratislava"),("3057108", "Trstená", "", "SK", "703", "", "08", "511", "", "49.36101", "19.61249", "Europe/Bratislava"),("3057124", "Trnava", "Трнава", "SK", "703", "", "07", "207", "", "48.37741", "17.58723", "Europe/Bratislava"),("3057140", "Trenčín", "Тренчин", "SK", "703", "", "06", "309", "", "48.89452", "18.04436", "Europe/Bratislava");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("3057339", "Šurany", "", "SK", "703", "", "04", "", "", "48.08613", "18.18447", "Europe/Bratislava"),("3057379", "Štúrovo", "", "SK", "703", "", "04", "404", "", "47.79495", "18.7175", "Europe/Bratislava"),("3057384", "Stupava", "", "SK", "703", "", "02", "106", "", "48.27474", "17.03173", "Europe/Bratislava"),("3057480", "Stará Turá", "", "SK", "703", "", "06", "", "", "48.77721", "17.69433", "Europe/Bratislava"),("3057602", "Sládkovičovo", "", "SK", "703", "", "07", "", "", "48.20137", "17.63852", "Europe/Bratislava"),("3057630", "Skalica", "", "SK", "703", "", "07", "206", "", "48.8449", "17.22635", "Europe/Bratislava"),("3057691", "Senica", "Сеница", "SK", "703", "", "07", "205", "", "48.67922", "17.36697", "Europe/Bratislava"),("3057692", "Senec", "", "SK", "703", "", "02", "", "", "48.21951", "17.40043", "Europe/Bratislava"),("3057757", "Šamorín", "", "SK", "703", "", "07", "", "", "48.03015", "17.30972", "Europe/Bratislava"),("3057769", "Sellye", "Шаля", "SK", "703", "", "04", "", "", "48.15127", "17.88062", "Europe/Bratislava"),("3057772", "Šahy", "", "SK", "703", "", "04", "", "", "48.07408", "18.94946", "Europe/Bratislava"),("3057789", "Ružomberok", "Ружомберок", "SK", "703", "", "08", "", "", "49.0748", "19.30751", "Europe/Bratislava"),("3057910", "Rajec", "", "SK", "703", "", "08", "", "", "49.08899", "18.64007", "Europe/Bratislava"),("3057963", "Púchov", "Пухов", "SK", "703", "", "04", "", "", "49.12494", "18.32597", "Europe/Bratislava"),("3058000", "Prievidza", "Прьевидза", "SK", "703", "", "04", "", "", "48.77446", "18.6275", "Europe/Bratislava"),("3058060", "Považská Bystrica", "Поважска-Бистрица", "SK", "703", "", "06", "306", "", "49.12153", "18.42169", "Europe/Bratislava"),("3058083", "Poltár", "", "SK", "703", "", "01", "", "", "48.43094", "19.79408", "Europe/Bratislava"),("3058202", "Piešťany", "Пьештяны", "SK", "703", "", "07", "207", "", "48.59479", "17.82591", "Europe/Bratislava"),("3058210", "Pezinok", "Пезинок", "SK", "703", "", "02", "107", "", "48.28986", "17.26664", "Europe/Bratislava"),("3058268", "Partizánske", "Партизанске", "SK", "703", "", "04", "", "", "48.62861", "18.38455", "Europe/Bratislava"),("3058472", "Nové Zámky", "Нове Замки", "SK", "703", "", "04", "404", "", "47.98544", "18.16195", "Europe/Bratislava"),("3058477", "Nové Mesto nad Váhom", "", "SK", "703", "", "06", "304", "", "48.75763", "17.8309", "Europe/Bratislava"),("3058496", "Nová Dubnica", "", "SK", "703", "", "06", "", "", "48.93479", "18.14632", "Europe/Bratislava"),("3058498", "Nová Baňa", "", "SK", "703", "", "01", "", "", "48.42305", "18.64037", "Europe/Bratislava"),("3058531", "Nitra", "Нитра", "SK", "703", "", "04", "403", "", "48.30763", "18.08453", "Europe/Bratislava"),("3058546", "Nemšová", "", "SK", "703", "", "04", "", "", "48.96702", "18.11892", "Europe/Bratislava"),("3058579", "Námestovo", "", "SK", "703", "", "08", "", "", "49.4079", "19.48032", "Europe/Bratislava"),("3058611", "Myjava", "", "SK", "703", "", "06", "303", "", "48.75876", "17.56866", "Europe/Bratislava"),("3058663", "Modra", "", "SK", "703", "", "02", "", "", "48.33397", "17.30711", "Europe/Bratislava"),("3058780", "Martin", "Мартин", "SK", "703", "", "08", "506", "", "49.06651", "18.92399", "Europe/Bratislava"),("3058897", "Malacky", "Малацки", "SK", "703", "", "02", "106", "", "48.43604", "17.02188", "Europe/Bratislava"),("3058986", "Lučenec", "Лученец", "SK", "703", "", "01", "", "", "48.33249", "19.66708", "Europe/Bratislava"),("3059050", "Liptovský Mikuláš", "Липтовски Микулаш", "SK", "703", "", "08", "505", "", "49.08061", "19.62218", "Europe/Bratislava"),("3059053", "Liptovský Hrádok", "", "SK", "703", "", "08", "511", "", "49.03962", "19.72335", "Europe/Bratislava"),("3059101", "Levice", "Левице", "SK", "703", "", "04", "", "", "48.21563", "18.60705", "Europe/Bratislava"),("3059179", "Kysucké Nové Mesto", "Кисуцке Нове Место", "SK", "703", "", "08", "", "", "49.3", "18.78333", "Europe/Bratislava"),("3059244", "Krupina", "", "SK", "703", "", "01", "", "", "48.3554", "19.06474", "Europe/Bratislava"),("3059282", "Kremnica", "", "SK", "703", "", "01", "613", "", "48.70519", "18.91834", "Europe/Bratislava"),("3059436", "Komárno", "Комарно", "SK", "703", "", "04", "", "", "47.76356", "18.12263", "Europe/Bratislava"),("3059448", "Kolárovo", "", "SK", "703", "", "04", "", "", "47.92294", "17.98467", "Europe/Bratislava"),("3059767", "Ivanka pri Dunaji", "", "SK", "703", "", "02", "108", "", "48.18675", "17.2554", "Europe/Bratislava"),("3059796", "Ilava", "", "SK", "703", "", "04", "", "", "48.99769", "18.2353", "Europe/Bratislava"),("3059821", "Hurbanovo", "", "SK", "703", "", "04", "401", "", "47.86984", "18.19233", "Europe/Bratislava"),("3059870", "Hriňová", "", "SK", "703", "", "01", "", "", "48.57787", "19.52574", "Europe/Bratislava"),("3060077", "Holíč", "", "SK", "703", "", "07", "206", "", "48.81105", "17.16238", "Europe/Bratislava"),("3060095", "Hlohovec", "Глоговец", "SK", "703", "", "07", "", "", "48.43174", "17.8031", "Europe/Bratislava"),("3060139", "Handlová", "", "SK", "703", "", "04", "", "", "48.7276", "18.76012", "Europe/Bratislava"),("3060208", "Gbely", "", "SK", "703", "", "07", "", "", "48.718", "17.11628", "Europe/Bratislava"),("3060219", "Galanta", "Галанта", "SK", "703", "", "07", "202", "", "48.19001", "17.72747", "Europe/Bratislava"),("3060224", "Gabčíkovo", "", "SK", "703", "", "07", "", "", "47.89211", "17.57884", "Europe/Bratislava"),("3060242", "Fiľakovo", "", "SK", "703", "", "01", "", "", "48.26757", "19.82473", "Europe/Bratislava"),("3060280", "Bratislava - Vajnory", "", "SK", "703", "", "02", "103", "", "48.20563", "17.20759", "Europe/Bratislava"),("3060308", "Dunajská Streda", "Дунайска-Стреда", "SK", "703", "", "07", "", "", "47.99268", "17.61211", "Europe/Bratislava"),("3060346", "Dubnica nad Váhom", "Дубница-над-Вагом", "SK", "703", "", "06", "302", "", "48.95981", "18.16634", "Europe/Bratislava"),("3060405", "Dolný Kubín", "Долны Кубин", "SK", "703", "", "08", "503", "", "49.20983", "19.30341", "Europe/Bratislava"),("3060589", "Detva", "Детва", "SK", "703", "", "01", "", "", "48.56082", "19.41954", "Europe/Bratislava"),("3060665", "Čierny Balog", "", "SK", "703", "", "01", "", "", "48.74722", "19.65125", "Europe/Bratislava"),("3060835", "Čadca", "Чадца", "SK", "703", "", "08", "502", "", "49.43503", "18.78895", "Europe/Bratislava"),("3060852", "Bytča", "", "SK", "703", "", "08", "501", "", "49.22404", "18.55878", "Europe/Bratislava"),("3060942", "Brezová pod Bradlom", "", "SK", "703", "", "06", "", "", "48.66349", "17.53905", "Europe/Bratislava"),("3060950", "Brezno", "Брезно", "SK", "703", "", "01", "603", "", "48.80431", "19.63631", "Europe/Bratislava"),("3060972", "Bratislava", "Братислава", "SK", "703", "", "02", "", "", "48.14816", "17.10674", "Europe/Bratislava"),("3061015", "Bojnice", "", "SK", "703", "", "04", "", "", "48.78511", "18.5864", "Europe/Bratislava"),("3061184", "Banská Štiavnica", "", "SK", "703", "", "01", "601", "", "48.44858", "18.91003", "Europe/Bratislava"),("3061186", "Banská Bystrica", "Банска-Бистрица", "SK", "703", "", "01", "601", "", "48.73946", "19.15349", "Europe/Bratislava"),("3061188", "Bánovce nad Bebravou", "", "SK", "703", "", "06", "301", "", "48.7213", "18.25754", "Europe/Bratislava"),("2402816", "Yengema", "", "SL", "694", "", "01", "", "", "8.71441", "-11.17057", "Africa/Freetown"),("2403094", "Waterloo", "", "SL", "694", "", "04", "", "", "8.3389", "-13.07091", "Africa/Freetown"),("2403324", "Tombodu", "", "SL", "694", "", "01", "", "", "8.13526", "-10.6196", "Africa/Freetown"),("2403407", "Tintafor", "", "SL", "694", "", "02", "", "", "8.62667", "-13.215", "Africa/Freetown"),("2403698", "Sumbuya", "", "SL", "694", "", "03", "", "", "7.64789", "-11.9606", "Africa/Freetown"),("2404041", "Segbwema", "", "SL", "694", "", "01", "", "", "7.99471", "-10.9502", "Africa/Freetown"),("2404303", "Rokupr", "", "SL", "694", "", "02", "", "", "8.67121", "-12.38497", "Africa/Freetown"),("2404433", "Port Loko", "Порт-Локо", "SL", "694", "", "02", "", "", "8.76609", "-12.78696", "Africa/Freetown"),("2404614", "Pendembu", "", "SL", "694", "", "01", "", "", "8.09807", "-10.69429", "Africa/Freetown"),("2404663", "Panguma", "", "SL", "694", "", "01", "", "", "8.18507", "-11.1329", "Africa/Freetown"),("2405013", "Moyamba", "", "SL", "694", "", "03", "", "", "8.15898", "-12.43168", "Africa/Freetown"),("2405038", "Motema", "", "SL", "694", "", "01", "", "", "8.61427", "-11.01252", "Africa/Freetown"),("2405729", "Masingbi", "", "SL", "694", "", "02", "", "", "8.78197", "-11.95171", "Africa/Freetown"),("2406142", "Mamboma", "", "SL", "694", "", "03", "", "", "8.08742", "-11.68841", "Africa/Freetown"),("2406145", "Mambolo", "", "SL", "694", "", "02", "", "", "8.9186", "-13.03674", "Africa/Freetown"),("2406407", "Makeni", "Макени", "SL", "694", "", "02", "", "", "8.88605", "-12.04417", "Africa/Freetown"),("2406576", "Magburaka", "", "SL", "694", "", "02", "", "", "8.72306", "-11.9488", "Africa/Freetown"),("2406916", "Lunsar", "Лунсаре", "SL", "694", "", "02", "", "", "8.68439", "-12.53499", "Africa/Freetown"),("2407262", "Kukuna", "", "SL", "694", "", "02", "", "", "9.39841", "-12.66476", "Africa/Freetown"),("2407656", "Koidu", "", "SL", "694", "", "01", "", "", "8.64387", "-10.9714", "Africa/Freetown"),("2407790", "Kenema", "Кенеме", "SL", "694", "", "01", "", "", "7.87687", "-11.19025", "Africa/Freetown"),("2407899", "Kassiri", "", "SL", "694", "", "02", "", "", "8.93814", "-13.11541", "Africa/Freetown"),("2408088", "Kambia", "", "SL", "694", "", "02", "", "", "9.12504", "-12.91816", "Africa/Freetown"),("2408154", "Kamakwie", "", "SL", "694", "", "02", "", "", "9.49689", "-12.24061", "Africa/Freetown"),("2408250", "Kailahun", "", "SL", "694", "", "01", "", "", "8.2789", "-10.573", "Africa/Freetown"),("2408329", "Kabala", "", "SL", "694", "", "02", "", "", "9.58893", "-11.55256", "Africa/Freetown"),("2408582", "Hastings", "", "SL", "694", "", "04", "", "", "8.37994", "-13.13693", "Africa/Freetown"),("2408585", "Hangha", "", "SL", "694", "", "01", "", "", "7.93974", "-11.14132", "Africa/Freetown"),("2408770", "Freetown", "", "SL", "694", "", "04", "", "", "8.43194", "-13.28972", "Africa/Freetown"),("2409214", "Gandorhun", "", "SL", "694", "", "03", "", "", "7.55502", "-11.6926", "Africa/Freetown"),("2409215", "Gandorhun", "", "SL", "694", "", "03", "", "", "7.49431", "-11.83064", "Africa/Freetown"),("2409306", "Freetown", "Фритаун", "SL", "694", "", "04", "", "", "8.484", "-13.22994", "Africa/Freetown"),("2409382", "Foindu", "", "SL", "694", "", "03", "", "", "7.40906", "-11.54328", "Africa/Freetown"),("2409663", "Daru", "", "SL", "694", "", "01", "", "", "7.98976", "-10.84223", "Africa/Freetown"),("2409751", "Buedu", "", "SL", "694", "", "01", "", "", "8.2796", "-10.37135", "Africa/Freetown"),("2409783", "Bunumbu", "", "SL", "694", "", "01", "", "", "8.17421", "-10.86432", "Africa/Freetown"),("2409823", "Bumpe", "", "SL", "694", "", "03", "", "", "7.89209", "-11.90541", "Africa/Freetown"),("2409914", "Bonthe", "", "SL", "694", "", "03", "", "", "7.52639", "-12.505", "Africa/Freetown"),("2409970", "Bomi", "", "SL", "694", "", "03", "", "", "7.24611", "-11.52583", "Africa/Freetown"),("2410040", "Boajibu", "", "SL", "694", "", "01", "", "", "8.18763", "-11.34026", "Africa/Freetown"),("2410048", "Bo", "Бо", "SL", "694", "", "03", "", "", "7.96472", "-11.73833", "Africa/Freetown"),("2410065", "Blama", "", "SL", "694", "", "01", "", "", "7.87481", "-11.34548", "Africa/Freetown"),("2410090", "Binkolo", "", "SL", "694", "", "02", "", "", "8.95225", "-11.98029", "Africa/Freetown"),("2410312", "Barma", "", "SL", "694", "", "01", "", "", "8.34959", "-11.33059", "Africa/Freetown"),("2410380", "Baoma", "", "SL", "694", "", "03", "", "", "7.99344", "-11.71468", "Africa/Freetown"),("2571039", "Pujehun", "", "SL", "694", "", "03", "", "", "7.35806", "-11.72083", "Africa/Freetown"),("2243940", "Ziguinchor", "Зигиншор", "SN", "686", "", "12", "", "", "12.56801", "-16.27326", "Africa/Dakar"),("2244177", "Vélingara", "", "SN", "686", "", "11", "", "", "13.15", "-14.11667", "Africa/Dakar"),("2244322", "Touba", "", "SN", "686", "", "03", "", "", "14.85", "-15.88333", "Africa/Dakar"),("2244436", "Tionk Essil", "", "SN", "686", "", "12", "", "", "12.78556", "-16.52167", "Africa/Dakar"),("2244616", "Tiébo", "", "SN", "686", "", "03", "", "", "14.63333", "-16.23333", "Africa/Dakar"),("2244786", "Tiadiaye", "", "SN", "686", "", "07", "", "", "14.41667", "-16.7", "Africa/Dakar"),("2244799", "Thiès Nones", "", "SN", "686", "", "07", "", "", "14.78333", "-16.96667", "Africa/Dakar"),("2244802", "Thiès", "", "SN", "686", "", "07", "", "", "14.78944", "-16.92602", "Africa/Dakar"),("2244991", "Tambacounda", "", "SN", "686", "", "05", "", "", "13.77073", "-13.66734", "Africa/Dakar"),("2245241", "Sokone", "", "SN", "686", "", "09", "", "", "13.88333", "-16.36667", "Africa/Dakar"),("2245666", "Sémé", "", "SN", "686", "", "15", "", "", "15.19422", "-12.94482", "Africa/Dakar"),("2245704", "Sédhiou", "", "SN", "686", "", "18", "", "", "12.70806", "-15.55694", "Africa/Dakar"),("2246452", "Saint-Louis", "Сен-Луи", "SN", "686", "SN", "14", "", "", "16.01793", "-16.48962", "Africa/Dakar"),("2246522", "Rosso", "", "SN", "686", "", "14", "", "", "16.42028", "-15.79834", "Africa/Dakar"),("2246544", "Richard-Toll", "", "SN", "686", "", "14", "", "", "16.4625", "-15.70083", "Africa/Dakar"),("2246606", "Pout", "", "SN", "686", "", "07", "", "", "14.77099", "-17.06107", "Africa/Dakar"),("2246608", "Pourham", "", "SN", "686", "", "09", "", "", "14.35", "-16.41667", "Africa/Dakar"),("2246678", "Pikine", "Пикин", "SN", "686", "", "01", "", "", "14.76457", "-17.39071", "Africa/Dakar"),("2246780", "Passi", "", "SN", "686", "", "09", "", "", "13.98333", "-16.26667", "Africa/Dakar"),("2246922", "Ouro Sogui", "", "SN", "686", "", "15", "", "", "15.60588", "-13.3223", "Africa/Dakar"),("2247044", "Waoundé", "", "SN", "686", "", "15", "", "", "15.26367", "-12.86821", "Africa/Dakar"),("2247157", "Nioro du Rip", "", "SN", "686", "", "10", "", "", "13.75", "-15.8", "Africa/Dakar"),("2247381", "Nguékhokh", "", "SN", "686", "", "07", "", "", "14.51255", "-17.00447", "Africa/Dakar"),("2247660", "Ndofane", "", "SN", "686", "", "10", "", "", "13.91667", "-15.93333", "Africa/Dakar"),("2247684", "Ndioum", "", "SN", "686", "", "14", "", "", "16.51293", "-14.64706", "Africa/Dakar"),("2247813", "Ndibène Dahra", "", "SN", "686", "", "13", "", "", "15.3338", "-15.4766", "Africa/Dakar"),("2248409", "Mékhé", "", "SN", "686", "", "07", "", "", "15.1097", "-16.6218", "Africa/Dakar"),("2248698", "Mbaké", "", "SN", "686", "SN", "03", "", "", "14.79032", "-15.90803", "Africa/Dakar"),("2248752", "Matam", "", "SN", "686", "", "15", "", "", "15.65587", "-13.25544", "Africa/Dakar"),("2248777", "Marsassoum", "", "SN", "686", "", "11", "", "", "12.8275", "-15.98056", "Africa/Dakar"),("2249222", "Louga", "", "SN", "686", "", "13", "", "", "15.61867", "-16.22436", "Africa/Dakar"),("2249554", "Koungheul", "", "SN", "686", "", "16", "", "", "13.98333", "-14.8", "Africa/Dakar"),("2249782", "Kolda", "Колда", "SN", "686", "", "11", "", "", "12.8939", "-14.94125", "Africa/Dakar"),("2249901", "Khombole", "", "SN", "686", "", "07", "", "", "14.76667", "-16.7", "Africa/Dakar"),("2250645", "Kédougou", "", "SN", "686", "", "17", "", "", "12.55561", "-12.18076", "Africa/Dakar"),("2250677", "Kayar", "", "SN", "686", "", "07", "", "", "14.91893", "-17.11978", "Africa/Dakar"),("2250805", "Kaolack", "", "SN", "686", "", "10", "", "", "14.15197", "-16.07259", "Africa/Dakar"),("2250849", "Kanel", "", "SN", "686", "", "15", "", "", "15.4916", "-13.17627", "Africa/Dakar"),("2251007", "Kaffrine", "", "SN", "686", "", "16", "", "", "14.10594", "-15.5508", "Africa/Dakar"),("2251084", "Joal-Fadiout", "", "SN", "686", "", "07", "", "", "14.16667", "-16.83333", "Africa/Dakar"),("2251230", "Guinguinéo", "", "SN", "686", "", "09", "", "", "14.26667", "-15.95", "Africa/Dakar"),("2251292", "Guéoul", "", "SN", "686", "SN", "13", "", "", "15.48333", "-16.35", "Africa/Dakar"),("2251544", "Goléré", "", "SN", "686", "", "14", "", "", "16.25575", "-14.10165", "Africa/Dakar"),("2251688", "Gandiaye", "", "SN", "686", "", "10", "", "", "14.23333", "-16.26667", "Africa/Dakar"),("2251791", "Foundiougne", "", "SN", "686", "", "09", "", "", "14.13333", "-16.46667", "Africa/Dakar"),("2251911", "Fatick", "", "SN", "686", "", "09", "", "", "14.33236", "-16.40513", "Africa/Dakar"),("2252309", "Diourbel", "", "SN", "686", "SN", "03", "", "", "14.64792", "-16.24363", "Africa/Dakar"),("2252473", "Diofior", "", "SN", "686", "", "09", "", "", "14.18333", "-16.66667", "Africa/Dakar"),("2252606", "Diawara", "", "SN", "686", "", "15", "", "", "15.02196", "-12.54374", "Africa/Dakar"),("2253277", "Dara", "Дар", "SN", "686", "SN", "13", "", "", "15.34844", "-15.47993", "Africa/Dakar"),("2253354", "Dakar", "Дакар", "SN", "686", "", "01", "", "", "14.6937", "-17.44406", "Africa/Dakar"),("2253901", "Bignona", "", "SN", "686", "", "12", "", "", "12.81028", "-16.22639", "Africa/Dakar"),("8030383", "Mermoz Boabab", "", "SN", "686", "", "01", "", "", "14.70649", "-17.47581", "Africa/Dakar"),("11101616", "N’diareme limamoulaye", "", "SN", "686", "", "01", "", "", "14.78148", "-17.3841", "Africa/Dakar"),("49593", "Yeed", "", "SO", "706", "", "01", "", "", "4.55", "43.03333", "Africa/Mogadishu"),("49747", "Xuddur", "", "SO", "706", "", "01", "", "", "4.12129", "43.88945", "Africa/Mogadishu"),("50672", "Wanlaweyn", "", "SO", "706", "", "14", "", "", "2.6185", "44.8938", "Africa/Mogadishu"),("50814", "Waajid", "", "SO", "706", "", "01", "", "", "3.80958", "43.24627", "Africa/Mogadishu"),("52381", "Saacow", "", "SO", "706", "", "08", "", "", "1.62794", "42.44067", "Africa/Mogadishu"),("52867", "Qoryooley", "", "SO", "706", "", "14", "", "", "1.78784", "44.52999", "Africa/Mogadishu"),("53157", "Qandala", "", "SO", "706", "", "03", "", "", "11.47197", "49.87282", "Africa/Mogadishu"),("53372", "Oodweyne", "", "SO", "706", "", "19", "", "", "9.4092", "45.06397", "Africa/Mogadishu"),("53654", "Mogadishu", "Могадишо", "SO", "706", "", "02", "", "", "2.03711", "45.34375", "Africa/Mogadishu"),("54225", "Marka", "", "SO", "706", "", "14", "", "", "1.71594", "44.77166", "Africa/Mogadishu"),("54460", "Mahaddayweyne", "", "SO", "706", "", "13", "", "", "2.9726", "45.5347", "Africa/Mogadishu"),("54715", "Luuq", "Лук", "SO", "706", "", "06", "", "", "3.80315", "42.54417", "Africa/Mogadishu"),("55223", "Las Khorey", "", "SO", "706", "", "12", "", "", "11.1595", "48.1967", "Africa/Mogadishu"),("55671", "Kismayo", "", "SO", "706", "", "09", "", "", "-0.35817", "42.54536", "Africa/Mogadishu"),("56166", "Jilib", "Джилиб", "SO", "706", "", "08", "", "", "0.48829", "42.78535", "Africa/Mogadishu"),("56335", "Jawhar", "", "SO", "706", "", "13", "", "", "2.78087", "45.50048", "Africa/Mogadishu"),("56399", "Jamaame", "", "SO", "706", "", "09", "", "", "0.06968", "42.74497", "Africa/Mogadishu"),("56414", "Jalalaqsi", "", "SO", "706", "", "07", "", "", "3.3766", "45.5996", "Africa/Mogadishu"),("56505", "Iskushuban", "", "SO", "706", "", "03", "", "", "10.2837", "50.23", "Africa/Mogadishu"),("57000", "Hobyo", "", "SO", "706", "", "10", "", "", "5.3505", "48.5268", "Africa/Mogadishu"),("57289", "Hargeysa", "Харгейсе", "SO", "706", "", "20", "", "", "9.56", "44.065", "Africa/Mogadishu"),("58933", "Garoowe", "", "SO", "706", "", "18", "", "", "8.40207", "48.48284", "Africa/Mogadishu"),("58994", "Garbahaarrey", "", "SO", "706", "", "06", "", "", "3.32892", "42.22091", "Africa/Mogadishu"),("59611", "Gaalkacyo", "Галькайо", "SO", "706", "", "10", "", "", "6.76972", "47.43083", "Africa/Mogadishu"),("60019", "Eyl", "", "SO", "706", "", "18", "", "", "7.9803", "49.8164", "Africa/Mogadishu"),("60928", "Dhuusamarreeb", "", "SO", "706", "", "05", "", "", "5.53597", "46.38666", "Africa/Mogadishu"),("62691", "Ceerigaabo", "", "SO", "706", "", "12", "", "", "10.61616", "47.36795", "Africa/Mogadishu"),("62788", "Ceeldheer", "", "SO", "706", "", "05", "", "", "3.84878", "47.18064", "Africa/Mogadishu"),("62821", "Ceelbuur", "", "SO", "706", "", "05", "", "", "4.68501", "46.6176", "Africa/Mogadishu"),("63344", "Cadale", "", "SO", "706", "", "13", "", "", "2.7603", "46.3222", "Africa/Mogadishu"),("63571", "Buurhakaba", "", "SO", "706", "", "04", "", "", "2.80257", "44.07805", "Africa/Mogadishu"),("63689", "Buulobarde", "", "SO", "706", "", "07", "", "", "3.85375", "45.56744", "Africa/Mogadishu"),("63795", "Burao", "Бурао", "SO", "706", "", "19", "", "", "9.52213", "45.53363", "Africa/Mogadishu"),("63949", "Bu’aale", "", "SO", "706", "", "08", "", "", "1.08333", "42.58333", "Africa/Mogadishu"),("64013", "Bosaso", "Босасо", "SO", "706", "", "03", "", "", "11.28421", "49.18158", "Africa/Mogadishu"),("64412", "Bereeda", "", "SO", "706", "", "03", "", "", "11.87037", "51.05795", "Africa/Mogadishu"),("64435", "Berbera", "Бербера", "SO", "706", "", "20", "", "", "10.43959", "45.01432", "Africa/Mogadishu"),("64460", "Beledweyne", "Беледуэйне", "SO", "706", "", "07", "", "", "4.73583", "45.20361", "Africa/Mogadishu"),("64536", "Baidoa", "Байдоа", "SO", "706", "", "04", "", "", "3.11383", "43.6498", "Africa/Mogadishu"),("64670", "Bargaal", "", "SO", "706", "", "03", "", "", "11.28636", "51.0773", "Africa/Mogadishu"),("64814", "Bandarbeyla", "", "SO", "706", "", "03", "", "", "9.4942", "50.8122", "Africa/Mogadishu"),("65170", "Baardheere", "", "SO", "706", "", "06", "", "", "2.34464", "42.27644", "Africa/Mogadishu"),("65785", "Afgooye", "Афгойе", "SO", "706", "", "14", "", "", "2.1381", "45.1212", "Africa/Mogadishu"),("400769", "Laascaanood", "", "SO", "706", "", "22", "", "", "8.47738", "47.35971", "Africa/Mogadishu"),("8045596", "Baki", "", "SO", "706", "", "21", "", "", "9.89206", "43.38531", "Africa/Mogadishu"),("2410763", "São Tomé", "Сан-Томе", "ST", "678", "", "02", "", "", "0.33654", "6.72732", "Africa/Sao_Tome"),("2410805", "Santo António", "", "ST", "678", "", "01", "", "", "1.63726", "7.41783", "Africa/Sao_Tome"),("162627", "Yabrūd", "Ябруд", "SY", "760", "", "08", "", "", "33.96921", "36.65729", "Asia/Damascus"),("163270", "Ţayyibat al Imām", "", "SY", "760", "", "10", "", "", "35.26592", "36.71219", "Asia/Damascus"),("163345", "Tartouss", "Тартус", "SY", "760", "", "14", "", "", "34.88902", "35.88659", "Asia/Damascus"),("163476", "Tall Rif‘at", "", "SY", "760", "", "09", "", "", "36.47229", "37.09471", "Asia/Damascus"),("163533", "Tallkalakh", "", "SY", "760", "", "11", "", "", "34.66842", "36.25995", "Asia/Damascus"),("163779", "Tallbīsah", "", "SY", "760", "", "11", "", "", "34.84072", "36.73092", "Asia/Damascus"),("163806", "Ţafas", "Тафас", "SY", "760", "", "06", "", "", "32.73709", "36.06654", "Asia/Damascus"),("163808", "Tadmur", "Пальмира", "SY", "760", "", "11", "", "", "34.5624", "38.28402", "Asia/Damascus"),("163811", "Tādif", "", "SY", "760", "", "09", "", "", "36.34814", "37.5309", "Asia/Damascus"),("163915", "Souran", "Суран", "SY", "760", "", "10", "", "", "35.29193", "36.74848", "Asia/Damascus"),("164025", "Subaykhān", "", "SY", "760", "", "07", "", "", "34.85305", "40.59987", "Asia/Damascus"),("164328", "Ash Shaykh Miskīn", "Шейх-Мискин", "SY", "760", "", "06", "", "", "32.82944", "36.15933", "Asia/Damascus"),("164626", "Shahbā", "", "SY", "760", "", "05", "", "", "32.85514", "36.62896", "Asia/Damascus"),("164816", "Sarāqib", "", "SY", "760", "", "12", "", "", "35.86447", "36.80591", "Asia/Damascus"),("164898", "Salqīn", "", "SY", "760", "", "12", "", "", "36.13951", "36.45413", "Asia/Damascus"),("164947", "As Salamīyah", "", "SY", "760", "", "10", "", "", "35.01127", "37.05324", "Asia/Damascus"),("164952", "Şalākhid", "", "SY", "760", "", "05", "", "", "32.87271", "36.57271", "Asia/Damascus"),("165060", "Satita", "", "SY", "760", "", "14", "", "", "34.82099", "36.11773", "Asia/Damascus"),("165929", "Qaţanā", "", "SY", "760", "", "08", "", "", "33.43757", "36.07888", "Asia/Damascus"),("165997", "Jāsim", "Джасим", "SY", "760", "", "06", "", "", "32.99233", "36.06018", "Asia/Damascus"),("166111", "Qārah", "", "SY", "760", "", "08", "", "", "34.15558", "36.74284", "Asia/Damascus"),("166331", "Nubl", "", "SY", "760", "", "09", "", "", "36.37867", "36.99294", "Asia/Damascus"),("166640", "Mūrak", "", "SY", "760", "", "10", "", "", "35.37615", "36.6897", "Asia/Damascus"),("166719", "Mukharram al Fawqānī", "", "SY", "760", "", "11", "", "", "34.81521", "37.08677", "Asia/Damascus"),("167046", "Maşyāf", "", "SY", "760", "", "10", "", "", "35.0653", "36.3406", "Asia/Damascus"),("167357", "Manbij", "", "SY", "760", "", "09", "", "", "36.52815", "37.95495", "Asia/Damascus"),("167605", "Ma‘arratmişrīn", "", "SY", "760", "", "12", "", "", "36.01152", "36.67183", "Asia/Damascus"),("168325", "Khān Shaykhūn", "", "SY", "760", "", "12", "", "", "35.44208", "36.65095", "Asia/Damascus"),("168620", "Kafr Zaytā", "", "SY", "760", "", "10", "", "", "35.37425", "36.6033", "Asia/Damascus"),("168629", "Kafr Takhārīm", "", "SY", "760", "", "12", "", "", "36.1168", "36.51522", "Asia/Damascus"),("168661", "Kafranbel", "", "SY", "760", "", "12", "167610", "", "35.61376", "36.56449", "Asia/Damascus"),("168668", "Kafr Lāhā", "", "SY", "760", "", "11", "", "", "34.89469", "36.49582", "Asia/Damascus"),("169023", "Jisr ash Shughūr", "", "SY", "760", "", "12", "", "", "35.81426", "36.32062", "Asia/Damascus"),("169113", "Jayrūd", "", "SY", "760", "", "08", "", "", "33.80709", "36.73861", "Asia/Damascus"),("169179", "Jarābulus", "", "SY", "760", "", "09", "", "", "36.8175", "38.01111", "Asia/Damascus"),("169304", "Jablah", "", "SY", "760", "", "02", "", "", "35.36211", "35.92759", "Asia/Damascus"),("169341", "Izra‘", "", "SY", "760", "", "06", "", "", "32.8706", "36.25453", "Asia/Damascus"),("169372", "‘Irbīn", "", "SY", "760", "", "08", "", "", "33.53719", "36.36635", "Asia/Damascus"),("169375", "Inkhil", "", "SY", "760", "", "06", "", "", "33.01809", "36.12828", "Asia/Damascus"),("169389", "Idlib", "Идлиб", "SY", "760", "", "12", "", "", "35.93062", "36.63393", "Asia/Damascus"),("169577", "Homs", "Хомс", "SY", "760", "", "11", "", "", "34.72682", "36.72339", "Asia/Damascus"),("169897", "Ḩarastā", "", "SY", "760", "", "08", "", "", "33.55869", "36.36515", "Asia/Damascus"),("170017", "Ḩamāh", "Хама", "SY", "760", "", "10", "", "", "35.13179", "36.75783", "Asia/Damascus"),("170044", "Ḩalfāyā", "", "SY", "760", "", "10", "", "", "35.26014", "36.60581", "Asia/Damascus"),("170063", "Aleppo", "Алеппо", "SY", "760", "", "09", "", "", "36.20124", "37.16117", "Asia/Damascus"),("170572", "Ad Duraykīsh", "", "SY", "760", "", "14", "", "", "34.89514", "36.14303", "Asia/Damascus"),("170592", "Douma", "Дума", "SY", "760", "", "08", "", "", "33.57175", "36.4027", "Asia/Damascus"),("170654", "Damascus", "Дамаск", "SY", "760", "", "13", "", "", "33.5102", "36.29128", "Asia/Damascus"),("170785", "Dayr Ḩāfir", "", "SY", "760", "", "09", "", "", "36.15694", "37.70778", "Asia/Damascus"),("170794", "Deir ez-Zor", "Дейр-эз-Зор", "SY", "760", "", "07", "", "", "35.33588", "40.14084", "Asia/Damascus"),("170817", "Dayr al ‘Aşāfīr", "", "SY", "760", "", "08", "", "", "33.46585", "36.42044", "Asia/Damascus"),("170887", "Ad Darbāsīyah", "", "SY", "760", "", "01", "", "", "37.07279", "40.65199", "Asia/Damascus"),("170892", "Dārayyā", "Дарайе", "SY", "760", "", "08", "", "", "33.45835", "36.23256", "Asia/Damascus"),("170905", "Dar‘ā", "Деръа", "SY", "760", "", "06", "", "", "32.61889", "36.10213", "Asia/Damascus"),("171451", "Binnish", "", "SY", "760", "", "12", "", "", "35.95664", "36.7138", "Asia/Damascus"),("171830", "Bāniyās", "Банияс", "SY", "760", "", "14", "", "", "35.18188", "35.94871", "Asia/Damascus"),("172059", "Az Zabadānī", "", "SY", "760", "", "08", "", "", "33.72488", "36.1005", "Asia/Damascus"),("172082", "I‘zāz", "Азаз", "SY", "760", "", "09", "", "", "36.58662", "37.04628", "Asia/Damascus"),("172256", "‘Ayn al ‘Arab", "", "SY", "760", "", "09", "", "", "36.89095", "38.35347", "Asia/Damascus"),("172349", "At Tall", "", "SY", "760", "", "08", "", "", "33.61033", "36.3107", "Asia/Damascus"),("172374", "Ath Thawrah", "", "SY", "760", "", "04", "", "", "35.83758", "38.54828", "Asia/Damascus"),("172408", "As Suwaydā’", "Эс-Сувейда", "SY", "760", "", "05", "", "", "32.70896", "36.56951", "Asia/Damascus"),("172469", "Aş Şanamayn", "Эс-Санамейн", "SY", "760", "", "06", "", "", "33.07186", "36.18316", "Asia/Damascus"),("172503", "As Safīrah", "", "SY", "760", "", "09", "", "", "36.07696", "37.37251", "Asia/Damascus"),("172946", "Ar Rastan", "", "SY", "760", "", "11", "", "", "34.92667", "36.73241", "Asia/Damascus"),("172955", "Ar Raqqah", "Ар-Ракка", "SY", "760", "", "04", "", "", "35.95283", "39.00788", "Asia/Damascus"),("173193", "An Nabk", "", "SY", "760", "", "08", "", "", "34.02403", "36.72848", "Asia/Damascus"),("173311", "Al Ghanţū", "", "SY", "760", "", "11", "", "", "34.82202", "36.69613", "Asia/Damascus"),("173312", "Al Quţayfah", "", "SY", "760", "", "08", "", "", "33.73848", "36.60071", "Asia/Damascus"),("173322", "Al Quşayr", "Аль-Кусайра", "SY", "760", "", "11", "", "", "34.5078", "36.58029", "Asia/Damascus"),("173334", "Al Qunayţirah", "Эль-Кунейтра", "SY", "760", "", "03", "", "", "33.12595", "35.82461", "Asia/Damascus"),("173361", "Al Qaryatayn", "", "SY", "760", "", "11", "", "", "34.22956", "37.24066", "Asia/Damascus"),("173480", "Al Mayādīn", "", "SY", "760", "", "07", "", "", "35.01982", "40.45154", "Asia/Damascus"),("173576", "Latakia", "Латакия", "SY", "760", "", "02", "", "", "35.53168", "35.79011", "Asia/Damascus"),("173598", "Al Kiswah", "", "SY", "760", "", "08", "", "", "33.3581", "36.2419", "Asia/Damascus"),("173811", "Al Ḩasakah", "", "SY", "760", "", "01", "", "", "36.50237", "40.74772", "Asia/Damascus"),("173819", "Al Ḩarāk", "", "SY", "760", "", "06", "", "", "32.74932", "36.30994", "Asia/Damascus"),("174018", "Al Bāb", "", "SY", "760", "", "09", "", "", "36.37051", "37.5157", "Asia/Damascus"),("174186", "‘Afrīn", "", "SY", "760", "", "09", "", "", "36.51194", "36.86954", "Asia/Damascus"),("174259", "Ad Dānā", "", "SY", "760", "", "12", "", "", "36.21252", "36.76978", "Asia/Damascus"),("174448", "Ālbū Kamāl", "Абу-Камаль", "SY", "760", "", "07", "", "", "34.45226", "40.91854", "Asia/Damascus"),("174506", "Hajīn", "", "SY", "760", "", "07", "", "", "34.69508", "40.83138", "Asia/Damascus"),("9847679", "Tremseh", "", "SY", "760", "", "10", "", "", "35.27181", "36.50395", "Asia/Damascus"),("934851", "Siteki", "", "SZ", "748", "", "02", "", "", "-26.45", "31.95", "Africa/Mbabane"),("934881", "Piggs Peak", "", "SZ", "748", "", "01", "", "", "-25.96082", "31.24666", "Africa/Mbabane"),("934913", "Nhlangano", "", "SZ", "748", "", "04", "", "", "-27.11667", "31.2", "Africa/Mbabane"),("934966", "Mhlume", "", "SZ", "748", "", "02", "", "", "-26.03333", "31.85", "Africa/Mbabane"),("934985", "Mbabane", "Мбабане", "SZ", "748", "", "01", "", "", "-26.31667", "31.13333", "Africa/Mbabane"),("934995", "Manzini", "", "SZ", "748", "", "03", "", "", "-26.49884", "31.38004", "Africa/Mbabane"),("935005", "Malkerns", "", "SZ", "748", "", "03", "", "", "-26.56667", "31.18333", "Africa/Mbabane"),("935048", "Lobamba", "", "SZ", "748", "", "01", "", "", "-26.46667", "31.2", "Africa/Mbabane"),("935076", "Hluti", "", "SZ", "748", "", "04", "", "", "-27.21667", "31.61667", "Africa/Mbabane"),("935081", "Hlatikulu", "", "SZ", "748", "", "04", "", "", "-26.96667", "31.31667", "Africa/Mbabane"),("935113", "Big Bend", "", "SZ", "748", "", "02", "", "", "-26.81667", "31.93333", "Africa/Mbabane"),("243787", "Goz Beïda", "", "TD", "148", "", "25", "", "", "12.22484", "21.41034", "Africa/Ndjamena"),("244128", "Fada", "", "TD", "148", "", "28", "", "", "17.18535", "21.58114", "Africa/Ndjamena"),("244878", "Biltine", "", "TD", "148", "", "02", "", "", "14.53333", "20.91667", "Africa/Ndjamena"),("245338", "Am Timan", "", "TD", "148", "", "13", "", "", "11.0297", "20.2827", "Africa/Ndjamena"),("245669", "Adré", "", "TD", "148", "", "12", "", "", "13.46667", "22.2", "Africa/Ndjamena"),("245785", "Abéché", "Абеше", "TD", "148", "", "12", "", "", "13.82916", "20.8324", "Africa/Ndjamena"),("2425791", "Sagh", "Сарх", "TD", "148", "", "17", "", "", "9.1429", "18.3923", "Africa/Ndjamena"),("2426240", "Pala", "Пала", "TD", "148", "", "20", "", "", "9.3642", "14.9046", "Africa/Ndjamena"),("2426370", "Oum Hadjer", "", "TD", "148", "", "01", "", "", "13.2954", "19.6966", "Africa/Ndjamena"),("2427036", "Ngama", "", "TD", "148", "", "15", "", "", "11.78333", "17.16667", "Africa/Ndjamena"),("2427123", "N'Djamena", "Нджамена", "TD", "148", "", "15", "", "", "12.10672", "15.0444", "Africa/Ndjamena"),("2427336", "Moussoro", "", "TD", "148", "", "22", "", "", "13.64143", "16.48941", "Africa/Ndjamena"),("2427455", "Moundou", "Мунду", "TD", "148", "", "08", "", "", "8.56667", "16.08333", "Africa/Ndjamena"),("2427637", "Mongo", "Монго", "TD", "148", "", "05", "", "", "12.18441", "18.69303", "Africa/Ndjamena"),("2427697", "Moïssala", "", "TD", "148", "", "19", "", "", "8.3404", "17.7663", "Africa/Ndjamena"),("2427949", "Melfi", "", "TD", "148", "", "05", "", "", "11.0598", "17.9355", "Africa/Ndjamena"),("2428042", "Mboursou Léré", "", "TD", "148", "", "20", "", "", "9.7639", "14.1539", "Africa/Ndjamena"),("2428216", "Massenya", "", "TD", "148", "", "15", "", "", "11.4039", "16.1705", "Africa/Ndjamena"),("2428228", "Massakory", "", "TD", "148", "", "18", "", "", "12.996", "15.72927", "Africa/Ndjamena"),("2428231", "Massaguet", "", "TD", "148", "", "18", "", "", "12.47554", "15.43647", "Africa/Ndjamena"),("2428394", "Mao", "", "TD", "148", "", "06", "", "", "14.12116", "15.3103", "Africa/Ndjamena"),("2429296", "Laï", "", "TD", "148", "", "14", "", "", "9.3952", "16.2989", "Africa/Ndjamena"),("2429344", "Kyabé", "", "TD", "148", "", "17", "", "", "9.45149", "18.94493", "Africa/Ndjamena"),("2429605", "Koumra", "", "TD", "148", "", "19", "", "", "8.91256", "17.55392", "Africa/Ndjamena"),("2430506", "Kelo", "Кел", "TD", "148", "", "14", "", "", "9.30859", "15.80658", "Africa/Ndjamena"),("2431573", "Guelendeng", "", "TD", "148", "", "16", "", "", "10.91762", "15.55011", "Africa/Ndjamena"),("2431724", "Gounou Gaya", "", "TD", "148", "", "16", "", "", "9.6294", "15.5132", "Africa/Ndjamena"),("2431736", "Goundi", "", "TD", "148", "", "19", "", "", "9.36267", "17.36597", "Africa/Ndjamena"),("2432678", "Faya-Largeau", "", "TD", "148", "", "23", "", "", "17.9257", "19.10428", "Africa/Ndjamena"),("2433055", "Dourbali", "", "TD", "148", "", "15", "", "", "11.80909", "15.86323", "Africa/Ndjamena"),("2433437", "Doba", "Доба", "TD", "148", "", "09", "", "", "8.65", "16.85", "Africa/Ndjamena"),("2434584", "Bousso", "", "TD", "148", "", "15", "", "", "10.48473", "16.71076", "Africa/Ndjamena"),("2434910", "Bongor", "Бонгор", "TD", "148", "", "16", "", "", "10.28056", "15.37222", "Africa/Ndjamena"),("2434979", "Bol", "", "TD", "148", "TD", "07", "", "", "13.45861", "14.71472", "Africa/Ndjamena"),("2434985", "Bokoro", "", "TD", "148", "", "18", "", "", "12.37813", "17.05876", "Africa/Ndjamena"),("2435124", "Bitkine", "", "TD", "148", "", "05", "", "", "11.9801", "18.2138", "Africa/Ndjamena"),("2435474", "Béré", "", "TD", "148", "", "14", "", "", "9.3202", "16.1552", "Africa/Ndjamena"),("2435508", "Benoy", "", "TD", "148", "", "08", "", "", "8.98327", "16.31991", "Africa/Ndjamena"),("2435708", "Beïnamar", "", "TD", "148", "", "08", "", "", "8.6698", "15.3813", "Africa/Ndjamena"),("2435837", "Béboto", "", "TD", "148", "", "09", "", "", "8.26681", "16.93898", "Africa/Ndjamena"),("2435854", "Bébédja", "", "TD", "148", "", "09", "", "", "8.6761", "16.566", "Africa/Ndjamena"),("2435976", "Bardaï", "", "TD", "148", "", "26", "", "", "21.35494", "17.00121", "Africa/Ndjamena"),("2436400", "Ati", "Ати", "TD", "148", "", "01", "", "", "13.2154", "18.3353", "Africa/Ndjamena"),("9534257", "Am Djarass", "", "TD", "148", "", "27", "", "", "16.06589", "22.84308", "Africa/Ndjamena"),("2363490", "Vogan", "Воган", "TG", "768", "", "24", "", "", "6.33333", "1.53333", "Africa/Lome"),("2363534", "Tsévié", "", "TG", "768", "", "24", "", "", "6.42611", "1.21333", "Africa/Lome"),("2363908", "Tchamba", "", "TG", "768", "", "22", "", "", "9.03333", "1.41667", "Africa/Lome"),("2364041", "Tabligbo", "", "TG", "768", "", "24", "", "", "6.58333", "1.5", "Africa/Lome"),("2364079", "Sotouboua", "", "TG", "768", "", "22", "", "", "8.5634", "0.98399", "Africa/Lome"),("2364104", "Sokodé", "Сокоде", "TG", "768", "", "22", "", "", "8.98333", "1.13333", "Africa/Lome"),("2364752", "Notsé", "", "TG", "768", "", "25", "", "", "6.95", "1.16667", "Africa/Lome"),("2364812", "Niamtougou", "Ниамтугу", "TG", "768", "", "23", "", "", "9.76806", "1.10528", "Africa/Lome"),("2365190", "Sansanné-Mango", "", "TG", "768", "", "26", "", "", "10.35917", "0.47083", "Africa/Lome"),("2365267", "Lomé", "Ломе", "TG", "768", "", "24", "", "", "6.13748", "1.21227", "Africa/Lome"),("2365560", "Kpalimé", "", "TG", "768", "", "25", "", "", "6.9", "0.63333", "Africa/Lome"),("2365571", "Pagouda", "", "TG", "768", "", "23", "", "", "9.7525", "1.32778", "Africa/Lome"),("2366152", "Kara", "Кара", "TG", "768", "", "23", "", "", "9.55111", "1.18611", "Africa/Lome"),("2366168", "Kandé", "", "TG", "768", "", "23", "", "", "9.95778", "1.04472", "Africa/Lome"),("2367164", "Dapaong", "Дапаонге", "TG", "768", "", "26", "", "", "10.86225", "0.20762", "Africa/Lome"),("2367568", "Bassar", "Басар", "TG", "768", "", "23", "2367567", "", "9.25025", "0.78213", "Africa/Lome"),("2367656", "Bafilo", "Бафило", "TG", "768", "", "23", "", "", "9.35", "1.26667", "Africa/Lome"),("2367660", "Badou", "Бад", "TG", "768", "", "25", "", "", "7.58333", "0.6", "Africa/Lome"),("2367886", "Atakpamé", "", "TG", "768", "", "25", "", "", "7.53333", "1.13333", "Africa/Lome"),("2367990", "Aného", "", "TG", "768", "", "24", "", "", "6.22798", "1.5919", "Africa/Lome"),("2368035", "Amlamé", "", "TG", "768", "", "25", "", "", "7.46667", "0.9", "Africa/Lome"),("1116760", "Don Sak", "", "TH", "764", "", "60", "", "", "9.31676", "99.69184", "Asia/Bangkok"),("1117557", "Tham Phannara", "", "TH", "764", "", "64", "", "", "8.42045", "99.39517", "Asia/Bangkok"),("1117652", "Ban Talat Yai", "Талат-Яи", "TH", "764", "", "62", "", "", "7.88481", "98.40008", "Asia/Bangkok"),("1117656", "Ban Talat Nua", "Талат-Нуа", "TH", "764", "", "62", "", "", "7.88489", "98.38557", "Asia/Bangkok"),("1117823", "Sam Roi Yot", "", "TH", "764", "", "57", "", "", "12.27081", "99.87203", "Asia/Bangkok"),("1149698", "Phetchaburi", "Пхетчабури", "TH", "764", "", "56", "", "", "13.11189", "99.94467", "Asia/Bangkok"),("1149700", "Mae Chai", "", "TH", "764", "", "41", "", "", "19.34597", "99.814", "Asia/Bangkok"),("1149878", "Wiang Sa", "", "TH", "764", "", "60", "7511035", "", "8.63585", "99.3666", "Asia/Bangkok"),("1150007", "Trang", "Транг", "TH", "764", "", "65", "", "", "7.55633", "99.61141", "Asia/Bangkok"),("1150085", "Thung Song", "", "TH", "764", "", "64", "", "", "8.16453", "99.68039", "Asia/Bangkok"),("1150154", "Thoen", "", "TH", "764", "", "06", "", "", "17.61289", "99.21612", "Asia/Bangkok"),("1150210", "Thap Than", "", "TH", "764", "", "15", "", "", "15.46063", "99.89166", "Asia/Bangkok"),("1150246", "Tha Muang", "", "TH", "764", "", "50", "", "", "13.96118", "99.64122", "Asia/Bangkok"),("1150275", "Tha Maka", "", "TH", "764", "", "50", "", "", "13.9", "99.76667", "Asia/Bangkok"),("1150490", "Tak", "Так", "TH", "764", "", "08", "", "", "16.86968", "99.12898", "Asia/Bangkok"),("1150515", "Surat Thani", "Сураттхани", "TH", "764", "", "60", "", "", "9.14011", "99.33311", "Asia/Bangkok"),("1150533", "Sukhothai", "Сукхотай", "TH", "764", "", "09", "", "", "17.00778", "99.823", "Asia/Bangkok"),("1150624", "Si Satchanalai", "", "TH", "764", "", "09", "1150623", "", "17.51692", "99.75978", "Asia/Bangkok"),("1150681", "Sawankhalok", "", "TH", "764", "", "09", "", "", "17.31597", "99.83186", "Asia/Bangkok"),("1150728", "San Pa Tong", "", "TH", "764", "", "02", "", "", "18.62828", "98.89572", "Asia/Bangkok"),("1150732", "San Kamphaeng", "", "TH", "764", "", "02", "", "", "18.74486", "99.11953", "Asia/Bangkok"),("1150735", "Sangkhla Buri", "", "TH", "764", "", "50", "", "", "15.15553", "98.45361", "Asia/Bangkok"),("1150921", "Ron Phibun", "", "TH", "764", "", "64", "", "", "8.17911", "99.85425", "Asia/Bangkok"),("1150954", "Ratchaburi", "Ратчабури", "TH", "764", "", "52", "", "", "13.53671", "99.81712", "Asia/Bangkok"),("1150965", "Ranong", "Ранонг", "TH", "764", "", "59", "", "", "9.96583", "98.63476", "Asia/Bangkok"),("1151063", "Pran Buri", "", "TH", "764", "", "57", "", "", "12.38487", "99.90157", "Asia/Bangkok"),("1151074", "Prachuap Khiri Khan", "", "TH", "764", "", "57", "", "", "11.82098", "99.7841", "Asia/Bangkok"),("1151211", "Tha Kham", "", "TH", "764", "", "60", "1151210", "", "9.11072", "99.23208", "Asia/Bangkok"),("1151254", "Phuket", "Пхукет", "TH", "764", "", "62", "", "", "7.89059", "98.3981", "Asia/Bangkok"),("1151340", "Photharam", "Пхотхарам", "TH", "764", "", "52", "", "", "13.69234", "99.84969", "Asia/Bangkok"),("1151426", "Phayao", "Пхаяо", "TH", "764", "", "41", "", "", "19.19203", "99.87883", "Asia/Bangkok"),("1151446", "Phanom Thuan", "", "TH", "764", "", "50", "", "", "14.13031", "99.69858", "Asia/Bangkok"),("1151464", "Phang Nga", "", "TH", "764", "", "61", "", "", "8.45091", "98.52985", "Asia/Bangkok"),("1151528", "Pa Sang", "", "TH", "764", "", "05", "", "", "18.52617", "98.93936", "Asia/Bangkok"),("1151933", "Nakhon Si Thammarat", "Накхонситхаммарат", "TH", "764", "", "64", "", "", "8.43333", "99.96667", "Asia/Bangkok"),("1152180", "Mae Tha", "", "TH", "764", "", "05", "", "", "18.46456", "99.14026", "Asia/Bangkok"),("1152188", "Mae Sot", "", "TH", "764", "", "08", "", "", "16.71667", "98.56667", "Asia/Bangkok"),("1152194", "Mae Sai", "", "TH", "764", "", "03", "", "", "20.43353", "99.87617", "Asia/Bangkok"),("1152202", "Mae Ramat", "", "TH", "764", "", "08", "", "", "16.98403", "98.51665", "Asia/Bangkok"),("1152222", "Mae Hong Son", "", "TH", "764", "", "01", "", "", "19.30029", "97.96852", "Asia/Bangkok"),("1152227", "Mae Chan", "", "TH", "764", "", "03", "", "", "20.14675", "99.85256", "Asia/Bangkok"),("1152322", "Long", "", "TH", "764", "", "07", "", "", "18.07422", "99.83073", "Asia/Bangkok"),("1152377", "Lat Yao", "", "TH", "764", "", "16", "", "", "15.751", "99.78925", "Asia/Bangkok"),("1152421", "Lan Sak", "", "TH", "764", "", "15", "", "", "15.45289", "99.57606", "Asia/Bangkok"),("1152423", "Lan Krabue", "", "TH", "764", "", "11", "", "", "16.60003", "99.84889", "Asia/Bangkok"),("1152432", "Lang Suan", "", "TH", "764", "", "58", "", "", "9.94561", "99.07847", "Asia/Bangkok"),("1152468", "Lamphun", "Лампхун", "TH", "764", "", "05", "", "", "18.58054", "99.00745", "Asia/Bangkok"),("1152473", "Lampang", "Лампанг", "TH", "764", "", "06", "", "", "18.29232", "99.49277", "Asia/Bangkok"),("1152562", "Kui Buri", "", "TH", "764", "", "57", "", "", "12.08283", "99.85431", "Asia/Bangkok"),("1152633", "Krabi", "Краби", "TH", "764", "", "63", "", "", "8.07257", "98.91052", "Asia/Bangkok"),("1152670", "Ko Lanta", "", "TH", "764", "TH", "63", "", "", "7.53362", "99.08647", "Asia/Bangkok"),("1152873", "Tha Khanon", "", "TH", "764", "", "60", "1152874", "", "9.0302", "98.95286", "Asia/Bangkok"),("1152876", "Khiri Mat", "", "TH", "764", "", "09", "", "", "16.83333", "99.8", "Asia/Bangkok"),("1152919", "Khao Yoi", "", "TH", "764", "", "56", "", "", "13.24025", "99.82428", "Asia/Bangkok"),("1152953", "Khanu Woralaksaburi", "", "TH", "764", "", "11", "", "", "16.0617", "99.86058", "Asia/Bangkok"),("1153035", "Kathu", "Кату", "TH", "764", "", "62", "1153034", "", "7.91779", "98.33322", "Asia/Bangkok"),("1153072", "Kantang", "", "TH", "764", "", "65", "", "", "7.40542", "99.51561", "Asia/Bangkok"),("1153081", "Kanchanaburi", "Канчанабури", "TH", "764", "", "50", "", "", "14.00412", "99.54832", "Asia/Bangkok"),("1153090", "Kamphaeng Phet", "", "TH", "764", "", "11", "", "", "16.48344", "99.52153", "Asia/Bangkok"),("1153241", "Huai Yot", "", "TH", "764", "", "65", "", "", "7.78937", "99.63469", "Asia/Bangkok"),("1153263", "Huai Khot", "", "TH", "764", "", "15", "", "", "15.29095", "99.61661", "Asia/Bangkok"),("1153269", "Hua Hin", "", "TH", "764", "", "57", "", "", "12.57065", "99.95876", "Asia/Bangkok"),("1153386", "Hang Dong", "", "TH", "764", "", "02", "", "", "18.68703", "98.91939", "Asia/Bangkok"),("1153427", "Fang", "", "TH", "764", "", "02", "", "", "19.91689", "99.2145", "Asia/Bangkok"),("1153464", "Dok Kham Tai", "", "TH", "764", "", "41", "", "", "19.16242", "99.99342", "Asia/Bangkok"),("1153513", "Damnoen Saduak", "Дамноенсадуак", "TH", "764", "", "52", "", "", "13.51825", "99.95469", "Asia/Bangkok"),("1153557", "Chumphon", "Чумпхон", "TH", "764", "", "58", "", "", "10.4957", "99.17971", "Asia/Bangkok"),("1153634", "Chom Thong", "", "TH", "764", "", "02", "", "", "18.41742", "98.67428", "Asia/Bangkok"),("1153646", "Chom Bueng", "", "TH", "764", "", "52", "1153645", "", "13.62", "99.59169", "Asia/Bangkok"),("1153669", "Chiang Rai", "Чианг-Рай", "TH", "764", "", "03", "", "", "19.90858", "99.8325", "Asia/Bangkok"),("1153671", "Chiang Mai", "Чианг-Май", "TH", "764", "", "02", "", "", "18.79038", "98.98468", "Asia/Bangkok"),("1153686", "Chawang", "", "TH", "764", "", "64", "", "", "8.42614", "99.50472", "Asia/Bangkok"),("1153783", "Chaiya", "", "TH", "764", "", "60", "", "", "9.38625", "99.19861", "Asia/Bangkok"),("1153788", "Chai Buri", "", "TH", "764", "", "60", "", "", "8.46222", "99.07631", "Asia/Bangkok"),("1153807", "Cha-am", "Ча-ам", "TH", "764", "", "56", "", "", "12.8", "99.96667", "Asia/Bangkok"),("1153850", "Bo Phloi", "", "TH", "764", "", "50", "", "", "14.32517", "99.51467", "Asia/Bangkok"),("1154677", "Ban Tak", "", "TH", "764", "", "08", "", "", "17.04325", "99.08128", "Asia/Bangkok"),("1154689", "Ko Samui", "", "TH", "764", "", "60", "", "", "9.53567", "99.93567", "Asia/Bangkok"),("1155010", "Rawai", "", "TH", "764", "TH", "62", "", "", "7.77965", "98.32532", "Asia/Bangkok"),("1155139", "Ban Pong", "Пан-понг", "TH", "764", "", "52", "", "", "13.81629", "99.87739", "Asia/Bangkok"),("1155231", "Ban Phru Nai", "", "TH", "764", "", "61", "", "", "7.95458", "98.58989", "Asia/Bangkok"),("1155525", "Nuea Khlong", "", "TH", "764", "", "63", "", "", "8.07143", "98.99933", "Asia/Bangkok"),("1156046", "Ban Na San", "", "TH", "764", "", "60", "", "", "8.80036", "99.36372", "Asia/Bangkok"),("1156257", "Ban Na", "", "TH", "764", "", "09", "", "", "17.01717", "99.73283", "Asia/Bangkok"),("1156836", "Ban Ko Kaeo", "", "TH", "764", "", "62", "", "", "7.93599", "98.39664", "Asia/Bangkok"),("1157249", "Ban Karon", "", "TH", "764", "TH", "62", "", "", "7.84769", "98.2985", "Asia/Bangkok"),("1157662", "Bang Saphan", "", "TH", "764", "", "57", "", "", "11.21259", "99.51167", "Asia/Bangkok"),("1157683", "Bang Phae", "", "TH", "764", "", "52", "", "", "13.69157", "99.92982", "Asia/Bangkok"),("1157969", "Ban Dan Lan Hoi", "", "TH", "764", "", "09", "", "", "17.00683", "99.57497", "Asia/Bangkok"),("1158377", "Ban Ao Nang", "", "TH", "764", "", "61", "", "", "8.0458", "98.81035", "Asia/Bangkok"),("1158412", "Ao Luek", "", "TH", "764", "", "63", "", "", "8.37803", "98.72117", "Asia/Bangkok"),("1595679", "Nong Kung Si", "", "TH", "764", "", "23", "", "", "16.65", "103.3", "Asia/Bangkok"),("1599640", "Ban Nong Wua So", "", "TH", "764", "", "76", "", "", "17.2675", "103.22472", "Asia/Bangkok"),("1599641", "Nong Wua So", "", "TH", "764", "", "76", "", "", "17.16261", "102.57272", "Asia/Bangkok"),("1600964", "Ban Nam Yuen", "", "TH", "764", "", "58", "", "", "9.87686", "98.86592", "Asia/Bangkok"),("1600983", "Na Mom", "", "TH", "764", "", "68", "", "", "6.95856", "100.55683", "Asia/Bangkok"),("1601579", "Ban Mai", "", "TH", "764", "", "68", "", "", "7.20411", "100.54508", "Asia/Bangkok"),("1603235", "Ban Huai Thalaeng", "", "TH", "764", "", "27", "", "", "14.98333", "102.65", "Asia/Bangkok"),("1604452", "Ban Khlong Bang Sao Thong", "", "TH", "764", "", "42", "", "", "13.64172", "100.83272", "Asia/Bangkok"),("1604654", "Na Klang", "", "TH", "764", "", "79", "", "", "17.3072", "102.18886", "Asia/Bangkok"),("1604769", "Yasothon", "Ясотхон", "TH", "764", "", "72", "", "", "15.79408", "104.1451", "Asia/Bangkok"),("1604771", "Yaring", "", "TH", "764", "", "69", "", "", "6.86617", "101.36894", "Asia/Bangkok"),("1604797", "Yang Talat", "", "TH", "764", "", "23", "", "", "16.39982", "103.36785", "Asia/Bangkok"),("1604870", "Yala", "Яла", "TH", "764", "", "70", "", "", "6.53995", "101.28128", "Asia/Bangkok"),("1605018", "Wiset Chaichan", "", "TH", "764", "", "35", "", "", "14.5945", "100.33825", "Asia/Bangkok"),("1605024", "Wichian Buri", "", "TH", "764", "", "14", "", "", "15.65778", "101.10603", "Asia/Bangkok"),("1605069", "Warin Chamrap", "", "TH", "764", "", "75", "", "", "15.19319", "104.8628", "Asia/Bangkok"),("1605072", "Wapi Pathum", "", "TH", "764", "", "24", "", "", "15.84523", "103.37678", "Asia/Bangkok"),("1605102", "Wang Saphung", "", "TH", "764", "", "18", "", "", "17.30097", "101.7685", "Asia/Bangkok"),("1605118", "Wang Noi", "", "TH", "764", "", "36", "", "", "14.22689", "100.7155", "Asia/Bangkok"),("1605119", "Wang Nam Yen", "", "TH", "764", "", "80", "", "", "13.50325", "102.18115", "Asia/Bangkok"),("1605156", "Wang Sai Phun", "", "TH", "764", "", "13", "", "", "16.3885", "100.53801", "Asia/Bangkok"),("1605215", "Uttaradit", "Уттарадит", "TH", "764", "", "10", "", "", "17.62557", "100.09421", "Asia/Bangkok"),("1605221", "Uthai Thani", "", "TH", "764", "", "15", "", "", "15.37939", "100.0245", "Asia/Bangkok"),("1605239", "Udon Thani", "Удон-Тхани", "TH", "764", "", "76", "", "", "17.41567", "102.78589", "Asia/Bangkok"),("1605245", "Ubon Ratchathani", "", "TH", "764", "", "75", "", "", "15.23844", "104.84866", "Asia/Bangkok"),("1605279", "Trat", "Трат", "TH", "764", "", "49", "", "", "12.24364", "102.51514", "Asia/Bangkok"),("1605467", "Tha Yang", "", "TH", "764", "", "56", "", "", "12.95772", "99.90555", "Asia/Bangkok"),("1605483", "That Phanom", "", "TH", "764", "", "73", "", "", "16.93636", "104.71039", "Asia/Bangkok"),("1605509", "Tha Ruea", "", "TH", "764", "", "36", "1605508", "", "14.56739", "100.72598", "Asia/Bangkok"),("1605538", "Thap Khlo", "", "TH", "764", "", "13", "", "", "16.16003", "100.59656", "Asia/Bangkok"),("1605601", "Tha Mai", "", "TH", "764", "", "48", "", "", "12.62137", "102.00481", "Asia/Bangkok"),("1605677", "Tha Bo", "", "TH", "764", "", "17", "", "", "17.85003", "102.58139", "Asia/Bangkok"),("1605754", "Taphan Hin", "", "TH", "764", "", "13", "", "", "16.22095", "100.41978", "Asia/Bangkok"),("1605957", "Tak Bai", "", "TH", "764", "", "31", "", "", "6.25947", "102.05461", "Asia/Bangkok"),("1606017", "Suwannaphum", "", "TH", "764", "", "25", "", "", "15.60348", "103.80207", "Asia/Bangkok"),("1606030", "Surin", "Сурин", "TH", "764", "", "29", "", "", "14.88181", "103.49364", "Asia/Bangkok"),("1606033", "Suphan Buri", "Суфан Бури", "TH", "764", "", "51", "", "", "14.47418", "100.12218", "Asia/Bangkok"),("1606040", "Sung Noen", "", "TH", "764", "", "27", "", "", "14.8992", "101.82075", "Asia/Bangkok"),("1606047", "Ban Su-ngai Pa Di", "", "TH", "764", "", "31", "", "", "6.07239", "101.87172", "Asia/Bangkok"),("1606050", "Su-ngai Kolok", "", "TH", "764", "", "31", "", "", "6.02977", "101.96586", "Asia/Bangkok"),("1606147", "Songkhla", "Сонгкхла", "TH", "764", "", "68", "", "", "7.19882", "100.5951", "Asia/Bangkok"),("1606213", "Soeng Sang", "", "TH", "764", "", "27", "", "", "14.42642", "102.46058", "Asia/Bangkok"),("1606239", "Si Sa Ket", "Си Са Кет", "TH", "764", "", "30", "", "", "15.11481", "104.32938", "Asia/Bangkok"),("1606250", "Si Racha", "", "TH", "764", "", "46", "", "", "13.17372", "100.93111", "Asia/Bangkok"),("1606270", "Sing Buri", "Синг Бури", "TH", "764", "", "33", "", "", "14.88786", "100.40464", "Asia/Bangkok"),("1606316", "Si Chiang Mai", "", "TH", "764", "", "17", "", "", "17.95639", "102.58667", "Asia/Bangkok"),("1606323", "Si Bun Rueang", "", "TH", "764", "", "79", "", "", "16.96705", "102.27607", "Asia/Bangkok"),("1606343", "Seka", "", "TH", "764", "", "81", "", "", "17.92851", "103.95519", "Asia/Bangkok"),("1606350", "Sawang Daen Din", "", "TH", "764", "", "20", "", "", "17.47531", "103.45753", "Asia/Bangkok"),("1606376", "Satun", "Сатун", "TH", "764", "", "67", "", "", "6.62314", "100.06676", "Asia/Bangkok"),("1606378", "Satuek", "", "TH", "764", "", "28", "", "", "15.29703", "103.29192", "Asia/Bangkok"),("1606386", "Sattahip", "", "TH", "764", "", "46", "", "", "12.66644", "100.90073", "Asia/Bangkok"),("1606418", "Saraburi", "", "TH", "764", "TH", "37", "", "", "14.53333", "100.91667", "Asia/Bangkok"),("1606586", "Samut Songkhram", "", "TH", "764", "", "54", "", "", "13.41456", "100.00264", "Asia/Bangkok"),("1606588", "Samut Sakhon", "", "TH", "764", "", "55", "", "", "13.54753", "100.27362", "Asia/Bangkok"),("1606590", "Samut Prakan", "Самутпракан", "TH", "764", "", "42", "", "", "13.59934", "100.59675", "Asia/Bangkok"),("1606638", "Sam Phran", "", "TH", "764", "", "53", "", "", "13.72698", "100.21526", "Asia/Bangkok"),("1606790", "Sakon Nakhon", "", "TH", "764", "", "20", "", "", "17.16116", "104.14725", "Asia/Bangkok"),("1606807", "Sa Kaeo", "", "TH", "764", "", "80", "", "", "13.81411", "102.07222", "Asia/Bangkok"),("1606851", "Sai Buri", "", "TH", "764", "", "69", "", "", "6.70131", "101.61675", "Asia/Bangkok"),("1606939", "Sadao", "Садао", "TH", "764", "", "68", "", "", "6.63883", "100.42342", "Asia/Bangkok"),("1606983", "Rong Kwang", "", "TH", "764", "", "07", "", "", "18.33903", "100.31736", "Asia/Bangkok"),("1607001", "Roi Et", "Рои Эт", "TH", "764", "", "25", "", "", "16.0567", "103.65309", "Asia/Bangkok"),("1607017", "Rayong", "Районг", "TH", "764", "TH", "47", "", "", "12.68095", "101.25798", "Asia/Bangkok"),("1607068", "Ranot", "", "TH", "764", "", "68", "", "", "7.77768", "100.32134", "Asia/Bangkok"),("1607083", "Ra-ngae", "", "TH", "764", "", "31", "", "", "6.29678", "101.72844", "Asia/Bangkok"),("1607257", "Prakhon Chai", "", "TH", "764", "", "28", "", "", "14.60592", "103.12081", "Asia/Bangkok"),("1607280", "Prachin Buri", "", "TH", "764", "", "74", "", "", "14.04992", "101.36864", "Asia/Bangkok"),("1607306", "Pong Nam Ron", "", "TH", "764", "", "48", "", "", "12.90575", "102.26225", "Asia/Bangkok"),("1607324", "Pong", "", "TH", "764", "", "41", "", "", "19.14931", "100.27522", "Asia/Bangkok"),("1607435", "Phu Kradueng", "", "TH", "764", "", "18", "", "", "16.88425", "101.88467", "Asia/Bangkok"),("1607439", "Phu Khiao", "", "TH", "764", "", "26", "", "", "16.3765", "102.12853", "Asia/Bangkok"),("1607508", "Phra Pradaeng", "", "TH", "764", "", "42", "", "", "13.65855", "100.53362", "Asia/Bangkok"),("1607512", "Phra Phutthabat", "", "TH", "764", "", "37", "", "", "14.72526", "100.79536", "Asia/Bangkok"),("1607532", "Phra Nakhon Si Ayutthaya", "Аюттхая", "TH", "764", "", "36", "", "", "14.35167", "100.57739", "Asia/Bangkok"),("1607544", "Phrai Bueng", "", "TH", "764", "", "30", "", "", "14.74833", "104.36261", "Asia/Bangkok"),("1607552", "Phrae", "Пхрае", "TH", "764", "", "07", "", "", "18.14589", "100.14103", "Asia/Bangkok"),("1607579", "Pho Thong", "", "TH", "764", "", "35", "", "", "14.66731", "100.40878", "Asia/Bangkok"),("1607600", "Waeng", "", "TH", "764", "", "25", "", "", "16.30006", "103.97786", "Asia/Bangkok"),("1607615", "Phon Charoen", "", "TH", "764", "", "17", "", "", "18.03333", "103.16667", "Asia/Bangkok"),("1607617", "Phon", "", "TH", "764", "", "22", "", "", "15.816", "102.59981", "Asia/Bangkok"),("1607635", "Pho Chai", "", "TH", "764", "", "25", "7510811", "", "16.32827", "103.77033", "Asia/Bangkok"),("1607708", "Phitsanulok", "Пхитсанулок", "TH", "764", "", "12", "", "", "16.82481", "100.25858", "Asia/Bangkok"),("1607716", "Phimai", "", "TH", "764", "", "27", "", "", "15.22324", "102.49473", "Asia/Bangkok"),("1607725", "Phichit", "Пхичит", "TH", "764", "", "13", "", "", "16.44184", "100.34879", "Asia/Bangkok"),("1607730", "Phibun Mangsahan", "", "TH", "764", "", "75", "", "", "15.24467", "105.22908", "Asia/Bangkok"),("1607737", "Phetchabun", "Пхетчабун", "TH", "764", "", "14", "", "", "16.41904", "101.16056", "Asia/Bangkok"),("1607752", "Phayuha Khiri", "", "TH", "764", "", "16", "", "", "15.45525", "100.13533", "Asia/Bangkok"),("1607763", "Phayakkhaphum Phisai", "", "TH", "764", "", "24", "", "", "15.51631", "103.19367", "Asia/Bangkok"),("1607779", "Phatthalung", "Пхетчабун", "TH", "764", "", "66", "", "", "7.61786", "100.07792", "Asia/Bangkok"),("1607793", "Phan Thong", "", "TH", "764", "", "46", "", "", "13.46804", "101.09532", "Asia/Bangkok"),("1607801", "Phanom Sarakham", "", "TH", "764", "", "44", "", "", "13.74787", "101.3553", "Asia/Bangkok"),("1607838", "Phanat Nikhom", "", "TH", "764", "", "46", "", "", "13.44581", "101.18445", "Asia/Bangkok"),("1607865", "Phak Hai", "", "TH", "764", "", "36", "", "", "14.45736", "100.36989", "Asia/Bangkok"),("1607881", "Phai Sali", "", "TH", "764", "", "16", "", "", "15.60003", "100.64937", "Asia/Bangkok"),("1607978", "Pattani", "Паттани", "TH", "764", "TH", "69", "", "", "6.86814", "101.25009", "Asia/Bangkok"),("1607983", "Pathum Thani", "Ратхум Тхани", "TH", "764", "", "39", "", "", "14.01346", "100.53049", "Asia/Bangkok"),("1608033", "Pak Phanang", "", "TH", "764", "", "64", "", "", "8.35109", "100.20195", "Asia/Bangkok"),("1608048", "Pak Kret", "", "TH", "764", "", "38", "", "", "13.91301", "100.49883", "Asia/Bangkok"),("1608057", "Pak Chong", "", "TH", "764", "", "27", "", "", "14.70802", "101.41614", "Asia/Bangkok"),("1608068", "Pa Daet", "", "TH", "764", "", "03", "", "", "19.50489", "99.99241", "Asia/Bangkok"),("1608131", "Non Thai", "", "TH", "764", "", "27", "", "", "15.1958", "102.07145", "Asia/Bangkok"),("1608133", "Mueang Nonthaburi", "Нонтхабури", "TH", "764", "", "38", "", "", "13.86075", "100.51477", "Asia/Bangkok"),("1608136", "Non Sung", "", "TH", "764", "", "27", "", "", "15.18014", "102.25695", "Asia/Bangkok"),("1608139", "Non Sang", "", "TH", "764", "", "79", "", "", "16.8687", "102.56642", "Asia/Bangkok"),("1608191", "Nong Phai", "", "TH", "764", "", "14", "", "", "15.99025", "101.06183", "Asia/Bangkok"),("1608222", "Nong Ki", "", "TH", "764", "", "28", "", "", "14.68679", "102.538", "Asia/Bangkok"),("1608232", "Nong Khai", "Нонг-Кхай", "TH", "764", "", "17", "", "", "17.87847", "102.742", "Asia/Bangkok"),("1608239", "Nong Khae", "", "TH", "764", "", "37", "", "", "14.34062", "100.86733", "Asia/Bangkok"),("1608263", "Nong Chik", "", "TH", "764", "", "69", "", "", "6.84356", "101.17803", "Asia/Bangkok"),("1608269", "Nong Bua Lamphu", "", "TH", "764", "", "79", "", "", "17.20406", "102.44068", "Asia/Bangkok"),("1608286", "Nong Bua", "", "TH", "764", "", "16", "", "", "15.86458", "100.58581", "Asia/Bangkok"),("1608399", "Na Wa", "", "TH", "764", "", "73", "", "", "17.4897", "104.10056", "Asia/Bangkok"),("1608409", "Narathiwat", "Наратхиват", "TH", "764", "", "31", "", "", "6.42639", "101.82308", "Asia/Bangkok"),("1608424", "Nang Rong", "", "TH", "764", "", "28", "", "", "14.6377", "102.79138", "Asia/Bangkok"),("1608452", "Nan", "Нан", "TH", "764", "", "04", "", "", "18.78378", "100.77899", "Asia/Bangkok"),("1608462", "Nam Som", "", "TH", "764", "", "76", "", "", "17.77036", "102.18947", "Asia/Bangkok"),("1608524", "Nakhon Thai", "", "TH", "764", "", "12", "", "", "17.10056", "100.83739", "Asia/Bangkok"),("1608527", "Nakhon Sawan", "", "TH", "764", "", "16", "", "", "15.70472", "100.13717", "Asia/Bangkok"),("1608529", "Nakhon Ratchasima", "Накхонратчасима", "TH", "764", "", "27", "", "", "14.97066", "102.10196", "Asia/Bangkok"),("1608531", "Nakhon Phanom", "", "TH", "764", "", "73", "", "", "17.41081", "104.77856", "Asia/Bangkok"),("1608534", "Nakhon Pathom", "", "TH", "764", "", "53", "", "", "13.8196", "100.04427", "Asia/Bangkok"),("1608539", "Nakhon Nayok", "", "TH", "764", "", "43", "", "", "14.20463", "101.21295", "Asia/Bangkok"),("1608541", "Nakhon Luang", "", "TH", "764", "", "36", "", "", "14.46281", "100.60832", "Asia/Bangkok"),("1608597", "Mukdahan", "Мукдахан", "TH", "764", "", "78", "", "", "16.54531", "104.72351", "Asia/Bangkok"),("1608725", "Moeiwadi", "", "TH", "764", "", "25", "", "", "16.38944", "104.1572", "Asia/Bangkok"),("1608900", "Maha Sarakham", "", "TH", "764", "", "24", "", "", "16.18483", "103.30067", "Asia/Bangkok"),("1609032", "Lop Buri", "Лопбури", "TH", "764", "", "34", "", "", "14.79808", "100.65397", "Asia/Bangkok"),("1609043", "Lom Sak", "", "TH", "764", "", "14", "", "", "16.77983", "101.24225", "Asia/Bangkok"),("1609071", "Loei", "Лоэ", "TH", "764", "", "18", "", "", "17.49052", "101.72749", "Asia/Bangkok"),("1609278", "Laem Sing", "", "TH", "764", "", "48", "", "", "12.48164", "102.07375", "Asia/Bangkok"),("1609324", "Kut Chap", "", "TH", "764", "", "76", "", "", "17.4257", "102.56692", "Asia/Bangkok"),("1609345", "Kuchinarai", "", "TH", "764", "", "23", "", "", "16.541", "104.05004", "Asia/Bangkok"),("1609350", "Bangkok", "Бангкок", "TH", "764", "", "40", "", "", "13.75398", "100.50144", "Asia/Bangkok"),("1609395", "Krathum Baen", "", "TH", "764", "", "55", "", "", "13.6533", "100.25972", "Asia/Bangkok"),("1609430", "Kranuan", "", "TH", "764", "", "22", "", "", "16.70672", "103.07878", "Asia/Bangkok"),("1609476", "Kosum Phisai", "", "TH", "764", "", "24", "", "", "16.24858", "103.06739", "Asia/Bangkok"),("1609610", "Klaeng", "", "TH", "764", "", "47", "", "", "12.77972", "101.64831", "Asia/Bangkok"),("1609776", "Khon Kaen", "Кхонкэн", "TH", "764", "", "22", "", "", "16.44671", "102.833", "Asia/Bangkok"),("1609795", "Khon Buri", "", "TH", "764", "", "27", "", "", "14.52541", "102.24591", "Asia/Bangkok"),("1609858", "Khlung", "", "TH", "764", "", "48", "", "", "12.45467", "102.22142", "Asia/Bangkok"),("1609899", "Khlong Luang", "", "TH", "764", "", "39", "", "", "14.06467", "100.64578", "Asia/Bangkok"),("1609990", "Khao Wong", "", "TH", "764", "", "23", "", "", "16.70008", "104.09019", "Asia/Bangkok"),("1610072", "Kham Sakae Saeng", "", "TH", "764", "", "27", "", "", "15.33221", "102.17278", "Asia/Bangkok"),("1610185", "Kaset Wisai", "", "TH", "764", "", "25", "", "", "15.65558", "103.58361", "Asia/Bangkok"),("1610187", "Kaset Sombun", "", "TH", "764", "", "26", "", "", "16.28053", "101.95422", "Asia/Bangkok"),("1610227", "Kantharalak", "Кантхаралак", "TH", "764", "", "30", "", "", "14.64056", "104.64992", "Asia/Bangkok"),("1610459", "Kamalasai", "", "TH", "764", "", "23", "", "", "16.33839", "103.57564", "Asia/Bangkok"),("1610469", "Kalasin", "Каласин", "TH", "764", "", "23", "", "", "16.43281", "103.50658", "Asia/Bangkok"),("1610503", "Kaeng Khoi", "", "TH", "764", "", "37", "", "", "14.58617", "100.99758", "Asia/Bangkok"),("1610505", "Kaeng Khro", "", "TH", "764", "", "26", "", "", "16.10864", "102.25808", "Asia/Bangkok"),("1610538", "Kabin Buri", "", "TH", "764", "", "74", "", "", "13.95114", "101.71769", "Asia/Bangkok"),("1610661", "Huai Mek", "", "TH", "764", "", "23", "", "", "16.58975", "103.23547", "Asia/Bangkok"),("1610780", "Hat Yai", "Хатъяй", "TH", "764", "", "68", "", "", "7.00836", "100.47668", "Asia/Bangkok"),("1610911", "Doembang Nangbuat", "", "TH", "764", "", "51", "", "", "14.83333", "100.1", "Asia/Bangkok"),("1610940", "Det Udom", "", "TH", "764", "", "75", "", "", "14.90598", "105.07836", "Asia/Bangkok"),("1610943", "Den Chai", "", "TH", "764", "", "07", "", "", "17.98372", "100.05217", "Asia/Bangkok"),("1610963", "Dan Khun Thot", "", "TH", "764", "", "27", "", "", "15.2085", "101.77138", "Asia/Bangkok"),("1611026", "Chum Phae", "", "TH", "764", "", "22", "", "", "16.5443", "102.09924", "Asia/Bangkok"),("1611106", "Chon Daen", "", "TH", "764", "", "14", "", "", "16.18953", "100.85958", "Asia/Bangkok"),("1611110", "Chon Buri", "Чонбури", "TH", "764", "", "46", "", "", "13.3622", "100.98345", "Asia/Bangkok"),("1611135", "Chok Chai", "", "TH", "764", "", "27", "", "", "14.72844", "102.16524", "Asia/Bangkok"),("1611187", "Chiang Saen", "", "TH", "764", "", "03", "", "", "20.27511", "100.08689", "Asia/Bangkok"),("1611195", "Chiang Klang", "", "TH", "764", "", "04", "", "", "19.29378", "100.86169", "Asia/Bangkok"),("1611197", "Chiang Khong", "", "TH", "764", "", "03", "", "", "20.26125", "100.40461", "Asia/Bangkok"),("1611202", "Chiang Kham", "", "TH", "764", "", "41", "", "", "19.52331", "100.3", "Asia/Bangkok"),("1611269", "Chanthaburi", "Чантхабури", "TH", "764", "", "48", "", "", "12.60961", "102.10447", "Asia/Bangkok"),("1611407", "Chaiyaphum", "Чайяпхум", "TH", "764", "", "26", "", "", "15.81047", "102.02881", "Asia/Bangkok"),("1611416", "Chai Nat", "", "TH", "764", "", "32", "", "", "15.18636", "100.12353", "Asia/Bangkok"),("1611424", "Chai Badan", "", "TH", "764", "", "34", "", "", "15.2", "101.13333", "Asia/Bangkok"),("1611439", "Chachoengsao", "Чачоенгсао", "TH", "764", "", "44", "", "", "13.6882", "101.07156", "Asia/Bangkok"),("1611453", "Buriram", "Бурирам", "TH", "764", "", "28", "", "", "14.99433", "103.10392", "Asia/Bangkok"),("1611475", "Bueng Kan", "", "TH", "764", "", "81", "", "", "18.36303", "103.65194", "Asia/Bangkok"),("1611492", "Bua Yai", "", "TH", "764", "", "27", "", "", "15.58552", "102.42587", "Asia/Bangkok"),("1611578", "Bo Rai", "", "TH", "764", "", "49", "", "", "12.57283", "102.53714", "Asia/Bangkok"),("1611635", "Betong", "Бетонг", "TH", "764", "", "70", "", "", "5.77434", "101.07231", "Asia/Bangkok"),("1612722", "Ban Thai Tan", "", "TH", "764", "", "35", "", "", "14.62161", "100.48739", "Asia/Bangkok"),("1613284", "Ban Selaphum", "", "TH", "764", "", "25", "", "", "16.01667", "103.95", "Asia/Bangkok"),("1613294", "Sawang Wirawong", "", "TH", "764", "", "75", "", "", "15.24158", "105.0922", "Asia/Bangkok"),("1613534", "Ban Sam Chuk", "", "TH", "764", "", "51", "", "", "14.74219", "100.09531", "Asia/Bangkok"),("1614295", "Phatthaya", "Паттайя", "TH", "764", "", "46", "", "", "12.93333", "100.88333", "Asia/Bangkok"),("1614336", "Ban Phan Don", "", "TH", "764", "", "76", "", "", "17.14272", "102.97261", "Asia/Bangkok"),("1614455", "Ban Phai", "", "TH", "764", "", "22", "", "", "16.05997", "102.73097", "Asia/Bangkok"),("1614465", "Ban Phaeo", "", "TH", "764", "", "55", "", "", "13.59072", "100.10748", "Asia/Bangkok"),("1616658", "Ban Mo", "", "TH", "764", "", "37", "", "", "14.61544", "100.72731", "Asia/Bangkok"),("1617111", "Ban Lam Luk Ka", "", "TH", "764", "", "39", "", "", "13.97738", "100.77776", "Asia/Bangkok"),("1619198", "Bang Yai", "", "TH", "764", "", "38", "", "", "13.84341", "100.36251", "Asia/Bangkok"),("1619276", "Bang Rakam", "", "TH", "764", "", "12", "", "", "16.75847", "100.11742", "Asia/Bangkok"),("1619281", "Bang Racham", "", "TH", "764", "", "33", "", "", "14.892", "100.31728", "Asia/Bangkok"),("1619363", "Bang Pakong", "", "TH", "764", "", "44", "", "", "13.54297", "100.99333", "Asia/Bangkok"),("1619369", "Bang Pa-in", "", "TH", "764", "", "36", "", "", "14.22783", "100.57589", "Asia/Bangkok"),("1619391", "Bang Nam Priao", "", "TH", "764", "", "44", "", "", "13.84739", "101.05306", "Asia/Bangkok"),("1619400", "Bang Mun Nak", "", "TH", "764", "", "13", "", "", "16.02781", "100.37917", "Asia/Bangkok"),("1619415", "Bang Len", "", "TH", "764", "", "53", "", "", "14.02188", "100.17183", "Asia/Bangkok"),("1619423", "Bang Lamung", "", "TH", "764", "", "46", "", "", "13.04704", "100.92891", "Asia/Bangkok"),("1619434", "Bang Kruai", "", "TH", "764", "", "38", "", "", "13.805", "100.47283", "Asia/Bangkok"),("1619437", "Bang Krathum", "", "TH", "764", "", "12", "", "", "16.57831", "100.30034", "Asia/Bangkok"),("1619498", "Bang Khla", "", "TH", "764", "", "44", "", "", "13.72144", "101.20814", "Asia/Bangkok"),("1619602", "Bang Bua Thong", "", "TH", "764", "", "38", "", "", "13.91783", "100.42403", "Asia/Bangkok"),("1619616", "Bang Ban", "", "TH", "764", "", "36", "", "", "14.37395", "100.48528", "Asia/Bangkok"),("1619650", "Ban Dung", "", "TH", "764", "", "76", "", "", "17.699", "103.25957", "Asia/Bangkok"),("1620254", "Ban Chang", "", "TH", "764", "", "47", "", "", "12.72543", "101.05531", "Asia/Bangkok"),("1620371", "Ban Bueng", "", "TH", "764", "", "46", "", "", "13.311", "101.11214", "Asia/Bangkok"),("1620442", "Ban Talat Bueng", "", "TH", "764", "", "46", "", "", "13.07147", "101.00314", "Asia/Bangkok"),("1620875", "Ban Bang Kadi Pathum Thani", "", "TH", "764", "", "36", "", "", "13.99904", "100.54962", "Asia/Bangkok"),("1620919", "Bang Bo District", "", "TH", "764", "", "42", "", "", "13.58333", "100.81667", "Asia/Bangkok"),("1620989", "Bamnet Narong", "", "TH", "764", "", "26", "", "", "15.50189", "101.68982", "Asia/Bangkok"),("1621020", "Aranyaprathet", "Араньяпратхет", "TH", "764", "", "80", "", "", "13.69276", "102.50128", "Asia/Bangkok"),("1621035", "Ang Thong", "", "TH", "764", "", "35", "", "", "14.58839", "100.45283", "Asia/Bangkok"),("1621060", "Amnat Charoen", "Амнат Чароен", "TH", "764", "", "77", "", "", "15.85851", "104.62883", "Asia/Bangkok"),("1884830", "Chaiyo", "", "TH", "764", "", "35", "", "", "14.67639", "100.46861", "Asia/Bangkok"),("1948015", "Amphoe Sikhiu", "", "TH", "764", "", "27", "", "", "14.89944", "101.70833", "Asia/Bangkok"),("6691842", "Saladan", "", "TH", "764", "", "63", "", "", "7.61342", "99.03651", "Asia/Bangkok"),("6696291", "Wichit", "", "TH", "764", "", "62", "", "", "7.8894", "98.38523", "Asia/Bangkok"),("6698658", "Ko Pha Ngan", "", "TH", "764", "", "64", "", "", "9.75778", "100.02914", "Asia/Bangkok"),("6941772", "Patong", "", "TH", "764", "", "62", "", "", "7.89607", "98.29661", "Asia/Bangkok"),("7091861", "Ban Chalong", "", "TH", "764", "", "62", "", "", "7.84468", "98.33897", "Asia/Bangkok"),("7091912", "Ban Ratsada", "Ратсада", "TH", "764", "", "62", "", "", "7.90963", "98.40248", "Asia/Bangkok"),("1220112", "Yovon", "", "TJ", "762", "", "02", "", "", "38.31408", "69.03784", "Asia/Dushanbe"),("1220163", "Vose’", "", "TJ", "762", "", "02", "", "", "37.80396", "69.64417", "Asia/Dushanbe"),("1220219", "Vakhsh", "", "TJ", "762", "", "02", "", "", "37.71485", "68.83456", "Asia/Dushanbe"),("1220253", "Istaravshan", "Истаравшан", "TJ", "762", "", "03", "", "", "39.9142", "69.00328", "Asia/Dushanbe"),("1220301", "Tursunzoda", "Турсунзаде", "TJ", "762", "", "RR", "", "", "38.51437", "68.23327", "Asia/Dushanbe"),("1220446", "Sovet", "", "TJ", "762", "", "02", "", "", "38.0467", "69.58822", "Asia/Dushanbe"),("1220566", "Shahrinav", "", "TJ", "762", "", "RR", "", "", "38.57085", "68.33498", "Asia/Dushanbe"),("1220576", "Shahritus", "", "TJ", "762", "", "02", "", "", "37.26206", "68.13849", "Asia/Dushanbe"),("1220701", "Roghun", "", "TJ", "762", "", "RR", "", "", "38.78257", "69.87081", "Asia/Dushanbe"),("1220747", "Qŭrghonteppa", "Курган Тюбе", "TJ", "762", "", "02", "", "", "37.83399", "68.78186", "Asia/Dushanbe"),("1220750", "Panj", "", "TJ", "762", "", "02", "", "", "37.23634", "69.09911", "Asia/Dushanbe"),("1220798", "Panjakent", "Пенджикент", "TJ", "762", "", "03", "", "", "39.49524", "67.60931", "Asia/Dushanbe"),("1220826", "Farkhor", "Фархор", "TJ", "762", "", "02", "", "", "37.49219", "69.40356", "Asia/Dushanbe"),("1220853", "Orzu", "", "TJ", "762", "", "02", "", "", "37.5582", "68.81952", "Asia/Dushanbe"),("1220855", "Vahdat", "Кофарнихона", "TJ", "762", "", "RR", "", "", "38.55632", "69.01354", "Asia/Dushanbe"),("1220888", "Obigarm", "", "TJ", "762", "", "RR", "", "", "38.71731", "69.70885", "Asia/Dushanbe"),("1220905", "Norak", "", "TJ", "762", "", "02", "", "", "38.38917", "69.32272", "Asia/Dushanbe"),("1220936", "Novobod", "", "TJ", "762", "", "RR", "", "", "39.01084", "70.15082", "Asia/Dushanbe"),("1220962", "Murghob", "", "TJ", "762", "", "01", "", "", "38.17023", "73.96674", "Asia/Dushanbe"),("1221091", "Mŭ’minobod", "", "TJ", "762", "", "02", "", "", "38.10714", "70.03213", "Asia/Dushanbe"),("1221136", "Abdurahmoni Jomí", "", "TJ", "762", "", "02", "", "", "37.94636", "68.80878", "Asia/Dushanbe"),("1221194", "Kŭlob", "Куляб", "TJ", "762", "", "02", "", "", "37.91459", "69.78454", "Asia/Dushanbe"),("1221259", "Kolkhozobod", "", "TJ", "762", "", "02", "", "", "37.58823", "68.65886", "Asia/Dushanbe"),("1221297", "Kirov", "", "TJ", "762", "", "02", "", "", "37.81908", "68.85905", "Asia/Dushanbe"),("1221328", "Khorugh", "Хорог", "TJ", "762", "", "01", "", "", "37.48974", "71.55304", "Asia/Dushanbe"),("1221344", "Khodzha-Maston", "", "TJ", "762", "", "RR", "", "", "38.74457", "68.62702", "Asia/Dushanbe"),("1221614", "Ishqoshim", "Ишкашим", "TJ", "762", "", "01", "", "", "36.72484", "71.61331", "Asia/Dushanbe"),("1221714", "Hisor", "Гиссар", "TJ", "762", "", "RR", "8238355", "", "38.52504", "68.55124", "Asia/Dushanbe"),("1221740", "Rasht", "", "TJ", "762", "", "RR", "", "", "39.02871", "70.37446", "Asia/Dushanbe"),("1221748", "Gharavŭtí", "", "TJ", "762", "", "02", "", "", "37.56703", "68.44668", "Asia/Dushanbe"),("1221808", "Jilikŭl", "", "TJ", "762", "", "02", "", "", "37.49167", "68.53106", "Asia/Dushanbe"),("1221871", "Dŭstí", "", "TJ", "762", "", "02", "", "", "37.34812", "68.66398", "Asia/Dushanbe"),("1221874", "Dushanbe", "Душанбе", "TJ", "762", "", "04", "", "", "38.53575", "68.77905", "Asia/Dushanbe"),("1221965", "Danghara", "Дангара", "TJ", "762", "", "02", "", "", "38.09578", "69.33998", "Asia/Dushanbe"),("1221997", "Chubek", "", "TJ", "762", "", "02", "", "", "37.61453", "69.70525", "Asia/Dushanbe"),("1222107", "Boshkengash", "", "TJ", "762", "", "04", "", "", "38.46613", "68.80533", "Asia/Dushanbe"),("1514829", "Taboshar", "", "TJ", "762", "", "03", "", "", "40.57017", "69.64175", "Asia/Dushanbe"),("1514839", "Proletar", "", "TJ", "762", "", "03", "", "", "40.16713", "69.50163", "Asia/Dushanbe"),("1514844", "Pakhtakoron", "", "TJ", "762", "", "03", "", "", "40.15709", "68.74659", "Asia/Dushanbe"),("1514856", "Nov", "", "TJ", "762", "", "03", "", "", "40.1522", "69.37076", "Asia/Dushanbe"),("1514879", "Khŭjand", "Худжанд", "TJ", "762", "", "03", "", "", "40.28256", "69.62216", "Asia/Dushanbe"),("1514889", "Konsoy", "", "TJ", "762", "", "03", "", "", "40.49155", "69.70245", "Asia/Dushanbe"),("1514891", "Konibodom", "Канибадам", "TJ", "762", "", "03", "", "", "40.29414", "70.43122", "Asia/Dushanbe"),("1514896", "Isfara", "Исфара", "TJ", "762", "", "03", "", "", "40.12649", "70.62526", "Asia/Dushanbe"),("1514913", "Bŭston", "", "TJ", "762", "", "03", "", "", "40.52286", "69.33307", "Asia/Dushanbe"),("1514921", "Shaydon", "", "TJ", "762", "", "03", "", "", "40.66992", "70.3502", "Asia/Dushanbe"),("1514929", "Adrasmon", "", "TJ", "762", "", "03", "", "", "40.64928", "69.98472", "Asia/Dushanbe"),("1538311", "Chkalov", "", "TJ", "762", "", "03", "", "", "40.23417", "69.69481", "Asia/Dushanbe"),("8416817", "Moskovskiy", "", "TJ", "762", "", "02", "", "", "37.60931", "68.58094", "Asia/Dushanbe"),("161616", "Balkanabat", "Балканабат", "TM", "795", "", "02", "", "", "39.51075", "54.36713", "Asia/Ashgabat"),("161901", "Kaka", "Кака", "TM", "795", "", "01", "", "", "37.34821", "59.61431", "Asia/Ashgabat"),("161931", "Serdar", "", "TM", "795", "", "02", "", "", "38.97644", "56.27575", "Asia/Ashgabat"),("161943", "Gumdag", "Гумдаге", "TM", "795", "", "02", "", "", "39.20611", "54.59056", "Asia/Ashgabat"),("161974", "Gazanjyk", "Газанджык", "TM", "795", "", "02", "", "", "39.24463", "55.51536", "Asia/Ashgabat"),("162099", "Abadan", "", "TM", "795", "", "01", "", "", "38.05415", "58.19721", "Asia/Ashgabat"),("162158", "Baharly", "Бахарден", "TM", "795", "", "01", "", "", "38.43624", "57.43158", "Asia/Ashgabat"),("162183", "Ashgabat", "Ашхабад", "TM", "795", "", "01", "", "", "37.95", "58.38333", "Asia/Ashgabat"),("162199", "Annau", "", "TM", "795", "", "01", "", "", "37.88757", "58.516", "Asia/Ashgabat"),("601432", "Yylanly", "", "TM", "795", "TM", "03", "", "", "41.83333", "59.65", "Asia/Ashgabat"),("601475", "Tagta", "", "TM", "795", "", "03", "", "", "41.65041", "59.9164", "Asia/Ashgabat"),("601551", "Akdepe", "", "TM", "795", "", "00", "", "", "42.05513", "59.37877", "Asia/Ashgabat"),("601594", "Türkmenbaşy", "Туркменбашы", "TM", "795", "", "02", "", "", "40.02216", "52.95517", "Asia/Ashgabat"),("601608", "Köneürgench", "Куня-Ургенч", "TM", "795", "", "03", "", "", "42.32773", "59.15442", "Asia/Ashgabat"),("601661", "Boldumsaz", "Болдумсаз", "TM", "795", "", "03", "", "", "42.12824", "59.67101", "Asia/Ashgabat"),("601734", "Daşoguz", "Дашогуз", "TM", "795", "", "03", "", "", "41.83625", "59.96661", "Asia/Ashgabat"),("1218021", "Yolöten", "Иолотань", "TM", "795", "", "05", "", "", "37.29886", "62.35975", "Asia/Ashgabat"),("1218239", "Tejen", "Теджен", "TM", "795", "", "01", "", "", "37.38338", "60.50545", "Asia/Ashgabat"),("1218420", "Seydi", "Сейди", "TM", "795", "", "05", "", "", "39.4816", "62.91374", "Asia/Ashgabat"),("1218436", "Saýat", "", "TM", "795", "", "04", "", "", "38.78393", "63.88035", "Asia/Ashgabat"),("1218612", "Murgab", "", "TM", "795", "", "00", "", "", "37.49656", "61.97142", "Asia/Ashgabat"),("1218667", "Mary", "Мары", "TM", "795", "", "05", "", "", "37.59378", "61.83031", "Asia/Ashgabat"),("1219002", "Atamyrat", "Атамырат", "TM", "795", "", "04", "", "", "37.83573", "65.21058", "Asia/Ashgabat"),("1219377", "Serhetabat", "", "TM", "795", "", "05", "", "", "35.27992", "62.34383", "Asia/Ashgabat"),("1219392", "Gowurdak", "", "TM", "795", "", "04", "", "", "37.81244", "66.04656", "Asia/Ashgabat"),("1219431", "Farap", "", "TM", "795", "", "04", "", "", "39.17037", "63.61165", "Asia/Ashgabat"),("1219649", "Türkmenabat", "Туркменабад", "TM", "795", "", "04", "", "", "39.07328", "63.57861", "Asia/Ashgabat"),("1219762", "Bayramaly", "Байрамалийского", "TM", "795", "", "05", "", "", "37.61852", "62.16715", "Asia/Ashgabat"),("1514792", "Gazojak", "", "TM", "795", "", "04", "", "", "41.18746", "61.4036", "Asia/Ashgabat"),("2463951", "Zaouiat Djedidi", "", "TN", "788", "", "19", "", "", "36.64375", "10.57428", "Africa/Tunis"),("2464041", "Zaghouan", "", "TN", "788", "", "37", "", "", "36.40291", "10.14292", "Africa/Tunis"),("2464168", "Oued Lill", "", "TN", "788", "", "36", "", "", "36.83408", "10.04057", "Africa/Tunis"),("2464427", "Touza", "", "TN", "788", "", "16", "", "", "35.63544", "10.82732", "Africa/Tunis"),("2464470", "Tunis", "Тунис", "TN", "788", "", "36", "", "", "36.81897", "10.16579", "Africa/Tunis"),("2464648", "Tozeur", "Тозер", "TN", "788", "", "35", "", "", "33.91968", "8.13352", "Africa/Tunis"),("2464701", "Tataouine", "", "TN", "788", "", "34", "", "", "32.92967", "10.45177", "Africa/Tunis"),("2464704", "Testour", "", "TN", "788", "", "17", "", "", "36.5513", "9.44307", "Africa/Tunis"),("2464795", "Thala", "", "TN", "788", "", "02", "", "", "35.57244", "8.67031", "Africa/Tunis"),("2464804", "Takelsa", "", "TN", "788", "", "19", "", "", "36.78333", "10.63333", "Africa/Tunis"),("2464809", "Tajerouine", "", "TN", "788", "", "14", "", "", "35.89174", "8.55276", "Africa/Tunis"),("2464855", "Tabursuq", "", "TN", "788", "", "17", "", "", "36.45692", "9.24751", "Africa/Tunis"),("2464871", "Tabarka", "", "TN", "788", "", "06", "", "", "36.95442", "8.75801", "Africa/Tunis"),("2464915", "Sousse", "Сусс", "TN", "788", "", "23", "", "", "35.82539", "10.63699", "Africa/Tunis"),("2465030", "Siliana", "Силиана", "TN", "788", "", "22", "", "", "36.08497", "9.37082", "Africa/Tunis"),("2465138", "Sidi Alouane", "", "TN", "788", "", "15", "", "", "35.37505", "10.93899", "Africa/Tunis"),("2465840", "Sidi Bouzid", "Сиди-Бу-Зид", "TN", "788", "", "33", "", "", "35.03823", "9.48494", "Africa/Tunis"),("2466034", "Sidi Bou Ali", "", "TN", "788", "", "23", "", "", "35.95667", "10.47306", "Africa/Tunis"),("2466897", "Chorbane", "", "TN", "788", "", "15", "", "", "35.28581", "10.3858", "Africa/Tunis"),("2467239", "Sakiet Sidi Youssef", "", "TN", "788", "", "14", "", "", "36.22292", "8.35547", "Africa/Tunis"),("2467246", "Skanes", "", "TN", "788", "", "16", "", "", "35.78333", "10.8", "Africa/Tunis"),("2467368", "Sejenane", "", "TN", "788", "", "18", "", "", "37.05722", "9.23806", "Africa/Tunis"),("2467454", "Sfax", "Сфвкс", "TN", "788", "", "32", "", "", "34.74056", "10.76028", "Africa/Tunis"),("2467506", "Sbiba", "", "TN", "788", "", "02", "", "", "35.54332", "9.0737", "Africa/Tunis"),("2467521", "La Sebala du Mornag", "", "TN", "788", "", "36", "", "", "36.67931", "10.29195", "Africa/Tunis"),("2467813", "Rafrāf", "", "TN", "788", "", "18", "", "", "37.19043", "10.18365", "Africa/Tunis"),("2467815", "Radès", "", "TN", "788", "", "36", "", "", "36.76806", "10.27528", "Africa/Tunis"),("2467856", "Ksour Essaf", "", "TN", "788", "", "15", "", "", "35.41808", "10.99475", "Africa/Tunis"),("2467890", "Ksibet el Mediouni", "", "TN", "788", "", "16", "", "", "35.68561", "10.84256", "Africa/Tunis"),("2467920", "Korba", "Корба", "TN", "788", "", "19", "", "", "36.57861", "10.85861", "Africa/Tunis"),("2467959", "Kélibia", "Келибия", "TN", "788", "", "19", "", "", "36.84757", "11.09386", "Africa/Tunis"),("2468018", "Kebili", "", "TN", "788", "", "31", "", "", "33.70439", "8.96903", "Africa/Tunis"),("2468106", "Ksar Hellal", "", "TN", "788", "", "16", "", "", "35.64773", "10.89046", "Africa/Tunis"),("2468245", "Carthage", "Карфаген", "TN", "788", "TN", "36", "", "", "36.86108", "10.33161", "Africa/Tunis"),("2468285", "El Fahs", "", "TN", "788", "", "37", "", "", "36.37419", "9.90651", "Africa/Tunis"),("2468329", "Galaat el Andeless", "Калат-аль-Андалус", "TN", "788", "", "38", "", "", "37.0629", "10.11829", "Africa/Tunis"),("2468349", "Gafour", "", "TN", "788", "", "22", "", "", "36.32045", "9.32424", "Africa/Tunis"),("2468353", "Gafsa", "Гафса", "TN", "788", "", "30", "2468352", "", "34.425", "8.78417", "Africa/Tunis"),("2468369", "Gabès", "Габес", "TN", "788", "", "29", "", "", "33.88146", "10.0982", "Africa/Tunis"),("2468561", "Nefta", "Нефта", "TN", "788", "", "35", "", "", "33.87309", "7.87765", "Africa/Tunis"),("2468579", "Nabeul", "Набул", "TN", "788", "", "19", "", "", "36.45606", "10.73763", "Africa/Tunis"),("2468925", "Midoun", "Мидун", "TN", "788", "", "28", "", "", "33.80813", "10.99228", "Africa/Tunis"),("2469088", "Mateur", "", "TN", "788", "", "18", "", "", "37.04045", "9.66557", "Africa/Tunis"),("2469140", "Msaken", "", "TN", "788", "", "23", "", "", "35.72917", "10.58082", "Africa/Tunis"),("2469255", "Menzel Kamel", "", "TN", "788", "", "16", "", "", "35.62477", "10.66727", "Africa/Tunis"),("2469256", "Menzel Jemil", "", "TN", "788", "", "18", "", "", "37.23618", "9.91448", "Africa/Tunis"),("2469262", "Mennzel Bou Zelfa", "", "TN", "788", "", "19", "", "", "36.68312", "10.58431", "Africa/Tunis"),("2469264", "Menzel Bourguiba", "", "TN", "788", "", "18", "", "", "37.15368", "9.78594", "Africa/Tunis"),("2469268", "Menzel Abderhaman", "", "TN", "788", "", "18", "", "", "37.23737", "9.86313", "Africa/Tunis"),("2469274", "Manouba", "", "TN", "788", "", "39", "", "", "36.80803", "10.09721", "Africa/Tunis"),("2469321", "Melloulèche", "", "TN", "788", "", "15", "", "", "35.16617", "11.03504", "Africa/Tunis"),("2469341", "Maktar", "", "TN", "788", "", "22", "", "", "35.85798", "9.20072", "Africa/Tunis"),("2469386", "Medjez el Bab", "", "TN", "788", "", "17", "", "", "36.64964", "9.61231", "Africa/Tunis"),("2469473", "Medenine", "", "TN", "788", "", "28", "", "", "33.35495", "10.50548", "Africa/Tunis"),("2469571", "Lemta", "", "TN", "788", "", "16", "", "", "35.66667", "10.88333", "Africa/Tunis"),("2470088", "Jendouba", "Джендуба", "TN", "788", "", "06", "", "", "36.50114", "8.78024", "Africa/Tunis"),("2470120", "Jilma", "", "TN", "788", "", "33", "", "", "35.27311", "9.42385", "Africa/Tunis"),("2470173", "Zarzis", "", "TN", "788", "", "28", "", "", "33.50398", "11.11215", "Africa/Tunis"),("2470189", "Jemna", "", "TN", "788", "", "31", "", "", "33.57778", "9.01472", "Africa/Tunis"),("2470191", "Djemmal", "Джамаль", "TN", "788", "", "16", "", "", "35.62231", "10.75696", "Africa/Tunis"),("2470260", "Djebeniana", "", "TN", "788", "", "32", "", "", "35.035", "10.90809", "Africa/Tunis"),("2470384", "Houmt Souk", "Хумт-Сук", "TN", "788", "", "28", "", "", "33.87576", "10.85745", "Africa/Tunis"),("2470483", "Harqalah", "", "TN", "788", "", "23", "", "", "36.03027", "10.50904", "Africa/Tunis"),("2470579", "Hammam Sousse", "", "TN", "788", "", "23", "", "", "35.8609", "10.60313", "Africa/Tunis"),("2470588", "Hammam-Lif", "Хаммам-Лиф", "TN", "788", "", "36", "", "", "36.72866", "10.34163", "Africa/Tunis"),("2470656", "La Goulette", "", "TN", "788", "", "36", "", "", "36.81806", "10.305", "Africa/Tunis"),("2470800", "Haffouz", "", "TN", "788", "", "03", "", "", "35.63235", "9.67624", "Africa/Tunis"),("2470996", "Rhar el Melah", "", "TN", "788", "", "18", "", "", "37.16939", "10.19064", "Africa/Tunis"),("2471287", "Douz", "Дуз", "TN", "788", "", "31", "", "", "33.46632", "9.0203", "Africa/Tunis"),("2471454", "Degache", "", "TN", "788", "", "35", "", "", "33.97606", "8.2081", "Africa/Tunis"),("2471475", "Douar Tindja", "", "TN", "788", "", "18", "", "", "37.16667", "9.75", "Africa/Tunis"),("2471637", "Dar Chabanne", "", "TN", "788", "", "19", "", "", "36.46798", "10.75167", "Africa/Tunis"),("2471915", "Bou Arkoub", "", "TN", "788", "", "19", "", "", "36.53853", "10.55093", "Africa/Tunis"),("2472261", "Bou Arada", "", "TN", "788", "", "22", "", "", "36.35251", "9.62175", "Africa/Tunis"),("2472380", "Bir el Hafey", "", "TN", "788", "", "33", "", "", "34.93212", "9.19321", "Africa/Tunis"),("2472431", "Ben Gardane", "", "TN", "788", "", "28", "", "", "33.13783", "11.21965", "Africa/Tunis"),("2472479", "Ben Arous", "", "TN", "788", "", "27", "", "", "36.75306", "10.21889", "Africa/Tunis"),("2472706", "Bizerte", "Бизерта", "TN", "788", "", "18", "", "", "37.27442", "9.87391", "Africa/Tunis"),("2472722", "Beni Khiar", "", "TN", "788", "", "19", "", "", "36.46917", "10.78222", "Africa/Tunis"),("2472724", "Beni Khalled", "", "TN", "788", "", "19", "", "", "36.65038", "10.59004", "Africa/Tunis"),("2472732", "Beni Hassane", "", "TN", "788", "", "16", "", "", "35.5672", "10.80869", "Africa/Tunis"),("2472744", "Banbalah", "", "TN", "788", "", "16", "", "", "35.7", "10.8", "Africa/Tunis"),("2472774", "Béja", "Беджа", "TN", "788", "", "17", "", "", "36.72564", "9.18169", "Africa/Tunis"),("2472833", "Zouila", "", "TN", "788", "", "15", "", "", "35.50056", "11.06056", "Africa/Tunis"),("2473161", "Skhira", "", "TN", "788", "", "32", "", "", "34.2992", "10.06999", "Africa/Tunis"),("2473163", "Sbikha", "", "TN", "788", "", "03", "", "", "35.93325", "10.02081", "Africa/Tunis"),("2473169", "Seïada", "", "TN", "788", "", "16", "", "", "35.66887", "10.89246", "Africa/Tunis"),("2473177", "As Sars", "", "TN", "788", "", "14", "", "", "36.0764", "9.02117", "Africa/Tunis"),("2473183", "As Sanad", "", "TN", "788", "", "30", "", "", "34.4628", "9.26404", "Africa/Tunis"),("2473190", "Sahline", "", "TN", "788", "", "16", "", "", "35.75166", "10.71109", "Africa/Tunis"),("2473229", "Chebba", "", "TN", "788", "", "15", "", "", "35.23722", "11.115", "Africa/Tunis"),("2473247", "Ariana", "", "TN", "788", "", "38", "", "", "36.86012", "10.19337", "Africa/Tunis"),("2473257", "Ar Rudayyif", "", "TN", "788", "", "30", "", "", "34.3827", "8.15549", "Africa/Tunis"),("2473258", "Er Regueb", "", "TN", "788", "", "33", "", "", "34.85932", "9.78654", "Africa/Tunis"),("2473420", "Ouardenine", "", "TN", "788", "", "16", "", "", "35.70915", "10.67397", "Africa/Tunis"),("2473439", "El Ksour", "", "TN", "788", "", "14", "", "", "35.89607", "8.88493", "Africa/Tunis"),("2473449", "Kairouan", "Кайруан", "TN", "788", "", "03", "", "", "35.6781", "10.09633", "Africa/Tunis"),("2473457", "Kasserine", "Кассерин", "TN", "788", "", "02", "", "", "35.16758", "8.83651", "Africa/Tunis"),("2473470", "Gremda", "", "TN", "788", "", "32", "", "", "34.75", "10.78333", "Africa/Tunis"),("2473486", "El Golaa", "", "TN", "788", "", "31", "", "", "33.48485", "9.00678", "Africa/Tunis"),("2473493", "Monastir", "Монастир", "TN", "788", "", "16", "", "", "35.77799", "10.82617", "Africa/Tunis"),("2473499", "La Mohammedia", "", "TN", "788", "", "36", "", "", "36.67446", "10.15633", "Africa/Tunis"),("2473517", "Metlaoui", "", "TN", "788", "", "30", "", "", "34.32081", "8.40157", "Africa/Tunis"),("2473525", "Mezzouna", "", "TN", "788", "", "33", "", "", "34.57758", "9.84193", "Africa/Tunis"),("2473533", "Al Matlīn", "", "TN", "788", "", "18", "", "", "37.24516", "10.05", "Africa/Tunis"),("2473540", "Al Marsá", "", "TN", "788", "", "36", "", "", "36.87818", "10.32466", "Africa/Tunis"),("2473558", "El Maamoura", "", "TN", "788", "", "19", "", "", "36.46499", "10.80612", "Africa/Tunis"),("2473572", "Mahdia", "Махдия", "TN", "788", "", "15", "", "", "35.50472", "11.06222", "Africa/Tunis"),("2473628", "Le Krib", "", "TN", "788", "", "22", "", "", "36.32802", "9.13613", "Africa/Tunis"),("2473634", "El Kef", "Эль-Кеф", "TN", "788", "", "14", "", "", "36.17424", "8.70486", "Africa/Tunis"),("2473654", "El Jem", "Эль Джем", "TN", "788", "", "15", "", "", "35.3", "10.71667", "Africa/Tunis"),("2473716", "El Haouaria", "", "TN", "788", "", "19", "", "", "37.05002", "11.01442", "Africa/Tunis"),("2473744", "Hammamet", "Хаммамет", "TN", "788", "", "19", "", "", "36.4", "10.61667", "Africa/Tunis"),("2473747", "El Hamma", "Эль-Хамма", "TN", "788", "", "29", "", "", "33.89152", "9.79629", "Africa/Tunis"),("2473823", "El Battan", "", "TN", "788", "", "39", "", "", "36.80368", "9.84424", "Africa/Tunis"),("2473826", "Bekalta", "", "TN", "788", "", "16", "", "", "35.61739", "10.99466", "Africa/Tunis"),("2473876", "El Alia", "Эль-Алия", "TN", "788", "", "18", "", "", "37.16911", "10.03478", "Africa/Tunis"),("2473913", "Akouda", "", "TN", "788", "", "23", "", "", "35.8691", "10.5653", "Africa/Tunis"),("2581754", "Douane", "", "TN", "788", "", "19", "", "", "36.44766", "10.7557", "Africa/Tunis"),("6355180", "Port el Kantaoui", "", "TN", "788", "", "23", "", "", "35.89239", "10.59434", "Africa/Tunis"),("295781", "Demre", "", "TR", "792", "", "07", "", "", "36.24444", "29.985", "Europe/Istanbul"),("295982", "Zara", "", "TR", "792", "", "58", "", "", "39.89778", "37.75833", "Europe/Istanbul"),("296134", "Yunak", "", "TR", "792", "", "71", "", "", "38.81418", "31.73223", "Europe/Istanbul"),("296138", "Yumurtalık", "", "TR", "792", "", "00", "", "", "36.76667", "35.78333", "Europe/Istanbul"),("296173", "Yüksekova", "", "TR", "792", "", "70", "", "", "37.57362", "44.28716", "Europe/Istanbul"),("296247", "Salat", "", "TR", "792", "", "21", "", "", "37.84172", "40.8865", "Europe/Istanbul"),("296562", "Yozgat", "Йозгат", "TR", "792", "", "66", "", "", "39.82", "34.80444", "Europe/Istanbul"),("296644", "Yolbaşı", "", "TR", "792", "", "72", "", "", "37.38717", "41.31778", "Europe/Istanbul"),("296791", "Yeşilyurt", "", "TR", "792", "", "44", "", "", "38.29602", "38.24526", "Europe/Istanbul"),("296823", "Yeşilova", "", "TR", "792", "", "15", "", "", "37.50806", "29.75472", "Europe/Istanbul"),("296832", "Yeşilli", "", "TR", "792", "", "72", "", "", "37.33813", "40.81739", "Europe/Istanbul"),("296852", "Erzin", "Эрзин", "TR", "792", "", "31", "", "", "36.95348", "36.19839", "Europe/Istanbul"),("296860", "Yeşilhisar", "", "TR", "792", "", "38", "7910468", "", "38.34972", "35.08667", "Europe/Istanbul"),("296895", "Yerköy", "", "TR", "792", "", "66", "", "", "39.63806", "34.46722", "Europe/Istanbul"),("296942", "Yenişarbademli", "", "TR", "792", "", "33", "", "", "37.70778", "31.38639", "Europe/Istanbul"),("296950", "Yenipazar", "", "TR", "792", "", "09", "", "", "37.82332", "28.19573", "Europe/Istanbul"),("297090", "Didim", "Дидимы", "TR", "792", "TR", "09", "8632405", "", "37.38496", "27.25643", "Europe/Istanbul"),("297099", "Yenifakılı", "", "TR", "792", "", "66", "", "", "39.21142", "35.00036", "Europe/Istanbul"),("297119", "Altpınar", "", "TR", "792", "", "68", "", "", "39.20417", "32.74778", "Europe/Istanbul"),("297371", "Yazıhan", "", "TR", "792", "", "44", "", "", "38.59292", "38.17327", "Europe/Istanbul"),("297466", "Yayladağı", "", "TR", "792", "", "31", "", "", "35.9025", "36.06272", "Europe/Istanbul"),("297532", "Yavuzeli", "", "TR", "792", "", "83", "", "", "37.31772", "37.56824", "Europe/Istanbul"),("297564", "Yatağan", "", "TR", "792", "", "48", "", "", "37.34025", "28.14279", "Europe/Istanbul"),("297789", "Yalvaç", "Ялвач", "TR", "792", "", "33", "", "", "38.29556", "31.17778", "Europe/Istanbul"),("297839", "Yalıhüyük", "", "TR", "792", "", "71", "", "", "37.30077", "32.08548", "Europe/Istanbul"),("297917", "Yahyalı", "Яхьялы", "TR", "792", "", "38", "", "", "38.10228", "35.35704", "Europe/Istanbul"),("298033", "Viranşehir", "Вираншехире", "TR", "792", "", "63", "", "", "37.22349", "39.75519", "Europe/Istanbul"),("298088", "Varto", "", "TR", "792", "", "49", "", "", "39.17375", "41.45402", "Europe/Istanbul"),("298117", "Van", "Ван", "TR", "792", "", "65", "", "", "38.49457", "43.38323", "Europe/Istanbul"),("298230", "Cimin", "", "TR", "792", "", "24", "", "", "39.70947", "39.70015", "Europe/Istanbul"),("298299", "Uşak", "Ушак", "TR", "792", "", "64", "", "", "38.67351", "29.4058", "Europe/Istanbul"),("298316", "Urla", "Урла", "TR", "792", "", "35", "", "", "38.32292", "26.76403", "Europe/Istanbul"),("298326", "Ürgüp", "", "TR", "792", "", "50", "", "", "38.6296", "34.91199", "Europe/Istanbul"),("298333", "Şanlıurfa", "Эдесса", "TR", "792", "", "63", "", "", "37.16708", "38.79392", "Europe/Istanbul"),("298433", "Uludere", "", "TR", "792", "", "80", "", "", "37.44074", "42.85236", "Europe/Istanbul"),("298451", "Uluborlu", "", "TR", "792", "", "33", "", "", "38.07825", "30.45019", "Europe/Istanbul"),("298454", "Ulubey", "", "TR", "792", "", "64", "", "", "38.41987", "29.29129", "Europe/Istanbul"),("298485", "Ula", "", "TR", "792", "", "48", "", "", "37.10491", "28.41667", "Europe/Istanbul"),("298647", "Tuzlukçu", "", "TR", "792", "", "71", "", "", "38.47778", "31.62639", "Europe/Istanbul"),("298728", "Tut", "", "TR", "792", "", "02", "", "", "37.79529", "37.9161", "Europe/Istanbul"),("298729", "Turunçova", "", "TR", "792", "", "07", "", "", "36.36889", "30.1375", "Europe/Istanbul"),("298806", "Turgutlu", "", "TR", "792", "", "45", "", "", "38.49533", "27.6997", "Europe/Istanbul"),("298846", "Tunceli", "Тунджели", "TR", "792", "", "62", "", "", "39.09921", "39.54351", "Europe/Istanbul"),("298882", "Tufanbeyli", "", "TR", "792", "", "81", "", "", "38.26333", "36.22056", "Europe/Istanbul"),("298935", "Torbalı", "Торбалы", "TR", "792", "", "35", "", "", "38.1519", "27.36223", "Europe/Istanbul"),("298977", "Toprakkale", "", "TR", "792", "", "91", "", "", "37.06855", "36.14661", "Europe/Istanbul"),("299044", "Pınarbaşı", "", "TR", "792", "", "32", "", "", "36.7034", "34.3627", "Europe/Istanbul"),("299054", "Tomarza", "", "TR", "792", "", "38", "", "", "38.44722", "35.79917", "Europe/Istanbul"),("299137", "Tire", "", "TR", "792", "", "35", "", "", "38.08877", "27.73508", "Europe/Istanbul"),("299268", "Tercan", "", "TR", "792", "", "24", "", "", "39.77709", "40.37783", "Europe/Istanbul"),("299413", "Tekman", "", "TR", "792", "", "25", "", "", "39.64111", "41.50542", "Europe/Istanbul"),("299445", "Tekirova", "Текирова", "TR", "792", "TR", "07", "", "", "36.5017", "30.52723", "Europe/Istanbul"),("299499", "Tefenni", "", "TR", "792", "", "15", "", "", "37.30968", "29.77538", "Europe/Istanbul"),("299545", "Tavşanlı", "", "TR", "792", "", "43", "", "", "39.54237", "29.49866", "Europe/Istanbul"),("299575", "Tavas", "", "TR", "792", "", "20", "", "", "37.57351", "29.07058", "Europe/Istanbul"),("299582", "Tatvan", "Татван", "TR", "792", "", "13", "", "", "38.49221", "42.28269", "Europe/Istanbul"),("299701", "Taşlıçay", "", "TR", "792", "", "04", "", "", "39.62966", "43.36878", "Europe/Istanbul"),("299755", "Taşkent", "", "TR", "792", "", "71", "", "", "36.9243", "32.49131", "Europe/Istanbul"),("299817", "Tarsus", "Тарсус", "TR", "792", "", "32", "", "", "36.91766", "34.89277", "Europe/Istanbul"),("299900", "Talas", "Талас", "TR", "792", "", "38", "", "", "38.6908", "35.5538", "Europe/Istanbul"),("300058", "Susurluk", "", "TR", "792", "", "10", "", "", "39.91361", "28.15778", "Europe/Istanbul"),("300075", "Suruç", "Суруч", "TR", "792", "", "63", "", "", "36.97612", "38.42533", "Europe/Istanbul"),("300195", "Sultanhisar", "", "TR", "792", "", "09", "", "", "37.88989", "28.15436", "Europe/Istanbul"),("300201", "Sultandağı", "", "TR", "792", "", "03", "", "", "38.53111", "31.22806", "Europe/Istanbul"),("300273", "Şuhut", "", "TR", "792", "", "03", "", "", "38.53111", "30.54583", "Europe/Istanbul"),("300352", "Sorgun", "Соргуне", "TR", "792", "", "66", "", "", "39.81012", "35.18596", "Europe/Istanbul"),("300371", "Soma", "Сомы", "TR", "792", "", "45", "", "", "39.18554", "27.60945", "Europe/Istanbul"),("300377", "Solhan", "", "TR", "792", "", "12", "", "", "38.96525", "41.05443", "Europe/Istanbul"),("300399", "Söke", "Сок", "TR", "792", "", "09", "", "", "37.7482", "27.40614", "Europe/Istanbul"),("300438", "Kindirip", "", "TR", "792", "", "72", "", "", "37.44706", "41.21976", "Europe/Istanbul"),("300593", "Sivrihisar", "", "TR", "792", "", "26", "", "", "39.45037", "31.53409", "Europe/Istanbul"),("300601", "Sivrice", "", "TR", "792", "", "23", "", "", "38.44223", "39.30938", "Europe/Istanbul"),("300614", "Siverek", "Сивереке", "TR", "792", "", "63", "", "", "37.75503", "39.31667", "Europe/Istanbul"),("300616", "Sivaslı", "", "TR", "792", "", "64", "", "", "38.49944", "29.68361", "Europe/Istanbul"),("300619", "Sivas", "Сивас", "TR", "792", "", "58", "", "", "39.74833", "37.01611", "Europe/Istanbul"),("300632", "Şirvan", "", "TR", "792", "", "74", "", "", "38.06251", "42.02517", "Europe/Istanbul"),("300640", "Şırnak", "Ширнак", "TR", "792", "", "80", "", "", "37.51393", "42.45432", "Europe/Istanbul"),("300732", "Sındırgı", "", "TR", "792", "", "10", "", "", "39.24128", "28.17842", "Europe/Istanbul"),("300743", "Sincik", "", "TR", "792", "", "02", "", "", "38.03645", "38.61257", "Europe/Istanbul"),("300754", "Sinanpaşa", "", "TR", "792", "", "03", "", "", "38.74444", "30.24278", "Europe/Istanbul"),("300791", "Simav", "", "TR", "792", "", "43", "", "", "39.0882", "28.97767", "Europe/Istanbul"),("300796", "Silvan", "Сильван", "TR", "792", "", "21", "", "", "38.13708", "41.00817", "Europe/Istanbul"),("300797", "Silopi", "Силопи", "TR", "792", "", "80", "", "", "37.24379", "42.46345", "Europe/Istanbul"),("300808", "Silifke", "Силифке", "TR", "792", "", "32", "", "", "36.37778", "33.93444", "Europe/Istanbul"),("300822", "Siirt", "Сиирт", "TR", "792", "", "74", "", "", "37.9293", "41.94134", "Europe/Istanbul"),("301010", "Seydişehir", "", "TR", "792", "", "71", "", "", "37.41926", "31.84527", "Europe/Istanbul"),("301089", "Serinyol", "", "TR", "792", "", "31", "", "", "36.36139", "36.21361", "Europe/Istanbul"),("301101", "Serik", "Серик", "TR", "792", "", "07", "", "", "36.91694", "31.09889", "Europe/Istanbul"),("301116", "Şereflikoçhisar", "", "TR", "792", "", "68", "", "", "38.93925", "33.5386", "Europe/Istanbul"),("301167", "Ebish", "", "TR", "792", "", "72", "", "", "37.46347", "41.18863", "Europe/Istanbul"),("301172", "Senirkent", "", "TR", "792", "", "33", "", "", "38.10444", "30.54861", "Europe/Istanbul"),("301209", "Şemdinli", "", "TR", "792", "", "70", "", "", "37.30514", "44.5742", "Europe/Istanbul"),("301238", "Side", "", "TR", "792", "", "07", "7732193", "", "36.76667", "31.38889", "Europe/Istanbul"),("301251", "Selendi", "", "TR", "792", "", "45", "", "", "38.74444", "28.86778", "Europe/Istanbul"),("301256", "Selçuk", "Сельчук", "TR", "792", "", "35", "", "", "37.95137", "27.36849", "Europe/Istanbul"),("301350", "Seferihisar", "", "TR", "792", "", "35", "7732732", "", "38.1975", "26.83881", "Europe/Istanbul"),("301353", "Şefaatlı", "", "TR", "792", "", "66", "", "", "39.5043", "34.7563", "Europe/Istanbul"),("301431", "Savur", "", "TR", "792", "", "72", "", "", "37.53544", "40.87876", "Europe/Istanbul"),("301453", "Savaştepe", "", "TR", "792", "", "10", "", "", "39.38319", "27.65612", "Europe/Istanbul"),("301483", "Sason", "", "TR", "792", "", "76", "", "", "38.32767", "41.41377", "Europe/Istanbul"),("301492", "Saruhanlı", "", "TR", "792", "", "45", "", "", "38.73455", "27.56811", "Europe/Istanbul"),("301529", "Edremit", "", "TR", "792", "", "65", "", "", "38.42069", "43.25889", "Europe/Istanbul"),("301537", "Şarkışla", "", "TR", "792", "", "58", "", "", "39.35186", "36.40976", "Europe/Istanbul"),("301539", "Şarkîkaraağaç", "", "TR", "792", "", "33", "", "", "38.07944", "31.36639", "Europe/Istanbul"),("301566", "Sarıyahşi", "", "TR", "792", "", "75", "", "", "38.98349", "33.84136", "Europe/Istanbul"),("301567", "Sarıveliler", "", "TR", "792", "", "78", "", "", "36.69705", "32.61203", "Europe/Istanbul"),("301609", "Sarıoğlan", "", "TR", "792", "", "38", "", "", "39.07694", "35.96671", "Europe/Istanbul"),("301731", "Sarıgöl", "", "TR", "792", "", "45", "", "", "38.23953", "28.69663", "Europe/Istanbul"),("301824", "Sarayönü", "", "TR", "792", "", "71", "", "", "38.26201", "32.40457", "Europe/Istanbul"),("301827", "Sarayköy", "", "TR", "792", "", "20", "", "", "37.92448", "28.92516", "Europe/Istanbul"),("301829", "Saraykent", "", "TR", "792", "", "66", "", "", "39.69361", "35.51111", "Europe/Istanbul"),("301884", "Şaphane", "", "TR", "792", "", "43", "", "", "39.0273", "29.22218", "Europe/Istanbul"),("301911", "Sandıklı", "Сандикли", "TR", "792", "", "03", "", "", "38.46472", "30.26946", "Europe/Istanbul"),("301943", "Samsat", "", "TR", "792", "", "02", "", "", "37.58194", "38.47417", "Europe/Istanbul"),("302043", "Salihli", "", "TR", "792", "", "45", "", "", "38.48258", "28.14774", "Europe/Istanbul"),("302150", "Saimbeyli", "", "TR", "792", "", "81", "", "", "37.98632", "36.09056", "Europe/Istanbul"),("302355", "Reyhanlı", "Рейханлы", "TR", "792", "", "31", "", "", "36.26791", "36.56747", "Europe/Istanbul"),("302401", "Refahiye", "", "TR", "792", "", "24", "", "", "39.89315", "38.76607", "Europe/Istanbul"),("302482", "Pozantı", "", "TR", "792", "", "81", "", "", "37.42778", "34.87167", "Europe/Istanbul"),("302525", "Polatlı", "", "TR", "792", "", "68", "", "", "39.57715", "32.14132", "Europe/Istanbul"),("302667", "Pınarbaşı", "", "TR", "792", "", "38", "", "", "38.72285", "36.39314", "Europe/Istanbul"),("302720", "Pervari", "", "TR", "792", "", "74", "", "", "37.93573", "42.54927", "Europe/Istanbul"),("302724", "Pertek", "", "TR", "792", "", "62", "", "", "38.86574", "39.32273", "Europe/Istanbul"),("302781", "Pazaryeri", "", "TR", "792", "", "11", "", "", "39.99395", "29.90424", "Europe/Istanbul"),("302787", "Pazarlar", "", "TR", "792", "", "43", "", "", "38.995", "29.12583", "Europe/Istanbul"),("302800", "Pazarcık", "Пазарджик", "TR", "792", "", "46", "", "", "37.48685", "37.29961", "Europe/Istanbul"),("302816", "Payallar", "", "TR", "792", "", "07", "7732185", "", "36.6016", "31.85057", "Europe/Istanbul"),("302819", "Patnos", "", "TR", "792", "", "04", "", "", "39.22493", "42.85693", "Europe/Istanbul"),("302824", "Pasinler", "", "TR", "792", "", "25", "", "", "39.97975", "41.66997", "Europe/Istanbul"),("302903", "Pamukkale", "", "TR", "792", "", "20", "", "", "37.91644", "29.11729", "Europe/Istanbul"),("302912", "Palu", "", "TR", "792", "", "23", "", "", "38.69135", "39.91984", "Europe/Istanbul"),("302986", "Özdere", "", "TR", "792", "TR", "35", "", "", "38.01611", "27.12806", "Europe/Istanbul"),("303022", "Özalp", "", "TR", "792", "", "65", "", "", "38.65455", "43.98869", "Europe/Istanbul"),("303195", "Osmaniye", "Османие", "TR", "792", "", "91", "", "", "37.07417", "36.24778", "Europe/Istanbul"),("303290", "Ortaköy", "", "TR", "792", "", "75", "", "", "38.73728", "34.03866", "Europe/Istanbul"),("303305", "Ortaköy", "", "TR", "792", "", "72", "", "", "37.22089", "40.78476", "Europe/Istanbul"),("303354", "Ortaca", "", "TR", "792", "", "48", "", "", "36.83915", "28.76457", "Europe/Istanbul"),("303409", "Orhaneli", "", "TR", "792", "", "16", "", "", "39.90333", "28.99056", "Europe/Istanbul"),("303532", "Ömerli", "", "TR", "792", "", "72", "", "", "37.39903", "40.95442", "Europe/Istanbul"),("303642", "Oğuzeli", "", "TR", "792", "", "83", "", "", "36.96572", "37.51339", "Europe/Istanbul"),("303700", "Ödemiş", "", "TR", "792", "", "35", "", "", "38.2278", "27.96955", "Europe/Istanbul"),("303750", "Nusaybin", "Нузайбин", "TR", "792", "", "72", "", "", "37.07028", "41.21465", "Europe/Istanbul"),("303763", "Nurhak", "", "TR", "792", "", "46", "", "", "37.96366", "37.44047", "Europe/Istanbul"),("303798", "Nizip", "Низипе", "TR", "792", "", "83", "", "", "37.00972", "37.79417", "Europe/Istanbul"),("303827", "Niğde", "Нигде", "TR", "792", "", "73", "", "", "37.96583", "34.67935", "Europe/Istanbul"),("303831", "Nevşehir", "Невшехир", "TR", "792", "", "50", "", "", "38.625", "34.71222", "Europe/Istanbul"),("303873", "Nazilli", "Назилли", "TR", "792", "", "09", "", "", "37.91631", "28.32225", "Europe/Istanbul"),("304009", "Mutki", "", "TR", "792", "", "13", "", "", "38.40624", "41.92018", "Europe/Istanbul"),("304013", "Mut", "", "TR", "792", "", "32", "", "", "36.64389", "33.43885", "Europe/Istanbul"),("304081", "Muş", "Муш", "TR", "792", "", "49", "", "", "38.73163", "41.48482", "Europe/Istanbul"),("304184", "Muğla", "Мугла", "TR", "792", "", "48", "", "", "37.21807", "28.3665", "Europe/Istanbul"),("304196", "Mucur", "", "TR", "792", "", "40", "", "", "39.06147", "34.38286", "Europe/Istanbul"),("304355", "Milas", "Милас", "TR", "792", "", "48", "", "", "37.31639", "27.78389", "Europe/Istanbul"),("304382", "Midyat", "Мидьят", "TR", "792", "", "72", "", "", "37.41908", "41.33909", "Europe/Istanbul"),("304531", "Mercin", "Мерсин", "TR", "792", "TR", "32", "", "", "36.79526", "34.61792", "Europe/Istanbul"),("304612", "Menemen", "Менемен", "TR", "792", "", "35", "", "", "38.60754", "27.06938", "Europe/Istanbul"),("304734", "Mazıdağı", "", "TR", "792", "", "72", "", "", "37.47801", "40.48152", "Europe/Istanbul"),("304782", "Marmaris", "Мармарис", "TR", "792", "", "48", "7732942", "", "36.855", "28.27417", "Europe/Istanbul"),("304797", "Mardin", "Мардин", "TR", "792", "", "72", "441866", "", "37.31309", "40.74357", "Europe/Istanbul"),("304827", "Manisa", "Маниса", "TR", "792", "", "45", "", "", "38.61202", "27.42647", "Europe/Istanbul"),("304854", "Manavgat", "Манавгат", "TR", "792", "", "07", "7732193", "", "36.78667", "31.44306", "Europe/Istanbul"),("304916", "Malazgirt", "", "TR", "792", "", "49", "", "", "39.1465", "42.53536", "Europe/Istanbul"),("304922", "Malatya", "Малатья", "TR", "792", "", "44", "", "", "38.35018", "38.31667", "Europe/Istanbul"),("304964", "Mahmutlar", "", "TR", "792", "", "07", "7732185", "", "36.49463", "32.09085", "Europe/Istanbul"),("305089", "Lice", "", "TR", "792", "", "21", "", "", "38.45821", "40.63888", "Europe/Istanbul"),("305210", "Kuyucak", "", "TR", "792", "", "09", "", "", "37.9133", "28.45917", "Europe/Istanbul"),("305268", "Kütahya", "Кютахья", "TR", "792", "", "43", "", "", "39.42417", "29.98333", "Europe/Istanbul"),("305359", "Kuşadası", "Кушадасы", "TR", "792", "", "09", "", "", "37.85562", "27.2566", "Europe/Istanbul"),("305532", "Kurtalan", "", "TR", "792", "", "74", "", "", "37.92533", "41.68493", "Europe/Istanbul"),("305680", "Beykonak", "", "TR", "792", "", "07", "", "", "36.32573", "30.30302", "Europe/Istanbul"),("305699", "Kumçatı", "", "TR", "792", "", "80", "", "", "37.46594", "42.28791", "Europe/Istanbul"),("305737", "Kuluncak", "", "TR", "792", "", "44", "", "", "38.87656", "37.66279", "Europe/Istanbul"),("305742", "Kulu", "", "TR", "792", "", "71", "", "", "39.09513", "33.07989", "Europe/Istanbul"),("305750", "Kulp", "", "TR", "792", "", "21", "", "", "38.49754", "41.00668", "Europe/Istanbul"),("305810", "Kula", "Кул", "TR", "792", "", "45", "7910589", "", "38.54726", "28.64976", "Europe/Istanbul"),("306041", "Kozluk", "", "TR", "792", "", "76", "", "", "38.19118", "41.47775", "Europe/Istanbul"),("306112", "Kozan", "", "TR", "792", "", "81", "", "", "37.45517", "35.81573", "Europe/Istanbul"),("306116", "Kozaklı", "", "TR", "792", "", "50", "", "", "39.21643", "34.84909", "Europe/Istanbul"),("306207", "Kovancılar", "", "TR", "792", "", "23", "", "", "38.71882", "39.86268", "Europe/Istanbul"),("306285", "Köşk", "", "TR", "792", "", "09", "", "", "37.85333", "28.05167", "Europe/Istanbul"),("306474", "Korkuteli", "Коркутели", "TR", "792", "", "07", "", "", "37.06498", "30.19565", "Europe/Istanbul"),("306476", "Korkut", "", "TR", "792", "", "49", "", "", "38.7339", "41.78396", "Europe/Istanbul"),("306571", "Konya", "Конья", "TR", "792", "", "71", "", "", "37.87135", "32.48464", "Europe/Istanbul"),("306908", "Koçarlı", "", "TR", "792", "", "09", "", "", "37.76113", "27.70583", "Europe/Istanbul"),("306935", "Kocaköy", "", "TR", "792", "", "21", "", "", "38.28889", "40.49786", "Europe/Istanbul"),("306962", "Kocahasanlı", "", "TR", "792", "", "32", "", "", "36.58417", "34.27359", "Europe/Istanbul"),("307084", "Kızıltepe", "Кызылтепе", "TR", "792", "", "72", "", "", "37.18836", "40.57723", "Europe/Istanbul"),("307211", "Serinhisar", "", "TR", "792", "", "20", "", "", "37.58105", "29.26639", "Europe/Istanbul"),("307515", "Kırşehir", "Кыршехир", "TR", "792", "", "40", "", "", "39.14583", "34.16389", "Europe/Istanbul"),("307623", "Kırkağaç", "", "TR", "792", "", "45", "", "", "39.10638", "27.66925", "Europe/Istanbul"),("307654", "Kırıkkale", "Кырыккале", "TR", "792", "", "79", "", "", "39.84528", "33.50639", "Europe/Istanbul"),("307657", "Kırıkhan", "", "TR", "792", "", "31", "", "", "36.49939", "36.35755", "Europe/Istanbul"),("307727", "Kiraz", "", "TR", "792", "", "35", "", "", "38.23056", "28.20444", "Europe/Istanbul"),("307786", "Kınık", "", "TR", "792", "", "35", "", "", "39.08722", "27.38333", "Europe/Istanbul"),("307864", "Kilis", "Килис", "TR", "792", "", "90", "", "", "36.71611", "37.115", "Europe/Istanbul"),("308024", "Keskin", "Кескин", "TR", "792", "", "79", "", "", "39.67306", "33.61361", "Europe/Istanbul"),("308133", "Kepsut", "", "TR", "792", "", "10", "", "", "39.68889", "28.15222", "Europe/Istanbul"),("308220", "Kemer", "Кемер", "TR", "792", "TR", "07", "", "", "36.59778", "30.56056", "Europe/Istanbul"),("308224", "Kemalpaşa", "Кемальпаша", "TR", "792", "", "35", "", "", "38.42621", "27.41731", "Europe/Istanbul"),("308365", "Keçiborlu", "", "TR", "792", "", "33", "", "", "37.9425", "30.30222", "Europe/Istanbul"),("308389", "Keban", "", "TR", "792", "", "23", "", "", "38.7938", "38.73517", "Europe/Istanbul"),("308464", "Kayseri", "Кайсери", "TR", "792", "", "38", "", "", "38.73222", "35.48528", "Europe/Istanbul"),("308572", "Kayapınar", "", "TR", "792", "", "76", "", "", "37.55762", "41.16231", "Europe/Istanbul"),("308697", "Kayabağlar", "", "TR", "792", "", "74", "", "", "37.98599", "41.66756", "Europe/Istanbul"),("308948", "Kaş", "", "TR", "792", "", "07", "", "", "36.20176", "29.63766", "Europe/Istanbul"),("308998", "Aladağ", "", "TR", "792", "", "81", "", "", "37.5485", "35.39603", "Europe/Istanbul"),("309032", "Karlıova", "", "TR", "792", "", "12", "", "", "39.29044", "41.00594", "Europe/Istanbul"),("309199", "Karayazı", "", "TR", "792", "", "25", "", "", "39.69604", "42.14277", "Europe/Istanbul"),("309312", "Karataş", "", "TR", "792", "", "81", "", "", "36.58204", "35.37014", "Europe/Istanbul"),("309415", "Karapınar", "", "TR", "792", "", "71", "", "", "37.71596", "33.55064", "Europe/Istanbul"),("309527", "Karaman", "Караман", "TR", "792", "", "78", "", "", "37.18111", "33.215", "Europe/Istanbul"),("309610", "Karakoyunlu", "", "TR", "792", "", "88", "", "", "39.87036", "43.63014", "Europe/Istanbul"),("309647", "Ağrı", "Агры", "TR", "792", "", "04", "", "", "39.71944", "43.05139", "Europe/Istanbul"),("309663", "Karakoçan", "Каракоджана", "TR", "792", "", "23", "", "", "38.95178", "40.02706", "Europe/Istanbul"),("309705", "Karakeçili", "", "TR", "792", "", "79", "", "", "39.59417", "33.37778", "Europe/Istanbul"),("309758", "Karaisalı", "", "TR", "792", "", "81", "", "", "37.25667", "35.05889", "Europe/Istanbul"),("310004", "Karaçoban", "", "TR", "792", "", "25", "", "", "39.34364", "42.09918", "Europe/Istanbul"),("310044", "Karacasu", "", "TR", "792", "", "09", "", "", "37.72816", "28.60569", "Europe/Istanbul"),("310554", "Kangal", "", "TR", "792", "", "58", "", "", "39.23354", "37.39111", "Europe/Istanbul"),("310641", "Kaman", "Каман", "TR", "792", "", "40", "", "", "39.3575", "33.72389", "Europe/Istanbul"),("310784", "Kale", "", "TR", "792", "", "44", "", "", "39.03333", "38", "Europe/Istanbul"),("310789", "Kale", "", "TR", "792", "", "20", "", "", "37.43917", "28.84528", "Europe/Istanbul"),("310855", "Kâhta", "Кахта", "TR", "792", "", "02", "", "", "37.78552", "38.6237", "Europe/Istanbul"),("310859", "Kahramanmaraş", "Кахраманмараш", "TR", "792", "", "46", "", "", "37.5847", "36.92641", "Europe/Istanbul"),("310888", "Kadışehri", "", "TR", "792", "", "66", "", "", "39.99568", "35.79193", "Europe/Istanbul"),("310892", "Kadirli", "", "TR", "792", "", "81", "", "", "37.37389", "36.09611", "Europe/Istanbul"),("310907", "Kadınhanı", "", "TR", "792", "", "71", "", "", "38.23972", "32.21139", "Europe/Istanbul"),("310982", "Kabala", "", "TR", "792", "", "72", "", "", "37.34585", "40.80059", "Europe/Istanbul"),("311046", "İzmir", "Измир", "TR", "792", "", "35", "", "", "38.41273", "27.13838", "Europe/Istanbul"),("311054", "İvrindi", "", "TR", "792", "", "10", "", "", "39.58389", "27.48639", "Europe/Istanbul"),("311073", "Isparta", "Испарта", "TR", "792", "", "33", "", "", "37.76444", "30.55222", "Europe/Istanbul"),("311111", "İskenderun", "Искендерун", "TR", "792", "", "31", "", "", "36.58718", "36.17347", "Europe/Istanbul"),("311159", "Işıklar", "", "TR", "792", "", "03", "", "", "38.67101", "30.74098", "Europe/Istanbul"),("311193", "İscehisar", "", "TR", "792", "", "03", "", "", "38.86194", "30.75028", "Europe/Istanbul"),("311264", "İnönü", "", "TR", "792", "", "78", "", "", "37.31667", "33.76667", "Europe/Istanbul"),("311314", "İncirliova", "", "TR", "792", "", "09", "", "", "37.85222", "27.72361", "Europe/Istanbul"),("311433", "İmranlı", "", "TR", "792", "", "58", "", "", "39.87544", "38.11358", "Europe/Istanbul"),("311453", "İmamoğlu", "", "TR", "792", "", "81", "", "", "37.26506", "35.65717", "Europe/Istanbul"),("311533", "Ilıca", "", "TR", "792", "", "25", "", "", "39.94653", "41.0952", "Europe/Istanbul"),("311553", "Ilgın", "", "TR", "792", "", "71", "", "", "38.27917", "31.91389", "Europe/Istanbul"),("311645", "İhsaniye", "", "TR", "792", "", "03", "", "", "39.02916", "30.41639", "Europe/Istanbul"),("311665", "Iğdır", "Игдир", "TR", "792", "", "88", "", "", "39.92371", "44.045", "Europe/Istanbul"),("311704", "İdil", "Идиль", "TR", "792", "", "80", "", "", "37.33481", "41.88944", "Europe/Istanbul"),("311777", "Hüyük", "", "TR", "792", "", "71", "", "", "37.95388", "31.59639", "Europe/Istanbul"),("311869", "Hozat", "", "TR", "792", "", "62", "", "", "39.10029", "39.20816", "Europe/Istanbul"),("311962", "Honaz", "", "TR", "792", "", "20", "", "", "37.7573", "29.26996", "Europe/Istanbul"),("312024", "Hizan", "", "TR", "792", "", "13", "", "", "38.22498", "42.4183", "Europe/Istanbul"),("312114", "Hınıs", "", "TR", "792", "", "25", "", "", "39.35766", "41.69253", "Europe/Istanbul"),("312134", "Hilvan", "", "TR", "792", "", "63", "", "", "37.58687", "38.95505", "Europe/Istanbul"),("312245", "Hekimhan", "", "TR", "792", "", "44", "", "", "38.81622", "37.92882", "Europe/Istanbul"),("312253", "Hazro", "", "TR", "792", "", "21", "", "", "38.24903", "40.77129", "Europe/Istanbul"),("312289", "Haymana", "", "TR", "792", "", "68", "", "", "39.43212", "32.49732", "Europe/Istanbul"),("312355", "Havran", "", "TR", "792", "", "10", "", "", "39.55833", "27.09833", "Europe/Istanbul"),("312405", "Hassa", "", "TR", "792", "", "31", "", "", "36.79944", "36.51778", "Europe/Istanbul"),("312504", "Hasanbeyli", "", "TR", "792", "", "91", "", "", "37.12838", "36.54608", "Europe/Istanbul"),("312531", "Harran", "", "TR", "792", "", "63", "", "", "36.86", "39.03139", "Europe/Istanbul"),("312663", "Hani", "", "TR", "792", "", "21", "", "", "38.40741", "40.38578", "Europe/Istanbul"),("312899", "Hadim", "Хадим", "TR", "792", "", "71", "", "", "36.98776", "32.45674", "Europe/Istanbul"),("313013", "Hacılar", "", "TR", "792", "", "38", "", "", "38.64631", "35.44937", "Europe/Istanbul"),("313110", "Hacıbektaş", "", "TR", "792", "", "50", "", "", "38.94077", "34.5577", "Europe/Istanbul"),("313314", "Gürün", "", "TR", "792", "", "58", "", "", "38.72225", "37.27097", "Europe/Istanbul"),("313331", "Güroymak", "", "TR", "792", "", "13", "", "", "38.5758", "42.01558", "Europe/Istanbul"),("313526", "Eksere", "", "TR", "792", "", "07", "", "", "36.81339", "31.99971", "Europe/Istanbul"),("313658", "Gülşehir", "", "TR", "792", "", "50", "", "", "38.74594", "34.62524", "Europe/Istanbul"),("313669", "Gülnar", "", "TR", "792", "", "32", "", "", "36.34148", "33.39921", "Europe/Istanbul"),("313900", "Göynük", "", "TR", "792", "", "07", "7732191", "", "36.66", "30.55", "Europe/Istanbul"),("313947", "Göreme", "", "TR", "792", "", "50", "", "", "38.6437", "34.83529", "Europe/Istanbul"),("313960", "Gördes", "", "TR", "792", "", "45", "", "", "38.93278", "28.28942", "Europe/Istanbul"),("313973", "Gönen", "", "TR", "792", "", "33", "", "", "37.95639", "30.5114", "Europe/Istanbul"),("314038", "Gölmarmara", "", "TR", "792", "", "45", "", "", "38.71389", "27.91417", "Europe/Istanbul"),("314072", "Gölhisar", "", "TR", "792", "", "15", "", "", "37.1459", "29.50876", "Europe/Istanbul"),("314136", "Gölbaşı", "", "TR", "792", "", "02", "", "", "37.78361", "37.63667", "Europe/Istanbul"),("314188", "Göksun", "", "TR", "792", "", "46", "", "", "38.02096", "36.4973", "Europe/Istanbul"),("314557", "Gevaş", "", "TR", "792", "", "65", "", "", "38.2921", "43.10189", "Europe/Istanbul"),("314573", "Germencik", "", "TR", "792", "", "09", "", "", "37.87056", "27.60283", "Europe/Istanbul"),("314608", "Gerdzhyush", "", "TR", "792", "", "76", "", "", "37.56249", "41.37753", "Europe/Istanbul"),("314648", "Genç", "Генк", "TR", "792", "", "12", "", "", "38.74773", "40.55343", "Europe/Istanbul"),("314665", "Gemerek", "", "TR", "792", "", "58", "", "", "39.18342", "36.07189", "Europe/Istanbul"),("314677", "Gelinkaya", "", "TR", "792", "", "72", "", "", "37.41683", "41.26994", "Europe/Istanbul"),("314698", "Gelendost", "", "TR", "792", "", "33", "", "", "38.12083", "31.01528", "Europe/Istanbul"),("314716", "Gediz", "Гедиз", "TR", "792", "", "43", "", "", "38.99389", "29.39131", "Europe/Istanbul"),("314812", "Gazipaşa", "", "TR", "792", "", "07", "", "", "36.26942", "32.31792", "Europe/Istanbul"),("314830", "Gaziantep", "Газиантеп", "TR", "792", "", "83", "", "", "37.05944", "37.3825", "Europe/Istanbul"),("314903", "Foça", "", "TR", "792", "", "35", "", "", "38.6703", "26.75656", "Europe/Istanbul"),("314923", "Finike", "", "TR", "792", "", "07", "7732189", "", "36.295", "30.14056", "Europe/Istanbul"),("314967", "Fethiye", "Фетхие", "TR", "792", "", "48", "7732940", "", "36.64038", "29.12758", "Europe/Istanbul"),("314996", "Felahiye", "", "TR", "792", "", "38", "", "", "39.09056", "35.56722", "Europe/Istanbul"),("315061", "Ezine", "", "TR", "792", "", "17", "", "", "39.78561", "26.34083", "Europe/Istanbul"),("315183", "Eşme", "", "TR", "792", "", "64", "", "", "38.39976", "28.96905", "Europe/Istanbul"),("315202", "Eskişehir", "Эскишехир", "TR", "792", "", "26", "", "", "39.77667", "30.52056", "Europe/Istanbul"),("315368", "Erzurum", "Эрзурум", "TR", "792", "", "25", "", "", "39.90861", "41.27694", "Europe/Istanbul"),("315373", "Erzincan", "Эрзинджан", "TR", "792", "", "24", "", "", "39.73919", "39.49015", "Europe/Istanbul"),("315378", "Eruh", "", "TR", "792", "", "74", "", "", "37.74183", "42.17422", "Europe/Istanbul"),("315401", "Ermenek", "", "TR", "792", "", "78", "", "", "36.64043", "32.89179", "Europe/Istanbul"),("315468", "Ergani", "Эграни", "TR", "792", "", "21", "", "", "38.26899", "39.75446", "Europe/Istanbul"),("315498", "Ereğli", "Эрегли", "TR", "792", "", "71", "", "", "37.51333", "34.04672", "Europe/Istanbul"),("315515", "Erdemli", "Эрдемли", "TR", "792", "", "32", "", "", "36.60498", "34.30836", "Europe/Istanbul"),("315530", "Erciş", "", "TR", "792", "", "65", "", "", "39.02587", "43.35964", "Europe/Istanbul"),("315617", "Emirgazi", "", "TR", "792", "", "71", "", "", "37.90222", "33.83722", "Europe/Istanbul"),("315621", "Emirdağ", "", "TR", "792", "", "03", "", "", "39.01972", "31.15", "Europe/Istanbul"),("315639", "Emet", "Эмет", "TR", "792", "", "43", "", "", "39.343", "29.25847", "Europe/Istanbul"),("315697", "Elmalı", "", "TR", "792", "", "07", "", "", "36.73583", "29.91775", "Europe/Istanbul"),("315720", "Elmadağ", "", "TR", "792", "", "68", "", "", "39.92083", "33.23083", "Europe/Istanbul"),("315758", "Eleşkirt", "", "TR", "792", "", "04", "", "", "39.79803", "42.67574", "Europe/Istanbul"),("315795", "Elbistan", "Эльбистан", "TR", "792", "", "46", "", "", "38.20591", "37.1983", "Europe/Istanbul"),("315808", "Elazığ", "Элязыг", "TR", "792", "", "23", "", "", "38.67431", "39.22321", "Europe/Istanbul"),("315835", "Celeyke", "", "TR", "792", "", "46", "", "", "38.05974", "37.18786", "Europe/Istanbul"),("315905", "Eğirdir", "", "TR", "792", "", "33", "", "", "37.87462", "30.85042", "Europe/Istanbul"),("315985", "Edremit", "Эдремит", "TR", "792", "", "10", "", "", "39.59611", "27.02444", "Europe/Istanbul"),("316102", "Dursunbey", "", "TR", "792", "", "10", "", "", "39.58596", "28.62568", "Europe/Istanbul"),("316284", "Dörtyol", "", "TR", "792", "", "31", "436927", "", "36.83917", "36.23025", "Europe/Istanbul"),("316330", "Domaniç", "", "TR", "792", "", "43", "", "", "39.80194", "29.60918", "Europe/Istanbul"),("316411", "Doğubayazıt", "Догубаязит", "TR", "792", "", "04", "", "", "39.54694", "44.08417", "Europe/Istanbul"),("316431", "Doğanyol", "", "TR", "792", "", "44", "", "", "38.30746", "39.03431", "Europe/Istanbul"),("316440", "Doğanşehir", "", "TR", "792", "", "44", "", "", "38.08574", "37.87116", "Europe/Istanbul"),("316475", "Doğanhisar", "", "TR", "792", "", "71", "", "", "38.1463", "31.67648", "Europe/Istanbul"),("316541", "Diyarbakır", "Диярбакыр", "TR", "792", "", "21", "", "", "37.91363", "40.21721", "Europe/Istanbul"),("316542", "Diyadin", "", "TR", "792", "", "04", "", "", "39.54056", "43.67135", "Europe/Istanbul"),("316544", "Divriği", "", "TR", "792", "", "58", "", "", "39.371", "38.1137", "Europe/Istanbul"),("316634", "Dinar", "Динар", "TR", "792", "", "03", "", "", "38.065", "30.16557", "Europe/Istanbul"),("316726", "Dikili", "", "TR", "792", "", "35", "", "", "39.071", "26.89017", "Europe/Istanbul"),("316746", "Dicle", "", "TR", "792", "", "21", "", "", "38.36571", "40.0645", "Europe/Istanbul"),("316795", "Develi", "", "TR", "792", "", "38", "", "", "38.39056", "35.49222", "Europe/Istanbul"),("316877", "Derinkuyu", "", "TR", "792", "", "50", "", "", "38.3751", "34.73419", "Europe/Istanbul"),("317049", "Derebucak", "", "TR", "792", "", "71", "", "", "37.39179", "31.50918", "Europe/Istanbul"),("317095", "Derbent", "", "TR", "792", "", "71", "", "", "38.01422", "32.01639", "Europe/Istanbul"),("317109", "Denizli", "Денизли", "TR", "792", "", "20", "", "", "37.77417", "29.0875", "Europe/Istanbul"),("317241", "Demirci", "", "TR", "792", "", "45", "", "", "39.04607", "28.65889", "Europe/Istanbul"),("317332", "Delice", "", "TR", "792", "", "79", "", "", "39.95371", "34.02587", "Europe/Istanbul"),("317496", "Dazkırı", "", "TR", "792", "", "03", "", "", "37.91861", "29.86056", "Europe/Istanbul"),("317515", "Davutlar", "", "TR", "792", "", "09", "", "", "37.73392", "27.29283", "Europe/Istanbul"),("317543", "Datça", "", "TR", "792", "", "48", "", "", "36.73778", "27.68417", "Europe/Istanbul"),("317587", "Dargeçit", "Даргечит", "TR", "792", "", "72", "", "", "37.54616", "41.71652", "Europe/Istanbul"),("317588", "Darende", "Даренде", "TR", "792", "", "44", "", "", "38.54583", "37.50583", "Europe/Istanbul"),("317837", "Çüngüş", "", "TR", "792", "", "21", "", "", "38.20798", "39.28554", "Europe/Istanbul"),("317844", "Çumra", "", "TR", "792", "", "71", "", "", "37.5732", "32.77446", "Europe/Istanbul"),("317851", "Menderes", "Мендерес", "TR", "792", "", "35", "", "", "38.24963", "27.13429", "Europe/Istanbul"),("317953", "Çukurca", "", "TR", "792", "", "70", "", "", "37.24806", "43.61361", "Europe/Istanbul"),("318137", "Hakkari", "Хаккари", "TR", "792", "", "70", "", "", "37.57444", "43.74083", "Europe/Istanbul"),("318253", "Cizre", "Джизре", "TR", "792", "", "80", "", "", "37.33024", "42.18484", "Europe/Istanbul"),("318264", "Çivril", "", "TR", "792", "", "20", "", "", "38.30139", "29.73861", "Europe/Istanbul"),("318372", "Çine", "", "TR", "792", "", "09", "", "", "37.61266", "28.05912", "Europe/Istanbul"),("318506", "Cihanbeyli", "", "TR", "792", "", "71", "", "", "38.66072", "32.92437", "Europe/Istanbul"),("318603", "Çifteler", "", "TR", "792", "", "26", "", "", "39.38306", "31.03917", "Europe/Istanbul"),("318668", "Ceylanpınar", "", "TR", "792", "", "63", "", "", "36.84722", "40.05", "Europe/Istanbul"),("318675", "Ceyhan", "Джейхан", "TR", "792", "", "81", "", "", "37.02472", "35.8175", "Europe/Istanbul"),("318755", "Çeşme", "Чешме", "TR", "792", "", "35", "", "", "38.32614", "26.30574", "Europe/Istanbul"),("318766", "Çermik", "", "TR", "792", "", "21", "", "", "38.13538", "39.445", "Europe/Istanbul"),("318904", "Çelikhan", "", "TR", "792", "", "02", "", "", "38.0256", "38.23665", "Europe/Istanbul"),("319069", "Çayıralan", "", "TR", "792", "", "66", "", "", "39.30278", "35.64389", "Europe/Istanbul"),("319104", "Çay", "Кей", "TR", "792", "", "03", "", "", "38.59167", "31.02861", "Europe/Istanbul"),("319118", "Çavuşlu", "", "TR", "792", "", "72", "", "", "37.50179", "41.24877", "Europe/Istanbul"),("320004", "Çağlayancerit", "", "TR", "792", "", "46", "", "", "37.74523", "37.28618", "Europe/Istanbul"),("320177", "Nikfer", "", "TR", "792", "TR", "20", "7732364", "", "37.40542", "29.13727", "Europe/Istanbul"),("320369", "Burhaniye", "", "TR", "792", "", "10", "", "", "39.50041", "26.97269", "Europe/Istanbul"),("320374", "Buharkent", "", "TR", "792", "", "09", "", "", "37.96397", "28.7427", "Europe/Istanbul"),("320392", "Burdur", "Бурдур", "TR", "792", "", "15", "", "", "37.72028", "30.29083", "Europe/Istanbul"),("320406", "Bünyan", "", "TR", "792", "", "38", "", "", "38.8463", "35.86033", "Europe/Istanbul"),("320437", "Buldan", "", "TR", "792", "", "20", "", "", "38.045", "28.83056", "Europe/Istanbul"),("320448", "Bulanık", "", "TR", "792", "", "49", "", "", "39.08656", "42.27158", "Europe/Istanbul"),("320533", "Bucak", "Буджак", "TR", "792", "", "15", "", "", "37.45917", "30.595", "Europe/Istanbul"),("320552", "Bozyazı", "", "TR", "792", "", "32", "", "", "36.1082", "32.96113", "Europe/Istanbul"),("320557", "Bozüyük", "", "TR", "792", "", "11", "", "", "39.90778", "30.03667", "Europe/Istanbul"),("320581", "Bozova", "Бозова", "TR", "792", "", "63", "", "", "37.3625", "38.52667", "Europe/Istanbul"),("320621", "Bozkır", "", "TR", "792", "", "71", "", "", "37.18963", "32.24736", "Europe/Istanbul"),("320647", "Bozdoğan", "", "TR", "792", "", "09", "", "", "37.67134", "28.31395", "Europe/Istanbul"),("320871", "Bor", "Бор", "TR", "792", "", "73", "", "", "37.89056", "34.55889", "Europe/Istanbul"),("320879", "Bolvadin", "", "TR", "792", "", "03", "", "", "38.71111", "31.04861", "Europe/Istanbul"),("320995", "Bodrum", "Бодрум", "TR", "792", "", "48", "7733242", "", "37.03833", "27.42917", "Europe/Istanbul"),("321025", "Bitlis", "Битлис", "TR", "792", "", "13", "", "", "38.40115", "42.10784", "Europe/Istanbul"),("321031", "Bismil", "", "TR", "792", "", "21", "", "", "37.84514", "40.65931", "Europe/Istanbul"),("321062", "Birecik", "Биреджик", "TR", "792", "", "63", "", "", "37.02577", "37.97841", "Europe/Istanbul"),("321082", "Bingöl", "Бингол", "TR", "792", "", "12", "", "", "38.88472", "40.49389", "Europe/Istanbul"),("321136", "Bigadiç", "", "TR", "792", "", "10", "", "", "39.3925", "28.13111", "Europe/Istanbul"),("321184", "Beytüşşebap", "", "TR", "792", "", "80", "", "", "37.56318", "43.16583", "Europe/Istanbul"),("321191", "Beyşehir", "Бейшехир", "TR", "792", "", "71", "", "", "37.67735", "31.72458", "Europe/Istanbul"),("321219", "Beylikova", "", "TR", "792", "", "26", "", "", "39.68694", "31.20556", "Europe/Istanbul"),("321337", "Besni", "Бесни", "TR", "792", "", "02", "", "", "37.69278", "37.86111", "Europe/Istanbul"),("321360", "Beşiri", "", "TR", "792", "", "76", "", "", "37.91573", "41.2865", "Europe/Istanbul"),("321426", "Bergama", "Пергам", "TR", "792", "", "35", "7732716", "", "39.12074", "27.18052", "Europe/Istanbul"),("321572", "Belen", "Белен", "TR", "792", "", "31", "", "", "36.48866", "36.19489", "Europe/Istanbul"),("321580", "Belek", "Белек", "TR", "792", "TR", "07", "", "", "36.86278", "31.05556", "Europe/Istanbul"),("321750", "Baykan", "", "TR", "792", "", "74", "", "", "38.15754", "41.7733", "Europe/Istanbul"),("321786", "Bayındır", "Байиндыр", "TR", "792", "", "35", "", "", "38.21741", "27.64744", "Europe/Istanbul"),("321836", "Batman", "Батман", "TR", "792", "", "76", "", "", "37.88738", "41.13221", "Europe/Istanbul"),("321887", "Başmakçı", "", "TR", "792", "", "03", "", "", "37.89722", "30.01167", "Europe/Istanbul"),("321929", "Baskil", "", "TR", "792", "", "23", "", "", "38.56866", "38.81634", "Europe/Istanbul"),("321940", "Başkale", "", "TR", "792", "", "65", "", "", "38.04526", "44.01718", "Europe/Istanbul"),("322051", "Banaz", "", "TR", "792", "", "64", "", "", "38.73707", "29.75194", "Europe/Istanbul"),("322165", "Balıkesir", "Балыкесир", "TR", "792", "", "10", "", "", "39.64917", "27.88611", "Europe/Istanbul"),("322250", "Baklan", "", "TR", "792", "", "20", "", "", "37.97694", "29.60861", "Europe/Istanbul"),("322391", "Bahçe", "", "TR", "792", "", "81", "", "", "37.19724", "36.57658", "Europe/Istanbul"),("322673", "Ayvalık", "Айвалык", "TR", "792", "", "10", "", "", "39.31905", "26.6954", "Europe/Istanbul"),("322692", "Ayvacık", "", "TR", "792", "", "17", "", "", "39.60111", "26.40472", "Europe/Istanbul"),("322817", "İbradı", "", "TR", "792", "", "07", "", "", "37.09694", "31.59917", "Europe/Istanbul"),("322826", "Aydıncık", "", "TR", "792", "", "32", "", "", "36.1437", "33.32016", "Europe/Istanbul"),("322830", "Aydın", "Айдын", "TR", "792", "", "09", "", "", "37.84501", "27.83963", "Europe/Istanbul"),("322887", "Avsallar", "", "TR", "792", "", "07", "7732185", "", "36.62448", "31.76941", "Europe/Istanbul"),("322965", "Avanos", "", "TR", "792", "", "50", "", "", "38.715", "34.84667", "Europe/Istanbul"),("323014", "Atça", "", "TR", "792", "", "09", "8632398", "", "37.88859", "28.21528", "Europe/Istanbul"),("323039", "Atabey", "", "TR", "792", "", "33", "", "", "37.95083", "30.63861", "Europe/Istanbul"),("323094", "Aşkale", "", "TR", "792", "", "25", "", "", "39.92083", "40.695", "Europe/Istanbul"),("323653", "Arıcak", "", "TR", "792", "", "23", "", "", "38.5634", "40.1248", "Europe/Istanbul"),("323721", "Arapgir", "", "TR", "792", "", "44", "", "", "39.04117", "38.49516", "Europe/Istanbul"),("323750", "Araban", "", "TR", "792", "", "83", "", "", "37.42667", "37.689", "Europe/Istanbul"),("323777", "Antalya", "Анталия", "TR", "792", "", "07", "", "", "36.90812", "30.69556", "Europe/Istanbul"),("323779", "Antakya", "Антиохия", "TR", "792", "", "31", "438417", "", "36.20655", "36.15722", "Europe/Istanbul"),("323786", "Ankara", "Анкара", "TR", "792", "", "68", "", "", "39.91987", "32.85427", "Europe/Istanbul"),("323797", "Andırın", "", "TR", "792", "", "46", "", "", "37.57757", "36.35492", "Europe/Istanbul"),("323828", "Anamur", "Анамур", "TR", "792", "", "32", "", "", "36.07508", "32.83691", "Europe/Istanbul"),("323854", "Ambar", "", "TR", "792", "", "21", "", "", "37.85305", "40.52798", "Europe/Istanbul"),("323886", "Altınyayla", "", "TR", "792", "", "58", "", "", "39.27249", "36.75098", "Europe/Istanbul"),("323911", "Altınoluk", "", "TR", "792", "", "10", "", "", "39.57944", "26.73722", "Europe/Istanbul"),("323930", "Altınekin", "", "TR", "792", "", "71", "", "", "38.30778", "32.86861", "Europe/Istanbul"),("323963", "Alpu", "", "TR", "792", "", "26", "", "", "39.76903", "30.9606", "Europe/Istanbul"),("324106", "Aliağa", "Алиага", "TR", "792", "", "35", "", "", "38.79975", "26.97203", "Europe/Istanbul"),("324172", "Alaşehir", "Алашехир", "TR", "792", "", "45", "", "", "38.35083", "28.51718", "Europe/Istanbul"),("324190", "Alanya", "Аланья", "TR", "792", "", "07", "7732185", "", "36.54375", "31.99982", "Europe/Istanbul"),("324486", "Akseki", "", "TR", "792", "", "07", "", "", "37.04861", "31.79", "Europe/Istanbul"),("324490", "Akşehir", "", "TR", "792", "", "71", "", "", "38.3575", "31.41639", "Europe/Istanbul"),("324496", "Aksaray", "Аксарай", "TR", "792", "", "75", "", "", "38.37255", "34.02537", "Europe/Istanbul"),("324698", "Akhisar", "Акхисар", "TR", "792", "", "45", "", "", "38.91852", "27.84006", "Europe/Istanbul"),("324768", "Akdağmadeni", "", "TR", "792", "", "66", "", "", "39.66028", "35.88361", "Europe/Istanbul"),("324944", "Akçakale", "", "TR", "792", "", "63", "", "", "36.71111", "38.9475", "Europe/Istanbul"),("324953", "Akçadağ", "", "TR", "792", "", "44", "", "", "38.33899", "37.97021", "Europe/Istanbul"),("325028", "Akarsu", "", "TR", "792", "", "72", "", "", "37.22616", "41.05138", "Europe/Istanbul"),("325066", "Ahmetli", "", "TR", "792", "", "45", "", "", "38.5196", "27.93865", "Europe/Istanbul"),("325103", "Ahlat", "Ахлат", "TR", "792", "", "13", "", "", "38.7489", "42.48007", "Europe/Istanbul"),("325269", "Ağaçören", "", "TR", "792", "", "75", "", "", "38.87484", "33.91674", "Europe/Istanbul"),("325303", "Afyonkarahisar", "Афьонкарахисар", "TR", "792", "", "03", "", "", "38.75667", "30.54333", "Europe/Istanbul"),("325304", "Afşin", "", "TR", "792", "", "46", "", "", "38.24769", "36.91399", "Europe/Istanbul"),("325330", "Adıyaman", "Адыяман", "TR", "792", "", "02", "", "", "37.76441", "38.27629", "Europe/Istanbul"),("325336", "Adilcevaz", "Адилджеваз", "TR", "792", "", "13", "", "", "38.79911", "42.73159", "Europe/Istanbul"),("325363", "Adana", "Адана", "TR", "792", "", "81", "", "", "37.00167", "35.32889", "Europe/Istanbul"),("325420", "Acırlı", "", "TR", "792", "", "72", "", "", "37.45549", "41.29499", "Europe/Istanbul"),("325426", "Acıpayam", "", "TR", "792", "", "20", "", "", "37.42385", "29.34941", "Europe/Istanbul"),("325449", "Dobada", "", "TR", "792", "", "50", "", "", "38.55028", "34.50917", "Europe/Istanbul"),("325474", "Acarlar", "", "TR", "792", "TR", "09", "", "", "37.82444", "27.74667", "Europe/Istanbul"),("415534", "Nurdağı", "", "TR", "792", "", "83", "", "", "37.16821", "36.73623", "Europe/Istanbul"),("436507", "Mahmutlar", "", "TR", "792", "TR", "31", "", "", "36.949", "36.19231", "Europe/Istanbul"),("438056", "Kastal", "", "TR", "792", "", "31", "", "", "36.2476", "36.2409", "Europe/Istanbul"),("438119", "Dursunlu", "", "TR", "792", "", "31", "", "", "36.16736", "36.15788", "Europe/Istanbul"),("438400", "Denizciler", "", "TR", "792", "", "31", "", "", "36.6411", "36.21418", "Europe/Istanbul"),("442301", "Batikent", "", "TR", "792", "", "68", "", "", "39.96833", "32.73083", "Europe/Istanbul"),("447025", "Türkler", "", "TR", "792", "", "07", "7732185", "", "36.60198", "31.82067", "Europe/Istanbul"),("447049", "Başyayla", "", "TR", "792", "", "78", "", "", "36.75337", "32.68018", "Europe/Istanbul"),("447273", "Dalaman", "", "TR", "792", "", "48", "", "", "36.76591", "28.8028", "Europe/Istanbul"),("737022", "Zonguldak", "Зонгулдак", "TR", "792", "", "85", "", "", "41.45139", "31.79305", "Europe/Istanbul"),("737054", "Zile", "Зил", "TR", "792", "", "60", "", "", "40.30306", "35.88639", "Europe/Istanbul"),("737071", "Zeytinburnu", "", "TR", "792", "", "34", "", "", "40.99441", "28.90417", "Europe/Istanbul"),("737119", "Yuvacık", "", "TR", "792", "", "41", "", "", "40.68815", "29.96738", "Europe/Istanbul"),("737140", "Yusufeli", "", "TR", "792", "", "08", "", "", "40.82042", "41.53743", "Europe/Istanbul"),("737421", "Yomra", "", "TR", "792", "", "61", "", "", "40.95326", "39.85546", "Europe/Istanbul"),("737529", "Yeşilyurt", "", "TR", "792", "", "60", "", "", "40.32786", "36.35144", "Europe/Istanbul"),("737611", "Yenişehir", "", "TR", "792", "", "16", "", "", "40.26444", "29.65306", "Europe/Istanbul"),("737756", "Yeniçağa", "", "TR", "792", "", "14", "", "", "40.77115", "32.03375", "Europe/Istanbul"),("737961", "Körfez", "", "TR", "792", "", "41", "", "", "40.76704", "29.78275", "Europe/Istanbul"),("737980", "Yapraklı", "", "TR", "792", "", "82", "", "", "40.75785", "33.77819", "Europe/Istanbul"),("738025", "Yalova", "Ялова", "TR", "792", "", "92", "", "", "40.65501", "29.27693", "Europe/Istanbul"),("738064", "Yakuplu", "", "TR", "792", "", "34", "", "", "40.98894", "28.67582", "Europe/Istanbul"),("738085", "Yakakent", "", "TR", "792", "", "55", "", "", "41.6325", "35.52889", "Europe/Istanbul"),("738154", "Vize", "", "TR", "792", "", "39", "", "", "41.5725", "27.76583", "Europe/Istanbul"),("738167", "Vezirköprü", "Везиркепрю", "TR", "792", "", "55", "", "", "41.14361", "35.45472", "Europe/Istanbul"),("738183", "Velimeşe", "", "TR", "792", "", "59", "", "", "41.25361", "27.87833", "Europe/Istanbul"),("738228", "Vakfıkebir", "", "TR", "792", "", "61", "", "", "41.04583", "39.27639", "Europe/Istanbul"),("738251", "Uzunköprü", "Узункепрю", "TR", "792", "", "22", "", "", "41.26597", "26.6885", "Europe/Istanbul"),("738276", "Uzundere", "", "TR", "792", "", "25", "", "", "40.53218", "41.53832", "Europe/Istanbul"),("738329", "Üsküdar", "Ускюдар", "TR", "792", "TR", "34", "", "", "41.02252", "29.02369", "Europe/Istanbul"),("738349", "Ünye", "Унье", "TR", "792", "", "52", "", "", "41.13139", "37.2825", "Europe/Istanbul"),("738377", "Umraniye", "", "TR", "792", "", "34", "", "", "41.01643", "29.12476", "Europe/Istanbul"),("738444", "Ulubey", "", "TR", "792", "", "52", "", "", "40.86863", "37.75405", "Europe/Istanbul"),("738468", "Uğurludağ", "", "TR", "792", "", "19", "", "", "40.44631", "34.45259", "Europe/Istanbul"),("738614", "Türkeli", "", "TR", "792", "", "57", "", "", "41.94764", "34.33861", "Europe/Istanbul"),("738618", "Turhal", "Турхал", "TR", "792", "", "60", "", "", "40.3875", "36.08111", "Europe/Istanbul"),("738648", "Trabzon", "Трабзон", "TR", "792", "", "61", "", "", "41.005", "39.72694", "Europe/Istanbul"),("738662", "Tosya", "Тося", "TR", "792", "", "37", "", "", "41.01545", "34.04013", "Europe/Istanbul"),("738674", "Tortum", "", "TR", "792", "", "25", "", "", "40.28892", "41.54096", "Europe/Istanbul"),("738715", "Tonya", "", "TR", "792", "", "61", "", "", "40.88402", "39.28486", "Europe/Istanbul"),("738743", "Tokat", "Токат", "TR", "792", "", "60", "", "", "40.31389", "36.55444", "Europe/Istanbul"),("738753", "Tirebolu", "Тиреболу", "TR", "792", "", "28", "", "", "41.00694", "38.81389", "Europe/Istanbul"),("738803", "Terme", "Терме", "TR", "792", "", "55", "", "", "41.20917", "36.97389", "Europe/Istanbul"),("738858", "Tepecik", "", "TR", "792", "", "34", "", "", "41.02931", "28.54978", "Europe/Istanbul"),("738907", "Tekkeköy", "Теккекей", "TR", "792", "", "55", "", "", "41.21167", "36.46", "Europe/Istanbul"),("738927", "Tekirdağ", "Текирдаг", "TR", "792", "", "59", "", "", "40.97801", "27.50852", "Europe/Istanbul"),("739015", "Taşova", "Ташова", "TR", "792", "", "05", "", "", "40.75972", "36.3225", "Europe/Istanbul"),("739061", "Taşköprü", "", "TR", "792", "", "37", "", "", "41.5098", "34.21414", "Europe/Istanbul"),("739209", "Suşehri", "Сушехри", "TR", "792", "", "58", "", "", "40.16005", "38.08413", "Europe/Istanbul"),("739215", "Sürmene", "Сюрмене", "TR", "792", "", "61", "", "", "40.90588", "40.12792", "Europe/Istanbul"),("739236", "Sungurlu", "Сунгурлу", "TR", "792", "", "19", "", "", "40.1675", "34.37389", "Europe/Istanbul"),("739251", "Suluova", "", "TR", "792", "", "05", "", "", "40.83129", "35.64788", "Europe/Istanbul"),("739318", "Sulakyurt", "", "TR", "792", "", "79", "", "", "40.15733", "33.716", "Europe/Istanbul"),("739425", "Söğütlü", "", "TR", "792", "", "54", "", "", "40.9059", "30.47448", "Europe/Istanbul"),("739549", "Şişli", "", "TR", "792", "", "34", "", "", "41.06046", "28.98717", "Europe/Istanbul"),("739574", "Şiran", "", "TR", "792", "", "69", "", "", "40.19064", "39.11747", "Europe/Istanbul"),("739600", "Sinop", "Синоп", "TR", "792", "", "57", "", "", "42.02683", "35.16253", "Europe/Istanbul"),("739634", "Silivri", "", "TR", "792", "", "34", "", "", "41.07393", "28.24644", "Europe/Istanbul"),("739636", "Şile", "", "TR", "792", "", "34", "", "", "41.1754", "29.61333", "Europe/Istanbul"),("739838", "Selimpaşa", "", "TR", "792", "", "34", "", "", "41.05448", "28.36678", "Europe/Istanbul"),("739914", "Şebin Karahisar", "Шебинкарахисар", "TR", "792", "", "28", "", "", "40.28833", "38.42361", "Europe/Istanbul"),("739950", "Şavşat", "", "TR", "792", "", "08", "", "", "41.24027", "42.36109", "Europe/Istanbul"),("740088", "Sarıkamış", "Сарыкамыш", "TR", "792", "", "84", "", "", "40.32769", "42.58705", "Europe/Istanbul"),("740230", "Sapanca", "", "TR", "792", "", "54", "7732953", "", "40.69141", "30.26738", "Europe/Istanbul"),("740264", "Samsun", "Самсун", "TR", "792", "", "55", "", "", "41.28667", "36.33", "Europe/Istanbul"),("740303", "Şalpazarı", "", "TR", "792", "", "61", "", "", "40.93826", "39.19006", "Europe/Istanbul"),("740430", "Safranbolu", "Сафранболу", "TR", "792", "", "89", "", "", "41.25083", "32.69417", "Europe/Istanbul"),("740462", "Şabanözü", "", "TR", "792", "", "82", "", "", "40.48249", "33.28352", "Europe/Istanbul"),("740483", "Rize", "Ризе", "TR", "792", "", "53", "", "", "41.02083", "40.52194", "Europe/Istanbul"),("740561", "Piraziz", "", "TR", "792", "", "28", "", "", "40.92244", "38.12458", "Europe/Istanbul"),("740570", "Pınarhisar", "", "TR", "792", "", "39", "", "", "41.62417", "27.52", "Europe/Istanbul"),("740605", "Perşembe", "", "TR", "792", "", "52", "", "", "41.06556", "37.77139", "Europe/Istanbul"),("740659", "Pazaryolu", "", "TR", "792", "", "25", "", "", "40.41142", "40.7678", "Europe/Istanbul"),("740677", "Pazar", "", "TR", "792", "", "60", "", "", "40.27652", "36.28347", "Europe/Istanbul"),("740729", "Pamukova", "", "TR", "792", "", "54", "", "", "40.5081", "30.16732", "Europe/Istanbul"),("740881", "Osmaneli", "", "TR", "792", "", "11", "", "", "40.35722", "30.01417", "Europe/Istanbul"),("740883", "Osmancık", "", "TR", "792", "", "19", "", "", "40.97818", "34.8047", "Europe/Istanbul"),("741002", "Orta", "", "TR", "792", "", "82", "", "", "40.6242", "33.10928", "Europe/Istanbul"),("741045", "Orhangazi", "", "TR", "792", "", "16", "", "", "40.48917", "29.30889", "Europe/Istanbul"),("741100", "Ordu", "Орду", "TR", "792", "", "52", "", "", "40.97782", "37.89047", "Europe/Istanbul"),("741160", "Oltu", "Олту", "TR", "792", "", "25", "", "", "40.53945", "41.98722", "Europe/Istanbul"),("741240", "Of", "Оф", "TR", "792", "", "61", "", "", "40.94055", "40.25918", "Europe/Istanbul"),("741304", "Niksar", "Никсар", "TR", "792", "", "60", "", "", "40.59167", "36.95167", "Europe/Istanbul"),("741330", "Narman", "", "TR", "792", "", "25", "", "", "40.34449", "41.86088", "Europe/Istanbul"),("741347", "Nallıhan", "", "TR", "792", "", "68", "", "", "40.18593", "31.35179", "Europe/Istanbul"),("741385", "Mustafakemalpaşa", "", "TR", "792", "", "16", "", "", "40.03815", "28.40866", "Europe/Istanbul"),("741484", "Mudurnu", "", "TR", "792", "", "14", "", "", "40.473", "31.20755", "Europe/Istanbul"),("741487", "Mudanya", "Муданьи", "TR", "792", "", "16", "7732334", "", "40.37528", "28.88222", "Europe/Istanbul"),("741529", "Mimarsinan", "Мимарсинан", "TR", "792", "", "34", "", "", "41.0179", "28.56176", "Europe/Istanbul"),("741538", "Mihalgazi", "", "TR", "792", "", "26", "", "", "40.02621", "30.57707", "Europe/Istanbul"),("741570", "Mesudiye", "", "TR", "792", "", "52", "", "", "40.45446", "37.77353", "Europe/Istanbul"),("741609", "Merzifon", "Мерзифон", "TR", "792", "", "05", "", "", "40.87333", "35.46306", "Europe/Istanbul"),("741692", "Mecitözü", "", "TR", "792", "", "19", "", "", "40.52", "35.29528", "Europe/Istanbul"),("741725", "Marmara Ereğlisi", "", "TR", "792", "", "59", "", "", "40.97003", "27.95528", "Europe/Istanbul"),("741727", "Marmaracık", "", "TR", "792", "", "59", "", "", "41.20667", "27.75444", "Europe/Istanbul"),("741737", "Manyas", "", "TR", "792", "", "10", "", "", "40.04639", "27.97", "Europe/Istanbul"),("741763", "Maltepe", "", "TR", "792", "", "34", "", "", "40.93567", "29.15507", "Europe/Istanbul"),("741771", "Malkara", "Малкара", "TR", "792", "", "59", "", "", "40.89", "26.90111", "Europe/Istanbul"),("741850", "Maçka", "", "TR", "792", "", "61", "", "", "40.81072", "39.60465", "Europe/Istanbul"),("741855", "Lüleburgaz", "", "TR", "792", "", "39", "", "", "41.40385", "27.35918", "Europe/Istanbul"),("741878", "Lapseki", "", "TR", "792", "", "17", "", "", "40.34417", "26.68556", "Europe/Istanbul"),("741892", "Ladik", "", "TR", "792", "", "55", "", "", "40.91056", "35.89194", "Europe/Istanbul"),("742164", "Kurşunlu", "", "TR", "792", "", "82", "", "", "40.84101", "33.26028", "Europe/Istanbul"),("742238", "Kumru", "Кумру", "TR", "792", "", "52", "", "", "40.87444", "37.26389", "Europe/Istanbul"),("742266", "Kumburgaz", "", "TR", "792", "", "34", "", "", "41.02108", "28.48033", "Europe/Istanbul"),("742292", "Kullar", "", "TR", "792", "", "41", "", "", "40.72419", "29.98943", "Europe/Istanbul"),("742499", "Koyulhisar", "", "TR", "792", "", "58", "", "", "40.30184", "37.82336", "Europe/Istanbul"),("742588", "Köseköy", "", "TR", "792", "", "41", "", "", "40.74012", "30.00556", "Europe/Istanbul"),("742606", "Köse", "", "TR", "792", "", "69", "", "", "40.20692", "39.64626", "Europe/Istanbul"),("742657", "Korgun", "", "TR", "792", "", "82", "", "", "40.73479", "33.51844", "Europe/Istanbul"),("742658", "Korgan", "Корган", "TR", "792", "", "52", "", "", "40.82472", "37.34667", "Europe/Istanbul"),("742686", "Köprübaşı", "", "TR", "792", "", "61", "", "", "40.80692", "40.11439", "Europe/Istanbul"),("742902", "Kocaali", "", "TR", "792", "", "54", "", "", "41.05336", "30.85278", "Europe/Istanbul"),("743051", "Kızılcahamam", "", "TR", "792", "", "68", "", "", "40.46972", "32.65056", "Europe/Istanbul"),("743166", "Kırklareli", "Кыркларели", "TR", "792", "", "39", "", "", "41.73508", "27.22521", "Europe/Istanbul"),("743404", "Kestel", "", "TR", "792", "", "16", "", "", "40.19828", "29.21237", "Europe/Istanbul"),("743438", "Keşap", "", "TR", "792", "", "28", "", "", "40.91032", "38.5013", "Europe/Istanbul"),("743439", "Keşan", "Кешан", "TR", "792", "", "22", "", "", "40.85583", "26.63028", "Europe/Istanbul"),("743537", "Kelkit", "Келькит", "TR", "792", "", "69", "", "", "40.12682", "39.43424", "Europe/Istanbul"),("743615", "Kazan", "", "TR", "792", "", "68", "", "", "40.23167", "32.68389", "Europe/Istanbul"),("743633", "Kaynarca", "", "TR", "792", "", "54", "", "", "41.03083", "30.3075", "Europe/Istanbul"),("743818", "Kavaklı", "Каваклы", "TR", "792", "", "34", "", "", "41.09258", "28.33172", "Europe/Istanbul"),("743851", "Kavak", "", "TR", "792", "", "55", "", "", "41.07833", "36.0425", "Europe/Istanbul"),("743882", "Kastamonu", "Кастамону", "TR", "792", "", "37", "7732736", "", "41.37805", "33.77528", "Europe/Istanbul"),("743952", "Kars", "Карс", "TR", "792", "", "84", "", "", "40.59825", "43.08548", "Europe/Istanbul"),("744093", "Karasu", "Карасу", "TR", "792", "", "54", "", "", "41.07096", "30.78543", "Europe/Istanbul"),("744168", "Karamürsel", "", "TR", "792", "", "41", "", "", "40.69144", "29.61568", "Europe/Istanbul"),("744537", "Karacabey", "Караджабей", "TR", "792", "", "16", "", "", "40.21323", "28.3612", "Europe/Istanbul"),("744562", "Karabük", "Карабюк", "TR", "792", "", "89", "", "", "41.20488", "32.62768", "Europe/Istanbul"),("744716", "Kandıra", "", "TR", "792", "", "41", "", "", "41.07", "30.15262", "Europe/Istanbul"),("744767", "Kalkandere", "", "TR", "792", "", "53", "", "", "40.92046", "40.43692", "Europe/Istanbul"),("744814", "Kalecik", "", "TR", "792", "", "68", "", "", "40.09722", "33.40833", "Europe/Istanbul"),("744873", "Kağızman", "Кагызман", "TR", "792", "", "84", "", "", "40.15669", "43.13424", "Europe/Istanbul"),("744958", "Kabataş", "", "TR", "792", "", "52", "", "", "40.75", "37.45", "Europe/Istanbul"),("745026", "İznik", "Изник", "TR", "792", "", "16", "", "", "40.42861", "29.72111", "Europe/Istanbul"),("745028", "İzmit", "Измит", "TR", "792", "", "41", "", "", "40.76694", "29.91694", "Europe/Istanbul"),("745030", "İyidere", "", "TR", "792", "", "53", "", "", "41.01192", "40.36185", "Europe/Istanbul"),("745044", "İstanbul", "Стамбул", "TR", "792", "", "34", "", "", "41.01384", "28.94966", "Europe/Istanbul"),("745047", "İspir", "", "TR", "792", "", "25", "", "", "40.47981", "40.99373", "Europe/Istanbul"),("745076", "İskilip", "", "TR", "792", "", "19", "", "", "40.73528", "34.47389", "Europe/Istanbul"),("745148", "İpsala", "", "TR", "792", "", "22", "", "", "40.92115", "26.38273", "Europe/Istanbul"),("745169", "İnegol", "", "TR", "792", "", "16", "7732332", "", "40.07806", "29.51333", "Europe/Istanbul"),("745175", "İnebolu", "", "TR", "792", "", "37", "", "", "41.97472", "33.76083", "Europe/Istanbul"),("745260", "Gökçeada", "", "TR", "792", "", "17", "7910945", "", "40.20107", "25.90902", "Europe/Istanbul"),("745344", "Ilgaz", "", "TR", "792", "", "82", "", "", "40.92511", "33.62586", "Europe/Istanbul"),("745364", "İkizce", "", "TR", "792", "", "52", "", "", "41.05833", "37.08028", "Europe/Istanbul"),("745383", "İhsaniye", "", "TR", "792", "", "41", "", "", "40.69087", "29.83472", "Europe/Istanbul"),("745527", "Horasan", "Хорасан", "TR", "792", "", "25", "", "", "40.03885", "42.16366", "Europe/Istanbul"),("745530", "Hopa", "Хопа", "TR", "792", "", "08", "", "", "41.39046", "41.41966", "Europe/Istanbul"),("745664", "Hendek", "", "TR", "792", "", "54", "", "", "40.79944", "30.74806", "Europe/Istanbul"),("745693", "Hayrat", "", "TR", "792", "", "61", "", "", "40.8853", "40.36495", "Europe/Istanbul"),("745697", "Hayrabolu", "", "TR", "792", "", "59", "", "", "41.21311", "27.10688", "Europe/Istanbul"),("745714", "Havza", "Хавза", "TR", "792", "", "55", "", "", "40.97056", "35.66222", "Europe/Istanbul"),("745719", "Havsa", "", "TR", "792", "", "22", "", "", "41.54898", "26.82207", "Europe/Istanbul"),("745903", "Hanak", "", "TR", "792", "", "86", "", "", "41.23344", "42.84037", "Europe/Istanbul"),("746232", "Gürsu", "", "TR", "792", "", "16", "", "", "40.21876", "29.19487", "Europe/Istanbul"),("746234", "Gürpınar", "Гюрпынар", "TR", "792", "", "34", "", "", "40.99256", "28.61428", "Europe/Istanbul"),("746252", "Gürgentepe", "", "TR", "792", "", "52", "", "", "40.78567", "37.58969", "Europe/Istanbul"),("746308", "Güneysu", "", "TR", "792", "", "53", "", "", "40.9813", "40.60465", "Europe/Istanbul"),("746425", "Gumushkhane", "Гюмюшане", "TR", "792", "", "69", "", "", "40.46001", "39.47176", "Europe/Istanbul"),("746426", "Gümüşhacıköy", "", "TR", "792", "", "05", "", "", "40.87306", "35.21472", "Europe/Istanbul"),("746497", "Güdül", "", "TR", "792", "", "68", "", "", "40.21051", "32.24552", "Europe/Istanbul"),("746546", "Göynük", "", "TR", "792", "", "14", "", "", "40.40028", "30.78833", "Europe/Istanbul"),("746565", "Görele", "Гереле", "TR", "792", "", "28", "", "", "41.03083", "39.00306", "Europe/Istanbul"),("746574", "Gönen", "Гонен", "TR", "792", "", "10", "", "", "40.1049", "27.65399", "Europe/Istanbul"),("746602", "Gölpazarı", "", "TR", "792", "", "11", "", "", "40.28472", "30.31722", "Europe/Istanbul"),("746643", "Merdinik", "", "TR", "792", "", "86", "", "", "40.78746", "42.60603", "Europe/Istanbul"),("746666", "Gölcük", "", "TR", "792", "", "41", "", "", "40.70323", "29.87216", "Europe/Istanbul"),("746821", "Gökçebey", "", "TR", "792", "", "85", "", "", "41.30583", "32.14234", "Europe/Istanbul"),("746881", "Giresun", "Гиресун", "TR", "792", "", "28", "", "", "40.91698", "38.38741", "Europe/Istanbul"),("746898", "Geyve", "", "TR", "792", "", "54", "", "", "40.5075", "30.2925", "Europe/Istanbul"),("746913", "Gerze", "", "TR", "792", "", "57", "", "", "41.80361", "35.20111", "Europe/Istanbul"),("746940", "Gerede", "Гереде", "TR", "792", "", "14", "", "", "40.80083", "32.19694", "Europe/Istanbul"),("746958", "Gemlik", "Гемлик", "TR", "792", "", "16", "", "", "40.43094", "29.15969", "Europe/Istanbul"),("746983", "Gelibolu", "Гелиболу", "TR", "792", "", "17", "", "", "40.41028", "26.67083", "Europe/Istanbul"),("747014", "Gebze", "Гебзе", "TR", "792", "", "41", "", "", "40.80276", "29.43068", "Europe/Istanbul"),("747135", "Ferizli", "", "TR", "792", "", "54", "", "", "40.94082", "30.48583", "Europe/Istanbul"),("747155", "Fatsa", "Фатса", "TR", "792", "", "52", "", "", "41.02778", "37.50139", "Europe/Istanbul"),("747191", "Eynesil", "", "TR", "792", "", "28", "", "", "41.06436", "39.14274", "Europe/Istanbul"),("747263", "Gözyeri", "", "TR", "792", "", "89", "", "", "40.86596", "32.54167", "Europe/Istanbul"),("747323", "Esenyurt", "", "TR", "792", "", "34", "", "", "41.02697", "28.67732", "Europe/Istanbul"),("747340", "Esenler", "", "TR", "792", "TR", "34", "", "", "41.0435", "28.87619", "Europe/Istanbul"),("747471", "Ereğli", "Эрегли", "TR", "792", "", "85", "", "", "41.28261", "31.41806", "Europe/Istanbul"),("747482", "Erdek", "", "TR", "792", "", "10", "", "", "40.3996", "27.79348", "Europe/Istanbul");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("747489", "Erbaa", "Эрба", "TR", "792", "", "60", "", "", "40.66889", "36.5675", "Europe/Istanbul"),("747538", "Eminönü", "Эминёню", "TR", "792", "TR", "34", "", "", "41.01766", "28.97438", "Europe/Istanbul"),("747618", "Eldivan", "", "TR", "792", "", "82", "", "", "40.52975", "33.49903", "Europe/Istanbul"),("747712", "Edirne", "Эдирне", "TR", "792", "", "22", "", "", "41.67719", "26.55597", "Europe/Istanbul"),("747728", "Eceabat", "", "TR", "792", "", "17", "", "", "40.18416", "26.3574", "Europe/Istanbul"),("747751", "Düzköy", "", "TR", "792", "", "61", "", "", "40.87461", "39.41536", "Europe/Istanbul"),("747764", "Düzce", "", "TR", "792", "", "93", "", "", "40.83889", "31.16389", "Europe/Istanbul"),("747826", "Durağan", "", "TR", "792", "", "57", "", "", "41.41583", "35.05444", "Europe/Istanbul"),("748166", "Devrekani", "", "TR", "792", "", "37", "", "", "41.60303", "33.83922", "Europe/Istanbul"),("748167", "Devrek", "", "TR", "792", "", "85", "", "", "41.21917", "31.95583", "Europe/Istanbul"),("748200", "Dernekpazarı", "", "TR", "792", "", "61", "", "", "40.79658", "40.2446", "Europe/Istanbul"),("748240", "Dereli", "", "TR", "792", "", "28", "", "", "40.7389", "38.44337", "Europe/Istanbul"),("748378", "Demirtaş", "", "TR", "792", "", "16", "", "", "40.27194", "29.09833", "Europe/Istanbul"),("748761", "Daday", "", "TR", "792", "", "37", "", "", "41.47866", "33.46667", "Europe/Istanbul"),("748870", "Çubuk", "", "TR", "792", "", "68", "", "", "40.23861", "33.03222", "Europe/Istanbul"),("748879", "Çorum", "Чорум", "TR", "792", "", "19", "", "", "40.54889", "34.95333", "Europe/Istanbul"),("748893", "Çorlu", "Чорлу", "TR", "792", "", "59", "", "", "41.15917", "27.8", "Europe/Istanbul"),("749075", "Çınarcık", "", "TR", "792", "", "92", "", "", "40.64538", "29.1245", "Europe/Istanbul"),("749163", "Çiftlikköy", "", "TR", "792", "", "92", "", "", "40.66028", "29.32361", "Europe/Istanbul"),("749274", "Çerkezköy", "", "TR", "792", "", "59", "", "", "41.28629", "27.99939", "Europe/Istanbul"),("749279", "Çerkeş", "", "TR", "792", "", "82", "", "", "40.81164", "32.89358", "Europe/Istanbul"),("749392", "Çekerek", "", "TR", "792", "", "66", "", "", "40.07306", "35.49472", "Europe/Istanbul"),("749456", "Çaykara", "", "TR", "792", "", "61", "", "", "40.74267", "40.23175", "Europe/Istanbul"),("749502", "Çayeli", "", "TR", "792", "", "53", "", "", "41.08609", "40.72213", "Europe/Istanbul"),("749508", "Çaycuma", "", "TR", "792", "", "85", "", "", "41.42639", "32.07556", "Europe/Istanbul"),("749644", "Çatalca", "", "TR", "792", "", "34", "", "", "41.14324", "28.46154", "Europe/Istanbul"),("749704", "Çarşamba", "Чаршамба", "TR", "792", "", "55", "", "", "41.19889", "36.72194", "Europe/Istanbul"),("749740", "Çanta", "", "TR", "792", "", "34", "", "", "41.07897", "28.08323", "Europe/Istanbul"),("749748", "Khanjarah", "Чанкыры", "TR", "792", "", "82", "", "", "40.59995", "33.6153", "Europe/Istanbul"),("749780", "Çanakkale", "Чанаккале", "TR", "792", "", "17", "", "", "40.15552", "26.41271", "Europe/Istanbul"),("749795", "Çan", "", "TR", "792", "", "17", "", "", "40.03328", "27.05236", "Europe/Istanbul"),("749843", "Çamlıdere", "", "TR", "792", "", "68", "", "", "40.48958", "32.47499", "Europe/Istanbul"),("749916", "Çamaş", "", "TR", "792", "", "52", "", "", "40.902", "37.52786", "Europe/Istanbul"),("750249", "Adalar", "", "TR", "792", "", "34", "", "", "40.86778", "29.13306", "Europe/Istanbul"),("750269", "Bursa", "Бурса", "TR", "792", "", "16", "7732338", "", "40.19559", "29.06013", "Europe/Istanbul"),("750317", "Bulancak", "Буланджак", "TR", "792", "", "28", "", "", "40.93805", "38.23148", "Europe/Istanbul"),("750392", "Bozkurt", "", "TR", "792", "", "37", "", "", "41.95769", "34.01087", "Europe/Istanbul"),("750446", "Boyalık", "", "TR", "792", "", "34", "", "", "41.26337", "28.63142", "Europe/Istanbul"),("750468", "Boyabat", "", "TR", "792", "", "57", "", "", "41.46889", "34.76667", "Europe/Istanbul"),("750496", "Borçka", "", "TR", "792", "", "08", "", "", "41.35792", "41.66579", "Europe/Istanbul"),("750516", "Bolu", "Болу", "TR", "792", "", "14", "", "", "40.73583", "31.60611", "Europe/Istanbul"),("750598", "Bilecik", "Биледжик", "TR", "792", "", "11", "", "", "40.14192", "29.97932", "Europe/Istanbul"),("750605", "Biga", "Биг", "TR", "792", "", "17", "", "", "40.22806", "27.24222", "Europe/Istanbul"),("750637", "Beypazarı", "", "TR", "792", "", "68", "", "", "40.1675", "31.92111", "Europe/Istanbul"),("750735", "Beşikdüzü", "", "TR", "792", "", "61", "", "", "41.05202", "39.23294", "Europe/Istanbul"),("750938", "Bayburt", "Байбурт", "TR", "792", "", "77", "", "", "40.25631", "40.22289", "Europe/Istanbul"),("751036", "Başçiftlik", "", "TR", "792", "", "60", "", "", "40.54694", "37.16917", "Europe/Istanbul"),("751057", "Bartın", "Бартин", "TR", "792", "", "87", "", "", "41.63583", "32.3375", "Europe/Istanbul"),("751077", "Bandırma", "Бандырма", "TR", "792", "", "10", "", "", "40.35222", "27.97667", "Europe/Istanbul"),("751277", "Bahçecik", "", "TR", "792", "", "41", "", "", "40.6681", "29.91478", "Europe/Istanbul"),("751324", "Bağcılar", "Багджылар", "TR", "792", "", "34", "", "", "41.03903", "28.85671", "Europe/Istanbul"),("751335", "Bafra", "Бафра", "TR", "792", "", "55", "", "", "41.56778", "35.90694", "Europe/Istanbul"),("751371", "Babaeski", "", "TR", "792", "", "39", "", "", "41.4325", "27.09306", "Europe/Istanbul"),("751427", "Ayvacık", "", "TR", "792", "", "55", "", "", "40.99111", "36.63139", "Europe/Istanbul"),("751475", "Aydıntepe", "", "TR", "792", "", "77", "", "", "40.38325", "40.14272", "Europe/Istanbul"),("751491", "Aydıncık", "", "TR", "792", "", "66", "", "", "40.12727", "35.28765", "Europe/Istanbul"),("751511", "Ayaş", "", "TR", "792", "", "68", "", "", "40.01933", "32.33221", "Europe/Istanbul"),("751516", "Ayancık", "", "TR", "792", "", "57", "", "", "41.94472", "34.58611", "Europe/Istanbul"),("751575", "Atkaracalar", "", "TR", "792", "", "82", "", "", "40.81593", "33.07556", "Europe/Istanbul"),("751817", "Artvin", "Артвин", "TR", "792", "", "08", "", "", "41.18161", "41.82172", "Europe/Istanbul"),("751818", "Artova", "", "TR", "792", "", "60", "", "", "40.11578", "36.3001", "Europe/Istanbul"),("751838", "Arsin", "", "TR", "792", "", "61", "", "", "40.95271", "39.92674", "Europe/Istanbul"),("751864", "Arpaçay", "", "TR", "792", "", "84", "", "", "40.84522", "43.32747", "Europe/Istanbul"),("751931", "Arhavi", "Мусазаде", "TR", "792", "", "08", "", "", "41.35121", "41.30456", "Europe/Istanbul"),("751949", "Ardeşen", "Ардешен", "TR", "792", "", "53", "", "", "41.19111", "40.9875", "Europe/Istanbul"),("751950", "Ardanuç", "", "TR", "792", "", "08", "", "", "41.12738", "42.06292", "Europe/Istanbul"),("751952", "Ardahan", "Ардаган", "TR", "792", "", "86", "", "", "41.10871", "42.70222", "Europe/Istanbul"),("751971", "Araklı", "Араклы", "TR", "792", "", "61", "", "", "40.93854", "40.05842", "Europe/Istanbul"),("751976", "Araç", "", "TR", "792", "", "37", "", "", "41.24222", "33.32767", "Europe/Istanbul"),("752015", "Amasya", "Амасья", "TR", "792", "", "05", "", "", "40.65333", "35.83306", "Europe/Istanbul"),("752016", "Amasra", "", "TR", "792", "", "87", "", "", "41.74633", "32.38633", "Europe/Istanbul"),("752083", "Almus", "", "TR", "792", "", "60", "", "", "40.37583", "36.90444", "Europe/Istanbul"),("752184", "Alaplı", "", "TR", "792", "", "85", "", "", "41.1814", "31.38514", "Europe/Istanbul"),("752278", "Alaca", "", "TR", "792", "", "19", "", "", "40.16833", "34.8425", "Europe/Istanbul"),("752284", "Akyurt", "", "TR", "792", "", "68", "", "", "40.13512", "33.08614", "Europe/Istanbul"),("752288", "Akyazı", "", "TR", "792", "", "54", "", "", "40.685", "30.62222", "Europe/Istanbul"),("752359", "Aksu", "", "TR", "792", "", "58", "", "", "40.08964", "38.03467", "Europe/Istanbul"),("752437", "Akkuş", "", "TR", "792", "", "52", "", "", "40.79306", "37.01639", "Europe/Istanbul"),("752584", "Akçakoca", "", "TR", "792", "", "93", "", "", "41.08663", "31.11623", "Europe/Istanbul"),("752627", "Akçaabat", "Акчаабад", "TR", "792", "", "61", "", "", "41.02121", "39.57146", "Europe/Istanbul"),("752850", "Adapazarı", "Сакарья", "TR", "792", "", "54", "", "", "40.78056", "30.40333", "Europe/Istanbul"),("831432", "Espiye", "", "TR", "792", "", "28", "", "", "40.94705", "38.70299", "Europe/Istanbul"),("857229", "Celâliye", "", "TR", "792", "", "34", "", "", "41.05188", "28.41867", "Europe/Istanbul"),("6354984", "merter keresteciler", "", "TR", "792", "", "34", "", "", "41.01295", "28.88593", "Europe/Istanbul"),("6354985", "güngören merter", "", "TR", "792", "", "34", "", "", "41.00711", "28.88795", "Europe/Istanbul"),("6559490", "Demre", "", "TR", "792", "", "07", "", "", "36.2537", "29.9777", "Europe/Istanbul"),("6620290", "Turgutreis", "", "TR", "792", "", "48", "7733242", "", "37.01667", "27.26667", "Europe/Istanbul"),("6692524", "Sarigerme", "Саригерме", "TR", "792", "", "48", "", "", "36.71549", "28.70436", "Europe/Istanbul"),("6940561", "Çatalhöyük", "", "TR", "792", "", "71", "", "", "37.66847", "32.82689", "Europe/Istanbul"),("6947637", "Ataşehir", "", "TR", "792", "", "34", "8521529", "", "40.9833", "29.1167", "Europe/Istanbul"),("6947639", "Başakşehir", "", "TR", "792", "", "34", "", "", "41.09307", "28.80203", "Europe/Istanbul"),("6947640", "Beylikdüzü", "", "TR", "792", "", "34", "", "", "40.982", "28.6399", "Europe/Istanbul"),("6947641", "Büyükçekmece", "", "TR", "792", "", "34", "", "", "41.02072", "28.58502", "Europe/Istanbul"),("6955677", "Çankaya", "", "TR", "792", "", "68", "", "", "39.9179", "32.86268", "Europe/Istanbul"),("7627067", "Bahçelievler", "", "TR", "792", "", "34", "", "", "41.00231", "28.8598", "Europe/Istanbul"),("7628416", "Sultangazi", "", "TR", "792", "", "34", "", "", "41.10652", "28.86847", "Europe/Istanbul"),("7628419", "Sultanbeyli", "", "TR", "792", "", "34", "", "", "40.96072", "29.27067", "Europe/Istanbul"),("7628420", "Sancaktepe", "", "TR", "792", "", "34", "", "", "41.00244", "29.23187", "Europe/Istanbul"),("7701384", "Karabağlar", "", "TR", "792", "", "35", "", "", "38.37396", "27.1352", "Europe/Istanbul"),("8074174", "Muratpaşa", "", "TR", "792", "", "07", "9535335", "", "36.89157", "30.76498", "Europe/Istanbul"),("11238838", "Merkezefendi", "", "TR", "792", "", "20", "9538816", "", "37.80544", "29.04236", "Europe/Istanbul"),("1665196", "Douliu", "Доулю", "TW", "158", "", "04", "YUN", "", "23.70944", "120.54333", "Asia/Taipei"),("1665357", "Yujing", "", "TW", "158", "", "04", "TNN", "", "23.12493", "120.46138", "Asia/Taipei"),("1668341", "Taipei", "Тайбэй", "TW", "158", "", "03", "TPE", "", "25.04776", "121.53185", "Asia/Taipei"),("1668355", "Tainan", "Тайнань", "TW", "158", "", "04", "TNN", "", "22.99083", "120.21333", "Asia/Taipei"),("1668399", "Taichung", "Тайчжун", "TW", "158", "", "04", "TXG", "", "24.1469", "120.6839", "Asia/Taipei"),("1668467", "Daxi", "Та-Си-чен", "TW", "158", "", "04", "TAO", "", "24.88373", "121.29043", "Asia/Taipei"),("1670029", "Banqiao", "", "TW", "158", "", "03", "TPQ", "", "25.01427", "121.46719", "Asia/Taipei"),("1670310", "Puli", "Пули", "TW", "158", "", "04", "NAN", "", "23.96639", "120.96952", "Asia/Taipei"),("1671566", "Nantou", "Наньтоу", "TW", "158", "", "04", "NAN", "", "23.91566", "120.66387", "Asia/Taipei"),("1672228", "Magong", "Магун", "TW", "158", "", "04", "PEN", "", "23.5654", "119.58627", "Asia/Taipei"),("1672551", "Lugu", "Лугу", "TW", "158", "", "04", "NAN", "", "23.74639", "120.7525", "Asia/Taipei"),("1673820", "Kaohsiung", "Гаосюн", "TW", "158", "", "02", "KHH", "", "22.61626", "120.31333", "Asia/Taipei"),("1674199", "Yilan", "Илань", "TW", "158", "", "04", "ILA", "", "24.757", "121.753", "Asia/Taipei"),("1674504", "Hualien City", "", "TW", "158", "", "04", "HUA", "", "23.97694", "121.60444", "Asia/Taipei"),("1675151", "Hsinchu", "Синьчжу", "TW", "158", "", "04", "HSZ", "", "24.80361", "120.96861", "Asia/Taipei"),("1676242", "Hengchun", "", "TW", "158", "", "04", "PIF", "", "22.00417", "120.74389", "Asia/Taipei"),("1678008", "Jincheng", "", "TW", "158", "", "01", "1676511", "", "24.43667", "118.31833", "Asia/Taipei"),("1678228", "Keelung", "Ши-лун", "TW", "158", "", "04", "KEE", "", "25.12825", "121.7419", "Asia/Taipei"),("6696918", "Taoyuan City", "Таоюань", "TW", "158", "", "04", "TAO", "", "24.99368", "121.29696", "Asia/Taipei"),("6949678", "Taitung City", "", "TW", "158", "", "04", "TTT", "", "22.7583", "121.1444", "Asia/Taipei"),("7601921", "Zhongxing New Village", "", "TW", "158", "", "04", "NAN", "", "23.95908", "120.68516", "Asia/Taipei"),("148730", "Zanzibar", "Занзибар", "TZ", "834", "", "25", "5302", "5302272", "-6.16394", "39.19793", "Africa/Dar_es_Salaam"),("148842", "Wete", "Вето", "TZ", "834", "", "13", "5401", "5401162", "-5.05589", "39.72938", "Africa/Dar_es_Salaam"),("148942", "Vwawa", "", "TZ", "834", "", "09", "1206", "1206182", "-9.11667", "32.93333", "Africa/Dar_es_Salaam"),("148987", "Vikindu", "", "TZ", "834", "", "02", "0604", "0604033", "-7.00667", "39.29849", "Africa/Dar_es_Salaam"),("149027", "Uyovu", "", "TZ", "834", "", "28", "2504", "2504051", "-3.28333", "31.52583", "Africa/Dar_es_Salaam"),("149050", "Uvinza", "", "TZ", "834", "", "05", "1605", "1605103", "-5.10361", "30.39111", "Africa/Dar_es_Salaam"),("149070", "Utete", "", "TZ", "834", "", "02", "0605", "0605043", "-7.98598", "38.75795", "Africa/Dar_es_Salaam"),("149114", "Usoke", "", "TZ", "834", "", "17", "1404", "1404091", "-5.16667", "32.35", "Africa/Dar_es_Salaam"),("149129", "Ushirombo", "", "TZ", "834", "", "28", "2504", "2504091", "-3.49194", "31.96389", "Africa/Dar_es_Salaam"),("149132", "Usevia", "", "TZ", "834", "", "29", "2303", "2303153", "-7.1", "31.23333", "Africa/Dar_es_Salaam"),("149151", "Usagara", "", "TZ", "834", "", "12", "1907", "1907033", "-2.68333", "33", "Africa/Dar_es_Salaam"),("149155", "Usa River", "", "TZ", "834", "", "26", "0202", "0202103", "-3.36667", "36.85", "Africa/Dar_es_Salaam"),("149172", "Urambo", "", "TZ", "834", "", "17", "1404", "1404023", "-5.06667", "32.05", "Africa/Dar_es_Salaam"),("149239", "Ulenje", "", "TZ", "834", "", "09", "1202", "1202021", "-8.93333", "33.68333", "Africa/Dar_es_Salaam"),("149402", "Tunduma", "", "TZ", "834", "", "09", "1210", "1210012", "-9.3", "32.76667", "Africa/Dar_es_Salaam"),("149418", "Tumbi", "", "TZ", "834", "", "17", "1406", "1406251", "-5.06667", "32.73333", "Africa/Dar_es_Salaam"),("149437", "Tukuyu", "", "TZ", "834", "", "09", "1204", "1204352", "-9.25", "33.65", "Africa/Dar_es_Salaam"),("149512", "Tinde", "", "TZ", "834", "", "15", "1703", "1703063", "-3.88333", "33.2", "Africa/Dar_es_Salaam"),("149581", "Tarime", "", "TZ", "834", "", "08", "2001", "2001162", "-1.35", "34.36667", "Africa/Dar_es_Salaam"),("149606", "Tanga", "Танга", "TZ", "834", "", "18", "0404", "0404012", "-5.06893", "39.09875", "Africa/Dar_es_Salaam"),("149658", "Tabora", "", "TZ", "834", "", "17", "1406", "1406082", "-5.01622", "32.82663", "Africa/Dar_es_Salaam"),("149703", "Sumbawanga", "", "TZ", "834", "", "24", "1504", "1504022", "-7.96667", "31.61667", "Africa/Dar_es_Salaam"),("149768", "Soni", "", "TZ", "834", "", "18", "0401", "0401053", "-4.85", "38.36667", "Africa/Dar_es_Salaam"),("149775", "Songwa", "", "TZ", "834", "", "15", "1702", "1702033", "-3.51667", "33.51667", "Africa/Dar_es_Salaam"),("149792", "Somanda", "", "TZ", "834", "", "31", "2404", "2404093", "-3.36667", "33.95", "Africa/Dar_es_Salaam"),("149812", "Sokoni", "", "TZ", "834", "", "21", "5202", "5202031", "-6.43333", "39.55", "Africa/Dar_es_Salaam"),("149854", "Sirari", "", "TZ", "834", "", "08", "2001", "2001033", "-1.25367", "34.47596", "Africa/Dar_es_Salaam"),("149879", "Singida", "", "TZ", "834", "", "16", "1304", "1304022", "-4.81629", "34.74358", "Africa/Dar_es_Salaam"),("149929", "Sikonge", "", "TZ", "834", "", "17", "1405", "1405141", "-5.63333", "32.76667", "Africa/Dar_es_Salaam"),("150006", "Shinyanga", "", "TZ", "834", "", "15", "1701", "1701052", "-3.66393", "33.42118", "Africa/Dar_es_Salaam"),("150037", "Shelui", "", "TZ", "834", "", "16", "1301", "1301053", "-4.36667", "34.2", "Africa/Dar_es_Salaam"),("150099", "Sepuka", "", "TZ", "834", "", "16", "1305", "1305251", "-4.75", "34.53333", "Africa/Dar_es_Salaam"),("150276", "Same", "", "TZ", "834", "", "06", "0303", "0303012", "-4.06667", "37.73333", "Africa/Dar_es_Salaam"),("150436", "Rulenge", "", "TZ", "834", "", "19", "1805", "1805033", "-2.7175", "30.6325", "Africa/Dar_es_Salaam"),("150453", "Rujewa", "", "TZ", "834", "", "09", "1207", "1207192", "-8.7", "34.38333", "Africa/Dar_es_Salaam"),("150634", "Puma", "", "TZ", "834", "", "16", "1305", "1305021", "-5", "34.73333", "Africa/Dar_es_Salaam"),("150689", "Poli", "", "TZ", "834", "", "26", "0202", "0202161", "-3.33333", "36.8", "Africa/Dar_es_Salaam"),("150793", "Pangani", "", "TZ", "834", "", "18", "0405", "0405022", "-5.42526", "38.97473", "Africa/Dar_es_Salaam"),("150885", "Old Shinyanga", "", "TZ", "834", "", "15", "1701", "1701173", "-3.55", "33.4", "Africa/Dar_es_Salaam"),("150930", "Nzega", "", "TZ", "834", "", "17", "1401", "1401102", "-4.21667", "33.18333", "Africa/Dar_es_Salaam"),("151062", "Nyanguge", "", "TZ", "834", "", "12", "1902", "1902053", "-2.55", "33.2", "Africa/Dar_es_Salaam"),("151108", "Nyamuswa", "", "TZ", "834", "", "08", "2004", "2004013", "-1.9", "34.01667", "Africa/Dar_es_Salaam"),("151211", "Nyalikungu", "", "TZ", "834", "", "31", "2404", "2404263", "-3.18333", "33.78333", "Africa/Dar_es_Salaam"),("151262", "Nyakahanga", "", "TZ", "834", "", "19", "1801", "1801203", "-1.60333", "31.14139", "Africa/Dar_es_Salaam"),("151266", "Nyakabindi", "", "TZ", "834", "", "31", "2401", "2401173", "-2.63333", "33.98333", "Africa/Dar_es_Salaam"),("151363", "Nsunga", "", "TZ", "834", "", "19", "1807", "1807021", "-1.14389", "31.39472", "Africa/Dar_es_Salaam"),("151373", "Nshamba", "", "TZ", "834", "", "19", "1803", "1803343", "-1.79833", "31.55111", "Africa/Dar_es_Salaam"),("151424", "Nkove", "", "TZ", "834", "", "24", "1503", "1503101", "-7.95", "30.85", "Africa/Dar_es_Salaam"),("151445", "Nkoaranga", "", "TZ", "834", "", "26", "0202", "0202161", "-3.33333", "36.8", "Africa/Dar_es_Salaam"),("151479", "Njombe", "", "TZ", "834", "", "30", "2201", "2201012", "-9.33333", "34.76667", "Africa/Dar_es_Salaam"),("151567", "Nguruka", "", "TZ", "834", "", "05", "1605", "1605133", "-5.10917", "31.04194", "Africa/Dar_es_Salaam"),("151599", "Ngudu", "", "TZ", "834", "", "12", "1904", "1904252", "-2.96667", "33.33333", "Africa/Dar_es_Salaam"),("151610", "Ngorongoro", "", "TZ", "834", "", "26", "0205", "0205103", "-3.23973", "35.48747", "Africa/Dar_es_Salaam"),("151678", "Ngerengere", "", "TZ", "834", "", "10", "0502", "0502121", "-6.75", "38.11667", "Africa/Dar_es_Salaam"),("151711", "Ngara", "", "TZ", "834", "", "19", "1805", "1805163", "-2.51222", "30.65583", "Africa/Dar_es_Salaam"),("151775", "Ndungu", "", "TZ", "834", "", "06", "0303", "0303143", "-4.36667", "38.05", "Africa/Dar_es_Salaam"),("151872", "Ndago", "", "TZ", "834", "", "16", "1301", "1301143", "-4.6", "34.35", "Africa/Dar_es_Salaam"),("151920", "Nansio", "", "TZ", "834", "", "08", "", "", "-2.13333", "33.05", "Africa/Dar_es_Salaam"),("151929", "Nangwa", "", "TZ", "834", "", "27", "2102", "2102151", "-4.46667", "35.45", "Africa/Dar_es_Salaam"),("151986", "Namanyere", "", "TZ", "834", "", "24", "1503", "1503162", "-7.51667", "31.05", "Africa/Dar_es_Salaam"),("151988", "Namanga", "", "TZ", "834", "", "26", "0207", "0207113", "-2.55116", "36.78377", "Africa/Dar_es_Salaam"),("152009", "Nakatunguru", "", "TZ", "834", "", "08", "", "", "-2.11667", "33.06667", "Africa/Dar_es_Salaam"),("152042", "Naberera", "", "TZ", "834", "", "27", "2104", "2104023", "-4.2", "36.93333", "Africa/Dar_es_Salaam"),("152169", "Mwembe", "", "TZ", "834", "", "06", "0303", "0303083", "-4.15", "37.85", "Africa/Dar_es_Salaam"),("152183", "Mwaya", "", "TZ", "834", "", "09", "1203", "1203041", "-9.55", "33.95", "Africa/Dar_es_Salaam"),("152224", "Mwanza", "Мванза", "TZ", "834", "", "12", "1903", "1903042", "-2.51667", "32.9", "Africa/Dar_es_Salaam"),("152265", "Mwanga", "", "TZ", "834", "", "18", "0402", "0402153", "-4.8", "38.2", "Africa/Dar_es_Salaam"),("152376", "Mwadui", "", "TZ", "834", "", "15", "1702", "1702063", "-3.55", "33.6", "Africa/Dar_es_Salaam"),("152403", "Mvomero", "", "TZ", "834", "", "02", "0601", "0601041", "-6.25", "38.66667", "Africa/Dar_es_Salaam"),("152451", "Musoma", "Мусома", "TZ", "834", "", "08", "2005", "2005092", "-1.5", "33.8", "Africa/Dar_es_Salaam"),("152497", "Muriti", "", "TZ", "834", "", "08", "", "", "-1.98333", "32.91667", "Africa/Dar_es_Salaam"),("152546", "Mungaa", "", "TZ", "834", "", "16", "1305", "1305033", "-4.96667", "34.88333", "Africa/Dar_es_Salaam"),("152570", "Muleba", "", "TZ", "834", "", "19", "1803", "1803123", "-1.83972", "31.65444", "Africa/Dar_es_Salaam"),("152632", "Muheza", "", "TZ", "834", "", "18", "0403", "0403092", "-5.16667", "38.78333", "Africa/Dar_es_Salaam"),("152663", "Mugumu", "", "TZ", "834", "", "08", "2002", "2002081", "-1.85", "34.7", "Africa/Dar_es_Salaam"),("152689", "Mugango", "", "TZ", "834", "", "08", "2003", "2003143", "-1.68333", "33.7", "Africa/Dar_es_Salaam"),("152718", "Mtwango", "", "TZ", "834", "", "30", "2204", "2204013", "-9.01667", "34.8", "Africa/Dar_es_Salaam"),("152743", "Mto wa Mbu", "", "TZ", "834", "", "26", "0201", "0201151", "-3.35", "35.85", "Africa/Dar_es_Salaam"),("152781", "Mtinko", "", "TZ", "834", "", "16", "1302", "1302191", "-4.55", "34.85", "Africa/Dar_es_Salaam"),("152793", "Mtimbira", "", "TZ", "834", "", "10", "0504", "0504223", "-8.78333", "36.35", "Africa/Dar_es_Salaam"),("152877", "Mtambile", "", "TZ", "834", "", "20", "5502", "5502133", "-5.38333", "39.7", "Africa/Dar_es_Salaam"),("152933", "Msowero", "", "TZ", "834", "", "10", "0501", "0501083", "-6.53333", "37.2", "Africa/Dar_es_Salaam"),("153046", "Msanga", "", "TZ", "834", "", "03", "0104", "0104061", "-6.05", "36.03333", "Africa/Dar_es_Salaam"),("153094", "Mpwapwa", "", "TZ", "834", "", "03", "0102", "0102183", "-6.35", "36.48333", "Africa/Dar_es_Salaam"),("153176", "Mpanda", "", "TZ", "834", "", "29", "2301", "2301052", "-6.34379", "31.06951", "Africa/Dar_es_Salaam"),("153209", "Moshi", "Моши", "TZ", "834", "", "06", "0306", "0306082", "-3.35", "37.33333", "Africa/Dar_es_Salaam"),("153220", "Morogoro", "Морогоро", "TZ", "834", "", "10", "0505", "0505042", "-6.82102", "37.66122", "Africa/Dar_es_Salaam"),("153247", "Monduli", "", "TZ", "834", "", "26", "0201", "0201052", "-3.3", "36.45", "Africa/Dar_es_Salaam"),("153352", "Mlowo", "", "TZ", "834", "", "09", "1206", "1206121", "-9", "32.98333", "Africa/Dar_es_Salaam"),("153384", "Mlimba", "", "TZ", "834", "", "10", "0503", "0503163", "-8.8", "35.81667", "Africa/Dar_es_Salaam"),("153408", "Mlangali", "", "TZ", "834", "", "30", "2205", "2205053", "-9.78333", "34.51667", "Africa/Dar_es_Salaam"),("153412", "Mlandizi", "", "TZ", "834", "", "02", "0602", "0602073", "-6.7", "38.73333", "Africa/Dar_es_Salaam"),("153423", "Mlalo", "", "TZ", "834", "", "18", "0408", "0408081", "-4.93333", "38.93333", "Africa/Dar_es_Salaam"),("153482", "Mkuranga", "", "TZ", "834", "", "02", "0604", "0604013", "-7.11799", "39.20782", "Africa/Dar_es_Salaam"),("153585", "Mkokotoni", "", "TZ", "834", "", "22", "5101", "5101013", "-5.87506", "39.25523", "Africa/Dar_es_Salaam"),("153709", "Mwandiga", "", "TZ", "834", "", "05", "1603", "1603113", "-4.83", "29.65806", "Africa/Dar_es_Salaam"),("153759", "Misungwi", "", "TZ", "834", "", "12", "1907", "1907093", "-2.85", "33.08333", "Africa/Dar_es_Salaam"),("153772", "Misasi", "", "TZ", "834", "", "12", "1907", "1907103", "-3", "33.08333", "Africa/Dar_es_Salaam"),("153871", "Mikumi", "", "TZ", "834", "", "10", "0501", "0501193", "-7.40409", "36.98309", "Africa/Dar_es_Salaam"),("153955", "Micheweni", "", "TZ", "834", "", "13", "5402", "5402131", "-4.96667", "39.83333", "Africa/Dar_es_Salaam"),("154002", "Mhango", "", "TZ", "834", "", "15", "1703", "1703221", "-3.28333", "32.85", "Africa/Dar_es_Salaam"),("154097", "Mgandu", "", "TZ", "834", "", "16", "1303", "1303171", "-5.95", "34.13333", "Africa/Dar_es_Salaam"),("154313", "Mbulu", "", "TZ", "834", "", "27", "2103", "2103272", "-3.85", "35.53333", "Africa/Dar_es_Salaam"),("154321", "Mbuguni", "", "TZ", "834", "", "26", "0202", "0202083", "-3.56667", "36.95", "Africa/Dar_es_Salaam"),("154380", "Mbeya", "Мбее", "TZ", "834", "", "09", "1208", "1208222", "-8.9", "33.45", "Africa/Dar_es_Salaam"),("154470", "Mazinde", "", "TZ", "834", "", "18", "0402", "0402153", "-4.8", "38.21667", "Africa/Dar_es_Salaam"),("154566", "Matui", "", "TZ", "834", "", "18", "0401", "0401012", "-4.8", "38.25", "Africa/Dar_es_Salaam"),("154576", "Matonga", "", "TZ", "834", "", "31", "2401", "2401201", "-2.38333", "34.08333", "Africa/Dar_es_Salaam"),("154635", "Matamba", "", "TZ", "834", "", "30", "2203", "2203221", "-8.98333", "33.96667", "Africa/Dar_es_Salaam"),("154638", "Matai", "", "TZ", "834", "", "24", "1501", "1501043", "-8.3", "31.51667", "Africa/Dar_es_Salaam"),("154648", "Maswa", "", "TZ", "834", "", "31", "2401", "2401173", "-2.68333", "33.98333", "Africa/Dar_es_Salaam"),("154654", "Masumbwe", "", "TZ", "834", "", "28", "2503", "2503123", "-3.63333", "32.18333", "Africa/Dar_es_Salaam"),("154666", "Masoko", "", "TZ", "834", "", "09", "1204", "1204161", "-9.33333", "33.75", "Africa/Dar_es_Salaam"),("154780", "Maramba", "", "TZ", "834", "", "18", "0403", "0403221", "-5.05", "38.61667", "Africa/Dar_es_Salaam"),("154915", "Maneromango", "", "TZ", "834", "", "02", "0603", "0603063", "-7.1988", "38.78478", "Africa/Dar_es_Salaam"),("154995", "Malya", "", "TZ", "834", "", "12", "1904", "1904123", "-2.98333", "33.51667", "Africa/Dar_es_Salaam"),("155016", "Malinyi", "", "TZ", "834", "", "10", "0504", "0504193", "-8.93333", "36.13333", "Africa/Dar_es_Salaam"),("155052", "Malangali", "", "TZ", "834", "", "04", "1102", "1102103", "-8.56667", "34.85", "Africa/Dar_es_Salaam"),("155056", "Malampaka", "", "TZ", "834", "", "31", "2404", "2404233", "-3.13333", "33.53333", "Africa/Dar_es_Salaam"),("155076", "Makuyuni", "", "TZ", "834", "", "18", "0402", "0402161", "-4.73333", "38.1", "Africa/Dar_es_Salaam"),("155093", "Makungu", "", "TZ", "834", "", "04", "1102", "1102023", "-8.73333", "35.28333", "Africa/Dar_es_Salaam"),("155101", "Makumbako", "", "TZ", "834", "", "30", "2206", "2206022", "-8.85", "34.83333", "Africa/Dar_es_Salaam"),("155187", "Makanya", "", "TZ", "834", "", "06", "0303", "0303233", "-4.36667", "37.83333", "Africa/Dar_es_Salaam"),("155244", "Majengo", "", "TZ", "834", "", "18", "0404", "0404173", "-5.15", "38.98333", "Africa/Dar_es_Salaam"),("155263", "Mahonda", "", "TZ", "834", "", "21", "5202", "5202091", "-6.45", "39.46667", "Africa/Dar_es_Salaam"),("155274", "Mahenge", "", "TZ", "834", "", "10", "0504", "0504053", "-8.68333", "36.71667", "Africa/Dar_es_Salaam"),("155285", "Mahanje", "", "TZ", "834", "", "14", "1002", "1002133", "-9.93333", "35.33333", "Africa/Dar_es_Salaam"),("155307", "Kihangara", "", "TZ", "834", "", "12", "1902", "1902081", "-2.58333", "33.35", "Africa/Dar_es_Salaam"),("155310", "Magugu", "", "TZ", "834", "", "27", "2101", "2101183", "-4.01667", "35.76667", "Africa/Dar_es_Salaam"),("155321", "Magomeni", "", "TZ", "834", "", "23", "0701", "0701032", "-6.8", "39.25", "Africa/Dar_es_Salaam"),("155322", "Magomeni", "", "TZ", "834", "", "18", "0406", "0406111", "-5.23333", "38.11667", "Africa/Dar_es_Salaam"),("155334", "Magole", "", "TZ", "834", "", "10", "0501", "0501073", "-6.37697", "37.37373", "Africa/Dar_es_Salaam"),("155405", "Mafinga", "", "TZ", "834", "", "04", "1101", "1101131", "-7.25", "35.06667", "Africa/Dar_es_Salaam"),("155514", "Mabamba", "", "TZ", "834", "", "05", "1601", "1601103", "-3.59833", "30.50194", "Africa/Dar_es_Salaam"),("155515", "Mabama", "", "TZ", "834", "", "17", "1403", "1403063", "-5.13333", "32.53333", "Africa/Dar_es_Salaam"),("155569", "Lushoto", "", "TZ", "834", "", "18", "0401", "0401012", "-4.78333", "38.28333", "Africa/Dar_es_Salaam"),("155584", "Lupiro", "", "TZ", "834", "", "10", "0504", "0504023", "-8.38333", "36.66667", "Africa/Dar_es_Salaam"),("155743", "Lugoba", "", "TZ", "834", "", "02", "0601", "0601133", "-6.45", "38.33333", "Africa/Dar_es_Salaam"),("155848", "Longido", "", "TZ", "834", "", "26", "0207", "0207132", "-2.73319", "36.69773", "Africa/Dar_es_Salaam"),("155921", "Liwale", "", "TZ", "834", "", "07", "0804", "0804183", "-9.76667", "37.93333", "Africa/Dar_es_Salaam"),("156025", "Lembeni", "", "TZ", "834", "", "06", "0302", "0302083", "-3.78333", "37.61667", "Africa/Dar_es_Salaam"),("156080", "Lalago", "", "TZ", "834", "", "31", "2404", "2404093", "-3.45", "33.95", "Africa/Dar_es_Salaam"),("156098", "Laela", "", "TZ", "834", "", "24", "1502", "1502151", "-8.56667", "32.05", "Africa/Dar_es_Salaam"),("156111", "Kyela", "", "TZ", "834", "", "09", "1203", "1203202", "-9.58333", "33.85", "Africa/Dar_es_Salaam"),("156124", "Kyaka", "", "TZ", "834", "", "19", "1807", "1807173", "-1.25222", "31.42028", "Africa/Dar_es_Salaam"),("156312", "Kwakoa", "", "TZ", "834", "", "06", "0302", "0302071", "-3.76667", "37.71667", "Africa/Dar_es_Salaam"),("156493", "Kongwa", "", "TZ", "834", "", "03", "0103", "0103013", "-6.2", "36.41667", "Africa/Dar_es_Salaam"),("156510", "Kondoa", "", "TZ", "834", "", "03", "0101", "0101142", "-4.9", "35.78333", "Africa/Dar_es_Salaam"),("156513", "Konde", "", "TZ", "834", "", "13", "5402", "5402083", "-4.95", "39.75", "Africa/Dar_es_Salaam"),("156589", "Koani", "", "TZ", "834", "", "21", "5201", "5201093", "-6.13333", "39.28333", "Africa/Dar_es_Salaam"),("156627", "Kiwira", "", "TZ", "834", "", "09", "1204", "1204293", "-9.17307", "33.54152", "Africa/Dar_es_Salaam"),("156918", "Kisiwani", "", "TZ", "834", "", "06", "0303", "0303043", "-4.13333", "37.95", "Africa/Dar_es_Salaam"),("156963", "Kishapu", "", "TZ", "834", "", "15", "1702", "1702083", "-3.61667", "33.86667", "Africa/Dar_es_Salaam"),("156974", "Kisesa", "", "TZ", "834", "", "31", "2403", "2403061", "-3.08333", "34.15", "Africa/Dar_es_Salaam"),("156996", "Kisarawe", "", "TZ", "834", "", "02", "0603", "0603013", "-6.9", "39.06667", "Africa/Dar_es_Salaam"),("157014", "Kisanga", "", "TZ", "834", "", "10", "0502", "0502071", "-7.43622", "37.70337", "Africa/Dar_es_Salaam"),("157107", "Kirando", "", "TZ", "834", "", "24", "1503", "1503141", "-7.41667", "30.6", "Africa/Dar_es_Salaam"),("157198", "Kiomboi", "", "TZ", "834", "", "16", "1301", "1301103", "-4.26667", "34.36667", "Africa/Dar_es_Salaam"),("157247", "Kintinku", "", "TZ", "834", "", "16", "1303", "1303063", "-5.88333", "35.23333", "Africa/Dar_es_Salaam"),("157268", "Kingori", "", "TZ", "834", "", "26", "0202", "0202033", "-3.28333", "36.98333", "Africa/Dar_es_Salaam"),("157366", "Kimamba", "", "TZ", "834", "", "10", "0501", "0501122", "-6.78333", "37.13333", "Africa/Dar_es_Salaam"),("157403", "Kilosa", "", "TZ", "834", "", "10", "0501", "0501162", "-6.83333", "36.98333", "Africa/Dar_es_Salaam"),("157429", "Kilindoni", "", "TZ", "834", "", "02", "0606", "0606043", "-7.91446", "39.66204", "Africa/Dar_es_Salaam"),("157448", "Kilimatinde", "", "TZ", "834", "", "16", "1303", "1303023", "-5.85", "34.95", "Africa/Dar_es_Salaam"),("157653", "Kihurio", "", "TZ", "834", "", "06", "0303", "0303153", "-4.46667", "38.06667", "Africa/Dar_es_Salaam"),("157738", "Kigoma", "Кигоме", "TZ", "834", "", "05", "1604", "1604162", "-4.87694", "29.62667", "Africa/Dar_es_Salaam"),("157826", "Kidodi", "", "TZ", "834", "", "10", "0501", "0501213", "-7.60361", "37.00438", "Africa/Dar_es_Salaam"),("157863", "Kidatu", "", "TZ", "834", "", "10", "0503", "0503013", "-7.69916", "36.95722", "Africa/Dar_es_Salaam"),("157960", "Kibondo", "", "TZ", "834", "", "05", "1601", "1601033", "-3.58639", "30.72028", "Africa/Dar_es_Salaam"),("157977", "Kibiti", "", "TZ", "834", "", "02", "0605", "0605083", "-7.72178", "38.93749", "Africa/Dar_es_Salaam"),("158006", "Kibaya", "", "TZ", "834", "", "27", "2105", "2105153", "-5.3", "36.56667", "Africa/Dar_es_Salaam"),("158016", "Kibara", "", "TZ", "834", "", "08", "2004", "2004133", "-2.15", "33.45", "Africa/Dar_es_Salaam"),("158024", "Kibakwe", "", "TZ", "834", "", "03", "0102", "0102053", "-6.71667", "36.36667", "Africa/Dar_es_Salaam"),("158027", "Kibaha", "", "TZ", "834", "", "02", "0607", "0607052", "-6.76667", "38.91667", "Africa/Dar_es_Salaam"),("158151", "Katumba", "Катумба", "TZ", "834", "", "09", "1204", "1204322", "-9.23333", "33.61667", "Africa/Dar_es_Salaam"),("158160", "Katoro", "", "TZ", "834", "", "28", "2505", "2505191", "-3.02028", "31.89583", "Africa/Dar_es_Salaam"),("158161", "Katoro", "", "TZ", "834", "", "19", "1802", "1802263", "-1.39972", "31.50028", "Africa/Dar_es_Salaam"),("158179", "Katerero", "", "TZ", "834", "", "19", "1802", "1802081", "-1.4", "31.73333", "Africa/Dar_es_Salaam"),("158214", "Kasulu", "Касулу", "TZ", "834", "", "05", "1608", "1608082", "-4.57667", "30.1025", "Africa/Dar_es_Salaam"),("158289", "Kasamwa", "", "TZ", "834", "", "28", "2501", "2501133", "-2.85", "32.43333", "Africa/Dar_es_Salaam"),("158321", "Karema", "", "TZ", "834", "", "29", "2302", "2302083", "-6.82052", "30.43887", "Africa/Dar_es_Salaam"),("158324", "Kiratu", "", "TZ", "834", "", "26", "0204", "0204013", "-3.33333", "35.66667", "Africa/Dar_es_Salaam"),("158422", "Kandete", "", "TZ", "834", "", "09", "1204", "1204051", "-9.15", "33.8", "Africa/Dar_es_Salaam"),("158492", "Kamachumu", "", "TZ", "834", "", "19", "1803", "1803413", "-1.61861", "31.62", "Africa/Dar_es_Salaam"),("158514", "Kaliua", "", "TZ", "834", "", "17", "1407", "1407031", "-5.06056", "31.79361", "Africa/Dar_es_Salaam"),("158563", "Kakonko", "", "TZ", "834", "", "05", "1607", "1607053", "-3.28278", "30.96417", "Africa/Dar_es_Salaam"),("158597", "Kahama", "", "TZ", "834", "", "15", "1705", "1705132", "-3.83333", "32.6", "Africa/Dar_es_Salaam"),("158684", "Kabanga", "", "TZ", "834", "", "19", "1805", "1805093", "-2.63861", "30.46778", "Africa/Dar_es_Salaam"),("158825", "Izazi", "", "TZ", "834", "", "04", "1101", "1101191", "-7.2", "35.73333", "Africa/Dar_es_Salaam"),("158876", "Itumba", "", "TZ", "834", "", "09", "1205", "1205013", "-9.4", "33.18333", "Africa/Dar_es_Salaam"),("158904", "Itigi", "", "TZ", "834", "", "16", "1303", "1303183", "-5.7", "34.48333", "Africa/Dar_es_Salaam"),("158974", "Issenye", "", "TZ", "834", "", "08", "2002", "2002123", "-2", "34.33333", "Africa/Dar_es_Salaam"),("159045", "Isaka", "Исака", "TZ", "834", "", "15", "1704", "1704163", "-3.9", "32.93333", "Africa/Dar_es_Salaam"),("159071", "Iringa", "Иринга", "TZ", "834", "", "04", "1103", "1103032", "-7.76667", "35.7", "Africa/Dar_es_Salaam"),("159107", "Ipinda", "", "TZ", "834", "", "09", "1203", "1203143", "-9.48333", "33.9", "Africa/Dar_es_Salaam"),("159134", "Inyonga", "", "TZ", "834", "", "29", "2303", "2303053", "-6.71667", "32.06667", "Africa/Dar_es_Salaam"),("159179", "Ilula", "", "TZ", "834", "", "04", "1104", "1104183", "-7.6766", "36.03658", "Africa/Dar_es_Salaam"),("159186", "Ilongero", "", "TZ", "834", "", "16", "1302", "1302163", "-4.66667", "34.86667", "Africa/Dar_es_Salaam"),("159218", "Ilembula", "", "TZ", "834", "", "30", "2202", "2202043", "-8.9", "34.58333", "Africa/Dar_es_Salaam"),("159242", "Ikwiriri", "", "TZ", "834", "", "02", "0605", "0605023", "-7.95618", "38.97164", "Africa/Dar_es_Salaam"),("159267", "Ikungi", "", "TZ", "834", "", "16", "1305", "1305143", "-5.13333", "34.76667", "Africa/Dar_es_Salaam"),("159380", "Igurusi", "", "TZ", "834", "", "09", "", "", "-8.85", "33.85", "Africa/Dar_es_Salaam"),("159382", "Igurubi", "", "TZ", "834", "", "17", "1402", "1402103", "-4", "33.7", "Africa/Dar_es_Salaam"),("159386", "Igunga", "", "TZ", "834", "", "17", "1402", "1402013", "-4.28333", "33.88333", "Africa/Dar_es_Salaam"),("159398", "Igugunu", "", "TZ", "834", "", "16", "1306", "1306113", "-4.56667", "34.63333", "Africa/Dar_es_Salaam"),("159492", "Ifakara", "", "TZ", "834", "", "10", "0503", "0503073", "-8.13333", "36.68333", "Africa/Dar_es_Salaam"),("159647", "Hedaru", "", "TZ", "834", "", "06", "0303", "0303243", "-4.5", "37.9", "Africa/Dar_es_Salaam"),("159908", "Geita", "", "TZ", "834", "", "28", "2501", "2501341", "-2.86667", "32.16667", "Africa/Dar_es_Salaam"),("159909", "Geiro", "", "TZ", "834", "", "10", "0507", "0507051", "-6.15", "36.86667", "Africa/Dar_es_Salaam"),("159951", "Galappo", "", "TZ", "834", "", "27", "2101", "2101053", "-4.26667", "35.85", "Africa/Dar_es_Salaam"),("160073", "Endasak", "", "TZ", "834", "", "27", "2102", "2102133", "-4.41667", "35.51667", "Africa/Dar_es_Salaam"),("160141", "Dunda", "", "TZ", "834", "", "09", "1207", "1207141", "-8.11667", "34.25", "Africa/Dar_es_Salaam"),("160172", "Dongobesh", "", "TZ", "834", "", "27", "2103", "2103103", "-4.06667", "35.38333", "Africa/Dar_es_Salaam"),("160196", "Dodoma", "Додома", "TZ", "834", "", "03", "0105", "0105272", "-6.17221", "35.73947", "Africa/Dar_es_Salaam"),("160263", "Dar es Salaam", "Дар-эс-Салам", "TZ", "834", "", "23", "0702", "0702132", "-6.82349", "39.26951", "Africa/Dar_es_Salaam"),("160266", "Dareda", "", "TZ", "834", "", "27", "2101", "2101123", "-4.21667", "35.55", "Africa/Dar_es_Salaam"),("160464", "Chimala", "", "TZ", "834", "", "09", "1207", "1207063", "-8.85637", "34.02393", "Africa/Dar_es_Salaam"),("160552", "Chato", "", "TZ", "834", "", "28", "2505", "2505093", "-2.63778", "31.76694", "Africa/Dar_es_Salaam"),("160592", "Chanika", "", "TZ", "834", "", "18", "0410", "0410102", "-5.41667", "38.01667", "Africa/Dar_es_Salaam"),("160660", "Chalinze", "", "TZ", "834", "", "02", "0601", "0601123", "-6.63784", "38.35396", "Africa/Dar_es_Salaam"),("160670", "Chala", "", "TZ", "834", "", "24", "1503", "1503043", "-7.58333", "31.26667", "Africa/Dar_es_Salaam"),("160677", "Chake Chake", "", "TZ", "834", "", "20", "5501", "5501262", "-5.24586", "39.76659", "Africa/Dar_es_Salaam"),("160798", "Butiama", "", "TZ", "834", "", "08", "2007", "2007083", "-1.76667", "33.96667", "Africa/Dar_es_Salaam"),("160833", "Buseresere", "", "TZ", "834", "", "28", "2505", "2505191", "-3.02361", "31.87472", "Africa/Dar_es_Salaam"),("160877", "Bungu", "", "TZ", "834", "", "02", "0605", "0605093", "-7.63369", "39.05818", "Africa/Dar_es_Salaam"),("160892", "Bunda", "", "TZ", "834", "", "08", "2004", "2004243", "-2.05", "33.86667", "Africa/Dar_es_Salaam"),("160961", "Bukoba", "Букоба", "TZ", "834", "", "19", "1806", "1806072", "-1.33167", "31.81222", "Africa/Dar_es_Salaam"),("160971", "Bukene", "", "TZ", "834", "", "17", "1401", "1401303", "-4.23333", "32.88333", "Africa/Dar_es_Salaam"),("161022", "Bugene", "", "TZ", "834", "", "19", "1801", "1801073", "-1.59111", "31.14028", "Africa/Dar_es_Salaam"),("161023", "Bugarama", "", "TZ", "834", "", "19", "1805", "1805071", "-2.87056", "30.52806", "Africa/Dar_es_Salaam"),("161154", "Biharamulo", "", "TZ", "834", "", "19", "1804", "1804033", "-2.63194", "31.30889", "Africa/Dar_es_Salaam"),("161197", "Basotu", "", "TZ", "834", "", "27", "2102", "2102073", "-4.36667", "35.08333", "Africa/Dar_es_Salaam"),("161204", "Bashanet", "", "TZ", "834", "", "27", "2101", "2101151", "-4.23333", "35.41667", "Africa/Dar_es_Salaam"),("161218", "Bariadi", "", "TZ", "834", "", "31", "2401", "2401233", "-2.8", "33.98333", "Africa/Dar_es_Salaam"),("161290", "Bagamoyo", "", "TZ", "834", "", "02", "0601", "0601062", "-6.44222", "38.90422", "Africa/Dar_es_Salaam"),("161312", "Babati", "", "TZ", "834", "", "27", "2106", "2106012", "-4.21667", "35.75", "Africa/Dar_es_Salaam"),("161325", "Arusha", "Аруша", "TZ", "834", "", "26", "0203", "0203152", "-3.36667", "36.68333", "Africa/Dar_es_Salaam"),("877384", "Tingi", "", "TZ", "834", "", "14", "1006", "1006021", "-11.3", "35.03333", "Africa/Dar_es_Salaam"),("877391", "Tandahimba", "", "TZ", "834", "", "11", "0904", "0904013", "-10.75", "39.63333", "Africa/Dar_es_Salaam"),("877401", "Songea", "Сонгеа", "TZ", "834", "", "14", "1004", "1004022", "-10.68333", "35.65", "Africa/Dar_es_Salaam"),("877433", "Ruangwa", "", "TZ", "834", "", "07", "0805", "0805163", "-10.06667", "38.93333", "Africa/Dar_es_Salaam"),("877471", "Nyangao", "", "TZ", "834", "", "07", "0802", "0802123", "-10.33333", "39.28333", "Africa/Dar_es_Salaam"),("877532", "Newala Kisimani", "", "TZ", "834", "", "11", "0902", "0902213", "-10.95", "39.28333", "Africa/Dar_es_Salaam"),("877581", "Nanyamba", "", "TZ", "834", "", "11", "0901", "0901271", "-10.68333", "39.83333", "Africa/Dar_es_Salaam"),("877588", "Nanhyanga", "", "TZ", "834", "", "11", "0904", "0904133", "-10.8", "39.55", "Africa/Dar_es_Salaam"),("877597", "Nangomba", "", "TZ", "834", "", "11", "0906", "0906021", "-10.9", "38.5", "Africa/Dar_es_Salaam"),("877605", "Nanganga", "", "TZ", "834", "", "11", "", "", "-10.38333", "39.15", "Africa/Dar_es_Salaam"),("877631", "Namikupa", "", "TZ", "834", "", "11", "0904", "0904261", "-10.83333", "39.6", "Africa/Dar_es_Salaam"),("877670", "Namalenga", "", "TZ", "834", "", "11", "0903", "0903183", "-10.95", "39.1", "Africa/Dar_es_Salaam"),("877702", "Nachingwea", "", "TZ", "834", "", "07", "0803", "0803012", "-10.3725", "38.76251", "Africa/Dar_es_Salaam"),("877747", "Mtwara", "Мтвара", "TZ", "834", "", "11", "0905", "0905052", "-10.26667", "40.18333", "Africa/Dar_es_Salaam"),("877784", "Mtama", "", "TZ", "834", "", "07", "0802", "0802113", "-10.3", "39.36667", "Africa/Dar_es_Salaam"),("877925", "Mingoyo", "", "TZ", "834", "", "07", "0806", "0806142", "-10.10526", "39.61859", "Africa/Dar_es_Salaam"),("877998", "Mbinga", "", "TZ", "834", "", "14", "1003", "1003063", "-10.93333", "35.01667", "Africa/Dar_es_Salaam"),("878006", "Mbekenyera", "", "TZ", "834", "", "07", "0805", "0805023", "-10", "38.98333", "Africa/Dar_es_Salaam"),("878023", "Mbamba Bay", "", "TZ", "834", "", "14", "", "", "-11.28333", "34.76667", "Africa/Dar_es_Salaam"),("878041", "Matiri", "", "TZ", "834", "", "14", "1003", "1003181", "-10.75", "34.9", "Africa/Dar_es_Salaam"),("878054", "Masuguru", "", "TZ", "834", "", "11", "0906", "0906121", "-11.36667", "38.41667", "Africa/Dar_es_Salaam"),("878058", "Masasi", "Масаси", "TZ", "834", "", "11", "0907", "0907102", "-10.71667", "38.8", "Africa/Dar_es_Salaam"),("878073", "Maposeni", "", "TZ", "834", "", "14", "1002", "1002111", "-10.58333", "35.4", "Africa/Dar_es_Salaam"),("878087", "Manda", "", "TZ", "834", "", "30", "", "", "-10.46667", "34.58333", "Africa/Dar_es_Salaam"),("878121", "Mahuta", "", "TZ", "834", "", "11", "0904", "0904283", "-10.86667", "39.45", "Africa/Dar_es_Salaam"),("878141", "Madimba", "", "TZ", "834", "", "11", "0901", "0901013", "-10.4", "40.33333", "Africa/Dar_es_Salaam"),("878184", "Lulindi", "", "TZ", "834", "", "11", "0903", "0903121", "-10.81667", "39.13333", "Africa/Dar_es_Salaam"),("878195", "Lukuledi", "", "TZ", "834", "", "11", "0903", "0903053", "-10.56667", "38.8", "Africa/Dar_es_Salaam"),("878223", "Luchingu", "", "TZ", "834", "", "11", "0902", "0902061", "-10.9", "39.33333", "Africa/Dar_es_Salaam"),("878242", "Liuli", "", "TZ", "834", "", "14", "", "", "-11.08333", "34.63333", "Africa/Dar_es_Salaam"),("878281", "Lindi", "Линда", "TZ", "834", "", "07", "0806", "0806022", "-9.99709", "39.71649", "Africa/Dar_es_Salaam"),("878362", "Kitangari", "", "TZ", "834", "", "11", "0902", "0902123", "-10.65", "39.33333", "Africa/Dar_es_Salaam"),("878367", "Kitama", "", "TZ", "834", "", "11", "0901", "0901081", "-10.71667", "39.73333", "Africa/Dar_es_Salaam"),("878400", "Kigonsera", "", "TZ", "834", "", "14", "1003", "1003033", "-10.8", "35.05", "Africa/Dar_es_Salaam"),("878455", "Chiungutwa", "", "TZ", "834", "", "11", "0903", "0903143", "-10.88333", "38.98333", "Africa/Dar_es_Salaam"),("6640202", "Merelani", "", "TZ", "834", "", "26", "", "", "-3.56182", "36.97895", "Africa/Dar_es_Salaam"),("7284275", "Nungwi", "", "TZ", "834", "", "22", "5101", "5101162", "-5.72651", "39.2987", "Africa/Dar_es_Salaam"),("9063978", "Kisasa", "", "TZ", "834", "", "03", "0105", "0105131", "-6.17526", "35.79266", "Africa/Dar_es_Salaam"),("613273", "Lebedyn", "Лебедин", "UA", "804", "", "21", "", "", "50.58518", "34.4849", "Europe/Kiev"),("616196", "Staryy Dobrotvir", "", "UA", "804", "", "15", "", "", "50.23154", "24.37701", "Europe/Kiev"),("616743", "Druzhkivka", "Дружковка", "UA", "804", "", "05", "", "", "48.63013", "37.55259", "Europe/Kiev"),("686729", "Vasylivka", "Василівка", "UA", "804", "", "26", "", "", "47.43694", "35.27417", "Europe/Zaporozhye"),("686762", "Ivano-Frankove", "", "UA", "804", "", "15", "", "", "49.91978", "23.72913", "Europe/Kiev"),("686803", "Zvenyhorodka", "Звенигородка", "UA", "804", "", "01", "", "", "49.07866", "30.96755", "Europe/Kiev"),("686812", "Zuya", "", "UA", "804", "", "11", "712585", "11152832", "45.05418", "34.32152", "Europe/Simferopol"),("686818", "Zuhres", "Зугрес", "UA", "804", "", "05", "", "", "48.0114", "38.26444", "Europe/Kiev"),("686852", "Zoryns’k", "", "UA", "804", "", "14", "", "", "48.41194", "38.62361", "Europe/Zaporozhye"),("686875", "Zolotonosha", "Золотоноша", "UA", "804", "", "01", "", "", "49.66832", "32.04047", "Europe/Kiev"),("686895", "Zolochiv", "", "UA", "804", "", "07", "", "", "50.27985", "35.98179", "Europe/Kiev"),("686896", "Zolochiv", "Золочев", "UA", "804", "", "15", "", "", "49.80597", "24.89436", "Europe/Kiev"),("686919", "Znomenka", "Знаменка", "UA", "804", "", "10", "", "", "48.71278", "32.66472", "Europe/Kiev"),("686928", "Zmiyiv", "Зміїв", "UA", "804", "", "07", "", "", "49.67453", "36.34775", "Europe/Kiev"),("686967", "Zhytomyr", "Житомир", "UA", "804", "", "27", "", "", "50.26487", "28.67669", "Europe/Kiev"),("687093", "Zhovkva", "", "UA", "804", "", "15", "", "", "50.05825", "23.9726", "Europe/Kiev"),("687116", "Zhmerynka", "Жмеринка", "UA", "804", "", "23", "", "", "49.03705", "28.11201", "Europe/Kiev"),("687196", "Zhovti Vody", "Желтые Воды", "UA", "804", "", "04", "", "", "48.34493", "33.50374", "Europe/Kiev"),("687245", "Zhashkiv", "Жашків", "UA", "804", "", "01", "", "", "49.24545", "30.1102", "Europe/Kiev"),("687277", "Zgurovka", "", "UA", "804", "", "13", "", "", "50.50276", "31.78492", "Europe/Kiev"),("687292", "Zin’kiv", "", "UA", "804", "", "18", "", "", "50.20806", "34.36376", "Europe/Kiev"),("687432", "Zdolbuniv", "Здолбунів", "UA", "804", "", "19", "", "", "50.5206", "26.24251", "Europe/Kiev"),("687449", "Zboriv", "", "UA", "804", "", "22", "", "", "49.66484", "25.14097", "Europe/Kiev"),("687455", "Zbarazh", "", "UA", "804", "", "22", "", "", "49.66357", "25.77616", "Europe/Kiev"),("687526", "Zavallya", "", "UA", "804", "", "10", "", "", "48.21354", "30.01558", "Europe/Kiev"),("687578", "Zastavna", "", "UA", "804", "", "03", "", "", "48.52307", "25.84369", "Europe/Kiev"),("687602", "Zorya", "", "UA", "804", "", "17", "", "", "45.9908", "29.69672", "Europe/Kiev"),("687652", "Zarichne", "", "UA", "804", "", "19", "", "", "51.8126", "26.12902", "Europe/Kiev"),("687700", "Zaporizhia", "Запорожье", "UA", "804", "", "26", "", "", "47.82289", "35.19031", "Europe/Zaporozhye"),("687826", "Zalishchyky", "", "UA", "804", "", "22", "", "", "48.64331", "25.73794", "Europe/Kiev"),("687997", "Yuzhne", "Южне", "UA", "804", "", "17", "", "", "46.62211", "31.10131", "Europe/Kiev"),("688105", "Yevpatoriya", "Евпатория", "UA", "804", "", "11", "8449691", "", "45.20091", "33.36655", "Europe/Simferopol"),("688148", "Yenakiyeve", "Енакиево", "UA", "804", "", "05", "", "", "48.23331", "38.21137", "Europe/Kiev"),("688288", "Yavoriv", "", "UA", "804", "", "15", "", "", "49.93864", "23.38254", "Europe/Kiev"),("688365", "Yasinya", "", "UA", "804", "", "25", "", "", "48.27937", "24.36042", "Europe/Uzhgorod"),("688373", "Yasynuvata", "Ясиноватая", "UA", "804", "", "05", "", "", "48.1298", "37.8594", "Europe/Kiev"),("688440", "Yarmolyntsi", "", "UA", "804", "", "09", "", "", "49.19236", "26.83725", "Europe/Kiev"),("688455", "Yaremche", "", "UA", "804", "", "06", "", "", "48.45157", "24.55436", "Europe/Kiev"),("688501", "Yampil’", "", "UA", "804", "", "21", "", "", "51.94765", "33.78759", "Europe/Kiev"),("688532", "Yalta", "", "UA", "804", "", "05", "", "", "46.96279", "37.27365", "Europe/Kiev"),("688533", "Yalta", "Ялта", "UA", "804", "", "11", "8449687", "", "44.50218", "34.16624", "Europe/Simferopol"),("688587", "Yahotyn", "Яготин", "UA", "804", "", "13", "", "", "50.27975", "31.76246", "Europe/Kiev"),("688696", "Vysokyy", "", "UA", "804", "", "07", "", "", "49.89156", "36.12175", "Europe/Kiev"),("688717", "Vyshkovo", "", "UA", "804", "", "25", "", "", "48.04911", "23.42113", "Europe/Uzhgorod"),("688723", "Vyshhorod", "Вишгород", "UA", "804", "", "13", "", "", "50.58476", "30.4898", "Europe/Kiev"),("688746", "Vynohradiv", "Виноградов", "UA", "804", "UA", "25", "", "", "48.14135", "23.02666", "Europe/Uzhgorod"),("688750", "Vylkove", "", "UA", "804", "", "17", "", "", "45.40214", "29.58595", "Europe/Kiev"),("688846", "Vradiyivka", "", "UA", "804", "", "16", "688847", "", "47.86195", "30.59195", "Europe/Kiev"),("688860", "Voznesensk", "Вознесенск", "UA", "804", "UA", "16", "", "", "47.56494", "31.33078", "Europe/Kiev"),("688956", "Vorzel’", "", "UA", "804", "", "13", "", "", "50.5444", "30.15305", "Europe/Kiev"),("688961", "Vorozhba", "", "UA", "804", "", "21", "", "", "51.17334", "34.21917", "Europe/Kiev"),("689003", "Voronovytsya", "", "UA", "804", "", "23", "", "", "49.10954", "28.68078", "Europe/Kiev"),("689106", "Volovets", "", "UA", "804", "UA", "25", "", "", "48.7109", "23.1851", "Europe/Uzhgorod"),("689157", "Volodarka", "", "UA", "804", "", "13", "", "", "49.52484", "29.91222", "Europe/Kiev"),("689190", "Vil’ne", "", "UA", "804", "", "04", "", "", "47.63645", "34.81387", "Europe/Kiev"),("689198", "Volnovakha", "Волноваха", "UA", "804", "", "05", "", "", "47.60103", "37.49674", "Europe/Kiev"),("689304", "Vovchans’k", "Вовчанськ", "UA", "804", "", "07", "", "", "50.29078", "36.94108", "Europe/Kiev"),("689321", "Vodyane", "", "UA", "804", "", "26", "", "", "47.48746", "34.49235", "Europe/Zaporozhye"),("689378", "Volodymyr-Volyns’kyy", "Владимир-Волынский", "UA", "804", "", "24", "", "", "50.85253", "24.32364", "Europe/Kiev"),("689428", "Volodymyrets’", "", "UA", "804", "", "19", "", "", "51.4213", "26.14469", "Europe/Kiev"),("689487", "Vyshneve", "Вишневе", "UA", "804", "", "13", "", "", "50.38913", "30.3705", "Europe/Kiev"),("689558", "Vinnytsya", "Винница", "UA", "804", "", "23", "", "", "49.23278", "28.48097", "Europe/Kiev"),("689595", "Vilino", "", "UA", "804", "", "11", "712968", "11152804", "44.8456", "33.67161", "Europe/Simferopol"),("689717", "Veselynove", "", "UA", "804", "", "16", "689751", "", "47.35666", "31.23488", "Europe/Kiev"),("689736", "Vesele", "", "UA", "804", "", "26", "", "", "47.01479", "34.91504", "Europe/Zaporozhye"),("689817", "Verkhovyna", "", "UA", "804", "", "06", "", "", "48.15571", "24.79112", "Europe/Kiev"),("689868", "Verkhniy Rohachyk", "", "UA", "804", "", "08", "", "", "47.25053", "34.33797", "Europe/Kiev"),("690038", "Velyka Mykhaylivka", "", "UA", "804", "", "17", "", "", "47.07971", "29.85753", "Europe/Kiev"),("690165", "Velyki Kopani", "", "UA", "804", "", "08", "", "", "46.48684", "32.97498", "Europe/Kiev"),("690197", "Velykyi Bereznyi", "", "UA", "804", "UA", "25", "", "", "48.88831", "22.46052", "Europe/Uzhgorod"),("690230", "Velyka Pysarivka", "", "UA", "804", "", "21", "", "", "50.4243", "35.47989", "Europe/Kiev"),("690247", "Velyka Lepetykha", "", "UA", "804", "", "08", "", "", "47.17572", "33.94362", "Europe/Kiev"),("690285", "Velyka Bahachka", "", "UA", "804", "", "18", "", "", "49.79116", "33.72258", "Europe/Kiev"),("690288", "Velyka Oleksandrivka", "", "UA", "804", "", "08", "", "", "47.31969", "33.30373", "Europe/Kiev"),("690312", "Vatutine", "Ватутіне", "UA", "804", "", "01", "", "", "49.01502", "31.06211", "Europe/Kiev"),("690335", "Vasyshcheve", "", "UA", "804", "", "07", "", "", "49.82852", "36.32691", "Europe/Kiev"),("690412", "Vasylkiv", "Васильков", "UA", "804", "", "13", "Vasylkiv Raion (undefined)", "", "50.18693", "30.31346", "Europe/Kiev"),("690428", "Vashkivtsi", "", "UA", "804", "", "03", "", "", "48.38491", "25.51023", "Europe/Kiev"),("690469", "Varva", "", "UA", "804", "", "02", "", "", "50.49503", "32.71968", "Europe/Kiev"),("690485", "Vapnyarka", "", "UA", "804", "", "23", "", "", "48.53479", "28.74358", "Europe/Kiev"),("690509", "Valky", "", "UA", "804", "", "07", "", "", "49.83597", "35.61223", "Europe/Kiev"),("690545", "Uzyn", "", "UA", "804", "", "13", "", "", "49.82619", "30.41487", "Europe/Kiev"),("690548", "Uzhhorod", "Ужгород", "UA", "804", "", "25", "690549", "", "48.61667", "22.3", "Europe/Uzhgorod"),("690629", "Uspenka", "", "UA", "804", "", "14", "", "", "48.39077", "39.16284", "Europe/Zaporozhye"),("690648", "Usatove", "", "UA", "804", "", "17", "", "", "46.53296", "30.6596", "Europe/Kiev"),("690688", "Uman’", "Умань", "UA", "804", "", "01", "", "", "48.74838", "30.22184", "Europe/Kiev"),("690773", "Ukrainka", "", "UA", "804", "", "13", "", "", "50.14317", "30.74612", "Europe/Kiev"),("690822", "Vuhlehirs’k", "", "UA", "804", "", "05", "", "", "48.31474", "38.27423", "Europe/Kiev"),("690873", "Tysmenytsya", "", "UA", "804", "", "06", "", "", "48.90219", "24.84482", "Europe/Kiev"),("690906", "Tyachiv", "", "UA", "804", "", "25", "", "", "48.01179", "23.57061", "Europe/Uzhgorod"),("690960", "Turka", "", "UA", "804", "", "15", "", "", "49.15411", "23.02967", "Europe/Kiev"),("690985", "Turbiv", "", "UA", "804", "", "23", "", "", "49.34788", "28.72117", "Europe/Kiev"),("691016", "Tul’chyn", "Тульчин", "UA", "804", "", "23", "", "", "48.67448", "28.84641", "Europe/Kiev"),("691037", "Tsyurupyns’k", "Цюрупинск", "UA", "804", "", "08", "", "", "46.61842", "32.7189", "Europe/Kiev"),("691155", "Tsarychanka", "", "UA", "804", "", "04", "", "", "48.93697", "34.4786", "Europe/Kiev"),("691179", "Truskavets’", "Трускавец", "UA", "804", "", "15", "", "", "49.27837", "23.50618", "Europe/Kiev"),("691255", "Trostyanets’", "", "UA", "804", "", "21", "", "", "50.48478", "34.96567", "Europe/Kiev"),("691336", "Trebukhiv", "", "UA", "804", "", "13", "", "", "50.48432", "30.90304", "Europe/Kiev"),("691374", "Torez", "Торез", "UA", "804", "", "05", "", "", "48.03876", "38.59685", "Europe/Kiev"),("691435", "Tomakivka", "", "UA", "804", "", "04", "", "", "47.81569", "34.74137", "Europe/Kiev"),("691469", "Tokmak", "Токмак", "UA", "804", "", "26", "", "", "47.25522", "35.71238", "Europe/Zaporozhye"),("691578", "Tetiyiv", "", "UA", "804", "", "13", "", "", "49.3767", "29.66474", "Europe/Kiev"),("691650", "Ternopil’", "Тернополь", "UA", "804", "", "22", "", "", "49.55589", "25.60556", "Europe/Kiev"),("691693", "Terebovlya", "", "UA", "804", "", "22", "", "", "49.30187", "25.70997", "Europe/Kiev"),("691708", "Teplyk", "", "UA", "804", "", "23", "", "", "48.66566", "29.74504", "Europe/Kiev"),("691803", "Tatarbunary", "", "UA", "804", "", "17", "691804", "", "45.83731", "29.61424", "Europe/Kiev"),("691820", "Tarutyne", "", "UA", "804", "", "17", "", "", "46.18636", "29.15203", "Europe/Kiev"),("691904", "Tarashcha", "", "UA", "804", "", "13", "", "", "49.55832", "30.49259", "Europe/Kiev"),("691936", "Tal’ne", "Тальное", "UA", "804", "", "01", "", "", "48.88877", "30.69482", "Europe/Kiev"),("691942", "Talalayivka", "", "UA", "804", "", "02", "", "", "50.95783", "31.92085", "Europe/Kiev"),("691999", "Syevyerodonets’k", "Северодонецк", "UA", "804", "", "14", "", "", "48.94832", "38.49166", "Europe/Zaporozhye"),("692087", "Svitlovods’k", "Светловодск", "UA", "804", "", "10", "", "", "49.04894", "33.24106", "Europe/Kiev"),("692093", "Svetlodarsk", "", "UA", "804", "", "05", "", "", "48.43374", "38.22331", "Europe/Kiev"),("692105", "Sverdlovs’k", "Свердловск", "UA", "804", "", "14", "", "", "48.08964", "39.65243", "Europe/Zaporozhye"),("692118", "Svatove", "Сватове", "UA", "804", "", "14", "", "", "49.41029", "38.15035", "Europe/Zaporozhye"),("692129", "Svalyava", "Свалява", "UA", "804", "", "25", "", "", "48.54853", "22.99578", "Europe/Uzhgorod"),("692146", "Sutysky", "", "UA", "804", "", "23", "", "", "49.04245", "28.41733", "Europe/Kiev"),("692194", "Sumy", "Сумы", "UA", "804", "", "21", "", "", "50.9216", "34.80029", "Europe/Kiev"),("692301", "Sudova Vyshnya", "", "UA", "804", "", "15", "", "", "49.78892", "23.37218", "Europe/Kiev"),("692315", "Sudak", "", "UA", "804", "", "11", "692311", "", "44.84924", "34.97471", "Europe/Simferopol"),("692372", "Stryi", "Стрый", "UA", "804", "", "15", "", "", "49.26223", "23.85609", "Europe/Kiev"),("692632", "Stebnyk", "Стебник", "UA", "804", "", "15", "", "", "49.29416", "23.56357", "Europe/Kiev"),("692672", "Stavyshche", "", "UA", "804", "", "13", "", "", "50.40051", "29.52796", "Europe/Kiev"),("692702", "Staryy Sambir", "", "UA", "804", "", "15", "", "", "49.43856", "23.00056", "Europe/Kiev"),("692713", "Staryy Krym", "", "UA", "804", "", "05", "", "", "47.16146", "37.48934", "Europe/Kiev"),("692714", "Stary Krym", "", "UA", "804", "", "11", "705800", "11152875", "45.02887", "35.09174", "Europe/Simferopol"),("692742", "Stari Kuty", "", "UA", "804", "", "06", "", "", "48.27093", "25.17293", "Europe/Kiev"),("692818", "Starokostyantyniv", "Старокостянтинів", "UA", "804", "", "09", "", "", "49.75764", "27.20342", "Europe/Kiev"),("692819", "Starokozache", "", "UA", "804", "", "17", "", "", "46.33722", "29.98528", "Europe/Kiev"),("692829", "Starobesheve", "", "UA", "804", "", "05", "", "", "47.75038", "38.03051", "Europe/Kiev"),("692832", "Starobil’s’k", "Старобельск", "UA", "804", "", "14", "", "", "49.27832", "38.91069", "Europe/Zaporozhye"),("692856", "Stara Vyzhivka", "", "UA", "804", "", "24", "", "", "51.43762", "24.43997", "Europe/Kiev"),("692866", "Stara Synyava", "", "UA", "804", "", "09", "", "", "49.60318", "27.61909", "Europe/Kiev"),("692953", "Stanytsya Luhans’ka", "", "UA", "804", "", "14", "", "", "48.65433", "39.47943", "Europe/Zaporozhye"),("692975", "Stakhanov", "Стаханов", "UA", "804", "", "14", "", "", "48.56818", "38.64352", "Europe/Zaporozhye"),("693001", "Serednye Vodyane", "", "UA", "804", "", "25", "", "", "47.98159", "23.91041", "Europe/Uzhgorod"),("693062", "Sovetskiy", "", "UA", "804", "", "11", "693058", "11153116", "45.34267", "34.92463", "Europe/Simferopol"),("693100", "Sosnytsya", "", "UA", "804", "", "02", "", "", "51.52387", "32.49985", "Europe/Kiev"),("693176", "Solotvyno", "", "UA", "804", "", "25", "", "", "47.94604", "23.87035", "Europe/Uzhgorod"),("693194", "Solonytsivka", "", "UA", "804", "", "07", "", "", "49.99682", "36.03464", "Europe/Kiev"),("693231", "Solone", "", "UA", "804", "", "04", "", "", "48.20805", "34.87208", "Europe/Kiev"),("693284", "Sokyryany", "", "UA", "804", "", "03", "", "", "48.44747", "27.41678", "Europe/Kiev"),("693301", "Sokal’", "Сокаль", "UA", "804", "", "15", "", "", "50.47438", "24.28288", "Europe/Kiev"),("693325", "Sofiyivka", "", "UA", "804", "", "04", "", "", "48.04865", "33.87618", "Europe/Kiev"),("693365", "Snyatyn", "", "UA", "804", "", "06", "", "", "48.44692", "25.56937", "Europe/Kiev"),("693379", "Snihurivka", "", "UA", "804", "", "16", "", "", "47.07579", "32.80516", "Europe/Kiev"),("693381", "Snizhne", "Снежное", "UA", "804", "", "05", "", "", "48.02612", "38.77225", "Europe/Kiev"),("693457", "Smila", "Смела", "UA", "804", "", "01", "", "", "49.22242", "31.88714", "Europe/Kiev"),("693468", "Sloviansk", "Славянск", "UA", "804", "UA", "05", "", "", "48.86667", "37.61667", "Europe/Kiev"),("693469", "Slov`yanoserbsk", "", "UA", "804", "", "14", "", "", "48.69779", "38.98133", "Europe/Zaporozhye"),("693581", "Slavuta", "Славута", "UA", "804", "", "09", "", "", "50.30155", "26.86506", "Europe/Kiev"),("693582", "Slavs’ke", "", "UA", "804", "", "15", "", "", "48.84734", "23.44587", "Europe/Kiev"),("693598", "Slatyne", "", "UA", "804", "", "07", "", "", "50.21041", "36.15376", "Europe/Kiev"),("693615", "Skvyra", "Сквира", "UA", "804", "", "13", "", "", "49.73177", "29.66569", "Europe/Kiev"),("693658", "Skole", "", "UA", "804", "", "15", "", "", "49.03717", "23.51346", "Europe/Kiev"),("693709", "Skadovs’k", "Скадовск", "UA", "804", "", "08", "", "", "46.1161", "32.91124", "Europe/Kiev"),("693796", "Synel’nykove", "Синельниково", "UA", "804", "", "04", "", "", "48.32044", "35.51792", "Europe/Kiev"),("693805", "Simferopol", "Симферополь", "UA", "804", "", "11", "8449684", "", "44.95719", "34.11079", "Europe/Simferopol"),("693920", "Shpola", "Шпола", "UA", "804", "", "01", "", "", "49.00687", "31.39471", "Europe/Kiev"),("693942", "Shostka", "Шостка", "UA", "804", "", "21", "", "", "51.86296", "33.4698", "Europe/Kiev"),("693995", "Shklo", "", "UA", "804", "", "15", "", "", "49.95675", "23.54408", "Europe/Kiev"),("694013", "Shyshaky", "", "UA", "804", "UA", "18", "", "", "49.88175", "34.01118", "Europe/Kiev"),("694016", "Shyryayeve", "", "UA", "804", "", "17", "694015", "", "47.38052", "30.19638", "Europe/Kiev"),("694025", "Shyroke", "", "UA", "804", "", "04", "", "", "47.69173", "33.25715", "Europe/Kiev"),("694137", "Shevchenkove", "", "UA", "804", "", "07", "", "", "49.69585", "37.17348", "Europe/Kiev"),("694152", "Shevchenkove", "", "UA", "804", "", "17", "", "", "45.55604", "29.33357", "Europe/Kiev"),("694216", "Shepetivka", "Шепетівка", "UA", "804", "", "09", "", "", "50.18545", "27.06365", "Europe/Kiev"),("694273", "Shchors", "", "UA", "804", "", "02", "", "", "51.81865", "31.94504", "Europe/Kiev"),("694278", "Shchyrets’", "", "UA", "804", "", "15", "", "", "49.65096", "23.87426", "Europe/Kiev"),("694333", "Shats’k", "", "UA", "804", "", "24", "", "", "51.50208", "23.93806", "Europe/Kiev"),("694350", "Sharhorod", "", "UA", "804", "", "23", "", "", "48.73835", "28.08497", "Europe/Kiev"),("694382", "Shakhtars’k", "Шахтерск", "UA", "804", "", "05", "", "", "48.05657", "38.43826", "Europe/Kiev"),("694392", "Shabo", "", "UA", "804", "", "17", "", "", "46.13262", "30.38595", "Europe/Kiev"),("694403", "Sivers’k", "", "UA", "804", "", "05", "", "", "48.86699", "38.10007", "Europe/Kiev"),("694423", "Sevastopol", "Севастополь", "UA", "804", "", "20", "", "", "44.58883", "33.5224", "Europe/Simferopol"),("694467", "Serhiyivka", "", "UA", "804", "", "17", "", "", "46.0272", "30.37682", "Europe/Kiev"),("694491", "Seredyna-Buda", "", "UA", "804", "", "21", "", "", "52.18903", "34.03639", "Europe/Kiev"),("694590", "Semenivka", "", "UA", "804", "", "02", "", "", "52.17827", "32.58183", "Europe/Kiev"),("694603", "Semenivka", "", "UA", "804", "", "18", "", "", "49.59031", "33.18049", "Europe/Kiev"),("694677", "Selydove", "Селидово", "UA", "804", "", "05", "", "", "48.14708", "37.30032", "Europe/Kiev"),("694725", "Shchastya", "", "UA", "804", "", "14", "", "", "48.73963", "39.2323", "Europe/Zaporozhye"),("694745", "Savran’", "", "UA", "804", "", "17", "694744", "", "48.13219", "30.08247", "Europe/Kiev"),("694752", "Savyntsi", "", "UA", "804", "", "07", "", "", "49.40257", "37.06266", "Europe/Kiev"),("694792", "Sarny", "Сарни", "UA", "804", "", "19", "", "", "51.33795", "26.60191", "Europe/Kiev"),("694812", "Sarata", "", "UA", "804", "", "17", "694810", "", "46.01966", "29.66567", "Europe/Kiev"),("694864", "Sambir", "Самбор", "UA", "804", "", "15", "", "", "49.5183", "23.19752", "Europe/Kiev"),("694910", "Saki", "Саки", "UA", "804", "", "11", "8449685", "", "45.13424", "33.59996", "Europe/Simferopol"),("694919", "Sakhnovshchyna", "", "UA", "804", "", "07", "", "", "49.15166", "35.87198", "Europe/Kiev"),("694992", "Rzhyshchiv", "", "UA", "804", "", "13", "", "", "49.96886", "31.04628", "Europe/Kiev"),("695104", "Russkaya Polyana", "", "UA", "804", "", "01", "", "", "49.417", "31.92009", "Europe/Kiev"),("695205", "Rudne", "", "UA", "804", "", "15", "", "", "49.83333", "23.9", "Europe/Kiev"),("695274", "Rubizhne", "Рубежное", "UA", "804", "", "14", "", "", "49.01229", "38.37967", "Europe/Zaporozhye"),("695320", "Rozhniv", "", "UA", "804", "", "06", "", "", "48.36597", "25.2258", "Europe/Kiev"),("695326", "Rozhyshche", "", "UA", "804", "", "24", "", "", "50.91542", "25.26906", "Europe/Kiev"),("695344", "Rozdil’na", "Раздельная", "UA", "804", "", "17", "695745", "", "46.84334", "30.07919", "Europe/Kiev"),("695365", "Rivne", "", "UA", "804", "", "10", "", "", "48.24742", "31.75432", "Europe/Kiev"),("695379", "Roven’ky", "Ровеньки", "UA", "804", "", "14", "", "", "48.08331", "39.37764", "Europe/Zaporozhye"),("695441", "Rozkishne", "", "UA", "804", "", "14", "", "", "48.48959", "39.27881", "Europe/Zaporozhye"),("695464", "Romny", "Ромни", "UA", "804", "", "21", "", "", "50.75104", "33.47471", "Europe/Kiev"),("695516", "Rokytne", "", "UA", "804", "", "19", "", "", "51.2796", "27.214", "Europe/Kiev"),("695559", "Rohatyn", "", "UA", "804", "", "06", "", "", "49.409", "24.60927", "Europe/Kiev"),("695581", "Rodyns’ke", "", "UA", "804", "", "05", "", "", "48.35199", "37.20602", "Europe/Kiev"),("695594", "Rivne", "Ровно", "UA", "804", "", "19", "", "", "50.62308", "26.22743", "Europe/Kiev"),("695643", "Reshetylivka", "", "UA", "804", "", "18", "", "", "49.56501", "34.07815", "Europe/Kiev"),("695653", "Ripky", "", "UA", "804", "", "02", "", "", "51.80105", "31.08383", "Europe/Kiev"),("695670", "Reni", "Рені", "UA", "804", "", "17", "", "", "45.45727", "28.29317", "Europe/Kiev"),("695740", "Razdol’noye", "", "UA", "804", "", "11", "695741", "11153022", "45.77083", "33.48777", "Europe/Simferopol"),("695781", "Rava-Rus’ka", "", "UA", "804", "", "15", "", "", "50.23079", "23.62825", "Europe/Kiev"),("695789", "Ratne", "", "UA", "804", "", "24", "", "", "51.6683", "24.5303", "Europe/Kiev"),("695859", "Rakhiv", "", "UA", "804", "", "25", "", "", "48.0526", "24.20089", "Europe/Uzhgorod"),("695912", "Radomyshl’", "Радомышль", "UA", "804", "", "27", "", "", "50.49613", "29.22911", "Europe/Kiev"),("695965", "Piatykhatky", "Пятихатки", "UA", "804", "UA", "04", "", "", "48.41333", "33.71056", "Europe/Kiev"),("696008", "Putyvl’", "Путивль", "UA", "804", "", "21", "", "", "51.33745", "33.87066", "Europe/Kiev"),("696032", "Pustomyty", "", "UA", "804", "", "15", "", "", "49.71532", "23.91295", "Europe/Kiev"),("696108", "Pryluky", "Прилуки", "UA", "804", "", "02", "", "", "50.59323", "32.38761", "Europe/Kiev"),("696218", "Pryvillya", "", "UA", "804", "", "14", "", "", "49.01501", "38.30457", "Europe/Zaporozhye"),("696280", "Sartana", "", "UA", "804", "", "05", "", "", "47.17436", "37.69266", "Europe/Kiev"),("696291", "Primorskiy", "", "UA", "804", "", "11", "8449683", "", "45.11904", "35.48025", "Europe/Simferopol"),("696292", "Prymors’k", "", "UA", "804", "", "26", "", "", "46.73479", "36.34425", "Europe/Zaporozhye"),("696557", "Popil'nya", "", "UA", "804", "UA", "27", "", "", "49.96652", "29.44353", "Europe/Kiev"),("696566", "Popasna", "Попасная", "UA", "804", "", "14", "", "", "48.63328", "38.37804", "Europe/Zaporozhye"),("696576", "Poninka", "", "UA", "804", "", "09", "", "", "50.18492", "27.53629", "Europe/Kiev"),("696581", "Pomichna", "", "UA", "804", "", "10", "", "", "48.24222", "31.41583", "Europe/Kiev"),("696643", "Poltava", "Полтава", "UA", "804", "", "18", "", "", "49.59373", "34.54073", "Europe/Kiev"),("696660", "Polonne", "Полонне", "UA", "804", "", "09", "", "", "50.12424", "27.51087", "Europe/Kiev"),("696677", "Polohy", "Пологи", "UA", "804", "", "26", "", "", "47.48444", "36.25361", "Europe/Zaporozhye"),("696743", "Pokotylivka", "", "UA", "804", "", "07", "", "", "49.91343", "36.17511", "Europe/Kiev"),("696771", "Pohrebyshche", "", "UA", "804", "", "23", "", "", "49.48639", "29.26361", "Europe/Kiev"),("696943", "Pidhorodne", "Підгородне", "UA", "804", "", "04", "", "", "48.57528", "35.1068", "Europe/Kiev"),("697006", "Pochayiv", "", "UA", "804", "", "22", "", "", "50.00509", "25.51183", "Europe/Kiev"),("697018", "Pobugskoye", "", "UA", "804", "", "10", "", "", "48.16579", "30.59274", "Europe/Kiev"),("697126", "Plakhtiyivka", "", "UA", "804", "", "17", "", "", "46.1006", "29.72169", "Europe/Kiev"),("697135", "Pivdenne", "", "UA", "804", "", "07", "", "", "49.88315", "36.06785", "Europe/Kiev"),("697183", "Pyryatyn", "Пирятин", "UA", "804", "", "18", "", "", "50.24242", "32.50621", "Europe/Kiev"),("697203", "Pionerskoye", "", "UA", "804", "", "11", "693803", "11152587", "44.88083", "34.20194", "Europe/Simferopol"),("697325", "Petrove", "", "UA", "804", "", "10", "", "", "48.32467", "33.25617", "Europe/Kiev"),("697396", "Petrovka", "", "UA", "804", "", "11", "704383", "11152924", "45.49776", "34.28816", "Europe/Simferopol"),("697423", "Petropavlivka", "", "UA", "804", "", "04", "", "", "48.45643", "36.4367", "Europe/Kiev"),("697489", "Piskivka", "", "UA", "804", "", "13", "", "", "50.69378", "29.61934", "Europe/Kiev"),("697568", "Pervomayskoye", "", "UA", "804", "", "11", "697572", "11152987", "45.71744", "33.85596", "Europe/Simferopol"),("697592", "Pervomays’k", "Первомайск", "UA", "804", "", "14", "", "", "48.62988", "38.54806", "Europe/Zaporozhye"),("697593", "Pervomays’k", "Первомайск", "UA", "804", "", "16", "", "", "48.04433", "30.85073", "Europe/Kiev"),("697613", "Manhush", "", "UA", "804", "", "05", "", "", "47.05582", "37.31068", "Europe/Kiev"),("697637", "Pereyaslav-Khmel’nyts’kyy", "Переяслав-Хмельницкий", "UA", "804", "", "13", "", "", "50.06739", "31.44969", "Europe/Kiev"),("697650", "Pereval’s’k", "Перевальск", "UA", "804", "", "14", "", "", "48.43779", "38.84384", "Europe/Zaporozhye"),("697676", "Peresichna", "", "UA", "804", "", "07", "", "", "50.02452", "35.97871", "Europe/Kiev"),("697692", "Peremyshlyany", "", "UA", "804", "", "15", "", "", "49.66523", "24.55846", "Europe/Kiev"),("697750", "Perechyn", "", "UA", "804", "", "25", "", "", "48.73616", "22.482", "Europe/Uzhgorod"),("697802", "Pechenizhyn", "", "UA", "804", "", "06", "", "", "48.51551", "24.89423", "Europe/Kiev"),("697889", "Pavlohrad", "Павлоград", "UA", "804", "", "04", "", "", "48.53426", "35.87098", "Europe/Kiev"),("698003", "Panyutyne", "", "UA", "804", "", "07", "", "", "48.93692", "36.27563", "Europe/Kiev"),("698102", "Ozerne", "", "UA", "804", "", "27", "", "", "50.17816", "28.73384", "Europe/Kiev"),("698107", "Ozerne", "", "UA", "804", "", "17", "", "", "45.403", "28.67546", "Europe/Kiev"),("698131", "Ovruch", "Овруч", "UA", "804", "", "27", "", "", "51.3246", "28.80351", "Europe/Kiev"),("698138", "Ovidiopol’", "", "UA", "804", "", "17", "698136", "", "46.24998", "30.44127", "Europe/Kiev"),("698142", "Otyniya", "", "UA", "804", "", "06", "", "", "48.73767", "24.86111", "Europe/Kiev"),("698232", "Ostroh", "", "UA", "804", "", "19", "", "", "50.32942", "26.51425", "Europe/Kiev"),("698247", "Oster", "", "UA", "804", "", "02", "", "", "50.9506", "30.88229", "Europe/Kiev"),("698428", "Orikhiv", "Оріхів", "UA", "804", "", "26", "", "", "47.56731", "35.78575", "Europe/Zaporozhye"),("698462", "Oposhnya", "", "UA", "804", "", "18", "", "", "49.95652", "34.61226", "Europe/Kiev"),("698625", "Oleksandriya", "Александрия", "UA", "804", "", "10", "", "", "48.66961", "33.11593", "Europe/Kiev"),("698627", "Oleksandrivka", "", "UA", "804", "", "10", "", "", "48.96336", "32.23492", "Europe/Kiev"),("698652", "Oktyabr’skoye", "", "UA", "804", "", "11", "704383", "11152923", "45.28866", "34.13521", "Europe/Simferopol"),("698740", "Odessa", "Одесса", "UA", "804", "", "17", "", "", "46.47747", "30.73262", "Europe/Kiev"),("698770", "Ochakiv", "Очаков", "UA", "804", "", "16", "", "", "46.61283", "31.54982", "Europe/Kiev"),("698782", "Obukhiv", "Обухов", "UA", "804", "", "13", "Obukhiv Raion (undefined)", "", "50.10689", "30.61848", "Europe/Kiev"),("698861", "Novyy Svit", "", "UA", "804", "", "05", "", "", "47.80591", "38.02112", "Europe/Kiev"),("698927", "Novi Sanzhary", "", "UA", "804", "", "18", "", "", "49.34395", "34.31084", "Europe/Kiev"),("698929", "Novi Petrivtsi", "", "UA", "804", "", "13", "Vyshhorod Raion (undefined)", "", "50.62754", "30.4431", "Europe/Kiev"),("698953", "Novyy Buh", "Новий Буг", "UA", "804", "", "16", "", "", "47.69308", "32.5216", "Europe/Kiev"),("699034", "Novovorontsovka", "", "UA", "804", "", "08", "", "", "47.50035", "33.91748", "Europe/Kiev"),("699035", "Novovolyns’k", "Нововолынск", "UA", "804", "", "24", "", "", "50.72576", "24.16265", "Europe/Kiev"),("699078", "Novoukrayinka", "Новоукраїнка", "UA", "804", "", "10", "", "", "48.32635", "31.52852", "Europe/Kiev"),("699285", "Novoselytsya", "", "UA", "804", "", "03", "", "", "48.21931", "26.26531", "Europe/Kiev"),("699311", "Novopskov", "", "UA", "804", "", "14", "", "", "49.5464", "39.08987", "Europe/Zaporozhye"),("699413", "Novomykolayivka", "", "UA", "804", "", "26", "", "", "47.9781", "35.9102", "Europe/Zaporozhye"),("699445", "Novomoskovs’k", "Новомосковск", "UA", "804", "", "04", "", "", "48.63799", "35.24548", "Europe/Kiev"),("699453", "Novomyrhorod", "", "UA", "804", "", "10", "", "", "48.78105", "31.64204", "Europe/Kiev"),("699553", "Novohrad-Volyns’kyy", "Новоград-Волынский", "UA", "804", "", "27", "", "", "50.59412", "27.6165", "Europe/Kiev"),("699607", "Novofedorovka", "", "UA", "804", "", "08", "", "", "46.17128", "32.31781", "Europe/Kiev"),("699617", "Novodonets’ke", "", "UA", "804", "", "05", "", "", "48.63526", "36.98477", "Europe/Kiev"),("699620", "Novodnistrovs’k", "", "UA", "804", "", "03", "", "", "48.58641", "27.38152", "Europe/Kiev"),("699675", "Novoazovs'k", "", "UA", "804", "UA", "05", "", "", "47.11389", "38.08599", "Europe/Kiev"),("699680", "Novoarkhanhel’s’k", "", "UA", "804", "", "10", "", "", "48.65803", "30.81821", "Europe/Kiev"),("699706", "Novooleksiyivka", "", "UA", "804", "", "08", "", "", "46.22472", "34.64031", "Europe/Kiev"),("699753", "Novhorod-Sivers’kyy", "", "UA", "804", "", "02", "", "", "52.00577", "33.2615", "Europe/Kiev"),("699756", "Novhorodka", "", "UA", "804", "", "10", "", "", "48.36506", "32.65785", "Europe/Kiev"),("699777", "Nova Vodolaha", "", "UA", "804", "", "07", "", "", "49.71901", "35.86578", "Europe/Kiev"),("699802", "Nova Praha", "", "UA", "804", "", "10", "", "", "48.56821", "32.90273", "Europe/Kiev"),("699811", "Nova Odesa", "", "UA", "804", "", "16", "", "", "47.30778", "31.78506", "Europe/Kiev"),("699823", "Nova Mayachka", "", "UA", "804", "", "08", "", "", "46.59996", "33.22707", "Europe/Kiev"),("699839", "Nova Kakhovka", "Новая Каховка", "UA", "804", "", "08", "", "", "46.75451", "33.34864", "Europe/Kiev"),("699882", "Nova Borova", "", "UA", "804", "", "27", "", "", "50.69296", "28.63446", "Europe/Kiev"),("699917", "Nosivka", "Носівка", "UA", "804", "", "02", "", "", "50.93152", "31.58282", "Europe/Kiev"),("699942", "Nizhyn", "Нежин", "UA", "804", "", "02", "", "", "51.04801", "31.88688", "Europe/Kiev"),("699956", "Nyzhnya Krynka", "", "UA", "804", "", "05", "", "", "48.1135", "38.16064", "Europe/Kiev"),("699986", "Nyzhni Sirohozy", "", "UA", "804", "", "08", "", "", "46.84842", "34.38044", "Europe/Kiev"),("700019", "Nizhnegorskiy", "Нижнегорский", "UA", "804", "", "11", "700018", "11152958", "45.44789", "34.73839", "Europe/Simferopol"),("700051", "Nikopol’", "Никополь", "UA", "804", "", "04", "", "", "47.57119", "34.39637", "Europe/Kiev"),("700261", "Netishyn", "Нетішин", "UA", "804", "", "09", "", "", "50.34004", "26.64171", "Europe/Kiev"),("700322", "Nemyriv", "", "UA", "804", "", "23", "", "", "48.97076", "28.83779", "Europe/Kiev"),("700371", "Nedryhayliv", "", "UA", "804", "", "21", "", "", "50.83398", "33.87626", "Europe/Kiev"),("700507", "Nadvirna", "Надворная", "UA", "804", "", "06", "", "", "48.6348", "24.56936", "Europe/Kiev"),("700551", "Shchyolkino", "", "UA", "804", "", "11", "703233", "11128209", "45.42985", "35.8225", "Europe/Zaporozhye"),("700568", "Mykolayiv", "", "UA", "804", "", "15", "", "", "49.52372", "23.98522", "Europe/Kiev"),("700569", "Mykolayiv", "Николаев", "UA", "804", "", "16", "", "", "46.96591", "31.9974", "Europe/Kiev"),("700606", "Murovani Kurylivtsi", "", "UA", "804", "", "23", "", "", "48.72348", "27.51892", "Europe/Kiev"),("700646", "Mukacheve", "Мукачево", "UA", "804", "", "25", "", "", "48.43919", "22.71779", "Europe/Uzhgorod"),("700696", "Mostys'ka", "", "UA", "804", "UA", "15", "", "", "49.79467", "23.15077", "Europe/Kiev"),("700700", "Mospyne", "", "UA", "804", "", "05", "", "", "47.89081", "38.06395", "Europe/Kiev"),("700753", "Morshyn", "", "UA", "804", "", "15", "", "", "49.15652", "23.87232", "Europe/Kiev"),("700796", "Monastyryshche", "", "UA", "804", "", "01", "", "", "48.9909", "29.8047", "Europe/Kiev"),("700829", "Molodohvardiys’k", "Молодогвардейск", "UA", "804", "", "14", "", "", "48.34511", "39.65244", "Europe/Zaporozhye"),("700835", "Molodyozhnoye", "", "UA", "804", "", "11", "693803", "11152610", "45.00354", "34.05634", "Europe/Simferopol"),("700918", "Mohyliv-Podil’s’kyy", "Могилев-Подольский", "UA", "804", "", "23", "", "", "48.44598", "27.7982", "Europe/Kiev"),("700964", "Mlyniv", "", "UA", "804", "", "19", "", "", "50.509", "25.61675", "Europe/Kiev"),("700977", "Miusyns’k", "", "UA", "804", "", "14", "", "", "48.0775", "38.90364", "Europe/Zaporozhye"),("701031", "Myronivka", "", "UA", "804", "", "13", "", "", "49.66007", "30.98225", "Europe/Kiev"),("701075", "Myrhorod", "Миргород", "UA", "804", "", "18", "", "", "49.96854", "33.60886", "Europe/Kiev"),("701104", "Milove", "", "UA", "804", "", "14", "", "", "49.37528", "40.13222", "Europe/Zaporozhye"),("701233", "Mykhaylivka", "", "UA", "804", "", "26", "", "", "47.27235", "35.22235", "Europe/Zaporozhye"),("701294", "Chudey", "", "UA", "804", "", "03", "", "", "48.05247", "25.62208", "Europe/Kiev"),("701299", "Volovo", "", "UA", "804", "", "25", "", "", "48.52458", "23.50563", "Europe/Uzhgorod"),("701305", "Mezhova", "", "UA", "804", "", "04", "", "", "48.25318", "36.73468", "Europe/Kiev"),("701347", "Merefa", "Мерефа", "UA", "804", "", "07", "", "", "49.82302", "36.05069", "Europe/Kiev"),("701372", "Mena", "", "UA", "804", "", "02", "", "", "51.5217", "32.21568", "Europe/Kiev"),("701404", "Melitopol’", "Мелитополь", "UA", "804", "", "26", "", "", "46.84891", "35.36533", "Europe/Zaporozhye"),("701560", "Mayaky", "", "UA", "804", "", "17", "", "", "47.44083", "29.55985", "Europe/Kiev"),("701619", "Massandra", "", "UA", "804", "", "11", "8449687", "", "44.50958", "34.18817", "Europe/Simferopol"),("701768", "Marshintsy", "", "UA", "804", "", "03", "", "", "48.21751", "26.29133", "Europe/Kiev"),("701792", "Markivka", "", "UA", "804", "", "14", "", "", "49.5229", "39.57055", "Europe/Zaporozhye"),("701822", "Mariupol", "Мариуполь", "UA", "804", "", "05", "", "", "47.09514", "37.54131", "Europe/Kiev"),("701855", "Marhanets’", "Марганец", "UA", "804", "", "04", "", "", "47.63543", "34.62769", "Europe/Kiev"),("701894", "Man’kivka", "", "UA", "804", "", "01", "", "", "48.96349", "30.33366", "Europe/Kiev"),("702116", "Malyn", "Малин", "UA", "804", "", "27", "", "", "50.77233", "29.23833", "Europe/Kiev"),("702147", "Mala Vyska", "", "UA", "804", "", "10", "", "", "48.64308", "31.63657", "Europe/Kiev"),("702231", "Mala Danylivka", "", "UA", "804", "", "07", "", "", "50.06354", "36.16564", "Europe/Kiev"),("702246", "Mala Bilozerka", "", "UA", "804", "", "26", "", "", "47.24737", "34.93457", "Europe/Zaporozhye"),("702302", "Makiv", "", "UA", "804", "", "09", "", "", "48.79487", "26.69188", "Europe/Kiev"),("702320", "Makiyivka", "Макеевка", "UA", "804", "", "05", "", "", "48.04782", "37.92576", "Europe/Kiev"),("702337", "Makariv", "", "UA", "804", "", "13", "", "", "50.46408", "29.81128", "Europe/Kiev"),("702356", "Mahdalynivka", "", "UA", "804", "", "04", "", "", "48.92111", "34.91491", "Europe/Kiev"),("702417", "Lyubotyn", "Люботин", "UA", "804", "", "07", "", "", "49.94691", "35.92907", "Europe/Kiev"),("702421", "Lyuboml’", "", "UA", "804", "", "24", "", "", "51.22601", "24.03727", "Europe/Kiev"),("702459", "Lyubymivka", "", "UA", "804", "", "08", "", "", "46.81063", "33.56862", "Europe/Kiev"),("702491", "Lysyanka", "", "UA", "804", "", "01", "", "", "49.25229", "30.82946", "Europe/Kiev"),("702550", "Lviv", "Львов", "UA", "804", "", "15", "", "", "49.83826", "24.02324", "Europe/Kiev"),("702563", "Lutuhyne", "Лутугино", "UA", "804", "", "14", "", "", "48.40507", "39.22675", "Europe/Zaporozhye"),("702569", "Luts’k", "Луцк", "UA", "804", "", "24", "", "", "50.75932", "25.34244", "Europe/Kiev"),("702658", "Luhansk", "Луганск", "UA", "804", "", "14", "", "", "48.56705", "39.31706", "Europe/Zaporozhye"),("702723", "Lubny", "Лубни", "UA", "804", "", "18", "", "", "50.01625", "32.99694", "Europe/Kiev"),("702760", "Lozova", "Лозова", "UA", "804", "", "07", "", "", "48.88937", "36.31755", "Europe/Kiev"),("702774", "Lozuvatka", "", "UA", "804", "", "10", "", "", "48.0571", "33.28581", "Europe/Kiev"),("702874", "Lokhvytsya", "", "UA", "804", "", "18", "", "", "50.36776", "33.26024", "Europe/Kiev"),("702898", "Lyubashivka", "", "UA", "804", "", "17", "", "", "47.83716", "30.25976", "Europe/Kiev"),("702931", "Lityn", "", "UA", "804", "", "23", "", "", "49.32509", "28.08094", "Europe/Kiev"),("702972", "Lysychans’k", "Лисичанск", "UA", "804", "", "14", "", "", "48.90485", "38.44207", "Europe/Zaporozhye"),("703015", "Lypova Dolyna", "", "UA", "804", "", "21", "", "", "50.56428", "33.79793", "Europe/Kiev"),("703061", "Lymanske", "", "UA", "804", "", "17", "", "", "46.6557", "29.96722", "Europe/Kiev"),("703142", "Letychiv", "", "UA", "804", "", "09", "", "", "49.38263", "27.63051", "Europe/Kiev"),("703261", "Lenino", "", "UA", "804", "", "11", "703233", "11128210", "45.29857", "35.77708", "Europe/Simferopol"),("703397", "Lanivtsi", "", "UA", "804", "", "22", "", "", "49.86328", "26.09082", "Europe/Kiev"),("703410", "Lanchyn", "", "UA", "804", "", "06", "", "", "48.55781", "24.75622", "Europe/Kiev"),("703428", "Ladyzhyn", "Ладижин", "UA", "804", "", "23", "", "", "48.68496", "29.23679", "Europe/Kiev"),("703438", "Ladan", "", "UA", "804", "", "02", "", "", "50.51959", "32.58178", "Europe/Kiev"),("703448", "Kiev", "Киев", "UA", "804", "", "12", "", "", "50.45466", "30.5238", "Europe/Kiev"),("703464", "Kuznetsovs’k", "Кузнецовск", "UA", "804", "", "19", "", "", "51.68333", "25.86667", "Europe/Kiev"),("703494", "Kuybysheve", "", "UA", "804", "", "26", "", "", "47.358", "36.64908", "Europe/Zaporozhye"),("703555", "Kushuhum", "", "UA", "804", "", "26", "", "", "47.71278", "35.20917", "Europe/Zaporozhye"),("703646", "Kurakhovo", "Курахово", "UA", "804", "", "05", "", "", "47.98522", "37.2821", "Europe/Kiev"),("703656", "Kupjansk", "Купьянск", "UA", "804", "", "07", "", "", "49.71055", "37.61517", "Europe/Kiev"),("703713", "Kulykivka", "", "UA", "804", "", "02", "", "", "51.37345", "31.64661", "Europe/Kiev"),("703840", "Kryzhopil’", "", "UA", "804", "", "23", "", "", "48.38289", "28.86622", "Europe/Kiev"),("703845", "Kryvyi Rih", "Кривой Рог", "UA", "804", "", "04", "", "", "47.90966", "33.38044", "Europe/Kiev"),("704000", "Krolevets’", "Кролевец", "UA", "804", "", "21", "", "", "51.54775", "33.38475", "Europe/Kiev"),("704010", "Kryve Ozero", "", "UA", "804", "", "16", "", "", "47.95242", "30.34928", "Europe/Kiev"),("704118", "Kripens’kyy", "", "UA", "804", "", "14", "", "", "48.07709", "39.058", "Europe/Zaporozhye"),("704138", "Kreminna", "Кремінна", "UA", "804", "", "14", "", "", "49.0495", "38.21792", "Europe/Zaporozhye"),("704143", "Kremenets’", "Кременец", "UA", "804", "", "22", "", "", "50.09693", "25.72459", "Europe/Kiev"),("704147", "Kremenchuk", "Кременчуг", "UA", "804", "", "18", "", "", "49.06802", "33.42041", "Europe/Kiev"),("704202", "Krasnyy Luch", "Красный луч", "UA", "804", "", "14", "", "", "48.13954", "38.93715", "Europe/Zaporozhye"),("704204", "Krasnyy Lyman", "Красный Лиман", "UA", "804", "", "05", "", "", "48.98837", "37.80225", "Europe/Kiev"),("704277", "Krasne", "", "UA", "804", "", "15", "", "", "49.91447", "24.6134", "Europe/Kiev"),("704343", "Krasnopillya", "", "UA", "804", "", "21", "", "", "50.77458", "35.25965", "Europe/Kiev"),("704362", "Krasnoperekops’k", "Красноперекопск", "UA", "804", "", "11", "8449693", "", "45.95716", "33.7965", "Europe/Simferopol"),("704363", "Krasnopavlivka", "", "UA", "804", "", "07", "", "", "49.13643", "36.31911", "Europe/Kiev"),("704376", "Krasnokuts’k", "", "UA", "804", "", "07", "", "", "50.06602", "35.16275", "Europe/Kiev"),("704381", "Krasnogvardeyskoye", "", "UA", "804", "", "11", "704383", "11152906", "45.50271", "34.30134", "Europe/Simferopol"),("704388", "Krasnohrad", "Красноград", "UA", "804", "", "07", "", "", "49.38009", "35.44186", "Europe/Kiev"),("704402", "Krasnodon", "", "UA", "804", "", "14", "", "", "48.31245", "39.56284", "Europe/Zaporozhye"),("704403", "Krasnodon", "Краснодон", "UA", "804", "", "14", "", "", "48.29235", "39.73921", "Europe/Zaporozhye"),("704422", "Krasnoarmiys’k", "Красноармейск", "UA", "804", "", "05", "", "", "48.28198", "37.17585", "Europe/Kiev"),("704492", "Krasyliv", "Красилів", "UA", "804", "", "09", "", "", "49.65186", "26.97253", "Europe/Kiev"),("704508", "Kramators’k", "Краматорск", "UA", "804", "", "05", "", "", "48.72305", "37.55629", "Europe/Kiev"),("704525", "Kozova", "", "UA", "804", "", "22", "", "", "49.43544", "25.15086", "Europe/Kiev"),("704573", "Kozelets’", "", "UA", "804", "", "02", "", "", "50.91334", "31.1214", "Europe/Kiev"),("704608", "Kivsharivka", "Ківшарівка", "UA", "804", "", "07", "", "", "49.63096", "37.68821", "Europe/Kiev"),("704617", "Kovel’", "Ковель", "UA", "804", "", "24", "", "", "51.21526", "24.70867", "Europe/Kiev"),("704670", "Kotsyubyns’ke", "", "UA", "804", "", "12", "", "", "50.48836", "30.32957", "Europe/Kiev"),("704679", "Kotovs’k", "Котовск", "UA", "804", "", "17", "", "", "47.75305", "29.53205", "Europe/Kiev"),("704705", "Kotel’va", "", "UA", "804", "", "18", "", "", "50.06864", "34.75862", "Europe/Kiev"),("704737", "Kostopil’", "Костополь", "UA", "804", "", "19", "", "", "50.87841", "26.45192", "Europe/Kiev"),("704764", "Kosiv", "", "UA", "804", "", "06", "", "", "48.31071", "25.09575", "Europe/Kiev"),("704772", "Kosmach", "", "UA", "804", "", "06", "", "", "48.75089", "24.36731", "Europe/Kiev"),("704773", "Kosmach", "", "UA", "804", "", "06", "", "", "48.32991", "24.82052", "Europe/Kiev"),("704839", "Koryukivka", "", "UA", "804", "", "02", "", "", "51.76877", "32.24813", "Europe/Kiev"),("704858", "Korsun’-Shevchenkivs’kyy", "Корсунь-Шевченковский", "UA", "804", "", "01", "", "", "49.41894", "31.25865", "Europe/Kiev"),("704885", "Korostyshiv", "Коростишів", "UA", "804", "", "27", "", "", "50.31723", "29.0563", "Europe/Kiev"),("704901", "Korosten’", "Коростень", "UA", "804", "", "27", "", "", "50.95937", "28.63855", "Europe/Kiev"),("704915", "Korop", "", "UA", "804", "", "02", "", "", "51.56638", "32.95861", "Europe/Kiev"),("704920", "Korolevo", "", "UA", "804", "", "25", "", "", "48.15247", "23.13659", "Europe/Uzhgorod"),("704968", "Korets’", "", "UA", "804", "", "19", "", "", "50.61655", "27.16055", "Europe/Kiev"),("704972", "Koreiz", "", "UA", "804", "", "11", "8449687", "", "44.43374", "34.08516", "Europe/Simferopol"),("705016", "Kopychyntsi", "", "UA", "804", "", "22", "", "", "49.10441", "25.91026", "Europe/Kiev"),("705104", "Kostyantynivka", "Константиновка", "UA", "804", "", "05", "", "", "48.5277", "37.7069", "Europe/Kiev"),("705115", "Kostyantynivka", "", "UA", "804", "", "26", "9130026", "", "46.81673", "35.42287", "Europe/Zaporozhye"),("705135", "Konotop", "Конотоп", "UA", "804", "", "21", "", "", "51.24032", "33.20263", "Europe/Kiev"),("705183", "Komsomol’s’ke", "Комсомольское", "UA", "804", "", "07", "", "", "49.59701", "36.52618", "Europe/Kiev"),("705392", "Kolomyya", "Коломия", "UA", "804", "", "06", "705389", "", "48.53115", "25.03649", "Europe/Kiev"),("705493", "Kodyma", "", "UA", "804", "", "17", "", "", "48.09875", "29.12463", "Europe/Kiev"),("705544", "Kobelyaky", "", "UA", "804", "", "18", "", "", "49.14892", "34.19653", "Europe/Kiev"),("705560", "Knyazhichi", "", "UA", "804", "", "13", "", "", "50.46275", "30.78369", "Europe/Kiev"),("705626", "Klishkivtsi", "", "UA", "804", "", "03", "", "", "48.43161", "26.26231", "Europe/Kiev"),("705730", "Kivertsi", "Ківерці", "UA", "804", "", "24", "", "", "50.83425", "25.45821", "Europe/Kiev"),("705799", "Kirovskoye", "", "UA", "804", "", "11", "705800", "11152890", "45.22967", "35.19987", "Europe/Simferopol"),("705809", "Kirovs’k", "Кировск", "UA", "804", "", "14", "", "", "48.63751", "38.6428", "Europe/Zaporozhye"),("705812", "Kropyvnytskyi", "Кировоград", "UA", "804", "", "10", "9815237", "", "48.5132", "32.2597", "Europe/Kiev"),("705883", "Kiliya", "Килия", "UA", "804", "", "17", "705882", "", "45.45518", "29.26367", "Europe/Kiev"),("706165", "Khust", "Хуст", "UA", "804", "", "25", "", "", "48.1793", "23.29909", "Europe/Uzhgorod"),("706200", "Khrystynivka", "", "UA", "804", "", "01", "", "", "48.82488", "29.96805", "Europe/Kiev"),("706244", "Khotyn", "", "UA", "804", "", "03", "", "", "48.50693", "26.49121", "Europe/Kiev"),("706271", "Khorostkiv", "", "UA", "804", "", "22", "", "", "49.21114", "25.92165", "Europe/Kiev"),("706289", "Khorol", "", "UA", "804", "", "18", "", "", "49.78367", "33.27833", "Europe/Kiev"),("706352", "Khodoriv", "", "UA", "804", "", "15", "", "", "49.40993", "24.3047", "Europe/Kiev"),("706369", "Khmel’nyts’kyy", "Хмельницкий", "UA", "804", "", "09", "", "", "49.42161", "26.99653", "Europe/Kiev"),("706380", "Khmil’nyk", "Хмельник", "UA", "804", "", "23", "", "", "49.55979", "27.95754", "Europe/Kiev"),("706448", "Kherson", "Херсон", "UA", "804", "", "08", "", "", "46.65581", "32.6178", "Europe/Kiev"),("706466", "Khartsyz’k", "Харцызск", "UA", "804", "", "05", "", "", "48.04243", "38.14728", "Europe/Kiev"),("706483", "Kharkiv", "Харьков", "UA", "804", "", "07", "", "", "49.98081", "36.25272", "Europe/Kiev"),("706524", "Kerch", "Керчь", "UA", "804", "", "11", "8449692", "", "45.3531", "36.47429", "Europe/Simferopol"),("706546", "Kehychivka", "", "UA", "804", "", "07", "", "", "49.28656", "35.76153", "Europe/Kiev"),("706571", "Kozyatyn", "Козятин", "UA", "804", "", "23", "", "", "49.71431", "28.83385", "Europe/Kiev"),("706580", "Kazanka", "", "UA", "804", "", "16", "", "", "47.84625", "32.82177", "Europe/Kiev"),("706749", "Karlivka", "Карлівка", "UA", "804", "", "18", "", "", "49.45723", "35.12975", "Europe/Kiev"),("706757", "Soledar", "", "UA", "804", "", "05", "", "", "48.67935", "38.08902", "Europe/Kiev"),("706900", "Kaniv", "Канів", "UA", "804", "", "01", "", "", "49.75182", "31.46004", "Europe/Kiev"),("706941", "Komyshuvakha", "", "UA", "804", "", "26", "", "", "47.71598", "35.52981", "Europe/Zaporozhye"),("706945", "Komyshany", "", "UA", "804", "", "08", "", "", "46.63716", "32.50719", "Europe/Kiev"),("706950", "Kamieniec Podolski", "Каменец-Подольский", "UA", "804", "", "09", "710863", "", "48.6845", "26.58559", "Europe/Kiev"),("707025", "Kamin’-Kashyrs’kyy", "", "UA", "804", "", "24", "", "", "51.62412", "24.95864", "Europe/Kiev"),("707052", "Kamianka", "", "UA", "804", "", "01", "", "", "49.0318", "32.10396", "Europe/Kiev"),("707099", "Kalush", "Калуш", "UA", "804", "", "06", "707098", "", "49.01187", "24.37308", "Europe/Kiev"),("707127", "Kalyny", "", "UA", "804", "", "25", "", "", "48.14078", "23.8738", "Europe/Uzhgorod"),("707155", "Kalynivka", "Калиновка", "UA", "804", "", "23", "", "", "49.45389", "28.52608", "Europe/Kiev"),("707232", "Kalanchak", "", "UA", "804", "", "08", "", "", "46.25623", "33.2907", "Europe/Kiev"),("707240", "Mirnoye", "", "UA", "804", "", "11", "693803", "11152609", "44.9833", "34.0616", "Europe/Simferopol"),("707244", "Kakhovka", "Каховка", "UA", "804", "", "08", "", "", "46.81371", "33.48698", "Europe/Kiev"),("707251", "Kaharlyk", "", "UA", "804", "", "13", "", "", "49.86233", "30.82815", "Europe/Kiev"),("707292", "Izyum", "Изюм", "UA", "804", "", "07", "", "", "49.20875", "37.24849", "Europe/Kiev"),("707296", "Izyaslav", "Изяслав", "UA", "804", "", "09", "", "", "50.11947", "26.82125", "Europe/Kiev"),("707308", "Izmayil", "Измаил", "UA", "804", "", "17", "", "", "45.34929", "28.84079", "Europe/Kiev"),("707317", "Iza", "", "UA", "804", "", "25", "", "", "48.21525", "23.32867", "Europe/Uzhgorod"),("707453", "Ivanivka", "", "UA", "804", "", "08", "", "", "46.72082", "34.55298", "Europe/Kiev"),("707471", "Ivano-Frankivs’k", "Ивано-Франковск", "UA", "804", "", "06", "", "", "48.9215", "24.70972", "Europe/Kiev"),("707489", "Ivankiv", "", "UA", "804", "", "13", "", "", "50.93865", "29.89426", "Europe/Kiev"),("707559", "Irshava", "", "UA", "804", "", "25", "", "", "48.31667", "23.03846", "Europe/Uzhgorod"),("707565", "Irpin", "Ирпень", "UA", "804", "", "13", "", "", "50.52175", "30.25055", "Europe/Kiev"),("707679", "Ilovays’k", "Иловайск", "UA", "804", "", "05", "", "", "47.92498", "38.20235", "Europe/Kiev"),("707688", "Illichivs’k", "Ильичевск", "UA", "804", "", "17", "", "", "46.30495", "30.65478", "Europe/Kiev"),("707695", "Illintsi", "", "UA", "804", "", "23", "", "", "49.10479", "29.21773", "Europe/Kiev"),("707744", "Ichnya", "", "UA", "804", "", "02", "", "", "50.86258", "32.39425", "Europe/Kiev"),("707752", "Horodok", "Городок", "UA", "804", "", "09", "", "", "49.16374", "26.58394", "Europe/Kiev"),("707753", "Horlivka", "Горловка", "UA", "804", "", "05", "", "", "48.33576", "38.05325", "Europe/Kiev"),("707757", "Hlyboka", "", "UA", "804", "", "03", "", "", "48.08971", "25.92933", "Europe/Kiev"),("707758", "Hlukhiv", "Глухів", "UA", "804", "", "21", "", "", "51.67822", "33.9162", "Europe/Kiev"),("707777", "Gvardeyskoye", "", "UA", "804", "", "11", "693803", "11152586", "45.11692", "34.02188", "Europe/Simferopol"),("707840", "Husyatyn", "", "UA", "804", "", "22", "", "", "49.07263", "26.2141", "Europe/Kiev"),("707860", "Gurzuf", "", "UA", "804", "", "11", "8449687", "", "44.54624", "34.27841", "Europe/Simferopol"),("707898", "Hulyaypole", "Гуляйполе", "UA", "804", "", "26", "", "", "47.66389", "36.25633", "Europe/Zaporozhye"),("707928", "Hubynykha", "", "UA", "804", "", "04", "", "", "48.8098", "35.25602", "Europe/Kiev"),("708140", "Gresovskiy", "", "UA", "804", "", "11", "8449684", "", "45.00804", "34.02657", "Europe/Simferopol"),("708181", "Hrebinka", "", "UA", "804", "", "18", "", "", "50.11712", "32.4361", "Europe/Kiev"),("708210", "Hradyz’k", "", "UA", "804", "", "18", "", "", "49.23458", "33.13613", "Europe/Kiev"),("708251", "Hostomel’", "", "UA", "804", "", "13", "", "", "50.56841", "30.2651", "Europe/Kiev"),("708257", "Hoshcha", "", "UA", "804", "", "19", "", "", "50.6003", "26.67435", "Europe/Kiev"),("708273", "Hirs’ke", "", "UA", "804", "", "14", "", "", "48.73468", "38.49541", "Europe/Zaporozhye"),("708313", "Horodok", "Городок", "UA", "804", "", "15", "", "", "49.78465", "23.64806", "Europe/Kiev"),("708320", "Horodnya", "", "UA", "804", "", "02", "", "", "51.89085", "31.59741", "Europe/Kiev"),("708324", "Horodnytsya", "", "UA", "804", "", "27", "", "", "50.80697", "27.31676", "Europe/Kiev"),("708366", "Horodyshche", "Городище", "UA", "804", "", "01", "", "", "49.28489", "31.44513", "Europe/Kiev"),("708380", "Horodenka", "", "UA", "804", "", "06", "", "", "48.67274", "25.50163", "Europe/Kiev"),("708403", "Hornostayivka", "", "UA", "804", "", "08", "", "", "47.00777", "33.72899", "Europe/Kiev"),("708632", "Hola Prystan’", "Голая Пристань", "UA", "804", "", "08", "", "", "46.52719", "32.52417", "Europe/Kiev"),("708695", "Hnidyn", "", "UA", "804", "", "13", "", "", "50.32899", "30.71059", "Europe/Kiev"),("708753", "Hlobyne", "", "UA", "804", "", "18", "", "", "49.38784", "33.25959", "Europe/Kiev"),("708784", "Hlevakha", "", "UA", "804", "", "13", "", "", "50.27423", "30.32706", "Europe/Kiev"),("708878", "Heniches’k", "Геническ", "UA", "804", "", "08", "", "", "46.17592", "34.8034", "Europe/Kiev"),("708898", "Hayvoron", "Гайворон", "UA", "804", "", "10", "", "", "48.33958", "29.86791", "Europe/Kiev"),("708901", "Haysyn", "Гайсин", "UA", "804", "", "23", "", "", "48.81143", "29.38977", "Europe/Kiev"),("708953", "Gaspra", "", "UA", "804", "", "11", "8449687", "", "44.43364", "34.10297", "Europe/Simferopol"),("709034", "Halych", "", "UA", "804", "", "06", "", "", "49.12179", "24.72578", "Europe/Kiev"),("709054", "Hadyach", "Гадяч", "UA", "804", "", "18", "", "", "50.37112", "33.99099", "Europe/Kiev"),("709071", "Frunzivka", "", "UA", "804", "", "17", "", "", "47.33232", "29.75903", "Europe/Kiev"),("709075", "Partenit", "", "UA", "804", "", "11", "8449688", "", "44.578", "34.34464", "Europe/Simferopol"),("709114", "Fontanka", "", "UA", "804", "", "17", "", "", "46.56646", "30.85965", "Europe/Kiev"),("709161", "Feodosiya", "Феодосия", "UA", "804", "", "11", "8449683", "", "45.03677", "35.37789", "Europe/Simferopol"),("709248", "Fastiv", "Фастов", "UA", "804", "", "13", "Fastiv Raion (undefined)", "", "50.0767", "29.9177", "Europe/Kiev"),("709270", "Eskhar", "", "UA", "804", "", "07", "", "", "49.79614", "36.59047", "Europe/Kiev"),("709276", "Energodar", "Энергодар", "UA", "804", "", "26", "", "", "47.49865", "34.6574", "Europe/Zaporozhye"),("709334", "Dzhankoy", "Джанкой", "UA", "804", "", "11", "8449690", "", "45.71168", "34.39274", "Europe/Simferopol"),("709354", "Dzerzhyns’k", "Дзержинськ", "UA", "804", "", "05", "", "", "48.39869", "37.84787", "Europe/Kiev"),("709373", "Dymer", "", "UA", "804", "", "13", "", "", "50.78647", "30.3026", "Europe/Kiev"),("709429", "Dunaivtsi", "Дунаївці", "UA", "804", "", "09", "", "", "48.88909", "26.85636", "Europe/Kiev"),("709493", "Dubrovytsya", "", "UA", "804", "", "19", "", "", "51.57438", "26.56503", "Europe/Kiev"),("709516", "Dubove", "", "UA", "804", "", "25", "", "", "48.17205", "23.88954", "Europe/Uzhgorod"),("709540", "Dubno", "Дубно", "UA", "804", "", "19", "", "", "50.41694", "25.73432", "Europe/Kiev"),("709546", "Dublyany", "", "UA", "804", "", "15", "", "", "49.90411", "24.08637", "Europe/Kiev"),("709584", "Druzhba", "", "UA", "804", "", "21", "", "", "52.04545", "33.94517", "Europe/Kiev"),("709611", "Drohobych", "Дрогобич", "UA", "804", "", "15", "", "", "49.34991", "23.50561", "Europe/Kiev"),("709643", "Drabiv", "", "UA", "804", "", "01", "", "", "49.96029", "32.1407", "Europe/Kiev"),("709717", "Donetsk", "Донецк", "UA", "804", "", "05", "", "", "48.023", "37.80224", "Europe/Kiev"),("709740", "Domanivka", "", "UA", "804", "", "16", "", "", "47.63192", "30.98851", "Europe/Kiev"),("709755", "Dolyna", "Долина", "UA", "804", "", "06", "709779", "", "48.9733", "24.00944", "Europe/Kiev"),("709782", "Dolyns'ka", "Долинская", "UA", "804", "UA", "10", "", "", "48.11041", "32.76449", "Europe/Kiev"),("709808", "Dovhe", "", "UA", "804", "", "25", "", "", "48.36527", "23.27904", "Europe/Uzhgorod"),("709835", "Dokuchayevs’k", "Докучаевск", "UA", "804", "", "05", "", "", "47.75046", "37.67936", "Europe/Kiev"),("709900", "Dobropillya", "Доброполье", "UA", "804", "", "05", "", "", "48.46147", "37.08524", "Europe/Kiev"),("709930", "Dnipro", "Днепропетровск", "UA", "804", "", "04", "", "", "48.4593", "35.03865", "Europe/Kiev"),("709932", "Dniprodzerzhyns’k", "Днепродзержинск", "UA", "804", "", "04", "", "", "48.51134", "34.6021", "Europe/Kiev"),("709960", "Dniprorudne", "Дніпрорудне", "UA", "804", "", "26", "", "", "47.38169", "34.97652", "Europe/Zaporozhye"),("710032", "Dymytrove", "", "UA", "804", "", "10", "", "", "48.60767", "32.98347", "Europe/Kiev"),("710035", "Dymytrov", "", "UA", "804", "", "05", "", "", "48.30523", "37.26091", "Europe/Kiev"),("710041", "Dykan’ka", "", "UA", "804", "", "18", "", "", "49.82501", "34.52787", "Europe/Kiev"),("710071", "Desna", "", "UA", "804", "", "02", "", "", "50.92731", "30.76048", "Europe/Kiev"),("710098", "Derhachi", "Дергачи", "UA", "804", "", "07", "", "", "50.10659", "36.12112", "Europe/Kiev"),("710129", "Derazhnya", "", "UA", "804", "", "09", "", "", "49.2692", "27.43382", "Europe/Kiev"),("710202", "Delyatyn", "", "UA", "804", "", "06", "", "", "48.52354", "24.62466", "Europe/Kiev"),("710229", "Debal’tseve", "Дебальцево", "UA", "804", "", "05", "", "", "48.34072", "38.4049", "Europe/Kiev"),("710342", "Chutove", "", "UA", "804", "", "18", "", "", "49.71043", "35.16571", "Europe/Kiev"),("710374", "Chuhuyiv", "Чугуїв", "UA", "804", "", "07", "", "", "49.83588", "36.68803", "Europe/Kiev"),("710381", "Chudniv", "", "UA", "804", "", "27", "", "", "50.05204", "28.11745", "Europe/Kiev"),("710400", "Chortkiv", "Чортков", "UA", "804", "", "22", "", "", "49.01709", "25.79804", "Europe/Kiev"),("710409", "Chop", "", "UA", "804", "", "25", "", "", "48.43198", "22.20555", "Europe/Uzhgorod"),("710454", "Chisten’koye", "", "UA", "804", "", "11", "693803", "11152624", "44.88152", "34.04716", "Europe/Simferopol"),("710463", "Chynadiyovo", "", "UA", "804", "", "25", "", "", "48.48179", "22.8217", "Europe/Uzhgorod"),("710473", "Chyhyryn", "", "UA", "804", "", "01", "", "", "49.08376", "32.65549", "Europe/Kiev"),("710548", "Chervonopartyzans’k", "Червонопартизанск", "UA", "804", "", "14", "", "", "48.07613", "39.79618", "Europe/Zaporozhye"),("710552", "Chervonohryhorivka", "", "UA", "804", "", "04", "", "", "47.62298", "34.53887", "Europe/Kiev"),("710554", "Chervonohrad", "Червоноград", "UA", "804", "", "15", "", "", "50.39105", "24.23514", "Europe/Kiev"),("710565", "Radyvyliv", "", "UA", "804", "", "19", "", "", "50.12994", "25.25576", "Europe/Kiev"),("710587", "Chervona Sloboda", "", "UA", "804", "", "01", "", "", "49.3789", "32.14643", "Europe/Kiev"),("710663", "Chernyakhiv", "", "UA", "804", "", "27", "", "", "50.45652", "28.67018", "Europe/Kiev"),("710668", "Chornukhyne", "", "UA", "804", "", "14", "", "", "48.32339", "38.52272", "Europe/Zaporozhye"),("710687", "Chernomorskoye", "", "UA", "804", "", "11", "710690", "11153132", "45.50657", "32.69776", "Europe/Simferopol"),("710715", "Chornobayivka", "", "UA", "804", "", "08", "", "", "46.69411", "32.55371", "Europe/Kiev"),("710716", "Chornobay", "", "UA", "804", "", "01", "", "", "49.66644", "32.32932", "Europe/Kiev"),("710719", "Chernivtsi", "Черновцы", "UA", "804", "", "03", "", "", "48.29149", "25.94034", "Europe/Kiev"),("710735", "Chernihiv", "Чернигов", "UA", "804", "", "02", "", "", "51.50551", "31.28487", "Europe/Kiev"),("710791", "Cherkasy", "Черкассы", "UA", "804", "", "01", "", "", "49.42854", "32.06207", "Europe/Kiev"),("710892", "Chechel’nyk", "", "UA", "804", "", "23", "", "", "48.21509", "29.36728", "Europe/Kiev"),("710915", "Chasiv Yar", "", "UA", "804", "", "05", "", "", "48.59348", "37.85724", "Europe/Kiev"),("710935", "Chaplynka", "", "UA", "804", "", "08", "", "", "46.36507", "33.54027", "Europe/Kiev"),("711105", "Bushtyno", "", "UA", "804", "", "25", "", "", "48.05121", "23.48579", "Europe/Uzhgorod"),("711116", "Buryn’", "", "UA", "804", "", "21", "", "", "51.19912", "33.83523", "Europe/Kiev"),("711134", "Burshtyn", "", "UA", "804", "", "06", "", "", "49.25867", "24.62777", "Europe/Kiev"),("711268", "Budy", "", "UA", "804", "", "07", "", "", "49.89133", "36.02096", "Europe/Kiev"),("711348", "Buchach", "", "UA", "804", "", "22", "", "", "49.06254", "25.38798", "Europe/Kiev"),("711350", "Bucha", "Буча", "UA", "804", "", "13", "", "", "50.54345", "30.21201", "Europe/Kiev"),("711359", "Bryukhovychi", "", "UA", "804", "", "15", "", "", "49.90467", "23.95969", "Europe/Kiev"),("711369", "Bryanka", "Брянка", "UA", "804", "", "14", "", "", "48.511", "38.67222", "Europe/Zaporozhye"),("711382", "Brusyliv", "", "UA", "804", "", "27", "", "", "50.28449", "29.52626", "Europe/Kiev"),("711390", "Brovary", "Бровары", "UA", "804", "", "13", "Brovary Raion (undefined)", "", "50.51809", "30.80671", "Europe/Kiev"),("711400", "Broshniv-Osada", "", "UA", "804", "", "06", "", "", "48.99621", "24.19748", "Europe/Kiev"),("711416", "Brody", "Броды", "UA", "804", "", "15", "", "", "50.08791", "25.15027", "Europe/Kiev"),("711459", "Bratslav", "", "UA", "804", "", "23", "", "", "48.82257", "28.9407", "Europe/Kiev"),("711515", "Boyarka", "Боярка", "UA", "804", "", "13", "", "", "50.31911", "30.29728", "Europe/Kiev"),("711536", "Borzna", "", "UA", "804", "", "02", "", "", "51.25464", "32.4269", "Europe/Kiev"),("711587", "Borshchiv", "", "UA", "804", "", "22", "", "", "48.80332", "26.04347", "Europe/Kiev"),("711621", "Borova", "", "UA", "804", "", "13", "", "", "50.17625", "30.10429", "Europe/Kiev"),("711623", "Borova", "", "UA", "804", "", "07", "", "", "49.3777", "37.62136", "Europe/Kiev"),("711635", "Borodyanka", "", "UA", "804", "", "13", "", "", "50.64484", "29.9201", "Europe/Kiev"),("711660", "Boryspil’", "Борисполь", "UA", "804", "", "13", "", "", "50.35269", "30.95501", "Europe/Kiev"),("711669", "Boryslav", "Борислав", "UA", "804", "", "15", "", "", "49.28672", "23.43238", "Europe/Kiev"),("711841", "Bolhrad", "Болград", "UA", "804", "", "17", "711842", "", "45.68262", "28.61487", "Europe/Kiev"),("711850", "Bolekhiv", "", "UA", "804", "", "06", "", "", "49.06607", "23.86435", "Europe/Kiev"),("711867", "Bohuslav", "Богуслав", "UA", "804", "", "13", "", "", "49.54939", "30.8744", "Europe/Kiev"),("711887", "Bohorodchany", "", "UA", "804", "", "06", "", "", "48.807", "24.53834", "Europe/Kiev"),("711894", "Bohodukhiv", "Богодухів", "UA", "804", "", "07", "", "", "50.16466", "35.52765", "Europe/Kiev"),("711999", "Bobrovytsya", "", "UA", "804", "", "02", "", "", "50.74693", "31.3948", "Europe/Kiev"),("712160", "Bilhorod-Dnistrovs’kyy", "Белгород-Днестровский", "UA", "804", "", "17", "", "", "46.1952", "30.34938", "Europe/Kiev"),("712165", "Bila Tserkva", "Белая Церковь", "UA", "804", "", "13", "", "", "49.80939", "30.11209", "Europe/Kiev"),("712200", "Bezlyudivka", "", "UA", "804", "", "07", "", "", "49.87547", "36.26539", "Europe/Kiev"),("712260", "Beryslav", "", "UA", "804", "", "08", "", "", "46.84152", "33.42838", "Europe/Kiev"),("712312", "Berezivka", "", "UA", "804", "", "17", "", "", "47.20429", "30.9078", "Europe/Kiev"),("712339", "Bereznehuvate", "", "UA", "804", "", "16", "", "", "47.30783", "32.84993", "Europe/Kiev"),("712343", "Berezna", "", "UA", "804", "", "02", "", "", "51.5716", "31.78456", "Europe/Kiev"),("712374", "Бережани", "Бережаны", "UA", "804", "", "22", "", "", "49.45", "24.93333", "Europe/Kiev"),("712423", "Berehove", "Берегово", "UA", "804", "", "25", "", "", "48.20555", "22.64418", "Europe/Uzhgorod"),("712430", "Berehomet", "", "UA", "804", "", "03", "", "", "48.17882", "25.34855", "Europe/Kiev"),("712441", "Berdychiv", "Бердичев", "UA", "804", "", "27", "", "", "49.89928", "28.60235", "Europe/Kiev"),("712451", "Berdyans’k", "Бердянск", "UA", "804", "", "26", "", "", "46.76644", "36.79872", "Europe/Zaporozhye"),("712488", "Bilyayivka", "", "UA", "804", "", "17", "712482", "", "46.48319", "30.21678", "Europe/Kiev"),("712508", "Bilozerka", "", "UA", "804", "", "08", "", "", "46.6248", "32.44251", "Europe/Kiev"),("712515", "Bile", "", "UA", "804", "", "14", "", "", "48.49523", "39.05051", "Europe/Zaporozhye"),("712521", "Bilovods'k", "", "UA", "804", "UA", "14", "", "", "49.20846", "39.58975", "Europe/Zaporozhye"),("712559", "Bilopillya", "Білопілля", "UA", "804", "", "21", "", "", "51.15016", "34.31287", "Europe/Kiev"),("712569", "Bilokurakyne", "", "UA", "804", "", "14", "", "", "49.5341", "38.73067", "Europe/Zaporozhye"),("712576", "Inkerman", "", "UA", "804", "", "20", "712927", "11153386", "44.61391", "33.6098", "Europe/Simferopol"),("712587", "Belogorsk", "Белогорск", "UA", "804", "", "11", "712585", "11152825", "45.05462", "34.60185", "Europe/Simferopol"),("712602", "Bilky", "", "UA", "804", "", "25", "", "", "48.31503", "23.13248", "Europe/Uzhgorod"),("712613", "Bilyts’ke", "", "UA", "804", "", "05", "", "", "48.40642", "37.18111", "Europe/Kiev"),("712775", "Bashtanka", "", "UA", "804", "", "16", "", "", "47.40719", "32.43868", "Europe/Kiev"),("712787", "Baryshivka", "", "UA", "804", "", "13", "", "", "50.36098", "31.32173", "Europe/Kiev"),("712794", "Barvinkove", "", "UA", "804", "", "07", "", "", "48.9097", "37.02051", "Europe/Kiev"),("712839", "Baranovka", "", "UA", "804", "", "27", "", "", "50.29691", "27.6622", "Europe/Kiev"),("712861", "Bar", "Бар", "UA", "804", "", "23", "", "", "49.07717", "27.68256", "Europe/Kiev"),("712886", "Balta", "Балта", "UA", "804", "", "17", "", "", "47.93548", "29.61982", "Europe/Kiev"),("712895", "Balky", "", "UA", "804", "", "26", "", "", "47.38336", "34.94396", "Europe/Zaporozhye"),("712926", "Balakliya", "Балаклея", "UA", "804", "", "07", "", "", "49.4627", "36.85951", "Europe/Kiev"),("712930", "Balaklava", "Балаклава", "UA", "804", "", "20", "712927", "11153385", "44.51118", "33.59942", "Europe/Simferopol"),("712967", "Bakhmach", "Бахмач", "UA", "804", "", "02", "", "", "51.18144", "32.83463", "Europe/Kiev"),("712969", "Bakhchisaray", "Бахчисарай", "UA", "804", "", "11", "712968", "11152799", "44.75525", "33.85782", "Europe/Simferopol"),("713122", "Avdiyivka", "Авдеевка", "UA", "804", "", "05", "", "", "48.13989", "37.74255", "Europe/Kiev"),("713163", "Artsyz", "Арциз", "UA", "804", "", "17", "713164", "", "45.99194", "29.41824", "Europe/Kiev"),("713174", "Artemivs’k", "Артемовск", "UA", "804", "", "05", "", "", "48.59559", "37.99987", "Europe/Kiev"),("713175", "Artemivs’k", "", "UA", "804", "", "14", "", "", "48.44061", "38.732", "Europe/Zaporozhye"),("713203", "Armyansk", "Армянск", "UA", "804", "", "11", "8449689", "", "46.10919", "33.69206", "Europe/Simferopol"),("713222", "Arbuzynka", "", "UA", "804", "", "16", "", "", "47.90972", "31.31963", "Europe/Kiev"),("713245", "Apostolove", "Апостолово", "UA", "804", "", "04", "", "", "47.66003", "33.71369", "Europe/Kiev"),("713259", "Antratsyt", "Антрацит", "UA", "804", "", "14", "", "", "48.11503", "39.09128", "Europe/Zaporozhye"),("713389", "Andrushivka", "", "UA", "804", "", "27", "", "", "50.02288", "29.02023", "Europe/Kiev"),("713504", "Amvrosiyivka", "Амвросиевка", "UA", "804", "", "05", "", "", "47.79348", "38.47768", "Europe/Kiev"),("713513", "Alushta", "Алушта", "UA", "804", "", "11", "8449688", "", "44.67728", "34.4097", "Europe/Simferopol"),("713514", "Alupka", "", "UA", "804", "", "11", "8449687", "", "44.41808", "34.04531", "Europe/Simferopol"),("713676", "Aleksandrovka", "", "UA", "804", "", "16", "", "", "46.83826", "32.76116", "Europe/Kiev"),("713716", "Alchevs’k", "Алчевск", "UA", "804", "", "14", "", "", "48.46893", "38.81669", "Europe/Zaporozhye"),("713743", "Yakymivka", "", "UA", "804", "", "26", "", "", "46.69972", "35.15916", "Europe/Zaporozhye"),("713749", "Okhtyrka", "Охтирка", "UA", "804", "", "21", "", "", "50.31036", "34.89879", "Europe/Kiev"),("793657", "Malynivka", "", "UA", "804", "", "07", "", "", "49.81667", "36.73333", "Europe/Kiev"),("860012", "Krasni Okny", "", "UA", "804", "", "17", "", "", "47.54044", "29.46001", "Europe/Kiev"),("865087", "Teplodar", "", "UA", "804", "", "17", "", "", "46.50585", "30.32521", "Europe/Kiev"),("6559559", "Komsomolsk", "Комсомольск", "UA", "804", "", "18", "", "", "49.01018", "33.63567", "Europe/Kiev"),("6930327", "Slavutych", "Славутич", "UA", "804", "", "13", "", "", "51.51964", "30.73434", "Europe/Kiev"),("7039154", "Novofedorovka", "", "UA", "804", "", "11", "694905", "11153099", "45.09473", "33.57211", "Europe/Simferopol"),("7525990", "Yuzhnoukrains'k", "Южноукраинск", "UA", "804", "", "16", "", "", "47.81777", "31.18263", "Europe/Kiev"),("8394261", "Mizhhir’ya", "", "UA", "804", "", "25", "", "", "48.51876", "23.50233", "Europe/Uzhgorod"),("8468760", "Novoyavorivs'k", "Новояворовск", "UA", "804", "", "15", "", "", "49.93023", "23.57357", "Europe/Kiev"),("8504651", "Sofiyivska Borschagivka", "", "UA", "804", "", "13", "", "", "50.41005", "30.36724", "Europe/Kiev"),("8516167", "Horenka", "", "UA", "804", "", "13", "", "", "50.55731", "30.33217", "Europe/Kiev"),("8519952", "Chabany", "", "UA", "804", "", "13", "", "", "50.34071", "30.42356", "Europe/Kiev"),("225835", "Yumbe", "", "UG", "800", "", "N", "97", "235054", "3.46506", "31.24689", "Africa/Kampala"),("225858", "Wobulenzi", "", "UG", "800", "", "C", "70", "8644176", "0.72833", "32.51222", "Africa/Kampala"),("225964", "Wakiso", "", "UG", "800", "", "C", "96", "234053", "0.40444", "32.45944", "Africa/Kampala"),("226110", "Tororo", "Тороро", "UG", "800", "", "E", "76", "7732077", "0.69299", "34.18085", "Africa/Kampala"),("226234", "Soroti", "", "UG", "800", "", "E", "95", "7732234", "1.71464", "33.61113", "Africa/Kampala"),("226267", "Sironko", "", "UG", "800", "", "E", "94", "7869959", "1.23132", "34.24773", "Africa/Kampala"),("226600", "Rukungiri", "", "UG", "800", "", "W", "93", "8644148", "-0.84111", "29.94194", "Africa/Kampala"),("226823", "Pallisa", "Паллиса", "UG", "800", "", "E", "60", "226822", "1.145", "33.70944", "Africa/Kampala"),("226853", "Paidha", "", "UG", "800", "", "N", "H7", "227147", "2.41669", "30.98551", "Africa/Kampala"),("226866", "Pader Palwo", "", "UG", "800", "", "N", "E3", "235459", "2.80056", "33.135", "Africa/Kampala"),("227528", "Nyachera", "", "UG", "800", "", "W", "59", "7732260", "-0.9", "30.41667", "Africa/Kampala"),("227592", "Ntungamo", "", "UG", "800", "", "W", "82", "7732525", "-0.88333", "29.65", "Africa/Kampala"),("227593", "Ntungamo", "", "UG", "800", "", "W", "59", "8644181", "-0.87944", "30.26417", "Africa/Kampala"),("227812", "Njeru", "", "UG", "800", "", "C", "E7", "7732075", "0.44166", "33.17917", "Africa/Kampala"),("227904", "Nebbi", "", "UG", "800", "", "N", "58", "8080237", "2.47826", "31.08893", "Africa/Kampala"),("228227", "Namasuba", "", "UG", "800", "", "C", "D9", "8644153", "0.68944", "32.42139", "Africa/Kampala"),("228418", "Nakasongola", "", "UG", "800", "", "C", "73", "234123", "1.30889", "32.45639", "Africa/Kampala"),("228853", "Mukono", "", "UG", "800", "", "C", "90", "8644169", "0.35333", "32.75528", "Africa/Kampala"),("228971", "Mubende", "", "UG", "800", "", "C", "56", "233891", "0.55849", "31.39489", "Africa/Kampala"),("229024", "Mpigi", "", "UG", "800", "", "C", "89", "7910214", "0.225", "32.31361", "Africa/Kampala"),("229059", "Moyo", "", "UG", "800", "", "N", "72", "8644132", "3.66088", "31.72474", "Africa/Kampala"),("229112", "Moroto", "", "UG", "800", "UG", "N", "88", "7732233", "2.53453", "34.66659", "Africa/Kampala"),("229139", "Mityana", "Митьяна", "UG", "800", "", "C", "D8", "8644152", "0.4175", "32.02278", "Africa/Kampala"),("229268", "Mbarara", "Мбарара", "UG", "800", "", "W", "52", "7732072", "-0.60467", "30.64851", "Africa/Kampala"),("229278", "Mbale", "Мбале", "UG", "800", "", "E", "87", "7732232", "1.08209", "34.17503", "Africa/Kampala"),("229292", "Mayuge", "", "UG", "800", "", "E", "86", "8644164", "0.45972", "33.48028", "Africa/Kampala"),("229361", "Masindi Port", "", "UG", "800", "", "W", "F7", "231597", "1.69606", "32.08608", "Africa/Kampala"),("229362", "Masindi", "Масинди", "UG", "800", "", "W", "50", "8644149", "1.67444", "31.715", "Africa/Kampala"),("229380", "Masaka", "Масаки", "UG", "800", "", "C", "71", "7732231", "-0.33379", "31.73409", "Africa/Kampala"),("229599", "Lyantonde", "", "UG", "800", "", "C", "D5", "232958", "-0.40306", "31.15722", "Africa/Kampala"),("229746", "Luwero", "", "UG", "800", "", "C", "70", "8644176", "0.84917", "32.47306", "Africa/Kampala"),("229911", "Lugazi", "", "UG", "800", "", "C", "E7", "7732075", "0.36788", "32.9376", "Africa/Kampala"),("230166", "Lira", "Лира", "UG", "800", "", "N", "47", "7732230", "2.2499", "32.89985", "Africa/Kampala"),("230256", "Kyotera", "", "UG", "800", "", "C", "61", "8644144", "-0.61556", "31.5175", "Africa/Kampala"),("230299", "Kyenjojo", "", "UG", "800", "", "W", "85", "228643", "0.63278", "30.62139", "Africa/Kampala"),("230584", "Kumi", "", "UG", "800", "", "E", "46", "7732907", "1.46083", "33.93611", "Africa/Kampala"),("230617", "Kotido", "", "UG", "800", "", "N", "45", "233117", "2.98056", "34.13306", "Africa/Kampala"),("230893", "Kitgum", "Китгум", "UG", "800", "", "N", "84", "233642", "3.27833", "32.88667", "Africa/Kampala"),("230993", "Kisoro", "", "UG", "800", "UG", "W", "43", "7874701", "-1.28538", "29.68497", "Africa/Kampala"),("231103", "Kiruhura", "", "UG", "800", "", "W", "D3", "7870011", "-0.19664", "30.84446", "Africa/Kampala"),("231139", "Kireka", "", "UG", "800", "", "C", "96", "7732385", "0.3475", "32.64917", "Africa/Kampala"),("231250", "Kilembe", "", "UG", "800", "", "W", "40", "8644173", "0.19835", "30.01302", "Africa/Kampala"),("231426", "Kigorobya", "", "UG", "800", "", "W", "31", "7732256", "1.6162", "31.3089", "Africa/Kampala"),("231550", "Kiboga", "", "UG", "800", "", "C", "42", "8644178", "0.91611", "31.77417", "Africa/Kampala"),("231617", "Kibale", "", "UG", "800", "", "W", "41", "8644139", "0.8", "31.06667", "Africa/Kampala"),("231696", "Kayunga", "", "UG", "800", "", "C", "83", "227613", "0.7025", "32.88861", "Africa/Kampala"),("232066", "Kasese", "Касесе", "UG", "800", "", "W", "40", "8644173", "0.18333", "30.08333", "Africa/Kampala"),("232235", "Kapchorwa", "", "UG", "800", "", "E", "39", "7870033", "1.40096", "34.45038", "Africa/Kampala"),("232287", "Kanungu", "", "UG", "800", "", "W", "82", "7732525", "-0.9575", "29.78972", "Africa/Kampala"),("232371", "Kamwenge", "", "UG", "800", "", "W", "81", "231608", "0.1866", "30.45393", "Africa/Kampala"),("232397", "Kamuli", "", "UG", "800", "", "E", "38", "234617", "0.94722", "33.11972", "Africa/Kampala"),("232422", "Kampala", "Кампала", "UG", "800", "", "C", "37", "8644170", "0.31628", "32.58219", "Africa/Kampala"),("232713", "Kajansi", "", "UG", "800", "", "C", "96", "234053", "0.21548", "32.53453", "Africa/Kampala"),("233070", "Kabale", "Кабале", "UG", "800", "", "W", "34", "7732229", "-1.24857", "29.98993", "Africa/Kampala"),("233114", "Jinja", "Джинджа", "UG", "800", "", "E", "33", "7732228", "0.43902", "33.20317", "Africa/Kampala"),("233275", "Iganga", "", "UG", "800", "", "E", "78", "8644168", "0.60917", "33.46861", "Africa/Kampala"),("233299", "Ibanda", "", "UG", "800", "", "W", "C8", "7732900", "-0.13398", "30.49616", "Africa/Kampala"),("233312", "Hoima", "", "UG", "800", "", "W", "31", "8644142", "1.43314", "31.35241", "Africa/Kampala"),("233346", "Gulu", "Гул", "UG", "800", "", "N", "30", "7732227", "2.77457", "32.29899", "Africa/Kampala"),("233476", "Fort Portal", "Форт-Портал", "UG", "800", "", "W", "79", "7732226", "0.66174", "30.2748", "Africa/Kampala"),("233508", "Entebbe", "Энтеббе", "UG", "800", "", "C", "96", "7732225", "0.06444", "32.44694", "Africa/Kampala"),("233725", "Byakabanda", "", "UG", "800", "", "C", "61", "8644135", "-0.7425", "31.40639", "Africa/Kampala"),("233730", "Bwizibwera", "", "UG", "800", "", "W", "52", "7732072", "-0.59167", "30.62861", "Africa/Kampala"),("233738", "Bweyogerere", "", "UG", "800", "", "C", "96", "7732385", "0.35773", "32.66332", "Africa/Kampala"),("233886", "Buwenge", "", "UG", "800", "", "E", "33", "8644143", "0.64222", "33.17444", "Africa/Kampala"),("234077", "Busia", "", "UG", "800", "", "E", "67", "8644151", "0.46588", "34.09221", "Africa/Kampala"),("234092", "Busembatia", "", "UG", "800", "", "E", "78", "234502", "0.77725", "33.62364", "Africa/Kampala"),("234178", "Bundibugyo", "", "UG", "800", "", "W", "28", "7732250", "0.71117", "30.06469", "Africa/Kampala"),("234565", "Bugiri", "", "UG", "800", "", "E", "G7", "8644167", "0.57139", "33.74167", "Africa/Kampala"),("234578", "Bugembe", "", "UG", "800", "", "E", "33", "8644138", "0.48213", "33.24065", "Africa/Kampala"),("235039", "Arua", "Аруа", "UG", "800", "", "N", "77", "7732730", "3.02013", "30.91105", "Africa/Kampala"),("235130", "Apac", "", "UG", "800", "", "N", "26", "229387", "1.97556", "32.53861", "Africa/Kampala"),("235489", "Adjumani", "", "UG", "800", "", "N", "65", "8644133", "3.37786", "31.7909", "Africa/Kampala"),("448227", "Pader", "", "UG", "800", "", "N", "E3", "235459", "3.05", "33.21667", "Africa/Kampala"),("448232", "Margherita", "", "UG", "800", "", "W", "40", "", "0.41861", "29.89111", "Africa/Kampala"),("4046255", "Bay Minette", "", "US", "840", "", "AL", "003", "", "30.88296", "-87.77305", "America/Chicago"),("4046274", "Edna", "", "US", "840", "", "TX", "239", "", "28.97859", "-96.64609", "America/Chicago"),("4046332", "Henderson", "", "US", "840", "", "TX", "401", "", "32.15322", "-94.79938", "America/Chicago"),("4046704", "Fort Hunt", "", "US", "840", "", "VA", "059", "", "38.73289", "-77.05803", "America/New_York"),("4047906", "Trinity", "", "US", "840", "", "FL", "101", "", "28.18085", "-82.68177", "America/New_York"),("4047914", "Villas", "", "US", "840", "", "FL", "071", "", "26.55035", "-81.8687", "America/New_York"),("4048023", "Bessemer", "", "US", "840", "", "AL", "073", "", "33.40178", "-86.95444", "America/Chicago"),("4048662", "Paducah", "", "US", "840", "", "KY", "145", "", "37.08339", "-88.60005", "America/Chicago"),("4048888", "Red Chute", "", "US", "840", "", "LA", "015", "", "32.55598", "-93.61323", "America/Chicago"),("4049032", "Jessup", "", "US", "840", "", "MD", "003", "", "39.14927", "-76.77525", "America/New_York"),("4049979", "Birmingham", "Бирмингем", "US", "840", "", "AL", "073", "", "33.52066", "-86.80249", "America/Chicago"),("4050006", "Delhi Hills", "", "US", "840", "", "OH", "061", "", "39.09284", "-84.61272", "America/New_York"),("4050118", "Turpin Hills", "", "US", "840", "", "OH", "061", "", "39.11006", "-84.37994", "America/New_York"),("4050356", "Lugoff", "", "US", "840", "", "SC", "055", "", "34.22737", "-80.68925", "America/New_York"),("4050880", "Buda", "", "US", "840", "", "TX", "209", "", "30.08521", "-97.84028", "America/Chicago"),("4051059", "Boaz", "", "US", "840", "", "AL", "095", "", "34.20065", "-86.16637", "America/Chicago"),("4051714", "Brewton", "", "US", "840", "", "AL", "053", "", "31.10518", "-87.07219", "America/Chicago"),("4051894", "Brook Highland", "", "US", "840", "", "AL", "117", "", "33.43566", "-86.67388", "America/Chicago"),("4052964", "Cahaba Heights", "", "US", "840", "", "AL", "073", "", "33.464", "-86.73193", "America/Chicago"),("4053050", "Calera", "", "US", "840", "", "AL", "117", "", "33.1029", "-86.7536", "America/Chicago"),("4054378", "Center Point", "", "US", "840", "", "AL", "073", "", "33.64566", "-86.6836", "America/Chicago"),("4054852", "Chelsea", "", "US", "840", "", "AL", "117", "", "33.34011", "-86.63026", "America/Chicago"),("4054996", "Chickasaw", "", "US", "840", "", "AL", "097", "", "30.7638", "-88.07472", "America/Chicago"),("4055045", "Childersburg", "", "US", "840", "", "AL", "121", "", "33.27817", "-86.35498", "America/Chicago"),("4055577", "Clanton", "", "US", "840", "", "AL", "021", "", "32.83874", "-86.62943", "America/Chicago"),("4055650", "Clay", "", "US", "840", "", "AL", "073", "", "33.7026", "-86.59971", "America/Chicago"),("4057835", "Cullman", "", "US", "840", "", "AL", "043", "", "34.17482", "-86.84361", "America/Chicago"),("4058061", "Daleville", "", "US", "840", "", "AL", "045", "", "31.31017", "-85.71299", "America/Chicago"),("4058198", "Danville", "", "US", "840", "", "AL", "103", "", "34.41454", "-87.08751", "America/Chicago"),("4058219", "Daphne", "", "US", "840", "", "AL", "003", "", "30.60353", "-87.9036", "America/Chicago"),("4058553", "Decatur", "", "US", "840", "", "AL", "103", "", "34.60593", "-86.98334", "America/Chicago"),("4058662", "Demopolis", "", "US", "840", "", "AL", "091", "", "32.51764", "-87.8364", "America/Chicago"),("4059102", "Dothan", "", "US", "840", "", "AL", "069", "", "31.22323", "-85.39049", "America/Chicago"),("4059870", "East Florence", "", "US", "840", "", "AL", "077", "", "34.80953", "-87.64947", "America/Chicago"),("4060791", "Enterprise", "", "US", "840", "", "AL", "031", "", "31.31517", "-85.85522", "America/Chicago"),("4060954", "Eufaula", "", "US", "840", "", "AL", "005", "", "31.89127", "-85.14549", "America/Chicago"),("4061206", "Fairfield", "", "US", "840", "", "AL", "073", "", "33.48594", "-86.91194", "America/Chicago"),("4061234", "Fairhope", "", "US", "840", "", "AL", "003", "", "30.52297", "-87.90333", "America/Chicago"),("4062577", "Florence", "Флоренция", "US", "840", "", "AL", "077", "", "34.79981", "-87.67725", "America/Chicago"),("4062644", "Foley", "", "US", "840", "", "AL", "003", "", "30.40659", "-87.6836", "America/Chicago"),("4062774", "Forestdale", "", "US", "840", "", "AL", "073", "", "33.57011", "-86.89638", "America/Chicago"),("4062861", "Fort Payne", "", "US", "840", "", "AL", "049", "", "34.44425", "-85.71969", "America/Chicago"),("4063570", "Fultondale", "", "US", "840", "", "AL", "073", "", "33.60483", "-86.79388", "America/Chicago"),("4063619", "Gadsden", "", "US", "840", "", "AL", "055", "", "34.01426", "-86.00664", "America/Chicago"),("4063765", "Gardendale", "", "US", "840", "", "AL", "073", "", "33.6601", "-86.81277", "America/Chicago"),("4064310", "Glencoe", "", "US", "840", "", "AL", "055", "", "33.95704", "-85.93247", "America/Chicago"),("4065029", "Grayson Valley", "", "US", "840", "", "AL", "073", "", "33.64816", "-86.63943", "America/Chicago"),("4065302", "Greenville", "", "US", "840", "", "AL", "013", "", "31.8296", "-86.61775", "America/Chicago"),("4065552", "Gulf Shores", "", "US", "840", "", "AL", "003", "", "30.24604", "-87.70082", "America/Chicago"),("4065649", "Guntersville", "", "US", "840", "", "AL", "095", "", "34.35815", "-86.2947", "America/Chicago"),("4065965", "Hamilton", "", "US", "840", "", "AL", "093", "", "34.14232", "-87.98864", "America/Chicago"),("4066449", "Hartselle", "", "US", "840", "", "AL", "103", "", "34.44343", "-86.93528", "America/Chicago"),("4066463", "Harvest", "", "US", "840", "", "AL", "089", "", "34.85564", "-86.75083", "America/Chicago"),("4066811", "Helena", "Хелена", "US", "840", "", "AL", "117", "", "33.29622", "-86.8436", "America/Chicago"),("4067927", "Homewood", "Хомвуд", "US", "840", "", "AL", "073", "", "33.47177", "-86.80082", "America/Chicago"),("4067994", "Hoover", "Гувер", "US", "840", "", "AL", "073", "", "33.40539", "-86.81138", "America/Chicago"),("4068446", "Hueytown", "", "US", "840", "", "AL", "073", "", "33.45122", "-86.99666", "America/Chicago"),("4068590", "Huntsville", "Хантсвилл", "US", "840", "", "AL", "089", "", "34.73037", "-86.5861", "America/Chicago"),("4069243", "Irondale", "", "US", "840", "", "AL", "073", "", "33.53816", "-86.70721", "America/Chicago"),("4069553", "Jacksonville", "", "US", "840", "", "AL", "015", "", "33.81371", "-85.76135", "America/Chicago"),("4069659", "Jasper", "", "US", "840", "", "AL", "127", "", "33.83122", "-87.27751", "America/Chicago"),("4071488", "Lake Purdy", "", "US", "840", "", "AL", "117", "", "33.43011", "-86.68054", "America/Chicago"),("4071763", "Lanett", "", "US", "840", "", "AL", "017", "", "32.86874", "-85.1905", "America/Chicago"),("4072130", "Leeds", "", "US", "840", "", "AL", "073", "", "33.54816", "-86.54443", "America/Chicago"),("4072767", "Lincoln", "", "US", "840", "", "AL", "121", "", "33.61316", "-86.11831", "America/Chicago"),("4074267", "Madison", "Мадисон", "US", "840", "", "AL", "089", "", "34.69926", "-86.74833", "America/Chicago"),("4075692", "Meadowbrook", "", "US", "840", "", "AL", "117", "", "33.40205", "-86.69665", "America/Chicago"),("4075854", "Meridianville", "", "US", "840", "", "AL", "089", "", "34.85148", "-86.57222", "America/Chicago"),("4075977", "Midfield", "", "US", "840", "", "AL", "073", "", "33.4615", "-86.90888", "America/Chicago"),("4076239", "Millbrook", "", "US", "840", "", "AL", "051", "", "32.47986", "-86.36192", "America/Chicago"),("4076598", "Mobile", "Мобил", "US", "840", "", "AL", "097", "", "30.69436", "-88.04305", "America/Chicago"),("4076725", "Monroeville", "", "US", "840", "", "AL", "099", "", "31.52794", "-87.32471", "America/Chicago"),("4076771", "Montevallo", "", "US", "840", "", "AL", "117", "", "33.10067", "-86.86416", "America/Chicago"),("4076784", "Montgomery", "Монтгомери", "US", "840", "", "AL", "101", "", "32.36681", "-86.29997", "America/Chicago"),("4076842", "Moody", "", "US", "840", "", "AL", "115", "", "33.59094", "-86.49082", "America/Chicago"),("4076982", "Moores Mill", "", "US", "840", "", "AL", "089", "", "34.84398", "-86.51832", "America/Chicago"),("4078646", "Mountain Brook", "", "US", "840", "", "AL", "073", "", "33.50094", "-86.75221", "America/Chicago"),("4078964", "Muscle Shoals", "", "US", "840", "", "AL", "033", "", "34.74481", "-87.66753", "America/Chicago"),("4080555", "Northport", "", "US", "840", "", "AL", "125", "", "33.22901", "-87.57723", "America/Chicago"),("4081644", "Opelika", "", "US", "840", "", "AL", "081", "", "32.64541", "-85.37828", "America/Chicago"),("4081671", "Oneonta", "", "US", "840", "", "AL", "009", "", "33.94815", "-86.47276", "America/Chicago"),("4081683", "Opp", "", "US", "840", "", "AL", "039", "", "31.28267", "-86.25551", "America/Chicago"),("4081696", "Orange Beach", "", "US", "840", "", "AL", "003", "", "30.29437", "-87.57359", "America/Chicago"),("4081914", "Oxford", "Оксфорд", "US", "840", "", "AL", "015", "", "33.61427", "-85.83496", "America/Chicago"),("4081936", "Ozark", "", "US", "840", "", "AL", "045", "", "31.45906", "-85.64049", "America/Chicago"),("4082569", "Pelham", "", "US", "840", "", "AL", "117", "", "33.28567", "-86.80999", "America/Chicago"),("4082589", "Pell City", "", "US", "840", "", "AL", "115", "", "33.58621", "-86.28609", "America/Chicago"),("4082866", "Phenix City", "", "US", "840", "", "AL", "113", "", "32.47098", "-85.00077", "America/New_York"),("4083073", "Pike Road", "", "US", "840", "", "AL", "101", "", "32.28431", "-86.10302", "America/Chicago"),("4083697", "Pinson", "", "US", "840", "", "AL", "073", "", "33.68899", "-86.68332", "America/Chicago"),("4083846", "Pleasant Grove", "", "US", "840", "", "AL", "073", "", "33.49094", "-86.97027", "America/Chicago"),("4084796", "Prattville", "", "US", "840", "", "AL", "001", "", "32.46402", "-86.4597", "America/Chicago"),("4084888", "Prichard", "Причард", "US", "840", "", "AL", "097", "", "30.7388", "-88.07889", "America/Chicago"),("4085336", "Rainbow City", "", "US", "840", "", "AL", "055", "", "33.95482", "-86.04192", "America/Chicago"),("4085373", "Rainsville", "", "US", "840", "", "AL", "049", "", "34.49425", "-85.84775", "America/Chicago"),("4086285", "Roanoke", "", "US", "840", "", "AL", "111", "", "33.15123", "-85.37217", "America/Chicago"),("4086363", "Robertsdale", "", "US", "840", "", "AL", "003", "", "30.5538", "-87.71193", "America/Chicago"),("4087313", "Russellville", "", "US", "840", "", "AL", "059", "", "34.50787", "-87.72864", "America/Chicago"),("4088146", "Saks", "", "US", "840", "", "AL", "015", "", "33.69871", "-85.83969", "America/Chicago"),("4088628", "Saraland", "", "US", "840", "", "AL", "097", "", "30.82074", "-88.07056", "America/Chicago"),("4088737", "Satsuma", "", "US", "840", "", "AL", "097", "", "30.85324", "-88.05611", "America/Chicago"),("4088916", "Scottsboro", "", "US", "840", "", "AL", "071", "", "34.67231", "-86.03415", "America/Chicago"),("4089114", "Selma", "Сельма", "US", "840", "", "AL", "047", "", "32.40736", "-87.0211", "America/Chicago"),("4089536", "Sheffield", "", "US", "840", "", "AL", "033", "", "34.76509", "-87.69864", "America/Chicago"),("4090684", "Smiths Station", "", "US", "840", "", "AL", "081", "", "32.54014", "-85.09855", "America/Chicago"),("4091058", "Southside", "", "US", "840", "", "AL", "055", "", "33.92454", "-86.02247", "America/Chicago"),("4091136", "Spanish Fort", "", "US", "840", "", "AL", "003", "", "30.67491", "-87.91527", "America/Chicago"),("4092671", "Sylacauga", "", "US", "840", "", "AL", "121", "", "33.17317", "-86.25164", "America/Chicago"),("4092788", "Talladega", "", "US", "840", "", "AL", "121", "", "33.43594", "-86.1058", "America/Chicago"),("4092970", "Tarrant", "", "US", "840", "", "AL", "073", "", "33.58344", "-86.77277", "America/Chicago"),("4093399", "Theodore", "", "US", "840", "", "AL", "097", "", "30.54769", "-88.17528", "America/Chicago"),("4093753", "Tillmans Corner", "", "US", "840", "", "AL", "097", "", "30.59019", "-88.17084", "America/Chicago"),("4094163", "Troy", "Троя", "US", "840", "", "AL", "109", "", "31.80877", "-85.96995", "America/Chicago"),("4094212", "Trussville", "", "US", "840", "", "AL", "073", "", "33.61983", "-86.60888", "America/Chicago"),("4094455", "Tuscaloosa", "Таскалуса", "US", "840", "", "AL", "125", "", "33.20984", "-87.56917", "America/Chicago"),("4094484", "Tuscumbia", "", "US", "840", "", "AL", "033", "", "34.7312", "-87.70253", "America/Chicago"),("4094490", "Tuskegee", "", "US", "840", "", "AL", "087", "", "32.42403", "-85.69162", "America/Chicago"),("4095186", "Valley", "", "US", "840", "", "AL", "017", "", "32.81874", "-85.17939", "America/Chicago"),("4095415", "Vestavia Hills", "", "US", "840", "", "AL", "073", "", "33.44872", "-86.78777", "America/Chicago"),("4097257", "Wetumpka", "", "US", "840", "", "AL", "051", "", "32.54374", "-86.21191", "America/Chicago"),("4099296", "Alma", "", "US", "840", "", "AR", "033", "", "35.47787", "-94.22188", "America/Chicago"),("4099647", "Arkadelphia", "", "US", "840", "", "AR", "019", "", "34.12093", "-93.05378", "America/Chicago"),("4100525", "Batesville", "", "US", "840", "", "AR", "063", "", "35.7698", "-91.64097", "America/Chicago"),("4100984", "Beebe", "", "US", "840", "", "AR", "145", "", "35.07064", "-91.87959", "America/Chicago"),("4101114", "Bella Vista", "", "US", "840", "", "AR", "007", "", "36.4807", "-94.27134", "America/Chicago"),("4101241", "Benton", "Бентон", "US", "840", "", "AR", "125", "", "34.56454", "-92.58683", "America/Chicago"),("4101260", "Bentonville", "Бентонвилле", "US", "840", "", "AR", "007", "", "36.37285", "-94.20882", "America/Chicago"),("4101309", "Berryville", "", "US", "840", "", "AR", "015", "", "36.36479", "-93.56797", "America/Chicago"),("4102412", "Blytheville", "Блайтвилл", "US", "840", "", "AR", "093", "", "35.9273", "-89.91898", "America/Chicago"),("4103448", "Bryant", "", "US", "840", "", "AR", "125", "", "34.59593", "-92.48905", "America/Chicago"),("4103957", "Cabot", "Кабот", "US", "840", "", "AR", "085", "", "34.97453", "-92.01653", "America/Chicago"),("4104182", "Camden", "", "US", "840", "", "AR", "103", "", "33.58456", "-92.83433", "America/Chicago"),("4105168", "Centerton", "", "US", "840", "", "AR", "007", "", "36.3598", "-94.28521", "America/Chicago"),("4105879", "Clarksville", "", "US", "840", "", "AR", "071", "", "35.47147", "-93.46657", "America/Chicago"),("4106458", "Conway", "Конвей", "US", "840", "", "AR", "045", "", "35.0887", "-92.4421", "America/Chicago"),("4107198", "Crossett", "", "US", "840", "", "AR", "003", "", "33.12818", "-91.96124", "America/Chicago"),("4107802", "De Queen", "", "US", "840", "", "AR", "133", "", "34.03789", "-94.34132", "America/Chicago"),("4109452", "East End", "", "US", "840", "", "AR", "125", "", "34.55065", "-92.34099", "America/Chicago"),("4109785", "El Dorado", "Эль-Дорадо", "US", "840", "", "AR", "139", "", "33.20763", "-92.66627", "America/Chicago"),("4110443", "Farmington", "", "US", "840", "", "AR", "143", "", "36.04202", "-94.24715", "America/Chicago"),("4110486", "Fayetteville", "Фейетвилл", "US", "840", "", "AR", "143", "", "36.06258", "-94.15743", "America/Chicago"),("4111382", "Forrest City", "Форрест-Сити", "US", "840", "", "AR", "123", "", "35.00815", "-90.78983", "America/Chicago"),("4111410", "Fort Smith", "Форт-Смит", "US", "840", "", "AR", "131", "", "35.38592", "-94.39855", "America/Chicago"),("4113067", "Greenbrier", "", "US", "840", "", "AR", "045", "", "35.23397", "-92.38765", "America/Chicago"),("4113143", "Greenwood", "", "US", "840", "", "AR", "131", "", "35.21565", "-94.25577", "America/Chicago"),("4113956", "Harrison", "", "US", "840", "", "AR", "009", "", "36.22979", "-93.10768", "America/Chicago"),("4114225", "Heber Springs", "", "US", "840", "", "AR", "023", "", "35.49147", "-92.03126", "America/Chicago"),("4114272", "Helena", "", "US", "840", "", "AR", "107", "", "34.52955", "-90.59177", "America/Chicago"),("4115181", "Hope", "", "US", "840", "", "AR", "057", "", "33.66706", "-93.59157", "America/Chicago"),("4115412", "Hot Springs", "Хот-Спрингс", "US", "840", "", "AR", "051", "", "34.5037", "-93.05518", "America/Chicago"),("4115429", "Hot Springs Village", "", "US", "840", "", "AR", "051", "", "34.67204", "-92.99879", "America/Chicago"),("4116315", "Jacksonville", "Джексонвилл", "US", "840", "", "AR", "119", "", "34.8662", "-92.11015", "America/Chicago"),("4116834", "Jonesboro", "Джонсборо", "US", "840", "", "AR", "031", "", "35.8423", "-90.70428", "America/Chicago"),("4119403", "Little Rock", "Литл-Рок", "US", "840", "", "AR", "119", "", "34.74648", "-92.28959", "America/Chicago"),("4119972", "Lowell", "", "US", "840", "", "AR", "007", "", "36.25535", "-94.13076", "America/Chicago"),("4120323", "Magnolia", "", "US", "840", "", "AR", "027", "", "33.26707", "-93.23933", "America/Chicago"),("4120388", "Malvern", "", "US", "840", "", "AR", "059", "", "34.36231", "-92.81295", "America/Chicago"),("4120524", "Marion", "", "US", "840", "", "AR", "035", "", "35.21453", "-90.19648", "America/Chicago"),("4120792", "Maumelle", "", "US", "840", "", "AR", "119", "", "34.86676", "-92.40432", "America/Chicago"),("4121297", "Mena", "", "US", "840", "", "AR", "113", "", "34.58622", "-94.23966", "America/Chicago"),("4122015", "Monticello", "", "US", "840", "", "AR", "043", "", "33.629", "-91.79096", "America/Chicago"),("4122218", "Morrilton", "", "US", "840", "", "AR", "029", "", "35.15092", "-92.74405", "America/Chicago"),("4123037", "Mountain Home", "", "US", "840", "", "AR", "005", "", "36.33534", "-92.38516", "America/Chicago"),("4123830", "Newport", "", "US", "840", "", "AR", "067", "", "35.6048", "-91.2818", "America/Chicago"),("4124112", "North Little Rock", "", "US", "840", "", "AR", "119", "", "34.76954", "-92.26709", "America/Chicago"),("4125027", "Osceola", "", "US", "840", "", "AR", "093", "", "35.70508", "-89.96953", "America/Chicago"),("4125388", "Paragould", "Парагулд", "US", "840", "", "AR", "055", "", "36.0584", "-90.49733", "America/Chicago"),("4125681", "Pea Ridge", "", "US", "840", "", "AR", "007", "", "36.45396", "-94.1152", "America/Chicago"),("4126226", "Pine Bluff", "", "US", "840", "", "AR", "069", "", "34.22843", "-92.0032", "America/Chicago"),("4126923", "Pocahontas", "", "US", "840", "", "AR", "121", "", "36.26146", "-90.97123", "America/Chicago"),("4127359", "Prairie Grove", "", "US", "840", "", "AR", "143", "", "35.97591", "-94.31771", "America/Chicago"),("4128894", "Rogers", "Роджерс", "US", "840", "", "AR", "007", "", "36.33202", "-94.11854", "America/Chicago"),("4129397", "Russellville", "", "US", "840", "", "AR", "115", "", "35.27842", "-93.13379", "America/Chicago"),("4130430", "Searcy", "Серси", "US", "840", "", "AR", "145", "", "35.25064", "-91.73625", "America/Chicago"),("4131116", "Siloam Springs", "Сайлом-Спрингс", "US", "840", "", "AR", "007", "", "36.18814", "-94.5405", "America/Chicago"),("4132093", "Springdale", "Спрингдейл", "US", "840", "", "AR", "143", "", "36.18674", "-94.12881", "America/Chicago"),("4132625", "Stuttgart", "", "US", "840", "", "AR", "001", "", "34.50037", "-91.55263", "America/Chicago"),("4133367", "Texarkana", "Тексаркана", "US", "840", "", "AR", "091", "", "33.44179", "-94.03769", "America/Chicago"),("4133933", "Trumann", "", "US", "840", "", "AR", "111", "", "35.67369", "-90.50733", "America/Chicago"),("4134716", "Van Buren", "Ван-Бьюрен", "US", "840", "", "AR", "033", "", "35.43676", "-94.34827", "America/Chicago"),("4135349", "Warren", "", "US", "840", "", "AR", "011", "", "33.61261", "-92.06458", "America/Chicago"),("4135840", "West Helena", "", "US", "840", "", "AR", "107", "", "34.55066", "-90.64177", "America/Chicago"),("4135865", "West Memphis", "", "US", "840", "", "AR", "035", "", "35.14648", "-90.18454", "America/Chicago"),("4136153", "White Hall", "", "US", "840", "", "AR", "069", "", "34.27399", "-92.09098", "America/Chicago"),("4137215", "Wynne", "", "US", "840", "", "AR", "037", "", "35.22453", "-90.78678", "America/Chicago"),("4138011", "Chevy Chase", "", "US", "840", "", "DC", "001", "", "38.964", "-77.06776", "America/New_York"),("4140963", "Washington, D.C.", "Вашингтон", "US", "840", "", "DC", "001", "", "38.89511", "-77.03637", "America/New_York"),("4141363", "Bear", "", "US", "840", "", "DE", "003", "", "39.62928", "-75.65826", "America/New_York"),("4141674", "Brookside", "", "US", "840", "", "DE", "003", "", "39.66706", "-75.72688", "America/New_York"),("4141974", "Claymont", "", "US", "840", "", "DE", "003", "", "39.80067", "-75.45964", "America/New_York"),("4142290", "Dover", "Довер", "US", "840", "", "DE", "001", "", "39.15817", "-75.52437", "America/New_York"),("4142398", "Edgemoor", "", "US", "840", "", "DE", "003", "", "39.75011", "-75.49964", "America/New_York"),("4142424", "Elsmere", "", "US", "840", "", "DE", "003", "", "39.73928", "-75.59798", "America/New_York"),("4142643", "Georgetown", "", "US", "840", "", "DE", "005", "", "38.69011", "-75.38547", "America/New_York"),("4142683", "Glasgow", "", "US", "840", "", "DE", "003", "", "39.60483", "-75.74521", "America/New_York"),("4142969", "Hockessin", "", "US", "840", "", "DE", "003", "", "39.78761", "-75.6966", "America/New_York"),("4143637", "Middletown", "", "US", "840", "", "DE", "003", "", "39.44956", "-75.71632", "America/New_York"),("4143658", "Milford", "", "US", "840", "", "DE", "005", "", "38.91261", "-75.42797", "America/New_York"),("4143834", "New Castle", "", "US", "840", "", "DE", "003", "", "39.66206", "-75.56631", "America/New_York"),("4143861", "Newark", "Ньюарк", "US", "840", "", "DE", "003", "", "39.68372", "-75.74966", "America/New_York"),("4143897", "North Star", "", "US", "840", "", "DE", "003", "", "39.76122", "-75.7191", "America/New_York"),("4144100", "Pike Creek", "", "US", "840", "", "DE", "003", "", "39.73095", "-75.7041", "America/New_York"),("4144101", "Pike Creek Valley", "", "US", "840", "", "DE", "003", "", "39.73622", "-75.69827", "America/New_York"),("4144600", "Seaford", "", "US", "840", "", "DE", "005", "", "38.64123", "-75.61104", "America/New_York"),("4144764", "Smyrna", "", "US", "840", "", "DE", "001", "", "39.29983", "-75.60465", "America/New_York"),("4145381", "Wilmington", "Уилмингтон", "US", "840", "", "DE", "003", "", "39.74595", "-75.54659", "America/New_York"),("4145395", "Wilmington Manor", "", "US", "840", "", "DE", "003", "", "39.68678", "-75.58437", "America/New_York"),("4145719", "Alachua", "", "US", "840", "", "FL", "001", "", "29.75163", "-82.42483", "America/New_York"),("4145805", "Allapattah", "", "US", "840", "", "FL", "086", "", "25.81454", "-80.22394", "America/New_York"),("4145941", "Altamonte Springs", "", "US", "840", "", "FL", "117", "", "28.66111", "-81.36562", "America/New_York"),("4146039", "Andover", "", "US", "840", "", "FL", "086", "", "25.96843", "-80.21283", "America/New_York"),("4146161", "Apollo Beach", "", "US", "840", "", "FL", "057", "", "27.77308", "-82.40759", "America/New_York"),("4146166", "Apopka", "", "US", "840", "", "FL", "095", "", "28.67617", "-81.51186", "America/New_York"),("4146206", "Arcadia", "", "US", "840", "", "FL", "027", "", "27.21588", "-81.85842", "America/New_York"),("4146302", "Asbury Lake", "", "US", "840", "", "FL", "019", "", "30.04913", "-81.82149", "America/New_York"),("4146354", "Atlantic Beach", "", "US", "840", "", "FL", "031", "", "30.33441", "-81.3987", "America/New_York"),("4146389", "Auburndale", "", "US", "840", "", "FL", "105", "", "28.0653", "-81.78869", "America/New_York"),("4146429", "Aventura", "", "US", "840", "", "FL", "086", "", "25.95648", "-80.13921", "America/New_York"),("4146440", "Avon Park", "", "US", "840", "", "FL", "055", "", "27.59587", "-81.50619", "America/New_York"),("4146464", "Azalea Park", "", "US", "840", "", "FL", "095", "", "28.54111", "-81.30062", "America/New_York"),("4146723", "Bartow", "", "US", "840", "", "FL", "105", "", "27.89641", "-81.84314", "America/New_York"),("4146823", "Bay Harbor Islands", "", "US", "840", "", "FL", "086", "", "25.88759", "-80.13116", "America/New_York"),("4146901", "Bayonet Point", "", "US", "840", "", "FL", "101", "", "28.32667", "-82.68343", "America/New_York"),("4146934", "Bayshore Gardens", "", "US", "840", "", "FL", "081", "", "27.42532", "-82.59038", "America/New_York"),("4146984", "Beacon Square", "", "US", "840", "", "FL", "101", "", "28.20862", "-82.75538", "America/New_York"),("4147145", "Bee Ridge", "", "US", "840", "", "FL", "115", "", "27.28394", "-82.48065", "America/New_York"),("4147241", "Belle Glade", "", "US", "840", "", "FL", "099", "", "26.68451", "-80.66756", "America/New_York"),("4147247", "Belle Isle", "", "US", "840", "", "FL", "095", "", "28.45834", "-81.35924", "America/New_York"),("4147290", "Bellview", "", "US", "840", "", "FL", "033", "", "30.46159", "-87.31497", "America/Chicago"),("4147581", "Beverly Hills", "", "US", "840", "", "FL", "017", "", "28.91692", "-82.45815", "America/New_York"),("4148012", "Bithlo", "", "US", "840", "", "FL", "095", "", "28.55472", "-81.10645", "America/New_York"),("4148207", "Bloomingdale", "", "US", "840", "", "FL", "057", "", "27.89364", "-82.24037", "America/New_York"),("4148399", "Boca Del Mar", "", "US", "840", "", "FL", "099", "", "26.34508", "-80.14671", "America/New_York"),("4148411", "Boca Raton", "Бока-Ратон", "US", "840", "", "FL", "099", "", "26.35869", "-80.0831", "America/New_York"),("4148533", "Bonita Springs", "", "US", "840", "", "FL", "071", "", "26.33981", "-81.7787", "America/New_York"),("4148674", "Boyette", "", "US", "840", "", "FL", "057", "", "27.81753", "-82.22259", "America/New_York"),("4148677", "Boynton Beach", "", "US", "840", "", "FL", "099", "", "26.52535", "-80.06643", "America/New_York"),("4148708", "Bradenton", "", "US", "840", "", "FL", "081", "", "27.49893", "-82.57482", "America/New_York"),("4148757", "Brandon", "Брэндон", "US", "840", "", "FL", "057", "", "27.9378", "-82.28592", "America/New_York"),("4148803", "Brent", "", "US", "840", "", "FL", "033", "", "30.46881", "-87.23608", "America/Chicago"),("4148944", "Broadview Park", "", "US", "840", "", "FL", "011", "", "26.09953", "-80.20866", "America/New_York"),("4148986", "Brooksville", "", "US", "840", "", "FL", "053", "", "28.55554", "-82.38991", "America/New_York"),("4149077", "Brownsville", "", "US", "840", "", "FL", "086", "", "25.82176", "-80.24116", "America/New_York"),("4149269", "Buenaventura Lakes", "", "US", "840", "", "FL", "097", "", "28.33584", "-81.35313", "America/New_York"),("4149635", "Callaway", "", "US", "840", "", "FL", "005", "", "30.15298", "-85.56993", "America/Chicago"),("4149956", "Cantonment", "", "US", "840", "", "FL", "033", "", "30.60853", "-87.33998", "America/Chicago"),("4149959", "Cape Canaveral", "", "US", "840", "", "FL", "009", "", "28.40584", "-80.60477", "America/New_York"),("4149962", "Cape Coral", "", "US", "840", "", "FL", "071", "", "26.56285", "-81.94953", "America/New_York"),("4150066", "Carol City", "", "US", "840", "", "FL", "086", "", "25.94065", "-80.2456", "America/New_York"),("4150115", "Carrollwood", "", "US", "840", "", "FL", "057", "", "28.05002", "-82.49287", "America/New_York"),("4150118", "Carrollwood Village", "", "US", "840", "", "FL", "057", "", "28.06752", "-82.52093", "America/New_York"),("4150190", "Casselberry", "", "US", "840", "", "FL", "117", "", "28.67778", "-81.32785", "America/New_York"),("4150394", "Celebration", "", "US", "840", "", "FL", "097", "", "28.32529", "-81.53313", "America/New_York"),("4150727", "Cheval", "", "US", "840", "", "FL", "057", "", "28.14862", "-82.51454", "America/New_York"),("4151132", "Citra", "", "US", "840", "", "FL", "083", "", "29.41192", "-82.10982", "America/New_York"),("4151153", "Citrus Hills", "", "US", "840", "", "FL", "017", "", "28.88831", "-82.4326", "America/New_York"),("4151157", "Citrus Park", "", "US", "840", "", "FL", "057", "", "28.07835", "-82.56982", "America/New_York"),("4151162", "Citrus Ridge", "", "US", "840", "", "FL", "105", "", "28.33385", "-81.64232", "America/New_York"),("4151163", "Citrus Springs", "", "US", "840", "", "FL", "017", "", "28.99748", "-82.47065", "America/New_York"),("4151316", "Clearwater", "Клируотер", "US", "840", "", "FL", "103", "", "27.96585", "-82.8001", "America/New_York"),("4151352", "Clermont", "", "US", "840", "", "FL", "069", "", "28.54944", "-81.77285", "America/New_York"),("4151366", "Clewiston", "", "US", "840", "", "FL", "051", "", "26.75423", "-80.93368", "America/New_York"),("4151440", "Cocoa", "Коко", "US", "840", "", "FL", "009", "", "28.38612", "-80.742", "America/New_York"),("4151441", "Cocoa Beach", "", "US", "840", "", "FL", "009", "", "28.32055", "-80.60922", "America/New_York"),("4151455", "Coconut Creek", "", "US", "840", "", "FL", "011", "", "26.25175", "-80.17894", "America/New_York"),("4151460", "Coconut Grove", "", "US", "840", "", "FL", "086", "", "25.7126", "-80.25699", "America/New_York"),("4151607", "Combee Settlement", "", "US", "840", "", "FL", "105", "", "28.05835", "-81.90536", "America/New_York"),("4151745", "Conway", "", "US", "840", "", "FL", "095", "", "28.50278", "-81.33062", "America/New_York"),("4151824", "Cooper City", "", "US", "840", "", "FL", "011", "", "26.05731", "-80.27172", "America/New_York"),("4151871", "Coral Gables", "", "US", "840", "", "FL", "086", "", "25.72149", "-80.26838", "America/New_York"),("4151909", "Coral Springs", "Корал-Спрингс", "US", "840", "", "FL", "011", "", "26.27119", "-80.2706", "America/New_York"),("4151921", "Coral Terrace", "", "US", "840", "", "FL", "086", "", "25.74593", "-80.3045", "America/New_York"),("4152064", "Country Walk", "", "US", "840", "", "FL", "086", "", "25.63399", "-80.43228", "America/New_York"),("4152093", "Country Club", "", "US", "840", "", "FL", "086", "", "25.94815", "-80.317", "America/New_York"),("4152311", "Crestview", "", "US", "840", "", "FL", "091", "", "30.76213", "-86.57051", "America/Chicago"),("4152472", "Crystal Lake", "", "US", "840", "", "FL", "105", "", "28.03558", "-81.90841", "America/New_York"),("4152564", "Cutler", "", "US", "840", "", "FL", "086", "", "25.6151", "-80.31061", "America/New_York"),("4152574", "Cutler Ridge", "", "US", "840", "", "FL", "086", "", "25.58066", "-80.34672", "America/New_York"),("4152628", "Cypress Gardens", "", "US", "840", "", "FL", "105", "", "27.99391", "-81.69008", "America/New_York"),("4152639", "Cypress Lake", "", "US", "840", "", "FL", "071", "", "26.53813", "-81.89925", "America/New_York"),("4152695", "Dade City", "", "US", "840", "", "FL", "101", "", "28.36472", "-82.19592", "America/New_York"),("4152772", "Dania Beach", "", "US", "840", "", "FL", "011", "", "26.05231", "-80.14393", "America/New_York"),("4152820", "Davie", "Дэви", "US", "840", "", "FL", "011", "", "26.06287", "-80.2331", "America/New_York"),("4152872", "Daytona Beach", "Дейтона-Бич", "US", "840", "", "FL", "127", "", "29.21081", "-81.02283", "America/New_York"),("4152888", "DeFuniak Springs", "", "US", "840", "", "FL", "131", "", "30.72102", "-86.11522", "America/Chicago"),("4152890", "DeLand", "", "US", "840", "", "FL", "127", "", "29.02832", "-81.30312", "America/New_York"),("4152926", "DeBary", "", "US", "840", "", "FL", "127", "", "28.88305", "-81.30868", "America/New_York"),("4153071", "Deerfield Beach", "", "US", "840", "", "FL", "011", "", "26.31841", "-80.09977", "America/New_York"),("4153132", "Delray Beach", "Делрей-Бич", "US", "840", "", "FL", "099", "", "26.46146", "-80.07282", "America/New_York"),("4153146", "Deltona", "Делтона", "US", "840", "", "FL", "127", "", "28.90054", "-81.26367", "America/New_York"),("4153188", "Destin", "", "US", "840", "", "FL", "091", "", "30.39353", "-86.49578", "America/Chicago"),("4153367", "Doctor Phillips", "", "US", "840", "", "FL", "095", "", "28.44945", "-81.49229", "America/New_York"),("4153471", "Doral", "", "US", "840", "", "FL", "086", "", "25.81954", "-80.35533", "America/New_York"),("4153759", "Dunedin", "Данедин", "US", "840", "", "FL", "103", "", "28.0199", "-82.77323", "America/New_York"),("4154008", "East Lake", "", "US", "840", "", "FL", "103", "", "28.11085", "-82.69482", "America/New_York"),("4154023", "East Milton", "", "US", "840", "", "FL", "113", "", "30.61519", "-87.02163", "America/Chicago"),("4154047", "East Pensacola Heights", "", "US", "840", "", "FL", "033", "", "30.42881", "-87.17997", "America/Chicago"),("4154051", "East Perrine", "", "US", "840", "", "FL", "086", "", "25.60872", "-80.33894", "America/New_York"),("4154205", "Edgewater", "", "US", "840", "", "FL", "127", "", "28.98888", "-80.90228", "America/New_York"),("4154270", "Eglin Village", "", "US", "840", "", "FL", "091", "", "30.46298", "-86.5394", "America/Chicago"),("4154280", "Egypt Lake-Leto", "", "US", "840", "", "FL", "057", "", "28.01769", "-82.50619", "America/New_York"),("4154336", "Elfers", "", "US", "840", "", "FL", "101", "", "28.21668", "-82.72232", "America/New_York"),("4154465", "Englewood", "", "US", "840", "", "FL", "115", "", "26.96201", "-82.3526", "America/New_York"),("4154489", "Ensley", "", "US", "840", "", "FL", "033", "", "30.51881", "-87.27275", "America/Chicago"),("4154568", "Estero", "", "US", "840", "", "FL", "071", "", "26.43814", "-81.80675", "America/New_York"),("4154606", "Eustis", "", "US", "840", "", "FL", "069", "", "28.85277", "-81.68535", "America/New_York"),("4154769", "Fairview Shores", "", "US", "840", "", "FL", "095", "", "28.59111", "-81.39424", "America/New_York"),("4154972", "Fellsmere", "", "US", "840", "", "FL", "061", "", "27.76781", "-80.60144", "America/New_York"),("4155000", "Fern Park", "", "US", "840", "", "FL", "117", "", "28.64916", "-81.35118", "America/New_York"),("4155006", "Fernandina Beach", "", "US", "840", "", "FL", "089", "", "30.66968", "-81.46259", "America/New_York"),("4155017", "Ferry Pass", "", "US", "840", "", "FL", "033", "", "30.5102", "-87.21247", "America/Chicago"),("4155430", "Fish Hawk", "", "US", "840", "", "FL", "057", "", "27.85058", "-82.21092", "America/New_York"),("4155529", "Flagami", "", "US", "840", "", "FL", "086", "", "25.76232", "-80.31616", "America/New_York"),("4155594", "Fleming Island", "", "US", "840", "", "FL", "019", "", "30.0933", "-81.71898", "America/New_York"),("4155623", "Floral City", "", "US", "840", "", "FL", "017", "", "28.74999", "-82.29676", "America/New_York"),("4155669", "Florida City", "", "US", "840", "", "FL", "086", "", "25.44789", "-80.47922", "America/New_York"),("4155726", "Florida Ridge", "", "US", "840", "", "FL", "061", "", "27.58031", "-80.38672", "America/New_York"),("4155824", "Forest City", "", "US", "840", "", "FL", "117", "", "28.66678", "-81.44334", "America/New_York"),("4155966", "Fort Lauderdale", "Форт-Лодердейл", "US", "840", "", "FL", "011", "", "26.12231", "-80.14338", "America/New_York"),("4155988", "Fort Meade", "", "US", "840", "", "FL", "105", "", "27.75225", "-81.80175", "America/New_York"),("4155995", "Fort Myers", "", "US", "840", "", "FL", "071", "", "26.62168", "-81.84059", "America/New_York"),("4155996", "Fort Myers Beach", "", "US", "840", "", "FL", "071", "", "26.45271", "-81.95011", "America/New_York"),("4156006", "Fort Myers Shores", "", "US", "840", "", "FL", "071", "", "26.70924", "-81.74592", "America/New_York"),("4156018", "Fort Pierce", "", "US", "840", "", "FL", "111", "", "27.44671", "-80.32561", "America/New_York"),("4156042", "Fort Walton Beach", "", "US", "840", "", "FL", "091", "", "30.42077", "-86.61939", "America/Chicago"),("4156091", "Fountainebleau", "", "US", "840", "", "FL", "086", "", "25.77288", "-80.34783", "America/New_York"),("4156331", "Fruit Cove", "", "US", "840", "", "FL", "109", "", "30.11107", "-81.64176", "America/New_York"),("4156340", "Fruitville", "", "US", "840", "", "FL", "115", "", "27.32977", "-82.4576", "America/New_York"),("4156367", "Fuller Heights", "", "US", "840", "", "FL", "105", "", "27.90919", "-81.99814", "America/New_York"),("4156370", "Fussels Corner", "", "US", "840", "", "FL", "105", "", "28.05419", "-81.86064", "America/New_York"),("4156404", "Gainesville", "Гейнсвилл", "US", "840", "", "FL", "001", "", "29.65163", "-82.32483", "America/New_York"),("4156601", "Gateway", "", "US", "840", "", "FL", "071", "", "26.57757", "-81.75036", "America/New_York"),("4156748", "Gibsonton", "", "US", "840", "", "FL", "057", "", "27.85364", "-82.38259", "America/New_York"),("4156752", "Gifford", "", "US", "840", "", "FL", "061", "", "27.67531", "-80.40922", "America/New_York"),("4156824", "Gladeview", "", "US", "840", "", "FL", "086", "", "25.83926", "-80.2356", "America/New_York"),("4156857", "Glenvar Heights", "", "US", "840", "", "FL", "086", "", "25.7076", "-80.32561", "America/New_York"),("4156920", "Golden Gate", "", "US", "840", "", "FL", "021", "", "26.18787", "-81.69509", "America/New_York"),("4156931", "Golden Glades", "", "US", "840", "", "FL", "086", "", "25.91176", "-80.20033", "America/New_York"),("4156959", "Goldenrod", "", "US", "840", "", "FL", "117", "", "28.61028", "-81.28868", "America/New_York"),("4156975", "Gonzalez", "", "US", "840", "", "FL", "033", "", "30.58158", "-87.29136", "America/Chicago"),("4157097", "Goulds", "", "US", "840", "", "FL", "086", "", "25.56261", "-80.38228", "America/New_York"),("4157427", "Green Cove Springs", "", "US", "840", "", "FL", "019", "", "29.99191", "-81.67815", "America/New_York"),("4157467", "Greenacres City", "", "US", "840", "", "FL", "099", "", "26.62368", "-80.12532", "America/New_York"),("4157605", "Groveland", "", "US", "840", "", "FL", "069", "", "28.55805", "-81.85119", "America/New_York"),("4157634", "Gulf Breeze", "", "US", "840", "", "FL", "113", "", "30.35714", "-87.16386", "America/Chicago"),("4157657", "Gulf Gate Estates", "", "US", "840", "", "FL", "115", "", "27.25173", "-82.51471", "America/New_York"),("4157687", "Gulfport", "", "US", "840", "", "FL", "103", "", "27.74836", "-82.70343", "America/New_York"),("4157827", "Haines City", "", "US", "840", "", "FL", "105", "", "28.1145", "-81.62009", "America/New_York"),("4157898", "Hallandale Beach", "", "US", "840", "", "FL", "011", "", "25.9812", "-80.14838", "America/New_York"),("4158296", "Heathrow", "", "US", "840", "", "FL", "117", "", "28.76333", "-81.37225", "America/New_York"),("4158445", "Hernando", "", "US", "840", "", "FL", "017", "", "28.89998", "-82.37454", "America/New_York"),("4158476", "Hialeah", "Хайалиа", "US", "840", "", "FL", "086", "", "25.8576", "-80.27811", "America/New_York"),("4158482", "Hialeah Gardens", "", "US", "840", "", "FL", "086", "", "25.8651", "-80.3245", "America/New_York"),("4158595", "High Springs", "", "US", "840", "", "FL", "001", "", "29.82691", "-82.59678", "America/New_York"),("4158604", "Highland City", "", "US", "840", "", "FL", "105", "", "27.9653", "-81.87786", "America/New_York"),("4158758", "Hobe Sound", "", "US", "840", "", "FL", "085", "", "27.0595", "-80.13643", "America/New_York"),("4158865", "Holiday", "", "US", "840", "", "FL", "101", "", "28.18779", "-82.73955", "America/New_York"),("4158914", "Holly Hill", "", "US", "840", "", "FL", "127", "", "29.24359", "-81.03756", "America/New_York"),("4158928", "Hollywood", "Голливуд", "US", "840", "", "FL", "011", "", "26.0112", "-80.14949", "America/New_York"),("4159050", "Homestead", "", "US", "840", "", "FL", "086", "", "25.46872", "-80.47756", "America/New_York"),("4159077", "Homosassa Springs", "", "US", "840", "", "FL", "017", "", "28.80359", "-82.57593", "America/New_York"),("4159335", "Hudson", "", "US", "840", "", "FL", "101", "", "28.36445", "-82.69343", "America/New_York"),("4159416", "Hunters Creek", "", "US", "840", "", "FL", "095", "", "28.36056", "-81.42229", "America/New_York"),("4159553", "Immokalee", "", "US", "840", "", "FL", "021", "", "26.41869", "-81.4173", "America/New_York"),("4159608", "Indian Harbour Beach", "", "US", "840", "", "FL", "009", "", "28.1489", "-80.58839", "America/New_York"),("4159659", "Indian River Estates", "", "US", "840", "", "FL", "111", "", "27.36449", "-80.30977", "America/New_York"),("4159687", "Indiantown", "", "US", "840", "", "FL", "085", "", "27.02728", "-80.48561", "America/New_York"),("4159786", "Inverness", "", "US", "840", "", "FL", "017", "", "28.83582", "-82.33037", "America/New_York"),("4159796", "Inwood", "", "US", "840", "", "FL", "105", "", "28.03697", "-81.76508", "America/New_York"),("4159805", "Iona", "", "US", "840", "", "FL", "071", "", "26.52036", "-81.96398", "America/New_York"),("4159839", "Islamorada", "", "US", "840", "", "FL", "087", "", "24.9243", "-80.62784", "America/New_York"),("4159896", "Ives Estates", "", "US", "840", "", "FL", "086", "", "25.96231", "-80.17671", "America/New_York"),("4160021", "Jacksonville", "Джэксонвилл", "US", "840", "", "FL", "031", "", "30.33218", "-81.65565", "America/New_York"),("4160023", "Jacksonville Beach", "", "US", "840", "", "FL", "031", "", "30.29469", "-81.39314", "America/New_York"),("4160086", "Jan-Phyl Village", "", "US", "840", "", "FL", "105", "", "28.01474", "-81.77175", "America/New_York"),("4160100", "Jasmine Estates", "", "US", "840", "", "FL", "101", "", "28.29306", "-82.6901", "America/New_York"),("4160171", "Jensen Beach", "", "US", "840", "", "FL", "085", "", "27.25449", "-80.22977", "America/New_York"),("4160610", "Jupiter", "Юпитер", "US", "840", "", "FL", "099", "", "26.93422", "-80.09421", "America/New_York"),("4160651", "Kathleen", "", "US", "840", "", "FL", "105", "", "28.12085", "-82.02314", "America/New_York");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("4160705", "Kendale Lakes", "", "US", "840", "", "FL", "086", "", "25.70816", "-80.407", "America/New_York"),("4160711", "Kendall", "Кендалл", "US", "840", "", "FL", "086", "", "25.67927", "-80.31727", "America/New_York"),("4160749", "Kenneth City", "", "US", "840", "", "FL", "103", "", "27.81558", "-82.7201", "America/New_York"),("4160789", "Key Biscayne", "", "US", "840", "", "FL", "086", "", "25.69371", "-80.16282", "America/New_York"),("4160795", "Key Largo", "", "US", "840", "", "FL", "087", "", "25.08652", "-80.44728", "America/New_York"),("4160812", "Key West", "Ки-Уэст", "US", "840", "", "FL", "087", "", "24.55524", "-81.78163", "America/New_York"),("4160822", "Keystone", "", "US", "840", "", "FL", "057", "", "28.15585", "-82.62121", "America/New_York"),("4160932", "Kings Point", "", "US", "840", "", "FL", "099", "", "26.44535", "-80.13977", "America/New_York"),("4160983", "Kissimmee", "Киссимми", "US", "840", "", "FL", "097", "", "28.30468", "-81.41667", "America/New_York"),("4161118", "Lady Lake", "", "US", "840", "", "FL", "069", "", "28.91749", "-81.92286", "America/New_York"),("4161150", "Lake Alfred", "", "US", "840", "", "FL", "105", "", "28.09196", "-81.72341", "America/New_York"),("4161178", "Lake Butler", "", "US", "840", "", "FL", "095", "", "28.50167", "-81.54091", "America/New_York"),("4161187", "Lake City", "", "US", "840", "", "FL", "023", "", "30.18968", "-82.63929", "America/New_York"),("4161228", "Lake Forest", "", "US", "840", "", "FL", "011", "", "25.97759", "-80.1831", "America/New_York"),("4161296", "Lake Lorraine", "", "US", "840", "", "FL", "091", "", "30.44159", "-86.56523", "America/Chicago"),("4161298", "Lake Lucerne", "", "US", "840", "", "FL", "086", "", "25.96509", "-80.24144", "America/New_York"),("4161313", "Lake Magdalene", "", "US", "840", "", "FL", "057", "", "28.07418", "-82.47176", "America/New_York"),("4161334", "Lake Park", "", "US", "840", "", "FL", "099", "", "26.80034", "-80.06643", "America/New_York"),("4161373", "Lake Mary", "", "US", "840", "", "FL", "117", "", "28.75888", "-81.31784", "America/New_York"),("4161400", "Lake Wales", "", "US", "840", "", "FL", "105", "", "27.90141", "-81.58591", "America/New_York"),("4161422", "Lake Worth", "", "US", "840", "", "FL", "099", "", "26.61708", "-80.07231", "America/New_York"),("4161424", "Lake Worth Corridor", "", "US", "840", "", "FL", "099", "", "26.61649", "-80.10102", "America/New_York"),("4161438", "Lakeland", "", "US", "840", "", "FL", "105", "", "28.03947", "-81.9498", "America/New_York"),("4161444", "Lakeland Highlands", "", "US", "840", "", "FL", "105", "", "27.95975", "-81.95008", "America/New_York"),("4161460", "Lakes by the Bay", "", "US", "840", "", "FL", "086", "", "25.57233", "-80.32533", "America/New_York"),("4161461", "Lakeside", "", "US", "840", "", "FL", "019", "", "30.12996", "-81.76815", "America/New_York"),("4161510", "Lakewood Park", "", "US", "840", "", "FL", "111", "", "27.54309", "-80.40227", "America/New_York"),("4161511", "Lakewood Park", "", "US", "840", "", "FL", "111", "", "27.48143", "-80.37422", "America/New_York"),("4161534", "Land O' Lakes", "", "US", "840", "", "FL", "101", "", "28.2189", "-82.45759", "America/New_York"),("4161571", "Lantana", "", "US", "840", "", "FL", "099", "", "26.58674", "-80.05199", "America/New_York"),("4161580", "Largo", "", "US", "840", "", "FL", "103", "", "27.90979", "-82.78842", "America/New_York"),("4161616", "Lauderdale Lakes", "", "US", "840", "", "FL", "011", "", "26.16647", "-80.20838", "America/New_York"),("4161624", "Lauderdale-by-the-Sea", "", "US", "840", "", "FL", "011", "", "26.19203", "-80.09643", "America/New_York"),("4161625", "Lauderhill", "", "US", "840", "", "FL", "011", "", "26.14036", "-80.21338", "America/New_York"),("4161659", "Laurel", "", "US", "840", "", "FL", "115", "", "27.14378", "-82.46158", "America/New_York"),("4161705", "Lealman", "", "US", "840", "", "FL", "103", "", "27.82114", "-82.67927", "America/New_York"),("4161733", "Lecanto", "", "US", "840", "", "FL", "017", "", "28.85165", "-82.4876", "America/New_York"),("4161771", "Leesburg", "", "US", "840", "", "FL", "069", "", "28.81082", "-81.87786", "America/New_York"),("4161785", "Lehigh Acres", "", "US", "840", "", "FL", "071", "", "26.62535", "-81.6248", "America/New_York"),("4161797", "Leisure City", "", "US", "840", "", "FL", "086", "", "25.49539", "-80.42922", "America/New_York"),("4161957", "Lighthouse Point", "", "US", "840", "", "FL", "011", "", "26.27564", "-80.08727", "America/New_York"),("4162461", "Live Oak", "", "US", "840", "", "FL", "121", "", "30.29495", "-82.98402", "America/New_York"),("4162539", "Lockhart", "", "US", "840", "", "FL", "095", "", "28.61944", "-81.44257", "America/New_York"),("4162776", "Longboat Key", "", "US", "840", "", "FL", "081", "", "27.41254", "-82.65899", "America/New_York"),("4162783", "Longwood", "", "US", "840", "", "FL", "117", "", "28.70305", "-81.3384", "America/New_York"),("4163033", "Lutz", "Лутц", "US", "840", "", "FL", "057", "", "28.15112", "-82.46148", "America/New_York"),("4163049", "Lynn Haven", "", "US", "840", "", "FL", "005", "", "30.24548", "-85.64826", "America/Chicago"),("4163083", "Macclenny", "", "US", "840", "", "FL", "003", "", "30.28218", "-82.12206", "America/New_York"),("4163220", "Maitland", "", "US", "840", "", "FL", "095", "", "28.62778", "-81.36312", "America/New_York"),("4163318", "Mango", "", "US", "840", "", "FL", "057", "", "27.97974", "-82.30648", "America/New_York"),("4163379", "Marathon", "", "US", "840", "", "FL", "087", "", "24.71375", "-81.09035", "America/New_York"),("4163384", "Marco", "", "US", "840", "", "FL", "021", "", "25.9726", "-81.72898", "America/New_York"),("4163388", "Marco Island", "", "US", "840", "", "FL", "021", "", "25.94121", "-81.71842", "America/New_York"),("4163407", "Margate", "", "US", "840", "", "FL", "011", "", "26.24453", "-80.20644", "America/New_York"),("4163428", "Marianna", "", "US", "840", "", "FL", "063", "", "30.77436", "-85.22687", "America/Chicago"),("4163635", "Mascotte", "", "US", "840", "", "FL", "069", "", "28.57833", "-81.88675", "America/New_York"),("4163833", "McGregor", "", "US", "840", "", "FL", "071", "", "26.56091", "-81.91453", "America/New_York"),("4163918", "Meadow Woods", "", "US", "840", "", "FL", "095", "", "28.38556", "-81.36646", "America/New_York"),("4163954", "Medulla", "", "US", "840", "", "FL", "105", "", "27.9678", "-81.97342", "America/New_York"),("4163971", "Melbourne", "Мельбурн", "US", "840", "", "FL", "009", "", "28.08363", "-80.60811", "America/New_York"),("4163994", "Melrose Park", "", "US", "840", "", "FL", "011", "", "26.11342", "-80.19338", "America/New_York"),("4164047", "Memphis", "", "US", "840", "", "FL", "081", "", "27.53587", "-82.56121", "America/New_York"),("4164092", "Merritt Island", "", "US", "840", "", "FL", "009", "", "28.53917", "-80.672", "America/New_York"),("4164138", "Miami", "Майами", "US", "840", "", "FL", "086", "", "25.77427", "-80.19366", "America/New_York"),("4164143", "Miami Beach", "Майами-Бич", "US", "840", "", "FL", "086", "", "25.79065", "-80.13005", "America/New_York"),("4164167", "Miami Gardens", "", "US", "840", "", "FL", "086", "", "25.94204", "-80.2456", "America/New_York"),("4164186", "Miami Lakes", "", "US", "840", "", "FL", "086", "", "25.90871", "-80.30866", "America/New_York"),("4164211", "Miami Shores", "", "US", "840", "", "FL", "086", "", "25.86315", "-80.19283", "America/New_York"),("4164223", "Miami Springs", "", "US", "840", "", "FL", "086", "", "25.82232", "-80.2895", "America/New_York"),("4164253", "Micco", "", "US", "840", "", "FL", "009", "", "27.88058", "-80.50033", "America/New_York"),("4164387", "Middleburg", "", "US", "840", "", "FL", "019", "", "30.06885", "-81.86038", "America/New_York"),("4164547", "Milton", "", "US", "840", "", "FL", "113", "", "30.63241", "-87.03969", "America/Chicago"),("4164554", "Mims", "", "US", "840", "", "FL", "009", "", "28.66527", "-80.84478", "America/New_York"),("4164575", "Minneola", "", "US", "840", "", "FL", "069", "", "28.57444", "-81.74619", "America/New_York"),("4164601", "Miramar", "Мирамар", "US", "840", "", "FL", "011", "", "25.98731", "-80.23227", "America/New_York"),("4164602", "Miramar Beach", "", "US", "840", "", "FL", "131", "", "30.37437", "-86.35856", "America/Chicago"),("4165069", "Mount Dora", "", "US", "840", "", "FL", "069", "", "28.80249", "-81.64452", "America/New_York"),("4165519", "Myrtle Grove", "", "US", "840", "", "FL", "033", "", "30.42103", "-87.30747", "America/Chicago"),("4165565", "Naples", "Неаполь", "US", "840", "", "FL", "021", "", "26.14234", "-81.79596", "America/New_York"),("4165574", "Naples Manor", "", "US", "840", "", "FL", "021", "", "26.0887", "-81.7262", "America/New_York"),("4165576", "Naples Park", "", "US", "840", "", "FL", "021", "", "26.26175", "-81.80925", "America/New_York"),("4165580", "Naranja", "", "US", "840", "", "FL", "086", "", "25.51816", "-80.42283", "America/New_York"),("4165637", "Navarre", "", "US", "840", "", "FL", "113", "", "30.40159", "-86.86357", "America/Chicago"),("4165695", "Neptune Beach", "", "US", "840", "", "FL", "031", "", "30.31191", "-81.39647", "America/New_York"),("4165869", "New Port Richey", "", "US", "840", "", "FL", "101", "", "28.24418", "-82.71927", "America/New_York"),("4165913", "New Smyrna Beach", "", "US", "840", "", "FL", "127", "", "29.02582", "-80.927", "America/New_York"),("4165961", "Newberry", "", "US", "840", "", "FL", "001", "", "29.64635", "-82.6065", "America/New_York"),("4165995", "Niceville", "", "US", "840", "", "FL", "091", "", "30.51686", "-86.48217", "America/Chicago"),("4166066", "Norland", "Норланд", "US", "840", "", "FL", "086", "", "25.94898", "-80.21227", "America/New_York"),("4166096", "North Andrews Gardens", "", "US", "840", "", "FL", "011", "", "26.19147", "-80.14421", "America/New_York"),("4166105", "North Bay Village", "", "US", "840", "", "FL", "086", "", "25.84621", "-80.15394", "America/New_York"),("4166195", "North Fort Myers", "", "US", "840", "", "FL", "071", "", "26.66729", "-81.88009", "America/New_York"),("4166222", "North Lauderdale", "", "US", "840", "", "FL", "011", "", "26.2173", "-80.22588", "America/New_York"),("4166232", "North Miami", "", "US", "840", "", "FL", "086", "", "25.89009", "-80.18671", "America/New_York"),("4166233", "North Miami Beach", "", "US", "840", "", "FL", "086", "", "25.93315", "-80.16255", "America/New_York"),("4166253", "North Palm Beach", "", "US", "840", "", "FL", "099", "", "26.81756", "-80.08199", "America/New_York"),("4166274", "North Port", "", "US", "840", "", "FL", "115", "", "27.04422", "-82.23593", "America/New_York"),("4166298", "North Sarasota", "", "US", "840", "", "FL", "115", "", "27.37393", "-82.51843", "America/New_York"),("4166583", "Oak Ridge", "", "US", "840", "", "FL", "095", "", "28.47112", "-81.42452", "America/New_York"),("4166638", "Oakland Park", "", "US", "840", "", "FL", "011", "", "26.17231", "-80.13199", "America/New_York"),("4166673", "Ocala", "Окала", "US", "840", "", "FL", "083", "", "29.1872", "-82.14009", "America/New_York"),("4166723", "Ocean City", "", "US", "840", "", "FL", "091", "", "30.44103", "-86.61356", "America/Chicago"),("4166776", "Ocoee", "", "US", "840", "", "FL", "095", "", "28.56917", "-81.54396", "America/New_York"),("4166787", "Odessa", "", "US", "840", "", "FL", "101", "", "28.1939", "-82.59176", "America/New_York"),("4166805", "Ojus", "", "US", "840", "", "FL", "086", "", "25.94843", "-80.1506", "America/New_York"),("4166822", "Okeechobee", "", "US", "840", "", "FL", "093", "", "27.24393", "-80.82978", "America/New_York"),("4166936", "Oldsmar", "", "US", "840", "", "FL", "103", "", "28.03418", "-82.6651", "America/New_York"),("4166979", "Olympia Heights", "", "US", "840", "", "FL", "086", "", "25.72677", "-80.35533", "America/New_York"),("4167003", "Opa-locka", "", "US", "840", "", "FL", "086", "", "25.90232", "-80.25033", "America/New_York"),("4167055", "Orange City", "", "US", "840", "", "FL", "127", "", "28.94888", "-81.29867", "America/New_York"),("4167102", "Orange Park", "", "US", "840", "", "FL", "019", "", "30.16607", "-81.70648", "America/New_York"),("4167147", "Orlando", "Орландо", "US", "840", "", "FL", "095", "", "28.53834", "-81.37924", "America/New_York"),("4167176", "Orlovista", "", "US", "840", "", "FL", "095", "", "28.53834", "-81.46035", "America/New_York"),("4167178", "Ormond Beach", "", "US", "840", "", "FL", "127", "", "29.28581", "-81.05589", "America/New_York"),("4167190", "Ormond-by-the-Sea", "", "US", "840", "", "FL", "127", "", "29.34914", "-81.06645", "America/New_York"),("4167245", "Osprey", "", "US", "840", "", "FL", "115", "", "27.19616", "-82.49037", "America/New_York"),("4167348", "Oviedo", "Овьедо", "US", "840", "", "FL", "117", "", "28.67", "-81.20812", "America/New_York"),("4167424", "Pace", "", "US", "840", "", "FL", "113", "", "30.59936", "-87.16108", "America/Chicago"),("4167473", "Pahokee", "", "US", "840", "", "FL", "099", "", "26.82006", "-80.66534", "America/New_York"),("4167482", "Palatka", "", "US", "840", "", "FL", "107", "", "29.64858", "-81.63758", "America/New_York"),("4167499", "Palm Bay", "Палм-Бей", "US", "840", "", "FL", "009", "", "28.03446", "-80.58866", "America/New_York"),("4167505", "Palm Beach", "", "US", "840", "", "FL", "099", "", "26.70562", "-80.03643", "America/New_York"),("4167519", "Palm Beach Gardens", "", "US", "840", "", "FL", "099", "", "26.82339", "-80.13865", "America/New_York"),("4167536", "Palm City", "", "US", "840", "", "FL", "085", "", "27.16783", "-80.26616", "America/New_York"),("4167538", "Palm Coast", "", "US", "840", "", "FL", "035", "", "29.58497", "-81.20784", "America/New_York"),("4167545", "Palm Harbor", "", "US", "840", "", "FL", "103", "", "28.07807", "-82.76371", "America/New_York"),("4167583", "Palm Springs", "Палм Спрингс", "US", "840", "", "FL", "099", "", "26.6359", "-80.09615", "America/New_York"),("4167594", "Palm Springs North", "", "US", "840", "", "FL", "086", "", "25.9351", "-80.33383", "America/New_York"),("4167601", "Palm Valley", "", "US", "840", "", "FL", "109", "", "30.17746", "-81.38758", "America/New_York"),("4167632", "Palmetto", "", "US", "840", "", "FL", "081", "", "27.52143", "-82.57232", "America/New_York"),("4167634", "Palmetto Bay", "", "US", "840", "", "FL", "086", "", "25.62177", "-80.32477", "America/New_York"),("4167647", "Palmetto Estates", "", "US", "840", "", "FL", "086", "", "25.62149", "-80.362", "America/New_York"),("4167694", "Panama City", "Панама", "US", "840", "", "FL", "005", "", "30.15946", "-85.65983", "America/Chicago"),("4167695", "Panama City Beach", "", "US", "840", "", "FL", "005", "", "30.17659", "-85.80549", "America/Chicago"),("4167829", "Parkland", "", "US", "840", "", "FL", "011", "", "26.31008", "-80.23727", "America/New_York"),("4168062", "Pebble Creek", "", "US", "840", "", "FL", "057", "", "28.14835", "-82.34565", "America/New_York"),("4168095", "Pelican Bay", "", "US", "840", "", "FL", "021", "", "26.2312", "-81.80564", "America/New_York"),("4168138", "Pembroke Park", "", "US", "840", "", "FL", "011", "", "25.98787", "-80.17477", "America/New_York"),("4168139", "Pembroke Pines", "Пемброк-Пайнс", "US", "840", "", "FL", "011", "", "26.00315", "-80.22394", "America/New_York"),("4168228", "Pensacola", "Пенсакола", "US", "840", "", "FL", "033", "", "30.42131", "-87.21691", "America/Chicago"),("4168244", "Perry", "", "US", "840", "", "FL", "123", "", "30.11766", "-83.58274", "America/New_York"),("4168418", "Pine Castle", "", "US", "840", "", "FL", "095", "", "28.47195", "-81.36785", "America/New_York"),("4168459", "Pine Hills", "", "US", "840", "", "FL", "095", "", "28.55778", "-81.4534", "America/New_York"),("4168506", "Pine Island Ridge", "", "US", "840", "", "FL", "011", "", "26.09481", "-80.27394", "America/New_York"),("4168563", "Pine Ridge", "", "US", "840", "", "FL", "017", "", "28.93831", "-82.47343", "America/New_York"),("4168590", "Pinecrest", "", "US", "840", "", "FL", "086", "", "25.66705", "-80.30811", "America/New_York"),("4168630", "Pinellas Park", "", "US", "840", "", "FL", "103", "", "27.8428", "-82.69954", "America/New_York"),("4168659", "Pinewood", "", "US", "840", "", "FL", "086", "", "25.86898", "-80.21699", "America/New_York"),("4168773", "Plant City", "", "US", "840", "", "FL", "057", "", "28.01888", "-82.11469", "America/New_York"),("4168782", "Plantation", "Плантация", "US", "840", "", "FL", "011", "", "26.13421", "-80.23184", "America/New_York"),("4168930", "Poinciana", "", "US", "840", "", "FL", "097", "", "28.14029", "-81.45841", "America/New_York"),("4169014", "Pompano Beach", "", "US", "840", "", "FL", "011", "", "26.23786", "-80.12477", "America/New_York"),("4169018", "Pompano Beach Highlands", "", "US", "840", "", "FL", "011", "", "26.28286", "-80.10699", "America/New_York"),("4169060", "Ponte Vedra Beach", "Понте-Ведра-Бич", "US", "840", "", "FL", "109", "", "30.23969", "-81.38564", "America/New_York"),("4169130", "Port Charlotte", "Порт-Шарлотт", "US", "840", "", "FL", "015", "", "26.97617", "-82.09064", "America/New_York"),("4169156", "Port Orange", "", "US", "840", "", "FL", "127", "", "29.13832", "-80.99561", "America/New_York"),("4169170", "Port Saint John", "", "US", "840", "", "FL", "009", "", "28.47695", "-80.78867", "America/New_York"),("4169171", "Port Saint Lucie", "", "US", "840", "", "FL", "111", "", "27.29393", "-80.35033", "America/New_York"),("4169176", "Port Salerno", "", "US", "840", "", "FL", "085", "", "27.14422", "-80.2006", "America/New_York"),("4169345", "Princeton", "Принстон", "US", "840", "", "FL", "086", "", "25.53844", "-80.40894", "America/New_York"),("4169378", "Progress Village", "", "US", "840", "", "FL", "057", "", "27.9003", "-82.36454", "America/New_York"),("4169452", "Punta Gorda", "", "US", "840", "", "FL", "015", "", "26.92978", "-82.04537", "America/New_York"),("4169455", "Punta Gorda Isles", "", "US", "840", "", "FL", "015", "", "26.91756", "-82.07842", "America/New_York"),("4169510", "Quincy", "", "US", "840", "", "FL", "039", "", "30.58714", "-84.58325", "America/New_York"),("4170000", "Richmond Heights", "", "US", "840", "", "FL", "086", "", "25.63149", "-80.36894", "America/New_York"),("4170005", "Richmond West", "", "US", "840", "", "FL", "086", "", "25.6105", "-80.42971", "America/New_York"),("4170092", "River Park", "", "US", "840", "", "FL", "111", "", "27.31421", "-80.34727", "America/New_York"),("4170156", "Riverview", "", "US", "840", "", "FL", "057", "", "27.86614", "-82.32648", "America/New_York"),("4170174", "Riviera Beach", "", "US", "840", "", "FL", "099", "", "26.77534", "-80.0581", "America/New_York"),("4170358", "Rockledge", "Рокледж", "US", "840", "", "FL", "009", "", "28.35084", "-80.72533", "America/New_York"),("4170556", "Rotonda", "", "US", "840", "", "FL", "015", "", "26.88368", "-82.29009", "America/New_York"),("4170617", "Royal Palm Beach", "", "US", "840", "", "FL", "099", "", "26.7084", "-80.2306", "America/New_York"),("4170688", "Ruskin", "", "US", "840", "", "FL", "057", "", "27.72086", "-82.43315", "America/New_York"),("4170797", "Safety Harbor", "", "US", "840", "", "FL", "103", "", "27.99085", "-82.69316", "America/New_York"),("4170894", "Saint Augustine", "", "US", "840", "", "FL", "109", "", "29.89469", "-81.31452", "America/New_York"),("4170896", "Saint Augustine Beach", "", "US", "840", "", "FL", "109", "", "29.85053", "-81.26535", "America/New_York"),("4170908", "Saint Augustine Shores", "", "US", "840", "", "FL", "109", "", "29.8108", "-81.31035", "America/New_York"),("4170965", "Saint Cloud", "", "US", "840", "", "FL", "097", "", "28.2489", "-81.28118", "America/New_York"),("4171522", "Saint Pete Beach", "", "US", "840", "", "FL", "103", "", "27.72531", "-82.74121", "America/New_York"),("4171563", "St. Petersburg", "", "US", "840", "", "FL", "103", "", "27.77086", "-82.67927", "America/New_York"),("4171782", "San Carlos Park", "", "US", "840", "", "FL", "071", "", "26.4673", "-81.80147", "America/New_York"),("4172052", "Sanibel", "", "US", "840", "", "FL", "071", "", "26.44897", "-82.02231", "America/New_York"),("4172086", "Sanford", "", "US", "840", "", "FL", "117", "", "28.80055", "-81.27312", "America/New_York"),("4172131", "Sarasota", "Сарасота", "US", "840", "", "FL", "115", "", "27.33643", "-82.53065", "America/New_York"),("4172150", "Sarasota Springs", "", "US", "840", "", "FL", "115", "", "27.30894", "-82.47954", "America/New_York"),("4172173", "Satellite Beach", "", "US", "840", "", "FL", "009", "", "28.17612", "-80.59005", "America/New_York"),("4172294", "Scott Lake", "", "US", "840", "", "FL", "086", "", "25.94148", "-80.23199", "America/New_York"),("4172372", "Sebastian", "", "US", "840", "", "FL", "061", "", "27.81641", "-80.47061", "America/New_York"),("4172383", "Sebring", "", "US", "840", "", "FL", "055", "", "27.49559", "-81.44091", "America/New_York"),("4172413", "Seffner", "", "US", "840", "", "FL", "057", "", "27.98363", "-82.27565", "America/New_York"),("4172434", "Seminole", "", "US", "840", "", "FL", "103", "", "27.83975", "-82.79121", "America/New_York"),("4172602", "Shady Hills", "", "US", "840", "", "FL", "101", "", "28.41", "-82.54288", "America/New_York"),("4172935", "Siesta Key", "", "US", "840", "", "FL", "115", "", "27.26785", "-82.54526", "America/New_York"),("4173007", "Silver Springs Shores", "", "US", "840", "", "FL", "083", "", "29.10442", "-82.02064", "America/New_York"),("4173124", "Sky Lake", "", "US", "840", "", "FL", "095", "", "28.45723", "-81.39146", "America/New_York"),("4173376", "South Bay", "", "US", "840", "", "FL", "099", "", "26.66396", "-80.71617", "America/New_York"),("4173392", "South Bradenton", "", "US", "840", "", "FL", "081", "", "27.4631", "-82.58176", "America/New_York"),("4173394", "South Apopka", "", "US", "840", "", "FL", "095", "", "28.66194", "-81.50952", "America/New_York"),("4173431", "South Daytona", "", "US", "840", "", "FL", "127", "", "29.16582", "-81.0045", "America/New_York"),("4173460", "South Gate Ridge", "", "US", "840", "", "FL", "115", "", "27.28644", "-82.49676", "America/New_York"),("4173467", "South Highpoint", "", "US", "840", "", "FL", "103", "", "27.91697", "-82.71288", "America/New_York"),("4173495", "South Miami", "", "US", "840", "", "FL", "086", "", "25.7076", "-80.29338", "America/New_York"),("4173497", "South Miami Heights", "", "US", "840", "", "FL", "086", "", "25.59761", "-80.38061", "America/New_York"),("4173524", "South Pasadena", "", "US", "840", "", "FL", "103", "", "27.75503", "-82.7376", "America/New_York"),("4173528", "South Patrick Shores", "", "US", "840", "", "FL", "009", "", "28.20223", "-80.6095", "America/New_York"),("4173593", "South Venice", "", "US", "840", "", "FL", "115", "", "27.05311", "-82.42426", "America/New_York"),("4173600", "Southchase", "", "US", "840", "", "FL", "095", "", "28.39306", "-81.3834", "America/New_York"),("4173634", "Southgate", "", "US", "840", "", "FL", "115", "", "27.3081", "-82.50982", "America/New_York"),("4173717", "Southwest Ranches", "", "US", "840", "", "FL", "011", "", "26.0587", "-80.33727", "America/New_York"),("4173838", "Spring Hill", "Спринг-Хилл", "US", "840", "", "FL", "053", "", "28.47688", "-82.52546", "America/New_York"),("4173892", "Springfield", "", "US", "840", "", "FL", "005", "", "30.15326", "-85.61132", "America/Chicago"),("4173999", "Starke", "", "US", "840", "", "FL", "007", "", "29.94413", "-82.10983", "America/New_York"),("4174201", "Stuart", "", "US", "840", "", "FL", "085", "", "27.19755", "-80.25283", "America/New_York"),("4174252", "Sugarmill Woods", "", "US", "840", "", "FL", "017", "", "28.73221", "-82.50621", "America/New_York"),("4174317", "Sun City Center", "", "US", "840", "", "FL", "057", "", "27.71809", "-82.35176", "America/New_York"),("4174383", "Sunny Isles Beach", "", "US", "840", "", "FL", "086", "", "25.95065", "-80.12282", "America/New_York"),("4174402", "Sunrise", "", "US", "840", "", "FL", "011", "", "26.13397", "-80.1131", "America/New_York"),("4174425", "Sunset", "", "US", "840", "", "FL", "086", "", "25.70594", "-80.35228", "America/New_York"),("4174518", "Surfside", "", "US", "840", "", "FL", "086", "", "25.87843", "-80.1256", "America/New_York"),("4174600", "Sweetwater", "", "US", "840", "", "FL", "086", "", "25.76343", "-80.37311", "America/New_York"),("4174715", "Tallahassee", "Таллахасси", "US", "840", "", "FL", "073", "", "30.43826", "-84.28073", "America/New_York"),("4174738", "Tamarac", "", "US", "840", "", "FL", "011", "", "26.21286", "-80.24977", "America/New_York"),("4174744", "Tamiami", "", "US", "840", "", "FL", "086", "", "25.75871", "-80.39839", "America/New_York"),("4174757", "Tampa", "Тампа", "US", "840", "", "FL", "057", "", "27.94752", "-82.45843", "America/New_York"),("4174855", "Tarpon Springs", "", "US", "840", "", "FL", "103", "", "28.14612", "-82.75677", "America/New_York"),("4174861", "Tavares", "", "US", "840", "", "FL", "069", "", "28.80416", "-81.72563", "America/New_York"),("4174969", "Temple Terrace", "", "US", "840", "", "FL", "057", "", "28.0353", "-82.38926", "America/New_York"),("4175011", "Tequesta", "", "US", "840", "", "FL", "099", "", "26.96811", "-80.12865", "America/New_York"),("4175091", "The Crossings", "", "US", "840", "", "FL", "086", "", "25.67066", "-80.40117", "America/New_York"),("4175117", "The Hammocks", "", "US", "840", "", "FL", "086", "", "25.67149", "-80.4445", "America/New_York"),("4175179", "The Villages", "", "US", "840", "", "FL", "119", "", "28.93408", "-81.95994", "America/New_York"),("4175269", "Thonotosassa", "", "US", "840", "", "FL", "057", "", "28.06141", "-82.30231", "America/New_York"),("4175296", "Three Lakes", "", "US", "840", "", "FL", "086", "", "25.64205", "-80.39839", "America/New_York"),("4175391", "Timber Pines", "", "US", "840", "", "FL", "053", "", "28.47028", "-82.60316", "America/New_York"),("4175437", "Titusville", "Титусвилль", "US", "840", "", "FL", "009", "", "28.61222", "-80.80755", "America/New_York"),("4175538", "Town 'n' Country", "", "US", "840", "", "FL", "057", "", "28.01057", "-82.57732", "America/New_York"),("4175626", "Treasure Island", "", "US", "840", "", "FL", "103", "", "27.76919", "-82.76899", "America/New_York"),("4176109", "Union Park", "", "US", "840", "", "FL", "095", "", "28.56806", "-81.28618", "America/New_York"),("4176217", "University Park", "", "US", "840", "", "FL", "086", "", "25.74649", "-80.36755", "America/New_York"),("4176277", "Upper Grand Lagoon", "", "US", "840", "", "FL", "005", "", "30.16326", "-85.74076", "America/Chicago"),("4176316", "Valparaiso", "", "US", "840", "", "FL", "091", "", "30.50853", "-86.50273", "America/Chicago"),("4176318", "Valrico", "", "US", "840", "", "FL", "057", "", "27.93789", "-82.23644", "America/New_York"),("4176380", "Venice", "Венеция", "US", "840", "", "FL", "115", "", "27.09978", "-82.45426", "America/New_York"),("4176387", "Venice Gardens", "", "US", "840", "", "FL", "115", "", "27.07311", "-82.4076", "America/New_York"),("4176409", "Vero Beach", "", "US", "840", "", "FL", "061", "", "27.63864", "-80.39727", "America/New_York"),("4177308", "Wahneta", "", "US", "840", "", "FL", "105", "", "27.9528", "-81.72702", "America/New_York"),("4177450", "Warm Mineral Springs", "", "US", "840", "", "FL", "115", "", "27.05978", "-82.26009", "America/New_York"),("4177465", "Warrington", "", "US", "840", "", "FL", "033", "", "30.38409", "-87.27497", "America/Chicago"),("4177617", "Wedgefield", "", "US", "840", "", "FL", "095", "", "28.48778", "-81.07729", "America/New_York"),("4177671", "Wekiwa Springs", "", "US", "840", "", "FL", "117", "", "28.69861", "-81.42563", "America/New_York"),("4177703", "Wellington", "Веллингтон", "US", "840", "", "FL", "099", "", "26.65868", "-80.24144", "America/New_York"),("4177727", "Wesley Chapel", "", "US", "840", "", "FL", "101", "", "28.23973", "-82.32787", "America/New_York"),("4177779", "Westchase", "", "US", "840", "", "FL", "057", "", "28.05502", "-82.60982", "America/New_York"),("4177816", "West Gate", "", "US", "840", "", "FL", "099", "", "26.70257", "-80.0981", "America/New_York"),("4177865", "West Little River", "", "US", "840", "", "FL", "086", "", "25.85704", "-80.23699", "America/New_York"),("4177872", "West Melbourne", "", "US", "840", "", "FL", "009", "", "28.07168", "-80.65339", "America/New_York"),("4177874", "West Miami", "", "US", "840", "", "FL", "086", "", "25.76343", "-80.29616", "America/New_York"),("4177887", "West Palm Beach", "Уэст-Палм-Бич", "US", "840", "", "FL", "099", "", "26.71534", "-80.05337", "America/New_York"),("4177897", "West Park", "", "US", "840", "", "FL", "011", "", "25.98454", "-80.19894", "America/New_York"),("4177908", "West Pensacola", "", "US", "840", "", "FL", "033", "", "30.42659", "-87.27969", "America/Chicago"),("4177917", "West Perrine", "", "US", "840", "", "FL", "086", "", "25.60594", "-80.36283", "America/New_York"),("4177930", "West Samoset", "", "US", "840", "", "FL", "081", "", "27.46948", "-82.55676", "America/New_York"),("4177950", "West Vero Corridor", "", "US", "840", "", "FL", "061", "", "27.63775", "-80.48576", "America/New_York"),("4177960", "West and East Lealman", "", "US", "840", "", "FL", "103", "", "27.81993", "-82.68944", "America/New_York"),("4177965", "Westchester", "Вестчестер", "US", "840", "", "FL", "086", "", "25.75482", "-80.32727", "America/New_York"),("4178003", "Weston", "Уэстон", "US", "840", "", "FL", "011", "", "26.10037", "-80.39977", "America/New_York"),("4178032", "Westview", "", "US", "840", "", "FL", "086", "", "25.88204", "-80.24199", "America/New_York"),("4178053", "Westwood Lake", "", "US", "840", "", "FL", "086", "", "25.72927", "-80.37283", "America/New_York"),("4178292", "Wildwood", "", "US", "840", "", "FL", "119", "", "28.86542", "-82.04058", "America/New_York"),("4178397", "Williamsburg", "", "US", "840", "", "FL", "095", "", "28.41445", "-81.44285", "America/New_York"),("4178449", "Willow Oak", "", "US", "840", "", "FL", "105", "", "27.91614", "-82.01786", "America/New_York"),("4178485", "Wilton Manors", "", "US", "840", "", "FL", "011", "", "26.16036", "-80.13893", "America/New_York"),("4178488", "Wimauma", "", "US", "840", "", "FL", "057", "", "27.71253", "-82.29898", "America/New_York"),("4178540", "Winston", "", "US", "840", "", "FL", "105", "", "28.03169", "-82.01481", "America/New_York"),("4178550", "Winter Garden", "", "US", "840", "", "FL", "095", "", "28.56528", "-81.58618", "America/New_York"),("4178552", "Winter Haven", "", "US", "840", "", "FL", "105", "", "28.02224", "-81.73286", "America/New_York"),("4178560", "Winter Park", "", "US", "840", "", "FL", "095", "", "28.6", "-81.33924", "America/New_York"),("4178573", "Winter Springs", "", "US", "840", "", "FL", "117", "", "28.69889", "-81.30812", "America/New_York"),("4178775", "Wright", "Райт", "US", "840", "", "FL", "091", "", "30.45575", "-86.63829", "America/Chicago"),("4178919", "Yulee", "", "US", "840", "", "FL", "089", "", "30.6319", "-81.60649", "America/New_York"),("4178941", "Zephyrhills", "", "US", "840", "", "FL", "101", "", "28.23362", "-82.18119", "America/New_York"),("4179074", "Acworth", "", "US", "840", "", "GA", "067", "", "34.06635", "-84.67837", "America/New_York"),("4179193", "Adel", "", "US", "840", "", "GA", "075", "", "31.13727", "-83.42408", "America/New_York"),("4179320", "Albany", "Олбани", "US", "840", "", "GA", "095", "", "31.57851", "-84.15574", "America/New_York"),("4179574", "Alpharetta", "Альфаретта", "US", "840", "", "GA", "121", "", "34.07538", "-84.29409", "America/New_York"),("4179667", "Americus", "", "US", "840", "", "GA", "261", "", "32.07239", "-84.23269", "America/New_York"),("4180386", "Athens", "Атенс", "US", "840", "", "GA", "059", "", "33.96095", "-83.37794", "America/New_York"),("4180439", "Atlanta", "Атланта", "US", "840", "", "GA", "121", "", "33.749", "-84.38798", "America/New_York"),("4180512", "Auburn", "", "US", "840", "", "GA", "013", "", "34.01372", "-83.82768", "America/New_York"),("4180531", "Augusta", "Огаста", "US", "840", "", "GA", "245", "", "33.47097", "-81.97484", "America/New_York"),("4180564", "Austell", "", "US", "840", "", "GA", "067", "", "33.81261", "-84.63438", "America/New_York"),("4180775", "Bainbridge", "", "US", "840", "", "GA", "087", "", "30.9038", "-84.57547", "America/New_York"),("4181110", "Barnesville", "", "US", "840", "", "GA", "171", "", "33.05457", "-84.15575", "America/New_York"),("4181936", "Belvedere Park", "", "US", "840", "", "GA", "089", "", "33.75483", "-84.26742", "America/New_York"),("4184165", "Braselton", "", "US", "840", "", "GA", "157", "", "34.10927", "-83.76267", "America/New_York"),("4184222", "Bremen", "", "US", "840", "", "GA", "143", "", "33.72122", "-85.1455", "America/New_York"),("4184530", "Brookhaven", "", "US", "840", "", "GA", "089", "", "33.85844", "-84.3402", "America/New_York"),("4184845", "Brunswick", "Брауншвейг", "US", "840", "", "GA", "127", "", "31.14995", "-81.49149", "America/New_York"),("4185110", "Buford", "", "US", "840", "", "GA", "135", "", "34.12066", "-84.00435", "America/New_York"),("4185553", "Byron", "", "US", "840", "", "GA", "225", "", "32.65376", "-83.75963", "America/New_York"),("4185632", "Cairo", "", "US", "840", "", "GA", "131", "", "30.87751", "-84.20214", "America/New_York"),("4185657", "Calhoun", "", "US", "840", "", "GA", "129", "", "34.50259", "-84.95105", "America/New_York"),("4185863", "Camilla", "", "US", "840", "", "GA", "205", "", "31.23129", "-84.21046", "America/New_York"),("4186213", "Canton", "", "US", "840", "", "GA", "057", "", "34.23676", "-84.49076", "America/New_York"),("4186416", "Carrollton", "", "US", "840", "", "GA", "045", "", "33.58011", "-85.07661", "America/New_York"),("4186531", "Cartersville", "", "US", "840", "", "GA", "015", "", "34.16533", "-84.80231", "America/New_York"),("4186955", "Cedartown", "", "US", "840", "", "GA", "233", "", "34.05371", "-85.25495", "America/New_York"),("4187055", "Centerville", "", "US", "840", "", "GA", "153", "", "32.63014", "-83.68963", "America/New_York"),("4187204", "Chamblee", "", "US", "840", "", "GA", "089", "", "33.89205", "-84.29881", "America/New_York"),("4188233", "Clarkston", "", "US", "840", "", "GA", "089", "", "33.80955", "-84.23964", "America/New_York"),("4188815", "College Park", "", "US", "840", "", "GA", "121", "", "33.65344", "-84.44937", "America/New_York"),("4188985", "Columbus", "Коламбус", "US", "840", "", "GA", "215", "", "32.46098", "-84.98771", "America/New_York"),("4189014", "Commerce", "", "US", "840", "", "GA", "157", "", "34.204", "-83.45711", "America/New_York"),("4189157", "Conley", "", "US", "840", "", "GA", "063", "", "33.64483", "-84.32576", "America/New_York"),("4189213", "Conyers", "", "US", "840", "", "GA", "247", "", "33.66761", "-84.01769", "America/New_York"),("4189423", "Cordele", "", "US", "840", "", "GA", "081", "", "31.96351", "-83.78239", "America/New_York"),("4189612", "Country Club Estates", "", "US", "840", "", "GA", "059", "", "33.98928", "-83.4096", "America/New_York"),("4189613", "Country Club Estates", "", "US", "840", "", "GA", "127", "", "31.21273", "-81.46427", "America/New_York"),("4189785", "Covington", "", "US", "840", "", "GA", "217", "", "33.59678", "-83.86018", "America/New_York"),("4190396", "Cumming", "", "US", "840", "", "GA", "117", "", "34.20732", "-84.14019", "America/New_York"),("4190434", "Cusseta", "", "US", "840", "", "GA", "053", "", "32.30543", "-84.7727", "America/New_York"),("4190523", "Dacula", "", "US", "840", "", "GA", "135", "", "33.98872", "-83.89796", "America/New_York"),("4190542", "Dahlonega", "", "US", "840", "", "GA", "187", "", "34.53259", "-83.98491", "America/New_York"),("4190581", "Dalton", "Далтон", "US", "840", "", "GA", "313", "", "34.7698", "-84.97022", "America/New_York"),("4190598", "Dallas", "", "US", "840", "", "GA", "223", "", "33.92371", "-84.84077", "America/New_York"),("4191124", "Decatur", "Декейтер", "US", "840", "", "GA", "089", "", "33.77483", "-84.29631", "America/New_York"),("4191628", "Dock Junction", "", "US", "840", "", "GA", "127", "", "31.20245", "-81.51677", "America/New_York"),("4191768", "Doraville", "", "US", "840", "", "GA", "089", "", "33.89816", "-84.28326", "America/New_York"),("4191916", "Douglas", "", "US", "840", "", "GA", "069", "", "31.50881", "-82.84987", "America/New_York"),("4191955", "Douglasville", "", "US", "840", "", "GA", "097", "", "33.7515", "-84.74771", "America/New_York"),("4192088", "Druid Hills", "", "US", "840", "", "GA", "089", "", "33.78038", "-84.33604", "America/New_York"),("4192205", "Dublin", "Дублин", "US", "840", "", "GA", "175", "", "32.54044", "-82.90375", "America/New_York"),("4192289", "Duluth", "Дулут", "US", "840", "", "GA", "135", "", "34.00288", "-84.14464", "America/New_York"),("4192375", "Dunwoody", "Данвуди", "US", "840", "", "GA", "089", "", "33.94621", "-84.33465", "America/New_York"),("4192674", "East Point", "", "US", "840", "", "GA", "121", "", "33.67955", "-84.43937", "America/New_York"),("4192754", "Eastman", "", "US", "840", "", "GA", "091", "", "32.19767", "-83.17765", "America/New_York"),("4192800", "Eatonton", "", "US", "840", "", "GA", "237", "", "33.3268", "-83.3885", "America/New_York"),("4193699", "Evans", "", "US", "840", "", "GA", "073", "", "33.53375", "-82.13067", "America/New_York"),("4194111", "Fair Oaks", "", "US", "840", "", "GA", "067", "", "33.91649", "-84.54465", "America/New_York"),("4194121", "Fairburn", "", "US", "840", "", "GA", "121", "", "33.56706", "-84.58104", "America/New_York"),("4194202", "Fairview", "", "US", "840", "", "GA", "295", "", "34.94563", "-85.2844", "America/New_York"),("4194474", "Fayetteville", "", "US", "840", "", "GA", "113", "", "33.44873", "-84.45493", "America/New_York"),("4195168", "Fitzgerald", "", "US", "840", "", "GA", "017", "", "31.71491", "-83.25265", "America/New_York"),("4195544", "Flowery Branch", "", "US", "840", "", "GA", "139", "", "34.1851", "-83.92518", "America/New_York"),("4195600", "Folkston", "", "US", "840", "", "GA", "049", "", "30.83095", "-82.01131", "America/New_York"),("4195701", "Forest Park", "", "US", "840", "", "GA", "063", "", "33.62205", "-84.36909", "America/New_York"),("4195850", "Fort Oglethorpe", "", "US", "840", "", "GA", "047", "", "34.94896", "-85.2569", "America/New_York"),("4195869", "Fort Valley", "", "US", "840", "", "GA", "225", "", "32.55376", "-83.88741", "America/New_York"),("4196586", "Gainesville", "", "US", "840", "", "GA", "139", "", "34.29788", "-83.82407", "America/New_York"),("4196688", "Garden City", "", "US", "840", "", "GA", "051", "", "32.11437", "-81.154", "America/New_York"),("4196917", "Georgetown", "", "US", "840", "", "GA", "051", "", "31.98326", "-81.22733", "America/New_York"),("4197325", "Glennville", "", "US", "840", "", "GA", "267", "", "31.93659", "-81.92845", "America/New_York"),("4198298", "Gresham Park", "", "US", "840", "", "GA", "089", "", "33.70344", "-84.31437", "America/New_York"),("4198322", "Griffin", "Гриффин", "US", "840", "", "GA", "255", "", "33.24678", "-84.26409", "America/New_York"),("4198514", "Grovetown", "", "US", "840", "", "GA", "073", "", "33.45042", "-82.19818", "America/New_York"),("4198972", "Hampton", "", "US", "840", "", "GA", "151", "", "33.38706", "-84.28298", "America/New_York"),("4199075", "Hapeville", "", "US", "840", "", "GA", "121", "", "33.66011", "-84.4102", "America/New_York"),("4199694", "Hawkinsville", "", "US", "840", "", "GA", "235", "", "32.28377", "-83.47212", "America/New_York"),("4200671", "Hinesville", "", "US", "840", "", "GA", "179", "", "31.84688", "-81.59595", "America/New_York"),("4201047", "Holly Springs", "", "US", "840", "", "GA", "057", "", "34.17399", "-84.50132", "America/New_York"),("4202260", "Irondale", "", "US", "840", "", "GA", "063", "", "33.48067", "-84.35881", "America/New_York"),("4202672", "Jefferson", "", "US", "840", "", "GA", "157", "", "34.11705", "-83.57239", "America/New_York"),("4202810", "Jesup", "", "US", "840", "", "GA", "305", "", "31.60785", "-81.88634", "America/New_York"),("4203696", "Kennesaw", "Кеннесо", "US", "840", "", "GA", "067", "", "34.02343", "-84.61549", "America/New_York"),("4204007", "Kingsland", "", "US", "840", "", "GA", "039", "", "30.79996", "-81.68983", "America/New_York"),("4204230", "La Grange", "", "US", "840", "", "GA", "285", "", "33.03929", "-85.03133", "America/New_York"),("4204241", "LaFayette", "", "US", "840", "", "GA", "295", "", "34.7048", "-85.2819", "America/New_York"),("4205196", "Lawrenceville", "", "US", "840", "", "GA", "135", "", "33.95621", "-83.98796", "America/New_York"),("4205724", "Lilburn", "", "US", "840", "", "GA", "135", "", "33.8901", "-84.14297", "America/New_York"),("4205885", "Lithia Springs", "", "US", "840", "", "GA", "097", "", "33.794", "-84.66049", "America/New_York"),("4206502", "Locust Grove", "", "US", "840", "", "GA", "151", "", "33.34595", "-84.10908", "America/New_York"),("4206547", "Loganville", "", "US", "840", "", "GA", "297", "", "33.839", "-83.90074", "America/New_York"),("4206905", "Lovejoy", "", "US", "840", "", "GA", "063", "", "33.43622", "-84.31437", "America/New_York"),("4207226", "Mableton", "", "US", "840", "", "GA", "067", "", "33.81872", "-84.58243", "America/New_York"),("4207400", "Macon", "Макон", "US", "840", "", "GA", "021", "", "32.84069", "-83.6324", "America/New_York"),("4207783", "Marietta", "Мариетта", "US", "840", "", "GA", "067", "", "33.9526", "-84.54993", "America/New_York"),("4207981", "Martinez", "Мартинес", "US", "840", "", "GA", "073", "", "33.51736", "-82.07567", "America/New_York"),("4208442", "McDonough", "", "US", "840", "", "GA", "151", "", "33.44734", "-84.14686", "America/New_York"),("4208683", "McRae", "", "US", "840", "", "GA", "271", "", "32.06795", "-82.9007", "America/New_York"),("4209448", "Milledgeville", "", "US", "840", "", "GA", "009", "", "33.08014", "-83.2321", "America/New_York"),("4209884", "Monroe", "", "US", "840", "", "GA", "297", "", "33.79484", "-83.71323", "America/New_York"),("4210254", "Morrow", "", "US", "840", "", "GA", "063", "", "33.58317", "-84.33937", "America/New_York"),("4210397", "Moultrie", "", "US", "840", "", "GA", "071", "", "31.17991", "-83.78906", "America/New_York"),("4211428", "Mountain Park", "", "US", "840", "", "GA", "135", "", "33.84427", "-84.12936", "America/New_York"),("4212684", "Newnan", "", "US", "840", "", "GA", "077", "", "33.38067", "-84.79966", "America/New_York"),("4212888", "Norcross", "", "US", "840", "", "GA", "135", "", "33.94121", "-84.21353", "America/New_York"),("4212937", "North Atlanta", "", "US", "840", "", "GA", "089", "", "33.8651", "-84.33659", "America/New_York"),("4212992", "North Decatur", "", "US", "840", "", "GA", "089", "", "33.79038", "-84.30603", "America/New_York"),("4212995", "North Druid Hills", "", "US", "840", "", "GA", "089", "", "33.81677", "-84.31326", "America/New_York"),("4214693", "Panthersville", "", "US", "840", "", "GA", "089", "", "33.70733", "-84.27187", "America/New_York"),("4215110", "Peachtree City", "", "US", "840", "", "GA", "113", "", "33.39678", "-84.59576", "America/New_York"),("4215114", "Peachtree Corners", "", "US", "840", "", "GA", "135", "", "33.9701", "-84.22159", "America/New_York"),("4215391", "Perry", "", "US", "840", "", "GA", "153", "", "32.45821", "-83.73157", "America/New_York"),("4216948", "Pooler", "", "US", "840", "", "GA", "051", "", "32.11548", "-81.24706", "America/New_York"),("4217075", "Port Wentworth", "", "US", "840", "", "GA", "051", "", "32.14909", "-81.16317", "America/New_York"),("4217214", "Powder Springs", "", "US", "840", "", "GA", "067", "", "33.85955", "-84.68382", "America/New_York"),("4218165", "Redan", "Редан", "US", "840", "", "GA", "089", "", "33.74538", "-84.13158", "America/New_York"),("4218752", "Richmond Hill", "", "US", "840", "", "GA", "029", "", "31.93827", "-81.30344", "America/New_York"),("4218882", "Rincon", "", "US", "840", "", "GA", "103", "", "32.29603", "-81.23539", "America/New_York"),("4219001", "Riverdale", "", "US", "840", "", "GA", "063", "", "33.57261", "-84.41326", "America/New_York"),("4219762", "Rome", "", "US", "840", "", "GA", "115", "", "34.25704", "-85.16467", "America/New_York"),("4219934", "Roswell", "", "US", "840", "", "GA", "121", "", "34.02316", "-84.36159", "America/New_York"),("4220629", "St. Marys", "", "US", "840", "", "GA", "039", "", "30.73051", "-81.54649", "America/New_York"),("4220861", "Saint Simon Mills", "", "US", "840", "", "GA", "127", "", "31.17079", "-81.40732", "America/New_York"),("4220866", "Saint Simons Island", "", "US", "840", "", "GA", "127", "", "31.15051", "-81.36954", "America/New_York"),("4221206", "Sandersville", "", "US", "840", "", "GA", "303", "", "32.98154", "-82.81014", "America/New_York"),("4221333", "Sandy Springs", "", "US", "840", "", "GA", "121", "", "33.92427", "-84.37854", "America/New_York"),("4221552", "Savannah", "Саванна", "US", "840", "", "GA", "051", "", "32.08354", "-81.09983", "America/New_York"),("4221732", "Scottdale", "", "US", "840", "", "GA", "089", "", "33.78983", "-84.26409", "America/New_York"),("4223004", "Skidaway Island", "", "US", "840", "", "GA", "051", "", "31.93494", "-81.04705", "America/New_York"),("4223379", "Smyrna", "Смирна", "US", "840", "", "GA", "067", "", "33.88399", "-84.51438", "America/New_York"),("4223413", "Snellville", "", "US", "840", "", "GA", "135", "", "33.85733", "-84.01991", "America/New_York"),("4224413", "Statesboro", "", "US", "840", "", "GA", "031", "", "32.44879", "-81.78317", "America/New_York"),("4224681", "Stockbridge", "", "US", "840", "", "GA", "151", "", "33.54428", "-84.23381", "America/New_York"),("4224745", "Stone Mountain", "", "US", "840", "", "GA", "089", "", "33.80816", "-84.1702", "America/New_York"),("4225039", "Sugar Hill", "", "US", "840", "", "GA", "135", "", "34.10649", "-84.03352", "America/New_York"),("4225309", "Suwanee", "", "US", "840", "", "GA", "135", "", "34.05149", "-84.0713", "America/New_York"),("4225346", "Swainsboro", "", "US", "840", "", "GA", "107", "", "32.59739", "-82.33374", "America/New_York"),("4225522", "Sylvester", "", "US", "840", "", "GA", "321", "", "31.53092", "-83.83693", "America/New_York"),("4226348", "Thomasville", "", "US", "840", "", "GA", "275", "", "30.83658", "-83.97878", "America/New_York"),("4226364", "Thomaston", "", "US", "840", "", "GA", "293", "", "32.88819", "-84.32659", "America/New_York"),("4226435", "Thomson", "", "US", "840", "", "GA", "189", "", "33.47069", "-82.50457", "America/New_York"),("4226552", "Tifton", "", "US", "840", "", "GA", "277", "", "31.45046", "-83.5085", "America/New_York"),("4226722", "Toccoa", "", "US", "840", "", "GA", "257", "", "34.57732", "-83.33239", "America/New_York"),("4227213", "Tucker", "Такер", "US", "840", "", "GA", "089", "", "33.85455", "-84.21714", "America/New_York"),("4227612", "Tyrone", "", "US", "840", "", "GA", "113", "", "33.47123", "-84.59715", "America/New_York"),("4227777", "Union City", "Юнион-Сити", "US", "840", "", "GA", "121", "", "33.58706", "-84.54243", "America/New_York"),("4228147", "Valdosta", "Валдоста", "US", "840", "", "GA", "185", "", "30.83334", "-83.28032", "America/New_York"),("4228425", "Vidalia", "", "US", "840", "", "GA", "279", "", "32.21769", "-82.41346", "America/New_York"),("4228452", "Villa Rica", "", "US", "840", "", "GA", "045", "", "33.73205", "-84.91911", "America/New_York"),("4228518", "Vinings", "", "US", "840", "", "GA", "067", "", "33.86483", "-84.46437", "America/New_York"),("4229476", "Warner Robins", "", "US", "840", "", "GA", "153", "", "32.61574", "-83.62664", "America/New_York"),("4229763", "Waycross", "", "US", "840", "", "GA", "299", "", "31.21368", "-82.3557", "America/New_York"),("4229791", "Waynesboro", "", "US", "840", "", "GA", "033", "", "33.08987", "-82.01567", "America/New_York"),("4230760", "Whitemarsh Island", "", "US", "840", "", "GA", "051", "", "32.02882", "-81.01678", "America/New_York"),("4231354", "Wilmington Island", "", "US", "840", "", "GA", "051", "", "32.00355", "-80.97372", "America/New_York"),("4231523", "Winder", "", "US", "840", "", "GA", "013", "", "33.99261", "-83.72017", "America/New_York"),("4231874", "Woodstock", "Вудсток", "US", "840", "", "GA", "057", "", "34.10149", "-84.51938", "America/New_York"),("4232679", "Alton", "", "US", "840", "", "IL", "119", "", "38.8906", "-90.18428", "America/Chicago"),("4233586", "Benton", "", "US", "840", "", "IL", "055", "", "37.99672", "-88.92007", "America/Chicago"),("4233662", "Bethalto", "", "US", "840", "", "IL", "119", "", "38.90921", "-90.04066", "America/Chicago"),("4233813", "Belleville", "Беллвилл", "US", "840", "", "IL", "163", "", "38.52005", "-89.98399", "America/Chicago"),("4234969", "Cahokia", "", "US", "840", "", "IL", "163", "", "38.57088", "-90.19011", "America/Chicago"),("4235193", "Carbondale", "", "US", "840", "", "IL", "077", "", "37.72727", "-89.21675", "America/Chicago"),("4235211", "Carlinville", "", "US", "840", "", "IL", "117", "", "39.27977", "-89.88177", "America/Chicago"),("4235246", "Carmi", "", "US", "840", "", "IL", "193", "", "38.09088", "-88.15865", "America/Chicago"),("4235311", "Carterville", "", "US", "840", "", "IL", "199", "", "37.76005", "-89.0773", "America/Chicago"),("4235587", "Centralia", "", "US", "840", "", "IL", "121", "", "38.52505", "-89.1334", "America/Chicago"),("4235600", "Centreville", "", "US", "840", "", "IL", "163", "", "38.58338", "-90.12511", "America/Chicago"),("4235668", "Charleston", "Чарлстон", "US", "840", "", "IL", "029", "", "39.49615", "-88.17615", "America/Chicago"),("4235683", "Chatham", "", "US", "840", "", "IL", "167", "", "39.67616", "-89.70454", "America/Chicago"),("4235724", "Chester", "", "US", "840", "", "IL", "157", "", "37.91366", "-89.82205", "America/Chicago"),("4236191", "Collinsville", "Коллинсвиль", "US", "840", "", "IL", "119", "", "38.67033", "-89.98455", "America/Chicago"),("4236206", "Columbia", "", "US", "840", "", "IL", "133", "", "38.44366", "-90.20122", "America/Chicago"),("4236895", "Decatur", "Декейтер", "US", "840", "", "IL", "115", "", "39.84031", "-88.9548", "America/Chicago"),("4237312", "Du Quoin", "", "US", "840", "", "IL", "145", "", "38.01144", "-89.23619", "America/Chicago"),("4237473", "East Alton", "", "US", "840", "", "IL", "119", "", "38.88033", "-90.11122", "America/Chicago"),("4237579", "East Saint Louis", "", "US", "840", "", "IL", "163", "", "38.6245", "-90.15094", "America/Chicago"),("4237717", "Edwardsville", "", "US", "840", "", "IL", "119", "", "38.81144", "-89.95316", "America/Chicago"),("4237727", "Effingham", "", "US", "840", "", "IL", "049", "", "39.12004", "-88.54338", "America/Chicago"),("4238081", "Fairfield", "", "US", "840", "", "IL", "191", "", "38.37894", "-88.35977", "America/Chicago"),("4238132", "Fairview Heights", "", "US", "840", "", "IL", "163", "", "38.58894", "-89.99038", "America/Chicago"),("4239465", "Glen Carbon", "", "US", "840", "", "IL", "119", "", "38.74838", "-89.98316", "America/Chicago"),("4239509", "Godfrey", "", "US", "840", "", "IL", "119", "", "38.9556", "-90.18678", "America/Chicago"),("4239714", "Granite City", "", "US", "840", "", "IL", "119", "", "38.70144", "-90.14872", "America/Chicago"),("4239867", "Greenville", "", "US", "840", "", "IL", "005", "", "38.89227", "-89.41314", "America/Chicago"),("4240284", "Harrisburg", "", "US", "840", "", "IL", "165", "", "37.73838", "-88.54061", "America/Chicago"),("4240540", "Herrin", "", "US", "840", "", "IL", "199", "", "37.80311", "-89.02757", "America/Chicago"),("4240679", "Highland", "", "US", "840", "", "IL", "119", "", "38.73949", "-89.6712", "America/Chicago"),("4240782", "Hillsboro", "", "US", "840", "", "IL", "135", "", "39.16128", "-89.4954", "America/Chicago"),("4241704", "Jacksonville", "Джексонвилл", "US", "840", "", "IL", "137", "", "39.73394", "-90.22901", "America/Chicago"),("4241822", "Jerseyville", "", "US", "840", "", "IL", "083", "", "39.12005", "-90.32845", "America/Chicago"),("4243131", "Litchfield", "", "US", "840", "", "IL", "135", "", "39.17533", "-89.65426", "America/Chicago"),("4243899", "Marion", "Мэрион", "US", "840", "", "IL", "199", "", "37.73061", "-88.93313", "America/Chicago"),("4244026", "Maryville", "", "US", "840", "", "IL", "119", "", "38.72366", "-89.95593", "America/Chicago"),("4244031", "Mascoutah", "", "US", "840", "", "IL", "163", "", "38.49033", "-89.79315", "America/Chicago"),("4244099", "Mattoon", "", "US", "840", "", "IL", "029", "", "39.48309", "-88.37283", "America/Chicago"),("4244462", "Metropolis", "", "US", "840", "", "IL", "127", "", "37.15117", "-88.732", "America/Chicago"),("4244967", "Mount Carmel", "", "US", "840", "", "IL", "185", "", "38.41088", "-87.76142", "America/Chicago"),("4245152", "Mount Vernon", "", "US", "840", "", "IL", "081", "", "38.31727", "-88.90312", "America/Chicago"),("4245174", "Mount Zion", "", "US", "840", "", "IL", "115", "", "39.77143", "-88.87424", "America/Chicago"),("4245336", "Murphysboro", "", "US", "840", "", "IL", "077", "", "37.7645", "-89.33509", "America/Chicago"),("4245926", "O'Fallon", "", "US", "840", "", "IL", "163", "", "38.59227", "-89.91121", "America/Chicago"),("4246382", "Olney", "", "US", "840", "", "IL", "159", "", "38.73088", "-88.08532", "America/Chicago"),("4246595", "Pana", "", "US", "840", "", "IL", "021", "", "39.38893", "-89.08008", "America/Chicago"),("4246659", "Paris", "", "US", "840", "", "IL", "045", "", "39.61115", "-87.69614", "America/Chicago"),("4246983", "Pinckneyville", "", "US", "840", "", "IL", "145", "", "38.08033", "-89.38203", "America/Chicago"),("4247379", "Pontoon Beach", "", "US", "840", "", "IL", "119", "", "38.73172", "-90.08038", "America/Chicago"),("4247703", "Quincy", "Куинси", "US", "840", "", "IL", "001", "", "39.9356", "-91.40987", "America/Chicago"),("4248256", "Robinson", "", "US", "840", "", "IL", "033", "", "39.00532", "-87.73919", "America/Chicago"),("4249286", "Salem", "", "US", "840", "", "IL", "121", "", "38.62699", "-88.94562", "America/Chicago"),("4249910", "Shiloh", "", "US", "840", "", "IL", "163", "", "38.56144", "-89.89732", "America/Chicago"),("4250542", "Springfield", "Спрингфилд", "US", "840", "", "IL", "167", "", "39.80172", "-89.64371", "America/Chicago"),("4250608", "Staunton", "", "US", "840", "", "IL", "117", "", "39.01227", "-89.79121", "America/Chicago"),("4251003", "Swansea", "", "US", "840", "", "IL", "163", "", "38.53394", "-89.98899", "America/Chicago"),("4251141", "Taylorville", "", "US", "840", "", "IL", "021", "", "39.54894", "-89.29453", "America/Chicago"),("4251513", "Troy", "", "US", "840", "", "IL", "119", "", "38.72921", "-89.88315", "America/Chicago"),("4251841", "Upper Alton", "", "US", "840", "", "IL", "119", "", "38.91144", "-90.15066", "America/Chicago"),("4251917", "Vandalia", "", "US", "840", "", "IL", "051", "", "38.9606", "-89.09368", "America/Chicago"),("4252548", "Waterloo", "", "US", "840", "", "IL", "133", "", "38.33589", "-90.14983", "America/Chicago"),("4252812", "West Frankfort", "", "US", "840", "", "IL", "055", "", "37.89783", "-88.93146", "America/Chicago"),("4253387", "Wood River", "", "US", "840", "", "IL", "119", "", "38.86116", "-90.09761", "America/Chicago"),("4254021", "Avon", "", "US", "840", "", "IN", "063", "", "39.76282", "-86.39972", "America/Indiana/Indianapolis"),("4254124", "Bargersville", "", "US", "840", "", "IN", "081", "", "39.52088", "-86.16777", "America/Indiana/Indianapolis"),("4254185", "Batesville", "", "US", "840", "", "IN", "137", "", "39.30005", "-85.22218", "America/Indiana/Indianapolis"),("4254282", "Bedford", "", "US", "840", "", "IN", "093", "", "38.86116", "-86.48721", "America/Indiana/Indianapolis"),("4254304", "Beech Grove", "", "US", "840", "", "IN", "097", "", "39.72199", "-86.08998", "America/Indiana/Indianapolis"),("4254679", "Bloomington", "Блумингтон", "US", "840", "", "IN", "105", "", "39.16533", "-86.52639", "America/Indiana/Indianapolis"),("4254797", "Boonville", "", "US", "840", "", "IN", "173", "", "38.04921", "-87.27417", "America/Chicago"),("4254884", "Brazil", "", "US", "840", "", "IN", "021", "", "39.52365", "-87.12502", "America/Indiana/Indianapolis"),("4254944", "Bright", "", "US", "840", "", "IN", "029", "", "39.21839", "-84.85606", "America/New_York"),("4254957", "Broad Ripple", "", "US", "840", "", "IN", "097", "", "39.86671", "-86.14165", "America/Indiana/Indianapolis"),("4255056", "Brownsburg", "", "US", "840", "", "IN", "063", "", "39.84338", "-86.39777", "America/Indiana/Indianapolis"),("4255466", "Carmel", "Кармель", "US", "840", "", "IN", "057", "", "39.97837", "-86.11804", "America/Indiana/Indianapolis"),("4255704", "Charlestown", "", "US", "840", "", "IN", "019", "", "38.45312", "-85.67024", "America/Kentucky/Louisville"),("4255836", "Clarksville", "", "US", "840", "", "IN", "019", "", "38.29674", "-85.75996", "America/Kentucky/Louisville"),("4256038", "Columbus", "Колумбус", "US", "840", "", "IN", "005", "", "39.20144", "-85.92138", "America/Indiana/Indianapolis"),("4256085", "Connersville", "", "US", "840", "", "IN", "041", "", "39.64116", "-85.14107", "America/Indiana/Indianapolis"),("4256384", "Cumberland", "", "US", "840", "", "IN", "097", "", "39.77615", "-85.9572", "America/Indiana/Indianapolis"),("4256447", "Danville", "", "US", "840", "", "IN", "063", "", "39.7606", "-86.52639", "America/Indiana/Indianapolis"),("4257110", "Ellettsville", "", "US", "840", "", "IN", "105", "", "39.23393", "-86.625", "America/Indiana/Indianapolis"),("4257227", "Evansville", "Эвансвилл", "US", "840", "", "IN", "163", "", "37.97476", "-87.55585", "America/Chicago"),("4257494", "Fishers", "", "US", "840", "", "IN", "057", "", "39.95559", "-86.01387", "America/Indiana/Indianapolis"),("4258273", "Greencastle", "", "US", "840", "", "IN", "133", "", "39.64449", "-86.86473", "America/Indiana/Indianapolis"),("4258285", "Greenfield", "Гринфилд", "US", "840", "", "IN", "059", "", "39.78504", "-85.76942", "America/Indiana/Indianapolis"),("4258302", "Greensburg", "", "US", "840", "", "IN", "031", "", "39.33727", "-85.48358", "America/Indiana/Indianapolis"),("4258313", "Greenwood", "", "US", "840", "", "IN", "081", "", "39.61366", "-86.10665", "America/Indiana/Indianapolis"),("4258871", "Hidden Valley", "", "US", "840", "", "IN", "029", "", "39.16228", "-84.84301", "America/New_York"),("4259271", "Huntingburg", "", "US", "840", "", "IN", "037", "", "38.29894", "-86.955", "America/Indiana/Vincennes"),("4259418", "Indianapolis", "Индианаполис", "US", "840", "", "IN", "097", "", "39.76838", "-86.15804", "America/Indiana/Indianapolis"),("4259640", "Jasper", "", "US", "840", "", "IN", "037", "", "38.39144", "-86.93111", "America/Indiana/Vincennes"),("4259671", "Jeffersonville", "", "US", "840", "", "IN", "019", "", "38.27757", "-85.73718", "America/Kentucky/Louisville"),("4260210", "Lawrence", "Лоуренс", "US", "840", "", "IN", "097", "", "39.83865", "-86.02526", "America/Indiana/Indianapolis"),("4260453", "Linton", "", "US", "840", "", "IN", "055", "", "39.03477", "-87.16585", "America/Indiana/Indianapolis"),("4260768", "Lowell", "", "US", "840", "", "IN", "005", "", "39.25311", "-85.94638", "America/Indiana/Indianapolis"),("4260853", "Madison", "", "US", "840", "", "IN", "077", "", "38.73589", "-85.37996", "America/Indiana/Indianapolis"),("4261032", "Martinsville", "", "US", "840", "", "IN", "109", "", "39.42783", "-86.42833", "America/Indiana/Indianapolis"),("4261132", "McCordsville", "", "US", "840", "", "IN", "059", "", "39.9081", "-85.92276", "America/Indiana/Indianapolis"),("4261585", "Mooresville", "", "US", "840", "", "IN", "109", "", "39.61282", "-86.37416", "America/Indiana/Indianapolis"),("4261837", "Mount Vernon", "", "US", "840", "", "IN", "129", "", "37.93227", "-87.89503", "America/Chicago"),("4262045", "New Albany", "Нью-Албани", "US", "840", "", "IN", "043", "", "38.28562", "-85.82413", "America/Kentucky/Louisville"),("4262072", "New Castle", "", "US", "840", "", "IN", "065", "", "39.92894", "-85.37025", "America/Indiana/Indianapolis"),("4262159", "New Whiteland", "", "US", "840", "", "IN", "081", "", "39.5581", "-86.09526", "America/Indiana/Indianapolis"),("4262293", "North Madison", "", "US", "840", "", "IN", "077", "", "38.76784", "-85.39663", "America/Indiana/Indianapolis"),("4262318", "North Vernon", "", "US", "840", "", "IN", "079", "", "39.00617", "-85.62358", "America/Indiana/Indianapolis"),("4262406", "Oak Park", "", "US", "840", "", "IN", "019", "", "38.30562", "-85.69635", "America/Kentucky/Louisville"),("4263108", "Plainfield", "", "US", "840", "", "IN", "063", "", "39.70421", "-86.39944", "America/Indiana/Indianapolis"),("4263396", "Princeton", "", "US", "840", "", "IN", "051", "", "38.35532", "-87.56752", "America/Chicago"),("4263681", "Richmond", "Ричмонд", "US", "840", "", "IN", "177", "", "39.82894", "-84.89024", "America/Indiana/Indianapolis"),("4263965", "Rushville", "", "US", "840", "", "IN", "139", "", "39.60921", "-85.44636", "America/Indiana/Indianapolis"),("4264334", "Salem", "", "US", "840", "", "IN", "175", "", "38.60561", "-86.10109", "America/Indiana/Indianapolis"),("4264555", "Scottsburg", "", "US", "840", "", "IN", "143", "", "38.68561", "-85.77025", "America/Indiana/Indianapolis"),("4264598", "Sellersburg", "", "US", "840", "", "IN", "019", "", "38.39812", "-85.75496", "America/Kentucky/Louisville"),("4264617", "Seymour", "", "US", "840", "", "IN", "071", "", "38.95922", "-85.89025", "America/Indiana/Indianapolis"),("4264688", "Shelbyville", "", "US", "840", "", "IN", "145", "", "39.52144", "-85.77692", "America/Indiana/Indianapolis"),("4265146", "Speedway", "", "US", "840", "", "IN", "097", "", "39.80227", "-86.26721", "America/Indiana/Indianapolis"),("4265717", "Tell City", "", "US", "840", "", "IN", "123", "", "37.95144", "-86.76777", "America/Indiana/Tell_City"),("4265737", "Terre Haute", "Терре-Хот", "US", "840", "", "IN", "167", "", "39.4667", "-87.41391", "America/Indiana/Indianapolis"),("4266307", "Vincennes", "", "US", "840", "", "IN", "083", "", "38.67727", "-87.52863", "America/Indiana/Vincennes"),("4266586", "Washington", "", "US", "840", "", "IN", "027", "", "38.65922", "-87.17279", "America/Indiana/Vincennes"),("4266965", "Whitestown", "", "US", "840", "", "IN", "011", "", "39.99726", "-86.34583", "America/Indiana/Indianapolis"),("4267336", "Zionsville", "", "US", "840", "", "IN", "011", "", "39.95087", "-86.26194", "America/Indiana/Indianapolis"),("4267354", "Abilene", "", "US", "840", "", "KS", "041", "", "38.91722", "-97.21391", "America/Chicago"),("4267594", "Andover", "", "US", "840", "", "KS", "015", "", "37.7139", "-97.13643", "America/Chicago"),("4267661", "Arkansas City", "", "US", "840", "", "KS", "035", "", "37.06197", "-97.03837", "America/Chicago"),("4267733", "Atchison", "", "US", "840", "", "KS", "005", "", "39.56305", "-95.12164", "America/Chicago"),("4267773", "Augusta", "", "US", "840", "", "KS", "015", "", "37.68668", "-96.9767", "America/Chicago"),("4267944", "Basehor", "", "US", "840", "", "KS", "103", "", "39.14167", "-94.93858", "America/Chicago"),("4268521", "Bonner Springs", "", "US", "840", "", "KS", "209", "", "39.05973", "-94.88358", "America/Chicago"),("4269392", "Chanute", "", "US", "840", "", "KS", "133", "", "37.67921", "-95.4572", "America/Chicago"),("4269789", "Coffeyville", "", "US", "840", "", "KS", "125", "", "37.0373", "-95.61637", "America/Chicago"),("4269872", "Concordia", "", "US", "840", "", "KS", "029", "", "39.57084", "-97.66254", "America/Chicago"),("4270269", "De Soto", "", "US", "840", "", "KS", "091", "", "38.97917", "-94.96858", "America/Chicago"),("4270356", "Derby", "", "US", "840", "", "KS", "173", "", "37.54557", "-97.26893", "America/Chicago"),("4270863", "El Dorado", "", "US", "840", "", "KS", "015", "", "37.81724", "-96.86225", "America/Chicago"),("4271086", "Emporia", "", "US", "840", "", "KS", "111", "", "38.4039", "-96.18166", "America/Chicago"),("4271196", "Eudora", "", "US", "840", "", "KS", "045", "", "38.94334", "-95.09858", "America/Chicago"),("4271690", "Fort Scott", "", "US", "840", "", "KS", "011", "", "37.83976", "-94.7083", "America/Chicago"),("4271935", "Gardner", "Гарднер", "US", "840", "", "KS", "091", "", "38.81084", "-94.92719", "America/Chicago"),("4272340", "Great Bend", "", "US", "840", "", "KS", "009", "", "38.36446", "-98.76481", "America/Chicago"),("4272782", "Hays", "", "US", "840", "", "KS", "051", "", "38.87918", "-99.32677", "America/Chicago"),("4272788", "Haysville", "", "US", "840", "", "KS", "173", "", "37.56446", "-97.35227", "America/Chicago"),("4273299", "Hutchinson", "Хатчинсон", "US", "840", "", "KS", "155", "", "38.06084", "-97.92977", "America/Chicago"),("4273359", "Independence", "", "US", "840", "", "KS", "125", "", "37.22424", "-95.70831", "America/Chicago"),("4273441", "Iola", "", "US", "840", "", "KS", "001", "", "37.92448", "-95.39998", "America/Chicago"),("4273680", "Junction City", "", "US", "840", "", "KS", "061", "", "39.02861", "-96.8314", "America/Chicago"),("4273837", "Kansas City", "Канзас-Сити", "US", "840", "", "KS", "209", "", "39.11417", "-94.62746", "America/Chicago"),("4274236", "Lansing", "", "US", "840", "", "KS", "103", "", "39.24861", "-94.90024", "America/Chicago"),("4274277", "Lawrence", "Лоуренс", "US", "840", "", "KS", "045", "", "38.97167", "-95.23525", "America/Chicago"),("4274305", "Leavenworth", "Ливенворс", "US", "840", "", "KS", "103", "", "39.31111", "-94.92246", "America/Chicago"),("4274317", "Leawood", "", "US", "840", "", "KS", "091", "", "38.96667", "-94.6169", "America/Chicago"),("4274356", "Lenexa", "", "US", "840", "", "KS", "091", "", "38.95362", "-94.73357", "America/Chicago"),("4274994", "Manhattan", "Манхэттен", "US", "840", "", "KS", "161", "", "39.18361", "-96.57167", "America/Chicago"),("4275261", "McPherson", "", "US", "840", "", "KS", "113", "", "38.37084", "-97.66421", "America/Chicago"),("4275393", "Merriam", "", "US", "840", "", "KS", "091", "", "39.02362", "-94.69357", "America/Chicago"),("4275600", "Mission", "", "US", "840", "", "KS", "091", "", "39.02778", "-94.65579", "America/Chicago"),("4276017", "Mulvane", "", "US", "840", "", "KS", "191", "", "37.47446", "-97.24393", "America/Chicago"),("4276248", "Newton", "Ньютон", "US", "840", "", "KS", "079", "", "38.04668", "-97.34504", "America/Chicago"),("4276614", "Olathe", "", "US", "840", "", "KS", "091", "", "38.8814", "-94.81913", "America/Chicago"),("4276816", "Ottawa", "", "US", "840", "", "KS", "059", "", "38.61557", "-95.26775", "America/Chicago"),("4276873", "Overland Park", "Оверленд-Парк", "US", "840", "", "KS", "091", "", "38.98223", "-94.67079", "America/Chicago"),("4276956", "Paola", "", "US", "840", "", "KS", "121", "", "38.57224", "-94.87913", "America/Chicago"),("4276974", "Park City", "", "US", "840", "", "KS", "173", "", "37.80001", "-97.31838", "America/Chicago"),("4277011", "Parsons", "", "US", "840", "", "KS", "099", "", "37.34034", "-95.26108", "America/Chicago"),("4277241", "Pittsburg", "Питсбург", "US", "840", "", "KS", "037", "", "37.41088", "-94.70496", "America/Chicago"),("4277718", "Prairie Village", "", "US", "840", "", "KS", "091", "", "38.99167", "-94.63357", "America/Chicago"),("4277752", "Pratt", "", "US", "840", "", "KS", "151", "", "37.64391", "-98.73759", "America/Chicago"),("4278272", "Roeland Park", "", "US", "840", "", "KS", "091", "", "39.03751", "-94.63218", "America/Chicago"),("4278890", "Salina", "Салина", "US", "840", "", "KS", "169", "", "38.84028", "-97.61142", "America/Chicago"),("4279247", "Shawnee", "", "US", "840", "", "KS", "091", "", "39.04167", "-94.72024", "America/Chicago"),("4279847", "Spring Hill", "", "US", "840", "", "KS", "091", "", "38.74306", "-94.82552", "America/Chicago"),("4280502", "Tonganoxie", "", "US", "840", "", "KS", "103", "", "39.10972", "-95.08775", "America/Chicago"),("4280539", "Topeka", "Топика", "US", "840", "", "KS", "177", "", "39.04833", "-95.67804", "America/Chicago"),("4280910", "Valley Center", "", "US", "840", "", "KS", "173", "", "37.83473", "-97.37338", "America/Chicago"),("4281386", "Wellington", "", "US", "840", "", "KS", "191", "", "37.2653", "-97.37171", "America/Chicago"),("4281730", "Wichita", "Уичито", "US", "840", "", "KS", "173", "", "37.69224", "-97.33754", "America/Chicago"),("4281897", "Winfield", "", "US", "840", "", "KS", "035", "", "37.23975", "-96.99559", "America/Chicago"),("4282342", "Alexandria", "", "US", "840", "", "KY", "037", "", "38.95951", "-84.38799", "America/New_York"),("4282757", "Ashland", "", "US", "840", "", "KY", "019", "", "38.47841", "-82.63794", "America/New_York"),("4283133", "Bardstown", "", "US", "840", "", "KY", "179", "", "37.80923", "-85.4669", "America/New_York"),("4283845", "Bellevue", "", "US", "840", "", "KY", "037", "", "39.10645", "-84.47883", "America/New_York"),("4283974", "Berea", "", "US", "840", "", "KY", "151", "", "37.56869", "-84.29632", "America/New_York"),("4285268", "Bowling Green", "Боулинг-Грин", "US", "840", "", "KY", "227", "", "36.99032", "-86.4436", "America/Chicago"),("4286037", "Buckner", "", "US", "840", "", "KY", "185", "", "38.38368", "-85.43996", "America/New_York"),("4286054", "Buechel", "", "US", "840", "", "KY", "111", "", "38.19507", "-85.6519", "America/Kentucky/Louisville"),("4286281", "Burlington", "Берлингтон", "US", "840", "", "KY", "015", "", "39.02756", "-84.72411", "America/New_York"),("4286717", "Campbellsville", "", "US", "840", "", "KY", "217", "", "37.3434", "-85.34191", "America/New_York"),("4287450", "Central City", "", "US", "840", "", "KY", "177", "", "37.29393", "-87.12333", "America/Chicago"),("4288230", "Cold Spring", "", "US", "840", "", "KY", "037", "", "39.02173", "-84.43994", "America/New_York"),("4288656", "Corbin", "", "US", "840", "", "KY", "235", "", "36.9487", "-84.09688", "America/New_York"),("4288809", "Covington", "Ковингтон", "US", "840", "", "KY", "117", "", "39.08367", "-84.50855", "America/New_York"),("4289323", "Cynthiana", "", "US", "840", "", "KY", "097", "", "38.39035", "-84.2941", "America/New_York"),("4289445", "Danville", "", "US", "840", "", "KY", "021", "", "37.64563", "-84.77217", "America/New_York"),("4289629", "Dayton", "", "US", "840", "", "KY", "037", "", "39.11284", "-84.47272", "America/New_York"),("4290181", "Douglass Hills", "", "US", "840", "", "KY", "111", "", "38.23785", "-85.55274", "America/Kentucky/Louisville"),("4290873", "Edgewood", "", "US", "840", "", "KY", "117", "", "39.01867", "-84.58189", "America/New_York"),("4290988", "Elizabethtown", "Элизабеттаун", "US", "840", "", "KY", "093", "", "37.69395", "-85.85913", "America/New_York"),("4291156", "Elsmere", "", "US", "840", "", "KY", "117", "", "39.01256", "-84.60467", "America/New_York"),("4291255", "Erlanger", "", "US", "840", "", "KY", "117", "", "39.01673", "-84.60078", "America/New_York"),("4291373", "Fairdale", "", "US", "840", "", "KY", "111", "", "38.10507", "-85.75885", "America/Kentucky/Louisville"),("4291620", "Fern Creek", "", "US", "840", "", "KY", "111", "", "38.15979", "-85.58774", "America/Kentucky/Louisville"),("4291884", "Flatwoods", "", "US", "840", "", "KY", "089", "", "38.52258", "-82.71711", "America/New_York"),("4291945", "Florence", "Флоренция", "US", "840", "", "KY", "015", "", "38.99895", "-84.62661", "America/New_York"),("4292067", "Fort Mitchell", "", "US", "840", "", "KY", "117", "", "39.0595", "-84.54744", "America/New_York"),("4292071", "Fort Thomas", "", "US", "840", "", "KY", "037", "", "39.07506", "-84.44716", "America/New_York"),("4292072", "Fort Wright", "", "US", "840", "", "KY", "117", "", "39.05173", "-84.53411", "America/New_York"),("4292182", "Francisville", "", "US", "840", "", "KY", "015", "", "39.10506", "-84.72439", "America/New_York"),("4292188", "Frankfort", "Франкфурт", "US", "840", "", "KY", "073", "", "38.20091", "-84.87328", "America/New_York"),("4292193", "Franklin", "", "US", "840", "", "KY", "213", "", "36.72226", "-86.57722", "America/Chicago"),("4292686", "Georgetown", "", "US", "840", "", "KY", "209", "", "38.2098", "-84.55883", "America/New_York"),("4292826", "Glasgow", "", "US", "840", "", "KY", "009", "", "36.99588", "-85.91192", "America/Chicago"),("4294180", "Harrodsburg", "", "US", "840", "", "KY", "167", "", "37.7623", "-84.84329", "America/New_York"),("4294349", "Hazard", "", "US", "840", "", "KY", "193", "", "37.24954", "-83.19323", "America/New_York"),("4294425", "Hebron", "", "US", "840", "", "KY", "015", "", "39.06589", "-84.70106", "America/New_York"),("4294494", "Henderson", "Хендерсон", "US", "840", "", "KY", "101", "", "37.83615", "-87.59001", "America/Chicago"),("4294788", "Highland Heights", "", "US", "840", "", "KY", "037", "", "39.03312", "-84.45189", "America/New_York"),("4294799", "Highview", "", "US", "840", "", "KY", "111", "", "38.14285", "-85.62413", "America/Kentucky/Louisville"),("4294858", "Hillview", "", "US", "840", "", "KY", "029", "", "38.06979", "-85.68551", "America/New_York"),("4295251", "Hopkinsville", "Хопкинсвилле", "US", "840", "", "KY", "047", "", "36.86561", "-87.49117", "America/Chicago"),("4295776", "Independence", "", "US", "840", "", "KY", "117", "", "38.94312", "-84.54411", "America/New_York"),("4295940", "Ironville", "", "US", "840", "", "KY", "019", "", "38.45647", "-82.69238", "America/New_York"),("4296218", "Jeffersontown", "", "US", "840", "", "KY", "111", "", "38.19424", "-85.5644", "America/Kentucky/Louisville"),("4297184", "Knottsville", "", "US", "840", "", "KY", "059", "", "37.77172", "-86.90416", "America/Chicago"),("4297238", "La Grange", "", "US", "840", "", "KY", "185", "", "38.40757", "-85.37885", "America/New_York"),("4297581", "Lawrenceburg", "", "US", "840", "", "KY", "005", "", "38.0373", "-84.89662", "America/New_York"),("4297653", "Lebanon", "", "US", "840", "", "KY", "155", "", "37.56979", "-85.25274", "America/New_York"),("4297882", "Leitchfield", "", "US", "840", "", "KY", "085", "", "37.48005", "-86.29386", "America/Chicago"),("4297983", "Lexington", "Лексингтон", "US", "840", "", "KY", "067", "", "37.98869", "-84.47772", "America/New_York"),("4297999", "Lexington-Fayette", "", "US", "840", "", "KY", "067", "", "38.0498", "-84.45855", "America/New_York"),("4298960", "London", "", "US", "840", "", "KY", "125", "", "37.12898", "-84.08326", "America/New_York"),("4299276", "Louisville", "Луисвилл", "US", "840", "", "KY", "111", "", "38.25424", "-85.75941", "America/Kentucky/Louisville"),("4299562", "Lyndon", "", "US", "840", "", "KY", "111", "", "38.25674", "-85.60163", "America/Kentucky/Louisville"),("4299670", "Madisonville", "", "US", "840", "", "KY", "107", "", "37.3281", "-87.49889", "America/Chicago"),("4300105", "Mayfield", "", "US", "840", "", "KY", "083", "", "36.74172", "-88.63672", "America/Chicago"),("4300152", "Maysville", "", "US", "840", "", "KY", "161", "", "38.64119", "-83.74437", "America/New_York"),("4300488", "Meads", "", "US", "840", "", "KY", "019", "", "38.41258", "-82.70905", "America/New_York"),("4300717", "Middlesboro", "", "US", "840", "", "KY", "013", "", "36.60842", "-83.71658", "America/New_York"),("4300725", "Middletown", "", "US", "840", "", "KY", "111", "", "38.24535", "-85.53885", "America/Kentucky/Louisville"),("4301224", "Monticello", "", "US", "840", "", "KY", "231", "", "36.82979", "-84.84911", "America/Kentucky/Monticello"),("4301229", "Monticello", "", "US", "840", "", "KY", "067", "", "37.9923", "-84.55022", "America/New_York"),("4301307", "Morehead", "", "US", "840", "", "KY", "205", "", "38.18397", "-83.43268", "America/New_York"),("4301317", "Morehead", "", "US", "840", "", "KY", "177", "", "37.27115", "-87.17638", "America/Chicago"),("4301683", "Mount Sterling", "", "US", "840", "", "KY", "173", "", "38.05647", "-83.94326", "America/New_York"),("4301732", "Mount Washington", "", "US", "840", "", "KY", "029", "", "38.05006", "-85.54579", "America/New_York"),("4302035", "Murray", "Мюррей", "US", "840", "", "KY", "035", "", "36.61033", "-88.31476", "America/Chicago"),("4302504", "Newburg", "", "US", "840", "", "KY", "111", "", "38.16007", "-85.65968", "America/Kentucky/Louisville"),("4302529", "Newport", "Ньюпорт", "US", "840", "", "KY", "037", "", "39.09145", "-84.49578", "America/New_York"),("4302561", "Nicholasville", "", "US", "840", "", "KY", "113", "", "37.88063", "-84.573", "America/New_York"),("4302827", "Oak Grove", "", "US", "840", "", "KY", "047", "", "36.66505", "-87.44279", "America/Chicago"),("4302828", "Oak Grove", "", "US", "840", "", "KY", "183", "", "37.34421", "-86.75471", "America/Chicago"),("4302910", "Oakbrook", "", "US", "840", "", "KY", "015", "", "38.99978", "-84.68522", "America/New_York"),("4303012", "Okolona", "", "US", "840", "", "KY", "111", "", "38.14118", "-85.68774", "America/Kentucky/Louisville"),("4303436", "Owensboro", "", "US", "840", "", "KY", "059", "", "37.77422", "-87.11333", "America/Chicago"),("4303602", "Paris", "", "US", "840", "", "KY", "017", "", "38.2098", "-84.25299", "America/New_York"),("4304232", "Pikeville", "", "US", "840", "", "KY", "195", "", "37.47927", "-82.51876", "America/New_York"),("4304713", "Pleasure Ridge Park", "", "US", "840", "", "KY", "111", "", "38.14535", "-85.8583", "America/Kentucky/Louisville"),("4305266", "Princeton", "", "US", "840", "", "KY", "033", "", "37.10922", "-87.88196", "America/Chicago"),("4305504", "Radcliff", "Радклиф", "US", "840", "", "KY", "093", "", "37.84035", "-85.94913", "America/New_York"),("4305974", "Richmond", "Ричмонд", "US", "840", "", "KY", "151", "", "37.74786", "-84.29465", "America/New_York"),("4307025", "Russellville", "", "US", "840", "", "KY", "141", "", "36.84532", "-86.88722", "America/Chicago"),("4307238", "Saint Matthews", "", "US", "840", "", "KY", "111", "", "38.25285", "-85.65579", "America/Kentucky/Louisville"),("4308122", "Shelbyville", "", "US", "840", "", "KY", "211", "", "38.21201", "-85.22357", "America/New_York"),("4308163", "Shepherdsville", "", "US", "840", "", "KY", "029", "", "37.9884", "-85.71579", "America/New_York"),("4308225", "Shively", "", "US", "840", "", "KY", "111", "", "38.20007", "-85.82274", "America/Kentucky/Louisville"),("4308922", "Somerset", "", "US", "840", "", "KY", "199", "", "37.09202", "-84.60411", "America/New_York"),("4309414", "Saint Dennis", "", "US", "840", "", "KY", "111", "", "38.1884", "-85.8458", "America/Kentucky/Louisville"),("4310616", "Taylor Mill", "", "US", "840", "", "KY", "117", "", "38.99756", "-84.49633", "America/New_York"),("4311646", "Union", "", "US", "840", "", "KY", "015", "", "38.9459", "-84.6805", "America/New_York"),("4311963", "Valley Station", "", "US", "840", "", "KY", "111", "", "38.11118", "-85.87024", "America/Kentucky/Louisville"),("4312057", "Versailles", "", "US", "840", "", "KY", "239", "", "38.05258", "-84.72995", "America/New_York"),("4312088", "Villa Hills", "", "US", "840", "", "KY", "117", "", "39.06339", "-84.593", "America/New_York"),("4312096", "Vine Grove", "", "US", "840", "", "KY", "093", "", "37.81007", "-85.98135", "America/New_York"),("4313563", "Williamsburg", "", "US", "840", "", "KY", "235", "", "36.74342", "-84.15966", "America/New_York"),("4313628", "Wilmore", "", "US", "840", "", "KY", "113", "", "37.86202", "-84.66161", "America/New_York"),("4313697", "Winchester", "", "US", "840", "", "KY", "049", "", "37.99008", "-84.17965", "America/New_York"),("4314295", "Abbeville", "", "US", "840", "", "LA", "113", "", "29.97465", "-92.13429", "America/Chicago"),("4314550", "Alexandria", "Александрия", "US", "840", "", "LA", "079", "", "31.31129", "-92.44514", "America/Chicago"),("4315312", "Baker", "", "US", "840", "", "LA", "033", "", "30.58824", "-91.16816", "America/Chicago"),("4315535", "Bastrop", "", "US", "840", "", "LA", "067", "", "32.75625", "-91.87235", "America/Chicago"),("4315588", "Baton Rouge", "Батон-Руж", "US", "840", "", "LA", "033", "", "30.45075", "-91.15455", "America/Chicago"),("4315768", "Bayou Cane", "", "US", "840", "", "LA", "109", "", "29.6241", "-90.7512", "America/Chicago"),("4316329", "Belle Chasse", "", "US", "840", "", "LA", "075", "", "29.85493", "-89.99063", "America/Chicago"),("4317412", "Bogalusa", "", "US", "840", "", "LA", "117", "", "30.79102", "-89.84869", "America/Chicago"),("4317639", "Bossier City", "", "US", "840", "", "LA", "015", "", "32.51599", "-93.73212", "America/Chicago"),("4317801", "Breaux Bridge", "", "US", "840", "", "LA", "099", "", "30.27353", "-91.89928", "America/Chicago"),("4317864", "Bridge City", "", "US", "840", "", "LA", "051", "", "29.93326", "-90.17007", "America/Chicago"),("4317985", "Broussard", "", "US", "840", "", "LA", "055", "", "30.14715", "-91.96123", "America/Chicago"),("4318037", "Brownsfield", "", "US", "840", "", "LA", "033", "", "30.54658", "-91.12066", "America/Chicago"),("4319030", "Carencro", "", "US", "840", "", "LA", "055", "", "30.31714", "-92.04901", "America/Chicago"),("4319435", "Central", "", "US", "840", "", "LA", "033", "", "30.55435", "-91.03677", "America/Chicago"),("4319507", "Chackbay", "", "US", "840", "", "LA", "057", "", "29.88354", "-90.79732", "America/Chicago"),("4319518", "Chalmette", "", "US", "840", "", "LA", "087", "", "29.94296", "-89.96537", "America/Chicago"),("4320107", "Claiborne", "", "US", "840", "", "LA", "073", "", "32.51598", "-92.1918", "America/Chicago"),("4321005", "Covington", "", "US", "840", "", "LA", "103", "", "30.47549", "-90.10042", "America/Chicago"),("4321310", "Crowley", "", "US", "840", "", "LA", "001", "", "30.21409", "-92.37458", "America/Chicago"),("4321399", "Cut Off", "", "US", "840", "", "LA", "057", "", "29.54272", "-90.33814", "America/Chicago"),("4321781", "DeRidder", "", "US", "840", "", "LA", "011", "", "30.84631", "-93.28905", "America/Chicago"),("4321988", "Denham Springs", "", "US", "840", "", "LA", "063", "", "30.4874", "-90.95753", "America/Chicago"),("4322034", "Destrehan", "", "US", "840", "", "LA", "089", "", "29.94322", "-90.35345", "America/Chicago"),("4322811", "Donaldsonville", "", "US", "840", "", "LA", "005", "", "30.10103", "-90.99288", "America/Chicago"),("4323546", "Eden Isle", "", "US", "840", "", "LA", "103", "", "30.22853", "-89.79867", "America/Chicago"),("4323873", "Estelle", "", "US", "840", "", "LA", "051", "", "29.84576", "-90.10674", "America/Chicago"),("4323900", "Eunice", "", "US", "840", "", "LA", "097", "", "30.49437", "-92.41763", "America/Chicago"),("4325150", "Franklin", "", "US", "840", "", "LA", "101", "", "29.79604", "-91.5015", "America/Chicago"),("4325424", "Galliano", "", "US", "840", "", "LA", "057", "", "29.44216", "-90.29925", "America/Chicago"),("4325507", "Gardere", "", "US", "840", "", "LA", "033", "", "30.34575", "-91.14011", "America/Chicago"),("4325889", "Gonzales", "", "US", "840", "", "LA", "005", "", "30.23853", "-90.9201", "America/Chicago"),("4326074", "Grambling", "", "US", "840", "", "LA", "061", "", "32.52765", "-92.71404", "America/Chicago"),("4326320", "Gray", "", "US", "840", "", "LA", "109", "", "29.69771", "-90.78648", "America/Chicago"),("4326575", "Gretna", "", "US", "840", "", "LA", "051", "", "29.91465", "-90.05396", "America/Chicago"),("4326868", "Hammond", "Хаммонд", "US", "840", "", "LA", "105", "", "30.50463", "-90.46293", "America/Chicago"),("4326916", "Harahan", "", "US", "840", "", "LA", "051", "", "29.94048", "-90.20313", "America/Chicago"),("4327047", "Harvey", "Харви", "US", "840", "", "LA", "051", "", "29.90354", "-90.07729", "America/Chicago"),("4328010", "Houma", "", "US", "840", "", "LA", "109", "", "29.59577", "-90.71953", "America/Chicago"),("4328435", "Inniswold", "", "US", "840", "", "LA", "033", "", "30.40491", "-91.08344", "America/Chicago"),("4328952", "Jeanerette", "", "US", "840", "", "LA", "045", "", "29.91104", "-91.66345", "America/Chicago"),("4328973", "Jefferson", "", "US", "840", "", "LA", "051", "", "29.96604", "-90.15313", "America/Chicago"),("4329037", "Jennings", "", "US", "840", "", "LA", "053", "", "30.22243", "-92.65708", "America/Chicago"),("4329753", "Kenner", "Кеннер", "US", "840", "", "LA", "051", "", "29.99409", "-90.24174", "America/Chicago"),("4330126", "Lacombe", "", "US", "840", "", "LA", "103", "", "30.31353", "-89.94313", "America/Chicago"),("4330145", "Lafayette", "Лафайет", "US", "840", "", "LA", "055", "", "30.22409", "-92.01984", "America/Chicago"),("4330236", "Lake Charles", "Лейк-Чарльз", "US", "840", "", "LA", "019", "", "30.21309", "-93.2044", "America/Chicago"),("4330525", "Laplace", "Лаплас", "US", "840", "", "LA", "095", "", "30.06698", "-90.48147", "America/Chicago"),("4330541", "Larose", "", "US", "840", "", "LA", "057", "", "29.57244", "-90.38175", "America/Chicago"),("4330740", "Leesville", "", "US", "840", "", "LA", "115", "", "31.14352", "-93.261", "America/Chicago"),("4332109", "Luling", "", "US", "840", "", "LA", "089", "", "29.93215", "-90.36647", "America/Chicago"),("4332455", "Mandeville", "", "US", "840", "", "LA", "103", "", "30.35825", "-90.06563", "America/Chicago"),("4332604", "Marksville", "", "US", "840", "", "LA", "009", "", "31.12797", "-92.06624", "America/Chicago"),("4332628", "Marrero", "Марреро", "US", "840", "", "LA", "051", "", "29.89937", "-90.10035", "America/Chicago"),("4333126", "Meraux", "", "US", "840", "", "LA", "087", "", "29.93017", "-89.91623", "America/Chicago"),("4333161", "Merrydale", "", "US", "840", "", "LA", "033", "", "30.5013", "-91.10844", "America/Chicago"),("4333177", "Metairie", "", "US", "840", "", "LA", "051", "", "29.98409", "-90.15285", "America/Chicago"),("4333190", "Metairie Terrace", "", "US", "840", "", "LA", "051", "", "29.97854", "-90.16396", "America/Chicago"),("4333533", "Minden", "", "US", "840", "", "LA", "119", "", "32.61543", "-93.28684", "America/Chicago"),("4333669", "Monroe", "Монро", "US", "840", "", "LA", "073", "", "32.50931", "-92.1193", "America/Chicago"),("4333718", "Monticello", "", "US", "840", "", "LA", "033", "", "30.48908", "-91.04872", "America/Chicago"),("4333811", "Morgan City", "", "US", "840", "", "LA", "101", "", "29.69937", "-91.20677", "America/Chicago"),("4333961", "Moss Bluff", "", "US", "840", "", "LA", "019", "", "30.3027", "-93.19071", "America/Chicago"),("4334720", "Natchitoches", "", "US", "840", "", "LA", "069", "", "31.76072", "-93.08627", "America/Chicago"),("4334971", "New Iberia", "", "US", "840", "", "LA", "045", "", "30.00354", "-91.81873", "America/Chicago"),("4335045", "New Orleans", "Новый Орлеан", "US", "840", "", "LA", "071", "", "29.95465", "-90.07507", "America/Chicago"),("4335754", "Oak Hills Place", "", "US", "840", "", "LA", "033", "", "30.35992", "-91.0876", "America/Chicago"),("4335796", "Oakdale", "", "US", "840", "", "LA", "003", "", "30.81603", "-92.66042", "America/Chicago"),("4335797", "Oakdale", "", "US", "840", "", "LA", "003", "", "30.80547", "-92.62153", "America/Chicago"),("4335963", "Old Jefferson", "", "US", "840", "", "LA", "033", "", "30.38269", "-91.01705", "America/Chicago"),("4336153", "Opelousas", "", "US", "840", "", "LA", "097", "", "30.53353", "-92.08151", "America/Chicago"),("4336646", "Patterson", "", "US", "840", "", "LA", "101", "", "29.69326", "-91.30205", "America/Chicago"),("4337291", "Pineville", "", "US", "840", "", "LA", "079", "", "31.3224", "-92.4343", "America/Chicago"),("4337436", "Plaquemine", "", "US", "840", "", "LA", "047", "", "30.28908", "-91.23427", "America/Chicago"),("4337775", "Ponchatoula", "", "US", "840", "", "LA", "105", "", "30.4388", "-90.44148", "America/Chicago"),("4337823", "Port Allen", "", "US", "840", "", "LA", "121", "", "30.45214", "-91.21011", "America/Chicago"),("4338012", "Prairieville", "", "US", "840", "", "LA", "005", "", "30.30297", "-90.97205", "America/Chicago"),("4338068", "Prien", "", "US", "840", "", "LA", "019", "", "30.18187", "-93.27377", "America/Chicago"),("4338298", "Raceland", "", "US", "840", "", "LA", "057", "", "29.72743", "-90.59898", "America/Chicago"),("4338406", "Rayne", "", "US", "840", "", "LA", "001", "", "30.23493", "-92.26846", "America/Chicago"),("4338615", "Reserve", "", "US", "840", "", "LA", "095", "", "30.05381", "-90.55175", "America/Chicago"),("4338818", "River Ridge", "", "US", "840", "", "LA", "051", "", "29.9602", "-90.21563", "America/Chicago"),("4339348", "Ruston", "", "US", "840", "", "LA", "061", "", "32.52321", "-92.63793", "America/Chicago"),("4339690", "Saint Gabriel", "", "US", "840", "", "LA", "047", "", "30.2577", "-91.09927", "America/Chicago"),("4340196", "Saint Martinville", "", "US", "840", "", "LA", "099", "", "30.1252", "-91.83345", "America/Chicago"),("4340551", "Saint Rose", "", "US", "840", "", "LA", "089", "", "29.94687", "-90.32313", "America/Chicago"),("4341007", "Schriever", "", "US", "840", "", "LA", "109", "", "29.74215", "-90.81037", "America/Chicago"),("4341033", "Scott", "", "US", "840", "", "LA", "055", "", "30.23576", "-92.09457", "America/Chicago"),("4341378", "Shenandoah", "", "US", "840", "", "LA", "033", "", "30.4013", "-91.00094", "America/Chicago"),("4341513", "Shreveport", "Шревепорт", "US", "840", "", "LA", "017", "", "32.52515", "-93.75018", "America/Chicago"),("4341727", "Slidell", "", "US", "840", "", "LA", "103", "", "30.27519", "-89.78117", "America/Chicago"),("4342429", "Springhill", "", "US", "840", "", "LA", "119", "", "33.00597", "-93.46684", "America/Chicago"),("4342816", "Sulphur", "", "US", "840", "", "LA", "019", "", "30.23659", "-93.37738", "America/Chicago"),("4343103", "Tallulah", "", "US", "840", "", "LA", "065", "", "32.40848", "-91.18678", "America/Chicago"),("4343327", "Terrytown", "", "US", "840", "", "LA", "051", "", "29.91021", "-90.03257", "America/Chicago"),("4343429", "Thibodaux", "", "US", "840", "", "LA", "057", "", "29.79576", "-90.82287", "America/Chicago"),("4343659", "Timberlane", "", "US", "840", "", "LA", "051", "", "29.87743", "-90.03202", "America/Chicago"),("4344644", "Village Saint George", "", "US", "840", "", "LA", "033", "", "30.36214", "-91.06733", "America/Chicago"),("4344651", "Ville Platte", "", "US", "840", "", "LA", "039", "", "30.68797", "-92.27152", "America/Chicago"),("4344819", "Waggaman", "", "US", "840", "", "LA", "051", "", "29.91854", "-90.21091", "America/Chicago"),("4344844", "Walker", "", "US", "840", "", "LA", "063", "", "30.48797", "-90.86149", "America/Chicago"),("4345850", "West Monroe", "", "US", "840", "", "LA", "073", "", "32.51848", "-92.14764", "America/Chicago"),("4345968", "Westwego", "", "US", "840", "", "LA", "051", "", "29.90604", "-90.1423", "America/Chicago"),("4346615", "Woodmere", "", "US", "840", "", "LA", "051", "", "29.85798", "-90.08035", "America/Chicago"),("4346788", "Zachary", "", "US", "840", "", "LA", "033", "", "30.64852", "-91.1565", "America/Chicago"),("4346810", "Youngsville", "", "US", "840", "", "LA", "055", "", "30.09965", "-91.99012", "America/Chicago"),("4346913", "Aberdeen", "", "US", "840", "", "MD", "025", "", "39.50956", "-76.16412", "America/New_York"),("4346952", "Accokeek", "", "US", "840", "", "MD", "033", "", "38.66762", "-77.02831", "America/New_York"),("4346991", "Adelphi", "", "US", "840", "", "MD", "033", "", "39.00317", "-76.97192", "America/New_York"),("4347242", "Annapolis", "Аннаполис", "US", "840", "", "MD", "003", "", "38.97845", "-76.49218", "America/New_York"),("4347371", "Arbutus", "", "US", "840", "", "MD", "005", "", "39.25455", "-76.69997", "America/New_York"),("4347426", "Arnold", "Арнольд", "US", "840", "", "MD", "003", "", "39.03206", "-76.50274", "America/New_York"),("4347553", "Aspen Hill", "", "US", "840", "", "MD", "031", "", "39.07955", "-77.07303", "America/New_York"),("4347778", "Baltimore", "Балтимор", "US", "840", "", "MD", "510", "", "39.29038", "-76.61219", "America/New_York"),("4347800", "Baltimore Highlands", "", "US", "840", "", "MD", "005", "", "39.23316", "-76.63663", "America/New_York"),("4347839", "Ballenger Creek", "", "US", "840", "", "MD", "021", "", "39.3726", "-77.43526", "America/New_York"),("4348240", "Bel Air", "", "US", "840", "", "MD", "025", "", "39.53594", "-76.34829", "America/New_York"),("4348353", "Beltsville", "", "US", "840", "", "MD", "033", "", "39.03483", "-76.90747", "America/New_York"),("4348418", "Bennsville", "", "US", "840", "", "MD", "017", "", "38.60929", "-77.0122", "America/New_York"),("4348599", "Bethesda", "Бетесда", "US", "840", "", "MD", "031", "", "38.98067", "-77.10026", "America/New_York"),("4348888", "Bladensburg", "", "US", "840", "", "MD", "033", "", "38.93928", "-76.93386", "America/New_York"),("4349159", "Bowie", "Боуи", "US", "840", "", "MD", "033", "", "38.94278", "-76.73028", "America/New_York"),("4349175", "Bowleys Quarters", "", "US", "840", "", "MD", "005", "", "39.33539", "-76.39024", "America/New_York"),("4349283", "Brandywine", "", "US", "840", "", "MD", "033", "", "38.69678", "-76.84775", "America/New_York"),("4349551", "Brock Hall", "", "US", "840", "", "MD", "033", "", "38.85011", "-76.76108", "America/New_York"),("4349599", "Brooklyn Park", "", "US", "840", "", "MD", "003", "", "39.22844", "-76.61636", "America/New_York"),("4349706", "Brunswick", "", "US", "840", "", "MD", "021", "", "39.31427", "-77.62777", "America/New_York"),("4349727", "Bryans Road", "", "US", "840", "", "MD", "017", "", "38.62706", "-77.07303", "America/New_York"),("4349903", "Burtonsville", "", "US", "840", "", "MD", "031", "", "39.11122", "-76.93248", "America/New_York"),("4350049", "California", "", "US", "840", "", "MD", "037", "", "38.3004", "-76.50745", "America/New_York"),("4350160", "Calverton", "", "US", "840", "", "MD", "033", "", "39.05761", "-76.93581", "America/New_York"),("4350175", "Cambridge", "", "US", "840", "", "MD", "019", "", "38.56317", "-76.07883", "America/New_York"),("4350288", "Camp Springs", "", "US", "840", "", "MD", "033", "", "38.804", "-76.90664", "America/New_York"),("4350348", "Cape Saint Claire", "", "US", "840", "", "MD", "003", "", "39.04317", "-76.44496", "America/New_York"),("4350413", "Carney", "Карни", "US", "840", "", "MD", "005", "", "39.39427", "-76.52358", "America/New_York"),("4350635", "Catonsville", "", "US", "840", "", "MD", "005", "", "39.27205", "-76.73192", "America/New_York"),("4351184", "Chesapeake Beach", "", "US", "840", "", "MD", "009", "", "38.68623", "-76.53468", "America/New_York"),("4351228", "Chesapeake Ranch Estates", "", "US", "840", "", "MD", "009", "", "38.34624", "-76.41773", "America/New_York"),("4351264", "Chestertown", "", "US", "840", "", "MD", "029", "", "39.209", "-76.06661", "America/New_York"),("4351327", "Cheverly", "", "US", "840", "", "MD", "033", "", "38.92817", "-76.91581", "America/New_York"),("4351335", "Chevy Chase", "", "US", "840", "", "MD", "031", "", "39.00287", "-77.07115", "America/New_York"),("4351383", "Chillum", "", "US", "840", "", "MD", "033", "", "38.96372", "-76.99081", "America/New_York"),("4351708", "Clarksburg", "", "US", "840", "", "MD", "031", "", "39.23872", "-77.27943", "America/New_York"),("4351851", "Cloverly", "", "US", "840", "", "MD", "031", "", "39.10816", "-76.99775", "America/New_York"),("4351871", "Clinton", "Клинтон", "US", "840", "", "MD", "033", "", "38.76511", "-76.89831", "America/New_York"),("4351887", "Cockeysville", "", "US", "840", "", "MD", "005", "", "39.48122", "-76.64386", "America/New_York"),("4351951", "Colesville", "", "US", "840", "", "MD", "031", "", "39.07566", "-77.00192", "America/New_York"),("4351977", "College Park", "", "US", "840", "", "MD", "033", "", "38.98067", "-76.93692", "America/New_York"),("4352053", "Columbia", "Колумбия", "US", "840", "", "MD", "027", "", "39.24038", "-76.83942", "America/New_York"),("4352247", "Coral Hills", "", "US", "840", "", "MD", "033", "", "38.87039", "-76.92108", "America/New_York"),("4352539", "Crofton", "Крофтона", "US", "840", "", "MD", "003", "", "39.00178", "-76.68747", "America/New_York"),("4352681", "Cumberland", "Камберленд", "US", "840", "", "MD", "001", "", "39.65287", "-78.76252", "America/New_York"),("4352728", "Damascus", "", "US", "840", "", "MD", "031", "", "39.28844", "-77.20387", "America/New_York"),("4352795", "Darnestown", "", "US", "840", "", "MD", "031", "", "39.10344", "-77.29082", "America/New_York"),("4352815", "Davidsonville", "", "US", "840", "", "MD", "003", "", "38.92289", "-76.6283", "America/New_York"),("4353463", "District Heights", "", "US", "840", "", "MD", "033", "", "38.85761", "-76.88942", "America/New_York"),("4353765", "Dundalk", "Дандолк", "US", "840", "", "MD", "005", "", "39.25066", "-76.52052", "America/New_York"),("4353925", "East Riverdale", "", "US", "840", "", "MD", "033", "", "38.96206", "-76.92192", "America/New_York"),("4353962", "Easton", "Истон", "US", "840", "", "MD", "041", "", "38.77428", "-76.07633", "America/New_York"),("4354060", "Edgemere", "", "US", "840", "", "MD", "005", "", "39.24205", "-76.44802", "America/New_York"),("4354072", "Edgewater", "", "US", "840", "", "MD", "003", "", "38.95706", "-76.54996", "America/New_York"),("4354087", "Edgewood", "", "US", "840", "", "MD", "025", "", "39.41872", "-76.2944", "America/New_York"),("4354163", "Eldersburg", "", "US", "840", "", "MD", "013", "", "39.40371", "-76.95026", "America/New_York"),("4354234", "Elkton", "", "US", "840", "", "MD", "015", "", "39.60678", "-75.83327", "America/New_York"),("4354256", "Elkridge", "", "US", "840", "", "MD", "027", "", "39.21261", "-76.71358", "America/New_York"),("4354265", "Ellicott City", "", "US", "840", "", "MD", "027", "", "39.26733", "-76.79831", "America/New_York"),("4354428", "Essex", "Эссекс", "US", "840", "", "MD", "005", "", "39.30927", "-76.47496", "America/New_York"),("4354573", "Fairland", "", "US", "840", "", "MD", "031", "", "39.07622", "-76.95775", "America/New_York"),("4354708", "Fallston", "", "US", "840", "", "MD", "025", "", "39.51455", "-76.41107", "America/New_York"),("4354821", "Ferndale", "", "US", "840", "", "MD", "003", "", "39.18316", "-76.64024", "America/New_York"),("4355214", "Forest Glen", "", "US", "840", "", "MD", "031", "", "39.01455", "-77.0547", "America/New_York"),("4355274", "Forestville", "", "US", "840", "", "MD", "033", "", "38.84511", "-76.87497", "America/New_York"),("4355322", "Fort George G Mead Junction", "", "US", "840", "", "MD", "027", "", "39.12594", "-76.78914", "America/New_York"),("4355355", "Fort Washington", "", "US", "840", "", "MD", "033", "", "38.70734", "-77.02303", "America/New_York"),("4355400", "Four Corners", "", "US", "840", "", "MD", "031", "", "39.02039", "-77.01275", "America/New_York"),("4355585", "Frederick", "Фредерик", "US", "840", "", "MD", "021", "", "39.41427", "-77.41054", "America/New_York"),("4355670", "Friendly", "", "US", "840", "", "MD", "033", "", "38.75178", "-76.97859", "America/New_York"),("4355756", "Frostburg", "", "US", "840", "", "MD", "001", "", "39.65814", "-78.92836", "America/New_York"),("4355780", "Fruitland", "", "US", "840", "", "MD", "045", "", "38.32206", "-75.6202", "America/New_York"),("4355843", "Gaithersburg", "Гейтерсберг", "US", "840", "", "MD", "031", "", "39.14344", "-77.20137", "America/New_York"),("4355958", "Garrison", "", "US", "840", "", "MD", "005", "", "39.40594", "-76.76053", "America/New_York"),("4356050", "Germantown", "", "US", "840", "", "MD", "031", "", "39.17316", "-77.27165", "America/New_York"),("4356165", "Glassmanor", "", "US", "840", "", "MD", "033", "", "38.819", "-76.99859", "America/New_York"),("4356188", "Glen Burnie", "", "US", "840", "", "MD", "003", "", "39.16261", "-76.62469", "America/New_York"),("4356242", "Glenarden", "", "US", "840", "", "MD", "033", "", "38.92928", "-76.86164", "America/New_York"),("4356280", "Glenmont", "", "US", "840", "", "MD", "031", "", "39.05789", "-77.0497", "America/New_York"),("4356289", "Glenn Dale", "", "US", "840", "", "MD", "033", "", "38.98761", "-76.82053", "America/New_York"),("4356341", "Goddard", "", "US", "840", "", "MD", "033", "", "38.98955", "-76.85331", "America/New_York"),("4356783", "Green Haven", "", "US", "840", "", "MD", "003", "", "39.13955", "-76.54774", "America/New_York"),("4356836", "Green Valley", "", "US", "840", "", "MD", "021", "", "39.30927", "-77.29721", "America/New_York"),("4356847", "Greenbelt", "Гринбелте", "US", "840", "", "MD", "033", "", "39.00455", "-76.87553", "America/New_York"),("4357141", "Hagerstown", "", "US", "840", "", "MD", "043", "", "39.64176", "-77.71999", "America/New_York"),("4357176", "Halfway", "", "US", "840", "", "MD", "043", "", "39.62065", "-77.75888", "America/New_York"),("4357279", "Hampstead", "", "US", "840", "", "MD", "013", "", "39.60483", "-76.84998", "America/New_York"),("4357289", "Hampton", "", "US", "840", "", "MD", "005", "", "39.42288", "-76.58469", "America/New_York"),("4357340", "Hanover", "", "US", "840", "", "MD", "027", "", "39.19289", "-76.72414", "America/New_York"),("4357617", "Havre de Grace", "", "US", "840", "", "MD", "025", "", "39.54928", "-76.09162", "America/New_York"),("4358066", "Hillandale", "", "US", "840", "", "MD", "031", "", "39.0265", "-76.97414", "America/New_York"),("4358082", "Hillcrest Heights", "", "US", "840", "", "MD", "033", "", "38.83289", "-76.95942", "America/New_York"),("4358701", "Hunt Valley", "", "US", "840", "", "MD", "005", "", "39.49983", "-76.64108", "America/New_York"),("4358821", "Hyattsville", "", "US", "840", "", "MD", "033", "", "38.95594", "-76.94553", "America/New_York"),("4358864", "Ilchester", "", "US", "840", "", "MD", "027", "", "39.25094", "-76.76469", "America/New_York"),("4359619", "Joppatowne", "", "US", "840", "", "MD", "025", "", "39.45789", "-76.35524", "America/New_York"),("4359721", "Kemp Mill", "", "US", "840", "", "MD", "031", "", "39.039", "-77.01914", "America/New_York"),("4359858", "Kettering", "", "US", "840", "", "MD", "033", "", "38.88456", "-76.81469", "America/New_York"),("4360103", "La Plata", "", "US", "840", "", "MD", "017", "", "38.52929", "-76.97525", "America/New_York"),("4360138", "Lake Arbor", "", "US", "840", "", "MD", "033", "", "38.90789", "-76.82969", "America/New_York"),("4360201", "Lake Shore", "", "US", "840", "", "MD", "003", "", "39.10705", "-76.48496", "America/New_York"),("4360287", "Landover", "", "US", "840", "", "MD", "033", "", "38.934", "-76.89664", "America/New_York"),("4360314", "Langley Park", "", "US", "840", "", "MD", "033", "", "38.98872", "-76.98136", "America/New_York"),("4360321", "Lanham", "", "US", "840", "", "MD", "033", "", "38.96875", "-76.8634", "America/New_York"),("4360328", "Lansdowne", "", "US", "840", "", "MD", "005", "", "39.24511", "-76.66052", "America/New_York"),("4360345", "Largo", "", "US", "840", "", "MD", "033", "", "38.89761", "-76.83025", "America/New_York"),("4360369", "Laurel", "", "US", "840", "", "MD", "033", "", "39.09928", "-76.84831", "America/New_York"),("4360443", "Layhill", "", "US", "840", "", "MD", "031", "", "39.09233", "-77.04442", "America/New_York"),("4360592", "Lexington Park", "", "US", "840", "", "MD", "037", "", "38.26679", "-76.45384", "America/New_York"),("4360700", "Linganore", "", "US", "840", "", "MD", "021", "", "39.44038", "-77.20804", "America/New_York"),("4360713", "Linthicum", "", "US", "840", "", "MD", "003", "", "39.20511", "-76.65275", "America/New_York"),("4360954", "Lochearn", "", "US", "840", "", "MD", "005", "", "39.34066", "-76.72219", "America/New_York"),("4361094", "Londontowne", "", "US", "840", "", "MD", "003", "", "38.93345", "-76.54941", "America/New_York"),("4361379", "Lutherville", "", "US", "840", "", "MD", "005", "", "39.42122", "-76.62608", "America/New_York"),("4361721", "Marlow Heights", "", "US", "840", "", "MD", "033", "", "38.83345", "-76.95164", "America/New_York"),("4361725", "Marlton", "", "US", "840", "", "MD", "033", "", "38.77373", "-76.78997", "America/New_York"),("4361831", "Maryland City", "", "US", "840", "", "MD", "003", "", "39.09205", "-76.81775", "America/New_York"),("4362001", "Mayo", "", "US", "840", "", "MD", "003", "", "38.88761", "-76.5119", "America/New_York"),("4362009", "Mays Chapel", "", "US", "840", "", "MD", "005", "", "39.43316", "-76.64941", "America/New_York"),("4362344", "Middle River", "", "US", "840", "", "MD", "005", "", "39.33427", "-76.43941", "America/New_York"),("4362438", "Milford Mill", "", "US", "840", "", "MD", "005", "", "39.34788", "-76.76997", "America/New_York"),("4362624", "Mitchellville", "", "US", "840", "", "MD", "033", "", "38.92511", "-76.74275", "America/New_York"),("4362743", "Montgomery Village", "", "US", "840", "", "MD", "031", "", "39.17677", "-77.19526", "America/New_York"),("4362882", "Mount Airy", "", "US", "840", "", "MD", "013", "", "39.37621", "-77.1547", "America/New_York"),("4363124", "Mount Rainier", "", "US", "840", "", "MD", "033", "", "38.9415", "-76.96498", "America/New_York"),("4363611", "New Carrollton", "", "US", "840", "", "MD", "033", "", "38.96983", "-76.87997", "America/New_York"),("4363836", "North Bel Air", "", "US", "840", "", "MD", "025", "", "39.53983", "-76.35496", "America/New_York"),("4363843", "North Bethesda", "", "US", "840", "", "MD", "031", "", "39.04455", "-77.11887", "America/New_York"),("4363960", "North Kensington", "", "US", "840", "", "MD", "031", "", "39.03039", "-77.07248", "America/New_York"),("4363990", "North Potomac", "", "US", "840", "", "MD", "031", "", "39.08289", "-77.26498", "America/New_York"),("4364312", "Ocean City", "", "US", "840", "", "MD", "047", "", "38.3365", "-75.08491", "America/New_York"),("4364326", "Ocean Pines", "", "US", "840", "", "MD", "047", "", "38.39539", "-75.15574", "America/New_York"),("4364362", "Odenton", "", "US", "840", "", "MD", "003", "", "39.084", "-76.70025", "America/New_York"),("4364537", "Olney", "Олни", "US", "840", "", "MD", "031", "", "39.15316", "-77.06692", "America/New_York"),("4364690", "Overlea", "", "US", "840", "", "MD", "005", "", "39.36344", "-76.52052", "America/New_York"),("4364727", "Owings Mills", "", "US", "840", "", "MD", "005", "", "39.41955", "-76.78025", "America/New_York"),("4364759", "Oxon Hill", "", "US", "840", "", "MD", "033", "", "38.80345", "-76.9897", "America/New_York"),("4364946", "Parkville", "", "US", "840", "", "MD", "005", "", "39.37733", "-76.53969", "America/New_York"),("4364964", "Parole", "", "US", "840", "", "MD", "003", "", "38.97956", "-76.53052", "America/New_York"),("4364990", "Pasadena", "Пасадена", "US", "840", "", "MD", "003", "", "39.10733", "-76.57108", "America/New_York"),("4365227", "Perry Hall", "", "US", "840", "", "MD", "005", "", "39.41261", "-76.46357", "America/New_York"),("4365387", "Pikesville", "", "US", "840", "", "MD", "005", "", "39.37427", "-76.72247", "America/New_York"),("4365877", "Poolesville", "", "US", "840", "", "MD", "031", "", "39.14594", "-77.41693", "America/New_York"),("4366001", "Potomac", "Потомак", "US", "840", "", "MD", "031", "", "39.01817", "-77.20859", "America/New_York"),("4366270", "Pumphrey", "", "US", "840", "", "MD", "003", "", "39.21733", "-76.63719", "America/New_York"),("4366476", "Randallstown", "", "US", "840", "", "MD", "005", "", "39.36733", "-76.79525", "America/New_York"),("4366593", "Redland", "", "US", "840", "", "MD", "031", "", "39.14539", "-77.14415", "America/New_York"),("4366647", "Reisterstown", "", "US", "840", "", "MD", "005", "", "39.46976", "-76.8319", "America/New_York"),("4366919", "Riverdale Park", "", "US", "840", "", "MD", "033", "", "38.96344", "-76.93164", "America/New_York"),("4366929", "Riverside", "", "US", "840", "", "MD", "025", "", "39.47372", "-76.24134", "America/New_York"),("4366930", "Riverside", "", "US", "840", "", "MD", "027", "", "39.17344", "-76.88525", "America/New_York"),("4366966", "Riviera Beach", "", "US", "840", "", "MD", "003", "", "39.16678", "-76.50802", "America/New_York"),("4367034", "Robinwood", "", "US", "840", "", "MD", "003", "", "38.95428", "-76.51468", "America/New_York"),("4367035", "Robinwood", "", "US", "840", "", "MD", "043", "", "39.63704", "-77.65694", "America/New_York"),("4367175", "Rockville", "Роквилл", "US", "840", "", "MD", "031", "", "39.084", "-77.15276", "America/New_York"),("4367344", "Rosaryville", "", "US", "840", "", "MD", "033", "", "38.75678", "-76.80969", "America/New_York"),("4367372", "Rosedale", "", "US", "840", "", "MD", "005", "", "39.32011", "-76.51552", "America/New_York"),("4367417", "Rossmoor", "", "US", "840", "", "MD", "031", "", "39.10372", "-77.07109", "America/New_York"),("4367419", "Rossville", "", "US", "840", "", "MD", "005", "", "39.33844", "-76.47968", "America/New_York"),("4367734", "Saint Charles", "", "US", "840", "", "MD", "017", "", "38.60317", "-76.93858", "America/New_York"),("4368711", "Salisbury", "Солсбери", "US", "840", "", "MD", "045", "", "38.36067", "-75.59937", "America/New_York"),("4368879", "Savage", "", "US", "840", "", "MD", "027", "", "39.13789", "-76.82386", "America/New_York"),("4368918", "Scaggsville", "", "US", "840", "", "MD", "027", "", "39.14511", "-76.90025", "America/New_York"),("4369076", "Seabrook", "", "US", "840", "", "MD", "033", "", "38.96805", "-76.84658", "America/New_York"),("4369190", "Severn", "Северн", "US", "840", "", "MD", "003", "", "39.13705", "-76.6983", "America/New_York"),("4369224", "Severna Park", "", "US", "840", "", "MD", "003", "", "39.07039", "-76.54524", "America/New_York"),("4369286", "Shady Side", "", "US", "840", "", "MD", "003", "", "38.84178", "-76.51218", "America/New_York"),("4369571", "Silver Hill", "", "US", "840", "", "MD", "033", "", "38.84178", "-76.94581", "America/New_York"),("4369596", "Silver Spring", "", "US", "840", "", "MD", "031", "", "38.99067", "-77.02609", "America/New_York"),("4369928", "South Bel Air", "", "US", "840", "", "MD", "025", "", "39.53316", "-76.33746", "America/New_York"),("4369964", "South Gate", "", "US", "840", "", "MD", "003", "", "39.129", "-76.6258", "America/New_York"),("4369976", "South Kensington", "", "US", "840", "", "MD", "031", "", "39.019", "-77.07998", "America/New_York"),("4369978", "South Laurel", "", "US", "840", "", "MD", "033", "", "39.06983", "-76.85025", "America/New_York"),("4370201", "Spring Ridge", "", "US", "840", "", "MD", "021", "", "39.40149", "-77.35248", "America/New_York"),("4370366", "Stevensville", "", "US", "840", "", "MD", "035", "", "38.98067", "-76.3144", "America/New_York"),("4370616", "Suitland", "", "US", "840", "", "MD", "033", "", "38.84872", "-76.92386", "America/New_York"),("4370890", "Takoma Park", "", "US", "840", "", "MD", "031", "", "38.97789", "-77.00748", "America/New_York"),("4370931", "Taneytown", "", "US", "840", "", "MD", "013", "", "39.65788", "-77.17443", "America/New_York"),("4371053", "Temple Hills", "", "US", "840", "", "MD", "033", "", "38.814", "-76.94553", "America/New_York"),("4371334", "Thurmont", "", "US", "840", "", "MD", "021", "", "39.62371", "-77.41082", "America/New_York"),("4371420", "Timonium", "", "US", "840", "", "MD", "005", "", "39.43705", "-76.61969", "America/New_York"),("4371582", "Towson", "", "US", "840", "", "MD", "005", "", "39.4015", "-76.60191", "America/New_York"),("4371635", "Travilah", "", "US", "840", "", "MD", "031", "", "39.069", "-77.26304", "America/New_York"),("4372201", "Urbana", "", "US", "840", "", "MD", "021", "", "39.32594", "-77.35137", "America/New_York"),("4372599", "Waldorf", "", "US", "840", "", "MD", "017", "", "38.62456", "-76.93914", "America/New_York"),("4372623", "Walker Mill", "", "US", "840", "", "MD", "033", "", "38.87539", "-76.88831", "America/New_York"),("4372630", "Walkersville", "", "US", "840", "", "MD", "021", "", "39.48621", "-77.35193", "America/New_York"),("4373104", "West Elkridge", "", "US", "840", "", "MD", "027", "", "39.20705", "-76.72692", "America/New_York"),("4373238", "Westminster", "", "US", "840", "", "MD", "013", "", "39.57538", "-76.99581", "America/New_York"),("4373275", "Westphalia", "", "US", "840", "", "MD", "033", "", "38.84539", "-76.81108", "America/New_York"),("4373349", "Wheaton", "", "US", "840", "", "MD", "031", "", "39.03983", "-77.05526", "America/New_York"),("4373426", "White Marsh", "", "US", "840", "", "MD", "005", "", "39.38372", "-76.43218", "America/New_York"),("4373449", "White Oak", "", "US", "840", "", "MD", "031", "", "39.03983", "-76.99303", "America/New_York"),("4374054", "Woodlawn", "", "US", "840", "", "MD", "005", "", "39.32288", "-76.72803", "America/New_York"),("4374056", "Woodlawn", "", "US", "840", "", "MD", "033", "", "38.94956", "-76.89136", "America/New_York"),("4374513", "Affton", "", "US", "840", "", "MO", "189", "", "38.55061", "-90.33317", "America/Chicago"),("4375087", "Arnold", "Арнольд", "US", "840", "", "MO", "099", "", "38.43283", "-90.37762", "America/Chicago"),("4375349", "Aurora", "", "US", "840", "", "MO", "109", "", "36.97089", "-93.71798", "America/Chicago"),("4375663", "Ballwin", "", "US", "840", "", "MO", "189", "", "38.59505", "-90.54623", "America/Chicago"),("4375832", "Barnhart", "", "US", "840", "", "MO", "099", "", "38.34422", "-90.39345", "America/Chicago"),("4375979", "Battlefield", "", "US", "840", "", "MO", "077", "", "37.11561", "-93.37019", "America/Chicago"),("4376444", "Bellefontaine Neighbors", "", "US", "840", "", "MO", "189", "", "38.74033", "-90.2265", "America/Chicago"),("4376482", "Belton", "Белтон", "US", "840", "", "MO", "037", "", "38.81195", "-94.5319", "America/Chicago"),("4376623", "Berkeley", "", "US", "840", "", "MO", "189", "", "38.7545", "-90.33123", "America/Chicago"),("4377295", "Black Jack", "", "US", "840", "", "MO", "189", "", "38.79338", "-90.26733", "America/Chicago"),("4377664", "Blue Springs", "", "US", "840", "", "MO", "095", "", "39.01695", "-94.28161", "America/Chicago"),("4377835", "Bolivar", "", "US", "840", "", "MO", "167", "", "37.61448", "-93.41047", "America/Chicago"),("4377913", "Bonne Terre", "", "US", "840", "", "MO", "187", "", "37.92311", "-90.5554", "America/Chicago"),("4377957", "Boonville", "", "US", "840", "", "MO", "053", "", "38.97364", "-92.74324", "America/Chicago"),("4378070", "Bowling Green", "", "US", "840", "", "MO", "163", "", "39.34199", "-91.19514", "America/Chicago"),("4378219", "Branson", "", "US", "840", "", "MO", "213", "", "36.64367", "-93.21851", "America/Chicago"),("4378312", "Brentwood", "", "US", "840", "", "MO", "189", "", "38.61755", "-90.34928", "America/Chicago"),("4378391", "Bridgeton", "", "US", "840", "", "MO", "189", "", "38.767", "-90.41151", "America/Chicago"),("4379644", "Cameron", "", "US", "840", "", "MO", "049", "", "39.74028", "-94.24106", "America/Chicago"),("4379966", "Cape Girardeau", "", "US", "840", "", "MO", "031", "", "37.30588", "-89.51815", "America/Chicago"),("4380043", "Carl Junction", "", "US", "840", "", "MO", "097", "", "37.17672", "-94.56551", "America/Chicago"),("4380202", "Carthage", "", "US", "840", "", "MO", "097", "", "37.17645", "-94.31022", "America/Chicago"),("4380211", "Caruthersville", "", "US", "840", "", "MO", "155", "", "36.19312", "-89.65564", "America/Chicago"),("4380997", "Charleston", "", "US", "840", "", "MO", "133", "", "36.92089", "-89.35063", "America/Chicago"),("4381072", "Chesterfield", "", "US", "840", "", "MO", "189", "", "38.66311", "-90.57707", "America/Chicago"),("4381104", "Chillicothe", "", "US", "840", "", "MO", "117", "", "39.79529", "-93.55244", "America/Chicago"),("4381478", "Clayton", "", "US", "840", "", "MO", "189", "", "38.64255", "-90.32373", "America/Chicago"),("4381643", "Clinton", "", "US", "840", "", "MO", "083", "", "38.36863", "-93.77827", "America/Chicago"),("4381982", "Columbia", "Колумбия", "US", "840", "", "MO", "019", "", "38.95171", "-92.33407", "America/Chicago"),("4382072", "Concord", "", "US", "840", "", "MO", "189", "", "38.5245", "-90.35734", "America/Chicago"),("4382833", "Crestwood", "", "US", "840", "", "MO", "189", "", "38.557", "-90.38178", "America/Chicago"),("4382837", "Creve Coeur", "", "US", "840", "", "MO", "189", "", "38.66089", "-90.42262", "America/Chicago"),("4383306", "Dardenne Prairie", "", "US", "840", "", "MO", "183", "", "38.7695", "-90.72902", "America/Chicago"),("4383513", "De Soto", "", "US", "840", "", "MO", "099", "", "38.1395", "-90.55513", "America/Chicago"),("4383713", "Dellwood", "", "US", "840", "", "MO", "189", "", "38.7495", "-90.28567", "America/Chicago"),("4383778", "Des Peres", "", "US", "840", "", "MO", "189", "", "38.60089", "-90.4329", "America/Chicago"),("4383857", "Dexter", "", "US", "840", "", "MO", "207", "", "36.79589", "-89.95787", "America/Chicago"),("4385018", "East Independence", "", "US", "840", "", "MO", "095", "", "39.09556", "-94.35523", "America/Chicago"),("4385494", "Ellisville", "", "US", "840", "", "MO", "189", "", "38.59255", "-90.58707", "America/Chicago"),("4385835", "Eureka", "", "US", "840", "", "MO", "189", "", "38.50255", "-90.6279", "America/Chicago"),("4385966", "Excelsior Springs", "", "US", "840", "", "MO", "047", "", "39.33917", "-94.22606", "America/Chicago"),("4386289", "Farmington", "Фармингтон", "US", "840", "", "MO", "187", "", "37.78088", "-90.42179", "America/Chicago"),("4386387", "Ferguson", "Фергюсон", "US", "840", "", "MO", "189", "", "38.74422", "-90.30539", "America/Chicago"),("4386419", "Festus", "", "US", "840", "", "MO", "099", "", "38.22061", "-90.39595", "America/Chicago"),("4386685", "Flat River", "", "US", "840", "", "MO", "187", "", "37.85005", "-90.51679", "America/Chicago"),("4386802", "Florissant", "", "US", "840", "", "MO", "189", "", "38.78922", "-90.32261", "America/Chicago"),("4387496", "Fulton", "", "US", "840", "", "MO", "027", "", "38.84671", "-91.94796", "America/Chicago"),("4387990", "Gladstone", "Гладстон", "US", "840", "", "MO", "047", "", "39.20389", "-94.55468", "America/Chicago"),("4388005", "Glasgow Village", "", "US", "840", "", "MO", "189", "", "38.75366", "-90.19844", "America/Chicago"),("4388036", "Glendale", "", "US", "840", "", "MO", "189", "", "38.59589", "-90.37706", "America/Chicago"),("4388402", "Grain Valley", "", "US", "840", "", "MO", "095", "", "39.01501", "-94.19856", "America/Chicago"),("4388460", "Grandview", "", "US", "840", "", "MO", "095", "", "38.88584", "-94.53301", "America/Chicago"),("4388831", "Greenwood", "", "US", "840", "", "MO", "095", "", "38.85168", "-94.34384", "America/Chicago"),("4389418", "Hannibal", "Ганнибал", "US", "840", "", "MO", "127", "", "39.70838", "-91.35848", "America/Chicago"),("4389658", "Harrisonville", "", "US", "840", "", "MO", "037", "", "38.65334", "-94.34884", "America/Chicago"),("4389967", "Hazelwood", "", "US", "840", "", "MO", "189", "", "38.77144", "-90.37095", "America/Chicago"),("4391812", "Independence", "Индепенденс", "US", "840", "", "MO", "095", "", "39.09112", "-94.41551", "America/Chicago"),("4392163", "Jackson", "", "US", "840", "", "MO", "031", "", "37.38227", "-89.66621", "America/Chicago"),("4392388", "Jefferson City", "Джефферсон-Сити", "US", "840", "", "MO", "051", "", "38.5767", "-92.17352", "America/Chicago"),("4392445", "Jennings", "", "US", "840", "", "MO", "189", "", "38.71922", "-90.26039", "America/Chicago"),("4392768", "Joplin", "Джоплин", "US", "840", "", "MO", "097", "", "37.08423", "-94.51328", "America/Chicago"),("4393217", "Kansas City", "Канзас-Сити", "US", "840", "", "MO", "095", "", "39.09973", "-94.57857", "America/Chicago"),("4393269", "Kearney", "", "US", "840", "", "MO", "047", "", "39.36778", "-94.36217", "America/Chicago"),("4393451", "Kennett", "", "US", "840", "", "MO", "069", "", "36.23618", "-90.05565", "America/Chicago"),("4393739", "Kirkwood", "Кирквуда", "US", "840", "", "MO", "189", "", "38.58339", "-90.40678", "America/Chicago"),("4394084", "Ladue", "", "US", "840", "", "MO", "189", "", "38.64977", "-90.38067", "America/Chicago"),("4394302", "Lake Saint Louis", "", "US", "840", "", "MO", "183", "", "38.79755", "-90.78568", "America/Chicago"),("4394794", "Lebanon", "", "US", "840", "", "MO", "105", "", "37.6806", "-92.66379", "America/Chicago"),("4394870", "Lee's Summit", "", "US", "840", "", "MO", "095", "", "38.91084", "-94.38217", "America/Chicago"),("4394905", "Lemay", "", "US", "840", "", "MO", "189", "", "38.53339", "-90.27928", "America/Chicago"),("4395052", "Liberty", "", "US", "840", "", "MO", "047", "", "39.24611", "-94.41912", "America/Chicago"),("4396767", "Macon", "", "US", "840", "", "MO", "121", "", "39.74226", "-92.47269", "America/Chicago"),("4396915", "Manchester", "Манчестер", "US", "840", "", "MO", "189", "", "38.597", "-90.50929", "America/Chicago"),("4397042", "Maplewood", "", "US", "840", "", "MO", "189", "", "38.61255", "-90.32456", "America/Chicago"),("4397211", "Marshall", "", "US", "840", "", "MO", "195", "", "39.12308", "-93.19687", "America/Chicago"),("4397238", "Marshfield", "", "US", "840", "", "MO", "225", "", "37.33866", "-92.90712", "America/Chicago"),("4397340", "Maryland Heights", "", "US", "840", "", "MO", "189", "", "38.71311", "-90.42984", "America/Chicago"),("4397962", "Mehlville", "", "US", "840", "", "MO", "189", "", "38.50839", "-90.32289", "America/Chicago"),("4398103", "Mexico", "", "US", "840", "", "MO", "007", "", "39.16976", "-91.88295", "America/Chicago"),("4398730", "Moberly", "", "US", "840", "", "MO", "175", "", "39.41837", "-92.43824", "America/Chicago"),("4398776", "Monett", "", "US", "840", "", "MO", "009", "", "36.92895", "-93.92771", "America/Chicago"),("4399914", "Murphy", "", "US", "840", "", "MO", "099", "", "38.49033", "-90.48707", "America/Chicago"),("4400183", "Neosho", "", "US", "840", "", "MO", "145", "", "36.86896", "-94.368", "America/Chicago"),("4400203", "Nevada", "", "US", "840", "", "MO", "217", "", "37.83921", "-94.35467", "America/Chicago"),("4400648", "Nixa", "", "US", "840", "", "MO", "043", "", "37.04339", "-93.29435", "America/Chicago"),("4401242", "O'Fallon", "", "US", "840", "", "MO", "183", "", "38.81061", "-90.69985", "America/Chicago"),("4401282", "Oak Grove", "", "US", "840", "", "MO", "095", "", "39.00501", "-94.12939", "America/Chicago"),("4401618", "Oakville", "", "US", "840", "", "MO", "189", "", "38.47005", "-90.30456", "America/Chicago"),("4401659", "Odessa", "", "US", "840", "", "MO", "107", "", "38.99917", "-93.95356", "America/Chicago"),("4401938", "Olivette", "", "US", "840", "", "MO", "189", "", "38.66533", "-90.37595", "America/Chicago"),("4402178", "Overland", "", "US", "840", "", "MO", "189", "", "38.70116", "-90.36234", "America/Chicago"),("4402245", "Ozark", "", "US", "840", "", "MO", "043", "", "37.02089", "-93.20602", "America/Chicago"),("4402300", "Pacific", "", "US", "840", "", "MO", "071", "", "38.482", "-90.74152", "America/Chicago"),("4402479", "Park Hills", "", "US", "840", "", "MO", "187", "", "37.85422", "-90.51818", "America/Chicago"),("4402544", "Parkville", "", "US", "840", "", "MO", "165", "", "39.195", "-94.68218", "America/Chicago"),("4402998", "Perryville", "", "US", "840", "", "MO", "157", "", "37.72422", "-89.86122", "America/Chicago"),("4403102", "Pevely", "", "US", "840", "", "MO", "099", "", "38.28339", "-90.39512", "America/Chicago"),("4403710", "Pleasant Hill", "", "US", "840", "", "MO", "037", "", "38.78751", "-94.26939", "America/Chicago"),("4404233", "Poplar Bluff", "", "US", "840", "", "MO", "023", "", "36.757", "-90.39289", "America/Chicago"),("4405180", "Raymore", "", "US", "840", "", "MO", "037", "", "38.80195", "-94.45273", "America/Chicago"),("4405188", "Raytown", "", "US", "840", "", "MO", "095", "", "39.00862", "-94.46356", "America/Chicago"),("4405434", "Republic", "", "US", "840", "", "MO", "077", "", "37.12005", "-93.48019", "America/Chicago"),("4405588", "Richmond", "", "US", "840", "", "MO", "177", "", "39.27862", "-93.97689", "America/Chicago"),("4405589", "Richmond Heights", "", "US", "840", "", "MO", "189", "", "38.62866", "-90.31956", "America/Chicago"),("4406282", "Rolla", "Ролла", "US", "840", "", "MO", "161", "", "37.95143", "-91.77127", "America/Chicago"),("4406783", "Saint Ann", "", "US", "840", "", "MO", "189", "", "38.72727", "-90.38317", "America/Chicago"),("4406831", "Saint Charles", "Сент-Чарльз", "US", "840", "", "MO", "183", "", "38.78394", "-90.48123", "America/Chicago"),("4406941", "Saint John", "", "US", "840", "", "MO", "189", "", "38.71484", "-90.34627", "America/Chicago"),("4406951", "Saint Johns", "", "US", "840", "", "MO", "189", "", "38.71338", "-90.34317", "America/Chicago"),("4407010", "Saint Joseph", "Сент-Джозеф", "US", "840", "", "MO", "021", "", "39.76861", "-94.84663", "America/Chicago"),("4407066", "St. Louis", "Сент-Луис", "US", "840", "", "MO", "510", "", "38.62727", "-90.19789", "America/Chicago"),("4407237", "Saint Peters", "Санкт-Петербу", "US", "840", "", "MO", "183", "", "38.80033", "-90.62651", "America/Chicago"),("4407617", "Sappington", "", "US", "840", "", "MO", "189", "", "38.537", "-90.37984", "America/Chicago"),("4407665", "Savannah", "", "US", "840", "", "MO", "003", "", "39.94166", "-94.83025", "America/Chicago"),("4408000", "Sedalia", "", "US", "840", "", "MO", "159", "", "38.70446", "-93.22826", "America/Chicago"),("4408611", "Shrewsbury", "", "US", "840", "", "MO", "189", "", "38.59033", "-90.33678", "America/Chicago"),("4408672", "Sikeston", "", "US", "840", "", "MO", "201", "", "36.87672", "-89.58786", "America/Chicago"),("4409199", "Smithville", "", "US", "840", "", "MO", "047", "", "39.38694", "-94.58107", "America/Chicago"),("4409591", "Spanish Lake", "", "US", "840", "", "MO", "189", "", "38.78783", "-90.21594", "America/Chicago"),("4409896", "Springfield", "Спрингфилд", "US", "840", "", "MO", "077", "", "37.21533", "-93.29824", "America/Chicago"),("4410669", "Sullivan", "", "US", "840", "", "MO", "071", "", "38.2081", "-91.16042", "America/Chicago"),("4410836", "Sunset Hills", "", "US", "840", "", "MO", "189", "", "38.53894", "-90.40734", "America/Chicago"),("4411912", "Town and Country", "", "US", "840", "", "MO", "189", "", "38.61228", "-90.46345", "America/Chicago"),("4412089", "Troy", "", "US", "840", "", "MO", "113", "", "38.97949", "-90.9807", "America/Chicago"),("4412454", "Union", "", "US", "840", "", "MO", "071", "", "38.45005", "-91.00848", "America/Chicago"),("4412697", "University City", "", "US", "840", "", "MO", "189", "", "38.65588", "-90.30928", "America/Chicago"),("4412820", "Valley Park", "", "US", "840", "", "MO", "189", "", "38.54922", "-90.49262", "America/Chicago"),("4413595", "Warrensburg", "", "US", "840", "", "MO", "101", "", "38.76279", "-93.73605", "America/Chicago"),("4413598", "Warrenton", "", "US", "840", "", "MO", "219", "", "38.81144", "-91.14154", "America/Chicago"),("4413621", "Washington", "", "US", "840", "", "MO", "071", "", "38.55811", "-91.01209", "America/Chicago"),("4413802", "Waynesville", "", "US", "840", "", "MO", "169", "", "37.82865", "-92.20072", "America/Chicago"),("4413842", "Webb City", "", "US", "840", "", "MO", "097", "", "37.14645", "-94.463", "America/Chicago"),("4413872", "Webster Groves", "", "US", "840", "", "MO", "189", "", "38.59255", "-90.35734", "America/Chicago"),("4413926", "Weldon Spring", "", "US", "840", "", "MO", "183", "", "38.71339", "-90.68929", "America/Chicago"),("4414001", "Wentzville", "", "US", "840", "", "MO", "183", "", "38.81144", "-90.85291", "America/Chicago"),("4414200", "West Plains", "", "US", "840", "", "MO", "091", "", "36.72812", "-91.85237", "America/Chicago"),("4414749", "Wildwood", "", "US", "840", "", "MO", "189", "", "38.58283", "-90.6629", "America/Chicago"),("4414816", "Willard", "", "US", "840", "", "MO", "077", "", "37.30505", "-93.42853", "America/Chicago"),("4415813", "Aberdeen", "", "US", "840", "", "MS", "095", "", "33.82511", "-88.54366", "America/Chicago"),("4416192", "Amory", "", "US", "840", "", "MS", "095", "", "33.98428", "-88.4881", "America/Chicago"),("4417130", "Batesville", "", "US", "840", "", "MS", "107", "", "34.3115", "-89.94426", "America/Chicago"),("4417205", "Bay Saint Louis", "", "US", "840", "", "MS", "045", "", "30.30881", "-89.33005", "America/Chicago"),("4418478", "Biloxi", "Билокси", "US", "840", "", "MS", "047", "", "30.39603", "-88.88531", "America/Chicago"),("4419094", "Booneville", "", "US", "840", "", "MS", "117", "", "34.65815", "-88.56672", "America/Chicago"),("4419290", "Brandon", "Брэндон", "US", "840", "", "MS", "121", "", "32.2732", "-89.98592", "America/Chicago"),("4419500", "Brookhaven", "", "US", "840", "", "MS", "085", "", "31.57906", "-90.44065", "America/Chicago"),("4420177", "Byram", "", "US", "840", "", "MS", "049", "", "32.17932", "-90.24537", "America/Chicago"),("4420617", "Canton", "", "US", "840", "", "MS", "089", "", "32.61264", "-90.03675", "America/Chicago"),("4420719", "Carriere", "", "US", "840", "", "MS", "109", "", "30.61686", "-89.65256", "America/Chicago"),("4421935", "Clarksdale", "", "US", "840", "", "MS", "027", "", "34.20011", "-90.57093", "America/Chicago"),("4422106", "Cleveland", "", "US", "840", "", "MS", "011", "", "33.744", "-90.72482", "America/Chicago"),("4422133", "Clinton", "Клинтон", "US", "840", "", "MS", "049", "", "32.34153", "-90.32176", "America/Chicago"),("4422442", "Columbus", "Колумбус", "US", "840", "", "MS", "087", "", "33.49567", "-88.42726", "America/Chicago"),("4422457", "Columbia", "", "US", "840", "", "MS", "091", "", "31.25184", "-89.83758", "America/Chicago"),("4422713", "Corinth", "", "US", "840", "", "MS", "003", "", "34.93425", "-88.52227", "America/Chicago"),("4423395", "D'Iberville", "", "US", "840", "", "MS", "047", "", "30.42631", "-88.89086", "America/Chicago"),("4423888", "Diamondhead", "", "US", "840", "", "MS", "045", "", "30.39464", "-89.36394", "America/Chicago"),("4426822", "Flowood", "", "US", "840", "", "MS", "121", "", "32.30959", "-90.13898", "America/Chicago"),("4426884", "Forest", "", "US", "840", "", "MS", "123", "", "32.36459", "-89.47423", "America/Chicago"),("4427569", "Gautier", "Готье", "US", "840", "", "MS", "059", "", "30.38575", "-88.61169", "America/Chicago"),("4428475", "Greenville", "Гринвилл", "US", "840", "", "MS", "151", "", "33.41012", "-91.06177", "America/Chicago"),("4428495", "Greenwood", "", "US", "840", "", "MS", "083", "", "33.51623", "-90.17953", "America/Chicago"),("4428539", "Grenada", "", "US", "840", "", "MS", "043", "", "33.769", "-89.80842", "America/Chicago"),("4428654", "Gulf Hills", "", "US", "840", "", "MS", "059", "", "30.43048", "-88.84225", "America/Chicago"),("4428663", "Gulf Park Estates", "", "US", "840", "", "MS", "059", "", "30.39187", "-88.76114", "America/Chicago"),("4428667", "Gulfport", "Галфпорта", "US", "840", "", "MS", "047", "", "30.36742", "-89.09282", "America/Chicago"),("4429295", "Hattiesburg", "", "US", "840", "", "MS", "035", "", "31.32712", "-89.29034", "America/Chicago"),("4429589", "Hernando", "", "US", "840", "", "MS", "033", "", "34.82399", "-89.9937", "America/Chicago"),("4430103", "Holly Springs", "", "US", "840", "", "MS", "091", "", "31.31573", "-89.97786", "America/Chicago"),("4430104", "Holly Springs", "", "US", "840", "", "MS", "093", "", "34.7676", "-89.44869", "America/Chicago"),("4430400", "Horn Lake", "", "US", "840", "", "MS", "033", "", "34.95537", "-90.03481", "America/Chicago"),("4430981", "Indianola", "", "US", "840", "", "MS", "133", "", "33.45095", "-90.65509", "America/Chicago"),("4431410", "Jackson", "Джексон", "US", "840", "", "MS", "049", "", "32.29876", "-90.18481", "America/Chicago"),("4432542", "Kosciusko", "", "US", "840", "", "MS", "007", "", "33.058", "-89.58956", "America/Chicago"),("4433016", "Latimer", "", "US", "840", "", "MS", "059", "", "30.53464", "-88.8667", "America/Chicago"),("4433039", "Laurel", "", "US", "840", "", "MS", "067", "", "31.69405", "-89.13061", "America/Chicago"),("4434069", "Long Beach", "", "US", "840", "", "MS", "047", "", "30.35048", "-89.15282", "America/Chicago"),("4434283", "Louisville", "", "US", "840", "", "MS", "159", "", "33.12374", "-89.05506", "America/Chicago"),("4434663", "Madison", "Мадисон", "US", "840", "", "MS", "089", "", "32.46181", "-90.11536", "America/Chicago"),("4435318", "McComb", "", "US", "840", "", "MS", "113", "", "31.24379", "-90.45315", "America/Chicago"),("4435764", "Meridian", "Меридиан", "US", "840", "", "MS", "075", "", "32.36431", "-88.70366", "America/Chicago"),("4436743", "Moss Point", "", "US", "840", "", "MS", "059", "", "30.41159", "-88.53446", "America/Chicago"),("4437982", "Natchez", "Натчез", "US", "840", "", "MS", "001", "", "31.56044", "-91.40317", "America/Chicago"),("4438121", "New Albany", "", "US", "840", "", "MS", "145", "", "34.49427", "-89.00784", "America/Chicago"),("4439506", "Ocean Springs", "", "US", "840", "", "MS", "059", "", "30.41131", "-88.82781", "America/Chicago"),("4439869", "Olive Branch", "", "US", "840", "", "MS", "033", "", "34.96176", "-89.82953", "America/Chicago"),("4440076", "Oxford", "Оксфорд", "US", "840", "", "MS", "071", "", "34.3665", "-89.51925", "America/Chicago"),("4440397", "Pascagoula", "Паскагула", "US", "840", "", "MS", "059", "", "30.36576", "-88.55613", "America/Chicago"),("4440413", "Pass Christian", "", "US", "840", "", "MS", "047", "", "30.31575", "-89.24754", "America/Chicago"),("4440559", "Pearl", "", "US", "840", "", "MS", "121", "", "32.27459", "-90.13203", "America/Chicago"),("4440837", "Petal", "", "US", "840", "", "MS", "035", "", "31.34656", "-89.26006", "America/Chicago"),("4440906", "Philadelphia", "", "US", "840", "", "MS", "099", "", "32.77152", "-89.11673", "America/Chicago"),("4440975", "Picayune", "", "US", "840", "", "MS", "109", "", "30.52556", "-89.67788", "America/Chicago"),("4442067", "Pontotoc", "", "US", "840", "", "MS", "115", "", "34.24788", "-88.99867", "America/Chicago"),("4443249", "Richland", "", "US", "840", "", "MS", "121", "", "32.23904", "-90.15842", "America/Chicago"),("4443296", "Ridgeland", "", "US", "840", "", "MS", "089", "", "32.42848", "-90.13231", "America/Chicago"),("4443338", "Ripley", "", "US", "840", "", "MS", "139", "", "34.72982", "-88.95062", "America/Chicago"),("4444938", "Saltillo", "", "US", "840", "", "MS", "081", "", "34.37649", "-88.68172", "America/Chicago"),("4445447", "Senatobia", "", "US", "840", "", "MS", "137", "", "34.6176", "-89.9687", "America/Chicago"),("4446675", "Southaven", "", "US", "840", "", "MS", "033", "", "34.98898", "-90.01259", "America/Chicago"),("4447069", "Saint Martin", "", "US", "840", "", "MS", "059", "", "30.43798", "-88.86809", "America/Chicago"),("4447161", "Starkville", "", "US", "840", "", "MS", "105", "", "33.45049", "-88.81961", "America/Chicago"),("4448903", "Tupelo", "", "US", "840", "", "MS", "081", "", "34.25807", "-88.70464", "America/Chicago"),("4449532", "Vancleave", "", "US", "840", "", "MS", "059", "", "30.54047", "-88.68752", "America/Chicago"),("4449620", "Vicksburg", "Виксберг", "US", "840", "", "MS", "149", "", "32.35265", "-90.87788", "America/Chicago"),("4450411", "Waveland", "", "US", "840", "", "MS", "045", "", "30.28686", "-89.37616", "America/Chicago"),("4450687", "West Gulfport", "", "US", "840", "", "MS", "047", "", "30.40409", "-89.0942", "America/Chicago"),("4450695", "West Hattiesburg", "", "US", "840", "", "MS", "073", "", "31.31906", "-89.37506", "America/Chicago"),("4450753", "West Point", "", "US", "840", "", "MS", "025", "", "33.60762", "-88.65033", "America/Chicago"),("4451810", "Yazoo City", "", "US", "840", "", "MS", "163", "", "32.85513", "-90.40565", "America/Chicago"),("4452137", "Aberdeen", "", "US", "840", "", "NC", "125", "", "35.13155", "-79.42948", "America/New_York"),("4452303", "Albemarle", "", "US", "840", "", "NC", "167", "", "35.35014", "-80.20006", "America/New_York"),("4452808", "Apex", "Апекс", "US", "840", "", "NC", "183", "", "35.73265", "-78.85029", "America/New_York"),("4452871", "Archdale", "", "US", "840", "", "NC", "151", "", "35.91458", "-79.97198", "America/New_York"),("4453035", "Asheboro", "", "US", "840", "", "NC", "151", "", "35.70791", "-79.81364", "America/New_York"),("4453066", "Asheville", "Эшвилл", "US", "840", "", "NC", "021", "", "35.60095", "-82.55402", "America/New_York"),("4453271", "Ayden", "", "US", "840", "", "NC", "147", "", "35.47266", "-77.41552", "America/New_York"),("4454860", "Belmont", "", "US", "840", "", "NC", "071", "", "35.24292", "-81.0373", "America/New_York"),("4455080", "Bessemer City", "", "US", "840", "", "NC", "071", "", "35.28486", "-81.28397", "America/New_York"),("4456121", "Black Mountain", "", "US", "840", "", "NC", "021", "", "35.6179", "-82.32123", "America/New_York"),("4456593", "Boiling Spring Lakes", "", "US", "840", "", "NC", "019", "", "34.03045", "-78.06721", "America/New_York"),("4456703", "Boone", "", "US", "840", "", "NC", "189", "", "36.21679", "-81.67455", "America/New_York"),("4457040", "Brevard", "", "US", "840", "", "NC", "175", "", "35.23345", "-82.73429", "America/New_York"),("4458228", "Burlington", "Берлингтон", "US", "840", "", "NC", "001", "", "36.09569", "-79.4378", "America/New_York"),("4458372", "Butner", "", "US", "840", "", "NC", "077", "", "36.13209", "-78.75667", "America/New_York"),("4459261", "Carolina Beach", "", "US", "840", "", "NC", "129", "", "34.03517", "-77.8936", "America/New_York"),("4459343", "Carrboro", "", "US", "840", "", "NC", "135", "", "35.91014", "-79.07529", "America/New_York"),("4459467", "Cary", "Кэри", "US", "840", "", "NC", "183", "", "35.79154", "-78.78112", "America/New_York"),("4460162", "Chapel Hill", "", "US", "840", "", "NC", "135", "", "35.9132", "-79.05584", "America/New_York"),("4460243", "Charlotte", "Шарлотт", "US", "840", "", "NC", "119", "", "35.22709", "-80.84313", "America/New_York"),("4460465", "Cherryville", "", "US", "840", "", "NC", "071", "", "35.37874", "-81.37897", "America/New_York"),("4460943", "Clayton", "", "US", "840", "", "NC", "101", "", "35.65071", "-78.45639", "America/New_York"),("4461015", "Clemmons", "", "US", "840", "", "NC", "067", "", "36.02153", "-80.382", "America/New_York"),("4461101", "Clinton", "", "US", "840", "", "NC", "163", "", "34.99795", "-78.32333", "America/New_York"),("4461574", "Concord", "Конкорд", "US", "840", "", "NC", "025", "", "35.40888", "-80.58158", "America/New_York"),("4461696", "Conover", "", "US", "840", "", "NC", "035", "", "35.70652", "-81.21869", "America/New_York"),("4461941", "Cornelius", "Корнелиус", "US", "840", "", "NC", "119", "", "35.4868", "-80.86007", "America/New_York"),("4462701", "Cullowhee", "", "US", "840", "", "NC", "099", "", "35.31371", "-83.17653", "America/New_York"),("4463053", "Davidson", "", "US", "840", "", "NC", "071", "", "35.50233", "-80.83912", "America/New_York"),("4464326", "Dunn", "", "US", "840", "", "NC", "085", "", "35.30627", "-78.6089", "America/New_York"),("4464368", "Durham", "Дарем", "US", "840", "", "NC", "063", "", "35.99403", "-78.89862", "America/New_York"),("4464873", "Eden", "", "US", "840", "", "NC", "157", "", "36.48847", "-79.7667", "America/New_York"),("4465088", "Elizabeth City", "", "US", "840", "", "NC", "139", "", "36.2946", "-76.25105", "America/New_York"),("4465285", "Elon", "", "US", "840", "", "NC", "001", "", "36.10291", "-79.50669", "America/New_York"),("4465507", "Etowah", "", "US", "840", "", "NC", "089", "", "35.31762", "-82.59429", "America/New_York"),("4466033", "Fayetteville", "Фейетвилл", "US", "840", "", "NC", "051", "", "35.05266", "-78.87836", "America/New_York"),("4466547", "Fletcher", "", "US", "840", "", "NC", "089", "", "35.43067", "-82.50123", "America/New_York"),("4466720", "Forest City", "", "US", "840", "", "NC", "161", "", "35.33401", "-81.8651", "America/New_York"),("4467485", "Fuquay-Varina", "", "US", "840", "", "NC", "183", "", "35.58432", "-78.80001", "America/New_York"),("4467657", "Garner", "Гарнер", "US", "840", "", "NC", "183", "", "35.71126", "-78.61417", "America/New_York"),("4467732", "Gastonia", "Гастония", "US", "840", "", "NC", "071", "", "35.26208", "-81.1873", "America/New_York"),("4467926", "Gibsonville", "", "US", "840", "", "NC", "081", "", "36.10569", "-79.54225", "America/New_York"),("4468261", "Goldsboro", "Голдсборо", "US", "840", "", "NC", "191", "", "35.38488", "-77.99277", "America/New_York"),("4468525", "Graham", "", "US", "840", "", "NC", "001", "", "36.06903", "-79.40058", "America/New_York"),("4469146", "Greensboro", "Гринсборо", "US", "840", "", "NC", "081", "", "36.07264", "-79.79198", "America/New_York"),("4469160", "Greenville", "Гринвилл", "US", "840", "", "NC", "147", "", "35.61266", "-77.36635", "America/New_York"),("4469607", "Half Moon", "", "US", "840", "", "NC", "133", "", "34.826", "-77.45941", "America/New_York"),("4469730", "Hamlet", "", "US", "840", "", "NC", "153", "", "34.88488", "-79.69422", "America/New_York"),("4470109", "Harrisburg", "", "US", "840", "", "NC", "025", "", "35.32395", "-80.65784", "America/New_York"),("4470244", "Havelock", "", "US", "840", "", "NC", "049", "", "34.87905", "-76.90133", "America/New_York"),("4470566", "Henderson", "Хендерсон", "US", "840", "", "NC", "181", "", "36.32959", "-78.39916", "America/New_York"),("4470592", "Hendersonville", "", "US", "840", "", "NC", "089", "", "35.31873", "-82.46095", "America/New_York"),("4470778", "Hickory", "Хикори", "US", "840", "", "NC", "035", "", "35.73319", "-81.3412", "America/New_York"),("4471025", "High Point", "Хай-Пойнт", "US", "840", "", "NC", "081", "", "35.95569", "-80.00532", "America/New_York"),("4471241", "Hillsborough", "", "US", "840", "", "NC", "135", "", "36.07542", "-79.09973", "America/New_York"),("4471641", "Holly Springs", "", "US", "840", "", "NC", "183", "", "35.65127", "-78.83362", "America/New_York"),("4471851", "Hope Mills", "", "US", "840", "", "NC", "051", "", "34.97044", "-78.94531", "America/New_York"),("4472370", "Huntersville", "", "US", "840", "", "NC", "119", "", "35.41069", "-80.84285", "America/New_York"),("4472687", "Indian Trail", "", "US", "840", "", "NC", "179", "", "35.07681", "-80.66924", "America/New_York"),("4473083", "Jacksonville", "Джексонвилл", "US", "840", "", "NC", "133", "", "34.75405", "-77.43024", "America/New_York"),("4473137", "James City", "", "US", "840", "", "NC", "049", "", "35.08877", "-77.03495", "America/New_York"),("4474040", "Kannapolis", "", "US", "840", "", "NC", "025", "", "35.48736", "-80.62173", "America/New_York"),("4474221", "Kernersville", "", "US", "840", "", "NC", "067", "", "36.11986", "-80.07365", "America/New_York"),("4474274", "Kill Devil Hills", "", "US", "840", "", "NC", "055", "", "36.03072", "-75.67601", "America/New_York"),("4474316", "King", "", "US", "840", "", "NC", "169", "", "36.28069", "-80.35922", "America/New_York"),("4474382", "Kings Grant", "", "US", "840", "", "NC", "129", "", "34.26295", "-77.8636", "America/New_York"),("4474388", "Kings Mountain", "", "US", "840", "", "NC", "045", "", "35.24513", "-81.34119", "America/New_York"),("4474436", "Kinston", "", "US", "840", "", "NC", "107", "", "35.26266", "-77.58164", "America/New_York"),("4474527", "Knightdale", "", "US", "840", "", "NC", "183", "", "35.78765", "-78.48056", "America/New_York"),("4474841", "Lake Norman of Catawba", "", "US", "840", "", "NC", "035", "", "35.5868", "-80.95952", "America/New_York"),("4475347", "Laurinburg", "", "US", "840", "", "NC", "165", "", "34.77405", "-79.46282", "America/New_York"),("4475622", "Leland", "", "US", "840", "", "NC", "019", "", "34.25628", "-78.04471", "America/New_York"),("4475640", "Lenoir", "", "US", "840", "", "NC", "027", "", "35.91402", "-81.53898", "America/New_York"),("4475767", "Lewisville", "", "US", "840", "", "NC", "067", "", "36.09708", "-80.41922", "America/New_York"),("4475773", "Lexington", "Лексингтон", "US", "840", "", "NC", "057", "", "35.82403", "-80.25338", "America/New_York"),("4475995", "Lincolnton", "", "US", "840", "", "NC", "109", "", "35.47375", "-81.25453", "America/New_York"),("4476919", "Long Beach", "", "US", "840", "", "NC", "019", "", "33.91045", "-78.11777", "America/New_York"),("4477525", "Lumberton", "", "US", "840", "", "NC", "155", "", "34.61834", "-79.01045", "America/New_York"),("4478003", "Marion", "", "US", "840", "", "NC", "111", "", "35.68401", "-82.00927", "America/New_York"),("4478192", "Marvin", "", "US", "840", "", "NC", "179", "", "34.99182", "-80.81479", "America/New_York"),("4478253", "Masonboro", "", "US", "840", "", "NC", "129", "", "34.17934", "-77.84748", "America/New_York"),("4478334", "Matthews", "", "US", "840", "", "NC", "119", "", "35.11681", "-80.72368", "America/New_York"),("4478877", "Mebane", "", "US", "840", "", "NC", "001", "", "36.09597", "-79.26696", "America/New_York"),("4479639", "Mills River", "", "US", "840", "", "NC", "089", "", "35.38845", "-82.56679", "America/New_York"),("4479759", "Mint Hill", "", "US", "840", "", "NC", "119", "", "35.17959", "-80.64729", "America/New_York"),("4479891", "Mocksville", "", "US", "840", "", "NC", "059", "", "35.89403", "-80.56145", "America/New_York"),("4479946", "Monroe", "Монро", "US", "840", "", "NC", "179", "", "34.98543", "-80.54951", "America/New_York"),("4480125", "Mooresville", "", "US", "840", "", "NC", "097", "", "35.58486", "-80.81007", "America/New_York"),("4480153", "Morehead City", "", "US", "840", "", "NC", "031", "", "34.72294", "-76.72604", "America/New_York"),("4480219", "Morganton", "", "US", "840", "", "NC", "023", "", "35.74541", "-81.68482", "America/New_York"),("4480285", "Morrisville", "", "US", "840", "", "NC", "183", "", "35.82348", "-78.82556", "America/New_York"),("4480378", "Mount Airy", "", "US", "840", "", "NC", "171", "", "36.4993", "-80.60729", "America/New_York"),("4480560", "Mount Holly", "", "US", "840", "", "NC", "071", "", "35.29819", "-81.01591", "America/New_York"),("4481345", "Murraysville", "", "US", "840", "", "NC", "129", "", "34.29572", "-77.84748", "America/New_York"),("4481385", "Myrtle Grove", "", "US", "840", "", "NC", "129", "", "34.13462", "-77.88165", "America/New_York"),("4481519", "Nashville", "", "US", "840", "", "NC", "127", "", "35.9746", "-77.96554", "America/New_York"),("4481682", "New Bern", "Нью-Берн", "US", "840", "", "NC", "049", "", "35.10849", "-77.04411", "America/New_York"),("4482101", "Newton", "", "US", "840", "", "NC", "035", "", "35.66986", "-81.22147", "America/New_York"),("4482916", "Oak Island", "", "US", "840", "", "NC", "019", "", "33.91656", "-78.16111", "America/New_York"),("4482941", "Oak Ridge", "", "US", "840", "", "NC", "081", "", "36.17347", "-79.98893", "America/New_York"),("4483174", "Ogden", "", "US", "840", "", "NC", "129", "", "34.27239", "-77.81859", "America/New_York"),("4483745", "Oxford", "", "US", "840", "", "NC", "077", "", "36.3107", "-78.59083", "America/New_York"),("4485272", "Pinehurst", "", "US", "840", "", "NC", "125", "", "35.19543", "-79.46948", "America/New_York"),("4485305", "Pineville", "", "US", "840", "", "NC", "119", "", "35.0832", "-80.8923", "America/New_York"),("4485355", "Piney Green", "", "US", "840", "", "NC", "133", "", "34.716", "-77.32024", "America/New_York"),("4487042", "Raleigh", "Роли", "US", "840", "", "NC", "183", "", "35.7721", "-78.63861", "America/New_York"),("4487682", "Reidsville", "", "US", "840", "", "NC", "157", "", "36.35486", "-79.66447", "America/New_York"),("4488232", "Roanoke Rapids", "", "US", "840", "", "NC", "083", "", "36.46154", "-77.65415", "America/New_York"),("4488587", "Rockingham", "", "US", "840", "", "NC", "153", "", "34.93932", "-79.77395", "America/New_York"),("4488762", "Rocky Mount", "Роки-Маунт", "US", "840", "", "NC", "127", "", "35.93821", "-77.79053", "America/New_York"),("4488859", "Rolesville", "", "US", "840", "", "NC", "183", "", "35.92321", "-78.4575", "America/New_York"),("4489200", "Roxboro", "", "US", "840", "", "NC", "145", "", "36.39375", "-78.98279", "America/New_York"),("4489985", "Salisbury", "", "US", "840", "", "NC", "159", "", "35.67097", "-80.47423", "America/New_York"),("4490329", "Sanford", "", "US", "840", "", "NC", "105", "", "35.47988", "-79.1803", "America/New_York"),("4490510", "Sawmills", "", "US", "840", "", "NC", "027", "", "35.82485", "-81.47454", "America/New_York"),("4490778", "Selma", "", "US", "840", "", "NC", "101", "", "35.53655", "-78.28444", "America/New_York"),("4491180", "Shelby", "", "US", "840", "", "NC", "045", "", "35.29235", "-81.53565", "America/New_York"),("4491651", "Siler City", "", "US", "840", "", "NC", "037", "", "35.72347", "-79.46224", "America/New_York"),("4491715", "Silver Lake", "", "US", "840", "", "NC", "129", "", "34.14878", "-77.9136", "America/New_York"),("4492168", "Smithfield", "", "US", "840", "", "NC", "101", "", "35.50849", "-78.33945", "America/New_York"),("4492573", "South Gastonia", "", "US", "840", "", "NC", "071", "", "35.2193", "-81.20563", "America/New_York"),("4492722", "Southern Pines", "", "US", "840", "", "NC", "125", "", "35.17405", "-79.39225", "America/New_York"),("4493035", "Spring Lake", "", "US", "840", "", "NC", "051", "", "35.16794", "-78.97281", "America/New_York"),("4493146", "Saint Stephens", "", "US", "840", "", "NC", "035", "", "35.76458", "-81.27314", "America/New_York"),("4493186", "Stallings", "", "US", "840", "", "NC", "179", "", "35.0907", "-80.68618", "America/New_York"),("4493316", "Statesville", "", "US", "840", "", "NC", "097", "", "35.78264", "-80.8873", "America/New_York"),("4493547", "Stokesdale", "", "US", "840", "", "NC", "081", "", "36.23708", "-79.97948", "America/New_York"),("4493990", "Summerfield", "", "US", "840", "", "NC", "081", "", "36.20875", "-79.90476", "America/New_York"),("4493991", "Summerfield", "", "US", "840", "", "NC", "147", "", "35.56822", "-77.40274", "America/New_York"),("4494513", "Tarboro", "", "US", "840", "", "NC", "065", "", "35.89682", "-77.5358", "America/New_York"),("4494942", "Thomasville", "", "US", "840", "", "NC", "057", "", "35.88264", "-80.08199", "America/New_York"),("4495616", "Trinity", "", "US", "840", "", "NC", "151", "", "35.89458", "-79.99087", "America/New_York"),("4496304", "Unionville", "", "US", "840", "", "NC", "179", "", "35.08737", "-80.50896", "America/New_York"),("4497244", "Wadesboro", "", "US", "840", "", "NC", "007", "", "34.96821", "-80.07673", "America/New_York"),("4497290", "Wake Forest", "", "US", "840", "", "NC", "183", "", "35.97987", "-78.50972", "America/New_York"),("4497666", "Washington", "", "US", "840", "", "NC", "013", "", "35.54655", "-77.05217", "America/New_York"),("4497833", "Waxhaw", "", "US", "840", "", "NC", "179", "", "34.92459", "-80.7434", "America/New_York"),("4497868", "Waynesville", "", "US", "840", "", "NC", "087", "", "35.48871", "-82.98875", "America/New_York"),("4497956", "Weddington", "", "US", "840", "", "NC", "179", "", "35.02237", "-80.7609", "America/New_York"),("4498075", "Wesley Chapel", "", "US", "840", "", "NC", "179", "", "35.00709", "-80.67451", "America/New_York"),("4498084", "Wendell", "", "US", "840", "", "NC", "183", "", "35.78099", "-78.36972", "America/New_York"),("4498303", "West Raleigh", "", "US", "840", "", "NC", "183", "", "35.78682", "-78.66389", "America/New_York"),("4498899", "Whiteville", "", "US", "840", "", "NC", "047", "", "34.33878", "-78.70307", "America/New_York"),("4499294", "Williamston", "", "US", "840", "", "NC", "117", "", "35.8546", "-77.05551", "America/New_York"),("4499379", "Wilmington", "Уилмингтон", "US", "840", "", "NC", "129", "", "34.22573", "-77.94471", "America/New_York"),("4499389", "Wilson", "Уилсон", "US", "840", "", "NC", "195", "", "35.72127", "-77.91554", "America/New_York"),("4499612", "Winston-Salem", "Винстон-Салем", "US", "840", "", "NC", "067", "", "36.09986", "-80.24422", "America/New_York"),("4499629", "Winterville", "", "US", "840", "", "NC", "147", "", "35.52905", "-77.40108", "America/New_York"),("4499850", "Woodfin", "", "US", "840", "", "NC", "021", "", "35.63344", "-82.58207", "America/New_York"),("4500458", "Absecon", "", "US", "840", "", "NJ", "001", "", "39.42845", "-74.49571", "America/New_York"),("4500538", "Ashland", "", "US", "840", "", "NJ", "007", "", "39.86317", "-75.006", "America/New_York"),("4500546", "Atlantic City", "Атлантик-Сити", "US", "840", "", "NJ", "001", "", "39.36428", "-74.42293", "America/New_York"),("4500572", "Audubon", "", "US", "840", "", "NJ", "007", "", "39.89095", "-75.07295", "America/New_York"),("4500653", "Barrington", "", "US", "840", "", "NJ", "007", "", "39.86484", "-75.05517", "America/New_York"),("4500709", "Beachwood", "", "US", "840", "", "NJ", "029", "", "39.93901", "-74.19292", "America/New_York"),("4500750", "Bellmawr", "", "US", "840", "", "NJ", "007", "", "39.86761", "-75.09462", "America/New_York"),("4500771", "Berlin", "", "US", "840", "", "NJ", "007", "", "39.79123", "-74.92905", "America/New_York"),("4500920", "Brigantine", "", "US", "840", "", "NJ", "001", "", "39.41012", "-74.36459", "America/New_York"),("4500942", "Bridgeton", "", "US", "840", "", "NJ", "011", "", "39.42734", "-75.23408", "America/New_York"),("4500959", "Browns Mills", "", "US", "840", "", "NJ", "005", "", "39.97261", "-74.58293", "America/New_York"),("4501018", "Camden", "Камден", "US", "840", "", "NJ", "007", "", "39.92595", "-75.11962", "America/New_York"),("4501057", "Cape May Court House", "", "US", "840", "", "NJ", "009", "", "39.08261", "-74.82378", "America/New_York"),("4501073", "Carneys Point", "", "US", "840", "", "NJ", "033", "", "39.71122", "-75.4702", "America/New_York"),("4501198", "Cherry Hill", "", "US", "840", "", "NJ", "007", "", "39.93484", "-75.03073", "America/New_York"),("4501204", "Cherry Hill Mall", "", "US", "840", "", "NJ", "007", "", "39.93595", "-75.00906", "America/New_York"),("4501234", "Cinnaminson", "", "US", "840", "", "NJ", "005", "", "39.99678", "-74.99267", "America/New_York"),("4501265", "Clayton", "", "US", "840", "", "NJ", "015", "", "39.66011", "-75.09212", "America/New_York"),("4501306", "Collingswood", "", "US", "840", "", "NJ", "007", "", "39.91817", "-75.07128", "America/New_York"),("4501393", "Crestwood Village", "", "US", "840", "", "NJ", "029", "", "39.94817", "-74.3607", "America/New_York"),("4501632", "Echelon", "", "US", "840", "", "NJ", "007", "", "39.84845", "-74.99572", "America/New_York"),("4501818", "Forked River", "", "US", "840", "", "NJ", "029", "", "39.83984", "-74.19014", "America/New_York"),("4501931", "Glassboro", "", "US", "840", "", "NJ", "015", "", "39.70289", "-75.11184", "America/New_York"),("4501943", "Gloucester City", "", "US", "840", "", "NJ", "007", "", "39.89178", "-75.11629", "America/New_York"),("4502049", "Greentree", "", "US", "840", "", "NJ", "007", "", "39.89706", "-74.95572", "America/New_York"),("4502093", "Haddon Heights", "", "US", "840", "", "NJ", "007", "", "39.87734", "-75.06462", "America/New_York"),("4502103", "Haddonfield", "", "US", "840", "", "NJ", "007", "", "39.8915", "-75.03767", "America/New_York"),("4502129", "Hammonton", "", "US", "840", "", "NJ", "001", "", "39.63651", "-74.80239", "America/New_York"),("4502434", "Jackson", "", "US", "840", "", "NJ", "007", "", "39.7765", "-74.86238", "America/New_York"),("4502543", "Kingston Estates", "", "US", "840", "", "NJ", "007", "", "39.92372", "-74.98795", "America/New_York"),("4502687", "Lindenwold", "", "US", "840", "", "NJ", "007", "", "39.82428", "-74.99767", "America/New_York"),("4502690", "Linwood", "", "US", "840", "", "NJ", "001", "", "39.33984", "-74.57516", "America/New_York"),("4502901", "Maple Shade", "", "US", "840", "", "NJ", "005", "", "39.95261", "-74.99239", "America/New_York"),("4502904", "Margate City", "", "US", "840", "", "NJ", "001", "", "39.32789", "-74.50349", "America/New_York"),("4502911", "Marlton", "", "US", "840", "", "NJ", "005", "", "39.89122", "-74.92183", "America/New_York"),("4503078", "Millville", "", "US", "840", "", "NJ", "011", "", "39.40206", "-75.03934", "America/New_York"),("4503134", "Mount Holly", "", "US", "840", "", "NJ", "005", "", "39.99289", "-74.78766", "America/New_York"),("4503136", "Mount Laurel", "", "US", "840", "", "NJ", "005", "", "39.934", "-74.891", "America/New_York"),("4503204", "Mystic Island", "", "US", "840", "", "NJ", "029", "", "39.54428", "-74.38237", "America/New_York"),("4503316", "Northfield", "", "US", "840", "", "NJ", "001", "", "39.37039", "-74.55015", "America/New_York"),("4503346", "Ocean Acres", "", "US", "840", "", "NJ", "029", "", "39.74345", "-74.28098", "America/New_York"),("4503351", "Ocean City", "", "US", "840", "", "NJ", "009", "", "39.27762", "-74.5746", "America/New_York"),("4503516", "Paulsboro", "", "US", "840", "", "NJ", "015", "", "39.83039", "-75.24046", "America/New_York"),("4503548", "Pennsauken", "", "US", "840", "", "NJ", "007", "", "39.95622", "-75.05795", "America/New_York"),("4503555", "Pennsville", "", "US", "840", "", "NJ", "033", "", "39.65345", "-75.51659", "America/New_York"),("4503606", "Pine Hill", "", "US", "840", "", "NJ", "007", "", "39.78428", "-74.99211", "America/New_York"),("4503635", "Pitman", "", "US", "840", "", "NJ", "015", "", "39.73289", "-75.13157", "America/New_York"),("4503646", "Pleasantville", "", "US", "840", "", "NJ", "001", "", "39.38984", "-74.52404", "America/New_York"),("4503665", "Pomona", "", "US", "840", "", "NJ", "001", "", "39.47845", "-74.57516", "America/New_York"),("4503736", "Ramblewood", "", "US", "840", "", "NJ", "005", "", "39.92872", "-74.94378", "America/New_York"),("4503953", "Runnemede", "", "US", "840", "", "NJ", "007", "", "39.85234", "-75.06795", "America/New_York"),("4504118", "Sicklerville", "", "US", "840", "", "NJ", "007", "", "39.71734", "-74.96933", "America/New_York"),("4504164", "Smithville", "", "US", "840", "", "NJ", "001", "", "39.49401", "-74.45709", "America/New_York"),("4504180", "Somerdale", "", "US", "840", "", "NJ", "007", "", "39.844", "-75.02267", "America/New_York"),("4504186", "Somers Point", "", "US", "840", "", "NJ", "001", "", "39.31762", "-74.5946", "America/New_York"),("4504225", "South Vineland", "", "US", "840", "", "NJ", "011", "", "39.44595", "-75.02879", "America/New_York"),("4504250", "Springdale", "", "US", "840", "", "NJ", "007", "", "39.90261", "-74.96628", "America/New_York"),("4504336", "Stratford", "", "US", "840", "", "NJ", "007", "", "39.82678", "-75.01545", "America/New_York"),("4504476", "Toms River", "", "US", "840", "", "NJ", "029", "", "39.95373", "-74.19792", "America/New_York"),("4504598", "Ventnor City", "", "US", "840", "", "NJ", "001", "", "39.34039", "-74.47737", "America/New_York"),("4504616", "Villas", "", "US", "840", "", "NJ", "009", "", "39.02872", "-74.93851", "America/New_York"),("4504621", "Vineland", "", "US", "840", "", "NJ", "011", "", "39.48623", "-75.02573", "America/New_York"),("4504856", "Wildwood", "", "US", "840", "", "NJ", "009", "", "38.99178", "-74.81489", "America/New_York"),("4504871", "Williamstown", "", "US", "840", "", "NJ", "015", "", "39.68623", "-74.99517", "America/New_York"),("4504915", "Woodbury", "", "US", "840", "", "NJ", "015", "", "39.83817", "-75.15268", "America/New_York"),("4505542", "Athens", "Афины", "US", "840", "", "OH", "009", "", "39.32924", "-82.10126", "America/New_York"),("4506008", "Beavercreek", "", "US", "840", "", "OH", "057", "", "39.70923", "-84.06327", "America/New_York"),("4506031", "Beckett Ridge", "", "US", "840", "", "OH", "017", "", "39.347", "-84.43522", "America/New_York"),("4506166", "Bellbrook", "", "US", "840", "", "OH", "057", "", "39.63562", "-84.07077", "America/New_York"),("4506187", "Belpre", "", "US", "840", "", "OH", "167", "", "39.27396", "-81.5729", "America/New_York"),("4506487", "Bexley", "", "US", "840", "", "OH", "049", "", "39.96895", "-82.93768", "America/New_York"),("4506666", "Blacklick Estates", "", "US", "840", "", "OH", "049", "", "39.90506", "-82.86434", "America/New_York"),("4506754", "Blue Ash", "", "US", "840", "", "OH", "061", "", "39.232", "-84.37827", "America/New_York"),("4507067", "Bridgetown", "", "US", "840", "", "OH", "061", "", "39.15311", "-84.63717", "America/New_York"),("4507188", "Brookville", "", "US", "840", "", "OH", "113", "", "39.83672", "-84.41134", "America/New_York"),("4507883", "Canal Winchester", "", "US", "840", "", "OH", "045", "", "39.84284", "-82.80462", "America/New_York"),("4507937", "Carlisle", "", "US", "840", "", "OH", "165", "", "39.582", "-84.32022", "America/New_York"),("4508204", "Centerville", "", "US", "840", "", "OH", "113", "", "39.62839", "-84.15938", "America/New_York"),("4508465", "Cheviot", "", "US", "840", "", "OH", "061", "", "39.157", "-84.61328", "America/New_York"),("4508722", "Cincinnati", "Цинциннати", "US", "840", "", "OH", "061", "", "39.162", "-84.45689", "America/New_York"),("4508778", "Circleville", "", "US", "840", "", "OH", "129", "", "39.60062", "-82.94601", "America/New_York"),("4508885", "Clayton", "", "US", "840", "", "OH", "113", "", "39.86311", "-84.3605", "America/New_York"),("4509177", "Columbus", "Колумбус", "US", "840", "", "OH", "049", "", "39.96118", "-82.99879", "America/New_York"),("4509506", "Covedale", "", "US", "840", "", "OH", "061", "", "39.12117", "-84.60633", "America/New_York"),("4509884", "Dayton", "Дейтон", "US", "840", "", "OH", "113", "", "39.75895", "-84.19161", "America/New_York"),("4509986", "Deer Park", "", "US", "840", "", "OH", "061", "", "39.20534", "-84.39466", "America/New_York"),("4510062", "Dent", "", "US", "840", "", "OH", "061", "", "39.18589", "-84.65134", "America/New_York"),("4510342", "Dry Run", "", "US", "840", "", "OH", "061", "", "39.10423", "-84.33049", "America/New_York"),("4510719", "Eaton", "", "US", "840", "", "OH", "135", "", "39.74394", "-84.63662", "America/New_York"),("4511064", "Englewood", "", "US", "840", "", "OH", "113", "", "39.87756", "-84.30217", "America/New_York"),("4511263", "Fairborn", "", "US", "840", "", "OH", "057", "", "39.82089", "-84.01938", "America/New_York"),("4511283", "Fairfield", "Феърфилд", "US", "840", "", "OH", "017", "", "39.34589", "-84.5605", "America/New_York"),("4511642", "Finneytown", "", "US", "840", "", "OH", "061", "", "39.20034", "-84.5205", "America/New_York"),("4512060", "Forest Park", "", "US", "840", "", "OH", "061", "", "39.29034", "-84.50411", "America/New_York"),("4512083", "Forestville", "", "US", "840", "", "OH", "061", "", "39.07506", "-84.34494", "America/New_York"),("4512203", "Franklin", "", "US", "840", "", "OH", "165", "", "39.55895", "-84.30411", "America/New_York"),("4512557", "Geneva", "", "US", "840", "", "OH", "045", "", "39.66201", "-82.43349", "America/New_York"),("4512620", "Germantown", "", "US", "840", "", "OH", "113", "", "39.62617", "-84.36939", "America/New_York"),("4512940", "Goshen", "", "US", "840", "", "OH", "025", "", "39.23339", "-84.16132", "America/New_York"),("4513057", "Grandview Heights", "", "US", "840", "", "OH", "049", "", "39.97979", "-83.04074", "America/New_York"),("4513394", "Groesbeck", "", "US", "840", "", "OH", "061", "", "39.22311", "-84.58689", "America/New_York"),("4513409", "Grove City", "", "US", "840", "", "OH", "049", "", "39.88145", "-83.09296", "America/New_York"),("4513425", "Groveport", "", "US", "840", "", "OH", "049", "", "39.8784", "-82.88379", "America/New_York"),("4513575", "Hamilton", "Гамильтон", "US", "840", "", "OH", "017", "", "39.3995", "-84.56134", "America/New_York"),("4513805", "Harrison", "", "US", "840", "", "OH", "061", "", "39.262", "-84.81995", "America/New_York"),("4514282", "Hillsboro", "", "US", "840", "", "OH", "071", "", "39.20229", "-83.61159", "America/New_York"),("4514746", "Huber Heights", "", "US", "840", "", "OH", "113", "", "39.84395", "-84.12466", "America/New_York"),("4515247", "Ironton", "", "US", "840", "", "OH", "087", "", "38.53675", "-82.68294", "America/New_York"),("4515318", "Jackson", "", "US", "840", "", "OH", "079", "", "39.05202", "-82.63655", "America/New_York"),("4515813", "Kenwood", "", "US", "840", "", "OH", "061", "", "39.21061", "-84.36716", "America/New_York"),("4515843", "Kettering", "Кеттеринг", "US", "840", "", "OH", "113", "", "39.6895", "-84.16883", "America/New_York"),("4516233", "Lancaster", "Ланкастер", "US", "840", "", "OH", "045", "", "39.71368", "-82.59933", "America/New_York"),("4516248", "Landen", "", "US", "840", "", "OH", "165", "", "39.312", "-84.28299", "America/New_York"),("4516412", "Lebanon", "", "US", "840", "", "OH", "165", "", "39.43534", "-84.20299", "America/New_York"),("4516701", "Lincoln Village", "", "US", "840", "", "OH", "049", "", "39.95479", "-83.13074", "America/New_York"),("4516989", "Logan", "", "US", "840", "", "OH", "073", "", "39.54007", "-82.4071", "America/New_York"),("4517009", "London", "", "US", "840", "", "OH", "097", "", "39.88645", "-83.44825", "America/New_York"),("4517140", "Loveland", "", "US", "840", "", "OH", "061", "", "39.26895", "-84.26383", "America/New_York"),("4517323", "Mack", "", "US", "840", "", "OH", "061", "", "39.15811", "-84.64967", "America/New_York"),("4517353", "Madeira", "", "US", "840", "", "OH", "061", "", "39.19089", "-84.36355", "America/New_York"),("4517586", "Marietta", "", "US", "840", "", "OH", "167", "", "39.41535", "-81.45484", "America/New_York"),("4517698", "Mason", "Мейсон", "US", "840", "", "OH", "165", "", "39.36006", "-84.30994", "America/New_York"),("4518188", "Miamisburg", "", "US", "840", "", "OH", "113", "", "39.64284", "-84.28661", "America/New_York"),("4518264", "Middletown", "Мидлтаун", "US", "840", "", "OH", "017", "", "39.51506", "-84.39828", "America/New_York"),("4518307", "Milford", "", "US", "840", "", "OH", "025", "", "39.17534", "-84.29438", "America/New_York");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("4518550", "Monroe", "", "US", "840", "", "OH", "017", "", "39.44034", "-84.36216", "America/New_York"),("4518596", "Monfort Heights", "", "US", "840", "", "OH", "061", "", "39.18839", "-84.59522", "America/New_York"),("4518597", "Montgomery", "", "US", "840", "", "OH", "061", "", "39.22811", "-84.35411", "America/New_York"),("4518661", "Moraine", "", "US", "840", "", "OH", "113", "", "39.70617", "-84.21938", "America/New_York"),("4518890", "Mount Healthy", "", "US", "840", "", "OH", "061", "", "39.23367", "-84.54578", "America/New_York"),("4519445", "Nelsonville", "", "US", "840", "", "OH", "009", "", "39.45868", "-82.23182", "America/New_York"),("4519486", "New Burlington", "", "US", "840", "", "OH", "061", "", "39.2595", "-84.55717", "America/New_York"),("4519497", "New Carlisle", "", "US", "840", "", "OH", "023", "", "39.93617", "-84.02549", "America/New_York"),("4519853", "North College Hill", "", "US", "840", "", "OH", "061", "", "39.21839", "-84.55078", "America/New_York"),("4519924", "Northbrook", "", "US", "840", "", "OH", "061", "", "39.24645", "-84.58356", "America/New_York"),("4519938", "Northgate", "", "US", "840", "", "OH", "061", "", "39.25283", "-84.59245", "America/New_York"),("4519950", "Northridge", "", "US", "840", "", "OH", "023", "", "39.99173", "-83.77854", "America/New_York"),("4519951", "Northridge", "", "US", "840", "", "OH", "113", "", "39.80756", "-84.19689", "America/New_York"),("4519995", "Norwood", "", "US", "840", "", "OH", "061", "", "39.15561", "-84.45966", "America/New_York"),("4520163", "Oakwood", "", "US", "840", "", "OH", "113", "", "39.72534", "-84.17411", "America/New_York"),("4520760", "Oxford", "Оксфорд", "US", "840", "", "OH", "017", "", "39.507", "-84.74523", "America/New_York"),("4520905", "Pataskala", "", "US", "840", "", "OH", "089", "", "39.99562", "-82.67433", "America/New_York"),("4521209", "Pickerington", "", "US", "840", "", "OH", "045", "", "39.88423", "-82.7535", "America/New_York"),("4521816", "Portsmouth", "Портсмут", "US", "840", "", "OH", "145", "", "38.73174", "-82.99767", "America/New_York"),("4522228", "Reading", "", "US", "840", "", "OH", "061", "", "39.22367", "-84.44216", "America/New_York"),("4522411", "Reynoldsburg", "", "US", "840", "", "OH", "049", "", "39.95479", "-82.81212", "America/New_York"),("4522586", "Riverside", "Риверсайд", "US", "840", "", "OH", "113", "", "39.77978", "-84.1241", "America/New_York"),("4524499", "Sharonville", "", "US", "840", "", "OH", "061", "", "39.26811", "-84.41327", "America/New_York"),("4524642", "Shiloh", "", "US", "840", "", "OH", "113", "", "39.81867", "-84.22855", "America/New_York"),("4525304", "Springboro", "", "US", "840", "", "OH", "165", "", "39.55228", "-84.23327", "America/New_York"),("4525310", "Springdale", "", "US", "840", "", "OH", "061", "", "39.287", "-84.48522", "America/New_York"),("4525353", "Springfield", "Спрингфилд", "US", "840", "", "OH", "023", "", "39.92423", "-83.80882", "America/New_York"),("4525829", "Summerside", "", "US", "840", "", "OH", "025", "", "39.10478", "-84.28827", "America/New_York"),("4526225", "The Village of Indian Hill", "", "US", "840", "", "OH", "061", "", "39.17949", "-84.33517", "America/New_York"),("4526365", "Tipp City", "", "US", "840", "", "OH", "109", "", "39.95839", "-84.17216", "America/New_York"),("4526469", "Trenton", "", "US", "840", "", "OH", "017", "", "39.48089", "-84.45772", "America/New_York"),("4526576", "Trotwood", "Тротвуд", "US", "840", "", "OH", "113", "", "39.79728", "-84.31133", "America/New_York"),("4526790", "Union", "", "US", "840", "", "OH", "113", "", "39.89783", "-84.30633", "America/New_York"),("4526993", "Upper Arlington", "", "US", "840", "", "OH", "049", "", "39.99451", "-83.06241", "America/New_York"),("4527124", "Vandalia", "", "US", "840", "", "OH", "113", "", "39.89061", "-84.19883", "America/New_York"),("4527660", "Washington Court House", "", "US", "840", "", "OH", "047", "", "39.53645", "-83.43908", "America/New_York"),("4527879", "Wellston", "", "US", "840", "", "OH", "079", "", "39.12341", "-82.53294", "America/New_York"),("4527963", "West Carrollton City", "", "US", "840", "", "OH", "113", "", "39.67228", "-84.25216", "America/New_York"),("4528203", "Wheelersburg", "", "US", "840", "", "OH", "145", "", "38.73035", "-82.85545", "America/New_York"),("4528259", "White Oak", "", "US", "840", "", "OH", "061", "", "39.21311", "-84.59939", "America/New_York"),("4528291", "Whitehall", "", "US", "840", "", "OH", "049", "", "39.96673", "-82.88546", "America/New_York"),("4528463", "Wilmington", "", "US", "840", "", "OH", "027", "", "39.44534", "-83.82854", "America/New_York"),("4528596", "Withamsville", "", "US", "840", "", "OH", "025", "", "39.06228", "-84.28827", "America/New_York"),("4528793", "Wyoming", "", "US", "840", "", "OH", "061", "", "39.23117", "-84.46578", "America/New_York"),("4528810", "Xenia", "Ксения", "US", "840", "", "OH", "057", "", "39.68478", "-83.92965", "America/New_York"),("4528923", "Zanesville", "", "US", "840", "", "OH", "119", "", "39.94035", "-82.01319", "America/New_York"),("4529096", "Ada", "", "US", "840", "", "OK", "123", "", "34.77453", "-96.67834", "America/Chicago"),("4529292", "Altus", "", "US", "840", "", "OK", "065", "", "34.63813", "-99.33398", "America/Chicago"),("4529308", "Alva", "", "US", "840", "", "OK", "151", "", "36.80499", "-98.66718", "America/Chicago"),("4529353", "Anadarko", "", "US", "840", "", "OK", "015", "", "35.07256", "-98.24366", "America/Chicago"),("4529469", "Ardmore", "", "US", "840", "", "OK", "019", "", "34.17426", "-97.14363", "America/Chicago"),("4529987", "Bartlesville", "", "US", "840", "", "OK", "147", "", "36.74731", "-95.98082", "America/Chicago"),("4530372", "Bethany", "", "US", "840", "", "OK", "109", "", "35.51867", "-97.63226", "America/Chicago"),("4530801", "Bixby", "", "US", "840", "", "OK", "143", "", "35.94204", "-95.88332", "America/Chicago"),("4530866", "Blackwell", "", "US", "840", "", "OK", "071", "", "36.80448", "-97.28282", "America/Chicago"),("4530883", "Blanchard", "", "US", "840", "", "OK", "087", "", "35.13784", "-97.65809", "America/Chicago"),("4531405", "Broken Arrow", "Брокен-Эрроу", "US", "840", "", "OK", "143", "", "36.0526", "-95.79082", "America/Chicago"),("4532493", "Catoosa", "", "US", "840", "", "OK", "131", "", "36.18899", "-95.74582", "America/Chicago"),("4533029", "Chickasha", "", "US", "840", "", "OK", "051", "", "35.05257", "-97.93643", "America/Chicago"),("4533130", "Choctaw", "", "US", "840", "", "OK", "109", "", "35.49756", "-97.26892", "America/Chicago"),("4533580", "Claremore", "Клермор", "US", "840", "", "OK", "131", "", "36.3126", "-95.61609", "America/Chicago"),("4533738", "Clinton", "", "US", "840", "", "OK", "039", "", "35.51561", "-98.96731", "America/Chicago"),("4533909", "Collinsville", "", "US", "840", "", "OK", "143", "", "36.36454", "-95.83888", "America/Chicago"),("4534386", "Coweta", "", "US", "840", "", "OK", "145", "", "35.95177", "-95.65081", "America/Chicago"),("4534659", "Cushing", "", "US", "840", "", "OK", "119", "", "35.98506", "-96.76697", "America/Chicago"),("4534934", "Del City", "", "US", "840", "", "OK", "109", "", "35.44201", "-97.44087", "America/Chicago"),("4535389", "Duncan", "Дункан", "US", "840", "", "OK", "137", "", "34.5023", "-97.95781", "America/Chicago"),("4535414", "Durant", "", "US", "840", "", "OK", "013", "", "33.99399", "-96.37082", "America/Chicago"),("4535740", "Edmond", "Эдмон", "US", "840", "", "OK", "109", "", "35.65283", "-97.4781", "America/Chicago"),("4535783", "El Reno", "", "US", "840", "", "OK", "017", "", "35.53227", "-97.95505", "America/Chicago"),("4535823", "Elk City", "", "US", "840", "", "OK", "009", "", "35.41199", "-99.40426", "America/Chicago"),("4535961", "Enid", "Энид", "US", "840", "", "OK", "047", "", "36.39559", "-97.87839", "America/Chicago"),("4537641", "Glenpool", "", "US", "840", "", "OK", "143", "", "35.95537", "-96.00888", "America/Chicago"),("4538126", "Grove", "", "US", "840", "", "OK", "041", "", "36.59369", "-94.76912", "America/Chicago"),("4538142", "Guthrie", "", "US", "840", "", "OK", "083", "", "35.87894", "-97.42532", "America/Chicago"),("4538346", "Harrah", "", "US", "840", "", "OK", "109", "", "35.48951", "-97.16364", "America/Chicago"),("4538577", "Henryetta", "", "US", "840", "", "OK", "111", "", "35.43983", "-95.98194", "America/Chicago"),("4538869", "Holdenville", "", "US", "840", "", "OK", "063", "", "35.08036", "-96.39918", "America/Chicago"),("4539145", "Hugo", "", "US", "840", "", "OK", "023", "", "34.01066", "-95.50968", "America/Chicago"),("4539224", "Idabel", "", "US", "840", "", "OK", "089", "", "33.89566", "-94.82633", "America/Chicago"),("4539615", "Jenks", "", "US", "840", "", "OK", "143", "", "36.02287", "-95.96833", "America/Chicago"),("4540737", "Lawton", "Лоутон", "US", "840", "", "OK", "031", "", "34.60869", "-98.39033", "America/Chicago"),("4541625", "Lone Grove", "", "US", "840", "", "OK", "019", "", "34.17537", "-97.26279", "America/Chicago"),("4542367", "McAlester", "", "US", "840", "", "OK", "121", "", "34.93343", "-95.76971", "America/Chicago"),("4542692", "Miami", "", "US", "840", "", "OK", "115", "", "36.87451", "-94.87746", "America/Chicago"),("4542765", "Midwest City", "", "US", "840", "", "OK", "109", "", "35.44951", "-97.3967", "America/Chicago"),("4542975", "Moore", "Мур", "US", "840", "", "OK", "027", "", "35.33951", "-97.4867", "America/Chicago"),("4543338", "Muskogee", "Маскоги", "US", "840", "", "OK", "101", "", "35.74788", "-95.36969", "America/Chicago"),("4543352", "Mustang", "", "US", "840", "", "OK", "017", "", "35.38423", "-97.72449", "America/Chicago"),("4543622", "Newcastle", "", "US", "840", "", "OK", "087", "", "35.24729", "-97.59976", "America/Chicago"),("4543733", "Noble", "", "US", "840", "", "OK", "027", "", "35.13924", "-97.39475", "America/Chicago"),("4543762", "Norman", "Норман", "US", "840", "", "OK", "027", "", "35.22257", "-97.43948", "America/Chicago"),("4544349", "Oklahoma City", "Оклахома Сити", "US", "840", "", "OK", "109", "", "35.46756", "-97.51643", "America/Chicago"),("4544383", "Okmulgee", "", "US", "840", "", "OK", "111", "", "35.62344", "-95.96055", "America/Chicago"),("4547407", "Owasso", "", "US", "840", "", "OK", "143", "", "36.26954", "-95.85471", "America/Chicago"),("4547690", "Pauls Valley", "", "US", "840", "", "OK", "049", "", "34.74008", "-97.22225", "America/Chicago"),("4547861", "Perry", "", "US", "840", "", "OK", "103", "", "36.28949", "-97.2881", "America/Chicago"),("4547969", "Piedmont", "", "US", "840", "", "OK", "017", "", "35.642", "-97.74643", "America/Chicago"),("4548267", "Ponca City", "", "US", "840", "", "OK", "071", "", "36.70698", "-97.08559", "America/Chicago"),("4548363", "Poteau", "", "US", "840", "", "OK", "079", "", "35.05371", "-94.62356", "America/Chicago"),("4548516", "Pryor", "", "US", "840", "", "OK", "097", "", "36.30843", "-95.31691", "America/Chicago"),("4548560", "Purcell", "", "US", "840", "", "OK", "087", "", "35.01368", "-97.36114", "America/Chicago"),("4550374", "Sallisaw", "", "US", "840", "", "OK", "135", "", "35.46037", "-94.78745", "America/Chicago"),("4550659", "Sand Springs", "", "US", "840", "", "OK", "143", "", "36.13981", "-96.10889", "America/Chicago"),("4550881", "Sapulpa", "", "US", "840", "", "OK", "037", "", "35.9987", "-96.11417", "America/Chicago"),("4551042", "Seminole", "", "US", "840", "", "OK", "133", "", "35.22452", "-96.67057", "America/Chicago"),("4551177", "Shawnee", "", "US", "840", "", "OK", "125", "", "35.32729", "-96.9253", "America/Chicago"),("4551408", "Skiatook", "", "US", "840", "", "OK", "113", "", "36.36842", "-96.00138", "America/Chicago"),("4552215", "Stillwater", "", "US", "840", "", "OK", "119", "", "36.11561", "-97.05837", "America/Chicago"),("4552519", "Sulphur", "", "US", "840", "", "OK", "099", "", "34.50787", "-96.96835", "America/Chicago"),("4552707", "Tahlequah", "", "US", "840", "", "OK", "021", "", "35.91537", "-94.96996", "America/Chicago"),("4552820", "Tecumseh", "", "US", "840", "", "OK", "125", "", "35.25785", "-96.93669", "America/Chicago"),("4552969", "The Village", "", "US", "840", "", "OK", "109", "", "35.56089", "-97.55143", "America/Chicago"),("4553433", "Tulsa", "Талса", "US", "840", "", "OK", "143", "", "36.15398", "-95.99277", "America/Chicago"),("4553574", "Tuttle", "", "US", "840", "", "OK", "051", "", "35.29089", "-97.81227", "America/Chicago"),("4554496", "Vinita", "", "US", "840", "", "OK", "035", "", "36.63869", "-95.15413", "America/Chicago"),("4554548", "Wagoner", "", "US", "840", "", "OK", "145", "", "35.95954", "-95.36941", "America/Chicago"),("4554687", "Warr Acres", "", "US", "840", "", "OK", "109", "", "35.52256", "-97.61893", "America/Chicago"),("4554858", "Weatherford", "", "US", "840", "", "OK", "039", "", "35.52616", "-98.70757", "America/Chicago"),("4556050", "Woodward", "", "US", "840", "", "OK", "153", "", "36.43365", "-99.39039", "America/Chicago"),("4556165", "Yukon", "Юкон", "US", "840", "", "OK", "017", "", "35.50672", "-97.76254", "America/Chicago"),("4556793", "Brookhaven", "", "US", "840", "", "PA", "045", "", "39.86928", "-75.38241", "America/New_York"),("4556802", "Broomall", "", "US", "840", "", "PA", "045", "", "39.9815", "-75.35658", "America/New_York"),("4557109", "Chambersburg", "", "US", "840", "", "PA", "055", "", "39.93759", "-77.6611", "America/New_York"),("4557137", "Chester", "Честер", "US", "840", "", "PA", "045", "", "39.84967", "-75.35707", "America/New_York"),("4557228", "Clifton Heights", "", "US", "840", "", "PA", "045", "", "39.92928", "-75.2963", "America/New_York"),("4557247", "Coatesville", "", "US", "840", "", "PA", "029", "", "39.98316", "-75.82384", "America/New_York"),("4557287", "Collingdale", "", "US", "840", "", "PA", "045", "", "39.91178", "-75.27713", "America/New_York"),("4557485", "Darby", "", "US", "840", "", "PA", "045", "", "39.91845", "-75.25907", "America/New_York"),("4557606", "Drexel Hill", "", "US", "840", "", "PA", "045", "", "39.94706", "-75.29213", "America/New_York"),("4557717", "East York", "", "US", "840", "", "PA", "133", "", "39.97371", "-76.68636", "America/New_York"),("4558002", "Folsom", "", "US", "840", "", "PA", "045", "", "39.88983", "-75.32519", "America/New_York"),("4558004", "Folcroft", "", "US", "840", "", "PA", "045", "", "39.89095", "-75.2838", "America/New_York"),("4558183", "Gettysburg", "", "US", "840", "", "PA", "001", "", "39.83093", "-77.2311", "America/New_York"),("4558247", "Glenolden", "", "US", "840", "", "PA", "045", "", "39.90011", "-75.28907", "America/New_York"),("4558475", "Hanover", "", "US", "840", "", "PA", "133", "", "39.80066", "-76.98304", "America/New_York"),("4558942", "Kennett Square", "", "US", "840", "", "PA", "029", "", "39.84678", "-75.7116", "America/New_York"),("4559077", "Lansdowne", "", "US", "840", "", "PA", "045", "", "39.93817", "-75.27185", "America/New_York"),("4559575", "Media", "", "US", "840", "", "PA", "045", "", "39.91678", "-75.38769", "America/New_York"),("4559685", "Millersville", "", "US", "840", "", "PA", "071", "", "39.99788", "-76.35413", "America/New_York"),("4560057", "Norwood", "", "US", "840", "", "PA", "045", "", "39.89178", "-75.29963", "America/New_York"),("4560185", "Oxford", "", "US", "840", "", "PA", "029", "", "39.78539", "-75.97883", "America/New_York"),("4560237", "Parkville", "", "US", "840", "", "PA", "133", "", "39.78121", "-76.96331", "America/New_York"),("4560291", "Penn Wynne", "", "US", "840", "", "PA", "091", "", "39.98622", "-75.27546", "America/New_York"),("4560349", "Philadelphia", "Филадельфия", "US", "840", "", "PA", "101", "", "39.95233", "-75.16379", "America/New_York"),("4560549", "Prospect Park", "", "US", "840", "", "PA", "045", "", "39.88789", "-75.30824", "America/New_York"),("4560639", "Red Lion", "", "US", "840", "", "PA", "133", "", "39.90093", "-76.6058", "America/New_York"),("4560709", "Ridley Park", "", "US", "840", "", "PA", "045", "", "39.88122", "-75.3238", "America/New_York"),("4561188", "Sharon Hill", "", "US", "840", "", "PA", "045", "", "39.9065", "-75.27157", "America/New_York"),("4561215", "Shiloh", "", "US", "840", "", "PA", "133", "", "39.97815", "-76.79719", "America/New_York"),("4561407", "Springfield", "Спрингфилд", "US", "840", "", "PA", "045", "", "39.93067", "-75.32019", "America/New_York"),("4561628", "Swarthmore", "", "US", "840", "", "PA", "045", "", "39.90206", "-75.34991", "America/New_York"),("4561859", "Uniontown", "", "US", "840", "", "PA", "051", "", "39.90008", "-79.71643", "America/New_York"),("4562070", "Waynesboro", "", "US", "840", "", "PA", "055", "", "39.75593", "-77.57777", "America/New_York"),("4562088", "Weigelstown", "", "US", "840", "", "PA", "133", "", "39.98371", "-76.82247", "America/New_York"),("4562144", "West Chester", "", "US", "840", "", "PA", "029", "", "39.96097", "-75.60804", "America/New_York"),("4562275", "Willow Street", "", "US", "840", "", "PA", "071", "", "39.97927", "-76.27635", "America/New_York"),("4562366", "Woodlyn", "", "US", "840", "", "PA", "045", "", "39.87233", "-75.33713", "America/New_York"),("4562407", "York", "Йорк", "US", "840", "", "PA", "133", "", "39.9626", "-76.72774", "America/New_York"),("4562430", "Yeadon", "", "US", "840", "", "PA", "045", "", "39.939", "-75.25546", "America/New_York"),("4568985", "Abbeville", "", "US", "840", "", "SC", "001", "", "34.17817", "-82.37901", "America/New_York"),("4569067", "Aiken", "Айкен", "US", "840", "", "SC", "003", "", "33.56042", "-81.71955", "America/New_York"),("4569298", "Anderson", "Андерсон", "US", "840", "", "SC", "007", "", "34.50344", "-82.65013", "America/New_York"),("4570117", "Batesburg-Leesville", "", "US", "840", "", "SC", "063", "", "33.91014", "-81.53733", "America/New_York"),("4570284", "Beaufort", "", "US", "840", "", "SC", "013", "", "32.43158", "-80.66983", "America/New_York"),("4570590", "Belvedere", "", "US", "840", "", "SC", "003", "", "33.53097", "-81.94484", "America/New_York"),("4570634", "Bennettsville", "", "US", "840", "", "SC", "069", "", "34.61738", "-79.68478", "America/New_York"),("4570664", "Berea", "", "US", "840", "", "SC", "045", "", "34.8854", "-82.45596", "America/New_York"),("4571722", "Bluffton", "", "US", "840", "", "SC", "013", "", "32.23715", "-80.86039", "America/New_York"),("4571804", "Boiling Springs", "", "US", "840", "", "SC", "011", "", "33.13515", "-81.43122", "America/New_York"),("4571805", "Boiling Springs", "", "US", "840", "", "SC", "083", "", "35.04651", "-81.98177", "America/New_York"),("4572881", "Burton", "", "US", "840", "", "SC", "013", "", "32.43575", "-80.724", "America/New_York"),("4573209", "Camden", "", "US", "840", "", "SC", "055", "", "34.24654", "-80.60702", "America/New_York"),("4573888", "Cayce", "", "US", "840", "", "SC", "063", "", "33.96571", "-81.07398", "America/New_York"),("4574140", "Centerville", "", "US", "840", "", "SC", "007", "", "34.53205", "-82.70402", "America/New_York"),("4574143", "Centerville", "", "US", "840", "", "SC", "035", "", "32.99573", "-80.17037", "America/New_York"),("4574153", "Central", "", "US", "840", "", "SC", "077", "", "34.72427", "-82.78125", "America/New_York"),("4574324", "Charleston", "Чарлстон", "US", "840", "", "SC", "019", "", "32.77657", "-79.93092", "America/New_York"),("4574434", "Cheraw", "", "US", "840", "", "SC", "025", "", "34.69766", "-79.8834", "America/New_York"),("4574565", "Chester", "", "US", "840", "", "SC", "023", "", "34.70486", "-81.21426", "America/New_York"),("4574989", "Clemson", "", "US", "840", "", "SC", "077", "", "34.68344", "-82.83737", "America/New_York"),("4575028", "Clinton", "", "US", "840", "", "SC", "059", "", "34.47263", "-81.88066", "America/New_York"),("4575061", "Clover", "", "US", "840", "", "SC", "091", "", "35.11125", "-81.22646", "America/New_York"),("4575352", "Columbia", "Колумбия", "US", "840", "", "SC", "079", "", "34.00071", "-81.03481", "America/New_York"),("4575461", "Conway", "Конвей", "US", "840", "", "SC", "051", "", "33.836", "-79.04781", "America/New_York"),("4576319", "Darlington", "", "US", "840", "", "SC", "031", "", "34.29988", "-79.87617", "America/New_York"),("4576573", "Dentsville", "", "US", "840", "", "SC", "079", "", "34.06404", "-80.95815", "America/New_York"),("4576653", "Dillon", "", "US", "840", "", "SC", "033", "", "34.41655", "-79.37116", "America/New_York"),("4577263", "Easley", "", "US", "840", "", "SC", "077", "4577263", "34.82984", "-82.60152", "America/New_York"),("4578602", "Five Forks", "", "US", "840", "", "SC", "045", "", "34.80484", "-82.22956", "America/New_York"),("4578737", "Florence", "Флоренция", "US", "840", "", "SC", "041", "", "34.19543", "-79.76256", "America/New_York"),("4578841", "Forest Acres", "", "US", "840", "", "SC", "079", "", "34.01932", "-80.98981", "America/New_York"),("4578977", "Fort Mill", "", "US", "840", "", "SC", "091", "", "35.00737", "-80.94508", "America/New_York"),("4579043", "Fountain Inn", "", "US", "840", "", "SC", "045", "", "34.68901", "-82.19567", "America/New_York"),("4579418", "Gaffney", "", "US", "840", "", "SC", "021", "", "35.07179", "-81.64982", "America/New_York"),("4579484", "Gantt", "", "US", "840", "", "SC", "045", "", "34.80012", "-82.42429", "America/New_York"),("4579503", "Garden City", "", "US", "840", "", "SC", "051", "", "33.59295", "-79.00865", "America/New_York"),("4579662", "Georgetown", "", "US", "840", "", "SC", "043", "", "33.37683", "-79.2945", "America/New_York"),("4580098", "Goose Creek", "", "US", "840", "", "SC", "015", "", "32.98101", "-80.03259", "America/New_York"),("4580543", "Greenville", "Гринвилл", "US", "840", "", "SC", "045", "", "34.85262", "-82.39401", "America/New_York"),("4580569", "Greenwood", "", "US", "840", "", "SC", "047", "", "34.1954", "-82.16179", "America/New_York"),("4580599", "Greer", "Грир", "US", "840", "", "SC", "045", "", "34.93873", "-82.22706", "America/New_York"),("4581023", "Hanahan", "", "US", "840", "", "SC", "015", "", "32.91851", "-80.02203", "America/New_York"),("4581095", "Hardeeville", "", "US", "840", "", "SC", "053", "", "32.28714", "-81.08067", "America/New_York"),("4581261", "Hartsville", "", "US", "840", "", "SC", "031", "", "34.37404", "-80.0734", "America/New_York"),("4581832", "Hilton Head Island", "", "US", "840", "", "SC", "013", "", "32.19382", "-80.73816", "America/New_York"),("4581833", "Hilton Head", "", "US", "840", "", "SC", "013", "", "32.21632", "-80.75261", "America/New_York"),("4582142", "Homeland Park", "", "US", "840", "", "SC", "007", "", "34.47066", "-82.67069", "America/New_York"),("4583057", "Irmo", "", "US", "840", "", "SC", "063", "", "34.08598", "-81.18315", "America/New_York"),("4584277", "Ladson", "", "US", "840", "", "SC", "015", "", "32.98573", "-80.10981", "America/New_York"),("4584322", "Lake City", "", "US", "840", "", "SC", "041", "", "33.871", "-79.75535", "America/New_York"),("4584474", "Lake Wylie", "", "US", "840", "", "SC", "091", "", "35.10848", "-81.04285", "America/New_York"),("4584556", "Lancaster", "", "US", "840", "", "SC", "057", "", "34.72043", "-80.7709", "America/New_York"),("4584683", "Laurel Bay", "", "US", "840", "", "SC", "013", "", "32.45019", "-80.78483", "America/New_York"),("4584738", "Laurens", "", "US", "840", "", "SC", "059", "", "34.49901", "-82.01426", "America/New_York"),("4585000", "Lexington", "Лексингтон", "US", "840", "", "SC", "063", "", "33.98154", "-81.23621", "America/New_York"),("4585421", "Little River", "", "US", "840", "", "SC", "051", "", "33.87323", "-78.61418", "America/New_York"),("4586266", "Marion", "", "US", "840", "", "SC", "067", "", "34.17822", "-79.40061", "America/New_York"),("4586523", "Mauldin", "", "US", "840", "", "SC", "045", "", "34.77873", "-82.31012", "America/New_York"),("4587511", "Moncks Corner", "", "US", "840", "", "SC", "015", "", "33.19632", "-80.01429", "America/New_York"),("4588165", "Mount Pleasant", "", "US", "840", "", "SC", "019", "", "32.79407", "-79.86259", "America/New_York"),("4588682", "Murrells Inlet", "", "US", "840", "", "SC", "043", "", "33.551", "-79.04143", "America/New_York"),("4588718", "Myrtle Beach", "Мертл-Бич", "US", "840", "", "SC", "051", "", "33.68906", "-78.88669", "America/New_York"),("4589207", "Newberry", "", "US", "840", "", "SC", "071", "", "34.27458", "-81.61872", "America/New_York"),("4589368", "North Augusta", "", "US", "840", "", "SC", "003", "", "33.5018", "-81.96512", "America/New_York"),("4589387", "North Charleston", "", "US", "840", "", "SC", "019", "", "32.85462", "-79.97481", "America/New_York"),("4589446", "North Myrtle Beach", "", "US", "840", "", "SC", "051", "", "33.81601", "-78.68002", "America/New_York"),("4589590", "Oak Grove", "", "US", "840", "", "SC", "017", "", "33.77821", "-80.96676", "America/New_York"),("4590184", "Orangeburg", "", "US", "840", "", "SC", "075", "", "33.49182", "-80.85565", "America/New_York"),("4590476", "Parker", "", "US", "840", "", "SC", "045", "", "34.85067", "-82.45346", "America/New_York"),("4590980", "Piedmont", "", "US", "840", "", "SC", "007", "", "34.70234", "-82.46457", "America/New_York"),("4591896", "Port Royal", "", "US", "840", "", "SC", "013", "", "32.37908", "-80.69261", "America/New_York"),("4591977", "Powdersville", "", "US", "840", "", "SC", "007", "", "34.79178", "-82.49291", "America/New_York"),("4592453", "Red Bank", "", "US", "840", "", "SC", "063", "", "33.93209", "-81.23843", "America/New_York"),("4592485", "Red Hill", "", "US", "840", "", "SC", "051", "", "33.99961", "-79.2581", "America/New_York"),("4592487", "Red Hill", "", "US", "840", "", "SC", "051", "", "33.82073", "-79.01892", "America/New_York"),("4593142", "Rock Hill", "", "US", "840", "", "SC", "091", "", "34.92487", "-81.02508", "America/New_York"),("4593724", "Saint Andrews", "", "US", "840", "", "SC", "063", "", "34.04543", "-81.12926", "America/New_York"),("4594971", "Sangaree", "", "US", "840", "", "SC", "015", "", "33.03545", "-80.12787", "America/New_York"),("4594975", "Sans Souci", "", "US", "840", "", "SC", "045", "", "34.8779", "-82.42401", "America/New_York"),("4595346", "Seneca", "", "US", "840", "", "SC", "073", "", "34.68566", "-82.9532", "America/New_York"),("4595374", "Seven Oaks", "", "US", "840", "", "SC", "063", "", "34.04876", "-81.14648", "America/New_York"),("4595864", "Simpsonville", "", "US", "840", "", "SC", "045", "", "34.73706", "-82.25428", "America/New_York"),("4596208", "Socastee", "", "US", "840", "", "SC", "051", "", "33.6835", "-78.99837", "America/New_York"),("4597200", "Spartanburg", "Спартанберг", "US", "840", "", "SC", "083", "", "34.94957", "-81.93205", "America/New_York"),("4597919", "Summerville", "", "US", "840", "", "SC", "035", "", "33.0185", "-80.17565", "America/New_York"),("4597948", "Sumter", "", "US", "840", "", "SC", "085", "", "33.92044", "-80.34147", "America/New_York"),("4598353", "Taylors", "", "US", "840", "", "SC", "045", "", "34.92039", "-82.29623", "America/New_York"),("4598379", "Tega Cay", "", "US", "840", "", "SC", "091", "", "35.02431", "-81.02785", "America/New_York"),("4599214", "Union", "", "US", "840", "", "SC", "087", "", "34.71541", "-81.62371", "America/New_York"),("4599455", "Valley Falls", "", "US", "840", "", "SC", "083", "", "35.01595", "-81.97483", "America/New_York"),("4599937", "Wade Hampton", "", "US", "840", "", "SC", "045", "", "34.90373", "-82.33317", "America/New_York"),("4600065", "Walterboro", "", "US", "840", "", "SC", "029", "", "32.90517", "-80.66677", "America/New_York"),("4600413", "Welcome", "", "US", "840", "", "SC", "045", "", "34.82651", "-82.43901", "America/New_York"),("4600541", "West Columbia", "", "US", "840", "", "SC", "063", "", "33.99349", "-81.07398", "America/New_York"),("4601475", "Woodfield", "", "US", "840", "", "SC", "079", "", "34.05932", "-80.93092", "America/New_York"),("4601703", "York", "", "US", "840", "", "SC", "091", "", "34.9943", "-81.24202", "America/New_York"),("4602181", "Alcoa", "", "US", "840", "", "TN", "009", "", "35.78953", "-83.97379", "America/New_York"),("4603001", "Arlington", "", "US", "840", "", "TN", "157", "", "35.2962", "-89.66147", "America/Chicago"),("4603284", "Athens", "", "US", "840", "", "TN", "107", "", "35.44285", "-84.59299", "America/New_York"),("4603347", "Atoka", "", "US", "840", "", "TN", "167", "", "35.44119", "-89.77814", "America/Chicago"),("4604183", "Bartlett", "Бартлетт", "US", "840", "", "TN", "157", "", "35.20453", "-89.87398", "America/Chicago"),("4607177", "Bloomingdale", "", "US", "840", "", "TN", "163", "", "36.58455", "-82.48932", "America/New_York"),("4607598", "Bolivar", "", "US", "840", "", "TN", "069", "", "35.25619", "-88.98784", "America/Chicago"),("4608408", "Brentwood", "", "US", "840", "", "TN", "187", "", "36.03312", "-86.78278", "America/Chicago"),("4608418", "Brentwood Estates", "", "US", "840", "", "TN", "187", "", "36.02506", "-86.77917", "America/Chicago"),("4608657", "Bristol", "", "US", "840", "", "TN", "163", "", "36.59511", "-82.18874", "America/New_York"),("4609116", "Brownsville", "", "US", "840", "", "TN", "075", "", "35.59397", "-89.26229", "America/Chicago"),("4612862", "Chattanooga", "Чаттануга", "US", "840", "", "TN", "065", "", "35.04563", "-85.30968", "America/New_York"),("4613501", "Christiana", "", "US", "840", "", "TN", "149", "", "35.71007", "-86.39944", "America/Chicago"),("4613560", "Church Hill", "", "US", "840", "", "TN", "073", "", "36.52232", "-82.71349", "America/New_York"),("4613868", "Clarksville", "Кларксвилл", "US", "840", "", "TN", "125", "", "36.52977", "-87.35945", "America/Chicago"),("4614088", "Cleveland", "Кливленд", "US", "840", "", "TN", "011", "", "35.15952", "-84.87661", "America/New_York"),("4614214", "Clinton", "", "US", "840", "", "TN", "001", "", "36.10341", "-84.13186", "America/New_York"),("4614720", "Collegedale", "", "US", "840", "", "TN", "065", "", "35.05313", "-85.05023", "America/New_York"),("4614748", "Collierville", "", "US", "840", "", "TN", "157", "", "35.04204", "-89.66453", "America/Chicago"),("4614843", "Colonial Heights", "", "US", "840", "", "TN", "163", "", "36.4851", "-82.5032", "America/New_York"),("4614867", "Columbia", "Колумбия", "US", "840", "", "TN", "119", "", "35.61507", "-87.03528", "America/Chicago"),("4615145", "Cookeville", "", "US", "840", "", "TN", "141", "", "36.16284", "-85.50164", "America/Chicago"),("4615804", "Covington", "", "US", "840", "", "TN", "167", "", "35.56425", "-89.64647", "America/Chicago"),("4616470", "Crossville", "", "US", "840", "", "TN", "035", "", "35.94896", "-85.0269", "America/Chicago"),("4617536", "Dayton", "", "US", "840", "", "TN", "143", "", "35.49396", "-85.01245", "America/New_York"),("4618057", "Dickson", "", "US", "840", "", "TN", "043", "", "36.077", "-87.38779", "America/Chicago"),("4619629", "Dunlap", "", "US", "840", "", "TN", "153", "", "35.37146", "-85.39052", "America/Chicago"),("4619800", "Dyersburg", "", "US", "840", "", "TN", "045", "", "36.03452", "-89.38563", "America/Chicago"),("4619893", "Eagleton Village", "", "US", "840", "", "TN", "009", "", "35.79508", "-83.93185", "America/New_York"),("4619943", "East Brainerd", "", "US", "840", "", "TN", "065", "", "34.99591", "-85.15023", "America/New_York"),("4619947", "East Chattanooga", "", "US", "840", "", "TN", "065", "", "35.06535", "-85.24912", "America/New_York"),("4620131", "East Ridge", "", "US", "840", "", "TN", "065", "", "35.01424", "-85.2519", "America/New_York"),("4620634", "Elizabethton", "", "US", "840", "", "TN", "019", "", "36.34872", "-82.21069", "America/New_York"),("4621130", "Erwin", "", "US", "840", "", "TN", "171", "", "36.14511", "-82.41681", "America/New_York"),("4621447", "Fairfield Glade", "", "US", "840", "", "TN", "035", "", "36.00035", "-84.88634", "America/Chicago"),("4621503", "Fairview", "", "US", "840", "", "TN", "187", "", "35.98201", "-87.1214", "America/Chicago"),("4621846", "Farragut", "", "US", "840", "", "TN", "093", "", "35.88452", "-84.15353", "America/New_York"),("4621915", "Fayetteville", "", "US", "840", "", "TN", "103", "", "35.15203", "-86.57055", "America/Chicago"),("4623039", "Forest Hills", "", "US", "840", "", "TN", "037", "", "36.06839", "-86.84417", "America/Chicago"),("4623560", "Franklin", "Франклин", "US", "840", "", "TN", "187", "", "35.92506", "-86.86889", "America/Chicago"),("4624180", "Gallatin", "", "US", "840", "", "TN", "165", "", "36.38838", "-86.44666", "America/Chicago"),("4624601", "Germantown", "", "US", "840", "", "TN", "157", "", "35.08676", "-89.81009", "America/Chicago"),("4625282", "Goodlettsville", "", "US", "840", "", "TN", "037", "", "36.32311", "-86.71333", "America/Chicago"),("4626181", "Green Hill", "", "US", "840", "", "TN", "189", "", "36.22283", "-86.54944", "America/Chicago"),("4626286", "Greenbrier", "", "US", "840", "", "TN", "147", "", "36.42755", "-86.80472", "America/Chicago"),("4626334", "Greeneville", "", "US", "840", "", "TN", "059", "", "36.16316", "-82.83099", "America/New_York"),("4627863", "Harriman", "", "US", "840", "", "TN", "145", "", "35.93396", "-84.55244", "America/New_York"),("4627983", "Harrison", "", "US", "840", "", "TN", "065", "", "35.11368", "-85.13801", "America/New_York"),("4628695", "Henderson", "", "US", "840", "", "TN", "023", "", "35.43924", "-88.64144", "America/Chicago"),("4628735", "Hendersonville", "", "US", "840", "", "TN", "165", "", "36.30477", "-86.62", "America/Chicago"),("4631291", "Humboldt", "", "US", "840", "", "TN", "053", "", "35.81979", "-88.9159", "America/Chicago"),("4632595", "Jackson", "Джексон", "US", "840", "", "TN", "113", "", "35.61452", "-88.81395", "America/Chicago"),("4632959", "Jefferson City", "", "US", "840", "", "TN", "089", "", "36.12231", "-83.4924", "America/New_York"),("4633419", "Johnson City", "", "US", "840", "", "TN", "179", "", "36.31344", "-82.35347", "America/New_York"),("4633848", "Jonesborough", "", "US", "840", "", "TN", "179", "", "36.29427", "-82.47348", "America/New_York"),("4634662", "Kingsport", "", "US", "840", "", "TN", "163", "", "36.54843", "-82.56182", "America/New_York"),("4634671", "Kingston", "", "US", "840", "", "TN", "145", "", "35.88091", "-84.50854", "America/New_York"),("4634946", "Knoxville", "Ноксвилл", "US", "840", "", "TN", "093", "", "35.96064", "-83.92074", "America/New_York"),("4635031", "La Vergne", "", "US", "840", "", "TN", "149", "", "36.01562", "-86.58194", "America/Chicago"),("4635037", "LaFollette", "", "US", "840", "", "TN", "013", "", "36.38286", "-84.11993", "America/New_York"),("4635268", "Lakeland", "", "US", "840", "", "TN", "157", "", "35.23064", "-89.74036", "America/Chicago"),("4635849", "Lawrenceburg", "", "US", "840", "", "TN", "099", "", "35.2423", "-87.33474", "America/Chicago"),("4636045", "Lebanon", "", "US", "840", "", "TN", "189", "", "36.20811", "-86.2911", "America/Chicago"),("4636285", "Lenoir City", "", "US", "840", "", "TN", "105", "", "35.7973", "-84.25603", "America/New_York"),("4636442", "Lewisburg", "", "US", "840", "", "TN", "117", "", "35.44924", "-86.78889", "America/Chicago"),("4636463", "Lexington", "", "US", "840", "", "TN", "077", "", "35.6509", "-88.39338", "America/Chicago"),("4638278", "Loudon", "", "US", "840", "", "TN", "105", "", "35.73285", "-84.33381", "America/New_York"),("4638782", "Lynchburg", "", "US", "840", "", "TN", "127", "", "35.28314", "-86.37416", "America/Chicago"),("4639224", "Manchester", "", "US", "840", "", "TN", "031", "", "35.48174", "-86.0886", "America/Chicago"),("4639684", "Martin", "", "US", "840", "", "TN", "183", "", "36.3434", "-88.85034", "America/Chicago"),("4639848", "Maryville", "", "US", "840", "", "TN", "009", "", "35.75647", "-83.97046", "America/New_York"),("4640736", "McKenzie", "", "US", "840", "", "TN", "017", "", "36.13256", "-88.51866", "America/Chicago"),("4640882", "McMinnville", "", "US", "840", "", "TN", "177", "", "35.6834", "-85.76998", "America/Chicago"),("4641239", "Memphis", "Мемфис", "US", "840", "", "TN", "157", "", "35.14953", "-90.04898", "America/Chicago"),("4641495", "Middle Valley", "", "US", "840", "", "TN", "065", "", "35.1959", "-85.18468", "America/New_York"),("4641630", "Milan", "", "US", "840", "", "TN", "053", "", "35.91979", "-88.75895", "America/Chicago"),("4641974", "Millersville", "", "US", "840", "", "TN", "165", "", "36.37116", "-86.71", "America/Chicago"),("4641998", "Millington", "", "US", "840", "", "TN", "157", "", "35.34147", "-89.89731", "America/Chicago"),("4642938", "Morristown", "", "US", "840", "", "TN", "063", "", "36.21398", "-83.29489", "America/New_York"),("4643150", "Mount Carmel", "", "US", "840", "", "TN", "039", "", "35.49785", "-88.00781", "America/Chicago"),("4643153", "Mount Carmel", "", "US", "840", "", "TN", "073", "", "36.54538", "-82.66099", "America/New_York"),("4643336", "Mount Juliet", "", "US", "840", "", "TN", "189", "", "36.20005", "-86.51861", "America/Chicago"),("4644282", "Munford", "", "US", "840", "", "TN", "167", "", "35.44925", "-89.81508", "America/Chicago"),("4644312", "Murfreesboro", "Мерфрисборо", "US", "840", "", "TN", "149", "", "35.84562", "-86.39027", "America/Chicago"),("4644585", "Nashville", "Нашвилл", "US", "840", "", "TN", "037", "", "36.16589", "-86.78444", "America/Chicago"),("4645421", "New South Memphis", "", "US", "840", "", "TN", "157", "", "35.08676", "-90.05676", "America/Chicago"),("4645532", "Newport", "", "US", "840", "", "TN", "029", "", "35.96704", "-83.18766", "America/New_York"),("4645738", "Nolensville", "", "US", "840", "", "TN", "187", "", "35.95229", "-86.66944", "America/Chicago"),("4646571", "Oak Ridge", "Оук-Ридж", "US", "840", "", "TN", "001", "", "36.01036", "-84.26964", "America/New_York"),("4646637", "Oakland", "", "US", "840", "", "TN", "047", "", "35.22898", "-89.51508", "America/Chicago"),("4647963", "Paris", "", "US", "840", "", "TN", "079", "", "36.302", "-88.32671", "America/Chicago"),("4649251", "Pigeon Forge", "", "US", "840", "", "TN", "155", "", "35.78842", "-83.55433", "America/New_York"),("4650946", "Portland", "", "US", "840", "", "TN", "165", "", "36.58171", "-86.51638", "America/Chicago"),("4651648", "Pulaski", "", "US", "840", "", "TN", "055", "", "35.1998", "-87.03084", "America/Chicago"),("4652341", "Red Bank", "", "US", "840", "", "TN", "065", "", "35.11229", "-85.29413", "America/New_York"),("4653228", "Ripley", "", "US", "840", "", "TN", "097", "", "35.74536", "-89.5298", "America/Chicago"),("4653999", "Rockwood", "", "US", "840", "", "TN", "145", "", "35.86563", "-84.68494", "America/New_York"),("4656006", "Savannah", "", "US", "840", "", "TN", "071", "", "35.2248", "-88.2492", "America/Chicago"),("4656585", "Sevierville", "", "US", "840", "", "TN", "155", "", "35.86815", "-83.56184", "America/New_York"),("4656630", "Seymour", "", "US", "840", "", "TN", "155", "", "35.89064", "-83.72462", "America/New_York"),("4657077", "Shelbyville", "", "US", "840", "", "TN", "003", "", "35.48341", "-86.46027", "America/Chicago"),("4657633", "Signal Mountain", "", "US", "840", "", "TN", "065", "", "35.12257", "-85.34385", "America/New_York"),("4658590", "Smyrna", "Смирна", "US", "840", "", "TN", "149", "", "35.98284", "-86.5186", "America/Chicago"),("4658766", "Soddy-Daisy", "", "US", "840", "", "TN", "065", "", "35.2359", "-85.19079", "America/New_York"),("4658861", "South Cleveland", "", "US", "840", "", "TN", "011", "", "35.14119", "-84.87217", "America/New_York"),("4659177", "Sparta", "", "US", "840", "", "TN", "185", "", "35.9259", "-85.46414", "America/Chicago"),("4659446", "Spring Hill", "Спринг-Хилл", "US", "840", "", "TN", "119", "", "35.75118", "-86.93", "America/Chicago"),("4659557", "Springfield", "Спрингфилд", "US", "840", "", "TN", "147", "", "36.50921", "-86.885", "America/Chicago"),("4661331", "Sweetwater", "", "US", "840", "", "TN", "123", "", "35.60146", "-84.46104", "America/New_York"),("4663494", "Tullahoma", "", "US", "840", "", "TN", "031", "", "35.36202", "-86.20943", "America/Chicago"),("4664170", "Union City", "", "US", "840", "", "TN", "131", "", "36.42423", "-89.05701", "America/Chicago"),("4667282", "White House", "", "US", "840", "", "TN", "165", "", "36.47032", "-86.65138", "America/Chicago"),("4668336", "Winchester", "", "US", "840", "", "TN", "051", "", "35.18592", "-86.11221", "America/Chicago"),("4669635", "Abilene", "Абилин", "US", "840", "", "TX", "441", "", "32.44874", "-99.73314", "America/Chicago"),("4669828", "Addison", "", "US", "840", "", "TX", "113", "", "32.96179", "-96.82917", "America/Chicago"),("4670029", "Alamo Heights", "", "US", "840", "", "TX", "029", "", "29.48495", "-98.46585", "America/Chicago"),("4670074", "Alamo", "", "US", "840", "", "TX", "215", "", "26.18369", "-98.12306", "America/Chicago"),("4670146", "Aldine", "", "US", "840", "", "TX", "201", "", "29.93245", "-95.38021", "America/Chicago"),("4670234", "Alice", "", "US", "840", "", "TX", "249", "", "27.75225", "-98.06972", "America/Chicago"),("4670300", "Allen", "Аллен", "US", "840", "", "TX", "085", "", "33.10317", "-96.67055", "America/Chicago"),("4670555", "Alton", "", "US", "840", "", "TX", "215", "", "26.28729", "-98.31335", "America/Chicago"),("4670562", "Alton North (historical)", "", "US", "840", "", "TX", "215", "", "26.29535", "-98.30446", "America/Chicago"),("4670592", "Alvin", "Элвин", "US", "840", "", "TX", "039", "", "29.42385", "-95.2441", "America/Chicago"),("4670783", "Anderson Mill", "", "US", "840", "", "TX", "491", "", "30.45492", "-97.80584", "America/Chicago"),("4670866", "Angleton", "", "US", "840", "", "TX", "039", "", "29.16941", "-95.43188", "America/Chicago"),("4670871", "Anna", "", "US", "840", "", "TX", "085", "", "33.349", "-96.5486", "America/Chicago"),("4671141", "Aransas Pass", "", "US", "840", "", "TX", "409", "", "27.90947", "-97.14999", "America/Chicago"),("4671240", "Arlington", "Арлингтон", "US", "840", "", "TX", "439", "", "32.73569", "-97.10807", "America/Chicago"),("4671524", "Atascocita", "", "US", "840", "", "TX", "201", "", "29.99883", "-95.1766", "America/Chicago"),("4671545", "Athens", "", "US", "840", "", "TX", "213", "", "32.20487", "-95.85552", "America/Chicago"),("4671576", "Atlanta", "", "US", "840", "", "TX", "067", "", "33.11374", "-94.16435", "America/Chicago"),("4671654", "Austin", "Остин", "US", "840", "", "TX", "453", "", "30.26715", "-97.74306", "America/Chicago"),("4671800", "Azle", "", "US", "840", "", "TX", "439", "", "32.89513", "-97.54586", "America/Chicago"),("4671895", "Bacliff", "", "US", "840", "", "TX", "167", "", "29.5069", "-94.99243", "America/Chicago"),("4672059", "Balch Springs", "", "US", "840", "", "TX", "113", "", "32.72874", "-96.62277", "America/Chicago"),("4672576", "Bastrop", "", "US", "840", "", "TX", "021", "", "30.11049", "-97.31527", "America/Chicago"),("4672731", "Baytown", "", "US", "840", "", "TX", "201", "", "29.7355", "-94.97743", "America/Chicago"),("4672989", "Beaumont", "Бомонт", "US", "840", "", "TX", "245", "", "30.08605", "-94.10185", "America/Chicago"),("4673094", "Bedford", "Бедфорд", "US", "840", "", "TX", "439", "", "32.84402", "-97.14307", "America/Chicago"),("4673132", "Bee Cave", "", "US", "840", "", "TX", "453", "", "30.30854", "-97.94501", "America/Chicago"),("4673258", "Beeville", "", "US", "840", "", "TX", "025", "", "28.40095", "-97.74974", "America/Chicago"),("4673353", "Bellaire", "", "US", "840", "", "TX", "201", "", "29.70579", "-95.45883", "America/Chicago"),("4673389", "Bellmead", "", "US", "840", "", "TX", "309", "", "31.59405", "-97.10889", "America/Chicago"),("4673425", "Belton", "Белтон", "US", "840", "", "TX", "027", "", "31.05601", "-97.46445", "America/Chicago"),("4673482", "Benbrook", "", "US", "840", "", "TX", "439", "", "32.67319", "-97.46058", "America/Chicago"),("4675373", "Boerne", "", "US", "840", "", "TX", "259", "", "29.79466", "-98.73197", "America/Chicago"),("4675577", "Bonham", "", "US", "840", "", "TX", "147", "", "33.57733", "-96.17831", "America/Chicago"),("4675803", "Bowie", "", "US", "840", "", "TX", "337", "", "33.559", "-97.84865", "America/Chicago"),("4676032", "Brady", "", "US", "840", "", "TX", "307", "", "31.13517", "-99.33506", "America/Chicago"),("4676181", "Breckenridge", "", "US", "840", "", "TX", "429", "", "32.75568", "-98.90229", "America/Chicago"),("4676206", "Brenham", "", "US", "840", "", "TX", "477", "", "30.16688", "-96.39774", "America/Chicago"),("4676266", "Briar", "", "US", "840", "", "TX", "497", "", "32.99512", "-97.5428", "America/Chicago"),("4676316", "Bridge City", "", "US", "840", "", "TX", "361", "", "30.02077", "-93.84573", "America/Chicago"),("4676327", "Bridgeport", "", "US", "840", "", "TX", "497", "", "33.21012", "-97.75476", "America/Chicago"),("4676571", "Brookshire", "", "US", "840", "", "TX", "473", "", "29.78606", "-95.95107", "America/Chicago"),("4676740", "Brownsville", "Браунсвилл", "US", "840", "", "TX", "061", "", "25.90175", "-97.49748", "America/Chicago"),("4676798", "Brownwood", "", "US", "840", "", "TX", "049", "", "31.70932", "-98.99116", "America/Chicago"),("4676920", "Brushy Creek", "", "US", "840", "", "TX", "491", "", "30.51353", "-97.73973", "America/Chicago"),("4677008", "Bryan", "", "US", "840", "", "TX", "041", "", "30.67436", "-96.36996", "America/Chicago"),("4677526", "Burkburnett", "", "US", "840", "", "TX", "485", "", "34.09787", "-98.57061", "America/Chicago"),("4677551", "Burleson", "Бурлесоне", "US", "840", "", "TX", "251", "", "32.54208", "-97.32085", "America/Chicago"),("4677592", "Burnet", "", "US", "840", "", "TX", "053", "", "30.75824", "-98.22836", "America/Chicago"),("4678357", "Cameron", "", "US", "840", "", "TX", "331", "", "30.85325", "-96.97693", "America/Chicago"),("4678379", "Cameron Park", "", "US", "840", "", "TX", "061", "", "25.96452", "-97.47665", "America/Chicago"),("4678381", "Cameron Park Colonia", "", "US", "840", "", "TX", "061", "", "25.97147", "-97.47832", "America/Chicago"),("4678565", "Camp Swift", "", "US", "840", "", "TX", "021", "", "30.19077", "-97.29221", "America/Chicago"),("4678901", "Canyon Lake", "", "US", "840", "", "TX", "091", "", "29.87522", "-98.26251", "America/Chicago"),("4679148", "Carrizo Springs", "", "US", "840", "", "TX", "127", "", "28.52193", "-99.86061", "America/Chicago"),("4679195", "Carrollton", "Кэрролтон", "US", "840", "", "TX", "113", "", "32.95373", "-96.89028", "America/Chicago"),("4679272", "Carthage", "", "US", "840", "", "TX", "365", "", "32.15738", "-94.33742", "America/Chicago"),("4679803", "Cedar Hill", "", "US", "840", "", "TX", "113", "", "32.58847", "-96.95612", "America/Chicago"),("4679867", "Cedar Park", "", "US", "840", "", "TX", "491", "", "30.5052", "-97.82029", "America/Chicago"),("4679944", "Celina", "", "US", "840", "", "TX", "085", "", "33.32456", "-96.78444", "America/Chicago"),("4679987", "Center", "", "US", "840", "", "TX", "293", "", "31.51073", "-96.4247", "America/Chicago"),("4679988", "Center", "", "US", "840", "", "TX", "419", "", "31.79545", "-94.17909", "America/Chicago"),("4680388", "Channelview", "", "US", "840", "", "TX", "201", "", "29.77606", "-95.11465", "America/Chicago"),("4681462", "Cibolo", "", "US", "840", "", "TX", "187", "", "29.56162", "-98.22696", "America/Chicago"),("4681485", "Cinco Ranch", "", "US", "840", "", "TX", "157", "", "29.73884", "-95.758", "America/Chicago"),("4681976", "Cleburne", "", "US", "840", "", "TX", "251", "", "32.34764", "-97.38668", "America/Chicago"),("4682031", "Cleveland", "", "US", "840", "", "TX", "083", "", "31.67682", "-99.25367", "America/Chicago"),("4682032", "Cleveland", "", "US", "840", "", "TX", "291", "", "30.34132", "-95.08549", "America/Chicago"),("4682127", "Cloverleaf", "", "US", "840", "", "TX", "201", "", "29.77828", "-95.17188", "America/Chicago"),("4682163", "Clute", "", "US", "840", "", "TX", "039", "", "29.02469", "-95.39883", "America/Chicago"),("4682464", "College Station", "Колледж-Стейшен", "US", "840", "", "TX", "041", "", "30.62798", "-96.33441", "America/Chicago"),("4682478", "Colleyville", "", "US", "840", "", "TX", "439", "", "32.88096", "-97.15501", "America/Chicago"),("4682762", "Commerce", "", "US", "840", "", "TX", "231", "", "33.24706", "-95.89997", "America/Chicago"),("4682991", "Conroe", "", "US", "840", "", "TX", "339", "", "30.31188", "-95.45605", "America/Chicago"),("4683021", "Converse", "", "US", "840", "", "TX", "029", "", "29.51801", "-98.31612", "America/Chicago"),("4683217", "Coppell", "Коппелл", "US", "840", "", "TX", "113", "", "32.95457", "-97.01501", "America/Chicago"),("4683244", "Copperas Cove", "", "US", "840", "", "TX", "099", "", "31.12406", "-97.90308", "America/Chicago"),("4683317", "Corinth", "", "US", "840", "", "TX", "121", "", "33.15401", "-97.06473", "America/Chicago"),("4683416", "Corpus Christi", "Корпус-Кристи", "US", "840", "", "TX", "355", "", "27.80058", "-97.39638", "America/Chicago"),("4683462", "Corsicana", "", "US", "840", "", "TX", "349", "", "32.09543", "-96.46887", "America/Chicago"),("4684218", "Crockett", "", "US", "840", "", "TX", "225", "", "31.31824", "-95.45661", "America/Chicago"),("4684434", "Crowley", "", "US", "840", "", "TX", "439", "", "32.57903", "-97.36252", "America/Chicago"),("4684480", "Crystal City", "", "US", "840", "", "TX", "507", "", "28.67748", "-99.82811", "America/Chicago"),("4684547", "Cuero", "", "US", "840", "", "TX", "123", "", "29.09387", "-97.28916", "America/Chicago"),("4684724", "Cypress", "", "US", "840", "", "TX", "201", "", "29.96911", "-95.69717", "America/Chicago"),("4684888", "Dallas", "Даллас", "US", "840", "", "TX", "113", "", "32.78306", "-96.80667", "America/Chicago"),("4685449", "Dayton", "", "US", "840", "", "TX", "291", "", "30.04661", "-94.8852", "America/Chicago"),("4685524", "DeSoto", "Сото", "US", "840", "", "TX", "113", "", "32.58986", "-96.85695", "America/Chicago"),("4685617", "Decatur", "", "US", "840", "", "TX", "497", "", "33.23428", "-97.58614", "America/Chicago"),("4685737", "Deer Park", "", "US", "840", "", "TX", "201", "", "29.70523", "-95.12382", "America/Chicago"),("4685892", "Denison", "Денисон", "US", "840", "", "TX", "181", "", "33.75566", "-96.53666", "America/Chicago"),("4685907", "Denton", "Дентон", "US", "840", "", "TX", "121", "", "33.21484", "-97.13307", "America/Chicago"),("4686131", "Diboll", "", "US", "840", "", "TX", "005", "", "31.18713", "-94.78104", "America/Chicago"),("4686163", "Dickinson", "", "US", "840", "", "TX", "167", "", "29.46079", "-95.05132", "America/Chicago"),("4686472", "Doffing", "", "US", "840", "", "TX", "215", "", "26.27452", "-98.38585", "America/Chicago"),("4686593", "Donna", "", "US", "840", "", "TX", "215", "", "26.17035", "-98.05195", "America/Chicago"),("4687331", "Duncanville", "", "US", "840", "", "TX", "113", "", "32.6518", "-96.90834", "America/Chicago"),("4687588", "Eagle Mountain", "", "US", "840", "", "TX", "439", "", "32.89346", "-97.44446", "America/Chicago"),("4688275", "Edinburg", "Эдинбург", "US", "840", "", "TX", "215", "", "26.30174", "-98.16334", "America/Chicago"),("4688506", "El Campo", "", "US", "840", "", "TX", "481", "", "29.19664", "-96.26969", "America/Chicago"),("4688756", "Elgin", "", "US", "840", "", "TX", "021", "", "30.34965", "-97.37027", "America/Chicago"),("4689120", "Elsa", "", "US", "840", "", "TX", "215", "", "26.2934", "-97.99306", "America/Chicago"),("4689311", "Ennis", "", "US", "840", "", "TX", "139", "", "32.32931", "-96.62527", "America/Chicago"),("4689550", "Euless", "", "US", "840", "", "TX", "439", "", "32.83707", "-97.08195", "America/Chicago"),("4689708", "Everman", "", "US", "840", "", "TX", "439", "", "32.63097", "-97.28918", "America/Chicago"),("4689803", "Fair Oaks Ranch", "", "US", "840", "", "TX", "029", "", "29.74578", "-98.64336", "America/Chicago"),("4689871", "Fairview", "", "US", "840", "", "TX", "085", "", "33.1579", "-96.63166", "America/Chicago"),("4690198", "Farmers Branch", "", "US", "840", "", "TX", "113", "", "32.92651", "-96.89612", "America/Chicago"),("4690257", "Fate", "", "US", "840", "", "TX", "397", "", "32.94151", "-96.38137", "America/Chicago"),("4691553", "Floresville", "", "US", "840", "", "TX", "493", "", "29.13358", "-98.15612", "America/Chicago"),("4691585", "Flower Mound", "", "US", "840", "", "TX", "121", "", "33.01457", "-97.09696", "America/Chicago"),("4691766", "Forest Hill", "", "US", "840", "", "TX", "439", "", "32.67208", "-97.26918", "America/Chicago"),("4691833", "Forney", "", "US", "840", "", "TX", "257", "", "32.74818", "-96.47193", "America/Chicago"),("4691930", "Fort Worth", "Форт-Уэрт", "US", "840", "", "TX", "439", "", "32.72541", "-97.32085", "America/Chicago"),("4692051", "Four Corners", "", "US", "840", "", "TX", "157", "", "29.66857", "-95.65772", "America/Chicago"),("4692279", "Fredericksburg", "", "US", "840", "", "TX", "171", "", "30.2752", "-98.87198", "America/Chicago"),("4692355", "Freeport", "", "US", "840", "", "TX", "039", "", "28.95414", "-95.35966", "America/Chicago"),("4692400", "Fresno", "Фресно", "US", "840", "", "TX", "157", "", "29.53885", "-95.44744", "America/Chicago"),("4692521", "Friendswood", "", "US", "840", "", "TX", "167", "", "29.5294", "-95.20104", "America/Chicago"),("4692559", "Frisco", "Фриско", "US", "840", "", "TX", "085", "", "33.15067", "-96.82361", "America/Chicago"),("4692658", "Fulshear", "", "US", "840", "", "TX", "157", "", "29.68996", "-95.89968", "America/Chicago"),("4692746", "Gainesville", "", "US", "840", "", "TX", "097", "", "33.62594", "-97.13335", "America/Chicago"),("4692771", "Galena Park", "", "US", "840", "", "TX", "201", "", "29.73356", "-95.23021", "America/Chicago"),("4692883", "Galveston", "Галвестон", "US", "840", "", "TX", "167", "", "29.30135", "-94.7977", "America/Chicago"),("4693003", "Garland", "Гирлянда", "US", "840", "", "TX", "113", "", "32.91262", "-96.63888", "America/Chicago"),("4693150", "Gatesville", "", "US", "840", "", "TX", "099", "", "31.43516", "-97.74391", "America/Chicago"),("4693342", "Georgetown", "", "US", "840", "", "TX", "491", "", "30.63269", "-97.67723", "America/Chicago"),("4693472", "Giddings", "", "US", "840", "", "TX", "287", "", "30.18272", "-96.93637", "America/Chicago"),("4693569", "Gilmer", "", "US", "840", "", "TX", "459", "", "32.72875", "-94.94244", "America/Chicago"),("4693621", "Gladewater", "", "US", "840", "", "TX", "183", "", "32.53653", "-94.94272", "America/Chicago"),("4693726", "Glenn Heights", "", "US", "840", "", "TX", "113", "", "32.54875", "-96.85667", "America/Chicago"),("4693940", "Gonzales", "", "US", "840", "", "TX", "177", "", "29.50163", "-97.45249", "America/Chicago"),("4694420", "Graham", "", "US", "840", "", "TX", "503", "", "33.10706", "-98.5895", "America/Chicago"),("4694459", "Granbury", "", "US", "840", "", "TX", "221", "", "32.44208", "-97.7942", "America/Chicago"),("4694482", "Grand Prairie", "Гранд-Прейри", "US", "840", "", "TX", "113", "", "32.74596", "-96.99778", "America/Chicago"),("4694535", "Granite Shoals", "", "US", "840", "", "TX", "053", "", "30.58908", "-98.38392", "America/Chicago"),("4694568", "Grapevine", "", "US", "840", "", "TX", "439", "", "32.93429", "-97.07807", "America/Chicago"),("4694896", "Greatwood", "", "US", "840", "", "TX", "157", "", "29.55413", "-95.67578", "America/Chicago"),("4695066", "Greenville", "Гринвилл", "US", "840", "", "TX", "231", "", "33.13845", "-96.11081", "America/Chicago"),("4695317", "Groves", "", "US", "840", "", "TX", "245", "", "29.94827", "-93.91712", "America/Chicago"),("4695535", "Gun Barrel City", "", "US", "840", "", "TX", "213", "", "32.33459", "-96.15136", "America/Chicago"),("4695912", "Haltom City", "", "US", "840", "", "TX", "439", "", "32.79957", "-97.26918", "America/Chicago"),("4696202", "Harker Heights", "", "US", "840", "", "TX", "027", "", "31.08351", "-97.65974", "America/Chicago"),("4696233", "Harlingen", "Харлинген", "US", "840", "", "TX", "061", "", "26.19063", "-97.6961", "America/Chicago"),("4696876", "Heath", "", "US", "840", "", "TX", "397", "", "32.83651", "-96.47499", "America/Chicago"),("4697038", "Helotes", "", "US", "840", "", "TX", "029", "", "29.57801", "-98.68975", "America/Chicago"),("4697060", "Hempstead", "", "US", "840", "", "TX", "473", "", "30.09744", "-96.07829", "America/Chicago"),("4697330", "Hewitt", "", "US", "840", "", "TX", "309", "", "31.46239", "-97.19584", "America/Chicago"),("4697442", "Hidalgo", "", "US", "840", "", "TX", "215", "", "26.10035", "-98.26307", "America/Chicago"),("4697616", "Highland Park", "", "US", "840", "", "TX", "113", "", "32.83346", "-96.79195", "America/Chicago"),("4697645", "Highland Village", "", "US", "840", "", "TX", "121", "", "33.09179", "-97.04668", "America/Chicago"),("4697652", "Highlands", "", "US", "840", "", "TX", "201", "", "29.81884", "-95.05604", "America/Chicago"),("4697867", "Hillsboro", "", "US", "840", "", "TX", "217", "", "32.01099", "-97.13001", "America/Chicago"),("4697988", "Hitchcock", "", "US", "840", "", "TX", "167", "", "29.34829", "-95.01604", "America/Chicago"),("4698562", "Hondo", "", "US", "840", "", "TX", "325", "", "29.34746", "-99.14142", "America/Chicago"),("4698809", "Hornsby Bend", "", "US", "840", "", "TX", "453", "", "30.24743", "-97.58333", "America/Chicago"),("4699066", "Houston", "Хьюстон", "US", "840", "", "TX", "201", "", "29.76328", "-95.36327", "America/Chicago"),("4699442", "Humble", "", "US", "840", "", "TX", "201", "", "29.99883", "-95.26216", "America/Chicago"),("4699540", "Huntsville", "Хантсвилл", "US", "840", "", "TX", "471", "", "30.72353", "-95.55078", "America/Chicago"),("4699575", "Hurst", "Херст", "US", "840", "", "TX", "439", "", "32.82346", "-97.17057", "America/Chicago"),("4699608", "Hutchins", "", "US", "840", "", "TX", "113", "", "32.6493", "-96.71305", "America/Chicago"),("4699626", "Hutto", "", "US", "840", "", "TX", "491", "", "30.5427", "-97.54667", "America/Chicago"),("4700033", "Ingleside", "", "US", "840", "", "TX", "409", "", "27.8778", "-97.21166", "America/Chicago"),("4700122", "Iowa Park", "", "US", "840", "", "TX", "485", "", "33.95148", "-98.66867", "America/Chicago"),("4700168", "Irving", "Ирвинг", "US", "840", "", "TX", "113", "", "32.81402", "-96.94889", "America/Chicago"),("4700401", "Jacinto City", "", "US", "840", "", "TX", "201", "", "29.76745", "-95.23382", "America/Chicago"),("4700550", "Jacksonville", "", "US", "840", "", "TX", "073", "", "31.96378", "-95.2705", "America/Chicago"),("4700731", "Jasper", "", "US", "840", "", "TX", "241", "", "30.9202", "-93.99658", "America/Chicago"),("4700967", "Jersey Village", "", "US", "840", "", "TX", "201", "", "29.88772", "-95.563", "America/Chicago"),("4701458", "Jollyville", "", "US", "840", "", "TX", "491", "", "30.4427", "-97.77501", "America/Chicago"),("4701659", "Joshua", "", "US", "840", "", "TX", "251", "", "32.46153", "-97.38807", "America/Chicago"),("4702728", "Kaufman", "", "US", "840", "", "TX", "257", "", "32.58902", "-96.30887", "America/Chicago"),("4702732", "Katy", "", "US", "840", "", "TX", "201", "", "29.78579", "-95.8244", "America/Chicago"),("4702785", "Keene", "", "US", "840", "", "TX", "251", "", "32.39681", "-97.3239", "America/Chicago"),("4702828", "Keller", "Келлер", "US", "840", "", "TX", "439", "", "32.93457", "-97.25168", "America/Chicago"),("4702986", "Kennedale", "", "US", "840", "", "TX", "439", "", "32.6468", "-97.22585", "America/Chicago"),("4703078", "Kerrville", "", "US", "840", "", "TX", "265", "", "30.04743", "-99.14032", "America/Chicago"),("4703199", "Kilgore", "", "US", "840", "", "TX", "183", "", "32.38626", "-94.87577", "America/Chicago"),("4703223", "Killeen", "Киллин", "US", "840", "", "TX", "027", "", "31.11712", "-97.7278", "America/Chicago"),("4703372", "Kingsland", "", "US", "840", "", "TX", "299", "", "30.65824", "-98.44058", "America/Chicago"),("4703384", "Kingsville", "", "US", "840", "", "TX", "273", "", "27.51587", "-97.85611", "America/Chicago"),("4703415", "Kirby", "", "US", "840", "", "TX", "029", "", "29.46329", "-98.38557", "America/Chicago"),("4703811", "Kyle", "", "US", "840", "", "TX", "209", "", "29.98911", "-97.87723", "America/Chicago"),("4703938", "La Feria", "", "US", "840", "", "TX", "061", "", "26.15896", "-97.82389", "America/Chicago"),("4703972", "La Homa", "", "US", "840", "", "TX", "215", "", "26.25007", "-98.36363", "America/Chicago"),("4704027", "La Marque", "", "US", "840", "", "TX", "167", "", "29.36857", "-94.97131", "America/Chicago"),("4704108", "La Porte", "", "US", "840", "", "TX", "201", "", "29.66578", "-95.01937", "America/Chicago"),("4704238", "Lacy-Lakeview", "", "US", "840", "", "TX", "309", "", "31.62933", "-97.10278", "America/Chicago"),("4704276", "Lago Vista", "", "US", "840", "", "TX", "453", "", "30.4602", "-97.98835", "America/Chicago"),("4704482", "Lake Dallas", "", "US", "840", "", "TX", "121", "", "33.11929", "-97.02556", "America/Chicago"),("4704628", "Lake Jackson", "", "US", "840", "", "TX", "039", "", "29.03386", "-95.43439", "America/Chicago"),("4704940", "Lakehills", "", "US", "840", "", "TX", "019", "", "29.60467", "-98.94309", "America/Chicago"),("4705041", "Lakeway", "", "US", "840", "", "TX", "453", "", "30.36377", "-97.97959", "America/Chicago"),("4705176", "Lampasas", "", "US", "840", "", "TX", "281", "", "31.06378", "-98.1817", "America/Chicago"),("4705191", "Lancaster", "Ланкастер", "US", "840", "", "TX", "113", "", "32.59208", "-96.75611", "America/Chicago"),("4705349", "Laredo", "Ларедо", "US", "840", "", "TX", "479", "", "27.50641", "-99.50754", "America/Chicago"),("4705692", "League City", "", "US", "840", "", "TX", "167", "", "29.50745", "-95.09493", "America/Chicago"),("4705708", "Leander", "", "US", "840", "", "TX", "491", "", "30.57881", "-97.85307", "America/Chicago"),("4705923", "Leon Valley", "", "US", "840", "", "TX", "029", "", "29.49523", "-98.61863", "America/Chicago"),("4706057", "Lewisville", "", "US", "840", "", "TX", "121", "", "33.04623", "-96.99417", "America/Chicago"),("4706088", "Liberty", "", "US", "840", "", "TX", "291", "", "30.05799", "-94.79548", "America/Chicago"),("4706386", "Lindale", "", "US", "840", "", "TX", "423", "", "32.5157", "-95.4094", "America/Chicago"),("4706736", "Little Elm", "", "US", "840", "", "TX", "121", "", "33.16262", "-96.93751", "America/Chicago"),("4707055", "Live Oak", "", "US", "840", "", "TX", "029", "", "29.56523", "-98.3364", "America/Chicago"),("4707173", "Livingston", "", "US", "840", "", "TX", "373", "", "30.71103", "-94.93299", "America/Chicago"),("4707295", "Lockhart", "", "US", "840", "", "TX", "055", "", "29.88494", "-97.67", "America/Chicago"),("4707814", "Longview", "", "US", "840", "", "TX", "183", "", "32.5007", "-94.74049", "America/Chicago"),("4707932", "Los Fresnos", "", "US", "840", "", "TX", "061", "", "26.07174", "-97.47637", "America/Chicago"),("4708255", "Lucas", "", "US", "840", "", "TX", "085", "", "33.08429", "-96.57666", "America/Chicago"),("4708308", "Lufkin", "", "US", "840", "", "TX", "005", "", "31.33824", "-94.7291", "America/Chicago"),("4708320", "Luling", "", "US", "840", "", "TX", "055", "", "29.68051", "-97.6475", "America/Chicago"),("4708328", "Lumberton", "", "US", "840", "", "TX", "199", "", "30.26577", "-94.19963", "America/Chicago"),("4708989", "Manor", "", "US", "840", "", "TX", "453", "", "30.34076", "-97.55695", "America/Chicago"),("4709013", "Mansfield", "Мэнсфилд", "US", "840", "", "TX", "439", "", "32.56319", "-97.14168", "America/Chicago"),("4709027", "Manvel", "", "US", "840", "", "TX", "039", "", "29.46274", "-95.35799", "America/Chicago"),("4709090", "Marble Falls", "", "US", "840", "", "TX", "053", "", "30.57841", "-98.27507", "America/Chicago"),("4709215", "Marlin", "", "US", "840", "", "TX", "145", "", "31.30629", "-96.89804", "America/Chicago"),("4709272", "Marshall", "Маршалл", "US", "840", "", "TX", "203", "", "32.54487", "-94.36742", "America/Chicago"),("4709615", "Mathis", "", "US", "840", "", "TX", "409", "", "28.09446", "-97.82805", "America/Chicago"),("4709796", "McAllen", "Мак-Аллен", "US", "840", "", "TX", "215", "", "26.20341", "-98.23001", "America/Chicago"),("4710129", "McGregor", "", "US", "840", "", "TX", "309", "", "31.44406", "-97.40918", "America/Chicago"),("4710178", "McKinney", "Мак-Кинни", "US", "840", "", "TX", "085", "", "33.19762", "-96.61527", "America/Chicago"),("4710574", "Melissa", "", "US", "840", "", "TX", "085", "", "33.28595", "-96.57277", "America/Chicago"),("4710749", "Mercedes", "", "US", "840", "", "TX", "215", "", "26.1498", "-97.91361", "America/Chicago"),("4710826", "Mesquite", "Мескит", "US", "840", "", "TX", "113", "", "32.7668", "-96.59916", "America/Chicago"),("4710963", "Mexia", "", "US", "840", "", "TX", "293", "", "31.67989", "-96.4822", "America/Chicago"),("4711156", "Midlothian", "", "US", "840", "", "TX", "139", "", "32.48236", "-96.99445", "America/Chicago"),("4711253", "Mila Doce", "", "US", "840", "", "TX", "215", "", "26.22618", "-97.95889", "America/Chicago"),("4711647", "Mineral Wells", "", "US", "840", "", "TX", "363", "", "32.80846", "-98.11282", "America/Chicago"),("4711725", "Mission", "Миссия", "US", "840", "", "TX", "215", "", "26.21591", "-98.32529", "America/Chicago"),("4711729", "Mission Bend", "", "US", "840", "", "TX", "157", "", "29.69384", "-95.66495", "America/Chicago"),("4711801", "Missouri City", "", "US", "840", "", "TX", "157", "", "29.61857", "-95.53772", "America/Chicago"),("4711967", "Mont Belvieu", "", "US", "840", "", "TX", "071", "", "29.84772", "-94.89076", "America/Chicago"),("4712933", "Mount Pleasant", "", "US", "840", "", "TX", "449", "", "33.15679", "-94.96827", "America/Chicago"),("4713506", "Murillo Colonia", "", "US", "840", "", "TX", "215", "", "26.25646", "-98.11334", "America/Chicago"),("4713507", "Murphy", "", "US", "840", "", "TX", "085", "", "33.01512", "-96.61305", "America/Chicago"),("4713735", "Nacogdoches", "", "US", "840", "", "TX", "347", "", "31.60351", "-94.65549", "America/Chicago"),("4713866", "Navasota", "", "US", "840", "", "TX", "185", "", "30.38798", "-96.08773", "America/Chicago"),("4713932", "Nederland", "", "US", "840", "", "TX", "245", "", "29.97438", "-93.9924", "America/Chicago"),("4714131", "New Braunfels", "", "US", "840", "", "TX", "091", "", "29.703", "-98.12445", "America/Chicago"),("4714582", "New Territory", "", "US", "840", "", "TX", "157", "", "29.59412", "-95.68078", "America/Chicago"),("4715292", "North Richland Hills", "", "US", "840", "", "TX", "439", "", "32.8343", "-97.2289", "America/Chicago"),("4715696", "Nurillo", "", "US", "840", "", "TX", "215", "", "26.26702", "-98.1214", "America/Chicago"),("4716805", "Orange", "", "US", "840", "", "TX", "361", "", "30.09299", "-93.73655", "America/Chicago"),("4717232", "Palestine", "Палестин", "US", "840", "", "TX", "001", "", "31.76212", "-95.63079", "America/Chicago"),("4717339", "Palmview", "", "US", "840", "", "TX", "215", "", "26.23341", "-98.37085", "America/Chicago"),("4717341", "Palmview South", "", "US", "840", "", "TX", "215", "", "26.21563", "-98.37863", "America/Chicago"),("4717560", "Paris", "Париж", "US", "840", "", "TX", "277", "", "33.66094", "-95.55551", "America/Chicago"),("4717782", "Pasadena", "Пасадена", "US", "840", "", "TX", "201", "", "29.69106", "-95.2091", "America/Chicago"),("4718097", "Pearland", "", "US", "840", "", "TX", "039", "", "29.56357", "-95.28605", "America/Chicago"),("4718107", "Pearsall", "", "US", "840", "", "TX", "163", "", "28.89219", "-99.09503", "America/Chicago"),("4718209", "Pecan Grove", "", "US", "840", "", "TX", "157", "", "29.62607", "-95.73162", "America/Chicago"),("4718236", "Pecan Plantation", "", "US", "840", "", "TX", "221", "", "32.36042", "-97.67558", "America/Chicago"),("4718491", "Perezville", "", "US", "840", "", "TX", "215", "", "26.22452", "-98.40057", "America/Chicago"),("4718711", "Pflugerville", "", "US", "840", "", "TX", "453", "", "30.43937", "-97.62", "America/Chicago"),("4718721", "Pharr", "Фарра", "US", "840", "", "TX", "215", "", "26.1948", "-98.18362", "America/Chicago"),("4719457", "Plano", "Планом", "US", "840", "", "TX", "085", "", "33.01984", "-96.69889", "America/Chicago"),("4719720", "Pleasanton", "", "US", "840", "", "TX", "013", "", "28.96719", "-98.47863", "America/Chicago"),("4720039", "Port Arthur", "Порт-Артур", "US", "840", "", "TX", "245", "", "29.88519", "-93.94233", "America/Chicago"),("4720060", "Port Isabel", "", "US", "840", "", "TX", "061", "", "26.07341", "-97.20858", "America/Chicago"),("4720067", "Port Lavaca", "", "US", "840", "", "TX", "057", "", "28.615", "-96.62609", "America/Chicago"),("4720072", "Port Neches", "", "US", "840", "", "TX", "245", "", "29.99132", "-93.95851", "America/Chicago"),("4720131", "Portland", "Портленд", "US", "840", "", "TX", "409", "", "27.87725", "-97.32388", "America/Chicago"),("4720493", "Prairie View", "", "US", "840", "", "TX", "473", "", "30.09327", "-95.98773", "America/Chicago"),("4720743", "Princeton", "", "US", "840", "", "TX", "085", "", "33.18012", "-96.49804", "America/Chicago"),("4720789", "Progreso", "", "US", "840", "", "TX", "215", "", "26.0923", "-97.95722", "America/Chicago"),("4720833", "Prosper", "", "US", "840", "", "TX", "085", "", "33.23623", "-96.80111", "America/Chicago"),("4721703", "Raymondville", "", "US", "840", "", "TX", "489", "", "26.48146", "-97.78305", "America/Chicago"),("4721921", "Red Oak", "", "US", "840", "", "TX", "139", "", "32.51764", "-96.80444", "America/Chicago"),("4722231", "Rendon", "", "US", "840", "", "TX", "439", "", "32.57625", "-97.2414", "America/Chicago"),("4722625", "Richardson", "Ричардсон", "US", "840", "", "TX", "113", "", "32.94818", "-96.72972", "America/Chicago"),("4722668", "Richland Hills", "", "US", "840", "", "TX", "439", "", "32.81596", "-97.22807", "America/Chicago"),("4722684", "Richmond", "", "US", "840", "", "TX", "157", "", "29.58218", "-95.76078", "America/Chicago"),("4722837", "Rio Grande City", "", "US", "840", "", "TX", "427", "", "26.37979", "-98.8203", "America/Chicago"),("4722925", "River Oaks", "", "US", "840", "", "TX", "439", "", "32.77707", "-97.39446", "America/Chicago"),("4723024", "Roanoke", "", "US", "840", "", "TX", "121", "", "33.00401", "-97.22585", "America/Chicago"),("4723165", "Robinson", "", "US", "840", "", "TX", "309", "", "31.46767", "-97.11472", "America/Chicago"),("4723212", "Robstown", "", "US", "840", "", "TX", "355", "", "27.7903", "-97.66888", "America/Chicago"),("4723369", "Rockdale", "", "US", "840", "", "TX", "331", "", "30.65548", "-97.00137", "America/Chicago"),("4723406", "Rockwall", "", "US", "840", "", "TX", "397", "", "32.93123", "-96.45971", "America/Chicago"),("4723422", "Rockport", "", "US", "840", "", "TX", "007", "", "28.02077", "-97.05601", "America/Chicago"),("4723763", "Roma-Los Saenz", "", "US", "840", "", "TX", "427", "", "26.40506", "-99.01586", "America/Chicago"),("4723914", "Rosenberg", "Розенберг", "US", "840", "", "TX", "157", "", "29.55718", "-95.80856", "America/Chicago"),("4724129", "Round Rock", "Раунд-Рок", "US", "840", "", "TX", "491", "", "30.50826", "-97.6789", "America/Chicago"),("4724194", "Rowlett", "", "US", "840", "", "TX", "113", "", "32.9029", "-96.56388", "America/Chicago"),("4724241", "Royse City", "", "US", "840", "", "TX", "397", "", "32.97512", "-96.33248", "America/Chicago"),("4724359", "Rusk", "", "US", "840", "", "TX", "073", "", "31.79601", "-95.15022", "America/Chicago"),("4724564", "Sachse", "", "US", "840", "", "TX", "113", "", "32.97623", "-96.59527", "America/Chicago"),("4724642", "Saginaw", "", "US", "840", "", "TX", "439", "", "32.86013", "-97.36391", "America/Chicago"),("4726206", "San Antonio", "Сан-Антонио", "US", "840", "", "TX", "029", "", "29.42412", "-98.49363", "America/Chicago"),("4726290", "San Benito", "", "US", "840", "", "TX", "061", "", "26.13258", "-97.6311", "America/Chicago"),("4726440", "San Juan", "", "US", "840", "", "TX", "215", "", "26.18924", "-98.15529", "America/Chicago"),("4726491", "San Marcos", "", "US", "840", "", "TX", "209", "", "29.88327", "-97.94139", "America/Chicago"),("4726957", "Sanger", "", "US", "840", "", "TX", "121", "", "33.36317", "-97.1739", "America/Chicago"),("4727022", "Santa Fe", "", "US", "840", "", "TX", "167", "", "29.37801", "-95.10576", "America/Chicago"),("4727326", "Schertz", "", "US", "840", "", "TX", "187", "", "29.55217", "-98.26973", "America/Chicago"),("4727596", "Seabrook", "", "US", "840", "", "TX", "201", "", "29.56412", "-95.02548", "America/Chicago"),("4727605", "Seagoville", "", "US", "840", "", "TX", "113", "", "32.63958", "-96.53832", "America/Chicago"),("4727629", "Sealy", "", "US", "840", "", "TX", "015", "", "29.78079", "-96.15718", "America/Chicago"),("4727756", "Seguin", "", "US", "840", "", "TX", "187", "", "29.56884", "-97.96473", "America/Chicago"),("4727785", "Selma", "", "US", "840", "", "TX", "029", "", "29.58439", "-98.30585", "America/Chicago"),("4728052", "Shady Hollow", "", "US", "840", "", "TX", "453", "", "30.16493", "-97.86223", "America/Chicago"),("4728328", "Sherman", "Шерман", "US", "840", "", "TX", "181", "", "33.63566", "-96.60888", "America/Chicago"),("4728608", "Sienna Plantation", "", "US", "840", "", "TX", "157", "", "29.48607", "-95.508", "America/Chicago"),("4728653", "Silsbee", "", "US", "840", "", "TX", "199", "", "30.3491", "-94.17796", "America/Chicago"),("4728826", "Sinton", "", "US", "840", "", "TX", "409", "", "28.03668", "-97.50916", "America/Chicago"),("4733042", "South Houston", "", "US", "840", "", "TX", "201", "", "29.66301", "-95.23549", "America/Chicago"),("4733313", "Southlake", "", "US", "840", "", "TX", "439", "", "32.94124", "-97.13418", "America/Chicago"),("4733624", "Spring", "", "US", "840", "", "TX", "201", "", "30.07994", "-95.41716", "America/Chicago"),("4734005", "Stafford", "", "US", "840", "", "TX", "157", "", "29.61607", "-95.55772", "America/Chicago"),("4734350", "Stephenville", "", "US", "840", "", "TX", "143", "", "32.2207", "-98.20226", "America/Chicago"),("4734825", "Sugar Land", "Шугар-Ленд", "US", "840", "", "TX", "157", "", "29.61968", "-95.63495", "America/Chicago"),("4734909", "Sulphur Springs", "", "US", "840", "", "TX", "223", "", "33.13845", "-95.60107", "America/Chicago"),("4735013", "Sunnyvale", "", "US", "840", "", "TX", "113", "", "32.79652", "-96.56082", "America/Chicago"),("4735702", "Taylor", "Тейлор", "US", "840", "", "TX", "491", "", "30.57076", "-97.40944", "America/Chicago"),("4735966", "Temple", "", "US", "840", "", "TX", "027", "", "31.09823", "-97.34278", "America/Chicago"),("4736028", "Terrell", "", "US", "840", "", "TX", "257", "", "32.73596", "-96.27526", "America/Chicago"),("4736043", "Terrell Hills", "", "US", "840", "", "TX", "029", "", "29.47495", "-98.45085", "America/Chicago"),("4736096", "Texarkana", "", "US", "840", "", "TX", "037", "", "33.42513", "-94.04769", "America/Chicago"),("4736134", "Texas City", "", "US", "840", "", "TX", "167", "", "29.38385", "-94.9027", "America/Chicago"),("4736388", "The Colony", "Колония", "US", "840", "", "TX", "121", "", "33.08901", "-96.88639", "America/Chicago"),("4736476", "The Woodlands", "Зе-Вудлендс", "US", "840", "", "TX", "339", "", "30.15799", "-95.48938", "America/Chicago"),("4736922", "Timberwood Park", "", "US", "840", "", "TX", "029", "", "29.70578", "-98.47835", "America/Chicago"),("4737094", "Tomball", "", "US", "840", "", "TX", "201", "", "30.09716", "-95.61605", "America/Chicago"),("4737676", "Trophy Club", "", "US", "840", "", "TX", "121", "", "32.9979", "-97.18362", "America/Chicago"),("4738214", "Tyler", "Тайлер", "US", "840", "", "TX", "423", "", "32.35126", "-95.30106", "America/Chicago"),("4738574", "Universal City", "", "US", "840", "", "TX", "029", "", "29.54801", "-98.29112", "America/Chicago"),("4738606", "University Park", "", "US", "840", "", "TX", "113", "", "32.85013", "-96.80028", "America/Chicago"),("4738721", "Uvalde", "", "US", "840", "", "TX", "463", "", "29.20968", "-99.78617", "America/Chicago"),("4739078", "Vernon", "", "US", "840", "", "TX", "487", "", "34.15536", "-99.26628", "America/Chicago"),("4739157", "Victoria", "Виктория", "US", "840", "", "TX", "469", "", "28.80527", "-97.0036", "America/Chicago"),("4739226", "Vidor", "", "US", "840", "", "TX", "361", "", "30.1316", "-94.01545", "America/Chicago"),("4739526", "Waco", "Вако", "US", "840", "", "TX", "309", "", "31.54933", "-97.14667", "America/Chicago"),("4739641", "Wake Village", "", "US", "840", "", "TX", "037", "", "33.42679", "-94.1063", "America/Chicago"),("4740214", "Watauga", "", "US", "840", "", "TX", "439", "", "32.85791", "-97.25474", "America/Chicago"),("4740328", "Waxahachie", "", "US", "840", "", "TX", "139", "", "32.38653", "-96.84833", "America/Chicago"),("4740364", "Weatherford", "", "US", "840", "", "TX", "367", "", "32.7593", "-97.79725", "America/Chicago"),("4740423", "Webster", "", "US", "840", "", "TX", "201", "", "29.53773", "-95.11826", "America/Chicago"),("4740584", "Wells Branch", "", "US", "840", "", "TX", "453", "", "30.44604", "-97.67945", "America/Chicago"),("4740629", "Weslaco", "", "US", "840", "", "TX", "215", "", "26.15952", "-97.99084", "America/Chicago"),("4740941", "West Livingston", "", "US", "840", "", "TX", "373", "", "30.69825", "-95.00188", "America/Chicago"),("4741100", "West University Place", "", "US", "840", "", "TX", "201", "", "29.71801", "-95.43383", "America/Chicago"),("4741325", "Wharton", "", "US", "840", "", "TX", "481", "", "29.31164", "-96.10274", "America/Chicago"),("4741501", "White Oak", "", "US", "840", "", "TX", "183", "", "32.52792", "-94.86133", "America/Chicago"),("4741616", "White Settlement", "", "US", "840", "", "TX", "439", "", "32.75957", "-97.45835", "America/Chicago"),("4741641", "Whitehouse", "", "US", "840", "", "TX", "423", "", "32.22682", "-95.2255", "America/Chicago"),("4741752", "Wichita Falls", "Уичито-Фолс", "US", "840", "", "TX", "485", "", "33.91371", "-98.49339", "America/Chicago"),("4742170", "Willis", "", "US", "840", "", "TX", "339", "", "30.42493", "-95.47994", "America/Chicago"),("4742537", "Windcrest", "", "US", "840", "", "TX", "029", "", "29.51551", "-98.38029", "America/Chicago"),("4743105", "Woodway", "", "US", "840", "", "TX", "309", "", "31.506", "-97.20501", "America/Chicago"),("4743275", "Wylie", "", "US", "840", "", "TX", "085", "", "33.01512", "-96.53888", "America/Chicago"),("4743432", "Yoakum", "", "US", "840", "", "TX", "123", "", "29.28775", "-97.15193", "America/Chicago"),("4743575", "Zapata", "", "US", "840", "", "TX", "505", "", "26.90726", "-99.27143", "America/Chicago"),("4743815", "Abingdon", "", "US", "840", "", "VA", "191", "", "36.70983", "-81.97735", "America/New_York"),("4744091", "Alexandria", "Александрия", "US", "840", "", "VA", "510", "", "38.80484", "-77.04692", "America/New_York"),("4744468", "Annandale", "", "US", "840", "", "VA", "059", "", "38.83039", "-77.19637", "America/New_York"),("4744645", "Aquia Harbour", "", "US", "840", "", "VA", "179", "", "38.46262", "-77.38887", "America/New_York"),("4744709", "Arlington", "Арлингтон", "US", "840", "", "VA", "013", "", "38.88101", "-77.10428", "America/New_York"),("4744870", "Ashburn", "", "US", "840", "", "VA", "107", "", "39.04372", "-77.48749", "America/New_York"),("4744905", "Ashland", "", "US", "840", "", "VA", "085", "", "37.75903", "-77.47998", "America/New_York"),("4745272", "Baileys Crossroads", "", "US", "840", "", "VA", "059", "", "38.85039", "-77.1297", "America/New_York"),("4746265", "Bedford", "", "US", "840", "", "VA", "515", "", "37.33431", "-79.52309", "America/New_York"),("4746457", "Belle Haven", "", "US", "840", "", "VA", "059", "", "38.78539", "-77.06303", "America/New_York"),("4746526", "Bellwood", "", "US", "840", "", "VA", "041", "", "37.42181", "-77.43748", "America/New_York"),("4746535", "Belmont", "", "US", "840", "", "VA", "107", "", "39.06483", "-77.50999", "America/New_York"),("4746664", "Bensley", "", "US", "840", "", "VA", "041", "", "37.44681", "-77.44332", "America/New_York"),("4747554", "Big Stone Gap", "", "US", "840", "", "VA", "195", "", "36.88176", "-82.7471", "America/New_York"),("4747845", "Blacksburg", "Блэксбург", "US", "840", "", "VA", "121", "", "37.22957", "-80.41394", "America/New_York"),("4748125", "Bluefield", "", "US", "840", "", "VA", "185", "", "37.25262", "-81.27121", "America/New_York"),("4748305", "Bon Air", "", "US", "840", "", "VA", "041", "", "37.52487", "-77.55777", "America/New_York"),("4748703", "Brambleton", "", "US", "840", "", "VA", "107", "", "38.98205", "-77.5386", "America/New_York"),("4748726", "Brandermill", "", "US", "840", "", "VA", "041", "", "37.43209", "-77.64971", "America/New_York"),("4748925", "Bridgewater", "", "US", "840", "", "VA", "165", "", "38.38207", "-78.9767", "America/New_York"),("4748993", "Bristol", "", "US", "840", "", "VA", "520", "", "36.59649", "-82.18847", "America/New_York"),("4749103", "Broadlands", "", "US", "840", "", "VA", "107", "", "39.01816", "-77.52027", "America/New_York"),("4749627", "Buckhall", "", "US", "840", "", "VA", "153", "", "38.73178", "-77.4311", "America/New_York"),("4749715", "Buena Vista", "", "US", "840", "", "VA", "530", "", "37.7343", "-79.35392", "America/New_York"),("4749854", "Bull Run", "", "US", "840", "", "VA", "153", "", "38.78373", "-77.52055", "America/New_York"),("4749950", "Burke", "Берк", "US", "840", "", "VA", "059", "", "38.79345", "-77.27165", "America/New_York"),("4751421", "Cave Spring", "", "US", "840", "", "VA", "161", "", "37.22764", "-80.01282", "America/New_York"),("4751839", "Centreville", "", "US", "840", "", "VA", "059", "", "38.84039", "-77.42888", "America/New_York"),("4751886", "Chamberlayne", "", "US", "840", "", "VA", "087", "", "37.62653", "-77.42859", "America/New_York"),("4751935", "Chantilly", "", "US", "840", "", "VA", "059", "", "38.89428", "-77.4311", "America/New_York"),("4752031", "Charlottesville", "Шарлоттсвилль", "US", "840", "", "VA", "540", "", "38.02931", "-78.47668", "America/New_York"),("4752136", "Cherry Hill", "", "US", "840", "", "VA", "153", "", "38.56984", "-77.26693", "America/New_York"),("4752186", "Chesapeake", "Чесапик", "US", "840", "", "VA", "550", "", "36.81904", "-76.27494", "America/New_York"),("4752229", "Chester", "Честер", "US", "840", "", "VA", "041", "", "37.35682", "-77.44165", "America/New_York"),("4752665", "Christiansburg", "", "US", "840", "", "VA", "121", "", "37.12985", "-80.40894", "America/New_York"),("4753635", "Collinsville", "", "US", "840", "", "VA", "089", "", "36.71514", "-79.91532", "America/New_York"),("4753671", "Colonial Heights", "", "US", "840", "", "VA", "570", "", "37.26804", "-77.40726", "America/New_York"),("4754219", "Countryside", "", "US", "840", "", "VA", "107", "", "39.04094", "-77.4136", "America/New_York"),("4754358", "Covington", "", "US", "840", "", "VA", "580", "", "37.79346", "-79.99395", "America/New_York"),("4754901", "Crozet", "", "US", "840", "", "VA", "003", "", "38.06958", "-78.70058", "America/New_York"),("4754966", "Culpeper", "Калпепер", "US", "840", "", "VA", "047", "", "38.47318", "-77.99666", "America/New_York"),("4755158", "Dale City", "", "US", "840", "", "VA", "153", "", "38.63706", "-77.31109", "America/New_York"),("4755280", "Danville", "", "US", "840", "", "VA", "590", "", "36.58597", "-79.39502", "America/New_York"),("4756348", "Dranesville", "", "US", "840", "", "VA", "059", "", "39.00067", "-77.34582", "America/New_York"),("4756643", "Dumfries", "", "US", "840", "", "VA", "153", "", "38.56762", "-77.32804", "America/New_York"),("4756653", "Dumbarton", "", "US", "840", "", "VA", "087", "", "37.60376", "-77.49137", "America/New_York"),("4756736", "Dunn Loring", "", "US", "840", "", "VA", "059", "", "38.89344", "-77.22165", "America/New_York"),("4756955", "East Hampton", "", "US", "840", "", "VA", "650", "", "37.03737", "-76.33161", "America/New_York"),("4756972", "East Highland Park", "", "US", "840", "", "VA", "087", "", "37.58098", "-77.40693", "America/New_York"),("4757673", "Emporia", "", "US", "840", "", "VA", "595", "", "36.68598", "-77.54248", "America/New_York"),("4757863", "Ettrick", "", "US", "840", "", "VA", "041", "", "37.24015", "-77.42998", "America/New_York"),("4758023", "Fairfax", "", "US", "840", "", "VA", "600", "", "38.84622", "-77.30637", "America/New_York"),("4758102", "Fairfax Station", "", "US", "840", "", "VA", "059", "", "38.80095", "-77.32554", "America/New_York"),("4758390", "Falls Church", "", "US", "840", "", "VA", "610", "", "38.88233", "-77.17109", "America/New_York"),("4758495", "Farmville", "", "US", "840", "", "VA", "147", "", "37.3021", "-78.39194", "America/New_York"),("4759120", "Fishersville", "", "US", "840", "", "VA", "015", "", "38.09902", "-78.96919", "America/New_York"),("4759430", "Floris", "", "US", "840", "", "VA", "059", "", "38.93706", "-77.41277", "America/New_York"),("4759556", "Forest", "", "US", "840", "", "VA", "019", "", "37.36375", "-79.28975", "America/New_York"),("4759735", "Fort Lee", "", "US", "840", "", "VA", "087", "", "37.4957", "-77.33526", "America/New_York"),("4759968", "Franconia", "Франкония", "US", "840", "", "VA", "059", "", "38.78206", "-77.14637", "America/New_York"),("4759986", "Franklin", "", "US", "840", "", "VA", "620", "", "36.67765", "-76.92246", "America/New_York"),("4760059", "Fredericksburg", "Фредериксбург", "US", "840", "", "VA", "630", "", "38.30318", "-77.46054", "America/New_York"),("4760232", "Front Royal", "", "US", "840", "", "VA", "187", "", "38.91817", "-78.19444", "America/New_York"),("4760363", "Gainesville", "", "US", "840", "", "VA", "153", "", "38.79567", "-77.61388", "America/New_York"),("4760376", "Galax", "", "US", "840", "", "VA", "640", "", "36.66124", "-80.92397", "America/New_York"),("4761054", "Glen Allen", "", "US", "840", "", "VA", "087", "", "37.66598", "-77.50637", "America/New_York"),("4761171", "Gloucester Point", "", "US", "840", "", "VA", "073", "", "37.25403", "-76.49689", "America/New_York"),("4761951", "Great Falls", "", "US", "840", "", "VA", "059", "", "38.99817", "-77.28832", "America/New_York"),("4762155", "Greenbriar", "", "US", "840", "", "VA", "059", "", "38.87345", "-77.40082", "America/New_York"),("4762493", "Groveton", "", "US", "840", "", "VA", "059", "", "38.76734", "-77.0847", "America/New_York"),("4762894", "Hampton", "Хэмптон", "US", "840", "", "VA", "650", "", "37.02987", "-76.34522", "America/New_York"),("4763231", "Harrisonburg", "", "US", "840", "", "VA", "660", "", "38.44957", "-78.86892", "America/New_York"),("4763793", "Herndon", "Херндон", "US", "840", "", "VA", "059", "", "38.96955", "-77.3861", "America/New_York"),("4764127", "Highland Springs", "", "US", "840", "", "VA", "087", "", "37.54598", "-77.32776", "America/New_York"),("4764534", "Hollins", "", "US", "840", "", "VA", "161", "", "37.34125", "-79.9431", "America/New_York"),("4764607", "Hollymead", "", "US", "840", "", "VA", "003", "", "38.11708", "-78.44168", "America/New_York"),("4764826", "Hopewell", "Хопуэлла", "US", "840", "", "VA", "670", "", "37.30432", "-77.2872", "America/New_York"),("4765392", "Huntington", "", "US", "840", "", "VA", "059", "", "38.79234", "-77.07081", "America/New_York"),("4765520", "Hybla Valley", "", "US", "840", "", "VA", "059", "", "38.74761", "-77.08303", "America/New_York"),("4765553", "Idylwood", "", "US", "840", "", "VA", "059", "", "38.89511", "-77.21165", "America/New_York"),("4765594", "Independent Hill", "", "US", "840", "", "VA", "153", "", "38.63595", "-77.43776", "America/New_York"),("4766586", "Jefferson", "Джефферсон", "US", "840", "", "VA", "059", "", "38.86456", "-77.18776", "America/New_York"),("4768185", "Lake Barcroft", "", "US", "840", "", "VA", "059", "", "38.84789", "-77.15581", "America/New_York"),("4768313", "Lake Monticello", "", "US", "840", "", "VA", "065", "", "37.9232", "-78.33473", "America/New_York"),("4768351", "Lake Ridge", "", "US", "840", "", "VA", "153", "", "38.68789", "-77.29776", "America/New_York"),("4768423", "Lakeside", "", "US", "840", "", "VA", "087", "", "37.60765", "-77.47693", "America/New_York"),("4768678", "Laurel", "", "US", "840", "", "VA", "087", "", "37.64292", "-77.50887", "America/New_York"),("4769125", "Leesburg", "", "US", "840", "", "VA", "107", "", "39.11566", "-77.5636", "America/New_York"),("4769339", "Lexington", "", "US", "840", "", "VA", "678", "", "37.78402", "-79.44282", "America/New_York"),("4769608", "Lincolnia", "", "US", "840", "", "VA", "059", "", "38.81845", "-77.14331", "America/New_York"),("4769667", "Linton Hall", "", "US", "840", "", "VA", "153", "", "38.75984", "-77.57499", "America/New_York"),("4770714", "Lorton", "", "US", "840", "", "VA", "059", "", "38.70428", "-77.22776", "America/New_York"),("4770931", "Lowes Island", "", "US", "840", "", "VA", "107", "", "39.05983", "-77.35221", "America/New_York"),("4771075", "Lynchburg", "", "US", "840", "", "VA", "680", "", "37.41375", "-79.14225", "America/New_York"),("4771247", "Madison Heights", "", "US", "840", "", "VA", "009", "", "37.43098", "-79.12308", "America/New_York"),("4771401", "Manassas", "Манассас", "US", "840", "", "VA", "683", "", "38.75095", "-77.47527", "America/New_York"),("4771414", "Manassas Park", "", "US", "840", "", "VA", "685", "", "38.784", "-77.46971", "America/New_York"),("4771494", "Mantua", "", "US", "840", "", "VA", "059", "", "38.85372", "-77.25943", "America/New_York"),("4771643", "Marion", "", "US", "840", "", "VA", "173", "", "36.83484", "-81.51484", "America/New_York"),("4771808", "Martinsville", "", "US", "840", "", "VA", "690", "", "36.69153", "-79.87254", "America/New_York"),("4772354", "McLean", "Маклин", "US", "840", "", "VA", "059", "", "38.93428", "-77.17748", "America/New_York"),("4772566", "Mechanicsville", "", "US", "840", "", "VA", "085", "", "37.60876", "-77.37331", "America/New_York"),("4772735", "Merrifield", "", "US", "840", "", "VA", "059", "", "38.87428", "-77.22693", "America/New_York"),("4773677", "Montclair", "", "US", "840", "", "VA", "153", "", "38.61095", "-77.33971", "America/New_York"),("4773747", "Montrose", "", "US", "840", "", "VA", "087", "", "37.5207", "-77.37831", "America/New_York"),("4775660", "New Baltimore", "", "US", "840", "", "VA", "061", "", "38.76734", "-77.72833", "America/New_York"),("4775981", "Newington", "", "US", "840", "", "VA", "059", "", "38.73845", "-77.18498", "America/New_York"),("4776024", "Newport News", "Ньюпорт-Ньюс", "US", "840", "", "VA", "700", "", "37.08339", "-76.46965", "America/New_York"),("4776222", "Norfolk", "Норфолк", "US", "840", "", "VA", "710", "", "36.84681", "-76.28522", "America/New_York"),("4776472", "North Springfield", "", "US", "840", "", "VA", "059", "", "38.80428", "-77.2047", "America/New_York"),("4776970", "Oakton", "", "US", "840", "", "VA", "059", "", "38.88095", "-77.30082", "America/New_York"),("4778626", "Petersburg", "Петербург", "US", "840", "", "VA", "730", "", "37.22793", "-77.40193", "America/New_York"),("4778945", "Pimmit Hills", "", "US", "840", "", "VA", "059", "", "38.91289", "-77.20081", "America/New_York"),("4779923", "Poquoson", "", "US", "840", "", "VA", "735", "", "37.12237", "-76.34578", "America/New_York"),("4779999", "Portsmouth", "Портсмут", "US", "840", "", "VA", "740", "", "36.83543", "-76.29827", "America/New_York"),("4780011", "Portsmouth Heights", "", "US", "840", "", "VA", "740", "", "36.82098", "-76.36883", "America/New_York"),("4780087", "Potomac Mills", "", "US", "840", "", "VA", "153", "", "38.64595", "-77.29415", "America/New_York"),("4780577", "Pulaski", "", "US", "840", "", "VA", "155", "", "37.0479", "-80.77979", "America/New_York"),("4780641", "Purcellville", "", "US", "840", "", "VA", "107", "", "39.13677", "-77.71472", "America/New_York"),("4780837", "Radford", "", "US", "840", "", "VA", "750", "", "37.13179", "-80.57645", "America/New_York"),("4781530", "Reston", "Рестон", "US", "840", "", "VA", "059", "", "38.96872", "-77.3411", "America/New_York"),("4781708", "Richmond", "Ричмонд", "US", "840", "", "VA", "760", "", "37.55376", "-77.46026", "America/New_York"),("4781711", "Richlands", "", "US", "840", "", "VA", "185", "", "37.09317", "-81.79373", "America/New_York"),("4782167", "Roanoke", "Роанок", "US", "840", "", "VA", "770", "", "37.27097", "-79.94143", "America/New_York"),("4782864", "Rose Hill", "", "US", "840", "", "VA", "059", "", "38.78872", "-77.11276", "America/New_York"),("4784112", "Salem", "Салем", "US", "840", "", "VA", "775", "", "37.29347", "-80.05476", "America/New_York"),("4784352", "Sandston", "", "US", "840", "", "VA", "087", "", "37.52348", "-77.31581", "America/New_York"),("4784902", "Seven Corners", "", "US", "840", "", "VA", "059", "", "38.87206", "-77.15526", "America/New_York"),("4785576", "Short Pump", "", "US", "840", "", "VA", "087", "", "37.65042", "-77.61249", "America/New_York"),("4786274", "Smithfield", "", "US", "840", "", "VA", "093", "", "36.98237", "-76.63107", "America/New_York"),("4786522", "South Boston", "", "US", "840", "", "VA", "083", "", "36.69875", "-78.9014", "America/New_York"),("4786667", "South Riding", "", "US", "840", "", "VA", "107", "", "38.92094", "-77.50388", "America/New_York"),("4786714", "South Suffolk", "", "US", "840", "", "VA", "800", "", "36.71709", "-76.59023", "America/New_York"),("4787117", "Springfield", "Спрингфилд", "US", "840", "", "VA", "059", "", "38.78928", "-77.1872", "America/New_York"),("4787440", "Staunton", "Стонтон", "US", "840", "", "VA", "790", "", "38.14991", "-79.0732", "America/New_York"),("4787534", "Sterling", "Стерлинг", "US", "840", "", "VA", "107", "", "39.00622", "-77.4286", "America/New_York"),("4787974", "Strasburg", "", "US", "840", "", "VA", "171", "", "38.98872", "-78.35862", "America/New_York"),("4788070", "Stuarts Draft", "", "US", "840", "", "VA", "015", "", "38.03014", "-79.03364", "America/New_York"),("4788145", "Sudley", "", "US", "840", "", "VA", "153", "", "38.79289", "-77.49749", "America/New_York"),("4788158", "Suffolk", "Саффолк", "US", "840", "", "VA", "800", "", "36.72836", "-76.58496", "America/New_York"),("4788216", "Sugarland Run", "", "US", "840", "", "VA", "107", "", "39.03761", "-77.37526", "America/New_York"),("4789648", "Timberlake", "", "US", "840", "", "VA", "031", "", "37.3207", "-79.25753", "America/New_York"),("4790025", "Triangle", "", "US", "840", "", "VA", "153", "", "38.54679", "-77.33665", "America/New_York"),("4790207", "Tuckahoe", "", "US", "840", "", "VA", "087", "", "37.59015", "-77.55638", "America/New_York"),("4790534", "Tysons Corner", "", "US", "840", "", "VA", "059", "", "38.91872", "-77.23109", "America/New_York"),("4791160", "Vienna", "", "US", "840", "", "VA", "059", "", "38.90122", "-77.26526", "America/New_York"),("4791237", "Vinton", "", "US", "840", "", "VA", "161", "", "37.28097", "-79.89698", "America/New_York"),("4791259", "Virginia Beach", "Вирджиния-Бич", "US", "840", "", "VA", "810", "", "36.85293", "-75.97799", "America/New_York"),("4792255", "Warrenton", "", "US", "840", "", "VA", "061", "", "38.71345", "-77.79527", "America/New_York"),("4792522", "Waynesboro", "", "US", "840", "", "VA", "820", "", "38.06847", "-78.88947", "America/New_York"),("4792799", "West Falls Church", "", "US", "840", "", "VA", "610", "", "38.89094", "-77.18443", "America/New_York"),("4792829", "West Gate", "", "US", "840", "", "VA", "153", "", "38.78289", "-77.49749", "America/New_York"),("4792867", "West Lynchburg", "", "US", "840", "", "VA", "680", "", "37.4032", "-79.17808", "America/New_York"),("4792901", "West Springfield", "", "US", "840", "", "VA", "059", "", "38.77261", "-77.22109", "America/New_York"),("4793846", "Williamsburg", "", "US", "840", "", "VA", "830", "", "37.2707", "-76.70746", "America/New_York"),("4794120", "Winchester", "", "US", "840", "", "VA", "840", "", "39.18566", "-78.16333", "America/New_York"),("4794350", "Wolf Trap", "", "US", "840", "", "VA", "059", "", "38.93983", "-77.28609", "America/New_York"),("4794531", "Woodlawn", "", "US", "840", "", "VA", "059", "", "38.71678", "-77.13276", "America/New_York"),("4794641", "Woodstock", "", "US", "840", "", "VA", "171", "", "38.88178", "-78.50584", "America/New_York"),("4794814", "Wyndham", "", "US", "840", "", "VA", "087", "", "37.69848", "-77.61249", "America/New_York"),("4794837", "Wytheville", "", "US", "840", "", "VA", "197", "", "36.94845", "-81.08481", "America/New_York"),("4794966", "Yorkshire", "", "US", "840", "", "VA", "153", "", "38.79317", "-77.44777", "America/New_York"),("4798308", "Beckley", "Бекли", "US", "840", "", "WV", "081", "", "37.77817", "-81.18816", "America/New_York"),("4799622", "Bluefield", "", "US", "840", "", "WV", "055", "", "37.26984", "-81.22232", "America/New_York"),("4800081", "Bridgeport", "", "US", "840", "", "WV", "033", "", "39.28648", "-80.2562", "America/New_York"),("4800195", "Brookhaven", "", "US", "840", "", "WV", "061", "", "39.61175", "-79.90451", "America/New_York"),("4800587", "Buckhannon", "", "US", "840", "", "WV", "097", "", "38.99399", "-80.23203", "America/New_York"),("4801850", "Charles Town", "", "US", "840", "", "WV", "037", "", "39.28899", "-77.85972", "America/New_York"),("4801859", "Charleston", "Чарлстон", "US", "840", "", "WV", "039", "", "38.34982", "-81.63262", "America/New_York"),("4801895", "Cheat Lake", "", "US", "840", "", "WV", "061", "", "39.67202", "-79.85339", "America/New_York"),("4802316", "Clarksburg", "Кларксберг", "US", "840", "", "WV", "033", "", "39.28065", "-80.34453", "America/New_York"),("4803372", "Cross Lanes", "", "US", "840", "", "WV", "039", "", "38.42037", "-81.79068", "America/New_York"),("4804563", "Dunbar", "", "US", "840", "", "WV", "039", "", "38.36065", "-81.73735", "America/New_York"),("4805033", "Elkins", "", "US", "840", "", "WV", "083", "", "38.92594", "-79.84673", "America/New_York"),("4805404", "Fairmont", "Фэрмонт", "US", "840", "", "WV", "049", "", "39.48508", "-80.14258", "America/New_York"),("4807310", "Grafton", "", "US", "840", "", "WV", "091", "", "39.34092", "-80.01897", "America/New_York"),("4809537", "Huntington", "Хантингтон", "US", "840", "", "WV", "011", "", "38.41925", "-82.44515", "America/New_York"),("4809558", "Hurricane", "", "US", "840", "", "WV", "079", "", "38.43259", "-82.02014", "America/New_York"),("4810884", "Keyser", "", "US", "840", "", "WV", "057", "", "39.44093", "-78.97392", "America/New_York"),("4813878", "Martinsburg", "Мартинсберг", "US", "840", "", "WV", "003", "", "39.45621", "-77.96389", "America/New_York"),("4815352", "Morgantown", "Моргантаун", "US", "840", "", "WV", "061", "", "39.62953", "-79.9559", "America/New_York"),("4815462", "Moundsville", "", "US", "840", "", "WV", "051", "", "39.92035", "-80.74314", "America/New_York"),("4816520", "New Martinsville", "", "US", "840", "", "WV", "103", "", "39.64452", "-80.8576", "America/New_York"),("4816665", "Nitro", "", "US", "840", "", "WV", "039", "", "38.41481", "-81.84402", "America/New_York"),("4816993", "Oak Hill", "", "US", "840", "", "WV", "019", "", "37.97233", "-81.14871", "America/New_York"),("4817641", "Parkersburg", "Паркерсберг", "US", "840", "", "WV", "107", "", "39.26674", "-81.56151", "America/New_York"),("4817825", "Pea Ridge", "", "US", "840", "", "WV", "011", "", "38.41397", "-82.31987", "America/New_York"),("4819079", "Princeton", "", "US", "840", "", "WV", "055", "", "37.36623", "-81.10259", "America/New_York"),("4820938", "Saint Albans", "", "US", "840", "", "WV", "039", "", "38.38565", "-81.83624", "America/New_York"),("4822764", "South Charleston", "", "US", "840", "", "WV", "039", "", "38.36843", "-81.69957", "America/New_York"),("4824469", "Teays Valley", "", "US", "840", "", "WV", "079", "", "38.45009", "-81.9293", "America/New_York"),("4825976", "Vienna", "", "US", "840", "", "WV", "107", "", "39.32702", "-81.54846", "America/New_York"),("4828193", "Sherwood", "", "US", "840", "", "AR", "119", "", "34.81509", "-92.22432", "America/Chicago"),("4828382", "Franklin", "Франклин", "US", "840", "", "IN", "081", "", "39.48061", "-86.05499", "America/Indiana/Indianapolis"),("4828890", "Chillicothe", "", "US", "840", "", "OH", "141", "", "39.33312", "-82.9824", "America/New_York"),("4829307", "Bay City", "Бей-Сити", "US", "840", "", "TX", "321", "", "28.98276", "-95.9694", "America/Chicago"),("4829762", "Alabaster", "Алебастр", "US", "840", "", "AL", "117", "", "33.24428", "-86.81638", "America/Chicago"),("4829791", "Albertville", "", "US", "840", "", "AL", "095", "", "34.26759", "-86.20887", "America/Chicago"),("4829843", "Alexander City", "", "US", "840", "", "AL", "123", "", "32.94401", "-85.95385", "America/Chicago"),("4830099", "Andalusia", "", "US", "840", "", "AL", "039", "", "31.3085", "-86.48329", "America/Chicago"),("4830198", "Anniston", "Аннистон", "US", "840", "", "AL", "015", "", "33.65983", "-85.83163", "America/Chicago"),("4830455", "Arab", "", "US", "840", "", "AL", "095", "", "34.31815", "-86.49582", "America/Chicago"),("4830668", "Athens", "Атенс", "US", "840", "", "AL", "083", "", "34.80287", "-86.97167", "America/Chicago"),("4830759", "Atmore", "", "US", "840", "", "AL", "053", "", "31.02379", "-87.49387", "America/Chicago"),("4830768", "Attalla", "", "US", "840", "", "AL", "055", "", "34.02176", "-86.08859", "America/Chicago"),("4830796", "Auburn", "Оберн", "US", "840", "", "AL", "081", "", "32.60986", "-85.48078", "America/Chicago"),("4831969", "Cos Cob", "", "US", "840", "", "CT", "001", "", "41.03343", "-73.59957", "America/New_York"),("4831990", "Canton", "", "US", "840", "", "IL", "057", "", "40.55809", "-90.03512", "America/Chicago"),("4832038", "Glendale Heights", "", "US", "840", "", "IL", "043", "", "41.91031", "-88.07174", "America/Chicago"),("4832121", "Cromwell", "", "US", "840", "", "CT", "007", "", "41.5951", "-72.64537", "America/New_York"),("4832176", "East Falmouth", "", "US", "840", "", "MA", "001", "", "41.57844", "-70.55864", "America/New_York"),("4832272", "North Andover", "", "US", "840", "", "MA", "009", "", "42.6987", "-71.13506", "America/New_York"),("4832294", "Revere", "", "US", "840", "", "MA", "025", "", "42.40843", "-71.01199", "America/New_York"),("4832353", "Danbury", "Данбери", "US", "840", "", "CT", "001", "", "41.39482", "-73.45401", "America/New_York"),("4832425", "Darien", "", "US", "840", "", "CT", "001", "", "41.07871", "-73.46929", "America/New_York"),("4832458", "Rockland", "", "US", "840", "", "ME", "013", "", "44.10369", "-69.10893", "America/New_York"),("4832554", "Inkster", "", "US", "840", "", "MI", "163", "", "42.2942", "-83.30993", "America/Detroit"),("4832745", "Derby", "", "US", "840", "", "CT", "009", "", "41.32065", "-73.089", "America/New_York"),("4833084", "Yardville", "", "US", "840", "", "NJ", "021", "", "40.18122", "-74.66432", "America/New_York"),("4833276", "Watervliet", "", "US", "840", "", "NY", "001", "", "42.73008", "-73.70123", "America/New_York"),("4833320", "Cleveland Heights", "Кливленд-Хайтс", "US", "840", "", "OH", "035", "", "41.52005", "-81.55624", "America/New_York"),("4833363", "East Haddam", "", "US", "840", "", "CT", "007", "", "41.45315", "-72.4612", "America/New_York"),("4833403", "East Hartford", "", "US", "840", "", "CT", "003", "", "41.78232", "-72.61203", "America/New_York"),("4833425", "East Haven", "", "US", "840", "", "CT", "009", "", "41.27621", "-72.86843", "America/New_York"),("4833478", "Carnegie", "", "US", "840", "", "PA", "003", "", "40.40868", "-80.08339", "America/New_York"),("4833505", "East Norwalk", "", "US", "840", "", "CT", "001", "", "41.10565", "-73.39845", "America/New_York"),("4833661", "Easton", "", "US", "840", "", "CT", "001", "", "41.25287", "-73.29734", "America/New_York"),("4833883", "Ellington", "", "US", "840", "", "CT", "013", "", "41.90399", "-72.46981", "America/New_York"),("4834040", "Enfield", "", "US", "840", "", "CT", "003", "", "41.97621", "-72.59176", "America/New_York"),("4834157", "Fairfield", "Феърфилд", "US", "840", "", "CT", "001", "", "41.14121", "-73.26373", "America/New_York"),("4834272", "Farmington", "Фармингтон", "US", "840", "", "CT", "003", "", "41.71982", "-72.83204", "America/New_York"),("4835003", "Glastonbury", "Гластонбери", "US", "840", "", "CT", "003", "", "41.71232", "-72.60815", "America/New_York"),("4835004", "Glastonbury Center", "", "US", "840", "", "CT", "003", "", "41.70093", "-72.59953", "America/New_York"),("4835395", "Greenwich", "", "US", "840", "", "CT", "001", "", "41.02649", "-73.62846", "America/New_York"),("4835461", "Groton", "", "US", "840", "", "CT", "011", "", "41.3501", "-72.07841", "America/New_York"),("4835512", "Guilford", "Гилфорд", "US", "840", "", "CT", "009", "", "41.28899", "-72.68176", "America/New_York"),("4835654", "Hamden", "", "US", "840", "", "CT", "009", "", "41.39593", "-72.89677", "America/New_York"),("4835797", "Hartford", "Хартфорд", "US", "840", "", "CT", "003", "", "41.76371", "-72.68509", "America/New_York"),("4835969", "Hebron", "", "US", "840", "", "CT", "013", "", "41.65788", "-72.36592", "America/New_York"),("4837222", "Kensington", "", "US", "840", "", "CT", "003", "", "41.63538", "-72.76871", "America/New_York"),("4837278", "Killingly Center", "", "US", "840", "", "CT", "015", "", "41.83871", "-71.86924", "America/New_York"),("4837648", "Ledyard Center", "", "US", "840", "", "CT", "011", "", "41.43982", "-72.01424", "America/New_York"),("4838116", "Madison", "Мадисон", "US", "840", "", "CT", "009", "", "41.27954", "-72.59843", "America/New_York"),("4838174", "Manchester", "Манчестер", "US", "840", "", "CT", "003", "", "41.77593", "-72.52148", "America/New_York"),("4838204", "Mansfield City", "", "US", "840", "", "CT", "013", "", "41.76593", "-72.23369", "America/New_York"),("4838524", "Meriden", "Мериден", "US", "840", "", "CT", "009", "", "41.53815", "-72.80704", "America/New_York"),("4838611", "Middlebury", "", "US", "840", "", "CT", "009", "", "41.52787", "-73.12761", "America/New_York"),("4838633", "Middletown", "Мидлтаун", "US", "840", "", "CT", "007", "", "41.56232", "-72.65065", "America/New_York"),("4838652", "Milford", "Милфорд", "US", "840", "", "CT", "009", "", "41.22232", "-73.0565", "America/New_York"),("4838887", "Montville Center", "", "US", "840", "", "CT", "011", "", "41.47899", "-72.15119", "America/New_York"),("4839222", "Naugatuck", "", "US", "840", "", "CT", "009", "", "41.48593", "-73.05066", "America/New_York"),("4839292", "New Britain", "Нью-Бритен", "US", "840", "", "CT", "003", "", "41.66121", "-72.77954", "America/New_York"),("4839319", "New Canaan", "", "US", "840", "", "CT", "001", "", "41.14676", "-73.49484", "America/New_York"),("4839345", "New Fairfield", "", "US", "840", "", "CT", "001", "", "41.46648", "-73.48568", "America/New_York"),("4839366", "New Haven", "Нью-Хейвен", "US", "840", "", "CT", "009", "", "41.30815", "-72.92816", "America/New_York"),("4839416", "New London", "Нью-Лондон", "US", "840", "", "CT", "011", "", "41.35565", "-72.09952", "America/New_York"),("4839435", "New Milford", "", "US", "840", "", "CT", "005", "", "41.57704", "-73.40845", "America/New_York"),("4839497", "Newington", "", "US", "840", "", "CT", "003", "", "41.69788", "-72.72371", "America/New_York"),("4839636", "North Branford", "", "US", "840", "", "CT", "009", "", "41.3276", "-72.76732", "America/New_York"),("4839704", "North Haven", "", "US", "840", "", "CT", "009", "", "41.39093", "-72.85954", "America/New_York"),("4839745", "North Stamford", "", "US", "840", "", "CT", "001", "", "41.13815", "-73.54346", "America/New_York"),("4839822", "Norwalk", "Норуолк", "US", "840", "", "CT", "001", "", "41.1176", "-73.4079", "America/New_York"),("4839843", "Norwich", "Норидж", "US", "840", "", "CT", "011", "", "41.52426", "-72.07591", "America/New_York"),("4839921", "Oakville", "", "US", "840", "", "CT", "005", "", "41.59343", "-73.08539", "America/New_York"),("4839983", "Old Greenwich", "", "US", "840", "", "CT", "001", "", "41.02287", "-73.56485", "America/New_York"),("4840035", "Old Saybrook", "", "US", "840", "", "CT", "007", "", "41.29177", "-72.3762", "America/New_York"),("4840104", "Orange", "", "US", "840", "", "CT", "009", "", "41.27843", "-73.02566", "America/New_York"),("4840237", "Oxford", "", "US", "840", "", "CT", "009", "", "41.43399", "-73.11678", "America/New_York"),("4840426", "Pawcatuck", "", "US", "840", "", "CT", "011", "", "41.37732", "-71.83368", "America/New_York"),("4840755", "Plainfield", "", "US", "840", "", "CT", "015", "", "41.67649", "-71.91507", "America/New_York"),("4840767", "Plainville", "Плейнвилль", "US", "840", "", "CT", "003", "", "41.67454", "-72.85816", "America/New_York"),("4840844", "Plymouth", "", "US", "840", "", "CT", "005", "", "41.67204", "-73.05289", "America/New_York"),("4841001", "Portland", "", "US", "840", "", "CT", "007", "", "41.57288", "-72.64065", "America/New_York"),("4841089", "Prospect", "", "US", "840", "", "CT", "009", "", "41.50232", "-72.97872", "America/New_York"),("4841187", "Putnam", "", "US", "840", "", "CT", "015", "", "41.9151", "-71.90896", "America/New_York"),("4841463", "Ridgefield", "", "US", "840", "", "CT", "001", "", "41.28148", "-73.49818", "America/New_York"),("4841527", "Riverside", "", "US", "840", "", "CT", "001", "", "41.03371", "-73.57818", "America/New_York"),("4841628", "Rockville", "", "US", "840", "", "CT", "013", "", "41.86676", "-72.44953", "America/New_York"),("4842818", "Seymour", "", "US", "840", "", "CT", "009", "", "41.39676", "-73.07594", "America/New_York"),("4842898", "Shelton", "Шелтон", "US", "840", "", "CT", "001", "", "41.31649", "-73.09316", "America/New_York"),("4842958", "Sherwood Manor", "", "US", "840", "", "CT", "003", "", "42.01343", "-72.56425", "America/New_York"),("4843353", "South Windsor", "", "US", "840", "", "CT", "003", "", "41.82371", "-72.6212", "America/New_York"),("4843362", "Southbury", "", "US", "840", "", "CT", "009", "", "41.48148", "-73.21317", "America/New_York"),("4843411", "Southwood Acres", "", "US", "840", "", "CT", "003", "", "41.9626", "-72.57148", "America/New_York"),("4843553", "Stafford", "", "US", "840", "", "CT", "013", "", "41.98482", "-72.28897", "America/New_York"),("4843564", "Stamford", "Стэмфорд", "US", "840", "", "CT", "001", "", "41.05343", "-73.53873", "America/New_York"),("4843786", "Storrs", "Сторрс", "US", "840", "", "CT", "013", "", "41.80843", "-72.24952", "America/New_York"),("4843811", "Stratford", "Стратфорд", "US", "840", "", "CT", "001", "", "41.18454", "-73.13317", "America/New_York"),("4844084", "Terryville", "", "US", "840", "", "CT", "005", "", "41.67815", "-73.01094", "America/New_York"),("4844184", "Thompson", "", "US", "840", "", "CT", "015", "", "41.95871", "-71.86257", "America/New_York"),("4844200", "Thompsonville", "", "US", "840", "", "CT", "003", "", "41.99704", "-72.59898", "America/New_York"),("4844273", "Tolland", "", "US", "840", "", "CT", "013", "", "41.87149", "-72.36869", "America/New_York"),("4844309", "Torrington", "", "US", "840", "", "CT", "005", "", "41.80065", "-73.12122", "America/New_York"),("4844459", "Trumbull", "Трамбал", "US", "840", "", "CT", "001", "", "41.24287", "-73.20067", "America/New_York"),("4845056", "Wallingford", "", "US", "840", "", "CT", "009", "", "41.45704", "-72.82316", "America/New_York"),("4845193", "Waterbury", "Уотербери", "US", "840", "", "CT", "009", "", "41.55815", "-73.0515", "America/New_York"),("4845411", "West Hartford", "Западный Хартфорд", "US", "840", "", "CT", "003", "", "41.76204", "-72.74204", "America/New_York"),("4845419", "West Haven", "Уэст-Хейвен", "US", "840", "", "CT", "009", "", "41.27065", "-72.94705", "America/New_York"),("4845519", "West Torrington", "", "US", "840", "", "CT", "005", "", "41.81843", "-73.14372", "America/New_York"),("4845585", "Westport", "", "US", "840", "", "CT", "001", "", "41.14149", "-73.3579", "America/New_York"),("4845612", "Wethersfield", "", "US", "840", "", "CT", "003", "", "41.71427", "-72.65259", "America/New_York"),("4845823", "Willimantic", "", "US", "840", "", "CT", "015", "", "41.71065", "-72.20813", "America/New_York"),("4845871", "Wilton", "", "US", "840", "", "CT", "001", "", "41.19537", "-73.4379", "America/New_York"),("4845889", "Winchester Center", "", "US", "840", "", "CT", "005", "", "41.9001", "-73.13483", "America/New_York"),("4845898", "Windham", "", "US", "840", "", "CT", "015", "", "41.69982", "-72.15702", "America/New_York"),("4845920", "Windsor", "", "US", "840", "", "CT", "003", "", "41.8526", "-72.6437", "America/New_York"),("4845926", "Windsor Locks", "", "US", "840", "", "CT", "003", "", "41.92926", "-72.62731", "America/New_York"),("4845953", "Winsted", "", "US", "840", "", "CT", "005", "", "41.92121", "-73.06011", "America/New_York"),("4845984", "Wolcott", "", "US", "840", "", "CT", "009", "", "41.60232", "-72.98677", "America/New_York"),("4846022", "Woodbridge", "", "US", "840", "", "CT", "009", "", "41.3526", "-73.00844", "America/New_York"),("4846028", "Woodbury", "", "US", "840", "", "CT", "005", "", "41.54454", "-73.209", "America/New_York"),("4846602", "Algona", "", "US", "840", "", "IA", "109", "", "43.06997", "-94.23302", "America/Chicago"),("4846757", "Altoona", "", "US", "840", "", "IA", "153", "", "41.64416", "-93.46466", "America/Chicago"),("4846834", "Ames", "Эймса", "US", "840", "", "IA", "169", "", "42.03471", "-93.61994", "America/Chicago"),("4846880", "Anamosa", "", "US", "840", "", "IA", "105", "", "42.10834", "-91.28516", "America/Chicago"),("4846960", "Ankeny", "", "US", "840", "", "IA", "153", "", "41.72971", "-93.60577", "America/Chicago"),("4847226", "Asbury", "", "US", "840", "", "IA", "061", "", "42.51445", "-90.75152", "America/Chicago"),("4847385", "Atlantic", "", "US", "840", "", "IA", "029", "", "41.4036", "-95.01388", "America/Chicago"),("4848489", "Bettendorf", "", "US", "840", "", "IA", "163", "", "41.52448", "-90.51569", "America/Chicago"),("4849051", "Boone", "", "US", "840", "", "IA", "015", "", "42.0597", "-93.88023", "America/Chicago"),("4849826", "Burlington", "Берлингтон", "US", "840", "", "IA", "057", "", "40.80754", "-91.11292", "America/Chicago"),("4850478", "Carroll", "", "US", "840", "", "IA", "027", "", "42.06582", "-94.86693", "America/Chicago"),("4850699", "Cedar Falls", "Сидар-Фолс", "US", "840", "", "IA", "013", "", "42.52776", "-92.44547", "America/Chicago"),("4850751", "Cedar Rapids", "Сидар-Рапидс", "US", "840", "", "IA", "113", "", "42.00833", "-91.64407", "America/Chicago"),("4850961", "Centerville", "", "US", "840", "", "IA", "007", "", "40.73418", "-92.87409", "America/Chicago"),("4850962", "Centerville", "", "US", "840", "", "IA", "015", "", "42.09276", "-93.93551", "America/Chicago"),("4851163", "Charles City", "", "US", "840", "", "IA", "067", "", "43.06636", "-92.67241", "America/Chicago"),("4851247", "Cherokee", "", "US", "840", "", "IA", "035", "", "42.74943", "-95.55167", "America/Chicago"),("4851762", "Clarinda", "", "US", "840", "", "IA", "145", "", "40.73981", "-95.038", "America/Chicago"),("4851935", "Clear Lake", "", "US", "840", "", "IA", "033", "", "43.13802", "-93.37937", "America/Chicago"),("4852022", "Clinton", "Клинтон", "US", "840", "", "IA", "045", "", "41.84447", "-90.18874", "America/Chicago"),("4852065", "Clive", "", "US", "840", "", "IA", "153", "", "41.60304", "-93.72411", "America/Chicago"),("4852066", "Clive", "", "US", "840", "", "IA", "153", "", "41.60832", "-93.73967", "America/Chicago"),("4852640", "Coralville", "", "US", "840", "", "IA", "103", "", "41.6764", "-91.58045", "America/Chicago"),("4852832", "Council Bluffs", "Каунсил-Блафс", "US", "840", "", "IA", "155", "", "41.26194", "-95.86083", "America/Chicago"),("4853078", "Creston", "", "US", "840", "", "IA", "175", "", "41.0586", "-94.36135", "America/Chicago"),("4853423", "Davenport", "Дэвенпорт", "US", "840", "", "IA", "163", "", "41.52364", "-90.57764", "America/Chicago"),("4853551", "De Witt", "", "US", "840", "", "IA", "045", "", "41.82336", "-90.53819", "America/Chicago"),("4853608", "Decorah", "", "US", "840", "", "IA", "191", "", "43.30331", "-91.78571", "America/Chicago"),("4853757", "Denison", "", "US", "840", "", "IA", "047", "", "42.01777", "-95.35528", "America/Chicago"),("4853828", "Des Moines", "Де-Мойн", "US", "840", "", "IA", "153", "", "41.60054", "-93.60911", "America/Chicago"),("4854529", "Dubuque", "Дубьюк", "US", "840", "", "IA", "061", "", "42.50056", "-90.66457", "America/Chicago"),("4855248", "Eldridge", "", "US", "840", "", "IA", "163", "", "41.65809", "-90.58458", "America/Chicago"),("4855709", "Estherville", "", "US", "840", "", "IA", "063", "", "43.40163", "-94.83276", "America/Chicago"),("4855967", "Fairfield", "", "US", "840", "", "IA", "101", "", "41.00863", "-91.96267", "America/Chicago"),("4857486", "Fort Dodge", "", "US", "840", "", "IA", "187", "", "42.49747", "-94.16802", "America/Chicago"),("4857507", "Fort Madison", "", "US", "840", "", "IA", "111", "", "40.62976", "-91.31515", "America/Chicago"),("4858479", "Glenwood", "", "US", "840", "", "IA", "129", "", "41.04694", "-95.74251", "America/Chicago"),("4859329", "Grimes", "", "US", "840", "", "IA", "153", "", "41.68832", "-93.79106", "America/Chicago"),("4859343", "Grinnell", "", "US", "840", "", "IA", "157", "", "41.74305", "-92.72241", "America/Chicago"),("4859802", "Harlan", "", "US", "840", "", "IA", "165", "", "41.65304", "-95.32555", "America/Chicago"),("4860452", "Hiawatha", "", "US", "840", "", "IA", "113", "", "42.03583", "-91.68212", "America/Chicago"),("4861620", "Independence", "", "US", "840", "", "IA", "019", "", "42.4686", "-91.88934", "America/Chicago"),("4861719", "Indianola", "", "US", "840", "", "IA", "181", "", "41.35805", "-93.55744", "America/Chicago"),("4862034", "Iowa City", "Айова-Сити", "US", "840", "", "IA", "103", "", "41.66113", "-91.53017", "America/Chicago"),("4862069", "Iowa Falls", "", "US", "840", "", "IA", "083", "", "42.52248", "-93.25131", "America/Chicago"),("4862760", "Johnston", "", "US", "840", "", "IA", "153", "", "41.67304", "-93.69772", "America/Chicago"),("4863349", "Keokuk", "", "US", "840", "", "IA", "111", "", "40.39727", "-91.38487", "America/Chicago"),("4863705", "Knoxville", "", "US", "840", "", "IA", "125", "", "41.32083", "-93.10937", "America/Chicago"),("4864337", "Le Mars", "", "US", "840", "", "IA", "149", "", "42.79416", "-96.16558", "America/Chicago"),("4865996", "Manchester", "", "US", "840", "", "IA", "055", "", "42.48415", "-91.45543", "America/Chicago"),("4866164", "Maquoketa", "", "US", "840", "", "IA", "097", "", "42.06891", "-90.66569", "America/Chicago"),("4866263", "Marion", "Мэрион", "US", "840", "", "IA", "113", "", "42.03417", "-91.59768", "America/Chicago"),("4866371", "Marshalltown", "Маршалтаун", "US", "840", "", "IA", "127", "", "42.04943", "-92.90798", "America/Chicago"),("4866445", "Mason City", "Мейсон-Сити", "US", "840", "", "IA", "033", "", "43.15357", "-93.20104", "America/Chicago"),("4868205", "Mount Pleasant", "", "US", "840", "", "IA", "087", "", "40.96364", "-91.55794", "America/Chicago"),("4868404", "Muscatine", "", "US", "840", "", "IA", "139", "", "41.42447", "-91.04321", "America/Chicago"),("4868620", "Nevada", "", "US", "840", "", "IA", "169", "", "42.02277", "-93.45243", "America/Chicago"),("4868907", "Newton", "Ньютон", "US", "840", "", "IA", "099", "", "41.69971", "-93.04798", "America/Chicago"),("4869195", "North Liberty", "", "US", "840", "", "IA", "103", "", "41.74918", "-91.59795", "America/Chicago"),("4869386", "Norwalk", "", "US", "840", "", "IA", "181", "", "41.47555", "-93.67883", "America/Chicago"),("4869760", "Oelwein", "", "US", "840", "", "IA", "065", "", "42.67332", "-91.9135", "America/Chicago"),("4870083", "Orange City", "", "US", "840", "", "IA", "167", "", "43.00721", "-96.05835", "America/Chicago"),("4870239", "Oskaloosa", "", "US", "840", "", "IA", "123", "", "41.29639", "-92.64436", "America/Chicago"),("4870380", "Ottumwa", "Оттамуа", "US", "840", "", "IA", "179", "", "41.02001", "-92.4113", "America/Chicago"),("4870915", "Pella", "", "US", "840", "", "IA", "125", "", "41.40805", "-92.91631", "America/Chicago"),("4871019", "Perry", "", "US", "840", "", "IA", "049", "", "41.8386", "-94.10718", "America/Chicago"),("4871472", "Pleasant Hill", "", "US", "840", "", "IA", "153", "", "41.58388", "-93.51994", "America/Chicago"),("4872593", "Red Oak", "", "US", "840", "", "IA", "137", "", "41.00972", "-95.22555", "America/Chicago"),("4876141", "Sheldon", "", "US", "840", "", "IA", "141", "", "43.18109", "-95.85613", "America/Chicago"),("4876190", "Shenandoah", "", "US", "840", "", "IA", "145", "", "40.76555", "-95.37221", "America/Chicago"),("4876510", "Sioux Center", "", "US", "840", "", "IA", "167", "", "43.07971", "-96.17558", "America/Chicago"),("4876523", "Sioux City", "Су-Сити", "US", "840", "", "IA", "193", "", "42.49999", "-96.40031", "America/Chicago"),("4877138", "Spencer", "", "US", "840", "", "IA", "041", "", "43.14136", "-95.14444", "America/Chicago"),("4877184", "Spirit Lake", "", "US", "840", "", "IA", "059", "", "43.42218", "-95.10222", "America/Chicago"),("4877655", "Storm Lake", "", "US", "840", "", "IA", "021", "", "42.64109", "-95.20972", "America/Chicago"),("4879890", "Urbandale", "", "US", "840", "", "IA", "153", "", "41.62666", "-93.71217", "America/Chicago"),("4880268", "Vinton", "", "US", "840", "", "IA", "011", "", "42.16861", "-92.02351", "America/Chicago"),("4880731", "Washington", "", "US", "840", "", "IA", "183", "", "41.29918", "-91.69294", "America/Chicago"),("4880889", "Waterloo", "", "US", "840", "", "IA", "013", "", "42.49276", "-92.34296", "America/Chicago"),("4880981", "Waukee", "", "US", "840", "", "IA", "049", "", "41.61166", "-93.88523", "America/Chicago"),("4881024", "Waverly", "", "US", "840", "", "IA", "017", "", "42.72581", "-92.47546", "America/Chicago"),("4881096", "Webster City", "", "US", "840", "", "IA", "079", "", "42.46942", "-93.81605", "America/Chicago"),("4881346", "West Des Moines", "", "US", "840", "", "IA", "153", "", "41.57721", "-93.71133", "America/Chicago"),("4882259", "Winterset", "", "US", "840", "", "IA", "121", "", "41.33082", "-94.01384", "America/Chicago"),("4882920", "Addison", "", "US", "840", "", "IL", "043", "", "41.9317", "-87.98896", "America/Chicago"),("4883078", "Algonquin", "", "US", "840", "", "IL", "111", "", "42.16558", "-88.29425", "America/Chicago"),("4883207", "Alsip", "", "US", "840", "", "IL", "031", "", "41.66892", "-87.73866", "America/Chicago"),("4883393", "Antioch", "", "US", "840", "", "IL", "097", "", "42.47724", "-88.09564", "America/Chicago"),("4883555", "Arlington Heights", "Арлингтон-Хайтс", "US", "840", "", "IL", "031", "", "42.08836", "-87.98063", "America/Chicago"),("4883817", "Aurora", "Аврора", "US", "840", "", "IL", "089", "", "41.76058", "-88.32007", "America/Chicago"),("4884116", "Barrington", "", "US", "840", "", "IL", "031", "", "42.15391", "-88.13619", "America/Chicago"),("4884141", "Bartlett", "Бартлетт", "US", "840", "", "IL", "031", "", "41.99503", "-88.18563", "America/Chicago"),("4884161", "Bartonville", "", "US", "840", "", "IL", "143", "", "40.65032", "-89.65205", "America/Chicago"),("4884192", "Batavia", "Батавия", "US", "840", "", "IL", "089", "", "41.85003", "-88.31257", "America/Chicago"),("4884249", "Beach Park", "", "US", "840", "", "IL", "097", "", "42.42224", "-87.8573", "America/Chicago"),("4884282", "Beardstown", "", "US", "840", "", "IL", "017", "", "40.01755", "-90.42429", "America/Chicago"),("4884434", "Bellwood", "", "US", "840", "", "IL", "031", "", "41.88142", "-87.88312", "America/Chicago"),("4884453", "Belvidere", "Бельведере", "US", "840", "", "IL", "007", "", "42.26391", "-88.84427", "America/Chicago"),("4884509", "Bensenville", "", "US", "840", "", "IL", "043", "", "41.95503", "-87.94007", "America/Chicago"),("4884562", "Berkeley", "", "US", "840", "", "IL", "031", "", "41.88892", "-87.9034", "America/Chicago"),("4884597", "Berwyn", "Беруин", "US", "840", "", "IL", "031", "", "41.85059", "-87.79367", "America/Chicago"),("4885156", "Bloomingdale", "", "US", "840", "", "IL", "043", "", "41.95753", "-88.0809", "America/Chicago"),("4885164", "Bloomington", "Блумингтон", "US", "840", "", "IL", "113", "", "40.4842", "-88.99369", "America/Chicago"),("4885186", "Blue Island", "", "US", "840", "", "IL", "031", "", "41.65726", "-87.68005", "America/Chicago"),("4885265", "Bolingbrook", "", "US", "840", "", "IL", "197", "", "41.69864", "-88.0684", "America/Chicago"),("4885336", "Boulder Hill", "", "US", "840", "", "IL", "093", "", "41.71253", "-88.33618", "America/Chicago"),("4885342", "Bourbonnais", "", "US", "840", "", "IL", "091", "", "41.15376", "-87.88754", "America/Chicago"),("4885418", "Bradley", "", "US", "840", "", "IL", "091", "", "41.14198", "-87.86115", "America/Chicago"),("4885444", "Braidwood", "", "US", "840", "", "IL", "197", "", "41.26503", "-88.21228", "America/Chicago"),("4885573", "Bridgeview", "", "US", "840", "", "IL", "031", "", "41.75003", "-87.80422", "America/Chicago"),("4885637", "Broadview", "", "US", "840", "", "IL", "031", "", "41.86392", "-87.85339", "America/Chicago"),("4885689", "Brookfield", "", "US", "840", "", "IL", "031", "", "41.82392", "-87.85173", "America/Chicago"),("4885955", "Buffalo Grove", "", "US", "840", "", "IL", "031", "", "42.15141", "-87.95979", "America/Chicago"),("4885983", "Burbank", "Бербанк", "US", "840", "", "IL", "031", "", "41.73392", "-87.7795", "America/Chicago"),("4886090", "Burr Ridge", "", "US", "840", "", "IL", "043", "", "41.74892", "-87.91839", "America/Chicago"),("4886255", "Calumet City", "", "US", "840", "", "IL", "031", "", "41.61559", "-87.52949", "America/Chicago"),("4886269", "Calumet Park", "", "US", "840", "", "IL", "031", "", "41.66281", "-87.6606", "America/Chicago"),("4886662", "Carol Stream", "", "US", "840", "", "IL", "043", "", "41.91253", "-88.13479", "America/Chicago"),("4886676", "Carpentersville", "", "US", "840", "", "IL", "089", "", "42.12114", "-88.25786", "America/Chicago"),("4886738", "Cary", "Кэри", "US", "840", "", "IL", "111", "", "42.21197", "-88.23814", "America/Chicago"),("4887158", "Champaign", "Шампейн", "US", "840", "", "IL", "019", "", "40.11642", "-88.24338", "America/Chicago"),("4887198", "Channahon", "", "US", "840", "", "IL", "197", "", "41.42948", "-88.22867", "America/Chicago"),("4887398", "Chicago", "Чикаго", "US", "840", "", "IL", "031", "", "41.85003", "-87.65005", "America/Chicago"),("4887442", "Chicago Heights", "", "US", "840", "", "IL", "031", "", "41.50615", "-87.6356", "America/Chicago"),("4887492", "Chicago Ridge", "", "US", "840", "", "IL", "031", "", "41.70142", "-87.77922", "America/Chicago"),("4887574", "Chillicothe", "", "US", "840", "", "IL", "143", "", "40.92226", "-89.4862", "America/Chicago"),("4888015", "Cicero", "Цицерон", "US", "840", "", "IL", "031", "", "41.84559", "-87.75394", "America/Chicago"),("4888080", "Clarendon Hills", "", "US", "840", "", "IL", "043", "", "41.79753", "-87.95478", "America/Chicago"),("4888217", "Clinton", "", "US", "840", "", "IL", "039", "", "40.15365", "-88.96453", "America/Chicago"),("4888270", "Coal City", "", "US", "840", "", "IL", "063", "", "41.28781", "-88.28562", "America/Chicago"),("4888432", "Colona", "", "US", "840", "", "IL", "073", "", "41.48392", "-90.35318", "America/Chicago"),("4888892", "Country Club Hills", "", "US", "840", "", "IL", "031", "", "41.56809", "-87.72033", "America/Chicago"),("4888906", "Countryside", "", "US", "840", "", "IL", "031", "", "41.78281", "-87.87811", "America/Chicago"),("4889107", "Crest Hill", "", "US", "840", "", "IL", "197", "", "41.55475", "-88.09867", "America/Chicago"),("4889113", "Crestwood", "", "US", "840", "", "IL", "031", "", "41.66114", "-87.75255", "America/Chicago"),("4889120", "Crete", "", "US", "840", "", "IL", "197", "", "41.44448", "-87.63143", "America/Chicago"),("4889130", "Creve Coeur", "", "US", "840", "", "IL", "179", "", "40.64726", "-89.59121", "America/Chicago"),("4889229", "Crystal Lake", "", "US", "840", "", "IL", "111", "", "42.24113", "-88.3162", "America/Chicago"),("4889426", "Danville", "Данвилл", "US", "840", "", "IL", "183", "", "40.12448", "-87.63002", "America/Chicago"),("4889447", "Darien", "", "US", "840", "", "IL", "043", "", "41.75198", "-87.97395", "America/Chicago"),("4889553", "DeKalb", "Де-Калб", "US", "840", "", "IL", "037", "", "41.92947", "-88.75036", "America/Chicago"),("4889668", "Deerfield", "", "US", "840", "", "IL", "097", "", "42.17114", "-87.84451", "America/Chicago"),("4889772", "Des Plaines", "Дес-Плейнс", "US", "840", "", "IL", "031", "", "42.03336", "-87.8834", "America/Chicago"),("4889959", "Dixon", "", "US", "840", "", "IL", "103", "", "41.83892", "-89.47955", "America/Chicago"),("4890009", "Dolton", "", "US", "840", "", "IL", "031", "", "41.63892", "-87.60727", "America/Chicago"),("4890119", "Downers Grove", "", "US", "840", "", "IL", "043", "", "41.80892", "-88.01117", "America/Chicago"),("4890536", "East Moline", "", "US", "840", "", "IL", "161", "", "41.50087", "-90.4443", "America/Chicago"),("4890549", "East Peoria", "", "US", "840", "", "IL", "179", "", "40.66615", "-89.5801", "America/Chicago"),("4890835", "Elburn", "", "US", "840", "", "IL", "089", "", "41.89225", "-88.4723", "America/Chicago"),("4890864", "Elgin", "Элджин", "US", "840", "", "IL", "089", "", "42.03725", "-88.28119", "America/Chicago"),("4890925", "Elk Grove Village", "", "US", "840", "", "IL", "031", "", "42.00392", "-87.97035", "America/Chicago"),("4891010", "Elmhurst", "", "US", "840", "", "IL", "043", "", "41.89947", "-87.94034", "America/Chicago"),("4891051", "Elmwood Park", "", "US", "840", "", "IL", "031", "", "41.92114", "-87.80923", "America/Chicago"),("4891310", "Eureka", "", "US", "840", "", "IL", "203", "", "40.72143", "-89.27286", "America/Chicago"),("4891382", "Evanston", "", "US", "840", "", "IL", "031", "", "42.04114", "-87.69006", "America/Chicago"),("4891431", "Evergreen Park", "", "US", "840", "", "IL", "031", "", "41.72059", "-87.70172", "America/Chicago"),("4891534", "Fairfield", "", "US", "840", "", "IL", "097", "", "42.21919", "-88.06147", "America/Chicago"),("4892684", "Flossmoor", "", "US", "840", "", "IL", "031", "", "41.54281", "-87.68477", "America/Chicago"),("4892775", "Forest Park", "", "US", "840", "", "IL", "031", "", "41.87948", "-87.81367", "America/Chicago"),("4892950", "Fox Lake", "", "US", "840", "", "IL", "097", "", "42.39669", "-88.1837", "America/Chicago"),("4893037", "Frankfort", "Франкфурт", "US", "840", "", "IL", "197", "", "41.49587", "-87.84866", "America/Chicago"),("4893043", "Frankfort Square", "", "US", "840", "", "IL", "197", "", "41.51892", "-87.8031", "America/Chicago"),("4893070", "Franklin Park", "", "US", "840", "", "IL", "031", "", "41.93531", "-87.86562", "America/Chicago"),("4893171", "Freeport", "Фрипорт", "US", "840", "", "IL", "177", "", "42.29669", "-89.62123", "America/Chicago"),("4893371", "Gages Lake", "", "US", "840", "", "IL", "097", "", "42.35169", "-87.98258", "America/Chicago"),("4893392", "Galesburg", "Гейлсберг", "US", "840", "", "IL", "095", "", "40.94782", "-90.37124", "America/Chicago"),("4893581", "Geneseo", "", "US", "840", "", "IL", "073", "", "41.44809", "-90.15428", "America/Chicago"),("4893591", "Geneva", "Женева", "US", "840", "", "IL", "089", "", "41.88753", "-88.30535", "America/Chicago"),("4893601", "Genoa", "", "US", "840", "", "IL", "037", "", "42.09725", "-88.69287", "America/Chicago"),("4893731", "Gilberts", "", "US", "840", "", "IL", "089", "", "42.10336", "-88.37286", "America/Chicago"),("4893811", "Glen Ellyn", "", "US", "840", "", "IL", "043", "", "41.87753", "-88.06701", "America/Chicago"),("4893886", "Glenview", "", "US", "840", "", "IL", "031", "", "42.06975", "-87.78784", "America/Chicago"),("4893896", "Glenwood", "", "US", "840", "", "IL", "031", "", "41.54253", "-87.60227", "America/Chicago"),("4894061", "Goodings Grove", "", "US", "840", "", "IL", "197", "", "41.6292", "-87.93089", "America/Chicago"),("4894078", "Glencoe", "", "US", "840", "", "IL", "031", "", "42.13503", "-87.75812", "America/Chicago"),("4894360", "Grandwood Park", "", "US", "840", "", "IL", "097", "", "42.39308", "-87.98674", "America/Chicago"),("4894465", "Grayslake", "", "US", "840", "", "IL", "097", "", "42.34447", "-88.04175", "America/Chicago"),("4894861", "Gurnee", "", "US", "840", "", "IL", "097", "", "42.3703", "-87.90202", "America/Chicago"),("4895016", "Hampshire", "", "US", "840", "", "IL", "089", "", "42.0978", "-88.53036", "America/Chicago"),("4895066", "Hanover Park", "", "US", "840", "", "IL", "043", "", "41.99947", "-88.14507", "America/Chicago"),("4895282", "Harvard", "", "US", "840", "", "IL", "111", "", "42.42224", "-88.61371", "America/Chicago"),("4895298", "Harvey", "Харви", "US", "840", "", "IL", "031", "", "41.61003", "-87.64671", "America/Chicago"),("4895308", "Harwood Heights", "", "US", "840", "", "IL", "031", "", "41.96725", "-87.80756", "America/Chicago"),("4895376", "Hawthorn Woods", "", "US", "840", "", "IL", "097", "", "42.21697", "-88.04952", "America/Chicago"),("4895416", "Hazel Crest", "", "US", "840", "", "IL", "031", "", "41.5717", "-87.69449", "America/Chicago"),("4895767", "Hickory Hills", "", "US", "840", "", "IL", "031", "", "41.72559", "-87.82506", "America/Chicago"),("4895876", "Highland Park", "Хайленд-Парк", "US", "840", "", "IL", "097", "", "42.18169", "-87.80034", "America/Chicago"),("4895918", "Highwood", "", "US", "840", "", "IL", "097", "", "42.19975", "-87.80923", "America/Chicago"),("4895971", "Hillside", "", "US", "840", "", "IL", "031", "", "41.87781", "-87.90284", "America/Chicago"),("4896012", "Hinsdale", "", "US", "840", "", "IL", "043", "", "41.80086", "-87.93701", "America/Chicago"),("4896075", "Hoffman Estates", "", "US", "840", "", "IL", "031", "", "42.04281", "-88.0798", "America/Chicago"),("4896336", "Homer Glen", "", "US", "840", "", "IL", "197", "", "41.60003", "-87.93811", "America/Chicago"),("4896353", "Homewood", "", "US", "840", "", "IL", "031", "", "41.55726", "-87.6656", "America/Chicago"),("4896390", "Hoopeston", "", "US", "840", "", "IL", "183", "", "40.46726", "-87.66836", "America/Chicago"),("4896691", "Huntley", "", "US", "840", "", "IL", "111", "", "42.16808", "-88.42814", "America/Chicago"),("4897482", "Inverness", "", "US", "840", "", "IL", "031", "", "42.11808", "-88.09619", "America/Chicago"),("4897579", "Island Lake", "", "US", "840", "", "IL", "097", "", "42.27613", "-88.19203", "America/Chicago"),("4897654", "Itasca", "", "US", "840", "", "IL", "043", "", "41.97503", "-88.00729", "America/Chicago"),("4897967", "Johnsburg", "", "US", "840", "", "IL", "111", "", "42.38002", "-88.24203", "America/Chicago"),("4898015", "Joliet", "", "US", "840", "", "IL", "197", "", "41.52519", "-88.0834", "America/Chicago"),("4898152", "Justice", "", "US", "840", "", "IL", "031", "", "41.74448", "-87.83783", "America/Chicago"),("4898182", "Kankakee", "Канкаки", "US", "840", "", "IL", "091", "", "41.12003", "-87.86115", "America/Chicago"),("4898433", "Kewanee", "", "US", "840", "", "IL", "073", "", "41.24559", "-89.92483", "America/Chicago"),("4898846", "La Grange", "", "US", "840", "", "IL", "031", "", "41.80503", "-87.86923", "America/Chicago"),("4898850", "La Grange Park", "", "US", "840", "", "IL", "031", "", "41.83475", "-87.86173", "America/Chicago"),("4898875", "La Salle", "", "US", "840", "", "IL", "099", "", "41.33337", "-89.09175", "America/Chicago"),("4898974", "Lake Bluff", "", "US", "840", "", "IL", "097", "", "42.27891", "-87.83424", "America/Chicago"),("4899012", "Lake Forest", "", "US", "840", "", "IL", "097", "", "42.25863", "-87.84063", "America/Chicago"),("4899154", "Lake Villa", "", "US", "840", "", "IL", "097", "", "42.41697", "-88.07397", "America/Chicago"),("4899170", "Lake Zurich", "", "US", "840", "", "IL", "097", "", "42.19697", "-88.09341", "America/Chicago"),("4899184", "Lake in the Hills", "", "US", "840", "", "IL", "111", "", "42.18169", "-88.33036", "America/Chicago"),("4899213", "Lakemoor", "", "US", "840", "", "IL", "111", "", "42.32863", "-88.19897", "America/Chicago"),("4899340", "Lansing", "Лансинг", "US", "840", "", "IL", "031", "", "41.56476", "-87.53893", "America/Chicago"),("4899581", "Lemont", "", "US", "840", "", "IL", "031", "", "41.67364", "-88.00173", "America/Chicago"),("4899739", "Libertyville", "", "US", "840", "", "IL", "097", "", "42.28308", "-87.95313", "America/Chicago"),("4899822", "Lincoln", "", "US", "840", "", "IL", "107", "", "40.14838", "-89.36482", "America/Chicago"),("4899983", "Lincolnshire", "", "US", "840", "", "IL", "097", "", "42.19002", "-87.9084", "America/Chicago"),("4899988", "Lincolnwood", "", "US", "840", "", "IL", "031", "", "42.00448", "-87.73006", "America/Chicago"),("4900013", "Lindenhurst", "", "US", "840", "", "IL", "097", "", "42.41058", "-88.02619", "America/Chicago"),("4900080", "Lisle", "Лилу", "US", "840", "", "IL", "043", "", "41.80114", "-88.07479", "America/Chicago"),("4900292", "Lockport", "", "US", "840", "", "IL", "197", "", "41.58948", "-88.05784", "America/Chicago"),("4900373", "Lombard", "Ломбард", "US", "840", "", "IL", "043", "", "41.88003", "-88.00784", "America/Chicago"),("4900416", "Long Grove", "", "US", "840", "", "IL", "097", "", "42.17836", "-87.99785", "America/Chicago"),("4900579", "Loves Park", "", "US", "840", "", "IL", "201", "", "42.32002", "-89.05816", "America/Chicago"),("4900739", "Lynwood", "", "US", "840", "", "IL", "031", "", "41.52642", "-87.53865", "America/Chicago"),("4900740", "Lynwood", "", "US", "840", "", "IL", "093", "", "41.68364", "-88.39368", "America/Chicago"),("4900749", "Lyons", "", "US", "840", "", "IL", "031", "", "41.81337", "-87.81811", "America/Chicago"),("4900801", "Machesney Park", "", "US", "840", "", "IL", "201", "", "42.34724", "-89.039", "America/Chicago"),("4900817", "Macomb", "", "US", "840", "", "IL", "109", "", "40.45921", "-90.6718", "America/Chicago"),("4900885", "Mahomet", "", "US", "840", "", "IL", "019", "", "40.19531", "-88.40422", "America/Chicago"),("4900961", "Manhattan", "", "US", "840", "", "IL", "197", "", "41.42253", "-87.98589", "America/Chicago"),("4901015", "Manteno", "", "US", "840", "", "IL", "091", "", "41.25059", "-87.83143", "America/Chicago"),("4901164", "Marengo", "", "US", "840", "", "IL", "111", "", "42.24863", "-88.60843", "America/Chicago"),("4901229", "Markham", "", "US", "840", "", "IL", "031", "", "41.59365", "-87.69477", "America/Chicago"),("4901445", "Matteson", "", "US", "840", "", "IL", "031", "", "41.50392", "-87.7131", "America/Chicago"),("4901514", "Maywood", "Мэйвуд", "US", "840", "", "IL", "031", "", "41.8792", "-87.84312", "America/Chicago"),("4901663", "McHenry", "", "US", "840", "", "IL", "111", "", "42.33335", "-88.26675", "America/Chicago"),("4901868", "Melrose Park", "", "US", "840", "", "IL", "031", "", "41.90059", "-87.85673", "America/Chicago"),("4901944", "Mendota", "", "US", "840", "", "IL", "099", "", "41.54725", "-89.11759", "America/Chicago"),("4902181", "Midlothian", "", "US", "840", "", "IL", "031", "", "41.62531", "-87.71755", "America/Chicago"),("4902218", "Milan", "", "US", "840", "", "IL", "161", "", "41.45309", "-90.57208", "America/Chicago"),("4902386", "Minooka", "", "US", "840", "", "IL", "063", "", "41.45531", "-88.26173", "America/Chicago"),("4902475", "Mokena", "", "US", "840", "", "IL", "197", "", "41.52614", "-87.88922", "America/Chicago"),("4902476", "Moline", "Молин", "US", "840", "", "IL", "161", "", "41.5067", "-90.51513", "America/Chicago"),("4902498", "Monee", "", "US", "840", "", "IL", "197", "", "41.42003", "-87.74171", "America/Chicago"),("4902512", "Monmouth", "", "US", "840", "", "IL", "187", "", "40.91143", "-90.64736", "America/Chicago"),("4902559", "Montgomery", "Монтгомери", "US", "840", "", "IL", "089", "", "41.73058", "-88.3459", "America/Chicago"),("4902567", "Monticello", "", "US", "840", "", "IL", "147", "", "40.02781", "-88.5734", "America/Chicago"),("4902706", "Morris", "", "US", "840", "", "IL", "063", "", "41.35725", "-88.42118", "America/Chicago"),("4902754", "Morton", "", "US", "840", "", "IL", "179", "", "40.61282", "-89.45926", "America/Chicago"),("4902763", "Morton Grove", "", "US", "840", "", "IL", "031", "", "42.04059", "-87.78256", "America/Chicago"),("4903024", "Mount Prospect", "", "US", "840", "", "IL", "031", "", "42.06642", "-87.93729", "America/Chicago"),("4903184", "Mundelein", "", "US", "840", "", "IL", "097", "", "42.26308", "-88.00397", "America/Chicago"),("4903279", "Naperville", "Нэпервилл", "US", "840", "", "IL", "043", "", "41.78586", "-88.14729", "America/Chicago"),("4903535", "New Lenox", "", "US", "840", "", "IL", "197", "", "41.51198", "-87.96561", "America/Chicago"),("4903730", "Niles", "", "US", "840", "", "IL", "031", "", "42.01892", "-87.80284", "America/Chicago"),("4903780", "Normal", "Нормальная", "US", "840", "", "IL", "113", "", "40.5142", "-88.99063", "America/Chicago"),("4903803", "Norridge", "", "US", "840", "", "IL", "031", "", "41.96336", "-87.82728", "America/Chicago"),("4903818", "North Aurora", "", "US", "840", "", "IL", "089", "", "41.80614", "-88.3273", "America/Chicago"),("4903862", "North Chicago", "", "US", "840", "", "IL", "097", "", "42.32558", "-87.84118", "America/Chicago"),("4903976", "North Peoria", "", "US", "840", "", "IL", "143", "", "40.71754", "-89.58426", "America/Chicago"),("4904002", "North Riverside", "", "US", "840", "", "IL", "031", "", "41.84281", "-87.82311", "America/Chicago"),("4904056", "Northbrook", "", "US", "840", "", "IL", "031", "", "42.12753", "-87.82895", "America/Chicago"),("4904094", "Northfield", "", "US", "840", "", "IL", "031", "", "42.09975", "-87.7809", "America/Chicago"),("4904102", "Northlake", "", "US", "840", "", "IL", "031", "", "41.91725", "-87.89562", "America/Chicago"),("4904277", "Oak Brook", "", "US", "840", "", "IL", "043", "", "41.83281", "-87.92895", "America/Chicago"),("4904286", "Oak Forest", "", "US", "840", "", "IL", "031", "", "41.60281", "-87.74394", "America/Chicago"),("4904365", "Oak Lawn", "", "US", "840", "", "IL", "031", "", "41.71087", "-87.75811", "America/Chicago"),("4904381", "Oak Park", "Оук-Парк", "US", "840", "", "IL", "031", "", "41.88503", "-87.7845", "America/Chicago"),("4904934", "Orland Hills", "", "US", "840", "", "IL", "031", "", "41.58531", "-87.84311", "America/Chicago"),("4904937", "Orland Park", "", "US", "840", "", "IL", "031", "", "41.63031", "-87.85394", "America/Chicago"),("4904996", "Oswego", "", "US", "840", "", "IL", "093", "", "41.68281", "-88.35146", "America/Chicago"),("4905006", "Ottawa", "Оттава", "US", "840", "", "IL", "099", "", "41.34559", "-88.84258", "America/Chicago"),("4905211", "Palatine", "Палатин", "US", "840", "", "IL", "031", "", "42.1103", "-88.03424", "America/Chicago"),("4905259", "Palos Heights", "", "US", "840", "", "IL", "031", "", "41.66809", "-87.79644", "America/Chicago"),("4905263", "Palos Hills", "", "US", "840", "", "IL", "031", "", "41.6967", "-87.817", "America/Chicago"),("4905334", "Park City", "", "US", "840", "", "IL", "097", "", "42.34836", "-87.88424", "America/Chicago"),("4905337", "Park Forest", "", "US", "840", "", "IL", "031", "", "41.49142", "-87.67449", "America/Chicago"),("4905367", "Park Ridge", "Парк-Ридж", "US", "840", "", "IL", "031", "", "42.01114", "-87.84062", "America/Chicago"),("4905599", "Pekin", "Пекин", "US", "840", "", "IL", "179", "", "40.56754", "-89.64066", "America/Chicago"),("4905687", "Peoria", "Пеория", "US", "840", "", "IL", "143", "", "40.69365", "-89.58899", "America/Chicago"),("4905704", "Peoria Heights", "", "US", "840", "", "IL", "143", "", "40.74726", "-89.57398", "America/Chicago"),("4905770", "Peru", "", "US", "840", "", "IL", "099", "", "41.32753", "-89.12897", "America/Chicago"),("4906035", "Pingree Grove", "", "US", "840", "", "IL", "089", "", "42.06864", "-88.41342", "America/Chicago"),("4906125", "Plainfield", "", "US", "840", "", "IL", "197", "", "41.62697", "-88.20395", "America/Chicago"),("4906143", "Plano", "", "US", "840", "", "IL", "093", "", "41.66281", "-88.53702", "America/Chicago"),("4906438", "Pontiac", "", "US", "840", "", "IL", "105", "", "40.88087", "-88.62978", "America/Chicago"),("4906482", "Poplar Grove", "", "US", "840", "", "IL", "007", "", "42.36835", "-88.82205", "America/Chicago"),("4906527", "Posen", "", "US", "840", "", "IL", "031", "", "41.6317", "-87.68144", "America/Chicago"),("4906818", "Princeton", "", "US", "840", "", "IL", "011", "", "41.36809", "-89.46481", "America/Chicago"),("4906882", "Prospect Heights", "", "US", "840", "", "IL", "031", "", "42.0953", "-87.93757", "America/Chicago"),("4907131", "Rantoul", "", "US", "840", "", "IL", "019", "", "40.30837", "-88.15588", "America/Chicago"),("4907514", "Richton Park", "", "US", "840", "", "IL", "031", "", "41.48448", "-87.70338", "America/Chicago"),("4907637", "River Forest", "", "US", "840", "", "IL", "031", "", "41.89781", "-87.81395", "America/Chicago"),("4907649", "River Grove", "", "US", "840", "", "IL", "031", "", "41.92586", "-87.83589", "America/Chicago"),("4907683", "Riverdale", "", "US", "840", "", "IL", "031", "", "41.63337", "-87.6331", "America/Chicago"),("4907706", "Riverside", "", "US", "840", "", "IL", "031", "", "41.83503", "-87.82284", "America/Chicago"),("4907786", "Robbins", "", "US", "840", "", "IL", "031", "", "41.64392", "-87.70366", "America/Chicago"),("4907863", "Rochelle", "", "US", "840", "", "IL", "141", "", "41.92392", "-89.06871", "America/Chicago"),("4907898", "Rock Falls", "", "US", "840", "", "IL", "195", "", "41.77975", "-89.689", "America/Chicago"),("4907907", "Rock Island", "Рок-Айленд", "US", "840", "", "IL", "161", "", "41.50948", "-90.57875", "America/Chicago"),("4907959", "Rockford", "Рокфорд", "US", "840", "", "IL", "201", "", "42.27113", "-89.094", "America/Chicago"),("4907985", "Rockton", "", "US", "840", "", "IL", "201", "", "42.45252", "-89.07233", "America/Chicago"),("4908052", "Rolling Meadows", "", "US", "840", "", "IL", "031", "", "42.08419", "-88.01313", "America/Chicago"),("4908068", "Romeoville", "", "US", "840", "", "IL", "197", "", "41.64753", "-88.08951", "America/Chicago"),("4908126", "Roscoe", "", "US", "840", "", "IL", "201", "", "42.41335", "-89.00927", "America/Chicago"),("4908173", "Roselle", "", "US", "840", "", "IL", "043", "", "41.98475", "-88.07979", "America/Chicago"),("4908236", "Round Lake", "", "US", "840", "", "IL", "097", "", "42.35336", "-88.09341", "America/Chicago"),("4908237", "Round Lake Beach", "", "US", "840", "", "IL", "097", "", "42.37169", "-88.09008", "America/Chicago"),("4908243", "Round Lake Park", "", "US", "840", "", "IL", "097", "", "42.35697", "-88.07675", "America/Chicago"),("4908737", "Saint Charles", "Сент-Чарльз", "US", "840", "", "IL", "089", "", "41.91419", "-88.30869", "America/Chicago"),("4910543", "Sandwich", "", "US", "840", "", "IL", "037", "", "41.64586", "-88.62174", "America/Chicago"),("4910634", "Sauk Village", "", "US", "840", "", "IL", "031", "", "41.48837", "-87.56754", "America/Chicago"),("4910663", "Savoy", "", "US", "840", "", "IL", "019", "", "40.05475", "-88.25172", "America/Chicago"),("4910713", "Schaumburg", "Шаумбург", "US", "840", "", "IL", "031", "", "42.03336", "-88.08341", "America/Chicago"),("4910743", "Schiller Park", "", "US", "840", "", "IL", "031", "", "41.95586", "-87.8709", "America/Chicago"),("4911418", "Shorewood", "", "US", "840", "", "IL", "197", "", "41.52003", "-88.20173", "America/Chicago"),("4911516", "Silvis", "", "US", "840", "", "IL", "161", "", "41.51226", "-90.41513", "America/Chicago"),("4911600", "Skokie", "Скоки", "US", "840", "", "IL", "031", "", "42.03336", "-87.73339", "America/Chicago"),("4911830", "South Beloit", "", "US", "840", "", "IL", "201", "", "42.49307", "-89.03678", "America/Chicago"),("4911893", "South Elgin", "", "US", "840", "", "IL", "089", "", "41.99419", "-88.2923", "America/Chicago"),("4911934", "South Holland", "", "US", "840", "", "IL", "031", "", "41.60087", "-87.60699", "America/Chicago"),("4912248", "Spring Grove", "", "US", "840", "", "IL", "111", "", "42.44363", "-88.23648", "America/Chicago"),("4912303", "Spring Valley", "", "US", "840", "", "IL", "011", "", "41.32754", "-89.19981", "America/Chicago"),("4912474", "Steger", "", "US", "840", "", "IL", "031", "", "41.47003", "-87.63643", "America/Chicago"),("4912499", "Sterling", "Стерлинг", "US", "840", "", "IL", "195", "", "41.78864", "-89.69622", "America/Chicago"),("4912555", "Stickney", "", "US", "840", "", "IL", "031", "", "41.82142", "-87.78283", "America/Chicago"),("4912691", "Streamwood", "", "US", "840", "", "IL", "031", "", "42.02558", "-88.17841", "America/Chicago"),("4912698", "Streator", "", "US", "840", "", "IL", "099", "", "41.12087", "-88.83535", "America/Chicago"),("4912783", "Sugar Grove", "", "US", "840", "", "IL", "089", "", "41.76142", "-88.44369", "America/Chicago"),("4912845", "Summit", "", "US", "840", "", "IL", "031", "", "41.78809", "-87.81033", "America/Chicago"),("4913110", "Sycamore", "", "US", "840", "", "IL", "037", "", "41.98892", "-88.68675", "America/Chicago"),("4913723", "Tinley Park", "", "US", "840", "", "IL", "031", "", "41.57337", "-87.78449", "America/Chicago"),("4914514", "University Park", "", "US", "840", "", "IL", "031", "", "41.59226", "-87.68533", "America/Chicago"),("4914570", "Urbana", "Урбана", "US", "840", "", "IL", "019", "", "40.11059", "-88.20727", "America/Chicago"),("4914738", "Vernon Hills", "", "US", "840", "", "IL", "097", "", "42.21947", "-87.97952", "America/Chicago"),("4914830", "Villa Park", "", "US", "840", "", "IL", "043", "", "41.88975", "-87.98895", "America/Chicago"),("4915525", "Warrenville", "", "US", "840", "", "IL", "043", "", "41.81781", "-88.1734", "America/Chicago"),("4915539", "Wasco", "", "US", "840", "", "IL", "089", "", "41.93808", "-88.40452", "America/Chicago"),("4915545", "Washington", "Вашингтон", "US", "840", "", "IL", "179", "", "40.70365", "-89.40731", "America/Chicago"),("4915703", "Watseka", "", "US", "840", "", "IL", "075", "", "40.77615", "-87.73642", "America/Chicago"),("4915725", "Wauconda", "", "US", "840", "", "IL", "097", "", "42.25891", "-88.13925", "America/Chicago"),("4915734", "Waukegan", "Уокиган", "US", "840", "", "IL", "097", "", "42.36363", "-87.84479", "America/Chicago"),("4915963", "West Chicago", "", "US", "840", "", "IL", "043", "", "41.88475", "-88.20396", "America/Chicago"),("4915977", "West Dundee", "", "US", "840", "", "IL", "089", "", "42.09808", "-88.28286", "America/Chicago"),("4916140", "Westchester", "Вестчестер", "US", "840", "", "IL", "031", "", "41.85059", "-87.882", "America/Chicago"),("4916161", "Western Springs", "", "US", "840", "", "IL", "031", "", "41.80975", "-87.90062", "America/Chicago"),("4916207", "Westmont", "", "US", "840", "", "IL", "043", "", "41.79586", "-87.97562", "America/Chicago"),("4916288", "Wheaton", "Уитон", "US", "840", "", "IL", "043", "", "41.86614", "-88.10701", "America/Chicago"),("4916311", "Wheeling", "", "US", "840", "", "IL", "031", "", "42.13919", "-87.92896", "America/Chicago"),("4916698", "Willow Springs", "", "US", "840", "", "IL", "031", "", "41.74087", "-87.86033", "America/Chicago"),("4916709", "Willowbrook", "", "US", "840", "", "IL", "043", "", "41.76975", "-87.93589", "America/Chicago"),("4916732", "Wilmette", "", "US", "840", "", "IL", "031", "", "42.07225", "-87.72284", "America/Chicago"),("4916740", "Wilmington", "", "US", "840", "", "IL", "197", "", "41.30781", "-88.14672", "America/Chicago"),("4916826", "Winfield", "", "US", "840", "", "IL", "043", "", "41.8617", "-88.1609", "America/Chicago"),("4916891", "Winnetka", "", "US", "840", "", "IL", "031", "", "42.10808", "-87.7359", "America/Chicago"),("4916894", "Winthrop Harbor", "", "US", "840", "", "IL", "097", "", "42.47891", "-87.82368", "America/Chicago"),("4916975", "Wood Dale", "", "US", "840", "", "IL", "043", "", "41.96336", "-87.97896", "America/Chicago"),("4917089", "Woodridge", "", "US", "840", "", "IL", "043", "", "41.74697", "-88.05034", "America/Chicago"),("4917123", "Woodstock", "Вудсток", "US", "840", "", "IL", "111", "", "42.31474", "-88.4487", "America/Chicago"),("4917171", "Worth", "", "US", "840", "", "IL", "031", "", "41.68975", "-87.79728", "America/Chicago"),("4917298", "Yorkville", "", "US", "840", "", "IL", "093", "", "41.64114", "-88.44729", "America/Chicago"),("4917358", "Zion", "Сион", "US", "840", "", "IL", "097", "", "42.44613", "-87.83285", "America/Chicago"),("4917537", "Alexandria", "", "US", "840", "", "IN", "095", "", "40.26282", "-85.67581", "America/Indiana/Indianapolis"),("4917592", "Anderson", "Андерсон", "US", "840", "", "IN", "095", "", "40.10532", "-85.68025", "America/Indiana/Indianapolis"),("4917614", "Angola", "", "US", "840", "", "IN", "151", "", "41.63477", "-84.99941", "America/Indiana/Indianapolis"),("4917712", "Auburn", "", "US", "840", "", "IN", "033", "", "41.36699", "-85.05886", "America/Indiana/Indianapolis"),("4918234", "Bluffton", "", "US", "840", "", "IN", "179", "", "40.73866", "-85.17164", "America/Indiana/Indianapolis"),("4918805", "Cedar Lake", "", "US", "840", "", "IN", "089", "", "41.36476", "-87.44115", "America/Chicago"),("4918962", "Chesterton", "", "US", "840", "", "IN", "127", "", "41.61059", "-87.0642", "America/Chicago"),("4919203", "Columbia City", "", "US", "840", "", "IN", "183", "", "41.15727", "-85.48831", "America/Indiana/Indianapolis"),("4919381", "Crawfordsville", "", "US", "840", "", "IN", "107", "", "40.04115", "-86.87445", "America/Indiana/Indianapolis"),("4919451", "Crown Point", "", "US", "840", "", "IN", "089", "", "41.41698", "-87.36531", "America/Chicago"),("4919564", "Decatur", "", "US", "840", "", "IN", "001", "", "40.8306", "-84.92913", "America/Indiana/Indianapolis"),("4919820", "Dyer", "", "US", "840", "", "IN", "089", "", "41.4942", "-87.52171", "America/Chicago"),("4919826", "Dunlap", "", "US", "840", "", "IN", "039", "", "41.63783", "-85.92166", "America/Indiana/Indianapolis"),("4919857", "East Chicago", "", "US", "840", "", "IN", "089", "", "41.6392", "-87.45476", "America/Chicago"),("4919987", "Elkhart", "Элкхарт", "US", "840", "", "IN", "039", "", "41.68199", "-85.97667", "America/Indiana/Indianapolis"),("4920041", "Elwood", "", "US", "840", "", "IN", "095", "", "40.27698", "-85.84192", "America/Indiana/Indianapolis"),("4920423", "Fort Wayne", "Форт-Уэйн", "US", "840", "", "IN", "003", "", "41.1306", "-85.12886", "America/Indiana/Indianapolis"),("4920473", "Frankfort", "Франкфурт", "US", "840", "", "IN", "023", "", "40.27948", "-86.51084", "America/Indiana/Indianapolis"),("4920600", "Garrett", "", "US", "840", "", "IN", "033", "", "41.34949", "-85.13553", "America/Indiana/Indianapolis"),("4920607", "Gary", "Гэри", "US", "840", "", "IN", "089", "", "41.59337", "-87.34643", "America/Chicago"),("4920637", "Gas City", "", "US", "840", "", "IN", "053", "", "40.48726", "-85.61303", "America/Indiana/Indianapolis"),("4920808", "Goshen", "Гошен", "US", "840", "", "IN", "039", "", "41.58227", "-85.83444", "America/Indiana/Indianapolis"),("4920869", "Granger", "", "US", "840", "", "IN", "141", "", "41.75338", "-86.11084", "America/Indiana/Indianapolis"),("4920986", "Griffith", "", "US", "840", "", "IN", "089", "", "41.52837", "-87.42365", "America/Chicago"),("4921100", "Hammond", "Хаммонд", "US", "840", "", "IN", "089", "", "41.58337", "-87.50004", "America/Chicago"),("4921229", "Hartford City", "", "US", "840", "", "IN", "009", "", "40.45115", "-85.36997", "America/Indiana/Indianapolis"),("4921402", "Highland", "", "US", "840", "", "IN", "089", "", "41.55365", "-87.45198", "America/Chicago"),("4921476", "Hobart", "Хобарт", "US", "840", "", "IN", "089", "", "41.53226", "-87.25504", "America/Chicago"),("4921722", "Huntertown", "", "US", "840", "", "IN", "003", "", "41.22838", "-85.17247", "America/Indiana/Indianapolis"),("4921725", "Huntington", "Хантингтон", "US", "840", "", "IN", "069", "", "40.8831", "-85.49748", "America/Indiana/Indianapolis"),("4922252", "Kendallville", "", "US", "840", "", "IN", "113", "", "41.44144", "-85.26498", "America/Indiana/Indianapolis"),("4922388", "Kokomo", "", "US", "840", "", "IN", "067", "", "40.48643", "-86.1336", "America/Indiana/Indianapolis"),("4922459", "LaPorte", "", "US", "840", "", "IN", "091", "", "41.6106", "-86.72252", "America/Chicago"),("4922462", "Lafayette", "Лафайет", "US", "840", "", "IN", "157", "", "40.4167", "-86.87529", "America/Indiana/Indianapolis"),("4922541", "Lake Station", "", "US", "840", "", "IN", "089", "", "41.57504", "-87.23892", "America/Chicago"),("4922562", "Lakes of the Four Seasons", "", "US", "840", "", "IN", "127", "", "41.41032", "-87.21309", "America/Chicago"),("4922673", "Lebanon", "", "US", "840", "", "IN", "011", "", "40.04837", "-86.46917", "America/Indiana/Indianapolis"),("4922968", "Logansport", "", "US", "840", "", "IN", "017", "", "40.75448", "-86.35667", "America/Indiana/Indianapolis"),("4923041", "Lowell", "", "US", "840", "", "IN", "089", "", "41.29142", "-87.42059", "America/Chicago"),("4923210", "Marion", "Мэрион", "US", "840", "", "IN", "053", "", "40.55837", "-85.65914", "America/Indiana/Indianapolis"),("4923482", "Merrillville", "", "US", "840", "", "IN", "089", "", "41.48281", "-87.33281", "America/Chicago"),("4923531", "Michigan City", "Мичиган-Сити", "US", "840", "", "IN", "091", "", "41.70754", "-86.89503", "America/Chicago"),("4923670", "Mishawaka", "", "US", "840", "", "IN", "141", "", "41.66199", "-86.15862", "America/Indiana/Indianapolis"),("4923745", "Monticello", "", "US", "840", "", "IN", "181", "", "40.74532", "-86.76473", "America/Indiana/Indianapolis"),("4923914", "Mount Vernon", "", "US", "840", "", "IN", "169", "", "40.66949", "-85.82415", "America/Indiana/Indianapolis"),("4924006", "Muncie", "Манси", "US", "840", "", "IN", "035", "", "40.19338", "-85.38636", "America/Indiana/Indianapolis"),("4924014", "Munster", "Мюнстер", "US", "840", "", "IN", "089", "", "41.56448", "-87.51254", "America/Chicago"),("4924077", "Nappanee", "", "US", "840", "", "IN", "039", "", "41.44283", "-86.00139", "America/Indiana/Indianapolis"),("4924104", "New Haven", "", "US", "840", "", "IN", "003", "", "41.0706", "-85.01441", "America/Indiana/Indianapolis"),("4924198", "Noblesville", "", "US", "840", "", "IN", "057", "", "40.04559", "-86.0086", "America/Indiana/Indianapolis"),("4924246", "North Manchester", "", "US", "840", "", "IN", "169", "", "41.0006", "-85.7686", "America/Indiana/Indianapolis"),("4924733", "Peru", "", "US", "840", "", "IN", "103", "", "40.75365", "-86.06888", "America/Indiana/Indianapolis"),("4924970", "Plymouth", "", "US", "840", "", "IN", "099", "", "41.34366", "-86.30973", "America/Indiana/Indianapolis"),("4925006", "Portage", "", "US", "840", "", "IN", "127", "", "41.57587", "-87.17615", "America/Chicago"),("4925037", "Portland", "", "US", "840", "", "IN", "075", "", "40.43449", "-84.97775", "America/Indiana/Indianapolis"),("4925311", "Rensselaer", "", "US", "840", "", "IN", "073", "", "40.9367", "-87.15086", "America/Chicago"),("4925519", "Rochester", "", "US", "840", "", "IN", "049", "", "41.06476", "-86.21583", "America/Indiana/Indianapolis"),("4925793", "Saint John", "", "US", "840", "", "IN", "089", "", "41.45004", "-87.47004", "America/Chicago"),("4926170", "Schererville", "", "US", "840", "", "IN", "089", "", "41.47892", "-87.45476", "America/Chicago"),("4926563", "South Bend", "Саут-Бенд", "US", "840", "", "IN", "141", "", "41.68338", "-86.25001", "America/Indiana/Indianapolis"),("4926613", "South Haven", "", "US", "840", "", "IN", "127", "", "41.54198", "-87.13726", "America/Chicago"),("4927242", "Tipton", "", "US", "840", "", "IN", "159", "", "40.28226", "-86.0411", "America/Indiana/Indianapolis"),("4927537", "Valparaiso", "Вальпараисо", "US", "840", "", "IN", "127", "", "41.47309", "-87.06114", "America/Chicago"),("4927746", "Wabash", "", "US", "840", "", "IN", "169", "", "40.79782", "-85.82054", "America/Indiana/Indianapolis"),("4927854", "Warsaw", "", "US", "840", "", "IN", "085", "", "41.2381", "-85.85305", "America/Indiana/Indianapolis"),("4928096", "West Lafayette", "Уэст-Лафайетт", "US", "840", "", "IN", "157", "", "40.42587", "-86.90807", "America/Indiana/Indianapolis"),("4928118", "Westfield", "", "US", "840", "", "IN", "057", "", "40.04282", "-86.12749", "America/Indiana/Indianapolis"),("4928145", "Westville", "", "US", "840", "", "IN", "091", "", "41.54143", "-86.90058", "America/Chicago"),("4928354", "Winfield", "", "US", "840", "", "IN", "089", "", "41.40531", "-87.27531", "America/Chicago"),("4928492", "Yorktown", "", "US", "840", "", "IN", "035", "", "40.17365", "-85.49414", "America/Indiana/Indianapolis"),("4928662", "Abington", "Абингтон", "US", "840", "", "MA", "023", "", "42.10482", "-70.94532", "America/New_York"),("4928703", "Acton", "Эктон", "US", "840", "", "MA", "017", "", "42.48509", "-71.43284", "America/New_York"),("4928720", "Acushnet", "", "US", "840", "", "MA", "005", "", "41.68066", "-70.90782", "America/New_York"),("4928733", "Adams", "", "US", "840", "", "MA", "003", "", "42.62425", "-73.1176", "America/New_York"),("4928788", "Agawam", "", "US", "840", "", "MA", "013", "", "42.06954", "-72.61481", "America/New_York"),("4929004", "Amesbury", "", "US", "840", "", "MA", "009", "", "42.85842", "-70.93005", "America/New_York"),("4929022", "Amherst", "", "US", "840", "", "MA", "015", "", "42.36723", "-72.51852", "America/New_York"),("4929023", "Amherst Center", "", "US", "840", "", "MA", "015", "", "42.37537", "-72.51925", "America/New_York"),("4929055", "Andover", "", "US", "840", "", "MA", "009", "", "42.65843", "-71.137", "America/New_York"),("4929180", "Arlington", "Арлингтон", "US", "840", "", "MA", "017", "", "42.41537", "-71.15644", "America/New_York"),("4929256", "Ashburnham", "", "US", "840", "", "MA", "027", "", "42.6362", "-71.90785", "America/New_York"),("4929283", "Ashland", "", "US", "840", "", "MA", "017", "", "42.26121", "-71.4634", "America/New_York"),("4929376", "Athol", "", "US", "840", "", "MA", "027", "", "42.59592", "-72.22675", "America/New_York"),("4929399", "Attleboro", "", "US", "840", "", "MA", "005", "", "41.94454", "-71.28561", "America/New_York"),("4929417", "Auburn", "", "US", "840", "", "MA", "027", "", "42.19454", "-71.83563", "America/New_York"),("4929771", "Barnstable", "", "US", "840", "", "MA", "001", "", "41.70011", "-70.29947", "America/New_York"),("4930183", "Bedford", "", "US", "840", "", "MA", "017", "", "42.49065", "-71.27617", "America/New_York"),("4930282", "Belmont", "Белмонт", "US", "840", "", "MA", "017", "", "42.39593", "-71.17867", "America/New_York"),("4930385", "Berkley", "", "US", "840", "", "MA", "005", "", "41.84593", "-71.08282", "America/New_York"),("4930505", "Beverly", "", "US", "840", "", "MA", "009", "", "42.55843", "-70.88005", "America/New_York"),("4930511", "Beverly Cove", "", "US", "840", "", "MA", "009", "", "42.55343", "-70.85366", "America/New_York"),("4930577", "Billerica", "", "US", "840", "", "MA", "017", "", "42.55843", "-71.26895", "America/New_York"),("4930738", "Blackstone", "", "US", "840", "", "MA", "027", "", "42.01788", "-71.54117", "America/New_York"),("4930804", "Bliss Corner", "", "US", "840", "", "MA", "005", "", "41.61177", "-70.93837", "America/New_York"),("4930956", "Boston", "Бостон", "US", "840", "", "MA", "025", "", "42.35843", "-71.05977", "America/New_York"),("4931181", "Braintree", "", "US", "840", "", "MA", "021", "", "42.22232", "-70.99949", "America/New_York"),("4931303", "Bridgewater", "", "US", "840", "", "MA", "023", "", "41.99038", "-70.97504", "America/New_York"),("4931429", "Brockton", "Броктон", "US", "840", "", "MA", "023", "", "42.08343", "-71.01838", "America/New_York"),("4931482", "Brookline", "Бруклин", "US", "840", "", "MA", "021", "", "42.33176", "-71.12116", "America/New_York"),("4931737", "Burlington", "Берлингтон", "US", "840", "", "MA", "017", "", "42.50482", "-71.19561", "America/New_York"),("4931972", "Cambridge", "Кеймбридж", "US", "840", "", "MA", "017", "", "42.3751", "-71.10561", "America/New_York"),("4932214", "Canton", "", "US", "840", "", "MA", "021", "", "42.15843", "-71.14477", "America/New_York"),("4932388", "Carver", "", "US", "840", "", "MA", "023", "", "41.88344", "-70.76254", "America/New_York"),("4932587", "Centerville", "", "US", "840", "", "MA", "001", "", "41.64872", "-70.34808", "America/New_York");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("4932823", "Charlton", "", "US", "840", "", "MA", "027", "", "42.13565", "-71.97007", "America/New_York"),("4932869", "Chelmsford", "Челмсфорд", "US", "840", "", "MA", "017", "", "42.59981", "-71.36728", "America/New_York"),("4932879", "Chelsea", "", "US", "840", "", "MA", "025", "", "42.39176", "-71.03283", "America/New_York"),("4933002", "Chicopee", "Чикопи", "US", "840", "", "MA", "013", "", "42.1487", "-72.60787", "America/New_York"),("4933426", "Clinton", "", "US", "840", "", "MA", "027", "", "42.41676", "-71.68285", "America/New_York"),("4933493", "Cochituate", "", "US", "840", "", "MA", "017", "", "42.32093", "-71.36423", "America/New_York"),("4933533", "Cohasset", "", "US", "840", "", "MA", "021", "", "42.24177", "-70.80365", "America/New_York"),("4933743", "Concord", "Конкорд", "US", "840", "", "MA", "017", "", "42.46037", "-71.34895", "America/New_York"),("4934429", "Dalton", "", "US", "840", "", "MA", "003", "", "42.4737", "-73.16621", "America/New_York"),("4934500", "Danvers", "Денверс", "US", "840", "", "MA", "009", "", "42.57509", "-70.93005", "America/New_York"),("4934664", "Dedham", "", "US", "840", "", "MA", "021", "", "42.24177", "-71.16616", "America/New_York"),("4934827", "Dighton", "", "US", "840", "", "MA", "005", "", "41.81399", "-71.12032", "America/New_York"),("4934999", "Douglas", "", "US", "840", "", "MA", "027", "", "42.05426", "-71.73951", "America/New_York"),("4935038", "Dracut", "", "US", "840", "", "MA", "017", "", "42.67037", "-71.30201", "America/New_York"),("4935125", "Dudley", "", "US", "840", "", "MA", "027", "", "42.0451", "-71.93007", "America/New_York"),("4935330", "East Bridgewater", "", "US", "840", "", "MA", "023", "", "42.03343", "-70.95921", "America/New_York"),("4935434", "East Longmeadow", "", "US", "840", "", "MA", "013", "", "42.06454", "-72.51259", "America/New_York"),("4935578", "Eastham", "", "US", "840", "", "MA", "001", "", "41.83011", "-69.97391", "America/New_York"),("4935582", "Easthampton", "Истхэмптон", "US", "840", "", "MA", "015", "", "42.26676", "-72.66898", "America/New_York"),("4935623", "Easton", "Истон", "US", "840", "", "MA", "005", "", "42.02454", "-71.12866", "America/New_York"),("4936008", "Everett", "Эверетт", "US", "840", "", "MA", "017", "", "42.40843", "-71.05366", "America/New_York"),("4936087", "Fairhaven", "", "US", "840", "", "MA", "005", "", "41.6376", "-70.90365", "America/New_York"),("4936159", "Fall River", "Фолл-Ривер", "US", "840", "", "MA", "005", "", "41.70149", "-71.15505", "America/New_York"),("4936812", "Fitchburg", "", "US", "840", "", "MA", "027", "", "42.58342", "-71.8023", "America/New_York"),("4937222", "Foxborough", "", "US", "840", "", "MA", "021", "", "42.06538", "-71.24783", "America/New_York"),("4937230", "Framingham", "", "US", "840", "", "MA", "017", "", "42.27926", "-71.41617", "America/New_York"),("4937232", "Framingham Center", "", "US", "840", "", "MA", "017", "", "42.29732", "-71.43701", "America/New_York"),("4937276", "Franklin", "Франклин", "US", "840", "", "MA", "021", "", "42.08343", "-71.39673", "America/New_York"),("4937355", "Freetown", "", "US", "840", "", "MA", "005", "", "41.76677", "-71.03282", "America/New_York"),("4937557", "Gardner", "Гарднер", "US", "840", "", "MA", "027", "", "42.57509", "-71.99813", "America/New_York"),("4937829", "Gloucester", "Глостер", "US", "840", "", "MA", "009", "", "42.61593", "-70.66199", "America/New_York"),("4938048", "Grafton", "", "US", "840", "", "MA", "027", "", "42.20704", "-71.68562", "America/New_York"),("4938378", "Greenfield", "Гринфилд", "US", "840", "", "MA", "011", "", "42.58759", "-72.59953", "America/New_York"),("4938501", "Groveland", "", "US", "840", "", "MA", "009", "", "42.76037", "-71.03145", "America/New_York"),("4938652", "Halifax", "", "US", "840", "", "MA", "023", "", "41.99121", "-70.86199", "America/New_York"),("4938697", "Hamilton", "", "US", "840", "", "MA", "027", "", "42.2562", "-71.76757", "America/New_York"),("4938738", "Hampden", "", "US", "840", "", "MA", "013", "", "42.06398", "-72.41342", "America/New_York"),("4938836", "Hanover", "", "US", "840", "", "MA", "023", "", "42.11316", "-70.81199", "America/New_York"),("4938957", "Harvard", "", "US", "840", "", "MA", "027", "", "42.50009", "-71.58284", "America/New_York"),("4939004", "Harwich", "", "US", "840", "", "MA", "001", "", "41.68622", "-70.07585", "America/New_York"),("4939085", "Haverhill", "Хаверхилл", "US", "840", "", "MA", "009", "", "42.7762", "-71.07728", "America/New_York"),("4939191", "Head of Westport", "", "US", "840", "", "MA", "005", "", "41.62094", "-71.06199", "America/New_York"),("4939549", "Hingham", "", "US", "840", "", "MA", "023", "", "42.24177", "-70.88977", "America/New_York"),("4939637", "Holbrook", "", "US", "840", "", "MA", "021", "", "42.1551", "-71.00866", "America/New_York"),("4939647", "Holden", "", "US", "840", "", "MA", "027", "", "42.35176", "-71.86341", "America/New_York"),("4939693", "Holliston", "", "US", "840", "", "MA", "017", "", "42.2001", "-71.4245", "America/New_York"),("4939783", "Holyoke", "Холиок", "US", "840", "", "MA", "013", "", "42.20426", "-72.6162", "America/New_York"),("4940094", "Hudson", "", "US", "840", "", "MA", "017", "", "42.39176", "-71.56618", "America/New_York"),("4940134", "Hull", "", "US", "840", "", "MA", "023", "", "42.30204", "-70.90782", "America/New_York"),("4940190", "Hyannis", "", "US", "840", "", "MA", "001", "", "41.65289", "-70.2828", "America/New_York"),("4940764", "Jamaica Plain", "", "US", "840", "", "MA", "025", "", "42.30982", "-71.12033", "America/New_York"),("4941383", "Kingston", "", "US", "840", "", "MA", "023", "", "41.99455", "-70.72448", "America/New_York"),("4941635", "Lancaster", "", "US", "840", "", "MA", "027", "", "42.45565", "-71.67312", "America/New_York"),("4941720", "Lawrence", "Лоуренс", "US", "840", "", "MA", "009", "", "42.70704", "-71.16311", "America/New_York"),("4941835", "Leicester", "", "US", "840", "", "MA", "027", "", "42.24593", "-71.90868", "America/New_York"),("4941873", "Leominster", "Леоминстере", "US", "840", "", "MA", "027", "", "42.52509", "-71.75979", "America/New_York"),("4941935", "Lexington", "Лексингтон", "US", "840", "", "MA", "017", "", "42.44732", "-71.2245", "America/New_York"),("4942021", "Lincoln", "", "US", "840", "", "MA", "017", "", "42.42593", "-71.30395", "America/New_York"),("4942508", "Longmeadow", "", "US", "840", "", "MA", "013", "", "42.0501", "-72.58287", "America/New_York"),("4942618", "Lowell", "Лоуэлл", "US", "840", "", "MA", "017", "", "42.63342", "-71.31617", "America/New_York"),("4942744", "Ludlow", "", "US", "840", "", "MA", "013", "", "42.16009", "-72.47592", "America/New_York"),("4942807", "Lynn", "Линн", "US", "840", "", "MA", "009", "", "42.46676", "-70.94949", "America/New_York"),("4942821", "Lynnfield", "", "US", "840", "", "MA", "009", "", "42.53898", "-71.04811", "America/New_York"),("4942939", "Malden", "", "US", "840", "", "MA", "017", "", "42.4251", "-71.06616", "America/New_York"),("4942975", "Manchester-by-the-Sea", "", "US", "840", "", "MA", "009", "", "42.57787", "-70.76894", "America/New_York"),("4943021", "Mansfield", "Мэнсфилд", "US", "840", "", "MA", "005", "", "42.03343", "-71.21894", "America/New_York"),("4943097", "Marblehead", "", "US", "840", "", "MA", "009", "", "42.5001", "-70.85783", "America/New_York"),("4943144", "Marion", "", "US", "840", "", "MA", "023", "", "41.7001", "-70.76281", "America/New_York"),("4943170", "Marlborough", "Марлборо", "US", "840", "", "MA", "017", "", "42.34593", "-71.55229", "America/New_York"),("4943227", "Marstons Mills", "", "US", "840", "", "MA", "001", "", "41.65622", "-70.41614", "America/New_York"),("4943297", "Mashpee", "", "US", "840", "", "MA", "001", "", "41.64844", "-70.48114", "America/New_York"),("4943432", "Mattapoisett", "", "US", "840", "", "MA", "023", "", "41.65844", "-70.81615", "America/New_York"),("4943490", "Maynard", "", "US", "840", "", "MA", "017", "", "42.43343", "-71.44951", "America/New_York"),("4943616", "Medfield", "", "US", "840", "", "MA", "021", "", "42.1876", "-71.30645", "America/New_York"),("4943629", "Medford", "Медфорд", "US", "840", "", "MA", "017", "", "42.41843", "-71.10616", "America/New_York"),("4943648", "Medway", "", "US", "840", "", "MA", "021", "", "42.14176", "-71.39673", "America/New_York"),("4943677", "Melrose", "Мелроуз", "US", "840", "", "MA", "017", "", "42.45843", "-71.06616", "America/New_York"),("4943746", "Mendon", "", "US", "840", "", "MA", "027", "", "42.10565", "-71.55229", "America/New_York"),("4943784", "Merrimac", "", "US", "840", "", "MA", "009", "", "42.83065", "-71.00228", "America/New_York"),("4943828", "Methuen", "", "US", "840", "", "MA", "009", "", "42.7262", "-71.19089", "America/New_York"),("4943926", "Middleton", "", "US", "840", "", "MA", "009", "", "42.59509", "-71.01616", "America/New_York"),("4943958", "Milford", "Милфорд", "US", "840", "", "MA", "027", "", "42.13982", "-71.51617", "America/New_York"),("4944122", "Millbury", "", "US", "840", "", "MA", "027", "", "42.19398", "-71.76007", "America/New_York"),("4944173", "Millis", "", "US", "840", "", "MA", "021", "", "42.1676", "-71.35784", "America/New_York"),("4944193", "Milton", "Мильтон", "US", "840", "", "MA", "021", "", "42.24954", "-71.06616", "America/New_York"),("4944350", "Monson", "", "US", "840", "", "MA", "013", "", "42.10426", "-72.31897", "America/New_York"),("4944413", "Montague", "", "US", "840", "", "MA", "011", "", "42.53564", "-72.53509", "America/New_York"),("4944903", "Nantucket", "", "US", "840", "", "MA", "019", "", "41.28346", "-70.09946", "America/New_York"),("4944994", "Natick", "", "US", "840", "", "MA", "017", "", "42.28343", "-71.3495", "America/New_York"),("4945055", "Needham", "", "US", "840", "", "MA", "021", "", "42.28343", "-71.23283", "America/New_York"),("4945121", "New Bedford", "Нью-Бедфорд", "US", "840", "", "MA", "005", "", "41.63622", "-70.93421", "America/New_York"),("4945256", "Newburyport", "", "US", "840", "", "MA", "009", "", "42.81259", "-70.87728", "America/New_York"),("4945283", "Newton", "Ньютон", "US", "840", "", "MA", "017", "", "42.33704", "-71.20922", "America/New_York"),("4945453", "Norfolk", "", "US", "840", "", "MA", "021", "", "42.11954", "-71.32506", "America/New_York"),("4945486", "North Adams", "", "US", "840", "", "MA", "003", "", "42.70092", "-73.10871", "America/New_York"),("4945497", "North Amherst", "", "US", "840", "", "MA", "015", "", "42.41037", "-72.53092", "America/New_York"),("4945588", "North Chicopee", "", "US", "840", "", "MA", "013", "", "42.18343", "-72.59953", "America/New_York"),("4945734", "North Reading", "", "US", "840", "", "MA", "017", "", "42.57509", "-71.07867", "America/New_York"),("4945764", "North Scituate", "", "US", "840", "", "MA", "023", "", "42.21899", "-70.7856", "America/New_York"),("4945819", "Northampton", "Нортхемптон", "US", "840", "", "MA", "015", "", "42.32509", "-72.6412", "America/New_York"),("4945840", "Northborough", "", "US", "840", "", "MA", "027", "", "42.31954", "-71.64118", "America/New_York"),("4945848", "Northbridge", "", "US", "840", "", "MA", "027", "", "42.15148", "-71.64951", "America/New_York"),("4945911", "Norton", "", "US", "840", "", "MA", "005", "", "41.96677", "-71.18699", "America/New_York"),("4945936", "Norwell", "", "US", "840", "", "MA", "023", "", "42.16177", "-70.79393", "America/New_York"),("4945952", "Norwood", "", "US", "840", "", "MA", "021", "", "42.19454", "-71.1995", "America/New_York"),("4946546", "Oxford", "", "US", "840", "", "MA", "027", "", "42.11676", "-71.86479", "America/New_York"),("4946620", "Palmer", "", "US", "840", "", "MA", "013", "", "42.15843", "-72.32869", "America/New_York"),("4946863", "Peabody", "Пибоди", "US", "840", "", "MA", "009", "", "42.52787", "-70.92866", "America/New_York"),("4947397", "Pinehurst", "", "US", "840", "", "MA", "017", "", "42.52926", "-71.22811", "America/New_York"),("4947459", "Pittsfield", "", "US", "840", "", "MA", "003", "", "42.45008", "-73.24538", "America/New_York"),("4947490", "Plainville", "", "US", "840", "", "MA", "021", "", "42.00427", "-71.33283", "America/New_York"),("4947597", "Plymouth", "", "US", "840", "", "MA", "023", "", "41.95844", "-70.66726", "America/New_York"),("4948247", "Quincy", "Куинси", "US", "840", "", "MA", "021", "", "42.25288", "-71.00227", "America/New_York"),("4948403", "Randolph", "Рандольф", "US", "840", "", "MA", "021", "", "42.1626", "-71.04116", "America/New_York"),("4948449", "Raynham", "", "US", "840", "", "MA", "005", "", "41.94871", "-71.0731", "America/New_York"),("4948462", "Reading", "Рединг", "US", "840", "", "MA", "017", "", "42.52565", "-71.09533", "America/New_York"),("4948545", "Rehoboth", "", "US", "840", "", "MA", "005", "", "41.84038", "-71.24949", "America/New_York"),("4948924", "Rockland", "", "US", "840", "", "MA", "023", "", "42.13066", "-70.91616", "America/New_York"),("4950065", "Salem", "Салем", "US", "840", "", "MA", "009", "", "42.51954", "-70.89672", "America/New_York"),("4950267", "Saugus", "", "US", "840", "", "MA", "009", "", "42.46482", "-71.01005", "America/New_York"),("4950395", "Scituate", "", "US", "840", "", "MA", "023", "", "42.19593", "-70.72587", "America/New_York"),("4950541", "Seekonk", "", "US", "840", "", "MA", "005", "", "41.80843", "-71.337", "America/New_York"),("4950654", "Sharon", "", "US", "840", "", "MA", "021", "", "42.12371", "-71.17866", "America/New_York"),("4950898", "Shrewsbury", "Шрусбери", "US", "840", "", "MA", "027", "", "42.29593", "-71.71285", "America/New_York"),("4951248", "Somerset", "Сомерсет", "US", "840", "", "MA", "005", "", "41.76955", "-71.12866", "America/New_York"),("4951257", "Somerville", "Сомервилл", "US", "840", "", "MA", "017", "", "42.3876", "-71.0995", "America/New_York"),("4951305", "South Boston", "", "US", "840", "", "MA", "025", "", "42.33343", "-71.04949", "America/New_York"),("4951397", "South Hadley", "", "US", "840", "", "MA", "015", "", "42.25842", "-72.57453", "America/New_York"),("4951473", "South Peabody", "", "US", "840", "", "MA", "009", "", "42.50982", "-70.94949", "America/New_York"),("4951579", "South Yarmouth", "", "US", "840", "", "MA", "001", "", "41.66678", "-70.18474", "America/New_York"),("4951582", "Southampton", "", "US", "840", "", "MA", "015", "", "42.22926", "-72.73009", "America/New_York"),("4951591", "Southborough", "", "US", "840", "", "MA", "027", "", "42.30565", "-71.52451", "America/New_York"),("4951594", "Southbridge", "", "US", "840", "", "MA", "027", "", "42.0751", "-72.03341", "America/New_York"),("4951640", "Southwick", "", "US", "840", "", "MA", "013", "", "42.05482", "-72.77037", "America/New_York"),("4951699", "Spencer", "", "US", "840", "", "MA", "027", "", "42.24398", "-71.9923", "America/New_York"),("4951788", "Springfield", "Спрингфилд", "US", "840", "", "MA", "013", "", "42.10148", "-72.58981", "America/New_York"),("4952005", "Sterling", "", "US", "840", "", "MA", "027", "", "42.43759", "-71.76063", "America/New_York"),("4952121", "Stoneham", "", "US", "840", "", "MA", "017", "", "42.4801", "-71.0995", "America/New_York"),("4952206", "Stoughton", "", "US", "840", "", "MA", "021", "", "42.1251", "-71.10227", "America/New_York"),("4952217", "Stow", "", "US", "840", "", "MA", "017", "", "42.43704", "-71.50562", "America/New_York"),("4952320", "Sudbury", "", "US", "840", "", "MA", "017", "", "42.38343", "-71.41617", "America/New_York"),("4952444", "Sutton", "", "US", "840", "", "MA", "027", "", "42.1501", "-71.76285", "America/New_York"),("4952468", "Swampscott", "", "US", "840", "", "MA", "009", "", "42.47093", "-70.91755", "America/New_York"),("4952487", "Swansea", "", "US", "840", "", "MA", "005", "", "41.74816", "-71.18977", "America/New_York"),("4952629", "Taunton", "Тонтон", "US", "840", "", "MA", "005", "", "41.9001", "-71.08977", "America/New_York"),("4952731", "Templeton", "", "US", "840", "", "MA", "027", "", "42.55564", "-72.06758", "America/New_York"),("4952762", "Tewksbury", "", "US", "840", "", "MA", "017", "", "42.61065", "-71.23422", "America/New_York"),("4953542", "Tyngsboro", "", "US", "840", "", "MA", "017", "", "42.67676", "-71.42451", "America/New_York"),("4953804", "Uxbridge", "", "US", "840", "", "MA", "027", "", "42.07732", "-71.62951", "America/New_York"),("4954265", "Wakefield", "", "US", "840", "", "MA", "017", "", "42.50648", "-71.07283", "America/New_York"),("4954364", "Walpole", "", "US", "840", "", "MA", "021", "", "42.14177", "-71.2495", "America/New_York"),("4954380", "Waltham", "Уолтем", "US", "840", "", "MA", "017", "", "42.37649", "-71.23561", "America/New_York"),("4954477", "Ware", "", "US", "840", "", "MA", "015", "", "42.25981", "-72.2398", "America/New_York"),("4954611", "Watertown", "", "US", "840", "", "MA", "017", "", "42.37093", "-71.18283", "America/New_York"),("4954654", "Wayland", "", "US", "840", "", "MA", "017", "", "42.3626", "-71.36145", "America/New_York"),("4954677", "Webster", "", "US", "840", "", "MA", "027", "", "42.0501", "-71.88007", "America/New_York"),("4954738", "Wellesley", "Уэлсли", "US", "840", "", "MA", "021", "", "42.29649", "-71.29256", "America/New_York"),("4954850", "West Boylston", "", "US", "840", "", "MA", "027", "", "42.36676", "-71.78563", "America/New_York"),("4954886", "West Bridgewater", "", "US", "840", "", "MA", "023", "", "42.01899", "-71.00782", "America/New_York"),("4954923", "West Concord", "", "US", "840", "", "MA", "017", "", "42.45843", "-71.39534", "America/New_York"),("4955089", "West Springfield", "", "US", "840", "", "MA", "013", "", "42.10704", "-72.62037", "America/New_York"),("4955143", "West Yarmouth", "", "US", "840", "", "MA", "001", "", "41.65011", "-70.24113", "America/New_York"),("4955190", "Westfield", "", "US", "840", "", "MA", "013", "", "42.12509", "-72.74954", "America/New_York"),("4955219", "Westford", "", "US", "840", "", "MA", "017", "", "42.57926", "-71.43784", "America/New_York"),("4955247", "Westminster", "", "US", "840", "", "MA", "027", "", "42.54592", "-71.91063", "America/New_York"),("4955259", "Weston", "", "US", "840", "", "MA", "017", "", "42.36676", "-71.30311", "America/New_York"),("4955317", "Westwood", "", "US", "840", "", "MA", "021", "", "42.21399", "-71.2245", "America/New_York"),("4955336", "Weymouth", "", "US", "840", "", "MA", "021", "", "42.22093", "-70.93977", "America/New_York"),("4955539", "Whitinsville", "", "US", "840", "", "MA", "027", "", "42.11121", "-71.66618", "America/New_York"),("4955544", "Whitman", "", "US", "840", "", "MA", "023", "", "42.08066", "-70.9356", "America/New_York"),("4955840", "Wilmington", "Уилмингтон", "US", "840", "", "MA", "017", "", "42.54648", "-71.17367", "America/New_York"),("4955884", "Winchester", "Уинчестер", "US", "840", "", "MA", "017", "", "42.45232", "-71.137", "America/New_York"),("4955993", "Winthrop", "", "US", "840", "", "MA", "025", "", "42.3751", "-70.98283", "America/New_York"),("4956032", "Woburn", "", "US", "840", "", "MA", "017", "", "42.47926", "-71.15228", "America/New_York"),("4956184", "Worcester", "Вустер", "US", "840", "", "MA", "027", "", "42.26259", "-71.80229", "America/New_York"),("4956266", "Wrentham", "", "US", "840", "", "MA", "021", "", "42.06677", "-71.32811", "America/New_York"),("4956335", "Yarmouth", "", "US", "840", "", "MA", "001", "", "41.70567", "-70.22863", "America/New_York"),("4956338", "Yarmouth Port", "", "US", "840", "", "MA", "001", "", "41.70205", "-70.24947", "America/New_York"),("4956976", "Auburn", "Оберн", "US", "840", "", "ME", "001", "", "44.09785", "-70.23117", "America/New_York"),("4957003", "Augusta", "Огаста", "US", "840", "", "ME", "011", "", "44.31062", "-69.77949", "America/New_York"),("4957280", "Bangor", "Бангор", "US", "840", "", "ME", "019", "", "44.80118", "-68.77781", "America/New_York"),("4957570", "Bath", "", "US", "840", "", "ME", "023", "", "43.91064", "-69.8206", "America/New_York"),("4957956", "Belfast", "", "US", "840", "", "ME", "027", "", "44.42591", "-69.00642", "America/New_York"),("4958141", "Biddeford", "Биддефорд", "US", "840", "", "ME", "031", "", "43.49258", "-70.45338", "America/New_York"),("4959233", "Brewer", "", "US", "840", "", "ME", "019", "", "44.79674", "-68.76142", "America/New_York"),("4959473", "Brunswick", "Брауншвейг", "US", "840", "", "ME", "005", "", "43.91452", "-69.96533", "America/New_York"),("4959799", "Buxton", "", "US", "840", "", "ME", "031", "", "43.63786", "-70.51894", "America/New_York"),("4960140", "Caribou", "", "US", "840", "", "ME", "003", "", "46.8606", "-68.01197", "America/New_York"),("4963642", "Eliot", "", "US", "840", "", "ME", "031", "", "43.15314", "-70.80006", "America/New_York"),("4963692", "Ellsworth", "", "US", "840", "", "ME", "009", "", "44.54341", "-68.41946", "America/New_York"),("4965079", "Gardiner", "", "US", "840", "", "ME", "011", "", "44.23007", "-69.77532", "America/New_York"),("4965481", "Gorham", "", "US", "840", "", "ME", "005", "", "43.67952", "-70.44422", "America/New_York"),("4966554", "Harpswell Center", "", "US", "840", "", "ME", "005", "", "43.80175", "-69.98421", "America/New_York"),("4968729", "Kennebunk", "", "US", "840", "", "ME", "031", "", "43.38397", "-70.54478", "America/New_York"),("4969280", "Lebanon", "", "US", "840", "", "ME", "031", "", "43.39453", "-70.85089", "America/New_York"),("4969398", "Lewiston", "Льюистон", "US", "840", "", "ME", "001", "", "44.10035", "-70.21478", "America/New_York"),("4969622", "Lisbon", "", "US", "840", "", "ME", "001", "", "44.03146", "-70.1045", "America/New_York"),("4973259", "New Gloucester", "", "US", "840", "", "ME", "005", "", "43.96285", "-70.28255", "America/New_York"),("4973457", "North Bath", "", "US", "840", "", "ME", "023", "", "43.9348", "-69.81588", "America/New_York"),("4974194", "Old Orchard Beach", "", "US", "840", "", "ME", "031", "", "43.51731", "-70.37755", "America/New_York"),("4974231", "Old Town", "", "US", "840", "", "ME", "019", "", "44.93423", "-68.64531", "America/New_York"),("4974313", "Orono", "", "US", "840", "", "ME", "019", "", "44.88312", "-68.67198", "America/New_York"),("4974617", "Paris", "", "US", "840", "", "ME", "017", "", "44.25979", "-70.50062", "America/New_York"),("4975603", "Poland", "", "US", "840", "", "ME", "001", "", "44.06063", "-70.39367", "America/New_York"),("4975802", "Portland", "Портленд", "US", "840", "", "ME", "005", "", "43.66147", "-70.25533", "America/New_York"),("4975966", "Presque Isle", "", "US", "840", "", "ME", "003", "", "46.68115", "-68.01586", "America/New_York"),("4977222", "Saco", "Сако", "US", "840", "", "ME", "031", "", "43.50092", "-70.44283", "America/New_York"),("4977762", "Sanford", "", "US", "840", "", "ME", "031", "", "43.43925", "-70.77422", "America/New_York"),("4978701", "Skowhegan", "", "US", "840", "", "ME", "025", "", "44.76506", "-69.71922", "America/New_York"),("4979050", "South Berwick", "", "US", "840", "", "ME", "031", "", "43.23453", "-70.8095", "America/New_York"),("4979244", "South Portland", "Саут-Портленд", "US", "840", "", "ME", "005", "", "43.64147", "-70.24088", "America/New_York"),("4979245", "South Portland Gardens", "", "US", "840", "", "ME", "005", "", "43.63897", "-70.31533", "America/New_York"),("4980927", "Topsham", "", "US", "840", "", "ME", "023", "", "43.92758", "-69.97588", "America/New_York"),("4981250", "Turner", "", "US", "840", "", "ME", "001", "", "44.25646", "-70.25617", "America/New_York"),("4982218", "Waterboro", "", "US", "840", "", "ME", "031", "", "43.53564", "-70.71506", "America/New_York"),("4982236", "Waterville", "Уотервилл", "US", "840", "", "ME", "011", "", "44.55201", "-69.63171", "America/New_York"),("4982394", "Wells Beach Station", "", "US", "840", "", "ME", "031", "", "43.32397", "-70.59144", "America/New_York"),("4982720", "West Scarborough", "", "US", "840", "", "ME", "005", "", "43.57036", "-70.38783", "America/New_York"),("4982753", "Westbrook", "Уэстбрук", "US", "840", "", "ME", "005", "", "43.67703", "-70.37116", "America/New_York"),("4983322", "Winslow", "", "US", "840", "", "ME", "011", "", "44.54701", "-69.62116", "America/New_York"),("4983572", "Yarmouth", "", "US", "840", "", "ME", "005", "", "43.80064", "-70.18672", "America/New_York"),("4983611", "York Beach", "", "US", "840", "", "ME", "031", "", "43.17148", "-70.60894", "America/New_York"),("4983811", "Adrian", "Адриан", "US", "840", "", "MI", "091", "", "41.89755", "-84.03717", "America/Detroit"),("4983905", "Albion", "", "US", "840", "", "MI", "025", "", "42.2431", "-84.75303", "America/Detroit"),("4983989", "Allegan", "", "US", "840", "", "MI", "005", "", "42.5292", "-85.8553", "America/Detroit"),("4984016", "Allen Park", "", "US", "840", "", "MI", "163", "", "42.25754", "-83.21104", "America/Detroit"),("4984029", "Allendale", "", "US", "840", "", "MI", "139", "", "42.97225", "-85.95365", "America/Detroit"),("4984049", "Alma", "", "US", "840", "", "MI", "057", "", "43.37892", "-84.65973", "America/Detroit"),("4984075", "Alpena", "", "US", "840", "", "MI", "007", "", "45.06168", "-83.43275", "America/Detroit"),("4984247", "Ann Arbor", "Анн-Арбор", "US", "840", "", "MI", "161", "", "42.27756", "-83.74088", "America/Detroit"),("4984565", "Auburn Hills", "Оберн-Хиллс", "US", "840", "", "MI", "125", "", "42.68753", "-83.2341", "America/Detroit"),("4985153", "Battle Creek", "", "US", "840", "", "MI", "025", "", "42.3173", "-85.17816", "America/Detroit"),("4985180", "Bay City", "Бей-Сити", "US", "840", "", "MI", "017", "", "43.59447", "-83.88886", "America/Detroit"),("4985521", "Beecher", "", "US", "840", "", "MI", "049", "", "43.09003", "-83.6944", "America/Detroit"),("4985552", "Belding", "", "US", "840", "", "MI", "067", "", "43.09781", "-85.22891", "America/Detroit"),("4985711", "Benton Harbor", "", "US", "840", "", "MI", "021", "", "42.11671", "-86.45419", "America/Detroit"),("4985744", "Berkley", "", "US", "840", "", "MI", "125", "", "42.50309", "-83.18354", "America/Detroit"),("4985891", "Beverly Hills", "", "US", "840", "", "MI", "125", "", "42.52392", "-83.22326", "America/Detroit"),("4986020", "Big Rapids", "", "US", "840", "", "MI", "107", "", "43.69808", "-85.48366", "America/Detroit"),("4986172", "Birmingham", "Бирмингем", "US", "840", "", "MI", "125", "", "42.5467", "-83.21132", "America/Detroit"),("4986963", "Bridgeport", "", "US", "840", "", "MI", "145", "", "43.35947", "-83.88164", "America/Detroit"),("4986994", "Brighton", "", "US", "840", "", "MI", "093", "", "42.52948", "-83.78022", "America/Detroit"),("4987304", "Buena Vista", "", "US", "840", "", "MI", "145", "", "43.4203", "-83.89858", "America/Detroit"),("4987482", "Burton", "Бертон", "US", "840", "", "MI", "049", "", "42.99947", "-83.61634", "America/Detroit"),("4987587", "Byron Center", "", "US", "840", "", "MI", "081", "", "42.81225", "-85.72281", "America/Detroit"),("4987617", "Cadillac", "", "US", "840", "", "MI", "165", "", "44.25195", "-85.40116", "America/Detroit"),("4987990", "Canton", "", "US", "840", "", "MI", "163", "", "42.30865", "-83.48216", "America/Detroit"),("4988132", "Carrollton", "", "US", "840", "", "MI", "145", "", "43.45864", "-83.93025", "America/Detroit"),("4988400", "Center Line", "", "US", "840", "", "MI", "099", "", "42.48504", "-83.0277", "America/Detroit"),("4988584", "Charlotte", "", "US", "840", "", "MI", "045", "", "42.56365", "-84.83582", "America/Detroit"),("4988628", "Chelsea", "", "US", "840", "", "MI", "161", "", "42.31807", "-84.02181", "America/Detroit"),("4989005", "Clawson", "", "US", "840", "", "MI", "125", "", "42.53337", "-83.14632", "America/Detroit"),("4989133", "Clinton", "", "US", "840", "", "MI", "099", "", "42.58698", "-82.91992", "America/Detroit"),("4989266", "Coldwater", "", "US", "840", "", "MI", "023", "", "41.94033", "-85.00052", "America/Detroit"),("4989432", "Comstock Park", "", "US", "840", "", "MI", "081", "", "43.03864", "-85.67003", "America/Detroit"),("4990242", "Cutlerville", "", "US", "840", "", "MI", "081", "", "42.84086", "-85.66364", "America/Detroit"),("4990510", "Dearborn", "Дирборн", "US", "840", "", "MI", "163", "", "42.32226", "-83.17631", "America/Detroit"),("4990512", "Dearborn Heights", "", "US", "840", "", "MI", "163", "", "42.33698", "-83.27326", "America/Detroit"),("4990729", "Detroit", "Детройт", "US", "840", "", "MI", "163", "", "42.33143", "-83.04575", "America/Detroit"),("4991111", "Dowagiac", "", "US", "840", "", "MI", "027", "", "41.98421", "-86.10862", "America/Detroit"),("4991600", "East Grand Rapids", "", "US", "840", "", "MI", "081", "", "42.94114", "-85.61003", "America/Detroit"),("4991640", "East Lansing", "Ист-Лансинг", "US", "840", "", "MI", "065", "", "42.73698", "-84.48387", "America/Detroit"),("4991735", "Eastpointe", "", "US", "840", "", "MI", "099", "", "42.46837", "-82.95547", "America/Detroit"),("4991740", "Eastwood", "", "US", "840", "", "MI", "077", "", "42.3031", "-85.55028", "America/Detroit"),("4991753", "Eaton Rapids", "", "US", "840", "", "MI", "045", "", "42.5092", "-84.65581", "America/Detroit"),("4991791", "Ecorse", "", "US", "840", "", "MI", "163", "", "42.24448", "-83.14576", "America/Detroit"),("4992232", "Escanaba", "", "US", "840", "", "MI", "041", "", "45.74525", "-87.06458", "America/Detroit"),("4992394", "Fair Plain", "", "US", "840", "", "MI", "021", "", "42.08699", "-86.45586", "America/Detroit"),("4992519", "Farmington", "", "US", "840", "", "MI", "125", "", "42.46448", "-83.37632", "America/Detroit"),("4992523", "Farmington Hills", "", "US", "840", "", "MI", "125", "", "42.48531", "-83.37716", "America/Detroit"),("4992612", "Fenton", "", "US", "840", "", "MI", "049", "", "42.79781", "-83.70495", "America/Detroit"),("4992635", "Ferndale", "", "US", "840", "", "MI", "125", "", "42.46059", "-83.13465", "America/Detroit"),("4992940", "Flat Rock", "", "US", "840", "", "MI", "163", "", "42.09643", "-83.29187", "America/Detroit"),("4992982", "Flint", "Флинт", "US", "840", "", "MI", "049", "", "43.01253", "-83.68746", "America/Detroit"),("4993022", "Flushing", "", "US", "840", "", "MI", "049", "", "43.06308", "-83.85107", "America/Detroit"),("4993125", "Forest Hills", "", "US", "840", "", "MI", "081", "", "42.95947", "-85.48975", "America/Detroit"),("4993321", "Frankenmuth", "", "US", "840", "", "MI", "145", "", "43.33169", "-83.73802", "America/Detroit"),("4993369", "Fraser", "", "US", "840", "", "MI", "099", "", "42.5392", "-82.94937", "America/Detroit"),("4993402", "Freeland", "", "US", "840", "", "MI", "145", "", "43.52503", "-84.12276", "America/Detroit"),("4993659", "Garden City", "", "US", "840", "", "MI", "163", "", "42.32559", "-83.33104", "America/Detroit"),("4994320", "Grand Blanc", "", "US", "840", "", "MI", "049", "", "42.92753", "-83.62995", "America/Detroit"),("4994325", "Grand Haven", "", "US", "840", "", "MI", "139", "", "43.06307", "-86.22839", "America/Detroit"),("4994344", "Grand Ledge", "", "US", "840", "", "MI", "045", "", "42.75337", "-84.74638", "America/Detroit"),("4994358", "Grand Rapids", "Гранд-Рапидс", "US", "840", "", "MI", "081", "", "42.96336", "-85.66809", "America/Detroit"),("4994391", "Grandville", "", "US", "840", "", "MI", "081", "", "42.90975", "-85.76309", "America/Detroit"),("4994763", "Greenville", "", "US", "840", "", "MI", "117", "", "43.17753", "-85.2528", "America/Detroit"),("4994851", "Grosse Ile", "", "US", "840", "", "MI", "163", "", "42.12921", "-83.14437", "America/Detroit"),("4994862", "Grosse Pointe", "", "US", "840", "", "MI", "163", "", "42.38615", "-82.91186", "America/Detroit"),("4994864", "Grosse Pointe Farms", "", "US", "840", "", "MI", "163", "", "42.4092", "-82.89186", "America/Detroit"),("4994868", "Grosse Pointe Park", "", "US", "840", "", "MI", "163", "", "42.37587", "-82.93742", "America/Detroit"),("4994871", "Grosse Pointe Woods", "", "US", "840", "", "MI", "163", "", "42.44365", "-82.90686", "America/Detroit"),("4995197", "Hamtramck", "", "US", "840", "", "MI", "163", "", "42.39282", "-83.04964", "America/Detroit"),("4995368", "Harper Woods", "", "US", "840", "", "MI", "163", "", "42.43309", "-82.92408", "America/Detroit"),("4995514", "Haslett", "", "US", "840", "", "MI", "065", "", "42.74698", "-84.40108", "America/Detroit"),("4995520", "Hastings", "", "US", "840", "", "MI", "015", "", "42.64587", "-85.29084", "America/Detroit"),("4995664", "Hazel Park", "", "US", "840", "", "MI", "125", "", "42.46254", "-83.10409", "America/Detroit"),("4996017", "Highland Park", "", "US", "840", "", "MI", "163", "", "42.40559", "-83.09687", "America/Detroit"),("4996107", "Hillsdale", "", "US", "840", "", "MI", "059", "", "41.92005", "-84.63051", "America/Detroit"),("4996248", "Holland", "Голландия", "US", "840", "", "MI", "139", "", "42.78752", "-86.10893", "America/Detroit"),("4996274", "Holly", "", "US", "840", "", "MI", "125", "", "42.79197", "-83.62773", "America/Detroit"),("4996306", "Holt", "", "US", "840", "", "MI", "065", "", "42.64059", "-84.51525", "America/Detroit"),("4996572", "Houghton", "", "US", "840", "", "MI", "061", "", "47.12187", "-88.56901", "America/Detroit"),("4996655", "Howell", "", "US", "840", "", "MI", "093", "", "42.60726", "-83.9294", "America/Detroit"),("4996736", "Hudsonville", "", "US", "840", "", "MI", "139", "", "42.87086", "-85.86504", "America/Detroit"),("4996832", "Huntington Woods", "", "US", "840", "", "MI", "125", "", "42.48059", "-83.16687", "America/Detroit"),("4997191", "Ionia", "", "US", "840", "", "MI", "067", "", "42.98725", "-85.07112", "America/Detroit"),("4997232", "Iron Mountain", "", "US", "840", "", "MI", "043", "", "45.82023", "-88.06596", "America/Menominee"),("4997238", "Iron River", "", "US", "840", "", "MI", "071", "", "46.09273", "-88.64235", "America/Menominee"),("4997249", "Ironwood", "", "US", "840", "", "MI", "053", "", "46.45467", "-90.17101", "America/Menominee"),("4997281", "Ishpeming", "", "US", "840", "", "MI", "103", "", "46.48855", "-87.66764", "America/Detroit"),("4997384", "Jackson", "Джексон", "US", "840", "", "MI", "075", "", "42.24587", "-84.40135", "America/Detroit"),("4997500", "Jenison", "", "US", "840", "", "MI", "139", "", "42.90725", "-85.79198", "America/Detroit"),("4997787", "Kalamazoo", "Каламазу", "US", "840", "", "MI", "077", "", "42.29171", "-85.58723", "America/Detroit"),("4998018", "Kentwood", "", "US", "840", "", "MI", "081", "", "42.86947", "-85.64475", "America/Detroit"),("4998189", "Kingsford", "", "US", "840", "", "MI", "043", "", "45.79496", "-88.07207", "America/Menominee"),("4998543", "Lake Fenton", "", "US", "840", "", "MI", "049", "", "42.84614", "-83.70773", "America/Detroit"),("4998769", "Lambertville", "", "US", "840", "", "MI", "115", "", "41.76588", "-83.62799", "America/Detroit"),("4998830", "Lansing", "Лансинг", "US", "840", "", "MI", "065", "", "42.73253", "-84.55553", "America/Detroit"),("4998842", "Lapeer", "", "US", "840", "", "MI", "087", "", "43.05142", "-83.31883", "America/Detroit"),("4999311", "Lincoln Park", "", "US", "840", "", "MI", "163", "", "42.25059", "-83.17854", "America/Detroit"),("4999837", "Livonia", "Ливония", "US", "840", "", "MI", "163", "", "42.36837", "-83.35271", "America/Detroit"),("5000306", "Ludington", "", "US", "840", "", "MI", "105", "", "43.95528", "-86.45258", "America/Detroit"),("5000500", "Madison Heights", "", "US", "840", "", "MI", "125", "", "42.48587", "-83.1052", "America/Detroit"),("5000611", "Manistee", "", "US", "840", "", "MI", "101", "", "44.24445", "-86.32425", "America/Detroit"),("5000947", "Marquette", "Маркетт", "US", "840", "", "MI", "103", "", "46.54354", "-87.39542", "America/Detroit"),("5000996", "Marshall", "", "US", "840", "", "MI", "025", "", "42.27226", "-84.96331", "America/Detroit"),("5001084", "Marysville", "", "US", "840", "", "MI", "147", "", "42.91253", "-82.48686", "America/Detroit"),("5001093", "Mason", "", "US", "840", "", "MI", "065", "", "42.5792", "-84.44358", "America/Detroit"),("5001634", "Melvindale", "", "US", "840", "", "MI", "163", "", "42.28254", "-83.1752", "America/Detroit"),("5001669", "Menominee", "", "US", "840", "", "MI", "109", "", "45.10776", "-87.61427", "America/Menominee"),("5001929", "Midland", "", "US", "840", "", "MI", "111", "", "43.61558", "-84.24721", "America/Detroit"),("5001962", "Milan", "", "US", "840", "", "MI", "161", "", "42.08532", "-83.68244", "America/Detroit"),("5001972", "Milford", "", "US", "840", "", "MI", "125", "", "42.59364", "-83.59939", "America/Detroit"),("5002344", "Monroe", "Монро", "US", "840", "", "MI", "115", "", "41.91643", "-83.39771", "America/Detroit"),("5002656", "Mount Clemens", "", "US", "840", "", "MI", "099", "", "42.59726", "-82.87798", "America/Detroit"),("5002714", "Mount Pleasant", "Маунт-Плезант", "US", "840", "", "MI", "073", "", "43.59781", "-84.76751", "America/Detroit"),("5003132", "Muskegon", "", "US", "840", "", "MI", "121", "", "43.23418", "-86.24839", "America/Detroit"),("5003140", "Muskegon Heights", "", "US", "840", "", "MI", "121", "", "43.20113", "-86.23895", "America/Detroit"),("5003369", "New Baltimore", "", "US", "840", "", "MI", "099", "", "42.68114", "-82.73686", "America/Detroit"),("5003384", "New Haven", "", "US", "840", "", "MI", "155", "", "43.09364", "-84.15331", "America/Detroit"),("5003514", "Niles", "", "US", "840", "", "MI", "021", "", "41.82977", "-86.25418", "America/Detroit"),("5003952", "Northview", "", "US", "840", "", "MI", "081", "", "43.04558", "-85.60059", "America/Detroit"),("5003956", "Northville", "", "US", "840", "", "MI", "163", "", "42.43115", "-83.48327", "America/Detroit"),("5004005", "Norton Shores", "", "US", "840", "", "MI", "121", "", "43.1689", "-86.26395", "America/Detroit"),("5004062", "Novi", "Новый", "US", "840", "", "MI", "125", "", "42.48059", "-83.47549", "America/Detroit"),("5004188", "Oak Park", "Оук-Парк", "US", "840", "", "MI", "125", "", "42.45948", "-83.18271", "America/Detroit"),("5004359", "Okemos", "", "US", "840", "", "MI", "065", "", "42.72226", "-84.42747", "America/Detroit"),("5004792", "Owosso", "", "US", "840", "", "MI", "155", "", "42.9978", "-84.17664", "America/Detroit"),("5005484", "Petoskey", "", "US", "840", "", "MI", "047", "", "45.37334", "-84.95533", "America/Detroit"),("5006059", "Plymouth", "", "US", "840", "", "MI", "163", "", "42.37143", "-83.47021", "America/Detroit"),("5006166", "Pontiac", "Понтиак", "US", "840", "", "MI", "125", "", "42.63892", "-83.29105", "America/Detroit"),("5006233", "Port Huron", "", "US", "840", "", "MI", "147", "", "42.97086", "-82.42491", "America/Detroit"),("5006250", "Portage", "", "US", "840", "", "MI", "077", "", "42.20115", "-85.58", "America/Detroit"),("5006917", "Redford", "Редфорд", "US", "840", "", "MI", "163", "", "42.38337", "-83.2966", "America/Detroit"),("5007141", "Richmond", "", "US", "840", "", "MI", "099", "", "42.8092", "-82.75576", "America/Detroit"),("5007247", "River Rouge", "", "US", "840", "", "MI", "163", "", "42.27337", "-83.13437", "America/Detroit"),("5007323", "Riverview", "", "US", "840", "", "MI", "163", "", "42.17421", "-83.17937", "America/Detroit"),("5007400", "Rochester", "", "US", "840", "", "MI", "125", "", "42.68059", "-83.13382", "America/Detroit"),("5007402", "Rochester Hills", "", "US", "840", "", "MI", "125", "", "42.65837", "-83.14993", "America/Detroit"),("5007436", "Rockford", "", "US", "840", "", "MI", "081", "", "43.12003", "-85.56003", "America/Detroit"),("5007531", "Romulus", "Ромул", "US", "840", "", "MI", "163", "", "42.22226", "-83.3966", "America/Detroit"),("5007655", "Roseville", "Розвелл", "US", "840", "", "MI", "099", "", "42.49726", "-82.93714", "America/Detroit"),("5007804", "Royal Oak", "", "US", "840", "", "MI", "125", "", "42.48948", "-83.14465", "America/Detroit"),("5007989", "Saginaw", "", "US", "840", "", "MI", "145", "", "43.41947", "-83.95081", "America/Detroit"),("5008278", "Saint Johns", "", "US", "840", "", "MI", "037", "", "43.00114", "-84.55915", "America/Detroit"),("5008327", "Saint Joseph", "", "US", "840", "", "MI", "021", "", "42.10976", "-86.48002", "America/Detroit"),("5008414", "Saint Louis", "", "US", "840", "", "MI", "057", "", "43.40836", "-84.60667", "America/Detroit"),("5008768", "Saline", "", "US", "840", "", "MI", "161", "", "42.16671", "-83.78161", "America/Detroit"),("5009004", "Sault Ste. Marie", "", "US", "840", "", "MI", "033", "", "46.4953", "-84.34532", "America/Detroit"),("5009586", "Shelby", "", "US", "840", "", "MI", "099", "", "42.67087", "-83.03298", "America/Detroit"),("5009717", "Shields", "", "US", "840", "", "MI", "145", "", "43.4153", "-84.05637", "America/Detroit"),("5010548", "South Lyon", "", "US", "840", "", "MI", "125", "", "42.46059", "-83.65161", "America/Detroit"),("5010569", "South Monroe", "", "US", "840", "", "MI", "115", "", "41.89588", "-83.41771", "America/Detroit"),("5010636", "Southfield", "", "US", "840", "", "MI", "125", "", "42.47337", "-83.22187", "America/Detroit"),("5010646", "Southgate", "", "US", "840", "", "MI", "163", "", "42.21393", "-83.19381", "America/Detroit"),("5010917", "Springfield", "", "US", "840", "", "MI", "025", "", "42.32643", "-85.23916", "America/Detroit"),("5010977", "Saint Clair", "", "US", "840", "", "MI", "147", "", "42.82087", "-82.48602", "America/Detroit"),("5010978", "Saint Clair Shores", "", "US", "840", "", "MI", "099", "", "42.49698", "-82.88881", "America/Detroit"),("5011148", "Sterling Heights", "", "US", "840", "", "MI", "099", "", "42.58031", "-83.0302", "America/Detroit"),("5011428", "Sturgis", "", "US", "840", "", "MI", "149", "", "41.79922", "-85.41915", "America/Detroit"),("5011701", "Swartz Creek", "", "US", "840", "", "MI", "049", "", "42.95725", "-83.83051", "America/Detroit"),("5011908", "Taylor", "Тейлор", "US", "840", "", "MI", "163", "", "42.24087", "-83.26965", "America/Detroit"),("5011973", "Tecumseh", "", "US", "840", "", "MI", "091", "", "42.00393", "-83.94494", "America/Detroit"),("5011989", "Temperance", "", "US", "840", "", "MI", "115", "", "41.77921", "-83.56882", "America/Detroit"),("5012194", "Three Rivers", "", "US", "840", "", "MI", "149", "", "41.94394", "-85.63249", "America/Detroit"),("5012495", "Traverse City", "", "US", "840", "", "MI", "055", "", "44.76306", "-85.62063", "America/Detroit"),("5012521", "Trenton", "Трентон", "US", "840", "", "MI", "163", "", "42.13949", "-83.17826", "America/Detroit"),("5012639", "Troy", "Троя", "US", "840", "", "MI", "125", "", "42.60559", "-83.14993", "America/Detroit"),("5013924", "Walker", "", "US", "840", "", "MI", "081", "", "43.00141", "-85.76809", "America/Detroit"),("5013961", "Walled Lake", "", "US", "840", "", "MI", "125", "", "42.53781", "-83.48105", "America/Detroit"),("5014051", "Warren", "Уоррен", "US", "840", "", "MI", "099", "", "42.47754", "-83.0277", "America/Detroit"),("5014130", "Waterford", "Уотерфорд", "US", "840", "", "MI", "125", "", "42.69303", "-83.41181", "America/Detroit"),("5014208", "Waverly", "", "US", "840", "", "MI", "045", "", "42.7392", "-84.62081", "America/Detroit"),("5014224", "Wayne", "", "US", "840", "", "MI", "163", "", "42.28143", "-83.38632", "America/Detroit"),("5014681", "Westland", "", "US", "840", "", "MI", "163", "", "42.3242", "-83.40021", "America/Detroit"),("5014706", "Westwood", "", "US", "840", "", "MI", "077", "", "42.30282", "-85.63362", "America/Detroit"),("5014946", "Whitmore Lake", "", "US", "840", "", "MI", "093", "", "42.4397", "-83.7453", "America/Detroit"),("5015351", "Wixom", "", "US", "840", "", "MI", "125", "", "42.52476", "-83.53633", "America/Detroit"),("5015456", "Woodhaven", "", "US", "840", "", "MI", "163", "", "42.13893", "-83.2416", "America/Detroit"),("5015599", "Wyandotte", "", "US", "840", "", "MI", "163", "", "42.21421", "-83.14992", "America/Detroit"),("5015618", "Wyoming", "", "US", "840", "", "MI", "081", "", "42.91336", "-85.70531", "America/Detroit"),("5015688", "Ypsilanti", "Ипсиланти", "US", "840", "", "MI", "161", "", "42.24115", "-83.61299", "America/Detroit"),("5015701", "Zeeland", "", "US", "840", "", "MI", "139", "", "42.81252", "-86.01865", "America/Detroit"),("5016024", "Albert Lea", "Альберт-Ли", "US", "840", "", "MN", "047", "", "43.64801", "-93.36827", "America/Chicago"),("5016051", "Albertville", "", "US", "840", "", "MN", "171", "", "45.23774", "-93.65441", "America/Chicago"),("5016108", "Alexandria", "", "US", "840", "", "MN", "041", "", "45.88524", "-95.37754", "America/Chicago"),("5016374", "Andover", "", "US", "840", "", "MN", "003", "", "45.2333", "-93.29134", "America/Chicago"),("5016450", "Anoka", "Анока", "US", "840", "", "MN", "003", "", "45.19774", "-93.38718", "America/Chicago"),("5016494", "Apple Valley", "Эпл-Вэлли", "US", "840", "", "MN", "037", "", "44.73191", "-93.21772", "America/Chicago"),("5016553", "Arden Hills", "", "US", "840", "", "MN", "123", "", "45.05024", "-93.15661", "America/Chicago"),("5016884", "Austin", "Остин", "US", "840", "", "MN", "099", "", "43.66663", "-92.97464", "America/Chicago"),("5017396", "Baxter", "", "US", "840", "", "MN", "035", "", "46.3433", "-94.28667", "America/Chicago"),("5017761", "Belle Plaine", "", "US", "840", "", "MN", "139", "", "44.62274", "-93.76857", "America/Chicago"),("5017822", "Bemidji", "", "US", "840", "", "MN", "007", "", "47.47356", "-94.88028", "America/Chicago"),("5018285", "Big Lake", "", "US", "840", "", "MN", "141", "", "45.33246", "-93.74608", "America/Chicago"),("5018651", "Blaine", "", "US", "840", "", "MN", "003", "", "45.1608", "-93.23495", "America/Chicago"),("5018739", "Bloomington", "Блумингтон", "US", "840", "", "MN", "053", "", "44.8408", "-93.29828", "America/Chicago"),("5019116", "Brainerd", "", "US", "840", "", "MN", "035", "", "46.35802", "-94.20083", "America/Chicago"),("5019330", "Brooklyn Center", "", "US", "840", "", "MN", "053", "", "45.07608", "-93.33273", "America/Chicago"),("5019335", "Brooklyn Park", "Бруклин-Парк", "US", "840", "", "MN", "053", "", "45.09413", "-93.35634", "America/Chicago"),("5019588", "Buffalo", "Буффало", "US", "840", "", "MN", "171", "", "45.17191", "-93.87469", "America/Chicago"),("5019767", "Burnsville", "Бернсвилл", "US", "840", "", "MN", "037", "", "44.76774", "-93.27772", "America/Chicago"),("5019890", "Byron", "", "US", "840", "", "MN", "109", "", "44.03274", "-92.64546", "America/Chicago"),("5020068", "Cambridge", "", "US", "840", "", "MN", "059", "", "45.57274", "-93.22439", "America/Chicago"),("5020859", "Champlin", "", "US", "840", "", "MN", "053", "", "45.18885", "-93.39745", "America/Chicago"),("5020881", "Chanhassen", "", "US", "840", "", "MN", "019", "", "44.86219", "-93.53079", "America/Chicago"),("5020938", "Chaska", "Часка", "US", "840", "", "MN", "019", "", "44.78941", "-93.60218", "America/Chicago"),("5021632", "Cloquet", "", "US", "840", "", "MN", "017", "", "46.72161", "-92.45936", "America/Chicago"),("5021828", "Columbia Heights", "", "US", "840", "", "MN", "003", "", "45.0408", "-93.263", "America/Chicago"),("5022025", "Coon Rapids", "Кун-Рапидс", "US", "840", "", "MN", "003", "", "45.11997", "-93.28773", "America/Chicago"),("5022050", "Corcoran", "", "US", "840", "", "MN", "053", "", "45.09524", "-93.54746", "America/Chicago"),("5022134", "Cottage Grove", "", "US", "840", "", "MN", "163", "", "44.82774", "-92.94382", "America/Chicago"),("5023465", "Crookston", "", "US", "840", "", "MN", "119", "", "47.77414", "-96.60812", "America/Chicago"),("5023571", "Crystal", "", "US", "840", "", "MN", "053", "", "45.03274", "-93.36023", "America/Chicago"),("5023970", "Dayton", "", "US", "840", "", "MN", "053", "", "45.24385", "-93.51496", "America/Chicago"),("5024138", "Delano", "", "US", "840", "", "MN", "171", "", "45.04191", "-93.78913", "America/Chicago"),("5024237", "Detroit Lakes", "", "US", "840", "", "MN", "005", "", "46.81718", "-95.84533", "America/Chicago"),("5024719", "Duluth", "Дулут", "US", "840", "", "MN", "137", "", "46.78327", "-92.10658", "America/Chicago"),("5024825", "Eagan", "Иган", "US", "840", "", "MN", "037", "", "44.80413", "-93.16689", "America/Chicago"),("5024937", "East Bethel", "", "US", "840", "", "MN", "003", "", "45.31941", "-93.20245", "America/Chicago"),("5024996", "East Grand Forks", "", "US", "840", "", "MN", "119", "", "47.92998", "-97.02452", "America/Chicago"),("5025219", "Eden Prairie", "Иден-Прери", "US", "840", "", "MN", "053", "", "44.85469", "-93.47079", "America/Chicago"),("5025264", "Edina", "Идайна", "US", "840", "", "MN", "053", "", "44.88969", "-93.34995", "America/Chicago"),("5025471", "Elk River", "Элк-Ривер", "US", "840", "", "MN", "141", "", "45.30385", "-93.56718", "America/Chicago"),("5026114", "Fairmont", "", "US", "840", "", "MN", "091", "", "43.65218", "-94.46108", "America/Chicago"),("5026251", "Falcon Heights", "", "US", "840", "", "MN", "123", "", "44.99163", "-93.16633", "America/Chicago"),("5026291", "Faribault", "Фэрибо", "US", "840", "", "MN", "131", "", "44.29496", "-93.26883", "America/Chicago"),("5026321", "Farmington", "Фармингтон", "US", "840", "", "MN", "037", "", "44.64024", "-93.14355", "America/Chicago"),("5026416", "Fergus Falls", "", "US", "840", "", "MN", "111", "", "46.28302", "-96.07756", "America/Chicago"),("5027117", "Forest Lake", "", "US", "840", "", "MN", "163", "", "45.27886", "-92.98522", "America/Chicago"),("5027482", "Fridley", "Фридли", "US", "840", "", "MN", "003", "", "45.08608", "-93.26328", "America/Chicago"),("5028042", "Glencoe", "", "US", "840", "", "MN", "085", "", "44.76913", "-94.15164", "America/Chicago"),("5028163", "Golden Valley", "", "US", "840", "", "MN", "053", "", "45.00969", "-93.34912", "America/Chicago"),("5028537", "Grand Rapids", "", "US", "840", "", "MN", "061", "", "47.23717", "-93.53021", "America/Chicago"),("5029181", "Ham Lake", "", "US", "840", "", "MN", "003", "", "45.25024", "-93.24995", "America/Chicago"),("5029500", "Hastings", "Хейстингс", "US", "840", "", "MN", "037", "", "44.7433", "-92.85243", "America/Chicago"),("5029952", "Hermantown", "", "US", "840", "", "MN", "137", "", "46.80689", "-92.23825", "America/Chicago"),("5030005", "Hibbing", "Хиббинг", "US", "840", "", "MN", "137", "", "47.42715", "-92.93769", "America/Chicago"),("5030670", "Hopkins", "", "US", "840", "", "MN", "053", "", "44.92496", "-93.46273", "America/Chicago"),("5030884", "Hugo", "", "US", "840", "", "MN", "163", "", "45.15997", "-92.99327", "America/Chicago"),("5030977", "Hutchinson", "", "US", "840", "", "MN", "085", "", "44.88774", "-94.36971", "America/Chicago"),("5031404", "International Falls", "", "US", "840", "", "MN", "071", "", "48.60105", "-93.41098", "America/Chicago"),("5031412", "Inver Grove Heights", "", "US", "840", "", "MN", "037", "", "44.84802", "-93.04272", "America/Chicago"),("5031489", "Isanti", "", "US", "840", "", "MN", "059", "", "45.49024", "-93.24773", "America/Chicago"),("5032106", "Jordan", "", "US", "840", "", "MN", "139", "", "44.66691", "-93.6269", "America/Chicago"),("5032920", "Kasson", "", "US", "840", "", "MN", "039", "", "44.02996", "-92.75074", "America/Chicago"),("5033727", "Lake City", "", "US", "840", "", "MN", "157", "", "44.44968", "-92.2682", "America/Chicago"),("5033762", "Lake Elmo", "", "US", "840", "", "MN", "163", "", "44.9958", "-92.87938", "America/Chicago"),("5033783", "Zimmerman", "", "US", "840", "", "MN", "141", "", "45.4433", "-93.58996", "America/Chicago"),("5034059", "Lakeville", "Лейквилл", "US", "840", "", "MN", "037", "", "44.64969", "-93.24272", "America/Chicago"),("5034767", "Lino Lakes", "", "US", "840", "", "MN", "003", "", "45.16024", "-93.08883", "America/Chicago"),("5034813", "Litchfield", "", "US", "840", "", "MN", "093", "", "45.12718", "-94.52805", "America/Chicago"),("5034905", "Little Canada", "", "US", "840", "", "MN", "123", "", "45.02691", "-93.08772", "America/Chicago"),("5034970", "Little Falls", "", "US", "840", "", "MN", "097", "", "45.97635", "-94.3625", "America/Chicago"),("5036295", "Mahtomedi", "", "US", "840", "", "MN", "163", "", "45.06969", "-92.9516", "America/Chicago"),("5036420", "Mankato", "Манкейто", "US", "840", "", "MN", "013", "", "44.15906", "-94.00915", "America/Chicago"),("5036493", "Maple Grove", "", "US", "840", "", "MN", "053", "", "45.07246", "-93.45579", "America/Chicago"),("5036588", "Maplewood", "", "US", "840", "", "MN", "123", "", "44.95302", "-92.99522", "America/Chicago"),("5036727", "Marshall", "", "US", "840", "", "MN", "083", "", "44.4469", "-95.78835", "America/Chicago"),("5037186", "Medina", "", "US", "840", "", "MN", "053", "", "45.03524", "-93.58246", "America/Chicago"),("5037280", "Mendota Heights", "", "US", "840", "", "MN", "037", "", "44.88358", "-93.13827", "America/Chicago"),("5037649", "Minneapolis", "Миннеаполис", "US", "840", "", "MN", "053", "", "44.97997", "-93.26384", "America/Chicago"),("5037784", "Minnetonka", "Миннетонка", "US", "840", "", "MN", "053", "", "44.9133", "-93.50329", "America/Chicago"),("5037790", "Minnetonka Mills", "", "US", "840", "", "MN", "053", "", "44.94107", "-93.4419", "America/Chicago"),("5037793", "Minnetrista", "", "US", "840", "", "MN", "053", "", "44.9383", "-93.71774", "America/Chicago"),("5038018", "Montevideo", "", "US", "840", "", "MN", "023", "", "44.94803", "-95.71701", "America/Chicago"),("5038045", "Monticello", "", "US", "840", "", "MN", "171", "", "45.30552", "-93.79414", "America/Chicago"),("5038108", "Moorhead", "Мурхед", "US", "840", "", "MN", "027", "", "46.87386", "-96.76951", "America/Chicago"),("5038252", "Morris", "", "US", "840", "", "MN", "149", "", "45.58607", "-95.91394", "America/Chicago"),("5038348", "Mound", "", "US", "840", "", "MN", "053", "", "44.93663", "-93.66607", "America/Chicago"),("5038373", "Mounds View", "", "US", "840", "", "MN", "123", "", "45.10497", "-93.20856", "America/Chicago"),("5039080", "New Brighton", "", "US", "840", "", "MN", "123", "", "45.06552", "-93.20189", "America/Chicago"),("5039094", "New Hope", "", "US", "840", "", "MN", "053", "", "45.03802", "-93.38662", "America/Chicago"),("5039133", "New Prague", "", "US", "840", "", "MN", "079", "", "44.5433", "-93.57607", "America/Chicago"),("5039173", "New Ulm", "", "US", "840", "", "MN", "015", "", "44.31246", "-94.46053", "America/Chicago"),("5039421", "North Branch", "", "US", "840", "", "MN", "025", "", "45.51135", "-92.98022", "America/Chicago"),("5039537", "North Mankato", "", "US", "840", "", "MN", "103", "", "44.1733", "-94.03385", "America/Chicago"),("5039587", "North Saint Paul", "", "US", "840", "", "MN", "123", "", "45.01247", "-92.99188", "America/Chicago"),("5039675", "Northfield", "Нортфилд", "US", "840", "", "MN", "131", "", "44.4583", "-93.1616", "America/Chicago"),("5039857", "Oak Grove", "", "US", "840", "", "MN", "003", "", "45.3408", "-93.3269", "America/Chicago"),("5039978", "Oakdale", "", "US", "840", "", "MN", "163", "", "44.96302", "-92.96494", "America/Chicago"),("5040332", "Orono", "", "US", "840", "", "MN", "053", "", "44.97135", "-93.6044", "America/Chicago"),("5040477", "Otsego", "", "US", "840", "", "MN", "171", "", "45.27413", "-93.59135", "America/Chicago"),("5040647", "Owatonna", "", "US", "840", "", "MN", "147", "", "44.08385", "-93.22604", "America/Chicago"),("5041926", "Plymouth", "", "US", "840", "", "MN", "053", "", "45.01052", "-93.45551", "America/Chicago"),("5042373", "Prior Lake", "", "US", "840", "", "MN", "139", "", "44.7133", "-93.42273", "America/Chicago"),("5042561", "Ramsey", "", "US", "840", "", "MN", "003", "", "45.2611", "-93.45", "America/Chicago"),("5042773", "Red Wing", "Ред-Уинг", "US", "840", "", "MN", "049", "", "44.56247", "-92.5338", "America/Chicago"),("5042832", "Redwood Falls", "", "US", "840", "", "MN", "127", "", "44.5394", "-95.11694", "America/Chicago"),("5043193", "Richfield", "Ричфилд", "US", "840", "", "MN", "053", "", "44.8833", "-93.283", "America/Chicago"),("5043439", "Robbinsdale", "", "US", "840", "", "MN", "053", "", "45.03219", "-93.33856", "America/Chicago"),("5043473", "Rochester", "Рочестер", "US", "840", "", "MN", "109", "", "44.02163", "-92.4699", "America/Chicago"),("5043608", "Rogers", "", "US", "840", "", "MN", "053", "", "45.18885", "-93.55301", "America/Chicago"),("5043779", "Rosemount", "", "US", "840", "", "MN", "037", "", "44.73941", "-93.12577", "America/Chicago"),("5043799", "Roseville", "Розвелл", "US", "840", "", "MN", "123", "", "45.00608", "-93.15661", "America/Chicago"),("5044290", "Saint Anthony", "", "US", "840", "", "MN", "053", "", "45.02052", "-93.218", "America/Chicago"),("5044407", "Saint Cloud", "", "US", "840", "", "MN", "145", "", "45.5608", "-94.16249", "America/Chicago"),("5044485", "Saint Francis", "", "US", "840", "", "MN", "003", "", "45.38691", "-93.3594", "America/Chicago"),("5044896", "Saint Joseph", "", "US", "840", "", "MN", "145", "", "45.56496", "-94.31833", "America/Chicago"),("5045021", "Saint Louis Park", "", "US", "840", "", "MN", "053", "", "44.9483", "-93.34801", "America/Chicago"),("5045258", "Saint Michael", "", "US", "840", "", "MN", "171", "", "45.20996", "-93.66496", "America/Chicago"),("5045360", "Saint Paul", "Сент-Пол", "US", "840", "", "MN", "123", "", "44.94441", "-93.09327", "America/Chicago"),("5045403", "Saint Paul Park", "", "US", "840", "", "MN", "163", "", "44.84219", "-92.99132", "America/Chicago"),("5045517", "Saint Peter", "", "US", "840", "", "MN", "103", "", "44.32358", "-93.95801", "America/Chicago"),("5046001", "Sartell", "", "US", "840", "", "MN", "145", "", "45.62163", "-94.20694", "America/Chicago"),("5046038", "Sauk Rapids", "", "US", "840", "", "MN", "009", "", "45.59191", "-94.1661", "America/Chicago"),("5046063", "Savage", "", "US", "840", "", "MN", "139", "", "44.77913", "-93.33634", "America/Chicago"),("5046997", "Shakopee", "Шейкопе", "US", "840", "", "MN", "139", "", "44.79802", "-93.5269", "America/Chicago"),("5047234", "Shoreview", "Шорвью", "US", "840", "", "MN", "123", "", "45.07913", "-93.14717", "America/Chicago"),("5047236", "Shorewood", "", "US", "840", "", "MN", "053", "", "44.9008", "-93.58912", "America/Chicago"),("5048033", "South Saint Paul", "", "US", "840", "", "MN", "037", "", "44.89274", "-93.03494", "America/Chicago"),("5048361", "Spring Lake Park", "", "US", "840", "", "MN", "003", "", "45.10774", "-93.238", "America/Chicago"),("5048796", "Stewartville", "", "US", "840", "", "MN", "109", "", "43.85552", "-92.48851", "America/Chicago"),("5048814", "Stillwater", "Стиллуотер", "US", "840", "", "MN", "163", "", "45.05636", "-92.80604", "America/Chicago"),("5049970", "Thief River Falls", "", "US", "840", "", "MN", "113", "", "48.11914", "-96.18115", "America/Chicago"),("5051197", "Vadnais Heights", "", "US", "840", "", "MN", "123", "", "45.05747", "-93.07383", "America/Chicago"),("5051387", "Victoria", "", "US", "840", "", "MN", "019", "", "44.85857", "-93.66163", "America/Chicago"),("5051468", "Virginia", "", "US", "840", "", "MN", "137", "", "47.52326", "-92.53657", "America/Chicago"),("5051640", "Waconia", "", "US", "840", "", "MN", "019", "", "44.8508", "-93.78691", "America/Chicago"),("5051694", "Waite Park", "", "US", "840", "", "MN", "145", "", "45.55719", "-94.22416", "America/Chicago"),("5051902", "Waseca", "", "US", "840", "", "MN", "161", "", "44.07774", "-93.50744", "America/Chicago"),("5052361", "West Coon Rapids", "", "US", "840", "", "MN", "053", "", "45.15969", "-93.34967", "America/Chicago"),("5052467", "West Saint Paul", "", "US", "840", "", "MN", "037", "", "44.91608", "-93.10161", "America/Chicago"),("5052658", "White Bear Lake", "Уайт-Бэр-Лейк", "US", "840", "", "MN", "123", "", "45.08469", "-93.00994", "America/Chicago"),("5052916", "Willmar", "Уилмар", "US", "840", "", "MN", "067", "", "45.12191", "-95.04334", "America/Chicago"),("5053156", "Winona", "Вайнона", "US", "840", "", "MN", "169", "", "44.04996", "-91.63932", "America/Chicago"),("5053358", "Woodbury", "", "US", "840", "", "MN", "163", "", "44.92386", "-92.95938", "America/Chicago"),("5053460", "Worthington", "", "US", "840", "", "MN", "105", "", "43.61996", "-95.5964", "America/Chicago"),("5053526", "Wyoming", "", "US", "840", "", "MN", "025", "", "45.33636", "-92.99716", "America/Chicago"),("5055787", "Kirksville", "", "US", "840", "", "MO", "001", "", "40.19475", "-92.58325", "America/Chicago"),("5056172", "Maryville", "", "US", "840", "", "MO", "147", "", "40.3461", "-94.87247", "America/Chicago"),("5057562", "Trenton", "", "US", "840", "", "MO", "079", "", "40.0789", "-93.61661", "America/Chicago"),("5058868", "Devils Lake", "", "US", "840", "", "ND", "071", "", "48.11278", "-98.86512", "America/Chicago"),("5059163", "Fargo", "Фарго", "US", "840", "", "ND", "017", "", "46.87719", "-96.7898", "America/Chicago"),("5059429", "Grand Forks", "Гранд-Форкс", "US", "840", "", "ND", "035", "", "47.92526", "-97.03285", "America/Chicago"),("5059836", "Jamestown", "", "US", "840", "", "ND", "093", "", "46.91054", "-98.70844", "America/Chicago"),("5062292", "Valley City", "", "US", "840", "", "ND", "003", "", "46.92331", "-98.00315", "America/Chicago"),("5062355", "Wahpeton", "", "US", "840", "", "ND", "077", "", "46.26524", "-96.60591", "America/Chicago"),("5062458", "West Fargo", "", "US", "840", "", "ND", "017", "", "46.87497", "-96.90036", "America/Chicago"),("5063646", "Beatrice", "", "US", "840", "", "NE", "067", "", "40.26806", "-96.74697", "America/Chicago"),("5063805", "Bellevue", "Белвью", "US", "840", "", "NE", "153", "", "41.13667", "-95.89084", "America/Chicago"),("5064236", "Blair", "", "US", "840", "", "NE", "177", "", "41.54444", "-96.12502", "America/Chicago"),("5065495", "Chalco", "", "US", "840", "", "NE", "153", "", "41.18389", "-96.1503", "America/Chicago"),("5066001", "Columbus", "Колумбус", "US", "840", "", "NE", "141", "", "41.42973", "-97.36838", "America/Chicago"),("5066435", "Crete", "", "US", "840", "", "NE", "151", "", "40.62778", "-96.96142", "America/Chicago"),("5067545", "Elkhorn", "", "US", "840", "", "NE", "055", "", "41.28639", "-96.23447", "America/Chicago"),("5068725", "Fremont", "Фримонт", "US", "840", "", "NE", "053", "", "41.43333", "-96.49808", "America/Chicago"),("5069297", "Grand Island", "Гранд-Айленд", "US", "840", "", "NE", "079", "", "40.92501", "-98.34201", "America/Chicago"),("5069480", "Gretna", "", "US", "840", "", "NE", "153", "", "41.14083", "-96.23974", "America/Chicago"),("5069802", "Hastings", "Хейстингс", "US", "840", "", "NE", "001", "", "40.58612", "-98.38839", "America/Chicago"),("5070216", "Holdrege", "", "US", "840", "", "NE", "137", "", "40.44029", "-99.36982", "America/Chicago"),("5071348", "Kearney", "Керни", "US", "840", "", "NE", "019", "", "40.69946", "-99.08148", "America/Chicago"),("5071665", "La Vista", "", "US", "840", "", "NE", "153", "", "41.18389", "-96.03113", "America/Chicago"),("5071934", "Lexington", "", "US", "840", "", "NE", "047", "", "40.78084", "-99.7415", "America/Chicago"),("5072006", "Lincoln", "Линкольн", "US", "840", "", "NE", "109", "", "40.8", "-96.66696", "America/Chicago"),("5073661", "Nebraska City", "", "US", "840", "", "NE", "131", "", "40.67667", "-95.85917", "America/Chicago"),("5073965", "Norfolk", "Норфолк", "US", "840", "", "NE", "119", "", "42.02834", "-97.417", "America/Chicago"),("5074472", "Omaha", "Омаха", "US", "840", "", "NE", "055", "", "41.25626", "-95.94043", "America/Chicago"),("5074792", "Papillion", "", "US", "840", "", "NE", "153", "", "41.15444", "-96.04224", "America/Chicago"),("5075348", "Plattsmouth", "", "US", "840", "", "NE", "025", "", "41.01139", "-95.88223", "America/Chicago"),("5075972", "Ralston", "", "US", "840", "", "NE", "055", "", "41.20528", "-96.04252", "America/Chicago"),("5078641", "Schuyler", "", "US", "840", "", "NE", "037", "", "41.44723", "-97.05948", "America/Chicago"),("5078792", "Seward", "", "US", "840", "", "NE", "159", "", "40.90695", "-97.09892", "America/Chicago"),("5079250", "South Sioux City", "", "US", "840", "", "NE", "043", "", "42.47388", "-96.41364", "America/Chicago"),("5081454", "Wayne", "", "US", "840", "", "NE", "179", "", "42.23056", "-97.01782", "America/Chicago"),("5082331", "York", "", "US", "840", "", "NE", "185", "", "40.86807", "-97.592", "America/Chicago"),("5082590", "Allenstown Elementary School", "", "US", "840", "", "NH", "013", "", "43.15786", "-71.40562", "America/New_York"),("5082790", "Atkinson", "", "US", "840", "", "NH", "015", "", "42.83842", "-71.147", "America/New_York"),("5082811", "Auburn", "", "US", "840", "", "NH", "015", "", "43.00453", "-71.3484", "America/New_York"),("5083023", "Barrington", "", "US", "840", "", "NH", "017", "", "43.22286", "-71.04701", "America/New_York"),("5083221", "Bedford", "Бедфорд", "US", "840", "", "NH", "011", "", "42.94647", "-71.5159", "America/New_York"),("5083330", "Berlin", "", "US", "840", "", "NH", "007", "", "44.46867", "-71.18508", "America/New_York"),("5083673", "Bow Bog", "", "US", "840", "", "NH", "013", "", "43.12064", "-71.51146", "America/New_York"),("5084518", "Chester", "", "US", "840", "", "NH", "015", "", "42.95675", "-71.25728", "America/New_York"),("5084633", "Claremont", "", "US", "840", "", "NH", "019", "", "43.37674", "-72.34676", "America/New_York"),("5084868", "Concord", "Конкорд", "US", "840", "", "NH", "013", "", "43.20814", "-71.53757", "America/New_York"),("5085374", "Derry", "Дерри", "US", "840", "", "NH", "015", "", "42.88064", "-71.32729", "America/New_York"),("5085382", "Derry Village", "", "US", "840", "", "NH", "015", "", "42.89175", "-71.31201", "America/New_York"),("5085520", "Dover", "Довер", "US", "840", "", "NH", "017", "", "43.19786", "-70.87367", "America/New_York"),("5085618", "Durham", "", "US", "840", "", "NH", "017", "", "43.13397", "-70.92645", "America/New_York"),("5085688", "East Concord", "", "US", "840", "", "NH", "013", "", "43.24202", "-71.53813", "America/New_York"),("5085966", "Exeter", "", "US", "840", "", "NH", "015", "", "42.98148", "-70.94783", "America/New_York"),("5086344", "Franklin", "", "US", "840", "", "NH", "013", "", "43.44424", "-71.6473", "America/New_York"),("5086544", "Gilford", "", "US", "840", "", "NH", "001", "", "43.54758", "-71.40674", "America/New_York"),("5087105", "Hampstead", "", "US", "840", "", "NH", "015", "", "42.87453", "-71.18117", "America/New_York"),("5087110", "Hampton", "", "US", "840", "", "NH", "015", "", "42.93759", "-70.83894", "America/New_York"),("5087168", "Hanover", "", "US", "840", "", "NH", "009", "", "43.70229", "-72.28954", "America/New_York"),("5087559", "Hollis", "", "US", "840", "", "NH", "011", "", "42.74314", "-71.59174", "America/New_York"),("5087639", "Hopkinton", "", "US", "840", "", "NH", "013", "", "43.19147", "-71.67535", "America/New_York"),("5087752", "Hudson", "", "US", "840", "", "NH", "011", "", "42.76481", "-71.43979", "America/New_York"),("5088262", "Keene", "", "US", "840", "", "NH", "005", "", "42.93369", "-72.27814", "America/New_York"),("5088377", "Kingston", "", "US", "840", "", "NH", "015", "", "42.93648", "-71.05339", "America/New_York"),("5088438", "Laconia", "", "US", "840", "", "NH", "001", "", "43.52785", "-71.47035", "America/New_York"),("5088597", "Lebanon", "", "US", "840", "", "NH", "009", "", "43.64229", "-72.25176", "America/New_York"),("5088753", "Litchfield", "", "US", "840", "", "NH", "011", "", "42.84425", "-71.47979", "America/New_York"),("5088905", "Londonderry", "", "US", "840", "", "NH", "015", "", "42.86509", "-71.37395", "America/New_York"),("5089178", "Manchester", "Манчестер", "US", "840", "", "NH", "011", "", "42.99564", "-71.45479", "America/New_York"),("5089478", "Merrimack", "Мерримак", "US", "840", "", "NH", "011", "", "42.86509", "-71.4934", "America/New_York"),("5089578", "Milford", "", "US", "840", "", "NH", "011", "", "42.83536", "-71.64896", "America/New_York"),("5089850", "Moultonborough", "", "US", "840", "", "NH", "003", "", "43.7548", "-71.39674", "America/New_York"),("5090046", "Nashua", "Нашуа", "US", "840", "", "NH", "011", "", "42.76537", "-71.46757", "America/New_York"),("5090183", "New Ipswich", "", "US", "840", "", "NH", "011", "", "42.74814", "-71.85424", "America/New_York"),("5090246", "Newmarket", "", "US", "840", "", "NH", "015", "", "43.08286", "-70.93506", "America/New_York"),("5090459", "Northfield", "", "US", "840", "", "NH", "013", "", "43.43313", "-71.5923", "America/New_York"),("5090910", "Pelham", "", "US", "840", "", "NH", "011", "", "42.73453", "-71.32451", "America/New_York"),("5090918", "Pembroke", "", "US", "840", "", "NH", "013", "", "43.14675", "-71.45757", "America/New_York"),("5091273", "Plaistow", "", "US", "840", "", "NH", "015", "", "42.83648", "-71.09478", "America/New_York"),("5091383", "Portsmouth", "Портсмут", "US", "840", "", "NH", "015", "", "43.07176", "-70.76255", "America/New_York"),("5091744", "Rindge", "", "US", "840", "", "NH", "005", "", "42.7512", "-72.0098", "America/New_York"),("5091872", "Rochester", "Рочестер", "US", "840", "", "NH", "017", "", "43.30453", "-70.97562", "America/New_York"),("5092018", "Rye", "", "US", "840", "", "NH", "015", "", "43.01342", "-70.77089", "America/New_York"),("5092268", "Salem", "Салем", "US", "840", "", "NH", "015", "", "42.78842", "-71.20089", "America/New_York"),("5092364", "Sandown", "", "US", "840", "", "NH", "015", "", "42.9287", "-71.18701", "America/New_York"),("5092485", "Seabrook", "", "US", "840", "", "NH", "015", "", "42.89481", "-70.87116", "America/New_York"),("5092813", "Somersworth", "", "US", "840", "", "NH", "017", "", "43.26175", "-70.86534", "America/New_York"),("5092902", "South Hooksett", "", "US", "840", "", "NH", "013", "", "43.02647", "-71.43534", "America/New_York"),("5093259", "Stratham Station", "", "US", "840", "", "NH", "015", "", "43.05287", "-70.89533", "America/New_York"),("5093360", "Suncook", "", "US", "840", "", "NH", "013", "", "43.13064", "-71.45312", "America/New_York"),("5093422", "Swanzey", "", "US", "840", "", "NH", "005", "", "42.8698", "-72.28175", "America/New_York"),("5094329", "Weare", "", "US", "840", "", "NH", "011", "", "43.0948", "-71.73063", "America/New_York"),("5094817", "Windham", "", "US", "840", "", "NH", "015", "", "42.80064", "-71.30423", "America/New_York"),("5095124", "Allendale", "", "US", "840", "", "NJ", "003", "", "41.04149", "-74.12903", "America/New_York"),("5095281", "Asbury Park", "", "US", "840", "", "NJ", "025", "", "40.22039", "-74.01208", "America/New_York"),("5095325", "Avenel", "", "US", "840", "", "NJ", "023", "", "40.58038", "-74.28515", "America/New_York"),("5095445", "Bayonne", "Бейонн", "US", "840", "", "NJ", "017", "", "40.66871", "-74.11431", "America/New_York"),("5095528", "Bedminster", "", "US", "840", "", "NJ", "035", "", "40.68066", "-74.64544", "America/New_York"),("5095549", "Belleville", "", "US", "840", "", "NJ", "013", "", "40.79371", "-74.15014", "America/New_York"),("5095561", "Belmar", "", "US", "840", "", "NJ", "025", "", "40.17845", "-74.0218", "America/New_York"),("5095611", "Bergenfield", "", "US", "840", "", "NJ", "003", "", "40.9276", "-73.99736", "America/New_York"),("5095617", "Berkeley Heights", "", "US", "840", "", "NJ", "039", "", "40.68343", "-74.44265", "America/New_York"),("5095626", "Bernardsville", "", "US", "840", "", "NJ", "035", "", "40.71871", "-74.56932", "America/New_York"),("5095779", "Bloomfield", "", "US", "840", "", "NJ", "013", "", "40.80677", "-74.18542", "America/New_York"),("5095786", "Bloomingdale", "", "US", "840", "", "NJ", "031", "", "41.00204", "-74.32654", "America/New_York"),("5095787", "Bloomingdale", "", "US", "840", "", "NJ", "035", "", "40.4976", "-74.64738", "America/New_York"),("5095808", "Bogota", "", "US", "840", "", "NJ", "003", "", "40.87621", "-74.02986", "America/New_York"),("5095826", "Boonton", "", "US", "840", "", "NJ", "027", "", "40.9026", "-74.4071", "America/New_York"),("5095860", "Bound Brook", "", "US", "840", "", "NJ", "035", "", "40.56844", "-74.53849", "America/New_York"),("5095887", "Bradley Gardens", "", "US", "840", "", "NJ", "035", "", "40.56288", "-74.6546", "America/New_York"),("5096049", "Brookdale", "", "US", "840", "", "NJ", "013", "", "40.83371", "-74.18292", "America/New_York"),("5096057", "Budd Lake", "", "US", "840", "", "NJ", "027", "", "40.87121", "-74.73405", "America/New_York"),("5096075", "Burlington", "", "US", "840", "", "NJ", "005", "", "40.07122", "-74.86489", "America/New_York"),("5096100", "Butler", "", "US", "840", "", "NJ", "027", "", "41.00371", "-74.34154", "America/New_York"),("5096133", "Caldwell", "", "US", "840", "", "NJ", "013", "", "40.83982", "-74.27654", "America/New_York"),("5096289", "Carlstadt", "", "US", "840", "", "NJ", "003", "", "40.84038", "-74.0907", "America/New_York"),("5096316", "Carteret", "", "US", "840", "", "NJ", "023", "", "40.57733", "-74.2282", "America/New_York"),("5096371", "Cedar Grove", "", "US", "840", "", "NJ", "013", "", "40.85177", "-74.22903", "America/New_York"),("5096495", "Chatham", "", "US", "840", "", "NJ", "027", "", "40.74093", "-74.38376", "America/New_York"),("5096655", "Clark", "", "US", "840", "", "NJ", "039", "", "40.64094", "-74.3107", "America/New_York"),("5096686", "Cliffside Park", "", "US", "840", "", "NJ", "003", "", "40.82149", "-73.98764", "America/New_York"),("5096699", "Clifton", "Клифтон", "US", "840", "", "NJ", "031", "", "40.85843", "-74.16376", "America/New_York"),("5096742", "Closter", "", "US", "840", "", "NJ", "003", "", "40.97315", "-73.96153", "America/New_York"),("5096798", "Colonia", "", "US", "840", "", "NJ", "023", "", "40.57455", "-74.30209", "America/New_York"),("5097017", "Cranford", "Крэнфорд", "US", "840", "", "NJ", "039", "", "40.65844", "-74.29959", "America/New_York"),("5097035", "Cresskill", "", "US", "840", "", "NJ", "003", "", "40.94149", "-73.9593", "America/New_York"),("5097152", "Dayton", "", "US", "840", "", "NJ", "023", "", "40.37261", "-74.51015", "America/New_York"),("5097224", "Demarest", "", "US", "840", "", "NJ", "003", "", "40.95732", "-73.96347", "America/New_York"),("5097315", "Dover", "Довер", "US", "840", "", "NJ", "027", "", "40.88399", "-74.5621", "America/New_York"),("5097349", "Dunellen", "", "US", "840", "", "NJ", "023", "", "40.58927", "-74.47182", "America/New_York"),("5097357", "Dumont", "", "US", "840", "", "NJ", "003", "", "40.94065", "-73.99681", "America/New_York"),("5097402", "East Brunswick", "", "US", "840", "", "NJ", "023", "", "40.42788", "-74.41598", "America/New_York"),("5097421", "East Hanover", "", "US", "840", "", "NJ", "027", "", "40.8201", "-74.36487", "America/New_York"),("5097441", "East Orange", "", "US", "840", "", "NJ", "013", "", "40.76732", "-74.20487", "America/New_York"),("5097459", "East Rutherford", "", "US", "840", "", "NJ", "003", "", "40.83399", "-74.09709", "America/New_York"),("5097482", "Eatontown", "", "US", "840", "", "NJ", "025", "", "40.29622", "-74.05097", "America/New_York"),("5097521", "Edgewater Park", "", "US", "840", "", "NJ", "005", "", "40.06817", "-74.90072", "America/New_York"),("5097529", "Edison", "Эдисон", "US", "840", "", "NJ", "023", "", "40.51872", "-74.4121", "America/New_York"),("5097575", "Edgewater", "", "US", "840", "", "NJ", "003", "", "40.82704", "-73.97569", "America/New_York"),("5097598", "Elizabeth", "Элизабет", "US", "840", "", "NJ", "039", "", "40.66399", "-74.2107", "America/New_York"),("5097627", "Elmwood Park", "", "US", "840", "", "NJ", "003", "", "40.90399", "-74.11848", "America/New_York"),("5097649", "Emerson", "", "US", "840", "", "NJ", "003", "", "40.97621", "-74.02625", "America/New_York"),("5097672", "Englewood", "Энглвуд", "US", "840", "", "NJ", "003", "", "40.89288", "-73.97264", "America/New_York"),("5097677", "Englewood Cliffs", "", "US", "840", "", "NJ", "003", "", "40.88538", "-73.95236", "America/New_York"),("5097751", "Ewing", "", "US", "840", "", "NJ", "021", "", "40.26983", "-74.79988", "America/New_York"),("5097769", "Fair Haven", "", "US", "840", "", "NJ", "025", "", "40.36067", "-74.03819", "America/New_York"),("5097773", "Fair Lawn", "", "US", "840", "", "NJ", "003", "", "40.94038", "-74.13181", "America/New_York"),("5097778", "Fairfield", "", "US", "840", "", "NJ", "013", "", "40.88371", "-74.30598", "America/New_York"),("5097801", "Fairview", "", "US", "840", "", "NJ", "003", "", "40.8126", "-73.99903", "America/New_York"),("5097830", "Fanwood", "", "US", "840", "", "NJ", "039", "", "40.64094", "-74.38348", "America/New_York"),("5097900", "Finderne", "", "US", "840", "", "NJ", "035", "", "40.56316", "-74.57766", "America/New_York"),("5098095", "Florham Park", "", "US", "840", "", "NJ", "027", "", "40.78788", "-74.38821", "America/New_York"),("5098109", "Fords", "", "US", "840", "", "NJ", "023", "", "40.52927", "-74.31598", "America/New_York"),("5098132", "Fort Dix", "", "US", "840", "", "NJ", "005", "", "40.02984", "-74.61849", "America/New_York"),("5098135", "Fort Lee", "", "US", "840", "", "NJ", "003", "", "40.85093", "-73.97014", "America/New_York"),("5098242", "Franklin Lakes", "", "US", "840", "", "NJ", "003", "", "41.01676", "-74.2057", "America/New_York"),("5098247", "Franklin Park", "", "US", "840", "", "NJ", "023", "", "40.43899", "-74.53515", "America/New_York"),("5098278", "Freehold", "", "US", "840", "", "NJ", "025", "", "40.26011", "-74.27376", "America/New_York"),("5098343", "Garfield", "", "US", "840", "", "NJ", "003", "", "40.88149", "-74.1132", "America/New_York"),("5098430", "Glen Ridge", "", "US", "840", "", "NJ", "013", "", "40.80538", "-74.20376", "America/New_York"),("5098436", "Glen Rock", "", "US", "840", "", "NJ", "003", "", "40.96288", "-74.13292", "America/New_York"),("5098617", "Green Knoll", "", "US", "840", "", "NJ", "035", "", "40.6001", "-74.6121", "America/New_York"),("5098698", "Guttenberg", "", "US", "840", "", "NJ", "017", "", "40.79205", "-74.00375", "America/New_York"),("5098706", "Hackensack", "Хакенсак", "US", "840", "", "NJ", "003", "", "40.88593", "-74.04347", "America/New_York"),("5098745", "Hackettstown", "", "US", "840", "", "NJ", "041", "", "40.85399", "-74.82906", "America/New_York"),("5098781", "Hamilton Square", "", "US", "840", "", "NJ", "021", "", "40.22733", "-74.65321", "America/New_York"),("5098794", "Haledon", "", "US", "840", "", "NJ", "031", "", "40.93565", "-74.18626", "America/New_York"),("5098805", "Hanover", "", "US", "840", "", "NJ", "027", "", "40.80454", "-74.36682", "America/New_York"),("5098863", "Harrison", "", "US", "840", "", "NJ", "017", "", "40.74649", "-74.15626", "America/New_York"),("5098878", "Hasbrouck Heights", "", "US", "840", "", "NJ", "003", "", "40.85816", "-74.0807", "America/New_York"),("5098909", "Hawthorne", "", "US", "840", "", "NJ", "031", "", "40.94926", "-74.15375", "America/New_York"),("5098945", "Heathcote", "", "US", "840", "", "NJ", "023", "", "40.38872", "-74.57571", "America/New_York"),("5099057", "Highland Park", "", "US", "840", "", "NJ", "023", "", "40.49594", "-74.42432", "America/New_York"),("5099067", "Hightstown", "", "US", "840", "", "NJ", "021", "", "40.26955", "-74.52321", "America/New_York"),("5099087", "Hillsdale", "", "US", "840", "", "NJ", "003", "", "41.0026", "-74.04042", "America/New_York"),("5099093", "Hillside", "", "US", "840", "", "NJ", "039", "", "40.70121", "-74.23015", "America/New_York"),("5099133", "Hoboken", "Хобокен", "US", "840", "", "NJ", "017", "", "40.74399", "-74.03236", "America/New_York"),("5099289", "Hopatcong", "", "US", "840", "", "NJ", "037", "", "40.93288", "-74.65933", "America/New_York"),("5099292", "Hopatcong Hills", "", "US", "840", "", "NJ", "037", "", "40.94399", "-74.67072", "America/New_York"),("5099724", "Irvington", "", "US", "840", "", "NJ", "013", "", "40.73232", "-74.23487", "America/New_York"),("5099738", "Iselin", "", "US", "840", "", "NJ", "023", "", "40.57538", "-74.32237", "America/New_York"),("5099795", "Jamesburg", "", "US", "840", "", "NJ", "023", "", "40.35261", "-74.44015", "America/New_York"),("5099836", "Jersey City", "Джерси-Сити", "US", "840", "", "NJ", "017", "", "40.72816", "-74.07764", "America/New_York"),("5099961", "Keansburg", "", "US", "840", "", "NJ", "025", "", "40.44177", "-74.12986", "America/New_York"),("5099967", "Kearny", "Керни", "US", "840", "", "NJ", "017", "", "40.76843", "-74.14542", "America/New_York"),("5099988", "Kendall Park", "", "US", "840", "", "NJ", "023", "", "40.42094", "-74.56071", "America/New_York"),("5100007", "Kenilworth", "", "US", "840", "", "NJ", "039", "", "40.67649", "-74.2907", "America/New_York"),("5100008", "Keyport", "", "US", "840", "", "NJ", "025", "", "40.43316", "-74.19959", "America/New_York"),("5100062", "Kinnelon", "", "US", "840", "", "NJ", "027", "", "41.00176", "-74.3671", "America/New_York"),("5100190", "Lake Mohawk", "", "US", "840", "", "NJ", "037", "", "41.01843", "-74.66016", "America/New_York"),("5100280", "Lakewood", "Лейквуд", "US", "840", "", "NJ", "029", "", "40.09789", "-74.21764", "America/New_York"),("5100340", "Laurence Harbor", "", "US", "840", "", "NJ", "023", "", "40.45677", "-74.24653", "America/New_York"),("5100399", "Leonia", "", "US", "840", "", "NJ", "003", "", "40.86149", "-73.98819", "America/New_York"),("5100477", "Lincoln Park", "", "US", "840", "", "NJ", "027", "", "40.92427", "-74.30209", "America/New_York"),("5100498", "Lincroft", "", "US", "840", "", "NJ", "025", "", "40.33067", "-74.12097", "America/New_York"),("5100506", "Linden", "Линден", "US", "840", "", "NJ", "039", "", "40.62205", "-74.24459", "America/New_York"),("5100540", "Little Falls", "", "US", "840", "", "NJ", "031", "", "40.86899", "-74.2082", "America/New_York"),("5100542", "Little Ferry", "", "US", "840", "", "NJ", "003", "", "40.85288", "-74.04208", "America/New_York"),("5100559", "Little Silver", "", "US", "840", "", "NJ", "025", "", "40.33678", "-74.04708", "America/New_York"),("5100572", "Livingston", "Ливингстон", "US", "840", "", "NJ", "013", "", "40.79593", "-74.31487", "America/New_York"),("5100604", "Lodi", "Лоди", "US", "840", "", "NJ", "003", "", "40.88232", "-74.0832", "America/New_York"),("5100619", "Long Branch", "", "US", "840", "", "NJ", "025", "", "40.30428", "-73.99236", "America/New_York"),("5100706", "Lyndhurst", "", "US", "840", "", "NJ", "003", "", "40.81204", "-74.12431", "America/New_York"),("5100748", "Madison", "Мадисон", "US", "840", "", "NJ", "027", "", "40.75982", "-74.4171", "America/New_York"),("5100764", "Madison Park", "", "US", "840", "", "NJ", "023", "", "40.4515", "-74.30792", "America/New_York"),("5100776", "Mahwah", "", "US", "840", "", "NJ", "003", "", "41.08871", "-74.14376", "America/New_York"),("5100809", "Manasquan", "", "US", "840", "", "NJ", "025", "", "40.12623", "-74.0493", "America/New_York"),("5100830", "Manville", "", "US", "840", "", "NJ", "035", "", "40.54094", "-74.58766", "America/New_York"),("5100854", "Maplewood", "", "US", "840", "", "NJ", "013", "", "40.73121", "-74.27348", "America/New_York"),("5100886", "Marlboro", "", "US", "840", "", "NJ", "025", "", "40.31539", "-74.24626", "America/New_York"),("5100924", "Martinsville", "", "US", "840", "", "NJ", "035", "", "40.60121", "-74.55905", "America/New_York"),("5100940", "Matawan", "", "US", "840", "", "NJ", "025", "", "40.41483", "-74.22959", "America/New_York"),("5100972", "Maywood", "", "US", "840", "", "NJ", "003", "", "40.9026", "-74.06181", "America/New_York"),("5101073", "Mendham", "", "US", "840", "", "NJ", "027", "", "40.77593", "-74.60071", "America/New_York"),("5101103", "Mercerville", "", "US", "840", "", "NJ", "021", "", "40.23705", "-74.68655", "America/New_York"),("5101125", "Metuchen", "", "US", "840", "", "NJ", "023", "", "40.54316", "-74.3632", "America/New_York"),("5101159", "Middlesex", "", "US", "840", "", "NJ", "023", "", "40.5726", "-74.49265", "America/New_York"),("5101178", "Midland Park", "", "US", "840", "", "NJ", "003", "", "40.98926", "-74.1407", "America/New_York"),("5101244", "Milltown", "", "US", "840", "", "NJ", "023", "", "40.45622", "-74.44321", "America/New_York"),("5101334", "Montclair", "", "US", "840", "", "NJ", "013", "", "40.82593", "-74.20903", "America/New_York"),("5101361", "Montvale", "", "US", "840", "", "NJ", "003", "", "41.04676", "-74.02292", "America/New_York"),("5101393", "Morganville", "", "US", "840", "", "NJ", "025", "", "40.3765", "-74.24431", "America/New_York"),("5101417", "Morris Plains", "", "US", "840", "", "NJ", "027", "", "40.82177", "-74.48099", "America/New_York"),("5101427", "Morristown", "", "US", "840", "", "NJ", "027", "", "40.79677", "-74.48154", "America/New_York"),("5101459", "Mount Arlington", "", "US", "840", "", "NJ", "027", "", "40.92593", "-74.63488", "America/New_York"),("5101601", "Mountainside", "", "US", "840", "", "NJ", "039", "", "40.67232", "-74.35737", "America/New_York"),("5101717", "New Brunswick", "Нью-Брансуик", "US", "840", "", "NJ", "023", "", "40.48622", "-74.45182", "America/New_York"),("5101766", "New Milford", "Новые Милфорд", "US", "840", "", "NJ", "003", "", "40.9351", "-74.01903", "America/New_York"),("5101775", "New Providence", "", "US", "840", "", "NJ", "039", "", "40.69843", "-74.40154", "America/New_York"),("5101798", "Newark", "Ньюарк", "US", "840", "", "NJ", "013", "", "40.73566", "-74.17237", "America/New_York"),("5101848", "Newton", "", "US", "840", "", "NJ", "037", "", "41.05815", "-74.75267", "America/New_York"),("5101873", "North Arlington", "", "US", "840", "", "NJ", "003", "", "40.78843", "-74.1332", "America/New_York"),("5101879", "North Bergen", "", "US", "840", "", "NJ", "017", "", "40.80427", "-74.01208", "America/New_York"),("5101901", "North Caldwell", "", "US", "840", "", "NJ", "013", "", "40.86482", "-74.2582", "America/New_York"),("5101922", "North Haledon", "", "US", "840", "", "NJ", "031", "", "40.9551", "-74.18598", "America/New_York"),("5101938", "North Plainfield", "", "US", "840", "", "NJ", "035", "", "40.6301", "-74.42737", "America/New_York"),("5101962", "Northfield", "", "US", "840", "", "NJ", "013", "", "40.77427", "-74.32459", "America/New_York"),("5101978", "Norwood", "", "US", "840", "", "NJ", "003", "", "40.99815", "-73.9618", "America/New_York"),("5102076", "Nutley", "", "US", "840", "", "NJ", "013", "", "40.82232", "-74.15987", "America/New_York"),("5102118", "Oakland", "", "US", "840", "", "NJ", "003", "", "41.01315", "-74.26431", "America/New_York"),("5102147", "Oceanport", "", "US", "840", "", "NJ", "025", "", "40.31817", "-74.01514", "America/New_York"),("5102162", "Old Bridge", "", "US", "840", "", "NJ", "023", "", "40.41483", "-74.36543", "America/New_York"),("5102190", "Old Tappan", "", "US", "840", "", "NJ", "003", "", "41.01065", "-73.99125", "America/New_York"),("5102208", "Oradell", "", "US", "840", "", "NJ", "003", "", "40.95871", "-74.03681", "America/New_York"),("5102213", "Orange", "", "US", "840", "", "NJ", "013", "", "40.77066", "-74.23265", "America/New_York"),("5102369", "Palisades Park", "", "US", "840", "", "NJ", "003", "", "40.84816", "-73.99764", "America/New_York"),("5102378", "Palmyra", "", "US", "840", "", "NJ", "005", "", "40.00706", "-75.02823", "America/New_York"),("5102387", "Paramus", "Парамус", "US", "840", "", "NJ", "003", "", "40.94454", "-74.07542", "America/New_York"),("5102400", "Park Ridge", "", "US", "840", "", "NJ", "003", "", "41.0376", "-74.0407", "America/New_York"),("5102427", "Parsippany", "Парсиппани", "US", "840", "", "NJ", "027", "", "40.85788", "-74.42599", "America/New_York"),("5102443", "Passaic", "", "US", "840", "", "NJ", "031", "", "40.85677", "-74.12848", "America/New_York"),("5102466", "Paterson", "Патерсон", "US", "840", "", "NJ", "031", "", "40.91677", "-74.17181", "America/New_York"),("5102578", "Perth Amboy", "", "US", "840", "", "NJ", "023", "", "40.50677", "-74.26542", "America/New_York"),("5102615", "Phillipsburg", "", "US", "840", "", "NJ", "041", "", "40.69371", "-75.19018", "America/New_York"),("5102691", "Pine Lake Park", "", "US", "840", "", "NJ", "029", "", "40.00317", "-74.25653", "America/New_York"),("5102713", "Piscataway", "", "US", "840", "", "NJ", "023", "", "40.49927", "-74.39904", "America/New_York"),("5102720", "Plainfield", "Плейнфилд", "US", "840", "", "NJ", "039", "", "40.63371", "-74.40737", "America/New_York"),("5102796", "Point Pleasant", "", "US", "840", "", "NJ", "029", "", "40.08317", "-74.06819", "America/New_York"),("5102825", "Pompton Lakes", "", "US", "840", "", "NJ", "031", "", "41.00538", "-74.2907", "America/New_York"),("5102922", "Princeton", "", "US", "840", "", "NJ", "021", "", "40.34872", "-74.65905", "America/New_York"),("5102941", "Princeton Meadows", "", "US", "840", "", "NJ", "023", "", "40.33177", "-74.56377", "America/New_York"),("5102970", "Prospect Park", "", "US", "840", "", "NJ", "021", "", "40.24039", "-74.76627", "America/New_York"),("5102973", "Prospect Park", "", "US", "840", "", "NJ", "031", "", "40.93704", "-74.17431", "America/New_York"),("5103055", "Rahway", "", "US", "840", "", "NJ", "039", "", "40.60816", "-74.27765", "America/New_York"),("5103086", "Ramsey", "", "US", "840", "", "NJ", "003", "", "41.05732", "-74.14098", "America/New_York"),("5103095", "Ramtown", "", "US", "840", "", "NJ", "025", "", "40.12095", "-74.14375", "America/New_York"),("5103116", "Raritan", "", "US", "840", "", "NJ", "035", "", "40.56955", "-74.63294", "America/New_York"),("5103159", "Red Bank", "", "US", "840", "", "NJ", "025", "", "40.34705", "-74.06431", "America/New_York"),("5103254", "Ridgefield", "", "US", "840", "", "NJ", "003", "", "40.83427", "-74.00875", "America/New_York"),("5103256", "Ridgefield Park", "", "US", "840", "", "NJ", "003", "", "40.85704", "-74.02153", "America/New_York"),("5103269", "Ridgewood", "Риджвуд", "US", "840", "", "NJ", "003", "", "40.97926", "-74.11653", "America/New_York"),("5103286", "Ringwood", "", "US", "840", "", "NJ", "031", "", "41.11343", "-74.24543", "America/New_York"),("5103301", "River Edge", "", "US", "840", "", "NJ", "003", "", "40.92871", "-74.03986", "America/New_York"),("5103310", "River Vale", "", "US", "840", "", "NJ", "003", "", "40.99538", "-74.01208", "America/New_York"),("5103374", "Robertsville", "", "US", "840", "", "NJ", "025", "", "40.34622", "-74.28792", "America/New_York"),("5103384", "Rochelle Park", "", "US", "840", "", "NJ", "003", "", "40.90732", "-74.07514", "America/New_York"),("5103396", "Rockaway", "", "US", "840", "", "NJ", "027", "", "40.90121", "-74.51432", "America/New_York"),("5103497", "Roseland", "", "US", "840", "", "NJ", "013", "", "40.82066", "-74.29376", "America/New_York"),("5103500", "Roselle", "", "US", "840", "", "NJ", "039", "", "40.65223", "-74.25882", "America/New_York"),("5103503", "Roselle Park", "", "US", "840", "", "NJ", "039", "", "40.66455", "-74.26431", "America/New_York"),("5103564", "Rumson", "", "US", "840", "", "NJ", "025", "", "40.37205", "-73.99903", "America/New_York"),("5103580", "Rutherford", "", "US", "840", "", "NJ", "003", "", "40.82649", "-74.10681", "America/New_York"),("5103637", "Saddle Brook", "", "US", "840", "", "NJ", "003", "", "40.89899", "-74.09264", "America/New_York"),("5104404", "Sayreville", "", "US", "840", "", "NJ", "023", "", "40.45927", "-74.36098", "America/New_York"),("5104405", "Sayreville Junction", "", "US", "840", "", "NJ", "023", "", "40.46538", "-74.33043", "America/New_York"),("5104473", "Scotch Plains", "", "US", "840", "", "NJ", "039", "", "40.65538", "-74.38987", "America/New_York"),("5104504", "Secaucus", "", "US", "840", "", "NJ", "017", "", "40.78955", "-74.05653", "America/New_York"),("5104630", "Short Hills", "", "US", "840", "", "NJ", "013", "", "40.74788", "-74.32543", "America/New_York"),("5104755", "Somerset", "Сомерсет", "US", "840", "", "NJ", "035", "", "40.4976", "-74.48849", "America/New_York"),("5104774", "Somerville", "", "US", "840", "", "NJ", "035", "", "40.57427", "-74.60988", "America/New_York"),("5104784", "South Amboy", "", "US", "840", "", "NJ", "023", "", "40.47788", "-74.2907", "America/New_York"),("5104835", "South Old Bridge", "", "US", "840", "", "NJ", "023", "", "40.40816", "-74.35432", "America/New_York"),("5104836", "South Orange", "", "US", "840", "", "NJ", "013", "", "40.74899", "-74.26126", "America/New_York"),("5104844", "South Plainfield", "", "US", "840", "", "NJ", "023", "", "40.57927", "-74.41154", "America/New_York"),("5104853", "South River", "", "US", "840", "", "NJ", "023", "", "40.44649", "-74.38598", "America/New_York"),("5104907", "Spotswood", "", "US", "840", "", "NJ", "023", "", "40.39177", "-74.39848", "America/New_York"),("5104952", "Springfield", "", "US", "840", "", "NJ", "039", "", "40.70491", "-74.31723", "America/New_York"),("5105095", "Strathmore", "", "US", "840", "", "NJ", "025", "", "40.39594", "-74.21348", "America/New_York"),("5105113", "Succasunna", "", "US", "840", "", "NJ", "027", "", "40.86843", "-74.64044", "America/New_York"),("5105127", "Summit", "", "US", "840", "", "NJ", "039", "", "40.71562", "-74.36468", "America/New_York"),("5105262", "Teaneck", "", "US", "840", "", "NJ", "003", "", "40.8976", "-74.01597", "America/New_York"),("5105300", "Tenafly", "", "US", "840", "", "NJ", "003", "", "40.92538", "-73.96292", "America/New_York"),("5105433", "Tinton Falls", "", "US", "840", "", "NJ", "025", "", "40.30428", "-74.10042", "America/New_York"),("5105455", "Totowa", "", "US", "840", "", "NJ", "031", "", "40.9051", "-74.20987", "America/New_York"),("5105496", "Trenton", "Трентон", "US", "840", "", "NJ", "021", "", "40.21705", "-74.74294", "America/New_York"),("5105594", "Twin Rivers", "", "US", "840", "", "NJ", "021", "", "40.264", "-74.49126", "America/New_York"),("5105608", "Union", "", "US", "840", "", "NJ", "039", "", "40.6976", "-74.2632", "America/New_York"),("5105615", "Union Beach", "", "US", "840", "", "NJ", "025", "", "40.4465", "-74.1782", "America/New_York"),("5105634", "Union City", "Юнион-Сити", "US", "840", "", "NJ", "017", "", "40.77955", "-74.02375", "America/New_York"),("5105722", "Upper Montclair", "", "US", "840", "", "NJ", "013", "", "40.84621", "-74.20126", "America/New_York"),("5105733", "Upper Saddle River", "", "US", "840", "", "NJ", "003", "", "41.05843", "-74.09848", "America/New_York"),("5105809", "Verona", "", "US", "840", "", "NJ", "013", "", "40.82982", "-74.24015", "America/New_York"),("5105860", "Voorhees", "", "US", "840", "", "NJ", "035", "", "40.48122", "-74.48321", "America/New_York"),("5105957", "Waldwick", "", "US", "840", "", "NJ", "003", "", "41.01065", "-74.11792", "America/New_York"),("5105974", "Wallington", "", "US", "840", "", "NJ", "003", "", "40.85316", "-74.11375", "America/New_York"),("5106014", "Wanaque", "", "US", "840", "", "NJ", "031", "", "41.03815", "-74.29404", "America/New_York"),("5106057", "Washington", "", "US", "840", "", "NJ", "041", "", "40.75843", "-74.97934", "America/New_York"),("5106129", "Watchung", "", "US", "840", "", "NJ", "035", "", "40.63788", "-74.45099", "America/New_York"),("5106160", "Wayne", "", "US", "840", "", "NJ", "031", "", "40.92538", "-74.27654", "America/New_York"),("5106184", "Weehawken", "", "US", "840", "", "NJ", "017", "", "40.76955", "-74.02042", "America/New_York"),("5106238", "West Caldwell", "", "US", "840", "", "NJ", "013", "", "40.84093", "-74.30182", "America/New_York"),("5106262", "West Freehold", "", "US", "840", "", "NJ", "025", "", "40.24206", "-74.30126", "America/New_York"),("5106275", "West Long Branch", "", "US", "840", "", "NJ", "025", "", "40.29039", "-74.01764", "America/New_York"),("5106279", "West Milford", "", "US", "840", "", "NJ", "031", "", "41.13121", "-74.36737", "America/New_York"),("5106292", "West New York", "", "US", "840", "", "NJ", "017", "", "40.78788", "-74.01431", "America/New_York"),("5106298", "West Orange", "", "US", "840", "", "NJ", "013", "", "40.79871", "-74.23904", "America/New_York"),("5106303", "Woodland Park", "", "US", "840", "", "NJ", "031", "", "40.88982", "-74.19487", "America/New_York"),("5106331", "Westfield", "", "US", "840", "", "NJ", "039", "", "40.65899", "-74.34737", "America/New_York"),("5106351", "Westwood", "", "US", "840", "", "NJ", "003", "", "40.99121", "-74.03264", "America/New_York"),("5106361", "Wharton", "", "US", "840", "", "NJ", "027", "", "40.89315", "-74.58183", "America/New_York"),("5106378", "White Horse", "", "US", "840", "", "NJ", "021", "", "40.19067", "-74.70238", "America/New_York"),("5106379", "White Meadow Lake", "", "US", "840", "", "NJ", "027", "", "40.92371", "-74.51071", "America/New_York"),("5106453", "Willingboro", "", "US", "840", "", "NJ", "005", "", "40.02789", "-74.86905", "America/New_York"),("5106520", "Wood-Ridge", "", "US", "840", "", "NJ", "003", "", "40.84566", "-74.08792", "America/New_York"),("5106529", "Woodbridge", "", "US", "840", "", "NJ", "023", "", "40.5576", "-74.28459", "America/New_York"),("5106548", "Woodcliff Lake", "", "US", "840", "", "NJ", "003", "", "41.02343", "-74.06653", "America/New_York"),("5106615", "Wyckoff", "", "US", "840", "", "NJ", "003", "", "41.00954", "-74.17292", "America/New_York"),("5106645", "Yorketown", "", "US", "840", "", "NJ", "025", "", "40.30789", "-74.33765", "America/New_York"),("5106817", "Airmont", "", "US", "840", "", "NY", "087", "", "41.10093", "-74.11625", "America/New_York"),("5106834", "Albany", "Олбани", "US", "840", "", "NY", "001", "", "42.65258", "-73.75623", "America/New_York"),("5106857", "Albertson", "", "US", "840", "", "NY", "059", "", "40.77343", "-73.64318", "America/New_York"),("5106862", "Albion", "", "US", "840", "", "NY", "073", "", "43.24645", "-78.19363", "America/New_York"),("5107129", "Amherst", "Амхерст", "US", "840", "", "NY", "029", "", "42.97839", "-78.79976", "America/New_York"),("5107140", "Amityville", "", "US", "840", "", "NY", "103", "", "40.67899", "-73.41707", "America/New_York"),("5107152", "Amsterdam", "", "US", "840", "", "NY", "057", "", "42.93869", "-74.18819", "America/New_York"),("5107505", "Auburn", "Оберн", "US", "840", "", "NY", "011", "", "42.93173", "-76.56605", "America/New_York"),("5107612", "Babylon", "", "US", "840", "", "NY", "103", "", "40.69566", "-73.32568", "America/New_York"),("5107760", "Baldwin", "Болдуин", "US", "840", "", "NY", "059", "", "40.65649", "-73.6093", "America/New_York"),("5107771", "Baldwin Harbor", "", "US", "840", "", "NY", "059", "", "40.63955", "-73.60846", "America/New_York"),("5107785", "Baldwinsville", "", "US", "840", "", "NY", "067", "", "43.15868", "-76.33271", "America/New_York"),("5107812", "Ballston Spa", "", "US", "840", "", "NY", "091", "", "43.00091", "-73.84901", "America/New_York"),("5108093", "Batavia", "Батавия", "US", "840", "", "NY", "037", "", "42.99812", "-78.18752", "America/New_York"),("5108110", "Bath", "", "US", "840", "", "NY", "101", "", "42.33702", "-77.31776", "America/New_York"),("5108169", "Bay Shore", "", "US", "840", "", "NY", "103", "", "40.7251", "-73.24539", "America/New_York"),("5108179", "Bay Wood", "", "US", "840", "", "NY", "103", "", "40.7501", "-73.29123", "America/New_York"),("5108191", "Bayport", "", "US", "840", "", "NY", "103", "", "40.73843", "-73.05067", "America/New_York"),("5108202", "Bayville", "", "US", "840", "", "NY", "059", "", "40.91065", "-73.56207", "America/New_York"),("5108219", "Beacon", "", "US", "840", "", "NY", "027", "", "41.50482", "-73.96958", "America/New_York"),("5108707", "Bellmore", "", "US", "840", "", "NY", "059", "", "40.66871", "-73.52707", "America/New_York"),("5108815", "Bensonhurst", "Бенсонхерст", "US", "840", "", "NY", "047", "", "40.60177", "-73.99403", "America/New_York"),("5108955", "Bethpage", "", "US", "840", "", "NY", "059", "", "40.74427", "-73.48207", "America/New_York"),("5109053", "Big Flats", "", "US", "840", "", "NY", "015", "", "42.1373", "-76.93691", "America/New_York"),("5109177", "Binghamton", "Бингемтон", "US", "840", "", "NY", "007", "", "42.09869", "-75.91797", "America/New_York"),("5109479", "Blauvelt", "", "US", "840", "", "NY", "087", "", "41.06343", "-73.95764", "America/New_York"),("5109694", "Bohemia", "", "US", "840", "", "NY", "103", "", "40.76926", "-73.11511", "America/New_York"),("5109797", "Boston", "", "US", "840", "", "NY", "029", "", "42.62895", "-78.73753", "America/New_York"),("5110077", "Brentwood", "", "US", "840", "", "NY", "103", "", "40.78121", "-73.24623", "America/New_York"),("5110108", "Briarcliff Manor", "", "US", "840", "", "NY", "119", "", "41.14565", "-73.82375", "America/New_York"),("5110159", "Brighton", "Брайтон", "US", "840", "", "NY", "055", "", "43.14756", "-77.55055", "America/New_York"),("5110227", "Brockport", "", "US", "840", "", "NY", "055", "", "43.21367", "-77.93918", "America/New_York"),("5110266", "The Bronx", "Бронкс", "US", "840", "", "NY", "005", "", "40.84985", "-73.86641", "America/New_York"),("5110269", "Bronxville", "", "US", "840", "", "NY", "119", "", "40.93815", "-73.83208", "America/New_York"),("5110302", "Brooklyn", "Бруклин", "US", "840", "", "NY", "047", "", "40.6501", "-73.94958", "America/New_York"),("5110629", "Buffalo", "Буффало", "US", "840", "", "NY", "029", "", "42.88645", "-78.87837", "America/New_York"),("5111137", "Calverton", "", "US", "840", "", "NY", "103", "", "40.90649", "-72.74343", "America/New_York"),("5111405", "Canandaigua", "", "US", "840", "", "NY", "069", "", "42.87423", "-77.28804", "America/New_York"),("5111484", "Canton", "", "US", "840", "", "NY", "089", "", "44.59562", "-75.16909", "America/New_York"),("5111974", "Cedarhurst", "", "US", "840", "", "NY", "059", "", "40.62288", "-73.7243", "America/New_York"),("5112020", "Center Moriches", "", "US", "840", "", "NY", "103", "", "40.80038", "-72.78982", "America/New_York"),("5112035", "Centereach", "", "US", "840", "", "NY", "103", "", "40.85843", "-73.09955", "America/New_York"),("5112037", "Centerport", "", "US", "840", "", "NY", "011", "", "43.0409", "-76.59272", "America/New_York"),("5112038", "Centerport", "", "US", "840", "", "NY", "103", "", "40.88538", "-73.37623", "America/New_York"),("5112078", "Central Islip", "", "US", "840", "", "NY", "103", "", "40.79065", "-73.20178", "America/New_York"),("5112375", "Cheektowaga", "", "US", "840", "", "NY", "029", "", "42.90339", "-78.75475", "America/New_York"),("5112493", "Chestnut Ridge", "", "US", "840", "", "NY", "087", "", "41.08426", "-74.0557", "America/New_York"),("5113142", "Cohoes", "", "US", "840", "", "NY", "001", "", "42.77424", "-73.70012", "America/New_York"),("5113223", "Cold Spring Harbor", "", "US", "840", "", "NY", "103", "", "40.87149", "-73.45679", "America/New_York"),("5113348", "Colonie", "", "US", "840", "", "NY", "001", "", "42.71786", "-73.83346", "America/New_York"),("5113412", "Commack", "", "US", "840", "", "NY", "103", "", "40.84288", "-73.29289", "America/New_York"),("5113481", "Coney Island", "Кони-Айленд", "US", "840", "", "NY", "047", "", "40.57788", "-73.99403", "America/New_York"),("5113500", "Congers", "", "US", "840", "", "NY", "087", "", "41.15065", "-73.94542", "America/New_York"),("5113683", "Copiague", "", "US", "840", "", "NY", "103", "", "40.68149", "-73.39984", "America/New_York"),("5113694", "Coram", "", "US", "840", "", "NY", "103", "", "40.86871", "-73.00149", "America/New_York"),("5113760", "Corning", "", "US", "840", "", "NY", "101", "", "42.14285", "-77.05469", "America/New_York"),("5113790", "Cortland", "", "US", "840", "", "NY", "023", "", "42.60118", "-76.18048", "America/New_York"),("5114221", "Croton-on-Hudson", "", "US", "840", "", "NY", "119", "", "41.20843", "-73.89125", "America/New_York"),("5114731", "Deer Park", "", "US", "840", "", "NY", "103", "", "40.76177", "-73.32929", "America/New_York"),("5114831", "Delmar", "", "US", "840", "", "NY", "001", "", "42.62202", "-73.83262", "America/New_York"),("5114900", "Depew", "", "US", "840", "", "NY", "029", "", "42.90395", "-78.69225", "America/New_York"),("5115107", "Dix Hills", "", "US", "840", "", "NY", "103", "", "40.80482", "-73.33623", "America/New_York"),("5115123", "Dobbs Ferry", "", "US", "840", "", "NY", "119", "", "41.01454", "-73.87264", "America/New_York"),("5115495", "Dunkirk", "", "US", "840", "", "NY", "013", "", "42.4795", "-79.33393", "America/New_York"),("5115704", "East Aurora", "", "US", "840", "", "NY", "029", "", "42.76784", "-78.61336", "America/New_York"),("5115838", "East Farmingdale", "", "US", "840", "", "NY", "103", "", "40.72927", "-73.41679", "America/New_York"),("5115854", "East Garden City", "", "US", "840", "", "NY", "059", "", "40.73083", "-73.59806", "America/New_York"),("5115857", "East Glenville", "", "US", "840", "", "NY", "093", "", "42.89452", "-73.9279", "America/New_York"),("5115904", "East Hills", "", "US", "840", "", "NY", "059", "", "40.79371", "-73.62707", "America/New_York"),("5115923", "East Islip", "", "US", "840", "", "NY", "103", "", "40.73204", "-73.18567", "America/New_York"),("5115960", "East Meadow", "", "US", "840", "", "NY", "059", "", "40.71399", "-73.55902", "America/New_York"),("5115962", "East Massapequa", "", "US", "840", "", "NY", "059", "", "40.67343", "-73.43651", "America/New_York"),("5115974", "East Moriches", "", "US", "840", "", "NY", "103", "", "40.8051", "-72.76093", "America/New_York"),("5115985", "East New York", "", "US", "840", "", "NY", "047", "", "40.66677", "-73.88236", "America/New_York"),("5115989", "East Northport", "", "US", "840", "", "NY", "103", "", "40.87676", "-73.32456", "America/New_York"),("5116004", "East Patchogue", "", "US", "840", "", "NY", "103", "", "40.76704", "-72.99622", "America/New_York"),("5116047", "East Rochester", "", "US", "840", "", "NY", "055", "", "43.10867", "-77.4875", "America/New_York"),("5116049", "East Rockaway", "", "US", "840", "", "NY", "059", "", "40.64205", "-73.66957", "America/New_York"),("5116060", "East Setauket", "", "US", "840", "", "NY", "103", "", "40.94149", "-73.10594", "America/New_York"),("5116063", "East Shoreham", "", "US", "840", "", "NY", "103", "", "40.94482", "-72.87955", "America/New_York"),("5116118", "Eastchester", "", "US", "840", "", "NY", "119", "", "40.95833", "-73.80861", "America/New_York"),("5116119", "Eastchester", "", "US", "840", "", "NY", "005", "", "40.8876", "-73.83291", "America/New_York"),("5116303", "Eggertsville", "", "US", "840", "", "NY", "029", "", "42.96339", "-78.80392", "America/New_York"),("5116497", "Elmira", "Эльмира", "US", "840", "", "NY", "015", "", "42.0898", "-76.80773", "America/New_York"),("5116508", "Elmont", "", "US", "840", "", "NY", "059", "", "40.70094", "-73.71291", "America/New_York"),("5116550", "Elwood", "", "US", "840", "", "NY", "103", "", "40.84538", "-73.33512", "America/New_York"),("5116602", "Endicott", "", "US", "840", "", "NY", "007", "", "42.09841", "-76.04937", "America/New_York"),("5116603", "Endwell", "", "US", "840", "", "NY", "007", "", "42.11285", "-76.02103", "America/New_York"),("5116811", "Fairmount", "", "US", "840", "", "NY", "067", "", "43.04729", "-76.23854", "America/New_York"),("5116815", "Fairport", "", "US", "840", "", "NY", "055", "", "43.09867", "-77.44194", "America/New_York"),("5116819", "Fairview", "", "US", "840", "", "NY", "027", "", "41.7237", "-73.91986", "America/New_York"),("5116900", "Fallsburg", "", "US", "840", "", "NY", "105", "", "41.73204", "-74.60127", "America/New_York"),("5116931", "Farmingdale", "", "US", "840", "", "NY", "059", "", "40.7326", "-73.4454", "America/New_York"),("5116937", "Farmingville", "", "US", "840", "", "NY", "103", "", "40.83121", "-73.02955", "America/New_York"),("5117438", "Floral Park", "", "US", "840", "", "NY", "059", "", "40.72371", "-73.70485", "America/New_York"),("5117703", "Fort Salonga", "", "US", "840", "", "NY", "103", "", "40.9126", "-73.30095", "America/New_York"),("5117891", "Franklin Square", "", "US", "840", "", "NY", "059", "", "40.70732", "-73.67596", "America/New_York"),("5117926", "Fredonia", "", "US", "840", "", "NY", "013", "", "42.44006", "-79.33171", "America/New_York"),("5117949", "Freeport", "", "US", "840", "", "NY", "059", "", "40.6576", "-73.58318", "America/New_York"),("5118136", "Fulton", "", "US", "840", "", "NY", "075", "", "43.32285", "-76.41716", "America/New_York"),("5118226", "Garden City", "", "US", "840", "", "NY", "059", "", "40.72677", "-73.6343", "America/New_York"),("5118228", "Garden City Park", "", "US", "840", "", "NY", "059", "", "40.74093", "-73.66263", "America/New_York"),("5118394", "Geneseo", "", "US", "840", "", "NY", "051", "", "42.7959", "-77.81695", "America/New_York"),("5118398", "Geneva", "", "US", "840", "", "NY", "069", "", "42.86896", "-76.97774", "America/New_York"),("5118626", "Glen Cove", "Глен-Коув", "US", "840", "", "NY", "059", "", "40.86232", "-73.63374", "America/New_York"),("5118693", "Glens Falls", "", "US", "840", "", "NY", "113", "", "43.30952", "-73.64401", "America/New_York"),("5118743", "Gloversville", "", "US", "840", "", "NY", "035", "", "43.05285", "-74.34375", "America/New_York"),("5118920", "Goshen", "", "US", "840", "", "NY", "071", "", "41.40204", "-74.32432", "America/New_York"),("5119019", "Grand Island", "", "US", "840", "", "NY", "029", "", "43.03311", "-78.96254", "America/New_York"),("5119218", "Great Neck", "", "US", "840", "", "NY", "059", "", "40.80066", "-73.72846", "America/New_York"),("5119226", "Great Neck Plaza", "", "US", "840", "", "NY", "059", "", "40.78677", "-73.72652", "America/New_York"),("5119251", "Greece", "", "US", "840", "", "NY", "055", "", "43.20978", "-77.69306", "America/New_York"),("5119347", "Greenburgh", "", "US", "840", "", "NY", "119", "", "41.03287", "-73.84291", "America/New_York"),("5119377", "Greenlawn", "", "US", "840", "", "NY", "103", "", "40.86899", "-73.36512", "America/New_York"),("5119405", "Greenville", "", "US", "840", "", "NY", "119", "", "40.99315", "-73.81986", "America/New_York"),("5119833", "Hamburg", "", "US", "840", "", "NY", "029", "", "42.71589", "-78.82948", "America/New_York"),("5119868", "Hamlin", "", "US", "840", "", "NY", "055", "", "43.30312", "-77.92112", "America/New_York"),("5119899", "Hampton Bays", "", "US", "840", "", "NY", "103", "", "40.86899", "-72.51759", "America/New_York"),("5120074", "Harris Hill", "", "US", "840", "", "NY", "029", "", "42.96478", "-78.67753", "America/New_York"),("5120095", "Harrison", "Харрисон", "US", "840", "", "NY", "119", "", "40.96899", "-73.71263", "America/New_York"),("5120141", "Hartsdale", "", "US", "840", "", "NY", "119", "", "41.01899", "-73.79819", "America/New_York"),("5120197", "Hastings-on-Hudson", "", "US", "840", "", "NY", "119", "", "40.99454", "-73.87875", "America/New_York"),("5120228", "Hauppauge", "", "US", "840", "", "NY", "103", "", "40.82565", "-73.20261", "America/New_York"),("5120238", "Haverstraw", "", "US", "840", "", "NY", "087", "", "41.19759", "-73.96458", "America/New_York"),("5120478", "Hempstead", "Хемпстед", "US", "840", "", "NY", "059", "", "40.70621", "-73.61874", "America/New_York"),("5120479", "New Hempstead", "", "US", "840", "", "NY", "087", "", "41.14982", "-74.03375", "America/New_York"),("5120545", "Herkimer", "", "US", "840", "", "NY", "043", "", "43.02563", "-74.98599", "America/New_York"),("5120598", "Hewlett", "", "US", "840", "", "NY", "059", "", "40.64316", "-73.69569", "America/New_York"),("5120656", "Hicksville", "Хиксвилла", "US", "840", "", "NY", "059", "", "40.76843", "-73.52513", "America/New_York"),("5120741", "Highland", "", "US", "840", "", "NY", "111", "", "41.72093", "-73.96014", "America/New_York"),("5120797", "Hillcrest", "", "US", "840", "", "NY", "087", "", "41.12787", "-74.04097", "America/New_York"),("5120871", "Hilton", "", "US", "840", "", "NY", "055", "", "43.28812", "-77.79334", "America/New_York"),("5120987", "Holbrook", "Холбрук", "US", "840", "", "NY", "103", "", "40.81232", "-73.07844", "America/New_York"),("5121163", "Holtsville", "", "US", "840", "", "NY", "103", "", "40.81538", "-73.04511", "America/New_York"),("5121283", "Hornell", "", "US", "840", "", "NY", "101", "", "42.32785", "-77.6611", "America/New_York"),("5121309", "Horseheads", "", "US", "840", "", "NY", "015", "", "42.16702", "-76.82051", "America/New_York"),("5121509", "Hudson", "", "US", "840", "", "NY", "021", "", "42.25286", "-73.79096", "America/New_York"),("5121513", "Hudson Falls", "", "US", "840", "", "NY", "115", "", "43.30063", "-73.58595", "America/New_York"),("5121636", "Huntington", "Хантингтон", "US", "840", "", "NY", "103", "", "40.86815", "-73.42568", "America/New_York"),("5121650", "Huntington Station", "", "US", "840", "", "NY", "103", "", "40.85343", "-73.41151", "America/New_York"),("5121765", "Ilion", "", "US", "840", "", "NY", "043", "", "43.01507", "-75.03543", "America/New_York"),("5122279", "Inwood", "", "US", "840", "", "NY", "059", "", "40.62205", "-73.7468", "America/New_York"),("5122280", "Inwood", "", "US", "840", "", "NY", "061", "", "40.86566", "-73.9268", "America/New_York"),("5122331", "Irondequoit", "", "US", "840", "", "NY", "055", "", "43.2134", "-77.57972", "America/New_York"),("5122365", "Irvington", "", "US", "840", "", "NY", "119", "", "41.03922", "-73.86823", "America/New_York"),("5122413", "Islip", "", "US", "840", "", "NY", "103", "", "40.72982", "-73.21039", "America/New_York"),("5122417", "Islip Terrace", "", "US", "840", "", "NY", "103", "", "40.74315", "-73.19262", "America/New_York"),("5122432", "Ithaca", "Итак", "US", "840", "", "NY", "109", "", "42.44063", "-76.49661", "America/New_York"),("5122520", "Jamaica", "", "US", "840", "", "NY", "081", "", "40.69149", "-73.80569", "America/New_York"),("5122534", "Jamestown", "", "US", "840", "", "NY", "013", "", "42.097", "-79.23533", "America/New_York"),("5122638", "Jericho", "", "US", "840", "", "NY", "059", "", "40.79204", "-73.53985", "America/New_York"),("5122794", "Johnson City", "Джонсон Сити", "US", "840", "", "NY", "007", "", "42.11563", "-75.95881", "America/New_York"),("5122833", "Johnstown", "", "US", "840", "", "NY", "035", "", "43.00674", "-74.36764", "America/New_York"),("5123109", "Kaser", "", "US", "840", "", "NY", "087", "", "41.12121", "-74.06709", "America/New_York"),("5123247", "Kenmore", "", "US", "840", "", "NY", "029", "", "42.96589", "-78.87004", "America/New_York"),("5123456", "Kings Park", "", "US", "840", "", "NY", "103", "", "40.88621", "-73.25734", "America/New_York"),("5123459", "Kings Point", "", "US", "840", "", "NY", "059", "", "40.81982", "-73.73513", "America/New_York"),("5123477", "Kingston", "Кингстон", "US", "840", "", "NY", "111", "", "41.92704", "-73.99736", "America/New_York"),("5123533", "Kiryas Joel", "", "US", "840", "", "NY", "071", "", "41.34204", "-74.16792", "America/New_York"),("5123718", "Lackawanna", "", "US", "840", "", "NY", "029", "", "42.82561", "-78.82337", "America/New_York"),("5123777", "Lake Carmel", "", "US", "840", "", "NY", "079", "", "41.46148", "-73.67096", "America/New_York"),("5123796", "Lake Grove", "", "US", "840", "", "NY", "103", "", "40.85288", "-73.11511", "America/New_York"),("5123823", "Lake Mohegan", "", "US", "840", "", "NY", "119", "", "41.31787", "-73.84625", "America/New_York"),("5123840", "Lake Ronkonkoma", "", "US", "840", "", "NY", "103", "", "40.8351", "-73.13122", "America/New_York"),("5123907", "Lakeview", "", "US", "840", "", "NY", "017", "", "42.43202", "-75.86547", "America/New_York"),("5123908", "Lakeview", "", "US", "840", "", "NY", "059", "", "40.68538", "-73.65263", "America/New_York"),("5123954", "Lancaster", "", "US", "840", "", "NY", "029", "", "42.90061", "-78.67031", "America/New_York"),("5124017", "Larchmont", "", "US", "840", "", "NY", "119", "", "40.92788", "-73.7518", "America/New_York"),("5124087", "Lawrence", "", "US", "840", "", "NY", "059", "", "40.61566", "-73.72958", "America/New_York"),("5124276", "Levittown", "", "US", "840", "", "NY", "059", "", "40.72593", "-73.51429", "America/New_York"),("5124497", "Lindenhurst", "", "US", "840", "", "NY", "103", "", "40.68677", "-73.37345", "America/New_York"),("5125011", "Lockport", "", "US", "840", "", "NY", "063", "", "43.17061", "-78.69031", "America/New_York"),("5125086", "Long Beach", "Лонг-Бич", "US", "840", "", "NY", "059", "", "40.58844", "-73.65791", "America/New_York"),("5125125", "Long Island City", "Лонг-Айленд-Сити", "US", "840", "", "NY", "081", "", "40.74482", "-73.94875", "America/New_York"),("5125523", "Lynbrook", "", "US", "840", "", "NY", "059", "", "40.65483", "-73.6718", "America/New_York"),("5125657", "Mahopac", "", "US", "840", "", "NY", "079", "", "41.37232", "-73.73346", "America/New_York"),("5125717", "Malone", "", "US", "840", "", "NY", "033", "", "44.84866", "-74.2949", "America/New_York"),("5125734", "Malverne", "", "US", "840", "", "NY", "059", "", "40.67899", "-73.67402", "America/New_York"),("5125738", "Mamaroneck", "", "US", "840", "", "NY", "119", "", "40.94871", "-73.73263", "America/New_York"),("5125766", "Manhasset", "", "US", "840", "", "NY", "059", "", "40.79788", "-73.69957", "America/New_York"),("5125771", "Manhattan", "Манхеттен", "US", "840", "", "NY", "061", "", "40.78343", "-73.96625", "America/New_York"),("5125813", "Manorhaven", "", "US", "840", "", "NY", "059", "", "40.84316", "-73.71485", "America/New_York"),("5125817", "Manorville", "", "US", "840", "", "NY", "103", "", "40.87371", "-72.80788", "America/New_York"),("5125818", "Manorville", "", "US", "840", "", "NY", "111", "", "42.14231", "-74.03597", "America/New_York"),("5125973", "Marbletown", "", "US", "840", "", "NY", "111", "", "41.88343", "-74.1132", "America/New_York"),("5126183", "Massapequa", "", "US", "840", "", "NY", "059", "", "40.68066", "-73.47429", "America/New_York"),("5126187", "Massapequa Park", "", "US", "840", "", "NY", "059", "", "40.68038", "-73.45512", "America/New_York"),("5126194", "Massena", "", "US", "840", "", "NY", "089", "", "44.9281", "-74.89186", "America/New_York"),("5126208", "Mastic", "", "US", "840", "", "NY", "103", "", "40.80204", "-72.84094", "America/New_York"),("5126209", "Mastic Beach", "", "US", "840", "", "NY", "103", "", "40.76677", "-72.85205", "America/New_York"),("5126246", "Mattydale", "", "US", "840", "", "NY", "067", "", "43.09784", "-76.1452", "America/New_York"),("5126509", "Mechanicstown", "", "US", "840", "", "NY", "071", "", "41.44287", "-74.38849", "America/New_York"),("5126510", "Mechanicville", "", "US", "840", "", "NY", "091", "", "42.90285", "-73.68734", "America/New_York"),("5126518", "Medford", "Медфорд", "US", "840", "", "NY", "103", "", "40.8176", "-73.00011", "America/New_York"),("5126521", "Medina", "", "US", "840", "", "NY", "073", "", "43.22006", "-78.38697", "America/New_York"),("5126555", "Melville", "", "US", "840", "", "NY", "103", "", "40.79343", "-73.41512", "America/New_York"),("5126630", "Merrick", "Меррик", "US", "840", "", "NY", "059", "", "40.66288", "-73.55152", "America/New_York"),("5126787", "Middle Island", "", "US", "840", "", "NY", "103", "", "40.88427", "-72.93733", "America/New_York"),("5126842", "Middletown", "", "US", "840", "", "NY", "071", "", "41.44593", "-74.42293", "America/New_York"),("5127043", "Miller Place", "", "US", "840", "", "NY", "103", "", "40.95982", "-72.99621", "America/New_York"),("5127134", "Mineola", "", "US", "840", "", "NY", "059", "", "40.74927", "-73.64068", "America/New_York"),("5127302", "Monroe", "", "US", "840", "", "NY", "071", "", "41.33065", "-74.18681", "America/New_York"),("5127315", "Monsey", "", "US", "840", "", "NY", "087", "", "41.11121", "-74.06848", "America/New_York"),("5127359", "Monticello", "", "US", "840", "", "NY", "105", "", "41.65565", "-74.68933", "America/New_York"),("5127741", "Mount Ivy", "", "US", "840", "", "NY", "087", "", "41.18676", "-74.03486", "America/New_York"),("5127744", "Mount Kisco", "", "US", "840", "", "NY", "119", "", "41.20426", "-73.72708", "America/New_York"),("5127824", "Mount Sinai", "", "US", "840", "", "NY", "103", "", "40.94704", "-73.02955", "America/New_York"),("5127835", "Mount Vernon", "Маунт-Вернон", "US", "840", "", "NY", "119", "", "40.9126", "-73.83708", "America/New_York"),("5128238", "Myers Corner", "", "US", "840", "", "NY", "027", "", "41.6062", "-73.87291", "America/New_York"),("5128266", "Nanuet", "", "US", "840", "", "NY", "087", "", "41.08871", "-74.01347", "America/New_York"),("5128433", "Nesconset", "", "US", "840", "", "NY", "103", "", "40.85204", "-73.154", "America/New_York"),("5128478", "New Cassel", "", "US", "840", "", "NY", "059", "", "40.75899", "-73.56957", "America/New_York"),("5128481", "New City", "", "US", "840", "", "NY", "087", "", "41.1476", "-73.98931", "America/New_York"),("5128514", "New Hyde Park", "", "US", "840", "", "NY", "059", "", "40.7351", "-73.68791", "America/New_York"),("5128539", "New Paltz", "", "US", "840", "", "NY", "111", "", "41.74759", "-74.08681", "America/New_York"),("5128549", "New Rochelle", "Нью-Рошель", "US", "840", "", "NY", "119", "", "40.91149", "-73.78235", "America/New_York"),("5128568", "New Square", "", "US", "840", "", "NY", "087", "", "41.13956", "-74.02942", "America/New_York"),("5128577", "New Windsor", "", "US", "840", "", "NY", "071", "", "41.47676", "-74.02375", "America/New_York"),("5128581", "New York City", "Нью-Йорк", "US", "840", "", "NY", "", "", "40.71427", "-74.00597", "America/New_York"),("5128639", "Newark", "", "US", "840", "", "NY", "117", "", "43.04673", "-77.09525", "America/New_York"),("5128654", "Newburgh", "Ньюберг", "US", "840", "", "NY", "071", "", "41.50343", "-74.01042", "America/New_York"),("5128723", "Niagara Falls", "Ниагара-Фолс", "US", "840", "", "NY", "063", "", "43.0945", "-79.05671", "America/New_York"),("5128884", "North Amityville", "", "US", "840", "", "NY", "103", "", "40.6976", "-73.42512", "America/New_York"),("5128886", "North Babylon", "", "US", "840", "", "NY", "103", "", "40.71649", "-73.32179", "America/New_York"),("5128898", "North Bay Shore", "", "US", "840", "", "NY", "103", "", "40.73621", "-73.26262", "America/New_York"),("5128904", "North Bellmore", "", "US", "840", "", "NY", "059", "", "40.69149", "-73.53346", "America/New_York"),("5128905", "North Bellport", "", "US", "840", "", "NY", "103", "", "40.77427", "-72.94288", "America/New_York"),("5129029", "North Elba", "", "US", "840", "", "NY", "031", "", "44.24338", "-73.95431", "America/New_York"),("5129050", "North Gates", "", "US", "840", "", "NY", "055", "", "43.17645", "-77.70139", "America/New_York"),("5129093", "North Hills", "", "US", "840", "", "NY", "059", "", "40.78093", "-73.67652", "America/New_York"),("5129125", "North Lindenhurst", "", "US", "840", "", "NY", "103", "", "40.71427", "-73.38151", "America/New_York"),("5129134", "North Massapequa", "", "US", "840", "", "NY", "059", "", "40.70093", "-73.46207", "America/New_York"),("5129141", "North Merrick", "", "US", "840", "", "NY", "059", "", "40.69121", "-73.56318", "America/New_York"),("5129147", "North New Hyde Park", "", "US", "840", "", "NY", "059", "", "40.74316", "-73.69319", "America/New_York"),("5129157", "North Patchogue", "", "US", "840", "", "NY", "103", "", "40.78704", "-73.009", "America/New_York"),("5129242", "North Syracuse", "", "US", "840", "", "NY", "067", "", "43.13479", "-76.12992", "America/New_York"),("5129245", "North Tonawanda", "", "US", "840", "", "NY", "063", "", "43.03867", "-78.8642", "America/New_York"),("5129248", "North Valley Stream", "", "US", "840", "", "NY", "059", "", "40.6851", "-73.7018", "America/New_York"),("5129254", "North Wantagh", "", "US", "840", "", "NY", "059", "", "40.69343", "-73.50763", "America/New_York"),("5129290", "Northport", "", "US", "840", "", "NY", "103", "", "40.90093", "-73.34317", "America/New_York"),("5129310", "Northumberland", "", "US", "840", "", "NY", "091", "", "43.1273", "-73.58817", "America/New_York"),("5129359", "Norwich", "", "US", "840", "", "NY", "017", "", "42.53118", "-75.52351", "America/New_York"),("5129433", "Nyack", "", "US", "840", "", "NY", "087", "", "41.09065", "-73.91791", "America/New_York"),("5129540", "Oakdale", "", "US", "840", "", "NY", "021", "", "42.2512", "-73.78013", "America/New_York"),("5129541", "Oakdale", "", "US", "840", "", "NY", "103", "", "40.74399", "-73.13872", "America/New_York"),("5129603", "Oceanside", "", "US", "840", "", "NY", "059", "", "40.63871", "-73.64013", "America/New_York"),("5129626", "Ogdensburg", "", "US", "840", "", "NY", "089", "", "44.69423", "-75.48634", "America/New_York"),("5129662", "Old Bethpage", "", "US", "840", "", "NY", "059", "", "40.7626", "-73.45318", "America/New_York"),("5129780", "Olean", "", "US", "840", "", "NY", "009", "", "42.07756", "-78.42974", "America/New_York"),("5129837", "Oneida", "", "US", "840", "", "NY", "053", "", "43.09257", "-75.65129", "America/New_York"),("5129852", "Oneonta", "", "US", "840", "", "NY", "077", "", "42.45286", "-75.06377", "America/New_York"),("5129919", "Orange Lake", "", "US", "840", "", "NY", "071", "", "41.53982", "-74.0982", "America/New_York"),("5130045", "Ossining", "", "US", "840", "", "NY", "119", "", "41.16287", "-73.86152", "America/New_York"),("5130081", "Oswego", "Осуиго", "US", "840", "", "NY", "075", "", "43.45535", "-76.5105", "America/New_York"),("5130327", "Oyster Bay", "", "US", "840", "", "NY", "059", "", "40.86565", "-73.53207", "America/New_York"),("5130672", "Patchogue", "", "US", "840", "", "NY", "103", "", "40.76565", "-73.01511", "America/New_York"),("5130780", "Pearl River", "", "US", "840", "", "NY", "087", "", "41.05899", "-74.02181", "America/New_York"),("5130831", "Peekskill", "", "US", "840", "", "NY", "119", "", "41.29009", "-73.92042", "America/New_York"),("5130854", "Pelham", "", "US", "840", "", "NY", "119", "", "40.90982", "-73.80791", "America/New_York"),("5130862", "Pelham Manor", "", "US", "840", "", "NY", "119", "", "40.89538", "-73.80708", "America/New_York"),("5130915", "Penn Yan", "", "US", "840", "", "NY", "123", "", "42.6609", "-77.05386", "America/New_York"),("5131628", "Plainedge", "", "US", "840", "", "NY", "059", "", "40.71732", "-73.48374", "America/New_York"),("5131638", "Plainview", "", "US", "840", "", "NY", "059", "", "40.77649", "-73.46735", "America/New_York"),("5131692", "Plattsburgh", "Платтсбург", "US", "840", "", "NY", "019", "", "44.69949", "-73.45291", "America/New_York"),("5131757", "Pleasantville", "", "US", "840", "", "NY", "119", "", "41.13287", "-73.79263", "America/New_York"),("5132002", "Port Chester", "", "US", "840", "", "NY", "119", "", "41.00176", "-73.66568", "America/New_York"),("5132013", "Port Jefferson", "", "US", "840", "", "NY", "103", "", "40.94649", "-73.06927", "America/New_York"),("5132015", "Port Jefferson Station", "", "US", "840", "", "NY", "103", "", "40.92538", "-73.04733", "America/New_York"),("5132016", "Port Jervis", "", "US", "840", "", "NY", "071", "", "41.37509", "-74.69266", "America/New_York"),("5132029", "Port Washington", "", "US", "840", "", "NY", "059", "", "40.82566", "-73.69819", "America/New_York"),("5132103", "Potsdam", "", "US", "840", "", "NY", "089", "", "44.66978", "-74.98131", "America/New_York"),("5132143", "Poughkeepsie", "", "US", "840", "", "NY", "027", "", "41.70037", "-73.92097", "America/New_York"),("5132152", "Pound Ridge", "", "US", "840", "", "NY", "119", "", "41.20871", "-73.57485", "America/New_York"),("5133273", "Borough of Queens", "", "US", "840", "", "NY", "081", "", "40.68149", "-73.83652", "America/New_York"),("5133279", "Queensbury", "", "US", "840", "", "NY", "113", "", "43.37729", "-73.61317", "America/New_York"),("5133667", "Rensselaer", "", "US", "840", "", "NY", "083", "", "42.64258", "-73.7429", "America/New_York"),("5133799", "Richland", "", "US", "840", "", "NY", "075", "", "43.56951", "-76.0477", "America/New_York"),("5133832", "Ridge", "", "US", "840", "", "NY", "103", "", "40.89399", "-72.89594", "America/New_York"),("5133926", "Riverhead", "", "US", "840", "", "NY", "103", "", "40.91704", "-72.66204", "America/New_York"),("5134086", "Rochester", "Рочестер", "US", "840", "", "NY", "055", "", "43.15478", "-77.61556", "America/New_York"),("5134203", "Rockville Centre", "", "US", "840", "", "NY", "059", "", "40.65871", "-73.64124", "America/New_York"),("5134235", "Rocky Point", "", "US", "840", "", "NY", "103", "", "40.9526", "-72.92538", "America/New_York"),("5134257", "Roessleville", "", "US", "840", "", "NY", "001", "", "42.69508", "-73.80707", "America/New_York"),("5134295", "Rome", "Рим", "US", "840", "", "NY", "065", "", "43.21285", "-75.45573", "America/New_York"),("5134316", "Ronkonkoma", "", "US", "840", "", "NY", "103", "", "40.81538", "-73.11233", "America/New_York"),("5134323", "Roosevelt", "", "US", "840", "", "NY", "059", "", "40.67871", "-73.58902", "America/New_York"),("5134420", "Roslyn Heights", "", "US", "840", "", "NY", "059", "", "40.78871", "-73.64735", "America/New_York"),("5134453", "Rotterdam", "", "US", "840", "", "NY", "093", "", "42.78702", "-73.97096", "America/New_York"),("5134693", "Rye", "", "US", "840", "", "NY", "119", "", "40.98065", "-73.68374", "America/New_York"),("5134696", "Rye Brook", "", "US", "840", "", "NY", "119", "", "41.01926", "-73.68346", "America/New_York"),("5135192", "Saint James", "", "US", "840", "", "NY", "103", "", "40.87899", "-73.15678", "America/New_York"),("5136088", "Salamanca", "", "US", "840", "", "NY", "009", "", "42.15784", "-78.71503", "America/New_York"),("5136107", "Salisbury", "", "US", "840", "", "NY", "059", "", "40.74566", "-73.56013", "America/New_York"),("5136322", "Saranac Lake", "", "US", "840", "", "NY", "033", "", "44.3295", "-74.13127", "America/New_York"),("5136334", "Saratoga Springs", "Саратога-Спрингс", "US", "840", "", "NY", "091", "", "43.08313", "-73.78457", "America/New_York"),("5136421", "Sayville", "", "US", "840", "", "NY", "103", "", "40.73593", "-73.08206", "America/New_York"),("5136433", "Scarsdale", "", "US", "840", "", "NY", "119", "", "41.0051", "-73.78458", "America/New_York"),("5136454", "Schenectady", "Скенектади", "US", "840", "", "NY", "093", "", "42.81424", "-73.93957", "America/New_York"),("5137421", "Scotchtown", "", "US", "840", "", "NY", "071", "", "41.48148", "-74.36015", "America/New_York"),("5137423", "Scotia", "", "US", "840", "", "NY", "093", "", "42.82647", "-73.96429", "America/New_York"),("5137484", "Sea Cliff", "", "US", "840", "", "NY", "059", "", "40.84899", "-73.64485", "America/New_York"),("5137507", "Seaford", "", "US", "840", "", "NY", "059", "", "40.66593", "-73.48818", "America/New_York"),("5137600", "Selden", "Селден", "US", "840", "", "NY", "103", "", "40.86649", "-73.03566", "America/New_York"),("5137622", "Seneca Falls", "", "US", "840", "", "NY", "099", "", "42.91062", "-76.79662", "America/New_York"),("5138022", "Shirley", "Ширли", "US", "840", "", "NY", "103", "", "40.80149", "-72.8676", "America/New_York"),("5138371", "Sleepy Hollow", "", "US", "840", "", "NY", "119", "", "41.08565", "-73.85847", "America/New_York"),("5138539", "Smithtown", "", "US", "840", "", "NY", "103", "", "40.85593", "-73.20067", "America/New_York"),("5138674", "Solvay", "", "US", "840", "", "NY", "067", "", "43.05812", "-76.20743", "America/New_York"),("5138704", "Sound Beach", "", "US", "840", "", "NY", "103", "", "40.95621", "-72.96788", "America/New_York"),("5138837", "South Farmingdale", "", "US", "840", "", "NY", "059", "", "40.72066", "-73.44012", "America/New_York"),("5138884", "South Hill", "", "US", "840", "", "NY", "109", "", "42.42924", "-76.49494", "America/New_York"),("5138892", "South Huntington", "", "US", "840", "", "NY", "103", "", "40.82371", "-73.39873", "America/New_York"),("5138918", "South Lockport", "", "US", "840", "", "NY", "063", "", "43.15006", "-78.6967", "America/New_York"),("5139015", "South Valley Stream", "", "US", "840", "", "NY", "059", "", "40.65594", "-73.71763", "America/New_York"),("5139054", "Southold", "", "US", "840", "", "NY", "103", "", "41.06482", "-72.4262", "America/New_York"),("5139058", "Southport", "", "US", "840", "", "NY", "015", "", "42.0548", "-76.81912", "America/New_York"),("5139294", "Springs", "", "US", "840", "", "NY", "103", "", "41.01621", "-72.15924", "America/New_York"),("5139301", "Spring Valley", "Спринг-Вэлли", "US", "840", "", "NY", "087", "", "41.11315", "-74.04375", "America/New_York"),("5139568", "Staten Island", "", "US", "840", "", "NY", "085", "", "40.56233", "-74.13986", "America/New_York"),("5139865", "Stony Brook", "", "US", "840", "", "NY", "103", "", "40.92565", "-73.14094", "America/New_York"),("5139927", "Stony Point", "", "US", "840", "", "NY", "087", "", "41.22954", "-73.98708", "America/New_York"),("5140072", "Suffern", "", "US", "840", "", "NY", "087", "", "41.11482", "-74.14959", "America/New_York"),("5140402", "Syosset", "", "US", "840", "", "NY", "059", "", "40.82621", "-73.50207", "America/New_York"),("5140405", "Syracuse", "Сиракьюс", "US", "840", "", "NY", "067", "", "43.04812", "-76.14742", "America/New_York"),("5140532", "Tappan", "", "US", "840", "", "NY", "087", "", "41.02204", "-73.94736", "America/New_York"),("5140538", "Tarrytown", "", "US", "840", "", "NY", "119", "", "41.07621", "-73.85875", "America/New_York"),("5140694", "Terryville", "", "US", "840", "", "NY", "103", "", "40.90899", "-73.06511", "America/New_York"),("5140789", "Thiells", "", "US", "840", "", "NY", "087", "", "41.21065", "-74.01764", "America/New_York"),("5141175", "Tonawanda", "", "US", "840", "", "NY", "029", "", "43.02033", "-78.88031", "America/New_York"),("5141502", "Troy", "Троя", "US", "840", "", "NY", "083", "", "42.72841", "-73.69179", "America/New_York"),("5141528", "Tuckahoe", "", "US", "840", "", "NY", "119", "", "40.95038", "-73.82736", "America/New_York"),("5141927", "Uniondale", "", "US", "840", "", "NY", "059", "", "40.70038", "-73.59291", "America/New_York"),("5142056", "Utica", "", "US", "840", "", "NY", "065", "", "43.1009", "-75.23266", "America/New_York"),("5142101", "Valley Cottage", "", "US", "840", "", "NY", "087", "", "41.11815", "-73.95542", "America/New_York"),("5142109", "Valley Stream", "", "US", "840", "", "NY", "059", "", "40.66427", "-73.70846", "America/New_York"),("5142362", "Viola", "", "US", "840", "", "NY", "087", "", "41.13648", "-74.08236", "America/New_York"),("5142408", "Volney", "", "US", "840", "", "NY", "075", "", "43.34285", "-76.35771", "America/New_York"),("5143022", "Wading River", "", "US", "840", "", "NY", "103", "", "40.95038", "-72.8426", "America/New_York"),("5143066", "Walden", "", "US", "840", "", "NY", "071", "", "41.5612", "-74.18848", "America/New_York"),("5143198", "Wantagh", "", "US", "840", "", "NY", "059", "", "40.68371", "-73.51013", "America/New_York"),("5143211", "Wappingers Falls", "", "US", "840", "", "NY", "027", "", "41.59648", "-73.91097", "America/New_York"),("5143285", "Warwick", "", "US", "840", "", "NY", "071", "", "41.25648", "-74.35988", "America/New_York"),("5143344", "Washingtonville", "", "US", "840", "", "NY", "071", "", "41.42787", "-74.16598", "America/New_York"),("5143380", "Waterloo", "", "US", "840", "", "NY", "099", "", "42.90479", "-76.86274", "America/New_York"),("5143396", "Watertown", "", "US", "840", "", "NY", "045", "", "43.97478", "-75.91076", "America/New_York"),("5143443", "Wawarsing", "", "US", "840", "", "NY", "111", "", "41.75898", "-74.35738", "America/New_York"),("5143495", "Webster", "", "US", "840", "", "NY", "055", "", "43.21229", "-77.42999", "America/New_York"),("5143610", "Wesley Hills", "", "US", "840", "", "NY", "087", "", "41.15926", "-74.06986", "America/New_York"),("5143620", "West Albany", "", "US", "840", "", "NY", "001", "", "42.68313", "-73.77845", "America/New_York"),("5143630", "West Babylon", "", "US", "840", "", "NY", "103", "", "40.71816", "-73.35429", "America/New_York"),("5143817", "West Glens Falls", "", "US", "840", "", "NY", "113", "", "43.30007", "-73.68401", "America/New_York"),("5143830", "West Haverstraw", "", "US", "840", "", "NY", "087", "", "41.20954", "-73.98542", "America/New_York"),("5143832", "West Hempstead", "", "US", "840", "", "NY", "059", "", "40.70482", "-73.65013", "America/New_York"),("5143857", "West Hills", "", "US", "840", "", "NY", "103", "", "40.81621", "-73.43234", "America/New_York"),("5143866", "West Islip", "", "US", "840", "", "NY", "103", "", "40.70621", "-73.30623", "America/New_York"),("5143966", "West Point", "", "US", "840", "", "NY", "071", "", "41.39148", "-73.95597", "America/New_York"),("5143988", "West Sayville", "", "US", "840", "", "NY", "103", "", "40.72788", "-73.09761", "America/New_York"),("5143992", "West Seneca", "", "US", "840", "", "NY", "029", "", "42.85006", "-78.79975", "America/New_York"),("5144040", "Westbury", "", "US", "840", "", "NY", "059", "", "40.75566", "-73.58763", "America/New_York"),("5144097", "Westmere", "", "US", "840", "", "NY", "001", "", "42.69119", "-73.86873", "America/New_York"),("5144182", "Wheatley Heights", "", "US", "840", "", "NY", "103", "", "40.76371", "-73.36984", "America/New_York"),("5144336", "White Plains", "Уайт-Плейнс", "US", "840", "", "NY", "119", "", "41.03399", "-73.76291", "America/New_York"),("5144588", "Williamsville", "", "US", "840", "", "NY", "029", "", "42.96395", "-78.73781", "America/New_York"),("5144606", "Williston Park", "", "US", "840", "", "NY", "059", "", "40.75649", "-73.64485", "America/New_York"),("5144947", "Woodbury", "", "US", "840", "", "NY", "059", "", "40.82565", "-73.46762", "America/New_York"),("5144948", "Woodbury", "", "US", "840", "", "NY", "071", "", "41.36454", "-74.10598", "America/New_York"),("5145028", "Woodmere", "", "US", "840", "", "NY", "059", "", "40.63205", "-73.71263", "America/New_York"),("5145135", "Wyandanch", "", "US", "840", "", "NY", "103", "", "40.75399", "-73.3604", "America/New_York"),("5145197", "Yaphank", "", "US", "840", "", "NY", "103", "", "40.83677", "-72.91705", "America/New_York"),("5145215", "Yonkers", "Йонкерс", "US", "840", "", "NY", "119", "", "40.93121", "-73.89875", "America/New_York"),("5145374", "Ada", "", "US", "840", "", "OH", "065", "", "40.7695", "-83.82271", "America/New_York"),("5145476", "Akron", "Акрон", "US", "840", "", "OH", "153", "", "41.08144", "-81.51901", "America/New_York"),("5145607", "Alliance", "Альянс", "US", "840", "", "OH", "151", "", "40.91534", "-81.10593", "America/New_York"),("5145695", "Amherst", "", "US", "840", "", "OH", "093", "", "41.39782", "-82.22238", "America/New_York"),("5146055", "Ashland", "Ашленд", "US", "840", "", "OH", "005", "", "40.86867", "-82.31822", "America/New_York"),("5146089", "Ashtabula", "", "US", "840", "", "OH", "007", "", "41.86505", "-80.78981", "America/New_York"),("5146233", "Aurora", "Аврора", "US", "840", "", "OH", "133", "", "41.31755", "-81.34539", "America/New_York"),("5146256", "Austintown", "", "US", "840", "", "OH", "099", "", "41.10172", "-80.76452", "America/New_York"),("5146277", "Avon", "", "US", "840", "", "OH", "093", "", "41.45171", "-82.03542", "America/New_York"),("5146282", "Avon Center", "", "US", "840", "", "OH", "093", "", "41.45976", "-82.01959", "America/New_York"),("5146286", "Avon Lake", "", "US", "840", "", "OH", "093", "", "41.50532", "-82.0282", "America/New_York"),("5146491", "Barberton", "", "US", "840", "", "OH", "153", "", "41.01283", "-81.60512", "America/New_York"),("5146675", "Bay Village", "", "US", "840", "", "OH", "035", "", "41.48477", "-81.92208", "America/New_York"),("5146711", "Beachwood", "", "US", "840", "", "OH", "035", "", "41.4645", "-81.50873", "America/New_York"),("5146831", "Bedford", "", "US", "840", "", "OH", "035", "", "41.39311", "-81.53651", "America/New_York"),("5146840", "Bedford Heights", "", "US", "840", "", "OH", "035", "", "41.417", "-81.52734", "America/New_York"),("5146965", "Bellefontaine", "", "US", "840", "", "OH", "091", "", "40.36116", "-83.75966", "America/New_York"),("5146978", "Bellevue", "", "US", "840", "", "OH", "077", "", "41.27366", "-82.84158", "America/New_York"),("5147097", "Berea", "Береа", "US", "840", "", "OH", "035", "", "41.36616", "-81.8543", "America/New_York"),("5147784", "Boardman", "Бордман", "US", "840", "", "OH", "099", "", "41.02423", "-80.66285", "America/New_York"),("5147968", "Bowling Green", "Боулинг-Грин", "US", "840", "", "OH", "173", "", "41.37477", "-83.65132", "America/New_York"),("5148115", "Brecksville", "", "US", "840", "", "OH", "035", "", "41.31978", "-81.62679", "America/New_York"),("5148273", "Broadview Heights", "", "US", "840", "", "OH", "035", "", "41.31394", "-81.68513", "America/New_York"),("5148326", "Brook Park", "", "US", "840", "", "OH", "035", "", "41.39838", "-81.80458", "America/New_York"),("5148346", "Brooklyn", "", "US", "840", "", "OH", "035", "", "41.43977", "-81.73541", "America/New_York"),("5148480", "Brunswick", "Брауншвейг", "US", "840", "", "OH", "103", "", "41.23811", "-81.8418", "America/New_York"),("5148533", "Bryan", "", "US", "840", "", "OH", "171", "", "41.47477", "-84.55245", "America/New_York"),("5148635", "Bucyrus", "", "US", "840", "", "OH", "033", "", "40.80839", "-82.97546", "America/New_York"),("5149007", "Cambridge", "", "US", "840", "", "OH", "059", "", "40.03118", "-81.58846", "America/New_York"),("5149149", "Campbell", "", "US", "840", "", "OH", "099", "", "41.07839", "-80.59924", "America/New_York"),("5149188", "Canal Fulton", "", "US", "840", "", "OH", "151", "", "40.88978", "-81.59762", "America/New_York"),("5149205", "Canfield", "", "US", "840", "", "OH", "099", "", "41.02506", "-80.76091", "America/New_York"),("5149222", "Canton", "", "US", "840", "", "OH", "151", "", "40.79895", "-81.37845", "America/New_York"),("5149493", "Celina", "", "US", "840", "", "OH", "107", "", "40.54894", "-84.57023", "America/New_York"),("5149818", "Chardon", "", "US", "840", "", "OH", "055", "", "41.61422", "-81.14899", "America/New_York"),("5150529", "Cleveland", "Кливленд", "US", "840", "", "OH", "035", "", "41.4995", "-81.69541", "America/New_York"),("5150651", "Clyde", "", "US", "840", "", "OH", "143", "", "41.30422", "-82.97519", "America/New_York"),("5150851", "Columbiana", "", "US", "840", "", "OH", "029", "", "40.88839", "-80.69396", "America/New_York"),("5150986", "Conneaut", "", "US", "840", "", "OH", "007", "", "41.94756", "-80.55424", "America/New_York"),("5151174", "Cortland", "", "US", "840", "", "OH", "155", "", "41.33033", "-80.72536", "America/New_York"),("5151186", "Coshocton", "", "US", "840", "", "OH", "031", "", "40.27202", "-81.85958", "America/New_York"),("5151613", "Cuyahoga Falls", "Каяхога-Фолс", "US", "840", "", "OH", "153", "", "41.13394", "-81.48456", "America/New_York"),("5151861", "Defiance", "", "US", "840", "", "OH", "039", "", "41.28449", "-84.35578", "America/New_York"),("5151891", "Delaware", "Делаварский", "US", "840", "", "OH", "041", "", "40.29867", "-83.06797", "America/New_York"),("5151941", "Delphos", "", "US", "840", "", "OH", "003", "", "40.84338", "-84.34162", "America/New_York"),("5152243", "Dover", "", "US", "840", "", "OH", "157", "", "40.52062", "-81.47401", "America/New_York"),("5152333", "Dublin", "Дублин", "US", "840", "", "OH", "049", "", "40.09923", "-83.11408", "America/New_York"),("5152599", "East Cleveland", "", "US", "840", "", "OH", "035", "", "41.53311", "-81.57901", "America/New_York"),("5152709", "East Liverpool", "", "US", "840", "", "OH", "029", "", "40.61868", "-80.57729", "America/New_York"),("5152833", "Eastlake", "", "US", "840", "", "OH", "085", "", "41.65394", "-81.45039", "America/New_York"),("5153207", "Elyria", "Элирия", "US", "840", "", "OH", "093", "", "41.36838", "-82.10765", "America/New_York"),("5153420", "Euclid", "Евклид", "US", "840", "", "OH", "035", "", "41.5931", "-81.52679", "America/New_York"),("5153592", "Fairlawn", "", "US", "840", "", "OH", "153", "", "41.12783", "-81.60984", "America/New_York"),("5153680", "Fairview Park", "", "US", "840", "", "OH", "035", "", "41.44144", "-81.8643", "America/New_York"),("5153924", "Findlay", "Финдли", "US", "840", "", "OH", "063", "", "41.04422", "-83.64993", "America/New_York"),("5154905", "Fostoria", "", "US", "840", "", "OH", "147", "", "41.157", "-83.41687", "America/New_York"),("5155207", "Fremont", "Фримонт", "US", "840", "", "OH", "143", "", "41.35033", "-83.12186", "America/New_York"),("5155393", "Gahanna", "", "US", "840", "", "OH", "049", "", "40.01923", "-82.87934", "America/New_York"),("5155414", "Galion", "", "US", "840", "", "OH", "033", "", "40.73367", "-82.7899", "America/New_York"),("5155499", "Garfield Heights", "", "US", "840", "", "OH", "035", "", "41.417", "-81.60596", "America/New_York"),("5155572", "Geneva", "", "US", "840", "", "OH", "007", "", "41.80505", "-80.94815", "America/New_York"),("5155755", "Girard", "", "US", "840", "", "OH", "155", "", "41.15395", "-80.70147", "America/New_York"),("5156170", "Grafton", "", "US", "840", "", "OH", "093", "", "41.27255", "-82.05459", "America/New_York"),("5156270", "Granville", "", "US", "840", "", "OH", "089", "", "40.06812", "-82.5196", "America/New_York"),("5156371", "Green", "", "US", "840", "", "OH", "153", "", "40.94589", "-81.48317", "America/New_York"),("5156493", "Greenville", "", "US", "840", "", "OH", "037", "", "40.10283", "-84.63301", "America/New_York"),("5157262", "Heath", "", "US", "840", "", "OH", "089", "", "40.02284", "-82.4446", "America/New_York"),("5157497", "Highland Heights", "", "US", "840", "", "OH", "035", "", "41.552", "-81.47845", "America/New_York"),("5157588", "Hilliard", "", "US", "840", "", "OH", "049", "", "40.0334", "-83.15825", "America/New_York"),("5158123", "Howland Center", "", "US", "840", "", "OH", "155", "", "41.25117", "-80.74536", "America/New_York"),("5158143", "Hubbard", "", "US", "840", "", "OH", "155", "", "41.15645", "-80.56924", "America/New_York"),("5158164", "Hudson", "Гудзон", "US", "840", "", "OH", "153", "", "41.24006", "-81.44067", "America/New_York"),("5158298", "Huron", "", "US", "840", "", "OH", "043", "", "41.39505", "-82.55517", "America/New_York"),("5158404", "Independence", "", "US", "840", "", "OH", "035", "", "41.36866", "-81.6379", "America/New_York"),("5159537", "Kent", "Кент", "US", "840", "", "OH", "133", "", "41.15367", "-81.35789", "America/New_York"),("5159554", "Kenton", "", "US", "840", "", "OH", "065", "", "40.647", "-83.60965", "America/New_York"),("5159809", "Kirtland", "", "US", "840", "", "OH", "085", "", "41.62894", "-81.3615", "America/New_York"),("5160315", "Lakewood", "Лейквуд", "US", "840", "", "OH", "035", "", "41.48199", "-81.79819", "America/New_York"),("5160622", "Lewis Center", "", "US", "840", "", "OH", "041", "", "40.1984", "-83.01018", "America/New_York"),("5160783", "Lima", "Лима", "US", "840", "", "OH", "003", "", "40.74255", "-84.10523", "America/New_York"),("5161262", "Lorain", "Лорейн", "US", "840", "", "OH", "093", "", "41.45282", "-82.18237", "America/New_York"),("5161347", "Louisville", "", "US", "840", "", "OH", "151", "", "40.83728", "-81.25955", "America/New_York"),("5161493", "Lyndhurst", "", "US", "840", "", "OH", "035", "", "41.52005", "-81.48873", "America/New_York"),("5161539", "Macedonia", "", "US", "840", "", "OH", "153", "", "41.31367", "-81.50845", "America/New_York"),("5161723", "Mansfield", "Мэнсфилд", "US", "840", "", "OH", "139", "", "40.75839", "-82.51545", "America/New_York"),("5161803", "Maple Heights", "", "US", "840", "", "OH", "035", "", "41.41533", "-81.56596", "America/New_York"),("5161902", "Marion", "Мэрион", "US", "840", "", "OH", "101", "", "40.58867", "-83.12852", "America/New_York"),("5162044", "Martins Ferry", "", "US", "840", "", "OH", "013", "", "40.09591", "-80.72453", "America/New_York"),("5162077", "Marysville", "", "US", "840", "", "OH", "159", "", "40.23645", "-83.36714", "America/New_York"),("5162097", "Massillon", "", "US", "840", "", "OH", "151", "", "40.79672", "-81.52151", "America/New_York"),("5162137", "Maumee", "", "US", "840", "", "OH", "095", "", "41.56283", "-83.65382", "America/New_York"),("5162188", "Mayfield Heights", "", "US", "840", "", "OH", "035", "", "41.51922", "-81.4579", "America/New_York"),("5162512", "Medina", "Медина", "US", "840", "", "OH", "103", "", "41.13839", "-81.86375", "America/New_York"),("5162645", "Mentor", "Ментор", "US", "840", "", "OH", "085", "", "41.66616", "-81.33955", "America/New_York"),("5162672", "Mentor-on-the-Lake", "", "US", "840", "", "OH", "085", "", "41.70504", "-81.36039", "America/New_York"),("5162851", "Middleburg Heights", "", "US", "840", "", "OH", "035", "", "41.36144", "-81.81291", "America/New_York"),("5163799", "Mount Vernon", "", "US", "840", "", "OH", "083", "", "40.3934", "-82.48572", "America/New_York"),("5163968", "Munroe Falls", "", "US", "840", "", "OH", "153", "", "41.1445", "-81.43983", "America/New_York"),("5164057", "Napoleon", "", "US", "840", "", "OH", "069", "", "41.39227", "-84.12522", "America/New_York"),("5164202", "New Albany", "", "US", "840", "", "OH", "049", "", "40.08117", "-82.80879", "America/New_York"),("5164274", "New Franklin", "", "US", "840", "", "OH", "153", "", "40.94172", "-81.54151", "America/New_York"),("5164390", "New Philadelphia", "", "US", "840", "", "OH", "157", "", "40.48979", "-81.44567", "America/New_York"),("5164466", "Newark", "Ньюарк", "US", "840", "", "OH", "089", "", "40.05812", "-82.40126", "America/New_York"),("5164582", "Niles", "", "US", "840", "", "OH", "155", "", "41.18284", "-80.76536", "America/New_York"),("5164706", "North Canton", "", "US", "840", "", "OH", "151", "", "40.87589", "-81.40234", "America/New_York"),("5164840", "North Madison", "", "US", "840", "", "OH", "085", "", "41.802", "-81.04899", "America/New_York"),("5164862", "North Olmsted", "", "US", "840", "", "OH", "035", "", "41.4156", "-81.92347", "America/New_York"),("5164903", "North Ridgeville", "", "US", "840", "", "OH", "093", "", "41.38949", "-82.01903", "America/New_York"),("5164916", "North Royalton", "", "US", "840", "", "OH", "035", "", "41.31366", "-81.72457", "America/New_York"),("5165067", "Northwood", "", "US", "840", "", "OH", "091", "", "40.47283", "-83.73243", "America/New_York"),("5165069", "Northwood", "", "US", "840", "", "OH", "173", "", "41.60727", "-83.46882", "America/New_York"),("5165087", "Norton", "", "US", "840", "", "OH", "153", "", "41.02922", "-81.63818", "America/New_York"),("5165101", "Norwalk", "", "US", "840", "", "OH", "077", "", "41.24255", "-82.61573", "America/New_York"),("5165445", "Oberlin", "", "US", "840", "", "OH", "093", "", "41.29394", "-82.21738", "America/New_York"),("5165635", "Olmsted Falls", "", "US", "840", "", "OH", "035", "", "41.37505", "-81.90819", "America/New_York"),("5165664", "Ontario", "", "US", "840", "", "OH", "139", "", "40.7595", "-82.59017", "America/New_York"),("5165734", "Oregon", "Орегон", "US", "840", "", "OH", "095", "", "41.64366", "-83.48688", "America/New_York"),("5165755", "Orrville", "", "US", "840", "", "OH", "169", "", "40.84367", "-81.76402", "America/New_York"),("5166009", "Painesville", "", "US", "840", "", "OH", "085", "", "41.72449", "-81.24566", "America/New_York"),("5166177", "Parma", "Парма", "US", "840", "", "OH", "035", "", "41.40477", "-81.72291", "America/New_York"),("5166184", "Parma Heights", "", "US", "840", "", "OH", "035", "", "41.39005", "-81.75958", "America/New_York"),("5166438", "Pepper Pike", "", "US", "840", "", "OH", "035", "", "41.47839", "-81.46373", "America/New_York"),("5166482", "Perry Heights", "", "US", "840", "", "OH", "151", "", "40.79534", "-81.47345", "America/New_York"),("5166516", "Perrysburg", "", "US", "840", "", "OH", "173", "", "41.557", "-83.62716", "America/New_York"),("5166819", "Piqua", "", "US", "840", "", "OH", "109", "", "40.14477", "-84.24244", "America/New_York"),("5167259", "Port Clinton", "", "US", "840", "", "OH", "123", "", "41.512", "-82.93769", "America/New_York"),("5167293", "Portage Lakes", "", "US", "840", "", "OH", "153", "", "41.00728", "-81.52706", "America/New_York"),("5167350", "Powell", "", "US", "840", "", "OH", "041", "", "40.15784", "-83.07519", "America/New_York"),("5167737", "Ravenna", "", "US", "840", "", "OH", "133", "", "41.15756", "-81.24205", "America/New_York"),("5168063", "Richmond Heights", "", "US", "840", "", "OH", "035", "", "41.55283", "-81.51012", "America/New_York"),("5168225", "Rittman", "", "US", "840", "", "OH", "169", "", "40.97811", "-81.78208", "America/New_York"),("5168491", "Rocky River", "", "US", "840", "", "OH", "035", "", "41.4756", "-81.8393", "America/New_York"),("5168673", "Rossford", "", "US", "840", "", "OH", "173", "", "41.60977", "-83.56438", "America/New_York"),("5169130", "Saint Clairsville", "", "US", "840", "", "OH", "013", "", "40.08063", "-80.90009", "America/New_York"),("5169796", "Saint Marys", "", "US", "840", "", "OH", "011", "", "40.54227", "-84.3894", "America/New_York"),("5170511", "Salem", "", "US", "840", "", "OH", "029", "", "40.90089", "-80.85675", "America/New_York"),("5170691", "Sandusky", "", "US", "840", "", "OH", "043", "", "41.44894", "-82.70796", "America/New_York"),("5171657", "Seven Hills", "", "US", "840", "", "OH", "035", "", "41.39533", "-81.67624", "America/New_York"),("5171728", "Shaker Heights", "", "US", "840", "", "OH", "035", "", "41.47394", "-81.53707", "America/New_York"),("5171856", "Sheffield Lake", "", "US", "840", "", "OH", "093", "", "41.48754", "-82.10154", "America/New_York"),("5171868", "Shelby", "", "US", "840", "", "OH", "139", "", "40.88145", "-82.66184", "America/New_York"),("5172078", "Sidney", "Сидней", "US", "840", "", "OH", "149", "", "40.28422", "-84.1555", "America/New_York"),("5172387", "Solon", "Солон", "US", "840", "", "OH", "035", "", "41.38978", "-81.44123", "America/New_York"),("5172485", "South Euclid", "", "US", "840", "", "OH", "035", "", "41.52311", "-81.51846", "America/New_York"),("5173048", "Steubenville", "", "US", "840", "", "OH", "081", "", "40.36979", "-80.63396", "America/New_York"),("5173171", "Stow", "Стоу", "US", "840", "", "OH", "153", "", "41.1595", "-81.44039", "America/New_York"),("5173210", "Streetsboro", "", "US", "840", "", "OH", "133", "", "41.23922", "-81.34594", "America/New_York"),("5173237", "Strongsville", "", "US", "840", "", "OH", "035", "", "41.3145", "-81.83569", "America/New_York"),("5173256", "Struthers", "", "US", "840", "", "OH", "099", "", "41.05256", "-80.60785", "America/New_York"),("5173412", "Sunbury", "", "US", "840", "", "OH", "041", "", "40.24256", "-82.85907", "America/New_York"),("5173572", "Sylvania", "", "US", "840", "", "OH", "095", "", "41.71894", "-83.71299", "America/New_York"),("5173623", "Tallmadge", "", "US", "840", "", "OH", "153", "", "41.10145", "-81.44178", "America/New_York"),("5173930", "Tiffin", "", "US", "840", "", "OH", "147", "", "41.1145", "-83.17797", "America/New_York"),("5174035", "Toledo", "Толедо", "US", "840", "", "OH", "095", "", "41.66394", "-83.55521", "America/New_York"),("5174358", "Troy", "Троя", "US", "840", "", "OH", "109", "", "40.0395", "-84.20328", "America/New_York"),("5174550", "Twinsburg", "", "US", "840", "", "OH", "153", "", "41.31256", "-81.44011", "America/New_York"),("5174585", "Uhrichsville", "", "US", "840", "", "OH", "157", "", "40.39312", "-81.3465", "America/New_York"),("5174830", "University Heights", "", "US", "840", "", "OH", "035", "", "41.49783", "-81.53735", "America/New_York"),("5174870", "Upper Sandusky", "", "US", "840", "", "OH", "175", "", "40.82728", "-83.28131", "America/New_York"),("5174897", "Urbana", "", "US", "840", "", "OH", "021", "", "40.10839", "-83.75243", "America/New_York"),("5175072", "Vermilion", "", "US", "840", "", "OH", "093", "", "41.42199", "-82.36461", "America/New_York"),("5175079", "Van Wert", "", "US", "840", "", "OH", "161", "", "40.86949", "-84.58412", "America/New_York"),("5175080", "Vermilion-on-the-Lake", "", "US", "840", "", "OH", "093", "", "41.42838", "-82.32377", "America/New_York"),("5175496", "Wadsworth", "", "US", "840", "", "OH", "103", "", "41.02561", "-81.72985", "America/New_York"),("5175670", "Wapakoneta", "", "US", "840", "", "OH", "011", "", "40.56783", "-84.19356", "America/New_York"),("5175726", "Warrensville Heights", "", "US", "840", "", "OH", "035", "", "41.43505", "-81.53623", "America/New_York"),("5175847", "Waterville", "", "US", "840", "", "OH", "095", "", "41.50089", "-83.71827", "America/New_York"),("5175865", "Warren", "Уоррен", "US", "840", "", "OH", "155", "", "41.23756", "-80.81842", "America/New_York"),("5175877", "Wauseon", "", "US", "840", "", "OH", "051", "", "41.54922", "-84.14161", "America/New_York"),("5176472", "Westerville", "", "US", "840", "", "OH", "049", "", "40.12617", "-82.92907", "America/New_York"),("5176517", "Westlake", "", "US", "840", "", "OH", "035", "", "41.45532", "-81.91792", "America/New_York"),("5176759", "Wickliffe", "", "US", "840", "", "OH", "085", "", "41.60533", "-81.45345", "America/New_York"),("5176830", "Willard", "", "US", "840", "", "OH", "077", "", "41.05311", "-82.72629", "America/New_York"),("5176937", "Willoughby", "Уиллоуби", "US", "840", "", "OH", "085", "", "41.63977", "-81.4065", "America/New_York"),("5176942", "Willoughby Hills", "", "US", "840", "", "OH", "085", "", "41.59838", "-81.41845", "America/New_York"),("5177007", "Willowick", "", "US", "840", "", "OH", "085", "", "41.6331", "-81.46873", "America/New_York"),("5177358", "Wooster", "Вустер", "US", "840", "", "OH", "169", "", "40.80517", "-81.93646", "America/New_York"),("5177396", "Worthington", "", "US", "840", "", "OH", "049", "", "40.09312", "-83.01796", "America/New_York"),("5177568", "Youngstown", "Янгстаун", "US", "840", "", "OH", "099", "", "41.09978", "-80.64952", "America/New_York"),("5178027", "Aliquippa", "", "US", "840", "", "PA", "007", "", "40.63673", "-80.24006", "America/New_York"),("5178127", "Allentown", "Аллентаун", "US", "840", "", "PA", "077", "", "40.60843", "-75.49018", "America/New_York"),("5178165", "Allison Park", "", "US", "840", "", "PA", "003", "", "40.55951", "-79.95867", "America/New_York"),("5178195", "Altoona", "Алтуна", "US", "840", "", "PA", "013", "", "40.51868", "-78.39474", "America/New_York"),("5178225", "Ambler", "", "US", "840", "", "PA", "091", "", "40.15455", "-75.22157", "America/New_York"),("5178228", "Ambridge", "", "US", "840", "", "PA", "007", "", "40.58923", "-80.22506", "America/New_York"),("5178280", "Ancient Oaks", "", "US", "840", "", "PA", "077", "", "40.54732", "-75.58935", "America/New_York"),("5178450", "Archbald", "", "US", "840", "", "PA", "069", "", "41.4948", "-75.53685", "America/New_York"),("5178481", "Ardmore", "", "US", "840", "", "PA", "091", "", "40.00678", "-75.28546", "America/New_York"),("5178489", "Arlington Heights", "", "US", "840", "", "PA", "089", "", "40.99009", "-75.21629", "America/New_York"),("5178686", "Audubon", "", "US", "840", "", "PA", "091", "", "40.12788", "-75.43185", "America/New_York"),("5178800", "Back Mountain", "", "US", "840", "", "PA", "079", "", "41.33591", "-75.99631", "America/New_York"),("5178892", "Bala-Cynwyd", "", "US", "840", "", "PA", "091", "", "40.00761", "-75.23407", "America/New_York"),("5178940", "Baldwin", "", "US", "840", "", "PA", "003", "", "40.33813", "-79.97894", "America/New_York"),("5178996", "Bangor", "", "US", "840", "", "PA", "095", "", "40.86565", "-75.20657", "America/New_York"),("5179478", "Beaver Falls", "", "US", "840", "", "PA", "007", "", "40.75201", "-80.31923", "America/New_York"),("5179641", "Bedminster", "", "US", "840", "", "PA", "017", "", "40.42594", "-75.17906", "America/New_York"),("5179799", "Bellefonte", "", "US", "840", "", "PA", "027", "", "40.91339", "-77.77833", "America/New_York"),("5179811", "Bellevue", "", "US", "840", "", "PA", "003", "", "40.49396", "-80.05172", "America/New_York"),("5180119", "Berwick", "", "US", "840", "", "PA", "037", "", "41.05453", "-76.23327", "America/New_York"),("5180199", "Bethel Park", "", "US", "840", "", "PA", "003", "", "40.32757", "-80.0395", "America/New_York"),("5180225", "Bethlehem", "Вифлеем", "US", "840", "", "PA", "095", "", "40.62593", "-75.37046", "America/New_York"),("5180620", "Birdsboro", "", "US", "840", "", "PA", "011", "", "40.26454", "-75.80409", "America/New_York"),("5180843", "Blakely", "", "US", "840", "", "PA", "069", "", "41.48091", "-75.59463", "America/New_York"),("5180859", "Blandon", "", "US", "840", "", "PA", "011", "", "40.4412", "-75.88687", "America/New_York"),("5180934", "Bloomsburg", "", "US", "840", "", "PA", "037", "", "41.0037", "-76.45495", "America/New_York"),("5180961", "Blue Bell", "", "US", "840", "", "PA", "091", "", "40.15233", "-75.26629", "America/New_York"),("5181407", "Bradford", "", "US", "840", "", "PA", "083", "", "41.9559", "-78.64392", "America/New_York"),("5181553", "Brentwood", "", "US", "840", "", "PA", "003", "", "40.37063", "-79.97477", "America/New_York"),("5181636", "Bridgeville", "", "US", "840", "", "PA", "003", "", "40.35618", "-80.11006", "America/New_York"),("5181688", "Bristol", "", "US", "840", "", "PA", "017", "", "40.10067", "-74.85183", "America/New_York"),("5182063", "Bryn Mawr", "", "US", "840", "", "PA", "003", "", "40.30396", "-80.08672", "America/New_York"),("5182534", "Butler", "", "US", "840", "", "PA", "019", "", "40.86118", "-79.89533", "America/New_York"),("5182733", "California", "", "US", "840", "", "PA", "125", "", "40.06563", "-79.89171", "America/New_York"),("5182928", "Camp Hill", "", "US", "840", "", "PA", "041", "", "40.23981", "-76.91997", "America/New_York"),("5183161", "Canonsburg", "", "US", "840", "", "PA", "125", "", "40.26257", "-80.18728", "America/New_York"),("5183204", "Carbondale", "", "US", "840", "", "PA", "069", "", "41.57369", "-75.50185", "America/New_York"),("5183234", "Carlisle", "", "US", "840", "", "PA", "041", "", "40.20148", "-77.18887", "America/New_York"),("5183428", "Castle Shannon", "", "US", "840", "", "PA", "003", "", "40.36479", "-80.02228", "America/New_York"),("5183438", "Catasauqua", "", "US", "840", "", "PA", "077", "", "40.65482", "-75.47463", "America/New_York"),("5184082", "Chester Springs", "", "US", "840", "", "PA", "029", "", "40.0951", "-75.61687", "America/New_York"),("5184396", "Clairton", "", "US", "840", "", "PA", "003", "", "40.29229", "-79.88171", "America/New_York"),("5184422", "Clarion", "", "US", "840", "", "PA", "031", "", "41.21479", "-79.38532", "America/New_York"),("5184541", "Clearfield", "", "US", "840", "", "PA", "033", "", "41.02728", "-78.43919", "America/New_York"),("5184966", "Collegeville", "", "US", "840", "", "PA", "091", "", "40.18566", "-75.45157", "America/New_York"),("5185006", "Colonial Park", "", "US", "840", "", "PA", "043", "", "40.30064", "-76.80969", "America/New_York"),("5185029", "Columbia", "", "US", "840", "", "PA", "071", "", "40.03371", "-76.50441", "America/New_York"),("5185237", "Connellsville", "", "US", "840", "", "PA", "051", "", "40.01785", "-79.58948", "America/New_York"),("5185267", "Conshohocken", "", "US", "840", "", "PA", "091", "", "40.07928", "-75.30157", "America/New_York"),("5185408", "Coraopolis", "", "US", "840", "", "PA", "003", "", "40.5184", "-80.16672", "America/New_York"),("5185490", "Corry", "", "US", "840", "", "PA", "049", "", "41.92033", "-79.64033", "America/New_York"),("5185721", "Crafton", "", "US", "840", "", "PA", "003", "", "40.43507", "-80.06617", "America/New_York"),("5186053", "Croydon", "", "US", "840", "", "PA", "017", "", "40.08733", "-74.9035", "America/New_York"),("5186924", "Dickson City", "", "US", "840", "", "PA", "069", "", "41.47147", "-75.60769", "America/New_York"),("5187150", "Dormont", "", "US", "840", "", "PA", "003", "", "40.3959", "-80.03311", "America/New_York"),("5187232", "Downingtown", "", "US", "840", "", "PA", "029", "", "40.0065", "-75.70327", "America/New_York"),("5187247", "Doylestown", "", "US", "840", "", "PA", "017", "", "40.31011", "-75.12989", "America/New_York"),("5187248", "Doylestown", "", "US", "840", "", "PA", "055", "", "40.19758", "-77.72138", "America/New_York"),("5187297", "Dresher", "", "US", "840", "", "PA", "091", "", "40.14094", "-75.16684", "America/New_York"),("5187432", "DuBois", "", "US", "840", "", "PA", "033", "", "41.11923", "-78.76003", "America/New_York"),("5187542", "Dunmore", "", "US", "840", "", "PA", "069", "", "41.4198", "-75.63241", "America/New_York"),("5187580", "Duquesne", "", "US", "840", "", "PA", "003", "", "40.38146", "-79.85977", "America/New_York"),("5188075", "East Stroudsburg", "", "US", "840", "", "PA", "089", "", "40.99954", "-75.18129", "America/New_York"),("5188140", "Easton", "Истон", "US", "840", "", "PA", "095", "", "40.68843", "-75.22073", "America/New_York"),("5188236", "Economy", "", "US", "840", "", "PA", "007", "", "40.60007", "-80.22478", "America/New_York"),("5188306", "Edinboro", "", "US", "840", "", "PA", "049", "", "41.87422", "-80.13172", "America/New_York");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("5188474", "Elizabethtown", "", "US", "840", "", "PA", "071", "", "40.15287", "-76.60275", "America/New_York"),("5188609", "Ellwood City", "", "US", "840", "", "PA", "073", "", "40.86173", "-80.28645", "America/New_York"),("5188726", "Emmaus", "", "US", "840", "", "PA", "077", "", "40.53954", "-75.49685", "America/New_York"),("5188793", "Enola", "", "US", "840", "", "PA", "041", "", "40.29009", "-76.93386", "America/New_York"),("5188815", "Ephrata", "", "US", "840", "", "PA", "071", "", "40.17982", "-76.17884", "America/New_York"),("5188843", "Erie", "Эри", "US", "840", "", "PA", "049", "", "42.12922", "-80.08506", "America/New_York"),("5189004", "Exeter", "", "US", "840", "", "PA", "079", "", "41.32064", "-75.81908", "America/New_York"),("5189091", "Fairless Hills", "", "US", "840", "", "PA", "017", "", "40.17955", "-74.85516", "America/New_York"),("5189493", "Fernway", "", "US", "840", "", "PA", "019", "", "40.69479", "-80.13089", "America/New_York"),("5189981", "Forest Hills", "", "US", "840", "", "PA", "003", "", "40.41979", "-79.85005", "America/New_York"),("5190089", "Fort Washington", "", "US", "840", "", "PA", "091", "", "40.14178", "-75.20906", "America/New_York"),("5190213", "Fox Chapel", "", "US", "840", "", "PA", "003", "", "40.5134", "-79.87977", "America/New_York"),("5190323", "Franklin", "", "US", "840", "", "PA", "121", "", "41.39784", "-79.83144", "America/New_York"),("5190360", "Franklin Park", "", "US", "840", "", "PA", "003", "", "40.5834", "-80.08784", "America/New_York"),("5190679", "Fullerton", "", "US", "840", "", "PA", "077", "", "40.63176", "-75.47324", "America/New_York"),("5191327", "Glenside", "", "US", "840", "", "PA", "091", "", "40.10233", "-75.15212", "America/New_York"),("5191335", "Glenshaw", "", "US", "840", "", "PA", "003", "", "40.53285", "-79.96755", "America/New_York"),("5192019", "Greenville", "", "US", "840", "", "PA", "085", "", "41.4045", "-80.39118", "America/New_York"),("5192029", "Greensburg", "", "US", "840", "", "PA", "129", "", "40.30146", "-79.53893", "America/New_York"),("5192184", "Grove City", "", "US", "840", "", "PA", "085", "", "41.15784", "-80.08867", "America/New_York"),("5192662", "Harleysville", "", "US", "840", "", "PA", "091", "", "40.27955", "-75.38712", "America/New_York"),("5192726", "Harrisburg", "Гаррисберг", "US", "840", "", "PA", "043", "", "40.2737", "-76.88442", "America/New_York"),("5192863", "Hatboro", "", "US", "840", "", "PA", "091", "", "40.17428", "-75.10684", "America/New_York"),("5193011", "Hazleton", "", "US", "840", "", "PA", "079", "", "40.95842", "-75.97465", "America/New_York"),("5193149", "Hellertown", "", "US", "840", "", "PA", "095", "", "40.57954", "-75.34073", "America/New_York"),("5193309", "Hermitage", "", "US", "840", "", "PA", "085", "", "41.23339", "-80.44868", "America/New_York"),("5193342", "Hershey", "", "US", "840", "", "PA", "043", "", "40.28592", "-76.65025", "America/New_York"),("5193920", "Hollidaysburg", "", "US", "840", "", "PA", "013", "", "40.42729", "-78.3889", "America/New_York"),("5194302", "Horsham", "", "US", "840", "", "PA", "091", "", "40.17844", "-75.12851", "America/New_York"),("5194590", "Huntingdon", "", "US", "840", "", "PA", "061", "", "40.4848", "-78.01028", "America/New_York"),("5194868", "Indiana", "", "US", "840", "", "PA", "063", "", "40.62146", "-79.15253", "America/New_York"),("5195283", "Jeannette", "", "US", "840", "", "PA", "129", "", "40.32812", "-79.61532", "America/New_York"),("5195297", "Jefferson Hills", "", "US", "840", "", "PA", "003", "", "40.29118", "-79.93199", "America/New_York"),("5195561", "Johnstown", "Джонстаун", "US", "840", "", "PA", "021", "", "40.32674", "-78.92197", "America/New_York"),("5196220", "King of Prussia", "", "US", "840", "", "PA", "091", "", "40.08927", "-75.39602", "America/New_York"),("5196245", "Kingston", "", "US", "840", "", "PA", "079", "", "41.26175", "-75.89686", "America/New_York"),("5196605", "Kulpsville", "", "US", "840", "", "PA", "091", "", "40.24288", "-75.33656", "America/New_York"),("5196621", "Kutztown", "", "US", "840", "", "PA", "011", "", "40.51732", "-75.77742", "America/New_York"),("5197079", "Lancaster", "Ланкастер", "US", "840", "", "PA", "071", "", "40.03788", "-76.30551", "America/New_York"),("5197159", "Lansdale", "", "US", "840", "", "PA", "091", "", "40.2415", "-75.28379", "America/New_York"),("5197227", "Latrobe", "", "US", "840", "", "PA", "129", "", "40.32118", "-79.37948", "America/New_York"),("5197517", "Lebanon", "", "US", "840", "", "PA", "075", "", "40.34093", "-76.41135", "America/New_York"),("5197673", "Lehighton", "", "US", "840", "", "PA", "025", "", "40.8337", "-75.7138", "America/New_York"),("5197749", "Leola", "", "US", "840", "", "PA", "071", "", "40.08787", "-76.18495", "America/New_York"),("5197796", "Levittown", "", "US", "840", "", "PA", "017", "", "40.15511", "-74.82877", "America/New_York"),("5197842", "Lewisburg", "", "US", "840", "", "PA", "119", "", "40.96453", "-76.88441", "America/New_York"),("5197850", "Lewistown", "", "US", "840", "", "PA", "087", "", "40.59924", "-77.57138", "America/New_York"),("5198034", "Limerick", "", "US", "840", "", "PA", "091", "", "40.23093", "-75.52212", "America/New_York"),("5198180", "Linglestown", "", "US", "840", "", "PA", "043", "", "40.33398", "-76.78914", "America/New_York"),("5198203", "Lionville", "", "US", "840", "", "PA", "029", "", "40.05372", "-75.65993", "America/New_York"),("5198218", "Lititz", "", "US", "840", "", "PA", "071", "", "40.15732", "-76.3069", "America/New_York"),("5198635", "Lock Haven", "", "US", "840", "", "PA", "035", "", "41.13701", "-77.44693", "America/New_York"),("5199075", "Lower Allen", "", "US", "840", "", "PA", "041", "", "40.22648", "-76.90053", "America/New_York"),("5199087", "Lower Burrell", "", "US", "840", "", "PA", "129", "", "40.55312", "-79.75727", "America/New_York"),("5199740", "Maple Glen", "", "US", "840", "", "PA", "125", "", "40.01563", "-79.97672", "America/New_York"),("5199781", "Maple Glen", "", "US", "840", "", "PA", "091", "", "40.17928", "-75.18045", "America/New_York"),("5200474", "McKees Rocks", "", "US", "840", "", "PA", "003", "", "40.46562", "-80.06561", "America/New_York"),("5200499", "McKeesport", "", "US", "840", "", "PA", "003", "", "40.34785", "-79.86422", "America/New_York"),("5200644", "Meadville", "", "US", "840", "", "PA", "039", "", "41.64144", "-80.15145", "America/New_York"),("5200657", "Mechanicsburg", "", "US", "840", "", "PA", "041", "", "40.21426", "-77.00859", "America/New_York"),("5201027", "Middletown", "", "US", "840", "", "PA", "043", "", "40.19981", "-76.73108", "America/New_York"),("5201031", "Middletown", "", "US", "840", "", "PA", "095", "", "40.64399", "-75.3324", "America/New_York"),("5201470", "Milton", "", "US", "840", "", "PA", "097", "", "41.01203", "-76.84774", "America/New_York"),("5201658", "Monaca", "", "US", "840", "", "PA", "007", "", "40.68729", "-80.27145", "America/New_York"),("5201665", "Monessen", "", "US", "840", "", "PA", "129", "", "40.14841", "-79.88783", "America/New_York"),("5201734", "Monroeville", "", "US", "840", "", "PA", "003", "", "40.42118", "-79.7881", "America/New_York"),("5201776", "Montgomeryville", "", "US", "840", "", "PA", "091", "", "40.24733", "-75.24379", "America/New_York"),("5201901", "Moosic", "", "US", "840", "", "PA", "069", "", "41.35341", "-75.73825", "America/New_York"),("5201996", "Morrisville", "", "US", "840", "", "PA", "017", "", "40.2115", "-74.78794", "America/New_York"),("5202114", "Mount Carmel", "", "US", "840", "", "PA", "097", "", "40.79703", "-76.4119", "America/New_York"),("5202202", "Mount Joy", "", "US", "840", "", "PA", "071", "", "40.10982", "-76.5033", "America/New_York"),("5202215", "Mount Lebanon", "", "US", "840", "", "PA", "003", "", "40.35535", "-80.0495", "America/New_York"),("5202535", "Mountain Top", "", "US", "840", "", "PA", "079", "", "41.16953", "-75.87742", "America/New_York"),("5202734", "Munhall", "", "US", "840", "", "PA", "003", "", "40.39229", "-79.90005", "America/New_York"),("5202765", "Murrysville", "", "US", "840", "", "PA", "129", "", "40.4284", "-79.69755", "America/New_York"),("5202855", "Nanticoke", "", "US", "840", "", "PA", "079", "", "41.20536", "-76.00492", "America/New_York"),("5202938", "Nazareth", "", "US", "840", "", "PA", "095", "", "40.74038", "-75.30962", "America/New_York"),("5203116", "New Brighton", "", "US", "840", "", "PA", "007", "", "40.73034", "-80.31006", "America/New_York"),("5203127", "New Castle", "", "US", "840", "", "PA", "073", "", "41.00367", "-80.34701", "America/New_York"),("5203164", "New Cumberland", "", "US", "840", "", "PA", "041", "", "40.23231", "-76.8847", "America/New_York"),("5203211", "New Kensington", "", "US", "840", "", "PA", "129", "", "40.56979", "-79.76477", "America/New_York"),("5203221", "New Holland", "", "US", "840", "", "PA", "071", "", "40.10176", "-76.08523", "America/New_York"),("5203506", "Norristown", "", "US", "840", "", "PA", "091", "", "40.1215", "-75.3399", "America/New_York"),("5203785", "North Versailles", "", "US", "840", "", "PA", "003", "", "40.37979", "-79.80949", "America/New_York"),("5203804", "Northampton", "", "US", "840", "", "PA", "095", "", "40.68621", "-75.49685", "America/New_York"),("5204203", "Oakmont", "", "US", "840", "", "PA", "003", "", "40.52173", "-79.84227", "America/New_York"),("5204278", "Oil City", "", "US", "840", "", "PA", "121", "", "41.43395", "-79.70644", "America/New_York"),("5204331", "Old Forge", "", "US", "840", "", "PA", "069", "", "41.37119", "-75.73491", "America/New_York"),("5204476", "Olyphant", "", "US", "840", "", "PA", "069", "", "41.46841", "-75.60297", "America/New_York"),("5204575", "Oreland", "", "US", "840", "", "PA", "091", "", "40.11844", "-75.17768", "America/New_York"),("5204957", "Palmerton", "", "US", "840", "", "PA", "025", "", "40.8014", "-75.6119", "America/New_York"),("5204964", "Palmyra", "", "US", "840", "", "PA", "075", "", "40.30898", "-76.5933", "America/New_York"),("5205037", "Paoli", "", "US", "840", "", "PA", "029", "", "40.04205", "-75.47631", "America/New_York"),("5205094", "Park Forest Village", "", "US", "840", "", "PA", "027", "", "40.80673", "-77.91695", "America/New_York"),("5205267", "Paxtonia", "", "US", "840", "", "PA", "043", "", "40.31731", "-76.79442", "America/New_York"),("5205377", "Penn Hills", "", "US", "840", "", "PA", "003", "", "40.50118", "-79.83922", "America/New_York"),("5205638", "Perkasie", "", "US", "840", "", "PA", "017", "", "40.37205", "-75.29268", "America/New_York"),("5205849", "Phoenixville", "Финиксвилл", "US", "840", "", "PA", "029", "", "40.13038", "-75.51491", "America/New_York"),("5206379", "Pittsburgh", "Питтсбург", "US", "840", "", "PA", "003", "", "40.44062", "-79.99589", "America/New_York"),("5206397", "Pittston", "", "US", "840", "", "PA", "079", "", "41.32591", "-75.78936", "America/New_York"),("5206510", "Pleasant Hills", "", "US", "840", "", "PA", "003", "", "40.33563", "-79.96061", "America/New_York"),("5206606", "Plum", "", "US", "840", "", "PA", "003", "", "40.50035", "-79.74949", "America/New_York"),("5206659", "Plymouth", "", "US", "840", "", "PA", "079", "", "41.24036", "-75.94464", "America/New_York"),("5206666", "Plymouth Meeting", "", "US", "840", "", "PA", "091", "", "40.10233", "-75.27435", "America/New_York"),("5207069", "Pottstown", "", "US", "840", "", "PA", "091", "", "40.24537", "-75.64963", "America/New_York"),("5207080", "Pottsville", "", "US", "840", "", "PA", "107", "", "40.68565", "-76.1955", "America/New_York"),("5207214", "Progress", "", "US", "840", "", "PA", "043", "", "40.28509", "-76.83136", "America/New_York"),("5207307", "Punxsutawney", "", "US", "840", "", "PA", "065", "", "40.94368", "-78.97087", "America/New_York"),("5207381", "Quakertown", "", "US", "840", "", "PA", "017", "", "40.44177", "-75.34157", "America/New_York"),("5207490", "Radnor", "", "US", "840", "", "PA", "045", "", "40.04622", "-75.35991", "America/New_York"),("5207728", "Reading", "Рединг", "US", "840", "", "PA", "011", "", "40.33565", "-75.92687", "America/New_York"),("5207794", "Red Lion", "", "US", "840", "", "PA", "011", "", "40.48065", "-75.61602", "America/New_York"),("5208166", "Richboro", "", "US", "840", "", "PA", "017", "", "40.21511", "-75.01072", "America/New_York"),("5210117", "Saint Marys", "", "US", "840", "", "PA", "047", "", "41.42784", "-78.56086", "America/New_York"),("5210764", "Sanatoga", "", "US", "840", "", "PA", "091", "", "40.2451", "-75.59518", "America/New_York"),("5211037", "Sayre", "", "US", "840", "", "PA", "015", "", "41.97896", "-76.5155", "America/New_York"),("5211113", "Schlusser", "", "US", "840", "", "PA", "041", "", "40.24175", "-77.17693", "America/New_York"),("5211212", "Schuylkill Haven", "", "US", "840", "", "PA", "107", "", "40.63065", "-76.17105", "America/New_York"),("5211303", "Scranton", "Скрантон", "US", "840", "", "PA", "069", "", "41.40916", "-75.6649", "America/New_York"),("5211411", "Selinsgrove", "", "US", "840", "", "PA", "109", "", "40.79897", "-76.86219", "America/New_York"),("5211622", "Shamokin", "", "US", "840", "", "PA", "097", "", "40.78897", "-76.55885", "America/New_York"),("5211683", "Sharon", "", "US", "840", "", "PA", "085", "", "41.23311", "-80.4934", "America/New_York"),("5211953", "Shillington", "", "US", "840", "", "PA", "011", "", "40.30787", "-75.96549", "America/New_York"),("5211957", "Shiloh", "", "US", "840", "", "PA", "033", "", "41.04172", "-78.2914", "America/New_York"),("5212038", "Shippensburg", "", "US", "840", "", "PA", "041", "", "40.05065", "-77.52026", "America/New_York"),("5212853", "Somerset", "", "US", "840", "", "PA", "111", "", "40.00841", "-79.07808", "America/New_York"),("5212897", "Souderton", "", "US", "840", "", "PA", "091", "", "40.31177", "-75.32518", "America/New_York"),("5213130", "South Williamsport", "", "US", "840", "", "PA", "081", "", "41.23202", "-76.99913", "America/New_York"),("5213681", "State College", "", "US", "840", "", "PA", "027", "", "40.79339", "-77.86", "America/New_York"),("5214040", "Steelton", "", "US", "840", "", "PA", "043", "", "40.23537", "-76.84136", "America/New_York"),("5214543", "Stroudsburg", "", "US", "840", "", "PA", "089", "", "40.98676", "-75.19462", "America/New_York"),("5214696", "Sugarcreek", "", "US", "840", "", "PA", "121", "", "41.42145", "-79.88117", "America/New_York"),("5214814", "Sunbury", "", "US", "840", "", "PA", "097", "", "40.86259", "-76.79441", "America/New_York"),("5215064", "Swissvale", "", "US", "840", "", "PA", "003", "", "40.42368", "-79.88283", "America/New_York"),("5215142", "Tamaqua", "", "US", "840", "", "PA", "107", "", "40.79731", "-75.96937", "America/New_York"),("5215247", "Taylor", "", "US", "840", "", "PA", "069", "", "41.3948", "-75.70658", "America/New_York"),("5215726", "Titusville", "", "US", "840", "", "PA", "039", "", "41.627", "-79.67366", "America/New_York"),("5216092", "Trooper", "", "US", "840", "", "PA", "091", "", "40.14983", "-75.40185", "America/New_York"),("5216343", "Turtle Creek", "", "US", "840", "", "PA", "003", "", "40.4059", "-79.82505", "America/New_York"),("5216514", "Tyrone", "", "US", "840", "", "PA", "013", "", "40.67062", "-78.23862", "America/New_York"),("5216895", "Upper Saint Clair", "", "US", "840", "", "PA", "003", "", "40.3359", "-80.08339", "America/New_York"),("5217103", "Vandergrift", "", "US", "840", "", "PA", "129", "", "40.60284", "-79.56477", "America/New_York"),("5218023", "Warren", "", "US", "840", "", "PA", "123", "", "41.84395", "-79.14504", "America/New_York"),("5218069", "Washington", "", "US", "840", "", "PA", "125", "", "40.17396", "-80.24617", "America/New_York"),("5218270", "Wayne", "", "US", "840", "", "PA", "045", "", "40.044", "-75.38769", "America/New_York"),("5218505", "Wescosville", "", "US", "840", "", "PA", "077", "", "40.56676", "-75.55296", "America/New_York"),("5218802", "West Mifflin", "", "US", "840", "", "PA", "003", "", "40.3634", "-79.86644", "America/New_York"),("5218827", "West Norriton", "", "US", "840", "", "PA", "091", "", "40.12955", "-75.37852", "America/New_York"),("5218918", "West View", "", "US", "840", "", "PA", "003", "", "40.52229", "-80.03422", "America/New_York"),("5219216", "White Oak", "", "US", "840", "", "PA", "003", "", "40.33757", "-79.80921", "America/New_York"),("5219271", "Whitehall", "", "US", "840", "", "PA", "003", "", "40.36118", "-79.99089", "America/New_York"),("5219287", "Whitehall Township", "", "US", "840", "", "PA", "077", "", "40.66676", "-75.49991", "America/New_York"),("5219488", "Wilkes-Barre", "Уилкс-Барре", "US", "840", "", "PA", "079", "", "41.24591", "-75.88131", "America/New_York"),("5219501", "Wilkinsburg", "", "US", "840", "", "PA", "003", "", "40.44174", "-79.88199", "America/New_York"),("5219585", "Williamsport", "", "US", "840", "", "PA", "081", "", "41.24119", "-77.00108", "America/New_York"),("5219619", "Willow Grove", "", "US", "840", "", "PA", "091", "", "40.144", "-75.11573", "America/New_York"),("5219667", "Wilson", "", "US", "840", "", "PA", "003", "", "40.31007", "-79.89144", "America/New_York"),("5219668", "Wilson", "", "US", "840", "", "PA", "095", "", "40.68399", "-75.24184", "America/New_York"),("5220221", "Wyndmoor", "", "US", "840", "", "PA", "091", "", "40.08122", "-75.18934", "America/New_York"),("5220248", "Wyomissing", "", "US", "840", "", "PA", "011", "", "40.32954", "-75.96521", "America/New_York"),("5220798", "Barrington", "", "US", "840", "", "RI", "001", "", "41.74066", "-71.30866", "America/New_York"),("5221077", "Bristol", "", "US", "840", "", "RI", "001", "", "41.67705", "-71.26616", "America/New_York"),("5221341", "Central Falls", "", "US", "840", "", "RI", "007", "", "41.89066", "-71.39228", "America/New_York"),("5221384", "Charlestown", "", "US", "840", "", "RI", "009", "", "41.38316", "-71.64173", "America/New_York"),("5221637", "Coventry", "Ковентри", "US", "840", "", "RI", "003", "", "41.7001", "-71.68284", "America/New_York"),("5221659", "Cranston", "Крэнстон", "US", "840", "", "RI", "007", "5221674", "41.77982", "-71.43728", "America/New_York"),("5221703", "Cumberland", "Камберленд", "US", "840", "", "RI", "007", "", "41.96677", "-71.43284", "America/New_York"),("5221705", "Cumberland Hill", "", "US", "840", "", "RI", "007", "", "41.97454", "-71.467", "America/New_York"),("5221875", "East Greenwich", "", "US", "840", "", "RI", "003", "", "41.66038", "-71.45589", "America/New_York"),("5221931", "East Providence", "", "US", "840", "", "RI", "007", "", "41.81371", "-71.37005", "America/New_York"),("5222019", "Exeter", "", "US", "840", "", "RI", "009", "", "41.5776", "-71.53756", "America/New_York"),("5222476", "Greenville", "", "US", "840", "", "RI", "007", "", "41.87121", "-71.55201", "America/New_York"),("5222680", "Hopkinton", "", "US", "840", "", "RI", "009", "", "41.46121", "-71.77757", "America/New_York"),("5222866", "Jamestown", "", "US", "840", "", "RI", "005", "", "41.49705", "-71.36728", "America/New_York"),("5223006", "Kingston", "", "US", "840", "", "RI", "009", "", "41.48038", "-71.52256", "America/New_York"),("5223358", "Middletown", "", "US", "840", "", "RI", "005", "", "41.54566", "-71.29144", "America/New_York"),("5223593", "Newport", "Ньюпорт", "US", "840", "", "RI", "005", "", "41.4901", "-71.31283", "America/New_York"),("5223672", "North Kingstown", "Норт-Кингстаун", "US", "840", "", "RI", "009", "", "41.5501", "-71.46617", "America/New_York"),("5223681", "North Providence", "", "US", "840", "", "RI", "007", "5223683", "41.8501", "-71.46617", "America/New_York"),("5223685", "North Scituate", "", "US", "840", "", "RI", "007", "", "41.83177", "-71.58729", "America/New_York"),("5223687", "North Smithfield", "", "US", "840", "", "RI", "007", "", "41.96677", "-71.54951", "America/New_York"),("5223869", "Pawtucket", "Потакет", "US", "840", "", "RI", "007", "", "41.87871", "-71.38256", "America/New_York"),("5224082", "Portsmouth", "Портсмут", "US", "840", "", "RI", "005", "", "41.60232", "-71.25033", "America/New_York"),("5224151", "Providence", "Провиденс", "US", "840", "", "RI", "007", "", "41.82399", "-71.41283", "America/New_York"),("5224949", "Smithfield", "", "US", "840", "", "RI", "007", "", "41.92204", "-71.54951", "America/New_York"),("5225245", "Tiverton", "", "US", "840", "", "RI", "005", "", "41.62594", "-71.21338", "America/New_York"),("5225388", "Valley Falls", "", "US", "840", "", "RI", "007", "", "41.90677", "-71.39061", "America/New_York"),("5225502", "Warren", "", "US", "840", "", "RI", "001", "", "41.73038", "-71.28255", "America/New_York"),("5225507", "Warwick", "Уорик", "US", "840", "", "RI", "003", "", "41.7001", "-71.41617", "America/New_York"),("5225627", "West Warwick", "", "US", "840", "", "RI", "003", "", "41.69689", "-71.52194", "America/New_York"),("5225631", "Westerly", "", "US", "840", "", "RI", "009", "", "41.3776", "-71.82729", "America/New_York"),("5225809", "Woonsocket", "Вунсокет", "US", "840", "", "RI", "007", "", "42.00288", "-71.51478", "America/New_York"),("5225857", "Aberdeen", "Абердин", "US", "840", "", "SD", "013", "", "45.4647", "-98.48648", "America/Chicago"),("5226489", "Brandon", "", "US", "840", "", "SD", "099", "", "43.5947", "-96.57199", "America/Chicago"),("5226534", "Brookings", "Брукингз", "US", "840", "", "SD", "011", "", "44.31136", "-96.79839", "America/Chicago"),("5228340", "Harrisburg", "", "US", "840", "", "SD", "083", "", "43.43137", "-96.69727", "America/Chicago"),("5228673", "Huron", "", "US", "840", "", "SD", "005", "", "44.36332", "-98.21426", "America/Chicago"),("5229526", "Madison", "", "US", "840", "", "SD", "079", "", "44.00608", "-97.11395", "America/Chicago"),("5229794", "Mitchell", "Митчелл", "US", "840", "", "SD", "035", "", "43.70943", "-98.0298", "America/Chicago"),("5231851", "Sioux Falls", "Су-Фолс", "US", "840", "", "SD", "099", "", "43.54997", "-96.70033", "America/Chicago"),("5232592", "Vermillion", "", "US", "840", "", "SD", "027", "", "42.77944", "-96.92921", "America/Chicago"),("5232741", "Watertown", "Уотертаун", "US", "840", "", "SD", "029", "", "44.89941", "-97.11507", "America/Chicago"),("5233053", "Yankton", "", "US", "840", "", "SD", "135", "", "42.87111", "-97.39728", "America/Chicago"),("5233500", "Barre", "", "US", "840", "", "VT", "023", "", "44.19701", "-72.50205", "America/New_York"),("5233742", "Bennington", "", "US", "840", "", "VT", "003", "", "42.87813", "-73.19677", "America/New_York"),("5234141", "Brattleboro", "", "US", "840", "", "VT", "025", "", "42.85092", "-72.55787", "America/New_York"),("5234372", "Burlington", "Берлингтон", "US", "840", "", "VT", "007", "", "44.47588", "-73.21207", "America/New_York"),("5235024", "Colchester", "", "US", "840", "", "VT", "007", "", "44.54394", "-73.14791", "America/New_York"),("5235952", "Essex Junction", "", "US", "840", "", "VT", "007", "", "44.49061", "-73.11096", "America/New_York"),("5236879", "Hartford", "", "US", "840", "", "VT", "027", "", "43.66063", "-72.33842", "America/New_York"),("5238190", "Lyndon", "", "US", "840", "", "VT", "005", "", "44.51422", "-72.01093", "America/New_York"),("5238499", "Middlebury (village)", "", "US", "840", "", "VT", "001", "", "44.01553", "-73.16937", "America/New_York"),("5238685", "Montpelier", "", "US", "840", "", "VT", "023", "", "44.26006", "-72.57539", "America/New_York"),("5238755", "Morristown", "", "US", "840", "", "VT", "015", "", "44.55727", "-72.62373", "America/New_York"),("5240399", "Rockingham", "", "US", "840", "", "VT", "025", "", "43.18758", "-72.48898", "America/New_York"),("5240509", "Rutland", "Ратленд", "US", "840", "", "VT", "021", "", "43.61062", "-72.97261", "America/New_York"),("5240569", "Saint Albans", "", "US", "840", "", "VT", "011", "", "44.81088", "-73.08319", "America/New_York"),("5240656", "Saint Johnsbury", "", "US", "840", "", "VT", "005", "", "44.41922", "-72.01509", "America/New_York"),("5241248", "South Burlington", "Саут-Берлингтон", "US", "840", "", "VT", "007", "", "44.46699", "-73.17096", "America/New_York"),("5243008", "Williston", "", "US", "840", "", "VT", "007", "", "44.43755", "-73.06818", "America/New_York"),("5243081", "Winooski", "", "US", "840", "", "VT", "007", "", "44.49144", "-73.18568", "America/New_York"),("5243770", "Allouez", "", "US", "840", "", "WI", "009", "", "44.47749", "-88.01621", "America/Chicago"),("5243819", "Altoona", "", "US", "840", "", "WI", "035", "", "44.80468", "-91.44321", "America/Chicago"),("5244010", "Antigo", "", "US", "840", "", "WI", "067", "", "45.14025", "-89.15234", "America/Chicago"),("5244080", "Appleton", "Аплтон", "US", "840", "", "WI", "087", "", "44.26193", "-88.41538", "America/Chicago"),("5244247", "Ashland", "", "US", "840", "", "WI", "003", "", "46.59244", "-90.8838", "America/Chicago"),("5244267", "Ashwaubenon", "", "US", "840", "", "WI", "009", "", "44.48221", "-88.0701", "America/Chicago"),("5244638", "Baraboo", "", "US", "840", "", "WI", "111", "", "43.47109", "-89.74429", "America/Chicago"),("5245193", "Beaver Dam", "", "US", "840", "", "WI", "027", "", "43.45777", "-88.83733", "America/Chicago"),("5245359", "Bellevue", "", "US", "840", "", "WI", "009", "", "44.44416", "-87.9201", "America/Chicago"),("5245387", "Beloit", "", "US", "840", "", "WI", "105", "", "42.50835", "-89.03178", "America/Chicago"),("5245497", "Berlin", "", "US", "840", "", "WI", "047", "", "43.96804", "-88.94345", "America/Chicago"),("5246835", "Brookfield", "", "US", "840", "", "WI", "133", "", "43.06057", "-88.10648", "America/Chicago"),("5246917", "Brown Deer", "", "US", "840", "", "WI", "079", "", "43.16334", "-87.96453", "America/Chicago"),("5247214", "Burlington", "", "US", "840", "", "WI", "101", "", "42.67807", "-88.2762", "America/Chicago"),("5247415", "Caledonia", "Каледония", "US", "840", "", "WI", "101", "", "42.8078", "-87.92425", "America/Chicago"),("5248171", "Cedarburg", "", "US", "840", "", "WI", "089", "", "43.29667", "-87.98759", "America/Chicago"),("5248511", "Chippewa Falls", "", "US", "840", "", "WI", "017", "", "44.93691", "-91.39293", "America/Chicago"),("5249503", "Cottage Grove", "", "US", "840", "", "WI", "025", "", "43.07611", "-89.19956", "America/Chicago"),("5249871", "Cudahy", "", "US", "840", "", "WI", "079", "", "42.95974", "-87.86147", "America/Chicago"),("5250188", "De Forest", "", "US", "840", "", "WI", "025", "", "43.24777", "-89.34373", "America/Chicago"),("5250201", "De Pere", "", "US", "840", "", "WI", "009", "", "44.44888", "-88.06038", "America/Chicago"),("5250393", "Delafield", "", "US", "840", "", "WI", "133", "", "43.06084", "-88.40371", "America/Chicago"),("5250399", "Delavan", "", "US", "840", "", "WI", "127", "", "42.63307", "-88.64371", "America/Chicago"),("5251436", "Eau Claire", "О-Клэр", "US", "840", "", "WI", "035", "", "44.81135", "-91.49849", "America/Chicago"),("5251524", "Edgerton", "", "US", "840", "", "WI", "105", "", "42.83528", "-89.06761", "America/Chicago"),("5251729", "Elkhorn", "", "US", "840", "", "WI", "127", "", "42.67279", "-88.54454", "America/Chicago"),("5251784", "Elm Grove", "", "US", "840", "", "WI", "133", "", "43.04307", "-88.07898", "America/Chicago"),("5252182", "Evansville", "", "US", "840", "", "WI", "105", "", "42.78028", "-89.29928", "America/Chicago"),("5253219", "Fitchburg", "", "US", "840", "", "WI", "025", "", "42.96083", "-89.46984", "America/Chicago"),("5253352", "Fond du Lac", "Фон-дю-Лак", "US", "840", "", "WI", "039", "", "43.775", "-88.43883", "America/Chicago"),("5253498", "Fort Atkinson", "", "US", "840", "", "WI", "055", "", "42.92889", "-88.83705", "America/Chicago"),("5253662", "Fox Point", "", "US", "840", "", "WI", "079", "", "43.15751", "-87.90175", "America/Chicago"),("5253710", "Franklin", "Франклин", "US", "840", "", "WI", "079", "", "42.88863", "-88.03842", "America/Chicago"),("5254218", "Germantown", "", "US", "840", "", "WI", "131", "", "43.22862", "-88.11037", "America/Chicago"),("5254404", "Glendale", "", "US", "840", "", "WI", "079", "", "43.13529", "-87.93564", "America/Chicago"),("5254739", "Grafton", "", "US", "840", "", "WI", "089", "", "43.31973", "-87.95342", "America/Chicago"),("5254962", "Green Bay", "Грин-Бей", "US", "840", "", "WI", "009", "", "44.51916", "-88.01983", "America/Chicago"),("5255057", "Greendale", "", "US", "840", "", "WI", "079", "", "42.94057", "-87.99592", "America/Chicago"),("5255068", "Greenfield", "Гринфилд", "US", "840", "", "WI", "079", "", "42.9614", "-88.01259", "America/Chicago"),("5255320", "Hales Corners", "", "US", "840", "", "WI", "079", "", "42.93751", "-88.0487", "America/Chicago"),("5255628", "Hartford", "", "US", "840", "", "WI", "131", "", "43.31778", "-88.37899", "America/Chicago"),("5255640", "Hartland", "", "US", "840", "", "WI", "133", "", "43.10501", "-88.34204", "America/Chicago"),("5256613", "Holmen", "", "US", "840", "", "WI", "063", "", "43.9633", "-91.25625", "America/Chicago"),("5257029", "Howard", "", "US", "840", "", "WI", "009", "", "44.5436", "-88.08816", "America/Chicago"),("5257080", "Hudson", "", "US", "840", "", "WI", "109", "", "44.97469", "-92.75687", "America/Chicago"),("5257669", "Jackson", "", "US", "840", "", "WI", "131", "", "43.32389", "-88.16676", "America/Chicago"),("5257754", "Janesville", "Джейнсвилл", "US", "840", "", "WI", "105", "", "42.68279", "-89.01872", "America/Chicago"),("5257784", "Jefferson", "", "US", "840", "", "WI", "055", "", "43.00556", "-88.80733", "America/Chicago"),("5258296", "Kaukauna", "", "US", "840", "", "WI", "087", "", "44.27804", "-88.27205", "America/Chicago"),("5258393", "Kenosha", "Кеноша", "US", "840", "", "WI", "059", "", "42.58474", "-87.82119", "America/Chicago"),("5258575", "Kimberly", "", "US", "840", "", "WI", "087", "", "44.27221", "-88.339", "America/Chicago"),("5258916", "Kronenwetter", "", "US", "840", "", "WI", "073", "", "44.82219", "-89.5904", "America/Chicago"),("5258957", "La Crosse", "Ла-Кросс", "US", "840", "", "WI", "063", "", "43.80136", "-91.23958", "America/Chicago"),("5259169", "Lake Geneva", "", "US", "840", "", "WI", "127", "", "42.59168", "-88.43343", "America/Chicago"),("5259182", "Lake Hallie", "", "US", "840", "", "WI", "017", "", "44.87579", "-91.44071", "America/Chicago"),("5259218", "Lake Mills", "", "US", "840", "", "WI", "055", "", "43.08139", "-88.91177", "America/Chicago"),("5260262", "Little Chute", "", "US", "840", "", "WI", "087", "", "44.27999", "-88.31844", "America/Chicago"),("5261457", "Madison", "Мадисон", "US", "840", "", "WI", "025", "", "43.07305", "-89.40123", "America/Chicago"),("5261585", "Manitowoc", "", "US", "840", "", "WI", "071", "", "44.08861", "-87.65758", "America/Chicago"),("5261852", "Marinette", "", "US", "840", "", "WI", "075", "", "45.09998", "-87.63066", "America/Chicago"),("5261969", "Marshfield", "", "US", "840", "", "WI", "141", "", "44.66885", "-90.1718", "America/Chicago"),("5262262", "McFarland", "", "US", "840", "", "WI", "025", "", "43.0125", "-89.28984", "America/Chicago"),("5262596", "Menasha", "", "US", "840", "", "WI", "139", "", "44.20221", "-88.4465", "America/Chicago"),("5262630", "Menomonee Falls", "", "US", "840", "", "WI", "133", "", "43.1789", "-88.11731", "America/Chicago"),("5262634", "Menomonie", "", "US", "840", "", "WI", "033", "", "44.87552", "-91.91934", "America/Chicago"),("5262649", "Mequon", "", "US", "840", "", "WI", "089", "", "43.2364", "-87.98453", "America/Chicago"),("5262680", "Merrill", "", "US", "840", "", "WI", "069", "", "45.18052", "-89.68346", "America/Chicago"),("5262838", "Middleton", "", "US", "840", "", "WI", "025", "", "43.09722", "-89.50429", "America/Chicago"),("5263023", "Milton", "", "US", "840", "", "WI", "105", "", "42.77556", "-88.944", "America/Chicago"),("5263045", "Milwaukee", "Милуоки", "US", "840", "", "WI", "079", "", "43.0389", "-87.90647", "America/Chicago"),("5263323", "Monona", "", "US", "840", "", "WI", "025", "", "43.06222", "-89.33401", "America/Chicago"),("5263331", "Monroe", "", "US", "840", "", "WI", "045", "", "42.60112", "-89.63845", "America/Chicago"),("5263667", "Mount Horeb", "", "US", "840", "", "WI", "025", "", "43.00861", "-89.73846", "America/Chicago"),("5263965", "Mukwonago", "", "US", "840", "", "WI", "133", "", "42.86668", "-88.33343", "America/Chicago"),("5264049", "Muskego", "", "US", "840", "", "WI", "133", "", "42.90585", "-88.13898", "America/Chicago"),("5264223", "Neenah", "", "US", "840", "", "WI", "139", "", "44.18582", "-88.46261", "America/Chicago"),("5264381", "New Berlin", "", "US", "840", "", "WI", "133", "", "42.9764", "-88.10842", "America/Chicago"),("5264455", "New London", "", "US", "840", "", "WI", "135", "", "44.39276", "-88.73983", "America/Chicago"),("5264475", "New Richmond", "", "US", "840", "", "WI", "109", "", "45.12302", "-92.53659", "America/Chicago"),("5264814", "North Fond du Lac", "", "US", "840", "", "WI", "039", "", "43.81138", "-88.48344", "America/Chicago"),("5264870", "North La Crosse", "", "US", "840", "", "WI", "063", "", "43.84635", "-91.24819", "America/Chicago"),("5265228", "Oak Creek", "", "US", "840", "", "WI", "079", "", "42.88585", "-87.86314", "America/Chicago"),("5265499", "Oconomowoc", "", "US", "840", "", "WI", "133", "", "43.11167", "-88.49927", "America/Chicago"),("5265702", "Onalaska", "", "US", "840", "", "WI", "063", "", "43.88441", "-91.23514", "America/Chicago"),("5265785", "Oregon", "", "US", "840", "", "WI", "025", "", "42.92611", "-89.38456", "America/Chicago"),("5265838", "Oshkosh", "Ошкош", "US", "840", "", "WI", "139", "", "44.02471", "-88.54261", "America/Chicago"),("5266731", "Pewaukee", "", "US", "840", "", "WI", "133", "", "43.08057", "-88.2612", "America/Chicago"),("5267332", "Platteville", "", "US", "840", "", "WI", "043", "", "42.73416", "-90.47846", "America/Chicago"),("5267403", "Pleasant Prairie", "", "US", "840", "", "WI", "059", "", "42.55308", "-87.93341", "America/Chicago"),("5267537", "Plover", "", "US", "840", "", "WI", "097", "", "44.45636", "-89.54401", "America/Chicago"),("5267585", "Plymouth", "", "US", "840", "", "WI", "117", "", "43.74861", "-87.97704", "America/Chicago"),("5267776", "Port Washington", "", "US", "840", "", "WI", "089", "", "43.38722", "-87.87564", "America/Chicago"),("5267785", "Portage", "", "US", "840", "", "WI", "021", "", "43.53915", "-89.46262", "America/Chicago"),("5268002", "Prairie du Chien", "", "US", "840", "", "WI", "023", "", "43.05165", "-91.14124", "America/Chicago"),("5268249", "Racine", "Расин", "US", "840", "", "WI", "101", "", "42.72613", "-87.78285", "America/Chicago"),("5268570", "Reedsburg", "", "US", "840", "", "WI", "111", "", "43.53248", "-90.00263", "America/Chicago"),("5268720", "Rhinelander", "", "US", "840", "", "WI", "085", "", "45.63662", "-89.41208", "America/Chicago"),("5268742", "Rib Mountain", "", "US", "840", "", "WI", "073", "", "44.91275", "-89.6754", "America/Chicago"),("5268798", "Rice Lake", "", "US", "840", "", "WI", "005", "", "45.50607", "-91.73823", "America/Chicago"),("5268838", "Richfield", "", "US", "840", "", "WI", "131", "", "43.25612", "-88.19398", "America/Chicago"),("5268850", "Richland Center", "", "US", "840", "", "WI", "103", "", "43.33471", "-90.38679", "America/Chicago"),("5268955", "Ripon", "", "US", "840", "", "WI", "039", "", "43.8422", "-88.83594", "America/Chicago"),("5268986", "River Falls", "", "US", "840", "", "WI", "093", "", "44.86136", "-92.62381", "America/Chicago"),("5269583", "Rothschild", "", "US", "840", "", "WI", "073", "", "44.88719", "-89.62012", "America/Chicago"),("5270249", "Saint Francis", "", "US", "840", "", "WI", "079", "", "42.96752", "-87.87758", "America/Chicago"),("5271991", "Salem", "", "US", "840", "", "WI", "059", "", "42.55474", "-88.11092", "America/Chicago"),("5272873", "Shawano", "", "US", "840", "", "WI", "115", "", "44.78221", "-88.60899", "America/Chicago"),("5272893", "Sheboygan", "Шебойган", "US", "840", "", "WI", "117", "", "43.75083", "-87.71453", "America/Chicago"),("5272907", "Sheboygan Falls", "", "US", "840", "", "WI", "117", "", "43.73197", "-87.82213", "America/Chicago"),("5273084", "Shorewood", "", "US", "840", "", "WI", "079", "", "43.08918", "-87.88758", "America/Chicago"),("5273439", "Slinger", "", "US", "840", "", "WI", "131", "", "43.33361", "-88.28621", "America/Chicago"),("5273614", "Somers", "", "US", "840", "", "WI", "059", "", "42.6403", "-87.91036", "America/Chicago"),("5273812", "South Milwaukee", "", "US", "840", "", "WI", "079", "", "42.91057", "-87.86064", "America/Chicago"),("5273927", "Sparta", "", "US", "840", "", "WI", "081", "", "43.94413", "-90.81291", "America/Chicago"),("5274644", "Stevens Point", "", "US", "840", "", "WI", "097", "", "44.52358", "-89.57456", "America/Chicago"),("5274787", "Stoughton", "", "US", "840", "", "WI", "025", "", "42.91695", "-89.21789", "America/Chicago"),("5274867", "Sturgeon Bay", "", "US", "840", "", "WI", "029", "", "44.83416", "-87.37704", "America/Chicago"),("5274885", "Sturtevant", "", "US", "840", "", "WI", "101", "", "42.69807", "-87.89452", "America/Chicago"),("5274887", "Suamico", "", "US", "840", "", "WI", "009", "", "44.63194", "-88.03927", "America/Chicago"),("5275020", "Sun Prairie", "", "US", "840", "", "WI", "025", "", "43.1836", "-89.21373", "America/Chicago"),("5275191", "Superior", "Сьюпириор", "US", "840", "", "WI", "031", "", "46.72077", "-92.10408", "America/Chicago"),("5275222", "Sussex", "", "US", "840", "", "WI", "133", "", "43.1339", "-88.22204", "America/Chicago"),("5275760", "Tichigan", "", "US", "840", "", "WI", "101", "", "42.8289", "-88.19759", "America/Chicago"),("5275871", "Tomah", "", "US", "840", "", "WI", "081", "", "43.97858", "-90.50402", "America/Chicago"),("5276542", "Twin Lakes", "", "US", "840", "", "WI", "059", "", "42.53113", "-88.24815", "America/Chicago"),("5276609", "Two Rivers", "", "US", "840", "", "WI", "071", "", "44.15388", "-87.56925", "America/Chicago"),("5277142", "Verona", "", "US", "840", "", "WI", "025", "", "42.99083", "-89.53318", "America/Chicago"),("5278003", "Waterford", "", "US", "840", "", "WI", "101", "", "42.76307", "-88.21426", "America/Chicago"),("5278005", "Watertown", "", "US", "840", "", "WI", "055", "", "43.19472", "-88.72899", "America/Chicago"),("5278052", "Waukesha", "Уокиша", "US", "840", "", "WI", "133", "", "43.01168", "-88.23148", "America/Chicago"),("5278073", "Waunakee", "", "US", "840", "", "WI", "025", "", "43.19194", "-89.45567", "America/Chicago"),("5278083", "Waupaca", "", "US", "840", "", "WI", "135", "", "44.35803", "-89.08595", "America/Chicago"),("5278106", "Waupun", "", "US", "840", "", "WI", "039", "", "43.63332", "-88.72955", "America/Chicago"),("5278120", "Wausau", "", "US", "840", "", "WI", "073", "", "44.95914", "-89.63012", "America/Chicago"),("5278159", "Wauwatosa", "", "US", "840", "", "WI", "079", "", "43.04946", "-88.00759", "America/Chicago"),("5278420", "West Allis", "", "US", "840", "", "WI", "079", "", "43.01668", "-88.00703", "America/Chicago"),("5278422", "West Bend", "", "US", "840", "", "WI", "131", "", "43.42528", "-88.18343", "America/Chicago"),("5278608", "West Salem", "", "US", "840", "", "WI", "063", "", "43.89913", "-91.08125", "America/Chicago"),("5278693", "Weston", "", "US", "840", "", "WI", "073", "", "44.8908", "-89.54762", "America/Chicago"),("5278897", "Whitefish Bay", "", "US", "840", "", "WI", "079", "", "43.11334", "-87.90009", "America/Chicago"),("5278931", "Whitewater", "", "US", "840", "", "WI", "127", "", "42.83362", "-88.73233", "America/Chicago"),("5279285", "Wind Lake", "", "US", "840", "", "WI", "101", "", "42.82946", "-88.1587", "America/Chicago"),("5279436", "Wisconsin Rapids", "", "US", "840", "", "WI", "141", "", "44.38358", "-89.81735", "America/Chicago"),("5280814", "Weirton", "Уиртон", "US", "840", "", "WV", "029", "", "40.41896", "-80.58952", "America/New_York"),("5280822", "Weirton Heights", "", "US", "840", "", "WV", "029", "", "40.4084", "-80.53924", "America/New_York"),("5280854", "Wheeling", "Уилинг", "US", "840", "", "WV", "069", "", "40.06396", "-80.72091", "America/New_York"),("5281551", "Ansonia", "", "US", "840", "", "CT", "009", "", "41.34621", "-73.079", "America/New_York"),("5282297", "Bethel", "", "US", "840", "", "CT", "001", "", "41.37121", "-73.41401", "America/New_York"),("5282804", "Bridgeport", "Бриджпорт", "US", "840", "", "CT", "001", "", "41.16704", "-73.20483", "America/New_York"),("5282835", "Bristol", "Бристол", "US", "840", "", "CT", "003", "", "41.67176", "-72.94927", "America/New_York"),("5283054", "Branford", "", "US", "840", "", "CT", "009", "", "41.27954", "-72.8151", "America/New_York"),("5283837", "Cheshire", "Чешир", "US", "840", "", "CT", "009", "", "41.49899", "-72.90066", "America/New_York"),("5284580", "Holbrook", "", "US", "840", "", "AZ", "017", "", "34.90225", "-110.15818", "America/Phoenix"),("5284756", "Fillmore", "", "US", "840", "", "CA", "111", "", "34.39916", "-118.91815", "America/Los_Angeles"),("5284905", "Bisbee", "", "US", "840", "", "AZ", "003", "", "31.44815", "-109.92841", "America/Phoenix"),("5287262", "Buckeye", "", "US", "840", "", "AZ", "013", "", "33.37032", "-112.58378", "America/Phoenix"),("5287565", "Bullhead City", "", "US", "840", "", "AZ", "015", "", "35.14778", "-114.5683", "America/Phoenix"),("5288261", "Camp Verde", "", "US", "840", "", "AZ", "025", "", "34.56364", "-111.85432", "America/Phoenix"),("5288636", "Casa Grande", "Каса-Гранде", "US", "840", "", "AZ", "021", "", "32.8795", "-111.75735", "America/Phoenix"),("5288661", "Casas Adobes", "", "US", "840", "", "AZ", "019", "", "32.32341", "-110.9951", "America/Phoenix"),("5288784", "Catalina", "", "US", "840", "", "AZ", "019", "", "32.50556", "-110.92111", "America/Phoenix"),("5288786", "Catalina Foothills", "", "US", "840", "", "AZ", "019", "", "32.29785", "-110.9187", "America/Phoenix"),("5288858", "Cave Creek", "", "US", "840", "", "AZ", "013", "", "33.83333", "-111.95083", "America/Phoenix"),("5289282", "Chandler", "Чандлер", "US", "840", "", "AZ", "013", "", "33.30616", "-111.84125", "America/Phoenix"),("5289658", "Chino Valley", "", "US", "840", "", "AZ", "025", "", "34.75752", "-112.45378", "America/Phoenix"),("5290663", "Coolidge", "", "US", "840", "", "AZ", "021", "", "32.97784", "-111.51762", "America/Phoenix"),("5290925", "Corona de Tucson", "", "US", "840", "", "AZ", "019", "", "31.96536", "-110.77564", "America/Phoenix"),("5291033", "Cottonwood", "", "US", "840", "", "AZ", "025", "", "34.73919", "-112.00988", "America/Phoenix"),("5293083", "Douglas", "", "US", "840", "", "AZ", "003", "", "31.34455", "-109.54534", "America/Phoenix"),("5293183", "Drexel Heights", "", "US", "840", "", "AZ", "019", "", "32.14119", "-111.02843", "America/Phoenix"),("5293996", "El Mirage", "", "US", "840", "", "AZ", "013", "", "33.61309", "-112.3246", "America/Phoenix"),("5294167", "Eloy", "", "US", "840", "", "AZ", "021", "", "32.7559", "-111.55484", "America/Phoenix"),("5294810", "Flagstaff", "Флагстафф", "US", "840", "", "AZ", "005", "", "35.19807", "-111.65127", "America/Phoenix"),("5294902", "Florence", "Флоренция", "US", "840", "", "AZ", "021", "", "33.03145", "-111.38734", "America/Phoenix"),("5294937", "Flowing Wells", "", "US", "840", "", "AZ", "019", "", "32.29396", "-111.00982", "America/Phoenix"),("5295143", "Fortuna Foothills", "", "US", "840", "", "AZ", "027", "", "32.65783", "-114.41189", "America/Phoenix"),("5295177", "Fountain Hills", "", "US", "840", "", "AZ", "013", "", "33.61171", "-111.71736", "America/Phoenix"),("5295903", "Gilbert", "Гилберт", "US", "840", "", "AZ", "013", "", "33.35283", "-111.78903", "America/Phoenix"),("5295985", "Glendale", "Глендейл", "US", "840", "", "AZ", "013", "", "33.53865", "-112.18599", "America/Phoenix"),("5296013", "Globe", "", "US", "840", "", "AZ", "007", "", "33.39422", "-110.7865", "America/Phoenix"),("5296106", "Gold Camp", "", "US", "840", "", "AZ", "021", "", "33.29367", "-111.30429", "America/Phoenix"),("5296189", "Golden Valley", "", "US", "840", "", "AZ", "015", "", "35.22333", "-114.22301", "America/Phoenix"),("5296266", "Goodyear", "Гудиер", "US", "840", "", "AZ", "013", "", "33.43532", "-112.35821", "America/Phoenix"),("5296802", "Green Valley", "", "US", "840", "", "AZ", "019", "", "31.85425", "-110.9937", "America/Phoenix"),("5296962", "Guadalupe", "", "US", "840", "", "AZ", "013", "", "33.37088", "-111.96292", "America/Phoenix"),("5300830", "Kayenta", "", "US", "840", "", "AZ", "017", "", "36.72778", "-110.25458", "America/Denver"),("5301067", "Kingman", "Кингмен", "US", "840", "", "AZ", "015", "", "35.18944", "-114.05301", "America/Phoenix"),("5301388", "Lake Havasu City", "Лейк-Хавасу-Сити", "US", "840", "", "AZ", "015", "", "34.4839", "-114.32245", "America/Phoenix"),("5301641", "Laveen", "", "US", "840", "", "AZ", "013", "", "33.36282", "-112.16932", "America/Phoenix"),("5302053", "Litchfield Park", "", "US", "840", "", "AZ", "013", "", "33.49337", "-112.35794", "America/Phoenix"),("5303705", "Marana", "", "US", "840", "", "AZ", "019", "", "32.43674", "-111.22538", "America/Phoenix"),("5303752", "Maricopa", "", "US", "840", "", "AZ", "021", "", "33.05811", "-112.04764", "America/Phoenix"),("5304391", "Mesa", "Меса", "US", "840", "", "AZ", "013", "", "33.42227", "-111.82264", "America/Phoenix"),("5306523", "New River", "", "US", "840", "", "AZ", "013", "", "33.91587", "-112.13599", "America/Phoenix"),("5306611", "Nogales", "Ногалес", "US", "840", "", "AZ", "023", "", "31.34038", "-110.93425", "America/Phoenix"),("5307540", "Oro Valley", "", "US", "840", "", "AZ", "019", "", "32.39091", "-110.96649", "America/Phoenix"),("5307778", "Page", "", "US", "840", "", "AZ", "005", "", "36.91472", "-111.45583", "America/Phoenix"),("5308049", "Paradise Valley", "", "US", "840", "", "AZ", "013", "", "33.53115", "-111.94265", "America/Phoenix"),("5308281", "Paulden", "", "US", "840", "", "AZ", "025", "", "34.88558", "-112.46823", "America/Phoenix"),("5308305", "Payson", "", "US", "840", "", "AZ", "007", "", "34.23087", "-111.32514", "America/Phoenix"),("5308480", "Peoria", "Пеория", "US", "840", "", "AZ", "013", "", "33.5806", "-112.23738", "America/Phoenix"),("5308655", "Phoenix", "Финикс", "US", "840", "", "AZ", "013", "", "33.44838", "-112.07404", "America/Phoenix"),("5308778", "Picture Rocks", "", "US", "840", "", "AZ", "019", "", "32.34591", "-111.24621", "America/Phoenix"),("5309842", "Prescott", "Прескотт", "US", "840", "", "AZ", "025", "", "34.54002", "-112.4685", "America/Phoenix"),("5309858", "Prescott Valley", "", "US", "840", "", "AZ", "025", "", "34.61002", "-112.31572", "America/Phoenix"),("5310193", "Queen Creek", "", "US", "840", "", "AZ", "013", "", "33.24866", "-111.6343", "America/Phoenix"),("5311433", "Rio Rico", "", "US", "840", "", "AZ", "023", "", "31.47148", "-110.97648", "America/Phoenix"),("5312476", "Safford", "", "US", "840", "", "AZ", "009", "", "32.83395", "-109.70758", "America/Phoenix"),("5312544", "Sahuarita", "", "US", "840", "", "AZ", "019", "", "31.95758", "-110.95565", "America/Phoenix"),("5312913", "San Luis", "", "US", "840", "", "AZ", "027", "", "32.487", "-114.78218", "America/Phoenix"),("5313457", "Scottsdale", "Скоттсдейл", "US", "840", "", "AZ", "013", "", "33.50921", "-111.89903", "America/Phoenix"),("5313667", "Sedona", "", "US", "840", "", "AZ", "005", "", "34.86974", "-111.76099", "America/Phoenix"),("5314245", "Show Low", "", "US", "840", "", "AZ", "017", "", "34.25421", "-110.02983", "America/Phoenix"),("5314328", "Sierra Vista", "Сьерра-Виста", "US", "840", "", "AZ", "003", "", "31.55454", "-110.30369", "America/Phoenix"),("5314943", "Snowflake", "", "US", "840", "", "AZ", "017", "", "34.51337", "-110.07845", "America/Phoenix"),("5315062", "Somerton", "", "US", "840", "", "AZ", "027", "", "32.59644", "-114.70968", "America/Phoenix"),("5315313", "South Tucson", "", "US", "840", "", "AZ", "019", "", "32.19952", "-110.96842", "America/Phoenix"),("5316172", "Summit", "", "US", "840", "", "AZ", "019", "", "32.06702", "-110.95148", "America/Phoenix"),("5316201", "Sun City", "", "US", "840", "", "AZ", "013", "", "33.59754", "-112.27182", "America/Phoenix"),("5316205", "Sun City West", "", "US", "840", "", "AZ", "013", "", "33.66198", "-112.34127", "America/Phoenix"),("5316209", "Sun Lakes", "", "US", "840", "", "AZ", "013", "", "33.21116", "-111.87542", "America/Phoenix"),("5316428", "Surprise", "Сюрприз", "US", "840", "", "AZ", "013", "", "33.63059", "-112.33322", "America/Phoenix"),("5316890", "Tanque Verde", "", "US", "840", "", "AZ", "019", "", "32.25174", "-110.73731", "America/Phoenix"),("5317058", "Tempe", "Темпе", "US", "840", "", "AZ", "013", "", "33.41477", "-111.90931", "America/Phoenix"),("5317071", "Tempe Junction", "", "US", "840", "", "AZ", "013", "", "33.41421", "-111.94348", "America/Phoenix"),("5317377", "Three Points", "", "US", "840", "", "AZ", "019", "", "32.07675", "-111.31371", "America/Phoenix"),("5317663", "Tolleson", "", "US", "840", "", "AZ", "013", "", "33.45004", "-112.25932", "America/Phoenix"),("5318279", "Tuba City", "", "US", "840", "", "AZ", "005", "", "36.13499", "-111.23986", "America/Denver"),("5318313", "Tucson", "Тусон", "US", "840", "", "AZ", "019", "", "32.22174", "-110.92648", "America/Phoenix"),("5318320", "Tucson Estates", "", "US", "840", "", "AZ", "019", "", "32.18758", "-111.09093", "America/Phoenix"),("5319311", "Vail", "", "US", "840", "", "AZ", "019", "", "32.04786", "-110.71203", "America/Phoenix"),("5320871", "Wickenburg", "", "US", "840", "", "AZ", "013", "", "33.96864", "-112.72962", "America/Phoenix"),("5321135", "Williamson", "", "US", "840", "", "AZ", "025", "", "34.69002", "-112.54101", "America/Phoenix"),("5321473", "Winslow", "", "US", "840", "", "AZ", "017", "", "35.02419", "-110.69736", "America/Phoenix"),("5322027", "Youngtown", "", "US", "840", "", "AZ", "013", "", "33.59393", "-112.30294", "America/Phoenix"),("5322053", "Yuma", "Юма", "US", "840", "", "AZ", "027", "", "32.72532", "-114.6244", "America/Phoenix"),("5322317", "Acton", "", "US", "840", "", "CA", "037", "", "34.46999", "-118.19674", "America/Los_Angeles"),("5322400", "Adelanto", "", "US", "840", "", "CA", "071", "", "34.58277", "-117.40922", "America/Los_Angeles"),("5322551", "Agoura", "", "US", "840", "", "CA", "037", "", "34.14306", "-118.73787", "America/Los_Angeles"),("5322553", "Agoura Hills", "", "US", "840", "", "CA", "037", "", "34.13639", "-118.77453", "America/Los_Angeles"),("5322737", "Alameda", "Аламеда", "US", "840", "", "CA", "001", "", "37.76521", "-122.24164", "America/Los_Angeles"),("5322794", "Alamo", "", "US", "840", "", "CA", "013", "", "37.8502", "-122.03218", "America/Los_Angeles"),("5322850", "Albany", "Олбани", "US", "840", "", "CA", "001", "", "37.88687", "-122.29775", "America/Los_Angeles"),("5323060", "Alhambra", "Альгамбра", "US", "840", "", "CA", "037", "", "34.09529", "-118.12701", "America/Los_Angeles"),("5323163", "Aliso Viejo", "", "US", "840", "", "CA", "059", "", "33.56504", "-117.72712", "America/Los_Angeles"),("5323371", "Alondra Park", "", "US", "840", "", "CA", "037", "", "33.88946", "-118.33091", "America/Los_Angeles"),("5323401", "Alpine", "", "US", "840", "", "CA", "073", "", "32.83505", "-116.76641", "America/Los_Angeles"),("5323499", "Alta Sierra", "", "US", "840", "", "CA", "029", "", "35.73126", "-118.5539", "America/Los_Angeles"),("5323500", "Alta Sierra", "", "US", "840", "", "CA", "057", "", "39.14156", "-121.05384", "America/Los_Angeles"),("5323525", "Altadena", "Альтадена", "US", "840", "", "CA", "037", "", "34.18973", "-118.13118", "America/Los_Angeles"),("5323566", "Alum Rock", "", "US", "840", "", "CA", "085", "", "37.36605", "-121.82718", "America/Los_Angeles"),("5323694", "American Canyon", "", "US", "840", "", "CA", "055", "", "38.17492", "-122.2608", "America/Los_Angeles"),("5323810", "Anaheim", "Анахайм", "US", "840", "", "CA", "059", "", "33.83529", "-117.9145", "America/Los_Angeles"),("5324105", "Antelope", "", "US", "840", "", "CA", "067", "", "38.70824", "-121.32995", "America/Los_Angeles"),("5324200", "Antioch", "", "US", "840", "", "CA", "013", "", "38.00492", "-121.80579", "America/Los_Angeles"),("5324363", "Apple Valley", "", "US", "840", "", "CA", "071", "", "34.50083", "-117.18588", "America/Los_Angeles"),("5324400", "Aptos", "", "US", "840", "", "CA", "087", "", "36.97717", "-121.8994", "America/Los_Angeles"),("5324477", "Arcadia", "Аркадия", "US", "840", "", "CA", "037", "", "34.13973", "-118.03534", "America/Los_Angeles"),("5324802", "Arroyo Grande", "", "US", "840", "", "CA", "079", "", "35.11859", "-120.59073", "America/Los_Angeles"),("5324862", "Artesia", "Артижа", "US", "840", "", "CA", "037", "", "33.86585", "-118.08312", "America/Los_Angeles"),("5324903", "Arvin", "", "US", "840", "", "CA", "029", "", "35.20913", "-118.82843", "America/Los_Angeles"),("5325011", "Ashland", "", "US", "840", "", "CA", "001", "", "37.69465", "-122.11385", "America/Los_Angeles"),("5325111", "Atascadero", "", "US", "840", "", "CA", "079", "", "35.48942", "-120.67073", "America/Los_Angeles"),("5325147", "Atherton", "", "US", "840", "", "CA", "081", "", "37.46133", "-122.19774", "America/Los_Angeles"),("5325187", "Atwater", "", "US", "840", "", "CA", "047", "", "37.34772", "-120.60908", "America/Los_Angeles"),("5325223", "Auburn", "", "US", "840", "", "CA", "061", "", "38.89657", "-121.07689", "America/Los_Angeles"),("5325256", "August", "", "US", "840", "", "CA", "077", "", "37.97881", "-121.26217", "America/Los_Angeles"),("5325327", "Avenal", "", "US", "840", "", "CA", "031", "", "36.00412", "-120.12903", "America/Los_Angeles"),("5325372", "Avocado Heights", "", "US", "840", "", "CA", "037", "", "34.03612", "-117.99118", "America/Los_Angeles"),("5325423", "Azusa", "Азуса", "US", "840", "", "CA", "037", "", "34.13362", "-117.90756", "America/Los_Angeles"),("5325738", "Bakersfield", "Бейкерсфилд", "US", "840", "", "CA", "029", "", "35.37329", "-119.01871", "America/Los_Angeles"),("5325866", "Baldwin Park", "Болдуин-Парк", "US", "840", "", "CA", "037", "", "34.08529", "-117.9609", "America/Los_Angeles"),("5326032", "Banning", "", "US", "840", "", "CA", "065", "", "33.92557", "-116.87641", "America/Los_Angeles"),("5326297", "Barstow", "Барстоу", "US", "840", "", "CA", "071", "", "34.89859", "-117.02282", "America/Los_Angeles"),("5326305", "Barstow Heights", "", "US", "840", "", "CA", "071", "", "34.86971", "-117.05615", "America/Los_Angeles"),("5326561", "Bay Point", "", "US", "840", "", "CA", "013", "", "38.02909", "-121.96163", "America/Los_Angeles"),("5327003", "Bear Valley Springs", "", "US", "840", "", "CA", "029", "", "35.15913", "-118.62842", "America/Los_Angeles"),("5327098", "Beaumont", "", "US", "840", "", "CA", "065", "", "33.92946", "-116.97725", "America/Los_Angeles"),("5327298", "Bell", "Белла", "US", "840", "", "CA", "037", "", "33.97751", "-118.18702", "America/Los_Angeles"),("5327319", "Bell Gardens", "", "US", "840", "", "CA", "037", "", "33.96529", "-118.15146", "America/Los_Angeles"),("5327422", "Bellflower", "Беллфлауэр", "US", "840", "", "CA", "037", "", "33.88168", "-118.11701", "America/Los_Angeles"),("5327455", "Belmont", "Белмонт", "US", "840", "", "CA", "081", "", "37.52021", "-122.2758", "America/Los_Angeles"),("5327522", "Ben Lomond", "", "US", "840", "", "CA", "087", "", "37.08911", "-122.08635", "America/Los_Angeles"),("5327550", "Benicia", "", "US", "840", "", "CA", "095", "", "38.04937", "-122.15858", "America/Los_Angeles"),("5327684", "Berkeley", "Беркли", "US", "840", "", "CA", "001", "", "37.87159", "-122.27275", "America/Los_Angeles"),("5327717", "Bermuda Dunes", "", "US", "840", "", "CA", "065", "", "33.7428", "-116.28918", "America/Los_Angeles"),("5328041", "Beverly Hills", "", "US", "840", "", "CA", "037", "", "34.07362", "-118.40036", "America/Los_Angeles"),("5328152", "Big Bear City", "", "US", "840", "", "CA", "071", "", "34.26112", "-116.84503", "America/Los_Angeles"),("5328163", "Big Bear Lake", "", "US", "840", "", "CA", "071", "", "34.2439", "-116.91142", "America/Los_Angeles"),("5329204", "Blackhawk", "", "US", "840", "", "CA", "013", "", "37.82076", "-121.90774", "America/Los_Angeles"),("5329408", "Bloomington", "Блумингтон", "US", "840", "", "CA", "071", "", "34.07029", "-117.39588", "America/Los_Angeles"),("5329649", "Blythe", "Блайт", "US", "840", "", "CA", "065", "", "33.6103", "-114.59635", "America/Los_Angeles"),("5329954", "Bonita", "", "US", "840", "", "CA", "073", "", "32.65783", "-117.03003", "America/Los_Angeles"),("5330167", "Bostonia", "", "US", "840", "", "CA", "073", "", "32.80755", "-116.93642", "America/Los_Angeles"),("5330413", "Boyle Heights", "", "US", "840", "", "CA", "037", "", "34.0339", "-118.20535", "America/Los_Angeles"),("5330427", "Boyes Hot Springs", "", "US", "840", "", "CA", "097", "", "38.3138", "-122.48193", "America/Los_Angeles"),("5330567", "Brawley", "", "US", "840", "", "CA", "025", "", "32.97866", "-115.53027", "America/Los_Angeles"),("5330582", "Brea", "", "US", "840", "", "CA", "059", "", "33.91668", "-117.90006", "America/Los_Angeles"),("5330642", "Brentwood", "", "US", "840", "", "CA", "013", "", "37.93187", "-121.69579", "America/Los_Angeles"),("5331568", "Buellton", "", "US", "840", "", "CA", "083", "", "34.6136", "-120.19265", "America/Los_Angeles"),("5331575", "Buena Park", "", "US", "840", "", "CA", "059", "", "33.86751", "-117.99812", "America/Los_Angeles"),("5331835", "Burbank", "Бербанк", "US", "840", "", "CA", "037", "", "34.18084", "-118.30897", "America/Los_Angeles"),("5331920", "Burlingame", "Берлингем", "US", "840", "", "CA", "081", "", "37.5841", "-122.36608", "America/Los_Angeles"),("5332593", "Calabasas", "Калабасас", "US", "840", "", "CA", "037", "", "34.15778", "-118.63842", "America/Los_Angeles"),("5332698", "Calexico", "Калексико", "US", "840", "", "CA", "025", "", "32.67895", "-115.49888", "America/Los_Angeles"),("5332748", "California City", "", "US", "840", "", "CA", "029", "", "35.1258", "-117.9859", "America/Los_Angeles"),("5332929", "Calipatria", "", "US", "840", "", "CA", "025", "", "33.1256", "-115.51415", "America/Los_Angeles"),("5332937", "Calistoga", "", "US", "840", "", "CA", "055", "", "38.5788", "-122.57971", "America/Los_Angeles"),("5332957", "Calimesa", "", "US", "840", "", "CA", "065", "", "34.0039", "-117.06198", "America/Los_Angeles"),("5333180", "Camarillo", "", "US", "840", "", "CA", "111", "", "34.21639", "-119.0376", "America/Los_Angeles"),("5333207", "Cambria", "", "US", "840", "", "CA", "079", "", "35.56414", "-121.08075", "America/Los_Angeles"),("5333282", "Cameron Park", "", "US", "840", "", "CA", "017", "", "38.66879", "-120.98716", "America/Los_Angeles"),("5333689", "Campbell", "Кэмпбелл", "US", "840", "", "CA", "085", "", "37.28717", "-121.94996", "America/Los_Angeles"),("5333913", "Canoga Park", "", "US", "840", "", "CA", "037", "", "34.20112", "-118.59814", "America/Los_Angeles"),("5333976", "Canyon Lake", "", "US", "840", "", "CA", "065", "", "33.68502", "-117.27309", "America/Los_Angeles"),("5334096", "Capitola", "", "US", "840", "", "CA", "087", "", "36.97523", "-121.95329", "America/Los_Angeles"),("5334223", "Carlsbad", "Карлсбад", "US", "840", "", "CA", "073", "", "33.15809", "-117.35059", "America/Los_Angeles"),("5334336", "Carmichael", "Кармайкл", "US", "840", "", "CA", "067", "", "38.61713", "-121.32828", "America/Los_Angeles"),("5334423", "Carpinteria", "", "US", "840", "", "CA", "083", "", "34.39888", "-119.51846", "America/Los_Angeles"),("5334519", "Carson", "Карсон", "US", "840", "", "CA", "037", "", "33.83141", "-118.28202", "America/Los_Angeles"),("5334799", "Castaic", "", "US", "840", "", "CA", "037", "", "34.48888", "-118.62287", "America/Los_Angeles"),("5334928", "Castro Valley", "", "US", "840", "", "CA", "001", "", "37.6941", "-122.08635", "America/Los_Angeles"),("5334937", "Castroville", "", "US", "840", "", "CA", "053", "", "36.76579", "-121.758", "America/Los_Angeles"),("5335006", "Cathedral City", "", "US", "840", "", "CA", "065", "", "33.77974", "-116.46529", "America/Los_Angeles"),("5335650", "Ceres", "Церера", "US", "840", "", "CA", "099", "", "37.59493", "-120.95771", "America/Los_Angeles"),("5335662", "Century City", "", "US", "840", "", "CA", "037", "", "34.05557", "-118.41786", "America/Los_Angeles"),("5335663", "Cerritos", "Серритос", "US", "840", "", "CA", "037", "", "33.85835", "-118.06479", "America/Los_Angeles"),("5336017", "Charter Oak", "", "US", "840", "", "CA", "037", "", "34.10306", "-117.84589", "America/Los_Angeles"),("5336054", "Chatsworth", "", "US", "840", "", "CA", "037", "", "34.25723", "-118.6012", "America/Los_Angeles"),("5336185", "Cherry Valley", "", "US", "840", "", "CA", "065", "", "33.97252", "-116.97725", "America/Los_Angeles"),("5336190", "Cherryland", "", "US", "840", "", "CA", "001", "", "37.67938", "-122.1033", "America/Los_Angeles"),("5336269", "Chico", "Чико", "US", "840", "", "CA", "007", "", "39.72849", "-121.83748", "America/Los_Angeles"),("5336537", "Chino", "Чино", "US", "840", "", "CA", "071", "", "34.01223", "-117.68894", "America/Los_Angeles"),("5336545", "Chino Hills", "", "US", "840", "", "CA", "071", "", "33.9938", "-117.75888", "America/Los_Angeles"),("5336667", "Chowchilla", "", "US", "840", "", "CA", "039", "", "37.123", "-120.26018", "America/Los_Angeles"),("5336899", "Chula Vista", "Чула-Виста", "US", "840", "", "CA", "073", "", "32.64005", "-117.0842", "America/Los_Angeles"),("5337551", "Citrus", "", "US", "840", "", "CA", "037", "", "34.11501", "-117.89173", "America/Los_Angeles"),("5337561", "Citrus Heights", "", "US", "840", "", "CA", "067", "", "38.70712", "-121.28106", "America/Los_Angeles"),("5337696", "Claremont", "Клермонт", "US", "840", "", "CA", "037", "", "34.09668", "-117.71978", "America/Los_Angeles"),("5337841", "Clayton", "", "US", "840", "", "CA", "013", "", "37.94103", "-121.93579", "America/Los_Angeles"),("5337908", "Clearlake", "", "US", "840", "", "CA", "033", "", "38.95823", "-122.62637", "America/Los_Angeles"),("5338104", "Cloverdale", "", "US", "840", "", "CA", "097", "", "38.80546", "-123.01722", "America/Los_Angeles"),("5338122", "Clovis", "Кловис", "US", "840", "", "CA", "019", "", "36.82523", "-119.70292", "America/Los_Angeles"),("5338166", "Coachella", "", "US", "840", "", "CA", "065", "", "33.6803", "-116.17389", "America/Los_Angeles"),("5338196", "Coalinga", "", "US", "840", "", "CA", "019", "", "36.13968", "-120.36015", "America/Los_Angeles"),("5338783", "Colton", "Колтон", "US", "840", "", "CA", "071", "", "34.0739", "-117.31365", "America/Los_Angeles"),("5338866", "Colusa", "", "US", "840", "", "CA", "011", "", "39.21433", "-122.00942", "America/Los_Angeles"),("5338929", "Commerce", "", "US", "840", "", "CA", "037", "", "34.00057", "-118.15979", "America/Los_Angeles"),("5339066", "Compton", "Комптон", "US", "840", "", "CA", "037", "", "33.89585", "-118.22007", "America/Los_Angeles"),("5339111", "Concord", "Конкорд", "US", "840", "", "CA", "013", "", "37.97798", "-122.03107", "America/Los_Angeles"),("5339539", "Corcoran", "Коркоран", "US", "840", "", "CA", "031", "", "36.09801", "-119.5604", "America/Los_Angeles"),("5339614", "Corning", "", "US", "840", "", "CA", "103", "", "39.92766", "-122.17916", "America/Los_Angeles"),("5339631", "Corona", "", "US", "840", "", "CA", "065", "", "33.87529", "-117.56644", "America/Los_Angeles"),("5339663", "Coronado", "Коронадо", "US", "840", "", "CA", "073", "", "32.68589", "-117.18309", "America/Los_Angeles"),("5339766", "Corte Madera", "", "US", "840", "", "CA", "041", "", "37.92548", "-122.52748", "America/Los_Angeles"),("5339840", "Costa Mesa", "Коста-Меса", "US", "840", "", "CA", "059", "", "33.64113", "-117.91867", "America/Los_Angeles"),("5339865", "Cotati", "", "US", "840", "", "CA", "097", "", "38.32686", "-122.70721", "America/Los_Angeles"),("5339873", "Coto De Caza", "", "US", "840", "", "CA", "059", "", "33.60419", "-117.58699", "America/Los_Angeles"),("5340066", "Country Club", "", "US", "840", "", "CA", "077", "", "37.96881", "-121.34078", "America/Los_Angeles"),("5340175", "Covina", "Ковина", "US", "840", "", "CA", "037", "", "34.09001", "-117.89034", "America/Los_Angeles"),("5340674", "Crestline", "", "US", "840", "", "CA", "071", "", "34.24195", "-117.2856", "America/Los_Angeles"),("5341051", "Cudahy", "Кадахи", "US", "840", "", "CA", "037", "", "33.96057", "-118.18535", "America/Los_Angeles"),("5341114", "Culver City", "Калвер-Сити", "US", "840", "", "CA", "037", "", "34.02112", "-118.39647", "America/Los_Angeles"),("5341145", "Cupertino", "Купертино", "US", "840", "", "CA", "085", "", "37.323", "-122.03218", "America/Los_Angeles"),("5341256", "Cypress", "", "US", "840", "", "CA", "059", "", "33.81696", "-118.03729", "America/Los_Angeles"),("5341430", "Daly City", "", "US", "840", "", "CA", "081", "", "37.70577", "-122.46192", "America/Los_Angeles"),("5341483", "Dana Point", "", "US", "840", "", "CA", "059", "", "33.46697", "-117.69811", "America/Los_Angeles"),("5341531", "Danville", "", "US", "840", "", "CA", "013", "", "37.82159", "-121.99996", "America/Los_Angeles"),("5341704", "Davis", "Дейвис", "US", "840", "", "CA", "113", "", "38.54491", "-121.74052", "America/Los_Angeles"),("5342425", "Del Aire", "", "US", "840", "", "CA", "037", "", "33.91613", "-118.36952", "America/Los_Angeles"),("5342485", "Delano", "Делано", "US", "840", "", "CA", "029", "", "35.76884", "-119.24705", "America/Los_Angeles"),("5342522", "Delhi", "", "US", "840", "", "CA", "047", "", "37.43216", "-120.77854", "America/Los_Angeles"),("5342710", "Desert Hot Springs", "", "US", "840", "", "CA", "065", "", "33.96173", "-116.50353", "America/Los_Angeles"),("5342992", "Diamond Bar", "Даймонд-Бар", "US", "840", "", "CA", "037", "", "34.02862", "-117.81034", "America/Los_Angeles"),("5343038", "Diamond Springs", "", "US", "840", "", "CA", "017", "", "38.69463", "-120.81494", "America/Los_Angeles"),("5343171", "Dinuba", "", "US", "840", "", "CA", "107", "", "36.54328", "-119.38707", "America/Los_Angeles"),("5343202", "Discovery Bay", "", "US", "840", "", "CA", "013", "", "37.90854", "-121.60023", "America/Los_Angeles"),("5343303", "Dixon", "", "US", "840", "", "CA", "095", "", "38.44546", "-121.8233", "America/Los_Angeles"),("5343728", "Dos Palos", "", "US", "840", "", "CA", "047", "", "36.98606", "-120.62657", "America/Los_Angeles"),("5343858", "Downey", "Дауни", "US", "840", "", "CA", "037", "", "33.94001", "-118.13257", "America/Los_Angeles"),("5344147", "Duarte", "Дуарте", "US", "840", "", "CA", "037", "", "34.13945", "-117.97729", "America/Los_Angeles"),("5344157", "Dublin", "Дублин", "US", "840", "", "CA", "001", "", "37.70215", "-121.93579", "America/Los_Angeles"),("5344359", "Durham", "", "US", "840", "", "CA", "007", "", "39.64627", "-121.79998", "America/Los_Angeles"),("5344702", "Earlimart", "", "US", "840", "", "CA", "107", "", "35.88412", "-119.27233", "America/Los_Angeles"),("5344817", "East Rancho Dominguez", "", "US", "840", "", "CA", "037", "", "33.89807", "-118.19535", "America/Los_Angeles"),("5344844", "East Foothills", "", "US", "840", "", "CA", "085", "", "37.38105", "-121.81745", "America/Los_Angeles"),("5344942", "East Hemet", "", "US", "840", "", "CA", "065", "", "33.74002", "-116.93891", "America/Los_Angeles"),("5344987", "East La Mirada", "", "US", "840", "", "CA", "037", "", "33.92446", "-117.98895", "America/Los_Angeles"),("5344994", "East Los Angeles", "", "US", "840", "", "CA", "037", "", "34.0239", "-118.17202", "America/Los_Angeles"),("5345032", "East Palo Alto", "", "US", "840", "", "CA", "081", "", "37.46883", "-122.14108", "America/Los_Angeles"),("5345038", "East Pasadena", "", "US", "840", "", "CA", "037", "", "34.13814", "-118.07384", "America/Los_Angeles"),("5345049", "East Porterville", "", "US", "840", "", "CA", "107", "", "36.05745", "-118.97566", "America/Los_Angeles"),("5345071", "East San Gabriel", "", "US", "840", "", "CA", "037", "", "34.09168", "-118.09118", "America/Los_Angeles"),("5345529", "El Cajon", "", "US", "840", "", "CA", "073", "", "32.79477", "-116.96253", "America/Los_Angeles"),("5345609", "El Centro", "Эль-Сентро", "US", "840", "", "CA", "025", "", "32.792", "-115.56305", "America/Los_Angeles"),("5345623", "El Cerrito", "", "US", "840", "", "CA", "013", "", "37.91576", "-122.31164", "America/Los_Angeles"),("5345624", "El Cerrito", "", "US", "840", "", "CA", "065", "", "33.84057", "-117.52283", "America/Los_Angeles"),("5345679", "El Dorado Hills", "", "US", "840", "", "CA", "017", "", "38.68574", "-121.08217", "America/Los_Angeles"),("5345716", "El Granada", "", "US", "840", "", "CA", "081", "", "37.50272", "-122.46942", "America/Los_Angeles"),("5345743", "El Monte", "Эль-Монте", "US", "840", "", "CA", "037", "", "34.06862", "-118.02757", "America/Los_Angeles"),("5345844", "El Rio", "", "US", "840", "", "CA", "111", "", "34.23578", "-119.16383", "America/Los_Angeles"),("5345860", "El Segundo", "", "US", "840", "", "CA", "037", "", "33.91918", "-118.41647", "America/Los_Angeles"),("5345888", "El Sobrante", "", "US", "840", "", "CA", "013", "", "37.97715", "-122.29525", "America/Los_Angeles"),("5346111", "Elk Grove", "", "US", "840", "", "CA", "067", "", "38.4088", "-121.37162", "America/Los_Angeles"),("5346342", "Elverta", "", "US", "840", "", "CA", "067", "", "38.71379", "-121.46273", "America/Los_Angeles"),("5346462", "Emeryville", "", "US", "840", "", "CA", "001", "", "37.83132", "-122.28525", "America/Los_Angeles"),("5346646", "Encinitas", "Энсинитас", "US", "840", "", "CA", "073", "", "33.03699", "-117.29198", "America/Los_Angeles"),("5346811", "Escalon", "", "US", "840", "", "CA", "077", "", "37.79781", "-120.99792", "America/Los_Angeles"),("5346827", "Escondido", "", "US", "840", "", "CA", "073", "", "33.11921", "-117.08642", "America/Los_Angeles"),("5346986", "Eucalyptus Hills", "", "US", "840", "", "CA", "073", "", "32.87977", "-116.94669", "America/Los_Angeles"),("5347239", "Exeter", "", "US", "840", "", "CA", "107", "", "36.29606", "-119.14205", "America/Los_Angeles"),("5347287", "Fair Oaks", "", "US", "840", "", "CA", "067", "", "38.64463", "-121.27217", "America/Los_Angeles"),("5347322", "Fairfax", "", "US", "840", "", "CA", "041", "", "37.98715", "-122.58887", "America/Los_Angeles"),("5347335", "Fairfield", "", "US", "840", "", "CA", "095", "", "38.24936", "-122.03997", "America/Los_Angeles"),("5347397", "Fairview", "", "US", "840", "", "CA", "001", "", "37.67854", "-122.0458", "America/Los_Angeles"),("5347578", "Fallbrook", "", "US", "840", "", "CA", "073", "", "33.37642", "-117.25115", "America/Los_Angeles"),("5347742", "Farmersville", "", "US", "840", "", "CA", "107", "", "36.29773", "-119.20678", "America/Los_Angeles"),("5348299", "Firebaugh", "", "US", "840", "", "CA", "019", "", "36.85884", "-120.45601", "America/Los_Angeles"),("5349613", "Florin", "Флорин", "US", "840", "", "CA", "067", "", "38.49602", "-121.40884", "America/Los_Angeles"),("5349705", "Folsom", "", "US", "840", "", "CA", "067", "", "38.67796", "-121.17606", "America/Los_Angeles"),("5349755", "Fontana", "Фонтана", "US", "840", "", "CA", "071", "", "34.09223", "-117.43505", "America/Los_Angeles"),("5349803", "Foothill Farms", "", "US", "840", "", "CA", "067", "", "38.67877", "-121.35114", "America/Los_Angeles"),("5349828", "Foothill Ranch", "", "US", "840", "", "CA", "059", "", "33.68641", "-117.66088", "America/Los_Angeles"),("5350039", "Fort Bragg", "", "US", "840", "", "CA", "045", "", "39.44572", "-123.80529", "America/Los_Angeles"),("5350057", "Fort Irwin", "", "US", "840", "", "CA", "071", "", "35.26275", "-116.68475", "America/Los_Angeles"),("5350159", "Foster City", "", "US", "840", "", "CA", "081", "", "37.55855", "-122.27108", "America/Los_Angeles"),("5350207", "Fountain Valley", "", "US", "840", "", "CA", "059", "", "33.70918", "-117.95367", "America/Los_Angeles"),("5350351", "Fowler", "", "US", "840", "", "CA", "019", "", "36.63051", "-119.67847", "America/Los_Angeles"),("5350734", "Fremont", "Фримонт", "US", "840", "", "CA", "001", "", "37.54827", "-121.98857", "America/Los_Angeles"),("5350937", "Fresno", "Фресно", "US", "840", "", "CA", "019", "", "36.74773", "-119.77237", "America/Los_Angeles"),("5351247", "Fullerton", "Фуллертон", "US", "840", "", "CA", "059", "", "33.87029", "-117.92534", "America/Los_Angeles"),("5351428", "Galt", "Галт", "US", "840", "", "CA", "067", "", "38.25464", "-121.29995", "America/Los_Angeles"),("5351496", "Garden Acres", "", "US", "840", "", "CA", "077", "", "37.96381", "-121.22939", "America/Los_Angeles"),("5351515", "Garden Grove", "", "US", "840", "", "CA", "059", "", "33.77391", "-117.94145", "America/Los_Angeles"),("5351549", "Gardena", "Гардина", "US", "840", "", "CA", "037", "", "33.88835", "-118.30896", "America/Los_Angeles"),("5351654", "Garnet", "", "US", "840", "", "CA", "065", "", "33.90196", "-116.54557", "America/Los_Angeles"),("5352214", "Gilroy", "", "US", "840", "", "CA", "085", "", "37.00578", "-121.56828", "America/Los_Angeles"),("5352350", "Glen Avon", "", "US", "840", "", "CA", "065", "", "34.01168", "-117.48477", "America/Los_Angeles"),("5352423", "Glendale", "Глендейл", "US", "840", "", "CA", "037", "", "34.14251", "-118.25508", "America/Los_Angeles"),("5352439", "Glendora", "Глендора", "US", "840", "", "CA", "037", "", "34.13612", "-117.86534", "America/Los_Angeles"),("5352771", "Gold River", "", "US", "840", "", "CA", "067", "", "38.62629", "-121.24662", "America/Los_Angeles"),("5352875", "Golden Hills", "", "US", "840", "", "CA", "029", "", "35.14247", "-118.49036", "America/Los_Angeles"),("5352963", "Goleta", "Шхуна", "US", "840", "", "CA", "083", "", "34.43583", "-119.82764", "America/Los_Angeles"),("5352997", "Gonzales", "", "US", "840", "", "CA", "053", "", "36.50663", "-121.44438", "America/Los_Angeles"),("5353058", "Good Hope", "", "US", "840", "", "CA", "065", "", "33.76474", "-117.26698", "America/Los_Angeles"),("5353484", "Grand Terrace", "", "US", "840", "", "CA", "071", "", "34.0339", "-117.31365", "America/Los_Angeles"),("5353530", "Granite Bay", "", "US", "840", "", "CA", "061", "", "38.76323", "-121.16384", "America/Los_Angeles"),("5353775", "Grass Valley", "", "US", "840", "", "CA", "057", "", "39.21906", "-121.06106", "America/Los_Angeles"),("5354157", "Greenacres", "", "US", "840", "", "CA", "029", "", "35.38329", "-119.10983", "America/Los_Angeles"),("5354172", "Greenfield", "Гринфилд", "US", "840", "", "CA", "053", "", "36.3208", "-121.24381", "America/Los_Angeles"),("5354307", "Gridley", "", "US", "840", "", "CA", "007", "", "39.36378", "-121.69358", "America/Los_Angeles"),("5354552", "Grover Beach", "", "US", "840", "", "CA", "079", "", "35.12164", "-120.62128", "America/Los_Angeles"),("5354591", "Guadalupe", "", "US", "840", "", "CA", "083", "", "34.97164", "-120.57184", "America/Los_Angeles"),("5354747", "Gustine", "", "US", "840", "", "CA", "047", "", "37.25772", "-120.99882", "America/Los_Angeles"),("5354819", "Hacienda Heights", "", "US", "840", "", "CA", "037", "", "33.99307", "-117.96868", "America/Los_Angeles"),("5354943", "Half Moon Bay", "", "US", "840", "", "CA", "081", "", "37.46355", "-122.42859", "America/Los_Angeles"),("5355180", "Hanford", "Хэнфорд", "US", "840", "", "CA", "031", "", "36.32745", "-119.64568", "America/Los_Angeles"),("5355782", "Hawaiian Gardens", "", "US", "840", "", "CA", "037", "", "33.8314", "-118.07284", "America/Los_Angeles"),("5355828", "Hawthorne", "", "US", "840", "", "CA", "037", "", "33.9164", "-118.35257", "America/Los_Angeles"),("5355933", "Hayward", "", "US", "840", "", "CA", "001", "", "37.66882", "-122.0808", "America/Los_Angeles"),("5356012", "Healdsburg", "", "US", "840", "", "CA", "097", "", "38.61047", "-122.86916", "America/Los_Angeles"),("5356277", "Hemet", "", "US", "840", "", "CA", "065", "", "33.74761", "-116.97307", "America/Los_Angeles"),("5356451", "Hercules", "Геркулес", "US", "840", "", "CA", "013", "", "38.01714", "-122.28858", "America/Los_Angeles"),("5356521", "Hermosa Beach", "", "US", "840", "", "CA", "037", "", "33.86224", "-118.39952", "America/Los_Angeles"),("5356576", "Hesperia", "", "US", "840", "", "CA", "071", "", "34.42639", "-117.30088", "America/Los_Angeles"),("5356767", "Hidden Valley Lake", "", "US", "840", "", "CA", "033", "", "38.80796", "-122.55832", "America/Los_Angeles"),("5356868", "Highland", "", "US", "840", "", "CA", "071", "", "34.12834", "-117.20865", "America/Los_Angeles"),("5357155", "Hillsborough", "", "US", "840", "", "CA", "081", "", "37.5741", "-122.37942", "America/Los_Angeles"),("5357499", "Hollister", "", "US", "840", "", "CA", "069", "", "36.85245", "-121.4016", "America/Los_Angeles"),("5357527", "Hollywood", "Голливуд", "US", "840", "", "CA", "037", "", "34.09834", "-118.32674", "America/Los_Angeles"),("5357598", "Holtville", "", "US", "840", "", "CA", "025", "", "32.81116", "-115.38026", "America/Los_Angeles"),("5357731", "Home Gardens", "", "US", "840", "", "CA", "065", "", "33.87807", "-117.52088", "America/Los_Angeles"),("5357755", "Homeland", "", "US", "840", "", "CA", "065", "", "33.74308", "-117.1092", "America/Los_Angeles"),("5358539", "Hughson", "", "US", "840", "", "CA", "099", "", "37.59688", "-120.86604", "America/Los_Angeles"),("5358705", "Huntington Beach", "Хантингтон-Бич", "US", "840", "", "CA", "059", "", "33.6603", "-117.99923", "America/Los_Angeles"),("5358736", "Huntington Park", "", "US", "840", "", "CA", "037", "", "33.98168", "-118.22507", "America/Los_Angeles"),("5358769", "Huron", "", "US", "840", "", "CA", "019", "", "36.20273", "-120.10292", "America/Los_Angeles"),("5359052", "Imperial", "", "US", "840", "", "CA", "025", "", "32.84755", "-115.56944", "America/Los_Angeles"),("5359054", "Imperial Beach", "", "US", "840", "", "CA", "073", "", "32.58394", "-117.11308", "America/Los_Angeles"),("5359426", "Indian Wells", "", "US", "840", "", "CA", "065", "", "33.71791", "-116.34311", "America/Los_Angeles"),("5359446", "Indio", "Индио", "US", "840", "", "CA", "065", "", "33.7207", "-116.21677", "America/Los_Angeles"),("5359488", "Inglewood", "Инглвуд", "US", "840", "", "CA", "037", "", "33.96168", "-118.35313", "America/Los_Angeles"),("5359577", "Interlaken", "", "US", "840", "", "CA", "087", "", "36.95134", "-121.73384", "America/Los_Angeles"),("5359634", "Ione", "", "US", "840", "", "CA", "005", "", "38.35269", "-120.93272", "America/Los_Angeles"),("5359777", "Irvine", "Ирвин", "US", "840", "", "CA", "059", "", "33.66946", "-117.82311", "America/Los_Angeles"),("5359864", "Isla Vista", "", "US", "840", "", "CA", "083", "", "34.41333", "-119.86097", "America/Los_Angeles"),("5360403", "Jamul", "", "US", "840", "", "CA", "073", "", "32.717", "-116.87613", "America/Los_Angeles"),("5361298", "Joshua Tree", "", "US", "840", "", "CA", "071", "", "34.13473", "-116.31307", "America/Los_Angeles"),("5362849", "Kensington", "", "US", "840", "", "CA", "013", "", "37.91048", "-122.28025", "America/Los_Angeles"),("5362864", "Kentfield", "", "US", "840", "", "CA", "041", "", "37.95215", "-122.5572", "America/Los_Angeles"),("5362909", "Kerman", "", "US", "840", "", "CA", "019", "", "36.72356", "-120.05988", "America/Los_Angeles"),("5363058", "Keyes", "", "US", "840", "", "CA", "099", "", "37.5566", "-120.91549", "America/Los_Angeles"),("5363208", "King City", "", "US", "840", "", "CA", "053", "", "36.21274", "-121.12603", "America/Los_Angeles"),("5363429", "Kingsburg", "", "US", "840", "", "CA", "019", "", "36.51384", "-119.55402", "America/Los_Angeles"),("5363859", "La Cañada Flintridge", "", "US", "840", "", "CA", "037", "", "34.19917", "-118.18785", "America/Los_Angeles"),("5363922", "La Habra", "", "US", "840", "", "CA", "059", "", "33.93196", "-117.94617", "America/Los_Angeles"),("5363925", "La Habra Heights", "", "US", "840", "", "CA", "037", "", "33.96085", "-117.95062", "America/Los_Angeles"),("5363943", "La Jolla", "Ла-Хойя", "US", "840", "", "CA", "073", "", "32.84727", "-117.2742", "America/Los_Angeles"),("5363990", "La Mesa", "", "US", "840", "", "CA", "073", "", "32.76783", "-117.02308", "America/Los_Angeles"),("5364007", "La Mirada", "", "US", "840", "", "CA", "037", "", "33.91724", "-118.01201", "America/Los_Angeles"),("5364022", "La Palma", "", "US", "840", "", "CA", "059", "", "33.8464", "-118.04673", "America/Los_Angeles"),("5364059", "La Presa", "", "US", "840", "", "CA", "073", "", "32.70811", "-116.99725", "America/Los_Angeles"),("5364066", "La Puente", "", "US", "840", "", "CA", "037", "", "34.02001", "-117.94951", "America/Los_Angeles"),("5364079", "La Quinta", "", "US", "840", "", "CA", "065", "", "33.66336", "-116.31001", "America/Los_Angeles"),("5364095", "La Riviera", "", "US", "840", "", "CA", "067", "", "38.56685", "-121.3569", "America/Los_Angeles"),("5364134", "La Verne", "", "US", "840", "", "CA", "037", "", "34.10084", "-117.76784", "America/Los_Angeles"),("5364195", "Ladera Heights", "", "US", "840", "", "CA", "037", "", "33.99418", "-118.37535", "America/Los_Angeles"),("5364199", "Ladera Ranch", "", "US", "840", "", "CA", "059", "", "33.57086", "-117.63561", "America/Los_Angeles"),("5364226", "Lafayette", "Лафайет", "US", "840", "", "CA", "013", "", "37.88576", "-122.11802", "America/Los_Angeles"),("5364271", "Laguna", "", "US", "840", "", "CA", "067", "", "38.42102", "-121.42384", "America/Los_Angeles"),("5364275", "Laguna Beach", "Лагуна-Бич", "US", "840", "", "CA", "059", "", "33.54225", "-117.78311", "America/Los_Angeles"),("5364306", "Laguna Hills", "", "US", "840", "", "CA", "059", "", "33.61252", "-117.71283", "America/Los_Angeles"),("5364329", "Laguna Niguel", "", "US", "840", "", "CA", "059", "", "33.52253", "-117.70755", "America/Los_Angeles"),("5364369", "Laguna Woods", "", "US", "840", "", "CA", "059", "", "33.6103", "-117.72533", "America/Los_Angeles"),("5364414", "Lake Arrowhead", "", "US", "840", "", "CA", "071", "", "34.24834", "-117.18921", "America/Los_Angeles"),("5364499", "Lake Elsinore", "", "US", "840", "", "CA", "065", "", "33.66808", "-117.32726", "America/Los_Angeles"),("5364514", "Lake Forest", "", "US", "840", "", "CA", "059", "", "33.64697", "-117.68922", "America/Los_Angeles"),("5364571", "Lake Los Angeles", "", "US", "840", "", "CA", "037", "", "34.61249", "-117.82812", "America/Los_Angeles"),("5364750", "Lakeland Village", "", "US", "840", "", "CA", "065", "", "33.63863", "-117.34393", "America/Los_Angeles"),("5364782", "Lakeside", "", "US", "840", "", "CA", "073", "", "32.85727", "-116.92225", "America/Los_Angeles"),("5364855", "Lakewood", "Лейквуд", "US", "840", "", "CA", "037", "", "33.85363", "-118.13396", "America/Los_Angeles"),("5364916", "Lamont", "", "US", "840", "", "CA", "029", "", "35.25968", "-118.91427", "America/Los_Angeles"),("5364940", "Lancaster", "Ланкастер", "US", "840", "", "CA", "037", "", "34.69804", "-118.13674", "America/Los_Angeles"),("5365113", "Larkspur", "", "US", "840", "", "CA", "041", "", "37.93409", "-122.53525", "America/Los_Angeles"),("5365171", "Las Flores", "", "US", "840", "", "CA", "037", "", "34.03723", "-118.63592", "America/Los_Angeles"),("5365172", "Las Flores", "", "US", "840", "", "CA", "059", "", "33.58808", "-117.62672", "America/Los_Angeles"),("5365425", "Lathrop", "", "US", "840", "", "CA", "077", "", "37.8227", "-121.27661", "America/Los_Angeles"),("5365603", "Lawndale", "", "US", "840", "", "CA", "037", "", "33.88724", "-118.35257", "America/Los_Angeles"),("5365893", "Lemon Grove", "", "US", "840", "", "CA", "073", "", "32.74255", "-117.03142", "America/Los_Angeles"),("5365918", "Lemoore", "", "US", "840", "", "CA", "031", "", "36.30078", "-119.78291", "America/Los_Angeles"),("5365937", "Lennox", "Леннокс", "US", "840", "", "CA", "037", "", "33.93807", "-118.35258", "America/Los_Angeles"),("5366375", "Lincoln", "Линколн", "US", "840", "", "CA", "061", "", "38.89156", "-121.29301", "America/Los_Angeles"),("5366531", "Linda", "", "US", "840", "", "CA", "115", "", "39.12767", "-121.5508", "America/Los_Angeles"),("5366604", "Lindsay", "", "US", "840", "", "CA", "107", "", "36.20301", "-119.08816", "America/Los_Angeles"),("5367314", "Live Oak", "", "US", "840", "", "CA", "087", "", "36.98356", "-121.98052", "America/Los_Angeles"),("5367315", "Live Oak", "", "US", "840", "", "CA", "101", "", "39.27572", "-121.65997", "America/Los_Angeles"),("5367427", "Livingston", "", "US", "840", "", "CA", "047", "", "37.38688", "-120.72353", "America/Los_Angeles"),("5367440", "Livermore", "Ливермор", "US", "840", "", "CA", "001", "", "37.68187", "-121.76801", "America/Los_Angeles"),("5367565", "Lodi", "Лоди", "US", "840", "", "CA", "077", "", "38.1302", "-121.27245", "America/Los_Angeles"),("5367696", "Loma Linda", "Лома-Линда", "US", "840", "", "CA", "071", "", "34.04835", "-117.26115", "America/Los_Angeles"),("5367767", "Lomita", "", "US", "840", "", "CA", "037", "", "33.79224", "-118.31507", "America/Los_Angeles"),("5367788", "Lompoc", "", "US", "840", "", "CA", "083", "", "34.63915", "-120.45794", "America/Los_Angeles"),("5367929", "Long Beach", "Лонг-Бич", "US", "840", "", "CA", "037", "", "33.76696", "-118.18923", "America/Los_Angeles"),("5368233", "Loomis", "", "US", "840", "", "CA", "061", "", "38.82129", "-121.193", "America/Los_Angeles"),("5368304", "Los Alamitos", "", "US", "840", "", "CA", "059", "", "33.80307", "-118.07256", "America/Los_Angeles"),("5368335", "Los Altos", "", "US", "840", "", "CA", "085", "", "37.38522", "-122.11413", "America/Los_Angeles"),("5368346", "Los Altos Hills", "", "US", "840", "", "CA", "085", "", "37.37966", "-122.13746", "America/Los_Angeles"),("5368361", "Los Angeles", "Лос-Анджелес", "US", "840", "", "CA", "037", "", "34.05223", "-118.24368", "America/Los_Angeles"),("5368453", "Los Banos", "Лос-Баньос", "US", "840", "", "CA", "047", "", "37.05828", "-120.84992", "America/Los_Angeles"),("5368518", "Los Gatos", "", "US", "840", "", "CA", "085", "", "37.22661", "-121.97468", "America/Los_Angeles"),("5368565", "Los Osos", "", "US", "840", "", "CA", "079", "", "35.31109", "-120.8324", "America/Los_Angeles"),("5368618", "Los Serranos", "", "US", "840", "", "CA", "071", "", "33.97279", "-117.70811", "America/Los_Angeles"),("5369150", "Lucerne Valley", "", "US", "840", "", "CA", "071", "", "34.44389", "-116.96781", "America/Los_Angeles"),("5369367", "Lynwood", "Линвуд", "US", "840", "", "CA", "037", "", "33.93029", "-118.21146", "America/Los_Angeles"),("5369568", "Madera", "Мадера", "US", "840", "", "CA", "039", "", "36.96134", "-120.06072", "America/Los_Angeles"),("5369569", "Madera Acres", "", "US", "840", "", "CA", "039", "", "37.01911", "-120.06683", "America/Los_Angeles"),("5369690", "Magalia", "", "US", "840", "", "CA", "007", "", "39.81211", "-121.57831", "America/Los_Angeles"),("5369906", "Malibu", "", "US", "840", "", "CA", "037", "", "34.02577", "-118.7804", "America/Los_Angeles"),("5369909", "Malibu Beach", "", "US", "840", "", "CA", "037", "", "34.03279", "-118.68842", "America/Los_Angeles"),("5370006", "Mammoth Lakes", "", "US", "840", "", "CA", "051", "", "37.64855", "-118.97208", "America/Los_Angeles"),("5370082", "Manhattan Beach", "", "US", "840", "", "CA", "037", "", "33.88474", "-118.41091", "America/Los_Angeles"),("5370164", "Manteca", "", "US", "840", "", "CA", "077", "", "37.79743", "-121.21605", "America/Los_Angeles"),("5370493", "Marina", "", "US", "840", "", "CA", "053", "", "36.6844", "-121.80217", "America/Los_Angeles"),("5370542", "Marina del Rey", "", "US", "840", "", "CA", "037", "", "33.98029", "-118.45174", "America/Los_Angeles"),("5370868", "Martinez", "Мартинес", "US", "840", "", "CA", "013", "", "38.01937", "-122.13413", "America/Los_Angeles"),("5370984", "Marysville", "", "US", "840", "", "CA", "115", "", "39.14573", "-121.59135", "America/Los_Angeles"),("5371243", "Mayflower Village", "", "US", "840", "", "CA", "037", "", "34.11501", "-118.00979", "America/Los_Angeles"),("5371261", "Maywood", "", "US", "840", "", "CA", "037", "", "33.98668", "-118.18535", "America/Los_Angeles"),("5371530", "McFarland", "", "US", "840", "", "CA", "029", "", "35.67801", "-119.22927", "America/Los_Angeles"),("5371858", "Mead Valley", "", "US", "840", "", "CA", "065", "", "33.83335", "-117.29615", "America/Los_Angeles"),("5371965", "Mecca", "", "US", "840", "", "CA", "065", "", "33.57219", "-116.0782", "America/Los_Angeles"),("5372190", "Mendota", "", "US", "840", "", "CA", "019", "", "36.75356", "-120.38156", "America/Los_Angeles"),("5372205", "Menifee", "", "US", "840", "", "CA", "065", "", "33.72835", "-117.14642", "America/Los_Angeles"),("5372223", "Menlo Park", "Менло-Парк", "US", "840", "", "CA", "081", "", "37.45383", "-122.18219", "America/Los_Angeles"),("5372242", "Mentone", "", "US", "840", "", "CA", "071", "", "34.07001", "-117.13448", "America/Los_Angeles"),("5372253", "Merced", "Мерсед", "US", "840", "", "CA", "047", "", "37.30216", "-120.48297", "America/Los_Angeles"),("5372902", "Midway City", "", "US", "840", "", "CA", "059", "", "33.74474", "-117.98923", "America/Los_Angeles"),("5373121", "Mill Valley", "", "US", "840", "", "CA", "041", "", "37.90604", "-122.54498", "America/Los_Angeles"),("5373129", "Millbrae", "", "US", "840", "", "CA", "081", "", "37.59855", "-122.38719", "America/Los_Angeles"),("5373327", "Milpitas", "", "US", "840", "", "CA", "085", "", "37.42827", "-121.90662", "America/Los_Angeles"),("5373492", "Mira Loma", "", "US", "840", "", "CA", "065", "", "33.99251", "-117.51644", "America/Los_Angeles"),("5373497", "Mira Mesa", "", "US", "840", "", "CA", "073", "", "32.9156", "-117.14392", "America/Los_Angeles"),("5373504", "Mira Monte", "", "US", "840", "", "CA", "111", "", "34.43361", "-119.28511", "America/Los_Angeles"),("5373763", "Mission Viejo", "Мишн-Вьехо", "US", "840", "", "CA", "059", "", "33.60002", "-117.672", "America/Los_Angeles"),("5373900", "Modesto", "Модесто", "US", "840", "", "CA", "099", "", "37.6391", "-120.99688", "America/Los_Angeles"),("5374175", "Monrovia", "Монровия", "US", "840", "", "CA", "037", "", "34.14806", "-117.99895", "America/Los_Angeles"),("5374232", "Montclair", "", "US", "840", "", "CA", "071", "", "34.07751", "-117.68978", "America/Los_Angeles"),("5374322", "Montebello", "Монтебелло", "US", "840", "", "CA", "037", "", "34.00946", "-118.10535", "America/Los_Angeles"),("5374340", "Montecito", "", "US", "840", "", "CA", "083", "", "34.43666", "-119.63208", "America/Los_Angeles"),("5374361", "Monterey", "Монтерей", "US", "840", "", "CA", "053", "", "36.60024", "-121.89468", "America/Los_Angeles"),("5374406", "Monterey Park", "", "US", "840", "", "CA", "037", "", "34.06251", "-118.12285", "America/Los_Angeles"),("5374648", "Moorpark", "Мурпарк", "US", "840", "", "CA", "111", "", "34.28556", "-118.88204", "America/Los_Angeles"),("5374671", "Moraga", "", "US", "840", "", "CA", "013", "", "37.83493", "-122.12969", "America/Los_Angeles"),("5374732", "Moreno Valley", "Морено-Валли", "US", "840", "", "CA", "065", "", "33.93752", "-117.23059", "America/Los_Angeles"),("5374764", "Morgan Hill", "", "US", "840", "", "CA", "085", "", "37.1305", "-121.65439", "America/Los_Angeles"),("5374920", "Morro Bay", "", "US", "840", "", "CA", "079", "", "35.36581", "-120.8499", "America/Los_Angeles"),("5375407", "Mountain House", "", "US", "840", "", "CA", "077", "", "37.78326", "-121.54273", "America/Los_Angeles"),("5375480", "Mountain View", "Маунтин-Вью", "US", "840", "", "CA", "085", "", "37.38605", "-122.08385", "America/Los_Angeles"),("5375911", "Murrieta", "", "US", "840", "", "CA", "065", "", "33.55391", "-117.21392", "America/Los_Angeles"),("5375938", "Muscoy", "", "US", "840", "", "CA", "071", "", "34.15418", "-117.34421", "America/Los_Angeles"),("5376095", "Napa", "Напа", "US", "840", "", "CA", "055", "", "38.29714", "-122.28553", "America/Los_Angeles"),("5376200", "National City", "", "US", "840", "", "CA", "073", "", "32.67811", "-117.0992", "America/Los_Angeles"),("5376803", "Newark", "Ньюарк", "US", "840", "", "CA", "001", "", "37.52966", "-122.04024", "America/Los_Angeles"),("5376870", "Newman", "", "US", "840", "", "CA", "099", "", "37.31383", "-121.02076", "America/Los_Angeles"),("5376890", "Newport Beach", "", "US", "840", "", "CA", "059", "", "33.61891", "-117.92895", "America/Los_Angeles"),("5377100", "Nipomo", "", "US", "840", "", "CA", "079", "", "35.04275", "-120.476", "America/Los_Angeles"),("5377199", "Norco", "", "US", "840", "", "CA", "065", "", "33.93113", "-117.54866", "America/Los_Angeles"),("5377266", "North Auburn", "", "US", "840", "", "CA", "061", "", "38.93129", "-121.08189", "America/Los_Angeles"),("5377389", "North Fair Oaks", "", "US", "840", "", "CA", "081", "", "37.47438", "-122.19663", "America/Los_Angeles"),("5377613", "North Glendale", "", "US", "840", "", "CA", "037", "", "34.16056", "-118.26452", "America/Los_Angeles"),("5377640", "North Highlands", "", "US", "840", "", "CA", "067", "", "38.68574", "-121.37217", "America/Los_Angeles"),("5377654", "North Hollywood", "", "US", "840", "", "CA", "037", "", "34.17223", "-118.37897", "America/Los_Angeles"),("5377985", "Northridge", "", "US", "840", "", "CA", "037", "", "34.22834", "-118.53675", "America/Los_Angeles"),("5377995", "Norwalk", "", "US", "840", "", "CA", "037", "", "33.90224", "-118.08173", "America/Los_Angeles"),("5378044", "Novato", "Новато", "US", "840", "", "CA", "041", "", "38.10742", "-122.5697", "America/Los_Angeles"),("5378087", "Nuevo", "", "US", "840", "", "CA", "065", "", "33.80141", "-117.14587", "America/Los_Angeles"),("5378354", "Oak Hills", "", "US", "840", "", "CA", "071", "", "34.38313", "-117.38135", "America/Los_Angeles"),("5378408", "Oak Park", "", "US", "840", "", "CA", "111", "", "34.17917", "-118.76287", "America/Los_Angeles"),("5378500", "Oakdale", "", "US", "840", "", "CA", "099", "", "37.76659", "-120.84715", "America/Los_Angeles"),("5378538", "Oakland", "Окленд", "US", "840", "", "CA", "001", "", "37.80437", "-122.2708", "America/Los_Angeles"),("5378566", "Oakley", "", "US", "840", "", "CA", "013", "", "37.99742", "-121.71245", "America/Los_Angeles"),("5378617", "Oasis", "", "US", "840", "", "CA", "065", "", "33.46586", "-116.09889", "America/Los_Angeles"),("5378763", "Oceano", "", "US", "840", "", "CA", "079", "", "35.09886", "-120.61239", "America/Los_Angeles"),("5378771", "Oceanside", "Оушенсайд", "US", "840", "", "CA", "073", "", "33.19587", "-117.37948", "America/Los_Angeles"),("5378870", "Oildale", "", "US", "840", "", "CA", "029", "", "35.41968", "-119.01955", "America/Los_Angeles"),("5378880", "Ojai", "", "US", "840", "", "CA", "111", "", "34.44805", "-119.24289", "America/Los_Angeles"),("5379264", "Olivehurst", "", "US", "840", "", "CA", "115", "", "39.09545", "-121.55219", "America/Los_Angeles"),("5379439", "Ontario", "Онтарио", "US", "840", "", "CA", "071", "", "34.06334", "-117.65089", "America/Los_Angeles"),("5379475", "Opal Cliffs", "", "US", "840", "", "CA", "087", "", "36.96078", "-121.96413", "America/Los_Angeles"),("5379513", "Orange", "", "US", "840", "", "CA", "059", "", "33.78779", "-117.85311", "America/Los_Angeles"),("5379533", "Orange Cove", "", "US", "840", "", "CA", "019", "", "36.62439", "-119.31373", "America/Los_Angeles"),("5379566", "Orangevale", "", "US", "840", "", "CA", "067", "", "38.67851", "-121.22578", "America/Los_Angeles"),("5379609", "Orcutt", "", "US", "840", "", "CA", "083", "", "34.86526", "-120.436", "America/Los_Angeles"),("5379678", "Orinda", "", "US", "840", "", "CA", "013", "", "37.87715", "-122.17969", "America/Los_Angeles"),("5379698", "Orland", "", "US", "840", "", "CA", "021", "", "39.74738", "-122.19637", "America/Los_Angeles"),("5379755", "Orosi", "", "US", "840", "", "CA", "107", "", "36.54495", "-119.28734", "America/Los_Angeles"),("5379759", "Oroville", "Оровилл", "US", "840", "", "CA", "007", "", "39.51394", "-121.55776", "America/Los_Angeles"),("5380184", "Oxnard", "Окснард", "US", "840", "", "CA", "111", "", "34.1975", "-119.17705", "America/Los_Angeles"),("5380202", "Oxnard Shores", "", "US", "840", "", "CA", "111", "", "34.19084", "-119.2415", "America/Los_Angeles"),("5380420", "Pacifica", "", "US", "840", "", "CA", "081", "", "37.61383", "-122.48692", "America/Los_Angeles"),("5380437", "Pacific Grove", "", "US", "840", "", "CA", "053", "", "36.61774", "-121.91662", "America/Los_Angeles"),("5380571", "Palermo", "", "US", "840", "", "CA", "007", "", "39.43544", "-121.53802", "America/Los_Angeles"),("5380626", "Palm Desert", "Палм-Дезерт", "US", "840", "", "CA", "065", "", "33.72255", "-116.37697", "America/Los_Angeles"),("5380668", "Palm Springs", "Палм-Спрингс", "US", "840", "", "CA", "065", "", "33.8303", "-116.54529", "America/Los_Angeles"),("5380698", "Palmdale", "Палмдейл", "US", "840", "", "CA", "037", "", "34.57943", "-118.11646", "America/Los_Angeles"),("5380748", "Palo Alto", "Пало Альто", "US", "840", "", "CA", "085", "", "37.44188", "-122.14302", "America/Los_Angeles"),("5380883", "Palos Verdes Estates", "", "US", "840", "", "CA", "037", "", "33.80105", "-118.39245", "America/Los_Angeles"),("5381002", "Paradise", "", "US", "840", "", "CA", "007", "", "39.75961", "-121.62192", "America/Los_Angeles"),("5381110", "Paramount", "", "US", "840", "", "CA", "037", "", "33.88946", "-118.15979", "America/Los_Angeles"),("5381305", "Parkway", "", "US", "840", "", "CA", "067", "", "38.49602", "-121.45884", "America/Los_Angeles"),("5381325", "Parlier", "", "US", "840", "", "CA", "019", "", "36.61162", "-119.52707", "America/Los_Angeles"),("5381396", "Pasadena", "Пасадина", "US", "840", "", "CA", "037", "", "34.14778", "-118.14452", "America/Los_Angeles"),("5381438", "Paso Robles", "", "US", "840", "", "CA", "079", "", "35.62664", "-120.691", "America/Los_Angeles"),("5381515", "Patterson", "", "US", "840", "", "CA", "099", "", "37.4716", "-121.12966", "America/Los_Angeles"),("5381796", "Pedley", "", "US", "840", "", "CA", "065", "", "33.97529", "-117.47588", "America/Los_Angeles"),("5382146", "Perris", "", "US", "840", "", "CA", "065", "", "33.78252", "-117.22865", "America/Los_Angeles"),("5382232", "Petaluma", "Петалума", "US", "840", "", "CA", "097", "", "38.23242", "-122.63665", "America/Los_Angeles"),("5382362", "Phelan", "", "US", "840", "", "CA", "071", "", "34.42611", "-117.57228", "America/Los_Angeles"),("5382496", "Pico Rivera", "", "US", "840", "", "CA", "037", "", "33.98307", "-118.09673", "America/Los_Angeles"),("5382514", "Piedmont", "", "US", "840", "", "CA", "001", "", "37.82437", "-122.23163", "America/Los_Angeles"),("5383187", "Pinole", "", "US", "840", "", "CA", "013", "", "38.00437", "-122.29886", "America/Los_Angeles"),("5383431", "Pismo Beach", "", "US", "840", "", "CA", "079", "", "35.14275", "-120.64128", "America/Los_Angeles"),("5383465", "Pittsburg", "", "US", "840", "", "CA", "013", "", "38.02798", "-121.88468", "America/Los_Angeles"),("5383526", "Piñon Hills", "", "US", "840", "", "CA", "071", "", "34.43333", "-117.64672", "America/Los_Angeles"),("5383527", "Placentia", "", "US", "840", "", "CA", "059", "", "33.87224", "-117.87034", "America/Los_Angeles"),("5383559", "Placerville", "", "US", "840", "", "CA", "017", "", "38.72963", "-120.79855", "America/Los_Angeles"),("5383720", "Pleasant Hill", "", "US", "840", "", "CA", "013", "", "37.94798", "-122.0608", "America/Los_Angeles"),("5383777", "Pleasanton", "Плезантон", "US", "840", "", "CA", "001", "", "37.66243", "-121.87468", "America/Los_Angeles"),("5383844", "Plumas Lake", "", "US", "840", "", "CA", "115", "", "39.02073", "-121.55802", "America/Los_Angeles"),("5384133", "Pollock Pines", "", "US", "840", "", "CA", "017", "", "38.76138", "-120.58911", "America/Los_Angeles"),("5384170", "Pomona", "Помона", "US", "840", "", "CA", "037", "", "34.05529", "-117.75228", "America/Los_Angeles"),("5384339", "Port Hueneme", "", "US", "840", "", "CA", "111", "", "34.14778", "-119.19511", "America/Los_Angeles"),("5384452", "Portola Hills", "", "US", "840", "", "CA", "059", "", "33.67919", "-117.63116", "America/Los_Angeles"),("5384471", "Porterville", "", "US", "840", "", "CA", "107", "", "36.06523", "-119.01677", "America/Los_Angeles"),("5384690", "Poway", "", "US", "840", "", "CA", "073", "", "32.96282", "-117.03586", "America/Los_Angeles"),("5385082", "Prunedale", "", "US", "840", "", "CA", "053", "", "36.77579", "-121.66967", "America/Los_Angeles"),("5385393", "Quartz Hill", "", "US", "840", "", "CA", "037", "", "34.64526", "-118.21813", "America/Los_Angeles"),("5385793", "Ramona", "", "US", "840", "", "CA", "073", "", "33.04171", "-116.86808", "America/Los_Angeles"),("5385926", "Rancho Calaveras", "", "US", "840", "", "CA", "009", "", "38.1275", "-120.85833", "America/Los_Angeles"),("5385941", "Rancho Cordova", "", "US", "840", "", "CA", "067", "", "38.58907", "-121.30273", "America/Los_Angeles"),("5385955", "Rancho Cucamonga", "Ранчо-Кукамонга", "US", "840", "", "CA", "071", "", "34.1064", "-117.59311", "America/Los_Angeles"),("5386015", "Rancho Mirage", "", "US", "840", "", "CA", "065", "", "33.73974", "-116.41279", "America/Los_Angeles"),("5386027", "Rancho Murieta", "", "US", "840", "", "CA", "067", "", "38.50185", "-121.09467", "America/Los_Angeles"),("5386035", "Rancho Palos Verdes", "", "US", "840", "", "CA", "037", "", "33.74446", "-118.38702", "America/Los_Angeles"),("5386039", "Rancho Penasquitos", "", "US", "840", "", "CA", "073", "", "32.95949", "-117.11531", "America/Los_Angeles"),("5386053", "Rancho San Diego", "", "US", "840", "", "CA", "073", "", "32.74727", "-116.9353", "America/Los_Angeles"),("5386082", "Rancho Santa Margarita", "", "US", "840", "", "CA", "059", "", "33.64086", "-117.6031", "America/Los_Angeles"),("5386754", "Redlands", "", "US", "840", "", "CA", "071", "", "34.05557", "-117.18254", "America/Los_Angeles"),("5386785", "Redondo Beach", "Редондо-Бич", "US", "840", "", "CA", "037", "", "33.84918", "-118.38841", "America/Los_Angeles"),("5386834", "Redwood City", "Редвуд Сити", "US", "840", "", "CA", "081", "", "37.48522", "-122.23635", "America/Los_Angeles"),("5386932", "Redwood Shores", "", "US", "840", "", "CA", "081", "", "37.53188", "-122.24802", "America/Los_Angeles"),("5386984", "Reedley", "", "US", "840", "", "CA", "019", "", "36.59634", "-119.4504", "America/Los_Angeles"),("5387288", "Rialto", "Риальто", "US", "840", "", "CA", "071", "", "34.1064", "-117.37032", "America/Los_Angeles"),("5387428", "Richmond", "", "US", "840", "", "CA", "013", "", "37.93576", "-122.34775", "America/Los_Angeles"),("5387494", "Ridgecrest", "", "US", "840", "", "CA", "029", "", "35.62246", "-117.6709", "America/Los_Angeles"),("5387673", "Rio Del Mar", "", "US", "840", "", "CA", "087", "", "36.96828", "-121.90023", "America/Los_Angeles"),("5387687", "Rio Linda", "", "US", "840", "", "CA", "067", "", "38.69101", "-121.44857", "America/Los_Angeles"),("5387749", "Ripon", "", "US", "840", "", "CA", "077", "", "37.74159", "-121.12438", "America/Los_Angeles"),("5387844", "Riverbank", "", "US", "840", "", "CA", "099", "", "37.73604", "-120.93549", "America/Los_Angeles"),("5387877", "Riverside", "Риверсайд", "US", "840", "", "CA", "065", "", "33.95335", "-117.39616", "America/Los_Angeles"),("5388319", "Rocklin", "", "US", "840", "", "CA", "061", "", "38.79073", "-121.23578", "America/Los_Angeles"),("5388467", "Rodeo", "", "US", "840", "", "CA", "013", "", "38.03298", "-122.26691", "America/Los_Angeles"),("5388564", "Rohnert Park", "", "US", "840", "", "CA", "097", "", "38.33964", "-122.7011", "America/Los_Angeles"),("5388601", "Rolling Hills Estates", "", "US", "840", "", "CA", "037", "", "33.78779", "-118.35813", "America/Los_Angeles"),("5388735", "Rosamond", "", "US", "840", "", "CA", "029", "", "34.86414", "-118.16341", "America/Los_Angeles"),("5388843", "Rosedale", "", "US", "840", "", "CA", "029", "", "35.38357", "-119.14538", "America/Los_Angeles"),("5388858", "Roseland", "", "US", "840", "", "CA", "097", "", "38.42213", "-122.72804", "America/Los_Angeles"),("5388867", "Rosemead", "", "US", "840", "", "CA", "037", "", "34.08057", "-118.07285", "America/Los_Angeles"),("5388873", "Rosemont", "Роземонт", "US", "840", "", "CA", "067", "", "38.55185", "-121.36467", "America/Los_Angeles"),("5388881", "Roseville", "Розвелл", "US", "840", "", "CA", "061", "", "38.75212", "-121.28801", "America/Los_Angeles"),("5388953", "Rossmoor", "", "US", "840", "", "CA", "059", "", "33.78557", "-118.08506", "America/Los_Angeles"),("5389126", "Rowland Heights", "", "US", "840", "", "CA", "037", "", "33.97612", "-117.90534", "America/Los_Angeles"),("5389213", "Rubidoux", "", "US", "840", "", "CA", "065", "", "33.99613", "-117.4056", "America/Los_Angeles"),("5389489", "Sacramento", "Сакраменто", "US", "840", "", "CA", "067", "", "38.58157", "-121.4944", "America/Los_Angeles"),("5390267", "Saint Helena", "", "US", "840", "", "CA", "055", "", "38.50519", "-122.47026", "America/Los_Angeles"),("5391291", "Salida", "", "US", "840", "", "CA", "099", "", "37.70576", "-121.08494", "America/Los_Angeles"),("5391295", "Salinas", "Салинас", "US", "840", "", "CA", "053", "", "36.67774", "-121.6555", "America/Los_Angeles"),("5391615", "San Anselmo", "", "US", "840", "", "CA", "041", "", "37.97465", "-122.56164", "America/Los_Angeles"),("5391710", "San Bernardino", "Сан-Бернардино", "US", "840", "", "CA", "071", "", "34.10834", "-117.28977", "America/Los_Angeles"),("5391749", "San Bruno", "", "US", "840", "", "CA", "081", "", "37.63049", "-122.41108", "America/Los_Angeles"),("5391760", "San Carlos", "", "US", "840", "", "CA", "081", "", "37.50716", "-122.26052", "America/Los_Angeles"),("5391791", "San Clemente", "", "US", "840", "", "CA", "059", "", "33.42697", "-117.61199", "America/Los_Angeles"),("5391811", "San Diego", "Сан-Диего", "US", "840", "", "CA", "073", "", "32.71533", "-117.15726", "America/Los_Angeles"),("5391831", "San Diego Country Estates", "", "US", "840", "", "CA", "073", "", "33.00671", "-116.78364", "America/Los_Angeles"),("5391891", "San Dimas", "", "US", "840", "", "CA", "037", "", "34.10668", "-117.80673", "America/Los_Angeles"),("5391945", "San Fernando", "Сан-Фернандо", "US", "840", "", "CA", "037", "", "34.28195", "-118.43897", "America/Los_Angeles"),("5391959", "San Francisco", "Сан-Франциско", "US", "840", "", "CA", "075", "", "37.77493", "-122.41942", "America/Los_Angeles"),("5392034", "San Gabriel", "Сан-Гейбриел", "US", "840", "", "CA", "037", "", "34.09611", "-118.10583", "America/Los_Angeles"),("5392090", "San Jacinto", "", "US", "840", "", "CA", "065", "", "33.78391", "-116.95864", "America/Los_Angeles"),("5392171", "San Jose", "Сан-Хосе", "US", "840", "", "CA", "085", "", "37.33939", "-121.89496", "America/Los_Angeles"),("5392229", "San Juan Capistrano", "Сан Хуан Капистрано", "US", "840", "", "CA", "059", "", "33.50169", "-117.66255", "America/Los_Angeles"),("5392263", "San Leandro", "", "US", "840", "", "CA", "001", "", "37.72493", "-122.15608", "America/Los_Angeles"),("5392281", "San Lorenzo", "", "US", "840", "", "CA", "001", "", "37.68104", "-122.12441", "America/Los_Angeles"),("5392323", "San Luis Obispo", "Сан Луис Обиспо", "US", "840", "", "CA", "079", "", "35.28275", "-120.65962", "America/Los_Angeles"),("5392368", "San Marcos", "Сан-Маркос", "US", "840", "", "CA", "073", "", "33.14337", "-117.16614", "America/Los_Angeles"),("5392400", "San Marino", "", "US", "840", "", "CA", "037", "", "34.1214", "-118.10646", "America/Los_Angeles"),("5392408", "San Martin", "", "US", "840", "", "CA", "085", "", "37.08495", "-121.61022", "America/Los_Angeles"),("5392423", "San Mateo", "Сан-Матео", "US", "840", "", "CA", "081", "", "37.56299", "-122.32553", "America/Los_Angeles"),("5392508", "San Pablo", "", "US", "840", "", "CA", "013", "", "37.96215", "-122.34553", "America/Los_Angeles"),("5392528", "San Pedro", "", "US", "840", "", "CA", "037", "", "33.73585", "-118.29229", "America/Los_Angeles"),("5392567", "San Rafael", "Сан-Рафел", "US", "840", "", "CA", "041", "", "37.97353", "-122.53109", "America/Los_Angeles"),("5392593", "San Ramon", "Сан-Рамон", "US", "840", "", "CA", "013", "", "37.77993", "-121.97802", "America/Los_Angeles"),("5392868", "Sanger", "", "US", "840", "", "CA", "019", "", "36.70801", "-119.55597", "America/Los_Angeles"),("5392900", "Santa Ana", "Санта-Ана", "US", "840", "", "CA", "059", "", "33.74557", "-117.86783", "America/Los_Angeles"),("5392952", "Santa Barbara", "Санта-Барбара", "US", "840", "", "CA", "083", "", "34.42083", "-119.69819", "America/Los_Angeles"),("5393015", "Santa Clara", "Санта-Клара", "US", "840", "", "CA", "085", "", "37.35411", "-121.95524", "America/Los_Angeles"),("5393049", "Santa Clarita", "Санта-Кларита", "US", "840", "", "CA", "037", "", "34.39166", "-118.54259", "America/Los_Angeles"),("5393052", "Santa Cruz", "Санта-Крус", "US", "840", "", "CA", "087", "", "36.97412", "-122.0308", "America/Los_Angeles"),("5393128", "Santa Fe Springs", "", "US", "840", "", "CA", "037", "", "33.94724", "-118.08535", "America/Los_Angeles"),("5393180", "Santa Maria", "", "US", "840", "", "CA", "083", "", "34.95303", "-120.43572", "America/Los_Angeles"),("5393212", "Santa Monica", "Санта-Моника", "US", "840", "", "CA", "037", "", "34.01945", "-118.49119", "America/Los_Angeles"),("5393245", "Santa Paula", "Санта-Паула", "US", "840", "", "CA", "111", "", "34.35417", "-119.05927", "America/Los_Angeles"),("5393287", "Santa Rosa", "Санта-Роза", "US", "840", "", "CA", "097", "", "38.44047", "-122.71443", "America/Los_Angeles"),("5393429", "Santee", "Санти", "US", "840", "", "CA", "073", "", "32.83838", "-116.97392", "America/Los_Angeles"),("5393484", "Saranap", "", "US", "840", "", "CA", "013", "", "37.88492", "-122.07607", "America/Los_Angeles"),("5393485", "Saratoga", "", "US", "840", "", "CA", "085", "", "37.26383", "-122.02301", "America/Los_Angeles"),("5393611", "Sausalito", "", "US", "840", "", "CA", "041", "", "37.85909", "-122.48525", "America/Los_Angeles"),("5393971", "Scotts Valley", "", "US", "840", "", "CA", "087", "", "37.05106", "-122.01468", "America/Los_Angeles"),("5394086", "Seal Beach", "", "US", "840", "", "CA", "059", "", "33.74141", "-118.10479", "America/Los_Angeles"),("5394136", "Seaside", "Сисайд", "US", "840", "", "CA", "053", "", "36.61107", "-121.85162", "America/Los_Angeles"),("5394165", "Sebastopol", "", "US", "840", "", "CA", "097", "", "38.40214", "-122.82388", "America/Los_Angeles"),("5394329", "Selma", "Сельма", "US", "840", "", "CA", "019", "", "36.57078", "-119.61208", "America/Los_Angeles"),("5394842", "Shafter", "", "US", "840", "", "CA", "029", "", "35.50051", "-119.27178", "America/Los_Angeles"),("5395244", "Sherman Oaks", "", "US", "840", "", "CA", "037", "", "34.15112", "-118.44925", "America/Los_Angeles"),("5395622", "Sierra Madre", "", "US", "840", "", "CA", "037", "", "34.16167", "-118.05285", "America/Los_Angeles"),("5395754", "Signal Hill", "", "US", "840", "", "CA", "037", "", "33.80446", "-118.16785", "America/Los_Angeles"),("5396003", "Simi Valley", "", "US", "840", "", "CA", "111", "", "34.26945", "-118.78148", "America/Los_Angeles"),("5396974", "Solana Beach", "", "US", "840", "", "CA", "073", "", "32.99115", "-117.27115", "America/Los_Angeles"),("5397018", "Soledad", "Соледад", "US", "840", "", "CA", "053", "", "36.42469", "-121.32632", "America/Los_Angeles"),("5397059", "Solvang", "", "US", "840", "", "CA", "083", "", "34.59582", "-120.13765", "America/Los_Angeles"),("5397095", "Sonoma", "", "US", "840", "", "CA", "097", "", "38.29186", "-122.45804", "America/Los_Angeles"),("5397166", "Soquel", "", "US", "840", "", "CA", "087", "", "36.98801", "-121.95663", "America/Los_Angeles"),("5397376", "South El Monte", "", "US", "840", "", "CA", "037", "", "34.05195", "-118.04673", "America/Los_Angeles"),("5397603", "South Gate", "", "US", "840", "", "CA", "037", "", "33.95474", "-118.21202", "America/Los_Angeles"),("5397664", "South Lake Tahoe", "", "US", "840", "", "CA", "017", "", "38.93324", "-119.98435", "America/Los_Angeles"),("5397700", "South Oroville", "", "US", "840", "", "CA", "007", "", "39.49655", "-121.55219", "America/Los_Angeles"),("5397717", "South Pasadena", "", "US", "840", "", "CA", "037", "", "34.11612", "-118.15035", "America/Los_Angeles"),("5397765", "South San Francisco", "", "US", "840", "", "CA", "081", "", "37.65466", "-122.40775", "America/Los_Angeles"),("5397771", "South San Gabriel", "", "US", "840", "", "CA", "037", "", "34.04915", "-118.09462", "America/Los_Angeles"),("5397777", "South San Jose Hills", "", "US", "840", "", "CA", "037", "", "34.01279", "-117.90478", "America/Los_Angeles"),("5397841", "South Whittier", "", "US", "840", "", "CA", "037", "", "33.95015", "-118.03917", "America/Los_Angeles"),("5397851", "South Yuba City", "", "US", "840", "", "CA", "101", "", "39.11656", "-121.63913", "America/Los_Angeles"),("5398277", "Spring Valley", "Спринг-Вэлли", "US", "840", "", "CA", "073", "", "32.74477", "-116.99892", "America/Los_Angeles"),("5398563", "Stanford", "", "US", "840", "", "CA", "085", "", "37.42411", "-122.16608", "America/Los_Angeles"),("5398630", "Stanton", "Стэнтон", "US", "840", "", "CA", "059", "", "33.80252", "-117.99312", "America/Los_Angeles"),("5399020", "Stockton", "Стоктон", "US", "840", "", "CA", "077", "", "37.9577", "-121.29078", "America/Los_Angeles"),("5399319", "Strawberry", "", "US", "840", "", "CA", "041", "", "37.89687", "-122.50886", "America/Los_Angeles"),("5399629", "Suisun", "", "US", "840", "", "CA", "095", "", "38.23825", "-122.04024", "America/Los_Angeles"),("5399901", "Sun City", "", "US", "840", "", "CA", "065", "", "33.70919", "-117.19726", "America/Los_Angeles"),("5400065", "Sunnyslope", "", "US", "840", "", "CA", "065", "", "34.01196", "-117.43338", "America/Los_Angeles"),("5400075", "Sunnyvale", "Саннивейл", "US", "840", "", "CA", "085", "", "37.36883", "-122.03635", "America/Los_Angeles"),("5400877", "Taft", "", "US", "840", "", "CA", "029", "", "35.14247", "-119.45651", "America/Los_Angeles"),("5401017", "Tamalpais Valley", "", "US", "840", "", "CA", "041", "", "37.87965", "-122.54581", "America/Los_Angeles"),("5401121", "Tara Hills", "", "US", "840", "", "CA", "013", "", "37.99353", "-122.31636", "America/Los_Angeles"),("5401297", "Tehachapi", "", "US", "840", "", "CA", "029", "", "35.13219", "-118.44897", "America/Los_Angeles"),("5401395", "Temecula", "Темекула", "US", "840", "", "CA", "065", "", "33.49364", "-117.14836", "America/Los_Angeles"),("5401469", "Temple City", "", "US", "840", "", "CA", "037", "", "34.10723", "-118.05785", "America/Los_Angeles"),("5401516", "Templeton", "", "US", "840", "", "CA", "079", "", "35.54969", "-120.706", "America/Los_Angeles"),("5402159", "Thermalito", "", "US", "840", "", "CA", "007", "", "39.51128", "-121.58692", "America/Los_Angeles"),("5402405", "Thousand Oaks", "Таузенд-Оукс", "US", "840", "", "CA", "111", "", "34.17056", "-118.83759", "America/Los_Angeles"),("5402415", "Thousand Palms", "", "US", "840", "", "CA", "065", "", "33.82002", "-116.39029", "America/Los_Angeles"),("5402535", "Tiburon", "", "US", "840", "", "CA", "041", "", "37.87354", "-122.45664", "America/Los_Angeles"),("5402570", "Tierra Buena", "", "US", "840", "", "CA", "101", "", "39.14878", "-121.66691", "America/Los_Angeles"),("5402961", "Topanga", "", "US", "840", "", "CA", "037", "", "34.09362", "-118.60147", "America/Los_Angeles"),("5403022", "Torrance", "Торранс", "US", "840", "", "CA", "037", "", "33.83585", "-118.34063", "America/Los_Angeles"),("5403191", "Tracy", "Трейси", "US", "840", "", "CA", "077", "", "37.73987", "-121.42618", "America/Los_Angeles"),("5403676", "Truckee", "", "US", "840", "", "CA", "057", "", "39.32796", "-120.18325", "America/Los_Angeles"),("5403783", "Tulare", "Тулар", "US", "840", "", "CA", "107", "", "36.20773", "-119.34734", "America/Los_Angeles"),("5404024", "Turlock", "", "US", "840", "", "CA", "099", "", "37.49466", "-120.84659", "America/Los_Angeles"),("5404119", "Tustin", "", "US", "840", "", "CA", "059", "", "33.74585", "-117.82617", "America/Los_Angeles"),("5404122", "North Tustin", "", "US", "840", "", "CA", "059", "", "33.76446", "-117.79394", "America/Los_Angeles"),("5404198", "Twentynine Palms", "Туэнтинайн-Палмс", "US", "840", "", "CA", "071", "", "34.13556", "-116.05417", "America/Los_Angeles"),("5404476", "Ukiah", "Юкайа", "US", "840", "", "CA", "045", "", "39.15017", "-123.20778", "America/Los_Angeles"),("5404555", "Union City", "", "US", "840", "", "CA", "001", "", "37.59577", "-122.01913", "America/Los_Angeles"),("5404794", "Universal City", "Юниверсал-Сити", "US", "840", "", "CA", "037", "", "34.1389", "-118.35341", "America/Los_Angeles"),("5404915", "Upland", "", "US", "840", "", "CA", "071", "", "34.09751", "-117.64839", "America/Los_Angeles"),("5405228", "Vacaville", "", "US", "840", "", "CA", "095", "", "38.35658", "-121.98774", "America/Los_Angeles"),("5405288", "Valencia", "", "US", "840", "", "CA", "037", "", "34.44361", "-118.60953", "America/Los_Angeles"),("5405326", "Valinda", "", "US", "840", "", "CA", "037", "", "34.04529", "-117.94367", "America/Los_Angeles"),("5405346", "Valle Vista", "", "US", "840", "", "CA", "065", "", "33.7478", "-116.89336", "America/Los_Angeles"),("5405380", "Vallejo", "Вальехо", "US", "840", "", "CA", "095", "", "38.10409", "-122.25664", "America/Los_Angeles"),("5405430", "Valley Center", "", "US", "840", "", "CA", "073", "", "33.21837", "-117.0342", "America/Los_Angeles"),("5405693", "Van Nuys", "", "US", "840", "", "CA", "037", "", "34.18667", "-118.44897", "America/Los_Angeles"),("5405737", "Vandenberg Village", "", "US", "840", "", "CA", "083", "", "34.70832", "-120.46766", "America/Los_Angeles"),("5405878", "Ventura", "Вентура", "US", "840", "", "CA", "111", "", "34.27834", "-119.29317", "America/Los_Angeles"),("5406222", "Victorville", "", "US", "840", "", "CA", "071", "", "34.53611", "-117.29116", "America/Los_Angeles"),("5406337", "Villa Park", "", "US", "840", "", "CA", "059", "", "33.81446", "-117.81311", "America/Los_Angeles"),("5406421", "Vincent", "", "US", "840", "", "CA", "037", "", "34.50055", "-118.11646", "America/Los_Angeles"),("5406567", "Visalia", "Висейлия", "US", "840", "", "CA", "107", "", "36.33023", "-119.29206", "America/Los_Angeles"),("5406602", "Vista", "", "US", "840", "", "CA", "073", "", "33.20004", "-117.24254", "America/Los_Angeles"),("5406879", "Waldon", "", "US", "840", "", "CA", "013", "", "37.92631", "-122.05552", "America/Los_Angeles"),("5406976", "Walnut", "Уолнат", "US", "840", "", "CA", "037", "", "34.02029", "-117.86534", "America/Los_Angeles"),("5406990", "Walnut Creek", "Уолнат-Крик", "US", "840", "", "CA", "013", "", "37.90631", "-122.06496", "America/Los_Angeles"),("5407030", "Walnut Park", "", "US", "840", "", "CA", "037", "", "33.96807", "-118.22507", "America/Los_Angeles"),("5407463", "Waterford", "", "US", "840", "", "CA", "099", "", "37.64132", "-120.76048", "America/Los_Angeles"),("5407529", "Watsonville", "", "US", "840", "", "CA", "087", "", "36.91023", "-121.75689", "America/Los_Angeles"),("5407841", "West Athens", "", "US", "840", "", "CA", "037", "", "33.92335", "-118.30341", "America/Los_Angeles"),("5407908", "West Carson", "", "US", "840", "", "CA", "037", "", "33.82168", "-118.29257", "America/Los_Angeles"),("5407927", "West Rancho Dominguez", "", "US", "840", "", "CA", "037", "", "33.8939", "-118.27063", "America/Los_Angeles"),("5407933", "West Covina", "Западная Ковина", "US", "840", "", "CA", "037", "", "34.06862", "-117.93895", "America/Los_Angeles"),("5408076", "West Hollywood", "Западный Голливуд", "US", "840", "", "CA", "037", "", "34.09001", "-118.36174", "America/Los_Angeles"),("5408191", "West Puente Valley", "", "US", "840", "", "CA", "037", "", "34.05168", "-117.9684", "America/Los_Angeles"),("5408211", "West Sacramento", "", "US", "840", "", "CA", "113", "", "38.58046", "-121.53023", "America/Los_Angeles"),("5408395", "Westlake Village", "", "US", "840", "", "CA", "037", "", "34.14584", "-118.80565", "America/Los_Angeles"),("5408406", "Westminster", "", "US", "840", "", "CA", "059", "", "33.75918", "-118.00673", "America/Los_Angeles"),("5408431", "Westmont", "", "US", "840", "", "CA", "037", "", "33.9414", "-118.3023", "America/Los_Angeles"),("5409059", "Whittier", "", "US", "840", "", "CA", "037", "", "33.97918", "-118.03284", "America/Los_Angeles"),("5409260", "Wildomar", "", "US", "840", "", "CA", "065", "", "33.59891", "-117.28004", "America/Los_Angeles"),("5409417", "Williams", "", "US", "840", "", "CA", "011", "", "39.15461", "-122.14942", "America/Los_Angeles"),("5409768", "Willowbrook", "", "US", "840", "", "CA", "037", "", "33.91696", "-118.25507", "America/Los_Angeles"),("5409777", "Willows", "", "US", "840", "", "CA", "021", "", "39.52433", "-122.19359", "America/Los_Angeles"),("5409941", "Wilton", "", "US", "840", "", "CA", "067", "", "38.41186", "-121.27217", "America/Los_Angeles"),("5410004", "Windsor", "Виндзор", "US", "840", "", "CA", "097", "", "38.54713", "-122.81638", "America/Los_Angeles"),("5410125", "Winters", "", "US", "840", "", "CA", "113", "", "38.52491", "-121.9708", "America/Los_Angeles"),("5410129", "Winter Gardens", "", "US", "840", "", "CA", "073", "", "32.83116", "-116.93336", "America/Los_Angeles"),("5410144", "Winton", "", "US", "840", "", "CA", "047", "", "37.38938", "-120.61325", "America/Los_Angeles"),("5410382", "Woodcrest", "", "US", "840", "", "CA", "065", "", "33.88224", "-117.35727", "America/Los_Angeles"),("5410416", "Woodlake", "", "US", "840", "", "CA", "107", "", "36.41356", "-119.09872", "America/Los_Angeles"),("5410430", "Woodland", "", "US", "840", "", "CA", "113", "", "38.67852", "-121.7733", "America/Los_Angeles"),("5410438", "Woodland Hills", "", "US", "840", "", "CA", "037", "", "34.16834", "-118.60592", "America/Los_Angeles"),("5410535", "Woodside", "", "US", "840", "", "CA", "081", "", "37.42994", "-122.25386", "America/Los_Angeles"),("5410902", "Yorba Linda", "Йорба-Линда", "US", "840", "", "CA", "059", "", "33.88863", "-117.81311", "America/Los_Angeles"),("5411015", "Yuba City", "Юба-Сити", "US", "840", "", "CA", "101", "", "39.14045", "-121.61691", "America/Los_Angeles"),("5411046", "Yucaipa", "", "US", "840", "", "CA", "071", "", "34.03363", "-117.04309", "America/Los_Angeles"),("5411079", "Yucca Valley", "", "US", "840", "", "CA", "071", "", "34.11417", "-116.43224", "America/Los_Angeles"),("5411479", "Alamosa", "", "US", "840", "", "CO", "003", "", "37.46945", "-105.87002", "America/Denver"),("5412030", "Applewood", "", "US", "840", "", "CO", "059", "", "39.75778", "-105.1625", "America/Denver"),("5412199", "Arvada", "Арвада", "US", "840", "", "CO", "059", "", "39.80276", "-105.08748", "America/Denver"),("5412230", "Aspen", "", "US", "840", "", "CO", "097", "", "39.1911", "-106.81754", "America/Denver"),("5412347", "Aurora", "Аврора", "US", "840", "", "CO", "001", "", "39.72943", "-104.83192", "America/Denver"),("5412396", "Avon", "", "US", "840", "", "CO", "037", "", "39.63137", "-106.52225", "America/Denver"),("5413519", "Berkley", "", "US", "840", "", "CO", "001", "", "39.80443", "-105.02609", "America/Denver"),("5414069", "Black Forest", "", "US", "840", "", "CO", "041", "", "39.01305", "-104.70081", "America/Denver"),("5414941", "Brighton", "Брайтон", "US", "840", "", "CO", "001", "", "39.98526", "-104.82053", "America/Denver"),("5415035", "Broomfield", "", "US", "840", "", "CO", "014", "", "39.92054", "-105.08665", "America/Denver"),("5416005", "Cañon City", "", "US", "840", "", "CO", "043", "", "38.44098", "-105.24245", "America/Denver"),("5416113", "Carbondale", "", "US", "840", "", "CO", "045", "", "39.40221", "-107.21116", "America/Denver"),("5416329", "Castle Rock", "", "US", "840", "", "CO", "035", "", "39.37221", "-104.85609", "America/Denver"),("5416357", "Castlewood", "", "US", "840", "", "CO", "005", "", "39.58471", "-104.90109", "America/Denver"),("5416541", "Centennial", "Сентенниал", "US", "840", "", "CO", "005", "", "39.57916", "-104.87692", "America/Denver"),("5416824", "Cherry Hills Village", "", "US", "840", "", "CO", "005", "", "39.64165", "-104.95943", "America/Denver"),("5417041", "Cimarron Hills", "", "US", "840", "", "CO", "041", "", "38.85861", "-104.69886", "America/Denver"),("5417258", "Clifton", "Клифтон", "US", "840", "", "CO", "077", "", "39.09193", "-108.44898", "America/Denver"),("5417598", "Colorado Springs", "Колорадо-Спрингс", "US", "840", "", "CO", "041", "", "38.83388", "-104.82136", "America/Denver"),("5417657", "Columbine", "Коломбина", "US", "840", "", "CO", "059", "", "39.58777", "-105.06943", "America/Denver"),("5417737", "Commerce City", "", "US", "840", "", "CO", "001", "", "39.80832", "-104.93387", "America/Denver"),("5418104", "Cortez", "", "US", "840", "", "CO", "083", "", "37.34888", "-108.58593", "America/Denver"),("5419334", "Delta", "", "US", "840", "", "CO", "029", "", "38.74221", "-108.06896", "America/Denver"),("5419384", "Denver", "Денвер", "US", "840", "", "CO", "031", "", "39.73915", "-104.9847", "America/Denver"),("5419431", "Derby", "", "US", "840", "", "CO", "001", "", "39.83943", "-104.91859", "America/Denver"),("5420241", "Durango", "", "US", "840", "", "CO", "067", "", "37.27528", "-107.88007", "America/Denver"),("5420328", "Eagle", "", "US", "840", "", "CO", "037", "", "39.65526", "-106.82865", "America/Denver"),("5420859", "Edgewater", "", "US", "840", "", "CO", "059", "", "39.75304", "-105.06415", "America/Denver"),("5420885", "Edwards", "", "US", "840", "", "CO", "037", "", "39.64499", "-106.5942", "America/Denver"),("5421250", "Englewood", "", "US", "840", "", "CO", "005", "", "39.64777", "-104.98776", "America/Denver"),("5421418", "Evergreen", "", "US", "840", "", "CO", "059", "", "39.63332", "-105.31721", "America/Denver"),("5421709", "Federal Heights", "", "US", "840", "", "CO", "001", "", "39.85137", "-104.99859", "America/Denver"),("5422140", "Fort Carson", "", "US", "840", "", "CO", "041", "", "38.73749", "-104.78886", "America/Denver"),("5422191", "Fountain", "", "US", "840", "", "CO", "041", "", "38.68222", "-104.70081", "America/Denver"),("5422534", "Fruita", "", "US", "840", "", "CO", "077", "", "39.15887", "-108.72899", "America/Denver"),("5422557", "Fruitvale", "", "US", "840", "", "CO", "077", "", "39.08165", "-108.49676", "America/Denver"),("5423075", "Glendale", "", "US", "840", "", "CO", "005", "", "39.70499", "-104.93359", "America/Denver"),("5423078", "Gleneagle", "", "US", "840", "", "CO", "041", "", "39.04527", "-104.82442", "America/Denver"),("5423092", "Glenwood Springs", "", "US", "840", "", "CO", "045", "", "39.55054", "-107.32478", "America/Denver"),("5423294", "Golden", "Голден", "US", "840", "", "CO", "059", "", "39.75554", "-105.2211", "America/Denver"),("5423573", "Grand Junction", "Гранд Джанкшен", "US", "840", "", "CO", "077", "", "39.06387", "-108.55065", "America/Denver"),("5423908", "Greenwood Village", "", "US", "840", "", "CO", "005", "", "39.61721", "-104.95081", "America/Denver"),("5424099", "Gunnison", "", "US", "840", "", "CO", "051", "", "38.54582", "-106.92532", "America/Denver"),("5424152", "Gypsum", "", "US", "840", "", "CO", "037", "", "39.64693", "-106.95171", "America/Denver"),("5425043", "Highlands Ranch", "", "US", "840", "", "CO", "035", "", "39.55388", "-104.96943", "America/Denver"),("5427207", "Ken Caryl", "", "US", "840", "", "CO", "059", "", "39.57582", "-105.11221", "America/Denver"),("5427705", "La Junta", "", "US", "840", "", "CO", "089", "", "37.98501", "-103.54383", "America/Denver"),("5427771", "Lafayette", "Лафайет", "US", "840", "", "CO", "013", "", "39.9936", "-105.08971", "America/Denver"),("5427946", "Lakewood", "Лейквуд", "US", "840", "", "CO", "059", "", "39.70471", "-105.08137", "America/Denver"),("5427957", "Lamar", "", "US", "840", "", "CO", "099", "", "38.08723", "-102.62075", "America/Denver"),("5429032", "Littleton", "Литтлтон", "US", "840", "", "CO", "005", "", "39.61332", "-105.01665", "America/Denver"),("5429208", "Lone Tree", "", "US", "840", "", "CO", "001", "", "39.55171", "-104.8863", "America/Denver"),("5429522", "Louisville", "Луисвил", "US", "840", "", "CO", "013", "", "39.97776", "-105.13193", "America/Denver"),("5430023", "Manitou Springs", "", "US", "840", "", "CO", "041", "", "38.85971", "-104.9172", "America/Denver"),("5431710", "Montrose", "", "US", "840", "", "CO", "085", "", "38.47832", "-107.87617", "America/Denver"),("5431740", "Monument", "", "US", "840", "", "CO", "041", "", "39.09166", "-104.87276", "America/Denver"),("5433124", "Northglenn", "", "US", "840", "", "CO", "001", "", "39.88554", "-104.9872", "America/Denver"),("5433549", "Orchard Mesa", "", "US", "840", "", "CO", "077", "", "39.04304", "-108.55232", "America/Denver"),("5434006", "Parker", "Паркер", "US", "840", "", "CO", "035", "", "39.5186", "-104.76136", "America/Denver"),("5435464", "Pueblo", "Пуэбло", "US", "840", "", "CO", "101", "", "38.25445", "-104.60914", "America/Denver"),("5435477", "Pueblo West", "", "US", "840", "", "CO", "101", "", "38.35", "-104.72275", "America/Denver"),("5436099", "Redlands", "", "US", "840", "", "CO", "077", "", "39.07887", "-108.63565", "America/Denver"),("5436363", "Rifle", "", "US", "840", "", "CO", "045", "", "39.5347", "-107.78312", "America/Denver"),("5437081", "Roxborough Park", "", "US", "840", "", "CO", "035", "", "39.47388", "-105.08526", "America/Denver"),("5437555", "Salida", "", "US", "840", "", "CO", "015", "", "38.53472", "-105.9989", "America/Denver"),("5438542", "Sheridan", "", "US", "840", "", "CO", "005", "", "39.64693", "-105.02526", "America/Denver"),("5438567", "Sherrelwood", "", "US", "840", "", "CO", "001", "", "39.83776", "-105.00137", "America/Denver"),("5439752", "Southglenn", "", "US", "840", "", "CO", "005", "", "39.58721", "-104.95276", "America/Denver"),("5440437", "Stonegate", "", "US", "840", "", "CO", "035", "", "39.53082", "-104.80386", "America/Denver"),("5440520", "Stratmoor", "", "US", "840", "", "CO", "041", "", "38.77388", "-104.7797", "America/Denver"),("5440838", "Superior", "", "US", "840", "", "CO", "013", "", "39.95276", "-105.1686", "America/Denver"),("5441384", "The Pinery", "", "US", "840", "", "CO", "035", "", "39.45527", "-104.73442", "America/Denver"),("5441492", "Thornton", "Торнтон", "US", "840", "", "CO", "001", "", "39.86804", "-104.97192", "America/Denver"),("5442007", "Trinidad", "", "US", "840", "", "CO", "071", "", "37.16946", "-104.50054", "America/Denver"),("5442271", "Twin Lakes", "", "US", "840", "", "CO", "001", "", "39.82499", "-105.0047", "America/Denver"),("5442727", "Vail", "", "US", "840", "", "CO", "037", "", "39.64026", "-106.3742", "America/Denver"),("5443482", "Welby", "", "US", "840", "", "CO", "001", "", "39.83665", "-104.95915", "America/Denver"),("5443910", "Westminster", "Вестминстер", "US", "840", "", "CO", "001", "", "39.83665", "-105.0372", "America/Denver"),("5443948", "Wheat Ridge", "", "US", "840", "", "CO", "059", "", "39.7661", "-105.07721", "America/Denver"),("5444689", "Woodland Park", "", "US", "840", "", "CO", "119", "", "38.99388", "-105.05693", "America/Denver"),("5444707", "Woodmoor", "", "US", "840", "", "CO", "041", "", "39.10138", "-104.84748", "America/Denver"),("5445194", "Colby", "", "US", "840", "", "KS", "193", "", "39.39584", "-101.05238", "America/Chicago"),("5445298", "Dodge City", "Додж-сити", "US", "840", "", "KS", "057", "", "37.7528", "-100.01708", "America/Chicago"),("5445439", "Garden City", "", "US", "840", "", "KS", "055", "", "37.97169", "-100.87266", "America/Chicago"),("5445820", "Liberal", "Либеральная", "US", "840", "", "KS", "175", "", "37.04308", "-100.921", "America/Chicago"),("5446683", "Ulysses", "", "US", "840", "", "KS", "067", "", "37.58141", "-101.35517", "America/Chicago"),("5454627", "Alamogordo", "Аламогордо", "US", "840", "", "NM", "035", "", "32.89953", "-105.96027", "America/Denver"),("5454711", "Albuquerque", "Альбукерке", "US", "840", "", "NM", "001", "", "35.08449", "-106.65114", "America/Denver"),("5455381", "Anthony", "", "US", "840", "", "NM", "013", "", "32.00399", "-106.60583", "America/Denver"),("5455796", "Artesia", "", "US", "840", "", "NM", "015", "", "32.84233", "-104.4033", "America/Denver"),("5456049", "Aztec", "", "US", "840", "", "NM", "045", "", "36.82223", "-107.99285", "America/Denver"),("5456975", "Belen", "", "US", "840", "", "NM", "061", "", "34.66284", "-106.77642", "America/Denver"),("5457198", "Bernalillo", "", "US", "840", "", "NM", "043", "", "35.30004", "-106.55114", "America/Denver"),("5458067", "Bloomfield", "", "US", "840", "", "NM", "045", "", "36.71112", "-107.98451", "America/Denver"),("5460459", "Carlsbad", "Карлсбад", "US", "840", "", "NM", "015", "", "32.42067", "-104.22884", "America/Denver"),("5461353", "Chaparral", "", "US", "840", "", "NM", "013", "", "32.02376", "-106.38566", "America/Denver"),("5462393", "Clovis", "Кловис", "US", "840", "", "NM", "009", "", "34.4048", "-103.20523", "America/Denver"),("5463237", "Corrales", "", "US", "840", "", "NM", "043", "", "35.23782", "-106.60669", "America/Denver"),("5464806", "Deming", "", "US", "840", "", "NM", "029", "", "32.2687", "-107.75864", "America/Denver"),("5466585", "Eldorado at Santa Fe", "", "US", "840", "", "NM", "049", "", "35.52642", "-105.93474", "America/Denver"),("5467024", "Española", "", "US", "840", "", "NM", "039", "", "35.99113", "-106.08058", "America/Denver"),("5467328", "Farmington", "Фармингтон", "US", "840", "", "NM", "045", "", "36.72806", "-108.21869", "America/Denver"),("5468773", "Gallup", "Гэллап", "US", "840", "", "NM", "031", "", "35.52808", "-108.74258", "America/Denver"),("5469841", "Grants", "", "US", "840", "", "NM", "006", "", "35.1476", "-107.85261", "America/Denver"),("5471578", "Hobbs", "Хоббс", "US", "840", "", "NM", "025", "", "32.70261", "-103.13604", "America/Denver"),("5474539", "Kirtland", "", "US", "840", "", "NM", "045", "", "36.73417", "-108.3598", "America/Denver"),("5475352", "Las Cruces", "Лас-Крусес", "US", "840", "", "NM", "013", "", "32.31232", "-106.77834", "America/Denver"),("5475433", "Las Vegas", "", "US", "840", "", "NM", "047", "", "35.59393", "-105.2239", "America/Denver"),("5475667", "Lee Acres", "", "US", "840", "", "NM", "001", "", "35.14866", "-106.64697", "America/Denver"),("5475668", "Lee Acres", "", "US", "840", "", "NM", "045", "", "36.69889", "-108.03674", "America/Denver"),("5476825", "Los Alamos", "", "US", "840", "", "NM", "028", "", "35.88808", "-106.30697", "America/Denver"),("5476881", "Los Chavez", "", "US", "840", "", "NM", "061", "", "34.72571", "-106.75726", "America/Denver"),("5476913", "Los Lunas", "", "US", "840", "", "NM", "061", "", "34.80617", "-106.73336", "America/Denver"),("5476960", "Los Ranchos de Albuquerque", "", "US", "840", "", "NM", "001", "", "35.16199", "-106.6428", "America/Denver"),("5477090", "Lovington", "", "US", "840", "", "NM", "025", "", "32.94401", "-103.34855", "America/Denver"),("5481793", "North Valley", "", "US", "840", "", "NM", "001", "", "35.17338", "-106.62336", "America/Denver"),("5484874", "Portales", "", "US", "840", "", "NM", "041", "", "34.18619", "-103.3344", "America/Denver"),("5486795", "Raton", "", "US", "840", "", "NM", "007", "", "36.90336", "-104.43915", "America/Denver"),("5487810", "Rio Rancho", "", "US", "840", "", "NM", "043", "", "35.26004", "-106.70614", "America/Denver"),("5487811", "Rio Rancho", "Рио-Ранчо", "US", "840", "", "NM", "043", "", "35.23338", "-106.66447", "America/Denver"),("5488441", "Roswell", "Розуэлл", "US", "840", "", "NM", "005", "", "33.39437", "-104.52491", "America/Denver"),("5488598", "Ruidoso", "", "US", "840", "", "NM", "027", "", "33.33175", "-105.67304", "America/Denver"),("5490263", "Santa Fe", "Санта-Фе", "US", "840", "", "NM", "049", "", "35.68698", "-105.9378", "America/Denver"),("5491288", "Shiprock", "", "US", "840", "", "NM", "045", "", "36.78555", "-108.68703", "America/Denver"),("5491487", "Silver City", "", "US", "840", "", "NM", "017", "", "32.77007", "-108.28033", "America/Denver"),("5491999", "Socorro", "", "US", "840", "", "NM", "053", "", "34.0584", "-106.89142", "America/Denver"),("5492450", "South Valley", "", "US", "840", "", "NM", "001", "", "35.01005", "-106.67808", "America/Denver"),("5493403", "Sunland Park", "", "US", "840", "", "NM", "013", "", "31.7965", "-106.57999", "America/Denver"),("5493811", "Taos", "", "US", "840", "", "NM", "055", "", "36.40725", "-105.57307", "America/Denver"),("5495292", "Truth or Consequences", "", "US", "840", "", "NM", "051", "", "33.1284", "-107.25281", "America/Denver"),("5495360", "Tucumcari", "", "US", "840", "", "NM", "037", "", "35.17191", "-103.72686", "America/Denver"),("5497876", "White Rock", "", "US", "840", "", "NM", "028", "", "35.82753", "-106.20391", "America/Denver"),("5499004", "Zuni Pueblo", "", "US", "840", "", "NM", "031", "", "35.07253", "-108.85064", "America/Denver"),("5500539", "Boulder City", "Боулдер", "US", "840", "", "NV", "003", "", "35.97859", "-114.83249", "America/Los_Angeles"),("5501344", "Carson City", "Карсон-Сити", "US", "840", "", "NV", "510", "", "39.1638", "-119.7674", "America/Los_Angeles"),("5502015", "Cold Springs", "", "US", "840", "", "NV", "031", "", "39.68019", "-119.97659", "America/Los_Angeles"),("5502732", "Dayton", "", "US", "840", "", "NV", "019", "", "39.23714", "-119.59295", "America/Los_Angeles"),("5503766", "Enterprise", "", "US", "840", "", "NV", "003", "", "36.02525", "-115.24194", "America/Los_Angeles"),("5503914", "Fallon", "", "US", "840", "", "NV", "001", "", "39.47353", "-118.77737", "America/Los_Angeles"),("5504003", "Fernley", "", "US", "840", "", "NV", "019", "", "39.60797", "-119.25183", "America/Los_Angeles"),("5504468", "Gardnerville", "", "US", "840", "", "NV", "005", "", "38.9413", "-119.74962", "America/Los_Angeles"),("5504473", "Gardnerville Ranchos", "", "US", "840", "", "NV", "005", "", "38.88824", "-119.74129", "America/Los_Angeles"),("5505411", "Henderson", "Хендерсон", "US", "840", "", "NV", "003", "", "36.0397", "-114.98194", "America/Los_Angeles"),("5505963", "Incline Village", "", "US", "840", "", "NV", "031", "", "39.2513", "-119.97297", "America/Los_Angeles"),("5506353", "Johnson Lane", "", "US", "840", "", "NV", "005", "", "39.04796", "-119.72212", "America/Los_Angeles"),("5506956", "Las Vegas", "Лас-Вегас", "US", "840", "", "NV", "003", "", "36.17497", "-115.13722", "America/Los_Angeles"),("5507016", "Laughlin", "", "US", "840", "", "NV", "003", "", "35.16778", "-114.57302", "America/Los_Angeles"),("5507103", "Lemmon Valley", "", "US", "840", "", "NV", "031", "", "39.63602", "-119.84325", "America/Los_Angeles"),("5508180", "Mesquite", "", "US", "840", "", "NV", "003", "", "36.80553", "-114.06719", "America/Los_Angeles"),("5508473", "Moapa Valley", "", "US", "840", "", "NV", "003", "", "36.58053", "-114.47026", "America/Los_Angeles"),("5509403", "North Las Vegas", "Норт-Лас-Вегас", "US", "840", "", "NV", "003", "", "36.19886", "-115.1175", "America/Los_Angeles"),("5509851", "Pahrump", "", "US", "840", "", "NV", "023", "", "36.20829", "-115.98391", "America/Los_Angeles"),("5509952", "Paradise", "Парадайз", "US", "840", "", "NV", "003", "", "36.09719", "-115.14666", "America/Los_Angeles"),("5511077", "Reno", "Рино", "US", "840", "", "NV", "031", "", "39.52963", "-119.8138", "America/Los_Angeles"),("5512373", "Silver Springs", "", "US", "840", "", "NV", "019", "", "39.41547", "-119.22461", "America/Los_Angeles"),("5512827", "Spanish Springs", "", "US", "840", "", "NV", "031", "", "39.64908", "-119.70741", "America/Los_Angeles"),("5512862", "Sparks", "Спаркс", "US", "840", "", "NV", "031", "", "39.53491", "-119.75269", "America/Los_Angeles"),("5512909", "Spring Valley", "Спринг-Вэлли", "US", "840", "", "NV", "003", "", "36.10803", "-115.245", "America/Los_Angeles"),("5513307", "Sun Valley", "", "US", "840", "", "NV", "031", "", "39.5963", "-119.77602", "America/Los_Angeles"),("5513343", "Sunrise Manor", "", "US", "840", "", "NV", "003", "", "36.21108", "-115.07306", "America/Los_Angeles"),("5515110", "Whitney", "Уитни", "US", "840", "", "NV", "003", "", "36.09831", "-115.0363", "America/Los_Angeles"),("5515345", "Winchester", "", "US", "840", "", "NV", "003", "", "36.12997", "-115.11889", "America/Los_Angeles"),("5515743", "Guymon", "", "US", "840", "", "OK", "139", "", "36.6828", "-101.48155", "America/Chicago"),("5516203", "Alpine", "", "US", "840", "", "TX", "043", "", "30.35862", "-103.66206", "America/Chicago"),("5516233", "Amarillo", "Амарилло", "US", "840", "", "TX", "375", "", "35.222", "-101.8313", "America/Chicago"),("5516288", "Andrews", "", "US", "840", "", "TX", "003", "", "32.31872", "-102.54572", "America/Chicago"),("5516368", "Anthony", "", "US", "840", "", "TX", "141", "", "31.99927", "-106.60555", "America/Denver"),("5517061", "Big Spring", "", "US", "840", "", "TX", "227", "", "32.2504", "-101.47874", "America/Chicago"),("5517469", "Borger", "", "US", "840", "", "TX", "233", "", "35.66782", "-101.39739", "America/Chicago"),("5517675", "Brownfield", "", "US", "840", "", "TX", "445", "", "33.1812", "-102.27435", "America/Chicago"),("5518232", "Canutillo", "", "US", "840", "", "TX", "141", "", "31.91149", "-106.60027", "America/Denver"),("5518239", "Canyon", "", "US", "840", "", "TX", "381", "", "34.98033", "-101.9188", "America/Chicago"),("5518758", "Childress", "", "US", "840", "", "TX", "075", "", "34.42645", "-100.204", "America/Chicago"),("5519862", "Dalhart", "", "US", "840", "", "TX", "111", "", "36.05948", "-102.51325", "America/Chicago"),("5520076", "Del Rio", "Дель-Рио", "US", "840", "", "TX", "465", "", "29.36273", "-100.89676", "America/Chicago"),("5520552", "Dumas", "", "US", "840", "", "TX", "341", "", "35.86559", "-101.97324", "America/Chicago"),("5520677", "Eagle Pass", "", "US", "840", "", "TX", "323", "", "28.70914", "-100.49952", "America/Chicago"),("5520953", "Eidson Road", "", "US", "840", "", "TX", "323", "", "28.6772", "-100.48702", "America/Chicago"),("5520993", "El Paso", "Эль-Пасо", "US", "840", "", "TX", "141", "", "31.75872", "-106.48693", "America/Denver"),("5521233", "Fabens", "", "US", "840", "", "TX", "141", "", "31.50234", "-106.15859", "America/Denver"),("5521746", "Fort Stockton", "", "US", "840", "", "TX", "371", "", "30.89404", "-102.87932", "America/Chicago"),("5523074", "Hereford", "", "US", "840", "", "TX", "117", "", "34.81521", "-102.39932", "America/Chicago"),("5523335", "Homestead Meadows North", "", "US", "840", "", "TX", "141", "", "31.84963", "-106.17285", "America/Denver"),("5523336", "Homestead Meadows South", "", "US", "840", "", "TX", "141", "", "31.81097", "-106.16427", "America/Denver"),("5523369", "Horizon City", "", "US", "840", "", "TX", "141", "", "31.69261", "-106.20748", "America/Denver"),("5524527", "Kermit", "", "US", "840", "", "TX", "495", "", "31.85763", "-103.09267", "America/Chicago"),("5524849", "Lamesa", "", "US", "840", "", "TX", "115", "", "32.7376", "-101.95099", "America/Chicago"),("5525042", "Levelland", "", "US", "840", "", "TX", "219", "", "33.58732", "-102.37796", "America/Chicago"),("5525295", "Littlefield", "", "US", "840", "", "TX", "279", "", "33.91731", "-102.3249", "America/Chicago"),("5525577", "Lubbock", "Лаббок", "US", "840", "", "TX", "303", "", "33.57786", "-101.85517", "America/Chicago"),("5526337", "Midland", "Мидленд", "US", "840", "", "TX", "329", "", "31.99735", "-102.07791", "America/Chicago"),("5526514", "Monahans", "", "US", "840", "", "TX", "475", "", "31.5943", "-102.89265", "America/Chicago"),("5526805", "Muleshoe", "", "US", "840", "", "TX", "017", "", "34.22647", "-102.72383", "America/Chicago"),("5527554", "Odessa", "Одесса", "US", "840", "", "TX", "135", "", "31.84568", "-102.36764", "America/Chicago"),("5527953", "Pampa", "Пампа", "US", "840", "", "TX", "179", "", "35.53616", "-100.95987", "America/Chicago"),("5528182", "Pecos", "", "US", "840", "", "TX", "389", "", "31.42291", "-103.49323", "America/Chicago"),("5528274", "Perryton", "", "US", "840", "", "TX", "357", "", "36.40003", "-100.80265", "America/Chicago"),("5528450", "Plainview", "", "US", "840", "", "TX", "189", "", "34.18479", "-101.70684", "America/Chicago"),("5528596", "Post", "", "US", "840", "", "TX", "169", "", "33.19122", "-101.379", "America/Chicago"),("5530022", "San Angelo", "", "US", "840", "", "TX", "451", "", "31.46377", "-100.43704", "America/Chicago"),("5530058", "San Elizario", "", "US", "840", "", "TX", "141", "", "31.58511", "-106.27276", "America/Denver"),("5530452", "Seminole", "", "US", "840", "", "TX", "165", "", "32.71899", "-102.64491", "America/Chicago"),("5530825", "Slaton", "", "US", "840", "", "TX", "303", "", "33.43731", "-101.64349", "America/Chicago"),("5530921", "Snyder", "", "US", "840", "", "TX", "415", "", "32.71789", "-100.91762", "America/Chicago"),("5530932", "Socorro", "Сокорро", "US", "840", "", "TX", "141", "", "31.65456", "-106.30331", "America/Denver"),("5530937", "Socorro Mission Number 1 Colonia", "", "US", "840", "", "TX", "141", "", "31.63622", "-106.29054", "America/Denver"),("5531968", "Sweetwater", "", "US", "840", "", "TX", "353", "", "32.47095", "-100.40594", "America/Chicago"),("5533366", "West Odessa", "", "US", "840", "", "TX", "135", "", "31.84235", "-102.49876", "America/Chicago"),("5536630", "Cedar City", "", "US", "840", "", "UT", "021", "", "37.67748", "-113.06189", "America/Denver"),("5538914", "Enoch", "", "US", "840", "", "UT", "021", "", "37.77331", "-113.02439", "America/Denver"),("5538927", "Ephraim", "", "US", "840", "", "UT", "039", "", "39.35968", "-111.58631", "America/Denver"),("5540831", "Hurricane", "", "US", "840", "", "UT", "053", "", "37.17526", "-113.28995", "America/Denver"),("5541061", "Ivins", "", "US", "840", "", "UT", "053", "", "37.16859", "-113.67941", "America/Denver"),("5543307", "Moab", "", "US", "840", "", "UT", "019", "", "38.57332", "-109.54984", "America/Denver"),("5543853", "Nephi", "", "US", "840", "", "UT", "023", "", "39.71023", "-111.83632", "America/Denver"),("5545269", "Price", "", "US", "840", "", "UT", "007", "", "39.59941", "-110.81071", "America/Denver"),("5545710", "Richfield", "", "US", "840", "", "UT", "041", "", "38.77247", "-112.08409", "America/Denver"),("5546220", "Saint George", "", "US", "840", "", "UT", "053", "", "37.10415", "-113.58412", "America/Denver"),("5546441", "Santa Clara", "", "US", "840", "", "UT", "053", "", "37.13304", "-113.65413", "America/Denver"),("5546452", "Santaquin", "", "US", "840", "", "UT", "049", "", "39.97551", "-111.78521", "America/Denver"),("5549222", "Washington", "Вашингтон", "US", "840", "", "UT", "053", "", "37.13054", "-113.50829", "America/Denver"),("5550192", "West Sedona", "", "US", "840", "", "AZ", "025", "", "34.86724", "-111.80543", "America/Phoenix"),("5550368", "Wasco", "", "US", "840", "", "CA", "029", "", "35.59412", "-119.34095", "America/Los_Angeles"),("5550579", "Indian Hills", "", "US", "840", "", "NV", "005", "", "39.08602", "-119.78407", "America/Los_Angeles"),("5551498", "Anthem", "", "US", "840", "", "AZ", "013", "", "33.86726", "-112.14682", "America/Phoenix"),("5551535", "Apache Junction", "", "US", "840", "", "AZ", "021", "", "33.41505", "-111.54958", "America/Phoenix"),("5551665", "Arizona City", "", "US", "840", "", "AZ", "021", "", "32.75589", "-111.67096", "America/Phoenix"),("5552301", "Avondale", "", "US", "840", "", "AZ", "013", "", "33.4356", "-112.3496", "America/Phoenix"),("5552323", "Avra Valley", "", "US", "840", "", "AZ", "019", "", "32.43785", "-111.31539", "America/Phoenix"),("5553533", "Big Park", "", "US", "840", "", "AZ", "025", "", "34.7803", "-111.76265", "America/Phoenix"),("5553955", "Rathdrum", "", "US", "840", "", "ID", "055", "", "47.8124", "-116.89659", "America/Los_Angeles"),("5554072", "Juneau", "Джуно", "US", "840", "", "AK", "110", "", "58.30194", "-134.41972", "America/Juneau"),("5554428", "Ketchikan", "", "US", "840", "", "AK", "130", "", "55.34225", "-131.64784", "America/Sitka"),("5555083", "Little Cottonwood Creek Valley", "", "US", "840", "", "UT", "035", "", "40.60439", "-111.82938", "America/Denver"),("5555097", "Salem", "", "US", "840", "", "UT", "049", "", "40.05301", "-111.67354", "America/Denver"),("5555235", "Lea Hill", "", "US", "840", "", "WA", "033", "", "47.32621", "-122.18151", "America/Los_Angeles"),("5557293", "Sitka", "", "US", "840", "", "AK", "220", "", "57.05315", "-135.33088", "America/Sitka"),("5558857", "Anderson", "", "US", "840", "", "CA", "089", "", "40.44821", "-122.29778", "America/Los_Angeles"),("5558953", "Arcata", "", "US", "840", "", "CA", "023", "", "40.86652", "-124.08284", "America/Los_Angeles"),("5559320", "Bayside", "", "US", "840", "", "CA", "023", "", "40.84235", "-124.06367", "America/Los_Angeles"),("5562087", "Crescent City", "", "US", "840", "", "CA", "015", "", "41.75595", "-124.20175", "America/Los_Angeles"),("5563397", "Eureka", "Эврика", "US", "840", "", "CA", "023", "", "40.80207", "-124.16367", "America/Los_Angeles"),("5563839", "Fortuna", "", "US", "840", "", "CA", "023", "", "40.59819", "-124.15728", "America/Los_Angeles"),("5567770", "McKinleyville", "", "US", "840", "", "CA", "023", "", "40.94652", "-124.10062", "America/Los_Angeles"),("5570065", "Red Bluff", "", "US", "840", "", "CA", "103", "", "40.17849", "-122.23583", "America/Los_Angeles"),("5570160", "Redding", "", "US", "840", "", "CA", "089", "", "40.58654", "-122.39168", "America/Los_Angeles"),("5571109", "Shasta Lake", "", "US", "840", "", "CA", "089", "", "40.68043", "-122.37084", "America/Los_Angeles"),("5572400", "Susanville", "", "US", "840", "", "CA", "035", "", "40.41628", "-120.65301", "America/Los_Angeles"),("5574093", "Yreka", "", "US", "840", "", "CA", "093", "", "41.73542", "-122.63447", "America/Los_Angeles"),("5574704", "Berthoud", "", "US", "840", "", "CO", "069", "", "40.30832", "-105.08109", "America/Denver"),("5574991", "Boulder", "Боулдер", "US", "840", "", "CO", "013", "", "40.01499", "-105.27055", "America/Denver"),("5575194", "Brush", "", "US", "840", "", "CO", "087", "", "40.25887", "-103.62384", "America/Denver"),("5576064", "Craig", "", "US", "840", "", "CO", "081", "", "40.51525", "-107.54645", "America/Denver"),("5576859", "Erie", "Эри", "US", "840", "", "CO", "013", "", "40.05026", "-105.04998", "America/Denver"),("5576882", "Estes Park", "", "US", "840", "", "CO", "069", "", "40.37721", "-105.52167", "America/Denver"),("5576909", "Evans", "", "US", "840", "", "CO", "123", "", "40.37637", "-104.69219", "America/Denver"),("5577008", "Firestone", "", "US", "840", "", "CO", "123", "", "40.11248", "-104.93664", "America/Denver"),("5577147", "Fort Collins", "Форт-Коллинс", "US", "840", "", "CO", "069", "", "40.58526", "-105.08442", "America/Denver"),("5577153", "Fort Lupton", "", "US", "840", "", "CO", "123", "", "40.08471", "-104.81303", "America/Denver"),("5577158", "Fort Morgan", "", "US", "840", "", "CO", "087", "", "40.25026", "-103.79995", "America/Denver"),("5577217", "Frederick", "", "US", "840", "", "CO", "123", "", "40.09915", "-104.9372", "America/Denver"),("5577592", "Greeley", "Грили", "US", "840", "", "CO", "123", "", "40.42331", "-104.70913", "America/Denver"),("5578536", "Johnstown", "", "US", "840", "", "CO", "123", "", "40.33693", "-104.9122", "America/Denver"),("5579170", "Lochbuie", "", "US", "840", "", "CO", "123", "", "40.00721", "-104.71608", "America/Denver"),("5579276", "Longmont", "", "US", "840", "", "CO", "013", "", "40.16721", "-105.10193", "America/Denver"),("5579368", "Loveland", "", "US", "840", "", "CO", "069", "", "40.39776", "-105.07498", "America/Denver"),("5579899", "Milliken", "", "US", "840", "", "CO", "123", "", "40.32943", "-104.85525", "America/Denver"),("5582371", "Steamboat Springs", "", "US", "840", "", "CO", "107", "", "40.48498", "-106.83172", "America/Denver"),("5582392", "Sterling", "", "US", "840", "", "CO", "075", "", "40.62554", "-103.20771", "America/Denver"),("5583250", "Wellington", "", "US", "840", "", "CO", "069", "", "40.70387", "-105.00859", "America/Denver"),("5583509", "Windsor", "Виндзор", "US", "840", "", "CO", "123", "", "40.47748", "-104.90136", "America/Denver"),("5583997", "Ammon", "", "US", "840", "", "ID", "019", "", "43.46964", "-111.96664", "America/Boise"),("5586093", "Blackfoot", "", "US", "840", "", "ID", "011", "", "43.19047", "-112.34498", "America/Boise"),("5586437", "Boise", "Бойсе", "US", "840", "", "ID", "001", "", "43.6135", "-116.20345", "America/Boise"),("5587385", "Burley", "", "US", "840", "", "ID", "031", "", "42.53574", "-113.79279", "America/Boise"),("5587698", "Caldwell", "Колдуэлл", "US", "840", "", "ID", "027", "", "43.66294", "-116.68736", "America/Boise"),("5588842", "Chubbuck", "", "US", "840", "", "ID", "005", "", "42.92075", "-112.46609", "America/Boise"),("5589173", "Coeur d'Alene", "Кёр-д’Ален", "US", "840", "", "ID", "055", "", "47.67768", "-116.78047", "America/Los_Angeles"),("5591778", "Eagle", "Игл", "US", "840", "", "ID", "001", "", "43.69544", "-116.35401", "America/Boise"),("5592562", "Emmett", "", "US", "840", "", "ID", "045", "", "43.8735", "-116.4993", "America/Boise"),("5593708", "Fruitland", "", "US", "840", "", "ID", "075", "", "44.00766", "-116.91655", "America/Boise"),("5593814", "Garden City", "", "US", "840", "", "ID", "001", "", "43.62211", "-116.23817", "America/Boise"),("5594956", "Hailey", "", "US", "840", "", "ID", "013", "", "43.51963", "-114.31532", "America/Boise"),("5595320", "Hayden", "", "US", "840", "", "ID", "055", "", "47.76602", "-116.78658", "America/Los_Angeles"),("5596475", "Idaho Falls", "Айдахо-Фолс", "US", "840", "", "ID", "019", "", "43.46658", "-112.03414", "America/Boise"),("5597034", "Jerome", "", "US", "840", "", "ID", "053", "", "42.72407", "-114.51865", "America/Boise"),("5597955", "Kuna", "", "US", "840", "", "ID", "001", "", "43.49183", "-116.42012", "America/Boise"),("5598538", "Lewiston", "Льюистон", "US", "840", "", "ID", "069", "", "46.41655", "-117.01766", "America/Los_Angeles"),("5598542", "Lewiston Orchards", "", "US", "840", "", "ID", "069", "", "46.38044", "-116.97543", "America/Los_Angeles"),("5600685", "Meridian", "Меридиан", "US", "840", "", "ID", "001", "", "43.61211", "-116.39151", "America/Boise"),("5600890", "Middleton", "", "US", "840", "", "ID", "027", "", "43.70683", "-116.62014", "America/Boise"),("5601538", "Moscow", "Москва", "US", "840", "", "ID", "057", "", "46.73239", "-117.00017", "America/Los_Angeles"),("5601615", "Mountain Home", "", "US", "840", "", "ID", "039", "", "43.13295", "-115.6912", "America/Boise"),("5601933", "Nampa", "Нампа", "US", "840", "", "ID", "027", "", "43.54072", "-116.56346", "America/Boise"),("5603393", "Payette", "", "US", "840", "", "ID", "075", "", "44.07822", "-116.93377", "America/Boise"),("5604045", "Pocatello", "Покателло", "US", "840", "", "ID", "005", "", "42.8713", "-112.44553", "America/Boise"),("5604353", "Post Falls", "Пост-Фолс", "US", "840", "", "ID", "055", "", "47.71796", "-116.95159", "America/Los_Angeles"),("5604473", "Preston", "", "US", "840", "", "ID", "041", "", "42.09631", "-111.87662", "America/Boise"),("5605242", "Rexburg", "Рексберг", "US", "840", "", "ID", "065", "", "43.82602", "-111.78969", "America/Boise"),("5606000", "Rupert", "", "US", "840", "", "ID", "067", "", "42.61908", "-113.67723", "America/Boise"),("5606401", "Sandpoint", "", "US", "840", "", "ID", "017", "", "48.27659", "-116.55325", "America/Los_Angeles"),("5608754", "Star", "", "US", "840", "", "ID", "001", "", "43.69211", "-116.49346", "America/Boise"),("5610810", "Twin Falls", "Туин-Фолс", "US", "840", "", "ID", "083", "", "42.56297", "-114.46087", "America/Boise"),("5611730", "Weiser", "", "US", "840", "", "ID", "087", "", "44.251", "-116.96933", "America/Boise"),("5637146", "Anaconda", "", "US", "840", "", "MT", "023", "", "46.12854", "-112.94226", "America/Denver"),("5639364", "Belgrade", "", "US", "840", "", "MT", "031", "", "45.77604", "-111.1769", "America/Denver"),("5640350", "Billings", "Биллингс", "US", "840", "", "MT", "111", "", "45.78329", "-108.50069", "America/Denver"),("5641727", "Bozeman", "Бозмана", "US", "840", "", "MT", "031", "", "45.67965", "-111.03856", "America/Denver"),("5642934", "Butte", "Бьютт", "US", "840", "", "MT", "093", "", "46.00382", "-112.53474", "America/Denver"),("5645859", "Columbia Falls", "", "US", "840", "", "MT", "029", "", "48.37246", "-114.18152", "America/Denver"),("5651289", "Evergreen", "", "US", "840", "", "MT", "029", "", "48.22579", "-114.27624", "America/Denver"),("5654391", "Glendive", "", "US", "840", "", "MT", "021", "", "47.10529", "-104.71246", "America/Denver"),("5655240", "Great Falls", "Грейт-Фолс", "US", "840", "", "MT", "013", "", "47.50024", "-111.30081", "America/Denver"),("5656497", "Havre", "", "US", "840", "", "MT", "041", "", "48.55", "-109.68409", "America/Denver"),("5656882", "Helena", "Хелена", "US", "840", "", "MT", "049", "", "46.59271", "-112.03611", "America/Denver"),("5660340", "Kalispell", "Калиспелл", "US", "840", "", "MT", "029", "", "48.19579", "-114.31291", "America/Denver"),("5661766", "Laurel", "", "US", "840", "", "MT", "111", "", "45.66912", "-108.77153", "America/Denver"),("5662162", "Lewistown", "", "US", "840", "", "MT", "027", "", "47.06247", "-109.42824", "America/Denver"),("5663049", "Livingston", "", "US", "840", "", "MT", "067", "", "45.66244", "-110.56104", "America/Denver"),("5663135", "Lockwood", "", "US", "840", "", "MT", "111", "", "45.81912", "-108.41486", "America/Denver"),("5666176", "Miles City", "", "US", "840", "", "MT", "017", "", "46.40834", "-105.84056", "America/Denver"),("5666639", "Missoula", "Миссула", "US", "840", "", "MT", "063", "", "46.87215", "-113.994", "America/Denver"),("5670128", "Orchard Homes", "", "US", "840", "", "MT", "063", "", "46.86326", "-114.04844", "America/Denver"),("5677735", "Sidney", "", "US", "840", "", "MT", "083", "", "47.71668", "-104.15633", "America/Denver"),("5686121", "Whitefish", "", "US", "840", "", "MT", "029", "", "48.41108", "-114.33763", "America/Denver"),("5688025", "Bismarck", "Бисмарк", "US", "840", "", "ND", "015", "", "46.80833", "-100.78374", "America/Chicago"),("5688789", "Dickinson", "", "US", "840", "", "ND", "089", "", "46.87918", "-102.78962", "America/Denver"),("5690366", "Mandan", "", "US", "840", "", "ND", "059", "", "46.82666", "-100.88958", "America/North_Dakota/New_Salem"),("5690532", "Minot", "Мина", "US", "840", "", "ND", "101", "", "48.23251", "-101.29627", "America/Chicago"),("5692814", "Watford City", "", "US", "840", "", "ND", "053", "", "47.80224", "-103.28325", "America/Chicago"),("5692947", "Williston", "", "US", "840", "", "ND", "105", "", "48.14697", "-103.61797", "America/Chicago"),("5693164", "Alliance", "", "US", "840", "", "NE", "013", "", "42.10163", "-102.87215", "America/Denver"),("5694163", "Chadron", "", "US", "840", "", "NE", "045", "", "42.82942", "-102.99991", "America/Denver"),("5695604", "Gering", "", "US", "840", "", "NE", "157", "", "41.8258", "-103.6605", "America/Denver"),("5697383", "McCook", "", "US", "840", "", "NE", "145", "", "40.20195", "-100.62571", "America/Chicago"),("5697939", "North Platte", "Норт-Платт", "US", "840", "", "NE", "111", "", "41.12389", "-100.76542", "America/Chicago"),("5699404", "Scottsbluff", "Скотсблафф", "US", "840", "", "NE", "157", "", "41.86663", "-103.66717", "America/Denver"),("5699552", "Sidney", "", "US", "840", "", "NE", "033", "", "41.14276", "-102.97798", "America/Denver"),("5703670", "Elko", "Элко", "US", "840", "", "NV", "007", "", "40.83242", "-115.76312", "America/Los_Angeles"),("5708894", "Spring Creek", "", "US", "840", "", "NV", "007", "", "40.72659", "-115.5859", "America/Los_Angeles"),("5710360", "Winnemucca", "", "US", "840", "", "NV", "013", "", "40.97296", "-117.73568", "America/Los_Angeles"),("5710756", "Albany", "Олбани", "US", "840", "", "OR", "043", "", "44.63651", "-123.10593", "America/Los_Angeles"),("5711099", "Aloha", "", "US", "840", "", "OR", "067", "", "45.49428", "-122.86705", "America/Los_Angeles"),("5711149", "Altamont", "", "US", "840", "", "OR", "035", "", "42.20681", "-121.73722", "America/Los_Angeles"),("5711789", "Ashland", "", "US", "840", "", "OR", "029", "", "42.19458", "-122.70948", "America/Los_Angeles"),("5711847", "Astoria", "", "US", "840", "", "OR", "007", "", "46.18788", "-123.83125", "America/Los_Angeles"),("5712169", "Baker City", "", "US", "840", "", "OR", "001", "", "44.77487", "-117.83438", "America/Los_Angeles"),("5713376", "Beaverton", "Бивертон", "US", "840", "", "OR", "067", "", "45.48706", "-122.80371", "America/Los_Angeles"),("5713587", "Bend", "Бенд", "US", "840", "", "OR", "017", "", "44.05817", "-121.31531", "America/Los_Angeles"),("5713759", "Bethany", "", "US", "840", "", "OR", "067", "", "45.55789", "-122.8676", "America/Los_Angeles"),("5715905", "Brookings", "", "US", "840", "", "OR", "015", "", "42.05261", "-124.28398", "America/Los_Angeles"),("5717758", "Canby", "", "US", "840", "", "OR", "005", "", "45.2629", "-122.69259", "America/Los_Angeles"),("5718480", "Cedar Hills", "", "US", "840", "", "OR", "067", "", "45.50484", "-122.79843", "America/Los_Angeles"),("5718492", "Cedar Mill", "", "US", "840", "", "OR", "067", "", "45.52484", "-122.81093", "America/Los_Angeles"),("5718601", "Central Point", "", "US", "840", "", "OR", "029", "", "42.37596", "-122.91643", "America/Los_Angeles"),("5719308", "Clackamas", "", "US", "840", "", "OR", "005", "", "45.40762", "-122.57037", "America/Los_Angeles"),("5720495", "Coos Bay", "", "US", "840", "", "OR", "011", "", "43.3665", "-124.21789", "America/Los_Angeles"),("5720639", "Cornelius", "", "US", "840", "", "OR", "067", "", "45.51984", "-123.05983", "America/Los_Angeles"),("5720727", "Corvallis", "", "US", "840", "", "OR", "003", "", "44.56457", "-123.26204", "America/Los_Angeles"),("5720755", "Cottage Grove", "", "US", "840", "", "OR", "039", "", "43.79762", "-123.05952", "America/Los_Angeles"),("5721551", "Creswell", "", "US", "840", "", "OR", "039", "", "43.9179", "-123.02453", "America/Los_Angeles"),("5722064", "Dallas", "", "US", "840", "", "OR", "053", "", "44.91928", "-123.31705", "America/Los_Angeles"),("5722088", "Damascus", "", "US", "840", "", "OR", "005", "", "45.41762", "-122.45898", "America/Los_Angeles"),("5722960", "Deschutes River Woods", "", "US", "840", "", "OR", "017", "", "43.99151", "-121.35836", "America/Los_Angeles"),("5724581", "Eagle Point", "", "US", "840", "", "OR", "029", "", "42.47263", "-122.80282", "America/Los_Angeles"),("5725846", "Eugene", "Юджин", "US", "840", "", "OR", "039", "", "44.05207", "-123.08675", "America/Los_Angeles"),("5726018", "Fairview", "", "US", "840", "", "OR", "051", "", "45.53845", "-122.43398", "America/Los_Angeles"),("5727032", "Florence", "", "US", "840", "", "OR", "039", "", "43.98262", "-124.09984", "America/Los_Angeles"),("5727190", "Forest Grove", "", "US", "840", "", "OR", "067", "", "45.51984", "-123.11066", "America/Los_Angeles"),("5727382", "Four Corners", "", "US", "840", "", "OR", "047", "", "44.9279", "-122.98371", "America/Los_Angeles"),("5728429", "Gladstone", "", "US", "840", "", "OR", "005", "", "45.38068", "-122.59481", "America/Los_Angeles"),("5729080", "Grants Pass", "Грантс-Пасс", "US", "840", "", "OR", "033", "", "42.43933", "-123.33067", "America/Los_Angeles"),("5729293", "Green", "", "US", "840", "", "OR", "019", "", "43.16039", "-123.36785", "America/Los_Angeles"),("5729485", "Gresham", "Грешам", "US", "840", "", "OR", "051", "", "45.49818", "-122.43148", "America/Los_Angeles"),("5730183", "Happy Valley", "", "US", "840", "", "OR", "005", "", "45.44679", "-122.53037", "America/Los_Angeles"),("5730675", "Hayesville", "", "US", "840", "", "OR", "047", "", "44.98595", "-122.98287", "America/Los_Angeles"),("5731070", "Hermiston", "", "US", "840", "", "OR", "059", "", "45.84041", "-119.28946", "America/Los_Angeles"),("5731371", "Hillsboro", "Хиллсборо", "US", "840", "", "OR", "067", "", "45.52289", "-122.98983", "America/Los_Angeles"),("5731777", "Hood River", "", "US", "840", "", "OR", "027", "", "45.7054", "-121.52146", "America/Los_Angeles"),("5732763", "Independence", "", "US", "840", "", "OR", "053", "", "44.85123", "-123.18677", "America/Los_Angeles"),("5733582", "Jennings Lodge", "", "US", "840", "", "OR", "005", "", "45.39123", "-122.61259", "America/Los_Angeles"),("5734198", "Junction City", "", "US", "840", "", "OR", "039", "", "44.21929", "-123.20565", "America/Los_Angeles"),("5734711", "Keizer", "Кейзер", "US", "840", "", "OR", "047", "", "44.99012", "-123.02621", "America/Los_Angeles"),("5735238", "Klamath Falls", "Кламат Фолс", "US", "840", "", "OR", "035", "", "42.22487", "-121.78167", "America/Los_Angeles"),("5735537", "La Grande", "", "US", "840", "", "OR", "061", "", "45.32458", "-118.08772", "America/Los_Angeles"),("5735724", "Lake Oswego", "", "US", "840", "", "OR", "005", "", "45.42067", "-122.67065", "America/Los_Angeles"),("5736218", "Lebanon", "", "US", "840", "", "OR", "043", "", "44.53651", "-122.90703", "America/Los_Angeles"),("5736378", "Lents", "", "US", "840", "", "OR", "051", "", "45.47984", "-122.56731", "America/Los_Angeles"),("5736645", "Lincoln City", "", "US", "840", "", "OR", "041", "", "44.95816", "-124.01789", "America/Los_Angeles"),("5738690", "Madras", "", "US", "840", "", "OR", "031", "", "44.63345", "-121.12949", "America/Los_Angeles"),("5739936", "McMinnville", "", "US", "840", "", "OR", "071", "", "45.21012", "-123.19872", "America/Los_Angeles"),("5740099", "Medford", "Медфорд", "US", "840", "", "OR", "029", "", "42.32652", "-122.87559", "America/Los_Angeles"),("5740898", "Milton-Freewater", "", "US", "840", "", "OR", "059", "", "45.93263", "-118.38774", "America/Los_Angeles"),("5740900", "Milwaukie", "Милуоки", "US", "840", "", "OR", "005", "", "45.44623", "-122.63926", "America/Los_Angeles"),("5741182", "Molalla", "", "US", "840", "", "OR", "005", "", "45.14734", "-122.57703", "America/Los_Angeles"),("5741227", "Monmouth", "", "US", "840", "", "OR", "053", "", "44.84845", "-123.23399", "America/Los_Angeles"),("5742726", "Newberg", "Ньюберг", "US", "840", "", "OR", "071", "", "45.30012", "-122.97316", "America/Los_Angeles"),("5742750", "Newport", "", "US", "840", "", "OR", "041", "", "44.63678", "-124.05345", "America/Los_Angeles"),("5742974", "North Bend", "", "US", "840", "", "OR", "011", "", "43.4065", "-124.22428", "America/Los_Angeles"),("5743731", "Oak Grove", "", "US", "840", "", "OR", "005", "", "45.41679", "-122.64009", "America/Los_Angeles"),("5743753", "Oak Hills", "", "US", "840", "", "OR", "067", "", "45.54123", "-122.84121", "America/Los_Angeles"),("5744166", "Ontario", "", "US", "840", "", "OR", "045", "", "44.02655", "-116.96294", "America/Boise"),("5744253", "Oregon City", "", "US", "840", "", "OR", "005", "", "45.35734", "-122.60676", "America/Los_Angeles"),("5745380", "Pendleton", "", "US", "840", "", "OR", "059", "", "45.67207", "-118.7886", "America/Los_Angeles"),("5746545", "Portland", "Портленд", "US", "840", "", "OR", "051", "", "45.52345", "-122.67621", "America/Los_Angeles"),("5746901", "Prineville", "", "US", "840", "", "OR", "013", "", "44.29985", "-120.83447", "America/Los_Angeles"),("5747420", "Raleigh Hills", "", "US", "840", "", "OR", "067", "", "45.48067", "-122.76204", "America/Los_Angeles"),("5747882", "Redmond", "Редмонд", "US", "840", "", "OR", "017", "", "44.27262", "-121.17392", "America/Los_Angeles"),("5749017", "Rockcreek", "", "US", "840", "", "OR", "067", "", "45.55012", "-122.87705", "America/Los_Angeles"),("5749352", "Roseburg", "", "US", "840", "", "OR", "019", "", "43.2165", "-123.34174", "America/Los_Angeles"),("5750041", "Saint Helens", "", "US", "840", "", "OR", "009", "", "45.864", "-122.80649", "America/Los_Angeles"),("5750162", "Salem", "Сейлем", "US", "840", "", "OR", "047", "", "44.9429", "-123.0351", "America/Los_Angeles"),("5750477", "Sandy", "", "US", "840", "", "OR", "005", "", "45.39734", "-122.26148", "America/Los_Angeles"),("5750663", "Scappoose", "", "US", "840", "", "OR", "009", "", "45.75428", "-122.8776", "America/Los_Angeles"),("5750984", "Seaside", "", "US", "840", "", "OR", "007", "", "45.99316", "-123.92264", "America/Los_Angeles");
EOL
);
        $this->addSql(<<<EOL
INSERT INTO `all_cities` (`id`, `name`, `name_ru`, `country`, `country_id`, `admin1_code`, `admin2_code`, `admin3_code`, `admin4_code`, `lat`, `lon`, `timezone`) VALUES ("5751600", "Sheridan", "", "US", "840", "", "OR", "071", "", "45.09928", "-123.39483", "America/Los_Angeles"),("5751632", "Sherwood", "", "US", "840", "", "OR", "067", "", "45.35651", "-122.8401", "America/Los_Angeles"),("5752024", "Silverton", "", "US", "840", "", "OR", "047", "", "45.00512", "-122.78315", "America/Los_Angeles"),("5754005", "Springfield", "Спрингфилд", "US", "840", "", "OR", "039", "", "44.04624", "-123.02203", "America/Los_Angeles"),("5754464", "Stayton", "", "US", "840", "", "OR", "047", "", "44.80068", "-122.79453", "America/Los_Angeles"),("5755474", "Sutherlin", "", "US", "840", "", "OR", "019", "", "43.39012", "-123.31258", "America/Los_Angeles"),("5755674", "Sweet Home", "", "US", "840", "", "OR", "043", "", "44.39762", "-122.7362", "America/Los_Angeles"),("5755890", "Talent", "", "US", "840", "", "OR", "029", "", "42.24568", "-122.78865", "America/Los_Angeles"),("5756304", "The Dalles", "", "US", "840", "", "OR", "065", "", "45.59456", "-121.17868", "America/Los_Angeles"),("5756758", "Tigard", "", "US", "840", "", "OR", "067", "", "45.43123", "-122.77149", "America/Los_Angeles"),("5757477", "Troutdale", "", "US", "840", "", "OR", "051", "", "45.53929", "-122.38731", "America/Los_Angeles"),("5757506", "Tualatin", "", "US", "840", "", "OR", "067", "", "45.38401", "-122.76399", "America/Los_Angeles"),("5758052", "Umatilla", "", "US", "840", "", "OR", "059", "", "45.91735", "-119.34252", "America/Los_Angeles"),("5759289", "Warrenton", "", "US", "840", "", "OR", "007", "", "46.1651", "-123.92376", "America/Los_Angeles"),("5759989", "West Haven", "", "US", "840", "", "OR", "067", "", "45.51762", "-122.76954", "America/Los_Angeles"),("5760009", "West Linn", "", "US", "840", "", "OR", "005", "", "45.36568", "-122.61231", "America/Los_Angeles"),("5760068", "West Slope", "", "US", "840", "", "OR", "067", "", "45.49873", "-122.76454", "America/Los_Angeles"),("5760396", "White City", "", "US", "840", "", "OR", "029", "", "42.43735", "-122.85893", "America/Los_Angeles"),("5761287", "Wilsonville", "", "US", "840", "", "OR", "005", "", "45.29984", "-122.77371", "America/Los_Angeles"),("5761481", "Winston", "", "US", "840", "", "OR", "019", "", "43.12234", "-123.41257", "America/Los_Angeles"),("5761708", "Woodburn", "Вудберн", "US", "840", "", "OR", "047", "", "45.14373", "-122.85537", "America/Los_Angeles"),("5762718", "Belle Fourche", "", "US", "840", "", "SD", "019", "", "44.67137", "-103.85215", "America/Denver"),("5763011", "Box Elder", "", "US", "840", "", "SD", "103", "", "44.11249", "-103.06823", "America/Denver"),("5767918", "Pierre", "", "US", "840", "", "SD", "065", "", "44.36832", "-100.35097", "America/Chicago"),("5768233", "Rapid City", "Рапид-Сити", "US", "840", "", "SD", "103", "", "44.08054", "-103.23101", "America/Denver"),("5768244", "Rapid Valley", "", "US", "840", "", "SD", "103", "", "44.06249", "-103.14629", "America/Denver"),("5769288", "Spearfish", "", "US", "840", "", "SD", "081", "", "44.49082", "-103.85937", "America/Denver"),("5769489", "Sturgis", "", "US", "840", "", "SD", "093", "", "44.40971", "-103.50908", "America/Denver"),("5770732", "Alpine", "", "US", "840", "", "UT", "049", "", "40.45328", "-111.77799", "America/Denver"),("5771716", "Bluffdale", "", "US", "840", "", "UT", "035", "", "40.48967", "-111.93882", "America/Denver"),("5771826", "Bountiful", "", "US", "840", "", "UT", "011", "", "40.88939", "-111.88077", "America/Denver"),("5771960", "Brigham City", "", "US", "840", "", "UT", "003", "", "41.51021", "-112.0155", "America/Denver"),("5772418", "Canyon Rim", "", "US", "840", "", "UT", "035", "", "40.70661", "-111.82188", "America/Denver"),("5772581", "Cedar Hills", "", "US", "840", "", "UT", "049", "", "40.41412", "-111.75854", "America/Denver"),("5772654", "Centerville", "", "US", "840", "", "UT", "011", "", "40.918", "-111.87216", "America/Denver"),("5772959", "Clearfield", "", "US", "840", "", "UT", "011", "", "41.11078", "-112.02605", "America/Denver"),("5773001", "Clinton", "Клинтон", "US", "840", "", "UT", "011", "", "41.13967", "-112.0505", "America/Denver"),("5773304", "Cottonwood Heights", "", "US", "840", "", "UT", "035", "", "40.61967", "-111.81021", "America/Denver"),("5774001", "Draper", "", "US", "840", "", "UT", "035", "", "40.52467", "-111.86382", "America/Denver"),("5774215", "Eagle Mountain", "", "US", "840", "", "UT", "049", "", "40.31412", "-112.00688", "America/Denver"),("5774301", "East Millcreek", "", "US", "840", "", "UT", "035", "", "40.69995", "-111.81049", "America/Denver"),("5774662", "Farmington", "Фармингтон", "US", "840", "", "UT", "011", "", "40.9805", "-111.88744", "America/Denver"),("5774685", "Farr West", "", "US", "840", "", "UT", "057", "", "41.29717", "-112.02772", "America/Denver"),("5775035", "Fruit Heights", "", "US", "840", "", "UT", "011", "", "41.03217", "-111.90216", "America/Denver"),("5775346", "Grantsville", "", "US", "840", "", "UT", "045", "", "40.59994", "-112.4644", "America/Denver"),("5775615", "Harrisville", "", "US", "840", "", "UT", "057", "", "41.28133", "-111.98828", "America/Denver"),("5775699", "Heber City", "", "US", "840", "", "UT", "051", "", "40.5069", "-111.41324", "America/Denver"),("5775782", "Herriman", "", "US", "840", "", "UT", "035", "", "40.51411", "-112.03299", "America/Denver"),("5775863", "Highland", "", "US", "840", "", "UT", "049", "", "40.42548", "-111.79447", "America/Denver"),("5776008", "Holladay", "", "US", "840", "", "UT", "035", "", "40.66884", "-111.82466", "America/Denver"),("5776092", "Hooper", "", "US", "840", "", "UT", "057", "", "41.16383", "-112.12244", "America/Denver"),("5776228", "Hyrum", "", "US", "840", "", "UT", "005", "", "41.6341", "-111.85217", "America/Denver"),("5776715", "Kaysville", "", "US", "840", "", "UT", "011", "", "41.03522", "-111.93855", "America/Denver"),("5776727", "Kearns", "Кернс", "US", "840", "", "UT", "035", "", "40.65995", "-111.99633", "America/Denver"),("5777107", "Layton", "Лейтон", "US", "840", "", "UT", "011", "", "41.06022", "-111.97105", "America/Denver"),("5777224", "Lehi", "Лехе", "US", "840", "", "UT", "049", "", "40.39162", "-111.85077", "America/Denver"),("5777332", "Lindon", "", "US", "840", "", "UT", "049", "", "40.34329", "-111.72076", "America/Denver"),("5777544", "Logan", "", "US", "840", "", "UT", "005", "", "41.73549", "-111.83439", "America/Denver"),("5777793", "Magna", "", "US", "840", "", "UT", "035", "", "40.70911", "-112.10161", "America/Denver"),("5777915", "Mapleton", "", "US", "840", "", "UT", "049", "", "40.13023", "-111.57853", "America/Denver"),("5778244", "Midvale", "", "US", "840", "", "UT", "035", "", "40.61106", "-111.89994", "America/Denver"),("5778352", "Millcreek", "", "US", "840", "", "UT", "035", "", "40.68689", "-111.87549", "America/Denver"),("5778601", "Mount Olympus", "", "US", "840", "", "UT", "035", "", "40.6855", "-111.78854", "America/Denver"),("5778755", "Murray", "Мюррей", "US", "840", "", "UT", "035", "", "40.66689", "-111.88799", "America/Denver"),("5778898", "Nibley", "", "US", "840", "", "UT", "005", "", "41.67438", "-111.833", "America/Denver"),("5779025", "North Logan", "", "US", "840", "", "UT", "005", "", "41.76937", "-111.80467", "America/Denver"),("5779036", "North Ogden", "", "US", "840", "", "UT", "057", "", "41.30716", "-111.96022", "America/Denver"),("5779068", "North Salt Lake", "", "US", "840", "", "UT", "011", "", "40.84856", "-111.90688", "America/Denver"),("5779206", "Ogden", "Огден", "US", "840", "", "UT", "057", "", "41.223", "-111.97383", "America/Denver"),("5779333", "Oquirrh", "", "US", "840", "", "UT", "035", "", "40.6305", "-112.03383", "America/Denver"),("5779334", "Orem", "Орем", "US", "840", "", "UT", "049", "", "40.2969", "-111.69465", "America/Denver"),("5779451", "Park City", "", "US", "840", "", "UT", "043", "", "40.64606", "-111.49797", "America/Denver"),("5779548", "Payson", "", "US", "840", "", "UT", "049", "", "40.0444", "-111.73215", "America/Denver"),("5779798", "Plain City", "", "US", "840", "", "UT", "057", "", "41.298", "-112.08605", "America/Denver"),("5779816", "Pleasant Grove", "", "US", "840", "", "UT", "049", "", "40.36412", "-111.73854", "America/Denver"),("5779833", "Pleasant View", "", "US", "840", "", "UT", "057", "", "41.31828", "-111.99216", "America/Denver"),("5780020", "Providence", "", "US", "840", "", "UT", "005", "", "41.70632", "-111.81717", "America/Denver"),("5780026", "Provo", "Прово", "US", "840", "", "UT", "049", "", "40.23384", "-111.65853", "America/Denver"),("5780531", "Riverdale", "", "US", "840", "", "UT", "057", "", "41.17689", "-112.00383", "America/Denver"),("5780557", "Riverton", "Ривертон", "US", "840", "", "UT", "035", "", "40.52189", "-111.9391", "America/Denver"),("5780699", "Roosevelt", "", "US", "840", "", "UT", "013", "", "40.2994", "-109.98876", "America/Denver"),("5780802", "Roy", "Рой", "US", "840", "", "UT", "057", "", "41.16161", "-112.02633", "America/Denver"),("5780993", "Salt Lake City", "Солт-Лейк-Сити", "US", "840", "", "UT", "035", "", "40.76078", "-111.89105", "America/Denver"),("5781061", "Sandy", "", "US", "840", "", "UT", "035", "", "40.59161", "-111.8841", "America/Denver"),("5781070", "Sandy Hills", "", "US", "840", "", "UT", "035", "", "40.58106", "-111.85077", "America/Denver"),("5781087", "Saratoga Springs", "Саратога-Спрингс", "US", "840", "", "UT", "049", "", "40.34912", "-111.90466", "America/Denver"),("5781551", "Smithfield", "", "US", "840", "", "UT", "005", "", "41.83826", "-111.83272", "America/Denver"),("5781609", "Snyderville", "", "US", "840", "", "UT", "043", "", "40.69439", "-111.54381", "America/Denver"),("5781765", "South Jordan Heights", "", "US", "840", "", "UT", "035", "", "40.56384", "-111.94938", "America/Denver"),("5781770", "South Jordan", "Саут-Джордан", "US", "840", "", "UT", "035", "", "40.56217", "-111.92966", "America/Denver"),("5781783", "South Ogden", "", "US", "840", "", "UT", "057", "", "41.19189", "-111.97133", "America/Denver"),("5781794", "South Salt Lake", "", "US", "840", "", "UT", "035", "", "40.71884", "-111.88827", "America/Denver"),("5781809", "South Weber", "", "US", "840", "", "UT", "011", "", "41.13244", "-111.93022", "America/Denver"),("5781860", "Spanish Fork", "", "US", "840", "", "UT", "049", "", "40.11496", "-111.65492", "America/Denver"),("5781993", "Springville", "", "US", "840", "", "UT", "049", "", "40.16523", "-111.61075", "America/Denver"),("5782055", "Stansbury park", "", "US", "840", "", "UT", "045", "", "40.63772", "-112.29606", "America/Denver"),("5782272", "Summit Park", "", "US", "840", "", "UT", "043", "", "40.74578", "-111.61159", "America/Denver"),("5782320", "Sunset", "", "US", "840", "", "UT", "011", "", "41.13633", "-112.03105", "America/Denver"),("5782391", "Syracuse", "", "US", "840", "", "UT", "011", "", "41.08939", "-112.06467", "America/Denver"),("5782476", "Taylorsville", "Тейлорсвилл", "US", "840", "", "UT", "035", "", "40.66772", "-111.93883", "America/Denver"),("5783695", "Tooele", "", "US", "840", "", "UT", "045", "", "40.53078", "-112.29828", "America/Denver"),("5783768", "Tremonton", "", "US", "840", "", "UT", "003", "", "41.71187", "-112.16551", "America/Denver"),("5784154", "Vernal", "", "US", "840", "", "UT", "047", "", "40.45552", "-109.52875", "America/Denver"),("5784384", "Washington Terrace", "", "US", "840", "", "UT", "057", "", "41.17272", "-111.97661", "America/Denver"),("5784504", "West Bountiful", "", "US", "840", "", "UT", "011", "", "40.89383", "-111.90188", "America/Denver"),("5784540", "West Haven", "", "US", "840", "", "UT", "057", "", "41.203", "-112.05105", "America/Denver"),("5784549", "West Jordan", "Уэст-Джордан", "US", "840", "", "UT", "035", "", "40.60967", "-111.9391", "America/Denver"),("5784580", "West Point", "", "US", "840", "", "UT", "011", "", "41.11828", "-112.08411", "America/Denver"),("5784607", "West Valley City", "Вест-Вэлли-Сити", "US", "840", "", "UT", "035", "", "40.69161", "-112.00105", "America/Denver"),("5784731", "White City", "", "US", "840", "", "UT", "035", "", "40.56578", "-111.86438", "America/Denver"),("5785116", "Woods Cross", "", "US", "840", "", "UT", "011", "", "40.87161", "-111.89216", "America/Denver"),("5785243", "Aberdeen", "Абердин", "US", "840", "", "WA", "027", "", "46.97537", "-123.81572", "America/Los_Angeles"),("5785378", "Airway Heights", "", "US", "840", "", "WA", "063", "", "47.64461", "-117.59327", "America/Los_Angeles"),("5785453", "Alderwood Manor", "", "US", "840", "", "WA", "061", "", "47.82204", "-122.28207", "America/Los_Angeles"),("5785657", "Anacortes", "", "US", "840", "", "WA", "057", "", "48.5126", "-122.61267", "America/Los_Angeles"),("5785868", "Arlington", "Арлингтон", "US", "840", "", "WA", "061", "", "48.19871", "-122.12514", "America/Los_Angeles"),("5785909", "Artondale", "", "US", "840", "", "WA", "053", "", "47.29954", "-122.62069", "America/Los_Angeles"),("5785965", "Auburn", "", "US", "840", "", "WA", "033", "", "47.30732", "-122.22845", "America/Los_Angeles"),("5786322", "Barberton", "", "US", "840", "", "WA", "011", "", "45.69317", "-122.59899", "America/Los_Angeles"),("5786485", "Battle Ground", "", "US", "840", "", "WA", "011", "", "45.78095", "-122.53343", "America/Los_Angeles"),("5786882", "Bellevue", "Белвью", "US", "840", "", "WA", "033", "", "47.61038", "-122.20068", "America/Los_Angeles"),("5786899", "Bellingham", "Беллингхем", "US", "840", "", "WA", "073", "", "48.75955", "-122.48822", "America/Los_Angeles"),("5787316", "Birch Bay", "", "US", "840", "", "WA", "073", "", "48.91789", "-122.74462", "America/Los_Angeles"),("5787475", "Blaine", "", "US", "840", "", "WA", "073", "", "48.99372", "-122.74712", "America/Los_Angeles"),("5787776", "Bonney Lake", "", "US", "840", "", "WA", "053", "", "47.17705", "-122.18651", "America/Los_Angeles"),("5787829", "Bothell", "", "US", "840", "", "WA", "033", "", "47.76232", "-122.2054", "America/Los_Angeles"),("5787893", "Boulevard Park", "", "US", "840", "", "WA", "033", "", "47.48927", "-122.31512", "America/Los_Angeles"),("5788054", "Bremerton", "Бремертон", "US", "840", "", "WA", "035", "", "47.56732", "-122.63264", "America/Los_Angeles"),("5788125", "Brier", "", "US", "840", "", "WA", "061", "", "47.78454", "-122.27429", "America/Los_Angeles"),("5788516", "Burien", "", "US", "840", "", "WA", "033", "", "47.47038", "-122.34679", "America/Los_Angeles"),("5788539", "Burlington", "", "US", "840", "", "WA", "057", "", "48.47566", "-122.32544", "America/Los_Angeles"),("5788816", "Camano", "", "US", "840", "", "WA", "029", "", "48.17399", "-122.52821", "America/Los_Angeles"),("5788822", "Camas", "", "US", "840", "", "WA", "011", "", "45.58706", "-122.39954", "America/Los_Angeles"),("5789683", "Centralia", "", "US", "840", "", "WA", "041", "", "46.71621", "-122.9543", "America/Los_Angeles"),("5789817", "Chehalis", "", "US", "840", "", "WA", "041", "", "46.66205", "-122.96402", "America/Los_Angeles"),("5789856", "Cheney", "", "US", "840", "", "WA", "063", "", "47.48739", "-117.57576", "America/Los_Angeles"),("5790218", "Clarkston", "", "US", "840", "", "WA", "003", "", "46.41627", "-117.04516", "America/Los_Angeles"),("5790562", "College Place", "", "US", "840", "", "WA", "071", "", "46.0493", "-118.3883", "America/Los_Angeles"),("5790756", "Connell", "", "US", "840", "", "WA", "021", "", "46.66347", "-118.86111", "America/Los_Angeles"),("5790971", "Cottage Lake", "", "US", "840", "", "WA", "033", "", "47.74427", "-122.07735", "America/Los_Angeles"),("5791127", "Country Homes", "", "US", "840", "", "WA", "063", "", "47.7485", "-117.40439", "America/Los_Angeles"),("5791159", "Covington", "", "US", "840", "", "WA", "033", "", "47.35818", "-122.12216", "America/Los_Angeles"),("5792244", "Des Moines", "Де-Мойн", "US", "840", "", "WA", "033", "", "47.40177", "-122.32429", "America/Los_Angeles"),("5792474", "Dishman", "", "US", "840", "", "WA", "063", "", "47.66007", "-117.27596", "America/Los_Angeles"),("5792869", "DuPont", "", "US", "840", "", "WA", "053", "", "47.09676", "-122.63124", "America/Los_Angeles"),("5792990", "Duvall", "", "US", "840", "", "WA", "033", "", "47.74232", "-121.98568", "America/Los_Angeles"),("5793237", "East Port Orchard", "", "US", "840", "", "WA", "035", "", "47.52343", "-122.6243", "America/Los_Angeles"),("5793242", "East Renton Highlands", "", "US", "840", "", "WA", "033", "", "47.48482", "-122.11234", "America/Los_Angeles"),("5793271", "East Wenatchee", "", "US", "840", "", "WA", "017", "", "47.41568", "-120.29313", "America/Los_Angeles"),("5793272", "East Wenatchee Bench", "", "US", "840", "", "WA", "017", "", "47.42568", "-120.28118", "America/Los_Angeles"),("5793406", "Edgewood", "", "US", "840", "", "WA", "053", "", "47.2501", "-122.29373", "America/Los_Angeles"),("5793427", "Edmonds", "Эдмондс", "US", "840", "", "WA", "061", "", "47.81065", "-122.37736", "America/Los_Angeles"),("5793609", "Elk Plain", "", "US", "840", "", "WA", "053", "", "47.05316", "-122.39762", "America/Los_Angeles"),("5793639", "Ellensburg", "", "US", "840", "", "WA", "037", "", "46.99651", "-120.54785", "America/Los_Angeles"),("5793822", "Enumclaw", "", "US", "840", "", "WA", "033", "", "47.20427", "-121.9915", "America/Los_Angeles"),("5793832", "Ephrata", "", "US", "840", "", "WA", "025", "", "47.31764", "-119.55365", "America/Los_Angeles"),("5793933", "Everett", "Эверетт", "US", "840", "", "WA", "061", "", "47.97898", "-122.20208", "America/Los_Angeles"),("5794097", "Fairwood", "", "US", "840", "", "WA", "033", "", "47.44843", "-122.15734", "America/Los_Angeles"),("5794098", "Fairwood", "", "US", "840", "", "WA", "063", "", "47.76684", "-117.41744", "America/Los_Angeles"),("5794242", "Felida", "", "US", "840", "", "WA", "011", "", "45.70956", "-122.70732", "America/Los_Angeles"),("5794245", "Federal Way", "", "US", "840", "", "WA", "033", "", "47.32232", "-122.31262", "America/Los_Angeles"),("5794276", "Ferndale", "", "US", "840", "", "WA", "073", "", "48.8465", "-122.59101", "America/Los_Angeles"),("5794328", "Fife", "", "US", "840", "", "WA", "053", "", "47.23927", "-122.35707", "America/Los_Angeles"),("5794369", "Finley", "", "US", "840", "", "WA", "005", "", "46.15402", "-119.0339", "America/Los_Angeles"),("5794416", "Fircrest", "", "US", "840", "", "WA", "053", "", "47.23954", "-122.51596", "America/Los_Angeles"),("5794559", "Five Corners", "", "US", "840", "", "WA", "011", "", "45.68456", "-122.5751", "America/Los_Angeles"),("5795011", "Frederickson", "", "US", "840", "", "WA", "053", "", "47.09621", "-122.35873", "America/Los_Angeles"),("5795440", "Gig Harbor", "", "US", "840", "", "WA", "053", "", "47.32926", "-122.58013", "America/Los_Angeles"),("5795906", "Graham", "", "US", "840", "", "WA", "053", "", "47.05288", "-122.29428", "America/Los_Angeles"),("5795969", "Grandview", "", "US", "840", "", "WA", "077", "", "46.25097", "-119.9017", "America/Los_Angeles"),("5796984", "Hazel Dell", "", "US", "840", "", "WA", "011", "", "45.67151", "-122.66288", "America/Los_Angeles"),("5797430", "Hobart", "", "US", "840", "", "WA", "033", "", "47.42177", "-121.97289", "America/Los_Angeles"),("5797693", "Hoquiam", "", "US", "840", "", "WA", "027", "", "46.98092", "-123.88933", "America/Los_Angeles"),("5798487", "Issaquah", "", "US", "840", "", "WA", "033", "", "47.5301", "-122.03262", "America/Los_Angeles"),("5799571", "Kelso", "", "US", "840", "", "WA", "015", "", "46.14678", "-122.90844", "America/Los_Angeles"),("5799587", "Kenmore", "", "US", "840", "", "WA", "033", "", "47.75732", "-122.24401", "America/Los_Angeles"),("5799610", "Kennewick", "Кенневик", "US", "840", "", "WA", "005", "", "46.21125", "-119.13723", "America/Los_Angeles"),("5799625", "Kent", "Кент", "US", "840", "", "WA", "033", "", "47.38093", "-122.23484", "America/Los_Angeles"),("5799819", "Kingsgate", "", "US", "840", "", "WA", "033", "", "47.72704", "-122.17957", "America/Los_Angeles"),("5799841", "Kirkland", "", "US", "840", "", "WA", "033", "", "47.68149", "-122.20874", "America/Los_Angeles"),("5799884", "Klahanie", "", "US", "840", "", "WA", "033", "", "47.43121", "-122.43652", "America/Los_Angeles"),("5800112", "Lacey", "Лейси", "US", "840", "", "WA", "067", "", "47.03426", "-122.82319", "America/Los_Angeles"),("5800227", "Lake Forest Park", "", "US", "840", "", "WA", "033", "", "47.75676", "-122.28096", "America/Los_Angeles"),("5800314", "Lake Shore", "", "US", "840", "", "WA", "011", "", "45.69067", "-122.69093", "America/Los_Angeles"),("5800317", "Lake Stevens", "", "US", "840", "", "WA", "061", "", "48.0151", "-122.06374", "America/Los_Angeles"),("5800420", "Lakewood", "Лейквуд", "US", "840", "", "WA", "053", "", "47.17176", "-122.51846", "America/Los_Angeles"),("5800870", "Liberty Lake", "", "US", "840", "", "WA", "063", "", "47.67591", "-117.11821", "America/Los_Angeles"),("5801617", "Longview", "", "US", "840", "", "WA", "015", "", "46.13817", "-122.93817", "America/Los_Angeles"),("5802035", "Lynden", "", "US", "840", "", "WA", "073", "", "48.9465", "-122.45211", "America/Los_Angeles"),("5802049", "Lynnwood", "Линвуд", "US", "840", "", "WA", "061", "", "47.82093", "-122.31513", "America/Los_Angeles"),("5802236", "Maltby", "", "US", "840", "", "WA", "061", "", "47.8051", "-122.11318", "America/Los_Angeles"),("5802247", "Manchester", "", "US", "840", "", "WA", "035", "", "47.55593", "-122.54486", "America/Los_Angeles"),("5802340", "Maple Valley", "", "US", "840", "", "WA", "033", "", "47.39272", "-122.04641", "America/Los_Angeles"),("5802349", "Maplewood", "", "US", "840", "", "WA", "053", "", "47.40176", "-122.55707", "America/Los_Angeles"),("5802493", "Martha Lake", "", "US", "840", "", "WA", "061", "", "47.85093", "-122.2393", "America/Los_Angeles"),("5802570", "Marysville", "", "US", "840", "", "WA", "061", "", "48.05176", "-122.17708", "America/Los_Angeles"),("5802984", "Mead", "", "US", "840", "", "WA", "063", "", "47.76739", "-117.35494", "America/Los_Angeles"),("5803139", "Mercer Island", "", "US", "840", "", "WA", "033", "", "47.57065", "-122.22207", "America/Los_Angeles"),("5803357", "Midland", "", "US", "840", "", "WA", "053", "", "47.16704", "-122.40484", "America/Los_Angeles"),("5803457", "Mill Creek", "", "US", "840", "", "WA", "061", "", "47.8601", "-122.2043", "America/Los_Angeles"),("5803482", "Mill Plain", "", "US", "840", "", "WA", "011", "", "45.6429", "-122.49398", "America/Los_Angeles"),("5803556", "Milton", "", "US", "840", "", "WA", "053", "", "47.24816", "-122.3129", "America/Los_Angeles"),("5803622", "Minnehaha", "", "US", "840", "", "WA", "011", "", "45.65901", "-122.64871", "America/Los_Angeles"),("5803786", "Monroe", "Монро", "US", "840", "", "WA", "061", "", "47.85538", "-121.97096", "America/Los_Angeles"),("5803990", "Moses Lake", "", "US", "840", "", "WA", "025", "", "47.13014", "-119.27808", "America/Los_Angeles"),("5804127", "Mount Vernon", "Маунт-Вернон", "US", "840", "", "WA", "057", "", "48.42122", "-122.33405", "America/Los_Angeles"),("5804135", "Mount Vista", "", "US", "840", "", "WA", "011", "", "45.73428", "-122.63288", "America/Los_Angeles"),("5804191", "Mountlake Terrace", "", "US", "840", "", "WA", "061", "", "47.78815", "-122.30874", "America/Los_Angeles"),("5804306", "Mukilteo", "", "US", "840", "", "WA", "061", "", "47.94454", "-122.30458", "America/Los_Angeles"),("5804676", "Newcastle", "", "US", "840", "", "WA", "033", "", "47.53899", "-122.15568", "America/Los_Angeles"),("5804885", "Normandy Park", "", "US", "840", "", "WA", "033", "", "47.43621", "-122.34068", "America/Los_Angeles"),("5804915", "North Bend", "", "US", "840", "", "WA", "033", "", "47.49566", "-121.78678", "America/Los_Angeles"),("5804953", "North Creek", "", "US", "840", "", "WA", "061", "", "47.81954", "-122.17624", "America/Los_Angeles"),("5805441", "Oak Harbor", "", "US", "840", "", "WA", "029", "", "48.29316", "-122.64322", "America/Los_Angeles"),("5805505", "Ocean Shores", "", "US", "840", "", "WA", "027", "", "46.9737", "-124.15629", "America/Los_Angeles"),("5805687", "Olympia", "Олимпия", "US", "840", "", "WA", "067", "", "47.03787", "-122.9007", "America/Los_Angeles"),("5805782", "Opportunity", "", "US", "840", "", "WA", "063", "", "47.64995", "-117.23991", "America/Los_Angeles"),("5805815", "Orchards", "", "US", "840", "", "WA", "011", "", "45.66651", "-122.56093", "America/Los_Angeles"),("5805849", "Orting", "", "US", "840", "", "WA", "053", "", "47.09788", "-122.20428", "America/Los_Angeles"),("5805879", "Othello", "", "US", "840", "", "WA", "001", "", "46.82597", "-119.17529", "America/Los_Angeles"),("5806017", "Pacific", "", "US", "840", "", "WA", "033", "", "47.26455", "-122.25012", "America/Los_Angeles"),("5806253", "Parkland", "", "US", "840", "", "WA", "053", "", "47.15538", "-122.43401", "America/Los_Angeles"),("5806274", "Parkwood", "", "US", "840", "", "WA", "035", "", "47.53315", "-122.61014", "America/Los_Angeles"),("5806298", "Pasco", "Паско", "US", "840", "", "WA", "021", "", "46.23958", "-119.10057", "America/Los_Angeles"),("5807212", "Port Angeles", "", "US", "840", "", "WA", "009", "", "48.11815", "-123.43074", "America/Los_Angeles"),("5807236", "Port Orchard", "", "US", "840", "", "WA", "035", "", "47.54037", "-122.63625", "America/Los_Angeles"),("5807239", "Port Townsend", "", "US", "840", "", "WA", "031", "", "48.11704", "-122.76045", "America/Los_Angeles"),("5807337", "Poulsbo", "", "US", "840", "", "WA", "035", "", "47.73593", "-122.64654", "America/Los_Angeles"),("5807367", "Prairie Ridge", "", "US", "840", "", "WA", "053", "", "47.1376", "-122.14873", "America/Los_Angeles"),("5807487", "Prosser", "", "US", "840", "", "WA", "005", "", "46.2068", "-119.76892", "America/Los_Angeles"),("5807540", "Pullman", "", "US", "840", "", "WA", "075", "", "46.73127", "-117.17962", "America/Los_Angeles"),("5807575", "Puyallup", "", "US", "840", "", "WA", "053", "", "47.18538", "-122.2929", "America/Los_Angeles"),("5807713", "Quincy", "", "US", "840", "", "WA", "025", "", "47.2343", "-119.85255", "America/Los_Angeles"),("5808079", "Redmond", "Редмонд", "US", "840", "", "WA", "033", "", "47.67399", "-122.12151", "America/Los_Angeles"),("5808189", "Renton", "Рентон", "US", "840", "", "WA", "033", "", "47.48288", "-122.21707", "America/Los_Angeles"),("5808276", "Richland", "Ричленд", "US", "840", "", "WA", "005", "", "46.28569", "-119.28446", "America/Los_Angeles"),("5808311", "Ridgefield", "", "US", "840", "", "WA", "011", "", "45.81511", "-122.7426", "America/Los_Angeles"),("5808432", "Riverton", "", "US", "840", "", "WA", "033", "", "47.48427", "-122.29457", "America/Los_Angeles"),("5809333", "Salmon Creek", "", "US", "840", "", "WA", "011", "", "45.71067", "-122.64899", "America/Los_Angeles"),("5809402", "Sammamish", "", "US", "840", "", "WA", "033", "", "47.64177", "-122.0804", "America/Los_Angeles"),("5809805", "SeaTac", "", "US", "840", "", "WA", "033", "", "47.44846", "-122.29217", "America/Los_Angeles"),("5809844", "Seattle", "Сиэтл", "US", "840", "", "WA", "033", "", "47.60621", "-122.33207", "America/Los_Angeles"),("5809902", "Sedro-Woolley", "", "US", "840", "", "WA", "057", "", "48.50389", "-122.23611", "America/Los_Angeles"),("5809928", "Selah", "", "US", "840", "", "WA", "077", "", "46.65402", "-120.53007", "America/Los_Angeles"),("5809983", "Sequim", "", "US", "840", "", "WA", "009", "", "48.07954", "-123.10184", "America/Los_Angeles"),("5810176", "Shelton", "", "US", "840", "", "WA", "045", "", "47.21509", "-123.10071", "America/Los_Angeles"),("5810301", "Shoreline", "", "US", "840", "", "WA", "033", "", "47.75565", "-122.34152", "America/Los_Angeles"),("5810490", "Silverdale", "", "US", "840", "", "WA", "035", "", "47.64454", "-122.69487", "America/Los_Angeles"),("5810988", "Snohomish", "", "US", "840", "", "WA", "061", "", "47.91288", "-122.09818", "America/Los_Angeles"),("5810995", "Snoqualmie", "", "US", "840", "", "WA", "033", "", "47.52871", "-121.82539", "America/Los_Angeles"),("5811456", "South Hill", "", "US", "840", "", "WA", "053", "", "47.14121", "-122.27012", "America/Los_Angeles"),("5811581", "Spanaway", "", "US", "840", "", "WA", "053", "", "47.10399", "-122.43457", "America/Los_Angeles"),("5811696", "Spokane", "Спокан", "US", "840", "", "WA", "063", "", "47.65966", "-117.42908", "America/Los_Angeles"),("5811729", "Spokane Valley", "", "US", "840", "", "WA", "063", "", "47.67323", "-117.23937", "America/Los_Angeles"),("5811995", "Stanwood", "", "US", "840", "", "WA", "061", "", "48.24121", "-122.37071", "America/Los_Angeles"),("5812092", "Steilacoom", "", "US", "840", "", "WA", "053", "", "47.16982", "-122.60263", "America/Los_Angeles"),("5812434", "Sudden Valley", "", "US", "840", "", "WA", "073", "", "48.72289", "-122.34655", "America/Los_Angeles"),("5812505", "Summit", "", "US", "840", "", "WA", "053", "", "47.16177", "-122.35707", "America/Los_Angeles"),("5812543", "Sumner", "", "US", "840", "", "WA", "053", "", "47.20316", "-122.2404", "America/Los_Angeles"),("5812604", "Sunnyside", "", "US", "840", "", "WA", "077", "", "46.32374", "-120.00865", "America/Los_Angeles"),("5812944", "Tacoma", "Такома", "US", "840", "", "WA", "053", "", "47.25288", "-122.44429", "America/Los_Angeles"),("5813249", "Terrace Heights", "", "US", "840", "", "WA", "077", "", "46.60624", "-120.43979", "America/Los_Angeles"),("5813747", "Toppenish", "", "US", "840", "", "WA", "077", "", "46.37735", "-120.30867", "America/Los_Angeles"),("5813832", "Tracyton", "", "US", "840", "", "WA", "035", "", "47.60898", "-122.65514", "America/Los_Angeles"),("5814043", "Tukwila", "", "US", "840", "", "WA", "033", "", "47.47399", "-122.26096", "America/Los_Angeles"),("5814047", "Tulalip", "", "US", "840", "", "WA", "061", "", "48.06843", "-122.29181", "America/Los_Angeles"),("5814095", "Tumwater", "", "US", "840", "", "WA", "067", "", "47.00732", "-122.90931", "America/Los_Angeles"),("5814419", "Union Gap", "", "US", "840", "", "WA", "077", "", "46.55735", "-120.47506", "America/Los_Angeles"),("5814450", "University Place", "", "US", "840", "", "WA", "053", "", "47.23565", "-122.5504", "America/Los_Angeles"),("5814616", "Vancouver", "Ванкувер", "US", "840", "", "WA", "011", "", "45.63873", "-122.66149", "America/Los_Angeles"),("5814647", "Vashon", "", "US", "840", "", "WA", "033", "", "47.44732", "-122.45985", "America/Los_Angeles"),("5814686", "Veradale", "", "US", "840", "", "WA", "063", "", "47.64995", "-117.20738", "America/Los_Angeles"),("5814916", "Walla Walla", "", "US", "840", "", "WA", "071", "", "46.06458", "-118.34302", "America/Los_Angeles"),("5814941", "Waller", "", "US", "840", "", "WA", "053", "", "47.20066", "-122.36929", "America/Los_Angeles"),("5814950", "Walnut Grove", "", "US", "840", "", "WA", "011", "", "45.66789", "-122.59899", "America/Los_Angeles"),("5814992", "Wapato", "", "US", "840", "", "WA", "077", "", "46.44763", "-120.42034", "America/Los_Angeles"),("5815136", "Washougal", "", "US", "840", "", "WA", "011", "", "45.58262", "-122.35342", "America/Los_Angeles"),("5815342", "Wenatchee", "", "US", "840", "", "WA", "007", "", "47.42346", "-120.31035", "America/Los_Angeles"),("5815538", "West Lake Sammamish", "", "US", "840", "", "WA", "033", "", "47.5776", "-122.10123", "America/Los_Angeles"),("5815539", "West Lake Stevens", "", "US", "840", "", "WA", "061", "", "47.99343", "-122.1018", "America/Los_Angeles"),("5815599", "West Richland", "", "US", "840", "", "WA", "005", "", "46.3043", "-119.36141", "America/Los_Angeles"),("5815605", "West Valley", "", "US", "840", "", "WA", "077", "", "46.59207", "-120.60507", "America/Los_Angeles"),("5815759", "White Center", "", "US", "840", "", "WA", "033", "", "47.51732", "-122.35485", "America/Los_Angeles"),("5816320", "Bainbridge Island", "Остров Бейнбридж", "US", "840", "", "WA", "035", "", "47.62621", "-122.52124", "America/Los_Angeles"),("5816413", "Wollochet", "", "US", "840", "", "WA", "053", "", "47.26871", "-122.58402", "America/Los_Angeles"),("5816449", "Woodinville", "", "US", "840", "", "WA", "033", "", "47.75427", "-122.16346", "America/Los_Angeles"),("5816457", "Woodland", "", "US", "840", "", "WA", "015", "", "45.90456", "-122.74399", "America/Los_Angeles"),("5816494", "Woods Creek", "", "US", "840", "", "WA", "061", "", "47.87871", "-121.89846", "America/Los_Angeles"),("5816605", "Yakima", "Якима", "US", "840", "", "WA", "077", "", "46.60207", "-120.5059", "America/Los_Angeles"),("5816656", "Yelm", "", "US", "840", "", "WA", "067", "", "46.94204", "-122.60596", "America/Los_Angeles"),("5820705", "Casper", "Каспер", "US", "840", "", "WY", "025", "", "42.86663", "-106.31308", "America/Denver"),("5821086", "Cheyenne", "Шайенн", "US", "840", "", "WY", "021", "", "41.13998", "-104.82025", "America/Denver"),("5821593", "Cody", "", "US", "840", "", "WY", "029", "", "44.52634", "-109.05653", "America/Denver"),("5823516", "Douglas", "", "US", "840", "", "WY", "009", "", "42.75969", "-105.38221", "America/Denver"),("5824805", "Evanston", "", "US", "840", "", "WY", "041", "", "41.26828", "-110.96324", "America/Denver"),("5826027", "Gillette", "Джиллетт", "US", "840", "", "WY", "005", "", "44.29109", "-105.50222", "America/Denver"),("5826559", "Green River", "", "US", "840", "", "WY", "037", "", "41.52858", "-109.46625", "America/Denver"),("5828648", "Jackson", "", "US", "840", "", "WY", "039", "", "43.47993", "-110.76243", "America/Denver"),("5830007", "Lander", "", "US", "840", "", "WY", "013", "", "42.83301", "-108.73067", "America/Denver"),("5830062", "Laramie", "Ларами", "US", "840", "", "WY", "001", "", "41.31137", "-105.5911", "America/Denver"),("5835606", "Powell", "", "US", "840", "", "WY", "029", "", "44.75384", "-108.75735", "America/Denver"),("5835956", "Ranchettes", "", "US", "840", "", "WY", "021", "", "41.21859", "-104.79025", "America/Denver"),("5836068", "Rawlins", "", "US", "840", "", "WY", "007", "", "41.79107", "-107.23866", "America/Denver"),("5836665", "Riverton", "", "US", "840", "", "WY", "013", "", "43.02496", "-108.3801", "America/Denver"),("5836898", "Rock Springs", "Рок-Спрингс", "US", "840", "", "WY", "037", "", "41.58746", "-109.2029", "America/Denver"),("5838198", "Sheridan", "Шеридан", "US", "840", "", "WY", "033", "", "44.79719", "-106.95618", "America/Denver"),("5841207", "Torrington", "", "US", "840", "", "WY", "015", "", "42.06246", "-104.18439", "America/Denver"),("5843495", "Worland", "", "US", "840", "", "WY", "043", "", "44.0169", "-107.95537", "America/Denver"),("5844096", "American Fork", "", "US", "840", "", "UT", "049", "", "40.3769", "-111.79576", "America/Denver"),("5847411", "Kahului", "", "US", "840", "", "HI", "009", "", "20.88953", "-156.47432", "Pacific/Honolulu"),("5847486", "Kailua", "", "US", "840", "", "HI", "003", "", "21.40241", "-157.74054", "Pacific/Honolulu"),("5847504", "Kailua-Kona", "", "US", "840", "", "HI", "001", "", "19.64016", "-155.99912", "Pacific/Honolulu"),("5847746", "Kalaoa", "", "US", "840", "", "HI", "001", "", "19.72861", "-155.98167", "Pacific/Honolulu"),("5848189", "Kaneohe", "", "US", "840", "", "HI", "003", "", "21.39994", "-157.79895", "Pacific/Honolulu"),("5848280", "Kapa‘a", "", "US", "840", "", "HI", "007", "", "22.07521", "-159.31895", "Pacific/Honolulu"),("5849297", "Kīhei", "", "US", "840", "", "HI", "009", "", "20.76462", "-156.44578", "Pacific/Honolulu"),("5849996", "Lahaina", "", "US", "840", "", "HI", "009", "", "20.87429", "-156.67663", "Pacific/Honolulu"),("5850027", "Lā‘ie", "", "US", "840", "", "HI", "003", "", "21.64547", "-157.9225", "Pacific/Honolulu"),("5850248", "Lihue", "", "US", "840", "", "HI", "007", "", "21.98121", "-159.3721", "Pacific/Honolulu"),("5850492", "Mā‘ili", "", "US", "840", "", "HI", "003", "", "21.41629", "-158.17531", "Pacific/Honolulu"),("5850511", "Mākaha", "", "US", "840", "", "HI", "003", "", "21.46627", "-158.21037", "Pacific/Honolulu"),("5850554", "Makakilo City", "", "US", "840", "", "HI", "003", "", "21.34694", "-158.08583", "Pacific/Honolulu"),("5850616", "Makawao", "", "US", "840", "", "HI", "009", "", "20.85694", "-156.31306", "Pacific/Honolulu"),("5851030", "Mililani Town", "", "US", "840", "", "HI", "003", "", "21.45", "-158.00111", "Pacific/Honolulu"),("5851349", "Nānākuli", "", "US", "840", "", "HI", "003", "", "21.39362", "-158.15429", "Pacific/Honolulu"),("5852275", "Pearl City", "", "US", "840", "", "HI", "003", "7306149", "21.39734", "-157.97516", "Pacific/Honolulu"),("5852697", "Pukalani", "", "US", "840", "", "HI", "009", "", "20.83667", "-156.33667", "Pacific/Honolulu"),("5853965", "Village Park", "", "US", "840", "", "HI", "003", "", "21.39806", "-158.03028", "Pacific/Honolulu"),("5853992", "Wahiawā", "", "US", "840", "", "HI", "003", "", "21.50279", "-158.02464", "Pacific/Honolulu"),("5854189", "Waianae", "", "US", "840", "", "HI", "003", "", "21.43621", "-158.1863", "Pacific/Honolulu"),("5854421", "Waikoloa Village", "", "US", "840", "", "HI", "001", "", "19.9325", "-155.82778", "Pacific/Honolulu"),("5854450", "Wailea", "", "US", "840", "", "HI", "009", "", "20.68973", "-156.4419", "Pacific/Honolulu"),("5854496", "Wailuku", "", "US", "840", "", "HI", "009", "", "20.89133", "-156.50604", "Pacific/Honolulu"),("5854530", "Waimalu", "", "US", "840", "", "HI", "003", "", "21.40472", "-157.94333", "Pacific/Honolulu"),("5854532", "Waimanalo", "", "US", "840", "", "HI", "003", "", "21.34614", "-157.7238", "Pacific/Honolulu"),("5854571", "Waimea", "", "US", "840", "", "HI", "001", "", "20.02323", "-155.67288", "Pacific/Honolulu"),("5854686", "Waipahu", "", "US", "840", "", "HI", "003", "", "21.38667", "-158.00917", "Pacific/Honolulu"),("5854717", "Waipio", "", "US", "840", "", "HI", "003", "", "21.41823", "-157.99906", "Pacific/Honolulu"),("5854718", "Waipi‘o Acres", "", "US", "840", "", "HI", "003", "", "21.46485", "-158.01331", "Pacific/Honolulu"),("5855051", "‘Ewa Beach", "", "US", "840", "", "HI", "003", "", "21.31556", "-158.00722", "Pacific/Honolulu"),("5855070", "‘Ewa Gentry", "", "US", "840", "", "HI", "003", "", "21.33999", "-158.03039", "Pacific/Honolulu"),("5855073", "‘Ewa Villages", "", "US", "840", "", "HI", "003", "", "21.34127", "-158.0397", "Pacific/Honolulu"),("5855319", "Hālawa", "", "US", "840", "", "HI", "003", "", "21.37944", "-157.92167", "Pacific/Honolulu"),("5855327", "Hālawa Heights", "", "US", "840", "", "HI", "003", "", "21.37848", "-157.91388", "Pacific/Honolulu"),("5855809", "Hawaiian Paradise Park", "", "US", "840", "", "HI", "001", "", "19.59333", "-154.97306", "Pacific/Honolulu"),("5855927", "Hilo", "Хило", "US", "840", "", "HI", "001", "", "19.72991", "-155.09073", "Pacific/Honolulu"),("5856050", "Hōlualoa", "", "US", "840", "", "HI", "001", "", "19.61979", "-155.94831", "Pacific/Honolulu"),("5856195", "Honolulu", "Гонолулу", "US", "840", "", "HI", "003", "", "21.30694", "-157.85833", "Pacific/Honolulu"),("5856430", "‘Aiea", "", "US", "840", "", "HI", "003", "", "21.38222", "-157.93361", "Pacific/Honolulu"),("5856516", "‘Āhuimanu", "", "US", "840", "", "HI", "003", "", "21.44472", "-157.83778", "Pacific/Honolulu"),("5859699", "College", "", "US", "840", "", "AK", "090", "", "64.85694", "-147.80278", "America/Anchorage"),("5861187", "Eagle River", "", "US", "840", "", "AK", "020", "", "61.32139", "-149.56778", "America/Anchorage"),("5861897", "Fairbanks", "Фэрбанкс", "US", "840", "", "AK", "090", "", "64.83778", "-147.71639", "America/Anchorage"),("5862727", "Gateway", "", "US", "840", "", "AK", "170", "", "61.57278", "-149.24083", "America/Anchorage"),("5864145", "Homer", "", "US", "840", "", "AK", "122", "", "59.6425", "-151.5494", "America/Anchorage"),("5865702", "Kalifornsky", "", "US", "840", "", "AK", "122", "", "60.41833", "-151.29", "America/Anchorage"),("5866063", "Kenai", "", "US", "840", "", "AK", "122", "", "60.55444", "-151.25833", "America/Anchorage"),("5866583", "Kodiak", "", "US", "840", "", "AK", "150", "", "57.79", "-152.40722", "America/Anchorage"),("5868651", "Meadow Lakes", "", "US", "840", "", "AK", "170", "", "61.62472", "-149.60111", "America/Anchorage"),("5871146", "Palmer", "", "US", "840", "", "AK", "170", "", "61.59972", "-149.11278", "America/Anchorage"),("5875173", "Sterling", "", "US", "840", "", "AK", "122", "", "60.53722", "-150.76472", "America/Anchorage"),("5875796", "Tanaina", "", "US", "840", "", "AK", "170", "", "61.62694", "-149.42806", "America/Anchorage"),("5877641", "Wasilla", "", "US", "840", "", "AK", "170", "", "61.58139", "-149.43944", "America/Anchorage"),("5879400", "Anchorage", "Анкоридж", "US", "840", "", "AK", "020", "", "61.21806", "-149.90028", "America/Anchorage"),("5879898", "Badger", "", "US", "840", "", "AK", "090", "", "64.8", "-147.53333", "America/Anchorage"),("5880568", "Bethel", "", "US", "840", "", "AK", "050", "", "60.79222", "-161.75583", "America/Anchorage"),("6331908", "Milton", "", "US", "840", "", "GA", "121", "", "34.13216", "-84.30067", "America/New_York"),("6331909", "Johns Creek", "", "US", "840", "", "GA", "121", "", "34.02893", "-84.19858", "America/New_York"),("6331911", "Helena-West Helena", "", "US", "840", "", "AR", "107", "", "34.5291", "-90.59", "America/Chicago"),("6332309", "Cutler Bay", "", "US", "840", "", "FL", "086", "", "25.5783", "-80.3377", "America/New_York"),("6332439", "Alafaya", "", "US", "840", "", "FL", "095", "", "28.5641", "-81.2114", "America/New_York"),("6424355", "St Johnsbury", "", "US", "840", "", "VT", "005", "", "44.42526", "-72.01512", "America/New_York"),("6690773", "Stevenson Ranch", "", "US", "840", "", "CA", "037", "", "34.39048", "-118.57372", "America/Los_Angeles"),("6690909", "Eastchester", "", "US", "840", "", "NY", "119", "", "40.95754", "-73.80976", "America/New_York"),("6930979", "Village of Campton Hills", "", "US", "840", "", "IL", "089", "", "41.9366", "-88.3975", "America/Chicago"),("6941080", "Fort Bragg", "", "US", "840", "", "NC", "051", "", "35.139", "-79.00603", "America/New_York"),("6957263", "Kapolei", "", "US", "840", "", "HI", "003", "", "21.33555", "-158.0582", "Pacific/Honolulu"),("7160204", "City of Milford (balance)", "", "US", "840", "", "CT", "009", "", "41.22374", "-73.06164", "America/New_York"),("7172886", "Butte-Silver Bow (Balance)", "", "US", "840", "", "MT", "093", "", "45.90194", "-112.65708", "America/Denver"),("7174365", "City of Sammamish", "", "US", "840", "", "WA", "033", "", "47.60444", "-122.03768", "America/Los_Angeles"),("7176035", "Silver Firs", "", "US", "840", "", "WA", "061", "", "47.86602", "-122.1551", "America/Los_Angeles"),("7176038", "Verde Village", "", "US", "840", "", "AZ", "025", "", "34.7105", "-112.01152", "America/Phoenix"),("7176039", "Vineyard", "", "US", "840", "", "CA", "067", "", "38.46449", "-121.34692", "America/Los_Angeles"),("7249078", "North Castle", "", "US", "840", "", "NY", "119", "", "41.14", "-73.68389", "America/New_York"),("7249307", "Saddle Brooke", "", "US", "840", "", "AZ", "021", "", "32.53472", "-110.87361", "America/Phoenix"),("7257357", "Conning Towers-Nautilus Park", "", "US", "840", "", "CT", "011", "", "41.38548", "-72.06877", "America/New_York"),("7257408", "Simsbury Center", "", "US", "840", "", "CT", "003", "", "41.88088", "-72.81116", "America/New_York"),("7257422", "Wallingford Center", "", "US", "840", "", "CT", "009", "", "41.44987", "-72.81892", "America/New_York"),("7257648", "Barrington", "", "US", "840", "", "RI", "001", "", "41.73424", "-71.31929", "America/New_York"),("7257658", "Newport East", "", "US", "840", "", "RI", "005", "", "41.51579", "-71.28752", "America/New_York"),("7257663", "Wakefield-Peacedale", "", "US", "840", "", "RI", "009", "", "41.44606", "-71.5004", "America/New_York"),("7257665", "West Warwick", "", "US", "840", "", "RI", "003", "", "41.67964", "-71.52178", "America/New_York"),("7257704", "Mansfield Center", "", "US", "840", "", "MA", "005", "", "42.02262", "-71.21808", "America/New_York"),("7257713", "Middleborough Center", "", "US", "840", "", "MA", "023", "", "41.8946", "-70.92618", "America/New_York"),("7257798", "Branford Center", "", "US", "840", "", "CT", "009", "", "41.27738", "-72.81511", "America/New_York"),("7257805", "Cheshire Village", "", "US", "840", "", "CT", "009", "", "41.5026", "-72.89952", "America/New_York"),("7257902", "Fort Belvoir", "", "US", "840", "", "VA", "059", "", "38.7119", "-77.14589", "America/New_York"),("7257905", "Fort Drum", "", "US", "840", "", "NY", "045", "", "44.05843", "-75.76189", "America/New_York"),("7257909", "Fort Meade", "", "US", "840", "", "MD", "003", "", "39.10815", "-76.74323", "America/New_York"),("7257953", "Ashton-Sandy Spring", "", "US", "840", "", "MD", "031", "", "39.14976", "-77.00504", "America/New_York"),("7257991", "Bel Air North", "", "US", "840", "", "MD", "025", "", "39.55429", "-76.37309", "America/New_York"),("7257992", "Bel Air South", "", "US", "840", "", "MD", "025", "", "39.50506", "-76.31977", "America/New_York"),("7258078", "Carmel Hamlet", "", "US", "840", "", "NY", "079", "", "41.41485", "-73.68524", "America/New_York"),("7258082", "Carnot-Moon", "", "US", "840", "", "PA", "003", "", "40.51856", "-80.21736", "America/New_York"),("7258140", "Coeymans", "", "US", "840", "", "NY", "001", "", "42.47491", "-73.79562", "America/New_York"),("7258303", "Moorestown-Lenola", "", "US", "840", "", "NJ", "005", "", "39.96591", "-74.96441", "America/New_York"),("7258318", "Mount Vernon", "", "US", "840", "", "VA", "059", "", "38.71919", "-77.10726", "America/New_York"),("7258393", "Northwest Harborcreek", "", "US", "840", "", "PA", "049", "", "42.14944", "-79.99463", "America/New_York"),("7258581", "Leisure World", "", "US", "840", "", "MD", "031", "", "39.1023", "-77.06898", "America/New_York"),("7258606", "Fountainhead-Orchard Hills", "", "US", "840", "", "MD", "043", "", "39.68636", "-77.71901", "America/New_York"),("7258652", "Glens Falls North", "", "US", "840", "", "NY", "113", "", "43.33506", "-73.68251", "America/New_York"),("7258741", "Holiday City-Berkeley", "", "US", "840", "", "NJ", "029", "", "39.9638", "-74.27803", "America/New_York"),("7258746", "Homeacre-Lyndora", "", "US", "840", "", "PA", "019", "", "40.87206", "-79.9206", "America/New_York"),("7258782", "Jefferson Valley-Yorktown", "", "US", "840", "", "NY", "119", "", "41.31797", "-73.80066", "America/New_York"),("7258965", "Setauket-East Setauket", "", "US", "840", "", "NY", "103", "", "40.93064", "-73.10179", "America/New_York"),("7258973", "Shanor-Northvue", "", "US", "840", "", "PA", "019", "", "40.91045", "-79.91562", "America/New_York"),("7259013", "South Park Township", "", "US", "840", "", "PA", "003", "", "40.29864", "-79.99405", "America/New_York"),("7259124", "Village Green-Green Ridge", "", "US", "840", "", "PA", "045", "", "39.86363", "-75.42548", "America/New_York"),("7259265", "Fort Leonard Wood", "", "US", "840", "", "MO", "169", "", "37.70573", "-92.15717", "America/Chicago"),("7259267", "Fort Riley North", "", "US", "840", "", "KS", "161", "", "39.11081", "-96.81392", "America/Chicago"),("7259295", "Grissom Air Force Base", "", "US", "840", "", "IN", "103", "", "40.65753", "-86.14755", "America/Indiana/Indianapolis"),("7259396", "Minot Air Force Base", "", "US", "840", "", "ND", "101", "", "48.42087", "-101.33914", "America/Chicago"),("7259400", "Montrose-Ghent", "", "US", "840", "", "OH", "153", "", "41.1538", "-81.64378", "America/New_York"),("7259582", "Champion Heights", "", "US", "840", "", "OH", "155", "", "41.28999", "-80.84595", "America/New_York"),("7259593", "Comstock Northwest", "", "US", "840", "", "MI", "077", "", "42.32182", "-85.51759", "America/Detroit"),("7259621", "West Bloomfield Township", "", "US", "840", "", "MI", "125", "", "42.56891", "-83.38356", "America/Detroit"),("7259705", "East Lake-Orient Park", "", "US", "840", "", "FL", "057", "", "27.98269", "-82.37878", "America/New_York"),("7259770", "Fort Campbell North", "", "US", "840", "", "KY", "047", "", "36.65429", "-87.46056", "America/Chicago"),("7259771", "Fort Knox", "", "US", "840", "", "KY", "093", "", "37.89113", "-85.96363", "America/New_York"),("7259773", "Fort Pierce North", "", "US", "840", "", "FL", "111", "", "27.47364", "-80.3593", "America/New_York"),("7259774", "Fort Pierce South", "", "US", "840", "", "FL", "111", "", "27.40962", "-80.35483", "America/New_York"),("7259776", "Fort Polk South", "", "US", "840", "", "LA", "115", "", "31.0511", "-93.21578", "America/Chicago"),("7259780", "Four Corners", "", "US", "840", "", "FL", "069", "", "28.33287", "-81.64738", "America/New_York"),("7259823", "Greater Northdale", "", "US", "840", "", "FL", "057", "", "28.10545", "-82.52594", "America/New_York"),("7259881", "Hutchinson Island South", "", "US", "840", "", "FL", "111", "", "27.29949", "-80.22045", "America/New_York"),("7259892", "Inverness Highlands South", "", "US", "840", "", "FL", "017", "", "28.80055", "-82.3371", "America/New_York"),("7259949", "Bellair-Meadowbrook Terrace", "", "US", "840", "", "FL", "019", "", "30.17881", "-81.74341", "America/New_York"),("7260019", "Candler-McAfee", "", "US", "840", "", "GA", "089", "", "33.72672", "-84.27246", "America/New_York"),("7260057", "Cocoa West", "", "US", "840", "", "FL", "009", "", "28.35942", "-80.77109", "America/New_York"),("7260093", "Samsula-Spruce Creek", "", "US", "840", "", "FL", "127", "", "29.04932", "-81.06192", "America/New_York"),("7260157", "Southeast Arcadia", "", "US", "840", "", "FL", "027", "", "27.18629", "-81.8521", "America/New_York"),("7260219", "University", "", "US", "840", "", "FL", "057", "", "28.07389", "-82.43902", "America/New_York"),("7260233", "Vero Beach South", "", "US", "840", "", "FL", "061", "", "27.61638", "-80.41308", "America/New_York"),("7260319", "Zephyrhills South", "", "US", "840", "", "FL", "101", "", "28.21492", "-82.18873", "America/New_York"),("7260320", "Zephyrhills West", "", "US", "840", "", "FL", "101", "", "28.23081", "-82.20556", "America/New_York"),("7260327", "Kendall West", "", "US", "840", "", "FL", "086", "", "25.7065", "-80.4388", "America/New_York"),("7260357", "Lake Murray of Richland", "", "US", "840", "", "SC", "079", "", "34.12048", "-81.2645", "America/New_York"),("7260358", "Lake Norman of Catawba", "", "US", "840", "", "NC", "035", "", "35.58043", "-81.01654", "America/New_York"),("7260484", "Nassau Village-Ratliff", "", "US", "840", "", "FL", "089", "", "30.51111", "-81.80925", "America/New_York"),("7260490", "New Port Richey East", "", "US", "840", "", "FL", "101", "", "28.26027", "-82.69261", "America/New_York"),("7260514", "North Weeki Wachee", "", "US", "840", "", "FL", "053", "", "28.55014", "-82.55888", "America/New_York"),("7260518", "Oak Grove", "", "US", "840", "", "SC", "063", "", "33.9809", "-81.14286", "America/New_York"),("7260548", "Palm River-Clair Mel", "", "US", "840", "", "FL", "057", "", "27.92386", "-82.37939", "America/New_York"),("7260679", "Clarkston Heights-Vineland", "", "US", "840", "", "WA", "003", "", "46.38742", "-117.083", "America/Los_Angeles"),("7260752", "Air Force Academy", "", "US", "840", "", "CO", "041", "", "38.99425", "-104.86375", "America/Denver"),("7260806", "Arden-Arcade", "", "US", "840", "", "CA", "067", "", "38.6025", "-121.37854", "America/Los_Angeles"),("7260845", "Bangor Trident Base", "", "US", "840", "", "WA", "035", "", "47.72274", "-122.71446", "America/Los_Angeles"),("7260892", "Village of Oak Creek (Big Park)", "", "US", "840", "", "AZ", "025", "", "34.7809", "-111.76227", "America/Phoenix"),("7260929", "Bonadelle Ranchos-Madera Ranchos", "", "US", "840", "", "CA", "039", "", "36.98467", "-119.87463", "America/Los_Angeles"),("7260952", "Bret Harte", "", "US", "840", "", "CA", "099", "", "37.60207", "-121.00519", "America/Los_Angeles"),("7260966", "Bryn Mawr-Skyway", "", "US", "840", "", "WA", "033", "", "47.4943", "-122.24092", "America/Los_Angeles"),("7260996", "Camp Pendleton North", "", "US", "840", "", "CA", "073", "", "33.31465", "-117.31603", "America/Los_Angeles"),("7260997", "Camp Pendleton South", "", "US", "840", "", "CA", "073", "", "33.22844", "-117.37929", "America/Los_Angeles"),("7261029", "Casa de Oro-Mount Helix", "", "US", "840", "", "CA", "073", "", "32.76397", "-116.96877", "America/Los_Angeles"),("7261199", "Lucas Valley-Marinwood", "", "US", "840", "", "CA", "041", "", "38.04011", "-122.5755", "America/Los_Angeles"),("7261268", "Florence-Graham", "", "US", "840", "", "CA", "037", "", "33.96772", "-118.24438", "America/Los_Angeles"),("7261282", "Fort Bliss", "", "US", "840", "", "TX", "141", "", "31.81357", "-106.41224", "America/Denver"),("7261291", "Fort Hood", "", "US", "840", "", "TX", "027", "", "31.13489", "-97.77561", "America/Chicago"),("7261292", "Fort Lewis", "", "US", "840", "", "WA", "053", "", "47.10787", "-122.57694", "America/Los_Angeles"),("7261327", "Garden Home-Whitford", "", "US", "840", "", "OR", "067", "", "45.464", "-122.75891", "America/Los_Angeles"),("7261353", "Gold Canyon", "", "US", "840", "", "AZ", "021", "", "33.37145", "-111.43691", "America/Phoenix"),("7261393", "Gunbarrel", "", "US", "840", "", "CO", "013", "", "40.06335", "-105.17107", "America/Denver"),("7261423", "Helena Valley Southeast", "", "US", "840", "", "MT", "049", "", "46.61527", "-111.92156", "America/Denver"),("7261424", "Helena Valley West Central", "", "US", "840", "", "MT", "049", "", "46.66291", "-112.06044", "America/Denver"),("7261441", "Hilmar-Irwin", "", "US", "840", "", "CA", "047", "", "37.40454", "-120.85042", "America/Los_Angeles"),("7261476", "Inglewood-Finn Hill", "", "US", "840", "", "WA", "033", "", "47.72049", "-122.23167", "America/Los_Angeles"),("7261553", "La Crescenta-Montrose", "", "US", "840", "", "CA", "037", "", "34.23216", "-118.23529", "America/Los_Angeles"),("7261570", "Lackland Air Force Base", "", "US", "840", "", "TX", "029", "", "29.38663", "-98.61797", "America/Chicago"),("7261595", "Lake Morton-Berrydale", "", "US", "840", "", "WA", "033", "", "47.33251", "-122.10286", "America/Los_Angeles"),("7261608", "Lakeland North", "", "US", "840", "", "WA", "033", "", "47.33343", "-122.27695", "America/Los_Angeles"),("7261609", "Lakeland South", "", "US", "840", "", "WA", "033", "", "47.27843", "-122.28326", "America/Los_Angeles"),("7261625", "Larkfield-Wikiup", "", "US", "840", "", "CA", "097", "", "38.51342", "-122.75094", "America/Los_Angeles"),("7261649", "Lemoore Station", "", "US", "840", "", "CA", "031", "", "36.26326", "-119.90476", "America/Los_Angeles"),("7261759", "East Hill-Meridian", "", "US", "840", "", "WA", "033", "", "47.41052", "-122.17369", "America/Los_Angeles"),("7261785", "Sierra Vista Southeast", "", "US", "840", "", "AZ", "003", "", "31.45385", "-110.21637", "America/Phoenix"),("7261968", "New Kingman-Butler", "", "US", "840", "", "AZ", "015", "", "35.26504", "-114.03226", "America/Phoenix"),("7262019", "Oatfield", "", "US", "840", "", "OR", "005", "", "45.41418", "-122.60007", "America/Los_Angeles"),("7262050", "Oroville East", "", "US", "840", "", "CA", "007", "", "39.51126", "-121.47519", "America/Los_Angeles"),("7262053", "Otis Orchards-East Farms", "", "US", "840", "", "WA", "063", "", "47.70988", "-117.07975", "America/Los_Angeles"),("7262259", "Roseburg North", "", "US", "840", "", "OR", "019", "", "43.26452", "-123.30331", "America/Los_Angeles"),("7262349", "Security-Widefield", "", "US", "840", "", "CO", "041", "", "38.74728", "-104.71439", "America/Denver"),("7262428", "Union Hill-Novelty Hill", "", "US", "840", "", "WA", "033", "", "47.67887", "-122.02833", "America/Los_Angeles"),("7262440", "Valencia West", "", "US", "840", "", "AZ", "019", "", "32.13238", "-111.11414", "America/Phoenix"),("7262460", "View Park-Windsor Hills", "", "US", "840", "", "CA", "037", "", "33.99551", "-118.34835", "America/Los_Angeles"),("7262464", "Vincent", "", "US", "840", "", "CA", "037", "", "34.09836", "-117.92383", "America/Los_Angeles"),("7262495", "West Clarkston-Highland", "", "US", "840", "", "WA", "003", "", "46.40287", "-117.06395", "America/Los_Angeles"),("7262498", "West Haven-Sylvan", "", "US", "840", "", "OR", "067", "", "45.51613", "-122.76809", "America/Los_Angeles"),("7262504", "West Modesto", "", "US", "840", "", "CA", "099", "", "37.61754", "-121.03914", "America/Los_Angeles"),("7262515", "West Side Highway", "", "US", "840", "", "WA", "015", "", "46.18399", "-122.91715", "America/Los_Angeles"),("7262518", "West Whittier-Los Nietos", "", "US", "840", "", "CA", "037", "", "33.976", "-118.06909", "America/Los_Angeles"),("7262622", "Summerlin South", "", "US", "840", "", "NV", "003", "", "36.11708", "-115.33001", "America/Los_Angeles"),("7262659", "Tamalpais-Homestead Valley", "", "US", "840", "", "CA", "041", "", "37.87834", "-122.53625", "America/Los_Angeles"),("7262660", "Tanglewilde-Thompson Place", "", "US", "840", "", "WA", "067", "", "47.05116", "-122.78081", "America/Los_Angeles"),("7262697", "Haiku-Pauwela", "", "US", "840", "", "HI", "009", "", "20.92187", "-156.30508", "Pacific/Honolulu"),("7262713", "Hickam Field", "", "US", "840", "", "HI", "003", "", "21.33967", "-157.96018", "Pacific/Honolulu"),("7262734", "Marine Corps Base Hawaii - MCBH", "", "US", "840", "", "HI", "003", "", "21.44336", "-157.74981", "Pacific/Honolulu"),("7262761", "Makakilo", "", "US", "840", "", "HI", "003", "", "21.35237", "-158.08655", "Pacific/Honolulu"),("7262771", "Napili-Honokowai", "", "US", "840", "", "HI", "009", "", "20.97533", "-156.67826", "Pacific/Honolulu"),("7262790", "Schofield Barracks", "", "US", "840", "", "HI", "003", "", "21.49837", "-158.06515", "Pacific/Honolulu"),("7262791", "Royal Kunia", "", "US", "840", "", "HI", "003", "", "21.39392", "-158.0267", "Pacific/Honolulu"),("7262796", "Waihee-Waiehu", "", "US", "840", "", "HI", "009", "", "20.93022", "-156.50458", "Pacific/Honolulu"),("7262802", "Wailua Homesteads", "", "US", "840", "", "HI", "007", "", "22.07244", "-159.37677", "Pacific/Honolulu"),("7262897", "Knik-Fairview", "", "US", "840", "", "AK", "170", "", "61.51262", "-149.60012", "America/Anchorage"),("7262905", "Lakes", "", "US", "840", "", "AK", "170", "", "61.60713", "-149.30861", "America/Anchorage"),("7310164", "San Tan Valley", "", "US", "840", "", "AZ", "021", "", "33.1911", "-111.528", "America/Phoenix"),("7315196", "Fruitridge Pocket", "", "US", "840", "", "CA", "067", "", "38.53265", "-121.45581", "America/Los_Angeles"),("7315205", "Old Fig Garden", "", "US", "840", "", "CA", "019", "", "36.79885", "-119.80515", "America/Los_Angeles"),("7315210", "Sun Village", "", "US", "840", "", "CA", "037", "", "34.55952", "-117.95676", "America/Los_Angeles"),("7315230", "Horizon West", "", "US", "840", "", "FL", "095", "", "28.43383", "-81.6227", "America/New_York"),("7315234", "Midway", "", "US", "840", "", "FL", "113", "", "30.40648", "-87.00553", "America/Chicago"),("7315237", "Oakleaf Plantation", "", "US", "840", "", "FL", "019", "", "30.17083", "-81.83549", "America/New_York"),("7315238", "Pasadena Hills", "", "US", "840", "", "FL", "101", "", "28.28001", "-82.22438", "America/New_York"),("7315241", "Viera East", "", "US", "840", "", "FL", "009", "", "28.26234", "-80.71449", "America/New_York"),("7315242", "Viera West", "", "US", "840", "", "FL", "009", "", "28.24504", "-80.7338", "America/New_York"),("7315245", "East Honolulu", "", "US", "840", "", "HI", "003", "", "21.28906", "-157.71734", "Pacific/Honolulu"),("7315246", "Ocean Pointe", "", "US", "840", "", "HI", "003", "", "21.31066", "-158.03638", "Pacific/Honolulu"),("7315258", "Fairwood", "", "US", "840", "", "MD", "033", "", "38.95665", "-76.77772", "America/New_York"),("7315260", "Marlboro Village", "", "US", "840", "", "MD", "033", "", "38.83054", "-76.76965", "America/New_York"),("7315263", "Summerfield", "", "US", "840", "", "MD", "033", "", "38.90454", "-76.8683", "America/New_York"),("7315274", "Old Jamestown", "", "US", "840", "", "MO", "189", "", "38.83494", "-90.28511", "America/Chicago"),("7315293", "East Franklin", "", "US", "840", "", "NJ", "035", "", "40.4933", "-74.4711", "America/New_York"),("7315352", "Tellico Village", "", "US", "840", "", "TN", "105", "", "35.68321", "-84.25518", "America/New_York"),("7315364", "Lantana", "", "US", "840", "", "TX", "121", "", "33.09073", "-97.12416", "America/Chicago"),("7315398", "Kings Park West", "", "US", "840", "", "VA", "059", "", "38.81443", "-77.29582", "America/New_York"),("7315408", "Bothell East", "", "US", "840", "", "WA", "061", "", "47.80631", "-122.18427", "America/Los_Angeles"),("7315409", "Bothell West", "", "US", "840", "", "WA", "061", "", "47.80527", "-122.24064", "America/Los_Angeles"),("7315412", "Eastmont", "", "US", "840", "", "WA", "061", "", "47.8974", "-122.18154", "America/Los_Angeles"),("7315415", "Klahanie", "", "US", "840", "", "WA", "033", "", "47.57097", "-122.00839", "America/Los_Angeles"),("7315418", "Mill Creek East", "", "US", "840", "", "WA", "061", "", "47.83602", "-122.18766", "America/Los_Angeles"),("7315426", "Summit View", "", "US", "840", "", "WA", "053", "", "47.13632", "-122.35202", "America/Los_Angeles"),("7535510", "University Park", "", "US", "840", "", "IL", "197", "", "41.44298", "-87.6836", "America/Chicago"),("7536026", "Rio Vista", "", "US", "840", "", "CA", "095", "", "38.16389", "-121.69583", "America/Los_Angeles"),("7728582", "Woodlake", "", "US", "840", "", "VA", "041", "", "37.42106", "-77.67931", "America/New_York"),("7729501", "Dove Valley", "", "US", "840", "", "CO", "005", "", "39.57771", "-104.8294", "America/Denver"),("7839240", "Enchanted Hills", "", "US", "840", "", "NM", "043", "", "35.33676", "-106.59296", "America/Denver"),("8030162", "West Hills", "", "US", "840", "", "CA", "037", "", "34.19731", "-118.64398", "America/Los_Angeles"),("8096113", "The Acreage", "", "US", "840", "", "FL", "099", "", "26.79404", "-80.26749", "America/New_York"),("8096217", "Eastvale", "", "US", "840", "", "CA", "065", "", "33.96358", "-117.56418", "America/Los_Angeles"),("8097131", "Oak Hill", "", "US", "840", "", "VA", "059", "", "38.9258", "-77.40156", "America/New_York"),("8097232", "Contra Costa Centre", "", "US", "840", "", "CA", "013", "", "37.92752", "-122.05786", "America/Los_Angeles"),("8260172", "West Greenwich", "", "US", "840", "", "RI", "003", "", "41.637", "-71.66004", "America/New_York"),("8299576", "Bridgewater", "", "US", "840", "", "NJ", "035", "", "40.60079", "-74.64815", "America/New_York"),("8299577", "Warren Township", "", "US", "840", "", "NJ", "035", "", "40.60822", "-74.51803", "America/New_York"),("8299699", "Castle Pines North", "", "US", "840", "", "CO", "093", "", "39.47174", "-104.89482", "America/Denver"),("8347326", "Fairfield Heights", "", "US", "840", "", "IN", "063", "", "39.82861", "-86.38224", "America/Indiana/Indianapolis"),("8436572", "South Kingstown", "", "US", "840", "", "RI", "009", "", "41.44718", "-71.52494", "America/New_York"),("8449910", "La Porte", "", "US", "840", "", "IN", "091", "", "41.60774", "-86.71389", "America/Chicago"),("8469294", "Notre Dame", "", "US", "840", "", "IN", "141", "", "41.70019", "-86.23793", "America/Indiana/Indianapolis"),("8469295", "Randolph", "", "US", "840", "", "NJ", "027", "", "40.84829", "-74.58148", "America/New_York"),("8478940", "Hobart", "", "US", "840", "", "WI", "009", "", "44.49925", "-88.14986", "America/Chicago"),("8478941", "Mount Pleasant", "", "US", "840", "", "WI", "101", "", "42.69743", "-87.85577", "America/Chicago"),("8479308", "Shaw Heights", "", "US", "840", "", "CO", "001", "", "39.8525", "-105.04306", "America/Denver"),("8479411", "Northdale", "", "US", "840", "", "FL", "057", "", "28.0939", "-82.50561", "America/New_York"),("8479422", "Lake Stickney", "", "US", "840", "", "WA", "061", "", "47.87655", "-122.26214", "America/Los_Angeles"),("8479428", "Picnic Point", "", "US", "840", "", "WA", "061", "", "47.88111", "-122.3284", "America/Los_Angeles"),("8479429", "Roma", "", "US", "840", "", "TX", "427", "", "26.40526", "-99.01581", "America/Chicago"),("8479430", "Tanglewilde", "", "US", "840", "", "WA", "067", "", "47.0515", "-122.78241", "America/Los_Angeles"),("8480031", "Waterford", "", "US", "840", "", "CT", "011", "", "41.3417", "-72.13597", "America/New_York"),("8480048", "Cherry Creek", "", "US", "840", "", "CO", "005", "", "39.63455", "-104.88286", "America/Denver"),("8480059", "Apple Valley", "", "US", "840", "", "OH", "083", "", "40.4389", "-82.35391", "America/New_York"),("8480062", "Meadowbrook", "", "US", "840", "", "VA", "041", "", "37.44882", "-77.47353", "America/New_York"),("8480064", "Woodburn", "", "US", "840", "", "VA", "059", "", "38.84745", "-77.23605", "America/New_York"),("8481841", "Silver Lakes", "", "US", "840", "", "CA", "071", "", "34.74558", "-117.34098", "America/Los_Angeles"),("8481842", "Spring Valley Lake", "", "US", "840", "", "CA", "071", "", "34.49364", "-117.26832", "America/Los_Angeles"),("8531960", "Lincoln", "", "US", "840", "", "RI", "007", "", "41.92111", "-71.435", "America/New_York"),("8531961", "Kula", "", "US", "840", "", "HI", "009", "", "20.79094", "-156.32695", "Pacific/Honolulu"),("8604682", "Johnston", "", "US", "840", "", "RI", "007", "5222928", "41.82186", "-71.50675", "America/New_York"),("8605012", "Elmendorf Air Force Base", "", "US", "840", "", "AK", "020", "", "61.25703", "-149.63139", "America/Anchorage"),("8605040", "Hot Springs National Park", "", "US", "840", "", "AR", "051", "", "34.5317", "-93.06377", "America/Chicago"),("8605041", "Dixiana", "", "US", "840", "", "AL", "073", "", "33.74021", "-86.64938", "America/Chicago"),("8643098", "Cranberry Township", "", "US", "840", "", "PA", "019", "", "40.68496", "-80.10714", "America/New_York"),("9670593", "Laurel Hill", "", "US", "840", "", "VA", "059", "", "38.71663", "-77.23686", "America/New_York"),("9682914", "Harrison", "", "US", "840", "", "WI", "015", "", "44.22776", "-88.33591", "America/Chicago"),("10103966", "Pryor Creek", "", "US", "840", "", "OK", "097", "", "36.30862", "-95.31777", "America/Chicago"),("10104153", "Silver Lake", "", "US", "840", "", "CA", "037", "", "34.08668", "-118.27023", "America/Los_Angeles"),("10104154", "Echo Park", "", "US", "840", "", "CA", "037", "", "34.07808", "-118.26066", "America/Los_Angeles"),("601294", "Nukus", "Нукус", "UZ", "860", "", "09", "", "", "42.45306", "59.61028", "Asia/Samarkand"),("601299", "Mŭynoq", "", "UZ", "860", "UZ", "09", "", "", "43.76833", "59.02139", "Asia/Samarkand"),("601339", "Khŭjayli", "Ходжейли", "UZ", "860", "", "09", "", "", "42.40043", "59.46005", "Asia/Samarkand"),("601349", "Kegeyli Shahar", "", "UZ", "860", "", "09", "", "", "42.77667", "59.60778", "Asia/Samarkand"),("601417", "Oltinko‘l", "", "UZ", "860", "", "09", "", "", "43.06874", "58.90372", "Asia/Samarkand"),("1215694", "Zomin", "Зомин", "UZ", "860", "", "15", "", "", "39.96056", "68.39583", "Asia/Samarkand"),("1215736", "Nishon Tumani", "", "UZ", "860", "", "08", "", "", "38.69395", "65.67512", "Asia/Samarkand"),("1215839", "Urgut", "Ургут", "UZ", "860", "", "10", "", "", "39.40222", "67.24306", "Asia/Samarkand"),("1215957", "Tirmiz", "Термез", "UZ", "860", "", "12", "", "", "37.22417", "67.27833", "Asia/Samarkand"),("1216115", "Sho‘rchi", "", "UZ", "860", "", "12", "", "", "37.99944", "67.7875", "Asia/Samarkand"),("1216187", "Shahrisabz", "Шахрисабз", "UZ", "860", "", "08", "", "", "39.05778", "66.83417", "Asia/Samarkand"),("1216189", "Shohimardon", "", "UZ", "860", "", "03", "", "", "39.98322", "71.80512", "Asia/Bishkek"),("1216265", "Samarqand", "Самарканд", "UZ", "860", "", "10", "", "", "39.65417", "66.95972", "Asia/Samarkand"),("1216290", "Romiton", "", "UZ", "860", "", "02", "", "", "39.92944", "64.37944", "Asia/Samarkand"),("1216311", "Qarshi", "Карши", "UZ", "860", "", "08", "", "", "38.86056", "65.78905", "Asia/Samarkand"),("1216475", "Muborak", "Муборак", "UZ", "860", "", "08", "", "", "39.25528", "65.15278", "Asia/Samarkand"),("1216787", "Kitob", "Китоб", "UZ", "860", "", "08", "", "", "39.08425", "66.83318", "Asia/Samarkand"),("1216982", "Kattaqo‘rg‘on", "", "UZ", "860", "", "10", "", "", "39.89889", "66.25611", "Asia/Samarkand"),("1217007", "Koson", "Косон", "UZ", "860", "", "08", "", "", "39.0375", "65.585", "Asia/Samarkand"),("1217035", "Qorovulbozor", "", "UZ", "860", "", "02", "", "", "39.50056", "64.79361", "Asia/Samarkand"),("1217084", "Karakul’", "Каракуль", "UZ", "860", "", "02", "", "", "39.53333", "63.83333", "Asia/Samarkand"),("1217180", "Kogon", "Каган", "UZ", "860", "", "02", "", "", "39.72278", "64.55167", "Asia/Samarkand"),("1217215", "Ishtixon", "", "UZ", "860", "", "10", "", "", "39.96639", "66.48611", "Asia/Samarkand"),("1217262", "G‘uzor", "", "UZ", "860", "", "08", "", "", "38.62083", "66.24806", "Asia/Samarkand"),("1217340", "Galaosiyo", "", "UZ", "860", "", "02", "", "", "39.85778", "64.44833", "Asia/Samarkand"),("1217362", "Juma", "", "UZ", "860", "", "10", "", "", "39.71611", "66.66417", "Asia/Samarkand"),("1217414", "Jomboy", "", "UZ", "860", "", "10", "", "", "39.69889", "67.09333", "Asia/Samarkand"),("1217474", "Denov", "Денов", "UZ", "860", "", "12", "", "", "38.26746", "67.89886", "Asia/Samarkand"),("1217512", "Daxbet", "", "UZ", "860", "", "10", "", "", "39.76389", "66.9125", "Asia/Samarkand"),("1217540", "Chiroqchi", "", "UZ", "860", "", "08", "", "", "39.03361", "66.57222", "Asia/Samarkand"),("1217569", "Chelak", "", "UZ", "860", "", "10", "", "", "39.92028", "66.86111", "Asia/Samarkand"),("1217595", "Charxin", "", "UZ", "860", "", "10", "", "", "39.69667", "66.76861", "Asia/Samarkand"),("1217658", "Bulung’ur", "", "UZ", "860", "", "10", "", "", "39.76472", "67.27139", "Asia/Samarkand"),("1217662", "Bukhara", "Бухара", "UZ", "860", "", "02", "", "", "39.77472", "64.42861", "Asia/Samarkand"),("1217703", "Beshkent", "Бешкент", "UZ", "860", "", "08", "", "", "38.82139", "65.65306", "Asia/Samarkand"),("1217734", "Boysun", "Бойсун", "UZ", "860", "", "12", "", "", "38.20835", "67.20664", "Asia/Samarkand"),("1217907", "Olot", "", "UZ", "860", "", "02", "", "", "39.415", "63.80333", "Asia/Samarkand"),("1217926", "Oqtosh", "", "UZ", "860", "", "10", "", "", "39.92139", "65.92528", "Asia/Samarkand"),("1512287", "Zafar", "Зафар", "UZ", "860", "", "14", "", "", "40.98333", "68.9", "Asia/Tashkent"),("1512320", "Yaypan", "Яйпан", "UZ", "860", "", "03", "", "", "40.37583", "70.81556", "Asia/Tashkent"),("1512339", "Yangiyŭl", "Янгиюль", "UZ", "860", "UZ", "14", "", "", "41.11202", "69.0471", "Asia/Tashkent"),("1512342", "Yangiyer", "Янгиер", "UZ", "860", "", "16", "", "", "40.275", "68.8225", "Asia/Tashkent"),("1512348", "Yangirabot", "", "UZ", "860", "", "07", "", "", "40.02539", "65.96095", "Asia/Samarkand"),("1512350", "Yangiqo‘rg‘on", "", "UZ", "860", "", "06", "", "", "41.18722", "71.73333", "Asia/Tashkent"),("1512372", "Yangiobod", "Янгиабад", "UZ", "860", "UZ", "14", "", "", "41.11919", "70.09406", "Asia/Tashkent"),("1512423", "Wobkent", "", "UZ", "860", "", "02", "", "", "40.03028", "64.515", "Asia/Samarkand"),("1512449", "Uychi", "Уйчи", "UZ", "860", "", "06", "", "", "41.08073", "71.92331", "Asia/Tashkent"),("1512464", "Ŭrtaowul", "", "UZ", "860", "", "14", "", "", "41.18667", "69.14528", "Asia/Tashkent"),("1512473", "Urganch", "Ургенч", "UZ", "860", "", "05", "", "", "41.55", "60.63333", "Asia/Samarkand"),("1512480", "Dashtobod", "", "UZ", "860", "", "15", "", "", "40.12694", "68.49444", "Asia/Tashkent"),("1512501", "Uchqŭrghon Shahri", "", "UZ", "860", "", "06", "", "", "41.11371", "72.07915", "Asia/Tashkent"),("1512524", "Tŭytepa", "Тойтепа", "UZ", "860", "UZ", "14", "", "", "41.0321", "69.36253", "Asia/Tashkent"),("1512549", "To‘rqao‘rg‘on", "", "UZ", "860", "", "06", "", "", "40.99984", "71.51162", "Asia/Tashkent"),("1512568", "Toshloq", "", "UZ", "860", "", "03", "", "", "40.47722", "71.76778", "Asia/Tashkent"),("1512569", "Tashkent", "Ташкент", "UZ", "860", "", "13", "", "", "41.26465", "69.21627", "Asia/Tashkent"),("1512658", "Toshbuloq", "", "UZ", "860", "", "06", "", "", "40.91617", "71.57819", "Asia/Tashkent"),("1512770", "Sirdaryo", "Сырдарьинская", "UZ", "860", "", "16", "", "", "40.84361", "68.66167", "Asia/Tashkent"),("1512790", "Showot", "", "UZ", "860", "", "05", "", "", "41.65583", "60.3025", "Asia/Samarkand"),("1512838", "Shofirkon", "", "UZ", "860", "", "02", "", "", "40.12", "64.50139", "Asia/Samarkand"),("1512934", "Salor", "", "UZ", "860", "", "14", "", "", "41.37222", "69.38167", "Asia/Tashkent"),("1512978", "Qŭshkŭpir", "", "UZ", "860", "", "05", "", "", "41.535", "60.34556", "Asia/Samarkand"),("1512979", "Qo‘qon", "Коканд", "UZ", "860", "", "03", "", "", "40.52861", "70.9425", "Asia/Tashkent"),("1512986", "Piskent", "", "UZ", "860", "", "14", "", "", "40.89722", "69.35056", "Asia/Tashkent"),("1513011", "Payshanba", "Пайшанба", "UZ", "860", "", "10", "", "", "40.00778", "66.23694", "Asia/Samarkand"),("1513017", "Parkent", "", "UZ", "860", "", "14", "", "", "41.29444", "69.67639", "Asia/Tashkent"),("1513023", "Pop", "Поп", "UZ", "860", "", "06", "", "", "40.87361", "71.10889", "Asia/Tashkent"),("1513038", "Paxtakor", "", "UZ", "860", "", "15", "", "", "40.31528", "67.95444", "Asia/Samarkand"),("1513064", "Olmaliq", "Алмалык", "UZ", "860", "", "14", "", "", "40.84472", "69.59833", "Asia/Tashkent"),("1513072", "Ohangaron", "", "UZ", "860", "", "14", "", "", "40.90639", "69.63833", "Asia/Tashkent"),("1513087", "Nurota", "Нурота", "UZ", "860", "", "07", "", "", "40.56139", "65.68861", "Asia/Samarkand"),("1513092", "Novyy Turtkul’", "", "UZ", "860", "", "09", "", "", "41.55", "61.01667", "Asia/Samarkand"),("1513131", "Navoiy", "Навои", "UZ", "860", "", "07", "", "", "40.08444", "65.37917", "Asia/Samarkand"),("1513157", "Namangan", "Наманган", "UZ", "860", "", "06", "", "", "40.9983", "71.67257", "Asia/Tashkent"),("1513242", "Marhamat", "", "UZ", "860", "", "01", "", "", "40.48048", "72.31388", "Asia/Tashkent"),("1513243", "Marg‘ilon", "Маргилан", "UZ", "860", "", "03", "", "", "40.47237", "71.72463", "Asia/Tashkent"),("1513245", "Manghit", "", "UZ", "860", "", "09", "", "", "42.11556", "60.05972", "Asia/Samarkand"),("1513271", "Asaka", "Асака", "UZ", "860", "", "01", "", "", "40.64153", "72.23868", "Asia/Tashkent"),("1513288", "Qiziltepa", "", "UZ", "860", "", "07", "", "", "40.03306", "64.85", "Asia/Samarkand"),("1513331", "Quvasoy", "", "UZ", "860", "", "03", "", "", "40.29721", "71.98026", "Asia/Bishkek"),("1513364", "Qo‘rg‘ontepa", "", "UZ", "860", "", "01", "", "", "40.73192", "72.76177", "Asia/Tashkent"),("1513491", "Yangi Marg‘ilon", "", "UZ", "860", "", "03", "", "", "40.42722", "71.71889", "Asia/Tashkent"),("1513555", "Kirguli", "", "UZ", "860", "", "03", "", "", "40.43553", "71.76721", "Asia/Tashkent"),("1513567", "Qibray", "", "UZ", "860", "", "14", "", "", "41.38972", "69.465", "Asia/Tashkent"),("1513600", "Xo‘jaobod", "", "UZ", "860", "", "01", "", "", "40.66886", "72.56002", "Asia/Tashkent"),("1513604", "Khiwa", "Хива", "UZ", "860", "", "05", "", "", "41.37833", "60.36389", "Asia/Samarkand"),("1513650", "Hamza", "", "UZ", "860", "", "03", "", "", "40.42762", "71.50534", "Asia/Tashkent"),("1513655", "Haqqulobod", "", "UZ", "860", "", "06", "", "", "40.91667", "72.11667", "Asia/Tashkent"),("1513714", "Kosonsoy", "", "UZ", "860", "", "06", "", "", "41.24944", "71.54738", "Asia/Tashkent"),("1513886", "Jizzax", "Джизак", "UZ", "860", "", "15", "", "", "40.11583", "67.84222", "Asia/Samarkand"),("1513900", "Iskandar", "Искандар", "UZ", "860", "", "14", "", "", "41.55389", "69.70083", "Asia/Tashkent"),("1513957", "Hazorasp", "", "UZ", "860", "", "05", "", "", "41.31944", "61.07417", "Asia/Samarkand"),("1513962", "Gurlan", "Гурлан", "UZ", "860", "", "05", "", "", "41.84472", "60.39194", "Asia/Samarkand"),("1513966", "Guliston", "Гулистан", "UZ", "860", "", "16", "", "", "40.48972", "68.78417", "Asia/Tashkent"),("1513983", "Ghijduwon", "", "UZ", "860", "", "02", "", "", "40.1", "64.68333", "Asia/Samarkand"),("1513990", "Gazli", "", "UZ", "860", "", "02", "", "", "40.13333", "63.45", "Asia/Samarkand"),("1513996", "G‘azalkent", "Газалкент", "UZ", "860", "", "14", "", "", "41.55806", "69.77083", "Asia/Tashkent"),("1514011", "Gagarin", "Гагарин", "UZ", "860", "", "15", "", "", "40.66194", "68.17222", "Asia/Tashkent"),("1514019", "Fergana", "Фергана", "UZ", "860", "", "03", "", "", "40.38421", "71.78432", "Asia/Tashkent"),("1514027", "Amir Timur", "", "UZ", "860", "UZ", "14", "", "", "41.01944", "68.94083", "Asia/Tashkent"),("1514125", "Dŭstlik", "", "UZ", "860", "", "15", "", "", "40.52472", "68.03583", "Asia/Tashkent"),("1514192", "Chust Shahri", "Чуст", "UZ", "860", "", "06", "", "", "41.00936", "71.2287", "Asia/Tashkent"),("1514210", "Chirchiq", "Чирчик", "UZ", "860", "", "14", "", "", "41.46889", "69.58222", "Asia/Tashkent"),("1514215", "Chinoz", "Чиноз", "UZ", "860", "", "14", "", "", "40.93633", "68.76128", "Asia/Tashkent"),("1514258", "Chortoq", "", "UZ", "860", "", "06", "", "", "41.06924", "71.82372", "Asia/Tashkent"),("1514330", "Bo‘ka", "", "UZ", "860", "", "14", "", "", "40.81108", "69.19417", "Asia/Tashkent"),("1514382", "Beshariq", "Бешарыкского", "UZ", "860", "", "03", "", "", "40.43583", "70.61028", "Asia/Tashkent"),("1514387", "Beruniy", "Беруний", "UZ", "860", "", "09", "", "", "41.69111", "60.7525", "Asia/Samarkand"),("1514396", "Bektemir", "Бектемир", "UZ", "860", "", "13", "", "", "41.20972", "69.33417", "Asia/Tashkent"),("1514402", "Bekobod", "", "UZ", "860", "", "14", "", "", "40.22083", "69.26972", "Asia/Tashkent"),("1514581", "Angren", "Ангрен", "UZ", "860", "", "14", "", "", "41.01667", "70.14361", "Asia/Tashkent"),("1514588", "Andijon", "Андижан", "UZ", "860", "", "01", "", "", "40.78206", "72.34424", "Asia/Tashkent"),("1514615", "Oltiariq", "", "UZ", "860", "", "03", "", "", "40.39194", "71.47417", "Asia/Tashkent"),("1526979", "Quva", "Кува", "UZ", "860", "", "03", "", "", "40.52204", "72.07292", "Asia/Tashkent"),("1538229", "Navoiy", "", "UZ", "860", "", "07", "", "", "40.1", "65.36667", "Asia/Samarkand"),("3577430", "Road Town", "Род-Таун", "VG", "93", "", "00", "", "", "18.42693", "-64.62079", "America/Tortola"),("1560037", "Yên Vinh", "", "VN", "704", "", "58", "", "", "18.66667", "105.66667", "Asia/Ho_Chi_Minh"),("1560349", "Yên Bái", "Йенбай", "VN", "704", "", "70", "", "", "21.72288", "104.9113", "Asia/Ho_Chi_Minh"),("1562414", "Vũng Tàu", "Вунгтау", "VN", "704", "", "45", "", "", "10.34599", "107.08426", "Asia/Ho_Chi_Minh"),("1562538", "Vị Thanh", "", "VN", "704", "", "93", "", "", "9.78449", "105.47012", "Asia/Ho_Chi_Minh"),("1562548", "Vĩnh Yên", "", "VN", "704", "", "86", "", "", "21.30891", "105.60489", "Asia/Ho_Chi_Minh"),("1562693", "Vĩnh Long", "", "VN", "704", "", "69", "", "", "10.25369", "105.9722", "Asia/Ho_Chi_Minh"),("1562798", "Vinh", "Винь", "VN", "704", "", "58", "", "", "18.67337", "105.69232", "Asia/Ho_Chi_Minh"),("1562820", "Việt Trì", "", "VN", "704", "", "83", "", "", "21.32274", "105.40198", "Asia/Ho_Chi_Minh"),("1563241", "Thành Phố Uông Bí", "", "VN", "704", "", "30", "", "", "21.03433", "106.77049", "Asia/Ho_Chi_Minh"),("1563281", "Tuy Hòa", "Туихоа", "VN", "704", "", "61", "", "", "13.09546", "109.32094", "Asia/Ho_Chi_Minh"),("1563287", "Thành Phố Tuyên Quang", "", "VN", "704", "", "68", "", "", "21.82356", "105.21424", "Asia/Ho_Chi_Minh"),("1563926", "Trà Vinh", "", "VN", "704", "", "67", "", "", "9.94719", "106.34225", "Asia/Ho_Chi_Minh"),("1565022", "Thủ Dầu Một", "", "VN", "704", "", "75", "", "", "10.9804", "106.6519", "Asia/Ho_Chi_Minh"),("1566083", "Ho Chi Minh City", "Хошимин", "VN", "704", "", "20", "", "", "10.82302", "106.62965", "Asia/Ho_Chi_Minh"),("1566166", "Thanh Hóa", "", "VN", "704", "", "34", "", "", "19.8", "105.76667", "Asia/Ho_Chi_Minh"),("1566319", "Thành Phố Thái Nguyên", "Тай-Нгуен", "VN", "704", "", "85", "", "", "21.59422", "105.84817", "Asia/Ho_Chi_Minh"),("1566346", "Thành Phố Thái Bình", "", "VN", "704", "", "35", "", "", "20.45", "106.34002", "Asia/Ho_Chi_Minh"),("1566559", "Tây Ninh", "", "VN", "704", "", "33", "", "", "11.31004", "106.09828", "Asia/Ho_Chi_Minh"),("1567069", "Tân An", "Тан", "VN", "704", "", "24", "", "", "10.53589", "106.41366", "Asia/Ho_Chi_Minh"),("1567148", "Tam Kỳ", "", "VN", "704", "", "84", "", "", "15.57364", "108.47403", "Asia/Ho_Chi_Minh"),("1567621", "Sơn Tây", "Сон-Тай", "VN", "704", "", "44", "", "", "21.14053", "105.50686", "Asia/Ho_Chi_Minh"),("1567681", "Sơn La", "Сон-Ла", "VN", "704", "", "32", "", "", "21.3256", "103.91882", "Asia/Ho_Chi_Minh"),("1567723", "Sông Cầu", "", "VN", "704", "", "61", "", "", "13.4556", "109.22348", "Asia/Ho_Chi_Minh"),("1567788", "Sóc Trăng", "Шокчанг", "VN", "704", "", "65", "", "", "9.59995", "105.97193", "Asia/Ho_Chi_Minh"),("1568043", "Sa Pá", "Шапа", "VN", "704", "VN", "90", "", "", "22.34023", "103.84415", "Asia/Ho_Chi_Minh"),("1568212", "Sa Dec", "", "VN", "704", "", "09", "", "", "10.29085", "105.75635", "Asia/Ho_Chi_Minh"),("1568510", "Rạch Giá", "", "VN", "704", "", "21", "", "", "10.01245", "105.08091", "Asia/Ho_Chi_Minh"),("1568574", "Qui Nhon", "Куинён", "VN", "704", "", "46", "", "", "13.77648", "109.22367", "Asia/Ho_Chi_Minh"),("1568770", "Quảng Ngãi", "Куангнгай", "VN", "704", "", "63", "", "", "15.12047", "108.79232", "Asia/Ho_Chi_Minh"),("1569684", "Pleiku", "Плейку", "VN", "704", "", "49", "", "", "13.98333", "108", "Asia/Ho_Chi_Minh"),("1569973", "Dương Đông", "", "VN", "704", "VN", "21", "", "", "10.21716", "103.95929", "Asia/Ho_Chi_Minh"),("1570449", "Thành Phố Phủ Lý", "", "VN", "704", "", "80", "", "", "20.54531", "105.91221", "Asia/Ho_Chi_Minh"),("1570549", "Phú Khương", "", "VN", "704", "", "33", "", "", "11.28333", "106.13333", "Asia/Ho_Chi_Minh"),("1571058", "Phan Thiết", "Фантьет", "VN", "704", "", "47", "", "", "10.92889", "108.10208", "Asia/Ho_Chi_Minh"),("1571067", "Phan Rang-Tháp Chàm", "", "VN", "704", "", "60", "", "", "11.56432", "108.98858", "Asia/Ho_Chi_Minh"),("1571968", "Thành Phố Ninh Bình", "", "VN", "704", "", "59", "", "", "20.25809", "105.97965", "Asia/Ho_Chi_Minh"),("1572151", "Nha Trang", "Нячанг", "VN", "704", "", "54", "", "", "12.24507", "109.19432", "Asia/Ho_Chi_Minh"),("1573517", "Thành Phố Nam Định", "Намдинь", "VN", "704", "", "82", "", "", "20.43389", "106.17729", "Asia/Ho_Chi_Minh"),("1574023", "Mỹ Tho", "", "VN", "704", "", "37", "", "", "10.36004", "106.35996", "Asia/Ho_Chi_Minh"),("1574507", "Móng Cái", "", "VN", "704", "", "30", "", "", "21.52471", "107.96619", "Asia/Ho_Chi_Minh"),("1575627", "Long Xuyên", "", "VN", "704", "", "01", "", "", "10.38639", "105.43518", "Asia/Ho_Chi_Minh"),("1576303", "Lào Cai", "Лаокай", "VN", "704", "", "90", "", "", "22.48556", "103.97066", "Asia/Ho_Chi_Minh"),("1576633", "Thành Phố Lạng Sơn", "", "VN", "704", "", "39", "", "", "21.85264", "106.76101", "Asia/Ho_Chi_Minh"),("1577995", "La Gi", "", "VN", "704", "", "47", "", "", "10.65993", "107.77206", "Asia/Ho_Chi_Minh"),("1578500", "Kon Tum", "", "VN", "704", "", "55", "", "", "14.35451", "108.00759", "Asia/Ho_Chi_Minh"),("1580142", "Hưng Yên", "", "VN", "704", "", "81", "", "", "20.64637", "106.05112", "Asia/Ho_Chi_Minh"),("1580240", "Huế", "Хюэ", "VN", "704", "", "66", "", "", "16.4619", "107.59546", "Asia/Ho_Chi_Minh"),("1580349", "Bình Long", "", "VN", "704", "", "76", "", "", "11.64711", "106.60586", "Asia/Ho_Chi_Minh"),("1580410", "Thành Phố Hạ Long", "Халонг", "VN", "704", "", "30", "", "", "20.95045", "107.07336", "Asia/Ho_Chi_Minh"),("1580541", "Hội An", "Хой", "VN", "704", "", "84", "", "", "15.87944", "108.335", "Asia/Ho_Chi_Minh"),("1580830", "Thành Phố Hòa Bình", "", "VN", "704", "", "53", "", "", "20.81717", "105.33759", "Asia/Ho_Chi_Minh"),("1581047", "Hà Tĩnh", "Хатинь", "VN", "704", "", "52", "", "", "18.34282", "105.90569", "Asia/Ho_Chi_Minh"),("1581052", "Hà Tiên", "Хатьен", "VN", "704", "", "21", "", "", "10.3831", "104.48753", "Asia/Ho_Chi_Minh"),("1581130", "Hanoi", "Ханой", "VN", "704", "", "44", "", "", "21.0245", "105.84117", "Asia/Ho_Chi_Minh"),("1581298", "Haiphong", "Хайфон", "VN", "704", "", "13", "", "", "20.86481", "106.68345", "Asia/Ho_Chi_Minh"),("1581326", "Thành Phố Hải Dương", "Хайзыонг", "VN", "704", "", "79", "", "", "20.94099", "106.33302", "Asia/Ho_Chi_Minh"),("1581349", "Thành Phố Hà Giang", "", "VN", "704", "", "50", "", "", "22.82333", "104.98357", "Asia/Ho_Chi_Minh"),("1581364", "Hà Đông", "", "VN", "704", "", "44", "", "", "20.97136", "105.77876", "Asia/Ho_Chi_Minh"),("1581834", "Gia Nghĩa", "", "VN", "704", "", "91", "", "", "12.00423", "107.69074", "Asia/Ho_Chi_Minh"),("1582173", "Đưc Trọng", "", "VN", "704", "", "23", "", "", "11.73559", "108.3733", "Asia/Ho_Chi_Minh"),("1582436", "Don Luan", "", "VN", "704", "", "76", "", "", "11.53495", "106.88324", "Asia/Ho_Chi_Minh"),("1582886", "Kwang Binh", "Донгхой", "VN", "704", "", "62", "", "", "17.46885", "106.62226", "Asia/Ho_Chi_Minh"),("1582926", "Ðông Hà", "", "VN", "704", "", "64", "", "", "16.81625", "107.10031", "Asia/Ho_Chi_Minh"),("1583477", "Dien Bien Phu", "Дьен Бьен Фу", "VN", "704", "", "92", "", "", "21.38602", "103.02301", "Asia/Ho_Chi_Minh"),("1583992", "Da Nang", "", "VN", "704", "", "78", "", "", "16.06778", "108.22083", "Asia/Ho_Chi_Minh"),("1584071", "Ðà Lạt", "Далат", "VN", "704", "", "23", "", "", "11.94646", "108.44193", "Asia/Ho_Chi_Minh"),("1584661", "Củ Chi", "Ку-Чи", "VN", "704", "", "20", "", "", "10.97333", "106.49325", "Asia/Ho_Chi_Minh"),("1585660", "Cho Dok", "", "VN", "704", "", "01", "", "", "10.7", "105.11667", "Asia/Ho_Chi_Minh"),("1586052", "Cát Bà", "Кат Ба", "VN", "704", "", "13", "", "", "20.72779", "107.04819", "Asia/Ho_Chi_Minh"),("1586151", "Cao Lãnh", "", "VN", "704", "", "09", "", "", "10.46017", "105.63294", "Asia/Ho_Chi_Minh"),("1586185", "Thành Phố Cao Bằng", "Каобанг", "VN", "704", "", "05", "", "", "22.66568", "106.25786", "Asia/Ho_Chi_Minh"),("1586203", "Cần Thơ", "", "VN", "704", "", "87", "", "", "10.03711", "105.78825", "Asia/Ho_Chi_Minh"),("1586288", "Cần Giờ", "", "VN", "704", "", "20", "", "", "10.41115", "106.95474", "Asia/Ho_Chi_Minh"),("1586296", "Cần Giuộc", "", "VN", "704", "", "24", "", "", "10.60857", "106.67135", "Asia/Ho_Chi_Minh"),("1586350", "Cam Ranh", "Камрань", "VN", "704", "", "54", "", "", "11.92144", "109.15913", "Asia/Ho_Chi_Minh"),("1586357", "Cẩm Phả Mines", "", "VN", "704", "", "30", "", "", "21.01667", "107.3", "Asia/Ho_Chi_Minh"),("1586443", "Cà Mau", "Камау", "VN", "704", "", "77", "", "", "9.17682", "105.15242", "Asia/Ho_Chi_Minh"),("1586896", "Buôn Ma Thuột", "", "VN", "704", "", "88", "", "", "12.66747", "108.03775", "Asia/Ho_Chi_Minh"),("1587919", "Bỉm Sơn", "", "VN", "704", "", "34", "", "", "20.07806", "105.86028", "Asia/Ho_Chi_Minh"),("1587923", "Biên Hòa", "", "VN", "704", "", "43", "", "", "10.94469", "106.82432", "Asia/Ho_Chi_Minh"),("1587976", "Bến Tre", "", "VN", "704", "", "03", "", "", "10.24147", "106.37585", "Asia/Ho_Chi_Minh"),("1588275", "Bảo Lộc", "", "VN", "704", "", "23", "1905200", "", "11.54798", "107.80772", "Asia/Ho_Chi_Minh"),("1591449", "Bắc Ninh", "", "VN", "704", "", "74", "", "", "21.18608", "106.07631", "Asia/Ho_Chi_Minh"),("1591474", "Thành phố Bạc Liêu", "", "VN", "704", "", "73", "", "", "9.29414", "105.72776", "Asia/Ho_Chi_Minh"),("1591527", "Bắc Giang", "", "VN", "704", "", "71", "", "", "21.27307", "106.1946", "Asia/Ho_Chi_Minh"),("1591538", "Bắc Kạn", "", "VN", "704", "", "72", "", "", "22.14701", "105.83481", "Asia/Ho_Chi_Minh"),("1592214", "Ấp Tân Ngãi", "", "VN", "704", "VN", "03", "", "", "10.23333", "106.28333", "Asia/Ho_Chi_Minh"),("8340760", "Cung Kiệm", "", "VN", "704", "", "74", "1905415", "", "21.18697", "106.16076", "Asia/Ho_Chi_Minh"),("8456741", "Lai Châu", "", "VN", "704", "", "89", "", "", "22.39644", "103.45824", "Asia/Ho_Chi_Minh"),("8594709", "Thành Phố Bà Rịa", "", "VN", "704", "", "45", "", "", "10.49629", "107.16841", "Asia/Ho_Chi_Minh"),("8991407", "Đinh Văn", "Динь Ван", "VN", "704", "", "23", "", "", "11.78624", "108.24282", "Asia/Ho_Chi_Minh"),("69426", "Zinjibār", "", "YE", "887", "", "01", "1210", "", "13.12871", "45.38073", "Asia/Aden"),("69500", "Zabīd", "Забид", "YE", "887", "", "08", "1824", "", "14.1951", "43.31518", "Asia/Aden"),("69559", "Yarīm", "Ярим", "YE", "887", "", "23", "1102", "", "14.29804", "44.37795", "Asia/Aden"),("70225", "Ta‘izz", "Таиз", "YE", "887", "", "25", "1520", "", "13.57952", "44.02091", "Asia/Aden"),("70979", "Sayyān", "", "YE", "887", "", "16", "2305", "", "15.17177", "44.32442", "Asia/Aden"),("71137", "Sanaa", "Сана", "YE", "887", "", "16", "", "", "15.35472", "44.20667", "Asia/Aden"),("71273", "Saḩar", "", "YE", "887", "", "16", "2305", "", "15.31586", "44.30858", "Asia/Aden"),("71334", "Sa'dah", "", "YE", "887", "", "15", "2215", "", "16.94021", "43.76393", "Asia/Aden"),("72968", "Ma'rib", "Мариб", "YE", "887", "", "14", "2612", "", "15.46253", "45.32581", "Asia/Aden"),("73560", "Laḩij", "Лахыдж", "YE", "887", "", "24", "2514", "", "13.05667", "44.88194", "Asia/Aden"),("74219", "Jawf al Maqbābah", "", "YE", "887", "", "01", "1204", "", "13.83783", "45.83488", "Asia/Aden"),("74477", "Ibb", "", "YE", "887", "", "23", "1118", "", "13.96667", "44.18333", "Asia/Aden"),("75337", "Ḩajjah", "Хадж", "YE", "887", "", "22", "1728", "", "15.69425", "43.60582", "Asia/Aden"),("75427", "Hadibu", "", "YE", "887", "", "28", "1926", "", "12.64881", "54.01895", "Asia/Aden"),("76154", "Dhī as Sufāl", "", "YE", "887", "", "23", "1116", "", "13.83446", "44.11469", "Asia/Aden"),("76184", "Dhamār", "", "YE", "887", "", "11", "2008", "", "14.54274", "44.40514", "Asia/Aden"),("76991", "Bayt al Faqīh", "", "YE", "887", "", "08", "1817", "", "14.51635", "43.32446", "Asia/Aden"),("77408", "Bājil", "", "YE", "887", "", "08", "1810", "", "15.05898", "43.28731", "Asia/Aden"),("77726", "Ataq", "", "YE", "887", "", "05", "2113", "", "14.53767", "46.83187", "Asia/Aden"),("78428", "‘Amrān", "", "YE", "887", "", "19", "2915", "", "15.6594", "43.94385", "Asia/Aden"),("78754", "Al Mukallā", "Аль-Мукалла", "YE", "887", "", "04", "1929", "", "14.54248", "49.12424", "Asia/Aden"),("78977", "Al Maḩwīt", "", "YE", "887", "", "10", "2708", "", "15.47007", "43.54481", "Asia/Aden"),("79415", "Al Ḩudaydah", "", "YE", "887", "", "08", "1821", "", "14.79781", "42.95452", "Asia/Aden"),("79455", "Al Ḩazm", "", "YE", "887", "", "21", "1605", "", "16.16406", "44.77692", "Asia/Aden"),("79700", "Al Ghayz̧ah", "", "YE", "887", "", "03", "2804", "", "16.20787", "52.17605", "Asia/Aden"),("79836", "Al Bayḑā’", "", "YE", "887", "", "20", "1409", "", "13.98523", "45.57272", "Asia/Aden"),("80384", "Dhalie", "", "YE", "887", "", "18", "3006", "", "13.69572", "44.73137", "Asia/Aden"),("401043", "Al Jabīn", "", "YE", "887", "", "27", "3102", "", "14.70389", "43.59917", "Asia/Aden"),("415189", "Aden", "Аден", "YE", "887", "", "02", "2407", "", "12.77944", "45.03667", "Asia/Aden"),("936374", "Roodepoort", "", "ZA", "710", "ZA", "06", "JHB", "JHB", "-26.1625", "27.8725", "Africa/Johannesburg"),("937136", "Zeerust", "", "ZA", "710", "", "10", "DC38", "NW385", "-25.53695", "26.07512", "Africa/Johannesburg"),("937246", "Zastron", "", "ZA", "710", "", "03", "DC16", "FS163", "-30.30225", "27.08395", "Africa/Johannesburg"),("938457", "Wolmaransstad", "", "ZA", "710", "", "10", "DC40", "NW404", "-27.1974", "25.98311", "Africa/Johannesburg"),("938694", "White River", "", "ZA", "710", "", "07", "DC32", "MP322", "-25.33177", "31.01166", "Africa/Johannesburg"),("939270", "Witbank", "", "ZA", "710", "", "07", "DC31", "MP312", "-25.87133", "29.23323", "Africa/Johannesburg"),("939608", "Winburg", "", "ZA", "710", "", "03", "DC18", "FS181", "-28.51805", "27.00933", "Africa/Johannesburg"),("939676", "Willowmore", "", "ZA", "710", "", "05", "DC10", "EC107", "-33.29265", "23.48954", "Africa/Johannesburg"),("940186", "Whittlesea", "", "ZA", "710", "", "05", "DC13", "EC134", "-32.17588", "26.82437", "Africa/Johannesburg"),("940316", "Westonaria", "Вестонария", "ZA", "710", "", "06", "DC48", "GT483", "-26.31905", "27.6486", "Africa/Johannesburg"),("940424", "Wesselsbron", "", "ZA", "710", "", "03", "DC18", "FS185", "-27.8549", "26.36583", "Africa/Johannesburg"),("940909", "Welkom", "", "ZA", "710", "", "03", "DC18", "FS184", "-27.97742", "26.73506", "Africa/Johannesburg"),("941931", "Warrenton", "", "ZA", "710", "", "08", "DC9", "NC093", "-28.11396", "24.84753", "Africa/Johannesburg"),("941966", "Warmbaths", "", "ZA", "710", "", "09", "DC36", "LIM366", "-24.88333", "28.28333", "Africa/Johannesburg"),("942470", "Vryheid", "", "ZA", "710", "", "02", "DC26", "KZN263", "-27.76952", "30.79165", "Africa/Johannesburg"),("942511", "Vryburg", "Фрейбурга", "ZA", "710", "", "10", "DC39", "NW392", "-26.95659", "24.7284", "Africa/Johannesburg"),("942683", "Vredefort", "", "ZA", "710", "", "03", "DC20", "FS203", "-27.00805", "27.3646", "Africa/Johannesburg"),("942701", "Vrede", "", "ZA", "710", "", "03", "DC19", "FS195", "-27.42573", "29.16585", "Africa/Johannesburg"),("943032", "Volksrust", "", "ZA", "710", "", "07", "DC30", "MP304", "-27.36541", "29.88175", "Africa/Johannesburg"),("943882", "Virginia", "Вирджиния", "ZA", "710", "", "03", "DC18", "FS184", "-28.10391", "26.86593", "Africa/Johannesburg"),("943937", "Villiers", "", "ZA", "710", "", "03", "DC20", "FS205", "-27.03026", "28.60061", "Africa/Johannesburg"),("943960", "Viljoenskroon", "", "ZA", "710", "", "03", "DC20", "FS201", "-27.20841", "26.94855", "Africa/Johannesburg"),("944385", "Vereeniging", "Феринихинг", "ZA", "710", "", "06", "DC42", "GT421", "-26.67313", "27.92615", "Africa/Johannesburg"),("944540", "Ventersburg", "", "ZA", "710", "", "03", "DC18", "FS184", "-28.08561", "27.13814", "Africa/Johannesburg"),("944986", "Vanderbijlpark", "", "ZA", "710", "", "06", "DC42", "GT421", "-26.71171", "27.83795", "Africa/Johannesburg"),("945945", "Upington", "Апингтон", "ZA", "710", "", "08", "DC8", "NC083", "-28.44776", "21.25612", "Africa/Johannesburg"),("946058", "Mthatha", "Умтата", "ZA", "710", "", "05", "DC15", "EC157", "-31.58893", "28.78443", "Africa/Johannesburg"),("946128", "Umkomaas", "", "ZA", "710", "", "02", "ETH", "ETH", "-30.20674", "30.79776", "Africa/Johannesburg"),("946257", "Ulundi", "Улунди", "ZA", "710", "", "02", "DC26", "KZN266", "-28.33523", "31.41617", "Africa/Johannesburg"),("946877", "Uitenhage", "", "ZA", "710", "", "05", "NMA", "NMA", "-33.75757", "25.3971", "Africa/Johannesburg"),("946973", "Tzaneen", "", "ZA", "710", "", "09", "DC33", "LIM333", "-23.83322", "30.16351", "Africa/Johannesburg"),("949026", "Thulamahashi", "", "ZA", "710", "", "09", "", "", "-24.72459", "31.19939", "Africa/Johannesburg"),("949224", "Thohoyandou", "", "ZA", "710", "", "09", "DC34", "LIM343", "-22.94564", "30.48497", "Africa/Johannesburg"),("949282", "Theunissen", "Тениссен", "ZA", "710", "", "03", "DC18", "FS181", "-28.41098", "26.70107", "Africa/Johannesburg"),("949683", "Thabazimbi", "", "ZA", "710", "", "09", "DC36", "LIM361", "-24.59165", "27.41155", "Africa/Johannesburg"),("949703", "Thaba Nchu", "", "ZA", "710", "", "03", "MAN", "MAN", "-29.20932", "26.83898", "Africa/Johannesburg"),("949880", "Tembisa", "", "ZA", "710", "", "06", "EKU", "EKU", "-25.99636", "28.2268", "Africa/Johannesburg"),("950709", "Swellendam", "", "ZA", "710", "", "11", "DC3", "WC034", "-34.02262", "20.44171", "Africa/Johannesburg"),("951441", "Sundumbili", "", "ZA", "710", "", "02", "DC29", "KZN291", "-29.13371", "31.39752", "Africa/Johannesburg"),("951650", "Stutterheim", "", "ZA", "710", "", "05", "DC12", "EC124", "-32.57076", "27.42396", "Africa/Johannesburg"),("952192", "Stilfontein", "", "ZA", "710", "", "10", "DC40", "NW403", "-26.84493", "26.76829", "Africa/Johannesburg"),("952734", "Stanger", "", "ZA", "710", "", "02", "DC29", "KZN292", "-29.32816", "31.28954", "Africa/Johannesburg"),("952747", "Standerton", "", "ZA", "710", "", "07", "DC30", "MP305", "-26.93366", "29.24152", "Africa/Johannesburg"),("952865", "Springs", "", "ZA", "710", "", "06", "EKU", "EKU", "-26.25", "28.4", "Africa/Johannesburg"),("953781", "Soweto", "Соуэто", "ZA", "710", "", "06", "JHB", "JHB", "-26.26781", "27.85849", "Africa/Johannesburg"),("954161", "Somerset East", "", "ZA", "710", "", "05", "DC10", "EC102", "-32.72173", "25.58804", "Africa/Johannesburg"),("955313", "Siyabuswa", "", "ZA", "710", "", "07", "DC31", "MP316", "-25.11319", "29.04454", "Africa/Johannesburg"),("956507", "Senekal", "", "ZA", "710", "", "03", "DC19", "FS191", "-28.31971", "27.62082", "Africa/Johannesburg"),("956767", "Secunda", "Секунда", "ZA", "710", "", "07", "DC30", "MP307", "-26.55", "29.16667", "Africa/Johannesburg"),("956878", "Scottburgh", "", "ZA", "710", "", "02", "DC21", "KZN212", "-30.28666", "30.75316", "Africa/Johannesburg"),("956907", "Schweizer-Reneke", "", "ZA", "710", "", "10", "DC39", "NW393", "-27.18871", "25.32931", "Africa/Johannesburg"),("957487", "Sasolburg", "", "ZA", "710", "", "03", "DC20", "FS204", "-26.81358", "27.81695", "Africa/Johannesburg"),("958724", "Rustenburg", "Рюстенбург", "ZA", "710", "", "10", "DC37", "NW373", "-25.66756", "27.24208", "Africa/Johannesburg"),("961152", "Riversdale", "", "ZA", "710", "", "11", "DC4", "WC042", "-34.09345", "21.25725", "Africa/Johannesburg"),("961226", "Ritchie", "", "ZA", "710", "", "08", "DC9", "NC091", "-29.03801", "24.60278", "Africa/Johannesburg"),("962330", "Richmond", "", "ZA", "710", "", "02", "DC22", "KZN227", "-29.87196", "30.27235", "Africa/Johannesburg"),("962367", "Richards Bay", "Ричардс-Бей", "ZA", "710", "", "02", "DC28", "KZN282", "-28.78301", "32.03768", "Africa/Johannesburg"),("962847", "Reitz", "", "ZA", "710", "", "03", "DC19", "FS193", "-27.80138", "28.42726", "Africa/Johannesburg"),("963230", "Randfontein", "", "ZA", "710", "", "06", "DC48", "GT482", "-26.1844", "27.70203", "Africa/Johannesburg"),("963516", "Queenstown", "Квинстаун", "ZA", "710", "", "05", "DC13", "EC134", "-31.89756", "26.87533", "Africa/Johannesburg"),("963525", "Queensdale", "", "ZA", "710", "", "05", "DC13", "EC134", "-31.87101", "26.97862", "Africa/Johannesburg"),("964078", "Prince Albert", "", "ZA", "710", "", "11", "DC5", "WC052", "-33.22476", "22.02673", "Africa/Johannesburg"),("964090", "Prieska", "", "ZA", "710", "", "08", "DC7", "NC077", "-29.66803", "22.74251", "Africa/Johannesburg"),("964137", "Pretoria", "Претория", "ZA", "710", "", "06", "TSH", "TSH", "-25.74486", "28.18783", "Africa/Johannesburg"),("964315", "Mokopane", "Потгитерсрус", "ZA", "710", "", "09", "DC36", "LIM367", "-24.19436", "29.00974", "Africa/Johannesburg"),("964349", "Potchefstroom", "Почефструм", "ZA", "710", "", "10", "DC40", "NW402", "-26.71667", "27.1", "Africa/Johannesburg"),("964406", "Port Shepstone", "", "ZA", "710", "", "02", "DC21", "KZN216", "-30.74137", "30.45499", "Africa/Johannesburg"),("964408", "Port Saint John’s", "", "ZA", "710", "", "05", "DC15", "EC154", "-31.62291", "29.54477", "Africa/Johannesburg"),("964420", "Port Elizabeth", "Порт-Элизабет", "ZA", "710", "", "05", "NMA", "NMA", "-33.91799", "25.57007", "Africa/Johannesburg"),("964432", "Port Alfred", "", "ZA", "710", "", "05", "DC10", "EC105", "-33.58601", "26.88329", "Africa/Johannesburg"),("964712", "Plettenberg Bay", "", "ZA", "710", "", "11", "DC4", "WC047", "-34.05274", "23.3716", "Africa/Johannesburg"),("965241", "Piet Retief", "", "ZA", "710", "", "07", "DC30", "MP303", "-27.00706", "30.81323", "Africa/Johannesburg"),("965289", "Polokwane", "Полокване", "ZA", "710", "", "09", "DC35", "LIM354", "-23.90449", "29.46885", "Africa/Johannesburg"),("965301", "Pietermaritzburg", "Питермарицбург", "ZA", "710", "", "02", "DC22", "KZN225", "-29.61679", "30.39278", "Africa/Johannesburg"),("965401", "Phuthaditjhaba", "", "ZA", "710", "", "03", "DC19", "FS194", "-28.52423", "28.81582", "Africa/Johannesburg"),("965528", "Phalaborwa", "Палаборва", "ZA", "710", "", "09", "DC33", "LIM334", "-23.94299", "31.14107", "Africa/Johannesburg"),("966166", "Parys", "Парис", "ZA", "710", "", "03", "DC20", "FS203", "-26.9033", "27.45727", "Africa/Johannesburg"),("966380", "Pampierstad", "", "ZA", "710", "", "08", "DC9", "NC094", "-27.78324", "24.68768", "Africa/Johannesburg"),("967106", "Oudtshoorn", "", "ZA", "710", "", "11", "DC4", "WC045", "-33.60047", "22.19955", "Africa/Johannesburg"),("967476", "Orkney", "Оркнейские", "ZA", "710", "", "10", "DC40", "NW403", "-26.98023", "26.67272", "Africa/Johannesburg"),("967580", "Orange Farm", "", "ZA", "710", "", "06", "JHB", "JHB", "-26.48333", "27.86667", "Africa/Johannesburg"),("968665", "Modimolle", "", "ZA", "710", "", "09", "DC36", "LIM365", "-24.7", "28.4", "Africa/Johannesburg"),("970341", "Nkowakowa", "", "ZA", "710", "", "09", "DC33", "LIM333", "-23.88782", "30.28708", "Africa/Johannesburg"),("970566", "Nigel", "Найджел", "ZA", "710", "", "06", "EKU", "EKU", "-26.43138", "28.47713", "Africa/Johannesburg"),("971421", "Newcastle", "", "ZA", "710", "", "02", "DC25", "KZN252", "-27.75796", "29.9318", "Africa/Johannesburg"),("971534", "Nelspruit", "Мбомбела", "ZA", "710", "", "07", "DC32", "MP322", "-25.47448", "30.97033", "Africa/Johannesburg"),("973111", "Mpumalanga", "", "ZA", "710", "", "02", "ETH", "ETH", "-29.81292", "30.63646", "Africa/Johannesburg"),("973139", "Mpophomeni", "", "ZA", "710", "", "02", "DC22", "KZN222", "-29.56822", "30.18618", "Africa/Johannesburg"),("973709", "Mossel Bay", "Моссел-Бей", "ZA", "710", "", "11", "DC4", "WC043", "-34.18307", "22.14605", "Africa/Johannesburg"),("974222", "Mooirivier", "", "ZA", "710", "", "02", "DC22", "KZN223", "-29.20824", "29.9946", "Africa/Johannesburg"),("974670", "Mondlo", "", "ZA", "710", "", "02", "DC26", "KZN263", "-27.98299", "30.71769", "Africa/Johannesburg"),("974719", "Molteno", "", "ZA", "710", "", "05", "DC13", "EC133", "-31.39675", "26.36246", "Africa/Johannesburg"),("975436", "Mmabatho", "", "ZA", "710", "", "10", "DC38", "NW383", "-25.85", "25.63333", "Africa/Johannesburg"),("976358", "Middelburg", "", "ZA", "710", "", "05", "DC13", "EC131", "-31.49285", "25.00633", "Africa/Johannesburg"),("976361", "Middelburg", "", "ZA", "710", "", "07", "DC31", "MP313", "-25.77507", "29.46482", "Africa/Johannesburg"),("978677", "Marquard", "", "ZA", "710", "", "03", "DC19", "FS191", "-28.66449", "27.43048", "Africa/Johannesburg"),("978895", "Margate", "", "ZA", "710", "", "02", "DC21", "KZN216", "-30.8636", "30.37052", "Africa/Johannesburg"),("979365", "Mankoeng", "", "ZA", "710", "", "09", "DC35", "LIM354", "-23.9", "29.81667", "Africa/Johannesburg"),("980595", "Mahikeng", "", "ZA", "710", "", "10", "DC38", "NW383", "-25.86522", "25.64421", "Africa/Johannesburg"),("980921", "Mabopane", "", "ZA", "710", "", "06", "TSH", "TSH", "-25.49768", "28.10065", "Africa/Johannesburg"),("981158", "Lydenburg", "", "ZA", "710", "", "07", "DC32", "MP321", "-25.09598", "30.44393", "Africa/Johannesburg"),("981827", "Louis Trichardt", "", "ZA", "710", "", "09", "DC34", "LIM344", "-23.04385", "29.90319", "Africa/Johannesburg"),("982899", "Lichtenburg", "Лихтенбурге", "ZA", "710", "", "10", "DC38", "NW384", "-26.152", "26.15968", "Africa/Johannesburg"),("984087", "Lebowakgomo", "", "ZA", "710", "", "09", "DC35", "LIM354", "-24.2", "29.5", "Africa/Johannesburg"),("985011", "Lady Frere", "", "ZA", "710", "", "05", "DC13", "EC136", "-31.70312", "27.2329", "Africa/Johannesburg"),("985015", "Ladybrand", "", "ZA", "710", "", "03", "DC19", "FS196", "-29.19448", "27.45739", "Africa/Johannesburg"),("985020", "Ladismith", "", "ZA", "710", "", "11", "DC4", "WC041", "-33.49331", "21.26755", "Africa/Johannesburg"),("986083", "Kutloanong", "", "ZA", "710", "", "03", "DC18", "FS184", "-27.83333", "26.75", "Africa/Johannesburg"),("986134", "Kuruman", "", "ZA", "710", "", "08", "DC45", "NC452", "-27.4524", "23.43246", "Africa/Johannesburg"),("986717", "Kruisfontein", "", "ZA", "710", "", "05", "DC10", "EC108", "-34.00333", "24.73142", "Africa/Johannesburg"),("986822", "Krugersdorp", "Крюгерсдорпа", "ZA", "710", "", "06", "DC48", "GT481", "-26.08577", "27.77515", "Africa/Johannesburg"),("986846", "Kroonstad", "", "ZA", "710", "", "03", "DC20", "FS201", "-27.65036", "27.23488", "Africa/Johannesburg"),("987202", "Kriel", "", "ZA", "710", "", "07", "DC31", "MP312", "-26.27391", "29.2253", "Africa/Johannesburg"),("987648", "Koster", "", "ZA", "710", "", "10", "DC37", "NW374", "-25.86301", "26.89756", "Africa/Johannesburg"),("987875", "Koppies", "", "ZA", "710", "", "03", "DC20", "FS203", "-27.24179", "27.57422", "Africa/Johannesburg"),("988290", "Komatipoort", "", "ZA", "710", "", "07", "DC32", "MP324", "-25.43321", "31.95478", "Africa/Johannesburg"),("988356", "Kokstad", "", "ZA", "710", "", "02", "DC43", "KZN433", "-30.54723", "29.42412", "Africa/Johannesburg"),("988698", "Knysna", "Найсна", "ZA", "710", "", "11", "DC4", "WC048", "-34.03627", "23.04713", "Africa/Johannesburg"),("989921", "Klerksdorp", "Клерксдорп", "ZA", "710", "", "10", "DC40", "NW403", "-26.85213", "26.66672", "Africa/Johannesburg"),("990802", "Kirkwood", "", "ZA", "710", "", "05", "DC10", "EC106", "-33.39829", "25.44279", "Africa/Johannesburg"),("990930", "Kimberley", "Кимберли", "ZA", "710", "", "08", "DC9", "NC091", "-28.73226", "24.76232", "Africa/Johannesburg"),("991664", "Kathu", "", "ZA", "710", "", "08", "DC45", "NC453", "-27.69569", "23.04929", "Africa/Johannesburg"),("993800", "Johannesburg", "Йоханнесбург", "ZA", "710", "", "06", "JHB", "JHB", "-26.20227", "28.04363", "Africa/Johannesburg"),("993911", "Jeffrey’s Bay", "", "ZA", "710", "", "05", "DC10", "EC108", "-34.05045", "24.90768", "Africa/Johannesburg"),("994023", "Jan Kempdorp", "", "ZA", "710", "", "10", "", "", "-27.92246", "24.83051", "Africa/Johannesburg"),("994939", "Ilinge", "", "ZA", "710", "", "05", "DC13", "EC134", "-31.97676", "27.04267", "Africa/Johannesburg"),("995202", "Howick", "", "ZA", "710", "", "02", "DC22", "KZN222", "-29.47795", "30.23057", "Africa/Johannesburg"),("995573", "Hoopstad", "", "ZA", "710", "", "03", "DC18", "FS183", "-27.83273", "25.90833", "Africa/Johannesburg"),("996918", "Hennenman", "", "ZA", "710", "", "03", "DC18", "FS184", "-27.97654", "27.02423", "Africa/Johannesburg"),("996930", "Hendrina", "", "ZA", "710", "", "07", "DC31", "MP313", "-26.15881", "29.71528", "Africa/Johannesburg"),("997140", "Heilbron", "", "ZA", "710", "", "03", "DC20", "FS203", "-27.28115", "27.9709", "Africa/Johannesburg"),("997151", "Heidelberg", "Гейдельберг", "ZA", "710", "", "06", "DC42", "GT423", "-26.50476", "28.35921", "Africa/Johannesburg"),("997751", "Harrismith", "", "ZA", "710", "", "03", "DC19", "FS194", "-28.27276", "29.12946", "Africa/Johannesburg"),("1000006", "Greytown", "", "ZA", "710", "", "02", "DC24", "KZN245", "-29.06415", "30.59279", "Africa/Johannesburg"),("1000501", "Grahamstown", "Грэхэмстаун", "ZA", "710", "", "05", "DC10", "EC104", "-33.30422", "26.53276", "Africa/Johannesburg"),("1000543", "Graaff-Reinet", "Храфф-Рейнет", "ZA", "710", "", "05", "DC10", "EC101", "-32.25215", "24.53075", "Africa/Johannesburg"),("1001736", "Glencoe", "", "ZA", "710", "", "02", "DC24", "KZN241", "-28.17827", "30.14702", "Africa/Johannesburg"),("1001860", "Giyani", "", "ZA", "710", "", "09", "DC33", "LIM331", "-23.30246", "30.71868", "Africa/Johannesburg"),("1002145", "George", "Джордж", "ZA", "710", "", "11", "DC4", "WC044", "-33.963", "22.46173", "Africa/Johannesburg"),("1002851", "Ga-Rankuwa", "", "ZA", "710", "", "10", "", "", "-25.61692", "27.99471", "Africa/Johannesburg"),("1003462", "Ga-Kgapane", "", "ZA", "710", "", "09", "DC33", "LIM332", "-23.64378", "30.22324", "Africa/Johannesburg"),("1003953", "Fort Beaufort", "", "ZA", "710", "", "05", "DC12", "EC127", "-32.77477", "26.63376", "Africa/Johannesburg"),("1004109", "Fochville", "", "ZA", "710", "", "10", "", "", "-26.48862", "27.49387", "Africa/Johannesburg"),("1005029", "eSikhawini", "", "ZA", "710", "", "02", "DC28", "KZN282", "-28.87097", "31.89961", "Africa/Johannesburg"),("1005040", "Eshowe", "", "ZA", "710", "", "02", "DC28", "KZN284", "-28.88649", "31.4699", "Africa/Johannesburg"),("1005125", "Ermelo", "Эрмело", "ZA", "710", "", "07", "DC30", "MP302", "-26.53333", "29.98333", "Africa/Johannesburg"),("1005544", "Empangeni", "", "ZA", "710", "", "02", "DC28", "KZN282", "-28.76197", "31.89329", "Africa/Johannesburg"),("1005646", "eMbalenhle", "", "ZA", "710", "", "07", "DC30", "MP307", "-26.53333", "29.06667", "Africa/Johannesburg"),("1005781", "Elliot", "", "ZA", "710", "", "05", "DC13", "EC138", "-31.33333", "27.85", "Africa/Johannesburg"),("1006420", "Ekuvukeni", "", "ZA", "710", "", "02", "DC23", "KZN233", "-28.46752", "30.15513", "Africa/Johannesburg"),("1006834", "Edenvale", "", "ZA", "710", "", "06", "EKU", "EKU", "-26.14095", "28.15247", "Africa/Johannesburg"),("1006984", "East London", "Ист-Лондон", "ZA", "710", "ZA", "05", "BUF", "BUF", "-33.01529", "27.91162", "Africa/Johannesburg"),("1007311", "Durban", "Дурбан", "ZA", "710", "", "02", "ETH", "ETH", "-29.8579", "31.0292", "Africa/Johannesburg"),("1007400", "Dundee", "Данди", "ZA", "710", "", "02", "DC24", "KZN241", "-28.16678", "30.23371", "Africa/Johannesburg"),("1007514", "Duiwelskloof", "", "ZA", "710", "", "09", "DC33", "LIM332", "-23.69339", "30.14002", "Africa/Johannesburg"),("1008261", "Driefontein", "", "ZA", "710", "", "07", "DC30", "MP303", "-27.0177", "30.44979", "Africa/Johannesburg"),("1008858", "Dordrecht", "", "ZA", "710", "", "05", "DC13", "EC136", "-31.372", "27.04878", "Africa/Johannesburg"),("1010962", "Deneysville", "", "ZA", "710", "", "03", "DC20", "FS204", "-26.8908", "28.09707", "Africa/Johannesburg"),("1011031", "Delmas", "Дельмас", "ZA", "710", "", "07", "DC31", "MP311", "-26.1466", "28.68322", "Africa/Johannesburg"),("1011632", "De Aar", "", "ZA", "710", "", "08", "DC7", "NC073", "-30.64966", "24.0123", "Africa/Johannesburg"),("1011918", "Daniëlskuil", "", "ZA", "710", "", "08", "DC8", "NC086", "-28.18873", "23.53951", "Africa/Johannesburg"),("1012413", "Cullinan", "Куллинан", "ZA", "710", "", "06", "TSH", "TSH", "-25.67088", "28.52364", "Africa/Johannesburg"),("1012600", "Cradock", "", "ZA", "710", "", "05", "DC13", "EC131", "-32.16422", "25.61918", "Africa/Johannesburg"),("1013076", "Colesberg", "", "ZA", "710", "", "08", "DC7", "NC072", "-30.71999", "25.09718", "Africa/Johannesburg"),("1013266", "Clocolan", "", "ZA", "710", "", "03", "DC19", "FS191", "-28.91367", "27.56555", "Africa/Johannesburg"),("1013550", "Christiana", "", "ZA", "710", "", "10", "DC39", "NW396", "-27.91402", "25.16111", "Africa/Johannesburg"),("1014034", "Carnarvon", "", "ZA", "710", "", "08", "DC7", "NC074", "-30.96827", "22.13303", "Africa/Johannesburg"),("1014073", "Carletonville", "", "ZA", "710", "", "06", "DC48", "GT484", "-26.36094", "27.39767", "Africa/Johannesburg"),("1014489", "Butterworth", "Баттерворта", "ZA", "710", "", "05", "DC12", "EC122", "-32.33083", "28.14981", "Africa/Johannesburg"),("1014653", "Burgersdorp", "", "ZA", "710", "", "05", "DC14", "EC144", "-30.99766", "26.32862", "Africa/Johannesburg"),("1015504", "Bronkhorstspruit", "", "ZA", "710", "", "06", "TSH", "TSH", "-25.81015", "28.74248", "Africa/Johannesburg"),("1015621", "Brits", "Британцы", "ZA", "710", "", "10", "DC37", "NW372", "-25.63473", "27.78022", "Africa/Johannesburg"),("1015694", "Breyten", "", "ZA", "710", "", "07", "DC30", "MP302", "-26.30176", "29.98696", "Africa/Johannesburg"),("1015776", "Bredasdorp", "", "ZA", "710", "", "11", "DC3", "WC033", "-34.53215", "20.04031", "Africa/Johannesburg"),("1015969", "Brandfort", "", "ZA", "710", "", "03", "DC18", "FS181", "-28.70008", "26.45968", "Africa/Johannesburg"),("1016181", "Brakpan", "", "ZA", "710", "", "06", "EKU", "EKU", "-26.23656", "28.36938", "Africa/Johannesburg"),("1016670", "Botshabelo", "", "ZA", "710", "", "03", "MAN", "MAN", "-29.26737", "26.72595", "Africa/Johannesburg"),("1016698", "Bothaville", "Ботавилль", "ZA", "710", "", "03", "DC18", "FS185", "-27.3887", "26.61701", "Africa/Johannesburg"),("1017780", "Boksburg", "", "ZA", "710", "", "06", "EKU", "EKU", "-26.21197", "28.25958", "Africa/Johannesburg"),("1018673", "Bloemhof", "", "ZA", "710", "", "10", "DC39", "NW396", "-27.64685", "25.60697", "Africa/Johannesburg"),("1018725", "Bloemfontein", "Блумфонтейн", "ZA", "710", "", "03", "MAN", "MAN", "-29.12107", "26.214", "Africa/Johannesburg"),("1019330", "Bhisho", "Бишо", "ZA", "710", "", "05", "BUF", "BUF", "-32.84721", "27.44218", "Africa/Johannesburg"),("1019704", "Bethlehem", "Вифлеем", "ZA", "710", "", "03", "DC19", "FS192", "-28.23078", "28.30707", "Africa/Johannesburg"),("1019760", "Bethal", "", "ZA", "710", "", "07", "DC30", "MP307", "-26.45794", "29.46553", "Africa/Johannesburg"),("1020066", "Berea", "", "ZA", "710", "", "02", "ETH", "ETH", "-29.85185", "30.99337", "Africa/Johannesburg"),("1020098", "Benoni", "Бенони", "ZA", "710", "", "06", "EKU", "EKU", "-26.18848", "28.32078", "Africa/Johannesburg"),("1020340", "Belfast", "", "ZA", "710", "", "07", "DC31", "MP314", "-25.68991", "30.03504", "Africa/Johannesburg"),("1020641", "Beaufort West", "", "ZA", "710", "", "11", "DC5", "WC053", "-32.35671", "22.58295", "Africa/Johannesburg"),("1021040", "Barkly West", "", "ZA", "710", "", "08", "DC9", "NC092", "-28.53537", "24.52151", "Africa/Johannesburg"),("1021086", "Barberton", "", "ZA", "710", "", "07", "DC32", "MP323", "-25.78842", "31.05319", "Africa/Johannesburg"),("1021360", "Ballito", "", "ZA", "710", "", "02", "DC29", "KZN292", "-29.53897", "31.21439", "Africa/Johannesburg"),("1021396", "Balfour", "Бальфур", "ZA", "710", "", "07", "DC30", "MP306", "-26.66331", "28.59016", "Africa/Johannesburg"),("1023287", "Allanridge", "", "ZA", "710", "", "03", "DC18", "FS184", "-27.75431", "26.64382", "Africa/Johannesburg"),("1023309", "Aliwal North", "", "ZA", "710", "", "05", "DC14", "EC143", "-30.69366", "26.71141", "Africa/Johannesburg"),("1023332", "Alice", "", "ZA", "710", "", "05", "DC12", "EC127", "-32.78749", "26.8344", "Africa/Johannesburg"),("1023445", "Albertina", "", "ZA", "710", "", "11", "DC4", "WC042", "-34.20544", "21.58001", "Africa/Johannesburg"),("1023656", "Adelaide", "", "ZA", "710", "", "05", "DC12", "EC128", "-32.70747", "26.29564", "Africa/Johannesburg"),("1105726", "Ekangala", "", "ZA", "710", "", "06", "TSH", "TSH", "-25.69619", "28.74918", "Africa/Johannesburg"),("1105776", "Midrand", "Мидранд", "ZA", "710", "", "06", "JHB", "JHB", "-25.98953", "28.12843", "Africa/Johannesburg"),("1105777", "Centurion", "Центурион", "ZA", "710", "", "06", "TSH", "TSH", "-25.85891", "28.18577", "Africa/Johannesburg"),("3359041", "Worcester", "Вустер", "ZA", "710", "", "11", "DC2", "WC025", "-33.64651", "19.44852", "Africa/Johannesburg"),("3359510", "Wellington", "", "ZA", "710", "", "11", "DC2", "WC023", "-33.63981", "19.0112", "Africa/Johannesburg"),("3359736", "Vredendal", "", "ZA", "710", "", "11", "DC1", "WC011", "-31.66833", "18.50119", "Africa/Johannesburg"),("3361025", "Stellenbosch", "Стелленбос", "ZA", "710", "", "11", "DC2", "WC024", "-33.93462", "18.86676", "Africa/Johannesburg"),("3361142", "Springbok", "", "ZA", "710", "", "08", "DC6", "NC062", "-29.66434", "17.8865", "Africa/Johannesburg"),("3361934", "Saldanha", "Салдана", "ZA", "710", "", "11", "DC1", "WC014", "-33.01167", "17.9442", "Africa/Johannesburg"),("3362024", "Rosebank", "", "ZA", "710", "", "11", "CPT", "CPT", "-33.95556", "18.47417", "Africa/Johannesburg"),("3362349", "Robertson", "", "ZA", "710", "", "11", "DC2", "WC026", "-33.80342", "19.88537", "Africa/Johannesburg"),("3363094", "Paarl", "", "ZA", "710", "", "11", "DC2", "WC023", "-33.73378", "18.97523", "Africa/Johannesburg"),("3364346", "Malmesbury", "", "ZA", "710", "", "11", "DC1", "WC015", "-33.4608", "18.72714", "Africa/Johannesburg"),("3364682", "Lansdowne", "", "ZA", "710", "", "11", "CPT", "CPT", "-33.98735", "18.49746", "Africa/Johannesburg"),("3365083", "Kraaifontein", "", "ZA", "710", "", "11", "CPT", "CPT", "-33.84808", "18.71723", "Africa/Johannesburg"),("3366880", "Hermanus", "", "ZA", "710", "", "11", "DC3", "WC032", "-34.4187", "19.23446", "Africa/Johannesburg"),("3367513", "Grabouw", "", "ZA", "710", "", "11", "DC3", "WC031", "-34.15152", "19.01509", "Africa/Johannesburg"),("3369056", "Constantia", "", "ZA", "710", "", "11", "CPT", "CPT", "-34.03139", "18.41833", "Africa/Johannesburg"),("3369098", "Claremont", "", "ZA", "710", "", "11", "CPT", "CPT", "-33.98056", "18.46528", "Africa/Johannesburg"),("3369129", "Ceres", "Церера", "ZA", "710", "", "11", "DC2", "WC022", "-33.36889", "19.31095", "Africa/Johannesburg"),("3369157", "Cape Town", "Кейптаун", "ZA", "710", "", "11", "CPT", "CPT", "-33.92584", "18.42322", "Africa/Johannesburg"),("3369174", "Calvinia", "", "ZA", "710", "", "08", "DC6", "NC065", "-31.47069", "19.77601", "Africa/Johannesburg"),("3370352", "Atlantis", "Атлантида", "ZA", "710", "", "11", "CPT", "CPT", "-33.56668", "18.48335", "Africa/Johannesburg"),("7302797", "Eden Glen", "", "ZA", "710", "", "06", "EKU", "EKU", "-26.1323", "28.16859", "Africa/Johannesburg"),("7302802", "Rondebosch", "", "ZA", "710", "", "11", "CPT", "CPT", "-33.96333", "18.47639", "Africa/Johannesburg"),("7506857", "Newlands", "", "ZA", "710", "", "11", "CPT", "CPT", "-33.97846", "18.4481", "Africa/Johannesburg"),("8030233", "Midstream", "", "ZA", "710", "", "06", "EKU", "EKU", "-25.91849", "28.19881", "Africa/Johannesburg"),("8604596", "Retreat", "", "ZA", "710", "", "11", "CPT", "CPT", "-34.05515", "18.47617", "Africa/Johannesburg"),("8764562", "Diepsloot", "", "ZA", "710", "", "06", "JHB", "JHB", "-25.93312", "28.01213", "Africa/Johannesburg"),("10295373", "Hardys Memories of Africa", "", "ZA", "710", "", "11", "DC3", "WC034", "-33.90539", "20.7169", "Africa/Johannesburg"),("11204670", "Eastleigh", "", "ZA", "710", "", "06", "EKU", "EKU", "-26.12965", "28.15541", "Africa/Johannesburg"),("11205175", "Riverlea", "", "ZA", "710", "", "06", "JHB", "JHB", "-26.2119", "27.97322", "Africa/Johannesburg"),("11427405", "Eden Glen Ext 60", "", "ZA", "710", "", "06", "EKU", "EKU", "-26.12593", "28.165", "Africa/Johannesburg"),("175499", "Nchelenge", "Нчеленге", "ZM", "894", "", "04", "", "", "-9.34506", "28.73396", "Africa/Lusaka"),("175555", "Nakonde", "", "ZM", "894", "", "10", "", "", "-9.34213", "32.745", "Africa/Lusaka"),("175961", "Mpulungu", "", "ZM", "894", "", "05", "", "", "-8.76234", "31.11405", "Africa/Lusaka"),("176146", "Mbala", "Мбала", "ZM", "894", "", "05", "", "", "-8.84024", "31.36587", "Africa/Lusaka"),("176555", "Kawambwa", "", "ZM", "894", "", "04", "", "", "-9.7915", "29.07913", "Africa/Lusaka"),("895953", "Zambezi", "", "ZM", "894", "", "06", "", "", "-13.54323", "23.10467", "Africa/Lusaka"),("897045", "Solwezi", "", "ZM", "894", "", "06", "", "", "-12.1688", "26.38938", "Africa/Lusaka"),("897456", "Sinazongwe", "", "ZM", "894", "", "07", "", "", "-17.2614", "27.46179", "Africa/Lusaka"),("898188", "Siavonga", "", "ZM", "894", "", "07", "", "", "-16.53818", "28.70876", "Africa/Lusaka"),("898905", "Sesheke", "Шешеке", "ZM", "894", "", "01", "", "", "-17.47593", "24.29684", "Africa/Lusaka"),("898912", "Serenje", "", "ZM", "894", "", "02", "", "", "-13.23251", "30.23522", "Africa/Lusaka"),("898947", "Senanga", "", "ZM", "894", "", "01", "", "", "-16.11667", "23.26667", "Africa/Lusaka"),("899274", "Samfya", "", "ZM", "894", "", "04", "", "", "-11.36491", "29.55652", "Africa/Lusaka"),("899825", "Petauke", "", "ZM", "894", "", "03", "899821", "", "-14.24117", "31.31975", "Africa/Lusaka"),("901344", "Ndola", "Ндола", "ZM", "894", "", "08", "", "", "-12.95867", "28.63659", "Africa/Lusaka"),("902344", "Nakambala", "", "ZM", "894", "", "07", "", "", "-15.83244", "27.77994", "Africa/Lusaka"),("902620", "Mwinilunga", "", "ZM", "894", "", "06", "", "", "-11.73584", "24.42926", "Africa/Lusaka"),("904241", "Mungwi", "", "ZM", "894", "", "05", "", "", "-10.1732", "31.36942", "Africa/Lusaka"),("904422", "Mumbwa", "", "ZM", "894", "", "02", "", "", "-14.98293", "27.0619", "Africa/Lusaka"),("905382", "Mufumbwe", "", "ZM", "894", "", "06", "", "", "-13.68333", "24.8", "Africa/Lusaka"),("905395", "Mufulira", "Муфулире", "ZM", "894", "", "08", "", "", "-12.54982", "28.24071", "Africa/Lusaka"),("905789", "Mpongwe", "", "ZM", "894", "", "08", "", "", "-13.50914", "28.15504", "Africa/Lusaka"),("905846", "Mpika", "", "ZM", "894", "", "10", "", "", "-11.83431", "31.45287", "Africa/Lusaka"),("906044", "Monze", "", "ZM", "894", "", "07", "", "", "-16.28333", "27.48333", "Africa/Lusaka"),("906054", "Mongu", "Монгу", "ZM", "894", "", "01", "", "", "-15.24835", "23.12741", "Africa/Lusaka"),("906221", "Mkushi", "", "ZM", "894", "", "02", "", "", "-13.62015", "29.3939", "Africa/Lusaka"),("907111", "Mazabuka", "Мазабука", "ZM", "894", "", "07", "", "", "-15.85601", "27.748", "Africa/Lusaka"),("907770", "Mansa", "Манса", "ZM", "894", "", "04", "", "", "-11.19976", "28.89431", "Africa/Lusaka"),("908718", "Maamba", "", "ZM", "894", "", "07", "", "", "-17.36667", "27.15", "Africa/Lusaka"),("908913", "Luwingu", "", "ZM", "894", "", "05", "", "", "-10.2621", "29.92712", "Africa/Lusaka"),("909137", "Lusaka", "Лусака", "ZM", "894", "", "09", "", "", "-15.40669", "28.28713", "Africa/Lusaka"),("909299", "Lundazi", "", "ZM", "894", "", "03", "", "", "-12.29292", "33.1782", "Africa/Lusaka"),("909863", "Luanshya", "", "ZM", "894", "", "08", "", "", "-13.13667", "28.41661", "Africa/Lusaka"),("910111", "Livingstone", "Ливингстон", "ZM", "894", "", "07", "910107", "", "-17.84194", "25.85425", "Africa/Lusaka"),("910361", "Limulunga", "", "ZM", "894", "", "01", "", "", "-15.09691", "23.13757", "Africa/Lusaka"),("911148", "Kitwe", "Китве", "ZM", "894", "", "08", "", "", "-12.80243", "28.21323", "Africa/Lusaka"),("912226", "Kataba", "", "ZM", "894", "", "08", "", "", "-11.88333", "29.78333", "Africa/Lusaka"),("912628", "Kasempa", "", "ZM", "894", "", "06", "", "", "-13.45836", "25.8338", "Africa/Lusaka"),("912764", "Kasama", "Касама", "ZM", "894", "", "05", "", "", "-10.21289", "31.18084", "Africa/Lusaka"),("913029", "Kapiri Mposhi", "", "ZM", "894", "", "02", "", "", "-13.97147", "28.66985", "Africa/Lusaka"),("913323", "Kaoma", "", "ZM", "894", "", "01", "", "", "-14.78333", "24.8", "Africa/Lusaka"),("913613", "Kansanshi", "", "ZM", "894", "", "06", "", "", "-12.09514", "26.42727", "Africa/Lusaka"),("914959", "Kalulushi", "", "ZM", "894", "", "08", "", "", "-12.84151", "28.09479", "Africa/Lusaka"),("915285", "Kalengwa", "", "ZM", "894", "", "06", "", "", "-13.46586", "25.00271", "Africa/Lusaka"),("915471", "Kalabo", "", "ZM", "894", "", "01", "", "", "-14.97005", "22.68138", "Africa/Lusaka"),("915883", "Kafue", "Кафе", "ZM", "894", "", "09", "", "", "-15.76911", "28.18136", "Africa/Lusaka"),("916095", "Kabwe", "Кабве", "ZM", "894", "", "02", "", "", "-14.4469", "28.44644", "Africa/Lusaka"),("916246", "Kabompo", "", "ZM", "894", "", "06", "", "", "-13.59268", "24.20081", "Africa/Lusaka"),("916668", "Isoka", "", "ZM", "894", "", "10", "", "", "-10.16062", "32.63353", "Africa/Lusaka"),("917688", "Chongwe", "", "ZM", "894", "", "09", "", "", "-15.32916", "28.68204", "Africa/Lusaka"),("917748", "Choma", "", "ZM", "894", "", "07", "917743", "", "-16.80648", "26.95305", "Africa/Lusaka"),("918702", "Chipata", "Чипата", "ZM", "894", "", "03", "", "", "-13.63333", "32.65", "Africa/Lusaka"),("918905", "Chinsali", "", "ZM", "894", "", "10", "", "", "-10.54142", "32.08162", "Africa/Lusaka"),("919009", "Chingola", "Чингола", "ZM", "894", "", "08", "919006", "", "-12.52897", "27.88382", "Africa/Lusaka"),("919544", "Chililabombwe", "", "ZM", "894", "", "08", "", "", "-12.36475", "27.82286", "Africa/Lusaka"),("920820", "Chambishi", "", "ZM", "894", "", "08", "", "", "-12.63247", "28.05367", "Africa/Lusaka"),("878549", "Zvishavane", "", "ZW", "716", "", "08", "", "", "-20.32674", "30.06648", "Africa/Harare"),("879431", "Victoria Falls", "", "ZW", "716", "", "06", "889941", "", "-17.93285", "25.83066", "Africa/Harare"),("881164", "Shurugwi", "", "ZW", "716", "", "02", "", "", "-19.67016", "30.00589", "Africa/Harare"),("881345", "Shamva", "", "ZW", "716", "", "03", "", "", "-17.31159", "31.57561", "Africa/Harare"),("882100", "Rusape", "", "ZW", "716", "", "01", "", "", "-18.52785", "32.12843", "Africa/Harare"),("882599", "Redcliff", "Рэдклифф", "ZW", "716", "", "02", "", "", "-19.03333", "29.78333", "Africa/Harare"),("882955", "Penhalonga", "", "ZW", "716", "", "01", "", "", "-18.89112", "32.69781", "Africa/Harare"),("884141", "Norton", "Нортон", "ZW", "716", "", "05", "", "", "-17.88333", "30.7", "Africa/Harare"),("884798", "Mvurwi", "", "ZW", "716", "", "03", "", "", "-17.03333", "30.85", "Africa/Harare"),("884927", "Mutoko", "", "ZW", "716", "", "04", "", "", "-17.39699", "32.22677", "Africa/Harare"),("884979", "Mutare", "Мутаре", "ZW", "716", "", "01", "", "", "-18.9707", "32.67086", "Africa/Harare"),("885159", "Murehwa", "", "ZW", "716", "", "04", "", "", "-17.64322", "31.784", "Africa/Harare"),("885800", "Mount Darwin", "", "ZW", "716", "", "03", "", "", "-16.77251", "31.58381", "Africa/Harare"),("886146", "Mhangura", "", "ZW", "716", "", "05", "", "", "-16.89387", "30.16828", "Africa/Harare"),("886384", "Mazowe", "", "ZW", "716", "", "03", "", "", "-17.50404", "30.97388", "Africa/Harare"),("886763", "Masvingo", "", "ZW", "716", "", "08", "", "", "-20.06373", "30.82766", "Africa/Harare"),("886864", "Mashava", "", "ZW", "716", "", "08", "", "", "-20.03665", "30.48225", "Africa/Harare"),("886990", "Marondera", "", "ZW", "716", "", "04", "", "", "-18.18527", "31.55193", "Africa/Harare"),("888225", "Lupane", "", "ZW", "716", "", "06", "", "", "-18.93149", "27.80696", "Africa/Harare"),("888710", "Kwekwe", "", "ZW", "716", "", "02", "", "", "-18.92809", "29.81486", "Africa/Harare"),("889191", "Karoi", "", "ZW", "716", "", "05", "", "", "-16.80993", "29.69247", "Africa/Harare"),("889215", "Kariba", "Кариба", "ZW", "716", "", "05", "", "", "-16.51667", "28.8", "Africa/Harare"),("889453", "Kadoma", "Кадоме", "ZW", "716", "", "05", "", "", "-18.33328", "29.91534", "Africa/Harare"),("889723", "Inyati", "", "ZW", "716", "", "06", "", "", "-19.67563", "28.84687", "Africa/Harare"),("889942", "Hwange", "Хванге", "ZW", "716", "", "06", "889941", "", "-18.36446", "26.49877", "Africa/Harare"),("890299", "Harare", "Хараре", "ZW", "716", "", "10", "", "", "-17.82772", "31.05337", "Africa/Harare"),("890422", "Gweru", "", "ZW", "716", "", "02", "", "", "-19.45", "29.81667", "Africa/Harare"),("890516", "Gwanda", "", "ZW", "716", "", "07", "", "", "-20.93333", "29", "Africa/Harare"),("890983", "Gokwe", "", "ZW", "716", "", "02", "", "", "-18.20476", "28.9349", "Africa/Harare"),("891099", "Glendale", "", "ZW", "716", "", "03", "", "", "-17.35514", "31.06718", "Africa/Harare"),("893172", "Chivhu", "", "ZW", "716", "", "04", "", "", "-19.02112", "30.89218", "Africa/Harare"),("893485", "Chiredzi", "", "ZW", "716", "", "08", "", "", "-21.05", "31.66667", "Africa/Harare"),("893549", "Chipinge", "", "ZW", "716", "", "01", "", "", "-20.18833", "32.62365", "Africa/Harare"),("893697", "Chinhoyi", "", "ZW", "716", "", "05", "", "", "-17.36667", "30.2", "Africa/Harare"),("894239", "Chegutu", "", "ZW", "716", "", "05", "", "", "-18.13021", "30.14074", "Africa/Harare"),("894413", "Chakari", "", "ZW", "716", "", "05", "", "", "-18.06294", "29.89246", "Africa/Harare"),("894701", "Bulawayo", "Булавайо", "ZW", "716", "", "09", "", "", "-20.15", "28.58333", "Africa/Harare"),("895061", "Bindura", "Биндура", "ZW", "716", "", "03", "", "", "-17.30192", "31.33056", "Africa/Harare"),("895269", "Beitbridge", "", "ZW", "716", "", "07", "", "", "-22.21667", "30", "Africa/Harare"),("895417", "Banket", "", "ZW", "716", "", "05", "", "", "-17.38333", "30.4", "Africa/Harare"),("1085510", "Epworth", "", "ZW", "716", "", "10", "", "", "-17.89", "31.1475", "Africa/Harare"),("1106542", "Chitungwiza", "", "ZW", "716", "", "10", "", "", "-18.01274", "31.07555", "Africa/Harare");
EOL
);
    }
    public function down(\Doctrine\DBAL\Schema\Schema $schema)
    {
        $this->addSql(<<<EOL
DROP TABLE `all_cities`;
ALTER TABLE `weatherco_cache` DROP `updated_forecast`;
ALTER TABLE `weatherco_cache` DROP `updated_current`;
DROP TABLE `openweathermap_cache`;
ALTER TABLE `users` DROP `openweathermap_city_id`;
--
EOL
);
    }
}
